require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ARPA_INET_H_)) {
    eval 'sub _ARPA_INET_H_ () {1;}' unless defined(&_ARPA_INET_H_);
    require 'sys/cdefs.ph';
    require 'sys/_types.ph';
    require 'machine/endian.ph';
    eval 'sub INET_ADDRSTRLEN () {16;}' unless defined(&INET_ADDRSTRLEN);
    eval 'sub INET6_ADDRSTRLEN () {46;}' unless defined(&INET6_ADDRSTRLEN);
    unless(defined(&_UINT16_T_DECLARED)) {
	eval 'sub _UINT16_T_DECLARED () {1;}' unless defined(&_UINT16_T_DECLARED);
    }
    unless(defined(&_UINT32_T_DECLARED)) {
	eval 'sub _UINT32_T_DECLARED () {1;}' unless defined(&_UINT32_T_DECLARED);
    }
    unless(defined(&_IN_ADDR_T_DECLARED)) {
	eval 'sub _IN_ADDR_T_DECLARED () {1;}' unless defined(&_IN_ADDR_T_DECLARED);
    }
    unless(defined(&_IN_PORT_T_DECLARED)) {
	eval 'sub _IN_PORT_T_DECLARED () {1;}' unless defined(&_IN_PORT_T_DECLARED);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	unless(defined(&_SIZE_T_DECLARED)) {
	    eval 'sub _SIZE_T_DECLARED () {1;}' unless defined(&_SIZE_T_DECLARED);
	}
    }
    unless(defined(&_SOCKLEN_T_DECLARED)) {
	eval 'sub _SOCKLEN_T_DECLARED () {1;}' unless defined(&_SOCKLEN_T_DECLARED);
    }
    unless(defined(&_STRUCT_IN_ADDR_DECLARED)) {
	eval 'sub _STRUCT_IN_ADDR_DECLARED () {1;}' unless defined(&_STRUCT_IN_ADDR_DECLARED);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub inet_addr () { &__inet_addr;}' unless defined(&inet_addr);
	eval 'sub inet_aton () { &__inet_aton;}' unless defined(&inet_aton);
	eval 'sub inet_lnaof () { &__inet_lnaof;}' unless defined(&inet_lnaof);
	eval 'sub inet_makeaddr () { &__inet_makeaddr;}' unless defined(&inet_makeaddr);
	eval 'sub inet_neta () { &__inet_neta;}' unless defined(&inet_neta);
	eval 'sub inet_netof () { &__inet_netof;}' unless defined(&inet_netof);
	eval 'sub inet_network () { &__inet_network;}' unless defined(&inet_network);
	eval 'sub inet_net_ntop () { &__inet_net_ntop;}' unless defined(&inet_net_ntop);
	eval 'sub inet_net_pton () { &__inet_net_pton;}' unless defined(&inet_net_pton);
	eval 'sub inet_cidr_ntop () { &__inet_cidr_ntop;}' unless defined(&inet_cidr_ntop);
	eval 'sub inet_cidr_pton () { &__inet_cidr_pton;}' unless defined(&inet_cidr_pton);
	eval 'sub inet_ntoa () { &__inet_ntoa;}' unless defined(&inet_ntoa);
	eval 'sub inet_ntoa_r () { &__inet_ntoa_r;}' unless defined(&inet_ntoa_r);
	eval 'sub inet_pton () { &__inet_pton;}' unless defined(&inet_pton);
	eval 'sub inet_ntop () { &__inet_ntop;}' unless defined(&inet_ntop);
	eval 'sub inet_nsap_addr () { &__inet_nsap_addr;}' unless defined(&inet_nsap_addr);
	eval 'sub inet_nsap_ntoa () { &__inet_nsap_ntoa;}' unless defined(&inet_nsap_ntoa);
    }
    unless(defined(&_BYTEORDER_PROTOTYPED)) {
	eval 'sub _BYTEORDER_PROTOTYPED () {1;}' unless defined(&_BYTEORDER_PROTOTYPED);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
    }
    unless(defined(&_BYTEORDER_FUNC_DEFINED)) {
	eval 'sub _BYTEORDER_FUNC_DEFINED () {1;}' unless defined(&_BYTEORDER_FUNC_DEFINED);
	eval 'sub htonl {
	    my($x) = @_;
    	    eval q( &__htonl($x));
	}' unless defined(&htonl);
	eval 'sub htons {
	    my($x) = @_;
    	    eval q( &__htons($x));
	}' unless defined(&htons);
	eval 'sub ntohl {
	    my($x) = @_;
    	    eval q( &__ntohl($x));
	}' unless defined(&ntohl);
	eval 'sub ntohs {
	    my($x) = @_;
    	    eval q( &__ntohs($x));
	}' unless defined(&ntohs);
    }
}
1;
