require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_BSM_AUDIT_H)) {
    eval 'sub _BSM_AUDIT_H () {1;}' unless defined(&_BSM_AUDIT_H);
    require 'sys/param.ph';
    require 'sys/types.ph';
    eval 'sub AUDIT_RECORD_MAGIC () {0x828a0f1b;}' unless defined(&AUDIT_RECORD_MAGIC);
    eval 'sub MAX_AUDIT_RECORDS () {20;}' unless defined(&MAX_AUDIT_RECORDS);
    eval 'sub MAXAUDITDATA () {(0x8000 - 1);}' unless defined(&MAXAUDITDATA);
    eval 'sub MAX_AUDIT_RECORD_SIZE () { &MAXAUDITDATA;}' unless defined(&MAX_AUDIT_RECORD_SIZE);
    eval 'sub MIN_AUDIT_FILE_SIZE () {(512* 1024);}' unless defined(&MIN_AUDIT_FILE_SIZE);
    eval 'sub AUDIT_HARD_LIMIT_FREE_BLOCKS () {4;}' unless defined(&AUDIT_HARD_LIMIT_FREE_BLOCKS);
    eval 'sub AUDIT_TRIGGER_MIN () {1;}' unless defined(&AUDIT_TRIGGER_MIN);
    eval 'sub AUDIT_TRIGGER_LOW_SPACE () {1;}' unless defined(&AUDIT_TRIGGER_LOW_SPACE);
    eval 'sub AUDIT_TRIGGER_ROTATE_KERNEL () {2;}' unless defined(&AUDIT_TRIGGER_ROTATE_KERNEL);
    eval 'sub AUDIT_TRIGGER_READ_FILE () {3;}' unless defined(&AUDIT_TRIGGER_READ_FILE);
    eval 'sub AUDIT_TRIGGER_CLOSE_AND_DIE () {4;}' unless defined(&AUDIT_TRIGGER_CLOSE_AND_DIE);
    eval 'sub AUDIT_TRIGGER_NO_SPACE () {5;}' unless defined(&AUDIT_TRIGGER_NO_SPACE);
    eval 'sub AUDIT_TRIGGER_ROTATE_USER () {6;}' unless defined(&AUDIT_TRIGGER_ROTATE_USER);
    eval 'sub AUDIT_TRIGGER_INITIALIZE () {7;}' unless defined(&AUDIT_TRIGGER_INITIALIZE);
    eval 'sub AUDIT_TRIGGER_EXPIRE_TRAILS () {8;}' unless defined(&AUDIT_TRIGGER_EXPIRE_TRAILS);
    eval 'sub AUDIT_TRIGGER_MAX () {8;}' unless defined(&AUDIT_TRIGGER_MAX);
    eval 'sub AUDITDEV_FILENAME () {"audit";}' unless defined(&AUDITDEV_FILENAME);
    eval 'sub AUDIT_TRIGGER_FILE () {("/dev/"  &AUDITDEV_FILENAME);}' unless defined(&AUDIT_TRIGGER_FILE);
    eval 'sub AU_DEFAUDITID () {( &uid_t)(-1);}' unless defined(&AU_DEFAUDITID);
    eval 'sub AU_DEFAUDITSID () {0;}' unless defined(&AU_DEFAUDITSID);
    eval 'sub AU_ASSIGN_ASID () {-1;}' unless defined(&AU_ASSIGN_ASID);
    eval 'sub AT_IPC_MSG () {(1);}' unless defined(&AT_IPC_MSG);
    eval 'sub AT_IPC_SEM () {(2);}' unless defined(&AT_IPC_SEM);
    eval 'sub AT_IPC_SHM () {(3);}' unless defined(&AT_IPC_SHM);
    eval 'sub AUC_UNSET () {0;}' unless defined(&AUC_UNSET);
    eval 'sub AUC_AUDITING () {1;}' unless defined(&AUC_AUDITING);
    eval 'sub AUC_NOAUDIT () {2;}' unless defined(&AUC_NOAUDIT);
    eval 'sub AUC_DISABLED () {-1;}' unless defined(&AUC_DISABLED);
    eval 'sub A_OLDGETPOLICY () {2;}' unless defined(&A_OLDGETPOLICY);
    eval 'sub A_OLDSETPOLICY () {3;}' unless defined(&A_OLDSETPOLICY);
    eval 'sub A_GETKMASK () {4;}' unless defined(&A_GETKMASK);
    eval 'sub A_SETKMASK () {5;}' unless defined(&A_SETKMASK);
    eval 'sub A_OLDGETQCTRL () {6;}' unless defined(&A_OLDGETQCTRL);
    eval 'sub A_OLDSETQCTRL () {7;}' unless defined(&A_OLDSETQCTRL);
    eval 'sub A_GETCWD () {8;}' unless defined(&A_GETCWD);
    eval 'sub A_GETCAR () {9;}' unless defined(&A_GETCAR);
    eval 'sub A_GETSTAT () {12;}' unless defined(&A_GETSTAT);
    eval 'sub A_SETSTAT () {13;}' unless defined(&A_SETSTAT);
    eval 'sub A_SETUMASK () {14;}' unless defined(&A_SETUMASK);
    eval 'sub A_SETSMASK () {15;}' unless defined(&A_SETSMASK);
    eval 'sub A_OLDGETCOND () {20;}' unless defined(&A_OLDGETCOND);
    eval 'sub A_OLDSETCOND () {21;}' unless defined(&A_OLDSETCOND);
    eval 'sub A_GETCLASS () {22;}' unless defined(&A_GETCLASS);
    eval 'sub A_SETCLASS () {23;}' unless defined(&A_SETCLASS);
    eval 'sub A_GETPINFO () {24;}' unless defined(&A_GETPINFO);
    eval 'sub A_SETPMASK () {25;}' unless defined(&A_SETPMASK);
    eval 'sub A_SETFSIZE () {26;}' unless defined(&A_SETFSIZE);
    eval 'sub A_GETFSIZE () {27;}' unless defined(&A_GETFSIZE);
    eval 'sub A_GETPINFO_ADDR () {28;}' unless defined(&A_GETPINFO_ADDR);
    eval 'sub A_GETKAUDIT () {29;}' unless defined(&A_GETKAUDIT);
    eval 'sub A_SETKAUDIT () {30;}' unless defined(&A_SETKAUDIT);
    eval 'sub A_SENDTRIGGER () {31;}' unless defined(&A_SENDTRIGGER);
    eval 'sub A_GETSINFO_ADDR () {32;}' unless defined(&A_GETSINFO_ADDR);
    eval 'sub A_GETPOLICY () {33;}' unless defined(&A_GETPOLICY);
    eval 'sub A_SETPOLICY () {34;}' unless defined(&A_SETPOLICY);
    eval 'sub A_GETQCTRL () {35;}' unless defined(&A_GETQCTRL);
    eval 'sub A_SETQCTRL () {36;}' unless defined(&A_SETQCTRL);
    eval 'sub A_GETCOND () {37;}' unless defined(&A_GETCOND);
    eval 'sub A_SETCOND () {38;}' unless defined(&A_SETCOND);
    eval 'sub AUDIT_CNT () {0x1;}' unless defined(&AUDIT_CNT);
    eval 'sub AUDIT_AHLT () {0x2;}' unless defined(&AUDIT_AHLT);
    eval 'sub AUDIT_ARGV () {0x4;}' unless defined(&AUDIT_ARGV);
    eval 'sub AUDIT_ARGE () {0x8;}' unless defined(&AUDIT_ARGE);
    eval 'sub AUDIT_SEQ () {0x10;}' unless defined(&AUDIT_SEQ);
    eval 'sub AUDIT_WINDATA () {0x20;}' unless defined(&AUDIT_WINDATA);
    eval 'sub AUDIT_USER () {0x40;}' unless defined(&AUDIT_USER);
    eval 'sub AUDIT_GROUP () {0x80;}' unless defined(&AUDIT_GROUP);
    eval 'sub AUDIT_TRAIL () {0x100;}' unless defined(&AUDIT_TRAIL);
    eval 'sub AUDIT_PATH () {0x200;}' unless defined(&AUDIT_PATH);
    eval 'sub AUDIT_SCNT () {0x400;}' unless defined(&AUDIT_SCNT);
    eval 'sub AUDIT_PUBLIC () {0x800;}' unless defined(&AUDIT_PUBLIC);
    eval 'sub AUDIT_ZONENAME () {0x1000;}' unless defined(&AUDIT_ZONENAME);
    eval 'sub AUDIT_PERZONE () {0x2000;}' unless defined(&AUDIT_PERZONE);
    eval 'sub AQ_HIWATER () {100;}' unless defined(&AQ_HIWATER);
    eval 'sub AQ_MAXHIGH () {10000;}' unless defined(&AQ_MAXHIGH);
    eval 'sub AQ_LOWATER () {10;}' unless defined(&AQ_LOWATER);
    eval 'sub AQ_BUFSZ () { &MAXAUDITDATA;}' unless defined(&AQ_BUFSZ);
    eval 'sub AQ_MAXBUFSZ () {1048576;}' unless defined(&AQ_MAXBUFSZ);
    eval 'sub AU_FS_MINFREE () {20;}' unless defined(&AU_FS_MINFREE);
    eval 'sub AU_IPv4 () {4;}' unless defined(&AU_IPv4);
    eval 'sub AU_IPv6 () {16;}' unless defined(&AU_IPv6);
    if(!defined(&_KERNEL)  && !defined(&KERNEL)) {
	if(defined(&__APPLE_API_PRIVATE)) {
	    require 'mach/port.ph';
	}
    }
}
1;
