require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_BSM_AUDIT_ERRNO_H_)) {
    eval 'sub _BSM_AUDIT_ERRNO_H_ () {1;}' unless defined(&_BSM_AUDIT_ERRNO_H_);
    eval 'sub BSM_ERRNO_ESUCCESS () {0;}' unless defined(&BSM_ERRNO_ESUCCESS);
    eval 'sub BSM_ERRNO_EPERM () {1;}' unless defined(&BSM_ERRNO_EPERM);
    eval 'sub BSM_ERRNO_ENOENT () {2;}' unless defined(&BSM_ERRNO_ENOENT);
    eval 'sub BSM_ERRNO_ESRCH () {3;}' unless defined(&BSM_ERRNO_ESRCH);
    eval 'sub BSM_ERRNO_EINTR () {4;}' unless defined(&BSM_ERRNO_EINTR);
    eval 'sub BSM_ERRNO_EIO () {5;}' unless defined(&BSM_ERRNO_EIO);
    eval 'sub BSM_ERRNO_ENXIO () {6;}' unless defined(&BSM_ERRNO_ENXIO);
    eval 'sub BSM_ERRNO_E2BIG () {7;}' unless defined(&BSM_ERRNO_E2BIG);
    eval 'sub BSM_ERRNO_ENOEXEC () {8;}' unless defined(&BSM_ERRNO_ENOEXEC);
    eval 'sub BSM_ERRNO_EBADF () {9;}' unless defined(&BSM_ERRNO_EBADF);
    eval 'sub BSM_ERRNO_ECHILD () {10;}' unless defined(&BSM_ERRNO_ECHILD);
    eval 'sub BSM_ERRNO_EAGAIN () {11;}' unless defined(&BSM_ERRNO_EAGAIN);
    eval 'sub BSM_ERRNO_ENOMEM () {12;}' unless defined(&BSM_ERRNO_ENOMEM);
    eval 'sub BSM_ERRNO_EACCES () {13;}' unless defined(&BSM_ERRNO_EACCES);
    eval 'sub BSM_ERRNO_EFAULT () {14;}' unless defined(&BSM_ERRNO_EFAULT);
    eval 'sub BSM_ERRNO_ENOTBLK () {15;}' unless defined(&BSM_ERRNO_ENOTBLK);
    eval 'sub BSM_ERRNO_EBUSY () {16;}' unless defined(&BSM_ERRNO_EBUSY);
    eval 'sub BSM_ERRNO_EEXIST () {17;}' unless defined(&BSM_ERRNO_EEXIST);
    eval 'sub BSM_ERRNO_EXDEV () {18;}' unless defined(&BSM_ERRNO_EXDEV);
    eval 'sub BSM_ERRNO_ENODEV () {19;}' unless defined(&BSM_ERRNO_ENODEV);
    eval 'sub BSM_ERRNO_ENOTDIR () {20;}' unless defined(&BSM_ERRNO_ENOTDIR);
    eval 'sub BSM_ERRNO_EISDIR () {21;}' unless defined(&BSM_ERRNO_EISDIR);
    eval 'sub BSM_ERRNO_EINVAL () {22;}' unless defined(&BSM_ERRNO_EINVAL);
    eval 'sub BSM_ERRNO_ENFILE () {23;}' unless defined(&BSM_ERRNO_ENFILE);
    eval 'sub BSM_ERRNO_EMFILE () {24;}' unless defined(&BSM_ERRNO_EMFILE);
    eval 'sub BSM_ERRNO_ENOTTY () {25;}' unless defined(&BSM_ERRNO_ENOTTY);
    eval 'sub BSM_ERRNO_ETXTBSY () {26;}' unless defined(&BSM_ERRNO_ETXTBSY);
    eval 'sub BSM_ERRNO_EFBIG () {27;}' unless defined(&BSM_ERRNO_EFBIG);
    eval 'sub BSM_ERRNO_ENOSPC () {28;}' unless defined(&BSM_ERRNO_ENOSPC);
    eval 'sub BSM_ERRNO_ESPIPE () {29;}' unless defined(&BSM_ERRNO_ESPIPE);
    eval 'sub BSM_ERRNO_EROFS () {30;}' unless defined(&BSM_ERRNO_EROFS);
    eval 'sub BSM_ERRNO_EMLINK () {31;}' unless defined(&BSM_ERRNO_EMLINK);
    eval 'sub BSM_ERRNO_EPIPE () {32;}' unless defined(&BSM_ERRNO_EPIPE);
    eval 'sub BSM_ERRNO_EDOM () {33;}' unless defined(&BSM_ERRNO_EDOM);
    eval 'sub BSM_ERRNO_ERANGE () {34;}' unless defined(&BSM_ERRNO_ERANGE);
    eval 'sub BSM_ERRNO_ENOMSG () {35;}' unless defined(&BSM_ERRNO_ENOMSG);
    eval 'sub BSM_ERRNO_EIDRM () {36;}' unless defined(&BSM_ERRNO_EIDRM);
    eval 'sub BSM_ERRNO_ECHRNG () {37;}' unless defined(&BSM_ERRNO_ECHRNG);
    eval 'sub BSM_ERRNO_EL2NSYNC () {38;}' unless defined(&BSM_ERRNO_EL2NSYNC);
    eval 'sub BSM_ERRNO_EL3HLT () {39;}' unless defined(&BSM_ERRNO_EL3HLT);
    eval 'sub BSM_ERRNO_EL3RST () {40;}' unless defined(&BSM_ERRNO_EL3RST);
    eval 'sub BSM_ERRNO_ELNRNG () {41;}' unless defined(&BSM_ERRNO_ELNRNG);
    eval 'sub BSM_ERRNO_EUNATCH () {42;}' unless defined(&BSM_ERRNO_EUNATCH);
    eval 'sub BSM_ERRNO_ENOCSI () {43;}' unless defined(&BSM_ERRNO_ENOCSI);
    eval 'sub BSM_ERRNO_EL2HLT () {44;}' unless defined(&BSM_ERRNO_EL2HLT);
    eval 'sub BSM_ERRNO_EDEADLK () {45;}' unless defined(&BSM_ERRNO_EDEADLK);
    eval 'sub BSM_ERRNO_ENOLCK () {46;}' unless defined(&BSM_ERRNO_ENOLCK);
    eval 'sub BSM_ERRNO_ECANCELED () {47;}' unless defined(&BSM_ERRNO_ECANCELED);
    eval 'sub BSM_ERRNO_ENOTSUP () {48;}' unless defined(&BSM_ERRNO_ENOTSUP);
    eval 'sub BSM_ERRNO_EDQUOT () {49;}' unless defined(&BSM_ERRNO_EDQUOT);
    eval 'sub BSM_ERRNO_EBADE () {50;}' unless defined(&BSM_ERRNO_EBADE);
    eval 'sub BSM_ERRNO_EBADR () {51;}' unless defined(&BSM_ERRNO_EBADR);
    eval 'sub BSM_ERRNO_EXFULL () {52;}' unless defined(&BSM_ERRNO_EXFULL);
    eval 'sub BSM_ERRNO_ENOANO () {53;}' unless defined(&BSM_ERRNO_ENOANO);
    eval 'sub BSM_ERRNO_EBADRQC () {54;}' unless defined(&BSM_ERRNO_EBADRQC);
    eval 'sub BSM_ERRNO_EBADSLT () {55;}' unless defined(&BSM_ERRNO_EBADSLT);
    eval 'sub BSM_ERRNO_EDEADLOCK () {56;}' unless defined(&BSM_ERRNO_EDEADLOCK);
    eval 'sub BSM_ERRNO_EBFONT () {57;}' unless defined(&BSM_ERRNO_EBFONT);
    eval 'sub BSM_ERRNO_EOWNERDEAD () {58;}' unless defined(&BSM_ERRNO_EOWNERDEAD);
    eval 'sub BSM_ERRNO_ENOTRECOVERABLE () {59;}' unless defined(&BSM_ERRNO_ENOTRECOVERABLE);
    eval 'sub BSM_ERRNO_ENOSTR () {60;}' unless defined(&BSM_ERRNO_ENOSTR);
    eval 'sub BSM_ERRNO_ENODATA () {61;}' unless defined(&BSM_ERRNO_ENODATA);
    eval 'sub BSM_ERRNO_ETIME () {62;}' unless defined(&BSM_ERRNO_ETIME);
    eval 'sub BSM_ERRNO_ENOSR () {63;}' unless defined(&BSM_ERRNO_ENOSR);
    eval 'sub BSM_ERRNO_ENONET () {64;}' unless defined(&BSM_ERRNO_ENONET);
    eval 'sub BSM_ERRNO_ENOPKG () {65;}' unless defined(&BSM_ERRNO_ENOPKG);
    eval 'sub BSM_ERRNO_EREMOTE () {66;}' unless defined(&BSM_ERRNO_EREMOTE);
    eval 'sub BSM_ERRNO_ENOLINK () {67;}' unless defined(&BSM_ERRNO_ENOLINK);
    eval 'sub BSM_ERRNO_EADV () {68;}' unless defined(&BSM_ERRNO_EADV);
    eval 'sub BSM_ERRNO_ESRMNT () {69;}' unless defined(&BSM_ERRNO_ESRMNT);
    eval 'sub BSM_ERRNO_ECOMM () {70;}' unless defined(&BSM_ERRNO_ECOMM);
    eval 'sub BSM_ERRNO_EPROTO () {71;}' unless defined(&BSM_ERRNO_EPROTO);
    eval 'sub BSM_ERRNO_ELOCKUNMAPPED () {72;}' unless defined(&BSM_ERRNO_ELOCKUNMAPPED);
    eval 'sub BSM_ERRNO_ENOTACTIVE () {73;}' unless defined(&BSM_ERRNO_ENOTACTIVE);
    eval 'sub BSM_ERRNO_EMULTIHOP () {74;}' unless defined(&BSM_ERRNO_EMULTIHOP);
    eval 'sub BSM_ERRNO_EBADMSG () {77;}' unless defined(&BSM_ERRNO_EBADMSG);
    eval 'sub BSM_ERRNO_ENAMETOOLONG () {78;}' unless defined(&BSM_ERRNO_ENAMETOOLONG);
    eval 'sub BSM_ERRNO_EOVERFLOW () {79;}' unless defined(&BSM_ERRNO_EOVERFLOW);
    eval 'sub BSM_ERRNO_ENOTUNIQ () {80;}' unless defined(&BSM_ERRNO_ENOTUNIQ);
    eval 'sub BSM_ERRNO_EBADFD () {81;}' unless defined(&BSM_ERRNO_EBADFD);
    eval 'sub BSM_ERRNO_EREMCHG () {82;}' unless defined(&BSM_ERRNO_EREMCHG);
    eval 'sub BSM_ERRNO_ELIBACC () {83;}' unless defined(&BSM_ERRNO_ELIBACC);
    eval 'sub BSM_ERRNO_ELIBBAD () {84;}' unless defined(&BSM_ERRNO_ELIBBAD);
    eval 'sub BSM_ERRNO_ELIBSCN () {85;}' unless defined(&BSM_ERRNO_ELIBSCN);
    eval 'sub BSM_ERRNO_ELIBMAX () {86;}' unless defined(&BSM_ERRNO_ELIBMAX);
    eval 'sub BSM_ERRNO_ELIBEXEC () {87;}' unless defined(&BSM_ERRNO_ELIBEXEC);
    eval 'sub BSM_ERRNO_EILSEQ () {88;}' unless defined(&BSM_ERRNO_EILSEQ);
    eval 'sub BSM_ERRNO_ENOSYS () {89;}' unless defined(&BSM_ERRNO_ENOSYS);
    eval 'sub BSM_ERRNO_ELOOP () {90;}' unless defined(&BSM_ERRNO_ELOOP);
    eval 'sub BSM_ERRNO_ERESTART () {91;}' unless defined(&BSM_ERRNO_ERESTART);
    eval 'sub BSM_ERRNO_ESTRPIPE () {92;}' unless defined(&BSM_ERRNO_ESTRPIPE);
    eval 'sub BSM_ERRNO_ENOTEMPTY () {93;}' unless defined(&BSM_ERRNO_ENOTEMPTY);
    eval 'sub BSM_ERRNO_EUSERS () {94;}' unless defined(&BSM_ERRNO_EUSERS);
    eval 'sub BSM_ERRNO_ENOTSOCK () {95;}' unless defined(&BSM_ERRNO_ENOTSOCK);
    eval 'sub BSM_ERRNO_EDESTADDRREQ () {96;}' unless defined(&BSM_ERRNO_EDESTADDRREQ);
    eval 'sub BSM_ERRNO_EMSGSIZE () {97;}' unless defined(&BSM_ERRNO_EMSGSIZE);
    eval 'sub BSM_ERRNO_EPROTOTYPE () {98;}' unless defined(&BSM_ERRNO_EPROTOTYPE);
    eval 'sub BSM_ERRNO_ENOPROTOOPT () {99;}' unless defined(&BSM_ERRNO_ENOPROTOOPT);
    eval 'sub BSM_ERRNO_EPROTONOSUPPORT () {120;}' unless defined(&BSM_ERRNO_EPROTONOSUPPORT);
    eval 'sub BSM_ERRNO_ESOCKTNOSUPPORT () {121;}' unless defined(&BSM_ERRNO_ESOCKTNOSUPPORT);
    eval 'sub BSM_ERRNO_EOPNOTSUPP () {122;}' unless defined(&BSM_ERRNO_EOPNOTSUPP);
    eval 'sub BSM_ERRNO_EPFNOSUPPORT () {123;}' unless defined(&BSM_ERRNO_EPFNOSUPPORT);
    eval 'sub BSM_ERRNO_EAFNOSUPPORT () {124;}' unless defined(&BSM_ERRNO_EAFNOSUPPORT);
    eval 'sub BSM_ERRNO_EADDRINUSE () {125;}' unless defined(&BSM_ERRNO_EADDRINUSE);
    eval 'sub BSM_ERRNO_EADDRNOTAVAIL () {126;}' unless defined(&BSM_ERRNO_EADDRNOTAVAIL);
    eval 'sub BSM_ERRNO_ENETDOWN () {127;}' unless defined(&BSM_ERRNO_ENETDOWN);
    eval 'sub BSM_ERRNO_ENETUNREACH () {128;}' unless defined(&BSM_ERRNO_ENETUNREACH);
    eval 'sub BSM_ERRNO_ENETRESET () {129;}' unless defined(&BSM_ERRNO_ENETRESET);
    eval 'sub BSM_ERRNO_ECONNABORTED () {130;}' unless defined(&BSM_ERRNO_ECONNABORTED);
    eval 'sub BSM_ERRNO_ECONNRESET () {131;}' unless defined(&BSM_ERRNO_ECONNRESET);
    eval 'sub BSM_ERRNO_ENOBUFS () {132;}' unless defined(&BSM_ERRNO_ENOBUFS);
    eval 'sub BSM_ERRNO_EISCONN () {133;}' unless defined(&BSM_ERRNO_EISCONN);
    eval 'sub BSM_ERRNO_ENOTCONN () {134;}' unless defined(&BSM_ERRNO_ENOTCONN);
    eval 'sub BSM_ERRNO_ESHUTDOWN () {143;}' unless defined(&BSM_ERRNO_ESHUTDOWN);
    eval 'sub BSM_ERRNO_ETOOMANYREFS () {144;}' unless defined(&BSM_ERRNO_ETOOMANYREFS);
    eval 'sub BSM_ERRNO_ETIMEDOUT () {145;}' unless defined(&BSM_ERRNO_ETIMEDOUT);
    eval 'sub BSM_ERRNO_ECONNREFUSED () {146;}' unless defined(&BSM_ERRNO_ECONNREFUSED);
    eval 'sub BSM_ERRNO_EHOSTDOWN () {147;}' unless defined(&BSM_ERRNO_EHOSTDOWN);
    eval 'sub BSM_ERRNO_EHOSTUNREACH () {148;}' unless defined(&BSM_ERRNO_EHOSTUNREACH);
    eval 'sub BSM_ERRNO_EALREADY () {149;}' unless defined(&BSM_ERRNO_EALREADY);
    eval 'sub BSM_ERRNO_EINPROGRESS () {150;}' unless defined(&BSM_ERRNO_EINPROGRESS);
    eval 'sub BSM_ERRNO_ESTALE () {151;}' unless defined(&BSM_ERRNO_ESTALE);
    eval 'sub BSM_ERRNO_EPROCLIM () {190;}' unless defined(&BSM_ERRNO_EPROCLIM);
    eval 'sub BSM_ERRNO_EBADRPC () {191;}' unless defined(&BSM_ERRNO_EBADRPC);
    eval 'sub BSM_ERRNO_ERPCMISMATCH () {192;}' unless defined(&BSM_ERRNO_ERPCMISMATCH);
    eval 'sub BSM_ERRNO_EPROGUNAVAIL () {193;}' unless defined(&BSM_ERRNO_EPROGUNAVAIL);
    eval 'sub BSM_ERRNO_EPROGMISMATCH () {194;}' unless defined(&BSM_ERRNO_EPROGMISMATCH);
    eval 'sub BSM_ERRNO_EPROCUNAVAIL () {195;}' unless defined(&BSM_ERRNO_EPROCUNAVAIL);
    eval 'sub BSM_ERRNO_EFTYPE () {196;}' unless defined(&BSM_ERRNO_EFTYPE);
    eval 'sub BSM_ERRNO_EAUTH () {197;}' unless defined(&BSM_ERRNO_EAUTH);
    eval 'sub BSM_ERRNO_ENEEDAUTH () {198;}' unless defined(&BSM_ERRNO_ENEEDAUTH);
    eval 'sub BSM_ERRNO_ENOATTR () {199;}' unless defined(&BSM_ERRNO_ENOATTR);
    eval 'sub BSM_ERRNO_EDOOFUS () {200;}' unless defined(&BSM_ERRNO_EDOOFUS);
    eval 'sub BSM_ERRNO_EJUSTRETURN () {201;}' unless defined(&BSM_ERRNO_EJUSTRETURN);
    eval 'sub BSM_ERRNO_ENOIOCTL () {202;}' unless defined(&BSM_ERRNO_ENOIOCTL);
    eval 'sub BSM_ERRNO_EDIRIOCTL () {203;}' unless defined(&BSM_ERRNO_EDIRIOCTL);
    eval 'sub BSM_ERRNO_EPWROFF () {204;}' unless defined(&BSM_ERRNO_EPWROFF);
    eval 'sub BSM_ERRNO_EDEVERR () {205;}' unless defined(&BSM_ERRNO_EDEVERR);
    eval 'sub BSM_ERRNO_EBADEXEC () {206;}' unless defined(&BSM_ERRNO_EBADEXEC);
    eval 'sub BSM_ERRNO_EBADARCH () {207;}' unless defined(&BSM_ERRNO_EBADARCH);
    eval 'sub BSM_ERRNO_ESHLIBVERS () {208;}' unless defined(&BSM_ERRNO_ESHLIBVERS);
    eval 'sub BSM_ERRNO_EBADMACHO () {209;}' unless defined(&BSM_ERRNO_EBADMACHO);
    eval 'sub BSM_ERRNO_EPOLICY () {210;}' unless defined(&BSM_ERRNO_EPOLICY);
    eval 'sub BSM_ERRNO_EDOTDOT () {211;}' unless defined(&BSM_ERRNO_EDOTDOT);
    eval 'sub BSM_ERRNO_EUCLEAN () {212;}' unless defined(&BSM_ERRNO_EUCLEAN);
    eval 'sub BSM_ERRNO_ENOTNAM () {213;}' unless defined(&BSM_ERRNO_ENOTNAM);
    eval 'sub BSM_ERRNO_ENAVAIL () {214;}' unless defined(&BSM_ERRNO_ENAVAIL);
    eval 'sub BSM_ERRNO_EISNAM () {215;}' unless defined(&BSM_ERRNO_EISNAM);
    eval 'sub BSM_ERRNO_EREMOTEIO () {216;}' unless defined(&BSM_ERRNO_EREMOTEIO);
    eval 'sub BSM_ERRNO_ENOMEDIUM () {217;}' unless defined(&BSM_ERRNO_ENOMEDIUM);
    eval 'sub BSM_ERRNO_EMEDIUMTYPE () {218;}' unless defined(&BSM_ERRNO_EMEDIUMTYPE);
    eval 'sub BSM_ERRNO_ENOKEY () {219;}' unless defined(&BSM_ERRNO_ENOKEY);
    eval 'sub BSM_ERRNO_EKEYEXPIRED () {220;}' unless defined(&BSM_ERRNO_EKEYEXPIRED);
    eval 'sub BSM_ERRNO_EKEYREVOKED () {221;}' unless defined(&BSM_ERRNO_EKEYREVOKED);
    eval 'sub BSM_ERRNO_EKEYREJECTED () {222;}' unless defined(&BSM_ERRNO_EKEYREJECTED);
    eval 'sub BSM_ERRNO_ENOTCAPABLE () {223;}' unless defined(&BSM_ERRNO_ENOTCAPABLE);
    eval 'sub BSM_ERRNO_ECAPMODE () {224;}' unless defined(&BSM_ERRNO_ECAPMODE);
    eval 'sub BSM_ERRNO_UNKNOWN () {250;}' unless defined(&BSM_ERRNO_UNKNOWN);
}
1;
