require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_BSM_AUDIT_FCNTL_H_)) {
    eval 'sub _BSM_AUDIT_FCNTL_H_ () {1;}' unless defined(&_BSM_AUDIT_FCNTL_H_);
    eval 'sub BSM_F_DUPFD () {0;}' unless defined(&BSM_F_DUPFD);
    eval 'sub BSM_F_GETFD () {1;}' unless defined(&BSM_F_GETFD);
    eval 'sub BSM_F_SETFD () {2;}' unless defined(&BSM_F_SETFD);
    eval 'sub BSM_F_GETFL () {3;}' unless defined(&BSM_F_GETFL);
    eval 'sub BSM_F_SETFL () {4;}' unless defined(&BSM_F_SETFL);
    eval 'sub BSM_F_O_GETLK () {5;}' unless defined(&BSM_F_O_GETLK);
    eval 'sub BSM_F_SETLK () {6;}' unless defined(&BSM_F_SETLK);
    eval 'sub BSM_F_SETLKW () {7;}' unless defined(&BSM_F_SETLKW);
    eval 'sub BSM_F_CHKFL () {8;}' unless defined(&BSM_F_CHKFL);
    eval 'sub BSM_F_DUP2FD () {9;}' unless defined(&BSM_F_DUP2FD);
    eval 'sub BSM_F_ALLOCSP () {10;}' unless defined(&BSM_F_ALLOCSP);
    eval 'sub BSM_F_FREESP () {11;}' unless defined(&BSM_F_FREESP);
    eval 'sub BSM_F_ISSTREAM () {13;}' unless defined(&BSM_F_ISSTREAM);
    eval 'sub BSM_F_GETLK () {14;}' unless defined(&BSM_F_GETLK);
    eval 'sub BSM_F_PRIV () {15;}' unless defined(&BSM_F_PRIV);
    eval 'sub BSM_F_NPRIV () {16;}' unless defined(&BSM_F_NPRIV);
    eval 'sub BSM_F_QUOTACTL () {17;}' unless defined(&BSM_F_QUOTACTL);
    eval 'sub BSM_F_BLOCKS () {18;}' unless defined(&BSM_F_BLOCKS);
    eval 'sub BSM_F_BLKSIZE () {19;}' unless defined(&BSM_F_BLKSIZE);
    eval 'sub BSM_F_GETOWN () {23;}' unless defined(&BSM_F_GETOWN);
    eval 'sub BSM_F_SETOWN () {24;}' unless defined(&BSM_F_SETOWN);
    eval 'sub BSM_F_REVOKE () {25;}' unless defined(&BSM_F_REVOKE);
    eval 'sub BSM_F_HASREMOTELOCKS () {26;}' unless defined(&BSM_F_HASREMOTELOCKS);
    eval 'sub BSM_F_FREESP64 () {27;}' unless defined(&BSM_F_FREESP64);
    eval 'sub BSM_F_ALLOCSP64 () {28;}' unless defined(&BSM_F_ALLOCSP64);
    eval 'sub BSM_F_GETLK64 () {33;}' unless defined(&BSM_F_GETLK64);
    eval 'sub BSM_F_SETLK64 () {34;}' unless defined(&BSM_F_SETLK64);
    eval 'sub BSM_F_SETLKW64 () {35;}' unless defined(&BSM_F_SETLKW64);
    eval 'sub BSM_F_SHARE () {40;}' unless defined(&BSM_F_SHARE);
    eval 'sub BSM_F_UNSHARE () {41;}' unless defined(&BSM_F_UNSHARE);
    eval 'sub BSM_F_SETLK_NBMAND () {42;}' unless defined(&BSM_F_SETLK_NBMAND);
    eval 'sub BSM_F_SHARE_NBMAND () {43;}' unless defined(&BSM_F_SHARE_NBMAND);
    eval 'sub BSM_F_SETLK64_NBMAND () {44;}' unless defined(&BSM_F_SETLK64_NBMAND);
    eval 'sub BSM_F_GETXFL () {45;}' unless defined(&BSM_F_GETXFL);
    eval 'sub BSM_F_BADFD () {46;}' unless defined(&BSM_F_BADFD);
    eval 'sub BSM_F_OGETLK () {107;}' unless defined(&BSM_F_OGETLK);
    eval 'sub BSM_F_OSETLK () {108;}' unless defined(&BSM_F_OSETLK);
    eval 'sub BSM_F_OSETLKW () {109;}' unless defined(&BSM_F_OSETLKW);
    eval 'sub BSM_F_SETLK_REMOTE () {114;}' unless defined(&BSM_F_SETLK_REMOTE);
    eval 'sub BSM_F_SETSIG () {210;}' unless defined(&BSM_F_SETSIG);
    eval 'sub BSM_F_GETSIG () {211;}' unless defined(&BSM_F_GETSIG);
    eval 'sub BSM_F_CHKCLEAN () {341;}' unless defined(&BSM_F_CHKCLEAN);
    eval 'sub BSM_F_PREALLOCATE () {342;}' unless defined(&BSM_F_PREALLOCATE);
    eval 'sub BSM_F_SETSIZE () {343;}' unless defined(&BSM_F_SETSIZE);
    eval 'sub BSM_F_RDADVISE () {344;}' unless defined(&BSM_F_RDADVISE);
    eval 'sub BSM_F_RDAHEAD () {345;}' unless defined(&BSM_F_RDAHEAD);
    eval 'sub BSM_F_READBOOTSTRAP () {346;}' unless defined(&BSM_F_READBOOTSTRAP);
    eval 'sub BSM_F_WRITEBOOTSTRAP () {347;}' unless defined(&BSM_F_WRITEBOOTSTRAP);
    eval 'sub BSM_F_NOCACHE () {348;}' unless defined(&BSM_F_NOCACHE);
    eval 'sub BSM_F_LOG2PHYS () {349;}' unless defined(&BSM_F_LOG2PHYS);
    eval 'sub BSM_F_GETPATH () {350;}' unless defined(&BSM_F_GETPATH);
    eval 'sub BSM_F_FULLFSYNC () {351;}' unless defined(&BSM_F_FULLFSYNC);
    eval 'sub BSM_F_PATHPKG_CHECK () {352;}' unless defined(&BSM_F_PATHPKG_CHECK);
    eval 'sub BSM_F_FREEZE_FS () {353;}' unless defined(&BSM_F_FREEZE_FS);
    eval 'sub BSM_F_THAW_FS () {354;}' unless defined(&BSM_F_THAW_FS);
    eval 'sub BSM_F_GLOBAL_NOCACHE () {355;}' unless defined(&BSM_F_GLOBAL_NOCACHE);
    eval 'sub BSM_F_OPENFROM () {356;}' unless defined(&BSM_F_OPENFROM);
    eval 'sub BSM_F_UNLINKFROM () {357;}' unless defined(&BSM_F_UNLINKFROM);
    eval 'sub BSM_F_CHECK_OPENEVT () {358;}' unless defined(&BSM_F_CHECK_OPENEVT);
    eval 'sub BSM_F_ADDSIGS () {359;}' unless defined(&BSM_F_ADDSIGS);
    eval 'sub BSM_F_MARKDEPENDENCY () {360;}' unless defined(&BSM_F_MARKDEPENDENCY);
    eval 'sub BSM_F_FS_SPECIFIC_0 () {400;}' unless defined(&BSM_F_FS_SPECIFIC_0);
    eval 'sub BSM_F_FS_SPECIFIC_1 () {401;}' unless defined(&BSM_F_FS_SPECIFIC_1);
    eval 'sub BSM_F_FS_SPECIFIC_2 () {402;}' unless defined(&BSM_F_FS_SPECIFIC_2);
    eval 'sub BSM_F_FS_SPECIFIC_3 () {403;}' unless defined(&BSM_F_FS_SPECIFIC_3);
    eval 'sub BSM_F_FS_SPECIFIC_4 () {404;}' unless defined(&BSM_F_FS_SPECIFIC_4);
    eval 'sub BSM_F_FS_SPECIFIC_5 () {405;}' unless defined(&BSM_F_FS_SPECIFIC_5);
    eval 'sub BSM_F_FS_SPECIFIC_6 () {406;}' unless defined(&BSM_F_FS_SPECIFIC_6);
    eval 'sub BSM_F_FS_SPECIFIC_7 () {407;}' unless defined(&BSM_F_FS_SPECIFIC_7);
    eval 'sub BSM_F_FS_SPECIFIC_8 () {408;}' unless defined(&BSM_F_FS_SPECIFIC_8);
    eval 'sub BSM_F_FS_SPECIFIC_9 () {409;}' unless defined(&BSM_F_FS_SPECIFIC_9);
    eval 'sub BSM_F_FS_SPECIFIC_10 () {410;}' unless defined(&BSM_F_FS_SPECIFIC_10);
    eval 'sub BSM_F_FS_SPECIFIC_11 () {411;}' unless defined(&BSM_F_FS_SPECIFIC_11);
    eval 'sub BSM_F_FS_SPECIFIC_12 () {412;}' unless defined(&BSM_F_FS_SPECIFIC_12);
    eval 'sub BSM_F_FS_SPECIFIC_13 () {413;}' unless defined(&BSM_F_FS_SPECIFIC_13);
    eval 'sub BSM_F_FS_SPECIFIC_14 () {414;}' unless defined(&BSM_F_FS_SPECIFIC_14);
    eval 'sub BSM_F_FS_SPECIFIC_15 () {415;}' unless defined(&BSM_F_FS_SPECIFIC_15);
    eval 'sub BSM_F_UNKNOWN () {0xffff;}' unless defined(&BSM_F_UNKNOWN);
}
1;
