require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AUDIT_INTERNAL_H)) {
    eval 'sub _AUDIT_INTERNAL_H () {1;}' unless defined(&_AUDIT_INTERNAL_H);
    if(defined(&__linux__)  && !defined(&__unused)) {
	eval 'sub __unused () {1;}' unless defined(&__unused);
    }
    eval 'sub AUDIT_HEADER_EX_SIZE {
        my($a) = @_;
	    eval q((($a)-> ($ai_termid->{at_type})+18+$sizeof{ &u_int32_t}));
    }' unless defined(&AUDIT_HEADER_EX_SIZE);
    eval 'sub AUDIT_HEADER_SIZE () {18;}' unless defined(&AUDIT_HEADER_SIZE);
    eval 'sub MAX_AUDIT_HEADER_SIZE () {(5*$sizeof{ &u_int32_t}+18);}' unless defined(&MAX_AUDIT_HEADER_SIZE);
    eval 'sub AUDIT_TRAILER_SIZE () {7;}' unless defined(&AUDIT_TRAILER_SIZE);
    eval 'sub ADD_U_CHAR {
        my($loc, $val) = @_;
	    eval q( &do { *($loc) = ($val); ($loc) += $sizeof{\'u_char\'}; }  &while(0));
    }' unless defined(&ADD_U_CHAR);
    eval 'sub ADD_U_INT16 {
        my($loc, $val) = @_;
	    eval q( &do {  &be16enc(($loc), ($val)); ($loc) += $sizeof{ &u_int16_t}; }  &while(0));
    }' unless defined(&ADD_U_INT16);
    eval 'sub ADD_U_INT32 {
        my($loc, $val) = @_;
	    eval q( &do {  &be32enc(($loc), ($val)); ($loc) += $sizeof{ &u_int32_t}; }  &while(0));
    }' unless defined(&ADD_U_INT32);
    eval 'sub ADD_U_INT64 {
        my($loc, $val) = @_;
	    eval q( &do {  &be64enc(($loc), ($val)); ($loc) += $sizeof{ &u_int64_t}; }  &while(0));
    }' unless defined(&ADD_U_INT64);
    eval 'sub ADD_MEM {
        my($loc, $data, $size) = @_;
	    eval q( &do {  &memcpy(($loc), ($data), ($size)); ($loc) += $size; }  &while(0));
    }' unless defined(&ADD_MEM);
    eval 'sub ADD_STRING {
        my($loc, $data, $size) = @_;
	    eval q( &ADD_MEM($loc, $data, $size));
    }' unless defined(&ADD_STRING);
}
1;
