require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_BSM_AUDIT_RECORD_H_)) {
    eval 'sub _BSM_AUDIT_RECORD_H_ () {1;}' unless defined(&_BSM_AUDIT_RECORD_H_);
    require 'sys/types.ph';
    require 'sys/time.ph';
    eval 'sub AUT_INVALID () {0x;}' unless defined(&AUT_INVALID);
    eval 'sub AUT_OTHER_FILE32 () {0x11;}' unless defined(&AUT_OTHER_FILE32);
    eval 'sub AUT_OHEADER () {0x12;}' unless defined(&AUT_OHEADER);
    eval 'sub AUT_TRAILER () {0x13;}' unless defined(&AUT_TRAILER);
    eval 'sub AUT_HEADER32 () {0x14;}' unless defined(&AUT_HEADER32);
    eval 'sub AUT_HEADER32_EX () {0x15;}' unless defined(&AUT_HEADER32_EX);
    eval 'sub AUT_DATA () {0x21;}' unless defined(&AUT_DATA);
    eval 'sub AUT_IPC () {0x22;}' unless defined(&AUT_IPC);
    eval 'sub AUT_PATH () {0x23;}' unless defined(&AUT_PATH);
    eval 'sub AUT_SUBJECT32 () {0x24;}' unless defined(&AUT_SUBJECT32);
    eval 'sub AUT_XATPATH () {0x25;}' unless defined(&AUT_XATPATH);
    eval 'sub AUT_PROCESS32 () {0x26;}' unless defined(&AUT_PROCESS32);
    eval 'sub AUT_RETURN32 () {0x27;}' unless defined(&AUT_RETURN32);
    eval 'sub AUT_TEXT () {0x28;}' unless defined(&AUT_TEXT);
    eval 'sub AUT_OPAQUE () {0x29;}' unless defined(&AUT_OPAQUE);
    eval 'sub AUT_IN_ADDR () {0x2a;}' unless defined(&AUT_IN_ADDR);
    eval 'sub AUT_IP () {0x2b;}' unless defined(&AUT_IP);
    eval 'sub AUT_IPORT () {0x2c;}' unless defined(&AUT_IPORT);
    eval 'sub AUT_ARG32 () {0x2d;}' unless defined(&AUT_ARG32);
    eval 'sub AUT_SOCKET () {0x2e;}' unless defined(&AUT_SOCKET);
    eval 'sub AUT_SEQ () {0x2f;}' unless defined(&AUT_SEQ);
    eval 'sub AUT_ACL () {0x30;}' unless defined(&AUT_ACL);
    eval 'sub AUT_ATTR () {0x31;}' unless defined(&AUT_ATTR);
    eval 'sub AUT_IPC_PERM () {0x32;}' unless defined(&AUT_IPC_PERM);
    eval 'sub AUT_LABEL () {0x33;}' unless defined(&AUT_LABEL);
    eval 'sub AUT_GROUPS () {0x34;}' unless defined(&AUT_GROUPS);
    eval 'sub AUT_ACE () {0x35;}' unless defined(&AUT_ACE);
    eval 'sub AUT_PRIV () {0x38;}' unless defined(&AUT_PRIV);
    eval 'sub AUT_UPRIV () {0x39;}' unless defined(&AUT_UPRIV);
    eval 'sub AUT_LIAISON () {0x3a;}' unless defined(&AUT_LIAISON);
    eval 'sub AUT_NEWGROUPS () {0x3b;}' unless defined(&AUT_NEWGROUPS);
    eval 'sub AUT_EXEC_ARGS () {0x3c;}' unless defined(&AUT_EXEC_ARGS);
    eval 'sub AUT_EXEC_ENV () {0x3d;}' unless defined(&AUT_EXEC_ENV);
    eval 'sub AUT_ATTR32 () {0x3e;}' unless defined(&AUT_ATTR32);
    eval 'sub AUT_UNAUTH () {0x3f;}' unless defined(&AUT_UNAUTH);
    eval 'sub AUT_XATOM () {0x40;}' unless defined(&AUT_XATOM);
    eval 'sub AUT_XOBJ () {0x41;}' unless defined(&AUT_XOBJ);
    eval 'sub AUT_XPROTO () {0x42;}' unless defined(&AUT_XPROTO);
    eval 'sub AUT_XSELECT () {0x43;}' unless defined(&AUT_XSELECT);
    eval 'sub AUT_XCOLORMAP () {0x44;}' unless defined(&AUT_XCOLORMAP);
    eval 'sub AUT_XCURSOR () {0x45;}' unless defined(&AUT_XCURSOR);
    eval 'sub AUT_XFONT () {0x46;}' unless defined(&AUT_XFONT);
    eval 'sub AUT_XGC () {0x47;}' unless defined(&AUT_XGC);
    eval 'sub AUT_XPIXMAP () {0x48;}' unless defined(&AUT_XPIXMAP);
    eval 'sub AUT_XPROPERTY () {0x49;}' unless defined(&AUT_XPROPERTY);
    eval 'sub AUT_XWINDOW () {0x4a;}' unless defined(&AUT_XWINDOW);
    eval 'sub AUT_XCLIENT () {0x4b;}' unless defined(&AUT_XCLIENT);
    eval 'sub AUT_CMD () {0x51;}' unless defined(&AUT_CMD);
    eval 'sub AUT_EXIT () {0x52;}' unless defined(&AUT_EXIT);
    eval 'sub AUT_ZONENAME () {0x60;}' unless defined(&AUT_ZONENAME);
    eval 'sub AUT_HOST () {0x70;}' unless defined(&AUT_HOST);
    eval 'sub AUT_ARG64 () {0x71;}' unless defined(&AUT_ARG64);
    eval 'sub AUT_RETURN64 () {0x72;}' unless defined(&AUT_RETURN64);
    eval 'sub AUT_ATTR64 () {0x73;}' unless defined(&AUT_ATTR64);
    eval 'sub AUT_HEADER64 () {0x74;}' unless defined(&AUT_HEADER64);
    eval 'sub AUT_SUBJECT64 () {0x75;}' unless defined(&AUT_SUBJECT64);
    eval 'sub AUT_PROCESS64 () {0x77;}' unless defined(&AUT_PROCESS64);
    eval 'sub AUT_OTHER_FILE64 () {0x78;}' unless defined(&AUT_OTHER_FILE64);
    eval 'sub AUT_HEADER64_EX () {0x79;}' unless defined(&AUT_HEADER64_EX);
    eval 'sub AUT_SUBJECT32_EX () {0x7a;}' unless defined(&AUT_SUBJECT32_EX);
    eval 'sub AUT_PROCESS32_EX () {0x7b;}' unless defined(&AUT_PROCESS32_EX);
    eval 'sub AUT_SUBJECT64_EX () {0x7c;}' unless defined(&AUT_SUBJECT64_EX);
    eval 'sub AUT_PROCESS64_EX () {0x7d;}' unless defined(&AUT_PROCESS64_EX);
    eval 'sub AUT_IN_ADDR_EX () {0x7e;}' unless defined(&AUT_IN_ADDR_EX);
    eval 'sub AUT_SOCKET_EX () {0x7f;}' unless defined(&AUT_SOCKET_EX);
    eval 'sub AUT_HEADER () { &AUT_HEADER32;}' unless defined(&AUT_HEADER);
    eval 'sub AUT_ARG () { &AUT_ARG32;}' unless defined(&AUT_ARG);
    eval 'sub AUT_RETURN () { &AUT_RETURN32;}' unless defined(&AUT_RETURN);
    eval 'sub AUT_SUBJECT () { &AUT_SUBJECT32;}' unless defined(&AUT_SUBJECT);
    eval 'sub AUT_PROCESS () { &AUT_PROCESS32;}' unless defined(&AUT_PROCESS);
    eval 'sub AUT_OTHER_FILE () { &AUT_OTHER_FILE32;}' unless defined(&AUT_OTHER_FILE);
    eval 'sub AUT_SOCKINET32 () {0x80;}' unless defined(&AUT_SOCKINET32);
    eval 'sub AUT_SOCKINET128 () {0x81;}' unless defined(&AUT_SOCKINET128);
    eval 'sub AUT_SOCKUNIX () {0x82;}' unless defined(&AUT_SOCKUNIX);
    eval 'sub AUT_RIGHTS () {0x83;}' unless defined(&AUT_RIGHTS);
    eval 'sub AUP_BINARY () {0;}' unless defined(&AUP_BINARY);
    eval 'sub AUP_OCTAL () {1;}' unless defined(&AUP_OCTAL);
    eval 'sub AUP_DECIMAL () {2;}' unless defined(&AUP_DECIMAL);
    eval 'sub AUP_HEX () {3;}' unless defined(&AUP_HEX);
    eval 'sub AUP_STRING () {4;}' unless defined(&AUP_STRING);
    eval 'sub AUR_BYTE () {0;}' unless defined(&AUR_BYTE);
    eval 'sub AUR_CHAR () { &AUR_BYTE;}' unless defined(&AUR_CHAR);
    eval 'sub AUR_SHORT () {1;}' unless defined(&AUR_SHORT);
    eval 'sub AUR_INT32 () {2;}' unless defined(&AUR_INT32);
    eval 'sub AUR_INT () { &AUR_INT32;}' unless defined(&AUR_INT);
    eval 'sub AUR_INT64 () {3;}' unless defined(&AUR_INT64);
    eval 'sub AUR_BYTE_SIZE () {$sizeof{\'u_char\'};}' unless defined(&AUR_BYTE_SIZE);
    eval 'sub AUR_CHAR_SIZE () { &AUR_BYTE_SIZE;}' unless defined(&AUR_CHAR_SIZE);
    eval 'sub AUR_SHORT_SIZE () {$sizeof{ &uint16_t};}' unless defined(&AUR_SHORT_SIZE);
    eval 'sub AUR_INT32_SIZE () {$sizeof{ &uint32_t};}' unless defined(&AUR_INT32_SIZE);
    eval 'sub AUR_INT_SIZE () { &AUR_INT32_SIZE;}' unless defined(&AUR_INT_SIZE);
    eval 'sub AUR_INT64_SIZE () {$sizeof{ &uint64_t};}' unless defined(&AUR_INT64_SIZE);
    eval 'sub PAD_NOTATTR () {0x4000;}' unless defined(&PAD_NOTATTR);
    eval 'sub PAD_FAILURE () {0x8000;}' unless defined(&PAD_FAILURE);
    eval 'sub AUDIT_MAX_GROUPS () {16;}' unless defined(&AUDIT_MAX_GROUPS);
    eval 'sub AUDIT_HEADER_VERSION_OLDDARWIN () {1;}' unless defined(&AUDIT_HEADER_VERSION_OLDDARWIN);
    eval 'sub AUDIT_HEADER_VERSION_SOLARIS () {2;}' unless defined(&AUDIT_HEADER_VERSION_SOLARIS);
    eval 'sub AUDIT_HEADER_VERSION_TSOL25 () {3;}' unless defined(&AUDIT_HEADER_VERSION_TSOL25);
    eval 'sub AUDIT_HEADER_VERSION_TSOL () {4;}' unless defined(&AUDIT_HEADER_VERSION_TSOL);
    eval 'sub AUDIT_HEADER_VERSION_OPENBSM10 () {10;}' unless defined(&AUDIT_HEADER_VERSION_OPENBSM10);
    eval 'sub AUDIT_HEADER_VERSION_OPENBSM11 () {11;}' unless defined(&AUDIT_HEADER_VERSION_OPENBSM11);
    eval 'sub AUDIT_HEADER_VERSION_OPENBSM () { &AUDIT_HEADER_VERSION_OPENBSM11;}' unless defined(&AUDIT_HEADER_VERSION_OPENBSM);
    eval 'sub AUT_TRAILER_MAGIC () {0xb105;}' unless defined(&AUT_TRAILER_MAGIC);
    if(defined(&_KERNEL) || defined(&KERNEL)) {
    }
    unless(defined(&_CAP_RIGHTS_T_DECLARED)) {
	eval 'sub _CAP_RIGHTS_T_DECLARED () {1;}' unless defined(&_CAP_RIGHTS_T_DECLARED);
    }
    if(!defined(&KERNEL)  && !defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL) || defined(&KERNEL)) {
    }
    if(defined(&_KERNEL) || defined(&KERNEL)) {
    } else {
    }
}
1;
