require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&asn1_h_)) {
    eval 'sub asn1_h_ () {1;}' unless defined(&asn1_h_);
    require 'sys/types.ph';
    eval 'sub asn_cptr () { ($asn_u->{cptr});}' unless defined(&asn_cptr);
    eval 'sub asn_ptr () { ($asn_u->{ptr});}' unless defined(&asn_ptr);
    eval 'sub ASN_MAXID () {0xffffffff;}' unless defined(&ASN_MAXID);
    eval 'sub ASN_MAXOIDLEN () {128;}' unless defined(&ASN_MAXOIDLEN);
    eval 'sub ASN_OIDSTRLEN () {( &ASN_MAXOIDLEN * (10+ 1) - 1+ 1);}' unless defined(&ASN_OIDSTRLEN);
    eval("sub ASN_ERR_OK () { 0; }") unless defined(&ASN_ERR_OK);
    eval("sub ASN_ERR_FAILED () { 1|0x1000; }") unless defined(&ASN_ERR_FAILED);
    eval("sub ASN_ERR_BADLEN () { 2; }") unless defined(&ASN_ERR_BADLEN);
    eval("sub ASN_ERR_EOBUF () { 3|0x1000; }") unless defined(&ASN_ERR_EOBUF);
    eval("sub ASN_ERR_RANGE () { 4; }") unless defined(&ASN_ERR_RANGE);
    eval("sub ASN_ERR_TAG () { 5|0x1000; }") unless defined(&ASN_ERR_TAG);
    eval 'sub ASN_ERR_STOPPED {
        my($E) = @_;
	    eval q(((($E) & 0x1000) != 0));
    }' unless defined(&ASN_ERR_STOPPED);
    eval 'sub ASN_MAXLEN () {65535;}' unless defined(&ASN_MAXLEN);
    eval 'sub ASN_MAXLENLEN () {2;}' unless defined(&ASN_MAXLENLEN);
    eval 'sub ASN_MAXOCTETSTRING () {65535;}' unless defined(&ASN_MAXOCTETSTRING);
    eval("sub ASN_TYPE_BOOLEAN () { 0x01; }") unless defined(&ASN_TYPE_BOOLEAN);
    eval("sub ASN_TYPE_INTEGER () { 0x02; }") unless defined(&ASN_TYPE_INTEGER);
    eval("sub ASN_TYPE_BITSTRING () { 0x03; }") unless defined(&ASN_TYPE_BITSTRING);
    eval("sub ASN_TYPE_OCTETSTRING () { 0x04; }") unless defined(&ASN_TYPE_OCTETSTRING);
    eval("sub ASN_TYPE_NULL () { 0x05; }") unless defined(&ASN_TYPE_NULL);
    eval("sub ASN_TYPE_OBJID () { 0x06; }") unless defined(&ASN_TYPE_OBJID);
    eval("sub ASN_TYPE_SEQUENCE () { 0x10; }") unless defined(&ASN_TYPE_SEQUENCE);
    eval("sub ASN_TYPE_CONSTRUCTED () { 0x20; }") unless defined(&ASN_TYPE_CONSTRUCTED);
    eval("sub ASN_CLASS_UNIVERSAL () { 0x00; }") unless defined(&ASN_CLASS_UNIVERSAL);
    eval("sub ASN_CLASS_APPLICATION () { 0x40; }") unless defined(&ASN_CLASS_APPLICATION);
    eval("sub ASN_CLASS_CONTEXT () { 0x80; }") unless defined(&ASN_CLASS_CONTEXT);
    eval("sub ASN_CLASS_PRIVATE () { 0xc0; }") unless defined(&ASN_CLASS_PRIVATE);
    eval("sub ASN_TYPE_MASK () { 0x1f; }") unless defined(&ASN_TYPE_MASK);
    eval("sub ASN_APP_IPADDRESS () { 0x00; }") unless defined(&ASN_APP_IPADDRESS);
    eval("sub ASN_APP_COUNTER () { 0x01; }") unless defined(&ASN_APP_COUNTER);
    eval("sub ASN_APP_GAUGE () { 0x02; }") unless defined(&ASN_APP_GAUGE);
    eval("sub ASN_APP_TIMETICKS () { 0x03; }") unless defined(&ASN_APP_TIMETICKS);
    eval("sub ASN_APP_OPAQUE () { 0x04; }") unless defined(&ASN_APP_OPAQUE);
    eval("sub ASN_APP_COUNTER64 () { 0x06; }") unless defined(&ASN_APP_COUNTER64);
    eval("sub ASN_EXCEPT_NOSUCHOBJECT () { 0x00; }") unless defined(&ASN_EXCEPT_NOSUCHOBJECT);
    eval("sub ASN_EXCEPT_NOSUCHINSTANCE () { 0x01; }") unless defined(&ASN_EXCEPT_NOSUCHINSTANCE);
    eval("sub ASN_EXCEPT_ENDOFMIBVIEW () { 0x02; }") unless defined(&ASN_EXCEPT_ENDOFMIBVIEW);
}
1;
