require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&snmpmod_h_)) {
    eval 'sub snmpmod_h_ () {1;}' unless defined(&snmpmod_h_);
    require 'sys/types.ph';
    require 'sys/queue.ph';
    require 'sys/socket.ph';
    require 'net/if.ph';
    require 'netinet/in.ph';
    require './bsnmp/asn1.ph';
    require './bsnmp/snmp.ph';
    require './bsnmp/snmpagent.ph';
    eval 'sub MAX_MOD_ARGS () {16;}' unless defined(&MAX_MOD_ARGS);
    eval 'sub INSERT_OBJECT_OID_LINK_INDEX {
        my($PTR, $LIST, $LINK, $INDEX) = @_;
	    eval q( &do {  &__typeof ($PTR)  &_lelem;  &TAILQ_FOREACH( &_lelem, ($LIST), $LINK)  &if ( &asn_compare_oid(& ($_lelem->{INDEX}), ($PTR)->$INDEX) > 0)  &break;  &if ( &_lelem ==  &NULL)  &TAILQ_INSERT_TAIL(($LIST), ($PTR), $LINK);  &else  &TAILQ_INSERT_BEFORE( &_lelem, ($PTR), $LINK); }  &while (0));
    }' unless defined(&INSERT_OBJECT_OID_LINK_INDEX);
    eval 'sub INSERT_OBJECT_INT_LINK_INDEX {
        my($PTR, $LIST, $LINK, $INDEX) = @_;
	    eval q( &do {  &__typeof ($PTR)  &_lelem;  &TAILQ_FOREACH( &_lelem, ($LIST), $LINK)  &if (( &asn_subid_t) ($_lelem->{INDEX}) > ( &asn_subid_t)($PTR)->$INDEX)  &break;  &if ( &_lelem ==  &NULL)  &TAILQ_INSERT_TAIL(($LIST), ($PTR), $LINK);  &else  &TAILQ_INSERT_BEFORE( &_lelem, ($PTR), $LINK); }  &while (0));
    }' unless defined(&INSERT_OBJECT_INT_LINK_INDEX);
    eval 'sub INSERT_OBJECT_FUNC_LINK {
        my($PTR, $LIST, $LINK, $FUNC) = @_;
	    eval q( &do {  &__typeof ($PTR)  &_lelem;  &TAILQ_FOREACH( &_lelem, ($LIST), $LINK)  &if (($FUNC)( &_lelem, ($PTR)) > 0)  &break;  &if ( &_lelem ==  &NULL)  &TAILQ_INSERT_TAIL(($LIST), ($PTR), $LINK);  &else  &TAILQ_INSERT_BEFORE( &_lelem, ($PTR), $LINK); }  &while (0));
    }' unless defined(&INSERT_OBJECT_FUNC_LINK);
    eval 'sub INSERT_OBJECT_FUNC_LINK_REV {
        my($PTR, $LIST, $HEAD, $LINK, $FUNC) = @_;
	    eval q( &do {  &__typeof ($PTR)  &_lelem;  &TAILQ_FOREACH_REVERSE( &_lelem, ($LIST), $HEAD, $LINK)  &if (($FUNC)( &_lelem, ($PTR)) < 0)  &break;  &if ( &_lelem ==  &NULL)  &TAILQ_INSERT_HEAD(($LIST), ($PTR), $LINK);  &else  &TAILQ_INSERT_AFTER(($LIST),  &_lelem, ($PTR), $LINK); }  &while (0));
    }' unless defined(&INSERT_OBJECT_FUNC_LINK_REV);
    eval 'sub FIND_OBJECT_OID_LINK_INDEX {
        my($LIST, $OID, $SUB, $LINK, $INDEX) = @_;
	    eval q(({  &__typeof ( &TAILQ_FIRST($LIST))  &_lelem;  &TAILQ_FOREACH( &_lelem, ($LIST), $LINK)  &if ( &index_compare($OID, $SUB, & ($_lelem->{INDEX})) == 0)  &break; ( &_lelem); }));
    }' unless defined(&FIND_OBJECT_OID_LINK_INDEX);
    eval 'sub NEXT_OBJECT_OID_LINK_INDEX {
        my($LIST, $OID, $SUB, $LINK, $INDEX) = @_;
	    eval q(({  &__typeof ( &TAILQ_FIRST($LIST))  &_lelem;  &TAILQ_FOREACH( &_lelem, ($LIST), $LINK)  &if ( &index_compare($OID, $SUB, & ($_lelem->{INDEX})) < 0)  &break; ( &_lelem); }));
    }' unless defined(&NEXT_OBJECT_OID_LINK_INDEX);
    eval 'sub FIND_OBJECT_INT_LINK_INDEX {
        my($LIST, $OID, $SUB, $LINK, $INDEX) = @_;
	    eval q(({  &__typeof ( &TAILQ_FIRST($LIST))  &_lelem;  &if (($OID)-> &len - $SUB != 1)  &_lelem =  &NULL;  &else  &TAILQ_FOREACH( &_lelem, ($LIST), $LINK)  &if (($OID)-> $subs[$SUB] == ( &asn_subid_t) ($_lelem->{INDEX}))  &break; ( &_lelem); }));
    }' unless defined(&FIND_OBJECT_INT_LINK_INDEX);
    eval 'sub NEXT_OBJECT_INT_LINK_INDEX {
        my($LIST, $OID, $SUB, $LINK, $INDEX) = @_;
	    eval q(({  &__typeof ( &TAILQ_FIRST($LIST))  &_lelem;  &if (($OID)-> &len - $SUB == 0)  &_lelem =  &TAILQ_FIRST($LIST);  &else  &TAILQ_FOREACH( &_lelem, ($LIST), $LINK)  &if (($OID)-> $subs[$SUB] < ( &asn_subid_t) ($_lelem->{INDEX}))  &break; ( &_lelem); }));
    }' unless defined(&NEXT_OBJECT_INT_LINK_INDEX);
    eval 'sub FIND_OBJECT_FUNC_LINK {
        my($LIST, $OID, $SUB, $LINK, $FUNC) = @_;
	    eval q(({  &__typeof ( &TAILQ_FIRST($LIST))  &_lelem;  &TAILQ_FOREACH( &_lelem, ($LIST), $LINK)  &if (($FUNC)($OID, $SUB,  &_lelem) == 0)  &break; ( &_lelem); }));
    }' unless defined(&FIND_OBJECT_FUNC_LINK);
    eval 'sub NEXT_OBJECT_FUNC_LINK {
        my($LIST, $OID, $SUB, $LINK, $FUNC) = @_;
	    eval q(({  &__typeof ( &TAILQ_FIRST($LIST))  &_lelem;  &TAILQ_FOREACH( &_lelem, ($LIST), $LINK)  &if (($FUNC)($OID, $SUB,  &_lelem) < 0)  &break; ( &_lelem); }));
    }' unless defined(&NEXT_OBJECT_FUNC_LINK);
    eval 'sub INSERT_OBJECT_OID_LINK {
        my($PTR, $LIST, $LINK) = @_;
	    eval q( &INSERT_OBJECT_OID_LINK_INDEX($PTR, $LIST, $LINK,  &index));
    }' unless defined(&INSERT_OBJECT_OID_LINK);
    eval 'sub INSERT_OBJECT_INT_LINK {
        my($PTR, $LIST, $LINK) = @_;
	    eval q( &do {  &INSERT_OBJECT_INT_LINK_INDEX($PTR, $LIST, $LINK,  &index));
    }' unless defined(&INSERT_OBJECT_INT_LINK);
    eval 'sub FIND_OBJECT_OID_LINK {
        my($LIST, $OID, $SUB, $LINK) = @_;
	    eval q( &FIND_OBJECT_OID_LINK_INDEX($LIST, $OID, $SUB, $LINK,  &index));
    }' unless defined(&FIND_OBJECT_OID_LINK);
    eval 'sub NEXT_OBJECT_OID_LINK {
        my($LIST, $OID, $SUB, $LINK) = @_;
	    eval q( &NEXT_OBJECT_OID_LINK_INDEX($LIST, $OID, $SUB, $LINK,  &index));
    }' unless defined(&NEXT_OBJECT_OID_LINK);
    eval 'sub FIND_OBJECT_INT_LINK {
        my($LIST, $OID, $SUB, $LINK) = @_;
	    eval q( &FIND_OBJECT_INT_LINK_INDEX($LIST, $OID, $SUB, $LINK,  &index));
    }' unless defined(&FIND_OBJECT_INT_LINK);
    eval 'sub NEXT_OBJECT_INT_LINK {
        my($LIST, $OID, $SUB, $LINK) = @_;
	    eval q( &NEXT_OBJECT_INT_LINK_INDEX($LIST, $OID, $SUB, $LINK,  &index));
    }' unless defined(&NEXT_OBJECT_INT_LINK);
    eval 'sub INSERT_OBJECT_OID {
        my($PTR, $LIST) = @_;
	    eval q( &INSERT_OBJECT_OID_LINK_INDEX($PTR, $LIST,  &link,  &index));
    }' unless defined(&INSERT_OBJECT_OID);
    eval 'sub INSERT_OBJECT_INT {
        my($PTR, $LIST) = @_;
	    eval q( &INSERT_OBJECT_INT_LINK_INDEX($PTR, $LIST,  &link,  &index));
    }' unless defined(&INSERT_OBJECT_INT);
    eval 'sub INSERT_OBJECT_FUNC_REV {
        my($PTR, $LIST, $HEAD, $FUNC) = @_;
	    eval q( &INSERT_OBJECT_FUNC_LINK_REV($PTR, $LIST, $HEAD,  &link, $FUNC));
    }' unless defined(&INSERT_OBJECT_FUNC_REV);
    eval 'sub FIND_OBJECT_OID {
        my($LIST, $OID, $SUB) = @_;
	    eval q( &FIND_OBJECT_OID_LINK_INDEX($LIST, $OID, $SUB,  &link,  &index));
    }' unless defined(&FIND_OBJECT_OID);
    eval 'sub FIND_OBJECT_INT {
        my($LIST, $OID, $SUB) = @_;
	    eval q( &FIND_OBJECT_INT_LINK_INDEX($LIST, $OID, $SUB,  &link,  &index));
    }' unless defined(&FIND_OBJECT_INT);
    eval 'sub FIND_OBJECT_FUNC {
        my($LIST, $OID, $SUB, $FUNC) = @_;
	    eval q( &FIND_OBJECT_FUNC_LINK($LIST, $OID, $SUB,  &link, $FUNC));
    }' unless defined(&FIND_OBJECT_FUNC);
    eval 'sub NEXT_OBJECT_OID {
        my($LIST, $OID, $SUB) = @_;
	    eval q( &NEXT_OBJECT_OID_LINK_INDEX($LIST, $OID, $SUB,  &link,  &index));
    }' unless defined(&NEXT_OBJECT_OID);
    eval 'sub NEXT_OBJECT_INT {
        my($LIST, $OID, $SUB) = @_;
	    eval q( &NEXT_OBJECT_INT_LINK_INDEX($LIST, $OID, $SUB,  &link,  &index));
    }' unless defined(&NEXT_OBJECT_INT);
    eval 'sub NEXT_OBJECT_FUNC {
        my($LIST, $OID, $SUB, $FUNC) = @_;
	    eval q( &NEXT_OBJECT_FUNC_LINK($LIST, $OID, $SUB,  &link, $FUNC));
    }' unless defined(&NEXT_OBJECT_FUNC);
    eval("sub SNMPD_PROXY_OK () { 0; }") unless defined(&SNMPD_PROXY_OK);
    eval("sub SNMPD_PROXY_REJ () { 1; }") unless defined(&SNMPD_PROXY_REJ);
    eval("sub SNMPD_PROXY_DROP () { 2; }") unless defined(&SNMPD_PROXY_DROP);
    eval("sub SNMPD_PROXY_BADCOMM () { 3; }") unless defined(&SNMPD_PROXY_BADCOMM);
    eval("sub SNMPD_PROXY_BADCOMMUSE () { 4; }") unless defined(&SNMPD_PROXY_BADCOMMUSE);
    eval("sub SNMPD_INPUT_OK () { 0; }") unless defined(&SNMPD_INPUT_OK);
    eval("sub SNMPD_INPUT_FAILED () { 1; }") unless defined(&SNMPD_INPUT_FAILED);
    eval("sub SNMPD_INPUT_VALBADLEN () { 2; }") unless defined(&SNMPD_INPUT_VALBADLEN);
    eval("sub SNMPD_INPUT_VALRANGE () { 3; }") unless defined(&SNMPD_INPUT_VALRANGE);
    eval("sub SNMPD_INPUT_VALBADENC () { 4; }") unless defined(&SNMPD_INPUT_VALBADENC);
    eval("sub SNMPD_INPUT_TRUNC () { 5; }") unless defined(&SNMPD_INPUT_TRUNC);
    eval("sub SNMPD_INPUT_BAD_COMM () { 6; }") unless defined(&SNMPD_INPUT_BAD_COMM);
    eval 'sub COMM_INITIALIZE () {0;}' unless defined(&COMM_INITIALIZE);
    eval 'sub COMM_READ () {1;}' unless defined(&COMM_READ);
    eval 'sub COMM_WRITE () {2;}' unless defined(&COMM_WRITE);
    eval 'sub SNMP_UDP_ADDR_SIZ () {6;}' unless defined(&SNMP_UDP_ADDR_SIZ);
    eval 'sub SNMP_TAG_SIZ () {(255+ 1);}' unless defined(&SNMP_TAG_SIZ);
}
1;
