require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LIBCPP_BSD_LOCALE_DEFAULTS_H)) {
    eval 'sub _LIBCPP_BSD_LOCALE_DEFAULTS_H () {1;}' unless defined(&_LIBCPP_BSD_LOCALE_DEFAULTS_H);
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    eval 'sub __libcpp_mb_cur_max_l {
        my($loc) = @_;
	    eval q( &MB_CUR_MAX_L($loc));
    }' unless defined(&__libcpp_mb_cur_max_l);
    eval 'sub __libcpp_btowc_l {
        my($ch, $loc) = @_;
	    eval q( &btowc_l($ch, $loc));
    }' unless defined(&__libcpp_btowc_l);
    eval 'sub __libcpp_wctob_l {
        my($wch, $loc) = @_;
	    eval q( &wctob_l($wch, $loc));
    }' unless defined(&__libcpp_wctob_l);
    eval 'sub __libcpp_wcsnrtombs_l {
        my($dst, $src, $nwc, $len, $ps, $loc) = @_;
	    eval q( &wcsnrtombs_l($dst, $src, $nwc, $len, $ps, $loc));
    }' unless defined(&__libcpp_wcsnrtombs_l);
    eval 'sub __libcpp_wcrtomb_l {
        my($src, $wc, $ps, $loc) = @_;
	    eval q( &wcrtomb_l($src, $wc, $ps, $loc));
    }' unless defined(&__libcpp_wcrtomb_l);
    eval 'sub __libcpp_mbsnrtowcs_l {
        my($dst, $src, $nms, $len, $ps, $loc) = @_;
	    eval q( &mbsnrtowcs_l($dst, $src, $nms, $len, $ps, $loc));
    }' unless defined(&__libcpp_mbsnrtowcs_l);
    eval 'sub __libcpp_mbrtowc_l {
        my($pwc, $s, $n, $ps, $l) = @_;
	    eval q( &mbrtowc_l($pwc, $s, $n, $ps, $l));
    }' unless defined(&__libcpp_mbrtowc_l);
    eval 'sub __libcpp_mbtowc_l {
        my($pwc, $pmb, $max, $l) = @_;
	    eval q( &mbtowc_l($pwc, $pmb, $max, $l));
    }' unless defined(&__libcpp_mbtowc_l);
    eval 'sub __libcpp_mbrlen_l {
        my($s, $n, $ps, $l) = @_;
	    eval q( &mbrlen_l($s, $n, $ps, $l));
    }' unless defined(&__libcpp_mbrlen_l);
    eval 'sub __libcpp_localeconv_l {
        my($l) = @_;
	    eval q( &localeconv_l($l));
    }' unless defined(&__libcpp_localeconv_l);
    eval 'sub __libcpp_mbsrtowcs_l {
        my($dest, $src, $len, $ps, $l) = @_;
	    eval q( &mbsrtowcs_l($dest, $src, $len, $ps, $l));
    }' unless defined(&__libcpp_mbsrtowcs_l);
    eval 'sub __libcpp_snprintf_l () {(...)  &snprintf_l( &__VA_ARGS__);}' unless defined(&__libcpp_snprintf_l);
    eval 'sub __libcpp_asprintf_l () {(...)  &asprintf_l( &__VA_ARGS__);}' unless defined(&__libcpp_asprintf_l);
    eval 'sub __libcpp_sscanf_l () {(...)  &sscanf_l( &__VA_ARGS__);}' unless defined(&__libcpp_sscanf_l);
}
1;
