require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LIBCPP_ERRNO_H)) {
    eval 'sub _LIBCPP_ERRNO_H () {1;}' unless defined(&_LIBCPP_ERRNO_H);
    require '__config';
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "errno.ph" } keys(%INC));
	@REM = map { "$_/errno.ph" } (grep { not exists($INCD{"$_/errno.ph"}) and -f "$_/errno.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
    if(defined(&__cplusplus)) {
	if(!defined(&EOWNERDEAD) || !defined(&ENOTRECOVERABLE)) {
	    if(defined(&ELAST)) {
	    } else {
	    }
	    if(defined(&ENOTRECOVERABLE)) {
		eval 'sub EOWNERDEAD () { &__elast1;}' unless defined(&EOWNERDEAD);
		if(defined(&ELAST)) {
		    undef(&ELAST) if defined(&ELAST);
		    eval 'sub ELAST () { &EOWNERDEAD;}' unless defined(&ELAST);
		}
	    }
 elsif(defined(&EOWNERDEAD)) {
		eval 'sub ENOTRECOVERABLE () { &__elast1;}' unless defined(&ENOTRECOVERABLE);
		if(defined(&ELAST)) {
		    undef(&ELAST) if defined(&ELAST);
		    eval 'sub ELAST () { &ENOTRECOVERABLE;}' unless defined(&ELAST);
		}
	    } else {
		eval 'sub EOWNERDEAD () { &__elast1;}' unless defined(&EOWNERDEAD);
		eval 'sub ENOTRECOVERABLE () { &__elast2;}' unless defined(&ENOTRECOVERABLE);
		if(defined(&ELAST)) {
		    undef(&ELAST) if defined(&ELAST);
		    eval 'sub ELAST () { &ENOTRECOVERABLE;}' unless defined(&ELAST);
		}
	    }
	}
	unless(defined(&EAFNOSUPPORT)) {
	    eval 'sub EAFNOSUPPORT () {9901;}' unless defined(&EAFNOSUPPORT);
	}
	unless(defined(&EADDRINUSE)) {
	    eval 'sub EADDRINUSE () {9902;}' unless defined(&EADDRINUSE);
	}
	unless(defined(&EADDRNOTAVAIL)) {
	    eval 'sub EADDRNOTAVAIL () {9903;}' unless defined(&EADDRNOTAVAIL);
	}
	unless(defined(&EISCONN)) {
	    eval 'sub EISCONN () {9904;}' unless defined(&EISCONN);
	}
	unless(defined(&EBADMSG)) {
	    eval 'sub EBADMSG () {9905;}' unless defined(&EBADMSG);
	}
	unless(defined(&ECONNABORTED)) {
	    eval 'sub ECONNABORTED () {9906;}' unless defined(&ECONNABORTED);
	}
	unless(defined(&EALREADY)) {
	    eval 'sub EALREADY () {9907;}' unless defined(&EALREADY);
	}
	unless(defined(&ECONNREFUSED)) {
	    eval 'sub ECONNREFUSED () {9908;}' unless defined(&ECONNREFUSED);
	}
	unless(defined(&ECONNRESET)) {
	    eval 'sub ECONNRESET () {9909;}' unless defined(&ECONNRESET);
	}
	unless(defined(&EDESTADDRREQ)) {
	    eval 'sub EDESTADDRREQ () {9910;}' unless defined(&EDESTADDRREQ);
	}
	unless(defined(&EHOSTUNREACH)) {
	    eval 'sub EHOSTUNREACH () {9911;}' unless defined(&EHOSTUNREACH);
	}
	unless(defined(&EIDRM)) {
	    eval 'sub EIDRM () {9912;}' unless defined(&EIDRM);
	}
	unless(defined(&EMSGSIZE)) {
	    eval 'sub EMSGSIZE () {9913;}' unless defined(&EMSGSIZE);
	}
	unless(defined(&ENETDOWN)) {
	    eval 'sub ENETDOWN () {9914;}' unless defined(&ENETDOWN);
	}
	unless(defined(&ENETRESET)) {
	    eval 'sub ENETRESET () {9915;}' unless defined(&ENETRESET);
	}
	unless(defined(&ENETUNREACH)) {
	    eval 'sub ENETUNREACH () {9916;}' unless defined(&ENETUNREACH);
	}
	unless(defined(&ENOBUFS)) {
	    eval 'sub ENOBUFS () {9917;}' unless defined(&ENOBUFS);
	}
	unless(defined(&ENOLINK)) {
	    eval 'sub ENOLINK () {9918;}' unless defined(&ENOLINK);
	}
	unless(defined(&ENODATA)) {
	    eval 'sub ENODATA () {9919;}' unless defined(&ENODATA);
	}
	unless(defined(&ENOMSG)) {
	    eval 'sub ENOMSG () {9920;}' unless defined(&ENOMSG);
	}
	unless(defined(&ENOPROTOOPT)) {
	    eval 'sub ENOPROTOOPT () {9921;}' unless defined(&ENOPROTOOPT);
	}
	unless(defined(&ENOSR)) {
	    eval 'sub ENOSR () {9922;}' unless defined(&ENOSR);
	}
	unless(defined(&ENOTSOCK)) {
	    eval 'sub ENOTSOCK () {9923;}' unless defined(&ENOTSOCK);
	}
	unless(defined(&ENOSTR)) {
	    eval 'sub ENOSTR () {9924;}' unless defined(&ENOSTR);
	}
	unless(defined(&ENOTCONN)) {
	    eval 'sub ENOTCONN () {9925;}' unless defined(&ENOTCONN);
	}
	unless(defined(&ENOTSUP)) {
	    eval 'sub ENOTSUP () {9926;}' unless defined(&ENOTSUP);
	}
	unless(defined(&ECANCELED)) {
	    eval 'sub ECANCELED () {9927;}' unless defined(&ECANCELED);
	}
	unless(defined(&EINPROGRESS)) {
	    eval 'sub EINPROGRESS () {9928;}' unless defined(&EINPROGRESS);
	}
	unless(defined(&EOPNOTSUPP)) {
	    eval 'sub EOPNOTSUPP () {9929;}' unless defined(&EOPNOTSUPP);
	}
	unless(defined(&EWOULDBLOCK)) {
	    eval 'sub EWOULDBLOCK () {9930;}' unless defined(&EWOULDBLOCK);
	}
	unless(defined(&EOWNERDEAD)) {
	    eval 'sub EOWNERDEAD () {9931;}' unless defined(&EOWNERDEAD);
	}
	unless(defined(&EPROTO)) {
	    eval 'sub EPROTO () {9932;}' unless defined(&EPROTO);
	}
	unless(defined(&EPROTONOSUPPORT)) {
	    eval 'sub EPROTONOSUPPORT () {9933;}' unless defined(&EPROTONOSUPPORT);
	}
	unless(defined(&ENOTRECOVERABLE)) {
	    eval 'sub ENOTRECOVERABLE () {9934;}' unless defined(&ENOTRECOVERABLE);
	}
	unless(defined(&ETIME)) {
	    eval 'sub ETIME () {9935;}' unless defined(&ETIME);
	}
	unless(defined(&ETXTBSY)) {
	    eval 'sub ETXTBSY () {9936;}' unless defined(&ETXTBSY);
	}
	unless(defined(&ETIMEDOUT)) {
	    eval 'sub ETIMEDOUT () {9938;}' unless defined(&ETIMEDOUT);
	}
	unless(defined(&ELOOP)) {
	    eval 'sub ELOOP () {9939;}' unless defined(&ELOOP);
	}
	unless(defined(&EOVERFLOW)) {
	    eval 'sub EOVERFLOW () {9940;}' unless defined(&EOVERFLOW);
	}
	unless(defined(&EPROTOTYPE)) {
	    eval 'sub EPROTOTYPE () {9941;}' unless defined(&EPROTOTYPE);
	}
	unless(defined(&ENOSYS)) {
	    eval 'sub ENOSYS () {9942;}' unless defined(&ENOSYS);
	}
	unless(defined(&EINVAL)) {
	    eval 'sub EINVAL () {9943;}' unless defined(&EINVAL);
	}
	unless(defined(&ERANGE)) {
	    eval 'sub ERANGE () {9944;}' unless defined(&ERANGE);
	}
	unless(defined(&EILSEQ)) {
	    eval 'sub EILSEQ () {9945;}' unless defined(&EILSEQ);
	}
	unless(defined(&E2BIG)) {
	    eval 'sub E2BIG () {9946;}' unless defined(&E2BIG);
	}
	unless(defined(&EDOM)) {
	    eval 'sub EDOM () {9947;}' unless defined(&EDOM);
	}
	unless(defined(&EFAULT)) {
	    eval 'sub EFAULT () {9948;}' unless defined(&EFAULT);
	}
	unless(defined(&EBADF)) {
	    eval 'sub EBADF () {9949;}' unless defined(&EBADF);
	}
	unless(defined(&EPIPE)) {
	    eval 'sub EPIPE () {9950;}' unless defined(&EPIPE);
	}
	unless(defined(&EXDEV)) {
	    eval 'sub EXDEV () {9951;}' unless defined(&EXDEV);
	}
	unless(defined(&EBUSY)) {
	    eval 'sub EBUSY () {9952;}' unless defined(&EBUSY);
	}
	unless(defined(&ENOTEMPTY)) {
	    eval 'sub ENOTEMPTY () {9953;}' unless defined(&ENOTEMPTY);
	}
	unless(defined(&ENOEXEC)) {
	    eval 'sub ENOEXEC () {9954;}' unless defined(&ENOEXEC);
	}
	unless(defined(&EEXIST)) {
	    eval 'sub EEXIST () {9955;}' unless defined(&EEXIST);
	}
	unless(defined(&EFBIG)) {
	    eval 'sub EFBIG () {9956;}' unless defined(&EFBIG);
	}
	unless(defined(&ENAMETOOLONG)) {
	    eval 'sub ENAMETOOLONG () {9957;}' unless defined(&ENAMETOOLONG);
	}
	unless(defined(&ENOTTY)) {
	    eval 'sub ENOTTY () {9958;}' unless defined(&ENOTTY);
	}
	unless(defined(&EINTR)) {
	    eval 'sub EINTR () {9959;}' unless defined(&EINTR);
	}
	unless(defined(&ESPIPE)) {
	    eval 'sub ESPIPE () {9960;}' unless defined(&ESPIPE);
	}
	unless(defined(&EIO)) {
	    eval 'sub EIO () {9961;}' unless defined(&EIO);
	}
	unless(defined(&EISDIR)) {
	    eval 'sub EISDIR () {9962;}' unless defined(&EISDIR);
	}
	unless(defined(&ECHILD)) {
	    eval 'sub ECHILD () {9963;}' unless defined(&ECHILD);
	}
	unless(defined(&ENOLCK)) {
	    eval 'sub ENOLCK () {9964;}' unless defined(&ENOLCK);
	}
	unless(defined(&ENOSPC)) {
	    eval 'sub ENOSPC () {9965;}' unless defined(&ENOSPC);
	}
	unless(defined(&ENXIO)) {
	    eval 'sub ENXIO () {9966;}' unless defined(&ENXIO);
	}
	unless(defined(&ENODEV)) {
	    eval 'sub ENODEV () {9967;}' unless defined(&ENODEV);
	}
	unless(defined(&ENOENT)) {
	    eval 'sub ENOENT () {9968;}' unless defined(&ENOENT);
	}
	unless(defined(&ESRCH)) {
	    eval 'sub ESRCH () {9969;}' unless defined(&ESRCH);
	}
	unless(defined(&ENOTDIR)) {
	    eval 'sub ENOTDIR () {9970;}' unless defined(&ENOTDIR);
	}
	unless(defined(&ENOMEM)) {
	    eval 'sub ENOMEM () {9971;}' unless defined(&ENOMEM);
	}
	unless(defined(&EPERM)) {
	    eval 'sub EPERM () {9972;}' unless defined(&EPERM);
	}
	unless(defined(&EACCES)) {
	    eval 'sub EACCES () {9973;}' unless defined(&EACCES);
	}
	unless(defined(&EROFS)) {
	    eval 'sub EROFS () {9974;}' unless defined(&EROFS);
	}
	unless(defined(&EDEADLK)) {
	    eval 'sub EDEADLK () {9975;}' unless defined(&EDEADLK);
	}
	unless(defined(&EAGAIN)) {
	    eval 'sub EAGAIN () {9976;}' unless defined(&EAGAIN);
	}
	unless(defined(&ENFILE)) {
	    eval 'sub ENFILE () {9977;}' unless defined(&ENFILE);
	}
	unless(defined(&EMFILE)) {
	    eval 'sub EMFILE () {9978;}' unless defined(&EMFILE);
	}
	unless(defined(&EMLINK)) {
	    eval 'sub EMLINK () {9979;}' unless defined(&EMLINK);
	}
    }
}
1;
