require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LIBCPP_FLOAT_H)) {
    eval 'sub _LIBCPP_FLOAT_H () {1;}' unless defined(&_LIBCPP_FLOAT_H);
    require '__config';
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "float.ph" } keys(%INC));
	@REM = map { "$_/float.ph" } (grep { not exists($INCD{"$_/float.ph"}) and -f "$_/float.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
    if(defined(&__cplusplus)) {
	unless(defined(&FLT_EVAL_METHOD)) {
	    eval 'sub FLT_EVAL_METHOD () { &__FLT_EVAL_METHOD__;}' unless defined(&FLT_EVAL_METHOD);
	}
	unless(defined(&DECIMAL_DIG)) {
	    eval 'sub DECIMAL_DIG () { &__DECIMAL_DIG__;}' unless defined(&DECIMAL_DIG);
	}
    }
}
1;
