require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LIBCPP_STDINT_H)) {
    eval 'sub _LIBCPP_STDINT_H () {1;}' unless defined(&_LIBCPP_STDINT_H);
    require '__config';
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    if(defined(&__cplusplus)  && !defined(&__STDC_LIMIT_MACROS)) {
	eval 'sub __STDC_LIMIT_MACROS () {1;}' unless defined(&__STDC_LIMIT_MACROS);
    }
    if(defined(&__cplusplus)  && !defined(&__STDC_CONSTANT_MACROS)) {
	eval 'sub __STDC_CONSTANT_MACROS () {1;}' unless defined(&__STDC_CONSTANT_MACROS);
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "stdint.ph" } keys(%INC));
	@REM = map { "$_/stdint.ph" } (grep { not exists($INCD{"$_/stdint.ph"}) and -f "$_/stdint.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
}
1;
