require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LIBCPP_STRING_H)) {
    eval 'sub _LIBCPP_STRING_H () {1;}' unless defined(&_LIBCPP_STRING_H);
    require '__config';
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "string.ph" } keys(%INC));
	@REM = map { "$_/string.ph" } (grep { not exists($INCD{"$_/string.ph"}) and -f "$_/string.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
    if(defined(&__CORRECT_ISO_CPP_STRING_H_PROTO) || defined(&_LIBCPP_MSVCRT) || defined(&__sun__) || defined(&_STRING_H_CPLUSPLUS_98_CONFORMANCE_)) {
	eval 'sub _LIBCPP_STRING_H_HAS_CONST_OVERLOADS () {1;}' unless defined(&_LIBCPP_STRING_H_HAS_CONST_OVERLOADS);
    }
    if(defined(&__cplusplus)  && !defined(&_LIBCPP_STRING_H_HAS_CONST_OVERLOADS)  && defined(&_LIBCPP_PREFERRED_OVERLOAD)) {
    }
}
1;
