require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__need_wint_t) || defined(&__need_mbstate_t)) {
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "wchar.ph" } keys(%INC));
	@REM = map { "$_/wchar.ph" } (grep { not exists($INCD{"$_/wchar.ph"}) and -f "$_/wchar.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
}
 elsif(!defined(&_LIBCPP_WCHAR_H)) {
    eval 'sub _LIBCPP_WCHAR_H () {1;}' unless defined(&_LIBCPP_WCHAR_H);
    require '__config';
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    if(defined(&__cplusplus)) {
	eval 'sub __CORRECT_ISO_CPP_WCHAR_H_PROTO () {1;}' unless defined(&__CORRECT_ISO_CPP_WCHAR_H_PROTO);
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "wchar.ph" } keys(%INC));
	@REM = map { "$_/wchar.ph" } (grep { not exists($INCD{"$_/wchar.ph"}) and -f "$_/wchar.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
    if(defined(&_WCHAR_H_CPLUSPLUS_98_CONFORMANCE_)) {
	eval 'sub _LIBCPP_WCHAR_H_HAS_CONST_OVERLOADS () {1;}' unless defined(&_LIBCPP_WCHAR_H_HAS_CONST_OVERLOADS);
    }
 elsif(defined(&__GLIBC_PREREQ)) {
	if( &__GLIBC_PREREQ(2, 10)) {
	    eval 'sub _LIBCPP_WCHAR_H_HAS_CONST_OVERLOADS () {1;}' unless defined(&_LIBCPP_WCHAR_H_HAS_CONST_OVERLOADS);
	}
    }
 elsif(defined(&_LIBCPP_MSVCRT)) {
	if(defined(&_CRT_CONST_CORRECT_OVERLOADS)) {
	    eval 'sub _LIBCPP_WCHAR_H_HAS_CONST_OVERLOADS () {1;}' unless defined(&_LIBCPP_WCHAR_H_HAS_CONST_OVERLOADS);
	}
    }
    if(defined(&__cplusplus)  && !defined(&_LIBCPP_WCHAR_H_HAS_CONST_OVERLOADS)  && defined(&_LIBCPP_PREFERRED_OVERLOAD)) {
    }
    if(defined(&__cplusplus)  && defined(&_LIBCPP_MSVCRT_LIKE)) {
    }
}
1;
