require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CAM_CAM_H)) {
    eval 'sub _CAM_CAM_H () {1;}' unless defined(&_CAM_CAM_H);
    if(defined(&_KERNEL)) {
	require 'opt_cam.ph';
    }
    require 'sys/cdefs.ph';
    eval 'sub CAM_XPT_PATH_ID () {(( &path_id_t)~0);}' unless defined(&CAM_XPT_PATH_ID);
    eval 'sub CAM_BUS_WILDCARD () {(( &path_id_t)~0);}' unless defined(&CAM_BUS_WILDCARD);
    eval 'sub CAM_TARGET_WILDCARD () {(( &target_id_t)~0);}' unless defined(&CAM_TARGET_WILDCARD);
    eval 'sub CAM_LUN_WILDCARD () {(~0);}' unless defined(&CAM_LUN_WILDCARD);
    eval 'sub CAM_EXTLUN_BYTE_SWIZZLE {
        my($lun) = @_;
	    eval q(( (((( &u_int64_t)$lun) & 0xffff000000000000) >> 48) | (((( &u_int64_t)$lun) & 0xffff00000000) >> 16) | (((( &u_int64_t)$lun) & 0xffff0000) << 16) | (((( &u_int64_t)$lun) & 0xffff) << 48)));
    }' unless defined(&CAM_EXTLUN_BYTE_SWIZZLE);
    eval 'sub CAM_MAX_CDBLEN () {16;}' unless defined(&CAM_MAX_CDBLEN);
    eval("sub CAM_RL_HOST () { 0; }") unless defined(&CAM_RL_HOST);
    eval("sub CAM_RL_BUS () { 1; }") unless defined(&CAM_RL_BUS);
    eval("sub CAM_RL_XPT () { 2; }") unless defined(&CAM_RL_XPT);
    eval("sub CAM_RL_DEV () { 3; }") unless defined(&CAM_RL_DEV);
    eval("sub CAM_RL_NORMAL () { 4; }") unless defined(&CAM_RL_NORMAL);
    eval("sub CAM_RL_VALUES () { 5; }") unless defined(&CAM_RL_VALUES);
    eval 'sub CAM_PRIORITY_HOST () {(( &CAM_RL_HOST << 8) + 0x80);}' unless defined(&CAM_PRIORITY_HOST);
    eval 'sub CAM_PRIORITY_BUS () {(( &CAM_RL_BUS << 8) + 0x80);}' unless defined(&CAM_PRIORITY_BUS);
    eval 'sub CAM_PRIORITY_XPT () {(( &CAM_RL_XPT << 8) + 0x80);}' unless defined(&CAM_PRIORITY_XPT);
    eval 'sub CAM_PRIORITY_DEV () {(( &CAM_RL_DEV << 8) + 0x80);}' unless defined(&CAM_PRIORITY_DEV);
    eval 'sub CAM_PRIORITY_OOB () {( &CAM_RL_DEV << 8);}' unless defined(&CAM_PRIORITY_OOB);
    eval 'sub CAM_PRIORITY_NORMAL () {(( &CAM_RL_NORMAL << 8) + 0x80);}' unless defined(&CAM_PRIORITY_NORMAL);
    eval 'sub CAM_PRIORITY_NONE () {( &u_int32_t)-1;}' unless defined(&CAM_PRIORITY_NONE);
    eval 'sub CAM_UNQUEUED_INDEX () {-1;}' unless defined(&CAM_UNQUEUED_INDEX);
    eval 'sub CAM_ACTIVE_INDEX () {-2;}' unless defined(&CAM_ACTIVE_INDEX);
    eval 'sub CAM_DONEQ_INDEX () {-3;}' unless defined(&CAM_DONEQ_INDEX);
    eval 'sub CAM_EXTRAQ_INDEX () { &INT_MAX;}' unless defined(&CAM_EXTRAQ_INDEX);
    eval 'sub GENERATIONCMP {
        my($x, $op, $y) = @_;
	    eval q((( &int32_t)(($x) - ($y)) $op 0));
    }' unless defined(&GENERATIONCMP);
    eval("sub CAM_FLAG_NONE () { 0x00; }") unless defined(&CAM_FLAG_NONE);
    eval("sub CAM_EXPECT_INQ_CHANGE () { 0x01; }") unless defined(&CAM_EXPECT_INQ_CHANGE);
    eval("sub CAM_RETRY_SELTO () { 0x02; }") unless defined(&CAM_RETRY_SELTO);
    eval("sub SF_RETRY_UA () { 0x01; }") unless defined(&SF_RETRY_UA);
    eval("sub SF_NO_PRINT () { 0x02; }") unless defined(&SF_NO_PRINT);
    eval("sub SF_QUIET_IR () { 0x04; }") unless defined(&SF_QUIET_IR);
    eval("sub SF_PRINT_ALWAYS () { 0x08; }") unless defined(&SF_PRINT_ALWAYS);
    eval("sub SF_NO_RECOVERY () { 0x10; }") unless defined(&SF_NO_RECOVERY);
    eval("sub SF_NO_RETRY () { 0x20; }") unless defined(&SF_NO_RETRY);
    eval("sub SF_RETRY_BUSY () { 0x40; }") unless defined(&SF_RETRY_BUSY);
    eval("sub CAM_REQ_INPROG () { 0x00; }") unless defined(&CAM_REQ_INPROG);
    eval("sub CAM_REQ_CMP () { 0x01; }") unless defined(&CAM_REQ_CMP);
    eval("sub CAM_REQ_ABORTED () { 0x02; }") unless defined(&CAM_REQ_ABORTED);
    eval("sub CAM_UA_ABORT () { 0x03; }") unless defined(&CAM_UA_ABORT);
    eval("sub CAM_REQ_CMP_ERR () { 0x04; }") unless defined(&CAM_REQ_CMP_ERR);
    eval("sub CAM_BUSY () { 0x05; }") unless defined(&CAM_BUSY);
    eval("sub CAM_REQ_INVALID () { 0x06; }") unless defined(&CAM_REQ_INVALID);
    eval("sub CAM_PATH_INVALID () { 0x07; }") unless defined(&CAM_PATH_INVALID);
    eval("sub CAM_DEV_NOT_THERE () { 0x08; }") unless defined(&CAM_DEV_NOT_THERE);
    eval("sub CAM_UA_TERMIO () { 0x09; }") unless defined(&CAM_UA_TERMIO);
    eval("sub CAM_SEL_TIMEOUT () { 0x0a; }") unless defined(&CAM_SEL_TIMEOUT);
    eval("sub CAM_CMD_TIMEOUT () { 0x0b; }") unless defined(&CAM_CMD_TIMEOUT);
    eval("sub CAM_SCSI_STATUS_ERROR () { 0x0c; }") unless defined(&CAM_SCSI_STATUS_ERROR);
    eval("sub CAM_MSG_REJECT_REC () { 0x0d; }") unless defined(&CAM_MSG_REJECT_REC);
    eval("sub CAM_SCSI_BUS_RESET () { 0x0e; }") unless defined(&CAM_SCSI_BUS_RESET);
    eval("sub CAM_UNCOR_PARITY () { 0x0f; }") unless defined(&CAM_UNCOR_PARITY);
    eval("sub CAM_AUTOSENSE_FAIL () { 0x10; }") unless defined(&CAM_AUTOSENSE_FAIL);
    eval("sub CAM_NO_HBA () { 0x11; }") unless defined(&CAM_NO_HBA);
    eval("sub CAM_DATA_RUN_ERR () { 0x12; }") unless defined(&CAM_DATA_RUN_ERR);
    eval("sub CAM_UNEXP_BUSFREE () { 0x13; }") unless defined(&CAM_UNEXP_BUSFREE);
    eval("sub CAM_SEQUENCE_FAIL () { 0x14; }") unless defined(&CAM_SEQUENCE_FAIL);
    eval("sub CAM_CCB_LEN_ERR () { 0x15; }") unless defined(&CAM_CCB_LEN_ERR);
    eval("sub CAM_PROVIDE_FAIL () { 0x16; }") unless defined(&CAM_PROVIDE_FAIL);
    eval("sub CAM_BDR_SENT () { 0x17; }") unless defined(&CAM_BDR_SENT);
    eval("sub CAM_REQ_TERMIO () { 0x18; }") unless defined(&CAM_REQ_TERMIO);
    eval("sub CAM_UNREC_HBA_ERROR () { 0x19; }") unless defined(&CAM_UNREC_HBA_ERROR);
    eval("sub CAM_REQ_TOO_BIG () { 0x1a; }") unless defined(&CAM_REQ_TOO_BIG);
    eval("sub CAM_REQUEUE_REQ () { 0x1b; }") unless defined(&CAM_REQUEUE_REQ);
    eval("sub CAM_ATA_STATUS_ERROR () { 0x1c; }") unless defined(&CAM_ATA_STATUS_ERROR);
    eval("sub CAM_SCSI_IT_NEXUS_LOST () { 0x1d; }") unless defined(&CAM_SCSI_IT_NEXUS_LOST);
    eval("sub CAM_SMP_STATUS_ERROR () { 0x1e; }") unless defined(&CAM_SMP_STATUS_ERROR);
    eval("sub CAM_REQ_SOFTTIMEOUT () { 0x1f; }") unless defined(&CAM_REQ_SOFTTIMEOUT);
    eval("sub CAM_IDE () { 0x33; }") unless defined(&CAM_IDE);
    eval("sub CAM_RESRC_UNAVAIL () { 0x34; }") unless defined(&CAM_RESRC_UNAVAIL);
    eval("sub CAM_UNACKED_EVENT () { 0x35; }") unless defined(&CAM_UNACKED_EVENT);
    eval("sub CAM_MESSAGE_RECV () { 0x36; }") unless defined(&CAM_MESSAGE_RECV);
    eval("sub CAM_INVALID_CDB () { 0x37; }") unless defined(&CAM_INVALID_CDB);
    eval("sub CAM_LUN_INVALID () { 0x38; }") unless defined(&CAM_LUN_INVALID);
    eval("sub CAM_TID_INVALID () { 0x39; }") unless defined(&CAM_TID_INVALID);
    eval("sub CAM_FUNC_NOTAVAIL () { 0x3a; }") unless defined(&CAM_FUNC_NOTAVAIL);
    eval("sub CAM_NO_NEXUS () { 0x3b; }") unless defined(&CAM_NO_NEXUS);
    eval("sub CAM_IID_INVALID () { 0x3c; }") unless defined(&CAM_IID_INVALID);
    eval("sub CAM_CDB_RECVD () { 0x3d; }") unless defined(&CAM_CDB_RECVD);
    eval("sub CAM_LUN_ALRDY_ENA () { 0x3e; }") unless defined(&CAM_LUN_ALRDY_ENA);
    eval("sub CAM_SCSI_BUSY () { 0x3f; }") unless defined(&CAM_SCSI_BUSY);
    eval("sub CAM_DEV_QFRZN () { 0x40; }") unless defined(&CAM_DEV_QFRZN);
    eval("sub CAM_AUTOSNS_VALID () { 0x80; }") unless defined(&CAM_AUTOSNS_VALID);
    eval("sub CAM_RELEASE_SIMQ () { 0x100; }") unless defined(&CAM_RELEASE_SIMQ);
    eval("sub CAM_SIM_QUEUED () { 0x200; }") unless defined(&CAM_SIM_QUEUED);
    eval("sub CAM_QOS_VALID () { 0x400; }") unless defined(&CAM_QOS_VALID);
    eval("sub CAM_STATUS_MASK () { 0x3F; }") unless defined(&CAM_STATUS_MASK);
    eval("sub CAM_SENT_SENSE () { 0x40000000; }") unless defined(&CAM_SENT_SENSE);
    eval("sub CAM_ESF_NONE () { 0x00; }") unless defined(&CAM_ESF_NONE);
    eval("sub CAM_ESF_COMMAND () { 0x01; }") unless defined(&CAM_ESF_COMMAND);
    eval("sub CAM_ESF_CAM_STATUS () { 0x02; }") unless defined(&CAM_ESF_CAM_STATUS);
    eval("sub CAM_ESF_PROTO_STATUS () { 0x04; }") unless defined(&CAM_ESF_PROTO_STATUS);
    eval("sub CAM_ESF_ALL () { 0xff; }") unless defined(&CAM_ESF_ALL);
    eval("sub CAM_EPF_NONE () { 0x00; }") unless defined(&CAM_EPF_NONE);
    eval("sub CAM_EPF_MINIMAL () { 0x01; }") unless defined(&CAM_EPF_MINIMAL);
    eval("sub CAM_EPF_NORMAL () { 0x02; }") unless defined(&CAM_EPF_NORMAL);
    eval("sub CAM_EPF_ALL () { 0x03; }") unless defined(&CAM_EPF_ALL);
    eval("sub CAM_EPF_LEVEL_MASK () { 0x0f; }") unless defined(&CAM_EPF_LEVEL_MASK);
    eval("sub CAM_ESF_PRINT_NONE () { 0x00; }") unless defined(&CAM_ESF_PRINT_NONE);
    eval("sub CAM_ESF_PRINT_STATUS () { 0x10; }") unless defined(&CAM_ESF_PRINT_STATUS);
    eval("sub CAM_ESF_PRINT_SENSE () { 0x20; }") unless defined(&CAM_ESF_PRINT_SENSE);
    eval("sub CAM_ESMF_PRINT_NONE () { 0x00; }") unless defined(&CAM_ESMF_PRINT_NONE);
    eval("sub CAM_ESMF_PRINT_STATUS () { 0x10; }") unless defined(&CAM_ESMF_PRINT_STATUS);
    eval("sub CAM_ESMF_PRINT_FULL_CMD () { 0x20; }") unless defined(&CAM_ESMF_PRINT_FULL_CMD);
    eval("sub CAM_EAF_PRINT_NONE () { 0x00; }") unless defined(&CAM_EAF_PRINT_NONE);
    eval("sub CAM_EAF_PRINT_STATUS () { 0x10; }") unless defined(&CAM_EAF_PRINT_STATUS);
    eval("sub CAM_EAF_PRINT_RESULT () { 0x20; }") unless defined(&CAM_EAF_PRINT_RESULT);
    eval("sub CAM_STRVIS_FLAG_NONE () { 0x00; }") unless defined(&CAM_STRVIS_FLAG_NONE);
    eval("sub CAM_STRVIS_FLAG_NONASCII_MASK () { 0x03; }") unless defined(&CAM_STRVIS_FLAG_NONASCII_MASK);
    eval("sub CAM_STRVIS_FLAG_NONASCII_TRIM () { 0x00; }") unless defined(&CAM_STRVIS_FLAG_NONASCII_TRIM);
    eval("sub CAM_STRVIS_FLAG_NONASCII_RAW () { 0x01; }") unless defined(&CAM_STRVIS_FLAG_NONASCII_RAW);
    eval("sub CAM_STRVIS_FLAG_NONASCII_SPC () { 0x02; }") unless defined(&CAM_STRVIS_FLAG_NONASCII_SPC);
    eval("sub CAM_STRVIS_FLAG_NONASCII_ESC () { 0x03; }") unless defined(&CAM_STRVIS_FLAG_NONASCII_ESC);
    if(defined(&_KERNEL)) {
    }
    if(defined(&SYSCTL_DECL)) {
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    if(defined(&_KERNEL)) {
	eval 'sub cam_init_pinfo {
	    my($pinfo) = @_;
    	    eval q({  ($pinfo->{priority}) =  &CAM_PRIORITY_NONE;  ($pinfo->{index}) =  &CAM_UNQUEUED_INDEX; });
	}' unless defined(&cam_init_pinfo);
    }
}
1;
