require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CAM_CAM_COMPAT_H)) {
    eval 'sub _CAM_CAM_COMPAT_H () {1;}' unless defined(&_CAM_CAM_COMPAT_H);
    if(defined(&_KERNEL)) {
	eval 'sub CAM_VERSION_0x16 () {0x16;}' unless defined(&CAM_VERSION_0x16);
	eval 'sub CAMIOCOMMAND_0x16 () { &_IOC( &IOC_INOUT,  &CAM_VERSION_0x16, 2,  &CAM_0X17_LEN);}' unless defined(&CAMIOCOMMAND_0x16);
	eval 'sub CAMGETPASSTHRU_0x16 () { &_IOC( &IOC_INOUT,  &CAM_VERSION_0x16, 3,  &CAM_0X17_LEN);}' unless defined(&CAMGETPASSTHRU_0x16);
	eval 'sub CAM_SCATTER_VALID_0x16 () {0x10;}' unless defined(&CAM_SCATTER_VALID_0x16);
	eval 'sub CAM_SG_LIST_PHYS_0x16 () {0x40000;}' unless defined(&CAM_SG_LIST_PHYS_0x16);
	eval 'sub CAM_DATA_PHYS_0x16 () {0x200000;}' unless defined(&CAM_DATA_PHYS_0x16);
	eval 'sub CAM_VERSION_0x17 () {0x17;}' unless defined(&CAM_VERSION_0x17);
	eval 'sub CAM_0X17_DATA_LEN () { &CAM_0X18_DATA_LEN;}' unless defined(&CAM_0X17_DATA_LEN);
	eval 'sub CAM_0X17_LEN () {($sizeof{\'struct ccb_hdr_0x17\'} +  &CAM_0X17_DATA_LEN);}' unless defined(&CAM_0X17_LEN);
	eval 'sub CAMIOCOMMAND_0x17 () { &_IOC( &IOC_INOUT,  &CAM_VERSION_0x17, 2,  &CAM_0X17_LEN);}' unless defined(&CAMIOCOMMAND_0x17);
	eval 'sub CAMGETPASSTHRU_0x17 () { &_IOC( &IOC_INOUT,  &CAM_VERSION_0x17, 3,  &CAM_0X17_LEN);}' unless defined(&CAMGETPASSTHRU_0x17);
	eval 'sub CAM_VERSION_0x18 () {0x18;}' unless defined(&CAM_VERSION_0x18);
	eval("sub CAM_EXTLUN_VALID_0x18 () { 0x00000001; }") unless defined(&CAM_EXTLUN_VALID_0x18);
	eval 'sub CAM_0X18_DATA_LEN () {($sizeof{\'union ccb\'} - 2*$sizeof{ &void } - $sizeof{\'struct ccb_hdr\'});}' unless defined(&CAM_0X18_DATA_LEN);
	eval 'sub CAM_0X18_LEN () {($sizeof{\'struct ccb_hdr_0x18\'} +  &CAM_0X18_DATA_LEN);}' unless defined(&CAM_0X18_LEN);
	eval 'sub CAMIOCOMMAND_0x18 () { &_IOC( &IOC_INOUT,  &CAM_VERSION_0x18, 2,  &CAM_0X18_LEN);}' unless defined(&CAMIOCOMMAND_0x18);
	eval 'sub CAMGETPASSTHRU_0x18 () { &_IOC( &IOC_INOUT,  &CAM_VERSION_0x18, 3,  &CAM_0X18_LEN);}' unless defined(&CAMGETPASSTHRU_0x18);
    }
}
1;
