require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CAM_CAM_DEBUG_H)) {
    eval 'sub _CAM_CAM_DEBUG_H () {1;}' unless defined(&_CAM_CAM_DEBUG_H);
    eval("sub CAM_DEBUG_NONE () { 0x00; }") unless defined(&CAM_DEBUG_NONE);
    eval("sub CAM_DEBUG_INFO () { 0x01; }") unless defined(&CAM_DEBUG_INFO);
    eval("sub CAM_DEBUG_TRACE () { 0x02; }") unless defined(&CAM_DEBUG_TRACE);
    eval("sub CAM_DEBUG_SUBTRACE () { 0x04; }") unless defined(&CAM_DEBUG_SUBTRACE);
    eval("sub CAM_DEBUG_CDB () { 0x08; }") unless defined(&CAM_DEBUG_CDB);
    eval("sub CAM_DEBUG_XPT () { 0x10; }") unless defined(&CAM_DEBUG_XPT);
    eval("sub CAM_DEBUG_PERIPH () { 0x20; }") unless defined(&CAM_DEBUG_PERIPH);
    eval("sub CAM_DEBUG_PROBE () { 0x40; }") unless defined(&CAM_DEBUG_PROBE);
    if(defined(&_KERNEL)) {
	unless(defined(&CAM_DEBUG_FLAGS)) {
	    eval 'sub CAM_DEBUG_FLAGS () { &CAM_DEBUG_NONE;}' unless defined(&CAM_DEBUG_FLAGS);
	}
	unless(defined(&CAM_DEBUG_COMPILE)) {
	    if(defined(&CAMDEBUG)) {
		eval 'sub CAM_DEBUG_COMPILE () {(-1);}' unless defined(&CAM_DEBUG_COMPILE);
	    } else {
		eval 'sub CAM_DEBUG_COMPILE () {( &CAM_DEBUG_INFO |  &CAM_DEBUG_CDB |  &CAM_DEBUG_PERIPH |  &CAM_DEBUG_PROBE |  &CAM_DEBUG_FLAGS);}' unless defined(&CAM_DEBUG_COMPILE);
	    }
	}
	unless(defined(&CAM_DEBUG_BUS)) {
	    eval 'sub CAM_DEBUG_BUS () { &CAM_BUS_WILDCARD;}' unless defined(&CAM_DEBUG_BUS);
	}
	unless(defined(&CAM_DEBUG_TARGET)) {
	    eval 'sub CAM_DEBUG_TARGET () { &CAM_TARGET_WILDCARD;}' unless defined(&CAM_DEBUG_TARGET);
	}
	unless(defined(&CAM_DEBUG_LUN)) {
	    eval 'sub CAM_DEBUG_LUN () { &CAM_LUN_WILDCARD;}' unless defined(&CAM_DEBUG_LUN);
	}
	unless(defined(&CAM_DEBUG_DELAY)) {
	    eval 'sub CAM_DEBUG_DELAY () {0;}' unless defined(&CAM_DEBUG_DELAY);
	}
	eval 'sub CAM_DEBUGGED {
	    my($path, $flag) = @_;
    	    eval q(((($flag) & ( &CAM_DEBUG_COMPILE) &  &cam_dflags)  && ( &cam_dpath !=  &NULL)  && ( &xpt_path_comp( &cam_dpath, $path) >= 0)  && ( &xpt_path_comp( &cam_dpath, $path) < 2)));
	}' unless defined(&CAM_DEBUGGED);
	eval 'sub CAM_DEBUG {
	    my($path, $flag, $printfargs) = @_;
    	    eval q( &if ((($flag) & ( &CAM_DEBUG_COMPILE) &  &cam_dflags)  && ( &cam_dpath !=  &NULL)  && ( &xpt_path_comp( &cam_dpath, $path) >= 0)  && ( &xpt_path_comp( &cam_dpath, $path) < 2)) {  &xpt_print_path($path);  &printf $printfargs;  &if ( &cam_debug_delay != 0)  &DELAY( &cam_debug_delay); });
	}' unless defined(&CAM_DEBUG);
	eval 'sub CAM_DEBUG_DEV {
	    my($dev, $flag, $printfargs) = @_;
    	    eval q( &if ((($flag) & ( &CAM_DEBUG_COMPILE) &  &cam_dflags)  && ( &cam_dpath !=  &NULL)  && ( &xpt_path_comp_dev( &cam_dpath, $dev) >= 0)  && ( &xpt_path_comp_dev( &cam_dpath, $dev) < 2)) {  &xpt_print_device($dev);  &printf $printfargs;  &if ( &cam_debug_delay != 0)  &DELAY( &cam_debug_delay); });
	}' unless defined(&CAM_DEBUG_DEV);
	eval 'sub CAM_DEBUG_PRINT {
	    my($flag, $printfargs) = @_;
    	    eval q( &if ((($flag) & ( &CAM_DEBUG_COMPILE) &  &cam_dflags)) {  &printf(\\"cam_debug: \\");  &printf $printfargs;  &if ( &cam_debug_delay != 0)  &DELAY( &cam_debug_delay); });
	}' unless defined(&CAM_DEBUG_PRINT);
	eval 'sub CAM_DEBUG_PATH_PRINT {
	    my($flag, $path, $printfargs) = @_;
    	    eval q( &if ((($flag) & ( &CAM_DEBUG_COMPILE) &  &cam_dflags)) {  &xpt_print($path, \\"cam_debug: \\");  &printf $printfargs;  &if ( &cam_debug_delay != 0)  &DELAY( &cam_debug_delay); });
	}' unless defined(&CAM_DEBUG_PATH_PRINT);
    } else {
	eval 'sub CAM_DEBUGGED {
	    my($A, $B) = @_;
    	    eval q(0);
	}' unless defined(&CAM_DEBUGGED);
	eval 'sub CAM_DEBUG {
	    my($A, $B, $C) = @_;
    	    eval q();
	}' unless defined(&CAM_DEBUG);
	eval 'sub CAM_DEBUG_PRINT {
	    my($A, $B) = @_;
    	    eval q();
	}' unless defined(&CAM_DEBUG_PRINT);
	eval 'sub CAM_DEBUG_PATH_PRINT {
	    my($A, $B, $C) = @_;
    	    eval q();
	}' unless defined(&CAM_DEBUG_PATH_PRINT);
    }
}
1;
