require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CAM_CAM_SIM_H)) {
    eval 'sub _CAM_CAM_SIM_H () {1;}' unless defined(&_CAM_CAM_SIM_H);
    if(defined(&_KERNEL)) {
	eval 'sub spriv_ptr0 () { ($sim_priv->{entries[0]}->{ptr});}' unless defined(&spriv_ptr0);
	eval 'sub spriv_ptr1 () { ($sim_priv->{entries[1]}->{ptr});}' unless defined(&spriv_ptr1);
	eval 'sub spriv_field0 () { ($sim_priv->{entries[0]}->{field});}' unless defined(&spriv_field0);
	eval 'sub spriv_field1 () { ($sim_priv->{entries[1]}->{field});}' unless defined(&spriv_field1);
	eval 'sub CAM_SIM_REL_TIMEOUT_PENDING () {0x1;}' unless defined(&CAM_SIM_REL_TIMEOUT_PENDING);
	eval 'sub CAM_SIM_MPSAFE () {0x2;}' unless defined(&CAM_SIM_MPSAFE);
	eval 'sub CAM_SIM_LOCK {
	    my($sim) = @_;
    	    eval q( &mtx_lock(($sim)-> &mtx));
	}' unless defined(&CAM_SIM_LOCK);
	eval 'sub CAM_SIM_UNLOCK {
	    my($sim) = @_;
    	    eval q( &mtx_unlock(($sim)-> &mtx));
	}' unless defined(&CAM_SIM_UNLOCK);
	eval 'sub cam_sim_path {
	    my($sim) = @_;
    	    eval q({ ( ($sim->{path_id})); });
	}' unless defined(&cam_sim_path);
	eval 'sub cam_sim_name {
	    my($sim) = @_;
    	    eval q({ ( ($sim->{sim_name})); });
	}' unless defined(&cam_sim_name);
	eval 'sub cam_sim_softc {
	    my($sim) = @_;
    	    eval q({ ( ($sim->{softc})); });
	}' unless defined(&cam_sim_softc);
	eval 'sub cam_sim_unit {
	    my($sim) = @_;
    	    eval q({ ( ($sim->{unit_number})); });
	}' unless defined(&cam_sim_unit);
	eval 'sub cam_sim_bus {
	    my($sim) = @_;
    	    eval q({ ( ($sim->{bus_id})); });
	}' unless defined(&cam_sim_bus);
    }
}
1;
