require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SCSI_SCSI_CD_H)) {
    eval 'sub _SCSI_SCSI_CD_H () {1;}' unless defined(&_SCSI_SCSI_CD_H);
    eval 'sub CD_RELADDR () {0x1;}' unless defined(&CD_RELADDR);
    eval 'sub CD_MSF () {0x2;}' unless defined(&CD_MSF);
    eval 'sub SGC_RT_ALL () {0x;}' unless defined(&SGC_RT_ALL);
    eval 'sub SGC_RT_CURRENT () {0x1;}' unless defined(&SGC_RT_CURRENT);
    eval 'sub SGC_RT_SPECIFIC () {0x2;}' unless defined(&SGC_RT_SPECIFIC);
    eval 'sub SGC_RT_MASK () {0x3;}' unless defined(&SGC_RT_MASK);
    eval 'sub SGC_F_CURRENT () {0x1;}' unless defined(&SGC_F_CURRENT);
    eval 'sub SGC_F_PERSISTENT () {0x2;}' unless defined(&SGC_F_PERSISTENT);
    eval 'sub SGC_F_VERSION_MASK () {0x2c;}' unless defined(&SGC_F_VERSION_MASK);
    eval 'sub SGC_F_VERSION_SHIFT () {2;}' unless defined(&SGC_F_VERSION_SHIFT);
    eval 'sub SGESN_POLLED () {1;}' unless defined(&SGESN_POLLED);
    eval 'sub SGESN_NEA () {0x80;}' unless defined(&SGESN_NEA);
    eval 'sub PA_PAUSE () {1;}' unless defined(&PA_PAUSE);
    eval 'sub PA_RESUME () {0;}' unless defined(&PA_RESUME);
    eval 'sub SRS_SUBQ () {0x40;}' unless defined(&SRS_SUBQ);
    eval 'sub RK_KF_AGID_MASK () {0xc0;}' unless defined(&RK_KF_AGID_MASK);
    eval 'sub RK_KF_AGID_SHIFT () {6;}' unless defined(&RK_KF_AGID_SHIFT);
    eval 'sub RK_KF_KEYFORMAT_MASK () {0x3f;}' unless defined(&RK_KF_KEYFORMAT_MASK);
    eval 'sub RK_KF_AGID () {0x;}' unless defined(&RK_KF_AGID);
    eval 'sub RK_KF_CHALLENGE () {0x1;}' unless defined(&RK_KF_CHALLENGE);
    eval 'sub RF_KF_KEY1 () {0x2;}' unless defined(&RF_KF_KEY1);
    eval 'sub RK_KF_KEY2 () {0x3;}' unless defined(&RK_KF_KEY2);
    eval 'sub RF_KF_TITLE () {0x4;}' unless defined(&RF_KF_TITLE);
    eval 'sub RF_KF_ASF () {0x5;}' unless defined(&RF_KF_ASF);
    eval 'sub RK_KF_RPC_SET () {0x6;}' unless defined(&RK_KF_RPC_SET);
    eval 'sub RF_KF_RPC_REPORT () {0x8;}' unless defined(&RF_KF_RPC_REPORT);
    eval 'sub RF_KF_INV_AGID () {0x3f;}' unless defined(&RF_KF_INV_AGID);
    eval 'sub RDS_FORMAT_PHYSICAL () {0x;}' unless defined(&RDS_FORMAT_PHYSICAL);
    eval 'sub RDS_FORMAT_COPYRIGHT () {0x1;}' unless defined(&RDS_FORMAT_COPYRIGHT);
    eval 'sub RDS_FORMAT_DISC_KEY () {0x2;}' unless defined(&RDS_FORMAT_DISC_KEY);
    eval 'sub RDS_FORMAT_BCA () {0x3;}' unless defined(&RDS_FORMAT_BCA);
    eval 'sub RDS_FORMAT_MANUFACTURER () {0x4;}' unless defined(&RDS_FORMAT_MANUFACTURER);
    eval 'sub RDS_FORMAT_CMGS_CPM () {0x5;}' unless defined(&RDS_FORMAT_CMGS_CPM);
    eval 'sub RDS_FORMAT_PROT_DISCID () {0x6;}' unless defined(&RDS_FORMAT_PROT_DISCID);
    eval 'sub RDS_FORMAT_DISC_KEY_BLOCK () {0x7;}' unless defined(&RDS_FORMAT_DISC_KEY_BLOCK);
    eval 'sub RDS_FORMAT_DDS () {0x8;}' unless defined(&RDS_FORMAT_DDS);
    eval 'sub RDS_FORMAT_DVDRAM_MEDIA_STAT () {0x9;}' unless defined(&RDS_FORMAT_DVDRAM_MEDIA_STAT);
    eval 'sub RDS_FORMAT_SPARE_AREA () {0xa;}' unless defined(&RDS_FORMAT_SPARE_AREA);
    eval 'sub RDS_FORMAT_RMD_BORDEROUT () {0xc;}' unless defined(&RDS_FORMAT_RMD_BORDEROUT);
    eval 'sub RDS_FORMAT_RMD () {0xd;}' unless defined(&RDS_FORMAT_RMD);
    eval 'sub RDS_FORMAT_LEADIN () {0xe;}' unless defined(&RDS_FORMAT_LEADIN);
    eval 'sub RDS_FORMAT_DISC_ID () {0xf;}' unless defined(&RDS_FORMAT_DISC_ID);
    eval 'sub RDS_FORMAT_DCB () {0x30;}' unless defined(&RDS_FORMAT_DCB);
    eval 'sub RDS_FORMAT_WRITE_PROT () {0xc0;}' unless defined(&RDS_FORMAT_WRITE_PROT);
    eval 'sub RDS_FORMAT_STRUCTURE_LIST () {0xff;}' unless defined(&RDS_FORMAT_STRUCTURE_LIST);
    eval 'sub READ_CD_CAPACITY () {0x25;}' unless defined(&READ_CD_CAPACITY);
    eval 'sub READ_SUBCHANNEL () {0x42;}' unless defined(&READ_SUBCHANNEL);
    eval 'sub READ_TOC () {0x43;}' unless defined(&READ_TOC);
    eval 'sub READ_HEADER () {0x44;}' unless defined(&READ_HEADER);
    eval 'sub PLAY_10 () {0x45;}' unless defined(&PLAY_10);
    eval 'sub GET_CONFIGURATION () {0x46;}' unless defined(&GET_CONFIGURATION);
    eval 'sub PLAY_MSF () {0x47;}' unless defined(&PLAY_MSF);
    eval 'sub PLAY_TRACK () {0x48;}' unless defined(&PLAY_TRACK);
    eval 'sub PLAY_TRACK_REL () {0x49;}' unless defined(&PLAY_TRACK_REL);
    eval 'sub GET_EVENT_STATUS () {0x4a;}' unless defined(&GET_EVENT_STATUS);
    eval 'sub PAUSE () {0x4b;}' unless defined(&PAUSE);
    eval 'sub SEND_KEY () {0xa3;}' unless defined(&SEND_KEY);
    eval 'sub REPORT_KEY () {0xa4;}' unless defined(&REPORT_KEY);
    eval 'sub PLAY_12 () {0xa5;}' unless defined(&PLAY_12);
    eval 'sub PLAY_TRACK_REL_BIG () {0xa9;}' unless defined(&PLAY_TRACK_REL_BIG);
    eval 'sub READ_DVD_STRUCTURE () {0xad;}' unless defined(&READ_DVD_STRUCTURE);
    eval 'sub SET_CD_SPEED () {0xbb;}' unless defined(&SET_CD_SPEED);
    eval 'sub MECHANISM_STATUS () {0xbd;}' unless defined(&MECHANISM_STATUS);
    eval 'sub RKD_AGID_MASK () {0xc0;}' unless defined(&RKD_AGID_MASK);
    eval 'sub RKD_AGID_SHIFT () {6;}' unless defined(&RKD_AGID_SHIFT);
    eval 'sub RKD_TITLE_CPM () {0x80;}' unless defined(&RKD_TITLE_CPM);
    eval 'sub RKD_TITLE_CPM_SHIFT () {7;}' unless defined(&RKD_TITLE_CPM_SHIFT);
    eval 'sub RKD_TITLE_CP_SEC () {0x40;}' unless defined(&RKD_TITLE_CP_SEC);
    eval 'sub RKD_TITLE_CP_SEC_SHIFT () {6;}' unless defined(&RKD_TITLE_CP_SEC_SHIFT);
    eval 'sub RKD_TITLE_CMGS_MASK () {0x30;}' unless defined(&RKD_TITLE_CMGS_MASK);
    eval 'sub RKD_TITLE_CMGS_SHIFT () {4;}' unless defined(&RKD_TITLE_CMGS_SHIFT);
    eval 'sub RKD_TITLE_CMGS_NO_RST () {0x;}' unless defined(&RKD_TITLE_CMGS_NO_RST);
    eval 'sub RKD_TITLE_CMGS_RSVD () {0x10;}' unless defined(&RKD_TITLE_CMGS_RSVD);
    eval 'sub RKD_TITLE_CMGS_1_GEN () {0x20;}' unless defined(&RKD_TITLE_CMGS_1_GEN);
    eval 'sub RKD_TITLE_CMGS_NO_COPY () {0x30;}' unless defined(&RKD_TITLE_CMGS_NO_COPY);
    eval 'sub RKD_ASF_SUCCESS () {0x1;}' unless defined(&RKD_ASF_SUCCESS);
    eval 'sub RKD_RPC_SCHEME_UNKNOWN () {0x;}' unless defined(&RKD_RPC_SCHEME_UNKNOWN);
    eval 'sub RKD_RPC_SCHEME_PHASE_II () {0x1;}' unless defined(&RKD_RPC_SCHEME_PHASE_II);
    eval 'sub RKD_RPC_TYPE_MASK () {0xc0;}' unless defined(&RKD_RPC_TYPE_MASK);
    eval 'sub RKD_RPC_TYPE_SHIFT () {6;}' unless defined(&RKD_RPC_TYPE_SHIFT);
    eval 'sub RKD_RPC_TYPE_NONE () {0x;}' unless defined(&RKD_RPC_TYPE_NONE);
    eval 'sub RKD_RPC_TYPE_SET () {0x40;}' unless defined(&RKD_RPC_TYPE_SET);
    eval 'sub RKD_RPC_TYPE_LAST_CHANCE () {0x80;}' unless defined(&RKD_RPC_TYPE_LAST_CHANCE);
    eval 'sub RKD_RPC_TYPE_PERM () {0xc0;}' unless defined(&RKD_RPC_TYPE_PERM);
    eval 'sub RKD_RPC_VENDOR_RESET_MASK () {0x38;}' unless defined(&RKD_RPC_VENDOR_RESET_MASK);
    eval 'sub RKD_RPC_VENDOR_RESET_SHIFT () {3;}' unless defined(&RKD_RPC_VENDOR_RESET_SHIFT);
    eval 'sub RKD_RPC_USER_RESET_MASK () {0x7;}' unless defined(&RKD_RPC_USER_RESET_MASK);
    eval 'sub RKD_RPC_USER_RESET_SHIFT () {0;}' unless defined(&RKD_RPC_USER_RESET_SHIFT);
    eval 'sub RDSD_BOOK_TYPE_DVD_ROM () {0x;}' unless defined(&RDSD_BOOK_TYPE_DVD_ROM);
    eval 'sub RDSD_BOOK_TYPE_DVD_RAM () {0x10;}' unless defined(&RDSD_BOOK_TYPE_DVD_RAM);
    eval 'sub RDSD_BOOK_TYPE_DVD_R () {0x20;}' unless defined(&RDSD_BOOK_TYPE_DVD_R);
    eval 'sub RDSD_BOOK_TYPE_DVD_RW () {0x30;}' unless defined(&RDSD_BOOK_TYPE_DVD_RW);
    eval 'sub RDSD_BOOK_TYPE_DVD_PRW () {0x90;}' unless defined(&RDSD_BOOK_TYPE_DVD_PRW);
    eval 'sub RDSD_BOOK_TYPE_MASK () {0xf0;}' unless defined(&RDSD_BOOK_TYPE_MASK);
    eval 'sub RDSD_BOOK_TYPE_SHIFT () {4;}' unless defined(&RDSD_BOOK_TYPE_SHIFT);
    eval 'sub RDSD_BOOK_VERSION_MASK () {0xf;}' unless defined(&RDSD_BOOK_VERSION_MASK);
    eval 'sub RDSD_DISC_SIZE_120MM () {0x;}' unless defined(&RDSD_DISC_SIZE_120MM);
    eval 'sub RDSD_DISC_SIZE_80MM () {0x10;}' unless defined(&RDSD_DISC_SIZE_80MM);
    eval 'sub RDSD_DISC_SIZE_MASK () {0xf0;}' unless defined(&RDSD_DISC_SIZE_MASK);
    eval 'sub RDSD_DISC_SIZE_SHIFT () {4;}' unless defined(&RDSD_DISC_SIZE_SHIFT);
    eval 'sub RDSD_MAX_RATE_0252 () {0x;}' unless defined(&RDSD_MAX_RATE_0252);
    eval 'sub RDSD_MAX_RATE_0504 () {0x1;}' unless defined(&RDSD_MAX_RATE_0504);
    eval 'sub RDSD_MAX_RATE_1008 () {0x2;}' unless defined(&RDSD_MAX_RATE_1008);
    eval 'sub RDSD_MAX_RATE_NOT_SPEC () {0xf;}' unless defined(&RDSD_MAX_RATE_NOT_SPEC);
    eval 'sub RDSD_MAX_RATE_MASK () {0xf;}' unless defined(&RDSD_MAX_RATE_MASK);
    eval 'sub RDSD_NUM_LAYERS_MASK () {0x60;}' unless defined(&RDSD_NUM_LAYERS_MASK);
    eval 'sub RDSD_NUM_LAYERS_SHIFT () {5;}' unless defined(&RDSD_NUM_LAYERS_SHIFT);
    eval 'sub RDSD_NL_ONE_LAYER () {0x;}' unless defined(&RDSD_NL_ONE_LAYER);
    eval 'sub RDSD_NL_TWO_LAYERS () {0x20;}' unless defined(&RDSD_NL_TWO_LAYERS);
    eval 'sub RDSD_TRACK_PATH_MASK () {0x10;}' unless defined(&RDSD_TRACK_PATH_MASK);
    eval 'sub RDSD_TRACK_PATH_SHIFT () {4;}' unless defined(&RDSD_TRACK_PATH_SHIFT);
    eval 'sub RDSD_TP_PTP () {0x;}' unless defined(&RDSD_TP_PTP);
    eval 'sub RDSD_TP_OTP () {0x10;}' unless defined(&RDSD_TP_OTP);
    eval 'sub RDSD_LAYER_TYPE_RO () {0x1;}' unless defined(&RDSD_LAYER_TYPE_RO);
    eval 'sub RDSD_LAYER_TYPE_RECORD () {0x2;}' unless defined(&RDSD_LAYER_TYPE_RECORD);
    eval 'sub RDSD_LAYER_TYPE_RW () {0x4;}' unless defined(&RDSD_LAYER_TYPE_RW);
    eval 'sub RDSD_LAYER_TYPE_MASK () {0xf;}' unless defined(&RDSD_LAYER_TYPE_MASK);
    eval 'sub RDSD_LIN_DENSITY_0267 () {0x;}' unless defined(&RDSD_LIN_DENSITY_0267);
    eval 'sub RDSD_LIN_DENSITY_0293 () {0x10;}' unless defined(&RDSD_LIN_DENSITY_0293);
    eval 'sub RDSD_LIN_DENSITY_0409_0435 () {0x20;}' unless defined(&RDSD_LIN_DENSITY_0409_0435);
    eval 'sub RDSD_LIN_DENSITY_0280_0291 () {0x40;}' unless defined(&RDSD_LIN_DENSITY_0280_0291);
    eval 'sub RDSD_LIN_DENSITY_0353 () {0x80;}' unless defined(&RDSD_LIN_DENSITY_0353);
    eval 'sub RDSD_LIN_DENSITY_MASK () {0xf0;}' unless defined(&RDSD_LIN_DENSITY_MASK);
    eval 'sub RDSD_LIN_DENSITY_SHIFT () {4;}' unless defined(&RDSD_LIN_DENSITY_SHIFT);
    eval 'sub RDSD_TRACK_DENSITY_074 () {0x;}' unless defined(&RDSD_TRACK_DENSITY_074);
    eval 'sub RDSD_TRACK_DENSITY_080 () {0x1;}' unless defined(&RDSD_TRACK_DENSITY_080);
    eval 'sub RDSD_TRACK_DENSITY_0615 () {0x2;}' unless defined(&RDSD_TRACK_DENSITY_0615);
    eval 'sub RDSD_TRACK_DENSITY_MASK () {0xf;}' unless defined(&RDSD_TRACK_DENSITY_MASK);
    eval 'sub RDSD_MAIN_DATA_START_DVD_RO () {0x30000;}' unless defined(&RDSD_MAIN_DATA_START_DVD_RO);
    eval 'sub RDSD_MAIN_DATA_START_DVD_RW () {0x31000;}' unless defined(&RDSD_MAIN_DATA_START_DVD_RW);
    eval 'sub RDSD_BCA () {0x80;}' unless defined(&RDSD_BCA);
    eval 'sub RDSD_BCA_MASK () {0x80;}' unless defined(&RDSD_BCA_MASK);
    eval 'sub RDSD_BCA_SHIFT () {7;}' unless defined(&RDSD_BCA_SHIFT);
    eval 'sub RDSD_CPS_NOT_PRESENT () {0x;}' unless defined(&RDSD_CPS_NOT_PRESENT);
    eval 'sub RDSD_CPS_DATA_EXISTS () {0x1;}' unless defined(&RDSD_CPS_DATA_EXISTS);
    eval 'sub RDSD_CPM_NO_COPYRIGHT () {0x;}' unless defined(&RDSD_CPM_NO_COPYRIGHT);
    eval 'sub RDSD_CPM_HAS_COPYRIGHT () {0x80;}' unless defined(&RDSD_CPM_HAS_COPYRIGHT);
    eval 'sub RDSD_CPM_MASK () {0x80;}' unless defined(&RDSD_CPM_MASK);
    eval 'sub RDSD_CMGS_COPY_ALLOWED () {0x;}' unless defined(&RDSD_CMGS_COPY_ALLOWED);
    eval 'sub RDSD_CMGS_ONE_COPY () {0x20;}' unless defined(&RDSD_CMGS_ONE_COPY);
    eval 'sub RDSD_CMGS_NO_COPIES () {0x30;}' unless defined(&RDSD_CMGS_NO_COPIES);
    eval 'sub RDSD_CMGS_MASK () {0x30;}' unless defined(&RDSD_CMGS_MASK);
    eval 'sub RDSD_MS_CARTRIDGE () {0x80;}' unless defined(&RDSD_MS_CARTRIDGE);
    eval 'sub RDSD_MS_OUT () {0x40;}' unless defined(&RDSD_MS_OUT);
    eval 'sub RDSD_MS_MSWI () {0x8;}' unless defined(&RDSD_MS_MSWI);
    eval 'sub RDSD_MS_CWP () {0x4;}' unless defined(&RDSD_MS_CWP);
    eval 'sub RDSD_MS_PWP () {0x2;}' unless defined(&RDSD_MS_PWP);
    eval 'sub RDSD_DT_NEED_CARTRIDGE () {0x;}' unless defined(&RDSD_DT_NEED_CARTRIDGE);
    eval 'sub RDSD_DT_NO_CART_NEEDED () {0x1;}' unless defined(&RDSD_DT_NO_CART_NEEDED);
    eval 'sub RDSD_SWI_NO_BARE () {0x1;}' unless defined(&RDSD_SWI_NO_BARE);
    eval 'sub RDSD_SWI_UNSPEC () {0xff;}' unless defined(&RDSD_SWI_UNSPEC);
    eval 'sub SCSI_RCB () {1;}' unless defined(&SCSI_RCB);
    eval 'sub RDSD_ACTION_RECORDING () {0x1;}' unless defined(&RDSD_ACTION_RECORDING);
    eval 'sub RDSD_ACTION_READING () {0x2;}' unless defined(&RDSD_ACTION_READING);
    eval 'sub RDSD_ACTION_FORMAT () {0x4;}' unless defined(&RDSD_ACTION_FORMAT);
    eval 'sub RDSD_ACTION_MODIFY_DCB () {0x8;}' unless defined(&RDSD_ACTION_MODIFY_DCB);
    eval 'sub RDSD_WPS_MSWI () {0x8;}' unless defined(&RDSD_WPS_MSWI);
    eval 'sub RDSD_WPS_CWP () {0x4;}' unless defined(&RDSD_WPS_CWP);
    eval 'sub RDSD_WPS_PWP () {0x2;}' unless defined(&RDSD_WPS_PWP);
    eval 'sub RDSD_WPS_SWPP () {0x1;}' unless defined(&RDSD_WPS_SWPP);
    eval 'sub RDSD_SDS_NOT_WRITEABLE () {0x;}' unless defined(&RDSD_SDS_NOT_WRITEABLE);
    eval 'sub RDSD_SDS_WRITEABLE () {0x80;}' unless defined(&RDSD_SDS_WRITEABLE);
    eval 'sub RDSD_SDS_MASK () {0x80;}' unless defined(&RDSD_SDS_MASK);
    eval 'sub RDSD_RDS_NOT_READABLE () {0x;}' unless defined(&RDSD_RDS_NOT_READABLE);
    eval 'sub RDSD_RDS_READABLE () {0x40;}' unless defined(&RDSD_RDS_READABLE);
    eval 'sub RDSD_RDS_MASK () {0x40;}' unless defined(&RDSD_RDS_MASK);
    eval 'sub CD_PAGE_CODE () {0x3f;}' unless defined(&CD_PAGE_CODE);
    eval 'sub AUDIO_PAGE () {0xe;}' unless defined(&AUDIO_PAGE);
    eval 'sub CD_PAGE_PS () {0x80;}' unless defined(&CD_PAGE_PS);
    eval 'sub CD_PA_SOTC () {0x2;}' unless defined(&CD_PA_SOTC);
    eval 'sub CD_PA_IMMED () {0x4;}' unless defined(&CD_PA_IMMED);
    eval 'sub CD_PA_FORMAT_LBA () {0xf;}' unless defined(&CD_PA_FORMAT_LBA);
    eval 'sub CD_PA_APR_VALID () {0x80;}' unless defined(&CD_PA_APR_VALID);
    eval 'sub CHANNEL () {0xf;}' unless defined(&CHANNEL);
    eval 'sub CHANNEL_0 () {1;}' unless defined(&CHANNEL_0);
    eval 'sub CHANNEL_1 () {2;}' unless defined(&CHANNEL_1);
    eval 'sub CHANNEL_2 () {4;}' unless defined(&CHANNEL_2);
    eval 'sub CHANNEL_3 () {8;}' unless defined(&CHANNEL_3);
    eval 'sub LEFT_CHANNEL () { &CHANNEL_0;}' unless defined(&LEFT_CHANNEL);
    eval 'sub RIGHT_CHANNEL () { &CHANNEL_1;}' unless defined(&RIGHT_CHANNEL);
    eval 'sub LEFT_PORT () {0;}' unless defined(&LEFT_PORT);
    eval 'sub RIGHT_PORT () {1;}' unless defined(&RIGHT_PORT);
    eval 'sub SMS_CDDVD_CAPS_PAGE () {0x2a;}' unless defined(&SMS_CDDVD_CAPS_PAGE);
}
1;
