require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SCSI_SCSI_CH_H)) {
    eval 'sub _SCSI_SCSI_CH_H () {1;}' unless defined(&_SCSI_SCSI_CH_H);
    require 'sys/cdefs.ph';
    eval 'sub EXCHANGE_MEDIUM () {0xa6;}' unless defined(&EXCHANGE_MEDIUM);
    eval 'sub EXCHANGE_MEDIUM_INV1 () {0x1;}' unless defined(&EXCHANGE_MEDIUM_INV1);
    eval 'sub EXCHANGE_MEDIUM_INV2 () {0x2;}' unless defined(&EXCHANGE_MEDIUM_INV2);
    eval 'sub INITIALIZE_ELEMENT_STATUS () {0x7;}' unless defined(&INITIALIZE_ELEMENT_STATUS);
    eval 'sub MOVE_MEDIUM_INVERT () {0x1;}' unless defined(&MOVE_MEDIUM_INVERT);
    eval 'sub POSITION_TO_ELEMENT_INVERT () {0x1;}' unless defined(&POSITION_TO_ELEMENT_INVERT);
    eval 'sub READ_ELEMENT_STATUS_VOLTAG () {0x10;}' unless defined(&READ_ELEMENT_STATUS_VOLTAG);
    eval 'sub READ_ELEMENT_STATUS_DVCID () {0x1;}' unless defined(&READ_ELEMENT_STATUS_DVCID);
    eval 'sub READ_ELEMENT_STATUS_CURDATA () {0x2;}' unless defined(&READ_ELEMENT_STATUS_CURDATA);
    eval 'sub REQUEST_VOLUME_ELEMENT_ADDRESS_VOLTAG () {0x10;}' unless defined(&REQUEST_VOLUME_ELEMENT_ADDRESS_VOLTAG);
    eval 'sub CH_ELEMENT_ADDR_ASSIGN_PAGE () {0x1d;}' unless defined(&CH_ELEMENT_ADDR_ASSIGN_PAGE);
    eval 'sub CH_TRANS_GEOM_PARAMS_PAGE () {0x1e;}' unless defined(&CH_TRANS_GEOM_PARAMS_PAGE);
    eval 'sub CH_DEVICE_CAP_PAGE () {0x1f;}' unless defined(&CH_DEVICE_CAP_PAGE);
    eval 'sub READ_ELEMENT_STATUS_AVOLTAG () {0x40;}' unless defined(&READ_ELEMENT_STATUS_AVOLTAG);
    eval 'sub READ_ELEMENT_STATUS_PVOLTAG () {0x80;}' unless defined(&READ_ELEMENT_STATUS_PVOLTAG);
    eval 'sub READ_ELEMENT_STATUS_CODE_SET {
        my($p) = @_;
	    eval q((($p) & 0xf));
    }' unless defined(&READ_ELEMENT_STATUS_CODE_SET);
    eval 'sub READ_ELEMENT_STATUS_PROTOCOL_ID {
        my($p) = @_;
	    eval q((($p) >> 4));
    }' unless defined(&READ_ELEMENT_STATUS_PROTOCOL_ID);
    eval 'sub READ_ELEMENT_STATUS_PIV_SET () {0x80;}' unless defined(&READ_ELEMENT_STATUS_PIV_SET);
    eval 'sub READ_ELEMENT_STATUS_ASSOCIATION {
        my($p) = @_;
	    eval q((($p) >> 4));
    }' unless defined(&READ_ELEMENT_STATUS_ASSOCIATION);
    eval 'sub READ_ELEMENT_STATUS_DESIGNATOR_TYPE {
        my($p) = @_;
	    eval q((($p) & 0xf));
    }' unless defined(&READ_ELEMENT_STATUS_DESIGNATOR_TYPE);
    eval 'sub READ_ELEMENT_STATUS_FULL () {0x1;}' unless defined(&READ_ELEMENT_STATUS_FULL);
    eval 'sub READ_ELEMENT_STATUS_IMPEXP () {0x2;}' unless defined(&READ_ELEMENT_STATUS_IMPEXP);
    eval 'sub READ_ELEMENT_STATUS_EXCEPT () {0x4;}' unless defined(&READ_ELEMENT_STATUS_EXCEPT);
    eval 'sub READ_ELEMENT_STATUS_ACCESS () {0x8;}' unless defined(&READ_ELEMENT_STATUS_ACCESS);
    eval 'sub READ_ELEMENT_STATUS_EXENAB () {0x10;}' unless defined(&READ_ELEMENT_STATUS_EXENAB);
    eval 'sub READ_ELEMENT_STATUS_INENAB () {0x20;}' unless defined(&READ_ELEMENT_STATUS_INENAB);
    eval 'sub READ_ELEMENT_STATUS_MT_MASK1 () {0x5;}' unless defined(&READ_ELEMENT_STATUS_MT_MASK1);
    eval 'sub READ_ELEMENT_STATUS_ST_MASK1 () {0xc;}' unless defined(&READ_ELEMENT_STATUS_ST_MASK1);
    eval 'sub READ_ELEMENT_STATUS_IE_MASK1 () {0x3f;}' unless defined(&READ_ELEMENT_STATUS_IE_MASK1);
    eval 'sub READ_ELEMENT_STATUS_DT_MASK1 () {0xc;}' unless defined(&READ_ELEMENT_STATUS_DT_MASK1);
    eval 'sub READ_ELEMENT_STATUS_DT_LUNMASK () {0x7;}' unless defined(&READ_ELEMENT_STATUS_DT_LUNMASK);
    eval 'sub READ_ELEMENT_STATUS_DT_LUVALID () {0x10;}' unless defined(&READ_ELEMENT_STATUS_DT_LUVALID);
    eval 'sub READ_ELEMENT_STATUS_DT_IDVALID () {0x20;}' unless defined(&READ_ELEMENT_STATUS_DT_IDVALID);
    eval 'sub READ_ELEMENT_STATUS_DT_NOTBUS () {0x80;}' unless defined(&READ_ELEMENT_STATUS_DT_NOTBUS);
    eval 'sub READ_ELEMENT_STATUS_INVERT () {0x40;}' unless defined(&READ_ELEMENT_STATUS_INVERT);
    eval 'sub READ_ELEMENT_STATUS_SVALID () {0x80;}' unless defined(&READ_ELEMENT_STATUS_SVALID);
    eval 'sub READ_ELEMENT_STATUS_ED () {0x80;}' unless defined(&READ_ELEMENT_STATUS_ED);
    eval 'sub READ_ELEMENT_STATUS_MEDIA_TYPE_MASK () {0x7;}' unless defined(&READ_ELEMENT_STATUS_MEDIA_TYPE_MASK);
    eval 'sub ELEMENT_TYPE_MASK () {0xf;}' unless defined(&ELEMENT_TYPE_MASK);
    eval 'sub ELEMENT_TYPE_ALL () {0x;}' unless defined(&ELEMENT_TYPE_ALL);
    eval 'sub ELEMENT_TYPE_MT () {0x1;}' unless defined(&ELEMENT_TYPE_MT);
    eval 'sub ELEMENT_TYPE_ST () {0x2;}' unless defined(&ELEMENT_TYPE_ST);
    eval 'sub ELEMENT_TYPE_IE () {0x3;}' unless defined(&ELEMENT_TYPE_IE);
    eval 'sub ELEMENT_TYPE_DT () {0x4;}' unless defined(&ELEMENT_TYPE_DT);
    eval 'sub PGCODE_MASK () {0x3f;}' unless defined(&PGCODE_MASK);
    eval 'sub PGCODE_PS () {0x80;}' unless defined(&PGCODE_PS);
    eval 'sub SEND_VOLUME_TAG () {0xb6;}' unless defined(&SEND_VOLUME_TAG);
    eval 'sub SEND_VOLUME_TAG_ASSERT_PRIMARY () {0x8;}' unless defined(&SEND_VOLUME_TAG_ASSERT_PRIMARY);
    eval 'sub SEND_VOLUME_TAG_ASSERT_ALTERNATE () {0x9;}' unless defined(&SEND_VOLUME_TAG_ASSERT_ALTERNATE);
    eval 'sub SEND_VOLUME_TAG_REPLACE_PRIMARY () {0xa;}' unless defined(&SEND_VOLUME_TAG_REPLACE_PRIMARY);
    eval 'sub SEND_VOLUME_TAG_REPLACE_ALTERNATE () {0xb;}' unless defined(&SEND_VOLUME_TAG_REPLACE_ALTERNATE);
    eval 'sub SEND_VOLUME_TAG_UNDEFINED_PRIMARY () {0xc;}' unless defined(&SEND_VOLUME_TAG_UNDEFINED_PRIMARY);
    eval 'sub SEND_VOLUME_TAG_UNDEFINED_ALTERNATE () {0xd;}' unless defined(&SEND_VOLUME_TAG_UNDEFINED_ALTERNATE);
    eval 'sub STOR_MT () {0x1;}' unless defined(&STOR_MT);
    eval 'sub STOR_ST () {0x2;}' unless defined(&STOR_ST);
    eval 'sub STOR_IE () {0x4;}' unless defined(&STOR_IE);
    eval 'sub STOR_DT () {0x8;}' unless defined(&STOR_DT);
    eval 'sub MOVE_TO_MT () {0x1;}' unless defined(&MOVE_TO_MT);
    eval 'sub MOVE_TO_ST () {0x2;}' unless defined(&MOVE_TO_ST);
    eval 'sub MOVE_TO_IE () {0x4;}' unless defined(&MOVE_TO_IE);
    eval 'sub MOVE_TO_DT () {0x8;}' unless defined(&MOVE_TO_DT);
    eval 'sub EXCHANGE_WITH_MT () {0x1;}' unless defined(&EXCHANGE_WITH_MT);
    eval 'sub EXCHANGE_WITH_ST () {0x2;}' unless defined(&EXCHANGE_WITH_ST);
    eval 'sub EXCHANGE_WITH_IE () {0x4;}' unless defined(&EXCHANGE_WITH_IE);
    eval 'sub EXCHANGE_WITH_DT () {0x8;}' unless defined(&EXCHANGE_WITH_DT);
    eval 'sub CAN_ROTATE () {0x1;}' unless defined(&CAN_ROTATE);
}
1;
