require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__SCSI_ENC_INTERNAL_H__)) {
    eval 'sub __SCSI_ENC_INTERNAL_H__ () {1;}' unless defined(&__SCSI_ENC_INTERNAL_H__);
    eval("sub ENC_NONE () { 0; }") unless defined(&ENC_NONE);
    eval("sub ENC_SES_SCSI2 () { 1; }") unless defined(&ENC_SES_SCSI2);
    eval("sub ENC_SES () { 2; }") unless defined(&ENC_SES);
    eval("sub ENC_SES_PASSTHROUGH () { 3; }") unless defined(&ENC_SES_PASSTHROUGH);
    eval("sub ENC_SEN () { 4; }") unless defined(&ENC_SEN);
    eval("sub ENC_SAFT () { 5; }") unless defined(&ENC_SAFT);
    eval("sub ENC_SEMB_SES () { 6; }") unless defined(&ENC_SEMB_SES);
    eval("sub ENC_SEMB_SAFT () { 7; }") unless defined(&ENC_SEMB_SAFT);
    eval 'sub ENC_FLAG_INVALID () {0x1;}' unless defined(&ENC_FLAG_INVALID);
    eval 'sub ENC_FLAG_INITIALIZED () {0x2;}' unless defined(&ENC_FLAG_INITIALIZED);
    eval 'sub ENC_FLAG_SHUTDOWN () {0x4;}' unless defined(&ENC_FLAG_SHUTDOWN);
    eval 'sub ENC_UPDATE_NONE () {0x;}' unless defined(&ENC_UPDATE_NONE);
    eval 'sub ENC_UPDATE_INVALID () {0xff;}' unless defined(&ENC_UPDATE_INVALID);
    eval 'sub enc_other_cache {
        my($enc,$primary) = @_;
	    eval q({ ($primary ==  ($enc->{enc_cache})  ?  ($enc->{enc_daemon_cache}) :  ($enc->{enc_cache})); });
    }' unless defined(&enc_other_cache);
    eval 'sub SES_MGMT_MODE_PAGE_CODE () {0x14;}' unless defined(&SES_MGMT_MODE_PAGE_CODE);
    eval 'sub SES_MGMT_MODE_PAGE_LEN () {6;}' unless defined(&SES_MGMT_MODE_PAGE_LEN);
    eval 'sub SES_MGMT_TIMED_COMP_EN () {0x1;}' unless defined(&SES_MGMT_TIMED_COMP_EN);
    eval 'sub ENC_CFLAGS () { &CAM_RETRY_SELTO;}' unless defined(&ENC_CFLAGS);
    eval 'sub ENC_FLAGS () { &SF_NO_PRINT |  &SF_RETRY_UA;}' unless defined(&ENC_FLAGS);
    eval 'sub STRNCMP () { &strncmp;}' unless defined(&STRNCMP);
    eval 'sub PRINTF () { &printf;}' unless defined(&PRINTF);
    eval 'sub ENC_LOG () { &enc_log;}' unless defined(&ENC_LOG);
    if(defined(&DEBUG) || defined(&ENC_DEBUG)) {
	eval 'sub ENC_DLOG () { &enc_log;}' unless defined(&ENC_DLOG);
    } else {
	eval 'sub ENC_DLOG () { &if (0)  &enc_log;}' unless defined(&ENC_DLOG);
    }
    eval 'sub ENC_VLOG () { &if ( &bootverbose)  &enc_log;}' unless defined(&ENC_VLOG);
    eval 'sub ENC_MALLOC {
        my($amt) = @_;
	    eval q( &malloc($amt,  &M_SCSIENC,  &M_NOWAIT));
    }' unless defined(&ENC_MALLOC);
    eval 'sub ENC_MALLOCZ {
        my($amt) = @_;
	    eval q( &malloc($amt,  &M_SCSIENC,  &M_ZERO| &M_NOWAIT));
    }' unless defined(&ENC_MALLOCZ);
    eval 'sub ENC_FREE {
        my($ptr) = @_;
	    eval q( &free(( &void *)(( &uintptr_t)$ptr),  &M_SCSIENC));
    }' unless defined(&ENC_FREE);
    eval 'sub ENC_FREE_AND_NULL {
        my($ptr) = @_;
	    eval q( &do {  &if ($ptr !=  &NULL) {  &ENC_FREE($ptr); $ptr =  &NULL; } }  &while(0));
    }' unless defined(&ENC_FREE_AND_NULL);
    eval 'sub MEMZERO () { &bzero;}' unless defined(&MEMZERO);
    eval 'sub MEMCPY {
        my($dest, $src, $amt) = @_;
	    eval q( &bcopy($src, $dest, $amt));
    }' unless defined(&MEMCPY);
}
1;
