require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SCSI_SCSI_SA_H)) {
    eval 'sub _SCSI_SCSI_SA_H () {1;}' unless defined(&_SCSI_SCSI_SA_H);
    require 'sys/cdefs.ph';
    eval 'sub RBL_GRAN_MASK () {0x1f;}' unless defined(&RBL_GRAN_MASK);
    eval 'sub RBL_GRAN {
        my($rblim) = @_;
	    eval q((($rblim)-> &gran &  &RBL_GRAN_MASK));
    }' unless defined(&RBL_GRAN);
    eval 'sub SAR_SLI () {0x2;}' unless defined(&SAR_SLI);
    eval 'sub SARW_FIXED () {0x1;}' unless defined(&SARW_FIXED);
    eval 'sub SLU_IMMED () {0x1;}' unless defined(&SLU_IMMED);
    eval 'sub SLU_EOT () {0x4;}' unless defined(&SLU_EOT);
    eval 'sub SLU_RETEN () {0x2;}' unless defined(&SLU_RETEN);
    eval 'sub SLU_LOAD () {0x1;}' unless defined(&SLU_LOAD);
    eval 'sub SREW_IMMED () {0x1;}' unless defined(&SREW_IMMED);
    eval("sub SS_BLOCKS () { 0; }") unless defined(&SS_BLOCKS);
    eval("sub SS_FILEMARKS () { 1; }") unless defined(&SS_FILEMARKS);
    eval("sub SS_SEQFILEMARKS () { 2; }") unless defined(&SS_SEQFILEMARKS);
    eval("sub SS_EOD () { 3; }") unless defined(&SS_EOD);
    eval("sub SS_SETMARKS () { 4; }") unless defined(&SS_SETMARKS);
    eval("sub SS_SEQSETMARKS () { 5; }") unless defined(&SS_SEQSETMARKS);
    eval 'sub SREW_IMMED () {0x1;}' unless defined(&SREW_IMMED);
    eval 'sub SWFMRK_IMMED () {0x1;}' unless defined(&SWFMRK_IMMED);
    eval 'sub SWFMRK_WSMK () {0x2;}' unless defined(&SWFMRK_WSMK);
    eval 'sub SRRU_LUN_MASK () {0xe0;}' unless defined(&SRRU_LUN_MASK);
    eval 'sub SRRU_3RD_PARTY () {0x10;}' unless defined(&SRRU_3RD_PARTY);
    eval 'sub SRRU_3RD_SHAMT () {1;}' unless defined(&SRRU_3RD_SHAMT);
    eval 'sub SRRU_3RD_MASK () {0xe;}' unless defined(&SRRU_3RD_MASK);
    eval 'sub SE_LUN_MASK () {0xe0;}' unless defined(&SE_LUN_MASK);
    eval 'sub SE_LONG () {0x1;}' unless defined(&SE_LONG);
    eval 'sub SE_IMMED () {0x2;}' unless defined(&SE_IMMED);
    eval 'sub SA_SSC_IMMED () {0x1;}' unless defined(&SA_SSC_IMMED);
    eval 'sub SFM_IMMED () {0x1;}' unless defined(&SFM_IMMED);
    eval 'sub SFM_VERIFY () {0x2;}' unless defined(&SFM_VERIFY);
    eval 'sub SFM_FORMAT_DEFAULT () {0x;}' unless defined(&SFM_FORMAT_DEFAULT);
    eval 'sub SFM_FORMAT_PARTITION () {0x1;}' unless defined(&SFM_FORMAT_PARTITION);
    eval 'sub SFM_FORMAT_DEF_PART () {0x2;}' unless defined(&SFM_FORMAT_DEF_PART);
    eval 'sub SFM_FORMAT_MASK () {0xf;}' unless defined(&SFM_FORMAT_MASK);
    eval 'sub SAO_ALLOW_OVERWRITE_DISABLED () {0x;}' unless defined(&SAO_ALLOW_OVERWRITE_DISABLED);
    eval 'sub SAO_ALLOW_OVERWRITE_CUR_POS () {0x1;}' unless defined(&SAO_ALLOW_OVERWRITE_CUR_POS);
    eval 'sub SAO_ALLOW_OVERWRITE_FORMAT () {0x2;}' unless defined(&SAO_ALLOW_OVERWRITE_FORMAT);
    eval 'sub SMH_SA_WP () {0x80;}' unless defined(&SMH_SA_WP);
    eval 'sub SMH_SA_BUF_MODE_MASK () {0x70;}' unless defined(&SMH_SA_BUF_MODE_MASK);
    eval 'sub SMH_SA_BUF_MODE_NOBUF () {0x;}' unless defined(&SMH_SA_BUF_MODE_NOBUF);
    eval 'sub SMH_SA_BUF_MODE_SIBUF () {0x10;}' unless defined(&SMH_SA_BUF_MODE_SIBUF);
    eval 'sub SMH_SA_BUF_MODE_MIBUF () {0x20;}' unless defined(&SMH_SA_BUF_MODE_MIBUF);
    eval 'sub SMH_SA_SPEED_MASK () {0xf;}' unless defined(&SMH_SA_SPEED_MASK);
    eval 'sub SMH_SA_SPEED_DEFAULT () {0x;}' unless defined(&SMH_SA_SPEED_DEFAULT);
    eval 'sub SA_DEVICE_CONFIGURATION_PAGE () {0x10;}' unless defined(&SA_DEVICE_CONFIGURATION_PAGE);
    eval 'sub SA_MEDIUM_PARTITION_PAGE_1 () {0x11;}' unless defined(&SA_MEDIUM_PARTITION_PAGE_1);
    eval 'sub SA_MEDIUM_PARTITION_PAGE_2 () {0x12;}' unless defined(&SA_MEDIUM_PARTITION_PAGE_2);
    eval 'sub SA_MEDIUM_PARTITION_PAGE_3 () {0x13;}' unless defined(&SA_MEDIUM_PARTITION_PAGE_3);
    eval 'sub SA_MEDIUM_PARTITION_PAGE_4 () {0x14;}' unless defined(&SA_MEDIUM_PARTITION_PAGE_4);
    eval 'sub SA_DATA_COMPRESSION_PAGE () {0xf;}' unless defined(&SA_DATA_COMPRESSION_PAGE);
    eval 'sub SA_DBR () {0x80;}' unless defined(&SA_DBR);
    eval 'sub SA_BIS () {0x40;}' unless defined(&SA_BIS);
    eval 'sub SA_RSMK () {0x20;}' unless defined(&SA_RSMK);
    eval 'sub SA_AVC () {0x10;}' unless defined(&SA_AVC);
    eval 'sub SA_SOCF_MASK () {0xc;}' unless defined(&SA_SOCF_MASK);
    eval 'sub SA_RBO () {0x2;}' unless defined(&SA_RBO);
    eval 'sub SA_REW () {0x1;}' unless defined(&SA_REW);
    eval 'sub SA_EOD_DEF_MASK () {0xe0;}' unless defined(&SA_EOD_DEF_MASK);
    eval 'sub SA_EEG () {0x10;}' unless defined(&SA_EEG);
    eval 'sub SA_SEW () {0x8;}' unless defined(&SA_SEW);
    eval 'sub SA_SOFT_WP () {0x4;}' unless defined(&SA_SOFT_WP);
    eval 'sub SA_BAML () {0x2;}' unless defined(&SA_BAML);
    eval 'sub SA_BAM () {0x1;}' unless defined(&SA_BAM);
    eval 'sub SA_COMP_NONE () {0x;}' unless defined(&SA_COMP_NONE);
    eval 'sub SA_COMP_DEFAULT () {0x1;}' unless defined(&SA_COMP_DEFAULT);
    eval 'sub SA_ASOC_WP () {0x4;}' unless defined(&SA_ASOC_WP);
    eval 'sub SA_PERS_WP () {0x2;}' unless defined(&SA_PERS_WP);
    eval 'sub SA_PERM_WP () {0x1;}' unless defined(&SA_PERM_WP);
    eval 'sub SA_DCP_DCE () {0x80;}' unless defined(&SA_DCP_DCE);
    eval 'sub SA_DCP_DCC () {0x40;}' unless defined(&SA_DCP_DCC);
    eval 'sub SA_DCP_DDE () {0x80;}' unless defined(&SA_DCP_DDE);
    eval 'sub SA_DCP_RED_MASK () {0x60;}' unless defined(&SA_DCP_RED_MASK);
    eval 'sub SA_DCP_RED_SHAMT () {5;}' unless defined(&SA_DCP_RED_SHAMT);
    eval 'sub SA_DCP_RED_0 () {0x;}' unless defined(&SA_DCP_RED_0);
    eval 'sub SA_DCP_RED_1 () {0x20;}' unless defined(&SA_DCP_RED_1);
    eval 'sub SA_DCP_RED_2 () {0x40;}' unless defined(&SA_DCP_RED_2);
    eval 'sub SA_CTRL_DP_PAGE_CODE () {0xa;}' unless defined(&SA_CTRL_DP_PAGE_CODE);
    eval 'sub SA_CTRL_DP_SUBPAGE_CODE () {0xf0;}' unless defined(&SA_CTRL_DP_SUBPAGE_CODE);
    eval 'sub SA_CTRL_DP_NO_LBP () {0x;}' unless defined(&SA_CTRL_DP_NO_LBP);
    eval 'sub SA_CTRL_DP_REED_SOLOMON () {0x1;}' unless defined(&SA_CTRL_DP_REED_SOLOMON);
    eval 'sub SA_CTRL_DP_METHOD_MAX () {0xff;}' unless defined(&SA_CTRL_DP_METHOD_MAX);
    eval 'sub SA_CTRL_DP_PI_LENGTH_MASK () {0x3f;}' unless defined(&SA_CTRL_DP_PI_LENGTH_MASK);
    eval 'sub SA_CTRL_DP_RS_LENGTH () {4;}' unless defined(&SA_CTRL_DP_RS_LENGTH);
    eval 'sub SA_CTRL_DP_LBP_W () {0x80;}' unless defined(&SA_CTRL_DP_LBP_W);
    eval 'sub SA_CTRL_DP_LBP_R () {0x40;}' unless defined(&SA_CTRL_DP_LBP_R);
    eval 'sub SA_CTRL_DP_RBDP () {0x20;}' unless defined(&SA_CTRL_DP_RBDP);
    eval 'sub SA_IBM_RW_CTRL_PAGE_CODE () {0x25;}' unless defined(&SA_IBM_RW_CTRL_PAGE_CODE);
    eval 'sub SA_IBM_RW_CTRL_LOC_IGNORE_SEQ () {0x4;}' unless defined(&SA_IBM_RW_CTRL_LOC_IGNORE_SEQ);
    eval 'sub SA_IBM_RW_CTRL_SPC_BLK_IGNORE_SEQ () {0x2;}' unless defined(&SA_IBM_RW_CTRL_SPC_BLK_IGNORE_SEQ);
    eval 'sub SA_IBM_RW_CTRL_SPC_FM_IGNORE_SEQ () {0x1;}' unless defined(&SA_IBM_RW_CTRL_SPC_FM_IGNORE_SEQ);
    eval 'sub SA_IBM_RW_CTRL_LOC_IGNORE_DATA () {0x4;}' unless defined(&SA_IBM_RW_CTRL_LOC_IGNORE_DATA);
    eval 'sub SA_IBM_RW_CTRL_SPC_BLK_IGNORE_DATA () {0x2;}' unless defined(&SA_IBM_RW_CTRL_SPC_BLK_IGNORE_DATA);
    eval 'sub SA_IBM_RW_CTRL_SPC_FM_IGNORE_DATA () {0x1;}' unless defined(&SA_IBM_RW_CTRL_SPC_FM_IGNORE_DATA);
    eval 'sub SA_IBM_RW_CTRL_LEOP_DEFAULT () {0x;}' unless defined(&SA_IBM_RW_CTRL_LEOP_DEFAULT);
    eval 'sub SA_IBM_RW_CTRL_LEOP_MAX_CAP () {0x1;}' unless defined(&SA_IBM_RW_CTRL_LEOP_MAX_CAP);
    eval 'sub SA_IBM_RW_CTRL_LEOP_CONST_CAP () {0x2;}' unless defined(&SA_IBM_RW_CTRL_LEOP_CONST_CAP);
    eval 'sub SA_IBM_RW_CTRL_DISABLE_FASTSYNC () {0x80;}' unless defined(&SA_IBM_RW_CTRL_DISABLE_FASTSYNC);
    eval 'sub SA_IBM_RW_CTRL_DISABLE_SKIPSYNC () {0x40;}' unless defined(&SA_IBM_RW_CTRL_DISABLE_SKIPSYNC);
    eval 'sub SA_IBM_RW_CTRL_DISABLE_CROSS_EOD () {0x8;}' unless defined(&SA_IBM_RW_CTRL_DISABLE_CROSS_EOD);
    eval 'sub SA_IBM_RW_CTRL_DISABLE_CROSS_PERM_ERR () {0x4;}' unless defined(&SA_IBM_RW_CTRL_DISABLE_CROSS_PERM_ERR);
    eval 'sub SA_IBM_RW_CTRL_REPORT_SEG_EW () {0x2;}' unless defined(&SA_IBM_RW_CTRL_REPORT_SEG_EW);
    eval 'sub SA_IBM_RW_CTRL_REPORT_HOUSEKEEPING_ERR () {0x1;}' unless defined(&SA_IBM_RW_CTRL_REPORT_HOUSEKEEPING_ERR);
    eval 'sub SA_RPOS_SHORT_FORM () {0x;}' unless defined(&SA_RPOS_SHORT_FORM);
    eval 'sub SA_RPOS_SHORT_VENDOR () {0x1;}' unless defined(&SA_RPOS_SHORT_VENDOR);
    eval 'sub SA_RPOS_LONG_FORM () {0x6;}' unless defined(&SA_RPOS_LONG_FORM);
    eval 'sub SA_RPOS_EXTENDED_FORM () {0x8;}' unless defined(&SA_RPOS_EXTENDED_FORM);
    eval 'sub SA_RPOS_BOP () {0x80;}' unless defined(&SA_RPOS_BOP);
    eval 'sub SA_RPOS_EOP () {0x40;}' unless defined(&SA_RPOS_EOP);
    eval 'sub SA_RPOS_BCU () {0x20;}' unless defined(&SA_RPOS_BCU);
    eval 'sub SA_RPOS_BYCU () {0x10;}' unless defined(&SA_RPOS_BYCU);
    eval 'sub SA_RPOS_BPU () {0x4;}' unless defined(&SA_RPOS_BPU);
    eval 'sub SA_RPOS_PERR () {0x2;}' unless defined(&SA_RPOS_PERR);
    eval 'sub SA_RPOS_BPEW () {0x1;}' unless defined(&SA_RPOS_BPEW);
    eval 'sub SA_RPOS_UNCERTAIN () { &SA_RPOS_BPU;}' unless defined(&SA_RPOS_UNCERTAIN);
    eval 'sub SA_RPOS_LONG_BOP () {0x80;}' unless defined(&SA_RPOS_LONG_BOP);
    eval 'sub SA_RPOS_LONG_EOP () {0x40;}' unless defined(&SA_RPOS_LONG_EOP);
    eval 'sub SA_RPOS_LONG_MPU () {0x8;}' unless defined(&SA_RPOS_LONG_MPU);
    eval 'sub SA_RPOS_LONG_LONU () {0x4;}' unless defined(&SA_RPOS_LONG_LONU);
    eval 'sub SA_RPOS_LONG_BPEW () {0x1;}' unless defined(&SA_RPOS_LONG_BPEW);
    eval 'sub SA_RPOS_EXT_BOP () {0x80;}' unless defined(&SA_RPOS_EXT_BOP);
    eval 'sub SA_RPOS_EXT_EOP () {0x40;}' unless defined(&SA_RPOS_EXT_EOP);
    eval 'sub SA_RPOS_EXT_LOCU () {0x20;}' unless defined(&SA_RPOS_EXT_LOCU);
    eval 'sub SA_RPOS_EXT_BYCU () {0x10;}' unless defined(&SA_RPOS_EXT_BYCU);
    eval 'sub SA_RPOS_EXT_LOLU () {0x4;}' unless defined(&SA_RPOS_EXT_LOLU);
    eval 'sub SA_RPOS_EXT_PERR () {0x2;}' unless defined(&SA_RPOS_EXT_PERR);
    eval 'sub SA_RPOS_EXT_BPEW () {0x1;}' unless defined(&SA_RPOS_EXT_BPEW);
    eval 'sub SA_SPOS_IMMED () {0x1;}' unless defined(&SA_SPOS_IMMED);
    eval 'sub SA_SPOS_CP () {0x2;}' unless defined(&SA_SPOS_CP);
    eval 'sub SA_SPOS_BT () {0x4;}' unless defined(&SA_SPOS_BT);
    eval 'sub SA_SPOS_MAX_BLK () {0xffffffff;}' unless defined(&SA_SPOS_MAX_BLK);
    eval 'sub SA_LC_IMMEDIATE () {0x1;}' unless defined(&SA_LC_IMMEDIATE);
    eval 'sub SA_LC_CP () {0x2;}' unless defined(&SA_LC_CP);
    eval 'sub SA_LC_DEST_TYPE_MASK () {0x38;}' unless defined(&SA_LC_DEST_TYPE_MASK);
    eval 'sub SA_LC_DEST_TYPE_SHIFT () {3;}' unless defined(&SA_LC_DEST_TYPE_SHIFT);
    eval 'sub SA_LC_DEST_OBJECT () {0x;}' unless defined(&SA_LC_DEST_OBJECT);
    eval 'sub SA_LC_DEST_FILE () {0x1;}' unless defined(&SA_LC_DEST_FILE);
    eval 'sub SA_LC_DEST_SET () {0x2;}' unless defined(&SA_LC_DEST_SET);
    eval 'sub SA_LC_DEST_EOD () {0x3;}' unless defined(&SA_LC_DEST_EOD);
    eval 'sub SA_LC_BAM_IMPLICIT () {0x;}' unless defined(&SA_LC_BAM_IMPLICIT);
    eval 'sub SA_LC_BAM_EXPLICIT () {0x1;}' unless defined(&SA_LC_BAM_EXPLICIT);
    eval 'sub SRDS_MEDIA () {0x1;}' unless defined(&SRDS_MEDIA);
    eval 'sub SRDS_MEDIUM_TYPE () {0x2;}' unless defined(&SRDS_MEDIUM_TYPE);
    eval 'sub SRDS_MAX_LENGTH () {0xffff;}' unless defined(&SRDS_MAX_LENGTH);
    eval 'sub SDD_DLV () {0x1;}' unless defined(&SDD_DLV);
    eval 'sub SDD_DEFLT () {0x20;}' unless defined(&SDD_DEFLT);
    eval 'sub SDD_DUP () {0x40;}' unless defined(&SDD_DUP);
    eval 'sub SDD_WRTOK () {0x80;}' unless defined(&SDD_WRTOK);
    eval 'sub SDD_DEFAULT_LENGTH () {52;}' unless defined(&SDD_DEFAULT_LENGTH);
    eval 'sub SMTD_DEFAULT_LENGTH () {52;}' unless defined(&SMTD_DEFAULT_LENGTH);
    eval 'sub SVPD_MFG_SERIAL_NUMBER_PAGE_CODE () {0xb1;}' unless defined(&SVPD_MFG_SERIAL_NUMBER_PAGE_CODE);
    eval 'sub TDE_IN_SUPPORT_PAGE () {0x;}' unless defined(&TDE_IN_SUPPORT_PAGE);
    eval 'sub TDE_OUT_SUPPORT_PAGE () {0x1;}' unless defined(&TDE_OUT_SUPPORT_PAGE);
    eval 'sub TDE_DATA_ENC_CAP_PAGE () {0x10;}' unless defined(&TDE_DATA_ENC_CAP_PAGE);
    eval 'sub TDE_SUPPORTED_KEY_FORMATS_PAGE () {0x11;}' unless defined(&TDE_SUPPORTED_KEY_FORMATS_PAGE);
    eval 'sub TDE_DATA_ENC_MAN_CAP_PAGE () {0x12;}' unless defined(&TDE_DATA_ENC_MAN_CAP_PAGE);
    eval 'sub TDE_DATA_ENC_STATUS_PAGE () {0x20;}' unless defined(&TDE_DATA_ENC_STATUS_PAGE);
    eval 'sub TDE_NEXT_BLOCK_ENC_STATUS_PAGE () {0x21;}' unless defined(&TDE_NEXT_BLOCK_ENC_STATUS_PAGE);
    eval 'sub TDE_GET_ENC_MAN_ATTR_PAGE () {0x22;}' unless defined(&TDE_GET_ENC_MAN_ATTR_PAGE);
    eval 'sub TDE_RANDOM_NUM_PAGE () {0x30;}' unless defined(&TDE_RANDOM_NUM_PAGE);
    eval 'sub TDE_KEY_WRAP_PK_PAGE () {0x31;}' unless defined(&TDE_KEY_WRAP_PK_PAGE);
    eval 'sub TDE_BEA_AVFMV () {0x80;}' unless defined(&TDE_BEA_AVFMV);
    eval 'sub TDE_BEA_SDK_C () {0x40;}' unless defined(&TDE_BEA_SDK_C);
    eval 'sub TDE_BEA_MAC_C () {0x20;}' unless defined(&TDE_BEA_MAC_C);
    eval 'sub TDE_BEA_DELB_C () {0x10;}' unless defined(&TDE_BEA_DELB_C);
    eval 'sub TDE_BEA_DECRYPT_C_MASK () {0xc;}' unless defined(&TDE_BEA_DECRYPT_C_MASK);
    eval 'sub TDE_BEA_DECRYPT_C_EXT () {0xc;}' unless defined(&TDE_BEA_DECRYPT_C_EXT);
    eval 'sub TDE_BEA_DECRYPT_C_HARD () {0x8;}' unless defined(&TDE_BEA_DECRYPT_C_HARD);
    eval 'sub TDE_BEA_DECRYPT_C_SOFT () {0x4;}' unless defined(&TDE_BEA_DECRYPT_C_SOFT);
    eval 'sub TDE_BEA_DECRYPT_C_NO_CAP () {0x;}' unless defined(&TDE_BEA_DECRYPT_C_NO_CAP);
    eval 'sub TDE_BEA_ENCRYPT_C_MASK () {0x3;}' unless defined(&TDE_BEA_ENCRYPT_C_MASK);
    eval 'sub TDE_BEA_ENCRYPT_C_EXT () {0x3;}' unless defined(&TDE_BEA_ENCRYPT_C_EXT);
    eval 'sub TDE_BEA_ENCRYPT_C_HARD () {0x2;}' unless defined(&TDE_BEA_ENCRYPT_C_HARD);
    eval 'sub TDE_BEA_ENCRYPT_C_SOFT () {0x1;}' unless defined(&TDE_BEA_ENCRYPT_C_SOFT);
    eval 'sub TDE_BEA_ENCRYPT_C_NO_CAP () {0x;}' unless defined(&TDE_BEA_ENCRYPT_C_NO_CAP);
    eval 'sub TDE_BEA_AVFCLP_MASK () {0xc0;}' unless defined(&TDE_BEA_AVFCLP_MASK);
    eval 'sub TDE_BEA_AVFCLP_VALID () {0x80;}' unless defined(&TDE_BEA_AVFCLP_VALID);
    eval 'sub TDE_BEA_AVFCLP_NOT_VALID () {0x40;}' unless defined(&TDE_BEA_AVFCLP_NOT_VALID);
    eval 'sub TDE_BEA_AVFCLP_NOT_APP () {0x;}' unless defined(&TDE_BEA_AVFCLP_NOT_APP);
    eval 'sub TDE_BEA_NONCE_C_MASK () {0x30;}' unless defined(&TDE_BEA_NONCE_C_MASK);
    eval 'sub TDE_BEA_NONCE_C_SUPPORTED () {0x30;}' unless defined(&TDE_BEA_NONCE_C_SUPPORTED);
    eval 'sub TDE_BEA_NONCE_C_PROVIDED () {0x20;}' unless defined(&TDE_BEA_NONCE_C_PROVIDED);
    eval 'sub TDE_BEA_NONCE_C_GENERATED () {0x10;}' unless defined(&TDE_BEA_NONCE_C_GENERATED);
    eval 'sub TDE_BEA_NONCE_C_NOT_REQUIRED () {0x;}' unless defined(&TDE_BEA_NONCE_C_NOT_REQUIRED);
    eval 'sub TDE_BEA_KADF_C () {0x8;}' unless defined(&TDE_BEA_KADF_C);
    eval 'sub TDE_BEA_VCELB_C () {0x4;}' unless defined(&TDE_BEA_VCELB_C);
    eval 'sub TDE_BEA_UKADF () {0x2;}' unless defined(&TDE_BEA_UKADF);
    eval 'sub TDE_BEA_AKADF () {0x1;}' unless defined(&TDE_BEA_AKADF);
    eval 'sub TDE_BEA_DKAD_C_MASK () {0xc0;}' unless defined(&TDE_BEA_DKAD_C_MASK);
    eval 'sub TDE_BEA_DKAD_C_CAPABLE () {0xc0;}' unless defined(&TDE_BEA_DKAD_C_CAPABLE);
    eval 'sub TDE_BEA_DKAD_C_NOT_ALLOWED () {0x80;}' unless defined(&TDE_BEA_DKAD_C_NOT_ALLOWED);
    eval 'sub TDE_BEA_DKAD_C_REQUIRED () {0x40;}' unless defined(&TDE_BEA_DKAD_C_REQUIRED);
    eval 'sub TDE_BEA_EEMC_C_MASK () {0x30;}' unless defined(&TDE_BEA_EEMC_C_MASK);
    eval 'sub TDE_BEA_EEMC_C_ALLOWED () {0x20;}' unless defined(&TDE_BEA_EEMC_C_ALLOWED);
    eval 'sub TDE_BEA_EEMC_C_NOT_ALLOWED () {0x10;}' unless defined(&TDE_BEA_EEMC_C_NOT_ALLOWED);
    eval 'sub TDE_BEA_EEMC_C_NOT_SPECIFIED () {0x;}' unless defined(&TDE_BEA_EEMC_C_NOT_SPECIFIED);
    eval 'sub TDE_BEA_RDMC_C_MASK () {0xe;}' unless defined(&TDE_BEA_RDMC_C_MASK);
    eval 'sub TDE_BEA_RDMC_C_MODE_7 () {0xe;}' unless defined(&TDE_BEA_RDMC_C_MODE_7);
    eval 'sub TDE_BEA_RDMC_C_MODE_6 () {0xc;}' unless defined(&TDE_BEA_RDMC_C_MODE_6);
    eval 'sub TDE_BEA_RDMC_C_MODE_5 () {0xa;}' unless defined(&TDE_BEA_RDMC_C_MODE_5);
    eval 'sub TDE_BEA_RDMC_C_MODE_4 () {0x8;}' unless defined(&TDE_BEA_RDMC_C_MODE_4);
    eval 'sub TDE_BEA_RDMC_C_MODE_1 () {0x2;}' unless defined(&TDE_BEA_RDMC_C_MODE_1);
    eval 'sub TDE_BEA_EAREM () {0x1;}' unless defined(&TDE_BEA_EAREM);
    eval 'sub TDE_BEA_MAX_EEDKS_MASK () {0xf;}' unless defined(&TDE_BEA_MAX_EEDKS_MASK);
    eval 'sub DATA_ENC_CAP_EXTDECC_MASK () {0xc;}' unless defined(&DATA_ENC_CAP_EXTDECC_MASK);
    eval 'sub DATA_ENC_CAP_EXTDECC_NOT_REPORTED () {0x;}' unless defined(&DATA_ENC_CAP_EXTDECC_NOT_REPORTED);
    eval 'sub DATA_ENC_CAP_EXTDECC_NOT_CAPABLE () {0x4;}' unless defined(&DATA_ENC_CAP_EXTDECC_NOT_CAPABLE);
    eval 'sub DATA_ENC_CAP_EXTDECC_CAPABLE () {0x8;}' unless defined(&DATA_ENC_CAP_EXTDECC_CAPABLE);
    eval 'sub DATA_ENC_CAP_CFG_P_MASK () {0x3;}' unless defined(&DATA_ENC_CAP_CFG_P_MASK);
    eval 'sub DATA_ENC_CAP_CFG_P_NOT_REPORTED () {0x;}' unless defined(&DATA_ENC_CAP_CFG_P_NOT_REPORTED);
    eval 'sub DATA_ENC_CAP_CFG_P_ALLOWED () {0x1;}' unless defined(&DATA_ENC_CAP_CFG_P_ALLOWED);
    eval 'sub DATA_ENC_CAP_CFG_P_NOT_ALLOWED () {0x2;}' unless defined(&DATA_ENC_CAP_CFG_P_NOT_ALLOWED);
    eval 'sub TDE_DEMC_LOCK_C () {0x1;}' unless defined(&TDE_DEMC_LOCK_C);
    eval 'sub TDE_DEMC_CKOD_C () {0x4;}' unless defined(&TDE_DEMC_CKOD_C);
    eval 'sub TDE_DEMC_CKORP_C () {0x2;}' unless defined(&TDE_DEMC_CKORP_C);
    eval 'sub TDE_DEMC_CKORL_C () {0x1;}' unless defined(&TDE_DEMC_CKORL_C);
    eval 'sub TDE_DEMC_AITN_C () {0x4;}' unless defined(&TDE_DEMC_AITN_C);
    eval 'sub TDE_DEMC_LOCAL_C () {0x2;}' unless defined(&TDE_DEMC_LOCAL_C);
    eval 'sub TDE_DEMC_PUBLIC_C () {0x1;}' unless defined(&TDE_DEMC_PUBLIC_C);
    eval 'sub TDE_DES_IT_NEXUS_SCOPE_MASK () {0xe0;}' unless defined(&TDE_DES_IT_NEXUS_SCOPE_MASK);
    eval 'sub TDE_DES_LBE_SCOPE_MASK () {0x7;}' unless defined(&TDE_DES_LBE_SCOPE_MASK);
    eval 'sub TDE_DES_PARAM_CTRL_MASK () {0x70;}' unless defined(&TDE_DES_PARAM_CTRL_MASK);
    eval 'sub TDE_DES_PARAM_CTRL_MGMT () {0x40;}' unless defined(&TDE_DES_PARAM_CTRL_MGMT);
    eval 'sub TDE_DES_PARAM_CTRL_CHANGER () {0x30;}' unless defined(&TDE_DES_PARAM_CTRL_CHANGER);
    eval 'sub TDE_DES_PARAM_CTRL_DRIVE () {0x20;}' unless defined(&TDE_DES_PARAM_CTRL_DRIVE);
    eval 'sub TDE_DES_PARAM_CTRL_EXT () {0x10;}' unless defined(&TDE_DES_PARAM_CTRL_EXT);
    eval 'sub TDE_DES_PARAM_CTRL_NOT_REPORTED () {0x;}' unless defined(&TDE_DES_PARAM_CTRL_NOT_REPORTED);
    eval 'sub TDE_DES_VCELB () {0x8;}' unless defined(&TDE_DES_VCELB);
    eval 'sub TDE_DES_CEEMS_MASK () {0x6;}' unless defined(&TDE_DES_CEEMS_MASK);
    eval 'sub TDE_DES_RDMD () {0x1;}' unless defined(&TDE_DES_RDMD);
    eval 'sub TDE_NBES_COMP_STATUS_MASK () {0xf0;}' unless defined(&TDE_NBES_COMP_STATUS_MASK);
    eval 'sub TDE_NBES_COMP_INCAPABLE () {0x;}' unless defined(&TDE_NBES_COMP_INCAPABLE);
    eval 'sub TDE_NBES_COMP_NOT_YET () {0x10;}' unless defined(&TDE_NBES_COMP_NOT_YET);
    eval 'sub TDE_NBES_COMP_NOT_A_BLOCK () {0x20;}' unless defined(&TDE_NBES_COMP_NOT_A_BLOCK);
    eval 'sub TDE_NBES_COMP_NOT_COMPRESSED () {0x30;}' unless defined(&TDE_NBES_COMP_NOT_COMPRESSED);
    eval 'sub TDE_NBES_COMP_COMPRESSED () {0x40;}' unless defined(&TDE_NBES_COMP_COMPRESSED);
    eval 'sub TDE_NBES_ENC_STATUS_MASK () {0xf;}' unless defined(&TDE_NBES_ENC_STATUS_MASK);
    eval 'sub TDE_NBES_ENC_INCAPABLE () {0x;}' unless defined(&TDE_NBES_ENC_INCAPABLE);
    eval 'sub TDE_NBES_ENC_NOT_YET () {0x1;}' unless defined(&TDE_NBES_ENC_NOT_YET);
    eval 'sub TDE_NBES_ENC_NOT_A_BLOCK () {0x2;}' unless defined(&TDE_NBES_ENC_NOT_A_BLOCK);
    eval 'sub TDE_NBES_ENC_NOT_ENCRYPTED () {0x3;}' unless defined(&TDE_NBES_ENC_NOT_ENCRYPTED);
    eval 'sub TDE_NBES_ENC_ALG_NOT_SUPPORTED () {0x4;}' unless defined(&TDE_NBES_ENC_ALG_NOT_SUPPORTED);
    eval 'sub TDE_NBES_ENC_SUPPORTED_ALG () {0x5;}' unless defined(&TDE_NBES_ENC_SUPPORTED_ALG);
    eval 'sub TDE_NBES_ENC_NO_KEY () {0x6;}' unless defined(&TDE_NBES_ENC_NO_KEY);
    eval 'sub TDE_NBES_EMES () {0x2;}' unless defined(&TDE_NBES_EMES);
    eval 'sub TDE_NBES_RDMDS () {0x1;}' unless defined(&TDE_NBES_RDMDS);
    eval 'sub TDE_GEMA_CAOD () {0x1;}' unless defined(&TDE_GEMA_CAOD);
    eval 'sub TDE_SET_DATA_ENC_PAGE () {0x10;}' unless defined(&TDE_SET_DATA_ENC_PAGE);
    eval 'sub TDE_SA_ENCAP_PAGE () {0x11;}' unless defined(&TDE_SA_ENCAP_PAGE);
    eval 'sub TDE_SET_ENC_MGMT_ATTR_PAGE () {0x22;}' unless defined(&TDE_SET_ENC_MGMT_ATTR_PAGE);
    eval 'sub TDE_SDE_SCOPE_MASK () {0xe0;}' unless defined(&TDE_SDE_SCOPE_MASK);
    eval 'sub TDE_SDE_SCOPE_ALL_IT_NEXUS () {0x80;}' unless defined(&TDE_SDE_SCOPE_ALL_IT_NEXUS);
    eval 'sub TDE_SDE_SCOPE_LOCAL () {0x40;}' unless defined(&TDE_SDE_SCOPE_LOCAL);
    eval 'sub TDE_SDE_SCOPE_PUBLIC () {0x;}' unless defined(&TDE_SDE_SCOPE_PUBLIC);
    eval 'sub TDE_SDE_LOCK () {0x1;}' unless defined(&TDE_SDE_LOCK);
    eval 'sub TDE_SDE_CEEM_MASK () {0xc0;}' unless defined(&TDE_SDE_CEEM_MASK);
    eval 'sub TDE_SDE_CEEM_ENCRYPT () {0xc0;}' unless defined(&TDE_SDE_CEEM_ENCRYPT);
    eval 'sub TDE_SDE_CEEM_EXTERNAL () {0x80;}' unless defined(&TDE_SDE_CEEM_EXTERNAL);
    eval 'sub TDE_SDE_CEEM_NO_CHECK () {0x40;}' unless defined(&TDE_SDE_CEEM_NO_CHECK);
    eval 'sub TDE_SDE_RDMC_MASK () {0x30;}' unless defined(&TDE_SDE_RDMC_MASK);
    eval 'sub TDE_SDE_RDMC_DISABLED () {0x30;}' unless defined(&TDE_SDE_RDMC_DISABLED);
    eval 'sub TDE_SDE_RDMC_ENABLED () {0x20;}' unless defined(&TDE_SDE_RDMC_ENABLED);
    eval 'sub TDE_SDE_RDMC_DEFAULT () {0x;}' unless defined(&TDE_SDE_RDMC_DEFAULT);
    eval 'sub TDE_SDE_SDK () {0x8;}' unless defined(&TDE_SDE_SDK);
    eval 'sub TDE_SDE_CKOD () {0x4;}' unless defined(&TDE_SDE_CKOD);
    eval 'sub TDE_SDE_CKORP () {0x2;}' unless defined(&TDE_SDE_CKORP);
    eval 'sub TDE_SDE_CKORL () {0x1;}' unless defined(&TDE_SDE_CKORL);
    eval 'sub TDE_SDE_ENC_MODE_DISABLE () {0x;}' unless defined(&TDE_SDE_ENC_MODE_DISABLE);
    eval 'sub TDE_SDE_ENC_MODE_EXTERNAL () {0x1;}' unless defined(&TDE_SDE_ENC_MODE_EXTERNAL);
    eval 'sub TDE_SDE_ENC_MODE_ENCRYPT () {0x2;}' unless defined(&TDE_SDE_ENC_MODE_ENCRYPT);
    eval 'sub TDE_SDE_DEC_MODE_DISABLE () {0x;}' unless defined(&TDE_SDE_DEC_MODE_DISABLE);
    eval 'sub TDE_SDE_DEC_MODE_RAW () {0x1;}' unless defined(&TDE_SDE_DEC_MODE_RAW);
    eval 'sub TDE_SDE_DEC_MODE_DECRYPT () {0x2;}' unless defined(&TDE_SDE_DEC_MODE_DECRYPT);
    eval 'sub TDE_SDE_DEC_MODE_MIXED () {0x3;}' unless defined(&TDE_SDE_DEC_MODE_MIXED);
    eval 'sub TDE_SDE_KEY_PLAINTEXT () {0x;}' unless defined(&TDE_SDE_KEY_PLAINTEXT);
    eval 'sub TDE_SDE_KEY_VENDOR_SPEC () {0x1;}' unless defined(&TDE_SDE_KEY_VENDOR_SPEC);
    eval 'sub TDE_SDE_KEY_PUBLIC_WRAP () {0x2;}' unless defined(&TDE_SDE_KEY_PUBLIC_WRAP);
    eval 'sub TDE_SDE_KEY_ESP_SCSI () {0x3;}' unless defined(&TDE_SDE_KEY_ESP_SCSI);
    eval 'sub TDE_SDE_KAD_ASCII () {0x2;}' unless defined(&TDE_SDE_KAD_ASCII);
    eval 'sub TDE_SDE_KAD_BINARY () {0x1;}' unless defined(&TDE_SDE_KAD_BINARY);
    eval 'sub TDE_SDE_KAD_UNSPECIFIED () {0x;}' unless defined(&TDE_SDE_KAD_UNSPECIFIED);
    eval 'sub TDE_PARAM_SET_RSA2048 () {0x;}' unless defined(&TDE_PARAM_SET_RSA2048);
    eval 'sub TDE_PARAM_SET_ECC521 () {0x10;}' unless defined(&TDE_PARAM_SET_ECC521);
    eval 'sub TDE_SEMA_CAOD () {0x1;}' unless defined(&TDE_SEMA_CAOD);
    eval 'sub TDE_KEY_DESC_WK_KAD () {0x4;}' unless defined(&TDE_KEY_DESC_WK_KAD);
    eval 'sub TDE_KEY_DESC_M_KAD () {0x3;}' unless defined(&TDE_KEY_DESC_M_KAD);
    eval 'sub TDE_KEY_DESC_NONCE_VALUE () {0x2;}' unless defined(&TDE_KEY_DESC_NONCE_VALUE);
    eval 'sub TDE_KEY_DESC_A_KAD () {0x1;}' unless defined(&TDE_KEY_DESC_A_KAD);
    eval 'sub TDE_KEY_DESC_U_KAD () {0x;}' unless defined(&TDE_KEY_DESC_U_KAD);
    eval 'sub TDE_KEY_DESC_AUTH_MASK () {0x7;}' unless defined(&TDE_KEY_DESC_AUTH_MASK);
    eval 'sub TDE_KEY_DESC_AUTH_FAILED () {0x4;}' unless defined(&TDE_KEY_DESC_AUTH_FAILED);
    eval 'sub TDE_KEY_DESC_AUTH_SUCCESS () {0x3;}' unless defined(&TDE_KEY_DESC_AUTH_SUCCESS);
    eval 'sub TDE_KEY_DESC_AUTH_NO_ATTEMPT () {0x2;}' unless defined(&TDE_KEY_DESC_AUTH_NO_ATTEMPT);
    eval 'sub TDE_KEY_DESC_AUTH_U_KAD () {0x1;}' unless defined(&TDE_KEY_DESC_AUTH_U_KAD);
    eval 'sub TDE_WRAP_KEY_DESC_LENGTH () {0x4;}' unless defined(&TDE_WRAP_KEY_DESC_LENGTH);
    eval 'sub TDE_WRAP_KEY_DESC_IDENT () {0x3;}' unless defined(&TDE_WRAP_KEY_DESC_IDENT);
    eval 'sub TDE_WRAP_KEY_DESC_INFO () {0x2;}' unless defined(&TDE_WRAP_KEY_DESC_INFO);
    eval 'sub TDE_WRAP_KEY_DESC_ENTITY_ID () {0x1;}' unless defined(&TDE_WRAP_KEY_DESC_ENTITY_ID);
    eval 'sub TDE_WRAP_KEY_DESC_DEVICE_ID () {0x;}' unless defined(&TDE_WRAP_KEY_DESC_DEVICE_ID);
    eval 'sub TDE_EMAD_DESIRED_KEY_MGR_OP () {0x;}' unless defined(&TDE_EMAD_DESIRED_KEY_MGR_OP);
    eval 'sub TDE_EMAD_LOG_BLOCK_ENC_KEY_CRIT () {0x1;}' unless defined(&TDE_EMAD_LOG_BLOCK_ENC_KEY_CRIT);
    eval 'sub TDE_EMAD_LOG_BLOCK_ENC_KEY_WRAP () {0x2;}' unless defined(&TDE_EMAD_LOG_BLOCK_ENC_KEY_WRAP);
    eval 'sub TDE_EMAD_CRIT () {0x80;}' unless defined(&TDE_EMAD_CRIT);
    eval 'sub TDE_EMAD_DESIRED_KEY_CREATE () {0x1;}' unless defined(&TDE_EMAD_DESIRED_KEY_CREATE);
    eval 'sub TDE_EMAD_DESIRED_KEY_RESOLVE () {0x2;}' unless defined(&TDE_EMAD_DESIRED_KEY_RESOLVE);
    eval 'sub TDE_LBE_KEY_SEL_CRIT () {0x80;}' unless defined(&TDE_LBE_KEY_SEL_CRIT);
    eval 'sub TDE_LBE_KEY_SEL_ALGO () {0x1;}' unless defined(&TDE_LBE_KEY_SEL_ALGO);
    eval 'sub TDE_LBE_KEY_SEL_ID () {0x2;}' unless defined(&TDE_LBE_KEY_SEL_ID);
    eval 'sub TDE_LBE_KEY_WRAP_CRIT () {0x80;}' unless defined(&TDE_LBE_KEY_WRAP_CRIT);
    eval 'sub TDE_LBE_KEY_WRAP_KEKS () {0x1;}' unless defined(&TDE_LBE_KEY_WRAP_KEKS);
    eval 'sub REWIND () {0x1;}' unless defined(&REWIND);
    eval 'sub FORMAT_MEDIUM () {0x4;}' unless defined(&FORMAT_MEDIUM);
    eval 'sub READ_BLOCK_LIMITS () {0x5;}' unless defined(&READ_BLOCK_LIMITS);
    eval 'sub SA_READ () {0x8;}' unless defined(&SA_READ);
    eval 'sub SA_WRITE () {0xa;}' unless defined(&SA_WRITE);
    eval 'sub SET_CAPACITY () {0xb;}' unless defined(&SET_CAPACITY);
    eval 'sub WRITE_FILEMARKS () {0x10;}' unless defined(&WRITE_FILEMARKS);
    eval 'sub SPACE () {0x11;}' unless defined(&SPACE);
    eval 'sub RESERVE_UNIT () {0x16;}' unless defined(&RESERVE_UNIT);
    eval 'sub RELEASE_UNIT () {0x17;}' unless defined(&RELEASE_UNIT);
    eval 'sub ERASE () {0x19;}' unless defined(&ERASE);
    eval 'sub LOAD_UNLOAD () {0x1b;}' unless defined(&LOAD_UNLOAD);
    eval 'sub LOCATE () {0x2b;}' unless defined(&LOCATE);
    eval 'sub READ_POSITION () {0x34;}' unless defined(&READ_POSITION);
    eval 'sub REPORT_DENSITY_SUPPORT () {0x44;}' unless defined(&REPORT_DENSITY_SUPPORT);
    eval 'sub ALLOW_OVERWRITE () {0x82;}' unless defined(&ALLOW_OVERWRITE);
    eval 'sub LOCATE_16 () {0x92;}' unless defined(&LOCATE_16);
    eval 'sub SCSI_DENSITY_HALFINCH_800 () {0x1;}' unless defined(&SCSI_DENSITY_HALFINCH_800);
    eval 'sub SCSI_DENSITY_HALFINCH_1600 () {0x2;}' unless defined(&SCSI_DENSITY_HALFINCH_1600);
    eval 'sub SCSI_DENSITY_HALFINCH_6250 () {0x3;}' unless defined(&SCSI_DENSITY_HALFINCH_6250);
    eval 'sub SCSI_DENSITY_HALFINCH_6250C () {0xc3;}' unless defined(&SCSI_DENSITY_HALFINCH_6250C);
    eval 'sub SCSI_DENSITY_QIC_11_4TRK () {0x4;}' unless defined(&SCSI_DENSITY_QIC_11_4TRK);
    eval 'sub SCSI_DENSITY_QIC_11_9TRK () {0x84;}' unless defined(&SCSI_DENSITY_QIC_11_9TRK);
    eval 'sub SCSI_DENSITY_QIC_24 () {0x5;}' unless defined(&SCSI_DENSITY_QIC_24);
    eval 'sub SCSI_DENSITY_HALFINCH_PE () {0x6;}' unless defined(&SCSI_DENSITY_HALFINCH_PE);
    eval 'sub SCSI_DENSITY_QIC_120 () {0xf;}' unless defined(&SCSI_DENSITY_QIC_120);
    eval 'sub SCSI_DENSITY_QIC_150 () {0x10;}' unless defined(&SCSI_DENSITY_QIC_150);
    eval 'sub SCSI_DENSITY_QIC_525_320 () {0x11;}' unless defined(&SCSI_DENSITY_QIC_525_320);
    eval 'sub SCSI_DENSITY_QIC_1320 () {0x12;}' unless defined(&SCSI_DENSITY_QIC_1320);
    eval 'sub SCSI_DENSITY_QIC_2GB () {0x22;}' unless defined(&SCSI_DENSITY_QIC_2GB);
    eval 'sub SCSI_DENSITY_QIC_4GB () {0x26;}' unless defined(&SCSI_DENSITY_QIC_4GB);
    eval 'sub SCSI_DENSITY_QIC_3080 () {0x29;}' unless defined(&SCSI_DENSITY_QIC_3080);
}
1;
