require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SCSI_SES_H_)) {
    eval 'sub _SCSI_SES_H_ () {1;}' unless defined(&_SCSI_SES_H_);
    require 'cam/scsi/scsi_all.ph';
    eval 'sub MK_ENUM {
        my($S, $F, $SUFFIX) = @_;
	    eval q($S   &_  $F  $SUFFIX);
    }' unless defined(&MK_ENUM);
    eval 'sub GEN_GETTER {
        my($LS, $US, $LF, $UF) = @_;
	    eval q( &static  &inline \'int\' $LS   &_get_  $LF(\'struct LS\' * &elem) {  &return (( ($elem->{bytes[MK_ENUM($US,$UF,_BYTE)]}) &  &MK_ENUM($US,$UF, &_MASK)) >>  &MK_ENUM($US,$UF, &_SHIFT)); });
    }' unless defined(&GEN_GETTER);
    eval 'sub GEN_SETTER {
        my($LS, $US, $LF, $UF) = @_;
	    eval q( &static  &inline  &void $LS   &_set_  $LF(\'struct LS\' * &elem, \'int\'  &val) {  ($elem->{bytes[MK_ENUM($US,$UF,_BYTE)]}) &= ~ &MK_ENUM($US,$UF, &_MASK);  ($elem->{bytes[MK_ENUM($US,$UF,_BYTE)]}) |= ( &val <<  &MK_ENUM($US,$UF, &_SHIFT)) &  &MK_ENUM($US,$UF, &_MASK); });
    }' unless defined(&GEN_SETTER);
    eval 'sub GEN_HDR_GETTER {
        my($LS, $US, $LF, $UF) = @_;
	    eval q( &static  &inline \'int\' $LS   &_get_  $LF(\'struct LS\' * &page) {  &return (( ($page->{hdr}->{page_specific_flags}) &  &MK_ENUM($US,$UF, &_MASK)) >>  &MK_ENUM($US,$UF, &_SHIFT)); });
    }' unless defined(&GEN_HDR_GETTER);
    eval 'sub GEN_HDR_SETTER {
        my($LS, $US, $LF, $UF) = @_;
	    eval q( &static  &inline  &void $LS   &_set_  $LF(\'struct LS\' * &page, \'int\'  &val) {  ($page->{hdr}->{page_specific_flags}) &= ~ &MK_ENUM($US,$UF, &_MASK);  ($page->{hdr}->{page_specific_flags}) |= ( &val <<  &MK_ENUM($US,$UF, &_SHIFT)) &  &MK_ENUM($US,$UF, &_MASK); });
    }' unless defined(&GEN_HDR_SETTER);
    eval 'sub GEN_ACCESSORS {
        my($LS, $US, $LF, $UF) = @_;
	    eval q( &GEN_GETTER($LS, $US, $LF, $UF)  &GEN_SETTER($LS, $US, $LF, $UF));
    }' unless defined(&GEN_ACCESSORS);
    eval 'sub GEN_HDR_ACCESSORS {
        my($LS, $US, $LF, $UF) = @_;
	    eval q( &GEN_HDR_GETTER($LS, $US, $LF, $UF)  &GEN_HDR_SETTER($LS, $US, $LF, $UF));
    }' unless defined(&GEN_HDR_ACCESSORS);
    eval 'sub ses_page_length {
        my($hdr) = @_;
	    eval q({ ( &scsi_2btoul( ($hdr->{length})) +  &offsetof(\'struct ses_page_hdr\',  &gen_code)); });
    }' unless defined(&ses_page_length);
    eval 'sub ses_enc_desc_last_byte {
        my($encdesc) = @_;
	    eval q({ ( ($encdesc->{length}) +  ($encdesc->{length})); });
    }' unless defined(&ses_enc_desc_last_byte);
    eval 'sub ses_enc_desc_next {
        my($encdesc) = @_;
	    eval q({ (( &ses_enc_desc_last_byte($encdesc) + 1)); });
    }' unless defined(&ses_enc_desc_next);
    eval 'sub ses_enc_desc_is_complete {
        my($encdesc,$last_buf_byte) = @_;
	    eval q({ ( ($encdesc->{length}) <= $last_buf_byte  &&  &ses_enc_desc_last_byte($encdesc) <= $last_buf_byte); });
    }' unless defined(&ses_enc_desc_is_complete);
    eval 'sub ses_cfg_page_get_num_subenc {
        my($page) = @_;
	    eval q({ ( ($page->{hdr}->{page_specific_flags}) + 1); });
    }' unless defined(&ses_cfg_page_get_num_subenc);
    eval("sub SES_CTRL_COMMON_SELECT_BYTE () { 0; }") unless defined(&SES_CTRL_COMMON_SELECT_BYTE);
    eval("sub SES_CTRL_COMMON_SELECT_MASK () { 0x80; }") unless defined(&SES_CTRL_COMMON_SELECT_MASK);
    eval("sub SES_CTRL_COMMON_SELECT_SHIFT () { 7; }") unless defined(&SES_CTRL_COMMON_SELECT_SHIFT);
    eval("sub SES_CTRL_COMMON_PRDFAIL_BYTE () { 0; }") unless defined(&SES_CTRL_COMMON_PRDFAIL_BYTE);
    eval("sub SES_CTRL_COMMON_PRDFAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_COMMON_PRDFAIL_MASK);
    eval("sub SES_CTRL_COMMON_PRDFAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_COMMON_PRDFAIL_SHIFT);
    eval("sub SES_CTRL_COMMON_DISABLE_BYTE () { 0; }") unless defined(&SES_CTRL_COMMON_DISABLE_BYTE);
    eval("sub SES_CTRL_COMMON_DISABLE_MASK () { 0x20; }") unless defined(&SES_CTRL_COMMON_DISABLE_MASK);
    eval("sub SES_CTRL_COMMON_DISABLE_SHIFT () { 5; }") unless defined(&SES_CTRL_COMMON_DISABLE_SHIFT);
    eval("sub SES_CTRL_COMMON_RST_SWAP_BYTE () { 0; }") unless defined(&SES_CTRL_COMMON_RST_SWAP_BYTE);
    eval("sub SES_CTRL_COMMON_RST_SWAP_MASK () { 0x10; }") unless defined(&SES_CTRL_COMMON_RST_SWAP_MASK);
    eval("sub SES_CTRL_COMMON_RST_SWAP_SHIFT () { 4; }") unless defined(&SES_CTRL_COMMON_RST_SWAP_SHIFT);
    eval 'sub GEN_SES_CTRL_COMMON_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_common,  &SES_CTRL_COMMON, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_COMMON_ACCESSORS);
    undef(&GEN_SES_CTRL_COMMON_ACCESSORS) if defined(&GEN_SES_CTRL_COMMON_ACCESSORS);
    eval("sub SES_CTRL_DEV_SLOT_RQST_ACTIVE_BYTE () { 1; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_ACTIVE_BYTE);
    eval("sub SES_CTRL_DEV_SLOT_RQST_ACTIVE_MASK () { 0x80; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_ACTIVE_MASK);
    eval("sub SES_CTRL_DEV_SLOT_RQST_ACTIVE_SHIFT () { 7; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_ACTIVE_SHIFT);
    eval("sub SES_CTRL_DEV_SLOT_DO_NOT_REMOVE_BYTE () { 1; }") unless defined(&SES_CTRL_DEV_SLOT_DO_NOT_REMOVE_BYTE);
    eval("sub SES_CTRL_DEV_SLOT_DO_NOT_REMOVE_MASK () { 0x40; }") unless defined(&SES_CTRL_DEV_SLOT_DO_NOT_REMOVE_MASK);
    eval("sub SES_CTRL_DEV_SLOT_DO_NOT_REMOVE_SHIFT () { 6; }") unless defined(&SES_CTRL_DEV_SLOT_DO_NOT_REMOVE_SHIFT);
    eval("sub SES_CTRL_DEV_SLOT_RQST_MISSING_BYTE () { 1; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_MISSING_BYTE);
    eval("sub SES_CTRL_DEV_SLOT_RQST_MISSING_MASK () { 0x10; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_MISSING_MASK);
    eval("sub SES_CTRL_DEV_SLOT_RQST_MISSING_SHIFT () { 4; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_MISSING_SHIFT);
    eval("sub SES_CTRL_DEV_SLOT_RQST_INSERT_BYTE () { 1; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_INSERT_BYTE);
    eval("sub SES_CTRL_DEV_SLOT_RQST_INSERT_MASK () { 0x08; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_INSERT_MASK);
    eval("sub SES_CTRL_DEV_SLOT_RQST_INSERT_SHIFT () { 3; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_INSERT_SHIFT);
    eval("sub SES_CTRL_DEV_SLOT_RQST_REMOVE_BYTE () { 1; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_REMOVE_BYTE);
    eval("sub SES_CTRL_DEV_SLOT_RQST_REMOVE_MASK () { 0x04; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_REMOVE_MASK);
    eval("sub SES_CTRL_DEV_SLOT_RQST_REMOVE_SHIFT () { 2; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_REMOVE_SHIFT);
    eval("sub SES_CTRL_DEV_SLOT_RQST_IDENT_BYTE () { 1; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_DEV_SLOT_RQST_IDENT_MASK () { 0x02; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_IDENT_MASK);
    eval("sub SES_CTRL_DEV_SLOT_RQST_IDENT_SHIFT () { 1; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_DEV_SLOT_RQST_FAULT_BYTE () { 2; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_FAULT_BYTE);
    eval("sub SES_CTRL_DEV_SLOT_RQST_FAULT_MASK () { 0x20; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_FAULT_MASK);
    eval("sub SES_CTRL_DEV_SLOT_RQST_FAULT_SHIFT () { 5; }") unless defined(&SES_CTRL_DEV_SLOT_RQST_FAULT_SHIFT);
    eval("sub SES_CTRL_DEV_SLOT_DEVICE_OFF_BYTE () { 2; }") unless defined(&SES_CTRL_DEV_SLOT_DEVICE_OFF_BYTE);
    eval("sub SES_CTRL_DEV_SLOT_DEVICE_OFF_MASK () { 0x10; }") unless defined(&SES_CTRL_DEV_SLOT_DEVICE_OFF_MASK);
    eval("sub SES_CTRL_DEV_SLOT_DEVICE_OFF_SHIFT () { 4; }") unless defined(&SES_CTRL_DEV_SLOT_DEVICE_OFF_SHIFT);
    eval("sub SES_CTRL_DEV_SLOT_ENABLE_BYP_A_BYTE () { 2; }") unless defined(&SES_CTRL_DEV_SLOT_ENABLE_BYP_A_BYTE);
    eval("sub SES_CTRL_DEV_SLOT_ENABLE_BYP_A_MASK () { 0x08; }") unless defined(&SES_CTRL_DEV_SLOT_ENABLE_BYP_A_MASK);
    eval("sub SES_CTRL_DEV_SLOT_ENABLE_BYP_A_SHIFT () { 3; }") unless defined(&SES_CTRL_DEV_SLOT_ENABLE_BYP_A_SHIFT);
    eval("sub SES_CTRL_DEV_SLOT_ENABLE_BYP_B_BYTE () { 2; }") unless defined(&SES_CTRL_DEV_SLOT_ENABLE_BYP_B_BYTE);
    eval("sub SES_CTRL_DEV_SLOT_ENABLE_BYP_B_MASK () { 0x04; }") unless defined(&SES_CTRL_DEV_SLOT_ENABLE_BYP_B_MASK);
    eval("sub SES_CTRL_DEV_SLOT_ENABLE_BYP_B_SHIFT () { 2; }") unless defined(&SES_CTRL_DEV_SLOT_ENABLE_BYP_B_SHIFT);
    eval 'sub GEN_SES_CTRL_DEV_SLOT_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_dev_slot,  &SES_CTRL_DEV_SLOT, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_DEV_SLOT_ACCESSORS);
    undef(&GEN_SES_CTRL_DEV_SLOT_ACCESSORS) if defined(&GEN_SES_CTRL_DEV_SLOT_ACCESSORS);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_OK_BYTE () { 0; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_OK_BYTE);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_OK_MASK () { 0x80; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_OK_MASK);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_OK_SHIFT () { 7; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_OK_SHIFT);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_RSVD_DEVICE_BYTE () { 0; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_RSVD_DEVICE_BYTE);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_RSVD_DEVICE_MASK () { 0x40; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_RSVD_DEVICE_MASK);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_RSVD_DEVICE_SHIFT () { 6; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_RSVD_DEVICE_SHIFT);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_HOT_SPARE_BYTE () { 0; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_HOT_SPARE_BYTE);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_HOT_SPARE_MASK () { 0x20; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_HOT_SPARE_MASK);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_HOT_SPARE_SHIFT () { 5; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_HOT_SPARE_SHIFT);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_CONS_CHECK_BYTE () { 0; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_CONS_CHECK_BYTE);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_CONS_CHECK_MASK () { 0x10; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_CONS_CHECK_MASK);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_CONS_CHECK_SHIFT () { 4; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_CONS_CHECK_SHIFT);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_CRIT_ARRAY_BYTE () { 0; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_CRIT_ARRAY_BYTE);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_CRIT_ARRAY_MASK () { 0x08; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_CRIT_ARRAY_MASK);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_CRIT_ARRAY_SHIFT () { 3; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_CRIT_ARRAY_SHIFT);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_FAILED_ARRAY_BYTE () { 0; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_FAILED_ARRAY_BYTE);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_FAILED_ARRAY_MASK () { 0x04; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_FAILED_ARRAY_MASK);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_FAILED_ARRAY_SHIFT () { 2; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_IN_FAILED_ARRAY_SHIFT);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_BYTE () { 0; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_BYTE);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_MASK () { 0x02; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_MASK);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_SHIFT () { 1; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_SHIFT);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_ABORT_BYTE () { 0; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_ABORT_BYTE);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_ABORT_MASK () { 0x01; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_ABORT_MASK);
    eval("sub SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_ABORT_SHIFT () { 0; }") unless defined(&SES_CTRL_ARRAY_DEV_SLOT_RQST_REBUILD_REMAP_ABORT_SHIFT);
    eval 'sub GEN_SES_CTRL_ARRAY_DEV_SLOT_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_array_dev_slot,  &SES_CTRL_ARRAY_DEV_SLOT, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_ARRAY_DEV_SLOT_ACCESSORS);
    undef(&GEN_SES_CTRL_ARRAY_DEV_SLOT_ACCESSORS) if defined(&GEN_SES_CTRL_ARRAY_DEV_SLOT_ACCESSORS);
    eval("sub SES_CTRL_POWER_SUPPLY_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_POWER_SUPPLY_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_POWER_SUPPLY_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_POWER_SUPPLY_RQST_IDENT_MASK);
    eval("sub SES_CTRL_POWER_SUPPLY_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_POWER_SUPPLY_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_POWER_SUPPLY_RQST_FAIL_BYTE () { 2; }") unless defined(&SES_CTRL_POWER_SUPPLY_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_POWER_SUPPLY_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_POWER_SUPPLY_RQST_FAIL_MASK);
    eval("sub SES_CTRL_POWER_SUPPLY_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_POWER_SUPPLY_RQST_FAIL_SHIFT);
    eval("sub SES_CTRL_POWER_SUPPLY_RQST_ON_BYTE () { 2; }") unless defined(&SES_CTRL_POWER_SUPPLY_RQST_ON_BYTE);
    eval("sub SES_CTRL_POWER_SUPPLY_RQST_ON_MASK () { 0x20; }") unless defined(&SES_CTRL_POWER_SUPPLY_RQST_ON_MASK);
    eval("sub SES_CTRL_POWER_SUPPLY_RQST_ON_SHIFT () { 5; }") unless defined(&SES_CTRL_POWER_SUPPLY_RQST_ON_SHIFT);
    eval 'sub GEN_SES_CTRL_POWER_SUPPLY_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_power_supply,  &SES_CTRL_POWER_SUPPLY, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_POWER_SUPPLY_ACCESSORS);
    undef(&GEN_SES_CTRL_POWER_SUPPLY_ACCESSORS) if defined(&GEN_SES_CTRL_POWER_SUPPLY_ACCESSORS);
    eval("sub SES_CTRL_COOLING_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_COOLING_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_COOLING_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_COOLING_RQST_IDENT_MASK);
    eval("sub SES_CTRL_COOLING_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_COOLING_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_COOLING_RQST_FAIL_BYTE () { 2; }") unless defined(&SES_CTRL_COOLING_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_COOLING_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_COOLING_RQST_FAIL_MASK);
    eval("sub SES_CTRL_COOLING_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_COOLING_RQST_FAIL_SHIFT);
    eval("sub SES_CTRL_COOLING_RQST_ON_BYTE () { 2; }") unless defined(&SES_CTRL_COOLING_RQST_ON_BYTE);
    eval("sub SES_CTRL_COOLING_RQST_ON_MASK () { 0x20; }") unless defined(&SES_CTRL_COOLING_RQST_ON_MASK);
    eval("sub SES_CTRL_COOLING_RQST_ON_SHIFT () { 5; }") unless defined(&SES_CTRL_COOLING_RQST_ON_SHIFT);
    eval("sub SES_CTRL_COOLING_RQSTED_SPEED_CODE_BYTE () { 2; }") unless defined(&SES_CTRL_COOLING_RQSTED_SPEED_CODE_BYTE);
    eval("sub SES_CTRL_COOLING_RQSTED_SPEED_CODE_MASK () { 0x07; }") unless defined(&SES_CTRL_COOLING_RQSTED_SPEED_CODE_MASK);
    eval("sub SES_CTRL_COOLING_RQSTED_SPEED_CODE_SHIFT () { 2; }") unless defined(&SES_CTRL_COOLING_RQSTED_SPEED_CODE_SHIFT);
    eval("sub SES_CTRL_COOLING_RQSTED_SPEED_CODE_UNCHANGED () { 0x00; }") unless defined(&SES_CTRL_COOLING_RQSTED_SPEED_CODE_UNCHANGED);
    eval("sub SES_CTRL_COOLING_RQSTED_SPEED_CODE_LOWEST () { 0x01; }") unless defined(&SES_CTRL_COOLING_RQSTED_SPEED_CODE_LOWEST);
    eval("sub SES_CTRL_COOLING_RQSTED_SPEED_CODE_HIGHEST () { 0x07; }") unless defined(&SES_CTRL_COOLING_RQSTED_SPEED_CODE_HIGHEST);
    eval 'sub GEN_SES_CTRL_COOLING_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_cooling,  &SES_CTRL_COOLING, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_COOLING_ACCESSORS);
    undef(&GEN_SES_CTRL_COOLING_ACCESSORS) if defined(&GEN_SES_CTRL_COOLING_ACCESSORS);
    eval("sub SES_CTRL_TEMP_SENSOR_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_TEMP_SENSOR_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_TEMP_SENSOR_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_TEMP_SENSOR_RQST_IDENT_MASK);
    eval("sub SES_CTRL_TEMP_SENSOR_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_TEMP_SENSOR_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_TEMP_SENSOR_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_TEMP_SENSOR_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_TEMP_SENSOR_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_TEMP_SENSOR_RQST_FAIL_MASK);
    eval("sub SES_CTRL_TEMP_SENSOR_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_TEMP_SENSOR_RQST_FAIL_SHIFT);
    eval 'sub GEN_SES_CTRL_TEMP_SENSOR_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_temp_sensor,  &SES_CTRL_TEMP_SENSOR, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_TEMP_SENSOR_ACCESSORS);
    undef(&GEN_SES_CTRL_TEMP_SENSOR_ACCESSORS) if defined(&GEN_SES_CTRL_TEMP_SENSOR_ACCESSORS);
    eval("sub SES_CTRL_DOOR_LOCK_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_DOOR_LOCK_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_DOOR_LOCK_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_DOOR_LOCK_RQST_IDENT_MASK);
    eval("sub SES_CTRL_DOOR_LOCK_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_DOOR_LOCK_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_DOOR_LOCK_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_DOOR_LOCK_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_DOOR_LOCK_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_DOOR_LOCK_RQST_FAIL_MASK);
    eval("sub SES_CTRL_DOOR_LOCK_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_DOOR_LOCK_RQST_FAIL_SHIFT);
    eval("sub SES_CTRL_DOOR_LOCK_UNLOCK_BYTE () { 2; }") unless defined(&SES_CTRL_DOOR_LOCK_UNLOCK_BYTE);
    eval("sub SES_CTRL_DOOR_LOCK_UNLOCK_MASK () { 0x01; }") unless defined(&SES_CTRL_DOOR_LOCK_UNLOCK_MASK);
    eval("sub SES_CTRL_DOOR_LOCK_UNLOCK_SHIFT () { 0; }") unless defined(&SES_CTRL_DOOR_LOCK_UNLOCK_SHIFT);
    eval 'sub GEN_SES_CTRL_DOOR_LOCK_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_door_lock,  &SES_CTRL_DOOR_LOCK, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_DOOR_LOCK_ACCESSORS);
    undef(&GEN_SES_CTRL_DOOR_LOCK_ACCESSORS) if defined(&GEN_SES_CTRL_DOOR_LOCK_ACCESSORS);
    eval("sub SES_CTRL_AUDIBLE_ALARM_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_AUDIBLE_ALARM_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_RQST_IDENT_MASK);
    eval("sub SES_CTRL_AUDIBLE_ALARM_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_AUDIBLE_ALARM_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_AUDIBLE_ALARM_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_RQST_FAIL_MASK);
    eval("sub SES_CTRL_AUDIBLE_ALARM_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_RQST_FAIL_SHIFT);
    eval("sub SES_CTRL_AUDIBLE_ALARM_SET_MUTE_BYTE () { 2; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_SET_MUTE_BYTE);
    eval("sub SES_CTRL_AUDIBLE_ALARM_SET_MUTE_MASK () { 0x40; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_SET_MUTE_MASK);
    eval("sub SES_CTRL_AUDIBLE_ALARM_SET_MUTE_SHIFT () { 6; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_SET_MUTE_SHIFT);
    eval("sub SES_CTRL_AUDIBLE_ALARM_SET_REMIND_BYTE () { 2; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_SET_REMIND_BYTE);
    eval("sub SES_CTRL_AUDIBLE_ALARM_SET_REMIND_MASK () { 0x10; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_SET_REMIND_MASK);
    eval("sub SES_CTRL_AUDIBLE_ALARM_SET_REMIND_SHIFT () { 4; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_SET_REMIND_SHIFT);
    eval("sub SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_BYTE () { 2; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_BYTE);
    eval("sub SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_MASK () { 0x0F; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_MASK);
    eval("sub SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_SHIFT () { 0; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_SHIFT);
    eval("sub SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_INFO () { 0x08; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_INFO);
    eval("sub SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_NON_CRIT () { 0x04; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_NON_CRIT);
    eval("sub SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_CRIT () { 0x02; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_CRIT);
    eval("sub SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_UNRECOV () { 0x01; }") unless defined(&SES_CTRL_AUDIBLE_ALARM_TONE_CONTROL_UNRECOV);
    eval 'sub GEN_SES_CTRL_AUDIBLE_ALARM_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_audible_alarm,  &SES_CTRL_AUDIBLE_ALARM, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_AUDIBLE_ALARM_ACCESSORS);
    undef(&GEN_SES_CTRL_AUDIBLE_ALARM_ACCESSORS) if defined(&GEN_SES_CTRL_AUDIBLE_ALARM_ACCESSORS);
    eval("sub SES_CTRL_ECC_ELECTRONICS_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_ECC_ELECTRONICS_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_ECC_ELECTRONICS_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_ECC_ELECTRONICS_RQST_IDENT_MASK);
    eval("sub SES_CTRL_ECC_ELECTRONICS_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_ECC_ELECTRONICS_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_ECC_ELECTRONICS_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_ECC_ELECTRONICS_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_ECC_ELECTRONICS_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_ECC_ELECTRONICS_RQST_FAIL_MASK);
    eval("sub SES_CTRL_ECC_ELECTRONICS_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_ECC_ELECTRONICS_RQST_FAIL_SHIFT);
    eval("sub SES_CTRL_ECC_ELECTRONICS_SELECT_ELEMENT_BYTE () { 1; }") unless defined(&SES_CTRL_ECC_ELECTRONICS_SELECT_ELEMENT_BYTE);
    eval("sub SES_CTRL_ECC_ELECTRONICS_SELECT_ELEMENT_MASK () { 0x01; }") unless defined(&SES_CTRL_ECC_ELECTRONICS_SELECT_ELEMENT_MASK);
    eval("sub SES_CTRL_ECC_ELECTRONICS_SELECT_ELEMENT_SHIFT () { 0; }") unless defined(&SES_CTRL_ECC_ELECTRONICS_SELECT_ELEMENT_SHIFT);
    eval 'sub GEN_SES_CTRL_ECC_ELECTRONICS_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_ecc_electronics,  &SES_CTRL_ECC_ELECTRONICS, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_ECC_ELECTRONICS_ACCESSORS);
    undef(&GEN_SES_CTRL_ECC_ELECTRONICS_ACCESSORS) if defined(&GEN_SES_CTRL_ECC_ELECTRONICS_ACCESSORS);
    eval("sub SES_CTRL_SCC_ELECTRONICS_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_SCC_ELECTRONICS_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_SCC_ELECTRONICS_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_SCC_ELECTRONICS_RQST_IDENT_MASK);
    eval("sub SES_CTRL_SCC_ELECTRONICS_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_SCC_ELECTRONICS_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_SCC_ELECTRONICS_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_SCC_ELECTRONICS_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_SCC_ELECTRONICS_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_SCC_ELECTRONICS_RQST_FAIL_MASK);
    eval("sub SES_CTRL_SCC_ELECTRONICS_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_SCC_ELECTRONICS_RQST_FAIL_SHIFT);
    eval 'sub GEN_SES_CTRL_SCC_ELECTRONICS_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_scc_electronics,  &SES_CTRL_SCC_ELECTRONICS, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_SCC_ELECTRONICS_ACCESSORS);
    undef(&GEN_SES_CTRL_SCC_ELECTRONICS_ACCESSORS) if defined(&GEN_SES_CTRL_SCC_ELECTRONICS_ACCESSORS);
    eval("sub SES_CTRL_NV_CACHE_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_NV_CACHE_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_NV_CACHE_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_NV_CACHE_RQST_IDENT_MASK);
    eval("sub SES_CTRL_NV_CACHE_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_NV_CACHE_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_NV_CACHE_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_NV_CACHE_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_NV_CACHE_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_NV_CACHE_RQST_FAIL_MASK);
    eval("sub SES_CTRL_NV_CACHE_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_NV_CACHE_RQST_FAIL_SHIFT);
    eval 'sub GEN_SES_CTRL_NV_CACHE_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_nv_cache,  &SES_CTRL_NV_CACHE, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_NV_CACHE_ACCESSORS);
    undef(&GEN_SES_CTRL_NV_CACHE_ACCESSORS) if defined(&GEN_SES_CTRL_NV_CACHE_ACCESSORS);
    eval("sub SES_CTRL_UPS_RQST_IDENT_BYTE () { 2; }") unless defined(&SES_CTRL_UPS_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_UPS_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_UPS_RQST_IDENT_MASK);
    eval("sub SES_CTRL_UPS_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_UPS_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_UPS_RQST_FAIL_BYTE () { 2; }") unless defined(&SES_CTRL_UPS_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_UPS_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_UPS_RQST_FAIL_MASK);
    eval("sub SES_CTRL_UPS_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_UPS_RQST_FAIL_SHIFT);
    eval 'sub GEN_SES_CTRL_UPS_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_ups,  &SES_CTRL_UPS, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_UPS_ACCESSORS);
    undef(&GEN_SES_CTRL_UPS_ACCESSORS) if defined(&GEN_SES_CTRL_UPS_ACCESSORS);
    eval("sub SES_CTRL_DISPLAY_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_DISPLAY_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_DISPLAY_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_DISPLAY_RQST_IDENT_MASK);
    eval("sub SES_CTRL_DISPLAY_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_DISPLAY_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_DISPLAY_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_DISPLAY_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_DISPLAY_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_DISPLAY_RQST_FAIL_MASK);
    eval("sub SES_CTRL_DISPLAY_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_DISPLAY_RQST_FAIL_SHIFT);
    eval("sub SES_CTRL_DISPLAY_DISPLAY_MODE_BYTE () { 0; }") unless defined(&SES_CTRL_DISPLAY_DISPLAY_MODE_BYTE);
    eval("sub SES_CTRL_DISPLAY_DISPLAY_MODE_MASK () { 0x03; }") unless defined(&SES_CTRL_DISPLAY_DISPLAY_MODE_MASK);
    eval("sub SES_CTRL_DISPLAY_DISPLAY_MODE_SHIFT () { 6; }") unless defined(&SES_CTRL_DISPLAY_DISPLAY_MODE_SHIFT);
    eval("sub SES_CTRL_DISPLAY_DISPLAY_MODE_UNCHANGED () { 0x0; }") unless defined(&SES_CTRL_DISPLAY_DISPLAY_MODE_UNCHANGED);
    eval("sub SES_CTRL_DISPLAY_DISPLAY_MODE_ESP () { 0x1; }") unless defined(&SES_CTRL_DISPLAY_DISPLAY_MODE_ESP);
    eval("sub SES_CTRL_DISPLAY_DISPLAY_MODE_DC_FIELD () { 0x2; }") unless defined(&SES_CTRL_DISPLAY_DISPLAY_MODE_DC_FIELD);
    eval 'sub GEN_SES_CTRL_DISPLAY_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_display,  &SES_CTRL_DISPLAY, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_DISPLAY_ACCESSORS);
    undef(&GEN_SES_CTRL_DISPLAY_ACCESSORS) if defined(&GEN_SES_CTRL_DISPLAY_ACCESSORS);
    eval("sub SES_CTRL_KEY_PAD_ENTRY_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_KEY_PAD_ENTRY_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_KEY_PAD_ENTRY_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_KEY_PAD_ENTRY_RQST_IDENT_MASK);
    eval("sub SES_CTRL_KEY_PAD_ENTRY_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_KEY_PAD_ENTRY_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_KEY_PAD_ENTRY_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_KEY_PAD_ENTRY_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_KEY_PAD_ENTRY_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_KEY_PAD_ENTRY_RQST_FAIL_MASK);
    eval("sub SES_CTRL_KEY_PAD_ENTRY_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_KEY_PAD_ENTRY_RQST_FAIL_SHIFT);
    eval 'sub GEN_SES_CTRL_KEY_PAD_ENTRY_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_key_pad_entry,  &SES_CTRL_KEY_PAD_ENTRY, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_KEY_PAD_ENTRY_ACCESSORS);
    undef(&GEN_SES_CTRL_KEY_PAD_ENTRY_ACCESSORS) if defined(&GEN_SES_CTRL_KEY_PAD_ENTRY_ACCESSORS);
    eval("sub SES_CTRL_ENCLOSURE_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_ENCLOSURE_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_ENCLOSURE_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_ENCLOSURE_RQST_IDENT_MASK);
    eval("sub SES_CTRL_ENCLOSURE_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_ENCLOSURE_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_BYTE () { 1; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_BYTE);
    eval("sub SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_MASK () { 0xC0; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_MASK);
    eval("sub SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_SHIFT () { 6; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_SHIFT);
    eval("sub SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_NONE () { 0x0; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_NONE);
    eval("sub SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_AFTER_DELAY () { 0x1; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_AFTER_DELAY);
    eval("sub SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_CANCEL () { 0x2; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_CYCLE_RQST_CANCEL);
    eval("sub SES_CTRL_ENCLOSURE_POWER_CYCLE_DELAY_BYTE () { 1; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_CYCLE_DELAY_BYTE);
    eval("sub SES_CTRL_ENCLOSURE_POWER_CYCLE_DELAY_MASK () { 0x3F; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_CYCLE_DELAY_MASK);
    eval("sub SES_CTRL_ENCLOSURE_POWER_CYCLE_DELAY_SHIFT () { 0; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_CYCLE_DELAY_SHIFT);
    eval("sub SES_CTRL_ENCLOSURE_POWER_CYCLE_DELAY_MAX () { 60; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_CYCLE_DELAY_MAX);
    eval("sub SES_CTRL_ENCLOSURE_POWER_OFF_DURATION_BYTE () { 2; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_OFF_DURATION_BYTE);
    eval("sub SES_CTRL_ENCLOSURE_POWER_OFF_DURATION_MASK () { 0xFC; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_OFF_DURATION_MASK);
    eval("sub SES_CTRL_ENCLOSURE_POWER_OFF_DURATION_SHIFT () { 2; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_OFF_DURATION_SHIFT);
    eval("sub SES_CTRL_ENCLOSURE_POWER_OFF_DURATION_MAX_AUTO () { 60; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_OFF_DURATION_MAX_AUTO);
    eval("sub SES_CTRL_ENCLOSURE_POWER_OFF_DURATION_MANUAL () { 63; }") unless defined(&SES_CTRL_ENCLOSURE_POWER_OFF_DURATION_MANUAL);
    eval("sub SES_CTRL_ENCLOSURE_RQST_FAIL_BYTE () { 2; }") unless defined(&SES_CTRL_ENCLOSURE_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_ENCLOSURE_RQST_FAIL_MASK () { 0x02; }") unless defined(&SES_CTRL_ENCLOSURE_RQST_FAIL_MASK);
    eval("sub SES_CTRL_ENCLOSURE_RQST_FAIL_SHIFT () { 1; }") unless defined(&SES_CTRL_ENCLOSURE_RQST_FAIL_SHIFT);
    eval("sub SES_CTRL_ENCLOSURE_RQST_WARN_BYTE () { 2; }") unless defined(&SES_CTRL_ENCLOSURE_RQST_WARN_BYTE);
    eval("sub SES_CTRL_ENCLOSURE_RQST_WARN_MASK () { 0x01; }") unless defined(&SES_CTRL_ENCLOSURE_RQST_WARN_MASK);
    eval("sub SES_CTRL_ENCLOSURE_RQST_WARN_SHIFT () { 0; }") unless defined(&SES_CTRL_ENCLOSURE_RQST_WARN_SHIFT);
    eval 'sub GEN_SES_CTRL_ENCLOSURE_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_enclosure,  &SES_CTRL_ENCLOSURE, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_ENCLOSURE_ACCESSORS);
    undef(&GEN_SES_CTRL_ENCLOSURE_ACCESSORS) if defined(&GEN_SES_CTRL_ENCLOSURE_ACCESSORS);
    eval("sub SES_CTRL_SCSI_PORT_OR_XCVR_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_SCSI_PORT_OR_XCVR_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_SCSI_PORT_OR_XCVR_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_SCSI_PORT_OR_XCVR_RQST_IDENT_MASK);
    eval("sub SES_CTRL_SCSI_PORT_OR_XCVR_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_SCSI_PORT_OR_XCVR_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_SCSI_PORT_OR_XCVR_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_SCSI_PORT_OR_XCVR_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_SCSI_PORT_OR_XCVR_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_SCSI_PORT_OR_XCVR_RQST_FAIL_MASK);
    eval("sub SES_CTRL_SCSI_PORT_OR_XCVR_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_SCSI_PORT_OR_XCVR_RQST_FAIL_SHIFT);
    eval("sub SES_CTRL_SCSI_PORT_OR_XCVR_DISABLE_BYTE () { 2; }") unless defined(&SES_CTRL_SCSI_PORT_OR_XCVR_DISABLE_BYTE);
    eval("sub SES_CTRL_SCSI_PORT_OR_XCVR_DISABLE_MASK () { 0x10; }") unless defined(&SES_CTRL_SCSI_PORT_OR_XCVR_DISABLE_MASK);
    eval("sub SES_CTRL_SCSI_PORT_OR_XCVR_DISABLE_SHIFT () { 4; }") unless defined(&SES_CTRL_SCSI_PORT_OR_XCVR_DISABLE_SHIFT);
    eval 'sub GEN_SES_CTRL_SCSI_PORT_OR_XCVR_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_scsi_port_or_xcvr,  &SES_CTRL_SCSI_PORT_OR_XCVR, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_SCSI_PORT_OR_XCVR_ACCESSORS);
    undef(&GEN_SES_CTRL_SCSI_PORT_OR_XCVR_ACCESSORS) if defined(&GEN_SES_CTRL_SCSI_PORT_OR_XCVR_ACCESSORS);
    eval("sub SES_CTRL_LANGUAGE_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_LANGUAGE_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_LANGUAGE_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_LANGUAGE_RQST_IDENT_MASK);
    eval("sub SES_CTRL_LANGUAGE_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_LANGUAGE_RQST_IDENT_SHIFT);
    eval 'sub GEN_SES_CTRL_LANGUAGE_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_language,  &SES_CTRL_LANGUAGE, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_LANGUAGE_ACCESSORS);
    undef(&GEN_SES_CTRL_LANGUAGE_ACCESSORS) if defined(&GEN_SES_CTRL_LANGUAGE_ACCESSORS);
    eval("sub SES_CTRL_COMM_PORT_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_COMM_PORT_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_COMM_PORT_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_COMM_PORT_RQST_IDENT_MASK);
    eval("sub SES_CTRL_COMM_PORT_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_COMM_PORT_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_COMM_PORT_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_COMM_PORT_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_COMM_PORT_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_COMM_PORT_RQST_FAIL_MASK);
    eval("sub SES_CTRL_COMM_PORT_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_COMM_PORT_RQST_FAIL_SHIFT);
    eval("sub SES_CTRL_COMM_PORT_DISABLE_BYTE () { 2; }") unless defined(&SES_CTRL_COMM_PORT_DISABLE_BYTE);
    eval("sub SES_CTRL_COMM_PORT_DISABLE_MASK () { 0x01; }") unless defined(&SES_CTRL_COMM_PORT_DISABLE_MASK);
    eval("sub SES_CTRL_COMM_PORT_DISABLE_SHIFT () { 0; }") unless defined(&SES_CTRL_COMM_PORT_DISABLE_SHIFT);
    eval 'sub GEN_SES_CTRL_COMM_PORT_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_comm_port,  &SES_CTRL_COMM_PORT, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_COMM_PORT_ACCESSORS);
    undef(&GEN_SES_CTRL_COMM_PORT_ACCESSORS) if defined(&GEN_SES_CTRL_COMM_PORT_ACCESSORS);
    eval("sub SES_CTRL_VOLTAGE_SENSOR_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_VOLTAGE_SENSOR_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_VOLTAGE_SENSOR_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_VOLTAGE_SENSOR_RQST_IDENT_MASK);
    eval("sub SES_CTRL_VOLTAGE_SENSOR_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_VOLTAGE_SENSOR_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_VOLTAGE_SENSOR_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_VOLTAGE_SENSOR_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_VOLTAGE_SENSOR_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_VOLTAGE_SENSOR_RQST_FAIL_MASK);
    eval("sub SES_CTRL_VOLTAGE_SENSOR_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_VOLTAGE_SENSOR_RQST_FAIL_SHIFT);
    eval 'sub GEN_SES_CTRL_VOLTAGE_SENSOR_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_voltage_sensor,  &SES_CTRL_VOLTAGE_SENSOR, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_VOLTAGE_SENSOR_ACCESSORS);
    undef(&GEN_SES_CTRL_VOLTAGE_SENSOR_ACCESSORS) if defined(&GEN_SES_CTRL_VOLTAGE_SENSOR_ACCESSORS);
    eval("sub SES_CTRL_CURRENT_SENSOR_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_CURRENT_SENSOR_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_CURRENT_SENSOR_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_CURRENT_SENSOR_RQST_IDENT_MASK);
    eval("sub SES_CTRL_CURRENT_SENSOR_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_CURRENT_SENSOR_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_CURRENT_SENSOR_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_CURRENT_SENSOR_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_CURRENT_SENSOR_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_CURRENT_SENSOR_RQST_FAIL_MASK);
    eval("sub SES_CTRL_CURRENT_SENSOR_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_CURRENT_SENSOR_RQST_FAIL_SHIFT);
    eval 'sub GEN_SES_CTRL_CURRENT_SENSOR_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_current_sensor,  &SES_CTRL_CURRENT_SENSOR, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_CURRENT_SENSOR_ACCESSORS);
    undef(&GEN_SES_CTRL_CURRENT_SENSOR_ACCESSORS) if defined(&GEN_SES_CTRL_CURRENT_SENSOR_ACCESSORS);
    eval("sub SES_CTRL_TARGET_PORT_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_TARGET_PORT_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_TARGET_PORT_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_TARGET_PORT_RQST_IDENT_MASK);
    eval("sub SES_CTRL_TARGET_PORT_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_TARGET_PORT_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_TARGET_PORT_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_TARGET_PORT_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_TARGET_PORT_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_TARGET_PORT_RQST_FAIL_MASK);
    eval("sub SES_CTRL_TARGET_PORT_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_TARGET_PORT_RQST_FAIL_SHIFT);
    eval("sub SES_CTRL_TARGET_PORT_ENABLE_BYTE () { 2; }") unless defined(&SES_CTRL_TARGET_PORT_ENABLE_BYTE);
    eval("sub SES_CTRL_TARGET_PORT_ENABLE_MASK () { 0x01; }") unless defined(&SES_CTRL_TARGET_PORT_ENABLE_MASK);
    eval("sub SES_CTRL_TARGET_PORT_ENABLE_SHIFT () { 0; }") unless defined(&SES_CTRL_TARGET_PORT_ENABLE_SHIFT);
    eval 'sub GEN_SES_CTRL_TARGET_PORT_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_target_port,  &SES_CTRL_TARGET_PORT, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_TARGET_PORT_ACCESSORS);
    undef(&GEN_SES_CTRL_TARGET_PORT_ACCESSORS) if defined(&GEN_SES_CTRL_TARGET_PORT_ACCESSORS);
    eval("sub SES_CTRL_INITIATOR_PORT_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_INITIATOR_PORT_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_INITIATOR_PORT_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_INITIATOR_PORT_RQST_IDENT_MASK);
    eval("sub SES_CTRL_INITIATOR_PORT_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_INITIATOR_PORT_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_INITIATOR_PORT_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_INITIATOR_PORT_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_INITIATOR_PORT_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_INITIATOR_PORT_RQST_FAIL_MASK);
    eval("sub SES_CTRL_INITIATOR_PORT_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_INITIATOR_PORT_RQST_FAIL_SHIFT);
    eval("sub SES_CTRL_INITIATOR_PORT_ENABLE_BYTE () { 2; }") unless defined(&SES_CTRL_INITIATOR_PORT_ENABLE_BYTE);
    eval("sub SES_CTRL_INITIATOR_PORT_ENABLE_MASK () { 0x01; }") unless defined(&SES_CTRL_INITIATOR_PORT_ENABLE_MASK);
    eval("sub SES_CTRL_INITIATOR_PORT_ENABLE_SHIFT () { 0; }") unless defined(&SES_CTRL_INITIATOR_PORT_ENABLE_SHIFT);
    eval 'sub GEN_SES_CTRL_INITIATOR_PORT_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_initiator_port,  &SES_CTRL_INITIATOR_PORT, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_INITIATOR_PORT_ACCESSORS);
    undef(&GEN_SES_CTRL_INITIATOR_PORT_ACCESSORS) if defined(&GEN_SES_CTRL_INITIATOR_PORT_ACCESSORS);
    eval("sub SES_CTRL_SIMPlE_SUBSES_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_SIMPlE_SUBSES_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_SIMPlE_SUBSES_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_SIMPlE_SUBSES_RQST_IDENT_MASK);
    eval("sub SES_CTRL_SIMPlE_SUBSES_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_SIMPlE_SUBSES_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_SIMPlE_SUBSES_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_SIMPlE_SUBSES_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_SIMPlE_SUBSES_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_SIMPlE_SUBSES_RQST_FAIL_MASK);
    eval("sub SES_CTRL_SIMPlE_SUBSES_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_SIMPlE_SUBSES_RQST_FAIL_SHIFT);
    eval 'sub GEN_SES_CTRL_SIMPlE_SUBSES_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_simple_subenc,  &SES_CTRL_SIMPlE_SUBSES, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_SIMPlE_SUBSES_ACCESSORS);
    undef(&GEN_SES_CTRL_SIMPlE_SUBSES_ACCESSORS) if defined(&GEN_SES_CTRL_SIMPlE_SUBSES_ACCESSORS);
    eval("sub SES_CTRL_SAS_EXPANDER_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_SAS_EXPANDER_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_SAS_EXPANDER_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_SAS_EXPANDER_RQST_IDENT_MASK);
    eval("sub SES_CTRL_SAS_EXPANDER_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_SAS_EXPANDER_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_SAS_EXPANDER_RQST_FAIL_BYTE () { 0; }") unless defined(&SES_CTRL_SAS_EXPANDER_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_SAS_EXPANDER_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_SAS_EXPANDER_RQST_FAIL_MASK);
    eval("sub SES_CTRL_SAS_EXPANDER_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_SAS_EXPANDER_RQST_FAIL_SHIFT);
    eval 'sub GEN_SES_CTRL_SAS_EXPANDER_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_sas_expander,  &SES_CTRL_SAS_EXPANDER, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_SAS_EXPANDER_ACCESSORS);
    undef(&GEN_SES_CTRL_SAS_EXPANDER_ACCESSORS) if defined(&GEN_SES_CTRL_SAS_EXPANDER_ACCESSORS);
    eval("sub SES_CTRL_SAS_CONNECTOR_RQST_IDENT_BYTE () { 0; }") unless defined(&SES_CTRL_SAS_CONNECTOR_RQST_IDENT_BYTE);
    eval("sub SES_CTRL_SAS_CONNECTOR_RQST_IDENT_MASK () { 0x80; }") unless defined(&SES_CTRL_SAS_CONNECTOR_RQST_IDENT_MASK);
    eval("sub SES_CTRL_SAS_CONNECTOR_RQST_IDENT_SHIFT () { 7; }") unless defined(&SES_CTRL_SAS_CONNECTOR_RQST_IDENT_SHIFT);
    eval("sub SES_CTRL_SAS_CONNECTOR_RQST_FAIL_BYTE () { 2; }") unless defined(&SES_CTRL_SAS_CONNECTOR_RQST_FAIL_BYTE);
    eval("sub SES_CTRL_SAS_CONNECTOR_RQST_FAIL_MASK () { 0x40; }") unless defined(&SES_CTRL_SAS_CONNECTOR_RQST_FAIL_MASK);
    eval("sub SES_CTRL_SAS_CONNECTOR_RQST_FAIL_SHIFT () { 6; }") unless defined(&SES_CTRL_SAS_CONNECTOR_RQST_FAIL_SHIFT);
    eval 'sub GEN_SES_CTRL_SAS_CONNECTOR_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_ACCESSORS( &ses_ctrl_sas_connector,  &SES_CTRL_SAS_CONNECTOR, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_SAS_CONNECTOR_ACCESSORS);
    undef(&GEN_SES_CTRL_SAS_CONNECTOR_ACCESSORS) if defined(&GEN_SES_CTRL_SAS_CONNECTOR_ACCESSORS);
    eval("sub SES_CTRL_PAGE_INFO_MASK () { 0x08; }") unless defined(&SES_CTRL_PAGE_INFO_MASK);
    eval("sub SES_CTRL_PAGE_INFO_SHIFT () { 3; }") unless defined(&SES_CTRL_PAGE_INFO_SHIFT);
    eval("sub SES_CTRL_PAGE_NON_CRIT_MASK () { 0x04; }") unless defined(&SES_CTRL_PAGE_NON_CRIT_MASK);
    eval("sub SES_CTRL_PAGE_NON_CRIT_SHIFT () { 2; }") unless defined(&SES_CTRL_PAGE_NON_CRIT_SHIFT);
    eval("sub SES_CTRL_PAGE_CRIT_MASK () { 0x02; }") unless defined(&SES_CTRL_PAGE_CRIT_MASK);
    eval("sub SES_CTRL_PAGE_CRIT_SHIFT () { 1; }") unless defined(&SES_CTRL_PAGE_CRIT_SHIFT);
    eval("sub SES_CTRL_PAGE_UNRECOV_MASK () { 0x01; }") unless defined(&SES_CTRL_PAGE_UNRECOV_MASK);
    eval("sub SES_CTRL_PAGE_UNRECOV_SHIFT () { 0; }") unless defined(&SES_CTRL_PAGE_UNRECOV_SHIFT);
    eval 'sub GEN_SES_CTRL_PAGE_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_HDR_ACCESSORS( &ses_ctrl_page,  &SES_CTRL_PAGE, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_CTRL_PAGE_ACCESSORS);
    undef(&GEN_SES_CTRL_PAGE_ACCESSORS) if defined(&GEN_SES_CTRL_PAGE_ACCESSORS);
    eval("sub SES_STATUS_COMMON_PRDFAIL_BYTE () { 0; }") unless defined(&SES_STATUS_COMMON_PRDFAIL_BYTE);
    eval("sub SES_STATUS_COMMON_PRDFAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_COMMON_PRDFAIL_MASK);
    eval("sub SES_STATUS_COMMON_PRDFAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_COMMON_PRDFAIL_SHIFT);
    eval("sub SES_STATUS_COMMON_DISABLED_BYTE () { 0; }") unless defined(&SES_STATUS_COMMON_DISABLED_BYTE);
    eval("sub SES_STATUS_COMMON_DISABLED_MASK () { 0x20; }") unless defined(&SES_STATUS_COMMON_DISABLED_MASK);
    eval("sub SES_STATUS_COMMON_DISABLED_SHIFT () { 5; }") unless defined(&SES_STATUS_COMMON_DISABLED_SHIFT);
    eval("sub SES_STATUS_COMMON_SWAP_BYTE () { 0; }") unless defined(&SES_STATUS_COMMON_SWAP_BYTE);
    eval("sub SES_STATUS_COMMON_SWAP_MASK () { 0x10; }") unless defined(&SES_STATUS_COMMON_SWAP_MASK);
    eval("sub SES_STATUS_COMMON_SWAP_SHIFT () { 4; }") unless defined(&SES_STATUS_COMMON_SWAP_SHIFT);
    eval("sub SES_STATUS_COMMON_ELEMENT_STATUS_CODE_BYTE () { 0; }") unless defined(&SES_STATUS_COMMON_ELEMENT_STATUS_CODE_BYTE);
    eval("sub SES_STATUS_COMMON_ELEMENT_STATUS_CODE_MASK () { 0x0F; }") unless defined(&SES_STATUS_COMMON_ELEMENT_STATUS_CODE_MASK);
    eval("sub SES_STATUS_COMMON_ELEMENT_STATUS_CODE_SHIFT () { 0; }") unless defined(&SES_STATUS_COMMON_ELEMENT_STATUS_CODE_SHIFT);
    eval 'sub GEN_SES_STATUS_COMMON_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_common,  &SES_STATUS_COMMON, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_COMMON_ACCESSORS);
    undef(&GEN_SES_STATUS_COMMON_ACCESSORS) if defined(&GEN_SES_STATUS_COMMON_ACCESSORS);
    eval("sub SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_A_BYTE () { 0; }") unless defined(&SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_A_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_A_MASK () { 0x80; }") unless defined(&SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_A_MASK);
    eval("sub SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_A_SHIFT () { 7; }") unless defined(&SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_A_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_DO_NOT_REMOVE_BYTE () { 0; }") unless defined(&SES_STATUS_DEV_SLOT_DO_NOT_REMOVE_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_DO_NOT_REMOVE_MASK () { 0x40; }") unless defined(&SES_STATUS_DEV_SLOT_DO_NOT_REMOVE_MASK);
    eval("sub SES_STATUS_DEV_SLOT_DO_NOT_REMOVE_SHIFT () { 6; }") unless defined(&SES_STATUS_DEV_SLOT_DO_NOT_REMOVE_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_A_BYTE () { 0; }") unless defined(&SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_A_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_A_MASK () { 0x20; }") unless defined(&SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_A_MASK);
    eval("sub SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_A_SHIFT () { 5; }") unless defined(&SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_A_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_B_BYTE () { 0; }") unless defined(&SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_B_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_B_MASK () { 0x10; }") unless defined(&SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_B_MASK);
    eval("sub SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_B_SHIFT () { 4; }") unless defined(&SES_STATUS_DEV_SLOT_ENCLOSURE_BYPED_B_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_INSERT_READY_BYTE () { 0; }") unless defined(&SES_STATUS_DEV_SLOT_INSERT_READY_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_INSERT_READY_MASK () { 0x08; }") unless defined(&SES_STATUS_DEV_SLOT_INSERT_READY_MASK);
    eval("sub SES_STATUS_DEV_SLOT_INSERT_READY_SHIFT () { 3; }") unless defined(&SES_STATUS_DEV_SLOT_INSERT_READY_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_REMOVE_BYTE () { 0; }") unless defined(&SES_STATUS_DEV_SLOT_REMOVE_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_REMOVE_MASK () { 0x04; }") unless defined(&SES_STATUS_DEV_SLOT_REMOVE_MASK);
    eval("sub SES_STATUS_DEV_SLOT_REMOVE_SHIFT () { 2; }") unless defined(&SES_STATUS_DEV_SLOT_REMOVE_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_DEV_SLOT_IDENT_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_IDENT_MASK () { 0x02; }") unless defined(&SES_STATUS_DEV_SLOT_IDENT_MASK);
    eval("sub SES_STATUS_DEV_SLOT_IDENT_SHIFT () { 1; }") unless defined(&SES_STATUS_DEV_SLOT_IDENT_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_REPORT_BYTE () { 0; }") unless defined(&SES_STATUS_DEV_SLOT_REPORT_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_REPORT_MASK () { 0x01; }") unless defined(&SES_STATUS_DEV_SLOT_REPORT_MASK);
    eval("sub SES_STATUS_DEV_SLOT_REPORT_SHIFT () { 0; }") unless defined(&SES_STATUS_DEV_SLOT_REPORT_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_B_BYTE () { 1; }") unless defined(&SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_B_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_B_MASK () { 0x80; }") unless defined(&SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_B_MASK);
    eval("sub SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_B_SHIFT () { 7; }") unless defined(&SES_STATUS_DEV_SLOT_APP_CLIENT_BYPED_B_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_FAULT_SENSED_BYTE () { 1; }") unless defined(&SES_STATUS_DEV_SLOT_FAULT_SENSED_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_FAULT_SENSED_MASK () { 0x40; }") unless defined(&SES_STATUS_DEV_SLOT_FAULT_SENSED_MASK);
    eval("sub SES_STATUS_DEV_SLOT_FAULT_SENSED_SHIFT () { 6; }") unless defined(&SES_STATUS_DEV_SLOT_FAULT_SENSED_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_FAULT_REQUESTED_BYTE () { 1; }") unless defined(&SES_STATUS_DEV_SLOT_FAULT_REQUESTED_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_FAULT_REQUESTED_MASK () { 0x20; }") unless defined(&SES_STATUS_DEV_SLOT_FAULT_REQUESTED_MASK);
    eval("sub SES_STATUS_DEV_SLOT_FAULT_REQUESTED_SHIFT () { 5; }") unless defined(&SES_STATUS_DEV_SLOT_FAULT_REQUESTED_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_DEVICE_OFF_BYTE () { 1; }") unless defined(&SES_STATUS_DEV_SLOT_DEVICE_OFF_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_DEVICE_OFF_MASK () { 0x10; }") unless defined(&SES_STATUS_DEV_SLOT_DEVICE_OFF_MASK);
    eval("sub SES_STATUS_DEV_SLOT_DEVICE_OFF_SHIFT () { 4; }") unless defined(&SES_STATUS_DEV_SLOT_DEVICE_OFF_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_BYPED_A_BYTE () { 1; }") unless defined(&SES_STATUS_DEV_SLOT_BYPED_A_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_BYPED_A_MASK () { 0x08; }") unless defined(&SES_STATUS_DEV_SLOT_BYPED_A_MASK);
    eval("sub SES_STATUS_DEV_SLOT_BYPED_A_SHIFT () { 3; }") unless defined(&SES_STATUS_DEV_SLOT_BYPED_A_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_BYPED_B_BYTE () { 1; }") unless defined(&SES_STATUS_DEV_SLOT_BYPED_B_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_BYPED_B_MASK () { 0x04; }") unless defined(&SES_STATUS_DEV_SLOT_BYPED_B_MASK);
    eval("sub SES_STATUS_DEV_SLOT_BYPED_B_SHIFT () { 2; }") unless defined(&SES_STATUS_DEV_SLOT_BYPED_B_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_DEVICE_BYPED_A_BYTE () { 1; }") unless defined(&SES_STATUS_DEV_SLOT_DEVICE_BYPED_A_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_DEVICE_BYPED_A_MASK () { 0x02; }") unless defined(&SES_STATUS_DEV_SLOT_DEVICE_BYPED_A_MASK);
    eval("sub SES_STATUS_DEV_SLOT_DEVICE_BYPED_A_SHIFT () { 1; }") unless defined(&SES_STATUS_DEV_SLOT_DEVICE_BYPED_A_SHIFT);
    eval("sub SES_STATUS_DEV_SLOT_DEVICE_BYPED_B_BYTE () { 1; }") unless defined(&SES_STATUS_DEV_SLOT_DEVICE_BYPED_B_BYTE);
    eval("sub SES_STATUS_DEV_SLOT_DEVICE_BYPED_B_MASK () { 0x01; }") unless defined(&SES_STATUS_DEV_SLOT_DEVICE_BYPED_B_MASK);
    eval("sub SES_STATUS_DEV_SLOT_DEVICE_BYPED_B_SHIFT () { 0; }") unless defined(&SES_STATUS_DEV_SLOT_DEVICE_BYPED_B_SHIFT);
    eval 'sub GEN_SES_STATUS_DEV_SLOT_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_dev_slot,  &SES_STATUS_DEV_SLOT, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_DEV_SLOT_ACCESSORS);
    undef(&GEN_SES_STATUS_DEV_SLOT_ACCESSORS) if defined(&GEN_SES_STATUS_DEV_SLOT_ACCESSORS);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_OK_BYTE () { 0; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_OK_BYTE);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_OK_MASK () { 0x80; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_OK_MASK);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_OK_SHIFT () { 7; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_OK_SHIFT);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_RSVD_DEVICE_BYTE () { 0; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_RSVD_DEVICE_BYTE);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_RSVD_DEVICE_MASK () { 0x40; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_RSVD_DEVICE_MASK);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_RSVD_DEVICE_SHIFT () { 6; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_RSVD_DEVICE_SHIFT);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_HOT_SPARE_BYTE () { 0; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_HOT_SPARE_BYTE);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_HOT_SPARE_MASK () { 0x20; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_HOT_SPARE_MASK);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_HOT_SPARE_SHIFT () { 5; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_HOT_SPARE_SHIFT);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_CONS_CHECK_BYTE () { 0; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_CONS_CHECK_BYTE);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_CONS_CHECK_MASK () { 0x10; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_CONS_CHECK_MASK);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_CONS_CHECK_SHIFT () { 4; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_CONS_CHECK_SHIFT);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_IN_CRIT_ARRAY_BYTE () { 0; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_IN_CRIT_ARRAY_BYTE);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_IN_CRIT_ARRAY_MASK () { 0x08; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_IN_CRIT_ARRAY_MASK);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_IN_CRIT_ARRAY_SHIFT () { 3; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_IN_CRIT_ARRAY_SHIFT);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_IN_FAILED_ARRAY_BYTE () { 0; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_IN_FAILED_ARRAY_BYTE);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_IN_FAILED_ARRAY_MASK () { 0x04; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_IN_FAILED_ARRAY_MASK);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_IN_FAILED_ARRAY_SHIFT () { 2; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_IN_FAILED_ARRAY_SHIFT);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_BYTE () { 0; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_BYTE);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_MASK () { 0x02; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_MASK);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_SHIFT () { 1; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_SHIFT);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_ABORT_BYTE () { 0; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_ABORT_BYTE);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_ABORT_MASK () { 0x01; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_ABORT_MASK);
    eval("sub SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_ABORT_SHIFT () { 0; }") unless defined(&SES_STATUS_ARRAY_DEV_SLOT_REBUILD_REMAP_ABORT_SHIFT);
    eval 'sub GEN_SES_STATUS_ARRAY_DEV_SLOT_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_array_dev_slot,  &SES_STATUS_ARRAY_DEV_SLOT, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_ARRAY_DEV_SLOT_ACCESSORS);
    undef(&GEN_SES_STATUS_ARRAY_DEV_SLOT_ACCESSORS) if defined(&GEN_SES_STATUS_ARRAY_DEV_SLOT_ACCESSORS);
    eval("sub SES_STATUS_POWER_SUPPLY_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_POWER_SUPPLY_IDENT_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_POWER_SUPPLY_IDENT_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_POWER_SUPPLY_IDENT_SHIFT);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_OVER_VOLTAGE_BYTE () { 1; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_OVER_VOLTAGE_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_OVER_VOLTAGE_MASK () { 0x08; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_OVER_VOLTAGE_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_OVER_VOLTAGE_SHIFT () { 3; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_OVER_VOLTAGE_SHIFT);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_UNDER_VOLTAGE_BYTE () { 1; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_UNDER_VOLTAGE_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_UNDER_VOLTAGE_MASK () { 0x04; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_UNDER_VOLTAGE_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_UNDER_VOLTAGE_SHIFT () { 2; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_UNDER_VOLTAGE_SHIFT);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_OVER_CURRENT_BYTE () { 1; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_OVER_CURRENT_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_OVER_CURRENT_MASK () { 0x02; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_OVER_CURRENT_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_OVER_CURRENT_SHIFT () { 1; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_OVER_CURRENT_SHIFT);
    eval("sub SES_STATUS_POWER_SUPPLY_HOT_SWAP_BYTE () { 2; }") unless defined(&SES_STATUS_POWER_SUPPLY_HOT_SWAP_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_HOT_SWAP_MASK () { 0x80; }") unless defined(&SES_STATUS_POWER_SUPPLY_HOT_SWAP_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_HOT_SWAP_SHIFT () { 7; }") unless defined(&SES_STATUS_POWER_SUPPLY_HOT_SWAP_SHIFT);
    eval("sub SES_STATUS_POWER_SUPPLY_FAIL_BYTE () { 2; }") unless defined(&SES_STATUS_POWER_SUPPLY_FAIL_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_POWER_SUPPLY_FAIL_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_POWER_SUPPLY_FAIL_SHIFT);
    eval("sub SES_STATUS_POWER_SUPPLY_REQUESTED_ON_BYTE () { 2; }") unless defined(&SES_STATUS_POWER_SUPPLY_REQUESTED_ON_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_REQUESTED_ON_MASK () { 0x20; }") unless defined(&SES_STATUS_POWER_SUPPLY_REQUESTED_ON_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_REQUESTED_ON_SHIFT () { 5; }") unless defined(&SES_STATUS_POWER_SUPPLY_REQUESTED_ON_SHIFT);
    eval("sub SES_STATUS_POWER_SUPPLY_OFF_BYTE () { 2; }") unless defined(&SES_STATUS_POWER_SUPPLY_OFF_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_OFF_MASK () { 0x10; }") unless defined(&SES_STATUS_POWER_SUPPLY_OFF_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_OFF_SHIFT () { 4; }") unless defined(&SES_STATUS_POWER_SUPPLY_OFF_SHIFT);
    eval("sub SES_STATUS_POWER_SUPPLY_OVERTMP_FAIL_BYTE () { 2; }") unless defined(&SES_STATUS_POWER_SUPPLY_OVERTMP_FAIL_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_OVERTMP_FAIL_MASK () { 0x08; }") unless defined(&SES_STATUS_POWER_SUPPLY_OVERTMP_FAIL_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_OVERTMP_FAIL_SHIFT () { 3; }") unless defined(&SES_STATUS_POWER_SUPPLY_OVERTMP_FAIL_SHIFT);
    eval("sub SES_STATUS_POWER_SUPPLY_TEMP_WARN_BYTE () { 2; }") unless defined(&SES_STATUS_POWER_SUPPLY_TEMP_WARN_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_TEMP_WARN_MASK () { 0x04; }") unless defined(&SES_STATUS_POWER_SUPPLY_TEMP_WARN_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_TEMP_WARN_SHIFT () { 2; }") unless defined(&SES_STATUS_POWER_SUPPLY_TEMP_WARN_SHIFT);
    eval("sub SES_STATUS_POWER_SUPPLY_AC_FAIL_BYTE () { 2; }") unless defined(&SES_STATUS_POWER_SUPPLY_AC_FAIL_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_AC_FAIL_MASK () { 0x02; }") unless defined(&SES_STATUS_POWER_SUPPLY_AC_FAIL_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_AC_FAIL_SHIFT () { 1; }") unless defined(&SES_STATUS_POWER_SUPPLY_AC_FAIL_SHIFT);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_FAIL_BYTE () { 2; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_FAIL_BYTE);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_FAIL_MASK () { 0x01; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_FAIL_MASK);
    eval("sub SES_STATUS_POWER_SUPPLY_DC_FAIL_SHIFT () { 0; }") unless defined(&SES_STATUS_POWER_SUPPLY_DC_FAIL_SHIFT);
    eval 'sub GEN_SES_STATUS_POWER_SUPPLY_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_power_supply,  &SES_STATUS_POWER_SUPPLY, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_POWER_SUPPLY_ACCESSORS);
    undef(&GEN_SES_STATUS_POWER_SUPPLY_ACCESSORS) if defined(&GEN_SES_STATUS_POWER_SUPPLY_ACCESSORS);
    eval("sub SES_STATUS_COOLING_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_COOLING_IDENT_BYTE);
    eval("sub SES_STATUS_COOLING_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_COOLING_IDENT_MASK);
    eval("sub SES_STATUS_COOLING_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_COOLING_IDENT_SHIFT);
    eval("sub SES_STATUS_COOLING_ACTUAL_FAN_SPEED_MSB_BYTE () { 0; }") unless defined(&SES_STATUS_COOLING_ACTUAL_FAN_SPEED_MSB_BYTE);
    eval("sub SES_STATUS_COOLING_ACTUAL_FAN_SPEED_MSB_MASK () { 0x07; }") unless defined(&SES_STATUS_COOLING_ACTUAL_FAN_SPEED_MSB_MASK);
    eval("sub SES_STATUS_COOLING_ACTUAL_FAN_SPEED_MSB_SHIFT () { 0; }") unless defined(&SES_STATUS_COOLING_ACTUAL_FAN_SPEED_MSB_SHIFT);
    eval("sub SES_STATUS_COOLING_ACTUAL_FAN_SPEED_LSB_BYTE () { 1; }") unless defined(&SES_STATUS_COOLING_ACTUAL_FAN_SPEED_LSB_BYTE);
    eval("sub SES_STATUS_COOLING_ACTUAL_FAN_SPEED_LSB_MASK () { 0xFF; }") unless defined(&SES_STATUS_COOLING_ACTUAL_FAN_SPEED_LSB_MASK);
    eval("sub SES_STATUS_COOLING_ACTUAL_FAN_SPEED_LSB_SHIFT () { 0; }") unless defined(&SES_STATUS_COOLING_ACTUAL_FAN_SPEED_LSB_SHIFT);
    eval("sub SES_STATUS_COOLING_HOT_SWAP_BYTE () { 2; }") unless defined(&SES_STATUS_COOLING_HOT_SWAP_BYTE);
    eval("sub SES_STATUS_COOLING_HOT_SWAP_MASK () { 0x40; }") unless defined(&SES_STATUS_COOLING_HOT_SWAP_MASK);
    eval("sub SES_STATUS_COOLING_HOT_SWAP_SHIFT () { 6; }") unless defined(&SES_STATUS_COOLING_HOT_SWAP_SHIFT);
    eval("sub SES_STATUS_COOLING_FAIL_BYTE () { 2; }") unless defined(&SES_STATUS_COOLING_FAIL_BYTE);
    eval("sub SES_STATUS_COOLING_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_COOLING_FAIL_MASK);
    eval("sub SES_STATUS_COOLING_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_COOLING_FAIL_SHIFT);
    eval("sub SES_STATUS_COOLING_REQUESTED_ON_BYTE () { 2; }") unless defined(&SES_STATUS_COOLING_REQUESTED_ON_BYTE);
    eval("sub SES_STATUS_COOLING_REQUESTED_ON_MASK () { 0x20; }") unless defined(&SES_STATUS_COOLING_REQUESTED_ON_MASK);
    eval("sub SES_STATUS_COOLING_REQUESTED_ON_SHIFT () { 5; }") unless defined(&SES_STATUS_COOLING_REQUESTED_ON_SHIFT);
    eval("sub SES_STATUS_COOLING_OFF_BYTE () { 2; }") unless defined(&SES_STATUS_COOLING_OFF_BYTE);
    eval("sub SES_STATUS_COOLING_OFF_MASK () { 0x20; }") unless defined(&SES_STATUS_COOLING_OFF_MASK);
    eval("sub SES_STATUS_COOLING_OFF_SHIFT () { 5; }") unless defined(&SES_STATUS_COOLING_OFF_SHIFT);
    eval("sub SES_STATUS_COOLING_ACTUAL_SPEED_CODE_BYTE () { 2; }") unless defined(&SES_STATUS_COOLING_ACTUAL_SPEED_CODE_BYTE);
    eval("sub SES_STATUS_COOLING_ACTUAL_SPEED_CODE_MASK () { 0x07; }") unless defined(&SES_STATUS_COOLING_ACTUAL_SPEED_CODE_MASK);
    eval("sub SES_STATUS_COOLING_ACTUAL_SPEED_CODE_SHIFT () { 2; }") unless defined(&SES_STATUS_COOLING_ACTUAL_SPEED_CODE_SHIFT);
    eval("sub SES_STATUS_COOLING_ACTUAL_SPEED_CODE_STOPPED () { 0x00; }") unless defined(&SES_STATUS_COOLING_ACTUAL_SPEED_CODE_STOPPED);
    eval("sub SES_STATUS_COOLING_ACTUAL_SPEED_CODE_LOWEST () { 0x01; }") unless defined(&SES_STATUS_COOLING_ACTUAL_SPEED_CODE_LOWEST);
    eval("sub SES_STATUS_COOLING_ACTUAL_SPEED_CODE_HIGHEST () { 0x07; }") unless defined(&SES_STATUS_COOLING_ACTUAL_SPEED_CODE_HIGHEST);
    eval 'sub GEN_SES_STATUS_COOLING_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_cooling,  &SES_STATUS_COOLING, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_COOLING_ACCESSORS);
    undef(&GEN_SES_STATUS_COOLING_ACCESSORS) if defined(&GEN_SES_STATUS_COOLING_ACCESSORS);
    eval 'sub ses_status_cooling_get_actual_fan_speed {
        my($elem) = @_;
	    eval q({ ( &ses_status_cooling_get_actual_fan_speed_msb($elem) << 8|  &ses_status_cooling_get_actual_fan_speed_lsb($elem)); });
    }' unless defined(&ses_status_cooling_get_actual_fan_speed);
    eval("sub SES_STATUS_TEMP_SENSOR_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_TEMP_SENSOR_IDENT_BYTE);
    eval("sub SES_STATUS_TEMP_SENSOR_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_TEMP_SENSOR_IDENT_MASK);
    eval("sub SES_STATUS_TEMP_SENSOR_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_TEMP_SENSOR_IDENT_SHIFT);
    eval("sub SES_STATUS_TEMP_SENSOR_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_TEMP_SENSOR_FAIL_BYTE);
    eval("sub SES_STATUS_TEMP_SENSOR_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_TEMP_SENSOR_FAIL_MASK);
    eval("sub SES_STATUS_TEMP_SENSOR_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_TEMP_SENSOR_FAIL_SHIFT);
    eval("sub SES_STATUS_TEMP_SENSOR_TEMPERATURE_BYTE () { 1; }") unless defined(&SES_STATUS_TEMP_SENSOR_TEMPERATURE_BYTE);
    eval("sub SES_STATUS_TEMP_SENSOR_TEMPERATURE_MASK () { 0xFF; }") unless defined(&SES_STATUS_TEMP_SENSOR_TEMPERATURE_MASK);
    eval("sub SES_STATUS_TEMP_SENSOR_TEMPERATURE_SHIFT () { 0; }") unless defined(&SES_STATUS_TEMP_SENSOR_TEMPERATURE_SHIFT);
    eval("sub SES_STATUS_TEMP_SENSOR_OT_FAILURE_BYTE () { 2; }") unless defined(&SES_STATUS_TEMP_SENSOR_OT_FAILURE_BYTE);
    eval("sub SES_STATUS_TEMP_SENSOR_OT_FAILURE_MASK () { 0x08; }") unless defined(&SES_STATUS_TEMP_SENSOR_OT_FAILURE_MASK);
    eval("sub SES_STATUS_TEMP_SENSOR_OT_FAILURE_SHIFT () { 3; }") unless defined(&SES_STATUS_TEMP_SENSOR_OT_FAILURE_SHIFT);
    eval("sub SES_STATUS_TEMP_SENSOR_OT_WARNING_BYTE () { 2; }") unless defined(&SES_STATUS_TEMP_SENSOR_OT_WARNING_BYTE);
    eval("sub SES_STATUS_TEMP_SENSOR_OT_WARNING_MASK () { 0x04; }") unless defined(&SES_STATUS_TEMP_SENSOR_OT_WARNING_MASK);
    eval("sub SES_STATUS_TEMP_SENSOR_OT_WARNING_SHIFT () { 2; }") unless defined(&SES_STATUS_TEMP_SENSOR_OT_WARNING_SHIFT);
    eval("sub SES_STATUS_TEMP_SENSOR_UT_FAILURE_BYTE () { 2; }") unless defined(&SES_STATUS_TEMP_SENSOR_UT_FAILURE_BYTE);
    eval("sub SES_STATUS_TEMP_SENSOR_UT_FAILURE_MASK () { 0x02; }") unless defined(&SES_STATUS_TEMP_SENSOR_UT_FAILURE_MASK);
    eval("sub SES_STATUS_TEMP_SENSOR_UT_FAILURE_SHIFT () { 1; }") unless defined(&SES_STATUS_TEMP_SENSOR_UT_FAILURE_SHIFT);
    eval("sub SES_STATUS_TEMP_SENSOR_UT_WARNING_BYTE () { 2; }") unless defined(&SES_STATUS_TEMP_SENSOR_UT_WARNING_BYTE);
    eval("sub SES_STATUS_TEMP_SENSOR_UT_WARNING_MASK () { 0x01; }") unless defined(&SES_STATUS_TEMP_SENSOR_UT_WARNING_MASK);
    eval("sub SES_STATUS_TEMP_SENSOR_UT_WARNING_SHIFT () { 0; }") unless defined(&SES_STATUS_TEMP_SENSOR_UT_WARNING_SHIFT);
    eval 'sub GEN_SES_STATUS_TEMP_SENSOR_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_temp_sensor,  &SES_STATUS_TEMP_SENSOR, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_TEMP_SENSOR_ACCESSORS);
    undef(&GEN_SES_STATUS_TEMP_SENSOR_ACCESSORS) if defined(&GEN_SES_STATUS_TEMP_SENSOR_ACCESSORS);
    eval("sub SES_STATUS_DOOR_LOCK_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_DOOR_LOCK_IDENT_BYTE);
    eval("sub SES_STATUS_DOOR_LOCK_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_DOOR_LOCK_IDENT_MASK);
    eval("sub SES_STATUS_DOOR_LOCK_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_DOOR_LOCK_IDENT_SHIFT);
    eval("sub SES_STATUS_DOOR_LOCK_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_DOOR_LOCK_FAIL_BYTE);
    eval("sub SES_STATUS_DOOR_LOCK_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_DOOR_LOCK_FAIL_MASK);
    eval("sub SES_STATUS_DOOR_LOCK_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_DOOR_LOCK_FAIL_SHIFT);
    eval("sub SES_STATUS_DOOR_LOCK_UNLOCKED_BYTE () { 2; }") unless defined(&SES_STATUS_DOOR_LOCK_UNLOCKED_BYTE);
    eval("sub SES_STATUS_DOOR_LOCK_UNLOCKED_MASK () { 0x01; }") unless defined(&SES_STATUS_DOOR_LOCK_UNLOCKED_MASK);
    eval("sub SES_STATUS_DOOR_LOCK_UNLOCKED_SHIFT () { 0; }") unless defined(&SES_STATUS_DOOR_LOCK_UNLOCKED_SHIFT);
    eval 'sub GEN_SES_STATUS_DOOR_LOCK_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_door_lock,  &SES_STATUS_DOOR_LOCK, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_DOOR_LOCK_ACCESSORS);
    undef(&GEN_SES_STATUS_DOOR_LOCK_ACCESSORS) if defined(&GEN_SES_STATUS_DOOR_LOCK_ACCESSORS);
    eval("sub SES_STATUS_AUDIBLE_ALARM_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_IDENT_BYTE);
    eval("sub SES_STATUS_AUDIBLE_ALARM_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_IDENT_MASK);
    eval("sub SES_STATUS_AUDIBLE_ALARM_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_IDENT_SHIFT);
    eval("sub SES_STATUS_AUDIBLE_ALARM_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_FAIL_BYTE);
    eval("sub SES_STATUS_AUDIBLE_ALARM_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_FAIL_MASK);
    eval("sub SES_STATUS_AUDIBLE_ALARM_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_FAIL_SHIFT);
    eval("sub SES_STATUS_AUDIBLE_ALARM_RQST_MUTE_BYTE () { 2; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_RQST_MUTE_BYTE);
    eval("sub SES_STATUS_AUDIBLE_ALARM_RQST_MUTE_MASK () { 0x80; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_RQST_MUTE_MASK);
    eval("sub SES_STATUS_AUDIBLE_ALARM_RQST_MUTE_SHIFT () { 7; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_RQST_MUTE_SHIFT);
    eval("sub SES_STATUS_AUDIBLE_ALARM_MUTED_BYTE () { 2; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_MUTED_BYTE);
    eval("sub SES_STATUS_AUDIBLE_ALARM_MUTED_MASK () { 0x40; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_MUTED_MASK);
    eval("sub SES_STATUS_AUDIBLE_ALARM_MUTED_SHIFT () { 6; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_MUTED_SHIFT);
    eval("sub SES_STATUS_AUDIBLE_ALARM_REMIND_BYTE () { 2; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_REMIND_BYTE);
    eval("sub SES_STATUS_AUDIBLE_ALARM_REMIND_MASK () { 0x10; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_REMIND_MASK);
    eval("sub SES_STATUS_AUDIBLE_ALARM_REMIND_SHIFT () { 4; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_REMIND_SHIFT);
    eval("sub SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_BYTE () { 2; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_BYTE);
    eval("sub SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_MASK () { 0x0F; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_MASK);
    eval("sub SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_SHIFT () { 0; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_SHIFT);
    eval("sub SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_INFO () { 0x08; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_INFO);
    eval("sub SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_NON_CRIT () { 0x04; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_NON_CRIT);
    eval("sub SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_CRIT () { 0x02; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_CRIT);
    eval("sub SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_UNRECOV () { 0x01; }") unless defined(&SES_STATUS_AUDIBLE_ALARM_TONE_INDICATOR_UNRECOV);
    eval 'sub GEN_SES_STATUS_AUDIBLE_ALARM_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_audible_alarm,  &SES_STATUS_AUDIBLE_ALARM, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_AUDIBLE_ALARM_ACCESSORS);
    undef(&GEN_SES_STATUS_AUDIBLE_ALARM_ACCESSORS) if defined(&GEN_SES_STATUS_AUDIBLE_ALARM_ACCESSORS);
    eval("sub SES_STATUS_ECC_ELECTRONICS_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_IDENT_BYTE);
    eval("sub SES_STATUS_ECC_ELECTRONICS_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_IDENT_MASK);
    eval("sub SES_STATUS_ECC_ELECTRONICS_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_IDENT_SHIFT);
    eval("sub SES_STATUS_ECC_ELECTRONICS_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_FAIL_BYTE);
    eval("sub SES_STATUS_ECC_ELECTRONICS_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_FAIL_MASK);
    eval("sub SES_STATUS_ECC_ELECTRONICS_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_FAIL_SHIFT);
    eval("sub SES_STATUS_ECC_ELECTRONICS_REPORT_BYTE () { 1; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_REPORT_BYTE);
    eval("sub SES_STATUS_ECC_ELECTRONICS_REPORT_MASK () { 0x01; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_REPORT_MASK);
    eval("sub SES_STATUS_ECC_ELECTRONICS_REPORT_SHIFT () { 0; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_REPORT_SHIFT);
    eval("sub SES_STATUS_ECC_ELECTRONICS_HOT_SWAP_BYTE () { 2; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_HOT_SWAP_BYTE);
    eval("sub SES_STATUS_ECC_ELECTRONICS_HOT_SWAP_MASK () { 0x80; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_HOT_SWAP_MASK);
    eval("sub SES_STATUS_ECC_ELECTRONICS_HOT_SWAP_SHIFT () { 7; }") unless defined(&SES_STATUS_ECC_ELECTRONICS_HOT_SWAP_SHIFT);
    eval 'sub GEN_SES_STATUS_ECC_ELECTRONICS_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_ecc_electronics,  &SES_STATUS_ECC_ELECTRONICS, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_ECC_ELECTRONICS_ACCESSORS);
    undef(&GEN_SES_STATUS_ECC_ELECTRONICS_ACCESSORS) if defined(&GEN_SES_STATUS_ECC_ELECTRONICS_ACCESSORS);
    eval("sub SES_STATUS_SCC_ELECTRONICS_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_SCC_ELECTRONICS_IDENT_BYTE);
    eval("sub SES_STATUS_SCC_ELECTRONICS_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_SCC_ELECTRONICS_IDENT_MASK);
    eval("sub SES_STATUS_SCC_ELECTRONICS_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_SCC_ELECTRONICS_IDENT_SHIFT);
    eval("sub SES_STATUS_SCC_ELECTRONICS_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_SCC_ELECTRONICS_FAIL_BYTE);
    eval("sub SES_STATUS_SCC_ELECTRONICS_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_SCC_ELECTRONICS_FAIL_MASK);
    eval("sub SES_STATUS_SCC_ELECTRONICS_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_SCC_ELECTRONICS_FAIL_SHIFT);
    eval("sub SES_STATUS_SCC_ELECTRONICS_REPORT_BYTE () { 1; }") unless defined(&SES_STATUS_SCC_ELECTRONICS_REPORT_BYTE);
    eval("sub SES_STATUS_SCC_ELECTRONICS_REPORT_MASK () { 0x01; }") unless defined(&SES_STATUS_SCC_ELECTRONICS_REPORT_MASK);
    eval("sub SES_STATUS_SCC_ELECTRONICS_REPORT_SHIFT () { 0; }") unless defined(&SES_STATUS_SCC_ELECTRONICS_REPORT_SHIFT);
    eval 'sub GEN_SES_STATUS_SCC_ELECTRONICS_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_scc_electronics,  &SES_STATUS_SCC_ELECTRONICS, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_SCC_ELECTRONICS_ACCESSORS);
    undef(&GEN_SES_STATUS_SCC_ELECTRONICS_ACCESSORS) if defined(&GEN_SES_STATUS_SCC_ELECTRONICS_ACCESSORS);
    eval("sub SES_STATUS_NV_CACHE_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_NV_CACHE_IDENT_BYTE);
    eval("sub SES_STATUS_NV_CACHE_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_NV_CACHE_IDENT_MASK);
    eval("sub SES_STATUS_NV_CACHE_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_NV_CACHE_IDENT_SHIFT);
    eval("sub SES_STATUS_NV_CACHE_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_NV_CACHE_FAIL_BYTE);
    eval("sub SES_STATUS_NV_CACHE_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_NV_CACHE_FAIL_MASK);
    eval("sub SES_STATUS_NV_CACHE_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_NV_CACHE_FAIL_SHIFT);
    eval("sub SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_BYTE () { 0; }") unless defined(&SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_BYTE);
    eval("sub SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_MASK () { 0x03; }") unless defined(&SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_MASK);
    eval("sub SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_SHIFT () { 0; }") unless defined(&SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_SHIFT);
    eval("sub SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_BYTES () { 0x0; }") unless defined(&SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_BYTES);
    eval("sub SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_KBYTES () { 0x1; }") unless defined(&SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_KBYTES);
    eval("sub SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_MBYTES () { 0x2; }") unless defined(&SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_MBYTES);
    eval("sub SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_GBYTES () { 0x3; }") unless defined(&SES_STATUS_NV_CACHE_SIZE_MULTIPLIER_GBYTES);
    eval 'sub GEN_SES_STATUS_NV_CACHE_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_nv_cache,  &SES_STATUS_NV_CACHE, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_NV_CACHE_ACCESSORS);
    undef(&GEN_SES_STATUS_NV_CACHE_ACCESSORS) if defined(&GEN_SES_STATUS_NV_CACHE_ACCESSORS);
    eval 'sub ses_status_nv_cache_get_cache_size {
        my($elem) = @_;
	    eval q({  &uintmax_t  &cache_size; \'int\'  &multiplier;  &cache_size =  &scsi_2btoul( ($elem->{cache_size}));  &multiplier = 10*  &ses_status_nv_cache_get_size_multiplier($elem); ( &cache_size <<  &multiplier); });
    }' unless defined(&ses_status_nv_cache_get_cache_size);
    eval("sub SES_STATUS_INVALID_OP_REASON_TYPE_BYTE () { 0; }") unless defined(&SES_STATUS_INVALID_OP_REASON_TYPE_BYTE);
    eval("sub SES_STATUS_INVALID_OP_REASON_TYPE_MASK () { 0xC0; }") unless defined(&SES_STATUS_INVALID_OP_REASON_TYPE_MASK);
    eval("sub SES_STATUS_INVALID_OP_REASON_TYPE_SHIFT () { 6; }") unless defined(&SES_STATUS_INVALID_OP_REASON_TYPE_SHIFT);
    eval("sub SES_STATUS_INVALID_OP_REASON_TYPE_PC_ERROR () { 0x00; }") unless defined(&SES_STATUS_INVALID_OP_REASON_TYPE_PC_ERROR);
    eval("sub SES_STATUS_INVALID_OP_REASON_TYPE_PF_ERROR () { 0x01; }") unless defined(&SES_STATUS_INVALID_OP_REASON_TYPE_PF_ERROR);
    eval("sub SES_STATUS_INVALID_OP_REASON_TYPE_VS_ERROR () { 0x03; }") unless defined(&SES_STATUS_INVALID_OP_REASON_TYPE_VS_ERROR);
    eval("sub SES_STATUS_INVALID_OP_REASON_PC_ERROR_PC_NOT_SUPPORTED_BYTE () { 0; }") unless defined(&SES_STATUS_INVALID_OP_REASON_PC_ERROR_PC_NOT_SUPPORTED_BYTE);
    eval("sub SES_STATUS_INVALID_OP_REASON_PC_ERROR_PC_NOT_SUPPORTED_MASK () { 0x01; }") unless defined(&SES_STATUS_INVALID_OP_REASON_PC_ERROR_PC_NOT_SUPPORTED_MASK);
    eval("sub SES_STATUS_INVALID_OP_REASON_PC_ERROR_PC_NOT_SUPPORTED_SHIFT () { 0; }") unless defined(&SES_STATUS_INVALID_OP_REASON_PC_ERROR_PC_NOT_SUPPORTED_SHIFT);
    eval("sub SES_STATUS_INVALID_OP_REASON_PF_ERROR_BIT_NUMBER_BYTE () { 0; }") unless defined(&SES_STATUS_INVALID_OP_REASON_PF_ERROR_BIT_NUMBER_BYTE);
    eval("sub SES_STATUS_INVALID_OP_REASON_PF_ERROR_BIT_NUMBER_MASK () { 0x03; }") unless defined(&SES_STATUS_INVALID_OP_REASON_PF_ERROR_BIT_NUMBER_MASK);
    eval("sub SES_STATUS_INVALID_OP_REASON_PF_ERROR_BIT_NUMBER_SHIFT () { 0; }") unless defined(&SES_STATUS_INVALID_OP_REASON_PF_ERROR_BIT_NUMBER_SHIFT);
    eval 'sub GEN_SES_STATUS_INVALID_OP_REASON_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_invalid_op_reason,  &SES_STATUS_INVALID_OP_REASON, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_INVALID_OP_REASON_ACCESSORS);
    undef(&GEN_SES_STATUS_INVALID_OP_ACCESSORS) if defined(&GEN_SES_STATUS_INVALID_OP_ACCESSORS);
    eval("sub SES_STATUS_UPS_AC_LO_BYTE () { 0; }") unless defined(&SES_STATUS_UPS_AC_LO_BYTE);
    eval("sub SES_STATUS_UPS_AC_LO_MASK () { 0x80; }") unless defined(&SES_STATUS_UPS_AC_LO_MASK);
    eval("sub SES_STATUS_UPS_AC_LO_SHIFT () { 7; }") unless defined(&SES_STATUS_UPS_AC_LO_SHIFT);
    eval("sub SES_STATUS_UPS_AC_HI_BYTE () { 0; }") unless defined(&SES_STATUS_UPS_AC_HI_BYTE);
    eval("sub SES_STATUS_UPS_AC_HI_MASK () { 0x40; }") unless defined(&SES_STATUS_UPS_AC_HI_MASK);
    eval("sub SES_STATUS_UPS_AC_HI_SHIFT () { 6; }") unless defined(&SES_STATUS_UPS_AC_HI_SHIFT);
    eval("sub SES_STATUS_UPS_AC_QUAL_BYTE () { 0; }") unless defined(&SES_STATUS_UPS_AC_QUAL_BYTE);
    eval("sub SES_STATUS_UPS_AC_QUAL_MASK () { 0x20; }") unless defined(&SES_STATUS_UPS_AC_QUAL_MASK);
    eval("sub SES_STATUS_UPS_AC_QUAL_SHIFT () { 5; }") unless defined(&SES_STATUS_UPS_AC_QUAL_SHIFT);
    eval("sub SES_STATUS_UPS_AC_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_UPS_AC_FAIL_BYTE);
    eval("sub SES_STATUS_UPS_AC_FAIL_MASK () { 0x10; }") unless defined(&SES_STATUS_UPS_AC_FAIL_MASK);
    eval("sub SES_STATUS_UPS_AC_FAIL_SHIFT () { 4; }") unless defined(&SES_STATUS_UPS_AC_FAIL_SHIFT);
    eval("sub SES_STATUS_UPS_DC_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_UPS_DC_FAIL_BYTE);
    eval("sub SES_STATUS_UPS_DC_FAIL_MASK () { 0x08; }") unless defined(&SES_STATUS_UPS_DC_FAIL_MASK);
    eval("sub SES_STATUS_UPS_DC_FAIL_SHIFT () { 3; }") unless defined(&SES_STATUS_UPS_DC_FAIL_SHIFT);
    eval("sub SES_STATUS_UPS_UPS_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_UPS_UPS_FAIL_BYTE);
    eval("sub SES_STATUS_UPS_UPS_FAIL_MASK () { 0x04; }") unless defined(&SES_STATUS_UPS_UPS_FAIL_MASK);
    eval("sub SES_STATUS_UPS_UPS_FAIL_SHIFT () { 2; }") unless defined(&SES_STATUS_UPS_UPS_FAIL_SHIFT);
    eval("sub SES_STATUS_UPS_WARN_BYTE () { 0; }") unless defined(&SES_STATUS_UPS_WARN_BYTE);
    eval("sub SES_STATUS_UPS_WARN_MASK () { 0x02; }") unless defined(&SES_STATUS_UPS_WARN_MASK);
    eval("sub SES_STATUS_UPS_WARN_SHIFT () { 1; }") unless defined(&SES_STATUS_UPS_WARN_SHIFT);
    eval("sub SES_STATUS_UPS_INTF_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_UPS_INTF_FAIL_BYTE);
    eval("sub SES_STATUS_UPS_INTF_FAIL_MASK () { 0x01; }") unless defined(&SES_STATUS_UPS_INTF_FAIL_MASK);
    eval("sub SES_STATUS_UPS_INTF_FAIL_SHIFT () { 0; }") unless defined(&SES_STATUS_UPS_INTF_FAIL_SHIFT);
    eval("sub SES_STATUS_UPS_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_UPS_IDENT_BYTE);
    eval("sub SES_STATUS_UPS_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_UPS_IDENT_MASK);
    eval("sub SES_STATUS_UPS_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_UPS_IDENT_SHIFT);
    eval("sub SES_STATUS_UPS_FAIL_BYTE () { 1; }") unless defined(&SES_STATUS_UPS_FAIL_BYTE);
    eval("sub SES_STATUS_UPS_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_UPS_FAIL_MASK);
    eval("sub SES_STATUS_UPS_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_UPS_FAIL_SHIFT);
    eval("sub SES_STATUS_UPS_BATT_FAIL_BYTE () { 1; }") unless defined(&SES_STATUS_UPS_BATT_FAIL_BYTE);
    eval("sub SES_STATUS_UPS_BATT_FAIL_MASK () { 0x02; }") unless defined(&SES_STATUS_UPS_BATT_FAIL_MASK);
    eval("sub SES_STATUS_UPS_BATT_FAIL_SHIFT () { 1; }") unless defined(&SES_STATUS_UPS_BATT_FAIL_SHIFT);
    eval("sub SES_STATUS_UPS_BPF_BYTE () { 1; }") unless defined(&SES_STATUS_UPS_BPF_BYTE);
    eval("sub SES_STATUS_UPS_BPF_MASK () { 0x01; }") unless defined(&SES_STATUS_UPS_BPF_MASK);
    eval("sub SES_STATUS_UPS_BPF_SHIFT () { 0; }") unless defined(&SES_STATUS_UPS_BPF_SHIFT);
    eval 'sub GEN_SES_STATUS_UPS_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_ups,  &SES_STATUS_UPS, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_UPS_ACCESSORS);
    undef(&GEN_SES_STATUS_UPS_ACCESSORS) if defined(&GEN_SES_STATUS_UPS_ACCESSORS);
    eval("sub SES_STATUS_DISPLAY_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_DISPLAY_IDENT_BYTE);
    eval("sub SES_STATUS_DISPLAY_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_DISPLAY_IDENT_MASK);
    eval("sub SES_STATUS_DISPLAY_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_DISPLAY_IDENT_SHIFT);
    eval("sub SES_STATUS_DISPLAY_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_DISPLAY_FAIL_BYTE);
    eval("sub SES_STATUS_DISPLAY_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_DISPLAY_FAIL_MASK);
    eval("sub SES_STATUS_DISPLAY_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_DISPLAY_FAIL_SHIFT);
    eval("sub SES_STATUS_DISPLAY_DISPLAY_MODE_BYTE () { 0; }") unless defined(&SES_STATUS_DISPLAY_DISPLAY_MODE_BYTE);
    eval("sub SES_STATUS_DISPLAY_DISPLAY_MODE_MASK () { 0x03; }") unless defined(&SES_STATUS_DISPLAY_DISPLAY_MODE_MASK);
    eval("sub SES_STATUS_DISPLAY_DISPLAY_MODE_SHIFT () { 6; }") unless defined(&SES_STATUS_DISPLAY_DISPLAY_MODE_SHIFT);
    eval("sub SES_STATUS_DISPLAY_DISPLAY_MODE_DC_FIELD_UNSUPP () { 0x0; }") unless defined(&SES_STATUS_DISPLAY_DISPLAY_MODE_DC_FIELD_UNSUPP);
    eval("sub SES_STATUS_DISPLAY_DISPLAY_MODE_DC_FIELD_SUPP () { 0x1; }") unless defined(&SES_STATUS_DISPLAY_DISPLAY_MODE_DC_FIELD_SUPP);
    eval("sub SES_STATUS_DISPLAY_DISPLAY_MODE_DC_FIELD () { 0x2; }") unless defined(&SES_STATUS_DISPLAY_DISPLAY_MODE_DC_FIELD);
    eval 'sub GEN_SES_STATUS_DISPLAY_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_display,  &SES_STATUS_DISPLAY, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_DISPLAY_ACCESSORS);
    undef(&GEN_SES_STATUS_DISPLAY_ACCESSORS) if defined(&GEN_SES_STATUS_DISPLAY_ACCESSORS);
    eval("sub SES_STATUS_KEY_PAD_ENTRY_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_KEY_PAD_ENTRY_IDENT_BYTE);
    eval("sub SES_STATUS_KEY_PAD_ENTRY_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_KEY_PAD_ENTRY_IDENT_MASK);
    eval("sub SES_STATUS_KEY_PAD_ENTRY_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_KEY_PAD_ENTRY_IDENT_SHIFT);
    eval("sub SES_STATUS_KEY_PAD_ENTRY_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_KEY_PAD_ENTRY_FAIL_BYTE);
    eval("sub SES_STATUS_KEY_PAD_ENTRY_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_KEY_PAD_ENTRY_FAIL_MASK);
    eval("sub SES_STATUS_KEY_PAD_ENTRY_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_KEY_PAD_ENTRY_FAIL_SHIFT);
    eval 'sub GEN_SES_STATUS_KEY_PAD_ENTRY_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_key_pad_entry,  &SES_STATUS_KEY_PAD_ENTRY, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_KEY_PAD_ENTRY_ACCESSORS);
    undef(&GEN_SES_STATUS_KEY_PAD_ENTRY_ACCESSORS) if defined(&GEN_SES_STATUS_KEY_PAD_ENTRY_ACCESSORS);
    eval("sub SES_STATUS_ENCLOSURE_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_ENCLOSURE_IDENT_BYTE);
    eval("sub SES_STATUS_ENCLOSURE_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_ENCLOSURE_IDENT_MASK);
    eval("sub SES_STATUS_ENCLOSURE_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_ENCLOSURE_IDENT_SHIFT);
    eval("sub SES_STATUS_ENCLOSURE_TIME_UNTIL_POWER_CYCLE_BYTE () { 1; }") unless defined(&SES_STATUS_ENCLOSURE_TIME_UNTIL_POWER_CYCLE_BYTE);
    eval("sub SES_STATUS_ENCLOSURE_TIME_UNTIL_POWER_CYCLE_MASK () { 0xFC; }") unless defined(&SES_STATUS_ENCLOSURE_TIME_UNTIL_POWER_CYCLE_MASK);
    eval("sub SES_STATUS_ENCLOSURE_TIME_UNTIL_POWER_CYCLE_SHIFT () { 2; }") unless defined(&SES_STATUS_ENCLOSURE_TIME_UNTIL_POWER_CYCLE_SHIFT);
    eval("sub SES_STATUS_ENCLOSURE_FAIL_BYTE () { 1; }") unless defined(&SES_STATUS_ENCLOSURE_FAIL_BYTE);
    eval("sub SES_STATUS_ENCLOSURE_FAIL_MASK () { 0x02; }") unless defined(&SES_STATUS_ENCLOSURE_FAIL_MASK);
    eval("sub SES_STATUS_ENCLOSURE_FAIL_SHIFT () { 1; }") unless defined(&SES_STATUS_ENCLOSURE_FAIL_SHIFT);
    eval("sub SES_STATUS_ENCLOSURE_WARN_BYTE () { 1; }") unless defined(&SES_STATUS_ENCLOSURE_WARN_BYTE);
    eval("sub SES_STATUS_ENCLOSURE_WARN_MASK () { 0x01; }") unless defined(&SES_STATUS_ENCLOSURE_WARN_MASK);
    eval("sub SES_STATUS_ENCLOSURE_WARN_SHIFT () { 0; }") unless defined(&SES_STATUS_ENCLOSURE_WARN_SHIFT);
    eval("sub SES_STATUS_ENCLOSURE_REQUESTED_POWER_OFF_DURATION_BYTE () { 2; }") unless defined(&SES_STATUS_ENCLOSURE_REQUESTED_POWER_OFF_DURATION_BYTE);
    eval("sub SES_STATUS_ENCLOSURE_REQUESTED_POWER_OFF_DURATION_MASK () { 0xFC; }") unless defined(&SES_STATUS_ENCLOSURE_REQUESTED_POWER_OFF_DURATION_MASK);
    eval("sub SES_STATUS_ENCLOSURE_REQUESTED_POWER_OFF_DURATION_SHIFT () { 2; }") unless defined(&SES_STATUS_ENCLOSURE_REQUESTED_POWER_OFF_DURATION_SHIFT);
    eval("sub SES_STATUS_ENCLOSURE_REQUESTED_POWER_OFF_DURATION_MAX_AUTO () { 60; }") unless defined(&SES_STATUS_ENCLOSURE_REQUESTED_POWER_OFF_DURATION_MAX_AUTO);
    eval("sub SES_STATUS_ENCLOSURE_REQUESTED_POWER_OFF_DURATION_MANUAL () { 63; }") unless defined(&SES_STATUS_ENCLOSURE_REQUESTED_POWER_OFF_DURATION_MANUAL);
    eval("sub SES_STATUS_ENCLOSURE_REQUESTED_FAIL_BYTE () { 2; }") unless defined(&SES_STATUS_ENCLOSURE_REQUESTED_FAIL_BYTE);
    eval("sub SES_STATUS_ENCLOSURE_REQUESTED_FAIL_MASK () { 0x02; }") unless defined(&SES_STATUS_ENCLOSURE_REQUESTED_FAIL_MASK);
    eval("sub SES_STATUS_ENCLOSURE_REQUESTED_FAIL_SHIFT () { 1; }") unless defined(&SES_STATUS_ENCLOSURE_REQUESTED_FAIL_SHIFT);
    eval("sub SES_STATUS_ENCLOSURE_REQUESTED_WARN_BYTE () { 2; }") unless defined(&SES_STATUS_ENCLOSURE_REQUESTED_WARN_BYTE);
    eval("sub SES_STATUS_ENCLOSURE_REQUESTED_WARN_MASK () { 0x01; }") unless defined(&SES_STATUS_ENCLOSURE_REQUESTED_WARN_MASK);
    eval("sub SES_STATUS_ENCLOSURE_REQUESTED_WARN_SHIFT () { 0; }") unless defined(&SES_STATUS_ENCLOSURE_REQUESTED_WARN_SHIFT);
    eval 'sub GEN_SES_STATUS_ENCLOSURE_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_enclosure,  &SES_STATUS_ENCLOSURE, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_ENCLOSURE_ACCESSORS);
    undef(&GEN_SES_STATUS_ENCLOSURE_ACCESSORS) if defined(&GEN_SES_STATUS_ENCLOSURE_ACCESSORS);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_IDENT_BYTE);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_IDENT_MASK);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_IDENT_SHIFT);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_FAIL_BYTE);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_FAIL_MASK);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_FAIL_SHIFT);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_REPORT_BYTE () { 1; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_REPORT_BYTE);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_REPORT_MASK () { 0x01; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_REPORT_MASK);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_REPORT_SHIFT () { 0; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_REPORT_SHIFT);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_DISABLED_BYTE () { 2; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_DISABLED_BYTE);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_DISABLED_MASK () { 0x10; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_DISABLED_MASK);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_DISABLED_SHIFT () { 4; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_DISABLED_SHIFT);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_LOL_BYTE () { 2; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_LOL_BYTE);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_LOL_MASK () { 0x02; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_LOL_MASK);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_LOL_SHIFT () { 1; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_LOL_SHIFT);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_XMIT_FAIL_BYTE () { 2; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_XMIT_FAIL_BYTE);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_XMIT_FAIL_MASK () { 0x01; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_XMIT_FAIL_MASK);
    eval("sub SES_STATUS_SCSI_PORT_OR_XCVR_XMIT_FAIL_SHIFT () { 0; }") unless defined(&SES_STATUS_SCSI_PORT_OR_XCVR_XMIT_FAIL_SHIFT);
    eval 'sub GEN_SES_STATUS_SCSI_PORT_OR_XCVR_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_scsi_port_or_xcvr,  &SES_STATUS_SCSI_PORT_OR_XCVR, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_SCSI_PORT_OR_XCVR_ACCESSORS);
    undef(&GEN_SES_STATUS_SCSI_PORT_OR_XCVR_ACCESSORS) if defined(&GEN_SES_STATUS_SCSI_PORT_OR_XCVR_ACCESSORS);
    eval("sub SES_STATUS_LANGUAGE_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_LANGUAGE_IDENT_BYTE);
    eval("sub SES_STATUS_LANGUAGE_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_LANGUAGE_IDENT_MASK);
    eval("sub SES_STATUS_LANGUAGE_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_LANGUAGE_IDENT_SHIFT);
    eval 'sub GEN_SES_STATUS_LANGUAGE_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_language,  &SES_STATUS_LANGUAGE, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_LANGUAGE_ACCESSORS);
    undef(&GEN_SES_STATUS_LANGUAGE_ACCESSORS) if defined(&GEN_SES_STATUS_LANGUAGE_ACCESSORS);
    eval("sub SES_STATUS_COMM_PORT_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_COMM_PORT_IDENT_BYTE);
    eval("sub SES_STATUS_COMM_PORT_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_COMM_PORT_IDENT_MASK);
    eval("sub SES_STATUS_COMM_PORT_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_COMM_PORT_IDENT_SHIFT);
    eval("sub SES_STATUS_COMM_PORT_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_COMM_PORT_FAIL_BYTE);
    eval("sub SES_STATUS_COMM_PORT_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_COMM_PORT_FAIL_MASK);
    eval("sub SES_STATUS_COMM_PORT_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_COMM_PORT_FAIL_SHIFT);
    eval("sub SES_STATUS_COMM_PORT_DISABLED_BYTE () { 2; }") unless defined(&SES_STATUS_COMM_PORT_DISABLED_BYTE);
    eval("sub SES_STATUS_COMM_PORT_DISABLED_MASK () { 0x01; }") unless defined(&SES_STATUS_COMM_PORT_DISABLED_MASK);
    eval("sub SES_STATUS_COMM_PORT_DISABLED_SHIFT () { 0; }") unless defined(&SES_STATUS_COMM_PORT_DISABLED_SHIFT);
    eval 'sub GEN_SES_STATUS_COMM_PORT_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_comm_port,  &SES_STATUS_COMM_PORT, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_COMM_PORT_ACCESSORS);
    undef(&GEN_SES_STATUS_COMM_PORT_ACCESSORS) if defined(&GEN_SES_STATUS_COMM_PORT_ACCESSORS);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_IDENT_BYTE);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_IDENT_MASK);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_IDENT_SHIFT);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_FAIL_BYTE);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_FAIL_MASK);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_FAIL_SHIFT);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_WARN_OVER_BYTE () { 0; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_WARN_OVER_BYTE);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_WARN_OVER_MASK () { 0x08; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_WARN_OVER_MASK);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_WARN_OVER_SHIFT () { 3; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_WARN_OVER_SHIFT);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_WARN_UNDER_BYTE () { 0; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_WARN_UNDER_BYTE);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_WARN_UNDER_MASK () { 0x04; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_WARN_UNDER_MASK);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_WARN_UNDER_SHIFT () { 2; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_WARN_UNDER_SHIFT);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_CRIT_OVER_BYTE () { 0; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_CRIT_OVER_BYTE);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_CRIT_OVER_MASK () { 0x02; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_CRIT_OVER_MASK);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_CRIT_OVER_SHIFT () { 1; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_CRIT_OVER_SHIFT);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_CRIT_UNDER_BYTE () { 0; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_CRIT_UNDER_BYTE);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_CRIT_UNDER_MASK () { 0x01; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_CRIT_UNDER_MASK);
    eval("sub SES_STATUS_VOLTAGE_SENSOR_CRIT_UNDER_SHIFT () { 0; }") unless defined(&SES_STATUS_VOLTAGE_SENSOR_CRIT_UNDER_SHIFT);
    eval 'sub GEN_SES_STATUS_VOLTAGE_SENSOR_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_voltage_sensor,  &SES_STATUS_VOLTAGE_SENSOR, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_VOLTAGE_SENSOR_ACCESSORS);
    undef(&GEN_SES_STATUS_VOLTAGE_SENSOR_ACCESSORS) if defined(&GEN_SES_STATUS_VOLTAGE_SENSOR_ACCESSORS);
    eval("sub SES_STATUS_CURRENT_SENSOR_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_CURRENT_SENSOR_IDENT_BYTE);
    eval("sub SES_STATUS_CURRENT_SENSOR_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_CURRENT_SENSOR_IDENT_MASK);
    eval("sub SES_STATUS_CURRENT_SENSOR_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_CURRENT_SENSOR_IDENT_SHIFT);
    eval("sub SES_STATUS_CURRENT_SENSOR_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_CURRENT_SENSOR_FAIL_BYTE);
    eval("sub SES_STATUS_CURRENT_SENSOR_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_CURRENT_SENSOR_FAIL_MASK);
    eval("sub SES_STATUS_CURRENT_SENSOR_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_CURRENT_SENSOR_FAIL_SHIFT);
    eval("sub SES_STATUS_CURRENT_SENSOR_WARN_OVER_BYTE () { 0; }") unless defined(&SES_STATUS_CURRENT_SENSOR_WARN_OVER_BYTE);
    eval("sub SES_STATUS_CURRENT_SENSOR_WARN_OVER_MASK () { 0x08; }") unless defined(&SES_STATUS_CURRENT_SENSOR_WARN_OVER_MASK);
    eval("sub SES_STATUS_CURRENT_SENSOR_WARN_OVER_SHIFT () { 3; }") unless defined(&SES_STATUS_CURRENT_SENSOR_WARN_OVER_SHIFT);
    eval("sub SES_STATUS_CURRENT_SENSOR_CRIT_OVER_BYTE () { 0; }") unless defined(&SES_STATUS_CURRENT_SENSOR_CRIT_OVER_BYTE);
    eval("sub SES_STATUS_CURRENT_SENSOR_CRIT_OVER_MASK () { 0x02; }") unless defined(&SES_STATUS_CURRENT_SENSOR_CRIT_OVER_MASK);
    eval("sub SES_STATUS_CURRENT_SENSOR_CRIT_OVER_SHIFT () { 1; }") unless defined(&SES_STATUS_CURRENT_SENSOR_CRIT_OVER_SHIFT);
    eval 'sub GEN_SES_STATUS_CURRENT_SENSOR_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_current_sensor,  &SES_STATUS_CURRENT_SENSOR, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_CURRENT_SENSOR_ACCESSORS);
    undef(&GEN_SES_STATUS_CURRENT_SENSOR_ACCESSORS) if defined(&GEN_SES_STATUS_CURRENT_SENSOR_ACCESSORS);
    eval("sub SES_STATUS_TARGET_PORT_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_TARGET_PORT_IDENT_BYTE);
    eval("sub SES_STATUS_TARGET_PORT_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_TARGET_PORT_IDENT_MASK);
    eval("sub SES_STATUS_TARGET_PORT_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_TARGET_PORT_IDENT_SHIFT);
    eval("sub SES_STATUS_TARGET_PORT_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_TARGET_PORT_FAIL_BYTE);
    eval("sub SES_STATUS_TARGET_PORT_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_TARGET_PORT_FAIL_MASK);
    eval("sub SES_STATUS_TARGET_PORT_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_TARGET_PORT_FAIL_SHIFT);
    eval("sub SES_STATUS_TARGET_PORT_REPORT_BYTE () { 1; }") unless defined(&SES_STATUS_TARGET_PORT_REPORT_BYTE);
    eval("sub SES_STATUS_TARGET_PORT_REPORT_MASK () { 0x01; }") unless defined(&SES_STATUS_TARGET_PORT_REPORT_MASK);
    eval("sub SES_STATUS_TARGET_PORT_REPORT_SHIFT () { 0; }") unless defined(&SES_STATUS_TARGET_PORT_REPORT_SHIFT);
    eval("sub SES_STATUS_TARGET_PORT_ENABLED_BYTE () { 2; }") unless defined(&SES_STATUS_TARGET_PORT_ENABLED_BYTE);
    eval("sub SES_STATUS_TARGET_PORT_ENABLED_MASK () { 0x01; }") unless defined(&SES_STATUS_TARGET_PORT_ENABLED_MASK);
    eval("sub SES_STATUS_TARGET_PORT_ENABLED_SHIFT () { 0; }") unless defined(&SES_STATUS_TARGET_PORT_ENABLED_SHIFT);
    eval 'sub GEN_SES_STATUS_TARGET_PORT_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_target_port,  &SES_STATUS_TARGET_PORT, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_TARGET_PORT_ACCESSORS);
    undef(&GEN_SES_STATUS_TARGET_PORT_ACCESSORS) if defined(&GEN_SES_STATUS_TARGET_PORT_ACCESSORS);
    eval("sub SES_STATUS_INITIATOR_PORT_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_INITIATOR_PORT_IDENT_BYTE);
    eval("sub SES_STATUS_INITIATOR_PORT_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_INITIATOR_PORT_IDENT_MASK);
    eval("sub SES_STATUS_INITIATOR_PORT_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_INITIATOR_PORT_IDENT_SHIFT);
    eval("sub SES_STATUS_INITIATOR_PORT_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_INITIATOR_PORT_FAIL_BYTE);
    eval("sub SES_STATUS_INITIATOR_PORT_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_INITIATOR_PORT_FAIL_MASK);
    eval("sub SES_STATUS_INITIATOR_PORT_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_INITIATOR_PORT_FAIL_SHIFT);
    eval("sub SES_STATUS_INITIATOR_PORT_REPORT_BYTE () { 1; }") unless defined(&SES_STATUS_INITIATOR_PORT_REPORT_BYTE);
    eval("sub SES_STATUS_INITIATOR_PORT_REPORT_MASK () { 0x01; }") unless defined(&SES_STATUS_INITIATOR_PORT_REPORT_MASK);
    eval("sub SES_STATUS_INITIATOR_PORT_REPORT_SHIFT () { 0; }") unless defined(&SES_STATUS_INITIATOR_PORT_REPORT_SHIFT);
    eval("sub SES_STATUS_INITIATOR_PORT_ENABLED_BYTE () { 2; }") unless defined(&SES_STATUS_INITIATOR_PORT_ENABLED_BYTE);
    eval("sub SES_STATUS_INITIATOR_PORT_ENABLED_MASK () { 0x01; }") unless defined(&SES_STATUS_INITIATOR_PORT_ENABLED_MASK);
    eval("sub SES_STATUS_INITIATOR_PORT_ENABLED_SHIFT () { 0; }") unless defined(&SES_STATUS_INITIATOR_PORT_ENABLED_SHIFT);
    eval 'sub GEN_SES_STATUS_INITIATOR_PORT_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_initiator_port,  &SES_STATUS_INITIATOR_PORT, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_INITIATOR_PORT_ACCESSORS);
    undef(&GEN_SES_STATUS_INITIATOR_PORT_ACCESSORS) if defined(&GEN_SES_STATUS_INITIATOR_PORT_ACCESSORS);
    eval("sub SES_STATUS_SIMPlE_SUBSES_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_SIMPlE_SUBSES_IDENT_BYTE);
    eval("sub SES_STATUS_SIMPlE_SUBSES_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_SIMPlE_SUBSES_IDENT_MASK);
    eval("sub SES_STATUS_SIMPlE_SUBSES_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_SIMPlE_SUBSES_IDENT_SHIFT);
    eval("sub SES_STATUS_SIMPlE_SUBSES_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_SIMPlE_SUBSES_FAIL_BYTE);
    eval("sub SES_STATUS_SIMPlE_SUBSES_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_SIMPlE_SUBSES_FAIL_MASK);
    eval("sub SES_STATUS_SIMPlE_SUBSES_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_SIMPlE_SUBSES_FAIL_SHIFT);
    eval 'sub GEN_SES_STATUS_SIMPlE_SUBSES_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_simple_subses,  &SES_STATUS_SIMPlE_SUBSES, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_SIMPlE_SUBSES_ACCESSORS);
    undef(&GEN_SES_STATUS_SIMPlE_SUBSES_ACCESSORS) if defined(&GEN_SES_STATUS_SIMPlE_SUBSES_ACCESSORS);
    eval("sub SES_STATUS_SAS_EXPANDER_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_SAS_EXPANDER_IDENT_BYTE);
    eval("sub SES_STATUS_SAS_EXPANDER_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_SAS_EXPANDER_IDENT_MASK);
    eval("sub SES_STATUS_SAS_EXPANDER_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_SAS_EXPANDER_IDENT_SHIFT);
    eval("sub SES_STATUS_SAS_EXPANDER_FAIL_BYTE () { 0; }") unless defined(&SES_STATUS_SAS_EXPANDER_FAIL_BYTE);
    eval("sub SES_STATUS_SAS_EXPANDER_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_SAS_EXPANDER_FAIL_MASK);
    eval("sub SES_STATUS_SAS_EXPANDER_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_SAS_EXPANDER_FAIL_SHIFT);
    eval 'sub GEN_SES_STATUS_SAS_EXPANDER_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_sas_expander,  &SES_STATUS_SAS_EXPANDER, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_SAS_EXPANDER_ACCESSORS);
    undef(&GEN_SES_STATUS_SAS_EXPANDER_ACCESSORS) if defined(&GEN_SES_STATUS_SAS_EXPANDER_ACCESSORS);
    eval("sub SES_STATUS_SAS_CONNECTOR_IDENT_BYTE () { 0; }") unless defined(&SES_STATUS_SAS_CONNECTOR_IDENT_BYTE);
    eval("sub SES_STATUS_SAS_CONNECTOR_IDENT_MASK () { 0x80; }") unless defined(&SES_STATUS_SAS_CONNECTOR_IDENT_MASK);
    eval("sub SES_STATUS_SAS_CONNECTOR_IDENT_SHIFT () { 7; }") unless defined(&SES_STATUS_SAS_CONNECTOR_IDENT_SHIFT);
    eval("sub SES_STATUS_SAS_CONNECTOR_TYPE_BYTE () { 0; }") unless defined(&SES_STATUS_SAS_CONNECTOR_TYPE_BYTE);
    eval("sub SES_STATUS_SAS_CONNECTOR_TYPE_MASK () { 0x7F; }") unless defined(&SES_STATUS_SAS_CONNECTOR_TYPE_MASK);
    eval("sub SES_STATUS_SAS_CONNECTOR_TYPE_SHIFT () { 0; }") unless defined(&SES_STATUS_SAS_CONNECTOR_TYPE_SHIFT);
    eval("sub SES_STATUS_SAS_CONNECTOR_PHYS_LINK_BYTE () { 1; }") unless defined(&SES_STATUS_SAS_CONNECTOR_PHYS_LINK_BYTE);
    eval("sub SES_STATUS_SAS_CONNECTOR_PHYS_LINK_MASK () { 0xFF; }") unless defined(&SES_STATUS_SAS_CONNECTOR_PHYS_LINK_MASK);
    eval("sub SES_STATUS_SAS_CONNECTOR_PHYS_LINK_SHIFT () { 0; }") unless defined(&SES_STATUS_SAS_CONNECTOR_PHYS_LINK_SHIFT);
    eval("sub SES_STATUS_SAS_CONNECTOR_PHYS_LINK_ALL () { 0xFF; }") unless defined(&SES_STATUS_SAS_CONNECTOR_PHYS_LINK_ALL);
    eval("sub SES_STATUS_SAS_CONNECTOR_FAIL_BYTE () { 2; }") unless defined(&SES_STATUS_SAS_CONNECTOR_FAIL_BYTE);
    eval("sub SES_STATUS_SAS_CONNECTOR_FAIL_MASK () { 0x40; }") unless defined(&SES_STATUS_SAS_CONNECTOR_FAIL_MASK);
    eval("sub SES_STATUS_SAS_CONNECTOR_FAIL_SHIFT () { 6; }") unless defined(&SES_STATUS_SAS_CONNECTOR_FAIL_SHIFT);
    eval 'sub GEN_SES_STATUS_SAS_CONNECTOR_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_GETTER( &ses_status_sas_connector,  &SES_STATUS_SAS_CONNECTOR, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_SAS_CONNECTOR_ACCESSORS);
    undef(&GEN_SES_STATUS_SAS_CONNECTOR_ACCESSORS) if defined(&GEN_SES_STATUS_SAS_CONNECTOR_ACCESSORS);
    eval("sub SES_STATUS_PAGE_INVOP_MASK () { 0x10; }") unless defined(&SES_STATUS_PAGE_INVOP_MASK);
    eval("sub SES_STATUS_PAGE_INVOP_SHIFT () { 4; }") unless defined(&SES_STATUS_PAGE_INVOP_SHIFT);
    eval("sub SES_STATUS_PAGE_INFO_MASK () { 0x08; }") unless defined(&SES_STATUS_PAGE_INFO_MASK);
    eval("sub SES_STATUS_PAGE_INFO_SHIFT () { 3; }") unless defined(&SES_STATUS_PAGE_INFO_SHIFT);
    eval("sub SES_STATUS_PAGE_NON_CRIT_MASK () { 0x04; }") unless defined(&SES_STATUS_PAGE_NON_CRIT_MASK);
    eval("sub SES_STATUS_PAGE_NON_CRIT_SHIFT () { 2; }") unless defined(&SES_STATUS_PAGE_NON_CRIT_SHIFT);
    eval("sub SES_STATUS_PAGE_CRIT_MASK () { 0x02; }") unless defined(&SES_STATUS_PAGE_CRIT_MASK);
    eval("sub SES_STATUS_PAGE_CRIT_SHIFT () { 1; }") unless defined(&SES_STATUS_PAGE_CRIT_SHIFT);
    eval("sub SES_STATUS_PAGE_UNRECOV_MASK () { 0x01; }") unless defined(&SES_STATUS_PAGE_UNRECOV_MASK);
    eval("sub SES_STATUS_PAGE_UNRECOV_SHIFT () { 0; }") unless defined(&SES_STATUS_PAGE_UNRECOV_SHIFT);
    eval("sub SES_STATUS_PAGE_CHANGED_MASK () { SES_STATUS_PAGE_INVOP_MASK|SES_STATUS_PAGE_INFO_MASK|SES_STATUS_PAGE_NON_CRIT_MASK|SES_STATUS_PAGE_CRIT_MASK|SES_STATUS_PAGE_UNRECOV_MASK; }") unless defined(&SES_STATUS_PAGE_CHANGED_MASK);
    eval("sub SES_STATUS_PAGE_CHANGED_SHIFT () { 0; }") unless defined(&SES_STATUS_PAGE_CHANGED_SHIFT);
    eval 'sub GEN_SES_STATUS_PAGE_ACCESSORS {
        my($LCASE, $UCASE) = @_;
	    eval q( &GEN_HDR_ACCESSORS( &ses_status_page,  &SES_STATUS_PAGE, $LCASE, $UCASE));
    }' unless defined(&GEN_SES_STATUS_PAGE_ACCESSORS);
    undef(&GEN_SES_STATUS_PAGE_ACCESSORS) if defined(&GEN_SES_STATUS_PAGE_ACCESSORS);
    eval 'sub SES_ENCSTAT_UNRECOV () {0x1;}' unless defined(&SES_ENCSTAT_UNRECOV);
    eval 'sub SES_ENCSTAT_CRITICAL () {0x2;}' unless defined(&SES_ENCSTAT_CRITICAL);
    eval 'sub SES_ENCSTAT_NONCRITICAL () {0x4;}' unless defined(&SES_ENCSTAT_NONCRITICAL);
    eval 'sub SES_ENCSTAT_INFO () {0x8;}' unless defined(&SES_ENCSTAT_INFO);
    eval 'sub SES_ENCSTAT_INVOP () {0x10;}' unless defined(&SES_ENCSTAT_INVOP);
    eval 'sub SES_STATUS_MASK () {0x1f;}' unless defined(&SES_STATUS_MASK);
    eval 'sub SES_SET_STATUS_MASK () {0xf;}' unless defined(&SES_SET_STATUS_MASK);
    eval 'sub SES_OBJSTAT_UNSUPPORTED () {0;}' unless defined(&SES_OBJSTAT_UNSUPPORTED);
    eval 'sub SES_OBJSTAT_OK () {1;}' unless defined(&SES_OBJSTAT_OK);
    eval 'sub SES_OBJSTAT_CRIT () {2;}' unless defined(&SES_OBJSTAT_CRIT);
    eval 'sub SES_OBJSTAT_NONCRIT () {3;}' unless defined(&SES_OBJSTAT_NONCRIT);
    eval 'sub SES_OBJSTAT_UNRECOV () {4;}' unless defined(&SES_OBJSTAT_UNRECOV);
    eval 'sub SES_OBJSTAT_NOTINSTALLED () {5;}' unless defined(&SES_OBJSTAT_NOTINSTALLED);
    eval 'sub SES_OBJSTAT_UNKNOWN () {6;}' unless defined(&SES_OBJSTAT_UNKNOWN);
    eval 'sub SES_OBJSTAT_NOTAVAIL () {7;}' unless defined(&SES_OBJSTAT_NOTAVAIL);
    eval 'sub SES_OBJSTAT_NOACCESS () {8;}' unless defined(&SES_OBJSTAT_NOACCESS);
    eval 'sub SESCTL_CSEL () {0x80;}' unless defined(&SESCTL_CSEL);
    eval 'sub SESCTL_PRDFAIL () {0x40;}' unless defined(&SESCTL_PRDFAIL);
    eval 'sub SESCTL_DISABLE () {0x20;}' unless defined(&SESCTL_DISABLE);
    eval 'sub SESCTL_RSTSWAP () {0x10;}' unless defined(&SESCTL_RSTSWAP);
    eval 'sub SESCTL_DRVLCK () {0x40;}' unless defined(&SESCTL_DRVLCK);
    eval 'sub SESCTL_RQSINS () {0x8;}' unless defined(&SESCTL_RQSINS);
    eval 'sub SESCTL_RQSRMV () {0x4;}' unless defined(&SESCTL_RQSRMV);
    eval 'sub SESCTL_RQSID () {0x2;}' unless defined(&SESCTL_RQSID);
    eval 'sub SESCTL_RQSFLT () {0x20;}' unless defined(&SESCTL_RQSFLT);
    eval 'sub SESCTL_DEVOFF () {0x10;}' unless defined(&SESCTL_DEVOFF);
    eval 'sub SESCTL_RQSTFAIL () {0x40;}' unless defined(&SESCTL_RQSTFAIL);
    eval 'sub SESCTL_RQSTON () {0x20;}' unless defined(&SESCTL_RQSTON);
    eval 'sub SES_FC_PORT_BYPASS_UNBYPASSED () {0x;}' unless defined(&SES_FC_PORT_BYPASS_UNBYPASSED);
    eval 'sub SES_FC_PORT_BYPASS_LINKFAIL_RATE_TOO_HIGH () {0x10;}' unless defined(&SES_FC_PORT_BYPASS_LINKFAIL_RATE_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_SYNC_LOSS_RATE_TOO_HIGH () {0x11;}' unless defined(&SES_FC_PORT_BYPASS_SYNC_LOSS_RATE_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_SIGNAL_LOSS_RATE_TOO_HIGH () {0x12;}' unless defined(&SES_FC_PORT_BYPASS_SIGNAL_LOSS_RATE_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_SEQPROTO_ERR_RATE_TOO_HIGH () {0x13;}' unless defined(&SES_FC_PORT_BYPASS_SEQPROTO_ERR_RATE_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_INVAL_XMIT_RATE_TOO_HIGH () {0x14;}' unless defined(&SES_FC_PORT_BYPASS_INVAL_XMIT_RATE_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_CRC_ERR_RATE_TOO_HIGH () {0x15;}' unless defined(&SES_FC_PORT_BYPASS_CRC_ERR_RATE_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_ERR_RATE_RESERVED_BEGIN () {0x16;}' unless defined(&SES_FC_PORT_BYPASS_ERR_RATE_RESERVED_BEGIN);
    eval 'sub SES_FC_PORT_BYPASS_ERR_RATE_RESERVED_END () {0x1f;}' unless defined(&SES_FC_PORT_BYPASS_ERR_RATE_RESERVED_END);
    eval 'sub SES_FC_PORT_BYPASS_LINKFAIL_COUNT_TOO_HIGH () {0x20;}' unless defined(&SES_FC_PORT_BYPASS_LINKFAIL_COUNT_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_SYNC_LOSS_COUNT_TOO_HIGH () {0x21;}' unless defined(&SES_FC_PORT_BYPASS_SYNC_LOSS_COUNT_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_SIGNAL_LOSS_COUNT_TOO_HIGH () {0x22;}' unless defined(&SES_FC_PORT_BYPASS_SIGNAL_LOSS_COUNT_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_SEQPROTO_ERR_COUNT_TOO_HIGH () {0x23;}' unless defined(&SES_FC_PORT_BYPASS_SEQPROTO_ERR_COUNT_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_INVAL_XMIT_COUNT_TOO_HIGH () {0x24;}' unless defined(&SES_FC_PORT_BYPASS_INVAL_XMIT_COUNT_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_CRC_ERR_COUNT_TOO_HIGH () {0x25;}' unless defined(&SES_FC_PORT_BYPASS_CRC_ERR_COUNT_TOO_HIGH);
    eval 'sub SES_FC_PORT_BYPASS_ERR_COUNT_RESERVED_BEGIN () {0x26;}' unless defined(&SES_FC_PORT_BYPASS_ERR_COUNT_RESERVED_BEGIN);
    eval 'sub SES_FC_PORT_BYPASS_ERR_COUNT_RESERVED_END () {0x2f;}' unless defined(&SES_FC_PORT_BYPASS_ERR_COUNT_RESERVED_END);
    eval 'sub SES_FC_PORT_BYPASS_RESERVED_BEGIN () {0x30;}' unless defined(&SES_FC_PORT_BYPASS_RESERVED_BEGIN);
    eval 'sub SES_FC_PORT_BYPASS_RESERVED_END () {0xbf;}' unless defined(&SES_FC_PORT_BYPASS_RESERVED_END);
    eval 'sub SES_FC_PORT_BYPASS_VENDOR_SPECIFIC_BEGIN () {0xc0;}' unless defined(&SES_FC_PORT_BYPASS_VENDOR_SPECIFIC_BEGIN);
    eval 'sub SES_FC_PORT_BYPASS_VENDOR_SPECIFIC_END () {0xff;}' unless defined(&SES_FC_PORT_BYPASS_VENDOR_SPECIFIC_END);
    eval 'sub SES_SASOBJ_DEV_PHY_SMP () {0x2;}' unless defined(&SES_SASOBJ_DEV_PHY_SMP);
    eval 'sub SES_SASOBJ_DEV_PHY_STP () {0x4;}' unless defined(&SES_SASOBJ_DEV_PHY_STP);
    eval 'sub SES_SASOBJ_DEV_PHY_SSP () {0x8;}' unless defined(&SES_SASOBJ_DEV_PHY_SSP);
    eval 'sub SES_SASOBJ_DEV_PHY_PROTOMASK () {0xe;}' unless defined(&SES_SASOBJ_DEV_PHY_PROTOMASK);
    if(defined(&_KERNEL)) {
    }
    eval 'sub SES_SASOBJ_TYPE0_NOT_ALL_PHYS {
        my($obj) = @_;
	    eval q((($obj)-> &byte1 & 0x1));
    }' unless defined(&SES_SASOBJ_TYPE0_NOT_ALL_PHYS);
    eval 'sub SES_SASOBJ_TYPE_SLOT () {0;}' unless defined(&SES_SASOBJ_TYPE_SLOT);
    eval 'sub SES_SASOBJ_TYPE_OTHER () {1;}' unless defined(&SES_SASOBJ_TYPE_OTHER);
    eval 'sub SES_ADDL_EIP_EIIOE () {1;}' unless defined(&SES_ADDL_EIP_EIIOE);
    eval 'sub SES_EIP_HDR_EXTRA_LEN () {2;}' unless defined(&SES_EIP_HDR_EXTRA_LEN);
    undef(&GEN_HDR_ACCESSORS) if defined(&GEN_HDR_ACCESSORS);
    undef(&GEN_ACCESSORS) if defined(&GEN_ACCESSORS);
    undef(&GEN_HDR_SETTER) if defined(&GEN_HDR_SETTER);
    undef(&GEN_HDR_GETTER) if defined(&GEN_HDR_GETTER);
    undef(&GEN_SETTER) if defined(&GEN_SETTER);
    undef(&GEN_GETTER) if defined(&GEN_GETTER);
    undef(&MK_ENUM) if defined(&MK_ENUM);
}
1;
