require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SCSI_SMP_ALL_H)) {
    eval 'sub _SCSI_SMP_ALL_H () {1;}' unless defined(&_SCSI_SMP_ALL_H);
    eval 'sub SMP_FRAME_TYPE_REQUEST () {0x40;}' unless defined(&SMP_FRAME_TYPE_REQUEST);
    eval 'sub SMP_FRAME_TYPE_RESPONSE () {0x41;}' unless defined(&SMP_FRAME_TYPE_RESPONSE);
    eval 'sub SMP_WORD_LEN () {4;}' unless defined(&SMP_WORD_LEN);
    eval 'sub SMP_CRC_LEN () {4;}' unless defined(&SMP_CRC_LEN);
    eval 'sub SMP_FUNC_REPORT_GENERAL () {0x;}' unless defined(&SMP_FUNC_REPORT_GENERAL);
    eval 'sub SMP_FUNC_REPORT_MANUF_INFO () {0x1;}' unless defined(&SMP_FUNC_REPORT_MANUF_INFO);
    eval 'sub SMP_FUNC_REPORT_SC_STATUS () {0x3;}' unless defined(&SMP_FUNC_REPORT_SC_STATUS);
    eval 'sub SMP_FUNC_REPORT_ZONE_PERM_TBL () {0x4;}' unless defined(&SMP_FUNC_REPORT_ZONE_PERM_TBL);
    eval 'sub SMP_FUNC_REPORT_ZONE_MAN_PWD () {0x5;}' unless defined(&SMP_FUNC_REPORT_ZONE_MAN_PWD);
    eval 'sub SMP_FUNC_REPORT_BROADCAST () {0x6;}' unless defined(&SMP_FUNC_REPORT_BROADCAST);
    eval 'sub SMP_FUNC_DISCOVER () {0x10;}' unless defined(&SMP_FUNC_DISCOVER);
    eval 'sub SMP_FUNC_REPORT_PHY_ERR_LOG () {0x11;}' unless defined(&SMP_FUNC_REPORT_PHY_ERR_LOG);
    eval 'sub SMP_FUNC_REPORT_PHY_SATA () {0x12;}' unless defined(&SMP_FUNC_REPORT_PHY_SATA);
    eval 'sub SMP_FUNC_REPORT_ROUTE_INFO () {0x13;}' unless defined(&SMP_FUNC_REPORT_ROUTE_INFO);
    eval 'sub SMP_FUNC_REPORT_PHY_EVENT () {0x14;}' unless defined(&SMP_FUNC_REPORT_PHY_EVENT);
    eval 'sub SMP_FUNC_DISCOVER_LIST () {0x20;}' unless defined(&SMP_FUNC_DISCOVER_LIST);
    eval 'sub SMP_FUNC_REPORT_PHY_EVENT_LIST () {0x21;}' unless defined(&SMP_FUNC_REPORT_PHY_EVENT_LIST);
    eval 'sub SMP_FUNC_REPORT_EXP_RTL () {0x22;}' unless defined(&SMP_FUNC_REPORT_EXP_RTL);
    eval 'sub SMP_FUNC_CONFIG_GENERAL () {0x80;}' unless defined(&SMP_FUNC_CONFIG_GENERAL);
    eval 'sub SMP_FUNC_ENABLE_DISABLE_ZONING () {0x81;}' unless defined(&SMP_FUNC_ENABLE_DISABLE_ZONING);
    eval 'sub SMP_FUNC_ZONED_BROADCAST () {0x85;}' unless defined(&SMP_FUNC_ZONED_BROADCAST);
    eval 'sub SMP_FUNC_ZONE_LOCK () {0x86;}' unless defined(&SMP_FUNC_ZONE_LOCK);
    eval 'sub SMP_FUNC_ZONE_ACTIVATE () {0x87;}' unless defined(&SMP_FUNC_ZONE_ACTIVATE);
    eval 'sub SMP_FUNC_ZONE_UNLOCK () {0x88;}' unless defined(&SMP_FUNC_ZONE_UNLOCK);
    eval 'sub SMP_FUNC_CONFIG_ZM_PWD () {0x89;}' unless defined(&SMP_FUNC_CONFIG_ZM_PWD);
    eval 'sub SMP_FUNC_CONFIG_ZONE_PHY_INFO () {0x8a;}' unless defined(&SMP_FUNC_CONFIG_ZONE_PHY_INFO);
    eval 'sub SMP_FUNC_CONFIG_ZONE_PERM_TBL () {0x8b;}' unless defined(&SMP_FUNC_CONFIG_ZONE_PERM_TBL);
    eval 'sub SMP_FUNC_CONFIG_ROUTE_INFO () {0x90;}' unless defined(&SMP_FUNC_CONFIG_ROUTE_INFO);
    eval 'sub SMP_FUNC_PHY_CONTROL () {0x91;}' unless defined(&SMP_FUNC_PHY_CONTROL);
    eval 'sub SMP_FUNC_PHY_TEST_FUNC () {0x92;}' unless defined(&SMP_FUNC_PHY_TEST_FUNC);
    eval 'sub SMP_FUNC_CONFIG_PHY_EVENT () {0x93;}' unless defined(&SMP_FUNC_CONFIG_PHY_EVENT);
    eval 'sub SMP_FR_ACCEPTED () {0x;}' unless defined(&SMP_FR_ACCEPTED);
    eval 'sub SMP_FR_UNKNOWN_FUNC () {0x1;}' unless defined(&SMP_FR_UNKNOWN_FUNC);
    eval 'sub SMP_FR_FUNCTION_FAILED () {0x2;}' unless defined(&SMP_FR_FUNCTION_FAILED);
    eval 'sub SMP_FR_INVALID_REQ_FRAME_LEN () {0x3;}' unless defined(&SMP_FR_INVALID_REQ_FRAME_LEN);
    eval 'sub SMP_FR_INVALID_EXP_CHG_CNT () {0x4;}' unless defined(&SMP_FR_INVALID_EXP_CHG_CNT);
    eval 'sub SMP_FR_BUSY () {0x5;}' unless defined(&SMP_FR_BUSY);
    eval 'sub SMP_FR_INCOMPLETE_DESC_LIST () {0x6;}' unless defined(&SMP_FR_INCOMPLETE_DESC_LIST);
    eval 'sub SMP_FR_PHY_DOES_NOT_EXIST () {0x10;}' unless defined(&SMP_FR_PHY_DOES_NOT_EXIST);
    eval 'sub SMP_FR_INDEX_DOES_NOT_EXIST () {0x11;}' unless defined(&SMP_FR_INDEX_DOES_NOT_EXIST);
    eval 'sub SMP_FR_PHY_DOES_NOT_SUP_SATA () {0x12;}' unless defined(&SMP_FR_PHY_DOES_NOT_SUP_SATA);
    eval 'sub SMP_FR_UNKNOWN_PHY_OP () {0x13;}' unless defined(&SMP_FR_UNKNOWN_PHY_OP);
    eval 'sub SMP_FR_UNKNOWN_PHY_TEST_FUNC () {0x14;}' unless defined(&SMP_FR_UNKNOWN_PHY_TEST_FUNC);
    eval 'sub SMP_FR_PHY_TEST_FUNC_INPROG () {0x15;}' unless defined(&SMP_FR_PHY_TEST_FUNC_INPROG);
    eval 'sub SMP_FR_PHY_VACANT () {0x16;}' unless defined(&SMP_FR_PHY_VACANT);
    eval 'sub SMP_FR_UNKNOWN_PHY_EVENT_SRC () {0x17;}' unless defined(&SMP_FR_UNKNOWN_PHY_EVENT_SRC);
    eval 'sub SMP_FR_UNKNOWN_DESC_TYPE () {0x18;}' unless defined(&SMP_FR_UNKNOWN_DESC_TYPE);
    eval 'sub SMP_FR_UNKNOWN_PHY_FILTER () {0x19;}' unless defined(&SMP_FR_UNKNOWN_PHY_FILTER);
    eval 'sub SMP_FR_AFFILIATION_VIOLATION () {0x1a;}' unless defined(&SMP_FR_AFFILIATION_VIOLATION);
    eval 'sub SMP_FR_SMP_ZONE_VIOLATION () {0x20;}' unless defined(&SMP_FR_SMP_ZONE_VIOLATION);
    eval 'sub SMP_FR_NO_MGMT_ACCESS_RIGHTS () {0x21;}' unless defined(&SMP_FR_NO_MGMT_ACCESS_RIGHTS);
    eval 'sub SMP_FR_UNKNOWN_ED_ZONING_VAL () {0x22;}' unless defined(&SMP_FR_UNKNOWN_ED_ZONING_VAL);
    eval 'sub SMP_FR_ZONE_LOCK_VIOLATION () {0x23;}' unless defined(&SMP_FR_ZONE_LOCK_VIOLATION);
    eval 'sub SMP_FR_NOT_ACTIVATED () {0x24;}' unless defined(&SMP_FR_NOT_ACTIVATED);
    eval 'sub SMP_FR_ZG_OUT_OF_RANGE () {0x25;}' unless defined(&SMP_FR_ZG_OUT_OF_RANGE);
    eval 'sub SMP_FR_NO_PHYS_PRESENCE () {0x26;}' unless defined(&SMP_FR_NO_PHYS_PRESENCE);
    eval 'sub SMP_FR_SAVING_NOT_SUP () {0x27;}' unless defined(&SMP_FR_SAVING_NOT_SUP);
    eval 'sub SMP_FR_SRC_ZONE_DNE () {0x28;}' unless defined(&SMP_FR_SRC_ZONE_DNE);
    eval 'sub SMP_FR_DISABLED_PWD_NOT_SUP () {0x29;}' unless defined(&SMP_FR_DISABLED_PWD_NOT_SUP);
    eval 'sub SMP_RG_RESPONSE_LEN () {0x11;}' unless defined(&SMP_RG_RESPONSE_LEN);
    eval 'sub SMP_RG_LONG_RESPONSE () {0x80;}' unless defined(&SMP_RG_LONG_RESPONSE);
    eval 'sub SMP_RG_TABLE_TO_TABLE_SUP () {0x80;}' unless defined(&SMP_RG_TABLE_TO_TABLE_SUP);
    eval 'sub SMP_RG_ZONE_CONFIGURING () {0x40;}' unless defined(&SMP_RG_ZONE_CONFIGURING);
    eval 'sub SMP_RG_SELF_CONFIGURING () {0x20;}' unless defined(&SMP_RG_SELF_CONFIGURING);
    eval 'sub SMP_RG_STP_CONTINUE_AWT () {0x10;}' unless defined(&SMP_RG_STP_CONTINUE_AWT);
    eval 'sub SMP_RG_OPEN_REJECT_RETRY_SUP () {0x8;}' unless defined(&SMP_RG_OPEN_REJECT_RETRY_SUP);
    eval 'sub SMP_RG_CONFIGURES_OTHERS () {0x4;}' unless defined(&SMP_RG_CONFIGURES_OTHERS);
    eval 'sub SMP_RG_CONFIGURING () {0x2;}' unless defined(&SMP_RG_CONFIGURING);
    eval 'sub SMP_RG_EXT_CONFIG_ROUTE_TABLE () {0x1;}' unless defined(&SMP_RG_EXT_CONFIG_ROUTE_TABLE);
    eval 'sub SMP_RG_NUM_ZONE_GROUPS_MASK () {0xc0;}' unless defined(&SMP_RG_NUM_ZONE_GROUPS_MASK);
    eval 'sub SMP_RG_NUM_ZONE_GROUPS_SHIFT () {6;}' unless defined(&SMP_RG_NUM_ZONE_GROUPS_SHIFT);
    eval 'sub SMP_RG_ZONE_LOCKED () {0x10;}' unless defined(&SMP_RG_ZONE_LOCKED);
    eval 'sub SMP_RG_PP_SUPPORTED () {0x8;}' unless defined(&SMP_RG_PP_SUPPORTED);
    eval 'sub SMP_RG_PP_ASSERTED () {0x4;}' unless defined(&SMP_RG_PP_ASSERTED);
    eval 'sub SMP_RG_ZONING_SUPPORTED () {0x2;}' unless defined(&SMP_RG_ZONING_SUPPORTED);
    eval 'sub SMP_RG_ZONING_ENABLED () {0x1;}' unless defined(&SMP_RG_ZONING_ENABLED);
    eval 'sub SMP_RG_SAVING () {0x10;}' unless defined(&SMP_RG_SAVING);
    eval 'sub SMP_RG_SAVING_ZM_PWD_SUP () {0x8;}' unless defined(&SMP_RG_SAVING_ZM_PWD_SUP);
    eval 'sub SMP_RG_SAVING_PHY_INFO_SUP () {0x4;}' unless defined(&SMP_RG_SAVING_PHY_INFO_SUP);
    eval 'sub SMP_RG_SAVING_ZPERM_TAB_SUP () {0x2;}' unless defined(&SMP_RG_SAVING_ZPERM_TAB_SUP);
    eval 'sub SMP_RG_SAVING_ZENABLED_SUP () {0x1;}' unless defined(&SMP_RG_SAVING_ZENABLED_SUP);
    eval 'sub SMP_RG_REDUCED_FUNCTIONALITY () {0x80;}' unless defined(&SMP_RG_REDUCED_FUNCTIONALITY);
    eval 'sub SMP_RMI_REQUEST_LEN () {0x;}' unless defined(&SMP_RMI_REQUEST_LEN);
    eval 'sub SMP_RMI_RESPONSE_LEN () {0xe;}' unless defined(&SMP_RMI_RESPONSE_LEN);
    eval 'sub SMP_RMI_SAS11_FORMAT () {0x1;}' unless defined(&SMP_RMI_SAS11_FORMAT);
    eval 'sub SMP_DIS_REQUEST_LEN () {0x2;}' unless defined(&SMP_DIS_REQUEST_LEN);
    eval 'sub SMP_DIS_IGNORE_ZONE_GROUP () {0x1;}' unless defined(&SMP_DIS_IGNORE_ZONE_GROUP);
    eval 'sub SMP_DIS_RESPONSE_LEN () {0x20;}' unless defined(&SMP_DIS_RESPONSE_LEN);
    eval 'sub SMP_DIS_AD_TYPE_MASK () {0x70;}' unless defined(&SMP_DIS_AD_TYPE_MASK);
    eval 'sub SMP_DIS_AD_TYPE_NONE () {0x;}' unless defined(&SMP_DIS_AD_TYPE_NONE);
    eval 'sub SMP_DIS_AD_TYPE_SAS_SATA () {0x10;}' unless defined(&SMP_DIS_AD_TYPE_SAS_SATA);
    eval 'sub SMP_DIS_AD_TYPE_EXP () {0x20;}' unless defined(&SMP_DIS_AD_TYPE_EXP);
    eval 'sub SMP_DIS_AD_TYPE_EXP_OLD () {0x30;}' unless defined(&SMP_DIS_AD_TYPE_EXP_OLD);
    eval 'sub SMP_DIS_ATTACH_REASON_MASK () {0xf;}' unless defined(&SMP_DIS_ATTACH_REASON_MASK);
    eval 'sub SMP_DIS_LR_MASK () {0xf;}' unless defined(&SMP_DIS_LR_MASK);
    eval 'sub SMP_DIS_LR_DISABLED () {0x1;}' unless defined(&SMP_DIS_LR_DISABLED);
    eval 'sub SMP_DIS_LR_PHY_RES_PROB () {0x2;}' unless defined(&SMP_DIS_LR_PHY_RES_PROB);
    eval 'sub SMP_DIS_LR_SPINUP_HOLD () {0x3;}' unless defined(&SMP_DIS_LR_SPINUP_HOLD);
    eval 'sub SMP_DIS_LR_PORT_SEL () {0x4;}' unless defined(&SMP_DIS_LR_PORT_SEL);
    eval 'sub SMP_DIS_LR_RESET_IN_PROG () {0x5;}' unless defined(&SMP_DIS_LR_RESET_IN_PROG);
    eval 'sub SMP_DIS_LR_UNSUP_PHY_ATTACHED () {0x6;}' unless defined(&SMP_DIS_LR_UNSUP_PHY_ATTACHED);
    eval 'sub SMP_DIS_LR_G1_15GBPS () {0x8;}' unless defined(&SMP_DIS_LR_G1_15GBPS);
    eval 'sub SMP_DIS_LR_G2_30GBPS () {0x9;}' unless defined(&SMP_DIS_LR_G2_30GBPS);
    eval 'sub SMP_DIS_LR_G3_60GBPS () {0xa;}' unless defined(&SMP_DIS_LR_G3_60GBPS);
    eval 'sub SMP_DIS_ATTACHED_SSP_INIT () {0x8;}' unless defined(&SMP_DIS_ATTACHED_SSP_INIT);
    eval 'sub SMP_DIS_ATTACHED_STP_INIT () {0x4;}' unless defined(&SMP_DIS_ATTACHED_STP_INIT);
    eval 'sub SMP_DIS_ATTACHED_SMP_INIT () {0x2;}' unless defined(&SMP_DIS_ATTACHED_SMP_INIT);
    eval 'sub SMP_DIS_ATTACHED_SATA_HOST () {0x1;}' unless defined(&SMP_DIS_ATTACHED_SATA_HOST);
    eval 'sub SMP_DIS_ATTACHED_SATA_PORTSEL () {0x80;}' unless defined(&SMP_DIS_ATTACHED_SATA_PORTSEL);
    eval 'sub SMP_DIS_STP_BUFFER_TOO_SMALL () {0x10;}' unless defined(&SMP_DIS_STP_BUFFER_TOO_SMALL);
    eval 'sub SMP_DIS_ATTACHED_SSP_TARG () {0x8;}' unless defined(&SMP_DIS_ATTACHED_SSP_TARG);
    eval 'sub SMP_DIS_ATTACHED_STP_TARG () {0x4;}' unless defined(&SMP_DIS_ATTACHED_STP_TARG);
    eval 'sub SMP_DIS_ATTACHED_SMP_TARG () {0x2;}' unless defined(&SMP_DIS_ATTACHED_SMP_TARG);
    eval 'sub SMP_DIS_ATTACHED_SATA_DEV () {0x1;}' unless defined(&SMP_DIS_ATTACHED_SATA_DEV);
    eval 'sub SMP_DIS_ATT_SLUMB_CAP () {0x10;}' unless defined(&SMP_DIS_ATT_SLUMB_CAP);
    eval 'sub SMP_DIS_ATT_PAR_CAP () {0x8;}' unless defined(&SMP_DIS_ATT_PAR_CAP);
    eval 'sub SMP_DIS_ATT_IN_ZPSDS_PER () {0x4;}' unless defined(&SMP_DIS_ATT_IN_ZPSDS_PER);
    eval 'sub SMP_DIS_ATT_REQ_IN_ZPSDS () {0x2;}' unless defined(&SMP_DIS_ATT_REQ_IN_ZPSDS);
    eval 'sub SMP_DIS_ATT_BREAK_RPL_CAP () {0x1;}' unless defined(&SMP_DIS_ATT_BREAK_RPL_CAP);
    eval 'sub SMP_DIS_PROG_MIN_LR_MASK () {0xf0;}' unless defined(&SMP_DIS_PROG_MIN_LR_MASK);
    eval 'sub SMP_DIS_PROG_MIN_LR_SHIFT () {4;}' unless defined(&SMP_DIS_PROG_MIN_LR_SHIFT);
    eval 'sub SMP_DIS_HARD_MIN_LR_MASK () {0xf;}' unless defined(&SMP_DIS_HARD_MIN_LR_MASK);
    eval 'sub SMP_DIS_PROG_MAX_LR_MAX () {0xf0;}' unless defined(&SMP_DIS_PROG_MAX_LR_MAX);
    eval 'sub SMP_DIS_PROG_MAX_LR_SHIFT () {4;}' unless defined(&SMP_DIS_PROG_MAX_LR_SHIFT);
    eval 'sub SMP_DIS_HARD_MAX_LR_MASK () {0xf;}' unless defined(&SMP_DIS_HARD_MAX_LR_MASK);
    eval 'sub SMP_DIS_VIRTUAL_PHY () {0x80;}' unless defined(&SMP_DIS_VIRTUAL_PHY);
    eval 'sub SMP_DIS_PP_TIMEOUT_MASK () {0xf;}' unless defined(&SMP_DIS_PP_TIMEOUT_MASK);
    eval 'sub SMP_DIS_PHY_POW_COND_MASK () {0xc0;}' unless defined(&SMP_DIS_PHY_POW_COND_MASK);
    eval 'sub SMP_DIS_PHY_POW_COND_SHIFT () {6;}' unless defined(&SMP_DIS_PHY_POW_COND_SHIFT);
    eval 'sub SMP_DIS_SAS_SLUMB_CAP () {0x8;}' unless defined(&SMP_DIS_SAS_SLUMB_CAP);
    eval 'sub SMP_DIS_SAS_PART_CAP () {0x4;}' unless defined(&SMP_DIS_SAS_PART_CAP);
    eval 'sub SMP_DIS_SATA_SLUMB_CAP () {0x2;}' unless defined(&SMP_DIS_SATA_SLUMB_CAP);
    eval 'sub SMP_DIS_SATA_PART_CAP () {0x1;}' unless defined(&SMP_DIS_SATA_PART_CAP);
    eval 'sub SMP_DIS_SAS_SLUMB_ENB () {0x8;}' unless defined(&SMP_DIS_SAS_SLUMB_ENB);
    eval 'sub SMP_DIS_SAS_PART_ENB () {0x4;}' unless defined(&SMP_DIS_SAS_PART_ENB);
    eval 'sub SMP_DIS_SATA_SLUMB_ENB () {0x2;}' unless defined(&SMP_DIS_SATA_SLUMB_ENB);
    eval 'sub SMP_DIS_SATA_PART_ENB () {0x1;}' unless defined(&SMP_DIS_SATA_PART_ENB);
    eval 'sub SMP_DIS_REQ_IN_ZPSDS_CHG () {0x40;}' unless defined(&SMP_DIS_REQ_IN_ZPSDS_CHG);
    eval 'sub SMP_DIS_IN_ZPSDS_PER () {0x20;}' unless defined(&SMP_DIS_IN_ZPSDS_PER);
    eval 'sub SMP_DIS_REQ_IN_ZPSDS () {0x10;}' unless defined(&SMP_DIS_REQ_IN_ZPSDS);
    eval 'sub SMP_DIS_ZG_PER () {0x4;}' unless defined(&SMP_DIS_ZG_PER);
    eval 'sub SMP_DIS_IN_ZPSDS () {0x2;}' unless defined(&SMP_DIS_IN_ZPSDS);
    eval 'sub SMP_DIS_ZONING_ENB () {0x1;}' unless defined(&SMP_DIS_ZONING_ENB);
    eval 'sub SMP_DIS_REASON_MASK () {0xf0;}' unless defined(&SMP_DIS_REASON_MASK);
    eval 'sub SMP_DIS_REASON_SHIFT () {4;}' unless defined(&SMP_DIS_REASON_SHIFT);
    eval 'sub SMP_DIS_PHYS_LR_MASK () {0xf;}' unless defined(&SMP_DIS_PHYS_LR_MASK);
    eval 'sub SMP_DIS_OPTICAL_MODE_ENB () {0x4;}' unless defined(&SMP_DIS_OPTICAL_MODE_ENB);
    eval 'sub SMP_DIS_NEG_SSC () {0x2;}' unless defined(&SMP_DIS_NEG_SSC);
    eval 'sub SMP_DIS_HW_MUX_SUP () {0x1;}' unless defined(&SMP_DIS_HW_MUX_SUP);
    eval 'sub SMP_DIS_DEF_IN_ZPSDS_PER () {0x20;}' unless defined(&SMP_DIS_DEF_IN_ZPSDS_PER);
    eval 'sub SMP_DIS_DEF_REQ_IN_ZPSDS () {0x10;}' unless defined(&SMP_DIS_DEF_REQ_IN_ZPSDS);
    eval 'sub SMP_DIS_DEF_ZG_PER () {0x4;}' unless defined(&SMP_DIS_DEF_ZG_PER);
    eval 'sub SMP_DIS_DEF_ZONING_ENB () {0x1;}' unless defined(&SMP_DIS_DEF_ZONING_ENB);
    eval 'sub SMP_DIS_SAVED_IN_ZPSDS_PER () {0x20;}' unless defined(&SMP_DIS_SAVED_IN_ZPSDS_PER);
    eval 'sub SMP_DIS_SAVED_REQ_IN_SPSDS () {0x10;}' unless defined(&SMP_DIS_SAVED_REQ_IN_SPSDS);
    eval 'sub SMP_DIS_SAVED_ZG_PER () {0x4;}' unless defined(&SMP_DIS_SAVED_ZG_PER);
    eval 'sub SMP_DIS_SAVED_ZONING_ENB () {0x1;}' unless defined(&SMP_DIS_SAVED_ZONING_ENB);
    eval 'sub SMP_DIS_SHADOW_IN_ZPSDS_PER () {0x20;}' unless defined(&SMP_DIS_SHADOW_IN_ZPSDS_PER);
    eval 'sub SMP_DIS_SHADOW_IN_REQ_IN_ZPSDS () {0x10;}' unless defined(&SMP_DIS_SHADOW_IN_REQ_IN_ZPSDS);
    eval 'sub SMP_DIS_SHADOW_ZG_PER () {0x4;}' unless defined(&SMP_DIS_SHADOW_ZG_PER);
    eval 'sub SMP_PC_RESPONSE_LEN () {0x;}' unless defined(&SMP_PC_RESPONSE_LEN);
    eval 'sub SMP_PC_REQUEST_LEN () {0x9;}' unless defined(&SMP_PC_REQUEST_LEN);
    eval 'sub SMP_PC_PHY_OP_NOP () {0x;}' unless defined(&SMP_PC_PHY_OP_NOP);
    eval 'sub SMP_PC_PHY_OP_LINK_RESET () {0x1;}' unless defined(&SMP_PC_PHY_OP_LINK_RESET);
    eval 'sub SMP_PC_PHY_OP_HARD_RESET () {0x2;}' unless defined(&SMP_PC_PHY_OP_HARD_RESET);
    eval 'sub SMP_PC_PHY_OP_DISABLE () {0x3;}' unless defined(&SMP_PC_PHY_OP_DISABLE);
    eval 'sub SMP_PC_PHY_OP_CLEAR_ERR_LOG () {0x5;}' unless defined(&SMP_PC_PHY_OP_CLEAR_ERR_LOG);
    eval 'sub SMP_PC_PHY_OP_CLEAR_AFFILIATON () {0x6;}' unless defined(&SMP_PC_PHY_OP_CLEAR_AFFILIATON);
    eval 'sub SMP_PC_PHY_OP_TRANS_SATA_PSS () {0x7;}' unless defined(&SMP_PC_PHY_OP_TRANS_SATA_PSS);
    eval 'sub SMP_PC_PHY_OP_CLEAR_STP_ITN_LS () {0x8;}' unless defined(&SMP_PC_PHY_OP_CLEAR_STP_ITN_LS);
    eval 'sub SMP_PC_PHY_OP_SET_ATT_DEV_NAME () {0x9;}' unless defined(&SMP_PC_PHY_OP_SET_ATT_DEV_NAME);
    eval 'sub SMP_PC_UPDATE_PP_TIMEOUT () {0x1;}' unless defined(&SMP_PC_UPDATE_PP_TIMEOUT);
    eval 'sub SMP_PC_PROG_MIN_PL_RATE_MASK () {0xf0;}' unless defined(&SMP_PC_PROG_MIN_PL_RATE_MASK);
    eval 'sub SMP_PC_PROG_MIN_PL_RATE_SHIFT () {4;}' unless defined(&SMP_PC_PROG_MIN_PL_RATE_SHIFT);
    eval 'sub SMP_PC_PROG_MAX_PL_RATE_MASK () {0xf0;}' unless defined(&SMP_PC_PROG_MAX_PL_RATE_MASK);
    eval 'sub SMP_PC_PROG_MAX_PL_RATE_SHIFT () {4;}' unless defined(&SMP_PC_PROG_MAX_PL_RATE_SHIFT);
    eval 'sub SMP_PC_SP_NC () {0x;}' unless defined(&SMP_PC_SP_NC);
    eval 'sub SMP_PC_SP_DISABLE () {0x2;}' unless defined(&SMP_PC_SP_DISABLE);
    eval 'sub SMP_PC_SP_ENABLE () {0x1;}' unless defined(&SMP_PC_SP_ENABLE);
    eval 'sub SMP_PC_SAS_SLUMBER_NC () {0x;}' unless defined(&SMP_PC_SAS_SLUMBER_NC);
    eval 'sub SMP_PC_SAS_SLUMBER_DISABLE () {0x80;}' unless defined(&SMP_PC_SAS_SLUMBER_DISABLE);
    eval 'sub SMP_PC_SAS_SLUMBER_ENABLE () {0x40;}' unless defined(&SMP_PC_SAS_SLUMBER_ENABLE);
    eval 'sub SMP_PC_SAS_SLUMBER_MASK () {0xc0;}' unless defined(&SMP_PC_SAS_SLUMBER_MASK);
    eval 'sub SMP_PC_SAS_SLUMBER_SHIFT () {6;}' unless defined(&SMP_PC_SAS_SLUMBER_SHIFT);
    eval 'sub SMP_PC_SAS_PARTIAL_NC () {0x;}' unless defined(&SMP_PC_SAS_PARTIAL_NC);
    eval 'sub SMP_PC_SAS_PARTIAL_DISABLE () {0x20;}' unless defined(&SMP_PC_SAS_PARTIAL_DISABLE);
    eval 'sub SMP_PC_SAS_PARTIAL_ENABLE () {0x10;}' unless defined(&SMP_PC_SAS_PARTIAL_ENABLE);
    eval 'sub SMP_PC_SAS_PARTIAL_MASK () {0x30;}' unless defined(&SMP_PC_SAS_PARTIAL_MASK);
    eval 'sub SMP_PC_SAS_PARTIAL_SHIFT () {4;}' unless defined(&SMP_PC_SAS_PARTIAL_SHIFT);
    eval 'sub SMP_PC_SATA_SLUMBER_NC () {0x;}' unless defined(&SMP_PC_SATA_SLUMBER_NC);
    eval 'sub SMP_PC_SATA_SLUMBER_DISABLE () {0x8;}' unless defined(&SMP_PC_SATA_SLUMBER_DISABLE);
    eval 'sub SMP_PC_SATA_SLUMBER_ENABLE () {0x4;}' unless defined(&SMP_PC_SATA_SLUMBER_ENABLE);
    eval 'sub SMP_PC_SATA_SLUMBER_MASK () {0xc;}' unless defined(&SMP_PC_SATA_SLUMBER_MASK);
    eval 'sub SMP_PC_SATA_SLUMBER_SHIFT () {2;}' unless defined(&SMP_PC_SATA_SLUMBER_SHIFT);
    eval 'sub SMP_PC_SATA_PARTIAL_NC () {0x;}' unless defined(&SMP_PC_SATA_PARTIAL_NC);
    eval 'sub SMP_PC_SATA_PARTIAL_DISABLE () {0x2;}' unless defined(&SMP_PC_SATA_PARTIAL_DISABLE);
    eval 'sub SMP_PC_SATA_PARTIAL_ENABLE () {0x1;}' unless defined(&SMP_PC_SATA_PARTIAL_ENABLE);
    eval 'sub SMP_PC_SATA_PARTIAL_MASK () {0x3;}' unless defined(&SMP_PC_SATA_PARTIAL_MASK);
    eval 'sub SMP_PC_SATA_PARTIAL_SHIFT () {0;}' unless defined(&SMP_PC_SATA_PARTIAL_SHIFT);
    eval 'sub SMP_PC_PP_TIMEOUT_MASK () {0xf;}' unless defined(&SMP_PC_PP_TIMEOUT_MASK);
    eval 'sub SMP_PC_RESPONSE_LEN () {0x;}' unless defined(&SMP_PC_RESPONSE_LEN);
    if(defined(&_KERNEL)) {
    } else {
    }
}
1;
