require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IF_AIRONET_IEEE_H)) {
    eval 'sub _IF_AIRONET_IEEE_H () {1;}' unless defined(&_IF_AIRONET_IEEE_H);
    unless(defined(&SIOCSAIRONET)) {
	eval 'sub SIOCSAIRONET () { &SIOCSIFGENERIC;}' unless defined(&SIOCSAIRONET);
    }
    unless(defined(&SIOCGAIRONET)) {
	eval 'sub SIOCGAIRONET () { &SIOCGIFGENERIC;}' unless defined(&SIOCGAIRONET);
    }
    eval 'sub AN_RID_TX_SPEED () {0x1234;}' unless defined(&AN_RID_TX_SPEED);
    eval 'sub AN_MAX_DATALEN () {4096;}' unless defined(&AN_MAX_DATALEN);
    eval 'sub AN_RID_IFACE_STATS () {0x100;}' unless defined(&AN_RID_IFACE_STATS);
    eval 'sub AN_RID_MGMT_XMIT () {0x200;}' unless defined(&AN_RID_MGMT_XMIT);
    if(defined(&ANCACHE)) {
	eval 'sub AN_RID_ZERO_CACHE () {0x300;}' unless defined(&AN_RID_ZERO_CACHE);
	eval 'sub AN_RID_READ_CACHE () {0x400;}' unless defined(&AN_RID_READ_CACHE);
    }
    eval 'sub AN_FCTL_VERS () {0x2;}' unless defined(&AN_FCTL_VERS);
    eval 'sub AN_FCTL_FTYPE () {0xc;}' unless defined(&AN_FCTL_FTYPE);
    eval 'sub AN_FCTL_STYPE () {0xf0;}' unless defined(&AN_FCTL_STYPE);
    eval 'sub AN_FCTL_TODS () {0x100;}' unless defined(&AN_FCTL_TODS);
    eval 'sub AN_FCTL_FROMDS () {0x200;}' unless defined(&AN_FCTL_FROMDS);
    eval 'sub AN_FCTL_MOREFRAGS () {0x400;}' unless defined(&AN_FCTL_MOREFRAGS);
    eval 'sub AN_FCTL_RETRY () {0x800;}' unless defined(&AN_FCTL_RETRY);
    eval 'sub AN_FCTL_PM () {0x1000;}' unless defined(&AN_FCTL_PM);
    eval 'sub AN_FCTL_MOREDATA () {0x2000;}' unless defined(&AN_FCTL_MOREDATA);
    eval 'sub AN_FCTL_WEP () {0x4000;}' unless defined(&AN_FCTL_WEP);
    eval 'sub AN_FCTL_ORDER () {0x8000;}' unless defined(&AN_FCTL_ORDER);
    eval 'sub AN_FTYPE_MGMT () {0x;}' unless defined(&AN_FTYPE_MGMT);
    eval 'sub AN_FTYPE_CTL () {0x4;}' unless defined(&AN_FTYPE_CTL);
    eval 'sub AN_FTYPE_DATA () {0x8;}' unless defined(&AN_FTYPE_DATA);
    eval 'sub AN_STYPE_MGMT_ASREQ () {0x;}' unless defined(&AN_STYPE_MGMT_ASREQ);
    eval 'sub AN_STYPE_MGMT_ASRESP () {0x10;}' unless defined(&AN_STYPE_MGMT_ASRESP);
    eval 'sub AN_STYPE_MGMT_REASREQ () {0x20;}' unless defined(&AN_STYPE_MGMT_REASREQ);
    eval 'sub AN_STYPE_MGMT_REASRESP () {0x30;}' unless defined(&AN_STYPE_MGMT_REASRESP);
    eval 'sub AN_STYPE_MGMT_PROBEREQ () {0x40;}' unless defined(&AN_STYPE_MGMT_PROBEREQ);
    eval 'sub AN_STYPE_MGMT_PROBERESP () {0x50;}' unless defined(&AN_STYPE_MGMT_PROBERESP);
    eval 'sub AN_STYPE_MGMT_BEACON () {0x80;}' unless defined(&AN_STYPE_MGMT_BEACON);
    eval 'sub AN_STYPE_MGMT_ATIM () {0x90;}' unless defined(&AN_STYPE_MGMT_ATIM);
    eval 'sub AN_STYPE_MGMT_DISAS () {0xa0;}' unless defined(&AN_STYPE_MGMT_DISAS);
    eval 'sub AN_STYPE_MGMT_AUTH () {0xb0;}' unless defined(&AN_STYPE_MGMT_AUTH);
    eval 'sub AN_STYPE_MGMT_DEAUTH () {0xc0;}' unless defined(&AN_STYPE_MGMT_DEAUTH);
    if(defined(&ANCACHE)) {
	eval 'sub MAXANCACHE () {10;}' unless defined(&MAXANCACHE);
    }
    eval 'sub AN_OPMODE_IBSS_ADHOC () {0x;}' unless defined(&AN_OPMODE_IBSS_ADHOC);
    eval 'sub AN_OPMODE_INFRASTRUCTURE_STATION () {0x1;}' unless defined(&AN_OPMODE_INFRASTRUCTURE_STATION);
    eval 'sub AN_OPMODE_AP () {0x2;}' unless defined(&AN_OPMODE_AP);
    eval 'sub AN_OPMODE_AP_REPEATER () {0x3;}' unless defined(&AN_OPMODE_AP_REPEATER);
    eval 'sub AN_OPMODE_UNMODIFIED_PAYLOAD () {0x100;}' unless defined(&AN_OPMODE_UNMODIFIED_PAYLOAD);
    eval 'sub AN_OPMODE_AIRONET_EXTENSIONS () {0x200;}' unless defined(&AN_OPMODE_AIRONET_EXTENSIONS);
    eval 'sub AN_OPMODE_AP_EXTENSIONS () {0x400;}' unless defined(&AN_OPMODE_AP_EXTENSIONS);
    eval 'sub AN_RXMODE_BC_MC_ADDR () {0x;}' unless defined(&AN_RXMODE_BC_MC_ADDR);
    eval 'sub AN_RXMODE_BC_ADDR () {0x1;}' unless defined(&AN_RXMODE_BC_ADDR);
    eval 'sub AN_RXMODE_ADDR () {0x2;}' unless defined(&AN_RXMODE_ADDR);
    eval 'sub AN_RXMODE_80211_MONITOR_CURBSS () {0x3;}' unless defined(&AN_RXMODE_80211_MONITOR_CURBSS);
    eval 'sub AN_RXMODE_80211_MONITOR_ANYBSS () {0x4;}' unless defined(&AN_RXMODE_80211_MONITOR_ANYBSS);
    eval 'sub AN_RXMODE_LAN_MONITOR_CURBSS () {0x5;}' unless defined(&AN_RXMODE_LAN_MONITOR_CURBSS);
    eval 'sub AN_RXMODE_NO_8023_HEADER () {0x100;}' unless defined(&AN_RXMODE_NO_8023_HEADER);
    eval 'sub AN_RXMODE_NORMALIZED_RSSI () {0x200;}' unless defined(&AN_RXMODE_NORMALIZED_RSSI);
    eval 'sub AN_RATE_1MBPS () {0x2;}' unless defined(&AN_RATE_1MBPS);
    eval 'sub AN_RATE_2MBPS () {0x4;}' unless defined(&AN_RATE_2MBPS);
    eval 'sub AN_RATE_5_5MBPS () {0xb;}' unless defined(&AN_RATE_5_5MBPS);
    eval 'sub AN_RATE_11MBPS () {0x16;}' unless defined(&AN_RATE_11MBPS);
    eval 'sub AN_DEVTYPE_PC4500 () {0x65;}' unless defined(&AN_DEVTYPE_PC4500);
    eval 'sub AN_DEVTYPE_PC4800 () {0x6d;}' unless defined(&AN_DEVTYPE_PC4800);
    eval 'sub AN_SCANMODE_ACTIVE () {0x;}' unless defined(&AN_SCANMODE_ACTIVE);
    eval 'sub AN_SCANMODE_PASSIVE () {0x1;}' unless defined(&AN_SCANMODE_PASSIVE);
    eval 'sub AN_SCANMODE_AIRONET_ACTIVE () {0x2;}' unless defined(&AN_SCANMODE_AIRONET_ACTIVE);
    eval 'sub AN_AUTHTYPE_NONE () {0x;}' unless defined(&AN_AUTHTYPE_NONE);
    eval 'sub AN_AUTHTYPE_OPEN () {0x1;}' unless defined(&AN_AUTHTYPE_OPEN);
    eval 'sub AN_AUTHTYPE_SHAREDKEY () {0x2;}' unless defined(&AN_AUTHTYPE_SHAREDKEY);
    eval 'sub AN_AUTHTYPE_MASK () {0xff;}' unless defined(&AN_AUTHTYPE_MASK);
    eval 'sub AN_AUTHTYPE_ENABLE () {0x100;}' unless defined(&AN_AUTHTYPE_ENABLE);
    eval 'sub AN_AUTHTYPE_PRIVACY_IN_USE () {0x100;}' unless defined(&AN_AUTHTYPE_PRIVACY_IN_USE);
    eval 'sub AN_AUTHTYPE_ALLOW_UNENCRYPTED () {0x200;}' unless defined(&AN_AUTHTYPE_ALLOW_UNENCRYPTED);
    eval 'sub AN_AUTHTYPE_LEAP () {0x1000;}' unless defined(&AN_AUTHTYPE_LEAP);
    eval 'sub AN_PSAVE_NONE () {0x;}' unless defined(&AN_PSAVE_NONE);
    eval 'sub AN_PSAVE_CAM () {0x1;}' unless defined(&AN_PSAVE_CAM);
    eval 'sub AN_PSAVE_PSP () {0x2;}' unless defined(&AN_PSAVE_PSP);
    eval 'sub AN_PSAVE_PSP_CAM () {0x3;}' unless defined(&AN_PSAVE_PSP_CAM);
    eval 'sub AN_RADIOTYPE_80211_FH () {0x1;}' unless defined(&AN_RADIOTYPE_80211_FH);
    eval 'sub AN_RADIOTYPE_80211_DS () {0x2;}' unless defined(&AN_RADIOTYPE_80211_DS);
    eval 'sub AN_RADIOTYPE_LM2000_DS () {0x4;}' unless defined(&AN_RADIOTYPE_LM2000_DS);
    eval 'sub AN_DIVERSITY_FACTORY_DEFAULT () {0x;}' unless defined(&AN_DIVERSITY_FACTORY_DEFAULT);
    eval 'sub AN_DIVERSITY_ANTENNA_1_ONLY () {0x1;}' unless defined(&AN_DIVERSITY_ANTENNA_1_ONLY);
    eval 'sub AN_DIVERSITY_ANTENNA_2_ONLY () {0x2;}' unless defined(&AN_DIVERSITY_ANTENNA_2_ONLY);
    eval 'sub AN_DIVERSITY_ANTENNA_1_AND_2 () {0x3;}' unless defined(&AN_DIVERSITY_ANTENNA_1_AND_2);
    eval 'sub AN_TXPOWER_FACTORY_DEFAULT () {0x;}' unless defined(&AN_TXPOWER_FACTORY_DEFAULT);
    eval 'sub AN_TXPOWER_50MW () {50;}' unless defined(&AN_TXPOWER_50MW);
    eval 'sub AN_TXPOWER_100MW () {100;}' unless defined(&AN_TXPOWER_100MW);
    eval 'sub AN_TXPOWER_250MW () {250;}' unless defined(&AN_TXPOWER_250MW);
    eval 'sub AN_HOME_NETWORK () {0x1;}' unless defined(&AN_HOME_NETWORK);
    eval 'sub AN_HOME_INSTALL_AP () {0x2;}' unless defined(&AN_HOME_INSTALL_AP);
    eval 'sub MAX_SSIDS () {25;}' unless defined(&MAX_SSIDS);
    eval 'sub AN_ENCAP_ACTION_RX () {0x1;}' unless defined(&AN_ENCAP_ACTION_RX);
    eval 'sub AN_ENCAP_ACTION_TX () {0x2;}' unless defined(&AN_ENCAP_ACTION_TX);
    eval 'sub AN_RXENCAP_NONE () {0x;}' unless defined(&AN_RXENCAP_NONE);
    eval 'sub AN_RXENCAP_RFC1024 () {0x1;}' unless defined(&AN_RXENCAP_RFC1024);
    eval 'sub AN_TXENCAP_RFC1024 () {0x;}' unless defined(&AN_TXENCAP_RFC1024);
    eval 'sub AN_TXENCAP_80211 () {0x2;}' unless defined(&AN_TXENCAP_80211);
    eval 'sub AN_STATUS_OPMODE_CONFIGURED () {0x1;}' unless defined(&AN_STATUS_OPMODE_CONFIGURED);
    eval 'sub AN_STATUS_OPMODE_MAC_ENABLED () {0x2;}' unless defined(&AN_STATUS_OPMODE_MAC_ENABLED);
    eval 'sub AN_STATUS_OPMODE_RX_ENABLED () {0x4;}' unless defined(&AN_STATUS_OPMODE_RX_ENABLED);
    eval 'sub AN_STATUS_OPMODE_IN_SYNC () {0x10;}' unless defined(&AN_STATUS_OPMODE_IN_SYNC);
    eval 'sub AN_STATUS_OPMODE_ASSOCIATED () {0x20;}' unless defined(&AN_STATUS_OPMODE_ASSOCIATED);
    eval 'sub AN_STATUS_OPMODE_LEAP () {0x40;}' unless defined(&AN_STATUS_OPMODE_LEAP);
    eval 'sub AN_STATUS_OPMODE_ERROR () {0x8000;}' unless defined(&AN_STATUS_OPMODE_ERROR);
    eval 'sub LEAP_USERNAME_MAX () {32;}' unless defined(&LEAP_USERNAME_MAX);
    eval 'sub LEAP_PASSWORD_MAX () {32;}' unless defined(&LEAP_PASSWORD_MAX);
    eval 'sub AN_RID_GENCONFIG () {0xff10;}' unless defined(&AN_RID_GENCONFIG);
    eval 'sub AN_RID_SSIDLIST () {0xff11;}' unless defined(&AN_RID_SSIDLIST);
    eval 'sub AN_RID_APLIST () {0xff12;}' unless defined(&AN_RID_APLIST);
    eval 'sub AN_RID_DRVNAME () {0xff13;}' unless defined(&AN_RID_DRVNAME);
    eval 'sub AN_RID_ENCAPPROTO () {0xff14;}' unless defined(&AN_RID_ENCAPPROTO);
    eval 'sub AN_RID_WEP_TEMP () {0xff15;}' unless defined(&AN_RID_WEP_TEMP);
    eval 'sub AN_RID_WEP_PERM () {0xff16;}' unless defined(&AN_RID_WEP_PERM);
    eval 'sub AN_RID_ACTUALCFG () {0xff20;}' unless defined(&AN_RID_ACTUALCFG);
    eval 'sub AN_RID_CAPABILITIES () {0xff00;}' unless defined(&AN_RID_CAPABILITIES);
    eval 'sub AN_RID_AP_INFO () {0xff01;}' unless defined(&AN_RID_AP_INFO);
    eval 'sub AN_RID_RADIO_INFO () {0xff02;}' unless defined(&AN_RID_RADIO_INFO);
    eval 'sub AN_RID_RSSI_MAP () {0xff04;}' unless defined(&AN_RID_RSSI_MAP);
    eval 'sub AN_RID_STATUS () {0xff50;}' unless defined(&AN_RID_STATUS);
    eval 'sub AN_RID_BEACONS_HST () {0xff51;}' unless defined(&AN_RID_BEACONS_HST);
    eval 'sub AN_RID_BUSY_HST () {0xff52;}' unless defined(&AN_RID_BUSY_HST);
    eval 'sub AN_RID_RETRIES_HST () {0xff53;}' unless defined(&AN_RID_RETRIES_HST);
    eval 'sub AN_RID_16BITS_CUM () {0xff60;}' unless defined(&AN_RID_16BITS_CUM);
    eval 'sub AN_RID_16BITS_DELTA () {0xff61;}' unless defined(&AN_RID_16BITS_DELTA);
    eval 'sub AN_RID_16BITS_DELTACLR () {0xff62;}' unless defined(&AN_RID_16BITS_DELTACLR);
    eval 'sub AN_RID_32BITS_CUM () {0xff68;}' unless defined(&AN_RID_32BITS_CUM);
    eval 'sub AN_RID_32BITS_DELTA () {0xff69;}' unless defined(&AN_RID_32BITS_DELTA);
    eval 'sub AN_RID_32BITS_DELTACLR () {0xff6a;}' unless defined(&AN_RID_32BITS_DELTACLR);
    eval 'sub AN_RID_LEAPUSERNAME () {0xff23;}' unless defined(&AN_RID_LEAPUSERNAME);
    eval 'sub AN_RID_LEAPPASSWORD () {0xff24;}' unless defined(&AN_RID_LEAPPASSWORD);
    eval 'sub AN_RID_MOD () {0xff17;}' unless defined(&AN_RID_MOD);
    eval 'sub AN_RID_OPTIONS () {0xff18;}' unless defined(&AN_RID_OPTIONS);
    eval 'sub AN_RID_FACTORY_CONFIG () {0xff18;}' unless defined(&AN_RID_FACTORY_CONFIG);
    eval 'sub AN_RID_MONITOR_MODE () {0x1;}' unless defined(&AN_RID_MONITOR_MODE);
    eval 'sub AN_MONITOR () {1;}' unless defined(&AN_MONITOR);
    eval 'sub AN_MONITOR_ANY_BSS () {2;}' unless defined(&AN_MONITOR_ANY_BSS);
    eval 'sub AN_MONITOR_INCLUDE_BEACON () {4;}' unless defined(&AN_MONITOR_INCLUDE_BEACON);
    eval 'sub AN_MONITOR_AIRONET_HEADER () {8;}' unless defined(&AN_MONITOR_AIRONET_HEADER);
    eval 'sub DLT_AIRONET_HEADER () {120;}' unless defined(&DLT_AIRONET_HEADER);
    eval 'sub AIROGCAP () {0;}' unless defined(&AIROGCAP);
    eval 'sub AIROGCFG () {1;}' unless defined(&AIROGCFG);
    eval 'sub AIROGSLIST () {2;}' unless defined(&AIROGSLIST);
    eval 'sub AIROGVLIST () {3;}' unless defined(&AIROGVLIST);
    eval 'sub AIROGDRVNAM () {4;}' unless defined(&AIROGDRVNAM);
    eval 'sub AIROGEHTENC () {5;}' unless defined(&AIROGEHTENC);
    eval 'sub AIROGWEPKTMP () {6;}' unless defined(&AIROGWEPKTMP);
    eval 'sub AIROGWEPKNV () {7;}' unless defined(&AIROGWEPKNV);
    eval 'sub AIROGSTAT () {8;}' unless defined(&AIROGSTAT);
    eval 'sub AIROGSTATSC32 () {9;}' unless defined(&AIROGSTATSC32);
    eval 'sub AIROGSTATSD32 () {10;}' unless defined(&AIROGSTATSD32);
    eval 'sub AIROPCAP () { &AIROGSTATSD32 + 40;}' unless defined(&AIROPCAP);
    eval 'sub AIROPVLIST () { &AIROPCAP + 1;}' unless defined(&AIROPVLIST);
    eval 'sub AIROPSLIST () { &AIROPVLIST + 1;}' unless defined(&AIROPSLIST);
    eval 'sub AIROPCFG () { &AIROPSLIST + 1;}' unless defined(&AIROPCFG);
    eval 'sub AIROPSIDS () { &AIROPCFG + 1;}' unless defined(&AIROPSIDS);
    eval 'sub AIROPAPLIST () { &AIROPSIDS + 1;}' unless defined(&AIROPAPLIST);
    eval 'sub AIROPMACON () { &AIROPAPLIST + 1;}' unless defined(&AIROPMACON);
    eval 'sub AIROPMACOFF () { &AIROPMACON + 1;}' unless defined(&AIROPMACOFF);
    eval 'sub AIROPSTCLR () { &AIROPMACOFF + 1;}' unless defined(&AIROPSTCLR);
    eval 'sub AIROPWEPKEY () { &AIROPSTCLR + 1;}' unless defined(&AIROPWEPKEY);
    eval 'sub AIROPWEPKEYNV () { &AIROPWEPKEY + 1;}' unless defined(&AIROPWEPKEYNV);
    eval 'sub AIROPLEAPPWD () { &AIROPWEPKEYNV + 1;}' unless defined(&AIROPLEAPPWD);
    eval 'sub AIROPLEAPUSR () { &AIROPLEAPPWD + 1;}' unless defined(&AIROPLEAPUSR);
    eval 'sub AIROFLSHRST () { &AIROPWEPKEYNV + 40;}' unless defined(&AIROFLSHRST);
    eval 'sub AIROFLSHGCHR () { &AIROFLSHRST + 1;}' unless defined(&AIROFLSHGCHR);
    eval 'sub AIROFLSHSTFL () { &AIROFLSHGCHR + 1;}' unless defined(&AIROFLSHSTFL);
    eval 'sub AIROFLSHPCHR () { &AIROFLSHSTFL + 1;}' unless defined(&AIROFLSHPCHR);
    eval 'sub AIROFLPUTBUF () { &AIROFLSHPCHR + 1;}' unless defined(&AIROFLPUTBUF);
    eval 'sub AIRORESTART () { &AIROFLPUTBUF + 1;}' unless defined(&AIRORESTART);
    eval 'sub AIROMAGIC () {0xa55a;}' unless defined(&AIROMAGIC);
}
1;
