require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub AN_TIMEOUT () {65536;}' unless defined(&AN_TIMEOUT);
eval 'sub AN_DEFAULT_NETNAME () {"";}' unless defined(&AN_DEFAULT_NETNAME);
eval 'sub AN_DEFAULT_NODENAME () {"FreeBSD";}' unless defined(&AN_DEFAULT_NODENAME);
eval 'sub AN_DEFAULT_IBSS () {"FreeBSD IBSS";}' unless defined(&AN_DEFAULT_IBSS);
unless(defined(&CSR_WRITE_2)) {
    sub CSR_WRITE_2 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_write_2( ($sc->{port_res}), $reg, $val));
    }
}
unless(defined(&CSR_READ_2)) {
    sub CSR_READ_2 {
	my($sc, $reg) = @_;
	eval q( &bus_read_2( ($sc->{port_res}), $reg));
    }
}
unless(defined(&CSR_WRITE_1)) {
    sub CSR_WRITE_1 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_write_1( ($sc->{port_res}), $reg, $val));
    }
}
unless(defined(&CSR_READ_1)) {
    sub CSR_READ_1 {
	my($sc, $reg) = @_;
	eval q( &bus_read_1( ($sc->{port_res}), $reg));
    }
}
unless(defined(&CSR_MEM_WRITE_2)) {
    sub CSR_MEM_WRITE_2 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_write_2( ($sc->{mem_res}), $reg, $val));
    }
}
unless(defined(&CSR_MEM_READ_2)) {
    sub CSR_MEM_READ_2 {
	my($sc, $reg) = @_;
	eval q( &bus_read_2( ($sc->{mem_res}), $reg));
    }
}
unless(defined(&CSR_MEM_WRITE_1)) {
    sub CSR_MEM_WRITE_1 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_write_1( ($sc->{mem_res}), $reg, $val));
    }
}
unless(defined(&CSR_MEM_READ_1)) {
    sub CSR_MEM_READ_1 {
	my($sc, $reg) = @_;
	eval q( &bus_read_1( ($sc->{mem_res}), $reg));
    }
}
unless(defined(&CSR_MEM_AUX_WRITE_4)) {
    sub CSR_MEM_AUX_WRITE_4 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_write_4( ($sc->{mem_aux_res}), $reg, $val));
    }
}
unless(defined(&CSR_MEM_AUX_READ_4)) {
    sub CSR_MEM_AUX_READ_4 {
	my($sc, $reg) = @_;
	eval q( &bus_read_4( ($sc->{mem_aux_res}), $reg));
    }
}
unless(defined(&CSR_MEM_AUX_WRITE_1)) {
    sub CSR_MEM_AUX_WRITE_1 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_write_1( ($sc->{mem_aux_res}), $reg, $val));
    }
}
unless(defined(&CSR_MEM_AUX_READ_1)) {
    sub CSR_MEM_AUX_READ_1 {
	my($sc, $reg) = @_;
	eval q( &bus_read_1( ($sc->{mem_aux_res}), $reg));
    }
}
eval 'sub AN_IOSIZ () {0x40;}' unless defined(&AN_IOSIZ);
eval 'sub AN_AUX_MEM_SIZE () {(256* 1024);}' unless defined(&AN_AUX_MEM_SIZE);
unless(defined(&AN_COMMAND)) {
    sub AN_COMMAND {
	my($x) = @_;
	eval q(($x ? 0x : 0x));
    }
}
unless(defined(&AN_PARAM0)) {
    sub AN_PARAM0 {
	my($x) = @_;
	eval q(($x ? 0x4 : 0x2));
    }
}
unless(defined(&AN_PARAM1)) {
    sub AN_PARAM1 {
	my($x) = @_;
	eval q(($x ? 0x8 : 0x4));
    }
}
unless(defined(&AN_PARAM2)) {
    sub AN_PARAM2 {
	my($x) = @_;
	eval q(($x ? 0xc : 0x6));
    }
}
unless(defined(&AN_STATUS)) {
    sub AN_STATUS {
	my($x) = @_;
	eval q(($x ? 0x10 : 0x8));
    }
}
unless(defined(&AN_RESP0)) {
    sub AN_RESP0 {
	my($x) = @_;
	eval q(($x ? 0x14 : 0xa));
    }
}
unless(defined(&AN_RESP1)) {
    sub AN_RESP1 {
	my($x) = @_;
	eval q(($x ? 0x18 : 0xc));
    }
}
unless(defined(&AN_RESP2)) {
    sub AN_RESP2 {
	my($x) = @_;
	eval q(($x ? 0x1c : 0xe));
    }
}
unless(defined(&AN_LINKSTAT)) {
    sub AN_LINKSTAT {
	my($x) = @_;
	eval q(($x ? 0x20 : 0x10));
    }
}
eval 'sub AN_CMD_BUSY () {0x8000;}' unless defined(&AN_CMD_BUSY);
eval 'sub AN_CMD_NO_ACK () {0x80;}' unless defined(&AN_CMD_NO_ACK);
eval 'sub AN_CMD_CODE_MASK () {0x3f;}' unless defined(&AN_CMD_CODE_MASK);
eval 'sub AN_CMD_QUAL_MASK () {0x7f00;}' unless defined(&AN_CMD_QUAL_MASK);
eval 'sub AN_CMD_NOOP () {0x;}' unless defined(&AN_CMD_NOOP);
eval 'sub AN_CMD_ENABLE () {0x1;}' unless defined(&AN_CMD_ENABLE);
eval 'sub AN_CMD_DISABLE () {0x2;}' unless defined(&AN_CMD_DISABLE);
eval 'sub AN_CMD_FORCE_SYNCLOSS () {0x3;}' unless defined(&AN_CMD_FORCE_SYNCLOSS);
eval 'sub AN_CMD_FW_RESTART () {0x4;}' unless defined(&AN_CMD_FW_RESTART);
eval 'sub AN_CMD_HOST_SLEEP () {0x5;}' unless defined(&AN_CMD_HOST_SLEEP);
eval 'sub AN_CMD_MAGIC_PKT () {0x6;}' unless defined(&AN_CMD_MAGIC_PKT);
eval 'sub AN_CMD_READCFG () {0x8;}' unless defined(&AN_CMD_READCFG);
eval 'sub AN_CMD_SET_MODE () {0x9;}' unless defined(&AN_CMD_SET_MODE);
eval 'sub AN_CMD_ALLOC_MEM () {0xa;}' unless defined(&AN_CMD_ALLOC_MEM);
eval 'sub AN_CMD_TX () {0xb;}' unless defined(&AN_CMD_TX);
eval 'sub AN_CMD_DEALLOC_MEM () {0xc;}' unless defined(&AN_CMD_DEALLOC_MEM);
eval 'sub AN_CMD_NOOP2 () {0x10;}' unless defined(&AN_CMD_NOOP2);
eval 'sub AN_CMD_ALLOC_DESC () {0x20;}' unless defined(&AN_CMD_ALLOC_DESC);
eval 'sub AN_CMD_ACCESS () {0x21;}' unless defined(&AN_CMD_ACCESS);
eval 'sub AN_CMD_ALLOC_BUF () {0x28;}' unless defined(&AN_CMD_ALLOC_BUF);
eval 'sub AN_CMD_PSP_NODES () {0x30;}' unless defined(&AN_CMD_PSP_NODES);
eval 'sub AN_CMD_SET_PHYREG () {0x3e;}' unless defined(&AN_CMD_SET_PHYREG);
eval 'sub AN_CMD_TX_TEST () {0x3f;}' unless defined(&AN_CMD_TX_TEST);
eval 'sub AN_CMD_SLEEP () {0x85;}' unless defined(&AN_CMD_SLEEP);
eval 'sub AN_CMD_SAVECFG () {0x108;}' unless defined(&AN_CMD_SAVECFG);
eval 'sub AN_DESCRIPTOR_TX () {0x1;}' unless defined(&AN_DESCRIPTOR_TX);
eval 'sub AN_DESCRIPTOR_RX () {0x2;}' unless defined(&AN_DESCRIPTOR_RX);
eval 'sub AN_DESCRIPTOR_TXCMP () {0x4;}' unless defined(&AN_DESCRIPTOR_TXCMP);
eval 'sub AN_DESCRIPTOR_HOSTWRITE () {0x8;}' unless defined(&AN_DESCRIPTOR_HOSTWRITE);
eval 'sub AN_DESCRIPTOR_HOSTREAD () {0x10;}' unless defined(&AN_DESCRIPTOR_HOSTREAD);
eval 'sub AN_DESCRIPTOR_HOSTRW () {0x20;}' unless defined(&AN_DESCRIPTOR_HOSTRW);
eval 'sub AN_MAX_RX_DESC () {1;}' unless defined(&AN_MAX_RX_DESC);
eval 'sub AN_MAX_TX_DESC () {1;}' unless defined(&AN_MAX_TX_DESC);
eval 'sub AN_HOSTBUFSIZ () {1840;}' unless defined(&AN_HOSTBUFSIZ);
eval 'sub AN_RID_BUFFER_SIZE () { &AN_MAX_DATALEN;}' unless defined(&AN_RID_BUFFER_SIZE);
eval 'sub AN_RX_BUFFER_SIZE () { &AN_HOSTBUFSIZ;}' unless defined(&AN_RX_BUFFER_SIZE);
eval 'sub AN_TX_BUFFER_SIZE () { &AN_HOSTBUFSIZ;}' unless defined(&AN_TX_BUFFER_SIZE);
eval 'sub AN_HOST_DESC_OFFSET () {0x800;}' unless defined(&AN_HOST_DESC_OFFSET);
eval 'sub AN_RX_DESC_OFFSET () {( &AN_HOST_DESC_OFFSET + $sizeof{\'struct an_card_rid_desc\'});}' unless defined(&AN_RX_DESC_OFFSET);
eval 'sub AN_TX_DESC_OFFSET () {( &AN_RX_DESC_OFFSET + ( &AN_MAX_RX_DESC * $sizeof{\'struct an_card_rx_desc\'}));}' unless defined(&AN_TX_DESC_OFFSET);
eval 'sub AN_RECLAIM () {0x100;}' unless defined(&AN_RECLAIM);
eval 'sub AN_ACCESS_READ () {0x;}' unless defined(&AN_ACCESS_READ);
eval 'sub AN_ACCESS_WRITE () {0x100;}' unless defined(&AN_ACCESS_WRITE);
eval 'sub AN_PROGRAM_DISABLE () {0x;}' unless defined(&AN_PROGRAM_DISABLE);
eval 'sub AN_PROGRAM_ENABLE_RAM () {0x100;}' unless defined(&AN_PROGRAM_ENABLE_RAM);
eval 'sub AN_PROGRAM_ENABLE_NVRAM () {0x200;}' unless defined(&AN_PROGRAM_ENABLE_NVRAM);
eval 'sub AN_PROGRAM_NVRAM () {0x300;}' unless defined(&AN_PROGRAM_NVRAM);
eval 'sub AN_STAT_CMD_CODE () {0x3f;}' unless defined(&AN_STAT_CMD_CODE);
eval 'sub AN_STAT_CMD_RESULT () {0x7f00;}' unless defined(&AN_STAT_CMD_RESULT);
eval 'sub AN_LINKSTAT_ASSOCIATED () {0x400;}' unless defined(&AN_LINKSTAT_ASSOCIATED);
eval 'sub AN_LINKSTAT_AUTHFAIL () {0x300;}' unless defined(&AN_LINKSTAT_AUTHFAIL);
eval 'sub AN_LINKSTAT_ASSOC_FAIL () {0x8400;}' unless defined(&AN_LINKSTAT_ASSOC_FAIL);
eval 'sub AN_LINKSTAT_DISASSOC () {0x8200;}' unless defined(&AN_LINKSTAT_DISASSOC);
eval 'sub AN_LINKSTAT_DEAUTH () {0x8100;}' unless defined(&AN_LINKSTAT_DEAUTH);
eval 'sub AN_LINKSTAT_SYNCLOST_TSF () {0x8004;}' unless defined(&AN_LINKSTAT_SYNCLOST_TSF);
eval 'sub AN_LINKSTAT_SYNCLOST_HOSTREQ () {0x8003;}' unless defined(&AN_LINKSTAT_SYNCLOST_HOSTREQ);
eval 'sub AN_LINKSTAT_SYNCLOST_AVGRETRY () {0x8002;}' unless defined(&AN_LINKSTAT_SYNCLOST_AVGRETRY);
eval 'sub AN_LINKSTAT_SYNCLOST_MAXRETRY () {0x8001;}' unless defined(&AN_LINKSTAT_SYNCLOST_MAXRETRY);
eval 'sub AN_LINKSTAT_SYNCLOST_MISSBEACON () {0x8000;}' unless defined(&AN_LINKSTAT_SYNCLOST_MISSBEACON);
eval 'sub AN_RX_FID () {0x20;}' unless defined(&AN_RX_FID);
eval 'sub AN_ALLOC_FID () {0x22;}' unless defined(&AN_ALLOC_FID);
unless(defined(&AN_TX_CMP_FID)) {
    sub AN_TX_CMP_FID {
	my($x) = @_;
	eval q(($x ? 0x1a : 0x24));
    }
}
eval 'sub AN_SEL0 () {0x18;}' unless defined(&AN_SEL0);
eval 'sub AN_SEL1 () {0x1a;}' unless defined(&AN_SEL1);
eval 'sub AN_OFF0 () {0x1c;}' unless defined(&AN_OFF0);
eval 'sub AN_OFF1 () {0x1e;}' unless defined(&AN_OFF1);
eval 'sub AN_DATA0 () {0x36;}' unless defined(&AN_DATA0);
eval 'sub AN_DATA1 () {0x38;}' unless defined(&AN_DATA1);
eval 'sub AN_BAP0 () { &AN_DATA0;}' unless defined(&AN_BAP0);
eval 'sub AN_BAP1 () { &AN_DATA1;}' unless defined(&AN_BAP1);
eval 'sub AN_OFF_BUSY () {0x8000;}' unless defined(&AN_OFF_BUSY);
eval 'sub AN_OFF_ERR () {0x4000;}' unless defined(&AN_OFF_ERR);
eval 'sub AN_OFF_DONE () {0x2000;}' unless defined(&AN_OFF_DONE);
eval 'sub AN_OFF_DATAOFF () {0xfff;}' unless defined(&AN_OFF_DATAOFF);
unless(defined(&AN_EVENT_STAT)) {
    sub AN_EVENT_STAT {
	my($x) = @_;
	eval q(($x ? 0x60 : 0x30));
    }
}
unless(defined(&AN_INT_EN)) {
    sub AN_INT_EN {
	my($x) = @_;
	eval q(($x ? 0x64 : 0x32));
    }
}
unless(defined(&AN_EVENT_ACK)) {
    sub AN_EVENT_ACK {
	my($x) = @_;
	eval q(($x ? 0x68 : 0x34));
    }
}
eval 'sub AN_EV_CLR_STUCK_BUSY () {0x4000;}' unless defined(&AN_EV_CLR_STUCK_BUSY);
eval 'sub AN_EV_WAKEREQUEST () {0x2000;}' unless defined(&AN_EV_WAKEREQUEST);
eval 'sub AN_EV_MIC () {0x1000;}' unless defined(&AN_EV_MIC);
eval 'sub AN_EV_AWAKE () {0x100;}' unless defined(&AN_EV_AWAKE);
eval 'sub AN_EV_LINKSTAT () {0x80;}' unless defined(&AN_EV_LINKSTAT);
eval 'sub AN_EV_CMD () {0x10;}' unless defined(&AN_EV_CMD);
eval 'sub AN_EV_ALLOC () {0x8;}' unless defined(&AN_EV_ALLOC);
eval 'sub AN_EV_TX_CPY () {0x400;}' unless defined(&AN_EV_TX_CPY);
eval 'sub AN_EV_TX_EXC () {0x4;}' unless defined(&AN_EV_TX_EXC);
eval 'sub AN_EV_TX () {0x2;}' unless defined(&AN_EV_TX);
eval 'sub AN_EV_RX () {0x1;}' unless defined(&AN_EV_RX);
unless(defined(&AN_INTRS)) {
    sub AN_INTRS {
	my($x) = @_;
	eval q(( $x ? ( &AN_EV_RX| &AN_EV_TX| &AN_EV_TX_EXC| &AN_EV_TX_CPY| &AN_EV_ALLOC | &AN_EV_LINKSTAT| &AN_EV_MIC) : ( &AN_EV_RX| &AN_EV_TX| &AN_EV_TX_EXC| &AN_EV_ALLOC | &AN_EV_LINKSTAT| &AN_EV_MIC) ));
    }
}
unless(defined(&AN_SW0)) {
    sub AN_SW0 {
	my($x) = @_;
	eval q(($x ? 0x50 : 0x28));
    }
}
unless(defined(&AN_SW1)) {
    sub AN_SW1 {
	my($x) = @_;
	eval q(($x ? 0x54 : 0x2a));
    }
}
unless(defined(&AN_SW2)) {
    sub AN_SW2 {
	my($x) = @_;
	eval q(($x ? 0x58 : 0x2c));
    }
}
unless(defined(&AN_SW3)) {
    sub AN_SW3 {
	my($x) = @_;
	eval q(($x ? 0x5c : 0x2e));
    }
}
eval 'sub AN_CNTL () {0x14;}' unless defined(&AN_CNTL);
eval 'sub AN_CNTL_AUX_ENA () {0xc000;}' unless defined(&AN_CNTL_AUX_ENA);
eval 'sub AN_CNTL_AUX_ENA_STAT () {0xc000;}' unless defined(&AN_CNTL_AUX_ENA_STAT);
eval 'sub AN_CNTL_AUX_DIS_STAT () {0x;}' unless defined(&AN_CNTL_AUX_DIS_STAT);
eval 'sub AN_CNTL_AUX_ENA_CNTL () {0x8000;}' unless defined(&AN_CNTL_AUX_ENA_CNTL);
eval 'sub AN_CNTL_AUX_DIS_CNTL () {0x4000;}' unless defined(&AN_CNTL_AUX_DIS_CNTL);
eval 'sub AN_AUX_PAGE () {0x3a;}' unless defined(&AN_AUX_PAGE);
eval 'sub AN_AUX_OFFSET () {0x3c;}' unless defined(&AN_AUX_OFFSET);
eval 'sub AN_AUX_DATA () {0x3e;}' unless defined(&AN_AUX_DATA);
eval 'sub AN_DEF_SSID_LEN () {7;}' unless defined(&AN_DEF_SSID_LEN);
eval 'sub AN_DEF_SSID () {"tsunami";}' unless defined(&AN_DEF_SSID);
eval 'sub AN_RXGAP_MAX () {8;}' unless defined(&AN_RXGAP_MAX);
eval 'sub AN_RXGAP_MAX () {8;}' unless defined(&AN_RXGAP_MAX);
eval 'sub AN_TXSTAT_EXCESS_RETRY () {0x2;}' unless defined(&AN_TXSTAT_EXCESS_RETRY);
eval 'sub AN_TXSTAT_LIFE_EXCEEDED () {0x4;}' unless defined(&AN_TXSTAT_LIFE_EXCEEDED);
eval 'sub AN_TXSTAT_AID_FAIL () {0x8;}' unless defined(&AN_TXSTAT_AID_FAIL);
eval 'sub AN_TXSTAT_MAC_DISABLED () {0x10;}' unless defined(&AN_TXSTAT_MAC_DISABLED);
eval 'sub AN_TXSTAT_ASSOC_LOST () {0x20;}' unless defined(&AN_TXSTAT_ASSOC_LOST);
eval 'sub AN_TXCTL_RSVD () {0x1;}' unless defined(&AN_TXCTL_RSVD);
eval 'sub AN_TXCTL_TXOK_INTR () {0x2;}' unless defined(&AN_TXCTL_TXOK_INTR);
eval 'sub AN_TXCTL_TXERR_INTR () {0x4;}' unless defined(&AN_TXCTL_TXERR_INTR);
eval 'sub AN_TXCTL_HEADER_TYPE () {0x8;}' unless defined(&AN_TXCTL_HEADER_TYPE);
eval 'sub AN_TXCTL_PAYLOAD_TYPE () {0x10;}' unless defined(&AN_TXCTL_PAYLOAD_TYPE);
eval 'sub AN_TXCTL_NORELEASE () {0x20;}' unless defined(&AN_TXCTL_NORELEASE);
eval 'sub AN_TXCTL_NORETRIES () {0x40;}' unless defined(&AN_TXCTL_NORETRIES);
eval 'sub AN_TXCTL_CLEAR_AID () {0x80;}' unless defined(&AN_TXCTL_CLEAR_AID);
eval 'sub AN_TXCTL_STRICT_ORDER () {0x100;}' unless defined(&AN_TXCTL_STRICT_ORDER);
eval 'sub AN_TXCTL_USE_RTS () {0x200;}' unless defined(&AN_TXCTL_USE_RTS);
eval 'sub AN_HEADERTYPE_8023 () {0x;}' unless defined(&AN_HEADERTYPE_8023);
eval 'sub AN_HEADERTYPE_80211 () {0x8;}' unless defined(&AN_HEADERTYPE_80211);
eval 'sub AN_PAYLOADTYPE_ETHER () {0x;}' unless defined(&AN_PAYLOADTYPE_ETHER);
eval 'sub AN_PAYLOADTYPE_LLC () {0x10;}' unless defined(&AN_PAYLOADTYPE_LLC);
eval 'sub AN_TXCTL_80211 () {( &AN_HEADERTYPE_80211| &AN_PAYLOADTYPE_LLC);}' unless defined(&AN_TXCTL_80211);
eval 'sub AN_TXCTL_8023 () {( &AN_HEADERTYPE_8023| &AN_PAYLOADTYPE_ETHER);}' unless defined(&AN_TXCTL_8023);
unless(defined(&AN_TXCTL_HW)) {
    sub AN_TXCTL_HW {
	my($x) = @_;
	eval q(( $x ? ( &AN_TXCTL_NORELEASE) : ( &AN_TXCTL_TXOK_INTR| &AN_TXCTL_TXERR_INTR| &AN_TXCTL_NORELEASE) ));
    }
}
eval 'sub AN_TXGAP_80211 () {0;}' unless defined(&AN_TXGAP_80211);
eval 'sub AN_TXGAP_8023 () {0;}' unless defined(&AN_TXGAP_8023);
eval 'sub AN_TX_RING_CNT () {4;}' unless defined(&AN_TX_RING_CNT);
unless(defined(&AN_INC)) {
    sub AN_INC {
	my($x, $y) = @_;
	eval q(($x) = ($x + 1) % $y);
    }
}
if(defined(&ANCACHE)) {
}
unless(defined(&AN_LOCK)) {
    sub AN_LOCK {
	my($_sc) = @_;
	eval q( &mtx_lock(($_sc)-> &an_mtx));
    }
}
unless(defined(&AN_UNLOCK)) {
    sub AN_UNLOCK {
	my($_sc) = @_;
	eval q( &mtx_unlock(($_sc)-> &an_mtx));
    }
}
unless(defined(&AN_LOCK_ASSERT)) {
    sub AN_LOCK_ASSERT {
	my($_sc) = @_;
	eval q( &mtx_assert(($_sc)-> &an_mtx,  &MA_OWNED));
    }
}
eval 'sub AN_802_3_OFFSET () {0x2e;}' unless defined(&AN_802_3_OFFSET);
eval 'sub AN_802_11_OFFSET () {0x44;}' unless defined(&AN_802_11_OFFSET);
eval 'sub AN_802_11_OFFSET_RAW () {0x3c;}' unless defined(&AN_802_11_OFFSET_RAW);
eval 'sub AN_STAT_BADCRC () {0x1;}' unless defined(&AN_STAT_BADCRC);
eval 'sub AN_STAT_UNDECRYPTABLE () {0x2;}' unless defined(&AN_STAT_UNDECRYPTABLE);
eval 'sub AN_STAT_ERRSTAT () {0x3;}' unless defined(&AN_STAT_ERRSTAT);
eval 'sub AN_STAT_MAC_PORT () {0x700;}' unless defined(&AN_STAT_MAC_PORT);
eval 'sub AN_STAT_1042 () {0x2000;}' unless defined(&AN_STAT_1042);
eval 'sub AN_STAT_TUNNEL () {0x4000;}' unless defined(&AN_STAT_TUNNEL);
eval 'sub AN_STAT_WMP_MSG () {0x6000;}' unless defined(&AN_STAT_WMP_MSG);
eval 'sub AN_RXSTAT_MSG_TYPE () {0xe000;}' unless defined(&AN_RXSTAT_MSG_TYPE);
eval 'sub AN_ENC_TX_802_3 () {0x;}' unless defined(&AN_ENC_TX_802_3);
eval 'sub AN_ENC_TX_802_11 () {0x11;}' unless defined(&AN_ENC_TX_802_11);
eval 'sub AN_ENC_TX_E_II () {0xe;}' unless defined(&AN_ENC_TX_E_II);
eval 'sub AN_ENC_TX_1042 () {0x;}' unless defined(&AN_ENC_TX_1042);
eval 'sub AN_ENC_TX_TUNNEL () {0xf8;}' unless defined(&AN_ENC_TX_TUNNEL);
eval 'sub AN_TXCNTL_MACPORT () {0xff;}' unless defined(&AN_TXCNTL_MACPORT);
eval 'sub AN_TXCNTL_STRUCTTYPE () {0xff00;}' unless defined(&AN_TXCNTL_STRUCTTYPE);
eval 'sub AN_SNAP_K1 () {0xaa;}' unless defined(&AN_SNAP_K1);
eval 'sub AN_SNAP_K2 () {0x;}' unless defined(&AN_SNAP_K2);
eval 'sub AN_SNAP_CONTROL () {0x3;}' unless defined(&AN_SNAP_CONTROL);
eval 'sub AN_SNAP_WORD0 () {( &AN_SNAP_K1 | ( &AN_SNAP_K1 << 8));}' unless defined(&AN_SNAP_WORD0);
eval 'sub AN_SNAP_WORD1 () {( &AN_SNAP_K2 | ( &AN_SNAP_CONTROL << 8));}' unless defined(&AN_SNAP_WORD1);
eval 'sub AN_SNAPHDR_LEN () {0x6;}' unless defined(&AN_SNAPHDR_LEN);
1;
