require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub CISS_MAX_REQUESTS () {1024;}' unless defined(&CISS_MAX_REQUESTS);
eval 'sub CISS_MAX_LOGICAL () {16;}' unless defined(&CISS_MAX_LOGICAL);
eval 'sub CISS_MAX_PHYSICAL () {1024;}' unless defined(&CISS_MAX_PHYSICAL);
eval 'sub CISS_INTERRUPT_COALESCE_DELAY () {0;}' unless defined(&CISS_INTERRUPT_COALESCE_DELAY);
eval 'sub CISS_INTERRUPT_COALESCE_COUNT () {16;}' unless defined(&CISS_INTERRUPT_COALESCE_COUNT);
eval 'sub CISS_HEARTBEAT_RATE () {10;}' unless defined(&CISS_HEARTBEAT_RATE);
eval 'sub CISS_DRIVER_VERSION () {20011201;}' unless defined(&CISS_DRIVER_VERSION);
eval 'sub CISS_REQ_MAPPED () {(1<<0);}' unless defined(&CISS_REQ_MAPPED);
eval 'sub CISS_REQ_SLEEP () {(1<<1);}' unless defined(&CISS_REQ_SLEEP);
eval 'sub CISS_REQ_POLL () {(1<<2);}' unless defined(&CISS_REQ_POLL);
eval 'sub CISS_REQ_DATAOUT () {(1<<3);}' unless defined(&CISS_REQ_DATAOUT);
eval 'sub CISS_REQ_DATAIN () {(1<<4);}' unless defined(&CISS_REQ_DATAIN);
eval 'sub CISS_REQ_BUSY () {(1<<5);}' unless defined(&CISS_REQ_BUSY);
eval 'sub CISS_REQ_CCB () {(1<<6);}' unless defined(&CISS_REQ_CCB);
eval 'sub CISS_SG_MAX () {(( &CISS_SG_FETCH_MAX << 1) | 0x1);}' unless defined(&CISS_SG_MAX);
eval 'sub CISS_SG_1 () {(( &CISS_SG_FETCH_1 << 1) | 0x1);}' unless defined(&CISS_SG_1);
eval 'sub CISS_SG_2 () {(( &CISS_SG_FETCH_2 << 1) | 0x1);}' unless defined(&CISS_SG_2);
eval 'sub CISS_SG_4 () {(( &CISS_SG_FETCH_4 << 1) | 0x1);}' unless defined(&CISS_SG_4);
eval 'sub CISS_SG_8 () {(( &CISS_SG_FETCH_8 << 1) | 0x1);}' unless defined(&CISS_SG_8);
eval 'sub CISS_SG_16 () {(( &CISS_SG_FETCH_16 << 1) | 0x1);}' unless defined(&CISS_SG_16);
eval 'sub CISS_SG_32 () {(( &CISS_SG_FETCH_32 << 1) | 0x1);}' unless defined(&CISS_SG_32);
eval 'sub CISS_SG_NONE () {(( &CISS_SG_FETCH_NONE << 1) | 0x1);}' unless defined(&CISS_SG_NONE);
eval 'sub CISS_MAX_SG_ELEMENTS () {65;}' unless defined(&CISS_MAX_SG_ELEMENTS);
eval 'sub CISS_COMMAND_ALIGN () {32;}' unless defined(&CISS_COMMAND_ALIGN);
eval 'sub CISS_COMMAND_SG_LENGTH () {($sizeof{\'struct ciss_sg_entry\'} *  &CISS_MAX_SG_ELEMENTS);}' unless defined(&CISS_COMMAND_SG_LENGTH);
eval 'sub CISS_COMMAND_ALLOC_SIZE () {( &roundup2($sizeof{\'struct ciss_command\'} +  &CISS_COMMAND_SG_LENGTH,  &CISS_COMMAND_ALIGN));}' unless defined(&CISS_COMMAND_ALLOC_SIZE);
eval 'sub CISS_LD_NONEXISTENT () {0;}' unless defined(&CISS_LD_NONEXISTENT);
eval 'sub CISS_LD_ONLINE () {1;}' unless defined(&CISS_LD_ONLINE);
eval 'sub CISS_LD_OFFLINE () {2;}' unless defined(&CISS_LD_OFFLINE);
eval 'sub CISS_PHYSICAL_SHIFT () {5;}' unless defined(&CISS_PHYSICAL_SHIFT);
eval 'sub CISS_PHYSICAL_BASE () {(1<<  &CISS_PHYSICAL_SHIFT);}' unless defined(&CISS_PHYSICAL_BASE);
eval 'sub CISS_MAX_PHYSTGT () {256;}' unless defined(&CISS_MAX_PHYSTGT);
unless(defined(&CISS_IS_PHYSICAL)) {
    sub CISS_IS_PHYSICAL {
	my($bus) = @_;
	eval q(($bus >=  &CISS_PHYSICAL_BASE));
    }
}
unless(defined(&CISS_CAM_TO_PBUS)) {
    sub CISS_CAM_TO_PBUS {
	my($bus) = @_;
	eval q(($bus -  &CISS_PHYSICAL_BASE));
    }
}
eval 'sub CISS_FLAG_NOTIFY_OK () {(1<<0);}' unless defined(&CISS_FLAG_NOTIFY_OK);
eval 'sub CISS_FLAG_CONTROL_OPEN () {(1<<1);}' unless defined(&CISS_FLAG_CONTROL_OPEN);
eval 'sub CISS_FLAG_ABORTING () {(1<<2);}' unless defined(&CISS_FLAG_ABORTING);
eval 'sub CISS_FLAG_RUNNING () {(1<<3);}' unless defined(&CISS_FLAG_RUNNING);
eval 'sub CISS_FLAG_BUSY () {(1<<4);}' unless defined(&CISS_FLAG_BUSY);
eval 'sub CISS_FLAG_FAKE_SYNCH () {(1<<16);}' unless defined(&CISS_FLAG_FAKE_SYNCH);
eval 'sub CISS_FLAG_BMIC_ABORT () {(1<<17);}' unless defined(&CISS_FLAG_BMIC_ABORT);
eval 'sub CISS_FLAG_THREAD_SHUT () {(1<<20);}' unless defined(&CISS_FLAG_THREAD_SHUT);
if(defined(&CISS_DEBUG)) {
    eval 'sub debug () {( &level,  &fmt,  &args...)  &do {  &if ( &level <=  &CISS_DEBUG)  &printf("%s: "  &fmt "\\n",  &__func__ ,  &args); }  &while(0);}' unless defined(&debug);
    eval 'sub debug_called {
        my($level) = @_;
	    eval q( &do {  &if ($level <=  &CISS_DEBUG)  &printf(\\"%s: called\\\\n\\",  &__func__); }  &while(0));
    }' unless defined(&debug_called);
    eval 'sub debug_struct {
        my($s) = @_;
	    eval q( &printf(\\"  SIZE %s: %zu\\\\n\\", $s, $sizeof{\'struct s\'}));
    }' unless defined(&debug_struct);
    eval 'sub debug_union {
        my($s) = @_;
	    eval q( &printf(\\"  SIZE %s: %zu\\\\n\\", $s, $sizeof{\'union s\'}));
    }' unless defined(&debug_union);
    eval 'sub debug_type {
        my($s) = @_;
	    eval q( &printf(\\"  SIZE %s: %zu\\\\n\\", $s, $sizeof{$s}));
    }' unless defined(&debug_type);
    eval 'sub debug_field {
        my($s, $f) = @_;
	    eval q( &printf(\\"  OFFSET %s.%s: %d\\\\n\\", $s, $f, (((0)->$f))));
    }' unless defined(&debug_field);
    eval 'sub debug_const {
        my($c) = @_;
	    eval q( &printf(\\"  CONST %s %jd/0x%jx\\\\n\\", $c, ( &intmax_t)$c, ( &intmax_t)$c););
    }' unless defined(&debug_const);
} else {
    eval 'sub debug () {( &level,  &fmt,  &args...);}' unless defined(&debug);
    eval 'sub debug_called {
        my($level) = @_;
	    eval q();
    }' unless defined(&debug_called);
    eval 'sub debug_struct {
        my($s) = @_;
	    eval q();
    }' unless defined(&debug_struct);
    eval 'sub debug_union {
        my($s) = @_;
	    eval q();
    }' unless defined(&debug_union);
    eval 'sub debug_type {
        my($s) = @_;
	    eval q();
    }' unless defined(&debug_type);
    eval 'sub debug_field {
        my($s, $f) = @_;
	    eval q();
    }' unless defined(&debug_field);
    eval 'sub debug_const {
        my($c) = @_;
	    eval q();
    }' unless defined(&debug_const);
}
eval 'sub ciss_printf () {( &sc,  &fmt,  &args...)  &device_printf( ($sc->{ciss_dev}),  &fmt ,  &args);}' unless defined(&ciss_printf);
unless(defined(&CISSQ_ADD)) {
    sub CISSQ_ADD {
	my($sc, $qname) = @_;
	eval q( &do { 'struct ciss_qstat' * &qs = ($sc)-> $ciss_qstat[$qname];  ($qs->{q_length})++;  &if ( ($qs->{q_length}) >  ($qs->{q_max}))  ($qs->{q_max}) =  ($qs->{q_length}); }  &while(0));
    }
}
unless(defined(&CISSQ_REMOVE)) {
    sub CISSQ_REMOVE {
	my($sc, $qname) = @_;
	eval q(($sc)-> ($ciss_qstat[$qname]->{q_length})--);
    }
}
unless(defined(&CISSQ_INIT)) {
    sub CISSQ_INIT {
	my($sc, $qname) = @_;
	eval q( &do {  ($sc->{ciss_qstat[$qname]}->{q_length}) = 0;  ($sc->{ciss_qstat[$qname]}->{q_max}) = 0; }  &while(0));
    }
}
unless(defined(&CISSQ_REQUEST_QUEUE)) {
    sub CISSQ_REQUEST_QUEUE {
	my($name, $index) = @_;
	eval q( &static  &__inline  &void  &ciss_initq_  $name ('struct ciss_softc' * &sc) {  &STAILQ_INIT( ($sc->{ciss_})  $name);  &CISSQ_INIT( &sc, $index); }  &static  &__inline  &void  &ciss_enqueue_  $name ('struct ciss_request' * &cr) {  &STAILQ_INSERT_TAIL( ($cr->{cr_sc}->{ciss_})  $name,  &cr,  &cr_link);  &CISSQ_ADD( ($cr->{cr_sc}), $index);  ($cr->{cr_onq}) = $index; }  &static  &__inline  &void  &ciss_requeue_  $name ('struct ciss_request' * &cr) {  &STAILQ_INSERT_HEAD( ($cr->{cr_sc}->{ciss_})  $name,  &cr,  &cr_link);  &CISSQ_ADD( ($cr->{cr_sc}), $index);  ($cr->{cr_onq}) = $index; }  &static  &__inline 'struct ciss_request' *  &ciss_dequeue_  $name ('struct ciss_softc' * &sc) { 'struct ciss_request' * &cr;  &if (( &cr =  &STAILQ_FIRST( ($sc->{ciss_})  $name)) !=  &NULL) {  &STAILQ_REMOVE_HEAD( ($sc->{ciss_})  $name,  &cr_link);  &CISSQ_REMOVE( &sc, $index);  ($cr->{cr_onq}) = -1; }  &return( &cr); } 'struct hack');
    }
}
unless(defined(&ciss_enqueue_complete)) {
    sub ciss_enqueue_complete {
	my($ac,$head) = @_;
	eval q({  &STAILQ_INSERT_TAIL($head, $ac,  &cr_link); });
    }
}
unless(defined(&ciss_dequeue_complete)) {
    sub ciss_dequeue_complete {
	my($sc,$head) = @_;
	eval q({ 'struct ciss_request' * &ac;  &if (( &ac =  &STAILQ_FIRST($head)) !=  &NULL)  &STAILQ_REMOVE_HEAD($head,  &cr_link); ( &ac); });
    }
}
unless(defined(&ciss_report_request)) {
    sub ciss_report_request {
	my($a, $b, $c) = @_;
	eval q( &_ciss_report_request($a, $b, $c,  &__FUNCTION__));
    }
}
1;
