require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_EVDEV_UINPUT_H_)) {
    eval 'sub _EVDEV_UINPUT_H_ () {1;}' unless defined(&_EVDEV_UINPUT_H_);
    require 'sys/types.ph';
    require 'dev/evdev/input.ph';
    eval 'sub UINPUT_VERSION () {5;}' unless defined(&UINPUT_VERSION);
    eval 'sub UINPUT_MAX_NAME_SIZE () {80;}' unless defined(&UINPUT_MAX_NAME_SIZE);
    eval 'sub UINPUT_IOCTL_BASE () {ord(\'U\');}' unless defined(&UINPUT_IOCTL_BASE);
    eval 'sub UI_DEV_CREATE () { &_IO( &UINPUT_IOCTL_BASE, 1);}' unless defined(&UI_DEV_CREATE);
    eval 'sub UI_DEV_DESTROY () { &_IO( &UINPUT_IOCTL_BASE, 2);}' unless defined(&UI_DEV_DESTROY);
    eval 'sub UI_DEV_SETUP () { &_IOW( &UINPUT_IOCTL_BASE, 3, \'struct uinput_setup\');}' unless defined(&UI_DEV_SETUP);
    eval 'sub UI_ABS_SETUP () { &_IOW( &UINPUT_IOCTL_BASE, 4, \'struct uinput_abs_setup\');}' unless defined(&UI_ABS_SETUP);
    eval 'sub UI_GET_SYSNAME {
        my($len) = @_;
	    eval q( &_IOC( &IOC_OUT,  &UINPUT_IOCTL_BASE, 44, $len));
    }' unless defined(&UI_GET_SYSNAME);
    eval 'sub UI_GET_VERSION () { &_IOR( &UINPUT_IOCTL_BASE, 45, \'unsigned int\');}' unless defined(&UI_GET_VERSION);
    eval 'sub UI_SET_EVBIT () { &_IOWINT( &UINPUT_IOCTL_BASE, 100);}' unless defined(&UI_SET_EVBIT);
    eval 'sub UI_SET_KEYBIT () { &_IOWINT( &UINPUT_IOCTL_BASE, 101);}' unless defined(&UI_SET_KEYBIT);
    eval 'sub UI_SET_RELBIT () { &_IOWINT( &UINPUT_IOCTL_BASE, 102);}' unless defined(&UI_SET_RELBIT);
    eval 'sub UI_SET_ABSBIT () { &_IOWINT( &UINPUT_IOCTL_BASE, 103);}' unless defined(&UI_SET_ABSBIT);
    eval 'sub UI_SET_MSCBIT () { &_IOWINT( &UINPUT_IOCTL_BASE, 104);}' unless defined(&UI_SET_MSCBIT);
    eval 'sub UI_SET_LEDBIT () { &_IOWINT( &UINPUT_IOCTL_BASE, 105);}' unless defined(&UI_SET_LEDBIT);
    eval 'sub UI_SET_SNDBIT () { &_IOWINT( &UINPUT_IOCTL_BASE, 106);}' unless defined(&UI_SET_SNDBIT);
    eval 'sub UI_SET_FFBIT () { &_IOWINT( &UINPUT_IOCTL_BASE, 107);}' unless defined(&UI_SET_FFBIT);
    eval 'sub UI_SET_PHYS () { &_IO( &UINPUT_IOCTL_BASE, 108);}' unless defined(&UI_SET_PHYS);
    eval 'sub UI_SET_SWBIT () { &_IOWINT( &UINPUT_IOCTL_BASE, 109);}' unless defined(&UI_SET_SWBIT);
    eval 'sub UI_SET_PROPBIT () { &_IOWINT( &UINPUT_IOCTL_BASE, 110);}' unless defined(&UI_SET_PROPBIT);
    eval 'sub UI_BEGIN_FF_UPLOAD () { &_IOWR( &UINPUT_IOCTL_BASE, 200, \'struct uinput_ff_upload\');}' unless defined(&UI_BEGIN_FF_UPLOAD);
    eval 'sub UI_END_FF_UPLOAD () { &_IOW( &UINPUT_IOCTL_BASE, 201, \'struct uinput_ff_upload\');}' unless defined(&UI_END_FF_UPLOAD);
    eval 'sub UI_BEGIN_FF_ERASE () { &_IOWR( &UINPUT_IOCTL_BASE, 202, \'struct uinput_ff_erase\');}' unless defined(&UI_BEGIN_FF_ERASE);
    eval 'sub UI_END_FF_ERASE () { &_IOW( &UINPUT_IOCTL_BASE, 203, \'struct uinput_ff_erase\');}' unless defined(&UI_END_FF_ERASE);
    eval 'sub EV_UINPUT () {0x101;}' unless defined(&EV_UINPUT);
    eval 'sub UI_FF_UPLOAD () {1;}' unless defined(&UI_FF_UPLOAD);
    eval 'sub UI_FF_ERASE () {2;}' unless defined(&UI_FF_ERASE);
}
1;
