require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/selinfo.ph';
require 'sys/uio.ph';
require 'sys/mutex.ph';
require 'sys/taskqueue.ph';
eval 'sub splfw () { &splimp;}' unless defined(&splfw);
eval 'sub CSRROMOFF () {0x400;}' unless defined(&CSRROMOFF);
eval 'sub CSRROMSIZE () {0x400;}' unless defined(&CSRROMSIZE);
eval 'sub FWDEVINIT () {1;}' unless defined(&FWDEVINIT);
eval 'sub FWDEVATTACHED () {2;}' unless defined(&FWDEVATTACHED);
eval 'sub FWDEVINVAL () {3;}' unless defined(&FWDEVINVAL);
eval 'sub FW_MAX_DMACH () {0x20;}' unless defined(&FW_MAX_DMACH);
eval 'sub FW_MAX_DEVCH () { &FW_MAX_DMACH;}' unless defined(&FW_MAX_DEVCH);
eval 'sub FW_XFERTIMEOUT () {1;}' unless defined(&FW_XFERTIMEOUT);
eval 'sub FWTI_REQ () {(1<< 0);}' unless defined(&FWTI_REQ);
eval 'sub FWTI_RES () {(1<< 1);}' unless defined(&FWTI_RES);
eval 'sub FWTI_TLABEL () {(1<< 2);}' unless defined(&FWTI_TLABEL);
eval 'sub FWTI_BLOCK_STR () {(1<< 3);}' unless defined(&FWTI_BLOCK_STR);
eval 'sub FWTI_BLOCK_ASY () {(1<< 4);}' unless defined(&FWTI_BLOCK_ASY);
eval 'sub FWPHYASYST () {(1<< 0);}' unless defined(&FWPHYASYST);
eval 'sub FWBUSDETACH () {(-2);}' unless defined(&FWBUSDETACH);
eval 'sub FWBUSNOTREADY () {(-1);}' unless defined(&FWBUSNOTREADY);
eval 'sub FWBUSRESET () {0;}' unless defined(&FWBUSRESET);
eval 'sub FWBUSINIT () {1;}' unless defined(&FWBUSINIT);
eval 'sub FWBUSCYMELECT () {2;}' unless defined(&FWBUSCYMELECT);
eval 'sub FWBUSMGRELECT () {3;}' unless defined(&FWBUSMGRELECT);
eval 'sub FWBUSMGRDONE () {4;}' unless defined(&FWBUSMGRDONE);
eval 'sub FWBUSEXPLORE () {5;}' unless defined(&FWBUSEXPLORE);
eval 'sub FWBUSPHYCONF () {6;}' unless defined(&FWBUSPHYCONF);
eval 'sub FWBUSEXPDONE () {7;}' unless defined(&FWBUSEXPDONE);
eval 'sub FWBUSCOMPLETION () {10;}' unless defined(&FWBUSCOMPLETION);
eval 'sub CSRSIZE () {0x4000;}' unless defined(&CSRSIZE);
eval 'sub CROMSIZE () {0x400;}' unless defined(&CROMSIZE);
unless(defined(&CSRARC)) {
    sub CSRARC {
	my($sc, $offset) = @_;
	eval q((($sc)-> $csr_arc[($offset) / 4]));
    }
}
unless(defined(&FW_GMTX)) {
    sub FW_GMTX {
	my($fc) = @_;
	eval q((($fc)-> &mtx));
    }
}
unless(defined(&FW_GLOCK)) {
    sub FW_GLOCK {
	my($fc) = @_;
	eval q( &mtx_lock( &FW_GMTX($fc)));
    }
}
unless(defined(&FW_GUNLOCK)) {
    sub FW_GUNLOCK {
	my($fc) = @_;
	eval q( &mtx_unlock( &FW_GMTX($fc)));
    }
}
unless(defined(&FW_GLOCK_ASSERT)) {
    sub FW_GLOCK_ASSERT {
	my($fc) = @_;
	eval q( &mtx_assert( &FW_GMTX($fc),  &MA_OWNED));
    }
}
eval 'sub FWXFERQ_CHTAGMASK () {0xff;}' unless defined(&FWXFERQ_CHTAGMASK);
eval 'sub FWXFERQ_RUNNING () {(1<< 8);}' unless defined(&FWXFERQ_RUNNING);
eval 'sub FWXFERQ_STREAM () {(1<< 9);}' unless defined(&FWXFERQ_STREAM);
eval 'sub FWXFERQ_BULK () {(1<< 11);}' unless defined(&FWXFERQ_BULK);
eval 'sub FWXFERQ_MODEMASK () {(7<< 10);}' unless defined(&FWXFERQ_MODEMASK);
eval 'sub FWXFERQ_EXTBUF () {(1<< 13);}' unless defined(&FWXFERQ_EXTBUF);
eval 'sub FWXFERQ_OPEN () {(1<< 14);}' unless defined(&FWXFERQ_OPEN);
eval 'sub FWXFERQ_HANDLER () {(1<< 16);}' unless defined(&FWXFERQ_HANDLER);
eval 'sub FWXFERQ_WAKEUP () {(1<< 17);}' unless defined(&FWXFERQ_WAKEUP);
eval 'sub FWXF_INIT () {0x;}' unless defined(&FWXF_INIT);
eval 'sub FWXF_INQ () {0x1;}' unless defined(&FWXF_INQ);
eval 'sub FWXF_START () {0x2;}' unless defined(&FWXF_START);
eval 'sub FWXF_SENT () {0x4;}' unless defined(&FWXF_SENT);
eval 'sub FWXF_SENTERR () {0x8;}' unless defined(&FWXF_SENTERR);
eval 'sub FWXF_BUSY () {0x10;}' unless defined(&FWXF_BUSY);
eval 'sub FWXF_RCVD () {0x20;}' unless defined(&FWXF_RCVD);
eval 'sub FWXF_WAKE () {0x80;}' unless defined(&FWXF_WAKE);
eval 'sub FWPRI () {(( &PZERO + 8) |  &PCATCH);}' unless defined(&FWPRI);
unless(defined(&CALLOUT_INIT)) {
    sub CALLOUT_INIT {
	my($x) = @_;
	eval q( &callout_init($x, 1));
    }
}
1;
