require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&fwdma_v_addr)) {
    sub fwdma_v_addr {
	my($am,$index) = @_;
	eval q({  &bus_size_t  &ssize =  ($am->{ssize}); 'int'  &offset =  ($am->{esize}) * $index; ( ($am->{seg[&offset/ssize]}->{v_addr}) + ( &offset %  &ssize)); });
    }
}
unless(defined(&fwdma_bus_addr)) {
    sub fwdma_bus_addr {
	my($am,$index) = @_;
	eval q({  &bus_size_t  &ssize =  ($am->{ssize}); 'int'  &offset =  ($am->{esize}) * $index; ( ($am->{seg[&offset/ssize]}->{bus_addr}) + ( &offset %  &ssize)); });
    }
}
unless(defined(&fwdma_sync)) {
    sub fwdma_sync {
	my($dma,$op) = @_;
	eval q({  &bus_dmamap_sync( ($dma->{dma_tag}),  ($dma->{dma_map}), $op); });
    }
}
unless(defined(&fwdma_sync_multiseg)) {
    sub fwdma_sync_multiseg {
	my($am,$start,$end,$op) = @_;
	eval q({ 'struct fwdma_seg' * &seg, * &eseg;  &seg =  ($am->{seg[$am}->{esize * start / am}->{ssize]});  &eseg =  ($am->{seg[$am}->{esize * end / am}->{ssize]});  &for (;  &seg <=  &eseg;  &seg++)  &bus_dmamap_sync( ($am->{dma_tag}),  ($seg->{dma_map}), $op); });
    }
}
unless(defined(&fwdma_sync_multiseg_all)) {
    sub fwdma_sync_multiseg_all {
	my($am,$op) = @_;
	eval q({ 'struct fwdma_seg' * &seg; 'int'  &i;  &seg =  ($am->{seg[0]});  &for ( &i = 0;  &i <  ($am->{nseg});  &i++,  &seg++)  &bus_dmamap_sync( ($am->{dma_tag}),  ($seg->{dma_map}), $op); });
    }
}
1;
