require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_HWPMC_AMD_H_)) {
    eval 'sub _DEV_HWPMC_AMD_H_ () {1;}' unless defined(&_DEV_HWPMC_AMD_H_);
    eval 'sub AMD_PMC_EVSEL_0 () {0xc0010000;}' unless defined(&AMD_PMC_EVSEL_0);
    eval 'sub AMD_PMC_EVSEL_1 () {0xc0010001;}' unless defined(&AMD_PMC_EVSEL_1);
    eval 'sub AMD_PMC_EVSEL_2 () {0xc0010002;}' unless defined(&AMD_PMC_EVSEL_2);
    eval 'sub AMD_PMC_EVSEL_3 () {0xc0010003;}' unless defined(&AMD_PMC_EVSEL_3);
    eval 'sub AMD_PMC_PERFCTR_0 () {0xc0010004;}' unless defined(&AMD_PMC_PERFCTR_0);
    eval 'sub AMD_PMC_PERFCTR_1 () {0xc0010005;}' unless defined(&AMD_PMC_PERFCTR_1);
    eval 'sub AMD_PMC_PERFCTR_2 () {0xc0010006;}' unless defined(&AMD_PMC_PERFCTR_2);
    eval 'sub AMD_PMC_PERFCTR_3 () {0xc0010007;}' unless defined(&AMD_PMC_PERFCTR_3);
    eval 'sub AMD_NPMCS () {4;}' unless defined(&AMD_NPMCS);
    eval 'sub AMD_PMC_COUNTERMASK () {0xff000000;}' unless defined(&AMD_PMC_COUNTERMASK);
    eval 'sub AMD_PMC_TO_COUNTER {
        my($x) = @_;
	    eval q(((($x) << 24) &  &AMD_PMC_COUNTERMASK));
    }' unless defined(&AMD_PMC_TO_COUNTER);
    eval 'sub AMD_PMC_INVERT () {(1<< 23);}' unless defined(&AMD_PMC_INVERT);
    eval 'sub AMD_PMC_ENABLE () {(1<< 22);}' unless defined(&AMD_PMC_ENABLE);
    eval 'sub AMD_PMC_INT () {(1<< 20);}' unless defined(&AMD_PMC_INT);
    eval 'sub AMD_PMC_PC () {(1<< 19);}' unless defined(&AMD_PMC_PC);
    eval 'sub AMD_PMC_EDGE () {(1<< 18);}' unless defined(&AMD_PMC_EDGE);
    eval 'sub AMD_PMC_OS () {(1<< 17);}' unless defined(&AMD_PMC_OS);
    eval 'sub AMD_PMC_USR () {(1<< 16);}' unless defined(&AMD_PMC_USR);
    eval 'sub AMD_PMC_UNITMASK_M () {0x10;}' unless defined(&AMD_PMC_UNITMASK_M);
    eval 'sub AMD_PMC_UNITMASK_O () {0x8;}' unless defined(&AMD_PMC_UNITMASK_O);
    eval 'sub AMD_PMC_UNITMASK_E () {0x4;}' unless defined(&AMD_PMC_UNITMASK_E);
    eval 'sub AMD_PMC_UNITMASK_S () {0x2;}' unless defined(&AMD_PMC_UNITMASK_S);
    eval 'sub AMD_PMC_UNITMASK_I () {0x1;}' unless defined(&AMD_PMC_UNITMASK_I);
    eval 'sub AMD_PMC_UNITMASK_MOESI () {0x1f;}' unless defined(&AMD_PMC_UNITMASK_MOESI);
    eval 'sub AMD_PMC_UNITMASK () {0xff00;}' unless defined(&AMD_PMC_UNITMASK);
    eval 'sub AMD_PMC_EVENTMASK () {0xff;}' unless defined(&AMD_PMC_EVENTMASK);
    eval 'sub AMD_PMC_TO_UNITMASK {
        my($x) = @_;
	    eval q(((($x) << 8) &  &AMD_PMC_UNITMASK));
    }' unless defined(&AMD_PMC_TO_UNITMASK);
    eval 'sub AMD_PMC_TO_EVENTMASK {
        my($x) = @_;
	    eval q((($x) & 0xff));
    }' unless defined(&AMD_PMC_TO_EVENTMASK);
    eval 'sub AMD_VALID_BITS () {( &AMD_PMC_COUNTERMASK |  &AMD_PMC_INVERT |  &AMD_PMC_ENABLE |  &AMD_PMC_INT |  &AMD_PMC_PC |  &AMD_PMC_EDGE |  &AMD_PMC_OS |  &AMD_PMC_USR |  &AMD_PMC_UNITMASK |  &AMD_PMC_EVENTMASK);}' unless defined(&AMD_VALID_BITS);
    eval 'sub AMD_PMC_CAPS () {( &PMC_CAP_INTERRUPT |  &PMC_CAP_USER |  &PMC_CAP_SYSTEM |  &PMC_CAP_EDGE |  &PMC_CAP_THRESHOLD |  &PMC_CAP_READ |  &PMC_CAP_WRITE |  &PMC_CAP_INVERT |  &PMC_CAP_QUALIFIER);}' unless defined(&AMD_PMC_CAPS);
    eval 'sub AMD_PMC_IS_STOPPED {
        my($evsel) = @_;
	    eval q((( &rdmsr(($evsel)) &  &AMD_PMC_ENABLE) == 0));
    }' unless defined(&AMD_PMC_IS_STOPPED);
    eval 'sub AMD_PMC_HAS_OVERFLOWED {
        my($pmc) = @_;
	    eval q((( &rdpmc($pmc) & (1 << 47)) == 0));
    }' unless defined(&AMD_PMC_HAS_OVERFLOWED);
    eval 'sub AMD_RELOAD_COUNT_TO_PERFCTR_VALUE {
        my($V) = @_;
	    eval q((-($V)));
    }' unless defined(&AMD_RELOAD_COUNT_TO_PERFCTR_VALUE);
    eval 'sub AMD_PERFCTR_VALUE_TO_RELOAD_COUNT {
        my($P) = @_;
	    eval q((-($P)));
    }' unless defined(&AMD_PERFCTR_VALUE_TO_RELOAD_COUNT);
    if(defined(&_KERNEL)) {
    }
}
1;
