require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_HWPMC_CORE_H_)) {
    eval 'sub _DEV_HWPMC_CORE_H_ () {1;}' unless defined(&_DEV_HWPMC_CORE_H_);
    eval 'sub IA32_PERF_CAPABILITIES () {0x345;}' unless defined(&IA32_PERF_CAPABILITIES);
    eval 'sub PERFCAP_LBR_FORMAT () {0x3f;}' unless defined(&PERFCAP_LBR_FORMAT);
    eval 'sub PERFCAP_PEBS_TRAP () {0x40;}' unless defined(&PERFCAP_PEBS_TRAP);
    eval 'sub PERFCAP_PEBS_SAVEARCH () {0x80;}' unless defined(&PERFCAP_PEBS_SAVEARCH);
    eval 'sub PERFCAP_PEBS_RECFORMAT () {0xf00;}' unless defined(&PERFCAP_PEBS_RECFORMAT);
    eval 'sub PERFCAP_SMM_FREEZE () {0x1000;}' unless defined(&PERFCAP_SMM_FREEZE);
    eval 'sub PERFCAP_FW_WRITE () {0x2000;}' unless defined(&PERFCAP_FW_WRITE);
    eval 'sub IAF_OS () {0x1;}' unless defined(&IAF_OS);
    eval 'sub IAF_USR () {0x2;}' unless defined(&IAF_USR);
    eval 'sub IAF_ANY () {0x4;}' unless defined(&IAF_ANY);
    eval 'sub IAF_PMI () {0x8;}' unless defined(&IAF_PMI);
    eval 'sub IAP_EVSEL {
        my($C) = @_;
	    eval q((($C) & 0xff));
    }' unless defined(&IAP_EVSEL);
    eval 'sub IAP_UMASK {
        my($C) = @_;
	    eval q((($C) & 0xff00));
    }' unless defined(&IAP_UMASK);
    eval 'sub IAP_USR () {(1<< 16);}' unless defined(&IAP_USR);
    eval 'sub IAP_OS () {(1<< 17);}' unless defined(&IAP_OS);
    eval 'sub IAP_EDGE () {(1<< 18);}' unless defined(&IAP_EDGE);
    eval 'sub IAP_INT () {(1<< 20);}' unless defined(&IAP_INT);
    eval 'sub IAP_ANY () {(1<< 21);}' unless defined(&IAP_ANY);
    eval 'sub IAP_EN () {(1<< 22);}' unless defined(&IAP_EN);
    eval 'sub IAP_INV () {(1<< 23);}' unless defined(&IAP_INV);
    eval 'sub IAP_CMASK {
        my($C) = @_;
	    eval q(((($C) & 0xff) << 24));
    }' unless defined(&IAP_CMASK);
    eval 'sub IA_OFFCORE_RSP_MASK_I7WM () {0xf7ff;}' unless defined(&IA_OFFCORE_RSP_MASK_I7WM);
    eval 'sub IA_OFFCORE_RSP_MASK_SBIB () {0x3f807f8fff;}' unless defined(&IA_OFFCORE_RSP_MASK_SBIB);
    if(defined(&_KERNEL)) {
	eval 'sub IAF_MASK () {0xf;}' unless defined(&IAF_MASK);
	eval 'sub IAF_COUNTER_MASK () {0xffffffffffff;}' unless defined(&IAF_COUNTER_MASK);
	eval 'sub IAF_CTR0 () {0x309;}' unless defined(&IAF_CTR0);
	eval 'sub IAF_CTR1 () {0x30a;}' unless defined(&IAF_CTR1);
	eval 'sub IAF_CTR2 () {0x30b;}' unless defined(&IAF_CTR2);
	eval 'sub IAF_OFFSET () {32;}' unless defined(&IAF_OFFSET);
	eval 'sub IAF_CTRL () {0x38d;}' unless defined(&IAF_CTRL);
	eval 'sub IAF_CTRL_MASK () {0xbbb;}' unless defined(&IAF_CTRL_MASK);
	eval 'sub IAP_PMC0 () {0xc1;}' unless defined(&IAP_PMC0);
	eval 'sub IAP_A_PMC0 () {0x4c1;}' unless defined(&IAP_A_PMC0);
	eval 'sub IAP_EVSEL_MASK () {0xffdfffff;}' unless defined(&IAP_EVSEL_MASK);
	eval 'sub IAP_EVSEL0 () {0x186;}' unless defined(&IAP_EVSEL0);
	eval 'sub IA_GLOBAL_STATUS () {0x38e;}' unless defined(&IA_GLOBAL_STATUS);
	eval 'sub IA_GLOBAL_CTRL () {0x38f;}' unless defined(&IA_GLOBAL_CTRL);
	eval 'sub IAF_GLOBAL_CTRL_MASK () {0x700000000;}' unless defined(&IAF_GLOBAL_CTRL_MASK);
	eval 'sub IAP_GLOBAL_CTRL_MASK () {0xffffffff;}' unless defined(&IAP_GLOBAL_CTRL_MASK);
	eval 'sub IA_GLOBAL_CTRL_MASK () {0x7ffffffff;}' unless defined(&IA_GLOBAL_CTRL_MASK);
	eval 'sub IA_GLOBAL_OVF_CTRL () {0x390;}' unless defined(&IA_GLOBAL_OVF_CTRL);
	eval 'sub IA_GLOBAL_STATUS_FLAG_CONDCHG () {(1 << 63);}' unless defined(&IA_GLOBAL_STATUS_FLAG_CONDCHG);
	eval 'sub IA_GLOBAL_STATUS_FLAG_OVFBUF () {(1 << 62);}' unless defined(&IA_GLOBAL_STATUS_FLAG_OVFBUF);
	eval 'sub IA_OFFCORE_RSP0 () {0x1a6;}' unless defined(&IA_OFFCORE_RSP0);
	eval 'sub IA_OFFCORE_RSP1 () {0x1a7;}' unless defined(&IA_OFFCORE_RSP1);
    }
}
1;
