require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_HWPMC_PIV_H_)) {
    eval 'sub _DEV_HWPMC_PIV_H_ () {1;}' unless defined(&_DEV_HWPMC_PIV_H_);
    eval 'sub P4_NPMCS () {18;}' unless defined(&P4_NPMCS);
    eval 'sub P4_NESCR () {45;}' unless defined(&P4_NESCR);
    eval 'sub P4_INVALID_PMC_INDEX () {-1;}' unless defined(&P4_INVALID_PMC_INDEX);
    eval 'sub P4_MAX_ESCR_PER_EVENT () {2;}' unless defined(&P4_MAX_ESCR_PER_EVENT);
    eval 'sub P4_MAX_PMC_PER_ESCR () {3;}' unless defined(&P4_MAX_PMC_PER_ESCR);
    eval 'sub P4_CCCR_OVF () {(1 << 31);}' unless defined(&P4_CCCR_OVF);
    eval 'sub P4_CCCR_CASCADE () {(1<< 30);}' unless defined(&P4_CCCR_CASCADE);
    eval 'sub P4_CCCR_OVF_PMI_T1 () {(1<< 27);}' unless defined(&P4_CCCR_OVF_PMI_T1);
    eval 'sub P4_CCCR_OVF_PMI_T0 () {(1<< 26);}' unless defined(&P4_CCCR_OVF_PMI_T0);
    eval 'sub P4_CCCR_FORCE_OVF () {(1<< 25);}' unless defined(&P4_CCCR_FORCE_OVF);
    eval 'sub P4_CCCR_EDGE () {(1<< 24);}' unless defined(&P4_CCCR_EDGE);
    eval 'sub P4_CCCR_THRESHOLD_SHIFT () {20;}' unless defined(&P4_CCCR_THRESHOLD_SHIFT);
    eval 'sub P4_CCCR_THRESHOLD_MASK () {0xf00000;}' unless defined(&P4_CCCR_THRESHOLD_MASK);
    eval 'sub P4_CCCR_TO_THRESHOLD {
        my($C) = @_;
	    eval q(((($C) <<  &P4_CCCR_THRESHOLD_SHIFT) &  &P4_CCCR_THRESHOLD_MASK));
    }' unless defined(&P4_CCCR_TO_THRESHOLD);
    eval 'sub P4_CCCR_COMPLEMENT () {(1<< 19);}' unless defined(&P4_CCCR_COMPLEMENT);
    eval 'sub P4_CCCR_COMPARE () {(1<< 18);}' unless defined(&P4_CCCR_COMPARE);
    eval 'sub P4_CCCR_ACTIVE_THREAD_SHIFT () {16;}' unless defined(&P4_CCCR_ACTIVE_THREAD_SHIFT);
    eval 'sub P4_CCCR_ACTIVE_THREAD_MASK () {0x30000;}' unless defined(&P4_CCCR_ACTIVE_THREAD_MASK);
    eval 'sub P4_CCCR_TO_ACTIVE_THREAD {
        my($T) = @_;
	    eval q(((($T) <<  &P4_CCCR_ACTIVE_THREAD_SHIFT) &  &P4_CCCR_ACTIVE_THREAD_MASK));
    }' unless defined(&P4_CCCR_TO_ACTIVE_THREAD);
    eval 'sub P4_CCCR_ESCR_SELECT_SHIFT () {13;}' unless defined(&P4_CCCR_ESCR_SELECT_SHIFT);
    eval 'sub P4_CCCR_ESCR_SELECT_MASK () {0xe000;}' unless defined(&P4_CCCR_ESCR_SELECT_MASK);
    eval 'sub P4_CCCR_TO_ESCR_SELECT {
        my($E) = @_;
	    eval q(((($E) <<  &P4_CCCR_ESCR_SELECT_SHIFT) &  &P4_CCCR_ESCR_SELECT_MASK));
    }' unless defined(&P4_CCCR_TO_ESCR_SELECT);
    eval 'sub P4_CCCR_ENABLE () {(1<< 12);}' unless defined(&P4_CCCR_ENABLE);
    eval 'sub P4_CCCR_VALID_BITS () {( &P4_CCCR_OVF |  &P4_CCCR_CASCADE |  &P4_CCCR_OVF_PMI_T1 |  &P4_CCCR_OVF_PMI_T0 |  &P4_CCCR_FORCE_OVF |  &P4_CCCR_EDGE |  &P4_CCCR_THRESHOLD_MASK |  &P4_CCCR_COMPLEMENT |  &P4_CCCR_COMPARE |  &P4_CCCR_ESCR_SELECT_MASK |  &P4_CCCR_ENABLE);}' unless defined(&P4_CCCR_VALID_BITS);
    eval 'sub P4_ESCR_EVENT_SELECT_SHIFT () {25;}' unless defined(&P4_ESCR_EVENT_SELECT_SHIFT);
    eval 'sub P4_ESCR_EVENT_SELECT_MASK () {0x7e000000;}' unless defined(&P4_ESCR_EVENT_SELECT_MASK);
    eval 'sub P4_ESCR_TO_EVENT_SELECT {
        my($E) = @_;
	    eval q(((($E) <<  &P4_ESCR_EVENT_SELECT_SHIFT) &  &P4_ESCR_EVENT_SELECT_MASK));
    }' unless defined(&P4_ESCR_TO_EVENT_SELECT);
    eval 'sub P4_ESCR_EVENT_MASK_SHIFT () {9;}' unless defined(&P4_ESCR_EVENT_MASK_SHIFT);
    eval 'sub P4_ESCR_EVENT_MASK_MASK () {0x1fffe00;}' unless defined(&P4_ESCR_EVENT_MASK_MASK);
    eval 'sub P4_ESCR_TO_EVENT_MASK {
        my($M) = @_;
	    eval q(((($M) <<  &P4_ESCR_EVENT_MASK_SHIFT) &  &P4_ESCR_EVENT_MASK_MASK));
    }' unless defined(&P4_ESCR_TO_EVENT_MASK);
    eval 'sub P4_ESCR_TAG_VALUE_SHIFT () {5;}' unless defined(&P4_ESCR_TAG_VALUE_SHIFT);
    eval 'sub P4_ESCR_TAG_VALUE_MASK () {0x1e0;}' unless defined(&P4_ESCR_TAG_VALUE_MASK);
    eval 'sub P4_ESCR_TO_TAG_VALUE {
        my($T) = @_;
	    eval q(((($T) <<  &P4_ESCR_TAG_VALUE_SHIFT) &  &P4_ESCR_TAG_VALUE_MASK));
    }' unless defined(&P4_ESCR_TO_TAG_VALUE);
    eval 'sub P4_ESCR_TAG_ENABLE () {0x10;}' unless defined(&P4_ESCR_TAG_ENABLE);
    eval 'sub P4_ESCR_T0_OS () {0x8;}' unless defined(&P4_ESCR_T0_OS);
    eval 'sub P4_ESCR_T0_USR () {0x4;}' unless defined(&P4_ESCR_T0_USR);
    eval 'sub P4_ESCR_T1_OS () {0x2;}' unless defined(&P4_ESCR_T1_OS);
    eval 'sub P4_ESCR_T1_USR () {0x1;}' unless defined(&P4_ESCR_T1_USR);
    eval 'sub P4_ESCR_OS () { &P4_ESCR_T0_OS;}' unless defined(&P4_ESCR_OS);
    eval 'sub P4_ESCR_USR () { &P4_ESCR_T0_USR;}' unless defined(&P4_ESCR_USR);
    eval 'sub P4_ESCR_VALID_BITS () {( &P4_ESCR_EVENT_SELECT_MASK |  &P4_ESCR_EVENT_MASK_MASK |  &P4_ESCR_TAG_VALUE_MASK |  &P4_ESCR_TAG_ENABLE |  &P4_ESCR_T0_OS |  &P4_ESCR_T0_USR |  &P4_ESCR_T1_OS  &P4_ESCR_T1_USR);}' unless defined(&P4_ESCR_VALID_BITS);
    eval 'sub P4_PERFCTR_MASK () {0xffffffffff;}' unless defined(&P4_PERFCTR_MASK);
    eval 'sub P4_PERFCTR_OVERFLOWED {
        my($PMC) = @_;
	    eval q((( &rdpmc($PMC) & (1 << 39)) == 0));
    }' unless defined(&P4_PERFCTR_OVERFLOWED);
    eval 'sub P4_CCCR_MSR_FIRST () {0x360;}' unless defined(&P4_CCCR_MSR_FIRST);
    eval 'sub P4_PERFCTR_MSR_FIRST () {0x300;}' unless defined(&P4_PERFCTR_MSR_FIRST);
    eval 'sub P4_RELOAD_COUNT_TO_PERFCTR_VALUE {
        my($V) = @_;
	    eval q((1- ($V)));
    }' unless defined(&P4_RELOAD_COUNT_TO_PERFCTR_VALUE);
    eval 'sub P4_PERFCTR_VALUE_TO_RELOAD_COUNT {
        my($P) = @_;
	    eval q((1- ($P)));
    }' unless defined(&P4_PERFCTR_VALUE_TO_RELOAD_COUNT);
    if(defined(&_KERNEL)) {
    }
}
1;
