require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_HWPMC_POWERPC_H_)) {
    eval 'sub _DEV_HWPMC_POWERPC_H_ () {1;}' unless defined(&_DEV_HWPMC_POWERPC_H_);
    if(defined(&_KERNEL)) {
	eval 'sub POWERPC_PMC_CAPS () {( &PMC_CAP_INTERRUPT |  &PMC_CAP_USER |  &PMC_CAP_SYSTEM |  &PMC_CAP_EDGE |  &PMC_CAP_THRESHOLD |  &PMC_CAP_READ |  &PMC_CAP_WRITE |  &PMC_CAP_INVERT |  &PMC_CAP_QUALIFIER);}' unless defined(&POWERPC_PMC_CAPS);
	eval 'sub POWERPC_PMC_KERNEL_ENABLE () {(0x1 << 30);}' unless defined(&POWERPC_PMC_KERNEL_ENABLE);
	eval 'sub POWERPC_PMC_USER_ENABLE () {(0x1 << 31);}' unless defined(&POWERPC_PMC_USER_ENABLE);
	eval 'sub POWERPC_PMC_ENABLE () {( &POWERPC_PMC_KERNEL_ENABLE |  &POWERPC_PMC_USER_ENABLE);}' unless defined(&POWERPC_PMC_ENABLE);
	eval 'sub POWERPC_RELOAD_COUNT_TO_PERFCTR_VALUE {
	    my($V) = @_;
    	    eval q((0x80000000-($V)));
	}' unless defined(&POWERPC_RELOAD_COUNT_TO_PERFCTR_VALUE);
	eval 'sub POWERPC_PERFCTR_VALUE_TO_RELOAD_COUNT {
	    my($P) = @_;
    	    eval q((0x80000000-($P)));
	}' unless defined(&POWERPC_PERFCTR_VALUE_TO_RELOAD_COUNT);
    }
}
1;
