require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_HWPMC_PPRO_H_)) {
    eval 'sub _DEV_HWPMC_PPRO_H_ () {1;}' unless defined(&_DEV_HWPMC_PPRO_H_);
    eval 'sub P6_NPMCS () {2;}' unless defined(&P6_NPMCS);
    eval 'sub P6_EVSEL_CMASK_MASK () {0xff000000;}' unless defined(&P6_EVSEL_CMASK_MASK);
    eval 'sub P6_EVSEL_TO_CMASK {
        my($C) = @_;
	    eval q(((($C) & 0xff) << 24));
    }' unless defined(&P6_EVSEL_TO_CMASK);
    eval 'sub P6_EVSEL_INV () {(1<< 23);}' unless defined(&P6_EVSEL_INV);
    eval 'sub P6_EVSEL_EN () {(1<< 22);}' unless defined(&P6_EVSEL_EN);
    eval 'sub P6_EVSEL_INT () {(1<< 20);}' unless defined(&P6_EVSEL_INT);
    eval 'sub P6_EVSEL_PC () {(1<< 19);}' unless defined(&P6_EVSEL_PC);
    eval 'sub P6_EVSEL_E () {(1<< 18);}' unless defined(&P6_EVSEL_E);
    eval 'sub P6_EVSEL_OS () {(1<< 17);}' unless defined(&P6_EVSEL_OS);
    eval 'sub P6_EVSEL_USR () {(1<< 16);}' unless defined(&P6_EVSEL_USR);
    eval 'sub P6_EVSEL_UMASK_MASK () {0xff00;}' unless defined(&P6_EVSEL_UMASK_MASK);
    eval 'sub P6_EVSEL_TO_UMASK {
        my($U) = @_;
	    eval q(((($U) & 0xff) << 8));
    }' unless defined(&P6_EVSEL_TO_UMASK);
    eval 'sub P6_EVSEL_EVENT_SELECT {
        my($ES) = @_;
	    eval q((($ES) & 0xff));
    }' unless defined(&P6_EVSEL_EVENT_SELECT);
    eval 'sub P6_EVSEL_RESERVED () {(1<< 21);}' unless defined(&P6_EVSEL_RESERVED);
    eval 'sub P6_MSR_EVSEL0 () {0x186;}' unless defined(&P6_MSR_EVSEL0);
    eval 'sub P6_MSR_EVSEL1 () {0x187;}' unless defined(&P6_MSR_EVSEL1);
    eval 'sub P6_MSR_PERFCTR0 () {0xc1;}' unless defined(&P6_MSR_PERFCTR0);
    eval 'sub P6_MSR_PERFCTR1 () {0xc2;}' unless defined(&P6_MSR_PERFCTR1);
    eval 'sub P6_PERFCTR_READ_MASK () {0xffffffffff;}' unless defined(&P6_PERFCTR_READ_MASK);
    eval 'sub P6_PERFCTR_WRITE_MASK () {0xffffffff;}' unless defined(&P6_PERFCTR_WRITE_MASK);
    eval 'sub P6_RELOAD_COUNT_TO_PERFCTR_VALUE {
        my($R) = @_;
	    eval q((-($R)));
    }' unless defined(&P6_RELOAD_COUNT_TO_PERFCTR_VALUE);
    eval 'sub P6_PERFCTR_VALUE_TO_RELOAD_COUNT {
        my($P) = @_;
	    eval q((-($P)));
    }' unless defined(&P6_PERFCTR_VALUE_TO_RELOAD_COUNT);
    eval 'sub P6_PMC_HAS_OVERFLOWED {
        my($P) = @_;
	    eval q((( &rdpmc($P) & (1 << 39)) == 0));
    }' unless defined(&P6_PMC_HAS_OVERFLOWED);
    if(defined(&_KERNEL)) {
    }
}
1;
