require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_HWPMC_UNCORE_H_)) {
    eval 'sub _DEV_HWPMC_UNCORE_H_ () {1;}' unless defined(&_DEV_HWPMC_UNCORE_H_);
    eval 'sub UCF_EN () {0x1;}' unless defined(&UCF_EN);
    eval 'sub UCF_PMI () {0x4;}' unless defined(&UCF_PMI);
    eval 'sub UCP_EVSEL {
        my($C) = @_;
	    eval q((($C) & 0xff));
    }' unless defined(&UCP_EVSEL);
    eval 'sub UCP_UMASK {
        my($C) = @_;
	    eval q((($C) & 0xff00));
    }' unless defined(&UCP_UMASK);
    eval 'sub UCP_CTRR () {(1<< 17);}' unless defined(&UCP_CTRR);
    eval 'sub UCP_EDGE () {(1<< 18);}' unless defined(&UCP_EDGE);
    eval 'sub UCP_INT () {(1<< 20);}' unless defined(&UCP_INT);
    eval 'sub UCP_EN () {(1<< 22);}' unless defined(&UCP_EN);
    eval 'sub UCP_INV () {(1<< 23);}' unless defined(&UCP_INV);
    eval 'sub UCP_CMASK {
        my($C) = @_;
	    eval q(((($C) & 0xff) << 24));
    }' unless defined(&UCP_CMASK);
    if(defined(&_KERNEL)) {
	eval 'sub DCTL_FLAG_UNC_PMI () {(1 << 13);}' unless defined(&DCTL_FLAG_UNC_PMI);
	eval 'sub UCF_MASK () {0xf;}' unless defined(&UCF_MASK);
	eval 'sub UCF_CTR0 () {0x394;}' unless defined(&UCF_CTR0);
	eval 'sub UCF_OFFSET () {32;}' unless defined(&UCF_OFFSET);
	eval 'sub UCF_OFFSET_SB () {29;}' unless defined(&UCF_OFFSET_SB);
	eval 'sub UCF_CTRL () {0x395;}' unless defined(&UCF_CTRL);
	eval 'sub UCP_PMC0 () {0x3b0;}' unless defined(&UCP_PMC0);
	eval 'sub UCP_EVSEL0 () {0x3c0;}' unless defined(&UCP_EVSEL0);
	eval 'sub UCP_OPCODE_MATCH () {0x396;}' unless defined(&UCP_OPCODE_MATCH);
	eval 'sub UCP_CB0_EVSEL0 () {0x700;}' unless defined(&UCP_CB0_EVSEL0);
	eval 'sub UC_GLOBAL_STATUS () {0x392;}' unless defined(&UC_GLOBAL_STATUS);
	eval 'sub UC_GLOBAL_CTRL () {0x391;}' unless defined(&UC_GLOBAL_CTRL);
	eval 'sub UC_GLOBAL_OVF_CTRL () {0x393;}' unless defined(&UC_GLOBAL_OVF_CTRL);
	eval 'sub UC_GLOBAL_STATUS_FLAG_CLRCHG () {(1 << 63);}' unless defined(&UC_GLOBAL_STATUS_FLAG_CLRCHG);
	eval 'sub UC_GLOBAL_STATUS_FLAG_OVFPMI () {(1 << 61);}' unless defined(&UC_GLOBAL_STATUS_FLAG_OVFPMI);
	eval 'sub UC_GLOBAL_CTRL_FLAG_FRZ () {(1 << 63);}' unless defined(&UC_GLOBAL_CTRL_FLAG_FRZ);
	eval 'sub UC_GLOBAL_CTRL_FLAG_ENPMICORE0 () {(1 << 48);}' unless defined(&UC_GLOBAL_CTRL_FLAG_ENPMICORE0);
	eval 'sub MSR_GQ_SNOOP_MESF () {0x301;}' unless defined(&MSR_GQ_SNOOP_MESF);
    }
}
1;
