require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_HYPERV_H_)) {
    eval 'sub _HYPERV_H_ () {1;}' unless defined(&_HYPERV_H_);
    if(defined(&_KERNEL)) {
	require 'sys/param.ph';
	require 'sys/systm.ph';
	eval 'sub MSR_HV_TIME_REF_COUNT () {0x40000020;}' unless defined(&MSR_HV_TIME_REF_COUNT);
	eval 'sub CPUID_HV_MSR_TIME_REFCNT () {0x2;}' unless defined(&CPUID_HV_MSR_TIME_REFCNT);
	eval 'sub CPUID_HV_MSR_SYNIC () {0x4;}' unless defined(&CPUID_HV_MSR_SYNIC);
	eval 'sub CPUID_HV_MSR_SYNTIMER () {0x8;}' unless defined(&CPUID_HV_MSR_SYNTIMER);
	eval 'sub CPUID_HV_MSR_APIC () {0x10;}' unless defined(&CPUID_HV_MSR_APIC);
	eval 'sub CPUID_HV_MSR_HYPERCALL () {0x20;}' unless defined(&CPUID_HV_MSR_HYPERCALL);
	eval 'sub CPUID_HV_MSR_VP_INDEX () {0x40;}' unless defined(&CPUID_HV_MSR_VP_INDEX);
	eval 'sub CPUID_HV_MSR_REFERENCE_TSC () {0x200;}' unless defined(&CPUID_HV_MSR_REFERENCE_TSC);
	eval 'sub CPUID_HV_MSR_GUEST_IDLE () {0x400;}' unless defined(&CPUID_HV_MSR_GUEST_IDLE);
	unless(defined(&NANOSEC)) {
	    eval 'sub NANOSEC () {1000000000;}' unless defined(&NANOSEC);
	}
	eval 'sub HYPERV_TIMER_NS_FACTOR () {100;}' unless defined(&HYPERV_TIMER_NS_FACTOR);
	eval 'sub HYPERV_TIMER_FREQ () {( &NANOSEC /  &HYPERV_TIMER_NS_FACTOR);}' unless defined(&HYPERV_TIMER_FREQ);
    }
    eval 'sub HYPERV_REFTSC_DEVNAME () {"hv_tsc";}' unless defined(&HYPERV_REFTSC_DEVNAME);
    if(defined(&CTASSERT)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub HYPERV_GUID_STRLEN () {40;}' unless defined(&HYPERV_GUID_STRLEN);
    }
}
1;
