require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_IC_SAB82532_H_)) {
    eval 'sub _DEV_IC_SAB82532_H_ () {1;}' unless defined(&_DEV_IC_SAB82532_H_);
    eval 'sub SAB_NCHAN () {2;}' unless defined(&SAB_NCHAN);
    eval 'sub SAB_CHANLEN () {0x40;}' unless defined(&SAB_CHANLEN);
    eval 'sub SAB_CHAN_A () {0x;}' unless defined(&SAB_CHAN_A);
    eval 'sub SAB_CHAN_B () {0x40;}' unless defined(&SAB_CHAN_B);
    eval 'sub SAB_RFIFO () {0x;}' unless defined(&SAB_RFIFO);
    eval 'sub SAB_XFIFO () {0x;}' unless defined(&SAB_XFIFO);
    eval 'sub SAB_STAR () {0x20;}' unless defined(&SAB_STAR);
    eval 'sub SAB_CMDR () {0x20;}' unless defined(&SAB_CMDR);
    eval 'sub SAB_MODE () {0x22;}' unless defined(&SAB_MODE);
    eval 'sub SAB_TIMR () {0x23;}' unless defined(&SAB_TIMR);
    eval 'sub SAB_XON () {0x24;}' unless defined(&SAB_XON);
    eval 'sub SAB_XOFF () {0x25;}' unless defined(&SAB_XOFF);
    eval 'sub SAB_TCR () {0x26;}' unless defined(&SAB_TCR);
    eval 'sub SAB_DAFO () {0x27;}' unless defined(&SAB_DAFO);
    eval 'sub SAB_RFC () {0x28;}' unless defined(&SAB_RFC);
    eval 'sub SAB_RBCL () {0x2a;}' unless defined(&SAB_RBCL);
    eval 'sub SAB_TBCL () {0x2a;}' unless defined(&SAB_TBCL);
    eval 'sub SAB_RBCH () {0x2b;}' unless defined(&SAB_RBCH);
    eval 'sub SAB_XBCH () {0x2b;}' unless defined(&SAB_XBCH);
    eval 'sub SAB_CCR0 () {0x2c;}' unless defined(&SAB_CCR0);
    eval 'sub SAB_CCR1 () {0x2d;}' unless defined(&SAB_CCR1);
    eval 'sub SAB_CCR2 () {0x2e;}' unless defined(&SAB_CCR2);
    eval 'sub SAB_CCR3 () {0x2f;}' unless defined(&SAB_CCR3);
    eval 'sub SAB_TSAX () {0x30;}' unless defined(&SAB_TSAX);
    eval 'sub SAB_TSAR () {0x31;}' unless defined(&SAB_TSAR);
    eval 'sub SAB_XCCR () {0x32;}' unless defined(&SAB_XCCR);
    eval 'sub SAB_RCCR () {0x33;}' unless defined(&SAB_RCCR);
    eval 'sub SAB_VSTR () {0x34;}' unless defined(&SAB_VSTR);
    eval 'sub SAB_BGR () {0x34;}' unless defined(&SAB_BGR);
    eval 'sub SAB_TIC () {0x35;}' unless defined(&SAB_TIC);
    eval 'sub SAB_MXN () {0x36;}' unless defined(&SAB_MXN);
    eval 'sub SAB_MXF () {0x37;}' unless defined(&SAB_MXF);
    eval 'sub SAB_GIS () {0x38;}' unless defined(&SAB_GIS);
    eval 'sub SAB_IVA () {0x38;}' unless defined(&SAB_IVA);
    eval 'sub SAB_IPC () {0x39;}' unless defined(&SAB_IPC);
    eval 'sub SAB_ISR0 () {0x3a;}' unless defined(&SAB_ISR0);
    eval 'sub SAB_IMR0 () {0x3a;}' unless defined(&SAB_IMR0);
    eval 'sub SAB_ISR1 () {0x3b;}' unless defined(&SAB_ISR1);
    eval 'sub SAB_IMR1 () {0x3b;}' unless defined(&SAB_IMR1);
    eval 'sub SAB_PVR () {0x3c;}' unless defined(&SAB_PVR);
    eval 'sub SAB_PIS () {0x3d;}' unless defined(&SAB_PIS);
    eval 'sub SAB_PIM () {0x3d;}' unless defined(&SAB_PIM);
    eval 'sub SAB_PCR () {0x3e;}' unless defined(&SAB_PCR);
    eval 'sub SAB_CCR4 () {0x3f;}' unless defined(&SAB_CCR4);
    eval 'sub SAB_STAR_XDOV () {0x80;}' unless defined(&SAB_STAR_XDOV);
    eval 'sub SAB_STAR_XFW () {0x40;}' unless defined(&SAB_STAR_XFW);
    eval 'sub SAB_STAR_RFNE () {0x20;}' unless defined(&SAB_STAR_RFNE);
    eval 'sub SAB_STAR_FCS () {0x10;}' unless defined(&SAB_STAR_FCS);
    eval 'sub SAB_STAR_TEC () {0x8;}' unless defined(&SAB_STAR_TEC);
    eval 'sub SAB_STAR_CEC () {0x4;}' unless defined(&SAB_STAR_CEC);
    eval 'sub SAB_STAR_CTS () {0x2;}' unless defined(&SAB_STAR_CTS);
    eval 'sub SAB_CMDR_RMC () {0x80;}' unless defined(&SAB_CMDR_RMC);
    eval 'sub SAB_CMDR_RRES () {0x40;}' unless defined(&SAB_CMDR_RRES);
    eval 'sub SAB_CMDR_RFRD () {0x20;}' unless defined(&SAB_CMDR_RFRD);
    eval 'sub SAB_CMDR_STI () {0x10;}' unless defined(&SAB_CMDR_STI);
    eval 'sub SAB_CMDR_XF () {0x8;}' unless defined(&SAB_CMDR_XF);
    eval 'sub SAB_CMDR_XRES () {0x1;}' unless defined(&SAB_CMDR_XRES);
    eval 'sub SAB_MODE_FRTS () {0x40;}' unless defined(&SAB_MODE_FRTS);
    eval 'sub SAB_MODE_FCTS () {0x20;}' unless defined(&SAB_MODE_FCTS);
    eval 'sub SAB_MODE_FLON () {0x10;}' unless defined(&SAB_MODE_FLON);
    eval 'sub SAB_MODE_RAC () {0x8;}' unless defined(&SAB_MODE_RAC);
    eval 'sub SAB_MODE_RTS () {0x4;}' unless defined(&SAB_MODE_RTS);
    eval 'sub SAB_MODE_TRS () {0x2;}' unless defined(&SAB_MODE_TRS);
    eval 'sub SAB_MODE_TLP () {0x1;}' unless defined(&SAB_MODE_TLP);
    eval 'sub SAB_TIMR_CNT () {0xe0;}' unless defined(&SAB_TIMR_CNT);
    eval 'sub SAB_TIMR_VAL () {0x1f;}' unless defined(&SAB_TIMR_VAL);
    eval 'sub SAB_DAFO_XBRK () {0x40;}' unless defined(&SAB_DAFO_XBRK);
    eval 'sub SAB_DAFO_STOP () {0x20;}' unless defined(&SAB_DAFO_STOP);
    eval 'sub SAB_DAFO_PAR1 () {0x10;}' unless defined(&SAB_DAFO_PAR1);
    eval 'sub SAB_DAFO_PAR0 () {0x8;}' unless defined(&SAB_DAFO_PAR0);
    eval 'sub SAB_DAFO_PARE () {0x4;}' unless defined(&SAB_DAFO_PARE);
    eval 'sub SAB_DAFO_CHL1 () {0x2;}' unless defined(&SAB_DAFO_CHL1);
    eval 'sub SAB_DAFO_CHL0 () {0x1;}' unless defined(&SAB_DAFO_CHL0);
    eval 'sub SAB_DAFO_CHL_CSIZE () {( &SAB_DAFO_CHL1| &SAB_DAFO_CHL0);}' unless defined(&SAB_DAFO_CHL_CSIZE);
    eval 'sub SAB_DAFO_CHL_CS5 () {( &SAB_DAFO_CHL1| &SAB_DAFO_CHL0);}' unless defined(&SAB_DAFO_CHL_CS5);
    eval 'sub SAB_DAFO_CHL_CS6 () {( &SAB_DAFO_CHL1);}' unless defined(&SAB_DAFO_CHL_CS6);
    eval 'sub SAB_DAFO_CHL_CS7 () {( &SAB_DAFO_CHL0);}' unless defined(&SAB_DAFO_CHL_CS7);
    eval 'sub SAB_DAFO_CHL_CS8 () {(0);}' unless defined(&SAB_DAFO_CHL_CS8);
    eval 'sub SAB_DAFO_PARMASK () {( &SAB_DAFO_PAR1| &SAB_DAFO_PAR0| &SAB_DAFO_PARE);}' unless defined(&SAB_DAFO_PARMASK);
    eval 'sub SAB_DAFO_PAR_MARK () {( &SAB_DAFO_PAR1| &SAB_DAFO_PAR0| &SAB_DAFO_PARE);}' unless defined(&SAB_DAFO_PAR_MARK);
    eval 'sub SAB_DAFO_PAR_EVEN () {( &SAB_DAFO_PAR1| &SAB_DAFO_PARE);}' unless defined(&SAB_DAFO_PAR_EVEN);
    eval 'sub SAB_DAFO_PAR_ODD () {( &SAB_DAFO_PAR0| &SAB_DAFO_PARE);}' unless defined(&SAB_DAFO_PAR_ODD);
    eval 'sub SAB_DAFO_PAR_SPACE () {( &SAB_DAFO_PARE);}' unless defined(&SAB_DAFO_PAR_SPACE);
    eval 'sub SAB_DAFO_PAR_NONE () {(0);}' unless defined(&SAB_DAFO_PAR_NONE);
    eval 'sub SAB_RFC_DPS () {0x40;}' unless defined(&SAB_RFC_DPS);
    eval 'sub SAB_RFC_DXS () {0x20;}' unless defined(&SAB_RFC_DXS);
    eval 'sub SAB_RFC_RFDF () {0x10;}' unless defined(&SAB_RFC_RFDF);
    eval 'sub SAB_RFC_RFTH1 () {0x8;}' unless defined(&SAB_RFC_RFTH1);
    eval 'sub SAB_RFC_RFTH0 () {0x4;}' unless defined(&SAB_RFC_RFTH0);
    eval 'sub SAB_RFC_TCDE () {0x1;}' unless defined(&SAB_RFC_TCDE);
    eval 'sub SAB_RFC_RFTH_MASK () {( &SAB_RFC_RFTH1| &SAB_RFC_RFTH0);}' unless defined(&SAB_RFC_RFTH_MASK);
    eval 'sub SAB_RFC_RFTH_32CHAR () {( &SAB_RFC_RFTH1| &SAB_RFC_RFTH0);}' unless defined(&SAB_RFC_RFTH_32CHAR);
    eval 'sub SAB_RFC_RFTH_16CHAR () {( &SAB_RFC_RFTH1);}' unless defined(&SAB_RFC_RFTH_16CHAR);
    eval 'sub SAB_RFC_RFTH_4CHAR () {( &SAB_RFC_RFTH0);}' unless defined(&SAB_RFC_RFTH_4CHAR);
    eval 'sub SAB_RFC_RFTH_1CHAR () {(0);}' unless defined(&SAB_RFC_RFTH_1CHAR);
    eval 'sub SAB_RBCH_DMA () {0x80;}' unless defined(&SAB_RBCH_DMA);
    eval 'sub SAB_RBCH_CAS () {0x20;}' unless defined(&SAB_RBCH_CAS);
    eval 'sub SAB_RBCH_CNT () {0xf;}' unless defined(&SAB_RBCH_CNT);
    eval 'sub SAB_XBCH_DMA () {0x80;}' unless defined(&SAB_XBCH_DMA);
    eval 'sub SAB_XBCH_CAS () {0x20;}' unless defined(&SAB_XBCH_CAS);
    eval 'sub SAB_XBCH_XC () {0x10;}' unless defined(&SAB_XBCH_XC);
    eval 'sub SAB_XBCH_CNT () {0xf;}' unless defined(&SAB_XBCH_CNT);
    eval 'sub SAB_CCR0_PU () {0x80;}' unless defined(&SAB_CCR0_PU);
    eval 'sub SAB_CCR0_MCE () {0x40;}' unless defined(&SAB_CCR0_MCE);
    eval 'sub SAB_CCR0_SC2 () {0x10;}' unless defined(&SAB_CCR0_SC2);
    eval 'sub SAB_CCR0_SC1 () {0x8;}' unless defined(&SAB_CCR0_SC1);
    eval 'sub SAB_CCR0_SC0 () {0x4;}' unless defined(&SAB_CCR0_SC0);
    eval 'sub SAB_CCR0_SM1 () {0x2;}' unless defined(&SAB_CCR0_SM1);
    eval 'sub SAB_CCR0_SM0 () {0x1;}' unless defined(&SAB_CCR0_SM0);
    eval 'sub SAB_CCR0_SC_MASK () {( &SAB_CCR0_SC2| &SAB_CCR0_SC1| &SAB_CCR0_SC0);}' unless defined(&SAB_CCR0_SC_MASK);
    eval 'sub SAB_CCR0_SC_NRZ () {(0);}' unless defined(&SAB_CCR0_SC_NRZ);
    eval 'sub SAB_CCR0_SC_NRZI () {( &SAB_CCR0_SC1);}' unless defined(&SAB_CCR0_SC_NRZI);
    eval 'sub SAB_CCR0_SC_FM0 () {( &SAB_CCR0_SC2);}' unless defined(&SAB_CCR0_SC_FM0);
    eval 'sub SAB_CCR0_SC_FM1 () {( &SAB_CCR0_SC2| &SAB_CCR0_SC0);}' unless defined(&SAB_CCR0_SC_FM1);
    eval 'sub SAB_CCR0_SC_MANCHESTER () {( &SAB_CCR0_SC2| &SAB_CCR0_SC1);}' unless defined(&SAB_CCR0_SC_MANCHESTER);
    eval 'sub SAB_CCR0_SM_MASK () {( &SAB_CCR0_SM1| &SAB_CCR0_SM0);}' unless defined(&SAB_CCR0_SM_MASK);
    eval 'sub SAB_CCR0_SM_DLC () {(0);}' unless defined(&SAB_CCR0_SM_DLC);
    eval 'sub SAB_CCR0_SM_DLCLOOP () {( &SAB_CCR0_SM0);}' unless defined(&SAB_CCR0_SM_DLCLOOP);
    eval 'sub SAB_CCR0_SM_BISYNC () {( &SAB_CCR0_SM1);}' unless defined(&SAB_CCR0_SM_BISYNC);
    eval 'sub SAB_CCR0_SM_ASYNC () {( &SAB_CCR0_SM1| &SAB_CCR0_SM0);}' unless defined(&SAB_CCR0_SM_ASYNC);
    eval 'sub SAB_CCR1_ODS () {0x10;}' unless defined(&SAB_CCR1_ODS);
    eval 'sub SAB_CCR1_BCR () {0x8;}' unless defined(&SAB_CCR1_BCR);
    eval 'sub SAB_CCR1_CM2 () {0x4;}' unless defined(&SAB_CCR1_CM2);
    eval 'sub SAB_CCR1_CM1 () {0x2;}' unless defined(&SAB_CCR1_CM1);
    eval 'sub SAB_CCR1_CM0 () {0x1;}' unless defined(&SAB_CCR1_CM0);
    eval 'sub SAB_CCR1_CM_MASK () {( &SAB_CCR1_CM2| &SAB_CCR1_CM1| &SAB_CCR1_CM0);}' unless defined(&SAB_CCR1_CM_MASK);
    eval 'sub SAB_CCR1_CM_7 () {( &SAB_CCR1_CM2| &SAB_CCR1_CM1| &SAB_CCR1_CM0);}' unless defined(&SAB_CCR1_CM_7);
    eval 'sub SAB_CCR2_SOC1 () {0x80;}' unless defined(&SAB_CCR2_SOC1);
    eval 'sub SAB_CCR2_SOC0 () {0x40;}' unless defined(&SAB_CCR2_SOC0);
    eval 'sub SAB_CCR2_SOC_MASK () {( &SAB_CCR2_SOC1| &SAB_CCR2_SOC0);}' unless defined(&SAB_CCR2_SOC_MASK);
    eval 'sub SAB_CCR2_SOC_RTSHIGH () {( &SAB_CCR2_SOC1);}' unless defined(&SAB_CCR2_SOC_RTSHIGH);
    eval 'sub SAB_CCR2_SOC_RTSNORM () {(0);}' unless defined(&SAB_CCR2_SOC_RTSNORM);
    eval 'sub SAB_CCR2_SOC_RTSRX () {( &SAB_CCR2_SOC1| &SAB_CCR2_SOC0);}' unless defined(&SAB_CCR2_SOC_RTSRX);
    eval 'sub SAB_CCR2_BR9 () {0x80;}' unless defined(&SAB_CCR2_BR9);
    eval 'sub SAB_CCR2_BR8 () {0x40;}' unless defined(&SAB_CCR2_BR8);
    eval 'sub SAB_CCR2_BDF () {0x20;}' unless defined(&SAB_CCR2_BDF);
    eval 'sub SAB_CCR2_SSEL () {0x10;}' unless defined(&SAB_CCR2_SSEL);
    eval 'sub SAB_CCR2_XCS0 () {0x20;}' unless defined(&SAB_CCR2_XCS0);
    eval 'sub SAB_CCR2_RCS0 () {0x10;}' unless defined(&SAB_CCR2_RCS0);
    eval 'sub SAB_CCR2_TOE () {0x8;}' unless defined(&SAB_CCR2_TOE);
    eval 'sub SAB_CCR2_RWX () {0x4;}' unless defined(&SAB_CCR2_RWX);
    eval 'sub SAB_CCR2_DIV () {0x1;}' unless defined(&SAB_CCR2_DIV);
    eval 'sub SAB_CCR3_PSD () {0x1;}' unless defined(&SAB_CCR3_PSD);
    eval 'sub SAB_TSAX_TSNX () {0xfc;}' unless defined(&SAB_TSAX_TSNX);
    eval 'sub SAB_TSAX_XCS2 () {0x2;}' unless defined(&SAB_TSAX_XCS2);
    eval 'sub SAB_TSAX_XCS1 () {0x1;}' unless defined(&SAB_TSAX_XCS1);
    eval 'sub SAB_TSAR_TSNR () {0xfc;}' unless defined(&SAB_TSAR_TSNR);
    eval 'sub SAB_TSAR_RCS2 () {0x2;}' unless defined(&SAB_TSAR_RCS2);
    eval 'sub SAB_TSAR_RCS1 () {0x1;}' unless defined(&SAB_TSAR_RCS1);
    eval 'sub SAB_VSTR_CD () {0x80;}' unless defined(&SAB_VSTR_CD);
    eval 'sub SAB_VSTR_DPLA () {0x40;}' unless defined(&SAB_VSTR_DPLA);
    eval 'sub SAB_VSTR_VMASK () {0xf;}' unless defined(&SAB_VSTR_VMASK);
    eval 'sub SAB_VSTR_V_1 () {0x;}' unless defined(&SAB_VSTR_V_1);
    eval 'sub SAB_VSTR_V_2 () {0x1;}' unless defined(&SAB_VSTR_V_2);
    eval 'sub SAB_VSTR_V_32 () {0x2;}' unless defined(&SAB_VSTR_V_32);
    eval 'sub SAB_GIS_PI () {0x80;}' unless defined(&SAB_GIS_PI);
    eval 'sub SAB_GIS_ISA1 () {0x8;}' unless defined(&SAB_GIS_ISA1);
    eval 'sub SAB_GIS_ISA0 () {0x4;}' unless defined(&SAB_GIS_ISA0);
    eval 'sub SAB_GIS_ISB1 () {0x2;}' unless defined(&SAB_GIS_ISB1);
    eval 'sub SAB_GIS_ISB0 () {0x1;}' unless defined(&SAB_GIS_ISB0);
    eval 'sub SAB_IVA_MASK () {0xf8;}' unless defined(&SAB_IVA_MASK);
    eval 'sub SAB_IPC_VIS () {0x80;}' unless defined(&SAB_IPC_VIS);
    eval 'sub SAB_IPC_SLAMASK () {0x18;}' unless defined(&SAB_IPC_SLAMASK);
    eval 'sub SAB_IPC_CASM () {0x4;}' unless defined(&SAB_IPC_CASM);
    eval 'sub SAB_IPC_ICMASK () {0x3;}' unless defined(&SAB_IPC_ICMASK);
    eval 'sub SAB_IPC_ICOD () {0x;}' unless defined(&SAB_IPC_ICOD);
    eval 'sub SAB_IPC_ICPL () {0x1;}' unless defined(&SAB_IPC_ICPL);
    eval 'sub SAB_IPC_ICPH () {0x3;}' unless defined(&SAB_IPC_ICPH);
    eval 'sub SAB_ISR0_TCD () {0x80;}' unless defined(&SAB_ISR0_TCD);
    eval 'sub SAB_ISR0_TIME () {0x40;}' unless defined(&SAB_ISR0_TIME);
    eval 'sub SAB_ISR0_PERR () {0x20;}' unless defined(&SAB_ISR0_PERR);
    eval 'sub SAB_ISR0_FERR () {0x10;}' unless defined(&SAB_ISR0_FERR);
    eval 'sub SAB_ISR0_PLLA () {0x8;}' unless defined(&SAB_ISR0_PLLA);
    eval 'sub SAB_ISR0_CDSC () {0x4;}' unless defined(&SAB_ISR0_CDSC);
    eval 'sub SAB_ISR0_RFO () {0x2;}' unless defined(&SAB_ISR0_RFO);
    eval 'sub SAB_ISR0_RPF () {0x1;}' unless defined(&SAB_ISR0_RPF);
    eval 'sub SAB_ISR1_BRK () {0x80;}' unless defined(&SAB_ISR1_BRK);
    eval 'sub SAB_ISR1_BRKT () {0x40;}' unless defined(&SAB_ISR1_BRKT);
    eval 'sub SAB_ISR1_ALLS () {0x20;}' unless defined(&SAB_ISR1_ALLS);
    eval 'sub SAB_ISR1_XOFF () {0x10;}' unless defined(&SAB_ISR1_XOFF);
    eval 'sub SAB_ISR1_TIN () {0x8;}' unless defined(&SAB_ISR1_TIN);
    eval 'sub SAB_ISR1_CSC () {0x4;}' unless defined(&SAB_ISR1_CSC);
    eval 'sub SAB_ISR1_XON () {0x2;}' unless defined(&SAB_ISR1_XON);
    eval 'sub SAB_ISR1_XPR () {0x1;}' unless defined(&SAB_ISR1_XPR);
    eval 'sub SAB_IMR0_TCD () {0x80;}' unless defined(&SAB_IMR0_TCD);
    eval 'sub SAB_IMR0_TIME () {0x40;}' unless defined(&SAB_IMR0_TIME);
    eval 'sub SAB_IMR0_PERR () {0x20;}' unless defined(&SAB_IMR0_PERR);
    eval 'sub SAB_IMR0_FERR () {0x10;}' unless defined(&SAB_IMR0_FERR);
    eval 'sub SAB_IMR0_PLLA () {0x8;}' unless defined(&SAB_IMR0_PLLA);
    eval 'sub SAB_IMR0_CDSC () {0x4;}' unless defined(&SAB_IMR0_CDSC);
    eval 'sub SAB_IMR0_RFO () {0x2;}' unless defined(&SAB_IMR0_RFO);
    eval 'sub SAB_IMR0_RPF () {0x1;}' unless defined(&SAB_IMR0_RPF);
    eval 'sub SAB_IMR1_BRK () {0x80;}' unless defined(&SAB_IMR1_BRK);
    eval 'sub SAB_IMR1_BRKT () {0x40;}' unless defined(&SAB_IMR1_BRKT);
    eval 'sub SAB_IMR1_ALLS () {0x20;}' unless defined(&SAB_IMR1_ALLS);
    eval 'sub SAB_IMR1_XDU () {0x10;}' unless defined(&SAB_IMR1_XDU);
    eval 'sub SAB_IMR1_TIN () {0x8;}' unless defined(&SAB_IMR1_TIN);
    eval 'sub SAB_IMR1_CSC () {0x4;}' unless defined(&SAB_IMR1_CSC);
    eval 'sub SAB_IMR1_XMR () {0x2;}' unless defined(&SAB_IMR1_XMR);
    eval 'sub SAB_IMR1_XPR () {0x1;}' unless defined(&SAB_IMR1_XPR);
    eval 'sub SAB_PVR_DSR_A () {0x1;}' unless defined(&SAB_PVR_DSR_A);
    eval 'sub SAB_PVR_DTR_A () {0x2;}' unless defined(&SAB_PVR_DTR_A);
    eval 'sub SAB_PVR_DTR_B () {0x4;}' unless defined(&SAB_PVR_DTR_B);
    eval 'sub SAB_PVR_DSR_B () {0x8;}' unless defined(&SAB_PVR_DSR_B);
    eval 'sub SAB_PVR_MAGIC () {0x10;}' unless defined(&SAB_PVR_MAGIC);
    eval 'sub SAB_CCR4_MCK4 () {0x80;}' unless defined(&SAB_CCR4_MCK4);
    eval 'sub SAB_CCR4_EBRG () {0x40;}' unless defined(&SAB_CCR4_EBRG);
    eval 'sub SAB_CCR4_TST1 () {0x20;}' unless defined(&SAB_CCR4_TST1);
    eval 'sub SAB_CCR4_ICD () {0x10;}' unless defined(&SAB_CCR4_ICD);
    eval 'sub SAB_RSTAT_PE () {0x80;}' unless defined(&SAB_RSTAT_PE);
    eval 'sub SAB_RSTAT_FE () {0x40;}' unless defined(&SAB_RSTAT_FE);
    eval 'sub SAB_RSTAT_PAR () {0x1;}' unless defined(&SAB_RSTAT_PAR);
}
1;
