require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_VIA6522REG_H_)) {
    eval 'sub _VIA6522REG_H_ () {1;}' unless defined(&_VIA6522REG_H_);
    eval 'sub REG_OIRB () {0;}' unless defined(&REG_OIRB);
    eval 'sub REG_OIRA () {1;}' unless defined(&REG_OIRA);
    eval 'sub REG_DDRB () {2;}' unless defined(&REG_DDRB);
    eval 'sub REG_DDRA () {3;}' unless defined(&REG_DDRA);
    eval 'sub REG_T1CL () {4;}' unless defined(&REG_T1CL);
    eval 'sub REG_T1CH () {5;}' unless defined(&REG_T1CH);
    eval 'sub REG_T1LL () {6;}' unless defined(&REG_T1LL);
    eval 'sub REG_T1LH () {7;}' unless defined(&REG_T1LH);
    eval 'sub REG_T2CL () {8;}' unless defined(&REG_T2CL);
    eval 'sub REG_T2CH () {9;}' unless defined(&REG_T2CH);
    eval 'sub REG_SR () {10;}' unless defined(&REG_SR);
    eval 'sub REG_ACR () {11;}' unless defined(&REG_ACR);
    eval 'sub REG_PCR () {12;}' unless defined(&REG_PCR);
    eval 'sub REG_IFR () {13;}' unless defined(&REG_IFR);
    eval 'sub REG_IER () {14;}' unless defined(&REG_IER);
    eval 'sub REG_OIRA_NH () {15;}' unless defined(&REG_OIRA_NH);
    eval 'sub ACR_SR_NONE () {0x;}' unless defined(&ACR_SR_NONE);
    eval 'sub ACR_SR_DIR () {0x4;}' unless defined(&ACR_SR_DIR);
    eval 'sub ACR_SRI_T2 () {0x1;}' unless defined(&ACR_SRI_T2);
    eval 'sub ACR_SRI_PHI2 () {0x2;}' unless defined(&ACR_SRI_PHI2);
    eval 'sub ACR_SRI_EXTCLK () {0x3;}' unless defined(&ACR_SRI_EXTCLK);
    eval 'sub ACR_SRO () {0x4;}' unless defined(&ACR_SRO);
    eval 'sub ACR_SRO_T2 () {0x5;}' unless defined(&ACR_SRO_T2);
    eval 'sub ACR_SRO_PHI2 () {0x6;}' unless defined(&ACR_SRO_PHI2);
    eval 'sub ACR_SRO_EXTCLK () {0x7;}' unless defined(&ACR_SRO_EXTCLK);
    eval 'sub ACR_T1_SHIFT () {5;}' unless defined(&ACR_T1_SHIFT);
    eval 'sub ACR_SR_SHIFT () {2;}' unless defined(&ACR_SR_SHIFT);
    eval 'sub PCR_INTCNTL () {0x1;}' unless defined(&PCR_INTCNTL);
    eval 'sub PCR_CNTL_MASK () {0x3;}' unless defined(&PCR_CNTL_MASK);
    eval 'sub PCR_CNTL_NEDGE () {0x;}' unless defined(&PCR_CNTL_NEDGE);
    eval 'sub PCR_CNTL_INEDGE () {0x1;}' unless defined(&PCR_CNTL_INEDGE);
    eval 'sub PCR_CNTL_PEDGE () {0x2;}' unless defined(&PCR_CNTL_PEDGE);
    eval 'sub PCR_CNTL_IPEDGE () {0x3;}' unless defined(&PCR_CNTL_IPEDGE);
    eval 'sub PCR_CNTL_HSHAKE () {0x4;}' unless defined(&PCR_CNTL_HSHAKE);
    eval 'sub PCR_CNTL_PULSE () {0x5;}' unless defined(&PCR_CNTL_PULSE);
    eval 'sub PCR_CNTL_LOW () {0x6;}' unless defined(&PCR_CNTL_LOW);
    eval 'sub PCR_CNTL_HIGH () {0x7;}' unless defined(&PCR_CNTL_HIGH);
    eval 'sub PCR_CB2_SHIFT () {5;}' unless defined(&PCR_CB2_SHIFT);
    eval 'sub PCR_CB1_SHIFT () {4;}' unless defined(&PCR_CB1_SHIFT);
    eval 'sub PCR_CA2_SHIFT () {1;}' unless defined(&PCR_CA2_SHIFT);
    eval 'sub PCR_CA1_SHIFT () {0;}' unless defined(&PCR_CA1_SHIFT);
    eval 'sub IFR_CA2 () {0x1;}' unless defined(&IFR_CA2);
    eval 'sub IFR_CA1 () {0x2;}' unless defined(&IFR_CA1);
    eval 'sub IFR_SR () {0x4;}' unless defined(&IFR_SR);
    eval 'sub IFR_CB2 () {0x8;}' unless defined(&IFR_CB2);
    eval 'sub IFR_CB1 () {0x10;}' unless defined(&IFR_CB1);
    eval 'sub IFR_T2 () {0x20;}' unless defined(&IFR_T2);
    eval 'sub IFR_T1 () {0x40;}' unless defined(&IFR_T1);
    eval 'sub IFR_IRQB () {0x80;}' unless defined(&IFR_IRQB);
    eval 'sub IER_CA2 () { &IFR_CA2;}' unless defined(&IER_CA2);
    eval 'sub IER_CA1 () { &IFR_CA1;}' unless defined(&IER_CA1);
    eval 'sub IER_SR () { &IFR_SR;}' unless defined(&IER_SR);
    eval 'sub IER_CB2 () { &IFR_CB2;}' unless defined(&IER_CB2);
    eval 'sub IER_CB1 () { &IFR_CB1;}' unless defined(&IER_CB1);
    eval 'sub IER_T2 () { &IFR_T2;}' unless defined(&IER_T2);
    eval 'sub IER_T1 () { &IFR_T1;}' unless defined(&IER_T1);
    eval 'sub IER_IRQB () { &IFR_IRQB;}' unless defined(&IER_IRQB);
}
1;
