require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DS3231REG_H_)) {
    eval 'sub _DS3231REG_H_ () {1;}' unless defined(&_DS3231REG_H_);
    eval 'sub DS3231_SECS () {0x;}' unless defined(&DS3231_SECS);
    eval 'sub DS3231_SECS_MASK () {0x7f;}' unless defined(&DS3231_SECS_MASK);
    eval 'sub DS3231_MINS () {0x1;}' unless defined(&DS3231_MINS);
    eval 'sub DS3231_MINS_MASK () {0x7f;}' unless defined(&DS3231_MINS_MASK);
    eval 'sub DS3231_HOUR () {0x2;}' unless defined(&DS3231_HOUR);
    eval 'sub DS3231_HOUR_MASK_12HR () {0x3f;}' unless defined(&DS3231_HOUR_MASK_12HR);
    eval 'sub DS3231_HOUR_MASK_24HR () {0x1f;}' unless defined(&DS3231_HOUR_MASK_24HR);
    eval 'sub DS3231_HOUR_IS_PM () {0x20;}' unless defined(&DS3231_HOUR_IS_PM);
    eval 'sub DS3231_HOUR_USE_AMPM () {0x40;}' unless defined(&DS3231_HOUR_USE_AMPM);
    eval 'sub DS3231_WEEKDAY () {0x3;}' unless defined(&DS3231_WEEKDAY);
    eval 'sub DS3231_WEEKDAY_MASK () {0x7;}' unless defined(&DS3231_WEEKDAY_MASK);
    eval 'sub DS3231_DATE () {0x4;}' unless defined(&DS3231_DATE);
    eval 'sub DS3231_DATE_MASK () {0x3f;}' unless defined(&DS3231_DATE_MASK);
    eval 'sub DS3231_MONTH () {0x5;}' unless defined(&DS3231_MONTH);
    eval 'sub DS3231_MONTH_MASK () {0x1f;}' unless defined(&DS3231_MONTH_MASK);
    eval 'sub DS3231_C_MASK () {0x80;}' unless defined(&DS3231_C_MASK);
    eval 'sub DS3231_YEAR () {0x6;}' unless defined(&DS3231_YEAR);
    eval 'sub DS3231_YEAR_MASK () {0xff;}' unless defined(&DS3231_YEAR_MASK);
    eval 'sub DS3231_CONTROL () {0xe;}' unless defined(&DS3231_CONTROL);
    eval 'sub DS3231_CTRL_EOSC () {(1<< 7);}' unless defined(&DS3231_CTRL_EOSC);
    eval 'sub DS3231_CTRL_BBSQW () {(1<< 6);}' unless defined(&DS3231_CTRL_BBSQW);
    eval 'sub DS3231_CTRL_CONV () {(1<< 5);}' unless defined(&DS3231_CTRL_CONV);
    eval 'sub DS3231_CTRL_RS2 () {(1<< 4);}' unless defined(&DS3231_CTRL_RS2);
    eval 'sub DS3231_CTRL_RS1 () {(1<< 3);}' unless defined(&DS3231_CTRL_RS1);
    eval 'sub DS3231_CTRL_RS_MASK () {( &DS3231_CTRL_RS2 |  &DS3231_CTRL_RS1);}' unless defined(&DS3231_CTRL_RS_MASK);
    eval 'sub DS3231_CTRL_RS_SHIFT () {3;}' unless defined(&DS3231_CTRL_RS_SHIFT);
    eval 'sub DS3231_CTRL_INTCN () {(1<< 2);}' unless defined(&DS3231_CTRL_INTCN);
    eval 'sub DS3231_CTRL_A2IE () {(1<< 1);}' unless defined(&DS3231_CTRL_A2IE);
    eval 'sub DS3231_CTRL_A1IE () {(1<< 0);}' unless defined(&DS3231_CTRL_A1IE);
    eval 'sub DS3231_CTRL_MASK () {( &DS3231_CTRL_EOSC |  &DS3231_CTRL_A1IE |  &DS3231_CTRL_A2IE);}' unless defined(&DS3231_CTRL_MASK);
    eval 'sub DS3231_STATUS () {0xf;}' unless defined(&DS3231_STATUS);
    eval 'sub DS3231_STATUS_OSF () {(1<< 7);}' unless defined(&DS3231_STATUS_OSF);
    eval 'sub DS3231_STATUS_EN32KHZ () {(1<< 3);}' unless defined(&DS3231_STATUS_EN32KHZ);
    eval 'sub DS3231_STATUS_BUSY () {(1<< 2);}' unless defined(&DS3231_STATUS_BUSY);
    eval 'sub DS3231_STATUS_A2F () {(1<< 1);}' unless defined(&DS3231_STATUS_A2F);
    eval 'sub DS3231_STATUS_A1F () {(1<< 0);}' unless defined(&DS3231_STATUS_A1F);
    eval 'sub DS3231_TEMP () {0x11;}' unless defined(&DS3231_TEMP);
    eval 'sub DS3231_TEMP_MASK () {0xffc0;}' unless defined(&DS3231_TEMP_MASK);
    eval 'sub DS3231_0500C () {0x80;}' unless defined(&DS3231_0500C);
    eval 'sub DS3231_0250C () {0x40;}' unless defined(&DS3231_0250C);
    eval 'sub DS3231_MSB () {0x8000;}' unless defined(&DS3231_MSB);
    eval 'sub DS3231_NEG_BIT () { &DS3231_MSB;}' unless defined(&DS3231_NEG_BIT);
    eval 'sub TZ_ZEROC () {2731;}' unless defined(&TZ_ZEROC);
}
1;
