require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__IICBUS_H)) {
    eval 'sub __IICBUS_H () {1;}' unless defined(&__IICBUS_H);
    require 'sys/_lock.ph';
    require 'sys/_mutex.ph';
    eval 'sub IICBUS_IVAR {
        my($d) = @_;
	    eval q(  &device_get_ivars($d));
    }' unless defined(&IICBUS_IVAR);
    eval 'sub IICBUS_SOFTC {
        my($d) = @_;
	    eval q(  &device_get_softc($d));
    }' unless defined(&IICBUS_SOFTC);
    eval("sub IICBUS_IVAR_ADDR () { 0; }") unless defined(&IICBUS_IVAR_ADDR);
    eval("sub IICBUS_IVAR_NOSTOP () { 1; }") unless defined(&IICBUS_IVAR_NOSTOP);
    eval 'sub IICBUS_ACCESSOR {
        my($A, $B, $T) = @_;
	    eval q( &__BUS_ACCESSOR( &iicbus, $A,  &IICBUS, $B, $T));
    }' unless defined(&IICBUS_ACCESSOR);
    eval 'sub IICBUS_LOCK {
        my($sc) = @_;
	    eval q( &mtx_lock(($sc)-> &lock));
    }' unless defined(&IICBUS_LOCK);
    eval 'sub IICBUS_UNLOCK {
        my($sc) = @_;
	    eval q( &mtx_unlock(($sc)-> &lock));
    }' unless defined(&IICBUS_UNLOCK);
    eval 'sub IICBUS_ASSERT_LOCKED {
        my($sc) = @_;
	    eval q( &mtx_assert(($sc)-> &lock,  &MA_OWNED));
    }' unless defined(&IICBUS_ASSERT_LOCKED);
}
1;
