require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__IICONF_H)) {
    eval 'sub __IICONF_H () {1;}' unless defined(&__IICONF_H);
    require 'sys/queue.ph';
    require 'dev/iicbus/iic.ph';
    eval 'sub IICPRI () {( &PZERO+8);}' unless defined(&IICPRI);
    eval 'sub LSB () {0x1;}' unless defined(&LSB);
    eval 'sub IIC_DONTWAIT () {0;}' unless defined(&IIC_DONTWAIT);
    eval 'sub IIC_NOINTR () {0;}' unless defined(&IIC_NOINTR);
    eval 'sub IIC_WAIT () {0x1;}' unless defined(&IIC_WAIT);
    eval 'sub IIC_INTR () {0x2;}' unless defined(&IIC_INTR);
    eval 'sub IIC_INTRWAIT () {( &IIC_INTR |  &IIC_WAIT);}' unless defined(&IIC_INTRWAIT);
    eval 'sub IIC_RECURSIVE () {0x4;}' unless defined(&IIC_RECURSIVE);
    eval 'sub IIC_MASTER () {0x1;}' unless defined(&IIC_MASTER);
    eval 'sub IIC_SLAVE () {0x2;}' unless defined(&IIC_SLAVE);
    eval 'sub IIC_POLLED () {0x4;}' unless defined(&IIC_POLLED);
    eval 'sub IIC_UNKNOWN () {0x;}' unless defined(&IIC_UNKNOWN);
    eval 'sub IIC_SLOW () {0x1;}' unless defined(&IIC_SLOW);
    eval 'sub IIC_FAST () {0x2;}' unless defined(&IIC_FAST);
    eval 'sub IIC_FASTEST () {0x3;}' unless defined(&IIC_FASTEST);
    eval 'sub IIC_LAST_READ () {0x1;}' unless defined(&IIC_LAST_READ);
    eval 'sub IIC_REQUEST_BUS () {0x1;}' unless defined(&IIC_REQUEST_BUS);
    eval 'sub IIC_RELEASE_BUS () {0x2;}' unless defined(&IIC_RELEASE_BUS);
    eval 'sub INTR_GENERAL () {0x1;}' unless defined(&INTR_GENERAL);
    eval 'sub INTR_START () {0x2;}' unless defined(&INTR_START);
    eval 'sub INTR_STOP () {0x3;}' unless defined(&INTR_STOP);
    eval 'sub INTR_RECEIVE () {0x4;}' unless defined(&INTR_RECEIVE);
    eval 'sub INTR_TRANSMIT () {0x5;}' unless defined(&INTR_TRANSMIT);
    eval 'sub INTR_ERROR () {0x6;}' unless defined(&INTR_ERROR);
    eval 'sub INTR_NOACK () {0x7;}' unless defined(&INTR_NOACK);
    eval 'sub IIC_NOERR () {0x;}' unless defined(&IIC_NOERR);
    eval 'sub IIC_EBUSERR () {0x1;}' unless defined(&IIC_EBUSERR);
    eval 'sub IIC_ENOACK () {0x2;}' unless defined(&IIC_ENOACK);
    eval 'sub IIC_ETIMEOUT () {0x3;}' unless defined(&IIC_ETIMEOUT);
    eval 'sub IIC_EBUSBSY () {0x4;}' unless defined(&IIC_EBUSBSY);
    eval 'sub IIC_ESTATUS () {0x5;}' unless defined(&IIC_ESTATUS);
    eval 'sub IIC_EUNDERFLOW () {0x6;}' unless defined(&IIC_EUNDERFLOW);
    eval 'sub IIC_EOVERFLOW () {0x7;}' unless defined(&IIC_EOVERFLOW);
    eval 'sub IIC_ENOTSUPP () {0x8;}' unless defined(&IIC_ENOTSUPP);
    eval 'sub IIC_ENOADDR () {0x9;}' unless defined(&IIC_ENOADDR);
    eval 'sub IIC_ERESOURCE () {0xa;}' unless defined(&IIC_ERESOURCE);
    eval 'sub iicbus_reset {
        my($bus,$speed,$addr,$oldaddr) = @_;
	    eval q(( &IICBUS_RESET( &device_get_parent($bus), $speed, $addr, $oldaddr)));
    }' unless defined(&iicbus_reset);
    eval 'sub IICBUS_MODVER () {1;}' unless defined(&IICBUS_MODVER);
    eval 'sub IICBUS_MINVER () {1;}' unless defined(&IICBUS_MINVER);
    eval 'sub IICBUS_MAXVER () {1;}' unless defined(&IICBUS_MAXVER);
    eval 'sub IICBUS_PREFVER () { &IICBUS_MODVER;}' unless defined(&IICBUS_PREFVER);
    eval 'sub IICBB_MODVER () {1;}' unless defined(&IICBB_MODVER);
    eval 'sub IICBB_MINVER () {1;}' unless defined(&IICBB_MINVER);
    eval 'sub IICBB_MAXVER () {1;}' unless defined(&IICBB_MAXVER);
    eval 'sub IICBB_PREFVER () { &IICBB_MODVER;}' unless defined(&IICBB_PREFVER);
}
1;
