require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MFIVAR_H)) {
    eval 'sub _MFIVAR_H () {1;}' unless defined(&_MFIVAR_H);
    require 'sys/cdefs.ph';
    require 'sys/lock.ph';
    require 'sys/sx.ph';
    require 'sys/types.ph';
    require 'sys/taskqueue.ph';
    require './dev/mfi/opt_mfi.ph';
    require 'cam/scsi/scsi_all.ph';
    eval 'sub MEGASAS_MAX_NAME () {32;}' unless defined(&MEGASAS_MAX_NAME);
    eval 'sub MEGASAS_VERSION () {"4.23";}' unless defined(&MEGASAS_VERSION);
    eval 'sub MFI_CMD_MAPPED () {(1<<0);}' unless defined(&MFI_CMD_MAPPED);
    eval 'sub MFI_CMD_DATAIN () {(1<<1);}' unless defined(&MFI_CMD_DATAIN);
    eval 'sub MFI_CMD_DATAOUT () {(1<<2);}' unless defined(&MFI_CMD_DATAOUT);
    eval 'sub MFI_CMD_COMPLETED () {(1<<3);}' unless defined(&MFI_CMD_COMPLETED);
    eval 'sub MFI_CMD_POLLED () {(1<<4);}' unless defined(&MFI_CMD_POLLED);
    eval 'sub MFI_CMD_SCSI () {(1<<5);}' unless defined(&MFI_CMD_SCSI);
    eval 'sub MFI_CMD_CCB () {(1<<6);}' unless defined(&MFI_CMD_CCB);
    eval 'sub MFI_CMD_BIO () {(1<<7);}' unless defined(&MFI_CMD_BIO);
    eval 'sub MFI_CMD_TBOLT () {(1<<8);}' unless defined(&MFI_CMD_TBOLT);
    eval 'sub MFI_ON_MFIQ_FREE () {(1<<9);}' unless defined(&MFI_ON_MFIQ_FREE);
    eval 'sub MFI_ON_MFIQ_READY () {(1<<10);}' unless defined(&MFI_ON_MFIQ_READY);
    eval 'sub MFI_ON_MFIQ_BUSY () {(1<<11);}' unless defined(&MFI_ON_MFIQ_BUSY);
    eval 'sub MFI_ON_MFIQ_MASK () {( &MFI_ON_MFIQ_FREE |  &MFI_ON_MFIQ_READY|  &MFI_ON_MFIQ_BUSY);}' unless defined(&MFI_ON_MFIQ_MASK);
    eval 'sub MFI_CMD_FLAGS_FMT () {"\\20" "\\1MAPPED" "\\2DATAIN" "\\3DATAOUT" "\\4COMPLETED" "\\5POLLED" "\\6SCSI" "\\7BIO" "\\10TBOLT" "\\11Q_FREE" "\\12Q_READY" "\\13Q_BUSY";}' unless defined(&MFI_CMD_FLAGS_FMT);
    eval 'sub MFI_DISK_FLAGS_OPEN () {0x1;}' unless defined(&MFI_DISK_FLAGS_OPEN);
    eval 'sub MFI_DISK_FLAGS_DISABLED () {0x2;}' unless defined(&MFI_DISK_FLAGS_DISABLED);
    eval 'sub MFI_FLAGS_SG64 () {(1<<0);}' unless defined(&MFI_FLAGS_SG64);
    eval 'sub MFI_FLAGS_QFRZN () {(1<<1);}' unless defined(&MFI_FLAGS_QFRZN);
    eval 'sub MFI_FLAGS_OPEN () {(1<<2);}' unless defined(&MFI_FLAGS_OPEN);
    eval 'sub MFI_FLAGS_STOP () {(1<<3);}' unless defined(&MFI_FLAGS_STOP);
    eval 'sub MFI_FLAGS_1064R () {(1<<4);}' unless defined(&MFI_FLAGS_1064R);
    eval 'sub MFI_FLAGS_1078 () {(1<<5);}' unless defined(&MFI_FLAGS_1078);
    eval 'sub MFI_FLAGS_GEN2 () {(1<<6);}' unless defined(&MFI_FLAGS_GEN2);
    eval 'sub MFI_FLAGS_SKINNY () {(1<<7);}' unless defined(&MFI_FLAGS_SKINNY);
    eval 'sub MFI_FLAGS_TBOLT () {(1<<8);}' unless defined(&MFI_FLAGS_TBOLT);
    eval 'sub MFI_FLAGS_MRSAS () {(1<<9);}' unless defined(&MFI_FLAGS_MRSAS);
    eval 'sub MFI_FLAGS_INVADER () {(1<<10);}' unless defined(&MFI_FLAGS_INVADER);
    eval 'sub MFI_FLAGS_FURY () {(1<<11);}' unless defined(&MFI_FLAGS_FURY);
    eval 'sub XXX_MFI_CMD_OP_INIT2 () {0x9;}' unless defined(&XXX_MFI_CMD_OP_INIT2);
    eval 'sub MFI_REQ_DESCRIPT_FLAGS_LD_IO () {0x7;}' unless defined(&MFI_REQ_DESCRIPT_FLAGS_LD_IO);
    eval 'sub MFI_REQ_DESCRIPT_FLAGS_MFA () {0x1;}' unless defined(&MFI_REQ_DESCRIPT_FLAGS_MFA);
    eval 'sub MFI_REQ_DESCRIPT_FLAGS_TYPE_SHIFT () {0x1;}' unless defined(&MFI_REQ_DESCRIPT_FLAGS_TYPE_SHIFT);
    eval 'sub MFI_FUSION_FP_DEFAULT_TIMEOUT () {0x14;}' unless defined(&MFI_FUSION_FP_DEFAULT_TIMEOUT);
    eval 'sub MFI_LOAD_BALANCE_FLAG () {0x1;}' unless defined(&MFI_LOAD_BALANCE_FLAG);
    eval 'sub MFI_DCMD_MBOX_PEND_FLAG () {0x1;}' unless defined(&MFI_DCMD_MBOX_PEND_FLAG);
    eval 'sub MEGASAS_SCSI_VARIABLE_LENGTH_CMD () {0x7f;}' unless defined(&MEGASAS_SCSI_VARIABLE_LENGTH_CMD);
    eval 'sub MEGASAS_SCSI_SERVICE_ACTION_READ32 () {0x9;}' unless defined(&MEGASAS_SCSI_SERVICE_ACTION_READ32);
    eval 'sub MEGASAS_SCSI_SERVICE_ACTION_WRITE32 () {0xb;}' unless defined(&MEGASAS_SCSI_SERVICE_ACTION_WRITE32);
    eval 'sub MEGASAS_SCSI_ADDL_CDB_LEN () {0x18;}' unless defined(&MEGASAS_SCSI_ADDL_CDB_LEN);
    eval 'sub MEGASAS_RD_WR_PROTECT_CHECK_ALL () {0x20;}' unless defined(&MEGASAS_RD_WR_PROTECT_CHECK_ALL);
    eval 'sub MEGASAS_RD_WR_PROTECT_CHECK_NONE () {0x60;}' unless defined(&MEGASAS_RD_WR_PROTECT_CHECK_NONE);
    eval 'sub MEGASAS_EEDPBLOCKSIZE () {512;}' unless defined(&MEGASAS_EEDPBLOCKSIZE);
    eval 'sub MFIQ_ADD {
        my($sc, $qname) = @_;
	    eval q( &do { \'struct mfi_qstat\' * &qs;  &qs = ($sc)-> $mfi_qstat[$qname];  ($qs->{q_length})++;  &if ( ($qs->{q_length}) >  ($qs->{q_max}))  ($qs->{q_max}) =  ($qs->{q_length}); }  &while (0));
    }' unless defined(&MFIQ_ADD);
    eval 'sub MFIQ_REMOVE {
        my($sc, $qname) = @_;
	    eval q(($sc)-> ($mfi_qstat[$qname]->{q_length})--);
    }' unless defined(&MFIQ_REMOVE);
    eval 'sub MFIQ_INIT {
        my($sc, $qname) = @_;
	    eval q( &do {  ($sc->{mfi_qstat[$qname]}->{q_length}) = 0;  ($sc->{mfi_qstat[$qname]}->{q_max}) = 0; }  &while (0));
    }' unless defined(&MFIQ_INIT);
    eval 'sub MFIQ_COMMAND_QUEUE {
        my($name, $index) = @_;
	    eval q( &static  &__inline  &void  &mfi_initq_  $name (\'struct mfi_softc\' * &sc) {  &TAILQ_INIT( ($sc->{mfi_})  $name);  &MFIQ_INIT( &sc, $index); }  &static  &__inline  &void  &mfi_enqueue_  $name (\'struct mfi_command\' * &cm) {  &if (( ($cm->{cm_flags}) &  &MFI_ON_MFIQ_MASK) != 0) {  &panic(\\"command %p is on another queue, \\" \\"flags = %#x\\\\n\\",  &cm,  ($cm->{cm_flags})); }  &TAILQ_INSERT_TAIL( ($cm->{cm_sc}->{mfi_})  $name,  &cm,  &cm_link);  ($cm->{cm_flags}) |=  &MFI_ON_  $index;  &MFIQ_ADD( ($cm->{cm_sc}), $index); }  &static  &__inline  &void  &mfi_requeue_  $name (\'struct mfi_command\' * &cm) {  &if (( ($cm->{cm_flags}) &  &MFI_ON_MFIQ_MASK) != 0) {  &panic(\\"command %p is on another queue, \\" \\"flags = %#x\\\\n\\",  &cm,  ($cm->{cm_flags})); }  &TAILQ_INSERT_HEAD( ($cm->{cm_sc}->{mfi_})  $name,  &cm,  &cm_link);  ($cm->{cm_flags}) |=  &MFI_ON_  $index;  &MFIQ_ADD( ($cm->{cm_sc}), $index); }  &static  &__inline \'struct mfi_command\' *  &mfi_dequeue_  $name (\'struct mfi_softc\' * &sc) { \'struct mfi_command\' * &cm;  &if (( &cm =  &TAILQ_FIRST( ($sc->{mfi_})  $name)) !=  &NULL) {  &if (( ($cm->{cm_flags}) &  &MFI_ON_  $index) == 0) {  &panic(\\"command %p not in queue, \\" \\"flags = %#x, bit = %#x\\\\n\\",  &cm,  ($cm->{cm_flags}),  &MFI_ON_  $index); }  &TAILQ_REMOVE( ($sc->{mfi_})  $name,  &cm,  &cm_link);  ($cm->{cm_flags}) &= ~ &MFI_ON_  $index;  &MFIQ_REMOVE( &sc, $index); }  &return ( &cm); }  &static  &__inline  &void  &mfi_remove_  $name (\'struct mfi_command\' * &cm) {  &if (( ($cm->{cm_flags}) &  &MFI_ON_  $index) == 0) {  &panic(\\"command %p not in queue, flags = %#x, \\" \\"bit = %#x\\\\n\\",  &cm,  ($cm->{cm_flags}),  &MFI_ON_  $index); }  &TAILQ_REMOVE( ($cm->{cm_sc}->{mfi_})  $name,  &cm,  &cm_link);  ($cm->{cm_flags}) &= ~ &MFI_ON_  $index;  &MFIQ_REMOVE( ($cm->{cm_sc}), $index); } \'struct hack\');
    }' unless defined(&MFIQ_COMMAND_QUEUE);
    eval 'sub mfi_initq_bio {
        my($sc) = @_;
	    eval q({  &bioq_init( ($sc->{mfi_bioq}));  &MFIQ_INIT($sc,  &MFIQ_BIO); });
    }' unless defined(&mfi_initq_bio);
    eval 'sub mfi_enqueue_bio {
        my($sc,$bp) = @_;
	    eval q({  &bioq_insert_tail( ($sc->{mfi_bioq}), $bp);  &MFIQ_ADD($sc,  &MFIQ_BIO); });
    }' unless defined(&mfi_enqueue_bio);
    eval 'sub mfi_dequeue_bio {
        my($sc) = @_;
	    eval q({ \'struct bio\' * &bp;  &if (( &bp =  &bioq_first( ($sc->{mfi_bioq}))) !=  &NULL) {  &bioq_remove( ($sc->{mfi_bioq}),  &bp);  &MFIQ_REMOVE($sc,  &MFIQ_BIO); } ( &bp); });
    }' unless defined(&mfi_dequeue_bio);
    eval 'sub mfi_print_sense {
        my($sc,$sense) = @_;
	    eval q({ \'int\'  &error,  &key,  &asc,  &ascq;  &mfi_extract_sense($sense,  &error,  &key,  &asc,  &ascq);  &device_printf( ($sc->{mfi_dev}), \\"sense error %d, sense_key %d, \\" \\"asc %d, ascq %d\\\\n\\",  &error,  &key,  &asc,  &ascq); });
    }' unless defined(&mfi_print_sense);
    eval 'sub MFI_WRITE4 {
        my($sc, $reg, $val) = @_;
	    eval q( &bus_space_write_4(($sc)-> &mfi_btag,  ($sc->{mfi_bhandle}), ($reg), ($val)));
    }' unless defined(&MFI_WRITE4);
    eval 'sub MFI_READ4 {
        my($sc, $reg) = @_;
	    eval q( &bus_space_read_4(($sc)-> &mfi_btag, ($sc)-> &mfi_bhandle, ($reg)));
    }' unless defined(&MFI_READ4);
    eval 'sub MFI_WRITE2 {
        my($sc, $reg, $val) = @_;
	    eval q( &bus_space_write_2(($sc)-> &mfi_btag,  ($sc->{mfi_bhandle}), ($reg), ($val)));
    }' unless defined(&MFI_WRITE2);
    eval 'sub MFI_READ2 {
        my($sc, $reg) = @_;
	    eval q( &bus_space_read_2(($sc)-> &mfi_btag, ($sc)-> &mfi_bhandle, ($reg)));
    }' unless defined(&MFI_READ2);
    eval 'sub MFI_WRITE1 {
        my($sc, $reg, $val) = @_;
	    eval q( &bus_space_write_1(($sc)-> &mfi_btag,  ($sc->{mfi_bhandle}), ($reg), ($val)));
    }' unless defined(&MFI_WRITE1);
    eval 'sub MFI_READ1 {
        my($sc, $reg) = @_;
	    eval q( &bus_space_read_1(($sc)-> &mfi_btag, ($sc)-> &mfi_bhandle, ($reg)));
    }' unless defined(&MFI_READ1);
    eval 'sub MFI_RESET_WAIT_TIME () {180;}' unless defined(&MFI_RESET_WAIT_TIME);
    eval 'sub MFI_CMD_TIMEOUT () {30;}' unless defined(&MFI_CMD_TIMEOUT);
    eval 'sub MFI_SYS_PD_IO () {0;}' unless defined(&MFI_SYS_PD_IO);
    eval 'sub MFI_LD_IO () {1;}' unless defined(&MFI_LD_IO);
    eval 'sub MFI_SKINNY_MEMORY () {0x2000000;}' unless defined(&MFI_SKINNY_MEMORY);
    eval 'sub MFI_MAXPHYS () {(128* 1024);}' unless defined(&MFI_MAXPHYS);
    if(defined(&MFI_DEBUG)) {
	eval 'sub MFI_PRINT_CMD {
	    my($cm) = @_;
    	    eval q( &mfi_print_cmd($cm));
	}' unless defined(&MFI_PRINT_CMD);
	eval 'sub MFI_DUMP_CMDS {
	    my($sc) = @_;
    	    eval q( &mfi_dump_cmds($sc));
	}' unless defined(&MFI_DUMP_CMDS);
	eval 'sub MFI_VALIDATE_CMD {
	    my($sc, $cm) = @_;
    	    eval q( &mfi_validate_sg($sc, $cm,  &__FUNCTION__,  &__LINE__));
	}' unless defined(&MFI_VALIDATE_CMD);
    } else {
	eval 'sub MFI_PRINT_CMD {
	    my($cm) = @_;
    	    eval q();
	}' unless defined(&MFI_PRINT_CMD);
	eval 'sub MFI_DUMP_CMDS {
	    my($sc) = @_;
    	    eval q();
	}' unless defined(&MFI_DUMP_CMDS);
	eval 'sub MFI_VALIDATE_CMD {
	    my($sc, $cm) = @_;
    	    eval q();
	}' unless defined(&MFI_VALIDATE_CMD);
    }
}
1;
