require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&DEV_MMC_MMCREG_H)) {
    eval 'sub DEV_MMC_MMCREG_H () {1;}' unless defined(&DEV_MMC_MMCREG_H);
    eval 'sub MMC_RSP_PRESENT () {(1 << 0);}' unless defined(&MMC_RSP_PRESENT);
    eval 'sub MMC_RSP_136 () {(1 << 1);}' unless defined(&MMC_RSP_136);
    eval 'sub MMC_RSP_CRC () {(1 << 2);}' unless defined(&MMC_RSP_CRC);
    eval 'sub MMC_RSP_BUSY () {(1 << 3);}' unless defined(&MMC_RSP_BUSY);
    eval 'sub MMC_RSP_OPCODE () {(1 << 4);}' unless defined(&MMC_RSP_OPCODE);
    eval 'sub MMC_RSP_MASK () {0x1f;}' unless defined(&MMC_RSP_MASK);
    eval 'sub MMC_CMD_AC () {(0 << 5);}' unless defined(&MMC_CMD_AC);
    eval 'sub MMC_CMD_ADTC () {(1 << 5);}' unless defined(&MMC_CMD_ADTC);
    eval 'sub MMC_CMD_BC () {(2 << 5);}' unless defined(&MMC_CMD_BC);
    eval 'sub MMC_CMD_BCR () {(3 << 5);}' unless defined(&MMC_CMD_BCR);
    eval 'sub MMC_CMD_MASK () {(3 << 5);}' unless defined(&MMC_CMD_MASK);
    eval 'sub MMC_RSP_NONE () {(0);}' unless defined(&MMC_RSP_NONE);
    eval 'sub MMC_RSP_R1 () {( &MMC_RSP_PRESENT |  &MMC_RSP_CRC |  &MMC_RSP_OPCODE);}' unless defined(&MMC_RSP_R1);
    eval 'sub MMC_RSP_R1B () {( &MMC_RSP_PRESENT |  &MMC_RSP_CRC |  &MMC_RSP_OPCODE |  &MMC_RSP_BUSY);}' unless defined(&MMC_RSP_R1B);
    eval 'sub MMC_RSP_R2 () {( &MMC_RSP_PRESENT |  &MMC_RSP_136 |  &MMC_RSP_CRC);}' unless defined(&MMC_RSP_R2);
    eval 'sub MMC_RSP_R3 () {( &MMC_RSP_PRESENT);}' unless defined(&MMC_RSP_R3);
    eval 'sub MMC_RSP_R4 () {( &MMC_RSP_PRESENT);}' unless defined(&MMC_RSP_R4);
    eval 'sub MMC_RSP_R5 () {( &MMC_RSP_PRESENT |  &MMC_RSP_CRC |  &MMC_RSP_OPCODE);}' unless defined(&MMC_RSP_R5);
    eval 'sub MMC_RSP_R5B () {( &MMC_RSP_PRESENT |  &MMC_RSP_CRC |  &MMC_RSP_OPCODE |  &MMC_RSP_BUSY);}' unless defined(&MMC_RSP_R5B);
    eval 'sub MMC_RSP_R6 () {( &MMC_RSP_PRESENT |  &MMC_RSP_CRC |  &MMC_RSP_OPCODE);}' unless defined(&MMC_RSP_R6);
    eval 'sub MMC_RSP_R7 () {( &MMC_RSP_PRESENT |  &MMC_RSP_CRC |  &MMC_RSP_OPCODE);}' unless defined(&MMC_RSP_R7);
    eval 'sub MMC_RSP {
        my($x) = @_;
	    eval q((($x) &  &MMC_RSP_MASK));
    }' unless defined(&MMC_RSP);
    eval 'sub MMC_ERR_NONE () {0;}' unless defined(&MMC_ERR_NONE);
    eval 'sub MMC_ERR_TIMEOUT () {1;}' unless defined(&MMC_ERR_TIMEOUT);
    eval 'sub MMC_ERR_BADCRC () {2;}' unless defined(&MMC_ERR_BADCRC);
    eval 'sub MMC_ERR_FIFO () {3;}' unless defined(&MMC_ERR_FIFO);
    eval 'sub MMC_ERR_FAILED () {4;}' unless defined(&MMC_ERR_FAILED);
    eval 'sub MMC_ERR_INVALID () {5;}' unless defined(&MMC_ERR_INVALID);
    eval 'sub MMC_ERR_NO_MEMORY () {6;}' unless defined(&MMC_ERR_NO_MEMORY);
    eval 'sub MMC_ERR_MAX () {6;}' unless defined(&MMC_ERR_MAX);
    eval 'sub R1_OUT_OF_RANGE () {(1 << 31);}' unless defined(&R1_OUT_OF_RANGE);
    eval 'sub R1_ADDRESS_ERROR () {(1 << 30);}' unless defined(&R1_ADDRESS_ERROR);
    eval 'sub R1_BLOCK_LEN_ERROR () {(1 << 29);}' unless defined(&R1_BLOCK_LEN_ERROR);
    eval 'sub R1_ERASE_SEQ_ERROR () {(1 << 28);}' unless defined(&R1_ERASE_SEQ_ERROR);
    eval 'sub R1_ERASE_PARAM () {(1 << 27);}' unless defined(&R1_ERASE_PARAM);
    eval 'sub R1_WP_VIOLATION () {(1 << 26);}' unless defined(&R1_WP_VIOLATION);
    eval 'sub R1_CARD_IS_LOCKED () {(1 << 25);}' unless defined(&R1_CARD_IS_LOCKED);
    eval 'sub R1_LOCK_UNLOCK_FAILED () {(1 << 24);}' unless defined(&R1_LOCK_UNLOCK_FAILED);
    eval 'sub R1_COM_CRC_ERROR () {(1 << 23);}' unless defined(&R1_COM_CRC_ERROR);
    eval 'sub R1_ILLEGAL_COMMAND () {(1 << 22);}' unless defined(&R1_ILLEGAL_COMMAND);
    eval 'sub R1_CARD_ECC_FAILED () {(1 << 21);}' unless defined(&R1_CARD_ECC_FAILED);
    eval 'sub R1_CC_ERROR () {(1 << 20);}' unless defined(&R1_CC_ERROR);
    eval 'sub R1_ERROR () {(1 << 19);}' unless defined(&R1_ERROR);
    eval 'sub R1_CSD_OVERWRITE () {(1 << 16);}' unless defined(&R1_CSD_OVERWRITE);
    eval 'sub R1_WP_ERASE_SKIP () {(1 << 15);}' unless defined(&R1_WP_ERASE_SKIP);
    eval 'sub R1_CARD_ECC_DISABLED () {(1 << 14);}' unless defined(&R1_CARD_ECC_DISABLED);
    eval 'sub R1_ERASE_RESET () {(1 << 13);}' unless defined(&R1_ERASE_RESET);
    eval 'sub R1_CURRENT_STATE_MASK () {(0xf << 9);}' unless defined(&R1_CURRENT_STATE_MASK);
    eval 'sub R1_READY_FOR_DATA () {(1 << 8);}' unless defined(&R1_READY_FOR_DATA);
    eval 'sub R1_SWITCH_ERROR () {(1 << 7);}' unless defined(&R1_SWITCH_ERROR);
    eval 'sub R1_APP_CMD () {(1 << 5);}' unless defined(&R1_APP_CMD);
    eval 'sub R1_AKE_SEQ_ERROR () {(1 << 3);}' unless defined(&R1_AKE_SEQ_ERROR);
    eval 'sub R1_STATUS {
        my($x) = @_;
	    eval q((($x) & 0xffffe000));
    }' unless defined(&R1_STATUS);
    eval 'sub R1_CURRENT_STATE {
        my($x) = @_;
	    eval q(((($x) &  &R1_CURRENT_STATE_MASK) >> 9));
    }' unless defined(&R1_CURRENT_STATE);
    eval 'sub R1_STATE_IDLE () {0;}' unless defined(&R1_STATE_IDLE);
    eval 'sub R1_STATE_READY () {1;}' unless defined(&R1_STATE_READY);
    eval 'sub R1_STATE_IDENT () {2;}' unless defined(&R1_STATE_IDENT);
    eval 'sub R1_STATE_STBY () {3;}' unless defined(&R1_STATE_STBY);
    eval 'sub R1_STATE_TRAN () {4;}' unless defined(&R1_STATE_TRAN);
    eval 'sub R1_STATE_DATA () {5;}' unless defined(&R1_STATE_DATA);
    eval 'sub R1_STATE_RCV () {6;}' unless defined(&R1_STATE_RCV);
    eval 'sub R1_STATE_PRG () {7;}' unless defined(&R1_STATE_PRG);
    eval 'sub R1_STATE_DIS () {8;}' unless defined(&R1_STATE_DIS);
    eval 'sub MMC_DATA_WRITE () {(1 << 0);}' unless defined(&MMC_DATA_WRITE);
    eval 'sub MMC_DATA_READ () {(1 << 1);}' unless defined(&MMC_DATA_READ);
    eval 'sub MMC_DATA_STREAM () {(1 << 2);}' unless defined(&MMC_DATA_STREAM);
    eval 'sub MMC_DATA_MULTI () {(1 << 3);}' unless defined(&MMC_DATA_MULTI);
    eval 'sub MMC_REQ_DONE () {1;}' unless defined(&MMC_REQ_DONE);
    eval 'sub MMC_TUNE_DONE () {2;}' unless defined(&MMC_TUNE_DONE);
    eval 'sub MMC_GO_IDLE_STATE () {0;}' unless defined(&MMC_GO_IDLE_STATE);
    eval 'sub MMC_SEND_OP_COND () {1;}' unless defined(&MMC_SEND_OP_COND);
    eval 'sub MMC_ALL_SEND_CID () {2;}' unless defined(&MMC_ALL_SEND_CID);
    eval 'sub MMC_SET_RELATIVE_ADDR () {3;}' unless defined(&MMC_SET_RELATIVE_ADDR);
    eval 'sub SD_SEND_RELATIVE_ADDR () {3;}' unless defined(&SD_SEND_RELATIVE_ADDR);
    eval 'sub MMC_SET_DSR () {4;}' unless defined(&MMC_SET_DSR);
    eval 'sub MMC_SLEEP_AWAKE () {5;}' unless defined(&MMC_SLEEP_AWAKE);
    eval 'sub MMC_SWITCH_FUNC () {6;}' unless defined(&MMC_SWITCH_FUNC);
    eval 'sub MMC_SWITCH_FUNC_CMDS () {0;}' unless defined(&MMC_SWITCH_FUNC_CMDS);
    eval 'sub MMC_SWITCH_FUNC_SET () {1;}' unless defined(&MMC_SWITCH_FUNC_SET);
    eval 'sub MMC_SWITCH_FUNC_CLR () {2;}' unless defined(&MMC_SWITCH_FUNC_CLR);
    eval 'sub MMC_SWITCH_FUNC_WR () {3;}' unless defined(&MMC_SWITCH_FUNC_WR);
    eval 'sub MMC_SELECT_CARD () {7;}' unless defined(&MMC_SELECT_CARD);
    eval 'sub MMC_DESELECT_CARD () {7;}' unless defined(&MMC_DESELECT_CARD);
    eval 'sub MMC_SEND_EXT_CSD () {8;}' unless defined(&MMC_SEND_EXT_CSD);
    eval 'sub SD_SEND_IF_COND () {8;}' unless defined(&SD_SEND_IF_COND);
    eval 'sub MMC_SEND_CSD () {9;}' unless defined(&MMC_SEND_CSD);
    eval 'sub MMC_SEND_CID () {10;}' unless defined(&MMC_SEND_CID);
    eval 'sub MMC_READ_DAT_UNTIL_STOP () {11;}' unless defined(&MMC_READ_DAT_UNTIL_STOP);
    eval 'sub MMC_STOP_TRANSMISSION () {12;}' unless defined(&MMC_STOP_TRANSMISSION);
    eval 'sub MMC_SEND_STATUS () {13;}' unless defined(&MMC_SEND_STATUS);
    eval 'sub MMC_BUSTEST_R () {14;}' unless defined(&MMC_BUSTEST_R);
    eval 'sub MMC_GO_INACTIVE_STATE () {15;}' unless defined(&MMC_GO_INACTIVE_STATE);
    eval 'sub MMC_BUSTEST_W () {19;}' unless defined(&MMC_BUSTEST_W);
    eval 'sub MMC_SET_BLOCKLEN () {16;}' unless defined(&MMC_SET_BLOCKLEN);
    eval 'sub MMC_READ_SINGLE_BLOCK () {17;}' unless defined(&MMC_READ_SINGLE_BLOCK);
    eval 'sub MMC_READ_MULTIPLE_BLOCK () {18;}' unless defined(&MMC_READ_MULTIPLE_BLOCK);
    eval 'sub MMC_SEND_TUNING_BLOCK () {19;}' unless defined(&MMC_SEND_TUNING_BLOCK);
    eval 'sub MMC_SEND_TUNING_BLOCK_HS200 () {21;}' unless defined(&MMC_SEND_TUNING_BLOCK_HS200);
    eval 'sub MMC_WRITE_DAT_UNTIL_STOP () {20;}' unless defined(&MMC_WRITE_DAT_UNTIL_STOP);
    eval 'sub MMC_SET_BLOCK_COUNT () {23;}' unless defined(&MMC_SET_BLOCK_COUNT);
    eval 'sub MMC_WRITE_BLOCK () {24;}' unless defined(&MMC_WRITE_BLOCK);
    eval 'sub MMC_WRITE_MULTIPLE_BLOCK () {25;}' unless defined(&MMC_WRITE_MULTIPLE_BLOCK);
    eval 'sub MMC_PROGARM_CID () {26;}' unless defined(&MMC_PROGARM_CID);
    eval 'sub MMC_PROGRAM_CSD () {27;}' unless defined(&MMC_PROGRAM_CSD);
    eval 'sub MMC_SET_WRITE_PROT () {28;}' unless defined(&MMC_SET_WRITE_PROT);
    eval 'sub MMC_CLR_WRITE_PROT () {29;}' unless defined(&MMC_CLR_WRITE_PROT);
    eval 'sub MMC_SEND_WRITE_PROT () {30;}' unless defined(&MMC_SEND_WRITE_PROT);
    eval 'sub SD_ERASE_WR_BLK_START () {32;}' unless defined(&SD_ERASE_WR_BLK_START);
    eval 'sub SD_ERASE_WR_BLK_END () {33;}' unless defined(&SD_ERASE_WR_BLK_END);
    eval 'sub MMC_ERASE_GROUP_START () {35;}' unless defined(&MMC_ERASE_GROUP_START);
    eval 'sub MMC_ERASE_GROUP_END () {36;}' unless defined(&MMC_ERASE_GROUP_END);
    eval 'sub MMC_ERASE () {38;}' unless defined(&MMC_ERASE);
    eval 'sub MMC_ERASE_ERASE () {0x;}' unless defined(&MMC_ERASE_ERASE);
    eval 'sub MMC_ERASE_TRIM () {0x1;}' unless defined(&MMC_ERASE_TRIM);
    eval 'sub MMC_ERASE_FULE () {0x2;}' unless defined(&MMC_ERASE_FULE);
    eval 'sub MMC_ERASE_DISCARD () {0x3;}' unless defined(&MMC_ERASE_DISCARD);
    eval 'sub MMC_ERASE_SECURE_ERASE () {0x80000000;}' unless defined(&MMC_ERASE_SECURE_ERASE);
    eval 'sub MMC_ERASE_SECURE_TRIM1 () {0x80000001;}' unless defined(&MMC_ERASE_SECURE_TRIM1);
    eval 'sub MMC_ERASE_SECURE_TRIM2 () {0x80008000;}' unless defined(&MMC_ERASE_SECURE_TRIM2);
    eval 'sub MMC_FAST_IO () {39;}' unless defined(&MMC_FAST_IO);
    eval 'sub MMC_GO_IRQ_STATE () {40;}' unless defined(&MMC_GO_IRQ_STATE);
    eval 'sub MMC_LOCK_UNLOCK () {42;}' unless defined(&MMC_LOCK_UNLOCK);
    eval 'sub MMC_APP_CMD () {55;}' unless defined(&MMC_APP_CMD);
    eval 'sub MMC_GEN_CMD () {56;}' unless defined(&MMC_GEN_CMD);
    eval 'sub SD_IO_RW_DIRECT () {52;}' unless defined(&SD_IO_RW_DIRECT);
    eval 'sub SD_IO_RW_EXTENDED () {53;}' unless defined(&SD_IO_RW_EXTENDED);
    eval 'sub SD_SWITCH_FUNC () {6;}' unless defined(&SD_SWITCH_FUNC);
    eval 'sub ACMD_SET_BUS_WIDTH () {6;}' unless defined(&ACMD_SET_BUS_WIDTH);
    eval 'sub ACMD_SD_STATUS () {13;}' unless defined(&ACMD_SD_STATUS);
    eval 'sub ACMD_SEND_NUM_WR_BLOCKS () {22;}' unless defined(&ACMD_SEND_NUM_WR_BLOCKS);
    eval 'sub ACMD_SET_WR_BLK_ERASE_COUNT () {23;}' unless defined(&ACMD_SET_WR_BLK_ERASE_COUNT);
    eval 'sub ACMD_SD_SEND_OP_COND () {41;}' unless defined(&ACMD_SD_SEND_OP_COND);
    eval 'sub ACMD_SET_CLR_CARD_DETECT () {42;}' unless defined(&ACMD_SET_CLR_CARD_DETECT);
    eval 'sub ACMD_SEND_SCR () {51;}' unless defined(&ACMD_SEND_SCR);
    eval 'sub EXT_CSD_EXT_PART_ATTR () {52;}' unless defined(&EXT_CSD_EXT_PART_ATTR);
    eval 'sub EXT_CSD_ENH_START_ADDR () {136;}' unless defined(&EXT_CSD_ENH_START_ADDR);
    eval 'sub EXT_CSD_ENH_SIZE_MULT () {140;}' unless defined(&EXT_CSD_ENH_SIZE_MULT);
    eval 'sub EXT_CSD_GP_SIZE_MULT () {143;}' unless defined(&EXT_CSD_GP_SIZE_MULT);
    eval 'sub EXT_CSD_PART_SET () {155;}' unless defined(&EXT_CSD_PART_SET);
    eval 'sub EXT_CSD_PART_ATTR () {156;}' unless defined(&EXT_CSD_PART_ATTR);
    eval 'sub EXT_CSD_PART_SUPPORT () {160;}' unless defined(&EXT_CSD_PART_SUPPORT);
    eval 'sub EXT_CSD_RPMB_MULT () {168;}' unless defined(&EXT_CSD_RPMB_MULT);
    eval 'sub EXT_CSD_BOOT_WP_STATUS () {174;}' unless defined(&EXT_CSD_BOOT_WP_STATUS);
    eval 'sub EXT_CSD_ERASE_GRP_DEF () {175;}' unless defined(&EXT_CSD_ERASE_GRP_DEF);
    eval 'sub EXT_CSD_PART_CONFIG () {179;}' unless defined(&EXT_CSD_PART_CONFIG);
    eval 'sub EXT_CSD_BUS_WIDTH () {183;}' unless defined(&EXT_CSD_BUS_WIDTH);
    eval 'sub EXT_CSD_STROBE_SUPPORT () {184;}' unless defined(&EXT_CSD_STROBE_SUPPORT);
    eval 'sub EXT_CSD_HS_TIMING () {185;}' unless defined(&EXT_CSD_HS_TIMING);
    eval 'sub EXT_CSD_POWER_CLASS () {187;}' unless defined(&EXT_CSD_POWER_CLASS);
    eval 'sub EXT_CSD_CARD_TYPE () {196;}' unless defined(&EXT_CSD_CARD_TYPE);
    eval 'sub EXT_CSD_DRIVER_STRENGTH () {197;}' unless defined(&EXT_CSD_DRIVER_STRENGTH);
    eval 'sub EXT_CSD_REV () {192;}' unless defined(&EXT_CSD_REV);
    eval 'sub EXT_CSD_PART_SWITCH_TO () {199;}' unless defined(&EXT_CSD_PART_SWITCH_TO);
    eval 'sub EXT_CSD_PWR_CL_52_195 () {200;}' unless defined(&EXT_CSD_PWR_CL_52_195);
    eval 'sub EXT_CSD_PWR_CL_26_195 () {201;}' unless defined(&EXT_CSD_PWR_CL_26_195);
    eval 'sub EXT_CSD_PWR_CL_52_360 () {202;}' unless defined(&EXT_CSD_PWR_CL_52_360);
    eval 'sub EXT_CSD_PWR_CL_26_360 () {203;}' unless defined(&EXT_CSD_PWR_CL_26_360);
    eval 'sub EXT_CSD_SEC_CNT () {212;}' unless defined(&EXT_CSD_SEC_CNT);
    eval 'sub EXT_CSD_HC_WP_GRP_SIZE () {221;}' unless defined(&EXT_CSD_HC_WP_GRP_SIZE);
    eval 'sub EXT_CSD_ERASE_TO_MULT () {223;}' unless defined(&EXT_CSD_ERASE_TO_MULT);
    eval 'sub EXT_CSD_ERASE_GRP_SIZE () {224;}' unless defined(&EXT_CSD_ERASE_GRP_SIZE);
    eval 'sub EXT_CSD_BOOT_SIZE_MULT () {226;}' unless defined(&EXT_CSD_BOOT_SIZE_MULT);
    eval 'sub EXT_CSD_SEC_FEATURE_SUPPORT () {231;}' unless defined(&EXT_CSD_SEC_FEATURE_SUPPORT);
    eval 'sub EXT_CSD_PWR_CL_200_195 () {236;}' unless defined(&EXT_CSD_PWR_CL_200_195);
    eval 'sub EXT_CSD_PWR_CL_200_360 () {237;}' unless defined(&EXT_CSD_PWR_CL_200_360);
    eval 'sub EXT_CSD_PWR_CL_52_195_DDR () {238;}' unless defined(&EXT_CSD_PWR_CL_52_195_DDR);
    eval 'sub EXT_CSD_PWR_CL_52_360_DDR () {239;}' unless defined(&EXT_CSD_PWR_CL_52_360_DDR);
    eval 'sub EXT_CSD_GEN_CMD6_TIME () {248;}' unless defined(&EXT_CSD_GEN_CMD6_TIME);
    eval 'sub EXT_CSD_PWR_CL_200_360_DDR () {253;}' unless defined(&EXT_CSD_PWR_CL_200_360_DDR);
    eval 'sub EXT_CSD_EXT_PART_ATTR_DEFAULT () {0x;}' unless defined(&EXT_CSD_EXT_PART_ATTR_DEFAULT);
    eval 'sub EXT_CSD_EXT_PART_ATTR_SYSTEMCODE () {0x1;}' unless defined(&EXT_CSD_EXT_PART_ATTR_SYSTEMCODE);
    eval 'sub EXT_CSD_EXT_PART_ATTR_NPERSISTENT () {0x2;}' unless defined(&EXT_CSD_EXT_PART_ATTR_NPERSISTENT);
    eval 'sub EXT_CSD_PART_SET_COMPLETED () {0x1;}' unless defined(&EXT_CSD_PART_SET_COMPLETED);
    eval 'sub EXT_CSD_PART_ATTR_ENH_USR () {0x1;}' unless defined(&EXT_CSD_PART_ATTR_ENH_USR);
    eval 'sub EXT_CSD_PART_ATTR_ENH_GP0 () {0x2;}' unless defined(&EXT_CSD_PART_ATTR_ENH_GP0);
    eval 'sub EXT_CSD_PART_ATTR_ENH_GP1 () {0x4;}' unless defined(&EXT_CSD_PART_ATTR_ENH_GP1);
    eval 'sub EXT_CSD_PART_ATTR_ENH_GP2 () {0x8;}' unless defined(&EXT_CSD_PART_ATTR_ENH_GP2);
    eval 'sub EXT_CSD_PART_ATTR_ENH_GP3 () {0x10;}' unless defined(&EXT_CSD_PART_ATTR_ENH_GP3);
    eval 'sub EXT_CSD_PART_ATTR_ENH_MASK () {0x1f;}' unless defined(&EXT_CSD_PART_ATTR_ENH_MASK);
    eval 'sub EXT_CSD_PART_SUPPORT_EN () {0x1;}' unless defined(&EXT_CSD_PART_SUPPORT_EN);
    eval 'sub EXT_CSD_PART_SUPPORT_ENH_ATTR_EN () {0x2;}' unless defined(&EXT_CSD_PART_SUPPORT_ENH_ATTR_EN);
    eval 'sub EXT_CSD_PART_SUPPORT_EXT_ATTR_EN () {0x4;}' unless defined(&EXT_CSD_PART_SUPPORT_EXT_ATTR_EN);
    eval 'sub EXT_CSD_BOOT_WP_STATUS_BOOT0_PWR () {0x1;}' unless defined(&EXT_CSD_BOOT_WP_STATUS_BOOT0_PWR);
    eval 'sub EXT_CSD_BOOT_WP_STATUS_BOOT0_PERM () {0x2;}' unless defined(&EXT_CSD_BOOT_WP_STATUS_BOOT0_PERM);
    eval 'sub EXT_CSD_BOOT_WP_STATUS_BOOT0_MASK () {0x3;}' unless defined(&EXT_CSD_BOOT_WP_STATUS_BOOT0_MASK);
    eval 'sub EXT_CSD_BOOT_WP_STATUS_BOOT1_PWR () {0x4;}' unless defined(&EXT_CSD_BOOT_WP_STATUS_BOOT1_PWR);
    eval 'sub EXT_CSD_BOOT_WP_STATUS_BOOT1_PERM () {0x8;}' unless defined(&EXT_CSD_BOOT_WP_STATUS_BOOT1_PERM);
    eval 'sub EXT_CSD_BOOT_WP_STATUS_BOOT1_MASK () {0xc;}' unless defined(&EXT_CSD_BOOT_WP_STATUS_BOOT1_MASK);
    eval 'sub EXT_CSD_ERASE_GRP_DEF_EN () {0x1;}' unless defined(&EXT_CSD_ERASE_GRP_DEF_EN);
    eval 'sub EXT_CSD_PART_CONFIG_ACC_DEFAULT () {0x;}' unless defined(&EXT_CSD_PART_CONFIG_ACC_DEFAULT);
    eval 'sub EXT_CSD_PART_CONFIG_ACC_BOOT0 () {0x1;}' unless defined(&EXT_CSD_PART_CONFIG_ACC_BOOT0);
    eval 'sub EXT_CSD_PART_CONFIG_ACC_BOOT1 () {0x2;}' unless defined(&EXT_CSD_PART_CONFIG_ACC_BOOT1);
    eval 'sub EXT_CSD_PART_CONFIG_ACC_RPMB () {0x3;}' unless defined(&EXT_CSD_PART_CONFIG_ACC_RPMB);
    eval 'sub EXT_CSD_PART_CONFIG_ACC_GP0 () {0x4;}' unless defined(&EXT_CSD_PART_CONFIG_ACC_GP0);
    eval 'sub EXT_CSD_PART_CONFIG_ACC_GP1 () {0x5;}' unless defined(&EXT_CSD_PART_CONFIG_ACC_GP1);
    eval 'sub EXT_CSD_PART_CONFIG_ACC_GP2 () {0x6;}' unless defined(&EXT_CSD_PART_CONFIG_ACC_GP2);
    eval 'sub EXT_CSD_PART_CONFIG_ACC_GP3 () {0x7;}' unless defined(&EXT_CSD_PART_CONFIG_ACC_GP3);
    eval 'sub EXT_CSD_PART_CONFIG_ACC_MASK () {0x7;}' unless defined(&EXT_CSD_PART_CONFIG_ACC_MASK);
    eval 'sub EXT_CSD_PART_CONFIG_BOOT0 () {0x8;}' unless defined(&EXT_CSD_PART_CONFIG_BOOT0);
    eval 'sub EXT_CSD_PART_CONFIG_BOOT1 () {0x10;}' unless defined(&EXT_CSD_PART_CONFIG_BOOT1);
    eval 'sub EXT_CSD_PART_CONFIG_BOOT_USR () {0x38;}' unless defined(&EXT_CSD_PART_CONFIG_BOOT_USR);
    eval 'sub EXT_CSD_PART_CONFIG_BOOT_MASK () {0x38;}' unless defined(&EXT_CSD_PART_CONFIG_BOOT_MASK);
    eval 'sub EXT_CSD_PART_CONFIG_BOOT_ACK () {0x40;}' unless defined(&EXT_CSD_PART_CONFIG_BOOT_ACK);
    eval 'sub EXT_CSD_CMD_SET_NORMAL () {1;}' unless defined(&EXT_CSD_CMD_SET_NORMAL);
    eval 'sub EXT_CSD_CMD_SET_SECURE () {2;}' unless defined(&EXT_CSD_CMD_SET_SECURE);
    eval 'sub EXT_CSD_CMD_SET_CPSECURE () {4;}' unless defined(&EXT_CSD_CMD_SET_CPSECURE);
    eval 'sub EXT_CSD_HS_TIMING_BC () {0;}' unless defined(&EXT_CSD_HS_TIMING_BC);
    eval 'sub EXT_CSD_HS_TIMING_HS () {1;}' unless defined(&EXT_CSD_HS_TIMING_HS);
    eval 'sub EXT_CSD_HS_TIMING_HS200 () {2;}' unless defined(&EXT_CSD_HS_TIMING_HS200);
    eval 'sub EXT_CSD_HS_TIMING_HS400 () {3;}' unless defined(&EXT_CSD_HS_TIMING_HS400);
    eval 'sub EXT_CSD_HS_TIMING_DRV_STR_SHIFT () {4;}' unless defined(&EXT_CSD_HS_TIMING_DRV_STR_SHIFT);
    eval 'sub EXT_CSD_POWER_CLASS_8BIT_MASK () {0xf0;}' unless defined(&EXT_CSD_POWER_CLASS_8BIT_MASK);
    eval 'sub EXT_CSD_POWER_CLASS_8BIT_SHIFT () {4;}' unless defined(&EXT_CSD_POWER_CLASS_8BIT_SHIFT);
    eval 'sub EXT_CSD_POWER_CLASS_4BIT_MASK () {0xf;}' unless defined(&EXT_CSD_POWER_CLASS_4BIT_MASK);
    eval 'sub EXT_CSD_POWER_CLASS_4BIT_SHIFT () {0;}' unless defined(&EXT_CSD_POWER_CLASS_4BIT_SHIFT);
    eval 'sub EXT_CSD_CARD_TYPE_HS_26 () {0x1;}' unless defined(&EXT_CSD_CARD_TYPE_HS_26);
    eval 'sub EXT_CSD_CARD_TYPE_HS_52 () {0x2;}' unless defined(&EXT_CSD_CARD_TYPE_HS_52);
    eval 'sub EXT_CSD_CARD_TYPE_DDR_52_1_8V () {0x4;}' unless defined(&EXT_CSD_CARD_TYPE_DDR_52_1_8V);
    eval 'sub EXT_CSD_CARD_TYPE_DDR_52_1_2V () {0x8;}' unless defined(&EXT_CSD_CARD_TYPE_DDR_52_1_2V);
    eval 'sub EXT_CSD_CARD_TYPE_HS200_1_8V () {0x10;}' unless defined(&EXT_CSD_CARD_TYPE_HS200_1_8V);
    eval 'sub EXT_CSD_CARD_TYPE_HS200_1_2V () {0x20;}' unless defined(&EXT_CSD_CARD_TYPE_HS200_1_2V);
    eval 'sub EXT_CSD_CARD_TYPE_HS400_1_8V () {0x40;}' unless defined(&EXT_CSD_CARD_TYPE_HS400_1_8V);
    eval 'sub EXT_CSD_CARD_TYPE_HS400_1_2V () {0x80;}' unless defined(&EXT_CSD_CARD_TYPE_HS400_1_2V);
    eval 'sub EXT_CSD_BUS_WIDTH_1 () {0;}' unless defined(&EXT_CSD_BUS_WIDTH_1);
    eval 'sub EXT_CSD_BUS_WIDTH_4 () {1;}' unless defined(&EXT_CSD_BUS_WIDTH_4);
    eval 'sub EXT_CSD_BUS_WIDTH_8 () {2;}' unless defined(&EXT_CSD_BUS_WIDTH_8);
    eval 'sub EXT_CSD_BUS_WIDTH_4_DDR () {5;}' unless defined(&EXT_CSD_BUS_WIDTH_4_DDR);
    eval 'sub EXT_CSD_BUS_WIDTH_8_DDR () {6;}' unless defined(&EXT_CSD_BUS_WIDTH_8_DDR);
    eval 'sub EXT_CSD_BUS_WIDTH_ES () {0x80;}' unless defined(&EXT_CSD_BUS_WIDTH_ES);
    eval 'sub EXT_CSD_STROBE_SUPPORT_EN () {0x1;}' unless defined(&EXT_CSD_STROBE_SUPPORT_EN);
    eval 'sub EXT_CSD_SEC_FEATURE_SUPPORT_ER_EN () {0x1;}' unless defined(&EXT_CSD_SEC_FEATURE_SUPPORT_ER_EN);
    eval 'sub EXT_CSD_SEC_FEATURE_SUPPORT_BD_BLK_EN () {0x4;}' unless defined(&EXT_CSD_SEC_FEATURE_SUPPORT_BD_BLK_EN);
    eval 'sub EXT_CSD_SEC_FEATURE_SUPPORT_GB_CL_EN () {0x10;}' unless defined(&EXT_CSD_SEC_FEATURE_SUPPORT_GB_CL_EN);
    eval 'sub EXT_CSD_SEC_FEATURE_SUPPORT_SANITIZE () {0x40;}' unless defined(&EXT_CSD_SEC_FEATURE_SUPPORT_SANITIZE);
    eval 'sub EXT_CSD_INAND_CMD38 () {113;}' unless defined(&EXT_CSD_INAND_CMD38);
    eval 'sub EXT_CSD_INAND_CMD38_ERASE () {0x;}' unless defined(&EXT_CSD_INAND_CMD38_ERASE);
    eval 'sub EXT_CSD_INAND_CMD38_TRIM () {0x1;}' unless defined(&EXT_CSD_INAND_CMD38_TRIM);
    eval 'sub EXT_CSD_INAND_CMD38_SECURE_ERASE () {0x80;}' unless defined(&EXT_CSD_INAND_CMD38_SECURE_ERASE);
    eval 'sub EXT_CSD_INAND_CMD38_SECURE_TRIM1 () {0x81;}' unless defined(&EXT_CSD_INAND_CMD38_SECURE_TRIM1);
    eval 'sub EXT_CSD_INAND_CMD38_SECURE_TRIM2 () {0x82;}' unless defined(&EXT_CSD_INAND_CMD38_SECURE_TRIM2);
    eval 'sub MMC_TYPE_HS_26_MAX () {26000000;}' unless defined(&MMC_TYPE_HS_26_MAX);
    eval 'sub MMC_TYPE_HS_52_MAX () {52000000;}' unless defined(&MMC_TYPE_HS_52_MAX);
    eval 'sub MMC_TYPE_DDR52_MAX () {52000000;}' unless defined(&MMC_TYPE_DDR52_MAX);
    eval 'sub MMC_TYPE_HS200_HS400ES_MAX () {200000000;}' unless defined(&MMC_TYPE_HS200_HS400ES_MAX);
    eval 'sub SD_BUS_WIDTH_1 () {0;}' unless defined(&SD_BUS_WIDTH_1);
    eval 'sub SD_BUS_WIDTH_4 () {2;}' unless defined(&SD_BUS_WIDTH_4);
    eval 'sub SD_SWITCH_MODE_CHECK () {0;}' unless defined(&SD_SWITCH_MODE_CHECK);
    eval 'sub SD_SWITCH_MODE_SET () {1;}' unless defined(&SD_SWITCH_MODE_SET);
    eval 'sub SD_SWITCH_GROUP1 () {0;}' unless defined(&SD_SWITCH_GROUP1);
    eval 'sub SD_SWITCH_NORMAL_MODE () {0;}' unless defined(&SD_SWITCH_NORMAL_MODE);
    eval 'sub SD_SWITCH_HS_MODE () {1;}' unless defined(&SD_SWITCH_HS_MODE);
    eval 'sub SD_SWITCH_SDR50_MODE () {2;}' unless defined(&SD_SWITCH_SDR50_MODE);
    eval 'sub SD_SWITCH_SDR104_MODE () {3;}' unless defined(&SD_SWITCH_SDR104_MODE);
    eval 'sub SD_SWITCH_DDR50 () {4;}' unless defined(&SD_SWITCH_DDR50);
    eval 'sub SD_SWITCH_NOCHANGE () {0xf;}' unless defined(&SD_SWITCH_NOCHANGE);
    eval 'sub SD_CLR_CARD_DETECT () {0;}' unless defined(&SD_CLR_CARD_DETECT);
    eval 'sub SD_SET_CARD_DETECT () {1;}' unless defined(&SD_SET_CARD_DETECT);
    eval 'sub SD_HS_MAX () {50000000;}' unless defined(&SD_HS_MAX);
    eval 'sub SD_DDR50_MAX () {50000000;}' unless defined(&SD_DDR50_MAX);
    eval 'sub SD_SDR12_MAX () {25000000;}' unless defined(&SD_SDR12_MAX);
    eval 'sub SD_SDR25_MAX () {50000000;}' unless defined(&SD_SDR25_MAX);
    eval 'sub SD_SDR50_MAX () {100000000;}' unless defined(&SD_SDR50_MAX);
    eval 'sub SD_SDR104_MAX () {208000000;}' unless defined(&SD_SDR104_MAX);
    eval 'sub SD_MMC_CARD_ID_FREQUENCY () {400000;}' unless defined(&SD_MMC_CARD_ID_FREQUENCY);
    eval 'sub MMC_OCR_VOLTAGE () {0x3fffffff;}' unless defined(&MMC_OCR_VOLTAGE);
    eval 'sub MMC_OCR_LOW_VOLTAGE () {(1 << 7);}' unless defined(&MMC_OCR_LOW_VOLTAGE);
    eval 'sub MMC_OCR_MIN_VOLTAGE_SHIFT () {7;}' unless defined(&MMC_OCR_MIN_VOLTAGE_SHIFT);
    eval 'sub MMC_OCR_200_210 () {(1 << 8);}' unless defined(&MMC_OCR_200_210);
    eval 'sub MMC_OCR_210_220 () {(1 << 9);}' unless defined(&MMC_OCR_210_220);
    eval 'sub MMC_OCR_220_230 () {(1 << 10);}' unless defined(&MMC_OCR_220_230);
    eval 'sub MMC_OCR_230_240 () {(1 << 11);}' unless defined(&MMC_OCR_230_240);
    eval 'sub MMC_OCR_240_250 () {(1 << 12);}' unless defined(&MMC_OCR_240_250);
    eval 'sub MMC_OCR_250_260 () {(1 << 13);}' unless defined(&MMC_OCR_250_260);
    eval 'sub MMC_OCR_260_270 () {(1 << 14);}' unless defined(&MMC_OCR_260_270);
    eval 'sub MMC_OCR_270_280 () {(1 << 15);}' unless defined(&MMC_OCR_270_280);
    eval 'sub MMC_OCR_280_290 () {(1 << 16);}' unless defined(&MMC_OCR_280_290);
    eval 'sub MMC_OCR_290_300 () {(1 << 17);}' unless defined(&MMC_OCR_290_300);
    eval 'sub MMC_OCR_300_310 () {(1 << 18);}' unless defined(&MMC_OCR_300_310);
    eval 'sub MMC_OCR_310_320 () {(1 << 19);}' unless defined(&MMC_OCR_310_320);
    eval 'sub MMC_OCR_320_330 () {(1 << 20);}' unless defined(&MMC_OCR_320_330);
    eval 'sub MMC_OCR_330_340 () {(1 << 21);}' unless defined(&MMC_OCR_330_340);
    eval 'sub MMC_OCR_340_350 () {(1 << 22);}' unless defined(&MMC_OCR_340_350);
    eval 'sub MMC_OCR_350_360 () {(1 << 23);}' unless defined(&MMC_OCR_350_360);
    eval 'sub MMC_OCR_MAX_VOLTAGE_SHIFT () {23;}' unless defined(&MMC_OCR_MAX_VOLTAGE_SHIFT);
    eval 'sub MMC_OCR_S18R () {(1 << 24);}' unless defined(&MMC_OCR_S18R);
    eval 'sub MMC_OCR_S18A () { &MMC_OCR_S18R;}' unless defined(&MMC_OCR_S18A);
    eval 'sub MMC_OCR_XPC () {(1 << 28);}' unless defined(&MMC_OCR_XPC);
    eval 'sub MMC_OCR_ACCESS_MODE_BYTE () {(0 << 29);}' unless defined(&MMC_OCR_ACCESS_MODE_BYTE);
    eval 'sub MMC_OCR_ACCESS_MODE_SECT () {(1 << 29);}' unless defined(&MMC_OCR_ACCESS_MODE_SECT);
    eval 'sub MMC_OCR_ACCESS_MODE_MASK () {(3 << 29);}' unless defined(&MMC_OCR_ACCESS_MODE_MASK);
    eval 'sub MMC_OCR_CCS () {(1 << 30);}' unless defined(&MMC_OCR_CCS);
    eval 'sub MMC_OCR_CARD_BUSY () {(1 << 31);}' unless defined(&MMC_OCR_CARD_BUSY);
    eval 'sub SD_SCR_BUS_WIDTH_1 () {(1<< 0);}' unless defined(&SD_SCR_BUS_WIDTH_1);
    eval 'sub SD_SCR_BUS_WIDTH_4 () {(1<< 2);}' unless defined(&SD_SCR_BUS_WIDTH_4);
    eval 'sub MMC_QUIRK_MID_ANY () {(( &uint32_t)-1);}' unless defined(&MMC_QUIRK_MID_ANY);
    eval 'sub MMC_QUIRK_OID_ANY () {(( &uint16_t)-1);}' unless defined(&MMC_QUIRK_OID_ANY);
    eval 'sub MMC_QUIRK_INAND_CMD38 () {0x1;}' unless defined(&MMC_QUIRK_INAND_CMD38);
    eval 'sub MMC_QUIRK_BROKEN_TRIM () {0x2;}' unless defined(&MMC_QUIRK_BROKEN_TRIM);
    eval 'sub MMC_QUIRKS_FMT () {"\\020" "\\001INAND_CMD38" "\\002BROKEN_TRIM";}' unless defined(&MMC_QUIRKS_FMT);
    eval 'sub MMC_BOOT_RPMB_BLOCK_SIZE () {(128* 1024);}' unless defined(&MMC_BOOT_RPMB_BLOCK_SIZE);
    eval 'sub MMC_EXTCSD_SIZE () {512;}' unless defined(&MMC_EXTCSD_SIZE);
    eval 'sub MMC_PART_GP_MAX () {4;}' unless defined(&MMC_PART_GP_MAX);
    eval 'sub MMC_PART_MAX () {8;}' unless defined(&MMC_PART_MAX);
    eval 'sub MMC_TUNING_MAX () {64;}' unless defined(&MMC_TUNING_MAX);
    eval 'sub MMC_TUNING_LEN () {64;}' unless defined(&MMC_TUNING_LEN);
    eval 'sub MMC_TUNING_LEN_HS200 () {128;}' unless defined(&MMC_TUNING_LEN_HS200);
    eval 'sub MMC_SECTOR_SIZE () {512;}' unless defined(&MMC_SECTOR_SIZE);
}
1;
