require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MPI_CNFG_H)) {
    eval 'sub MPI_CNFG_H () {1;}' unless defined(&MPI_CNFG_H);
    eval 'sub MPI_CONFIG_PAGEATTR_READ_ONLY () {(0x);}' unless defined(&MPI_CONFIG_PAGEATTR_READ_ONLY);
    eval 'sub MPI_CONFIG_PAGEATTR_CHANGEABLE () {(0x10);}' unless defined(&MPI_CONFIG_PAGEATTR_CHANGEABLE);
    eval 'sub MPI_CONFIG_PAGEATTR_PERSISTENT () {(0x20);}' unless defined(&MPI_CONFIG_PAGEATTR_PERSISTENT);
    eval 'sub MPI_CONFIG_PAGEATTR_RO_PERSISTENT () {(0x30);}' unless defined(&MPI_CONFIG_PAGEATTR_RO_PERSISTENT);
    eval 'sub MPI_CONFIG_PAGEATTR_MASK () {(0xf0);}' unless defined(&MPI_CONFIG_PAGEATTR_MASK);
    eval 'sub MPI_CONFIG_PAGETYPE_IO_UNIT () {(0x);}' unless defined(&MPI_CONFIG_PAGETYPE_IO_UNIT);
    eval 'sub MPI_CONFIG_PAGETYPE_IOC () {(0x1);}' unless defined(&MPI_CONFIG_PAGETYPE_IOC);
    eval 'sub MPI_CONFIG_PAGETYPE_BIOS () {(0x2);}' unless defined(&MPI_CONFIG_PAGETYPE_BIOS);
    eval 'sub MPI_CONFIG_PAGETYPE_SCSI_PORT () {(0x3);}' unless defined(&MPI_CONFIG_PAGETYPE_SCSI_PORT);
    eval 'sub MPI_CONFIG_PAGETYPE_SCSI_DEVICE () {(0x4);}' unless defined(&MPI_CONFIG_PAGETYPE_SCSI_DEVICE);
    eval 'sub MPI_CONFIG_PAGETYPE_FC_PORT () {(0x5);}' unless defined(&MPI_CONFIG_PAGETYPE_FC_PORT);
    eval 'sub MPI_CONFIG_PAGETYPE_FC_DEVICE () {(0x6);}' unless defined(&MPI_CONFIG_PAGETYPE_FC_DEVICE);
    eval 'sub MPI_CONFIG_PAGETYPE_LAN () {(0x7);}' unless defined(&MPI_CONFIG_PAGETYPE_LAN);
    eval 'sub MPI_CONFIG_PAGETYPE_RAID_VOLUME () {(0x8);}' unless defined(&MPI_CONFIG_PAGETYPE_RAID_VOLUME);
    eval 'sub MPI_CONFIG_PAGETYPE_MANUFACTURING () {(0x9);}' unless defined(&MPI_CONFIG_PAGETYPE_MANUFACTURING);
    eval 'sub MPI_CONFIG_PAGETYPE_RAID_PHYSDISK () {(0xa);}' unless defined(&MPI_CONFIG_PAGETYPE_RAID_PHYSDISK);
    eval 'sub MPI_CONFIG_PAGETYPE_INBAND () {(0xb);}' unless defined(&MPI_CONFIG_PAGETYPE_INBAND);
    eval 'sub MPI_CONFIG_PAGETYPE_EXTENDED () {(0xf);}' unless defined(&MPI_CONFIG_PAGETYPE_EXTENDED);
    eval 'sub MPI_CONFIG_PAGETYPE_MASK () {(0xf);}' unless defined(&MPI_CONFIG_PAGETYPE_MASK);
    eval 'sub MPI_CONFIG_TYPENUM_MASK () {(0xfff);}' unless defined(&MPI_CONFIG_TYPENUM_MASK);
    eval 'sub MPI_CONFIG_EXTPAGETYPE_SAS_IO_UNIT () {(0x10);}' unless defined(&MPI_CONFIG_EXTPAGETYPE_SAS_IO_UNIT);
    eval 'sub MPI_CONFIG_EXTPAGETYPE_SAS_EXPANDER () {(0x11);}' unless defined(&MPI_CONFIG_EXTPAGETYPE_SAS_EXPANDER);
    eval 'sub MPI_CONFIG_EXTPAGETYPE_SAS_DEVICE () {(0x12);}' unless defined(&MPI_CONFIG_EXTPAGETYPE_SAS_DEVICE);
    eval 'sub MPI_CONFIG_EXTPAGETYPE_SAS_PHY () {(0x13);}' unless defined(&MPI_CONFIG_EXTPAGETYPE_SAS_PHY);
    eval 'sub MPI_CONFIG_EXTPAGETYPE_LOG () {(0x14);}' unless defined(&MPI_CONFIG_EXTPAGETYPE_LOG);
    eval 'sub MPI_CONFIG_EXTPAGETYPE_ENCLOSURE () {(0x15);}' unless defined(&MPI_CONFIG_EXTPAGETYPE_ENCLOSURE);
    eval 'sub MPI_SCSI_PORT_PGAD_PORT_MASK () {(0xff);}' unless defined(&MPI_SCSI_PORT_PGAD_PORT_MASK);
    eval 'sub MPI_SCSI_DEVICE_FORM_MASK () {(0xf0000000);}' unless defined(&MPI_SCSI_DEVICE_FORM_MASK);
    eval 'sub MPI_SCSI_DEVICE_FORM_BUS_TID () {(0x);}' unless defined(&MPI_SCSI_DEVICE_FORM_BUS_TID);
    eval 'sub MPI_SCSI_DEVICE_TARGET_ID_MASK () {(0xff);}' unless defined(&MPI_SCSI_DEVICE_TARGET_ID_MASK);
    eval 'sub MPI_SCSI_DEVICE_TARGET_ID_SHIFT () {(0);}' unless defined(&MPI_SCSI_DEVICE_TARGET_ID_SHIFT);
    eval 'sub MPI_SCSI_DEVICE_BUS_MASK () {(0xff00);}' unless defined(&MPI_SCSI_DEVICE_BUS_MASK);
    eval 'sub MPI_SCSI_DEVICE_BUS_SHIFT () {(8);}' unless defined(&MPI_SCSI_DEVICE_BUS_SHIFT);
    eval 'sub MPI_SCSI_DEVICE_FORM_TARGET_MODE () {(0x10000000);}' unless defined(&MPI_SCSI_DEVICE_FORM_TARGET_MODE);
    eval 'sub MPI_SCSI_DEVICE_TM_RESPOND_ID_MASK () {(0xff);}' unless defined(&MPI_SCSI_DEVICE_TM_RESPOND_ID_MASK);
    eval 'sub MPI_SCSI_DEVICE_TM_RESPOND_ID_SHIFT () {(0);}' unless defined(&MPI_SCSI_DEVICE_TM_RESPOND_ID_SHIFT);
    eval 'sub MPI_SCSI_DEVICE_TM_BUS_MASK () {(0xff00);}' unless defined(&MPI_SCSI_DEVICE_TM_BUS_MASK);
    eval 'sub MPI_SCSI_DEVICE_TM_BUS_SHIFT () {(8);}' unless defined(&MPI_SCSI_DEVICE_TM_BUS_SHIFT);
    eval 'sub MPI_SCSI_DEVICE_TM_INIT_ID_MASK () {(0xff0000);}' unless defined(&MPI_SCSI_DEVICE_TM_INIT_ID_MASK);
    eval 'sub MPI_SCSI_DEVICE_TM_INIT_ID_SHIFT () {(16);}' unless defined(&MPI_SCSI_DEVICE_TM_INIT_ID_SHIFT);
    eval 'sub MPI_FC_PORT_PGAD_PORT_MASK () {(0xf0000000);}' unless defined(&MPI_FC_PORT_PGAD_PORT_MASK);
    eval 'sub MPI_FC_PORT_PGAD_PORT_SHIFT () {(28);}' unless defined(&MPI_FC_PORT_PGAD_PORT_SHIFT);
    eval 'sub MPI_FC_PORT_PGAD_FORM_MASK () {(0xf000000);}' unless defined(&MPI_FC_PORT_PGAD_FORM_MASK);
    eval 'sub MPI_FC_PORT_PGAD_FORM_INDEX () {(0x1000000);}' unless defined(&MPI_FC_PORT_PGAD_FORM_INDEX);
    eval 'sub MPI_FC_PORT_PGAD_INDEX_MASK () {(0xffff);}' unless defined(&MPI_FC_PORT_PGAD_INDEX_MASK);
    eval 'sub MPI_FC_PORT_PGAD_INDEX_SHIFT () {(0);}' unless defined(&MPI_FC_PORT_PGAD_INDEX_SHIFT);
    eval 'sub MPI_FC_DEVICE_PGAD_PORT_MASK () {(0xf0000000);}' unless defined(&MPI_FC_DEVICE_PGAD_PORT_MASK);
    eval 'sub MPI_FC_DEVICE_PGAD_PORT_SHIFT () {(28);}' unless defined(&MPI_FC_DEVICE_PGAD_PORT_SHIFT);
    eval 'sub MPI_FC_DEVICE_PGAD_FORM_MASK () {(0xf000000);}' unless defined(&MPI_FC_DEVICE_PGAD_FORM_MASK);
    eval 'sub MPI_FC_DEVICE_PGAD_FORM_NEXT_DID () {(0x);}' unless defined(&MPI_FC_DEVICE_PGAD_FORM_NEXT_DID);
    eval 'sub MPI_FC_DEVICE_PGAD_ND_PORT_MASK () {(0xf0000000);}' unless defined(&MPI_FC_DEVICE_PGAD_ND_PORT_MASK);
    eval 'sub MPI_FC_DEVICE_PGAD_ND_PORT_SHIFT () {(28);}' unless defined(&MPI_FC_DEVICE_PGAD_ND_PORT_SHIFT);
    eval 'sub MPI_FC_DEVICE_PGAD_ND_DID_MASK () {(0xffffff);}' unless defined(&MPI_FC_DEVICE_PGAD_ND_DID_MASK);
    eval 'sub MPI_FC_DEVICE_PGAD_ND_DID_SHIFT () {(0);}' unless defined(&MPI_FC_DEVICE_PGAD_ND_DID_SHIFT);
    eval 'sub MPI_FC_DEVICE_PGAD_FORM_BUS_TID () {(0x1000000);}' unless defined(&MPI_FC_DEVICE_PGAD_FORM_BUS_TID);
    eval 'sub MPI_FC_DEVICE_PGAD_BT_BUS_MASK () {(0xff00);}' unless defined(&MPI_FC_DEVICE_PGAD_BT_BUS_MASK);
    eval 'sub MPI_FC_DEVICE_PGAD_BT_BUS_SHIFT () {(8);}' unless defined(&MPI_FC_DEVICE_PGAD_BT_BUS_SHIFT);
    eval 'sub MPI_FC_DEVICE_PGAD_BT_TID_MASK () {(0xff);}' unless defined(&MPI_FC_DEVICE_PGAD_BT_TID_MASK);
    eval 'sub MPI_FC_DEVICE_PGAD_BT_TID_SHIFT () {(0);}' unless defined(&MPI_FC_DEVICE_PGAD_BT_TID_SHIFT);
    eval 'sub MPI_PHYSDISK_PGAD_PHYSDISKNUM_MASK () {(0xff);}' unless defined(&MPI_PHYSDISK_PGAD_PHYSDISKNUM_MASK);
    eval 'sub MPI_PHYSDISK_PGAD_PHYSDISKNUM_SHIFT () {(0);}' unless defined(&MPI_PHYSDISK_PGAD_PHYSDISKNUM_SHIFT);
    eval 'sub MPI_SAS_EXPAND_PGAD_FORM_MASK () {(0xf0000000);}' unless defined(&MPI_SAS_EXPAND_PGAD_FORM_MASK);
    eval 'sub MPI_SAS_EXPAND_PGAD_FORM_SHIFT () {(28);}' unless defined(&MPI_SAS_EXPAND_PGAD_FORM_SHIFT);
    eval 'sub MPI_SAS_EXPAND_PGAD_FORM_GET_NEXT_HANDLE () {(0x);}' unless defined(&MPI_SAS_EXPAND_PGAD_FORM_GET_NEXT_HANDLE);
    eval 'sub MPI_SAS_EXPAND_PGAD_FORM_HANDLE_PHY_NUM () {(0x1);}' unless defined(&MPI_SAS_EXPAND_PGAD_FORM_HANDLE_PHY_NUM);
    eval 'sub MPI_SAS_EXPAND_PGAD_FORM_HANDLE () {(0x2);}' unless defined(&MPI_SAS_EXPAND_PGAD_FORM_HANDLE);
    eval 'sub MPI_SAS_EXPAND_PGAD_GNH_MASK_HANDLE () {(0xffff);}' unless defined(&MPI_SAS_EXPAND_PGAD_GNH_MASK_HANDLE);
    eval 'sub MPI_SAS_EXPAND_PGAD_GNH_SHIFT_HANDLE () {(0);}' unless defined(&MPI_SAS_EXPAND_PGAD_GNH_SHIFT_HANDLE);
    eval 'sub MPI_SAS_EXPAND_PGAD_HPN_MASK_PHY () {(0xff0000);}' unless defined(&MPI_SAS_EXPAND_PGAD_HPN_MASK_PHY);
    eval 'sub MPI_SAS_EXPAND_PGAD_HPN_SHIFT_PHY () {(16);}' unless defined(&MPI_SAS_EXPAND_PGAD_HPN_SHIFT_PHY);
    eval 'sub MPI_SAS_EXPAND_PGAD_HPN_MASK_HANDLE () {(0xffff);}' unless defined(&MPI_SAS_EXPAND_PGAD_HPN_MASK_HANDLE);
    eval 'sub MPI_SAS_EXPAND_PGAD_HPN_SHIFT_HANDLE () {(0);}' unless defined(&MPI_SAS_EXPAND_PGAD_HPN_SHIFT_HANDLE);
    eval 'sub MPI_SAS_EXPAND_PGAD_H_MASK_HANDLE () {(0xffff);}' unless defined(&MPI_SAS_EXPAND_PGAD_H_MASK_HANDLE);
    eval 'sub MPI_SAS_EXPAND_PGAD_H_SHIFT_HANDLE () {(0);}' unless defined(&MPI_SAS_EXPAND_PGAD_H_SHIFT_HANDLE);
    eval 'sub MPI_SAS_DEVICE_PGAD_FORM_MASK () {(0xf0000000);}' unless defined(&MPI_SAS_DEVICE_PGAD_FORM_MASK);
    eval 'sub MPI_SAS_DEVICE_PGAD_FORM_SHIFT () {(28);}' unless defined(&MPI_SAS_DEVICE_PGAD_FORM_SHIFT);
    eval 'sub MPI_SAS_DEVICE_PGAD_FORM_GET_NEXT_HANDLE () {(0x);}' unless defined(&MPI_SAS_DEVICE_PGAD_FORM_GET_NEXT_HANDLE);
    eval 'sub MPI_SAS_DEVICE_PGAD_FORM_BUS_TARGET_ID () {(0x1);}' unless defined(&MPI_SAS_DEVICE_PGAD_FORM_BUS_TARGET_ID);
    eval 'sub MPI_SAS_DEVICE_PGAD_FORM_HANDLE () {(0x2);}' unless defined(&MPI_SAS_DEVICE_PGAD_FORM_HANDLE);
    eval 'sub MPI_SAS_DEVICE_PGAD_GNH_HANDLE_MASK () {(0xffff);}' unless defined(&MPI_SAS_DEVICE_PGAD_GNH_HANDLE_MASK);
    eval 'sub MPI_SAS_DEVICE_PGAD_GNH_HANDLE_SHIFT () {(0);}' unless defined(&MPI_SAS_DEVICE_PGAD_GNH_HANDLE_SHIFT);
    eval 'sub MPI_SAS_DEVICE_PGAD_BT_BUS_MASK () {(0xff00);}' unless defined(&MPI_SAS_DEVICE_PGAD_BT_BUS_MASK);
    eval 'sub MPI_SAS_DEVICE_PGAD_BT_BUS_SHIFT () {(8);}' unless defined(&MPI_SAS_DEVICE_PGAD_BT_BUS_SHIFT);
    eval 'sub MPI_SAS_DEVICE_PGAD_BT_TID_MASK () {(0xff);}' unless defined(&MPI_SAS_DEVICE_PGAD_BT_TID_MASK);
    eval 'sub MPI_SAS_DEVICE_PGAD_BT_TID_SHIFT () {(0);}' unless defined(&MPI_SAS_DEVICE_PGAD_BT_TID_SHIFT);
    eval 'sub MPI_SAS_DEVICE_PGAD_H_HANDLE_MASK () {(0xffff);}' unless defined(&MPI_SAS_DEVICE_PGAD_H_HANDLE_MASK);
    eval 'sub MPI_SAS_DEVICE_PGAD_H_HANDLE_SHIFT () {(0);}' unless defined(&MPI_SAS_DEVICE_PGAD_H_HANDLE_SHIFT);
    eval 'sub MPI_SAS_PHY_PGAD_FORM_MASK () {(0xf0000000);}' unless defined(&MPI_SAS_PHY_PGAD_FORM_MASK);
    eval 'sub MPI_SAS_PHY_PGAD_FORM_SHIFT () {(28);}' unless defined(&MPI_SAS_PHY_PGAD_FORM_SHIFT);
    eval 'sub MPI_SAS_PHY_PGAD_FORM_PHY_NUMBER () {(0x);}' unless defined(&MPI_SAS_PHY_PGAD_FORM_PHY_NUMBER);
    eval 'sub MPI_SAS_PHY_PGAD_FORM_PHY_TBL_INDEX () {(0x1);}' unless defined(&MPI_SAS_PHY_PGAD_FORM_PHY_TBL_INDEX);
    eval 'sub MPI_SAS_PHY_PGAD_PHY_NUMBER_MASK () {(0xff);}' unless defined(&MPI_SAS_PHY_PGAD_PHY_NUMBER_MASK);
    eval 'sub MPI_SAS_PHY_PGAD_PHY_NUMBER_SHIFT () {(0);}' unless defined(&MPI_SAS_PHY_PGAD_PHY_NUMBER_SHIFT);
    eval 'sub MPI_SAS_PHY_PGAD_PHY_TBL_INDEX_MASK () {(0xffff);}' unless defined(&MPI_SAS_PHY_PGAD_PHY_TBL_INDEX_MASK);
    eval 'sub MPI_SAS_PHY_PGAD_PHY_TBL_INDEX_SHIFT () {(0);}' unless defined(&MPI_SAS_PHY_PGAD_PHY_TBL_INDEX_SHIFT);
    eval 'sub MPI_SAS_ENCLOS_PGAD_FORM_MASK () {(0xf0000000);}' unless defined(&MPI_SAS_ENCLOS_PGAD_FORM_MASK);
    eval 'sub MPI_SAS_ENCLOS_PGAD_FORM_SHIFT () {(28);}' unless defined(&MPI_SAS_ENCLOS_PGAD_FORM_SHIFT);
    eval 'sub MPI_SAS_ENCLOS_PGAD_FORM_GET_NEXT_HANDLE () {(0x);}' unless defined(&MPI_SAS_ENCLOS_PGAD_FORM_GET_NEXT_HANDLE);
    eval 'sub MPI_SAS_ENCLOS_PGAD_FORM_HANDLE () {(0x1);}' unless defined(&MPI_SAS_ENCLOS_PGAD_FORM_HANDLE);
    eval 'sub MPI_SAS_ENCLOS_PGAD_GNH_HANDLE_MASK () {(0xffff);}' unless defined(&MPI_SAS_ENCLOS_PGAD_GNH_HANDLE_MASK);
    eval 'sub MPI_SAS_ENCLOS_PGAD_GNH_HANDLE_SHIFT () {(0);}' unless defined(&MPI_SAS_ENCLOS_PGAD_GNH_HANDLE_SHIFT);
    eval 'sub MPI_SAS_ENCLOS_PGAD_H_HANDLE_MASK () {(0xffff);}' unless defined(&MPI_SAS_ENCLOS_PGAD_H_HANDLE_MASK);
    eval 'sub MPI_SAS_ENCLOS_PGAD_H_HANDLE_SHIFT () {(0);}' unless defined(&MPI_SAS_ENCLOS_PGAD_H_HANDLE_SHIFT);
    eval 'sub MPI_CONFIG_ACTION_PAGE_HEADER () {(0x);}' unless defined(&MPI_CONFIG_ACTION_PAGE_HEADER);
    eval 'sub MPI_CONFIG_ACTION_PAGE_READ_CURRENT () {(0x1);}' unless defined(&MPI_CONFIG_ACTION_PAGE_READ_CURRENT);
    eval 'sub MPI_CONFIG_ACTION_PAGE_WRITE_CURRENT () {(0x2);}' unless defined(&MPI_CONFIG_ACTION_PAGE_WRITE_CURRENT);
    eval 'sub MPI_CONFIG_ACTION_PAGE_DEFAULT () {(0x3);}' unless defined(&MPI_CONFIG_ACTION_PAGE_DEFAULT);
    eval 'sub MPI_CONFIG_ACTION_PAGE_WRITE_NVRAM () {(0x4);}' unless defined(&MPI_CONFIG_ACTION_PAGE_WRITE_NVRAM);
    eval 'sub MPI_CONFIG_ACTION_PAGE_READ_DEFAULT () {(0x5);}' unless defined(&MPI_CONFIG_ACTION_PAGE_READ_DEFAULT);
    eval 'sub MPI_CONFIG_ACTION_PAGE_READ_NVRAM () {(0x6);}' unless defined(&MPI_CONFIG_ACTION_PAGE_READ_NVRAM);
    eval 'sub MPI_MANUFACTPAGE_VENDORID_LSILOGIC () {(0x1000);}' unless defined(&MPI_MANUFACTPAGE_VENDORID_LSILOGIC);
    eval 'sub MPI_MANUFACTPAGE_DEVICEID_FC909 () {(0x621);}' unless defined(&MPI_MANUFACTPAGE_DEVICEID_FC909);
    eval 'sub MPI_MANUFACTPAGE_DEVICEID_FC919 () {(0x624);}' unless defined(&MPI_MANUFACTPAGE_DEVICEID_FC919);
    eval 'sub MPI_MANUFACTPAGE_DEVICEID_FC929 () {(0x622);}' unless defined(&MPI_MANUFACTPAGE_DEVICEID_FC929);
    eval 'sub MPI_MANUFACTPAGE_DEVICEID_FC919X () {(0x628);}' unless defined(&MPI_MANUFACTPAGE_DEVICEID_FC919X);
    eval 'sub MPI_MANUFACTPAGE_DEVICEID_FC929X () {(0x626);}' unless defined(&MPI_MANUFACTPAGE_DEVICEID_FC929X);
    eval 'sub MPI_MANUFACTPAGE_DEVICEID_FC939X () {(0x642);}' unless defined(&MPI_MANUFACTPAGE_DEVICEID_FC939X);
    eval 'sub MPI_MANUFACTPAGE_DEVICEID_FC949X () {(0x640);}' unless defined(&MPI_MANUFACTPAGE_DEVICEID_FC949X);
    eval 'sub MPI_MANUFACTPAGE_DEVICEID_FC949E () {(0x646);}' unless defined(&MPI_MANUFACTPAGE_DEVICEID_FC949E);
    eval 'sub MPI_MANUFACTPAGE_DEVID_53C1030 () {(0x30);}' unless defined(&MPI_MANUFACTPAGE_DEVID_53C1030);
    eval 'sub MPI_MANUFACTPAGE_DEVID_53C1030ZC () {(0x31);}' unless defined(&MPI_MANUFACTPAGE_DEVID_53C1030ZC);
    eval 'sub MPI_MANUFACTPAGE_DEVID_1030_53C1035 () {(0x32);}' unless defined(&MPI_MANUFACTPAGE_DEVID_1030_53C1035);
    eval 'sub MPI_MANUFACTPAGE_DEVID_1030ZC_53C1035 () {(0x33);}' unless defined(&MPI_MANUFACTPAGE_DEVID_1030ZC_53C1035);
    eval 'sub MPI_MANUFACTPAGE_DEVID_53C1035 () {(0x40);}' unless defined(&MPI_MANUFACTPAGE_DEVID_53C1035);
    eval 'sub MPI_MANUFACTPAGE_DEVID_53C1035ZC () {(0x41);}' unless defined(&MPI_MANUFACTPAGE_DEVID_53C1035ZC);
    eval 'sub MPI_MANUFACTPAGE_DEVID_SAS1064 () {(0x50);}' unless defined(&MPI_MANUFACTPAGE_DEVID_SAS1064);
    eval 'sub MPI_MANUFACTPAGE_DEVID_SAS1064A () {(0x5c);}' unless defined(&MPI_MANUFACTPAGE_DEVID_SAS1064A);
    eval 'sub MPI_MANUFACTPAGE_DEVID_SAS1064E () {(0x56);}' unless defined(&MPI_MANUFACTPAGE_DEVID_SAS1064E);
    eval 'sub MPI_MANUFACTPAGE_DEVID_SAS1066 () {(0x5e);}' unless defined(&MPI_MANUFACTPAGE_DEVID_SAS1066);
    eval 'sub MPI_MANUFACTPAGE_DEVID_SAS1066E () {(0x5a);}' unless defined(&MPI_MANUFACTPAGE_DEVID_SAS1066E);
    eval 'sub MPI_MANUFACTPAGE_DEVID_SAS1068 () {(0x54);}' unless defined(&MPI_MANUFACTPAGE_DEVID_SAS1068);
    eval 'sub MPI_MANUFACTPAGE_DEVID_SAS1068E () {(0x58);}' unless defined(&MPI_MANUFACTPAGE_DEVID_SAS1068E);
    eval 'sub MPI_MANUFACTPAGE_DEVID_SAS1078 () {(0x62);}' unless defined(&MPI_MANUFACTPAGE_DEVID_SAS1078);
    eval 'sub MPI_MANUFACTURING0_PAGEVERSION () {(0x);}' unless defined(&MPI_MANUFACTURING0_PAGEVERSION);
    eval 'sub MPI_MANUFACTURING1_PAGEVERSION () {(0x);}' unless defined(&MPI_MANUFACTURING1_PAGEVERSION);
    unless(defined(&MPI_MAN_PAGE_2_HW_SETTINGS_WORDS)) {
	eval 'sub MPI_MAN_PAGE_2_HW_SETTINGS_WORDS () {(1);}' unless defined(&MPI_MAN_PAGE_2_HW_SETTINGS_WORDS);
    }
    eval 'sub MPI_MANUFACTURING2_PAGEVERSION () {(0x);}' unless defined(&MPI_MANUFACTURING2_PAGEVERSION);
    unless(defined(&MPI_MAN_PAGE_3_INFO_WORDS)) {
	eval 'sub MPI_MAN_PAGE_3_INFO_WORDS () {(1);}' unless defined(&MPI_MAN_PAGE_3_INFO_WORDS);
    }
    eval 'sub MPI_MANUFACTURING3_PAGEVERSION () {(0x);}' unless defined(&MPI_MANUFACTURING3_PAGEVERSION);
    eval 'sub MPI_MANUFACTURING4_PAGEVERSION () {(0x5);}' unless defined(&MPI_MANUFACTURING4_PAGEVERSION);
    eval 'sub MPI_MANPAGE4_FORCE_BAD_BLOCK_TABLE () {(0x80);}' unless defined(&MPI_MANPAGE4_FORCE_BAD_BLOCK_TABLE);
    eval 'sub MPI_MANPAGE4_FORCE_OFFLINE_FAILOVER () {(0x40);}' unless defined(&MPI_MANPAGE4_FORCE_OFFLINE_FAILOVER);
    eval 'sub MPI_MANPAGE4_IME_DISABLE () {(0x20);}' unless defined(&MPI_MANPAGE4_IME_DISABLE);
    eval 'sub MPI_MANPAGE4_IM_DISABLE () {(0x10);}' unless defined(&MPI_MANPAGE4_IM_DISABLE);
    eval 'sub MPI_MANPAGE4_IS_DISABLE () {(0x8);}' unless defined(&MPI_MANPAGE4_IS_DISABLE);
    eval 'sub MPI_MANPAGE4_IR_MODEPAGE8_DISABLE () {(0x4);}' unless defined(&MPI_MANPAGE4_IR_MODEPAGE8_DISABLE);
    eval 'sub MPI_MANPAGE4_IM_RESYNC_CACHE_ENABLE () {(0x2);}' unless defined(&MPI_MANPAGE4_IM_RESYNC_CACHE_ENABLE);
    eval 'sub MPI_MANPAGE4_IR_NO_MIX_SAS_SATA () {(0x1);}' unless defined(&MPI_MANPAGE4_IR_NO_MIX_SAS_SATA);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_RAID0_SINGLE_DRIVE () {(0x400);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_RAID0_SINGLE_DRIVE);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_SSD_SCRUB_DISABLE () {(0x200);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_SSD_SCRUB_DISABLE);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_MASK_COERCION_SIZE () {(0x180);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_MASK_COERCION_SIZE);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_SHIFT_COERCION_SIZE () {(7);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_SHIFT_COERCION_SIZE);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_1GB_COERCION_SIZE () {(0);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_1GB_COERCION_SIZE);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_128MB_COERCION_SIZE () {(1);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_128MB_COERCION_SIZE);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_NO_MIX_SSD_SAS_SATA () {(0x40);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_NO_MIX_SSD_SAS_SATA);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_MIX_SSD_AND_NON_SSD () {(0x20);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_MIX_SSD_AND_NON_SSD);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_DUAL_PORT_SUPPORT () {(0x10);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_DUAL_PORT_SUPPORT);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_HIDE_NON_IR_METADATA () {(0x8);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_HIDE_NON_IR_METADATA);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_SAS_CACHE_DISABLE () {(0x4);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_SAS_CACHE_DISABLE);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_SATA_CACHE_DISABLE () {(0x2);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_SATA_CACHE_DISABLE);
    eval 'sub MPI_MANPAGE4_EXTFLAGS_LEGACY_MODE () {(0x1);}' unless defined(&MPI_MANPAGE4_EXTFLAGS_LEGACY_MODE);
    unless(defined(&MPI_MANPAGE5_NUM_FORCEWWID)) {
	eval 'sub MPI_MANPAGE5_NUM_FORCEWWID () {(1);}' unless defined(&MPI_MANPAGE5_NUM_FORCEWWID);
    }
    eval 'sub MPI_MANUFACTURING5_PAGEVERSION () {(0x2);}' unless defined(&MPI_MANUFACTURING5_PAGEVERSION);
    eval 'sub MPI_MANPAGE5_TWO_WWID_PER_PHY () {(0x1);}' unless defined(&MPI_MANPAGE5_TWO_WWID_PER_PHY);
    eval 'sub MPI_MANUFACTURING6_PAGEVERSION () {(0x);}' unless defined(&MPI_MANUFACTURING6_PAGEVERSION);
    eval 'sub MPI_MANPAGE7_PINOUT_SFF_8484_L4 () {(0x80000);}' unless defined(&MPI_MANPAGE7_PINOUT_SFF_8484_L4);
    eval 'sub MPI_MANPAGE7_PINOUT_SFF_8484_L3 () {(0x40000);}' unless defined(&MPI_MANPAGE7_PINOUT_SFF_8484_L3);
    eval 'sub MPI_MANPAGE7_PINOUT_SFF_8484_L2 () {(0x20000);}' unless defined(&MPI_MANPAGE7_PINOUT_SFF_8484_L2);
    eval 'sub MPI_MANPAGE7_PINOUT_SFF_8484_L1 () {(0x10000);}' unless defined(&MPI_MANPAGE7_PINOUT_SFF_8484_L1);
    eval 'sub MPI_MANPAGE7_PINOUT_SFF_8470_L4 () {(0x800);}' unless defined(&MPI_MANPAGE7_PINOUT_SFF_8470_L4);
    eval 'sub MPI_MANPAGE7_PINOUT_SFF_8470_L3 () {(0x400);}' unless defined(&MPI_MANPAGE7_PINOUT_SFF_8470_L3);
    eval 'sub MPI_MANPAGE7_PINOUT_SFF_8470_L2 () {(0x200);}' unless defined(&MPI_MANPAGE7_PINOUT_SFF_8470_L2);
    eval 'sub MPI_MANPAGE7_PINOUT_SFF_8470_L1 () {(0x100);}' unless defined(&MPI_MANPAGE7_PINOUT_SFF_8470_L1);
    eval 'sub MPI_MANPAGE7_PINOUT_SFF_8482 () {(0x2);}' unless defined(&MPI_MANPAGE7_PINOUT_SFF_8482);
    eval 'sub MPI_MANPAGE7_PINOUT_CONNECTION_UNKNOWN () {(0x1);}' unless defined(&MPI_MANPAGE7_PINOUT_CONNECTION_UNKNOWN);
    eval 'sub MPI_MANPAGE7_LOCATION_UNKNOWN () {(0x1);}' unless defined(&MPI_MANPAGE7_LOCATION_UNKNOWN);
    eval 'sub MPI_MANPAGE7_LOCATION_INTERNAL () {(0x2);}' unless defined(&MPI_MANPAGE7_LOCATION_INTERNAL);
    eval 'sub MPI_MANPAGE7_LOCATION_EXTERNAL () {(0x4);}' unless defined(&MPI_MANPAGE7_LOCATION_EXTERNAL);
    eval 'sub MPI_MANPAGE7_LOCATION_SWITCHABLE () {(0x8);}' unless defined(&MPI_MANPAGE7_LOCATION_SWITCHABLE);
    eval 'sub MPI_MANPAGE7_LOCATION_AUTO () {(0x10);}' unless defined(&MPI_MANPAGE7_LOCATION_AUTO);
    eval 'sub MPI_MANPAGE7_LOCATION_NOT_PRESENT () {(0x20);}' unless defined(&MPI_MANPAGE7_LOCATION_NOT_PRESENT);
    eval 'sub MPI_MANPAGE7_LOCATION_NOT_CONNECTED () {(0x80);}' unless defined(&MPI_MANPAGE7_LOCATION_NOT_CONNECTED);
    unless(defined(&MPI_MANPAGE7_CONNECTOR_INFO_MAX)) {
	eval 'sub MPI_MANPAGE7_CONNECTOR_INFO_MAX () {(1);}' unless defined(&MPI_MANPAGE7_CONNECTOR_INFO_MAX);
    }
    eval 'sub MPI_MANUFACTURING7_PAGEVERSION () {(0x);}' unless defined(&MPI_MANUFACTURING7_PAGEVERSION);
    eval 'sub MPI_MANPAGE7_FLAG_USE_SLOT_INFO () {(0x1);}' unless defined(&MPI_MANPAGE7_FLAG_USE_SLOT_INFO);
    eval 'sub MPI_MANUFACTURING8_PAGEVERSION () {(0x);}' unless defined(&MPI_MANUFACTURING8_PAGEVERSION);
    eval 'sub MPI_MANUFACTURING9_PAGEVERSION () {(0x);}' unless defined(&MPI_MANUFACTURING9_PAGEVERSION);
    eval 'sub MPI_MANUFACTURING10_PAGEVERSION () {(0x);}' unless defined(&MPI_MANUFACTURING10_PAGEVERSION);
    eval 'sub MPI_IOUNITPAGE0_PAGEVERSION () {(0x);}' unless defined(&MPI_IOUNITPAGE0_PAGEVERSION);
    eval 'sub MPI_IOUNITPAGE1_PAGEVERSION () {(0x2);}' unless defined(&MPI_IOUNITPAGE1_PAGEVERSION);
    eval 'sub MPI_IOUNITPAGE1_MULTI_FUNCTION () {(0x);}' unless defined(&MPI_IOUNITPAGE1_MULTI_FUNCTION);
    eval 'sub MPI_IOUNITPAGE1_SINGLE_FUNCTION () {(0x1);}' unless defined(&MPI_IOUNITPAGE1_SINGLE_FUNCTION);
    eval 'sub MPI_IOUNITPAGE1_MULTI_PATHING () {(0x2);}' unless defined(&MPI_IOUNITPAGE1_MULTI_PATHING);
    eval 'sub MPI_IOUNITPAGE1_SINGLE_PATHING () {(0x);}' unless defined(&MPI_IOUNITPAGE1_SINGLE_PATHING);
    eval 'sub MPI_IOUNITPAGE1_IR_USE_STATIC_VOLUME_ID () {(0x4);}' unless defined(&MPI_IOUNITPAGE1_IR_USE_STATIC_VOLUME_ID);
    eval 'sub MPI_IOUNITPAGE1_DISABLE_QUEUE_FULL_HANDLING () {(0x20);}' unless defined(&MPI_IOUNITPAGE1_DISABLE_QUEUE_FULL_HANDLING);
    eval 'sub MPI_IOUNITPAGE1_DISABLE_IR () {(0x40);}' unless defined(&MPI_IOUNITPAGE1_DISABLE_IR);
    eval 'sub MPI_IOUNITPAGE1_FORCE_32 () {(0x80);}' unless defined(&MPI_IOUNITPAGE1_FORCE_32);
    eval 'sub MPI_IOUNITPAGE1_NATIVE_COMMAND_Q_DISABLE () {(0x100);}' unless defined(&MPI_IOUNITPAGE1_NATIVE_COMMAND_Q_DISABLE);
    eval 'sub MPI_IOUNITPAGE1_SATA_WRITE_CACHE_DISABLE () {(0x200);}' unless defined(&MPI_IOUNITPAGE1_SATA_WRITE_CACHE_DISABLE);
    eval 'sub MPI_ADAPTER_INFO_FLAGS_EMBEDDED () {(0x1);}' unless defined(&MPI_ADAPTER_INFO_FLAGS_EMBEDDED);
    eval 'sub MPI_ADAPTER_INFO_FLAGS_INIT_STATUS () {(0x2);}' unless defined(&MPI_ADAPTER_INFO_FLAGS_INIT_STATUS);
    eval 'sub MPI_IOUNITPAGE2_PAGEVERSION () {(0x2);}' unless defined(&MPI_IOUNITPAGE2_PAGEVERSION);
    eval 'sub MPI_IOUNITPAGE2_FLAGS_PAUSE_ON_ERROR () {(0x2);}' unless defined(&MPI_IOUNITPAGE2_FLAGS_PAUSE_ON_ERROR);
    eval 'sub MPI_IOUNITPAGE2_FLAGS_VERBOSE_ENABLE () {(0x4);}' unless defined(&MPI_IOUNITPAGE2_FLAGS_VERBOSE_ENABLE);
    eval 'sub MPI_IOUNITPAGE2_FLAGS_COLOR_VIDEO_DISABLE () {(0x8);}' unless defined(&MPI_IOUNITPAGE2_FLAGS_COLOR_VIDEO_DISABLE);
    eval 'sub MPI_IOUNITPAGE2_FLAGS_DONT_HOOK_INT_40 () {(0x10);}' unless defined(&MPI_IOUNITPAGE2_FLAGS_DONT_HOOK_INT_40);
    eval 'sub MPI_IOUNITPAGE2_FLAGS_DEV_LIST_DISPLAY_MASK () {(0xe0);}' unless defined(&MPI_IOUNITPAGE2_FLAGS_DEV_LIST_DISPLAY_MASK);
    eval 'sub MPI_IOUNITPAGE2_FLAGS_INSTALLED_DEV_DISPLAY () {(0x);}' unless defined(&MPI_IOUNITPAGE2_FLAGS_INSTALLED_DEV_DISPLAY);
    eval 'sub MPI_IOUNITPAGE2_FLAGS_ADAPTER_DISPLAY () {(0x20);}' unless defined(&MPI_IOUNITPAGE2_FLAGS_ADAPTER_DISPLAY);
    eval 'sub MPI_IOUNITPAGE2_FLAGS_ADAPTER_DEV_DISPLAY () {(0x40);}' unless defined(&MPI_IOUNITPAGE2_FLAGS_ADAPTER_DEV_DISPLAY);
    unless(defined(&MPI_IO_UNIT_PAGE_3_GPIO_VAL_MAX)) {
	eval 'sub MPI_IO_UNIT_PAGE_3_GPIO_VAL_MAX () {(1);}' unless defined(&MPI_IO_UNIT_PAGE_3_GPIO_VAL_MAX);
    }
    eval 'sub MPI_IOUNITPAGE3_PAGEVERSION () {(0x1);}' unless defined(&MPI_IOUNITPAGE3_PAGEVERSION);
    eval 'sub MPI_IOUNITPAGE3_GPIO_FUNCTION_MASK () {(0xfc);}' unless defined(&MPI_IOUNITPAGE3_GPIO_FUNCTION_MASK);
    eval 'sub MPI_IOUNITPAGE3_GPIO_FUNCTION_SHIFT () {(2);}' unless defined(&MPI_IOUNITPAGE3_GPIO_FUNCTION_SHIFT);
    eval 'sub MPI_IOUNITPAGE3_GPIO_SETTING_OFF () {(0x);}' unless defined(&MPI_IOUNITPAGE3_GPIO_SETTING_OFF);
    eval 'sub MPI_IOUNITPAGE3_GPIO_SETTING_ON () {(0x1);}' unless defined(&MPI_IOUNITPAGE3_GPIO_SETTING_ON);
    eval 'sub MPI_IOUNITPAGE4_PAGEVERSION () {(0x);}' unless defined(&MPI_IOUNITPAGE4_PAGEVERSION);
    eval 'sub MPI_IOCPAGE0_PAGEVERSION () {(0x1);}' unless defined(&MPI_IOCPAGE0_PAGEVERSION);
    eval 'sub MPI_IOCPAGE1_PAGEVERSION () {(0x3);}' unless defined(&MPI_IOCPAGE1_PAGEVERSION);
    eval 'sub MPI_IOCPAGE1_EEDP_MODE_MASK () {(0x7000000);}' unless defined(&MPI_IOCPAGE1_EEDP_MODE_MASK);
    eval 'sub MPI_IOCPAGE1_EEDP_MODE_OFF () {(0x);}' unless defined(&MPI_IOCPAGE1_EEDP_MODE_OFF);
    eval 'sub MPI_IOCPAGE1_EEDP_MODE_T10 () {(0x1000000);}' unless defined(&MPI_IOCPAGE1_EEDP_MODE_T10);
    eval 'sub MPI_IOCPAGE1_EEDP_MODE_LSI_1 () {(0x2000000);}' unless defined(&MPI_IOCPAGE1_EEDP_MODE_LSI_1);
    eval 'sub MPI_IOCPAGE1_INITIATOR_CONTEXT_REPLY_DISABLE () {(0x10);}' unless defined(&MPI_IOCPAGE1_INITIATOR_CONTEXT_REPLY_DISABLE);
    eval 'sub MPI_IOCPAGE1_REPLY_COALESCING () {(0x1);}' unless defined(&MPI_IOCPAGE1_REPLY_COALESCING);
    eval 'sub MPI_IOCPAGE1_PCISLOTNUM_UNKNOWN () {(0xff);}' unless defined(&MPI_IOCPAGE1_PCISLOTNUM_UNKNOWN);
    eval 'sub MPI_RAID_VOL_TYPE_IS () {(0x);}' unless defined(&MPI_RAID_VOL_TYPE_IS);
    eval 'sub MPI_RAID_VOL_TYPE_IME () {(0x1);}' unless defined(&MPI_RAID_VOL_TYPE_IME);
    eval 'sub MPI_RAID_VOL_TYPE_IM () {(0x2);}' unless defined(&MPI_RAID_VOL_TYPE_IM);
    eval 'sub MPI_RAID_VOL_TYPE_RAID_5 () {(0x3);}' unless defined(&MPI_RAID_VOL_TYPE_RAID_5);
    eval 'sub MPI_RAID_VOL_TYPE_RAID_6 () {(0x4);}' unless defined(&MPI_RAID_VOL_TYPE_RAID_6);
    eval 'sub MPI_RAID_VOL_TYPE_RAID_10 () {(0x5);}' unless defined(&MPI_RAID_VOL_TYPE_RAID_10);
    eval 'sub MPI_RAID_VOL_TYPE_RAID_50 () {(0x6);}' unless defined(&MPI_RAID_VOL_TYPE_RAID_50);
    eval 'sub MPI_RAID_VOL_TYPE_UNKNOWN () {(0xff);}' unless defined(&MPI_RAID_VOL_TYPE_UNKNOWN);
    eval 'sub MPI_IOCPAGE2_FLAG_VOLUME_INACTIVE () {(0x8);}' unless defined(&MPI_IOCPAGE2_FLAG_VOLUME_INACTIVE);
    unless(defined(&MPI_IOC_PAGE_2_RAID_VOLUME_MAX)) {
	eval 'sub MPI_IOC_PAGE_2_RAID_VOLUME_MAX () {(1);}' unless defined(&MPI_IOC_PAGE_2_RAID_VOLUME_MAX);
    }
    eval 'sub MPI_IOCPAGE2_PAGEVERSION () {(0x4);}' unless defined(&MPI_IOCPAGE2_PAGEVERSION);
    eval 'sub MPI_IOCPAGE2_CAP_FLAGS_IS_SUPPORT () {(0x1);}' unless defined(&MPI_IOCPAGE2_CAP_FLAGS_IS_SUPPORT);
    eval 'sub MPI_IOCPAGE2_CAP_FLAGS_IME_SUPPORT () {(0x2);}' unless defined(&MPI_IOCPAGE2_CAP_FLAGS_IME_SUPPORT);
    eval 'sub MPI_IOCPAGE2_CAP_FLAGS_IM_SUPPORT () {(0x4);}' unless defined(&MPI_IOCPAGE2_CAP_FLAGS_IM_SUPPORT);
    eval 'sub MPI_IOCPAGE2_CAP_FLAGS_RAID_5_SUPPORT () {(0x8);}' unless defined(&MPI_IOCPAGE2_CAP_FLAGS_RAID_5_SUPPORT);
    eval 'sub MPI_IOCPAGE2_CAP_FLAGS_RAID_6_SUPPORT () {(0x10);}' unless defined(&MPI_IOCPAGE2_CAP_FLAGS_RAID_6_SUPPORT);
    eval 'sub MPI_IOCPAGE2_CAP_FLAGS_RAID_10_SUPPORT () {(0x20);}' unless defined(&MPI_IOCPAGE2_CAP_FLAGS_RAID_10_SUPPORT);
    eval 'sub MPI_IOCPAGE2_CAP_FLAGS_RAID_50_SUPPORT () {(0x40);}' unless defined(&MPI_IOCPAGE2_CAP_FLAGS_RAID_50_SUPPORT);
    eval 'sub MPI_IOCPAGE2_CAP_FLAGS_RAID_64_BIT_ADDRESSING () {(0x10000000);}' unless defined(&MPI_IOCPAGE2_CAP_FLAGS_RAID_64_BIT_ADDRESSING);
    eval 'sub MPI_IOCPAGE2_CAP_FLAGS_SES_SUPPORT () {(0x20000000);}' unless defined(&MPI_IOCPAGE2_CAP_FLAGS_SES_SUPPORT);
    eval 'sub MPI_IOCPAGE2_CAP_FLAGS_SAFTE_SUPPORT () {(0x40000000);}' unless defined(&MPI_IOCPAGE2_CAP_FLAGS_SAFTE_SUPPORT);
    eval 'sub MPI_IOCPAGE2_CAP_FLAGS_CROSS_CHANNEL_SUPPORT () {(0x80000000);}' unless defined(&MPI_IOCPAGE2_CAP_FLAGS_CROSS_CHANNEL_SUPPORT);
    unless(defined(&MPI_IOC_PAGE_3_PHYSDISK_MAX)) {
	eval 'sub MPI_IOC_PAGE_3_PHYSDISK_MAX () {(1);}' unless defined(&MPI_IOC_PAGE_3_PHYSDISK_MAX);
    }
    eval 'sub MPI_IOCPAGE3_PAGEVERSION () {(0x);}' unless defined(&MPI_IOCPAGE3_PAGEVERSION);
    unless(defined(&MPI_IOC_PAGE_4_SEP_MAX)) {
	eval 'sub MPI_IOC_PAGE_4_SEP_MAX () {(1);}' unless defined(&MPI_IOC_PAGE_4_SEP_MAX);
    }
    eval 'sub MPI_IOCPAGE4_PAGEVERSION () {(0x);}' unless defined(&MPI_IOCPAGE4_PAGEVERSION);
    eval 'sub MPI_IOC_PAGE_5_HOT_SPARE_ACTIVE () {(0x1);}' unless defined(&MPI_IOC_PAGE_5_HOT_SPARE_ACTIVE);
    unless(defined(&MPI_IOC_PAGE_5_HOT_SPARE_MAX)) {
	eval 'sub MPI_IOC_PAGE_5_HOT_SPARE_MAX () {(1);}' unless defined(&MPI_IOC_PAGE_5_HOT_SPARE_MAX);
    }
    eval 'sub MPI_IOCPAGE5_PAGEVERSION () {(0x);}' unless defined(&MPI_IOCPAGE5_PAGEVERSION);
    eval 'sub MPI_IOCPAGE6_PAGEVERSION () {(0x1);}' unless defined(&MPI_IOCPAGE6_PAGEVERSION);
    eval 'sub MPI_IOCPAGE6_CAP_FLAGS_SSD_SUPPORT () {(0x20);}' unless defined(&MPI_IOCPAGE6_CAP_FLAGS_SSD_SUPPORT);
    eval 'sub MPI_IOCPAGE6_CAP_FLAGS_MULTIPORT_DRIVE_SUPPORT () {(0x10);}' unless defined(&MPI_IOCPAGE6_CAP_FLAGS_MULTIPORT_DRIVE_SUPPORT);
    eval 'sub MPI_IOCPAGE6_CAP_FLAGS_DISABLE_SMART_POLLING () {(0x8);}' unless defined(&MPI_IOCPAGE6_CAP_FLAGS_DISABLE_SMART_POLLING);
    eval 'sub MPI_IOCPAGE6_CAP_FLAGS_MASK_METADATA_SIZE () {(0x6);}' unless defined(&MPI_IOCPAGE6_CAP_FLAGS_MASK_METADATA_SIZE);
    eval 'sub MPI_IOCPAGE6_CAP_FLAGS_64MB_METADATA_SIZE () {(0x);}' unless defined(&MPI_IOCPAGE6_CAP_FLAGS_64MB_METADATA_SIZE);
    eval 'sub MPI_IOCPAGE6_CAP_FLAGS_512MB_METADATA_SIZE () {(0x2);}' unless defined(&MPI_IOCPAGE6_CAP_FLAGS_512MB_METADATA_SIZE);
    eval 'sub MPI_IOCPAGE6_CAP_FLAGS_GLOBAL_HOT_SPARE () {(0x1);}' unless defined(&MPI_IOCPAGE6_CAP_FLAGS_GLOBAL_HOT_SPARE);
    eval 'sub MPI_BIOSPAGE1_PAGEVERSION () {(0x3);}' unless defined(&MPI_BIOSPAGE1_PAGEVERSION);
    eval 'sub MPI_BIOSPAGE1_OPTIONS_SPI_ENABLE () {(0x400);}' unless defined(&MPI_BIOSPAGE1_OPTIONS_SPI_ENABLE);
    eval 'sub MPI_BIOSPAGE1_OPTIONS_FC_ENABLE () {(0x200);}' unless defined(&MPI_BIOSPAGE1_OPTIONS_FC_ENABLE);
    eval 'sub MPI_BIOSPAGE1_OPTIONS_SAS_ENABLE () {(0x100);}' unless defined(&MPI_BIOSPAGE1_OPTIONS_SAS_ENABLE);
    eval 'sub MPI_BIOSPAGE1_OPTIONS_SCAN_HIGH_TO_LOW () {(0x2);}' unless defined(&MPI_BIOSPAGE1_OPTIONS_SCAN_HIGH_TO_LOW);
    eval 'sub MPI_BIOSPAGE1_OPTIONS_SCAN_LOW_TO_HIGH () {(0x);}' unless defined(&MPI_BIOSPAGE1_OPTIONS_SCAN_LOW_TO_HIGH);
    eval 'sub MPI_BIOSPAGE1_OPTIONS_DISABLE_BIOS () {(0x1);}' unless defined(&MPI_BIOSPAGE1_OPTIONS_DISABLE_BIOS);
    eval 'sub MPI_BIOSPAGE1_IOCSET_MASK_INITIAL_SPINUP_DELAY () {(0xf000000);}' unless defined(&MPI_BIOSPAGE1_IOCSET_MASK_INITIAL_SPINUP_DELAY);
    eval 'sub MPI_BIOSPAGE1_IOCSET_SHIFT_INITIAL_SPINUP_DELAY () {(24);}' unless defined(&MPI_BIOSPAGE1_IOCSET_SHIFT_INITIAL_SPINUP_DELAY);
    eval 'sub MPI_BIOSPAGE1_IOCSET_MASK_PORT_ENABLE_DELAY () {(0xf00000);}' unless defined(&MPI_BIOSPAGE1_IOCSET_MASK_PORT_ENABLE_DELAY);
    eval 'sub MPI_BIOSPAGE1_IOCSET_SHIFT_PORT_ENABLE_DELAY () {(20);}' unless defined(&MPI_BIOSPAGE1_IOCSET_SHIFT_PORT_ENABLE_DELAY);
    eval 'sub MPI_BIOSPAGE1_IOCSET_AUTO_PORT_ENABLE () {(0x80000);}' unless defined(&MPI_BIOSPAGE1_IOCSET_AUTO_PORT_ENABLE);
    eval 'sub MPI_BIOSPAGE1_IOCSET_DIRECT_ATTACH_SPINUP_MODE () {(0x40000);}' unless defined(&MPI_BIOSPAGE1_IOCSET_DIRECT_ATTACH_SPINUP_MODE);
    eval 'sub MPI_BIOSPAGE1_IOCSET_MASK_BOOT_PREFERENCE () {(0x30000);}' unless defined(&MPI_BIOSPAGE1_IOCSET_MASK_BOOT_PREFERENCE);
    eval 'sub MPI_BIOSPAGE1_IOCSET_ENCLOSURE_SLOT_BOOT () {(0x);}' unless defined(&MPI_BIOSPAGE1_IOCSET_ENCLOSURE_SLOT_BOOT);
    eval 'sub MPI_BIOSPAGE1_IOCSET_SAS_ADDRESS_BOOT () {(0x10000);}' unless defined(&MPI_BIOSPAGE1_IOCSET_SAS_ADDRESS_BOOT);
    eval 'sub MPI_BIOSPAGE1_IOCSET_MASK_MAX_TARGET_SPIN_UP () {(0xf000);}' unless defined(&MPI_BIOSPAGE1_IOCSET_MASK_MAX_TARGET_SPIN_UP);
    eval 'sub MPI_BIOSPAGE1_IOCSET_SHIFT_MAX_TARGET_SPIN_UP () {(12);}' unless defined(&MPI_BIOSPAGE1_IOCSET_SHIFT_MAX_TARGET_SPIN_UP);
    eval 'sub MPI_BIOSPAGE1_IOCSET_MASK_SPINUP_DELAY () {(0xf00);}' unless defined(&MPI_BIOSPAGE1_IOCSET_MASK_SPINUP_DELAY);
    eval 'sub MPI_BIOSPAGE1_IOCSET_SHIFT_SPINUP_DELAY () {(8);}' unless defined(&MPI_BIOSPAGE1_IOCSET_SHIFT_SPINUP_DELAY);
    eval 'sub MPI_BIOSPAGE1_IOCSET_MASK_RM_SETTING () {(0xc0);}' unless defined(&MPI_BIOSPAGE1_IOCSET_MASK_RM_SETTING);
    eval 'sub MPI_BIOSPAGE1_IOCSET_NONE_RM_SETTING () {(0x);}' unless defined(&MPI_BIOSPAGE1_IOCSET_NONE_RM_SETTING);
    eval 'sub MPI_BIOSPAGE1_IOCSET_BOOT_RM_SETTING () {(0x40);}' unless defined(&MPI_BIOSPAGE1_IOCSET_BOOT_RM_SETTING);
    eval 'sub MPI_BIOSPAGE1_IOCSET_MEDIA_RM_SETTING () {(0x80);}' unless defined(&MPI_BIOSPAGE1_IOCSET_MEDIA_RM_SETTING);
    eval 'sub MPI_BIOSPAGE1_IOCSET_MASK_ADAPTER_SUPPORT () {(0x30);}' unless defined(&MPI_BIOSPAGE1_IOCSET_MASK_ADAPTER_SUPPORT);
    eval 'sub MPI_BIOSPAGE1_IOCSET_NO_SUPPORT () {(0x);}' unless defined(&MPI_BIOSPAGE1_IOCSET_NO_SUPPORT);
    eval 'sub MPI_BIOSPAGE1_IOCSET_BIOS_SUPPORT () {(0x10);}' unless defined(&MPI_BIOSPAGE1_IOCSET_BIOS_SUPPORT);
    eval 'sub MPI_BIOSPAGE1_IOCSET_OS_SUPPORT () {(0x20);}' unless defined(&MPI_BIOSPAGE1_IOCSET_OS_SUPPORT);
    eval 'sub MPI_BIOSPAGE1_IOCSET_ALL_SUPPORT () {(0x30);}' unless defined(&MPI_BIOSPAGE1_IOCSET_ALL_SUPPORT);
    eval 'sub MPI_BIOSPAGE1_IOCSET_ALTERNATE_CHS () {(0x8);}' unless defined(&MPI_BIOSPAGE1_IOCSET_ALTERNATE_CHS);
    eval 'sub MPI_BIOSPAGE1_DEVSET_DISABLE_SMART_POLLING () {(0x10);}' unless defined(&MPI_BIOSPAGE1_DEVSET_DISABLE_SMART_POLLING);
    eval 'sub MPI_BIOSPAGE1_DEVSET_DISABLE_SEQ_LUN () {(0x8);}' unless defined(&MPI_BIOSPAGE1_DEVSET_DISABLE_SEQ_LUN);
    eval 'sub MPI_BIOSPAGE1_DEVSET_DISABLE_RM_LUN () {(0x4);}' unless defined(&MPI_BIOSPAGE1_DEVSET_DISABLE_RM_LUN);
    eval 'sub MPI_BIOSPAGE1_DEVSET_DISABLE_NON_RM_LUN () {(0x2);}' unless defined(&MPI_BIOSPAGE1_DEVSET_DISABLE_NON_RM_LUN);
    eval 'sub MPI_BIOSPAGE1_DEVSET_DISABLE_OTHER_LUN () {(0x1);}' unless defined(&MPI_BIOSPAGE1_DEVSET_DISABLE_OTHER_LUN);
    eval 'sub MPI_BIOSPAGE1_EXPSPINUP_MASK_MAX_TARGET () {(0xf0);}' unless defined(&MPI_BIOSPAGE1_EXPSPINUP_MASK_MAX_TARGET);
    eval 'sub MPI_BIOSPAGE1_EXPSPINUP_SHIFT_MAX_TARGET () {(4);}' unless defined(&MPI_BIOSPAGE1_EXPSPINUP_SHIFT_MAX_TARGET);
    eval 'sub MPI_BIOSPAGE1_EXPSPINUP_MASK_DELAY () {(0xf);}' unless defined(&MPI_BIOSPAGE1_EXPSPINUP_MASK_DELAY);
    eval 'sub MPI_BIOSPAGE2_PAGEVERSION () {(0x2);}' unless defined(&MPI_BIOSPAGE2_PAGEVERSION);
    eval 'sub MPI_BIOSPAGE2_FORM_MASK () {(0xf);}' unless defined(&MPI_BIOSPAGE2_FORM_MASK);
    eval 'sub MPI_BIOSPAGE2_FORM_ADAPTER_ORDER () {(0x);}' unless defined(&MPI_BIOSPAGE2_FORM_ADAPTER_ORDER);
    eval 'sub MPI_BIOSPAGE2_FORM_ADAPTER_NUMBER () {(0x1);}' unless defined(&MPI_BIOSPAGE2_FORM_ADAPTER_NUMBER);
    eval 'sub MPI_BIOSPAGE2_FORM_PCI_ADDRESS () {(0x2);}' unless defined(&MPI_BIOSPAGE2_FORM_PCI_ADDRESS);
    eval 'sub MPI_BIOSPAGE2_FORM_PCI_SLOT_NUMBER () {(0x3);}' unless defined(&MPI_BIOSPAGE2_FORM_PCI_SLOT_NUMBER);
    eval 'sub MPI_BIOSPAGE2_FORM_FC_WWN () {(0x4);}' unless defined(&MPI_BIOSPAGE2_FORM_FC_WWN);
    eval 'sub MPI_BIOSPAGE2_FORM_SAS_WWN () {(0x5);}' unless defined(&MPI_BIOSPAGE2_FORM_SAS_WWN);
    eval 'sub MPI_BIOSPAGE2_FORM_ENCLOSURE_SLOT () {(0x6);}' unless defined(&MPI_BIOSPAGE2_FORM_ENCLOSURE_SLOT);
    eval 'sub MPI_BIOSPAGE4_PAGEVERSION () {(0x);}' unless defined(&MPI_BIOSPAGE4_PAGEVERSION);
    eval 'sub MPI_SCSIPORTPAGE0_PAGEVERSION () {(0x2);}' unless defined(&MPI_SCSIPORTPAGE0_PAGEVERSION);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_IU () {(0x1);}' unless defined(&MPI_SCSIPORTPAGE0_CAP_IU);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_DT () {(0x2);}' unless defined(&MPI_SCSIPORTPAGE0_CAP_DT);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_QAS () {(0x4);}' unless defined(&MPI_SCSIPORTPAGE0_CAP_QAS);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_MIN_SYNC_PERIOD_MASK () {(0xff00);}' unless defined(&MPI_SCSIPORTPAGE0_CAP_MIN_SYNC_PERIOD_MASK);
    eval 'sub MPI_SCSIPORTPAGE0_SYNC_ASYNC () {(0x);}' unless defined(&MPI_SCSIPORTPAGE0_SYNC_ASYNC);
    eval 'sub MPI_SCSIPORTPAGE0_SYNC_5 () {(0x32);}' unless defined(&MPI_SCSIPORTPAGE0_SYNC_5);
    eval 'sub MPI_SCSIPORTPAGE0_SYNC_10 () {(0x19);}' unless defined(&MPI_SCSIPORTPAGE0_SYNC_10);
    eval 'sub MPI_SCSIPORTPAGE0_SYNC_20 () {(0xc);}' unless defined(&MPI_SCSIPORTPAGE0_SYNC_20);
    eval 'sub MPI_SCSIPORTPAGE0_SYNC_33_33 () {(0xb);}' unless defined(&MPI_SCSIPORTPAGE0_SYNC_33_33);
    eval 'sub MPI_SCSIPORTPAGE0_SYNC_40 () {(0xa);}' unless defined(&MPI_SCSIPORTPAGE0_SYNC_40);
    eval 'sub MPI_SCSIPORTPAGE0_SYNC_80 () {(0x9);}' unless defined(&MPI_SCSIPORTPAGE0_SYNC_80);
    eval 'sub MPI_SCSIPORTPAGE0_SYNC_160 () {(0x8);}' unless defined(&MPI_SCSIPORTPAGE0_SYNC_160);
    eval 'sub MPI_SCSIPORTPAGE0_SYNC_UNKNOWN () {(0xff);}' unless defined(&MPI_SCSIPORTPAGE0_SYNC_UNKNOWN);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_SHIFT_MIN_SYNC_PERIOD () {(8);}' unless defined(&MPI_SCSIPORTPAGE0_CAP_SHIFT_MIN_SYNC_PERIOD);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_GET_MIN_SYNC_PERIOD {
        my($Cap) = @_;
	    eval q(( (($Cap) &  &MPI_SCSIPORTPAGE0_CAP_MIN_SYNC_PERIOD_MASK) >>  &MPI_SCSIPORTPAGE0_CAP_SHIFT_MIN_SYNC_PERIOD ));
    }' unless defined(&MPI_SCSIPORTPAGE0_CAP_GET_MIN_SYNC_PERIOD);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_MAX_SYNC_OFFSET_MASK () {(0xff0000);}' unless defined(&MPI_SCSIPORTPAGE0_CAP_MAX_SYNC_OFFSET_MASK);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_SHIFT_MAX_SYNC_OFFSET () {(16);}' unless defined(&MPI_SCSIPORTPAGE0_CAP_SHIFT_MAX_SYNC_OFFSET);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_GET_MAX_SYNC_OFFSET {
        my($Cap) = @_;
	    eval q(( (($Cap) &  &MPI_SCSIPORTPAGE0_CAP_MAX_SYNC_OFFSET_MASK) >>  &MPI_SCSIPORTPAGE0_CAP_SHIFT_MAX_SYNC_OFFSET ));
    }' unless defined(&MPI_SCSIPORTPAGE0_CAP_GET_MAX_SYNC_OFFSET);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_IDP () {(0x8000000);}' unless defined(&MPI_SCSIPORTPAGE0_CAP_IDP);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_WIDE () {(0x20000000);}' unless defined(&MPI_SCSIPORTPAGE0_CAP_WIDE);
    eval 'sub MPI_SCSIPORTPAGE0_CAP_AIP () {(0x80000000);}' unless defined(&MPI_SCSIPORTPAGE0_CAP_AIP);
    eval 'sub MPI_SCSIPORTPAGE0_PHY_SIGNAL_TYPE_MASK () {(0x3);}' unless defined(&MPI_SCSIPORTPAGE0_PHY_SIGNAL_TYPE_MASK);
    eval 'sub MPI_SCSIPORTPAGE0_PHY_SIGNAL_HVD () {(0x1);}' unless defined(&MPI_SCSIPORTPAGE0_PHY_SIGNAL_HVD);
    eval 'sub MPI_SCSIPORTPAGE0_PHY_SIGNAL_SE () {(0x2);}' unless defined(&MPI_SCSIPORTPAGE0_PHY_SIGNAL_SE);
    eval 'sub MPI_SCSIPORTPAGE0_PHY_SIGNAL_LVD () {(0x3);}' unless defined(&MPI_SCSIPORTPAGE0_PHY_SIGNAL_LVD);
    eval 'sub MPI_SCSIPORTPAGE0_PHY_MASK_CONNECTED_ID () {(0xff000000);}' unless defined(&MPI_SCSIPORTPAGE0_PHY_MASK_CONNECTED_ID);
    eval 'sub MPI_SCSIPORTPAGE0_PHY_SHIFT_CONNECTED_ID () {(24);}' unless defined(&MPI_SCSIPORTPAGE0_PHY_SHIFT_CONNECTED_ID);
    eval 'sub MPI_SCSIPORTPAGE0_PHY_BUS_FREE_CONNECTED_ID () {(0xfe);}' unless defined(&MPI_SCSIPORTPAGE0_PHY_BUS_FREE_CONNECTED_ID);
    eval 'sub MPI_SCSIPORTPAGE0_PHY_UNKNOWN_CONNECTED_ID () {(0xff);}' unless defined(&MPI_SCSIPORTPAGE0_PHY_UNKNOWN_CONNECTED_ID);
    eval 'sub MPI_SCSIPORTPAGE1_PAGEVERSION () {(0x3);}' unless defined(&MPI_SCSIPORTPAGE1_PAGEVERSION);
    eval 'sub MPI_SCSIPORTPAGE1_CFG_PORT_SCSI_ID_MASK () {(0xff);}' unless defined(&MPI_SCSIPORTPAGE1_CFG_PORT_SCSI_ID_MASK);
    eval 'sub MPI_SCSIPORTPAGE1_CFG_PORT_RESPONSE_ID_MASK () {(0xffff0000);}' unless defined(&MPI_SCSIPORTPAGE1_CFG_PORT_RESPONSE_ID_MASK);
    eval 'sub MPI_SCSIPORTPAGE1_CFG_SHIFT_PORT_RESPONSE_ID () {(16);}' unless defined(&MPI_SCSIPORTPAGE1_CFG_SHIFT_PORT_RESPONSE_ID);
    eval 'sub MPI_SCSIPORTPAGE1_TARGCONFIG_TARG_ONLY () {(0x1);}' unless defined(&MPI_SCSIPORTPAGE1_TARGCONFIG_TARG_ONLY);
    eval 'sub MPI_SCSIPORTPAGE1_TARGCONFIG_INIT_TARG () {(0x2);}' unless defined(&MPI_SCSIPORTPAGE1_TARGCONFIG_INIT_TARG);
    eval 'sub MPI_SCSIPORTPAGE2_PAGEVERSION () {(0x2);}' unless defined(&MPI_SCSIPORTPAGE2_PAGEVERSION);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_FLAGS_SCAN_HIGH_TO_LOW () {(0x1);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_FLAGS_SCAN_HIGH_TO_LOW);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_FLAGS_AVOID_SCSI_RESET () {(0x4);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_FLAGS_AVOID_SCSI_RESET);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_FLAGS_ALTERNATE_CHS () {(0x8);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_FLAGS_ALTERNATE_CHS);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_FLAGS_TERMINATION_DISABLE () {(0x10);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_FLAGS_TERMINATION_DISABLE);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_FLAGS_DV_MASK () {(0x60);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_FLAGS_DV_MASK);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_FLAGS_FULL_DV () {(0x);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_FLAGS_FULL_DV);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_FLAGS_BASIC_DV_ONLY () {(0x20);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_FLAGS_BASIC_DV_ONLY);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_FLAGS_OFF_DV () {(0x60);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_FLAGS_OFF_DV);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_HOST_ID_MASK () {(0xf);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_HOST_ID_MASK);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_MASK_INIT_HBA () {(0x30);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_MASK_INIT_HBA);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_DISABLE_INIT_HBA () {(0x);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_DISABLE_INIT_HBA);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_BIOS_INIT_HBA () {(0x10);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_BIOS_INIT_HBA);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_OS_INIT_HBA () {(0x20);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_OS_INIT_HBA);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_BIOS_OS_INIT_HBA () {(0x30);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_BIOS_OS_INIT_HBA);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_REMOVABLE_MEDIA () {(0xc0);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_REMOVABLE_MEDIA);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_RM_NONE () {(0x);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_RM_NONE);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_RM_BOOT_ONLY () {(0x40);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_RM_BOOT_ONLY);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_RM_WITH_MEDIA () {(0x80);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_RM_WITH_MEDIA);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_SPINUP_DELAY_MASK () {(0xf00);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_SPINUP_DELAY_MASK);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_SHIFT_SPINUP_DELAY () {(8);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_SHIFT_SPINUP_DELAY);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_MASK_NEGO_MASTER_SETTINGS () {(0x3000);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_MASK_NEGO_MASTER_SETTINGS);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_NEGO_MASTER_SETTINGS () {(0x);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_NEGO_MASTER_SETTINGS);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_NONE_MASTER_SETTINGS () {(0x1000);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_NONE_MASTER_SETTINGS);
    eval 'sub MPI_SCSIPORTPAGE2_PORT_ALL_MASTER_SETTINGS () {(0x3000);}' unless defined(&MPI_SCSIPORTPAGE2_PORT_ALL_MASTER_SETTINGS);
    eval 'sub MPI_SCSIPORTPAGE2_DEVICE_DISCONNECT_ENABLE () {(0x1);}' unless defined(&MPI_SCSIPORTPAGE2_DEVICE_DISCONNECT_ENABLE);
    eval 'sub MPI_SCSIPORTPAGE2_DEVICE_ID_SCAN_ENABLE () {(0x2);}' unless defined(&MPI_SCSIPORTPAGE2_DEVICE_ID_SCAN_ENABLE);
    eval 'sub MPI_SCSIPORTPAGE2_DEVICE_LUN_SCAN_ENABLE () {(0x4);}' unless defined(&MPI_SCSIPORTPAGE2_DEVICE_LUN_SCAN_ENABLE);
    eval 'sub MPI_SCSIPORTPAGE2_DEVICE_TAG_QUEUE_ENABLE () {(0x8);}' unless defined(&MPI_SCSIPORTPAGE2_DEVICE_TAG_QUEUE_ENABLE);
    eval 'sub MPI_SCSIPORTPAGE2_DEVICE_WIDE_DISABLE () {(0x10);}' unless defined(&MPI_SCSIPORTPAGE2_DEVICE_WIDE_DISABLE);
    eval 'sub MPI_SCSIPORTPAGE2_DEVICE_BOOT_CHOICE () {(0x20);}' unless defined(&MPI_SCSIPORTPAGE2_DEVICE_BOOT_CHOICE);
    eval 'sub MPI_SCSIDEVPAGE0_PAGEVERSION () {(0x4);}' unless defined(&MPI_SCSIDEVPAGE0_PAGEVERSION);
    eval 'sub MPI_SCSIDEVPAGE0_NP_IU () {(0x1);}' unless defined(&MPI_SCSIDEVPAGE0_NP_IU);
    eval 'sub MPI_SCSIDEVPAGE0_NP_DT () {(0x2);}' unless defined(&MPI_SCSIDEVPAGE0_NP_DT);
    eval 'sub MPI_SCSIDEVPAGE0_NP_QAS () {(0x4);}' unless defined(&MPI_SCSIDEVPAGE0_NP_QAS);
    eval 'sub MPI_SCSIDEVPAGE0_NP_HOLD_MCS () {(0x8);}' unless defined(&MPI_SCSIDEVPAGE0_NP_HOLD_MCS);
    eval 'sub MPI_SCSIDEVPAGE0_NP_WR_FLOW () {(0x10);}' unless defined(&MPI_SCSIDEVPAGE0_NP_WR_FLOW);
    eval 'sub MPI_SCSIDEVPAGE0_NP_RD_STRM () {(0x20);}' unless defined(&MPI_SCSIDEVPAGE0_NP_RD_STRM);
    eval 'sub MPI_SCSIDEVPAGE0_NP_RTI () {(0x40);}' unless defined(&MPI_SCSIDEVPAGE0_NP_RTI);
    eval 'sub MPI_SCSIDEVPAGE0_NP_PCOMP_EN () {(0x80);}' unless defined(&MPI_SCSIDEVPAGE0_NP_PCOMP_EN);
    eval 'sub MPI_SCSIDEVPAGE0_NP_NEG_SYNC_PERIOD_MASK () {(0xff00);}' unless defined(&MPI_SCSIDEVPAGE0_NP_NEG_SYNC_PERIOD_MASK);
    eval 'sub MPI_SCSIDEVPAGE0_NP_SHIFT_SYNC_PERIOD () {(8);}' unless defined(&MPI_SCSIDEVPAGE0_NP_SHIFT_SYNC_PERIOD);
    eval 'sub MPI_SCSIDEVPAGE0_NP_NEG_SYNC_OFFSET_MASK () {(0xff0000);}' unless defined(&MPI_SCSIDEVPAGE0_NP_NEG_SYNC_OFFSET_MASK);
    eval 'sub MPI_SCSIDEVPAGE0_NP_SHIFT_SYNC_OFFSET () {(16);}' unless defined(&MPI_SCSIDEVPAGE0_NP_SHIFT_SYNC_OFFSET);
    eval 'sub MPI_SCSIDEVPAGE0_NP_IDP () {(0x8000000);}' unless defined(&MPI_SCSIDEVPAGE0_NP_IDP);
    eval 'sub MPI_SCSIDEVPAGE0_NP_WIDE () {(0x20000000);}' unless defined(&MPI_SCSIDEVPAGE0_NP_WIDE);
    eval 'sub MPI_SCSIDEVPAGE0_NP_AIP () {(0x80000000);}' unless defined(&MPI_SCSIDEVPAGE0_NP_AIP);
    eval 'sub MPI_SCSIDEVPAGE0_INFO_PARAMS_NEGOTIATED () {(0x1);}' unless defined(&MPI_SCSIDEVPAGE0_INFO_PARAMS_NEGOTIATED);
    eval 'sub MPI_SCSIDEVPAGE0_INFO_SDTR_REJECTED () {(0x2);}' unless defined(&MPI_SCSIDEVPAGE0_INFO_SDTR_REJECTED);
    eval 'sub MPI_SCSIDEVPAGE0_INFO_WDTR_REJECTED () {(0x4);}' unless defined(&MPI_SCSIDEVPAGE0_INFO_WDTR_REJECTED);
    eval 'sub MPI_SCSIDEVPAGE0_INFO_PPR_REJECTED () {(0x8);}' unless defined(&MPI_SCSIDEVPAGE0_INFO_PPR_REJECTED);
    eval 'sub MPI_SCSIDEVPAGE1_PAGEVERSION () {(0x5);}' unless defined(&MPI_SCSIDEVPAGE1_PAGEVERSION);
    eval 'sub MPI_SCSIDEVPAGE1_RP_IU () {(0x1);}' unless defined(&MPI_SCSIDEVPAGE1_RP_IU);
    eval 'sub MPI_SCSIDEVPAGE1_RP_DT () {(0x2);}' unless defined(&MPI_SCSIDEVPAGE1_RP_DT);
    eval 'sub MPI_SCSIDEVPAGE1_RP_QAS () {(0x4);}' unless defined(&MPI_SCSIDEVPAGE1_RP_QAS);
    eval 'sub MPI_SCSIDEVPAGE1_RP_HOLD_MCS () {(0x8);}' unless defined(&MPI_SCSIDEVPAGE1_RP_HOLD_MCS);
    eval 'sub MPI_SCSIDEVPAGE1_RP_WR_FLOW () {(0x10);}' unless defined(&MPI_SCSIDEVPAGE1_RP_WR_FLOW);
    eval 'sub MPI_SCSIDEVPAGE1_RP_RD_STRM () {(0x20);}' unless defined(&MPI_SCSIDEVPAGE1_RP_RD_STRM);
    eval 'sub MPI_SCSIDEVPAGE1_RP_RTI () {(0x40);}' unless defined(&MPI_SCSIDEVPAGE1_RP_RTI);
    eval 'sub MPI_SCSIDEVPAGE1_RP_PCOMP_EN () {(0x80);}' unless defined(&MPI_SCSIDEVPAGE1_RP_PCOMP_EN);
    eval 'sub MPI_SCSIDEVPAGE1_RP_MIN_SYNC_PERIOD_MASK () {(0xff00);}' unless defined(&MPI_SCSIDEVPAGE1_RP_MIN_SYNC_PERIOD_MASK);
    eval 'sub MPI_SCSIDEVPAGE1_RP_SHIFT_MIN_SYNC_PERIOD () {(8);}' unless defined(&MPI_SCSIDEVPAGE1_RP_SHIFT_MIN_SYNC_PERIOD);
    eval 'sub MPI_SCSIDEVPAGE1_RP_MAX_SYNC_OFFSET_MASK () {(0xff0000);}' unless defined(&MPI_SCSIDEVPAGE1_RP_MAX_SYNC_OFFSET_MASK);
    eval 'sub MPI_SCSIDEVPAGE1_RP_SHIFT_MAX_SYNC_OFFSET () {(16);}' unless defined(&MPI_SCSIDEVPAGE1_RP_SHIFT_MAX_SYNC_OFFSET);
    eval 'sub MPI_SCSIDEVPAGE1_RP_IDP () {(0x8000000);}' unless defined(&MPI_SCSIDEVPAGE1_RP_IDP);
    eval 'sub MPI_SCSIDEVPAGE1_RP_WIDE () {(0x20000000);}' unless defined(&MPI_SCSIDEVPAGE1_RP_WIDE);
    eval 'sub MPI_SCSIDEVPAGE1_RP_AIP () {(0x80000000);}' unless defined(&MPI_SCSIDEVPAGE1_RP_AIP);
    eval 'sub MPI_SCSIDEVPAGE1_CONF_WDTR_DISALLOWED () {(0x2);}' unless defined(&MPI_SCSIDEVPAGE1_CONF_WDTR_DISALLOWED);
    eval 'sub MPI_SCSIDEVPAGE1_CONF_SDTR_DISALLOWED () {(0x4);}' unless defined(&MPI_SCSIDEVPAGE1_CONF_SDTR_DISALLOWED);
    eval 'sub MPI_SCSIDEVPAGE1_CONF_EXTENDED_PARAMS_ENABLE () {(0x8);}' unless defined(&MPI_SCSIDEVPAGE1_CONF_EXTENDED_PARAMS_ENABLE);
    eval 'sub MPI_SCSIDEVPAGE1_CONF_FORCE_PPR_MSG () {(0x10);}' unless defined(&MPI_SCSIDEVPAGE1_CONF_FORCE_PPR_MSG);
    eval 'sub MPI_SCSIDEVPAGE2_PAGEVERSION () {(0x1);}' unless defined(&MPI_SCSIDEVPAGE2_PAGEVERSION);
    eval 'sub MPI_SCSIDEVPAGE2_DV_ISI_ENABLE () {(0x10);}' unless defined(&MPI_SCSIDEVPAGE2_DV_ISI_ENABLE);
    eval 'sub MPI_SCSIDEVPAGE2_DV_SECONDARY_DRIVER_ENABLE () {(0x20);}' unless defined(&MPI_SCSIDEVPAGE2_DV_SECONDARY_DRIVER_ENABLE);
    eval 'sub MPI_SCSIDEVPAGE2_DV_SLEW_RATE_CTRL () {(0x380);}' unless defined(&MPI_SCSIDEVPAGE2_DV_SLEW_RATE_CTRL);
    eval 'sub MPI_SCSIDEVPAGE2_DV_PRIM_DRIVE_STR_CTRL () {(0x1c00);}' unless defined(&MPI_SCSIDEVPAGE2_DV_PRIM_DRIVE_STR_CTRL);
    eval 'sub MPI_SCSIDEVPAGE2_DV_SECOND_DRIVE_STR_CTRL () {(0xe000);}' unless defined(&MPI_SCSIDEVPAGE2_DV_SECOND_DRIVE_STR_CTRL);
    eval 'sub MPI_SCSIDEVPAGE2_DV_XCLKH_ST () {(0x10000000);}' unless defined(&MPI_SCSIDEVPAGE2_DV_XCLKH_ST);
    eval 'sub MPI_SCSIDEVPAGE2_DV_XCLKS_ST () {(0x20000000);}' unless defined(&MPI_SCSIDEVPAGE2_DV_XCLKS_ST);
    eval 'sub MPI_SCSIDEVPAGE2_DV_XCLKH_DT () {(0x40000000);}' unless defined(&MPI_SCSIDEVPAGE2_DV_XCLKH_DT);
    eval 'sub MPI_SCSIDEVPAGE2_DV_XCLKS_DT () {(0x80000000);}' unless defined(&MPI_SCSIDEVPAGE2_DV_XCLKS_DT);
    eval 'sub MPI_SCSIDEVPAGE2_PPS_PPS_MASK () {(0x3);}' unless defined(&MPI_SCSIDEVPAGE2_PPS_PPS_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_0_PL_SELECT_MASK () {(0x3);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_0_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_1_PL_SELECT_MASK () {(0xc);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_1_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_2_PL_SELECT_MASK () {(0x30);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_2_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_3_PL_SELECT_MASK () {(0xc0);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_3_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_4_PL_SELECT_MASK () {(0x300);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_4_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_5_PL_SELECT_MASK () {(0xc00);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_5_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_6_PL_SELECT_MASK () {(0x3000);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_6_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_7_PL_SELECT_MASK () {(0xc000);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_7_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_8_PL_SELECT_MASK () {(0x30000);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_8_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_9_PL_SELECT_MASK () {(0xc0000);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_9_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_10_PL_SELECT_MASK () {(0x300000);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_10_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_11_PL_SELECT_MASK () {(0xc00000);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_11_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_12_PL_SELECT_MASK () {(0x3000000);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_12_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_13_PL_SELECT_MASK () {(0xc000000);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_13_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_14_PL_SELECT_MASK () {(0x30000000);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_14_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE2_DPS_BIT_15_PL_SELECT_MASK () {(0xc0000000);}' unless defined(&MPI_SCSIDEVPAGE2_DPS_BIT_15_PL_SELECT_MASK);
    eval 'sub MPI_SCSIDEVPAGE3_PAGEVERSION () {(0x);}' unless defined(&MPI_SCSIDEVPAGE3_PAGEVERSION);
    eval 'sub MPI_SCSIDEVPAGE3_MAX_COUNTER () {(0xfffe);}' unless defined(&MPI_SCSIDEVPAGE3_MAX_COUNTER);
    eval 'sub MPI_SCSIDEVPAGE3_UNSUPPORTED_COUNTER () {(0xffff);}' unless defined(&MPI_SCSIDEVPAGE3_UNSUPPORTED_COUNTER);
    eval 'sub MPI_FCPORTPAGE0_PAGEVERSION () {(0x2);}' unless defined(&MPI_FCPORTPAGE0_PAGEVERSION);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_PROT_MASK () {(0xf);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_PROT_MASK);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_PROT_FCP_INIT () {( &MPI_PORTFACTS_PROTOCOL_INITIATOR);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_PROT_FCP_INIT);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_PROT_FCP_TARG () {( &MPI_PORTFACTS_PROTOCOL_TARGET);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_PROT_FCP_TARG);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_PROT_LAN () {( &MPI_PORTFACTS_PROTOCOL_LAN);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_PROT_LAN);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_PROT_LOGBUSADDR () {( &MPI_PORTFACTS_PROTOCOL_LOGBUSADDR);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_PROT_LOGBUSADDR);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_ALIAS_ALPA_SUPPORTED () {(0x10);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_ALIAS_ALPA_SUPPORTED);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_ALIAS_WWN_SUPPORTED () {(0x20);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_ALIAS_WWN_SUPPORTED);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_FABRIC_WWN_VALID () {(0x40);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_FABRIC_WWN_VALID);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_ATTACH_TYPE_MASK () {(0xf00);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_ATTACH_TYPE_MASK);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_ATTACH_NO_INIT () {(0x);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_ATTACH_NO_INIT);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_ATTACH_POINT_TO_POINT () {(0x100);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_ATTACH_POINT_TO_POINT);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_ATTACH_PRIVATE_LOOP () {(0x200);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_ATTACH_PRIVATE_LOOP);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_ATTACH_FABRIC_DIRECT () {(0x400);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_ATTACH_FABRIC_DIRECT);
    eval 'sub MPI_FCPORTPAGE0_FLAGS_ATTACH_PUBLIC_LOOP () {(0x800);}' unless defined(&MPI_FCPORTPAGE0_FLAGS_ATTACH_PUBLIC_LOOP);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_RESERVED () {(0x);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_RESERVED);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_OTHER () {(0x1);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_OTHER);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_UNKNOWN () {(0x2);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_UNKNOWN);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_COPPER () {(0x3);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_COPPER);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_SINGLE_1300 () {(0x4);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_SINGLE_1300);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_SINGLE_1500 () {(0x5);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_SINGLE_1500);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_50_LASER_MULTI () {(0x6);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_50_LASER_MULTI);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_50_LED_MULTI () {(0x7);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_50_LED_MULTI);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_62_LASER_MULTI () {(0x8);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_62_LASER_MULTI);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_62_LED_MULTI () {(0x9);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_62_LED_MULTI);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_MULTI_LONG_WAVE () {(0xa);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_MULTI_LONG_WAVE);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_MULTI_SHORT_WAVE () {(0xb);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_MULTI_SHORT_WAVE);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_LASER_SHORT_WAVE () {(0xc);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_LASER_SHORT_WAVE);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_LED_SHORT_WAVE () {(0xd);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_LED_SHORT_WAVE);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_1300_LONG_WAVE () {(0xe);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_1300_LONG_WAVE);
    eval 'sub MPI_FCPORTPAGE0_LTYPE_1500_LONG_WAVE () {(0xf);}' unless defined(&MPI_FCPORTPAGE0_LTYPE_1500_LONG_WAVE);
    eval 'sub MPI_FCPORTPAGE0_PORTSTATE_UNKNOWN () {(0x1);}' unless defined(&MPI_FCPORTPAGE0_PORTSTATE_UNKNOWN);
    eval 'sub MPI_FCPORTPAGE0_PORTSTATE_ONLINE () {(0x2);}' unless defined(&MPI_FCPORTPAGE0_PORTSTATE_ONLINE);
    eval 'sub MPI_FCPORTPAGE0_PORTSTATE_OFFLINE () {(0x3);}' unless defined(&MPI_FCPORTPAGE0_PORTSTATE_OFFLINE);
    eval 'sub MPI_FCPORTPAGE0_PORTSTATE_BYPASSED () {(0x4);}' unless defined(&MPI_FCPORTPAGE0_PORTSTATE_BYPASSED);
    eval 'sub MPI_FCPORTPAGE0_PORTSTATE_DIAGNOST () {(0x5);}' unless defined(&MPI_FCPORTPAGE0_PORTSTATE_DIAGNOST);
    eval 'sub MPI_FCPORTPAGE0_PORTSTATE_LINKDOWN () {(0x6);}' unless defined(&MPI_FCPORTPAGE0_PORTSTATE_LINKDOWN);
    eval 'sub MPI_FCPORTPAGE0_PORTSTATE_ERROR () {(0x7);}' unless defined(&MPI_FCPORTPAGE0_PORTSTATE_ERROR);
    eval 'sub MPI_FCPORTPAGE0_PORTSTATE_LOOPBACK () {(0x8);}' unless defined(&MPI_FCPORTPAGE0_PORTSTATE_LOOPBACK);
    eval 'sub MPI_FCPORTPAGE0_SUPPORT_CLASS_1 () {(0x1);}' unless defined(&MPI_FCPORTPAGE0_SUPPORT_CLASS_1);
    eval 'sub MPI_FCPORTPAGE0_SUPPORT_CLASS_2 () {(0x2);}' unless defined(&MPI_FCPORTPAGE0_SUPPORT_CLASS_2);
    eval 'sub MPI_FCPORTPAGE0_SUPPORT_CLASS_3 () {(0x4);}' unless defined(&MPI_FCPORTPAGE0_SUPPORT_CLASS_3);
    eval 'sub MPI_FCPORTPAGE0_SUPPORT_SPEED_UKNOWN () {(0x);}' unless defined(&MPI_FCPORTPAGE0_SUPPORT_SPEED_UKNOWN);
    eval 'sub MPI_FCPORTPAGE0_SUPPORT_1GBIT_SPEED () {(0x1);}' unless defined(&MPI_FCPORTPAGE0_SUPPORT_1GBIT_SPEED);
    eval 'sub MPI_FCPORTPAGE0_SUPPORT_2GBIT_SPEED () {(0x2);}' unless defined(&MPI_FCPORTPAGE0_SUPPORT_2GBIT_SPEED);
    eval 'sub MPI_FCPORTPAGE0_SUPPORT_10GBIT_SPEED () {(0x4);}' unless defined(&MPI_FCPORTPAGE0_SUPPORT_10GBIT_SPEED);
    eval 'sub MPI_FCPORTPAGE0_SUPPORT_4GBIT_SPEED () {(0x8);}' unless defined(&MPI_FCPORTPAGE0_SUPPORT_4GBIT_SPEED);
    eval 'sub MPI_FCPORTPAGE0_CURRENT_SPEED_UKNOWN () { &MPI_FCPORTPAGE0_SUPPORT_SPEED_UKNOWN;}' unless defined(&MPI_FCPORTPAGE0_CURRENT_SPEED_UKNOWN);
    eval 'sub MPI_FCPORTPAGE0_CURRENT_SPEED_1GBIT () { &MPI_FCPORTPAGE0_SUPPORT_1GBIT_SPEED;}' unless defined(&MPI_FCPORTPAGE0_CURRENT_SPEED_1GBIT);
    eval 'sub MPI_FCPORTPAGE0_CURRENT_SPEED_2GBIT () { &MPI_FCPORTPAGE0_SUPPORT_2GBIT_SPEED;}' unless defined(&MPI_FCPORTPAGE0_CURRENT_SPEED_2GBIT);
    eval 'sub MPI_FCPORTPAGE0_CURRENT_SPEED_10GBIT () { &MPI_FCPORTPAGE0_SUPPORT_10GBIT_SPEED;}' unless defined(&MPI_FCPORTPAGE0_CURRENT_SPEED_10GBIT);
    eval 'sub MPI_FCPORTPAGE0_CURRENT_SPEED_4GBIT () { &MPI_FCPORTPAGE0_SUPPORT_4GBIT_SPEED;}' unless defined(&MPI_FCPORTPAGE0_CURRENT_SPEED_4GBIT);
    eval 'sub MPI_FCPORTPAGE0_CURRENT_SPEED_NOT_NEGOTIATED () {(0x8000);}' unless defined(&MPI_FCPORTPAGE0_CURRENT_SPEED_NOT_NEGOTIATED);
    eval 'sub MPI_FCPORTPAGE1_PAGEVERSION () {(0x6);}' unless defined(&MPI_FCPORTPAGE1_PAGEVERSION);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_EXT_FCP_STATUS_EN () {(0x8000000);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_EXT_FCP_STATUS_EN);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_IMMEDIATE_ERROR_REPLY () {(0x4000000);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_IMMEDIATE_ERROR_REPLY);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_FORCE_USE_NOSEEPROM_WWNS () {(0x2000000);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_FORCE_USE_NOSEEPROM_WWNS);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_VERBOSE_RESCAN_EVENTS () {(0x1000000);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_VERBOSE_RESCAN_EVENTS);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_TARGET_MODE_OXID () {(0x800000);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_TARGET_MODE_OXID);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_PORT_OFFLINE () {(0x400000);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_PORT_OFFLINE);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_SOFT_ALPA_FALLBACK () {(0x200000);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_SOFT_ALPA_FALLBACK);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_TARGET_LARGE_CDB_ENABLE () {(0x80);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_TARGET_LARGE_CDB_ENABLE);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_MASK_RR_TOV_UNITS () {(0x70);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_MASK_RR_TOV_UNITS);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_SUPPRESS_PROT_REG () {(0x8);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_SUPPRESS_PROT_REG);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_PLOGI_ON_LOGO () {(0x4);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_PLOGI_ON_LOGO);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_MAINTAIN_LOGINS () {(0x2);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_MAINTAIN_LOGINS);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_SORT_BY_DID () {(0x1);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_SORT_BY_DID);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_SORT_BY_WWN () {(0x);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_SORT_BY_WWN);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_PROT_MASK () {(0xf0000000);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_PROT_MASK);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_PROT_SHIFT () {(28);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_PROT_SHIFT);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_PROT_FCP_INIT () {(( &U32) &MPI_PORTFACTS_PROTOCOL_INITIATOR <<  &MPI_FCPORTPAGE1_FLAGS_PROT_SHIFT);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_PROT_FCP_INIT);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_PROT_FCP_TARG () {(( &U32) &MPI_PORTFACTS_PROTOCOL_TARGET <<  &MPI_FCPORTPAGE1_FLAGS_PROT_SHIFT);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_PROT_FCP_TARG);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_PROT_LAN () {(( &U32) &MPI_PORTFACTS_PROTOCOL_LAN <<  &MPI_FCPORTPAGE1_FLAGS_PROT_SHIFT);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_PROT_LAN);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_PROT_LOGBUSADDR () {(( &U32) &MPI_PORTFACTS_PROTOCOL_LOGBUSADDR <<  &MPI_FCPORTPAGE1_FLAGS_PROT_SHIFT);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_PROT_LOGBUSADDR);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_NONE_RR_TOV_UNITS () {(0x);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_NONE_RR_TOV_UNITS);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_THOUSANDTH_RR_TOV_UNITS () {(0x10);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_THOUSANDTH_RR_TOV_UNITS);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_TENTH_RR_TOV_UNITS () {(0x30);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_TENTH_RR_TOV_UNITS);
    eval 'sub MPI_FCPORTPAGE1_FLAGS_TEN_RR_TOV_UNITS () {(0x50);}' unless defined(&MPI_FCPORTPAGE1_FLAGS_TEN_RR_TOV_UNITS);
    eval 'sub MPI_FCPORTPAGE1_HARD_ALPA_NOT_USED () {(0xff);}' unless defined(&MPI_FCPORTPAGE1_HARD_ALPA_NOT_USED);
    eval 'sub MPI_FCPORTPAGE1_LCONFIG_SPEED_MASK () {(0xf);}' unless defined(&MPI_FCPORTPAGE1_LCONFIG_SPEED_MASK);
    eval 'sub MPI_FCPORTPAGE1_LCONFIG_SPEED_1GIG () {(0x);}' unless defined(&MPI_FCPORTPAGE1_LCONFIG_SPEED_1GIG);
    eval 'sub MPI_FCPORTPAGE1_LCONFIG_SPEED_2GIG () {(0x1);}' unless defined(&MPI_FCPORTPAGE1_LCONFIG_SPEED_2GIG);
    eval 'sub MPI_FCPORTPAGE1_LCONFIG_SPEED_4GIG () {(0x2);}' unless defined(&MPI_FCPORTPAGE1_LCONFIG_SPEED_4GIG);
    eval 'sub MPI_FCPORTPAGE1_LCONFIG_SPEED_10GIG () {(0x3);}' unless defined(&MPI_FCPORTPAGE1_LCONFIG_SPEED_10GIG);
    eval 'sub MPI_FCPORTPAGE1_LCONFIG_SPEED_AUTO () {(0xf);}' unless defined(&MPI_FCPORTPAGE1_LCONFIG_SPEED_AUTO);
    eval 'sub MPI_FCPORTPAGE1_TOPOLOGY_MASK () {(0xf);}' unless defined(&MPI_FCPORTPAGE1_TOPOLOGY_MASK);
    eval 'sub MPI_FCPORTPAGE1_TOPOLOGY_NLPORT () {(0x1);}' unless defined(&MPI_FCPORTPAGE1_TOPOLOGY_NLPORT);
    eval 'sub MPI_FCPORTPAGE1_TOPOLOGY_NPORT () {(0x2);}' unless defined(&MPI_FCPORTPAGE1_TOPOLOGY_NPORT);
    eval 'sub MPI_FCPORTPAGE1_TOPOLOGY_AUTO () {(0xf);}' unless defined(&MPI_FCPORTPAGE1_TOPOLOGY_AUTO);
    eval 'sub MPI_FCPORTPAGE1_ALT_CONN_UNKNOWN () {(0x);}' unless defined(&MPI_FCPORTPAGE1_ALT_CONN_UNKNOWN);
    eval 'sub MPI_FCPORTPAGE1_INITIATOR_DEV_TIMEOUT_MASK () {(0x7f);}' unless defined(&MPI_FCPORTPAGE1_INITIATOR_DEV_TIMEOUT_MASK);
    eval 'sub MPI_FCPORTPAGE1_INITIATOR_DEV_UNIT_16 () {(0x80);}' unless defined(&MPI_FCPORTPAGE1_INITIATOR_DEV_UNIT_16);
    eval 'sub MPI_FCPORTPAGE2_PAGEVERSION () {(0x1);}' unless defined(&MPI_FCPORTPAGE2_PAGEVERSION);
    eval 'sub MPI_PERSISTENT_FLAGS_SHIFT () {(16);}' unless defined(&MPI_PERSISTENT_FLAGS_SHIFT);
    eval 'sub MPI_PERSISTENT_FLAGS_ENTRY_VALID () {(0x1);}' unless defined(&MPI_PERSISTENT_FLAGS_ENTRY_VALID);
    eval 'sub MPI_PERSISTENT_FLAGS_SCAN_ID () {(0x2);}' unless defined(&MPI_PERSISTENT_FLAGS_SCAN_ID);
    eval 'sub MPI_PERSISTENT_FLAGS_SCAN_LUNS () {(0x4);}' unless defined(&MPI_PERSISTENT_FLAGS_SCAN_LUNS);
    eval 'sub MPI_PERSISTENT_FLAGS_BOOT_DEVICE () {(0x8);}' unless defined(&MPI_PERSISTENT_FLAGS_BOOT_DEVICE);
    eval 'sub MPI_PERSISTENT_FLAGS_BY_DID () {(0x80);}' unless defined(&MPI_PERSISTENT_FLAGS_BY_DID);
    unless(defined(&MPI_FC_PORT_PAGE_3_ENTRY_MAX)) {
	eval 'sub MPI_FC_PORT_PAGE_3_ENTRY_MAX () {(1);}' unless defined(&MPI_FC_PORT_PAGE_3_ENTRY_MAX);
    }
    eval 'sub MPI_FCPORTPAGE3_PAGEVERSION () {(0x1);}' unless defined(&MPI_FCPORTPAGE3_PAGEVERSION);
    eval 'sub MPI_FCPORTPAGE4_PAGEVERSION () {(0x);}' unless defined(&MPI_FCPORTPAGE4_PAGEVERSION);
    eval 'sub MPI_FCPORTPAGE4_PORT_FLAGS_ALTERNATE_CHS () {(0x8);}' unless defined(&MPI_FCPORTPAGE4_PORT_FLAGS_ALTERNATE_CHS);
    eval 'sub MPI_FCPORTPAGE4_PORT_MASK_INIT_HBA () {(0x30);}' unless defined(&MPI_FCPORTPAGE4_PORT_MASK_INIT_HBA);
    eval 'sub MPI_FCPORTPAGE4_PORT_DISABLE_INIT_HBA () {(0x);}' unless defined(&MPI_FCPORTPAGE4_PORT_DISABLE_INIT_HBA);
    eval 'sub MPI_FCPORTPAGE4_PORT_BIOS_INIT_HBA () {(0x10);}' unless defined(&MPI_FCPORTPAGE4_PORT_BIOS_INIT_HBA);
    eval 'sub MPI_FCPORTPAGE4_PORT_OS_INIT_HBA () {(0x20);}' unless defined(&MPI_FCPORTPAGE4_PORT_OS_INIT_HBA);
    eval 'sub MPI_FCPORTPAGE4_PORT_BIOS_OS_INIT_HBA () {(0x30);}' unless defined(&MPI_FCPORTPAGE4_PORT_BIOS_OS_INIT_HBA);
    eval 'sub MPI_FCPORTPAGE4_PORT_REMOVABLE_MEDIA () {(0xc0);}' unless defined(&MPI_FCPORTPAGE4_PORT_REMOVABLE_MEDIA);
    eval 'sub MPI_FCPORTPAGE4_PORT_SPINUP_DELAY_MASK () {(0xf00);}' unless defined(&MPI_FCPORTPAGE4_PORT_SPINUP_DELAY_MASK);
    eval 'sub MPI_FCPORTPAGE5_PAGEVERSION () {(0x2);}' unless defined(&MPI_FCPORTPAGE5_PAGEVERSION);
    eval 'sub MPI_FCPORTPAGE5_FLAGS_ALPA_ACQUIRED () {(0x1);}' unless defined(&MPI_FCPORTPAGE5_FLAGS_ALPA_ACQUIRED);
    eval 'sub MPI_FCPORTPAGE5_FLAGS_HARD_ALPA () {(0x2);}' unless defined(&MPI_FCPORTPAGE5_FLAGS_HARD_ALPA);
    eval 'sub MPI_FCPORTPAGE5_FLAGS_HARD_WWNN () {(0x4);}' unless defined(&MPI_FCPORTPAGE5_FLAGS_HARD_WWNN);
    eval 'sub MPI_FCPORTPAGE5_FLAGS_HARD_WWPN () {(0x8);}' unless defined(&MPI_FCPORTPAGE5_FLAGS_HARD_WWPN);
    eval 'sub MPI_FCPORTPAGE5_FLAGS_DISABLE () {(0x10);}' unless defined(&MPI_FCPORTPAGE5_FLAGS_DISABLE);
    eval 'sub MPI_FCPORTPAGE6_PAGEVERSION () {(0x);}' unless defined(&MPI_FCPORTPAGE6_PAGEVERSION);
    eval 'sub MPI_FCPORTPAGE7_PAGEVERSION () {(0x);}' unless defined(&MPI_FCPORTPAGE7_PAGEVERSION);
    eval 'sub MPI_FCPORTPAGE8_PAGEVERSION () {(0x);}' unless defined(&MPI_FCPORTPAGE8_PAGEVERSION);
    eval 'sub MPI_FCPORTPAGE9_PAGEVERSION () {(0x);}' unless defined(&MPI_FCPORTPAGE9_PAGEVERSION);
    eval 'sub MPI_FCPORT10_BASE_ID_UNKNOWN () {(0x);}' unless defined(&MPI_FCPORT10_BASE_ID_UNKNOWN);
    eval 'sub MPI_FCPORT10_BASE_ID_GBIC () {(0x1);}' unless defined(&MPI_FCPORT10_BASE_ID_GBIC);
    eval 'sub MPI_FCPORT10_BASE_ID_FIXED () {(0x2);}' unless defined(&MPI_FCPORT10_BASE_ID_FIXED);
    eval 'sub MPI_FCPORT10_BASE_ID_SFP () {(0x3);}' unless defined(&MPI_FCPORT10_BASE_ID_SFP);
    eval 'sub MPI_FCPORT10_BASE_ID_SFP_MIN () {(0x4);}' unless defined(&MPI_FCPORT10_BASE_ID_SFP_MIN);
    eval 'sub MPI_FCPORT10_BASE_ID_SFP_MAX () {(0x7f);}' unless defined(&MPI_FCPORT10_BASE_ID_SFP_MAX);
    eval 'sub MPI_FCPORT10_BASE_ID_VEND_SPEC_MASK () {(0x80);}' unless defined(&MPI_FCPORT10_BASE_ID_VEND_SPEC_MASK);
    eval 'sub MPI_FCPORT10_BASE_EXTID_UNKNOWN () {(0x);}' unless defined(&MPI_FCPORT10_BASE_EXTID_UNKNOWN);
    eval 'sub MPI_FCPORT10_BASE_EXTID_MODDEF1 () {(0x1);}' unless defined(&MPI_FCPORT10_BASE_EXTID_MODDEF1);
    eval 'sub MPI_FCPORT10_BASE_EXTID_MODDEF2 () {(0x2);}' unless defined(&MPI_FCPORT10_BASE_EXTID_MODDEF2);
    eval 'sub MPI_FCPORT10_BASE_EXTID_MODDEF3 () {(0x3);}' unless defined(&MPI_FCPORT10_BASE_EXTID_MODDEF3);
    eval 'sub MPI_FCPORT10_BASE_EXTID_SEEPROM () {(0x4);}' unless defined(&MPI_FCPORT10_BASE_EXTID_SEEPROM);
    eval 'sub MPI_FCPORT10_BASE_EXTID_MODDEF5 () {(0x5);}' unless defined(&MPI_FCPORT10_BASE_EXTID_MODDEF5);
    eval 'sub MPI_FCPORT10_BASE_EXTID_MODDEF6 () {(0x6);}' unless defined(&MPI_FCPORT10_BASE_EXTID_MODDEF6);
    eval 'sub MPI_FCPORT10_BASE_EXTID_MODDEF7 () {(0x7);}' unless defined(&MPI_FCPORT10_BASE_EXTID_MODDEF7);
    eval 'sub MPI_FCPORT10_BASE_EXTID_VNDSPC_MASK () {(0x80);}' unless defined(&MPI_FCPORT10_BASE_EXTID_VNDSPC_MASK);
    eval 'sub MPI_FCPORT10_BASE_CONN_UNKNOWN () {(0x);}' unless defined(&MPI_FCPORT10_BASE_CONN_UNKNOWN);
    eval 'sub MPI_FCPORT10_BASE_CONN_SC () {(0x1);}' unless defined(&MPI_FCPORT10_BASE_CONN_SC);
    eval 'sub MPI_FCPORT10_BASE_CONN_COPPER1 () {(0x2);}' unless defined(&MPI_FCPORT10_BASE_CONN_COPPER1);
    eval 'sub MPI_FCPORT10_BASE_CONN_COPPER2 () {(0x3);}' unless defined(&MPI_FCPORT10_BASE_CONN_COPPER2);
    eval 'sub MPI_FCPORT10_BASE_CONN_BNC_TNC () {(0x4);}' unless defined(&MPI_FCPORT10_BASE_CONN_BNC_TNC);
    eval 'sub MPI_FCPORT10_BASE_CONN_COAXIAL () {(0x5);}' unless defined(&MPI_FCPORT10_BASE_CONN_COAXIAL);
    eval 'sub MPI_FCPORT10_BASE_CONN_FIBERJACK () {(0x6);}' unless defined(&MPI_FCPORT10_BASE_CONN_FIBERJACK);
    eval 'sub MPI_FCPORT10_BASE_CONN_LC () {(0x7);}' unless defined(&MPI_FCPORT10_BASE_CONN_LC);
    eval 'sub MPI_FCPORT10_BASE_CONN_MT_RJ () {(0x8);}' unless defined(&MPI_FCPORT10_BASE_CONN_MT_RJ);
    eval 'sub MPI_FCPORT10_BASE_CONN_MU () {(0x9);}' unless defined(&MPI_FCPORT10_BASE_CONN_MU);
    eval 'sub MPI_FCPORT10_BASE_CONN_SG () {(0xa);}' unless defined(&MPI_FCPORT10_BASE_CONN_SG);
    eval 'sub MPI_FCPORT10_BASE_CONN_OPT_PIGT () {(0xb);}' unless defined(&MPI_FCPORT10_BASE_CONN_OPT_PIGT);
    eval 'sub MPI_FCPORT10_BASE_CONN_RSV1_MIN () {(0xc);}' unless defined(&MPI_FCPORT10_BASE_CONN_RSV1_MIN);
    eval 'sub MPI_FCPORT10_BASE_CONN_RSV1_MAX () {(0x1f);}' unless defined(&MPI_FCPORT10_BASE_CONN_RSV1_MAX);
    eval 'sub MPI_FCPORT10_BASE_CONN_HSSDC_II () {(0x20);}' unless defined(&MPI_FCPORT10_BASE_CONN_HSSDC_II);
    eval 'sub MPI_FCPORT10_BASE_CONN_CPR_PIGT () {(0x21);}' unless defined(&MPI_FCPORT10_BASE_CONN_CPR_PIGT);
    eval 'sub MPI_FCPORT10_BASE_CONN_RSV2_MIN () {(0x22);}' unless defined(&MPI_FCPORT10_BASE_CONN_RSV2_MIN);
    eval 'sub MPI_FCPORT10_BASE_CONN_RSV2_MAX () {(0x7f);}' unless defined(&MPI_FCPORT10_BASE_CONN_RSV2_MAX);
    eval 'sub MPI_FCPORT10_BASE_CONN_VNDSPC_MASK () {(0x80);}' unless defined(&MPI_FCPORT10_BASE_CONN_VNDSPC_MASK);
    eval 'sub MPI_FCPORT10_BASE_ENCODE_UNSPEC () {(0x);}' unless defined(&MPI_FCPORT10_BASE_ENCODE_UNSPEC);
    eval 'sub MPI_FCPORT10_BASE_ENCODE_8B10B () {(0x1);}' unless defined(&MPI_FCPORT10_BASE_ENCODE_8B10B);
    eval 'sub MPI_FCPORT10_BASE_ENCODE_4B5B () {(0x2);}' unless defined(&MPI_FCPORT10_BASE_ENCODE_4B5B);
    eval 'sub MPI_FCPORT10_BASE_ENCODE_NRZ () {(0x3);}' unless defined(&MPI_FCPORT10_BASE_ENCODE_NRZ);
    eval 'sub MPI_FCPORT10_BASE_ENCODE_MANCHESTER () {(0x4);}' unless defined(&MPI_FCPORT10_BASE_ENCODE_MANCHESTER);
    eval 'sub MPI_FCPORT10_EXT_OPTION1_RATESEL () {(0x20);}' unless defined(&MPI_FCPORT10_EXT_OPTION1_RATESEL);
    eval 'sub MPI_FCPORT10_EXT_OPTION1_TX_DISABLE () {(0x10);}' unless defined(&MPI_FCPORT10_EXT_OPTION1_TX_DISABLE);
    eval 'sub MPI_FCPORT10_EXT_OPTION1_TX_FAULT () {(0x8);}' unless defined(&MPI_FCPORT10_EXT_OPTION1_TX_FAULT);
    eval 'sub MPI_FCPORT10_EXT_OPTION1_LOS_INVERT () {(0x4);}' unless defined(&MPI_FCPORT10_EXT_OPTION1_LOS_INVERT);
    eval 'sub MPI_FCPORT10_EXT_OPTION1_LOS () {(0x2);}' unless defined(&MPI_FCPORT10_EXT_OPTION1_LOS);
    eval 'sub MPI_FCPORTPAGE10_PAGEVERSION () {(0x1);}' unless defined(&MPI_FCPORTPAGE10_PAGEVERSION);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF_MASK () {(0x7);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF_MASK);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF2 () {(0x1);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF2);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF1 () {(0x2);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF1);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF0 () {(0x4);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF0);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF_NOGBIC () {(0x7);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF_NOGBIC);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF_CPR_IEEE_CX () {(0x6);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF_CPR_IEEE_CX);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF_COPPER () {(0x5);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF_COPPER);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF_OPTICAL_LW () {(0x4);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF_OPTICAL_LW);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF_SEEPROM () {(0x3);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF_SEEPROM);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF_SW_OPTICAL () {(0x2);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF_SW_OPTICAL);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF_LX_IEEE_OPT_LW () {(0x1);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF_LX_IEEE_OPT_LW);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_MODDEF_SX_IEEE_OPT_SW () {(0x);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_MODDEF_SX_IEEE_OPT_SW);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_CC_BASE_OK () {(0x10);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_CC_BASE_OK);
    eval 'sub MPI_FCPORTPAGE10_FLAGS_CC_EXT_OK () {(0x20);}' unless defined(&MPI_FCPORTPAGE10_FLAGS_CC_EXT_OK);
    eval 'sub MPI_FC_DEVICE_PAGE0_PAGEVERSION () {(0x3);}' unless defined(&MPI_FC_DEVICE_PAGE0_PAGEVERSION);
    eval 'sub MPI_FC_DEVICE_PAGE0_FLAGS_TARGETID_BUS_VALID () {(0x1);}' unless defined(&MPI_FC_DEVICE_PAGE0_FLAGS_TARGETID_BUS_VALID);
    eval 'sub MPI_FC_DEVICE_PAGE0_FLAGS_PLOGI_INVALID () {(0x2);}' unless defined(&MPI_FC_DEVICE_PAGE0_FLAGS_PLOGI_INVALID);
    eval 'sub MPI_FC_DEVICE_PAGE0_FLAGS_PRLI_INVALID () {(0x4);}' unless defined(&MPI_FC_DEVICE_PAGE0_FLAGS_PRLI_INVALID);
    eval 'sub MPI_FC_DEVICE_PAGE0_PROT_IP () {(0x1);}' unless defined(&MPI_FC_DEVICE_PAGE0_PROT_IP);
    eval 'sub MPI_FC_DEVICE_PAGE0_PROT_FCP_TARGET () {(0x2);}' unless defined(&MPI_FC_DEVICE_PAGE0_PROT_FCP_TARGET);
    eval 'sub MPI_FC_DEVICE_PAGE0_PROT_FCP_INITIATOR () {(0x4);}' unless defined(&MPI_FC_DEVICE_PAGE0_PROT_FCP_INITIATOR);
    eval 'sub MPI_FC_DEVICE_PAGE0_PROT_FCP_RETRY () {(0x8);}' unless defined(&MPI_FC_DEVICE_PAGE0_PROT_FCP_RETRY);
    eval 'sub MPI_FC_DEVICE_PAGE0_PGAD_PORT_MASK () {( &MPI_FC_DEVICE_PGAD_PORT_MASK);}' unless defined(&MPI_FC_DEVICE_PAGE0_PGAD_PORT_MASK);
    eval 'sub MPI_FC_DEVICE_PAGE0_PGAD_FORM_MASK () {( &MPI_FC_DEVICE_PGAD_FORM_MASK);}' unless defined(&MPI_FC_DEVICE_PAGE0_PGAD_FORM_MASK);
    eval 'sub MPI_FC_DEVICE_PAGE0_PGAD_FORM_NEXT_DID () {( &MPI_FC_DEVICE_PGAD_FORM_NEXT_DID);}' unless defined(&MPI_FC_DEVICE_PAGE0_PGAD_FORM_NEXT_DID);
    eval 'sub MPI_FC_DEVICE_PAGE0_PGAD_FORM_BUS_TID () {( &MPI_FC_DEVICE_PGAD_FORM_BUS_TID);}' unless defined(&MPI_FC_DEVICE_PAGE0_PGAD_FORM_BUS_TID);
    eval 'sub MPI_FC_DEVICE_PAGE0_PGAD_DID_MASK () {( &MPI_FC_DEVICE_PGAD_ND_DID_MASK);}' unless defined(&MPI_FC_DEVICE_PAGE0_PGAD_DID_MASK);
    eval 'sub MPI_FC_DEVICE_PAGE0_PGAD_BUS_MASK () {( &MPI_FC_DEVICE_PGAD_BT_BUS_MASK);}' unless defined(&MPI_FC_DEVICE_PAGE0_PGAD_BUS_MASK);
    eval 'sub MPI_FC_DEVICE_PAGE0_PGAD_BUS_SHIFT () {( &MPI_FC_DEVICE_PGAD_BT_BUS_SHIFT);}' unless defined(&MPI_FC_DEVICE_PAGE0_PGAD_BUS_SHIFT);
    eval 'sub MPI_FC_DEVICE_PAGE0_PGAD_TID_MASK () {( &MPI_FC_DEVICE_PGAD_BT_TID_MASK);}' unless defined(&MPI_FC_DEVICE_PAGE0_PGAD_TID_MASK);
    eval 'sub MPI_FC_DEVICE_PAGE0_HARD_ALPA_UNKNOWN () {(0xff);}' unless defined(&MPI_FC_DEVICE_PAGE0_HARD_ALPA_UNKNOWN);
    eval 'sub MPI_RAIDVOL0_PHYSDISK_PRIMARY () {(0x1);}' unless defined(&MPI_RAIDVOL0_PHYSDISK_PRIMARY);
    eval 'sub MPI_RAIDVOL0_PHYSDISK_SECONDARY () {(0x2);}' unless defined(&MPI_RAIDVOL0_PHYSDISK_SECONDARY);
    eval 'sub MPI_RAIDVOL0_STATUS_FLAG_ENABLED () {(0x1);}' unless defined(&MPI_RAIDVOL0_STATUS_FLAG_ENABLED);
    eval 'sub MPI_RAIDVOL0_STATUS_FLAG_QUIESCED () {(0x2);}' unless defined(&MPI_RAIDVOL0_STATUS_FLAG_QUIESCED);
    eval 'sub MPI_RAIDVOL0_STATUS_FLAG_RESYNC_IN_PROGRESS () {(0x4);}' unless defined(&MPI_RAIDVOL0_STATUS_FLAG_RESYNC_IN_PROGRESS);
    eval 'sub MPI_RAIDVOL0_STATUS_FLAG_VOLUME_INACTIVE () {(0x8);}' unless defined(&MPI_RAIDVOL0_STATUS_FLAG_VOLUME_INACTIVE);
    eval 'sub MPI_RAIDVOL0_STATUS_FLAG_BAD_BLOCK_TABLE_FULL () {(0x10);}' unless defined(&MPI_RAIDVOL0_STATUS_FLAG_BAD_BLOCK_TABLE_FULL);
    eval 'sub MPI_RAIDVOL0_STATUS_STATE_OPTIMAL () {(0x);}' unless defined(&MPI_RAIDVOL0_STATUS_STATE_OPTIMAL);
    eval 'sub MPI_RAIDVOL0_STATUS_STATE_DEGRADED () {(0x1);}' unless defined(&MPI_RAIDVOL0_STATUS_STATE_DEGRADED);
    eval 'sub MPI_RAIDVOL0_STATUS_STATE_FAILED () {(0x2);}' unless defined(&MPI_RAIDVOL0_STATUS_STATE_FAILED);
    eval 'sub MPI_RAIDVOL0_STATUS_STATE_MISSING () {(0x3);}' unless defined(&MPI_RAIDVOL0_STATUS_STATE_MISSING);
    eval 'sub MPI_RAIDVOL0_SETTING_WRITE_CACHING_ENABLE () {(0x1);}' unless defined(&MPI_RAIDVOL0_SETTING_WRITE_CACHING_ENABLE);
    eval 'sub MPI_RAIDVOL0_SETTING_OFFLINE_ON_SMART () {(0x2);}' unless defined(&MPI_RAIDVOL0_SETTING_OFFLINE_ON_SMART);
    eval 'sub MPI_RAIDVOL0_SETTING_AUTO_CONFIGURE () {(0x4);}' unless defined(&MPI_RAIDVOL0_SETTING_AUTO_CONFIGURE);
    eval 'sub MPI_RAIDVOL0_SETTING_PRIORITY_RESYNC () {(0x8);}' unless defined(&MPI_RAIDVOL0_SETTING_PRIORITY_RESYNC);
    eval 'sub MPI_RAIDVOL0_SETTING_FAST_DATA_SCRUBBING_0102 () {(0x20);}' unless defined(&MPI_RAIDVOL0_SETTING_FAST_DATA_SCRUBBING_0102);
    eval 'sub MPI_RAIDVOL0_SETTING_MASK_METADATA_SIZE () {(0xc0);}' unless defined(&MPI_RAIDVOL0_SETTING_MASK_METADATA_SIZE);
    eval 'sub MPI_RAIDVOL0_SETTING_64MB_METADATA_SIZE () {(0x);}' unless defined(&MPI_RAIDVOL0_SETTING_64MB_METADATA_SIZE);
    eval 'sub MPI_RAIDVOL0_SETTING_512MB_METADATA_SIZE () {(0x40);}' unless defined(&MPI_RAIDVOL0_SETTING_512MB_METADATA_SIZE);
    eval 'sub MPI_RAIDVOL0_SETTING_USE_PRODUCT_ID_SUFFIX () {(0x10);}' unless defined(&MPI_RAIDVOL0_SETTING_USE_PRODUCT_ID_SUFFIX);
    eval 'sub MPI_RAIDVOL0_SETTING_USE_DEFAULTS () {(0x8000);}' unless defined(&MPI_RAIDVOL0_SETTING_USE_DEFAULTS);
    eval 'sub MPI_RAID_HOT_SPARE_POOL_0 () {(0x1);}' unless defined(&MPI_RAID_HOT_SPARE_POOL_0);
    eval 'sub MPI_RAID_HOT_SPARE_POOL_1 () {(0x2);}' unless defined(&MPI_RAID_HOT_SPARE_POOL_1);
    eval 'sub MPI_RAID_HOT_SPARE_POOL_2 () {(0x4);}' unless defined(&MPI_RAID_HOT_SPARE_POOL_2);
    eval 'sub MPI_RAID_HOT_SPARE_POOL_3 () {(0x8);}' unless defined(&MPI_RAID_HOT_SPARE_POOL_3);
    eval 'sub MPI_RAID_HOT_SPARE_POOL_4 () {(0x10);}' unless defined(&MPI_RAID_HOT_SPARE_POOL_4);
    eval 'sub MPI_RAID_HOT_SPARE_POOL_5 () {(0x20);}' unless defined(&MPI_RAID_HOT_SPARE_POOL_5);
    eval 'sub MPI_RAID_HOT_SPARE_POOL_6 () {(0x40);}' unless defined(&MPI_RAID_HOT_SPARE_POOL_6);
    eval 'sub MPI_RAID_HOT_SPARE_POOL_7 () {(0x80);}' unless defined(&MPI_RAID_HOT_SPARE_POOL_7);
    unless(defined(&MPI_RAID_VOL_PAGE_0_PHYSDISK_MAX)) {
	eval 'sub MPI_RAID_VOL_PAGE_0_PHYSDISK_MAX () {(1);}' unless defined(&MPI_RAID_VOL_PAGE_0_PHYSDISK_MAX);
    }
    eval 'sub MPI_RAIDVOLPAGE0_PAGEVERSION () {(0x7);}' unless defined(&MPI_RAIDVOLPAGE0_PAGEVERSION);
    eval 'sub MPI_RAIDVOLPAGE0_UNKNOWN_INACTIVE () {(0x);}' unless defined(&MPI_RAIDVOLPAGE0_UNKNOWN_INACTIVE);
    eval 'sub MPI_RAIDVOLPAGE0_STALE_METADATA_INACTIVE () {(0x1);}' unless defined(&MPI_RAIDVOLPAGE0_STALE_METADATA_INACTIVE);
    eval 'sub MPI_RAIDVOLPAGE0_FOREIGN_VOLUME_INACTIVE () {(0x2);}' unless defined(&MPI_RAIDVOLPAGE0_FOREIGN_VOLUME_INACTIVE);
    eval 'sub MPI_RAIDVOLPAGE0_INSUFFICIENT_RESOURCE_INACTIVE () {(0x3);}' unless defined(&MPI_RAIDVOLPAGE0_INSUFFICIENT_RESOURCE_INACTIVE);
    eval 'sub MPI_RAIDVOLPAGE0_CLONE_VOLUME_INACTIVE () {(0x4);}' unless defined(&MPI_RAIDVOLPAGE0_CLONE_VOLUME_INACTIVE);
    eval 'sub MPI_RAIDVOLPAGE0_INSUFFICIENT_METADATA_INACTIVE () {(0x5);}' unless defined(&MPI_RAIDVOLPAGE0_INSUFFICIENT_METADATA_INACTIVE);
    eval 'sub MPI_RAIDVOLPAGE0_PREVIOUSLY_DELETED () {(0x6);}' unless defined(&MPI_RAIDVOLPAGE0_PREVIOUSLY_DELETED);
    eval 'sub MPI_RAIDVOLPAGE1_PAGEVERSION () {(0x1);}' unless defined(&MPI_RAIDVOLPAGE1_PAGEVERSION);
    eval 'sub MPI_PHYSDISK0_STATUS_FLAG_OUT_OF_SYNC () {(0x1);}' unless defined(&MPI_PHYSDISK0_STATUS_FLAG_OUT_OF_SYNC);
    eval 'sub MPI_PHYSDISK0_STATUS_FLAG_QUIESCED () {(0x2);}' unless defined(&MPI_PHYSDISK0_STATUS_FLAG_QUIESCED);
    eval 'sub MPI_PHYSDISK0_STATUS_FLAG_INACTIVE_VOLUME () {(0x4);}' unless defined(&MPI_PHYSDISK0_STATUS_FLAG_INACTIVE_VOLUME);
    eval 'sub MPI_PHYSDISK0_STATUS_FLAG_OPTIMAL_PREVIOUS () {(0x);}' unless defined(&MPI_PHYSDISK0_STATUS_FLAG_OPTIMAL_PREVIOUS);
    eval 'sub MPI_PHYSDISK0_STATUS_FLAG_NOT_OPTIMAL_PREVIOUS () {(0x8);}' unless defined(&MPI_PHYSDISK0_STATUS_FLAG_NOT_OPTIMAL_PREVIOUS);
    eval 'sub MPI_PHYSDISK0_STATUS_ONLINE () {(0x);}' unless defined(&MPI_PHYSDISK0_STATUS_ONLINE);
    eval 'sub MPI_PHYSDISK0_STATUS_MISSING () {(0x1);}' unless defined(&MPI_PHYSDISK0_STATUS_MISSING);
    eval 'sub MPI_PHYSDISK0_STATUS_NOT_COMPATIBLE () {(0x2);}' unless defined(&MPI_PHYSDISK0_STATUS_NOT_COMPATIBLE);
    eval 'sub MPI_PHYSDISK0_STATUS_FAILED () {(0x3);}' unless defined(&MPI_PHYSDISK0_STATUS_FAILED);
    eval 'sub MPI_PHYSDISK0_STATUS_INITIALIZING () {(0x4);}' unless defined(&MPI_PHYSDISK0_STATUS_INITIALIZING);
    eval 'sub MPI_PHYSDISK0_STATUS_OFFLINE_REQUESTED () {(0x5);}' unless defined(&MPI_PHYSDISK0_STATUS_OFFLINE_REQUESTED);
    eval 'sub MPI_PHYSDISK0_STATUS_FAILED_REQUESTED () {(0x6);}' unless defined(&MPI_PHYSDISK0_STATUS_FAILED_REQUESTED);
    eval 'sub MPI_PHYSDISK0_STATUS_OTHER_OFFLINE () {(0xff);}' unless defined(&MPI_PHYSDISK0_STATUS_OTHER_OFFLINE);
    eval 'sub MPI_RAIDPHYSDISKPAGE0_PAGEVERSION () {(0x2);}' unless defined(&MPI_RAIDPHYSDISKPAGE0_PAGEVERSION);
    eval 'sub MPI_RAID_PHYSDISK1_FLAG_BROKEN () {(0x2);}' unless defined(&MPI_RAID_PHYSDISK1_FLAG_BROKEN);
    eval 'sub MPI_RAID_PHYSDISK1_FLAG_INVALID () {(0x1);}' unless defined(&MPI_RAID_PHYSDISK1_FLAG_INVALID);
    unless(defined(&MPI_RAID_PHYS_DISK1_PATH_MAX)) {
	eval 'sub MPI_RAID_PHYS_DISK1_PATH_MAX () {(1);}' unless defined(&MPI_RAID_PHYS_DISK1_PATH_MAX);
    }
    eval 'sub MPI_RAIDPHYSDISKPAGE1_PAGEVERSION () {(0x);}' unless defined(&MPI_RAIDPHYSDISKPAGE1_PAGEVERSION);
    eval 'sub MPI_LAN_PAGE0_PAGEVERSION () {(0x1);}' unless defined(&MPI_LAN_PAGE0_PAGEVERSION);
    eval 'sub MPI_LAN_PAGE0_RETURN_LOOPBACK () {(0x);}' unless defined(&MPI_LAN_PAGE0_RETURN_LOOPBACK);
    eval 'sub MPI_LAN_PAGE0_SUPPRESS_LOOPBACK () {(0x1);}' unless defined(&MPI_LAN_PAGE0_SUPPRESS_LOOPBACK);
    eval 'sub MPI_LAN_PAGE0_LOOPBACK_MASK () {(0x1);}' unless defined(&MPI_LAN_PAGE0_LOOPBACK_MASK);
    eval 'sub MPI_LAN_PAGE1_PAGEVERSION () {(0x3);}' unless defined(&MPI_LAN_PAGE1_PAGEVERSION);
    eval 'sub MPI_LAN_PAGE1_DEV_STATE_RESET () {(0x);}' unless defined(&MPI_LAN_PAGE1_DEV_STATE_RESET);
    eval 'sub MPI_LAN_PAGE1_DEV_STATE_OPERATIONAL () {(0x1);}' unless defined(&MPI_LAN_PAGE1_DEV_STATE_OPERATIONAL);
    eval 'sub MPI_INBAND_PAGEVERSION () {(0x);}' unless defined(&MPI_INBAND_PAGEVERSION);
    unless(defined(&MPI_SAS_IOUNIT0_PHY_MAX)) {
	eval 'sub MPI_SAS_IOUNIT0_PHY_MAX () {(1);}' unless defined(&MPI_SAS_IOUNIT0_PHY_MAX);
    }
    eval 'sub MPI_SASIOUNITPAGE0_PAGEVERSION () {(0x4);}' unless defined(&MPI_SASIOUNITPAGE0_PAGEVERSION);
    eval 'sub MPI_SAS_IOUNIT0_PORT_FLAGS_DISCOVERY_IN_PROGRESS () {(0x8);}' unless defined(&MPI_SAS_IOUNIT0_PORT_FLAGS_DISCOVERY_IN_PROGRESS);
    eval 'sub MPI_SAS_IOUNIT0_PORT_FLAGS_0_TARGET_IOC_NUM () {(0x);}' unless defined(&MPI_SAS_IOUNIT0_PORT_FLAGS_0_TARGET_IOC_NUM);
    eval 'sub MPI_SAS_IOUNIT0_PORT_FLAGS_1_TARGET_IOC_NUM () {(0x4);}' unless defined(&MPI_SAS_IOUNIT0_PORT_FLAGS_1_TARGET_IOC_NUM);
    eval 'sub MPI_SAS_IOUNIT0_PORT_FLAGS_AUTO_PORT_CONFIG () {(0x1);}' unless defined(&MPI_SAS_IOUNIT0_PORT_FLAGS_AUTO_PORT_CONFIG);
    eval 'sub MPI_SAS_IOUNIT0_PHY_FLAGS_PHY_DISABLED () {(0x4);}' unless defined(&MPI_SAS_IOUNIT0_PHY_FLAGS_PHY_DISABLED);
    eval 'sub MPI_SAS_IOUNIT0_PHY_FLAGS_TX_INVERT () {(0x2);}' unless defined(&MPI_SAS_IOUNIT0_PHY_FLAGS_TX_INVERT);
    eval 'sub MPI_SAS_IOUNIT0_PHY_FLAGS_RX_INVERT () {(0x1);}' unless defined(&MPI_SAS_IOUNIT0_PHY_FLAGS_RX_INVERT);
    eval 'sub MPI_SAS_IOUNIT0_RATE_UNKNOWN () {(0x);}' unless defined(&MPI_SAS_IOUNIT0_RATE_UNKNOWN);
    eval 'sub MPI_SAS_IOUNIT0_RATE_PHY_DISABLED () {(0x1);}' unless defined(&MPI_SAS_IOUNIT0_RATE_PHY_DISABLED);
    eval 'sub MPI_SAS_IOUNIT0_RATE_FAILED_SPEED_NEGOTIATION () {(0x2);}' unless defined(&MPI_SAS_IOUNIT0_RATE_FAILED_SPEED_NEGOTIATION);
    eval 'sub MPI_SAS_IOUNIT0_RATE_SATA_OOB_COMPLETE () {(0x3);}' unless defined(&MPI_SAS_IOUNIT0_RATE_SATA_OOB_COMPLETE);
    eval 'sub MPI_SAS_IOUNIT0_RATE_1_5 () {(0x8);}' unless defined(&MPI_SAS_IOUNIT0_RATE_1_5);
    eval 'sub MPI_SAS_IOUNIT0_RATE_3_0 () {(0x9);}' unless defined(&MPI_SAS_IOUNIT0_RATE_3_0);
    eval 'sub MPI_SAS_IOUNIT0_RATE_6_0 () {(0xa);}' unless defined(&MPI_SAS_IOUNIT0_RATE_6_0);
    eval 'sub MPI_SAS_IOUNIT0_DS_LOOP_DETECTED () {(0x1);}' unless defined(&MPI_SAS_IOUNIT0_DS_LOOP_DETECTED);
    eval 'sub MPI_SAS_IOUNIT0_DS_UNADDRESSABLE_DEVICE () {(0x2);}' unless defined(&MPI_SAS_IOUNIT0_DS_UNADDRESSABLE_DEVICE);
    eval 'sub MPI_SAS_IOUNIT0_DS_MULTIPLE_PORTS () {(0x4);}' unless defined(&MPI_SAS_IOUNIT0_DS_MULTIPLE_PORTS);
    eval 'sub MPI_SAS_IOUNIT0_DS_EXPANDER_ERR () {(0x8);}' unless defined(&MPI_SAS_IOUNIT0_DS_EXPANDER_ERR);
    eval 'sub MPI_SAS_IOUNIT0_DS_SMP_TIMEOUT () {(0x10);}' unless defined(&MPI_SAS_IOUNIT0_DS_SMP_TIMEOUT);
    eval 'sub MPI_SAS_IOUNIT0_DS_OUT_ROUTE_ENTRIES () {(0x20);}' unless defined(&MPI_SAS_IOUNIT0_DS_OUT_ROUTE_ENTRIES);
    eval 'sub MPI_SAS_IOUNIT0_DS_INDEX_NOT_EXIST () {(0x40);}' unless defined(&MPI_SAS_IOUNIT0_DS_INDEX_NOT_EXIST);
    eval 'sub MPI_SAS_IOUNIT0_DS_SMP_FUNCTION_FAILED () {(0x80);}' unless defined(&MPI_SAS_IOUNIT0_DS_SMP_FUNCTION_FAILED);
    eval 'sub MPI_SAS_IOUNIT0_DS_SMP_CRC_ERROR () {(0x100);}' unless defined(&MPI_SAS_IOUNIT0_DS_SMP_CRC_ERROR);
    eval 'sub MPI_SAS_IOUNIT0_DS_SUBTRACTIVE_LINK () {(0x200);}' unless defined(&MPI_SAS_IOUNIT0_DS_SUBTRACTIVE_LINK);
    eval 'sub MPI_SAS_IOUNIT0_DS_TABLE_LINK () {(0x400);}' unless defined(&MPI_SAS_IOUNIT0_DS_TABLE_LINK);
    eval 'sub MPI_SAS_IOUNIT0_DS_UNSUPPORTED_DEVICE () {(0x800);}' unless defined(&MPI_SAS_IOUNIT0_DS_UNSUPPORTED_DEVICE);
    eval 'sub MPI_SAS_IOUNIT0_DS_MAX_SATA_TARGETS () {(0x1000);}' unless defined(&MPI_SAS_IOUNIT0_DS_MAX_SATA_TARGETS);
    eval 'sub MPI_SAS_IOUNIT0_DS_MULTI_PORT_DOMAIN () {(0x2000);}' unless defined(&MPI_SAS_IOUNIT0_DS_MULTI_PORT_DOMAIN);
    unless(defined(&MPI_SAS_IOUNIT1_PHY_MAX)) {
	eval 'sub MPI_SAS_IOUNIT1_PHY_MAX () {(1);}' unless defined(&MPI_SAS_IOUNIT1_PHY_MAX);
    }
    eval 'sub MPI_SASIOUNITPAGE1_PAGEVERSION () {(0x7);}' unless defined(&MPI_SASIOUNITPAGE1_PAGEVERSION);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_DEVICE_SELF_TEST () {(0x8000);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_DEVICE_SELF_TEST);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_SATA_3_0_MAX () {(0x4000);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_SATA_3_0_MAX);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_SATA_1_5_MAX () {(0x2000);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_SATA_1_5_MAX);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_SATA_SW_PRESERVE () {(0x1000);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_SATA_SW_PRESERVE);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_DISABLE_SAS_HASH () {(0x800);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_DISABLE_SAS_HASH);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_MASK_DEV_SUPPORT () {(0x600);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_MASK_DEV_SUPPORT);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_SHIFT_DEV_SUPPORT () {(9);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_SHIFT_DEV_SUPPORT);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_DEV_SUPPORT_BOTH () {(0x);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_DEV_SUPPORT_BOTH);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_DEV_SAS_SUPPORT () {(0x1);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_DEV_SAS_SUPPORT);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_DEV_SATA_SUPPORT () {(0x2);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_DEV_SATA_SUPPORT);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_POSTPONE_SATA_INIT () {(0x100);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_POSTPONE_SATA_INIT);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_SATA_48BIT_LBA_REQUIRED () {(0x80);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_SATA_48BIT_LBA_REQUIRED);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_SATA_SMART_REQUIRED () {(0x40);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_SATA_SMART_REQUIRED);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_SATA_NCQ_REQUIRED () {(0x20);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_SATA_NCQ_REQUIRED);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_SATA_FUA_REQUIRED () {(0x10);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_SATA_FUA_REQUIRED);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_PHY_ENABLE_ORDER_HIGH () {(0x8);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_PHY_ENABLE_ORDER_HIGH);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_SUBTRACTIVE_ILLEGAL () {(0x4);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_SUBTRACTIVE_ILLEGAL);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_FIRST_LVL_DISC_ONLY () {(0x2);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_FIRST_LVL_DISC_ONLY);
    eval 'sub MPI_SAS_IOUNIT1_CONTROL_CLEAR_AFFILIATION () {(0x1);}' unless defined(&MPI_SAS_IOUNIT1_CONTROL_CLEAR_AFFILIATION);
    eval 'sub MPI_SAS_IOUNIT1_ACONTROL_MULTI_PORT_DOMAIN_ILLEGAL () {(0x80);}' unless defined(&MPI_SAS_IOUNIT1_ACONTROL_MULTI_PORT_DOMAIN_ILLEGAL);
    eval 'sub MPI_SAS_IOUNIT1_ACONTROL_SATA_ASYNCHROUNOUS_NOTIFICATION () {(0x40);}' unless defined(&MPI_SAS_IOUNIT1_ACONTROL_SATA_ASYNCHROUNOUS_NOTIFICATION);
    eval 'sub MPI_SAS_IOUNIT1_ACONTROL_HIDE_NONZERO_ATTACHED_PHY_IDENT () {(0x20);}' unless defined(&MPI_SAS_IOUNIT1_ACONTROL_HIDE_NONZERO_ATTACHED_PHY_IDENT);
    eval 'sub MPI_SAS_IOUNIT1_ACONTROL_PORT_ENABLE_ONLY_SATA_LINK_RESET () {(0x10);}' unless defined(&MPI_SAS_IOUNIT1_ACONTROL_PORT_ENABLE_ONLY_SATA_LINK_RESET);
    eval 'sub MPI_SAS_IOUNIT1_ACONTROL_OTHER_AFFILIATION_SATA_LINK_RESET () {(0x8);}' unless defined(&MPI_SAS_IOUNIT1_ACONTROL_OTHER_AFFILIATION_SATA_LINK_RESET);
    eval 'sub MPI_SAS_IOUNIT1_ACONTROL_SELF_AFFILIATION_SATA_LINK_RESET () {(0x4);}' unless defined(&MPI_SAS_IOUNIT1_ACONTROL_SELF_AFFILIATION_SATA_LINK_RESET);
    eval 'sub MPI_SAS_IOUNIT1_ACONTROL_NO_AFFILIATION_SATA_LINK_RESET () {(0x2);}' unless defined(&MPI_SAS_IOUNIT1_ACONTROL_NO_AFFILIATION_SATA_LINK_RESET);
    eval 'sub MPI_SAS_IOUNIT1_ACONTROL_ALLOW_TABLE_TO_TABLE () {(0x1);}' unless defined(&MPI_SAS_IOUNIT1_ACONTROL_ALLOW_TABLE_TO_TABLE);
    eval 'sub MPI_SAS_IOUNIT1_REPORT_MISSING_TIMEOUT_MASK () {(0x7f);}' unless defined(&MPI_SAS_IOUNIT1_REPORT_MISSING_TIMEOUT_MASK);
    eval 'sub MPI_SAS_IOUNIT1_REPORT_MISSING_UNIT_16 () {(0x80);}' unless defined(&MPI_SAS_IOUNIT1_REPORT_MISSING_UNIT_16);
    eval 'sub MPI_SAS_IOUNIT1_PORT_FLAGS_0_TARGET_IOC_NUM () {(0x);}' unless defined(&MPI_SAS_IOUNIT1_PORT_FLAGS_0_TARGET_IOC_NUM);
    eval 'sub MPI_SAS_IOUNIT1_PORT_FLAGS_1_TARGET_IOC_NUM () {(0x4);}' unless defined(&MPI_SAS_IOUNIT1_PORT_FLAGS_1_TARGET_IOC_NUM);
    eval 'sub MPI_SAS_IOUNIT1_PORT_FLAGS_AUTO_PORT_CONFIG () {(0x1);}' unless defined(&MPI_SAS_IOUNIT1_PORT_FLAGS_AUTO_PORT_CONFIG);
    eval 'sub MPI_SAS_IOUNIT1_PHY_FLAGS_PHY_DISABLE () {(0x4);}' unless defined(&MPI_SAS_IOUNIT1_PHY_FLAGS_PHY_DISABLE);
    eval 'sub MPI_SAS_IOUNIT1_PHY_FLAGS_TX_INVERT () {(0x2);}' unless defined(&MPI_SAS_IOUNIT1_PHY_FLAGS_TX_INVERT);
    eval 'sub MPI_SAS_IOUNIT1_PHY_FLAGS_RX_INVERT () {(0x1);}' unless defined(&MPI_SAS_IOUNIT1_PHY_FLAGS_RX_INVERT);
    eval 'sub MPI_SAS_IOUNIT1_MAX_RATE_MASK () {(0xf0);}' unless defined(&MPI_SAS_IOUNIT1_MAX_RATE_MASK);
    eval 'sub MPI_SAS_IOUNIT1_MAX_RATE_1_5 () {(0x80);}' unless defined(&MPI_SAS_IOUNIT1_MAX_RATE_1_5);
    eval 'sub MPI_SAS_IOUNIT1_MAX_RATE_3_0 () {(0x90);}' unless defined(&MPI_SAS_IOUNIT1_MAX_RATE_3_0);
    eval 'sub MPI_SAS_IOUNIT1_MIN_RATE_MASK () {(0xf);}' unless defined(&MPI_SAS_IOUNIT1_MIN_RATE_MASK);
    eval 'sub MPI_SAS_IOUNIT1_MIN_RATE_1_5 () {(0x8);}' unless defined(&MPI_SAS_IOUNIT1_MIN_RATE_1_5);
    eval 'sub MPI_SAS_IOUNIT1_MIN_RATE_3_0 () {(0x9);}' unless defined(&MPI_SAS_IOUNIT1_MIN_RATE_3_0);
    eval 'sub MPI_SASIOUNITPAGE2_PAGEVERSION () {(0x7);}' unless defined(&MPI_SASIOUNITPAGE2_PAGEVERSION);
    eval 'sub MPI_SAS_IOUNIT2_STATUS_DEVICE_LIMIT_EXCEEDED () {(0x8);}' unless defined(&MPI_SAS_IOUNIT2_STATUS_DEVICE_LIMIT_EXCEEDED);
    eval 'sub MPI_SAS_IOUNIT2_STATUS_ENCLOSURE_DEVICES_UNMAPPED () {(0x4);}' unless defined(&MPI_SAS_IOUNIT2_STATUS_ENCLOSURE_DEVICES_UNMAPPED);
    eval 'sub MPI_SAS_IOUNIT2_STATUS_DISABLED_PERSISTENT_MAPPINGS () {(0x2);}' unless defined(&MPI_SAS_IOUNIT2_STATUS_DISABLED_PERSISTENT_MAPPINGS);
    eval 'sub MPI_SAS_IOUNIT2_STATUS_FULL_PERSISTENT_MAPPINGS () {(0x1);}' unless defined(&MPI_SAS_IOUNIT2_STATUS_FULL_PERSISTENT_MAPPINGS);
    eval 'sub MPI_SAS_IOUNIT2_FLAGS_DISABLE_PERSISTENT_MAPPINGS () {(0x1);}' unless defined(&MPI_SAS_IOUNIT2_FLAGS_DISABLE_PERSISTENT_MAPPINGS);
    eval 'sub MPI_SAS_IOUNIT2_FLAGS_MASK_PHYS_MAP_MODE () {(0xe);}' unless defined(&MPI_SAS_IOUNIT2_FLAGS_MASK_PHYS_MAP_MODE);
    eval 'sub MPI_SAS_IOUNIT2_FLAGS_SHIFT_PHYS_MAP_MODE () {(1);}' unless defined(&MPI_SAS_IOUNIT2_FLAGS_SHIFT_PHYS_MAP_MODE);
    eval 'sub MPI_SAS_IOUNIT2_FLAGS_NO_PHYS_MAP () {(0x);}' unless defined(&MPI_SAS_IOUNIT2_FLAGS_NO_PHYS_MAP);
    eval 'sub MPI_SAS_IOUNIT2_FLAGS_DIRECT_ATTACH_PHYS_MAP () {(0x1);}' unless defined(&MPI_SAS_IOUNIT2_FLAGS_DIRECT_ATTACH_PHYS_MAP);
    eval 'sub MPI_SAS_IOUNIT2_FLAGS_ENCLOSURE_SLOT_PHYS_MAP () {(0x2);}' unless defined(&MPI_SAS_IOUNIT2_FLAGS_ENCLOSURE_SLOT_PHYS_MAP);
    eval 'sub MPI_SAS_IOUNIT2_FLAGS_HOST_ASSIGNED_PHYS_MAP () {(0x7);}' unless defined(&MPI_SAS_IOUNIT2_FLAGS_HOST_ASSIGNED_PHYS_MAP);
    eval 'sub MPI_SAS_IOUNIT2_FLAGS_RESERVE_ID_0_FOR_BOOT () {(0x10);}' unless defined(&MPI_SAS_IOUNIT2_FLAGS_RESERVE_ID_0_FOR_BOOT);
    eval 'sub MPI_SAS_IOUNIT2_FLAGS_DA_STARTING_SLOT () {(0x20);}' unless defined(&MPI_SAS_IOUNIT2_FLAGS_DA_STARTING_SLOT);
    eval 'sub MPI_SASIOUNITPAGE3_PAGEVERSION () {(0x);}' unless defined(&MPI_SASIOUNITPAGE3_PAGEVERSION);
    eval 'sub MPI_SASEXPANDER0_PAGEVERSION () {(0x3);}' unless defined(&MPI_SASEXPANDER0_PAGEVERSION);
    eval 'sub MPI_SAS_EXPANDER0_DS_LOOP_DETECTED () {(0x1);}' unless defined(&MPI_SAS_EXPANDER0_DS_LOOP_DETECTED);
    eval 'sub MPI_SAS_EXPANDER0_DS_UNADDRESSABLE_DEVICE () {(0x2);}' unless defined(&MPI_SAS_EXPANDER0_DS_UNADDRESSABLE_DEVICE);
    eval 'sub MPI_SAS_EXPANDER0_DS_MULTIPLE_PORTS () {(0x4);}' unless defined(&MPI_SAS_EXPANDER0_DS_MULTIPLE_PORTS);
    eval 'sub MPI_SAS_EXPANDER0_DS_EXPANDER_ERR () {(0x8);}' unless defined(&MPI_SAS_EXPANDER0_DS_EXPANDER_ERR);
    eval 'sub MPI_SAS_EXPANDER0_DS_SMP_TIMEOUT () {(0x10);}' unless defined(&MPI_SAS_EXPANDER0_DS_SMP_TIMEOUT);
    eval 'sub MPI_SAS_EXPANDER0_DS_OUT_ROUTE_ENTRIES () {(0x20);}' unless defined(&MPI_SAS_EXPANDER0_DS_OUT_ROUTE_ENTRIES);
    eval 'sub MPI_SAS_EXPANDER0_DS_INDEX_NOT_EXIST () {(0x40);}' unless defined(&MPI_SAS_EXPANDER0_DS_INDEX_NOT_EXIST);
    eval 'sub MPI_SAS_EXPANDER0_DS_SMP_FUNCTION_FAILED () {(0x80);}' unless defined(&MPI_SAS_EXPANDER0_DS_SMP_FUNCTION_FAILED);
    eval 'sub MPI_SAS_EXPANDER0_DS_SMP_CRC_ERROR () {(0x100);}' unless defined(&MPI_SAS_EXPANDER0_DS_SMP_CRC_ERROR);
    eval 'sub MPI_SAS_EXPANDER0_DS_SUBTRACTIVE_LINK () {(0x200);}' unless defined(&MPI_SAS_EXPANDER0_DS_SUBTRACTIVE_LINK);
    eval 'sub MPI_SAS_EXPANDER0_DS_TABLE_LINK () {(0x400);}' unless defined(&MPI_SAS_EXPANDER0_DS_TABLE_LINK);
    eval 'sub MPI_SAS_EXPANDER0_DS_UNSUPPORTED_DEVICE () {(0x800);}' unless defined(&MPI_SAS_EXPANDER0_DS_UNSUPPORTED_DEVICE);
    eval 'sub MPI_SAS_EXPANDER0_FLAGS_CONNECTOR_END_DEVICE () {(0x4);}' unless defined(&MPI_SAS_EXPANDER0_FLAGS_CONNECTOR_END_DEVICE);
    eval 'sub MPI_SAS_EXPANDER0_FLAGS_ROUTE_TABLE_CONFIG () {(0x2);}' unless defined(&MPI_SAS_EXPANDER0_FLAGS_ROUTE_TABLE_CONFIG);
    eval 'sub MPI_SAS_EXPANDER0_FLAGS_CONFIG_IN_PROGRESS () {(0x1);}' unless defined(&MPI_SAS_EXPANDER0_FLAGS_CONFIG_IN_PROGRESS);
    eval 'sub MPI_SASEXPANDER1_PAGEVERSION () {(0x1);}' unless defined(&MPI_SASEXPANDER1_PAGEVERSION);
    eval 'sub MPI_SAS_EXPANDER1_DISCINFO_BAD_PHY_DISABLED () {(0x4);}' unless defined(&MPI_SAS_EXPANDER1_DISCINFO_BAD_PHY_DISABLED);
    eval 'sub MPI_SAS_EXPANDER1_DISCINFO_LINK_STATUS_CHANGE () {(0x2);}' unless defined(&MPI_SAS_EXPANDER1_DISCINFO_LINK_STATUS_CHANGE);
    eval 'sub MPI_SAS_EXPANDER1_DISCINFO_NO_ROUTING_ENTRIES () {(0x1);}' unless defined(&MPI_SAS_EXPANDER1_DISCINFO_NO_ROUTING_ENTRIES);
    eval 'sub MPI_SAS_EXPANDER1_NEG_RATE_UNKNOWN () {(0x);}' unless defined(&MPI_SAS_EXPANDER1_NEG_RATE_UNKNOWN);
    eval 'sub MPI_SAS_EXPANDER1_NEG_RATE_PHY_DISABLED () {(0x1);}' unless defined(&MPI_SAS_EXPANDER1_NEG_RATE_PHY_DISABLED);
    eval 'sub MPI_SAS_EXPANDER1_NEG_RATE_FAILED_NEGOTIATION () {(0x2);}' unless defined(&MPI_SAS_EXPANDER1_NEG_RATE_FAILED_NEGOTIATION);
    eval 'sub MPI_SAS_EXPANDER1_NEG_RATE_SATA_OOB_COMPLETE () {(0x3);}' unless defined(&MPI_SAS_EXPANDER1_NEG_RATE_SATA_OOB_COMPLETE);
    eval 'sub MPI_SAS_EXPANDER1_NEG_RATE_1_5 () {(0x8);}' unless defined(&MPI_SAS_EXPANDER1_NEG_RATE_1_5);
    eval 'sub MPI_SAS_EXPANDER1_NEG_RATE_3_0 () {(0x9);}' unless defined(&MPI_SAS_EXPANDER1_NEG_RATE_3_0);
    eval 'sub MPI_SASDEVICE0_PAGEVERSION () {(0x5);}' unless defined(&MPI_SASDEVICE0_PAGEVERSION);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_NO_ERRORS () {(0x);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_NO_ERRORS);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SATA_INIT_FAILED () {(0x1);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SATA_INIT_FAILED);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SATA_CAPABILITY_FAILED () {(0x2);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SATA_CAPABILITY_FAILED);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SATA_AFFILIATION_CONFLICT () {(0x3);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SATA_AFFILIATION_CONFLICT);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SATA_NEEDS_INITIALIZATION () {(0x4);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SATA_NEEDS_INITIALIZATION);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SIF_UNKNOWN () {(0x10);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SIF_UNKNOWN);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SIF_AFFILIATION_CONFLICT () {(0x11);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SIF_AFFILIATION_CONFLICT);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SIF_DIAG () {(0x12);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SIF_DIAG);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SIF_IDENTIFICATION () {(0x13);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SIF_IDENTIFICATION);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SIF_CHECK_POWER () {(0x14);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SIF_CHECK_POWER);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SIF_PIO_SN () {(0x15);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SIF_PIO_SN);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SIF_MDMA_SN () {(0x16);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SIF_MDMA_SN);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SIF_UDMA_SN () {(0x17);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SIF_UDMA_SN);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SIF_ZONING_VIOLATION () {(0x18);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SIF_ZONING_VIOLATION);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SIF_NOT_ADDRESSABLE () {(0x19);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SIF_NOT_ADDRESSABLE);
    eval 'sub MPI_SAS_DEVICE0_ASTATUS_SIF_MAX () {(0x1f);}' unless defined(&MPI_SAS_DEVICE0_ASTATUS_SIF_MAX);
    eval 'sub MPI_SAS_DEVICE0_FLAGS_SATA_ASYNCHRONOUS_NOTIFY () {(0x400);}' unless defined(&MPI_SAS_DEVICE0_FLAGS_SATA_ASYNCHRONOUS_NOTIFY);
    eval 'sub MPI_SAS_DEVICE0_FLAGS_SATA_SW_PRESERVE () {(0x200);}' unless defined(&MPI_SAS_DEVICE0_FLAGS_SATA_SW_PRESERVE);
    eval 'sub MPI_SAS_DEVICE0_FLAGS_UNSUPPORTED_DEVICE () {(0x100);}' unless defined(&MPI_SAS_DEVICE0_FLAGS_UNSUPPORTED_DEVICE);
    eval 'sub MPI_SAS_DEVICE0_FLAGS_SATA_48BIT_LBA_SUPPORTED () {(0x80);}' unless defined(&MPI_SAS_DEVICE0_FLAGS_SATA_48BIT_LBA_SUPPORTED);
    eval 'sub MPI_SAS_DEVICE0_FLAGS_SATA_SMART_SUPPORTED () {(0x40);}' unless defined(&MPI_SAS_DEVICE0_FLAGS_SATA_SMART_SUPPORTED);
    eval 'sub MPI_SAS_DEVICE0_FLAGS_SATA_NCQ_SUPPORTED () {(0x20);}' unless defined(&MPI_SAS_DEVICE0_FLAGS_SATA_NCQ_SUPPORTED);
    eval 'sub MPI_SAS_DEVICE0_FLAGS_SATA_FUA_SUPPORTED () {(0x10);}' unless defined(&MPI_SAS_DEVICE0_FLAGS_SATA_FUA_SUPPORTED);
    eval 'sub MPI_SAS_DEVICE0_FLAGS_PORT_SELECTOR_ATTACH () {(0x8);}' unless defined(&MPI_SAS_DEVICE0_FLAGS_PORT_SELECTOR_ATTACH);
    eval 'sub MPI_SAS_DEVICE0_FLAGS_MAPPING_PERSISTENT () {(0x4);}' unless defined(&MPI_SAS_DEVICE0_FLAGS_MAPPING_PERSISTENT);
    eval 'sub MPI_SAS_DEVICE0_FLAGS_DEVICE_MAPPED () {(0x2);}' unless defined(&MPI_SAS_DEVICE0_FLAGS_DEVICE_MAPPED);
    eval 'sub MPI_SAS_DEVICE0_FLAGS_DEVICE_PRESENT () {(0x1);}' unless defined(&MPI_SAS_DEVICE0_FLAGS_DEVICE_PRESENT);
    eval 'sub MPI_SASDEVICE1_PAGEVERSION () {(0x);}' unless defined(&MPI_SASDEVICE1_PAGEVERSION);
    eval 'sub MPI_SASDEVICE2_PAGEVERSION () {(0x1);}' unless defined(&MPI_SASDEVICE2_PAGEVERSION);
    eval 'sub MPI_SASDEVICE2_ENC_MAP_MASK_MISSING_COUNT () {(0xf);}' unless defined(&MPI_SASDEVICE2_ENC_MAP_MASK_MISSING_COUNT);
    eval 'sub MPI_SASDEVICE2_ENC_MAP_SHIFT_MISSING_COUNT () {(0);}' unless defined(&MPI_SASDEVICE2_ENC_MAP_SHIFT_MISSING_COUNT);
    eval 'sub MPI_SASDEVICE2_ENC_MAP_MASK_NUM_SLOTS () {(0x7f0);}' unless defined(&MPI_SASDEVICE2_ENC_MAP_MASK_NUM_SLOTS);
    eval 'sub MPI_SASDEVICE2_ENC_MAP_SHIFT_NUM_SLOTS () {(4);}' unless defined(&MPI_SASDEVICE2_ENC_MAP_SHIFT_NUM_SLOTS);
    eval 'sub MPI_SASDEVICE2_ENC_MAP_MASK_START_INDEX () {(0x1ff800);}' unless defined(&MPI_SASDEVICE2_ENC_MAP_MASK_START_INDEX);
    eval 'sub MPI_SASDEVICE2_ENC_MAP_SHIFT_START_INDEX () {(11);}' unless defined(&MPI_SASDEVICE2_ENC_MAP_SHIFT_START_INDEX);
    eval 'sub MPI_SASPHY0_PAGEVERSION () {(0x1);}' unless defined(&MPI_SASPHY0_PAGEVERSION);
    eval 'sub MPI_SAS_PHY0_PRATE_MAX_RATE_MASK () {(0xf0);}' unless defined(&MPI_SAS_PHY0_PRATE_MAX_RATE_MASK);
    eval 'sub MPI_SAS_PHY0_PRATE_MAX_RATE_NOT_PROGRAMMABLE () {(0x);}' unless defined(&MPI_SAS_PHY0_PRATE_MAX_RATE_NOT_PROGRAMMABLE);
    eval 'sub MPI_SAS_PHY0_PRATE_MAX_RATE_1_5 () {(0x80);}' unless defined(&MPI_SAS_PHY0_PRATE_MAX_RATE_1_5);
    eval 'sub MPI_SAS_PHY0_PRATE_MAX_RATE_3_0 () {(0x90);}' unless defined(&MPI_SAS_PHY0_PRATE_MAX_RATE_3_0);
    eval 'sub MPI_SAS_PHY0_PRATE_MIN_RATE_MASK () {(0xf);}' unless defined(&MPI_SAS_PHY0_PRATE_MIN_RATE_MASK);
    eval 'sub MPI_SAS_PHY0_PRATE_MIN_RATE_NOT_PROGRAMMABLE () {(0x);}' unless defined(&MPI_SAS_PHY0_PRATE_MIN_RATE_NOT_PROGRAMMABLE);
    eval 'sub MPI_SAS_PHY0_PRATE_MIN_RATE_1_5 () {(0x8);}' unless defined(&MPI_SAS_PHY0_PRATE_MIN_RATE_1_5);
    eval 'sub MPI_SAS_PHY0_PRATE_MIN_RATE_3_0 () {(0x9);}' unless defined(&MPI_SAS_PHY0_PRATE_MIN_RATE_3_0);
    eval 'sub MPI_SAS_PHY0_HWRATE_MAX_RATE_MASK () {(0xf0);}' unless defined(&MPI_SAS_PHY0_HWRATE_MAX_RATE_MASK);
    eval 'sub MPI_SAS_PHY0_HWRATE_MAX_RATE_1_5 () {(0x80);}' unless defined(&MPI_SAS_PHY0_HWRATE_MAX_RATE_1_5);
    eval 'sub MPI_SAS_PHY0_HWRATE_MAX_RATE_3_0 () {(0x90);}' unless defined(&MPI_SAS_PHY0_HWRATE_MAX_RATE_3_0);
    eval 'sub MPI_SAS_PHY0_HWRATE_MIN_RATE_MASK () {(0xf);}' unless defined(&MPI_SAS_PHY0_HWRATE_MIN_RATE_MASK);
    eval 'sub MPI_SAS_PHY0_HWRATE_MIN_RATE_1_5 () {(0x8);}' unless defined(&MPI_SAS_PHY0_HWRATE_MIN_RATE_1_5);
    eval 'sub MPI_SAS_PHY0_HWRATE_MIN_RATE_3_0 () {(0x9);}' unless defined(&MPI_SAS_PHY0_HWRATE_MIN_RATE_3_0);
    eval 'sub MPI_SAS_PHY0_FLAGS_SGPIO_DIRECT_ATTACH_ENC () {(0x1);}' unless defined(&MPI_SAS_PHY0_FLAGS_SGPIO_DIRECT_ATTACH_ENC);
    eval 'sub MPI_SAS_PHY0_PHYINFO_PHY_VACANT () {(0x80000000);}' unless defined(&MPI_SAS_PHY0_PHYINFO_PHY_VACANT);
    eval 'sub MPI_SAS_PHY0_PHYINFO_SATA_PORT_ACTIVE () {(0x4000);}' unless defined(&MPI_SAS_PHY0_PHYINFO_SATA_PORT_ACTIVE);
    eval 'sub MPI_SAS_PHY0_PHYINFO_SATA_PORT_SELECTOR () {(0x2000);}' unless defined(&MPI_SAS_PHY0_PHYINFO_SATA_PORT_SELECTOR);
    eval 'sub MPI_SAS_PHY0_PHYINFO_VIRTUAL_PHY () {(0x1000);}' unless defined(&MPI_SAS_PHY0_PHYINFO_VIRTUAL_PHY);
    eval 'sub MPI_SAS_PHY0_PHYINFO_MASK_PARTIAL_PATHWAY_TIME () {(0xf00);}' unless defined(&MPI_SAS_PHY0_PHYINFO_MASK_PARTIAL_PATHWAY_TIME);
    eval 'sub MPI_SAS_PHY0_PHYINFO_SHIFT_PARTIAL_PATHWAY_TIME () {(8);}' unless defined(&MPI_SAS_PHY0_PHYINFO_SHIFT_PARTIAL_PATHWAY_TIME);
    eval 'sub MPI_SAS_PHY0_PHYINFO_MASK_ROUTING_ATTRIBUTE () {(0xf0);}' unless defined(&MPI_SAS_PHY0_PHYINFO_MASK_ROUTING_ATTRIBUTE);
    eval 'sub MPI_SAS_PHY0_PHYINFO_DIRECT_ROUTING () {(0x);}' unless defined(&MPI_SAS_PHY0_PHYINFO_DIRECT_ROUTING);
    eval 'sub MPI_SAS_PHY0_PHYINFO_SUBTRACTIVE_ROUTING () {(0x10);}' unless defined(&MPI_SAS_PHY0_PHYINFO_SUBTRACTIVE_ROUTING);
    eval 'sub MPI_SAS_PHY0_PHYINFO_TABLE_ROUTING () {(0x20);}' unless defined(&MPI_SAS_PHY0_PHYINFO_TABLE_ROUTING);
    eval 'sub MPI_SAS_PHY0_PHYINFO_MASK_LINK_RATE () {(0xf);}' unless defined(&MPI_SAS_PHY0_PHYINFO_MASK_LINK_RATE);
    eval 'sub MPI_SAS_PHY0_PHYINFO_UNKNOWN_LINK_RATE () {(0x);}' unless defined(&MPI_SAS_PHY0_PHYINFO_UNKNOWN_LINK_RATE);
    eval 'sub MPI_SAS_PHY0_PHYINFO_PHY_DISABLED () {(0x1);}' unless defined(&MPI_SAS_PHY0_PHYINFO_PHY_DISABLED);
    eval 'sub MPI_SAS_PHY0_PHYINFO_NEGOTIATION_FAILED () {(0x2);}' unless defined(&MPI_SAS_PHY0_PHYINFO_NEGOTIATION_FAILED);
    eval 'sub MPI_SAS_PHY0_PHYINFO_SATA_OOB_COMPLETE () {(0x3);}' unless defined(&MPI_SAS_PHY0_PHYINFO_SATA_OOB_COMPLETE);
    eval 'sub MPI_SAS_PHY0_PHYINFO_RATE_1_5 () {(0x8);}' unless defined(&MPI_SAS_PHY0_PHYINFO_RATE_1_5);
    eval 'sub MPI_SAS_PHY0_PHYINFO_RATE_3_0 () {(0x9);}' unless defined(&MPI_SAS_PHY0_PHYINFO_RATE_3_0);
    eval 'sub MPI_SASPHY1_PAGEVERSION () {(0x);}' unless defined(&MPI_SASPHY1_PAGEVERSION);
    eval 'sub MPI_SASENCLOSURE0_PAGEVERSION () {(0x1);}' unless defined(&MPI_SASENCLOSURE0_PAGEVERSION);
    eval 'sub MPI_SAS_ENCLS0_FLAGS_SEP_BUS_ID_VALID () {(0x20);}' unless defined(&MPI_SAS_ENCLS0_FLAGS_SEP_BUS_ID_VALID);
    eval 'sub MPI_SAS_ENCLS0_FLAGS_START_BUS_ID_VALID () {(0x10);}' unless defined(&MPI_SAS_ENCLS0_FLAGS_START_BUS_ID_VALID);
    eval 'sub MPI_SAS_ENCLS0_FLAGS_MNG_MASK () {(0xf);}' unless defined(&MPI_SAS_ENCLS0_FLAGS_MNG_MASK);
    eval 'sub MPI_SAS_ENCLS0_FLAGS_MNG_UNKNOWN () {(0x);}' unless defined(&MPI_SAS_ENCLS0_FLAGS_MNG_UNKNOWN);
    eval 'sub MPI_SAS_ENCLS0_FLAGS_MNG_IOC_SES () {(0x1);}' unless defined(&MPI_SAS_ENCLS0_FLAGS_MNG_IOC_SES);
    eval 'sub MPI_SAS_ENCLS0_FLAGS_MNG_IOC_SGPIO () {(0x2);}' unless defined(&MPI_SAS_ENCLS0_FLAGS_MNG_IOC_SGPIO);
    eval 'sub MPI_SAS_ENCLS0_FLAGS_MNG_EXP_SGPIO () {(0x3);}' unless defined(&MPI_SAS_ENCLS0_FLAGS_MNG_EXP_SGPIO);
    eval 'sub MPI_SAS_ENCLS0_FLAGS_MNG_SES_ENCLOSURE () {(0x4);}' unless defined(&MPI_SAS_ENCLS0_FLAGS_MNG_SES_ENCLOSURE);
    eval 'sub MPI_SAS_ENCLS0_FLAGS_MNG_IOC_GPIO () {(0x5);}' unless defined(&MPI_SAS_ENCLS0_FLAGS_MNG_IOC_GPIO);
    unless(defined(&MPI_LOG_0_NUM_LOG_ENTRIES)) {
	eval 'sub MPI_LOG_0_NUM_LOG_ENTRIES () {(1);}' unless defined(&MPI_LOG_0_NUM_LOG_ENTRIES);
    }
    eval 'sub MPI_LOG_0_LOG_DATA_LENGTH () {(0x1c);}' unless defined(&MPI_LOG_0_LOG_DATA_LENGTH);
    eval 'sub MPI_LOG_0_ENTRY_QUAL_ENTRY_UNUSED () {(0x);}' unless defined(&MPI_LOG_0_ENTRY_QUAL_ENTRY_UNUSED);
    eval 'sub MPI_LOG_0_ENTRY_QUAL_POWER_ON_RESET () {(0x1);}' unless defined(&MPI_LOG_0_ENTRY_QUAL_POWER_ON_RESET);
    eval 'sub MPI_LOG_0_PAGEVERSION () {(0x1);}' unless defined(&MPI_LOG_0_PAGEVERSION);
}
1;
