require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MPI_FC_H)) {
    eval 'sub MPI_FC_H () {1;}' unless defined(&MPI_FC_H);
    eval 'sub LINK_SERVICE_BUFFER_POST_FLAGS_PORT_MASK () {(0x1);}' unless defined(&LINK_SERVICE_BUFFER_POST_FLAGS_PORT_MASK);
    eval 'sub MPI_LS_BUF_POST_REPLY_FLAG_NO_RSP_NEEDED () {(0x80);}' unless defined(&MPI_LS_BUF_POST_REPLY_FLAG_NO_RSP_NEEDED);
    eval 'sub MPI_FC_DID_MASK () {(0xffffff);}' unless defined(&MPI_FC_DID_MASK);
    eval 'sub MPI_FC_DID_SHIFT () {(0);}' unless defined(&MPI_FC_DID_SHIFT);
    eval 'sub MPI_FC_RCTL_MASK () {(0xff000000);}' unless defined(&MPI_FC_RCTL_MASK);
    eval 'sub MPI_FC_RCTL_SHIFT () {(24);}' unless defined(&MPI_FC_RCTL_SHIFT);
    eval 'sub MPI_FC_SID_MASK () {(0xffffff);}' unless defined(&MPI_FC_SID_MASK);
    eval 'sub MPI_FC_SID_SHIFT () {(0);}' unless defined(&MPI_FC_SID_SHIFT);
    eval 'sub MPI_FC_CSCTL_MASK () {(0xff000000);}' unless defined(&MPI_FC_CSCTL_MASK);
    eval 'sub MPI_FC_CSCTL_SHIFT () {(24);}' unless defined(&MPI_FC_CSCTL_SHIFT);
    eval 'sub MPI_FC_FCTL_MASK () {(0xffffff);}' unless defined(&MPI_FC_FCTL_MASK);
    eval 'sub MPI_FC_FCTL_SHIFT () {(0);}' unless defined(&MPI_FC_FCTL_SHIFT);
    eval 'sub MPI_FC_TYPE_MASK () {(0xff000000);}' unless defined(&MPI_FC_TYPE_MASK);
    eval 'sub MPI_FC_TYPE_SHIFT () {(24);}' unless defined(&MPI_FC_TYPE_SHIFT);
    eval 'sub FCP_TARGET_DID_MASK () {(0xffffff);}' unless defined(&FCP_TARGET_DID_MASK);
    eval 'sub FCP_TARGET_DID_SHIFT () {(0);}' unless defined(&FCP_TARGET_DID_SHIFT);
    eval 'sub FCP_TARGET_RCTL_MASK () {(0xff000000);}' unless defined(&FCP_TARGET_RCTL_MASK);
    eval 'sub FCP_TARGET_RCTL_SHIFT () {(24);}' unless defined(&FCP_TARGET_RCTL_SHIFT);
    eval 'sub FCP_TARGET_SID_MASK () {(0xffffff);}' unless defined(&FCP_TARGET_SID_MASK);
    eval 'sub FCP_TARGET_SID_SHIFT () {(0);}' unless defined(&FCP_TARGET_SID_SHIFT);
    eval 'sub FCP_TARGET_CSCTL_MASK () {(0xff000000);}' unless defined(&FCP_TARGET_CSCTL_MASK);
    eval 'sub FCP_TARGET_CSCTL_SHIFT () {(24);}' unless defined(&FCP_TARGET_CSCTL_SHIFT);
    eval 'sub FCP_TARGET_FCTL_MASK () {(0xffffff);}' unless defined(&FCP_TARGET_FCTL_MASK);
    eval 'sub FCP_TARGET_FCTL_SHIFT () {(0);}' unless defined(&FCP_TARGET_FCTL_SHIFT);
    eval 'sub FCP_TARGET_TYPE_MASK () {(0xff000000);}' unless defined(&FCP_TARGET_TYPE_MASK);
    eval 'sub FCP_TARGET_TYPE_SHIFT () {(24);}' unless defined(&FCP_TARGET_TYPE_SHIFT);
    eval 'sub LINK_SERVICE_RSP_FLAGS_IMMEDIATE () {(0x80);}' unless defined(&LINK_SERVICE_RSP_FLAGS_IMMEDIATE);
    eval 'sub LINK_SERVICE_RSP_FLAGS_PORT_MASK () {(0x1);}' unless defined(&LINK_SERVICE_RSP_FLAGS_PORT_MASK);
    eval 'sub EX_LINK_SERVICE_SEND_DID_MASK () {(0xffffff);}' unless defined(&EX_LINK_SERVICE_SEND_DID_MASK);
    eval 'sub EX_LINK_SERVICE_SEND_DID_SHIFT () {(0);}' unless defined(&EX_LINK_SERVICE_SEND_DID_SHIFT);
    eval 'sub EX_LINK_SERVICE_SEND_MSGFLAGS_MASK () {(0xff000000);}' unless defined(&EX_LINK_SERVICE_SEND_MSGFLAGS_MASK);
    eval 'sub EX_LINK_SERVICE_SEND_MSGFLAGS_SHIFT () {(24);}' unless defined(&EX_LINK_SERVICE_SEND_MSGFLAGS_SHIFT);
    eval 'sub FC_ABORT_FLAG_PORT_MASK () {(0x1);}' unless defined(&FC_ABORT_FLAG_PORT_MASK);
    eval 'sub FC_ABORT_TYPE_ALL_FC_BUFFERS () {(0x);}' unless defined(&FC_ABORT_TYPE_ALL_FC_BUFFERS);
    eval 'sub FC_ABORT_TYPE_EXACT_FC_BUFFER () {(0x1);}' unless defined(&FC_ABORT_TYPE_EXACT_FC_BUFFER);
    eval 'sub FC_ABORT_TYPE_CT_SEND_REQUEST () {(0x2);}' unless defined(&FC_ABORT_TYPE_CT_SEND_REQUEST);
    eval 'sub FC_ABORT_TYPE_EXLINKSEND_REQUEST () {(0x3);}' unless defined(&FC_ABORT_TYPE_EXLINKSEND_REQUEST);
    eval 'sub MPI_FC_CT_SEND_DID_MASK () {(0xffffff);}' unless defined(&MPI_FC_CT_SEND_DID_MASK);
    eval 'sub MPI_FC_CT_SEND_DID_SHIFT () {(0);}' unless defined(&MPI_FC_CT_SEND_DID_SHIFT);
    eval 'sub MPI_FC_CT_SEND_MSGFLAGS_MASK () {(0xff000000);}' unless defined(&MPI_FC_CT_SEND_MSGFLAGS_MASK);
    eval 'sub MPI_FC_CT_SEND_MSGFLAGS_SHIFT () {(24);}' unless defined(&MPI_FC_CT_SEND_MSGFLAGS_SHIFT);
    eval 'sub MPI_FC_PRIM_SEND_FLAGS_PORT_MASK () {(0x1);}' unless defined(&MPI_FC_PRIM_SEND_FLAGS_PORT_MASK);
    eval 'sub MPI_FC_PRIM_SEND_FLAGS_ML_RESET_LINK () {(0x2);}' unless defined(&MPI_FC_PRIM_SEND_FLAGS_ML_RESET_LINK);
    eval 'sub MPI_FC_PRIM_SEND_FLAGS_RESET_LINK () {(0x4);}' unless defined(&MPI_FC_PRIM_SEND_FLAGS_RESET_LINK);
    eval 'sub MPI_FC_PRIM_SEND_FLAGS_STOP_SEND () {(0x8);}' unless defined(&MPI_FC_PRIM_SEND_FLAGS_STOP_SEND);
    eval 'sub MPI_FC_PRIM_SEND_FLAGS_SEND_ONCE () {(0x10);}' unless defined(&MPI_FC_PRIM_SEND_FLAGS_SEND_ONCE);
    eval 'sub MPI_FC_PRIM_SEND_FLAGS_SEND_AROUND () {(0x20);}' unless defined(&MPI_FC_PRIM_SEND_FLAGS_SEND_AROUND);
    eval 'sub MPI_FC_PRIM_SEND_FLAGS_UNTIL_FULL () {(0x40);}' unless defined(&MPI_FC_PRIM_SEND_FLAGS_UNTIL_FULL);
    eval 'sub MPI_FC_PRIM_SEND_FLAGS_FOREVER () {(0x80);}' unless defined(&MPI_FC_PRIM_SEND_FLAGS_FOREVER);
}
1;
