require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&IOPI_IOCLOGINFO_H_INCLUDED)) {
    eval 'sub IOPI_IOCLOGINFO_H_INCLUDED () {1;}' unless defined(&IOPI_IOCLOGINFO_H_INCLUDED);
    eval 'sub SAS_LOGINFO_NEXUS_LOSS () {0x31170000;}' unless defined(&SAS_LOGINFO_NEXUS_LOSS);
    eval 'sub SAS_LOGINFO_MASK () {0xffff0000;}' unless defined(&SAS_LOGINFO_MASK);
    eval 'sub IOC_LOGINFO_ORIGINATOR_IOP () {(0x);}' unless defined(&IOC_LOGINFO_ORIGINATOR_IOP);
    eval 'sub IOC_LOGINFO_ORIGINATOR_PL () {(0x1000000);}' unless defined(&IOC_LOGINFO_ORIGINATOR_PL);
    eval 'sub IOC_LOGINFO_ORIGINATOR_IR () {(0x2000000);}' unless defined(&IOC_LOGINFO_ORIGINATOR_IR);
    eval 'sub IOC_LOGINFO_ORIGINATOR_MASK () {(0xf000000);}' unless defined(&IOC_LOGINFO_ORIGINATOR_MASK);
    eval 'sub IOC_LOGINFO_CODE_MASK () {(0xff0000);}' unless defined(&IOC_LOGINFO_CODE_MASK);
    eval 'sub IOC_LOGINFO_CODE_SHIFT () {(16);}' unless defined(&IOC_LOGINFO_CODE_SHIFT);
    eval 'sub IOP_LOGINFO_CODE_INVALID_SAS_ADDRESS () {(0x10000);}' unless defined(&IOP_LOGINFO_CODE_INVALID_SAS_ADDRESS);
    eval 'sub IOP_LOGINFO_CODE_UNUSED2 () {(0x20000);}' unless defined(&IOP_LOGINFO_CODE_UNUSED2);
    eval 'sub IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE () {(0x30000);}' unless defined(&IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE);
    eval 'sub IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_RT () {(0x30100);}' unless defined(&IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_RT);
    eval 'sub IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_PN () {(0x30200);}' unless defined(&IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_PN);
    eval 'sub IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_FORM () {(0x30300);}' unless defined(&IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_FORM);
    eval 'sub IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_PT () {(0x30400);}' unless defined(&IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_PT);
    eval 'sub IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_DNM () {(0x30500);}' unless defined(&IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_DNM);
    eval 'sub IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_PERSIST () {(0x30600);}' unless defined(&IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_PERSIST);
    eval 'sub IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_DEFAULT () {(0x30700);}' unless defined(&IOP_LOGINFO_CODE_CONFIG_INVALID_PAGE_DEFAULT);
    eval 'sub IOP_LOGINFO_CODE_FWUPLOAD_NO_FLASH_AVAILABLE () {(0x3e000);}' unless defined(&IOP_LOGINFO_CODE_FWUPLOAD_NO_FLASH_AVAILABLE);
    eval 'sub IOP_LOGINFO_CODE_FWUPLOAD_UNKNOWN_IMAGE_TYPE () {(0x3e001);}' unless defined(&IOP_LOGINFO_CODE_FWUPLOAD_UNKNOWN_IMAGE_TYPE);
    eval 'sub IOP_LOGINFO_CODE_FWUPLOAD_WRONG_IMAGE_SIZE () {(0x3e002);}' unless defined(&IOP_LOGINFO_CODE_FWUPLOAD_WRONG_IMAGE_SIZE);
    eval 'sub IOP_LOGINFO_CODE_FWUPLOAD_ENTIRE_FLASH_UPLOAD_FAILED () {(0x3e003);}' unless defined(&IOP_LOGINFO_CODE_FWUPLOAD_ENTIRE_FLASH_UPLOAD_FAILED);
    eval 'sub IOP_LOGINFO_CODE_FWUPLOAD_REGION_UPLOAD_FAILED () {(0x3e004);}' unless defined(&IOP_LOGINFO_CODE_FWUPLOAD_REGION_UPLOAD_FAILED);
    eval 'sub IOP_LOGINFO_CODE_FWUPLOAD_DMA_FAILURE () {(0x3e005);}' unless defined(&IOP_LOGINFO_CODE_FWUPLOAD_DMA_FAILURE);
    eval 'sub IOP_LOGINFO_CODE_DIAG_MSG_ERROR () {(0x40000);}' unless defined(&IOP_LOGINFO_CODE_DIAG_MSG_ERROR);
    eval 'sub IOP_LOGINFO_CODE_TASK_TERMINATED () {(0x50000);}' unless defined(&IOP_LOGINFO_CODE_TASK_TERMINATED);
    eval 'sub IOP_LOGINFO_CODE_ENCL_MGMT_READ_ACTION_ERR0R () {(0x60001);}' unless defined(&IOP_LOGINFO_CODE_ENCL_MGMT_READ_ACTION_ERR0R);
    eval 'sub IOP_LOGINFO_CODE_ENCL_MGMT_INVALID_BUS_ID_ERR0R () {(0x60002);}' unless defined(&IOP_LOGINFO_CODE_ENCL_MGMT_INVALID_BUS_ID_ERR0R);
    eval 'sub IOP_LOGINFO_CODE_TARGET_ASSIST_TERMINATED () {(0x70001);}' unless defined(&IOP_LOGINFO_CODE_TARGET_ASSIST_TERMINATED);
    eval 'sub IOP_LOGINFO_CODE_TARGET_STATUS_SEND_TERMINATED () {(0x70002);}' unless defined(&IOP_LOGINFO_CODE_TARGET_STATUS_SEND_TERMINATED);
    eval 'sub IOP_LOGINFO_CODE_TARGET_MODE_ABORT_ALL_IO () {(0x70003);}' unless defined(&IOP_LOGINFO_CODE_TARGET_MODE_ABORT_ALL_IO);
    eval 'sub IOP_LOGINFO_CODE_TARGET_MODE_ABORT_EXACT_IO () {(0x70004);}' unless defined(&IOP_LOGINFO_CODE_TARGET_MODE_ABORT_EXACT_IO);
    eval 'sub IOP_LOGINFO_CODE_TARGET_MODE_ABORT_EXACT_IO_REQ () {(0x70005);}' unless defined(&IOP_LOGINFO_CODE_TARGET_MODE_ABORT_EXACT_IO_REQ);
    eval 'sub IOP_LOGINFO_CODE_LOG_TIMESTAMP_EVENT () {(0x80000);}' unless defined(&IOP_LOGINFO_CODE_LOG_TIMESTAMP_EVENT);
    eval 'sub PL_LOGINFO_CODE_OPEN_FAILURE () {(0x10000);}' unless defined(&PL_LOGINFO_CODE_OPEN_FAILURE);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_NO_DEST_TIME_OUT () {(0x1);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_NO_DEST_TIME_OUT);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_PATHWAY_BLOCKED () {(0x2);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_PATHWAY_BLOCKED);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_CONTINUE0 () {(0x3);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_CONTINUE0);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_CONTINUE1 () {(0x4);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_CONTINUE1);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_INITIALIZE0 () {(0x5);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_INITIALIZE0);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_INITIALIZE1 () {(0x6);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_INITIALIZE1);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_STOP0 () {(0x7);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_STOP0);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_STOP1 () {(0x8);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RES_STOP1);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RETRY () {(0x9);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RETRY);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_BREAK () {(0xa);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_BREAK);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_UNUSED_0B () {(0xb);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_UNUSED_0B);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_OPEN_TIMEOUT_EXP () {(0xc);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_OPEN_TIMEOUT_EXP);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_UNUSED_0D () {(0xd);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_UNUSED_0D);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_DVTBLE_ACCSS_FAIL () {(0xe);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_DVTBLE_ACCSS_FAIL);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_BAD_DEST () {(0x11);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_BAD_DEST);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RATE_NOT_SUPP () {(0x12);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RATE_NOT_SUPP);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_PROT_NOT_SUPP () {(0x13);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_PROT_NOT_SUPP);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RESERVED_ABANDON0 () {(0x14);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RESERVED_ABANDON0);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RESERVED_ABANDON1 () {(0x15);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RESERVED_ABANDON1);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RESERVED_ABANDON2 () {(0x16);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RESERVED_ABANDON2);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_RESERVED_ABANDON3 () {(0x17);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_RESERVED_ABANDON3);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_STP_RESOURCES_BSY () {(0x18);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_STP_RESOURCES_BSY);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_WRONG_DESTINATION () {(0x19);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_WRONG_DESTINATION);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_PATH_BLOCKED () {(0x1b);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_PATH_BLOCKED);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAIL_AWT_MAXED () {(0x1c);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAIL_AWT_MAXED);
    eval 'sub PL_LOGINFO_CODE_INVALID_SGL () {(0x20000);}' unless defined(&PL_LOGINFO_CODE_INVALID_SGL);
    eval 'sub PL_LOGINFO_CODE_WRONG_REL_OFF_OR_FRAME_LENGTH () {(0x30000);}' unless defined(&PL_LOGINFO_CODE_WRONG_REL_OFF_OR_FRAME_LENGTH);
    eval 'sub PL_LOGINFO_CODE_FRAME_XFER_ERROR () {(0x40000);}' unless defined(&PL_LOGINFO_CODE_FRAME_XFER_ERROR);
    eval 'sub PL_LOGINFO_CODE_TX_FM_CONNECTED_LOW () {(0x50000);}' unless defined(&PL_LOGINFO_CODE_TX_FM_CONNECTED_LOW);
    eval 'sub PL_LOGINFO_CODE_SATA_NON_NCQ_RW_ERR_BIT_SET () {(0x60000);}' unless defined(&PL_LOGINFO_CODE_SATA_NON_NCQ_RW_ERR_BIT_SET);
    eval 'sub PL_LOGINFO_CODE_SATA_READ_LOG_RECEIVE_DATA_ERR () {(0x70000);}' unless defined(&PL_LOGINFO_CODE_SATA_READ_LOG_RECEIVE_DATA_ERR);
    eval 'sub PL_LOGINFO_CODE_SATA_NCQ_FAIL_ALL_CMDS_AFTR_ERR () {(0x80000);}' unless defined(&PL_LOGINFO_CODE_SATA_NCQ_FAIL_ALL_CMDS_AFTR_ERR);
    eval 'sub PL_LOGINFO_CODE_SATA_ERR_IN_RCV_SET_DEV_BIT_FIS () {(0x90000);}' unless defined(&PL_LOGINFO_CODE_SATA_ERR_IN_RCV_SET_DEV_BIT_FIS);
    eval 'sub PL_LOGINFO_CODE_RX_FM_INVALID_MESSAGE () {(0xa0000);}' unless defined(&PL_LOGINFO_CODE_RX_FM_INVALID_MESSAGE);
    eval 'sub PL_LOGINFO_CODE_RX_CTX_MESSAGE_VALID_ERROR () {(0xb0000);}' unless defined(&PL_LOGINFO_CODE_RX_CTX_MESSAGE_VALID_ERROR);
    eval 'sub PL_LOGINFO_CODE_RX_FM_CURRENT_FRAME_ERROR () {(0xc0000);}' unless defined(&PL_LOGINFO_CODE_RX_FM_CURRENT_FRAME_ERROR);
    eval 'sub PL_LOGINFO_CODE_SATA_LINK_DOWN () {(0xd0000);}' unless defined(&PL_LOGINFO_CODE_SATA_LINK_DOWN);
    eval 'sub PL_LOGINFO_CODE_DISCOVERY_SATA_INIT_W_IOS () {(0xe0000);}' unless defined(&PL_LOGINFO_CODE_DISCOVERY_SATA_INIT_W_IOS);
    eval 'sub PL_LOGINFO_CODE_CONFIG_INVALID_PAGE () {(0xf0000);}' unless defined(&PL_LOGINFO_CODE_CONFIG_INVALID_PAGE);
    eval 'sub PL_LOGINFO_CODE_CONFIG_PL_NOT_INITIALIZED () {(0xf0001);}' unless defined(&PL_LOGINFO_CODE_CONFIG_PL_NOT_INITIALIZED);
    eval 'sub PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_PT () {(0xf0100);}' unless defined(&PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_PT);
    eval 'sub PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_NUM_PHYS () {(0xf0200);}' unless defined(&PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_NUM_PHYS);
    eval 'sub PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_NOT_IMP () {(0xf0300);}' unless defined(&PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_NOT_IMP);
    eval 'sub PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_NO_DEV () {(0xf0400);}' unless defined(&PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_NO_DEV);
    eval 'sub PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_FORM () {(0xf0500);}' unless defined(&PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_FORM);
    eval 'sub PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_PHY () {(0xf0600);}' unless defined(&PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_PHY);
    eval 'sub PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_NO_OWNER () {(0xf0700);}' unless defined(&PL_LOGINFO_CODE_CONFIG_INVALID_PAGE_NO_OWNER);
    eval 'sub PL_LOGINFO_CODE_DSCVRY_SATA_INIT_TIMEOUT () {(0x100000);}' unless defined(&PL_LOGINFO_CODE_DSCVRY_SATA_INIT_TIMEOUT);
    eval 'sub PL_LOGINFO_CODE_RESET () {(0x110000);}' unless defined(&PL_LOGINFO_CODE_RESET);
    eval 'sub PL_LOGINFO_CODE_ABORT () {(0x120000);}' unless defined(&PL_LOGINFO_CODE_ABORT);
    eval 'sub PL_LOGINFO_CODE_IO_NOT_YET_EXECUTED () {(0x130000);}' unless defined(&PL_LOGINFO_CODE_IO_NOT_YET_EXECUTED);
    eval 'sub PL_LOGINFO_CODE_IO_EXECUTED () {(0x140000);}' unless defined(&PL_LOGINFO_CODE_IO_EXECUTED);
    eval 'sub PL_LOGINFO_CODE_PERS_RESV_OUT_NOT_AFFIL_OWNER () {(0x150000);}' unless defined(&PL_LOGINFO_CODE_PERS_RESV_OUT_NOT_AFFIL_OWNER);
    eval 'sub PL_LOGINFO_CODE_OPEN_TXDMA_ABORT () {(0x160000);}' unless defined(&PL_LOGINFO_CODE_OPEN_TXDMA_ABORT);
    eval 'sub PL_LOGINFO_CODE_IO_DEVICE_MISSING_DELAY_RETRY () {(0x170000);}' unless defined(&PL_LOGINFO_CODE_IO_DEVICE_MISSING_DELAY_RETRY);
    eval 'sub PL_LOGINFO_CODE_IO_CANCELLED_DUE_TO_R_ERR () {(0x180000);}' unless defined(&PL_LOGINFO_CODE_IO_CANCELLED_DUE_TO_R_ERR);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE () {(0x100);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_NO_DEST_TIMEOUT () {(0x101);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_NO_DEST_TIMEOUT);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_SATA_NEG_RATE_2HI () {(0x102);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_SATA_NEG_RATE_2HI);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_RATE_NOT_SUPPORTED () {(0x103);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_RATE_NOT_SUPPORTED);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_BREAK () {(0x104);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_BREAK);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ZONE_VIOLATION () {(0x114);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ZONE_VIOLATION);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ABANDON0 () {(0x114);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ABANDON0);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ABANDON1 () {(0x115);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ABANDON1);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ABANDON2 () {(0x116);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ABANDON2);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ABANDON3 () {(0x117);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ABANDON3);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ORR_TIMEOUT () {(0x11a);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_ORR_TIMEOUT);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_PATH_BLOCKED () {(0x11b);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_PATH_BLOCKED);
    eval 'sub PL_LOGINFO_SUB_CODE_OPEN_FAILURE_AWT_MAXED () {(0x11c);}' unless defined(&PL_LOGINFO_SUB_CODE_OPEN_FAILURE_AWT_MAXED);
    eval 'sub PL_LOGINFO_SUB_CODE_TARGET_BUS_RESET () {(0x120);}' unless defined(&PL_LOGINFO_SUB_CODE_TARGET_BUS_RESET);
    eval 'sub PL_LOGINFO_SUB_CODE_TRANSPORT_LAYER () {(0x130);}' unless defined(&PL_LOGINFO_SUB_CODE_TRANSPORT_LAYER);
    eval 'sub PL_LOGINFO_SUB_CODE_PORT_LAYER () {(0x140);}' unless defined(&PL_LOGINFO_SUB_CODE_PORT_LAYER);
    eval 'sub PL_LOGINFO_SUB_CODE_INVALID_SGL () {(0x200);}' unless defined(&PL_LOGINFO_SUB_CODE_INVALID_SGL);
    eval 'sub PL_LOGINFO_SUB_CODE_WRONG_REL_OFF_OR_FRAME_LENGTH () {(0x300);}' unless defined(&PL_LOGINFO_SUB_CODE_WRONG_REL_OFF_OR_FRAME_LENGTH);
    eval 'sub PL_LOGINFO_SUB_CODE_FRAME_XFER_ERROR () {(0x400);}' unless defined(&PL_LOGINFO_SUB_CODE_FRAME_XFER_ERROR);
    eval 'sub PL_LOGINFO_SUB_CODE_TX_FM_CONNECTED_LOW () {(0x500);}' unless defined(&PL_LOGINFO_SUB_CODE_TX_FM_CONNECTED_LOW);
    eval 'sub PL_LOGINFO_SUB_CODE_SATA_NON_NCQ_RW_ERR_BIT_SET () {(0x600);}' unless defined(&PL_LOGINFO_SUB_CODE_SATA_NON_NCQ_RW_ERR_BIT_SET);
    eval 'sub PL_LOGINFO_SUB_CODE_SATA_READ_LOG_RECEIVE_DATA_ERR () {(0x700);}' unless defined(&PL_LOGINFO_SUB_CODE_SATA_READ_LOG_RECEIVE_DATA_ERR);
    eval 'sub PL_LOGINFO_SUB_CODE_SATA_NCQ_FAIL_ALL_CMDS_AFTR_ERR () {(0x800);}' unless defined(&PL_LOGINFO_SUB_CODE_SATA_NCQ_FAIL_ALL_CMDS_AFTR_ERR);
    eval 'sub PL_LOGINFO_SUB_CODE_SATA_ERR_IN_RCV_SET_DEV_BIT_FIS () {(0x900);}' unless defined(&PL_LOGINFO_SUB_CODE_SATA_ERR_IN_RCV_SET_DEV_BIT_FIS);
    eval 'sub PL_LOGINFO_SUB_CODE_RX_FM_INVALID_MESSAGE () {(0xa00);}' unless defined(&PL_LOGINFO_SUB_CODE_RX_FM_INVALID_MESSAGE);
    eval 'sub PL_LOGINFO_SUB_CODE_RX_CTX_MESSAGE_VALID_ERROR () {(0xb00);}' unless defined(&PL_LOGINFO_SUB_CODE_RX_CTX_MESSAGE_VALID_ERROR);
    eval 'sub PL_LOGINFO_SUB_CODE_RX_FM_CURRENT_FRAME_ERROR () {(0xc00);}' unless defined(&PL_LOGINFO_SUB_CODE_RX_FM_CURRENT_FRAME_ERROR);
    eval 'sub PL_LOGINFO_SUB_CODE_SATA_LINK_DOWN () {(0xd00);}' unless defined(&PL_LOGINFO_SUB_CODE_SATA_LINK_DOWN);
    eval 'sub PL_LOGINFO_SUB_CODE_DISCOVERY_SATA_INIT_W_IOS () {(0xe00);}' unless defined(&PL_LOGINFO_SUB_CODE_DISCOVERY_SATA_INIT_W_IOS);
    eval 'sub PL_LOGINFO_SUB_CODE_DISCOVERY_REMOTE_SEP_RESET () {(0xe01);}' unless defined(&PL_LOGINFO_SUB_CODE_DISCOVERY_REMOTE_SEP_RESET);
    eval 'sub PL_LOGINFO_SUB_CODE_SECOND_OPEN () {(0xf00);}' unless defined(&PL_LOGINFO_SUB_CODE_SECOND_OPEN);
    eval 'sub PL_LOGINFO_SUB_CODE_DSCVRY_SATA_INIT_TIMEOUT () {(0x1000);}' unless defined(&PL_LOGINFO_SUB_CODE_DSCVRY_SATA_INIT_TIMEOUT);
    eval 'sub PL_LOGINFO_SUB_CODE_BREAK_ON_SATA_CONNECTION () {(0x2000);}' unless defined(&PL_LOGINFO_SUB_CODE_BREAK_ON_SATA_CONNECTION);
    eval 'sub PL_LOGINFO_SUB_CODE_BREAK_ON_STUCK_LINK () {(0x3000);}' unless defined(&PL_LOGINFO_SUB_CODE_BREAK_ON_STUCK_LINK);
    eval 'sub PL_LOGINFO_SUB_CODE_BREAK_ON_STUCK_LINK_AIP () {(0x4000);}' unless defined(&PL_LOGINFO_SUB_CODE_BREAK_ON_STUCK_LINK_AIP);
    eval 'sub PL_LOGINFO_SUB_CODE_BREAK_ON_INCOMPLETE_BREAK_RCVD () {(0x5000);}' unless defined(&PL_LOGINFO_SUB_CODE_BREAK_ON_INCOMPLETE_BREAK_RCVD);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_SMP_FRAME_FAILURE () {(0x200000);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_SMP_FRAME_FAILURE);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_SMP_READ_ERROR () {(0x200010);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_SMP_READ_ERROR);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_SMP_WRITE_ERROR () {(0x200020);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_SMP_WRITE_ERROR);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_NOT_SUPPORTED_ON_ENCL () {(0x200040);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_NOT_SUPPORTED_ON_ENCL);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_ADDR_MODE_NOT_SUPPORTED () {(0x200050);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_ADDR_MODE_NOT_SUPPORTED);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_BAD_SLOT_NUM () {(0x200060);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_BAD_SLOT_NUM);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_SGPIO_NOT_PRESENT () {(0x200070);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_SGPIO_NOT_PRESENT);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_GPIO_NOT_CONFIGURED () {(0x200080);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_GPIO_NOT_CONFIGURED);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_GPIO_FRAME_ERROR () {(0x200090);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_GPIO_FRAME_ERROR);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_GPIO_CONFIG_PAGE_ERROR () {(0x2000a0);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_GPIO_CONFIG_PAGE_ERROR);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_SES_FRAME_ALLOC_ERROR () {(0x2000b0);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_SES_FRAME_ALLOC_ERROR);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_SES_IO_ERROR () {(0x2000c0);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_SES_IO_ERROR);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_SES_RETRIES_EXHAUSTED () {(0x2000d0);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_SES_RETRIES_EXHAUSTED);
    eval 'sub PL_LOGINFO_CODE_ENCL_MGMT_SMP_FRAME_ALLOC_ERROR () {(0x2000e0);}' unless defined(&PL_LOGINFO_CODE_ENCL_MGMT_SMP_FRAME_ALLOC_ERROR);
    eval 'sub PL_LOGINFO_DA_SEP_NOT_PRESENT () {(0x200100);}' unless defined(&PL_LOGINFO_DA_SEP_NOT_PRESENT);
    eval 'sub PL_LOGINFO_DA_SEP_SINGLE_THREAD_ERROR () {(0x200101);}' unless defined(&PL_LOGINFO_DA_SEP_SINGLE_THREAD_ERROR);
    eval 'sub PL_LOGINFO_DA_SEP_ISTWI_INTR_IN_IDLE_STATE () {(0x200102);}' unless defined(&PL_LOGINFO_DA_SEP_ISTWI_INTR_IN_IDLE_STATE);
    eval 'sub PL_LOGINFO_DA_SEP_RECEIVED_NACK_FROM_SLAVE () {(0x200103);}' unless defined(&PL_LOGINFO_DA_SEP_RECEIVED_NACK_FROM_SLAVE);
    eval 'sub PL_LOGINFO_DA_SEP_DID_NOT_RECEIVE_ACK () {(0x200104);}' unless defined(&PL_LOGINFO_DA_SEP_DID_NOT_RECEIVE_ACK);
    eval 'sub PL_LOGINFO_DA_SEP_BAD_STATUS_HDR_CHKSUM () {(0x200105);}' unless defined(&PL_LOGINFO_DA_SEP_BAD_STATUS_HDR_CHKSUM);
    eval 'sub PL_LOGINFO_DA_SEP_STOP_ON_DATA () {(0x200106);}' unless defined(&PL_LOGINFO_DA_SEP_STOP_ON_DATA);
    eval 'sub PL_LOGINFO_DA_SEP_STOP_ON_SENSE_DATA () {(0x200107);}' unless defined(&PL_LOGINFO_DA_SEP_STOP_ON_SENSE_DATA);
    eval 'sub PL_LOGINFO_DA_SEP_UNSUPPORTED_SCSI_STATUS_1 () {(0x200108);}' unless defined(&PL_LOGINFO_DA_SEP_UNSUPPORTED_SCSI_STATUS_1);
    eval 'sub PL_LOGINFO_DA_SEP_UNSUPPORTED_SCSI_STATUS_2 () {(0x200109);}' unless defined(&PL_LOGINFO_DA_SEP_UNSUPPORTED_SCSI_STATUS_2);
    eval 'sub PL_LOGINFO_DA_SEP_CHKSUM_ERROR_AFTER_STOP () {(0x20010a);}' unless defined(&PL_LOGINFO_DA_SEP_CHKSUM_ERROR_AFTER_STOP);
    eval 'sub PL_LOGINFO_DA_SEP_CHKSUM_ERROR_AFTER_STOP_GETDATA () {(0x20010b);}' unless defined(&PL_LOGINFO_DA_SEP_CHKSUM_ERROR_AFTER_STOP_GETDATA);
    eval 'sub PL_LOGINFO_DA_SEP_UNSUPPORTED_COMMAND () {(0x20010c);}' unless defined(&PL_LOGINFO_DA_SEP_UNSUPPORTED_COMMAND);
    eval 'sub PL_LOGINFO_DA_SEP_UNSUPPORTED_COMMAND_2 () {(0x20010d);}' unless defined(&PL_LOGINFO_DA_SEP_UNSUPPORTED_COMMAND_2);
    eval 'sub PL_LOGINFO_DA_SEP_UNSUPPORTED_COMMAND_3 () {(0x20010e);}' unless defined(&PL_LOGINFO_DA_SEP_UNSUPPORTED_COMMAND_3);
    eval 'sub IR_LOGINFO_RAID_ACTION_ERROR () {(0x10000);}' unless defined(&IR_LOGINFO_RAID_ACTION_ERROR);
    eval 'sub IR_LOGINFO_CODE_UNUSED2 () {(0x20000);}' unless defined(&IR_LOGINFO_CODE_UNUSED2);
    eval 'sub IR_LOGINFO_VOLUME_CREATE_INVALID_LENGTH () {(0x10001);}' unless defined(&IR_LOGINFO_VOLUME_CREATE_INVALID_LENGTH);
    eval 'sub IR_LOGINFO_VOLUME_CREATE_DUPLICATE () {(0x10002);}' unless defined(&IR_LOGINFO_VOLUME_CREATE_DUPLICATE);
    eval 'sub IR_LOGINFO_VOLUME_CREATE_NO_SLOTS () {(0x10003);}' unless defined(&IR_LOGINFO_VOLUME_CREATE_NO_SLOTS);
    eval 'sub IR_LOGINFO_VOLUME_CREATE_DMA_ERROR () {(0x10004);}' unless defined(&IR_LOGINFO_VOLUME_CREATE_DMA_ERROR);
    eval 'sub IR_LOGINFO_VOLUME_CREATE_INVALID_VOLUME_TYPE () {(0x10005);}' unless defined(&IR_LOGINFO_VOLUME_CREATE_INVALID_VOLUME_TYPE);
    eval 'sub IR_LOGINFO_VOLUME_MFG_PAGE4_ERROR () {(0x10006);}' unless defined(&IR_LOGINFO_VOLUME_MFG_PAGE4_ERROR);
    eval 'sub IR_LOGINFO_VOLUME_INTERNAL_CONFIG_STRUCTURE_ERROR () {(0x10007);}' unless defined(&IR_LOGINFO_VOLUME_INTERNAL_CONFIG_STRUCTURE_ERROR);
    eval 'sub IR_LOGINFO_VOLUME_ACTIVATING_AN_ACTIVE_VOLUME () {(0x10010);}' unless defined(&IR_LOGINFO_VOLUME_ACTIVATING_AN_ACTIVE_VOLUME);
    eval 'sub IR_LOGINFO_VOLUME_ACTIVATING_INVALID_VOLUME_TYPE () {(0x10011);}' unless defined(&IR_LOGINFO_VOLUME_ACTIVATING_INVALID_VOLUME_TYPE);
    eval 'sub IR_LOGINFO_VOLUME_ACTIVATING_TOO_MANY_VOLUMES () {(0x10012);}' unless defined(&IR_LOGINFO_VOLUME_ACTIVATING_TOO_MANY_VOLUMES);
    eval 'sub IR_LOGINFO_VOLUME_ACTIVATING_VOLUME_ID_IN_USE () {(0x10013);}' unless defined(&IR_LOGINFO_VOLUME_ACTIVATING_VOLUME_ID_IN_USE);
    eval 'sub IR_LOGINFO_VOLUME_ACTIVATE_VOLUME_FAILED () {(0x10014);}' unless defined(&IR_LOGINFO_VOLUME_ACTIVATE_VOLUME_FAILED);
    eval 'sub IR_LOGINFO_VOLUME_ACTIVATING_IMPORT_VOLUME_FAILED () {(0x10015);}' unless defined(&IR_LOGINFO_VOLUME_ACTIVATING_IMPORT_VOLUME_FAILED);
    eval 'sub IR_LOGINFO_VOLUME_ACTIVATING_TOO_MANY_PHYS_DISKS () {(0x10016);}' unless defined(&IR_LOGINFO_VOLUME_ACTIVATING_TOO_MANY_PHYS_DISKS);
    eval 'sub IR_LOGINFO_PHYSDISK_CREATE_TOO_MANY_DISKS () {(0x10020);}' unless defined(&IR_LOGINFO_PHYSDISK_CREATE_TOO_MANY_DISKS);
    eval 'sub IR_LOGINFO_PHYSDISK_CREATE_INVALID_LENGTH () {(0x10021);}' unless defined(&IR_LOGINFO_PHYSDISK_CREATE_INVALID_LENGTH);
    eval 'sub IR_LOGINFO_PHYSDISK_CREATE_DMA_ERROR () {(0x10022);}' unless defined(&IR_LOGINFO_PHYSDISK_CREATE_DMA_ERROR);
    eval 'sub IR_LOGINFO_PHYSDISK_CREATE_BUS_TID_INVALID () {(0x10023);}' unless defined(&IR_LOGINFO_PHYSDISK_CREATE_BUS_TID_INVALID);
    eval 'sub IR_LOGINFO_PHYSDISK_CREATE_CONFIG_PAGE_ERROR () {(0x10024);}' unless defined(&IR_LOGINFO_PHYSDISK_CREATE_CONFIG_PAGE_ERROR);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_RAID_DISABLED () {(0x10030);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_RAID_DISABLED);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_INQUIRY_FAILED () {(0x10031);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_INQUIRY_FAILED);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_NOT_DIRECT_ACCESS () {(0x10032);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_NOT_DIRECT_ACCESS);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_REMOVABLE_FOUND () {(0x10033);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_REMOVABLE_FOUND);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_NEED_SCSI_2_OR_HIGHER () {(0x10034);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_NEED_SCSI_2_OR_HIGHER);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_SATA_48BIT_LBA_NOT_SUPPORTED () {(0x10035);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_SATA_48BIT_LBA_NOT_SUPPORTED);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_DEVICE_NOT_512_BYTE_BLOCK () {(0x10036);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_DEVICE_NOT_512_BYTE_BLOCK);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_VOLUME_TYPE_CHECK_FAILED () {(0x10037);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_VOLUME_TYPE_CHECK_FAILED);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_UNSUPPORTED_VOLUME_TYPE () {(0x10038);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_UNSUPPORTED_VOLUME_TYPE);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_DISK_TOO_SMALL () {(0x10039);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_DISK_TOO_SMALL);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_PHYS_DISK_NOT_FOUND () {(0x1003a);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_PHYS_DISK_NOT_FOUND);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_MEMBERSHIP_COUNT () {(0x1003b);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_MEMBERSHIP_COUNT);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_NON_64K_STRIPE_SIZE () {(0x1003c);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_NON_64K_STRIPE_SIZE);
    eval 'sub IR_LOGINFO_COMPAT_ERROR_IME_VOL_NOT_CURRENTLY_SUPPORTED () {(0x1003d);}' unless defined(&IR_LOGINFO_COMPAT_ERROR_IME_VOL_NOT_CURRENTLY_SUPPORTED);
    eval 'sub IR_LOGINFO_DEV_FW_UPDATE_ERR_DFU_IN_PROGRESS () {(0x10050);}' unless defined(&IR_LOGINFO_DEV_FW_UPDATE_ERR_DFU_IN_PROGRESS);
    eval 'sub IR_LOGINFO_DEV_FW_UPDATE_ERR_DEVICE_IN_INVALID_STATE () {(0x10051);}' unless defined(&IR_LOGINFO_DEV_FW_UPDATE_ERR_DEVICE_IN_INVALID_STATE);
    eval 'sub IR_LOGINFO_DEV_FW_UPDATE_ERR_INVALID_TIMEOUT () {(0x10052);}' unless defined(&IR_LOGINFO_DEV_FW_UPDATE_ERR_INVALID_TIMEOUT);
    eval 'sub IR_LOGINFO_DEV_FW_UPDATE_ERR_NO_TIMERS () {(0x10053);}' unless defined(&IR_LOGINFO_DEV_FW_UPDATE_ERR_NO_TIMERS);
    eval 'sub IR_LOGINFO_DEV_FW_UPDATE_ERR_READING_CFG_PAGE () {(0x10054);}' unless defined(&IR_LOGINFO_DEV_FW_UPDATE_ERR_READING_CFG_PAGE);
    eval 'sub IR_LOGINFO_DEV_FW_UPDATE_ERR_PORT_IO_TIMEOUTS_REQUIRED () {(0x10055);}' unless defined(&IR_LOGINFO_DEV_FW_UPDATE_ERR_PORT_IO_TIMEOUTS_REQUIRED);
    eval 'sub IR_LOGINFO_DEV_FW_UPDATE_ERR_ALLOC_CFG_PAGE () {(0x10056);}' unless defined(&IR_LOGINFO_DEV_FW_UPDATE_ERR_ALLOC_CFG_PAGE);
    eval 'sub IOC_LOGINFO_PREFIX_IOP () {(( &MPI_IOCLOGINFO_TYPE_SAS <<  &MPI_IOCLOGINFO_TYPE_SHIFT) |  &IOC_LOGINFO_ORIGINATOR_IOP);}' unless defined(&IOC_LOGINFO_PREFIX_IOP);
    eval 'sub IOC_LOGINFO_PREFIX_PL () {(( &MPI_IOCLOGINFO_TYPE_SAS <<  &MPI_IOCLOGINFO_TYPE_SHIFT) |  &IOC_LOGINFO_ORIGINATOR_PL);}' unless defined(&IOC_LOGINFO_PREFIX_PL);
    eval 'sub IOC_LOGINFO_PREFIX_IR () {(( &MPI_IOCLOGINFO_TYPE_SAS <<  &MPI_IOCLOGINFO_TYPE_SHIFT) |  &IOC_LOGINFO_ORIGINATOR_IR);}' unless defined(&IOC_LOGINFO_PREFIX_IR);
}
1;
