require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MPI_SAS_H)) {
    eval 'sub MPI_SAS_H () {1;}' unless defined(&MPI_SAS_H);
    eval 'sub MPI_SASSTATUS_SUCCESS () {(0x);}' unless defined(&MPI_SASSTATUS_SUCCESS);
    eval 'sub MPI_SASSTATUS_UNKNOWN_ERROR () {(0x1);}' unless defined(&MPI_SASSTATUS_UNKNOWN_ERROR);
    eval 'sub MPI_SASSTATUS_INVALID_FRAME () {(0x2);}' unless defined(&MPI_SASSTATUS_INVALID_FRAME);
    eval 'sub MPI_SASSTATUS_UTC_BAD_DEST () {(0x3);}' unless defined(&MPI_SASSTATUS_UTC_BAD_DEST);
    eval 'sub MPI_SASSTATUS_UTC_BREAK_RECEIVED () {(0x4);}' unless defined(&MPI_SASSTATUS_UTC_BREAK_RECEIVED);
    eval 'sub MPI_SASSTATUS_UTC_CONNECT_RATE_NOT_SUPPORTED () {(0x5);}' unless defined(&MPI_SASSTATUS_UTC_CONNECT_RATE_NOT_SUPPORTED);
    eval 'sub MPI_SASSTATUS_UTC_PORT_LAYER_REQUEST () {(0x6);}' unless defined(&MPI_SASSTATUS_UTC_PORT_LAYER_REQUEST);
    eval 'sub MPI_SASSTATUS_UTC_PROTOCOL_NOT_SUPPORTED () {(0x7);}' unless defined(&MPI_SASSTATUS_UTC_PROTOCOL_NOT_SUPPORTED);
    eval 'sub MPI_SASSTATUS_UTC_STP_RESOURCES_BUSY () {(0x8);}' unless defined(&MPI_SASSTATUS_UTC_STP_RESOURCES_BUSY);
    eval 'sub MPI_SASSTATUS_UTC_WRONG_DESTINATION () {(0x9);}' unless defined(&MPI_SASSTATUS_UTC_WRONG_DESTINATION);
    eval 'sub MPI_SASSTATUS_SHORT_INFORMATION_UNIT () {(0xa);}' unless defined(&MPI_SASSTATUS_SHORT_INFORMATION_UNIT);
    eval 'sub MPI_SASSTATUS_LONG_INFORMATION_UNIT () {(0xb);}' unless defined(&MPI_SASSTATUS_LONG_INFORMATION_UNIT);
    eval 'sub MPI_SASSTATUS_XFER_RDY_INCORRECT_WRITE_DATA () {(0xc);}' unless defined(&MPI_SASSTATUS_XFER_RDY_INCORRECT_WRITE_DATA);
    eval 'sub MPI_SASSTATUS_XFER_RDY_REQUEST_OFFSET_ERROR () {(0xd);}' unless defined(&MPI_SASSTATUS_XFER_RDY_REQUEST_OFFSET_ERROR);
    eval 'sub MPI_SASSTATUS_XFER_RDY_NOT_EXPECTED () {(0xe);}' unless defined(&MPI_SASSTATUS_XFER_RDY_NOT_EXPECTED);
    eval 'sub MPI_SASSTATUS_DATA_INCORRECT_DATA_LENGTH () {(0xf);}' unless defined(&MPI_SASSTATUS_DATA_INCORRECT_DATA_LENGTH);
    eval 'sub MPI_SASSTATUS_DATA_TOO_MUCH_READ_DATA () {(0x10);}' unless defined(&MPI_SASSTATUS_DATA_TOO_MUCH_READ_DATA);
    eval 'sub MPI_SASSTATUS_DATA_OFFSET_ERROR () {(0x11);}' unless defined(&MPI_SASSTATUS_DATA_OFFSET_ERROR);
    eval 'sub MPI_SASSTATUS_SDSF_NAK_RECEIVED () {(0x12);}' unless defined(&MPI_SASSTATUS_SDSF_NAK_RECEIVED);
    eval 'sub MPI_SASSTATUS_SDSF_CONNECTION_FAILED () {(0x13);}' unless defined(&MPI_SASSTATUS_SDSF_CONNECTION_FAILED);
    eval 'sub MPI_SASSTATUS_INITIATOR_RESPONSE_TIMEOUT () {(0x14);}' unless defined(&MPI_SASSTATUS_INITIATOR_RESPONSE_TIMEOUT);
    eval 'sub MPI_SAS_DEVICE_INFO_PRODUCT_SPECIFIC () {(0xf0000000);}' unless defined(&MPI_SAS_DEVICE_INFO_PRODUCT_SPECIFIC);
    eval 'sub MPI_SAS_DEVICE_INFO_SEP () {(0x4000);}' unless defined(&MPI_SAS_DEVICE_INFO_SEP);
    eval 'sub MPI_SAS_DEVICE_INFO_ATAPI_DEVICE () {(0x2000);}' unless defined(&MPI_SAS_DEVICE_INFO_ATAPI_DEVICE);
    eval 'sub MPI_SAS_DEVICE_INFO_LSI_DEVICE () {(0x1000);}' unless defined(&MPI_SAS_DEVICE_INFO_LSI_DEVICE);
    eval 'sub MPI_SAS_DEVICE_INFO_DIRECT_ATTACH () {(0x800);}' unless defined(&MPI_SAS_DEVICE_INFO_DIRECT_ATTACH);
    eval 'sub MPI_SAS_DEVICE_INFO_SSP_TARGET () {(0x400);}' unless defined(&MPI_SAS_DEVICE_INFO_SSP_TARGET);
    eval 'sub MPI_SAS_DEVICE_INFO_STP_TARGET () {(0x200);}' unless defined(&MPI_SAS_DEVICE_INFO_STP_TARGET);
    eval 'sub MPI_SAS_DEVICE_INFO_SMP_TARGET () {(0x100);}' unless defined(&MPI_SAS_DEVICE_INFO_SMP_TARGET);
    eval 'sub MPI_SAS_DEVICE_INFO_SATA_DEVICE () {(0x80);}' unless defined(&MPI_SAS_DEVICE_INFO_SATA_DEVICE);
    eval 'sub MPI_SAS_DEVICE_INFO_SSP_INITIATOR () {(0x40);}' unless defined(&MPI_SAS_DEVICE_INFO_SSP_INITIATOR);
    eval 'sub MPI_SAS_DEVICE_INFO_STP_INITIATOR () {(0x20);}' unless defined(&MPI_SAS_DEVICE_INFO_STP_INITIATOR);
    eval 'sub MPI_SAS_DEVICE_INFO_SMP_INITIATOR () {(0x10);}' unless defined(&MPI_SAS_DEVICE_INFO_SMP_INITIATOR);
    eval 'sub MPI_SAS_DEVICE_INFO_SATA_HOST () {(0x8);}' unless defined(&MPI_SAS_DEVICE_INFO_SATA_HOST);
    eval 'sub MPI_SAS_DEVICE_INFO_MASK_DEVICE_TYPE () {(0x7);}' unless defined(&MPI_SAS_DEVICE_INFO_MASK_DEVICE_TYPE);
    eval 'sub MPI_SAS_DEVICE_INFO_NO_DEVICE () {(0x);}' unless defined(&MPI_SAS_DEVICE_INFO_NO_DEVICE);
    eval 'sub MPI_SAS_DEVICE_INFO_END_DEVICE () {(0x1);}' unless defined(&MPI_SAS_DEVICE_INFO_END_DEVICE);
    eval 'sub MPI_SAS_DEVICE_INFO_EDGE_EXPANDER () {(0x2);}' unless defined(&MPI_SAS_DEVICE_INFO_EDGE_EXPANDER);
    eval 'sub MPI_SAS_DEVICE_INFO_FANOUT_EXPANDER () {(0x3);}' unless defined(&MPI_SAS_DEVICE_INFO_FANOUT_EXPANDER);
    eval 'sub MPI_SMP_PT_REQ_PT_FLAGS_IMMEDIATE () {(0x80);}' unless defined(&MPI_SMP_PT_REQ_PT_FLAGS_IMMEDIATE);
    eval 'sub MPI_SMP_PT_REQ_CONNECT_RATE_NEGOTIATED () {(0x);}' unless defined(&MPI_SMP_PT_REQ_CONNECT_RATE_NEGOTIATED);
    eval 'sub MPI_SMP_PT_REQ_CONNECT_RATE_1_5 () {(0x8);}' unless defined(&MPI_SMP_PT_REQ_CONNECT_RATE_1_5);
    eval 'sub MPI_SMP_PT_REQ_CONNECT_RATE_3_0 () {(0x9);}' unless defined(&MPI_SMP_PT_REQ_CONNECT_RATE_3_0);
    eval 'sub MPI_SMP_PT_REPLY_PT_FLAGS_IMMEDIATE () {(0x80);}' unless defined(&MPI_SMP_PT_REPLY_PT_FLAGS_IMMEDIATE);
    eval 'sub MPI_SATA_PT_REQ_PT_FLAGS_RESET_DEVICE () {(0x200);}' unless defined(&MPI_SATA_PT_REQ_PT_FLAGS_RESET_DEVICE);
    eval 'sub MPI_SATA_PT_REQ_PT_FLAGS_EXECUTE_DIAG () {(0x100);}' unless defined(&MPI_SATA_PT_REQ_PT_FLAGS_EXECUTE_DIAG);
    eval 'sub MPI_SATA_PT_REQ_PT_FLAGS_DMA_QUEUED () {(0x80);}' unless defined(&MPI_SATA_PT_REQ_PT_FLAGS_DMA_QUEUED);
    eval 'sub MPI_SATA_PT_REQ_PT_FLAGS_PACKET_COMMAND () {(0x40);}' unless defined(&MPI_SATA_PT_REQ_PT_FLAGS_PACKET_COMMAND);
    eval 'sub MPI_SATA_PT_REQ_PT_FLAGS_DMA () {(0x20);}' unless defined(&MPI_SATA_PT_REQ_PT_FLAGS_DMA);
    eval 'sub MPI_SATA_PT_REQ_PT_FLAGS_PIO () {(0x10);}' unless defined(&MPI_SATA_PT_REQ_PT_FLAGS_PIO);
    eval 'sub MPI_SATA_PT_REQ_PT_FLAGS_UNSPECIFIED_VU () {(0x4);}' unless defined(&MPI_SATA_PT_REQ_PT_FLAGS_UNSPECIFIED_VU);
    eval 'sub MPI_SATA_PT_REQ_PT_FLAGS_WRITE () {(0x2);}' unless defined(&MPI_SATA_PT_REQ_PT_FLAGS_WRITE);
    eval 'sub MPI_SATA_PT_REQ_PT_FLAGS_READ () {(0x1);}' unless defined(&MPI_SATA_PT_REQ_PT_FLAGS_READ);
    eval 'sub MPI_SATA_PT_REQ_CONNECT_RATE_NEGOTIATED () {(0x);}' unless defined(&MPI_SATA_PT_REQ_CONNECT_RATE_NEGOTIATED);
    eval 'sub MPI_SATA_PT_REQ_CONNECT_RATE_1_5 () {(0x8);}' unless defined(&MPI_SATA_PT_REQ_CONNECT_RATE_1_5);
    eval 'sub MPI_SATA_PT_REQ_CONNECT_RATE_3_0 () {(0x9);}' unless defined(&MPI_SATA_PT_REQ_CONNECT_RATE_3_0);
    eval 'sub MPI_SAS_OP_CLEAR_NOT_PRESENT () {(0x1);}' unless defined(&MPI_SAS_OP_CLEAR_NOT_PRESENT);
    eval 'sub MPI_SAS_OP_CLEAR_ALL_PERSISTENT () {(0x2);}' unless defined(&MPI_SAS_OP_CLEAR_ALL_PERSISTENT);
    eval 'sub MPI_SAS_OP_PHY_LINK_RESET () {(0x6);}' unless defined(&MPI_SAS_OP_PHY_LINK_RESET);
    eval 'sub MPI_SAS_OP_PHY_HARD_RESET () {(0x7);}' unless defined(&MPI_SAS_OP_PHY_HARD_RESET);
    eval 'sub MPI_SAS_OP_PHY_CLEAR_ERROR_LOG () {(0x8);}' unless defined(&MPI_SAS_OP_PHY_CLEAR_ERROR_LOG);
    eval 'sub MPI_SAS_OP_MAP_CURRENT () {(0x9);}' unless defined(&MPI_SAS_OP_MAP_CURRENT);
    eval 'sub MPI_SAS_OP_SEND_PRIMITIVE () {(0xa);}' unless defined(&MPI_SAS_OP_SEND_PRIMITIVE);
    eval 'sub MPI_SAS_OP_FORCE_FULL_DISCOVERY () {(0xb);}' unless defined(&MPI_SAS_OP_FORCE_FULL_DISCOVERY);
    eval 'sub MPI_SAS_OP_TRANSMIT_PORT_SELECT_SIGNAL () {(0xc);}' unless defined(&MPI_SAS_OP_TRANSMIT_PORT_SELECT_SIGNAL);
    eval 'sub MPI_SAS_OP_TRANSMIT_REMOVE_DEVICE () {(0xd);}' unless defined(&MPI_SAS_OP_TRANSMIT_REMOVE_DEVICE);
    eval 'sub MPI_SAS_OP_REMOVE_DEVICE () {(0xd);}' unless defined(&MPI_SAS_OP_REMOVE_DEVICE);
    eval 'sub MPI_SAS_OP_SET_IOC_PARAMETER () {(0xe);}' unless defined(&MPI_SAS_OP_SET_IOC_PARAMETER);
    eval 'sub MPI_SAS_OP_PRODUCT_SPECIFIC_MIN () {(0x80);}' unless defined(&MPI_SAS_OP_PRODUCT_SPECIFIC_MIN);
    eval 'sub MPI_SAS_PRIMFLAGS_SINGLE () {(0x8);}' unless defined(&MPI_SAS_PRIMFLAGS_SINGLE);
    eval 'sub MPI_SAS_PRIMFLAGS_TRIPLE () {(0x2);}' unless defined(&MPI_SAS_PRIMFLAGS_TRIPLE);
    eval 'sub MPI_SAS_PRIMFLAGS_REDUNDANT () {(0x1);}' unless defined(&MPI_SAS_PRIMFLAGS_REDUNDANT);
}
1;
