require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MPI_TOOL_H)) {
    eval 'sub MPI_TOOL_H () {1;}' unless defined(&MPI_TOOL_H);
    eval 'sub MPI_TOOLBOX_CLEAN_TOOL () {(0x);}' unless defined(&MPI_TOOLBOX_CLEAN_TOOL);
    eval 'sub MPI_TOOLBOX_MEMORY_MOVE_TOOL () {(0x1);}' unless defined(&MPI_TOOLBOX_MEMORY_MOVE_TOOL);
    eval 'sub MPI_TOOLBOX_DIAG_DATA_UPLOAD_TOOL () {(0x2);}' unless defined(&MPI_TOOLBOX_DIAG_DATA_UPLOAD_TOOL);
    eval 'sub MPI_TOOLBOX_ISTWI_READ_WRITE_TOOL () {(0x3);}' unless defined(&MPI_TOOLBOX_ISTWI_READ_WRITE_TOOL);
    eval 'sub MPI_TOOLBOX_FC_MANAGEMENT_TOOL () {(0x4);}' unless defined(&MPI_TOOLBOX_FC_MANAGEMENT_TOOL);
    eval 'sub MPI_TOOLBOX_BEACON_TOOL () {(0x5);}' unless defined(&MPI_TOOLBOX_BEACON_TOOL);
    eval 'sub MPI_TOOLBOX_CLEAN_NVSRAM () {(0x1);}' unless defined(&MPI_TOOLBOX_CLEAN_NVSRAM);
    eval 'sub MPI_TOOLBOX_CLEAN_SEEPROM () {(0x2);}' unless defined(&MPI_TOOLBOX_CLEAN_SEEPROM);
    eval 'sub MPI_TOOLBOX_CLEAN_FLASH () {(0x4);}' unless defined(&MPI_TOOLBOX_CLEAN_FLASH);
    eval 'sub MPI_TOOLBOX_CLEAN_BOOTLOADER () {(0x4000000);}' unless defined(&MPI_TOOLBOX_CLEAN_BOOTLOADER);
    eval 'sub MPI_TOOLBOX_CLEAN_FW_BACKUP () {(0x8000000);}' unless defined(&MPI_TOOLBOX_CLEAN_FW_BACKUP);
    eval 'sub MPI_TOOLBOX_CLEAN_FW_CURRENT () {(0x10000000);}' unless defined(&MPI_TOOLBOX_CLEAN_FW_CURRENT);
    eval 'sub MPI_TOOLBOX_CLEAN_OTHER_PERSIST_PAGES () {(0x20000000);}' unless defined(&MPI_TOOLBOX_CLEAN_OTHER_PERSIST_PAGES);
    eval 'sub MPI_TOOLBOX_CLEAN_PERSIST_MANUFACT_PAGES () {(0x40000000);}' unless defined(&MPI_TOOLBOX_CLEAN_PERSIST_MANUFACT_PAGES);
    eval 'sub MPI_TOOLBOX_CLEAN_BOOT_SERVICES () {(0x80000000);}' unless defined(&MPI_TOOLBOX_CLEAN_BOOT_SERVICES);
    eval 'sub MPI_TB_DIAG_FORMAT_SCSI_PRINTF_1 () {(0x1);}' unless defined(&MPI_TB_DIAG_FORMAT_SCSI_PRINTF_1);
    eval 'sub MPI_TB_DIAG_FORMAT_SCSI_2 () {(0x2);}' unless defined(&MPI_TB_DIAG_FORMAT_SCSI_2);
    eval 'sub MPI_TB_DIAG_FORMAT_SCSI_3 () {(0x3);}' unless defined(&MPI_TB_DIAG_FORMAT_SCSI_3);
    eval 'sub MPI_TB_DIAG_FORMAT_FC_TRACE_1 () {(0x4);}' unless defined(&MPI_TB_DIAG_FORMAT_FC_TRACE_1);
    eval 'sub MPI_TB_ISTWI_FLAGS_WRITE () {(0x);}' unless defined(&MPI_TB_ISTWI_FLAGS_WRITE);
    eval 'sub MPI_TB_ISTWI_FLAGS_READ () {(0x1);}' unless defined(&MPI_TB_ISTWI_FLAGS_READ);
    eval 'sub MPI_TB_FC_MANAGE_ACTION_DISC_ALL () {(0x);}' unless defined(&MPI_TB_FC_MANAGE_ACTION_DISC_ALL);
    eval 'sub MPI_TB_FC_MANAGE_ACTION_DISC_PID () {(0x1);}' unless defined(&MPI_TB_FC_MANAGE_ACTION_DISC_PID);
    eval 'sub MPI_TB_FC_MANAGE_ACTION_DISC_BUS_TID () {(0x2);}' unless defined(&MPI_TB_FC_MANAGE_ACTION_DISC_BUS_TID);
    eval 'sub MPI_TB_FC_MANAGE_ACTION_SET_MAX_FRAME_SIZE () {(0x3);}' unless defined(&MPI_TB_FC_MANAGE_ACTION_SET_MAX_FRAME_SIZE);
    eval 'sub MPI_TOOLBOX_FLAGS_BEACON_MODE_OFF () {(0x);}' unless defined(&MPI_TOOLBOX_FLAGS_BEACON_MODE_OFF);
    eval 'sub MPI_TOOLBOX_FLAGS_BEACON_MODE_ON () {(0x1);}' unless defined(&MPI_TOOLBOX_FLAGS_BEACON_MODE_ON);
    eval 'sub MPI_DIAG_BUF_TYPE_TRACE () {(0x);}' unless defined(&MPI_DIAG_BUF_TYPE_TRACE);
    eval 'sub MPI_DIAG_BUF_TYPE_SNAPSHOT () {(0x1);}' unless defined(&MPI_DIAG_BUF_TYPE_SNAPSHOT);
    eval 'sub MPI_DIAG_BUF_TYPE_EXTENDED () {(0x2);}' unless defined(&MPI_DIAG_BUF_TYPE_EXTENDED);
    eval 'sub MPI_DIAG_BUF_TYPE_COUNT () {(0x3);}' unless defined(&MPI_DIAG_BUF_TYPE_COUNT);
    eval 'sub MPI_DIAG_EXTENDED_QTAG () {(0x1);}' unless defined(&MPI_DIAG_EXTENDED_QTAG);
}
1;
