require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__NVME_H__)) {
    eval 'sub __NVME_H__ () {1;}' unless defined(&__NVME_H__);
    if(defined(&_KERNEL)) {
	require 'sys/types.ph';
    }
    require 'sys/param.ph';
    eval 'sub NVME_PASSTHROUGH_CMD () { &_IOWR(ord(\'n\'), 0, \'struct nvme_pt_command\');}' unless defined(&NVME_PASSTHROUGH_CMD);
    eval 'sub NVME_RESET_CONTROLLER () { &_IO(ord(\'n\'), 1);}' unless defined(&NVME_RESET_CONTROLLER);
    eval 'sub NVME_IO_TEST () { &_IOWR(ord(\'n\'), 100, \'struct nvme_io_test\');}' unless defined(&NVME_IO_TEST);
    eval 'sub NVME_BIO_TEST () { &_IOWR(ord(\'n\'), 101, \'struct nvme_io_test\');}' unless defined(&NVME_BIO_TEST);
    eval 'sub NVME_GLOBAL_NAMESPACE_TAG () {(( &uint32_t)0xffffffff);}' unless defined(&NVME_GLOBAL_NAMESPACE_TAG);
    eval 'sub NVME_MAX_XFER_SIZE () {( &MAXPHYS < (1<<20) ?  &MAXPHYS : (1<<20));}' unless defined(&NVME_MAX_XFER_SIZE);
    eval("sub NVME_SHN_NORMAL () { 0x1; }") unless defined(&NVME_SHN_NORMAL);
    eval("sub NVME_SHN_ABRUPT () { 0x2; }") unless defined(&NVME_SHN_ABRUPT);
    eval("sub NVME_SHST_NORMAL () { 0x0; }") unless defined(&NVME_SHST_NORMAL);
    eval("sub NVME_SHST_OCCURRING () { 0x1; }") unless defined(&NVME_SHST_OCCURRING);
    eval("sub NVME_SHST_COMPLETE () { 0x2; }") unless defined(&NVME_SHST_COMPLETE);
    eval("sub NVME_SCT_GENERIC () { 0x0; }") unless defined(&NVME_SCT_GENERIC);
    eval("sub NVME_SCT_COMMAND_SPECIFIC () { 0x1; }") unless defined(&NVME_SCT_COMMAND_SPECIFIC);
    eval("sub NVME_SCT_MEDIA_ERROR () { 0x2; }") unless defined(&NVME_SCT_MEDIA_ERROR);
    eval("sub NVME_SCT_VENDOR_SPECIFIC () { 0x7; }") unless defined(&NVME_SCT_VENDOR_SPECIFIC);
    eval("sub NVME_SC_SUCCESS () { 0x00; }") unless defined(&NVME_SC_SUCCESS);
    eval("sub NVME_SC_INVALID_OPCODE () { 0x01; }") unless defined(&NVME_SC_INVALID_OPCODE);
    eval("sub NVME_SC_INVALID_FIELD () { 0x02; }") unless defined(&NVME_SC_INVALID_FIELD);
    eval("sub NVME_SC_COMMAND_ID_CONFLICT () { 0x03; }") unless defined(&NVME_SC_COMMAND_ID_CONFLICT);
    eval("sub NVME_SC_DATA_TRANSFER_ERROR () { 0x04; }") unless defined(&NVME_SC_DATA_TRANSFER_ERROR);
    eval("sub NVME_SC_ABORTED_POWER_LOSS () { 0x05; }") unless defined(&NVME_SC_ABORTED_POWER_LOSS);
    eval("sub NVME_SC_INTERNAL_DEVICE_ERROR () { 0x06; }") unless defined(&NVME_SC_INTERNAL_DEVICE_ERROR);
    eval("sub NVME_SC_ABORTED_BY_REQUEST () { 0x07; }") unless defined(&NVME_SC_ABORTED_BY_REQUEST);
    eval("sub NVME_SC_ABORTED_SQ_DELETION () { 0x08; }") unless defined(&NVME_SC_ABORTED_SQ_DELETION);
    eval("sub NVME_SC_ABORTED_FAILED_FUSED () { 0x09; }") unless defined(&NVME_SC_ABORTED_FAILED_FUSED);
    eval("sub NVME_SC_ABORTED_MISSING_FUSED () { 0x0a; }") unless defined(&NVME_SC_ABORTED_MISSING_FUSED);
    eval("sub NVME_SC_INVALID_NAMESPACE_OR_FORMAT () { 0x0b; }") unless defined(&NVME_SC_INVALID_NAMESPACE_OR_FORMAT);
    eval("sub NVME_SC_COMMAND_SEQUENCE_ERROR () { 0x0c; }") unless defined(&NVME_SC_COMMAND_SEQUENCE_ERROR);
    eval("sub NVME_SC_LBA_OUT_OF_RANGE () { 0x80; }") unless defined(&NVME_SC_LBA_OUT_OF_RANGE);
    eval("sub NVME_SC_CAPACITY_EXCEEDED () { 0x81; }") unless defined(&NVME_SC_CAPACITY_EXCEEDED);
    eval("sub NVME_SC_NAMESPACE_NOT_READY () { 0x82; }") unless defined(&NVME_SC_NAMESPACE_NOT_READY);
    eval("sub NVME_SC_COMPLETION_QUEUE_INVALID () { 0x00; }") unless defined(&NVME_SC_COMPLETION_QUEUE_INVALID);
    eval("sub NVME_SC_INVALID_QUEUE_IDENTIFIER () { 0x01; }") unless defined(&NVME_SC_INVALID_QUEUE_IDENTIFIER);
    eval("sub NVME_SC_MAXIMUM_QUEUE_SIZE_EXCEEDED () { 0x02; }") unless defined(&NVME_SC_MAXIMUM_QUEUE_SIZE_EXCEEDED);
    eval("sub NVME_SC_ABORT_COMMAND_LIMIT_EXCEEDED () { 0x03; }") unless defined(&NVME_SC_ABORT_COMMAND_LIMIT_EXCEEDED);
    eval("sub NVME_SC_ASYNC_EVENT_REQUEST_LIMIT_EXCEEDED () { 0x05; }") unless defined(&NVME_SC_ASYNC_EVENT_REQUEST_LIMIT_EXCEEDED);
    eval("sub NVME_SC_INVALID_FIRMWARE_SLOT () { 0x06; }") unless defined(&NVME_SC_INVALID_FIRMWARE_SLOT);
    eval("sub NVME_SC_INVALID_FIRMWARE_IMAGE () { 0x07; }") unless defined(&NVME_SC_INVALID_FIRMWARE_IMAGE);
    eval("sub NVME_SC_INVALID_INTERRUPT_VECTOR () { 0x08; }") unless defined(&NVME_SC_INVALID_INTERRUPT_VECTOR);
    eval("sub NVME_SC_INVALID_LOG_PAGE () { 0x09; }") unless defined(&NVME_SC_INVALID_LOG_PAGE);
    eval("sub NVME_SC_INVALID_FORMAT () { 0x0a; }") unless defined(&NVME_SC_INVALID_FORMAT);
    eval("sub NVME_SC_FIRMWARE_REQUIRES_RESET () { 0x0b; }") unless defined(&NVME_SC_FIRMWARE_REQUIRES_RESET);
    eval("sub NVME_SC_CONFLICTING_ATTRIBUTES () { 0x80; }") unless defined(&NVME_SC_CONFLICTING_ATTRIBUTES);
    eval("sub NVME_SC_INVALID_PROTECTION_INFO () { 0x81; }") unless defined(&NVME_SC_INVALID_PROTECTION_INFO);
    eval("sub NVME_SC_ATTEMPTED_WRITE_TO_RO_PAGE () { 0x82; }") unless defined(&NVME_SC_ATTEMPTED_WRITE_TO_RO_PAGE);
    eval("sub NVME_SC_WRITE_FAULTS () { 0x80; }") unless defined(&NVME_SC_WRITE_FAULTS);
    eval("sub NVME_SC_UNRECOVERED_READ_ERROR () { 0x81; }") unless defined(&NVME_SC_UNRECOVERED_READ_ERROR);
    eval("sub NVME_SC_GUARD_CHECK_ERROR () { 0x82; }") unless defined(&NVME_SC_GUARD_CHECK_ERROR);
    eval("sub NVME_SC_APPLICATION_TAG_CHECK_ERROR () { 0x83; }") unless defined(&NVME_SC_APPLICATION_TAG_CHECK_ERROR);
    eval("sub NVME_SC_REFERENCE_TAG_CHECK_ERROR () { 0x84; }") unless defined(&NVME_SC_REFERENCE_TAG_CHECK_ERROR);
    eval("sub NVME_SC_COMPARE_FAILURE () { 0x85; }") unless defined(&NVME_SC_COMPARE_FAILURE);
    eval("sub NVME_SC_ACCESS_DENIED () { 0x86; }") unless defined(&NVME_SC_ACCESS_DENIED);
    eval("sub NVME_OPC_DELETE_IO_SQ () { 0x00; }") unless defined(&NVME_OPC_DELETE_IO_SQ);
    eval("sub NVME_OPC_CREATE_IO_SQ () { 0x01; }") unless defined(&NVME_OPC_CREATE_IO_SQ);
    eval("sub NVME_OPC_GET_LOG_PAGE () { 0x02; }") unless defined(&NVME_OPC_GET_LOG_PAGE);
    eval("sub NVME_OPC_DELETE_IO_CQ () { 0x04; }") unless defined(&NVME_OPC_DELETE_IO_CQ);
    eval("sub NVME_OPC_CREATE_IO_CQ () { 0x05; }") unless defined(&NVME_OPC_CREATE_IO_CQ);
    eval("sub NVME_OPC_IDENTIFY () { 0x06; }") unless defined(&NVME_OPC_IDENTIFY);
    eval("sub NVME_OPC_ABORT () { 0x08; }") unless defined(&NVME_OPC_ABORT);
    eval("sub NVME_OPC_SET_FEATURES () { 0x09; }") unless defined(&NVME_OPC_SET_FEATURES);
    eval("sub NVME_OPC_GET_FEATURES () { 0x0a; }") unless defined(&NVME_OPC_GET_FEATURES);
    eval("sub NVME_OPC_ASYNC_EVENT_REQUEST () { 0x0c; }") unless defined(&NVME_OPC_ASYNC_EVENT_REQUEST);
    eval("sub NVME_OPC_NAMESPACE_MANAGEMENT () { 0x0d; }") unless defined(&NVME_OPC_NAMESPACE_MANAGEMENT);
    eval("sub NVME_OPC_FIRMWARE_ACTIVATE () { 0x10; }") unless defined(&NVME_OPC_FIRMWARE_ACTIVATE);
    eval("sub NVME_OPC_FIRMWARE_IMAGE_DOWNLOAD () { 0x11; }") unless defined(&NVME_OPC_FIRMWARE_IMAGE_DOWNLOAD);
    eval("sub NVME_OPC_NAMESPACE_ATTACHMENT () { 0x15; }") unless defined(&NVME_OPC_NAMESPACE_ATTACHMENT);
    eval("sub NVME_OPC_FORMAT_NVM () { 0x80; }") unless defined(&NVME_OPC_FORMAT_NVM);
    eval("sub NVME_OPC_SECURITY_SEND () { 0x81; }") unless defined(&NVME_OPC_SECURITY_SEND);
    eval("sub NVME_OPC_SECURITY_RECEIVE () { 0x82; }") unless defined(&NVME_OPC_SECURITY_RECEIVE);
    eval("sub NVME_OPC_FLUSH () { 0x00; }") unless defined(&NVME_OPC_FLUSH);
    eval("sub NVME_OPC_WRITE () { 0x01; }") unless defined(&NVME_OPC_WRITE);
    eval("sub NVME_OPC_READ () { 0x02; }") unless defined(&NVME_OPC_READ);
    eval("sub NVME_OPC_WRITE_UNCORRECTABLE () { 0x04; }") unless defined(&NVME_OPC_WRITE_UNCORRECTABLE);
    eval("sub NVME_OPC_COMPARE () { 0x05; }") unless defined(&NVME_OPC_COMPARE);
    eval("sub NVME_OPC_DATASET_MANAGEMENT () { 0x09; }") unless defined(&NVME_OPC_DATASET_MANAGEMENT);
    eval("sub NVME_FEAT_ARBITRATION () { 0x01; }") unless defined(&NVME_FEAT_ARBITRATION);
    eval("sub NVME_FEAT_POWER_MANAGEMENT () { 0x02; }") unless defined(&NVME_FEAT_POWER_MANAGEMENT);
    eval("sub NVME_FEAT_LBA_RANGE_TYPE () { 0x03; }") unless defined(&NVME_FEAT_LBA_RANGE_TYPE);
    eval("sub NVME_FEAT_TEMPERATURE_THRESHOLD () { 0x04; }") unless defined(&NVME_FEAT_TEMPERATURE_THRESHOLD);
    eval("sub NVME_FEAT_ERROR_RECOVERY () { 0x05; }") unless defined(&NVME_FEAT_ERROR_RECOVERY);
    eval("sub NVME_FEAT_VOLATILE_WRITE_CACHE () { 0x06; }") unless defined(&NVME_FEAT_VOLATILE_WRITE_CACHE);
    eval("sub NVME_FEAT_NUMBER_OF_QUEUES () { 0x07; }") unless defined(&NVME_FEAT_NUMBER_OF_QUEUES);
    eval("sub NVME_FEAT_INTERRUPT_COALESCING () { 0x08; }") unless defined(&NVME_FEAT_INTERRUPT_COALESCING);
    eval("sub NVME_FEAT_INTERRUPT_VECTOR_CONFIGURATION () { 0x09; }") unless defined(&NVME_FEAT_INTERRUPT_VECTOR_CONFIGURATION);
    eval("sub NVME_FEAT_WRITE_ATOMICITY () { 0x0A; }") unless defined(&NVME_FEAT_WRITE_ATOMICITY);
    eval("sub NVME_FEAT_ASYNC_EVENT_CONFIGURATION () { 0x0B; }") unless defined(&NVME_FEAT_ASYNC_EVENT_CONFIGURATION);
    eval("sub NVME_FEAT_AUTONOMOUS_POWER_STATE_TRANSITION () { 0x0C; }") unless defined(&NVME_FEAT_AUTONOMOUS_POWER_STATE_TRANSITION);
    eval("sub NVME_FEAT_HOST_MEMORY_BUFFER () { 0x0D; }") unless defined(&NVME_FEAT_HOST_MEMORY_BUFFER);
    eval("sub NVME_FEAT_TIMESTAMP () { 0x0E; }") unless defined(&NVME_FEAT_TIMESTAMP);
    eval("sub NVME_FEAT_KEEP_ALIVE_TIMER () { 0x0F; }") unless defined(&NVME_FEAT_KEEP_ALIVE_TIMER);
    eval("sub NVME_FEAT_HOST_CONTROLLED_THERMAL_MGMT () { 0x10; }") unless defined(&NVME_FEAT_HOST_CONTROLLED_THERMAL_MGMT);
    eval("sub NVME_FEAT_NON_OP_POWER_STATE_CONFIG () { 0x11; }") unless defined(&NVME_FEAT_NON_OP_POWER_STATE_CONFIG);
    eval("sub NVME_FEAT_SOFTWARE_PROGRESS_MARKER () { 0x80; }") unless defined(&NVME_FEAT_SOFTWARE_PROGRESS_MARKER);
    eval("sub NVME_DSM_ATTR_INTEGRAL_READ () { 0x1; }") unless defined(&NVME_DSM_ATTR_INTEGRAL_READ);
    eval("sub NVME_DSM_ATTR_INTEGRAL_WRITE () { 0x2; }") unless defined(&NVME_DSM_ATTR_INTEGRAL_WRITE);
    eval("sub NVME_DSM_ATTR_DEALLOCATE () { 0x4; }") unless defined(&NVME_DSM_ATTR_DEALLOCATE);
    eval("sub NVME_AA_REPLACE_NO_ACTIVATE () { 0x0; }") unless defined(&NVME_AA_REPLACE_NO_ACTIVATE);
    eval("sub NVME_AA_REPLACE_ACTIVATE () { 0x1; }") unless defined(&NVME_AA_REPLACE_ACTIVATE);
    eval("sub NVME_AA_ACTIVATE () { 0x2; }") unless defined(&NVME_AA_ACTIVATE);
    eval 'sub NVME_SERIAL_NUMBER_LENGTH () {20;}' unless defined(&NVME_SERIAL_NUMBER_LENGTH);
    eval 'sub NVME_MODEL_NUMBER_LENGTH () {40;}' unless defined(&NVME_MODEL_NUMBER_LENGTH);
    eval 'sub NVME_FIRMWARE_REVISION_LENGTH () {8;}' unless defined(&NVME_FIRMWARE_REVISION_LENGTH);
    eval("sub NVME_LOG_ERROR () { 0x01; }") unless defined(&NVME_LOG_ERROR);
    eval("sub NVME_LOG_HEALTH_INFORMATION () { 0x02; }") unless defined(&NVME_LOG_HEALTH_INFORMATION);
    eval("sub NVME_LOG_FIRMWARE_SLOT () { 0x03; }") unless defined(&NVME_LOG_FIRMWARE_SLOT);
    eval("sub NVME_LOG_CHANGED_NAMESPACE () { 0x04; }") unless defined(&NVME_LOG_CHANGED_NAMESPACE);
    eval("sub NVME_LOG_COMMAND_EFFECT () { 0x05; }") unless defined(&NVME_LOG_COMMAND_EFFECT);
    eval("sub NVME_LOG_RES_NOTIFICATION () { 0x80; }") unless defined(&NVME_LOG_RES_NOTIFICATION);
    eval("sub INTEL_LOG_READ_LAT_LOG () { 0xc1; }") unless defined(&INTEL_LOG_READ_LAT_LOG);
    eval("sub INTEL_LOG_WRITE_LAT_LOG () { 0xc2; }") unless defined(&INTEL_LOG_WRITE_LAT_LOG);
    eval("sub INTEL_LOG_TEMP_STATS () { 0xc5; }") unless defined(&INTEL_LOG_TEMP_STATS);
    eval("sub INTEL_LOG_ADD_SMART () { 0xca; }") unless defined(&INTEL_LOG_ADD_SMART);
    eval("sub INTEL_LOG_DRIVE_MKT_NAME () { 0xdd; }") unless defined(&INTEL_LOG_DRIVE_MKT_NAME);
    eval("sub HGST_INFO_LOG () { 0xc1; }") unless defined(&HGST_INFO_LOG);
    eval 'sub NVME_TEST_MAX_THREADS () {128;}' unless defined(&NVME_TEST_MAX_THREADS);
    eval("sub NVME_TEST_FLAG_REFTHREAD () { 0x1; }") unless defined(&NVME_TEST_FLAG_REFTHREAD);
    eval 'sub nvme_completion_is_error {
        my($cpl) = @_;
	    eval q((($cpl)-> ($status->{sc}) != 0|| ($cpl)-> ($status->{sct}) != 0));
    }' unless defined(&nvme_completion_is_error);
    if(defined(&_KERNEL)) {
	eval("sub NVME_NS_DEALLOCATE_SUPPORTED () { 0x1; }") unless defined(&NVME_NS_DEALLOCATE_SUPPORTED);
	eval("sub NVME_NS_FLUSH_SUPPORTED () { 0x2; }") unless defined(&NVME_NS_FLUSH_SUPPORTED);
    }
}
1;
