require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub PCI_DOMAINMAX () {65535;}' unless defined(&PCI_DOMAINMAX);
eval 'sub PCI_BUSMAX () {255;}' unless defined(&PCI_BUSMAX);
eval 'sub PCI_SLOTMAX () {31;}' unless defined(&PCI_SLOTMAX);
eval 'sub PCI_FUNCMAX () {7;}' unless defined(&PCI_FUNCMAX);
eval 'sub PCI_REGMAX () {255;}' unless defined(&PCI_REGMAX);
eval 'sub PCIE_REGMAX () {4095;}' unless defined(&PCIE_REGMAX);
eval 'sub PCI_MAXHDRTYPE () {2;}' unless defined(&PCI_MAXHDRTYPE);
eval 'sub PCIE_ARI_SLOTMAX () {0;}' unless defined(&PCIE_ARI_SLOTMAX);
eval 'sub PCIE_ARI_FUNCMAX () {255;}' unless defined(&PCIE_ARI_FUNCMAX);
eval 'sub PCI_RID_DOMAIN_SHIFT () {16;}' unless defined(&PCI_RID_DOMAIN_SHIFT);
eval 'sub PCI_RID_BUS_SHIFT () {8;}' unless defined(&PCI_RID_BUS_SHIFT);
eval 'sub PCI_RID_SLOT_SHIFT () {3;}' unless defined(&PCI_RID_SLOT_SHIFT);
eval 'sub PCI_RID_FUNC_SHIFT () {0;}' unless defined(&PCI_RID_FUNC_SHIFT);
unless(defined(&PCI_RID)) {
    sub PCI_RID {
	my($bus, $slot, $func) = @_;
	eval q((((($bus) &  &PCI_BUSMAX) <<  &PCI_RID_BUS_SHIFT) | ((($slot) &  &PCI_SLOTMAX) <<  &PCI_RID_SLOT_SHIFT) | ((($func) &  &PCI_FUNCMAX) <<  &PCI_RID_FUNC_SHIFT)));
    }
}
unless(defined(&PCI_ARI_RID)) {
    sub PCI_ARI_RID {
	my($bus, $func) = @_;
	eval q((((($bus) &  &PCI_BUSMAX) <<  &PCI_RID_BUS_SHIFT) | ((($func) &  &PCIE_ARI_FUNCMAX) <<  &PCI_RID_FUNC_SHIFT)));
    }
}
unless(defined(&PCI_RID2BUS)) {
    sub PCI_RID2BUS {
	my($rid) = @_;
	eval q(((($rid) >>  &PCI_RID_BUS_SHIFT) &  &PCI_BUSMAX));
    }
}
unless(defined(&PCI_RID2SLOT)) {
    sub PCI_RID2SLOT {
	my($rid) = @_;
	eval q(((($rid) >>  &PCI_RID_SLOT_SHIFT) &  &PCI_SLOTMAX));
    }
}
unless(defined(&PCI_RID2FUNC)) {
    sub PCI_RID2FUNC {
	my($rid) = @_;
	eval q(((($rid) >>  &PCI_RID_FUNC_SHIFT) &  &PCI_FUNCMAX));
    }
}
unless(defined(&PCIE_ARI_RID2SLOT)) {
    sub PCIE_ARI_RID2SLOT {
	my($rid) = @_;
	eval q((0));
    }
}
unless(defined(&PCIE_ARI_RID2FUNC)) {
    sub PCIE_ARI_RID2FUNC {
	my($rid) = @_;
	eval q(((($rid) >>  &PCI_RID_FUNC_SHIFT) &  &PCIE_ARI_FUNCMAX));
    }
}
unless(defined(&PCIE_ARI_SLOT)) {
    sub PCIE_ARI_SLOT {
	my($func) = @_;
	eval q(((($func) >>  &PCI_RID_SLOT_SHIFT) &  &PCI_SLOTMAX));
    }
}
unless(defined(&PCIE_ARI_FUNC)) {
    sub PCIE_ARI_FUNC {
	my($func) = @_;
	eval q(((($func) >>  &PCI_RID_FUNC_SHIFT) &  &PCI_FUNCMAX));
    }
}
eval 'sub PCIR_DEVVENDOR () {0x;}' unless defined(&PCIR_DEVVENDOR);
eval 'sub PCIR_VENDOR () {0x;}' unless defined(&PCIR_VENDOR);
eval 'sub PCIR_DEVICE () {0x2;}' unless defined(&PCIR_DEVICE);
eval 'sub PCIR_COMMAND () {0x4;}' unless defined(&PCIR_COMMAND);
eval 'sub PCIM_CMD_PORTEN () {0x1;}' unless defined(&PCIM_CMD_PORTEN);
eval 'sub PCIM_CMD_MEMEN () {0x2;}' unless defined(&PCIM_CMD_MEMEN);
eval 'sub PCIM_CMD_BUSMASTEREN () {0x4;}' unless defined(&PCIM_CMD_BUSMASTEREN);
eval 'sub PCIM_CMD_SPECIALEN () {0x8;}' unless defined(&PCIM_CMD_SPECIALEN);
eval 'sub PCIM_CMD_MWRICEN () {0x10;}' unless defined(&PCIM_CMD_MWRICEN);
eval 'sub PCIM_CMD_PERRESPEN () {0x40;}' unless defined(&PCIM_CMD_PERRESPEN);
eval 'sub PCIM_CMD_SERRESPEN () {0x100;}' unless defined(&PCIM_CMD_SERRESPEN);
eval 'sub PCIM_CMD_BACKTOBACK () {0x200;}' unless defined(&PCIM_CMD_BACKTOBACK);
eval 'sub PCIM_CMD_INTxDIS () {0x400;}' unless defined(&PCIM_CMD_INTxDIS);
eval 'sub PCIR_STATUS () {0x6;}' unless defined(&PCIR_STATUS);
eval 'sub PCIM_STATUS_INTxSTATE () {0x8;}' unless defined(&PCIM_STATUS_INTxSTATE);
eval 'sub PCIM_STATUS_CAPPRESENT () {0x10;}' unless defined(&PCIM_STATUS_CAPPRESENT);
eval 'sub PCIM_STATUS_66CAPABLE () {0x20;}' unless defined(&PCIM_STATUS_66CAPABLE);
eval 'sub PCIM_STATUS_BACKTOBACK () {0x80;}' unless defined(&PCIM_STATUS_BACKTOBACK);
eval 'sub PCIM_STATUS_MDPERR () {0x100;}' unless defined(&PCIM_STATUS_MDPERR);
eval 'sub PCIM_STATUS_SEL_FAST () {0x;}' unless defined(&PCIM_STATUS_SEL_FAST);
eval 'sub PCIM_STATUS_SEL_MEDIMUM () {0x200;}' unless defined(&PCIM_STATUS_SEL_MEDIMUM);
eval 'sub PCIM_STATUS_SEL_SLOW () {0x400;}' unless defined(&PCIM_STATUS_SEL_SLOW);
eval 'sub PCIM_STATUS_SEL_MASK () {0x600;}' unless defined(&PCIM_STATUS_SEL_MASK);
eval 'sub PCIM_STATUS_STABORT () {0x800;}' unless defined(&PCIM_STATUS_STABORT);
eval 'sub PCIM_STATUS_RTABORT () {0x1000;}' unless defined(&PCIM_STATUS_RTABORT);
eval 'sub PCIM_STATUS_RMABORT () {0x2000;}' unless defined(&PCIM_STATUS_RMABORT);
eval 'sub PCIM_STATUS_SERR () {0x4000;}' unless defined(&PCIM_STATUS_SERR);
eval 'sub PCIM_STATUS_PERR () {0x8000;}' unless defined(&PCIM_STATUS_PERR);
eval 'sub PCIR_REVID () {0x8;}' unless defined(&PCIR_REVID);
eval 'sub PCIR_PROGIF () {0x9;}' unless defined(&PCIR_PROGIF);
eval 'sub PCIR_SUBCLASS () {0xa;}' unless defined(&PCIR_SUBCLASS);
eval 'sub PCIR_CLASS () {0xb;}' unless defined(&PCIR_CLASS);
eval 'sub PCIR_CACHELNSZ () {0xc;}' unless defined(&PCIR_CACHELNSZ);
eval 'sub PCIR_LATTIMER () {0xd;}' unless defined(&PCIR_LATTIMER);
eval 'sub PCIR_HDRTYPE () {0xe;}' unless defined(&PCIR_HDRTYPE);
eval 'sub PCIM_HDRTYPE () {0x7f;}' unless defined(&PCIM_HDRTYPE);
eval 'sub PCIM_HDRTYPE_NORMAL () {0x;}' unless defined(&PCIM_HDRTYPE_NORMAL);
eval 'sub PCIM_HDRTYPE_BRIDGE () {0x1;}' unless defined(&PCIM_HDRTYPE_BRIDGE);
eval 'sub PCIM_HDRTYPE_CARDBUS () {0x2;}' unless defined(&PCIM_HDRTYPE_CARDBUS);
eval 'sub PCIM_MFDEV () {0x80;}' unless defined(&PCIM_MFDEV);
eval 'sub PCIR_BIST () {0xf;}' unless defined(&PCIR_BIST);
eval 'sub PCICAP_ID () {0x;}' unless defined(&PCICAP_ID);
eval 'sub PCICAP_NEXTPTR () {0x1;}' unless defined(&PCICAP_NEXTPTR);
eval 'sub PCIY_PMG () {0x1;}' unless defined(&PCIY_PMG);
eval 'sub PCIY_AGP () {0x2;}' unless defined(&PCIY_AGP);
eval 'sub PCIY_VPD () {0x3;}' unless defined(&PCIY_VPD);
eval 'sub PCIY_SLOTID () {0x4;}' unless defined(&PCIY_SLOTID);
eval 'sub PCIY_MSI () {0x5;}' unless defined(&PCIY_MSI);
eval 'sub PCIY_CHSWP () {0x6;}' unless defined(&PCIY_CHSWP);
eval 'sub PCIY_PCIX () {0x7;}' unless defined(&PCIY_PCIX);
eval 'sub PCIY_HT () {0x8;}' unless defined(&PCIY_HT);
eval 'sub PCIY_VENDOR () {0x9;}' unless defined(&PCIY_VENDOR);
eval 'sub PCIY_DEBUG () {0xa;}' unless defined(&PCIY_DEBUG);
eval 'sub PCIY_CRES () {0xb;}' unless defined(&PCIY_CRES);
eval 'sub PCIY_HOTPLUG () {0xc;}' unless defined(&PCIY_HOTPLUG);
eval 'sub PCIY_SUBVENDOR () {0xd;}' unless defined(&PCIY_SUBVENDOR);
eval 'sub PCIY_AGP8X () {0xe;}' unless defined(&PCIY_AGP8X);
eval 'sub PCIY_SECDEV () {0xf;}' unless defined(&PCIY_SECDEV);
eval 'sub PCIY_EXPRESS () {0x10;}' unless defined(&PCIY_EXPRESS);
eval 'sub PCIY_MSIX () {0x11;}' unless defined(&PCIY_MSIX);
eval 'sub PCIY_SATA () {0x12;}' unless defined(&PCIY_SATA);
eval 'sub PCIY_PCIAF () {0x13;}' unless defined(&PCIY_PCIAF);
eval 'sub PCIY_EA () {0x14;}' unless defined(&PCIY_EA);
eval 'sub PCIR_EXTCAP () {0x100;}' unless defined(&PCIR_EXTCAP);
eval 'sub PCIM_EXTCAP_ID () {0xffff;}' unless defined(&PCIM_EXTCAP_ID);
eval 'sub PCIM_EXTCAP_VER () {0xf0000;}' unless defined(&PCIM_EXTCAP_VER);
eval 'sub PCIM_EXTCAP_NEXTPTR () {0xfff00000;}' unless defined(&PCIM_EXTCAP_NEXTPTR);
unless(defined(&PCI_EXTCAP_ID)) {
    sub PCI_EXTCAP_ID {
	my($ecap) = @_;
	eval q((($ecap) &  &PCIM_EXTCAP_ID));
    }
}
unless(defined(&PCI_EXTCAP_VER)) {
    sub PCI_EXTCAP_VER {
	my($ecap) = @_;
	eval q(((($ecap) &  &PCIM_EXTCAP_VER) >> 16));
    }
}
unless(defined(&PCI_EXTCAP_NEXTPTR)) {
    sub PCI_EXTCAP_NEXTPTR {
	my($ecap) = @_;
	eval q(((($ecap) &  &PCIM_EXTCAP_NEXTPTR) >> 20));
    }
}
eval 'sub PCIZ_AER () {0x1;}' unless defined(&PCIZ_AER);
eval 'sub PCIZ_VC () {0x2;}' unless defined(&PCIZ_VC);
eval 'sub PCIZ_SERNUM () {0x3;}' unless defined(&PCIZ_SERNUM);
eval 'sub PCIZ_PWRBDGT () {0x4;}' unless defined(&PCIZ_PWRBDGT);
eval 'sub PCIZ_RCLINK_DCL () {0x5;}' unless defined(&PCIZ_RCLINK_DCL);
eval 'sub PCIZ_RCLINK_CTL () {0x6;}' unless defined(&PCIZ_RCLINK_CTL);
eval 'sub PCIZ_RCEC_ASSOC () {0x7;}' unless defined(&PCIZ_RCEC_ASSOC);
eval 'sub PCIZ_MFVC () {0x8;}' unless defined(&PCIZ_MFVC);
eval 'sub PCIZ_VC2 () {0x9;}' unless defined(&PCIZ_VC2);
eval 'sub PCIZ_RCRB () {0xa;}' unless defined(&PCIZ_RCRB);
eval 'sub PCIZ_VENDOR () {0xb;}' unless defined(&PCIZ_VENDOR);
eval 'sub PCIZ_CAC () {0xc;}' unless defined(&PCIZ_CAC);
eval 'sub PCIZ_ACS () {0xd;}' unless defined(&PCIZ_ACS);
eval 'sub PCIZ_ARI () {0xe;}' unless defined(&PCIZ_ARI);
eval 'sub PCIZ_ATS () {0xf;}' unless defined(&PCIZ_ATS);
eval 'sub PCIZ_SRIOV () {0x10;}' unless defined(&PCIZ_SRIOV);
eval 'sub PCIZ_MRIOV () {0x11;}' unless defined(&PCIZ_MRIOV);
eval 'sub PCIZ_MULTICAST () {0x12;}' unless defined(&PCIZ_MULTICAST);
eval 'sub PCIZ_PAGE_REQ () {0x13;}' unless defined(&PCIZ_PAGE_REQ);
eval 'sub PCIZ_AMD () {0x14;}' unless defined(&PCIZ_AMD);
eval 'sub PCIZ_RESIZE_BAR () {0x15;}' unless defined(&PCIZ_RESIZE_BAR);
eval 'sub PCIZ_DPA () {0x16;}' unless defined(&PCIZ_DPA);
eval 'sub PCIZ_TPH_REQ () {0x17;}' unless defined(&PCIZ_TPH_REQ);
eval 'sub PCIZ_LTR () {0x18;}' unless defined(&PCIZ_LTR);
eval 'sub PCIZ_SEC_PCIE () {0x19;}' unless defined(&PCIZ_SEC_PCIE);
eval 'sub PCIZ_PMUX () {0x1a;}' unless defined(&PCIZ_PMUX);
eval 'sub PCIZ_PASID () {0x1b;}' unless defined(&PCIZ_PASID);
eval 'sub PCIZ_LN_REQ () {0x1c;}' unless defined(&PCIZ_LN_REQ);
eval 'sub PCIZ_DPC () {0x1d;}' unless defined(&PCIZ_DPC);
eval 'sub PCIZ_L1PM () {0x1e;}' unless defined(&PCIZ_L1PM);
eval 'sub PCIR_BARS () {0x10;}' unless defined(&PCIR_BARS);
unless(defined(&PCIR_BAR)) {
    sub PCIR_BAR {
	my($x) = @_;
	eval q(( &PCIR_BARS + ($x) * 4));
    }
}
eval 'sub PCIR_MAX_BAR_0 () {5;}' unless defined(&PCIR_MAX_BAR_0);
unless(defined(&PCI_RID2BAR)) {
    sub PCI_RID2BAR {
	my($rid) = @_;
	eval q(((($rid) -  &PCIR_BARS) / 4));
    }
}
unless(defined(&PCI_BAR_IO)) {
    sub PCI_BAR_IO {
	my($x) = @_;
	eval q(((($x) &  &PCIM_BAR_SPACE) ==  &PCIM_BAR_IO_SPACE));
    }
}
unless(defined(&PCI_BAR_MEM)) {
    sub PCI_BAR_MEM {
	my($x) = @_;
	eval q(((($x) &  &PCIM_BAR_SPACE) ==  &PCIM_BAR_MEM_SPACE));
    }
}
eval 'sub PCIM_BAR_SPACE () {0x1;}' unless defined(&PCIM_BAR_SPACE);
eval 'sub PCIM_BAR_MEM_SPACE () {0;}' unless defined(&PCIM_BAR_MEM_SPACE);
eval 'sub PCIM_BAR_IO_SPACE () {1;}' unless defined(&PCIM_BAR_IO_SPACE);
eval 'sub PCIM_BAR_MEM_TYPE () {0x6;}' unless defined(&PCIM_BAR_MEM_TYPE);
eval 'sub PCIM_BAR_MEM_32 () {0;}' unless defined(&PCIM_BAR_MEM_32);
eval 'sub PCIM_BAR_MEM_1MB () {2;}' unless defined(&PCIM_BAR_MEM_1MB);
eval 'sub PCIM_BAR_MEM_64 () {4;}' unless defined(&PCIM_BAR_MEM_64);
eval 'sub PCIM_BAR_MEM_PREFETCH () {0x8;}' unless defined(&PCIM_BAR_MEM_PREFETCH);
eval 'sub PCIM_BAR_MEM_BASE () {0xfffffffffffffff0;}' unless defined(&PCIM_BAR_MEM_BASE);
eval 'sub PCIM_BAR_IO_RESERVED () {0x2;}' unless defined(&PCIM_BAR_IO_RESERVED);
eval 'sub PCIM_BAR_IO_BASE () {0xfffffffc;}' unless defined(&PCIM_BAR_IO_BASE);
eval 'sub PCIR_CIS () {0x28;}' unless defined(&PCIR_CIS);
eval 'sub PCIM_CIS_ASI_MASK () {0x7;}' unless defined(&PCIM_CIS_ASI_MASK);
eval 'sub PCIM_CIS_ASI_CONFIG () {0;}' unless defined(&PCIM_CIS_ASI_CONFIG);
eval 'sub PCIM_CIS_ASI_BAR0 () {1;}' unless defined(&PCIM_CIS_ASI_BAR0);
eval 'sub PCIM_CIS_ASI_BAR1 () {2;}' unless defined(&PCIM_CIS_ASI_BAR1);
eval 'sub PCIM_CIS_ASI_BAR2 () {3;}' unless defined(&PCIM_CIS_ASI_BAR2);
eval 'sub PCIM_CIS_ASI_BAR3 () {4;}' unless defined(&PCIM_CIS_ASI_BAR3);
eval 'sub PCIM_CIS_ASI_BAR4 () {5;}' unless defined(&PCIM_CIS_ASI_BAR4);
eval 'sub PCIM_CIS_ASI_BAR5 () {6;}' unless defined(&PCIM_CIS_ASI_BAR5);
eval 'sub PCIM_CIS_ASI_ROM () {7;}' unless defined(&PCIM_CIS_ASI_ROM);
eval 'sub PCIM_CIS_ADDR_MASK () {0xffffff8;}' unless defined(&PCIM_CIS_ADDR_MASK);
eval 'sub PCIM_CIS_ROM_MASK () {0xf0000000;}' unless defined(&PCIM_CIS_ROM_MASK);
eval 'sub PCIM_CIS_CONFIG_MASK () {0xff;}' unless defined(&PCIM_CIS_CONFIG_MASK);
eval 'sub PCIR_SUBVEND_0 () {0x2c;}' unless defined(&PCIR_SUBVEND_0);
eval 'sub PCIR_SUBDEV_0 () {0x2e;}' unless defined(&PCIR_SUBDEV_0);
eval 'sub PCIR_BIOS () {0x30;}' unless defined(&PCIR_BIOS);
eval 'sub PCIM_BIOS_ENABLE () {0x1;}' unless defined(&PCIM_BIOS_ENABLE);
eval 'sub PCIM_BIOS_ADDR_MASK () {0xfffff800;}' unless defined(&PCIM_BIOS_ADDR_MASK);
eval 'sub PCIR_CAP_PTR () {0x34;}' unless defined(&PCIR_CAP_PTR);
eval 'sub PCIR_INTLINE () {0x3c;}' unless defined(&PCIR_INTLINE);
eval 'sub PCIR_INTPIN () {0x3d;}' unless defined(&PCIR_INTPIN);
eval 'sub PCIR_MINGNT () {0x3e;}' unless defined(&PCIR_MINGNT);
eval 'sub PCIR_MAXLAT () {0x3f;}' unless defined(&PCIR_MAXLAT);
eval 'sub PCIR_MAX_BAR_1 () {1;}' unless defined(&PCIR_MAX_BAR_1);
eval 'sub PCIR_SECSTAT_1 () {0x1e;}' unless defined(&PCIR_SECSTAT_1);
eval 'sub PCIR_PRIBUS_1 () {0x18;}' unless defined(&PCIR_PRIBUS_1);
eval 'sub PCIR_SECBUS_1 () {0x19;}' unless defined(&PCIR_SECBUS_1);
eval 'sub PCIR_SUBBUS_1 () {0x1a;}' unless defined(&PCIR_SUBBUS_1);
eval 'sub PCIR_SECLAT_1 () {0x1b;}' unless defined(&PCIR_SECLAT_1);
eval 'sub PCIR_IOBASEL_1 () {0x1c;}' unless defined(&PCIR_IOBASEL_1);
eval 'sub PCIR_IOLIMITL_1 () {0x1d;}' unless defined(&PCIR_IOLIMITL_1);
eval 'sub PCIR_IOBASEH_1 () {0x30;}' unless defined(&PCIR_IOBASEH_1);
eval 'sub PCIR_IOLIMITH_1 () {0x32;}' unless defined(&PCIR_IOLIMITH_1);
eval 'sub PCIM_BRIO_16 () {0x;}' unless defined(&PCIM_BRIO_16);
eval 'sub PCIM_BRIO_32 () {0x1;}' unless defined(&PCIM_BRIO_32);
eval 'sub PCIM_BRIO_MASK () {0xf;}' unless defined(&PCIM_BRIO_MASK);
eval 'sub PCIR_MEMBASE_1 () {0x20;}' unless defined(&PCIR_MEMBASE_1);
eval 'sub PCIR_MEMLIMIT_1 () {0x22;}' unless defined(&PCIR_MEMLIMIT_1);
eval 'sub PCIR_PMBASEL_1 () {0x24;}' unless defined(&PCIR_PMBASEL_1);
eval 'sub PCIR_PMLIMITL_1 () {0x26;}' unless defined(&PCIR_PMLIMITL_1);
eval 'sub PCIR_PMBASEH_1 () {0x28;}' unless defined(&PCIR_PMBASEH_1);
eval 'sub PCIR_PMLIMITH_1 () {0x2c;}' unless defined(&PCIR_PMLIMITH_1);
eval 'sub PCIM_BRPM_32 () {0x;}' unless defined(&PCIM_BRPM_32);
eval 'sub PCIM_BRPM_64 () {0x1;}' unless defined(&PCIM_BRPM_64);
eval 'sub PCIM_BRPM_MASK () {0xf;}' unless defined(&PCIM_BRPM_MASK);
eval 'sub PCIR_BIOS_1 () {0x38;}' unless defined(&PCIR_BIOS_1);
eval 'sub PCIR_BRIDGECTL_1 () {0x3e;}' unless defined(&PCIR_BRIDGECTL_1);
unless(defined(&PCI_PPBMEMBASE)) {
    sub PCI_PPBMEMBASE {
	my($h,$l) = @_;
	eval q((((( &uint64_t)($h) << 32) + (($l)<<16)) & ~0xfffff));
    }
}
unless(defined(&PCI_PPBMEMLIMIT)) {
    sub PCI_PPBMEMLIMIT {
	my($h,$l) = @_;
	eval q((((( &uint64_t)($h) << 32) + (($l)<<16)) | 0xfffff));
    }
}
unless(defined(&PCI_PPBIOBASE)) {
    sub PCI_PPBIOBASE {
	my($h,$l) = @_;
	eval q((((($h)<<16) + (($l)<<8)) & ~0xfff));
    }
}
unless(defined(&PCI_PPBIOLIMIT)) {
    sub PCI_PPBIOLIMIT {
	my($h,$l) = @_;
	eval q((((($h)<<16) + (($l)<<8)) | 0xfff));
    }
}
eval 'sub PCIR_MAX_BAR_2 () {0;}' unless defined(&PCIR_MAX_BAR_2);
eval 'sub PCIR_CAP_PTR_2 () {0x14;}' unless defined(&PCIR_CAP_PTR_2);
eval 'sub PCIR_SECSTAT_2 () {0x16;}' unless defined(&PCIR_SECSTAT_2);
eval 'sub PCIR_PRIBUS_2 () {0x18;}' unless defined(&PCIR_PRIBUS_2);
eval 'sub PCIR_SECBUS_2 () {0x19;}' unless defined(&PCIR_SECBUS_2);
eval 'sub PCIR_SUBBUS_2 () {0x1a;}' unless defined(&PCIR_SUBBUS_2);
eval 'sub PCIR_SECLAT_2 () {0x1b;}' unless defined(&PCIR_SECLAT_2);
eval 'sub PCIR_MEMBASE0_2 () {0x1c;}' unless defined(&PCIR_MEMBASE0_2);
eval 'sub PCIR_MEMLIMIT0_2 () {0x20;}' unless defined(&PCIR_MEMLIMIT0_2);
eval 'sub PCIR_MEMBASE1_2 () {0x24;}' unless defined(&PCIR_MEMBASE1_2);
eval 'sub PCIR_MEMLIMIT1_2 () {0x28;}' unless defined(&PCIR_MEMLIMIT1_2);
eval 'sub PCIR_IOBASE0_2 () {0x2c;}' unless defined(&PCIR_IOBASE0_2);
eval 'sub PCIR_IOLIMIT0_2 () {0x30;}' unless defined(&PCIR_IOLIMIT0_2);
eval 'sub PCIR_IOBASE1_2 () {0x34;}' unless defined(&PCIR_IOBASE1_2);
eval 'sub PCIR_IOLIMIT1_2 () {0x38;}' unless defined(&PCIR_IOLIMIT1_2);
eval 'sub PCIM_CBBIO_16 () {0x;}' unless defined(&PCIM_CBBIO_16);
eval 'sub PCIM_CBBIO_32 () {0x1;}' unless defined(&PCIM_CBBIO_32);
eval 'sub PCIM_CBBIO_MASK () {0x3;}' unless defined(&PCIM_CBBIO_MASK);
eval 'sub PCIR_BRIDGECTL_2 () {0x3e;}' unless defined(&PCIR_BRIDGECTL_2);
eval 'sub PCIR_SUBVEND_2 () {0x40;}' unless defined(&PCIR_SUBVEND_2);
eval 'sub PCIR_SUBDEV_2 () {0x42;}' unless defined(&PCIR_SUBDEV_2);
eval 'sub PCIR_PCCARDIF_2 () {0x44;}' unless defined(&PCIR_PCCARDIF_2);
unless(defined(&PCI_CBBMEMBASE)) {
    sub PCI_CBBMEMBASE {
	my($l) = @_;
	eval q((($l) & ~0xfffff));
    }
}
unless(defined(&PCI_CBBMEMLIMIT)) {
    sub PCI_CBBMEMLIMIT {
	my($l) = @_;
	eval q((($l) | 0xfffff));
    }
}
unless(defined(&PCI_CBBIOBASE)) {
    sub PCI_CBBIOBASE {
	my($l) = @_;
	eval q((($l) & ~0x3));
    }
}
unless(defined(&PCI_CBBIOLIMIT)) {
    sub PCI_CBBIOLIMIT {
	my($l) = @_;
	eval q((($l) | 0x3));
    }
}
eval 'sub PCIC_OLD () {0x;}' unless defined(&PCIC_OLD);
eval 'sub PCIS_OLD_NONVGA () {0x;}' unless defined(&PCIS_OLD_NONVGA);
eval 'sub PCIS_OLD_VGA () {0x1;}' unless defined(&PCIS_OLD_VGA);
eval 'sub PCIC_STORAGE () {0x1;}' unless defined(&PCIC_STORAGE);
eval 'sub PCIS_STORAGE_SCSI () {0x;}' unless defined(&PCIS_STORAGE_SCSI);
eval 'sub PCIS_STORAGE_IDE () {0x1;}' unless defined(&PCIS_STORAGE_IDE);
eval 'sub PCIP_STORAGE_IDE_MODEPRIM () {0x1;}' unless defined(&PCIP_STORAGE_IDE_MODEPRIM);
eval 'sub PCIP_STORAGE_IDE_PROGINDPRIM () {0x2;}' unless defined(&PCIP_STORAGE_IDE_PROGINDPRIM);
eval 'sub PCIP_STORAGE_IDE_MODESEC () {0x4;}' unless defined(&PCIP_STORAGE_IDE_MODESEC);
eval 'sub PCIP_STORAGE_IDE_PROGINDSEC () {0x8;}' unless defined(&PCIP_STORAGE_IDE_PROGINDSEC);
eval 'sub PCIP_STORAGE_IDE_MASTERDEV () {0x80;}' unless defined(&PCIP_STORAGE_IDE_MASTERDEV);
eval 'sub PCIS_STORAGE_FLOPPY () {0x2;}' unless defined(&PCIS_STORAGE_FLOPPY);
eval 'sub PCIS_STORAGE_IPI () {0x3;}' unless defined(&PCIS_STORAGE_IPI);
eval 'sub PCIS_STORAGE_RAID () {0x4;}' unless defined(&PCIS_STORAGE_RAID);
eval 'sub PCIS_STORAGE_ATA_ADMA () {0x5;}' unless defined(&PCIS_STORAGE_ATA_ADMA);
eval 'sub PCIS_STORAGE_SATA () {0x6;}' unless defined(&PCIS_STORAGE_SATA);
eval 'sub PCIP_STORAGE_SATA_AHCI_1_0 () {0x1;}' unless defined(&PCIP_STORAGE_SATA_AHCI_1_0);
eval 'sub PCIS_STORAGE_SAS () {0x7;}' unless defined(&PCIS_STORAGE_SAS);
eval 'sub PCIS_STORAGE_NVM () {0x8;}' unless defined(&PCIS_STORAGE_NVM);
eval 'sub PCIP_STORAGE_NVM_NVMHCI_1_0 () {0x1;}' unless defined(&PCIP_STORAGE_NVM_NVMHCI_1_0);
eval 'sub PCIP_STORAGE_NVM_ENTERPRISE_NVMHCI_1_0 () {0x2;}' unless defined(&PCIP_STORAGE_NVM_ENTERPRISE_NVMHCI_1_0);
eval 'sub PCIS_STORAGE_OTHER () {0x80;}' unless defined(&PCIS_STORAGE_OTHER);
eval 'sub PCIC_NETWORK () {0x2;}' unless defined(&PCIC_NETWORK);
eval 'sub PCIS_NETWORK_ETHERNET () {0x;}' unless defined(&PCIS_NETWORK_ETHERNET);
eval 'sub PCIS_NETWORK_TOKENRING () {0x1;}' unless defined(&PCIS_NETWORK_TOKENRING);
eval 'sub PCIS_NETWORK_FDDI () {0x2;}' unless defined(&PCIS_NETWORK_FDDI);
eval 'sub PCIS_NETWORK_ATM () {0x3;}' unless defined(&PCIS_NETWORK_ATM);
eval 'sub PCIS_NETWORK_ISDN () {0x4;}' unless defined(&PCIS_NETWORK_ISDN);
eval 'sub PCIS_NETWORK_WORLDFIP () {0x5;}' unless defined(&PCIS_NETWORK_WORLDFIP);
eval 'sub PCIS_NETWORK_PICMG () {0x6;}' unless defined(&PCIS_NETWORK_PICMG);
eval 'sub PCIS_NETWORK_OTHER () {0x80;}' unless defined(&PCIS_NETWORK_OTHER);
eval 'sub PCIC_DISPLAY () {0x3;}' unless defined(&PCIC_DISPLAY);
eval 'sub PCIS_DISPLAY_VGA () {0x;}' unless defined(&PCIS_DISPLAY_VGA);
eval 'sub PCIS_DISPLAY_XGA () {0x1;}' unless defined(&PCIS_DISPLAY_XGA);
eval 'sub PCIS_DISPLAY_3D () {0x2;}' unless defined(&PCIS_DISPLAY_3D);
eval 'sub PCIS_DISPLAY_OTHER () {0x80;}' unless defined(&PCIS_DISPLAY_OTHER);
eval 'sub PCIC_MULTIMEDIA () {0x4;}' unless defined(&PCIC_MULTIMEDIA);
eval 'sub PCIS_MULTIMEDIA_VIDEO () {0x;}' unless defined(&PCIS_MULTIMEDIA_VIDEO);
eval 'sub PCIS_MULTIMEDIA_AUDIO () {0x1;}' unless defined(&PCIS_MULTIMEDIA_AUDIO);
eval 'sub PCIS_MULTIMEDIA_TELE () {0x2;}' unless defined(&PCIS_MULTIMEDIA_TELE);
eval 'sub PCIS_MULTIMEDIA_HDA () {0x3;}' unless defined(&PCIS_MULTIMEDIA_HDA);
eval 'sub PCIS_MULTIMEDIA_OTHER () {0x80;}' unless defined(&PCIS_MULTIMEDIA_OTHER);
eval 'sub PCIC_MEMORY () {0x5;}' unless defined(&PCIC_MEMORY);
eval 'sub PCIS_MEMORY_RAM () {0x;}' unless defined(&PCIS_MEMORY_RAM);
eval 'sub PCIS_MEMORY_FLASH () {0x1;}' unless defined(&PCIS_MEMORY_FLASH);
eval 'sub PCIS_MEMORY_OTHER () {0x80;}' unless defined(&PCIS_MEMORY_OTHER);
eval 'sub PCIC_BRIDGE () {0x6;}' unless defined(&PCIC_BRIDGE);
eval 'sub PCIS_BRIDGE_HOST () {0x;}' unless defined(&PCIS_BRIDGE_HOST);
eval 'sub PCIS_BRIDGE_ISA () {0x1;}' unless defined(&PCIS_BRIDGE_ISA);
eval 'sub PCIS_BRIDGE_EISA () {0x2;}' unless defined(&PCIS_BRIDGE_EISA);
eval 'sub PCIS_BRIDGE_MCA () {0x3;}' unless defined(&PCIS_BRIDGE_MCA);
eval 'sub PCIS_BRIDGE_PCI () {0x4;}' unless defined(&PCIS_BRIDGE_PCI);
eval 'sub PCIP_BRIDGE_PCI_SUBTRACTIVE () {0x1;}' unless defined(&PCIP_BRIDGE_PCI_SUBTRACTIVE);
eval 'sub PCIS_BRIDGE_PCMCIA () {0x5;}' unless defined(&PCIS_BRIDGE_PCMCIA);
eval 'sub PCIS_BRIDGE_NUBUS () {0x6;}' unless defined(&PCIS_BRIDGE_NUBUS);
eval 'sub PCIS_BRIDGE_CARDBUS () {0x7;}' unless defined(&PCIS_BRIDGE_CARDBUS);
eval 'sub PCIS_BRIDGE_RACEWAY () {0x8;}' unless defined(&PCIS_BRIDGE_RACEWAY);
eval 'sub PCIS_BRIDGE_PCI_TRANSPARENT () {0x9;}' unless defined(&PCIS_BRIDGE_PCI_TRANSPARENT);
eval 'sub PCIS_BRIDGE_INFINIBAND () {0xa;}' unless defined(&PCIS_BRIDGE_INFINIBAND);
eval 'sub PCIS_BRIDGE_OTHER () {0x80;}' unless defined(&PCIS_BRIDGE_OTHER);
eval 'sub PCIC_SIMPLECOMM () {0x7;}' unless defined(&PCIC_SIMPLECOMM);
eval 'sub PCIS_SIMPLECOMM_UART () {0x;}' unless defined(&PCIS_SIMPLECOMM_UART);
eval 'sub PCIP_SIMPLECOMM_UART_8250 () {0x;}' unless defined(&PCIP_SIMPLECOMM_UART_8250);
eval 'sub PCIP_SIMPLECOMM_UART_16450A () {0x1;}' unless defined(&PCIP_SIMPLECOMM_UART_16450A);
eval 'sub PCIP_SIMPLECOMM_UART_16550A () {0x2;}' unless defined(&PCIP_SIMPLECOMM_UART_16550A);
eval 'sub PCIP_SIMPLECOMM_UART_16650A () {0x3;}' unless defined(&PCIP_SIMPLECOMM_UART_16650A);
eval 'sub PCIP_SIMPLECOMM_UART_16750A () {0x4;}' unless defined(&PCIP_SIMPLECOMM_UART_16750A);
eval 'sub PCIP_SIMPLECOMM_UART_16850A () {0x5;}' unless defined(&PCIP_SIMPLECOMM_UART_16850A);
eval 'sub PCIP_SIMPLECOMM_UART_16950A () {0x6;}' unless defined(&PCIP_SIMPLECOMM_UART_16950A);
eval 'sub PCIS_SIMPLECOMM_PAR () {0x1;}' unless defined(&PCIS_SIMPLECOMM_PAR);
eval 'sub PCIS_SIMPLECOMM_MULSER () {0x2;}' unless defined(&PCIS_SIMPLECOMM_MULSER);
eval 'sub PCIS_SIMPLECOMM_MODEM () {0x3;}' unless defined(&PCIS_SIMPLECOMM_MODEM);
eval 'sub PCIS_SIMPLECOMM_GPIB () {0x4;}' unless defined(&PCIS_SIMPLECOMM_GPIB);
eval 'sub PCIS_SIMPLECOMM_SMART_CARD () {0x5;}' unless defined(&PCIS_SIMPLECOMM_SMART_CARD);
eval 'sub PCIS_SIMPLECOMM_OTHER () {0x80;}' unless defined(&PCIS_SIMPLECOMM_OTHER);
eval 'sub PCIC_BASEPERIPH () {0x8;}' unless defined(&PCIC_BASEPERIPH);
eval 'sub PCIS_BASEPERIPH_PIC () {0x;}' unless defined(&PCIS_BASEPERIPH_PIC);
eval 'sub PCIP_BASEPERIPH_PIC_8259A () {0x;}' unless defined(&PCIP_BASEPERIPH_PIC_8259A);
eval 'sub PCIP_BASEPERIPH_PIC_ISA () {0x1;}' unless defined(&PCIP_BASEPERIPH_PIC_ISA);
eval 'sub PCIP_BASEPERIPH_PIC_EISA () {0x2;}' unless defined(&PCIP_BASEPERIPH_PIC_EISA);
eval 'sub PCIP_BASEPERIPH_PIC_IO_APIC () {0x10;}' unless defined(&PCIP_BASEPERIPH_PIC_IO_APIC);
eval 'sub PCIP_BASEPERIPH_PIC_IOX_APIC () {0x20;}' unless defined(&PCIP_BASEPERIPH_PIC_IOX_APIC);
eval 'sub PCIS_BASEPERIPH_DMA () {0x1;}' unless defined(&PCIS_BASEPERIPH_DMA);
eval 'sub PCIS_BASEPERIPH_TIMER () {0x2;}' unless defined(&PCIS_BASEPERIPH_TIMER);
eval 'sub PCIS_BASEPERIPH_RTC () {0x3;}' unless defined(&PCIS_BASEPERIPH_RTC);
eval 'sub PCIS_BASEPERIPH_PCIHOT () {0x4;}' unless defined(&PCIS_BASEPERIPH_PCIHOT);
eval 'sub PCIS_BASEPERIPH_SDHC () {0x5;}' unless defined(&PCIS_BASEPERIPH_SDHC);
eval 'sub PCIS_BASEPERIPH_IOMMU () {0x6;}' unless defined(&PCIS_BASEPERIPH_IOMMU);
eval 'sub PCIS_BASEPERIPH_OTHER () {0x80;}' unless defined(&PCIS_BASEPERIPH_OTHER);
eval 'sub PCIC_INPUTDEV () {0x9;}' unless defined(&PCIC_INPUTDEV);
eval 'sub PCIS_INPUTDEV_KEYBOARD () {0x;}' unless defined(&PCIS_INPUTDEV_KEYBOARD);
eval 'sub PCIS_INPUTDEV_DIGITIZER () {0x1;}' unless defined(&PCIS_INPUTDEV_DIGITIZER);
eval 'sub PCIS_INPUTDEV_MOUSE () {0x2;}' unless defined(&PCIS_INPUTDEV_MOUSE);
eval 'sub PCIS_INPUTDEV_SCANNER () {0x3;}' unless defined(&PCIS_INPUTDEV_SCANNER);
eval 'sub PCIS_INPUTDEV_GAMEPORT () {0x4;}' unless defined(&PCIS_INPUTDEV_GAMEPORT);
eval 'sub PCIS_INPUTDEV_OTHER () {0x80;}' unless defined(&PCIS_INPUTDEV_OTHER);
eval 'sub PCIC_DOCKING () {0xa;}' unless defined(&PCIC_DOCKING);
eval 'sub PCIS_DOCKING_GENERIC () {0x;}' unless defined(&PCIS_DOCKING_GENERIC);
eval 'sub PCIS_DOCKING_OTHER () {0x80;}' unless defined(&PCIS_DOCKING_OTHER);
eval 'sub PCIC_PROCESSOR () {0xb;}' unless defined(&PCIC_PROCESSOR);
eval 'sub PCIS_PROCESSOR_386 () {0x;}' unless defined(&PCIS_PROCESSOR_386);
eval 'sub PCIS_PROCESSOR_486 () {0x1;}' unless defined(&PCIS_PROCESSOR_486);
eval 'sub PCIS_PROCESSOR_PENTIUM () {0x2;}' unless defined(&PCIS_PROCESSOR_PENTIUM);
eval 'sub PCIS_PROCESSOR_ALPHA () {0x10;}' unless defined(&PCIS_PROCESSOR_ALPHA);
eval 'sub PCIS_PROCESSOR_POWERPC () {0x20;}' unless defined(&PCIS_PROCESSOR_POWERPC);
eval 'sub PCIS_PROCESSOR_MIPS () {0x30;}' unless defined(&PCIS_PROCESSOR_MIPS);
eval 'sub PCIS_PROCESSOR_COPROC () {0x40;}' unless defined(&PCIS_PROCESSOR_COPROC);
eval 'sub PCIC_SERIALBUS () {0xc;}' unless defined(&PCIC_SERIALBUS);
eval 'sub PCIS_SERIALBUS_FW () {0x;}' unless defined(&PCIS_SERIALBUS_FW);
eval 'sub PCIS_SERIALBUS_ACCESS () {0x1;}' unless defined(&PCIS_SERIALBUS_ACCESS);
eval 'sub PCIS_SERIALBUS_SSA () {0x2;}' unless defined(&PCIS_SERIALBUS_SSA);
eval 'sub PCIS_SERIALBUS_USB () {0x3;}' unless defined(&PCIS_SERIALBUS_USB);
eval 'sub PCIP_SERIALBUS_USB_UHCI () {0x;}' unless defined(&PCIP_SERIALBUS_USB_UHCI);
eval 'sub PCIP_SERIALBUS_USB_OHCI () {0x10;}' unless defined(&PCIP_SERIALBUS_USB_OHCI);
eval 'sub PCIP_SERIALBUS_USB_EHCI () {0x20;}' unless defined(&PCIP_SERIALBUS_USB_EHCI);
eval 'sub PCIP_SERIALBUS_USB_XHCI () {0x30;}' unless defined(&PCIP_SERIALBUS_USB_XHCI);
eval 'sub PCIP_SERIALBUS_USB_DEVICE () {0xfe;}' unless defined(&PCIP_SERIALBUS_USB_DEVICE);
eval 'sub PCIS_SERIALBUS_FC () {0x4;}' unless defined(&PCIS_SERIALBUS_FC);
eval 'sub PCIS_SERIALBUS_SMBUS () {0x5;}' unless defined(&PCIS_SERIALBUS_SMBUS);
eval 'sub PCIS_SERIALBUS_INFINIBAND () {0x6;}' unless defined(&PCIS_SERIALBUS_INFINIBAND);
eval 'sub PCIS_SERIALBUS_IPMI () {0x7;}' unless defined(&PCIS_SERIALBUS_IPMI);
eval 'sub PCIP_SERIALBUS_IPMI_SMIC () {0x;}' unless defined(&PCIP_SERIALBUS_IPMI_SMIC);
eval 'sub PCIP_SERIALBUS_IPMI_KCS () {0x1;}' unless defined(&PCIP_SERIALBUS_IPMI_KCS);
eval 'sub PCIP_SERIALBUS_IPMI_BT () {0x2;}' unless defined(&PCIP_SERIALBUS_IPMI_BT);
eval 'sub PCIS_SERIALBUS_SERCOS () {0x8;}' unless defined(&PCIS_SERIALBUS_SERCOS);
eval 'sub PCIS_SERIALBUS_CANBUS () {0x9;}' unless defined(&PCIS_SERIALBUS_CANBUS);
eval 'sub PCIC_WIRELESS () {0xd;}' unless defined(&PCIC_WIRELESS);
eval 'sub PCIS_WIRELESS_IRDA () {0x;}' unless defined(&PCIS_WIRELESS_IRDA);
eval 'sub PCIS_WIRELESS_IR () {0x1;}' unless defined(&PCIS_WIRELESS_IR);
eval 'sub PCIS_WIRELESS_RF () {0x10;}' unless defined(&PCIS_WIRELESS_RF);
eval 'sub PCIS_WIRELESS_BLUETOOTH () {0x11;}' unless defined(&PCIS_WIRELESS_BLUETOOTH);
eval 'sub PCIS_WIRELESS_BROADBAND () {0x12;}' unless defined(&PCIS_WIRELESS_BROADBAND);
eval 'sub PCIS_WIRELESS_80211A () {0x20;}' unless defined(&PCIS_WIRELESS_80211A);
eval 'sub PCIS_WIRELESS_80211B () {0x21;}' unless defined(&PCIS_WIRELESS_80211B);
eval 'sub PCIS_WIRELESS_OTHER () {0x80;}' unless defined(&PCIS_WIRELESS_OTHER);
eval 'sub PCIC_INTELLIIO () {0xe;}' unless defined(&PCIC_INTELLIIO);
eval 'sub PCIS_INTELLIIO_I2O () {0x;}' unless defined(&PCIS_INTELLIIO_I2O);
eval 'sub PCIC_SATCOM () {0xf;}' unless defined(&PCIC_SATCOM);
eval 'sub PCIS_SATCOM_TV () {0x1;}' unless defined(&PCIS_SATCOM_TV);
eval 'sub PCIS_SATCOM_AUDIO () {0x2;}' unless defined(&PCIS_SATCOM_AUDIO);
eval 'sub PCIS_SATCOM_VOICE () {0x3;}' unless defined(&PCIS_SATCOM_VOICE);
eval 'sub PCIS_SATCOM_DATA () {0x4;}' unless defined(&PCIS_SATCOM_DATA);
eval 'sub PCIC_CRYPTO () {0x10;}' unless defined(&PCIC_CRYPTO);
eval 'sub PCIS_CRYPTO_NETCOMP () {0x;}' unless defined(&PCIS_CRYPTO_NETCOMP);
eval 'sub PCIS_CRYPTO_ENTERTAIN () {0x10;}' unless defined(&PCIS_CRYPTO_ENTERTAIN);
eval 'sub PCIS_CRYPTO_OTHER () {0x80;}' unless defined(&PCIS_CRYPTO_OTHER);
eval 'sub PCIC_DASP () {0x11;}' unless defined(&PCIC_DASP);
eval 'sub PCIS_DASP_DPIO () {0x;}' unless defined(&PCIS_DASP_DPIO);
eval 'sub PCIS_DASP_PERFCNTRS () {0x1;}' unless defined(&PCIS_DASP_PERFCNTRS);
eval 'sub PCIS_DASP_COMM_SYNC () {0x10;}' unless defined(&PCIS_DASP_COMM_SYNC);
eval 'sub PCIS_DASP_MGMT_CARD () {0x20;}' unless defined(&PCIS_DASP_MGMT_CARD);
eval 'sub PCIS_DASP_OTHER () {0x80;}' unless defined(&PCIS_DASP_OTHER);
eval 'sub PCIC_ACCEL () {0x12;}' unless defined(&PCIC_ACCEL);
eval 'sub PCIS_ACCEL_PROCESSING () {0x;}' unless defined(&PCIS_ACCEL_PROCESSING);
eval 'sub PCIC_INSTRUMENT () {0x13;}' unless defined(&PCIC_INSTRUMENT);
eval 'sub PCIC_OTHER () {0xff;}' unless defined(&PCIC_OTHER);
eval 'sub PCIB_BCR_PERR_ENABLE () {0x1;}' unless defined(&PCIB_BCR_PERR_ENABLE);
eval 'sub PCIB_BCR_SERR_ENABLE () {0x2;}' unless defined(&PCIB_BCR_SERR_ENABLE);
eval 'sub PCIB_BCR_ISA_ENABLE () {0x4;}' unless defined(&PCIB_BCR_ISA_ENABLE);
eval 'sub PCIB_BCR_VGA_ENABLE () {0x8;}' unless defined(&PCIB_BCR_VGA_ENABLE);
eval 'sub PCIB_BCR_MASTER_ABORT_MODE () {0x20;}' unless defined(&PCIB_BCR_MASTER_ABORT_MODE);
eval 'sub PCIB_BCR_SECBUS_RESET () {0x40;}' unless defined(&PCIB_BCR_SECBUS_RESET);
eval 'sub PCIB_BCR_SECBUS_BACKTOBACK () {0x80;}' unless defined(&PCIB_BCR_SECBUS_BACKTOBACK);
eval 'sub PCIB_BCR_PRI_DISCARD_TIMEOUT () {0x100;}' unless defined(&PCIB_BCR_PRI_DISCARD_TIMEOUT);
eval 'sub PCIB_BCR_SEC_DISCARD_TIMEOUT () {0x200;}' unless defined(&PCIB_BCR_SEC_DISCARD_TIMEOUT);
eval 'sub PCIB_BCR_DISCARD_TIMER_STATUS () {0x400;}' unless defined(&PCIB_BCR_DISCARD_TIMER_STATUS);
eval 'sub PCIB_BCR_DISCARD_TIMER_SERREN () {0x800;}' unless defined(&PCIB_BCR_DISCARD_TIMER_SERREN);
eval 'sub CBB_BCR_PERR_ENABLE () {0x1;}' unless defined(&CBB_BCR_PERR_ENABLE);
eval 'sub CBB_BCR_SERR_ENABLE () {0x2;}' unless defined(&CBB_BCR_SERR_ENABLE);
eval 'sub CBB_BCR_ISA_ENABLE () {0x4;}' unless defined(&CBB_BCR_ISA_ENABLE);
eval 'sub CBB_BCR_VGA_ENABLE () {0x8;}' unless defined(&CBB_BCR_VGA_ENABLE);
eval 'sub CBB_BCR_MASTER_ABORT_MODE () {0x20;}' unless defined(&CBB_BCR_MASTER_ABORT_MODE);
eval 'sub CBB_BCR_CARDBUS_RESET () {0x40;}' unless defined(&CBB_BCR_CARDBUS_RESET);
eval 'sub CBB_BCR_IREQ_INT_ENABLE () {0x80;}' unless defined(&CBB_BCR_IREQ_INT_ENABLE);
eval 'sub CBB_BCR_PREFETCH_0_ENABLE () {0x100;}' unless defined(&CBB_BCR_PREFETCH_0_ENABLE);
eval 'sub CBB_BCR_PREFETCH_1_ENABLE () {0x200;}' unless defined(&CBB_BCR_PREFETCH_1_ENABLE);
eval 'sub CBB_BCR_WRITE_POSTING_ENABLE () {0x400;}' unless defined(&CBB_BCR_WRITE_POSTING_ENABLE);
eval 'sub PCIR_POWER_CAP () {0x2;}' unless defined(&PCIR_POWER_CAP);
eval 'sub PCIM_PCAP_SPEC () {0x7;}' unless defined(&PCIM_PCAP_SPEC);
eval 'sub PCIM_PCAP_PMEREQCLK () {0x8;}' unless defined(&PCIM_PCAP_PMEREQCLK);
eval 'sub PCIM_PCAP_DEVSPECINIT () {0x20;}' unless defined(&PCIM_PCAP_DEVSPECINIT);
eval 'sub PCIM_PCAP_AUXPWR_0 () {0x;}' unless defined(&PCIM_PCAP_AUXPWR_0);
eval 'sub PCIM_PCAP_AUXPWR_55 () {0x40;}' unless defined(&PCIM_PCAP_AUXPWR_55);
eval 'sub PCIM_PCAP_AUXPWR_100 () {0x80;}' unless defined(&PCIM_PCAP_AUXPWR_100);
eval 'sub PCIM_PCAP_AUXPWR_160 () {0xc0;}' unless defined(&PCIM_PCAP_AUXPWR_160);
eval 'sub PCIM_PCAP_AUXPWR_220 () {0x100;}' unless defined(&PCIM_PCAP_AUXPWR_220);
eval 'sub PCIM_PCAP_AUXPWR_270 () {0x140;}' unless defined(&PCIM_PCAP_AUXPWR_270);
eval 'sub PCIM_PCAP_AUXPWR_320 () {0x180;}' unless defined(&PCIM_PCAP_AUXPWR_320);
eval 'sub PCIM_PCAP_AUXPWR_375 () {0x1c0;}' unless defined(&PCIM_PCAP_AUXPWR_375);
eval 'sub PCIM_PCAP_AUXPWRMASK () {0x1c0;}' unless defined(&PCIM_PCAP_AUXPWRMASK);
eval 'sub PCIM_PCAP_D1SUPP () {0x200;}' unless defined(&PCIM_PCAP_D1SUPP);
eval 'sub PCIM_PCAP_D2SUPP () {0x400;}' unless defined(&PCIM_PCAP_D2SUPP);
eval 'sub PCIM_PCAP_D0PME () {0x800;}' unless defined(&PCIM_PCAP_D0PME);
eval 'sub PCIM_PCAP_D1PME () {0x1000;}' unless defined(&PCIM_PCAP_D1PME);
eval 'sub PCIM_PCAP_D2PME () {0x2000;}' unless defined(&PCIM_PCAP_D2PME);
eval 'sub PCIM_PCAP_D3PME_HOT () {0x4000;}' unless defined(&PCIM_PCAP_D3PME_HOT);
eval 'sub PCIM_PCAP_D3PME_COLD () {0x8000;}' unless defined(&PCIM_PCAP_D3PME_COLD);
eval 'sub PCIR_POWER_STATUS () {0x4;}' unless defined(&PCIR_POWER_STATUS);
eval 'sub PCIM_PSTAT_D0 () {0x;}' unless defined(&PCIM_PSTAT_D0);
eval 'sub PCIM_PSTAT_D1 () {0x1;}' unless defined(&PCIM_PSTAT_D1);
eval 'sub PCIM_PSTAT_D2 () {0x2;}' unless defined(&PCIM_PSTAT_D2);
eval 'sub PCIM_PSTAT_D3 () {0x3;}' unless defined(&PCIM_PSTAT_D3);
eval 'sub PCIM_PSTAT_DMASK () {0x3;}' unless defined(&PCIM_PSTAT_DMASK);
eval 'sub PCIM_PSTAT_NOSOFTRESET () {0x8;}' unless defined(&PCIM_PSTAT_NOSOFTRESET);
eval 'sub PCIM_PSTAT_PMEENABLE () {0x100;}' unless defined(&PCIM_PSTAT_PMEENABLE);
eval 'sub PCIM_PSTAT_D0POWER () {0x;}' unless defined(&PCIM_PSTAT_D0POWER);
eval 'sub PCIM_PSTAT_D1POWER () {0x200;}' unless defined(&PCIM_PSTAT_D1POWER);
eval 'sub PCIM_PSTAT_D2POWER () {0x400;}' unless defined(&PCIM_PSTAT_D2POWER);
eval 'sub PCIM_PSTAT_D3POWER () {0x600;}' unless defined(&PCIM_PSTAT_D3POWER);
eval 'sub PCIM_PSTAT_D0HEAT () {0x800;}' unless defined(&PCIM_PSTAT_D0HEAT);
eval 'sub PCIM_PSTAT_D1HEAT () {0xa00;}' unless defined(&PCIM_PSTAT_D1HEAT);
eval 'sub PCIM_PSTAT_D2HEAT () {0xc00;}' unless defined(&PCIM_PSTAT_D2HEAT);
eval 'sub PCIM_PSTAT_D3HEAT () {0xe00;}' unless defined(&PCIM_PSTAT_D3HEAT);
eval 'sub PCIM_PSTAT_DATASELMASK () {0x1e00;}' unless defined(&PCIM_PSTAT_DATASELMASK);
eval 'sub PCIM_PSTAT_DATAUNKN () {0x;}' unless defined(&PCIM_PSTAT_DATAUNKN);
eval 'sub PCIM_PSTAT_DATADIV10 () {0x2000;}' unless defined(&PCIM_PSTAT_DATADIV10);
eval 'sub PCIM_PSTAT_DATADIV100 () {0x4000;}' unless defined(&PCIM_PSTAT_DATADIV100);
eval 'sub PCIM_PSTAT_DATADIV1000 () {0x6000;}' unless defined(&PCIM_PSTAT_DATADIV1000);
eval 'sub PCIM_PSTAT_DATADIVMASK () {0x6000;}' unless defined(&PCIM_PSTAT_DATADIVMASK);
eval 'sub PCIM_PSTAT_PME () {0x8000;}' unless defined(&PCIM_PSTAT_PME);
eval 'sub PCIR_POWER_BSE () {0x6;}' unless defined(&PCIR_POWER_BSE);
eval 'sub PCIM_PMCSR_BSE_D3B3 () {0x;}' unless defined(&PCIM_PMCSR_BSE_D3B3);
eval 'sub PCIM_PMCSR_BSE_D3B2 () {0x40;}' unless defined(&PCIM_PMCSR_BSE_D3B2);
eval 'sub PCIM_PMCSR_BSE_BPCCE () {0x80;}' unless defined(&PCIM_PMCSR_BSE_BPCCE);
eval 'sub PCIR_POWER_DATA () {0x7;}' unless defined(&PCIR_POWER_DATA);
eval 'sub PCIR_VPD_ADDR () {0x2;}' unless defined(&PCIR_VPD_ADDR);
eval 'sub PCIR_VPD_DATA () {0x4;}' unless defined(&PCIR_VPD_DATA);
eval 'sub PCIR_MSI_CTRL () {0x2;}' unless defined(&PCIR_MSI_CTRL);
eval 'sub PCIM_MSICTRL_VECTOR () {0x100;}' unless defined(&PCIM_MSICTRL_VECTOR);
eval 'sub PCIM_MSICTRL_64BIT () {0x80;}' unless defined(&PCIM_MSICTRL_64BIT);
eval 'sub PCIM_MSICTRL_MME_MASK () {0x70;}' unless defined(&PCIM_MSICTRL_MME_MASK);
eval 'sub PCIM_MSICTRL_MME_1 () {0x;}' unless defined(&PCIM_MSICTRL_MME_1);
eval 'sub PCIM_MSICTRL_MME_2 () {0x10;}' unless defined(&PCIM_MSICTRL_MME_2);
eval 'sub PCIM_MSICTRL_MME_4 () {0x20;}' unless defined(&PCIM_MSICTRL_MME_4);
eval 'sub PCIM_MSICTRL_MME_8 () {0x30;}' unless defined(&PCIM_MSICTRL_MME_8);
eval 'sub PCIM_MSICTRL_MME_16 () {0x40;}' unless defined(&PCIM_MSICTRL_MME_16);
eval 'sub PCIM_MSICTRL_MME_32 () {0x50;}' unless defined(&PCIM_MSICTRL_MME_32);
eval 'sub PCIM_MSICTRL_MMC_MASK () {0xe;}' unless defined(&PCIM_MSICTRL_MMC_MASK);
eval 'sub PCIM_MSICTRL_MMC_1 () {0x;}' unless defined(&PCIM_MSICTRL_MMC_1);
eval 'sub PCIM_MSICTRL_MMC_2 () {0x2;}' unless defined(&PCIM_MSICTRL_MMC_2);
eval 'sub PCIM_MSICTRL_MMC_4 () {0x4;}' unless defined(&PCIM_MSICTRL_MMC_4);
eval 'sub PCIM_MSICTRL_MMC_8 () {0x6;}' unless defined(&PCIM_MSICTRL_MMC_8);
eval 'sub PCIM_MSICTRL_MMC_16 () {0x8;}' unless defined(&PCIM_MSICTRL_MMC_16);
eval 'sub PCIM_MSICTRL_MMC_32 () {0xa;}' unless defined(&PCIM_MSICTRL_MMC_32);
eval 'sub PCIM_MSICTRL_MSI_ENABLE () {0x1;}' unless defined(&PCIM_MSICTRL_MSI_ENABLE);
eval 'sub PCIR_MSI_ADDR () {0x4;}' unless defined(&PCIR_MSI_ADDR);
eval 'sub PCIR_MSI_ADDR_HIGH () {0x8;}' unless defined(&PCIR_MSI_ADDR_HIGH);
eval 'sub PCIR_MSI_DATA () {0x8;}' unless defined(&PCIR_MSI_DATA);
eval 'sub PCIR_MSI_DATA_64BIT () {0xc;}' unless defined(&PCIR_MSI_DATA_64BIT);
eval 'sub PCIR_MSI_MASK () {0x10;}' unless defined(&PCIR_MSI_MASK);
eval 'sub PCIR_MSI_PENDING () {0x14;}' unless defined(&PCIR_MSI_PENDING);
eval 'sub PCIR_EA_NUM_ENT () {2;}' unless defined(&PCIR_EA_NUM_ENT);
eval 'sub PCIM_EA_NUM_ENT_MASK () {0x3f;}' unless defined(&PCIM_EA_NUM_ENT_MASK);
eval 'sub PCIR_EA_FIRST_ENT () {4;}' unless defined(&PCIR_EA_FIRST_ENT);
eval 'sub PCIR_EA_FIRST_ENT_BRIDGE () {8;}' unless defined(&PCIR_EA_FIRST_ENT_BRIDGE);
eval 'sub PCIM_EA_ES () {0x7;}' unless defined(&PCIM_EA_ES);
eval 'sub PCIM_EA_BEI () {0xf0;}' unless defined(&PCIM_EA_BEI);
eval 'sub PCIM_EA_BEI_OFFSET () {4;}' unless defined(&PCIM_EA_BEI_OFFSET);
eval 'sub PCIM_EA_BEI_BAR_0 () {0;}' unless defined(&PCIM_EA_BEI_BAR_0);
eval 'sub PCIM_EA_BEI_BAR_5 () {5;}' unless defined(&PCIM_EA_BEI_BAR_5);
unless(defined(&PCIM_EA_BEI_BAR)) {
    sub PCIM_EA_BEI_BAR {
	my($x) = @_;
	eval q(((($x) >>  &PCIM_EA_BEI_OFFSET) & 0xf));
    }
}
eval 'sub PCIM_EA_BEI_BRIDGE () {0x6;}' unless defined(&PCIM_EA_BEI_BRIDGE);
eval 'sub PCIM_EA_BEI_ENI () {0x7;}' unless defined(&PCIM_EA_BEI_ENI);
eval 'sub PCIM_EA_BEI_ROM () {0x8;}' unless defined(&PCIM_EA_BEI_ROM);
eval 'sub PCIM_EA_BEI_VF_BAR_0 () {9;}' unless defined(&PCIM_EA_BEI_VF_BAR_0);
eval 'sub PCIM_EA_BEI_VF_BAR_5 () {14;}' unless defined(&PCIM_EA_BEI_VF_BAR_5);
eval 'sub PCIM_EA_BEI_RESERVED () {0xf;}' unless defined(&PCIM_EA_BEI_RESERVED);
eval 'sub PCIM_EA_PP () {0xff00;}' unless defined(&PCIM_EA_PP);
eval 'sub PCIM_EA_PP_OFFSET () {8;}' unless defined(&PCIM_EA_PP_OFFSET);
eval 'sub PCIM_EA_SP_OFFSET () {16;}' unless defined(&PCIM_EA_SP_OFFSET);
eval 'sub PCIM_EA_SP () {0xff0000;}' unless defined(&PCIM_EA_SP);
eval 'sub PCIM_EA_P_MEM () {0x;}' unless defined(&PCIM_EA_P_MEM);
eval 'sub PCIM_EA_P_MEM_PREFETCH () {0x1;}' unless defined(&PCIM_EA_P_MEM_PREFETCH);
eval 'sub PCIM_EA_P_IO () {0x2;}' unless defined(&PCIM_EA_P_IO);
eval 'sub PCIM_EA_P_VF_MEM_PREFETCH () {0x3;}' unless defined(&PCIM_EA_P_VF_MEM_PREFETCH);
eval 'sub PCIM_EA_P_VF_MEM () {0x4;}' unless defined(&PCIM_EA_P_VF_MEM);
eval 'sub PCIM_EA_P_BRIDGE_MEM () {0x5;}' unless defined(&PCIM_EA_P_BRIDGE_MEM);
eval 'sub PCIM_EA_P_BRIDGE_MEM_PREFETCH () {0x6;}' unless defined(&PCIM_EA_P_BRIDGE_MEM_PREFETCH);
eval 'sub PCIM_EA_P_BRIDGE_IO () {0x7;}' unless defined(&PCIM_EA_P_BRIDGE_IO);
eval 'sub PCIM_EA_P_MEM_RESERVED () {0xfd;}' unless defined(&PCIM_EA_P_MEM_RESERVED);
eval 'sub PCIM_EA_P_IO_RESERVED () {0xfe;}' unless defined(&PCIM_EA_P_IO_RESERVED);
eval 'sub PCIM_EA_P_UNAVAILABLE () {0xff;}' unless defined(&PCIM_EA_P_UNAVAILABLE);
eval 'sub PCIM_EA_WRITABLE () {0x40000000;}' unless defined(&PCIM_EA_WRITABLE);
eval 'sub PCIM_EA_ENABLE () {0x80000000;}' unless defined(&PCIM_EA_ENABLE);
eval 'sub PCIM_EA_BASE () {4;}' unless defined(&PCIM_EA_BASE);
eval 'sub PCIM_EA_MAX_OFFSET () {8;}' unless defined(&PCIM_EA_MAX_OFFSET);
eval 'sub PCIM_EA_IS_64 () {0x2;}' unless defined(&PCIM_EA_IS_64);
eval 'sub PCIM_EA_FIELD_MASK () {0xfffffffc;}' unless defined(&PCIM_EA_FIELD_MASK);
unless(defined(&PCIM_EA_SEC_NR)) {
    sub PCIM_EA_SEC_NR {
	my($reg) = @_;
	eval q((($reg) & 0xff));
    }
}
unless(defined(&PCIM_EA_SUB_NR)) {
    sub PCIM_EA_SUB_NR {
	my($reg) = @_;
	eval q(((($reg) >> 8) & 0xff));
    }
}
eval 'sub PCIXR_COMMAND () {0x2;}' unless defined(&PCIXR_COMMAND);
eval 'sub PCIXM_COMMAND_DPERR_E () {0x1;}' unless defined(&PCIXM_COMMAND_DPERR_E);
eval 'sub PCIXM_COMMAND_ERO () {0x2;}' unless defined(&PCIXM_COMMAND_ERO);
eval 'sub PCIXM_COMMAND_MAX_READ () {0xc;}' unless defined(&PCIXM_COMMAND_MAX_READ);
eval 'sub PCIXM_COMMAND_MAX_READ_512 () {0x;}' unless defined(&PCIXM_COMMAND_MAX_READ_512);
eval 'sub PCIXM_COMMAND_MAX_READ_1024 () {0x4;}' unless defined(&PCIXM_COMMAND_MAX_READ_1024);
eval 'sub PCIXM_COMMAND_MAX_READ_2048 () {0x8;}' unless defined(&PCIXM_COMMAND_MAX_READ_2048);
eval 'sub PCIXM_COMMAND_MAX_READ_4096 () {0xc;}' unless defined(&PCIXM_COMMAND_MAX_READ_4096);
eval 'sub PCIXM_COMMAND_MAX_SPLITS () {0x70;}' unless defined(&PCIXM_COMMAND_MAX_SPLITS);
eval 'sub PCIXM_COMMAND_MAX_SPLITS_1 () {0x;}' unless defined(&PCIXM_COMMAND_MAX_SPLITS_1);
eval 'sub PCIXM_COMMAND_MAX_SPLITS_2 () {0x10;}' unless defined(&PCIXM_COMMAND_MAX_SPLITS_2);
eval 'sub PCIXM_COMMAND_MAX_SPLITS_3 () {0x20;}' unless defined(&PCIXM_COMMAND_MAX_SPLITS_3);
eval 'sub PCIXM_COMMAND_MAX_SPLITS_4 () {0x30;}' unless defined(&PCIXM_COMMAND_MAX_SPLITS_4);
eval 'sub PCIXM_COMMAND_MAX_SPLITS_8 () {0x40;}' unless defined(&PCIXM_COMMAND_MAX_SPLITS_8);
eval 'sub PCIXM_COMMAND_MAX_SPLITS_12 () {0x50;}' unless defined(&PCIXM_COMMAND_MAX_SPLITS_12);
eval 'sub PCIXM_COMMAND_MAX_SPLITS_16 () {0x60;}' unless defined(&PCIXM_COMMAND_MAX_SPLITS_16);
eval 'sub PCIXM_COMMAND_MAX_SPLITS_32 () {0x70;}' unless defined(&PCIXM_COMMAND_MAX_SPLITS_32);
eval 'sub PCIXM_COMMAND_VERSION () {0x3000;}' unless defined(&PCIXM_COMMAND_VERSION);
eval 'sub PCIXR_STATUS () {0x4;}' unless defined(&PCIXR_STATUS);
eval 'sub PCIXM_STATUS_DEVFN () {0xff;}' unless defined(&PCIXM_STATUS_DEVFN);
eval 'sub PCIXM_STATUS_BUS () {0xff00;}' unless defined(&PCIXM_STATUS_BUS);
eval 'sub PCIXM_STATUS_64BIT () {0x10000;}' unless defined(&PCIXM_STATUS_64BIT);
eval 'sub PCIXM_STATUS_133CAP () {0x20000;}' unless defined(&PCIXM_STATUS_133CAP);
eval 'sub PCIXM_STATUS_SC_DISCARDED () {0x40000;}' unless defined(&PCIXM_STATUS_SC_DISCARDED);
eval 'sub PCIXM_STATUS_UNEXP_SC () {0x80000;}' unless defined(&PCIXM_STATUS_UNEXP_SC);
eval 'sub PCIXM_STATUS_COMPLEX_DEV () {0x100000;}' unless defined(&PCIXM_STATUS_COMPLEX_DEV);
eval 'sub PCIXM_STATUS_MAX_READ () {0x600000;}' unless defined(&PCIXM_STATUS_MAX_READ);
eval 'sub PCIXM_STATUS_MAX_READ_512 () {0x;}' unless defined(&PCIXM_STATUS_MAX_READ_512);
eval 'sub PCIXM_STATUS_MAX_READ_1024 () {0x200000;}' unless defined(&PCIXM_STATUS_MAX_READ_1024);
eval 'sub PCIXM_STATUS_MAX_READ_2048 () {0x400000;}' unless defined(&PCIXM_STATUS_MAX_READ_2048);
eval 'sub PCIXM_STATUS_MAX_READ_4096 () {0x600000;}' unless defined(&PCIXM_STATUS_MAX_READ_4096);
eval 'sub PCIXM_STATUS_MAX_SPLITS () {0x3800000;}' unless defined(&PCIXM_STATUS_MAX_SPLITS);
eval 'sub PCIXM_STATUS_MAX_SPLITS_1 () {0x;}' unless defined(&PCIXM_STATUS_MAX_SPLITS_1);
eval 'sub PCIXM_STATUS_MAX_SPLITS_2 () {0x800000;}' unless defined(&PCIXM_STATUS_MAX_SPLITS_2);
eval 'sub PCIXM_STATUS_MAX_SPLITS_3 () {0x1000000;}' unless defined(&PCIXM_STATUS_MAX_SPLITS_3);
eval 'sub PCIXM_STATUS_MAX_SPLITS_4 () {0x1800000;}' unless defined(&PCIXM_STATUS_MAX_SPLITS_4);
eval 'sub PCIXM_STATUS_MAX_SPLITS_8 () {0x2000000;}' unless defined(&PCIXM_STATUS_MAX_SPLITS_8);
eval 'sub PCIXM_STATUS_MAX_SPLITS_12 () {0x2800000;}' unless defined(&PCIXM_STATUS_MAX_SPLITS_12);
eval 'sub PCIXM_STATUS_MAX_SPLITS_16 () {0x3000000;}' unless defined(&PCIXM_STATUS_MAX_SPLITS_16);
eval 'sub PCIXM_STATUS_MAX_SPLITS_32 () {0x3800000;}' unless defined(&PCIXM_STATUS_MAX_SPLITS_32);
eval 'sub PCIXM_STATUS_MAX_CUM_READ () {0x1c000000;}' unless defined(&PCIXM_STATUS_MAX_CUM_READ);
eval 'sub PCIXM_STATUS_RCVD_SC_ERR () {0x20000000;}' unless defined(&PCIXM_STATUS_RCVD_SC_ERR);
eval 'sub PCIXM_STATUS_266CAP () {0x40000000;}' unless defined(&PCIXM_STATUS_266CAP);
eval 'sub PCIXM_STATUS_533CAP () {0x80000000;}' unless defined(&PCIXM_STATUS_533CAP);
eval 'sub PCIXR_SEC_STATUS () {0x2;}' unless defined(&PCIXR_SEC_STATUS);
eval 'sub PCIXM_SEC_STATUS_64BIT () {0x1;}' unless defined(&PCIXM_SEC_STATUS_64BIT);
eval 'sub PCIXM_SEC_STATUS_133CAP () {0x2;}' unless defined(&PCIXM_SEC_STATUS_133CAP);
eval 'sub PCIXM_SEC_STATUS_SC_DISC () {0x4;}' unless defined(&PCIXM_SEC_STATUS_SC_DISC);
eval 'sub PCIXM_SEC_STATUS_UNEXP_SC () {0x8;}' unless defined(&PCIXM_SEC_STATUS_UNEXP_SC);
eval 'sub PCIXM_SEC_STATUS_SC_OVERRUN () {0x10;}' unless defined(&PCIXM_SEC_STATUS_SC_OVERRUN);
eval 'sub PCIXM_SEC_STATUS_SR_DELAYED () {0x20;}' unless defined(&PCIXM_SEC_STATUS_SR_DELAYED);
eval 'sub PCIXM_SEC_STATUS_BUS_MODE () {0x3c0;}' unless defined(&PCIXM_SEC_STATUS_BUS_MODE);
eval 'sub PCIXM_SEC_STATUS_VERSION () {0x3000;}' unless defined(&PCIXM_SEC_STATUS_VERSION);
eval 'sub PCIXM_SEC_STATUS_266CAP () {0x4000;}' unless defined(&PCIXM_SEC_STATUS_266CAP);
eval 'sub PCIXM_SEC_STATUS_533CAP () {0x8000;}' unless defined(&PCIXM_SEC_STATUS_533CAP);
eval 'sub PCIXR_BRIDGE_STATUS () {0x4;}' unless defined(&PCIXR_BRIDGE_STATUS);
eval 'sub PCIXM_BRIDGE_STATUS_DEVFN () {0xff;}' unless defined(&PCIXM_BRIDGE_STATUS_DEVFN);
eval 'sub PCIXM_BRIDGE_STATUS_BUS () {0xff00;}' unless defined(&PCIXM_BRIDGE_STATUS_BUS);
eval 'sub PCIXM_BRIDGE_STATUS_64BIT () {0x10000;}' unless defined(&PCIXM_BRIDGE_STATUS_64BIT);
eval 'sub PCIXM_BRIDGE_STATUS_133CAP () {0x20000;}' unless defined(&PCIXM_BRIDGE_STATUS_133CAP);
eval 'sub PCIXM_BRIDGE_STATUS_SC_DISCARDED () {0x40000;}' unless defined(&PCIXM_BRIDGE_STATUS_SC_DISCARDED);
eval 'sub PCIXM_BRIDGE_STATUS_UNEXP_SC () {0x80000;}' unless defined(&PCIXM_BRIDGE_STATUS_UNEXP_SC);
eval 'sub PCIXM_BRIDGE_STATUS_SC_OVERRUN () {0x100000;}' unless defined(&PCIXM_BRIDGE_STATUS_SC_OVERRUN);
eval 'sub PCIXM_BRIDGE_STATUS_SR_DELAYED () {0x200000;}' unless defined(&PCIXM_BRIDGE_STATUS_SR_DELAYED);
eval 'sub PCIXM_BRIDGE_STATUS_DEVID_MSGCAP () {0x20000000;}' unless defined(&PCIXM_BRIDGE_STATUS_DEVID_MSGCAP);
eval 'sub PCIXM_BRIDGE_STATUS_266CAP () {0x40000000;}' unless defined(&PCIXM_BRIDGE_STATUS_266CAP);
eval 'sub PCIXM_BRIDGE_STATUS_533CAP () {0x80000000;}' unless defined(&PCIXM_BRIDGE_STATUS_533CAP);
eval 'sub PCIR_HT_COMMAND () {0x2;}' unless defined(&PCIR_HT_COMMAND);
eval 'sub PCIM_HTCMD_CAP_MASK () {0xf800;}' unless defined(&PCIM_HTCMD_CAP_MASK);
eval 'sub PCIM_HTCAP_SLAVE () {0x;}' unless defined(&PCIM_HTCAP_SLAVE);
eval 'sub PCIM_HTCAP_HOST () {0x2000;}' unless defined(&PCIM_HTCAP_HOST);
eval 'sub PCIM_HTCAP_SWITCH () {0x4000;}' unless defined(&PCIM_HTCAP_SWITCH);
eval 'sub PCIM_HTCAP_INTERRUPT () {0x8000;}' unless defined(&PCIM_HTCAP_INTERRUPT);
eval 'sub PCIM_HTCAP_REVISION_ID () {0x8800;}' unless defined(&PCIM_HTCAP_REVISION_ID);
eval 'sub PCIM_HTCAP_UNITID_CLUMPING () {0x9000;}' unless defined(&PCIM_HTCAP_UNITID_CLUMPING);
eval 'sub PCIM_HTCAP_EXT_CONFIG_SPACE () {0x9800;}' unless defined(&PCIM_HTCAP_EXT_CONFIG_SPACE);
eval 'sub PCIM_HTCAP_ADDRESS_MAPPING () {0xa000;}' unless defined(&PCIM_HTCAP_ADDRESS_MAPPING);
eval 'sub PCIM_HTCAP_MSI_MAPPING () {0xa800;}' unless defined(&PCIM_HTCAP_MSI_MAPPING);
eval 'sub PCIM_HTCAP_DIRECT_ROUTE () {0xb000;}' unless defined(&PCIM_HTCAP_DIRECT_ROUTE);
eval 'sub PCIM_HTCAP_VCSET () {0xb800;}' unless defined(&PCIM_HTCAP_VCSET);
eval 'sub PCIM_HTCAP_RETRY_MODE () {0xc000;}' unless defined(&PCIM_HTCAP_RETRY_MODE);
eval 'sub PCIM_HTCAP_X86_ENCODING () {0xc800;}' unless defined(&PCIM_HTCAP_X86_ENCODING);
eval 'sub PCIM_HTCAP_GEN3 () {0xd000;}' unless defined(&PCIM_HTCAP_GEN3);
eval 'sub PCIM_HTCAP_FLE () {0xd800;}' unless defined(&PCIM_HTCAP_FLE);
eval 'sub PCIM_HTCAP_PM () {0xe000;}' unless defined(&PCIM_HTCAP_PM);
eval 'sub PCIM_HTCAP_HIGH_NODE_COUNT () {0xe800;}' unless defined(&PCIM_HTCAP_HIGH_NODE_COUNT);
eval 'sub PCIM_HTCMD_MSI_ENABLE () {0x1;}' unless defined(&PCIM_HTCMD_MSI_ENABLE);
eval 'sub PCIM_HTCMD_MSI_FIXED () {0x2;}' unless defined(&PCIM_HTCMD_MSI_FIXED);
eval 'sub PCIR_HTMSI_ADDRESS_LO () {0x4;}' unless defined(&PCIR_HTMSI_ADDRESS_LO);
eval 'sub PCIR_HTMSI_ADDRESS_HI () {0x8;}' unless defined(&PCIR_HTMSI_ADDRESS_HI);
eval 'sub PCIR_VENDOR_LENGTH () {0x2;}' unless defined(&PCIR_VENDOR_LENGTH);
eval 'sub PCIR_VENDOR_DATA () {0x3;}' unless defined(&PCIR_VENDOR_DATA);
eval 'sub PCIR_DEVICE_LENGTH () {0x2;}' unless defined(&PCIR_DEVICE_LENGTH);
eval 'sub PCIR_DEBUG_PORT () {0x2;}' unless defined(&PCIR_DEBUG_PORT);
eval 'sub PCIM_DEBUG_PORT_OFFSET () {0x1fff;}' unless defined(&PCIM_DEBUG_PORT_OFFSET);
eval 'sub PCIM_DEBUG_PORT_BAR () {0xe000;}' unless defined(&PCIM_DEBUG_PORT_BAR);
eval 'sub PCIR_SUBVENDCAP_ID () {0x4;}' unless defined(&PCIR_SUBVENDCAP_ID);
eval 'sub PCIER_FLAGS () {0x2;}' unless defined(&PCIER_FLAGS);
eval 'sub PCIEM_FLAGS_VERSION () {0xf;}' unless defined(&PCIEM_FLAGS_VERSION);
eval 'sub PCIEM_FLAGS_TYPE () {0xf0;}' unless defined(&PCIEM_FLAGS_TYPE);
eval 'sub PCIEM_TYPE_ENDPOINT () {0x;}' unless defined(&PCIEM_TYPE_ENDPOINT);
eval 'sub PCIEM_TYPE_LEGACY_ENDPOINT () {0x10;}' unless defined(&PCIEM_TYPE_LEGACY_ENDPOINT);
eval 'sub PCIEM_TYPE_ROOT_PORT () {0x40;}' unless defined(&PCIEM_TYPE_ROOT_PORT);
eval 'sub PCIEM_TYPE_UPSTREAM_PORT () {0x50;}' unless defined(&PCIEM_TYPE_UPSTREAM_PORT);
eval 'sub PCIEM_TYPE_DOWNSTREAM_PORT () {0x60;}' unless defined(&PCIEM_TYPE_DOWNSTREAM_PORT);
eval 'sub PCIEM_TYPE_PCI_BRIDGE () {0x70;}' unless defined(&PCIEM_TYPE_PCI_BRIDGE);
eval 'sub PCIEM_TYPE_PCIE_BRIDGE () {0x80;}' unless defined(&PCIEM_TYPE_PCIE_BRIDGE);
eval 'sub PCIEM_TYPE_ROOT_INT_EP () {0x90;}' unless defined(&PCIEM_TYPE_ROOT_INT_EP);
eval 'sub PCIEM_TYPE_ROOT_EC () {0xa0;}' unless defined(&PCIEM_TYPE_ROOT_EC);
eval 'sub PCIEM_FLAGS_SLOT () {0x100;}' unless defined(&PCIEM_FLAGS_SLOT);
eval 'sub PCIEM_FLAGS_IRQ () {0x3e00;}' unless defined(&PCIEM_FLAGS_IRQ);
eval 'sub PCIER_DEVICE_CAP () {0x4;}' unless defined(&PCIER_DEVICE_CAP);
eval 'sub PCIEM_CAP_MAX_PAYLOAD () {0x7;}' unless defined(&PCIEM_CAP_MAX_PAYLOAD);
eval 'sub PCIEM_CAP_PHANTHOM_FUNCS () {0x18;}' unless defined(&PCIEM_CAP_PHANTHOM_FUNCS);
eval 'sub PCIEM_CAP_EXT_TAG_FIELD () {0x20;}' unless defined(&PCIEM_CAP_EXT_TAG_FIELD);
eval 'sub PCIEM_CAP_L0S_LATENCY () {0x1c0;}' unless defined(&PCIEM_CAP_L0S_LATENCY);
eval 'sub PCIEM_CAP_L1_LATENCY () {0xe00;}' unless defined(&PCIEM_CAP_L1_LATENCY);
eval 'sub PCIEM_CAP_ROLE_ERR_RPT () {0x8000;}' unless defined(&PCIEM_CAP_ROLE_ERR_RPT);
eval 'sub PCIEM_CAP_SLOT_PWR_LIM_VAL () {0x3fc0000;}' unless defined(&PCIEM_CAP_SLOT_PWR_LIM_VAL);
eval 'sub PCIEM_CAP_SLOT_PWR_LIM_SCALE () {0xc000000;}' unless defined(&PCIEM_CAP_SLOT_PWR_LIM_SCALE);
eval 'sub PCIEM_CAP_FLR () {0x10000000;}' unless defined(&PCIEM_CAP_FLR);
eval 'sub PCIER_DEVICE_CTL () {0x8;}' unless defined(&PCIER_DEVICE_CTL);
eval 'sub PCIEM_CTL_COR_ENABLE () {0x1;}' unless defined(&PCIEM_CTL_COR_ENABLE);
eval 'sub PCIEM_CTL_NFER_ENABLE () {0x2;}' unless defined(&PCIEM_CTL_NFER_ENABLE);
eval 'sub PCIEM_CTL_FER_ENABLE () {0x4;}' unless defined(&PCIEM_CTL_FER_ENABLE);
eval 'sub PCIEM_CTL_URR_ENABLE () {0x8;}' unless defined(&PCIEM_CTL_URR_ENABLE);
eval 'sub PCIEM_CTL_RELAXED_ORD_ENABLE () {0x10;}' unless defined(&PCIEM_CTL_RELAXED_ORD_ENABLE);
eval 'sub PCIEM_CTL_MAX_PAYLOAD () {0xe0;}' unless defined(&PCIEM_CTL_MAX_PAYLOAD);
eval 'sub PCIEM_CTL_EXT_TAG_FIELD () {0x100;}' unless defined(&PCIEM_CTL_EXT_TAG_FIELD);
eval 'sub PCIEM_CTL_PHANTHOM_FUNCS () {0x200;}' unless defined(&PCIEM_CTL_PHANTHOM_FUNCS);
eval 'sub PCIEM_CTL_AUX_POWER_PM () {0x400;}' unless defined(&PCIEM_CTL_AUX_POWER_PM);
eval 'sub PCIEM_CTL_NOSNOOP_ENABLE () {0x800;}' unless defined(&PCIEM_CTL_NOSNOOP_ENABLE);
eval 'sub PCIEM_CTL_MAX_READ_REQUEST () {0x7000;}' unless defined(&PCIEM_CTL_MAX_READ_REQUEST);
eval 'sub PCIEM_CTL_BRDG_CFG_RETRY () {0x8000;}' unless defined(&PCIEM_CTL_BRDG_CFG_RETRY);
eval 'sub PCIEM_CTL_INITIATE_FLR () {0x8000;}' unless defined(&PCIEM_CTL_INITIATE_FLR);
eval 'sub PCIER_DEVICE_STA () {0xa;}' unless defined(&PCIER_DEVICE_STA);
eval 'sub PCIEM_STA_CORRECTABLE_ERROR () {0x1;}' unless defined(&PCIEM_STA_CORRECTABLE_ERROR);
eval 'sub PCIEM_STA_NON_FATAL_ERROR () {0x2;}' unless defined(&PCIEM_STA_NON_FATAL_ERROR);
eval 'sub PCIEM_STA_FATAL_ERROR () {0x4;}' unless defined(&PCIEM_STA_FATAL_ERROR);
eval 'sub PCIEM_STA_UNSUPPORTED_REQ () {0x8;}' unless defined(&PCIEM_STA_UNSUPPORTED_REQ);
eval 'sub PCIEM_STA_AUX_POWER () {0x10;}' unless defined(&PCIEM_STA_AUX_POWER);
eval 'sub PCIEM_STA_TRANSACTION_PND () {0x20;}' unless defined(&PCIEM_STA_TRANSACTION_PND);
eval 'sub PCIER_LINK_CAP () {0xc;}' unless defined(&PCIER_LINK_CAP);
eval 'sub PCIEM_LINK_CAP_MAX_SPEED () {0xf;}' unless defined(&PCIEM_LINK_CAP_MAX_SPEED);
eval 'sub PCIEM_LINK_CAP_MAX_WIDTH () {0x3f0;}' unless defined(&PCIEM_LINK_CAP_MAX_WIDTH);
eval 'sub PCIEM_LINK_CAP_ASPM () {0xc00;}' unless defined(&PCIEM_LINK_CAP_ASPM);
eval 'sub PCIEM_LINK_CAP_L0S_EXIT () {0x7000;}' unless defined(&PCIEM_LINK_CAP_L0S_EXIT);
eval 'sub PCIEM_LINK_CAP_L1_EXIT () {0x38000;}' unless defined(&PCIEM_LINK_CAP_L1_EXIT);
eval 'sub PCIEM_LINK_CAP_CLOCK_PM () {0x40000;}' unless defined(&PCIEM_LINK_CAP_CLOCK_PM);
eval 'sub PCIEM_LINK_CAP_SURPRISE_DOWN () {0x80000;}' unless defined(&PCIEM_LINK_CAP_SURPRISE_DOWN);
eval 'sub PCIEM_LINK_CAP_DL_ACTIVE () {0x100000;}' unless defined(&PCIEM_LINK_CAP_DL_ACTIVE);
eval 'sub PCIEM_LINK_CAP_LINK_BW_NOTIFY () {0x200000;}' unless defined(&PCIEM_LINK_CAP_LINK_BW_NOTIFY);
eval 'sub PCIEM_LINK_CAP_ASPM_COMPLIANCE () {0x400000;}' unless defined(&PCIEM_LINK_CAP_ASPM_COMPLIANCE);
eval 'sub PCIEM_LINK_CAP_PORT () {0xff000000;}' unless defined(&PCIEM_LINK_CAP_PORT);
eval 'sub PCIER_LINK_CTL () {0x10;}' unless defined(&PCIER_LINK_CTL);
eval 'sub PCIEM_LINK_CTL_ASPMC_DIS () {0x;}' unless defined(&PCIEM_LINK_CTL_ASPMC_DIS);
eval 'sub PCIEM_LINK_CTL_ASPMC_L0S () {0x1;}' unless defined(&PCIEM_LINK_CTL_ASPMC_L0S);
eval 'sub PCIEM_LINK_CTL_ASPMC_L1 () {0x2;}' unless defined(&PCIEM_LINK_CTL_ASPMC_L1);
eval 'sub PCIEM_LINK_CTL_ASPMC () {0x3;}' unless defined(&PCIEM_LINK_CTL_ASPMC);
eval 'sub PCIEM_LINK_CTL_RCB () {0x8;}' unless defined(&PCIEM_LINK_CTL_RCB);
eval 'sub PCIEM_LINK_CTL_LINK_DIS () {0x10;}' unless defined(&PCIEM_LINK_CTL_LINK_DIS);
eval 'sub PCIEM_LINK_CTL_RETRAIN_LINK () {0x20;}' unless defined(&PCIEM_LINK_CTL_RETRAIN_LINK);
eval 'sub PCIEM_LINK_CTL_COMMON_CLOCK () {0x40;}' unless defined(&PCIEM_LINK_CTL_COMMON_CLOCK);
eval 'sub PCIEM_LINK_CTL_EXTENDED_SYNC () {0x80;}' unless defined(&PCIEM_LINK_CTL_EXTENDED_SYNC);
eval 'sub PCIEM_LINK_CTL_ECPM () {0x100;}' unless defined(&PCIEM_LINK_CTL_ECPM);
eval 'sub PCIEM_LINK_CTL_HAWD () {0x200;}' unless defined(&PCIEM_LINK_CTL_HAWD);
eval 'sub PCIEM_LINK_CTL_LBMIE () {0x400;}' unless defined(&PCIEM_LINK_CTL_LBMIE);
eval 'sub PCIEM_LINK_CTL_LABIE () {0x800;}' unless defined(&PCIEM_LINK_CTL_LABIE);
eval 'sub PCIER_LINK_STA () {0x12;}' unless defined(&PCIER_LINK_STA);
eval 'sub PCIEM_LINK_STA_SPEED () {0xf;}' unless defined(&PCIEM_LINK_STA_SPEED);
eval 'sub PCIEM_LINK_STA_WIDTH () {0x3f0;}' unless defined(&PCIEM_LINK_STA_WIDTH);
eval 'sub PCIEM_LINK_STA_TRAINING_ERROR () {0x400;}' unless defined(&PCIEM_LINK_STA_TRAINING_ERROR);
eval 'sub PCIEM_LINK_STA_TRAINING () {0x800;}' unless defined(&PCIEM_LINK_STA_TRAINING);
eval 'sub PCIEM_LINK_STA_SLOT_CLOCK () {0x1000;}' unless defined(&PCIEM_LINK_STA_SLOT_CLOCK);
eval 'sub PCIEM_LINK_STA_DL_ACTIVE () {0x2000;}' unless defined(&PCIEM_LINK_STA_DL_ACTIVE);
eval 'sub PCIEM_LINK_STA_LINK_BW_MGMT () {0x4000;}' unless defined(&PCIEM_LINK_STA_LINK_BW_MGMT);
eval 'sub PCIEM_LINK_STA_LINK_AUTO_BW () {0x8000;}' unless defined(&PCIEM_LINK_STA_LINK_AUTO_BW);
eval 'sub PCIER_SLOT_CAP () {0x14;}' unless defined(&PCIER_SLOT_CAP);
eval 'sub PCIEM_SLOT_CAP_APB () {0x1;}' unless defined(&PCIEM_SLOT_CAP_APB);
eval 'sub PCIEM_SLOT_CAP_PCP () {0x2;}' unless defined(&PCIEM_SLOT_CAP_PCP);
eval 'sub PCIEM_SLOT_CAP_MRLSP () {0x4;}' unless defined(&PCIEM_SLOT_CAP_MRLSP);
eval 'sub PCIEM_SLOT_CAP_AIP () {0x8;}' unless defined(&PCIEM_SLOT_CAP_AIP);
eval 'sub PCIEM_SLOT_CAP_PIP () {0x10;}' unless defined(&PCIEM_SLOT_CAP_PIP);
eval 'sub PCIEM_SLOT_CAP_HPS () {0x20;}' unless defined(&PCIEM_SLOT_CAP_HPS);
eval 'sub PCIEM_SLOT_CAP_HPC () {0x40;}' unless defined(&PCIEM_SLOT_CAP_HPC);
eval 'sub PCIEM_SLOT_CAP_SPLV () {0x7f80;}' unless defined(&PCIEM_SLOT_CAP_SPLV);
eval 'sub PCIEM_SLOT_CAP_SPLS () {0x18000;}' unless defined(&PCIEM_SLOT_CAP_SPLS);
eval 'sub PCIEM_SLOT_CAP_EIP () {0x20000;}' unless defined(&PCIEM_SLOT_CAP_EIP);
eval 'sub PCIEM_SLOT_CAP_NCCS () {0x40000;}' unless defined(&PCIEM_SLOT_CAP_NCCS);
eval 'sub PCIEM_SLOT_CAP_PSN () {0xfff80000;}' unless defined(&PCIEM_SLOT_CAP_PSN);
eval 'sub PCIER_SLOT_CTL () {0x18;}' unless defined(&PCIER_SLOT_CTL);
eval 'sub PCIEM_SLOT_CTL_ABPE () {0x1;}' unless defined(&PCIEM_SLOT_CTL_ABPE);
eval 'sub PCIEM_SLOT_CTL_PFDE () {0x2;}' unless defined(&PCIEM_SLOT_CTL_PFDE);
eval 'sub PCIEM_SLOT_CTL_MRLSCE () {0x4;}' unless defined(&PCIEM_SLOT_CTL_MRLSCE);
eval 'sub PCIEM_SLOT_CTL_PDCE () {0x8;}' unless defined(&PCIEM_SLOT_CTL_PDCE);
eval 'sub PCIEM_SLOT_CTL_CCIE () {0x10;}' unless defined(&PCIEM_SLOT_CTL_CCIE);
eval 'sub PCIEM_SLOT_CTL_HPIE () {0x20;}' unless defined(&PCIEM_SLOT_CTL_HPIE);
eval 'sub PCIEM_SLOT_CTL_AIC () {0xc0;}' unless defined(&PCIEM_SLOT_CTL_AIC);
eval 'sub PCIEM_SLOT_CTL_AI_ON () {0x40;}' unless defined(&PCIEM_SLOT_CTL_AI_ON);
eval 'sub PCIEM_SLOT_CTL_AI_BLINK () {0x80;}' unless defined(&PCIEM_SLOT_CTL_AI_BLINK);
eval 'sub PCIEM_SLOT_CTL_AI_OFF () {0xc0;}' unless defined(&PCIEM_SLOT_CTL_AI_OFF);
eval 'sub PCIEM_SLOT_CTL_PIC () {0x300;}' unless defined(&PCIEM_SLOT_CTL_PIC);
eval 'sub PCIEM_SLOT_CTL_PI_ON () {0x100;}' unless defined(&PCIEM_SLOT_CTL_PI_ON);
eval 'sub PCIEM_SLOT_CTL_PI_BLINK () {0x200;}' unless defined(&PCIEM_SLOT_CTL_PI_BLINK);
eval 'sub PCIEM_SLOT_CTL_PI_OFF () {0x300;}' unless defined(&PCIEM_SLOT_CTL_PI_OFF);
eval 'sub PCIEM_SLOT_CTL_PCC () {0x400;}' unless defined(&PCIEM_SLOT_CTL_PCC);
eval 'sub PCIEM_SLOT_CTL_PC_ON () {0x;}' unless defined(&PCIEM_SLOT_CTL_PC_ON);
eval 'sub PCIEM_SLOT_CTL_PC_OFF () {0x400;}' unless defined(&PCIEM_SLOT_CTL_PC_OFF);
eval 'sub PCIEM_SLOT_CTL_EIC () {0x800;}' unless defined(&PCIEM_SLOT_CTL_EIC);
eval 'sub PCIEM_SLOT_CTL_DLLSCE () {0x1000;}' unless defined(&PCIEM_SLOT_CTL_DLLSCE);
eval 'sub PCIER_SLOT_STA () {0x1a;}' unless defined(&PCIER_SLOT_STA);
eval 'sub PCIEM_SLOT_STA_ABP () {0x1;}' unless defined(&PCIEM_SLOT_STA_ABP);
eval 'sub PCIEM_SLOT_STA_PFD () {0x2;}' unless defined(&PCIEM_SLOT_STA_PFD);
eval 'sub PCIEM_SLOT_STA_MRLSC () {0x4;}' unless defined(&PCIEM_SLOT_STA_MRLSC);
eval 'sub PCIEM_SLOT_STA_PDC () {0x8;}' unless defined(&PCIEM_SLOT_STA_PDC);
eval 'sub PCIEM_SLOT_STA_CC () {0x10;}' unless defined(&PCIEM_SLOT_STA_CC);
eval 'sub PCIEM_SLOT_STA_MRLSS () {0x20;}' unless defined(&PCIEM_SLOT_STA_MRLSS);
eval 'sub PCIEM_SLOT_STA_PDS () {0x40;}' unless defined(&PCIEM_SLOT_STA_PDS);
eval 'sub PCIEM_SLOT_STA_EIS () {0x80;}' unless defined(&PCIEM_SLOT_STA_EIS);
eval 'sub PCIEM_SLOT_STA_DLLSC () {0x100;}' unless defined(&PCIEM_SLOT_STA_DLLSC);
eval 'sub PCIER_ROOT_CTL () {0x1c;}' unless defined(&PCIER_ROOT_CTL);
eval 'sub PCIEM_ROOT_CTL_SERR_CORR () {0x1;}' unless defined(&PCIEM_ROOT_CTL_SERR_CORR);
eval 'sub PCIEM_ROOT_CTL_SERR_NONFATAL () {0x2;}' unless defined(&PCIEM_ROOT_CTL_SERR_NONFATAL);
eval 'sub PCIEM_ROOT_CTL_SERR_FATAL () {0x4;}' unless defined(&PCIEM_ROOT_CTL_SERR_FATAL);
eval 'sub PCIEM_ROOT_CTL_PME () {0x8;}' unless defined(&PCIEM_ROOT_CTL_PME);
eval 'sub PCIEM_ROOT_CTL_CRS_VIS () {0x10;}' unless defined(&PCIEM_ROOT_CTL_CRS_VIS);
eval 'sub PCIER_ROOT_CAP () {0x1e;}' unless defined(&PCIER_ROOT_CAP);
eval 'sub PCIEM_ROOT_CAP_CRS_VIS () {0x1;}' unless defined(&PCIEM_ROOT_CAP_CRS_VIS);
eval 'sub PCIER_ROOT_STA () {0x20;}' unless defined(&PCIER_ROOT_STA);
eval 'sub PCIEM_ROOT_STA_PME_REQID_MASK () {0xffff;}' unless defined(&PCIEM_ROOT_STA_PME_REQID_MASK);
eval 'sub PCIEM_ROOT_STA_PME_STATUS () {0x10000;}' unless defined(&PCIEM_ROOT_STA_PME_STATUS);
eval 'sub PCIEM_ROOT_STA_PME_PEND () {0x20000;}' unless defined(&PCIEM_ROOT_STA_PME_PEND);
eval 'sub PCIER_DEVICE_CAP2 () {0x24;}' unless defined(&PCIER_DEVICE_CAP2);
eval 'sub PCIEM_CAP2_COMP_TIMO_RANGES () {0xf;}' unless defined(&PCIEM_CAP2_COMP_TIMO_RANGES);
eval 'sub PCIEM_CAP2_COMP_TIMO_RANGE_A () {0x1;}' unless defined(&PCIEM_CAP2_COMP_TIMO_RANGE_A);
eval 'sub PCIEM_CAP2_COMP_TIMO_RANGE_B () {0x2;}' unless defined(&PCIEM_CAP2_COMP_TIMO_RANGE_B);
eval 'sub PCIEM_CAP2_COMP_TIMO_RANGE_C () {0x4;}' unless defined(&PCIEM_CAP2_COMP_TIMO_RANGE_C);
eval 'sub PCIEM_CAP2_COMP_TIMO_RANGE_D () {0x8;}' unless defined(&PCIEM_CAP2_COMP_TIMO_RANGE_D);
eval 'sub PCIEM_CAP2_COMP_TIMO_DISABLE () {0x10;}' unless defined(&PCIEM_CAP2_COMP_TIMO_DISABLE);
eval 'sub PCIEM_CAP2_ARI () {0x20;}' unless defined(&PCIEM_CAP2_ARI);
eval 'sub PCIER_DEVICE_CTL2 () {0x28;}' unless defined(&PCIER_DEVICE_CTL2);
eval 'sub PCIEM_CTL2_COMP_TIMO_VAL () {0xf;}' unless defined(&PCIEM_CTL2_COMP_TIMO_VAL);
eval 'sub PCIEM_CTL2_COMP_TIMO_50MS () {0x;}' unless defined(&PCIEM_CTL2_COMP_TIMO_50MS);
eval 'sub PCIEM_CTL2_COMP_TIMO_100US () {0x1;}' unless defined(&PCIEM_CTL2_COMP_TIMO_100US);
eval 'sub PCIEM_CTL2_COMP_TIMO_10MS () {0x2;}' unless defined(&PCIEM_CTL2_COMP_TIMO_10MS);
eval 'sub PCIEM_CTL2_COMP_TIMO_55MS () {0x5;}' unless defined(&PCIEM_CTL2_COMP_TIMO_55MS);
eval 'sub PCIEM_CTL2_COMP_TIMO_210MS () {0x6;}' unless defined(&PCIEM_CTL2_COMP_TIMO_210MS);
eval 'sub PCIEM_CTL2_COMP_TIMO_900MS () {0x9;}' unless defined(&PCIEM_CTL2_COMP_TIMO_900MS);
eval 'sub PCIEM_CTL2_COMP_TIMO_3500MS () {0xa;}' unless defined(&PCIEM_CTL2_COMP_TIMO_3500MS);
eval 'sub PCIEM_CTL2_COMP_TIMO_13S () {0xd;}' unless defined(&PCIEM_CTL2_COMP_TIMO_13S);
eval 'sub PCIEM_CTL2_COMP_TIMO_64S () {0xe;}' unless defined(&PCIEM_CTL2_COMP_TIMO_64S);
eval 'sub PCIEM_CTL2_COMP_TIMO_DISABLE () {0x10;}' unless defined(&PCIEM_CTL2_COMP_TIMO_DISABLE);
eval 'sub PCIEM_CTL2_ARI () {0x20;}' unless defined(&PCIEM_CTL2_ARI);
eval 'sub PCIEM_CTL2_ATOMIC_REQ_ENABLE () {0x40;}' unless defined(&PCIEM_CTL2_ATOMIC_REQ_ENABLE);
eval 'sub PCIEM_CTL2_ATOMIC_EGR_BLOCK () {0x80;}' unless defined(&PCIEM_CTL2_ATOMIC_EGR_BLOCK);
eval 'sub PCIEM_CTL2_ID_ORDERED_REQ_EN () {0x100;}' unless defined(&PCIEM_CTL2_ID_ORDERED_REQ_EN);
eval 'sub PCIEM_CTL2_ID_ORDERED_CMP_EN () {0x200;}' unless defined(&PCIEM_CTL2_ID_ORDERED_CMP_EN);
eval 'sub PCIEM_CTL2_LTR_ENABLE () {0x400;}' unless defined(&PCIEM_CTL2_LTR_ENABLE);
eval 'sub PCIEM_CTL2_OBFF () {0x6000;}' unless defined(&PCIEM_CTL2_OBFF);
eval 'sub PCIEM_OBFF_DISABLE () {0x;}' unless defined(&PCIEM_OBFF_DISABLE);
eval 'sub PCIEM_OBFF_MSGA_ENABLE () {0x2000;}' unless defined(&PCIEM_OBFF_MSGA_ENABLE);
eval 'sub PCIEM_OBFF_MSGB_ENABLE () {0x4000;}' unless defined(&PCIEM_OBFF_MSGB_ENABLE);
eval 'sub PCIEM_OBFF_WAKE_ENABLE () {0x6000;}' unless defined(&PCIEM_OBFF_WAKE_ENABLE);
eval 'sub PCIEM_CTL2_END2END_TLP () {0x8000;}' unless defined(&PCIEM_CTL2_END2END_TLP);
eval 'sub PCIER_DEVICE_STA2 () {0x2a;}' unless defined(&PCIER_DEVICE_STA2);
eval 'sub PCIER_LINK_CAP2 () {0x2c;}' unless defined(&PCIER_LINK_CAP2);
eval 'sub PCIER_LINK_CTL2 () {0x30;}' unless defined(&PCIER_LINK_CTL2);
eval 'sub PCIER_LINK_STA2 () {0x32;}' unless defined(&PCIER_LINK_STA2);
eval 'sub PCIER_SLOT_CAP2 () {0x34;}' unless defined(&PCIER_SLOT_CAP2);
eval 'sub PCIER_SLOT_CTL2 () {0x38;}' unless defined(&PCIER_SLOT_CTL2);
eval 'sub PCIER_SLOT_STA2 () {0x3a;}' unless defined(&PCIER_SLOT_STA2);
eval 'sub PCIR_MSIX_CTRL () {0x2;}' unless defined(&PCIR_MSIX_CTRL);
eval 'sub PCIM_MSIXCTRL_MSIX_ENABLE () {0x8000;}' unless defined(&PCIM_MSIXCTRL_MSIX_ENABLE);
eval 'sub PCIM_MSIXCTRL_FUNCTION_MASK () {0x4000;}' unless defined(&PCIM_MSIXCTRL_FUNCTION_MASK);
eval 'sub PCIM_MSIXCTRL_TABLE_SIZE () {0x7ff;}' unless defined(&PCIM_MSIXCTRL_TABLE_SIZE);
eval 'sub PCIR_MSIX_TABLE () {0x4;}' unless defined(&PCIR_MSIX_TABLE);
eval 'sub PCIR_MSIX_PBA () {0x8;}' unless defined(&PCIR_MSIX_PBA);
eval 'sub PCIM_MSIX_BIR_MASK () {0x7;}' unless defined(&PCIM_MSIX_BIR_MASK);
eval 'sub PCIM_MSIX_BIR_BAR_10 () {0;}' unless defined(&PCIM_MSIX_BIR_BAR_10);
eval 'sub PCIM_MSIX_BIR_BAR_14 () {1;}' unless defined(&PCIM_MSIX_BIR_BAR_14);
eval 'sub PCIM_MSIX_BIR_BAR_18 () {2;}' unless defined(&PCIM_MSIX_BIR_BAR_18);
eval 'sub PCIM_MSIX_BIR_BAR_1C () {3;}' unless defined(&PCIM_MSIX_BIR_BAR_1C);
eval 'sub PCIM_MSIX_BIR_BAR_20 () {4;}' unless defined(&PCIM_MSIX_BIR_BAR_20);
eval 'sub PCIM_MSIX_BIR_BAR_24 () {5;}' unless defined(&PCIM_MSIX_BIR_BAR_24);
eval 'sub PCIM_MSIX_VCTRL_MASK () {0x1;}' unless defined(&PCIM_MSIX_VCTRL_MASK);
eval 'sub PCIR_PCIAF_CAP () {0x3;}' unless defined(&PCIR_PCIAF_CAP);
eval 'sub PCIM_PCIAFCAP_TP () {0x1;}' unless defined(&PCIM_PCIAFCAP_TP);
eval 'sub PCIM_PCIAFCAP_FLR () {0x2;}' unless defined(&PCIM_PCIAFCAP_FLR);
eval 'sub PCIR_PCIAF_CTRL () {0x4;}' unless defined(&PCIR_PCIAF_CTRL);
eval 'sub PCIR_PCIAFCTRL_FLR () {0x1;}' unless defined(&PCIR_PCIAFCTRL_FLR);
eval 'sub PCIR_PCIAF_STATUS () {0x5;}' unless defined(&PCIR_PCIAF_STATUS);
eval 'sub PCIR_PCIAFSTATUS_TP () {0x1;}' unless defined(&PCIR_PCIAFSTATUS_TP);
eval 'sub PCIR_AER_UC_STATUS () {0x4;}' unless defined(&PCIR_AER_UC_STATUS);
eval 'sub PCIM_AER_UC_TRAINING_ERROR () {0x1;}' unless defined(&PCIM_AER_UC_TRAINING_ERROR);
eval 'sub PCIM_AER_UC_DL_PROTOCOL_ERROR () {0x10;}' unless defined(&PCIM_AER_UC_DL_PROTOCOL_ERROR);
eval 'sub PCIM_AER_UC_SURPRISE_LINK_DOWN () {0x20;}' unless defined(&PCIM_AER_UC_SURPRISE_LINK_DOWN);
eval 'sub PCIM_AER_UC_POISONED_TLP () {0x1000;}' unless defined(&PCIM_AER_UC_POISONED_TLP);
eval 'sub PCIM_AER_UC_FC_PROTOCOL_ERROR () {0x2000;}' unless defined(&PCIM_AER_UC_FC_PROTOCOL_ERROR);
eval 'sub PCIM_AER_UC_COMPLETION_TIMEOUT () {0x4000;}' unless defined(&PCIM_AER_UC_COMPLETION_TIMEOUT);
eval 'sub PCIM_AER_UC_COMPLETER_ABORT () {0x8000;}' unless defined(&PCIM_AER_UC_COMPLETER_ABORT);
eval 'sub PCIM_AER_UC_UNEXPECTED_COMPLETION () {0x10000;}' unless defined(&PCIM_AER_UC_UNEXPECTED_COMPLETION);
eval 'sub PCIM_AER_UC_RECEIVER_OVERFLOW () {0x20000;}' unless defined(&PCIM_AER_UC_RECEIVER_OVERFLOW);
eval 'sub PCIM_AER_UC_MALFORMED_TLP () {0x40000;}' unless defined(&PCIM_AER_UC_MALFORMED_TLP);
eval 'sub PCIM_AER_UC_ECRC_ERROR () {0x80000;}' unless defined(&PCIM_AER_UC_ECRC_ERROR);
eval 'sub PCIM_AER_UC_UNSUPPORTED_REQUEST () {0x100000;}' unless defined(&PCIM_AER_UC_UNSUPPORTED_REQUEST);
eval 'sub PCIM_AER_UC_ACS_VIOLATION () {0x200000;}' unless defined(&PCIM_AER_UC_ACS_VIOLATION);
eval 'sub PCIM_AER_UC_INTERNAL_ERROR () {0x400000;}' unless defined(&PCIM_AER_UC_INTERNAL_ERROR);
eval 'sub PCIM_AER_UC_MC_BLOCKED_TLP () {0x800000;}' unless defined(&PCIM_AER_UC_MC_BLOCKED_TLP);
eval 'sub PCIM_AER_UC_ATOMIC_EGRESS_BLK () {0x1000000;}' unless defined(&PCIM_AER_UC_ATOMIC_EGRESS_BLK);
eval 'sub PCIM_AER_UC_TLP_PREFIX_BLOCKED () {0x2000000;}' unless defined(&PCIM_AER_UC_TLP_PREFIX_BLOCKED);
eval 'sub PCIR_AER_UC_MASK () {0x8;}' unless defined(&PCIR_AER_UC_MASK);
eval 'sub PCIR_AER_UC_SEVERITY () {0xc;}' unless defined(&PCIR_AER_UC_SEVERITY);
eval 'sub PCIR_AER_COR_STATUS () {0x10;}' unless defined(&PCIR_AER_COR_STATUS);
eval 'sub PCIM_AER_COR_RECEIVER_ERROR () {0x1;}' unless defined(&PCIM_AER_COR_RECEIVER_ERROR);
eval 'sub PCIM_AER_COR_BAD_TLP () {0x40;}' unless defined(&PCIM_AER_COR_BAD_TLP);
eval 'sub PCIM_AER_COR_BAD_DLLP () {0x80;}' unless defined(&PCIM_AER_COR_BAD_DLLP);
eval 'sub PCIM_AER_COR_REPLAY_ROLLOVER () {0x100;}' unless defined(&PCIM_AER_COR_REPLAY_ROLLOVER);
eval 'sub PCIM_AER_COR_REPLAY_TIMEOUT () {0x1000;}' unless defined(&PCIM_AER_COR_REPLAY_TIMEOUT);
eval 'sub PCIM_AER_COR_ADVISORY_NF_ERROR () {0x2000;}' unless defined(&PCIM_AER_COR_ADVISORY_NF_ERROR);
eval 'sub PCIM_AER_COR_INTERNAL_ERROR () {0x4000;}' unless defined(&PCIM_AER_COR_INTERNAL_ERROR);
eval 'sub PCIM_AER_COR_HEADER_LOG_OVFLOW () {0x8000;}' unless defined(&PCIM_AER_COR_HEADER_LOG_OVFLOW);
eval 'sub PCIR_AER_COR_MASK () {0x14;}' unless defined(&PCIR_AER_COR_MASK);
eval 'sub PCIR_AER_CAP_CONTROL () {0x18;}' unless defined(&PCIR_AER_CAP_CONTROL);
eval 'sub PCIM_AER_FIRST_ERROR_PTR () {0x1f;}' unless defined(&PCIM_AER_FIRST_ERROR_PTR);
eval 'sub PCIM_AER_ECRC_GEN_CAPABLE () {0x20;}' unless defined(&PCIM_AER_ECRC_GEN_CAPABLE);
eval 'sub PCIM_AER_ECRC_GEN_ENABLE () {0x40;}' unless defined(&PCIM_AER_ECRC_GEN_ENABLE);
eval 'sub PCIM_AER_ECRC_CHECK_CAPABLE () {0x80;}' unless defined(&PCIM_AER_ECRC_CHECK_CAPABLE);
eval 'sub PCIM_AER_ECRC_CHECK_ENABLE () {0x100;}' unless defined(&PCIM_AER_ECRC_CHECK_ENABLE);
eval 'sub PCIM_AER_MULT_HDR_CAPABLE () {0x200;}' unless defined(&PCIM_AER_MULT_HDR_CAPABLE);
eval 'sub PCIM_AER_MULT_HDR_ENABLE () {0x400;}' unless defined(&PCIM_AER_MULT_HDR_ENABLE);
eval 'sub PCIM_AER_TLP_PREFIX_LOG_PRESENT () {0x800;}' unless defined(&PCIM_AER_TLP_PREFIX_LOG_PRESENT);
eval 'sub PCIR_AER_HEADER_LOG () {0x1c;}' unless defined(&PCIR_AER_HEADER_LOG);
eval 'sub PCIR_AER_ROOTERR_CMD () {0x2c;}' unless defined(&PCIR_AER_ROOTERR_CMD);
eval 'sub PCIM_AER_ROOTERR_COR_ENABLE () {0x1;}' unless defined(&PCIM_AER_ROOTERR_COR_ENABLE);
eval 'sub PCIM_AER_ROOTERR_NF_ENABLE () {0x2;}' unless defined(&PCIM_AER_ROOTERR_NF_ENABLE);
eval 'sub PCIM_AER_ROOTERR_F_ENABLE () {0x4;}' unless defined(&PCIM_AER_ROOTERR_F_ENABLE);
eval 'sub PCIR_AER_ROOTERR_STATUS () {0x30;}' unless defined(&PCIR_AER_ROOTERR_STATUS);
eval 'sub PCIM_AER_ROOTERR_COR_ERR () {0x1;}' unless defined(&PCIM_AER_ROOTERR_COR_ERR);
eval 'sub PCIM_AER_ROOTERR_MULTI_COR_ERR () {0x2;}' unless defined(&PCIM_AER_ROOTERR_MULTI_COR_ERR);
eval 'sub PCIM_AER_ROOTERR_UC_ERR () {0x4;}' unless defined(&PCIM_AER_ROOTERR_UC_ERR);
eval 'sub PCIM_AER_ROOTERR_MULTI_UC_ERR () {0x8;}' unless defined(&PCIM_AER_ROOTERR_MULTI_UC_ERR);
eval 'sub PCIM_AER_ROOTERR_FIRST_UC_FATAL () {0x10;}' unless defined(&PCIM_AER_ROOTERR_FIRST_UC_FATAL);
eval 'sub PCIM_AER_ROOTERR_NF_ERR () {0x20;}' unless defined(&PCIM_AER_ROOTERR_NF_ERR);
eval 'sub PCIM_AER_ROOTERR_F_ERR () {0x40;}' unless defined(&PCIM_AER_ROOTERR_F_ERR);
eval 'sub PCIM_AER_ROOTERR_INT_MESSAGE () {0xf8000000;}' unless defined(&PCIM_AER_ROOTERR_INT_MESSAGE);
eval 'sub PCIR_AER_COR_SOURCE_ID () {0x34;}' unless defined(&PCIR_AER_COR_SOURCE_ID);
eval 'sub PCIR_AER_ERR_SOURCE_ID () {0x36;}' unless defined(&PCIR_AER_ERR_SOURCE_ID);
eval 'sub PCIR_AER_TLP_PREFIX_LOG () {0x38;}' unless defined(&PCIR_AER_TLP_PREFIX_LOG);
eval 'sub PCIR_VC_CAP1 () {0x4;}' unless defined(&PCIR_VC_CAP1);
eval 'sub PCIM_VC_CAP1_EXT_COUNT () {0x7;}' unless defined(&PCIM_VC_CAP1_EXT_COUNT);
eval 'sub PCIM_VC_CAP1_LOWPRI_EXT_COUNT () {0x70;}' unless defined(&PCIM_VC_CAP1_LOWPRI_EXT_COUNT);
eval 'sub PCIR_VC_CAP2 () {0x8;}' unless defined(&PCIR_VC_CAP2);
eval 'sub PCIR_VC_CONTROL () {0xc;}' unless defined(&PCIR_VC_CONTROL);
eval 'sub PCIR_VC_STATUS () {0xe;}' unless defined(&PCIR_VC_STATUS);
unless(defined(&PCIR_VC_RESOURCE_CAP)) {
    sub PCIR_VC_RESOURCE_CAP {
	my($n) = @_;
	eval q((0x10 + ($n) * 0xc));
    }
}
unless(defined(&PCIR_VC_RESOURCE_CTL)) {
    sub PCIR_VC_RESOURCE_CTL {
	my($n) = @_;
	eval q((0x14 + ($n) * 0xc));
    }
}
unless(defined(&PCIR_VC_RESOURCE_STA)) {
    sub PCIR_VC_RESOURCE_STA {
	my($n) = @_;
	eval q((0x18 + ($n) * 0xc));
    }
}
eval 'sub PCIR_SERIAL_LOW () {0x4;}' unless defined(&PCIR_SERIAL_LOW);
eval 'sub PCIR_SERIAL_HIGH () {0x8;}' unless defined(&PCIR_SERIAL_HIGH);
eval 'sub PCIR_SRIOV_CTL () {0x8;}' unless defined(&PCIR_SRIOV_CTL);
eval 'sub PCIM_SRIOV_VF_EN () {0x1;}' unless defined(&PCIM_SRIOV_VF_EN);
eval 'sub PCIM_SRIOV_VF_MSE () {0x8;}' unless defined(&PCIM_SRIOV_VF_MSE);
eval 'sub PCIM_SRIOV_ARI_EN () {0x10;}' unless defined(&PCIM_SRIOV_ARI_EN);
eval 'sub PCIR_SRIOV_TOTAL_VFS () {0xe;}' unless defined(&PCIR_SRIOV_TOTAL_VFS);
eval 'sub PCIR_SRIOV_NUM_VFS () {0x10;}' unless defined(&PCIR_SRIOV_NUM_VFS);
eval 'sub PCIR_SRIOV_VF_OFF () {0x14;}' unless defined(&PCIR_SRIOV_VF_OFF);
eval 'sub PCIR_SRIOV_VF_STRIDE () {0x16;}' unless defined(&PCIR_SRIOV_VF_STRIDE);
eval 'sub PCIR_SRIOV_VF_DID () {0x1a;}' unless defined(&PCIR_SRIOV_VF_DID);
eval 'sub PCIR_SRIOV_PAGE_CAP () {0x1c;}' unless defined(&PCIR_SRIOV_PAGE_CAP);
eval 'sub PCIR_SRIOV_PAGE_SIZE () {0x20;}' unless defined(&PCIR_SRIOV_PAGE_SIZE);
eval 'sub PCI_SRIOV_BASE_PAGE_SHIFT () {12;}' unless defined(&PCI_SRIOV_BASE_PAGE_SHIFT);
eval 'sub PCIR_SRIOV_BARS () {0x24;}' unless defined(&PCIR_SRIOV_BARS);
unless(defined(&PCIR_SRIOV_BAR)) {
    sub PCIR_SRIOV_BAR {
	my($x) = @_;
	eval q(( &PCIR_SRIOV_BARS + ($x) * 4));
    }
}
1;
