require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__PPBCONF_H)) {
    eval 'sub __PPBCONF_H () {1;}' unless defined(&__PPBCONF_H);
    eval 'sub n {
        my($flags) = @_;
	    eval q((~($flags) & ($flags)));
    }' unless defined(&n);
    eval 'sub STROBE () {0x1;}' unless defined(&STROBE);
    eval 'sub AUTOFEED () {0x2;}' unless defined(&AUTOFEED);
    eval 'sub nINIT () {0x4;}' unless defined(&nINIT);
    eval 'sub SELECTIN () {0x8;}' unless defined(&SELECTIN);
    eval 'sub IRQENABLE () {0x10;}' unless defined(&IRQENABLE);
    eval 'sub PCD () {0x20;}' unless defined(&PCD);
    eval 'sub nSTROBE () { &n( &STROBE);}' unless defined(&nSTROBE);
    eval 'sub nAUTOFEED () { &n( &AUTOFEED);}' unless defined(&nAUTOFEED);
    eval 'sub INIT () { &n( &nINIT);}' unless defined(&INIT);
    eval 'sub nSELECTIN () { &n( &SELECTIN);}' unless defined(&nSELECTIN);
    eval 'sub nPCD () { &n( &PCD);}' unless defined(&nPCD);
    eval 'sub TIMEOUT () {0x1;}' unless defined(&TIMEOUT);
    eval 'sub nFAULT () {0x8;}' unless defined(&nFAULT);
    eval 'sub SELECT () {0x10;}' unless defined(&SELECT);
    eval 'sub PERROR () {0x20;}' unless defined(&PERROR);
    eval 'sub nACK () {0x40;}' unless defined(&nACK);
    eval 'sub nBUSY () {0x80;}' unless defined(&nBUSY);
    if(defined(&_KERNEL)) {
	require 'sys/queue.ph';
	eval 'sub PPBPRI () {( &PZERO+8);}' unless defined(&PPBPRI);
	eval 'sub PPB_COMPATIBLE () {0x;}' unless defined(&PPB_COMPATIBLE);
	eval 'sub PPB_NIBBLE () {0x1;}' unless defined(&PPB_NIBBLE);
	eval 'sub PPB_PS2 () {0x2;}' unless defined(&PPB_PS2);
	eval 'sub PPB_EPP () {0x4;}' unless defined(&PPB_EPP);
	eval 'sub PPB_ECP () {0x8;}' unless defined(&PPB_ECP);
	eval 'sub PPB_SPP () { &PPB_NIBBLE| &PPB_PS2;}' unless defined(&PPB_SPP);
	eval 'sub PPB_BYTE () { &PPB_PS2;}' unless defined(&PPB_BYTE);
	eval 'sub PPB_MASK () {0xf;}' unless defined(&PPB_MASK);
	eval 'sub PPB_OPTIONS_MASK () {0xf0;}' unless defined(&PPB_OPTIONS_MASK);
	eval 'sub PPB_IS_EPP {
	    my($mode) = @_;
    	    eval q(($mode &  &PPB_EPP));
	}' unless defined(&PPB_IS_EPP);
	eval 'sub PPB_IN_EPP_MODE {
	    my($bus) = @_;
    	    eval q(( &PPB_IS_EPP ( &ppb_get_mode ($bus))));
	}' unless defined(&PPB_IN_EPP_MODE);
	eval 'sub PPB_IN_NIBBLE_MODE {
	    my($bus) = @_;
    	    eval q(( &ppb_get_mode ($bus) &  &PPB_NIBBLE));
	}' unless defined(&PPB_IN_NIBBLE_MODE);
	eval 'sub PPB_IN_PS2_MODE {
	    my($bus) = @_;
    	    eval q(( &ppb_get_mode ($bus) &  &PPB_PS2));
	}' unless defined(&PPB_IN_PS2_MODE);
	eval 'sub PPB_OUTSB_EPP () {1;}' unless defined(&PPB_OUTSB_EPP);
	eval 'sub PPB_OUTSW_EPP () {2;}' unless defined(&PPB_OUTSW_EPP);
	eval 'sub PPB_OUTSL_EPP () {3;}' unless defined(&PPB_OUTSL_EPP);
	eval 'sub PPB_INSB_EPP () {4;}' unless defined(&PPB_INSB_EPP);
	eval 'sub PPB_INSW_EPP () {5;}' unless defined(&PPB_INSW_EPP);
	eval 'sub PPB_INSL_EPP () {6;}' unless defined(&PPB_INSL_EPP);
	eval 'sub PPB_RDTR () {7;}' unless defined(&PPB_RDTR);
	eval 'sub PPB_RSTR () {8;}' unless defined(&PPB_RSTR);
	eval 'sub PPB_RCTR () {9;}' unless defined(&PPB_RCTR);
	eval 'sub PPB_REPP_A () {10;}' unless defined(&PPB_REPP_A);
	eval 'sub PPB_REPP_D () {11;}' unless defined(&PPB_REPP_D);
	eval 'sub PPB_RECR () {12;}' unless defined(&PPB_RECR);
	eval 'sub PPB_RFIFO () {13;}' unless defined(&PPB_RFIFO);
	eval 'sub PPB_WDTR () {14;}' unless defined(&PPB_WDTR);
	eval 'sub PPB_WSTR () {15;}' unless defined(&PPB_WSTR);
	eval 'sub PPB_WCTR () {16;}' unless defined(&PPB_WCTR);
	eval 'sub PPB_WEPP_A () {17;}' unless defined(&PPB_WEPP_A);
	eval 'sub PPB_WEPP_D () {18;}' unless defined(&PPB_WEPP_D);
	eval 'sub PPB_WECR () {19;}' unless defined(&PPB_WECR);
	eval 'sub PPB_WFIFO () {20;}' unless defined(&PPB_WFIFO);
	eval 'sub PPB_DONTWAIT () {0;}' unless defined(&PPB_DONTWAIT);
	eval 'sub PPB_NOINTR () {0;}' unless defined(&PPB_NOINTR);
	eval 'sub PPB_WAIT () {0x1;}' unless defined(&PPB_WAIT);
	eval 'sub PPB_INTR () {0x2;}' unless defined(&PPB_INTR);
	eval 'sub PPB_POLL () {0x4;}' unless defined(&PPB_POLL);
	eval 'sub PPB_FOREVER () {-1;}' unless defined(&PPB_FOREVER);
	eval 'sub PPB_MS_MAXLEN () {64;}' unless defined(&PPB_MS_MAXLEN);
	eval 'sub PPB_MS_MAXARGS () {3;}' unless defined(&PPB_MS_MAXARGS);
	eval 'sub PPB_MAX_XFER () {6;}' unless defined(&PPB_MAX_XFER);
	eval 'sub PPBUS_IVAR_MODE () {0;}' unless defined(&PPBUS_IVAR_MODE);
	eval 'sub EPP_1_9 () {0x;}' unless defined(&EPP_1_9);
	eval 'sub EPP_1_7 () {0x1;}' unless defined(&EPP_1_7);
	eval 'sub PPC_IVAR_EPP_PROTO () {0;}' unless defined(&PPC_IVAR_EPP_PROTO);
	eval 'sub PPC_IVAR_LOCK () {1;}' unless defined(&PPC_IVAR_LOCK);
	eval 'sub PPC_IVAR_INTR_HANDLER () {2;}' unless defined(&PPC_IVAR_INTR_HANDLER);
	eval 'sub PPB_PnP_STRING_SIZE () {256;}' unless defined(&PPB_PnP_STRING_SIZE);
	eval 'sub PPB_PnP_PRINTER () {0;}' unless defined(&PPB_PnP_PRINTER);
	eval 'sub PPB_PnP_MODEM () {1;}' unless defined(&PPB_PnP_MODEM);
	eval 'sub PPB_PnP_NET () {2;}' unless defined(&PPB_PnP_NET);
	eval 'sub PPB_PnP_HDC () {3;}' unless defined(&PPB_PnP_HDC);
	eval 'sub PPB_PnP_PCMCIA () {4;}' unless defined(&PPB_PnP_PCMCIA);
	eval 'sub PPB_PnP_MEDIA () {5;}' unless defined(&PPB_PnP_MEDIA);
	eval 'sub PPB_PnP_FDC () {6;}' unless defined(&PPB_PnP_FDC);
	eval 'sub PPB_PnP_PORTS () {7;}' unless defined(&PPB_PnP_PORTS);
	eval 'sub PPB_PnP_SCANNER () {8;}' unless defined(&PPB_PnP_SCANNER);
	eval 'sub PPB_PnP_DIGICAM () {9;}' unless defined(&PPB_PnP_DIGICAM);
	eval 'sub PPB_PnP_UNKNOWN () {10;}' unless defined(&PPB_PnP_UNKNOWN);
	if(defined(&INVARIANTS)) {
	    eval 'sub ppb_assert_locked {
	        my($dev) = @_;
    		eval q( &_ppb_assert_locked($dev,  &__FILE__,  &__LINE__));
	    }' unless defined(&ppb_assert_locked);
	} else {
	    eval 'sub ppb_assert_locked {
	        my($dev) = @_;
    		eval q();
	    }' unless defined(&ppb_assert_locked);
	}
    }
}
1;
