require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_USB_DEVICE_H_)) {
    eval 'sub _USB_DEVICE_H_ () {1;}' unless defined(&_USB_DEVICE_H_);
    unless(defined(&USB_GLOBAL_INCLUDE_FILE)) {
	require 'dev/usb/usb_core.ph';
	require 'dev/usb/usb_busdma.ph';
	require 'dev/usb/usb_transfer.ph';
    }
    eval 'sub USB_CTRL_XFER_MAX () {2;}' unless defined(&USB_CTRL_XFER_MAX);
    eval 'sub USB_CFG_ALLOC () {0;}' unless defined(&USB_CFG_ALLOC);
    eval 'sub USB_CFG_FREE () {1;}' unless defined(&USB_CFG_FREE);
    eval 'sub USB_CFG_INIT () {2;}' unless defined(&USB_CFG_INIT);
    eval 'sub USB_UNCFG_FLAG_NONE () {0x;}' unless defined(&USB_UNCFG_FLAG_NONE);
    eval 'sub USB_UNCFG_FLAG_FREE_EP0 () {0x2;}' unless defined(&USB_UNCFG_FLAG_FREE_EP0);
    if(((defined(&USB_HAVE_FIXED_IFACE) ? &USB_HAVE_FIXED_IFACE : undef) == 0)) {
    } else {
    }
    if(((defined(&USB_HAVE_FIXED_ENDPOINT) ? &USB_HAVE_FIXED_ENDPOINT : undef) == 0)) {
    } else {
    }
    if((defined(&USB_HAVE_UGEN) ? &USB_HAVE_UGEN : undef)) {
    }
    eval 'sub USB_DEV_REF_MAX () {0xffff;}' unless defined(&USB_DEV_REF_MAX);
    eval 'sub USB_RE_ENUM_DONE () {0;}' unless defined(&USB_RE_ENUM_DONE);
    eval 'sub USB_RE_ENUM_START () {1;}' unless defined(&USB_RE_ENUM_START);
    eval 'sub USB_RE_ENUM_PWR_OFF () {2;}' unless defined(&USB_RE_ENUM_PWR_OFF);
    eval 'sub USB_RE_ENUM_SET_CONFIG () {3;}' unless defined(&USB_RE_ENUM_SET_CONFIG);
    if((defined(&USB_HAVE_COMPAT_LINUX) ? &USB_HAVE_COMPAT_LINUX : undef)) {
    }
    if(((defined(&USB_HAVE_FIXED_CONFIG) ? &USB_HAVE_FIXED_CONFIG : undef) != 0)) {
    }
    if((defined(&USB_HAVE_UGEN) ? &USB_HAVE_UGEN : undef)) {
    }
    if((defined(&USB_HAVE_UGEN) ? &USB_HAVE_UGEN : undef)) {
    }
    if((defined(&USB_HAVE_TT_SUPPORT) ? &USB_HAVE_TT_SUPPORT : undef)) {
    }
}
1;
