require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_USB_USBDI_H_)) {
    eval 'sub _USB_USBDI_H_ () {1;}' unless defined(&_USB_USBDI_H_);
    eval("sub USB_ERR_NORMAL_COMPLETION () { 0; }") unless defined(&USB_ERR_NORMAL_COMPLETION);
    eval("sub USB_ERR_PENDING_REQUESTS () { 1; }") unless defined(&USB_ERR_PENDING_REQUESTS);
    eval("sub USB_ERR_NOT_STARTED () { 2; }") unless defined(&USB_ERR_NOT_STARTED);
    eval("sub USB_ERR_INVAL () { 3; }") unless defined(&USB_ERR_INVAL);
    eval("sub USB_ERR_NOMEM () { 4; }") unless defined(&USB_ERR_NOMEM);
    eval("sub USB_ERR_CANCELLED () { 5; }") unless defined(&USB_ERR_CANCELLED);
    eval("sub USB_ERR_BAD_ADDRESS () { 6; }") unless defined(&USB_ERR_BAD_ADDRESS);
    eval("sub USB_ERR_BAD_BUFSIZE () { 7; }") unless defined(&USB_ERR_BAD_BUFSIZE);
    eval("sub USB_ERR_BAD_FLAG () { 8; }") unless defined(&USB_ERR_BAD_FLAG);
    eval("sub USB_ERR_NO_CALLBACK () { 9; }") unless defined(&USB_ERR_NO_CALLBACK);
    eval("sub USB_ERR_IN_USE () { 10; }") unless defined(&USB_ERR_IN_USE);
    eval("sub USB_ERR_NO_ADDR () { 11; }") unless defined(&USB_ERR_NO_ADDR);
    eval("sub USB_ERR_NO_PIPE () { 12; }") unless defined(&USB_ERR_NO_PIPE);
    eval("sub USB_ERR_ZERO_NFRAMES () { 13; }") unless defined(&USB_ERR_ZERO_NFRAMES);
    eval("sub USB_ERR_ZERO_MAXP () { 14; }") unless defined(&USB_ERR_ZERO_MAXP);
    eval("sub USB_ERR_SET_ADDR_FAILED () { 15; }") unless defined(&USB_ERR_SET_ADDR_FAILED);
    eval("sub USB_ERR_NO_POWER () { 16; }") unless defined(&USB_ERR_NO_POWER);
    eval("sub USB_ERR_TOO_DEEP () { 17; }") unless defined(&USB_ERR_TOO_DEEP);
    eval("sub USB_ERR_IOERROR () { 18; }") unless defined(&USB_ERR_IOERROR);
    eval("sub USB_ERR_NOT_CONFIGURED () { 19; }") unless defined(&USB_ERR_NOT_CONFIGURED);
    eval("sub USB_ERR_TIMEOUT () { 20; }") unless defined(&USB_ERR_TIMEOUT);
    eval("sub USB_ERR_SHORT_XFER () { 21; }") unless defined(&USB_ERR_SHORT_XFER);
    eval("sub USB_ERR_STALLED () { 22; }") unless defined(&USB_ERR_STALLED);
    eval("sub USB_ERR_INTERRUPTED () { 23; }") unless defined(&USB_ERR_INTERRUPTED);
    eval("sub USB_ERR_DMA_LOAD_FAILED () { 24; }") unless defined(&USB_ERR_DMA_LOAD_FAILED);
    eval("sub USB_ERR_BAD_CONTEXT () { 25; }") unless defined(&USB_ERR_BAD_CONTEXT);
    eval("sub USB_ERR_NO_ROOT_HUB () { 26; }") unless defined(&USB_ERR_NO_ROOT_HUB);
    eval("sub USB_ERR_NO_INTR_THREAD () { 27; }") unless defined(&USB_ERR_NO_INTR_THREAD);
    eval("sub USB_ERR_NOT_LOCKED () { 28; }") unless defined(&USB_ERR_NOT_LOCKED);
    eval("sub USB_ERR_MAX () { 29; }") unless defined(&USB_ERR_MAX);
    eval 'sub USB_FORCE_SHORT_XFER () {0x1;}' unless defined(&USB_FORCE_SHORT_XFER);
    eval 'sub USB_SHORT_XFER_OK () {0x4;}' unless defined(&USB_SHORT_XFER_OK);
    eval 'sub USB_DELAY_STATUS_STAGE () {0x10;}' unless defined(&USB_DELAY_STATUS_STAGE);
    eval 'sub USB_USER_DATA_PTR () {0x20;}' unless defined(&USB_USER_DATA_PTR);
    eval 'sub USB_MULTI_SHORT_OK () {0x40;}' unless defined(&USB_MULTI_SHORT_OK);
    eval 'sub USB_MANUAL_STATUS () {0x80;}' unless defined(&USB_MANUAL_STATUS);
    eval 'sub USB_NO_TIMEOUT () {0;}' unless defined(&USB_NO_TIMEOUT);
    eval 'sub USB_DEFAULT_TIMEOUT () {5000;}' unless defined(&USB_DEFAULT_TIMEOUT);
    if(defined(&_KERNEL)) {
	unless(defined(&USB_GLOBAL_INCLUDE_FILE)) {
	    require 'sys/eventhandler.ph';
	}
	eval 'sub USB_MS_HZ () {1024;}' unless defined(&USB_MS_HZ);
	eval 'sub USB_MS_TO_TICKS {
	    my($ms) = @_;
    	    eval q(((( &uint32_t)(((( &uint32_t)($ms)) * (( &uint32_t)( &hz))) +  &USB_MS_HZ - 1)) /  &USB_MS_HZ));
	}' unless defined(&USB_MS_TO_TICKS);
	eval 'sub USB_EP_REF_MAX () {0x3f;}' unless defined(&USB_EP_REF_MAX);
	eval 'sub USB_DEFAULT_INTERVAL () {0;}' unless defined(&USB_DEFAULT_INTERVAL);
	if((defined(&USB_HAVE_ID_SECTION) ? &USB_HAVE_ID_SECTION : undef)) {
	    eval 'sub STRUCT_USB_HOST_ID () {\'struct usb_device_id\'  &__section("usb_host_id");}' unless defined(&STRUCT_USB_HOST_ID);
	    eval 'sub STRUCT_USB_DEVICE_ID () {\'struct usb_device_id\'  &__section("usb_device_id");}' unless defined(&STRUCT_USB_DEVICE_ID);
	    eval 'sub STRUCT_USB_DUAL_ID () {\'struct usb_device_id\'  &__section("usb_dual_id");}' unless defined(&STRUCT_USB_DUAL_ID);
	} else {
	    eval 'sub STRUCT_USB_HOST_ID () {\'struct usb_device_id\';}' unless defined(&STRUCT_USB_HOST_ID);
	    eval 'sub STRUCT_USB_DEVICE_ID () {\'struct usb_device_id\';}' unless defined(&STRUCT_USB_DEVICE_ID);
	    eval 'sub STRUCT_USB_DUAL_ID () {\'struct usb_device_id\';}' unless defined(&STRUCT_USB_DUAL_ID);
	}
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&LITTLE_ENDIAN) ? &LITTLE_ENDIAN : undef)) {
	} else {
	}
	if((defined(&USB_HAVE_COMPAT_LINUX) ? &USB_HAVE_COMPAT_LINUX : undef)) {
	    eval 'sub USB_DEVICE_ID_MATCH_VENDOR () {0x1;}' unless defined(&USB_DEVICE_ID_MATCH_VENDOR);
	    eval 'sub USB_DEVICE_ID_MATCH_PRODUCT () {0x2;}' unless defined(&USB_DEVICE_ID_MATCH_PRODUCT);
	    eval 'sub USB_DEVICE_ID_MATCH_DEV_LO () {0x4;}' unless defined(&USB_DEVICE_ID_MATCH_DEV_LO);
	    eval 'sub USB_DEVICE_ID_MATCH_DEV_HI () {0x8;}' unless defined(&USB_DEVICE_ID_MATCH_DEV_HI);
	    eval 'sub USB_DEVICE_ID_MATCH_DEV_CLASS () {0x10;}' unless defined(&USB_DEVICE_ID_MATCH_DEV_CLASS);
	    eval 'sub USB_DEVICE_ID_MATCH_DEV_SUBCLASS () {0x20;}' unless defined(&USB_DEVICE_ID_MATCH_DEV_SUBCLASS);
	    eval 'sub USB_DEVICE_ID_MATCH_DEV_PROTOCOL () {0x40;}' unless defined(&USB_DEVICE_ID_MATCH_DEV_PROTOCOL);
	    eval 'sub USB_DEVICE_ID_MATCH_INT_CLASS () {0x80;}' unless defined(&USB_DEVICE_ID_MATCH_INT_CLASS);
	    eval 'sub USB_DEVICE_ID_MATCH_INT_SUBCLASS () {0x100;}' unless defined(&USB_DEVICE_ID_MATCH_INT_SUBCLASS);
	    eval 'sub USB_DEVICE_ID_MATCH_INT_PROTOCOL () {0x200;}' unless defined(&USB_DEVICE_ID_MATCH_INT_PROTOCOL);
	}
	eval 'sub USB_STD_PNP_INFO () {"M16:mask;U16:vendor;U16:product;L16:release;G16:release;" "U8:devclass;U8:devsubclass;U8:devprotocol;" "U8:intclass;U8:intsubclass;U8:intprotocol;";}' unless defined(&USB_STD_PNP_INFO);
	eval 'sub USB_STD_PNP_HOST_INFO () { &USB_STD_PNP_INFO "T:mode=host;";}' unless defined(&USB_STD_PNP_HOST_INFO);
	eval 'sub USB_STD_PNP_DEVICE_INFO () { &USB_STD_PNP_INFO "T:mode=device;";}' unless defined(&USB_STD_PNP_DEVICE_INFO);
	eval 'sub USB_PNP_HOST_INFO {
	    my($table) = @_;
    	    eval q( &MODULE_PNP_INFO( &USB_STD_PNP_HOST_INFO,  &usb, $table, $table, $sizeof{$table->[0]}, $sizeof{$table} / $sizeof{$table->[0]}));
	}' unless defined(&USB_PNP_HOST_INFO);
	eval 'sub USB_PNP_DEVICE_INFO {
	    my($table) = @_;
    	    eval q( &MODULE_PNP_INFO( &USB_STD_PNP_DEVICE_INFO,  &usb, $table, $table, $sizeof{$table->[0]}, $sizeof{$table} / $sizeof{$table->[0]}));
	}' unless defined(&USB_PNP_DEVICE_INFO);
	eval 'sub USB_PNP_DUAL_INFO {
	    my($table) = @_;
    	    eval q( &MODULE_PNP_INFO( &USB_STD_PNP_INFO,  &usb, $table, $table, $sizeof{$table->[0]}, $sizeof{$table} / $sizeof{$table->[0]}));
	}' unless defined(&USB_PNP_DUAL_INFO);
	eval 'sub USB_VENDOR {
	    my($vend) = @_;
    	    eval q(. &match_flag_vendor = 1, . &idVendor = ($vend));
	}' unless defined(&USB_VENDOR);
	eval 'sub USB_PRODUCT {
	    my($prod) = @_;
    	    eval q(. &match_flag_product = 1, . &idProduct = ($prod));
	}' unless defined(&USB_PRODUCT);
	eval 'sub USB_VP {
	    my($vend,$prod) = @_;
    	    eval q( &USB_VENDOR($vend),  &USB_PRODUCT($prod));
	}' unless defined(&USB_VP);
	eval 'sub USB_VPI {
	    my($vend,$prod,$info) = @_;
    	    eval q( &USB_VENDOR($vend),  &USB_PRODUCT($prod),  &USB_DRIVER_INFO($info));
	}' unless defined(&USB_VPI);
	eval 'sub USB_DEV_BCD_GTEQ {
	    my($lo) = @_;
    	    eval q(. &match_flag_dev_lo = 1, . &bcdDevice_lo = ($lo));
	}' unless defined(&USB_DEV_BCD_GTEQ);
	eval 'sub USB_DEV_BCD_LTEQ {
	    my($hi) = @_;
    	    eval q(. &match_flag_dev_hi = 1, . &bcdDevice_hi = ($hi));
	}' unless defined(&USB_DEV_BCD_LTEQ);
	eval 'sub USB_DEV_CLASS {
	    my($dc) = @_;
    	    eval q(. &match_flag_dev_class = 1, . &bDeviceClass = ($dc));
	}' unless defined(&USB_DEV_CLASS);
	eval 'sub USB_DEV_SUBCLASS {
	    my($dsc) = @_;
    	    eval q(. &match_flag_dev_subclass = 1, . &bDeviceSubClass = ($dsc));
	}' unless defined(&USB_DEV_SUBCLASS);
	eval 'sub USB_DEV_PROTOCOL {
	    my($dp) = @_;
    	    eval q(. &match_flag_dev_protocol = 1, . &bDeviceProtocol = ($dp));
	}' unless defined(&USB_DEV_PROTOCOL);
	eval 'sub USB_IFACE_CLASS {
	    my($ic) = @_;
    	    eval q(. &match_flag_int_class = 1, . &bInterfaceClass = ($ic));
	}' unless defined(&USB_IFACE_CLASS);
	eval 'sub USB_IFACE_SUBCLASS {
	    my($isc) = @_;
    	    eval q(. &match_flag_int_subclass = 1, . &bInterfaceSubClass = ($isc));
	}' unless defined(&USB_IFACE_SUBCLASS);
	eval 'sub USB_IFACE_PROTOCOL {
	    my($ip) = @_;
    	    eval q(. &match_flag_int_protocol = 1, . &bInterfaceProtocol = ($ip));
	}' unless defined(&USB_IFACE_PROTOCOL);
	eval 'sub USB_IF_CSI {
	    my($class,$subclass,$info) = @_;
    	    eval q( &USB_IFACE_CLASS($class),  &USB_IFACE_SUBCLASS($subclass),  &USB_DRIVER_INFO($info));
	}' unless defined(&USB_IF_CSI);
	eval 'sub USB_DRIVER_INFO {
	    my($n) = @_;
    	    eval q(. &driver_info = ($n));
	}' unless defined(&USB_DRIVER_INFO);
	eval 'sub USB_GET_DRIVER_INFO {
	    my($did) = @_;
    	    eval q(($did)-> &driver_info);
	}' unless defined(&USB_GET_DRIVER_INFO);
	eval 'sub UAA_DEV_READY () {0;}' unless defined(&UAA_DEV_READY);
	eval 'sub UAA_DEV_DISABLED () {1;}' unless defined(&UAA_DEV_DISABLED);
	eval 'sub UAA_DEV_EJECTING () {2;}' unless defined(&UAA_DEV_EJECTING);
	eval 'sub usb_callout_init_mtx {
	    my($c,$m,$f) = @_;
    	    eval q( &callout_init_mtx(($c)-> &co,$m,$f));
	}' unless defined(&usb_callout_init_mtx);
	eval 'sub usb_callout_reset {
	    my($c,$t,$f,$d) = @_;
    	    eval q( &callout_reset(($c)-> &co,$t,$f,$d));
	}' unless defined(&usb_callout_reset);
	eval 'sub usb_callout_stop {
	    my($c) = @_;
    	    eval q( &callout_stop(($c)-> &co));
	}' unless defined(&usb_callout_stop);
	eval 'sub usb_callout_drain {
	    my($c) = @_;
    	    eval q( &callout_drain(($c)-> &co));
	}' unless defined(&usb_callout_drain);
	eval 'sub usb_callout_pending {
	    my($c) = @_;
    	    eval q( &callout_pending(($c)-> &co));
	}' unless defined(&usb_callout_pending);
	eval 'sub USB_ST_SETUP () {0;}' unless defined(&USB_ST_SETUP);
	eval 'sub USB_ST_TRANSFERRED () {1;}' unless defined(&USB_ST_TRANSFERRED);
	eval 'sub USB_ST_ERROR () {2;}' unless defined(&USB_ST_ERROR);
	eval 'sub USB_HR_NOT_COMPLETE () {0;}' unless defined(&USB_HR_NOT_COMPLETE);
	eval 'sub USB_HR_COMPLETE_OK () {1;}' unless defined(&USB_HR_COMPLETE_OK);
	eval 'sub USB_HR_COMPLETE_ERR () {2;}' unless defined(&USB_HR_COMPLETE_ERR);
	eval 'sub USB_GET_STATE {
	    my($xfer) = @_;
    	    eval q(( &usbd_xfer_state($xfer)));
	}' unless defined(&USB_GET_STATE);
	eval 'sub USB_FIFO_TX () {0;}' unless defined(&USB_FIFO_TX);
	eval 'sub USB_FIFO_RX () {1;}' unless defined(&USB_FIFO_RX);
	eval 'sub usbd_do_request {
	    my($u,$m,$r,$d) = @_;
    	    eval q( &usbd_do_request_flags($u,$m,$r,$d,0, &NULL, &USB_DEFAULT_TIMEOUT));
	}' unless defined(&usbd_do_request);
    }
}
1;
