require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_UTOPIA_IDTPHY_H)) {
    eval 'sub _DEV_UTOPIA_IDTPHY_H () {1;}' unless defined(&_DEV_UTOPIA_IDTPHY_H);
    eval 'sub IDTPHY_REGO_MCR () {0x;}' unless defined(&IDTPHY_REGO_MCR);
    eval 'sub IDTPHY_REGN_MCR () {"Master Control Register";}' unless defined(&IDTPHY_REGN_MCR);
    eval 'sub IDTPHY_REGX_MCR () {"\\020\\010UPLO\\7DREC\\6ECEI\\5TDPC\\4DRIC\\3HALTTX\\2BYTEM\\1EI";}' unless defined(&IDTPHY_REGX_MCR);
    eval 'sub IDTPHY_REGM_MCR_UPL0 () {0x80;}' unless defined(&IDTPHY_REGM_MCR_UPL0);
    eval 'sub IDTPHY_REGM_MCR_DREC () {0x40;}' unless defined(&IDTPHY_REGM_MCR_DREC);
    eval 'sub IDTPHY_REGM_MCR_ECEI () {0x20;}' unless defined(&IDTPHY_REGM_MCR_ECEI);
    eval 'sub IDTPHY_REGM_MCR_TDPC () {0x10;}' unless defined(&IDTPHY_REGM_MCR_TDPC);
    eval 'sub IDTPHY_REGM_MCR_DRIC () {0x8;}' unless defined(&IDTPHY_REGM_MCR_DRIC);
    eval 'sub IDTPHY_REGM_MCR_HALTTX () {0x4;}' unless defined(&IDTPHY_REGM_MCR_HALTTX);
    eval 'sub IDTPHY_REGM_MCR_BYTEM () {0x2;}' unless defined(&IDTPHY_REGM_MCR_BYTEM);
    eval 'sub IDTPHY_REGM_MCR_EI () {0x1;}' unless defined(&IDTPHY_REGM_MCR_EI);
    eval 'sub IDTPHY_REGO_ISTAT () {0x1;}' unless defined(&IDTPHY_REGO_ISTAT);
    eval 'sub IDTPHY_REGN_ISTAT () {"Interrupt Status";}' unless defined(&IDTPHY_REGN_ISTAT);
    eval 'sub IDTPHY_REGX_ISTAT () {"\\020\\7GOOD\\6HECE\\5SCRE\\4TPE\\3RSCC\\2RSE\\1RFO";}' unless defined(&IDTPHY_REGX_ISTAT);
    eval 'sub IDTPHY_REGM_ISTAT_GOOD () {0x40;}' unless defined(&IDTPHY_REGM_ISTAT_GOOD);
    eval 'sub IDTPHY_REGM_ISTAT_HECE () {0x20;}' unless defined(&IDTPHY_REGM_ISTAT_HECE);
    eval 'sub IDTPHY_REGM_ISTAT_SCRE () {0x10;}' unless defined(&IDTPHY_REGM_ISTAT_SCRE);
    eval 'sub IDTPHY_REGM_ISTAT_TPE () {0x8;}' unless defined(&IDTPHY_REGM_ISTAT_TPE);
    eval 'sub IDTPHY_REGM_ISTAT_RSCC () {0x4;}' unless defined(&IDTPHY_REGM_ISTAT_RSCC);
    eval 'sub IDTPHY_REGM_ISTAT_RSE () {0x2;}' unless defined(&IDTPHY_REGM_ISTAT_RSE);
    eval 'sub IDTPHY_REGM_ISTAT_RFO () {0x1;}' unless defined(&IDTPHY_REGM_ISTAT_RFO);
    eval 'sub IDTPHY_REGO_DIAG () {0x2;}' unless defined(&IDTPHY_REGO_DIAG);
    eval 'sub IDTPHY_REGN_DIAG () {"Diagnostic Control";}' unless defined(&IDTPHY_REGN_DIAG);
    eval 'sub IDTPHY_REGX_DIAG () {"\\020\\010FTD\\7ROS\\6MULTI\\5RFLUSH\\4ITPE\\3IHECE\\11\\3\\0NORM\\11\\3\\2PLOOP\\11\\3\\3LLOOP";}' unless defined(&IDTPHY_REGX_DIAG);
    eval 'sub IDTPHY_REGM_DIAG_FTD () {0x80;}' unless defined(&IDTPHY_REGM_DIAG_FTD);
    eval 'sub IDTPHY_REGM_DIAG_ROS () {0x40;}' unless defined(&IDTPHY_REGM_DIAG_ROS);
    eval 'sub IDTPHY_REGM_DIAG_MULTI () {0x20;}' unless defined(&IDTPHY_REGM_DIAG_MULTI);
    eval 'sub IDTPHY_REGM_DIAG_RFLUSH () {0x10;}' unless defined(&IDTPHY_REGM_DIAG_RFLUSH);
    eval 'sub IDTPHY_REGM_DIAG_ITPE () {0x8;}' unless defined(&IDTPHY_REGM_DIAG_ITPE);
    eval 'sub IDTPHY_REGM_DIAG_IHECE () {0x4;}' unless defined(&IDTPHY_REGM_DIAG_IHECE);
    eval 'sub IDTPHY_REGM_DIAG_LOOP () {0x3;}' unless defined(&IDTPHY_REGM_DIAG_LOOP);
    eval 'sub IDTPHY_REGM_DIAG_LOOP_NONE () {0x;}' unless defined(&IDTPHY_REGM_DIAG_LOOP_NONE);
    eval 'sub IDTPHY_REGM_DIAG_LOOP_PHY () {0x2;}' unless defined(&IDTPHY_REGM_DIAG_LOOP_PHY);
    eval 'sub IDTPHY_REGM_DIAG_LOOP_LINE () {0x3;}' unless defined(&IDTPHY_REGM_DIAG_LOOP_LINE);
    eval 'sub IDTPHY_REGO_LHEC () {0x3;}' unless defined(&IDTPHY_REGO_LHEC);
    eval 'sub IDTPHY_REGN_LHEC () {"LED Driver and HEC Status/Control";}' unless defined(&IDTPHY_REGN_LHEC);
    eval 'sub IDTPHY_REGX_LHEC () {"\\020\\7DRHEC\\6DTHEC\\11\\x18\\0CYC1\\11\\x18\\1CYC2\\11\\x18\\2CYC4\\11\\x18\\3CYC8\\3FIFOE\\2TXLED\\1RXLED";}' unless defined(&IDTPHY_REGX_LHEC);
    eval 'sub IDTPHY_REGM_LHEC_DRHEC () {0x40;}' unless defined(&IDTPHY_REGM_LHEC_DRHEC);
    eval 'sub IDTPHY_REGM_LHEC_DTHEC () {0x20;}' unless defined(&IDTPHY_REGM_LHEC_DTHEC);
    eval 'sub IDTPHY_REGM_LHEC_RXREF () {0x18;}' unless defined(&IDTPHY_REGM_LHEC_RXREF);
    eval 'sub IDTPHY_REGM_LHEC_RXREF1 () {0x;}' unless defined(&IDTPHY_REGM_LHEC_RXREF1);
    eval 'sub IDTPHY_REGM_LHEC_RXREF2 () {0x8;}' unless defined(&IDTPHY_REGM_LHEC_RXREF2);
    eval 'sub IDTPHY_REGM_LHEC_RXREF4 () {0x10;}' unless defined(&IDTPHY_REGM_LHEC_RXREF4);
    eval 'sub IDTPHY_REGM_LHEC_RXREF8 () {0x18;}' unless defined(&IDTPHY_REGM_LHEC_RXREF8);
    eval 'sub IDTPHY_REGM_LHEC_FIFOE () {0x4;}' unless defined(&IDTPHY_REGM_LHEC_FIFOE);
    eval 'sub IDTPHY_REGM_LHEC_TXLED () {0x2;}' unless defined(&IDTPHY_REGM_LHEC_TXLED);
    eval 'sub IDTPHY_REGM_LHEC_RXLED () {0x1;}' unless defined(&IDTPHY_REGM_LHEC_RXLED);
    eval 'sub IDTPHY_REGO_CNT () {0x4;}' unless defined(&IDTPHY_REGO_CNT);
    eval 'sub IDTPHY_REGN_CNT () {"Counter";}' unless defined(&IDTPHY_REGN_CNT);
    eval 'sub IDTPHY_REGO_CNTS () {0x6;}' unless defined(&IDTPHY_REGO_CNTS);
    eval 'sub IDTPHY_REGN_CNTS () {"Counter select";}' unless defined(&IDTPHY_REGN_CNTS);
    eval 'sub IDTPHY_REGX_CNTS () {"\\020\\4SEC\\3TX\\2RX\\1HECE";}' unless defined(&IDTPHY_REGX_CNTS);
    eval 'sub IDTPHY_REGM_CNTS_SEC () {0x8;}' unless defined(&IDTPHY_REGM_CNTS_SEC);
    eval 'sub IDTPHY_REGM_CNTS_TX () {0x4;}' unless defined(&IDTPHY_REGM_CNTS_TX);
    eval 'sub IDTPHY_REGM_CNTS_RX () {0x2;}' unless defined(&IDTPHY_REGM_CNTS_RX);
    eval 'sub IDTPHY_REGM_CNTS_HECE () {0x1;}' unless defined(&IDTPHY_REGM_CNTS_HECE);
    eval 'sub IDTPHY_PRINT_77105 () {{  &UTP_REGT_BITS,  &IDTPHY_REGO_MCR,  &IDTPHY_REGN_MCR,  &IDTPHY_REGX_MCR }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_ISTAT,  &IDTPHY_REGN_ISTAT,  &IDTPHY_REGX_ISTAT }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_DIAG,  &IDTPHY_REGN_DIAG,  &IDTPHY_REGX_DIAG }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_LHEC,  &IDTPHY_REGN_LHEC,  &IDTPHY_REGX_LHEC }, {  &UTP_REGT_INT16,  &IDTPHY_REGO_CNT,  &IDTPHY_REGN_CNT,  &NULL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_CNTS,  &IDTPHY_REGN_CNTS,  &IDTPHY_REGX_CNTS };}' unless defined(&IDTPHY_PRINT_77105);
    eval 'sub IDTPHY_REGO_MRID () {0x;}' unless defined(&IDTPHY_REGO_MRID);
    eval 'sub IDTPHY_REGN_MRID () {"Master Reset & ID";}' unless defined(&IDTPHY_REGN_MRID);
    eval 'sub IDTPHY_REGM_MRID_RESET () {0x80;}' unless defined(&IDTPHY_REGM_MRID_RESET);
    eval 'sub IDTPHY_REGM_MRID_TYPE () {0x70;}' unless defined(&IDTPHY_REGM_MRID_TYPE);
    eval 'sub IDTPHY_REGM_MRID_155 () {0x30;}' unless defined(&IDTPHY_REGM_MRID_155);
    eval 'sub IDTPHY_REGM_MRID_ID () {0xf;}' unless defined(&IDTPHY_REGM_MRID_ID);
    eval 'sub IDTPHY_REGX_MRID () {"\\020\\010mstReset\\12\\x70\\12type\\12\\xf\\12id";}' unless defined(&IDTPHY_REGX_MRID);
    eval 'sub IDTPHY_REGO_CONF () {0x1;}' unless defined(&IDTPHY_REGO_CONF);
    eval 'sub IDTPHY_REGN_CONF () {"Configuration";}' unless defined(&IDTPHY_REGN_CONF);
    eval 'sub IDTPHY_REGM_CONF_AFEBE () {0x40;}' unless defined(&IDTPHY_REGM_CONF_AFEBE);
    eval 'sub IDTPHY_REGM_CONF_ALRDI () {0x20;}' unless defined(&IDTPHY_REGM_CONF_ALRDI);
    eval 'sub IDTPHY_REGM_CONF_APRDI () {0x10;}' unless defined(&IDTPHY_REGM_CONF_APRDI);
    eval 'sub IDTPHY_REGM_CONF_TCAIN () {0x8;}' unless defined(&IDTPHY_REGM_CONF_TCAIN);
    eval 'sub IDTPHY_REGM_CONF_RCAIN () {0x4;}' unless defined(&IDTPHY_REGM_CONF_RCAIN);
    eval 'sub IDTPHY_REGM_CONF_RXDIN () {0x2;}' unless defined(&IDTPHY_REGM_CONF_RXDIN);
    eval 'sub IDTPHY_REGM_CONF_RESV () {0x81;}' unless defined(&IDTPHY_REGM_CONF_RESV);
    eval 'sub IDTPHY_REGX_CONF () {"\\020\\07autoFEBE\\6autoLRDI\\5autoPRDI\\4TCAInv\\3RCAInv\\2RXDInv";}' unless defined(&IDTPHY_REGX_CONF);
    eval 'sub IDTPHY_REGO_INT () {0x2;}' unless defined(&IDTPHY_REGO_INT);
    eval 'sub IDTPHY_REGN_INT () {"Interrupt";}' unless defined(&IDTPHY_REGN_INT);
    eval 'sub IDTPHY_REGM_INT_TXOOLI () {0x80;}' unless defined(&IDTPHY_REGM_INT_TXOOLI);
    eval 'sub IDTPHY_REGM_INT_RXLOCI () {0x40;}' unless defined(&IDTPHY_REGM_INT_RXLOCI);
    eval 'sub IDTPHY_REGM_INT_RXOOLI () {0x20;}' unless defined(&IDTPHY_REGM_INT_RXOOLI);
    eval 'sub IDTPHY_REGM_INT_TXCDI () {0x10;}' unless defined(&IDTPHY_REGM_INT_TXCDI);
    eval 'sub IDTPHY_REGM_INT_RXCDI () {0x8;}' unless defined(&IDTPHY_REGM_INT_RXCDI);
    eval 'sub IDTPHY_REGM_INT_RXPOHI () {0x4;}' unless defined(&IDTPHY_REGM_INT_RXPOHI);
    eval 'sub IDTPHY_REGM_INT_RXLOHI () {0x2;}' unless defined(&IDTPHY_REGM_INT_RXLOHI);
    eval 'sub IDTPHY_REGM_INT_RXSOHI () {0x1;}' unless defined(&IDTPHY_REGM_INT_RXSOHI);
    eval 'sub IDTPHY_REGX_INT () {"\\020\\10txOOLInt\\7rxLOCInt\\6rxOOLInt\\5txCDi\\4rxCDi\\3rxPOHi" "\\2rxLOHi\\1rxSOHi";}' unless defined(&IDTPHY_REGX_INT);
    eval 'sub IDTPHY_REGO_MCM () {0x4;}' unless defined(&IDTPHY_REGO_MCM);
    eval 'sub IDTPHY_REGN_MCM () {"Master Clock Monitor";}' unless defined(&IDTPHY_REGN_MCM);
    eval 'sub IDTPHY_REGM_MCM_RRCLK () {0x8;}' unless defined(&IDTPHY_REGM_MCM_RRCLK);
    eval 'sub IDTPHY_REGM_MCM_TRCLK () {0x4;}' unless defined(&IDTPHY_REGM_MCM_TRCLK);
    eval 'sub IDTPHY_REGM_MCM_RCLK () {0x2;}' unless defined(&IDTPHY_REGM_MCM_RCLK);
    eval 'sub IDTPHY_REGM_MCM_TCLK () {0x1;}' unless defined(&IDTPHY_REGM_MCM_TCLK);
    eval 'sub IDTPHY_REGM_MCM_RESV () {0xf0;}' unless defined(&IDTPHY_REGM_MCM_RESV);
    eval 'sub IDTPHY_REGX_MCM () {"\\020\\4rrclkReg\\3trclkReg\\2rclkReg\\1tclkReg";}' unless defined(&IDTPHY_REGX_MCM);
    eval 'sub IDTPHY_REGO_MCTL () {0x5;}' unless defined(&IDTPHY_REGO_MCTL);
    eval 'sub IDTPHY_REGN_MCTL () {"Master Control";}' unless defined(&IDTPHY_REGN_MCTL);
    eval 'sub IDTPHY_REGM_MCTL_LOCI () {0x80;}' unless defined(&IDTPHY_REGM_MCTL_LOCI);
    eval 'sub IDTPHY_REGM_MCTL_LOC () {0x40;}' unless defined(&IDTPHY_REGM_MCTL_LOC);
    eval 'sub IDTPHY_REGM_MCTL_FIXP () {0x20;}' unless defined(&IDTPHY_REGM_MCTL_FIXP);
    eval 'sub IDTPHY_REGM_MCTL_LLOOP () {0x4;}' unless defined(&IDTPHY_REGM_MCTL_LLOOP);
    eval 'sub IDTPHY_REGM_MCTL_DLOOP () {0x2;}' unless defined(&IDTPHY_REGM_MCTL_DLOOP);
    eval 'sub IDTPHY_REGM_MCTL_TLOOP () {0x1;}' unless defined(&IDTPHY_REGM_MCTL_TLOOP);
    eval 'sub IDTPHY_REGM_MCTL_RESV () {0x18;}' unless defined(&IDTPHY_REGM_MCTL_RESV);
    eval 'sub IDTPHY_REGX_MCTL () {"\\020\\10rxLOCIEn\\7LOC\\6txFixptr\\3txLLoop\\2rxDLoop\\1rxLoopT";}' unless defined(&IDTPHY_REGX_MCTL);
    eval 'sub IDTPHY_REGO_TXC () {0x6;}' unless defined(&IDTPHY_REGO_TXC);
    eval 'sub IDTPHY_REGN_TXC () {"Transmit Clock Synthesis C/S";}' unless defined(&IDTPHY_REGN_TXC);
    eval 'sub IDTPHY_REGM_TXC_TXOOL () {0x8;}' unless defined(&IDTPHY_REGM_TXC_TXOOL);
    eval 'sub IDTPHY_REGM_TXC_TXOOLI () {0x2;}' unless defined(&IDTPHY_REGM_TXC_TXOOLI);
    eval 'sub IDTPHY_REGM_TXC_TXREF () {0x1;}' unless defined(&IDTPHY_REGM_TXC_TXREF);
    eval 'sub IDTPHY_REGM_TXC_RESV () {0xf4;}' unless defined(&IDTPHY_REGM_TXC_RESV);
    eval 'sub IDTPHY_REGX_TXC () {"\\020\\4txOOL\\2txOOLIEn\\1txrefSel";}' unless defined(&IDTPHY_REGX_TXC);
    eval 'sub IDTPHY_REGO_RXC () {0x7;}' unless defined(&IDTPHY_REGO_RXC);
    eval 'sub IDTPHY_REGN_RXC () {"Receive Clock/Data Recovery C/S";}' unless defined(&IDTPHY_REGN_RXC);
    eval 'sub IDTPHY_REGM_RXC_RXOOL () {0x8;}' unless defined(&IDTPHY_REGM_RXC_RXOOL);
    eval 'sub IDTPHY_REGM_RXC_RXOOLI () {0x2;}' unless defined(&IDTPHY_REGM_RXC_RXOOLI);
    eval 'sub IDTPHY_REGM_RXC_RXREF () {0x1;}' unless defined(&IDTPHY_REGM_RXC_RXREF);
    eval 'sub IDTPHY_REGM_RXC_RESV () {0xf4;}' unless defined(&IDTPHY_REGM_RXC_RESV);
    eval 'sub IDTPHY_REGX_RXC () {"\\020\\4rxOOL\\2rxOOLIEn\\1rxrefSel";}' unless defined(&IDTPHY_REGX_RXC);
    eval 'sub IDTPHY_REGO_RSOC () {0x10;}' unless defined(&IDTPHY_REGO_RSOC);
    eval 'sub IDTPHY_REGN_RSOC () {"Receive Overhead Control";}' unless defined(&IDTPHY_REGN_RSOC);
    eval 'sub IDTPHY_REGM_RSOC_DSCR () {0x40;}' unless defined(&IDTPHY_REGM_RSOC_DSCR);
    eval 'sub IDTPHY_REGM_RSOC_FOOF () {0x20;}' unless defined(&IDTPHY_REGM_RSOC_FOOF);
    eval 'sub IDTPHY_REGM_RSOC_B1IE () {0x8;}' unless defined(&IDTPHY_REGM_RSOC_B1IE);
    eval 'sub IDTPHY_REGM_RSOC_LOSI () {0x4;}' unless defined(&IDTPHY_REGM_RSOC_LOSI);
    eval 'sub IDTPHY_REGM_RSOC_LOFI () {0x2;}' unless defined(&IDTPHY_REGM_RSOC_LOFI);
    eval 'sub IDTPHY_REGM_RSOC_OOFI () {0x1;}' unless defined(&IDTPHY_REGM_RSOC_OOFI);
    eval 'sub IDTPHY_REGM_RSOC_RESV () {0x90;}' unless defined(&IDTPHY_REGM_RSOC_RESV);
    eval 'sub IDTPHY_REGX_RSOC () {"\\020\\7scrDis\\6frcOOF\\4B1ErrIEn\\3LOSIEn\\2LOFIEn\\1OOFIEn";}' unless defined(&IDTPHY_REGX_RSOC);
    eval 'sub IDTPHY_REGO_RSOS () {0x11;}' unless defined(&IDTPHY_REGO_RSOS);
    eval 'sub IDTPHY_REGN_RSOS () {"Receive Overhead Status";}' unless defined(&IDTPHY_REGN_RSOS);
    eval 'sub IDTPHY_REGM_RSOS_C1INT () {0x80;}' unless defined(&IDTPHY_REGM_RSOS_C1INT);
    eval 'sub IDTPHY_REGM_RSOS_B1INT () {0x40;}' unless defined(&IDTPHY_REGM_RSOS_B1INT);
    eval 'sub IDTPHY_REGM_RSOS_LOSI () {0x20;}' unless defined(&IDTPHY_REGM_RSOS_LOSI);
    eval 'sub IDTPHY_REGM_RSOS_LOFI () {0x10;}' unless defined(&IDTPHY_REGM_RSOS_LOFI);
    eval 'sub IDTPHY_REGM_RSOS_OOFI () {0x8;}' unless defined(&IDTPHY_REGM_RSOS_OOFI);
    eval 'sub IDTPHY_REGM_RSOS_LOS () {0x4;}' unless defined(&IDTPHY_REGM_RSOS_LOS);
    eval 'sub IDTPHY_REGM_RSOS_LOF () {0x2;}' unless defined(&IDTPHY_REGM_RSOS_LOF);
    eval 'sub IDTPHY_REGM_RSOS_OOF () {0x1;}' unless defined(&IDTPHY_REGM_RSOS_OOF);
    eval 'sub IDTPHY_REGX_RSOS () {"\\020\\10C1Int\\7B1ErrInt\\6LOSInt\\5LOFInt\\4OOFint\\3LOS\\2LOF\\1OOF";}' unless defined(&IDTPHY_REGX_RSOS);
    eval 'sub IDTPHY_REGO_BIPC () {0x12;}' unless defined(&IDTPHY_REGO_BIPC);
    eval 'sub IDTPHY_REGN_BIPC () {"Receive Section BIP Errors";}' unless defined(&IDTPHY_REGN_BIPC);
    eval 'sub IDTPHY_REGO_TSOC () {0x14;}' unless defined(&IDTPHY_REGO_TSOC);
    eval 'sub IDTPHY_REGN_TSOC () {"Transmit Overhead Control";}' unless defined(&IDTPHY_REGN_TSOC);
    eval 'sub IDTPHY_REGM_TSOC_DSCR () {0x40;}' unless defined(&IDTPHY_REGM_TSOC_DSCR);
    eval 'sub IDTPHY_REGM_TSOC_LAISI () {0x1;}' unless defined(&IDTPHY_REGM_TSOC_LAISI);
    eval 'sub IDTPHY_REGM_TSOC_RESV () {0xbe;}' unless defined(&IDTPHY_REGM_TSOC_RESV);
    eval 'sub IDTPHY_REGX_TSOC () {"\\020\\7scrDis\\1LAISIns";}' unless defined(&IDTPHY_REGX_TSOC);
    eval 'sub IDTPHY_REGO_TSOC2 () {0x15;}' unless defined(&IDTPHY_REGO_TSOC2);
    eval 'sub IDTPHY_REGN_TSOC2 () {"Transmit Overhead Control 2";}' unless defined(&IDTPHY_REGN_TSOC2);
    eval 'sub IDTPHY_REGM_TSOC2_LOSI () {0x4;}' unless defined(&IDTPHY_REGM_TSOC2_LOSI);
    eval 'sub IDTPHY_REGM_TSOC2_B1INV () {0x2;}' unless defined(&IDTPHY_REGM_TSOC2_B1INV);
    eval 'sub IDTPHY_REGM_TSOC2_IFE () {0x1;}' unless defined(&IDTPHY_REGM_TSOC2_IFE);
    eval 'sub IDTPHY_REGM_TSOC2_RESV () {0xf8;}' unless defined(&IDTPHY_REGM_TSOC2_RESV);
    eval 'sub IDTPHY_REGX_TSOC2 () {"\\020\\3LOSIns\\2B1Inv\\1frErrIns";}' unless defined(&IDTPHY_REGX_TSOC2);
    eval 'sub IDTPHY_REGO_RLOS () {0x18;}' unless defined(&IDTPHY_REGO_RLOS);
    eval 'sub IDTPHY_REGN_RLOS () {"Receive Line Overhead Status";}' unless defined(&IDTPHY_REGN_RLOS);
    eval 'sub IDTPHY_REGM_RLOS_B2W () {0x80;}' unless defined(&IDTPHY_REGM_RLOS_B2W);
    eval 'sub IDTPHY_REGM_RLOS_LAIS () {0x2;}' unless defined(&IDTPHY_REGM_RLOS_LAIS);
    eval 'sub IDTPHY_REGM_RLOS_LRDI () {0x1;}' unless defined(&IDTPHY_REGM_RLOS_LRDI);
    eval 'sub IDTPHY_REGM_RLOS_RESV () {0x7c;}' unless defined(&IDTPHY_REGM_RLOS_RESV);
    eval 'sub IDTPHY_REGX_RLOS () {"\\020\\10B2Word\\2LAIS\\1LRDI";}' unless defined(&IDTPHY_REGX_RLOS);
    eval 'sub IDTPHY_REGO_RLOI () {0x19;}' unless defined(&IDTPHY_REGO_RLOI);
    eval 'sub IDTPHY_REGN_RLOI () {"Receive Line Overhead Interrupt";}' unless defined(&IDTPHY_REGN_RLOI);
    eval 'sub IDTPHY_REGM_RLOI_LFEBEE () {0x80;}' unless defined(&IDTPHY_REGM_RLOI_LFEBEE);
    eval 'sub IDTPHY_REGM_RLOI_B2EE () {0x40;}' unless defined(&IDTPHY_REGM_RLOI_B2EE);
    eval 'sub IDTPHY_REGM_RLOI_LAISE () {0x20;}' unless defined(&IDTPHY_REGM_RLOI_LAISE);
    eval 'sub IDTPHY_REGM_RLOI_LRDIE () {0x10;}' unless defined(&IDTPHY_REGM_RLOI_LRDIE);
    eval 'sub IDTPHY_REGM_RLOI_LFEBEI () {0x8;}' unless defined(&IDTPHY_REGM_RLOI_LFEBEI);
    eval 'sub IDTPHY_REGM_RLOI_B2EI () {0x4;}' unless defined(&IDTPHY_REGM_RLOI_B2EI);
    eval 'sub IDTPHY_REGM_RLOI_LAISI () {0x2;}' unless defined(&IDTPHY_REGM_RLOI_LAISI);
    eval 'sub IDTPHY_REGM_RLOI_LRDII () {0x1;}' unless defined(&IDTPHY_REGM_RLOI_LRDII);
    eval 'sub IDTPHY_REGX_RLOI () {"\\020\\10LFEBEIEn\\7B2ErrIEn\\6LAISIEn\\5LRDIIEn\\4LFEBEInt\\3B2ErrInt" "\\2LAISInt\\1LRDIInt";}' unless defined(&IDTPHY_REGX_RLOI);
    eval 'sub IDTPHY_REGO_B2EC () {0x1a;}' unless defined(&IDTPHY_REGO_B2EC);
    eval 'sub IDTPHY_REGN_B2EC () {"B2 Errors";}' unless defined(&IDTPHY_REGN_B2EC);
    eval 'sub IDTPHY_REGO_FEBEC () {0x1d;}' unless defined(&IDTPHY_REGO_FEBEC);
    eval 'sub IDTPHY_REGN_FEBEC () {"Line FEBE Errors";}' unless defined(&IDTPHY_REGN_FEBEC);
    eval 'sub IDTPHY_REGO_TLOS () {0x20;}' unless defined(&IDTPHY_REGO_TLOS);
    eval 'sub IDTPHY_REGN_TLOS () {"Transmit Line Overhead Status";}' unless defined(&IDTPHY_REGN_TLOS);
    eval 'sub IDTPHY_REGM_TLOS_LRDI () {0x1;}' unless defined(&IDTPHY_REGM_TLOS_LRDI);
    eval 'sub IDTPHY_REGM_TLOS_RESV () {0xfe;}' unless defined(&IDTPHY_REGM_TLOS_RESV);
    eval 'sub IDTPHY_REGX_TLOS () {"\\020\\1LRDI";}' unless defined(&IDTPHY_REGX_TLOS);
    eval 'sub IDTPHY_REGO_TLOC () {0x21;}' unless defined(&IDTPHY_REGO_TLOC);
    eval 'sub IDTPHY_REGN_TLOC () {"Transmit Line Overhead Control";}' unless defined(&IDTPHY_REGN_TLOC);
    eval 'sub IDTPHY_REGM_TLOC_B2INV () {0x1;}' unless defined(&IDTPHY_REGM_TLOC_B2INV);
    eval 'sub IDTPHY_REGM_TLOC_RESV () {0xfe;}' unless defined(&IDTPHY_REGM_TLOC_RESV);
    eval 'sub IDTPHY_REGX_TLOC () {"\\020\\1B2Inv";}' unless defined(&IDTPHY_REGX_TLOC);
    eval 'sub IDTPHY_REGO_TK1 () {0x24;}' unless defined(&IDTPHY_REGO_TK1);
    eval 'sub IDTPHY_REGN_TK1 () {"Transmit K1";}' unless defined(&IDTPHY_REGN_TK1);
    eval 'sub IDTPHY_REGO_TK2 () {0x25;}' unless defined(&IDTPHY_REGO_TK2);
    eval 'sub IDTPHY_REGN_TK2 () {"Transmit K2";}' unless defined(&IDTPHY_REGN_TK2);
    eval 'sub IDTPHY_REGO_RK1 () {0x26;}' unless defined(&IDTPHY_REGO_RK1);
    eval 'sub IDTPHY_REGN_RK1 () {"Receive K1";}' unless defined(&IDTPHY_REGN_RK1);
    eval 'sub IDTPHY_REGO_RK2 () {0x27;}' unless defined(&IDTPHY_REGO_RK2);
    eval 'sub IDTPHY_REGN_RK2 () {"Receive K2";}' unless defined(&IDTPHY_REGN_RK2);
    eval 'sub IDTPHY_REGO_RPOS () {0x30;}' unless defined(&IDTPHY_REGO_RPOS);
    eval 'sub IDTPHY_REGN_RPOS () {"Receive Path Overhead Status";}' unless defined(&IDTPHY_REGN_RPOS);
    eval 'sub IDTPHY_REGM_RPOS_LOP () {0x20;}' unless defined(&IDTPHY_REGM_RPOS_LOP);
    eval 'sub IDTPHY_REGM_RPOS_PAIS () {0x8;}' unless defined(&IDTPHY_REGM_RPOS_PAIS);
    eval 'sub IDTPHY_REGM_RPOS_PRDI () {0x4;}' unless defined(&IDTPHY_REGM_RPOS_PRDI);
    eval 'sub IDTPHY_REGM_RPOS_RESV () {0xd3;}' unless defined(&IDTPHY_REGM_RPOS_RESV);
    eval 'sub IDTPHY_REGX_RPOS () {"\\020\\6LOP\\4PAIS\\3PRDI";}' unless defined(&IDTPHY_REGX_RPOS);
    eval 'sub IDTPHY_REGO_RPOI () {0x31;}' unless defined(&IDTPHY_REGO_RPOI);
    eval 'sub IDTPHY_REGN_RPOI () {"Receive Path Overhead Interrupt";}' unless defined(&IDTPHY_REGN_RPOI);
    eval 'sub IDTPHY_REGM_RPOI_C2I () {0x80;}' unless defined(&IDTPHY_REGM_RPOI_C2I);
    eval 'sub IDTPHY_REGM_RPOI_LOPI () {0x20;}' unless defined(&IDTPHY_REGM_RPOI_LOPI);
    eval 'sub IDTPHY_REGM_RPOI_PAISI () {0x8;}' unless defined(&IDTPHY_REGM_RPOI_PAISI);
    eval 'sub IDTPHY_REGM_RPOI_PRDII () {0x4;}' unless defined(&IDTPHY_REGM_RPOI_PRDII);
    eval 'sub IDTPHY_REGM_RPOI_B3EI () {0x2;}' unless defined(&IDTPHY_REGM_RPOI_B3EI);
    eval 'sub IDTPHY_REGM_RPOI_PFEBEI () {0x1;}' unless defined(&IDTPHY_REGM_RPOI_PFEBEI);
    eval 'sub IDTPHY_REGM_RPOI_RESV () {0x50;}' unless defined(&IDTPHY_REGM_RPOI_RESV);
    eval 'sub IDTPHY_REGX_RPOI () {"\\020\\10C2Int\\6LOPInt\\4PAISInt\\3PRDIInt\\2B3ErrInt\\1PFEBEInt";}' unless defined(&IDTPHY_REGX_RPOI);
    eval 'sub IDTPHY_REGO_RPIE () {0x33;}' unless defined(&IDTPHY_REGO_RPIE);
    eval 'sub IDTPHY_REGN_RPIE () {"Receive Path Interrupt Enable";}' unless defined(&IDTPHY_REGN_RPIE);
    eval 'sub IDTPHY_REGM_RPIE_C2E () {0x80;}' unless defined(&IDTPHY_REGM_RPIE_C2E);
    eval 'sub IDTPHY_REGM_RPIE_LOPE () {0x20;}' unless defined(&IDTPHY_REGM_RPIE_LOPE);
    eval 'sub IDTPHY_REGM_RPIE_PAISE () {0x8;}' unless defined(&IDTPHY_REGM_RPIE_PAISE);
    eval 'sub IDTPHY_REGM_RPIE_PRDIE () {0x4;}' unless defined(&IDTPHY_REGM_RPIE_PRDIE);
    eval 'sub IDTPHY_REGM_RPIE_B3EE () {0x2;}' unless defined(&IDTPHY_REGM_RPIE_B3EE);
    eval 'sub IDTPHY_REGM_RPIE_PFEBEE () {0x1;}' unless defined(&IDTPHY_REGM_RPIE_PFEBEE);
    eval 'sub IDTPHY_REGM_RPIE_RESV () {0x50;}' unless defined(&IDTPHY_REGM_RPIE_RESV);
    eval 'sub IDTPHY_REGX_RPIE () {"\\020\\10CSIEn\\6LOPIEn\\4PAISIEn\\3PRDIIEn\\2B3ErrIEn\\1PFEBEIEn";}' unless defined(&IDTPHY_REGX_RPIE);
    eval 'sub IDTPHY_REGO_RC2 () {0x37;}' unless defined(&IDTPHY_REGO_RC2);
    eval 'sub IDTPHY_REGN_RC2 () {"Receive C2";}' unless defined(&IDTPHY_REGN_RC2);
    eval 'sub IDTPHY_REGO_B3EC () {0x38;}' unless defined(&IDTPHY_REGO_B3EC);
    eval 'sub IDTPHY_REGN_B3EC () {"B3 Errors";}' unless defined(&IDTPHY_REGN_B3EC);
    eval 'sub IDTPHY_REGO_PFEBEC () {0x3a;}' unless defined(&IDTPHY_REGO_PFEBEC);
    eval 'sub IDTPHY_REGN_PFEBEC () {"Path FEBE Errors";}' unless defined(&IDTPHY_REGN_PFEBEC);
    eval 'sub IDTPHY_REGO_RPEC () {0x3d;}' unless defined(&IDTPHY_REGO_RPEC);
    eval 'sub IDTPHY_REGN_RPEC () {"Receive Path BIP Error Control";}' unless defined(&IDTPHY_REGN_RPEC);
    eval 'sub IDTPHY_REGM_RPEC_B3C () {0x20;}' unless defined(&IDTPHY_REGM_RPEC_B3C);
    eval 'sub IDTPHY_REGM_RPEC_RESV () {0xdf;}' unless defined(&IDTPHY_REGM_RPEC_RESV);
    eval 'sub IDTPHY_REGX_RPEC () {"\\020\\6blkBIP";}' unless defined(&IDTPHY_REGX_RPEC);
    eval 'sub IDTPHY_REGO_TPOC () {0x40;}' unless defined(&IDTPHY_REGO_TPOC);
    eval 'sub IDTPHY_REGN_TPOC () {"Transmit Path Control";}' unless defined(&IDTPHY_REGN_TPOC);
    eval 'sub IDTPHY_REGM_TPOC_B3INV () {0x2;}' unless defined(&IDTPHY_REGM_TPOC_B3INV);
    eval 'sub IDTPHY_REGM_TPOC_PAISI () {0x1;}' unless defined(&IDTPHY_REGM_TPOC_PAISI);
    eval 'sub IDTPHY_REGM_TPOC_RESC () {0xfc;}' unless defined(&IDTPHY_REGM_TPOC_RESC);
    eval 'sub IDTPHY_REGX_TPOC () {"\\020\\2B3Inv\\1PAISIns";}' unless defined(&IDTPHY_REGX_TPOC);
    eval 'sub IDTPHY_REGO_TPTC () {0x41;}' unless defined(&IDTPHY_REGO_TPTC);
    eval 'sub IDTPHY_REGN_TPTC () {"Transmit Pointer Control";}' unless defined(&IDTPHY_REGN_TPTC);
    eval 'sub IDTPHY_REGM_TPTC_FPTR () {0x40;}' unless defined(&IDTPHY_REGM_TPTC_FPTR);
    eval 'sub IDTPHY_REGM_TPTC_STUFF () {0x20;}' unless defined(&IDTPHY_REGM_TPTC_STUFF);
    eval 'sub IDTPHY_REGM_TPTC_PTR () {0x10;}' unless defined(&IDTPHY_REGM_TPTC_PTR);
    eval 'sub IDTPHY_REGM_TPTC_NDF () {0x8;}' unless defined(&IDTPHY_REGM_TPTC_NDF);
    eval 'sub IDTPHY_REGM_TPTC_DECP () {0x4;}' unless defined(&IDTPHY_REGM_TPTC_DECP);
    eval 'sub IDTPHY_REGM_TPTC_INCP () {0x2;}' unless defined(&IDTPHY_REGM_TPTC_INCP);
    eval 'sub IDTPHY_REGM_TPTC_RESV () {0x81;}' unless defined(&IDTPHY_REGM_TPTC_RESV);
    eval 'sub IDTPHY_REGX_TPTC () {"\\020\\7frcPtr\\6stuffCtl\\5Ptr\\4NDF\\3decPtr\\2incPtr";}' unless defined(&IDTPHY_REGX_TPTC);
    eval 'sub IDTPHY_REGO_PTRL () {0x45;}' unless defined(&IDTPHY_REGO_PTRL);
    eval 'sub IDTPHY_REGN_PTRL () {"Transmit Pointer LSB";}' unless defined(&IDTPHY_REGN_PTRL);
    eval 'sub IDTPHY_REGX_PTRL () {"\\020\\12\\xff\\20arbPtr";}' unless defined(&IDTPHY_REGX_PTRL);
    eval 'sub IDTPHY_REGO_PTRM () {0x46;}' unless defined(&IDTPHY_REGO_PTRM);
    eval 'sub IDTPHY_REGN_PTRM () {"Transmit Pointer MSB";}' unless defined(&IDTPHY_REGN_PTRM);
    eval 'sub IDTPHY_REGM_PTRM_NDF () {0xf0;}' unless defined(&IDTPHY_REGM_PTRM_NDF);
    eval 'sub IDTPHY_REGS_PTRM_NDF () {4;}' unless defined(&IDTPHY_REGS_PTRM_NDF);
    eval 'sub IDTPHY_REGM_PTRM_SS () {0xc;}' unless defined(&IDTPHY_REGM_PTRM_SS);
    eval 'sub IDTPHY_REGM_PTRM_SONET () {0x;}' unless defined(&IDTPHY_REGM_PTRM_SONET);
    eval 'sub IDTPHY_REGM_PTRM_SDH () {0x8;}' unless defined(&IDTPHY_REGM_PTRM_SDH);
    eval 'sub IDTPHY_REGM_PTRM_PTR () {0x3;}' unless defined(&IDTPHY_REGM_PTRM_PTR);
    eval 'sub IDTPHY_REGX_PTRM () {"\\020\\12\\xf0\\20NDFVal\\12\\xc\\20ssBit\\12\\x3\\20arbPtr";}' unless defined(&IDTPHY_REGX_PTRM);
    eval 'sub IDTPHY_REGO_TC2 () {0x48;}' unless defined(&IDTPHY_REGO_TC2);
    eval 'sub IDTPHY_REGN_TC2 () {"Transmit C2";}' unless defined(&IDTPHY_REGN_TC2);
    eval 'sub IDTPHY_REGO_TPOC2 () {0x49;}' unless defined(&IDTPHY_REGO_TPOC2);
    eval 'sub IDTPHY_REGN_TPOC2 () {"Transmit Path Control 2";}' unless defined(&IDTPHY_REGN_TPOC2);
    eval 'sub IDTPHY_REGM_TPOC2_FEBE () {0xf0;}' unless defined(&IDTPHY_REGM_TPOC2_FEBE);
    eval 'sub IDTPHY_REGS_TPOC2_FEBE () {4;}' unless defined(&IDTPHY_REGS_TPOC2_FEBE);
    eval 'sub IDTPHY_REGM_TPOC2_PRDII () {0x8;}' unless defined(&IDTPHY_REGM_TPOC2_PRDII);
    eval 'sub IDTPHY_REGM_TPOC2_G1 () {0x7;}' unless defined(&IDTPHY_REGM_TPOC2_G1);
    eval 'sub IDTPHY_REGX_TPOC2 () {"\\020\\12\\xf0\\20PFEBEIns\\4PRDIIns\\12\\x7\\20G1Ins";}' unless defined(&IDTPHY_REGX_TPOC2);
    eval 'sub IDTPHY_REGO_RCC () {0x50;}' unless defined(&IDTPHY_REGO_RCC);
    eval 'sub IDTPHY_REGN_RCC () {"Receive Cell Control";}' unless defined(&IDTPHY_REGN_RCC);
    eval 'sub IDTPHY_REGM_RCC_OCD () {0x80;}' unless defined(&IDTPHY_REGM_RCC_OCD);
    eval 'sub IDTPHY_REGM_RCC_PARTY () {0x40;}' unless defined(&IDTPHY_REGM_RCC_PARTY);
    eval 'sub IDTPHY_REGM_RCC_PASS () {0x20;}' unless defined(&IDTPHY_REGM_RCC_PASS);
    eval 'sub IDTPHY_REGM_RCC_DCOR () {0x10;}' unless defined(&IDTPHY_REGM_RCC_DCOR);
    eval 'sub IDTPHY_REGM_RCC_DHEC () {0x8;}' unless defined(&IDTPHY_REGM_RCC_DHEC);
    eval 'sub IDTPHY_REGM_RCC_ADD () {0x4;}' unless defined(&IDTPHY_REGM_RCC_ADD);
    eval 'sub IDTPHY_REGM_RCC_DSCR () {0x2;}' unless defined(&IDTPHY_REGM_RCC_DSCR);
    eval 'sub IDTPHY_REGM_RCC_RFIFO () {0x1;}' unless defined(&IDTPHY_REGM_RCC_RFIFO);
    eval 'sub IDTPHY_REGX_RCC () {"\\020\\10OCD\\7parity\\6pass\\5corDis\\4HECdis\\3csetAdd" "\\2scrDis\\1rxFIFOrst";}' unless defined(&IDTPHY_REGX_RCC);
    eval 'sub IDTPHY_REGO_RCI () {0x51;}' unless defined(&IDTPHY_REGO_RCI);
    eval 'sub IDTPHY_REGN_RCI () {"Receive Cell Interrupt";}' unless defined(&IDTPHY_REGN_RCI);
    eval 'sub IDTPHY_REGM_RCI_OCDE () {0x80;}' unless defined(&IDTPHY_REGM_RCI_OCDE);
    eval 'sub IDTPHY_REGM_RCI_HECE () {0x40;}' unless defined(&IDTPHY_REGM_RCI_HECE);
    eval 'sub IDTPHY_REGM_RCI_OVFE () {0x20;}' unless defined(&IDTPHY_REGM_RCI_OVFE);
    eval 'sub IDTPHY_REGM_RCI_OCDI () {0x10;}' unless defined(&IDTPHY_REGM_RCI_OCDI);
    eval 'sub IDTPHY_REGM_RCI_CORI () {0x8;}' unless defined(&IDTPHY_REGM_RCI_CORI);
    eval 'sub IDTPHY_REGM_RCI_UCORI () {0x4;}' unless defined(&IDTPHY_REGM_RCI_UCORI);
    eval 'sub IDTPHY_REGM_RCI_OVFI () {0x2;}' unless defined(&IDTPHY_REGM_RCI_OVFI);
    eval 'sub IDTPHY_REGM_RCI_RESV () {0x1;}' unless defined(&IDTPHY_REGM_RCI_RESV);
    eval 'sub IDTPHY_REGX_RCI () {"\\020\\10OCDIEn\\7HECIEn\\6ovfIEn\\5OCDInt\\4corInt\\3uncorInt\\2ovfInt";}' unless defined(&IDTPHY_REGX_RCI);
    eval 'sub IDTPHY_REGO_CMH () {0x52;}' unless defined(&IDTPHY_REGO_CMH);
    eval 'sub IDTPHY_REGN_CMH () {"Receive Cell Match Header";}' unless defined(&IDTPHY_REGN_CMH);
    eval 'sub IDTPHY_REGM_CMH_GFC () {0xf0;}' unless defined(&IDTPHY_REGM_CMH_GFC);
    eval 'sub IDTPHY_REGS_CMH_GFC () {4;}' unless defined(&IDTPHY_REGS_CMH_GFC);
    eval 'sub IDTPHY_REGM_CMH_PTI () {0xe;}' unless defined(&IDTPHY_REGM_CMH_PTI);
    eval 'sub IDTPHY_REGS_CMH_PTI () {1;}' unless defined(&IDTPHY_REGS_CMH_PTI);
    eval 'sub IDTPHY_REGM_CMH_CLP () {0x1;}' unless defined(&IDTPHY_REGM_CMH_CLP);
    eval 'sub IDTPHY_REGX_CMH () {"\\020\\12\\xf0\\20GFC\\12\\xe\\20PTI\\12\\x1\\20CLP";}' unless defined(&IDTPHY_REGX_CMH);
    eval 'sub IDTPHY_REGO_CMHM () {0x53;}' unless defined(&IDTPHY_REGO_CMHM);
    eval 'sub IDTPHY_REGN_CMHM () {"Receive Cell Match Header Mask";}' unless defined(&IDTPHY_REGN_CMHM);
    eval 'sub IDTPHY_REGM_CMHM_GFC () {0xf0;}' unless defined(&IDTPHY_REGM_CMHM_GFC);
    eval 'sub IDTPHY_REGS_CMHM_GFC () {4;}' unless defined(&IDTPHY_REGS_CMHM_GFC);
    eval 'sub IDTPHY_REGM_CMHM_PTI () {0xe;}' unless defined(&IDTPHY_REGM_CMHM_PTI);
    eval 'sub IDTPHY_REGS_CMHM_PTI () {1;}' unless defined(&IDTPHY_REGS_CMHM_PTI);
    eval 'sub IDTPHY_REGM_CMHM_CLP () {0x1;}' unless defined(&IDTPHY_REGM_CMHM_CLP);
    eval 'sub IDTPHY_REGX_CMHM () {"\\020\\12\\xf0\\20mskGFC\\12\\xe\\20mskPTI\\12\\x1\\20mskCLP";}' unless defined(&IDTPHY_REGX_CMHM);
    eval 'sub IDTPHY_REGO_CEC () {0x54;}' unless defined(&IDTPHY_REGO_CEC);
    eval 'sub IDTPHY_REGN_CEC () {"Correctable Errors";}' unless defined(&IDTPHY_REGN_CEC);
    eval 'sub IDTPHY_REGO_UEC () {0x55;}' unless defined(&IDTPHY_REGO_UEC);
    eval 'sub IDTPHY_REGN_UEC () {"Uncorrectable Errors";}' unless defined(&IDTPHY_REGN_UEC);
    eval 'sub IDTPHY_REGO_RCCNT () {0x56;}' unless defined(&IDTPHY_REGO_RCCNT);
    eval 'sub IDTPHY_REGN_RCCNT () {"Receive Cells";}' unless defined(&IDTPHY_REGN_RCCNT);
    eval 'sub IDTPHY_REGO_RCCF () {0x59;}' unless defined(&IDTPHY_REGO_RCCF);
    eval 'sub IDTPHY_REGN_RCCF () {"Receive Cell Configuration";}' unless defined(&IDTPHY_REGN_RCCF);
    eval 'sub IDTPHY_REGM_RCCF_GFCE () {0xf0;}' unless defined(&IDTPHY_REGM_RCCF_GFCE);
    eval 'sub IDTPHY_REGS_RCCF_GFCE () {4;}' unless defined(&IDTPHY_REGS_RCCF_GFCE);
    eval 'sub IDTPHY_REGM_RCCF_FIXS () {0x8;}' unless defined(&IDTPHY_REGM_RCCF_FIXS);
    eval 'sub IDTPHY_REGM_RCCF_RCAL () {0x4;}' unless defined(&IDTPHY_REGM_RCCF_RCAL);
    eval 'sub IDTPHY_REGM_RCCF_HECF () {0x3;}' unless defined(&IDTPHY_REGM_RCCF_HECF);
    eval 'sub IDTPHY_REGX_RCCF () {"\\020\\12\\xf0\\20GFCen\\4FixSen\\3RCAlevel\\12\\x3\\20HECftr";}' unless defined(&IDTPHY_REGX_RCCF);
    eval 'sub IDTPHY_REGO_RXID () {0x5a;}' unless defined(&IDTPHY_REGO_RXID);
    eval 'sub IDTPHY_REGN_RXID () {"Receive ID Address";}' unless defined(&IDTPHY_REGN_RXID);
    eval 'sub IDTPHY_REGM_RXID_ID () {0x3;}' unless defined(&IDTPHY_REGM_RXID_ID);
    eval 'sub IDTPHY_REGM_RXID_RESV () {0xfc;}' unless defined(&IDTPHY_REGM_RXID_RESV);
    eval 'sub IDTPHY_REGX_RXID () {"\\020\\12\\x3\\20IDAddr";}' unless defined(&IDTPHY_REGX_RXID);
    eval 'sub IDTPHY_REGO_TCC () {0x60;}' unless defined(&IDTPHY_REGO_TCC);
    eval 'sub IDTPHY_REGN_TCC () {"Transmit Cell Control";}' unless defined(&IDTPHY_REGN_TCC);
    eval 'sub IDTPHY_REGM_TCC_FIFOE () {0x80;}' unless defined(&IDTPHY_REGM_TCC_FIFOE);
    eval 'sub IDTPHY_REGM_TCC_SOCI () {0x40;}' unless defined(&IDTPHY_REGM_TCC_SOCI);
    eval 'sub IDTPHY_REGM_TCC_FIFOI () {0x20;}' unless defined(&IDTPHY_REGM_TCC_FIFOI);
    eval 'sub IDTPHY_REGM_TCC_HECINV () {0x10;}' unless defined(&IDTPHY_REGM_TCC_HECINV);
    eval 'sub IDTPHY_REGM_TCC_HECDIS () {0x8;}' unless defined(&IDTPHY_REGM_TCC_HECDIS);
    eval 'sub IDTPHY_REGM_TCC_ADD () {0x4;}' unless defined(&IDTPHY_REGM_TCC_ADD);
    eval 'sub IDTPHY_REGM_TCC_DSCR () {0x2;}' unless defined(&IDTPHY_REGM_TCC_DSCR);
    eval 'sub IDTPHY_REGM_TCC_FIFOR () {0x1;}' unless defined(&IDTPHY_REGM_TCC_FIFOR);
    eval 'sub IDTPHY_REGX_TCC () {"\\020\\10fovrIEn\\7socInt\\6fovrInt\\5HECInv\\4HECDis\\3csetAdd" "\\2scrDis\\1txFIFOrst";}' unless defined(&IDTPHY_REGX_TCC);
    eval 'sub IDTPHY_REGO_TCHP () {0x61;}' unless defined(&IDTPHY_REGO_TCHP);
    eval 'sub IDTPHY_REGN_TCHP () {"Transmit Idle Cell Header";}' unless defined(&IDTPHY_REGN_TCHP);
    eval 'sub IDTPHY_REGM_TCHP_GFC () {0xf0;}' unless defined(&IDTPHY_REGM_TCHP_GFC);
    eval 'sub IDTPHY_REGS_TCHP_GFC () {4;}' unless defined(&IDTPHY_REGS_TCHP_GFC);
    eval 'sub IDTPHY_REGM_TCHP_PTI () {0xe;}' unless defined(&IDTPHY_REGM_TCHP_PTI);
    eval 'sub IDTPHY_REGS_TCHP_PTI () {1;}' unless defined(&IDTPHY_REGS_TCHP_PTI);
    eval 'sub IDTPHY_REGM_TCHP_CLP () {0x1;}' unless defined(&IDTPHY_REGM_TCHP_CLP);
    eval 'sub IDTPHY_REGX_TCHP () {"\\020\\12\\xf0\\20GFCtx\\12\\xe\\20PTItx\\12\\x1\\20CLPtx";}' unless defined(&IDTPHY_REGX_TCHP);
    eval 'sub IDTPHY_REGO_TPLD () {0x62;}' unless defined(&IDTPHY_REGO_TPLD);
    eval 'sub IDTPHY_REGN_TPLD () {"Transmit Idle Cell Payload";}' unless defined(&IDTPHY_REGN_TPLD);
    eval 'sub IDTPHY_REGO_TCC2 () {0x63;}' unless defined(&IDTPHY_REGO_TCC2);
    eval 'sub IDTPHY_REGN_TCC2 () {"Transmit Cell Configuration 2";}' unless defined(&IDTPHY_REGN_TCC2);
    eval 'sub IDTPHY_REGM_TCC2_PARITY () {0x80;}' unless defined(&IDTPHY_REGM_TCC2_PARITY);
    eval 'sub IDTPHY_REGM_TCC2_PARE () {0x40;}' unless defined(&IDTPHY_REGM_TCC2_PARE);
    eval 'sub IDTPHY_REGM_TCC2_PARI () {0x10;}' unless defined(&IDTPHY_REGM_TCC2_PARI);
    eval 'sub IDTPHY_REGM_TCC2_FIFO () {0xc;}' unless defined(&IDTPHY_REGM_TCC2_FIFO);
    eval 'sub IDTPHY_REGS_TCC2_FIFO () {2;}' unless defined(&IDTPHY_REGS_TCC2_FIFO);
    eval 'sub IDTPHY_REGM_TCC2_TCAL () {0x2;}' unless defined(&IDTPHY_REGM_TCC2_TCAL);
    eval 'sub IDTPHY_REGM_TCC2_RESV () {0x1;}' unless defined(&IDTPHY_REGM_TCC2_RESV);
    eval 'sub IDTPHY_REGX_TCC2 () {"\\020\\10parity\\7parIEn\\5parInt\\12\\xc\\20FIFOdpth\\2TCAlevel";}' unless defined(&IDTPHY_REGX_TCC2);
    eval 'sub IDTPHY_REGO_TXCNT () {0x64;}' unless defined(&IDTPHY_REGO_TXCNT);
    eval 'sub IDTPHY_REGN_TXCNT () {"Transmit Cells";}' unless defined(&IDTPHY_REGN_TXCNT);
    eval 'sub IDTPHY_REGO_TCC3 () {0x67;}' unless defined(&IDTPHY_REGO_TCC3);
    eval 'sub IDTPHY_REGN_TCC3 () {"Transmit Cell Configuration 3";}' unless defined(&IDTPHY_REGN_TCC3);
    eval 'sub IDTPHY_REGM_TCC3_GFCE () {0xf0;}' unless defined(&IDTPHY_REGM_TCC3_GFCE);
    eval 'sub IDTPHY_REGS_TCC3_GFCE () {4;}' unless defined(&IDTPHY_REGS_TCC3_GFCE);
    eval 'sub IDTPHY_REGM_TCC3_FIXE () {0x8;}' unless defined(&IDTPHY_REGM_TCC3_FIXE);
    eval 'sub IDTPHY_REGM_TCC3_H4ID () {0x4;}' unless defined(&IDTPHY_REGM_TCC3_H4ID);
    eval 'sub IDTPHY_REGM_TCC3_FIXB () {0x3;}' unless defined(&IDTPHY_REGM_TCC3_FIXB);
    eval 'sub IDTPHY_REGM_TCC3_FIX00 () {0x;}' unless defined(&IDTPHY_REGM_TCC3_FIX00);
    eval 'sub IDTPHY_REGM_TCC3_FIX55 () {0x1;}' unless defined(&IDTPHY_REGM_TCC3_FIX55);
    eval 'sub IDTPHY_REGM_TCC3_FIXAA () {0x2;}' unless defined(&IDTPHY_REGM_TCC3_FIXAA);
    eval 'sub IDTPHY_REGM_TCC3_FIXFF () {0x3;}' unless defined(&IDTPHY_REGM_TCC3_FIXFF);
    eval 'sub IDTPHY_REGX_TCC3 () {"\\020\\12\\xf0\\20txGFCen\\4txFixSen\\3H4InsDis" "\\11\\x3\\x0FIX00\\11\\x3\\x1FIX55\\11\\x3\\x2FIXAA\\11\\x3\\x3FIXFF";}' unless defined(&IDTPHY_REGX_TCC3);
    eval 'sub IDTPHY_REGO_TXID () {0x68;}' unless defined(&IDTPHY_REGO_TXID);
    eval 'sub IDTPHY_REGN_TXID () {"Transmit ID Address";}' unless defined(&IDTPHY_REGN_TXID);
    eval 'sub IDTPHY_REGM_TXID_ID () {0x3;}' unless defined(&IDTPHY_REGM_TXID_ID);
    eval 'sub IDTPHY_REGM_TXID_RESV () {0xfc;}' unless defined(&IDTPHY_REGM_TXID_RESV);
    eval 'sub IDTPHY_REGX_TXID () {"\\020\\12\\x3\\20txIDAddr";}' unless defined(&IDTPHY_REGX_TXID);
    eval 'sub IDTPHY_REGO_RBER () {0x70;}' unless defined(&IDTPHY_REGO_RBER);
    eval 'sub IDTPHY_REGN_RBER () {"Receive BER S/C";}' unless defined(&IDTPHY_REGN_RBER);
    eval 'sub IDTPHY_REGM_RBER_FAILE () {0x8;}' unless defined(&IDTPHY_REGM_RBER_FAILE);
    eval 'sub IDTPHY_REGM_RBER_WARNE () {0x4;}' unless defined(&IDTPHY_REGM_RBER_WARNE);
    eval 'sub IDTPHY_REGM_RBER_FAIL () {0x2;}' unless defined(&IDTPHY_REGM_RBER_FAIL);
    eval 'sub IDTPHY_REGM_RBER_WARN () {0x1;}' unless defined(&IDTPHY_REGM_RBER_WARN);
    eval 'sub IDTPHY_REGM_RBER_RESV () {0xf0;}' unless defined(&IDTPHY_REGM_RBER_RESV);
    eval 'sub IDTPHY_REGX_RBER () {"\\020\\4FailIEn\\3WarnIEn\\2BERfail\\1BERwarn";}' unless defined(&IDTPHY_REGX_RBER);
    eval 'sub IDTPHY_REGO_BFTH () {0x71;}' unless defined(&IDTPHY_REGO_BFTH);
    eval 'sub IDTPHY_REGN_BFTH () {"Receive BER Fail Threshold";}' unless defined(&IDTPHY_REGN_BFTH);
    eval 'sub IDTPHY_REGO_BFWIN () {0x72;}' unless defined(&IDTPHY_REGO_BFWIN);
    eval 'sub IDTPHY_REGN_BFWIN () {"Receive BER Fail Window";}' unless defined(&IDTPHY_REGN_BFWIN);
    eval 'sub IDTPHY_REGO_BFDEN () {0x73;}' unless defined(&IDTPHY_REGO_BFDEN);
    eval 'sub IDTPHY_REGN_BFDEN () {"Receive BER Fail Denominator";}' unless defined(&IDTPHY_REGN_BFDEN);
    eval 'sub IDTPHY_REGO_BWTH () {0x75;}' unless defined(&IDTPHY_REGO_BWTH);
    eval 'sub IDTPHY_REGN_BWTH () {"Receive BER Warn Threshold";}' unless defined(&IDTPHY_REGN_BWTH);
    eval 'sub IDTPHY_REGO_BWWIN () {0x76;}' unless defined(&IDTPHY_REGO_BWWIN);
    eval 'sub IDTPHY_REGN_BWWIN () {"Receive BER Warn Window";}' unless defined(&IDTPHY_REGN_BWWIN);
    eval 'sub IDTPHY_REGO_BWDEN () {0x77;}' unless defined(&IDTPHY_REGO_BWDEN);
    eval 'sub IDTPHY_REGN_BWDEN () {"Receive BER Warn Denomiator";}' unless defined(&IDTPHY_REGN_BWDEN);
    eval 'sub IDTPHY_REGO_OPEC () {0x7f;}' unless defined(&IDTPHY_REGO_OPEC);
    eval 'sub IDTPHY_REGN_OPEC () {"Output PECL Control";}' unless defined(&IDTPHY_REGN_OPEC);
    eval 'sub IDTPHY_REGM_OPEC_TXC () {0x4;}' unless defined(&IDTPHY_REGM_OPEC_TXC);
    eval 'sub IDTPHY_REGM_OPEC_TXD () {0x2;}' unless defined(&IDTPHY_REGM_OPEC_TXD);
    eval 'sub IDTPHY_REGM_OPEC_RXDO () {0x1;}' unless defined(&IDTPHY_REGM_OPEC_RXDO);
    eval 'sub IDTPHY_REGM_OPEC_RESV () {0xf8;}' unless defined(&IDTPHY_REGM_OPEC_RESV);
    eval 'sub IDTPHY_REGX_OPEC () {"\\020\\3pctl_tc\\2pcctl_td\\1pcctl_r";}' unless defined(&IDTPHY_REGX_OPEC);
    eval 'sub IDTPHY_PRINT_77155 () {{  &UTP_REGT_BITS,  &IDTPHY_REGO_MRID,  &IDTPHY_REGN_MRID,  &IDTPHY_REGX_MRID }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_CONF,  &IDTPHY_REGN_CONF,  &IDTPHY_REGX_CONF }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_INT,  &IDTPHY_REGN_INT,  &IDTPHY_REGX_INT }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_MCM,  &IDTPHY_REGN_MCM,  &IDTPHY_REGX_MCM }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_MCTL,  &IDTPHY_REGN_MCTL,  &IDTPHY_REGX_MCTL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TXC,  &IDTPHY_REGN_TXC,  &IDTPHY_REGX_TXC }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RXC,  &IDTPHY_REGN_RXC,  &IDTPHY_REGX_RXC }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RSOC,  &IDTPHY_REGN_RSOC,  &IDTPHY_REGX_RSOC }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RSOS,  &IDTPHY_REGN_RSOS,  &IDTPHY_REGX_RSOS }, {  &UTP_REGT_INT16,  &IDTPHY_REGO_BIPC,  &IDTPHY_REGN_BIPC,  &NULL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TSOC,  &IDTPHY_REGN_TSOC,  &IDTPHY_REGX_TSOC }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TSOC2,  &IDTPHY_REGN_TSOC2,  &IDTPHY_REGX_TSOC2 }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RLOS,  &IDTPHY_REGN_RLOS,  &IDTPHY_REGX_RLOS }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RLOI,  &IDTPHY_REGN_RLOI,  &IDTPHY_REGX_RLOI }, {  &UTP_REGT_INT20,  &IDTPHY_REGO_B2EC,  &IDTPHY_REGN_B2EC,  &NULL }, {  &UTP_REGT_INT20,  &IDTPHY_REGO_FEBEC,  &IDTPHY_REGN_FEBEC,  &NULL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TLOS,  &IDTPHY_REGN_TLOS,  &IDTPHY_REGX_TLOS }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TLOC,  &IDTPHY_REGN_TLOC,  &IDTPHY_REGX_TLOC }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_TK1,  &IDTPHY_REGN_TK1,  &NULL }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_TK2,  &IDTPHY_REGN_TK2,  &NULL }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_RK1,  &IDTPHY_REGN_RK1,  &NULL }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_RK2,  &IDTPHY_REGN_RK2,  &NULL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RPOS,  &IDTPHY_REGN_RPOS,  &IDTPHY_REGX_RPOS }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RPOI,  &IDTPHY_REGN_RPOI,  &IDTPHY_REGX_RPOI }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RPIE,  &IDTPHY_REGN_RPIE,  &IDTPHY_REGX_RPIE }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_RC2,  &IDTPHY_REGN_RC2,  &NULL }, {  &UTP_REGT_INT16,  &IDTPHY_REGO_B3EC,  &IDTPHY_REGN_B3EC,  &NULL }, {  &UTP_REGT_INT16,  &IDTPHY_REGO_PFEBEC,  &IDTPHY_REGN_PFEBEC,  &NULL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RPEC,  &IDTPHY_REGN_RPEC,  &IDTPHY_REGX_RPEC }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TPOC,  &IDTPHY_REGN_TPOC,  &IDTPHY_REGX_TPOC }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TPTC,  &IDTPHY_REGN_TPTC,  &IDTPHY_REGX_TPTC }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_PTRL,  &IDTPHY_REGN_PTRL,  &IDTPHY_REGX_PTRL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_PTRM,  &IDTPHY_REGN_PTRM,  &IDTPHY_REGX_PTRM }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_TC2,  &IDTPHY_REGN_TC2,  &NULL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TPOC2,  &IDTPHY_REGN_TPOC2,  &IDTPHY_REGX_TPOC2 }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RCC,  &IDTPHY_REGN_RCC,  &IDTPHY_REGX_RCC }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RCI,  &IDTPHY_REGN_RCI,  &IDTPHY_REGX_RCI }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_CMH,  &IDTPHY_REGN_CMH,  &IDTPHY_REGX_CMH }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_CMHM,  &IDTPHY_REGN_CMHM,  &IDTPHY_REGX_CMHM }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_CEC,  &IDTPHY_REGN_CEC,  &NULL }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_UEC,  &IDTPHY_REGN_UEC,  &NULL }, {  &UTP_REGT_INT19,  &IDTPHY_REGO_RCCNT,  &IDTPHY_REGN_RCCNT,  &NULL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RCCF,  &IDTPHY_REGN_RCCF,  &IDTPHY_REGX_RCCF }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RXID,  &IDTPHY_REGN_RXID,  &IDTPHY_REGX_RXID }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TCC,  &IDTPHY_REGN_TCC,  &IDTPHY_REGX_TCC }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TCHP,  &IDTPHY_REGN_TCHP,  &IDTPHY_REGX_TCHP }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_TPLD,  &IDTPHY_REGN_TPLD,  &NULL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TCC2,  &IDTPHY_REGN_TCC2,  &IDTPHY_REGX_TCC2 }, {  &UTP_REGT_INT19,  &IDTPHY_REGO_TXCNT,  &IDTPHY_REGN_TXCNT,  &NULL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TCC3,  &IDTPHY_REGN_TCC3,  &IDTPHY_REGX_TCC3 }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_TXID,  &IDTPHY_REGN_TXID,  &IDTPHY_REGX_TXID }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_RBER,  &IDTPHY_REGN_RBER,  &IDTPHY_REGX_RBER }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_BFTH,  &IDTPHY_REGN_BFTH,  &NULL }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_BFWIN,  &IDTPHY_REGN_BFWIN,  &NULL }, {  &UTP_REGT_INT16,  &IDTPHY_REGO_BFDEN,  &IDTPHY_REGN_BFDEN,  &NULL }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_BWTH,  &IDTPHY_REGN_BWTH,  &NULL }, {  &UTP_REGT_INT8,  &IDTPHY_REGO_BWWIN,  &IDTPHY_REGN_BWWIN,  &NULL }, {  &UTP_REGT_INT16,  &IDTPHY_REGO_BWDEN,  &IDTPHY_REGN_BWDEN,  &NULL }, {  &UTP_REGT_BITS,  &IDTPHY_REGO_OPEC,  &IDTPHY_REGN_OPEC,  &IDTPHY_REGX_OPEC };}' unless defined(&IDTPHY_PRINT_77155);
}
1;
