require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_UTOPIA_SUNI_H)) {
    eval 'sub _DEV_UTOPIA_SUNI_H () {1;}' unless defined(&_DEV_UTOPIA_SUNI_H);
    eval 'sub SUNI_REGN_MRESET () {"Master Reset and Identity/Load Meters";}' unless defined(&SUNI_REGN_MRESET);
    eval 'sub SUNI_REGO_MRESET () {0x;}' unless defined(&SUNI_REGO_MRESET);
    eval 'sub SUNI_REGM_MRESET_RESET () {0x80;}' unless defined(&SUNI_REGM_MRESET_RESET);
    eval 'sub SUNI_REGM_MRESET_TYPE () {0x70;}' unless defined(&SUNI_REGM_MRESET_TYPE);
    eval 'sub SUNI_REGM_MRESET_TYPE_622 () {0x10;}' unless defined(&SUNI_REGM_MRESET_TYPE_622);
    eval 'sub SUNI_REGM_MRESET_TYPE_LITE () {0x30;}' unless defined(&SUNI_REGM_MRESET_TYPE_LITE);
    eval 'sub SUNI_REGM_MRESET_TYPE_ULTRA () {0x70;}' unless defined(&SUNI_REGM_MRESET_TYPE_ULTRA);
    eval 'sub SUNI_REGM_MRESET_TIP_ULTRA () {0x8;}' unless defined(&SUNI_REGM_MRESET_TIP_ULTRA);
    eval 'sub SUNI_REGM_MRESET_ID_ULTRA () {0x7;}' unless defined(&SUNI_REGM_MRESET_ID_ULTRA);
    eval 'sub SUNI_REGM_MRESET_ID_LITE () {0xf;}' unless defined(&SUNI_REGM_MRESET_ID_LITE);
    eval 'sub SUNI_REGM_MRESET_ID_622 () {0xf;}' unless defined(&SUNI_REGM_MRESET_ID_622);
    eval 'sub SUNI_REGX_MRESET_ULTRA () {"\\020\\10RESET\\12\\x70\\12TYPE\\4TIP\\12\\7\\12ID";}' unless defined(&SUNI_REGX_MRESET_ULTRA);
    eval 'sub SUNI_REGX_MRESET_LITE () {"\\020\\10RESET\\12\\x70\\12TYPE\\12\\xf\\12ID";}' unless defined(&SUNI_REGX_MRESET_LITE);
    eval 'sub SUNI_REGX_MRESET_622 () {"\\020\\10RESET\\12\\x70\\12TYPE\\12\\xf\\12ID";}' unless defined(&SUNI_REGX_MRESET_622);
    eval 'sub SUNI_REGN_MCONFIG () {"Master Configuration";}' unless defined(&SUNI_REGN_MCONFIG);
    eval 'sub SUNI_REGO_MCONFIG () {0x1;}' unless defined(&SUNI_REGO_MCONFIG);
    eval 'sub SUNI_REGM_MCONFIG_AUTOFEBE () {0x40;}' unless defined(&SUNI_REGM_MCONFIG_AUTOFEBE);
    eval 'sub SUNI_REGM_MCONFIG_AUTOLRDI () {0x20;}' unless defined(&SUNI_REGM_MCONFIG_AUTOLRDI);
    eval 'sub SUNI_REGM_MCONFIG_AUTOPRDI () {0x10;}' unless defined(&SUNI_REGM_MCONFIG_AUTOPRDI);
    eval 'sub SUNI_REGM_MCONFIG_TCAINV () {0x8;}' unless defined(&SUNI_REGM_MCONFIG_TCAINV);
    eval 'sub SUNI_REGM_MCONFIG_RCAINV () {0x4;}' unless defined(&SUNI_REGM_MCONFIG_RCAINV);
    eval 'sub SUNI_REGM_MCONFIG_RXDINV_LITE () {0x2;}' unless defined(&SUNI_REGM_MCONFIG_RXDINV_LITE);
    eval 'sub SUNI_REGM_MCONFIG_TFP_IN_ULTRA () {0x1;}' unless defined(&SUNI_REGM_MCONFIG_TFP_IN_ULTRA);
    eval 'sub SUNI_REGM_MCONFIG_RESERVED () {0x;}' unless defined(&SUNI_REGM_MCONFIG_RESERVED);
    eval 'sub SUNI_REGX_MCONFIG_LITE () {"\\020\\7AUTOFEBE\\6AUTOLRDI\\5AUTOPRDI\\4TCAINV\\3RCAINV\\2RXDINV";}' unless defined(&SUNI_REGX_MCONFIG_LITE);
    eval 'sub SUNI_REGX_MCONFIG_ULTRA () {"\\020\\7AUTOFEBE\\6AUTOLRDI\\5AUTOPRDI\\4TCAINV\\3RCAINV\\1TFPI_IN";}' unless defined(&SUNI_REGX_MCONFIG_ULTRA);
    eval 'sub SUNI_REGM_MCONFIG_TPTBEN_622 () {0x80;}' unless defined(&SUNI_REGM_MCONFIG_TPTBEN_622);
    eval 'sub SUNI_REGM_MCONFIG_TSTBEN_622 () {0x40;}' unless defined(&SUNI_REGM_MCONFIG_TSTBEN_622);
    eval 'sub SUNI_REGM_MCONFIG_SDH_C1_622 () {0x20;}' unless defined(&SUNI_REGM_MCONFIG_SDH_C1_622);
    eval 'sub SUNI_REGM_MCONFIG_FIXPTR_622 () {0x10;}' unless defined(&SUNI_REGM_MCONFIG_FIXPTR_622);
    eval 'sub SUNI_REGM_MCONFIG_TMODE_622 () {0xc;}' unless defined(&SUNI_REGM_MCONFIG_TMODE_622);
    eval 'sub SUNI_REGM_MCONFIG_TMODE_STS1_BYTE () {0x;}' unless defined(&SUNI_REGM_MCONFIG_TMODE_STS1_BYTE);
    eval 'sub SUNI_REGM_MCONFIG_TMODE_STS3c () {0x4;}' unless defined(&SUNI_REGM_MCONFIG_TMODE_STS3c);
    eval 'sub SUNI_REGM_MCONFIG_TMODE_STS1_BIT () {0x8;}' unless defined(&SUNI_REGM_MCONFIG_TMODE_STS1_BIT);
    eval 'sub SUNI_REGM_MCONFIG_TMODE_STS12c () {0xc;}' unless defined(&SUNI_REGM_MCONFIG_TMODE_STS12c);
    eval 'sub SUNI_REGM_MCONFIG_RMODE_622 () {0x3;}' unless defined(&SUNI_REGM_MCONFIG_RMODE_622);
    eval 'sub SUNI_REGM_MCONFIG_RMODE_STS1_BYTE () {0x;}' unless defined(&SUNI_REGM_MCONFIG_RMODE_STS1_BYTE);
    eval 'sub SUNI_REGM_MCONFIG_RMODE_STS3c () {0x1;}' unless defined(&SUNI_REGM_MCONFIG_RMODE_STS3c);
    eval 'sub SUNI_REGM_MCONFIG_RMODE_STS1_BIT () {0x2;}' unless defined(&SUNI_REGM_MCONFIG_RMODE_STS1_BIT);
    eval 'sub SUNI_REGM_MCONFIG_RMODE_STS12c () {0x3;}' unless defined(&SUNI_REGM_MCONFIG_RMODE_STS12c);
    eval 'sub SUNI_REGX_MCONFIG_622 () {"\\020\\10TPTBEN\\7TSTBEN\\6SDH_C1\\5FIXPTR\\11\\x0C\\0x00XSTS1BYTE\\11\\0x0C\\0x04XSTS3c\\11\\0x0C\\0x08XSTS1BIT\\11\\0x0C\\0x0CXSTS12c\\11\\0x03\\0x00RSTS1BYTE\\11\\0x03\\0x01RSTS3c\\11\\0x03\\0x02RSTS1BIT\\11\\0x03\\0x03RSTS12c";}' unless defined(&SUNI_REGX_MCONFIG_622);
    eval 'sub SUNI_REGN_MISTATUS () {"Master Interrupt Status";}' unless defined(&SUNI_REGN_MISTATUS);
    eval 'sub SUNI_REGO_MISTATUS () {0x2;}' unless defined(&SUNI_REGO_MISTATUS);
    eval 'sub SUNI_REGM_MISTATUS_CSUI_ULTRA () {0x80;}' unless defined(&SUNI_REGM_MISTATUS_CSUI_ULTRA);
    eval 'sub SUNI_REGM_MISTATUS_TROOLI_LITE () {0x80;}' unless defined(&SUNI_REGM_MISTATUS_TROOLI_LITE);
    eval 'sub SUNI_REGM_MISTATUS_SUNII_622 () {0x80;}' unless defined(&SUNI_REGM_MISTATUS_SUNII_622);
    eval 'sub SUNI_REGM_MISTATUS_LCDI () {0x40;}' unless defined(&SUNI_REGM_MISTATUS_LCDI);
    eval 'sub SUNI_REGM_MISTATUS_STBI_622 () {0x40;}' unless defined(&SUNI_REGM_MISTATUS_STBI_622);
    eval 'sub SUNI_REGM_MISTATUS_CRUI_ULTRA () {0x20;}' unless defined(&SUNI_REGM_MISTATUS_CRUI_ULTRA);
    eval 'sub SUNI_REGM_MISTATUS_RDOOLI_LITE () {0x20;}' unless defined(&SUNI_REGM_MISTATUS_RDOOLI_LITE);
    eval 'sub SUNI_REGM_MISTATUS_RESERVED_622 () {0x20;}' unless defined(&SUNI_REGM_MISTATUS_RESERVED_622);
    eval 'sub SUNI_REGM_MISTATUS_TACPI () {0x10;}' unless defined(&SUNI_REGM_MISTATUS_TACPI);
    eval 'sub SUNI_REGM_MISTATUS_RACPI () {0x8;}' unless defined(&SUNI_REGM_MISTATUS_RACPI);
    eval 'sub SUNI_REGM_MISTATUS_RPOPI () {0x4;}' unless defined(&SUNI_REGM_MISTATUS_RPOPI);
    eval 'sub SUNI_REGM_MISTATUS_RLOPI () {0x2;}' unless defined(&SUNI_REGM_MISTATUS_RLOPI);
    eval 'sub SUNI_REGM_MISTATUS_RSOPI () {0x1;}' unless defined(&SUNI_REGM_MISTATUS_RSOPI);
    eval 'sub SUNI_REGX_MISTATUS_LITE () {"\\020\\10TROOLI\\7LCDI\\6RDOOLI\\5TACPI\\4RACPI\\3RPOPI\\2RLOPI\\1RSOPI";}' unless defined(&SUNI_REGX_MISTATUS_LITE);
    eval 'sub SUNI_REGX_MISTATUS_ULTRA () {"\\020\\10CSUI\\7LCDI\\6CRUI\\5TACPI\\4RACPI\\3RPOPI\\2RLOPI\\1RSOPI";}' unless defined(&SUNI_REGX_MISTATUS_ULTRA);
    eval 'sub SUNI_REGX_MISTATUS_622 () {"\\020\\10S/UNII\\7STBI\\5TACPI\\4RACPI\\3RPOPI\\2RLOPI\\1RSOPI";}' unless defined(&SUNI_REGX_MISTATUS_622);
    eval 'sub SUNI_REGN_MMCTRL () {"Master Mode Control";}' unless defined(&SUNI_REGN_MMCTRL);
    eval 'sub SUNI_REGO_MMCTRL () {0x3;}' unless defined(&SUNI_REGO_MMCTRL);
    eval 'sub SUNI_REGM_MMCTRL_51 () {0x2;}' unless defined(&SUNI_REGM_MMCTRL_51);
    eval 'sub SUNI_REGM_MMCTRL_155 () {0x3;}' unless defined(&SUNI_REGM_MMCTRL_155);
    eval 'sub SUNI_REGX_MMCTRL () {"\\020\\11\\3\\00251MBIT\\11\\3\\003155MBIT";}' unless defined(&SUNI_REGX_MMCTRL);
    eval 'sub SUNI_REGN_PISO () {"PISO Interrupt";}' unless defined(&SUNI_REGN_PISO);
    eval 'sub SUNI_REGO_PISO () {0x3;}' unless defined(&SUNI_REGO_PISO);
    eval 'sub SUNI_REGM_PISO_PAEE () {0x2;}' unless defined(&SUNI_REGM_PISO_PAEE);
    eval 'sub SUNI_REGM_PISO_PAEI () {0x1;}' unless defined(&SUNI_REGM_PISO_PAEI);
    eval 'sub SUNI_REGX_PISO () {"\\020\\2PAEE\\1PAEI";}' unless defined(&SUNI_REGX_PISO);
    eval 'sub SUNI_REGN_MCLKM () {"Master Clock Monitor";}' unless defined(&SUNI_REGN_MCLKM);
    eval 'sub SUNI_REGO_MCLKM () {0x4;}' unless defined(&SUNI_REGO_MCLKM);
    eval 'sub SUNI_REGM_MCLKM_RFCLKA () {0x10;}' unless defined(&SUNI_REGM_MCLKM_RFCLKA);
    eval 'sub SUNI_REGM_MCLKM_TFCLKA () {0x8;}' unless defined(&SUNI_REGM_MCLKM_TFCLKA);
    eval 'sub SUNI_REGM_MCLKM_RRCLKA () {0x8;}' unless defined(&SUNI_REGM_MCLKM_RRCLKA);
    eval 'sub SUNI_REGM_MCLKM_REFCLKA () {0x4;}' unless defined(&SUNI_REGM_MCLKM_REFCLKA);
    eval 'sub SUNI_REGM_MCLKM_TRCLKA () {0x4;}' unless defined(&SUNI_REGM_MCLKM_TRCLKA);
    eval 'sub SUNI_REGM_MCLKM_RCLKA () {0x2;}' unless defined(&SUNI_REGM_MCLKM_RCLKA);
    eval 'sub SUNI_REGM_MCLKM_TCLKA () {0x1;}' unless defined(&SUNI_REGM_MCLKM_TCLKA);
    eval 'sub SUNI_REGX_MCLKM_LITE () {"\\020\\4RRCLKA\\3TRCLKA\\2RCLKA\\1TCLKA";}' unless defined(&SUNI_REGX_MCLKM_LITE);
    eval 'sub SUNI_REGX_MCLKM_ULTRA () {"\\020\\5RFCLKA\\4TFCLKA\\3REFCLKA\\2RCLKA\\1TCLKA";}' unless defined(&SUNI_REGX_MCLKM_ULTRA);
    eval 'sub SUNI_REGN_MCTRLM () {"Master Control/Monitor";}' unless defined(&SUNI_REGN_MCTRLM);
    eval 'sub SUNI_REGO_MCTRLM () {0x4;}' unless defined(&SUNI_REGO_MCTRLM);
    eval 'sub SUNI_REGM_MCTRLM_TCAINV () {0x80;}' unless defined(&SUNI_REGM_MCTRLM_TCAINV);
    eval 'sub SUNI_REGM_MCTRLM_RCAINV () {0x40;}' unless defined(&SUNI_REGM_MCTRLM_RCAINV);
    eval 'sub SUNI_REGM_MCTRLM_LLE () {0x20;}' unless defined(&SUNI_REGM_MCTRLM_LLE);
    eval 'sub SUNI_REGM_MCTRLM_DLE () {0x10;}' unless defined(&SUNI_REGM_MCTRLM_DLE);
    eval 'sub SUNI_REGM_MCTRLM_LOOPT () {0x8;}' unless defined(&SUNI_REGM_MCTRLM_LOOPT);
    eval 'sub SUNI_REGM_MCTRLM_DPLE () {0x4;}' unless defined(&SUNI_REGM_MCTRLM_DPLE);
    eval 'sub SUNI_REGM_MCTRLM_PICLKA () {0x2;}' unless defined(&SUNI_REGM_MCTRLM_PICLKA);
    eval 'sub SUNI_REGM_MCTRLM_TCLKA () {0x1;}' unless defined(&SUNI_REGM_MCTRLM_TCLKA);
    eval 'sub SUNI_REGX_MCTRLM () {"\\020\\10TCAINV\\7RCAINV\\6LLE\\5DLE\\4LOOPT\\3DPLE\\2PICLKA\\1TCLKA";}' unless defined(&SUNI_REGX_MCTRLM);
    eval 'sub SUNI_REGN_MCTRL () {"Master Control";}' unless defined(&SUNI_REGN_MCTRL);
    eval 'sub SUNI_REGO_MCTRL () {0x5;}' unless defined(&SUNI_REGO_MCTRL);
    eval 'sub SUNI_REGM_MCTRL_LCDE () {0x80;}' unless defined(&SUNI_REGM_MCTRL_LCDE);
    eval 'sub SUNI_REGM_MCTRL_LCDV () {0x40;}' unless defined(&SUNI_REGM_MCTRL_LCDV);
    eval 'sub SUNI_REGM_MCTRL_FIXPTR () {0x20;}' unless defined(&SUNI_REGM_MCTRL_FIXPTR);
    eval 'sub SUNI_REGM_MCTRL_TPLE () {0x10;}' unless defined(&SUNI_REGM_MCTRL_TPLE);
    eval 'sub SUNI_REGM_MCTRL_PDLE () {0x8;}' unless defined(&SUNI_REGM_MCTRL_PDLE);
    eval 'sub SUNI_REGM_MCTRL_LLE () {0x4;}' unless defined(&SUNI_REGM_MCTRL_LLE);
    eval 'sub SUNI_REGM_MCTRL_SDLE () {0x2;}' unless defined(&SUNI_REGM_MCTRL_SDLE);
    eval 'sub SUNI_REGM_MCTRL_DLE () {0x2;}' unless defined(&SUNI_REGM_MCTRL_DLE);
    eval 'sub SUNI_REGM_MCTRL_LOOPT () {0x1;}' unless defined(&SUNI_REGM_MCTRL_LOOPT);
    eval 'sub SUNI_REGX_MCTRL_ULTRA () {"\\020\\10LCDE\\7LCDV\\6FIXPTR\\5TPLE\\4PDLE\\3LLE\\2SDLE\\1LOOPT";}' unless defined(&SUNI_REGX_MCTRL_ULTRA);
    eval 'sub SUNI_REGX_MCTRL_LITE () {"\\020\\10LCDE\\7LCDV\\6FIXPTR\\3LLE\\2DLE\\1LOOPT";}' unless defined(&SUNI_REGX_MCTRL_LITE);
    eval 'sub SUNI_REGN_MALARM () {"Master Auto Alarm";}' unless defined(&SUNI_REGN_MALARM);
    eval 'sub SUNI_REGO_MALARM () {0x5;}' unless defined(&SUNI_REGO_MALARM);
    eval 'sub SUNI_REGM_MALARM_AUTOFEBE () {0x4;}' unless defined(&SUNI_REGM_MALARM_AUTOFEBE);
    eval 'sub SUNI_REGM_MALARM_AUTOLRDI () {0x2;}' unless defined(&SUNI_REGM_MALARM_AUTOLRDI);
    eval 'sub SUNI_REGM_MALARM_AUTOPRDI () {0x1;}' unless defined(&SUNI_REGM_MALARM_AUTOPRDI);
    eval 'sub SUNI_REGX_MALARM () {"\\020\\4AUTOFEBE\\2AUTOLRDI\\1AUTOPRDI";}' unless defined(&SUNI_REGX_MALARM);
    eval 'sub SUNI_REGN_CLKSYN () {"Clock Synthesis Control and Status";}' unless defined(&SUNI_REGN_CLKSYN);
    eval 'sub SUNI_REGO_CLKSYN () {0x6;}' unless defined(&SUNI_REGO_CLKSYN);
    eval 'sub SUNI_REGM_CLKSYN_TROOLI () {0x20;}' unless defined(&SUNI_REGM_CLKSYN_TROOLI);
    eval 'sub SUNI_REGM_CLKSYN_TROOLV () {0x8;}' unless defined(&SUNI_REGM_CLKSYN_TROOLV);
    eval 'sub SUNI_REGM_CLKSYN_TROOLE () {0x2;}' unless defined(&SUNI_REGM_CLKSYN_TROOLE);
    eval 'sub SUNI_REGM_CLKSYN_TREFSEL () {0x1;}' unless defined(&SUNI_REGM_CLKSYN_TREFSEL);
    eval 'sub SUNI_REGM_CLKSYN_RESERVED () {0x;}' unless defined(&SUNI_REGM_CLKSYN_RESERVED);
    eval 'sub SUNI_REGX_CLKSYN_ULTRA () {"\\020\\6TROOLI\\4TROOLV\\2TROOLE";}' unless defined(&SUNI_REGX_CLKSYN_ULTRA);
    eval 'sub SUNI_REGX_CLKSYN_LITE () {"\\020\\4TROOLV\\2TROOLE\\1TREFSEL";}' unless defined(&SUNI_REGX_CLKSYN_LITE);
    eval 'sub SUNI_REGN_POUT () {"Parallel Output Port";}' unless defined(&SUNI_REGN_POUT);
    eval 'sub SUNI_REGO_POUT () {0x6;}' unless defined(&SUNI_REGO_POUT);
    eval 'sub SUNI_REGM_POUT_POP () {0x3f;}' unless defined(&SUNI_REGM_POUT_POP);
    eval 'sub SUNI_REGX_POUT () {"\\020\\12\\x3f\\12POP";}' unless defined(&SUNI_REGX_POUT);
    eval 'sub SUNI_REGN_CLKREC () {"Clock Recovery Control and Status";}' unless defined(&SUNI_REGN_CLKREC);
    eval 'sub SUNI_REGO_CLKREC_LITE () {0x7;}' unless defined(&SUNI_REGO_CLKREC_LITE);
    eval 'sub SUNI_REGO_CLKREC_ULTRA () {0x8;}' unless defined(&SUNI_REGO_CLKREC_ULTRA);
    eval 'sub SUNI_REGM_CLKREC_RROOLI () {0x40;}' unless defined(&SUNI_REGM_CLKREC_RROOLI);
    eval 'sub SUNI_REGM_CLKREC_RDOOLI () {0x20;}' unless defined(&SUNI_REGM_CLKREC_RDOOLI);
    eval 'sub SUNI_REGM_CLKREC_RROOLV () {0x10;}' unless defined(&SUNI_REGM_CLKREC_RROOLV);
    eval 'sub SUNI_REGM_CLKREC_RDOOLV () {0x8;}' unless defined(&SUNI_REGM_CLKREC_RDOOLV);
    eval 'sub SUNI_REGM_CLKREC_RROOLE () {0x4;}' unless defined(&SUNI_REGM_CLKREC_RROOLE);
    eval 'sub SUNI_REGM_CLKREC_RDOOLE () {0x2;}' unless defined(&SUNI_REGM_CLKREC_RDOOLE);
    eval 'sub SUNI_REGM_CLKREC_RREFSEL () {0x1;}' unless defined(&SUNI_REGM_CLKREC_RREFSEL);
    eval 'sub SUNI_REGM_CLKREC_RESERVED () {0x;}' unless defined(&SUNI_REGM_CLKREC_RESERVED);
    eval 'sub SUNI_REGX_CLKREC_ULTRA () {"\\020\\7RROOLI\\6RDOOLI\\5RROOLV\\4RDOOLV\\3RROOLE\\2RDOOLE";}' unless defined(&SUNI_REGX_CLKREC_ULTRA);
    eval 'sub SUNI_REGX_CLKREC_LITE () {"\\020\\5RROOLV\\4RDOOLV\\2RDOOLE\\1RREFSEL";}' unless defined(&SUNI_REGX_CLKREC_LITE);
    eval 'sub SUNI_REGN_PIN () {"Parallel Input Port";}' unless defined(&SUNI_REGN_PIN);
    eval 'sub SUNI_REGO_PIN () {0x7;}' unless defined(&SUNI_REGO_PIN);
    eval 'sub SUNI_REGN_PINV () {"Parallel Input Port Value";}' unless defined(&SUNI_REGN_PINV);
    eval 'sub SUNI_REGO_PINV () {0x8;}' unless defined(&SUNI_REGO_PINV);
    eval 'sub SUNI_REGM_PINV_PIPV () {0xf;}' unless defined(&SUNI_REGM_PINV_PIPV);
    eval 'sub SUNI_REGX_PINV () {"\\020\\12\\0x0f\\12PIPIV";}' unless defined(&SUNI_REGX_PINV);
    eval 'sub SUNI_REGN_CLKRECCFG () {"Clock Recovery Configuration";}' unless defined(&SUNI_REGN_CLKRECCFG);
    eval 'sub SUNI_REGO_CLKRECCFG () {0x9;}' unless defined(&SUNI_REGO_CLKRECCFG);
    eval 'sub SUNI_REGM_CLKRECCFG_RESERVED () {0x7;}' unless defined(&SUNI_REGM_CLKRECCFG_RESERVED);
    eval 'sub SUNI_REGX_CLKRECCFG () {"\\020";}' unless defined(&SUNI_REGX_CLKRECCFG);
    eval 'sub SUNI_REGN_PINE () {"Parallel Input Port Enable";}' unless defined(&SUNI_REGN_PINE);
    eval 'sub SUNI_REGO_PINE () {0x9;}' unless defined(&SUNI_REGO_PINE);
    eval 'sub SUNI_REGN_LTXCFG1 () {"Line Transmitter Configuration 1";}' unless defined(&SUNI_REGN_LTXCFG1);
    eval 'sub SUNI_REGO_LTXCFG1 () {0xa;}' unless defined(&SUNI_REGO_LTXCFG1);
    eval 'sub SUNI_REGM_LTXCFG1_VREFSEL () {0x80;}' unless defined(&SUNI_REGM_LTXCFG1_VREFSEL);
    eval 'sub SUNI_REGM_LTXCFG1_OEN () {0x20;}' unless defined(&SUNI_REGM_LTXCFG1_OEN);
    eval 'sub SUNI_REGM_LTXCFG1_OTQ () {0x10;}' unless defined(&SUNI_REGM_LTXCFG1_OTQ);
    eval 'sub SUNI_REGM_LTXCFG1_RESERVED () {0xc;}' unless defined(&SUNI_REGM_LTXCFG1_RESERVED);
    eval 'sub SUNI_REGX_LTXCFG1 () {"\\020\\10VREFSEL\\6OEN\\5OTQ";}' unless defined(&SUNI_REGX_LTXCFG1);
    eval 'sub SUNI_REGN_XC1 () {"Transmit C1";}' unless defined(&SUNI_REGN_XC1);
    eval 'sub SUNI_REGO_XC1 () {0xa;}' unless defined(&SUNI_REGO_XC1);
    eval 'sub SUNI_REGN_LTXCFG2 () {"Line Transmitter Configuration 2";}' unless defined(&SUNI_REGN_LTXCFG2);
    eval 'sub SUNI_REGO_LTXCFG2 () {0xb;}' unless defined(&SUNI_REGO_LTXCFG2);
    eval 'sub SUNI_REGM_LTXCFG2_RESERVED () {0xff;}' unless defined(&SUNI_REGM_LTXCFG2_RESERVED);
    eval 'sub SUNI_REGX_LTXCFG2 () {"\\020";}' unless defined(&SUNI_REGX_LTXCFG2);
    eval 'sub SUNI_REGN_APSCS () {"APS Control/Status";}' unless defined(&SUNI_REGN_APSCS);
    eval 'sub SUNI_REGO_APSCS () {0xb;}' unless defined(&SUNI_REGO_APSCS);
    eval 'sub SUNI_REGM_APSCS_PSBFE () {0x80;}' unless defined(&SUNI_REGM_APSCS_PSBFE);
    eval 'sub SUNI_REGM_APSCS_COAPSE () {0x40;}' unless defined(&SUNI_REGM_APSCS_COAPSE);
    eval 'sub SUNI_REGM_APSCS_Z1E () {0x20;}' unless defined(&SUNI_REGM_APSCS_Z1E);
    eval 'sub SUNI_REGM_APSCS_Zi1 () {0x10;}' unless defined(&SUNI_REGM_APSCS_Zi1);
    eval 'sub SUNI_REGM_APSCS_PSBFI () {0x8;}' unless defined(&SUNI_REGM_APSCS_PSBFI);
    eval 'sub SUNI_REGM_APSCS_COAPSI () {0x4;}' unless defined(&SUNI_REGM_APSCS_COAPSI);
    eval 'sub SUNI_REGM_APSCS_RESERVED () {0x2;}' unless defined(&SUNI_REGM_APSCS_RESERVED);
    eval 'sub SUNI_REGM_APSCS_PSBFV () {0x1;}' unless defined(&SUNI_REGM_APSCS_PSBFV);
    eval 'sub SUNI_REGX_APSCS () {"\\020\\10PSBFE\\7COAPSE\\6Z1E\\5Z1I\\4PSBFI\\3COAPSI\\1PSBFV";}' unless defined(&SUNI_REGX_APSCS);
    eval 'sub SUNI_REGN_LRXCFG () {"Line Receiver Configuration";}' unless defined(&SUNI_REGN_LRXCFG);
    eval 'sub SUNI_REGO_LRXCFG () {0xc;}' unless defined(&SUNI_REGO_LRXCFG);
    eval 'sub SUNI_REGM_LRXCFG_RESERVED () {0x1;}' unless defined(&SUNI_REGM_LRXCFG_RESERVED);
    eval 'sub SUNI_REGX_LRXCFG () {"\\020";}' unless defined(&SUNI_REGX_LRXCFG);
    eval 'sub SUNI_REGN_RK1 () {"Receive K1";}' unless defined(&SUNI_REGN_RK1);
    eval 'sub SUNI_REGO_RK1 () {0xc;}' unless defined(&SUNI_REGO_RK1);
    eval 'sub SUNI_REGN_RK2 () {"Receive K2";}' unless defined(&SUNI_REGN_RK2);
    eval 'sub SUNI_REGO_RK2 () {0xd;}' unless defined(&SUNI_REGO_RK2);
    eval 'sub SUNI_REGN_RZ1 () {"Receive Z1";}' unless defined(&SUNI_REGN_RZ1);
    eval 'sub SUNI_REGO_RZ1 () {0xe;}' unless defined(&SUNI_REGO_RZ1);
    eval 'sub SUNI_REGN_XZ1 () {"Transmit Z1";}' unless defined(&SUNI_REGN_XZ1);
    eval 'sub SUNI_REGO_XZ1 () {0xf;}' unless defined(&SUNI_REGO_XZ1);
    eval 'sub SUNI_REGN_RSOPCIE () {"RSOP Control/Interrupt Enable";}' unless defined(&SUNI_REGN_RSOPCIE);
    eval 'sub SUNI_REGO_RSOPCIE () {0x10;}' unless defined(&SUNI_REGO_RSOPCIE);
    eval 'sub SUNI_REGO_RSOPCIE_BIPWORD_622 () {0x80;}' unless defined(&SUNI_REGO_RSOPCIE_BIPWORD_622);
    eval 'sub SUNI_REGM_RSOPCIE_DDS () {0x40;}' unless defined(&SUNI_REGM_RSOPCIE_DDS);
    eval 'sub SUNI_REGM_RSOPCIE_FOOF () {0x20;}' unless defined(&SUNI_REGM_RSOPCIE_FOOF);
    eval 'sub SUNI_REGM_RSOPCIE_RESV () {0x10;}' unless defined(&SUNI_REGM_RSOPCIE_RESV);
    eval 'sub SUNI_REGM_RSOPCIE_ALGO2_622 () {0x10;}' unless defined(&SUNI_REGM_RSOPCIE_ALGO2_622);
    eval 'sub SUNI_REGM_RSOPCIE_BIPEE () {0x8;}' unless defined(&SUNI_REGM_RSOPCIE_BIPEE);
    eval 'sub SUNI_REGM_RSOPCIE_LOSE () {0x4;}' unless defined(&SUNI_REGM_RSOPCIE_LOSE);
    eval 'sub SUNI_REGM_RSOPCIE_LOFE () {0x2;}' unless defined(&SUNI_REGM_RSOPCIE_LOFE);
    eval 'sub SUNI_REGM_RSOPCIE_OOFE () {0x1;}' unless defined(&SUNI_REGM_RSOPCIE_OOFE);
    eval 'sub SUNI_REGX_RSOPCIE () {"\\020\\7DDS\\6FOOF\\4BIPEE\\3LOSE\\2LOFE\\1OOFE";}' unless defined(&SUNI_REGX_RSOPCIE);
    eval 'sub SUNI_REGX_RSOPCIE_622 () {"\\020\\10BIPWORD\\7DDS\\6FOOF\\5ALGO2\\4BIPEE\\3LOSE\\2LOFE\\1OOFE";}' unless defined(&SUNI_REGX_RSOPCIE_622);
    eval 'sub SUNI_REGN_RSOPSIS () {"RSOP Status/Interrupt Status";}' unless defined(&SUNI_REGN_RSOPSIS);
    eval 'sub SUNI_REGO_RSOPSIS () {0x11;}' unless defined(&SUNI_REGO_RSOPSIS);
    eval 'sub SUNI_REGM_RSOPSIS_BIPEI () {0x40;}' unless defined(&SUNI_REGM_RSOPSIS_BIPEI);
    eval 'sub SUNI_REGM_RSOPSIS_LOSI () {0x20;}' unless defined(&SUNI_REGM_RSOPSIS_LOSI);
    eval 'sub SUNI_REGM_RSOPSIS_LOFI () {0x10;}' unless defined(&SUNI_REGM_RSOPSIS_LOFI);
    eval 'sub SUNI_REGM_RSOPSIS_OOFI () {0x8;}' unless defined(&SUNI_REGM_RSOPSIS_OOFI);
    eval 'sub SUNI_REGM_RSOPSIS_LOSV () {0x4;}' unless defined(&SUNI_REGM_RSOPSIS_LOSV);
    eval 'sub SUNI_REGM_RSOPSIS_LOFV () {0x2;}' unless defined(&SUNI_REGM_RSOPSIS_LOFV);
    eval 'sub SUNI_REGM_RSOPSIS_OOFV () {0x1;}' unless defined(&SUNI_REGM_RSOPSIS_OOFV);
    eval 'sub SUNI_REGX_RSOPSIS () {"\\020\\7BIPEI\\6LOSI\\5LOFI\\4OOFI\\3LOSV\\2LOFV\\1OOFV";}' unless defined(&SUNI_REGX_RSOPSIS);
    eval 'sub SUNI_REGN_RSOP_BIP8 () {"RSOP Section BIP-8";}' unless defined(&SUNI_REGN_RSOP_BIP8);
    eval 'sub SUNI_REGO_RSOP_BIP8 () {0x12;}' unless defined(&SUNI_REGO_RSOP_BIP8);
    eval 'sub SUNI_REGN_TSOPCTRL () {"TSOP Control";}' unless defined(&SUNI_REGN_TSOPCTRL);
    eval 'sub SUNI_REGO_TSOPCTRL () {0x14;}' unless defined(&SUNI_REGO_TSOPCTRL);
    eval 'sub SUNI_REGM_TSOPCTRL_DS () {0x40;}' unless defined(&SUNI_REGM_TSOPCTRL_DS);
    eval 'sub SUNI_REGM_TSOPCTRL_LAIS () {0x1;}' unless defined(&SUNI_REGM_TSOPCTRL_LAIS);
    eval 'sub SUNI_REGM_TSOPCTRL_RESERVED () {0x;}' unless defined(&SUNI_REGM_TSOPCTRL_RESERVED);
    eval 'sub SUNI_REGX_TSOPCTRL () {"\\020\\7DS\\1LAIS";}' unless defined(&SUNI_REGX_TSOPCTRL);
    eval 'sub SUNI_REGN_TSOPDIAG () {"TSOP Diagnostics";}' unless defined(&SUNI_REGN_TSOPDIAG);
    eval 'sub SUNI_REGO_TSOPDIAG () {0x15;}' unless defined(&SUNI_REGO_TSOPDIAG);
    eval 'sub SUNI_REGM_TSOPDIAG_DLOS () {0x4;}' unless defined(&SUNI_REGM_TSOPDIAG_DLOS);
    eval 'sub SUNI_REGM_TSOPDIAG_DBIP8 () {0x2;}' unless defined(&SUNI_REGM_TSOPDIAG_DBIP8);
    eval 'sub SUNI_REGM_TSOPDIAG_DFP () {0x1;}' unless defined(&SUNI_REGM_TSOPDIAG_DFP);
    eval 'sub SUNI_REGX_TSOPDIAG () {"\\020\\3DLOS\\2DBIP8\\1DFP";}' unless defined(&SUNI_REGX_TSOPDIAG);
    eval 'sub SUNI_REGN_RLOPCTRL () {"RLOP Control/Status";}' unless defined(&SUNI_REGN_RLOPCTRL);
    eval 'sub SUNI_REGO_RLOPCTRL () {0x18;}' unless defined(&SUNI_REGO_RLOPCTRL);
    eval 'sub SUNI_REGO_RLOPCTRL_BIPWORD () {0x80;}' unless defined(&SUNI_REGO_RLOPCTRL_BIPWORD);
    eval 'sub SUNI_REGO_RLOPCTRL_ALLONES_622 () {0x40;}' unless defined(&SUNI_REGO_RLOPCTRL_ALLONES_622);
    eval 'sub SUNI_REGO_RLOPCTRL_AISDET_622 () {0x20;}' unless defined(&SUNI_REGO_RLOPCTRL_AISDET_622);
    eval 'sub SUNI_REGO_RLOPCTRL_LRDIDET_622 () {0x10;}' unless defined(&SUNI_REGO_RLOPCTRL_LRDIDET_622);
    eval 'sub SUNI_REGO_RLOPCTRL_BIPWORDO_622 () {0x8;}' unless defined(&SUNI_REGO_RLOPCTRL_BIPWORDO_622);
    eval 'sub SUNI_REGO_RLOPCTRL_LAISV () {0x2;}' unless defined(&SUNI_REGO_RLOPCTRL_LAISV);
    eval 'sub SUNI_REGO_RLOPCTRL_RDIV () {0x1;}' unless defined(&SUNI_REGO_RLOPCTRL_RDIV);
    eval 'sub SUNI_REGO_RLOPCTRL_RESERVED () {0x;}' unless defined(&SUNI_REGO_RLOPCTRL_RESERVED);
    eval 'sub SUNI_REGX_RLOPCTRL () {"\\020\\10BIPWORD\\2LAISV\\1RDIV";}' unless defined(&SUNI_REGX_RLOPCTRL);
    eval 'sub SUNI_REGX_RLOPCTRL_622 () {"\\020\\10BIPWORD\\7ALLONES\\6AISDET\\5LRDIDET\\4BIPWORDO\\2LAISV\\1RDIV";}' unless defined(&SUNI_REGX_RLOPCTRL_622);
    eval 'sub SUNI_REGN_RLOPINTR () {"RLOP Interrupt Enable/Interrupt Status";}' unless defined(&SUNI_REGN_RLOPINTR);
    eval 'sub SUNI_REGO_RLOPINTR () {0x19;}' unless defined(&SUNI_REGO_RLOPINTR);
    eval 'sub SUNI_REGO_RLOPINTR_FEBEE () {0x80;}' unless defined(&SUNI_REGO_RLOPINTR_FEBEE);
    eval 'sub SUNI_REGO_RLOPINTR_BIPEE () {0x40;}' unless defined(&SUNI_REGO_RLOPINTR_BIPEE);
    eval 'sub SUNI_REGO_RLOPINTR_LAISE () {0x20;}' unless defined(&SUNI_REGO_RLOPINTR_LAISE);
    eval 'sub SUNI_REGO_RLOPINTR_RDIE () {0x10;}' unless defined(&SUNI_REGO_RLOPINTR_RDIE);
    eval 'sub SUNI_REGO_RLOPINTR_FEBEI () {0x8;}' unless defined(&SUNI_REGO_RLOPINTR_FEBEI);
    eval 'sub SUNI_REGO_RLOPINTR_BIPEI () {0x4;}' unless defined(&SUNI_REGO_RLOPINTR_BIPEI);
    eval 'sub SUNI_REGO_RLOPINTR_LAISI () {0x2;}' unless defined(&SUNI_REGO_RLOPINTR_LAISI);
    eval 'sub SUNI_REGO_RLOPINTR_RDII () {0x1;}' unless defined(&SUNI_REGO_RLOPINTR_RDII);
    eval 'sub SUNI_REGX_RLOPINTR () {"\\020\\10FEBEE\\7BIPEE\\6LAISE\\5DRIE\\4FEBEI\\3BIPEI\\2LAISI\\1RDII";}' unless defined(&SUNI_REGX_RLOPINTR);
    eval 'sub SUNI_REGN_RLOPBIP8_24 () {"RLOP Line BIP-8/24";}' unless defined(&SUNI_REGN_RLOPBIP8_24);
    eval 'sub SUNI_REGO_RLOPBIP8_24 () {0x1a;}' unless defined(&SUNI_REGO_RLOPBIP8_24);
    eval 'sub SUNI_REGM_RLOPBIP8_24 () {0xf;}' unless defined(&SUNI_REGM_RLOPBIP8_24);
    eval 'sub SUNI_REGN_RLOPBIP8_24_96 () {"RLOP Line BIP-8/24/96";}' unless defined(&SUNI_REGN_RLOPBIP8_24_96);
    eval 'sub SUNI_REGO_RLOPBIP8_24_96 () {0x1a;}' unless defined(&SUNI_REGO_RLOPBIP8_24_96);
    eval 'sub SUNI_REGM_RLOPBIP8_24_96 () {0xf;}' unless defined(&SUNI_REGM_RLOPBIP8_24_96);
    eval 'sub SUNI_REGN_RLOPFEBE () {"RLOP Line FEBE";}' unless defined(&SUNI_REGN_RLOPFEBE);
    eval 'sub SUNI_REGO_RLOPFEBE () {0x1d;}' unless defined(&SUNI_REGO_RLOPFEBE);
    eval 'sub SUNI_REGM_RLOPFEBE () {0xf;}' unless defined(&SUNI_REGM_RLOPFEBE);
    eval 'sub SUNI_REGN_TLOPCTRL () {"TLOP Control";}' unless defined(&SUNI_REGN_TLOPCTRL);
    eval 'sub SUNI_REGO_TLOPCTRL () {0x20;}' unless defined(&SUNI_REGO_TLOPCTRL);
    eval 'sub SUNI_REGM_TLOPCTRL_APSREG_622 () {0x20;}' unless defined(&SUNI_REGM_TLOPCTRL_APSREG_622);
    eval 'sub SUNI_REGM_TLOPCTRL_RDI () {0x1;}' unless defined(&SUNI_REGM_TLOPCTRL_RDI);
    eval 'sub SUNI_REGM_TLOPCTRL_RESERVED () {0x;}' unless defined(&SUNI_REGM_TLOPCTRL_RESERVED);
    eval 'sub SUNI_REGX_TLOPCTRL () {"\\020\\1RDI";}' unless defined(&SUNI_REGX_TLOPCTRL);
    eval 'sub SUNI_REGX_TLOPCTRL_622 () {"\\020\\6APSREG\\1LRDI";}' unless defined(&SUNI_REGX_TLOPCTRL_622);
    eval 'sub SUNI_REGN_TLOPDIAG () {"TLOP Diagnostics";}' unless defined(&SUNI_REGN_TLOPDIAG);
    eval 'sub SUNI_REGO_TLOPDIAG () {0x21;}' unless defined(&SUNI_REGO_TLOPDIAG);
    eval 'sub SUNI_REGM_TLOPDIAG_DBIP () {0x1;}' unless defined(&SUNI_REGM_TLOPDIAG_DBIP);
    eval 'sub SUNI_REGX_TLOPDIAG () {"\\020\\1DBIP";}' unless defined(&SUNI_REGX_TLOPDIAG);
    eval 'sub SUNI_REGN_TLOP_XK1 () {"TLOP Transmit K1";}' unless defined(&SUNI_REGN_TLOP_XK1);
    eval 'sub SUNI_REGO_TLOP_XK1 () {0x22;}' unless defined(&SUNI_REGO_TLOP_XK1);
    eval 'sub SUNI_REGN_TLOP_XK2 () {"TLOP Transmit K2";}' unless defined(&SUNI_REGN_TLOP_XK2);
    eval 'sub SUNI_REGO_TLOP_XK2 () {0x23;}' unless defined(&SUNI_REGO_TLOP_XK2);
    eval 'sub SUNI_REGN_SSTBCTRL () {"SSTB Control";}' unless defined(&SUNI_REGN_SSTBCTRL);
    eval 'sub SUNI_REGO_SSTBCTRL () {0x28;}' unless defined(&SUNI_REGO_SSTBCTRL);
    eval 'sub SUNI_REGM_SSTBCTRL_RRAMACC () {0x40;}' unless defined(&SUNI_REGM_SSTBCTRL_RRAMACC);
    eval 'sub SUNI_REGM_SSTBCTRL_RTIUIE () {0x20;}' unless defined(&SUNI_REGM_SSTBCTRL_RTIUIE);
    eval 'sub SUNI_REGM_SSTBCTRL_RTIMIE () {0x10;}' unless defined(&SUNI_REGM_SSTBCTRL_RTIMIE);
    eval 'sub SUNI_REGM_SSTBCTRL_PER5 () {0x8;}' unless defined(&SUNI_REGM_SSTBCTRL_PER5);
    eval 'sub SUNI_REGM_SSTBCTRL_TNULL () {0x4;}' unless defined(&SUNI_REGM_SSTBCTRL_TNULL);
    eval 'sub SUNI_REGM_SSTBCTRL_NOSYNC () {0x2;}' unless defined(&SUNI_REGM_SSTBCTRL_NOSYNC);
    eval 'sub SUNI_REGM_SSTBCTRL_LEN16 () {0x1;}' unless defined(&SUNI_REGM_SSTBCTRL_LEN16);
    eval 'sub SUNI_REGX_SSTBCTRL () {"\\020\\7RRAMACC\\6RTIUIE\\5RTIMIE\\4PER5\\3TNULL\\2NOSYNC\\1LEN16";}' unless defined(&SUNI_REGX_SSTBCTRL);
    eval 'sub SUNI_REGN_SSTBSTIS () {"SSTB Section Trace Identifier Status";}' unless defined(&SUNI_REGN_SSTBSTIS);
    eval 'sub SUNI_REGO_SSTBSTIS () {0x29;}' unless defined(&SUNI_REGO_SSTBSTIS);
    eval 'sub SUNI_REGM_SSTBSTIS_BUSY () {0x80;}' unless defined(&SUNI_REGM_SSTBSTIS_BUSY);
    eval 'sub SUNI_REGM_SSTBSTIS_RTIUI () {0x8;}' unless defined(&SUNI_REGM_SSTBSTIS_RTIUI);
    eval 'sub SUNI_REGM_SSTBSTIS_RTIUV () {0x4;}' unless defined(&SUNI_REGM_SSTBSTIS_RTIUV);
    eval 'sub SUNI_REGM_SSTBSTIS_RTIMI () {0x2;}' unless defined(&SUNI_REGM_SSTBSTIS_RTIMI);
    eval 'sub SUNI_REGM_SSTBSTIS_RTIMV () {0x1;}' unless defined(&SUNI_REGM_SSTBSTIS_RTIMV);
    eval 'sub SUNI_REGX_SSTBSTIS () {"\\020\\10BUSY\\4RTIUI\\3RTIUV\\2RTIMI\\1RTIMV";}' unless defined(&SUNI_REGX_SSTBSTIS);
    eval 'sub SUNI_REGN_SSTBIAR () {"SSTB Indirect Address Register";}' unless defined(&SUNI_REGN_SSTBIAR);
    eval 'sub SUNI_REGO_SSTBIAR () {0x2a;}' unless defined(&SUNI_REGO_SSTBIAR);
    eval 'sub SUNI_REGM_SSTBIAR_RWB () {0x80;}' unless defined(&SUNI_REGM_SSTBIAR_RWB);
    eval 'sub SUNI_REGM_SSTBIAR_A () {0x7f;}' unless defined(&SUNI_REGM_SSTBIAR_A);
    eval 'sub SUNI_REGX_SSTBIAR () {"\\020\\10RWB\\12\\x7f\\20";}' unless defined(&SUNI_REGX_SSTBIAR);
    eval 'sub SUNI_REGN_SSTBIDR () {"SSTB Indirect Data Register";}' unless defined(&SUNI_REGN_SSTBIDR);
    eval 'sub SUNI_REGO_SSTBIDR () {0x2b;}' unless defined(&SUNI_REGO_SSTBIDR);
    if(0) {
	eval 'sub SUNI_REGN_SSTBECSM () {"SSTB Expected Clock Synchronization Message";}' unless defined(&SUNI_REGN_SSTBECSM);
	eval 'sub SUNI_REGO_SSTBECSM () {0x2c;}' unless defined(&SUNI_REGO_SSTBECSM);
    }
    eval 'sub SUNI_REGN_SSTBCSMS () {"SSTB Clock Synchronisation Message Status";}' unless defined(&SUNI_REGN_SSTBCSMS);
    eval 'sub SUNI_REGO_SSTBCSMS () {0x2d;}' unless defined(&SUNI_REGO_SSTBCSMS);
    eval 'sub SUNI_REGM_SSTBCSMS_RCSMUIE () {0x80;}' unless defined(&SUNI_REGM_SSTBCSMS_RCSMUIE);
    eval 'sub SUNI_REGM_SSTBCSMS_RCSMMIE () {0x40;}' unless defined(&SUNI_REGM_SSTBCSMS_RCSMMIE);
    eval 'sub SUNI_REGM_SSTBCSMS_RCSMUI () {0x8;}' unless defined(&SUNI_REGM_SSTBCSMS_RCSMUI);
    eval 'sub SUNI_REGM_SSTBCSMS_RCSMUV () {0x4;}' unless defined(&SUNI_REGM_SSTBCSMS_RCSMUV);
    eval 'sub SUNI_REGM_SSTBCSMS_RCSMMI () {0x2;}' unless defined(&SUNI_REGM_SSTBCSMS_RCSMMI);
    eval 'sub SUNI_REGM_SSTBCSMS_RCSMMV () {0x1;}' unless defined(&SUNI_REGM_SSTBCSMS_RCSMMV);
    eval 'sub SUNI_REGX_SSTBCSMS () {"\\020\\10RCSMUIE\\7RCSMMIE\\4RCSMUI\\3RCSMUV\\2RCSMMI\\1RCSMMV";}' unless defined(&SUNI_REGX_SSTBCSMS);
    eval 'sub SUNI_REGN_RPOPCTRL () {"RPOP Status/Control";}' unless defined(&SUNI_REGN_RPOPCTRL);
    eval 'sub SUNI_REGO_RPOPCTRL () {0x30;}' unless defined(&SUNI_REGO_RPOPCTRL);
    eval 'sub SUNI_REGM_RPOPCTRL_LOP () {0x20;}' unless defined(&SUNI_REGM_RPOPCTRL_LOP);
    eval 'sub SUNI_REGM_RPOPCTRL_PAIS () {0x8;}' unless defined(&SUNI_REGM_RPOPCTRL_PAIS);
    eval 'sub SUNI_REGM_RPOPCTRL_PRDI () {0x4;}' unless defined(&SUNI_REGM_RPOPCTRL_PRDI);
    eval 'sub SUNI_REGM_RPOPCTRL_NEWPTRI_622 () {0x2;}' unless defined(&SUNI_REGM_RPOPCTRL_NEWPTRI_622);
    eval 'sub SUNI_REGM_RPOPCTRL_NEWPTRE_622 () {0x1;}' unless defined(&SUNI_REGM_RPOPCTRL_NEWPTRE_622);
    eval 'sub SUNI_REGM_RPOPCTRL_RESERVED () {0x;}' unless defined(&SUNI_REGM_RPOPCTRL_RESERVED);
    eval 'sub SUNI_REGX_RPOPCTRL () {"\\020\\6LOP\\4PAIS\\3PRDI";}' unless defined(&SUNI_REGX_RPOPCTRL);
    eval 'sub SUNI_REGX_RPOPCTRL_622 () {"\\020\\6LOP\\4PAIS\\3PRDI\\2NEWPTRI\\1NEWPTRE";}' unless defined(&SUNI_REGX_RPOPCTRL_622);
    eval 'sub SUNI_REGN_RPOPISTAT () {"RPOP Interrupt Status";}' unless defined(&SUNI_REGN_RPOPISTAT);
    eval 'sub SUNI_REGO_RPOPISTAT () {0x31;}' unless defined(&SUNI_REGO_RPOPISTAT);
    eval 'sub SUNI_REGM_RPOPISTAT_PSLI () {0x80;}' unless defined(&SUNI_REGM_RPOPISTAT_PSLI);
    eval 'sub SUNI_REGM_RPOPISTAT_LOPI () {0x20;}' unless defined(&SUNI_REGM_RPOPISTAT_LOPI);
    eval 'sub SUNI_REGM_RPOPISTAT_PAISI () {0x8;}' unless defined(&SUNI_REGM_RPOPISTAT_PAISI);
    eval 'sub SUNI_REGM_RPOPISTAT_PRDII () {0x4;}' unless defined(&SUNI_REGM_RPOPISTAT_PRDII);
    eval 'sub SUNI_REGM_RPOPISTAT_BIPEI () {0x2;}' unless defined(&SUNI_REGM_RPOPISTAT_BIPEI);
    eval 'sub SUNI_REGM_RPOPISTAT_FEBEI () {0x1;}' unless defined(&SUNI_REGM_RPOPISTAT_FEBEI);
    eval 'sub SUNI_REGX_RPOPISTAT () {"\\02010PSLI\\6LOPI\\4PAISI\\3PRDII\\2BIPEI\\1FEBEI";}' unless defined(&SUNI_REGX_RPOPISTAT);
    eval 'sub SUNI_REGN_RPOPPIS () {"RPOP Pointer Interrupt Status";}' unless defined(&SUNI_REGN_RPOPPIS);
    eval 'sub SUNI_REGO_RPOPPIS () {0x32;}' unless defined(&SUNI_REGO_RPOPPIS);
    eval 'sub SUNI_REGM_RPOPPIS_ILLJREQI () {0x80;}' unless defined(&SUNI_REGM_RPOPPIS_ILLJREQI);
    eval 'sub SUNI_REGM_RPOPPIS_DISCOPAI () {0x20;}' unless defined(&SUNI_REGM_RPOPPIS_DISCOPAI);
    eval 'sub SUNI_REGM_RPOPPIS_INVNDFI () {0x10;}' unless defined(&SUNI_REGM_RPOPPIS_INVNDFI);
    eval 'sub SUNI_REGM_RPOPPIS_ILLPTRI () {0x8;}' unless defined(&SUNI_REGM_RPOPPIS_ILLPTRI);
    eval 'sub SUNI_REGM_RPOPPIS_NSEI () {0x4;}' unless defined(&SUNI_REGM_RPOPPIS_NSEI);
    eval 'sub SUNI_REGM_RPOPPIS_PSEI () {0x2;}' unless defined(&SUNI_REGM_RPOPPIS_PSEI);
    eval 'sub SUNI_REGM_RPOPPIS_NDFI () {0x1;}' unless defined(&SUNI_REGM_RPOPPIS_NDFI);
    eval 'sub SUNI_REGX_RPOPPIS () {"\\020\\10ILLJREQI\\6DISCOPAI\\5INVNDFI\\4ILLPTRI\\3NSEI\\2PSEI\\1NDFI";}' unless defined(&SUNI_REGX_RPOPPIS);
    eval 'sub SUNI_REGN_RPOPIEN () {"RPOP Interrupt Enable";}' unless defined(&SUNI_REGN_RPOPIEN);
    eval 'sub SUNI_REGO_RPOPIEN () {0x33;}' unless defined(&SUNI_REGO_RPOPIEN);
    eval 'sub SUNI_REGM_RPOPIEN_PSLE () {0x80;}' unless defined(&SUNI_REGM_RPOPIEN_PSLE);
    eval 'sub SUNI_REGM_RPOPIEN_LOPE () {0x20;}' unless defined(&SUNI_REGM_RPOPIEN_LOPE);
    eval 'sub SUNI_REGM_RPOPIEN_PAISE () {0x8;}' unless defined(&SUNI_REGM_RPOPIEN_PAISE);
    eval 'sub SUNI_REGM_RPOPIEN_PRDIE () {0x4;}' unless defined(&SUNI_REGM_RPOPIEN_PRDIE);
    eval 'sub SUNI_REGM_RPOPIEN_BIPEE () {0x2;}' unless defined(&SUNI_REGM_RPOPIEN_BIPEE);
    eval 'sub SUNI_REGM_RPOPIEN_FEBEE () {0x1;}' unless defined(&SUNI_REGM_RPOPIEN_FEBEE);
    eval 'sub SUNI_REGM_RPOPIEN_RESERVED () {0x;}' unless defined(&SUNI_REGM_RPOPIEN_RESERVED);
    eval 'sub SUNI_REGX_RPOPIEN () {"\\02010PSLE\\6LOPE\\4PAISE\\3PRDIE\\2BIPEE\\1FEBEE";}' unless defined(&SUNI_REGX_RPOPIEN);
    eval 'sub SUNI_REGN_RPOPPIE () {"RPOP Pointer Interrupt Enable";}' unless defined(&SUNI_REGN_RPOPPIE);
    eval 'sub SUNI_REGO_RPOPPIE () {0x34;}' unless defined(&SUNI_REGO_RPOPPIE);
    eval 'sub SUNI_REGM_RPOPPIE_ILLJREQE () {0x80;}' unless defined(&SUNI_REGM_RPOPPIE_ILLJREQE);
    eval 'sub SUNI_REGM_RPOPPIE_DISCOPAE () {0x20;}' unless defined(&SUNI_REGM_RPOPPIE_DISCOPAE);
    eval 'sub SUNI_REGM_RPOPPIE_INVNDFE () {0x10;}' unless defined(&SUNI_REGM_RPOPPIE_INVNDFE);
    eval 'sub SUNI_REGM_RPOPPIE_ILLPTRE () {0x8;}' unless defined(&SUNI_REGM_RPOPPIE_ILLPTRE);
    eval 'sub SUNI_REGM_RPOPPIE_NSEE () {0x4;}' unless defined(&SUNI_REGM_RPOPPIE_NSEE);
    eval 'sub SUNI_REGM_RPOPPIE_PSEE () {0x2;}' unless defined(&SUNI_REGM_RPOPPIE_PSEE);
    eval 'sub SUNI_REGM_RPOPPIE_NDFE () {0x1;}' unless defined(&SUNI_REGM_RPOPPIE_NDFE);
    eval 'sub SUNI_REGX_RPOPPIE () {"\\020\\10ILLJREQE\\6DISCOPAE\\5INVNDFE\\4ILLPTRE\\3NSEE\\2PSEE\\1NDFE";}' unless defined(&SUNI_REGX_RPOPPIE);
    eval 'sub SUNI_REGN_RPOPPTR () {"RPOP Pointer";}' unless defined(&SUNI_REGN_RPOPPTR);
    eval 'sub SUNI_REGO_RPOPPTR () {0x35;}' unless defined(&SUNI_REGO_RPOPPTR);
    eval 'sub SUNI_REGM_RPOPPTR_RDI10 () {0x20;}' unless defined(&SUNI_REGM_RPOPPTR_RDI10);
    eval 'sub SUNI_REGM_RPOPPTR_S () {0xc;}' unless defined(&SUNI_REGM_RPOPPTR_S);
    eval 'sub SUNI_REGS_RPOPPTR_S () {2;}' unless defined(&SUNI_REGS_RPOPPTR_S);
    eval 'sub SUNI_REGM_RPOPPTR () {0x3;}' unless defined(&SUNI_REGM_RPOPPTR);
    eval 'sub SUNI_REGS_RPOPPTR () {0;}' unless defined(&SUNI_REGS_RPOPPTR);
    eval 'sub SUNI_REGX_RPOPPTR () {"\\020\\6RDI10\\12\\xc\\20S";}' unless defined(&SUNI_REGX_RPOPPTR);
    eval 'sub SUNI_REGN_RPOPPSL () {"RPOP Path Signal Label";}' unless defined(&SUNI_REGN_RPOPPSL);
    eval 'sub SUNI_REGO_RPOPPSL () {0x37;}' unless defined(&SUNI_REGO_RPOPPSL);
    eval 'sub SUNI_REGN_RPOPBIP8 () {"RPOP Path BIP-8";}' unless defined(&SUNI_REGN_RPOPBIP8);
    eval 'sub SUNI_REGO_RPOPBIP8 () {0x38;}' unless defined(&SUNI_REGO_RPOPBIP8);
    eval 'sub SUNI_REGN_RPOPFEBE () {"RPOP Path FEBE";}' unless defined(&SUNI_REGN_RPOPFEBE);
    eval 'sub SUNI_REGO_RPOPFEBE () {0x3a;}' unless defined(&SUNI_REGO_RPOPFEBE);
    eval 'sub SUNI_REGN_RPOPRDI () {"RPOP RDI";}' unless defined(&SUNI_REGN_RPOPRDI);
    eval 'sub SUNI_REGO_RPOPRDI () {0x3c;}' unless defined(&SUNI_REGO_RPOPRDI);
    eval 'sub SUNI_REGM_RPOPRDI_BLKFEBE () {0x10;}' unless defined(&SUNI_REGM_RPOPRDI_BLKFEBE);
    eval 'sub SUNI_REGM_RPOPRDI_ARDIE () {0x2;}' unless defined(&SUNI_REGM_RPOPRDI_ARDIE);
    eval 'sub SUNI_REGM_RPOPRDI_ARDIV () {0x1;}' unless defined(&SUNI_REGM_RPOPRDI_ARDIV);
    eval 'sub SUNI_REGM_RPOPRDI_RESERVED () {0x;}' unless defined(&SUNI_REGM_RPOPRDI_RESERVED);
    eval 'sub SUNI_REGX_RPOPRDI () {"\\020\\5BLKFEBE\\2ARDIE\\1ARDIV";}' unless defined(&SUNI_REGX_RPOPRDI);
    eval 'sub SUNI_REGN_RPOPBIP8CFG () {"RPOP Path BIP-8 Configuration";}' unless defined(&SUNI_REGN_RPOPBIP8CFG);
    eval 'sub SUNI_REGO_RPOPBIP8CFG () {0x3d;}' unless defined(&SUNI_REGO_RPOPBIP8CFG);
    eval 'sub SUNI_REGM_RPOPBIP8CFG_BLKBIP () {0x20;}' unless defined(&SUNI_REGM_RPOPBIP8CFG_BLKBIP);
    eval 'sub SUNI_REGM_RPOPBIP8CFG_RESERVED () {0x;}' unless defined(&SUNI_REGM_RPOPBIP8CFG_RESERVED);
    eval 'sub SUNI_REGX_RPOPBIP8CFG () {"\\020\\6BLKBIP";}' unless defined(&SUNI_REGX_RPOPBIP8CFG);
    eval 'sub SUNI_REGN_RPOPRING () {"RPOP Ring Control";}' unless defined(&SUNI_REGN_RPOPRING);
    eval 'sub SUNI_REGO_RPOPRING () {0x3d;}' unless defined(&SUNI_REGO_RPOPRING);
    eval 'sub SUNI_REGM_RPOPRING_SOS () {0x80;}' unless defined(&SUNI_REGM_RPOPRING_SOS);
    eval 'sub SUNI_REGM_RPOPRING_ENSS () {0x40;}' unless defined(&SUNI_REGM_RPOPRING_ENSS);
    eval 'sub SUNI_REGM_RPOPRING_BLKBIP () {0x20;}' unless defined(&SUNI_REGM_RPOPRING_BLKBIP);
    eval 'sub SUNI_REGM_RPOPRING_DISFS () {0x10;}' unless defined(&SUNI_REGM_RPOPRING_DISFS);
    eval 'sub SUNI_REGM_RPOPRING_BLKBIPO () {0x8;}' unless defined(&SUNI_REGM_RPOPRING_BLKBIPO);
    eval 'sub SUNI_REGM_RPOPRING_RESERVED () {0x;}' unless defined(&SUNI_REGM_RPOPRING_RESERVED);
    eval 'sub SUNI_REGX_RPOPRING () {"\\020\\10SOS\\7ENSS\\6BLKBIP\\5DISFS\\4BLKBIPO";}' unless defined(&SUNI_REGX_RPOPRING);
    eval 'sub SUNI_REGN_TPOPCTRL () {"TPOP Control/Diagnostic";}' unless defined(&SUNI_REGN_TPOPCTRL);
    eval 'sub SUNI_REGO_TPOPCTRL () {0x40;}' unless defined(&SUNI_REGO_TPOPCTRL);
    eval 'sub SUNI_REGM_TPOPCTRL_EXCFS () {0x80;}' unless defined(&SUNI_REGM_TPOPCTRL_EXCFS);
    eval 'sub SUNI_REGM_TPOPCTRL_DB3 () {0x2;}' unless defined(&SUNI_REGM_TPOPCTRL_DB3);
    eval 'sub SUNI_REGM_TPOPCTRL_PAIS () {0x1;}' unless defined(&SUNI_REGM_TPOPCTRL_PAIS);
    eval 'sub SUNI_REGM_TPOPCTRL_RESERVED () {0x;}' unless defined(&SUNI_REGM_TPOPCTRL_RESERVED);
    eval 'sub SUNI_REGX_TPOPCTRL () {"\\020\\2DB3\\1PAIS";}' unless defined(&SUNI_REGX_TPOPCTRL);
    eval 'sub SUNI_REGX_TPOPCTRL_622 () {"\\020\\4EXCFS\\2DB3\\1PAIS";}' unless defined(&SUNI_REGX_TPOPCTRL_622);
    eval 'sub SUNI_REGN_TPOPPTRC () {"TPOP Pointer Control";}' unless defined(&SUNI_REGN_TPOPPTRC);
    eval 'sub SUNI_REGO_TPOPPTRC () {0x41;}' unless defined(&SUNI_REGO_TPOPPTRC);
    eval 'sub SUNI_REGM_TPOPPTRC_FTPTR () {0x40;}' unless defined(&SUNI_REGM_TPOPPTRC_FTPTR);
    eval 'sub SUNI_REGM_TPOPPTRC_SOS () {0x20;}' unless defined(&SUNI_REGM_TPOPPTRC_SOS);
    eval 'sub SUNI_REGM_TPOPPTRC_PLD () {0x10;}' unless defined(&SUNI_REGM_TPOPPTRC_PLD);
    eval 'sub SUNI_REGM_TPOPPTRC_NDF () {0x8;}' unless defined(&SUNI_REGM_TPOPPTRC_NDF);
    eval 'sub SUNI_REGM_TPOPPTRC_NSE () {0x4;}' unless defined(&SUNI_REGM_TPOPPTRC_NSE);
    eval 'sub SUNI_REGM_TPOPPTRC_PSE () {0x2;}' unless defined(&SUNI_REGM_TPOPPTRC_PSE);
    eval 'sub SUNI_REGM_TPOPPTRC_RESERVED () {0x;}' unless defined(&SUNI_REGM_TPOPPTRC_RESERVED);
    eval 'sub SUNI_REGX_TPOPPTRC () {"\\020\\7FTPTR\\6SOS\\5PLD\\4NDF\\3NSE\\2PSE";}' unless defined(&SUNI_REGX_TPOPPTRC);
    eval 'sub SUNI_REGN_TPOPCP () {"TPOP Current Pointer";}' unless defined(&SUNI_REGN_TPOPCP);
    eval 'sub SUNI_REGO_TPOPCP () {0x43;}' unless defined(&SUNI_REGO_TPOPCP);
    eval 'sub SUNI_REGM_TPOPCP () {0x3;}' unless defined(&SUNI_REGM_TPOPCP);
    eval 'sub SUNI_REGS_TPOPCP () {0;}' unless defined(&SUNI_REGS_TPOPCP);
    eval 'sub SUNI_REGX_TPOPCP () {"\\020";}' unless defined(&SUNI_REGX_TPOPCP);
    eval 'sub SUNI_REGN_TPOPAPTR () {"TPOP Arbitrary Pointer";}' unless defined(&SUNI_REGN_TPOPAPTR);
    eval 'sub SUNI_REGO_TPOPAPTR () {0x45;}' unless defined(&SUNI_REGO_TPOPAPTR);
    eval 'sub SUNI_REGM_TPOPAPTR_NDF () {0xf0;}' unless defined(&SUNI_REGM_TPOPAPTR_NDF);
    eval 'sub SUNI_REGS_TPOPAPTR_NDF () {4;}' unless defined(&SUNI_REGS_TPOPAPTR_NDF);
    eval 'sub SUNI_REGM_TPOPAPTR_S () {0xc;}' unless defined(&SUNI_REGM_TPOPAPTR_S);
    eval 'sub SUNI_REGS_TPOPAPTR_S () {2;}' unless defined(&SUNI_REGS_TPOPAPTR_S);
    eval 'sub SUNI_REGM_TPOPAPTR () {0x3;}' unless defined(&SUNI_REGM_TPOPAPTR);
    eval 'sub SUNI_REGS_TPOPAPTR () {0;}' unless defined(&SUNI_REGS_TPOPAPTR);
    eval 'sub SUNI_REGX_TPOPAPTR () {"\\020\\12\\x0C\\12S\\12\\xF0\\12NDF";}' unless defined(&SUNI_REGX_TPOPAPTR);
    eval 'sub SUNI_REGM_SONET () {0;}' unless defined(&SUNI_REGM_SONET);
    eval 'sub SUNI_REGM_SDH () {2;}' unless defined(&SUNI_REGM_SDH);
    eval 'sub SUNI_REGN_TPOPPT () {"TPOP Path Trace";}' unless defined(&SUNI_REGN_TPOPPT);
    eval 'sub SUNI_REGO_TPOPPT () {0x47;}' unless defined(&SUNI_REGO_TPOPPT);
    eval 'sub SUNI_REGN_TPOPPSL () {"TPOP Path Signal Label";}' unless defined(&SUNI_REGN_TPOPPSL);
    eval 'sub SUNI_REGO_TPOPPSL () {0x48;}' unless defined(&SUNI_REGO_TPOPPSL);
    eval 'sub SUNI_REGN_TPOPSTATUS () {"TPOP Path Status";}' unless defined(&SUNI_REGN_TPOPSTATUS);
    eval 'sub SUNI_REGO_TPOPSTATUS () {0x49;}' unless defined(&SUNI_REGO_TPOPSTATUS);
    eval 'sub SUNI_REGM_TPOPSTATUS_FEBE () {0xf0;}' unless defined(&SUNI_REGM_TPOPSTATUS_FEBE);
    eval 'sub SUNI_REGS_TPOPSTATUS_FEBE () {4;}' unless defined(&SUNI_REGS_TPOPSTATUS_FEBE);
    eval 'sub SUNI_REGM_TPOPSTATUS_PRDI () {0x8;}' unless defined(&SUNI_REGM_TPOPSTATUS_PRDI);
    eval 'sub SUNI_REGM_TPOPSTATUS_G1 () {0x7;}' unless defined(&SUNI_REGM_TPOPSTATUS_G1);
    eval 'sub SUNI_REGS_TPOPSTATUS_G1 () {0;}' unless defined(&SUNI_REGS_TPOPSTATUS_G1);
    eval 'sub SUNI_REGX_TPOPSTATUS () {"\\020\\12\\xF0\\12FEBE\\4PRDI\\12\\x7\\12G";}' unless defined(&SUNI_REGX_TPOPSTATUS);
    eval 'sub SUNI_REGN_TPOPPUC () {"TPOP Path User Channel";}' unless defined(&SUNI_REGN_TPOPPUC);
    eval 'sub SUNI_REGO_TPOPPUC () {0x4a;}' unless defined(&SUNI_REGO_TPOPPUC);
    eval 'sub SUNI_REGN_TPOPPG1 () {"TPOP Path Grow #1";}' unless defined(&SUNI_REGN_TPOPPG1);
    eval 'sub SUNI_REGO_TPOPPG1 () {0x4b;}' unless defined(&SUNI_REGO_TPOPPG1);
    eval 'sub SUNI_REGN_TPOPPG2 () {"TPOP Path Grow #2";}' unless defined(&SUNI_REGN_TPOPPG2);
    eval 'sub SUNI_REGO_TPOPPG2 () {0x4c;}' unless defined(&SUNI_REGO_TPOPPG2);
    eval 'sub SUNI_REGN_TPOPPG3 () {"TPOP Path Grow #3";}' unless defined(&SUNI_REGN_TPOPPG3);
    eval 'sub SUNI_REGO_TPOPPG3 () {0x4d;}' unless defined(&SUNI_REGO_TPOPPG3);
    eval 'sub SUNI_REGN_RACPCTRL () {"RACP Control/Status";}' unless defined(&SUNI_REGN_RACPCTRL);
    eval 'sub SUNI_REGO_RACPCTRL () {0x50;}' unless defined(&SUNI_REGO_RACPCTRL);
    eval 'sub SUNI_REGM_RACPCTRL_OOCDV () {0x80;}' unless defined(&SUNI_REGM_RACPCTRL_OOCDV);
    eval 'sub SUNI_REGM_RACPCTRL_FSEN () {0x80;}' unless defined(&SUNI_REGM_RACPCTRL_FSEN);
    eval 'sub SUNI_REGM_RACPCTRL_RXPTYP () {0x40;}' unless defined(&SUNI_REGM_RACPCTRL_RXPTYP);
    eval 'sub SUNI_REGM_RACPCTRL_PASS () {0x20;}' unless defined(&SUNI_REGM_RACPCTRL_PASS);
    eval 'sub SUNI_REGM_RACPCTRL_DISCOR () {0x10;}' unless defined(&SUNI_REGM_RACPCTRL_DISCOR);
    eval 'sub SUNI_REGM_RACPCTRL_HCSPASS () {0x8;}' unless defined(&SUNI_REGM_RACPCTRL_HCSPASS);
    eval 'sub SUNI_REGM_RACPCTRL_HCSADD () {0x4;}' unless defined(&SUNI_REGM_RACPCTRL_HCSADD);
    eval 'sub SUNI_REGM_RACPCTRL_DDSCR () {0x2;}' unless defined(&SUNI_REGM_RACPCTRL_DDSCR);
    eval 'sub SUNI_REGM_RACPCTRL_FIFORST () {0x1;}' unless defined(&SUNI_REGM_RACPCTRL_FIFORST);
    eval 'sub SUNI_REGX_RACPCTRL () {"\\020\\10OOCDV\\7RXPTYP\\6PASS\\5DISCO\\4HCSPASS\\3HCSADD\\2DDSCR\\1FIFORST";}' unless defined(&SUNI_REGX_RACPCTRL);
    eval 'sub SUNI_REGX_RACPCTRL_622 () {"\\020\\10FSEN\\7RXPTYP\\6PASS\\5DISCO\\4HCSPASS\\3HCSADD\\2DDSCR\\1FIFORST";}' unless defined(&SUNI_REGX_RACPCTRL_622);
    eval 'sub SUNI_REGN_RACPINTR () {"RACP Interrupt Enable/Status";}' unless defined(&SUNI_REGN_RACPINTR);
    eval 'sub SUNI_REGO_RACPINTR () {0x51;}' unless defined(&SUNI_REGO_RACPINTR);
    eval 'sub SUNI_REGM_RACPINTR_OOCDE () {0x80;}' unless defined(&SUNI_REGM_RACPINTR_OOCDE);
    eval 'sub SUNI_REGM_RACPINTR_HCSE () {0x40;}' unless defined(&SUNI_REGM_RACPINTR_HCSE);
    eval 'sub SUNI_REGM_RACPINTR_FIFOE () {0x20;}' unless defined(&SUNI_REGM_RACPINTR_FIFOE);
    eval 'sub SUNI_REGM_RACPINTR_OOCDI () {0x10;}' unless defined(&SUNI_REGM_RACPINTR_OOCDI);
    eval 'sub SUNI_REGM_RACPINTR_CHCSI () {0x8;}' unless defined(&SUNI_REGM_RACPINTR_CHCSI);
    eval 'sub SUNI_REGM_RACPINTR_UHCSI () {0x4;}' unless defined(&SUNI_REGM_RACPINTR_UHCSI);
    eval 'sub SUNI_REGM_RACPINTR_FOVRI () {0x2;}' unless defined(&SUNI_REGM_RACPINTR_FOVRI);
    eval 'sub SUNI_REGX_RACPINTR () {"\\020\\10OOCDE\\7HCSE\\6FIFOE\\5OOCDI\\4CHCSI\\3UHCSI\\2FOVRI";}' unless defined(&SUNI_REGX_RACPINTR);
    eval 'sub SUNI_REGN_RACPIS () {"RACP Interrupt Status";}' unless defined(&SUNI_REGN_RACPIS);
    eval 'sub SUNI_REGO_RACPIS () {0x51;}' unless defined(&SUNI_REGO_RACPIS);
    eval 'sub SUNI_REGM_RACPIS_OCDV () {0x80;}' unless defined(&SUNI_REGM_RACPIS_OCDV);
    eval 'sub SUNI_REGM_RACPIS_LCDV () {0x40;}' unless defined(&SUNI_REGM_RACPIS_LCDV);
    eval 'sub SUNI_REGM_RACPIS_OCDI () {0x20;}' unless defined(&SUNI_REGM_RACPIS_OCDI);
    eval 'sub SUNI_REGM_RACPIS_LCDI () {0x10;}' unless defined(&SUNI_REGM_RACPIS_LCDI);
    eval 'sub SUNI_REGM_RACPIS_CHCSI () {0x8;}' unless defined(&SUNI_REGM_RACPIS_CHCSI);
    eval 'sub SUNI_REGM_RACPIS_UHCSI () {0x4;}' unless defined(&SUNI_REGM_RACPIS_UHCSI);
    eval 'sub SUNI_REGM_RACPIS_FOVRI () {0x2;}' unless defined(&SUNI_REGM_RACPIS_FOVRI);
    eval 'sub SUNI_REGM_RACPIS_FUDRI () {0x1;}' unless defined(&SUNI_REGM_RACPIS_FUDRI);
    eval 'sub SUNI_REGX_RACPIS () {"\\020\\10OCDV\\7LCDV\\6OCDI\\5LCDI\\4CHCSI\\3UHCSI\\2FOVRI\\1FUDRI";}' unless defined(&SUNI_REGX_RACPIS);
    eval 'sub SUNI_REGN_RACPPATTERN () {"RACP Match Header Pattern";}' unless defined(&SUNI_REGN_RACPPATTERN);
    eval 'sub SUNI_REGO_RACPPATTERN () {0x52;}' unless defined(&SUNI_REGO_RACPPATTERN);
    eval 'sub SUNI_REGM_RACPPATTERN_GFC () {0xf0;}' unless defined(&SUNI_REGM_RACPPATTERN_GFC);
    eval 'sub SUNI_REGS_RACPPATTERN_GFC () {4;}' unless defined(&SUNI_REGS_RACPPATTERN_GFC);
    eval 'sub SUNI_REGM_RACPPATTERN_PTI () {0xe;}' unless defined(&SUNI_REGM_RACPPATTERN_PTI);
    eval 'sub SUNI_REGS_RACPPATTERN_PTI () {1;}' unless defined(&SUNI_REGS_RACPPATTERN_PTI);
    eval 'sub SUNI_REGM_RACPPATTERN_CLP () {0x1;}' unless defined(&SUNI_REGM_RACPPATTERN_CLP);
    eval 'sub SUNI_REGS_RACPPATTERN_CLP () {0;}' unless defined(&SUNI_REGS_RACPPATTERN_CLP);
    eval 'sub SUNI_REGX_RACPPATTERN () {"\\020\\12\\xF0\\12GFC\\12\\x0E\\12PTI\\1CLP";}' unless defined(&SUNI_REGX_RACPPATTERN);
    eval 'sub SUNI_REGN_RACPIEC () {"RACP Interrupt Enable/Control";}' unless defined(&SUNI_REGN_RACPIEC);
    eval 'sub SUNI_REGO_RACPIEC () {0x52;}' unless defined(&SUNI_REGO_RACPIEC);
    eval 'sub SUNI_REGM_RACPIEC_OCDE () {0x80;}' unless defined(&SUNI_REGM_RACPIEC_OCDE);
    eval 'sub SUNI_REGM_RACPIEC_LCDE () {0x40;}' unless defined(&SUNI_REGM_RACPIEC_LCDE);
    eval 'sub SUNI_REGM_RACPIEC_HCSE () {0x20;}' unless defined(&SUNI_REGM_RACPIEC_HCSE);
    eval 'sub SUNI_REGM_RACPIEC_FIFOE () {0x10;}' unless defined(&SUNI_REGM_RACPIEC_FIFOE);
    eval 'sub SUNI_REGM_RACPIEC_LCDDROP () {0x8;}' unless defined(&SUNI_REGM_RACPIEC_LCDDROP);
    eval 'sub SUNI_REGM_RACPIEC_RCALEVEL0 () {0x4;}' unless defined(&SUNI_REGM_RACPIEC_RCALEVEL0);
    eval 'sub SUNI_REGM_RACPIEC_HCSFTR () {0x3;}' unless defined(&SUNI_REGM_RACPIEC_HCSFTR);
    eval 'sub SUNI_REGX_RACPIEC () {"\\020\\10OCDE\\7LCDE\\6HCSE\\5FIFOE\\4LCDDROP\\3RCALEVEL0\\12\\0x3\\12HCSFTR";}' unless defined(&SUNI_REGX_RACPIEC);
    eval 'sub SUNI_REGN_RACPMASK () {"RACP Match Header Mask";}' unless defined(&SUNI_REGN_RACPMASK);
    eval 'sub SUNI_REGO_RACPMASK () {0x53;}' unless defined(&SUNI_REGO_RACPMASK);
    eval 'sub SUNI_REGM_RACPMASK_MGFC () {0xf0;}' unless defined(&SUNI_REGM_RACPMASK_MGFC);
    eval 'sub SUNI_REGS_RACPMASK_MGFC () {4;}' unless defined(&SUNI_REGS_RACPMASK_MGFC);
    eval 'sub SUNI_REGM_RACPMASK_MPTI () {0xe;}' unless defined(&SUNI_REGM_RACPMASK_MPTI);
    eval 'sub SUNI_REGS_RACPMASK_MPTI () {1;}' unless defined(&SUNI_REGS_RACPMASK_MPTI);
    eval 'sub SUNI_REGM_RACPMASK_MCLP () {0x1;}' unless defined(&SUNI_REGM_RACPMASK_MCLP);
    eval 'sub SUNI_REGS_RACPMASK_MCLP () {0;}' unless defined(&SUNI_REGS_RACPMASK_MCLP);
    eval 'sub SUNI_REGX_RACPMASK () {"\\020\\12\\xF0\\12MGFC\\12\\x0E\\12MPTI\\1MCLP";}' unless defined(&SUNI_REGX_RACPMASK);
    eval 'sub SUNI_REGO_RACPPATTERN_622 () {0x53;}' unless defined(&SUNI_REGO_RACPPATTERN_622);
    eval 'sub SUNI_REGN_RACPCHCS () {"RACP Correctable HCS Error Count";}' unless defined(&SUNI_REGN_RACPCHCS);
    eval 'sub SUNI_REGO_RACPCHCS () {0x54;}' unless defined(&SUNI_REGO_RACPCHCS);
    eval 'sub SUNI_REGO_RACPMASK_622 () {0x54;}' unless defined(&SUNI_REGO_RACPMASK_622);
    eval 'sub SUNI_REGN_RACPUHCS () {"RACP Uncorrectable HCS Error Count";}' unless defined(&SUNI_REGN_RACPUHCS);
    eval 'sub SUNI_REGO_RACPUHCS () {0x55;}' unless defined(&SUNI_REGO_RACPUHCS);
    eval 'sub SUNI_REGO_RACPCHCS_622 () {0x55;}' unless defined(&SUNI_REGO_RACPCHCS_622);
    eval 'sub SUNI_REGM_RACPCHCS_622 () {0xf;}' unless defined(&SUNI_REGM_RACPCHCS_622);
    eval 'sub SUNI_REGN_RACPCNT () {"RACP Receive Cell Counter";}' unless defined(&SUNI_REGN_RACPCNT);
    eval 'sub SUNI_REGO_RACPCNT () {0x56;}' unless defined(&SUNI_REGO_RACPCNT);
    eval 'sub SUNI_REGM_RACPCNT () {0x7;}' unless defined(&SUNI_REGM_RACPCNT);
    eval 'sub SUNI_REGO_RACPUHCS_622 () {0x57;}' unless defined(&SUNI_REGO_RACPUHCS_622);
    eval 'sub SUNI_REGM_RACPUHCS_622 () {0xf;}' unless defined(&SUNI_REGM_RACPUHCS_622);
    eval 'sub SUNI_REGO_RACPCNT_622 () {0x59;}' unless defined(&SUNI_REGO_RACPCNT_622);
    eval 'sub SUNI_REGM_RACPCNT_622 () {0x1f;}' unless defined(&SUNI_REGM_RACPCNT_622);
    eval 'sub SUNI_REGN_RACPCFG () {"RACP Configuration";}' unless defined(&SUNI_REGN_RACPCFG);
    eval 'sub SUNI_REGO_RACPCFG () {0x59;}' unless defined(&SUNI_REGO_RACPCFG);
    eval 'sub SUNI_REGM_RACPCFG_RGFCE () {0xf0;}' unless defined(&SUNI_REGM_RACPCFG_RGFCE);
    eval 'sub SUNI_REGS_RACPCFG_RGFCE () {4;}' unless defined(&SUNI_REGS_RACPCFG_RGFCE);
    eval 'sub SUNI_REGM_RACPCFG_FSEN () {0x8;}' unless defined(&SUNI_REGM_RACPCFG_FSEN);
    eval 'sub SUNI_REGM_RACPCFG_LEVEL0 () {0x4;}' unless defined(&SUNI_REGM_RACPCFG_LEVEL0);
    eval 'sub SUNI_REGM_RACPCFG_HCSFTR () {0x3;}' unless defined(&SUNI_REGM_RACPCFG_HCSFTR);
    eval 'sub SUNI_REGS_RACPCFG_HCSFTR () {0;}' unless defined(&SUNI_REGS_RACPCFG_HCSFTR);
    eval 'sub SUNI_REGX_RACPCFG () {"\\020\\12\\xF0\\20RGFCE\\4FSEN\\3RCALEVEL0\\12\\x03\\12HCSFTR";}' unless defined(&SUNI_REGX_RACPCFG);
    eval 'sub SUNI_REGN_RACPGFC () {"RACP GFC Control/Misc. Control";}' unless defined(&SUNI_REGN_RACPGFC);
    eval 'sub SUNI_REGO_RACPGFC () {0x5c;}' unless defined(&SUNI_REGO_RACPGFC);
    eval 'sub SUNI_REGM_RACPGFC_CDDIS () {0x80;}' unless defined(&SUNI_REGM_RACPGFC_CDDIS);
    eval 'sub SUNI_REGM_RACPGFC_RXBYTEPRTY () {0x40;}' unless defined(&SUNI_REGM_RACPGFC_RXBYTEPRTY);
    eval 'sub SUNI_REGM_RACPGFC_RGFCE () {0xf;}' unless defined(&SUNI_REGM_RACPGFC_RGFCE);
    eval 'sub SUNI_REGX_RACPGFC () {"\\020\\10CDDIS\\7RXBYTEPRTY\\12\\xf\\20";}' unless defined(&SUNI_REGX_RACPGFC);
    eval 'sub SUNI_REGN_TACPCTRL () {"TACP Control/Status";}' unless defined(&SUNI_REGN_TACPCTRL);
    eval 'sub SUNI_REGO_TACPCTRL () {0x60;}' unless defined(&SUNI_REGO_TACPCTRL);
    eval 'sub SUNI_REGM_TACPCTRL_FIFOE () {0x80;}' unless defined(&SUNI_REGM_TACPCTRL_FIFOE);
    eval 'sub SUNI_REGM_TACPCTRL_TSOCI () {0x40;}' unless defined(&SUNI_REGM_TACPCTRL_TSOCI);
    eval 'sub SUNI_REGM_TACPCTRL_FOVRI () {0x20;}' unless defined(&SUNI_REGM_TACPCTRL_FOVRI);
    eval 'sub SUNI_REGM_TACPCTRL_DHCS () {0x10;}' unless defined(&SUNI_REGM_TACPCTRL_DHCS);
    eval 'sub SUNI_REGM_TACPCTRL_HCSB () {0x8;}' unless defined(&SUNI_REGM_TACPCTRL_HCSB);
    eval 'sub SUNI_REGM_TACPCTRL_HCSADD () {0x4;}' unless defined(&SUNI_REGM_TACPCTRL_HCSADD);
    eval 'sub SUNI_REGM_TACPCTRL_DSCR () {0x2;}' unless defined(&SUNI_REGM_TACPCTRL_DSCR);
    eval 'sub SUNI_REGM_TACPCTRL_FIFORST () {0x1;}' unless defined(&SUNI_REGM_TACPCTRL_FIFORST);
    eval 'sub SUNI_REGX_TACPCTRL_LITE () {"\\020\\10FIFOE\\7TSOCI\\6FOVRI\\5DHCS\\3HCSADD\\2DSCR\\1FIFORST";}' unless defined(&SUNI_REGX_TACPCTRL_LITE);
    eval 'sub SUNI_REGX_TACPCTRL_ULTRA () {"\\020\\10FIFOE\\7TSOCI\\6FOVRI\\5DHCS\\4HCSB\\3HCSADD\\2DSCR\\1FIFORST";}' unless defined(&SUNI_REGX_TACPCTRL_ULTRA);
    eval 'sub SUNI_REGX_TACPCTRL_622 () {"\\020\\10FIFOE\\7TSOCI\\6FOVRI\\5DHCS\\4HCSB\\3HCSADD\\2DSCR\\1FIFORST";}' unless defined(&SUNI_REGX_TACPCTRL_622);
    eval 'sub SUNI_REGN_TACPIDLEH () {"TACP Idle/Unassigned Cell Header Pattern";}' unless defined(&SUNI_REGN_TACPIDLEH);
    eval 'sub SUNI_REGO_TACPIDLEH () {0x61;}' unless defined(&SUNI_REGO_TACPIDLEH);
    eval 'sub SUNI_REGM_TACPIDLEH_GFC () {0xf0;}' unless defined(&SUNI_REGM_TACPIDLEH_GFC);
    eval 'sub SUNI_REGS_TACPIDLEH_GFC () {4;}' unless defined(&SUNI_REGS_TACPIDLEH_GFC);
    eval 'sub SUNI_REGM_TACPIDLEH_PTI () {0xe;}' unless defined(&SUNI_REGM_TACPIDLEH_PTI);
    eval 'sub SUNI_REGS_TACPIDLEH_PTI () {1;}' unless defined(&SUNI_REGS_TACPIDLEH_PTI);
    eval 'sub SUNI_REGM_TACPIDLEH_CLP () {0x1;}' unless defined(&SUNI_REGM_TACPIDLEH_CLP);
    eval 'sub SUNI_REGS_TACPIDLEH_CLP () {0;}' unless defined(&SUNI_REGS_TACPIDLEH_CLP);
    eval 'sub SUNI_REGX_TACPIDLEH () {"\\020\\12\\xF0\\20GFC\\12\\x0E\\20PTI\\12\\x01\\20CLP";}' unless defined(&SUNI_REGX_TACPIDLEH);
    eval 'sub SUNI_REGN_TACPIDLEP () {"TACP Idle/Unassigned Cell Payload Octet Pattern";}' unless defined(&SUNI_REGN_TACPIDLEP);
    eval 'sub SUNI_REGO_TACPIDLEP () {0x62;}' unless defined(&SUNI_REGO_TACPIDLEP);
    eval 'sub SUNI_REGN_TACPFIFOC () {"TACP FIFO Control";}' unless defined(&SUNI_REGN_TACPFIFOC);
    eval 'sub SUNI_REGO_TACPFIFOC () {0x63;}' unless defined(&SUNI_REGO_TACPFIFOC);
    eval 'sub SUNI_REGM_TACPFIFOC_TXPTYP () {0x80;}' unless defined(&SUNI_REGM_TACPFIFOC_TXPTYP);
    eval 'sub SUNI_REGM_TACPFIFOC_TXPRTYE () {0x40;}' unless defined(&SUNI_REGM_TACPFIFOC_TXPRTYE);
    eval 'sub SUNI_REGM_TACPFIFOC_TXPRTYI () {0x10;}' unless defined(&SUNI_REGM_TACPFIFOC_TXPRTYI);
    eval 'sub SUNI_REGM_TACPFIFOC_TXPRTYI_622 () {0x30;}' unless defined(&SUNI_REGM_TACPFIFOC_TXPRTYI_622);
    eval 'sub SUNI_REGS_TACPFIFOC_TXPRTYI_622 () {4;}' unless defined(&SUNI_REGS_TACPFIFOC_TXPRTYI_622);
    eval 'sub SUNI_REGM_TACPFIFOC_FIFODP () {0xc;}' unless defined(&SUNI_REGM_TACPFIFOC_FIFODP);
    eval 'sub SUNI_REGS_TACPFIFOC_FIFODP () {2;}' unless defined(&SUNI_REGS_TACPFIFOC_FIFODP);
    eval 'sub SUNI_REGM_TACPFIFOC_TCALEVEL0 () {0x2;}' unless defined(&SUNI_REGM_TACPFIFOC_TCALEVEL0);
    eval 'sub SUNI_REGM_TACPFIFOC_HCSCTLEB () {0x1;}' unless defined(&SUNI_REGM_TACPFIFOC_HCSCTLEB);
    eval 'sub SUNI_REGM_TACPFIFOC_RESERVED () {0x;}' unless defined(&SUNI_REGM_TACPFIFOC_RESERVED);
    eval 'sub SUNI_REGX_TACPFIFOC () {"\\020\\10TXPTYP\\7TXPRTYE\\5TXPRTYI\\12\\x0C\\20FIFODP\\2TCALEVEL0";}' unless defined(&SUNI_REGX_TACPFIFOC);
    eval 'sub SUNI_REGX_TACPFIFOC_622 () {"\\020\\10TXPTYP\\7TXPRTYE\\12\\x30\\12TXPRTYI\\12\\x0C\\20FIFODP\\2TCALEVEL0\\1HCSCTLEB";}' unless defined(&SUNI_REGX_TACPFIFOC_622);
    eval 'sub SUNI_REGN_TACPCNT () {"TACP Transmit Cell Counter";}' unless defined(&SUNI_REGN_TACPCNT);
    eval 'sub SUNI_REGO_TACPCNT () {0x64;}' unless defined(&SUNI_REGO_TACPCNT);
    eval 'sub SUNI_REGM_TACPCNT () {0x7;}' unless defined(&SUNI_REGM_TACPCNT);
    eval 'sub SUNI_REGM_TACPCNT_622 () {0x1f;}' unless defined(&SUNI_REGM_TACPCNT_622);
    eval 'sub SUNI_REGN_TACPCFG () {"TACP Configuration";}' unless defined(&SUNI_REGN_TACPCFG);
    eval 'sub SUNI_REGO_TACPCFG () {0x67;}' unless defined(&SUNI_REGO_TACPCFG);
    eval 'sub SUNI_REGM_TACPCFG_TGFCE () {0xf0;}' unless defined(&SUNI_REGM_TACPCFG_TGFCE);
    eval 'sub SUNI_REGS_TACPCFG_TGFCE () {4;}' unless defined(&SUNI_REGS_TACPCFG_TGFCE);
    eval 'sub SUNI_REGM_TACPCFG_FSEN () {0x8;}' unless defined(&SUNI_REGM_TACPCFG_FSEN);
    eval 'sub SUNI_REGM_TACPCFG_H4INSB () {0x4;}' unless defined(&SUNI_REGM_TACPCFG_H4INSB);
    eval 'sub SUNI_REGM_TACPCFG_FIXBYTE () {0x3;}' unless defined(&SUNI_REGM_TACPCFG_FIXBYTE);
    eval 'sub SUNI_REGS_TACPCFG_FIXBYTE () {0;}' unless defined(&SUNI_REGS_TACPCFG_FIXBYTE);
    eval 'sub SUNI_REGX_TACPCFG () {"\\020\\12\\xF0\\20TGFCE\\4FSEN\\3H4INSB\\12\\x03\\20FIXBYTE";}' unless defined(&SUNI_REGX_TACPCFG);
    eval 'sub SUNI_REGN_TACPGFC () {"TACP Fixed Stuff/GFC";}' unless defined(&SUNI_REGN_TACPGFC);
    eval 'sub SUNI_REGO_TACPGFC () {0x67;}' unless defined(&SUNI_REGO_TACPGFC);
    eval 'sub SUNI_REGO_TACPGFC_TGFCE () {0xf0;}' unless defined(&SUNI_REGO_TACPGFC_TGFCE);
    eval 'sub SUNI_REGS_TACPGFC_TGFCE () {4;}' unless defined(&SUNI_REGS_TACPGFC_TGFCE);
    eval 'sub SUNI_REGO_TACPGFC_FSEN () {0x8;}' unless defined(&SUNI_REGO_TACPGFC_FSEN);
    eval 'sub SUNI_REGO_TACPGFC_TXBYTEPRTY () {0x4;}' unless defined(&SUNI_REGO_TACPGFC_TXBYTEPRTY);
    eval 'sub SUNI_REGO_TACPGFC_FIXBYTE () {0x3;}' unless defined(&SUNI_REGO_TACPGFC_FIXBYTE);
    eval 'sub SUNI_REGS_TACPGFC_FIXBYTE () {0;}' unless defined(&SUNI_REGS_TACPGFC_FIXBYTE);
    eval 'sub SUNI_REGX_TACPGFC () {"\\020\\12\\xf0\\20TGFCE\\4FSEN\\3TXBYTEPRTY\\12\\x3\\20FIXBYTE";}' unless defined(&SUNI_REGX_TACPGFC);
    eval 'sub SUNI_REGN_SPTBCTRL () {"SPTB Control";}' unless defined(&SUNI_REGN_SPTBCTRL);
    eval 'sub SUNI_REGO_SPTBCTRL () {0x68;}' unless defined(&SUNI_REGO_SPTBCTRL);
    eval 'sub SUNI_REGO_SPTBCTRL_RRAMACC () {0x40;}' unless defined(&SUNI_REGO_SPTBCTRL_RRAMACC);
    eval 'sub SUNI_REGO_SPTBCTRL_RTIUIE () {0x20;}' unless defined(&SUNI_REGO_SPTBCTRL_RTIUIE);
    eval 'sub SUNI_REGO_SPTBCTRL_RTIMIE () {0x10;}' unless defined(&SUNI_REGO_SPTBCTRL_RTIMIE);
    eval 'sub SUNI_REGO_SPTBCTRL_PER5 () {0x8;}' unless defined(&SUNI_REGO_SPTBCTRL_PER5);
    eval 'sub SUNI_REGO_SPTBCTRL_TNULL () {0x4;}' unless defined(&SUNI_REGO_SPTBCTRL_TNULL);
    eval 'sub SUNI_REGO_SPTBCTRL_NOSYNC () {0x2;}' unless defined(&SUNI_REGO_SPTBCTRL_NOSYNC);
    eval 'sub SUNI_REGO_SPTBCTRL_LEN16 () {0x1;}' unless defined(&SUNI_REGO_SPTBCTRL_LEN16);
    eval 'sub SUNI_REGX_SPTBCTRL () {"\\020\\7RRAMACC\\6RTIUIE\\5RTIMIE\\4PER5\\3TNULL\\2NOSYNC\\1LEN16";}' unless defined(&SUNI_REGX_SPTBCTRL);
    eval 'sub SUNI_REGN_SPTBPTIS () {"SPTB Path Trace Identifier Status";}' unless defined(&SUNI_REGN_SPTBPTIS);
    eval 'sub SUNI_REGO_SPTBPTIS () {0x69;}' unless defined(&SUNI_REGO_SPTBPTIS);
    eval 'sub SUNI_REGM_SPTBPTIS_BUSY () {0x80;}' unless defined(&SUNI_REGM_SPTBPTIS_BUSY);
    eval 'sub SUNI_REGM_SPTBPTIS_RTIUI () {0x8;}' unless defined(&SUNI_REGM_SPTBPTIS_RTIUI);
    eval 'sub SUNI_REGM_SPTBPTIS_RTIUV () {0x4;}' unless defined(&SUNI_REGM_SPTBPTIS_RTIUV);
    eval 'sub SUNI_REGM_SPTBPTIS_RTIMI () {0x2;}' unless defined(&SUNI_REGM_SPTBPTIS_RTIMI);
    eval 'sub SUNI_REGM_SPTBPTIS_RTIMV () {0x1;}' unless defined(&SUNI_REGM_SPTBPTIS_RTIMV);
    eval 'sub SUNI_REGX_SPTBPTIS () {"\\020\\10BUSY\\4RTIUI\\3RTIUV\\2RTIMI\\1RTIMV";}' unless defined(&SUNI_REGX_SPTBPTIS);
    eval 'sub SUNI_REGN_SPTBIAR () {"SPTB Indirect Address Register";}' unless defined(&SUNI_REGN_SPTBIAR);
    eval 'sub SUNI_REGO_SPTBIAR () {0x6a;}' unless defined(&SUNI_REGO_SPTBIAR);
    eval 'sub SUNI_REGM_SPTBIAR_RWB () {0x80;}' unless defined(&SUNI_REGM_SPTBIAR_RWB);
    eval 'sub SUNI_REGM_SPTBIAR_A () {0x7f;}' unless defined(&SUNI_REGM_SPTBIAR_A);
    eval 'sub SUNI_REGX_SPTBIAR () {"\\020\\10RWB\\12\\x7f\\20A";}' unless defined(&SUNI_REGX_SPTBIAR);
    eval 'sub SUNI_REGN_SPTBIDR () {"SPTB Indirect Data Register";}' unless defined(&SUNI_REGN_SPTBIDR);
    eval 'sub SUNI_REGO_SPTBIDR () {0x6b;}' unless defined(&SUNI_REGO_SPTBIDR);
    eval 'sub SUNI_REGN_SPTBEPSL () {"SPTB Expected Path Signal Label";}' unless defined(&SUNI_REGN_SPTBEPSL);
    eval 'sub SUNI_REGO_SPTBEPSL () {0x6c;}' unless defined(&SUNI_REGO_SPTBEPSL);
    eval 'sub SUNI_REGN_SPTBPSLS () {"SPTB Path Signal Label Status";}' unless defined(&SUNI_REGN_SPTBPSLS);
    eval 'sub SUNI_REGO_SPTBPSLS () {0x6d;}' unless defined(&SUNI_REGO_SPTBPSLS);
    eval 'sub SUNI_REGM_SPTBPSLS_RPSLUIE () {0x80;}' unless defined(&SUNI_REGM_SPTBPSLS_RPSLUIE);
    eval 'sub SUNI_REGM_SPTBPSLS_RPSLMIE () {0x40;}' unless defined(&SUNI_REGM_SPTBPSLS_RPSLMIE);
    eval 'sub SUNI_REGM_SPTBPSLS_RPSLUI () {0x8;}' unless defined(&SUNI_REGM_SPTBPSLS_RPSLUI);
    eval 'sub SUNI_REGM_SPTBPSLS_RPSLUV () {0x4;}' unless defined(&SUNI_REGM_SPTBPSLS_RPSLUV);
    eval 'sub SUNI_REGM_SPTBPSLS_RPSLMI () {0x2;}' unless defined(&SUNI_REGM_SPTBPSLS_RPSLMI);
    eval 'sub SUNI_REGM_SPTBPSLS_RPSLMV () {0x1;}' unless defined(&SUNI_REGM_SPTBPSLS_RPSLMV);
    eval 'sub SUNI_REGX_SPTBPSLS () {"\\020\\10RPSLUIE\\7RPSLMIE\\4RPSLUI\\3RPSLUV\\2RPSLMI\\1RPSLMV";}' unless defined(&SUNI_REGX_SPTBPSLS);
    eval 'sub SUNI_REGN_POPCCTRL () {"POPC Control";}' unless defined(&SUNI_REGN_POPCCTRL);
    eval 'sub SUNI_REGO_POPCCTRL () {0x68;}' unless defined(&SUNI_REGO_POPCCTRL);
    eval 'sub SUNI_REGM_POPCCTRL_PDAT () {0xc0;}' unless defined(&SUNI_REGM_POPCCTRL_PDAT);
    eval 'sub SUNI_REGS_POPCCTRL_PDAT () {6;}' unless defined(&SUNI_REGS_POPCCTRL_PDAT);
    eval 'sub SUNI_REGM_POPCCTRL_TOGGLE () {0x30;}' unless defined(&SUNI_REGM_POPCCTRL_TOGGLE);
    eval 'sub SUNI_REGS_POPCCTRL_TOGGLE () {4;}' unless defined(&SUNI_REGS_POPCCTRL_TOGGLE);
    eval 'sub SUNI_REGM_POPCCTRL_TRAFFIC () {0x2;}' unless defined(&SUNI_REGM_POPCCTRL_TRAFFIC);
    eval 'sub SUNI_REGM_POPCCTRL_ALARM () {0x1;}' unless defined(&SUNI_REGM_POPCCTRL_ALARM);
    eval 'sub SUNI_REGX_POPCCTRL () {"\\020\\12\\xC0\\20PDAT\\12\\x30\\20TOGGLE\\2TRAFFIC\\1ALARM";}' unless defined(&SUNI_REGX_POPCCTRL);
    eval 'sub SUNI_REGN_POPCSTROBE0 () {"POPC Strobe Rate 0";}' unless defined(&SUNI_REGN_POPCSTROBE0);
    eval 'sub SUNI_REGO_POPCSTROBE0 () {0x69;}' unless defined(&SUNI_REGO_POPCSTROBE0);
    eval 'sub SUNI_REGN_POPCSTROBE1 () {"POPC Strobe Rate 1";}' unless defined(&SUNI_REGN_POPCSTROBE1);
    eval 'sub SUNI_REGO_POPCSTROBE1 () {0x6a;}' unless defined(&SUNI_REGO_POPCSTROBE1);
    eval 'sub SUNI_REGN_BERMCTRL () {"BERM Control";}' unless defined(&SUNI_REGN_BERMCTRL);
    eval 'sub SUNI_REGO_BERMCTRL () {0x70;}' unless defined(&SUNI_REGO_BERMCTRL);
    eval 'sub SUNI_REGM_BERMCTRL_BERTEN () {0x80;}' unless defined(&SUNI_REGM_BERMCTRL_BERTEN);
    eval 'sub SUNI_REGM_BERMCTRL_BERIE () {0x1;}' unless defined(&SUNI_REGM_BERMCTRL_BERIE);
    eval 'sub SUNI_REGX_BERMCTRL () {"\\020\\10BERTEN\\1BERIE";}' unless defined(&SUNI_REGX_BERMCTRL);
    eval 'sub SUNI_REGN_BERMINT () {"BERM Interrupt";}' unless defined(&SUNI_REGN_BERMINT);
    eval 'sub SUNI_REGO_BERMINT () {0x71;}' unless defined(&SUNI_REGO_BERMINT);
    eval 'sub SUNI_REGM_BERMINT_TST () {0xf0;}' unless defined(&SUNI_REGM_BERMINT_TST);
    eval 'sub SUNI_REGS_BERMINT_TST () {4;}' unless defined(&SUNI_REGS_BERMINT_TST);
    eval 'sub SUNI_REGM_BERMINT_BERI () {0x1;}' unless defined(&SUNI_REGM_BERMINT_BERI);
    eval 'sub SUNI_REGX_BERMINT () {"\\020\\12\\xf0\\20BERM_TST\\1BERI";}' unless defined(&SUNI_REGX_BERMINT);
    eval 'sub SUNI_REGN_BERMLAP () {"BERM Line BIP Accumulation Period";}' unless defined(&SUNI_REGN_BERMLAP);
    eval 'sub SUNI_REGO_BERMLAP () {0x72;}' unless defined(&SUNI_REGO_BERMLAP);
    eval 'sub SUNI_REGN_BERMLT () {"BERM Line BIP Threshold";}' unless defined(&SUNI_REGN_BERMLT);
    eval 'sub SUNI_REGO_BERMLT () {0x74;}' unless defined(&SUNI_REGO_BERMLT);
    eval 'sub SUNI_REGN_MTEST () {"Master Test";}' unless defined(&SUNI_REGN_MTEST);
    eval 'sub SUNI_REGO_MTEST () {0x80;}' unless defined(&SUNI_REGO_MTEST);
    eval 'sub SUNI_REGM_MTEST_DS27_53_622 () {0x80;}' unless defined(&SUNI_REGM_MTEST_DS27_53_622);
    eval 'sub SUNI_REGM_MTEST_BYPASS_ULTRA () {0x40;}' unless defined(&SUNI_REGM_MTEST_BYPASS_ULTRA);
    eval 'sub SUNI_REGM_MTEST_PMCATST_ULTRA () {0x20;}' unless defined(&SUNI_REGM_MTEST_PMCATST_ULTRA);
    eval 'sub SUNI_REGM_MTEST_PMCTST () {0x10;}' unless defined(&SUNI_REGM_MTEST_PMCTST);
    eval 'sub SUNI_REGM_MTEST_DBCTRL () {0x8;}' unless defined(&SUNI_REGM_MTEST_DBCTRL);
    eval 'sub SUNI_REGM_MTEST_IOTST () {0x4;}' unless defined(&SUNI_REGM_MTEST_IOTST);
    eval 'sub SUNI_REGM_MTEST_HIZDATA () {0x2;}' unless defined(&SUNI_REGM_MTEST_HIZDATA);
    eval 'sub SUNI_REGM_MTEST_HIZIO () {0x1;}' unless defined(&SUNI_REGM_MTEST_HIZIO);
    eval 'sub SUNI_REGX_MTEST_LITE () {"\\020\\5PMCTST\\4DBCTRL\\3IOTST\\2HIZDATA\\1HIZIO";}' unless defined(&SUNI_REGX_MTEST_LITE);
    eval 'sub SUNI_REGX_MTEST_ULTRA () {"\\020\\7BYPASS\\6PMCATST\\5PMCTST\\4DBCTRL\\3IOTST\\2HIZDATA\\1HIZIO";}' unless defined(&SUNI_REGX_MTEST_ULTRA);
    eval 'sub SUNI_REGX_MTEST_622 () {"\\020\\10DS27_53\\5PMCTST\\4DBCTRL\\3IOTST\\2HIZDATA\\1HIZIO";}' unless defined(&SUNI_REGX_MTEST_622);
    eval 'sub SUNI_PRINT_LITE () {{  &UTP_REGT_BITS,  &SUNI_REGO_MRESET,  &SUNI_REGN_MRESET,  &SUNI_REGX_MRESET_LITE }, {  &UTP_REGT_BITS,  &SUNI_REGO_MCONFIG,  &SUNI_REGN_MCONFIG,  &SUNI_REGX_MCONFIG_LITE }, {  &UTP_REGT_BITS,  &SUNI_REGO_MISTATUS,  &SUNI_REGN_MISTATUS,  &SUNI_REGX_MISTATUS_LITE }, {  &UTP_REGT_BITS,  &SUNI_REGO_MCLKM,  &SUNI_REGN_MCLKM,  &SUNI_REGX_MCLKM_LITE }, {  &UTP_REGT_BITS,  &SUNI_REGO_MCTRL,  &SUNI_REGN_MCTRL,  &SUNI_REGX_MCTRL_LITE }, {  &UTP_REGT_BITS,  &SUNI_REGO_CLKSYN,  &SUNI_REGN_CLKSYN,  &SUNI_REGX_CLKSYN_LITE }, {  &UTP_REGT_BITS,  &SUNI_REGO_CLKREC_LITE,  &SUNI_REGN_CLKREC,  &SUNI_REGX_CLKREC_LITE }, {  &UTP_REGT_BITS,  &SUNI_REGO_RSOPCIE,  &SUNI_REGN_RSOPCIE,  &SUNI_REGX_RSOPCIE }, {  &UTP_REGT_BITS,  &SUNI_REGO_RSOPSIS,  &SUNI_REGN_RSOPSIS,  &SUNI_REGX_RSOPSIS }, {  &UTP_REGT_INT16,  &SUNI_REGO_RSOP_BIP8,  &SUNI_REGN_RSOP_BIP8,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TSOPCTRL,  &SUNI_REGN_TSOPCTRL,  &SUNI_REGX_TSOPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TSOPDIAG,  &SUNI_REGN_TSOPDIAG,  &SUNI_REGX_TSOPDIAG }, {  &UTP_REGT_BITS,  &SUNI_REGO_RLOPCTRL,  &SUNI_REGN_RLOPCTRL,  &SUNI_REGX_RLOPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RLOPINTR,  &SUNI_REGN_RLOPINTR,  &SUNI_REGX_RLOPINTR }, {  &UTP_REGT_INT20,  &SUNI_REGO_RLOPBIP8_24,  &SUNI_REGN_RLOPBIP8_24,  &NULL }, {  &UTP_REGT_INT20,  &SUNI_REGO_RLOPFEBE,  &SUNI_REGN_RLOPFEBE,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TLOPCTRL,  &SUNI_REGN_TLOPCTRL,  &SUNI_REGX_TLOPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TLOPDIAG,  &SUNI_REGN_TLOPDIAG,  &SUNI_REGX_TLOPDIAG }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPCTRL,  &SUNI_REGN_RPOPCTRL,  &SUNI_REGX_RPOPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPISTAT,  &SUNI_REGN_RPOPISTAT,  &SUNI_REGX_RPOPISTAT }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPIEN,  &SUNI_REGN_RPOPIEN,  &SUNI_REGX_RPOPIEN }, {  &UTP_REGT_INT8,  &SUNI_REGO_RPOPPSL,  &SUNI_REGN_RPOPPSL,  &NULL }, {  &UTP_REGT_INT16,  &SUNI_REGO_RPOPBIP8,  &SUNI_REGN_RPOPBIP8,  &NULL }, {  &UTP_REGT_INT16,  &SUNI_REGO_RPOPFEBE,  &SUNI_REGN_RPOPFEBE,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPBIP8CFG,  &SUNI_REGN_RPOPBIP8CFG,  &SUNI_REGX_RPOPBIP8CFG }, {  &UTP_REGT_BITS,  &SUNI_REGO_TPOPCTRL,  &SUNI_REGN_TPOPCTRL,  &SUNI_REGX_TPOPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TPOPPTRC,  &SUNI_REGN_TPOPPTRC,  &SUNI_REGX_TPOPPTRC }, {  &UTP_REGT_INT10BITS,  &SUNI_REGO_TPOPAPTR,  &SUNI_REGN_TPOPAPTR,  &SUNI_REGX_TPOPAPTR }, {  &UTP_REGT_INT8,  &SUNI_REGO_TPOPPSL,  &SUNI_REGN_TPOPPSL,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TPOPSTATUS,  &SUNI_REGN_TPOPSTATUS,  &SUNI_REGX_TPOPSTATUS }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPCTRL,  &SUNI_REGN_RACPCTRL,  &SUNI_REGX_RACPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPINTR,  &SUNI_REGN_RACPINTR,  &SUNI_REGX_RACPINTR }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPPATTERN,  &SUNI_REGN_RACPPATTERN,  &SUNI_REGX_RACPPATTERN }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPMASK,  &SUNI_REGN_RACPMASK,  &SUNI_REGX_RACPMASK }, {  &UTP_REGT_INT8,  &SUNI_REGO_RACPCHCS,  &SUNI_REGN_RACPCHCS,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_RACPUHCS,  &SUNI_REGN_RACPUHCS,  &NULL }, {  &UTP_REGT_INT19,  &SUNI_REGO_RACPCNT,  &SUNI_REGN_RACPCNT,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPCFG,  &SUNI_REGN_RACPCFG,  &SUNI_REGX_RACPCFG }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPCTRL,  &SUNI_REGN_TACPCTRL,  &SUNI_REGX_TACPCTRL_LITE }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPIDLEH,  &SUNI_REGN_TACPIDLEH,  &SUNI_REGX_TACPIDLEH }, {  &UTP_REGT_INT8,  &SUNI_REGO_TACPIDLEP,  &SUNI_REGN_TACPIDLEP,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPFIFOC,  &SUNI_REGN_TACPFIFOC,  &SUNI_REGX_TACPFIFOC }, {  &UTP_REGT_INT19,  &SUNI_REGO_TACPCNT,  &SUNI_REGN_TACPCNT,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPGFC,  &SUNI_REGN_TACPGFC,  &SUNI_REGX_TACPGFC }, {  &UTP_REGT_BITS,  &SUNI_REGO_MTEST,  &SUNI_REGN_MTEST,  &SUNI_REGX_MTEST_LITE };}' unless defined(&SUNI_PRINT_LITE);
    eval 'sub SUNI_PRINT_ULTRA () {{  &UTP_REGT_BITS,  &SUNI_REGO_MRESET,  &SUNI_REGN_MRESET,  &SUNI_REGX_MRESET_ULTRA }, {  &UTP_REGT_BITS,  &SUNI_REGO_MCONFIG,  &SUNI_REGN_MCONFIG,  &SUNI_REGX_MCONFIG_ULTRA }, {  &UTP_REGT_BITS,  &SUNI_REGO_MISTATUS,  &SUNI_REGN_MISTATUS,  &SUNI_REGX_MISTATUS_ULTRA }, {  &UTP_REGT_BITS,  &SUNI_REGO_MMCTRL,  &SUNI_REGN_MMCTRL,  &SUNI_REGX_MMCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_MCLKM,  &SUNI_REGN_MCLKM,  &SUNI_REGX_MCLKM_ULTRA }, {  &UTP_REGT_BITS,  &SUNI_REGO_MCTRL,  &SUNI_REGN_MCTRL,  &SUNI_REGX_MCTRL_ULTRA }, {  &UTP_REGT_BITS,  &SUNI_REGO_CLKSYN,  &SUNI_REGN_CLKSYN,  &SUNI_REGX_CLKSYN_ULTRA }, {  &UTP_REGT_BITS,  &SUNI_REGO_CLKREC_ULTRA,  &SUNI_REGN_CLKREC,  &SUNI_REGX_CLKREC_ULTRA }, {  &UTP_REGT_BITS,  &SUNI_REGO_CLKRECCFG,  &SUNI_REGN_CLKRECCFG,  &SUNI_REGX_CLKRECCFG }, {  &UTP_REGT_BITS,  &SUNI_REGO_LTXCFG1,  &SUNI_REGN_LTXCFG1,  &SUNI_REGX_LTXCFG1 }, {  &UTP_REGT_BITS,  &SUNI_REGO_LTXCFG2,  &SUNI_REGN_LTXCFG2,  &SUNI_REGX_LTXCFG2 }, {  &UTP_REGT_BITS,  &SUNI_REGO_LRXCFG,  &SUNI_REGN_LRXCFG,  &SUNI_REGX_LRXCFG }, {  &UTP_REGT_BITS,  &SUNI_REGO_RSOPCIE,  &SUNI_REGN_RSOPCIE,  &SUNI_REGX_RSOPCIE }, {  &UTP_REGT_BITS,  &SUNI_REGO_RSOPSIS,  &SUNI_REGN_RSOPSIS,  &SUNI_REGX_RSOPSIS }, {  &UTP_REGT_INT16,  &SUNI_REGO_RSOP_BIP8,  &SUNI_REGN_RSOP_BIP8,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TSOPCTRL,  &SUNI_REGN_TSOPCTRL,  &SUNI_REGX_TSOPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TSOPDIAG,  &SUNI_REGN_TSOPDIAG,  &SUNI_REGX_TSOPDIAG }, {  &UTP_REGT_BITS,  &SUNI_REGO_RLOPCTRL,  &SUNI_REGN_RLOPCTRL,  &SUNI_REGX_RLOPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RLOPINTR,  &SUNI_REGN_RLOPINTR,  &SUNI_REGX_RLOPINTR }, {  &UTP_REGT_INT20,  &SUNI_REGO_RLOPBIP8_24,  &SUNI_REGN_RLOPBIP8_24,  &NULL }, {  &UTP_REGT_INT20,  &SUNI_REGO_RLOPFEBE,  &SUNI_REGN_RLOPFEBE,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TLOPCTRL,  &SUNI_REGN_TLOPCTRL,  &SUNI_REGX_TLOPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TLOPDIAG,  &SUNI_REGN_TLOPDIAG,  &SUNI_REGX_TLOPDIAG }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPCTRL,  &SUNI_REGN_RPOPCTRL,  &SUNI_REGX_RPOPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPISTAT,  &SUNI_REGN_RPOPISTAT,  &SUNI_REGX_RPOPISTAT }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPIEN,  &SUNI_REGN_RPOPIEN,  &SUNI_REGX_RPOPIEN }, {  &UTP_REGT_INT8,  &SUNI_REGO_RPOPPSL,  &SUNI_REGN_RPOPPSL,  &NULL }, {  &UTP_REGT_INT16,  &SUNI_REGO_RPOPBIP8,  &SUNI_REGN_RPOPBIP8,  &NULL }, {  &UTP_REGT_INT16,  &SUNI_REGO_RPOPFEBE,  &SUNI_REGN_RPOPFEBE,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPBIP8CFG,  &SUNI_REGN_RPOPBIP8CFG,  &SUNI_REGX_RPOPBIP8CFG }, {  &UTP_REGT_BITS,  &SUNI_REGO_TPOPCTRL,  &SUNI_REGN_TPOPCTRL,  &SUNI_REGX_TPOPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TPOPPTRC,  &SUNI_REGN_TPOPPTRC,  &SUNI_REGX_TPOPPTRC }, {  &UTP_REGT_INT10BITS,  &SUNI_REGO_TPOPAPTR,  &SUNI_REGN_TPOPAPTR,  &SUNI_REGX_TPOPAPTR }, {  &UTP_REGT_INT8,  &SUNI_REGO_TPOPPSL,  &SUNI_REGN_TPOPPSL,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TPOPSTATUS,  &SUNI_REGN_TPOPSTATUS,  &SUNI_REGX_TPOPSTATUS }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPCTRL,  &SUNI_REGN_RACPCTRL,  &SUNI_REGX_RACPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPINTR,  &SUNI_REGN_RACPINTR,  &SUNI_REGX_RACPINTR }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPPATTERN,  &SUNI_REGN_RACPPATTERN,  &SUNI_REGX_RACPPATTERN }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPMASK,  &SUNI_REGN_RACPMASK,  &SUNI_REGX_RACPMASK }, {  &UTP_REGT_INT8,  &SUNI_REGO_RACPCHCS,  &SUNI_REGN_RACPCHCS,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_RACPUHCS,  &SUNI_REGN_RACPUHCS,  &NULL }, {  &UTP_REGT_INT19,  &SUNI_REGO_RACPCNT,  &SUNI_REGN_RACPCNT,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPCFG,  &SUNI_REGN_RACPCFG,  &SUNI_REGX_RACPCFG }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPCTRL,  &SUNI_REGN_TACPCTRL,  &SUNI_REGX_TACPCTRL_ULTRA }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPIDLEH,  &SUNI_REGN_TACPIDLEH,  &SUNI_REGX_TACPIDLEH }, {  &UTP_REGT_INT8,  &SUNI_REGO_TACPIDLEP,  &SUNI_REGN_TACPIDLEP,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPFIFOC,  &SUNI_REGN_TACPFIFOC,  &SUNI_REGX_TACPFIFOC }, {  &UTP_REGT_INT19,  &SUNI_REGO_TACPCNT,  &SUNI_REGN_TACPCNT,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPGFC,  &SUNI_REGN_TACPGFC,  &SUNI_REGX_TACPGFC }, {  &UTP_REGT_BITS,  &SUNI_REGO_POPCCTRL,  &SUNI_REGN_POPCCTRL,  &SUNI_REGX_POPCCTRL }, {  &UTP_REGT_INT8,  &SUNI_REGO_POPCSTROBE0,  &SUNI_REGN_POPCSTROBE0,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_POPCSTROBE1,  &SUNI_REGN_POPCSTROBE1,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_MTEST,  &SUNI_REGN_MTEST,  &SUNI_REGX_MTEST_ULTRA };}' unless defined(&SUNI_PRINT_ULTRA);
    eval 'sub SUNI_PRINT_622 () {{  &UTP_REGT_BITS,  &SUNI_REGO_MRESET,  &SUNI_REGN_MRESET,  &SUNI_REGX_MRESET_622 }, {  &UTP_REGT_BITS,  &SUNI_REGO_MCONFIG,  &SUNI_REGN_MCONFIG,  &SUNI_REGX_MCONFIG_622 }, {  &UTP_REGT_BITS,  &SUNI_REGO_MISTATUS,  &SUNI_REGN_MISTATUS,  &SUNI_REGX_MISTATUS_622 }, {  &UTP_REGT_BITS,  &SUNI_REGO_PISO,  &SUNI_REGN_PISO,  &SUNI_REGX_PISO }, {  &UTP_REGT_BITS,  &SUNI_REGO_MCTRLM,  &SUNI_REGN_MCTRLM,  &SUNI_REGX_MCTRLM }, {  &UTP_REGT_BITS,  &SUNI_REGO_MALARM,  &SUNI_REGN_MALARM,  &SUNI_REGX_MALARM }, {  &UTP_REGT_BITS,  &SUNI_REGO_POUT,  &SUNI_REGN_POUT,  &SUNI_REGX_POUT }, {  &UTP_REGT_INT8,  &SUNI_REGO_PIN,  &SUNI_REGN_PIN,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_PINV,  &SUNI_REGN_PINV,  &SUNI_REGX_PINV }, {  &UTP_REGT_INT8,  &SUNI_REGO_PINE,  &SUNI_REGN_PINE,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_XC1,  &SUNI_REGN_XC1,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_APSCS,  &SUNI_REGN_APSCS,  &SUNI_REGX_APSCS }, {  &UTP_REGT_INT8,  &SUNI_REGO_RK1,  &SUNI_REGN_RK1,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_RK2,  &SUNI_REGN_RK2,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_RZ1,  &SUNI_REGN_RZ1,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_XZ1,  &SUNI_REGN_XZ1,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RSOPCIE,  &SUNI_REGN_RSOPCIE,  &SUNI_REGX_RSOPCIE_622 }, {  &UTP_REGT_BITS,  &SUNI_REGO_RSOPSIS,  &SUNI_REGN_RSOPSIS,  &SUNI_REGX_RSOPSIS }, {  &UTP_REGT_INT16,  &SUNI_REGO_RSOP_BIP8,  &SUNI_REGN_RSOP_BIP8,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TSOPCTRL,  &SUNI_REGN_TSOPCTRL,  &SUNI_REGX_TSOPCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TSOPDIAG,  &SUNI_REGN_TSOPDIAG,  &SUNI_REGX_TSOPDIAG }, {  &UTP_REGT_BITS,  &SUNI_REGO_RLOPCTRL,  &SUNI_REGN_RLOPCTRL,  &SUNI_REGX_RLOPCTRL_622 }, {  &UTP_REGT_BITS,  &SUNI_REGO_RLOPINTR,  &SUNI_REGN_RLOPINTR,  &SUNI_REGX_RLOPINTR }, {  &UTP_REGT_INT20,  &SUNI_REGO_RLOPBIP8_24_96,  &SUNI_REGN_RLOPBIP8_24_96,  &NULL }, {  &UTP_REGT_INT20,  &SUNI_REGO_RLOPFEBE,  &SUNI_REGN_RLOPFEBE,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TLOPCTRL,  &SUNI_REGN_TLOPCTRL,  &SUNI_REGX_TLOPCTRL_622 }, {  &UTP_REGT_BITS,  &SUNI_REGO_TLOPDIAG,  &SUNI_REGN_TLOPDIAG,  &SUNI_REGX_TLOPDIAG }, {  &UTP_REGT_INT8,  &SUNI_REGO_TLOP_XK1,  &SUNI_REGN_TLOP_XK1,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_TLOP_XK2,  &SUNI_REGN_TLOP_XK2,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_SSTBCTRL,  &SUNI_REGN_SSTBCTRL,  &SUNI_REGX_SSTBCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_SSTBSTIS,  &SUNI_REGN_SSTBSTIS,  &SUNI_REGX_SSTBSTIS }, {  &UTP_REGT_BITS,  &SUNI_REGO_SSTBIAR,  &SUNI_REGN_SSTBIAR,  &SUNI_REGX_SSTBIAR }, {  &UTP_REGT_INT8,  &SUNI_REGO_SSTBIDR,  &SUNI_REGN_SSTBIDR,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_SSTBCSMS,  &SUNI_REGN_SSTBCSMS,  &SUNI_REGX_SSTBCSMS }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPCTRL,  &SUNI_REGN_RPOPCTRL,  &SUNI_REGX_RPOPCTRL_622 }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPISTAT,  &SUNI_REGN_RPOPISTAT,  &SUNI_REGX_RPOPISTAT }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPPIS,  &SUNI_REGN_RPOPPIS,  &SUNI_REGX_RPOPPIS }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPIEN,  &SUNI_REGN_RPOPIEN,  &SUNI_REGX_RPOPIEN }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPPIE,  &SUNI_REGN_RPOPPIE,  &SUNI_REGX_RPOPPIE }, {  &UTP_REGT_INT10BITS,  &SUNI_REGO_RPOPPTR,  &SUNI_REGN_RPOPPTR,  &SUNI_REGX_RPOPPTR }, {  &UTP_REGT_INT8,  &SUNI_REGO_RPOPPSL,  &SUNI_REGN_RPOPPSL,  &NULL }, {  &UTP_REGT_INT16,  &SUNI_REGO_RPOPBIP8,  &SUNI_REGN_RPOPBIP8,  &NULL }, {  &UTP_REGT_INT16,  &SUNI_REGO_RPOPFEBE,  &SUNI_REGN_RPOPFEBE,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPRDI,  &SUNI_REGN_RPOPRDI,  &SUNI_REGX_RPOPRDI }, {  &UTP_REGT_BITS,  &SUNI_REGO_RPOPRING,  &SUNI_REGN_RPOPRING,  &SUNI_REGX_RPOPRING }, {  &UTP_REGT_BITS,  &SUNI_REGO_TPOPCTRL,  &SUNI_REGN_TPOPCTRL,  &SUNI_REGX_TPOPCTRL_622 }, {  &UTP_REGT_BITS,  &SUNI_REGO_TPOPPTRC,  &SUNI_REGN_TPOPPTRC,  &SUNI_REGX_TPOPPTRC }, {  &UTP_REGT_INT10BITS,  &SUNI_REGO_TPOPCP,  &SUNI_REGN_TPOPCP,  &SUNI_REGX_TPOPCP }, {  &UTP_REGT_INT10BITS,  &SUNI_REGO_TPOPAPTR,  &SUNI_REGN_TPOPAPTR,  &SUNI_REGX_TPOPAPTR }, {  &UTP_REGT_INT8,  &SUNI_REGO_TPOPPT,  &SUNI_REGN_TPOPPT,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_TPOPPSL,  &SUNI_REGN_TPOPPSL,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TPOPSTATUS,  &SUNI_REGN_TPOPSTATUS,  &SUNI_REGX_TPOPSTATUS }, {  &UTP_REGT_INT8,  &SUNI_REGO_TPOPPUC,  &SUNI_REGN_TPOPPUC,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_TPOPPG1,  &SUNI_REGN_TPOPPG1,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_TPOPPG2,  &SUNI_REGN_TPOPPG2,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_TPOPPG3,  &SUNI_REGN_TPOPPG3,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPCTRL,  &SUNI_REGN_RACPCTRL,  &SUNI_REGX_RACPCTRL_622 }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPIS,  &SUNI_REGN_RACPIS,  &SUNI_REGX_RACPIS }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPIEC,  &SUNI_REGN_RACPIEC,  &SUNI_REGX_RACPIEC }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPPATTERN_622,  &SUNI_REGN_RACPPATTERN,  &SUNI_REGX_RACPPATTERN }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPMASK_622,  &SUNI_REGN_RACPMASK,  &SUNI_REGX_RACPMASK }, {  &UTP_REGT_INT12,  &SUNI_REGO_RACPCHCS_622,  &SUNI_REGN_RACPCHCS,  &NULL }, {  &UTP_REGT_INT12,  &SUNI_REGO_RACPUHCS_622,  &SUNI_REGN_RACPUHCS,  &NULL }, {  &UTP_REGT_INT21,  &SUNI_REGO_RACPCNT_622,  &SUNI_REGN_RACPCNT,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_RACPGFC,  &SUNI_REGN_RACPGFC,  &SUNI_REGX_RACPGFC }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPCTRL,  &SUNI_REGN_TACPCTRL,  &SUNI_REGX_TACPCTRL_622 }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPIDLEH,  &SUNI_REGN_TACPIDLEH,  &SUNI_REGX_TACPIDLEH }, {  &UTP_REGT_INT8,  &SUNI_REGO_TACPIDLEP,  &SUNI_REGN_TACPIDLEP,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPFIFOC,  &SUNI_REGN_TACPFIFOC,  &SUNI_REGX_TACPFIFOC_622 }, {  &UTP_REGT_INT21,  &SUNI_REGO_TACPCNT,  &SUNI_REGN_TACPCNT,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_TACPGFC,  &SUNI_REGN_TACPGFC,  &SUNI_REGX_TACPGFC }, {  &UTP_REGT_BITS,  &SUNI_REGO_SPTBCTRL,  &SUNI_REGN_SPTBCTRL,  &SUNI_REGX_SPTBCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_SPTBPTIS,  &SUNI_REGN_SPTBPTIS,  &SUNI_REGX_SPTBPTIS }, {  &UTP_REGT_BITS,  &SUNI_REGO_SPTBIAR,  &SUNI_REGN_SPTBIAR,  &SUNI_REGX_SPTBIAR }, {  &UTP_REGT_INT8,  &SUNI_REGO_SPTBIDR,  &SUNI_REGN_SPTBIDR,  &NULL }, {  &UTP_REGT_INT8,  &SUNI_REGO_SPTBEPSL,  &SUNI_REGN_SPTBEPSL,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_SPTBPSLS,  &SUNI_REGN_SPTBPSLS,  &SUNI_REGX_SPTBPSLS }, {  &UTP_REGT_BITS,  &SUNI_REGO_BERMCTRL,  &SUNI_REGN_BERMCTRL,  &SUNI_REGX_BERMCTRL }, {  &UTP_REGT_BITS,  &SUNI_REGO_BERMINT,  &SUNI_REGN_BERMINT,  &SUNI_REGX_BERMINT }, {  &UTP_REGT_INT16,  &SUNI_REGO_BERMLAP,  &SUNI_REGN_BERMLAP,  &NULL }, {  &UTP_REGT_INT16,  &SUNI_REGO_BERMLT,  &SUNI_REGN_BERMLT,  &NULL }, {  &UTP_REGT_BITS,  &SUNI_REGO_MTEST,  &SUNI_REGN_MTEST,  &SUNI_REGX_MTEST_622 };}' unless defined(&SUNI_PRINT_622);
}
1;
