require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub WI_DELAY () {5;}' unless defined(&WI_DELAY);
eval 'sub WI_TIMEOUT () {(500000/ &WI_DELAY);}' unless defined(&WI_TIMEOUT);
eval 'sub WI_PORT0 () {(0<< 8);}' unless defined(&WI_PORT0);
eval 'sub WI_PORT1 () {(1<< 8);}' unless defined(&WI_PORT1);
eval 'sub WI_PORT2 () {(2<< 8);}' unless defined(&WI_PORT2);
eval 'sub WI_PORT3 () {(3<< 8);}' unless defined(&WI_PORT3);
eval 'sub WI_PORT4 () {(4<< 8);}' unless defined(&WI_PORT4);
eval 'sub WI_PORT5 () {(5<< 8);}' unless defined(&WI_PORT5);
eval 'sub WI_PCI_LMEMRES () {0x10;}' unless defined(&WI_PCI_LMEMRES);
eval 'sub WI_PCI_LOCALRES () {0x14;}' unless defined(&WI_PCI_LOCALRES);
eval 'sub WI_PCI_MEMRES () {0x18;}' unless defined(&WI_PCI_MEMRES);
eval 'sub WI_PCI_IORES () {0x1c;}' unless defined(&WI_PCI_IORES);
eval 'sub WI_LOCAL_INTCSR () {0x4c;}' unless defined(&WI_LOCAL_INTCSR);
eval 'sub WI_LOCAL_INTEN () {0x40;}' unless defined(&WI_LOCAL_INTEN);
eval 'sub WI_HFA384X_SWSUPPORT0_OFF () {0x28;}' unless defined(&WI_HFA384X_SWSUPPORT0_OFF);
eval 'sub WI_PRISM2STA_MAGIC () {0x4a2d;}' unless defined(&WI_PRISM2STA_MAGIC);
eval 'sub WI_PCICOR_OFF () {0x26;}' unless defined(&WI_PCICOR_OFF);
eval 'sub WI_PCICOR_RESET () {0x80;}' unless defined(&WI_PCICOR_RESET);
eval 'sub WI_DEFAULT_PORT () { &WI_PORT0;}' unless defined(&WI_DEFAULT_PORT);
eval 'sub WI_DEFAULT_NETNAME () {"";}' unless defined(&WI_DEFAULT_NETNAME);
eval 'sub WI_DEFAULT_AP_DENSITY () {1;}' unless defined(&WI_DEFAULT_AP_DENSITY);
eval 'sub WI_DEFAULT_RTS_THRESH () {2347;}' unless defined(&WI_DEFAULT_RTS_THRESH);
eval 'sub WI_DEFAULT_DATALEN () {2304;}' unless defined(&WI_DEFAULT_DATALEN);
eval 'sub WI_DEFAULT_CREATE_IBSS () {0;}' unless defined(&WI_DEFAULT_CREATE_IBSS);
eval 'sub WI_DEFAULT_PM_ENABLED () {0;}' unless defined(&WI_DEFAULT_PM_ENABLED);
eval 'sub WI_DEFAULT_MAX_SLEEP () {100;}' unless defined(&WI_DEFAULT_MAX_SLEEP);
eval 'sub WI_DEFAULT_ROAMING () {1;}' unless defined(&WI_DEFAULT_ROAMING);
eval 'sub WI_DEFAULT_AUTHTYPE () {1;}' unless defined(&WI_DEFAULT_AUTHTYPE);
if(defined(&__NetBSD__)) {
    eval 'sub OS_STRING_NAME () {"NetBSD";}' unless defined(&OS_STRING_NAME);
}
if(defined(&__FreeBSD__)) {
    eval 'sub OS_STRING_NAME () {"FreeBSD";}' unless defined(&OS_STRING_NAME);
}
if(defined(&__OpenBSD__)) {
    eval 'sub OS_STRING_NAME () {"OpenBSD";}' unless defined(&OS_STRING_NAME);
}
eval 'sub WI_DEFAULT_NODENAME () { &OS_STRING_NAME " WaveLAN/IEEE node";}' unless defined(&WI_DEFAULT_NODENAME);
eval 'sub WI_DEFAULT_IBSS () { &OS_STRING_NAME " IBSS";}' unless defined(&WI_DEFAULT_IBSS);
eval 'sub WI_BUS_PCCARD () {0;}' unless defined(&WI_BUS_PCCARD);
eval 'sub WI_BUS_PCI_PLX () {1;}' unless defined(&WI_BUS_PCI_PLX);
eval 'sub WI_BUS_PCI_NATIVE () {2;}' unless defined(&WI_BUS_PCI_NATIVE);
unless(defined(&CSR_WRITE_4)) {
    sub CSR_WRITE_4 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_space_write_4(($sc)-> &wi_btag, ($sc)-> &wi_bhandle, ($sc)-> &wi_bus_type ==  &WI_BUS_PCI_NATIVE ? ($reg)*2: ($reg), $val));
    }
}
unless(defined(&CSR_WRITE_2)) {
    sub CSR_WRITE_2 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_space_write_2(($sc)-> &wi_btag, ($sc)-> &wi_bhandle, ($sc)-> &wi_bus_type ==  &WI_BUS_PCI_NATIVE ? ($reg)*2: ($reg), $val));
    }
}
unless(defined(&CSR_WRITE_1)) {
    sub CSR_WRITE_1 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_space_write_1(($sc)-> &wi_btag, ($sc)-> &wi_bhandle, ($sc)-> &wi_bus_type ==  &WI_BUS_PCI_NATIVE ? ($reg)*2: ($reg), $val));
    }
}
unless(defined(&CSR_READ_4)) {
    sub CSR_READ_4 {
	my($sc, $reg) = @_;
	eval q( &bus_space_read_4(($sc)-> &wi_btag, ($sc)-> &wi_bhandle, ($sc)-> &wi_bus_type ==  &WI_BUS_PCI_NATIVE ? ($reg)*2: ($reg)));
    }
}
unless(defined(&CSR_READ_2)) {
    sub CSR_READ_2 {
	my($sc, $reg) = @_;
	eval q( &bus_space_read_2(($sc)-> &wi_btag, ($sc)-> &wi_bhandle, ($sc)-> &wi_bus_type ==  &WI_BUS_PCI_NATIVE ? ($reg)*2: ($reg)));
    }
}
unless(defined(&CSR_READ_1)) {
    sub CSR_READ_1 {
	my($sc, $reg) = @_;
	eval q( &bus_space_read_1(($sc)-> &wi_btag, ($sc)-> &wi_bhandle, ($sc)-> &wi_bus_type ==  &WI_BUS_PCI_NATIVE ? ($reg)*2: ($reg)));
    }
}
unless(defined(&CSM_WRITE_1)) {
    sub CSM_WRITE_1 {
	my($sc, $off, $val) = @_;
	eval q( &bus_space_write_1(($sc)-> &wi_bmemtag, ($sc)-> &wi_bmemhandle, $off, $val));
    }
}
unless(defined(&CSM_READ_1)) {
    sub CSM_READ_1 {
	my($sc, $off) = @_;
	eval q( &bus_space_read_1(($sc)-> &wi_bmemtag, ($sc)-> &wi_bmemhandle, $off));
    }
}
unless(defined(&CSR_WRITE_STREAM_2)) {
    sub CSR_WRITE_STREAM_2 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_space_write_stream_2( ($sc->{wi_btag}),  ($sc->{wi_bhandle}), ( ($sc->{wi_bus_type}) ==  &WI_BUS_PCI_NATIVE ? ($reg) * 2: ($reg)), $val));
    }
}
unless(defined(&CSR_WRITE_MULTI_STREAM_2)) {
    sub CSR_WRITE_MULTI_STREAM_2 {
	my($sc, $reg, $val, $count) = @_;
	eval q( &bus_space_write_multi_stream_2( ($sc->{wi_btag}),  ($sc->{wi_bhandle}), ( ($sc->{wi_bus_type}) ==  &WI_BUS_PCI_NATIVE ? ($reg) * 2: ($reg)), $val, $count));
    }
}
unless(defined(&CSR_READ_STREAM_2)) {
    sub CSR_READ_STREAM_2 {
	my($sc, $reg) = @_;
	eval q( &bus_space_read_stream_2( ($sc->{wi_btag}),  ($sc->{wi_bhandle}), ( ($sc->{wi_bus_type}) ==  &WI_BUS_PCI_NATIVE ? ($reg) * 2: ($reg))));
    }
}
unless(defined(&CSR_READ_MULTI_STREAM_2)) {
    sub CSR_READ_MULTI_STREAM_2 {
	my($sc, $reg, $buf, $count) = @_;
	eval q( &bus_space_read_multi_stream_2( ($sc->{wi_btag}),  ($sc->{wi_bhandle}), ( ($sc->{wi_bus_type}) ==  &WI_BUS_PCI_NATIVE ? ($reg) * 2: ($reg)), $buf, $count));
    }
}
eval 'sub WI_IOSIZ () {0x40;}' unless defined(&WI_IOSIZ);
eval 'sub WI_COMMAND () {0x;}' unless defined(&WI_COMMAND);
eval 'sub WI_PARAM0 () {0x2;}' unless defined(&WI_PARAM0);
eval 'sub WI_PARAM1 () {0x4;}' unless defined(&WI_PARAM1);
eval 'sub WI_PARAM2 () {0x6;}' unless defined(&WI_PARAM2);
eval 'sub WI_STATUS () {0x8;}' unless defined(&WI_STATUS);
eval 'sub WI_RESP0 () {0xa;}' unless defined(&WI_RESP0);
eval 'sub WI_RESP1 () {0xc;}' unless defined(&WI_RESP1);
eval 'sub WI_RESP2 () {0xe;}' unless defined(&WI_RESP2);
eval 'sub WI_CMD_BUSY () {0x8000;}' unless defined(&WI_CMD_BUSY);
eval 'sub WI_CMD_INI () {0x;}' unless defined(&WI_CMD_INI);
eval 'sub WI_CMD_ENABLE () {0x1;}' unless defined(&WI_CMD_ENABLE);
eval 'sub WI_CMD_DISABLE () {0x2;}' unless defined(&WI_CMD_DISABLE);
eval 'sub WI_CMD_DIAG () {0x3;}' unless defined(&WI_CMD_DIAG);
eval 'sub WI_CMD_ALLOC_MEM () {0xa;}' unless defined(&WI_CMD_ALLOC_MEM);
eval 'sub WI_CMD_TX () {0xb;}' unless defined(&WI_CMD_TX);
eval 'sub WI_CMD_NOTIFY () {0x10;}' unless defined(&WI_CMD_NOTIFY);
eval 'sub WI_CMD_INQUIRE () {0x11;}' unless defined(&WI_CMD_INQUIRE);
eval 'sub WI_CMD_ACCESS () {0x21;}' unless defined(&WI_CMD_ACCESS);
eval 'sub WI_CMD_ACCESS_WRITE () {0x121;}' unless defined(&WI_CMD_ACCESS_WRITE);
eval 'sub WI_CMD_PROGRAM () {0x22;}' unless defined(&WI_CMD_PROGRAM);
eval 'sub WI_CMD_READEE () {0x30;}' unless defined(&WI_CMD_READEE);
eval 'sub WI_CMD_READMIF () {0x30;}' unless defined(&WI_CMD_READMIF);
eval 'sub WI_CMD_WRITEMIF () {0x31;}' unless defined(&WI_CMD_WRITEMIF);
eval 'sub WI_CMD_DEBUG () {0x38;}' unless defined(&WI_CMD_DEBUG);
eval 'sub WI_CMD_CODE_MASK () {0x3f;}' unless defined(&WI_CMD_CODE_MASK);
eval 'sub WI_TEST_MONITOR () {0xb;}' unless defined(&WI_TEST_MONITOR);
eval 'sub WI_TEST_STOP () {0xf;}' unless defined(&WI_TEST_STOP);
eval 'sub WI_TEST_CFG_BITS () {0x15;}' unless defined(&WI_TEST_CFG_BITS);
eval 'sub WI_TEST_CFG_BIT_ALC () {0x8;}' unless defined(&WI_TEST_CFG_BIT_ALC);
eval 'sub WI_RECLAIM () {0x100;}' unless defined(&WI_RECLAIM);
eval 'sub WI_ACCESS_READ () {0x;}' unless defined(&WI_ACCESS_READ);
eval 'sub WI_ACCESS_WRITE () {0x100;}' unless defined(&WI_ACCESS_WRITE);
eval 'sub WI_PROGRAM_DISABLE () {0x;}' unless defined(&WI_PROGRAM_DISABLE);
eval 'sub WI_PROGRAM_ENABLE_RAM () {0x100;}' unless defined(&WI_PROGRAM_ENABLE_RAM);
eval 'sub WI_PROGRAM_ENABLE_NVRAM () {0x200;}' unless defined(&WI_PROGRAM_ENABLE_NVRAM);
eval 'sub WI_PROGRAM_NVRAM () {0x300;}' unless defined(&WI_PROGRAM_NVRAM);
eval 'sub WI_STAT_CMD_CODE () {0x3f;}' unless defined(&WI_STAT_CMD_CODE);
eval 'sub WI_STAT_DIAG_ERR () {0x100;}' unless defined(&WI_STAT_DIAG_ERR);
eval 'sub WI_STAT_INQ_ERR () {0x500;}' unless defined(&WI_STAT_INQ_ERR);
eval 'sub WI_STAT_CMD_RESULT () {0x7f00;}' unless defined(&WI_STAT_CMD_RESULT);
eval 'sub WI_INFO_FID () {0x10;}' unless defined(&WI_INFO_FID);
eval 'sub WI_RX_FID () {0x20;}' unless defined(&WI_RX_FID);
eval 'sub WI_ALLOC_FID () {0x22;}' unless defined(&WI_ALLOC_FID);
eval 'sub WI_TX_CMP_FID () {0x24;}' unless defined(&WI_TX_CMP_FID);
eval 'sub WI_SEL0 () {0x18;}' unless defined(&WI_SEL0);
eval 'sub WI_SEL1 () {0x1a;}' unless defined(&WI_SEL1);
eval 'sub WI_OFF0 () {0x1c;}' unless defined(&WI_OFF0);
eval 'sub WI_OFF1 () {0x1e;}' unless defined(&WI_OFF1);
eval 'sub WI_DATA0 () {0x36;}' unless defined(&WI_DATA0);
eval 'sub WI_DATA1 () {0x38;}' unless defined(&WI_DATA1);
eval 'sub WI_BAP0 () { &WI_DATA0;}' unless defined(&WI_BAP0);
eval 'sub WI_BAP1 () { &WI_DATA1;}' unless defined(&WI_BAP1);
eval 'sub WI_OFF_BUSY () {0x8000;}' unless defined(&WI_OFF_BUSY);
eval 'sub WI_OFF_ERR () {0x4000;}' unless defined(&WI_OFF_ERR);
eval 'sub WI_OFF_DATAOFF () {0xfff;}' unless defined(&WI_OFF_DATAOFF);
eval 'sub WI_EVENT_STAT () {0x30;}' unless defined(&WI_EVENT_STAT);
eval 'sub WI_INT_EN () {0x32;}' unless defined(&WI_INT_EN);
eval 'sub WI_EVENT_ACK () {0x34;}' unless defined(&WI_EVENT_ACK);
eval 'sub WI_EV_TICK () {0x8000;}' unless defined(&WI_EV_TICK);
eval 'sub WI_EV_RES () {0x4000;}' unless defined(&WI_EV_RES);
eval 'sub WI_EV_INFO_DROP () {0x2000;}' unless defined(&WI_EV_INFO_DROP);
eval 'sub WI_EV_NO_CARD () {0x800;}' unless defined(&WI_EV_NO_CARD);
eval 'sub WI_EV_DUIF_RX () {0x400;}' unless defined(&WI_EV_DUIF_RX);
eval 'sub WI_EV_INFO () {0x80;}' unless defined(&WI_EV_INFO);
eval 'sub WI_EV_CMD () {0x10;}' unless defined(&WI_EV_CMD);
eval 'sub WI_EV_ALLOC () {0x8;}' unless defined(&WI_EV_ALLOC);
eval 'sub WI_EV_TX_EXC () {0x4;}' unless defined(&WI_EV_TX_EXC);
eval 'sub WI_EV_TX () {0x2;}' unless defined(&WI_EV_TX);
eval 'sub WI_EV_RX () {0x1;}' unless defined(&WI_EV_RX);
eval 'sub WI_SW0 () {0x28;}' unless defined(&WI_SW0);
eval 'sub WI_SW1 () {0x2a;}' unless defined(&WI_SW1);
eval 'sub WI_SW2 () {0x2c;}' unless defined(&WI_SW2);
eval 'sub WI_SW3 () {0x2e;}' unless defined(&WI_SW3);
eval 'sub WI_CNTL () {0x14;}' unless defined(&WI_CNTL);
eval 'sub WI_CNTL_AUX_ENA () {0xc000;}' unless defined(&WI_CNTL_AUX_ENA);
eval 'sub WI_CNTL_AUX_ENA_STAT () {0xc000;}' unless defined(&WI_CNTL_AUX_ENA_STAT);
eval 'sub WI_CNTL_AUX_DIS_STAT () {0x;}' unless defined(&WI_CNTL_AUX_DIS_STAT);
eval 'sub WI_CNTL_AUX_ENA_CNTL () {0x8000;}' unless defined(&WI_CNTL_AUX_ENA_CNTL);
eval 'sub WI_CNTL_AUX_DIS_CNTL () {0x4000;}' unless defined(&WI_CNTL_AUX_DIS_CNTL);
eval 'sub WI_AUX_PAGE () {0x3a;}' unless defined(&WI_AUX_PAGE);
eval 'sub WI_AUX_OFFSET () {0x3c;}' unless defined(&WI_AUX_OFFSET);
eval 'sub WI_AUX_DATA () {0x3e;}' unless defined(&WI_AUX_DATA);
eval 'sub WI_AUX_PGSZ () {128;}' unless defined(&WI_AUX_PGSZ);
eval 'sub WI_AUX_KEY0 () {0xfe01;}' unless defined(&WI_AUX_KEY0);
eval 'sub WI_AUX_KEY1 () {0xdc23;}' unless defined(&WI_AUX_KEY1);
eval 'sub WI_AUX_KEY2 () {0xba45;}' unless defined(&WI_AUX_KEY2);
eval 'sub WI_COR () {0x40;}' unless defined(&WI_COR);
eval 'sub WI_COR_RESET () {0x80;}' unless defined(&WI_COR_RESET);
eval 'sub WI_COR_IOMODE () {0x41;}' unless defined(&WI_COR_IOMODE);
eval 'sub WI_HCR () {0x42;}' unless defined(&WI_HCR);
eval 'sub WI_HCR_4WIRE () {0x10;}' unless defined(&WI_HCR_4WIRE);
eval 'sub WI_HCR_RUN () {0x7;}' unless defined(&WI_HCR_RUN);
eval 'sub WI_HCR_HOLD () {0xf;}' unless defined(&WI_HCR_HOLD);
eval 'sub WI_HCR_EEHOLD () {0xce;}' unless defined(&WI_HCR_EEHOLD);
eval 'sub WI_COR_OFFSET () {0x3e0;}' unless defined(&WI_COR_OFFSET);
eval 'sub WI_COR_VALUE () {0x41;}' unless defined(&WI_COR_VALUE);
eval 'sub WI_NIC_LUCENT_ID () {0x1;}' unless defined(&WI_NIC_LUCENT_ID);
eval 'sub WI_NIC_LUCENT_STR () {"Lucent Technologies, WaveLAN/IEEE";}' unless defined(&WI_NIC_LUCENT_STR);
eval 'sub WI_NIC_SONY_ID () {0x2;}' unless defined(&WI_NIC_SONY_ID);
eval 'sub WI_NIC_SONY_STR () {"Sony WaveLAN/IEEE";}' unless defined(&WI_NIC_SONY_STR);
eval 'sub WI_NIC_LUCENT_EMB_ID () {0x5;}' unless defined(&WI_NIC_LUCENT_EMB_ID);
eval 'sub WI_NIC_LUCENT_EMB_STR () {"Lucent Embedded WaveLAN/IEEE";}' unless defined(&WI_NIC_LUCENT_EMB_STR);
eval 'sub WI_NIC_EVB2_ID () {0x8000;}' unless defined(&WI_NIC_EVB2_ID);
eval 'sub WI_NIC_EVB2_STR () {"RF:PRISM2 MAC:HFA3841";}' unless defined(&WI_NIC_EVB2_STR);
eval 'sub WI_NIC_HWB3763_ID () {0x8001;}' unless defined(&WI_NIC_HWB3763_ID);
eval 'sub WI_NIC_HWB3763_STR () {"RF:PRISM2 MAC:HFA3841 CARD:HWB3763 rev.B";}' unless defined(&WI_NIC_HWB3763_STR);
eval 'sub WI_NIC_HWB3163_ID () {0x8002;}' unless defined(&WI_NIC_HWB3163_ID);
eval 'sub WI_NIC_HWB3163_STR () {"RF:PRISM2 MAC:HFA3841 CARD:HWB3163 rev.A";}' unless defined(&WI_NIC_HWB3163_STR);
eval 'sub WI_NIC_HWB3163B_ID () {0x8003;}' unless defined(&WI_NIC_HWB3163B_ID);
eval 'sub WI_NIC_HWB3163B_STR () {"RF:PRISM2 MAC:HFA3841 CARD:HWB3163 rev.B";}' unless defined(&WI_NIC_HWB3163B_STR);
eval 'sub WI_NIC_EVB3_ID () {0x8004;}' unless defined(&WI_NIC_EVB3_ID);
eval 'sub WI_NIC_EVB3_STR () {"RF:PRISM2 MAC:HFA3842 CARD:HFA3842 EVAL";}' unless defined(&WI_NIC_EVB3_STR);
eval 'sub WI_NIC_HWB1153_ID () {0x8007;}' unless defined(&WI_NIC_HWB1153_ID);
eval 'sub WI_NIC_HWB1153_STR () {"RF:PRISM1 MAC:HFA3841 CARD:HWB1153";}' unless defined(&WI_NIC_HWB1153_STR);
eval 'sub WI_NIC_P2_SST_ID () {0x8008;}' unless defined(&WI_NIC_P2_SST_ID);
eval 'sub WI_NIC_P2_SST_STR () {"RF:PRISM2 MAC:HFA3841 CARD:HWB3163-SST-flash";}' unless defined(&WI_NIC_P2_SST_STR);
eval 'sub WI_NIC_EVB2_SST_ID () {0x8009;}' unless defined(&WI_NIC_EVB2_SST_ID);
eval 'sub WI_NIC_EVB2_SST_STR () {"RF:PRISM2 MAC:HFA3841 CARD:HWB3163-SST-flash";}' unless defined(&WI_NIC_EVB2_SST_STR);
eval 'sub WI_NIC_3842_EVA_ID () {0x800a;}' unless defined(&WI_NIC_3842_EVA_ID);
eval 'sub WI_NIC_3842_EVA_STR () {"RF:PRISM2 MAC:HFA3842 CARD:HFA3842 EVAL";}' unless defined(&WI_NIC_3842_EVA_STR);
eval 'sub WI_NIC_3842_PCMCIA_AMD_ID () {0x800b;}' unless defined(&WI_NIC_3842_PCMCIA_AMD_ID);
eval 'sub WI_NIC_3842_PCMCIA_SST_ID () {0x800c;}' unless defined(&WI_NIC_3842_PCMCIA_SST_ID);
eval 'sub WI_NIC_3842_PCMCIA_ATL_ID () {0x800d;}' unless defined(&WI_NIC_3842_PCMCIA_ATL_ID);
eval 'sub WI_NIC_3842_PCMCIA_ATS_ID () {0x800e;}' unless defined(&WI_NIC_3842_PCMCIA_ATS_ID);
eval 'sub WI_NIC_3842_PCMCIA_STR () {"RF:PRISM2.5 MAC:ISL3873";}' unless defined(&WI_NIC_3842_PCMCIA_STR);
eval 'sub WI_NIC_3842_MINI_AMD_ID () {0x8012;}' unless defined(&WI_NIC_3842_MINI_AMD_ID);
eval 'sub WI_NIC_3842_MINI_SST_ID () {0x8013;}' unless defined(&WI_NIC_3842_MINI_SST_ID);
eval 'sub WI_NIC_3842_MINI_ATL_ID () {0x8014;}' unless defined(&WI_NIC_3842_MINI_ATL_ID);
eval 'sub WI_NIC_3842_MINI_ATS_ID () {0x8015;}' unless defined(&WI_NIC_3842_MINI_ATS_ID);
eval 'sub WI_NIC_3842_MINI_STR () {"RF:PRISM2.5 MAC:ISL3874A(Mini-PCI)";}' unless defined(&WI_NIC_3842_MINI_STR);
eval 'sub WI_NIC_3842_PCI_AMD_ID () {0x8016;}' unless defined(&WI_NIC_3842_PCI_AMD_ID);
eval 'sub WI_NIC_3842_PCI_SST_ID () {0x8017;}' unless defined(&WI_NIC_3842_PCI_SST_ID);
eval 'sub WI_NIC_3842_PCI_ATL_ID () {0x8018;}' unless defined(&WI_NIC_3842_PCI_ATL_ID);
eval 'sub WI_NIC_3842_PCI_ATS_ID () {0x8019;}' unless defined(&WI_NIC_3842_PCI_ATS_ID);
eval 'sub WI_NIC_3842_PCI_STR () {"RF:PRISM2.5 MAC:ISL3874A(PCI-bridge)";}' unless defined(&WI_NIC_3842_PCI_STR);
eval 'sub WI_NIC_P3_PCMCIA_AMD_ID () {0x801a;}' unless defined(&WI_NIC_P3_PCMCIA_AMD_ID);
eval 'sub WI_NIC_P3_PCMCIA_SST_ID () {0x801b;}' unless defined(&WI_NIC_P3_PCMCIA_SST_ID);
eval 'sub WI_NIC_P3_PCMCIA_ATL_ID () {0x801c;}' unless defined(&WI_NIC_P3_PCMCIA_ATL_ID);
eval 'sub WI_NIC_P3_PCMCIA_ATS_ID () {0x801d;}' unless defined(&WI_NIC_P3_PCMCIA_ATS_ID);
eval 'sub WI_NIC_P3_PCMCIA_STR () {"RF:PRISM3(PCMCIA)";}' unless defined(&WI_NIC_P3_PCMCIA_STR);
eval 'sub WI_NIC_P3_USB_AMD_ID () {0x801e;}' unless defined(&WI_NIC_P3_USB_AMD_ID);
eval 'sub WI_NIC_P3_USB_SST_ID () {0x801f;}' unless defined(&WI_NIC_P3_USB_SST_ID);
eval 'sub WI_NIC_P3_USB_ATL_ID () {0x8020;}' unless defined(&WI_NIC_P3_USB_ATL_ID);
eval 'sub WI_NIC_P3_MINI_AMD_ID () {0x8021;}' unless defined(&WI_NIC_P3_MINI_AMD_ID);
eval 'sub WI_NIC_P3_MINI_SST_ID () {0x8022;}' unless defined(&WI_NIC_P3_MINI_SST_ID);
eval 'sub WI_NIC_P3_MINI_ATL_ID () {0x8023;}' unless defined(&WI_NIC_P3_MINI_ATL_ID);
eval 'sub WI_NIC_P3_MINI_ATS_ID () {0x8024;}' unless defined(&WI_NIC_P3_MINI_ATS_ID);
eval 'sub WI_NIC_P3_MINI_STR () {"RF:PRISM3(Mini-PCI)";}' unless defined(&WI_NIC_P3_MINI_STR);
eval 'sub WI_PORTTYPE_IBSS () {0x;}' unless defined(&WI_PORTTYPE_IBSS);
eval 'sub WI_PORTTYPE_BSS () {0x1;}' unless defined(&WI_PORTTYPE_BSS);
eval 'sub WI_PORTTYPE_WDS () {0x2;}' unless defined(&WI_PORTTYPE_WDS);
eval 'sub WI_PORTTYPE_ADHOC () {0x3;}' unless defined(&WI_PORTTYPE_ADHOC);
eval 'sub WI_PORTTYPE_APSILENT () {0x5;}' unless defined(&WI_PORTTYPE_APSILENT);
eval 'sub WI_PORTTYPE_HOSTAP () {0x6;}' unless defined(&WI_PORTTYPE_HOSTAP);
eval 'sub WI_SUPPRATES_1M () {0x1;}' unless defined(&WI_SUPPRATES_1M);
eval 'sub WI_SUPPRATES_2M () {0x2;}' unless defined(&WI_SUPPRATES_2M);
eval 'sub WI_SUPPRATES_5M () {0x4;}' unless defined(&WI_SUPPRATES_5M);
eval 'sub WI_SUPPRATES_11M () {0x8;}' unless defined(&WI_SUPPRATES_11M);
eval 'sub WI_RATES_BITS () {"\\20\\0011M\\0022M\\0035.5M\\00411M";}' unless defined(&WI_RATES_BITS);
eval 'sub WI_INFO_NOTIFY () {0xf000;}' unless defined(&WI_INFO_NOTIFY);
eval 'sub WI_INFO_COUNTERS () {0xf100;}' unless defined(&WI_INFO_COUNTERS);
eval 'sub WI_INFO_SCAN_RESULTS () {0xf101;}' unless defined(&WI_INFO_SCAN_RESULTS);
eval 'sub WI_INFO_HOST_SCAN_RESULTS () {0xf104;}' unless defined(&WI_INFO_HOST_SCAN_RESULTS);
eval 'sub WI_INFO_LINK_STAT () {0xf200;}' unless defined(&WI_INFO_LINK_STAT);
eval 'sub WI_INFO_LINK_STAT_CONNECTED () {1;}' unless defined(&WI_INFO_LINK_STAT_CONNECTED);
eval 'sub WI_INFO_LINK_STAT_DISCONNECTED () {2;}' unless defined(&WI_INFO_LINK_STAT_DISCONNECTED);
eval 'sub WI_INFO_LINK_STAT_AP_CHG () {3;}' unless defined(&WI_INFO_LINK_STAT_AP_CHG);
eval 'sub WI_INFO_LINK_STAT_AP_OOR () {4;}' unless defined(&WI_INFO_LINK_STAT_AP_OOR);
eval 'sub WI_INFO_LINK_STAT_AP_INR () {5;}' unless defined(&WI_INFO_LINK_STAT_AP_INR);
eval 'sub WI_INFO_LINK_STAT_ASSOC_FAILED () {6;}' unless defined(&WI_INFO_LINK_STAT_ASSOC_FAILED);
eval 'sub WI_INFO_ASSOC_STAT () {0xf201;}' unless defined(&WI_INFO_ASSOC_STAT);
eval 'sub WI_INFO_AUTH_REQUEST () {0xf202;}' unless defined(&WI_INFO_AUTH_REQUEST);
eval 'sub WI_INFO_POWERSAVE_COUNT () {0xf203;}' unless defined(&WI_INFO_POWERSAVE_COUNT);
eval 'sub ASSOC () {1;}' unless defined(&ASSOC);
eval 'sub REASSOC () {2;}' unless defined(&REASSOC);
eval 'sub DISASSOC () {3;}' unless defined(&DISASSOC);
eval 'sub ASSOCFAIL () {4;}' unless defined(&ASSOCFAIL);
eval 'sub AUTHFAIL () {5;}' unless defined(&AUTHFAIL);
eval 'sub WI_APRATE_1 () {0xa;}' unless defined(&WI_APRATE_1);
eval 'sub WI_APRATE_2 () {0x14;}' unless defined(&WI_APRATE_2);
eval 'sub WI_APRATE_5 () {0x37;}' unless defined(&WI_APRATE_5);
eval 'sub WI_APRATE_11 () {0x6e;}' unless defined(&WI_APRATE_11);
eval 'sub WI_TXSTAT_RET_ERR () {0x1;}' unless defined(&WI_TXSTAT_RET_ERR);
eval 'sub WI_TXSTAT_AGED_ERR () {0x2;}' unless defined(&WI_TXSTAT_AGED_ERR);
eval 'sub WI_TXSTAT_DISCONNECT () {0x4;}' unless defined(&WI_TXSTAT_DISCONNECT);
eval 'sub WI_TXSTAT_FORM_ERR () {0x8;}' unless defined(&WI_TXSTAT_FORM_ERR);
eval 'sub WI_STAT_BADCRC () {0x1;}' unless defined(&WI_STAT_BADCRC);
eval 'sub WI_STAT_UNDECRYPTABLE () {0x2;}' unless defined(&WI_STAT_UNDECRYPTABLE);
eval 'sub WI_STAT_ERRSTAT () {0x3;}' unless defined(&WI_STAT_ERRSTAT);
eval 'sub WI_STAT_MAC_PORT () {0x700;}' unless defined(&WI_STAT_MAC_PORT);
eval 'sub WI_STAT_PCF () {0x1000;}' unless defined(&WI_STAT_PCF);
eval 'sub WI_RXSTAT_MSG_TYPE () {0xe000;}' unless defined(&WI_RXSTAT_MSG_TYPE);
eval 'sub WI_STAT_1042 () {0x2000;}' unless defined(&WI_STAT_1042);
eval 'sub WI_STAT_TUNNEL () {0x4000;}' unless defined(&WI_STAT_TUNNEL);
eval 'sub WI_STAT_WMP_MSG () {0x6000;}' unless defined(&WI_STAT_WMP_MSG);
eval 'sub WI_STAT_MGMT () {0x8000;}' unless defined(&WI_STAT_MGMT);
eval 'sub WI_ENC_TX_E_II () {0xe;}' unless defined(&WI_ENC_TX_E_II);
eval 'sub WI_ENC_TX_1042 () {0x;}' unless defined(&WI_ENC_TX_1042);
eval 'sub WI_ENC_TX_TUNNEL () {0xf8;}' unless defined(&WI_ENC_TX_TUNNEL);
eval 'sub WI_TXCNTL_TX_OK () {0x2;}' unless defined(&WI_TXCNTL_TX_OK);
eval 'sub WI_TXCNTL_TX_EX () {0x4;}' unless defined(&WI_TXCNTL_TX_EX);
eval 'sub WI_TXCNTL_STRUCT_TYPE () {0x18;}' unless defined(&WI_TXCNTL_STRUCT_TYPE);
eval 'sub WI_ENC_TX_802_3 () {0x;}' unless defined(&WI_ENC_TX_802_3);
eval 'sub WI_ENC_TX_802_11 () {0x8;}' unless defined(&WI_ENC_TX_802_11);
eval 'sub WI_TXCNTL_ALTRTRY () {0x20;}' unless defined(&WI_TXCNTL_ALTRTRY);
eval 'sub WI_TXCNTL_NOCRYPT () {0x80;}' unless defined(&WI_TXCNTL_NOCRYPT);
eval 'sub WI_HFA386X_CR_A_D_TEST_MODES2 () {0x1a;}' unless defined(&WI_HFA386X_CR_A_D_TEST_MODES2);
eval 'sub WI_HFA386X_CR_MANUAL_TX_POWER () {0x3e;}' unless defined(&WI_HFA386X_CR_MANUAL_TX_POWER);
if(defined(&IEEE80211_RADIOTAP_F_CFP)) {
    eval 'sub WI_RX_RADIOTAP_PRESENT () {((1<<  &IEEE80211_RADIOTAP_TSFT) | (1<<  &IEEE80211_RADIOTAP_FLAGS) | (1<<  &IEEE80211_RADIOTAP_RATE) | (1<<  &IEEE80211_RADIOTAP_CHANNEL) | (1<<  &IEEE80211_RADIOTAP_DB_ANTSIGNAL) | (1<<  &IEEE80211_RADIOTAP_DB_ANTNOISE));}' unless defined(&WI_RX_RADIOTAP_PRESENT);
    eval 'sub WI_TX_RADIOTAP_PRESENT () {((1<<  &IEEE80211_RADIOTAP_FLAGS) | (1<<  &IEEE80211_RADIOTAP_RATE) | (1<<  &IEEE80211_RADIOTAP_CHANNEL));}' unless defined(&WI_TX_RADIOTAP_PRESENT);
}
1;
