require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CUSE_DEFS_H_)) {
    eval 'sub _CUSE_DEFS_H_ () {1;}' unless defined(&_CUSE_DEFS_H_);
    eval 'sub CUSE_VERSION () {0x123;}' unless defined(&CUSE_VERSION);
    eval 'sub CUSE_ERR_NONE () {0;}' unless defined(&CUSE_ERR_NONE);
    eval 'sub CUSE_ERR_BUSY () {-1;}' unless defined(&CUSE_ERR_BUSY);
    eval 'sub CUSE_ERR_WOULDBLOCK () {-2;}' unless defined(&CUSE_ERR_WOULDBLOCK);
    eval 'sub CUSE_ERR_INVALID () {-3;}' unless defined(&CUSE_ERR_INVALID);
    eval 'sub CUSE_ERR_NO_MEMORY () {-4;}' unless defined(&CUSE_ERR_NO_MEMORY);
    eval 'sub CUSE_ERR_FAULT () {-5;}' unless defined(&CUSE_ERR_FAULT);
    eval 'sub CUSE_ERR_SIGNAL () {-6;}' unless defined(&CUSE_ERR_SIGNAL);
    eval 'sub CUSE_ERR_OTHER () {-7;}' unless defined(&CUSE_ERR_OTHER);
    eval 'sub CUSE_ERR_NOT_LOADED () {-8;}' unless defined(&CUSE_ERR_NOT_LOADED);
    eval 'sub CUSE_ERR_NO_DEVICE () {-9;}' unless defined(&CUSE_ERR_NO_DEVICE);
    eval 'sub CUSE_POLL_NONE () {0;}' unless defined(&CUSE_POLL_NONE);
    eval 'sub CUSE_POLL_READ () {1;}' unless defined(&CUSE_POLL_READ);
    eval 'sub CUSE_POLL_WRITE () {2;}' unless defined(&CUSE_POLL_WRITE);
    eval 'sub CUSE_POLL_ERROR () {4;}' unless defined(&CUSE_POLL_ERROR);
    eval 'sub CUSE_FFLAG_NONE () {0;}' unless defined(&CUSE_FFLAG_NONE);
    eval 'sub CUSE_FFLAG_READ () {1;}' unless defined(&CUSE_FFLAG_READ);
    eval 'sub CUSE_FFLAG_WRITE () {2;}' unless defined(&CUSE_FFLAG_WRITE);
    eval 'sub CUSE_FFLAG_NONBLOCK () {4;}' unless defined(&CUSE_FFLAG_NONBLOCK);
    eval 'sub CUSE_DBG_NONE () {0;}' unless defined(&CUSE_DBG_NONE);
    eval 'sub CUSE_DBG_FULL () {1;}' unless defined(&CUSE_DBG_FULL);
    eval 'sub CUSE_LENGTH_MAX () {0x7fffffff;}' unless defined(&CUSE_LENGTH_MAX);
    eval("sub CUSE_CMD_NONE () { 0; }") unless defined(&CUSE_CMD_NONE);
    eval("sub CUSE_CMD_OPEN () { 1; }") unless defined(&CUSE_CMD_OPEN);
    eval("sub CUSE_CMD_CLOSE () { 2; }") unless defined(&CUSE_CMD_CLOSE);
    eval("sub CUSE_CMD_READ () { 3; }") unless defined(&CUSE_CMD_READ);
    eval("sub CUSE_CMD_WRITE () { 4; }") unless defined(&CUSE_CMD_WRITE);
    eval("sub CUSE_CMD_IOCTL () { 5; }") unless defined(&CUSE_CMD_IOCTL);
    eval("sub CUSE_CMD_POLL () { 6; }") unless defined(&CUSE_CMD_POLL);
    eval("sub CUSE_CMD_SIGNAL () { 7; }") unless defined(&CUSE_CMD_SIGNAL);
    eval("sub CUSE_CMD_SYNC () { 8; }") unless defined(&CUSE_CMD_SYNC);
    eval("sub CUSE_CMD_MAX () { 9; }") unless defined(&CUSE_CMD_MAX);
    eval 'sub CUSE_MAKE_ID {
        my($a,$b,$c,$u) = @_;
	    eval q((((($a) & 0x7f) << 24)| ((($b) & 0xff) << 16)|((($c) & 0xff) << 8)|(($u) & 0xff)));
    }' unless defined(&CUSE_MAKE_ID);
    eval 'sub CUSE_ID_MASK () {0x7fffff00;}' unless defined(&CUSE_ID_MASK);
    eval 'sub CUSE_ID_DEFAULT {
        my($what) = @_;
	    eval q( &CUSE_MAKE_ID(0,0,$what,0));
    }' unless defined(&CUSE_ID_DEFAULT);
    eval 'sub CUSE_ID_WEBCAMD {
        my($what) = @_;
	    eval q( &CUSE_MAKE_ID(ord(\'W\',\'C\'),$what,0));
    }' unless defined(&CUSE_ID_WEBCAMD);
    eval 'sub CUSE_ID_SUNDTEK {
        my($what) = @_;
	    eval q( &CUSE_MAKE_ID(ord(\'S\',\'K\'),$what,0));
    }' unless defined(&CUSE_ID_SUNDTEK);
    eval 'sub CUSE_ID_CX88 {
        my($what) = @_;
	    eval q( &CUSE_MAKE_ID(ord(\'C\',\'X\'),$what,0));
    }' unless defined(&CUSE_ID_CX88);
    eval 'sub CUSE_ID_UHIDD {
        my($what) = @_;
	    eval q( &CUSE_MAKE_ID(ord(\'U\',\'D\'),$what,0));
    }' unless defined(&CUSE_ID_UHIDD);
}
1;
