require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FS_DEVFS_DEVFS_H_)) {
    eval 'sub _FS_DEVFS_DEVFS_H_ () {1;}' unless defined(&_FS_DEVFS_DEVFS_H_);
    eval 'sub DEVFS_MAGIC () {0xdb0a087a;}' unless defined(&DEVFS_MAGIC);
    eval 'sub rid2rsn {
        my($rid) = @_;
	    eval q((($rid) >> 16));
    }' unless defined(&rid2rsn);
    eval 'sub rid2rn {
        my($rid) = @_;
	    eval q((($rid) & 0xffff));
    }' unless defined(&rid2rn);
    eval 'sub mkrid {
        my($rsn, $rn) = @_;
	    eval q((($rn) | (($rsn) << 16)));
    }' unless defined(&mkrid);
    eval 'sub DRC_DSWFLAGS () {0x1;}' unless defined(&DRC_DSWFLAGS);
    eval 'sub DRC_PATHPTRN () {0x2;}' unless defined(&DRC_PATHPTRN);
    eval 'sub DEVFS_MAXPTRNLEN () {200;}' unless defined(&DEVFS_MAXPTRNLEN);
    eval 'sub DRA_BACTS () {0x1;}' unless defined(&DRA_BACTS);
    eval 'sub DRA_UID () {0x2;}' unless defined(&DRA_UID);
    eval 'sub DRA_GID () {0x4;}' unless defined(&DRA_GID);
    eval 'sub DRA_MODE () {0x8;}' unless defined(&DRA_MODE);
    eval 'sub DRA_INCSET () {0x10;}' unless defined(&DRA_INCSET);
    eval 'sub DRB_HIDE () {0x1;}' unless defined(&DRB_HIDE);
    eval 'sub DRB_UNHIDE () {0x2;}' unless defined(&DRB_UNHIDE);
    eval 'sub DEVFSIO_RADD () { &_IOWR(ord(\'D\'), 0, \'struct devfs_rule\');}' unless defined(&DEVFSIO_RADD);
    eval 'sub DEVFSIO_RDEL () { &_IOW(ord(\'D\'), 1,  &devfs_rid);}' unless defined(&DEVFSIO_RDEL);
    eval 'sub DEVFSIO_RAPPLY () { &_IOW(ord(\'D\'), 2, \'struct devfs_rule\');}' unless defined(&DEVFSIO_RAPPLY);
    eval 'sub DEVFSIO_RAPPLYID () { &_IOW(ord(\'D\'), 3,  &devfs_rid);}' unless defined(&DEVFSIO_RAPPLYID);
    eval 'sub DEVFSIO_RGETNEXT () { &_IOWR(ord(\'D\'), 4, \'struct devfs_rule\');}' unless defined(&DEVFSIO_RGETNEXT);
    eval 'sub DEVFSIO_SUSE () { &_IOW(ord(\'D\'), 10,  &devfs_rsnum);}' unless defined(&DEVFSIO_SUSE);
    eval 'sub DEVFSIO_SAPPLY () { &_IOW(ord(\'D\'), 11,  &devfs_rsnum);}' unless defined(&DEVFSIO_SAPPLY);
    eval 'sub DEVFSIO_SGETNEXT () { &_IOWR(ord(\'D\'), 12,  &devfs_rsnum);}' unless defined(&DEVFSIO_SGETNEXT);
    if(defined(&_KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
	eval 'sub DE_WHITEOUT () {0x1;}' unless defined(&DE_WHITEOUT);
	eval 'sub DE_DOT () {0x2;}' unless defined(&DE_DOT);
	eval 'sub DE_DOTDOT () {0x4;}' unless defined(&DE_DOTDOT);
	eval 'sub DE_DOOMED () {0x8;}' unless defined(&DE_DOOMED);
	eval 'sub DE_COVERED () {0x10;}' unless defined(&DE_COVERED);
	eval 'sub DE_USER () {0x20;}' unless defined(&DE_USER);
	eval 'sub DEVFS_ROOTINO () {2;}' unless defined(&DEVFS_ROOTINO);
	eval 'sub VFSTODEVFS {
	    my($mp) = @_;
    	    eval q(((($mp)-> &mnt_data)));
	}' unless defined(&VFSTODEVFS);
	eval 'sub DEVFS_DE_HOLD {
	    my($de) = @_;
    	    eval q((($de)-> &de_holdcnt++));
	}' unless defined(&DEVFS_DE_HOLD);
	eval 'sub DEVFS_DE_DROP {
	    my($de) = @_;
    	    eval q((--($de)-> &de_holdcnt == 0));
	}' unless defined(&DEVFS_DE_DROP);
	eval 'sub DEVFS_DMP_HOLD {
	    my($dmp) = @_;
    	    eval q((($dmp)-> &dm_holdcnt++));
	}' unless defined(&DEVFS_DMP_HOLD);
	eval 'sub DEVFS_DMP_DROP {
	    my($dmp) = @_;
    	    eval q((--($dmp)-> &dm_holdcnt == 0));
	}' unless defined(&DEVFS_DMP_DROP);
	eval 'sub DEVFS_DEL_VNLOCKED () {0x1;}' unless defined(&DEVFS_DEL_VNLOCKED);
	eval 'sub DEVFS_DEL_NORECURSE () {0x2;}' unless defined(&DEVFS_DEL_NORECURSE);
    }
}
1;
