require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FS_MSDOSFS_BPB_H_)) {
    eval 'sub _FS_MSDOSFS_BPB_H_ () {1;}' unless defined(&_FS_MSDOSFS_BPB_H_);
    eval 'sub FATNUM () {0xf;}' unless defined(&FATNUM);
    eval 'sub FATMIRROR () {0x80;}' unless defined(&FATMIRROR);
    eval 'sub FSVERS () {0;}' unless defined(&FSVERS);
    require 'sys/endian.ph';
    eval 'sub getushort {
        my($x) = @_;
	    eval q( &le16dec($x));
    }' unless defined(&getushort);
    eval 'sub getulong {
        my($x) = @_;
	    eval q( &le32dec($x));
    }' unless defined(&getulong);
    eval 'sub putushort {
        my($p, $v) = @_;
	    eval q( &le16enc($p, $v));
    }' unless defined(&putushort);
    eval 'sub putulong {
        my($p, $v) = @_;
	    eval q( &le32enc($p, $v));
    }' unless defined(&putulong);
}
1;
