require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FS_NANDFS_NANDFS_SUBR_H_)) {
    eval 'sub _FS_NANDFS_NANDFS_SUBR_H_ () {1;}' unless defined(&_FS_NANDFS_NANDFS_SUBR_H_);
    eval 'sub NANDFS_VBLK_ASSIGNED () {1;}' unless defined(&NANDFS_VBLK_ASSIGNED);
    eval 'sub NANDFS_IS_INDIRECT {
        my($bp) = @_;
	    eval q((($bp)-> &b_lblkno < 0));
    }' unless defined(&NANDFS_IS_INDIRECT);
    eval 'sub NANDFS_VOP_ISLOCKED {
        my($vp) = @_;
	    eval q( &nandfs_vop_islocked(($vp)));
    }' unless defined(&NANDFS_VOP_ISLOCKED);
    eval 'sub DEBUG_MODE () {1;}' unless defined(&DEBUG_MODE);
    if(defined(&DEBUG_MODE)) {
	eval 'sub nandfs_error () { &panic;}' unless defined(&nandfs_error);
	eval 'sub nandfs_warning () { &printf;}' unless defined(&nandfs_warning);
    }
 elsif(defined(&TEST_MODE)) {
	eval 'sub nandfs_error () { &printf;}' unless defined(&nandfs_error);
	eval 'sub nandfs_warning () { &printf;}' unless defined(&nandfs_warning);
    } else {
	eval 'sub nandfs_error () {(...);}' unless defined(&nandfs_error);
	eval 'sub nandfs_warning () {(...);}' unless defined(&nandfs_warning);
    }
}
1;
