require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFS_NFSM_SUBS_H_)) {
    eval 'sub _NFS_NFSM_SUBS_H_ () {1;}' unless defined(&_NFS_NFSM_SUBS_H_);
    unless(defined(&APPLE)) {
	eval 'sub NFSM_DATAP {
	    my($m, $s) = @_;
    	    eval q(($m)-> &m_data += ($s));
	}' unless defined(&NFSM_DATAP);
	eval 'sub NFSM_BUILD {
	    my($a, $c, $s) = @_;
    	    eval q((($a) = ($c) &nfsm_build( &nd, ($s))));
	}' unless defined(&NFSM_BUILD);
	eval 'sub nfsm_dissect {
	    my($nd,$siz) = @_;
    	    eval q({ \'int\'  &tt1;  &void * &retp;  &tt1 =  &NFSMTOD( ($nd->{nd_md}), \'caddr_t\') +  ($nd->{nd_md}->{m_len}) -  ($nd->{nd_dpos});  &if ( &tt1 >= $siz) {  &retp = ( &void *) ($nd->{nd_dpos});  ($nd->{nd_dpos}) += $siz; }  &else {  &retp =  &nfsm_dissct($nd, $siz,  &M_WAITOK); } ( &retp); });
	}' unless defined(&nfsm_dissect);
	eval 'sub nfsm_dissect_nonblock {
	    my($nd,$siz) = @_;
    	    eval q({ \'int\'  &tt1;  &void * &retp;  &tt1 =  &NFSMTOD( ($nd->{nd_md}), \'caddr_t\') +  ($nd->{nd_md}->{m_len}) -  ($nd->{nd_dpos});  &if ( &tt1 >= $siz) {  &retp = ( &void *) ($nd->{nd_dpos});  ($nd->{nd_dpos}) += $siz; }  &else {  &retp =  &nfsm_dissct($nd, $siz,  &M_NOWAIT); } ( &retp); });
	}' unless defined(&nfsm_dissect_nonblock);
	eval 'sub NFSM_DISSECT {
	    my($a, $c, $s) = @_;
    	    eval q( &do { ($a) = ($c) &nfsm_dissect( &nd, ($s));  &if (($a) ==  &NULL) {  &error =  &EBADRPC;  &goto  &nfsmout; } }  &while (0));
	}' unless defined(&NFSM_DISSECT);
	eval 'sub NFSM_DISSECT_NONBLOCK {
	    my($a, $c, $s) = @_;
    	    eval q( &do { ($a) = ($c) &nfsm_dissect_nonblock( &nd, ($s));  &if (($a) ==  &NULL) {  &error =  &EBADRPC;  &goto  &nfsmout; } }  &while (0));
	}' unless defined(&NFSM_DISSECT_NONBLOCK);
    }
    eval 'sub NFSM_STRSIZ {
        my($s, $m) = @_;
	    eval q( &do {  &tl = ( &u_int32_t *) &nfsm_dissect( &nd,  &NFSX_UNSIGNED);  &if (! &tl || (($s) =  &fxdr_unsigned( &int32_t, * &tl)) > ($m)) {  &error =  &EBADRPC;  &goto  &nfsmout; } }  &while (0));
    }' unless defined(&NFSM_STRSIZ);
    eval 'sub NFSM_RNDUP {
        my($a) = @_;
	    eval q(((($a)+3)(~0x3)));
    }' unless defined(&NFSM_RNDUP);
}
1;
