require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFS_NFSRVCACHE_H_)) {
    eval 'sub _NFS_NFSRVCACHE_H_ () {1;}' unless defined(&_NFS_NFSRVCACHE_H_);
    eval 'sub NFSRVCACHE_MAX_SIZE () {2048;}' unless defined(&NFSRVCACHE_MAX_SIZE);
    eval 'sub NFSRVCACHE_MIN_SIZE () {64;}' unless defined(&NFSRVCACHE_MIN_SIZE);
    eval 'sub NFSRVCACHE_HASHSIZE () {500;}' unless defined(&NFSRVCACHE_HASHSIZE);
    eval 'sub rc_reply () { ($rc_un->{repmb});}' unless defined(&rc_reply);
    eval 'sub rc_status () { ($rc_un->{repstat});}' unless defined(&rc_status);
    eval 'sub rc_inet () { ($rc_un2->{udp}->{haddr}->{had_inet}->{s_addr});}' unless defined(&rc_inet);
    eval 'sub rc_inet6 () { ($rc_un2->{udp}->{haddr}->{had_inet6});}' unless defined(&rc_inet6);
    eval 'sub rc_haddr () { ($rc_un2->{udp}->{haddr});}' unless defined(&rc_haddr);
    eval 'sub rc_sockref () { ($rc_un2->{ot}->{sockref});}' unless defined(&rc_sockref);
    eval 'sub rc_tcpseq () { ($rc_un2->{ot}->{tcpseq});}' unless defined(&rc_tcpseq);
    eval 'sub rc_refcnt () { ($rc_un2->{ot}->{refcnt});}' unless defined(&rc_refcnt);
    eval 'sub rc_reqlen () { ($rc_un2->{ot}->{len});}' unless defined(&rc_reqlen);
    eval 'sub rc_cksum () { ($rc_un2->{ot}->{cksum});}' unless defined(&rc_cksum);
    eval 'sub rc_cachetime () { ($rc_un2->{ot}->{cachetime});}' unless defined(&rc_cachetime);
    eval 'sub rc_acked () { ($rc_un2->{ot}->{acked});}' unless defined(&rc_acked);
    eval 'sub RC_NO_SEQ () {0;}' unless defined(&RC_NO_SEQ);
    eval 'sub RC_NO_ACK () {1;}' unless defined(&RC_NO_ACK);
    eval 'sub RC_ACK () {2;}' unless defined(&RC_ACK);
    eval 'sub RC_NACK () {3;}' unless defined(&RC_NACK);
    eval 'sub RC_DROPIT () {0;}' unless defined(&RC_DROPIT);
    eval 'sub RC_REPLY () {1;}' unless defined(&RC_REPLY);
    eval 'sub RC_DOIT () {2;}' unless defined(&RC_DOIT);
    eval 'sub RC_LOCKED () {0x1;}' unless defined(&RC_LOCKED);
    eval 'sub RC_WANTED () {0x2;}' unless defined(&RC_WANTED);
    eval 'sub RC_REPSTATUS () {0x4;}' unless defined(&RC_REPSTATUS);
    eval 'sub RC_REPMBUF () {0x8;}' unless defined(&RC_REPMBUF);
    eval 'sub RC_UDP () {0x10;}' unless defined(&RC_UDP);
    eval 'sub RC_INETIPV6 () {0x20;}' unless defined(&RC_INETIPV6);
    eval 'sub RC_INPROG () {0x40;}' unless defined(&RC_INPROG);
    eval 'sub RC_NFSV2 () {0x100;}' unless defined(&RC_NFSV2);
    eval 'sub RC_NFSV3 () {0x200;}' unless defined(&RC_NFSV3);
    eval 'sub RC_NFSV4 () {0x400;}' unless defined(&RC_NFSV4);
    eval 'sub RC_NFSVERS () {( &RC_NFSV2 |  &RC_NFSV3 |  &RC_NFSV4);}' unless defined(&RC_NFSVERS);
    eval 'sub RC_REFCNT () {0x800;}' unless defined(&RC_REFCNT);
    eval 'sub RC_SAMETCPCONN () {0x1000;}' unless defined(&RC_SAMETCPCONN);
}
1;
