require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFS_NFSRVSTATE_H_)) {
    eval 'sub _NFS_NFSRVSTATE_H_ () {1;}' unless defined(&_NFS_NFSRVSTATE_H_);
    eval 'sub NFSCLIENTHASH {
        my($id) = @_;
	    eval q(( $nfsclienthash[($id). $lval[1] %  &nfsrv_clienthashsize]));
    }' unless defined(&NFSCLIENTHASH);
    eval 'sub NFSSTATEHASH {
        my($clp, $id) = @_;
	    eval q(((($clp)-> $lc_stateid[($id). $other[2] %  &nfsrv_statehashsize])));
    }' unless defined(&NFSSTATEHASH);
    eval 'sub NFSUSERHASH {
        my($id) = @_;
	    eval q(( $nfsuserhash[($id) %  &nfsrv_lughashsize]));
    }' unless defined(&NFSUSERHASH);
    eval 'sub NFSUSERNAMEHASH {
        my($p, $l) = @_;
	    eval q(( $nfsusernamehash[(($l)>=4?(*($p)+*(($p)+1)+*(($p)+2)+*(($p)+3)):*($p)) %  &nfsrv_lughashsize]));
    }' unless defined(&NFSUSERNAMEHASH);
    eval 'sub NFSGROUPHASH {
        my($id) = @_;
	    eval q(( $nfsgrouphash[($id) %  &nfsrv_lughashsize]));
    }' unless defined(&NFSGROUPHASH);
    eval 'sub NFSGROUPNAMEHASH {
        my($p, $l) = @_;
	    eval q(( $nfsgroupnamehash[(($l)>=4?(*($p)+*(($p)+1)+*(($p)+2)+*(($p)+3)):*($p)) %  &nfsrv_lughashsize]));
    }' unless defined(&NFSGROUPNAMEHASH);
    eval 'sub NFSSESSIONHASH {
        my($f) = @_;
	    eval q(( $nfssessionhash[ &nfsrv_hashsessionid($f) %  &nfsrv_sessionhashsize]));
    }' unless defined(&NFSSESSIONHASH);
    eval 'sub CLOPS_CONFIRM () {0x1;}' unless defined(&CLOPS_CONFIRM);
    eval 'sub CLOPS_RENEW () {0x2;}' unless defined(&CLOPS_RENEW);
    eval 'sub CLOPS_RENEWOP () {0x4;}' unless defined(&CLOPS_RENEWOP);
    eval 'sub ls_lock () { ($ls_head->{lock});}' unless defined(&ls_lock);
    eval 'sub ls_open () { ($ls_head->{open});}' unless defined(&ls_open);
    eval 'sub ls_opentolockseq () { ($ls_un->{opentolockseq});}' unless defined(&ls_opentolockseq);
    eval 'sub ls_openowner () { ($ls_un->{openowner});}' unless defined(&ls_openowner);
    eval 'sub ls_openstp () { ($ls_un->{openowner});}' unless defined(&ls_openstp);
    eval 'sub ls_noopens () { ($ls_un->{noopens});}' unless defined(&ls_noopens);
    eval 'sub ls_filerev () { ($ls_un->{deleg}->{filerev});}' unless defined(&ls_filerev);
    eval 'sub ls_delegtime () { ($ls_un->{deleg}->{expiry});}' unless defined(&ls_delegtime);
    eval 'sub ls_delegtimelimit () { ($ls_un->{deleg}->{limit});}' unless defined(&ls_delegtimelimit);
    eval 'sub ls_compref () { ($ls_un->{deleg}->{compref});}' unless defined(&ls_compref);
    eval 'sub lug_uid () { ($lug_un->{un_uid});}' unless defined(&lug_uid);
    eval 'sub lug_gid () { ($lug_un->{un_gid});}' unless defined(&lug_gid);
    if(defined(&_KERNEL) || defined(&KERNEL)) {
    }
}
1;
