require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FS_SMBFS_NODE_H_)) {
    eval 'sub _FS_SMBFS_NODE_H_ () {1;}' unless defined(&_FS_SMBFS_NODE_H_);
    eval 'sub SMBFS_ROOT_INO () {2;}' unless defined(&SMBFS_ROOT_INO);
    eval 'sub NFLUSHINPROG () {0x1;}' unless defined(&NFLUSHINPROG);
    eval 'sub NFLUSHWANT () {0x2;}' unless defined(&NFLUSHWANT);
    eval 'sub NMODIFIED () {0x4;}' unless defined(&NMODIFIED);
    eval 'sub NREFPARENT () {0x10;}' unless defined(&NREFPARENT);
    eval 'sub NFLUSHWIRE () {0x1000;}' unless defined(&NFLUSHWIRE);
    eval 'sub NOPEN () {0x2000;}' unless defined(&NOPEN);
    eval 'sub NGONE () {0x4000;}' unless defined(&NGONE);
    eval 'sub VTOSMB {
        my($vp) = @_;
	    eval q((($vp)-> &v_data));
    }' unless defined(&VTOSMB);
    eval 'sub SMBTOV {
        my($np) = @_;
	    eval q((($np)-> &n_vnode));
    }' unless defined(&SMBTOV);
    eval 'sub SMBFS_DNP_SEP {
        my($dnp) = @_;
	    eval q((( ($dnp->{n_rplen}) > 1) ? ord(\'\\\\\\\\\' : \'\\\\0\')));
    }' unless defined(&SMBFS_DNP_SEP);
    eval 'sub smbfs_attr_cacheremove {
        my($vp) = @_;
	    eval q( &VTOSMB($vp)-> &n_attrage = 0);
    }' unless defined(&smbfs_attr_cacheremove);
}
1;
