require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_GEOM_GEOM_DISK_H_)) {
    eval 'sub _GEOM_GEOM_DISK_H_ () {1;}' unless defined(&_GEOM_GEOM_DISK_H_);
    eval 'sub DISK_RR_UNKNOWN () {0;}' unless defined(&DISK_RR_UNKNOWN);
    eval 'sub DISK_RR_NON_ROTATING () {1;}' unless defined(&DISK_RR_NON_ROTATING);
    eval 'sub DISK_RR_MIN () {0x401;}' unless defined(&DISK_RR_MIN);
    eval 'sub DISK_RR_MAX () {0xfffe;}' unless defined(&DISK_RR_MAX);
    if(defined(&_KERNEL)) {
	require 'sys/queue.ph';
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
	require 'sys/disk.ph';
	eval 'sub G_DISK_CLASS_NAME () {"DISK";}' unless defined(&G_DISK_CLASS_NAME);
	eval("sub DISK_INIT_NONE () { 0; }") unless defined(&DISK_INIT_NONE);
	eval("sub DISK_INIT_START () { 1; }") unless defined(&DISK_INIT_START);
	eval("sub DISK_INIT_DONE () { 2; }") unless defined(&DISK_INIT_DONE);
	eval 'sub DISKFLAG_RESERVED () {0x1;}' unless defined(&DISKFLAG_RESERVED);
	eval 'sub DISKFLAG_OPEN () {0x2;}' unless defined(&DISKFLAG_OPEN);
	eval 'sub DISKFLAG_CANDELETE () {0x4;}' unless defined(&DISKFLAG_CANDELETE);
	eval 'sub DISKFLAG_CANFLUSHCACHE () {0x8;}' unless defined(&DISKFLAG_CANFLUSHCACHE);
	eval 'sub DISKFLAG_UNMAPPED_BIO () {0x10;}' unless defined(&DISKFLAG_UNMAPPED_BIO);
	eval 'sub DISKFLAG_DIRECT_COMPLETION () {0x20;}' unless defined(&DISKFLAG_DIRECT_COMPLETION);
	eval 'sub DISKFLAG_CANZONE () {0x80;}' unless defined(&DISKFLAG_CANZONE);
	eval 'sub DISKFLAG_WRITE_PROTECT () {0x100;}' unless defined(&DISKFLAG_WRITE_PROTECT);
	eval 'sub DISK_VERSION_00 () {0x58561059;}' unless defined(&DISK_VERSION_00);
	eval 'sub DISK_VERSION_01 () {0x5856105a;}' unless defined(&DISK_VERSION_01);
	eval 'sub DISK_VERSION_02 () {0x5856105b;}' unless defined(&DISK_VERSION_02);
	eval 'sub DISK_VERSION_03 () {0x5856105c;}' unless defined(&DISK_VERSION_03);
	eval 'sub DISK_VERSION_04 () {0x5856105d;}' unless defined(&DISK_VERSION_04);
	eval 'sub DISK_VERSION_05 () {0x5856105e;}' unless defined(&DISK_VERSION_05);
	eval 'sub DISK_VERSION () { &DISK_VERSION_05;}' unless defined(&DISK_VERSION);
    }
}
1;
