require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_G_JOURNAL_H_)) {
    eval 'sub _G_JOURNAL_H_ () {1;}' unless defined(&_G_JOURNAL_H_);
    require 'sys/endian.ph';
    require 'sys/md5.ph';
    if(defined(&_KERNEL)) {
	require 'sys/bio.ph';
    }
    eval 'sub G_JOURNAL_CLASS_NAME () {"JOURNAL";}' unless defined(&G_JOURNAL_CLASS_NAME);
    eval 'sub G_JOURNAL_MAGIC () {"GEOM::JOURNAL";}' unless defined(&G_JOURNAL_MAGIC);
    eval 'sub G_JOURNAL_VERSION () {0;}' unless defined(&G_JOURNAL_VERSION);
    if(defined(&_KERNEL)) {
	eval 'sub GJ_DEBUG () {( &lvl, ...)  &do {  &if ( &g_journal_debug >= ( &lvl)) {  &printf("GEOM_JOURNAL");  &if ( &g_journal_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf("\\n"); } }  &while (0);}' unless defined(&GJ_DEBUG);
	eval 'sub GJ_LOGREQ () {( &lvl,  &bp, ...)  &do {  &if ( &g_journal_debug >= ( &lvl)) {  &printf("GEOM_JOURNAL");  &if ( &g_journal_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf(" ");  &g_print_bio( &bp);  &printf("\\n"); } }  &while (0);}' unless defined(&GJ_LOGREQ);
	eval 'sub JEMPTY {
	    my($sc) = @_;
    	    eval q((($sc)-> &sc_journal_offset - ($sc)-> ($sc_jprovider->{sectorsize}) == ($sc)-> ($sc_active->{jj_offset})  && ($sc)-> &sc_current_count == 0));
	}' unless defined(&JEMPTY);
	eval 'sub GJ_BIO_REGULAR () {0x;}' unless defined(&GJ_BIO_REGULAR);
	eval 'sub GJ_BIO_READ () {0x1;}' unless defined(&GJ_BIO_READ);
	eval 'sub GJ_BIO_JOURNAL () {0x2;}' unless defined(&GJ_BIO_JOURNAL);
	eval 'sub GJ_BIO_COPY () {0x3;}' unless defined(&GJ_BIO_COPY);
	eval 'sub GJ_BIO_MASK () {0xf;}' unless defined(&GJ_BIO_MASK);
	if(0) {
	    eval 'sub GJF_BIO_DONT_FREE () {0x10;}' unless defined(&GJF_BIO_DONT_FREE);
	    eval 'sub GJF_BIO_MASK () {0xf0;}' unless defined(&GJF_BIO_MASK);
	}
	eval 'sub GJF_DEVICE_HARDCODED () {0x1;}' unless defined(&GJF_DEVICE_HARDCODED);
	eval 'sub GJF_DEVICE_DESTROY () {0x10;}' unless defined(&GJF_DEVICE_DESTROY);
	eval 'sub GJF_DEVICE_SWITCH () {0x20;}' unless defined(&GJF_DEVICE_SWITCH);
	eval 'sub GJF_DEVICE_BEFORE_SWITCH () {0x40;}' unless defined(&GJF_DEVICE_BEFORE_SWITCH);
	eval 'sub GJF_DEVICE_CLEAN () {0x80;}' unless defined(&GJF_DEVICE_CLEAN);
	eval 'sub GJF_DEVICE_CHECKSUM () {0x100;}' unless defined(&GJF_DEVICE_CHECKSUM);
	eval 'sub GJ_HARD_LIMIT () {64;}' unless defined(&GJ_HARD_LIMIT);
	eval 'sub bio_joffset () { &bio_completed;}' unless defined(&bio_joffset);
	eval 'sub bio_next () { &bio_caller1;}' unless defined(&bio_next);
	eval 'sub GJ_FLUSH_DATA () {0x1;}' unless defined(&GJ_FLUSH_DATA);
	eval 'sub GJ_FLUSH_JOURNAL () {0x2;}' unless defined(&GJ_FLUSH_JOURNAL);
	eval 'sub sc_dprovider () { ($sc_dconsumer->{provider});}' unless defined(&sc_dprovider);
	eval 'sub sc_jprovider () { ($sc_jconsumer->{provider});}' unless defined(&sc_jprovider);
	eval 'sub sc_name () { ($sc_dprovider->{name});}' unless defined(&sc_name);
	eval 'sub GJQ_INSERT_HEAD {
	    my($head, $bp) = @_;
    	    eval q( &do { ($bp)-> &bio_next = ($head); ($head) = ($bp); }  &while (0));
	}' unless defined(&GJQ_INSERT_HEAD);
	eval 'sub GJQ_INSERT_AFTER {
	    my($head, $bp, $pbp) = @_;
    	    eval q( &do {  &if (($pbp) ==  &NULL)  &GJQ_INSERT_HEAD($head, $bp);  &else { ($bp)-> &bio_next = ($pbp)-> &bio_next; ($pbp)-> &bio_next = ($bp); } }  &while (0));
	}' unless defined(&GJQ_INSERT_AFTER);
	eval 'sub GJQ_LAST {
	    my($head, $bp) = @_;
    	    eval q( &do { \'struct bio\' * &_bp;  &if (($head) ==  &NULL) { ($bp) = ($head);  &break; }  &for ( &_bp = ($head);  ($_$bp->{bio_next}) !=  &NULL;  &_bp =  ($_$bp->{bio_next}))  &continue; ($bp) = ( &_bp); }  &while (0));
	}' unless defined(&GJQ_LAST);
	eval 'sub GJQ_FIRST {
	    my($head) = @_;
    	    eval q(($head));
	}' unless defined(&GJQ_FIRST);
	eval 'sub GJQ_REMOVE {
	    my($head, $bp) = @_;
    	    eval q( &do { \'struct bio\' * &_bp;  &if (($head) == ($bp)) { ($head) = ($bp)-> &bio_next; ($bp)-> &bio_next =  &NULL;  &break; }  &for ( &_bp = ($head);  ($_$bp->{bio_next}) !=  &NULL;  &_bp =  ($_$bp->{bio_next})) {  &if ( ($_$bp->{bio_next}) == ($bp))  &break; }  &KASSERT( ($_$bp->{bio_next}) !=  &NULL, (\\"NULL bio_next\\"));  &KASSERT( ($_$bp->{bio_next}) == ($bp), (\\"bio_next != bp\\"));  ($_$bp->{bio_next}) = ($bp)-> &bio_next; ($bp)-> &bio_next =  &NULL; }  &while (0));
	}' unless defined(&GJQ_REMOVE);
	eval 'sub GJQ_FOREACH {
	    my($head, $bp) = @_;
    	    eval q( &for (($bp) = ($head); ($bp) !=  &NULL; ($bp) = ($bp)-> &bio_next));
	}' unless defined(&GJQ_FOREACH);
	eval 'sub GJ_HEADER_MAGIC () {"GJHDR";}' unless defined(&GJ_HEADER_MAGIC);
	eval 'sub GJ_RECORD_HEADER_MAGIC () {"GJRHDR";}' unless defined(&GJ_RECORD_HEADER_MAGIC);
	eval 'sub GJ_RECORD_HEADER_NENTRIES () {(20);}' unless defined(&GJ_RECORD_HEADER_NENTRIES);
	eval 'sub GJ_RECORD_MAX_SIZE {
	    my($sc) = @_;
    	    eval q((($sc)-> ($sc_jprovider->{sectorsize}) +  &GJ_RECORD_HEADER_NENTRIES *  &MAXPHYS));
	}' unless defined(&GJ_RECORD_MAX_SIZE);
	eval 'sub GJ_VALIDATE_OFFSET {
	    my($offset, $sc) = @_;
    	    eval q( &do {  &if (($offset) +  &GJ_RECORD_MAX_SIZE($sc) >= ($sc)-> &sc_jend) { ($offset) = ($sc)-> &sc_jstart;  &GJ_DEBUG(2, \\"Starting from the beginning (%s).\\", ($sc)-> &sc_name); } }  &while (0));
	}' unless defined(&GJ_VALIDATE_OFFSET);
	eval 'sub GJ_TIMER_START {
	    my($lvl, $bt) = @_;
    	    eval q( &do {  &if ( &g_journal_debug >= ($lvl))  &binuptime($bt); }  &while (0));
	}' unless defined(&GJ_TIMER_START);
	eval 'sub GJ_TIMER_STOP () {( &lvl,  &bt, ...)  &do {  &if ( &g_journal_debug >= ( &lvl)) { \'struct bintime\'  &_bt2; \'struct timeval\'  &_tv;  &binuptime(& &_bt2);  &bintime_sub(& &_bt2,  &bt);  &bintime2timeval(& &_bt2, & &_tv);  &printf("GEOM_JOURNAL");  &if ( &g_journal_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf(": %jd.%06jds\\n", ( &intmax_t) ($_tv->{tv_sec}), ( &intmax_t) ($_tv->{tv_usec})); } }  &while (0);}' unless defined(&GJ_TIMER_STOP);
    }
    eval 'sub GJ_TYPE_DATA () {0x1;}' unless defined(&GJ_TYPE_DATA);
    eval 'sub GJ_TYPE_JOURNAL () {0x2;}' unless defined(&GJ_TYPE_JOURNAL);
    eval 'sub GJ_TYPE_COMPLETE () {( &GJ_TYPE_DATA| &GJ_TYPE_JOURNAL);}' unless defined(&GJ_TYPE_COMPLETE);
    eval 'sub GJ_FLAG_CLEAN () {0x1;}' unless defined(&GJ_FLAG_CLEAN);
    eval 'sub GJ_FLAG_CHECKSUM () {0x2;}' unless defined(&GJ_FLAG_CHECKSUM);
    eval 'sub journal_metadata_encode {
        my($md,$data) = @_;
	    eval q({  &MD5_CTX  &ctx;  &bcopy( ($md->{md_magic}), $data, 16);  &le32enc($data + 16,  ($md->{md_version}));  &le32enc($data + 20,  ($md->{md_id})); *($data + 24) =  ($md->{md_type});  &le64enc($data + 25,  ($md->{md_jstart}));  &le64enc($data + 33,  ($md->{md_jend}));  &le64enc($data + 41,  ($md->{md_joffset}));  &le32enc($data + 49,  ($md->{md_jid}));  &le64enc($data + 53,  ($md->{md_flags}));  &bcopy( ($md->{md_provider}), $data + 61, 16);  &le64enc($data + 77,  ($md->{md_provsize}));  &MD5Init( &ctx);  &MD5Update( &ctx, $data, 85);  &MD5Final( ($md->{md_hash}),  &ctx);  &bcopy( ($md->{md_hash}), $data + 85, 16); });
    }' unless defined(&journal_metadata_encode);
    eval 'sub journal_metadata_decode_v0 {
        my($data,$md) = @_;
	    eval q({  &MD5_CTX  &ctx;  ($md->{md_id}) =  &le32dec($data + 20);  ($md->{md_type}) = *($data + 24);  ($md->{md_jstart}) =  &le64dec($data + 25);  ($md->{md_jend}) =  &le64dec($data + 33);  ($md->{md_joffset}) =  &le64dec($data + 41);  ($md->{md_jid}) =  &le32dec($data + 49);  ($md->{md_flags}) =  &le64dec($data + 53);  &bcopy($data + 61,  ($md->{md_provider}), 16);  ($md->{md_provsize}) =  &le64dec($data + 77);  &MD5Init( &ctx);  &MD5Update( &ctx, $data, 85);  &MD5Final( ($md->{md_hash}),  &ctx);  &if ( &bcmp( ($md->{md_hash}), $data + 85, 16) != 0) ( &EINVAL); (0); });
    }' unless defined(&journal_metadata_decode_v0);
    eval 'sub journal_metadata_decode {
        my($data,$md) = @_;
	    eval q({ \'int\'  &error;  &bcopy($data,  ($md->{md_magic}), 16);  ($md->{md_version}) =  &le32dec($data + 16);  &switch ( ($md->{md_version})) {  &case 0:  &error =  &journal_metadata_decode_v0($data, $md);  &break;  &default:  &error =  &EINVAL;  &break; } ( &error); });
    }' unless defined(&journal_metadata_decode);
    eval 'sub journal_metadata_dump {
        my($md) = @_;
	    eval q({  &const \'char\'  $hex[] = \\"0123456789abcdef\\"; \'char\'  $hash[16* 2+ 1]; \'u_int\'  &i;  &printf(\\"     magic: %s\\\\n\\",  ($md->{md_magic}));  &printf(\\"   version: %u\\\\n\\",  ($md->{md_version}));  &printf(\\"	id: %u\\\\n\\",  ($md->{md_id}));  &printf(\\"      type: %u\\\\n\\",  ($md->{md_type}));  &printf(\\"     start: %ju\\\\n\\", ( &uintmax_t) ($md->{md_jstart}));  &printf(\\"       end: %ju\\\\n\\", ( &uintmax_t) ($md->{md_jend}));  &printf(\\"   joffset: %ju\\\\n\\", ( &uintmax_t) ($md->{md_joffset}));  &printf(\\"       jid: %u\\\\n\\",  ($md->{md_jid}));  &printf(\\"     flags: %u\\\\n\\",  ($md->{md_flags}));  &printf(\\"hcprovider: %s\\\\n\\",  ($md->{md_provider}));  &printf(\\"  provsize: %ju\\\\n\\", ( &uintmax_t) ($md->{md_provsize}));  &bzero( &hash, $sizeof{ &hash});  &for ( &i = 0;  &i < 16;  &i++) {  $hash[ &i * 2] =  $hex[ ($md->{md_hash[&i]}) >> 4];  $hash[ &i * 2+ 1] =  $hex[ ($md->{md_hash[&i]}) & 0xf]; }  &printf(\\"  MD5 hash: %s\\\\n\\",  &hash); });
    }' unless defined(&journal_metadata_dump);
}
1;
