require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_G_LABEL_H_)) {
    eval 'sub _G_LABEL_H_ () {1;}' unless defined(&_G_LABEL_H_);
    require 'sys/endian.ph';
    if(defined(&_KERNEL)) {
	require 'sys/sysctl.ph';
    }
    eval 'sub G_LABEL_CLASS_NAME () {"LABEL";}' unless defined(&G_LABEL_CLASS_NAME);
    eval 'sub G_LABEL_MAGIC () {"GEOM::LABEL";}' unless defined(&G_LABEL_MAGIC);
    eval 'sub G_LABEL_VERSION () {2;}' unless defined(&G_LABEL_VERSION);
    eval 'sub G_LABEL_DIR () {"label";}' unless defined(&G_LABEL_DIR);
    if(defined(&_KERNEL)) {
	eval 'sub G_LABEL_DEBUG () {( &lvl, ...)  &do {  &if ( &g_label_debug >= ( &lvl)) {  &printf("GEOM_LABEL");  &if ( &g_label_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf("\\n"); } }  &while (0);}' unless defined(&G_LABEL_DEBUG);
	eval 'sub G_LABEL_INIT {
	    my($kind, $label, $descr) = @_;
    	    eval q( &SYSCTL_NODE( &_kern_geom_label,  &OID_AUTO, $kind,  &CTLFLAG_RD,  &NULL, \\"\\");  &SYSCTL_INT( &_kern_geom_label_$kind,  &OID_AUTO,  &enable,  &CTLFLAG_RWTUN,  ($label->{ld_enabled}), 1, $descr));
	}' unless defined(&G_LABEL_INIT);
    }
    eval 'sub label_metadata_encode {
        my($md,$data) = @_;
	    eval q({  &bcopy( ($md->{md_magic}), $data, $sizeof{ ($md->{md_magic})});  &le32enc($data + 16,  ($md->{md_version}));  &bcopy( ($md->{md_label}), $data + 20, $sizeof{ ($md->{md_label})});  &le64enc($data + 36,  ($md->{md_provsize})); });
    }' unless defined(&label_metadata_encode);
    eval 'sub label_metadata_decode {
        my($data,$md) = @_;
	    eval q({  &bcopy($data,  ($md->{md_magic}), $sizeof{ ($md->{md_magic})});  ($md->{md_version}) =  &le32dec($data + 16);  &bcopy($data + 20,  ($md->{md_label}), $sizeof{ ($md->{md_label})});  ($md->{md_provsize}) =  &le64dec($data + 36); });
    }' unless defined(&label_metadata_decode);
}
1;
