require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_G_SHSEC_H_)) {
    eval 'sub _G_SHSEC_H_ () {1;}' unless defined(&_G_SHSEC_H_);
    require 'sys/endian.ph';
    eval 'sub G_SHSEC_CLASS_NAME () {"SHSEC";}' unless defined(&G_SHSEC_CLASS_NAME);
    eval 'sub G_SHSEC_MAGIC () {"GEOM::SHSEC";}' unless defined(&G_SHSEC_MAGIC);
    eval 'sub G_SHSEC_VERSION () {1;}' unless defined(&G_SHSEC_VERSION);
    if(defined(&_KERNEL)) {
	eval 'sub G_SHSEC_BFLAG_FIRST () {0x1;}' unless defined(&G_SHSEC_BFLAG_FIRST);
	eval 'sub G_SHSEC_DEBUG () {( &lvl, ...)  &do {  &if ( &g_shsec_debug >= ( &lvl)) {  &printf("GEOM_SHSEC");  &if ( &g_shsec_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf("\\n"); } }  &while (0);}' unless defined(&G_SHSEC_DEBUG);
	eval 'sub G_SHSEC_LOGREQ () {( &lvl,  &bp, ...)  &do {  &if ( &g_shsec_debug >= ( &lvl)) {  &printf("GEOM_SHSEC");  &if ( &g_shsec_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf(" ");  &g_print_bio( &bp);  &printf("\\n"); } }  &while (0);}' unless defined(&G_SHSEC_LOGREQ);
	eval 'sub sc_name () { ($sc_geom->{name});}' unless defined(&sc_name);
    }
    eval 'sub shsec_metadata_encode {
        my($md,$data) = @_;
	    eval q({  &bcopy( ($md->{md_magic}), $data, $sizeof{ ($md->{md_magic})});  &le32enc($data + 16,  ($md->{md_version}));  &bcopy( ($md->{md_name}), $data + 20, $sizeof{ ($md->{md_name})});  &le32enc($data + 36,  ($md->{md_id}));  &le16enc($data + 40,  ($md->{md_no}));  &le16enc($data + 42,  ($md->{md_all}));  &bcopy( ($md->{md_provider}), $data + 44, $sizeof{ ($md->{md_provider})});  &le64enc($data + 60,  ($md->{md_provsize})); });
    }' unless defined(&shsec_metadata_encode);
    eval 'sub shsec_metadata_decode {
        my($data,$md) = @_;
	    eval q({  &bcopy($data,  ($md->{md_magic}), $sizeof{ ($md->{md_magic})});  ($md->{md_version}) =  &le32dec($data + 16);  &bcopy($data + 20,  ($md->{md_name}), $sizeof{ ($md->{md_name})});  ($md->{md_id}) =  &le32dec($data + 36);  ($md->{md_no}) =  &le16dec($data + 40);  ($md->{md_all}) =  &le16dec($data + 42);  &bcopy($data + 44,  ($md->{md_provider}), $sizeof{ ($md->{md_provider})});  ($md->{md_provsize}) =  &le64dec($data + 60); });
    }' unless defined(&shsec_metadata_decode);
}
1;
