require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&ISODCL)) {
    sub ISODCL {
	my($from, $to) = @_;
	eval q(($to - $from + 1));
    }
}
eval 'sub ISO_VD_PRIMARY () {1;}' unless defined(&ISO_VD_PRIMARY);
eval 'sub ISO_VD_SUPPLEMENTARY () {2;}' unless defined(&ISO_VD_SUPPLEMENTARY);
eval 'sub ISO_VD_END () {255;}' unless defined(&ISO_VD_END);
eval 'sub ISO_STANDARD_ID () {"CD001";}' unless defined(&ISO_STANDARD_ID);
eval 'sub ISO_ECMA_ID () {"CDW01";}' unless defined(&ISO_ECMA_ID);
eval 'sub ISO_SIERRA_ID () {"CDROM";}' unless defined(&ISO_SIERRA_ID);
eval 'sub ISO_DEFAULT_BLOCK_SHIFT () {11;}' unless defined(&ISO_DEFAULT_BLOCK_SHIFT);
eval 'sub ISO_DEFAULT_BLOCK_SIZE () {(1<<  &ISO_DEFAULT_BLOCK_SHIFT);}' unless defined(&ISO_DEFAULT_BLOCK_SIZE);
eval 'sub ISO_DIRECTORY_RECORD_SIZE () {33;}' unless defined(&ISO_DIRECTORY_RECORD_SIZE);
if(defined(&_KERNEL)) {
    eval("sub ISO_FTYPE_DEFAULT () { 0; }") unless defined(&ISO_FTYPE_DEFAULT);
    eval("sub ISO_FTYPE_9660 () { 1; }") unless defined(&ISO_FTYPE_9660);
    eval("sub ISO_FTYPE_RRIP () { 2; }") unless defined(&ISO_FTYPE_RRIP);
    eval("sub ISO_FTYPE_JOLIET () { 3; }") unless defined(&ISO_FTYPE_JOLIET);
    eval("sub ISO_FTYPE_ECMA () { 4; }") unless defined(&ISO_FTYPE_ECMA);
    eval("sub ISO_FTYPE_HIGH_SIERRA () { 5; }") unless defined(&ISO_FTYPE_HIGH_SIERRA);
    unless(defined(&ISOFSMNT_ROOT)) {
	eval 'sub ISOFSMNT_ROOT () {0;}' unless defined(&ISOFSMNT_ROOT);
    }
    eval 'sub VFSTOISOFS {
        my($mp) = @_;
	    eval q(((($mp)-> &mnt_data)));
    }' unless defined(&VFSTOISOFS);
    eval 'sub blkoff {
        my($imp, $loc) = @_;
	    eval q((($loc) & ($imp)-> &im_bmask));
    }' unless defined(&blkoff);
    eval 'sub lblktosize {
        my($imp, $blk) = @_;
	    eval q((($blk) << ($imp)-> &im_bshift));
    }' unless defined(&lblktosize);
    eval 'sub lblkno {
        my($imp, $loc) = @_;
	    eval q((($loc) >> ($imp)-> &im_bshift));
    }' unless defined(&lblkno);
    eval 'sub blksize {
        my($imp, $ip, $lbn) = @_;
	    eval q((($imp)-> &logical_block_size));
    }' unless defined(&blksize);
    eval 'sub cd9660_sysctl () {(( &int (*)(\'int\' *, \'u_int\',  &void *, \'size_t\' *,  &void *, \'size_t\', \'struct proc\' *)) &eopnotsupp);}' unless defined(&cd9660_sysctl);
}
unless(defined(&isonum_712)) {
    sub isonum_712 {
	my($p) = @_;
	eval q({ ($p->[0]); });
    }
}
unless(defined(&isonum_713)) {
    sub isonum_713 {
	my($p) = @_;
	eval q({ ($p->[0]); });
    }
}
unless(defined(&isonum_721)) {
    sub isonum_721 {
	my($p) = @_;
	eval q({ ($p->[0] | $p->[1] << 8); });
    }
}
unless(defined(&isonum_722)) {
    sub isonum_722 {
	my($p) = @_;
	eval q({ ($p->[1] | $p->[0] << 8); });
    }
}
unless(defined(&isonum_723)) {
    sub isonum_723 {
	my($p) = @_;
	eval q({ ($p->[0] | $p->[1] << 8); });
    }
}
unless(defined(&isonum_731)) {
    sub isonum_731 {
	my($p) = @_;
	eval q({ ($p->[0] | $p->[1] << 8| $p->[2] << 16| $p->[3] << 24); });
    }
}
unless(defined(&isonum_732)) {
    sub isonum_732 {
	my($p) = @_;
	eval q({ ($p->[3] | $p->[2] << 8| $p->[1] << 16| $p->[0] << 24); });
    }
}
unless(defined(&isonum_733)) {
    sub isonum_733 {
	my($p) = @_;
	eval q({ ($p->[0] | $p->[1] << 8| $p->[2] << 16| $p->[3] << 24); });
    }
}
eval 'sub ASSOCCHAR () {ord(\'=\');}' unless defined(&ASSOCCHAR);
1;
