require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&INCLUDE_XO_H)) {
    eval 'sub INCLUDE_XO_H () {1;}' unless defined(&INCLUDE_XO_H);
    require 'stdio.ph';
    require 'sys/types.ph';
    require 'stdarg.ph';
    require 'limits.ph';
    require 'stdlib.ph';
    require 'errno.ph';
    if(defined(&__dead2)) {
	eval 'sub NORETURN () { &__dead2;}' unless defined(&NORETURN);
    } else {
	eval 'sub NORETURN () {1;}' unless defined(&NORETURN);
    }
    if(!defined(&NO_PRINTFLIKE)) {
	if(defined(&__linux)  && !defined(&__printflike)) {
	    eval 'sub __printflike {
	        my($_x, $_y) = @_;
    		eval q( &__attribute__(( &__format__ ( &__printf__, $_x, $_y))));
	    }' unless defined(&__printflike);
	}
	eval 'sub PRINTFLIKE {
	    my($_x, $_y) = @_;
    	    eval q( &__printflike($_x, $_y));
	}' unless defined(&PRINTFLIKE);
    } else {
	eval 'sub PRINTFLIKE {
	    my($_x, $_y) = @_;
    	    eval q();
	}' unless defined(&PRINTFLIKE);
    }
    eval 'sub XO_STYLE_TEXT () {0;}' unless defined(&XO_STYLE_TEXT);
    eval 'sub XO_STYLE_XML () {1;}' unless defined(&XO_STYLE_XML);
    eval 'sub XO_STYLE_JSON () {2;}' unless defined(&XO_STYLE_JSON);
    eval 'sub XO_STYLE_HTML () {3;}' unless defined(&XO_STYLE_HTML);
    eval 'sub XO_STYLE_SDPARAMS () {4;}' unless defined(&XO_STYLE_SDPARAMS);
    eval 'sub XO_STYLE_ENCODER () {5;}' unless defined(&XO_STYLE_ENCODER);
    eval 'sub XOF_BIT {
        my($_n) = @_;
	    eval q((( &xo_xof_flags_t) 1<< ($_n)));
    }' unless defined(&XOF_BIT);
    eval 'sub XOF_CLOSE_FP () { &XOF_BIT(0);}' unless defined(&XOF_CLOSE_FP);
    eval 'sub XOF_PRETTY () { &XOF_BIT(1);}' unless defined(&XOF_PRETTY);
    eval 'sub XOF_LOG_SYSLOG () { &XOF_BIT(2);}' unless defined(&XOF_LOG_SYSLOG);
    eval 'sub XOF_RESV3 () { &XOF_BIT(3);}' unless defined(&XOF_RESV3);
    eval 'sub XOF_WARN () { &XOF_BIT(4);}' unless defined(&XOF_WARN);
    eval 'sub XOF_XPATH () { &XOF_BIT(5);}' unless defined(&XOF_XPATH);
    eval 'sub XOF_INFO () { &XOF_BIT(6);}' unless defined(&XOF_INFO);
    eval 'sub XOF_WARN_XML () { &XOF_BIT(7);}' unless defined(&XOF_WARN_XML);
    eval 'sub XOF_NO_ENV () { &XOF_BIT(8);}' unless defined(&XOF_NO_ENV);
    eval 'sub XOF_NO_VA_ARG () { &XOF_BIT(9);}' unless defined(&XOF_NO_VA_ARG);
    eval 'sub XOF_DTRT () { &XOF_BIT(10);}' unless defined(&XOF_DTRT);
    eval 'sub XOF_KEYS () { &XOF_BIT(11);}' unless defined(&XOF_KEYS);
    eval 'sub XOF_IGNORE_CLOSE () { &XOF_BIT(12);}' unless defined(&XOF_IGNORE_CLOSE);
    eval 'sub XOF_NOT_FIRST () { &XOF_BIT(13);}' unless defined(&XOF_NOT_FIRST);
    eval 'sub XOF_NO_LOCALE () { &XOF_BIT(14);}' unless defined(&XOF_NO_LOCALE);
    eval 'sub XOF_RESV15 () { &XOF_BIT(15);}' unless defined(&XOF_RESV15);
    eval 'sub XOF_NO_TOP () { &XOF_BIT(16);}' unless defined(&XOF_NO_TOP);
    eval 'sub XOF_RESV17 () { &XOF_BIT(17);}' unless defined(&XOF_RESV17);
    eval 'sub XOF_UNITS () { &XOF_BIT(18);}' unless defined(&XOF_UNITS);
    eval 'sub XOF_RESV19 () { &XOF_BIT(19);}' unless defined(&XOF_RESV19);
    eval 'sub XOF_UNDERSCORES () { &XOF_BIT(20);}' unless defined(&XOF_UNDERSCORES);
    eval 'sub XOF_COLUMNS () { &XOF_BIT(21);}' unless defined(&XOF_COLUMNS);
    eval 'sub XOF_FLUSH () { &XOF_BIT(22);}' unless defined(&XOF_FLUSH);
    eval 'sub XOF_FLUSH_LINE () { &XOF_BIT(23);}' unless defined(&XOF_FLUSH_LINE);
    eval 'sub XOF_NO_CLOSE () { &XOF_BIT(24);}' unless defined(&XOF_NO_CLOSE);
    eval 'sub XOF_COLOR_ALLOWED () { &XOF_BIT(25);}' unless defined(&XOF_COLOR_ALLOWED);
    eval 'sub XOF_COLOR () { &XOF_BIT(26);}' unless defined(&XOF_COLOR);
    eval 'sub XOF_NO_HUMANIZE () { &XOF_BIT(27);}' unless defined(&XOF_NO_HUMANIZE);
    eval 'sub XOF_LOG_GETTEXT () { &XOF_BIT(28);}' unless defined(&XOF_LOG_GETTEXT);
    eval 'sub XOF_UTF8 () { &XOF_BIT(29);}' unless defined(&XOF_UTF8);
    eval 'sub XOF_RETAIN_ALL () { &XOF_BIT(30);}' unless defined(&XOF_RETAIN_ALL);
    eval 'sub XOF_RETAIN_NONE () { &XOF_BIT(31);}' unless defined(&XOF_RETAIN_NONE);
    eval 'sub XOF_COLOR_MAP () { &XOF_BIT(32);}' unless defined(&XOF_COLOR_MAP);
    eval 'sub XOEF_RETAIN () {(1<<0);}' unless defined(&XOEF_RETAIN);
    eval 'sub XO_INFO_NULL () { &NULL,  &NULL,  &NULL;}' unless defined(&XO_INFO_NULL);
    if(defined(&USE_INT_RETURN_CODES)) {
    } else {
    }
    eval 'sub xo_emit_hvp {
        my($xop,$fmt,$vap) = @_;
	    eval q({  &xo_emit_hv($xop, $fmt, $vap); });
    }' unless defined(&xo_emit_hvp);
    eval 'sub xo_emit_hp {
        my($xop,$fmt) = @_;
	    eval q({  &va_list  &vap;  &va_start( &vap, $fmt); \'int\'  &rc =  &xo_emit_hv($xop, $fmt,  &vap);  &va_end( &vap);  &rc; });
    }' unless defined(&xo_emit_hp);
    eval 'sub xo_emit_p {
        my($fmt) = @_;
	    eval q({  &va_list  &vap;  &va_start( &vap, $fmt); \'int\'  &rc =  &xo_emit_hv( &NULL, $fmt,  &vap);  &va_end( &vap);  &rc; });
    }' unless defined(&xo_emit_p);
    eval 'sub xo_emit_hvfp {
        my($xop,$flags,$fmt,$vap) = @_;
	    eval q({  &xo_emit_hvf($xop, $flags, $fmt, $vap); });
    }' unless defined(&xo_emit_hvfp);
    eval 'sub xo_emit_hfp {
        my($xop,$flags,$fmt) = @_;
	    eval q({  &va_list  &vap;  &va_start( &vap, $fmt); \'int\'  &rc =  &xo_emit_hvf($xop, $flags, $fmt,  &vap);  &va_end( &vap);  &rc; });
    }' unless defined(&xo_emit_hfp);
    eval 'sub xo_emit_fp {
        my($flags,$fmt) = @_;
	    eval q({  &va_list  &vap;  &va_start( &vap, $fmt); \'int\'  &rc =  &xo_emit_hvf( &NULL, $flags, $fmt,  &vap);  &va_end( &vap);  &rc; });
    }' unless defined(&xo_emit_fp);
    eval 'sub xo_emit_warn_hcvp {
        my($xop,$as_warning,$code,$fmt,$vap) = @_;
	    eval q({  &xo_emit_warn_hcv($xop, $as_warning, $code, $fmt, $vap); });
    }' unless defined(&xo_emit_warn_hcvp);
    eval 'sub xo_emit_warn_hcp {
        my($xop,$code,$fmt) = @_;
	    eval q({  &va_list  &vap;  &va_start( &vap, $fmt);  &xo_emit_warn_hcv($xop, 1, $code, $fmt,  &vap);  &va_end( &vap); });
    }' unless defined(&xo_emit_warn_hcp);
    eval 'sub xo_emit_warn_cp {
        my($code,$fmt) = @_;
	    eval q({  &va_list  &vap;  &va_start( &vap, $fmt);  &xo_emit_warn_hcv( &NULL, 1, $code, $fmt,  &vap);  &va_end( &vap); });
    }' unless defined(&xo_emit_warn_cp);
    eval 'sub xo_emit_warn_p {
        my($fmt) = @_;
	    eval q({ \'int\'  &code =  &errno;  &va_list  &vap;  &va_start( &vap, $fmt);  &xo_emit_warn_hcv( &NULL, 1,  &code, $fmt,  &vap);  &va_end( &vap); });
    }' unless defined(&xo_emit_warn_p);
    eval 'sub xo_emit_warnx_p {
        my($fmt) = @_;
	    eval q({  &va_list  &vap;  &va_start( &vap, $fmt);  &xo_emit_warn_hcv( &NULL, 1, -1, $fmt,  &vap);  &va_end( &vap); });
    }' unless defined(&xo_emit_warnx_p);
    eval 'sub xo_emit_err_p {
        my($eval,$fmt) = @_;
	    eval q({ \'int\'  &code =  &errno;  &va_list  &vap;  &va_start( &vap, $fmt);  &xo_emit_warn_hcv( &NULL, 0,  &code, $fmt,  &vap);  &va_end( &vap);  &exit($eval); });
    }' unless defined(&xo_emit_err_p);
    eval 'sub xo_emit_errx_p {
        my($eval,$fmt) = @_;
	    eval q({  &va_list  &vap;  &va_start( &vap, $fmt);  &xo_emit_warn_hcv( &NULL, 0, -1, $fmt,  &vap);  &va_end( &vap);  &exit($eval); });
    }' unless defined(&xo_emit_errx_p);
    eval 'sub xo_emit_errc_p {
        my($eval,$code,$fmt) = @_;
	    eval q({  &va_list  &vap;  &va_start( &vap, $fmt);  &xo_emit_warn_hcv( &NULL, 0, $code, $fmt,  &vap);  &va_end( &vap);  &exit($eval); });
    }' unless defined(&xo_emit_errc_p);
    eval 'sub XO_HAS_LIBXO () {121;}' unless defined(&XO_HAS_LIBXO);
}
1;
