require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ALTQ_ALTQ_FAIRQ_H_)) {
    eval 'sub _ALTQ_ALTQ_FAIRQ_H_ () {1;}' unless defined(&_ALTQ_ALTQ_FAIRQ_H_);
    require 'net/altq/altq.ph';
    require 'net/altq/altq_classq.ph';
    require 'net/altq/altq_codel.ph';
    require 'net/altq/altq_red.ph';
    require 'net/altq/altq_rio.ph';
    require 'net/altq/altq_rmclass.ph';
    eval 'sub FAIRQ_MAX_BUCKETS () {2048;}' unless defined(&FAIRQ_MAX_BUCKETS);
    eval 'sub FAIRQ_MAXPRI () { &RM_MAXPRIO;}' unless defined(&FAIRQ_MAXPRI);
    eval 'sub FAIRQ_BITMAP_WIDTH () {($sizeof{ &fairq_bitmap_t}*8);}' unless defined(&FAIRQ_BITMAP_WIDTH);
    eval 'sub FAIRQ_BITMAP_MASK () {( &FAIRQ_BITMAP_WIDTH - 1);}' unless defined(&FAIRQ_BITMAP_MASK);
    eval 'sub FARF_RED () {0x1;}' unless defined(&FARF_RED);
    eval 'sub FARF_ECN () {0x2;}' unless defined(&FARF_ECN);
    eval 'sub FARF_RIO () {0x4;}' unless defined(&FARF_RIO);
    eval 'sub FARF_CODEL () {0x8;}' unless defined(&FARF_CODEL);
    eval 'sub FARF_CLEARDSCP () {0x10;}' unless defined(&FARF_CLEARDSCP);
    eval 'sub FARF_DEFAULTCLASS () {0x1000;}' unless defined(&FARF_DEFAULTCLASS);
    eval 'sub FARF_HAS_PACKETS () {0x2000;}' unless defined(&FARF_HAS_PACKETS);
    eval 'sub FARF_USERFLAGS () {( &FARF_RED| &FARF_ECN| &FARF_RIO| &FARF_CLEARDSCP|  &FARF_DEFAULTCLASS);}' unless defined(&FARF_USERFLAGS);
    eval 'sub FAIRQ_NULLCLASS_HANDLE () {0;}' unless defined(&FAIRQ_NULLCLASS_HANDLE);
    if(defined(&_KERNEL)) {
	eval 'sub cl_red () { ($cl_aqm->{cl_red});}' unless defined(&cl_red);
	eval 'sub cl_codel () { ($cl_aqm->{cl_codel});}' unless defined(&cl_codel);
    }
}
1;
