require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_BPFDESC_H_)) {
    eval 'sub _NET_BPFDESC_H_ () {1;}' unless defined(&_NET_BPFDESC_H_);
    require 'sys/callout.ph';
    require 'sys/selinfo.ph';
    require 'sys/queue.ph';
    require 'sys/conf.ph';
    require 'net/if.ph';
    eval 'sub BPF_IDLE () {0;}' unless defined(&BPF_IDLE);
    eval 'sub BPF_WAITING () {1;}' unless defined(&BPF_WAITING);
    eval 'sub BPF_TIMED_OUT () {2;}' unless defined(&BPF_TIMED_OUT);
    eval 'sub BPFD_LOCK {
        my($bd) = @_;
	    eval q( &mtx_lock(($bd)-> &bd_lock));
    }' unless defined(&BPFD_LOCK);
    eval 'sub BPFD_UNLOCK {
        my($bd) = @_;
	    eval q( &mtx_unlock(($bd)-> &bd_lock));
    }' unless defined(&BPFD_UNLOCK);
    eval 'sub BPFD_LOCK_ASSERT {
        my($bd) = @_;
	    eval q( &mtx_assert(($bd)-> &bd_lock,  &MA_OWNED));
    }' unless defined(&BPFD_LOCK_ASSERT);
    eval 'sub BPF_PID_REFRESH {
        my($bd, $td) = @_;
	    eval q(($bd)-> &bd_pid = ($td)-> ($td_proc->{p_pid}));
    }' unless defined(&BPF_PID_REFRESH);
    eval 'sub BPF_PID_REFRESH_CUR {
        my($bd) = @_;
	    eval q(($bd)-> &bd_pid =  ($curthread->{td_proc}->{p_pid}));
    }' unless defined(&BPF_PID_REFRESH_CUR);
    eval 'sub BPFIF_RLOCK {
        my($bif) = @_;
	    eval q( &rw_rlock(($bif)-> &bif_lock));
    }' unless defined(&BPFIF_RLOCK);
    eval 'sub BPFIF_RUNLOCK {
        my($bif) = @_;
	    eval q( &rw_runlock(($bif)-> &bif_lock));
    }' unless defined(&BPFIF_RUNLOCK);
    eval 'sub BPFIF_WLOCK {
        my($bif) = @_;
	    eval q( &rw_wlock(($bif)-> &bif_lock));
    }' unless defined(&BPFIF_WLOCK);
    eval 'sub BPFIF_WUNLOCK {
        my($bif) = @_;
	    eval q( &rw_wunlock(($bif)-> &bif_lock));
    }' unless defined(&BPFIF_WUNLOCK);
    eval 'sub BPFIF_FLAG_DYING () {1;}' unless defined(&BPFIF_FLAG_DYING);
}
1;
