require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_IF_H_)) {
    eval 'sub _NET_IF_H_ () {1;}' unless defined(&_NET_IF_H_);
    require 'sys/cdefs.ph';
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	unless(defined(&_KERNEL)) {
	    require 'sys/time.ph';
	    require 'sys/socket.ph';
	}
    }
    eval 'sub IF_NAMESIZE () {16;}' unless defined(&IF_NAMESIZE);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub IFNAMSIZ () { &IF_NAMESIZE;}' unless defined(&IFNAMSIZ);
	eval 'sub IF_MAXUNIT () {0x7fff;}' unless defined(&IF_MAXUNIT);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub ifi_epoch () { ($__ifi_epoch->{tt});}' unless defined(&ifi_epoch);
	eval 'sub ifi_lastchange () { ($__ifi_lastchange->{tv});}' unless defined(&ifi_lastchange);
	eval 'sub IFF_UP () {0x1;}' unless defined(&IFF_UP);
	eval 'sub IFF_BROADCAST () {0x2;}' unless defined(&IFF_BROADCAST);
	eval 'sub IFF_DEBUG () {0x4;}' unless defined(&IFF_DEBUG);
	eval 'sub IFF_LOOPBACK () {0x8;}' unless defined(&IFF_LOOPBACK);
	eval 'sub IFF_POINTOPOINT () {0x10;}' unless defined(&IFF_POINTOPOINT);
	eval 'sub IFF_DRV_RUNNING () {0x40;}' unless defined(&IFF_DRV_RUNNING);
	eval 'sub IFF_NOARP () {0x80;}' unless defined(&IFF_NOARP);
	eval 'sub IFF_PROMISC () {0x100;}' unless defined(&IFF_PROMISC);
	eval 'sub IFF_ALLMULTI () {0x200;}' unless defined(&IFF_ALLMULTI);
	eval 'sub IFF_DRV_OACTIVE () {0x400;}' unless defined(&IFF_DRV_OACTIVE);
	eval 'sub IFF_SIMPLEX () {0x800;}' unless defined(&IFF_SIMPLEX);
	eval 'sub IFF_LINK0 () {0x1000;}' unless defined(&IFF_LINK0);
	eval 'sub IFF_LINK1 () {0x2000;}' unless defined(&IFF_LINK1);
	eval 'sub IFF_LINK2 () {0x4000;}' unless defined(&IFF_LINK2);
	eval 'sub IFF_ALTPHYS () { &IFF_LINK2;}' unless defined(&IFF_ALTPHYS);
	eval 'sub IFF_MULTICAST () {0x8000;}' unless defined(&IFF_MULTICAST);
	eval 'sub IFF_CANTCONFIG () {0x10000;}' unless defined(&IFF_CANTCONFIG);
	eval 'sub IFF_PPROMISC () {0x20000;}' unless defined(&IFF_PPROMISC);
	eval 'sub IFF_MONITOR () {0x40000;}' unless defined(&IFF_MONITOR);
	eval 'sub IFF_STATICARP () {0x80000;}' unless defined(&IFF_STATICARP);
	eval 'sub IFF_DYING () {0x200000;}' unless defined(&IFF_DYING);
	eval 'sub IFF_RENAMING () {0x400000;}' unless defined(&IFF_RENAMING);
	unless(defined(&_KERNEL)) {
	    eval 'sub IFF_RUNNING () { &IFF_DRV_RUNNING;}' unless defined(&IFF_RUNNING);
	    eval 'sub IFF_OACTIVE () { &IFF_DRV_OACTIVE;}' unless defined(&IFF_OACTIVE);
	}
	eval 'sub IFF_CANTCHANGE () {( &IFF_BROADCAST| &IFF_POINTOPOINT| &IFF_DRV_RUNNING| &IFF_DRV_OACTIVE|  &IFF_SIMPLEX| &IFF_MULTICAST| &IFF_ALLMULTI| &IFF_PROMISC|  &IFF_DYING| &IFF_CANTCONFIG);}' unless defined(&IFF_CANTCHANGE);
	eval 'sub LINK_STATE_UNKNOWN () {0;}' unless defined(&LINK_STATE_UNKNOWN);
	eval 'sub LINK_STATE_DOWN () {1;}' unless defined(&LINK_STATE_DOWN);
	eval 'sub LINK_STATE_UP () {2;}' unless defined(&LINK_STATE_UP);
	eval 'sub IF_Kbps {
	    my($x) = @_;
    	    eval q((( &uintmax_t)($x) * 1000));
	}' unless defined(&IF_Kbps);
	eval 'sub IF_Mbps {
	    my($x) = @_;
    	    eval q(( &IF_Kbps(($x) * 1000)));
	}' unless defined(&IF_Mbps);
	eval 'sub IF_Gbps {
	    my($x) = @_;
    	    eval q(( &IF_Mbps(($x) * 1000)));
	}' unless defined(&IF_Gbps);
	eval 'sub IFCAP_RXCSUM () {0x1;}' unless defined(&IFCAP_RXCSUM);
	eval 'sub IFCAP_TXCSUM () {0x2;}' unless defined(&IFCAP_TXCSUM);
	eval 'sub IFCAP_NETCONS () {0x4;}' unless defined(&IFCAP_NETCONS);
	eval 'sub IFCAP_VLAN_MTU () {0x8;}' unless defined(&IFCAP_VLAN_MTU);
	eval 'sub IFCAP_VLAN_HWTAGGING () {0x10;}' unless defined(&IFCAP_VLAN_HWTAGGING);
	eval 'sub IFCAP_JUMBO_MTU () {0x20;}' unless defined(&IFCAP_JUMBO_MTU);
	eval 'sub IFCAP_POLLING () {0x40;}' unless defined(&IFCAP_POLLING);
	eval 'sub IFCAP_VLAN_HWCSUM () {0x80;}' unless defined(&IFCAP_VLAN_HWCSUM);
	eval 'sub IFCAP_TSO4 () {0x100;}' unless defined(&IFCAP_TSO4);
	eval 'sub IFCAP_TSO6 () {0x200;}' unless defined(&IFCAP_TSO6);
	eval 'sub IFCAP_LRO () {0x400;}' unless defined(&IFCAP_LRO);
	eval 'sub IFCAP_WOL_UCAST () {0x800;}' unless defined(&IFCAP_WOL_UCAST);
	eval 'sub IFCAP_WOL_MCAST () {0x1000;}' unless defined(&IFCAP_WOL_MCAST);
	eval 'sub IFCAP_WOL_MAGIC () {0x2000;}' unless defined(&IFCAP_WOL_MAGIC);
	eval 'sub IFCAP_TOE4 () {0x4000;}' unless defined(&IFCAP_TOE4);
	eval 'sub IFCAP_TOE6 () {0x8000;}' unless defined(&IFCAP_TOE6);
	eval 'sub IFCAP_VLAN_HWFILTER () {0x10000;}' unless defined(&IFCAP_VLAN_HWFILTER);
	eval 'sub IFCAP_POLLING_NOCOUNT () {0x20000;}' unless defined(&IFCAP_POLLING_NOCOUNT);
	eval 'sub IFCAP_VLAN_HWTSO () {0x40000;}' unless defined(&IFCAP_VLAN_HWTSO);
	eval 'sub IFCAP_LINKSTATE () {0x80000;}' unless defined(&IFCAP_LINKSTATE);
	eval 'sub IFCAP_NETMAP () {0x100000;}' unless defined(&IFCAP_NETMAP);
	eval 'sub IFCAP_RXCSUM_IPV6 () {0x200000;}' unless defined(&IFCAP_RXCSUM_IPV6);
	eval 'sub IFCAP_TXCSUM_IPV6 () {0x400000;}' unless defined(&IFCAP_TXCSUM_IPV6);
	eval 'sub IFCAP_HWSTATS () {0x800000;}' unless defined(&IFCAP_HWSTATS);
	eval 'sub IFCAP_HWCSUM_IPV6 () {( &IFCAP_RXCSUM_IPV6 |  &IFCAP_TXCSUM_IPV6);}' unless defined(&IFCAP_HWCSUM_IPV6);
	eval 'sub IFCAP_HWCSUM () {( &IFCAP_RXCSUM |  &IFCAP_TXCSUM);}' unless defined(&IFCAP_HWCSUM);
	eval 'sub IFCAP_TSO () {( &IFCAP_TSO4 |  &IFCAP_TSO6);}' unless defined(&IFCAP_TSO);
	eval 'sub IFCAP_WOL () {( &IFCAP_WOL_UCAST |  &IFCAP_WOL_MCAST |  &IFCAP_WOL_MAGIC);}' unless defined(&IFCAP_WOL);
	eval 'sub IFCAP_TOE () {( &IFCAP_TOE4 |  &IFCAP_TOE6);}' unless defined(&IFCAP_TOE);
	eval 'sub IFCAP_CANTCHANGE () {( &IFCAP_NETMAP);}' unless defined(&IFCAP_CANTCHANGE);
	eval 'sub IFQ_MAXLEN () {50;}' unless defined(&IFQ_MAXLEN);
	eval 'sub IFNET_SLOWHZ () {1;}' unless defined(&IFNET_SLOWHZ);
	eval 'sub IF_MSGHDRL_IFM_DATA {
	    my($_l) = @_;
    	    eval q((($_l) + ($_l)-> &ifm_data_off));
	}' unless defined(&IF_MSGHDRL_IFM_DATA);
	eval 'sub IF_MSGHDRL_RTA {
	    my($_l) = @_;
    	    eval q(( &void *)(( &uintptr_t)($_l) + ($_l)-> &ifm_len));
	}' unless defined(&IF_MSGHDRL_RTA);
	eval 'sub IFA_MSGHDRL_IFAM_DATA {
	    my($_l) = @_;
    	    eval q((($_l) + ($_l)-> &ifam_data_off));
	}' unless defined(&IFA_MSGHDRL_IFAM_DATA);
	eval 'sub IFA_MSGHDRL_RTA {
	    my($_l) = @_;
    	    eval q(( &void *)(( &uintptr_t)($_l) + ($_l)-> &ifam_len));
	}' unless defined(&IFA_MSGHDRL_RTA);
	eval 'sub IFAN_ARRIVAL () {0;}' unless defined(&IFAN_ARRIVAL);
	eval 'sub IFAN_DEPARTURE () {1;}' unless defined(&IFAN_DEPARTURE);
	eval 'sub ifr_addr () { ($ifr_ifru->{ifru_addr});}' unless defined(&ifr_addr);
	eval 'sub ifr_dstaddr () { ($ifr_ifru->{ifru_dstaddr});}' unless defined(&ifr_dstaddr);
	eval 'sub ifr_broadaddr () { ($ifr_ifru->{ifru_broadaddr});}' unless defined(&ifr_broadaddr);
	unless(defined(&_KERNEL)) {
	    eval 'sub ifr_buffer () { ($ifr_ifru->{ifru_buffer});}' unless defined(&ifr_buffer);
	}
	eval 'sub ifr_flags () { ($ifr_ifru->{ifru_flags[0]});}' unless defined(&ifr_flags);
	eval 'sub ifr_flagshigh () { ($ifr_ifru->{ifru_flags[1]});}' unless defined(&ifr_flagshigh);
	eval 'sub ifr_jid () { ($ifr_ifru->{ifru_jid});}' unless defined(&ifr_jid);
	eval 'sub ifr_metric () { ($ifr_ifru->{ifru_metric});}' unless defined(&ifr_metric);
	eval 'sub ifr_mtu () { ($ifr_ifru->{ifru_mtu});}' unless defined(&ifr_mtu);
	eval 'sub ifr_phys () { ($ifr_ifru->{ifru_phys});}' unless defined(&ifr_phys);
	eval 'sub ifr_media () { ($ifr_ifru->{ifru_media});}' unless defined(&ifr_media);
	unless(defined(&_KERNEL)) {
	    eval 'sub ifr_data () { ($ifr_ifru->{ifru_data});}' unless defined(&ifr_data);
	}
	eval 'sub ifr_reqcap () { ($ifr_ifru->{ifru_cap[0]});}' unless defined(&ifr_reqcap);
	eval 'sub ifr_curcap () { ($ifr_ifru->{ifru_cap[1]});}' unless defined(&ifr_curcap);
	eval 'sub ifr_index () { ($ifr_ifru->{ifru_index});}' unless defined(&ifr_index);
	eval 'sub ifr_fib () { ($ifr_ifru->{ifru_fib});}' unless defined(&ifr_fib);
	eval 'sub ifr_vlan_pcp () { ($ifr_ifru->{ifru_vlan_pcp});}' unless defined(&ifr_vlan_pcp);
	eval 'sub ifr_lan_pcp () { ($ifr_ifru->{ifru_vlan_pcp});}' unless defined(&ifr_lan_pcp);
	eval 'sub _SIZEOF_ADDR_IFREQ {
	    my($ifr) = @_;
    	    eval q((($ifr). ($ifr_addr->{sa_len}) > $sizeof{\'struct sockaddr\'} ? ($sizeof{\'struct ifreq\'} - $sizeof{\'struct sockaddr\'} + ($ifr). ($ifr_addr->{sa_len})) : $sizeof{\'struct ifreq\'}));
	}' unless defined(&_SIZEOF_ADDR_IFREQ);
	eval 'sub IFSTATMAX () {800;}' unless defined(&IFSTATMAX);
	eval 'sub ifc_buf () { ($ifc_ifcu->{ifcu_buf});}' unless defined(&ifc_buf);
	eval 'sub ifc_req () { ($ifc_ifcu->{ifcu_req});}' unless defined(&ifc_req);
	eval 'sub IFG_ALL () {"all";}' unless defined(&IFG_ALL);
	eval 'sub IFG_EGRESS () {"egress";}' unless defined(&IFG_EGRESS);
	eval 'sub ifgrq_group () { ($ifgrq_ifgrqu->{ifgrqu_group});}' unless defined(&ifgrq_group);
	eval 'sub ifgrq_member () { ($ifgrq_ifgrqu->{ifgrqu_member});}' unless defined(&ifgrq_member);
	unless(defined(&_KERNEL)) {
	    eval 'sub ifgr_group () { ($ifgr_ifgru->{ifgru_group});}' unless defined(&ifgr_group);
	    eval 'sub ifgr_groups () { ($ifgr_ifgru->{ifgru_groups});}' unless defined(&ifgr_groups);
	}
	eval 'sub RSS_FUNC_NONE () {0;}' unless defined(&RSS_FUNC_NONE);
	eval 'sub RSS_FUNC_PRIVATE () {1;}' unless defined(&RSS_FUNC_PRIVATE);
	eval 'sub RSS_FUNC_TOEPLITZ () {2;}' unless defined(&RSS_FUNC_TOEPLITZ);
	eval 'sub RSS_TYPE_IPV4 () {0x1;}' unless defined(&RSS_TYPE_IPV4);
	eval 'sub RSS_TYPE_TCP_IPV4 () {0x2;}' unless defined(&RSS_TYPE_TCP_IPV4);
	eval 'sub RSS_TYPE_IPV6 () {0x4;}' unless defined(&RSS_TYPE_IPV6);
	eval 'sub RSS_TYPE_IPV6_EX () {0x8;}' unless defined(&RSS_TYPE_IPV6_EX);
	eval 'sub RSS_TYPE_TCP_IPV6 () {0x10;}' unless defined(&RSS_TYPE_TCP_IPV6);
	eval 'sub RSS_TYPE_TCP_IPV6_EX () {0x20;}' unless defined(&RSS_TYPE_TCP_IPV6_EX);
	eval 'sub RSS_TYPE_UDP_IPV4 () {0x40;}' unless defined(&RSS_TYPE_UDP_IPV4);
	eval 'sub RSS_TYPE_UDP_IPV6 () {0x80;}' unless defined(&RSS_TYPE_UDP_IPV6);
	eval 'sub RSS_TYPE_UDP_IPV6_EX () {0x100;}' unless defined(&RSS_TYPE_UDP_IPV6_EX);
	eval 'sub RSS_KEYLEN () {128;}' unless defined(&RSS_KEYLEN);
	eval 'sub IFNET_PCP_NONE () {0xff;}' unless defined(&IFNET_PCP_NONE);
    }
    if(defined(&_KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
    }
    unless(defined(&_KERNEL)) {
    }
}
1;
