require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_IF_ARP_H_)) {
    eval 'sub _NET_IF_ARP_H_ () {1;}' unless defined(&_NET_IF_ARP_H_);
    eval 'sub ARPHRD_ETHER () {1;}' unless defined(&ARPHRD_ETHER);
    eval 'sub ARPHRD_IEEE802 () {6;}' unless defined(&ARPHRD_IEEE802);
    eval 'sub ARPHRD_ARCNET () {7;}' unless defined(&ARPHRD_ARCNET);
    eval 'sub ARPHRD_FRELAY () {15;}' unless defined(&ARPHRD_FRELAY);
    eval 'sub ARPHRD_IEEE1394 () {24;}' unless defined(&ARPHRD_IEEE1394);
    eval 'sub ARPHRD_INFINIBAND () {32;}' unless defined(&ARPHRD_INFINIBAND);
    eval 'sub ARPOP_REQUEST () {1;}' unless defined(&ARPOP_REQUEST);
    eval 'sub ARPOP_REPLY () {2;}' unless defined(&ARPOP_REPLY);
    eval 'sub ARPOP_REVREQUEST () {3;}' unless defined(&ARPOP_REVREQUEST);
    eval 'sub ARPOP_REVREPLY () {4;}' unless defined(&ARPOP_REVREPLY);
    eval 'sub ARPOP_INVREQUEST () {8;}' unless defined(&ARPOP_INVREQUEST);
    eval 'sub ARPOP_INVREPLY () {9;}' unless defined(&ARPOP_INVREPLY);
    if(defined(&COMMENT_ONLY)) {
    }
    eval 'sub ar_sha {
        my($ap) = @_;
	    eval q((((($ap)+1)) + 0));
    }' unless defined(&ar_sha);
    eval 'sub ar_spa {
        my($ap) = @_;
	    eval q((((($ap)+1)) + ($ap)-> &ar_hln));
    }' unless defined(&ar_spa);
    eval 'sub ar_tha {
        my($ap) = @_;
	    eval q((((($ap)+1)) + ($ap)-> &ar_hln + ($ap)-> &ar_pln));
    }' unless defined(&ar_tha);
    eval 'sub ar_tpa {
        my($ap) = @_;
	    eval q((((($ap)+1)) + 2*($ap)-> &ar_hln + ($ap)-> &ar_pln));
    }' unless defined(&ar_tpa);
    eval 'sub arphdr_len2 {
        my($ar_hln, $ar_pln) = @_;
	    eval q(($sizeof{\'struct arphdr\'} + 2*($ar_hln) + 2*($ar_pln)));
    }' unless defined(&arphdr_len2);
    eval 'sub arphdr_len {
        my($ap) = @_;
	    eval q(( &arphdr_len2(($ap)-> &ar_hln, ($ap)-> &ar_pln)));
    }' unless defined(&arphdr_len);
    eval 'sub ATF_INUSE () {0x1;}' unless defined(&ATF_INUSE);
    eval 'sub ATF_COM () {0x2;}' unless defined(&ATF_COM);
    eval 'sub ATF_PERM () {0x4;}' unless defined(&ATF_PERM);
    eval 'sub ATF_PUBL () {0x8;}' unless defined(&ATF_PUBL);
    eval 'sub ATF_USETRAILERS () {0x10;}' unless defined(&ATF_USETRAILERS);
    if(defined(&_KERNEL)) {
	require 'sys/counter.ph';
	require 'net/vnet.ph';
	eval 'sub ARPSTAT_ADD {
	    my($name, $val) = @_;
    	    eval q( &VNET_PCPUSTAT_ADD(\'struct arpstat\',  &arpstat, $name, ($val)));
	}' unless defined(&ARPSTAT_ADD);
	eval 'sub ARPSTAT_SUB {
	    my($name, $val) = @_;
    	    eval q( &ARPSTAT_ADD($name, -($val)));
	}' unless defined(&ARPSTAT_SUB);
	eval 'sub ARPSTAT_INC {
	    my($name) = @_;
    	    eval q( &ARPSTAT_ADD($name, 1));
	}' unless defined(&ARPSTAT_INC);
	eval 'sub ARPSTAT_DEC {
	    my($name) = @_;
    	    eval q( &ARPSTAT_SUB($name, 1));
	}' unless defined(&ARPSTAT_DEC);
    }
}
1;
