require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub ATM_DEVICE_UNKNOWN () {0;}' unless defined(&ATM_DEVICE_UNKNOWN);
eval 'sub ATM_DEVICE_PCA200E () {1;}' unless defined(&ATM_DEVICE_PCA200E);
eval 'sub ATM_DEVICE_HE155 () {2;}' unless defined(&ATM_DEVICE_HE155);
eval 'sub ATM_DEVICE_HE622 () {3;}' unless defined(&ATM_DEVICE_HE622);
eval 'sub ATM_DEVICE_ENI155P () {4;}' unless defined(&ATM_DEVICE_ENI155P);
eval 'sub ATM_DEVICE_ADP155P () {5;}' unless defined(&ATM_DEVICE_ADP155P);
eval 'sub ATM_DEVICE_FORELE25 () {6;}' unless defined(&ATM_DEVICE_FORELE25);
eval 'sub ATM_DEVICE_FORELE155 () {7;}' unless defined(&ATM_DEVICE_FORELE155);
eval 'sub ATM_DEVICE_NICSTAR25 () {8;}' unless defined(&ATM_DEVICE_NICSTAR25);
eval 'sub ATM_DEVICE_NICSTAR155 () {9;}' unless defined(&ATM_DEVICE_NICSTAR155);
eval 'sub ATM_DEVICE_IDTABR25 () {10;}' unless defined(&ATM_DEVICE_IDTABR25);
eval 'sub ATM_DEVICE_IDTABR155 () {11;}' unless defined(&ATM_DEVICE_IDTABR155);
eval 'sub ATM_DEVICE_PROATM25 () {12;}' unless defined(&ATM_DEVICE_PROATM25);
eval 'sub ATM_DEVICE_PROATM155 () {13;}' unless defined(&ATM_DEVICE_PROATM155);
eval 'sub ATM_DEVICE_VIRTUAL () {14;}' unless defined(&ATM_DEVICE_VIRTUAL);
eval 'sub ATM_DEVICE_NAMES () {{ "Unknown", "Unknown" }, { "PCA200-E", "Fore/Marconi" }, { "HE155", "Fore/Marconi" }, { "HE622", "Fore/Marconi" }, { "ENI155p", "Efficient Networks" }, { "ADP155p", "Adaptec" }, { "ForeRunnerLE25", "Fore/Marconi" }, { "ForeRunnerLE155", "Fore/Marconi" }, { "IDT77211/25", "IDT" }, { "IDT77211/155", "IDT" }, { "IDT77252/25", "IDT" }, { "IDT77252/155", "IDT" }, { "ProATM/25", "ProSum" }, { "ProATM/155", "ProSum" }, { "Virtual", "NetGraph" },;}' unless defined(&ATM_DEVICE_NAMES);
eval 'sub ATMIO_FLAG_LLCSNAP () {0x2;}' unless defined(&ATMIO_FLAG_LLCSNAP);
eval 'sub ATMIO_FLAG_NG () {0x10;}' unless defined(&ATMIO_FLAG_NG);
eval 'sub ATMIO_FLAG_HARP () {0x20;}' unless defined(&ATMIO_FLAG_HARP);
eval 'sub ATMIO_FLAG_NORX () {0x100;}' unless defined(&ATMIO_FLAG_NORX);
eval 'sub ATMIO_FLAG_NOTX () {0x200;}' unless defined(&ATMIO_FLAG_NOTX);
eval 'sub ATMIO_FLAG_PVC () {0x400;}' unless defined(&ATMIO_FLAG_PVC);
eval 'sub ATMIO_FLAG_ASYNC () {0x800;}' unless defined(&ATMIO_FLAG_ASYNC);
eval 'sub ATMIO_FLAGS () {"\\020\\2LLCSNAP\\5NG\\6HARP\\11NORX\\12NOTX\\13PVC\\14ASYNC";}' unless defined(&ATMIO_FLAGS);
eval 'sub ATMIO_AAL_0 () {0;}' unless defined(&ATMIO_AAL_0);
eval 'sub ATMIO_AAL_34 () {4;}' unless defined(&ATMIO_AAL_34);
eval 'sub ATMIO_AAL_5 () {5;}' unless defined(&ATMIO_AAL_5);
eval 'sub ATMIO_AAL_RAW () {10;}' unless defined(&ATMIO_AAL_RAW);
eval 'sub ATMIO_TRAFFIC_UBR () {0;}' unless defined(&ATMIO_TRAFFIC_UBR);
eval 'sub ATMIO_TRAFFIC_CBR () {1;}' unless defined(&ATMIO_TRAFFIC_CBR);
eval 'sub ATMIO_TRAFFIC_ABR () {2;}' unless defined(&ATMIO_TRAFFIC_ABR);
eval 'sub ATMIO_TRAFFIC_VBR () {3;}' unless defined(&ATMIO_TRAFFIC_VBR);
eval 'sub ATM_RATE_25_6M () {59259;}' unless defined(&ATM_RATE_25_6M);
eval 'sub ATM_RATE_155M () {353208;}' unless defined(&ATM_RATE_155M);
eval 'sub ATM_RATE_622M () {1412830;}' unless defined(&ATM_RATE_622M);
eval 'sub ATM_RATE_2_4G () {5651320;}' unless defined(&ATM_RATE_2_4G);
if(defined(&_KERNEL)) {
    eval 'sub IFP2IFATM {
        my($ifp) = @_;
	    eval q((($ifp)-> &if_l2com));
    }' unless defined(&IFP2IFATM);
}
if(defined(&__NetBSD__) || defined(&__OpenBSD__) || defined(&__bsdi__)) {
    eval 'sub RTALLOC1 {
        my($A,$B) = @_;
	    eval q( &rtalloc1(($A),($B)));
    }' unless defined(&RTALLOC1);
}
 elsif(defined(&__FreeBSD__)) {
    eval 'sub RTALLOC1 {
        my($A,$B) = @_;
	    eval q( &rtalloc1(($A),($B),0));
    }' unless defined(&RTALLOC1);
}
unless(defined(&ATM_PH_FLAGS)) {
    sub ATM_PH_FLAGS {
	my($X) = @_;
	eval q((($X)-> $atm_ph[0]));
    }
}
unless(defined(&ATM_PH_VPI)) {
    sub ATM_PH_VPI {
	my($X) = @_;
	eval q((($X)-> $atm_ph[1]));
    }
}
unless(defined(&ATM_PH_VCI)) {
    sub ATM_PH_VCI {
	my($X) = @_;
	eval q((((($X)-> $atm_ph[2]) << 8) | (($X)-> $atm_ph[3])));
    }
}
unless(defined(&ATM_PH_SETVCI)) {
    sub ATM_PH_SETVCI {
	my($X,$V) = @_;
	eval q({ ($X)-> $atm_ph[2] = (($V) >> 8) & 0xff; ($X)-> $atm_ph[3] = (($V) & 0xff); });
    }
}
eval 'sub ATM_PH_AAL5 () {0x1;}' unless defined(&ATM_PH_AAL5);
eval 'sub ATM_PH_LLCSNAP () { &ATMIO_FLAG_LLCSNAP;}' unless defined(&ATM_PH_LLCSNAP);
eval 'sub ATM_PH_DRIVER7 () {0x40;}' unless defined(&ATM_PH_DRIVER7);
eval 'sub ATM_PH_DRIVER8 () {0x80;}' unless defined(&ATM_PH_DRIVER8);
eval 'sub ATMMTU () {9180;}' unless defined(&ATMMTU);
eval 'sub SIOCATMGETVCCS () { &_IOW(ord(\'a\'), 125, \'struct atmio_vcctable\');}' unless defined(&SIOCATMGETVCCS);
eval 'sub SIOCATMOPENVCC () { &_IOR(ord(\'a\'), 126, \'struct atmio_openvcc\');}' unless defined(&SIOCATMOPENVCC);
eval 'sub SIOCATMCLOSEVCC () { &_IOR(ord(\'a\'), 127, \'struct atmio_closevcc\');}' unless defined(&SIOCATMCLOSEVCC);
eval 'sub SIOCATMGVCCS () { &_IOWR(ord(\'i\'), 230, \'struct ifreq\');}' unless defined(&SIOCATMGVCCS);
eval 'sub ATMLLC_HDR () {"\\252\\252\\3\\0\\0\\0";}' unless defined(&ATMLLC_HDR);
unless(defined(&ATM_LLC_TYPE)) {
    sub ATM_LLC_TYPE {
	my($X) = @_;
	eval q(((($X)-> $type[0] << 8) | (($X)-> $type[1])));
    }
}
unless(defined(&ATM_LLC_SETTYPE)) {
    sub ATM_LLC_SETTYPE {
	my($X, $V) = @_;
	eval q( &do { ($X)-> $type[0] = (($V) >> 8) & 0xff; ($X)-> $type[1] = (($V) & 0xff); }  &while (0));
    }
}
eval 'sub ATMEV_FLOW_CONTROL () {0x1;}' unless defined(&ATMEV_FLOW_CONTROL);
eval 'sub ATMEV_IFSTATE_CHANGED () {0x2;}' unless defined(&ATMEV_IFSTATE_CHANGED);
eval 'sub ATMEV_VCC_CHANGED () {0x3;}' unless defined(&ATMEV_VCC_CHANGED);
eval 'sub ATMEV_ACR_CHANGED () {0x4;}' unless defined(&ATMEV_ACR_CHANGED);
if(defined(&_KERNEL)) {
    eval 'sub ATMEV_SEND_FLOW_CONTROL {
        my($ATMIF, $VPI, $VCI, $BUSY) = @_;
	    eval q( &do { \'struct atmev_flow_control\'  &_arg;  ($_arg->{vpi}) = ($VPI);  ($_arg->{vci}) = ($VCI);  ($_arg->{busy}) = ($BUSY);  &atm_event(($ATMIF)-> &ifp,  &ATMEV_FLOW_CONTROL, & &_arg); }  &while (0));
    }' unless defined(&ATMEV_SEND_FLOW_CONTROL);
    eval 'sub ATMEV_SEND_VCC_CHANGED {
        my($ATMIF, $VPI, $VCI, $UP) = @_;
	    eval q( &do { \'struct atmev_vcc_changed\'  &_arg;  ($_arg->{vpi}) = ($VPI);  ($_arg->{vci}) = ($VCI);  ($_arg->{up}) = ($UP);  &atm_event(($ATMIF)-> &ifp,  &ATMEV_VCC_CHANGED, & &_arg); }  &while (0));
    }' unless defined(&ATMEV_SEND_VCC_CHANGED);
    eval 'sub ATMEV_SEND_IFSTATE_CHANGED {
        my($ATMIF, $CARRIER) = @_;
	    eval q( &do { \'struct atmev_ifstate_changed\'  &_arg;  ($_arg->{running}) = ((($ATMIF)-> ($ifp->{if_drv_flags}) &  &IFF_DRV_RUNNING) != 0);  ($_arg->{carrier}) = (($CARRIER) != 0);  &atm_event(($ATMIF)-> &ifp,  &ATMEV_IFSTATE_CHANGED, & &_arg); }  &while (0));
    }' unless defined(&ATMEV_SEND_IFSTATE_CHANGED);
    eval 'sub ATMEV_SEND_ACR_CHANGED {
        my($ATMIF, $VPI, $VCI, $ACR) = @_;
	    eval q( &do { \'struct atmev_acr_changed\'  &_arg;  ($_arg->{vpi}) = ($VPI);  ($_arg->{vci}) = ($VCI);  ($_arg->{acr})= ($ACR);  &atm_event(($ATMIF)-> &ifp,  &ATMEV_ACR_CHANGED, & &_arg); }  &while (0));
    }' unless defined(&ATMEV_SEND_ACR_CHANGED);
}
1;
