require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_IF_GRE_H_)) {
    eval 'sub _NET_IF_GRE_H_ () {1;}' unless defined(&_NET_IF_GRE_H_);
    if(defined(&_KERNEL)) {
	eval 'sub GRE_FLAGS_CP () {0x8000;}' unless defined(&GRE_FLAGS_CP);
	eval 'sub GRE_FLAGS_KP () {0x2000;}' unless defined(&GRE_FLAGS_KP);
	eval 'sub GRE_FLAGS_SP () {0x1000;}' unless defined(&GRE_FLAGS_SP);
	eval 'sub GRE_FLAGS_MASK () {( &GRE_FLAGS_CP| &GRE_FLAGS_KP| &GRE_FLAGS_SP);}' unless defined(&GRE_FLAGS_MASK);
	if(defined(&INET)) {
	}
	if(defined(&INET6)) {
	}
	if(defined(&INET)) {
	}
	if(defined(&INET6)) {
	}
	eval 'sub GRE2IFP {
	    my($sc) = @_;
    	    eval q((($sc)-> &gre_ifp));
	}' unless defined(&GRE2IFP);
	eval 'sub GRE_LOCK_INIT {
	    my($sc) = @_;
    	    eval q( &rm_init(($sc)-> &gre_lock, \\"gre softc\\"));
	}' unless defined(&GRE_LOCK_INIT);
	eval 'sub GRE_LOCK_DESTROY {
	    my($sc) = @_;
    	    eval q( &rm_destroy(($sc)-> &gre_lock));
	}' unless defined(&GRE_LOCK_DESTROY);
	eval 'sub GRE_RLOCK_TRACKER () {\'struct rm_priotracker\'  &gre_tracker;}' unless defined(&GRE_RLOCK_TRACKER);
	eval 'sub GRE_RLOCK {
	    my($sc) = @_;
    	    eval q( &rm_rlock(($sc)-> &gre_lock,  &gre_tracker));
	}' unless defined(&GRE_RLOCK);
	eval 'sub GRE_RUNLOCK {
	    my($sc) = @_;
    	    eval q( &rm_runlock(($sc)-> &gre_lock,  &gre_tracker));
	}' unless defined(&GRE_RUNLOCK);
	eval 'sub GRE_RLOCK_ASSERT {
	    my($sc) = @_;
    	    eval q( &rm_assert(($sc)-> &gre_lock,  &RA_RLOCKED));
	}' unless defined(&GRE_RLOCK_ASSERT);
	eval 'sub GRE_WLOCK {
	    my($sc) = @_;
    	    eval q( &rm_wlock(($sc)-> &gre_lock));
	}' unless defined(&GRE_WLOCK);
	eval 'sub GRE_WUNLOCK {
	    my($sc) = @_;
    	    eval q( &rm_wunlock(($sc)-> &gre_lock));
	}' unless defined(&GRE_WUNLOCK);
	eval 'sub GRE_WLOCK_ASSERT {
	    my($sc) = @_;
    	    eval q( &rm_assert(($sc)-> &gre_lock,  &RA_WLOCKED));
	}' unless defined(&GRE_WLOCK_ASSERT);
	eval 'sub gre_hdr () { ($gre_uhdr->{hdr});}' unless defined(&gre_hdr);
	eval 'sub gre_gihdr () { ($gre_uhdr->{gihdr});}' unless defined(&gre_gihdr);
	eval 'sub gre_gi6hdr () { ($gre_uhdr->{gi6hdr});}' unless defined(&gre_gi6hdr);
	eval 'sub gre_oip () { ($gre_gihdr->{gi_ip});}' unless defined(&gre_oip);
	eval 'sub gre_oip6 () { ($gre_gi6hdr->{gi6_ip6});}' unless defined(&gre_oip6);
	if(defined(&INET)) {
	}
	if(defined(&INET6)) {
	}
	eval 'sub ETHERTYPE_WCCP () {0x883e;}' unless defined(&ETHERTYPE_WCCP);
    }
    eval 'sub GRESADDRS () { &_IOW(ord(\'i\'), 101, \'struct ifreq\');}' unless defined(&GRESADDRS);
    eval 'sub GRESADDRD () { &_IOW(ord(\'i\'), 102, \'struct ifreq\');}' unless defined(&GRESADDRD);
    eval 'sub GREGADDRS () { &_IOWR(ord(\'i\'), 103, \'struct ifreq\');}' unless defined(&GREGADDRS);
    eval 'sub GREGADDRD () { &_IOWR(ord(\'i\'), 104, \'struct ifreq\');}' unless defined(&GREGADDRD);
    eval 'sub GRESPROTO () { &_IOW(ord(\'i\') , 105, \'struct ifreq\');}' unless defined(&GRESPROTO);
    eval 'sub GREGPROTO () { &_IOWR(ord(\'i\'), 106, \'struct ifreq\');}' unless defined(&GREGPROTO);
    eval 'sub GREGKEY () { &_IOWR(ord(\'i\'), 107, \'struct ifreq\');}' unless defined(&GREGKEY);
    eval 'sub GRESKEY () { &_IOW(ord(\'i\'), 108, \'struct ifreq\');}' unless defined(&GRESKEY);
    eval 'sub GREGOPTS () { &_IOWR(ord(\'i\'), 109, \'struct ifreq\');}' unless defined(&GREGOPTS);
    eval 'sub GRESOPTS () { &_IOW(ord(\'i\'), 110, \'struct ifreq\');}' unless defined(&GRESOPTS);
    eval 'sub GRE_ENABLE_CSUM () {0x1;}' unless defined(&GRE_ENABLE_CSUM);
    eval 'sub GRE_ENABLE_SEQ () {0x2;}' unless defined(&GRE_ENABLE_SEQ);
    eval 'sub GRE_OPTMASK () {( &GRE_ENABLE_CSUM| &GRE_ENABLE_SEQ);}' unless defined(&GRE_OPTMASK);
}
1;
