require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_LAGG_H)) {
    eval 'sub _NET_LAGG_H () {1;}' unless defined(&_NET_LAGG_H);
    eval 'sub LAGG_MAX_PORTS () {32;}' unless defined(&LAGG_MAX_PORTS);
    eval 'sub LAGG_MAX_NAMESIZE () {32;}' unless defined(&LAGG_MAX_NAMESIZE);
    eval 'sub LAGG_MAX_STACKING () {4;}' unless defined(&LAGG_MAX_STACKING);
    eval 'sub LAGG_F_HASHL2 () {0x1;}' unless defined(&LAGG_F_HASHL2);
    eval 'sub LAGG_F_HASHL3 () {0x2;}' unless defined(&LAGG_F_HASHL3);
    eval 'sub LAGG_F_HASHL4 () {0x4;}' unless defined(&LAGG_F_HASHL4);
    eval 'sub LAGG_F_HASHMASK () {0x7;}' unless defined(&LAGG_F_HASHMASK);
    eval 'sub LAGG_PORT_SLAVE () {0x;}' unless defined(&LAGG_PORT_SLAVE);
    eval 'sub LAGG_PORT_MASTER () {0x1;}' unless defined(&LAGG_PORT_MASTER);
    eval 'sub LAGG_PORT_STACK () {0x2;}' unless defined(&LAGG_PORT_STACK);
    eval 'sub LAGG_PORT_ACTIVE () {0x4;}' unless defined(&LAGG_PORT_ACTIVE);
    eval 'sub LAGG_PORT_COLLECTING () {0x8;}' unless defined(&LAGG_PORT_COLLECTING);
    eval 'sub LAGG_PORT_DISTRIBUTING () {0x10;}' unless defined(&LAGG_PORT_DISTRIBUTING);
    eval 'sub LAGG_PORT_DISABLED () {0x20;}' unless defined(&LAGG_PORT_DISABLED);
    eval 'sub LAGG_PORT_BITS () {"\\20\\01MASTER\\02STACK\\03ACTIVE\\04COLLECTING" "\\05DISTRIBUTING\\06DISABLED";}' unless defined(&LAGG_PORT_BITS);
    eval("sub LAGG_PROTO_NONE () { 0; }") unless defined(&LAGG_PROTO_NONE);
    eval("sub LAGG_PROTO_ROUNDROBIN () { 1; }") unless defined(&LAGG_PROTO_ROUNDROBIN);
    eval("sub LAGG_PROTO_FAILOVER () { 2; }") unless defined(&LAGG_PROTO_FAILOVER);
    eval("sub LAGG_PROTO_LOADBALANCE () { 3; }") unless defined(&LAGG_PROTO_LOADBALANCE);
    eval("sub LAGG_PROTO_LACP () { 4; }") unless defined(&LAGG_PROTO_LACP);
    eval("sub LAGG_PROTO_BROADCAST () { 5; }") unless defined(&LAGG_PROTO_BROADCAST);
    eval("sub LAGG_PROTO_MAX () { 6; }") unless defined(&LAGG_PROTO_MAX);
    eval 'sub LAGG_PROTO_DEFAULT () { &LAGG_PROTO_FAILOVER;}' unless defined(&LAGG_PROTO_DEFAULT);
    eval 'sub LAGG_PROTOS () {{ { "failover",  &LAGG_PROTO_FAILOVER }, { "lacp",  &LAGG_PROTO_LACP }, { "loadbalance",  &LAGG_PROTO_LOADBALANCE }, { "roundrobin",  &LAGG_PROTO_ROUNDROBIN }, { "broadcast",  &LAGG_PROTO_BROADCAST }, { "none",  &LAGG_PROTO_NONE }, { "default",  &LAGG_PROTO_DEFAULT } };}' unless defined(&LAGG_PROTOS);
    eval 'sub rp_lacpreq () { ($rp_psc->{rpsc_lacp});}' unless defined(&rp_lacpreq);
    eval 'sub SIOCGLAGGPORT () { &_IOWR(ord(\'i\'), 140, \'struct lagg_reqport\');}' unless defined(&SIOCGLAGGPORT);
    eval 'sub SIOCSLAGGPORT () { &_IOW(ord(\'i\'), 141, \'struct lagg_reqport\');}' unless defined(&SIOCSLAGGPORT);
    eval 'sub SIOCSLAGGDELPORT () { &_IOW(ord(\'i\'), 142, \'struct lagg_reqport\');}' unless defined(&SIOCSLAGGDELPORT);
    eval 'sub ra_lacpreq () { ($ra_psc->{rpsc_lacp});}' unless defined(&ra_lacpreq);
    eval 'sub SIOCGLAGG () { &_IOWR(ord(\'i\'), 143, \'struct lagg_reqall\');}' unless defined(&SIOCGLAGG);
    eval 'sub SIOCSLAGG () { &_IOW(ord(\'i\'), 144, \'struct lagg_reqall\');}' unless defined(&SIOCSLAGG);
    eval 'sub SIOCGLAGGFLAGS () { &_IOWR(ord(\'i\'), 145, \'struct lagg_reqflags\');}' unless defined(&SIOCGLAGGFLAGS);
    eval 'sub SIOCSLAGGHASH () { &_IOW(ord(\'i\'), 146, \'struct lagg_reqflags\');}' unless defined(&SIOCSLAGGHASH);
    eval 'sub LAGG_OPT_NONE () {0x;}' unless defined(&LAGG_OPT_NONE);
    eval 'sub LAGG_OPT_USE_FLOWID () {0x1;}' unless defined(&LAGG_OPT_USE_FLOWID);
    eval 'sub LAGG_OPT_FLOWIDSHIFT () {0x2;}' unless defined(&LAGG_OPT_FLOWIDSHIFT);
    eval 'sub LAGG_OPT_FLOWIDSHIFT_MASK () {0x1f;}' unless defined(&LAGG_OPT_FLOWIDSHIFT_MASK);
    eval 'sub LAGG_OPT_LACP_STRICT () {0x10;}' unless defined(&LAGG_OPT_LACP_STRICT);
    eval 'sub LAGG_OPT_LACP_TXTEST () {0x20;}' unless defined(&LAGG_OPT_LACP_TXTEST);
    eval 'sub LAGG_OPT_LACP_RXTEST () {0x40;}' unless defined(&LAGG_OPT_LACP_RXTEST);
    eval 'sub LAGG_OPT_LACP_TIMEOUT () {0x80;}' unless defined(&LAGG_OPT_LACP_TIMEOUT);
    eval 'sub SIOCGLAGGOPTS () { &_IOWR(ord(\'i\'), 152, \'struct lagg_reqopts\');}' unless defined(&SIOCGLAGGOPTS);
    eval 'sub SIOCSLAGGOPTS () { &_IOW(ord(\'i\'), 153, \'struct lagg_reqopts\');}' unless defined(&SIOCSLAGGOPTS);
    eval 'sub LAGG_OPT_BITS () {"\\020\\001USE_FLOWID\\005LACP_STRICT" "\\006LACP_TXTEST\\007LACP_RXTEST";}' unless defined(&LAGG_OPT_BITS);
    if(defined(&_KERNEL)) {
	eval 'sub LAGG_PORTACTIVE {
	    my($_tp) = @_;
    	    eval q(( (($_tp)-> ($lp_ifp->{if_link_state}) ==  &LINK_STATE_UP)  && (($_tp)-> ($lp_ifp->{if_flags}) &  &IFF_UP) ));
	}' unless defined(&LAGG_PORTACTIVE);
	eval 'sub sc_ifflags () { ($sc_ifp->{if_flags});}' unless defined(&sc_ifflags);
	eval 'sub sc_ifname () { ($sc_ifp->{if_xname});}' unless defined(&sc_ifname);
	eval 'sub LAGG_LOCK_INIT {
	    my($_sc) = @_;
    	    eval q( &rm_init(($_sc)-> &sc_mtx, \\"if_lagg rmlock\\"));
	}' unless defined(&LAGG_LOCK_INIT);
	eval 'sub LAGG_LOCK_DESTROY {
	    my($_sc) = @_;
    	    eval q( &rm_destroy(($_sc)-> &sc_mtx));
	}' unless defined(&LAGG_LOCK_DESTROY);
	eval 'sub LAGG_RLOCK {
	    my($_sc, $_p) = @_;
    	    eval q( &rm_rlock(($_sc)-> &sc_mtx, ($_p)));
	}' unless defined(&LAGG_RLOCK);
	eval 'sub LAGG_WLOCK {
	    my($_sc) = @_;
    	    eval q( &rm_wlock(($_sc)-> &sc_mtx));
	}' unless defined(&LAGG_WLOCK);
	eval 'sub LAGG_RUNLOCK {
	    my($_sc, $_p) = @_;
    	    eval q( &rm_runlock(($_sc)-> &sc_mtx, ($_p)));
	}' unless defined(&LAGG_RUNLOCK);
	eval 'sub LAGG_WUNLOCK {
	    my($_sc) = @_;
    	    eval q( &rm_wunlock(($_sc)-> &sc_mtx));
	}' unless defined(&LAGG_WUNLOCK);
	eval 'sub LAGG_RLOCK_ASSERT {
	    my($_sc) = @_;
    	    eval q( &rm_assert(($_sc)-> &sc_mtx,  &RA_RLOCKED));
	}' unless defined(&LAGG_RLOCK_ASSERT);
	eval 'sub LAGG_WLOCK_ASSERT {
	    my($_sc) = @_;
    	    eval q( &rm_assert(($_sc)-> &sc_mtx,  &RA_WLOCKED));
	}' unless defined(&LAGG_WLOCK_ASSERT);
	eval 'sub LAGG_UNLOCK_ASSERT {
	    my($_sc) = @_;
    	    eval q( &rm_assert(($_sc)-> &sc_mtx,  &RA_UNLOCKED));
	}' unless defined(&LAGG_UNLOCK_ASSERT);
	eval 'sub LAGG_SX_INIT {
	    my($_sc) = @_;
    	    eval q( &sx_init(($_sc)-> &sc_sx, \\"if_lagg sx\\"));
	}' unless defined(&LAGG_SX_INIT);
	eval 'sub LAGG_SX_DESTROY {
	    my($_sc) = @_;
    	    eval q( &sx_destroy(($_sc)-> &sc_sx));
	}' unless defined(&LAGG_SX_DESTROY);
	eval 'sub LAGG_SLOCK {
	    my($_sc) = @_;
    	    eval q( &sx_slock(($_sc)-> &sc_sx));
	}' unless defined(&LAGG_SLOCK);
	eval 'sub LAGG_XLOCK {
	    my($_sc) = @_;
    	    eval q( &sx_xlock(($_sc)-> &sc_sx));
	}' unless defined(&LAGG_XLOCK);
	eval 'sub LAGG_SUNLOCK {
	    my($_sc) = @_;
    	    eval q( &sx_sunlock(($_sc)-> &sc_sx));
	}' unless defined(&LAGG_SUNLOCK);
	eval 'sub LAGG_XUNLOCK {
	    my($_sc) = @_;
    	    eval q( &sx_xunlock(($_sc)-> &sc_sx));
	}' unless defined(&LAGG_XUNLOCK);
	eval 'sub LAGG_SXLOCK_ASSERT {
	    my($_sc) = @_;
    	    eval q( &sx_assert(($_sc)-> &sc_sx,  &SA_LOCKED));
	}' unless defined(&LAGG_SXLOCK_ASSERT);
	eval 'sub LAGG_SLOCK_ASSERT {
	    my($_sc) = @_;
    	    eval q( &sx_assert(($_sc)-> &sc_sx,  &SA_SLOCKED));
	}' unless defined(&LAGG_SLOCK_ASSERT);
	eval 'sub LAGG_XLOCK_ASSERT {
	    my($_sc) = @_;
    	    eval q( &sx_assert(($_sc)-> &sc_sx,  &SA_XLOCKED));
	}' unless defined(&LAGG_XLOCK_ASSERT);
    }
}
1;
