require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_IF_MEDIA_H_)) {
    eval 'sub _NET_IF_MEDIA_H_ () {1;}' unless defined(&_NET_IF_MEDIA_H_);
    if(defined(&_KERNEL)) {
	require 'sys/queue.ph';
    }
    eval 'sub IFM_ETHER () {0x20;}' unless defined(&IFM_ETHER);
    eval 'sub IFM_ETHER_SUBTYPE {
        my($x) = @_;
	    eval q(((($x) &  &IFM_TMASK) | ((($x) & ( &IFM_ETH_XTYPE >>  &IFM_ETH_XSHIFT)) <<  &IFM_ETH_XSHIFT)));
    }' unless defined(&IFM_ETHER_SUBTYPE);
    eval 'sub IFM_X {
        my($x) = @_;
	    eval q( &IFM_ETHER_SUBTYPE($x));
    }' unless defined(&IFM_X);
    eval 'sub IFM_ETHER_SUBTYPE_SET {
        my($x) = @_;
	    eval q(( &IFM_ETHER_SUBTYPE($x) |  &IFM_ETHER));
    }' unless defined(&IFM_ETHER_SUBTYPE_SET);
    eval 'sub IFM_ETHER_SUBTYPE_GET {
        my($x) = @_;
	    eval q((($x) & ( &IFM_TMASK| &IFM_ETH_XTYPE)));
    }' unless defined(&IFM_ETHER_SUBTYPE_GET);
    eval 'sub IFM_ETHER_IS_EXTENDED {
        my($x) = @_;
	    eval q((($x) &  &IFM_ETH_XTYPE));
    }' unless defined(&IFM_ETHER_IS_EXTENDED);
    eval 'sub IFM_10_T () {3;}' unless defined(&IFM_10_T);
    eval 'sub IFM_10_2 () {4;}' unless defined(&IFM_10_2);
    eval 'sub IFM_10_5 () {5;}' unless defined(&IFM_10_5);
    eval 'sub IFM_100_TX () {6;}' unless defined(&IFM_100_TX);
    eval 'sub IFM_100_FX () {7;}' unless defined(&IFM_100_FX);
    eval 'sub IFM_100_T4 () {8;}' unless defined(&IFM_100_T4);
    eval 'sub IFM_100_VG () {9;}' unless defined(&IFM_100_VG);
    eval 'sub IFM_100_T2 () {10;}' unless defined(&IFM_100_T2);
    eval 'sub IFM_1000_SX () {11;}' unless defined(&IFM_1000_SX);
    eval 'sub IFM_10_STP () {12;}' unless defined(&IFM_10_STP);
    eval 'sub IFM_10_FL () {13;}' unless defined(&IFM_10_FL);
    eval 'sub IFM_1000_LX () {14;}' unless defined(&IFM_1000_LX);
    eval 'sub IFM_1000_CX () {15;}' unless defined(&IFM_1000_CX);
    eval 'sub IFM_1000_T () {16;}' unless defined(&IFM_1000_T);
    eval 'sub IFM_HPNA_1 () {17;}' unless defined(&IFM_HPNA_1);
    eval 'sub IFM_10G_LR () {18;}' unless defined(&IFM_10G_LR);
    eval 'sub IFM_10G_SR () {19;}' unless defined(&IFM_10G_SR);
    eval 'sub IFM_10G_CX4 () {20;}' unless defined(&IFM_10G_CX4);
    eval 'sub IFM_2500_SX () {21;}' unless defined(&IFM_2500_SX);
    eval 'sub IFM_10G_TWINAX () {22;}' unless defined(&IFM_10G_TWINAX);
    eval 'sub IFM_10G_TWINAX_LONG () {23;}' unless defined(&IFM_10G_TWINAX_LONG);
    eval 'sub IFM_10G_LRM () {24;}' unless defined(&IFM_10G_LRM);
    eval 'sub IFM_UNKNOWN () {25;}' unless defined(&IFM_UNKNOWN);
    eval 'sub IFM_10G_T () {26;}' unless defined(&IFM_10G_T);
    eval 'sub IFM_40G_CR4 () {27;}' unless defined(&IFM_40G_CR4);
    eval 'sub IFM_40G_SR4 () {28;}' unless defined(&IFM_40G_SR4);
    eval 'sub IFM_40G_LR4 () {29;}' unless defined(&IFM_40G_LR4);
    eval 'sub IFM_1000_KX () {30;}' unless defined(&IFM_1000_KX);
    eval 'sub IFM_OTHER () {31;}' unless defined(&IFM_OTHER);
    eval 'sub IFM_10G_KX4 () { &IFM_X(32);}' unless defined(&IFM_10G_KX4);
    eval 'sub IFM_10G_KR () { &IFM_X(33);}' unless defined(&IFM_10G_KR);
    eval 'sub IFM_10G_CR1 () { &IFM_X(34);}' unless defined(&IFM_10G_CR1);
    eval 'sub IFM_20G_KR2 () { &IFM_X(35);}' unless defined(&IFM_20G_KR2);
    eval 'sub IFM_2500_KX () { &IFM_X(36);}' unless defined(&IFM_2500_KX);
    eval 'sub IFM_2500_T () { &IFM_X(37);}' unless defined(&IFM_2500_T);
    eval 'sub IFM_5000_T () { &IFM_X(38);}' unless defined(&IFM_5000_T);
    eval 'sub IFM_50G_PCIE () { &IFM_X(39);}' unless defined(&IFM_50G_PCIE);
    eval 'sub IFM_25G_PCIE () { &IFM_X(40);}' unless defined(&IFM_25G_PCIE);
    eval 'sub IFM_1000_SGMII () { &IFM_X(41);}' unless defined(&IFM_1000_SGMII);
    eval 'sub IFM_10G_SFI () { &IFM_X(42);}' unless defined(&IFM_10G_SFI);
    eval 'sub IFM_40G_XLPPI () { &IFM_X(43);}' unless defined(&IFM_40G_XLPPI);
    eval 'sub IFM_1000_CX_SGMII () { &IFM_X(44);}' unless defined(&IFM_1000_CX_SGMII);
    eval 'sub IFM_40G_KR4 () { &IFM_X(45);}' unless defined(&IFM_40G_KR4);
    eval 'sub IFM_10G_ER () { &IFM_X(46);}' unless defined(&IFM_10G_ER);
    eval 'sub IFM_100G_CR4 () { &IFM_X(47);}' unless defined(&IFM_100G_CR4);
    eval 'sub IFM_100G_SR4 () { &IFM_X(48);}' unless defined(&IFM_100G_SR4);
    eval 'sub IFM_100G_KR4 () { &IFM_X(49);}' unless defined(&IFM_100G_KR4);
    eval 'sub IFM_100G_LR4 () { &IFM_X(50);}' unless defined(&IFM_100G_LR4);
    eval 'sub IFM_56G_R4 () { &IFM_X(51);}' unless defined(&IFM_56G_R4);
    eval 'sub IFM_100_T () { &IFM_X(52);}' unless defined(&IFM_100_T);
    eval 'sub IFM_25G_CR () { &IFM_X(53);}' unless defined(&IFM_25G_CR);
    eval 'sub IFM_25G_KR () { &IFM_X(54);}' unless defined(&IFM_25G_KR);
    eval 'sub IFM_25G_SR () { &IFM_X(55);}' unless defined(&IFM_25G_SR);
    eval 'sub IFM_50G_CR2 () { &IFM_X(56);}' unless defined(&IFM_50G_CR2);
    eval 'sub IFM_50G_KR2 () { &IFM_X(57);}' unless defined(&IFM_50G_KR2);
    eval 'sub IFM_25G_LR () { &IFM_X(58);}' unless defined(&IFM_25G_LR);
    eval 'sub IFM_10G_AOC () { &IFM_X(59);}' unless defined(&IFM_10G_AOC);
    eval 'sub IFM_25G_ACC () { &IFM_X(60);}' unless defined(&IFM_25G_ACC);
    eval 'sub IFM_25G_AOC () { &IFM_X(61);}' unless defined(&IFM_25G_AOC);
    eval 'sub IFM_ETH_MASTER () {0x100;}' unless defined(&IFM_ETH_MASTER);
    eval 'sub IFM_ETH_RXPAUSE () {0x200;}' unless defined(&IFM_ETH_RXPAUSE);
    eval 'sub IFM_ETH_TXPAUSE () {0x400;}' unless defined(&IFM_ETH_TXPAUSE);
    eval 'sub IFM_ETH_XTYPE () {0x7800;}' unless defined(&IFM_ETH_XTYPE);
    eval 'sub IFM_ETH_XSHIFT () {6;}' unless defined(&IFM_ETH_XSHIFT);
    eval 'sub IFM_TOKEN () {0x40;}' unless defined(&IFM_TOKEN);
    eval 'sub IFM_TOK_STP4 () {3;}' unless defined(&IFM_TOK_STP4);
    eval 'sub IFM_TOK_STP16 () {4;}' unless defined(&IFM_TOK_STP16);
    eval 'sub IFM_TOK_UTP4 () {5;}' unless defined(&IFM_TOK_UTP4);
    eval 'sub IFM_TOK_UTP16 () {6;}' unless defined(&IFM_TOK_UTP16);
    eval 'sub IFM_TOK_STP100 () {7;}' unless defined(&IFM_TOK_STP100);
    eval 'sub IFM_TOK_UTP100 () {8;}' unless defined(&IFM_TOK_UTP100);
    eval 'sub IFM_TOK_ETR () {0x200;}' unless defined(&IFM_TOK_ETR);
    eval 'sub IFM_TOK_SRCRT () {0x400;}' unless defined(&IFM_TOK_SRCRT);
    eval 'sub IFM_TOK_ALLR () {0x800;}' unless defined(&IFM_TOK_ALLR);
    eval 'sub IFM_TOK_DTR () {0x2000;}' unless defined(&IFM_TOK_DTR);
    eval 'sub IFM_TOK_CLASSIC () {0x4000;}' unless defined(&IFM_TOK_CLASSIC);
    eval 'sub IFM_TOK_AUTO () {0x8000;}' unless defined(&IFM_TOK_AUTO);
    eval 'sub IFM_FDDI () {0x60;}' unless defined(&IFM_FDDI);
    eval 'sub IFM_FDDI_SMF () {3;}' unless defined(&IFM_FDDI_SMF);
    eval 'sub IFM_FDDI_MMF () {4;}' unless defined(&IFM_FDDI_MMF);
    eval 'sub IFM_FDDI_UTP () {5;}' unless defined(&IFM_FDDI_UTP);
    eval 'sub IFM_FDDI_DA () {0x100;}' unless defined(&IFM_FDDI_DA);
    eval 'sub IFM_IEEE80211 () {0x80;}' unless defined(&IFM_IEEE80211);
    eval 'sub IFM_IEEE80211_FH1 () {3;}' unless defined(&IFM_IEEE80211_FH1);
    eval 'sub IFM_IEEE80211_FH2 () {4;}' unless defined(&IFM_IEEE80211_FH2);
    eval 'sub IFM_IEEE80211_DS1 () {5;}' unless defined(&IFM_IEEE80211_DS1);
    eval 'sub IFM_IEEE80211_DS2 () {6;}' unless defined(&IFM_IEEE80211_DS2);
    eval 'sub IFM_IEEE80211_DS5 () {7;}' unless defined(&IFM_IEEE80211_DS5);
    eval 'sub IFM_IEEE80211_DS11 () {8;}' unless defined(&IFM_IEEE80211_DS11);
    eval 'sub IFM_IEEE80211_DS22 () {9;}' unless defined(&IFM_IEEE80211_DS22);
    eval 'sub IFM_IEEE80211_OFDM6 () {10;}' unless defined(&IFM_IEEE80211_OFDM6);
    eval 'sub IFM_IEEE80211_OFDM9 () {11;}' unless defined(&IFM_IEEE80211_OFDM9);
    eval 'sub IFM_IEEE80211_OFDM12 () {12;}' unless defined(&IFM_IEEE80211_OFDM12);
    eval 'sub IFM_IEEE80211_OFDM18 () {13;}' unless defined(&IFM_IEEE80211_OFDM18);
    eval 'sub IFM_IEEE80211_OFDM24 () {14;}' unless defined(&IFM_IEEE80211_OFDM24);
    eval 'sub IFM_IEEE80211_OFDM36 () {15;}' unless defined(&IFM_IEEE80211_OFDM36);
    eval 'sub IFM_IEEE80211_OFDM48 () {16;}' unless defined(&IFM_IEEE80211_OFDM48);
    eval 'sub IFM_IEEE80211_OFDM54 () {17;}' unless defined(&IFM_IEEE80211_OFDM54);
    eval 'sub IFM_IEEE80211_OFDM72 () {18;}' unless defined(&IFM_IEEE80211_OFDM72);
    eval 'sub IFM_IEEE80211_DS354k () {19;}' unless defined(&IFM_IEEE80211_DS354k);
    eval 'sub IFM_IEEE80211_DS512k () {20;}' unless defined(&IFM_IEEE80211_DS512k);
    eval 'sub IFM_IEEE80211_OFDM3 () {21;}' unless defined(&IFM_IEEE80211_OFDM3);
    eval 'sub IFM_IEEE80211_OFDM4 () {22;}' unless defined(&IFM_IEEE80211_OFDM4);
    eval 'sub IFM_IEEE80211_OFDM27 () {23;}' unless defined(&IFM_IEEE80211_OFDM27);
    eval 'sub IFM_IEEE80211_MCS () {24;}' unless defined(&IFM_IEEE80211_MCS);
    eval 'sub IFM_IEEE80211_ADHOC () {0x100;}' unless defined(&IFM_IEEE80211_ADHOC);
    eval 'sub IFM_IEEE80211_HOSTAP () {0x200;}' unless defined(&IFM_IEEE80211_HOSTAP);
    eval 'sub IFM_IEEE80211_IBSS () {0x400;}' unless defined(&IFM_IEEE80211_IBSS);
    eval 'sub IFM_IEEE80211_WDS () {0x800;}' unless defined(&IFM_IEEE80211_WDS);
    eval 'sub IFM_IEEE80211_TURBO () {0x1000;}' unless defined(&IFM_IEEE80211_TURBO);
    eval 'sub IFM_IEEE80211_MONITOR () {0x2000;}' unless defined(&IFM_IEEE80211_MONITOR);
    eval 'sub IFM_IEEE80211_MBSS () {0x4000;}' unless defined(&IFM_IEEE80211_MBSS);
    eval 'sub IFM_IEEE80211_11A () {0x10000;}' unless defined(&IFM_IEEE80211_11A);
    eval 'sub IFM_IEEE80211_11B () {0x20000;}' unless defined(&IFM_IEEE80211_11B);
    eval 'sub IFM_IEEE80211_11G () {0x30000;}' unless defined(&IFM_IEEE80211_11G);
    eval 'sub IFM_IEEE80211_FH () {0x40000;}' unless defined(&IFM_IEEE80211_FH);
    eval 'sub IFM_IEEE80211_11NA () {0x50000;}' unless defined(&IFM_IEEE80211_11NA);
    eval 'sub IFM_IEEE80211_11NG () {0x60000;}' unless defined(&IFM_IEEE80211_11NG);
    eval 'sub IFM_ATM () {0xa0;}' unless defined(&IFM_ATM);
    eval 'sub IFM_ATM_UNKNOWN () {3;}' unless defined(&IFM_ATM_UNKNOWN);
    eval 'sub IFM_ATM_UTP_25 () {4;}' unless defined(&IFM_ATM_UTP_25);
    eval 'sub IFM_ATM_TAXI_100 () {5;}' unless defined(&IFM_ATM_TAXI_100);
    eval 'sub IFM_ATM_TAXI_140 () {6;}' unless defined(&IFM_ATM_TAXI_140);
    eval 'sub IFM_ATM_MM_155 () {7;}' unless defined(&IFM_ATM_MM_155);
    eval 'sub IFM_ATM_SM_155 () {8;}' unless defined(&IFM_ATM_SM_155);
    eval 'sub IFM_ATM_UTP_155 () {9;}' unless defined(&IFM_ATM_UTP_155);
    eval 'sub IFM_ATM_MM_622 () {10;}' unless defined(&IFM_ATM_MM_622);
    eval 'sub IFM_ATM_SM_622 () {11;}' unless defined(&IFM_ATM_SM_622);
    eval 'sub IFM_ATM_VIRTUAL () {12;}' unless defined(&IFM_ATM_VIRTUAL);
    eval 'sub IFM_ATM_SDH () {0x100;}' unless defined(&IFM_ATM_SDH);
    eval 'sub IFM_ATM_NOSCRAMB () {0x200;}' unless defined(&IFM_ATM_NOSCRAMB);
    eval 'sub IFM_ATM_UNASSIGNED () {0x400;}' unless defined(&IFM_ATM_UNASSIGNED);
    eval 'sub IFM_AUTO () {0;}' unless defined(&IFM_AUTO);
    eval 'sub IFM_MANUAL () {1;}' unless defined(&IFM_MANUAL);
    eval 'sub IFM_NONE () {2;}' unless defined(&IFM_NONE);
    eval 'sub IFM_FDX () {0x100000;}' unless defined(&IFM_FDX);
    eval 'sub IFM_HDX () {0x200000;}' unless defined(&IFM_HDX);
    eval 'sub IFM_FLOW () {0x400000;}' unless defined(&IFM_FLOW);
    eval 'sub IFM_FLAG0 () {0x1000000;}' unless defined(&IFM_FLAG0);
    eval 'sub IFM_FLAG1 () {0x2000000;}' unless defined(&IFM_FLAG1);
    eval 'sub IFM_FLAG2 () {0x4000000;}' unless defined(&IFM_FLAG2);
    eval 'sub IFM_LOOP () {0x8000000;}' unless defined(&IFM_LOOP);
    eval 'sub IFM_NMASK () {0xe0;}' unless defined(&IFM_NMASK);
    eval 'sub IFM_TMASK () {0x1f;}' unless defined(&IFM_TMASK);
    eval 'sub IFM_IMASK () {0xf0000000;}' unless defined(&IFM_IMASK);
    eval 'sub IFM_ISHIFT () {28;}' unless defined(&IFM_ISHIFT);
    eval 'sub IFM_OMASK () {0xff00;}' unless defined(&IFM_OMASK);
    eval 'sub IFM_MMASK () {0x70000;}' unless defined(&IFM_MMASK);
    eval 'sub IFM_MSHIFT () {16;}' unless defined(&IFM_MSHIFT);
    eval 'sub IFM_GMASK () {0xff00000;}' unless defined(&IFM_GMASK);
    eval 'sub IFM_ETH_FMASK () {( &IFM_FLOW |  &IFM_ETH_RXPAUSE |  &IFM_ETH_TXPAUSE);}' unless defined(&IFM_ETH_FMASK);
    eval 'sub IFM_AVALID () {0x1;}' unless defined(&IFM_AVALID);
    eval 'sub IFM_ACTIVE () {0x2;}' unless defined(&IFM_ACTIVE);
    eval 'sub IFM_STATUS_VALID () { &IFM_AVALID;}' unless defined(&IFM_STATUS_VALID);
    eval 'sub IFM_STATUS_VALID_LIST () {{  &IFM_AVALID, 0};}' unless defined(&IFM_STATUS_VALID_LIST);
    eval 'sub IFM_TYPE {
        my($x) = @_;
	    eval q((($x) &  &IFM_NMASK));
    }' unless defined(&IFM_TYPE);
    eval 'sub IFM_SUBTYPE {
        my($x) = @_;
	    eval q(( &IFM_TYPE($x) ==  &IFM_ETHER ?  &IFM_ETHER_SUBTYPE_GET($x) : (($x) &  &IFM_TMASK)));
    }' unless defined(&IFM_SUBTYPE);
    eval 'sub IFM_TYPE_MATCH {
        my($x,$y) = @_;
	    eval q(( &IFM_TYPE($x) ==  &IFM_TYPE($y)  &&  &IFM_SUBTYPE($x) ==  &IFM_SUBTYPE($y)));
    }' unless defined(&IFM_TYPE_MATCH);
    eval 'sub IFM_TYPE_OPTIONS {
        my($x) = @_;
	    eval q((($x) &  &IFM_OMASK));
    }' unless defined(&IFM_TYPE_OPTIONS);
    eval 'sub IFM_INST {
        my($x) = @_;
	    eval q(((($x) &  &IFM_IMASK) >>  &IFM_ISHIFT));
    }' unless defined(&IFM_INST);
    eval 'sub IFM_OPTIONS {
        my($x) = @_;
	    eval q((($x) & ( &IFM_OMASK |  &IFM_GMASK)));
    }' unless defined(&IFM_OPTIONS);
    eval 'sub IFM_MODE {
        my($x) = @_;
	    eval q((($x) &  &IFM_MMASK));
    }' unless defined(&IFM_MODE);
    eval 'sub IFM_INST_MAX () { &IFM_INST( &IFM_IMASK);}' unless defined(&IFM_INST_MAX);
    eval 'sub IFM_MAKEWORD {
        my($type, $subtype, $options, $instance) = @_;
	    eval q((($type) | ($subtype) | ($options) | (($instance) <<  &IFM_ISHIFT)));
    }' unless defined(&IFM_MAKEWORD);
    eval 'sub IFM_MAKEMODE {
        my($mode) = @_;
	    eval q(((($mode) <<  &IFM_MSHIFT) &  &IFM_MMASK));
    }' unless defined(&IFM_MAKEMODE);
    eval 'sub IFM_TYPE_DESCRIPTIONS () {{ {  &IFM_ETHER, "Ethernet" }, {  &IFM_TOKEN, "Token ring" }, {  &IFM_FDDI, "FDDI" }, {  &IFM_IEEE80211, "IEEE 802.11 Wireless Ethernet" }, {  &IFM_ATM, "ATM" }, { 0,  &NULL }, };}' unless defined(&IFM_TYPE_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_ETHERNET_DESCRIPTIONS () {{ {  &IFM_10_T, "10baseT/UTP" }, {  &IFM_10_2, "10base2/BNC" }, {  &IFM_10_5, "10base5/AUI" }, {  &IFM_100_TX, "100baseTX" }, {  &IFM_100_FX, "100baseFX" }, {  &IFM_100_T4, "100baseT4" }, {  &IFM_100_VG, "100baseVG" }, {  &IFM_100_T2, "100baseT2" }, {  &IFM_10_STP, "10baseSTP" }, {  &IFM_10_FL, "10baseFL" }, {  &IFM_1000_SX, "1000baseSX" }, {  &IFM_1000_LX, "1000baseLX" }, {  &IFM_1000_CX, "1000baseCX" }, {  &IFM_1000_T, "1000baseT" }, {  &IFM_HPNA_1, "homePNA" }, {  &IFM_10G_LR, "10Gbase-LR" }, {  &IFM_10G_SR, "10Gbase-SR" }, {  &IFM_10G_CX4, "10Gbase-CX4" }, {  &IFM_2500_SX, "2500BaseSX" }, {  &IFM_10G_LRM, "10Gbase-LRM" }, {  &IFM_10G_TWINAX, "10Gbase-Twinax" }, {  &IFM_10G_TWINAX_LONG, "10Gbase-Twinax-Long" }, {  &IFM_UNKNOWN, "Unknown" }, {  &IFM_10G_T, "10Gbase-T" }, {  &IFM_40G_CR4, "40Gbase-CR4" }, {  &IFM_40G_SR4, "40Gbase-SR4" }, {  &IFM_40G_LR4, "40Gbase-LR4" }, {  &IFM_1000_KX, "1000Base-KX" }, {  &IFM_OTHER, "Other" }, {  &IFM_10G_KX4, "10GBase-KX4" }, {  &IFM_10G_KR, "10GBase-KR" }, {  &IFM_10G_CR1, "10GBase-CR1" }, {  &IFM_20G_KR2, "20GBase-KR2" }, {  &IFM_2500_KX, "2500Base-KX" }, {  &IFM_2500_T, "2500Base-T" }, {  &IFM_5000_T, "5000Base-T" }, {  &IFM_50G_PCIE, "PCIExpress-50G" }, {  &IFM_25G_PCIE, "PCIExpress-25G" }, {  &IFM_1000_SGMII, "1000Base-SGMII" }, {  &IFM_10G_SFI, "10GBase-SFI" }, {  &IFM_40G_XLPPI, "40GBase-XLPPI" }, {  &IFM_1000_CX_SGMII, "1000Base-CX-SGMII" }, {  &IFM_40G_KR4, "40GBase-KR4" }, {  &IFM_10G_ER, "10GBase-ER" }, {  &IFM_100G_CR4, "100GBase-CR4" }, {  &IFM_100G_SR4, "100GBase-SR4" }, {  &IFM_100G_KR4, "100GBase-KR4" }, {  &IFM_100G_LR4, "100GBase-LR4" }, {  &IFM_56G_R4, "56GBase-R4" }, {  &IFM_100_T, "100BaseT" }, {  &IFM_25G_CR, "25GBase-CR" }, {  &IFM_25G_KR, "25GBase-KR" }, {  &IFM_25G_SR, "25GBase-SR" }, {  &IFM_50G_CR2, "50GBase-CR2" }, {  &IFM_50G_KR2, "50GBase-KR2" }, {  &IFM_25G_LR, "25GBase-LR" }, {  &IFM_10G_AOC, "10GBase-AOC" }, {  &IFM_25G_ACC, "25GBase-ACC" }, {  &IFM_25G_AOC, "25GBase-AOC" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_ETHERNET_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_ETHERNET_ALIASES () {{ {  &IFM_10_T, "10baseT" }, {  &IFM_10_T, "UTP" }, {  &IFM_10_T, "10UTP" }, {  &IFM_10_2, "BNC" }, {  &IFM_10_2, "10BNC" }, {  &IFM_10_5, "AUI" }, {  &IFM_10_5, "10AUI" }, {  &IFM_100_TX, "100TX" }, {  &IFM_100_T4, "100T4" }, {  &IFM_100_VG, "100VG" }, {  &IFM_100_T2, "100T2" }, {  &IFM_10_STP, "10STP" }, {  &IFM_10_FL, "10FL" }, {  &IFM_1000_SX, "1000SX" }, {  &IFM_1000_LX, "1000LX" }, {  &IFM_1000_CX, "1000CX" }, {  &IFM_1000_T, "1000baseTX" }, {  &IFM_1000_T, "1000TX" }, {  &IFM_1000_T, "1000T" }, {  &IFM_2500_SX, "2500SX" }, {  &IFM_10_T |  &IFM_FDX, "10baseT-FDX" }, {  &IFM_10_T |  &IFM_FDX |  &IFM_FLOW, "10baseT-FDX-flow" }, {  &IFM_100_TX |  &IFM_FDX, "100baseTX-FDX" }, {  &IFM_100_TX |  &IFM_FDX |  &IFM_FLOW, "100baseTX-FDX-flow" }, {  &IFM_1000_T |  &IFM_FDX, "1000baseT-FDX" }, {  &IFM_1000_T |  &IFM_FDX |  &IFM_FLOW, "1000baseT-FDX-flow" }, {  &IFM_1000_T |  &IFM_FDX |  &IFM_FLOW |  &IFM_ETH_MASTER, "1000baseT-FDX-flow-master" }, {  &IFM_1000_T |  &IFM_FDX |  &IFM_ETH_MASTER, "1000baseT-FDX-master" }, {  &IFM_1000_T |  &IFM_ETH_MASTER, "1000baseT-master" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_ETHERNET_ALIASES);
    eval 'sub IFM_SUBTYPE_ETHERNET_OPTION_DESCRIPTIONS () {{ {  &IFM_ETH_MASTER, "master" }, {  &IFM_ETH_RXPAUSE, "rxpause" }, {  &IFM_ETH_TXPAUSE, "txpause" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_ETHERNET_OPTION_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_TOKENRING_DESCRIPTIONS () {{ {  &IFM_TOK_STP4, "DB9/4Mbit" }, {  &IFM_TOK_STP16, "DB9/16Mbit" }, {  &IFM_TOK_UTP4, "UTP/4Mbit" }, {  &IFM_TOK_UTP16, "UTP/16Mbit" }, {  &IFM_TOK_STP100, "STP/100Mbit" }, {  &IFM_TOK_UTP100, "UTP/100Mbit" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_TOKENRING_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_TOKENRING_ALIASES () {{ {  &IFM_TOK_STP4, "4STP" }, {  &IFM_TOK_STP16, "16STP" }, {  &IFM_TOK_UTP4, "4UTP" }, {  &IFM_TOK_UTP16, "16UTP" }, {  &IFM_TOK_STP100, "100STP" }, {  &IFM_TOK_UTP100, "100UTP" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_TOKENRING_ALIASES);
    eval 'sub IFM_SUBTYPE_TOKENRING_OPTION_DESCRIPTIONS () {{ {  &IFM_TOK_ETR, "EarlyTokenRelease" }, {  &IFM_TOK_SRCRT, "SourceRouting" }, {  &IFM_TOK_ALLR, "AllRoutes" }, {  &IFM_TOK_DTR, "Dedicated" }, {  &IFM_TOK_CLASSIC,"Classic" }, {  &IFM_TOK_AUTO, " " }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_TOKENRING_OPTION_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_FDDI_DESCRIPTIONS () {{ {  &IFM_FDDI_SMF, "Single-mode" }, {  &IFM_FDDI_MMF, "Multi-mode" }, {  &IFM_FDDI_UTP, "UTP" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_FDDI_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_FDDI_ALIASES () {{ {  &IFM_FDDI_SMF, "SMF" }, {  &IFM_FDDI_MMF, "MMF" }, {  &IFM_FDDI_UTP, "CDDI" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_FDDI_ALIASES);
    eval 'sub IFM_SUBTYPE_FDDI_OPTION_DESCRIPTIONS () {{ {  &IFM_FDDI_DA, "Dual-attach" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_FDDI_OPTION_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_IEEE80211_DESCRIPTIONS () {{ {  &IFM_IEEE80211_FH1, "FH/1Mbps" }, {  &IFM_IEEE80211_FH2, "FH/2Mbps" }, {  &IFM_IEEE80211_DS1, "DS/1Mbps" }, {  &IFM_IEEE80211_DS2, "DS/2Mbps" }, {  &IFM_IEEE80211_DS5, "DS/5.5Mbps" }, {  &IFM_IEEE80211_DS11, "DS/11Mbps" }, {  &IFM_IEEE80211_DS22, "DS/22Mbps" }, {  &IFM_IEEE80211_OFDM6, "OFDM/6Mbps" }, {  &IFM_IEEE80211_OFDM9, "OFDM/9Mbps" }, {  &IFM_IEEE80211_OFDM12, "OFDM/12Mbps" }, {  &IFM_IEEE80211_OFDM18, "OFDM/18Mbps" }, {  &IFM_IEEE80211_OFDM24, "OFDM/24Mbps" }, {  &IFM_IEEE80211_OFDM36, "OFDM/36Mbps" }, {  &IFM_IEEE80211_OFDM48, "OFDM/48Mbps" }, {  &IFM_IEEE80211_OFDM54, "OFDM/54Mbps" }, {  &IFM_IEEE80211_OFDM72, "OFDM/72Mbps" }, {  &IFM_IEEE80211_DS354k, "DS/354Kbps" }, {  &IFM_IEEE80211_DS512k, "DS/512Kbps" }, {  &IFM_IEEE80211_OFDM3, "OFDM/3Mbps" }, {  &IFM_IEEE80211_OFDM4, "OFDM/4.5Mbps" }, {  &IFM_IEEE80211_OFDM27, "OFDM/27Mbps" }, {  &IFM_IEEE80211_MCS, "MCS" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_IEEE80211_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_IEEE80211_ALIASES () {{ {  &IFM_IEEE80211_FH1, "FH1" }, {  &IFM_IEEE80211_FH2, "FH2" }, {  &IFM_IEEE80211_FH1, "FrequencyHopping/1Mbps" }, {  &IFM_IEEE80211_FH2, "FrequencyHopping/2Mbps" }, {  &IFM_IEEE80211_DS1, "DS1" }, {  &IFM_IEEE80211_DS2, "DS2" }, {  &IFM_IEEE80211_DS5, "DS5.5" }, {  &IFM_IEEE80211_DS11, "DS11" }, {  &IFM_IEEE80211_DS22, "DS22" }, {  &IFM_IEEE80211_DS1, "DirectSequence/1Mbps" }, {  &IFM_IEEE80211_DS2, "DirectSequence/2Mbps" }, {  &IFM_IEEE80211_DS5, "DirectSequence/5.5Mbps" }, {  &IFM_IEEE80211_DS11, "DirectSequence/11Mbps" }, {  &IFM_IEEE80211_DS22, "DirectSequence/22Mbps" }, {  &IFM_IEEE80211_OFDM6, "OFDM6" }, {  &IFM_IEEE80211_OFDM9, "OFDM9" }, {  &IFM_IEEE80211_OFDM12, "OFDM12" }, {  &IFM_IEEE80211_OFDM18, "OFDM18" }, {  &IFM_IEEE80211_OFDM24, "OFDM24" }, {  &IFM_IEEE80211_OFDM36, "OFDM36" }, {  &IFM_IEEE80211_OFDM48, "OFDM48" }, {  &IFM_IEEE80211_OFDM54, "OFDM54" }, {  &IFM_IEEE80211_OFDM72, "OFDM72" }, {  &IFM_IEEE80211_DS1, "CCK1" }, {  &IFM_IEEE80211_DS2, "CCK2" }, {  &IFM_IEEE80211_DS5, "CCK5.5" }, {  &IFM_IEEE80211_DS11, "CCK11" }, {  &IFM_IEEE80211_DS354k, "DS354K" }, {  &IFM_IEEE80211_DS354k, "DirectSequence/354Kbps" }, {  &IFM_IEEE80211_DS512k, "DS512K" }, {  &IFM_IEEE80211_DS512k, "DirectSequence/512Kbps" }, {  &IFM_IEEE80211_OFDM3, "OFDM3" }, {  &IFM_IEEE80211_OFDM4, "OFDM4.5" }, {  &IFM_IEEE80211_OFDM27, "OFDM27" }, {  &IFM_IEEE80211_MCS, "MCS" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_IEEE80211_ALIASES);
    eval 'sub IFM_SUBTYPE_IEEE80211_OPTION_DESCRIPTIONS () {{ {  &IFM_IEEE80211_ADHOC, "adhoc" }, {  &IFM_IEEE80211_HOSTAP, "hostap" }, {  &IFM_IEEE80211_IBSS, "ibss" }, {  &IFM_IEEE80211_WDS, "wds" }, {  &IFM_IEEE80211_TURBO, "turbo" }, {  &IFM_IEEE80211_MONITOR, "monitor" }, {  &IFM_IEEE80211_MBSS, "mesh" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_IEEE80211_OPTION_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_IEEE80211_MODE_DESCRIPTIONS () {{ {  &IFM_AUTO, "autoselect" }, {  &IFM_IEEE80211_11A, "11a" }, {  &IFM_IEEE80211_11B, "11b" }, {  &IFM_IEEE80211_11G, "11g" }, {  &IFM_IEEE80211_FH, "fh" }, {  &IFM_IEEE80211_11NA, "11na" }, {  &IFM_IEEE80211_11NG, "11ng" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_IEEE80211_MODE_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_IEEE80211_MODE_ALIASES () {{ {  &IFM_AUTO, "auto" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_IEEE80211_MODE_ALIASES);
    eval 'sub IFM_SUBTYPE_ATM_DESCRIPTIONS () {{ {  &IFM_ATM_UNKNOWN, "Unknown" }, {  &IFM_ATM_UTP_25, "UTP/25.6MBit" }, {  &IFM_ATM_TAXI_100, "Taxi/100MBit" }, {  &IFM_ATM_TAXI_140, "Taxi/140MBit" }, {  &IFM_ATM_MM_155, "Multi-mode/155MBit" }, {  &IFM_ATM_SM_155, "Single-mode/155MBit" }, {  &IFM_ATM_UTP_155, "UTP/155MBit" }, {  &IFM_ATM_MM_622, "Multi-mode/622MBit" }, {  &IFM_ATM_SM_622, "Single-mode/622MBit" }, {  &IFM_ATM_VIRTUAL, "Virtual" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_ATM_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_ATM_ALIASES () {{ {  &IFM_ATM_UNKNOWN, "UNKNOWN" }, {  &IFM_ATM_UTP_25, "UTP-25" }, {  &IFM_ATM_TAXI_100, "TAXI-100" }, {  &IFM_ATM_TAXI_140, "TAXI-140" }, {  &IFM_ATM_MM_155, "MM-155" }, {  &IFM_ATM_SM_155, "SM-155" }, {  &IFM_ATM_UTP_155, "UTP-155" }, {  &IFM_ATM_MM_622, "MM-622" }, {  &IFM_ATM_SM_622, "SM-622" }, {  &IFM_ATM_VIRTUAL, "VIRTUAL" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_ATM_ALIASES);
    eval 'sub IFM_SUBTYPE_ATM_OPTION_DESCRIPTIONS () {{ {  &IFM_ATM_SDH, "SDH" }, {  &IFM_ATM_NOSCRAMB, "Noscramb" }, {  &IFM_ATM_UNASSIGNED, "Unassigned" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_ATM_OPTION_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_SHARED_DESCRIPTIONS () {{ {  &IFM_AUTO, "autoselect" }, {  &IFM_MANUAL, "manual" }, {  &IFM_NONE, "none" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_SHARED_DESCRIPTIONS);
    eval 'sub IFM_SUBTYPE_SHARED_ALIASES () {{ {  &IFM_AUTO, "auto" }, {  &IFM_AUTO |  &IFM_FLOW, "auto-flow" }, { 0,  &NULL }, };}' unless defined(&IFM_SUBTYPE_SHARED_ALIASES);
    eval 'sub IFM_SHARED_OPTION_DESCRIPTIONS () {{ {  &IFM_FDX, "full-duplex" }, {  &IFM_HDX, "half-duplex" }, {  &IFM_FLOW, "flowcontrol" }, {  &IFM_FLAG0, "flag0" }, {  &IFM_FLAG1, "flag1" }, {  &IFM_FLAG2, "flag2" }, {  &IFM_LOOP, "hw-loopback" }, { 0,  &NULL }, };}' unless defined(&IFM_SHARED_OPTION_DESCRIPTIONS);
    eval 'sub IFM_SHARED_OPTION_ALIASES () {{ {  &IFM_FDX, "fdx" }, {  &IFM_HDX, "hdx" }, {  &IFM_FLOW, "flow" }, {  &IFM_LOOP, "loop" }, {  &IFM_LOOP, "loopback" }, { 0,  &NULL }, };}' unless defined(&IFM_SHARED_OPTION_ALIASES);
    eval 'sub IFM_BAUDRATE_DESCRIPTIONS () {{ {  &IFM_ETHER |  &IFM_10_T,  &IF_Mbps(10) }, {  &IFM_ETHER |  &IFM_10_2,  &IF_Mbps(10) }, {  &IFM_ETHER |  &IFM_10_5,  &IF_Mbps(10) }, {  &IFM_ETHER |  &IFM_100_TX,  &IF_Mbps(100) }, {  &IFM_ETHER |  &IFM_100_FX,  &IF_Mbps(100) }, {  &IFM_ETHER |  &IFM_100_T4,  &IF_Mbps(100) }, {  &IFM_ETHER |  &IFM_100_VG,  &IF_Mbps(100) }, {  &IFM_ETHER |  &IFM_100_T2,  &IF_Mbps(100) }, {  &IFM_ETHER |  &IFM_1000_SX,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_10_STP,  &IF_Mbps(10) }, {  &IFM_ETHER |  &IFM_10_FL,  &IF_Mbps(10) }, {  &IFM_ETHER |  &IFM_1000_LX,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_1000_CX,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_1000_T,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_HPNA_1,  &IF_Mbps(1) }, {  &IFM_ETHER |  &IFM_10G_LR,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_SR,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_CX4,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_2500_SX,  &IF_Mbps(2500) }, {  &IFM_ETHER |  &IFM_10G_TWINAX,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_TWINAX_LONG,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_LRM,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_T,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_40G_CR4,  &IF_Gbps(40) }, {  &IFM_ETHER |  &IFM_40G_SR4,  &IF_Gbps(40) }, {  &IFM_ETHER |  &IFM_40G_LR4,  &IF_Gbps(40) }, {  &IFM_ETHER |  &IFM_1000_KX,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_10G_KX4,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_KR,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_10G_CR1,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_20G_KR2,  &IF_Gbps(20) }, {  &IFM_ETHER |  &IFM_2500_KX,  &IF_Mbps(2500) }, {  &IFM_ETHER |  &IFM_2500_T,  &IF_Mbps(2500) }, {  &IFM_ETHER |  &IFM_5000_T,  &IF_Mbps(5000) }, {  &IFM_ETHER |  &IFM_50G_PCIE,  &IF_Gbps(50) }, {  &IFM_ETHER |  &IFM_25G_PCIE,  &IF_Gbps(25) }, {  &IFM_ETHER |  &IFM_1000_SGMII,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_10G_SFI,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_40G_XLPPI,  &IF_Gbps(40) }, {  &IFM_ETHER |  &IFM_1000_CX_SGMII,  &IF_Mbps(1000) }, {  &IFM_ETHER |  &IFM_40G_KR4,  &IF_Gbps(40) }, {  &IFM_ETHER |  &IFM_10G_ER,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_100G_CR4,  &IF_Gbps(100) }, {  &IFM_ETHER |  &IFM_100G_SR4,  &IF_Gbps(100) }, {  &IFM_ETHER |  &IFM_100G_KR4,  &IF_Gbps(100) }, {  &IFM_ETHER |  &IFM_100G_LR4,  &IF_Gbps(100) }, {  &IFM_ETHER |  &IFM_56G_R4,  &IF_Gbps(56) }, {  &IFM_ETHER |  &IFM_100_T,  &IF_Mbps(100) }, {  &IFM_ETHER |  &IFM_25G_CR,  &IF_Gbps(25) }, {  &IFM_ETHER |  &IFM_25G_KR,  &IF_Gbps(25) }, {  &IFM_ETHER |  &IFM_25G_SR,  &IF_Gbps(25) }, {  &IFM_ETHER |  &IFM_50G_CR2,  &IF_Gbps(50) }, {  &IFM_ETHER |  &IFM_50G_KR2,  &IF_Gbps(50) }, {  &IFM_ETHER |  &IFM_25G_LR,  &IF_Gbps(25) }, {  &IFM_ETHER |  &IFM_10G_AOC,  &IF_Gbps(10) }, {  &IFM_ETHER |  &IFM_25G_ACC,  &IF_Gbps(25) }, {  &IFM_ETHER |  &IFM_25G_AOC,  &IF_Gbps(25) }, {  &IFM_TOKEN |  &IFM_TOK_STP4,  &IF_Mbps(4) }, {  &IFM_TOKEN |  &IFM_TOK_STP16,  &IF_Mbps(16) }, {  &IFM_TOKEN |  &IFM_TOK_UTP4,  &IF_Mbps(4) }, {  &IFM_TOKEN |  &IFM_TOK_UTP16,  &IF_Mbps(16) }, {  &IFM_FDDI |  &IFM_FDDI_SMF,  &IF_Mbps(100) }, {  &IFM_FDDI |  &IFM_FDDI_MMF,  &IF_Mbps(100) }, {  &IFM_FDDI |  &IFM_FDDI_UTP,  &IF_Mbps(100) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_FH1,  &IF_Mbps(1) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_FH2,  &IF_Mbps(2) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS2,  &IF_Mbps(2) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS5,  &IF_Kbps(5500) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS11,  &IF_Mbps(11) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS1,  &IF_Mbps(1) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_DS22,  &IF_Mbps(22) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM6,  &IF_Mbps(6) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM9,  &IF_Mbps(9) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM12,  &IF_Mbps(12) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM18,  &IF_Mbps(18) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM24,  &IF_Mbps(24) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM36,  &IF_Mbps(36) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM48,  &IF_Mbps(48) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM54,  &IF_Mbps(54) }, {  &IFM_IEEE80211 |  &IFM_IEEE80211_OFDM72,  &IF_Mbps(72) }, { 0, 0}, };}' unless defined(&IFM_BAUDRATE_DESCRIPTIONS);
    eval 'sub IFM_STATUS_DESC {
        my($ifms, $bit) = @_;
	    eval q(($ifms)-> $ifms_string[(($ifms)-> &ifms_bit & ($bit)) ? 1: 0]);
    }' unless defined(&IFM_STATUS_DESC);
    eval 'sub IFM_STATUS_DESCRIPTIONS () {{ {  &IFM_ETHER,  &IFM_AVALID,  &IFM_ACTIVE, { "no carrier", "active" } }, {  &IFM_FDDI,  &IFM_AVALID,  &IFM_ACTIVE, { "no ring", "inserted" } }, {  &IFM_TOKEN,  &IFM_AVALID,  &IFM_ACTIVE, { "no ring", "inserted" } }, {  &IFM_IEEE80211,  &IFM_AVALID,  &IFM_ACTIVE, { "no network", "active" } }, {  &IFM_ATM,  &IFM_AVALID,  &IFM_ACTIVE, { "no network", "active" } }, { 0, 0, 0, {  &NULL,  &NULL } } };}' unless defined(&IFM_STATUS_DESCRIPTIONS);
}
1;
