require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_IF_PFSYNC_H_)) {
    eval 'sub _NET_IF_PFSYNC_H_ () {1;}' unless defined(&_NET_IF_PFSYNC_H_);
    eval 'sub PFSYNC_VERSION () {5;}' unless defined(&PFSYNC_VERSION);
    eval 'sub PFSYNC_DFLTTL () {255;}' unless defined(&PFSYNC_DFLTTL);
    eval 'sub PFSYNC_ACT_CLR () {0;}' unless defined(&PFSYNC_ACT_CLR);
    eval 'sub PFSYNC_ACT_INS () {1;}' unless defined(&PFSYNC_ACT_INS);
    eval 'sub PFSYNC_ACT_INS_ACK () {2;}' unless defined(&PFSYNC_ACT_INS_ACK);
    eval 'sub PFSYNC_ACT_UPD () {3;}' unless defined(&PFSYNC_ACT_UPD);
    eval 'sub PFSYNC_ACT_UPD_C () {4;}' unless defined(&PFSYNC_ACT_UPD_C);
    eval 'sub PFSYNC_ACT_UPD_REQ () {5;}' unless defined(&PFSYNC_ACT_UPD_REQ);
    eval 'sub PFSYNC_ACT_DEL () {6;}' unless defined(&PFSYNC_ACT_DEL);
    eval 'sub PFSYNC_ACT_DEL_C () {7;}' unless defined(&PFSYNC_ACT_DEL_C);
    eval 'sub PFSYNC_ACT_INS_F () {8;}' unless defined(&PFSYNC_ACT_INS_F);
    eval 'sub PFSYNC_ACT_DEL_F () {9;}' unless defined(&PFSYNC_ACT_DEL_F);
    eval 'sub PFSYNC_ACT_BUS () {10;}' unless defined(&PFSYNC_ACT_BUS);
    eval 'sub PFSYNC_ACT_TDB () {11;}' unless defined(&PFSYNC_ACT_TDB);
    eval 'sub PFSYNC_ACT_EOF () {12;}' unless defined(&PFSYNC_ACT_EOF);
    eval 'sub PFSYNC_ACT_MAX () {13;}' unless defined(&PFSYNC_ACT_MAX);
    eval 'sub PFSYNC_BUS_START () {1;}' unless defined(&PFSYNC_BUS_START);
    eval 'sub PFSYNC_BUS_END () {2;}' unless defined(&PFSYNC_BUS_END);
    eval 'sub PFSYNC_HDRLEN () {$sizeof{\'struct pfsync_header\'};}' unless defined(&PFSYNC_HDRLEN);
    eval 'sub SIOCSETPFSYNC () { &_IOW(ord(\'i\'), 247, \'struct ifreq\');}' unless defined(&SIOCSETPFSYNC);
    eval 'sub SIOCGETPFSYNC () { &_IOWR(ord(\'i\'), 248, \'struct ifreq\');}' unless defined(&SIOCGETPFSYNC);
    if(defined(&_KERNEL)) {
	eval 'sub PFSYNC_S_INS () {0x;}' unless defined(&PFSYNC_S_INS);
	eval 'sub PFSYNC_S_IACK () {0x1;}' unless defined(&PFSYNC_S_IACK);
	eval 'sub PFSYNC_S_UPD () {0x2;}' unless defined(&PFSYNC_S_UPD);
	eval 'sub PFSYNC_S_UPD_C () {0x3;}' unless defined(&PFSYNC_S_UPD_C);
	eval 'sub PFSYNC_S_DEL () {0x4;}' unless defined(&PFSYNC_S_DEL);
	eval 'sub PFSYNC_S_COUNT () {0x5;}' unless defined(&PFSYNC_S_COUNT);
	eval 'sub PFSYNC_S_DEFER () {0xfe;}' unless defined(&PFSYNC_S_DEFER);
	eval 'sub PFSYNC_S_NONE () {0xff;}' unless defined(&PFSYNC_S_NONE);
	eval 'sub PFSYNC_SI_IOCTL () {0x1;}' unless defined(&PFSYNC_SI_IOCTL);
	eval 'sub PFSYNC_SI_CKSUM () {0x2;}' unless defined(&PFSYNC_SI_CKSUM);
	eval 'sub PFSYNC_SI_ACK () {0x4;}' unless defined(&PFSYNC_SI_ACK);
    }
}
1;
