require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_IF_VLAN_VAR_H_)) {
    eval 'sub _NET_IF_VLAN_VAR_H_ () {1;}' unless defined(&_NET_IF_VLAN_VAR_H_);
    eval 'sub EVL_APPLY_VLID {
        my($m, $vlid) = @_;
	    eval q( &do {  &if (($m)-> &m_flags &  &M_VLANTAG) { ($m)-> ($m_pkthdr->{ether_vtag}) &=  &EVL_VLID_MASK; ($m)-> ($m_pkthdr->{ether_vtag}) |= ($vlid); }  &else { ($m)-> ($m_pkthdr->{ether_vtag}) = ($vlid); ($m)-> &m_flags |=  &M_VLANTAG; } }  &while (0));
    }' unless defined(&EVL_APPLY_VLID);
    eval 'sub EVL_APPLY_PRI {
        my($m, $pri) = @_;
	    eval q( &do {  &if (($m)-> &m_flags &  &M_VLANTAG) {  &uint16_t  &__vlantag = ($m)-> ($m_pkthdr->{ether_vtag}); ($m)-> ($m_pkthdr->{ether_vtag}) |=  &EVL_MAKETAG(  &EVL_VLANOFTAG( &__vlantag), ($pri),  &EVL_CFIOFTAG( &__vlantag)); }  &else { ($m)-> ($m_pkthdr->{ether_vtag}) =  &EVL_MAKETAG(0, ($pri), 0); ($m)-> &m_flags |=  &M_VLANTAG; } }  &while (0));
    }' unless defined(&EVL_APPLY_PRI);
    eval 'sub VLANCTL_PROTO () {1;}' unless defined(&VLANCTL_PROTO);
    eval 'sub VLANCTL_MAX () {2;}' unless defined(&VLANCTL_MAX);
    eval 'sub SIOCSETVLAN () { &SIOCSIFGENERIC;}' unless defined(&SIOCSETVLAN);
    eval 'sub SIOCGETVLAN () { &SIOCGIFGENERIC;}' unless defined(&SIOCGETVLAN);
    eval 'sub SIOCGVLANPCP () { &SIOCGLANPCP;}' unless defined(&SIOCGVLANPCP);
    eval 'sub SIOCSVLANPCP () { &SIOCSLANPCP;}' unless defined(&SIOCSVLANPCP);
    if(defined(&_KERNEL)) {
	eval 'sub MTAG_8021Q () {1326104895;}' unless defined(&MTAG_8021Q);
	eval 'sub MTAG_8021Q_PCP_IN () {0;}' unless defined(&MTAG_8021Q_PCP_IN);
	eval 'sub MTAG_8021Q_PCP_OUT () {1;}' unless defined(&MTAG_8021Q_PCP_OUT);
	eval 'sub VLAN_CAPABILITIES {
	    my($_ifp) = @_;
    	    eval q( &do {  &if (($_ifp)-> &if_vlantrunk !=  &NULL) (* &vlan_trunk_cap_p)($_ifp); }  &while (0));
	}' unless defined(&VLAN_CAPABILITIES);
	eval 'sub VLAN_TRUNKDEV {
	    my($_ifp) = @_;
    	    eval q((($_ifp)-> &if_type ==  &IFT_L2VLAN ? (* &vlan_trunkdev_p)(($_ifp)) :  &NULL));
	}' unless defined(&VLAN_TRUNKDEV);
	eval 'sub VLAN_TAG {
	    my($_ifp, $_vid) = @_;
    	    eval q((($_ifp)-> &if_type ==  &IFT_L2VLAN ? (* &vlan_tag_p)(($_ifp), ($_vid)) :  &EINVAL));
	}' unless defined(&VLAN_TAG);
	eval 'sub VLAN_COOKIE {
	    my($_ifp) = @_;
    	    eval q((($_ifp)-> &if_type ==  &IFT_L2VLAN ? (* &vlan_cookie_p)(($_ifp)) :  &NULL));
	}' unless defined(&VLAN_COOKIE);
	eval 'sub VLAN_SETCOOKIE {
	    my($_ifp, $_cookie) = @_;
    	    eval q((($_ifp)-> &if_type ==  &IFT_L2VLAN ? (* &vlan_setcookie_p)(($_ifp), ($_cookie)) :  &EINVAL));
	}' unless defined(&VLAN_SETCOOKIE);
	eval 'sub VLAN_DEVAT {
	    my($_ifp, $_vid) = @_;
    	    eval q((($_ifp)-> &if_vlantrunk !=  &NULL ? (* &vlan_devat_p)(($_ifp), ($_vid)) :  &NULL));
	}' unless defined(&VLAN_DEVAT);
	if(defined(&_SYS_EVENTHANDLER_H_)) {
	}
    }
}
1;
