require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_IF_VXLAN_H_)) {
    eval 'sub _NET_IF_VXLAN_H_ () {1;}' unless defined(&_NET_IF_VXLAN_H_);
    require 'sys/types.ph';
    require 'sys/socket.ph';
    require 'net/ethernet.ph';
    require 'net/if.ph';
    require 'netinet/in.ph';
    eval 'sub VXLAN_HDR_FLAGS_VALID_VNI () {0x8000000;}' unless defined(&VXLAN_HDR_FLAGS_VALID_VNI);
    eval 'sub VXLAN_HDR_VNI_SHIFT () {8;}' unless defined(&VXLAN_HDR_VNI_SHIFT);
    eval 'sub VXLAN_VNI_MAX () {(1<< 24);}' unless defined(&VXLAN_VNI_MAX);
    eval 'sub VXLAN_VNI_MASK () {( &VXLAN_VNI_MAX - 1);}' unless defined(&VXLAN_VNI_MASK);
    eval 'sub VXLAN_PORT () {4789;}' unless defined(&VXLAN_PORT);
    eval 'sub VXLAN_LEGACY_PORT () {8472;}' unless defined(&VXLAN_LEGACY_PORT);
    eval 'sub VXLAN_PARAM_WITH_VNI () {0x1;}' unless defined(&VXLAN_PARAM_WITH_VNI);
    eval 'sub VXLAN_PARAM_WITH_LOCAL_ADDR4 () {0x2;}' unless defined(&VXLAN_PARAM_WITH_LOCAL_ADDR4);
    eval 'sub VXLAN_PARAM_WITH_LOCAL_ADDR6 () {0x4;}' unless defined(&VXLAN_PARAM_WITH_LOCAL_ADDR6);
    eval 'sub VXLAN_PARAM_WITH_REMOTE_ADDR4 () {0x8;}' unless defined(&VXLAN_PARAM_WITH_REMOTE_ADDR4);
    eval 'sub VXLAN_PARAM_WITH_REMOTE_ADDR6 () {0x10;}' unless defined(&VXLAN_PARAM_WITH_REMOTE_ADDR6);
    eval 'sub VXLAN_PARAM_WITH_LOCAL_PORT () {0x20;}' unless defined(&VXLAN_PARAM_WITH_LOCAL_PORT);
    eval 'sub VXLAN_PARAM_WITH_REMOTE_PORT () {0x40;}' unless defined(&VXLAN_PARAM_WITH_REMOTE_PORT);
    eval 'sub VXLAN_PARAM_WITH_PORT_RANGE () {0x80;}' unless defined(&VXLAN_PARAM_WITH_PORT_RANGE);
    eval 'sub VXLAN_PARAM_WITH_FTABLE_TIMEOUT () {0x100;}' unless defined(&VXLAN_PARAM_WITH_FTABLE_TIMEOUT);
    eval 'sub VXLAN_PARAM_WITH_FTABLE_MAX () {0x200;}' unless defined(&VXLAN_PARAM_WITH_FTABLE_MAX);
    eval 'sub VXLAN_PARAM_WITH_MULTICAST_IF () {0x400;}' unless defined(&VXLAN_PARAM_WITH_MULTICAST_IF);
    eval 'sub VXLAN_PARAM_WITH_TTL () {0x800;}' unless defined(&VXLAN_PARAM_WITH_TTL);
    eval 'sub VXLAN_PARAM_WITH_LEARN () {0x1000;}' unless defined(&VXLAN_PARAM_WITH_LEARN);
    eval 'sub VXLAN_SOCKADDR_IS_IPV4 {
        my($_vxsin) = @_;
	    eval q((($_vxsin)-> ($sa->{sa_family}) ==  &AF_INET));
    }' unless defined(&VXLAN_SOCKADDR_IS_IPV4);
    eval 'sub VXLAN_SOCKADDR_IS_IPV6 {
        my($_vxsin) = @_;
	    eval q((($_vxsin)-> ($sa->{sa_family}) ==  &AF_INET6));
    }' unless defined(&VXLAN_SOCKADDR_IS_IPV6);
    eval 'sub VXLAN_SOCKADDR_IS_IPV46 {
        my($_vxsin) = @_;
	    eval q(( &VXLAN_SOCKADDR_IS_IPV4($_vxsin) ||  &VXLAN_SOCKADDR_IS_IPV6($_vxsin)));
    }' unless defined(&VXLAN_SOCKADDR_IS_IPV46);
    eval 'sub VXLAN_CMD_GET_CONFIG () {0;}' unless defined(&VXLAN_CMD_GET_CONFIG);
    eval 'sub VXLAN_CMD_SET_VNI () {1;}' unless defined(&VXLAN_CMD_SET_VNI);
    eval 'sub VXLAN_CMD_SET_LOCAL_ADDR () {2;}' unless defined(&VXLAN_CMD_SET_LOCAL_ADDR);
    eval 'sub VXLAN_CMD_SET_REMOTE_ADDR () {4;}' unless defined(&VXLAN_CMD_SET_REMOTE_ADDR);
    eval 'sub VXLAN_CMD_SET_LOCAL_PORT () {5;}' unless defined(&VXLAN_CMD_SET_LOCAL_PORT);
    eval 'sub VXLAN_CMD_SET_REMOTE_PORT () {6;}' unless defined(&VXLAN_CMD_SET_REMOTE_PORT);
    eval 'sub VXLAN_CMD_SET_PORT_RANGE () {7;}' unless defined(&VXLAN_CMD_SET_PORT_RANGE);
    eval 'sub VXLAN_CMD_SET_FTABLE_TIMEOUT () {8;}' unless defined(&VXLAN_CMD_SET_FTABLE_TIMEOUT);
    eval 'sub VXLAN_CMD_SET_FTABLE_MAX () {9;}' unless defined(&VXLAN_CMD_SET_FTABLE_MAX);
    eval 'sub VXLAN_CMD_SET_MULTICAST_IF () {10;}' unless defined(&VXLAN_CMD_SET_MULTICAST_IF);
    eval 'sub VXLAN_CMD_SET_TTL () {11;}' unless defined(&VXLAN_CMD_SET_TTL);
    eval 'sub VXLAN_CMD_SET_LEARN () {12;}' unless defined(&VXLAN_CMD_SET_LEARN);
    eval 'sub VXLAN_CMD_FTABLE_ENTRY_ADD () {13;}' unless defined(&VXLAN_CMD_FTABLE_ENTRY_ADD);
    eval 'sub VXLAN_CMD_FTABLE_ENTRY_REM () {14;}' unless defined(&VXLAN_CMD_FTABLE_ENTRY_REM);
    eval 'sub VXLAN_CMD_FLUSH () {15;}' unless defined(&VXLAN_CMD_FLUSH);
    eval 'sub VXLAN_CMD_FLAG_FLUSH_ALL () {0x1;}' unless defined(&VXLAN_CMD_FLAG_FLUSH_ALL);
    eval 'sub VXLAN_CMD_FLAG_LEARN () {0x2;}' unless defined(&VXLAN_CMD_FLAG_LEARN);
}
1;
