require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__IFLIB_H_)) {
    eval 'sub __IFLIB_H_ () {1;}' unless defined(&__IFLIB_H_);
    require 'sys/kobj.ph';
    require 'sys/bus.ph';
    require 'sys/cpuset.ph';
    require 'machine/bus.ph';
    require 'sys/bus_dma.ph';
    require 'sys/nv.ph';
    require 'sys/gtaskqueue.ph';
    eval 'sub QIDX_INVALID () {0xffff;}' unless defined(&QIDX_INVALID);
    eval 'sub FREEBSD_TSO_SIZE_MAX () {65518;}' unless defined(&FREEBSD_TSO_SIZE_MAX);
    eval 'sub IPI_TX_INTR () {0x1;}' unless defined(&IPI_TX_INTR);
    eval 'sub IPI_TX_IPV4 () {0x2;}' unless defined(&IPI_TX_IPV4);
    eval 'sub IPI_TX_IPV6 () {0x4;}' unless defined(&IPI_TX_IPV6);
    eval("sub IFLIB_INTR_LEGACY () { 0; }") unless defined(&IFLIB_INTR_LEGACY);
    eval("sub IFLIB_INTR_MSI () { 1; }") unless defined(&IFLIB_INTR_MSI);
    eval("sub IFLIB_INTR_MSIX () { 2; }") unless defined(&IFLIB_INTR_MSIX);
    eval 'sub PVID {
        my($vendor, $devid, $name) = @_;
	    eval q({$vendor, $devid, 0, 0, 0, 0, $name});
    }' unless defined(&PVID);
    eval 'sub PVID_OEM {
        my($vendor, $devid, $svid, $sdevid, $revid, $name) = @_;
	    eval q({$vendor, $devid, $svid, $sdevid, $revid, 0, $name});
    }' unless defined(&PVID_OEM);
    eval 'sub PVID_END () {{0, 0, 0, 0, 0, 0,  &NULL};}' unless defined(&PVID_END);
    eval 'sub IFLIB_PNP_DESCR () {"U32:vendor;U32:device;U32:subvendor;U32:subdevice;" "U32:revision;U32:class;D:human";}' unless defined(&IFLIB_PNP_DESCR);
    eval 'sub IFLIB_PNP_INFO {
        my($b, $u, $t) = @_;
	    eval q( &MODULE_PNP_INFO( &IFLIB_PNP_DESCR, $b, $u, $t, $sizeof{$t->[0]},  &nitems($t) - 1));
    }' unless defined(&IFLIB_PNP_INFO);
    eval 'sub IFLIB_MAGIC () {0xcafef00d;}' unless defined(&IFLIB_MAGIC);
    eval("sub IFLIB_INTR_RX () { 0; }") unless defined(&IFLIB_INTR_RX);
    eval("sub IFLIB_INTR_TX () { 1; }") unless defined(&IFLIB_INTR_TX);
    eval("sub IFLIB_INTR_RXTX () { 2; }") unless defined(&IFLIB_INTR_RXTX);
    eval("sub IFLIB_INTR_ADMIN () { 3; }") unless defined(&IFLIB_INTR_ADMIN);
    eval("sub IFLIB_INTR_IOV () { 4; }") unless defined(&IFLIB_INTR_IOV);
    unless(defined(&ETH_ADDR_LEN)) {
	eval 'sub ETH_ADDR_LEN () {6;}' unless defined(&ETH_ADDR_LEN);
    }
    eval 'sub IFLIB_HAS_RXCQ () {0x1;}' unless defined(&IFLIB_HAS_RXCQ);
    eval 'sub IFLIB_SKIP_MSIX () {0x2;}' unless defined(&IFLIB_SKIP_MSIX);
    eval 'sub IFLIB_IS_VF () {0x4;}' unless defined(&IFLIB_IS_VF);
    eval 'sub IFLIB_HAS_TXCQ () {0x8;}' unless defined(&IFLIB_HAS_TXCQ);
    eval 'sub IFLIB_NEED_SCRATCH () {0x10;}' unless defined(&IFLIB_NEED_SCRATCH);
    eval 'sub IFLIB_TSO_INIT_IP () {0x20;}' unless defined(&IFLIB_TSO_INIT_IP);
    eval 'sub IFLIB_DO_RX_FIXUP () {0x40;}' unless defined(&IFLIB_DO_RX_FIXUP);
    eval 'sub IFLIB_NEED_ZERO_CSUM () {0x80;}' unless defined(&IFLIB_NEED_ZERO_CSUM);
    eval 'sub IFLIB_NEED_ETHER_PAD () {0x100;}' unless defined(&IFLIB_NEED_ETHER_PAD);
}
1;
