require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_NETMAP_H_)) {
    eval 'sub _NET_NETMAP_H_ () {1;}' unless defined(&_NET_NETMAP_H_);
    eval 'sub NETMAP_API () {11;}' unless defined(&NETMAP_API);
    eval 'sub NETMAP_MIN_API () {11;}' unless defined(&NETMAP_MIN_API);
    eval 'sub NETMAP_MAX_API () {15;}' unless defined(&NETMAP_MAX_API);
    eval 'sub NM_CACHE_ALIGN () {128;}' unless defined(&NM_CACHE_ALIGN);
    eval 'sub NS_BUF_CHANGED () {0x1;}' unless defined(&NS_BUF_CHANGED);
    eval 'sub NS_REPORT () {0x2;}' unless defined(&NS_REPORT);
    eval 'sub NS_FORWARD () {0x4;}' unless defined(&NS_FORWARD);
    eval 'sub NS_NO_LEARN () {0x8;}' unless defined(&NS_NO_LEARN);
    eval 'sub NS_INDIRECT () {0x10;}' unless defined(&NS_INDIRECT);
    eval 'sub NS_MOREFRAG () {0x20;}' unless defined(&NS_MOREFRAG);
    eval 'sub NS_PORT_SHIFT () {8;}' unless defined(&NS_PORT_SHIFT);
    eval 'sub NS_PORT_MASK () {(0xff <<  &NS_PORT_SHIFT);}' unless defined(&NS_PORT_MASK);
    eval 'sub NS_RFRAGS {
        my($_slot) = @_;
	    eval q(( (($_slot)-> &flags >> 8) & 0xff));
    }' unless defined(&NS_RFRAGS);
    eval 'sub NR_TIMESTAMP () {0x2;}' unless defined(&NR_TIMESTAMP);
    eval 'sub NR_FORWARD () {0x4;}' unless defined(&NR_FORWARD);
    eval 'sub NI_PRIV_MEM () {0x1;}' unless defined(&NI_PRIV_MEM);
    unless(defined(&NIOCREGIF)) {
	eval 'sub NETMAP_HW_RING () {0x4000;}' unless defined(&NETMAP_HW_RING);
	eval 'sub NETMAP_SW_RING () {0x2000;}' unless defined(&NETMAP_SW_RING);
	eval 'sub NETMAP_RING_MASK () {0xfff;}' unless defined(&NETMAP_RING_MASK);
	eval 'sub NETMAP_NO_TX_POLL () {0x1000;}' unless defined(&NETMAP_NO_TX_POLL);
	eval 'sub NETMAP_DO_RX_POLL () {0x8000;}' unless defined(&NETMAP_DO_RX_POLL);
	eval 'sub NETMAP_BDG_ATTACH () {1;}' unless defined(&NETMAP_BDG_ATTACH);
	eval 'sub NETMAP_BDG_DETACH () {2;}' unless defined(&NETMAP_BDG_DETACH);
	eval 'sub NETMAP_BDG_REGOPS () {3;}' unless defined(&NETMAP_BDG_REGOPS);
	eval 'sub NETMAP_BDG_LIST () {4;}' unless defined(&NETMAP_BDG_LIST);
	eval 'sub NETMAP_BDG_VNET_HDR () {5;}' unless defined(&NETMAP_BDG_VNET_HDR);
	eval 'sub NETMAP_BDG_OFFSET () { &NETMAP_BDG_VNET_HDR;}' unless defined(&NETMAP_BDG_OFFSET);
	eval 'sub NETMAP_BDG_NEWIF () {6;}' unless defined(&NETMAP_BDG_NEWIF);
	eval 'sub NETMAP_BDG_DELIF () {7;}' unless defined(&NETMAP_BDG_DELIF);
	eval 'sub NETMAP_BDG_HOST () {1;}' unless defined(&NETMAP_BDG_HOST);
	eval 'sub NR_REG_MASK () {0xf;}' unless defined(&NR_REG_MASK);
	eval("sub NR_REG_DEFAULT () { 0; }") unless defined(&NR_REG_DEFAULT);
	eval("sub NR_REG_ALL_NIC () { 1; }") unless defined(&NR_REG_ALL_NIC);
	eval("sub NR_REG_SW () { 2; }") unless defined(&NR_REG_SW);
	eval("sub NR_REG_NIC_SW () { 3; }") unless defined(&NR_REG_NIC_SW);
	eval("sub NR_REG_ONE_NIC () { 4; }") unless defined(&NR_REG_ONE_NIC);
	eval("sub NR_REG_PIPE_MASTER () { 5; }") unless defined(&NR_REG_PIPE_MASTER);
	eval("sub NR_REG_PIPE_SLAVE () { 6; }") unless defined(&NR_REG_PIPE_SLAVE);
	eval 'sub NR_MONITOR_TX () {0x100;}' unless defined(&NR_MONITOR_TX);
	eval 'sub NR_MONITOR_RX () {0x200;}' unless defined(&NR_MONITOR_RX);
	eval 'sub NR_ZCOPY_MON () {0x400;}' unless defined(&NR_ZCOPY_MON);
	eval 'sub NR_EXCLUSIVE () {0x800;}' unless defined(&NR_EXCLUSIVE);
	eval 'sub NIOCGINFO () { &_IOWR(ord(\'i\'), 145, \'struct nmreq\');}' unless defined(&NIOCGINFO);
	eval 'sub NIOCREGIF () { &_IOWR(ord(\'i\'), 146, \'struct nmreq\');}' unless defined(&NIOCREGIF);
	eval 'sub NIOCTXSYNC () { &_IO(ord(\'i\'), 148);}' unless defined(&NIOCTXSYNC);
	eval 'sub NIOCRXSYNC () { &_IO(ord(\'i\'), 149);}' unless defined(&NIOCRXSYNC);
	eval 'sub NIOCCONFIG () { &_IOWR(ord(\'i\'),150, \'struct nm_ifreq\');}' unless defined(&NIOCCONFIG);
    }
    eval 'sub NM_IFRDATA_LEN () {256;}' unless defined(&NM_IFRDATA_LEN);
}
1;
