require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_PFIL_H_)) {
    eval 'sub _NET_PFIL_H_ () {1;}' unless defined(&_NET_PFIL_H_);
    require 'sys/systm.ph';
    require 'sys/queue.ph';
    require 'sys/_lock.ph';
    require 'sys/_mutex.ph';
    require 'sys/lock.ph';
    require 'sys/rmlock.ph';
    require 'net/vnet.ph';
    eval 'sub PFIL_IN () {0x1;}' unless defined(&PFIL_IN);
    eval 'sub PFIL_OUT () {0x2;}' unless defined(&PFIL_OUT);
    eval 'sub PFIL_WAITOK () {0x4;}' unless defined(&PFIL_WAITOK);
    eval 'sub PFIL_FWD () {0x8;}' unless defined(&PFIL_FWD);
    eval 'sub PFIL_ALL () {( &PFIL_IN| &PFIL_OUT);}' unless defined(&PFIL_ALL);
    eval 'sub PFIL_TYPE_AF () {1;}' unless defined(&PFIL_TYPE_AF);
    eval 'sub PFIL_TYPE_IFNET () {2;}' unless defined(&PFIL_TYPE_IFNET);
    eval 'sub PFIL_FLAG_PRIVATE_LOCK () {0x1;}' unless defined(&PFIL_FLAG_PRIVATE_LOCK);
    if(defined( (defined(&__linux__) ? &__linux__ : undef) ) || defined( (defined(&_WIN32) ? &_WIN32 : undef) )) {
    } else {
    }
    eval 'sub ph_af () { ($ph_un->{phu_val});}' unless defined(&ph_af);
    eval 'sub ph_ifnet () { ($ph_un->{phu_ptr});}' unless defined(&ph_ifnet);
    eval 'sub V_pfil_lock () { &VNET( &pfil_lock);}' unless defined(&V_pfil_lock);
    eval 'sub PFIL_HOOKED {
        my($p) = @_;
	    eval q((($p)-> &ph_nhooks > 0));
    }' unless defined(&PFIL_HOOKED);
}
1;
