require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_RSS_CONFIG_H_)) {
    eval 'sub _NET_RSS_CONFIG_H_ () {1;}' unless defined(&_NET_RSS_CONFIG_H_);
    require 'netinet/in.ph';
    eval 'sub RSS_HASH_NAIVE () {0x1;}' unless defined(&RSS_HASH_NAIVE);
    eval 'sub RSS_HASH_TOEPLITZ () {0x2;}' unless defined(&RSS_HASH_TOEPLITZ);
    eval 'sub RSS_HASH_CRC32 () {0x4;}' unless defined(&RSS_HASH_CRC32);
    eval 'sub RSS_HASH_MASK () {( &RSS_HASH_NAIVE |  &RSS_HASH_TOEPLITZ);}' unless defined(&RSS_HASH_MASK);
    eval 'sub RSS_HASHFIELDS_NONE () {0;}' unless defined(&RSS_HASHFIELDS_NONE);
    eval 'sub RSS_HASHFIELDS_4TUPLE () {1;}' unless defined(&RSS_HASHFIELDS_4TUPLE);
    eval 'sub RSS_HASHFIELDS_2TUPLE () {2;}' unless defined(&RSS_HASHFIELDS_2TUPLE);
    eval 'sub RSS_HASHTYPE_RSS_IPV4 () {(1<< 1);}' unless defined(&RSS_HASHTYPE_RSS_IPV4);
    eval 'sub RSS_HASHTYPE_RSS_TCP_IPV4 () {(1<< 2);}' unless defined(&RSS_HASHTYPE_RSS_TCP_IPV4);
    eval 'sub RSS_HASHTYPE_RSS_IPV6 () {(1<< 3);}' unless defined(&RSS_HASHTYPE_RSS_IPV6);
    eval 'sub RSS_HASHTYPE_RSS_TCP_IPV6 () {(1<< 4);}' unless defined(&RSS_HASHTYPE_RSS_TCP_IPV6);
    eval 'sub RSS_HASHTYPE_RSS_IPV6_EX () {(1<< 5);}' unless defined(&RSS_HASHTYPE_RSS_IPV6_EX);
    eval 'sub RSS_HASHTYPE_RSS_TCP_IPV6_EX () {(1<< 6);}' unless defined(&RSS_HASHTYPE_RSS_TCP_IPV6_EX);
    eval 'sub RSS_HASHTYPE_RSS_UDP_IPV4 () {(1<< 7);}' unless defined(&RSS_HASHTYPE_RSS_UDP_IPV4);
    eval 'sub RSS_HASHTYPE_RSS_UDP_IPV4_EX () {(1<< 8);}' unless defined(&RSS_HASHTYPE_RSS_UDP_IPV4_EX);
    eval 'sub RSS_HASHTYPE_RSS_UDP_IPV6 () {(1<< 9);}' unless defined(&RSS_HASHTYPE_RSS_UDP_IPV6);
    eval 'sub RSS_HASHTYPE_RSS_UDP_IPV6_EX () {(1<< 10);}' unless defined(&RSS_HASHTYPE_RSS_UDP_IPV6_EX);
    eval 'sub RSS_MAXBITS () {7;}' unless defined(&RSS_MAXBITS);
    eval 'sub RSS_TABLE_MAXLEN () {(1<<  &RSS_MAXBITS);}' unless defined(&RSS_TABLE_MAXLEN);
    eval 'sub RSS_KEYSIZE () {40;}' unless defined(&RSS_KEYSIZE);
    eval 'sub RSS_HASH_PKT_INGRESS () {0;}' unless defined(&RSS_HASH_PKT_INGRESS);
    eval 'sub RSS_HASH_PKT_EGRESS () {1;}' unless defined(&RSS_HASH_PKT_EGRESS);
    eval 'sub RSS_DEBUG () {( &format, ...)  &do {  &if ( &rss_debug) {  &static \'struct timeval\'  &lastfail;  &static \'int\'  &curfail;  &if ( &ppsratecheck( &lastfail,  &curfail, 5))  &printf("RSS (%s:%u): "  &format,  &__func__,  &__LINE__,  &__VA_ARGS__); } }  &while (0);}' unless defined(&RSS_DEBUG);
}
1;
