require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211__IEEE80211_H_)) {
    eval 'sub _NET80211__IEEE80211_H_ () {1;}' unless defined(&_NET80211__IEEE80211_H_);
    eval("sub IEEE80211_T_DS () { 0; }") unless defined(&IEEE80211_T_DS);
    eval("sub IEEE80211_T_FH () { 1; }") unless defined(&IEEE80211_T_FH);
    eval("sub IEEE80211_T_OFDM () { 2; }") unless defined(&IEEE80211_T_OFDM);
    eval("sub IEEE80211_T_TURBO () { 3; }") unless defined(&IEEE80211_T_TURBO);
    eval("sub IEEE80211_T_HT () { 4; }") unless defined(&IEEE80211_T_HT);
    eval("sub IEEE80211_T_OFDM_HALF () { 5; }") unless defined(&IEEE80211_T_OFDM_HALF);
    eval("sub IEEE80211_T_OFDM_QUARTER () { 6; }") unless defined(&IEEE80211_T_OFDM_QUARTER);
    eval 'sub IEEE80211_T_CCK () { &IEEE80211_T_DS;}' unless defined(&IEEE80211_T_CCK);
    eval("sub IEEE80211_MODE_AUTO () { 0; }") unless defined(&IEEE80211_MODE_AUTO);
    eval("sub IEEE80211_MODE_11A () { 1; }") unless defined(&IEEE80211_MODE_11A);
    eval("sub IEEE80211_MODE_11B () { 2; }") unless defined(&IEEE80211_MODE_11B);
    eval("sub IEEE80211_MODE_11G () { 3; }") unless defined(&IEEE80211_MODE_11G);
    eval("sub IEEE80211_MODE_FH () { 4; }") unless defined(&IEEE80211_MODE_FH);
    eval("sub IEEE80211_MODE_TURBO_A () { 5; }") unless defined(&IEEE80211_MODE_TURBO_A);
    eval("sub IEEE80211_MODE_TURBO_G () { 6; }") unless defined(&IEEE80211_MODE_TURBO_G);
    eval("sub IEEE80211_MODE_STURBO_A () { 7; }") unless defined(&IEEE80211_MODE_STURBO_A);
    eval("sub IEEE80211_MODE_11NA () { 8; }") unless defined(&IEEE80211_MODE_11NA);
    eval("sub IEEE80211_MODE_11NG () { 9; }") unless defined(&IEEE80211_MODE_11NG);
    eval("sub IEEE80211_MODE_HALF () { 10; }") unless defined(&IEEE80211_MODE_HALF);
    eval("sub IEEE80211_MODE_QUARTER () { 11; }") unless defined(&IEEE80211_MODE_QUARTER);
    eval 'sub IEEE80211_MODE_MAX () {( &IEEE80211_MODE_QUARTER+1);}' unless defined(&IEEE80211_MODE_MAX);
    eval 'sub IEEE80211_MODE_BYTES () { &howmany( &IEEE80211_MODE_MAX,  &NBBY);}' unless defined(&IEEE80211_MODE_BYTES);
    eval("sub IEEE80211_M_IBSS () { 0; }") unless defined(&IEEE80211_M_IBSS);
    eval("sub IEEE80211_M_STA () { 1; }") unless defined(&IEEE80211_M_STA);
    eval("sub IEEE80211_M_WDS () { 2; }") unless defined(&IEEE80211_M_WDS);
    eval("sub IEEE80211_M_AHDEMO () { 3; }") unless defined(&IEEE80211_M_AHDEMO);
    eval("sub IEEE80211_M_HOSTAP () { 4; }") unless defined(&IEEE80211_M_HOSTAP);
    eval("sub IEEE80211_M_MONITOR () { 5; }") unless defined(&IEEE80211_M_MONITOR);
    eval("sub IEEE80211_M_MBSS () { 6; }") unless defined(&IEEE80211_M_MBSS);
    eval 'sub IEEE80211_OPMODE_MAX () {( &IEEE80211_M_MBSS+1);}' unless defined(&IEEE80211_OPMODE_MAX);
    eval("sub IEEE80211_PROT_NONE () { 0; }") unless defined(&IEEE80211_PROT_NONE);
    eval("sub IEEE80211_PROT_CTSONLY () { 1; }") unless defined(&IEEE80211_PROT_CTSONLY);
    eval("sub IEEE80211_PROT_RTSCTS () { 2; }") unless defined(&IEEE80211_PROT_RTSCTS);
    eval("sub IEEE80211_AUTH_NONE () { 0; }") unless defined(&IEEE80211_AUTH_NONE);
    eval("sub IEEE80211_AUTH_OPEN () { 1; }") unless defined(&IEEE80211_AUTH_OPEN);
    eval("sub IEEE80211_AUTH_SHARED () { 2; }") unless defined(&IEEE80211_AUTH_SHARED);
    eval("sub IEEE80211_AUTH_8021X () { 3; }") unless defined(&IEEE80211_AUTH_8021X);
    eval("sub IEEE80211_AUTH_AUTO () { 4; }") unless defined(&IEEE80211_AUTH_AUTO);
    eval("sub IEEE80211_AUTH_WPA () { 5; }") unless defined(&IEEE80211_AUTH_WPA);
    eval("sub IEEE80211_ROAMING_DEVICE () { 0; }") unless defined(&IEEE80211_ROAMING_DEVICE);
    eval("sub IEEE80211_ROAMING_AUTO () { 1; }") unless defined(&IEEE80211_ROAMING_AUTO);
    eval("sub IEEE80211_ROAMING_MANUAL () { 2; }") unless defined(&IEEE80211_ROAMING_MANUAL);
    eval 'sub IEEE80211_CHAN_MAX () {256;}' unless defined(&IEEE80211_CHAN_MAX);
    eval 'sub IEEE80211_CHAN_BYTES () { &howmany( &IEEE80211_CHAN_MAX,  &NBBY);}' unless defined(&IEEE80211_CHAN_BYTES);
    eval 'sub IEEE80211_CHAN_ANY () {0xffff;}' unless defined(&IEEE80211_CHAN_ANY);
    eval 'sub IEEE80211_CHAN_ANYC () {(  &IEEE80211_CHAN_ANY);}' unless defined(&IEEE80211_CHAN_ANYC);
    eval 'sub IEEE80211_CHAN_PRIV0 () {0x1;}' unless defined(&IEEE80211_CHAN_PRIV0);
    eval 'sub IEEE80211_CHAN_PRIV1 () {0x2;}' unless defined(&IEEE80211_CHAN_PRIV1);
    eval 'sub IEEE80211_CHAN_PRIV2 () {0x4;}' unless defined(&IEEE80211_CHAN_PRIV2);
    eval 'sub IEEE80211_CHAN_PRIV3 () {0x8;}' unless defined(&IEEE80211_CHAN_PRIV3);
    eval 'sub IEEE80211_CHAN_TURBO () {0x10;}' unless defined(&IEEE80211_CHAN_TURBO);
    eval 'sub IEEE80211_CHAN_CCK () {0x20;}' unless defined(&IEEE80211_CHAN_CCK);
    eval 'sub IEEE80211_CHAN_OFDM () {0x40;}' unless defined(&IEEE80211_CHAN_OFDM);
    eval 'sub IEEE80211_CHAN_2GHZ () {0x80;}' unless defined(&IEEE80211_CHAN_2GHZ);
    eval 'sub IEEE80211_CHAN_5GHZ () {0x100;}' unless defined(&IEEE80211_CHAN_5GHZ);
    eval 'sub IEEE80211_CHAN_PASSIVE () {0x200;}' unless defined(&IEEE80211_CHAN_PASSIVE);
    eval 'sub IEEE80211_CHAN_DYN () {0x400;}' unless defined(&IEEE80211_CHAN_DYN);
    eval 'sub IEEE80211_CHAN_GFSK () {0x800;}' unless defined(&IEEE80211_CHAN_GFSK);
    eval 'sub IEEE80211_CHAN_GSM () {0x1000;}' unless defined(&IEEE80211_CHAN_GSM);
    eval 'sub IEEE80211_CHAN_STURBO () {0x2000;}' unless defined(&IEEE80211_CHAN_STURBO);
    eval 'sub IEEE80211_CHAN_HALF () {0x4000;}' unless defined(&IEEE80211_CHAN_HALF);
    eval 'sub IEEE80211_CHAN_QUARTER () {0x8000;}' unless defined(&IEEE80211_CHAN_QUARTER);
    eval 'sub IEEE80211_CHAN_HT20 () {0x10000;}' unless defined(&IEEE80211_CHAN_HT20);
    eval 'sub IEEE80211_CHAN_HT40U () {0x20000;}' unless defined(&IEEE80211_CHAN_HT40U);
    eval 'sub IEEE80211_CHAN_HT40D () {0x40000;}' unless defined(&IEEE80211_CHAN_HT40D);
    eval 'sub IEEE80211_CHAN_DFS () {0x80000;}' unless defined(&IEEE80211_CHAN_DFS);
    eval 'sub IEEE80211_CHAN_4MSXMIT () {0x100000;}' unless defined(&IEEE80211_CHAN_4MSXMIT);
    eval 'sub IEEE80211_CHAN_NOADHOC () {0x200000;}' unless defined(&IEEE80211_CHAN_NOADHOC);
    eval 'sub IEEE80211_CHAN_NOHOSTAP () {0x400000;}' unless defined(&IEEE80211_CHAN_NOHOSTAP);
    eval 'sub IEEE80211_CHAN_11D () {0x800000;}' unless defined(&IEEE80211_CHAN_11D);
    eval 'sub IEEE80211_CHAN_HT40 () {( &IEEE80211_CHAN_HT40U |  &IEEE80211_CHAN_HT40D);}' unless defined(&IEEE80211_CHAN_HT40);
    eval 'sub IEEE80211_CHAN_HT () {( &IEEE80211_CHAN_HT20 |  &IEEE80211_CHAN_HT40);}' unless defined(&IEEE80211_CHAN_HT);
    eval 'sub IEEE80211_CHAN_BITS () {"\\20\\1PRIV0\\2PRIV2\\3PRIV3\\4PRIV4\\5TURBO\\6CCK\\7OFDM\\0102GHZ\\0115GHZ" "\\12PASSIVE\\13DYN\\14GFSK\\15GSM\\16STURBO\\17HALF\\20QUARTER\\21HT20" "\\22HT40U\\23HT40D\\24DFS\\0254MSXMIT\\26NOADHOC\\27NOHOSTAP\\03011D";}' unless defined(&IEEE80211_CHAN_BITS);
    eval 'sub IEEE80211_CHAN_FHSS () {( &IEEE80211_CHAN_2GHZ |  &IEEE80211_CHAN_GFSK);}' unless defined(&IEEE80211_CHAN_FHSS);
    eval 'sub IEEE80211_CHAN_A () {( &IEEE80211_CHAN_5GHZ |  &IEEE80211_CHAN_OFDM);}' unless defined(&IEEE80211_CHAN_A);
    eval 'sub IEEE80211_CHAN_B () {( &IEEE80211_CHAN_2GHZ |  &IEEE80211_CHAN_CCK);}' unless defined(&IEEE80211_CHAN_B);
    eval 'sub IEEE80211_CHAN_PUREG () {( &IEEE80211_CHAN_2GHZ |  &IEEE80211_CHAN_OFDM);}' unless defined(&IEEE80211_CHAN_PUREG);
    eval 'sub IEEE80211_CHAN_G () {( &IEEE80211_CHAN_2GHZ |  &IEEE80211_CHAN_DYN);}' unless defined(&IEEE80211_CHAN_G);
    eval 'sub IEEE80211_CHAN_108A () {( &IEEE80211_CHAN_A |  &IEEE80211_CHAN_TURBO);}' unless defined(&IEEE80211_CHAN_108A);
    eval 'sub IEEE80211_CHAN_108G () {( &IEEE80211_CHAN_PUREG |  &IEEE80211_CHAN_TURBO);}' unless defined(&IEEE80211_CHAN_108G);
    eval 'sub IEEE80211_CHAN_ST () {( &IEEE80211_CHAN_108A |  &IEEE80211_CHAN_STURBO);}' unless defined(&IEEE80211_CHAN_ST);
    eval 'sub IEEE80211_CHAN_ALL () {( &IEEE80211_CHAN_2GHZ |  &IEEE80211_CHAN_5GHZ |  &IEEE80211_CHAN_GFSK |  &IEEE80211_CHAN_CCK |  &IEEE80211_CHAN_OFDM |  &IEEE80211_CHAN_DYN |  &IEEE80211_CHAN_HALF |  &IEEE80211_CHAN_QUARTER |  &IEEE80211_CHAN_HT);}' unless defined(&IEEE80211_CHAN_ALL);
    eval 'sub IEEE80211_CHAN_ALLTURBO () {( &IEEE80211_CHAN_ALL |  &IEEE80211_CHAN_TURBO |  &IEEE80211_CHAN_STURBO);}' unless defined(&IEEE80211_CHAN_ALLTURBO);
    eval 'sub IEEE80211_IS_CHAN_FHSS {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_FHSS) ==  &IEEE80211_CHAN_FHSS));
    }' unless defined(&IEEE80211_IS_CHAN_FHSS);
    eval 'sub IEEE80211_IS_CHAN_A {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_A) ==  &IEEE80211_CHAN_A));
    }' unless defined(&IEEE80211_IS_CHAN_A);
    eval 'sub IEEE80211_IS_CHAN_B {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_B) ==  &IEEE80211_CHAN_B));
    }' unless defined(&IEEE80211_IS_CHAN_B);
    eval 'sub IEEE80211_IS_CHAN_PUREG {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_PUREG) ==  &IEEE80211_CHAN_PUREG));
    }' unless defined(&IEEE80211_IS_CHAN_PUREG);
    eval 'sub IEEE80211_IS_CHAN_G {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_G) ==  &IEEE80211_CHAN_G));
    }' unless defined(&IEEE80211_IS_CHAN_G);
    eval 'sub IEEE80211_IS_CHAN_ANYG {
        my($_c) = @_;
	    eval q(( &IEEE80211_IS_CHAN_PUREG($_c) ||  &IEEE80211_IS_CHAN_G($_c)));
    }' unless defined(&IEEE80211_IS_CHAN_ANYG);
    eval 'sub IEEE80211_IS_CHAN_ST {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_ST) ==  &IEEE80211_CHAN_ST));
    }' unless defined(&IEEE80211_IS_CHAN_ST);
    eval 'sub IEEE80211_IS_CHAN_108A {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_108A) ==  &IEEE80211_CHAN_108A));
    }' unless defined(&IEEE80211_IS_CHAN_108A);
    eval 'sub IEEE80211_IS_CHAN_108G {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_108G) ==  &IEEE80211_CHAN_108G));
    }' unless defined(&IEEE80211_IS_CHAN_108G);
    eval 'sub IEEE80211_IS_CHAN_2GHZ {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_2GHZ) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_2GHZ);
    eval 'sub IEEE80211_IS_CHAN_5GHZ {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_5GHZ) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_5GHZ);
    eval 'sub IEEE80211_IS_CHAN_PASSIVE {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_PASSIVE) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_PASSIVE);
    eval 'sub IEEE80211_IS_CHAN_OFDM {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags & ( &IEEE80211_CHAN_OFDM |  &IEEE80211_CHAN_DYN)) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_OFDM);
    eval 'sub IEEE80211_IS_CHAN_CCK {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags & ( &IEEE80211_CHAN_CCK |  &IEEE80211_CHAN_DYN)) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_CCK);
    eval 'sub IEEE80211_IS_CHAN_DYN {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_DYN) ==  &IEEE80211_CHAN_DYN));
    }' unless defined(&IEEE80211_IS_CHAN_DYN);
    eval 'sub IEEE80211_IS_CHAN_GFSK {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_GFSK) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_GFSK);
    eval 'sub IEEE80211_IS_CHAN_TURBO {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_TURBO) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_TURBO);
    eval 'sub IEEE80211_IS_CHAN_STURBO {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_STURBO) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_STURBO);
    eval 'sub IEEE80211_IS_CHAN_DTURBO {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags & ( &IEEE80211_CHAN_TURBO |  &IEEE80211_CHAN_STURBO)) ==  &IEEE80211_CHAN_TURBO));
    }' unless defined(&IEEE80211_IS_CHAN_DTURBO);
    eval 'sub IEEE80211_IS_CHAN_HALF {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_HALF) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_HALF);
    eval 'sub IEEE80211_IS_CHAN_QUARTER {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_QUARTER) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_QUARTER);
    eval 'sub IEEE80211_IS_CHAN_FULL {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags & ( &IEEE80211_CHAN_QUARTER |  &IEEE80211_CHAN_HALF)) == 0));
    }' unless defined(&IEEE80211_IS_CHAN_FULL);
    eval 'sub IEEE80211_IS_CHAN_GSM {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_GSM) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_GSM);
    eval 'sub IEEE80211_IS_CHAN_HT {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_HT) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_HT);
    eval 'sub IEEE80211_IS_CHAN_HT20 {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_HT20) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_HT20);
    eval 'sub IEEE80211_IS_CHAN_HT40 {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_HT40) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_HT40);
    eval 'sub IEEE80211_IS_CHAN_HT40U {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_HT40U) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_HT40U);
    eval 'sub IEEE80211_IS_CHAN_HT40D {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_HT40D) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_HT40D);
    eval 'sub IEEE80211_IS_CHAN_HTA {
        my($_c) = @_;
	    eval q(( &IEEE80211_IS_CHAN_5GHZ($_c)  && (($_c)-> &ic_flags &  &IEEE80211_CHAN_HT) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_HTA);
    eval 'sub IEEE80211_IS_CHAN_HTG {
        my($_c) = @_;
	    eval q(( &IEEE80211_IS_CHAN_2GHZ($_c)  && (($_c)-> &ic_flags &  &IEEE80211_CHAN_HT) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_HTG);
    eval 'sub IEEE80211_IS_CHAN_DFS {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_DFS) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_DFS);
    eval 'sub IEEE80211_IS_CHAN_NOADHOC {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_NOADHOC) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_NOADHOC);
    eval 'sub IEEE80211_IS_CHAN_NOHOSTAP {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_NOHOSTAP) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_NOHOSTAP);
    eval 'sub IEEE80211_IS_CHAN_11D {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_flags &  &IEEE80211_CHAN_11D) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_11D);
    eval 'sub IEEE80211_CHAN2IEEE {
        my($_c) = @_;
	    eval q(($_c)-> &ic_ieee);
    }' unless defined(&IEEE80211_CHAN2IEEE);
    eval 'sub IEEE80211_CHANSTATE_RADAR () {0x1;}' unless defined(&IEEE80211_CHANSTATE_RADAR);
    eval 'sub IEEE80211_CHANSTATE_CACDONE () {0x2;}' unless defined(&IEEE80211_CHANSTATE_CACDONE);
    eval 'sub IEEE80211_CHANSTATE_CWINT () {0x4;}' unless defined(&IEEE80211_CHANSTATE_CWINT);
    eval 'sub IEEE80211_CHANSTATE_NORADAR () {0x10;}' unless defined(&IEEE80211_CHANSTATE_NORADAR);
    eval 'sub IEEE80211_IS_CHAN_RADAR {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_state &  &IEEE80211_CHANSTATE_RADAR) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_RADAR);
    eval 'sub IEEE80211_IS_CHAN_CACDONE {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_state &  &IEEE80211_CHANSTATE_CACDONE) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_CACDONE);
    eval 'sub IEEE80211_IS_CHAN_CWINT {
        my($_c) = @_;
	    eval q(((($_c)-> &ic_state &  &IEEE80211_CHANSTATE_CWINT) != 0));
    }' unless defined(&IEEE80211_IS_CHAN_CWINT);
    eval 'sub IEEE80211_FH_CHANMOD () {80;}' unless defined(&IEEE80211_FH_CHANMOD);
    eval 'sub IEEE80211_FH_CHAN {
        my($set,$pat) = @_;
	    eval q(((($set)-1)* &IEEE80211_FH_CHANMOD+($pat)));
    }' unless defined(&IEEE80211_FH_CHAN);
    eval 'sub IEEE80211_FH_CHANSET {
        my($chan) = @_;
	    eval q((($chan)/ &IEEE80211_FH_CHANMOD+1));
    }' unless defined(&IEEE80211_FH_CHANSET);
    eval 'sub IEEE80211_FH_CHANPAT {
        my($chan) = @_;
	    eval q((($chan)% &IEEE80211_FH_CHANMOD));
    }' unless defined(&IEEE80211_FH_CHANPAT);
    eval 'sub IEEE80211_TID_SIZE () {( &WME_NUM_TID+1);}' unless defined(&IEEE80211_TID_SIZE);
    eval 'sub IEEE80211_NONQOS_TID () { &WME_NUM_TID;}' unless defined(&IEEE80211_NONQOS_TID);
    eval 'sub IEEE80211_AID_DEF () {128;}' unless defined(&IEEE80211_AID_DEF);
    eval 'sub IEEE80211_AID_MIN () {16;}' unless defined(&IEEE80211_AID_MIN);
    eval 'sub IEEE80211_RATE_SIZE () {8;}' unless defined(&IEEE80211_RATE_SIZE);
    eval 'sub IEEE80211_RATE_MAXSIZE () {15;}' unless defined(&IEEE80211_RATE_MAXSIZE);
    eval 'sub IEEE80211_HTRATE_MAXSIZE () {77;}' unless defined(&IEEE80211_HTRATE_MAXSIZE);
    eval 'sub IEEE80211_RATE_MCS () {0x80;}' unless defined(&IEEE80211_RATE_MCS);
}
1;
