require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_H_)) {
    eval 'sub _NET80211_IEEE80211_H_ () {1;}' unless defined(&_NET80211_IEEE80211_H_);
    eval 'sub IEEE80211_ADDR_LEN () {6;}' unless defined(&IEEE80211_ADDR_LEN);
    eval 'sub IEEE80211_IS_MULTICAST {
        my($_a) = @_;
	    eval q((*($_a) & 0x1));
    }' unless defined(&IEEE80211_IS_MULTICAST);
    if(defined(&_KERNEL)) {
    }
    eval 'sub IEEE80211_PLCP_SFD () {0xf3a0;}' unless defined(&IEEE80211_PLCP_SFD);
    eval 'sub IEEE80211_PLCP_SERVICE () {0x;}' unless defined(&IEEE80211_PLCP_SERVICE);
    eval 'sub IEEE80211_PLCP_SERVICE_LOCKED () {0x4;}' unless defined(&IEEE80211_PLCP_SERVICE_LOCKED);
    eval 'sub IEEE80211_PLCL_SERVICE_PBCC () {0x8;}' unless defined(&IEEE80211_PLCL_SERVICE_PBCC);
    eval 'sub IEEE80211_PLCP_SERVICE_LENEXT5 () {0x20;}' unless defined(&IEEE80211_PLCP_SERVICE_LENEXT5);
    eval 'sub IEEE80211_PLCP_SERVICE_LENEXT6 () {0x40;}' unless defined(&IEEE80211_PLCP_SERVICE_LENEXT6);
    eval 'sub IEEE80211_PLCP_SERVICE_LENEXT7 () {0x80;}' unless defined(&IEEE80211_PLCP_SERVICE_LENEXT7);
    eval 'sub IEEE80211_FC0_VERSION_MASK () {0x3;}' unless defined(&IEEE80211_FC0_VERSION_MASK);
    eval 'sub IEEE80211_FC0_VERSION_SHIFT () {0;}' unless defined(&IEEE80211_FC0_VERSION_SHIFT);
    eval 'sub IEEE80211_FC0_VERSION_0 () {0x;}' unless defined(&IEEE80211_FC0_VERSION_0);
    eval 'sub IEEE80211_FC0_TYPE_MASK () {0xc;}' unless defined(&IEEE80211_FC0_TYPE_MASK);
    eval 'sub IEEE80211_FC0_TYPE_SHIFT () {2;}' unless defined(&IEEE80211_FC0_TYPE_SHIFT);
    eval 'sub IEEE80211_FC0_TYPE_MGT () {0x;}' unless defined(&IEEE80211_FC0_TYPE_MGT);
    eval 'sub IEEE80211_FC0_TYPE_CTL () {0x4;}' unless defined(&IEEE80211_FC0_TYPE_CTL);
    eval 'sub IEEE80211_FC0_TYPE_DATA () {0x8;}' unless defined(&IEEE80211_FC0_TYPE_DATA);
    eval 'sub IEEE80211_FC0_SUBTYPE_MASK () {0xf0;}' unless defined(&IEEE80211_FC0_SUBTYPE_MASK);
    eval 'sub IEEE80211_FC0_SUBTYPE_SHIFT () {4;}' unless defined(&IEEE80211_FC0_SUBTYPE_SHIFT);
    eval 'sub IEEE80211_FC0_SUBTYPE_ASSOC_REQ () {0x;}' unless defined(&IEEE80211_FC0_SUBTYPE_ASSOC_REQ);
    eval 'sub IEEE80211_FC0_SUBTYPE_ASSOC_RESP () {0x10;}' unless defined(&IEEE80211_FC0_SUBTYPE_ASSOC_RESP);
    eval 'sub IEEE80211_FC0_SUBTYPE_REASSOC_REQ () {0x20;}' unless defined(&IEEE80211_FC0_SUBTYPE_REASSOC_REQ);
    eval 'sub IEEE80211_FC0_SUBTYPE_REASSOC_RESP () {0x30;}' unless defined(&IEEE80211_FC0_SUBTYPE_REASSOC_RESP);
    eval 'sub IEEE80211_FC0_SUBTYPE_PROBE_REQ () {0x40;}' unless defined(&IEEE80211_FC0_SUBTYPE_PROBE_REQ);
    eval 'sub IEEE80211_FC0_SUBTYPE_PROBE_RESP () {0x50;}' unless defined(&IEEE80211_FC0_SUBTYPE_PROBE_RESP);
    eval 'sub IEEE80211_FC0_SUBTYPE_TIMING_ADV () {0x60;}' unless defined(&IEEE80211_FC0_SUBTYPE_TIMING_ADV);
    eval 'sub IEEE80211_FC0_SUBTYPE_BEACON () {0x80;}' unless defined(&IEEE80211_FC0_SUBTYPE_BEACON);
    eval 'sub IEEE80211_FC0_SUBTYPE_ATIM () {0x90;}' unless defined(&IEEE80211_FC0_SUBTYPE_ATIM);
    eval 'sub IEEE80211_FC0_SUBTYPE_DISASSOC () {0xa0;}' unless defined(&IEEE80211_FC0_SUBTYPE_DISASSOC);
    eval 'sub IEEE80211_FC0_SUBTYPE_AUTH () {0xb0;}' unless defined(&IEEE80211_FC0_SUBTYPE_AUTH);
    eval 'sub IEEE80211_FC0_SUBTYPE_DEAUTH () {0xc0;}' unless defined(&IEEE80211_FC0_SUBTYPE_DEAUTH);
    eval 'sub IEEE80211_FC0_SUBTYPE_ACTION () {0xd0;}' unless defined(&IEEE80211_FC0_SUBTYPE_ACTION);
    eval 'sub IEEE80211_FC0_SUBTYPE_ACTION_NOACK () {0xe0;}' unless defined(&IEEE80211_FC0_SUBTYPE_ACTION_NOACK);
    eval 'sub IEEE80211_FC0_SUBTYPE_CONTROL_WRAP () {0x70;}' unless defined(&IEEE80211_FC0_SUBTYPE_CONTROL_WRAP);
    eval 'sub IEEE80211_FC0_SUBTYPE_BAR () {0x80;}' unless defined(&IEEE80211_FC0_SUBTYPE_BAR);
    eval 'sub IEEE80211_FC0_SUBTYPE_BA () {0x90;}' unless defined(&IEEE80211_FC0_SUBTYPE_BA);
    eval 'sub IEEE80211_FC0_SUBTYPE_PS_POLL () {0xa0;}' unless defined(&IEEE80211_FC0_SUBTYPE_PS_POLL);
    eval 'sub IEEE80211_FC0_SUBTYPE_RTS () {0xb0;}' unless defined(&IEEE80211_FC0_SUBTYPE_RTS);
    eval 'sub IEEE80211_FC0_SUBTYPE_CTS () {0xc0;}' unless defined(&IEEE80211_FC0_SUBTYPE_CTS);
    eval 'sub IEEE80211_FC0_SUBTYPE_ACK () {0xd0;}' unless defined(&IEEE80211_FC0_SUBTYPE_ACK);
    eval 'sub IEEE80211_FC0_SUBTYPE_CF_END () {0xe0;}' unless defined(&IEEE80211_FC0_SUBTYPE_CF_END);
    eval 'sub IEEE80211_FC0_SUBTYPE_CF_END_ACK () {0xf0;}' unless defined(&IEEE80211_FC0_SUBTYPE_CF_END_ACK);
    eval 'sub IEEE80211_FC0_SUBTYPE_DATA () {0x;}' unless defined(&IEEE80211_FC0_SUBTYPE_DATA);
    eval 'sub IEEE80211_FC0_SUBTYPE_CF_ACK () {0x10;}' unless defined(&IEEE80211_FC0_SUBTYPE_CF_ACK);
    eval 'sub IEEE80211_FC0_SUBTYPE_CF_POLL () {0x20;}' unless defined(&IEEE80211_FC0_SUBTYPE_CF_POLL);
    eval 'sub IEEE80211_FC0_SUBTYPE_CF_ACPL () {0x30;}' unless defined(&IEEE80211_FC0_SUBTYPE_CF_ACPL);
    eval 'sub IEEE80211_FC0_SUBTYPE_NODATA () {0x40;}' unless defined(&IEEE80211_FC0_SUBTYPE_NODATA);
    eval 'sub IEEE80211_FC0_SUBTYPE_CFACK () {0x50;}' unless defined(&IEEE80211_FC0_SUBTYPE_CFACK);
    eval 'sub IEEE80211_FC0_SUBTYPE_CFPOLL () {0x60;}' unless defined(&IEEE80211_FC0_SUBTYPE_CFPOLL);
    eval 'sub IEEE80211_FC0_SUBTYPE_CF_ACK_CF_ACK () {0x70;}' unless defined(&IEEE80211_FC0_SUBTYPE_CF_ACK_CF_ACK);
    eval 'sub IEEE80211_FC0_SUBTYPE_QOS () {0x80;}' unless defined(&IEEE80211_FC0_SUBTYPE_QOS);
    eval 'sub IEEE80211_FC0_SUBTYPE_QOS_NULL () {0xc0;}' unless defined(&IEEE80211_FC0_SUBTYPE_QOS_NULL);
    eval 'sub IEEE80211_FC1_DIR_MASK () {0x3;}' unless defined(&IEEE80211_FC1_DIR_MASK);
    eval 'sub IEEE80211_FC1_DIR_NODS () {0x;}' unless defined(&IEEE80211_FC1_DIR_NODS);
    eval 'sub IEEE80211_FC1_DIR_TODS () {0x1;}' unless defined(&IEEE80211_FC1_DIR_TODS);
    eval 'sub IEEE80211_FC1_DIR_FROMDS () {0x2;}' unless defined(&IEEE80211_FC1_DIR_FROMDS);
    eval 'sub IEEE80211_FC1_DIR_DSTODS () {0x3;}' unless defined(&IEEE80211_FC1_DIR_DSTODS);
    eval 'sub IEEE80211_IS_DSTODS {
        my($wh) = @_;
	    eval q(((($wh)-> $i_fc[1] &  &IEEE80211_FC1_DIR_MASK) ==  &IEEE80211_FC1_DIR_DSTODS));
    }' unless defined(&IEEE80211_IS_DSTODS);
    eval 'sub IEEE80211_FC1_MORE_FRAG () {0x4;}' unless defined(&IEEE80211_FC1_MORE_FRAG);
    eval 'sub IEEE80211_FC1_RETRY () {0x8;}' unless defined(&IEEE80211_FC1_RETRY);
    eval 'sub IEEE80211_FC1_PWR_MGT () {0x10;}' unless defined(&IEEE80211_FC1_PWR_MGT);
    eval 'sub IEEE80211_FC1_MORE_DATA () {0x20;}' unless defined(&IEEE80211_FC1_MORE_DATA);
    eval 'sub IEEE80211_FC1_PROTECTED () {0x40;}' unless defined(&IEEE80211_FC1_PROTECTED);
    eval 'sub IEEE80211_FC1_ORDER () {0x80;}' unless defined(&IEEE80211_FC1_ORDER);
    eval 'sub IEEE80211_HAS_SEQ {
        my($type, $subtype) = @_;
	    eval q((($type) !=  &IEEE80211_FC0_TYPE_CTL  && !(($type) ==  &IEEE80211_FC0_TYPE_DATA  && (($subtype) &  &IEEE80211_FC0_SUBTYPE_QOS_NULL) ==  &IEEE80211_FC0_SUBTYPE_QOS_NULL)));
    }' unless defined(&IEEE80211_HAS_SEQ);
    eval 'sub IEEE80211_SEQ_FRAG_MASK () {0xf;}' unless defined(&IEEE80211_SEQ_FRAG_MASK);
    eval 'sub IEEE80211_SEQ_FRAG_SHIFT () {0;}' unless defined(&IEEE80211_SEQ_FRAG_SHIFT);
    eval 'sub IEEE80211_SEQ_SEQ_MASK () {0xfff0;}' unless defined(&IEEE80211_SEQ_SEQ_MASK);
    eval 'sub IEEE80211_SEQ_SEQ_SHIFT () {4;}' unless defined(&IEEE80211_SEQ_SEQ_SHIFT);
    eval 'sub IEEE80211_SEQ_RANGE () {4096;}' unless defined(&IEEE80211_SEQ_RANGE);
    eval 'sub IEEE80211_SEQ_ADD {
        my($seq, $incr) = @_;
	    eval q(((($seq) + ($incr)) & ( &IEEE80211_SEQ_RANGE-1)));
    }' unless defined(&IEEE80211_SEQ_ADD);
    eval 'sub IEEE80211_SEQ_INC {
        my($seq) = @_;
	    eval q( &IEEE80211_SEQ_ADD($seq,1));
    }' unless defined(&IEEE80211_SEQ_INC);
    eval 'sub IEEE80211_SEQ_SUB {
        my($a, $b) = @_;
	    eval q(((($a) +  &IEEE80211_SEQ_RANGE - ($b)) & ( &IEEE80211_SEQ_RANGE-1)));
    }' unless defined(&IEEE80211_SEQ_SUB);
    eval 'sub IEEE80211_SEQ_BA_RANGE () {2048;}' unless defined(&IEEE80211_SEQ_BA_RANGE);
    eval 'sub IEEE80211_SEQ_BA_BEFORE {
        my($a, $b) = @_;
	    eval q(( &IEEE80211_SEQ_SUB($b, $a+1) <  &IEEE80211_SEQ_BA_RANGE-1));
    }' unless defined(&IEEE80211_SEQ_BA_BEFORE);
    eval 'sub IEEE80211_NWID_LEN () {32;}' unless defined(&IEEE80211_NWID_LEN);
    eval 'sub IEEE80211_MESHID_LEN () {32;}' unless defined(&IEEE80211_MESHID_LEN);
    eval 'sub IEEE80211_QOS_TXOP () {0xff;}' unless defined(&IEEE80211_QOS_TXOP);
    eval 'sub IEEE80211_QOS_AMSDU () {0x80;}' unless defined(&IEEE80211_QOS_AMSDU);
    eval 'sub IEEE80211_QOS_AMSDU_S () {7;}' unless defined(&IEEE80211_QOS_AMSDU_S);
    eval 'sub IEEE80211_QOS_ACKPOLICY () {0x60;}' unless defined(&IEEE80211_QOS_ACKPOLICY);
    eval 'sub IEEE80211_QOS_ACKPOLICY_S () {5;}' unless defined(&IEEE80211_QOS_ACKPOLICY_S);
    eval 'sub IEEE80211_QOS_ACKPOLICY_NOACK () {0x20;}' unless defined(&IEEE80211_QOS_ACKPOLICY_NOACK);
    eval 'sub IEEE80211_QOS_ACKPOLICY_BA () {0x60;}' unless defined(&IEEE80211_QOS_ACKPOLICY_BA);
    eval 'sub IEEE80211_QOS_EOSP () {0x10;}' unless defined(&IEEE80211_QOS_EOSP);
    eval 'sub IEEE80211_QOS_EOSP_S () {4;}' unless defined(&IEEE80211_QOS_EOSP_S);
    eval 'sub IEEE80211_QOS_TID () {0xf;}' unless defined(&IEEE80211_QOS_TID);
    eval 'sub IEEE80211_QOS_MC () {0x1;}' unless defined(&IEEE80211_QOS_MC);
    eval 'sub IEEE80211_QOS_MESH_PSL () {0x2;}' unless defined(&IEEE80211_QOS_MESH_PSL);
    eval 'sub IEEE80211_QOS_RSPI () {0x4;}' unless defined(&IEEE80211_QOS_RSPI);
    eval 'sub IEEE80211_QOS_HAS_SEQ {
        my($wh) = @_;
	    eval q(((($wh)-> $i_fc[0] & ( &IEEE80211_FC0_TYPE_MASK |  &IEEE80211_FC0_SUBTYPE_QOS)) == ( &IEEE80211_FC0_TYPE_DATA |  &IEEE80211_FC0_SUBTYPE_QOS)));
    }' unless defined(&IEEE80211_QOS_HAS_SEQ);
    eval 'sub WME_NUM_AC () {4;}' unless defined(&WME_NUM_AC);
    eval 'sub WME_NUM_TID () {16;}' unless defined(&WME_NUM_TID);
    eval 'sub WME_PARAM_ACI () {0x60;}' unless defined(&WME_PARAM_ACI);
    eval 'sub WME_PARAM_ACI_S () {5;}' unless defined(&WME_PARAM_ACI_S);
    eval 'sub WME_PARAM_ACM () {0x10;}' unless defined(&WME_PARAM_ACM);
    eval 'sub WME_PARAM_ACM_S () {4;}' unless defined(&WME_PARAM_ACM_S);
    eval 'sub WME_PARAM_AIFSN () {0xf;}' unless defined(&WME_PARAM_AIFSN);
    eval 'sub WME_PARAM_AIFSN_S () {0;}' unless defined(&WME_PARAM_AIFSN_S);
    eval 'sub WME_PARAM_LOGCWMIN () {0xf;}' unless defined(&WME_PARAM_LOGCWMIN);
    eval 'sub WME_PARAM_LOGCWMIN_S () {0;}' unless defined(&WME_PARAM_LOGCWMIN_S);
    eval 'sub WME_PARAM_LOGCWMAX () {0xf0;}' unless defined(&WME_PARAM_LOGCWMAX);
    eval 'sub WME_PARAM_LOGCWMAX_S () {4;}' unless defined(&WME_PARAM_LOGCWMAX_S);
    eval 'sub WME_AC_TO_TID {
        my($_ac) = @_;
	    eval q(( (($_ac) ==  &WME_AC_VO) ? 6: (($_ac) ==  &WME_AC_VI) ? 5: (($_ac) ==  &WME_AC_BK) ? 1: 0));
    }' unless defined(&WME_AC_TO_TID);
    eval 'sub TID_TO_WME_AC {
        my($_tid) = @_;
	    eval q(( (($_tid) == 0|| ($_tid) == 3) ?  &WME_AC_BE : (($_tid) < 3) ?  &WME_AC_BK : (($_tid) < 6) ?  &WME_AC_VI :  &WME_AC_VO));
    }' unless defined(&TID_TO_WME_AC);
    eval 'sub WME_QOSINFO_COUNT () {0xf;}' unless defined(&WME_QOSINFO_COUNT);
    eval 'sub WME_CAPINFO_UAPSD_EN () {0x80;}' unless defined(&WME_CAPINFO_UAPSD_EN);
    eval 'sub WME_CAPINFO_UAPSD_VO () {0x1;}' unless defined(&WME_CAPINFO_UAPSD_VO);
    eval 'sub WME_CAPINFO_UAPSD_VI () {0x2;}' unless defined(&WME_CAPINFO_UAPSD_VI);
    eval 'sub WME_CAPINFO_UAPSD_BK () {0x4;}' unless defined(&WME_CAPINFO_UAPSD_BK);
    eval 'sub WME_CAPINFO_UAPSD_BE () {0x8;}' unless defined(&WME_CAPINFO_UAPSD_BE);
    eval 'sub WME_CAPINFO_UAPSD_ACFLAGS_SHIFT () {0;}' unless defined(&WME_CAPINFO_UAPSD_ACFLAGS_SHIFT);
    eval 'sub WME_CAPINFO_UAPSD_ACFLAGS_MASK () {0xf;}' unless defined(&WME_CAPINFO_UAPSD_ACFLAGS_MASK);
    eval 'sub WME_CAPINFO_UAPSD_MAXSP_SHIFT () {5;}' unless defined(&WME_CAPINFO_UAPSD_MAXSP_SHIFT);
    eval 'sub WME_CAPINFO_UAPSD_MAXSP_MASK () {0x3;}' unless defined(&WME_CAPINFO_UAPSD_MAXSP_MASK);
    eval 'sub WME_CAPINFO_IE_OFFSET () {8;}' unless defined(&WME_CAPINFO_IE_OFFSET);
    eval 'sub WME_UAPSD_MAXSP {
        my($_qosinfo) = @_;
	    eval q(((($_qosinfo) >>  &WME_CAPINFO_UAPSD_MAXSP_SHIFT) &  &WME_CAPINFO_UAPSD_MAXSP_MASK));
    }' unless defined(&WME_UAPSD_MAXSP);
    eval 'sub WME_UAPSD_AC_ENABLED {
        my($_ac, $_qosinfo) = @_;
	    eval q(((1<< (3- ($_ac))) & ( (($_qosinfo) >>  &WME_CAPINFO_UAPSD_ACFLAGS_SHIFT) &  &WME_CAPINFO_UAPSD_ACFLAGS_MASK)));
    }' unless defined(&WME_UAPSD_AC_ENABLED);
    eval 'sub MNF_SETUP_REQ () {0;}' unless defined(&MNF_SETUP_REQ);
    eval 'sub MNF_SETUP_RESP () {1;}' unless defined(&MNF_SETUP_RESP);
    eval 'sub MNF_TEARDOWN () {2;}' unless defined(&MNF_TEARDOWN);
    eval 'sub IEEE80211_ACTION_CAT_SM () {0;}' unless defined(&IEEE80211_ACTION_CAT_SM);
    eval 'sub IEEE80211_ACTION_CAT_QOS () {1;}' unless defined(&IEEE80211_ACTION_CAT_QOS);
    eval 'sub IEEE80211_ACTION_CAT_DLS () {2;}' unless defined(&IEEE80211_ACTION_CAT_DLS);
    eval 'sub IEEE80211_ACTION_CAT_BA () {3;}' unless defined(&IEEE80211_ACTION_CAT_BA);
    eval 'sub IEEE80211_ACTION_CAT_HT () {7;}' unless defined(&IEEE80211_ACTION_CAT_HT);
    eval 'sub IEEE80211_ACTION_CAT_MESH () {13;}' unless defined(&IEEE80211_ACTION_CAT_MESH);
    eval 'sub IEEE80211_ACTION_CAT_SELF_PROT () {15;}' unless defined(&IEEE80211_ACTION_CAT_SELF_PROT);
    eval 'sub IEEE80211_ACTION_CAT_VHT () {21;}' unless defined(&IEEE80211_ACTION_CAT_VHT);
    eval 'sub IEEE80211_ACTION_CAT_VENDOR () {127;}' unless defined(&IEEE80211_ACTION_CAT_VENDOR);
    eval 'sub IEEE80211_ACTION_HT_TXCHWIDTH () {0;}' unless defined(&IEEE80211_ACTION_HT_TXCHWIDTH);
    eval 'sub IEEE80211_ACTION_HT_MIMOPWRSAVE () {1;}' unless defined(&IEEE80211_ACTION_HT_MIMOPWRSAVE);
    eval 'sub IEEE80211_A_HT_TXCHWIDTH_20 () {0;}' unless defined(&IEEE80211_A_HT_TXCHWIDTH_20);
    eval 'sub IEEE80211_A_HT_TXCHWIDTH_2040 () {1;}' unless defined(&IEEE80211_A_HT_TXCHWIDTH_2040);
    eval 'sub IEEE80211_A_HT_MIMOPWRSAVE_ENA () {0x1;}' unless defined(&IEEE80211_A_HT_MIMOPWRSAVE_ENA);
    eval 'sub IEEE80211_A_HT_MIMOPWRSAVE_MODE () {0x2;}' unless defined(&IEEE80211_A_HT_MIMOPWRSAVE_MODE);
    eval 'sub IEEE80211_A_HT_MIMOPWRSAVE_MODE_S () {1;}' unless defined(&IEEE80211_A_HT_MIMOPWRSAVE_MODE_S);
    eval 'sub IEEE80211_A_HT_MIMOPWRSAVE_DYNAMIC () {0x2;}' unless defined(&IEEE80211_A_HT_MIMOPWRSAVE_DYNAMIC);
    eval 'sub IEEE80211_A_HT_MIMOPWRSAVE_STATIC () {0x;}' unless defined(&IEEE80211_A_HT_MIMOPWRSAVE_STATIC);
    eval 'sub IEEE80211_ACTION_BA_ADDBA_REQUEST () {0;}' unless defined(&IEEE80211_ACTION_BA_ADDBA_REQUEST);
    eval 'sub IEEE80211_ACTION_BA_ADDBA_RESPONSE () {1;}' unless defined(&IEEE80211_ACTION_BA_ADDBA_RESPONSE);
    eval 'sub IEEE80211_ACTION_BA_DELBA () {2;}' unless defined(&IEEE80211_ACTION_BA_DELBA);
    eval 'sub IEEE80211_BAPS_BUFSIZ () {0xffc0;}' unless defined(&IEEE80211_BAPS_BUFSIZ);
    eval 'sub IEEE80211_BAPS_BUFSIZ_S () {6;}' unless defined(&IEEE80211_BAPS_BUFSIZ_S);
    eval 'sub IEEE80211_BAPS_TID () {0x3c;}' unless defined(&IEEE80211_BAPS_TID);
    eval 'sub IEEE80211_BAPS_TID_S () {2;}' unless defined(&IEEE80211_BAPS_TID_S);
    eval 'sub IEEE80211_BAPS_POLICY () {0x2;}' unless defined(&IEEE80211_BAPS_POLICY);
    eval 'sub IEEE80211_BAPS_POLICY_S () {1;}' unless defined(&IEEE80211_BAPS_POLICY_S);
    eval 'sub IEEE80211_BAPS_POLICY_DELAYED () {(0<< &IEEE80211_BAPS_POLICY_S);}' unless defined(&IEEE80211_BAPS_POLICY_DELAYED);
    eval 'sub IEEE80211_BAPS_POLICY_IMMEDIATE () {(1<< &IEEE80211_BAPS_POLICY_S);}' unless defined(&IEEE80211_BAPS_POLICY_IMMEDIATE);
    eval 'sub IEEE80211_BASEQ_START () {0xfff0;}' unless defined(&IEEE80211_BASEQ_START);
    eval 'sub IEEE80211_BASEQ_START_S () {4;}' unless defined(&IEEE80211_BASEQ_START_S);
    eval 'sub IEEE80211_BASEQ_FRAG () {0xf;}' unless defined(&IEEE80211_BASEQ_FRAG);
    eval 'sub IEEE80211_BASEQ_FRAG_S () {0;}' unless defined(&IEEE80211_BASEQ_FRAG_S);
    eval 'sub IEEE80211_DELBAPS_TID () {0xf000;}' unless defined(&IEEE80211_DELBAPS_TID);
    eval 'sub IEEE80211_DELBAPS_TID_S () {12;}' unless defined(&IEEE80211_DELBAPS_TID_S);
    eval 'sub IEEE80211_DELBAPS_INIT () {0x800;}' unless defined(&IEEE80211_DELBAPS_INIT);
    eval 'sub IEEE80211_DELBAPS_INIT_S () {11;}' unless defined(&IEEE80211_DELBAPS_INIT_S);
    eval 'sub IEEE80211_BAR_TID () {0xf000;}' unless defined(&IEEE80211_BAR_TID);
    eval 'sub IEEE80211_BAR_TID_S () {12;}' unless defined(&IEEE80211_BAR_TID_S);
    eval 'sub IEEE80211_BAR_COMP () {0x4;}' unless defined(&IEEE80211_BAR_COMP);
    eval 'sub IEEE80211_BAR_MTID () {0x2;}' unless defined(&IEEE80211_BAR_MTID);
    eval 'sub IEEE80211_BAR_NOACK () {0x1;}' unless defined(&IEEE80211_BAR_NOACK);
    eval 'sub IEEE80211_BAR_SEQ_START () {0xfff0;}' unless defined(&IEEE80211_BAR_SEQ_START);
    eval 'sub IEEE80211_BAR_SEQ_START_S () {4;}' unless defined(&IEEE80211_BAR_SEQ_START_S);
    eval 'sub IEEE80211_BEACON_INTERVAL {
        my($beacon) = @_;
	    eval q((($beacon)[8] | (($beacon)[9] << 8)));
    }' unless defined(&IEEE80211_BEACON_INTERVAL);
    eval 'sub IEEE80211_BEACON_CAPABILITY {
        my($beacon) = @_;
	    eval q((($beacon)[10] | (($beacon)[11] << 8)));
    }' unless defined(&IEEE80211_BEACON_CAPABILITY);
    eval 'sub IEEE80211_CAPINFO_ESS () {0x1;}' unless defined(&IEEE80211_CAPINFO_ESS);
    eval 'sub IEEE80211_CAPINFO_IBSS () {0x2;}' unless defined(&IEEE80211_CAPINFO_IBSS);
    eval 'sub IEEE80211_CAPINFO_CF_POLLABLE () {0x4;}' unless defined(&IEEE80211_CAPINFO_CF_POLLABLE);
    eval 'sub IEEE80211_CAPINFO_CF_POLLREQ () {0x8;}' unless defined(&IEEE80211_CAPINFO_CF_POLLREQ);
    eval 'sub IEEE80211_CAPINFO_PRIVACY () {0x10;}' unless defined(&IEEE80211_CAPINFO_PRIVACY);
    eval 'sub IEEE80211_CAPINFO_SHORT_PREAMBLE () {0x20;}' unless defined(&IEEE80211_CAPINFO_SHORT_PREAMBLE);
    eval 'sub IEEE80211_CAPINFO_PBCC () {0x40;}' unless defined(&IEEE80211_CAPINFO_PBCC);
    eval 'sub IEEE80211_CAPINFO_CHNL_AGILITY () {0x80;}' unless defined(&IEEE80211_CAPINFO_CHNL_AGILITY);
    eval 'sub IEEE80211_CAPINFO_SPECTRUM_MGMT () {0x100;}' unless defined(&IEEE80211_CAPINFO_SPECTRUM_MGMT);
    eval 'sub IEEE80211_CAPINFO_SHORT_SLOTTIME () {0x400;}' unless defined(&IEEE80211_CAPINFO_SHORT_SLOTTIME);
    eval 'sub IEEE80211_CAPINFO_RSN () {0x800;}' unless defined(&IEEE80211_CAPINFO_RSN);
    eval 'sub IEEE80211_CAPINFO_DSSSOFDM () {0x2000;}' unless defined(&IEEE80211_CAPINFO_DSSSOFDM);
    eval 'sub IEEE80211_CAPINFO_BITS () {"\\20\\1ESS\\2IBSS\\3CF_POLLABLE\\4CF_POLLREQ\\5PRIVACY\\6SHORT_PREAMBLE" "\\7PBCC\\10CHNL_AGILITY\\11SPECTRUM_MGMT\\13SHORT_SLOTTIME\\14RSN" "\\16DSSOFDM";}' unless defined(&IEEE80211_CAPINFO_BITS);
    eval 'sub IEEE80211_HTCAP_LDPC () {0x1;}' unless defined(&IEEE80211_HTCAP_LDPC);
    eval 'sub IEEE80211_HTCAP_CHWIDTH40 () {0x2;}' unless defined(&IEEE80211_HTCAP_CHWIDTH40);
    eval 'sub IEEE80211_HTCAP_SMPS () {0xc;}' unless defined(&IEEE80211_HTCAP_SMPS);
    eval 'sub IEEE80211_HTCAP_SMPS_OFF () {0xc;}' unless defined(&IEEE80211_HTCAP_SMPS_OFF);
    eval 'sub IEEE80211_HTCAP_SMPS_DYNAMIC () {0x4;}' unless defined(&IEEE80211_HTCAP_SMPS_DYNAMIC);
    eval 'sub IEEE80211_HTCAP_SMPS_ENA () {0x;}' unless defined(&IEEE80211_HTCAP_SMPS_ENA);
    eval 'sub IEEE80211_HTCAP_GREENFIELD () {0x10;}' unless defined(&IEEE80211_HTCAP_GREENFIELD);
    eval 'sub IEEE80211_HTCAP_SHORTGI20 () {0x20;}' unless defined(&IEEE80211_HTCAP_SHORTGI20);
    eval 'sub IEEE80211_HTCAP_SHORTGI40 () {0x40;}' unless defined(&IEEE80211_HTCAP_SHORTGI40);
    eval 'sub IEEE80211_HTCAP_TXSTBC () {0x80;}' unless defined(&IEEE80211_HTCAP_TXSTBC);
    eval 'sub IEEE80211_HTCAP_RXSTBC () {0x300;}' unless defined(&IEEE80211_HTCAP_RXSTBC);
    eval 'sub IEEE80211_HTCAP_RXSTBC_S () {8;}' unless defined(&IEEE80211_HTCAP_RXSTBC_S);
    eval 'sub IEEE80211_HTCAP_RXSTBC_1STREAM () {0x100;}' unless defined(&IEEE80211_HTCAP_RXSTBC_1STREAM);
    eval 'sub IEEE80211_HTCAP_RXSTBC_2STREAM () {0x200;}' unless defined(&IEEE80211_HTCAP_RXSTBC_2STREAM);
    eval 'sub IEEE80211_HTCAP_RXSTBC_3STREAM () {0x300;}' unless defined(&IEEE80211_HTCAP_RXSTBC_3STREAM);
    eval 'sub IEEE80211_HTCAP_DELBA () {0x400;}' unless defined(&IEEE80211_HTCAP_DELBA);
    eval 'sub IEEE80211_HTCAP_MAXAMSDU () {0x800;}' unless defined(&IEEE80211_HTCAP_MAXAMSDU);
    eval 'sub IEEE80211_HTCAP_MAXAMSDU_7935 () {0x800;}' unless defined(&IEEE80211_HTCAP_MAXAMSDU_7935);
    eval 'sub IEEE80211_HTCAP_MAXAMSDU_3839 () {0x;}' unless defined(&IEEE80211_HTCAP_MAXAMSDU_3839);
    eval 'sub IEEE80211_HTCAP_DSSSCCK40 () {0x1000;}' unless defined(&IEEE80211_HTCAP_DSSSCCK40);
    eval 'sub IEEE80211_HTCAP_PSMP () {0x2000;}' unless defined(&IEEE80211_HTCAP_PSMP);
    eval 'sub IEEE80211_HTCAP_40INTOLERANT () {0x4000;}' unless defined(&IEEE80211_HTCAP_40INTOLERANT);
    eval 'sub IEEE80211_HTCAP_LSIGTXOPPROT () {0x8000;}' unless defined(&IEEE80211_HTCAP_LSIGTXOPPROT);
    eval 'sub IEEE80211_HTCAP_BITS () {"\\20\\1LDPC\\2CHWIDTH40\\5GREENFIELD\\6SHORTGI20\\7SHORTGI40\\10TXSTBC" "\\13DELBA\\14AMSDU(7935)\\15DSSSCCK40\\16PSMP\\1740INTOLERANT" "\\20LSIGTXOPPROT";}' unless defined(&IEEE80211_HTCAP_BITS);
    eval 'sub IEEE80211_HTCAP_MAXRXAMPDU () {0x3;}' unless defined(&IEEE80211_HTCAP_MAXRXAMPDU);
    eval 'sub IEEE80211_HTCAP_MAXRXAMPDU_S () {0;}' unless defined(&IEEE80211_HTCAP_MAXRXAMPDU_S);
    eval 'sub IEEE80211_HTCAP_MAXRXAMPDU_8K () {0;}' unless defined(&IEEE80211_HTCAP_MAXRXAMPDU_8K);
    eval 'sub IEEE80211_HTCAP_MAXRXAMPDU_16K () {1;}' unless defined(&IEEE80211_HTCAP_MAXRXAMPDU_16K);
    eval 'sub IEEE80211_HTCAP_MAXRXAMPDU_32K () {2;}' unless defined(&IEEE80211_HTCAP_MAXRXAMPDU_32K);
    eval 'sub IEEE80211_HTCAP_MAXRXAMPDU_64K () {3;}' unless defined(&IEEE80211_HTCAP_MAXRXAMPDU_64K);
    eval 'sub IEEE80211_HTCAP_MPDUDENSITY () {0x1c;}' unless defined(&IEEE80211_HTCAP_MPDUDENSITY);
    eval 'sub IEEE80211_HTCAP_MPDUDENSITY_S () {2;}' unless defined(&IEEE80211_HTCAP_MPDUDENSITY_S);
    eval 'sub IEEE80211_HTCAP_MPDUDENSITY_NA () {0;}' unless defined(&IEEE80211_HTCAP_MPDUDENSITY_NA);
    eval 'sub IEEE80211_HTCAP_MPDUDENSITY_025 () {1;}' unless defined(&IEEE80211_HTCAP_MPDUDENSITY_025);
    eval 'sub IEEE80211_HTCAP_MPDUDENSITY_05 () {2;}' unless defined(&IEEE80211_HTCAP_MPDUDENSITY_05);
    eval 'sub IEEE80211_HTCAP_MPDUDENSITY_1 () {3;}' unless defined(&IEEE80211_HTCAP_MPDUDENSITY_1);
    eval 'sub IEEE80211_HTCAP_MPDUDENSITY_2 () {4;}' unless defined(&IEEE80211_HTCAP_MPDUDENSITY_2);
    eval 'sub IEEE80211_HTCAP_MPDUDENSITY_4 () {5;}' unless defined(&IEEE80211_HTCAP_MPDUDENSITY_4);
    eval 'sub IEEE80211_HTCAP_MPDUDENSITY_8 () {6;}' unless defined(&IEEE80211_HTCAP_MPDUDENSITY_8);
    eval 'sub IEEE80211_HTCAP_MPDUDENSITY_16 () {7;}' unless defined(&IEEE80211_HTCAP_MPDUDENSITY_16);
    eval 'sub IEEE80211_HTCAP_PCO () {0x1;}' unless defined(&IEEE80211_HTCAP_PCO);
    eval 'sub IEEE80211_HTCAP_PCOTRANS () {0x6;}' unless defined(&IEEE80211_HTCAP_PCOTRANS);
    eval 'sub IEEE80211_HTCAP_PCOTRANS_S () {1;}' unless defined(&IEEE80211_HTCAP_PCOTRANS_S);
    eval 'sub IEEE80211_HTCAP_PCOTRANS_04 () {0x2;}' unless defined(&IEEE80211_HTCAP_PCOTRANS_04);
    eval 'sub IEEE80211_HTCAP_PCOTRANS_15 () {0x4;}' unless defined(&IEEE80211_HTCAP_PCOTRANS_15);
    eval 'sub IEEE80211_HTCAP_PCOTRANS_5 () {0x6;}' unless defined(&IEEE80211_HTCAP_PCOTRANS_5);
    eval 'sub IEEE80211_HTCAP_MCSFBACK () {0x300;}' unless defined(&IEEE80211_HTCAP_MCSFBACK);
    eval 'sub IEEE80211_HTCAP_MCSFBACK_S () {8;}' unless defined(&IEEE80211_HTCAP_MCSFBACK_S);
    eval 'sub IEEE80211_HTCAP_MCSFBACK_NONE () {0x;}' unless defined(&IEEE80211_HTCAP_MCSFBACK_NONE);
    eval 'sub IEEE80211_HTCAP_MCSFBACK_UNSOL () {0x200;}' unless defined(&IEEE80211_HTCAP_MCSFBACK_UNSOL);
    eval 'sub IEEE80211_HTCAP_MCSFBACK_MRQ () {0x300;}' unless defined(&IEEE80211_HTCAP_MCSFBACK_MRQ);
    eval 'sub IEEE80211_HTCAP_HTC () {0x400;}' unless defined(&IEEE80211_HTCAP_HTC);
    eval 'sub IEEE80211_HTCAP_RDR () {0x800;}' unless defined(&IEEE80211_HTCAP_RDR);
    eval 'sub IEEE80211_HTINFO_2NDCHAN () {0x3;}' unless defined(&IEEE80211_HTINFO_2NDCHAN);
    eval 'sub IEEE80211_HTINFO_2NDCHAN_S () {0;}' unless defined(&IEEE80211_HTINFO_2NDCHAN_S);
    eval 'sub IEEE80211_HTINFO_2NDCHAN_NONE () {0x;}' unless defined(&IEEE80211_HTINFO_2NDCHAN_NONE);
    eval 'sub IEEE80211_HTINFO_2NDCHAN_ABOVE () {0x1;}' unless defined(&IEEE80211_HTINFO_2NDCHAN_ABOVE);
    eval 'sub IEEE80211_HTINFO_2NDCHAN_BELOW () {0x3;}' unless defined(&IEEE80211_HTINFO_2NDCHAN_BELOW);
    eval 'sub IEEE80211_HTINFO_TXWIDTH () {0x4;}' unless defined(&IEEE80211_HTINFO_TXWIDTH);
    eval 'sub IEEE80211_HTINFO_TXWIDTH_20 () {0x;}' unless defined(&IEEE80211_HTINFO_TXWIDTH_20);
    eval 'sub IEEE80211_HTINFO_TXWIDTH_2040 () {0x4;}' unless defined(&IEEE80211_HTINFO_TXWIDTH_2040);
    eval 'sub IEEE80211_HTINFO_RIFSMODE () {0x8;}' unless defined(&IEEE80211_HTINFO_RIFSMODE);
    eval 'sub IEEE80211_HTINFO_RIFSMODE_PROH () {0x;}' unless defined(&IEEE80211_HTINFO_RIFSMODE_PROH);
    eval 'sub IEEE80211_HTINFO_RIFSMODE_PERM () {0x8;}' unless defined(&IEEE80211_HTINFO_RIFSMODE_PERM);
    eval 'sub IEEE80211_HTINFO_PMSPONLY () {0x10;}' unless defined(&IEEE80211_HTINFO_PMSPONLY);
    eval 'sub IEEE80211_HTINFO_SIGRAN () {0xe0;}' unless defined(&IEEE80211_HTINFO_SIGRAN);
    eval 'sub IEEE80211_HTINFO_SIGRAN_S () {5;}' unless defined(&IEEE80211_HTINFO_SIGRAN_S);
    eval 'sub IEEE80211_HTINFO_SIGRAN_5 () {0x;}' unless defined(&IEEE80211_HTINFO_SIGRAN_5);
    eval 'sub IEEE80211_HTINFO_OPMODE () {0x3;}' unless defined(&IEEE80211_HTINFO_OPMODE);
    eval 'sub IEEE80211_HTINFO_OPMODE_S () {0;}' unless defined(&IEEE80211_HTINFO_OPMODE_S);
    eval 'sub IEEE80211_HTINFO_OPMODE_PURE () {0x;}' unless defined(&IEEE80211_HTINFO_OPMODE_PURE);
    eval 'sub IEEE80211_HTINFO_OPMODE_PROTOPT () {0x1;}' unless defined(&IEEE80211_HTINFO_OPMODE_PROTOPT);
    eval 'sub IEEE80211_HTINFO_OPMODE_HT20PR () {0x2;}' unless defined(&IEEE80211_HTINFO_OPMODE_HT20PR);
    eval 'sub IEEE80211_HTINFO_OPMODE_MIXED () {0x3;}' unless defined(&IEEE80211_HTINFO_OPMODE_MIXED);
    eval 'sub IEEE80211_HTINFO_NONGF_PRESENT () {0x4;}' unless defined(&IEEE80211_HTINFO_NONGF_PRESENT);
    eval 'sub IEEE80211_HTINFO_TXBL () {0x8;}' unless defined(&IEEE80211_HTINFO_TXBL);
    eval 'sub IEEE80211_HTINFO_NONHT_PRESENT () {0x10;}' unless defined(&IEEE80211_HTINFO_NONHT_PRESENT);
    eval 'sub IEEE80211_HTINFO_2NDARYBEACON () {0x1;}' unless defined(&IEEE80211_HTINFO_2NDARYBEACON);
    eval 'sub IEEE80211_HTINFO_LSIGTXOPPROT () {0x2;}' unless defined(&IEEE80211_HTINFO_LSIGTXOPPROT);
    eval 'sub IEEE80211_HTINFO_PCO_ACTIVE () {0x4;}' unless defined(&IEEE80211_HTINFO_PCO_ACTIVE);
    eval 'sub IEEE80211_HTINFO_40MHZPHASE () {0x8;}' unless defined(&IEEE80211_HTINFO_40MHZPHASE);
    eval 'sub IEEE80211_HTINFO_BASIC_STBCMCS () {0x7f;}' unless defined(&IEEE80211_HTINFO_BASIC_STBCMCS);
    eval 'sub IEEE80211_HTINFO_BASIC_STBCMCS_S () {0;}' unless defined(&IEEE80211_HTINFO_BASIC_STBCMCS_S);
    eval 'sub IEEE80211_HTINFO_DUALPROTECTED () {0x80;}' unless defined(&IEEE80211_HTINFO_DUALPROTECTED);
    eval 'sub IEEE80211_VHT_OPMODE_CHANWIDTH_MASK () {3;}' unless defined(&IEEE80211_VHT_OPMODE_CHANWIDTH_MASK);
    eval 'sub IEEE80211_VHT_OPMODE_CHANWIDTH_20MHZ () {0;}' unless defined(&IEEE80211_VHT_OPMODE_CHANWIDTH_20MHZ);
    eval 'sub IEEE80211_VHT_OPMODE_CHANWIDTH_40MHZ () {1;}' unless defined(&IEEE80211_VHT_OPMODE_CHANWIDTH_40MHZ);
    eval 'sub IEEE80211_VHT_OPMODE_CHANWIDTH_80MHZ () {2;}' unless defined(&IEEE80211_VHT_OPMODE_CHANWIDTH_80MHZ);
    eval 'sub IEEE80211_VHT_OPMODE_CHANWIDTH_160MHZ () {3;}' unless defined(&IEEE80211_VHT_OPMODE_CHANWIDTH_160MHZ);
    eval 'sub IEEE80211_VHT_OPMODE_RX_NSS_MASK () {0x70;}' unless defined(&IEEE80211_VHT_OPMODE_RX_NSS_MASK);
    eval 'sub IEEE80211_VHT_OPMODE_RX_NSS_SHIFT () {4;}' unless defined(&IEEE80211_VHT_OPMODE_RX_NSS_SHIFT);
    eval 'sub IEEE80211_VHT_OPMODE_RX_NSS_TYPE_BF () {0x80;}' unless defined(&IEEE80211_VHT_OPMODE_RX_NSS_TYPE_BF);
    eval 'sub IEEE80211_VHTCAP_MAX_AMPDU_8K () {0;}' unless defined(&IEEE80211_VHTCAP_MAX_AMPDU_8K);
    eval 'sub IEEE80211_VHTCAP_MAX_AMPDU_16K () {1;}' unless defined(&IEEE80211_VHTCAP_MAX_AMPDU_16K);
    eval 'sub IEEE80211_VHTCAP_MAX_AMPDU_32K () {2;}' unless defined(&IEEE80211_VHTCAP_MAX_AMPDU_32K);
    eval 'sub IEEE80211_VHTCAP_MAX_AMPDU_64K () {3;}' unless defined(&IEEE80211_VHTCAP_MAX_AMPDU_64K);
    eval 'sub IEEE80211_VHTCAP_MAX_AMPDU_128K () {4;}' unless defined(&IEEE80211_VHTCAP_MAX_AMPDU_128K);
    eval 'sub IEEE80211_VHTCAP_MAX_AMPDU_256K () {5;}' unless defined(&IEEE80211_VHTCAP_MAX_AMPDU_256K);
    eval 'sub IEEE80211_VHTCAP_MAX_AMPDU_512K () {6;}' unless defined(&IEEE80211_VHTCAP_MAX_AMPDU_512K);
    eval 'sub IEEE80211_VHTCAP_MAX_AMPDU_1024K () {7;}' unless defined(&IEEE80211_VHTCAP_MAX_AMPDU_1024K);
    eval 'sub IEEE80211_VHT_MCS_SUPPORT_0_7 () {0;}' unless defined(&IEEE80211_VHT_MCS_SUPPORT_0_7);
    eval 'sub IEEE80211_VHT_MCS_SUPPORT_0_8 () {1;}' unless defined(&IEEE80211_VHT_MCS_SUPPORT_0_8);
    eval 'sub IEEE80211_VHT_MCS_SUPPORT_0_9 () {2;}' unless defined(&IEEE80211_VHT_MCS_SUPPORT_0_9);
    eval 'sub IEEE80211_VHT_MCS_NOT_SUPPORTED () {3;}' unless defined(&IEEE80211_VHT_MCS_NOT_SUPPORTED);
    eval 'sub IEEE80211_VHT_CHANWIDTH_USE_HT () {0;}' unless defined(&IEEE80211_VHT_CHANWIDTH_USE_HT);
    eval 'sub IEEE80211_VHT_CHANWIDTH_80MHZ () {1;}' unless defined(&IEEE80211_VHT_CHANWIDTH_80MHZ);
    eval 'sub IEEE80211_VHT_CHANWIDTH_160MHZ () {2;}' unless defined(&IEEE80211_VHT_CHANWIDTH_160MHZ);
    eval 'sub IEEE80211_VHT_CHANWIDTH_80P80MHZ () {3;}' unless defined(&IEEE80211_VHT_CHANWIDTH_80P80MHZ);
    eval 'sub IEEE80211_VHTCAP_MAX_MPDU_LENGTH_3895 () {0x;}' unless defined(&IEEE80211_VHTCAP_MAX_MPDU_LENGTH_3895);
    eval 'sub IEEE80211_VHTCAP_MAX_MPDU_LENGTH_7991 () {0x1;}' unless defined(&IEEE80211_VHTCAP_MAX_MPDU_LENGTH_7991);
    eval 'sub IEEE80211_VHTCAP_MAX_MPDU_LENGTH_11454 () {0x2;}' unless defined(&IEEE80211_VHTCAP_MAX_MPDU_LENGTH_11454);
    eval 'sub IEEE80211_VHTCAP_MAX_MPDU_MASK () {0x3;}' unless defined(&IEEE80211_VHTCAP_MAX_MPDU_MASK);
    eval 'sub IEEE80211_VHTCAP_SUPP_CHAN_WIDTH_160MHZ () {0x4;}' unless defined(&IEEE80211_VHTCAP_SUPP_CHAN_WIDTH_160MHZ);
    eval 'sub IEEE80211_VHTCAP_SUPP_CHAN_WIDTH_160_80PLUS80MHZ () {0x8;}' unless defined(&IEEE80211_VHTCAP_SUPP_CHAN_WIDTH_160_80PLUS80MHZ);
    eval 'sub IEEE80211_VHTCAP_SUPP_CHAN_WIDTH_MASK () {0xc;}' unless defined(&IEEE80211_VHTCAP_SUPP_CHAN_WIDTH_MASK);
    eval 'sub IEEE80211_VHTCAP_RXLDPC () {0x10;}' unless defined(&IEEE80211_VHTCAP_RXLDPC);
    eval 'sub IEEE80211_VHTCAP_SHORT_GI_80 () {0x20;}' unless defined(&IEEE80211_VHTCAP_SHORT_GI_80);
    eval 'sub IEEE80211_VHTCAP_SHORT_GI_160 () {0x40;}' unless defined(&IEEE80211_VHTCAP_SHORT_GI_160);
    eval 'sub IEEE80211_VHTCAP_TXSTBC () {0x80;}' unless defined(&IEEE80211_VHTCAP_TXSTBC);
    eval 'sub IEEE80211_VHTCAP_RXSTBC_1 () {0x100;}' unless defined(&IEEE80211_VHTCAP_RXSTBC_1);
    eval 'sub IEEE80211_VHTCAP_RXSTBC_2 () {0x200;}' unless defined(&IEEE80211_VHTCAP_RXSTBC_2);
    eval 'sub IEEE80211_VHTCAP_RXSTBC_3 () {0x300;}' unless defined(&IEEE80211_VHTCAP_RXSTBC_3);
    eval 'sub IEEE80211_VHTCAP_RXSTBC_4 () {0x400;}' unless defined(&IEEE80211_VHTCAP_RXSTBC_4);
    eval 'sub IEEE80211_VHTCAP_RXSTBC_MASK () {0x700;}' unless defined(&IEEE80211_VHTCAP_RXSTBC_MASK);
    eval 'sub IEEE80211_VHTCAP_SU_BEAMFORMER_CAPABLE () {0x800;}' unless defined(&IEEE80211_VHTCAP_SU_BEAMFORMER_CAPABLE);
    eval 'sub IEEE80211_VHTCAP_SU_BEAMFORMEE_CAPABLE () {0x1000;}' unless defined(&IEEE80211_VHTCAP_SU_BEAMFORMEE_CAPABLE);
    eval 'sub IEEE80211_VHTCAP_BEAMFORMEE_STS_SHIFT () {13;}' unless defined(&IEEE80211_VHTCAP_BEAMFORMEE_STS_SHIFT);
    eval 'sub IEEE80211_VHTCAP_BEAMFORMEE_STS_MASK () {(7<<  &IEEE80211_VHTCAP_BEAMFORMEE_STS_SHIFT);}' unless defined(&IEEE80211_VHTCAP_BEAMFORMEE_STS_MASK);
    eval 'sub IEEE80211_VHTCAP_SOUNDING_DIMENSIONS_SHIFT () {16;}' unless defined(&IEEE80211_VHTCAP_SOUNDING_DIMENSIONS_SHIFT);
    eval 'sub IEEE80211_VHTCAP_SOUNDING_DIMENSIONS_MASK () {(7<<  &IEEE80211_VHTCAP_SOUNDING_DIMENSIONS_SHIFT);}' unless defined(&IEEE80211_VHTCAP_SOUNDING_DIMENSIONS_MASK);
    eval 'sub IEEE80211_VHTCAP_MU_BEAMFORMER_CAPABLE () {0x80000;}' unless defined(&IEEE80211_VHTCAP_MU_BEAMFORMER_CAPABLE);
    eval 'sub IEEE80211_VHTCAP_MU_BEAMFORMEE_CAPABLE () {0x100000;}' unless defined(&IEEE80211_VHTCAP_MU_BEAMFORMEE_CAPABLE);
    eval 'sub IEEE80211_VHTCAP_VHT_TXOP_PS () {0x200000;}' unless defined(&IEEE80211_VHTCAP_VHT_TXOP_PS);
    eval 'sub IEEE80211_VHTCAP_HTC_VHT () {0x400000;}' unless defined(&IEEE80211_VHTCAP_HTC_VHT);
    eval 'sub IEEE80211_VHTCAP_MAX_A_MPDU_LENGTH_EXPONENT_SHIFT () {23;}' unless defined(&IEEE80211_VHTCAP_MAX_A_MPDU_LENGTH_EXPONENT_SHIFT);
    eval 'sub IEEE80211_VHTCAP_MAX_A_MPDU_LENGTH_EXPONENT_MASK () {(7<<  &IEEE80211_VHTCAP_MAX_A_MPDU_LENGTH_EXPONENT_SHIFT);}' unless defined(&IEEE80211_VHTCAP_MAX_A_MPDU_LENGTH_EXPONENT_MASK);
    eval 'sub IEEE80211_VHTCAP_VHT_LINK_ADAPTATION_VHT_UNSOL_MFB () {0x8000000;}' unless defined(&IEEE80211_VHTCAP_VHT_LINK_ADAPTATION_VHT_UNSOL_MFB);
    eval 'sub IEEE80211_VHTCAP_VHT_LINK_ADAPTATION_VHT_MRQ_MFB () {0xc000000;}' unless defined(&IEEE80211_VHTCAP_VHT_LINK_ADAPTATION_VHT_MRQ_MFB);
    eval 'sub IEEE80211_VHTCAP_RX_ANTENNA_PATTERN () {0x10000000;}' unless defined(&IEEE80211_VHTCAP_RX_ANTENNA_PATTERN);
    eval 'sub IEEE80211_VHTCAP_TX_ANTENNA_PATTERN () {0x20000000;}' unless defined(&IEEE80211_VHTCAP_TX_ANTENNA_PATTERN);
    eval 'sub IEEE80211_VHT_TXPWRENV_INFO_COUNT_SHIFT () {0;}' unless defined(&IEEE80211_VHT_TXPWRENV_INFO_COUNT_SHIFT);
    eval 'sub IEEE80211_VHT_TXPWRENV_INFO_COUNT_MASK () {0x7;}' unless defined(&IEEE80211_VHT_TXPWRENV_INFO_COUNT_MASK);
    eval 'sub IEEE80211_VHT_TXPWRENV_UNIT_MASK () {0x38;}' unless defined(&IEEE80211_VHT_TXPWRENV_UNIT_MASK);
    eval 'sub IEEE80211_VHT_TXPWRENV_UNIT_SHIFT () {3;}' unless defined(&IEEE80211_VHT_TXPWRENV_UNIT_SHIFT);
    eval 'sub IEEE80211_VHT_TXPWRENV_UNIT_EIRP () {0;}' unless defined(&IEEE80211_VHT_TXPWRENV_UNIT_EIRP);
    eval 'sub WLAN_ACTION_VHT_COMPRESSED_BF () {0;}' unless defined(&WLAN_ACTION_VHT_COMPRESSED_BF);
    eval 'sub WLAN_ACTION_VHT_GROUPID_MGMT () {1;}' unless defined(&WLAN_ACTION_VHT_GROUPID_MGMT);
    eval 'sub WLAN_ACTION_VHT_OPMODE_NOTIF () {2;}' unless defined(&WLAN_ACTION_VHT_OPMODE_NOTIF);
    eval("sub IEEE80211_ELEMID_SSID () { 0; }") unless defined(&IEEE80211_ELEMID_SSID);
    eval("sub IEEE80211_ELEMID_RATES () { 1; }") unless defined(&IEEE80211_ELEMID_RATES);
    eval("sub IEEE80211_ELEMID_FHPARMS () { 2; }") unless defined(&IEEE80211_ELEMID_FHPARMS);
    eval("sub IEEE80211_ELEMID_DSPARMS () { 3; }") unless defined(&IEEE80211_ELEMID_DSPARMS);
    eval("sub IEEE80211_ELEMID_CFPARMS () { 4; }") unless defined(&IEEE80211_ELEMID_CFPARMS);
    eval("sub IEEE80211_ELEMID_TIM () { 5; }") unless defined(&IEEE80211_ELEMID_TIM);
    eval("sub IEEE80211_ELEMID_IBSSPARMS () { 6; }") unless defined(&IEEE80211_ELEMID_IBSSPARMS);
    eval("sub IEEE80211_ELEMID_COUNTRY () { 7; }") unless defined(&IEEE80211_ELEMID_COUNTRY);
    eval("sub IEEE80211_ELEMID_BSSLOAD () { 11; }") unless defined(&IEEE80211_ELEMID_BSSLOAD);
    eval("sub IEEE80211_ELEMID_TSPEC () { 13; }") unless defined(&IEEE80211_ELEMID_TSPEC);
    eval("sub IEEE80211_ELEMID_TCLAS () { 14; }") unless defined(&IEEE80211_ELEMID_TCLAS);
    eval("sub IEEE80211_ELEMID_CHALLENGE () { 16; }") unless defined(&IEEE80211_ELEMID_CHALLENGE);
    eval("sub IEEE80211_ELEMID_PWRCNSTR () { 32; }") unless defined(&IEEE80211_ELEMID_PWRCNSTR);
    eval("sub IEEE80211_ELEMID_PWRCAP () { 33; }") unless defined(&IEEE80211_ELEMID_PWRCAP);
    eval("sub IEEE80211_ELEMID_TPCREQ () { 34; }") unless defined(&IEEE80211_ELEMID_TPCREQ);
    eval("sub IEEE80211_ELEMID_TPCREP () { 35; }") unless defined(&IEEE80211_ELEMID_TPCREP);
    eval("sub IEEE80211_ELEMID_SUPPCHAN () { 36; }") unless defined(&IEEE80211_ELEMID_SUPPCHAN);
    eval("sub IEEE80211_ELEMID_CSA () { 37; }") unless defined(&IEEE80211_ELEMID_CSA);
    eval("sub IEEE80211_ELEMID_MEASREQ () { 38; }") unless defined(&IEEE80211_ELEMID_MEASREQ);
    eval("sub IEEE80211_ELEMID_MEASREP () { 39; }") unless defined(&IEEE80211_ELEMID_MEASREP);
    eval("sub IEEE80211_ELEMID_QUIET () { 40; }") unless defined(&IEEE80211_ELEMID_QUIET);
    eval("sub IEEE80211_ELEMID_IBSSDFS () { 41; }") unless defined(&IEEE80211_ELEMID_IBSSDFS);
    eval("sub IEEE80211_ELEMID_ERP () { 42; }") unless defined(&IEEE80211_ELEMID_ERP);
    eval("sub IEEE80211_ELEMID_HTCAP () { 45; }") unless defined(&IEEE80211_ELEMID_HTCAP);
    eval("sub IEEE80211_ELEMID_QOS () { 46; }") unless defined(&IEEE80211_ELEMID_QOS);
    eval("sub IEEE80211_ELEMID_RSN () { 48; }") unless defined(&IEEE80211_ELEMID_RSN);
    eval("sub IEEE80211_ELEMID_XRATES () { 50; }") unless defined(&IEEE80211_ELEMID_XRATES);
    eval("sub IEEE80211_ELEMID_APCHANREP () { 51; }") unless defined(&IEEE80211_ELEMID_APCHANREP);
    eval("sub IEEE80211_ELEMID_HTINFO () { 61; }") unless defined(&IEEE80211_ELEMID_HTINFO);
    eval("sub IEEE80211_ELEMID_SECCHAN_OFFSET () { 62; }") unless defined(&IEEE80211_ELEMID_SECCHAN_OFFSET);
    eval("sub IEEE80211_ELEMID_RRM_ENACAPS () { 70; }") unless defined(&IEEE80211_ELEMID_RRM_ENACAPS);
    eval("sub IEEE80211_ELEMID_MULTIBSSID () { 71; }") unless defined(&IEEE80211_ELEMID_MULTIBSSID);
    eval("sub IEEE80211_ELEMID_COEX_2040 () { 72; }") unless defined(&IEEE80211_ELEMID_COEX_2040);
    eval("sub IEEE80211_ELEMID_INTOL_CHN_REPORT () { 73; }") unless defined(&IEEE80211_ELEMID_INTOL_CHN_REPORT);
    eval("sub IEEE80211_ELEMID_OVERLAP_BSS_SCAN_PARAM () { 74; }") unless defined(&IEEE80211_ELEMID_OVERLAP_BSS_SCAN_PARAM);
    eval("sub IEEE80211_ELEMID_TSF_REQ () { 91; }") unless defined(&IEEE80211_ELEMID_TSF_REQ);
    eval("sub IEEE80211_ELEMID_TSF_RESP () { 92; }") unless defined(&IEEE80211_ELEMID_TSF_RESP);
    eval("sub IEEE80211_ELEMID_WNM_SLEEP_MODE () { 93; }") unless defined(&IEEE80211_ELEMID_WNM_SLEEP_MODE);
    eval("sub IEEE80211_ELEMID_TIM_BCAST_REQ () { 94; }") unless defined(&IEEE80211_ELEMID_TIM_BCAST_REQ);
    eval("sub IEEE80211_ELEMID_TIM_BCAST_RESP () { 95; }") unless defined(&IEEE80211_ELEMID_TIM_BCAST_RESP);
    eval("sub IEEE80211_ELEMID_TPC () { 150; }") unless defined(&IEEE80211_ELEMID_TPC);
    eval("sub IEEE80211_ELEMID_CCKM () { 156; }") unless defined(&IEEE80211_ELEMID_CCKM);
    eval("sub IEEE80211_ELEMID_VENDOR () { 221; }") unless defined(&IEEE80211_ELEMID_VENDOR);
    eval("sub IEEE80211_ELEMID_MESHCONF () { 113; }") unless defined(&IEEE80211_ELEMID_MESHCONF);
    eval("sub IEEE80211_ELEMID_MESHID () { 114; }") unless defined(&IEEE80211_ELEMID_MESHID);
    eval("sub IEEE80211_ELEMID_MESHLINK () { 115; }") unless defined(&IEEE80211_ELEMID_MESHLINK);
    eval("sub IEEE80211_ELEMID_MESHCNGST () { 116; }") unless defined(&IEEE80211_ELEMID_MESHCNGST);
    eval("sub IEEE80211_ELEMID_MESHPEER () { 117; }") unless defined(&IEEE80211_ELEMID_MESHPEER);
    eval("sub IEEE80211_ELEMID_MESHCSA () { 118; }") unless defined(&IEEE80211_ELEMID_MESHCSA);
    eval("sub IEEE80211_ELEMID_MESHTIM () { 39; }") unless defined(&IEEE80211_ELEMID_MESHTIM);
    eval("sub IEEE80211_ELEMID_MESHAWAKEW () { 119; }") unless defined(&IEEE80211_ELEMID_MESHAWAKEW);
    eval("sub IEEE80211_ELEMID_MESHBEACONT () { 120; }") unless defined(&IEEE80211_ELEMID_MESHBEACONT);
    eval("sub IEEE80211_ELEMID_MESHGANN () { 125; }") unless defined(&IEEE80211_ELEMID_MESHGANN);
    eval("sub IEEE80211_ELEMID_MESHRANN () { 126; }") unless defined(&IEEE80211_ELEMID_MESHRANN);
    eval("sub IEEE80211_ELEMID_EXTCAP () { 127; }") unless defined(&IEEE80211_ELEMID_EXTCAP);
    eval("sub IEEE80211_ELEMID_MESHPREQ () { 130; }") unless defined(&IEEE80211_ELEMID_MESHPREQ);
    eval("sub IEEE80211_ELEMID_MESHPREP () { 131; }") unless defined(&IEEE80211_ELEMID_MESHPREP);
    eval("sub IEEE80211_ELEMID_MESHPERR () { 132; }") unless defined(&IEEE80211_ELEMID_MESHPERR);
    eval("sub IEEE80211_ELEMID_MESHPXU () { 137; }") unless defined(&IEEE80211_ELEMID_MESHPXU);
    eval("sub IEEE80211_ELEMID_MESHPXUC () { 138; }") unless defined(&IEEE80211_ELEMID_MESHPXUC);
    eval("sub IEEE80211_ELEMID_MESHAH () { 60; }") unless defined(&IEEE80211_ELEMID_MESHAH);
    eval("sub IEEE80211_ELEMID_VHT_CAP () { 191; }") unless defined(&IEEE80211_ELEMID_VHT_CAP);
    eval("sub IEEE80211_ELEMID_VHT_OPMODE () { 192; }") unless defined(&IEEE80211_ELEMID_VHT_OPMODE);
    eval("sub IEEE80211_ELEMID_VHT_PWR_ENV () { 195; }") unless defined(&IEEE80211_ELEMID_VHT_PWR_ENV);
    eval 'sub IEEE80211_COUNTRY_MAX_BANDS () {84;}' unless defined(&IEEE80211_COUNTRY_MAX_BANDS);
    eval 'sub IEEE80211_COUNTRY_MAX_SIZE () {($sizeof{\'struct ieee80211_country_ie\'} + 3*( &IEEE80211_COUNTRY_MAX_BANDS-1));}' unless defined(&IEEE80211_COUNTRY_MAX_SIZE);
    eval 'sub IEEE80211_EXTCAP_CMS () {(1 << 0);}' unless defined(&IEEE80211_EXTCAP_CMS);
    eval 'sub IEEE80211_EXTCAP_RSVD_1 () {(1 << 1);}' unless defined(&IEEE80211_EXTCAP_RSVD_1);
    eval 'sub IEEE80211_EXTCAP_ECS () {(1 << 2);}' unless defined(&IEEE80211_EXTCAP_ECS);
    eval 'sub IEEE80211_EXTCAP_RSVD_3 () {(1 << 3);}' unless defined(&IEEE80211_EXTCAP_RSVD_3);
    eval 'sub IEEE80211_EXTCAP_PSMP_CAP () {(1 << 4);}' unless defined(&IEEE80211_EXTCAP_PSMP_CAP);
    eval 'sub IEEE80211_EXTCAP_RSVD_5 () {(1 << 5);}' unless defined(&IEEE80211_EXTCAP_RSVD_5);
    eval 'sub IEEE80211_EXTCAP_S_PSMP_SUPP () {(1 << 6);}' unless defined(&IEEE80211_EXTCAP_S_PSMP_SUPP);
    eval 'sub IEEE80211_EXTCAP_EVENT () {(1 << 7);}' unless defined(&IEEE80211_EXTCAP_EVENT);
    eval 'sub IEEE80211_EXTCAP_DIAGNOSTICS () {(1 << 8);}' unless defined(&IEEE80211_EXTCAP_DIAGNOSTICS);
    eval 'sub IEEE80211_EXTCAP_MCAST_DIAG () {(1 << 9);}' unless defined(&IEEE80211_EXTCAP_MCAST_DIAG);
    eval 'sub IEEE80211_EXTCAP_LOC_TRACKING () {(1 << 10);}' unless defined(&IEEE80211_EXTCAP_LOC_TRACKING);
    eval 'sub IEEE80211_EXTCAP_FMS () {(1 << 11);}' unless defined(&IEEE80211_EXTCAP_FMS);
    eval 'sub IEEE80211_EXTCAP_PROXY_ARP () {(1 << 12);}' unless defined(&IEEE80211_EXTCAP_PROXY_ARP);
    eval 'sub IEEE80211_EXTCAP_CIR () {(1 << 13);}' unless defined(&IEEE80211_EXTCAP_CIR);
    eval 'sub IEEE80211_EXTCAP_CIVIC_LOC () {(1 << 14);}' unless defined(&IEEE80211_EXTCAP_CIVIC_LOC);
    eval 'sub IEEE80211_EXTCAP_GEOSPATIAL_LOC () {(1 << 15);}' unless defined(&IEEE80211_EXTCAP_GEOSPATIAL_LOC);
    eval 'sub IEEE80211_EXTCAP_TFS () {(1 << 16);}' unless defined(&IEEE80211_EXTCAP_TFS);
    eval 'sub IEEE80211_EXTCAP_WNM_SLEEPMODE () {(1 << 17);}' unless defined(&IEEE80211_EXTCAP_WNM_SLEEPMODE);
    eval 'sub IEEE80211_EXTCAP_TIM_BROADCAST () {(1 << 18);}' unless defined(&IEEE80211_EXTCAP_TIM_BROADCAST);
    eval 'sub IEEE80211_EXTCAP_BSS_TRANSITION () {(1 << 19);}' unless defined(&IEEE80211_EXTCAP_BSS_TRANSITION);
    eval 'sub IEEE80211_EXTCAP_QOS_TRAF_CAP () {(1 << 20);}' unless defined(&IEEE80211_EXTCAP_QOS_TRAF_CAP);
    eval 'sub IEEE80211_EXTCAP_AC_STA_COUNT () {(1 << 21);}' unless defined(&IEEE80211_EXTCAP_AC_STA_COUNT);
    eval 'sub IEEE80211_EXTCAP_M_BSSID () {(1 << 22);}' unless defined(&IEEE80211_EXTCAP_M_BSSID);
    eval 'sub IEEE80211_EXTCAP_TIMING_MEAS () {(1 << 23);}' unless defined(&IEEE80211_EXTCAP_TIMING_MEAS);
    eval 'sub IEEE80211_EXTCAP_CHAN_USAGE () {(1 << 24);}' unless defined(&IEEE80211_EXTCAP_CHAN_USAGE);
    eval 'sub IEEE80211_EXTCAP_SSID_LIST () {(1 << 25);}' unless defined(&IEEE80211_EXTCAP_SSID_LIST);
    eval 'sub IEEE80211_EXTCAP_DMS () {(1 << 26);}' unless defined(&IEEE80211_EXTCAP_DMS);
    eval 'sub IEEE80211_EXTCAP_UTC_TSF_OFFSET () {(1 << 27);}' unless defined(&IEEE80211_EXTCAP_UTC_TSF_OFFSET);
    eval 'sub IEEE80211_EXTCAP_TLDS_BUF_STA_SUPP () {(1 << 28);}' unless defined(&IEEE80211_EXTCAP_TLDS_BUF_STA_SUPP);
    eval 'sub IEEE80211_EXTCAP_TLDS_PPSM_SUPP () {(1 << 29);}' unless defined(&IEEE80211_EXTCAP_TLDS_PPSM_SUPP);
    eval 'sub IEEE80211_EXTCAP_TLDS_CH_SW () {(1 << 30);}' unless defined(&IEEE80211_EXTCAP_TLDS_CH_SW);
    eval 'sub IEEE80211_EXTCAP_INTERWORKING () {(1 << 31);}' unless defined(&IEEE80211_EXTCAP_INTERWORKING);
    eval 'sub IEEE80211_EXTCAP_QOSMAP () {(1 << 32);}' unless defined(&IEEE80211_EXTCAP_QOSMAP);
    eval 'sub IEEE80211_EXTCAP_EBR () {(1 << 33);}' unless defined(&IEEE80211_EXTCAP_EBR);
    eval 'sub IEEE80211_EXTCAP_SSPN_IF () {(1 << 34);}' unless defined(&IEEE80211_EXTCAP_SSPN_IF);
    eval 'sub IEEE80211_EXTCAP_RSVD_35 () {(1 << 35);}' unless defined(&IEEE80211_EXTCAP_RSVD_35);
    eval 'sub IEEE80211_EXTCAP_MSGCF_CAP () {(1 << 36);}' unless defined(&IEEE80211_EXTCAP_MSGCF_CAP);
    eval 'sub IEEE80211_EXTCAP_TLDS_SUPP () {(1 << 37);}' unless defined(&IEEE80211_EXTCAP_TLDS_SUPP);
    eval 'sub IEEE80211_EXTCAP_TLDS_PROHIB () {(1 << 38);}' unless defined(&IEEE80211_EXTCAP_TLDS_PROHIB);
    eval 'sub IEEE80211_EXTCAP_TLDS_CH_SW_PROHIB () {(1 << 39);}' unless defined(&IEEE80211_EXTCAP_TLDS_CH_SW_PROHIB);
    eval 'sub IEEE80211_EXTCAP_RUF () {(1 << 40);}' unless defined(&IEEE80211_EXTCAP_RUF);
    eval 'sub IEEE80211_EXTCAP_SIG () {((1 << 41) | (1 << 42) | (1 << 43));}' unless defined(&IEEE80211_EXTCAP_SIG);
    eval 'sub IEEE80211_EXTCAP_ID_LOC () {(1 << 44);}' unless defined(&IEEE80211_EXTCAP_ID_LOC);
    eval 'sub IEEE80211_EXTCAP_U_APSD_COEX () {(1 << 45);}' unless defined(&IEEE80211_EXTCAP_U_APSD_COEX);
    eval 'sub IEEE80211_EXTCAP_WNM_NOTIFICATION () {(1 << 46);}' unless defined(&IEEE80211_EXTCAP_WNM_NOTIFICATION);
    eval 'sub IEEE80211_EXTCAP_RSVD_47 () {(1 << 47);}' unless defined(&IEEE80211_EXTCAP_RSVD_47);
    eval 'sub IEEE80211_EXTCAP_SSID () {(1 << 48);}' unless defined(&IEEE80211_EXTCAP_SSID);
    eval 'sub IEEE80211_CSA_COUNT_MIN () {2;}' unless defined(&IEEE80211_CSA_COUNT_MIN);
    eval 'sub IEEE80211_CSA_COUNT_MAX () {255;}' unless defined(&IEEE80211_CSA_COUNT_MAX);
    eval 'sub IEEE80211_RATE_BASIC () {0x80;}' unless defined(&IEEE80211_RATE_BASIC);
    eval 'sub IEEE80211_RATE_VAL () {0x7f;}' unless defined(&IEEE80211_RATE_VAL);
    eval 'sub IEEE80211_RV {
        my($v) = @_;
	    eval q((($v) &  &IEEE80211_RATE_VAL));
    }' unless defined(&IEEE80211_RV);
    eval 'sub IEEE80211_ERP_NON_ERP_PRESENT () {0x1;}' unless defined(&IEEE80211_ERP_NON_ERP_PRESENT);
    eval 'sub IEEE80211_ERP_USE_PROTECTION () {0x2;}' unless defined(&IEEE80211_ERP_USE_PROTECTION);
    eval 'sub IEEE80211_ERP_LONG_PREAMBLE () {0x4;}' unless defined(&IEEE80211_ERP_LONG_PREAMBLE);
    eval 'sub IEEE80211_ERP_BITS () {"\\20\\1NON_ERP_PRESENT\\2USE_PROTECTION\\3LONG_PREAMBLE";}' unless defined(&IEEE80211_ERP_BITS);
    eval 'sub ATH_OUI () {0x7f0300;}' unless defined(&ATH_OUI);
    eval 'sub ATH_OUI_TYPE () {0x1;}' unless defined(&ATH_OUI_TYPE);
    eval 'sub TDMA_OUI () { &ATH_OUI;}' unless defined(&TDMA_OUI);
    eval 'sub TDMA_OUI_TYPE () {0x2;}' unless defined(&TDMA_OUI_TYPE);
    eval 'sub BCM_OUI () {0x4c9000;}' unless defined(&BCM_OUI);
    eval 'sub BCM_OUI_HTCAP () {51;}' unless defined(&BCM_OUI_HTCAP);
    eval 'sub BCM_OUI_HTINFO () {52;}' unless defined(&BCM_OUI_HTINFO);
    eval 'sub WPA_OUI () {0xf25000;}' unless defined(&WPA_OUI);
    eval 'sub WPA_OUI_TYPE () {0x1;}' unless defined(&WPA_OUI_TYPE);
    eval 'sub WPA_VERSION () {1;}' unless defined(&WPA_VERSION);
    eval 'sub WPA_CSE_NULL () {0x;}' unless defined(&WPA_CSE_NULL);
    eval 'sub WPA_CSE_WEP40 () {0x1;}' unless defined(&WPA_CSE_WEP40);
    eval 'sub WPA_CSE_TKIP () {0x2;}' unless defined(&WPA_CSE_TKIP);
    eval 'sub WPA_CSE_CCMP () {0x4;}' unless defined(&WPA_CSE_CCMP);
    eval 'sub WPA_CSE_WEP104 () {0x5;}' unless defined(&WPA_CSE_WEP104);
    eval 'sub WPA_ASE_NONE () {0x;}' unless defined(&WPA_ASE_NONE);
    eval 'sub WPA_ASE_8021X_UNSPEC () {0x1;}' unless defined(&WPA_ASE_8021X_UNSPEC);
    eval 'sub WPA_ASE_8021X_PSK () {0x2;}' unless defined(&WPA_ASE_8021X_PSK);
    eval 'sub WPS_OUI_TYPE () {0x4;}' unless defined(&WPS_OUI_TYPE);
    eval 'sub RSN_OUI () {0xac0f00;}' unless defined(&RSN_OUI);
    eval 'sub RSN_VERSION () {1;}' unless defined(&RSN_VERSION);
    eval 'sub RSN_CSE_NULL () {0x;}' unless defined(&RSN_CSE_NULL);
    eval 'sub RSN_CSE_WEP40 () {0x1;}' unless defined(&RSN_CSE_WEP40);
    eval 'sub RSN_CSE_TKIP () {0x2;}' unless defined(&RSN_CSE_TKIP);
    eval 'sub RSN_CSE_WRAP () {0x3;}' unless defined(&RSN_CSE_WRAP);
    eval 'sub RSN_CSE_CCMP () {0x4;}' unless defined(&RSN_CSE_CCMP);
    eval 'sub RSN_CSE_WEP104 () {0x5;}' unless defined(&RSN_CSE_WEP104);
    eval 'sub RSN_ASE_NONE () {0x;}' unless defined(&RSN_ASE_NONE);
    eval 'sub RSN_ASE_8021X_UNSPEC () {0x1;}' unless defined(&RSN_ASE_8021X_UNSPEC);
    eval 'sub RSN_ASE_8021X_PSK () {0x2;}' unless defined(&RSN_ASE_8021X_PSK);
    eval 'sub RSN_CAP_PREAUTH () {0x1;}' unless defined(&RSN_CAP_PREAUTH);
    eval 'sub WME_OUI () {0xf25000;}' unless defined(&WME_OUI);
    eval 'sub WME_OUI_TYPE () {0x2;}' unless defined(&WME_OUI_TYPE);
    eval 'sub WME_INFO_OUI_SUBTYPE () {0x;}' unless defined(&WME_INFO_OUI_SUBTYPE);
    eval 'sub WME_PARAM_OUI_SUBTYPE () {0x1;}' unless defined(&WME_PARAM_OUI_SUBTYPE);
    eval 'sub WME_VERSION () {1;}' unless defined(&WME_VERSION);
    eval 'sub WME_AC_BE () {0;}' unless defined(&WME_AC_BE);
    eval 'sub WME_AC_BK () {1;}' unless defined(&WME_AC_BK);
    eval 'sub WME_AC_VI () {2;}' unless defined(&WME_AC_VI);
    eval 'sub WME_AC_VO () {3;}' unless defined(&WME_AC_VO);
    eval 'sub IEEE80211_CHALLENGE_LEN () {128;}' unless defined(&IEEE80211_CHALLENGE_LEN);
    eval 'sub IEEE80211_AUTH_ALG_OPEN () {0x;}' unless defined(&IEEE80211_AUTH_ALG_OPEN);
    eval 'sub IEEE80211_AUTH_ALG_SHARED () {0x1;}' unless defined(&IEEE80211_AUTH_ALG_SHARED);
    eval 'sub IEEE80211_AUTH_ALG_LEAP () {0x80;}' unless defined(&IEEE80211_AUTH_ALG_LEAP);
    eval("sub IEEE80211_AUTH_OPEN_REQUEST () { 1; }") unless defined(&IEEE80211_AUTH_OPEN_REQUEST);
    eval("sub IEEE80211_AUTH_OPEN_RESPONSE () { 2; }") unless defined(&IEEE80211_AUTH_OPEN_RESPONSE);
    eval("sub IEEE80211_AUTH_SHARED_REQUEST () { 1; }") unless defined(&IEEE80211_AUTH_SHARED_REQUEST);
    eval("sub IEEE80211_AUTH_SHARED_CHALLENGE () { 2; }") unless defined(&IEEE80211_AUTH_SHARED_CHALLENGE);
    eval("sub IEEE80211_AUTH_SHARED_RESPONSE () { 3; }") unless defined(&IEEE80211_AUTH_SHARED_RESPONSE);
    eval("sub IEEE80211_AUTH_SHARED_PASS () { 4; }") unless defined(&IEEE80211_AUTH_SHARED_PASS);
    eval("sub IEEE80211_REASON_UNSPECIFIED () { 1; }") unless defined(&IEEE80211_REASON_UNSPECIFIED);
    eval("sub IEEE80211_REASON_AUTH_EXPIRE () { 2; }") unless defined(&IEEE80211_REASON_AUTH_EXPIRE);
    eval("sub IEEE80211_REASON_AUTH_LEAVE () { 3; }") unless defined(&IEEE80211_REASON_AUTH_LEAVE);
    eval("sub IEEE80211_REASON_ASSOC_EXPIRE () { 4; }") unless defined(&IEEE80211_REASON_ASSOC_EXPIRE);
    eval("sub IEEE80211_REASON_ASSOC_TOOMANY () { 5; }") unless defined(&IEEE80211_REASON_ASSOC_TOOMANY);
    eval("sub IEEE80211_REASON_NOT_AUTHED () { 6; }") unless defined(&IEEE80211_REASON_NOT_AUTHED);
    eval("sub IEEE80211_REASON_NOT_ASSOCED () { 7; }") unless defined(&IEEE80211_REASON_NOT_ASSOCED);
    eval("sub IEEE80211_REASON_ASSOC_LEAVE () { 8; }") unless defined(&IEEE80211_REASON_ASSOC_LEAVE);
    eval("sub IEEE80211_REASON_ASSOC_NOT_AUTHED () { 9; }") unless defined(&IEEE80211_REASON_ASSOC_NOT_AUTHED);
    eval("sub IEEE80211_REASON_DISASSOC_PWRCAP_BAD () { 10; }") unless defined(&IEEE80211_REASON_DISASSOC_PWRCAP_BAD);
    eval("sub IEEE80211_REASON_DISASSOC_SUPCHAN_BAD () { 11; }") unless defined(&IEEE80211_REASON_DISASSOC_SUPCHAN_BAD);
    eval("sub IEEE80211_REASON_IE_INVALID () { 13; }") unless defined(&IEEE80211_REASON_IE_INVALID);
    eval("sub IEEE80211_REASON_MIC_FAILURE () { 14; }") unless defined(&IEEE80211_REASON_MIC_FAILURE);
    eval("sub IEEE80211_REASON_4WAY_HANDSHAKE_TIMEOUT () { 15; }") unless defined(&IEEE80211_REASON_4WAY_HANDSHAKE_TIMEOUT);
    eval("sub IEEE80211_REASON_GROUP_KEY_UPDATE_TIMEOUT () { 16; }") unless defined(&IEEE80211_REASON_GROUP_KEY_UPDATE_TIMEOUT);
    eval("sub IEEE80211_REASON_IE_IN_4WAY_DIFFERS () { 17; }") unless defined(&IEEE80211_REASON_IE_IN_4WAY_DIFFERS);
    eval("sub IEEE80211_REASON_GROUP_CIPHER_INVALID () { 18; }") unless defined(&IEEE80211_REASON_GROUP_CIPHER_INVALID);
    eval("sub IEEE80211_REASON_PAIRWISE_CIPHER_INVALID () { 19; }") unless defined(&IEEE80211_REASON_PAIRWISE_CIPHER_INVALID);
    eval("sub IEEE80211_REASON_AKMP_INVALID () { 20; }") unless defined(&IEEE80211_REASON_AKMP_INVALID);
    eval("sub IEEE80211_REASON_UNSUPP_RSN_IE_VERSION () { 21; }") unless defined(&IEEE80211_REASON_UNSUPP_RSN_IE_VERSION);
    eval("sub IEEE80211_REASON_INVALID_RSN_IE_CAP () { 22; }") unless defined(&IEEE80211_REASON_INVALID_RSN_IE_CAP);
    eval("sub IEEE80211_REASON_802_1X_AUTH_FAILED () { 23; }") unless defined(&IEEE80211_REASON_802_1X_AUTH_FAILED);
    eval("sub IEEE80211_REASON_CIPHER_SUITE_REJECTED () { 24; }") unless defined(&IEEE80211_REASON_CIPHER_SUITE_REJECTED);
    eval("sub IEEE80211_REASON_UNSPECIFIED_QOS () { 32; }") unless defined(&IEEE80211_REASON_UNSPECIFIED_QOS);
    eval("sub IEEE80211_REASON_INSUFFICIENT_BW () { 33; }") unless defined(&IEEE80211_REASON_INSUFFICIENT_BW);
    eval("sub IEEE80211_REASON_TOOMANY_FRAMES () { 34; }") unless defined(&IEEE80211_REASON_TOOMANY_FRAMES);
    eval("sub IEEE80211_REASON_OUTSIDE_TXOP () { 35; }") unless defined(&IEEE80211_REASON_OUTSIDE_TXOP);
    eval("sub IEEE80211_REASON_LEAVING_QBSS () { 36; }") unless defined(&IEEE80211_REASON_LEAVING_QBSS);
    eval("sub IEEE80211_REASON_BAD_MECHANISM () { 37; }") unless defined(&IEEE80211_REASON_BAD_MECHANISM);
    eval("sub IEEE80211_REASON_SETUP_NEEDED () { 38; }") unless defined(&IEEE80211_REASON_SETUP_NEEDED);
    eval("sub IEEE80211_REASON_TIMEOUT () { 39; }") unless defined(&IEEE80211_REASON_TIMEOUT);
    eval("sub IEEE80211_REASON_PEER_LINK_CANCELED () { 52; }") unless defined(&IEEE80211_REASON_PEER_LINK_CANCELED);
    eval("sub IEEE80211_REASON_MESH_MAX_PEERS () { 53; }") unless defined(&IEEE80211_REASON_MESH_MAX_PEERS);
    eval("sub IEEE80211_REASON_MESH_CPVIOLATION () { 54; }") unless defined(&IEEE80211_REASON_MESH_CPVIOLATION);
    eval("sub IEEE80211_REASON_MESH_CLOSE_RCVD () { 55; }") unless defined(&IEEE80211_REASON_MESH_CLOSE_RCVD);
    eval("sub IEEE80211_REASON_MESH_MAX_RETRIES () { 56; }") unless defined(&IEEE80211_REASON_MESH_MAX_RETRIES);
    eval("sub IEEE80211_REASON_MESH_CONFIRM_TIMEOUT () { 57; }") unless defined(&IEEE80211_REASON_MESH_CONFIRM_TIMEOUT);
    eval("sub IEEE80211_REASON_MESH_INVALID_GTK () { 58; }") unless defined(&IEEE80211_REASON_MESH_INVALID_GTK);
    eval("sub IEEE80211_REASON_MESH_INCONS_PARAMS () { 59; }") unless defined(&IEEE80211_REASON_MESH_INCONS_PARAMS);
    eval("sub IEEE80211_REASON_MESH_INVALID_SECURITY () { 60; }") unless defined(&IEEE80211_REASON_MESH_INVALID_SECURITY);
    eval("sub IEEE80211_REASON_MESH_PERR_NO_PROXY () { 61; }") unless defined(&IEEE80211_REASON_MESH_PERR_NO_PROXY);
    eval("sub IEEE80211_REASON_MESH_PERR_NO_FI () { 62; }") unless defined(&IEEE80211_REASON_MESH_PERR_NO_FI);
    eval("sub IEEE80211_REASON_MESH_PERR_DEST_UNREACH () { 63; }") unless defined(&IEEE80211_REASON_MESH_PERR_DEST_UNREACH);
    eval("sub IEEE80211_REASON_MESH_MAC_ALRDY_EXISTS_MBSS () { 64; }") unless defined(&IEEE80211_REASON_MESH_MAC_ALRDY_EXISTS_MBSS);
    eval("sub IEEE80211_REASON_MESH_CHAN_SWITCH_REG () { 65; }") unless defined(&IEEE80211_REASON_MESH_CHAN_SWITCH_REG);
    eval("sub IEEE80211_REASON_MESH_CHAN_SWITCH_UNSPEC () { 66; }") unless defined(&IEEE80211_REASON_MESH_CHAN_SWITCH_UNSPEC);
    eval("sub IEEE80211_STATUS_SUCCESS () { 0; }") unless defined(&IEEE80211_STATUS_SUCCESS);
    eval("sub IEEE80211_STATUS_UNSPECIFIED () { 1; }") unless defined(&IEEE80211_STATUS_UNSPECIFIED);
    eval("sub IEEE80211_STATUS_CAPINFO () { 10; }") unless defined(&IEEE80211_STATUS_CAPINFO);
    eval("sub IEEE80211_STATUS_NOT_ASSOCED () { 11; }") unless defined(&IEEE80211_STATUS_NOT_ASSOCED);
    eval("sub IEEE80211_STATUS_OTHER () { 12; }") unless defined(&IEEE80211_STATUS_OTHER);
    eval("sub IEEE80211_STATUS_ALG () { 13; }") unless defined(&IEEE80211_STATUS_ALG);
    eval("sub IEEE80211_STATUS_SEQUENCE () { 14; }") unless defined(&IEEE80211_STATUS_SEQUENCE);
    eval("sub IEEE80211_STATUS_CHALLENGE () { 15; }") unless defined(&IEEE80211_STATUS_CHALLENGE);
    eval("sub IEEE80211_STATUS_TIMEOUT () { 16; }") unless defined(&IEEE80211_STATUS_TIMEOUT);
    eval("sub IEEE80211_STATUS_TOOMANY () { 17; }") unless defined(&IEEE80211_STATUS_TOOMANY);
    eval("sub IEEE80211_STATUS_BASIC_RATE () { 18; }") unless defined(&IEEE80211_STATUS_BASIC_RATE);
    eval("sub IEEE80211_STATUS_SP_REQUIRED () { 19; }") unless defined(&IEEE80211_STATUS_SP_REQUIRED);
    eval("sub IEEE80211_STATUS_PBCC_REQUIRED () { 20; }") unless defined(&IEEE80211_STATUS_PBCC_REQUIRED);
    eval("sub IEEE80211_STATUS_CA_REQUIRED () { 21; }") unless defined(&IEEE80211_STATUS_CA_REQUIRED);
    eval("sub IEEE80211_STATUS_SPECMGMT_REQUIRED () { 22; }") unless defined(&IEEE80211_STATUS_SPECMGMT_REQUIRED);
    eval("sub IEEE80211_STATUS_PWRCAP_REQUIRED () { 23; }") unless defined(&IEEE80211_STATUS_PWRCAP_REQUIRED);
    eval("sub IEEE80211_STATUS_SUPCHAN_REQUIRED () { 24; }") unless defined(&IEEE80211_STATUS_SUPCHAN_REQUIRED);
    eval("sub IEEE80211_STATUS_SHORTSLOT_REQUIRED () { 25; }") unless defined(&IEEE80211_STATUS_SHORTSLOT_REQUIRED);
    eval("sub IEEE80211_STATUS_DSSSOFDM_REQUIRED () { 26; }") unless defined(&IEEE80211_STATUS_DSSSOFDM_REQUIRED);
    eval("sub IEEE80211_STATUS_MISSING_HT_CAPS () { 27; }") unless defined(&IEEE80211_STATUS_MISSING_HT_CAPS);
    eval("sub IEEE80211_STATUS_INVALID_IE () { 40; }") unless defined(&IEEE80211_STATUS_INVALID_IE);
    eval("sub IEEE80211_STATUS_GROUP_CIPHER_INVALID () { 41; }") unless defined(&IEEE80211_STATUS_GROUP_CIPHER_INVALID);
    eval("sub IEEE80211_STATUS_PAIRWISE_CIPHER_INVALID () { 42; }") unless defined(&IEEE80211_STATUS_PAIRWISE_CIPHER_INVALID);
    eval("sub IEEE80211_STATUS_AKMP_INVALID () { 43; }") unless defined(&IEEE80211_STATUS_AKMP_INVALID);
    eval("sub IEEE80211_STATUS_UNSUPP_RSN_IE_VERSION () { 44; }") unless defined(&IEEE80211_STATUS_UNSUPP_RSN_IE_VERSION);
    eval("sub IEEE80211_STATUS_INVALID_RSN_IE_CAP () { 45; }") unless defined(&IEEE80211_STATUS_INVALID_RSN_IE_CAP);
    eval("sub IEEE80211_STATUS_CIPHER_SUITE_REJECTED () { 46; }") unless defined(&IEEE80211_STATUS_CIPHER_SUITE_REJECTED);
    eval 'sub IEEE80211_WEP_KEYLEN () {5;}' unless defined(&IEEE80211_WEP_KEYLEN);
    eval 'sub IEEE80211_WEP_IVLEN () {3;}' unless defined(&IEEE80211_WEP_IVLEN);
    eval 'sub IEEE80211_WEP_KIDLEN () {1;}' unless defined(&IEEE80211_WEP_KIDLEN);
    eval 'sub IEEE80211_WEP_CRCLEN () {4;}' unless defined(&IEEE80211_WEP_CRCLEN);
    eval 'sub IEEE80211_WEP_TOTLEN () {( &IEEE80211_WEP_IVLEN +  &IEEE80211_WEP_KIDLEN +  &IEEE80211_WEP_CRCLEN);}' unless defined(&IEEE80211_WEP_TOTLEN);
    eval 'sub IEEE80211_WEP_NKID () {4;}' unless defined(&IEEE80211_WEP_NKID);
    eval 'sub IEEE80211_WEP_EXTIV () {0x20;}' unless defined(&IEEE80211_WEP_EXTIV);
    eval 'sub IEEE80211_WEP_EXTIVLEN () {4;}' unless defined(&IEEE80211_WEP_EXTIVLEN);
    eval 'sub IEEE80211_WEP_MICLEN () {8;}' unless defined(&IEEE80211_WEP_MICLEN);
    eval 'sub IEEE80211_CRC_LEN () {4;}' unless defined(&IEEE80211_CRC_LEN);
    eval 'sub IEEE80211_MTU_MAX () {2290;}' unless defined(&IEEE80211_MTU_MAX);
    eval 'sub IEEE80211_MTU_MIN () {32;}' unless defined(&IEEE80211_MTU_MIN);
    eval 'sub IEEE80211_MAX_LEN () {(2300+  &IEEE80211_CRC_LEN + ( &IEEE80211_WEP_IVLEN +  &IEEE80211_WEP_KIDLEN +  &IEEE80211_WEP_CRCLEN));}' unless defined(&IEEE80211_MAX_LEN);
    eval 'sub IEEE80211_ACK_LEN () {($sizeof{\'struct ieee80211_frame_ack\'} +  &IEEE80211_CRC_LEN);}' unless defined(&IEEE80211_ACK_LEN);
    eval 'sub IEEE80211_MIN_LEN () {($sizeof{\'struct ieee80211_frame_min\'} +  &IEEE80211_CRC_LEN);}' unless defined(&IEEE80211_MIN_LEN);
    eval 'sub IEEE80211_AID_MAX () {2007;}' unless defined(&IEEE80211_AID_MAX);
    eval 'sub IEEE80211_AID {
        my($b) = @_;
	    eval q((($b) &~ 0xc000));
    }' unless defined(&IEEE80211_AID);
    eval 'sub IEEE80211_RTS_MIN () {1;}' unless defined(&IEEE80211_RTS_MIN);
    eval 'sub IEEE80211_RTS_MAX () {2346;}' unless defined(&IEEE80211_RTS_MAX);
    eval 'sub IEEE80211_FRAG_MIN () {256;}' unless defined(&IEEE80211_FRAG_MIN);
    eval 'sub IEEE80211_FRAG_MAX () {2346;}' unless defined(&IEEE80211_FRAG_MAX);
    eval 'sub IEEE80211_BINTVAL_MAX () {1000;}' unless defined(&IEEE80211_BINTVAL_MAX);
    eval 'sub IEEE80211_BINTVAL_MIN () {25;}' unless defined(&IEEE80211_BINTVAL_MIN);
    eval 'sub IEEE80211_DTIM_MAX () {15;}' unless defined(&IEEE80211_DTIM_MAX);
    eval 'sub IEEE80211_DTIM_MIN () {1;}' unless defined(&IEEE80211_DTIM_MIN);
    eval 'sub IEEE80211_HWBMISS_MIN () {1;}' unless defined(&IEEE80211_HWBMISS_MIN);
    eval 'sub IEEE80211_HWBMISS_MAX () {255;}' unless defined(&IEEE80211_HWBMISS_MAX);
    eval 'sub IEEE80211_DUR_TU () {1024;}' unless defined(&IEEE80211_DUR_TU);
    eval 'sub IEEE80211_DUR_DS_LONG_PREAMBLE () {144;}' unless defined(&IEEE80211_DUR_DS_LONG_PREAMBLE);
    eval 'sub IEEE80211_DUR_DS_SHORT_PREAMBLE () {72;}' unless defined(&IEEE80211_DUR_DS_SHORT_PREAMBLE);
    eval 'sub IEEE80211_DUR_DS_SLOW_PLCPHDR () {48;}' unless defined(&IEEE80211_DUR_DS_SLOW_PLCPHDR);
    eval 'sub IEEE80211_DUR_DS_FAST_PLCPHDR () {24;}' unless defined(&IEEE80211_DUR_DS_FAST_PLCPHDR);
    eval 'sub IEEE80211_DUR_DS_SLOW_ACK () {112;}' unless defined(&IEEE80211_DUR_DS_SLOW_ACK);
    eval 'sub IEEE80211_DUR_DS_FAST_ACK () {56;}' unless defined(&IEEE80211_DUR_DS_FAST_ACK);
    eval 'sub IEEE80211_DUR_DS_SLOW_CTS () {112;}' unless defined(&IEEE80211_DUR_DS_SLOW_CTS);
    eval 'sub IEEE80211_DUR_DS_FAST_CTS () {56;}' unless defined(&IEEE80211_DUR_DS_FAST_CTS);
    eval 'sub IEEE80211_DUR_DS_SLOT () {20;}' unless defined(&IEEE80211_DUR_DS_SLOT);
    eval 'sub IEEE80211_DUR_DS_SIFS () {10;}' unless defined(&IEEE80211_DUR_DS_SIFS);
    eval 'sub IEEE80211_DUR_DS_PIFS () {( &IEEE80211_DUR_DS_SIFS +  &IEEE80211_DUR_DS_SLOT);}' unless defined(&IEEE80211_DUR_DS_PIFS);
    eval 'sub IEEE80211_DUR_DS_DIFS () {( &IEEE80211_DUR_DS_SIFS + 2*  &IEEE80211_DUR_DS_SLOT);}' unless defined(&IEEE80211_DUR_DS_DIFS);
    eval 'sub IEEE80211_DUR_DS_EIFS () {( &IEEE80211_DUR_DS_SIFS +  &IEEE80211_DUR_DS_SLOW_ACK +  &IEEE80211_DUR_DS_LONG_PREAMBLE +  &IEEE80211_DUR_DS_SLOW_PLCPHDR +  &IEEE80211_DUR_DIFS);}' unless defined(&IEEE80211_DUR_DS_EIFS);
}
1;
