require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_FREEBSD_H_)) {
    eval 'sub _NET80211_IEEE80211_FREEBSD_H_ () {1;}' unless defined(&_NET80211_IEEE80211_FREEBSD_H_);
    if(defined(&_KERNEL)) {
	require 'sys/param.ph';
	require 'sys/systm.ph';
	require 'sys/counter.ph';
	require 'sys/lock.ph';
	require 'sys/mutex.ph';
	require 'sys/rwlock.ph';
	require 'sys/sysctl.ph';
	require 'sys/taskqueue.ph';
	eval 'sub IEEE80211_LOCK_INIT {
	    my($_ic, $_name) = @_;
    	    eval q( &do {  &ieee80211_com_lock_t * &cl = ($_ic)-> &ic_comlock;  &snprintf( ($cl->{name}), $sizeof{ ($cl->{name})}, \\"%s_com_lock\\", $_name);  &mtx_init( ($cl->{mtx}),  ($cl->{name}),  &NULL,  &MTX_DEF |  &MTX_RECURSE); }  &while (0));
	}' unless defined(&IEEE80211_LOCK_INIT);
	eval 'sub IEEE80211_LOCK_OBJ {
	    my($_ic) = @_;
    	    eval q((($_ic)-> ($ic_comlock->{mtx})));
	}' unless defined(&IEEE80211_LOCK_OBJ);
	eval 'sub IEEE80211_LOCK_DESTROY {
	    my($_ic) = @_;
    	    eval q( &mtx_destroy( &IEEE80211_LOCK_OBJ($_ic)));
	}' unless defined(&IEEE80211_LOCK_DESTROY);
	eval 'sub IEEE80211_LOCK {
	    my($_ic) = @_;
    	    eval q( &mtx_lock( &IEEE80211_LOCK_OBJ($_ic)));
	}' unless defined(&IEEE80211_LOCK);
	eval 'sub IEEE80211_UNLOCK {
	    my($_ic) = @_;
    	    eval q( &mtx_unlock( &IEEE80211_LOCK_OBJ($_ic)));
	}' unless defined(&IEEE80211_UNLOCK);
	eval 'sub IEEE80211_LOCK_ASSERT {
	    my($_ic) = @_;
    	    eval q( &mtx_assert( &IEEE80211_LOCK_OBJ($_ic),  &MA_OWNED));
	}' unless defined(&IEEE80211_LOCK_ASSERT);
	eval 'sub IEEE80211_UNLOCK_ASSERT {
	    my($_ic) = @_;
    	    eval q( &mtx_assert( &IEEE80211_LOCK_OBJ($_ic),  &MA_NOTOWNED));
	}' unless defined(&IEEE80211_UNLOCK_ASSERT);
	eval 'sub IEEE80211_TX_LOCK_INIT {
	    my($_ic, $_name) = @_;
    	    eval q( &do {  &ieee80211_tx_lock_t * &cl = ($_ic)-> &ic_txlock;  &snprintf( ($cl->{name}), $sizeof{ ($cl->{name})}, \\"%s_tx_lock\\", $_name);  &mtx_init( ($cl->{mtx}),  ($cl->{name}),  &NULL,  &MTX_DEF); }  &while (0));
	}' unless defined(&IEEE80211_TX_LOCK_INIT);
	eval 'sub IEEE80211_TX_LOCK_OBJ {
	    my($_ic) = @_;
    	    eval q((($_ic)-> ($ic_txlock->{mtx})));
	}' unless defined(&IEEE80211_TX_LOCK_OBJ);
	eval 'sub IEEE80211_TX_LOCK_DESTROY {
	    my($_ic) = @_;
    	    eval q( &mtx_destroy( &IEEE80211_TX_LOCK_OBJ($_ic)));
	}' unless defined(&IEEE80211_TX_LOCK_DESTROY);
	eval 'sub IEEE80211_TX_LOCK {
	    my($_ic) = @_;
    	    eval q( &mtx_lock( &IEEE80211_TX_LOCK_OBJ($_ic)));
	}' unless defined(&IEEE80211_TX_LOCK);
	eval 'sub IEEE80211_TX_UNLOCK {
	    my($_ic) = @_;
    	    eval q( &mtx_unlock( &IEEE80211_TX_LOCK_OBJ($_ic)));
	}' unless defined(&IEEE80211_TX_UNLOCK);
	eval 'sub IEEE80211_TX_LOCK_ASSERT {
	    my($_ic) = @_;
    	    eval q( &mtx_assert( &IEEE80211_TX_LOCK_OBJ($_ic),  &MA_OWNED));
	}' unless defined(&IEEE80211_TX_LOCK_ASSERT);
	eval 'sub IEEE80211_TX_UNLOCK_ASSERT {
	    my($_ic) = @_;
    	    eval q( &mtx_assert( &IEEE80211_TX_LOCK_OBJ($_ic),  &MA_NOTOWNED));
	}' unless defined(&IEEE80211_TX_UNLOCK_ASSERT);
	eval 'sub IEEE80211_FF_LOCK_INIT {
	    my($_ic, $_name) = @_;
    	    eval q( &do {  &ieee80211_ff_lock_t * &fl = ($_ic)-> &ic_fflock;  &snprintf( ($fl->{name}), $sizeof{ ($fl->{name})}, \\"%s_ff_lock\\", $_name);  &mtx_init( ($fl->{mtx}),  ($fl->{name}),  &NULL,  &MTX_DEF); }  &while (0));
	}' unless defined(&IEEE80211_FF_LOCK_INIT);
	eval 'sub IEEE80211_FF_LOCK_OBJ {
	    my($_ic) = @_;
    	    eval q((($_ic)-> ($ic_fflock->{mtx})));
	}' unless defined(&IEEE80211_FF_LOCK_OBJ);
	eval 'sub IEEE80211_FF_LOCK_DESTROY {
	    my($_ic) = @_;
    	    eval q( &mtx_destroy( &IEEE80211_FF_LOCK_OBJ($_ic)));
	}' unless defined(&IEEE80211_FF_LOCK_DESTROY);
	eval 'sub IEEE80211_FF_LOCK {
	    my($_ic) = @_;
    	    eval q( &mtx_lock( &IEEE80211_FF_LOCK_OBJ($_ic)));
	}' unless defined(&IEEE80211_FF_LOCK);
	eval 'sub IEEE80211_FF_UNLOCK {
	    my($_ic) = @_;
    	    eval q( &mtx_unlock( &IEEE80211_FF_LOCK_OBJ($_ic)));
	}' unless defined(&IEEE80211_FF_UNLOCK);
	eval 'sub IEEE80211_FF_LOCK_ASSERT {
	    my($_ic) = @_;
    	    eval q( &mtx_assert( &IEEE80211_FF_LOCK_OBJ($_ic),  &MA_OWNED));
	}' unless defined(&IEEE80211_FF_LOCK_ASSERT);
	eval 'sub IEEE80211_NODE_LOCK_INIT {
	    my($_nt, $_name) = @_;
    	    eval q( &do {  &ieee80211_node_lock_t * &nl = ($_nt)-> &nt_nodelock;  &snprintf( ($nl->{name}), $sizeof{ ($nl->{name})}, \\"%s_node_lock\\", $_name);  &mtx_init( ($nl->{mtx}),  ($nl->{name}),  &NULL,  &MTX_DEF |  &MTX_RECURSE); }  &while (0));
	}' unless defined(&IEEE80211_NODE_LOCK_INIT);
	eval 'sub IEEE80211_NODE_LOCK_OBJ {
	    my($_nt) = @_;
    	    eval q((($_nt)-> ($nt_nodelock->{mtx})));
	}' unless defined(&IEEE80211_NODE_LOCK_OBJ);
	eval 'sub IEEE80211_NODE_LOCK_DESTROY {
	    my($_nt) = @_;
    	    eval q( &mtx_destroy( &IEEE80211_NODE_LOCK_OBJ($_nt)));
	}' unless defined(&IEEE80211_NODE_LOCK_DESTROY);
	eval 'sub IEEE80211_NODE_LOCK {
	    my($_nt) = @_;
    	    eval q( &mtx_lock( &IEEE80211_NODE_LOCK_OBJ($_nt)));
	}' unless defined(&IEEE80211_NODE_LOCK);
	eval 'sub IEEE80211_NODE_IS_LOCKED {
	    my($_nt) = @_;
    	    eval q( &mtx_owned( &IEEE80211_NODE_LOCK_OBJ($_nt)));
	}' unless defined(&IEEE80211_NODE_IS_LOCKED);
	eval 'sub IEEE80211_NODE_UNLOCK {
	    my($_nt) = @_;
    	    eval q( &mtx_unlock( &IEEE80211_NODE_LOCK_OBJ($_nt)));
	}' unless defined(&IEEE80211_NODE_UNLOCK);
	eval 'sub IEEE80211_NODE_LOCK_ASSERT {
	    my($_nt) = @_;
    	    eval q( &mtx_assert( &IEEE80211_NODE_LOCK_OBJ($_nt),  &MA_OWNED));
	}' unless defined(&IEEE80211_NODE_LOCK_ASSERT);
	eval 'sub IEEE80211_PSQ_INIT {
	    my($_psq, $_name) = @_;
    	    eval q( &mtx_init(($_psq)-> &psq_lock, $_name, \\"802.11 ps q\\",  &MTX_DEF));
	}' unless defined(&IEEE80211_PSQ_INIT);
	eval 'sub IEEE80211_PSQ_DESTROY {
	    my($_psq) = @_;
    	    eval q( &mtx_destroy(($_psq)-> &psq_lock));
	}' unless defined(&IEEE80211_PSQ_DESTROY);
	eval 'sub IEEE80211_PSQ_LOCK {
	    my($_psq) = @_;
    	    eval q( &mtx_lock(($_psq)-> &psq_lock));
	}' unless defined(&IEEE80211_PSQ_LOCK);
	eval 'sub IEEE80211_PSQ_UNLOCK {
	    my($_psq) = @_;
    	    eval q( &mtx_unlock(($_psq)-> &psq_lock));
	}' unless defined(&IEEE80211_PSQ_UNLOCK);
	unless(defined(&IF_PREPEND_LIST)) {
	    eval 'sub _IF_PREPEND_LIST {
	        my($ifq, $mhead, $mtail, $mcount) = @_;
    		eval q( &do { ($mtail)-> &m_nextpkt = ($ifq)-> &ifq_head;  &if (($ifq)-> &ifq_tail ==  &NULL) ($ifq)-> &ifq_tail = ($mtail); ($ifq)-> &ifq_head = ($mhead); ($ifq)-> &ifq_len += ($mcount); }  &while (0));
	    }' unless defined(&_IF_PREPEND_LIST);
	    eval 'sub IF_PREPEND_LIST {
	        my($ifq, $mhead, $mtail, $mcount) = @_;
    		eval q( &do {  &IF_LOCK($ifq);  &_IF_PREPEND_LIST($ifq, $mhead, $mtail, $mcount);  &IF_UNLOCK($ifq); }  &while (0));
	    }' unless defined(&IF_PREPEND_LIST);
	}
	eval 'sub IEEE80211_AGEQ_INIT {
	    my($_aq, $_name) = @_;
    	    eval q( &mtx_init(($_aq)-> &aq_lock, $_name, \\"802.11 age q\\",  &MTX_DEF));
	}' unless defined(&IEEE80211_AGEQ_INIT);
	eval 'sub IEEE80211_AGEQ_DESTROY {
	    my($_aq) = @_;
    	    eval q( &mtx_destroy(($_aq)-> &aq_lock));
	}' unless defined(&IEEE80211_AGEQ_DESTROY);
	eval 'sub IEEE80211_AGEQ_LOCK {
	    my($_aq) = @_;
    	    eval q( &mtx_lock(($_aq)-> &aq_lock));
	}' unless defined(&IEEE80211_AGEQ_LOCK);
	eval 'sub IEEE80211_AGEQ_UNLOCK {
	    my($_aq) = @_;
    	    eval q( &mtx_unlock(($_aq)-> &aq_lock));
	}' unless defined(&IEEE80211_AGEQ_UNLOCK);
	eval 'sub ACL_LOCK_INIT {
	    my($_as, $_name) = @_;
    	    eval q( &mtx_init(($_as)-> &as_lock, $_name, \\"802.11 ACL\\",  &MTX_DEF));
	}' unless defined(&ACL_LOCK_INIT);
	eval 'sub ACL_LOCK_DESTROY {
	    my($_as) = @_;
    	    eval q( &mtx_destroy(($_as)-> &as_lock));
	}' unless defined(&ACL_LOCK_DESTROY);
	eval 'sub ACL_LOCK {
	    my($_as) = @_;
    	    eval q( &mtx_lock(($_as)-> &as_lock));
	}' unless defined(&ACL_LOCK);
	eval 'sub ACL_UNLOCK {
	    my($_as) = @_;
    	    eval q( &mtx_unlock(($_as)-> &as_lock));
	}' unless defined(&ACL_UNLOCK);
	eval 'sub ACL_LOCK_ASSERT {
	    my($_as) = @_;
    	    eval q( &mtx_assert((($_as)-> &as_lock),  &MA_OWNED));
	}' unless defined(&ACL_LOCK_ASSERT);
	eval 'sub IEEE80211_SCAN_TABLE_LOCK_INIT {
	    my($_st, $_name) = @_;
    	    eval q( &mtx_init(($_st)-> &st_lock, $_name, \\"802.11 scan table\\",  &MTX_DEF));
	}' unless defined(&IEEE80211_SCAN_TABLE_LOCK_INIT);
	eval 'sub IEEE80211_SCAN_TABLE_LOCK_DESTROY {
	    my($_st) = @_;
    	    eval q( &mtx_destroy(($_st)-> &st_lock));
	}' unless defined(&IEEE80211_SCAN_TABLE_LOCK_DESTROY);
	eval 'sub IEEE80211_SCAN_TABLE_LOCK {
	    my($_st) = @_;
    	    eval q( &mtx_lock(($_st)-> &st_lock));
	}' unless defined(&IEEE80211_SCAN_TABLE_LOCK);
	eval 'sub IEEE80211_SCAN_TABLE_UNLOCK {
	    my($_st) = @_;
    	    eval q( &mtx_unlock(($_st)-> &st_lock));
	}' unless defined(&IEEE80211_SCAN_TABLE_UNLOCK);
	eval 'sub IEEE80211_SCAN_ITER_LOCK_INIT {
	    my($_st, $_name) = @_;
    	    eval q( &mtx_init(($_st)-> &st_scanlock, $_name, \\"802.11 scangen\\",  &MTX_DEF));
	}' unless defined(&IEEE80211_SCAN_ITER_LOCK_INIT);
	eval 'sub IEEE80211_SCAN_ITER_LOCK_DESTROY {
	    my($_st) = @_;
    	    eval q( &mtx_destroy(($_st)-> &st_scanlock));
	}' unless defined(&IEEE80211_SCAN_ITER_LOCK_DESTROY);
	eval 'sub IEEE80211_SCAN_ITER_LOCK {
	    my($_st) = @_;
    	    eval q( &mtx_lock(($_st)-> &st_scanlock));
	}' unless defined(&IEEE80211_SCAN_ITER_LOCK);
	eval 'sub IEEE80211_SCAN_ITER_UNLOCK {
	    my($_st) = @_;
    	    eval q( &mtx_unlock(($_st)-> &st_scanlock));
	}' unless defined(&IEEE80211_SCAN_ITER_UNLOCK);
	eval 'sub MESH_RT_ENTRY_LOCK_INIT {
	    my($_rt, $_name) = @_;
    	    eval q( &mtx_init(( &rt)-> &rt_lock, $_name, \\"802.11s route entry\\",  &MTX_DEF));
	}' unless defined(&MESH_RT_ENTRY_LOCK_INIT);
	eval 'sub MESH_RT_ENTRY_LOCK_DESTROY {
	    my($_rt) = @_;
    	    eval q( &mtx_destroy(($_rt)-> &rt_lock));
	}' unless defined(&MESH_RT_ENTRY_LOCK_DESTROY);
	eval 'sub MESH_RT_ENTRY_LOCK {
	    my($rt) = @_;
    	    eval q( &mtx_lock(($rt)-> &rt_lock));
	}' unless defined(&MESH_RT_ENTRY_LOCK);
	eval 'sub MESH_RT_ENTRY_LOCK_ASSERT {
	    my($rt) = @_;
    	    eval q( &mtx_assert(($rt)-> &rt_lock,  &MA_OWNED));
	}' unless defined(&MESH_RT_ENTRY_LOCK_ASSERT);
	eval 'sub MESH_RT_ENTRY_UNLOCK {
	    my($rt) = @_;
    	    eval q( &mtx_unlock(($rt)-> &rt_lock));
	}' unless defined(&MESH_RT_ENTRY_UNLOCK);
	eval 'sub MESH_RT_LOCK {
	    my($ms) = @_;
    	    eval q( &mtx_lock(($ms)-> &ms_rt_lock));
	}' unless defined(&MESH_RT_LOCK);
	eval 'sub MESH_RT_LOCK_ASSERT {
	    my($ms) = @_;
    	    eval q( &mtx_assert(($ms)-> &ms_rt_lock,  &MA_OWNED));
	}' unless defined(&MESH_RT_LOCK_ASSERT);
	eval 'sub MESH_RT_UNLOCK {
	    my($ms) = @_;
    	    eval q( &mtx_unlock(($ms)-> &ms_rt_lock));
	}' unless defined(&MESH_RT_UNLOCK);
	eval 'sub MESH_RT_LOCK_INIT {
	    my($ms, $name) = @_;
    	    eval q( &mtx_init(($ms)-> &ms_rt_lock, $name, \\"802.11s routing table\\",  &MTX_DEF));
	}' unless defined(&MESH_RT_LOCK_INIT);
	eval 'sub MESH_RT_LOCK_DESTROY {
	    my($ms) = @_;
    	    eval q( &mtx_destroy(($ms)-> &ms_rt_lock));
	}' unless defined(&MESH_RT_LOCK_DESTROY);
	require 'machine/atomic.ph';
	eval 'sub ieee80211_node_initref {
	    my($_ni) = @_;
    	    eval q( &do { (($_ni)-> &ni_refcnt = 1); }  &while (0));
	}' unless defined(&ieee80211_node_initref);
	eval 'sub ieee80211_node_incref {
	    my($_ni) = @_;
    	    eval q( &atomic_add_int(($_ni)-> &ni_refcnt, 1));
	}' unless defined(&ieee80211_node_incref);
	eval 'sub ieee80211_node_decref {
	    my($_ni) = @_;
    	    eval q( &atomic_subtract_int(($_ni)-> &ni_refcnt, 1));
	}' unless defined(&ieee80211_node_decref);
	eval 'sub ieee80211_node_refcnt {
	    my($_ni) = @_;
    	    eval q(($_ni)-> &ni_refcnt);
	}' unless defined(&ieee80211_node_refcnt);
	eval 'sub IFNET_IS_UP_RUNNING {
	    my($_ifp) = @_;
    	    eval q(((($_ifp)-> &if_flags &  &IFF_UP)  && (($_ifp)-> &if_drv_flags &  &IFF_DRV_RUNNING)));
	}' unless defined(&IFNET_IS_UP_RUNNING);
	eval 'sub msecs_to_ticks {
	    my($ms) = @_;
    	    eval q(((($ms)* &hz)/1000));
	}' unless defined(&msecs_to_ticks);
	eval 'sub ticks_to_msecs {
	    my($t) = @_;
    	    eval q((1000*($t) /  &hz));
	}' unless defined(&ticks_to_msecs);
	eval 'sub ticks_to_secs {
	    my($t) = @_;
    	    eval q((($t) /  &hz));
	}' unless defined(&ticks_to_secs);
	eval 'sub ieee80211_time_after {
	    my($a,$b) = @_;
    	    eval q(( - ($a) < 0));
	}' unless defined(&ieee80211_time_after);
	eval 'sub ieee80211_time_before {
	    my($a,$b) = @_;
    	    eval q( &ieee80211_time_after($b,$a));
	}' unless defined(&ieee80211_time_before);
	eval 'sub ieee80211_time_after_eq {
	    my($a,$b) = @_;
    	    eval q(( - ($b) >= 0));
	}' unless defined(&ieee80211_time_after_eq);
	eval 'sub ieee80211_time_before_eq {
	    my($a,$b) = @_;
    	    eval q( &ieee80211_time_after_eq($b,$a));
	}' unless defined(&ieee80211_time_before_eq);
	eval 'sub M_ENCAP () { &M_PROTO1;}' unless defined(&M_ENCAP);
	eval 'sub M_EAPOL () { &M_PROTO3;}' unless defined(&M_EAPOL);
	eval 'sub M_PWR_SAV () { &M_PROTO4;}' unless defined(&M_PWR_SAV);
	eval 'sub M_MORE_DATA () { &M_PROTO5;}' unless defined(&M_MORE_DATA);
	eval 'sub M_FF () { &M_PROTO6;}' unless defined(&M_FF);
	eval 'sub M_TXCB () { &M_PROTO7;}' unless defined(&M_TXCB);
	eval 'sub M_AMPDU_MPDU () { &M_PROTO8;}' unless defined(&M_AMPDU_MPDU);
	eval 'sub M_FRAG () { &M_PROTO9;}' unless defined(&M_FRAG);
	eval 'sub M_FIRSTFRAG () { &M_PROTO10;}' unless defined(&M_FIRSTFRAG);
	eval 'sub M_LASTFRAG () { &M_PROTO11;}' unless defined(&M_LASTFRAG);
	eval 'sub M_80211_TX () {( &M_ENCAP| &M_EAPOL| &M_PWR_SAV| &M_MORE_DATA| &M_FF| &M_TXCB|  &M_AMPDU_MPDU| &M_FRAG| &M_FIRSTFRAG| &M_LASTFRAG);}' unless defined(&M_80211_TX);
	eval 'sub M_AMPDU () { &M_PROTO1;}' unless defined(&M_AMPDU);
	eval 'sub M_WEP () { &M_PROTO2;}' unless defined(&M_WEP);
	if(0) {
	    eval 'sub M_AMPDU_MPDU () { &M_PROTO8;}' unless defined(&M_AMPDU_MPDU);
	}
	eval 'sub M_80211_RX () {( &M_AMPDU| &M_WEP| &M_AMPDU_MPDU);}' unless defined(&M_80211_RX);
	eval 'sub IEEE80211_MBUF_TX_FLAG_BITS () { &M_FLAG_BITS "\\15M_ENCAP\\17M_EAPOL\\20M_PWR_SAV\\21M_MORE_DATA\\22M_FF\\23M_TXCB" "\\24M_AMPDU_MPDU\\25M_FRAG\\26M_FIRSTFRAG\\27M_LASTFRAG";}' unless defined(&IEEE80211_MBUF_TX_FLAG_BITS);
	eval 'sub IEEE80211_MBUF_RX_FLAG_BITS () { &M_FLAG_BITS "\\15M_AMPDU\\16M_WEP\\24M_AMPDU_MPDU";}' unless defined(&IEEE80211_MBUF_RX_FLAG_BITS);
	eval 'sub M_WME_SETAC {
	    my($m, $ac) = @_;
    	    eval q((($m)-> ($m_pkthdr->{ether_vtag}) = ($ac)));
	}' unless defined(&M_WME_SETAC);
	eval 'sub M_WME_GETAC {
	    my($m) = @_;
    	    eval q((($m)-> ($m_pkthdr->{ether_vtag})));
	}' unless defined(&M_WME_GETAC);
	eval 'sub M_AGE_SET {
	    my($m,$v) = @_;
    	    eval q(( ($m->{m_pkthdr}->{csum_data}) = $v));
	}' unless defined(&M_AGE_SET);
	eval 'sub M_AGE_GET {
	    my($m) = @_;
    	    eval q(( ($m->{m_pkthdr}->{csum_data})));
	}' unless defined(&M_AGE_GET);
	eval 'sub M_AGE_SUB {
	    my($m,$adj) = @_;
    	    eval q(( ($m->{m_pkthdr}->{csum_data}) -= $adj));
	}' unless defined(&M_AGE_SUB);
	eval 'sub M_SEQNO_SET {
	    my($m, $seqno) = @_;
    	    eval q((($m)-> ($m_pkthdr->{tso_segsz}) = ($seqno)));
	}' unless defined(&M_SEQNO_SET);
	eval 'sub M_SEQNO_GET {
	    my($m) = @_;
    	    eval q((($m)-> ($m_pkthdr->{tso_segsz})));
	}' unless defined(&M_SEQNO_GET);
	eval 'sub MTAG_ABI_NET80211 () {1132948340;}' unless defined(&MTAG_ABI_NET80211);
	eval 'sub NET80211_TAG_CALLBACK () {0;}' unless defined(&NET80211_TAG_CALLBACK);
	eval 'sub NET80211_TAG_XMIT_PARAMS () {1;}' unless defined(&NET80211_TAG_XMIT_PARAMS);
	eval 'sub NET80211_TAG_RECV_PARAMS () {2;}' unless defined(&NET80211_TAG_RECV_PARAMS);
	eval 'sub _IEEE80211_POLICY_MODULE {
	    my($policy, $name, $version) = @_;
    	    eval q( &typedef  &void (*$policy &_setup);  &SET_DECLARE($policy &_set, $policy &_setup);  &static \'int\'  &wlan_$name &_modevent( &module_t  &mod, \'int\'  &type,  &void * &unused) { $policy &_setup *  &const * &iter,  &f;  &switch ( &type) {  &case  &MOD_LOAD:  &SET_FOREACH( &iter, $policy &_set) {  &f = ( &void*) * &iter;  &f( &type); }  &return 0;  &case  &MOD_UNLOAD:  &case  &MOD_QUIESCE:  &if ( &nrefs) {  &printf(\\"wlan_\\" $name \\": still in use \\" \\"(%u dynamic refs)\\\\n\\",  &nrefs);  &return  &EBUSY; }  &if ( &type ==  &MOD_UNLOAD) {  &SET_FOREACH( &iter, $policy &_set) {  &f = ( &void*) * &iter;  &f( &type); } }  &return 0; }  &return  &EINVAL; }  &static  &moduledata_t $name &_mod = { \\"wlan_\\" $name,  &wlan_$name &_modevent, 0};  &DECLARE_MODULE( &wlan_$name, $name &_mod,  &SI_SUB_DRIVERS,  &SI_ORDER_FIRST); &MODULE_VERSION( &wlan_$name, $version);  &MODULE_DEPEND( &wlan_$name,  &wlan, 1, 1, 1));
	}' unless defined(&_IEEE80211_POLICY_MODULE);
	eval 'sub IEEE80211_CRYPTO_MODULE {
	    my($name, $version) = @_;
    	    eval q( &_IEEE80211_POLICY_MODULE( &crypto, $name, $version);  &static  &void $name &_modevent(\'int\'  &type) {  &if ( &type ==  &MOD_LOAD)  &ieee80211_crypto_register($name);  &else  &ieee80211_crypto_unregister($name); }  &TEXT_SET( &crypto &_set, $name &_modevent));
	}' unless defined(&IEEE80211_CRYPTO_MODULE);
	eval 'sub IEEE80211_SCANNER_MODULE {
	    my($name, $version) = @_;
    	    eval q( &_IEEE80211_POLICY_MODULE( &scanner, $name, $version));
	}' unless defined(&IEEE80211_SCANNER_MODULE);
	eval 'sub IEEE80211_SCANNER_ALG {
	    my($name, $alg, $v) = @_;
    	    eval q( &static  &void $name &_modevent(\'int\'  &type) {  &if ( &type ==  &MOD_LOAD)  &ieee80211_scanner_register($alg, $v);  &else  &ieee80211_scanner_unregister($alg, $v); }  &TEXT_SET( &scanner_set, $name &_modevent););
	}' unless defined(&IEEE80211_SCANNER_ALG);
	eval 'sub IEEE80211_ACL_MODULE {
	    my($name, $alg, $version) = @_;
    	    eval q( &_IEEE80211_POLICY_MODULE( &acl, $name, $version);  &static  &void $alg &_modevent(\'int\'  &type) {  &if ( &type ==  &MOD_LOAD)  &ieee80211_aclator_register($alg);  &else  &ieee80211_aclator_unregister($alg); }  &TEXT_SET( &acl_set, $alg &_modevent););
	}' unless defined(&IEEE80211_ACL_MODULE);
	eval 'sub IEEE80211_AUTH_MODULE {
	    my($name, $version) = @_;
    	    eval q( &_IEEE80211_POLICY_MODULE( &auth, $name, $version));
	}' unless defined(&IEEE80211_AUTH_MODULE);
	eval 'sub IEEE80211_AUTH_ALG {
	    my($name, $alg, $v) = @_;
    	    eval q( &static  &void $name &_modevent(\'int\'  &type) {  &if ( &type ==  &MOD_LOAD)  &ieee80211_authenticator_register($alg, $v);  &else  &ieee80211_authenticator_unregister($alg); }  &TEXT_SET( &auth_set, $name &_modevent));
	}' unless defined(&IEEE80211_AUTH_ALG);
	eval 'sub IEEE80211_RATECTL_MODULE {
	    my($alg, $version) = @_;
    	    eval q( &_IEEE80211_POLICY_MODULE( &ratectl, $alg, $version););
	}' unless defined(&IEEE80211_RATECTL_MODULE);
	eval 'sub IEEE80211_RATECTL_ALG {
	    my($name, $alg, $v) = @_;
    	    eval q( &static  &void $alg &_modevent(\'int\'  &type) {  &if ( &type ==  &MOD_LOAD)  &ieee80211_ratectl_register($alg, $v);  &else  &ieee80211_ratectl_unregister($alg); }  &TEXT_SET( &ratectl &_set, $alg &_modevent));
	}' unless defined(&IEEE80211_RATECTL_ALG);
	eval 'sub IEEE80211_IOCTL_GET {
	    my($_name, $_get) = @_;
    	    eval q( &TEXT_SET( &ieee80211_ioctl_getset, $_get));
	}' unless defined(&IEEE80211_IOCTL_GET);
	eval 'sub IEEE80211_IOCTL_SET {
	    my($_name, $_set) = @_;
    	    eval q( &TEXT_SET( &ieee80211_ioctl_setset, $_set));
	}' unless defined(&IEEE80211_IOCTL_SET);
    }
    eval 'sub RTM_IEEE80211_ASSOC () {100;}' unless defined(&RTM_IEEE80211_ASSOC);
    eval 'sub RTM_IEEE80211_REASSOC () {101;}' unless defined(&RTM_IEEE80211_REASSOC);
    eval 'sub RTM_IEEE80211_DISASSOC () {102;}' unless defined(&RTM_IEEE80211_DISASSOC);
    eval 'sub RTM_IEEE80211_JOIN () {103;}' unless defined(&RTM_IEEE80211_JOIN);
    eval 'sub RTM_IEEE80211_LEAVE () {104;}' unless defined(&RTM_IEEE80211_LEAVE);
    eval 'sub RTM_IEEE80211_SCAN () {105;}' unless defined(&RTM_IEEE80211_SCAN);
    eval 'sub RTM_IEEE80211_REPLAY () {106;}' unless defined(&RTM_IEEE80211_REPLAY);
    eval 'sub RTM_IEEE80211_MICHAEL () {107;}' unless defined(&RTM_IEEE80211_MICHAEL);
    eval 'sub RTM_IEEE80211_REJOIN () {108;}' unless defined(&RTM_IEEE80211_REJOIN);
    eval 'sub RTM_IEEE80211_WDS () {109;}' unless defined(&RTM_IEEE80211_WDS);
    eval 'sub RTM_IEEE80211_CSA () {110;}' unless defined(&RTM_IEEE80211_CSA);
    eval 'sub RTM_IEEE80211_RADAR () {111;}' unless defined(&RTM_IEEE80211_RADAR);
    eval 'sub RTM_IEEE80211_CAC () {112;}' unless defined(&RTM_IEEE80211_CAC);
    eval 'sub RTM_IEEE80211_DEAUTH () {113;}' unless defined(&RTM_IEEE80211_DEAUTH);
    eval 'sub RTM_IEEE80211_AUTH () {114;}' unless defined(&RTM_IEEE80211_AUTH);
    eval 'sub RTM_IEEE80211_COUNTRY () {115;}' unless defined(&RTM_IEEE80211_COUNTRY);
    eval 'sub RTM_IEEE80211_RADIO () {116;}' unless defined(&RTM_IEEE80211_RADIO);
    eval 'sub IEEE80211_BPF_VERSION () {0;}' unless defined(&IEEE80211_BPF_VERSION);
    eval 'sub IEEE80211_BPF_SHORTPRE () {0x1;}' unless defined(&IEEE80211_BPF_SHORTPRE);
    eval 'sub IEEE80211_BPF_NOACK () {0x2;}' unless defined(&IEEE80211_BPF_NOACK);
    eval 'sub IEEE80211_BPF_CRYPTO () {0x4;}' unless defined(&IEEE80211_BPF_CRYPTO);
    eval 'sub IEEE80211_BPF_FCS () {0x10;}' unless defined(&IEEE80211_BPF_FCS);
    eval 'sub IEEE80211_BPF_DATAPAD () {0x20;}' unless defined(&IEEE80211_BPF_DATAPAD);
    eval 'sub IEEE80211_BPF_RTS () {0x40;}' unless defined(&IEEE80211_BPF_RTS);
    eval 'sub IEEE80211_BPF_CTS () {0x80;}' unless defined(&IEEE80211_BPF_CTS);
    if(defined(&_KERNEL)) {
	eval 'sub IEEE80211_MAX_CHAINS () {3;}' unless defined(&IEEE80211_MAX_CHAINS);
	eval 'sub IEEE80211_MAX_EVM_PILOTS () {6;}' unless defined(&IEEE80211_MAX_EVM_PILOTS);
	eval 'sub IEEE80211_R_NF () {0x1;}' unless defined(&IEEE80211_R_NF);
	eval 'sub IEEE80211_R_RSSI () {0x2;}' unless defined(&IEEE80211_R_RSSI);
	eval 'sub IEEE80211_R_C_CHAIN () {0x4;}' unless defined(&IEEE80211_R_C_CHAIN);
	eval 'sub IEEE80211_R_C_NF () {0x8;}' unless defined(&IEEE80211_R_C_NF);
	eval 'sub IEEE80211_R_C_RSSI () {0x10;}' unless defined(&IEEE80211_R_C_RSSI);
	eval 'sub IEEE80211_R_C_EVM () {0x20;}' unless defined(&IEEE80211_R_C_EVM);
	eval 'sub IEEE80211_R_C_HT40 () {0x40;}' unless defined(&IEEE80211_R_C_HT40);
	eval 'sub IEEE80211_R_FREQ () {0x80;}' unless defined(&IEEE80211_R_FREQ);
	eval 'sub IEEE80211_R_IEEE () {0x100;}' unless defined(&IEEE80211_R_IEEE);
	eval 'sub IEEE80211_R_BAND () {0x200;}' unless defined(&IEEE80211_R_BAND);
    }
    eval 'sub IEEE80211_MALLOC () { &malloc;}' unless defined(&IEEE80211_MALLOC);
    eval 'sub IEEE80211_FREE () { &free;}' unless defined(&IEEE80211_FREE);
    eval 'sub IEEE80211_M_NOWAIT () { &M_NOWAIT;}' unless defined(&IEEE80211_M_NOWAIT);
    eval 'sub IEEE80211_M_WAITOK () { &M_WAITOK;}' unless defined(&IEEE80211_M_WAITOK);
    eval 'sub IEEE80211_M_ZERO () { &M_ZERO;}' unless defined(&IEEE80211_M_ZERO);
}
1;
