require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_HT_H_)) {
    eval 'sub _NET80211_IEEE80211_HT_H_ () {1;}' unless defined(&_NET80211_IEEE80211_HT_H_);
    eval 'sub IEEE80211_AGGR_BAWMAX () {64;}' unless defined(&IEEE80211_AGGR_BAWMAX);
    eval 'sub IEEE80211_NONHT_PRESENT_AGE () { &msecs_to_ticks(60*1000);}' unless defined(&IEEE80211_NONHT_PRESENT_AGE);
    eval 'sub IEEE80211_AGGR_IMMEDIATE () {0x1;}' unless defined(&IEEE80211_AGGR_IMMEDIATE);
    eval 'sub IEEE80211_AGGR_XCHGPEND () {0x2;}' unless defined(&IEEE80211_AGGR_XCHGPEND);
    eval 'sub IEEE80211_AGGR_RUNNING () {0x4;}' unless defined(&IEEE80211_AGGR_RUNNING);
    eval 'sub IEEE80211_AGGR_SETUP () {0x8;}' unless defined(&IEEE80211_AGGR_SETUP);
    eval 'sub IEEE80211_AGGR_NAK () {0x10;}' unless defined(&IEEE80211_AGGR_NAK);
    eval 'sub IEEE80211_AGGR_BARPEND () {0x20;}' unless defined(&IEEE80211_AGGR_BARPEND);
    eval 'sub IEEE80211_AMPDU_RUNNING {
        my($tap) = @_;
	    eval q(((($tap)-> &txa_flags &  &IEEE80211_AGGR_RUNNING) != 0));
    }' unless defined(&IEEE80211_AMPDU_RUNNING);
    eval 'sub IEEE80211_AMPDU_NACKED {
        my($tap) = @_;
	    eval q((!! (($tap)-> &txa_flags &  &IEEE80211_AGGR_NAK)));
    }' unless defined(&IEEE80211_AMPDU_NACKED);
    eval 'sub IEEE80211_AMPDU_REQUESTED {
        my($tap) = @_;
	    eval q(((($tap)-> &txa_flags & ( &IEEE80211_AGGR_RUNNING| &IEEE80211_AGGR_XCHGPEND| &IEEE80211_AGGR_NAK)) != 0));
    }' unless defined(&IEEE80211_AMPDU_REQUESTED);
    eval 'sub IEEE80211_AGGR_BITS () {"\\20\\1IMMEDIATE\\2XCHGPEND\\3RUNNING\\4SETUP\\5NAK";}' unless defined(&IEEE80211_AGGR_BITS);
    eval 'sub ieee80211_txampdu_update_pps {
        my($tap) = @_;
	    eval q({  ($tap->{txa_avgpps}) = (( ($tap->{txa_avgpps}) << 2) -  ($tap->{txa_avgpps}) +  ($tap->{txa_pkts})) >> 2; });
    }' unless defined(&ieee80211_txampdu_update_pps);
}
1;
