require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_INPUT_H_)) {
    eval 'sub _NET80211_IEEE80211_INPUT_H_ () {1;}' unless defined(&_NET80211_IEEE80211_INPUT_H_);
    eval 'sub IEEE80211_VERIFY_ELEMENT {
        my($__elem, $__maxlen, $_action) = @_;
	    eval q( &do {  &if (($__elem) ==  &NULL) {  &IEEE80211_DISCARD( &vap,  &IEEE80211_MSG_ELEMID,  &wh,  &NULL, \\"%s\\", \\"no \\" $__elem );  ($vap->{iv_stats}->{is_rx_elem_missing})++; $_action; }  &else  &if (($__elem)[1] > ($__maxlen)) {  &IEEE80211_DISCARD( &vap,  &IEEE80211_MSG_ELEMID,  &wh,  &NULL, \\"bad \\" $__elem \\" len %d\\", ($__elem)[1]);  ($vap->{iv_stats}->{is_rx_elem_toobig})++; $_action; } }  &while (0));
    }' unless defined(&IEEE80211_VERIFY_ELEMENT);
    eval 'sub IEEE80211_VERIFY_LENGTH {
        my($_len, $_minlen, $_action) = @_;
	    eval q( &do {  &if (($_len) < ($_minlen)) {  &IEEE80211_DISCARD( &vap,  &IEEE80211_MSG_ELEMID,  &wh,  &NULL, \\"ie too short, got %d, expected %d\\", ($_len), ($_minlen));  ($vap->{iv_stats}->{is_rx_elem_toosmall})++; $_action; } }  &while (0));
    }' unless defined(&IEEE80211_VERIFY_LENGTH);
    if(defined(&IEEE80211_DEBUG)) {
	eval 'sub IEEE80211_VERIFY_SSID {
	    my($_ni, $_ssid, $_action) = @_;
    	    eval q( &do {  &if (($_ssid)[1] != 0 && (($_ssid)[1] != ($_ni)-> &ni_esslen ||  &memcmp(($_ssid) + 2, ($_ni)-> &ni_essid, ($_ssid)[1]) != 0)) {  &if ( &ieee80211_msg_input( &vap))  &ieee80211_ssid_mismatch( &vap,  &ieee80211_mgt_subtype_name( &subtype),  ($wh->{i_addr2}), $_ssid);  ($vap->{iv_stats}->{is_rx_ssidmismatch})++; $_action; } }  &while (0));
	}' unless defined(&IEEE80211_VERIFY_SSID);
    } else {
	eval 'sub IEEE80211_VERIFY_SSID {
	    my($_ni, $_ssid, $_action) = @_;
    	    eval q( &do {  &if (($_ssid)[1] != 0 && (($_ssid)[1] != ($_ni)-> &ni_esslen ||  &memcmp(($_ssid) + 2, ($_ni)-> &ni_essid, ($_ssid)[1]) != 0)) {  ($vap->{iv_stats}->{is_rx_ssidmismatch})++; $_action; } }  &while (0));
	}' unless defined(&IEEE80211_VERIFY_SSID);
    }
    require 'sys/endian.ph';
    eval 'sub iswpaoui {
        my($frm) = @_;
	    eval q({ $frm->[1] > 3 &&  &le32dec($frm+2) == (( &WPA_OUI_TYPE<<24)| &WPA_OUI); });
    }' unless defined(&iswpaoui);
    eval 'sub iswmeoui {
        my($frm) = @_;
	    eval q({ $frm->[1] > 3 &&  &le32dec($frm+2) == (( &WME_OUI_TYPE<<24)| &WME_OUI); });
    }' unless defined(&iswmeoui);
    eval 'sub iswmeparam {
        my($frm) = @_;
	    eval q({ $frm->[1] > 5 &&  &le32dec($frm+2) == (( &WME_OUI_TYPE<<24)| &WME_OUI)  && $frm->[6] ==  &WME_PARAM_OUI_SUBTYPE; });
    }' unless defined(&iswmeparam);
    eval 'sub iswmeinfo {
        my($frm) = @_;
	    eval q({ $frm->[1] > 5 &&  &le32dec($frm+2) == (( &WME_OUI_TYPE<<24)| &WME_OUI)  && $frm->[6] ==  &WME_INFO_OUI_SUBTYPE; });
    }' unless defined(&iswmeinfo);
    eval 'sub isatherosoui {
        my($frm) = @_;
	    eval q({ $frm->[1] > 3 &&  &le32dec($frm+2) == (( &ATH_OUI_TYPE<<24)| &ATH_OUI); });
    }' unless defined(&isatherosoui);
    eval 'sub istdmaoui {
        my($frm) = @_;
	    eval q({ $frm->[1] > 3 &&  &le32dec($frm+2) == (( &TDMA_OUI_TYPE<<24)| &TDMA_OUI); });
    }' unless defined(&istdmaoui);
    eval 'sub ishtcapoui {
        my($frm) = @_;
	    eval q({ $frm->[1] > 3 &&  &le32dec($frm+2) == (( &BCM_OUI_HTCAP<<24)| &BCM_OUI); });
    }' unless defined(&ishtcapoui);
    eval 'sub ishtinfooui {
        my($frm) = @_;
	    eval q({ $frm->[1] > 3 &&  &le32dec($frm+2) == (( &BCM_OUI_HTINFO<<24)| &BCM_OUI); });
    }' unless defined(&ishtinfooui);
    eval 'sub SEQ_LEQ {
        my($a,$b) = @_;
	    eval q(((($a)-($b)) <= 0));
    }' unless defined(&SEQ_LEQ);
    eval 'sub SEQ_EQ {
        my($a,$b) = @_;
	    eval q(((($a)-($b)) == 0));
    }' unless defined(&SEQ_EQ);
    eval 'sub SEQNO {
        my($a) = @_;
	    eval q((($a) >>  &IEEE80211_SEQ_SEQ_SHIFT));
    }' unless defined(&SEQNO);
    eval 'sub FRAGNO {
        my($a) = @_;
	    eval q((($a) &  &IEEE80211_SEQ_FRAG_MASK));
    }' unless defined(&FRAGNO);
    undef(&SEQ_LEQ) if defined(&SEQ_LEQ);
    undef(&SEQ_EQ) if defined(&SEQ_EQ);
    undef(&SEQNO) if defined(&SEQNO);
    undef(&FRAGNO) if defined(&FRAGNO);
}
1;
