require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_IOCTL_H_)) {
    eval 'sub _NET80211_IEEE80211_IOCTL_H_ () {1;}' unless defined(&_NET80211_IEEE80211_IOCTL_H_);
    require 'net80211/_ieee80211.ph';
    require 'net80211/ieee80211.ph';
    require 'net80211/ieee80211_crypto.ph';
    eval 'sub IEEE80211_MAX_OPT_IE () {256;}' unless defined(&IEEE80211_MAX_OPT_IE);
    eval 'sub IEEE80211_KEY_DEFAULT () {0x80;}' unless defined(&IEEE80211_KEY_DEFAULT);
    eval 'sub IEEE80211_MLME_ASSOC () {1;}' unless defined(&IEEE80211_MLME_ASSOC);
    eval 'sub IEEE80211_MLME_DISASSOC () {2;}' unless defined(&IEEE80211_MLME_DISASSOC);
    eval 'sub IEEE80211_MLME_DEAUTH () {3;}' unless defined(&IEEE80211_MLME_DEAUTH);
    eval 'sub IEEE80211_MLME_AUTHORIZE () {4;}' unless defined(&IEEE80211_MLME_AUTHORIZE);
    eval 'sub IEEE80211_MLME_UNAUTHORIZE () {5;}' unless defined(&IEEE80211_MLME_UNAUTHORIZE);
    eval 'sub IEEE80211_MLME_AUTH () {6;}' unless defined(&IEEE80211_MLME_AUTH);
    eval("sub IEEE80211_MACCMD_POLICY_OPEN () { 0; }") unless defined(&IEEE80211_MACCMD_POLICY_OPEN);
    eval("sub IEEE80211_MACCMD_POLICY_ALLOW () { 1; }") unless defined(&IEEE80211_MACCMD_POLICY_ALLOW);
    eval("sub IEEE80211_MACCMD_POLICY_DENY () { 2; }") unless defined(&IEEE80211_MACCMD_POLICY_DENY);
    eval("sub IEEE80211_MACCMD_FLUSH () { 3; }") unless defined(&IEEE80211_MACCMD_FLUSH);
    eval("sub IEEE80211_MACCMD_DETACH () { 4; }") unless defined(&IEEE80211_MACCMD_DETACH);
    eval("sub IEEE80211_MACCMD_POLICY () { 5; }") unless defined(&IEEE80211_MACCMD_POLICY);
    eval("sub IEEE80211_MACCMD_LIST () { 6; }") unless defined(&IEEE80211_MACCMD_LIST);
    eval("sub IEEE80211_MACCMD_POLICY_RADIUS () { 7; }") unless defined(&IEEE80211_MACCMD_POLICY_RADIUS);
    eval("sub IEEE80211_MESH_RTCMD_LIST () { 0; }") unless defined(&IEEE80211_MESH_RTCMD_LIST);
    eval("sub IEEE80211_MESH_RTCMD_FLUSH () { 1; }") unless defined(&IEEE80211_MESH_RTCMD_FLUSH);
    eval("sub IEEE80211_MESH_RTCMD_ADD () { 2; }") unless defined(&IEEE80211_MESH_RTCMD_ADD);
    eval("sub IEEE80211_MESH_RTCMD_DELETE () { 3; }") unless defined(&IEEE80211_MESH_RTCMD_DELETE);
    eval 'sub IEEE80211_MESHRT_FLAGS_DISCOVER () {0x1;}' unless defined(&IEEE80211_MESHRT_FLAGS_DISCOVER);
    eval 'sub IEEE80211_MESHRT_FLAGS_VALID () {0x2;}' unless defined(&IEEE80211_MESHRT_FLAGS_VALID);
    eval 'sub IEEE80211_MESHRT_FLAGS_PROXY () {0x4;}' unless defined(&IEEE80211_MESHRT_FLAGS_PROXY);
    eval 'sub IEEE80211_MESHRT_FLAGS_GATE () {0x8;}' unless defined(&IEEE80211_MESHRT_FLAGS_GATE);
    eval("sub IEEE80211_HWMP_ROOTMODE_DISABLED () { 0; }") unless defined(&IEEE80211_HWMP_ROOTMODE_DISABLED);
    eval("sub IEEE80211_HWMP_ROOTMODE_NORMAL () { 1; }") unless defined(&IEEE80211_HWMP_ROOTMODE_NORMAL);
    eval("sub IEEE80211_HWMP_ROOTMODE_PROACTIVE () { 2; }") unless defined(&IEEE80211_HWMP_ROOTMODE_PROACTIVE);
    eval("sub IEEE80211_HWMP_ROOTMODE_RANN () { 3; }") unless defined(&IEEE80211_HWMP_ROOTMODE_RANN);
    eval 'sub IEEE80211_CHANINFO_SIZE {
        my($_nchan) = @_;
	    eval q(($sizeof{\'struct ieee80211req_chaninfo\'} + ((($_nchan)-1) * $sizeof{\'struct ieee80211_channel\'})));
    }' unless defined(&IEEE80211_CHANINFO_SIZE);
    eval 'sub IEEE80211_CHANINFO_SPACE {
        my($_ci) = @_;
	    eval q( &IEEE80211_CHANINFO_SIZE(($_ci)-> &ic_nchans));
    }' unless defined(&IEEE80211_CHANINFO_SPACE);
    eval 'sub IEEE80211_WMEPARAM_SELF () {0x;}' unless defined(&IEEE80211_WMEPARAM_SELF);
    eval 'sub IEEE80211_WMEPARAM_BSS () {0x8000;}' unless defined(&IEEE80211_WMEPARAM_BSS);
    eval 'sub IEEE80211_WMEPARAM_VAL () {0x7fff;}' unless defined(&IEEE80211_WMEPARAM_VAL);
    eval 'sub IEEE80211_MAX_APPIE () {1024;}' unless defined(&IEEE80211_MAX_APPIE);
    eval 'sub IEEE80211_APPIE_WPA () {( &IEEE80211_FC0_TYPE_MGT |  &IEEE80211_FC0_SUBTYPE_BEACON |  &IEEE80211_FC0_SUBTYPE_PROBE_RESP);}' unless defined(&IEEE80211_APPIE_WPA);
    eval 'sub IEEE80211_REGDOMAIN_SIZE {
        my($_nchan) = @_;
	    eval q(($sizeof{\'struct ieee80211_regdomain_req\'} + ((($_nchan)-1) * $sizeof{\'struct ieee80211_channel\'})));
    }' unless defined(&IEEE80211_REGDOMAIN_SIZE);
    eval 'sub IEEE80211_REGDOMAIN_SPACE {
        my($_req) = @_;
	    eval q( &IEEE80211_REGDOMAIN_SIZE(($_req)-> ($chaninfo->{ic_nchans})));
    }' unless defined(&IEEE80211_REGDOMAIN_SPACE);
    eval 'sub IEEE80211_DEVCAPS_SIZE {
        my($_nchan) = @_;
	    eval q(($sizeof{\'struct ieee80211_devcaps_req\'} + ((($_nchan)-1) * $sizeof{\'struct ieee80211_channel\'})));
    }' unless defined(&IEEE80211_DEVCAPS_SIZE);
    eval 'sub IEEE80211_DEVCAPS_SPACE {
        my($_dc) = @_;
	    eval q( &IEEE80211_DEVCAPS_SIZE(($_dc)-> ($dc_chaninfo->{ic_nchans})));
    }' unless defined(&IEEE80211_DEVCAPS_SPACE);
    if(defined(&__FreeBSD__)) {
	eval 'sub SIOCS80211 () { &_IOW(ord(\'i\'), 234, \'struct ieee80211req\');}' unless defined(&SIOCS80211);
	eval 'sub SIOCG80211 () { &_IOWR(ord(\'i\'), 235, \'struct ieee80211req\');}' unless defined(&SIOCG80211);
	eval 'sub SIOCG80211STATS () { &_IOWR(ord(\'i\'), 236, \'struct ifreq\');}' unless defined(&SIOCG80211STATS);
	eval 'sub IEEE80211_IOC_SSID () {1;}' unless defined(&IEEE80211_IOC_SSID);
	eval 'sub IEEE80211_IOC_NUMSSIDS () {2;}' unless defined(&IEEE80211_IOC_NUMSSIDS);
	eval 'sub IEEE80211_IOC_WEP () {3;}' unless defined(&IEEE80211_IOC_WEP);
	eval 'sub IEEE80211_WEP_NOSUP () {-1;}' unless defined(&IEEE80211_WEP_NOSUP);
	eval 'sub IEEE80211_WEP_OFF () {0;}' unless defined(&IEEE80211_WEP_OFF);
	eval 'sub IEEE80211_WEP_ON () {1;}' unless defined(&IEEE80211_WEP_ON);
	eval 'sub IEEE80211_WEP_MIXED () {2;}' unless defined(&IEEE80211_WEP_MIXED);
	eval 'sub IEEE80211_IOC_WEPKEY () {4;}' unless defined(&IEEE80211_IOC_WEPKEY);
	eval 'sub IEEE80211_IOC_NUMWEPKEYS () {5;}' unless defined(&IEEE80211_IOC_NUMWEPKEYS);
	eval 'sub IEEE80211_IOC_WEPTXKEY () {6;}' unless defined(&IEEE80211_IOC_WEPTXKEY);
	eval 'sub IEEE80211_IOC_AUTHMODE () {7;}' unless defined(&IEEE80211_IOC_AUTHMODE);
	eval 'sub IEEE80211_IOC_STATIONNAME () {8;}' unless defined(&IEEE80211_IOC_STATIONNAME);
	eval 'sub IEEE80211_IOC_CHANNEL () {9;}' unless defined(&IEEE80211_IOC_CHANNEL);
	eval 'sub IEEE80211_IOC_POWERSAVE () {10;}' unless defined(&IEEE80211_IOC_POWERSAVE);
	eval 'sub IEEE80211_POWERSAVE_NOSUP () {-1;}' unless defined(&IEEE80211_POWERSAVE_NOSUP);
	eval 'sub IEEE80211_POWERSAVE_OFF () {0;}' unless defined(&IEEE80211_POWERSAVE_OFF);
	eval 'sub IEEE80211_POWERSAVE_CAM () {1;}' unless defined(&IEEE80211_POWERSAVE_CAM);
	eval 'sub IEEE80211_POWERSAVE_PSP () {2;}' unless defined(&IEEE80211_POWERSAVE_PSP);
	eval 'sub IEEE80211_POWERSAVE_PSP_CAM () {3;}' unless defined(&IEEE80211_POWERSAVE_PSP_CAM);
	eval 'sub IEEE80211_POWERSAVE_ON () { &IEEE80211_POWERSAVE_CAM;}' unless defined(&IEEE80211_POWERSAVE_ON);
	eval 'sub IEEE80211_IOC_POWERSAVESLEEP () {11;}' unless defined(&IEEE80211_IOC_POWERSAVESLEEP);
	eval 'sub IEEE80211_IOC_RTSTHRESHOLD () {12;}' unless defined(&IEEE80211_IOC_RTSTHRESHOLD);
	eval 'sub IEEE80211_IOC_PROTMODE () {13;}' unless defined(&IEEE80211_IOC_PROTMODE);
	eval 'sub IEEE80211_PROTMODE_OFF () {0;}' unless defined(&IEEE80211_PROTMODE_OFF);
	eval 'sub IEEE80211_PROTMODE_CTS () {1;}' unless defined(&IEEE80211_PROTMODE_CTS);
	eval 'sub IEEE80211_PROTMODE_RTSCTS () {2;}' unless defined(&IEEE80211_PROTMODE_RTSCTS);
	eval 'sub IEEE80211_IOC_TXPOWER () {14;}' unless defined(&IEEE80211_IOC_TXPOWER);
	eval 'sub IEEE80211_IOC_BSSID () {15;}' unless defined(&IEEE80211_IOC_BSSID);
	eval 'sub IEEE80211_IOC_ROAMING () {16;}' unless defined(&IEEE80211_IOC_ROAMING);
	eval 'sub IEEE80211_IOC_PRIVACY () {17;}' unless defined(&IEEE80211_IOC_PRIVACY);
	eval 'sub IEEE80211_IOC_DROPUNENCRYPTED () {18;}' unless defined(&IEEE80211_IOC_DROPUNENCRYPTED);
	eval 'sub IEEE80211_IOC_WPAKEY () {19;}' unless defined(&IEEE80211_IOC_WPAKEY);
	eval 'sub IEEE80211_IOC_DELKEY () {20;}' unless defined(&IEEE80211_IOC_DELKEY);
	eval 'sub IEEE80211_IOC_MLME () {21;}' unless defined(&IEEE80211_IOC_MLME);
	eval 'sub IEEE80211_IOC_COUNTERMEASURES () {25;}' unless defined(&IEEE80211_IOC_COUNTERMEASURES);
	eval 'sub IEEE80211_IOC_WPA () {26;}' unless defined(&IEEE80211_IOC_WPA);
	eval 'sub IEEE80211_IOC_CHANLIST () {27;}' unless defined(&IEEE80211_IOC_CHANLIST);
	eval 'sub IEEE80211_IOC_WME () {28;}' unless defined(&IEEE80211_IOC_WME);
	eval 'sub IEEE80211_IOC_HIDESSID () {29;}' unless defined(&IEEE80211_IOC_HIDESSID);
	eval 'sub IEEE80211_IOC_APBRIDGE () {30;}' unless defined(&IEEE80211_IOC_APBRIDGE);
	eval 'sub IEEE80211_IOC_WPAIE () {39;}' unless defined(&IEEE80211_IOC_WPAIE);
	eval 'sub IEEE80211_IOC_STA_STATS () {40;}' unless defined(&IEEE80211_IOC_STA_STATS);
	eval 'sub IEEE80211_IOC_MACCMD () {41;}' unless defined(&IEEE80211_IOC_MACCMD);
	eval 'sub IEEE80211_IOC_CHANINFO () {42;}' unless defined(&IEEE80211_IOC_CHANINFO);
	eval 'sub IEEE80211_IOC_TXPOWMAX () {43;}' unless defined(&IEEE80211_IOC_TXPOWMAX);
	eval 'sub IEEE80211_IOC_STA_TXPOW () {44;}' unless defined(&IEEE80211_IOC_STA_TXPOW);
	eval 'sub IEEE80211_IOC_WME_CWMIN () {46;}' unless defined(&IEEE80211_IOC_WME_CWMIN);
	eval 'sub IEEE80211_IOC_WME_CWMAX () {47;}' unless defined(&IEEE80211_IOC_WME_CWMAX);
	eval 'sub IEEE80211_IOC_WME_AIFS () {48;}' unless defined(&IEEE80211_IOC_WME_AIFS);
	eval 'sub IEEE80211_IOC_WME_TXOPLIMIT () {49;}' unless defined(&IEEE80211_IOC_WME_TXOPLIMIT);
	eval 'sub IEEE80211_IOC_WME_ACM () {50;}' unless defined(&IEEE80211_IOC_WME_ACM);
	eval 'sub IEEE80211_IOC_WME_ACKPOLICY () {51;}' unless defined(&IEEE80211_IOC_WME_ACKPOLICY);
	eval 'sub IEEE80211_IOC_DTIM_PERIOD () {52;}' unless defined(&IEEE80211_IOC_DTIM_PERIOD);
	eval 'sub IEEE80211_IOC_BEACON_INTERVAL () {53;}' unless defined(&IEEE80211_IOC_BEACON_INTERVAL);
	eval 'sub IEEE80211_IOC_ADDMAC () {54;}' unless defined(&IEEE80211_IOC_ADDMAC);
	eval 'sub IEEE80211_IOC_DELMAC () {55;}' unless defined(&IEEE80211_IOC_DELMAC);
	eval 'sub IEEE80211_IOC_PUREG () {56;}' unless defined(&IEEE80211_IOC_PUREG);
	eval 'sub IEEE80211_IOC_FF () {57;}' unless defined(&IEEE80211_IOC_FF);
	eval 'sub IEEE80211_IOC_TURBOP () {58;}' unless defined(&IEEE80211_IOC_TURBOP);
	eval 'sub IEEE80211_IOC_BGSCAN () {59;}' unless defined(&IEEE80211_IOC_BGSCAN);
	eval 'sub IEEE80211_IOC_BGSCAN_IDLE () {60;}' unless defined(&IEEE80211_IOC_BGSCAN_IDLE);
	eval 'sub IEEE80211_IOC_BGSCAN_INTERVAL () {61;}' unless defined(&IEEE80211_IOC_BGSCAN_INTERVAL);
	eval 'sub IEEE80211_IOC_SCANVALID () {65;}' unless defined(&IEEE80211_IOC_SCANVALID);
	eval 'sub IEEE80211_IOC_FRAGTHRESHOLD () {73;}' unless defined(&IEEE80211_IOC_FRAGTHRESHOLD);
	eval 'sub IEEE80211_IOC_BURST () {75;}' unless defined(&IEEE80211_IOC_BURST);
	eval 'sub IEEE80211_IOC_SCAN_RESULTS () {76;}' unless defined(&IEEE80211_IOC_SCAN_RESULTS);
	eval 'sub IEEE80211_IOC_BMISSTHRESHOLD () {77;}' unless defined(&IEEE80211_IOC_BMISSTHRESHOLD);
	eval 'sub IEEE80211_IOC_STA_INFO () {78;}' unless defined(&IEEE80211_IOC_STA_INFO);
	eval 'sub IEEE80211_IOC_WPAIE2 () {79;}' unless defined(&IEEE80211_IOC_WPAIE2);
	eval 'sub IEEE80211_IOC_CURCHAN () {80;}' unless defined(&IEEE80211_IOC_CURCHAN);
	eval 'sub IEEE80211_IOC_SHORTGI () {81;}' unless defined(&IEEE80211_IOC_SHORTGI);
	eval 'sub IEEE80211_IOC_AMPDU () {82;}' unless defined(&IEEE80211_IOC_AMPDU);
	eval 'sub IEEE80211_IOC_AMPDU_LIMIT () {83;}' unless defined(&IEEE80211_IOC_AMPDU_LIMIT);
	eval 'sub IEEE80211_IOC_AMPDU_DENSITY () {84;}' unless defined(&IEEE80211_IOC_AMPDU_DENSITY);
	eval 'sub IEEE80211_IOC_AMSDU () {85;}' unless defined(&IEEE80211_IOC_AMSDU);
	eval 'sub IEEE80211_IOC_AMSDU_LIMIT () {86;}' unless defined(&IEEE80211_IOC_AMSDU_LIMIT);
	eval 'sub IEEE80211_IOC_PUREN () {87;}' unless defined(&IEEE80211_IOC_PUREN);
	eval 'sub IEEE80211_IOC_DOTH () {88;}' unless defined(&IEEE80211_IOC_DOTH);
	eval 'sub IEEE80211_IOC_HTCOMPAT () {92;}' unless defined(&IEEE80211_IOC_HTCOMPAT);
	eval 'sub IEEE80211_IOC_DWDS () {93;}' unless defined(&IEEE80211_IOC_DWDS);
	eval 'sub IEEE80211_IOC_INACTIVITY () {94;}' unless defined(&IEEE80211_IOC_INACTIVITY);
	eval 'sub IEEE80211_IOC_APPIE () {95;}' unless defined(&IEEE80211_IOC_APPIE);
	eval 'sub IEEE80211_IOC_WPS () {96;}' unless defined(&IEEE80211_IOC_WPS);
	eval 'sub IEEE80211_IOC_TSN () {97;}' unless defined(&IEEE80211_IOC_TSN);
	eval 'sub IEEE80211_IOC_DEVCAPS () {98;}' unless defined(&IEEE80211_IOC_DEVCAPS);
	eval 'sub IEEE80211_IOC_CHANSWITCH () {99;}' unless defined(&IEEE80211_IOC_CHANSWITCH);
	eval 'sub IEEE80211_IOC_DFS () {100;}' unless defined(&IEEE80211_IOC_DFS);
	eval 'sub IEEE80211_IOC_DOTD () {101;}' unless defined(&IEEE80211_IOC_DOTD);
	eval 'sub IEEE80211_IOC_HTPROTMODE () {102;}' unless defined(&IEEE80211_IOC_HTPROTMODE);
	eval 'sub IEEE80211_IOC_SCAN_REQ () {103;}' unless defined(&IEEE80211_IOC_SCAN_REQ);
	eval 'sub IEEE80211_IOC_SCAN_CANCEL () {104;}' unless defined(&IEEE80211_IOC_SCAN_CANCEL);
	eval 'sub IEEE80211_IOC_HTCONF () {105;}' unless defined(&IEEE80211_IOC_HTCONF);
	eval 'sub IEEE80211_IOC_REGDOMAIN () {106;}' unless defined(&IEEE80211_IOC_REGDOMAIN);
	eval 'sub IEEE80211_IOC_ROAM () {107;}' unless defined(&IEEE80211_IOC_ROAM);
	eval 'sub IEEE80211_IOC_TXPARAMS () {108;}' unless defined(&IEEE80211_IOC_TXPARAMS);
	eval 'sub IEEE80211_IOC_STA_VLAN () {109;}' unless defined(&IEEE80211_IOC_STA_VLAN);
	eval 'sub IEEE80211_IOC_SMPS () {110;}' unless defined(&IEEE80211_IOC_SMPS);
	eval 'sub IEEE80211_IOC_RIFS () {111;}' unless defined(&IEEE80211_IOC_RIFS);
	eval 'sub IEEE80211_IOC_GREENFIELD () {112;}' unless defined(&IEEE80211_IOC_GREENFIELD);
	eval 'sub IEEE80211_IOC_STBC () {113;}' unless defined(&IEEE80211_IOC_STBC);
	eval 'sub IEEE80211_IOC_LDPC () {114;}' unless defined(&IEEE80211_IOC_LDPC);
	eval 'sub IEEE80211_IOC_MESH_ID () {170;}' unless defined(&IEEE80211_IOC_MESH_ID);
	eval 'sub IEEE80211_IOC_MESH_AP () {171;}' unless defined(&IEEE80211_IOC_MESH_AP);
	eval 'sub IEEE80211_IOC_MESH_FWRD () {172;}' unless defined(&IEEE80211_IOC_MESH_FWRD);
	eval 'sub IEEE80211_IOC_MESH_PROTO () {173;}' unless defined(&IEEE80211_IOC_MESH_PROTO);
	eval 'sub IEEE80211_IOC_MESH_TTL () {174;}' unless defined(&IEEE80211_IOC_MESH_TTL);
	eval 'sub IEEE80211_IOC_MESH_RTCMD () {175;}' unless defined(&IEEE80211_IOC_MESH_RTCMD);
	eval 'sub IEEE80211_IOC_MESH_PR_METRIC () {176;}' unless defined(&IEEE80211_IOC_MESH_PR_METRIC);
	eval 'sub IEEE80211_IOC_MESH_PR_PATH () {177;}' unless defined(&IEEE80211_IOC_MESH_PR_PATH);
	eval 'sub IEEE80211_IOC_MESH_PR_SIG () {178;}' unless defined(&IEEE80211_IOC_MESH_PR_SIG);
	eval 'sub IEEE80211_IOC_MESH_PR_CC () {179;}' unless defined(&IEEE80211_IOC_MESH_PR_CC);
	eval 'sub IEEE80211_IOC_MESH_PR_AUTH () {180;}' unless defined(&IEEE80211_IOC_MESH_PR_AUTH);
	eval 'sub IEEE80211_IOC_MESH_GATE () {181;}' unless defined(&IEEE80211_IOC_MESH_GATE);
	eval 'sub IEEE80211_IOC_HWMP_ROOTMODE () {190;}' unless defined(&IEEE80211_IOC_HWMP_ROOTMODE);
	eval 'sub IEEE80211_IOC_HWMP_MAXHOPS () {191;}' unless defined(&IEEE80211_IOC_HWMP_MAXHOPS);
	eval 'sub IEEE80211_IOC_HWMP_TTL () {192;}' unless defined(&IEEE80211_IOC_HWMP_TTL);
	eval 'sub IEEE80211_IOC_TDMA_SLOT () {201;}' unless defined(&IEEE80211_IOC_TDMA_SLOT);
	eval 'sub IEEE80211_IOC_TDMA_SLOTCNT () {202;}' unless defined(&IEEE80211_IOC_TDMA_SLOTCNT);
	eval 'sub IEEE80211_IOC_TDMA_SLOTLEN () {203;}' unless defined(&IEEE80211_IOC_TDMA_SLOTLEN);
	eval 'sub IEEE80211_IOC_TDMA_BINTERVAL () {204;}' unless defined(&IEEE80211_IOC_TDMA_BINTERVAL);
	eval 'sub IEEE80211_IOC_QUIET () {205;}' unless defined(&IEEE80211_IOC_QUIET);
	eval 'sub IEEE80211_IOC_QUIET_PERIOD () {206;}' unless defined(&IEEE80211_IOC_QUIET_PERIOD);
	eval 'sub IEEE80211_IOC_QUIET_OFFSET () {207;}' unless defined(&IEEE80211_IOC_QUIET_OFFSET);
	eval 'sub IEEE80211_IOC_QUIET_DUR () {208;}' unless defined(&IEEE80211_IOC_QUIET_DUR);
	eval 'sub IEEE80211_IOC_QUIET_COUNT () {209;}' unless defined(&IEEE80211_IOC_QUIET_COUNT);
	eval 'sub IEEE80211_IOC_SCAN_NOPICK () {0x1;}' unless defined(&IEEE80211_IOC_SCAN_NOPICK);
	eval 'sub IEEE80211_IOC_SCAN_ACTIVE () {0x2;}' unless defined(&IEEE80211_IOC_SCAN_ACTIVE);
	eval 'sub IEEE80211_IOC_SCAN_PICK1ST () {0x4;}' unless defined(&IEEE80211_IOC_SCAN_PICK1ST);
	eval 'sub IEEE80211_IOC_SCAN_BGSCAN () {0x8;}' unless defined(&IEEE80211_IOC_SCAN_BGSCAN);
	eval 'sub IEEE80211_IOC_SCAN_ONCE () {0x10;}' unless defined(&IEEE80211_IOC_SCAN_ONCE);
	eval 'sub IEEE80211_IOC_SCAN_NOBCAST () {0x20;}' unless defined(&IEEE80211_IOC_SCAN_NOBCAST);
	eval 'sub IEEE80211_IOC_SCAN_NOJOIN () {0x40;}' unless defined(&IEEE80211_IOC_SCAN_NOJOIN);
	eval 'sub IEEE80211_IOC_SCAN_FLUSH () {0x10000;}' unless defined(&IEEE80211_IOC_SCAN_FLUSH);
	eval 'sub IEEE80211_IOC_SCAN_CHECK () {0x20000;}' unless defined(&IEEE80211_IOC_SCAN_CHECK);
	eval 'sub IEEE80211_IOC_SCAN_DURATION_MIN () {1;}' unless defined(&IEEE80211_IOC_SCAN_DURATION_MIN);
	eval 'sub IEEE80211_IOC_SCAN_DURATION_MAX () {0x7fffffff;}' unless defined(&IEEE80211_IOC_SCAN_DURATION_MAX);
	eval 'sub IEEE80211_IOC_SCAN_FOREVER () { &IEEE80211_IOC_SCAN_DURATION_MAX;}' unless defined(&IEEE80211_IOC_SCAN_FOREVER);
	eval 'sub IEEE80211_IOC_SCAN_MAX_SSID () {3;}' unless defined(&IEEE80211_IOC_SCAN_MAX_SSID);
	eval 'sub IEEE80211_CLONE_BSSID () {0x1;}' unless defined(&IEEE80211_CLONE_BSSID);
	eval 'sub IEEE80211_CLONE_NOBEACONS () {0x2;}' unless defined(&IEEE80211_CLONE_NOBEACONS);
	eval 'sub IEEE80211_CLONE_WDSLEGACY () {0x4;}' unless defined(&IEEE80211_CLONE_WDSLEGACY);
	eval 'sub IEEE80211_CLONE_MACADDR () {0x8;}' unless defined(&IEEE80211_CLONE_MACADDR);
	eval 'sub IEEE80211_CLONE_TDMA () {0x10;}' unless defined(&IEEE80211_CLONE_TDMA);
    }
}
1;
