require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_MESH_H_)) {
    eval 'sub _NET80211_IEEE80211_MESH_H_ () {1;}' unless defined(&_NET80211_IEEE80211_MESH_H_);
    eval 'sub IEEE80211_MESH_DEFAULT_TTL () {31;}' unless defined(&IEEE80211_MESH_DEFAULT_TTL);
    eval 'sub IEEE80211_MESH_MAX_NEIGHBORS () {15;}' unless defined(&IEEE80211_MESH_MAX_NEIGHBORS);
    eval 'sub IEEE80211_MESH_CONF_SZ () {(7);}' unless defined(&IEEE80211_MESH_CONF_SZ);
    eval("sub IEEE80211_MESHCONF_PATH_HWMP () { 1; }") unless defined(&IEEE80211_MESHCONF_PATH_HWMP);
    eval("sub IEEE80211_MESHCONF_PATH_VENDOR () { 255; }") unless defined(&IEEE80211_MESHCONF_PATH_VENDOR);
    eval("sub IEEE80211_MESHCONF_METRIC_AIRTIME () { 1; }") unless defined(&IEEE80211_MESHCONF_METRIC_AIRTIME);
    eval("sub IEEE80211_MESHCONF_METRIC_VENDOR () { 255; }") unless defined(&IEEE80211_MESHCONF_METRIC_VENDOR);
    eval("sub IEEE80211_MESHCONF_CC_DISABLED () { 0; }") unless defined(&IEEE80211_MESHCONF_CC_DISABLED);
    eval("sub IEEE80211_MESHCONF_CC_SIG () { 1; }") unless defined(&IEEE80211_MESHCONF_CC_SIG);
    eval("sub IEEE80211_MESHCONF_CC_VENDOR () { 255; }") unless defined(&IEEE80211_MESHCONF_CC_VENDOR);
    eval("sub IEEE80211_MESHCONF_SYNC_NEIGHOFF () { 1; }") unless defined(&IEEE80211_MESHCONF_SYNC_NEIGHOFF);
    eval("sub IEEE80211_MESHCONF_SYNC_VENDOR () { 255; }") unless defined(&IEEE80211_MESHCONF_SYNC_VENDOR);
    eval("sub IEEE80211_MESHCONF_AUTH_DISABLED () { 0; }") unless defined(&IEEE80211_MESHCONF_AUTH_DISABLED);
    eval("sub IEEE80211_MESHCONF_AUTH_SEA () { 1; }") unless defined(&IEEE80211_MESHCONF_AUTH_SEA);
    eval("sub IEEE80211_MESHCONF_AUTH_8021X () { 2; }") unless defined(&IEEE80211_MESHCONF_AUTH_8021X);
    eval("sub IEEE80211_MESHCONF_AUTH_VENDOR () { 255; }") unless defined(&IEEE80211_MESHCONF_AUTH_VENDOR);
    eval 'sub IEEE80211_MESHCONF_FORM_GATE () {0x1;}' unless defined(&IEEE80211_MESHCONF_FORM_GATE);
    eval 'sub IEEE80211_MESHCONF_FORM_NNEIGH_MASK () {0x7e;}' unless defined(&IEEE80211_MESHCONF_FORM_NNEIGH_MASK);
    eval 'sub IEEE80211_MESHCONF_FORM_SA () {0xf0;}' unless defined(&IEEE80211_MESHCONF_FORM_SA);
    eval 'sub IEEE80211_MESHCONF_CAP_AP () {0x1;}' unless defined(&IEEE80211_MESHCONF_CAP_AP);
    eval 'sub IEEE80211_MESHCONF_CAP_MCCAS () {0x2;}' unless defined(&IEEE80211_MESHCONF_CAP_MCCAS);
    eval 'sub IEEE80211_MESHCONF_CAP_MCCAE () {0x4;}' unless defined(&IEEE80211_MESHCONF_CAP_MCCAE);
    eval 'sub IEEE80211_MESHCONF_CAP_FWRD () {0x8;}' unless defined(&IEEE80211_MESHCONF_CAP_FWRD);
    eval 'sub IEEE80211_MESHCONF_CAP_BTR () {0x10;}' unless defined(&IEEE80211_MESHCONF_CAP_BTR);
    eval 'sub IEEE80211_MESHCONF_CAP_TBTT () {0x20;}' unless defined(&IEEE80211_MESHCONF_CAP_TBTT);
    eval 'sub IEEE80211_MESHCONF_CAP_PSL () {0x40;}' unless defined(&IEEE80211_MESHCONF_CAP_PSL);
    eval 'sub IEEE80211_MESH_LMETRIC_FLAGS_REQ () {0x1;}' unless defined(&IEEE80211_MESH_LMETRIC_FLAGS_REQ);
    eval 'sub IEEE80211_MESHLMETRIC_INITIALVAL () {0;}' unless defined(&IEEE80211_MESHLMETRIC_INITIALVAL);
    eval 'sub IEEE80211_MPM_BASE_SZ () {(4);}' unless defined(&IEEE80211_MPM_BASE_SZ);
    eval 'sub IEEE80211_MPM_MAX_SZ () {(8);}' unless defined(&IEEE80211_MPM_MAX_SZ);
    eval("sub IEEE80211_MPPID_MPM () { 0; }") unless defined(&IEEE80211_MPPID_MPM);
    eval("sub IEEE80211_MPPID_AUTH_MPM () { 1; }") unless defined(&IEEE80211_MPPID_AUTH_MPM);
    if(defined(&notyet)) {
    }
    eval 'sub IEEE80211_MESHGANN_BASE_SZ () {(15);}' unless defined(&IEEE80211_MESHGANN_BASE_SZ);
    eval 'sub IEEE80211_MESHRANN_BASE_SZ () {(21);}' unless defined(&IEEE80211_MESHRANN_BASE_SZ);
    eval 'sub IEEE80211_MESHRANN_FLAGS_GATE () {0x1;}' unless defined(&IEEE80211_MESHRANN_FLAGS_GATE);
    eval 'sub IEEE80211_MESHPREQ_BASE_SZ () {(26);}' unless defined(&IEEE80211_MESHPREQ_BASE_SZ);
    eval 'sub IEEE80211_MESHPREQ_BASE_SZ_AE () {(32);}' unless defined(&IEEE80211_MESHPREQ_BASE_SZ_AE);
    eval 'sub IEEE80211_MESHPREQ_TRGT_SZ () {(11);}' unless defined(&IEEE80211_MESHPREQ_TRGT_SZ);
    eval 'sub IEEE80211_MESHPREQ_TCNT_OFFSET () {(27);}' unless defined(&IEEE80211_MESHPREQ_TCNT_OFFSET);
    eval 'sub IEEE80211_MESHPREQ_TCNT_OFFSET_AE () {(33);}' unless defined(&IEEE80211_MESHPREQ_TCNT_OFFSET_AE);
    eval 'sub IEEE80211_MESHPREQ_FLAGS_GATE () {0x1;}' unless defined(&IEEE80211_MESHPREQ_FLAGS_GATE);
    eval 'sub IEEE80211_MESHPREQ_FLAGS_AM () {0x2;}' unless defined(&IEEE80211_MESHPREQ_FLAGS_AM);
    eval 'sub IEEE80211_MESHPREQ_FLAGS_PP () {0x4;}' unless defined(&IEEE80211_MESHPREQ_FLAGS_PP);
    eval 'sub IEEE80211_MESHPREQ_FLAGS_AE () {0x40;}' unless defined(&IEEE80211_MESHPREQ_FLAGS_AE);
    eval 'sub IEEE80211_MESHPREQ_TFLAGS_TO () {0x1;}' unless defined(&IEEE80211_MESHPREQ_TFLAGS_TO);
    eval 'sub IEEE80211_MESHPREQ_TFLAGS_USN () {0x4;}' unless defined(&IEEE80211_MESHPREQ_TFLAGS_USN);
    eval 'sub IEEE80211_MESHPREP_BASE_SZ () {(31);}' unless defined(&IEEE80211_MESHPREP_BASE_SZ);
    eval 'sub IEEE80211_MESHPREP_BASE_SZ_AE () {(37);}' unless defined(&IEEE80211_MESHPREP_BASE_SZ_AE);
    eval 'sub IEEE80211_MESHPREP_FLAGS_AE () {0x40;}' unless defined(&IEEE80211_MESHPREP_FLAGS_AE);
    eval 'sub IEEE80211_MESHPERR_MAXDEST () {(19);}' unless defined(&IEEE80211_MESHPERR_MAXDEST);
    eval 'sub IEEE80211_MESHPERR_NDEST_OFFSET () {(3);}' unless defined(&IEEE80211_MESHPERR_NDEST_OFFSET);
    eval 'sub IEEE80211_MESHPERR_BASE_SZ () {(2);}' unless defined(&IEEE80211_MESHPERR_BASE_SZ);
    eval 'sub IEEE80211_MESHPERR_DEST_SZ () {(13);}' unless defined(&IEEE80211_MESHPERR_DEST_SZ);
    eval 'sub IEEE80211_MESHPERR_DEST_SZ_AE () {(19);}' unless defined(&IEEE80211_MESHPERR_DEST_SZ_AE);
    eval 'sub IEEE80211_MESHPERR_DFLAGS_USN () {0x1;}' unless defined(&IEEE80211_MESHPERR_DFLAGS_USN);
    eval 'sub IEEE80211_MESHPERR_DFLAGS_RC () {0x2;}' unless defined(&IEEE80211_MESHPERR_DFLAGS_RC);
    eval 'sub IEEE80211_MESHPERR_FLAGS_AE () {0x40;}' unless defined(&IEEE80211_MESHPERR_FLAGS_AE);
    if(defined(&notyet)) {
	eval 'sub IEEE80211_MESHPU_FLAGS_MASK () {0x1;}' unless defined(&IEEE80211_MESHPU_FLAGS_MASK);
	eval 'sub IEEE80211_MESHPU_FLAGS_DEL () {0x;}' unless defined(&IEEE80211_MESHPU_FLAGS_DEL);
	eval 'sub IEEE80211_MESHPU_FLAGS_ADD () {0x1;}' unless defined(&IEEE80211_MESHPU_FLAGS_ADD);
    }
    eval 'sub IEEE80211_ACTION_CAT_INTERWORK () {15;}' unless defined(&IEEE80211_ACTION_CAT_INTERWORK);
    eval 'sub IEEE80211_ACTION_CAT_RESOURCE () {16;}' unless defined(&IEEE80211_ACTION_CAT_RESOURCE);
    eval 'sub IEEE80211_ACTION_CAT_PROXY () {17;}' unless defined(&IEEE80211_ACTION_CAT_PROXY);
    eval("sub IEEE80211_ACTION_MESHPEERING_OPEN () { 1; }") unless defined(&IEEE80211_ACTION_MESHPEERING_OPEN);
    eval("sub IEEE80211_ACTION_MESHPEERING_CONFIRM () { 2; }") unless defined(&IEEE80211_ACTION_MESHPEERING_CONFIRM);
    eval("sub IEEE80211_ACTION_MESHPEERING_CLOSE () { 3; }") unless defined(&IEEE80211_ACTION_MESHPEERING_CLOSE);
    eval("sub IEEE80211_ACTION_MESH_LMETRIC () { 0; }") unless defined(&IEEE80211_ACTION_MESH_LMETRIC);
    eval("sub IEEE80211_ACTION_MESH_HWMP () { 1; }") unless defined(&IEEE80211_ACTION_MESH_HWMP);
    eval("sub IEEE80211_ACTION_MESH_GANN () { 2; }") unless defined(&IEEE80211_ACTION_MESH_GANN);
    eval("sub IEEE80211_ACTION_MESH_CC () { 3; }") unless defined(&IEEE80211_ACTION_MESH_CC);
    eval("sub IEEE80211_ACTION_MESH_MCCA_SREQ () { 4; }") unless defined(&IEEE80211_ACTION_MESH_MCCA_SREQ);
    eval("sub IEEE80211_ACTION_MESH_MCCA_SREP () { 5; }") unless defined(&IEEE80211_ACTION_MESH_MCCA_SREP);
    eval("sub IEEE80211_ACTION_MESH_MCCA_AREQ () { 6; }") unless defined(&IEEE80211_ACTION_MESH_MCCA_AREQ);
    eval("sub IEEE80211_ACTION_MESH_MCCA_ADVER () { 7; }") unless defined(&IEEE80211_ACTION_MESH_MCCA_ADVER);
    eval("sub IEEE80211_ACTION_MESH_MCCA_TRDOWN () { 8; }") unless defined(&IEEE80211_ACTION_MESH_MCCA_TRDOWN);
    eval("sub IEEE80211_ACTION_MESH_TBTT_REQ () { 9; }") unless defined(&IEEE80211_ACTION_MESH_TBTT_REQ);
    eval("sub IEEE80211_ACTION_MESH_TBTT_RES () { 10; }") unless defined(&IEEE80211_ACTION_MESH_TBTT_RES);
    eval 'sub IEEE80211_MESH_AE_MASK () {0x3;}' unless defined(&IEEE80211_MESH_AE_MASK);
    eval("sub IEEE80211_MESH_AE_00 () { 0; }") unless defined(&IEEE80211_MESH_AE_00);
    eval("sub IEEE80211_MESH_AE_01 () { 1; }") unless defined(&IEEE80211_MESH_AE_01);
    eval("sub IEEE80211_MESH_AE_10 () { 2; }") unless defined(&IEEE80211_MESH_AE_10);
    eval("sub IEEE80211_MESH_AE_11 () { 3; }") unless defined(&IEEE80211_MESH_AE_11);
    if(defined(&_KERNEL)) {
	eval 'sub IEEE80211_MESHRT_FLAGS_DISCOVER () {0x1;}' unless defined(&IEEE80211_MESHRT_FLAGS_DISCOVER);
	eval 'sub IEEE80211_MESHRT_FLAGS_VALID () {0x2;}' unless defined(&IEEE80211_MESHRT_FLAGS_VALID);
	eval 'sub IEEE80211_MESHRT_FLAGS_PROXY () {0x4;}' unless defined(&IEEE80211_MESHRT_FLAGS_PROXY);
	eval 'sub IEEE80211_MESHRT_FLAGS_GATE () {0x8;}' unless defined(&IEEE80211_MESHRT_FLAGS_GATE);
	eval 'sub IEEE80211_MESH_ROUTE_PRIV {
	    my($rt, $cast) = @_;
    	    eval q((($cast *) ($rt->{rt_priv})));
	}' unless defined(&IEEE80211_MESH_ROUTE_PRIV);
	eval 'sub IEEE80211_MESH_PROTO_DSZ () {12;}' unless defined(&IEEE80211_MESH_PROTO_DSZ);
	if(defined(&notyet)) {
	}
	eval 'sub IEEE80211_MESH_SEQ_LEQ {
	    my($a, $b) = @_;
    	    eval q((( &int32_t)(($a)-($b)) <= 0));
	}' unless defined(&IEEE80211_MESH_SEQ_LEQ);
	eval 'sub IEEE80211_MESH_SEQ_GEQ {
	    my($a, $b) = @_;
    	    eval q((( &int32_t)(($a)-($b)) >= 0));
	}' unless defined(&IEEE80211_MESH_SEQ_GEQ);
	eval 'sub IEEE80211_MESHFLAGS_AP () {0x1;}' unless defined(&IEEE80211_MESHFLAGS_AP);
	eval 'sub IEEE80211_MESHFLAGS_GATE () {0x2;}' unless defined(&IEEE80211_MESHFLAGS_GATE);
	eval 'sub IEEE80211_MESHFLAGS_FWD () {0x4;}' unless defined(&IEEE80211_MESHFLAGS_FWD);
	eval 'sub IEEE80211_MESHFLAGS_ROOT () {0x8;}' unless defined(&IEEE80211_MESHFLAGS_ROOT);
    }
}
1;
