require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_NODE_H_)) {
    eval 'sub _NET80211_IEEE80211_NODE_H_ () {1;}' unless defined(&_NET80211_IEEE80211_NODE_H_);
    require 'net80211/ieee80211_ioctl.ph';
    require 'net80211/ieee80211_ht.ph';
    eval 'sub IEEE80211_INACT_WAIT () {15;}' unless defined(&IEEE80211_INACT_WAIT);
    eval 'sub IEEE80211_INACT_INIT () {(30/ &IEEE80211_INACT_WAIT);}' unless defined(&IEEE80211_INACT_INIT);
    eval 'sub IEEE80211_INACT_AUTH () {(180/ &IEEE80211_INACT_WAIT);}' unless defined(&IEEE80211_INACT_AUTH);
    eval 'sub IEEE80211_INACT_RUN () {(300/ &IEEE80211_INACT_WAIT);}' unless defined(&IEEE80211_INACT_RUN);
    eval 'sub IEEE80211_INACT_PROBE () {(30/ &IEEE80211_INACT_WAIT);}' unless defined(&IEEE80211_INACT_PROBE);
    eval 'sub IEEE80211_INACT_SCAN () {(300/ &IEEE80211_INACT_WAIT);}' unless defined(&IEEE80211_INACT_SCAN);
    eval 'sub IEEE80211_TRANS_WAIT () {2;}' unless defined(&IEEE80211_TRANS_WAIT);
    eval 'sub IEEE80211_NONERP_PRESENT_AGE () { &msecs_to_ticks(60*1000);}' unless defined(&IEEE80211_NONERP_PRESENT_AGE);
    eval 'sub IEEE80211_NODE_HASHSIZE () {32;}' unless defined(&IEEE80211_NODE_HASHSIZE);
    eval 'sub IEEE80211_NODE_HASH {
        my($ic, $addr) = @_;
	    eval q(((( &const  &uint8_t *)($addr))[ &IEEE80211_ADDR_LEN - 1] %  &IEEE80211_NODE_HASHSIZE));
    }' unless defined(&IEEE80211_NODE_HASH);
    eval("sub IEEE80211_NODE_MESH_IDLE () { 0; }") unless defined(&IEEE80211_NODE_MESH_IDLE);
    eval("sub IEEE80211_NODE_MESH_OPENSNT () { 1; }") unless defined(&IEEE80211_NODE_MESH_OPENSNT);
    eval("sub IEEE80211_NODE_MESH_OPENRCV () { 2; }") unless defined(&IEEE80211_NODE_MESH_OPENRCV);
    eval("sub IEEE80211_NODE_MESH_CONFIRMRCV () { 3; }") unless defined(&IEEE80211_NODE_MESH_CONFIRMRCV);
    eval("sub IEEE80211_NODE_MESH_ESTABLISHED () { 4; }") unless defined(&IEEE80211_NODE_MESH_ESTABLISHED);
    eval("sub IEEE80211_NODE_MESH_HOLDING () { 5; }") unless defined(&IEEE80211_NODE_MESH_HOLDING);
    eval 'sub IEEE80211_MESH_MLSTATE_BITS () {"\\20\\1IDLE\\2OPENSNT\\2OPENRCV\\3CONFIRMRCV\\4ESTABLISHED\\5HOLDING";}' unless defined(&IEEE80211_MESH_MLSTATE_BITS);
    eval 'sub IEEE80211_NODE_AUTH () {0x1;}' unless defined(&IEEE80211_NODE_AUTH);
    eval 'sub IEEE80211_NODE_QOS () {0x2;}' unless defined(&IEEE80211_NODE_QOS);
    eval 'sub IEEE80211_NODE_ERP () {0x4;}' unless defined(&IEEE80211_NODE_ERP);
    eval 'sub IEEE80211_NODE_PWR_MGT () {0x10;}' unless defined(&IEEE80211_NODE_PWR_MGT);
    eval 'sub IEEE80211_NODE_AREF () {0x20;}' unless defined(&IEEE80211_NODE_AREF);
    eval 'sub IEEE80211_NODE_HT () {0x40;}' unless defined(&IEEE80211_NODE_HT);
    eval 'sub IEEE80211_NODE_HTCOMPAT () {0x80;}' unless defined(&IEEE80211_NODE_HTCOMPAT);
    eval 'sub IEEE80211_NODE_WPS () {0x100;}' unless defined(&IEEE80211_NODE_WPS);
    eval 'sub IEEE80211_NODE_TSN () {0x200;}' unless defined(&IEEE80211_NODE_TSN);
    eval 'sub IEEE80211_NODE_AMPDU_RX () {0x400;}' unless defined(&IEEE80211_NODE_AMPDU_RX);
    eval 'sub IEEE80211_NODE_AMPDU_TX () {0x800;}' unless defined(&IEEE80211_NODE_AMPDU_TX);
    eval 'sub IEEE80211_NODE_MIMO_PS () {0x1000;}' unless defined(&IEEE80211_NODE_MIMO_PS);
    eval 'sub IEEE80211_NODE_MIMO_RTS () {0x2000;}' unless defined(&IEEE80211_NODE_MIMO_RTS);
    eval 'sub IEEE80211_NODE_RIFS () {0x4000;}' unless defined(&IEEE80211_NODE_RIFS);
    eval 'sub IEEE80211_NODE_SGI20 () {0x8000;}' unless defined(&IEEE80211_NODE_SGI20);
    eval 'sub IEEE80211_NODE_SGI40 () {0x10000;}' unless defined(&IEEE80211_NODE_SGI40);
    eval 'sub IEEE80211_NODE_ASSOCID () {0x20000;}' unless defined(&IEEE80211_NODE_ASSOCID);
    eval 'sub IEEE80211_NODE_AMSDU_RX () {0x40000;}' unless defined(&IEEE80211_NODE_AMSDU_RX);
    eval 'sub IEEE80211_NODE_AMSDU_TX () {0x80000;}' unless defined(&IEEE80211_NODE_AMSDU_TX);
    eval 'sub IEEE80211_NODE_TURBOP () {0x1;}' unless defined(&IEEE80211_NODE_TURBOP);
    eval 'sub IEEE80211_NODE_COMP () {0x2;}' unless defined(&IEEE80211_NODE_COMP);
    eval 'sub IEEE80211_NODE_FF () {0x4;}' unless defined(&IEEE80211_NODE_FF);
    eval 'sub IEEE80211_NODE_XR () {0x8;}' unless defined(&IEEE80211_NODE_XR);
    eval 'sub IEEE80211_NODE_AR () {0x10;}' unless defined(&IEEE80211_NODE_AR);
    eval 'sub IEEE80211_NODE_BOOST () {0x80;}' unless defined(&IEEE80211_NODE_BOOST);
    eval 'sub IEEE80211_NODE_ATH () {( &IEEE80211_NODE_FF |  &IEEE80211_NODE_TURBOP);}' unless defined(&IEEE80211_NODE_ATH);
    eval 'sub IEEE80211_NODE_AMPDU () {( &IEEE80211_NODE_AMPDU_RX |  &IEEE80211_NODE_AMPDU_TX);}' unless defined(&IEEE80211_NODE_AMPDU);
    eval 'sub IEEE80211_NODE_AMSDU () {( &IEEE80211_NODE_AMSDU_RX |  &IEEE80211_NODE_AMSDU_TX);}' unless defined(&IEEE80211_NODE_AMSDU);
    eval 'sub IEEE80211_NODE_HT_ALL () {( &IEEE80211_NODE_HT |  &IEEE80211_NODE_HTCOMPAT |  &IEEE80211_NODE_AMPDU |  &IEEE80211_NODE_AMSDU |  &IEEE80211_NODE_MIMO_PS |  &IEEE80211_NODE_MIMO_RTS |  &IEEE80211_NODE_RIFS |  &IEEE80211_NODE_SGI20 |  &IEEE80211_NODE_SGI40);}' unless defined(&IEEE80211_NODE_HT_ALL);
    eval 'sub IEEE80211_NODE_BITS () {"\\20\\1AUTH\\2QOS\\3ERP\\5PWR_MGT\\6AREF\\7HT\\10HTCOMPAT\\11WPS\\12TSN" "\\13AMPDU_RX\\14AMPDU_TX\\15MIMO_PS\\16MIMO_RTS\\17RIFS\\20SGI20\\21SGI40" "\\22ASSOCID";}' unless defined(&IEEE80211_NODE_BITS);
    eval 'sub IEEE80211_NODE_AID {
        my($ni) = @_;
	    eval q( &IEEE80211_AID( ($ni->{ni_associd})));
    }' unless defined(&IEEE80211_NODE_AID);
    eval 'sub IEEE80211_NODE_STAT {
        my($ni,$stat) = @_;
	    eval q(( ($ni->{ni_stats}->{ns_})$stat++));
    }' unless defined(&IEEE80211_NODE_STAT);
    eval 'sub IEEE80211_NODE_STAT_ADD {
        my($ni,$stat,$v) = @_;
	    eval q(( ($ni->{ni_stats}->{ns_})$stat += $v));
    }' unless defined(&IEEE80211_NODE_STAT_ADD);
    eval 'sub IEEE80211_NODE_STAT_SET {
        my($ni,$stat,$v) = @_;
	    eval q(( ($ni->{ni_stats}->{ns_})$stat = $v));
    }' unless defined(&IEEE80211_NODE_STAT_SET);
    eval 'sub IEEE80211_RSSI_LPF_LEN () {10;}' unless defined(&IEEE80211_RSSI_LPF_LEN);
    eval 'sub IEEE80211_RSSI_DUMMY_MARKER () {127;}' unless defined(&IEEE80211_RSSI_DUMMY_MARKER);
    eval 'sub IEEE80211_RSSI_EP_MULTIPLIER () {(1<<7);}' unless defined(&IEEE80211_RSSI_EP_MULTIPLIER);
    eval 'sub IEEE80211_RSSI_IN {
        my($x) = @_;
	    eval q((($x) *  &IEEE80211_RSSI_EP_MULTIPLIER));
    }' unless defined(&IEEE80211_RSSI_IN);
    eval 'sub _IEEE80211_RSSI_LPF {
        my($x, $y, $len) = @_;
	    eval q(((($x) !=  &IEEE80211_RSSI_DUMMY_MARKER) ? ((($x) * (($len) - 1) + ($y)) / ($len)) : ($y)));
    }' unless defined(&_IEEE80211_RSSI_LPF);
    eval 'sub IEEE80211_RSSI_LPF {
        my($x, $y) = @_;
	    eval q( &do {  &if (($y) >= -20) { $x =  &_IEEE80211_RSSI_LPF(($x),  &IEEE80211_RSSI_IN(($y)),  &IEEE80211_RSSI_LPF_LEN); } }  &while (0));
    }' unless defined(&IEEE80211_RSSI_LPF);
    eval 'sub IEEE80211_RSSI_EP_RND {
        my($x, $mul) = @_;
	    eval q((((($x) % ($mul)) >= (($mul)/2)) ? (($x) + (($mul) - 1)) / ($mul) : ($x)/($mul)));
    }' unless defined(&IEEE80211_RSSI_EP_RND);
    eval 'sub IEEE80211_RSSI_GET {
        my($x) = @_;
	    eval q( &IEEE80211_RSSI_EP_RND($x,  &IEEE80211_RSSI_EP_MULTIPLIER));
    }' unless defined(&IEEE80211_RSSI_GET);
    eval 'sub ieee80211_ref_node {
        my($ni) = @_;
	    eval q({  &ieee80211_node_incref($ni); $ni; });
    }' unless defined(&ieee80211_ref_node);
    eval 'sub ieee80211_unref_node {
        my($ni) = @_;
	    eval q({  &ieee80211_node_decref(*$ni); *$ni =  &NULL; });
    }' unless defined(&ieee80211_unref_node);
    eval 'sub ieee80211_node_is_authorized {
        my($ni) = @_;
	    eval q({ ( ($ni->{ni_flags}) &  &IEEE80211_NODE_AUTH); });
    }' unless defined(&ieee80211_node_is_authorized);
    eval 'sub ieee80211_ies_setie {
        my($_ies, $_ie, $_off) = @_;
	    eval q( &do { ($_ies).$_ie = ($_ies). &data + ($_off); }  &while (0));
    }' unless defined(&ieee80211_ies_setie);
    if(defined(&IEEE80211_DEBUG_REFCNT)) {
	eval 'sub ieee80211_free_node {
	    my($ni) = @_;
    	    eval q( &ieee80211_free_node_debug($ni,  &__func__,  &__LINE__));
	}' unless defined(&ieee80211_free_node);
	eval 'sub ieee80211_find_node_locked {
	    my($nt, $mac) = @_;
    	    eval q( &ieee80211_find_node_locked_debug($nt, $mac,  &__func__,  &__LINE__));
	}' unless defined(&ieee80211_find_node_locked);
	eval 'sub ieee80211_find_node {
	    my($nt, $mac) = @_;
    	    eval q( &ieee80211_find_node_debug($nt, $mac,  &__func__,  &__LINE__));
	}' unless defined(&ieee80211_find_node);
	eval 'sub ieee80211_find_vap_node_locked {
	    my($nt, $vap, $mac) = @_;
    	    eval q( &ieee80211_find_vap_node_locked_debug($nt, $vap, $mac,  &__func__,  &__LINE__));
	}' unless defined(&ieee80211_find_vap_node_locked);
	eval 'sub ieee80211_find_vap_node {
	    my($nt, $vap, $mac) = @_;
    	    eval q( &ieee80211_find_vap_node_debug($nt, $vap, $mac,  &__func__,  &__LINE__));
	}' unless defined(&ieee80211_find_vap_node);
	eval 'sub ieee80211_find_rxnode {
	    my($ic, $wh) = @_;
    	    eval q( &ieee80211_find_rxnode_debug($ic, $wh,  &__func__,  &__LINE__));
	}' unless defined(&ieee80211_find_rxnode);
	eval 'sub ieee80211_find_rxnode_withkey {
	    my($ic, $wh, $keyix) = @_;
    	    eval q( &ieee80211_find_rxnode_withkey_debug($ic, $wh, $keyix,  &__func__,  &__LINE__));
	}' unless defined(&ieee80211_find_rxnode_withkey);
	eval 'sub ieee80211_find_txnode {
	    my($vap, $mac) = @_;
    	    eval q( &ieee80211_find_txnode_debug($vap, $mac,  &__func__,  &__LINE__));
	}' unless defined(&ieee80211_find_txnode);
    } else {
    }
}
1;
