require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_PHY_H_)) {
    eval 'sub _NET80211_IEEE80211_PHY_H_ () {1;}' unless defined(&_NET80211_IEEE80211_PHY_H_);
    if(defined(&_KERNEL)) {
	eval 'sub IEEE80211_CW_MAX () {1023;}' unless defined(&IEEE80211_CW_MAX);
	eval 'sub IEEE80211_CW_MIN_0 () {31;}' unless defined(&IEEE80211_CW_MIN_0);
	eval 'sub IEEE80211_CW_MIN_1 () {15;}' unless defined(&IEEE80211_CW_MIN_1);
	eval 'sub IEEE80211_DUR_SIFS () {10;}' unless defined(&IEEE80211_DUR_SIFS);
	eval 'sub IEEE80211_DUR_OFDM_SIFS () {16;}' unless defined(&IEEE80211_DUR_OFDM_SIFS);
	eval 'sub IEEE80211_DUR_SLOT () {20;}' unless defined(&IEEE80211_DUR_SLOT);
	eval 'sub IEEE80211_DUR_SHSLOT () {9;}' unless defined(&IEEE80211_DUR_SHSLOT);
	eval 'sub IEEE80211_DUR_OFDM_SLOT () {9;}' unless defined(&IEEE80211_DUR_OFDM_SLOT);
	eval 'sub IEEE80211_GET_SLOTTIME {
	    my($ic) = @_;
    	    eval q((( ($ic->{ic_flags}) &  &IEEE80211_F_SHSLOT) ?  &IEEE80211_DUR_SHSLOT :  &IEEE80211_DUR_SLOT));
	}' unless defined(&IEEE80211_GET_SLOTTIME);
	eval 'sub IEEE80211_DUR_DIFS {
	    my($sifs, $slot) = @_;
    	    eval q((($sifs) + 2* ($slot)));
	}' unless defined(&IEEE80211_DUR_DIFS);
	eval 'sub IEEE80211_RATE_TABLE_SIZE () {128;}' unless defined(&IEEE80211_RATE_TABLE_SIZE);
	eval 'sub ieee80211_ack_rate {
	    my($rt,$rate) = @_;
    	    eval q({  &KASSERT(! ($rate & 0x80), (\\"rate %d is basic/mcs?\\", $rate));  &uint8_t  &cix =  ($rt->{info[$rt}->{rateCodeToIndex[$rate & IEEE80211_RATE_VAL]})]. &ctlRateIndex;  &KASSERT( &cix != ( &uint8_t)-1, (\\"rate %d has no info\\", $rate));  ($rt->{info[&cix]}->{dot11Rate}); });
	}' unless defined(&ieee80211_ack_rate);
	eval 'sub ieee80211_ctl_rate {
	    my($rt,$rate) = @_;
    	    eval q({  &KASSERT(! ($rate & 0x80), (\\"rate %d is basic/mcs?\\", $rate));  &uint8_t  &cix =  ($rt->{info[$rt}->{rateCodeToIndex[$rate & IEEE80211_RATE_VAL]})]. &ctlRateIndex;  &KASSERT( &cix != ( &uint8_t)-1, (\\"rate %d has no info\\", $rate));  ($rt->{info[&cix]}->{dot11Rate}); });
	}' unless defined(&ieee80211_ctl_rate);
	eval 'sub ieee80211_rate2phytype {
	    my($rt,$rate) = @_;
    	    eval q({  &KASSERT(! ($rate & 0x80), (\\"rate %d is basic/mcs?\\", $rate));  &uint8_t  &rix =  ($rt->{rateCodeToIndex[$rate & IEEE80211_RATE_VAL]});  &KASSERT( &rix != ( &uint8_t)-1, (\\"rate %d has no info\\", $rate));  ($rt->{info[&rix]}->{phy}); });
	}' unless defined(&ieee80211_rate2phytype);
	eval 'sub ieee80211_isratevalid {
	    my($rt,$rate) = @_;
    	    eval q({  &KASSERT(! ($rate & 0x80), (\\"rate %d is basic/mcs?\\", $rate));  ($rt->{rateCodeToIndex[$rate]}) != ( &uint8_t)-1; });
	}' unless defined(&ieee80211_isratevalid);
	eval 'sub ieee80211_legacy_rate_lookup {
	    my($rt,$rate) = @_;
    	    eval q({ ( ($rt->{rateCodeToIndex[$rate & IEEE80211_RATE_VAL]})); });
	}' unless defined(&ieee80211_legacy_rate_lookup);
	eval 'sub IEEE80211_HT_RC_2_MCS {
	    my($_rc) = @_;
    	    eval q((($_rc) & 0x1f));
	}' unless defined(&IEEE80211_HT_RC_2_MCS);
	eval 'sub IEEE80211_HT_RC_2_STREAMS {
	    my($_rc) = @_;
    	    eval q((((($_rc) & 0x78) >> 3) + 1));
	}' unless defined(&IEEE80211_HT_RC_2_STREAMS);
	eval 'sub IEEE80211_IS_HT_RATE {
	    my($_rc) = @_;
    	    eval q(( ($_rc) &  &IEEE80211_RATE_MCS));
	}' unless defined(&IEEE80211_IS_HT_RATE);
    }
}
1;
