require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_PROTO_H_)) {
    eval 'sub _NET80211_IEEE80211_PROTO_H_ () {1;}' unless defined(&_NET80211_IEEE80211_PROTO_H_);
    eval("sub IEEE80211_S_INIT () { 0; }") unless defined(&IEEE80211_S_INIT);
    eval("sub IEEE80211_S_SCAN () { 1; }") unless defined(&IEEE80211_S_SCAN);
    eval("sub IEEE80211_S_AUTH () { 2; }") unless defined(&IEEE80211_S_AUTH);
    eval("sub IEEE80211_S_ASSOC () { 3; }") unless defined(&IEEE80211_S_ASSOC);
    eval("sub IEEE80211_S_CAC () { 4; }") unless defined(&IEEE80211_S_CAC);
    eval("sub IEEE80211_S_RUN () { 5; }") unless defined(&IEEE80211_S_RUN);
    eval("sub IEEE80211_S_CSA () { 6; }") unless defined(&IEEE80211_S_CSA);
    eval("sub IEEE80211_S_SLEEP () { 7; }") unless defined(&IEEE80211_S_SLEEP);
    eval 'sub IEEE80211_S_MAX () {( &IEEE80211_S_SLEEP+1);}' unless defined(&IEEE80211_S_MAX);
    eval 'sub IEEE80211_SEND_MGMT {
        my($_ni,$_type,$_arg) = @_;
	    eval q(((*($_ni)-> ($ni_ic->{ic_send_mgmt}))($_ni, $_type, $_arg)));
    }' unless defined(&IEEE80211_SEND_MGMT);
    eval 'sub ieee80211_mgt_subtype_name {
        my($subtype) = @_;
	    eval q({  $mgt_subtype_name[($subtype &  &IEEE80211_FC0_SUBTYPE_MASK) >>  &IEEE80211_FC0_SUBTYPE_SHIFT]; });
    }' unless defined(&ieee80211_mgt_subtype_name);
    eval 'sub ieee80211_ctl_subtype_name {
        my($subtype) = @_;
	    eval q({  $ctl_subtype_name[($subtype &  &IEEE80211_FC0_SUBTYPE_MASK) >>  &IEEE80211_FC0_SUBTYPE_SHIFT]; });
    }' unless defined(&ieee80211_ctl_subtype_name);
    eval 'sub ieee80211_input {
        my($ni, $m, $rssi, $nf) = @_;
	    eval q((($ni)-> ($ni_vap->{iv_input})($ni, $m,  &NULL, $rssi, $nf)));
    }' unless defined(&ieee80211_input);
    eval 'sub IEEE80211_SEND_LEGACY_11B () {0x1;}' unless defined(&IEEE80211_SEND_LEGACY_11B);
    eval 'sub IEEE80211_SEND_LEGACY_11 () {0x2;}' unless defined(&IEEE80211_SEND_LEGACY_11);
    eval 'sub IEEE80211_SEND_LEGACY () {0x3;}' unless defined(&IEEE80211_SEND_LEGACY);
    eval 'sub IEEE80211_F_DOSORT () {0x1;}' unless defined(&IEEE80211_F_DOSORT);
    eval 'sub IEEE80211_F_DOFRATE () {0x2;}' unless defined(&IEEE80211_F_DOFRATE);
    eval 'sub IEEE80211_F_DONEGO () {0x4;}' unless defined(&IEEE80211_F_DONEGO);
    eval 'sub IEEE80211_F_DODEL () {0x8;}' unless defined(&IEEE80211_F_DODEL);
    eval 'sub IEEE80211_F_DOBRS () {0x10;}' unless defined(&IEEE80211_F_DOBRS);
    eval 'sub IEEE80211_F_JOIN () {0x20;}' unless defined(&IEEE80211_F_JOIN);
    eval 'sub IEEE80211_F_DOFMCS () {0x40;}' unless defined(&IEEE80211_F_DOFMCS);
    eval 'sub IEEE80211_TXOP_TO_US {
        my($_txop) = @_;
	    eval q((($_txop)<<5));
    }' unless defined(&IEEE80211_TXOP_TO_US);
    eval 'sub IEEE80211_US_TO_TXOP {
        my($_us) = @_;
	    eval q((($_us)>>5));
    }' unless defined(&IEEE80211_US_TO_TXOP);
    eval 'sub WME_F_AGGRMODE () {0x1;}' unless defined(&WME_F_AGGRMODE);
    eval("sub IEEE80211_BEACON_CAPS () { 0; }") unless defined(&IEEE80211_BEACON_CAPS);
    eval("sub IEEE80211_BEACON_TIM () { 1; }") unless defined(&IEEE80211_BEACON_TIM);
    eval("sub IEEE80211_BEACON_WME () { 2; }") unless defined(&IEEE80211_BEACON_WME);
    eval("sub IEEE80211_BEACON_ERP () { 3; }") unless defined(&IEEE80211_BEACON_ERP);
    eval("sub IEEE80211_BEACON_HTINFO () { 4; }") unless defined(&IEEE80211_BEACON_HTINFO);
    eval("sub IEEE80211_BEACON_APPIE () { 5; }") unless defined(&IEEE80211_BEACON_APPIE);
    eval("sub IEEE80211_BEACON_CFP () { 6; }") unless defined(&IEEE80211_BEACON_CFP);
    eval("sub IEEE80211_BEACON_CSA () { 7; }") unless defined(&IEEE80211_BEACON_CSA);
    eval("sub IEEE80211_BEACON_TDMA () { 9; }") unless defined(&IEEE80211_BEACON_TDMA);
    eval("sub IEEE80211_BEACON_ATH () { 10; }") unless defined(&IEEE80211_BEACON_ATH);
    eval("sub IEEE80211_BEACON_MESHCONF () { 11; }") unless defined(&IEEE80211_BEACON_MESHCONF);
    eval("sub IEEE80211_NOTIFY_CAC_START () { 0; }") unless defined(&IEEE80211_NOTIFY_CAC_START);
    eval("sub IEEE80211_NOTIFY_CAC_STOP () { 1; }") unless defined(&IEEE80211_NOTIFY_CAC_STOP);
    eval("sub IEEE80211_NOTIFY_CAC_RADAR () { 2; }") unless defined(&IEEE80211_NOTIFY_CAC_RADAR);
    eval("sub IEEE80211_NOTIFY_CAC_EXPIRE () { 3; }") unless defined(&IEEE80211_NOTIFY_CAC_EXPIRE);
}
1;
