require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval("sub IEEE80211_RATECTL_AMRR () { 0; }") unless defined(&IEEE80211_RATECTL_AMRR);
eval("sub IEEE80211_RATECTL_RSSADAPT () { 1; }") unless defined(&IEEE80211_RATECTL_RSSADAPT);
eval("sub IEEE80211_RATECTL_ONOE () { 2; }") unless defined(&IEEE80211_RATECTL_ONOE);
eval("sub IEEE80211_RATECTL_SAMPLE () { 3; }") unless defined(&IEEE80211_RATECTL_SAMPLE);
eval("sub IEEE80211_RATECTL_NONE () { 4; }") unless defined(&IEEE80211_RATECTL_NONE);
eval("sub IEEE80211_RATECTL_MAX () { 5; }") unless defined(&IEEE80211_RATECTL_MAX);
eval 'sub IEEE80211_RATECTL_TX_SUCCESS () {1;}' unless defined(&IEEE80211_RATECTL_TX_SUCCESS);
eval 'sub IEEE80211_RATECTL_TX_FAILURE () {0;}' unless defined(&IEEE80211_RATECTL_TX_FAILURE);
unless(defined(&ieee80211_ratectl_deinit)) {
    sub ieee80211_ratectl_deinit {
	my($vap) = @_;
	eval q({  ($vap->{iv_rate}->{ir_deinit})($vap); });
    }
}
unless(defined(&ieee80211_ratectl_node_init)) {
    sub ieee80211_ratectl_node_init {
	my($ni) = @_;
	eval q({  &const 'struct ieee80211vap' * &vap =  ($ni->{ni_vap});  ($vap->{iv_rate}->{ir_node_init})($ni); });
    }
}
unless(defined(&ieee80211_ratectl_node_deinit)) {
    sub ieee80211_ratectl_node_deinit {
	my($ni) = @_;
	eval q({  &const 'struct ieee80211vap' * &vap =  ($ni->{ni_vap});  ($vap->{iv_rate}->{ir_node_deinit})($ni); });
    }
}
unless(defined(&ieee80211_ratectl_tx_complete)) {
    sub ieee80211_ratectl_tx_complete {
	my($vap,$ni,$status,$arg1,$arg2) = @_;
	eval q({  ($vap->{iv_rate}->{ir_tx_complete})($vap, $ni, $status, $arg1, $arg2); });
    }
}
unless(defined(&ieee80211_ratectl_tx_update)) {
    sub ieee80211_ratectl_tx_update {
	my($vap,$ni,$arg1,$arg2,$arg3) = @_;
	eval q({  &if ( ($vap->{iv_rate}->{ir_tx_update}) ==  &NULL) ;  ($vap->{iv_rate}->{ir_tx_update})($vap, $ni, $arg1, $arg2, $arg3); });
    }
}
unless(defined(&ieee80211_ratectl_setinterval)) {
    sub ieee80211_ratectl_setinterval {
	my($vap,$msecs) = @_;
	eval q({  &if ( ($vap->{iv_rate}->{ir_setinterval}) ==  &NULL) ;  ($vap->{iv_rate}->{ir_setinterval})($vap, $msecs); });
    }
}
unless(defined(&ieee80211_ratectl_node_stats)) {
    sub ieee80211_ratectl_node_stats {
	my($ni,$s) = @_;
	eval q({  &const 'struct ieee80211vap' * &vap =  ($ni->{ni_vap});  &if ( ($vap->{iv_rate}->{ir_node_stats}) ==  &NULL) ;  ($vap->{iv_rate}->{ir_node_stats})($ni, $s); });
    }
}
1;
