require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NG_NETFLOW_H_)) {
    eval 'sub _NG_NETFLOW_H_ () {1;}' unless defined(&_NG_NETFLOW_H_);
    eval 'sub NG_NETFLOW_NODE_TYPE () {"netflow";}' unless defined(&NG_NETFLOW_NODE_TYPE);
    eval 'sub NGM_NETFLOW_COOKIE () {1365756954;}' unless defined(&NGM_NETFLOW_COOKIE);
    eval 'sub NGM_NETFLOW_V9_COOKIE () {1349865386;}' unless defined(&NGM_NETFLOW_V9_COOKIE);
    eval 'sub NG_NETFLOW_MAXIFACES () { &USHRT_MAX;}' unless defined(&NG_NETFLOW_MAXIFACES);
    eval 'sub NG_NETFLOW_HOOK_DATA () {"iface";}' unless defined(&NG_NETFLOW_HOOK_DATA);
    eval 'sub NG_NETFLOW_HOOK_OUT () {"out";}' unless defined(&NG_NETFLOW_HOOK_OUT);
    eval 'sub NG_NETFLOW_HOOK_EXPORT () {"export";}' unless defined(&NG_NETFLOW_HOOK_EXPORT);
    eval 'sub NG_NETFLOW_HOOK_EXPORT9 () {"export9";}' unless defined(&NG_NETFLOW_HOOK_EXPORT9);
    eval("sub NGM_NETFLOW_INFO () { 1|NGM_READONLY|NGM_HASREPLY; }") unless defined(&NGM_NETFLOW_INFO);
    eval("sub NGM_NETFLOW_IFINFO () { 2|NGM_READONLY|NGM_HASREPLY; }") unless defined(&NGM_NETFLOW_IFINFO);
    eval("sub NGM_NETFLOW_SHOW () { 3|NGM_READONLY|NGM_HASREPLY; }") unless defined(&NGM_NETFLOW_SHOW);
    eval("sub NGM_NETFLOW_SETDLT () { 4; }") unless defined(&NGM_NETFLOW_SETDLT);
    eval("sub NGM_NETFLOW_SETIFINDEX () { 5; }") unless defined(&NGM_NETFLOW_SETIFINDEX);
    eval("sub NGM_NETFLOW_SETTIMEOUTS () { 6; }") unless defined(&NGM_NETFLOW_SETTIMEOUTS);
    eval("sub NGM_NETFLOW_SETCONFIG () { 7; }") unless defined(&NGM_NETFLOW_SETCONFIG);
    eval("sub NGM_NETFLOW_SETTEMPLATE () { 8; }") unless defined(&NGM_NETFLOW_SETTEMPLATE);
    eval("sub NGM_NETFLOW_SETMTU () { 9; }") unless defined(&NGM_NETFLOW_SETMTU);
    eval("sub NGM_NETFLOW_V9INFO () { 10|NGM_READONLY|NGM_HASREPLY; }") unless defined(&NGM_NETFLOW_V9INFO);
    eval 'sub NG_NETFLOW_INFO_TYPE () {{ { "IPv4 bytes",  &ng_parse_uint64_type }, { "IPv4 packets",  &ng_parse_uint64_type }, { "IPv6 bytes",  &ng_parse_uint64_type }, { "IPv6 packets",  &ng_parse_uint64_type }, { "IPv4 skipped bytes",  &ng_parse_uint64_type }, { "IPv4 skipped packets",  &ng_parse_uint64_type }, { "IPv6 skipped bytes",  &ng_parse_uint64_type }, { "IPv6 skipped packets",  &ng_parse_uint64_type }, { "Active expiries",  &ng_parse_uint64_type }, { "Inactive expiries",  &ng_parse_uint64_type }, { "IPv4 records used",  &ng_parse_uint32_type }, { "IPv6 records used",  &ng_parse_uint32_type }, { "Failed allocations",  &ng_parse_uint32_type }, { "V5 failed exports",  &ng_parse_uint32_type }, { "V9 failed exports",  &ng_parse_uint32_type }, { "mbuf reallocations",  &ng_parse_uint32_type }, { "fibs allocated",  &ng_parse_uint32_type }, { "Inactive timeout",  &ng_parse_uint32_type }, { "Active timeout",  &ng_parse_uint32_type }, {  &NULL } };}' unless defined(&NG_NETFLOW_INFO_TYPE);
    eval 'sub MAXDLTNAMELEN () {20;}' unless defined(&MAXDLTNAMELEN);
    eval 'sub NG_NETFLOW_CONF_INGRESS () {0x1;}' unless defined(&NG_NETFLOW_CONF_INGRESS);
    eval 'sub NG_NETFLOW_CONF_EGRESS () {0x2;}' unless defined(&NG_NETFLOW_CONF_EGRESS);
    eval 'sub NG_NETFLOW_CONF_ONCE () {0x4;}' unless defined(&NG_NETFLOW_CONF_ONCE);
    eval 'sub NG_NETFLOW_CONF_THISONCE () {0x8;}' unless defined(&NG_NETFLOW_CONF_THISONCE);
    eval 'sub NG_NETFLOW_CONF_NOSRCLOOKUP () {0x10;}' unless defined(&NG_NETFLOW_CONF_NOSRCLOOKUP);
    eval 'sub NG_NETFLOW_CONF_NODSTLOOKUP () {0x20;}' unless defined(&NG_NETFLOW_CONF_NODSTLOOKUP);
    eval 'sub NG_NETFLOW_IS_FRAG () {0x1;}' unless defined(&NG_NETFLOW_IS_FRAG);
    eval 'sub NG_NETFLOW_FLOW_FLAGS () {( &NG_NETFLOW_CONF_NOSRCLOOKUP|  &NG_NETFLOW_CONF_NODSTLOOKUP);}' unless defined(&NG_NETFLOW_FLOW_FLAGS);
    eval 'sub r_ip_p () { ($misc->{i}->{prot});}' unless defined(&r_ip_p);
    eval 'sub r_tos () { ($misc->{i}->{tos});}' unless defined(&r_tos);
    eval 'sub r_i_ifx () { ($misc->{i}->{i_ifx});}' unless defined(&r_i_ifx);
    eval 'sub r_misc () { ($misc->{all});}' unless defined(&r_misc);
    eval 'sub r_ports () { ($ports->{both});}' unless defined(&r_ports);
    eval 'sub r_sport () { ($ports->{dir}->{s_port});}' unless defined(&r_sport);
    eval 'sub r_dport () { ($ports->{dir}->{d_port});}' unless defined(&r_dport);
    eval 'sub fle_i_ifx () { ($r->{misc}->{i}->{i_ifx});}' unless defined(&fle_i_ifx);
    eval 'sub fle_i_ifx () { ($r->{misc}->{i}->{i_ifx});}' unless defined(&fle_i_ifx);
    eval 'sub NREC_AT_ONCE () {1000;}' unless defined(&NREC_AT_ONCE);
    eval 'sub NREC6_AT_ONCE () {( &NREC_AT_ONCE * $sizeof{\'struct flow_entry_data\'} / $sizeof{\'struct flow6_entry_data\'});}' unless defined(&NREC6_AT_ONCE);
    eval 'sub NGRESP_SIZE () {($sizeof{\'struct ngnf_show_header\'} + ( &NREC_AT_ONCE * $sizeof{\'struct flow_entry_data\'}));}' unless defined(&NGRESP_SIZE);
    eval 'sub SORCVBUF_SIZE () {( &NGRESP_SIZE + 2* $sizeof{\'struct ng_mesg\'});}' unless defined(&SORCVBUF_SIZE);
    if(defined(&_KERNEL)) {
	eval 'sub NG_NETFLOW_IFINFO_TYPE () {{ { "packets",  &ng_parse_uint32_type }, { "data link type",  &ng_parse_uint8_type }, { "index",  &ng_parse_uint16_type }, { "conf",  &ng_parse_uint32_type }, {  &NULL } };}' unless defined(&NG_NETFLOW_IFINFO_TYPE);
	eval 'sub NG_NETFLOW_SETDLT_TYPE () {{ { "iface",  &ng_parse_uint16_type }, { "dlt",  &ng_parse_uint8_type }, {  &NULL } };}' unless defined(&NG_NETFLOW_SETDLT_TYPE);
	eval 'sub NG_NETFLOW_SETIFINDEX_TYPE () {{ { "iface",  &ng_parse_uint16_type }, { "index",  &ng_parse_uint16_type }, {  &NULL } };}' unless defined(&NG_NETFLOW_SETIFINDEX_TYPE);
	eval 'sub NG_NETFLOW_SETTIMEOUTS_TYPE () {{ { "inactive",  &ng_parse_uint32_type }, { "active",  &ng_parse_uint32_type }, {  &NULL } };}' unless defined(&NG_NETFLOW_SETTIMEOUTS_TYPE);
	eval 'sub NG_NETFLOW_SETCONFIG_TYPE () {{ { "iface",  &ng_parse_uint16_type }, { "conf",  &ng_parse_uint32_type }, {  &NULL } };}' unless defined(&NG_NETFLOW_SETCONFIG_TYPE);
	eval 'sub NG_NETFLOW_SETTEMPLATE_TYPE () {{ { "time",  &ng_parse_uint16_type }, { "packets",  &ng_parse_uint16_type }, {  &NULL } };}' unless defined(&NG_NETFLOW_SETTEMPLATE_TYPE);
	eval 'sub NG_NETFLOW_SETMTU_TYPE () {{ { "mtu",  &ng_parse_uint16_type }, {  &NULL } };}' unless defined(&NG_NETFLOW_SETMTU_TYPE);
	eval 'sub NG_NETFLOW_V9INFO_TYPE () {{ { "v9 template packets",  &ng_parse_uint16_type }, { "v9 template time",  &ng_parse_uint16_type }, { "v9 MTU",  &ng_parse_uint16_type }, {  &NULL } };}' unless defined(&NG_NETFLOW_V9INFO_TYPE);
	eval 'sub CACHESIZE () {(65536*16);}' unless defined(&CACHESIZE);
	eval 'sub CACHELOWAT () {( &CACHESIZE * 3/4);}' unless defined(&CACHELOWAT);
	eval 'sub CACHEHIGHWAT () {( &CACHESIZE * 9/10);}' unless defined(&CACHEHIGHWAT);
	if(defined(&INET6)) {
	}
	eval 'sub NETFLOW_V9_MAX_FLOWSETS () {2;}' unless defined(&NETFLOW_V9_MAX_FLOWSETS);
	eval 'sub ERROUT {
	    my($x) = @_;
    	    eval q({  &error = ($x);  &goto  &done; });
	}' unless defined(&ERROUT);
	eval 'sub MTAG_NETFLOW () {1221656444;}' unless defined(&MTAG_NETFLOW);
	eval 'sub MTAG_NETFLOW_CALLED () {0;}' unless defined(&MTAG_NETFLOW_CALLED);
	eval 'sub m_pktlen {
	    my($m) = @_;
    	    eval q((($m)-> ($m_pkthdr->{len})));
	}' unless defined(&m_pktlen);
	eval 'sub IP6VERSION () {6;}' unless defined(&IP6VERSION);
	eval 'sub priv_to_fib {
	    my($priv, $fib) = @_;
    	    eval q(($priv)-> $fib_data[($fib)]);
	}' unless defined(&priv_to_fib);
	eval 'sub MILLIUPTIME {
	    my($t) = @_;
    	    eval q(((($t) << 9) + (($t) << 8) + (($t) << 7) + (($t) << 6) + (($t) << 5) + (($t) << 3)));
	}' unless defined(&MILLIUPTIME);
    }
}
1;
