require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETGRAPH_NG_BRIDGE_H_)) {
    eval 'sub _NETGRAPH_NG_BRIDGE_H_ () {1;}' unless defined(&_NETGRAPH_NG_BRIDGE_H_);
    eval 'sub NG_BRIDGE_NODE_TYPE () {"bridge";}' unless defined(&NG_BRIDGE_NODE_TYPE);
    eval 'sub NGM_BRIDGE_COOKIE () {967239368;}' unless defined(&NGM_BRIDGE_COOKIE);
    eval 'sub NG_BRIDGE_HOOK_LINK_PREFIX () {"link";}' unless defined(&NG_BRIDGE_HOOK_LINK_PREFIX);
    eval 'sub NG_BRIDGE_HOOK_LINK_FMT () {"link%d";}' unless defined(&NG_BRIDGE_HOOK_LINK_FMT);
    eval 'sub NG_BRIDGE_MAX_LINKS () {32;}' unless defined(&NG_BRIDGE_MAX_LINKS);
    eval 'sub NG_BRIDGE_CONFIG_TYPE_INFO {
        my($ainfo) = @_;
	    eval q({ { \\"ipfw\\", ($ainfo) }, { \\"debugLevel\\",  &ng_parse_uint8_type }, { \\"loopTimeout\\",  &ng_parse_uint32_type }, { \\"maxStaleness\\",  &ng_parse_uint32_type }, { \\"minStableAge\\",  &ng_parse_uint32_type }, {  &NULL } });
    }' unless defined(&NG_BRIDGE_CONFIG_TYPE_INFO);
    eval 'sub NG_BRIDGE_STATS_TYPE_INFO () {{ { "recvOctets",  &ng_parse_uint64_type }, { "recvPackets",  &ng_parse_uint64_type }, { "recvMulticast",  &ng_parse_uint64_type }, { "recvBroadcast",  &ng_parse_uint64_type }, { "recvUnknown",  &ng_parse_uint64_type }, { "recvRunts",  &ng_parse_uint64_type }, { "recvInvalid",  &ng_parse_uint64_type }, { "xmitOctets",  &ng_parse_uint64_type }, { "xmitPackets",  &ng_parse_uint64_type }, { "xmitMulticasts",  &ng_parse_uint64_type }, { "xmitBroadcasts",  &ng_parse_uint64_type }, { "loopDrops",  &ng_parse_uint64_type }, { "loopDetects",  &ng_parse_uint64_type }, { "memoryFailures",  &ng_parse_uint64_type }, {  &NULL } };}' unless defined(&NG_BRIDGE_STATS_TYPE_INFO);
    eval 'sub NG_BRIDGE_HOST_TYPE_INFO {
        my($entype) = @_;
	    eval q({ { \\"addr\\", ($entype) }, { \\"linkNum\\",  &ng_parse_uint16_type }, { \\"age\\",  &ng_parse_uint16_type }, { \\"staleness\\",  &ng_parse_uint16_type }, {  &NULL } });
    }' unless defined(&NG_BRIDGE_HOST_TYPE_INFO);
    eval 'sub NG_BRIDGE_HOST_ARY_TYPE_INFO {
        my($harytype) = @_;
	    eval q({ { \\"numHosts\\",  &ng_parse_uint32_type }, { \\"hosts\\", ($harytype) }, {  &NULL } });
    }' unless defined(&NG_BRIDGE_HOST_ARY_TYPE_INFO);
    eval("sub NGM_BRIDGE_SET_CONFIG () { 1; }") unless defined(&NGM_BRIDGE_SET_CONFIG);
    eval("sub NGM_BRIDGE_GET_CONFIG () { 2; }") unless defined(&NGM_BRIDGE_GET_CONFIG);
    eval("sub NGM_BRIDGE_RESET () { 3; }") unless defined(&NGM_BRIDGE_RESET);
    eval("sub NGM_BRIDGE_GET_STATS () { 4; }") unless defined(&NGM_BRIDGE_GET_STATS);
    eval("sub NGM_BRIDGE_CLR_STATS () { 5; }") unless defined(&NGM_BRIDGE_CLR_STATS);
    eval("sub NGM_BRIDGE_GETCLR_STATS () { 6; }") unless defined(&NGM_BRIDGE_GETCLR_STATS);
    eval("sub NGM_BRIDGE_GET_TABLE () { 7; }") unless defined(&NGM_BRIDGE_GET_TABLE);
    eval("sub NGM_BRIDGE_SET_PERSISTENT () { 8; }") unless defined(&NGM_BRIDGE_SET_PERSISTENT);
}
1;
