require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETGRAPH_NG_MESSAGE_H_)) {
    eval 'sub _NETGRAPH_NG_MESSAGE_H_ () {1;}' unless defined(&_NETGRAPH_NG_MESSAGE_H_);
    eval 'sub NG_TYPESIZ () {32;}' unless defined(&NG_TYPESIZ);
    eval 'sub NG_HOOKSIZ () {32;}' unless defined(&NG_HOOKSIZ);
    eval 'sub NG_NODESIZ () {32;}' unless defined(&NG_NODESIZ);
    eval 'sub NG_PATHSIZ () {512;}' unless defined(&NG_PATHSIZ);
    eval 'sub NG_CMDSTRSIZ () {32;}' unless defined(&NG_CMDSTRSIZ);
    eval 'sub NG_TEXTRESPONSE () {1024;}' unless defined(&NG_TEXTRESPONSE);
    eval 'sub NGM_READONLY () {0x10000000;}' unless defined(&NGM_READONLY);
    eval 'sub NGM_HASREPLY () {0x20000000;}' unless defined(&NGM_HASREPLY);
    eval 'sub NG_GENERIC_NG_MESG_INFO {
        my($dtype) = @_;
	    eval q({ { \\"version\\",  &ng_parse_uint8_type }, { \\"spare\\",  &ng_parse_uint8_type }, { \\"spare2\\",  &ng_parse_uint16_type }, { \\"arglen\\",  &ng_parse_uint32_type }, { \\"cmd\\",  &ng_parse_uint32_type }, { \\"flags\\",  &ng_parse_hint32_type }, { \\"token\\",  &ng_parse_uint32_type }, { \\"typecookie\\",  &ng_parse_uint32_type }, { \\"cmdstr\\",  &ng_parse_cmdbuf_type }, { \\"data\\", ($dtype) }, {  &NULL } });
    }' unless defined(&NG_GENERIC_NG_MESG_INFO);
    eval 'sub NG_VERSION () {8;}' unless defined(&NG_VERSION);
    eval 'sub NGF_ORIG () {0x;}' unless defined(&NGF_ORIG);
    eval 'sub NGF_RESP () {0x1;}' unless defined(&NGF_RESP);
    eval 'sub ng_ID_t () { &uint32_t;}' unless defined(&ng_ID_t);
    eval 'sub NGM_GENERIC_COOKIE () {1137070366;}' unless defined(&NGM_GENERIC_COOKIE);
    eval("sub NGM_SHUTDOWN () { 1; }") unless defined(&NGM_SHUTDOWN);
    eval("sub NGM_MKPEER () { 2; }") unless defined(&NGM_MKPEER);
    eval("sub NGM_CONNECT () { 3; }") unless defined(&NGM_CONNECT);
    eval("sub NGM_NAME () { 4; }") unless defined(&NGM_NAME);
    eval("sub NGM_RMHOOK () { 5; }") unless defined(&NGM_RMHOOK);
    eval("sub NGM_NODEINFO () { (6|NGM_READONLY|NGM_HASREPLY); }") unless defined(&NGM_NODEINFO);
    eval("sub NGM_LISTHOOKS () { (7|NGM_READONLY|NGM_HASREPLY); }") unless defined(&NGM_LISTHOOKS);
    eval("sub NGM_LISTNAMES () { (8|NGM_READONLY|NGM_HASREPLY); }") unless defined(&NGM_LISTNAMES);
    eval("sub NGM_LISTNODES () { (9|NGM_READONLY|NGM_HASREPLY); }") unless defined(&NGM_LISTNODES);
    eval("sub NGM_LISTTYPES () { (10|NGM_READONLY|NGM_HASREPLY); }") unless defined(&NGM_LISTTYPES);
    eval("sub NGM_TEXT_STATUS () { (11|NGM_READONLY|NGM_HASREPLY); }") unless defined(&NGM_TEXT_STATUS);
    eval("sub NGM_BINARY2ASCII () { (12|NGM_READONLY|NGM_HASREPLY); }") unless defined(&NGM_BINARY2ASCII);
    eval("sub NGM_ASCII2BINARY () { (13|NGM_READONLY|NGM_HASREPLY); }") unless defined(&NGM_ASCII2BINARY);
    eval("sub NGM_TEXT_CONFIG () { 14; }") unless defined(&NGM_TEXT_CONFIG);
    eval 'sub NGM_FLOW_COOKIE () {851672669;}' unless defined(&NGM_FLOW_COOKIE);
    eval 'sub NGM_LINK_IS_UP () {32;}' unless defined(&NGM_LINK_IS_UP);
    eval 'sub NGM_LINK_IS_DOWN () {33;}' unless defined(&NGM_LINK_IS_DOWN);
    eval 'sub NGM_HIGH_WATER_PASSED () {34;}' unless defined(&NGM_HIGH_WATER_PASSED);
    eval 'sub NGM_LOW_WATER_PASSED () {35;}' unless defined(&NGM_LOW_WATER_PASSED);
    eval 'sub NGM_SYNC_QUEUE_STATE () {36;}' unless defined(&NGM_SYNC_QUEUE_STATE);
    eval 'sub NGM_DROP_LINK () {41;}' unless defined(&NGM_DROP_LINK);
    eval 'sub NGM_RAISE_LINK () {42;}' unless defined(&NGM_RAISE_LINK);
    eval 'sub NGM_FLUSH_QUEUE () {43;}' unless defined(&NGM_FLUSH_QUEUE);
    eval 'sub NGM_GET_BANDWIDTH () {(44| &NGM_READONLY);}' unless defined(&NGM_GET_BANDWIDTH);
    eval 'sub NGM_SET_XMIT_Q_LIMITS () {45;}' unless defined(&NGM_SET_XMIT_Q_LIMITS);
    eval 'sub NGM_GET_XMIT_Q_LIMITS () {(46| &NGM_READONLY);}' unless defined(&NGM_GET_XMIT_Q_LIMITS);
    eval 'sub NGM_MICROMANAGE () {47;}' unless defined(&NGM_MICROMANAGE);
    eval 'sub NGM_SET_FLOW_MANAGER () {48;}' unless defined(&NGM_SET_FLOW_MANAGER);
    eval 'sub NG_GENERIC_MKPEER_INFO () {
        eval q({ { \\"type\\",  &ng_parse_typebuf_type }, { \\"ourhook\\",  &ng_parse_hookbuf_type }, { \\"peerhook\\",  &ng_parse_hookbuf_type }, {  &NULL } });
    }' unless defined(&NG_GENERIC_MKPEER_INFO);
    eval 'sub NG_GENERIC_CONNECT_INFO () {
        eval q({ { \\"path\\",  &ng_parse_pathbuf_type }, { \\"ourhook\\",  &ng_parse_hookbuf_type }, { \\"peerhook\\",  &ng_parse_hookbuf_type }, {  &NULL } });
    }' unless defined(&NG_GENERIC_CONNECT_INFO);
    eval 'sub NG_GENERIC_NAME_INFO () {
        eval q({ { \\"name\\",  &ng_parse_nodebuf_type }, {  &NULL } });
    }' unless defined(&NG_GENERIC_NAME_INFO);
    eval 'sub NG_GENERIC_RMHOOK_INFO () {
        eval q({ { \\"hook\\",  &ng_parse_hookbuf_type }, {  &NULL } });
    }' unless defined(&NG_GENERIC_RMHOOK_INFO);
    eval 'sub NG_GENERIC_NODEINFO_INFO () {
        eval q({ { \\"name\\",  &ng_parse_nodebuf_type }, { \\"type\\",  &ng_parse_typebuf_type }, { \\"id\\",  &ng_parse_hint32_type }, { \\"hooks\\",  &ng_parse_uint32_type }, {  &NULL } });
    }' unless defined(&NG_GENERIC_NODEINFO_INFO);
    eval 'sub NG_GENERIC_LINKINFO_INFO {
        my($nitype) = @_;
	    eval q({ { \\"ourhook\\",  &ng_parse_hookbuf_type }, { \\"peerhook\\",  &ng_parse_hookbuf_type }, { \\"nodeinfo\\", ($nitype) }, {  &NULL } });
    }' unless defined(&NG_GENERIC_LINKINFO_INFO);
    eval 'sub NG_GENERIC_HOOKLIST_INFO {
        my($nitype,$litype) = @_;
	    eval q({ { \\"nodeinfo\\", ($nitype) }, { \\"linkinfo\\", ($litype) }, {  &NULL } });
    }' unless defined(&NG_GENERIC_HOOKLIST_INFO);
    eval 'sub NG_GENERIC_LISTNODES_INFO {
        my($niarraytype) = @_;
	    eval q({ { \\"numnames\\",  &ng_parse_uint32_type }, { \\"nodeinfo\\", ($niarraytype) }, {  &NULL } });
    }' unless defined(&NG_GENERIC_LISTNODES_INFO);
    eval 'sub NG_GENERIC_TYPEINFO_INFO () {
        eval q({ { \\"typename\\",  &ng_parse_typebuf_type }, { \\"numnodes\\",  &ng_parse_uint32_type }, {  &NULL } });
    }' unless defined(&NG_GENERIC_TYPEINFO_INFO);
    eval 'sub NG_GENERIC_TYPELIST_INFO {
        my($tiarraytype) = @_;
	    eval q({ { \\"numtypes\\",  &ng_parse_uint32_type }, { \\"typeinfo\\", ($tiarraytype) }, {  &NULL } });
    }' unless defined(&NG_GENERIC_TYPELIST_INFO);
    eval 'sub NG_GENERIC_BANDWIDTH_INFO () {
        eval q({ { \\"nominal_in\\",  &ng_parse_uint64_type }, { \\"seen_in\\",  &ng_parse_uint64_type }, { \\"nominal_out\\",  &ng_parse_uint64_type }, { \\"seen_out\\",  &ng_parse_uint64_type }, {  &NULL } });
    }' unless defined(&NG_GENERIC_BANDWIDTH_INFO);
    eval 'sub NG_GENERIC_QUEUE_INFO () {
        eval q({ { \\"max_queuelen_bytes\\",  &ng_parse_uint_type }, { \\"max_queuelen_packets\\",  &ng_parse_uint_type }, { \\"high_watermark\\",  &ng_parse_uint_type }, { \\"low_watermark\\",  &ng_parse_uint_type }, { \\"current\\",  &ng_parse_uint_type }, {  &NULL } });
    }' unless defined(&NG_GENERIC_QUEUE_INFO);
    eval 'sub NG_GENERIC_FLOW_MANAGER_INFO () {
        eval q({ { \\"id\\",  &ng_parse_hint32_type }, {  &NULL } });
    }' unless defined(&NG_GENERIC_FLOW_MANAGER_INFO);
    eval 'sub NGIOCGINFO () { &_IOR(ord(\'N\'), 40, \'struct nodeinfo\');}' unless defined(&NGIOCGINFO);
    eval 'sub NGIOCSETNAME () { &_IOW(ord(\'N\'), 41, \'struct ngm_name\');}' unless defined(&NGIOCSETNAME);
    if(defined(&_KERNEL)) {
	eval 'sub NG_MKMESSAGE {
	    my($msg, $cookie, $cmdid, $len, $how) = @_;
    	    eval q( &do { ($msg) =  &malloc($sizeof{\'struct ng_mesg\'} + ($len),  &M_NETGRAPH_MSG, ($how) |  &M_ZERO);  &if (($msg) ==  &NULL)  &break; ($msg)-> ($header->{version}) =  &NG_VERSION; ($msg)-> ($header->{typecookie}) = ($cookie); ($msg)-> ($header->{cmd}) = ($cmdid); ($msg)-> ($header->{arglen}) = ($len);  &strncpy(($msg)-> ($header->{cmdstr}), $cmdid, $sizeof{($msg)-> ($header->{cmdstr})} - 1); }  &while (0));
	}' unless defined(&NG_MKMESSAGE);
	eval 'sub NG_MKRESPONSE {
	    my($rsp, $msg, $len, $how) = @_;
    	    eval q( &do { ($rsp) =  &malloc($sizeof{\'struct ng_mesg\'} + ($len),  &M_NETGRAPH_MSG, ($how) |  &M_ZERO);  &if (($rsp) ==  &NULL)  &break; ($rsp)-> ($header->{version}) =  &NG_VERSION; ($rsp)-> ($header->{arglen}) = ($len); ($rsp)-> ($header->{token}) = ($msg)-> ($header->{token}); ($rsp)-> ($header->{typecookie}) = ($msg)-> ($header->{typecookie}); ($rsp)-> ($header->{cmd}) = ($msg)-> ($header->{cmd});  &bcopy(($msg)-> ($header->{cmdstr}), ($rsp)-> ($header->{cmdstr}), $sizeof{($rsp)-> ($header->{cmdstr})}); ($rsp)-> ($header->{flags}) |=  &NGF_RESP; }  &while (0));
	}' unless defined(&NG_MKRESPONSE);
	eval 'sub NG_COPYMESSAGE {
	    my($copy, $msg, $how) = @_;
    	    eval q( &do { ($copy) =  &malloc($sizeof{\'struct ng_mesg\'} + ($msg)-> ($header->{arglen}),  &M_NETGRAPH_MSG, ($how) |  &M_ZERO);  &if (($copy) ==  &NULL)  &break; ($copy)-> ($header->{version}) =  &NG_VERSION; ($copy)-> ($header->{arglen}) = ($msg)-> ($header->{arglen}); ($copy)-> ($header->{token}) = ($msg)-> ($header->{token}); ($copy)-> ($header->{typecookie}) = ($msg)-> ($header->{typecookie}); ($copy)-> ($header->{cmd}) = ($msg)-> ($header->{cmd}); ($copy)-> ($header->{flags}) = ($msg)-> ($header->{flags});  &bcopy(($msg)-> ($header->{cmdstr}), ($copy)-> ($header->{cmdstr}), $sizeof{($copy)-> ($header->{cmdstr})});  &if (($msg)-> ($header->{arglen}) > 0)  &bcopy(($msg)-> &data, ($copy)-> &data, ($msg)-> ($header->{arglen})); }  &while (0));
	}' unless defined(&NG_COPYMESSAGE);
    }
}
1;
