require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub NG_NAT_NODE_TYPE () {"nat";}' unless defined(&NG_NAT_NODE_TYPE);
eval 'sub NGM_NAT_COOKIE () {1107718711;}' unless defined(&NGM_NAT_COOKIE);
eval 'sub NG_NAT_HOOK_IN () {"in";}' unless defined(&NG_NAT_HOOK_IN);
eval 'sub NG_NAT_HOOK_OUT () {"out";}' unless defined(&NG_NAT_HOOK_OUT);
eval 'sub NG_NAT_MODE_INFO () {{ { "flags",  &ng_parse_uint32_type }, { "mask",  &ng_parse_uint32_type }, {  &NULL } };}' unless defined(&NG_NAT_MODE_INFO);
eval 'sub NG_NAT_LOG () {0x1;}' unless defined(&NG_NAT_LOG);
eval 'sub NG_NAT_DENY_INCOMING () {0x2;}' unless defined(&NG_NAT_DENY_INCOMING);
eval 'sub NG_NAT_SAME_PORTS () {0x4;}' unless defined(&NG_NAT_SAME_PORTS);
eval 'sub NG_NAT_UNREGISTERED_ONLY () {0x10;}' unless defined(&NG_NAT_UNREGISTERED_ONLY);
eval 'sub NG_NAT_RESET_ON_ADDR_CHANGE () {0x20;}' unless defined(&NG_NAT_RESET_ON_ADDR_CHANGE);
eval 'sub NG_NAT_PROXY_ONLY () {0x40;}' unless defined(&NG_NAT_PROXY_ONLY);
eval 'sub NG_NAT_REVERSE () {0x80;}' unless defined(&NG_NAT_REVERSE);
eval 'sub NG_NAT_DESC_LENGTH () {64;}' unless defined(&NG_NAT_DESC_LENGTH);
eval 'sub NG_NAT_REDIRPROTO_ADDR () {( &IPPROTO_MAX + 3);}' unless defined(&NG_NAT_REDIRPROTO_ADDR);
unless(defined(&NG_NAT_REDIRECT_PORT_TYPE_INFO)) {
    sub NG_NAT_REDIRECT_PORT_TYPE_INFO {
	my($desctype) = @_;
	eval q({ { \"local_addr\",  &ng_parse_ipaddr_type }, { \"alias_addr\",  &ng_parse_ipaddr_type }, { \"remote_addr\",  &ng_parse_ipaddr_type }, { \"local_port\",  &ng_parse_uint16_type }, { \"alias_port\",  &ng_parse_uint16_type }, { \"remote_port\",  &ng_parse_uint16_type }, { \"proto\",  &ng_parse_uint8_type }, { \"description\", ($desctype) }, {  &NULL } });
    }
}
unless(defined(&NG_NAT_REDIRECT_ADDR_TYPE_INFO)) {
    sub NG_NAT_REDIRECT_ADDR_TYPE_INFO {
	my($desctype) = @_;
	eval q({ { \"local_addr\",  &ng_parse_ipaddr_type }, { \"alias_addr\",  &ng_parse_ipaddr_type }, { \"description\", ($desctype) }, {  &NULL } });
    }
}
unless(defined(&NG_NAT_REDIRECT_PROTO_TYPE_INFO)) {
    sub NG_NAT_REDIRECT_PROTO_TYPE_INFO {
	my($desctype) = @_;
	eval q({ { \"local_addr\",  &ng_parse_ipaddr_type }, { \"alias_addr\",  &ng_parse_ipaddr_type }, { \"remote_addr\",  &ng_parse_ipaddr_type }, { \"proto\",  &ng_parse_uint8_type }, { \"description\", ($desctype) }, {  &NULL } });
    }
}
eval 'sub NG_NAT_ADD_SERVER_TYPE_INFO () {{ { "id",  &ng_parse_uint32_type }, { "addr",  &ng_parse_ipaddr_type }, { "port",  &ng_parse_uint16_type }, {  &NULL } };}' unless defined(&NG_NAT_ADD_SERVER_TYPE_INFO);
unless(defined(&NG_NAT_LISTRDRS_ENTRY_TYPE_INFO)) {
    sub NG_NAT_LISTRDRS_ENTRY_TYPE_INFO {
	my($desctype) = @_;
	eval q({ { \"id\",  &ng_parse_uint32_type }, { \"local_addr\",  &ng_parse_ipaddr_type }, { \"alias_addr\",  &ng_parse_ipaddr_type }, { \"remote_addr\",  &ng_parse_ipaddr_type }, { \"local_port\",  &ng_parse_uint16_type }, { \"alias_port\",  &ng_parse_uint16_type }, { \"remote_port\",  &ng_parse_uint16_type }, { \"proto\",  &ng_parse_uint16_type }, { \"lsnat\",  &ng_parse_uint16_type }, { \"description\", ($desctype) }, {  &NULL } });
    }
}
unless(defined(&NG_NAT_LIST_REDIRECTS_TYPE_INFO)) {
    sub NG_NAT_LIST_REDIRECTS_TYPE_INFO {
	my($redirtype) = @_;
	eval q({ { \"total_count\",  &ng_parse_uint32_type }, { \"redirects\", ($redirtype) }, {  &NULL } });
    }
}
eval 'sub NG_NAT_LIBALIAS_INFO () {{ { "icmpLinkCount",  &ng_parse_uint32_type }, { "udpLinkCount",  &ng_parse_uint32_type }, { "tcpLinkCount",  &ng_parse_uint32_type }, { "sctpLinkCount",  &ng_parse_uint32_type }, { "pptpLinkCount",  &ng_parse_uint32_type }, { "protoLinkCount",  &ng_parse_uint32_type }, { "fragmentIdLinkCount",  &ng_parse_uint32_type }, { "fragmentPtrLinkCount",  &ng_parse_uint32_type }, { "sockCount",  &ng_parse_uint32_type }, {  &NULL } };}' unless defined(&NG_NAT_LIBALIAS_INFO);
eval("sub NGM_NAT_SET_IPADDR () { 1; }") unless defined(&NGM_NAT_SET_IPADDR);
eval("sub NGM_NAT_SET_MODE () { 2; }") unless defined(&NGM_NAT_SET_MODE);
eval("sub NGM_NAT_SET_TARGET () { 3; }") unless defined(&NGM_NAT_SET_TARGET);
eval("sub NGM_NAT_REDIRECT_PORT () { 4; }") unless defined(&NGM_NAT_REDIRECT_PORT);
eval("sub NGM_NAT_REDIRECT_ADDR () { 5; }") unless defined(&NGM_NAT_REDIRECT_ADDR);
eval("sub NGM_NAT_REDIRECT_PROTO () { 6; }") unless defined(&NGM_NAT_REDIRECT_PROTO);
eval("sub NGM_NAT_REDIRECT_DYNAMIC () { 7; }") unless defined(&NGM_NAT_REDIRECT_DYNAMIC);
eval("sub NGM_NAT_REDIRECT_DELETE () { 8; }") unless defined(&NGM_NAT_REDIRECT_DELETE);
eval("sub NGM_NAT_ADD_SERVER () { 9; }") unless defined(&NGM_NAT_ADD_SERVER);
eval("sub NGM_NAT_LIST_REDIRECTS () { 10; }") unless defined(&NGM_NAT_LIST_REDIRECTS);
eval("sub NGM_NAT_PROXY_RULE () { 11; }") unless defined(&NGM_NAT_PROXY_RULE);
eval("sub NGM_NAT_LIBALIAS_INFO () { 12; }") unless defined(&NGM_NAT_LIBALIAS_INFO);
1;
