require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETGRAPH_NG_PATCH_H_)) {
    eval 'sub _NETGRAPH_NG_PATCH_H_ () {1;}' unless defined(&_NETGRAPH_NG_PATCH_H_);
    eval 'sub NG_PATCH_NODE_TYPE () {"patch";}' unless defined(&NG_PATCH_NODE_TYPE);
    eval 'sub NGM_PATCH_COOKIE () {1262445509;}' unless defined(&NGM_PATCH_COOKIE);
    eval 'sub NG_PATCH_HOOK_IN () {"in";}' unless defined(&NG_PATCH_HOOK_IN);
    eval 'sub NG_PATCH_HOOK_OUT () {"out";}' unless defined(&NG_PATCH_HOOK_OUT);
    eval 'sub NG_PATCH_CSUM_IPV4 () {( &CSUM_IP| &CSUM_TCP| &CSUM_UDP| &CSUM_SCTP);}' unless defined(&NG_PATCH_CSUM_IPV4);
    eval 'sub NG_PATCH_CSUM_IPV6 () {( &CSUM_TCP_IPV6| &CSUM_UDP_IPV6| &CSUM_SCTP_IPV6);}' unless defined(&NG_PATCH_CSUM_IPV6);
    eval("sub NGM_PATCH_SETCONFIG () { 1; }") unless defined(&NGM_PATCH_SETCONFIG);
    eval("sub NGM_PATCH_GETCONFIG () { 2; }") unless defined(&NGM_PATCH_GETCONFIG);
    eval("sub NGM_PATCH_GET_STATS () { 3; }") unless defined(&NGM_PATCH_GET_STATS);
    eval("sub NGM_PATCH_CLR_STATS () { 4; }") unless defined(&NGM_PATCH_CLR_STATS);
    eval("sub NGM_PATCH_GETCLR_STATS () { 5; }") unless defined(&NGM_PATCH_GETCLR_STATS);
    eval("sub NGM_PATCH_GETDLT () { 6; }") unless defined(&NGM_PATCH_GETDLT);
    eval("sub NGM_PATCH_SETDLT () { 7; }") unless defined(&NGM_PATCH_SETDLT);
    eval("sub NG_PATCH_MODE_SET () { 1; }") unless defined(&NG_PATCH_MODE_SET);
    eval("sub NG_PATCH_MODE_ADD () { 2; }") unless defined(&NG_PATCH_MODE_ADD);
    eval("sub NG_PATCH_MODE_SUB () { 3; }") unless defined(&NG_PATCH_MODE_SUB);
    eval("sub NG_PATCH_MODE_MUL () { 4; }") unless defined(&NG_PATCH_MODE_MUL);
    eval("sub NG_PATCH_MODE_DIV () { 5; }") unless defined(&NG_PATCH_MODE_DIV);
    eval("sub NG_PATCH_MODE_NEG () { 6; }") unless defined(&NG_PATCH_MODE_NEG);
    eval("sub NG_PATCH_MODE_AND () { 7; }") unless defined(&NG_PATCH_MODE_AND);
    eval("sub NG_PATCH_MODE_OR () { 8; }") unless defined(&NG_PATCH_MODE_OR);
    eval("sub NG_PATCH_MODE_XOR () { 9; }") unless defined(&NG_PATCH_MODE_XOR);
    eval("sub NG_PATCH_MODE_SHL () { 10; }") unless defined(&NG_PATCH_MODE_SHL);
    eval("sub NG_PATCH_MODE_SHR () { 11; }") unless defined(&NG_PATCH_MODE_SHR);
    eval 'sub NG_PATCH_CONFIG_TYPE () {{ { "count",  &ng_parse_uint32_type }, { "csum_flags",  &ng_parse_uint64_type }, { "relative_offset",  &ng_parse_uint32_type }, { "ops",  &ng_patch_ops_array_type }, {  &NULL } };}' unless defined(&NG_PATCH_CONFIG_TYPE);
    eval 'sub NG_PATCH_OP_TYPE () {{ { "offset",  &ng_parse_uint32_type }, { "length",  &ng_parse_uint16_type }, { "mode",  &ng_parse_uint16_type }, { "value",  &ng_parse_uint64_type }, {  &NULL } };}' unless defined(&NG_PATCH_OP_TYPE);
    eval 'sub NG_PATCH_STATS_TYPE () {{ { "Received",  &ng_parse_uint64_type }, { "Patched",  &ng_parse_uint64_type }, { "Dropped",  &ng_parse_uint64_type }, {  &NULL } };}' unless defined(&NG_PATCH_STATS_TYPE);
    eval 'sub NG_PATCH_CONF_SIZE {
        my($count) = @_;
	    eval q(($sizeof{\'struct ng_patch_config\'} + ($count) * $sizeof{\'struct ng_patch_op\'}));
    }' unless defined(&NG_PATCH_CONF_SIZE);
}
1;
