require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETGRAPH_NG_PPPOE_H_)) {
    eval 'sub _NETGRAPH_NG_PPPOE_H_ () {1;}' unless defined(&_NETGRAPH_NG_PPPOE_H_);
    eval 'sub NG_PPPOE_NODE_TYPE () {"pppoe";}' unless defined(&NG_PPPOE_NODE_TYPE);
    eval 'sub NGM_PPPOE_COOKIE () {1089893072;}' unless defined(&NGM_PPPOE_COOKIE);
    eval 'sub NGM_PPPOE_SETMAXP_COOKIE () {1441624322;}' unless defined(&NGM_PPPOE_SETMAXP_COOKIE);
    eval 'sub NGM_PPPOE_PADM_COOKIE () {1488405822;}' unless defined(&NGM_PPPOE_PADM_COOKIE);
    eval 'sub PPPOE_SERVICE_NAME_SIZE () {64;}' unless defined(&PPPOE_SERVICE_NAME_SIZE);
    eval 'sub PPPOE_PADM_VALUE_SIZE () {128;}' unless defined(&PPPOE_PADM_VALUE_SIZE);
    eval 'sub NG_PPPOE_HOOK_ETHERNET () {"ethernet";}' unless defined(&NG_PPPOE_HOOK_ETHERNET);
    eval 'sub NG_PPPOE_HOOK_DEBUG () {"debug";}' unless defined(&NG_PPPOE_HOOK_DEBUG);
    eval 'sub NG_PPPOE_STANDARD () {"standard";}' unless defined(&NG_PPPOE_STANDARD);
    eval 'sub NG_PPPOE_3COM () {"3Com";}' unless defined(&NG_PPPOE_3COM);
    eval 'sub NG_PPPOE_NONSTANDARD () { &NG_PPPOE_3COM;}' unless defined(&NG_PPPOE_NONSTANDARD);
    eval 'sub NG_PPPOE_DLINK () {"D-Link";}' unless defined(&NG_PPPOE_DLINK);
    eval("sub NGM_PPPOE_SET_FLAG () { 1; }") unless defined(&NGM_PPPOE_SET_FLAG);
    eval("sub NGM_PPPOE_CONNECT () { 2; }") unless defined(&NGM_PPPOE_CONNECT);
    eval("sub NGM_PPPOE_LISTEN () { 3; }") unless defined(&NGM_PPPOE_LISTEN);
    eval("sub NGM_PPPOE_OFFER () { 4; }") unless defined(&NGM_PPPOE_OFFER);
    eval("sub NGM_PPPOE_SUCCESS () { 5; }") unless defined(&NGM_PPPOE_SUCCESS);
    eval("sub NGM_PPPOE_FAIL () { 6; }") unless defined(&NGM_PPPOE_FAIL);
    eval("sub NGM_PPPOE_CLOSE () { 7; }") unless defined(&NGM_PPPOE_CLOSE);
    eval("sub NGM_PPPOE_SERVICE () { 8; }") unless defined(&NGM_PPPOE_SERVICE);
    eval("sub NGM_PPPOE_ACNAME () { 9; }") unless defined(&NGM_PPPOE_ACNAME);
    eval("sub NGM_PPPOE_GET_STATUS () { 10; }") unless defined(&NGM_PPPOE_GET_STATUS);
    eval("sub NGM_PPPOE_SESSIONID () { 11; }") unless defined(&NGM_PPPOE_SESSIONID);
    eval("sub NGM_PPPOE_SETMODE () { 12; }") unless defined(&NGM_PPPOE_SETMODE);
    eval("sub NGM_PPPOE_GETMODE () { 13; }") unless defined(&NGM_PPPOE_GETMODE);
    eval("sub NGM_PPPOE_SETENADDR () { 14; }") unless defined(&NGM_PPPOE_SETENADDR);
    eval("sub NGM_PPPOE_SETMAXP () { 15; }") unless defined(&NGM_PPPOE_SETMAXP);
    eval("sub NGM_PPPOE_SEND_HURL () { 16; }") unless defined(&NGM_PPPOE_SEND_HURL);
    eval("sub NGM_PPPOE_HURL () { 17; }") unless defined(&NGM_PPPOE_HURL);
    eval("sub NGM_PPPOE_SEND_MOTM () { 18; }") unless defined(&NGM_PPPOE_SEND_MOTM);
    eval("sub NGM_PPPOE_MOTM () { 19; }") unless defined(&NGM_PPPOE_MOTM);
    eval 'sub NG_PPPOESTAT_TYPE_INFO () {{ { "packets_in",  &ng_parse_uint_type }, { "packets_out",  &ng_parse_uint_type }, {  &NULL } };}' unless defined(&NG_PPPOESTAT_TYPE_INFO);
    eval 'sub NG_PPPOE_INIT_DATA_TYPE_INFO () {{ { "hook",  &ng_parse_hookbuf_type }, { "data",  &ng_parse_sizedstring_type }, {  &NULL } };}' unless defined(&NG_PPPOE_INIT_DATA_TYPE_INFO);
    eval 'sub NG_PPPOE_STS_TYPE_INFO () {{ { "hook",  &ng_parse_hookbuf_type }, {  &NULL } };}' unless defined(&NG_PPPOE_STS_TYPE_INFO);
    eval 'sub PPPOE_TIMEOUT_LIMIT () {64;}' unless defined(&PPPOE_TIMEOUT_LIMIT);
    eval 'sub PPPOE_OFFER_TIMEOUT () {16;}' unless defined(&PPPOE_OFFER_TIMEOUT);
    eval 'sub PPPOE_INITIAL_TIMEOUT () {2;}' unless defined(&PPPOE_INITIAL_TIMEOUT);
    eval 'sub PADI_CODE () {0x9;}' unless defined(&PADI_CODE);
    eval 'sub PADO_CODE () {0x7;}' unless defined(&PADO_CODE);
    eval 'sub PADR_CODE () {0x19;}' unless defined(&PADR_CODE);
    eval 'sub PADS_CODE () {0x65;}' unless defined(&PADS_CODE);
    eval 'sub PADT_CODE () {0xa7;}' unless defined(&PADT_CODE);
    eval 'sub PADM_CODE () {0xd3;}' unless defined(&PADM_CODE);
    if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
	eval 'sub PTT_EOL () {(0x);}' unless defined(&PTT_EOL);
	eval 'sub PTT_SRV_NAME () {(0x101);}' unless defined(&PTT_SRV_NAME);
	eval 'sub PTT_AC_NAME () {(0x102);}' unless defined(&PTT_AC_NAME);
	eval 'sub PTT_HOST_UNIQ () {(0x103);}' unless defined(&PTT_HOST_UNIQ);
	eval 'sub PTT_AC_COOKIE () {(0x104);}' unless defined(&PTT_AC_COOKIE);
	eval 'sub PTT_VENDOR () {(0x105);}' unless defined(&PTT_VENDOR);
	eval 'sub PTT_RELAY_SID () {(0x110);}' unless defined(&PTT_RELAY_SID);
	eval 'sub PTT_HURL () {(0x111);}' unless defined(&PTT_HURL);
	eval 'sub PTT_MOTM () {(0x112);}' unless defined(&PTT_MOTM);
	eval 'sub PTT_MAX_PAYL () {(0x120);}' unless defined(&PTT_MAX_PAYL);
	eval 'sub PTT_SRV_ERR () {(0x201);}' unless defined(&PTT_SRV_ERR);
	eval 'sub PTT_SYS_ERR () {(0x202);}' unless defined(&PTT_SYS_ERR);
	eval 'sub PTT_GEN_ERR () {(0x203);}' unless defined(&PTT_GEN_ERR);
	eval 'sub ETHERTYPE_PPPOE_DISC () {0x8863;}' unless defined(&ETHERTYPE_PPPOE_DISC);
	eval 'sub ETHERTYPE_PPPOE_SESS () {0x8864;}' unless defined(&ETHERTYPE_PPPOE_SESS);
	eval 'sub ETHERTYPE_PPPOE_3COM_DISC () {0x3c12;}' unless defined(&ETHERTYPE_PPPOE_3COM_DISC);
	eval 'sub ETHERTYPE_PPPOE_3COM_SESS () {0x3c13;}' unless defined(&ETHERTYPE_PPPOE_3COM_SESS);
    } else {
	eval 'sub PTT_EOL () {(0x);}' unless defined(&PTT_EOL);
	eval 'sub PTT_SRV_NAME () {(0x101);}' unless defined(&PTT_SRV_NAME);
	eval 'sub PTT_AC_NAME () {(0x201);}' unless defined(&PTT_AC_NAME);
	eval 'sub PTT_HOST_UNIQ () {(0x301);}' unless defined(&PTT_HOST_UNIQ);
	eval 'sub PTT_AC_COOKIE () {(0x401);}' unless defined(&PTT_AC_COOKIE);
	eval 'sub PTT_VENDOR () {(0x501);}' unless defined(&PTT_VENDOR);
	eval 'sub PTT_RELAY_SID () {(0x1001);}' unless defined(&PTT_RELAY_SID);
	eval 'sub PTT_HURL () {(0x1101);}' unless defined(&PTT_HURL);
	eval 'sub PTT_MOTM () {(0x1201);}' unless defined(&PTT_MOTM);
	eval 'sub PTT_MAX_PAYL () {(0x2001);}' unless defined(&PTT_MAX_PAYL);
	eval 'sub PTT_SRV_ERR () {(0x102);}' unless defined(&PTT_SRV_ERR);
	eval 'sub PTT_SYS_ERR () {(0x202);}' unless defined(&PTT_SYS_ERR);
	eval 'sub PTT_GEN_ERR () {(0x302);}' unless defined(&PTT_GEN_ERR);
	eval 'sub ETHERTYPE_PPPOE_DISC () {0x6388;}' unless defined(&ETHERTYPE_PPPOE_DISC);
	eval 'sub ETHERTYPE_PPPOE_SESS () {0x6488;}' unless defined(&ETHERTYPE_PPPOE_SESS);
	eval 'sub ETHERTYPE_PPPOE_3COM_DISC () {0x123c;}' unless defined(&ETHERTYPE_PPPOE_3COM_DISC);
	eval 'sub ETHERTYPE_PPPOE_3COM_SESS () {0x133c;}' unless defined(&ETHERTYPE_PPPOE_3COM_SESS);
    }
    eval 'sub TAGI_SVC () {0;}' unless defined(&TAGI_SVC);
    eval 'sub TAGI_HUNIQ () {1;}' unless defined(&TAGI_HUNIQ);
    eval 'sub TAGO_ACNAME () {0;}' unless defined(&TAGO_ACNAME);
    eval 'sub TAGO_SVC () {1;}' unless defined(&TAGO_SVC);
    eval 'sub TAGO_COOKIE () {2;}' unless defined(&TAGO_COOKIE);
    eval 'sub TAGO_HUNIQ () {3;}' unless defined(&TAGO_HUNIQ);
    eval 'sub TAGR_SVC () {0;}' unless defined(&TAGR_SVC);
    eval 'sub TAGR_HUNIQ () {1;}' unless defined(&TAGR_HUNIQ);
    eval 'sub TAGR_COOKIE () {2;}' unless defined(&TAGR_COOKIE);
    eval 'sub TAGS_ACNAME () {0;}' unless defined(&TAGS_ACNAME);
    eval 'sub TAGS_SVC () {1;}' unless defined(&TAGS_SVC);
    eval 'sub TAGS_COOKIE () {2;}' unless defined(&TAGS_COOKIE);
    eval 'sub TAGS_HUNIQ () {3;}' unless defined(&TAGS_HUNIQ);
}
1;
