require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_CC_CC_H_)) {
    eval 'sub _NETINET_CC_CC_H_ () {1;}' unless defined(&_NETINET_CC_CC_H_);
    if(!defined(&_KERNEL)) {
	die("no user-servicable parts inside");
    }
    eval 'sub V_default_cc_ptr () { &VNET( &default_cc_ptr);}' unless defined(&V_default_cc_ptr);
    eval 'sub CCF_ABC_SENTAWND () {0x1;}' unless defined(&CCF_ABC_SENTAWND);
    eval 'sub CCF_CWND_LIMITED () {0x2;}' unless defined(&CCF_CWND_LIMITED);
    eval 'sub CCF_DELACK () {0x4;}' unless defined(&CCF_DELACK);
    eval 'sub CCF_ACKNOW () {0x8;}' unless defined(&CCF_ACKNOW);
    eval 'sub CCF_IPHDR_CE () {0x10;}' unless defined(&CCF_IPHDR_CE);
    eval 'sub CCF_TCPHDR_CWR () {0x20;}' unless defined(&CCF_TCPHDR_CWR);
    eval 'sub CC_ACK () {0x1;}' unless defined(&CC_ACK);
    eval 'sub CC_DUPACK () {0x2;}' unless defined(&CC_DUPACK);
    eval 'sub CC_PARTIALACK () {0x4;}' unless defined(&CC_PARTIALACK);
    eval 'sub CC_SACK () {0x8;}' unless defined(&CC_SACK);
    eval 'sub CC_ECN () {0x1;}' unless defined(&CC_ECN);
    eval 'sub CC_RTO () {0x2;}' unless defined(&CC_RTO);
    eval 'sub CC_RTO_ERR () {0x4;}' unless defined(&CC_RTO_ERR);
    eval 'sub CC_NDUPACK () {0x8;}' unless defined(&CC_NDUPACK);
    eval 'sub CC_SIGPRIVMASK () {0xff000000;}' unless defined(&CC_SIGPRIVMASK);
    eval 'sub CC_ALGO {
        my($tp) = @_;
	    eval q((($tp)-> &cc_algo));
    }' unless defined(&CC_ALGO);
    eval 'sub CC_DATA {
        my($tp) = @_;
	    eval q((($tp)-> ($ccv->{cc_data})));
    }' unless defined(&CC_DATA);
    eval 'sub CC_DEFAULT () {
        eval q( &V_default_cc_ptr);
    }' unless defined(&CC_DEFAULT);
    eval 'sub CC_LIST_LOCK_INIT () {
        eval q( &rw_init( &cc_list_lock, \\"cc_list\\"));
    }' unless defined(&CC_LIST_LOCK_INIT);
    eval 'sub CC_LIST_LOCK_DESTROY () {
        eval q( &rw_destroy( &cc_list_lock));
    }' unless defined(&CC_LIST_LOCK_DESTROY);
    eval 'sub CC_LIST_RLOCK () {
        eval q( &rw_rlock( &cc_list_lock));
    }' unless defined(&CC_LIST_RLOCK);
    eval 'sub CC_LIST_RUNLOCK () {
        eval q( &rw_runlock( &cc_list_lock));
    }' unless defined(&CC_LIST_RUNLOCK);
    eval 'sub CC_LIST_WLOCK () {
        eval q( &rw_wlock( &cc_list_lock));
    }' unless defined(&CC_LIST_WLOCK);
    eval 'sub CC_LIST_WUNLOCK () {
        eval q( &rw_wunlock( &cc_list_lock));
    }' unless defined(&CC_LIST_WUNLOCK);
    eval 'sub CC_LIST_LOCK_ASSERT () {
        eval q( &rw_assert( &cc_list_lock,  &RA_LOCKED));
    }' unless defined(&CC_LIST_LOCK_ASSERT);
}
1;
