require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_CC_CUBIC_H_)) {
    eval 'sub _NETINET_CC_CUBIC_H_ () {1;}' unless defined(&_NETINET_CC_CUBIC_H_);
    eval 'sub CUBIC_SHIFT () {8;}' unless defined(&CUBIC_SHIFT);
    eval 'sub CUBIC_SHIFT_4 () {32;}' unless defined(&CUBIC_SHIFT_4);
    eval 'sub RENO_BETA () {128;}' unless defined(&RENO_BETA);
    eval 'sub CUBIC_BETA () {204;}' unless defined(&CUBIC_BETA);
    eval 'sub ONE_SUB_CUBIC_BETA () {51;}' unless defined(&ONE_SUB_CUBIC_BETA);
    eval 'sub THREE_X_PT2 () {153;}' unless defined(&THREE_X_PT2);
    eval 'sub TWO_SUB_PT2 () {461;}' unless defined(&TWO_SUB_PT2);
    eval 'sub CUBIC_C_FACTOR () {102;}' unless defined(&CUBIC_C_FACTOR);
    eval 'sub CUBIC_FC_FACTOR () {230;}' unless defined(&CUBIC_FC_FACTOR);
    eval 'sub CUBIC_MIN_RTT_SAMPLES () {8;}' unless defined(&CUBIC_MIN_RTT_SAMPLES);
    unless(defined(&_KERNEL)) {
	eval 'sub theoretical_cubic_cwnd {
	    my($ticks_since_cong,$wmax,$smss) = @_;
    	    eval q({ \'double\'  &C,  &wmax_pkts;  &C = 0.4;  &wmax_pkts = $wmax / $smss; ($smss * ( &wmax_pkts + ( &C *  &pow($ticks_since_cong /  &hz -  &theoretical_cubic_k( &wmax_pkts) /  &pow(2,  &CUBIC_SHIFT), 3.0)))); });
	}' unless defined(&theoretical_cubic_cwnd);
	eval 'sub theoretical_reno_cwnd {
	    my($ticks_since_cong,$rtt_ticks,$wmax,$smss) = @_;
    	    eval q({ (($wmax * 0.5) + (($ticks_since_cong / $rtt_ticks) * $smss)); });
	}' unless defined(&theoretical_reno_cwnd);
	eval 'sub theoretical_tf_cwnd {
	    my($ticks_since_cong,$rtt_ticks,$wmax,$smss) = @_;
    	    eval q({ (($wmax * 0.8) + ((3* 0.2) / (2- 0.2) * ($ticks_since_cong / $rtt_ticks) * $smss)); });
	}' unless defined(&theoretical_tf_cwnd);
    }
}
1;
