require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_ICMP_VAR_H_)) {
    eval 'sub _NETINET_ICMP_VAR_H_ () {1;}' unless defined(&_NETINET_ICMP_VAR_H_);
    if(defined(&_KERNEL)) {
	require 'sys/counter.ph';
	eval 'sub ICMPSTAT_ADD {
	    my($name, $val) = @_;
    	    eval q( &VNET_PCPUSTAT_ADD(\'struct icmpstat\',  &icmpstat, $name, ($val)));
	}' unless defined(&ICMPSTAT_ADD);
	eval 'sub ICMPSTAT_INC {
	    my($name) = @_;
    	    eval q( &ICMPSTAT_ADD($name, 1));
	}' unless defined(&ICMPSTAT_INC);
	eval 'sub KMOD_ICMPSTAT_INC {
	    my($name) = @_;
    	    eval q( &kmod_icmpstat_inc( &offsetof(\'struct icmpstat\', $name) / $sizeof{ &uint64_t}));
	}' unless defined(&KMOD_ICMPSTAT_INC);
    }
    eval 'sub ICMPCTL_MASKREPL () {1;}' unless defined(&ICMPCTL_MASKREPL);
    eval 'sub ICMPCTL_STATS () {2;}' unless defined(&ICMPCTL_STATS);
    eval 'sub ICMPCTL_ICMPLIM () {3;}' unless defined(&ICMPCTL_ICMPLIM);
    if(defined(&_KERNEL)) {
	eval 'sub BANDLIM_UNLIMITED () {-1;}' unless defined(&BANDLIM_UNLIMITED);
	eval 'sub BANDLIM_ICMP_UNREACH () {0;}' unless defined(&BANDLIM_ICMP_UNREACH);
	eval 'sub BANDLIM_ICMP_ECHO () {1;}' unless defined(&BANDLIM_ICMP_ECHO);
	eval 'sub BANDLIM_ICMP_TSTAMP () {2;}' unless defined(&BANDLIM_ICMP_TSTAMP);
	eval 'sub BANDLIM_RST_CLOSEDPORT () {3;}' unless defined(&BANDLIM_RST_CLOSEDPORT);
	eval 'sub BANDLIM_RST_OPENPORT () {4;}' unless defined(&BANDLIM_RST_OPENPORT);
	eval 'sub BANDLIM_ICMP6_UNREACH () {5;}' unless defined(&BANDLIM_ICMP6_UNREACH);
	eval 'sub BANDLIM_SCTP_OOTB () {6;}' unless defined(&BANDLIM_SCTP_OOTB);
	eval 'sub BANDLIM_MAX () {6;}' unless defined(&BANDLIM_MAX);
    }
}
1;
