require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_IGMP_H_)) {
    eval 'sub _NETINET_IGMP_H_ () {1;}' unless defined(&_NETINET_IGMP_H_);
    eval 'sub IGMP_MINLEN () {8;}' unless defined(&IGMP_MINLEN);
    eval 'sub IGMP_V3_QUERY_MINLEN () {12;}' unless defined(&IGMP_V3_QUERY_MINLEN);
    eval 'sub IGMP_EXP {
        my($x) = @_;
	    eval q(((($x) >> 4) & 0x7));
    }' unless defined(&IGMP_EXP);
    eval 'sub IGMP_MANT {
        my($x) = @_;
	    eval q((($x) & 0xf));
    }' unless defined(&IGMP_MANT);
    eval 'sub IGMP_QRESV {
        my($x) = @_;
	    eval q(((($x) >> 4) & 0xf));
    }' unless defined(&IGMP_QRESV);
    eval 'sub IGMP_SFLAG {
        my($x) = @_;
	    eval q(((($x) >> 3) & 0x1));
    }' unless defined(&IGMP_SFLAG);
    eval 'sub IGMP_QRV {
        my($x) = @_;
	    eval q((($x) & 0x7));
    }' unless defined(&IGMP_QRV);
    eval 'sub IGMP_GRPREC_HDRLEN () {8;}' unless defined(&IGMP_GRPREC_HDRLEN);
    eval 'sub IGMP_V3_REPORT_MINLEN () {8;}' unless defined(&IGMP_V3_REPORT_MINLEN);
    eval 'sub IGMP_V3_REPORT_MAXRECS () {65535;}' unless defined(&IGMP_V3_REPORT_MAXRECS);
    eval 'sub IGMP_HOST_MEMBERSHIP_QUERY () {0x11;}' unless defined(&IGMP_HOST_MEMBERSHIP_QUERY);
    eval 'sub IGMP_v1_HOST_MEMBERSHIP_REPORT () {0x12;}' unless defined(&IGMP_v1_HOST_MEMBERSHIP_REPORT);
    eval 'sub IGMP_DVMRP () {0x13;}' unless defined(&IGMP_DVMRP);
    eval 'sub IGMP_PIM () {0x14;}' unless defined(&IGMP_PIM);
    eval 'sub IGMP_v2_HOST_MEMBERSHIP_REPORT () {0x16;}' unless defined(&IGMP_v2_HOST_MEMBERSHIP_REPORT);
    eval 'sub IGMP_HOST_LEAVE_MESSAGE () {0x17;}' unless defined(&IGMP_HOST_LEAVE_MESSAGE);
    eval 'sub IGMP_MTRACE_REPLY () {0x1e;}' unless defined(&IGMP_MTRACE_REPLY);
    eval 'sub IGMP_MTRACE_QUERY () {0x1f;}' unless defined(&IGMP_MTRACE_QUERY);
    eval 'sub IGMP_v3_HOST_MEMBERSHIP_REPORT () {0x22;}' unless defined(&IGMP_v3_HOST_MEMBERSHIP_REPORT);
    eval 'sub IGMP_DO_NOTHING () {0;}' unless defined(&IGMP_DO_NOTHING);
    eval 'sub IGMP_MODE_IS_INCLUDE () {1;}' unless defined(&IGMP_MODE_IS_INCLUDE);
    eval 'sub IGMP_MODE_IS_EXCLUDE () {2;}' unless defined(&IGMP_MODE_IS_EXCLUDE);
    eval 'sub IGMP_CHANGE_TO_INCLUDE_MODE () {3;}' unless defined(&IGMP_CHANGE_TO_INCLUDE_MODE);
    eval 'sub IGMP_CHANGE_TO_EXCLUDE_MODE () {4;}' unless defined(&IGMP_CHANGE_TO_EXCLUDE_MODE);
    eval 'sub IGMP_ALLOW_NEW_SOURCES () {5;}' unless defined(&IGMP_ALLOW_NEW_SOURCES);
    eval 'sub IGMP_BLOCK_OLD_SOURCES () {6;}' unless defined(&IGMP_BLOCK_OLD_SOURCES);
    eval 'sub IGMP_V3_GENERAL_QUERY () {1;}' unless defined(&IGMP_V3_GENERAL_QUERY);
    eval 'sub IGMP_V3_GROUP_QUERY () {2;}' unless defined(&IGMP_V3_GROUP_QUERY);
    eval 'sub IGMP_V3_GROUP_SOURCE_QUERY () {3;}' unless defined(&IGMP_V3_GROUP_SOURCE_QUERY);
    eval 'sub IGMP_V1V2_MAX_RI () {10;}' unless defined(&IGMP_V1V2_MAX_RI);
    eval 'sub IGMP_MAX_HOST_REPORT_DELAY () { &IGMP_V1V2_MAX_RI;}' unless defined(&IGMP_MAX_HOST_REPORT_DELAY);
    eval 'sub IGMP_TIMER_SCALE () {10;}' unless defined(&IGMP_TIMER_SCALE);
}
1;
