require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_IN_H_)) {
    eval 'sub _NETINET_IN_H_ () {1;}' unless defined(&_NETINET_IN_H_);
    require 'sys/cdefs.ph';
    require 'sys/_types.ph';
    require 'machine/endian.ph';
    eval 'sub IPPROTO_IP () {0;}' unless defined(&IPPROTO_IP);
    eval 'sub IPPROTO_ICMP () {1;}' unless defined(&IPPROTO_ICMP);
    eval 'sub IPPROTO_TCP () {6;}' unless defined(&IPPROTO_TCP);
    eval 'sub IPPROTO_UDP () {17;}' unless defined(&IPPROTO_UDP);
    eval 'sub INADDR_ANY () {(( &in_addr_t)0x);}' unless defined(&INADDR_ANY);
    eval 'sub INADDR_BROADCAST () {(( &in_addr_t)0xffffffff);}' unless defined(&INADDR_BROADCAST);
    unless(defined(&_UINT8_T_DECLARED)) {
	eval 'sub _UINT8_T_DECLARED () {1;}' unless defined(&_UINT8_T_DECLARED);
    }
    unless(defined(&_UINT16_T_DECLARED)) {
	eval 'sub _UINT16_T_DECLARED () {1;}' unless defined(&_UINT16_T_DECLARED);
    }
    unless(defined(&_UINT32_T_DECLARED)) {
	eval 'sub _UINT32_T_DECLARED () {1;}' unless defined(&_UINT32_T_DECLARED);
    }
    unless(defined(&_IN_ADDR_T_DECLARED)) {
	eval 'sub _IN_ADDR_T_DECLARED () {1;}' unless defined(&_IN_ADDR_T_DECLARED);
    }
    unless(defined(&_IN_PORT_T_DECLARED)) {
	eval 'sub _IN_PORT_T_DECLARED () {1;}' unless defined(&_IN_PORT_T_DECLARED);
    }
    unless(defined(&_SA_FAMILY_T_DECLARED)) {
	eval 'sub _SA_FAMILY_T_DECLARED () {1;}' unless defined(&_SA_FAMILY_T_DECLARED);
    }
    unless(defined(&_STRUCT_IN_ADDR_DECLARED)) {
	eval 'sub _STRUCT_IN_ADDR_DECLARED () {1;}' unless defined(&_STRUCT_IN_ADDR_DECLARED);
    }
    unless(defined(&_SOCKLEN_T_DECLARED)) {
	eval 'sub _SOCKLEN_T_DECLARED () {1;}' unless defined(&_SOCKLEN_T_DECLARED);
    }
    require 'sys/_sockaddr_storage.ph';
    if(!defined(&_KERNEL)  && (defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200112) {
	unless(defined(&_BYTEORDER_PROTOTYPED)) {
	    eval 'sub _BYTEORDER_PROTOTYPED () {1;}' unless defined(&_BYTEORDER_PROTOTYPED);
	}
	unless(defined(&_BYTEORDER_FUNC_DEFINED)) {
	    eval 'sub _BYTEORDER_FUNC_DEFINED () {1;}' unless defined(&_BYTEORDER_FUNC_DEFINED);
	    eval 'sub htonl {
	        my($x) = @_;
    		eval q( &__htonl($x));
	    }' unless defined(&htonl);
	    eval 'sub htons {
	        my($x) = @_;
    		eval q( &__htons($x));
	    }' unless defined(&htons);
	    eval 'sub ntohl {
	        my($x) = @_;
    		eval q( &__ntohl($x));
	    }' unless defined(&ntohl);
	    eval 'sub ntohs {
	        my($x) = @_;
    		eval q( &__ntohs($x));
	    }' unless defined(&ntohs);
	}
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200112) {
	eval 'sub IPPROTO_IPV6 () {41;}' unless defined(&IPPROTO_IPV6);
	eval 'sub IPPROTO_RAW () {255;}' unless defined(&IPPROTO_RAW);
	eval 'sub INET_ADDRSTRLEN () {16;}' unless defined(&INET_ADDRSTRLEN);
    }
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub IPPROTO_HOPOPTS () {0;}' unless defined(&IPPROTO_HOPOPTS);
	eval 'sub IPPROTO_IGMP () {2;}' unless defined(&IPPROTO_IGMP);
	eval 'sub IPPROTO_GGP () {3;}' unless defined(&IPPROTO_GGP);
	eval 'sub IPPROTO_IPV4 () {4;}' unless defined(&IPPROTO_IPV4);
	eval 'sub IPPROTO_IPIP () { &IPPROTO_IPV4;}' unless defined(&IPPROTO_IPIP);
	eval 'sub IPPROTO_ST () {7;}' unless defined(&IPPROTO_ST);
	eval 'sub IPPROTO_EGP () {8;}' unless defined(&IPPROTO_EGP);
	eval 'sub IPPROTO_PIGP () {9;}' unless defined(&IPPROTO_PIGP);
	eval 'sub IPPROTO_RCCMON () {10;}' unless defined(&IPPROTO_RCCMON);
	eval 'sub IPPROTO_NVPII () {11;}' unless defined(&IPPROTO_NVPII);
	eval 'sub IPPROTO_PUP () {12;}' unless defined(&IPPROTO_PUP);
	eval 'sub IPPROTO_ARGUS () {13;}' unless defined(&IPPROTO_ARGUS);
	eval 'sub IPPROTO_EMCON () {14;}' unless defined(&IPPROTO_EMCON);
	eval 'sub IPPROTO_XNET () {15;}' unless defined(&IPPROTO_XNET);
	eval 'sub IPPROTO_CHAOS () {16;}' unless defined(&IPPROTO_CHAOS);
	eval 'sub IPPROTO_MUX () {18;}' unless defined(&IPPROTO_MUX);
	eval 'sub IPPROTO_MEAS () {19;}' unless defined(&IPPROTO_MEAS);
	eval 'sub IPPROTO_HMP () {20;}' unless defined(&IPPROTO_HMP);
	eval 'sub IPPROTO_PRM () {21;}' unless defined(&IPPROTO_PRM);
	eval 'sub IPPROTO_IDP () {22;}' unless defined(&IPPROTO_IDP);
	eval 'sub IPPROTO_TRUNK1 () {23;}' unless defined(&IPPROTO_TRUNK1);
	eval 'sub IPPROTO_TRUNK2 () {24;}' unless defined(&IPPROTO_TRUNK2);
	eval 'sub IPPROTO_LEAF1 () {25;}' unless defined(&IPPROTO_LEAF1);
	eval 'sub IPPROTO_LEAF2 () {26;}' unless defined(&IPPROTO_LEAF2);
	eval 'sub IPPROTO_RDP () {27;}' unless defined(&IPPROTO_RDP);
	eval 'sub IPPROTO_IRTP () {28;}' unless defined(&IPPROTO_IRTP);
	eval 'sub IPPROTO_TP () {29;}' unless defined(&IPPROTO_TP);
	eval 'sub IPPROTO_BLT () {30;}' unless defined(&IPPROTO_BLT);
	eval 'sub IPPROTO_NSP () {31;}' unless defined(&IPPROTO_NSP);
	eval 'sub IPPROTO_INP () {32;}' unless defined(&IPPROTO_INP);
	eval 'sub IPPROTO_SEP () {33;}' unless defined(&IPPROTO_SEP);
	eval 'sub IPPROTO_3PC () {34;}' unless defined(&IPPROTO_3PC);
	eval 'sub IPPROTO_IDPR () {35;}' unless defined(&IPPROTO_IDPR);
	eval 'sub IPPROTO_XTP () {36;}' unless defined(&IPPROTO_XTP);
	eval 'sub IPPROTO_DDP () {37;}' unless defined(&IPPROTO_DDP);
	eval 'sub IPPROTO_CMTP () {38;}' unless defined(&IPPROTO_CMTP);
	eval 'sub IPPROTO_TPXX () {39;}' unless defined(&IPPROTO_TPXX);
	eval 'sub IPPROTO_IL () {40;}' unless defined(&IPPROTO_IL);
	eval 'sub IPPROTO_SDRP () {42;}' unless defined(&IPPROTO_SDRP);
	eval 'sub IPPROTO_ROUTING () {43;}' unless defined(&IPPROTO_ROUTING);
	eval 'sub IPPROTO_FRAGMENT () {44;}' unless defined(&IPPROTO_FRAGMENT);
	eval 'sub IPPROTO_IDRP () {45;}' unless defined(&IPPROTO_IDRP);
	eval 'sub IPPROTO_RSVP () {46;}' unless defined(&IPPROTO_RSVP);
	eval 'sub IPPROTO_GRE () {47;}' unless defined(&IPPROTO_GRE);
	eval 'sub IPPROTO_MHRP () {48;}' unless defined(&IPPROTO_MHRP);
	eval 'sub IPPROTO_BHA () {49;}' unless defined(&IPPROTO_BHA);
	eval 'sub IPPROTO_ESP () {50;}' unless defined(&IPPROTO_ESP);
	eval 'sub IPPROTO_AH () {51;}' unless defined(&IPPROTO_AH);
	eval 'sub IPPROTO_INLSP () {52;}' unless defined(&IPPROTO_INLSP);
	eval 'sub IPPROTO_SWIPE () {53;}' unless defined(&IPPROTO_SWIPE);
	eval 'sub IPPROTO_NHRP () {54;}' unless defined(&IPPROTO_NHRP);
	eval 'sub IPPROTO_MOBILE () {55;}' unless defined(&IPPROTO_MOBILE);
	eval 'sub IPPROTO_TLSP () {56;}' unless defined(&IPPROTO_TLSP);
	eval 'sub IPPROTO_SKIP () {57;}' unless defined(&IPPROTO_SKIP);
	eval 'sub IPPROTO_ICMPV6 () {58;}' unless defined(&IPPROTO_ICMPV6);
	eval 'sub IPPROTO_NONE () {59;}' unless defined(&IPPROTO_NONE);
	eval 'sub IPPROTO_DSTOPTS () {60;}' unless defined(&IPPROTO_DSTOPTS);
	eval 'sub IPPROTO_AHIP () {61;}' unless defined(&IPPROTO_AHIP);
	eval 'sub IPPROTO_CFTP () {62;}' unless defined(&IPPROTO_CFTP);
	eval 'sub IPPROTO_HELLO () {63;}' unless defined(&IPPROTO_HELLO);
	eval 'sub IPPROTO_SATEXPAK () {64;}' unless defined(&IPPROTO_SATEXPAK);
	eval 'sub IPPROTO_KRYPTOLAN () {65;}' unless defined(&IPPROTO_KRYPTOLAN);
	eval 'sub IPPROTO_RVD () {66;}' unless defined(&IPPROTO_RVD);
	eval 'sub IPPROTO_IPPC () {67;}' unless defined(&IPPROTO_IPPC);
	eval 'sub IPPROTO_ADFS () {68;}' unless defined(&IPPROTO_ADFS);
	eval 'sub IPPROTO_SATMON () {69;}' unless defined(&IPPROTO_SATMON);
	eval 'sub IPPROTO_VISA () {70;}' unless defined(&IPPROTO_VISA);
	eval 'sub IPPROTO_IPCV () {71;}' unless defined(&IPPROTO_IPCV);
	eval 'sub IPPROTO_CPNX () {72;}' unless defined(&IPPROTO_CPNX);
	eval 'sub IPPROTO_CPHB () {73;}' unless defined(&IPPROTO_CPHB);
	eval 'sub IPPROTO_WSN () {74;}' unless defined(&IPPROTO_WSN);
	eval 'sub IPPROTO_PVP () {75;}' unless defined(&IPPROTO_PVP);
	eval 'sub IPPROTO_BRSATMON () {76;}' unless defined(&IPPROTO_BRSATMON);
	eval 'sub IPPROTO_ND () {77;}' unless defined(&IPPROTO_ND);
	eval 'sub IPPROTO_WBMON () {78;}' unless defined(&IPPROTO_WBMON);
	eval 'sub IPPROTO_WBEXPAK () {79;}' unless defined(&IPPROTO_WBEXPAK);
	eval 'sub IPPROTO_EON () {80;}' unless defined(&IPPROTO_EON);
	eval 'sub IPPROTO_VMTP () {81;}' unless defined(&IPPROTO_VMTP);
	eval 'sub IPPROTO_SVMTP () {82;}' unless defined(&IPPROTO_SVMTP);
	eval 'sub IPPROTO_VINES () {83;}' unless defined(&IPPROTO_VINES);
	eval 'sub IPPROTO_TTP () {84;}' unless defined(&IPPROTO_TTP);
	eval 'sub IPPROTO_IGP () {85;}' unless defined(&IPPROTO_IGP);
	eval 'sub IPPROTO_DGP () {86;}' unless defined(&IPPROTO_DGP);
	eval 'sub IPPROTO_TCF () {87;}' unless defined(&IPPROTO_TCF);
	eval 'sub IPPROTO_IGRP () {88;}' unless defined(&IPPROTO_IGRP);
	eval 'sub IPPROTO_OSPFIGP () {89;}' unless defined(&IPPROTO_OSPFIGP);
	eval 'sub IPPROTO_SRPC () {90;}' unless defined(&IPPROTO_SRPC);
	eval 'sub IPPROTO_LARP () {91;}' unless defined(&IPPROTO_LARP);
	eval 'sub IPPROTO_MTP () {92;}' unless defined(&IPPROTO_MTP);
	eval 'sub IPPROTO_AX25 () {93;}' unless defined(&IPPROTO_AX25);
	eval 'sub IPPROTO_IPEIP () {94;}' unless defined(&IPPROTO_IPEIP);
	eval 'sub IPPROTO_MICP () {95;}' unless defined(&IPPROTO_MICP);
	eval 'sub IPPROTO_SCCSP () {96;}' unless defined(&IPPROTO_SCCSP);
	eval 'sub IPPROTO_ETHERIP () {97;}' unless defined(&IPPROTO_ETHERIP);
	eval 'sub IPPROTO_ENCAP () {98;}' unless defined(&IPPROTO_ENCAP);
	eval 'sub IPPROTO_APES () {99;}' unless defined(&IPPROTO_APES);
	eval 'sub IPPROTO_GMTP () {100;}' unless defined(&IPPROTO_GMTP);
	eval 'sub IPPROTO_IPCOMP () {108;}' unless defined(&IPPROTO_IPCOMP);
	eval 'sub IPPROTO_SCTP () {132;}' unless defined(&IPPROTO_SCTP);
	eval 'sub IPPROTO_MH () {135;}' unless defined(&IPPROTO_MH);
	eval 'sub IPPROTO_UDPLITE () {136;}' unless defined(&IPPROTO_UDPLITE);
	eval 'sub IPPROTO_HIP () {139;}' unless defined(&IPPROTO_HIP);
	eval 'sub IPPROTO_SHIM6 () {140;}' unless defined(&IPPROTO_SHIM6);
	eval 'sub IPPROTO_PIM () {103;}' unless defined(&IPPROTO_PIM);
	eval 'sub IPPROTO_CARP () {112;}' unless defined(&IPPROTO_CARP);
	eval 'sub IPPROTO_PGM () {113;}' unless defined(&IPPROTO_PGM);
	eval 'sub IPPROTO_MPLS () {137;}' unless defined(&IPPROTO_MPLS);
	eval 'sub IPPROTO_PFSYNC () {240;}' unless defined(&IPPROTO_PFSYNC);
	eval 'sub IPPROTO_RESERVED_253 () {253;}' unless defined(&IPPROTO_RESERVED_253);
	eval 'sub IPPROTO_RESERVED_254 () {254;}' unless defined(&IPPROTO_RESERVED_254);
	eval 'sub IPPROTO_OLD_DIVERT () {254;}' unless defined(&IPPROTO_OLD_DIVERT);
	eval 'sub IPPROTO_MAX () {256;}' unless defined(&IPPROTO_MAX);
	eval 'sub IPPROTO_DONE () {257;}' unless defined(&IPPROTO_DONE);
	eval 'sub IPPROTO_DIVERT () {258;}' unless defined(&IPPROTO_DIVERT);
	eval 'sub IPPROTO_SEND () {259;}' unless defined(&IPPROTO_SEND);
	eval 'sub IPPROTO_SPACER () {32767;}' unless defined(&IPPROTO_SPACER);
	eval 'sub IPPORT_RESERVED () {1024;}' unless defined(&IPPORT_RESERVED);
	eval 'sub IPPORT_EPHEMERALFIRST () {10000;}' unless defined(&IPPORT_EPHEMERALFIRST);
	eval 'sub IPPORT_EPHEMERALLAST () {65535;}' unless defined(&IPPORT_EPHEMERALLAST);
	eval 'sub IPPORT_HIFIRSTAUTO () {49152;}' unless defined(&IPPORT_HIFIRSTAUTO);
	eval 'sub IPPORT_HILASTAUTO () {65535;}' unless defined(&IPPORT_HILASTAUTO);
	eval 'sub IPPORT_RESERVEDSTART () {600;}' unless defined(&IPPORT_RESERVEDSTART);
	eval 'sub IPPORT_MAX () {65535;}' unless defined(&IPPORT_MAX);
	eval 'sub IN_CLASSA {
	    my($i) = @_;
    	    eval q(((( &in_addr_t)($i) & 0x80000000) == 0));
	}' unless defined(&IN_CLASSA);
	eval 'sub IN_CLASSA_NET () {0xff000000;}' unless defined(&IN_CLASSA_NET);
	eval 'sub IN_CLASSA_NSHIFT () {24;}' unless defined(&IN_CLASSA_NSHIFT);
	eval 'sub IN_CLASSA_HOST () {0xffffff;}' unless defined(&IN_CLASSA_HOST);
	eval 'sub IN_CLASSA_MAX () {128;}' unless defined(&IN_CLASSA_MAX);
	eval 'sub IN_CLASSB {
	    my($i) = @_;
    	    eval q(((( &in_addr_t)($i) & 0xc0000000) == 0x80000000));
	}' unless defined(&IN_CLASSB);
	eval 'sub IN_CLASSB_NET () {0xffff0000;}' unless defined(&IN_CLASSB_NET);
	eval 'sub IN_CLASSB_NSHIFT () {16;}' unless defined(&IN_CLASSB_NSHIFT);
	eval 'sub IN_CLASSB_HOST () {0xffff;}' unless defined(&IN_CLASSB_HOST);
	eval 'sub IN_CLASSB_MAX () {65536;}' unless defined(&IN_CLASSB_MAX);
	eval 'sub IN_CLASSC {
	    my($i) = @_;
    	    eval q(((( &in_addr_t)($i) & 0xe0000000) == 0xc0000000));
	}' unless defined(&IN_CLASSC);
	eval 'sub IN_CLASSC_NET () {0xffffff00;}' unless defined(&IN_CLASSC_NET);
	eval 'sub IN_CLASSC_NSHIFT () {8;}' unless defined(&IN_CLASSC_NSHIFT);
	eval 'sub IN_CLASSC_HOST () {0xff;}' unless defined(&IN_CLASSC_HOST);
	eval 'sub IN_CLASSD {
	    my($i) = @_;
    	    eval q(((( &in_addr_t)($i) & 0xf0000000) == 0xe0000000));
	}' unless defined(&IN_CLASSD);
	eval 'sub IN_CLASSD_NET () {0xf0000000;}' unless defined(&IN_CLASSD_NET);
	eval 'sub IN_CLASSD_NSHIFT () {28;}' unless defined(&IN_CLASSD_NSHIFT);
	eval 'sub IN_CLASSD_HOST () {0xfffffff;}' unless defined(&IN_CLASSD_HOST);
	eval 'sub IN_MULTICAST {
	    my($i) = @_;
    	    eval q( &IN_CLASSD($i));
	}' unless defined(&IN_MULTICAST);
	eval 'sub IN_EXPERIMENTAL {
	    my($i) = @_;
    	    eval q(((( &in_addr_t)($i) & 0xf0000000) == 0xf0000000));
	}' unless defined(&IN_EXPERIMENTAL);
	eval 'sub IN_BADCLASS {
	    my($i) = @_;
    	    eval q(((( &in_addr_t)($i) & 0xf0000000) == 0xf0000000));
	}' unless defined(&IN_BADCLASS);
	eval 'sub IN_LINKLOCAL {
	    my($i) = @_;
    	    eval q(((( &in_addr_t)($i) & 0xffff0000) == 0xa9fe0000));
	}' unless defined(&IN_LINKLOCAL);
	eval 'sub IN_LOOPBACK {
	    my($i) = @_;
    	    eval q(((( &in_addr_t)($i) & 0xff000000) == 0x7f000000));
	}' unless defined(&IN_LOOPBACK);
	eval 'sub IN_ZERONET {
	    my($i) = @_;
    	    eval q(((( &in_addr_t)($i) & 0xff000000) == 0));
	}' unless defined(&IN_ZERONET);
	eval 'sub IN_PRIVATE {
	    my($i) = @_;
    	    eval q((((( &in_addr_t)($i) & 0xff000000) == 0xa000000) || ((( &in_addr_t)($i) & 0xfff00000) == 0xac100000) || ((( &in_addr_t)($i) & 0xffff0000) == 0xc0a80000)));
	}' unless defined(&IN_PRIVATE);
	eval 'sub IN_LOCAL_GROUP {
	    my($i) = @_;
    	    eval q(((( &in_addr_t)($i) & 0xffffff00) == 0xe0000000));
	}' unless defined(&IN_LOCAL_GROUP);
	eval 'sub IN_ANY_LOCAL {
	    my($i) = @_;
    	    eval q(( &IN_LINKLOCAL($i) ||  &IN_LOCAL_GROUP($i)));
	}' unless defined(&IN_ANY_LOCAL);
	eval 'sub INADDR_LOOPBACK () {(( &in_addr_t)0x7f000001);}' unless defined(&INADDR_LOOPBACK);
	unless(defined(&_KERNEL)) {
	    eval 'sub INADDR_NONE () {(( &in_addr_t)0xffffffff);}' unless defined(&INADDR_NONE);
	}
	eval 'sub INADDR_UNSPEC_GROUP () {(( &in_addr_t)0xe0000000);}' unless defined(&INADDR_UNSPEC_GROUP);
	eval 'sub INADDR_ALLHOSTS_GROUP () {(( &in_addr_t)0xe0000001);}' unless defined(&INADDR_ALLHOSTS_GROUP);
	eval 'sub INADDR_ALLRTRS_GROUP () {(( &in_addr_t)0xe0000002);}' unless defined(&INADDR_ALLRTRS_GROUP);
	eval 'sub INADDR_ALLRPTS_GROUP () {(( &in_addr_t)0xe0000016);}' unless defined(&INADDR_ALLRPTS_GROUP);
	eval 'sub INADDR_CARP_GROUP () {(( &in_addr_t)0xe0000012);}' unless defined(&INADDR_CARP_GROUP);
	eval 'sub INADDR_PFSYNC_GROUP () {(( &in_addr_t)0xe00000f0);}' unless defined(&INADDR_PFSYNC_GROUP);
	eval 'sub INADDR_ALLMDNS_GROUP () {(( &in_addr_t)0xe00000fb);}' unless defined(&INADDR_ALLMDNS_GROUP);
	eval 'sub INADDR_MAX_LOCAL_GROUP () {(( &in_addr_t)0xe00000ff);}' unless defined(&INADDR_MAX_LOCAL_GROUP);
	eval 'sub IN_LOOPBACKNET () {127;}' unless defined(&IN_LOOPBACKNET);
	eval 'sub IN_RFC3021_MASK () {(( &in_addr_t)0xfffffffe);}' unless defined(&IN_RFC3021_MASK);
	eval 'sub IP_OPTIONS () {1;}' unless defined(&IP_OPTIONS);
	eval 'sub IP_HDRINCL () {2;}' unless defined(&IP_HDRINCL);
	eval 'sub IP_TOS () {3;}' unless defined(&IP_TOS);
	eval 'sub IP_TTL () {4;}' unless defined(&IP_TTL);
	eval 'sub IP_RECVOPTS () {5;}' unless defined(&IP_RECVOPTS);
	eval 'sub IP_RECVRETOPTS () {6;}' unless defined(&IP_RECVRETOPTS);
	eval 'sub IP_RECVDSTADDR () {7;}' unless defined(&IP_RECVDSTADDR);
	eval 'sub IP_SENDSRCADDR () { &IP_RECVDSTADDR;}' unless defined(&IP_SENDSRCADDR);
	eval 'sub IP_RETOPTS () {8;}' unless defined(&IP_RETOPTS);
	eval 'sub IP_MULTICAST_IF () {9;}' unless defined(&IP_MULTICAST_IF);
	eval 'sub IP_MULTICAST_TTL () {10;}' unless defined(&IP_MULTICAST_TTL);
	eval 'sub IP_MULTICAST_LOOP () {11;}' unless defined(&IP_MULTICAST_LOOP);
	eval 'sub IP_ADD_MEMBERSHIP () {12;}' unless defined(&IP_ADD_MEMBERSHIP);
	eval 'sub IP_DROP_MEMBERSHIP () {13;}' unless defined(&IP_DROP_MEMBERSHIP);
	eval 'sub IP_MULTICAST_VIF () {14;}' unless defined(&IP_MULTICAST_VIF);
	eval 'sub IP_RSVP_ON () {15;}' unless defined(&IP_RSVP_ON);
	eval 'sub IP_RSVP_OFF () {16;}' unless defined(&IP_RSVP_OFF);
	eval 'sub IP_RSVP_VIF_ON () {17;}' unless defined(&IP_RSVP_VIF_ON);
	eval 'sub IP_RSVP_VIF_OFF () {18;}' unless defined(&IP_RSVP_VIF_OFF);
	eval 'sub IP_PORTRANGE () {19;}' unless defined(&IP_PORTRANGE);
	eval 'sub IP_RECVIF () {20;}' unless defined(&IP_RECVIF);
	eval 'sub IP_IPSEC_POLICY () {21;}' unless defined(&IP_IPSEC_POLICY);
	eval 'sub IP_ONESBCAST () {23;}' unless defined(&IP_ONESBCAST);
	eval 'sub IP_BINDANY () {24;}' unless defined(&IP_BINDANY);
	eval 'sub IP_BINDMULTI () {25;}' unless defined(&IP_BINDMULTI);
	eval 'sub IP_RSS_LISTEN_BUCKET () {26;}' unless defined(&IP_RSS_LISTEN_BUCKET);
	eval 'sub IP_FW_TABLE_ADD () {40;}' unless defined(&IP_FW_TABLE_ADD);
	eval 'sub IP_FW_TABLE_DEL () {41;}' unless defined(&IP_FW_TABLE_DEL);
	eval 'sub IP_FW_TABLE_FLUSH () {42;}' unless defined(&IP_FW_TABLE_FLUSH);
	eval 'sub IP_FW_TABLE_GETSIZE () {43;}' unless defined(&IP_FW_TABLE_GETSIZE);
	eval 'sub IP_FW_TABLE_LIST () {44;}' unless defined(&IP_FW_TABLE_LIST);
	eval 'sub IP_FW3 () {48;}' unless defined(&IP_FW3);
	eval 'sub IP_DUMMYNET3 () {49;}' unless defined(&IP_DUMMYNET3);
	eval 'sub IP_FW_ADD () {50;}' unless defined(&IP_FW_ADD);
	eval 'sub IP_FW_DEL () {51;}' unless defined(&IP_FW_DEL);
	eval 'sub IP_FW_FLUSH () {52;}' unless defined(&IP_FW_FLUSH);
	eval 'sub IP_FW_ZERO () {53;}' unless defined(&IP_FW_ZERO);
	eval 'sub IP_FW_GET () {54;}' unless defined(&IP_FW_GET);
	eval 'sub IP_FW_RESETLOG () {55;}' unless defined(&IP_FW_RESETLOG);
	eval 'sub IP_FW_NAT_CFG () {56;}' unless defined(&IP_FW_NAT_CFG);
	eval 'sub IP_FW_NAT_DEL () {57;}' unless defined(&IP_FW_NAT_DEL);
	eval 'sub IP_FW_NAT_GET_CONFIG () {58;}' unless defined(&IP_FW_NAT_GET_CONFIG);
	eval 'sub IP_FW_NAT_GET_LOG () {59;}' unless defined(&IP_FW_NAT_GET_LOG);
	eval 'sub IP_DUMMYNET_CONFIGURE () {60;}' unless defined(&IP_DUMMYNET_CONFIGURE);
	eval 'sub IP_DUMMYNET_DEL () {61;}' unless defined(&IP_DUMMYNET_DEL);
	eval 'sub IP_DUMMYNET_FLUSH () {62;}' unless defined(&IP_DUMMYNET_FLUSH);
	eval 'sub IP_DUMMYNET_GET () {64;}' unless defined(&IP_DUMMYNET_GET);
	eval 'sub IP_RECVTTL () {65;}' unless defined(&IP_RECVTTL);
	eval 'sub IP_MINTTL () {66;}' unless defined(&IP_MINTTL);
	eval 'sub IP_DONTFRAG () {67;}' unless defined(&IP_DONTFRAG);
	eval 'sub IP_RECVTOS () {68;}' unless defined(&IP_RECVTOS);
	eval 'sub IP_ADD_SOURCE_MEMBERSHIP () {70;}' unless defined(&IP_ADD_SOURCE_MEMBERSHIP);
	eval 'sub IP_DROP_SOURCE_MEMBERSHIP () {71;}' unless defined(&IP_DROP_SOURCE_MEMBERSHIP);
	eval 'sub IP_BLOCK_SOURCE () {72;}' unless defined(&IP_BLOCK_SOURCE);
	eval 'sub IP_UNBLOCK_SOURCE () {73;}' unless defined(&IP_UNBLOCK_SOURCE);
	eval 'sub IP_MSFILTER () {74;}' unless defined(&IP_MSFILTER);
	eval 'sub MCAST_JOIN_GROUP () {80;}' unless defined(&MCAST_JOIN_GROUP);
	eval 'sub MCAST_LEAVE_GROUP () {81;}' unless defined(&MCAST_LEAVE_GROUP);
	eval 'sub MCAST_JOIN_SOURCE_GROUP () {82;}' unless defined(&MCAST_JOIN_SOURCE_GROUP);
	eval 'sub MCAST_LEAVE_SOURCE_GROUP () {83;}' unless defined(&MCAST_LEAVE_SOURCE_GROUP);
	eval 'sub MCAST_BLOCK_SOURCE () {84;}' unless defined(&MCAST_BLOCK_SOURCE);
	eval 'sub MCAST_UNBLOCK_SOURCE () {85;}' unless defined(&MCAST_UNBLOCK_SOURCE);
	eval 'sub IP_FLOWID () {90;}' unless defined(&IP_FLOWID);
	eval 'sub IP_FLOWTYPE () {91;}' unless defined(&IP_FLOWTYPE);
	eval 'sub IP_RSSBUCKETID () {92;}' unless defined(&IP_RSSBUCKETID);
	eval 'sub IP_RECVFLOWID () {93;}' unless defined(&IP_RECVFLOWID);
	eval 'sub IP_RECVRSSBUCKETID () {94;}' unless defined(&IP_RECVRSSBUCKETID);
	eval 'sub IP_DEFAULT_MULTICAST_TTL () {1;}' unless defined(&IP_DEFAULT_MULTICAST_TTL);
	eval 'sub IP_DEFAULT_MULTICAST_LOOP () {1;}' unless defined(&IP_DEFAULT_MULTICAST_LOOP);
	eval 'sub IP_MIN_MEMBERSHIPS () {31;}' unless defined(&IP_MIN_MEMBERSHIPS);
	eval 'sub IP_MAX_MEMBERSHIPS () {4095;}' unless defined(&IP_MAX_MEMBERSHIPS);
	eval 'sub IP_MAX_SOURCE_FILTER () {1024;}' unless defined(&IP_MAX_SOURCE_FILTER);
	eval 'sub IP_MAX_GROUP_SRC_FILTER () {512;}' unless defined(&IP_MAX_GROUP_SRC_FILTER);
	eval 'sub IP_MAX_SOCK_SRC_FILTER () {128;}' unless defined(&IP_MAX_SOCK_SRC_FILTER);
	eval 'sub IP_MAX_SOCK_MUTE_FILTER () {128;}' unless defined(&IP_MAX_SOCK_MUTE_FILTER);
	unless(defined(&__MSFILTERREQ_DEFINED)) {
	    eval 'sub __MSFILTERREQ_DEFINED () {1;}' unless defined(&__MSFILTERREQ_DEFINED);
	}
	eval 'sub MCAST_UNDEFINED () {0;}' unless defined(&MCAST_UNDEFINED);
	eval 'sub MCAST_INCLUDE () {1;}' unless defined(&MCAST_INCLUDE);
	eval 'sub MCAST_EXCLUDE () {2;}' unless defined(&MCAST_EXCLUDE);
	eval 'sub IP_PORTRANGE_DEFAULT () {0;}' unless defined(&IP_PORTRANGE_DEFAULT);
	eval 'sub IP_PORTRANGE_HIGH () {1;}' unless defined(&IP_PORTRANGE_HIGH);
	eval 'sub IP_PORTRANGE_LOW () {2;}' unless defined(&IP_PORTRANGE_LOW);
	eval 'sub IPCTL_FORWARDING () {1;}' unless defined(&IPCTL_FORWARDING);
	eval 'sub IPCTL_SENDREDIRECTS () {2;}' unless defined(&IPCTL_SENDREDIRECTS);
	eval 'sub IPCTL_DEFTTL () {3;}' unless defined(&IPCTL_DEFTTL);
	if(defined(&notyet)) {
	    eval 'sub IPCTL_DEFMTU () {4;}' unless defined(&IPCTL_DEFMTU);
	}
	eval 'sub IPCTL_SOURCEROUTE () {8;}' unless defined(&IPCTL_SOURCEROUTE);
	eval 'sub IPCTL_DIRECTEDBROADCAST () {9;}' unless defined(&IPCTL_DIRECTEDBROADCAST);
	eval 'sub IPCTL_INTRQMAXLEN () {10;}' unless defined(&IPCTL_INTRQMAXLEN);
	eval 'sub IPCTL_INTRQDROPS () {11;}' unless defined(&IPCTL_INTRQDROPS);
	eval 'sub IPCTL_STATS () {12;}' unless defined(&IPCTL_STATS);
	eval 'sub IPCTL_ACCEPTSOURCEROUTE () {13;}' unless defined(&IPCTL_ACCEPTSOURCEROUTE);
	eval 'sub IPCTL_FASTFORWARDING () {14;}' unless defined(&IPCTL_FASTFORWARDING);
	eval 'sub IPCTL_GIF_TTL () {16;}' unless defined(&IPCTL_GIF_TTL);
	eval 'sub IPCTL_INTRDQMAXLEN () {17;}' unless defined(&IPCTL_INTRDQMAXLEN);
	eval 'sub IPCTL_INTRDQDROPS () {18;}' unless defined(&IPCTL_INTRDQDROPS);
    }
    if(defined(&_KERNEL)) {
	eval 'sub in_hosteq {
	    my($s, $t) = @_;
    	    eval q((($s). &s_addr == ($t). &s_addr));
	}' unless defined(&in_hosteq);
	eval 'sub in_nullhost {
	    my($x) = @_;
    	    eval q((($x). &s_addr ==  &INADDR_ANY));
	}' unless defined(&in_nullhost);
	eval 'sub in_allhosts {
	    my($x) = @_;
    	    eval q((($x). &s_addr ==  &htonl( &INADDR_ALLHOSTS_GROUP)));
	}' unless defined(&in_allhosts);
	eval 'sub satosin {
	    my($sa) = @_;
    	    eval q((($sa)));
	}' unless defined(&satosin);
	eval 'sub sintosa {
	    my($sin) = @_;
    	    eval q((($sin)));
	}' unless defined(&sintosa);
	eval 'sub ifatoia {
	    my($ifa) = @_;
    	    eval q((($ifa)));
	}' unless defined(&ifatoia);
    }
    if((defined(&__POSIX_VISIBLE) ? &__POSIX_VISIBLE : undef) >= 200112) {
	eval 'sub __KAME_NETINET_IN_H_INCLUDED_ () {1;}' unless defined(&__KAME_NETINET_IN_H_INCLUDED_);
	require 'netinet6/in6.ph';
	undef(&__KAME_NETINET_IN_H_INCLUDED_) if defined(&__KAME_NETINET_IN_H_INCLUDED_);
    }
}
1;
