require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_IN_PCB_H_)) {
    eval 'sub _NETINET_IN_PCB_H_ () {1;}' unless defined(&_NETINET_IN_PCB_H_);
    require 'sys/queue.ph';
    require 'sys/_lock.ph';
    require 'sys/_mutex.ph';
    require 'sys/_rwlock.ph';
    require 'net/route.ph';
    if(defined(&_KERNEL)) {
	require 'sys/lock.ph';
	require 'sys/rwlock.ph';
	require 'net/vnet.ph';
	require 'vm/uma.ph';
    }
    eval 'sub in6pcb () { &inpcb;}' unless defined(&in6pcb);
    eval 'sub in6p_sp () { &inp_sp;}' unless defined(&in6p_sp);
    eval 'sub ie_faddr () { ($ie_dependfaddr->{ie46_foreign}->{ia46_addr4});}' unless defined(&ie_faddr);
    eval 'sub ie_laddr () { ($ie_dependladdr->{ie46_local}->{ia46_addr4});}' unless defined(&ie_laddr);
    eval 'sub ie6_faddr () { ($ie_dependfaddr->{ie6_foreign});}' unless defined(&ie6_faddr);
    eval 'sub ie6_laddr () { ($ie_dependladdr->{ie6_local});}' unless defined(&ie6_laddr);
    eval 'sub INC_ISIPV6 () {0x1;}' unless defined(&INC_ISIPV6);
    eval 'sub inc_isipv6 () { &inc_flags;}' unless defined(&inc_isipv6);
    eval 'sub inc_fport () { ($inc_ie->{ie_fport});}' unless defined(&inc_fport);
    eval 'sub inc_lport () { ($inc_ie->{ie_lport});}' unless defined(&inc_lport);
    eval 'sub inc_faddr () { ($inc_ie->{ie_faddr});}' unless defined(&inc_faddr);
    eval 'sub inc_laddr () { ($inc_ie->{ie_laddr});}' unless defined(&inc_laddr);
    eval 'sub inc6_faddr () { ($inc_ie->{ie6_faddr});}' unless defined(&inc6_faddr);
    eval 'sub inc6_laddr () { ($inc_ie->{ie6_laddr});}' unless defined(&inc6_laddr);
    eval 'sub inc6_zoneid () { ($inc_ie->{ie6_zoneid});}' unless defined(&inc6_zoneid);
    eval 'sub inp_zero_size () { &offsetof(\'struct inpcb\',  &inp_gencnt);}' unless defined(&inp_zero_size);
    eval 'sub inp_route () { ($inp_rtu->{inpu_route});}' unless defined(&inp_route);
    eval 'sub inp_route6 () { ($inp_rtu->{inpu_route6});}' unless defined(&inp_route6);
    eval 'sub inp_fport () { ($inp_inc->{inc_fport});}' unless defined(&inp_fport);
    eval 'sub inp_lport () { ($inp_inc->{inc_lport});}' unless defined(&inp_lport);
    eval 'sub inp_faddr () { ($inp_inc->{inc_faddr});}' unless defined(&inp_faddr);
    eval 'sub inp_laddr () { ($inp_inc->{inc_laddr});}' unless defined(&inp_laddr);
    eval 'sub inp_ip_tos () { ($inp_depend4->{inp4_ip_tos});}' unless defined(&inp_ip_tos);
    eval 'sub inp_options () { ($inp_depend4->{inp4_options});}' unless defined(&inp_options);
    eval 'sub inp_moptions () { ($inp_depend4->{inp4_moptions});}' unless defined(&inp_moptions);
    eval 'sub in6p_faddr () { ($inp_inc->{inc6_faddr});}' unless defined(&in6p_faddr);
    eval 'sub in6p_laddr () { ($inp_inc->{inc6_laddr});}' unless defined(&in6p_laddr);
    eval 'sub in6p_zoneid () { ($inp_inc->{inc6_zoneid});}' unless defined(&in6p_zoneid);
    eval 'sub in6p_hops () { ($inp_depend6->{inp6_hops});}' unless defined(&in6p_hops);
    eval 'sub in6p_flowinfo () { &inp_flow;}' unless defined(&in6p_flowinfo);
    eval 'sub in6p_options () { ($inp_depend6->{inp6_options});}' unless defined(&in6p_options);
    eval 'sub in6p_outputopts () { ($inp_depend6->{inp6_outputopts});}' unless defined(&in6p_outputopts);
    eval 'sub in6p_moptions () { ($inp_depend6->{inp6_moptions});}' unless defined(&in6p_moptions);
    eval 'sub in6p_icmp6filt () { ($inp_depend6->{inp6_icmp6filt});}' unless defined(&in6p_icmp6filt);
    eval 'sub in6p_cksum () { ($inp_depend6->{inp6_cksum});}' unless defined(&in6p_cksum);
    eval 'sub inp_vnet () { ($inp_pcbinfo->{ipi_vnet});}' unless defined(&inp_vnet);
    if(defined(&_SYS_SOCKETVAR_H_)) {
    }
    if(defined(&_KERNEL)) {
	eval 'sub INP_LOCK_INIT {
	    my($inp, $d, $t) = @_;
    	    eval q( &rw_init_flags(($inp)-> &inp_lock, ($t),  &RW_RECURSE |  &RW_DUPOK));
	}' unless defined(&INP_LOCK_INIT);
	eval 'sub INP_LOCK_DESTROY {
	    my($inp) = @_;
    	    eval q( &rw_destroy(($inp)-> &inp_lock));
	}' unless defined(&INP_LOCK_DESTROY);
	eval 'sub INP_RLOCK {
	    my($inp) = @_;
    	    eval q( &rw_rlock(($inp)-> &inp_lock));
	}' unless defined(&INP_RLOCK);
	eval 'sub INP_WLOCK {
	    my($inp) = @_;
    	    eval q( &rw_wlock(($inp)-> &inp_lock));
	}' unless defined(&INP_WLOCK);
	eval 'sub INP_TRY_RLOCK {
	    my($inp) = @_;
    	    eval q( &rw_try_rlock(($inp)-> &inp_lock));
	}' unless defined(&INP_TRY_RLOCK);
	eval 'sub INP_TRY_WLOCK {
	    my($inp) = @_;
    	    eval q( &rw_try_wlock(($inp)-> &inp_lock));
	}' unless defined(&INP_TRY_WLOCK);
	eval 'sub INP_RUNLOCK {
	    my($inp) = @_;
    	    eval q( &rw_runlock(($inp)-> &inp_lock));
	}' unless defined(&INP_RUNLOCK);
	eval 'sub INP_WUNLOCK {
	    my($inp) = @_;
    	    eval q( &rw_wunlock(($inp)-> &inp_lock));
	}' unless defined(&INP_WUNLOCK);
	eval 'sub INP_TRY_UPGRADE {
	    my($inp) = @_;
    	    eval q( &rw_try_upgrade(($inp)-> &inp_lock));
	}' unless defined(&INP_TRY_UPGRADE);
	eval 'sub INP_DOWNGRADE {
	    my($inp) = @_;
    	    eval q( &rw_downgrade(($inp)-> &inp_lock));
	}' unless defined(&INP_DOWNGRADE);
	eval 'sub INP_WLOCKED {
	    my($inp) = @_;
    	    eval q( &rw_wowned(($inp)-> &inp_lock));
	}' unless defined(&INP_WLOCKED);
	eval 'sub INP_LOCK_ASSERT {
	    my($inp) = @_;
    	    eval q( &rw_assert(($inp)-> &inp_lock,  &RA_LOCKED));
	}' unless defined(&INP_LOCK_ASSERT);
	eval 'sub INP_RLOCK_ASSERT {
	    my($inp) = @_;
    	    eval q( &rw_assert(($inp)-> &inp_lock,  &RA_RLOCKED));
	}' unless defined(&INP_RLOCK_ASSERT);
	eval 'sub INP_WLOCK_ASSERT {
	    my($inp) = @_;
    	    eval q( &rw_assert(($inp)-> &inp_lock,  &RA_WLOCKED));
	}' unless defined(&INP_WLOCK_ASSERT);
	eval 'sub INP_UNLOCK_ASSERT {
	    my($inp) = @_;
    	    eval q( &rw_assert(($inp)-> &inp_lock,  &RA_UNLOCKED));
	}' unless defined(&INP_UNLOCK_ASSERT);
	if(defined(&INVARIANTS)) {
	} else {
	    eval 'sub inp_lock_assert {
	        my($__unused) = @_;
    		eval q({ });
	    }' unless defined(&inp_lock_assert);
	    eval 'sub inp_unlock_assert {
	        my($__unused) = @_;
    		eval q({ });
	    }' unless defined(&inp_unlock_assert);
	}
    }
    eval 'sub INP_INFO_LOCK_INIT {
        my($ipi, $d) = @_;
	    eval q( &rw_init_flags(($ipi)-> &ipi_lock, ($d),  &RW_RECURSE));
    }' unless defined(&INP_INFO_LOCK_INIT);
    eval 'sub INP_INFO_LOCK_DESTROY {
        my($ipi) = @_;
	    eval q( &rw_destroy(($ipi)-> &ipi_lock));
    }' unless defined(&INP_INFO_LOCK_DESTROY);
    eval 'sub INP_INFO_RLOCK {
        my($ipi) = @_;
	    eval q( &rw_rlock(($ipi)-> &ipi_lock));
    }' unless defined(&INP_INFO_RLOCK);
    eval 'sub INP_INFO_WLOCK {
        my($ipi) = @_;
	    eval q( &rw_wlock(($ipi)-> &ipi_lock));
    }' unless defined(&INP_INFO_WLOCK);
    eval 'sub INP_INFO_TRY_RLOCK {
        my($ipi) = @_;
	    eval q( &rw_try_rlock(($ipi)-> &ipi_lock));
    }' unless defined(&INP_INFO_TRY_RLOCK);
    eval 'sub INP_INFO_TRY_WLOCK {
        my($ipi) = @_;
	    eval q( &rw_try_wlock(($ipi)-> &ipi_lock));
    }' unless defined(&INP_INFO_TRY_WLOCK);
    eval 'sub INP_INFO_TRY_UPGRADE {
        my($ipi) = @_;
	    eval q( &rw_try_upgrade(($ipi)-> &ipi_lock));
    }' unless defined(&INP_INFO_TRY_UPGRADE);
    eval 'sub INP_INFO_WLOCKED {
        my($ipi) = @_;
	    eval q( &rw_wowned(($ipi)-> &ipi_lock));
    }' unless defined(&INP_INFO_WLOCKED);
    eval 'sub INP_INFO_RUNLOCK {
        my($ipi) = @_;
	    eval q( &rw_runlock(($ipi)-> &ipi_lock));
    }' unless defined(&INP_INFO_RUNLOCK);
    eval 'sub INP_INFO_WUNLOCK {
        my($ipi) = @_;
	    eval q( &rw_wunlock(($ipi)-> &ipi_lock));
    }' unless defined(&INP_INFO_WUNLOCK);
    eval 'sub INP_INFO_LOCK_ASSERT {
        my($ipi) = @_;
	    eval q( &rw_assert(($ipi)-> &ipi_lock,  &RA_LOCKED));
    }' unless defined(&INP_INFO_LOCK_ASSERT);
    eval 'sub INP_INFO_RLOCK_ASSERT {
        my($ipi) = @_;
	    eval q( &rw_assert(($ipi)-> &ipi_lock,  &RA_RLOCKED));
    }' unless defined(&INP_INFO_RLOCK_ASSERT);
    eval 'sub INP_INFO_WLOCK_ASSERT {
        my($ipi) = @_;
	    eval q( &rw_assert(($ipi)-> &ipi_lock,  &RA_WLOCKED));
    }' unless defined(&INP_INFO_WLOCK_ASSERT);
    eval 'sub INP_INFO_UNLOCK_ASSERT {
        my($ipi) = @_;
	    eval q( &rw_assert(($ipi)-> &ipi_lock,  &RA_UNLOCKED));
    }' unless defined(&INP_INFO_UNLOCK_ASSERT);
    eval 'sub INP_LIST_LOCK_INIT {
        my($ipi, $d) = @_;
	    eval q( &rw_init_flags(($ipi)-> &ipi_list_lock, ($d), 0));
    }' unless defined(&INP_LIST_LOCK_INIT);
    eval 'sub INP_LIST_LOCK_DESTROY {
        my($ipi) = @_;
	    eval q( &rw_destroy(($ipi)-> &ipi_list_lock));
    }' unless defined(&INP_LIST_LOCK_DESTROY);
    eval 'sub INP_LIST_RLOCK {
        my($ipi) = @_;
	    eval q( &rw_rlock(($ipi)-> &ipi_list_lock));
    }' unless defined(&INP_LIST_RLOCK);
    eval 'sub INP_LIST_WLOCK {
        my($ipi) = @_;
	    eval q( &rw_wlock(($ipi)-> &ipi_list_lock));
    }' unless defined(&INP_LIST_WLOCK);
    eval 'sub INP_LIST_TRY_RLOCK {
        my($ipi) = @_;
	    eval q( &rw_try_rlock(($ipi)-> &ipi_list_lock));
    }' unless defined(&INP_LIST_TRY_RLOCK);
    eval 'sub INP_LIST_TRY_WLOCK {
        my($ipi) = @_;
	    eval q( &rw_try_wlock(($ipi)-> &ipi_list_lock));
    }' unless defined(&INP_LIST_TRY_WLOCK);
    eval 'sub INP_LIST_TRY_UPGRADE {
        my($ipi) = @_;
	    eval q( &rw_try_upgrade(($ipi)-> &ipi_list_lock));
    }' unless defined(&INP_LIST_TRY_UPGRADE);
    eval 'sub INP_LIST_RUNLOCK {
        my($ipi) = @_;
	    eval q( &rw_runlock(($ipi)-> &ipi_list_lock));
    }' unless defined(&INP_LIST_RUNLOCK);
    eval 'sub INP_LIST_WUNLOCK {
        my($ipi) = @_;
	    eval q( &rw_wunlock(($ipi)-> &ipi_list_lock));
    }' unless defined(&INP_LIST_WUNLOCK);
    eval 'sub INP_LIST_LOCK_ASSERT {
        my($ipi) = @_;
	    eval q( &rw_assert(($ipi)-> &ipi_list_lock,  &RA_LOCKED));
    }' unless defined(&INP_LIST_LOCK_ASSERT);
    eval 'sub INP_LIST_RLOCK_ASSERT {
        my($ipi) = @_;
	    eval q( &rw_assert(($ipi)-> &ipi_list_lock,  &RA_RLOCKED));
    }' unless defined(&INP_LIST_RLOCK_ASSERT);
    eval 'sub INP_LIST_WLOCK_ASSERT {
        my($ipi) = @_;
	    eval q( &rw_assert(($ipi)-> &ipi_list_lock,  &RA_WLOCKED));
    }' unless defined(&INP_LIST_WLOCK_ASSERT);
    eval 'sub INP_LIST_UNLOCK_ASSERT {
        my($ipi) = @_;
	    eval q( &rw_assert(($ipi)-> &ipi_list_lock,  &RA_UNLOCKED));
    }' unless defined(&INP_LIST_UNLOCK_ASSERT);
    eval 'sub INP_HASH_LOCK_INIT {
        my($ipi, $d) = @_;
	    eval q( &rw_init_flags(($ipi)-> &ipi_hash_lock, ($d), 0));
    }' unless defined(&INP_HASH_LOCK_INIT);
    eval 'sub INP_HASH_LOCK_DESTROY {
        my($ipi) = @_;
	    eval q( &rw_destroy(($ipi)-> &ipi_hash_lock));
    }' unless defined(&INP_HASH_LOCK_DESTROY);
    eval 'sub INP_HASH_RLOCK {
        my($ipi) = @_;
	    eval q( &rw_rlock(($ipi)-> &ipi_hash_lock));
    }' unless defined(&INP_HASH_RLOCK);
    eval 'sub INP_HASH_WLOCK {
        my($ipi) = @_;
	    eval q( &rw_wlock(($ipi)-> &ipi_hash_lock));
    }' unless defined(&INP_HASH_WLOCK);
    eval 'sub INP_HASH_RUNLOCK {
        my($ipi) = @_;
	    eval q( &rw_runlock(($ipi)-> &ipi_hash_lock));
    }' unless defined(&INP_HASH_RUNLOCK);
    eval 'sub INP_HASH_WUNLOCK {
        my($ipi) = @_;
	    eval q( &rw_wunlock(($ipi)-> &ipi_hash_lock));
    }' unless defined(&INP_HASH_WUNLOCK);
    eval 'sub INP_HASH_LOCK_ASSERT {
        my($ipi) = @_;
	    eval q( &rw_assert(($ipi)-> &ipi_hash_lock,  &RA_LOCKED));
    }' unless defined(&INP_HASH_LOCK_ASSERT);
    eval 'sub INP_HASH_WLOCK_ASSERT {
        my($ipi) = @_;
	    eval q( &rw_assert(($ipi)-> &ipi_hash_lock,  &RA_WLOCKED));
    }' unless defined(&INP_HASH_WLOCK_ASSERT);
    eval 'sub INP_GROUP_LOCK_INIT {
        my($ipg, $d) = @_;
	    eval q( &mtx_init(($ipg)-> &ipg_lock, ($d),  &NULL,  &MTX_DEF |  &MTX_DUPOK));
    }' unless defined(&INP_GROUP_LOCK_INIT);
    eval 'sub INP_GROUP_LOCK_DESTROY {
        my($ipg) = @_;
	    eval q( &mtx_destroy(($ipg)-> &ipg_lock));
    }' unless defined(&INP_GROUP_LOCK_DESTROY);
    eval 'sub INP_GROUP_LOCK {
        my($ipg) = @_;
	    eval q( &mtx_lock(($ipg)-> &ipg_lock));
    }' unless defined(&INP_GROUP_LOCK);
    eval 'sub INP_GROUP_LOCK_ASSERT {
        my($ipg) = @_;
	    eval q( &mtx_assert(($ipg)-> &ipg_lock,  &MA_OWNED));
    }' unless defined(&INP_GROUP_LOCK_ASSERT);
    eval 'sub INP_GROUP_UNLOCK {
        my($ipg) = @_;
	    eval q( &mtx_unlock(($ipg)-> &ipg_lock));
    }' unless defined(&INP_GROUP_UNLOCK);
    eval 'sub INP_PCBHASH {
        my($faddr, $lport, $fport, $mask) = @_;
	    eval q(((($faddr) ^ (($faddr) >> 16) ^  &ntohs(($lport) ^ ($fport))) & ($mask)));
    }' unless defined(&INP_PCBHASH);
    eval 'sub INP_PCBPORTHASH {
        my($lport, $mask) = @_;
	    eval q(( &ntohs(($lport)) & ($mask)));
    }' unless defined(&INP_PCBPORTHASH);
    eval 'sub INP6_PCBHASHKEY {
        my($faddr) = @_;
	    eval q((($faddr)-> $s6_addr32[3]));
    }' unless defined(&INP6_PCBHASHKEY);
    eval 'sub INP_IPV4 () {0x1;}' unless defined(&INP_IPV4);
    eval 'sub INP_IPV6 () {0x2;}' unless defined(&INP_IPV6);
    eval 'sub INP_IPV6PROTO () {0x4;}' unless defined(&INP_IPV6PROTO);
    eval 'sub INP_RECVOPTS () {0x1;}' unless defined(&INP_RECVOPTS);
    eval 'sub INP_RECVRETOPTS () {0x2;}' unless defined(&INP_RECVRETOPTS);
    eval 'sub INP_RECVDSTADDR () {0x4;}' unless defined(&INP_RECVDSTADDR);
    eval 'sub INP_HDRINCL () {0x8;}' unless defined(&INP_HDRINCL);
    eval 'sub INP_HIGHPORT () {0x10;}' unless defined(&INP_HIGHPORT);
    eval 'sub INP_LOWPORT () {0x20;}' unless defined(&INP_LOWPORT);
    eval 'sub INP_ANONPORT () {0x40;}' unless defined(&INP_ANONPORT);
    eval 'sub INP_RECVIF () {0x80;}' unless defined(&INP_RECVIF);
    eval 'sub INP_MTUDISC () {0x100;}' unless defined(&INP_MTUDISC);
    eval 'sub INP_RECVTTL () {0x400;}' unless defined(&INP_RECVTTL);
    eval 'sub INP_DONTFRAG () {0x800;}' unless defined(&INP_DONTFRAG);
    eval 'sub INP_BINDANY () {0x1000;}' unless defined(&INP_BINDANY);
    eval 'sub INP_INHASHLIST () {0x2000;}' unless defined(&INP_INHASHLIST);
    eval 'sub INP_RECVTOS () {0x4000;}' unless defined(&INP_RECVTOS);
    eval 'sub IN6P_IPV6_V6ONLY () {0x8000;}' unless defined(&IN6P_IPV6_V6ONLY);
    eval 'sub IN6P_PKTINFO () {0x10000;}' unless defined(&IN6P_PKTINFO);
    eval 'sub IN6P_HOPLIMIT () {0x20000;}' unless defined(&IN6P_HOPLIMIT);
    eval 'sub IN6P_HOPOPTS () {0x40000;}' unless defined(&IN6P_HOPOPTS);
    eval 'sub IN6P_DSTOPTS () {0x80000;}' unless defined(&IN6P_DSTOPTS);
    eval 'sub IN6P_RTHDR () {0x100000;}' unless defined(&IN6P_RTHDR);
    eval 'sub IN6P_RTHDRDSTOPTS () {0x200000;}' unless defined(&IN6P_RTHDRDSTOPTS);
    eval 'sub IN6P_TCLASS () {0x400000;}' unless defined(&IN6P_TCLASS);
    eval 'sub IN6P_AUTOFLOWLABEL () {0x800000;}' unless defined(&IN6P_AUTOFLOWLABEL);
    eval 'sub INP_TIMEWAIT () {0x1000000;}' unless defined(&INP_TIMEWAIT);
    eval 'sub INP_ONESBCAST () {0x2000000;}' unless defined(&INP_ONESBCAST);
    eval 'sub INP_DROPPED () {0x4000000;}' unless defined(&INP_DROPPED);
    eval 'sub INP_SOCKREF () {0x8000000;}' unless defined(&INP_SOCKREF);
    eval 'sub INP_RESERVED_0 () {0x10000000;}' unless defined(&INP_RESERVED_0);
    eval 'sub INP_RESERVED_1 () {0x20000000;}' unless defined(&INP_RESERVED_1);
    eval 'sub IN6P_RFC2292 () {0x40000000;}' unless defined(&IN6P_RFC2292);
    eval 'sub IN6P_MTU () {0x80000000;}' unless defined(&IN6P_MTU);
    eval 'sub INP_CONTROLOPTS () {( &INP_RECVOPTS| &INP_RECVRETOPTS| &INP_RECVDSTADDR|  &INP_RECVIF| &INP_RECVTTL| &INP_RECVTOS|  &IN6P_PKTINFO| &IN6P_HOPLIMIT| &IN6P_HOPOPTS|  &IN6P_DSTOPTS| &IN6P_RTHDR| &IN6P_RTHDRDSTOPTS|  &IN6P_TCLASS| &IN6P_AUTOFLOWLABEL| &IN6P_RFC2292|  &IN6P_MTU);}' unless defined(&INP_CONTROLOPTS);
    eval 'sub INP_LLE_VALID () {0x1;}' unless defined(&INP_LLE_VALID);
    eval 'sub INP_RT_VALID () {0x2;}' unless defined(&INP_RT_VALID);
    eval 'sub INP_PCBGROUPWILD () {0x4;}' unless defined(&INP_PCBGROUPWILD);
    eval 'sub INP_REUSEPORT () {0x8;}' unless defined(&INP_REUSEPORT);
    eval 'sub INP_FREED () {0x10;}' unless defined(&INP_FREED);
    eval 'sub INP_REUSEADDR () {0x20;}' unless defined(&INP_REUSEADDR);
    eval 'sub INP_BINDMULTI () {0x40;}' unless defined(&INP_BINDMULTI);
    eval 'sub INP_RSS_BUCKET_SET () {0x80;}' unless defined(&INP_RSS_BUCKET_SET);
    eval 'sub INP_RECVFLOWID () {0x100;}' unless defined(&INP_RECVFLOWID);
    eval 'sub INP_RECVRSSBUCKETID () {0x200;}' unless defined(&INP_RECVRSSBUCKETID);
    eval 'sub INPLOOKUP_WILDCARD () {0x1;}' unless defined(&INPLOOKUP_WILDCARD);
    eval 'sub INPLOOKUP_RLOCKPCB () {0x2;}' unless defined(&INPLOOKUP_RLOCKPCB);
    eval 'sub INPLOOKUP_WLOCKPCB () {0x4;}' unless defined(&INPLOOKUP_WLOCKPCB);
    eval 'sub INPLOOKUP_MASK () {( &INPLOOKUP_WILDCARD |  &INPLOOKUP_RLOCKPCB |  &INPLOOKUP_WLOCKPCB);}' unless defined(&INPLOOKUP_MASK);
    eval 'sub sotoinpcb {
        my($so) = @_;
	    eval q((($so)-> &so_pcb));
    }' unless defined(&sotoinpcb);
    eval 'sub sotoin6pcb {
        my($so) = @_;
	    eval q( &sotoinpcb($so));
    }' unless defined(&sotoin6pcb);
    eval 'sub INP_SOCKAF {
        my($so) = @_;
	    eval q( ($so->{so_proto}->{pr_domain}->{dom_family}));
    }' unless defined(&INP_SOCKAF);
    eval 'sub INP_CHECK_SOCKAF {
        my($so, $af) = @_;
	    eval q(( &INP_SOCKAF($so) == $af));
    }' unless defined(&INP_CHECK_SOCKAF);
    eval 'sub IPI_HASHFIELDS_NONE () {0;}' unless defined(&IPI_HASHFIELDS_NONE);
    eval 'sub IPI_HASHFIELDS_2TUPLE () {1;}' unless defined(&IPI_HASHFIELDS_2TUPLE);
    eval 'sub IPI_HASHFIELDS_4TUPLE () {2;}' unless defined(&IPI_HASHFIELDS_4TUPLE);
    if(defined(&_KERNEL)) {
	eval 'sub V_ipport_reservedhigh () { &VNET( &ipport_reservedhigh);}' unless defined(&V_ipport_reservedhigh);
	eval 'sub V_ipport_reservedlow () { &VNET( &ipport_reservedlow);}' unless defined(&V_ipport_reservedlow);
	eval 'sub V_ipport_lowfirstauto () { &VNET( &ipport_lowfirstauto);}' unless defined(&V_ipport_lowfirstauto);
	eval 'sub V_ipport_lowlastauto () { &VNET( &ipport_lowlastauto);}' unless defined(&V_ipport_lowlastauto);
	eval 'sub V_ipport_firstauto () { &VNET( &ipport_firstauto);}' unless defined(&V_ipport_firstauto);
	eval 'sub V_ipport_lastauto () { &VNET( &ipport_lastauto);}' unless defined(&V_ipport_lastauto);
	eval 'sub V_ipport_hifirstauto () { &VNET( &ipport_hifirstauto);}' unless defined(&V_ipport_hifirstauto);
	eval 'sub V_ipport_hilastauto () { &VNET( &ipport_hilastauto);}' unless defined(&V_ipport_hilastauto);
	eval 'sub V_ipport_randomized () { &VNET( &ipport_randomized);}' unless defined(&V_ipport_randomized);
	eval 'sub V_ipport_randomcps () { &VNET( &ipport_randomcps);}' unless defined(&V_ipport_randomcps);
	eval 'sub V_ipport_randomtime () { &VNET( &ipport_randomtime);}' unless defined(&V_ipport_randomtime);
	eval 'sub V_ipport_stoprandom () { &VNET( &ipport_stoprandom);}' unless defined(&V_ipport_stoprandom);
	eval 'sub V_ipport_tcpallocs () { &VNET( &ipport_tcpallocs);}' unless defined(&V_ipport_tcpallocs);
    }
}
1;
