require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IPFW2_H)) {
    eval 'sub _IPFW2_H () {1;}' unless defined(&_IPFW2_H);
    eval 'sub IPFW_DEFAULT_RULE () {65535;}' unless defined(&IPFW_DEFAULT_RULE);
    eval 'sub RESVD_SET () {31;}' unless defined(&RESVD_SET);
    eval 'sub IPFW_MAX_SETS () {32;}' unless defined(&IPFW_MAX_SETS);
    unless(defined(&_KERNEL)) {
	eval 'sub IPFW_TABLES_MAX () {65535;}' unless defined(&IPFW_TABLES_MAX);
	eval 'sub IPFW_TABLES_DEFAULT () {128;}' unless defined(&IPFW_TABLES_DEFAULT);
    }
    eval 'sub IPFW_ARG_MIN () {1;}' unless defined(&IPFW_ARG_MIN);
    eval 'sub IPFW_ARG_MAX () {65534;}' unless defined(&IPFW_ARG_MAX);
    eval 'sub IP_FW_TABLEARG () {65535;}' unless defined(&IP_FW_TABLEARG);
    eval 'sub IP_FW_TARG () {0;}' unless defined(&IP_FW_TARG);
    eval 'sub IP_FW_NAT44_GLOBAL () {65535;}' unless defined(&IP_FW_NAT44_GLOBAL);
    eval 'sub IPFW_CALLSTACK_SIZE () {16;}' unless defined(&IPFW_CALLSTACK_SIZE);
    eval 'sub IP_FW_TABLE_XADD () {86;}' unless defined(&IP_FW_TABLE_XADD);
    eval 'sub IP_FW_TABLE_XDEL () {87;}' unless defined(&IP_FW_TABLE_XDEL);
    eval 'sub IP_FW_TABLE_XGETSIZE () {88;}' unless defined(&IP_FW_TABLE_XGETSIZE);
    eval 'sub IP_FW_TABLE_XLIST () {89;}' unless defined(&IP_FW_TABLE_XLIST);
    eval 'sub IP_FW_TABLE_XDESTROY () {90;}' unless defined(&IP_FW_TABLE_XDESTROY);
    eval 'sub IP_FW_TABLES_XLIST () {92;}' unless defined(&IP_FW_TABLES_XLIST);
    eval 'sub IP_FW_TABLE_XINFO () {93;}' unless defined(&IP_FW_TABLE_XINFO);
    eval 'sub IP_FW_TABLE_XFLUSH () {94;}' unless defined(&IP_FW_TABLE_XFLUSH);
    eval 'sub IP_FW_TABLE_XCREATE () {95;}' unless defined(&IP_FW_TABLE_XCREATE);
    eval 'sub IP_FW_TABLE_XMODIFY () {96;}' unless defined(&IP_FW_TABLE_XMODIFY);
    eval 'sub IP_FW_XGET () {97;}' unless defined(&IP_FW_XGET);
    eval 'sub IP_FW_XADD () {98;}' unless defined(&IP_FW_XADD);
    eval 'sub IP_FW_XDEL () {99;}' unless defined(&IP_FW_XDEL);
    eval 'sub IP_FW_XMOVE () {100;}' unless defined(&IP_FW_XMOVE);
    eval 'sub IP_FW_XZERO () {101;}' unless defined(&IP_FW_XZERO);
    eval 'sub IP_FW_XRESETLOG () {102;}' unless defined(&IP_FW_XRESETLOG);
    eval 'sub IP_FW_SET_SWAP () {103;}' unless defined(&IP_FW_SET_SWAP);
    eval 'sub IP_FW_SET_MOVE () {104;}' unless defined(&IP_FW_SET_MOVE);
    eval 'sub IP_FW_SET_ENABLE () {105;}' unless defined(&IP_FW_SET_ENABLE);
    eval 'sub IP_FW_TABLE_XFIND () {106;}' unless defined(&IP_FW_TABLE_XFIND);
    eval 'sub IP_FW_XIFLIST () {107;}' unless defined(&IP_FW_XIFLIST);
    eval 'sub IP_FW_TABLES_ALIST () {108;}' unless defined(&IP_FW_TABLES_ALIST);
    eval 'sub IP_FW_TABLE_XSWAP () {109;}' unless defined(&IP_FW_TABLE_XSWAP);
    eval 'sub IP_FW_TABLE_VLIST () {110;}' unless defined(&IP_FW_TABLE_VLIST);
    eval 'sub IP_FW_NAT44_XCONFIG () {111;}' unless defined(&IP_FW_NAT44_XCONFIG);
    eval 'sub IP_FW_NAT44_DESTROY () {112;}' unless defined(&IP_FW_NAT44_DESTROY);
    eval 'sub IP_FW_NAT44_XGETCONFIG () {113;}' unless defined(&IP_FW_NAT44_XGETCONFIG);
    eval 'sub IP_FW_NAT44_LIST_NAT () {114;}' unless defined(&IP_FW_NAT44_LIST_NAT);
    eval 'sub IP_FW_NAT44_XGETLOG () {115;}' unless defined(&IP_FW_NAT44_XGETLOG);
    eval 'sub IP_FW_DUMP_SOPTCODES () {116;}' unless defined(&IP_FW_DUMP_SOPTCODES);
    eval 'sub IP_FW_DUMP_SRVOBJECTS () {117;}' unless defined(&IP_FW_DUMP_SRVOBJECTS);
    eval 'sub IP_FW_NAT64STL_CREATE () {130;}' unless defined(&IP_FW_NAT64STL_CREATE);
    eval 'sub IP_FW_NAT64STL_DESTROY () {131;}' unless defined(&IP_FW_NAT64STL_DESTROY);
    eval 'sub IP_FW_NAT64STL_CONFIG () {132;}' unless defined(&IP_FW_NAT64STL_CONFIG);
    eval 'sub IP_FW_NAT64STL_LIST () {133;}' unless defined(&IP_FW_NAT64STL_LIST);
    eval 'sub IP_FW_NAT64STL_STATS () {134;}' unless defined(&IP_FW_NAT64STL_STATS);
    eval 'sub IP_FW_NAT64STL_RESET_STATS () {135;}' unless defined(&IP_FW_NAT64STL_RESET_STATS);
    eval 'sub IP_FW_NAT64LSN_CREATE () {140;}' unless defined(&IP_FW_NAT64LSN_CREATE);
    eval 'sub IP_FW_NAT64LSN_DESTROY () {141;}' unless defined(&IP_FW_NAT64LSN_DESTROY);
    eval 'sub IP_FW_NAT64LSN_CONFIG () {142;}' unless defined(&IP_FW_NAT64LSN_CONFIG);
    eval 'sub IP_FW_NAT64LSN_LIST () {143;}' unless defined(&IP_FW_NAT64LSN_LIST);
    eval 'sub IP_FW_NAT64LSN_STATS () {144;}' unless defined(&IP_FW_NAT64LSN_STATS);
    eval 'sub IP_FW_NAT64LSN_LIST_STATES () {145;}' unless defined(&IP_FW_NAT64LSN_LIST_STATES);
    eval 'sub IP_FW_NAT64LSN_RESET_STATS () {146;}' unless defined(&IP_FW_NAT64LSN_RESET_STATS);
    eval 'sub IP_FW_NPTV6_CREATE () {150;}' unless defined(&IP_FW_NPTV6_CREATE);
    eval 'sub IP_FW_NPTV6_DESTROY () {151;}' unless defined(&IP_FW_NPTV6_DESTROY);
    eval 'sub IP_FW_NPTV6_CONFIG () {152;}' unless defined(&IP_FW_NPTV6_CONFIG);
    eval 'sub IP_FW_NPTV6_LIST () {153;}' unless defined(&IP_FW_NPTV6_LIST);
    eval 'sub IP_FW_NPTV6_STATS () {154;}' unless defined(&IP_FW_NPTV6_STATS);
    eval 'sub IP_FW_NPTV6_RESET_STATS () {155;}' unless defined(&IP_FW_NPTV6_RESET_STATS);
    eval("sub O_NOP () { 0; }") unless defined(&O_NOP);
    eval("sub O_IP_SRC () { 1; }") unless defined(&O_IP_SRC);
    eval("sub O_IP_SRC_MASK () { 2; }") unless defined(&O_IP_SRC_MASK);
    eval("sub O_IP_SRC_ME () { 3; }") unless defined(&O_IP_SRC_ME);
    eval("sub O_IP_SRC_SET () { 4; }") unless defined(&O_IP_SRC_SET);
    eval("sub O_IP_DST () { 5; }") unless defined(&O_IP_DST);
    eval("sub O_IP_DST_MASK () { 6; }") unless defined(&O_IP_DST_MASK);
    eval("sub O_IP_DST_ME () { 7; }") unless defined(&O_IP_DST_ME);
    eval("sub O_IP_DST_SET () { 8; }") unless defined(&O_IP_DST_SET);
    eval("sub O_IP_SRCPORT () { 9; }") unless defined(&O_IP_SRCPORT);
    eval("sub O_IP_DSTPORT () { 10; }") unless defined(&O_IP_DSTPORT);
    eval("sub O_PROTO () { 11; }") unless defined(&O_PROTO);
    eval("sub O_MACADDR2 () { 12; }") unless defined(&O_MACADDR2);
    eval("sub O_MAC_TYPE () { 13; }") unless defined(&O_MAC_TYPE);
    eval("sub O_LAYER2 () { 14; }") unless defined(&O_LAYER2);
    eval("sub O_IN () { 15; }") unless defined(&O_IN);
    eval("sub O_FRAG () { 16; }") unless defined(&O_FRAG);
    eval("sub O_RECV () { 17; }") unless defined(&O_RECV);
    eval("sub O_XMIT () { 18; }") unless defined(&O_XMIT);
    eval("sub O_VIA () { 19; }") unless defined(&O_VIA);
    eval("sub O_IPOPT () { 20; }") unless defined(&O_IPOPT);
    eval("sub O_IPLEN () { 21; }") unless defined(&O_IPLEN);
    eval("sub O_IPID () { 22; }") unless defined(&O_IPID);
    eval("sub O_IPTOS () { 23; }") unless defined(&O_IPTOS);
    eval("sub O_IPPRECEDENCE () { 24; }") unless defined(&O_IPPRECEDENCE);
    eval("sub O_IPTTL () { 25; }") unless defined(&O_IPTTL);
    eval("sub O_IPVER () { 26; }") unless defined(&O_IPVER);
    eval("sub O_UID () { 27; }") unless defined(&O_UID);
    eval("sub O_GID () { 28; }") unless defined(&O_GID);
    eval("sub O_ESTAB () { 29; }") unless defined(&O_ESTAB);
    eval("sub O_TCPFLAGS () { 30; }") unless defined(&O_TCPFLAGS);
    eval("sub O_TCPWIN () { 31; }") unless defined(&O_TCPWIN);
    eval("sub O_TCPSEQ () { 32; }") unless defined(&O_TCPSEQ);
    eval("sub O_TCPACK () { 33; }") unless defined(&O_TCPACK);
    eval("sub O_ICMPTYPE () { 34; }") unless defined(&O_ICMPTYPE);
    eval("sub O_TCPOPTS () { 35; }") unless defined(&O_TCPOPTS);
    eval("sub O_VERREVPATH () { 36; }") unless defined(&O_VERREVPATH);
    eval("sub O_VERSRCREACH () { 37; }") unless defined(&O_VERSRCREACH);
    eval("sub O_PROBE_STATE () { 38; }") unless defined(&O_PROBE_STATE);
    eval("sub O_KEEP_STATE () { 39; }") unless defined(&O_KEEP_STATE);
    eval("sub O_LIMIT () { 40; }") unless defined(&O_LIMIT);
    eval("sub O_LIMIT_PARENT () { 41; }") unless defined(&O_LIMIT_PARENT);
    eval("sub O_LOG () { 42; }") unless defined(&O_LOG);
    eval("sub O_PROB () { 43; }") unless defined(&O_PROB);
    eval("sub O_CHECK_STATE () { 44; }") unless defined(&O_CHECK_STATE);
    eval("sub O_ACCEPT () { 45; }") unless defined(&O_ACCEPT);
    eval("sub O_DENY () { 46; }") unless defined(&O_DENY);
    eval("sub O_REJECT () { 47; }") unless defined(&O_REJECT);
    eval("sub O_COUNT () { 48; }") unless defined(&O_COUNT);
    eval("sub O_SKIPTO () { 49; }") unless defined(&O_SKIPTO);
    eval("sub O_PIPE () { 50; }") unless defined(&O_PIPE);
    eval("sub O_QUEUE () { 51; }") unless defined(&O_QUEUE);
    eval("sub O_DIVERT () { 52; }") unless defined(&O_DIVERT);
    eval("sub O_TEE () { 53; }") unless defined(&O_TEE);
    eval("sub O_FORWARD_IP () { 54; }") unless defined(&O_FORWARD_IP);
    eval("sub O_FORWARD_MAC () { 55; }") unless defined(&O_FORWARD_MAC);
    eval("sub O_NAT () { 56; }") unless defined(&O_NAT);
    eval("sub O_REASS () { 57; }") unless defined(&O_REASS);
    eval("sub O_IPSEC () { 58; }") unless defined(&O_IPSEC);
    eval("sub O_IP_SRC_LOOKUP () { 59; }") unless defined(&O_IP_SRC_LOOKUP);
    eval("sub O_IP_DST_LOOKUP () { 60; }") unless defined(&O_IP_DST_LOOKUP);
    eval("sub O_ANTISPOOF () { 61; }") unless defined(&O_ANTISPOOF);
    eval("sub O_JAIL () { 62; }") unless defined(&O_JAIL);
    eval("sub O_ALTQ () { 63; }") unless defined(&O_ALTQ);
    eval("sub O_DIVERTED () { 64; }") unless defined(&O_DIVERTED);
    eval("sub O_TCPDATALEN () { 65; }") unless defined(&O_TCPDATALEN);
    eval("sub O_IP6_SRC () { 66; }") unless defined(&O_IP6_SRC);
    eval("sub O_IP6_SRC_ME () { 67; }") unless defined(&O_IP6_SRC_ME);
    eval("sub O_IP6_SRC_MASK () { 68; }") unless defined(&O_IP6_SRC_MASK);
    eval("sub O_IP6_DST () { 69; }") unless defined(&O_IP6_DST);
    eval("sub O_IP6_DST_ME () { 70; }") unless defined(&O_IP6_DST_ME);
    eval("sub O_IP6_DST_MASK () { 71; }") unless defined(&O_IP6_DST_MASK);
    eval("sub O_FLOW6ID () { 72; }") unless defined(&O_FLOW6ID);
    eval("sub O_ICMP6TYPE () { 73; }") unless defined(&O_ICMP6TYPE);
    eval("sub O_EXT_HDR () { 74; }") unless defined(&O_EXT_HDR);
    eval("sub O_IP6 () { 75; }") unless defined(&O_IP6);
    eval("sub O_NETGRAPH () { 76; }") unless defined(&O_NETGRAPH);
    eval("sub O_NGTEE () { 77; }") unless defined(&O_NGTEE);
    eval("sub O_IP4 () { 78; }") unless defined(&O_IP4);
    eval("sub O_UNREACH6 () { 79; }") unless defined(&O_UNREACH6);
    eval("sub O_TAG () { 80; }") unless defined(&O_TAG);
    eval("sub O_TAGGED () { 81; }") unless defined(&O_TAGGED);
    eval("sub O_SETFIB () { 82; }") unless defined(&O_SETFIB);
    eval("sub O_FIB () { 83; }") unless defined(&O_FIB);
    eval("sub O_SOCKARG () { 84; }") unless defined(&O_SOCKARG);
    eval("sub O_CALLRETURN () { 85; }") unless defined(&O_CALLRETURN);
    eval("sub O_FORWARD_IP6 () { 86; }") unless defined(&O_FORWARD_IP6);
    eval("sub O_DSCP () { 87; }") unless defined(&O_DSCP);
    eval("sub O_SETDSCP () { 88; }") unless defined(&O_SETDSCP);
    eval("sub O_IP_FLOW_LOOKUP () { 89; }") unless defined(&O_IP_FLOW_LOOKUP);
    eval("sub O_EXTERNAL_ACTION () { 90; }") unless defined(&O_EXTERNAL_ACTION);
    eval("sub O_EXTERNAL_INSTANCE () { 91; }") unless defined(&O_EXTERNAL_INSTANCE);
    eval("sub O_EXTERNAL_DATA () { 92; }") unless defined(&O_EXTERNAL_DATA);
    eval("sub O_LAST_OPCODE () { 93; }") unless defined(&O_LAST_OPCODE);
    eval 'sub EXT_FRAGMENT () {0x1;}' unless defined(&EXT_FRAGMENT);
    eval 'sub EXT_HOPOPTS () {0x2;}' unless defined(&EXT_HOPOPTS);
    eval 'sub EXT_ROUTING () {0x4;}' unless defined(&EXT_ROUTING);
    eval 'sub EXT_AH () {0x8;}' unless defined(&EXT_AH);
    eval 'sub EXT_ESP () {0x10;}' unless defined(&EXT_ESP);
    eval 'sub EXT_DSTOPTS () {0x20;}' unless defined(&EXT_DSTOPTS);
    eval 'sub EXT_RTHDR0 () {0x40;}' unless defined(&EXT_RTHDR0);
    eval 'sub EXT_RTHDR2 () {0x80;}' unless defined(&EXT_RTHDR2);
    eval 'sub F_NOT () {0x80;}' unless defined(&F_NOT);
    eval 'sub F_OR () {0x40;}' unless defined(&F_OR);
    eval 'sub F_LEN_MASK () {0x3f;}' unless defined(&F_LEN_MASK);
    eval 'sub F_LEN {
        my($cmd) = @_;
	    eval q((($cmd)-> &len &  &F_LEN_MASK));
    }' unless defined(&F_LEN);
    eval 'sub F_INSN_SIZE {
        my($t) = @_;
	    eval q((($sizeof{$t})/$sizeof{ &u_int32_t}));
    }' unless defined(&F_INSN_SIZE);
    eval 'sub DYN_SRC_ADDR () {0x1;}' unless defined(&DYN_SRC_ADDR);
    eval 'sub DYN_SRC_PORT () {0x2;}' unless defined(&DYN_SRC_PORT);
    eval 'sub DYN_DST_ADDR () {0x4;}' unless defined(&DYN_DST_ADDR);
    eval 'sub DYN_DST_PORT () {0x8;}' unless defined(&DYN_DST_PORT);
    unless(defined(&_KERNEL)) {
	if(defined(&IPFW_INTERNAL)) {
	}
	eval 'sub REDIR_ADDR () {0x1;}' unless defined(&REDIR_ADDR);
	eval 'sub REDIR_PORT () {0x2;}' unless defined(&REDIR_PORT);
	eval 'sub REDIR_PROTO () {0x4;}' unless defined(&REDIR_PROTO);
	if(defined(&IPFW_INTERNAL)) {
	}
	if(defined(&IPFW_INTERNAL)) {
	}
	eval 'sub SOF_NAT () {$sizeof{\'struct cfg_nat\'};}' unless defined(&SOF_NAT);
	eval 'sub SOF_REDIR () {$sizeof{\'struct cfg_redir\'};}' unless defined(&SOF_REDIR);
	eval 'sub SOF_SPOOL () {$sizeof{\'struct cfg_spool\'};}' unless defined(&SOF_SPOOL);
    }
    eval 'sub NAT44_REDIR_ADDR () {0x1;}' unless defined(&NAT44_REDIR_ADDR);
    eval 'sub NAT44_REDIR_PORT () {0x2;}' unless defined(&NAT44_REDIR_PORT);
    eval 'sub NAT44_REDIR_PROTO () {0x4;}' unless defined(&NAT44_REDIR_PROTO);
    eval 'sub APPLY_MASK {
        my($addr,$mask) = @_;
	    eval q(($addr)-> ($__u6_addr->{__u6_addr32[0]}) &= ($mask)-> ($__u6_addr->{__u6_addr32[0]}); ($addr)-> ($__u6_addr->{__u6_addr32[1]}) &= ($mask)-> ($__u6_addr->{__u6_addr32[1]}); ($addr)-> ($__u6_addr->{__u6_addr32[2]}) &= ($mask)-> ($__u6_addr->{__u6_addr32[2]}); ($addr)-> ($__u6_addr->{__u6_addr32[3]}) &= ($mask)-> ($__u6_addr->{__u6_addr32[3]}););
    }' unless defined(&APPLY_MASK);
    eval 'sub IPFW_RULE_NOOPT () {0x1;}' unless defined(&IPFW_RULE_NOOPT);
    unless(defined(&_KERNEL)) {
    }
    eval 'sub ACTION_PTR {
        my($rule) = @_;
	    eval q(( &ipfw_insn *)( ( &u_int32_t *)(($rule)-> &cmd) + (($rule)-> &act_ofs) ));
    }' unless defined(&ACTION_PTR);
    eval 'sub RULESIZE {
        my($rule) = @_;
	    eval q(($sizeof{($rule)} + ($rule)-> &cmd_len * 4- 4));
    }' unless defined(&RULESIZE);
    if(1) {
    }
    eval 'sub IS_IP4_FLOW_ID {
        my($id) = @_;
	    eval q((($id)-> &addr_type == 4));
    }' unless defined(&IS_IP4_FLOW_ID);
    eval 'sub IS_IP6_FLOW_ID {
        my($id) = @_;
	    eval q((($id)-> &addr_type == 6));
    }' unless defined(&IS_IP6_FLOW_ID);
    eval 'sub IP_FW_IPOPT_LSRR () {0x1;}' unless defined(&IP_FW_IPOPT_LSRR);
    eval 'sub IP_FW_IPOPT_SSRR () {0x2;}' unless defined(&IP_FW_IPOPT_SSRR);
    eval 'sub IP_FW_IPOPT_RR () {0x4;}' unless defined(&IP_FW_IPOPT_RR);
    eval 'sub IP_FW_IPOPT_TS () {0x8;}' unless defined(&IP_FW_IPOPT_TS);
    eval 'sub IP_FW_TCPOPT_MSS () {0x1;}' unless defined(&IP_FW_TCPOPT_MSS);
    eval 'sub IP_FW_TCPOPT_WINDOW () {0x2;}' unless defined(&IP_FW_TCPOPT_WINDOW);
    eval 'sub IP_FW_TCPOPT_SACK () {0x4;}' unless defined(&IP_FW_TCPOPT_SACK);
    eval 'sub IP_FW_TCPOPT_TS () {0x8;}' unless defined(&IP_FW_TCPOPT_TS);
    eval 'sub IP_FW_TCPOPT_CC () {0x10;}' unless defined(&IP_FW_TCPOPT_CC);
    eval 'sub ICMP_REJECT_RST () {0x100;}' unless defined(&ICMP_REJECT_RST);
    eval 'sub ICMP6_UNREACH_RST () {0x100;}' unless defined(&ICMP6_UNREACH_RST);
    eval 'sub ICMP_REJECT_ABORT () {0x101;}' unless defined(&ICMP_REJECT_ABORT);
    eval 'sub ICMP6_UNREACH_ABORT () {0x101;}' unless defined(&ICMP6_UNREACH_ABORT);
    eval 'sub IPFW_TABLE_ADDR () {1;}' unless defined(&IPFW_TABLE_ADDR);
    eval 'sub IPFW_TABLE_INTERFACE () {2;}' unless defined(&IPFW_TABLE_INTERFACE);
    eval 'sub IPFW_TABLE_NUMBER () {3;}' unless defined(&IPFW_TABLE_NUMBER);
    eval 'sub IPFW_TABLE_FLOW () {4;}' unless defined(&IPFW_TABLE_FLOW);
    eval 'sub IPFW_TABLE_MAXTYPE () {4;}' unless defined(&IPFW_TABLE_MAXTYPE);
    eval 'sub IPFW_TABLE_CIDR () { &IPFW_TABLE_ADDR;}' unless defined(&IPFW_TABLE_CIDR);
    eval 'sub IPFW_VTYPE_LEGACY () {0xffffffff;}' unless defined(&IPFW_VTYPE_LEGACY);
    eval 'sub IPFW_VTYPE_SKIPTO () {0x1;}' unless defined(&IPFW_VTYPE_SKIPTO);
    eval 'sub IPFW_VTYPE_PIPE () {0x2;}' unless defined(&IPFW_VTYPE_PIPE);
    eval 'sub IPFW_VTYPE_FIB () {0x4;}' unless defined(&IPFW_VTYPE_FIB);
    eval 'sub IPFW_VTYPE_NAT () {0x8;}' unless defined(&IPFW_VTYPE_NAT);
    eval 'sub IPFW_VTYPE_DSCP () {0x10;}' unless defined(&IPFW_VTYPE_DSCP);
    eval 'sub IPFW_VTYPE_TAG () {0x20;}' unless defined(&IPFW_VTYPE_TAG);
    eval 'sub IPFW_VTYPE_DIVERT () {0x40;}' unless defined(&IPFW_VTYPE_DIVERT);
    eval 'sub IPFW_VTYPE_NETGRAPH () {0x80;}' unless defined(&IPFW_VTYPE_NETGRAPH);
    eval 'sub IPFW_VTYPE_LIMIT () {0x100;}' unless defined(&IPFW_VTYPE_LIMIT);
    eval 'sub IPFW_VTYPE_NH4 () {0x200;}' unless defined(&IPFW_VTYPE_NH4);
    eval 'sub IPFW_VTYPE_NH6 () {0x400;}' unless defined(&IPFW_VTYPE_NH6);
    eval 'sub IPFW_TCF_INET () {0x1;}' unless defined(&IPFW_TCF_INET);
    eval 'sub IPFW_TLV_TBL_NAME () {1;}' unless defined(&IPFW_TLV_TBL_NAME);
    eval 'sub IPFW_TLV_TBLNAME_LIST () {2;}' unless defined(&IPFW_TLV_TBLNAME_LIST);
    eval 'sub IPFW_TLV_RULE_LIST () {3;}' unless defined(&IPFW_TLV_RULE_LIST);
    eval 'sub IPFW_TLV_DYNSTATE_LIST () {4;}' unless defined(&IPFW_TLV_DYNSTATE_LIST);
    eval 'sub IPFW_TLV_TBL_ENT () {5;}' unless defined(&IPFW_TLV_TBL_ENT);
    eval 'sub IPFW_TLV_DYN_ENT () {6;}' unless defined(&IPFW_TLV_DYN_ENT);
    eval 'sub IPFW_TLV_RULE_ENT () {7;}' unless defined(&IPFW_TLV_RULE_ENT);
    eval 'sub IPFW_TLV_TBLENT_LIST () {8;}' unless defined(&IPFW_TLV_TBLENT_LIST);
    eval 'sub IPFW_TLV_RANGE () {9;}' unless defined(&IPFW_TLV_RANGE);
    eval 'sub IPFW_TLV_EACTION () {10;}' unless defined(&IPFW_TLV_EACTION);
    eval 'sub IPFW_TLV_COUNTERS () {11;}' unless defined(&IPFW_TLV_COUNTERS);
    eval 'sub IPFW_TLV_OBJDATA () {12;}' unless defined(&IPFW_TLV_OBJDATA);
    eval 'sub IPFW_TLV_STATE_NAME () {14;}' unless defined(&IPFW_TLV_STATE_NAME);
    eval 'sub IPFW_TLV_EACTION_BASE () {1000;}' unless defined(&IPFW_TLV_EACTION_BASE);
    eval 'sub IPFW_TLV_EACTION_NAME {
        my($arg) = @_;
	    eval q(( &IPFW_TLV_EACTION_BASE + ($arg)));
    }' unless defined(&IPFW_TLV_EACTION_NAME);
    eval 'sub IPFW_TF_UPDATE () {0x1;}' unless defined(&IPFW_TF_UPDATE);
    eval 'sub IPFW_CTF_ATOMIC () {0x1;}' unless defined(&IPFW_CTF_ATOMIC);
    eval 'sub IPFW_TR_IGNORED () {0;}' unless defined(&IPFW_TR_IGNORED);
    eval 'sub IPFW_TR_ADDED () {1;}' unless defined(&IPFW_TR_ADDED);
    eval 'sub IPFW_TR_UPDATED () {2;}' unless defined(&IPFW_TR_UPDATED);
    eval 'sub IPFW_TR_DELETED () {3;}' unless defined(&IPFW_TR_DELETED);
    eval 'sub IPFW_TR_LIMIT () {4;}' unless defined(&IPFW_TR_LIMIT);
    eval 'sub IPFW_TR_NOTFOUND () {5;}' unless defined(&IPFW_TR_NOTFOUND);
    eval 'sub IPFW_TR_EXISTS () {6;}' unless defined(&IPFW_TR_EXISTS);
    eval 'sub IPFW_TR_ERROR () {7;}' unless defined(&IPFW_TR_ERROR);
    eval 'sub IPFW_DF_LAST () {0x1;}' unless defined(&IPFW_DF_LAST);
    eval 'sub IPFW_RCFLAG_RANGE () {0x1;}' unless defined(&IPFW_RCFLAG_RANGE);
    eval 'sub IPFW_RCFLAG_ALL () {0x2;}' unless defined(&IPFW_RCFLAG_ALL);
    eval 'sub IPFW_RCFLAG_SET () {0x4;}' unless defined(&IPFW_RCFLAG_SET);
    eval 'sub IPFW_RCFLAG_USER () {( &IPFW_RCFLAG_RANGE |  &IPFW_RCFLAG_ALL |  &IPFW_RCFLAG_SET);}' unless defined(&IPFW_RCFLAG_USER);
    eval 'sub IPFW_RCFLAG_DEFAULT () {0x100;}' unless defined(&IPFW_RCFLAG_DEFAULT);
    eval 'sub IPFW_TACLASS_HASH () {1;}' unless defined(&IPFW_TACLASS_HASH);
    eval 'sub IPFW_TACLASS_ARRAY () {2;}' unless defined(&IPFW_TACLASS_ARRAY);
    eval 'sub IPFW_TACLASS_RADIX () {3;}' unless defined(&IPFW_TACLASS_RADIX);
    eval 'sub IPFW_TATFLAGS_DATA () {0x1;}' unless defined(&IPFW_TATFLAGS_DATA);
    eval 'sub IPFW_TATFLAGS_AFDATA () {0x2;}' unless defined(&IPFW_TATFLAGS_AFDATA);
    eval 'sub IPFW_TATFLAGS_AFITEM () {0x4;}' unless defined(&IPFW_TATFLAGS_AFITEM);
    eval 'sub IPFW_TGFLAGS_LOCKED () {0x1;}' unless defined(&IPFW_TGFLAGS_LOCKED);
    eval 'sub IPFW_TFFLAG_SRCIP () {0x1;}' unless defined(&IPFW_TFFLAG_SRCIP);
    eval 'sub IPFW_TFFLAG_DSTIP () {0x2;}' unless defined(&IPFW_TFFLAG_DSTIP);
    eval 'sub IPFW_TFFLAG_SRCPORT () {0x4;}' unless defined(&IPFW_TFFLAG_SRCPORT);
    eval 'sub IPFW_TFFLAG_DSTPORT () {0x8;}' unless defined(&IPFW_TFFLAG_DSTPORT);
    eval 'sub IPFW_TFFLAG_PROTO () {0x10;}' unless defined(&IPFW_TFFLAG_PROTO);
    eval 'sub IPFW_TMFLAGS_LIMIT () {0x2;}' unless defined(&IPFW_TMFLAGS_LIMIT);
    eval 'sub IPFW_TMFLAGS_LOCK () {0x4;}' unless defined(&IPFW_TMFLAGS_LOCK);
    eval 'sub IPFW_IFFLAG_RESOLVED () {0x1;}' unless defined(&IPFW_IFFLAG_RESOLVED);
    eval 'sub IPFW_CFG_GET_STATIC () {0x1;}' unless defined(&IPFW_CFG_GET_STATIC);
    eval 'sub IPFW_CFG_GET_STATES () {0x2;}' unless defined(&IPFW_CFG_GET_STATES);
    eval 'sub IPFW_CFG_GET_COUNTERS () {0x4;}' unless defined(&IPFW_CFG_GET_COUNTERS);
}
1;
