require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_IP_VAR_H_)) {
    eval 'sub _NETINET_IP_VAR_H_ () {1;}' unless defined(&_NETINET_IP_VAR_H_);
    require 'sys/queue.ph';
    if(defined(&_KERNEL)) {
    }
    eval 'sub MAX_IPOPTLEN () {40;}' unless defined(&MAX_IPOPTLEN);
    if(defined(&_KERNEL)) {
	require 'sys/counter.ph';
	require 'net/vnet.ph';
	eval 'sub IPSTAT_ADD {
	    my($name, $val) = @_;
    	    eval q( &VNET_PCPUSTAT_ADD(\'struct ipstat\',  &ipstat, $name, ($val)));
	}' unless defined(&IPSTAT_ADD);
	eval 'sub IPSTAT_SUB {
	    my($name, $val) = @_;
    	    eval q( &IPSTAT_ADD($name, -($val)));
	}' unless defined(&IPSTAT_SUB);
	eval 'sub IPSTAT_INC {
	    my($name) = @_;
    	    eval q( &IPSTAT_ADD($name, 1));
	}' unless defined(&IPSTAT_INC);
	eval 'sub IPSTAT_DEC {
	    my($name) = @_;
    	    eval q( &IPSTAT_SUB($name, 1));
	}' unless defined(&IPSTAT_DEC);
	eval 'sub KMOD_IPSTAT_INC {
	    my($name) = @_;
    	    eval q( &kmod_ipstat_inc( &offsetof(\'struct ipstat\', $name) / $sizeof{ &uint64_t}));
	}' unless defined(&KMOD_IPSTAT_INC);
	eval 'sub KMOD_IPSTAT_DEC {
	    my($name) = @_;
    	    eval q( &kmod_ipstat_dec( &offsetof(\'struct ipstat\', $name) / $sizeof{ &uint64_t}));
	}' unless defined(&KMOD_IPSTAT_DEC);
	eval 'sub IP_FORWARDING () {0x1;}' unless defined(&IP_FORWARDING);
	eval 'sub IP_RAWOUTPUT () {0x2;}' unless defined(&IP_RAWOUTPUT);
	eval 'sub IP_SENDONES () {0x4;}' unless defined(&IP_SENDONES);
	eval 'sub IP_SENDTOIF () {0x8;}' unless defined(&IP_SENDTOIF);
	eval 'sub IP_ROUTETOIF () { &SO_DONTROUTE;}' unless defined(&IP_ROUTETOIF);
	eval 'sub IP_ALLOWBROADCAST () { &SO_BROADCAST;}' unless defined(&IP_ALLOWBROADCAST);
	eval 'sub IP_NODEFAULTFLOWID () {0x40;}' unless defined(&IP_NODEFAULTFLOWID);
	if(defined(&__NO_STRICT_ALIGNMENT)) {
	    eval 'sub IP_HDR_ALIGNED_P {
	        my($ip) = @_;
    		eval q(1);
	    }' unless defined(&IP_HDR_ALIGNED_P);
	} else {
	    eval 'sub IP_HDR_ALIGNED_P {
	        my($ip) = @_;
    		eval q((((( &intptr_t) ($ip)) & 3) == 0));
	    }' unless defined(&IP_HDR_ALIGNED_P);
	}
	if(defined(&IPSTEALTH)) {
	}
	eval 'sub V_ip_id () { &VNET( &ip_id);}' unless defined(&V_ip_id);
	eval 'sub V_ip_defttl () { &VNET( &ip_defttl);}' unless defined(&V_ip_defttl);
	eval 'sub V_ipforwarding () { &VNET( &ipforwarding);}' unless defined(&V_ipforwarding);
	if(defined(&IPSTEALTH)) {
	    eval 'sub V_ipstealth () { &VNET( &ipstealth);}' unless defined(&V_ipstealth);
	}
	eval 'sub V_ip_rsvpd () { &VNET( &ip_rsvpd);}' unless defined(&V_ip_rsvpd);
	eval 'sub V_ip_mrouter () { &VNET( &ip_mrouter);}' unless defined(&V_ip_mrouter);
	eval 'sub V_rsvp_on () { &VNET( &rsvp_on);}' unless defined(&V_rsvp_on);
	eval 'sub V_drop_redirect () { &VNET( &drop_redirect);}' unless defined(&V_drop_redirect);
	eval 'sub V_inet_pfil_hook () { &VNET( &inet_pfil_hook);}' unless defined(&V_inet_pfil_hook);
	eval("sub IPFW_INFO_MASK () { 0x0000ffff; }") unless defined(&IPFW_INFO_MASK);
	eval("sub IPFW_INFO_OUT () { 0x00000000; }") unless defined(&IPFW_INFO_OUT);
	eval("sub IPFW_INFO_IN () { 0x80000000; }") unless defined(&IPFW_INFO_IN);
	eval("sub IPFW_ONEPASS () { 0x40000000; }") unless defined(&IPFW_ONEPASS);
	eval("sub IPFW_IS_MASK () { 0x30000000; }") unless defined(&IPFW_IS_MASK);
	eval("sub IPFW_IS_DIVERT () { 0x20000000; }") unless defined(&IPFW_IS_DIVERT);
	eval("sub IPFW_IS_DUMMYNET () { 0x10000000; }") unless defined(&IPFW_IS_DUMMYNET);
	eval("sub IPFW_IS_PIPE () { 0x08000000; }") unless defined(&IPFW_IS_PIPE);
	eval 'sub MTAG_IPFW () {1148380143;}' unless defined(&MTAG_IPFW);
	eval 'sub MTAG_IPFW_RULE () {1262273568;}' unless defined(&MTAG_IPFW_RULE);
	eval 'sub MTAG_IPFW_CALL () {1308397630;}' unless defined(&MTAG_IPFW_CALL);
	eval 'sub V_ip_fw_ctl_ptr () { &VNET( &ip_fw_ctl_ptr);}' unless defined(&V_ip_fw_ctl_ptr);
    }
}
1;
