require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NETINET_SCTP_CONSTANTS_H_)) {
    eval 'sub _NETINET_SCTP_CONSTANTS_H_ () {1;}' unless defined(&_NETINET_SCTP_CONSTANTS_H_);
    eval 'sub SCTP_OVER_UDP_TUNNELING_PORT () {9899;}' unless defined(&SCTP_OVER_UDP_TUNNELING_PORT);
    eval 'sub SCTP_DEFAULT_SACK_FREQ () {2;}' unless defined(&SCTP_DEFAULT_SACK_FREQ);
    eval 'sub SCTP_ADDRESS_LIMIT () {1080;}' unless defined(&SCTP_ADDRESS_LIMIT);
    eval 'sub SCTP_LARGEST_INIT_ACCEPTED () {(65535- 2048);}' unless defined(&SCTP_LARGEST_INIT_ACCEPTED);
    eval 'sub SCTP_MAX_CHUNK_LENGTH () {0xffff;}' unless defined(&SCTP_MAX_CHUNK_LENGTH);
    eval 'sub SCTP_MAX_CAUSE_LENGTH () {0xffff;}' unless defined(&SCTP_MAX_CAUSE_LENGTH);
    eval 'sub SCTP_COUNT_LIMIT () {40;}' unless defined(&SCTP_COUNT_LIMIT);
    eval 'sub SCTP_ZERO_COPY_TICK_DELAY () {(((100*  &hz) + 999) / 1000);}' unless defined(&SCTP_ZERO_COPY_TICK_DELAY);
    eval 'sub SCTP_ZERO_COPY_SENDQ_TICK_DELAY () {(((100*  &hz) + 999) / 1000);}' unless defined(&SCTP_ZERO_COPY_SENDQ_TICK_DELAY);
    eval 'sub SCTP_ADDRESS_TICK_DELAY () {2;}' unless defined(&SCTP_ADDRESS_TICK_DELAY);
    eval 'sub SCTP_VERSION_STRING () {"KAME-BSD 1.1";}' unless defined(&SCTP_VERSION_STRING);
    eval 'sub SCTP_AUDIT_SIZE () {256;}' unless defined(&SCTP_AUDIT_SIZE);
    eval 'sub SCTP_KTRHEAD_NAME () {"sctp_iterator";}' unless defined(&SCTP_KTRHEAD_NAME);
    eval 'sub SCTP_KTHREAD_PAGES () {0;}' unless defined(&SCTP_KTHREAD_PAGES);
    eval 'sub SCTP_MCORE_NAME () {"sctp_core_worker";}' unless defined(&SCTP_MCORE_NAME);
    eval 'sub SCTP_DEFAULT_VRF_SIZE () {4;}' unless defined(&SCTP_DEFAULT_VRF_SIZE);
    eval 'sub ALPHA_BASE () {(1<<7);}' unless defined(&ALPHA_BASE);
    eval 'sub BETA_MIN () {(1<<6);}' unless defined(&BETA_MIN);
    eval 'sub BETA_MAX () {102;}' unless defined(&BETA_MAX);
    eval 'sub SCTP_CWND_LOG_FROM_FR () {1;}' unless defined(&SCTP_CWND_LOG_FROM_FR);
    eval 'sub SCTP_CWND_LOG_FROM_RTX () {2;}' unless defined(&SCTP_CWND_LOG_FROM_RTX);
    eval 'sub SCTP_CWND_LOG_FROM_BRST () {3;}' unless defined(&SCTP_CWND_LOG_FROM_BRST);
    eval 'sub SCTP_CWND_LOG_FROM_SS () {4;}' unless defined(&SCTP_CWND_LOG_FROM_SS);
    eval 'sub SCTP_CWND_LOG_FROM_CA () {5;}' unless defined(&SCTP_CWND_LOG_FROM_CA);
    eval 'sub SCTP_CWND_LOG_FROM_SAT () {6;}' unless defined(&SCTP_CWND_LOG_FROM_SAT);
    eval 'sub SCTP_BLOCK_LOG_INTO_BLK () {7;}' unless defined(&SCTP_BLOCK_LOG_INTO_BLK);
    eval 'sub SCTP_BLOCK_LOG_OUTOF_BLK () {8;}' unless defined(&SCTP_BLOCK_LOG_OUTOF_BLK);
    eval 'sub SCTP_BLOCK_LOG_CHECK () {9;}' unless defined(&SCTP_BLOCK_LOG_CHECK);
    eval 'sub SCTP_STR_LOG_FROM_INTO_STRD () {10;}' unless defined(&SCTP_STR_LOG_FROM_INTO_STRD);
    eval 'sub SCTP_STR_LOG_FROM_IMMED_DEL () {11;}' unless defined(&SCTP_STR_LOG_FROM_IMMED_DEL);
    eval 'sub SCTP_STR_LOG_FROM_INSERT_HD () {12;}' unless defined(&SCTP_STR_LOG_FROM_INSERT_HD);
    eval 'sub SCTP_STR_LOG_FROM_INSERT_MD () {13;}' unless defined(&SCTP_STR_LOG_FROM_INSERT_MD);
    eval 'sub SCTP_STR_LOG_FROM_INSERT_TL () {14;}' unless defined(&SCTP_STR_LOG_FROM_INSERT_TL);
    eval 'sub SCTP_STR_LOG_FROM_MARK_TSN () {15;}' unless defined(&SCTP_STR_LOG_FROM_MARK_TSN);
    eval 'sub SCTP_STR_LOG_FROM_EXPRS_DEL () {16;}' unless defined(&SCTP_STR_LOG_FROM_EXPRS_DEL);
    eval 'sub SCTP_FR_LOG_BIGGEST_TSNS () {17;}' unless defined(&SCTP_FR_LOG_BIGGEST_TSNS);
    eval 'sub SCTP_FR_LOG_STRIKE_TEST () {18;}' unless defined(&SCTP_FR_LOG_STRIKE_TEST);
    eval 'sub SCTP_FR_LOG_STRIKE_CHUNK () {19;}' unless defined(&SCTP_FR_LOG_STRIKE_CHUNK);
    eval 'sub SCTP_FR_T3_TIMEOUT () {20;}' unless defined(&SCTP_FR_T3_TIMEOUT);
    eval 'sub SCTP_MAP_PREPARE_SLIDE () {21;}' unless defined(&SCTP_MAP_PREPARE_SLIDE);
    eval 'sub SCTP_MAP_SLIDE_FROM () {22;}' unless defined(&SCTP_MAP_SLIDE_FROM);
    eval 'sub SCTP_MAP_SLIDE_RESULT () {23;}' unless defined(&SCTP_MAP_SLIDE_RESULT);
    eval 'sub SCTP_MAP_SLIDE_CLEARED () {24;}' unless defined(&SCTP_MAP_SLIDE_CLEARED);
    eval 'sub SCTP_MAP_SLIDE_NONE () {25;}' unless defined(&SCTP_MAP_SLIDE_NONE);
    eval 'sub SCTP_FR_T3_MARK_TIME () {26;}' unless defined(&SCTP_FR_T3_MARK_TIME);
    eval 'sub SCTP_FR_T3_MARKED () {27;}' unless defined(&SCTP_FR_T3_MARKED);
    eval 'sub SCTP_FR_T3_STOPPED () {28;}' unless defined(&SCTP_FR_T3_STOPPED);
    eval 'sub SCTP_FR_MARKED () {30;}' unless defined(&SCTP_FR_MARKED);
    eval 'sub SCTP_CWND_LOG_NOADV_SS () {31;}' unless defined(&SCTP_CWND_LOG_NOADV_SS);
    eval 'sub SCTP_CWND_LOG_NOADV_CA () {32;}' unless defined(&SCTP_CWND_LOG_NOADV_CA);
    eval 'sub SCTP_MAX_BURST_APPLIED () {33;}' unless defined(&SCTP_MAX_BURST_APPLIED);
    eval 'sub SCTP_MAX_IFP_APPLIED () {34;}' unless defined(&SCTP_MAX_IFP_APPLIED);
    eval 'sub SCTP_MAX_BURST_ERROR_STOP () {35;}' unless defined(&SCTP_MAX_BURST_ERROR_STOP);
    eval 'sub SCTP_INCREASE_PEER_RWND () {36;}' unless defined(&SCTP_INCREASE_PEER_RWND);
    eval 'sub SCTP_DECREASE_PEER_RWND () {37;}' unless defined(&SCTP_DECREASE_PEER_RWND);
    eval 'sub SCTP_SET_PEER_RWND_VIA_SACK () {38;}' unless defined(&SCTP_SET_PEER_RWND_VIA_SACK);
    eval 'sub SCTP_LOG_MBCNT_INCREASE () {39;}' unless defined(&SCTP_LOG_MBCNT_INCREASE);
    eval 'sub SCTP_LOG_MBCNT_DECREASE () {40;}' unless defined(&SCTP_LOG_MBCNT_DECREASE);
    eval 'sub SCTP_LOG_MBCNT_CHKSET () {41;}' unless defined(&SCTP_LOG_MBCNT_CHKSET);
    eval 'sub SCTP_LOG_NEW_SACK () {42;}' unless defined(&SCTP_LOG_NEW_SACK);
    eval 'sub SCTP_LOG_TSN_ACKED () {43;}' unless defined(&SCTP_LOG_TSN_ACKED);
    eval 'sub SCTP_LOG_TSN_REVOKED () {44;}' unless defined(&SCTP_LOG_TSN_REVOKED);
    eval 'sub SCTP_LOG_LOCK_TCB () {45;}' unless defined(&SCTP_LOG_LOCK_TCB);
    eval 'sub SCTP_LOG_LOCK_INP () {46;}' unless defined(&SCTP_LOG_LOCK_INP);
    eval 'sub SCTP_LOG_LOCK_SOCK () {47;}' unless defined(&SCTP_LOG_LOCK_SOCK);
    eval 'sub SCTP_LOG_LOCK_SOCKBUF_R () {48;}' unless defined(&SCTP_LOG_LOCK_SOCKBUF_R);
    eval 'sub SCTP_LOG_LOCK_SOCKBUF_S () {49;}' unless defined(&SCTP_LOG_LOCK_SOCKBUF_S);
    eval 'sub SCTP_LOG_LOCK_CREATE () {50;}' unless defined(&SCTP_LOG_LOCK_CREATE);
    eval 'sub SCTP_LOG_INITIAL_RTT () {51;}' unless defined(&SCTP_LOG_INITIAL_RTT);
    eval 'sub SCTP_LOG_RTTVAR () {52;}' unless defined(&SCTP_LOG_RTTVAR);
    eval 'sub SCTP_LOG_SBALLOC () {53;}' unless defined(&SCTP_LOG_SBALLOC);
    eval 'sub SCTP_LOG_SBFREE () {54;}' unless defined(&SCTP_LOG_SBFREE);
    eval 'sub SCTP_LOG_SBRESULT () {55;}' unless defined(&SCTP_LOG_SBRESULT);
    eval 'sub SCTP_FR_DUPED () {56;}' unless defined(&SCTP_FR_DUPED);
    eval 'sub SCTP_FR_MARKED_EARLY () {57;}' unless defined(&SCTP_FR_MARKED_EARLY);
    eval 'sub SCTP_FR_CWND_REPORT () {58;}' unless defined(&SCTP_FR_CWND_REPORT);
    eval 'sub SCTP_FR_CWND_REPORT_START () {59;}' unless defined(&SCTP_FR_CWND_REPORT_START);
    eval 'sub SCTP_FR_CWND_REPORT_STOP () {60;}' unless defined(&SCTP_FR_CWND_REPORT_STOP);
    eval 'sub SCTP_CWND_LOG_FROM_SEND () {61;}' unless defined(&SCTP_CWND_LOG_FROM_SEND);
    eval 'sub SCTP_CWND_INITIALIZATION () {62;}' unless defined(&SCTP_CWND_INITIALIZATION);
    eval 'sub SCTP_CWND_LOG_FROM_T3 () {63;}' unless defined(&SCTP_CWND_LOG_FROM_T3);
    eval 'sub SCTP_CWND_LOG_FROM_SACK () {64;}' unless defined(&SCTP_CWND_LOG_FROM_SACK);
    eval 'sub SCTP_CWND_LOG_NO_CUMACK () {65;}' unless defined(&SCTP_CWND_LOG_NO_CUMACK);
    eval 'sub SCTP_CWND_LOG_FROM_RESEND () {66;}' unless defined(&SCTP_CWND_LOG_FROM_RESEND);
    eval 'sub SCTP_FR_LOG_CHECK_STRIKE () {67;}' unless defined(&SCTP_FR_LOG_CHECK_STRIKE);
    eval 'sub SCTP_SEND_NOW_COMPLETES () {68;}' unless defined(&SCTP_SEND_NOW_COMPLETES);
    eval 'sub SCTP_CWND_LOG_FILL_OUTQ_CALLED () {69;}' unless defined(&SCTP_CWND_LOG_FILL_OUTQ_CALLED);
    eval 'sub SCTP_CWND_LOG_FILL_OUTQ_FILLS () {70;}' unless defined(&SCTP_CWND_LOG_FILL_OUTQ_FILLS);
    eval 'sub SCTP_LOG_FREE_SENT () {71;}' unless defined(&SCTP_LOG_FREE_SENT);
    eval 'sub SCTP_NAGLE_APPLIED () {72;}' unless defined(&SCTP_NAGLE_APPLIED);
    eval 'sub SCTP_NAGLE_SKIPPED () {73;}' unless defined(&SCTP_NAGLE_SKIPPED);
    eval 'sub SCTP_WAKESND_FROM_SACK () {74;}' unless defined(&SCTP_WAKESND_FROM_SACK);
    eval 'sub SCTP_WAKESND_FROM_FWDTSN () {75;}' unless defined(&SCTP_WAKESND_FROM_FWDTSN);
    eval 'sub SCTP_NOWAKE_FROM_SACK () {76;}' unless defined(&SCTP_NOWAKE_FROM_SACK);
    eval 'sub SCTP_CWNDLOG_PRESEND () {77;}' unless defined(&SCTP_CWNDLOG_PRESEND);
    eval 'sub SCTP_CWNDLOG_ENDSEND () {78;}' unless defined(&SCTP_CWNDLOG_ENDSEND);
    eval 'sub SCTP_AT_END_OF_SACK () {79;}' unless defined(&SCTP_AT_END_OF_SACK);
    eval 'sub SCTP_REASON_FOR_SC () {80;}' unless defined(&SCTP_REASON_FOR_SC);
    eval 'sub SCTP_BLOCK_LOG_INTO_BLKA () {81;}' unless defined(&SCTP_BLOCK_LOG_INTO_BLKA);
    eval 'sub SCTP_ENTER_USER_RECV () {82;}' unless defined(&SCTP_ENTER_USER_RECV);
    eval 'sub SCTP_USER_RECV_SACKS () {83;}' unless defined(&SCTP_USER_RECV_SACKS);
    eval 'sub SCTP_SORECV_BLOCKSA () {84;}' unless defined(&SCTP_SORECV_BLOCKSA);
    eval 'sub SCTP_SORECV_BLOCKSB () {85;}' unless defined(&SCTP_SORECV_BLOCKSB);
    eval 'sub SCTP_SORECV_DONE () {86;}' unless defined(&SCTP_SORECV_DONE);
    eval 'sub SCTP_SACK_RWND_UPDATE () {87;}' unless defined(&SCTP_SACK_RWND_UPDATE);
    eval 'sub SCTP_SORECV_ENTER () {88;}' unless defined(&SCTP_SORECV_ENTER);
    eval 'sub SCTP_SORECV_ENTERPL () {89;}' unless defined(&SCTP_SORECV_ENTERPL);
    eval 'sub SCTP_MBUF_INPUT () {90;}' unless defined(&SCTP_MBUF_INPUT);
    eval 'sub SCTP_MBUF_IALLOC () {91;}' unless defined(&SCTP_MBUF_IALLOC);
    eval 'sub SCTP_MBUF_IFREE () {92;}' unless defined(&SCTP_MBUF_IFREE);
    eval 'sub SCTP_MBUF_ICOPY () {93;}' unless defined(&SCTP_MBUF_ICOPY);
    eval 'sub SCTP_MBUF_SPLIT () {94;}' unless defined(&SCTP_MBUF_SPLIT);
    eval 'sub SCTP_SORCV_FREECTL () {95;}' unless defined(&SCTP_SORCV_FREECTL);
    eval 'sub SCTP_SORCV_DOESCPY () {96;}' unless defined(&SCTP_SORCV_DOESCPY);
    eval 'sub SCTP_SORCV_DOESLCK () {97;}' unless defined(&SCTP_SORCV_DOESLCK);
    eval 'sub SCTP_SORCV_DOESADJ () {98;}' unless defined(&SCTP_SORCV_DOESADJ);
    eval 'sub SCTP_SORCV_BOTWHILE () {99;}' unless defined(&SCTP_SORCV_BOTWHILE);
    eval 'sub SCTP_SORCV_PASSBF () {100;}' unless defined(&SCTP_SORCV_PASSBF);
    eval 'sub SCTP_SORCV_ADJD () {101;}' unless defined(&SCTP_SORCV_ADJD);
    eval 'sub SCTP_UNKNOWN_MAX () {102;}' unless defined(&SCTP_UNKNOWN_MAX);
    eval 'sub SCTP_RANDY_STUFF () {103;}' unless defined(&SCTP_RANDY_STUFF);
    eval 'sub SCTP_RANDY_STUFF1 () {104;}' unless defined(&SCTP_RANDY_STUFF1);
    eval 'sub SCTP_STRMOUT_LOG_ASSIGN () {105;}' unless defined(&SCTP_STRMOUT_LOG_ASSIGN);
    eval 'sub SCTP_STRMOUT_LOG_SEND () {106;}' unless defined(&SCTP_STRMOUT_LOG_SEND);
    eval 'sub SCTP_FLIGHT_LOG_DOWN_CA () {107;}' unless defined(&SCTP_FLIGHT_LOG_DOWN_CA);
    eval 'sub SCTP_FLIGHT_LOG_UP () {108;}' unless defined(&SCTP_FLIGHT_LOG_UP);
    eval 'sub SCTP_FLIGHT_LOG_DOWN_GAP () {109;}' unless defined(&SCTP_FLIGHT_LOG_DOWN_GAP);
    eval 'sub SCTP_FLIGHT_LOG_DOWN_RSND () {110;}' unless defined(&SCTP_FLIGHT_LOG_DOWN_RSND);
    eval 'sub SCTP_FLIGHT_LOG_UP_RSND () {111;}' unless defined(&SCTP_FLIGHT_LOG_UP_RSND);
    eval 'sub SCTP_FLIGHT_LOG_DOWN_RSND_TO () {112;}' unless defined(&SCTP_FLIGHT_LOG_DOWN_RSND_TO);
    eval 'sub SCTP_FLIGHT_LOG_DOWN_WP () {113;}' unless defined(&SCTP_FLIGHT_LOG_DOWN_WP);
    eval 'sub SCTP_FLIGHT_LOG_UP_REVOKE () {114;}' unless defined(&SCTP_FLIGHT_LOG_UP_REVOKE);
    eval 'sub SCTP_FLIGHT_LOG_DOWN_PDRP () {115;}' unless defined(&SCTP_FLIGHT_LOG_DOWN_PDRP);
    eval 'sub SCTP_FLIGHT_LOG_DOWN_PMTU () {116;}' unless defined(&SCTP_FLIGHT_LOG_DOWN_PMTU);
    eval 'sub SCTP_SACK_LOG_NORMAL () {117;}' unless defined(&SCTP_SACK_LOG_NORMAL);
    eval 'sub SCTP_SACK_LOG_EXPRESS () {118;}' unless defined(&SCTP_SACK_LOG_EXPRESS);
    eval 'sub SCTP_MAP_TSN_ENTERS () {119;}' unless defined(&SCTP_MAP_TSN_ENTERS);
    eval 'sub SCTP_THRESHOLD_CLEAR () {120;}' unless defined(&SCTP_THRESHOLD_CLEAR);
    eval 'sub SCTP_THRESHOLD_INCR () {121;}' unless defined(&SCTP_THRESHOLD_INCR);
    eval 'sub SCTP_FLIGHT_LOG_DWN_WP_FWD () {122;}' unless defined(&SCTP_FLIGHT_LOG_DWN_WP_FWD);
    eval 'sub SCTP_FWD_TSN_CHECK () {123;}' unless defined(&SCTP_FWD_TSN_CHECK);
    eval 'sub SCTP_LOG_MAX_TYPES () {124;}' unless defined(&SCTP_LOG_MAX_TYPES);
    eval 'sub SCTP_LOG_EVENT_UNKNOWN () {0;}' unless defined(&SCTP_LOG_EVENT_UNKNOWN);
    eval 'sub SCTP_LOG_EVENT_CWND () {1;}' unless defined(&SCTP_LOG_EVENT_CWND);
    eval 'sub SCTP_LOG_EVENT_BLOCK () {2;}' unless defined(&SCTP_LOG_EVENT_BLOCK);
    eval 'sub SCTP_LOG_EVENT_STRM () {3;}' unless defined(&SCTP_LOG_EVENT_STRM);
    eval 'sub SCTP_LOG_EVENT_FR () {4;}' unless defined(&SCTP_LOG_EVENT_FR);
    eval 'sub SCTP_LOG_EVENT_MAP () {5;}' unless defined(&SCTP_LOG_EVENT_MAP);
    eval 'sub SCTP_LOG_EVENT_MAXBURST () {6;}' unless defined(&SCTP_LOG_EVENT_MAXBURST);
    eval 'sub SCTP_LOG_EVENT_RWND () {7;}' unless defined(&SCTP_LOG_EVENT_RWND);
    eval 'sub SCTP_LOG_EVENT_MBCNT () {8;}' unless defined(&SCTP_LOG_EVENT_MBCNT);
    eval 'sub SCTP_LOG_EVENT_SACK () {9;}' unless defined(&SCTP_LOG_EVENT_SACK);
    eval 'sub SCTP_LOG_LOCK_EVENT () {10;}' unless defined(&SCTP_LOG_LOCK_EVENT);
    eval 'sub SCTP_LOG_EVENT_RTT () {11;}' unless defined(&SCTP_LOG_EVENT_RTT);
    eval 'sub SCTP_LOG_EVENT_SB () {12;}' unless defined(&SCTP_LOG_EVENT_SB);
    eval 'sub SCTP_LOG_EVENT_NAGLE () {13;}' unless defined(&SCTP_LOG_EVENT_NAGLE);
    eval 'sub SCTP_LOG_EVENT_WAKE () {14;}' unless defined(&SCTP_LOG_EVENT_WAKE);
    eval 'sub SCTP_LOG_MISC_EVENT () {15;}' unless defined(&SCTP_LOG_MISC_EVENT);
    eval 'sub SCTP_LOG_EVENT_CLOSE () {16;}' unless defined(&SCTP_LOG_EVENT_CLOSE);
    eval 'sub SCTP_LOG_EVENT_MBUF () {17;}' unless defined(&SCTP_LOG_EVENT_MBUF);
    eval 'sub SCTP_LOG_CHUNK_PROC () {18;}' unless defined(&SCTP_LOG_CHUNK_PROC);
    eval 'sub SCTP_LOG_ERROR_RET () {19;}' unless defined(&SCTP_LOG_ERROR_RET);
    eval 'sub SCTP_LOG_MAX_EVENT () {20;}' unless defined(&SCTP_LOG_MAX_EVENT);
    eval 'sub SCTP_LOCK_UNKNOWN () {2;}' unless defined(&SCTP_LOCK_UNKNOWN);
    eval 'sub SCTP_MAX_NUM_OF_ASOC () {40000;}' unless defined(&SCTP_MAX_NUM_OF_ASOC);
    eval 'sub SCTP_SCALE_FOR_ADDR () {2;}' unless defined(&SCTP_SCALE_FOR_ADDR);
    eval 'sub SCTP_DEFAULT_MULTIPLE_ASCONFS () {0;}' unless defined(&SCTP_DEFAULT_MULTIPLE_ASCONFS);
    eval 'sub SCTP_RWND_HIWAT_SHIFT () {3;}' unless defined(&SCTP_RWND_HIWAT_SHIFT);
    eval 'sub SCTP_PARTIAL_DELIVERY_SHIFT () {1;}' unless defined(&SCTP_PARTIAL_DELIVERY_SHIFT);
    eval 'sub SCTP_HMAC () { &SCTP_AUTH_HMAC_ID_SHA1;}' unless defined(&SCTP_HMAC);
    eval 'sub SCTP_SIGNATURE_SIZE () { &SCTP_AUTH_DIGEST_LEN_SHA1;}' unless defined(&SCTP_SIGNATURE_SIZE);
    eval 'sub SCTP_SIGNATURE_ALOC_SIZE () { &SCTP_SIGNATURE_SIZE;}' unless defined(&SCTP_SIGNATURE_ALOC_SIZE);
    eval 'sub PROTO_SIGNATURE_A () {0x30000000;}' unless defined(&PROTO_SIGNATURE_A);
    eval 'sub SCTP_VERSION_NUMBER () {0x3;}' unless defined(&SCTP_VERSION_NUMBER);
    eval 'sub MAX_TSN () {0xffffffff;}' unless defined(&MAX_TSN);
    eval 'sub SCTP_ITERATOR_MAX_AT_ONCE () {20;}' unless defined(&SCTP_ITERATOR_MAX_AT_ONCE);
    eval 'sub SCTP_ITERATOR_TICKS () {1;}' unless defined(&SCTP_ITERATOR_TICKS);
    eval 'sub SCTP_IGNORE_CWND_ON_FR () {1;}' unless defined(&SCTP_IGNORE_CWND_ON_FR);
    eval 'sub SCTP_NO_FR_UNLESS_SEGMENT_SMALLER () {1;}' unless defined(&SCTP_NO_FR_UNLESS_SEGMENT_SMALLER);
    eval 'sub SCTP_DEF_MAX_BURST () {4;}' unless defined(&SCTP_DEF_MAX_BURST);
    eval 'sub SCTP_DEF_HBMAX_BURST () {4;}' unless defined(&SCTP_DEF_HBMAX_BURST);
    eval 'sub SCTP_DEF_FRMAX_BURST () {4;}' unless defined(&SCTP_DEF_FRMAX_BURST);
    eval 'sub SCTP_RTT_FROM_NON_DATA () {0;}' unless defined(&SCTP_RTT_FROM_NON_DATA);
    eval 'sub SCTP_RTT_FROM_DATA () {1;}' unless defined(&SCTP_RTT_FROM_DATA);
    eval 'sub PR_SCTP_UNORDERED_FLAG () {0x1;}' unless defined(&PR_SCTP_UNORDERED_FLAG);
    eval 'sub SCTP_FIRST_MBUF_RESV () {68;}' unless defined(&SCTP_FIRST_MBUF_RESV);
    eval 'sub SCTP_DATAGRAM_UNSENT () {0;}' unless defined(&SCTP_DATAGRAM_UNSENT);
    eval 'sub SCTP_DATAGRAM_SENT () {1;}' unless defined(&SCTP_DATAGRAM_SENT);
    eval 'sub SCTP_DATAGRAM_RESEND1 () {2;}' unless defined(&SCTP_DATAGRAM_RESEND1);
    eval 'sub SCTP_DATAGRAM_RESEND2 () {3;}' unless defined(&SCTP_DATAGRAM_RESEND2);
    eval 'sub SCTP_DATAGRAM_RESEND () {4;}' unless defined(&SCTP_DATAGRAM_RESEND);
    eval 'sub SCTP_DATAGRAM_ACKED () {10010;}' unless defined(&SCTP_DATAGRAM_ACKED);
    eval 'sub SCTP_DATAGRAM_MARKED () {20010;}' unless defined(&SCTP_DATAGRAM_MARKED);
    eval 'sub SCTP_FORWARD_TSN_SKIP () {30010;}' unless defined(&SCTP_FORWARD_TSN_SKIP);
    eval 'sub SCTP_DATAGRAM_NR_ACKED () {40010;}' unless defined(&SCTP_DATAGRAM_NR_ACKED);
    eval 'sub SCTP_OUTPUT_FROM_USR_SEND () {0;}' unless defined(&SCTP_OUTPUT_FROM_USR_SEND);
    eval 'sub SCTP_OUTPUT_FROM_T3 () {1;}' unless defined(&SCTP_OUTPUT_FROM_T3);
    eval 'sub SCTP_OUTPUT_FROM_INPUT_ERROR () {2;}' unless defined(&SCTP_OUTPUT_FROM_INPUT_ERROR);
    eval 'sub SCTP_OUTPUT_FROM_CONTROL_PROC () {3;}' unless defined(&SCTP_OUTPUT_FROM_CONTROL_PROC);
    eval 'sub SCTP_OUTPUT_FROM_SACK_TMR () {4;}' unless defined(&SCTP_OUTPUT_FROM_SACK_TMR);
    eval 'sub SCTP_OUTPUT_FROM_SHUT_TMR () {5;}' unless defined(&SCTP_OUTPUT_FROM_SHUT_TMR);
    eval 'sub SCTP_OUTPUT_FROM_HB_TMR () {6;}' unless defined(&SCTP_OUTPUT_FROM_HB_TMR);
    eval 'sub SCTP_OUTPUT_FROM_SHUT_ACK_TMR () {7;}' unless defined(&SCTP_OUTPUT_FROM_SHUT_ACK_TMR);
    eval 'sub SCTP_OUTPUT_FROM_ASCONF_TMR () {8;}' unless defined(&SCTP_OUTPUT_FROM_ASCONF_TMR);
    eval 'sub SCTP_OUTPUT_FROM_STRRST_TMR () {9;}' unless defined(&SCTP_OUTPUT_FROM_STRRST_TMR);
    eval 'sub SCTP_OUTPUT_FROM_AUTOCLOSE_TMR () {10;}' unless defined(&SCTP_OUTPUT_FROM_AUTOCLOSE_TMR);
    eval 'sub SCTP_OUTPUT_FROM_EARLY_FR_TMR () {11;}' unless defined(&SCTP_OUTPUT_FROM_EARLY_FR_TMR);
    eval 'sub SCTP_OUTPUT_FROM_STRRST_REQ () {12;}' unless defined(&SCTP_OUTPUT_FROM_STRRST_REQ);
    eval 'sub SCTP_OUTPUT_FROM_USR_RCVD () {13;}' unless defined(&SCTP_OUTPUT_FROM_USR_RCVD);
    eval 'sub SCTP_OUTPUT_FROM_COOKIE_ACK () {14;}' unless defined(&SCTP_OUTPUT_FROM_COOKIE_ACK);
    eval 'sub SCTP_OUTPUT_FROM_DRAIN () {15;}' unless defined(&SCTP_OUTPUT_FROM_DRAIN);
    eval 'sub SCTP_OUTPUT_FROM_CLOSING () {16;}' unless defined(&SCTP_OUTPUT_FROM_CLOSING);
    eval 'sub SCTP_OUTPUT_FROM_SOCKOPT () {17;}' unless defined(&SCTP_OUTPUT_FROM_SOCKOPT);
    eval 'sub SCTP_SIZE32 {
        my($x) = @_;
	    eval q((((($x) + 3) >> 2) << 2));
    }' unless defined(&SCTP_SIZE32);
    eval 'sub IS_SCTP_CONTROL {
        my($a) = @_;
	    eval q(((($a)-> &chunk_type !=  &SCTP_DATA)  && (($a)-> &chunk_type !=  &SCTP_IDATA)));
    }' unless defined(&IS_SCTP_CONTROL);
    eval 'sub IS_SCTP_DATA {
        my($a) = @_;
	    eval q(((($a)-> &chunk_type ==  &SCTP_DATA) || (($a)-> &chunk_type ==  &SCTP_IDATA)));
    }' unless defined(&IS_SCTP_DATA);
    eval 'sub SCTP_HEARTBEAT_INFO () {0x1;}' unless defined(&SCTP_HEARTBEAT_INFO);
    eval 'sub SCTP_IPV4_ADDRESS () {0x5;}' unless defined(&SCTP_IPV4_ADDRESS);
    eval 'sub SCTP_IPV6_ADDRESS () {0x6;}' unless defined(&SCTP_IPV6_ADDRESS);
    eval 'sub SCTP_STATE_COOKIE () {0x7;}' unless defined(&SCTP_STATE_COOKIE);
    eval 'sub SCTP_UNRECOG_PARAM () {0x8;}' unless defined(&SCTP_UNRECOG_PARAM);
    eval 'sub SCTP_COOKIE_PRESERVE () {0x9;}' unless defined(&SCTP_COOKIE_PRESERVE);
    eval 'sub SCTP_HOSTNAME_ADDRESS () {0xb;}' unless defined(&SCTP_HOSTNAME_ADDRESS);
    eval 'sub SCTP_SUPPORTED_ADDRTYPE () {0xc;}' unless defined(&SCTP_SUPPORTED_ADDRTYPE);
    eval 'sub SCTP_STR_RESET_OUT_REQUEST () {0xd;}' unless defined(&SCTP_STR_RESET_OUT_REQUEST);
    eval 'sub SCTP_STR_RESET_IN_REQUEST () {0xe;}' unless defined(&SCTP_STR_RESET_IN_REQUEST);
    eval 'sub SCTP_STR_RESET_TSN_REQUEST () {0xf;}' unless defined(&SCTP_STR_RESET_TSN_REQUEST);
    eval 'sub SCTP_STR_RESET_RESPONSE () {0x10;}' unless defined(&SCTP_STR_RESET_RESPONSE);
    eval 'sub SCTP_STR_RESET_ADD_OUT_STREAMS () {0x11;}' unless defined(&SCTP_STR_RESET_ADD_OUT_STREAMS);
    eval 'sub SCTP_STR_RESET_ADD_IN_STREAMS () {0x12;}' unless defined(&SCTP_STR_RESET_ADD_IN_STREAMS);
    eval 'sub SCTP_MAX_RESET_PARAMS () {2;}' unless defined(&SCTP_MAX_RESET_PARAMS);
    eval 'sub SCTP_STREAM_RESET_TSN_DELTA () {0x1000;}' unless defined(&SCTP_STREAM_RESET_TSN_DELTA);
    eval 'sub SCTP_ECN_CAPABLE () {0x8000;}' unless defined(&SCTP_ECN_CAPABLE);
    eval 'sub SCTP_RANDOM () {0x8002;}' unless defined(&SCTP_RANDOM);
    eval 'sub SCTP_CHUNK_LIST () {0x8003;}' unless defined(&SCTP_CHUNK_LIST);
    eval 'sub SCTP_HMAC_LIST () {0x8004;}' unless defined(&SCTP_HMAC_LIST);
    eval 'sub SCTP_PAD () {0x8005;}' unless defined(&SCTP_PAD);
    eval 'sub SCTP_SUPPORTED_CHUNK_EXT () {0x8008;}' unless defined(&SCTP_SUPPORTED_CHUNK_EXT);
    eval 'sub SCTP_PRSCTP_SUPPORTED () {0xc000;}' unless defined(&SCTP_PRSCTP_SUPPORTED);
    eval 'sub SCTP_ADD_IP_ADDRESS () {0xc001;}' unless defined(&SCTP_ADD_IP_ADDRESS);
    eval 'sub SCTP_DEL_IP_ADDRESS () {0xc002;}' unless defined(&SCTP_DEL_IP_ADDRESS);
    eval 'sub SCTP_ERROR_CAUSE_IND () {0xc003;}' unless defined(&SCTP_ERROR_CAUSE_IND);
    eval 'sub SCTP_SET_PRIM_ADDR () {0xc004;}' unless defined(&SCTP_SET_PRIM_ADDR);
    eval 'sub SCTP_SUCCESS_REPORT () {0xc005;}' unless defined(&SCTP_SUCCESS_REPORT);
    eval 'sub SCTP_ULP_ADAPTATION () {0xc006;}' unless defined(&SCTP_ULP_ADAPTATION);
    eval 'sub SCTP_HAS_NAT_SUPPORT () {0xc007;}' unless defined(&SCTP_HAS_NAT_SUPPORT);
    eval 'sub SCTP_NAT_VTAGS () {0xc008;}' unless defined(&SCTP_NAT_VTAGS);
    eval 'sub SCTP_ECT0_BIT () {0x2;}' unless defined(&SCTP_ECT0_BIT);
    eval 'sub SCTP_ECT1_BIT () {0x1;}' unless defined(&SCTP_ECT1_BIT);
    eval 'sub SCTP_CE_BITS () {0x3;}' unless defined(&SCTP_CE_BITS);
    eval 'sub SCTP_FLEXIBLE_ADDRESS () {0x20;}' unless defined(&SCTP_FLEXIBLE_ADDRESS);
    eval 'sub SCTP_NO_HEARTBEAT () {0x40;}' unless defined(&SCTP_NO_HEARTBEAT);
    eval 'sub SCTP_STICKY_OPTIONS_MASK () {0xc;}' unless defined(&SCTP_STICKY_OPTIONS_MASK);
    eval 'sub SCTP_STATE_EMPTY () {0x;}' unless defined(&SCTP_STATE_EMPTY);
    eval 'sub SCTP_STATE_INUSE () {0x1;}' unless defined(&SCTP_STATE_INUSE);
    eval 'sub SCTP_STATE_COOKIE_WAIT () {0x2;}' unless defined(&SCTP_STATE_COOKIE_WAIT);
    eval 'sub SCTP_STATE_COOKIE_ECHOED () {0x4;}' unless defined(&SCTP_STATE_COOKIE_ECHOED);
    eval 'sub SCTP_STATE_OPEN () {0x8;}' unless defined(&SCTP_STATE_OPEN);
    eval 'sub SCTP_STATE_SHUTDOWN_SENT () {0x10;}' unless defined(&SCTP_STATE_SHUTDOWN_SENT);
    eval 'sub SCTP_STATE_SHUTDOWN_RECEIVED () {0x20;}' unless defined(&SCTP_STATE_SHUTDOWN_RECEIVED);
    eval 'sub SCTP_STATE_SHUTDOWN_ACK_SENT () {0x40;}' unless defined(&SCTP_STATE_SHUTDOWN_ACK_SENT);
    eval 'sub SCTP_STATE_SHUTDOWN_PENDING () {0x80;}' unless defined(&SCTP_STATE_SHUTDOWN_PENDING);
    eval 'sub SCTP_STATE_CLOSED_SOCKET () {0x100;}' unless defined(&SCTP_STATE_CLOSED_SOCKET);
    eval 'sub SCTP_STATE_ABOUT_TO_BE_FREED () {0x200;}' unless defined(&SCTP_STATE_ABOUT_TO_BE_FREED);
    eval 'sub SCTP_STATE_PARTIAL_MSG_LEFT () {0x400;}' unless defined(&SCTP_STATE_PARTIAL_MSG_LEFT);
    eval 'sub SCTP_STATE_WAS_ABORTED () {0x800;}' unless defined(&SCTP_STATE_WAS_ABORTED);
    eval 'sub SCTP_STATE_IN_ACCEPT_QUEUE () {0x1000;}' unless defined(&SCTP_STATE_IN_ACCEPT_QUEUE);
    eval 'sub SCTP_STATE_MASK () {0x7f;}' unless defined(&SCTP_STATE_MASK);
    eval 'sub SCTP_GET_STATE {
        my($asoc) = @_;
	    eval q((($asoc)-> &state &  &SCTP_STATE_MASK));
    }' unless defined(&SCTP_GET_STATE);
    eval 'sub SCTP_SET_STATE {
        my($asoc, $newstate) = @_;
	    eval q((($asoc)-> &state = (($asoc)-> &state & ~ &SCTP_STATE_MASK) | $newstate));
    }' unless defined(&SCTP_SET_STATE);
    eval 'sub SCTP_CLEAR_SUBSTATE {
        my($asoc, $substate) = @_;
	    eval q((($asoc)-> &state &= ~$substate));
    }' unless defined(&SCTP_CLEAR_SUBSTATE);
    eval 'sub SCTP_ADD_SUBSTATE {
        my($asoc, $substate) = @_;
	    eval q((($asoc)-> &state |= $substate));
    }' unless defined(&SCTP_ADD_SUBSTATE);
    eval 'sub SCTP_ADDR_REACHABLE () {0x1;}' unless defined(&SCTP_ADDR_REACHABLE);
    eval 'sub SCTP_ADDR_NO_PMTUD () {0x2;}' unless defined(&SCTP_ADDR_NO_PMTUD);
    eval 'sub SCTP_ADDR_NOHB () {0x4;}' unless defined(&SCTP_ADDR_NOHB);
    eval 'sub SCTP_ADDR_BEING_DELETED () {0x8;}' unless defined(&SCTP_ADDR_BEING_DELETED);
    eval 'sub SCTP_ADDR_NOT_IN_ASSOC () {0x10;}' unless defined(&SCTP_ADDR_NOT_IN_ASSOC);
    eval 'sub SCTP_ADDR_OUT_OF_SCOPE () {0x80;}' unless defined(&SCTP_ADDR_OUT_OF_SCOPE);
    eval 'sub SCTP_ADDR_UNCONFIRMED () {0x200;}' unless defined(&SCTP_ADDR_UNCONFIRMED);
    eval 'sub SCTP_ADDR_REQ_PRIMARY () {0x400;}' unless defined(&SCTP_ADDR_REQ_PRIMARY);
    eval 'sub SCTP_ADDR_PF () {0x800;}' unless defined(&SCTP_ADDR_PF);
    eval 'sub SCTP_BOUND_V6 () {0x1;}' unless defined(&SCTP_BOUND_V6);
    eval 'sub SCTP_BOUND_V4 () {0x2;}' unless defined(&SCTP_BOUND_V4);
    eval 'sub SCTP_DEFAULT_MBUFS_IN_CHAIN () {5;}' unless defined(&SCTP_DEFAULT_MBUFS_IN_CHAIN);
    eval 'sub SCTP_DEFAULT_COOKIE_LIFE () {60000;}' unless defined(&SCTP_DEFAULT_COOKIE_LIFE);
    eval 'sub SCTP_MAPPING_ARRAY () {512;}' unless defined(&SCTP_MAPPING_ARRAY);
    eval 'sub SCTP_INITIAL_MAPPING_ARRAY () {16;}' unless defined(&SCTP_INITIAL_MAPPING_ARRAY);
    eval 'sub SCTP_MAPPING_ARRAY_INCR () {32;}' unless defined(&SCTP_MAPPING_ARRAY_INCR);
    eval 'sub SCTP_TIMER_INIT () {0;}' unless defined(&SCTP_TIMER_INIT);
    eval 'sub SCTP_TIMER_RECV () {1;}' unless defined(&SCTP_TIMER_RECV);
    eval 'sub SCTP_TIMER_SEND () {2;}' unless defined(&SCTP_TIMER_SEND);
    eval 'sub SCTP_TIMER_HEARTBEAT () {3;}' unless defined(&SCTP_TIMER_HEARTBEAT);
    eval 'sub SCTP_TIMER_PMTU () {4;}' unless defined(&SCTP_TIMER_PMTU);
    eval 'sub SCTP_TIMER_MAXSHUTDOWN () {5;}' unless defined(&SCTP_TIMER_MAXSHUTDOWN);
    eval 'sub SCTP_TIMER_SIGNATURE () {6;}' unless defined(&SCTP_TIMER_SIGNATURE);
    eval 'sub SCTP_NUM_TMRS () {7;}' unless defined(&SCTP_NUM_TMRS);
    eval 'sub SCTP_TIMER_TYPE_NONE () {0;}' unless defined(&SCTP_TIMER_TYPE_NONE);
    eval 'sub SCTP_TIMER_TYPE_SEND () {1;}' unless defined(&SCTP_TIMER_TYPE_SEND);
    eval 'sub SCTP_TIMER_TYPE_INIT () {2;}' unless defined(&SCTP_TIMER_TYPE_INIT);
    eval 'sub SCTP_TIMER_TYPE_RECV () {3;}' unless defined(&SCTP_TIMER_TYPE_RECV);
    eval 'sub SCTP_TIMER_TYPE_SHUTDOWN () {4;}' unless defined(&SCTP_TIMER_TYPE_SHUTDOWN);
    eval 'sub SCTP_TIMER_TYPE_HEARTBEAT () {5;}' unless defined(&SCTP_TIMER_TYPE_HEARTBEAT);
    eval 'sub SCTP_TIMER_TYPE_COOKIE () {6;}' unless defined(&SCTP_TIMER_TYPE_COOKIE);
    eval 'sub SCTP_TIMER_TYPE_NEWCOOKIE () {7;}' unless defined(&SCTP_TIMER_TYPE_NEWCOOKIE);
    eval 'sub SCTP_TIMER_TYPE_PATHMTURAISE () {8;}' unless defined(&SCTP_TIMER_TYPE_PATHMTURAISE);
    eval 'sub SCTP_TIMER_TYPE_SHUTDOWNACK () {9;}' unless defined(&SCTP_TIMER_TYPE_SHUTDOWNACK);
    eval 'sub SCTP_TIMER_TYPE_ASCONF () {10;}' unless defined(&SCTP_TIMER_TYPE_ASCONF);
    eval 'sub SCTP_TIMER_TYPE_SHUTDOWNGUARD () {11;}' unless defined(&SCTP_TIMER_TYPE_SHUTDOWNGUARD);
    eval 'sub SCTP_TIMER_TYPE_AUTOCLOSE () {12;}' unless defined(&SCTP_TIMER_TYPE_AUTOCLOSE);
    eval 'sub SCTP_TIMER_TYPE_EVENTWAKE () {13;}' unless defined(&SCTP_TIMER_TYPE_EVENTWAKE);
    eval 'sub SCTP_TIMER_TYPE_STRRESET () {14;}' unless defined(&SCTP_TIMER_TYPE_STRRESET);
    eval 'sub SCTP_TIMER_TYPE_INPKILL () {15;}' unless defined(&SCTP_TIMER_TYPE_INPKILL);
    eval 'sub SCTP_TIMER_TYPE_ASOCKILL () {16;}' unless defined(&SCTP_TIMER_TYPE_ASOCKILL);
    eval 'sub SCTP_TIMER_TYPE_ADDR_WQ () {17;}' unless defined(&SCTP_TIMER_TYPE_ADDR_WQ);
    eval 'sub SCTP_TIMER_TYPE_PRIM_DELETED () {18;}' unless defined(&SCTP_TIMER_TYPE_PRIM_DELETED);
    eval 'sub SCTP_TIMER_TYPE_LAST () {19;}' unless defined(&SCTP_TIMER_TYPE_LAST);
    eval 'sub SCTP_IS_TIMER_TYPE_VALID {
        my($t) = @_;
	    eval q(((($t) >  &SCTP_TIMER_TYPE_NONE)  && (($t) <  &SCTP_TIMER_TYPE_LAST)));
    }' unless defined(&SCTP_IS_TIMER_TYPE_VALID);
    eval 'sub SCTP_MAX_DUP_TSNS () {20;}' unless defined(&SCTP_MAX_DUP_TSNS);
    eval 'sub SCTP_RETRY_DROPPED_THRESH () {4;}' unless defined(&SCTP_RETRY_DROPPED_THRESH);
    eval 'sub SCTP_ASOC_MAX_CHUNKS_ON_QUEUE () {512;}' unless defined(&SCTP_ASOC_MAX_CHUNKS_ON_QUEUE);
    eval 'sub MSEC_TO_TICKS {
        my($x) = @_;
	    eval q((( &hz == 1000) ? $x : (((($x) *  &hz) + 999) / 1000)));
    }' unless defined(&MSEC_TO_TICKS);
    eval 'sub TICKS_TO_MSEC {
        my($x) = @_;
	    eval q((( &hz == 1000) ? $x : (((($x) * 1000) + ( &hz - 1)) /  &hz)));
    }' unless defined(&TICKS_TO_MSEC);
    eval 'sub SEC_TO_TICKS {
        my($x) = @_;
	    eval q((($x) *  &hz));
    }' unless defined(&SEC_TO_TICKS);
    eval 'sub TICKS_TO_SEC {
        my($x) = @_;
	    eval q(((($x) + ( &hz - 1)) /  &hz));
    }' unless defined(&TICKS_TO_SEC);
    eval 'sub SCTP_MINFR_MSEC_TIMER () {250;}' unless defined(&SCTP_MINFR_MSEC_TIMER);
    eval 'sub SCTP_MINFR_MSEC_FLOOR () {20;}' unless defined(&SCTP_MINFR_MSEC_FLOOR);
    eval 'sub SCTP_INIT_SEC () {1;}' unless defined(&SCTP_INIT_SEC);
    eval 'sub SCTP_SEND_SEC () {1;}' unless defined(&SCTP_SEND_SEC);
    eval 'sub SCTP_RECV_MSEC () {200;}' unless defined(&SCTP_RECV_MSEC);
    eval 'sub SCTP_HB_DEFAULT_MSEC () {30000;}' unless defined(&SCTP_HB_DEFAULT_MSEC);
    eval 'sub SCTP_DEFAULT_SECRET_LIFE_SEC () {3600;}' unless defined(&SCTP_DEFAULT_SECRET_LIFE_SEC);
    eval 'sub SCTP_RTO_UPPER_BOUND () {(60000);}' unless defined(&SCTP_RTO_UPPER_BOUND);
    eval 'sub SCTP_RTO_LOWER_BOUND () {(1000);}' unless defined(&SCTP_RTO_LOWER_BOUND);
    eval 'sub SCTP_RTO_INITIAL () {(3000);}' unless defined(&SCTP_RTO_INITIAL);
    eval 'sub SCTP_INP_KILL_TIMEOUT () {20;}' unless defined(&SCTP_INP_KILL_TIMEOUT);
    eval 'sub SCTP_ASOC_KILL_TIMEOUT () {10;}' unless defined(&SCTP_ASOC_KILL_TIMEOUT);
    eval 'sub SCTP_DEF_MAX_INIT () {8;}' unless defined(&SCTP_DEF_MAX_INIT);
    eval 'sub SCTP_DEF_MAX_SEND () {10;}' unless defined(&SCTP_DEF_MAX_SEND);
    eval 'sub SCTP_DEF_MAX_PATH_RTX () {5;}' unless defined(&SCTP_DEF_MAX_PATH_RTX);
    eval 'sub SCTP_DEF_PATH_PF_THRESHOLD () { &SCTP_DEF_MAX_PATH_RTX;}' unless defined(&SCTP_DEF_PATH_PF_THRESHOLD);
    eval 'sub SCTP_DEF_PMTU_RAISE_SEC () {600;}' unless defined(&SCTP_DEF_PMTU_RAISE_SEC);
    eval 'sub SCTP_OSTREAM_INITIAL () {10;}' unless defined(&SCTP_OSTREAM_INITIAL);
    eval 'sub SCTP_ISTREAM_INITIAL () {2048;}' unless defined(&SCTP_ISTREAM_INITIAL);
    eval 'sub SCTP_MINIMAL_RWND () {(4096);}' unless defined(&SCTP_MINIMAL_RWND);
    eval 'sub SCTP_ADDRMAX () {16;}' unless defined(&SCTP_ADDRMAX);
    eval 'sub SCTP_DEBUG_TIMER1 () {0x1;}' unless defined(&SCTP_DEBUG_TIMER1);
    eval 'sub SCTP_DEBUG_TIMER2 () {0x2;}' unless defined(&SCTP_DEBUG_TIMER2);
    eval 'sub SCTP_DEBUG_TIMER3 () {0x4;}' unless defined(&SCTP_DEBUG_TIMER3);
    eval 'sub SCTP_DEBUG_TIMER4 () {0x8;}' unless defined(&SCTP_DEBUG_TIMER4);
    eval 'sub SCTP_DEBUG_OUTPUT1 () {0x10;}' unless defined(&SCTP_DEBUG_OUTPUT1);
    eval 'sub SCTP_DEBUG_OUTPUT2 () {0x20;}' unless defined(&SCTP_DEBUG_OUTPUT2);
    eval 'sub SCTP_DEBUG_OUTPUT3 () {0x40;}' unless defined(&SCTP_DEBUG_OUTPUT3);
    eval 'sub SCTP_DEBUG_OUTPUT4 () {0x80;}' unless defined(&SCTP_DEBUG_OUTPUT4);
    eval 'sub SCTP_DEBUG_UTIL1 () {0x100;}' unless defined(&SCTP_DEBUG_UTIL1);
    eval 'sub SCTP_DEBUG_UTIL2 () {0x200;}' unless defined(&SCTP_DEBUG_UTIL2);
    eval 'sub SCTP_DEBUG_AUTH1 () {0x400;}' unless defined(&SCTP_DEBUG_AUTH1);
    eval 'sub SCTP_DEBUG_AUTH2 () {0x800;}' unless defined(&SCTP_DEBUG_AUTH2);
    eval 'sub SCTP_DEBUG_INPUT1 () {0x1000;}' unless defined(&SCTP_DEBUG_INPUT1);
    eval 'sub SCTP_DEBUG_INPUT2 () {0x2000;}' unless defined(&SCTP_DEBUG_INPUT2);
    eval 'sub SCTP_DEBUG_INPUT3 () {0x4000;}' unless defined(&SCTP_DEBUG_INPUT3);
    eval 'sub SCTP_DEBUG_INPUT4 () {0x8000;}' unless defined(&SCTP_DEBUG_INPUT4);
    eval 'sub SCTP_DEBUG_ASCONF1 () {0x10000;}' unless defined(&SCTP_DEBUG_ASCONF1);
    eval 'sub SCTP_DEBUG_ASCONF2 () {0x20000;}' unless defined(&SCTP_DEBUG_ASCONF2);
    eval 'sub SCTP_DEBUG_OUTPUT5 () {0x40000;}' unless defined(&SCTP_DEBUG_OUTPUT5);
    eval 'sub SCTP_DEBUG_XXX () {0x80000;}' unless defined(&SCTP_DEBUG_XXX);
    eval 'sub SCTP_DEBUG_PCB1 () {0x100000;}' unless defined(&SCTP_DEBUG_PCB1);
    eval 'sub SCTP_DEBUG_PCB2 () {0x200000;}' unless defined(&SCTP_DEBUG_PCB2);
    eval 'sub SCTP_DEBUG_PCB3 () {0x400000;}' unless defined(&SCTP_DEBUG_PCB3);
    eval 'sub SCTP_DEBUG_PCB4 () {0x800000;}' unless defined(&SCTP_DEBUG_PCB4);
    eval 'sub SCTP_DEBUG_INDATA1 () {0x1000000;}' unless defined(&SCTP_DEBUG_INDATA1);
    eval 'sub SCTP_DEBUG_INDATA2 () {0x2000000;}' unless defined(&SCTP_DEBUG_INDATA2);
    eval 'sub SCTP_DEBUG_INDATA3 () {0x4000000;}' unless defined(&SCTP_DEBUG_INDATA3);
    eval 'sub SCTP_DEBUG_CRCOFFLOAD () {0x8000000;}' unless defined(&SCTP_DEBUG_CRCOFFLOAD);
    eval 'sub SCTP_DEBUG_USRREQ1 () {0x10000000;}' unless defined(&SCTP_DEBUG_USRREQ1);
    eval 'sub SCTP_DEBUG_USRREQ2 () {0x20000000;}' unless defined(&SCTP_DEBUG_USRREQ2);
    eval 'sub SCTP_DEBUG_PEEL1 () {0x40000000;}' unless defined(&SCTP_DEBUG_PEEL1);
    eval 'sub SCTP_DEBUG_XXXXX () {0x80000000;}' unless defined(&SCTP_DEBUG_XXXXX);
    eval 'sub SCTP_DEBUG_ALL () {0x7ff3ffff;}' unless defined(&SCTP_DEBUG_ALL);
    eval 'sub SCTP_DEBUG_NOISY () {0x40000;}' unless defined(&SCTP_DEBUG_NOISY);
    eval 'sub SCTP_SWS_SENDER_DEF () {1420;}' unless defined(&SCTP_SWS_SENDER_DEF);
    eval 'sub SCTP_SWS_RECEIVER_DEF () {3000;}' unless defined(&SCTP_SWS_RECEIVER_DEF);
    eval 'sub SCTP_INITIAL_CWND () {4380;}' unless defined(&SCTP_INITIAL_CWND);
    eval 'sub SCTP_DEFAULT_MTU () {1500;}' unless defined(&SCTP_DEFAULT_MTU);
    eval 'sub SCTP_MIN_RWND () {1500;}' unless defined(&SCTP_MIN_RWND);
    eval 'sub SCTP_DEFAULT_MAXSEGMENT () {65535;}' unless defined(&SCTP_DEFAULT_MAXSEGMENT);
    eval 'sub SCTP_CHUNK_BUFFER_SIZE () {512;}' unless defined(&SCTP_CHUNK_BUFFER_SIZE);
    eval 'sub SCTP_PARAM_BUFFER_SIZE () {512;}' unless defined(&SCTP_PARAM_BUFFER_SIZE);
    eval 'sub SCTP_SMALL_CHUNK_STORE () {260;}' unless defined(&SCTP_SMALL_CHUNK_STORE);
    eval 'sub SCTP_HOW_MANY_SECRETS () {2;}' unless defined(&SCTP_HOW_MANY_SECRETS);
    eval 'sub SCTP_NUMBER_OF_SECRETS () {8;}' unless defined(&SCTP_NUMBER_OF_SECRETS);
    eval 'sub SCTP_SECRET_SIZE () {32;}' unless defined(&SCTP_SECRET_SIZE);
    eval 'sub SCTP_NOTIFY_ASSOC_UP () {1;}' unless defined(&SCTP_NOTIFY_ASSOC_UP);
    eval 'sub SCTP_NOTIFY_ASSOC_DOWN () {2;}' unless defined(&SCTP_NOTIFY_ASSOC_DOWN);
    eval 'sub SCTP_NOTIFY_INTERFACE_DOWN () {3;}' unless defined(&SCTP_NOTIFY_INTERFACE_DOWN);
    eval 'sub SCTP_NOTIFY_INTERFACE_UP () {4;}' unless defined(&SCTP_NOTIFY_INTERFACE_UP);
    eval 'sub SCTP_NOTIFY_SENT_DG_FAIL () {5;}' unless defined(&SCTP_NOTIFY_SENT_DG_FAIL);
    eval 'sub SCTP_NOTIFY_UNSENT_DG_FAIL () {6;}' unless defined(&SCTP_NOTIFY_UNSENT_DG_FAIL);
    eval 'sub SCTP_NOTIFY_SPECIAL_SP_FAIL () {7;}' unless defined(&SCTP_NOTIFY_SPECIAL_SP_FAIL);
    eval 'sub SCTP_NOTIFY_ASSOC_LOC_ABORTED () {8;}' unless defined(&SCTP_NOTIFY_ASSOC_LOC_ABORTED);
    eval 'sub SCTP_NOTIFY_ASSOC_REM_ABORTED () {9;}' unless defined(&SCTP_NOTIFY_ASSOC_REM_ABORTED);
    eval 'sub SCTP_NOTIFY_ASSOC_RESTART () {10;}' unless defined(&SCTP_NOTIFY_ASSOC_RESTART);
    eval 'sub SCTP_NOTIFY_PEER_SHUTDOWN () {11;}' unless defined(&SCTP_NOTIFY_PEER_SHUTDOWN);
    eval 'sub SCTP_NOTIFY_ASCONF_ADD_IP () {12;}' unless defined(&SCTP_NOTIFY_ASCONF_ADD_IP);
    eval 'sub SCTP_NOTIFY_ASCONF_DELETE_IP () {13;}' unless defined(&SCTP_NOTIFY_ASCONF_DELETE_IP);
    eval 'sub SCTP_NOTIFY_ASCONF_SET_PRIMARY () {14;}' unless defined(&SCTP_NOTIFY_ASCONF_SET_PRIMARY);
    eval 'sub SCTP_NOTIFY_PARTIAL_DELVIERY_INDICATION () {15;}' unless defined(&SCTP_NOTIFY_PARTIAL_DELVIERY_INDICATION);
    eval 'sub SCTP_NOTIFY_INTERFACE_CONFIRMED () {16;}' unless defined(&SCTP_NOTIFY_INTERFACE_CONFIRMED);
    eval 'sub SCTP_NOTIFY_STR_RESET_RECV () {17;}' unless defined(&SCTP_NOTIFY_STR_RESET_RECV);
    eval 'sub SCTP_NOTIFY_STR_RESET_SEND () {18;}' unless defined(&SCTP_NOTIFY_STR_RESET_SEND);
    eval 'sub SCTP_NOTIFY_STR_RESET_FAILED_OUT () {19;}' unless defined(&SCTP_NOTIFY_STR_RESET_FAILED_OUT);
    eval 'sub SCTP_NOTIFY_STR_RESET_FAILED_IN () {20;}' unless defined(&SCTP_NOTIFY_STR_RESET_FAILED_IN);
    eval 'sub SCTP_NOTIFY_STR_RESET_DENIED_OUT () {21;}' unless defined(&SCTP_NOTIFY_STR_RESET_DENIED_OUT);
    eval 'sub SCTP_NOTIFY_STR_RESET_DENIED_IN () {22;}' unless defined(&SCTP_NOTIFY_STR_RESET_DENIED_IN);
    eval 'sub SCTP_NOTIFY_AUTH_NEW_KEY () {23;}' unless defined(&SCTP_NOTIFY_AUTH_NEW_KEY);
    eval 'sub SCTP_NOTIFY_AUTH_FREE_KEY () {24;}' unless defined(&SCTP_NOTIFY_AUTH_FREE_KEY);
    eval 'sub SCTP_NOTIFY_NO_PEER_AUTH () {25;}' unless defined(&SCTP_NOTIFY_NO_PEER_AUTH);
    eval 'sub SCTP_NOTIFY_SENDER_DRY () {26;}' unless defined(&SCTP_NOTIFY_SENDER_DRY);
    eval 'sub SCTP_NOTIFY_REMOTE_ERROR () {27;}' unless defined(&SCTP_NOTIFY_REMOTE_ERROR);
    eval 'sub SCTP_DEFAULT_SPLIT_POINT_MIN () {2904;}' unless defined(&SCTP_DEFAULT_SPLIT_POINT_MIN);
    eval 'sub SCTP_DIAG_INFO_LEN () {128;}' unless defined(&SCTP_DIAG_INFO_LEN);
    eval 'sub SCTP_FROM_SCTP_INPUT () {0x10000000;}' unless defined(&SCTP_FROM_SCTP_INPUT);
    eval 'sub SCTP_FROM_SCTP_PCB () {0x20000000;}' unless defined(&SCTP_FROM_SCTP_PCB);
    eval 'sub SCTP_FROM_SCTP_INDATA () {0x30000000;}' unless defined(&SCTP_FROM_SCTP_INDATA);
    eval 'sub SCTP_FROM_SCTP_TIMER () {0x40000000;}' unless defined(&SCTP_FROM_SCTP_TIMER);
    eval 'sub SCTP_FROM_SCTP_USRREQ () {0x50000000;}' unless defined(&SCTP_FROM_SCTP_USRREQ);
    eval 'sub SCTP_FROM_SCTPUTIL () {0x60000000;}' unless defined(&SCTP_FROM_SCTPUTIL);
    eval 'sub SCTP_FROM_SCTP6_USRREQ () {0x70000000;}' unless defined(&SCTP_FROM_SCTP6_USRREQ);
    eval 'sub SCTP_FROM_SCTP_ASCONF () {0x80000000;}' unless defined(&SCTP_FROM_SCTP_ASCONF);
    eval 'sub SCTP_FROM_SCTP_OUTPUT () {0x90000000;}' unless defined(&SCTP_FROM_SCTP_OUTPUT);
    eval 'sub SCTP_FROM_SCTP_PEELOFF () {0xa0000000;}' unless defined(&SCTP_FROM_SCTP_PEELOFF);
    eval 'sub SCTP_FROM_SCTP_PANDA () {0xb0000000;}' unless defined(&SCTP_FROM_SCTP_PANDA);
    eval 'sub SCTP_FROM_SCTP_SYSCTL () {0xc0000000;}' unless defined(&SCTP_FROM_SCTP_SYSCTL);
    eval 'sub SCTP_FROM_SCTP_CC_FUNCTIONS () {0xd0000000;}' unless defined(&SCTP_FROM_SCTP_CC_FUNCTIONS);
    eval 'sub SCTP_LOC_1 () {0x1;}' unless defined(&SCTP_LOC_1);
    eval 'sub SCTP_LOC_2 () {0x2;}' unless defined(&SCTP_LOC_2);
    eval 'sub SCTP_LOC_3 () {0x3;}' unless defined(&SCTP_LOC_3);
    eval 'sub SCTP_LOC_4 () {0x4;}' unless defined(&SCTP_LOC_4);
    eval 'sub SCTP_LOC_5 () {0x5;}' unless defined(&SCTP_LOC_5);
    eval 'sub SCTP_LOC_6 () {0x6;}' unless defined(&SCTP_LOC_6);
    eval 'sub SCTP_LOC_7 () {0x7;}' unless defined(&SCTP_LOC_7);
    eval 'sub SCTP_LOC_8 () {0x8;}' unless defined(&SCTP_LOC_8);
    eval 'sub SCTP_LOC_9 () {0x9;}' unless defined(&SCTP_LOC_9);
    eval 'sub SCTP_LOC_10 () {0xa;}' unless defined(&SCTP_LOC_10);
    eval 'sub SCTP_LOC_11 () {0xb;}' unless defined(&SCTP_LOC_11);
    eval 'sub SCTP_LOC_12 () {0xc;}' unless defined(&SCTP_LOC_12);
    eval 'sub SCTP_LOC_13 () {0xd;}' unless defined(&SCTP_LOC_13);
    eval 'sub SCTP_LOC_14 () {0xe;}' unless defined(&SCTP_LOC_14);
    eval 'sub SCTP_LOC_15 () {0xf;}' unless defined(&SCTP_LOC_15);
    eval 'sub SCTP_LOC_16 () {0x10;}' unless defined(&SCTP_LOC_16);
    eval 'sub SCTP_LOC_17 () {0x11;}' unless defined(&SCTP_LOC_17);
    eval 'sub SCTP_LOC_18 () {0x12;}' unless defined(&SCTP_LOC_18);
    eval 'sub SCTP_LOC_19 () {0x13;}' unless defined(&SCTP_LOC_19);
    eval 'sub SCTP_LOC_20 () {0x14;}' unless defined(&SCTP_LOC_20);
    eval 'sub SCTP_LOC_21 () {0x15;}' unless defined(&SCTP_LOC_21);
    eval 'sub SCTP_LOC_22 () {0x16;}' unless defined(&SCTP_LOC_22);
    eval 'sub SCTP_LOC_23 () {0x17;}' unless defined(&SCTP_LOC_23);
    eval 'sub SCTP_LOC_24 () {0x18;}' unless defined(&SCTP_LOC_24);
    eval 'sub SCTP_LOC_25 () {0x19;}' unless defined(&SCTP_LOC_25);
    eval 'sub SCTP_LOC_26 () {0x1a;}' unless defined(&SCTP_LOC_26);
    eval 'sub SCTP_LOC_27 () {0x1b;}' unless defined(&SCTP_LOC_27);
    eval 'sub SCTP_LOC_28 () {0x1c;}' unless defined(&SCTP_LOC_28);
    eval 'sub SCTP_LOC_29 () {0x1d;}' unless defined(&SCTP_LOC_29);
    eval 'sub SCTP_LOC_30 () {0x1e;}' unless defined(&SCTP_LOC_30);
    eval 'sub SCTP_LOC_31 () {0x1f;}' unless defined(&SCTP_LOC_31);
    eval 'sub SCTP_LOC_32 () {0x20;}' unless defined(&SCTP_LOC_32);
    eval 'sub SCTP_LOC_33 () {0x21;}' unless defined(&SCTP_LOC_33);
    eval 'sub SCTP_LOC_34 () {0x22;}' unless defined(&SCTP_LOC_34);
    eval 'sub SCTP_LOC_35 () {0x23;}' unless defined(&SCTP_LOC_35);
    eval 'sub SCTP_NORMAL_PROC () {0;}' unless defined(&SCTP_NORMAL_PROC);
    eval 'sub SCTP_PCBFREE_NOFORCE () {1;}' unless defined(&SCTP_PCBFREE_NOFORCE);
    eval 'sub SCTP_PCBFREE_FORCE () {2;}' unless defined(&SCTP_PCBFREE_FORCE);
    eval 'sub SCTP_ADDR_IS_CONFIRMED () {8;}' unless defined(&SCTP_ADDR_IS_CONFIRMED);
    eval 'sub SCTP_ADDR_DYNAMIC_ADDED () {6;}' unless defined(&SCTP_ADDR_DYNAMIC_ADDED);
    eval 'sub SCTP_IN_COOKIE_PROC () {100;}' unless defined(&SCTP_IN_COOKIE_PROC);
    eval 'sub SCTP_ALLOC_ASOC () {1;}' unless defined(&SCTP_ALLOC_ASOC);
    eval 'sub SCTP_LOAD_ADDR_2 () {2;}' unless defined(&SCTP_LOAD_ADDR_2);
    eval 'sub SCTP_LOAD_ADDR_3 () {3;}' unless defined(&SCTP_LOAD_ADDR_3);
    eval 'sub SCTP_LOAD_ADDR_4 () {4;}' unless defined(&SCTP_LOAD_ADDR_4);
    eval 'sub SCTP_LOAD_ADDR_5 () {5;}' unless defined(&SCTP_LOAD_ADDR_5);
    eval 'sub SCTP_DONOT_SETSCOPE () {0;}' unless defined(&SCTP_DONOT_SETSCOPE);
    eval 'sub SCTP_DO_SETSCOPE () {1;}' unless defined(&SCTP_DO_SETSCOPE);
    eval 'sub SCTP_DEFAULT_ADD_MORE () {1452;}' unless defined(&SCTP_DEFAULT_ADD_MORE);
    unless(defined(&SCTP_PCBHASHSIZE)) {
	eval 'sub SCTP_PCBHASHSIZE () {256;}' unless defined(&SCTP_PCBHASHSIZE);
    }
    unless(defined(&SCTP_TCBHASHSIZE)) {
	eval 'sub SCTP_TCBHASHSIZE () {1024;}' unless defined(&SCTP_TCBHASHSIZE);
    }
    unless(defined(&SCTP_CHUNKQUEUE_SCALE)) {
	eval 'sub SCTP_CHUNKQUEUE_SCALE () {10;}' unless defined(&SCTP_CHUNKQUEUE_SCALE);
    }
    eval 'sub SCTP_CLOCK_GRANULARITY () {1;}' unless defined(&SCTP_CLOCK_GRANULARITY);
    eval 'sub IP_HDR_SIZE () {40;}' unless defined(&IP_HDR_SIZE);
    eval 'sub SCTP_CALLED_DIRECTLY_NOCMPSET () {0;}' unless defined(&SCTP_CALLED_DIRECTLY_NOCMPSET);
    eval 'sub SCTP_CALLED_AFTER_CMPSET_OFCLOSE () {1;}' unless defined(&SCTP_CALLED_AFTER_CMPSET_OFCLOSE);
    eval 'sub SCTP_CALLED_FROM_INPKILL_TIMER () {2;}' unless defined(&SCTP_CALLED_FROM_INPKILL_TIMER);
    eval 'sub SCTP_FREE_SHOULD_USE_ABORT () {1;}' unless defined(&SCTP_FREE_SHOULD_USE_ABORT);
    eval 'sub SCTP_FREE_SHOULD_USE_GRACEFUL_CLOSE () {0;}' unless defined(&SCTP_FREE_SHOULD_USE_GRACEFUL_CLOSE);
    unless(defined(&IPPROTO_SCTP)) {
	eval 'sub IPPROTO_SCTP () {132;}' unless defined(&IPPROTO_SCTP);
    }
    eval 'sub SCTP_MAX_DATA_BUNDLING () {256;}' unless defined(&SCTP_MAX_DATA_BUNDLING);
    eval 'sub SCTP_UINT16_GT {
        my($a, $b) = @_;
	    eval q(((($a < $b)  && (( &uint16_t)($b - $a) > (1<<15))) || (($a > $b)  && (( &uint16_t)($a - $b) < (1<<15)))));
    }' unless defined(&SCTP_UINT16_GT);
    eval 'sub SCTP_UINT16_GE {
        my($a, $b) = @_;
	    eval q(( &SCTP_UINT16_GT($a, $b) || ($a == $b)));
    }' unless defined(&SCTP_UINT16_GE);
    eval 'sub SCTP_UINT32_GT {
        my($a, $b) = @_;
	    eval q(((($a < $b)  && (( &uint32_t)($b - $a) > (1<<31))) || (($a > $b)  && (( &uint32_t)($a - $b) < (1<<31)))));
    }' unless defined(&SCTP_UINT32_GT);
    eval 'sub SCTP_UINT32_GE {
        my($a, $b) = @_;
	    eval q(( &SCTP_UINT32_GT($a, $b) || ($a == $b)));
    }' unless defined(&SCTP_UINT32_GE);
    eval 'sub SCTP_SSN_GT {
        my($a, $b) = @_;
	    eval q( &SCTP_UINT16_GT($a, $b));
    }' unless defined(&SCTP_SSN_GT);
    eval 'sub SCTP_SSN_GE {
        my($a, $b) = @_;
	    eval q( &SCTP_UINT16_GE($a, $b));
    }' unless defined(&SCTP_SSN_GE);
    eval 'sub SCTP_TSN_GT {
        my($a, $b) = @_;
	    eval q( &SCTP_UINT32_GT($a, $b));
    }' unless defined(&SCTP_TSN_GT);
    eval 'sub SCTP_TSN_GE {
        my($a, $b) = @_;
	    eval q( &SCTP_UINT32_GE($a, $b));
    }' unless defined(&SCTP_TSN_GE);
    eval 'sub SCTP_MID_GT {
        my($i, $a, $b) = @_;
	    eval q(((($i) == 1) ?  &SCTP_UINT32_GT($a, $b) :  &SCTP_UINT16_GT(( &uint16_t)$a, ( &uint16_t)$b)));
    }' unless defined(&SCTP_MID_GT);
    eval 'sub SCTP_MID_GE {
        my($i, $a, $b) = @_;
	    eval q(((($i) == 1) ?  &SCTP_UINT32_GE($a, $b) :  &SCTP_UINT16_GE(( &uint16_t)$a, ( &uint16_t)$b)));
    }' unless defined(&SCTP_MID_GE);
    eval 'sub SCTP_MID_EQ {
        my($i, $a, $b) = @_;
	    eval q(((($i) == 1) ? $a == $b : ( &uint16_t)$a == ( &uint16_t)$b));
    }' unless defined(&SCTP_MID_EQ);
    eval 'sub SCTP_IS_TSN_PRESENT {
        my($arry, $gap) = @_;
	    eval q((($arry->[($gap >> 3)] >> ($gap & 0x7)) & 0x1));
    }' unless defined(&SCTP_IS_TSN_PRESENT);
    eval 'sub SCTP_SET_TSN_PRESENT {
        my($arry, $gap) = @_;
	    eval q(($arry->[($gap >> 3)] |= (0x1 << (($gap & 0x7)))));
    }' unless defined(&SCTP_SET_TSN_PRESENT);
    eval 'sub SCTP_UNSET_TSN_PRESENT {
        my($arry, $gap) = @_;
	    eval q(($arry->[($gap >> 3)] &= ((~(0x1 << (($gap & 0x7)))) & 0xff)));
    }' unless defined(&SCTP_UNSET_TSN_PRESENT);
    eval 'sub SCTP_CALC_TSN_TO_GAP {
        my($gap, $tsn, $mapping_tsn) = @_;
	    eval q( &do {  &if ($tsn >= $mapping_tsn) { $gap = $tsn - $mapping_tsn; }  &else { $gap = ( &MAX_TSN - $mapping_tsn) + $tsn + 1; } }  &while (0));
    }' unless defined(&SCTP_CALC_TSN_TO_GAP);
    eval 'sub SCTP_RETRAN_DONE () {-1;}' unless defined(&SCTP_RETRAN_DONE);
    eval 'sub SCTP_RETRAN_EXIT () {-2;}' unless defined(&SCTP_RETRAN_EXIT);
    eval 'sub SCTP_NUMBER_IN_VTAG_BLOCK () {15;}' unless defined(&SCTP_NUMBER_IN_VTAG_BLOCK);
    eval 'sub SCTP_STACK_VTAG_HASH_SIZE () {32;}' unless defined(&SCTP_STACK_VTAG_HASH_SIZE);
    eval 'sub SCTP_TIME_WAIT () {60;}' unless defined(&SCTP_TIME_WAIT);
    eval 'sub SCTP_LOCAL_LAN_RTT () {900;}' unless defined(&SCTP_LOCAL_LAN_RTT);
    eval 'sub SCTP_LAN_UNKNOWN () {0;}' unless defined(&SCTP_LAN_UNKNOWN);
    eval 'sub SCTP_LAN_LOCAL () {1;}' unless defined(&SCTP_LAN_LOCAL);
    eval 'sub SCTP_LAN_INTERNET () {2;}' unless defined(&SCTP_LAN_INTERNET);
    eval 'sub SCTP_SEND_BUFFER_SPLITTING () {0x1;}' unless defined(&SCTP_SEND_BUFFER_SPLITTING);
    eval 'sub SCTP_RECV_BUFFER_SPLITTING () {0x2;}' unless defined(&SCTP_RECV_BUFFER_SPLITTING);
    eval 'sub SCTP_DEF_ASOC_RESC_LIMIT () {10;}' unless defined(&SCTP_DEF_ASOC_RESC_LIMIT);
    eval 'sub SCTP_DEF_SYSTEM_RESC_LIMIT () {1000;}' unless defined(&SCTP_DEF_SYSTEM_RESC_LIMIT);
    eval 'sub SCTP_SO_LOCKED () {1;}' unless defined(&SCTP_SO_LOCKED);
    eval 'sub SCTP_SO_NOT_LOCKED () {0;}' unless defined(&SCTP_SO_NOT_LOCKED);
    eval 'sub SCTP_ADDR_LOCKED () {1;}' unless defined(&SCTP_ADDR_LOCKED);
    eval 'sub SCTP_ADDR_NOT_LOCKED () {0;}' unless defined(&SCTP_ADDR_NOT_LOCKED);
    eval 'sub IN4_ISPRIVATE_ADDRESS {
        my($a) = @_;
	    eval q((((( &uint8_t *)($a)-> &s_addr)[0] == 10) || (((( &uint8_t *)($a)-> &s_addr)[0] == 172)  && ((( &uint8_t *)($a)-> &s_addr)[1] >= 16)  && ((( &uint8_t *)($a)-> &s_addr)[1] <= 32)) || (((( &uint8_t *)($a)-> &s_addr)[0] == 192)  && ((( &uint8_t *)($a)-> &s_addr)[1] == 168))));
    }' unless defined(&IN4_ISPRIVATE_ADDRESS);
    eval 'sub IN4_ISLOOPBACK_ADDRESS {
        my($a) = @_;
	    eval q(((( &uint8_t *)($a)-> &s_addr)[0] == 127));
    }' unless defined(&IN4_ISLOOPBACK_ADDRESS);
    eval 'sub IN4_ISLINKLOCAL_ADDRESS {
        my($a) = @_;
	    eval q((((( &uint8_t *)($a)-> &s_addr)[0] == 169)  && ((( &uint8_t *)($a)-> &s_addr)[1] == 254)));
    }' unless defined(&IN4_ISLINKLOCAL_ADDRESS);
    if(defined(&_KERNEL)) {
	eval 'sub SCTP_GETTIME_TIMEVAL {
	    my($x) = @_;
    	    eval q(( &getmicrouptime($x)));
	}' unless defined(&SCTP_GETTIME_TIMEVAL);
	eval 'sub SCTP_GETPTIME_TIMEVAL {
	    my($x) = @_;
    	    eval q(( &microuptime($x)));
	}' unless defined(&SCTP_GETPTIME_TIMEVAL);
    }
    if(defined(&_KERNEL) || defined(&__Userspace__)) {
	eval 'sub sctp_sowwakeup {
	    my($inp, $so) = @_;
    	    eval q( &do {  &if ( ($inp->{sctp_flags}) &  &SCTP_PCB_FLAGS_DONT_WAKE) {  ($inp->{sctp_flags}) |=  &SCTP_PCB_FLAGS_WAKEOUTPUT; }  &else {  &sowwakeup($so); } }  &while (0));
	}' unless defined(&sctp_sowwakeup);
	eval 'sub sctp_sowwakeup_locked {
	    my($inp, $so) = @_;
    	    eval q( &do {  &if ( ($inp->{sctp_flags}) &  &SCTP_PCB_FLAGS_DONT_WAKE) {  &SOCKBUF_UNLOCK((($so)-> &so_snd));  ($inp->{sctp_flags}) |=  &SCTP_PCB_FLAGS_WAKEOUTPUT; }  &else {  &sowwakeup_locked($so); } }  &while (0));
	}' unless defined(&sctp_sowwakeup_locked);
	eval 'sub sctp_sorwakeup {
	    my($inp, $so) = @_;
    	    eval q( &do {  &if ( ($inp->{sctp_flags}) &  &SCTP_PCB_FLAGS_DONT_WAKE) {  ($inp->{sctp_flags}) |=  &SCTP_PCB_FLAGS_WAKEINPUT; }  &else {  &sorwakeup($so); } }  &while (0));
	}' unless defined(&sctp_sorwakeup);
	eval 'sub sctp_sorwakeup_locked {
	    my($inp, $so) = @_;
    	    eval q( &do {  &if ( ($inp->{sctp_flags}) &  &SCTP_PCB_FLAGS_DONT_WAKE) {  ($inp->{sctp_flags}) |=  &SCTP_PCB_FLAGS_WAKEINPUT;  &SOCKBUF_UNLOCK((($so)-> &so_rcv)); }  &else {  &sorwakeup_locked($so); } }  &while (0));
	}' unless defined(&sctp_sorwakeup_locked);
    }
}
1;
