require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NETINET_SCTP_PCB_H_)) {
    eval 'sub _NETINET_SCTP_PCB_H_ () {1;}' unless defined(&_NETINET_SCTP_PCB_H_);
    require 'netinet/sctp_os.ph';
    require 'netinet/sctp.ph';
    require 'netinet/sctp_constants.ph';
    require 'netinet/sctp_sysctl.ph';
    require 'netinet/sctp_structs.ph';
    require 'netinet/sctp_auth.ph';
    eval 'sub SCTP_PCBHASH_ALLADDR {
        my($port, $mask) = @_;
	    eval q(($port & $mask));
    }' unless defined(&SCTP_PCBHASH_ALLADDR);
    eval 'sub SCTP_PCBHASH_ASOC {
        my($tag, $mask) = @_;
	    eval q(($tag & $mask));
    }' unless defined(&SCTP_PCBHASH_ASOC);
    eval 'sub SCTP_ADDR_VALID () {0x1;}' unless defined(&SCTP_ADDR_VALID);
    eval 'sub SCTP_BEING_DELETED () {0x2;}' unless defined(&SCTP_BEING_DELETED);
    eval 'sub SCTP_ADDR_DEFER_USE () {0x4;}' unless defined(&SCTP_ADDR_DEFER_USE);
    eval 'sub SCTP_ADDR_IFA_UNUSEABLE () {0x8;}' unless defined(&SCTP_ADDR_IFA_UNUSEABLE);
    if(defined(&INET)) {
    }
    if(defined(&INET6)) {
    }
    if(defined(&__FreeBSD__)  && defined(&SMP)  && defined(&SCTP_USE_PERCPU_STAT)) {
    } else {
    }
    if(defined(&SCTP_PACKET_LOGGING)) {
    }
    if(defined(&INET6)) {
    }
    unless(defined(&SCTP_ALIGNMENT)) {
	eval 'sub SCTP_ALIGNMENT () {32;}' unless defined(&SCTP_ALIGNMENT);
    }
    unless(defined(&SCTP_ALIGNM1)) {
	eval 'sub SCTP_ALIGNM1 () {( &SCTP_ALIGNMENT-1);}' unless defined(&SCTP_ALIGNM1);
    }
    eval 'sub sctp_lport () { ($ip_inp->{inp}->{inp_lport});}' unless defined(&sctp_lport);
    eval 'sub SCTP_READ_LOG_SIZE () {135;}' unless defined(&SCTP_READ_LOG_SIZE);
    if(defined(&SCTP_TRACK_FREED_ASOCS)) {
    }
    if(defined(&SCTP_ASOCLOG_OF_TSNS)) {
    }
    require 'netinet/sctp_lock_bsd.ph';
    if(defined(&_KERNEL) || defined(&__Userspace__)) {
	if(defined(&INET6)) {
	}
	if(defined(&__FreeBSD__)  && defined(&SCTP_MCORE_INPUT)  && defined(&SMP)) {
	}
    }
}
1;
