require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NETINET_SCTP_STRUCTS_H_)) {
    eval 'sub _NETINET_SCTP_STRUCTS_H_ () {1;}' unless defined(&_NETINET_SCTP_STRUCTS_H_);
    require 'netinet/sctp_os.ph';
    require 'netinet/sctp_header.ph';
    require 'netinet/sctp_auth.ph';
    eval 'sub SCTP_PCB_ANY_FLAGS () {0x;}' unless defined(&SCTP_PCB_ANY_FLAGS);
    eval 'sub SCTP_PCB_ANY_FEATURES () {0x;}' unless defined(&SCTP_PCB_ANY_FEATURES);
    eval 'sub SCTP_ASOC_ANY_STATE () {0x;}' unless defined(&SCTP_ASOC_ANY_STATE);
    if(defined(&__FreeBSD__)  && defined(&SCTP_MCORE_INPUT)  && defined(&SMP)) {
    }
    eval 'sub SCTP_ITERATOR_DO_ALL_INP () {0x1;}' unless defined(&SCTP_ITERATOR_DO_ALL_INP);
    eval 'sub SCTP_ITERATOR_DO_SINGLE_INP () {0x2;}' unless defined(&SCTP_ITERATOR_DO_SINGLE_INP);
    eval 'sub SCTP_ITERATOR_STOP_CUR_IT () {0x4;}' unless defined(&SCTP_ITERATOR_STOP_CUR_IT);
    eval 'sub SCTP_ITERATOR_STOP_CUR_INP () {0x8;}' unless defined(&SCTP_ITERATOR_STOP_CUR_INP);
    if(defined(&INET6)) {
    }
    eval 'sub CHUNK_FLAGS_PR_SCTP_TTL () { &SCTP_PR_SCTP_TTL;}' unless defined(&CHUNK_FLAGS_PR_SCTP_TTL);
    eval 'sub CHUNK_FLAGS_PR_SCTP_BUF () { &SCTP_PR_SCTP_BUF;}' unless defined(&CHUNK_FLAGS_PR_SCTP_BUF);
    eval 'sub CHUNK_FLAGS_PR_SCTP_RTX () { &SCTP_PR_SCTP_RTX;}' unless defined(&CHUNK_FLAGS_PR_SCTP_RTX);
    eval 'sub CHUNK_FLAGS_FRAGMENT_OK () {0x100;}' unless defined(&CHUNK_FLAGS_FRAGMENT_OK);
    eval 'sub SCTP_ON_ORDERED () {1;}' unless defined(&SCTP_ON_ORDERED);
    eval 'sub SCTP_ON_UNORDERED () {2;}' unless defined(&SCTP_ON_UNORDERED);
    eval 'sub SCTP_STREAM_CLOSED () {0x;}' unless defined(&SCTP_STREAM_CLOSED);
    eval 'sub SCTP_STREAM_OPENING () {0x1;}' unless defined(&SCTP_STREAM_OPENING);
    eval 'sub SCTP_STREAM_OPEN () {0x2;}' unless defined(&SCTP_STREAM_OPEN);
    eval 'sub SCTP_STREAM_RESET_PENDING () {0x3;}' unless defined(&SCTP_STREAM_RESET_PENDING);
    eval 'sub SCTP_STREAM_RESET_IN_FLIGHT () {0x4;}' unless defined(&SCTP_STREAM_RESET_IN_FLIGHT);
    eval 'sub SCTP_MAX_STREAMS_AT_ONCE_RESET () {200;}' unless defined(&SCTP_MAX_STREAMS_AT_ONCE_RESET);
    if(defined(&SCTP_DETAILED_STR_STATS)) {
    } else {
    }
    eval 'sub SCTP_TSN_LOG_SIZE () {40;}' unless defined(&SCTP_TSN_LOG_SIZE);
    eval 'sub SCTP_FS_SPEC_LOG_SIZE () {200;}' unless defined(&SCTP_FS_SPEC_LOG_SIZE);
    if(defined(&SCTP_ASOCLOG_OF_TSNS)) {
    }
    if(defined(&SCTP_FS_SPEC_LOG)) {
    }
    if(defined(&INET6)) {
    }
}
1;
