require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_TCP_FSM_H_)) {
    eval 'sub _NETINET_TCP_FSM_H_ () {1;}' unless defined(&_NETINET_TCP_FSM_H_);
    eval 'sub TCP_NSTATES () {11;}' unless defined(&TCP_NSTATES);
    eval 'sub TCPS_CLOSED () {0;}' unless defined(&TCPS_CLOSED);
    eval 'sub TCPS_LISTEN () {1;}' unless defined(&TCPS_LISTEN);
    eval 'sub TCPS_SYN_SENT () {2;}' unless defined(&TCPS_SYN_SENT);
    eval 'sub TCPS_SYN_RECEIVED () {3;}' unless defined(&TCPS_SYN_RECEIVED);
    eval 'sub TCPS_ESTABLISHED () {4;}' unless defined(&TCPS_ESTABLISHED);
    eval 'sub TCPS_CLOSE_WAIT () {5;}' unless defined(&TCPS_CLOSE_WAIT);
    eval 'sub TCPS_FIN_WAIT_1 () {6;}' unless defined(&TCPS_FIN_WAIT_1);
    eval 'sub TCPS_CLOSING () {7;}' unless defined(&TCPS_CLOSING);
    eval 'sub TCPS_LAST_ACK () {8;}' unless defined(&TCPS_LAST_ACK);
    eval 'sub TCPS_FIN_WAIT_2 () {9;}' unless defined(&TCPS_FIN_WAIT_2);
    eval 'sub TCPS_TIME_WAIT () {10;}' unless defined(&TCPS_TIME_WAIT);
    eval 'sub TCP6_NSTATES () { &TCP_NSTATES;}' unless defined(&TCP6_NSTATES);
    eval 'sub TCP6S_CLOSED () { &TCPS_CLOSED;}' unless defined(&TCP6S_CLOSED);
    eval 'sub TCP6S_LISTEN () { &TCPS_LISTEN;}' unless defined(&TCP6S_LISTEN);
    eval 'sub TCP6S_SYN_SENT () { &TCPS_SYN_SENT;}' unless defined(&TCP6S_SYN_SENT);
    eval 'sub TCP6S_SYN_RECEIVED () { &TCPS_SYN_RECEIVED;}' unless defined(&TCP6S_SYN_RECEIVED);
    eval 'sub TCP6S_ESTABLISHED () { &TCPS_ESTABLISHED;}' unless defined(&TCP6S_ESTABLISHED);
    eval 'sub TCP6S_CLOSE_WAIT () { &TCPS_CLOSE_WAIT;}' unless defined(&TCP6S_CLOSE_WAIT);
    eval 'sub TCP6S_FIN_WAIT_1 () { &TCPS_FIN_WAIT_1;}' unless defined(&TCP6S_FIN_WAIT_1);
    eval 'sub TCP6S_CLOSING () { &TCPS_CLOSING;}' unless defined(&TCP6S_CLOSING);
    eval 'sub TCP6S_LAST_ACK () { &TCPS_LAST_ACK;}' unless defined(&TCP6S_LAST_ACK);
    eval 'sub TCP6S_FIN_WAIT_2 () { &TCPS_FIN_WAIT_2;}' unless defined(&TCP6S_FIN_WAIT_2);
    eval 'sub TCP6S_TIME_WAIT () { &TCPS_TIME_WAIT;}' unless defined(&TCP6S_TIME_WAIT);
    eval 'sub TCPS_HAVERCVDSYN {
        my($s) = @_;
	    eval q((($s) >=  &TCPS_SYN_RECEIVED));
    }' unless defined(&TCPS_HAVERCVDSYN);
    eval 'sub TCPS_HAVEESTABLISHED {
        my($s) = @_;
	    eval q((($s) >=  &TCPS_ESTABLISHED));
    }' unless defined(&TCPS_HAVEESTABLISHED);
    eval 'sub TCPS_HAVERCVDFIN {
        my($s) = @_;
	    eval q((($s) ==  &TCPS_CLOSE_WAIT || (($s) >=  &TCPS_CLOSING  && ($s) !=  &TCPS_FIN_WAIT_2)));
    }' unless defined(&TCPS_HAVERCVDFIN);
    if(defined(&TCPOUTFLAGS)) {
    }
    if(defined(&KPROF)) {
    }
    if(defined(&TCPSTATES)) {
    }
}
1;
