require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_TCP_SEQ_H_)) {
    eval 'sub _NETINET_TCP_SEQ_H_ () {1;}' unless defined(&_NETINET_TCP_SEQ_H_);
    eval 'sub SEQ_LT {
        my($a,$b) = @_;
	    eval q(((($a)-($b)) < 0));
    }' unless defined(&SEQ_LT);
    eval 'sub SEQ_LEQ {
        my($a,$b) = @_;
	    eval q(((($a)-($b)) <= 0));
    }' unless defined(&SEQ_LEQ);
    eval 'sub SEQ_GT {
        my($a,$b) = @_;
	    eval q(((($a)-($b)) > 0));
    }' unless defined(&SEQ_GT);
    eval 'sub SEQ_GEQ {
        my($a,$b) = @_;
	    eval q(((($a)-($b)) >= 0));
    }' unless defined(&SEQ_GEQ);
    eval 'sub SEQ_MIN {
        my($a, $b) = @_;
	    eval q((( &SEQ_LT($a, $b)) ? ($a) : ($b)));
    }' unless defined(&SEQ_MIN);
    eval 'sub SEQ_MAX {
        my($a, $b) = @_;
	    eval q((( &SEQ_GT($a, $b)) ? ($a) : ($b)));
    }' unless defined(&SEQ_MAX);
    eval 'sub WIN_LT {
        my($a,$b) = @_;
	    eval q(( &ntohs($a) <  &ntohs($b)));
    }' unless defined(&WIN_LT);
    eval 'sub WIN_LEQ {
        my($a,$b) = @_;
	    eval q(( &ntohs($a) <=  &ntohs($b)));
    }' unless defined(&WIN_LEQ);
    eval 'sub WIN_GT {
        my($a,$b) = @_;
	    eval q(( &ntohs($a) >  &ntohs($b)));
    }' unless defined(&WIN_GT);
    eval 'sub WIN_GEQ {
        my($a,$b) = @_;
	    eval q(( &ntohs($a) >=  &ntohs($b)));
    }' unless defined(&WIN_GEQ);
    eval 'sub WIN_MIN {
        my($a, $b) = @_;
	    eval q((( &WIN_LT($a, $b)) ? ($a) : ($b)));
    }' unless defined(&WIN_MIN);
    eval 'sub WIN_MAX {
        my($a, $b) = @_;
	    eval q((( &WIN_GT($a, $b)) ? ($a) : ($b)));
    }' unless defined(&WIN_MAX);
    eval 'sub TSTMP_LT {
        my($a,$b) = @_;
	    eval q(((($a)-($b)) < 0));
    }' unless defined(&TSTMP_LT);
    eval 'sub TSTMP_GT {
        my($a,$b) = @_;
	    eval q(((($a)-($b)) > 0));
    }' unless defined(&TSTMP_GT);
    eval 'sub TSTMP_GEQ {
        my($a,$b) = @_;
	    eval q(((($a)-($b)) >= 0));
    }' unless defined(&TSTMP_GEQ);
    eval 'sub tcp_rcvseqinit {
        my($tp) = @_;
	    eval q(($tp)-> &rcv_adv = ($tp)-> &rcv_nxt = ($tp)-> &irs + 1);
    }' unless defined(&tcp_rcvseqinit);
    eval 'sub tcp_sendseqinit {
        my($tp) = @_;
	    eval q(($tp)-> &snd_una = ($tp)-> &snd_nxt = ($tp)-> &snd_max = ($tp)-> &snd_up = ($tp)-> &snd_recover = ($tp)-> &iss);
    }' unless defined(&tcp_sendseqinit);
    if(defined(&_KERNEL)) {
	eval 'sub TCP_TS_TO_TICKS {
	    my($_t) = @_;
    	    eval q((($_t) *  &hz / 1000));
	}' unless defined(&TCP_TS_TO_TICKS);
	eval 'sub TCP_PAWS_IDLE () {(24* 24* 60* 60* 1000);}' unless defined(&TCP_PAWS_IDLE);
    }
}
1;
