require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_TCP_TIMER_H_)) {
    eval 'sub _NETINET_TCP_TIMER_H_ () {1;}' unless defined(&_NETINET_TCP_TIMER_H_);
    eval 'sub TCPTV_MSL () {( 30* &hz);}' unless defined(&TCPTV_MSL);
    eval 'sub TCPTV_SRTTBASE () {0;}' unless defined(&TCPTV_SRTTBASE);
    eval 'sub TCPTV_RTOBASE () {( 3* &hz);}' unless defined(&TCPTV_RTOBASE);
    eval 'sub TCPTV_PERSMIN () {( 5* &hz);}' unless defined(&TCPTV_PERSMIN);
    eval 'sub TCPTV_PERSMAX () {( 60* &hz);}' unless defined(&TCPTV_PERSMAX);
    eval 'sub TCPTV_KEEP_INIT () {( 75* &hz);}' unless defined(&TCPTV_KEEP_INIT);
    eval 'sub TCPTV_KEEP_IDLE () {(120*60* &hz);}' unless defined(&TCPTV_KEEP_IDLE);
    eval 'sub TCPTV_KEEPINTVL () {( 75* &hz);}' unless defined(&TCPTV_KEEPINTVL);
    eval 'sub TCPTV_KEEPCNT () {8;}' unless defined(&TCPTV_KEEPCNT);
    eval 'sub TCPTV_FINWAIT2_TIMEOUT () {(60* &hz);}' unless defined(&TCPTV_FINWAIT2_TIMEOUT);
    eval 'sub TCPTV_MIN () {(  &hz/33);}' unless defined(&TCPTV_MIN);
    eval 'sub TCPTV_CPU_VAR () {(  &hz/5);}' unless defined(&TCPTV_CPU_VAR);
    eval 'sub TCPTV_REXMTMAX () {( 64* &hz);}' unless defined(&TCPTV_REXMTMAX);
    eval 'sub TCPTV_TWTRUNC () {8;}' unless defined(&TCPTV_TWTRUNC);
    eval 'sub TCP_LINGERTIME () {120;}' unless defined(&TCP_LINGERTIME);
    eval 'sub TCP_MAXRXTSHIFT () {12;}' unless defined(&TCP_MAXRXTSHIFT);
    eval 'sub TCPTV_DELACK () {(  &hz/10);}' unless defined(&TCPTV_DELACK);
    if(defined(&TCPTIMERS)) {
    }
    eval 'sub TCPT_RANGESET {
        my($tv, $value, $tvmin, $tvmax) = @_;
	    eval q( &do { = +  &tcp_rexmit_slop;  &if ( < ) = ;  &if ( > ($tvmax)) ($tv) = ($tvmax); }  &while(0));
    }' unless defined(&TCPT_RANGESET);
    if(defined(&_KERNEL)) {
	eval 'sub TT_DELACK () {0x1;}' unless defined(&TT_DELACK);
	eval 'sub TT_REXMT () {0x2;}' unless defined(&TT_REXMT);
	eval 'sub TT_PERSIST () {0x4;}' unless defined(&TT_PERSIST);
	eval 'sub TT_KEEP () {0x8;}' unless defined(&TT_KEEP);
	eval 'sub TT_2MSL () {0x10;}' unless defined(&TT_2MSL);
	eval 'sub TT_MASK () {( &TT_DELACK| &TT_REXMT| &TT_PERSIST| &TT_KEEP| &TT_2MSL);}' unless defined(&TT_MASK);
	eval 'sub TT_DELACK_RST () {0x100;}' unless defined(&TT_DELACK_RST);
	eval 'sub TT_REXMT_RST () {0x200;}' unless defined(&TT_REXMT_RST);
	eval 'sub TT_PERSIST_RST () {0x400;}' unless defined(&TT_PERSIST_RST);
	eval 'sub TT_KEEP_RST () {0x800;}' unless defined(&TT_KEEP_RST);
	eval 'sub TT_2MSL_RST () {0x1000;}' unless defined(&TT_2MSL_RST);
	eval 'sub TT_STOPPED () {0x10000;}' unless defined(&TT_STOPPED);
	eval 'sub TP_KEEPINIT {
	    my($tp) = @_;
    	    eval q((($tp)-> &t_keepinit ? ($tp)-> &t_keepinit :  &tcp_keepinit));
	}' unless defined(&TP_KEEPINIT);
	eval 'sub TP_KEEPIDLE {
	    my($tp) = @_;
    	    eval q((($tp)-> &t_keepidle ? ($tp)-> &t_keepidle :  &tcp_keepidle));
	}' unless defined(&TP_KEEPIDLE);
	eval 'sub TP_KEEPINTVL {
	    my($tp) = @_;
    	    eval q((($tp)-> &t_keepintvl ? ($tp)-> &t_keepintvl :  &tcp_keepintvl));
	}' unless defined(&TP_KEEPINTVL);
	eval 'sub TP_KEEPCNT {
	    my($tp) = @_;
    	    eval q((($tp)-> &t_keepcnt ? ($tp)-> &t_keepcnt :  &tcp_keepcnt));
	}' unless defined(&TP_KEEPCNT);
	eval 'sub TP_MAXIDLE {
	    my($tp) = @_;
    	    eval q(( &TP_KEEPCNT($tp) *  &TP_KEEPINTVL($tp)));
	}' unless defined(&TP_MAXIDLE);
    }
}
1;
