require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_TCP_VAR_H_)) {
    eval 'sub _NETINET_TCP_VAR_H_ () {1;}' unless defined(&_NETINET_TCP_VAR_H_);
    require 'netinet/tcp.ph';
    require 'netinet/tcp_fsm.ph';
    if(defined(&_KERNEL)) {
	require 'net/vnet.ph';
	require 'sys/mbuf.ph';
	eval 'sub V_tcp_do_rfc1323 () { &VNET( &tcp_do_rfc1323);}' unless defined(&V_tcp_do_rfc1323);
    }
    eval 'sub tcp6cb () { &tcpcb;}' unless defined(&tcp6cb);
    eval 'sub TCP_FUNC_BEING_REMOVED () {0x1;}' unless defined(&TCP_FUNC_BEING_REMOVED);
    if(defined(&_KERNEL)  && defined(&TCP_RFC7413)) {
    } else {
    }
    if(defined(&_KERNEL)  && defined(&TCP_RFC7413)) {
    } else {
    }
    if(defined(&_KERNEL)  && defined(&TCPPCAP)) {
	if(defined(&_LP64)) {
	} else {
	}
    } else {
    }
    eval 'sub TF_ACKNOW () {0x1;}' unless defined(&TF_ACKNOW);
    eval 'sub TF_DELACK () {0x2;}' unless defined(&TF_DELACK);
    eval 'sub TF_NODELAY () {0x4;}' unless defined(&TF_NODELAY);
    eval 'sub TF_NOOPT () {0x8;}' unless defined(&TF_NOOPT);
    eval 'sub TF_SENTFIN () {0x10;}' unless defined(&TF_SENTFIN);
    eval 'sub TF_REQ_SCALE () {0x20;}' unless defined(&TF_REQ_SCALE);
    eval 'sub TF_RCVD_SCALE () {0x40;}' unless defined(&TF_RCVD_SCALE);
    eval 'sub TF_REQ_TSTMP () {0x80;}' unless defined(&TF_REQ_TSTMP);
    eval 'sub TF_RCVD_TSTMP () {0x100;}' unless defined(&TF_RCVD_TSTMP);
    eval 'sub TF_SACK_PERMIT () {0x200;}' unless defined(&TF_SACK_PERMIT);
    eval 'sub TF_NEEDSYN () {0x400;}' unless defined(&TF_NEEDSYN);
    eval 'sub TF_NEEDFIN () {0x800;}' unless defined(&TF_NEEDFIN);
    eval 'sub TF_NOPUSH () {0x1000;}' unless defined(&TF_NOPUSH);
    eval 'sub TF_PREVVALID () {0x2000;}' unless defined(&TF_PREVVALID);
    eval 'sub TF_MORETOCOME () {0x10000;}' unless defined(&TF_MORETOCOME);
    eval 'sub TF_LQ_OVERFLOW () {0x20000;}' unless defined(&TF_LQ_OVERFLOW);
    eval 'sub TF_LASTIDLE () {0x40000;}' unless defined(&TF_LASTIDLE);
    eval 'sub TF_RXWIN0SENT () {0x80000;}' unless defined(&TF_RXWIN0SENT);
    eval 'sub TF_FASTRECOVERY () {0x100000;}' unless defined(&TF_FASTRECOVERY);
    eval 'sub TF_WASFRECOVERY () {0x200000;}' unless defined(&TF_WASFRECOVERY);
    eval 'sub TF_SIGNATURE () {0x400000;}' unless defined(&TF_SIGNATURE);
    eval 'sub TF_FORCEDATA () {0x800000;}' unless defined(&TF_FORCEDATA);
    eval 'sub TF_TSO () {0x1000000;}' unless defined(&TF_TSO);
    eval 'sub TF_TOE () {0x2000000;}' unless defined(&TF_TOE);
    eval 'sub TF_ECN_PERMIT () {0x4000000;}' unless defined(&TF_ECN_PERMIT);
    eval 'sub TF_ECN_SND_CWR () {0x8000000;}' unless defined(&TF_ECN_SND_CWR);
    eval 'sub TF_ECN_SND_ECE () {0x10000000;}' unless defined(&TF_ECN_SND_ECE);
    eval 'sub TF_CONGRECOVERY () {0x20000000;}' unless defined(&TF_CONGRECOVERY);
    eval 'sub TF_WASCRECOVERY () {0x40000000;}' unless defined(&TF_WASCRECOVERY);
    eval 'sub TF_FASTOPEN () {0x80000000;}' unless defined(&TF_FASTOPEN);
    eval 'sub IN_FASTRECOVERY {
        my($t_flags) = @_;
	    eval q(($t_flags &  &TF_FASTRECOVERY));
    }' unless defined(&IN_FASTRECOVERY);
    eval 'sub ENTER_FASTRECOVERY {
        my($t_flags) = @_;
	    eval q($t_flags |=  &TF_FASTRECOVERY);
    }' unless defined(&ENTER_FASTRECOVERY);
    eval 'sub EXIT_FASTRECOVERY {
        my($t_flags) = @_;
	    eval q($t_flags &= ~ &TF_FASTRECOVERY);
    }' unless defined(&EXIT_FASTRECOVERY);
    eval 'sub IN_CONGRECOVERY {
        my($t_flags) = @_;
	    eval q(($t_flags &  &TF_CONGRECOVERY));
    }' unless defined(&IN_CONGRECOVERY);
    eval 'sub ENTER_CONGRECOVERY {
        my($t_flags) = @_;
	    eval q($t_flags |=  &TF_CONGRECOVERY);
    }' unless defined(&ENTER_CONGRECOVERY);
    eval 'sub EXIT_CONGRECOVERY {
        my($t_flags) = @_;
	    eval q($t_flags &= ~ &TF_CONGRECOVERY);
    }' unless defined(&EXIT_CONGRECOVERY);
    eval 'sub IN_RECOVERY {
        my($t_flags) = @_;
	    eval q(($t_flags & ( &TF_CONGRECOVERY |  &TF_FASTRECOVERY)));
    }' unless defined(&IN_RECOVERY);
    eval 'sub ENTER_RECOVERY {
        my($t_flags) = @_;
	    eval q($t_flags |= ( &TF_CONGRECOVERY |  &TF_FASTRECOVERY));
    }' unless defined(&ENTER_RECOVERY);
    eval 'sub EXIT_RECOVERY {
        my($t_flags) = @_;
	    eval q($t_flags &= ~( &TF_CONGRECOVERY |  &TF_FASTRECOVERY));
    }' unless defined(&EXIT_RECOVERY);
    eval 'sub BYTES_THIS_ACK {
        my($tp, $th) = @_;
	    eval q(( ($th->{th_ack}) -  ($tp->{snd_una})));
    }' unless defined(&BYTES_THIS_ACK);
    eval 'sub TCPOOB_HAVEDATA () {0x1;}' unless defined(&TCPOOB_HAVEDATA);
    eval 'sub TCPOOB_HADDATA () {0x2;}' unless defined(&TCPOOB_HADDATA);
    eval 'sub TF2_PLPMTU_BLACKHOLE () {0x1;}' unless defined(&TF2_PLPMTU_BLACKHOLE);
    eval 'sub TF2_PLPMTU_PMTUD () {0x2;}' unless defined(&TF2_PLPMTU_PMTUD);
    eval 'sub TF2_PLPMTU_MAXSEGSNT () {0x4;}' unless defined(&TF2_PLPMTU_MAXSEGSNT);
    eval 'sub TOF_MSS () {0x1;}' unless defined(&TOF_MSS);
    eval 'sub TOF_SCALE () {0x2;}' unless defined(&TOF_SCALE);
    eval 'sub TOF_SACKPERM () {0x4;}' unless defined(&TOF_SACKPERM);
    eval 'sub TOF_TS () {0x10;}' unless defined(&TOF_TS);
    eval 'sub TOF_SIGNATURE () {0x40;}' unless defined(&TOF_SIGNATURE);
    eval 'sub TOF_SACK () {0x80;}' unless defined(&TOF_SACK);
    eval 'sub TOF_FASTOPEN () {0x100;}' unless defined(&TOF_FASTOPEN);
    eval 'sub TOF_MAXOPT () {0x200;}' unless defined(&TOF_MAXOPT);
    eval 'sub TO_SYN () {0x1;}' unless defined(&TO_SYN);
    unless(defined(&_NETINET_IN_PCB_H_)) {
    }
    eval 'sub intotcpcb {
        my($ip) = @_;
	    eval q((($ip)-> &inp_ppcb));
    }' unless defined(&intotcpcb);
    eval 'sub intotw {
        my($ip) = @_;
	    eval q((($ip)-> &inp_ppcb));
    }' unless defined(&intotw);
    eval 'sub sototcpcb {
        my($so) = @_;
	    eval q(( &intotcpcb( &sotoinpcb($so))));
    }' unless defined(&sototcpcb);
    eval 'sub TCP_RTT_SCALE () {32;}' unless defined(&TCP_RTT_SCALE);
    eval 'sub TCP_RTT_SHIFT () {5;}' unless defined(&TCP_RTT_SHIFT);
    eval 'sub TCP_RTTVAR_SCALE () {16;}' unless defined(&TCP_RTTVAR_SCALE);
    eval 'sub TCP_RTTVAR_SHIFT () {4;}' unless defined(&TCP_RTTVAR_SHIFT);
    eval 'sub TCP_DELTA_SHIFT () {2;}' unless defined(&TCP_DELTA_SHIFT);
    eval 'sub TCP_REXMTVAL {
        my($tp) = @_;
	    eval q( &max(($tp)-> &t_rttmin, ((($tp)-> &t_srtt >> ( &TCP_RTT_SHIFT -  &TCP_DELTA_SHIFT)) + ($tp)-> &t_rttvar) >>  &TCP_DELTA_SHIFT));
    }' unless defined(&TCP_REXMTVAL);
    eval 'sub tcps_rcvmemdrop () { &tcps_rcvreassfull;}' unless defined(&tcps_rcvmemdrop);
    if(defined(&_KERNEL)) {
	eval 'sub TI_UNLOCKED () {1;}' unless defined(&TI_UNLOCKED);
	eval 'sub TI_RLOCKED () {2;}' unless defined(&TI_RLOCKED);
	require 'sys/counter.ph';
	eval 'sub TCPSTAT_ADD {
	    my($name, $val) = @_;
    	    eval q( &VNET_PCPUSTAT_ADD(\'struct tcpstat\',  &tcpstat, $name, ($val)));
	}' unless defined(&TCPSTAT_ADD);
	eval 'sub TCPSTAT_INC {
	    my($name) = @_;
    	    eval q( &TCPSTAT_ADD($name, 1));
	}' unless defined(&TCPSTAT_INC);
	eval 'sub KMOD_TCPSTAT_INC {
	    my($name) = @_;
    	    eval q( &kmod_tcpstat_inc( &offsetof(\'struct tcpstat\', $name) / $sizeof{ &uint64_t}));
	}' unless defined(&KMOD_TCPSTAT_INC);
	eval 'sub V_tcps_states () { &VNET( &tcps_states);}' unless defined(&V_tcps_states);
	eval 'sub TCPSTATES_INC {
	    my($state) = @_;
    	    eval q( &counter_u64_add( $V_tcps_states[$state], 1));
	}' unless defined(&TCPSTATES_INC);
	eval 'sub TCPSTATES_DEC {
	    my($state) = @_;
    	    eval q( &counter_u64_add( $V_tcps_states[$state], -1));
	}' unless defined(&TCPSTATES_DEC);
	eval 'sub HHOOK_TCP_EST_IN () {0;}' unless defined(&HHOOK_TCP_EST_IN);
	eval 'sub HHOOK_TCP_EST_OUT () {1;}' unless defined(&HHOOK_TCP_EST_OUT);
	eval 'sub HHOOK_TCP_LAST () { &HHOOK_TCP_EST_OUT;}' unless defined(&HHOOK_TCP_LAST);
    }
    if(defined(&_NETINET_IN_PCB_H_)  && defined(&_SYS_SOCKETVAR_H_)) {
    }
    eval 'sub TCPCTL_DO_RFC1323 () {1;}' unless defined(&TCPCTL_DO_RFC1323);
    eval 'sub TCPCTL_MSSDFLT () {3;}' unless defined(&TCPCTL_MSSDFLT);
    eval 'sub TCPCTL_STATS () {4;}' unless defined(&TCPCTL_STATS);
    eval 'sub TCPCTL_RTTDFLT () {5;}' unless defined(&TCPCTL_RTTDFLT);
    eval 'sub TCPCTL_KEEPIDLE () {6;}' unless defined(&TCPCTL_KEEPIDLE);
    eval 'sub TCPCTL_KEEPINTVL () {7;}' unless defined(&TCPCTL_KEEPINTVL);
    eval 'sub TCPCTL_SENDSPACE () {8;}' unless defined(&TCPCTL_SENDSPACE);
    eval 'sub TCPCTL_RECVSPACE () {9;}' unless defined(&TCPCTL_RECVSPACE);
    eval 'sub TCPCTL_KEEPINIT () {10;}' unless defined(&TCPCTL_KEEPINIT);
    eval 'sub TCPCTL_PCBLIST () {11;}' unless defined(&TCPCTL_PCBLIST);
    eval 'sub TCPCTL_DELACKTIME () {12;}' unless defined(&TCPCTL_DELACKTIME);
    eval 'sub TCPCTL_V6MSSDFLT () {13;}' unless defined(&TCPCTL_V6MSSDFLT);
    eval 'sub TCPCTL_SACK () {14;}' unless defined(&TCPCTL_SACK);
    eval 'sub TCPCTL_DROP () {15;}' unless defined(&TCPCTL_DROP);
    eval 'sub TCPCTL_STATES () {16;}' unless defined(&TCPCTL_STATES);
    if(defined(&_KERNEL)) {
	if(defined(&SYSCTL_DECL)) {
	}
	eval 'sub V_tcb () { &VNET( &tcb);}' unless defined(&V_tcb);
	eval 'sub V_tcbinfo () { &VNET( &tcbinfo);}' unless defined(&V_tcbinfo);
	eval 'sub V_tcp_mssdflt () { &VNET( &tcp_mssdflt);}' unless defined(&V_tcp_mssdflt);
	eval 'sub V_tcp_minmss () { &VNET( &tcp_minmss);}' unless defined(&V_tcp_minmss);
	eval 'sub V_tcp_delack_enabled () { &VNET( &tcp_delack_enabled);}' unless defined(&V_tcp_delack_enabled);
	eval 'sub V_tcp_do_rfc3390 () { &VNET( &tcp_do_rfc3390);}' unless defined(&V_tcp_do_rfc3390);
	eval 'sub V_tcp_initcwnd_segments () { &VNET( &tcp_initcwnd_segments);}' unless defined(&V_tcp_initcwnd_segments);
	eval 'sub V_tcp_sendspace () { &VNET( &tcp_sendspace);}' unless defined(&V_tcp_sendspace);
	eval 'sub V_tcp_recvspace () { &VNET( &tcp_recvspace);}' unless defined(&V_tcp_recvspace);
	eval 'sub V_path_mtu_discovery () { &VNET( &path_mtu_discovery);}' unless defined(&V_path_mtu_discovery);
	eval 'sub V_tcp_do_rfc3465 () { &VNET( &tcp_do_rfc3465);}' unless defined(&V_tcp_do_rfc3465);
	eval 'sub V_tcp_abc_l_var () { &VNET( &tcp_abc_l_var);}' unless defined(&V_tcp_abc_l_var);
	eval 'sub V_tcp_do_sack () { &VNET( &tcp_do_sack);}' unless defined(&V_tcp_do_sack);
	eval 'sub V_tcp_sc_rst_sock_fail () { &VNET( &tcp_sc_rst_sock_fail);}' unless defined(&V_tcp_sc_rst_sock_fail);
	eval 'sub V_tcp_do_ecn () { &VNET( &tcp_do_ecn);}' unless defined(&V_tcp_do_ecn);
	eval 'sub V_tcp_ecn_maxretries () { &VNET( &tcp_ecn_maxretries);}' unless defined(&V_tcp_ecn_maxretries);
	eval 'sub V_tcp_hhh () { &VNET( &tcp_hhh);}' unless defined(&V_tcp_hhh);
	eval 'sub V_tcp_do_rfc6675_pipe () { &VNET( &tcp_do_rfc6675_pipe);}' unless defined(&V_tcp_do_rfc6675_pipe);
	if(defined(&VIMAGE)) {
	}
	if(defined(&VIMAGE)) {
	}
	eval 'sub tcp_fields_to_host {
	    my($th) = @_;
    	    eval q({  ($th->{th_seq}) =  &ntohl( ($th->{th_seq}));  ($th->{th_ack}) =  &ntohl( ($th->{th_ack}));  ($th->{th_win}) =  &ntohs( ($th->{th_win}));  ($th->{th_urp}) =  &ntohs( ($th->{th_urp})); });
	}' unless defined(&tcp_fields_to_host);
	eval 'sub tcp_fields_to_net {
	    my($th) = @_;
    	    eval q({  ($th->{th_seq}) =  &htonl( ($th->{th_seq}));  ($th->{th_ack}) =  &htonl( ($th->{th_ack}));  ($th->{th_win}) =  &htons( ($th->{th_win}));  ($th->{th_urp}) =  &htons( ($th->{th_urp})); });
	}' unless defined(&tcp_fields_to_net);
    }
}
1;
