require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET6_IP6_VAR_H_)) {
    eval 'sub _NETINET6_IP6_VAR_H_ () {1;}' unless defined(&_NETINET6_IP6_VAR_H_);
    if(defined(&notyet)) {
    }
    eval 'sub IP6_REASS_MBUF {
        my($ip6af) = @_;
	    eval q((*(($ip6af)-> &ip6af_m)));
    }' unless defined(&IP6_REASS_MBUF);
    eval 'sub ip6po_rthdr () { ($ip6po_rhinfo->{ip6po_rhi_rthdr});}' unless defined(&ip6po_rthdr);
    eval 'sub ip6po_route () { ($ip6po_rhinfo->{ip6po_rhi_route});}' unless defined(&ip6po_route);
    eval 'sub ip6po_nexthop () { ($ip6po_nhinfo->{ip6po_nhi_nexthop});}' unless defined(&ip6po_nexthop);
    eval 'sub ip6po_nextroute () { ($ip6po_nhinfo->{ip6po_nhi_route});}' unless defined(&ip6po_nextroute);
    eval 'sub IP6PO_MINMTU_MCASTONLY () {-1;}' unless defined(&IP6PO_MINMTU_MCASTONLY);
    eval 'sub IP6PO_MINMTU_DISABLE () {0;}' unless defined(&IP6PO_MINMTU_DISABLE);
    eval 'sub IP6PO_MINMTU_ALL () {1;}' unless defined(&IP6PO_MINMTU_ALL);
    eval 'sub IP6PO_TEMPADDR_SYSTEM () {-1;}' unless defined(&IP6PO_TEMPADDR_SYSTEM);
    eval 'sub IP6PO_TEMPADDR_NOTPREFER () {0;}' unless defined(&IP6PO_TEMPADDR_NOTPREFER);
    eval 'sub IP6PO_TEMPADDR_PREFER () {1;}' unless defined(&IP6PO_TEMPADDR_PREFER);
    if(0) {
	eval 'sub IP6PO_REACHCONF () {0x1;}' unless defined(&IP6PO_REACHCONF);
	eval 'sub IP6PO_MINMTU () {0x2;}' unless defined(&IP6PO_MINMTU);
    }
    eval 'sub IP6PO_DONTFRAG () {0x4;}' unless defined(&IP6PO_DONTFRAG);
    eval 'sub IP6PO_USECOA () {0x8;}' unless defined(&IP6PO_USECOA);
    eval 'sub IP6S_HDRCNT () {256;}' unless defined(&IP6S_HDRCNT);
    eval 'sub IP6S_M2MMAX () {32;}' unless defined(&IP6S_M2MMAX);
    eval 'sub IP6S_RULESMAX () {16;}' unless defined(&IP6S_RULESMAX);
    eval 'sub IP6S_SCOPECNT () {16;}' unless defined(&IP6S_SCOPECNT);
    if(defined(&_KERNEL)) {
	require 'sys/counter.ph';
	eval 'sub IP6STAT_ADD {
	    my($name, $val) = @_;
    	    eval q( &VNET_PCPUSTAT_ADD(\'struct ip6stat\',  &ip6stat, $name, ($val)));
	}' unless defined(&IP6STAT_ADD);
	eval 'sub IP6STAT_SUB {
	    my($name, $val) = @_;
    	    eval q( &IP6STAT_ADD($name, -($val)));
	}' unless defined(&IP6STAT_SUB);
	eval 'sub IP6STAT_INC {
	    my($name) = @_;
    	    eval q( &IP6STAT_ADD($name, 1));
	}' unless defined(&IP6STAT_INC);
	eval 'sub IP6STAT_DEC {
	    my($name) = @_;
    	    eval q( &IP6STAT_SUB($name, 1));
	}' unless defined(&IP6STAT_DEC);
    }
    if(defined(&_KERNEL)) {
	eval 'sub IPV6_UNSPECSRC () {0x1;}' unless defined(&IPV6_UNSPECSRC);
	eval 'sub IPV6_FORWARDING () {0x2;}' unless defined(&IPV6_FORWARDING);
	eval 'sub IPV6_MINMTU () {0x4;}' unless defined(&IPV6_MINMTU);
	if(defined(&__NO_STRICT_ALIGNMENT)) {
	    eval 'sub IP6_HDR_ALIGNED_P {
	        my($ip) = @_;
    		eval q(1);
	    }' unless defined(&IP6_HDR_ALIGNED_P);
	} else {
	    eval 'sub IP6_HDR_ALIGNED_P {
	        my($ip) = @_;
    		eval q((((( &intptr_t) ($ip)) & 3) == 0));
	    }' unless defined(&IP6_HDR_ALIGNED_P);
	}
	eval 'sub V_ip6_defhlim () { &VNET( &ip6_defhlim);}' unless defined(&V_ip6_defhlim);
	eval 'sub V_ip6_defmcasthlim () { &VNET( &ip6_defmcasthlim);}' unless defined(&V_ip6_defmcasthlim);
	eval 'sub V_ip6_forwarding () { &VNET( &ip6_forwarding);}' unless defined(&V_ip6_forwarding);
	eval 'sub V_ip6_use_deprecated () { &VNET( &ip6_use_deprecated);}' unless defined(&V_ip6_use_deprecated);
	eval 'sub V_ip6_rr_prune () { &VNET( &ip6_rr_prune);}' unless defined(&V_ip6_rr_prune);
	eval 'sub V_ip6_mcast_pmtu () { &VNET( &ip6_mcast_pmtu);}' unless defined(&V_ip6_mcast_pmtu);
	eval 'sub V_ip6_v6only () { &VNET( &ip6_v6only);}' unless defined(&V_ip6_v6only);
	eval 'sub V_ip6_mrouter () { &VNET( &ip6_mrouter);}' unless defined(&V_ip6_mrouter);
	eval 'sub V_ip6_sendredirects () { &VNET( &ip6_sendredirects);}' unless defined(&V_ip6_sendredirects);
	eval 'sub V_ip6_maxfragpackets () { &VNET( &ip6_maxfragpackets);}' unless defined(&V_ip6_maxfragpackets);
	eval 'sub V_ip6_maxfrags () { &VNET( &ip6_maxfrags);}' unless defined(&V_ip6_maxfrags);
	eval 'sub V_ip6_accept_rtadv () { &VNET( &ip6_accept_rtadv);}' unless defined(&V_ip6_accept_rtadv);
	eval 'sub V_ip6_no_radr () { &VNET( &ip6_no_radr);}' unless defined(&V_ip6_no_radr);
	eval 'sub V_ip6_norbit_raif () { &VNET( &ip6_norbit_raif);}' unless defined(&V_ip6_norbit_raif);
	eval 'sub V_ip6_rfc6204w3 () { &VNET( &ip6_rfc6204w3);}' unless defined(&V_ip6_rfc6204w3);
	eval 'sub V_ip6_log_interval () { &VNET( &ip6_log_interval);}' unless defined(&V_ip6_log_interval);
	eval 'sub V_ip6_log_time () { &VNET( &ip6_log_time);}' unless defined(&V_ip6_log_time);
	eval 'sub V_ip6_hdrnestlimit () { &VNET( &ip6_hdrnestlimit);}' unless defined(&V_ip6_hdrnestlimit);
	eval 'sub V_ip6_dad_count () { &VNET( &ip6_dad_count);}' unless defined(&V_ip6_dad_count);
	eval 'sub V_ip6_auto_flowlabel () { &VNET( &ip6_auto_flowlabel);}' unless defined(&V_ip6_auto_flowlabel);
	eval 'sub V_ip6_auto_linklocal () { &VNET( &ip6_auto_linklocal);}' unless defined(&V_ip6_auto_linklocal);
	eval 'sub V_ip6_use_tempaddr () { &VNET( &ip6_use_tempaddr);}' unless defined(&V_ip6_use_tempaddr);
	eval 'sub V_ip6_prefer_tempaddr () { &VNET( &ip6_prefer_tempaddr);}' unless defined(&V_ip6_prefer_tempaddr);
	eval 'sub V_ip6_use_defzone () { &VNET( &ip6_use_defzone);}' unless defined(&V_ip6_use_defzone);
	eval 'sub V_inet6_pfil_hook () { &VNET( &inet6_pfil_hook);}' unless defined(&V_inet6_pfil_hook);
	if(defined(&IPSTEALTH)) {
	    eval 'sub V_ip6stealth () { &VNET( &ip6stealth);}' unless defined(&V_ip6stealth);
	}
    }
}
1;
