require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET6_MLD6_VAR_H_)) {
    eval 'sub _NETINET6_MLD6_VAR_H_ () {1;}' unless defined(&_NETINET6_MLD6_VAR_H_);
    eval 'sub MLD_NOT_MEMBER () {0;}' unless defined(&MLD_NOT_MEMBER);
    eval 'sub MLD_SILENT_MEMBER () {1;}' unless defined(&MLD_SILENT_MEMBER);
    eval 'sub MLD_REPORTING_MEMBER () {2;}' unless defined(&MLD_REPORTING_MEMBER);
    eval 'sub MLD_IDLE_MEMBER () {3;}' unless defined(&MLD_IDLE_MEMBER);
    eval 'sub MLD_LAZY_MEMBER () {4;}' unless defined(&MLD_LAZY_MEMBER);
    eval 'sub MLD_SLEEPING_MEMBER () {5;}' unless defined(&MLD_SLEEPING_MEMBER);
    eval 'sub MLD_AWAKENING_MEMBER () {6;}' unless defined(&MLD_AWAKENING_MEMBER);
    eval 'sub MLD_G_QUERY_PENDING_MEMBER () {7;}' unless defined(&MLD_G_QUERY_PENDING_MEMBER);
    eval 'sub MLD_SG_QUERY_PENDING_MEMBER () {8;}' unless defined(&MLD_SG_QUERY_PENDING_MEMBER);
    eval 'sub MLD_LEAVING_MEMBER () {9;}' unless defined(&MLD_LEAVING_MEMBER);
    eval 'sub MLD_VERSION_NONE () {0;}' unless defined(&MLD_VERSION_NONE);
    eval 'sub MLD_VERSION_1 () {1;}' unless defined(&MLD_VERSION_1);
    eval 'sub MLD_VERSION_2 () {2;}' unless defined(&MLD_VERSION_2);
    eval 'sub MLD_RV_INIT () {2;}' unless defined(&MLD_RV_INIT);
    eval 'sub MLD_RV_MIN () {1;}' unless defined(&MLD_RV_MIN);
    eval 'sub MLD_RV_MAX () {7;}' unless defined(&MLD_RV_MAX);
    eval 'sub MLD_QI_INIT () {125;}' unless defined(&MLD_QI_INIT);
    eval 'sub MLD_QI_MIN () {1;}' unless defined(&MLD_QI_MIN);
    eval 'sub MLD_QI_MAX () {255;}' unless defined(&MLD_QI_MAX);
    eval 'sub MLD_QRI_INIT () {10;}' unless defined(&MLD_QRI_INIT);
    eval 'sub MLD_QRI_MIN () {1;}' unless defined(&MLD_QRI_MIN);
    eval 'sub MLD_QRI_MAX () {255;}' unless defined(&MLD_QRI_MAX);
    eval 'sub MLD_URI_INIT () {3;}' unless defined(&MLD_URI_INIT);
    eval 'sub MLD_URI_MIN () {0;}' unless defined(&MLD_URI_MIN);
    eval 'sub MLD_URI_MAX () {10;}' unless defined(&MLD_URI_MAX);
    eval 'sub MLD_MAX_GS_SOURCES () {256;}' unless defined(&MLD_MAX_GS_SOURCES);
    eval 'sub MLD_MAX_G_GS_PACKETS () {8;}' unless defined(&MLD_MAX_G_GS_PACKETS);
    eval 'sub MLD_MAX_STATE_CHANGE_PACKETS () {8;}' unless defined(&MLD_MAX_STATE_CHANGE_PACKETS);
    eval 'sub MLD_MAX_RESPONSE_PACKETS () {16;}' unless defined(&MLD_MAX_RESPONSE_PACKETS);
    eval 'sub MLD_MAX_RESPONSE_BURST () {4;}' unless defined(&MLD_MAX_RESPONSE_BURST);
    eval 'sub MLD_RESPONSE_BURST_INTERVAL () {( &PR_FASTHZ / 2);}' unless defined(&MLD_RESPONSE_BURST_INTERVAL);
    eval 'sub M_MLDV1 () { &M_PROTO1;}' unless defined(&M_MLDV1);
    eval 'sub M_GROUPREC () { &M_PROTO3;}' unless defined(&M_GROUPREC);
    eval 'sub MLD_MTUSPACE () {($sizeof{\'struct ip6_hdr\'} + $sizeof{\'struct mld_raopt\'} + $sizeof{\'struct icmp6_hdr\'});}' unless defined(&MLD_MTUSPACE);
    eval 'sub MLIF_SILENT () {0x1;}' unless defined(&MLIF_SILENT);
    eval 'sub MLIF_USEALLOW () {0x2;}' unless defined(&MLIF_USEALLOW);
    if(defined(&_KERNEL)) {
	eval 'sub MLD_RANDOM_DELAY {
	    my($X) = @_;
    	    eval q(( &arc4random() % ($X) + 1));
	}' unless defined(&MLD_RANDOM_DELAY);
	eval 'sub MLD_MAX_STATE_CHANGES () {24;}' unless defined(&MLD_MAX_STATE_CHANGES);
	eval 'sub MLD_LOCK_INIT () {
	    eval q( &mtx_init( &mld_mtx, \\"mld_mtx\\",  &NULL,  &MTX_DEF));
	}' unless defined(&MLD_LOCK_INIT);
	eval 'sub MLD_LOCK_DESTROY () {
	    eval q( &mtx_destroy( &mld_mtx));
	}' unless defined(&MLD_LOCK_DESTROY);
	eval 'sub MLD_LOCK () {
	    eval q( &mtx_lock( &mld_mtx));
	}' unless defined(&MLD_LOCK);
	eval 'sub MLD_LOCK_ASSERT () {
	    eval q( &mtx_assert( &mld_mtx,  &MA_OWNED));
	}' unless defined(&MLD_LOCK_ASSERT);
	eval 'sub MLD_UNLOCK () {
	    eval q( &mtx_unlock( &mld_mtx));
	}' unless defined(&MLD_UNLOCK);
	eval 'sub MLD_UNLOCK_ASSERT () {
	    eval q( &mtx_assert( &mld_mtx,  &MA_NOTOWNED));
	}' unless defined(&MLD_UNLOCK_ASSERT);
	eval 'sub MLD_IFINFO {
	    my($ifp) = @_;
    	    eval q(((($ifp)-> $if_afdata[ &AF_INET6])-> &mld_ifinfo));
	}' unless defined(&MLD_IFINFO);
	if(defined(&SYSCTL_DECL)) {
	}
    }
}
1;
