require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET6_ND6_H_)) {
    eval 'sub _NETINET6_ND6_H_ () {1;}' unless defined(&_NETINET6_ND6_H_);
    unless(defined(&RTF_ANNOUNCE)) {
	eval 'sub RTF_ANNOUNCE () { &RTF_PROTO2;}' unless defined(&RTF_ANNOUNCE);
    }
    require 'sys/queue.ph';
    require 'sys/callout.ph';
    eval 'sub ND6_LLINFO_NOSTATE () {-2;}' unless defined(&ND6_LLINFO_NOSTATE);
    eval 'sub ND6_LLINFO_INCOMPLETE () {0;}' unless defined(&ND6_LLINFO_INCOMPLETE);
    eval 'sub ND6_LLINFO_REACHABLE () {1;}' unless defined(&ND6_LLINFO_REACHABLE);
    eval 'sub ND6_LLINFO_STALE () {2;}' unless defined(&ND6_LLINFO_STALE);
    eval 'sub ND6_LLINFO_DELAY () {3;}' unless defined(&ND6_LLINFO_DELAY);
    eval 'sub ND6_LLINFO_PROBE () {4;}' unless defined(&ND6_LLINFO_PROBE);
    eval 'sub ND6_IS_LLINFO_PROBREACH {
        my($n) = @_;
	    eval q((($n)-> &ln_state >  &ND6_LLINFO_INCOMPLETE));
    }' unless defined(&ND6_IS_LLINFO_PROBREACH);
    eval 'sub ND6_LLINFO_PERMANENT {
        my($n) = @_;
	    eval q(((($n)-> &la_expire == 0)  && (($n)-> &ln_state >  &ND6_LLINFO_INCOMPLETE)));
    }' unless defined(&ND6_LLINFO_PERMANENT);
    eval 'sub ND6_IFF_PERFORMNUD () {0x1;}' unless defined(&ND6_IFF_PERFORMNUD);
    eval 'sub ND6_IFF_ACCEPT_RTADV () {0x2;}' unless defined(&ND6_IFF_ACCEPT_RTADV);
    eval 'sub ND6_IFF_PREFER_SOURCE () {0x4;}' unless defined(&ND6_IFF_PREFER_SOURCE);
    eval 'sub ND6_IFF_IFDISABLED () {0x8;}' unless defined(&ND6_IFF_IFDISABLED);
    eval 'sub ND6_IFF_DONT_SET_IFROUTE () {0x10;}' unless defined(&ND6_IFF_DONT_SET_IFROUTE);
    eval 'sub ND6_IFF_AUTO_LINKLOCAL () {0x20;}' unless defined(&ND6_IFF_AUTO_LINKLOCAL);
    eval 'sub ND6_IFF_NO_RADR () {0x40;}' unless defined(&ND6_IFF_NO_RADR);
    eval 'sub ND6_IFF_NO_PREFER_IFACE () {0x80;}' unless defined(&ND6_IFF_NO_PREFER_IFACE);
    eval 'sub ND6_IFF_NO_DAD () {0x100;}' unless defined(&ND6_IFF_NO_DAD);
    if(defined(&_KERNEL)) {
	eval 'sub ND_IFINFO {
	    my($ifp) = @_;
    	    eval q(((($ifp)-> $if_afdata[ &AF_INET6])-> &nd_ifinfo));
	}' unless defined(&ND_IFINFO);
	eval 'sub IN6_LINKMTU {
	    my($ifp) = @_;
    	    eval q((( &ND_IFINFO($ifp)-> &linkmtu  &&  &ND_IFINFO($ifp)-> &linkmtu < ($ifp)-> &if_mtu) ?  &ND_IFINFO($ifp)-> &linkmtu : (( &ND_IFINFO($ifp)-> &maxmtu  &&  &ND_IFINFO($ifp)-> &maxmtu < ($ifp)-> &if_mtu) ?  &ND_IFINFO($ifp)-> &maxmtu : ($ifp)-> &if_mtu)));
	}' unless defined(&IN6_LINKMTU);
    }
    eval 'sub DRLSTSIZ () {10;}' unless defined(&DRLSTSIZ);
    eval 'sub PRLSTSIZ () {10;}' unless defined(&PRLSTSIZ);
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
    eval 'sub NDPRF_ONLINK () {0x1;}' unless defined(&NDPRF_ONLINK);
    eval 'sub NDPRF_DETACHED () {0x2;}' unless defined(&NDPRF_DETACHED);
    eval 'sub MAX_RTR_SOLICITATION_DELAY () {1;}' unless defined(&MAX_RTR_SOLICITATION_DELAY);
    eval 'sub RTR_SOLICITATION_INTERVAL () {4;}' unless defined(&RTR_SOLICITATION_INTERVAL);
    eval 'sub MAX_RTR_SOLICITATIONS () {3;}' unless defined(&MAX_RTR_SOLICITATIONS);
    eval 'sub ND6_INFINITE_LIFETIME () {0xffffffff;}' unless defined(&ND6_INFINITE_LIFETIME);
    if(defined(&_KERNEL)) {
	eval 'sub MAX_REACHABLE_TIME () {3600000;}' unless defined(&MAX_REACHABLE_TIME);
	eval 'sub REACHABLE_TIME () {30000;}' unless defined(&REACHABLE_TIME);
	eval 'sub RETRANS_TIMER () {1000;}' unless defined(&RETRANS_TIMER);
	eval 'sub MIN_RANDOM_FACTOR () {512;}' unless defined(&MIN_RANDOM_FACTOR);
	eval 'sub MAX_RANDOM_FACTOR () {1536;}' unless defined(&MAX_RANDOM_FACTOR);
	eval 'sub DEF_TEMP_VALID_LIFETIME () {604800;}' unless defined(&DEF_TEMP_VALID_LIFETIME);
	eval 'sub DEF_TEMP_PREFERRED_LIFETIME () {86400;}' unless defined(&DEF_TEMP_PREFERRED_LIFETIME);
	eval 'sub TEMPADDR_REGEN_ADVANCE () {5;}' unless defined(&TEMPADDR_REGEN_ADVANCE);
	eval 'sub MAX_TEMP_DESYNC_FACTOR () {600;}' unless defined(&MAX_TEMP_DESYNC_FACTOR);
	eval 'sub ND_COMPUTE_RTIME {
	    my($x) = @_;
    	    eval q(((( &MIN_RANDOM_FACTOR * ($x >> 10)) + ( &arc4random() & (( &MAX_RANDOM_FACTOR -  &MIN_RANDOM_FACTOR) * ($x >> 10)))) /1000));
	}' unless defined(&ND_COMPUTE_RTIME);
	eval 'sub ndpr_raf () { &ndpr_flags;}' unless defined(&ndpr_raf);
	eval 'sub ndpr_raf_onlink () { ($ndpr_flags->{onlink});}' unless defined(&ndpr_raf_onlink);
	eval 'sub ndpr_raf_auto () { ($ndpr_flags->{autonomous});}' unless defined(&ndpr_raf_auto);
	eval 'sub ndpr_raf_router () { ($ndpr_flags->{router});}' unless defined(&ndpr_raf_router);
	eval 'sub prm_raf_onlink () { ($prm_flags->{prf_ra}->{onlink});}' unless defined(&prm_raf_onlink);
	eval 'sub prm_raf_auto () { ($prm_flags->{prf_ra}->{autonomous});}' unless defined(&prm_raf_auto);
	eval 'sub prm_statef_onlink () { ($prm_flags->{prf_state}->{onlink});}' unless defined(&prm_statef_onlink);
	eval 'sub prm_rrf_decrvalid () { ($prm_flags->{prf_rr}->{decrvalid});}' unless defined(&prm_rrf_decrvalid);
	eval 'sub prm_rrf_decrprefd () { ($prm_flags->{prf_rr}->{decrprefd});}' unless defined(&prm_rrf_decrprefd);
	if(defined(&MALLOC_DECLARE)) {
	}
	eval 'sub V_nd6_prune () { &VNET( &nd6_prune);}' unless defined(&V_nd6_prune);
	eval 'sub V_nd6_delay () { &VNET( &nd6_delay);}' unless defined(&V_nd6_delay);
	eval 'sub V_nd6_umaxtries () { &VNET( &nd6_umaxtries);}' unless defined(&V_nd6_umaxtries);
	eval 'sub V_nd6_mmaxtries () { &VNET( &nd6_mmaxtries);}' unless defined(&V_nd6_mmaxtries);
	eval 'sub V_nd6_useloopback () { &VNET( &nd6_useloopback);}' unless defined(&V_nd6_useloopback);
	eval 'sub V_nd6_maxnudhint () { &VNET( &nd6_maxnudhint);}' unless defined(&V_nd6_maxnudhint);
	eval 'sub V_nd6_gctimer () { &VNET( &nd6_gctimer);}' unless defined(&V_nd6_gctimer);
	eval 'sub V_nd_defrouter () { &VNET( &nd_defrouter);}' unless defined(&V_nd_defrouter);
	eval 'sub V_nd_prefix () { &VNET( &nd_prefix);}' unless defined(&V_nd_prefix);
	eval 'sub V_nd6_debug () { &VNET( &nd6_debug);}' unless defined(&V_nd6_debug);
	eval 'sub V_nd6_onlink_ns_rfc4861 () { &VNET( &nd6_onlink_ns_rfc4861);}' unless defined(&V_nd6_onlink_ns_rfc4861);
	eval 'sub V_nd6_lock () { &VNET( &nd6_lock);}' unless defined(&V_nd6_lock);
	eval 'sub V_nd6_list_genid () { &VNET( &nd6_list_genid);}' unless defined(&V_nd6_list_genid);
	eval 'sub ND6_RLOCK () {
	    eval q( &rw_rlock( &V_nd6_lock));
	}' unless defined(&ND6_RLOCK);
	eval 'sub ND6_RUNLOCK () {
	    eval q( &rw_runlock( &V_nd6_lock));
	}' unless defined(&ND6_RUNLOCK);
	eval 'sub ND6_WLOCK () {
	    eval q( &rw_wlock( &V_nd6_lock));
	}' unless defined(&ND6_WLOCK);
	eval 'sub ND6_WUNLOCK () {
	    eval q( &rw_wunlock( &V_nd6_lock));
	}' unless defined(&ND6_WUNLOCK);
	eval 'sub ND6_TRY_UPGRADE () {
	    eval q( &rw_try_upgrade( &V_nd6_lock));
	}' unless defined(&ND6_TRY_UPGRADE);
	eval 'sub ND6_WLOCK_ASSERT () {
	    eval q( &rw_assert( &V_nd6_lock,  &RA_WLOCKED));
	}' unless defined(&ND6_WLOCK_ASSERT);
	eval 'sub ND6_RLOCK_ASSERT () {
	    eval q( &rw_assert( &V_nd6_lock,  &RA_RLOCKED));
	}' unless defined(&ND6_RLOCK_ASSERT);
	eval 'sub ND6_LOCK_ASSERT () {
	    eval q( &rw_assert( &V_nd6_lock,  &RA_LOCKED));
	}' unless defined(&ND6_LOCK_ASSERT);
	eval 'sub ND6_UNLOCK_ASSERT () {
	    eval q( &rw_assert( &V_nd6_lock,  &RA_UNLOCKED));
	}' unless defined(&ND6_UNLOCK_ASSERT);
	eval 'sub V_nd6_onlink_mtx () { &VNET( &nd6_onlink_mtx);}' unless defined(&V_nd6_onlink_mtx);
	eval 'sub ND6_ONLINK_LOCK () {
	    eval q( &mtx_lock( &V_nd6_onlink_mtx));
	}' unless defined(&ND6_ONLINK_LOCK);
	eval 'sub ND6_ONLINK_TRYLOCK () {
	    eval q( &mtx_trylock( &V_nd6_onlink_mtx));
	}' unless defined(&ND6_ONLINK_TRYLOCK);
	eval 'sub ND6_ONLINK_UNLOCK () {
	    eval q( &mtx_unlock( &V_nd6_onlink_mtx));
	}' unless defined(&ND6_ONLINK_UNLOCK);
	eval 'sub ND6_ONLINK_LOCK_ASSERT () {
	    eval q( &mtx_assert( &V_nd6_onlink_mtx,  &MA_OWNED));
	}' unless defined(&ND6_ONLINK_LOCK_ASSERT);
	eval 'sub ND6_ONLINK_UNLOCK_ASSERT () {
	    eval q( &mtx_assert( &V_nd6_onlink_mtx,  &MA_NOTOWNED));
	}' unless defined(&ND6_ONLINK_UNLOCK_ASSERT);
	eval 'sub nd6log {
	    my($x) = @_;
    	    eval q( &do {  &if ( &V_nd6_debug)  &log $x; }  &while ( 0));
	}' unless defined(&nd6log);
	eval 'sub V_nd6_defifindex () { &VNET( &nd6_defifindex);}' unless defined(&V_nd6_defifindex);
	eval 'sub V_ip6_desync_factor () { &VNET( &ip6_desync_factor);}' unless defined(&V_ip6_desync_factor);
	eval 'sub V_ip6_temp_preferred_lifetime () { &VNET( &ip6_temp_preferred_lifetime);}' unless defined(&V_ip6_temp_preferred_lifetime);
	eval 'sub V_ip6_temp_valid_lifetime () { &VNET( &ip6_temp_valid_lifetime);}' unless defined(&V_ip6_temp_valid_lifetime);
	eval 'sub V_ip6_temp_regen_advance () { &VNET( &ip6_temp_regen_advance);}' unless defined(&V_ip6_temp_regen_advance);
	eval 'sub nd_opts_src_lladdr () { ($nd_opt_each->{src_lladdr});}' unless defined(&nd_opts_src_lladdr);
	eval 'sub nd_opts_tgt_lladdr () { ($nd_opt_each->{tgt_lladdr});}' unless defined(&nd_opts_tgt_lladdr);
	eval 'sub nd_opts_pi () { ($nd_opt_each->{pi_beg});}' unless defined(&nd_opts_pi);
	eval 'sub nd_opts_pi_end () { ($nd_opt_each->{pi_end});}' unless defined(&nd_opts_pi_end);
	eval 'sub nd_opts_rh () { ($nd_opt_each->{rh});}' unless defined(&nd_opts_rh);
	eval 'sub nd_opts_mtu () { ($nd_opt_each->{mtu});}' unless defined(&nd_opts_mtu);
	eval 'sub nd_opts_nonce () { ($nd_opt_each->{nonce});}' unless defined(&nd_opts_nonce);
	eval 'sub nd_opts_search () { ($nd_opt_each->{search});}' unless defined(&nd_opts_search);
	eval 'sub nd_opts_last () { ($nd_opt_each->{last});}' unless defined(&nd_opts_last);
	eval 'sub nd_opts_done () { ($nd_opt_each->{done});}' unless defined(&nd_opts_done);
	if(defined(&VIMAGE)) {
	}
    }
}
1;
