require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETIPSEC_IPCOMP_VAR_H_)) {
    eval 'sub _NETIPSEC_IPCOMP_VAR_H_ () {1;}' unless defined(&_NETIPSEC_IPCOMP_VAR_H_);
    eval 'sub IPCOMP_ALG_MAX () {8;}' unless defined(&IPCOMP_ALG_MAX);
    eval 'sub IPCOMPSTAT_VERSION () {2;}' unless defined(&IPCOMPSTAT_VERSION);
    if(defined(&_KERNEL)) {
	require 'sys/counter.ph';
	eval 'sub IPCOMPSTAT_ADD {
	    my($name, $val) = @_;
    	    eval q( &VNET_PCPUSTAT_ADD(\'struct ipcompstat\',  &ipcompstat, $name, ($val)));
	}' unless defined(&IPCOMPSTAT_ADD);
	eval 'sub IPCOMPSTAT_INC {
	    my($name) = @_;
    	    eval q( &IPCOMPSTAT_ADD($name, 1));
	}' unless defined(&IPCOMPSTAT_INC);
	eval 'sub V_ipcomp_enable () { &VNET( &ipcomp_enable);}' unless defined(&V_ipcomp_enable);
    }
}
1;
