require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETIPSEC_KEY_DEBUG_H_)) {
    eval 'sub _NETIPSEC_KEY_DEBUG_H_ () {1;}' unless defined(&_NETIPSEC_KEY_DEBUG_H_);
    if(defined(&_KERNEL)) {
	eval 'sub KEYDEBUG_STAMP () {0x1;}' unless defined(&KEYDEBUG_STAMP);
	eval 'sub KEYDEBUG_DATA () {0x2;}' unless defined(&KEYDEBUG_DATA);
	eval 'sub KEYDEBUG_DUMP () {0x4;}' unless defined(&KEYDEBUG_DUMP);
	eval 'sub KEYDEBUG_KEY () {0x10;}' unless defined(&KEYDEBUG_KEY);
	eval 'sub KEYDEBUG_ALG () {0x20;}' unless defined(&KEYDEBUG_ALG);
	eval 'sub KEYDEBUG_IPSEC () {0x40;}' unless defined(&KEYDEBUG_IPSEC);
	eval 'sub KEYDEBUG_KEY_STAMP () {( &KEYDEBUG_KEY |  &KEYDEBUG_STAMP);}' unless defined(&KEYDEBUG_KEY_STAMP);
	eval 'sub KEYDEBUG_KEY_DATA () {( &KEYDEBUG_KEY |  &KEYDEBUG_DATA);}' unless defined(&KEYDEBUG_KEY_DATA);
	eval 'sub KEYDEBUG_KEY_DUMP () {( &KEYDEBUG_KEY |  &KEYDEBUG_DUMP);}' unless defined(&KEYDEBUG_KEY_DUMP);
	eval 'sub KEYDEBUG_ALG_STAMP () {( &KEYDEBUG_ALG |  &KEYDEBUG_STAMP);}' unless defined(&KEYDEBUG_ALG_STAMP);
	eval 'sub KEYDEBUG_ALG_DATA () {( &KEYDEBUG_ALG |  &KEYDEBUG_DATA);}' unless defined(&KEYDEBUG_ALG_DATA);
	eval 'sub KEYDEBUG_ALG_DUMP () {( &KEYDEBUG_ALG |  &KEYDEBUG_DUMP);}' unless defined(&KEYDEBUG_ALG_DUMP);
	eval 'sub KEYDEBUG_IPSEC_STAMP () {( &KEYDEBUG_IPSEC |  &KEYDEBUG_STAMP);}' unless defined(&KEYDEBUG_IPSEC_STAMP);
	eval 'sub KEYDEBUG_IPSEC_DATA () {( &KEYDEBUG_IPSEC |  &KEYDEBUG_DATA);}' unless defined(&KEYDEBUG_IPSEC_DATA);
	eval 'sub KEYDEBUG_IPSEC_DUMP () {( &KEYDEBUG_IPSEC |  &KEYDEBUG_DUMP);}' unless defined(&KEYDEBUG_IPSEC_DUMP);
	if(defined(&IPSEC_DEBUG)) {
	    eval 'sub KEYDBG {
	        my($lev, $arg) = @_;
    		eval q( &if (( &V_key_debug_level & ( &KEYDEBUG_  $lev)) == ( &KEYDEBUG_  $lev)) { $arg; });
	    }' unless defined(&KEYDBG);
	} else {
	    eval 'sub KEYDBG {
	        my($lev, $arg) = @_;
    		eval q();
	    }' unless defined(&KEYDBG);
	}
	eval 'sub V_key_debug_level () { &VNET( &key_debug_level);}' unless defined(&V_key_debug_level);
    }
    if(defined(&_KERNEL)) {
    }
}
1;
