require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETIPSEC_KEYDB_H_)) {
    eval 'sub _NETIPSEC_KEYDB_H_ () {1;}' unless defined(&_NETIPSEC_KEYDB_H_);
    if(defined(&_KERNEL)) {
	require 'sys/counter.ph';
	require 'sys/lock.ph';
	require 'sys/mutex.ph';
	require 'netipsec/key_var.ph';
	unless(defined(&_SOCKADDR_UNION_DEFINED)) {
	    eval 'sub _SOCKADDR_UNION_DEFINED () {1;}' unless defined(&_SOCKADDR_UNION_DEFINED);
	}
	eval 'sub IPSEC_NATT_F_OAI () {0x1;}' unless defined(&IPSEC_NATT_F_OAI);
	eval 'sub IPSEC_NATT_F_OAR () {0x2;}' unless defined(&IPSEC_NATT_F_OAR);
	eval 'sub lft_c_allocations () { &lft_c;}' unless defined(&lft_c_allocations);
	eval 'sub lft_c_bytes () { &lft_c + 1;}' unless defined(&lft_c_bytes);
	eval 'sub SECASVAR_LOCK {
	    my($_sav) = @_;
    	    eval q( &mtx_lock(($_sav)-> &lock));
	}' unless defined(&SECASVAR_LOCK);
	eval 'sub SECASVAR_UNLOCK {
	    my($_sav) = @_;
    	    eval q( &mtx_unlock(($_sav)-> &lock));
	}' unless defined(&SECASVAR_UNLOCK);
	eval 'sub SECASVAR_LOCK_ASSERT {
	    my($_sav) = @_;
    	    eval q( &mtx_assert(($_sav)-> &lock,  &MA_OWNED));
	}' unless defined(&SECASVAR_LOCK_ASSERT);
	eval 'sub SAV_ISGCM {
	    my($_sav) = @_;
    	    eval q((($_sav)-> &alg_enc ==  &SADB_X_EALG_AESGCM8 || ($_sav)-> &alg_enc ==  &SADB_X_EALG_AESGCM12 || ($_sav)-> &alg_enc ==  &SADB_X_EALG_AESGCM16));
	}' unless defined(&SAV_ISGCM);
	eval 'sub SAV_ISCTR {
	    my($_sav) = @_;
    	    eval q((($_sav)-> &alg_enc ==  &SADB_X_EALG_AESCTR));
	}' unless defined(&SAV_ISCTR);
	eval 'sub SAV_ISCTRORGCM {
	    my($_sav) = @_;
    	    eval q(( &SAV_ISCTR(($_sav)) ||  &SAV_ISGCM(($_sav))));
	}' unless defined(&SAV_ISCTRORGCM);
	eval 'sub SADB_KILL_INTERVAL () {600;}' unless defined(&SADB_KILL_INTERVAL);
    }
}
1;
