require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETNATM_MSG_UNI_HDR_H_)) {
    eval 'sub _NETNATM_MSG_UNI_HDR_H_ () {1;}' unless defined(&_NETNATM_MSG_UNI_HDR_H_);
    require 'sys/types.ph';
    if(defined(&_KERNEL)) {
	require 'sys/stdint.ph';
    } else {
	require 'stdint.ph';
    }
    require 'netnatm/msg/uni_config.ph';
    eval("sub UNI_PROTO () { 0x09; }") unless defined(&UNI_PROTO);
    eval("sub PNNI_PROTO () { 0xf0; }") unless defined(&PNNI_PROTO);
    eval("sub UNI_UNKNOWN () { 0x100; }") unless defined(&UNI_UNKNOWN);
    eval("sub UNI_ALERTING () { 0x01; }") unless defined(&UNI_ALERTING);
    eval("sub UNI_CALL_PROC () { 0x02; }") unless defined(&UNI_CALL_PROC);
    eval("sub UNI_SETUP () { 0x05; }") unless defined(&UNI_SETUP);
    eval("sub UNI_CONNECT () { 0x07; }") unless defined(&UNI_CONNECT);
    eval("sub UNI_CONNECT_ACK () { 0x0f; }") unless defined(&UNI_CONNECT_ACK);
    eval("sub UNI_RESTART () { 0x46; }") unless defined(&UNI_RESTART);
    eval("sub UNI_RELEASE () { 0x4d; }") unless defined(&UNI_RELEASE);
    eval("sub UNI_RESTART_ACK () { 0x4e; }") unless defined(&UNI_RESTART_ACK);
    eval("sub UNI_RELEASE_COMPL () { 0x5a; }") unless defined(&UNI_RELEASE_COMPL);
    eval("sub UNI_NOTIFY () { 0x6e; }") unless defined(&UNI_NOTIFY);
    eval("sub UNI_STATUS_ENQ () { 0x75; }") unless defined(&UNI_STATUS_ENQ);
    eval("sub UNI_STATUS () { 0x7d; }") unless defined(&UNI_STATUS);
    eval("sub UNI_ADD_PARTY () { 0x80; }") unless defined(&UNI_ADD_PARTY);
    eval("sub UNI_ADD_PARTY_ACK () { 0x81; }") unless defined(&UNI_ADD_PARTY_ACK);
    eval("sub UNI_ADD_PARTY_REJ () { 0x82; }") unless defined(&UNI_ADD_PARTY_REJ);
    eval("sub UNI_DROP_PARTY () { 0x83; }") unless defined(&UNI_DROP_PARTY);
    eval("sub UNI_DROP_PARTY_ACK () { 0x84; }") unless defined(&UNI_DROP_PARTY_ACK);
    eval("sub UNI_PARTY_ALERTING () { 0x85; }") unless defined(&UNI_PARTY_ALERTING);
    eval("sub UNI_LEAF_SETUP_FAIL () { 0x90; }") unless defined(&UNI_LEAF_SETUP_FAIL);
    eval("sub UNI_LEAF_SETUP_REQ () { 0x91; }") unless defined(&UNI_LEAF_SETUP_REQ);
    eval("sub UNI_COBISETUP () { 0x15; }") unless defined(&UNI_COBISETUP);
    eval("sub UNI_FACILITY () { 0x62; }") unless defined(&UNI_FACILITY);
    eval("sub UNI_MODIFY_REQ () { 0x88; }") unless defined(&UNI_MODIFY_REQ);
    eval("sub UNI_MODIFY_ACK () { 0x89; }") unless defined(&UNI_MODIFY_ACK);
    eval("sub UNI_MODIFY_REJ () { 0x8a; }") unless defined(&UNI_MODIFY_REJ);
    eval("sub UNI_CONN_AVAIL () { 0x8b; }") unless defined(&UNI_CONN_AVAIL);
    eval("sub UNI_IE_CAUSE () { 0x08; }") unless defined(&UNI_IE_CAUSE);
    eval("sub UNI_IE_CALLSTATE () { 0x14; }") unless defined(&UNI_IE_CALLSTATE);
    eval("sub UNI_IE_FACILITY () { 0x1C; }") unless defined(&UNI_IE_FACILITY);
    eval("sub UNI_IE_NOTIFY () { 0x27; }") unless defined(&UNI_IE_NOTIFY);
    eval("sub UNI_IE_EETD () { 0x42; }") unless defined(&UNI_IE_EETD);
    eval("sub UNI_IE_CONNED () { 0x4c; }") unless defined(&UNI_IE_CONNED);
    eval("sub UNI_IE_CONNEDSUB () { 0x4d; }") unless defined(&UNI_IE_CONNEDSUB);
    eval("sub UNI_IE_EPREF () { 0x54; }") unless defined(&UNI_IE_EPREF);
    eval("sub UNI_IE_EPSTATE () { 0x55; }") unless defined(&UNI_IE_EPSTATE);
    eval("sub UNI_IE_AAL () { 0x58; }") unless defined(&UNI_IE_AAL);
    eval("sub UNI_IE_TRAFFIC () { 0x59; }") unless defined(&UNI_IE_TRAFFIC);
    eval("sub UNI_IE_CONNID () { 0x5a; }") unless defined(&UNI_IE_CONNID);
    eval("sub UNI_IE_QOS () { 0x5c; }") unless defined(&UNI_IE_QOS);
    eval("sub UNI_IE_BHLI () { 0x5d; }") unless defined(&UNI_IE_BHLI);
    eval("sub UNI_IE_BEARER () { 0x5e; }") unless defined(&UNI_IE_BEARER);
    eval("sub UNI_IE_BLLI () { 0x5f; }") unless defined(&UNI_IE_BLLI);
    eval("sub UNI_IE_LSHIFT () { 0x60; }") unless defined(&UNI_IE_LSHIFT);
    eval("sub UNI_IE_NLSHIFT () { 0x61; }") unless defined(&UNI_IE_NLSHIFT);
    eval("sub UNI_IE_SCOMPL () { 0x62; }") unless defined(&UNI_IE_SCOMPL);
    eval("sub UNI_IE_REPEAT () { 0x63; }") unless defined(&UNI_IE_REPEAT);
    eval("sub UNI_IE_CALLING () { 0x6c; }") unless defined(&UNI_IE_CALLING);
    eval("sub UNI_IE_CALLINGSUB () { 0x6d; }") unless defined(&UNI_IE_CALLINGSUB);
    eval("sub UNI_IE_CALLED () { 0x70; }") unless defined(&UNI_IE_CALLED);
    eval("sub UNI_IE_CALLEDSUB () { 0x71; }") unless defined(&UNI_IE_CALLEDSUB);
    eval("sub UNI_IE_TNS () { 0x78; }") unless defined(&UNI_IE_TNS);
    eval("sub UNI_IE_RESTART () { 0x79; }") unless defined(&UNI_IE_RESTART);
    eval("sub UNI_IE_UU () { 0x7e; }") unless defined(&UNI_IE_UU);
    eval("sub UNI_IE_GIT () { 0x7f; }") unless defined(&UNI_IE_GIT);
    eval("sub UNI_IE_MINTRAFFIC () { 0x81; }") unless defined(&UNI_IE_MINTRAFFIC);
    eval("sub UNI_IE_ATRAFFIC () { 0x82; }") unless defined(&UNI_IE_ATRAFFIC);
    eval("sub UNI_IE_ABRSETUP () { 0x84; }") unless defined(&UNI_IE_ABRSETUP);
    eval("sub UNI_IE_REPORT () { 0x89; }") unless defined(&UNI_IE_REPORT);
    eval("sub UNI_IE_CALLED_SOFT () { 0xe0; }") unless defined(&UNI_IE_CALLED_SOFT);
    eval("sub UNI_IE_CRANKBACK () { 0xe1; }") unless defined(&UNI_IE_CRANKBACK);
    eval("sub UNI_IE_DTL () { 0xe2; }") unless defined(&UNI_IE_DTL);
    eval("sub UNI_IE_CALLING_SOFT () { 0xe3; }") unless defined(&UNI_IE_CALLING_SOFT);
    eval("sub UNI_IE_ABRADD () { 0xe4; }") unless defined(&UNI_IE_ABRADD);
    eval("sub UNI_IE_LIJ_CALLID () { 0xe8; }") unless defined(&UNI_IE_LIJ_CALLID);
    eval("sub UNI_IE_LIJ_PARAM () { 0xe9; }") unless defined(&UNI_IE_LIJ_PARAM);
    eval("sub UNI_IE_LIJ_SEQNO () { 0xea; }") unless defined(&UNI_IE_LIJ_SEQNO);
    eval("sub UNI_IE_CSCOPE () { 0xeb; }") unless defined(&UNI_IE_CSCOPE);
    eval("sub UNI_IE_EXQOS () { 0xec; }") unless defined(&UNI_IE_EXQOS);
    eval("sub UNI_IE_MDCR () { 0xf0; }") unless defined(&UNI_IE_MDCR);
    eval("sub UNI_IE_UNREC () { 0xfe; }") unless defined(&UNI_IE_UNREC);
    eval("sub UNI_CODING_ITU () { 0x0; }") unless defined(&UNI_CODING_ITU);
    eval("sub UNI_CODING_NET () { 0x3; }") unless defined(&UNI_CODING_NET);
    eval("sub UNI_MSGACT_CLEAR () { 0x0; }") unless defined(&UNI_MSGACT_CLEAR);
    eval("sub UNI_MSGACT_IGNORE () { 0x1; }") unless defined(&UNI_MSGACT_IGNORE);
    eval("sub UNI_MSGACT_REPORT () { 0x2; }") unless defined(&UNI_MSGACT_REPORT);
    eval("sub UNI_MSGACT_DEFAULT () { 0x4; }") unless defined(&UNI_MSGACT_DEFAULT);
    eval("sub UNI_IEACT_CLEAR () { 0x00; }") unless defined(&UNI_IEACT_CLEAR);
    eval("sub UNI_IEACT_IGNORE () { 0x01; }") unless defined(&UNI_IEACT_IGNORE);
    eval("sub UNI_IEACT_REPORT () { 0x02; }") unless defined(&UNI_IEACT_REPORT);
    eval("sub UNI_IEACT_MSG_IGNORE () { 0x05; }") unless defined(&UNI_IEACT_MSG_IGNORE);
    eval("sub UNI_IEACT_MSG_REPORT () { 0x06; }") unless defined(&UNI_IEACT_MSG_REPORT);
    eval("sub UNI_IEACT_DEFAULT () { 0x08; }") unless defined(&UNI_IEACT_DEFAULT);
    eval("sub CREF_GLOBAL () { 0; }") unless defined(&CREF_GLOBAL);
    eval("sub CREF_DUMMY () { 0x7fffff; }") unless defined(&CREF_DUMMY);
    eval 'sub UNI_IE_EMPTY () {0x80000000;}' unless defined(&UNI_IE_EMPTY);
    eval 'sub UNI_IE_PRESENT () {0x40000000;}' unless defined(&UNI_IE_PRESENT);
    eval 'sub UNI_IE_ERROR () {0x20000000;}' unless defined(&UNI_IE_ERROR);
    eval 'sub UNI_IE_XXX () {0x10000000;}' unless defined(&UNI_IE_XXX);
    eval 'sub UNI_IE_MASK () {0xf0000000;}' unless defined(&UNI_IE_MASK);
    eval 'sub IE_ISPRESENT {
        my($IE) = @_;
	    eval q(((($IE). ($h->{present}) & ( &UNI_IE_PRESENT| &UNI_IE_EMPTY)) ==  &UNI_IE_PRESENT));
    }' unless defined(&IE_ISPRESENT);
    eval 'sub IE_SETPRESENT {
        my($IE) = @_;
	    eval q((($IE). ($h->{present}) = (($IE). ($h->{present}) & ~ &UNI_IE_MASK) |  &UNI_IE_PRESENT));
    }' unless defined(&IE_SETPRESENT);
    eval 'sub IE_ADDPRESENT {
        my($IE) = @_;
	    eval q((($IE). ($h->{present}) = (($IE). ($h->{present}) & ~ &UNI_IE_EMPTY) |  &UNI_IE_PRESENT));
    }' unless defined(&IE_ADDPRESENT);
    eval 'sub IE_ISEMPTY {
        my($IE) = @_;
	    eval q(((($IE). ($h->{present}) &  &UNI_IE_MASK) == ( &UNI_IE_PRESENT |  &UNI_IE_EMPTY)));
    }' unless defined(&IE_ISEMPTY);
    eval 'sub IE_SETEMPTY {
        my($IE) = @_;
	    eval q((($IE). ($h->{present}) = (($IE). ($h->{present}) & ~ &UNI_IE_MASK) |  &UNI_IE_EMPTY |  &UNI_IE_PRESENT));
    }' unless defined(&IE_SETEMPTY);
    eval 'sub IE_ISERROR {
        my($IE) = @_;
	    eval q(((($IE). ($h->{present}) &  &UNI_IE_MASK) == ( &UNI_IE_PRESENT |  &UNI_IE_ERROR)));
    }' unless defined(&IE_ISERROR);
    eval 'sub IE_SETERROR {
        my($IE) = @_;
	    eval q((($IE). ($h->{present}) = (($IE). ($h->{present}) & ~ &UNI_IE_MASK) |  &UNI_IE_ERROR |  &UNI_IE_PRESENT));
    }' unless defined(&IE_SETERROR);
    eval 'sub IE_ISGOOD {
        my($IE) = @_;
	    eval q(((($IE). ($h->{present}) &  &UNI_IE_MASK) == ( &UNI_IE_PRESENT)));
    }' unless defined(&IE_ISGOOD);
}
1;
