require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETNATM_SAAL_SSCOPDEF_H_)) {
    eval 'sub _NETNATM_SAAL_SSCOPDEF_H_ () {1;}' unless defined(&_NETNATM_SAAL_SSCOPDEF_H_);
    require 'sys/types.ph';
    if(defined(&_KERNEL)) {
	require 'sys/stdint.ph';
    } else {
	require 'stdint.ph';
    }
    eval("sub SSCOP_ESTABLISH_request () { 0; }") unless defined(&SSCOP_ESTABLISH_request);
    eval("sub SSCOP_ESTABLISH_indication () { 1; }") unless defined(&SSCOP_ESTABLISH_indication);
    eval("sub SSCOP_ESTABLISH_response () { 2; }") unless defined(&SSCOP_ESTABLISH_response);
    eval("sub SSCOP_ESTABLISH_confirm () { 3; }") unless defined(&SSCOP_ESTABLISH_confirm);
    eval("sub SSCOP_RELEASE_request () { 4; }") unless defined(&SSCOP_RELEASE_request);
    eval("sub SSCOP_RELEASE_indication () { 5; }") unless defined(&SSCOP_RELEASE_indication);
    eval("sub SSCOP_RELEASE_confirm () { 6; }") unless defined(&SSCOP_RELEASE_confirm);
    eval("sub SSCOP_DATA_request () { 7; }") unless defined(&SSCOP_DATA_request);
    eval("sub SSCOP_DATA_indication () { 8; }") unless defined(&SSCOP_DATA_indication);
    eval("sub SSCOP_UDATA_request () { 9; }") unless defined(&SSCOP_UDATA_request);
    eval("sub SSCOP_UDATA_indication () { 10; }") unless defined(&SSCOP_UDATA_indication);
    eval("sub SSCOP_RECOVER_indication () { 11; }") unless defined(&SSCOP_RECOVER_indication);
    eval("sub SSCOP_RECOVER_response () { 12; }") unless defined(&SSCOP_RECOVER_response);
    eval("sub SSCOP_RESYNC_request () { 13; }") unless defined(&SSCOP_RESYNC_request);
    eval("sub SSCOP_RESYNC_indication () { 14; }") unless defined(&SSCOP_RESYNC_indication);
    eval("sub SSCOP_RESYNC_response () { 15; }") unless defined(&SSCOP_RESYNC_response);
    eval("sub SSCOP_RESYNC_confirm () { 16; }") unless defined(&SSCOP_RESYNC_confirm);
    eval("sub SSCOP_RETRIEVE_request () { 17; }") unless defined(&SSCOP_RETRIEVE_request);
    eval("sub SSCOP_RETRIEVE_indication () { 18; }") unless defined(&SSCOP_RETRIEVE_indication);
    eval("sub SSCOP_RETRIEVE_COMPL_indication () { 19; }") unless defined(&SSCOP_RETRIEVE_COMPL_indication);
    eval("sub SSCOP_MDATA_request () { 0; }") unless defined(&SSCOP_MDATA_request);
    eval("sub SSCOP_MDATA_indication () { 1; }") unless defined(&SSCOP_MDATA_indication);
    eval("sub SSCOP_MERROR_indication () { 2; }") unless defined(&SSCOP_MERROR_indication);
    eval("sub SSCOP_MAXSEQNO () { 0xffffff; }") unless defined(&SSCOP_MAXSEQNO);
    eval("sub SSCOP_RETRIEVE_UNKNOWN () { SSCOP_MAXSEQNO+1; }") unless defined(&SSCOP_RETRIEVE_UNKNOWN);
    eval("sub SSCOP_RETRIEVE_TOTAL () { SSCOP_MAXSEQNO+2; }") unless defined(&SSCOP_RETRIEVE_TOTAL);
    eval("sub SSCOP_IDLE () { 0; }") unless defined(&SSCOP_IDLE);
    eval("sub SSCOP_OUT_PEND () { 1; }") unless defined(&SSCOP_OUT_PEND);
    eval("sub SSCOP_IN_PEND () { 2; }") unless defined(&SSCOP_IN_PEND);
    eval("sub SSCOP_OUT_DIS_PEND () { 3; }") unless defined(&SSCOP_OUT_DIS_PEND);
    eval("sub SSCOP_OUT_RESYNC_PEND () { 4; }") unless defined(&SSCOP_OUT_RESYNC_PEND);
    eval("sub SSCOP_IN_RESYNC_PEND () { 5; }") unless defined(&SSCOP_IN_RESYNC_PEND);
    eval("sub SSCOP_OUT_REC_PEND () { 6; }") unless defined(&SSCOP_OUT_REC_PEND);
    eval("sub SSCOP_REC_PEND () { 7; }") unless defined(&SSCOP_REC_PEND);
    eval("sub SSCOP_IN_REC_PEND () { 8; }") unless defined(&SSCOP_IN_REC_PEND);
    eval("sub SSCOP_READY () { 9; }") unless defined(&SSCOP_READY);
    eval 'sub SSCOP_NSTATES () {10;}' unless defined(&SSCOP_NSTATES);
    eval("sub SSCOP_ROBUST () { 0x0001; }") unless defined(&SSCOP_ROBUST);
    eval("sub SSCOP_POLLREX () { 0x0002; }") unless defined(&SSCOP_POLLREX);
    eval("sub SSCOP_SET_TCC () { 0x0001; }") unless defined(&SSCOP_SET_TCC);
    eval("sub SSCOP_SET_TPOLL () { 0x0002; }") unless defined(&SSCOP_SET_TPOLL);
    eval("sub SSCOP_SET_TKA () { 0x0004; }") unless defined(&SSCOP_SET_TKA);
    eval("sub SSCOP_SET_TNR () { 0x0008; }") unless defined(&SSCOP_SET_TNR);
    eval("sub SSCOP_SET_TIDLE () { 0x0010; }") unless defined(&SSCOP_SET_TIDLE);
    eval("sub SSCOP_SET_MAXK () { 0x0020; }") unless defined(&SSCOP_SET_MAXK);
    eval("sub SSCOP_SET_MAXJ () { 0x0040; }") unless defined(&SSCOP_SET_MAXJ);
    eval("sub SSCOP_SET_MAXCC () { 0x0080; }") unless defined(&SSCOP_SET_MAXCC);
    eval("sub SSCOP_SET_MAXPD () { 0x0100; }") unless defined(&SSCOP_SET_MAXPD);
    eval("sub SSCOP_SET_MAXSTAT () { 0x0200; }") unless defined(&SSCOP_SET_MAXSTAT);
    eval("sub SSCOP_SET_MR () { 0x0400; }") unless defined(&SSCOP_SET_MR);
    eval("sub SSCOP_SET_ROBUST () { 0x0800; }") unless defined(&SSCOP_SET_ROBUST);
    eval("sub SSCOP_SET_POLLREX () { 0x1000; }") unless defined(&SSCOP_SET_POLLREX);
    eval("sub SSCOP_SET_ALLMASK () { 0x1fff; }") unless defined(&SSCOP_SET_ALLMASK);
    eval("sub SSCOP_DBG_USIG () { 0x0001; }") unless defined(&SSCOP_DBG_USIG);
    eval("sub SSCOP_DBG_TIMER () { 0x0002; }") unless defined(&SSCOP_DBG_TIMER);
    eval("sub SSCOP_DBG_BUG () { 0x0004; }") unless defined(&SSCOP_DBG_BUG);
    eval("sub SSCOP_DBG_INSIG () { 0x0008; }") unless defined(&SSCOP_DBG_INSIG);
    eval("sub SSCOP_DBG_STATE () { 0x0010; }") unless defined(&SSCOP_DBG_STATE);
    eval("sub SSCOP_DBG_PDU () { 0x0020; }") unless defined(&SSCOP_DBG_PDU);
    eval("sub SSCOP_DBG_ERR () { 0x0040; }") unless defined(&SSCOP_DBG_ERR);
    eval("sub SSCOP_DBG_EXEC () { 0x0080; }") unless defined(&SSCOP_DBG_EXEC);
    eval("sub SSCOP_DBG_FLOW () { 0x0100; }") unless defined(&SSCOP_DBG_FLOW);
}
1;
