require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETSMB_SMB_RQ_H_)) {
    eval 'sub _NETSMB_SMB_RQ_H_ () {1;}' unless defined(&_NETSMB_SMB_RQ_H_);
    unless(defined(&MB_MSYSTEM)) {
	require 'sys/mchain.ph';
    }
    eval 'sub SMBR_ALLOCED () {0x1;}' unless defined(&SMBR_ALLOCED);
    eval 'sub SMBR_SENT () {0x2;}' unless defined(&SMBR_SENT);
    eval 'sub SMBR_REXMIT () {0x4;}' unless defined(&SMBR_REXMIT);
    eval 'sub SMBR_INTR () {0x8;}' unless defined(&SMBR_INTR);
    eval 'sub SMBR_RESTART () {0x10;}' unless defined(&SMBR_RESTART);
    eval 'sub SMBR_NORESTART () {0x20;}' unless defined(&SMBR_NORESTART);
    eval 'sub SMBR_MULTIPACKET () {0x40;}' unless defined(&SMBR_MULTIPACKET);
    eval 'sub SMBR_INTERNAL () {0x80;}' unless defined(&SMBR_INTERNAL);
    eval 'sub SMBR_XLOCK () {0x100;}' unless defined(&SMBR_XLOCK);
    eval 'sub SMBR_XLOCKWANT () {0x200;}' unless defined(&SMBR_XLOCKWANT);
    eval 'sub SMBT2_ALLSENT () {0x1;}' unless defined(&SMBT2_ALLSENT);
    eval 'sub SMBT2_ALLRECV () {0x2;}' unless defined(&SMBT2_ALLRECV);
    eval 'sub SMBT2_ALLOCED () {0x4;}' unless defined(&SMBT2_ALLOCED);
    eval 'sub SMBT2_RESTART () {0x8;}' unless defined(&SMBT2_RESTART);
    eval 'sub SMBT2_NORESTART () {0x10;}' unless defined(&SMBT2_NORESTART);
    eval 'sub SMBT2_SECONDARY () {0x20;}' unless defined(&SMBT2_SECONDARY);
    eval 'sub SMBRQ_SLOCK {
        my($rqp) = @_;
	    eval q( &smb_sl_lock(($rqp)-> &sr_slock));
    }' unless defined(&SMBRQ_SLOCK);
    eval 'sub SMBRQ_SUNLOCK {
        my($rqp) = @_;
	    eval q( &smb_sl_unlock(($rqp)-> &sr_slock));
    }' unless defined(&SMBRQ_SUNLOCK);
    eval 'sub SMBRQ_SLOCKPTR {
        my($rqp) = @_;
	    eval q((($rqp)-> &sr_slock));
    }' unless defined(&SMBRQ_SLOCKPTR);
    eval("sub SMBRQ_NOTSENT () { 0; }") unless defined(&SMBRQ_NOTSENT);
    eval("sub SMBRQ_SENT () { 1; }") unless defined(&SMBRQ_SENT);
    eval("sub SMBRQ_REPLYRECEIVED () { 2; }") unless defined(&SMBRQ_REPLYRECEIVED);
    eval("sub SMBRQ_NOTIFIED () { 3; }") unless defined(&SMBRQ_NOTIFIED);
}
1;
