require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFSCLIENT_NFSM_SUBS_H_)) {
    eval 'sub _NFSCLIENT_NFSM_SUBS_H_ () {1;}' unless defined(&_NFSCLIENT_NFSM_SUBS_H_);
    require 'nfs/nfs_common.ph';
    eval 'sub nfsv2tov_type {
        my($a) = @_;
	    eval q( $nv2tov_type[ &fxdr_unsigned( &u_int32_t,($a))&0x7]);
    }' unless defined(&nfsv2tov_type);
    eval 'sub nfsm_bcheck {
        my($t1, $mreq) = @_;
	    eval q( &do {  &if ($t1) {  &error = $t1;  &m_freem($mreq);  &goto  &nfsmout; } }  &while (0));
    }' unless defined(&nfsm_bcheck);
    eval 'sub nfsm_fhtom {
        my($v, $v3) = @_;
	    eval q( &do {  &int32_t  &t1;  &t1 =  &nfsm_fhtom_xx(($v), ($v3),  &mb,  &bpos);  &nfsm_bcheck( &t1,  &mreq); }  &while (0));
    }' unless defined(&nfsm_fhtom);
    eval 'sub nfsm_v3attrbuild {
        my($a, $full) = @_;
	    eval q( &nfsm_v3attrbuild_xx($a, $full,  &mb,  &bpos));
    }' unless defined(&nfsm_v3attrbuild);
    eval 'sub nfsm_uiotom {
        my($p, $s) = @_;
	    eval q( &do { \'int\'  &t1;  &t1 =  &nfsm_uiotombuf(($p),  &mb, ($s),  &bpos);  &nfsm_bcheck( &t1,  &mreq); }  &while (0));
    }' unless defined(&nfsm_uiotom);
    eval 'sub nfsm_strtom {
        my($a, $s, $m) = @_;
	    eval q( &do { \'int\'  &t1;  &t1 =  &nfsm_strtom_xx(($a), ($s), ($m),  &mb,  &bpos);  &nfsm_bcheck( &t1,  &mreq); }  &while (0));
    }' unless defined(&nfsm_strtom);
    eval 'sub nfsm_request {
        my($v, $t, $p, $c) = @_;
	    eval q( &do {  &sigset_t  &oldset;  &nfs_set_sigmask($p,  &oldset);  &error =  &nfs_request(($v),  &mreq, ($t), ($p), ($c),  &mrep,  &md,  &dpos);  &nfs_restore_sigmask($p,  &oldset);  &if ( &error != 0) {  &if ( &error &  &NFSERR_RETERR)  &error &= ~ &NFSERR_RETERR;  &else  &goto  &nfsmout; } }  &while (0));
    }' unless defined(&nfsm_request);
    eval 'sub nfsm_mtofh {
        my($d, $v, $v3, $f) = @_;
	    eval q( &do {  &int32_t  &t1;  &t1 =  &nfsm_mtofh_xx(($d), ($v), ($v3), ($f),  &md,  &dpos);  &nfsm_dcheck( &t1,  &mrep); }  &while (0));
    }' unless defined(&nfsm_mtofh);
    eval 'sub nfsm_getfh {
        my($f, $s, $v3) = @_;
	    eval q( &do {  &int32_t  &t1;  &t1 =  &nfsm_getfh_xx(($f), ($s), ($v3),  &md,  &dpos);  &nfsm_dcheck( &t1,  &mrep); }  &while (0));
    }' unless defined(&nfsm_getfh);
    eval 'sub nfsm_loadattr {
        my($v, $a) = @_;
	    eval q( &do {  &int32_t  &t1;  &t1 =  &nfsm_loadattr_xx($v, $a,  &md,  &dpos);  &nfsm_dcheck( &t1,  &mrep); }  &while (0));
    }' unless defined(&nfsm_loadattr);
    eval 'sub nfsm_postop_attr {
        my($v, $f) = @_;
	    eval q( &do {  &int32_t  &t1;  &t1 =  &nfsm_postop_attr_xx($v, $f,  &NULL,  &md,  &dpos);  &nfsm_dcheck( &t1,  &mrep); }  &while (0));
    }' unless defined(&nfsm_postop_attr);
    eval 'sub nfsm_postop_attr_va {
        my($v, $f, $va) = @_;
	    eval q( &do {  &int32_t  &t1;  &t1 =  &nfsm_postop_attr_xx($v, $f, $va,  &md,  &dpos);  &nfsm_dcheck( &t1,  &mrep); }  &while (0));
    }' unless defined(&nfsm_postop_attr_va);
    eval 'sub NFSV3_WCCRATTR () {0;}' unless defined(&NFSV3_WCCRATTR);
    eval 'sub NFSV3_WCCCHK () {1;}' unless defined(&NFSV3_WCCCHK);
    eval 'sub nfsm_wcc_data {
        my($v, $f) = @_;
	    eval q( &do {  &int32_t  &t1;  &t1 =  &nfsm_wcc_data_xx($v, $f,  &md,  &dpos);  &nfsm_dcheck( &t1,  &mrep); }  &while (0));
    }' unless defined(&nfsm_wcc_data);
}
1;
