require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFSCLIENT_NFSMOUNT_H_)) {
    eval 'sub _NFSCLIENT_NFSMOUNT_H_ () {1;}' unless defined(&_NFSCLIENT_NFSMOUNT_H_);
    require 'sys/socket.ph';
    require 'nfs/nfs_mountcommon.ph';
    require 'rpc/types.ph';
    require 'rpc/auth.ph';
    require 'rpc/clnt.ph';
    require 'rpc/rpcsec_gss.ph';
    eval 'sub nm_mtx () { ($nm_com->{nmcom_mtx});}' unless defined(&nm_mtx);
    eval 'sub nm_flag () { ($nm_com->{nmcom_flag});}' unless defined(&nm_flag);
    eval 'sub nm_state () { ($nm_com->{nmcom_state});}' unless defined(&nm_state);
    eval 'sub nm_mountp () { ($nm_com->{nmcom_mountp});}' unless defined(&nm_mountp);
    eval 'sub nm_timeo () { ($nm_com->{nmcom_timeo});}' unless defined(&nm_timeo);
    eval 'sub nm_retry () { ($nm_com->{nmcom_retry});}' unless defined(&nm_retry);
    eval 'sub nm_hostname () { ($nm_com->{nmcom_hostname});}' unless defined(&nm_hostname);
    eval 'sub nm_getinfo () { ($nm_com->{nmcom_getinfo});}' unless defined(&nm_getinfo);
    eval 'sub nm_vinvalbuf () { ($nm_com->{nmcom_vinvalbuf});}' unless defined(&nm_vinvalbuf);
    if(defined(&_KERNEL)) {
	eval 'sub VFSTONFS {
	    my($mp) = @_;
    	    eval q(((($mp)-> &mnt_data)));
	}' unless defined(&VFSTONFS);
	unless(defined(&NFS_TPRINTF_INITIAL_DELAY)) {
	    eval 'sub NFS_TPRINTF_INITIAL_DELAY () {12;}' unless defined(&NFS_TPRINTF_INITIAL_DELAY);
	}
	unless(defined(&NFS_TPRINTF_DELAY)) {
	    eval 'sub NFS_TPRINTF_DELAY () {30;}' unless defined(&NFS_TPRINTF_DELAY);
	}
	unless(defined(&NFS_DEFAULT_NAMETIMEO)) {
	    eval 'sub NFS_DEFAULT_NAMETIMEO () {60;}' unless defined(&NFS_DEFAULT_NAMETIMEO);
	}
	unless(defined(&NFS_DEFAULT_NEGNAMETIMEO)) {
	    eval 'sub NFS_DEFAULT_NEGNAMETIMEO () {60;}' unless defined(&NFS_DEFAULT_NEGNAMETIMEO);
	}
    }
}
1;
