require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_RPC_SVC_H)) {
    eval 'sub _RPC_SVC_H () {1;}' unless defined(&_RPC_SVC_H);
    require 'sys/cdefs.ph';
    eval 'sub SVCGET_VERSQUIET () {1;}' unless defined(&SVCGET_VERSQUIET);
    eval 'sub SVCSET_VERSQUIET () {2;}' unless defined(&SVCSET_VERSQUIET);
    eval 'sub SVCGET_CONNMAXREC () {3;}' unless defined(&SVCGET_CONNMAXREC);
    eval 'sub SVCSET_CONNMAXREC () {4;}' unless defined(&SVCSET_CONNMAXREC);
    eval 'sub RPC_SVC_CONNMAXREC_SET () {0;}' unless defined(&RPC_SVC_CONNMAXREC_SET);
    eval 'sub RPC_SVC_CONNMAXREC_GET () {1;}' unless defined(&RPC_SVC_CONNMAXREC_GET);
    eval("sub XPRT_DIED () { 0; }") unless defined(&XPRT_DIED);
    eval("sub XPRT_MOREREQS () { 1; }") unless defined(&XPRT_MOREREQS);
    eval("sub XPRT_IDLE () { 2; }") unless defined(&XPRT_IDLE);
    eval 'sub xp_sock () { &xp_fd;}' unless defined(&xp_sock);
    eval 'sub svc_getrpccaller {
        my($x) = @_;
	    eval q((($x)-> &xp_rtaddr));
    }' unless defined(&svc_getrpccaller);
    eval 'sub SVC_RECV {
        my($xprt, $msg) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_recv}))(($xprt), ($msg)));
    }' unless defined(&SVC_RECV);
    eval 'sub svc_recv {
        my($xprt, $msg) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_recv}))(($xprt), ($msg)));
    }' unless defined(&svc_recv);
    eval 'sub SVC_STAT {
        my($xprt) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_stat}))($xprt));
    }' unless defined(&SVC_STAT);
    eval 'sub svc_stat {
        my($xprt) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_stat}))($xprt));
    }' unless defined(&svc_stat);
    eval 'sub SVC_GETARGS {
        my($xprt, $xargs, $argsp) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_getargs}))(($xprt), ($xargs), ($argsp)));
    }' unless defined(&SVC_GETARGS);
    eval 'sub svc_getargs {
        my($xprt, $xargs, $argsp) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_getargs}))(($xprt), ($xargs), ($argsp)));
    }' unless defined(&svc_getargs);
    eval 'sub SVC_REPLY {
        my($xprt, $msg) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_reply})) (($xprt), ($msg)));
    }' unless defined(&SVC_REPLY);
    eval 'sub svc_reply {
        my($xprt, $msg) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_reply})) (($xprt), ($msg)));
    }' unless defined(&svc_reply);
    eval 'sub SVC_FREEARGS {
        my($xprt, $xargs, $argsp) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_freeargs}))(($xprt), ($xargs), ($argsp)));
    }' unless defined(&SVC_FREEARGS);
    eval 'sub svc_freeargs {
        my($xprt, $xargs, $argsp) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_freeargs}))(($xprt), ($xargs), ($argsp)));
    }' unless defined(&svc_freeargs);
    eval 'sub SVC_DESTROY {
        my($xprt) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_destroy}))($xprt));
    }' unless defined(&SVC_DESTROY);
    eval 'sub svc_destroy {
        my($xprt) = @_;
	    eval q((*($xprt)-> ($xp_ops->{xp_destroy}))($xprt));
    }' unless defined(&svc_destroy);
    eval 'sub SVC_CONTROL {
        my($xprt, $rq, $in) = @_;
	    eval q((*($xprt)-> ($xp_ops2->{xp_control}))(($xprt), ($rq), ($in)));
    }' unless defined(&SVC_CONTROL);
    eval 'sub SVC_EXT {
        my($xprt) = @_;
	    eval q((( &SVCXPRT_EXT *)  ($xprt->{xp_p3})));
    }' unless defined(&SVC_EXT);
    eval 'sub SVC_AUTH {
        my($xprt) = @_;
	    eval q(( &SVC_EXT($xprt)-> &xp_auth));
    }' unless defined(&SVC_AUTH);
    eval 'sub SVCAUTH_WRAP {
        my($auth, $xdrs, $xfunc, $xwhere) = @_;
	    eval q((($auth)-> ($svc_ah_ops->{svc_ah_wrap})($auth, $xdrs, $xfunc, $xwhere)));
    }' unless defined(&SVCAUTH_WRAP);
    eval 'sub SVCAUTH_UNWRAP {
        my($auth, $xdrs, $xfunc, $xwhere) = @_;
	    eval q((($auth)-> ($svc_ah_ops->{svc_ah_unwrap})($auth, $xdrs, $xfunc, $xwhere)));
    }' unless defined(&SVCAUTH_UNWRAP);
    if(defined(&FD_SETSIZE)) {
	eval 'sub svc_fds () { ($svc_fdset->{fds_bits[0]});}' unless defined(&svc_fds);
    } else {
    }
    eval 'sub RPC_ANYSOCK () {-1;}' unless defined(&RPC_ANYSOCK);
    eval 'sub RPC_ANYFD () { &RPC_ANYSOCK;}' unless defined(&RPC_ANYFD);
    require 'rpc/svc_soc.ph';
}
1;
