require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_RPC_TYPES_H)) {
    eval 'sub _RPC_TYPES_H () {1;}' unless defined(&_RPC_TYPES_H);
    require 'sys/types.ph';
    require 'sys/_null.ph';
    eval 'sub __dontcare__ () {-1;}' unless defined(&__dontcare__);
    unless(defined(&FALSE)) {
	eval 'sub FALSE () {(0);}' unless defined(&FALSE);
    }
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {(1);}' unless defined(&TRUE);
    }
    if(defined(&_KERNEL)) {
	if(defined(&_SYS_MALLOC_H_)) {
	}
	eval 'sub mem_alloc {
	    my($bsize) = @_;
    	    eval q( &malloc($bsize,  &M_RPC,  &M_WAITOK| &M_ZERO));
	}' unless defined(&mem_alloc);
	eval 'sub mem_free {
	    my($ptr, $bsize) = @_;
    	    eval q( &free($ptr,  &M_RPC));
	}' unless defined(&mem_free);
    } else {
	eval 'sub mem_alloc {
	    my($bsize) = @_;
    	    eval q( &calloc(1, $bsize));
	}' unless defined(&mem_alloc);
	eval 'sub mem_free {
	    my($ptr, $bsize) = @_;
    	    eval q( &free($ptr));
	}' unless defined(&mem_free);
    }
    require 'sys/time.ph';
    if(defined(&_KERNEL)) {
	require 'rpc/netconfig.ph';
    } else {
	require 'netconfig.ph';
    }
}
1;
