require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SSP_STDIO_H)) {
    eval 'sub _SSP_STDIO_H () {1;}' unless defined(&_SSP_STDIO_H);
    require 'ssp.ph';
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "stdio.ph" } keys(%INC));
	@REM = map { "$_/stdio.ph" } (grep { not exists($INCD{"$_/stdio.ph"}) and -f "$_/stdio.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
    if((defined(&__SSP_FORTIFY_LEVEL) ? &__SSP_FORTIFY_LEVEL : undef) > 0) {
	require 'stdarg.ph';
	undef(&sprintf) if defined(&sprintf);
	undef(&vsprintf) if defined(&vsprintf);
	undef(&snprintf) if defined(&snprintf);
	undef(&vsnprintf) if defined(&vsnprintf);
	undef(&gets) if defined(&gets);
	undef(&fgets) if defined(&fgets);
	eval 'sub sprintf () {( &str, ...)  &__builtin___sprintf_chk ( &str, 0,  &__ssp_bos ( &str),  &__VA_ARGS__);}' unless defined(&sprintf);
	eval 'sub vsprintf {
	    my($str, $fmt, $ap) = @_;
    	    eval q( &__builtin___vsprintf_chk ($str, 0,  &__ssp_bos ($str), $fmt, $ap));
	}' unless defined(&vsprintf);
	eval 'sub snprintf () {( &str,  &len, ...)  &__builtin___snprintf_chk ( &str,  &len, 0,  &__ssp_bos ( &str),  &__VA_ARGS__);}' unless defined(&snprintf);
	eval 'sub vsnprintf {
	    my($str, $len, $fmt, $ap) = @_;
    	    eval q( &__builtin___vsnprintf_chk ($str, $len, 0,  &__ssp_bos ($str), $fmt, $ap));
	}' unless defined(&vsnprintf);
	eval 'sub __attribute__ () {
	    eval q((( &__always_inline__)) \'char\' *  &gets (\'char\' * &__str) {  &if ( &__ssp_bos ( &__str) !=  -1)  &__gets_chk ( &__str,  &__ssp_bos ( &__str));  &__gets_alias ( &__str); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q(() \'char\' *  &fgets (\'char\' * &__restrict__  &__s, \'int\'  &__n, \'FILE\' * &__restrict__  &__stream) {  &if ( &__ssp_bos != -1 &&  &__n >  &__ssp_bos ( &__s))  &__chk_fail ();  &__fgets_alias ( &__s,  &__n,  &__stream); });
	}' unless defined(&__attribute__);
    }
}
1;
