require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_TEKEN_H_)) {
    eval 'sub _TEKEN_H_ () {1;}' unless defined(&_TEKEN_H_);
    require 'sys/types.ph';
    eval 'sub TF_BOLD () {0x1;}' unless defined(&TF_BOLD);
    eval 'sub TF_UNDERLINE () {0x2;}' unless defined(&TF_UNDERLINE);
    eval 'sub TF_BLINK () {0x4;}' unless defined(&TF_BLINK);
    eval 'sub TF_REVERSE () {0x8;}' unless defined(&TF_REVERSE);
    eval 'sub TF_CJK_RIGHT () {0x10;}' unless defined(&TF_CJK_RIGHT);
    eval 'sub TC_BLACK () {0;}' unless defined(&TC_BLACK);
    eval 'sub TC_RED () {1;}' unless defined(&TC_RED);
    eval 'sub TC_GREEN () {2;}' unless defined(&TC_GREEN);
    eval 'sub TC_BROWN () {3;}' unless defined(&TC_BROWN);
    eval 'sub TC_BLUE () {4;}' unless defined(&TC_BLUE);
    eval 'sub TC_MAGENTA () {5;}' unless defined(&TC_MAGENTA);
    eval 'sub TC_CYAN () {6;}' unless defined(&TC_CYAN);
    eval 'sub TC_WHITE () {7;}' unless defined(&TC_WHITE);
    eval 'sub TC_NCOLORS () {8;}' unless defined(&TC_NCOLORS);
    eval 'sub TC_LIGHT () {8;}' unless defined(&TC_LIGHT);
    eval 'sub TP_SHOWCURSOR () {0;}' unless defined(&TP_SHOWCURSOR);
    eval 'sub TP_KEYPADAPP () {1;}' unless defined(&TP_KEYPADAPP);
    eval 'sub TP_AUTOREPEAT () {2;}' unless defined(&TP_AUTOREPEAT);
    eval 'sub TP_SWITCHVT () {3;}' unless defined(&TP_SWITCHVT);
    eval 'sub TP_132COLS () {4;}' unless defined(&TP_132COLS);
    eval 'sub TP_SETBELLPD () {5;}' unless defined(&TP_SETBELLPD);
    eval 'sub TP_SETBELLPD_PITCH {
        my($pd) = @_;
	    eval q((($pd) >> 16));
    }' unless defined(&TP_SETBELLPD_PITCH);
    eval 'sub TP_SETBELLPD_DURATION {
        my($pd) = @_;
	    eval q((($pd) & 0xffff));
    }' unless defined(&TP_SETBELLPD_DURATION);
    eval 'sub TP_MOUSE () {6;}' unless defined(&TP_MOUSE);
    eval 'sub T_NUMSIZE () {8;}' unless defined(&T_NUMSIZE);
    eval 'sub T_NUMCOL () {160;}' unless defined(&T_NUMCOL);
    eval 'sub TKEY_UP () {0x;}' unless defined(&TKEY_UP);
    eval 'sub TKEY_DOWN () {0x1;}' unless defined(&TKEY_DOWN);
    eval 'sub TKEY_LEFT () {0x2;}' unless defined(&TKEY_LEFT);
    eval 'sub TKEY_RIGHT () {0x3;}' unless defined(&TKEY_RIGHT);
    eval 'sub TKEY_HOME () {0x4;}' unless defined(&TKEY_HOME);
    eval 'sub TKEY_END () {0x5;}' unless defined(&TKEY_END);
    eval 'sub TKEY_INSERT () {0x6;}' unless defined(&TKEY_INSERT);
    eval 'sub TKEY_DELETE () {0x7;}' unless defined(&TKEY_DELETE);
    eval 'sub TKEY_PAGE_UP () {0x8;}' unless defined(&TKEY_PAGE_UP);
    eval 'sub TKEY_PAGE_DOWN () {0x9;}' unless defined(&TKEY_PAGE_DOWN);
    eval 'sub TKEY_F1 () {0xa;}' unless defined(&TKEY_F1);
    eval 'sub TKEY_F2 () {0xb;}' unless defined(&TKEY_F2);
    eval 'sub TKEY_F3 () {0xc;}' unless defined(&TKEY_F3);
    eval 'sub TKEY_F4 () {0xd;}' unless defined(&TKEY_F4);
    eval 'sub TKEY_F5 () {0xe;}' unless defined(&TKEY_F5);
    eval 'sub TKEY_F6 () {0xf;}' unless defined(&TKEY_F6);
    eval 'sub TKEY_F7 () {0x10;}' unless defined(&TKEY_F7);
    eval 'sub TKEY_F8 () {0x11;}' unless defined(&TKEY_F8);
    eval 'sub TKEY_F9 () {0x12;}' unless defined(&TKEY_F9);
    eval 'sub TKEY_F10 () {0x13;}' unless defined(&TKEY_F10);
    eval 'sub TKEY_F11 () {0x14;}' unless defined(&TKEY_F11);
    eval 'sub TKEY_F12 () {0x15;}' unless defined(&TKEY_F12);
}
1;
