require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/queue.ph';
eval 'sub ATTACHED () {0x1;}' unless defined(&ATTACHED);
eval 'sub UNDONE () {0x2;}' unless defined(&UNDONE);
eval 'sub COMPLETE () {0x4;}' unless defined(&COMPLETE);
eval 'sub DEPCOMPLETE () {0x8;}' unless defined(&DEPCOMPLETE);
eval 'sub MKDIR_PARENT () {0x10;}' unless defined(&MKDIR_PARENT);
eval 'sub MKDIR_BODY () {0x20;}' unless defined(&MKDIR_BODY);
eval 'sub RMDIR () {0x40;}' unless defined(&RMDIR);
eval 'sub DIRCHG () {0x80;}' unless defined(&DIRCHG);
eval 'sub GOINGAWAY () {0x100;}' unless defined(&GOINGAWAY);
eval 'sub IOSTARTED () {0x200;}' unless defined(&IOSTARTED);
eval 'sub DELAYEDFREE () {0x400;}' unless defined(&DELAYEDFREE);
eval 'sub NEWBLOCK () {0x800;}' unless defined(&NEWBLOCK);
eval 'sub INPROGRESS () {0x1000;}' unless defined(&INPROGRESS);
eval 'sub UFS1FMT () {0x2000;}' unless defined(&UFS1FMT);
eval 'sub EXTDATA () {0x4000;}' unless defined(&EXTDATA);
eval 'sub ONWORKLIST () {0x8000;}' unless defined(&ONWORKLIST);
eval 'sub IOWAITING () {0x10000;}' unless defined(&IOWAITING);
eval 'sub ONDEPLIST () {0x20000;}' unless defined(&ONDEPLIST);
eval 'sub UNLINKED () {0x40000;}' unless defined(&UNLINKED);
eval 'sub UNLINKNEXT () {0x80000;}' unless defined(&UNLINKNEXT);
eval 'sub UNLINKPREV () {0x100000;}' unless defined(&UNLINKPREV);
eval 'sub UNLINKONLIST () {0x200000;}' unless defined(&UNLINKONLIST);
eval 'sub UNLINKLINKS () {( &UNLINKNEXT |  &UNLINKPREV);}' unless defined(&UNLINKLINKS);
eval 'sub WRITESUCCEEDED () {0x400000;}' unless defined(&WRITESUCCEEDED);
eval 'sub ALLCOMPLETE () {( &ATTACHED |  &COMPLETE |  &DEPCOMPLETE);}' unless defined(&ALLCOMPLETE);
eval 'sub D_PAGEDEP () {0;}' unless defined(&D_PAGEDEP);
eval 'sub D_INODEDEP () {1;}' unless defined(&D_INODEDEP);
eval 'sub D_BMSAFEMAP () {2;}' unless defined(&D_BMSAFEMAP);
eval 'sub D_NEWBLK () {3;}' unless defined(&D_NEWBLK);
eval 'sub D_ALLOCDIRECT () {4;}' unless defined(&D_ALLOCDIRECT);
eval 'sub D_INDIRDEP () {5;}' unless defined(&D_INDIRDEP);
eval 'sub D_ALLOCINDIR () {6;}' unless defined(&D_ALLOCINDIR);
eval 'sub D_FREEFRAG () {7;}' unless defined(&D_FREEFRAG);
eval 'sub D_FREEBLKS () {8;}' unless defined(&D_FREEBLKS);
eval 'sub D_FREEFILE () {9;}' unless defined(&D_FREEFILE);
eval 'sub D_DIRADD () {10;}' unless defined(&D_DIRADD);
eval 'sub D_MKDIR () {11;}' unless defined(&D_MKDIR);
eval 'sub D_DIRREM () {12;}' unless defined(&D_DIRREM);
eval 'sub D_NEWDIRBLK () {13;}' unless defined(&D_NEWDIRBLK);
eval 'sub D_FREEWORK () {14;}' unless defined(&D_FREEWORK);
eval 'sub D_FREEDEP () {15;}' unless defined(&D_FREEDEP);
eval 'sub D_JADDREF () {16;}' unless defined(&D_JADDREF);
eval 'sub D_JREMREF () {17;}' unless defined(&D_JREMREF);
eval 'sub D_JMVREF () {18;}' unless defined(&D_JMVREF);
eval 'sub D_JNEWBLK () {19;}' unless defined(&D_JNEWBLK);
eval 'sub D_JFREEBLK () {20;}' unless defined(&D_JFREEBLK);
eval 'sub D_JFREEFRAG () {21;}' unless defined(&D_JFREEFRAG);
eval 'sub D_JSEG () {22;}' unless defined(&D_JSEG);
eval 'sub D_JSEGDEP () {23;}' unless defined(&D_JSEGDEP);
eval 'sub D_SBDEP () {24;}' unless defined(&D_SBDEP);
eval 'sub D_JTRUNC () {25;}' unless defined(&D_JTRUNC);
eval 'sub D_JFSYNC () {26;}' unless defined(&D_JFSYNC);
eval 'sub D_SENTINEL () {27;}' unless defined(&D_SENTINEL);
eval 'sub D_LAST () { &D_SENTINEL;}' unless defined(&D_LAST);
unless(defined(&WK_DATA)) {
    sub WK_DATA {
	my($wk) = @_;
	eval q((( &void *)($wk)));
    }
}
unless(defined(&WK_PAGEDEP)) {
    sub WK_PAGEDEP {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_INODEDEP)) {
    sub WK_INODEDEP {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_BMSAFEMAP)) {
    sub WK_BMSAFEMAP {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_NEWBLK)) {
    sub WK_NEWBLK {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_ALLOCDIRECT)) {
    sub WK_ALLOCDIRECT {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_INDIRDEP)) {
    sub WK_INDIRDEP {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_ALLOCINDIR)) {
    sub WK_ALLOCINDIR {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_FREEFRAG)) {
    sub WK_FREEFRAG {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_FREEBLKS)) {
    sub WK_FREEBLKS {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_FREEWORK)) {
    sub WK_FREEWORK {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_FREEFILE)) {
    sub WK_FREEFILE {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_DIRADD)) {
    sub WK_DIRADD {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_MKDIR)) {
    sub WK_MKDIR {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_DIRREM)) {
    sub WK_DIRREM {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_NEWDIRBLK)) {
    sub WK_NEWDIRBLK {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_JADDREF)) {
    sub WK_JADDREF {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_JREMREF)) {
    sub WK_JREMREF {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_JMVREF)) {
    sub WK_JMVREF {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_JSEGDEP)) {
    sub WK_JSEGDEP {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_JSEG)) {
    sub WK_JSEG {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_JNEWBLK)) {
    sub WK_JNEWBLK {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_JFREEBLK)) {
    sub WK_JFREEBLK {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_FREEDEP)) {
    sub WK_FREEDEP {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_JFREEFRAG)) {
    sub WK_JFREEFRAG {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_SBDEP)) {
    sub WK_SBDEP {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_JTRUNC)) {
    sub WK_JTRUNC {
	my($wk) = @_;
	eval q((($wk)));
    }
}
unless(defined(&WK_JFSYNC)) {
    sub WK_JFSYNC {
	my($wk) = @_;
	eval q((($wk)));
    }
}
eval 'sub DAHASHSZ () {5;}' unless defined(&DAHASHSZ);
unless(defined(&DIRADDHASH)) {
    sub DIRADDHASH {
	my($offset) = @_;
	eval q(((($offset) >> 2) %  &DAHASHSZ));
    }
}
eval 'sub pd_state () { ($pd_list->{wk_state});}' unless defined(&pd_state);
eval 'sub id_state () { ($id_list->{wk_state});}' unless defined(&id_state);
eval 'sub id_savedino1 () { ($id_un->{idu_savedino1});}' unless defined(&id_savedino1);
eval 'sub id_savedino2 () { ($id_un->{idu_savedino2});}' unless defined(&id_savedino2);
eval 'sub sm_state () { ($sm_list->{wk_state});}' unless defined(&sm_state);
eval 'sub nb_state () { ($nb_list->{wk_state});}' unless defined(&nb_state);
eval 'sub ad_list () { ($ad_block->{nb_list});}' unless defined(&ad_list);
eval 'sub ad_state () { ($ad_list->{wk_state});}' unless defined(&ad_state);
eval 'sub ad_newblkno () { ($ad_block->{nb_newblkno});}' unless defined(&ad_newblkno);
eval 'sub ad_freefrag () { ($ad_block->{nb_freefrag});}' unless defined(&ad_freefrag);
eval 'sub ad_newdirblk () { ($ad_block->{nb_newdirblk});}' unless defined(&ad_newdirblk);
eval 'sub ir_state () { ($ir_list->{wk_state});}' unless defined(&ir_state);
eval 'sub ai_state () { ($ai_block->{nb_list}->{wk_state});}' unless defined(&ai_state);
eval 'sub ai_newblkno () { ($ai_block->{nb_newblkno});}' unless defined(&ai_newblkno);
eval 'sub ai_freefrag () { ($ai_block->{nb_freefrag});}' unless defined(&ai_freefrag);
eval 'sub ai_newdirblk () { ($ai_block->{nb_newdirblk});}' unless defined(&ai_newdirblk);
eval 'sub ff_state () { ($ff_list->{wk_state});}' unless defined(&ff_state);
eval 'sub fb_state () { ($fb_list->{wk_state});}' unless defined(&fb_state);
if(defined(&QUOTA)) {
}
eval 'sub fw_state () { ($fw_list->{wk_state});}' unless defined(&fw_state);
eval 'sub da_state () { ($da_list->{wk_state});}' unless defined(&da_state);
eval 'sub da_previous () { ($da_un->{dau_previous});}' unless defined(&da_previous);
eval 'sub da_pagedep () { ($da_un->{dau_pagedep});}' unless defined(&da_pagedep);
eval 'sub md_state () { ($md_list->{wk_state});}' unless defined(&md_state);
eval 'sub dm_state () { ($dm_list->{wk_state});}' unless defined(&dm_state);
eval 'sub dm_pagedep () { ($dm_un->{dmu_pagedep});}' unless defined(&dm_pagedep);
eval 'sub dm_dirinum () { ($dm_un->{dmu_dirinum});}' unless defined(&dm_dirinum);
eval 'sub db_state () { ($db_list->{wk_state});}' unless defined(&db_state);
eval 'sub if_state () { ($if_list->{wk_state});}' unless defined(&if_state);
eval 'sub ja_list () { ($ja_ref->{if_list});}' unless defined(&ja_list);
eval 'sub ja_state () { ($ja_ref->{if_list}->{wk_state});}' unless defined(&ja_state);
eval 'sub ja_diradd () { ($ja_un->{jau_diradd});}' unless defined(&ja_diradd);
eval 'sub ja_mkdir () { ($ja_un->{jau_mkdir});}' unless defined(&ja_mkdir);
eval 'sub ja_diroff () { ($ja_ref->{if_diroff});}' unless defined(&ja_diroff);
eval 'sub ja_ino () { ($ja_ref->{if_ino});}' unless defined(&ja_ino);
eval 'sub ja_parent () { ($ja_ref->{if_parent});}' unless defined(&ja_parent);
eval 'sub ja_mode () { ($ja_ref->{if_mode});}' unless defined(&ja_mode);
eval 'sub jr_list () { ($jr_ref->{if_list});}' unless defined(&jr_list);
eval 'sub jr_state () { ($jr_ref->{if_list}->{wk_state});}' unless defined(&jr_state);
eval 'sub jn_state () { ($jn_list->{wk_state});}' unless defined(&jn_state);
eval 'sub fr_state () { ($fr_list->{wk_state});}' unless defined(&fr_state);
eval 'sub jd_state () { ($jd_list->{wk_state});}' unless defined(&jd_state);
eval 'sub js_state () { ($js_list->{wk_state});}' unless defined(&js_state);
eval 'sub FLUSH_EXIT () {0x1;}' unless defined(&FLUSH_EXIT);
eval 'sub FLUSH_CLEANUP () {0x2;}' unless defined(&FLUSH_CLEANUP);
eval 'sub FLUSH_STARTING () {0x4;}' unless defined(&FLUSH_STARTING);
eval 'sub FLUSH_RC_ACTIVE () {0x8;}' unless defined(&FLUSH_RC_ACTIVE);
eval 'sub softdep_workitem_pending () { ($um_softdep->{sd_workitem_pending});}' unless defined(&softdep_workitem_pending);
eval 'sub softdep_worklist_tail () { ($um_softdep->{sd_worklist_tail});}' unless defined(&softdep_worklist_tail);
eval 'sub softdep_journal_pending () { ($um_softdep->{sd_journal_pending});}' unless defined(&softdep_journal_pending);
eval 'sub softdep_journal_tail () { ($um_softdep->{sd_journal_tail});}' unless defined(&softdep_journal_tail);
eval 'sub softdep_jblocks () { ($um_softdep->{sd_jblocks});}' unless defined(&softdep_jblocks);
eval 'sub softdep_unlinked () { ($um_softdep->{sd_unlinked});}' unless defined(&softdep_unlinked);
eval 'sub softdep_dirtycg () { ($um_softdep->{sd_dirtycg});}' unless defined(&softdep_dirtycg);
eval 'sub softdep_mkdirlisthd () { ($um_softdep->{sd_mkdirlisthd});}' unless defined(&softdep_mkdirlisthd);
eval 'sub pagedep_hashtbl () { ($um_softdep->{sd_pdhash});}' unless defined(&pagedep_hashtbl);
eval 'sub pagedep_hash_size () { ($um_softdep->{sd_pdhashsize});}' unless defined(&pagedep_hash_size);
eval 'sub pagedep_nextclean () { ($um_softdep->{sd_pdnextclean});}' unless defined(&pagedep_nextclean);
eval 'sub inodedep_hashtbl () { ($um_softdep->{sd_idhash});}' unless defined(&inodedep_hashtbl);
eval 'sub inodedep_hash_size () { ($um_softdep->{sd_idhashsize});}' unless defined(&inodedep_hash_size);
eval 'sub inodedep_nextclean () { ($um_softdep->{sd_idnextclean});}' unless defined(&inodedep_nextclean);
eval 'sub newblk_hashtbl () { ($um_softdep->{sd_newblkhash});}' unless defined(&newblk_hashtbl);
eval 'sub newblk_hash_size () { ($um_softdep->{sd_newblkhashsize});}' unless defined(&newblk_hash_size);
eval 'sub bmsafemap_hashtbl () { ($um_softdep->{sd_bmhash});}' unless defined(&bmsafemap_hashtbl);
eval 'sub bmsafemap_hash_size () { ($um_softdep->{sd_bmhashsize});}' unless defined(&bmsafemap_hash_size);
eval 'sub indir_hashtbl () { ($um_softdep->{sd_indirhash});}' unless defined(&indir_hashtbl);
eval 'sub indir_hash_size () { ($um_softdep->{sd_indirhashsize});}' unless defined(&indir_hash_size);
eval 'sub softdep_on_journal () { ($um_softdep->{sd_on_journal});}' unless defined(&softdep_on_journal);
eval 'sub softdep_on_worklist () { ($um_softdep->{sd_on_worklist});}' unless defined(&softdep_on_worklist);
eval 'sub softdep_deps () { ($um_softdep->{sd_deps});}' unless defined(&softdep_deps);
eval 'sub softdep_accdeps () { ($um_softdep->{sd_accdeps});}' unless defined(&softdep_accdeps);
eval 'sub softdep_req () { ($um_softdep->{sd_req});}' unless defined(&softdep_req);
eval 'sub softdep_flags () { ($um_softdep->{sd_flags});}' unless defined(&softdep_flags);
eval 'sub softdep_flushtd () { ($um_softdep->{sd_flushtd});}' unless defined(&softdep_flushtd);
eval 'sub softdep_curdeps () { ($um_softdep->{sd_curdeps});}' unless defined(&softdep_curdeps);
1;
