require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_UFS_UFS_UFSMOUNT_H_)) {
    eval 'sub _UFS_UFS_UFSMOUNT_H_ () {1;}' unless defined(&_UFS_UFS_UFSMOUNT_H_);
    if(defined(&_KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
	eval 'sub UFS_BALLOC {
	    my($aa, $bb, $cc, $dd, $ee, $ff) = @_;
    	    eval q( &VFSTOUFS(($aa)-> &v_mount)-> &um_balloc($aa, $bb, $cc, $dd, $ee, $ff));
	}' unless defined(&UFS_BALLOC);
	eval 'sub UFS_BLKATOFF {
	    my($aa, $bb, $cc, $dd) = @_;
    	    eval q( &VFSTOUFS(($aa)-> &v_mount)-> &um_blkatoff($aa, $bb, $cc, $dd));
	}' unless defined(&UFS_BLKATOFF);
	eval 'sub UFS_TRUNCATE {
	    my($aa, $bb, $cc, $dd) = @_;
    	    eval q( &VFSTOUFS(($aa)-> &v_mount)-> &um_truncate($aa, $bb, $cc, $dd));
	}' unless defined(&UFS_TRUNCATE);
	eval 'sub UFS_UPDATE {
	    my($aa, $bb) = @_;
    	    eval q( &VFSTOUFS(($aa)-> &v_mount)-> &um_update($aa, $bb));
	}' unless defined(&UFS_UPDATE);
	eval 'sub UFS_VALLOC {
	    my($aa, $bb, $cc, $dd) = @_;
    	    eval q( &VFSTOUFS(($aa)-> &v_mount)-> &um_valloc($aa, $bb, $cc, $dd));
	}' unless defined(&UFS_VALLOC);
	eval 'sub UFS_VFREE {
	    my($aa, $bb, $cc) = @_;
    	    eval q( &VFSTOUFS(($aa)-> &v_mount)-> &um_vfree($aa, $bb, $cc));
	}' unless defined(&UFS_VFREE);
	eval 'sub UFS_IFREE {
	    my($aa, $bb) = @_;
    	    eval q((($aa)-> &um_ifree($aa, $bb)));
	}' unless defined(&UFS_IFREE);
	eval 'sub UFS_RDONLY {
	    my($aa) = @_;
    	    eval q(( &ITOUMP($aa)-> &um_rdonly($aa)));
	}' unless defined(&UFS_RDONLY);
	eval 'sub UFS_SNAPGONE {
	    my($aa) = @_;
    	    eval q(( &ITOUMP($aa)-> &um_snapgone($aa)));
	}' unless defined(&UFS_SNAPGONE);
	eval 'sub UFS_LOCK {
	    my($aa) = @_;
    	    eval q( &mtx_lock(($aa)-> &um_lock));
	}' unless defined(&UFS_LOCK);
	eval 'sub UFS_UNLOCK {
	    my($aa) = @_;
    	    eval q( &mtx_unlock(($aa)-> &um_lock));
	}' unless defined(&UFS_UNLOCK);
	eval 'sub UFS_MTX {
	    my($aa) = @_;
    	    eval q((($aa)-> &um_lock));
	}' unless defined(&UFS_MTX);
	eval 'sub UFS1 () {1;}' unless defined(&UFS1);
	eval 'sub UFS2 () {2;}' unless defined(&UFS2);
	eval 'sub QTF_OPENING () {0x1;}' unless defined(&QTF_OPENING);
	eval 'sub QTF_CLOSING () {0x2;}' unless defined(&QTF_CLOSING);
	eval 'sub QTF_64BIT () {0x4;}' unless defined(&QTF_64BIT);
	eval 'sub VFSTOUFS {
	    my($mp) = @_;
    	    eval q(((($mp)-> &mnt_data)));
	}' unless defined(&VFSTOUFS);
	eval 'sub UFSTOVFS {
	    my($ump) = @_;
    	    eval q(($ump)-> &um_mountp);
	}' unless defined(&UFSTOVFS);
	eval 'sub MNINDIR {
	    my($ump) = @_;
    	    eval q((($ump)-> &um_nindir));
	}' unless defined(&MNINDIR);
	eval 'sub blkptrtodb {
	    my($ump, $b) = @_;
    	    eval q((($b) << ($ump)-> &um_bptrtodb));
	}' unless defined(&blkptrtodb);
	eval 'sub is_sequential {
	    my($ump, $a, $b) = @_;
    	    eval q((($b) == ($a) +  ($ump->{um_seqinc})));
	}' unless defined(&is_sequential);
    }
}
1;
