require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_VM_UMA_H_)) {
    eval 'sub _VM_UMA_H_ () {1;}' unless defined(&_VM_UMA_H_);
    require 'sys/param.ph';
    require 'sys/malloc.ph';
    eval 'sub UMA_SMALLEST_UNIT () {( &PAGE_SIZE / 256);}' unless defined(&UMA_SMALLEST_UNIT);
    eval 'sub UMA_ZONE_PAGEABLE () {0x1;}' unless defined(&UMA_ZONE_PAGEABLE);
    eval 'sub UMA_ZONE_ZINIT () {0x2;}' unless defined(&UMA_ZONE_ZINIT);
    eval 'sub UMA_ZONE_STATIC () {0x4;}' unless defined(&UMA_ZONE_STATIC);
    eval 'sub UMA_ZONE_OFFPAGE () {0x8;}' unless defined(&UMA_ZONE_OFFPAGE);
    eval 'sub UMA_ZONE_MALLOC () {0x10;}' unless defined(&UMA_ZONE_MALLOC);
    eval 'sub UMA_ZONE_NOFREE () {0x20;}' unless defined(&UMA_ZONE_NOFREE);
    eval 'sub UMA_ZONE_MTXCLASS () {0x40;}' unless defined(&UMA_ZONE_MTXCLASS);
    eval 'sub UMA_ZONE_VM () {0x80;}' unless defined(&UMA_ZONE_VM);
    eval 'sub UMA_ZONE_HASH () {0x100;}' unless defined(&UMA_ZONE_HASH);
    eval 'sub UMA_ZONE_SECONDARY () {0x200;}' unless defined(&UMA_ZONE_SECONDARY);
    eval 'sub UMA_ZONE_MAXBUCKET () {0x800;}' unless defined(&UMA_ZONE_MAXBUCKET);
    eval 'sub UMA_ZONE_CACHESPREAD () {0x1000;}' unless defined(&UMA_ZONE_CACHESPREAD);
    eval 'sub UMA_ZONE_VTOSLAB () {0x2000;}' unless defined(&UMA_ZONE_VTOSLAB);
    eval 'sub UMA_ZONE_NODUMP () {0x4000;}' unless defined(&UMA_ZONE_NODUMP);
    eval 'sub UMA_ZONE_PCPU () {0x8000;}' unless defined(&UMA_ZONE_PCPU);
    eval 'sub UMA_ZONE_INHERIT () {( &UMA_ZONE_OFFPAGE |  &UMA_ZONE_MALLOC |  &UMA_ZONE_NOFREE |  &UMA_ZONE_HASH |  &UMA_ZONE_VTOSLAB |  &UMA_ZONE_PCPU);}' unless defined(&UMA_ZONE_INHERIT);
    eval 'sub UMA_ALIGN_PTR () {($sizeof{ &void } - 1);}' unless defined(&UMA_ALIGN_PTR);
    eval 'sub UMA_ALIGN_LONG () {($sizeof{\'long\'} - 1);}' unless defined(&UMA_ALIGN_LONG);
    eval 'sub UMA_ALIGN_INT () {($sizeof{\'int\'} - 1);}' unless defined(&UMA_ALIGN_INT);
    eval 'sub UMA_ALIGN_SHORT () {($sizeof{\'short\'} - 1);}' unless defined(&UMA_ALIGN_SHORT);
    eval 'sub UMA_ALIGN_CHAR () {($sizeof{\'char\'} - 1);}' unless defined(&UMA_ALIGN_CHAR);
    eval 'sub UMA_ALIGN_CACHE () {(0- 1);}' unless defined(&UMA_ALIGN_CACHE);
    eval 'sub UMA_ALIGNOF {
        my($type) = @_;
	    eval q(( &_Alignof($type) - 1));
    }' unless defined(&UMA_ALIGNOF);
    eval 'sub uma_zalloc {
        my($zone,$flags) = @_;
	    eval q({  &uma_zalloc_arg($zone,  &NULL, $flags); });
    }' unless defined(&uma_zalloc);
    eval 'sub uma_zfree {
        my($zone,$item) = @_;
	    eval q({  &uma_zfree_arg($zone, $item,  &NULL); });
    }' unless defined(&uma_zfree);
    eval 'sub UMA_SLAB_BOOT () {0x1;}' unless defined(&UMA_SLAB_BOOT);
    eval 'sub UMA_SLAB_KMEM () {0x2;}' unless defined(&UMA_SLAB_KMEM);
    eval 'sub UMA_SLAB_KERNEL () {0x4;}' unless defined(&UMA_SLAB_KERNEL);
    eval 'sub UMA_SLAB_PRIV () {0x8;}' unless defined(&UMA_SLAB_PRIV);
    eval 'sub UMA_SLAB_OFFP () {0x10;}' unless defined(&UMA_SLAB_OFFP);
    eval 'sub UMA_SLAB_MALLOC () {0x20;}' unless defined(&UMA_SLAB_MALLOC);
    eval 'sub UMA_STREAM_VERSION () {0x1;}' unless defined(&UMA_STREAM_VERSION);
    eval 'sub UTH_MAX_NAME () {32;}' unless defined(&UTH_MAX_NAME);
    eval 'sub UTH_ZONE_SECONDARY () {0x1;}' unless defined(&UTH_ZONE_SECONDARY);
}
1;
