require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_FRAME_H_)) {
    eval 'sub _MACHINE_FRAME_H_ () {1;}' unless defined(&_MACHINE_FRAME_H_);
    if(defined(&__i386__)) {
	eval 'sub TF_HAS_STACKREGS {
	    my($tf) = @_;
    	    eval q( &TRAPF_USERMODE($tf));
	}' unless defined(&TF_HAS_STACKREGS);
    }
    if(defined(&__amd64__)) {
	eval 'sub TF_HASSEGS () {0x1;}' unless defined(&TF_HASSEGS);
	eval 'sub TF_HASBASES () {0x2;}' unless defined(&TF_HASBASES);
	eval 'sub TF_HASFPXSTATE () {0x4;}' unless defined(&TF_HASFPXSTATE);
    }
}
1;
