require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_BSM_AUDIT_KEVENTS_H_)) {
    eval 'sub _BSM_AUDIT_KEVENTS_H_ () {1;}' unless defined(&_BSM_AUDIT_KEVENTS_H_);
    eval 'sub AUE_IS_A_KEVENT {
        my($e) = @_;
	    eval q(((($e) > 0 && ($e) < 2048) || (($e) > 43000 && ($e) < 45000)));
    }' unless defined(&AUE_IS_A_KEVENT);
    eval 'sub AUE_NULL () {0;}' unless defined(&AUE_NULL);
    eval 'sub AUE_EXIT () {1;}' unless defined(&AUE_EXIT);
    eval 'sub AUE_FORK () {2;}' unless defined(&AUE_FORK);
    eval 'sub AUE_FORKALL () { &AUE_FORK;}' unless defined(&AUE_FORKALL);
    eval 'sub AUE_OPEN () {3;}' unless defined(&AUE_OPEN);
    eval 'sub AUE_CREAT () {4;}' unless defined(&AUE_CREAT);
    eval 'sub AUE_LINK () {5;}' unless defined(&AUE_LINK);
    eval 'sub AUE_UNLINK () {6;}' unless defined(&AUE_UNLINK);
    eval 'sub AUE_DELETE () { &AUE_UNLINK;}' unless defined(&AUE_DELETE);
    eval 'sub AUE_EXEC () {7;}' unless defined(&AUE_EXEC);
    eval 'sub AUE_CHDIR () {8;}' unless defined(&AUE_CHDIR);
    eval 'sub AUE_MKNOD () {9;}' unless defined(&AUE_MKNOD);
    eval 'sub AUE_CHMOD () {10;}' unless defined(&AUE_CHMOD);
    eval 'sub AUE_CHOWN () {11;}' unless defined(&AUE_CHOWN);
    eval 'sub AUE_UMOUNT () {12;}' unless defined(&AUE_UMOUNT);
    eval 'sub AUE_JUNK () {13;}' unless defined(&AUE_JUNK);
    eval 'sub AUE_ACCESS () {14;}' unless defined(&AUE_ACCESS);
    eval 'sub AUE_KILL () {15;}' unless defined(&AUE_KILL);
    eval 'sub AUE_STAT () {16;}' unless defined(&AUE_STAT);
    eval 'sub AUE_LSTAT () {17;}' unless defined(&AUE_LSTAT);
    eval 'sub AUE_ACCT () {18;}' unless defined(&AUE_ACCT);
    eval 'sub AUE_MCTL () {19;}' unless defined(&AUE_MCTL);
    eval 'sub AUE_REBOOT () {20;}' unless defined(&AUE_REBOOT);
    eval 'sub AUE_SYMLINK () {21;}' unless defined(&AUE_SYMLINK);
    eval 'sub AUE_READLINK () {22;}' unless defined(&AUE_READLINK);
    eval 'sub AUE_EXECVE () {23;}' unless defined(&AUE_EXECVE);
    eval 'sub AUE_CHROOT () {24;}' unless defined(&AUE_CHROOT);
    eval 'sub AUE_VFORK () {25;}' unless defined(&AUE_VFORK);
    eval 'sub AUE_SETGROUPS () {26;}' unless defined(&AUE_SETGROUPS);
    eval 'sub AUE_SETPGRP () {27;}' unless defined(&AUE_SETPGRP);
    eval 'sub AUE_SWAPON () {28;}' unless defined(&AUE_SWAPON);
    eval 'sub AUE_SETHOSTNAME () {29;}' unless defined(&AUE_SETHOSTNAME);
    eval 'sub AUE_FCNTL () {30;}' unless defined(&AUE_FCNTL);
    eval 'sub AUE_SETPRIORITY () {31;}' unless defined(&AUE_SETPRIORITY);
    eval 'sub AUE_CONNECT () {32;}' unless defined(&AUE_CONNECT);
    eval 'sub AUE_ACCEPT () {33;}' unless defined(&AUE_ACCEPT);
    eval 'sub AUE_BIND () {34;}' unless defined(&AUE_BIND);
    eval 'sub AUE_SETSOCKOPT () {35;}' unless defined(&AUE_SETSOCKOPT);
    eval 'sub AUE_VTRACE () {36;}' unless defined(&AUE_VTRACE);
    eval 'sub AUE_SETTIMEOFDAY () {37;}' unless defined(&AUE_SETTIMEOFDAY);
    eval 'sub AUE_FCHOWN () {38;}' unless defined(&AUE_FCHOWN);
    eval 'sub AUE_FCHMOD () {39;}' unless defined(&AUE_FCHMOD);
    eval 'sub AUE_SETREUID () {40;}' unless defined(&AUE_SETREUID);
    eval 'sub AUE_SETREGID () {41;}' unless defined(&AUE_SETREGID);
    eval 'sub AUE_RENAME () {42;}' unless defined(&AUE_RENAME);
    eval 'sub AUE_TRUNCATE () {43;}' unless defined(&AUE_TRUNCATE);
    eval 'sub AUE_FTRUNCATE () {44;}' unless defined(&AUE_FTRUNCATE);
    eval 'sub AUE_FLOCK () {45;}' unless defined(&AUE_FLOCK);
    eval 'sub AUE_SHUTDOWN () {46;}' unless defined(&AUE_SHUTDOWN);
    eval 'sub AUE_MKDIR () {47;}' unless defined(&AUE_MKDIR);
    eval 'sub AUE_RMDIR () {48;}' unless defined(&AUE_RMDIR);
    eval 'sub AUE_UTIMES () {49;}' unless defined(&AUE_UTIMES);
    eval 'sub AUE_ADJTIME () {50;}' unless defined(&AUE_ADJTIME);
    eval 'sub AUE_SETRLIMIT () {51;}' unless defined(&AUE_SETRLIMIT);
    eval 'sub AUE_KILLPG () {52;}' unless defined(&AUE_KILLPG);
    eval 'sub AUE_NFS_SVC () {53;}' unless defined(&AUE_NFS_SVC);
    eval 'sub AUE_STATFS () {54;}' unless defined(&AUE_STATFS);
    eval 'sub AUE_FSTATFS () {55;}' unless defined(&AUE_FSTATFS);
    eval 'sub AUE_UNMOUNT () {56;}' unless defined(&AUE_UNMOUNT);
    eval 'sub AUE_ASYNC_DAEMON () {57;}' unless defined(&AUE_ASYNC_DAEMON);
    eval 'sub AUE_NFS_GETFH () {58;}' unless defined(&AUE_NFS_GETFH);
    eval 'sub AUE_SETDOMAINNAME () {59;}' unless defined(&AUE_SETDOMAINNAME);
    eval 'sub AUE_QUOTACTL () {60;}' unless defined(&AUE_QUOTACTL);
    eval 'sub AUE_EXPORTFS () {61;}' unless defined(&AUE_EXPORTFS);
    eval 'sub AUE_MOUNT () {62;}' unless defined(&AUE_MOUNT);
    eval 'sub AUE_SEMSYS () {63;}' unless defined(&AUE_SEMSYS);
    eval 'sub AUE_MSGSYS () {64;}' unless defined(&AUE_MSGSYS);
    eval 'sub AUE_SHMSYS () {65;}' unless defined(&AUE_SHMSYS);
    eval 'sub AUE_BSMSYS () {66;}' unless defined(&AUE_BSMSYS);
    eval 'sub AUE_RFSSYS () {67;}' unless defined(&AUE_RFSSYS);
    eval 'sub AUE_FCHDIR () {68;}' unless defined(&AUE_FCHDIR);
    eval 'sub AUE_FCHROOT () {69;}' unless defined(&AUE_FCHROOT);
    eval 'sub AUE_VPIXSYS () {70;}' unless defined(&AUE_VPIXSYS);
    eval 'sub AUE_PATHCONF () {71;}' unless defined(&AUE_PATHCONF);
    eval 'sub AUE_OPEN_R () {72;}' unless defined(&AUE_OPEN_R);
    eval 'sub AUE_OPEN_RC () {73;}' unless defined(&AUE_OPEN_RC);
    eval 'sub AUE_OPEN_RT () {74;}' unless defined(&AUE_OPEN_RT);
    eval 'sub AUE_OPEN_RTC () {75;}' unless defined(&AUE_OPEN_RTC);
    eval 'sub AUE_OPEN_W () {76;}' unless defined(&AUE_OPEN_W);
    eval 'sub AUE_OPEN_WC () {77;}' unless defined(&AUE_OPEN_WC);
    eval 'sub AUE_OPEN_WT () {78;}' unless defined(&AUE_OPEN_WT);
    eval 'sub AUE_OPEN_WTC () {79;}' unless defined(&AUE_OPEN_WTC);
    eval 'sub AUE_OPEN_RW () {80;}' unless defined(&AUE_OPEN_RW);
    eval 'sub AUE_OPEN_RWC () {81;}' unless defined(&AUE_OPEN_RWC);
    eval 'sub AUE_OPEN_RWT () {82;}' unless defined(&AUE_OPEN_RWT);
    eval 'sub AUE_OPEN_RWTC () {83;}' unless defined(&AUE_OPEN_RWTC);
    eval 'sub AUE_MSGCTL () {84;}' unless defined(&AUE_MSGCTL);
    eval 'sub AUE_MSGCTL_RMID () {85;}' unless defined(&AUE_MSGCTL_RMID);
    eval 'sub AUE_MSGCTL_SET () {86;}' unless defined(&AUE_MSGCTL_SET);
    eval 'sub AUE_MSGCTL_STAT () {87;}' unless defined(&AUE_MSGCTL_STAT);
    eval 'sub AUE_MSGGET () {88;}' unless defined(&AUE_MSGGET);
    eval 'sub AUE_MSGRCV () {89;}' unless defined(&AUE_MSGRCV);
    eval 'sub AUE_MSGSND () {90;}' unless defined(&AUE_MSGSND);
    eval 'sub AUE_SHMCTL () {91;}' unless defined(&AUE_SHMCTL);
    eval 'sub AUE_SHMCTL_RMID () {92;}' unless defined(&AUE_SHMCTL_RMID);
    eval 'sub AUE_SHMCTL_SET () {93;}' unless defined(&AUE_SHMCTL_SET);
    eval 'sub AUE_SHMCTL_STAT () {94;}' unless defined(&AUE_SHMCTL_STAT);
    eval 'sub AUE_SHMGET () {95;}' unless defined(&AUE_SHMGET);
    eval 'sub AUE_SHMAT () {96;}' unless defined(&AUE_SHMAT);
    eval 'sub AUE_SHMDT () {97;}' unless defined(&AUE_SHMDT);
    eval 'sub AUE_SEMCTL () {98;}' unless defined(&AUE_SEMCTL);
    eval 'sub AUE_SEMCTL_RMID () {99;}' unless defined(&AUE_SEMCTL_RMID);
    eval 'sub AUE_SEMCTL_SET () {100;}' unless defined(&AUE_SEMCTL_SET);
    eval 'sub AUE_SEMCTL_STAT () {101;}' unless defined(&AUE_SEMCTL_STAT);
    eval 'sub AUE_SEMCTL_GETNCNT () {102;}' unless defined(&AUE_SEMCTL_GETNCNT);
    eval 'sub AUE_SEMCTL_GETPID () {103;}' unless defined(&AUE_SEMCTL_GETPID);
    eval 'sub AUE_SEMCTL_GETVAL () {104;}' unless defined(&AUE_SEMCTL_GETVAL);
    eval 'sub AUE_SEMCTL_GETALL () {105;}' unless defined(&AUE_SEMCTL_GETALL);
    eval 'sub AUE_SEMCTL_GETZCNT () {106;}' unless defined(&AUE_SEMCTL_GETZCNT);
    eval 'sub AUE_SEMCTL_SETVAL () {107;}' unless defined(&AUE_SEMCTL_SETVAL);
    eval 'sub AUE_SEMCTL_SETALL () {108;}' unless defined(&AUE_SEMCTL_SETALL);
    eval 'sub AUE_SEMGET () {109;}' unless defined(&AUE_SEMGET);
    eval 'sub AUE_SEMOP () {110;}' unless defined(&AUE_SEMOP);
    eval 'sub AUE_CORE () {111;}' unless defined(&AUE_CORE);
    eval 'sub AUE_CLOSE () {112;}' unless defined(&AUE_CLOSE);
    eval 'sub AUE_SYSTEMBOOT () {113;}' unless defined(&AUE_SYSTEMBOOT);
    eval 'sub AUE_ASYNC_DAEMON_EXIT () {114;}' unless defined(&AUE_ASYNC_DAEMON_EXIT);
    eval 'sub AUE_NFSSVC_EXIT () {115;}' unless defined(&AUE_NFSSVC_EXIT);
    eval 'sub AUE_WRITEL () {128;}' unless defined(&AUE_WRITEL);
    eval 'sub AUE_WRITEVL () {129;}' unless defined(&AUE_WRITEVL);
    eval 'sub AUE_GETAUID () {130;}' unless defined(&AUE_GETAUID);
    eval 'sub AUE_SETAUID () {131;}' unless defined(&AUE_SETAUID);
    eval 'sub AUE_GETAUDIT () {132;}' unless defined(&AUE_GETAUDIT);
    eval 'sub AUE_SETAUDIT () {133;}' unless defined(&AUE_SETAUDIT);
    eval 'sub AUE_GETUSERAUDIT () {134;}' unless defined(&AUE_GETUSERAUDIT);
    eval 'sub AUE_SETUSERAUDIT () {135;}' unless defined(&AUE_SETUSERAUDIT);
    eval 'sub AUE_AUDITSVC () {136;}' unless defined(&AUE_AUDITSVC);
    eval 'sub AUE_AUDITUSER () {137;}' unless defined(&AUE_AUDITUSER);
    eval 'sub AUE_AUDITON () {138;}' unless defined(&AUE_AUDITON);
    eval 'sub AUE_AUDITON_GTERMID () {139;}' unless defined(&AUE_AUDITON_GTERMID);
    eval 'sub AUE_AUDITON_STERMID () {140;}' unless defined(&AUE_AUDITON_STERMID);
    eval 'sub AUE_AUDITON_GPOLICY () {141;}' unless defined(&AUE_AUDITON_GPOLICY);
    eval 'sub AUE_AUDITON_SPOLICY () {142;}' unless defined(&AUE_AUDITON_SPOLICY);
    eval 'sub AUE_AUDITON_GQCTRL () {145;}' unless defined(&AUE_AUDITON_GQCTRL);
    eval 'sub AUE_AUDITON_SQCTRL () {146;}' unless defined(&AUE_AUDITON_SQCTRL);
    eval 'sub AUE_GETKERNSTATE () {147;}' unless defined(&AUE_GETKERNSTATE);
    eval 'sub AUE_SETKERNSTATE () {148;}' unless defined(&AUE_SETKERNSTATE);
    eval 'sub AUE_GETPORTAUDIT () {149;}' unless defined(&AUE_GETPORTAUDIT);
    eval 'sub AUE_AUDITSTAT () {150;}' unless defined(&AUE_AUDITSTAT);
    eval 'sub AUE_REVOKE () {151;}' unless defined(&AUE_REVOKE);
    eval 'sub AUE_MAC () {152;}' unless defined(&AUE_MAC);
    eval 'sub AUE_ENTERPROM () {153;}' unless defined(&AUE_ENTERPROM);
    eval 'sub AUE_EXITPROM () {154;}' unless defined(&AUE_EXITPROM);
    eval 'sub AUE_IFLOAT () {155;}' unless defined(&AUE_IFLOAT);
    eval 'sub AUE_PFLOAT () {156;}' unless defined(&AUE_PFLOAT);
    eval 'sub AUE_UPRIV () {157;}' unless defined(&AUE_UPRIV);
    eval 'sub AUE_IOCTL () {158;}' unless defined(&AUE_IOCTL);
    eval 'sub AUE_SOCKET () {183;}' unless defined(&AUE_SOCKET);
    eval 'sub AUE_SENDTO () {184;}' unless defined(&AUE_SENDTO);
    eval 'sub AUE_PIPE () {185;}' unless defined(&AUE_PIPE);
    eval 'sub AUE_SOCKETPAIR () {186;}' unless defined(&AUE_SOCKETPAIR);
    eval 'sub AUE_SEND () {187;}' unless defined(&AUE_SEND);
    eval 'sub AUE_SENDMSG () {188;}' unless defined(&AUE_SENDMSG);
    eval 'sub AUE_RECV () {189;}' unless defined(&AUE_RECV);
    eval 'sub AUE_RECVMSG () {190;}' unless defined(&AUE_RECVMSG);
    eval 'sub AUE_RECVFROM () {191;}' unless defined(&AUE_RECVFROM);
    eval 'sub AUE_READ () {192;}' unless defined(&AUE_READ);
    eval 'sub AUE_GETDENTS () {193;}' unless defined(&AUE_GETDENTS);
    eval 'sub AUE_LSEEK () {194;}' unless defined(&AUE_LSEEK);
    eval 'sub AUE_WRITE () {195;}' unless defined(&AUE_WRITE);
    eval 'sub AUE_WRITEV () {196;}' unless defined(&AUE_WRITEV);
    eval 'sub AUE_NFS () {197;}' unless defined(&AUE_NFS);
    eval 'sub AUE_READV () {198;}' unless defined(&AUE_READV);
    eval 'sub AUE_OSTAT () {199;}' unless defined(&AUE_OSTAT);
    eval 'sub AUE_SETUID () {200;}' unless defined(&AUE_SETUID);
    eval 'sub AUE_STIME () {201;}' unless defined(&AUE_STIME);
    eval 'sub AUE_UTIME () {202;}' unless defined(&AUE_UTIME);
    eval 'sub AUE_NICE () {203;}' unless defined(&AUE_NICE);
    eval 'sub AUE_OSETPGRP () {204;}' unless defined(&AUE_OSETPGRP);
    eval 'sub AUE_SETGID () {205;}' unless defined(&AUE_SETGID);
    eval 'sub AUE_READL () {206;}' unless defined(&AUE_READL);
    eval 'sub AUE_READVL () {207;}' unless defined(&AUE_READVL);
    eval 'sub AUE_FSTAT () {208;}' unless defined(&AUE_FSTAT);
    eval 'sub AUE_DUP2 () {209;}' unless defined(&AUE_DUP2);
    eval 'sub AUE_MMAP () {210;}' unless defined(&AUE_MMAP);
    eval 'sub AUE_AUDIT () {211;}' unless defined(&AUE_AUDIT);
    eval 'sub AUE_PRIOCNTLSYS () {212;}' unless defined(&AUE_PRIOCNTLSYS);
    eval 'sub AUE_MUNMAP () {213;}' unless defined(&AUE_MUNMAP);
    eval 'sub AUE_SETEGID () {214;}' unless defined(&AUE_SETEGID);
    eval 'sub AUE_SETEUID () {215;}' unless defined(&AUE_SETEUID);
    eval 'sub AUE_PUTMSG () {216;}' unless defined(&AUE_PUTMSG);
    eval 'sub AUE_GETMSG () {217;}' unless defined(&AUE_GETMSG);
    eval 'sub AUE_PUTPMSG () {218;}' unless defined(&AUE_PUTPMSG);
    eval 'sub AUE_GETPMSG () {219;}' unless defined(&AUE_GETPMSG);
    eval 'sub AUE_AUDITSYS () {220;}' unless defined(&AUE_AUDITSYS);
    eval 'sub AUE_AUDITON_GETKMASK () {221;}' unless defined(&AUE_AUDITON_GETKMASK);
    eval 'sub AUE_AUDITON_SETKMASK () {222;}' unless defined(&AUE_AUDITON_SETKMASK);
    eval 'sub AUE_AUDITON_GETCWD () {223;}' unless defined(&AUE_AUDITON_GETCWD);
    eval 'sub AUE_AUDITON_GETCAR () {224;}' unless defined(&AUE_AUDITON_GETCAR);
    eval 'sub AUE_AUDITON_GETSTAT () {225;}' unless defined(&AUE_AUDITON_GETSTAT);
    eval 'sub AUE_AUDITON_SETSTAT () {226;}' unless defined(&AUE_AUDITON_SETSTAT);
    eval 'sub AUE_AUDITON_SETUMASK () {227;}' unless defined(&AUE_AUDITON_SETUMASK);
    eval 'sub AUE_AUDITON_SETSMASK () {228;}' unless defined(&AUE_AUDITON_SETSMASK);
    eval 'sub AUE_AUDITON_GETCOND () {229;}' unless defined(&AUE_AUDITON_GETCOND);
    eval 'sub AUE_AUDITON_SETCOND () {230;}' unless defined(&AUE_AUDITON_SETCOND);
    eval 'sub AUE_AUDITON_GETCLASS () {231;}' unless defined(&AUE_AUDITON_GETCLASS);
    eval 'sub AUE_AUDITON_SETCLASS () {232;}' unless defined(&AUE_AUDITON_SETCLASS);
    eval 'sub AUE_FUSERS () {233;}' unless defined(&AUE_FUSERS);
    eval 'sub AUE_STATVFS () {234;}' unless defined(&AUE_STATVFS);
    eval 'sub AUE_XSTAT () {235;}' unless defined(&AUE_XSTAT);
    eval 'sub AUE_LXSTAT () {236;}' unless defined(&AUE_LXSTAT);
    eval 'sub AUE_LCHOWN () {237;}' unless defined(&AUE_LCHOWN);
    eval 'sub AUE_MEMCNTL () {238;}' unless defined(&AUE_MEMCNTL);
    eval 'sub AUE_SYSINFO () {239;}' unless defined(&AUE_SYSINFO);
    eval 'sub AUE_XMKNOD () {240;}' unless defined(&AUE_XMKNOD);
    eval 'sub AUE_FORK1 () {241;}' unless defined(&AUE_FORK1);
    eval 'sub AUE_MODCTL () {242;}' unless defined(&AUE_MODCTL);
    eval 'sub AUE_MODLOAD () {243;}' unless defined(&AUE_MODLOAD);
    eval 'sub AUE_MODUNLOAD () {244;}' unless defined(&AUE_MODUNLOAD);
    eval 'sub AUE_MODCONFIG () {245;}' unless defined(&AUE_MODCONFIG);
    eval 'sub AUE_MODADDMAJ () {246;}' unless defined(&AUE_MODADDMAJ);
    eval 'sub AUE_SOCKACCEPT () {247;}' unless defined(&AUE_SOCKACCEPT);
    eval 'sub AUE_SOCKCONNECT () {248;}' unless defined(&AUE_SOCKCONNECT);
    eval 'sub AUE_SOCKSEND () {249;}' unless defined(&AUE_SOCKSEND);
    eval 'sub AUE_SOCKRECEIVE () {250;}' unless defined(&AUE_SOCKRECEIVE);
    eval 'sub AUE_ACLSET () {251;}' unless defined(&AUE_ACLSET);
    eval 'sub AUE_FACLSET () {252;}' unless defined(&AUE_FACLSET);
    eval 'sub AUE_DOORFS () {253;}' unless defined(&AUE_DOORFS);
    eval 'sub AUE_DOORFS_DOOR_CALL () {254;}' unless defined(&AUE_DOORFS_DOOR_CALL);
    eval 'sub AUE_DOORFS_DOOR_RETURN () {255;}' unless defined(&AUE_DOORFS_DOOR_RETURN);
    eval 'sub AUE_DOORFS_DOOR_CREATE () {256;}' unless defined(&AUE_DOORFS_DOOR_CREATE);
    eval 'sub AUE_DOORFS_DOOR_REVOKE () {257;}' unless defined(&AUE_DOORFS_DOOR_REVOKE);
    eval 'sub AUE_DOORFS_DOOR_INFO () {258;}' unless defined(&AUE_DOORFS_DOOR_INFO);
    eval 'sub AUE_DOORFS_DOOR_CRED () {259;}' unless defined(&AUE_DOORFS_DOOR_CRED);
    eval 'sub AUE_DOORFS_DOOR_BIND () {260;}' unless defined(&AUE_DOORFS_DOOR_BIND);
    eval 'sub AUE_DOORFS_DOOR_UNBIND () {261;}' unless defined(&AUE_DOORFS_DOOR_UNBIND);
    eval 'sub AUE_P_ONLINE () {262;}' unless defined(&AUE_P_ONLINE);
    eval 'sub AUE_PROCESSOR_BIND () {263;}' unless defined(&AUE_PROCESSOR_BIND);
    eval 'sub AUE_INST_SYNC () {264;}' unless defined(&AUE_INST_SYNC);
    eval 'sub AUE_SOCKCONFIG () {265;}' unless defined(&AUE_SOCKCONFIG);
    eval 'sub AUE_SETAUDIT_ADDR () {266;}' unless defined(&AUE_SETAUDIT_ADDR);
    eval 'sub AUE_GETAUDIT_ADDR () {267;}' unless defined(&AUE_GETAUDIT_ADDR);
    eval 'sub AUE_UMOUNT2 () {268;}' unless defined(&AUE_UMOUNT2);
    eval 'sub AUE_FSAT () {269;}' unless defined(&AUE_FSAT);
    eval 'sub AUE_OPENAT_R () {270;}' unless defined(&AUE_OPENAT_R);
    eval 'sub AUE_OPENAT_RC () {271;}' unless defined(&AUE_OPENAT_RC);
    eval 'sub AUE_OPENAT_RT () {272;}' unless defined(&AUE_OPENAT_RT);
    eval 'sub AUE_OPENAT_RTC () {273;}' unless defined(&AUE_OPENAT_RTC);
    eval 'sub AUE_OPENAT_W () {274;}' unless defined(&AUE_OPENAT_W);
    eval 'sub AUE_OPENAT_WC () {275;}' unless defined(&AUE_OPENAT_WC);
    eval 'sub AUE_OPENAT_WT () {276;}' unless defined(&AUE_OPENAT_WT);
    eval 'sub AUE_OPENAT_WTC () {277;}' unless defined(&AUE_OPENAT_WTC);
    eval 'sub AUE_OPENAT_RW () {278;}' unless defined(&AUE_OPENAT_RW);
    eval 'sub AUE_OPENAT_RWC () {279;}' unless defined(&AUE_OPENAT_RWC);
    eval 'sub AUE_OPENAT_RWT () {280;}' unless defined(&AUE_OPENAT_RWT);
    eval 'sub AUE_OPENAT_RWTC () {281;}' unless defined(&AUE_OPENAT_RWTC);
    eval 'sub AUE_RENAMEAT () {282;}' unless defined(&AUE_RENAMEAT);
    eval 'sub AUE_FSTATAT () {283;}' unless defined(&AUE_FSTATAT);
    eval 'sub AUE_FCHOWNAT () {284;}' unless defined(&AUE_FCHOWNAT);
    eval 'sub AUE_FUTIMESAT () {285;}' unless defined(&AUE_FUTIMESAT);
    eval 'sub AUE_UNLINKAT () {286;}' unless defined(&AUE_UNLINKAT);
    eval 'sub AUE_CLOCK_SETTIME () {287;}' unless defined(&AUE_CLOCK_SETTIME);
    eval 'sub AUE_NTP_ADJTIME () {288;}' unless defined(&AUE_NTP_ADJTIME);
    eval 'sub AUE_SETPPRIV () {289;}' unless defined(&AUE_SETPPRIV);
    eval 'sub AUE_MODDEVPLCY () {290;}' unless defined(&AUE_MODDEVPLCY);
    eval 'sub AUE_MODADDPRIV () {291;}' unless defined(&AUE_MODADDPRIV);
    eval 'sub AUE_CRYPTOADM () {292;}' unless defined(&AUE_CRYPTOADM);
    eval 'sub AUE_CONFIGKSSL () {293;}' unless defined(&AUE_CONFIGKSSL);
    eval 'sub AUE_BRANDSYS () {294;}' unless defined(&AUE_BRANDSYS);
    eval 'sub AUE_PF_POLICY_ADDRULE () {295;}' unless defined(&AUE_PF_POLICY_ADDRULE);
    eval 'sub AUE_PF_POLICY_DELRULE () {296;}' unless defined(&AUE_PF_POLICY_DELRULE);
    eval 'sub AUE_PF_POLICY_CLONE () {297;}' unless defined(&AUE_PF_POLICY_CLONE);
    eval 'sub AUE_PF_POLICY_FLIP () {298;}' unless defined(&AUE_PF_POLICY_FLIP);
    eval 'sub AUE_PF_POLICY_FLUSH () {299;}' unless defined(&AUE_PF_POLICY_FLUSH);
    eval 'sub AUE_PF_POLICY_ALGS () {300;}' unless defined(&AUE_PF_POLICY_ALGS);
    eval 'sub AUE_PORTFS () {301;}' unless defined(&AUE_PORTFS);
    eval 'sub AUE_DARWIN_GETFSSTAT () {301;}' unless defined(&AUE_DARWIN_GETFSSTAT);
    eval 'sub AUE_DARWIN_PTRACE () {302;}' unless defined(&AUE_DARWIN_PTRACE);
    eval 'sub AUE_DARWIN_CHFLAGS () {303;}' unless defined(&AUE_DARWIN_CHFLAGS);
    eval 'sub AUE_DARWIN_FCHFLAGS () {304;}' unless defined(&AUE_DARWIN_FCHFLAGS);
    eval 'sub AUE_DARWIN_PROFILE () {305;}' unless defined(&AUE_DARWIN_PROFILE);
    eval 'sub AUE_DARWIN_KTRACE () {306;}' unless defined(&AUE_DARWIN_KTRACE);
    eval 'sub AUE_DARWIN_SETLOGIN () {307;}' unless defined(&AUE_DARWIN_SETLOGIN);
    eval 'sub AUE_DARWIN_REBOOT () {308;}' unless defined(&AUE_DARWIN_REBOOT);
    eval 'sub AUE_DARWIN_REVOKE () {309;}' unless defined(&AUE_DARWIN_REVOKE);
    eval 'sub AUE_DARWIN_UMASK () {310;}' unless defined(&AUE_DARWIN_UMASK);
    eval 'sub AUE_DARWIN_MPROTECT () {311;}' unless defined(&AUE_DARWIN_MPROTECT);
    eval 'sub AUE_DARWIN_SETPRIORITY () {312;}' unless defined(&AUE_DARWIN_SETPRIORITY);
    eval 'sub AUE_DARWIN_SETTIMEOFDAY () {313;}' unless defined(&AUE_DARWIN_SETTIMEOFDAY);
    eval 'sub AUE_DARWIN_FLOCK () {314;}' unless defined(&AUE_DARWIN_FLOCK);
    eval 'sub AUE_DARWIN_MKFIFO () {315;}' unless defined(&AUE_DARWIN_MKFIFO);
    eval 'sub AUE_DARWIN_POLL () {316;}' unless defined(&AUE_DARWIN_POLL);
    eval 'sub AUE_DARWIN_SOCKETPAIR () {317;}' unless defined(&AUE_DARWIN_SOCKETPAIR);
    eval 'sub AUE_DARWIN_FUTIMES () {318;}' unless defined(&AUE_DARWIN_FUTIMES);
    eval 'sub AUE_DARWIN_SETSID () {319;}' unless defined(&AUE_DARWIN_SETSID);
    eval 'sub AUE_DARWIN_SETPRIVEXEC () {320;}' unless defined(&AUE_DARWIN_SETPRIVEXEC);
    eval 'sub AUE_DARWIN_NFSSVC () {321;}' unless defined(&AUE_DARWIN_NFSSVC);
    eval 'sub AUE_DARWIN_GETFH () {322;}' unless defined(&AUE_DARWIN_GETFH);
    eval 'sub AUE_DARWIN_QUOTACTL () {323;}' unless defined(&AUE_DARWIN_QUOTACTL);
    eval 'sub AUE_DARWIN_ADDPROFILE () {324;}' unless defined(&AUE_DARWIN_ADDPROFILE);
    eval 'sub AUE_DARWIN_KDEBUGTRACE () {325;}' unless defined(&AUE_DARWIN_KDEBUGTRACE);
    eval 'sub AUE_DARWIN_KDBUGTRACE () { &AUE_KDEBUGTRACE;}' unless defined(&AUE_DARWIN_KDBUGTRACE);
    eval 'sub AUE_DARWIN_FSTAT () {326;}' unless defined(&AUE_DARWIN_FSTAT);
    eval 'sub AUE_DARWIN_FPATHCONF () {327;}' unless defined(&AUE_DARWIN_FPATHCONF);
    eval 'sub AUE_DARWIN_GETDIRENTRIES () {328;}' unless defined(&AUE_DARWIN_GETDIRENTRIES);
    eval 'sub AUE_DARWIN_TRUNCATE () {329;}' unless defined(&AUE_DARWIN_TRUNCATE);
    eval 'sub AUE_DARWIN_FTRUNCATE () {330;}' unless defined(&AUE_DARWIN_FTRUNCATE);
    eval 'sub AUE_DARWIN_SYSCTL () {331;}' unless defined(&AUE_DARWIN_SYSCTL);
    eval 'sub AUE_DARWIN_MLOCK () {332;}' unless defined(&AUE_DARWIN_MLOCK);
    eval 'sub AUE_DARWIN_MUNLOCK () {333;}' unless defined(&AUE_DARWIN_MUNLOCK);
    eval 'sub AUE_DARWIN_UNDELETE () {334;}' unless defined(&AUE_DARWIN_UNDELETE);
    eval 'sub AUE_DARWIN_GETATTRLIST () {335;}' unless defined(&AUE_DARWIN_GETATTRLIST);
    eval 'sub AUE_DARWIN_SETATTRLIST () {336;}' unless defined(&AUE_DARWIN_SETATTRLIST);
    eval 'sub AUE_DARWIN_GETDIRENTRIESATTR () {337;}' unless defined(&AUE_DARWIN_GETDIRENTRIESATTR);
    eval 'sub AUE_DARWIN_EXCHANGEDATA () {338;}' unless defined(&AUE_DARWIN_EXCHANGEDATA);
    eval 'sub AUE_DARWIN_SEARCHFS () {339;}' unless defined(&AUE_DARWIN_SEARCHFS);
    eval 'sub AUE_DARWIN_MINHERIT () {340;}' unless defined(&AUE_DARWIN_MINHERIT);
    eval 'sub AUE_DARWIN_SEMCONFIG () {341;}' unless defined(&AUE_DARWIN_SEMCONFIG);
    eval 'sub AUE_DARWIN_SEMOPEN () {342;}' unless defined(&AUE_DARWIN_SEMOPEN);
    eval 'sub AUE_DARWIN_SEMCLOSE () {343;}' unless defined(&AUE_DARWIN_SEMCLOSE);
    eval 'sub AUE_DARWIN_SEMUNLINK () {344;}' unless defined(&AUE_DARWIN_SEMUNLINK);
    eval 'sub AUE_DARWIN_SHMOPEN () {345;}' unless defined(&AUE_DARWIN_SHMOPEN);
    eval 'sub AUE_DARWIN_SHMUNLINK () {346;}' unless defined(&AUE_DARWIN_SHMUNLINK);
    eval 'sub AUE_DARWIN_LOADSHFILE () {347;}' unless defined(&AUE_DARWIN_LOADSHFILE);
    eval 'sub AUE_DARWIN_RESETSHFILE () {348;}' unless defined(&AUE_DARWIN_RESETSHFILE);
    eval 'sub AUE_DARWIN_NEWSYSTEMSHREG () {349;}' unless defined(&AUE_DARWIN_NEWSYSTEMSHREG);
    eval 'sub AUE_DARWIN_PTHREADKILL () {350;}' unless defined(&AUE_DARWIN_PTHREADKILL);
    eval 'sub AUE_DARWIN_PTHREADSIGMASK () {351;}' unless defined(&AUE_DARWIN_PTHREADSIGMASK);
    eval 'sub AUE_DARWIN_AUDITCTL () {352;}' unless defined(&AUE_DARWIN_AUDITCTL);
    eval 'sub AUE_DARWIN_RFORK () {353;}' unless defined(&AUE_DARWIN_RFORK);
    eval 'sub AUE_DARWIN_LCHMOD () {354;}' unless defined(&AUE_DARWIN_LCHMOD);
    eval 'sub AUE_DARWIN_SWAPOFF () {355;}' unless defined(&AUE_DARWIN_SWAPOFF);
    eval 'sub AUE_DARWIN_INITPROCESS () {356;}' unless defined(&AUE_DARWIN_INITPROCESS);
    eval 'sub AUE_DARWIN_MAPFD () {357;}' unless defined(&AUE_DARWIN_MAPFD);
    eval 'sub AUE_DARWIN_TASKFORPID () {358;}' unless defined(&AUE_DARWIN_TASKFORPID);
    eval 'sub AUE_DARWIN_PIDFORTASK () {359;}' unless defined(&AUE_DARWIN_PIDFORTASK);
    eval 'sub AUE_DARWIN_SYSCTL_NONADMIN () {360;}' unless defined(&AUE_DARWIN_SYSCTL_NONADMIN);
    eval 'sub AUE_DARWIN_COPYFILE () {361;}' unless defined(&AUE_DARWIN_COPYFILE);
    eval 'sub AUE_GETFSSTAT () {43001;}' unless defined(&AUE_GETFSSTAT);
    eval 'sub AUE_PTRACE () {43002;}' unless defined(&AUE_PTRACE);
    eval 'sub AUE_CHFLAGS () {43003;}' unless defined(&AUE_CHFLAGS);
    eval 'sub AUE_FCHFLAGS () {43004;}' unless defined(&AUE_FCHFLAGS);
    eval 'sub AUE_PROFILE () {43005;}' unless defined(&AUE_PROFILE);
    eval 'sub AUE_KTRACE () {43006;}' unless defined(&AUE_KTRACE);
    eval 'sub AUE_SETLOGIN () {43007;}' unless defined(&AUE_SETLOGIN);
    eval 'sub AUE_OPENBSM_REVOKE () {43008;}' unless defined(&AUE_OPENBSM_REVOKE);
    eval 'sub AUE_UMASK () {43009;}' unless defined(&AUE_UMASK);
    eval 'sub AUE_MPROTECT () {43010;}' unless defined(&AUE_MPROTECT);
    eval 'sub AUE_MKFIFO () {43011;}' unless defined(&AUE_MKFIFO);
    eval 'sub AUE_POLL () {43012;}' unless defined(&AUE_POLL);
    eval 'sub AUE_FUTIMES () {43013;}' unless defined(&AUE_FUTIMES);
    eval 'sub AUE_SETSID () {43014;}' unless defined(&AUE_SETSID);
    eval 'sub AUE_SETPRIVEXEC () {43015;}' unless defined(&AUE_SETPRIVEXEC);
    eval 'sub AUE_ADDPROFILE () {43016;}' unless defined(&AUE_ADDPROFILE);
    eval 'sub AUE_KDEBUGTRACE () {43017;}' unless defined(&AUE_KDEBUGTRACE);
    eval 'sub AUE_KDBUGTRACE () { &AUE_KDEBUGTRACE;}' unless defined(&AUE_KDBUGTRACE);
    eval 'sub AUE_OPENBSM_FSTAT () {43018;}' unless defined(&AUE_OPENBSM_FSTAT);
    eval 'sub AUE_FPATHCONF () {43019;}' unless defined(&AUE_FPATHCONF);
    eval 'sub AUE_GETDIRENTRIES () {43020;}' unless defined(&AUE_GETDIRENTRIES);
    eval 'sub AUE_SYSCTL () {43021;}' unless defined(&AUE_SYSCTL);
    eval 'sub AUE_MLOCK () {43022;}' unless defined(&AUE_MLOCK);
    eval 'sub AUE_MUNLOCK () {43023;}' unless defined(&AUE_MUNLOCK);
    eval 'sub AUE_UNDELETE () {43024;}' unless defined(&AUE_UNDELETE);
    eval 'sub AUE_GETATTRLIST () {43025;}' unless defined(&AUE_GETATTRLIST);
    eval 'sub AUE_SETATTRLIST () {43026;}' unless defined(&AUE_SETATTRLIST);
    eval 'sub AUE_GETDIRENTRIESATTR () {43027;}' unless defined(&AUE_GETDIRENTRIESATTR);
    eval 'sub AUE_EXCHANGEDATA () {43028;}' unless defined(&AUE_EXCHANGEDATA);
    eval 'sub AUE_SEARCHFS () {43029;}' unless defined(&AUE_SEARCHFS);
    eval 'sub AUE_MINHERIT () {43030;}' unless defined(&AUE_MINHERIT);
    eval 'sub AUE_SEMCONFIG () {43031;}' unless defined(&AUE_SEMCONFIG);
    eval 'sub AUE_SEMOPEN () {43032;}' unless defined(&AUE_SEMOPEN);
    eval 'sub AUE_SEMCLOSE () {43033;}' unless defined(&AUE_SEMCLOSE);
    eval 'sub AUE_SEMUNLINK () {43034;}' unless defined(&AUE_SEMUNLINK);
    eval 'sub AUE_SHMOPEN () {43035;}' unless defined(&AUE_SHMOPEN);
    eval 'sub AUE_SHMUNLINK () {43036;}' unless defined(&AUE_SHMUNLINK);
    eval 'sub AUE_LOADSHFILE () {43037;}' unless defined(&AUE_LOADSHFILE);
    eval 'sub AUE_RESETSHFILE () {43038;}' unless defined(&AUE_RESETSHFILE);
    eval 'sub AUE_NEWSYSTEMSHREG () {43039;}' unless defined(&AUE_NEWSYSTEMSHREG);
    eval 'sub AUE_PTHREADKILL () {43040;}' unless defined(&AUE_PTHREADKILL);
    eval 'sub AUE_PTHREADSIGMASK () {43041;}' unless defined(&AUE_PTHREADSIGMASK);
    eval 'sub AUE_AUDITCTL () {43042;}' unless defined(&AUE_AUDITCTL);
    eval 'sub AUE_RFORK () {43043;}' unless defined(&AUE_RFORK);
    eval 'sub AUE_LCHMOD () {43044;}' unless defined(&AUE_LCHMOD);
    eval 'sub AUE_SWAPOFF () {43045;}' unless defined(&AUE_SWAPOFF);
    eval 'sub AUE_INITPROCESS () {43046;}' unless defined(&AUE_INITPROCESS);
    eval 'sub AUE_MAPFD () {43047;}' unless defined(&AUE_MAPFD);
    eval 'sub AUE_TASKFORPID () {43048;}' unless defined(&AUE_TASKFORPID);
    eval 'sub AUE_PIDFORTASK () {43049;}' unless defined(&AUE_PIDFORTASK);
    eval 'sub AUE_SYSCTL_NONADMIN () {43050;}' unless defined(&AUE_SYSCTL_NONADMIN);
    eval 'sub AUE_COPYFILE () {43051;}' unless defined(&AUE_COPYFILE);
    eval 'sub AUE_LUTIMES () {43052;}' unless defined(&AUE_LUTIMES);
    eval 'sub AUE_LCHFLAGS () {43053;}' unless defined(&AUE_LCHFLAGS);
    eval 'sub AUE_SENDFILE () {43054;}' unless defined(&AUE_SENDFILE);
    eval 'sub AUE_USELIB () {43055;}' unless defined(&AUE_USELIB);
    eval 'sub AUE_GETRESUID () {43056;}' unless defined(&AUE_GETRESUID);
    eval 'sub AUE_SETRESUID () {43057;}' unless defined(&AUE_SETRESUID);
    eval 'sub AUE_GETRESGID () {43058;}' unless defined(&AUE_GETRESGID);
    eval 'sub AUE_SETRESGID () {43059;}' unless defined(&AUE_SETRESGID);
    eval 'sub AUE_WAIT4 () {43060;}' unless defined(&AUE_WAIT4);
    eval 'sub AUE_LGETFH () {43061;}' unless defined(&AUE_LGETFH);
    eval 'sub AUE_FHSTATFS () {43062;}' unless defined(&AUE_FHSTATFS);
    eval 'sub AUE_FHOPEN () {43063;}' unless defined(&AUE_FHOPEN);
    eval 'sub AUE_FHSTAT () {43064;}' unless defined(&AUE_FHSTAT);
    eval 'sub AUE_JAIL () {43065;}' unless defined(&AUE_JAIL);
    eval 'sub AUE_EACCESS () {43066;}' unless defined(&AUE_EACCESS);
    eval 'sub AUE_KQUEUE () {43067;}' unless defined(&AUE_KQUEUE);
    eval 'sub AUE_KEVENT () {43068;}' unless defined(&AUE_KEVENT);
    eval 'sub AUE_FSYNC () {43069;}' unless defined(&AUE_FSYNC);
    eval 'sub AUE_NMOUNT () {43070;}' unless defined(&AUE_NMOUNT);
    eval 'sub AUE_BDFLUSH () {43071;}' unless defined(&AUE_BDFLUSH);
    eval 'sub AUE_SETFSUID () {43072;}' unless defined(&AUE_SETFSUID);
    eval 'sub AUE_SETFSGID () {43073;}' unless defined(&AUE_SETFSGID);
    eval 'sub AUE_PERSONALITY () {43074;}' unless defined(&AUE_PERSONALITY);
    eval 'sub AUE_SCHED_GETSCHEDULER () {43075;}' unless defined(&AUE_SCHED_GETSCHEDULER);
    eval 'sub AUE_SCHED_SETSCHEDULER () {43076;}' unless defined(&AUE_SCHED_SETSCHEDULER);
    eval 'sub AUE_PRCTL () {43077;}' unless defined(&AUE_PRCTL);
    eval 'sub AUE_GETCWD () {43078;}' unless defined(&AUE_GETCWD);
    eval 'sub AUE_CAPGET () {43079;}' unless defined(&AUE_CAPGET);
    eval 'sub AUE_CAPSET () {43080;}' unless defined(&AUE_CAPSET);
    eval 'sub AUE_PIVOT_ROOT () {43081;}' unless defined(&AUE_PIVOT_ROOT);
    eval 'sub AUE_RTPRIO () {43082;}' unless defined(&AUE_RTPRIO);
    eval 'sub AUE_SCHED_GETPARAM () {43083;}' unless defined(&AUE_SCHED_GETPARAM);
    eval 'sub AUE_SCHED_SETPARAM () {43084;}' unless defined(&AUE_SCHED_SETPARAM);
    eval 'sub AUE_SCHED_GET_PRIORITY_MAX () {43085;}' unless defined(&AUE_SCHED_GET_PRIORITY_MAX);
    eval 'sub AUE_SCHED_GET_PRIORITY_MIN () {43086;}' unless defined(&AUE_SCHED_GET_PRIORITY_MIN);
    eval 'sub AUE_SCHED_RR_GET_INTERVAL () {43087;}' unless defined(&AUE_SCHED_RR_GET_INTERVAL);
    eval 'sub AUE_ACL_GET_FILE () {43088;}' unless defined(&AUE_ACL_GET_FILE);
    eval 'sub AUE_ACL_SET_FILE () {43089;}' unless defined(&AUE_ACL_SET_FILE);
    eval 'sub AUE_ACL_GET_FD () {43090;}' unless defined(&AUE_ACL_GET_FD);
    eval 'sub AUE_ACL_SET_FD () {43091;}' unless defined(&AUE_ACL_SET_FD);
    eval 'sub AUE_ACL_DELETE_FILE () {43092;}' unless defined(&AUE_ACL_DELETE_FILE);
    eval 'sub AUE_ACL_DELETE_FD () {43093;}' unless defined(&AUE_ACL_DELETE_FD);
    eval 'sub AUE_ACL_CHECK_FILE () {43094;}' unless defined(&AUE_ACL_CHECK_FILE);
    eval 'sub AUE_ACL_CHECK_FD () {43095;}' unless defined(&AUE_ACL_CHECK_FD);
    eval 'sub AUE_ACL_GET_LINK () {43096;}' unless defined(&AUE_ACL_GET_LINK);
    eval 'sub AUE_ACL_SET_LINK () {43097;}' unless defined(&AUE_ACL_SET_LINK);
    eval 'sub AUE_ACL_DELETE_LINK () {43098;}' unless defined(&AUE_ACL_DELETE_LINK);
    eval 'sub AUE_ACL_CHECK_LINK () {43099;}' unless defined(&AUE_ACL_CHECK_LINK);
    eval 'sub AUE_SYSARCH () {43100;}' unless defined(&AUE_SYSARCH);
    eval 'sub AUE_EXTATTRCTL () {43101;}' unless defined(&AUE_EXTATTRCTL);
    eval 'sub AUE_EXTATTR_GET_FILE () {43102;}' unless defined(&AUE_EXTATTR_GET_FILE);
    eval 'sub AUE_EXTATTR_SET_FILE () {43103;}' unless defined(&AUE_EXTATTR_SET_FILE);
    eval 'sub AUE_EXTATTR_LIST_FILE () {43104;}' unless defined(&AUE_EXTATTR_LIST_FILE);
    eval 'sub AUE_EXTATTR_DELETE_FILE () {43105;}' unless defined(&AUE_EXTATTR_DELETE_FILE);
    eval 'sub AUE_EXTATTR_GET_FD () {43106;}' unless defined(&AUE_EXTATTR_GET_FD);
    eval 'sub AUE_EXTATTR_SET_FD () {43107;}' unless defined(&AUE_EXTATTR_SET_FD);
    eval 'sub AUE_EXTATTR_LIST_FD () {43108;}' unless defined(&AUE_EXTATTR_LIST_FD);
    eval 'sub AUE_EXTATTR_DELETE_FD () {43109;}' unless defined(&AUE_EXTATTR_DELETE_FD);
    eval 'sub AUE_EXTATTR_GET_LINK () {43110;}' unless defined(&AUE_EXTATTR_GET_LINK);
    eval 'sub AUE_EXTATTR_SET_LINK () {43111;}' unless defined(&AUE_EXTATTR_SET_LINK);
    eval 'sub AUE_EXTATTR_LIST_LINK () {43112;}' unless defined(&AUE_EXTATTR_LIST_LINK);
    eval 'sub AUE_EXTATTR_DELETE_LINK () {43113;}' unless defined(&AUE_EXTATTR_DELETE_LINK);
    eval 'sub AUE_KENV () {43114;}' unless defined(&AUE_KENV);
    eval 'sub AUE_JAIL_ATTACH () {43115;}' unless defined(&AUE_JAIL_ATTACH);
    eval 'sub AUE_SYSCTL_WRITE () {43116;}' unless defined(&AUE_SYSCTL_WRITE);
    eval 'sub AUE_IOPERM () {43117;}' unless defined(&AUE_IOPERM);
    eval 'sub AUE_READDIR () {43118;}' unless defined(&AUE_READDIR);
    eval 'sub AUE_IOPL () {43119;}' unless defined(&AUE_IOPL);
    eval 'sub AUE_VM86 () {43120;}' unless defined(&AUE_VM86);
    eval 'sub AUE_MAC_GET_PROC () {43121;}' unless defined(&AUE_MAC_GET_PROC);
    eval 'sub AUE_MAC_SET_PROC () {43122;}' unless defined(&AUE_MAC_SET_PROC);
    eval 'sub AUE_MAC_GET_FD () {43123;}' unless defined(&AUE_MAC_GET_FD);
    eval 'sub AUE_MAC_GET_FILE () {43124;}' unless defined(&AUE_MAC_GET_FILE);
    eval 'sub AUE_MAC_SET_FD () {43125;}' unless defined(&AUE_MAC_SET_FD);
    eval 'sub AUE_MAC_SET_FILE () {43126;}' unless defined(&AUE_MAC_SET_FILE);
    eval 'sub AUE_MAC_SYSCALL () {43127;}' unless defined(&AUE_MAC_SYSCALL);
    eval 'sub AUE_MAC_GET_PID () {43128;}' unless defined(&AUE_MAC_GET_PID);
    eval 'sub AUE_MAC_GET_LINK () {43129;}' unless defined(&AUE_MAC_GET_LINK);
    eval 'sub AUE_MAC_SET_LINK () {43130;}' unless defined(&AUE_MAC_SET_LINK);
    eval 'sub AUE_MAC_EXECVE () {43131;}' unless defined(&AUE_MAC_EXECVE);
    eval 'sub AUE_GETPATH_FROMFD () {43132;}' unless defined(&AUE_GETPATH_FROMFD);
    eval 'sub AUE_GETPATH_FROMADDR () {43133;}' unless defined(&AUE_GETPATH_FROMADDR);
    eval 'sub AUE_MQ_OPEN () {43134;}' unless defined(&AUE_MQ_OPEN);
    eval 'sub AUE_MQ_SETATTR () {43135;}' unless defined(&AUE_MQ_SETATTR);
    eval 'sub AUE_MQ_TIMEDRECEIVE () {43136;}' unless defined(&AUE_MQ_TIMEDRECEIVE);
    eval 'sub AUE_MQ_TIMEDSEND () {43137;}' unless defined(&AUE_MQ_TIMEDSEND);
    eval 'sub AUE_MQ_NOTIFY () {43138;}' unless defined(&AUE_MQ_NOTIFY);
    eval 'sub AUE_MQ_UNLINK () {43139;}' unless defined(&AUE_MQ_UNLINK);
    eval 'sub AUE_LISTEN () {43140;}' unless defined(&AUE_LISTEN);
    eval 'sub AUE_MLOCKALL () {43141;}' unless defined(&AUE_MLOCKALL);
    eval 'sub AUE_MUNLOCKALL () {43142;}' unless defined(&AUE_MUNLOCKALL);
    eval 'sub AUE_CLOSEFROM () {43143;}' unless defined(&AUE_CLOSEFROM);
    eval 'sub AUE_FEXECVE () {43144;}' unless defined(&AUE_FEXECVE);
    eval 'sub AUE_FACCESSAT () {43145;}' unless defined(&AUE_FACCESSAT);
    eval 'sub AUE_FCHMODAT () {43146;}' unless defined(&AUE_FCHMODAT);
    eval 'sub AUE_LINKAT () {43147;}' unless defined(&AUE_LINKAT);
    eval 'sub AUE_MKDIRAT () {43148;}' unless defined(&AUE_MKDIRAT);
    eval 'sub AUE_MKFIFOAT () {43149;}' unless defined(&AUE_MKFIFOAT);
    eval 'sub AUE_MKNODAT () {43150;}' unless defined(&AUE_MKNODAT);
    eval 'sub AUE_READLINKAT () {43151;}' unless defined(&AUE_READLINKAT);
    eval 'sub AUE_SYMLINKAT () {43152;}' unless defined(&AUE_SYMLINKAT);
    eval 'sub AUE_MAC_GETFSSTAT () {43153;}' unless defined(&AUE_MAC_GETFSSTAT);
    eval 'sub AUE_MAC_GET_MOUNT () {43154;}' unless defined(&AUE_MAC_GET_MOUNT);
    eval 'sub AUE_MAC_GET_LCID () {43155;}' unless defined(&AUE_MAC_GET_LCID);
    eval 'sub AUE_MAC_GET_LCTX () {43156;}' unless defined(&AUE_MAC_GET_LCTX);
    eval 'sub AUE_MAC_SET_LCTX () {43157;}' unless defined(&AUE_MAC_SET_LCTX);
    eval 'sub AUE_MAC_MOUNT () {43158;}' unless defined(&AUE_MAC_MOUNT);
    eval 'sub AUE_GETLCID () {43159;}' unless defined(&AUE_GETLCID);
    eval 'sub AUE_SETLCID () {43160;}' unless defined(&AUE_SETLCID);
    eval 'sub AUE_TASKNAMEFORPID () {43161;}' unless defined(&AUE_TASKNAMEFORPID);
    eval 'sub AUE_ACCESS_EXTENDED () {43162;}' unless defined(&AUE_ACCESS_EXTENDED);
    eval 'sub AUE_CHMOD_EXTENDED () {43163;}' unless defined(&AUE_CHMOD_EXTENDED);
    eval 'sub AUE_FCHMOD_EXTENDED () {43164;}' unless defined(&AUE_FCHMOD_EXTENDED);
    eval 'sub AUE_FSTAT_EXTENDED () {43165;}' unless defined(&AUE_FSTAT_EXTENDED);
    eval 'sub AUE_LSTAT_EXTENDED () {43166;}' unless defined(&AUE_LSTAT_EXTENDED);
    eval 'sub AUE_MKDIR_EXTENDED () {43167;}' unless defined(&AUE_MKDIR_EXTENDED);
    eval 'sub AUE_MKFIFO_EXTENDED () {43168;}' unless defined(&AUE_MKFIFO_EXTENDED);
    eval 'sub AUE_OPEN_EXTENDED () {43169;}' unless defined(&AUE_OPEN_EXTENDED);
    eval 'sub AUE_OPEN_EXTENDED_R () {43170;}' unless defined(&AUE_OPEN_EXTENDED_R);
    eval 'sub AUE_OPEN_EXTENDED_RC () {43171;}' unless defined(&AUE_OPEN_EXTENDED_RC);
    eval 'sub AUE_OPEN_EXTENDED_RT () {43172;}' unless defined(&AUE_OPEN_EXTENDED_RT);
    eval 'sub AUE_OPEN_EXTENDED_RTC () {43173;}' unless defined(&AUE_OPEN_EXTENDED_RTC);
    eval 'sub AUE_OPEN_EXTENDED_W () {43174;}' unless defined(&AUE_OPEN_EXTENDED_W);
    eval 'sub AUE_OPEN_EXTENDED_WC () {43175;}' unless defined(&AUE_OPEN_EXTENDED_WC);
    eval 'sub AUE_OPEN_EXTENDED_WT () {43176;}' unless defined(&AUE_OPEN_EXTENDED_WT);
    eval 'sub AUE_OPEN_EXTENDED_WTC () {43177;}' unless defined(&AUE_OPEN_EXTENDED_WTC);
    eval 'sub AUE_OPEN_EXTENDED_RW () {43178;}' unless defined(&AUE_OPEN_EXTENDED_RW);
    eval 'sub AUE_OPEN_EXTENDED_RWC () {43179;}' unless defined(&AUE_OPEN_EXTENDED_RWC);
    eval 'sub AUE_OPEN_EXTENDED_RWT () {43180;}' unless defined(&AUE_OPEN_EXTENDED_RWT);
    eval 'sub AUE_OPEN_EXTENDED_RWTC () {43181;}' unless defined(&AUE_OPEN_EXTENDED_RWTC);
    eval 'sub AUE_STAT_EXTENDED () {43182;}' unless defined(&AUE_STAT_EXTENDED);
    eval 'sub AUE_UMASK_EXTENDED () {43183;}' unless defined(&AUE_UMASK_EXTENDED);
    eval 'sub AUE_OPENAT () {43184;}' unless defined(&AUE_OPENAT);
    eval 'sub AUE_POSIX_OPENPT () {43185;}' unless defined(&AUE_POSIX_OPENPT);
    eval 'sub AUE_CAP_NEW () {43186;}' unless defined(&AUE_CAP_NEW);
    eval 'sub AUE_CAP_RIGHTS_GET () {43187;}' unless defined(&AUE_CAP_RIGHTS_GET);
    eval 'sub AUE_CAP_GETRIGHTS () { &AUE_CAP_RIGHTS_GET;}' unless defined(&AUE_CAP_GETRIGHTS);
    eval 'sub AUE_CAP_ENTER () {43188;}' unless defined(&AUE_CAP_ENTER);
    eval 'sub AUE_CAP_GETMODE () {43189;}' unless defined(&AUE_CAP_GETMODE);
    eval 'sub AUE_POSIX_SPAWN () {43190;}' unless defined(&AUE_POSIX_SPAWN);
    eval 'sub AUE_FSGETPATH () {43191;}' unless defined(&AUE_FSGETPATH);
    eval 'sub AUE_PREAD () {43192;}' unless defined(&AUE_PREAD);
    eval 'sub AUE_PWRITE () {43193;}' unless defined(&AUE_PWRITE);
    eval 'sub AUE_FSCTL () {43194;}' unless defined(&AUE_FSCTL);
    eval 'sub AUE_FFSCTL () {43195;}' unless defined(&AUE_FFSCTL);
    eval 'sub AUE_LPATHCONF () {43196;}' unless defined(&AUE_LPATHCONF);
    eval 'sub AUE_PDFORK () {43197;}' unless defined(&AUE_PDFORK);
    eval 'sub AUE_PDKILL () {43198;}' unless defined(&AUE_PDKILL);
    eval 'sub AUE_PDGETPID () {43199;}' unless defined(&AUE_PDGETPID);
    eval 'sub AUE_PDWAIT () {43200;}' unless defined(&AUE_PDWAIT);
    eval 'sub AUE_WAIT6 () {43201;}' unless defined(&AUE_WAIT6);
    eval 'sub AUE_CAP_RIGHTS_LIMIT () {43202;}' unless defined(&AUE_CAP_RIGHTS_LIMIT);
    eval 'sub AUE_CAP_IOCTLS_LIMIT () {43203;}' unless defined(&AUE_CAP_IOCTLS_LIMIT);
    eval 'sub AUE_CAP_IOCTLS_GET () {43204;}' unless defined(&AUE_CAP_IOCTLS_GET);
    eval 'sub AUE_CAP_FCNTLS_LIMIT () {43205;}' unless defined(&AUE_CAP_FCNTLS_LIMIT);
    eval 'sub AUE_CAP_FCNTLS_GET () {43206;}' unless defined(&AUE_CAP_FCNTLS_GET);
    eval 'sub AUE_BINDAT () {43207;}' unless defined(&AUE_BINDAT);
    eval 'sub AUE_CONNECTAT () {43208;}' unless defined(&AUE_CONNECTAT);
    eval 'sub AUE_CHFLAGSAT () {43209;}' unless defined(&AUE_CHFLAGSAT);
    eval 'sub AUE_O_CREAT () { &AUE_OPEN_RWTC;}' unless defined(&AUE_O_CREAT);
    eval 'sub AUE_O_EXECVE () { &AUE_NULL;}' unless defined(&AUE_O_EXECVE);
    eval 'sub AUE_O_SBREAK () { &AUE_NULL;}' unless defined(&AUE_O_SBREAK);
    eval 'sub AUE_O_LSEEK () { &AUE_NULL;}' unless defined(&AUE_O_LSEEK);
    eval 'sub AUE_O_MOUNT () { &AUE_NULL;}' unless defined(&AUE_O_MOUNT);
    eval 'sub AUE_O_UMOUNT () { &AUE_NULL;}' unless defined(&AUE_O_UMOUNT);
    eval 'sub AUE_O_STAT () { &AUE_STAT;}' unless defined(&AUE_O_STAT);
    eval 'sub AUE_O_LSTAT () { &AUE_LSTAT;}' unless defined(&AUE_O_LSTAT);
    eval 'sub AUE_O_FSTAT () { &AUE_FSTAT;}' unless defined(&AUE_O_FSTAT);
    eval 'sub AUE_O_GETPAGESIZE () { &AUE_NULL;}' unless defined(&AUE_O_GETPAGESIZE);
    eval 'sub AUE_O_VREAD () { &AUE_NULL;}' unless defined(&AUE_O_VREAD);
    eval 'sub AUE_O_VWRITE () { &AUE_NULL;}' unless defined(&AUE_O_VWRITE);
    eval 'sub AUE_O_MMAP () { &AUE_MMAP;}' unless defined(&AUE_O_MMAP);
    eval 'sub AUE_O_VADVISE () { &AUE_NULL;}' unless defined(&AUE_O_VADVISE);
    eval 'sub AUE_O_VHANGUP () { &AUE_NULL;}' unless defined(&AUE_O_VHANGUP);
    eval 'sub AUE_O_VLIMIT () { &AUE_NULL;}' unless defined(&AUE_O_VLIMIT);
    eval 'sub AUE_O_WAIT () { &AUE_NULL;}' unless defined(&AUE_O_WAIT);
    eval 'sub AUE_O_GETHOSTNAME () { &AUE_NULL;}' unless defined(&AUE_O_GETHOSTNAME);
    eval 'sub AUE_O_SETHOSTNAME () { &AUE_SYSCTL;}' unless defined(&AUE_O_SETHOSTNAME);
    eval 'sub AUE_O_GETDOPT () { &AUE_NULL;}' unless defined(&AUE_O_GETDOPT);
    eval 'sub AUE_O_SETDOPT () { &AUE_NULL;}' unless defined(&AUE_O_SETDOPT);
    eval 'sub AUE_O_ACCEPT () { &AUE_NULL;}' unless defined(&AUE_O_ACCEPT);
    eval 'sub AUE_O_SEND () { &AUE_SENDMSG;}' unless defined(&AUE_O_SEND);
    eval 'sub AUE_O_RECV () { &AUE_RECVMSG;}' unless defined(&AUE_O_RECV);
    eval 'sub AUE_O_VTIMES () { &AUE_NULL;}' unless defined(&AUE_O_VTIMES);
    eval 'sub AUE_O_SIGVEC () { &AUE_NULL;}' unless defined(&AUE_O_SIGVEC);
    eval 'sub AUE_O_SIGBLOCK () { &AUE_NULL;}' unless defined(&AUE_O_SIGBLOCK);
    eval 'sub AUE_O_SIGSETMASK () { &AUE_NULL;}' unless defined(&AUE_O_SIGSETMASK);
    eval 'sub AUE_O_SIGSTACK () { &AUE_NULL;}' unless defined(&AUE_O_SIGSTACK);
    eval 'sub AUE_O_RECVMSG () { &AUE_RECVMSG;}' unless defined(&AUE_O_RECVMSG);
    eval 'sub AUE_O_SENDMSG () { &AUE_SENDMSG;}' unless defined(&AUE_O_SENDMSG);
    eval 'sub AUE_O_VTRACE () { &AUE_NULL;}' unless defined(&AUE_O_VTRACE);
    eval 'sub AUE_O_RESUBA () { &AUE_NULL;}' unless defined(&AUE_O_RESUBA);
    eval 'sub AUE_O_RECVFROM () { &AUE_RECVFROM;}' unless defined(&AUE_O_RECVFROM);
    eval 'sub AUE_O_SETREUID () { &AUE_SETREUID;}' unless defined(&AUE_O_SETREUID);
    eval 'sub AUE_O_SETREGID () { &AUE_SETREGID;}' unless defined(&AUE_O_SETREGID);
    eval 'sub AUE_O_GETDIRENTRIES () { &AUE_GETDIRENTRIES;}' unless defined(&AUE_O_GETDIRENTRIES);
    eval 'sub AUE_O_TRUNCATE () { &AUE_TRUNCATE;}' unless defined(&AUE_O_TRUNCATE);
    eval 'sub AUE_O_FTRUNCATE () { &AUE_FTRUNCATE;}' unless defined(&AUE_O_FTRUNCATE);
    eval 'sub AUE_O_GETPEERNAME () { &AUE_NULL;}' unless defined(&AUE_O_GETPEERNAME);
    eval 'sub AUE_O_GETHOSTID () { &AUE_NULL;}' unless defined(&AUE_O_GETHOSTID);
    eval 'sub AUE_O_SETHOSTID () { &AUE_NULL;}' unless defined(&AUE_O_SETHOSTID);
    eval 'sub AUE_O_GETRLIMIT () { &AUE_NULL;}' unless defined(&AUE_O_GETRLIMIT);
    eval 'sub AUE_O_SETRLIMIT () { &AUE_SETRLIMIT;}' unless defined(&AUE_O_SETRLIMIT);
    eval 'sub AUE_O_KILLPG () { &AUE_KILL;}' unless defined(&AUE_O_KILLPG);
    eval 'sub AUE_O_SETQUOTA () { &AUE_NULL;}' unless defined(&AUE_O_SETQUOTA);
    eval 'sub AUE_O_QUOTA () { &AUE_NULL;}' unless defined(&AUE_O_QUOTA);
    eval 'sub AUE_O_GETSOCKNAME () { &AUE_NULL;}' unless defined(&AUE_O_GETSOCKNAME);
    eval 'sub AUE_O_GETDIREENTRIES () { &AUE_GETDIREENTRIES;}' unless defined(&AUE_O_GETDIREENTRIES);
    eval 'sub AUE_O_ASYNCDAEMON () { &AUE_NULL;}' unless defined(&AUE_O_ASYNCDAEMON);
    eval 'sub AUE_O_GETDOMAINNAME () { &AUE_NULL;}' unless defined(&AUE_O_GETDOMAINNAME);
    eval 'sub AUE_O_SETDOMAINNAME () { &AUE_SYSCTL;}' unless defined(&AUE_O_SETDOMAINNAME);
    eval 'sub AUE_O_PCFS_MOUNT () { &AUE_NULL;}' unless defined(&AUE_O_PCFS_MOUNT);
    eval 'sub AUE_O_EXPORTFS () { &AUE_NULL;}' unless defined(&AUE_O_EXPORTFS);
    eval 'sub AUE_O_USTATE () { &AUE_NULL;}' unless defined(&AUE_O_USTATE);
    eval 'sub AUE_O_WAIT3 () { &AUE_NULL;}' unless defined(&AUE_O_WAIT3);
    eval 'sub AUE_O_RPAUSE () { &AUE_NULL;}' unless defined(&AUE_O_RPAUSE);
    eval 'sub AUE_O_GETDENTS () { &AUE_NULL;}' unless defined(&AUE_O_GETDENTS);
    eval 'sub AUE_ATGETMSG () { &AUE_NULL;}' unless defined(&AUE_ATGETMSG);
    eval 'sub AUE_ATPUTMSG () { &AUE_NULL;}' unless defined(&AUE_ATPUTMSG);
    eval 'sub AUE_ATSOCKET () { &AUE_NULL;}' unless defined(&AUE_ATSOCKET);
    eval 'sub AUE_ATPGETREQ () { &AUE_NULL;}' unless defined(&AUE_ATPGETREQ);
    eval 'sub AUE_ATPGETRSP () { &AUE_NULL;}' unless defined(&AUE_ATPGETRSP);
    eval 'sub AUE_ATPSNDREQ () { &AUE_NULL;}' unless defined(&AUE_ATPSNDREQ);
    eval 'sub AUE_ATPSNDRSP () { &AUE_NULL;}' unless defined(&AUE_ATPSNDRSP);
    eval 'sub AUE_BSDTHREADCREATE () { &AUE_NULL;}' unless defined(&AUE_BSDTHREADCREATE);
    eval 'sub AUE_BSDTHREADTERMINATE () { &AUE_NULL;}' unless defined(&AUE_BSDTHREADTERMINATE);
    eval 'sub AUE_BSDTHREADREGISTER () { &AUE_NULL;}' unless defined(&AUE_BSDTHREADREGISTER);
    eval 'sub AUE_CHUD () { &AUE_NULL;}' unless defined(&AUE_CHUD);
    eval 'sub AUE_CSOPS () { &AUE_NULL;}' unless defined(&AUE_CSOPS);
    eval 'sub AUE_DUP () { &AUE_NULL;}' unless defined(&AUE_DUP);
    eval 'sub AUE_FDATASYNC () { &AUE_NULL;}' unless defined(&AUE_FDATASYNC);
    eval 'sub AUE_FGETATTRLIST () { &AUE_NULL;}' unless defined(&AUE_FGETATTRLIST);
    eval 'sub AUE_FGETXATTR () { &AUE_NULL;}' unless defined(&AUE_FGETXATTR);
    eval 'sub AUE_FLISTXATTR () { &AUE_NULL;}' unless defined(&AUE_FLISTXATTR);
    eval 'sub AUE_FREMOVEXATTR () { &AUE_NULL;}' unless defined(&AUE_FREMOVEXATTR);
    eval 'sub AUE_FSETATTRLIST () { &AUE_NULL;}' unless defined(&AUE_FSETATTRLIST);
    eval 'sub AUE_FSETXATTR () { &AUE_NULL;}' unless defined(&AUE_FSETXATTR);
    eval 'sub AUE_FSTATFS64 () { &AUE_NULL;}' unless defined(&AUE_FSTATFS64);
    eval 'sub AUE_FSTATV () { &AUE_NULL;}' unless defined(&AUE_FSTATV);
    eval 'sub AUE_FSTAT64 () { &AUE_NULL;}' unless defined(&AUE_FSTAT64);
    eval 'sub AUE_FSTAT64_EXTENDED () { &AUE_NULL;}' unless defined(&AUE_FSTAT64_EXTENDED);
    eval 'sub AUE_GCCONTROL () { &AUE_NULL;}' unless defined(&AUE_GCCONTROL);
    eval 'sub AUE_GETDIRENTRIES64 () { &AUE_NULL;}' unless defined(&AUE_GETDIRENTRIES64);
    eval 'sub AUE_GETDTABLESIZE () { &AUE_NULL;}' unless defined(&AUE_GETDTABLESIZE);
    eval 'sub AUE_GETEGID () { &AUE_NULL;}' unless defined(&AUE_GETEGID);
    eval 'sub AUE_GETEUID () { &AUE_NULL;}' unless defined(&AUE_GETEUID);
    eval 'sub AUE_GETFSSTAT64 () { &AUE_NULL;}' unless defined(&AUE_GETFSSTAT64);
    eval 'sub AUE_GETGID () { &AUE_NULL;}' unless defined(&AUE_GETGID);
    eval 'sub AUE_GETGROUPS () { &AUE_NULL;}' unless defined(&AUE_GETGROUPS);
    eval 'sub AUE_GETITIMER () { &AUE_NULL;}' unless defined(&AUE_GETITIMER);
    eval 'sub AUE_GETLOGIN () { &AUE_NULL;}' unless defined(&AUE_GETLOGIN);
    eval 'sub AUE_GETPEERNAME () { &AUE_NULL;}' unless defined(&AUE_GETPEERNAME);
    eval 'sub AUE_GETPGID () { &AUE_NULL;}' unless defined(&AUE_GETPGID);
    eval 'sub AUE_GETPGRP () { &AUE_NULL;}' unless defined(&AUE_GETPGRP);
    eval 'sub AUE_GETPID () { &AUE_NULL;}' unless defined(&AUE_GETPID);
    eval 'sub AUE_GETPPID () { &AUE_NULL;}' unless defined(&AUE_GETPPID);
    eval 'sub AUE_GETPRIORITY () { &AUE_NULL;}' unless defined(&AUE_GETPRIORITY);
    eval 'sub AUE_GETRLIMIT () { &AUE_NULL;}' unless defined(&AUE_GETRLIMIT);
    eval 'sub AUE_GETRUSAGE () { &AUE_NULL;}' unless defined(&AUE_GETRUSAGE);
    eval 'sub AUE_GETSGROUPS () { &AUE_NULL;}' unless defined(&AUE_GETSGROUPS);
    eval 'sub AUE_GETSID () { &AUE_NULL;}' unless defined(&AUE_GETSID);
    eval 'sub AUE_GETSOCKNAME () { &AUE_NULL;}' unless defined(&AUE_GETSOCKNAME);
    eval 'sub AUE_GETTIMEOFDAY () { &AUE_NULL;}' unless defined(&AUE_GETTIMEOFDAY);
    eval 'sub AUE_GETTID () { &AUE_NULL;}' unless defined(&AUE_GETTID);
    eval 'sub AUE_GETUID () { &AUE_NULL;}' unless defined(&AUE_GETUID);
    eval 'sub AUE_GETSOCKOPT () { &AUE_NULL;}' unless defined(&AUE_GETSOCKOPT);
    eval 'sub AUE_GETWGROUPS () { &AUE_NULL;}' unless defined(&AUE_GETWGROUPS);
    eval 'sub AUE_GETXATTR () { &AUE_NULL;}' unless defined(&AUE_GETXATTR);
    eval 'sub AUE_IDENTITYSVC () { &AUE_NULL;}' unless defined(&AUE_IDENTITYSVC);
    eval 'sub AUE_INITGROUPS () { &AUE_NULL;}' unless defined(&AUE_INITGROUPS);
    eval 'sub AUE_IOPOLICYSYS () { &AUE_NULL;}' unless defined(&AUE_IOPOLICYSYS);
    eval 'sub AUE_ISSETUGID () { &AUE_NULL;}' unless defined(&AUE_ISSETUGID);
    eval 'sub AUE_LIOLISTIO () { &AUE_NULL;}' unless defined(&AUE_LIOLISTIO);
    eval 'sub AUE_LISTXATTR () { &AUE_NULL;}' unless defined(&AUE_LISTXATTR);
    eval 'sub AUE_LSTATV () { &AUE_NULL;}' unless defined(&AUE_LSTATV);
    eval 'sub AUE_LSTAT64 () { &AUE_NULL;}' unless defined(&AUE_LSTAT64);
    eval 'sub AUE_LSTAT64_EXTENDED () { &AUE_NULL;}' unless defined(&AUE_LSTAT64_EXTENDED);
    eval 'sub AUE_MADVISE () { &AUE_NULL;}' unless defined(&AUE_MADVISE);
    eval 'sub AUE_MINCORE () { &AUE_NULL;}' unless defined(&AUE_MINCORE);
    eval 'sub AUE_MKCOMPLEX () { &AUE_NULL;}' unless defined(&AUE_MKCOMPLEX);
    eval 'sub AUE_MODWATCH () { &AUE_NULL;}' unless defined(&AUE_MODWATCH);
    eval 'sub AUE_MSGCL () { &AUE_NULL;}' unless defined(&AUE_MSGCL);
    eval 'sub AUE_MSYNC () { &AUE_NULL;}' unless defined(&AUE_MSYNC);
    eval 'sub AUE_PREADV () { &AUE_NULL;}' unless defined(&AUE_PREADV);
    eval 'sub AUE_PROCINFO () { &AUE_NULL;}' unless defined(&AUE_PROCINFO);
    eval 'sub AUE_PTHREADCANCELED () { &AUE_NULL;}' unless defined(&AUE_PTHREADCANCELED);
    eval 'sub AUE_PTHREADCHDIR () { &AUE_NULL;}' unless defined(&AUE_PTHREADCHDIR);
    eval 'sub AUE_PTHREADCONDBROADCAST () { &AUE_NULL;}' unless defined(&AUE_PTHREADCONDBROADCAST);
    eval 'sub AUE_PTHREADCONDDESTORY () { &AUE_NULL;}' unless defined(&AUE_PTHREADCONDDESTORY);
    eval 'sub AUE_PTHREADCONDINIT () { &AUE_NULL;}' unless defined(&AUE_PTHREADCONDINIT);
    eval 'sub AUE_PTHREADCONDSIGNAL () { &AUE_NULL;}' unless defined(&AUE_PTHREADCONDSIGNAL);
    eval 'sub AUE_PTHREADCONDWAIT () { &AUE_NULL;}' unless defined(&AUE_PTHREADCONDWAIT);
    eval 'sub AUE_PTHREADFCHDIR () { &AUE_NULL;}' unless defined(&AUE_PTHREADFCHDIR);
    eval 'sub AUE_PTHREADMARK () { &AUE_NULL;}' unless defined(&AUE_PTHREADMARK);
    eval 'sub AUE_PTHREADMUTEXDESTROY () { &AUE_NULL;}' unless defined(&AUE_PTHREADMUTEXDESTROY);
    eval 'sub AUE_PTHREADMUTEXINIT () { &AUE_NULL;}' unless defined(&AUE_PTHREADMUTEXINIT);
    eval 'sub AUE_PTHREADMUTEXTRYLOCK () { &AUE_NULL;}' unless defined(&AUE_PTHREADMUTEXTRYLOCK);
    eval 'sub AUE_PTHREADMUTEXUNLOCK () { &AUE_NULL;}' unless defined(&AUE_PTHREADMUTEXUNLOCK);
    eval 'sub AUE_PWRITEV () { &AUE_NULL;}' unless defined(&AUE_PWRITEV);
    eval 'sub AUE_REMOVEXATTR () { &AUE_NULL;}' unless defined(&AUE_REMOVEXATTR);
    eval 'sub AUE_SBRK () { &AUE_NULL;}' unless defined(&AUE_SBRK);
    eval 'sub AUE_SELECT () { &AUE_NULL;}' unless defined(&AUE_SELECT);
    eval 'sub AUE_SEMDESTROY () { &AUE_NULL;}' unless defined(&AUE_SEMDESTROY);
    eval 'sub AUE_SEMGETVALUE () { &AUE_NULL;}' unless defined(&AUE_SEMGETVALUE);
    eval 'sub AUE_SEMINIT () { &AUE_NULL;}' unless defined(&AUE_SEMINIT);
    eval 'sub AUE_SEMPOST () { &AUE_NULL;}' unless defined(&AUE_SEMPOST);
    eval 'sub AUE_SEMTRYWAIT () { &AUE_NULL;}' unless defined(&AUE_SEMTRYWAIT);
    eval 'sub AUE_SEMWAIT () { &AUE_NULL;}' unless defined(&AUE_SEMWAIT);
    eval 'sub AUE_SEMWAITSIGNAL () { &AUE_NULL;}' unless defined(&AUE_SEMWAITSIGNAL);
    eval 'sub AUE_SETITIMER () { &AUE_NULL;}' unless defined(&AUE_SETITIMER);
    eval 'sub AUE_SETSGROUPS () { &AUE_NULL;}' unless defined(&AUE_SETSGROUPS);
    eval 'sub AUE_SETTID () { &AUE_NULL;}' unless defined(&AUE_SETTID);
    eval 'sub AUE_SETTIDWITHPID () { &AUE_NULL;}' unless defined(&AUE_SETTIDWITHPID);
    eval 'sub AUE_SETWGROUPS () { &AUE_NULL;}' unless defined(&AUE_SETWGROUPS);
    eval 'sub AUE_SETXATTR () { &AUE_NULL;}' unless defined(&AUE_SETXATTR);
    eval 'sub AUE_SHAREDREGIONCHECK () { &AUE_NULL;}' unless defined(&AUE_SHAREDREGIONCHECK);
    eval 'sub AUE_SHAREDREGIONMAP () { &AUE_NULL;}' unless defined(&AUE_SHAREDREGIONMAP);
    eval 'sub AUE_SIGACTION () { &AUE_NULL;}' unless defined(&AUE_SIGACTION);
    eval 'sub AUE_SIGALTSTACK () { &AUE_NULL;}' unless defined(&AUE_SIGALTSTACK);
    eval 'sub AUE_SIGPENDING () { &AUE_NULL;}' unless defined(&AUE_SIGPENDING);
    eval 'sub AUE_SIGPROCMASK () { &AUE_NULL;}' unless defined(&AUE_SIGPROCMASK);
    eval 'sub AUE_SIGRETURN () { &AUE_NULL;}' unless defined(&AUE_SIGRETURN);
    eval 'sub AUE_SIGSUSPEND () { &AUE_NULL;}' unless defined(&AUE_SIGSUSPEND);
    eval 'sub AUE_SIGWAIT () { &AUE_NULL;}' unless defined(&AUE_SIGWAIT);
    eval 'sub AUE_SSTK () { &AUE_NULL;}' unless defined(&AUE_SSTK);
    eval 'sub AUE_STACKSNAPSHOT () { &AUE_NULL;}' unless defined(&AUE_STACKSNAPSHOT);
    eval 'sub AUE_STATFS64 () { &AUE_NULL;}' unless defined(&AUE_STATFS64);
    eval 'sub AUE_STATV () { &AUE_NULL;}' unless defined(&AUE_STATV);
    eval 'sub AUE_STAT64 () { &AUE_NULL;}' unless defined(&AUE_STAT64);
    eval 'sub AUE_STAT64_EXTENDED () { &AUE_NULL;}' unless defined(&AUE_STAT64_EXTENDED);
    eval 'sub AUE_SYNC () { &AUE_NULL;}' unless defined(&AUE_SYNC);
    eval 'sub AUE_SYSCALL () { &AUE_NULL;}' unless defined(&AUE_SYSCALL);
    eval 'sub AUE_TABLE () { &AUE_NULL;}' unless defined(&AUE_TABLE);
    eval 'sub AUE_VMPRESSUREMONITOR () { &AUE_NULL;}' unless defined(&AUE_VMPRESSUREMONITOR);
    eval 'sub AUE_WAITEVENT () { &AUE_NULL;}' unless defined(&AUE_WAITEVENT);
    eval 'sub AUE_WAITID () { &AUE_NULL;}' unless defined(&AUE_WAITID);
    eval 'sub AUE_WATCHEVENT () { &AUE_NULL;}' unless defined(&AUE_WATCHEVENT);
    eval 'sub AUE_WORKQOPEN () { &AUE_NULL;}' unless defined(&AUE_WORKQOPEN);
    eval 'sub AUE_WORKQOPS () { &AUE_NULL;}' unless defined(&AUE_WORKQOPS);
}
1;
