require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&snmp_h_)) {
    eval 'sub snmp_h_ () {1;}' unless defined(&snmp_h_);
    require 'sys/types.ph';
    eval 'sub SNMP_COMMUNITY_MAXLEN () {128;}' unless defined(&SNMP_COMMUNITY_MAXLEN);
    eval 'sub SNMP_MAX_BINDINGS () {100;}' unless defined(&SNMP_MAX_BINDINGS);
    eval 'sub SNMP_CONTEXT_NAME_SIZ () {(32+ 1);}' unless defined(&SNMP_CONTEXT_NAME_SIZ);
    eval 'sub SNMP_ENGINE_ID_SIZ () {32;}' unless defined(&SNMP_ENGINE_ID_SIZ);
    eval 'sub SNMP_TIME_WINDOW () {150;}' unless defined(&SNMP_TIME_WINDOW);
    eval("sub SNMP_SYNTAX_NULL () { 0; }") unless defined(&SNMP_SYNTAX_NULL);
    eval("sub SNMP_SYNTAX_INTEGER () { 1; }") unless defined(&SNMP_SYNTAX_INTEGER);
    eval("sub SNMP_SYNTAX_OCTETSTRING () { 2; }") unless defined(&SNMP_SYNTAX_OCTETSTRING);
    eval("sub SNMP_SYNTAX_OID () { 3; }") unless defined(&SNMP_SYNTAX_OID);
    eval("sub SNMP_SYNTAX_IPADDRESS () { 4; }") unless defined(&SNMP_SYNTAX_IPADDRESS);
    eval("sub SNMP_SYNTAX_COUNTER () { 5; }") unless defined(&SNMP_SYNTAX_COUNTER);
    eval("sub SNMP_SYNTAX_GAUGE () { 6; }") unless defined(&SNMP_SYNTAX_GAUGE);
    eval("sub SNMP_SYNTAX_TIMETICKS () { 7; }") unless defined(&SNMP_SYNTAX_TIMETICKS);
    eval("sub SNMP_SYNTAX_COUNTER64 () { 8; }") unless defined(&SNMP_SYNTAX_COUNTER64);
    eval("sub SNMP_SYNTAX_NOSUCHOBJECT () { 9; }") unless defined(&SNMP_SYNTAX_NOSUCHOBJECT);
    eval("sub SNMP_SYNTAX_NOSUCHINSTANCE () { 10; }") unless defined(&SNMP_SYNTAX_NOSUCHINSTANCE);
    eval("sub SNMP_SYNTAX_ENDOFMIBVIEW () { 11; }") unless defined(&SNMP_SYNTAX_ENDOFMIBVIEW);
    eval("sub SNMP_Verr () { 0; }") unless defined(&SNMP_Verr);
    eval("sub SNMP_V1 () { 1; }") unless defined(&SNMP_V1);
    eval("sub SNMP_V2c () { 2; }") unless defined(&SNMP_V2c);
    eval("sub SNMP_V3 () { 3; }") unless defined(&SNMP_V3);
    eval 'sub SNMP_MPM_SNMP_V1 () {0;}' unless defined(&SNMP_MPM_SNMP_V1);
    eval 'sub SNMP_MPM_SNMP_V2c () {1;}' unless defined(&SNMP_MPM_SNMP_V2c);
    eval 'sub SNMP_MPM_SNMP_V3 () {3;}' unless defined(&SNMP_MPM_SNMP_V3);
    eval 'sub SNMP_ADM_STR32_SIZ () {(32+ 1);}' unless defined(&SNMP_ADM_STR32_SIZ);
    eval 'sub SNMP_AUTH_KEY_SIZ () {40;}' unless defined(&SNMP_AUTH_KEY_SIZ);
    eval 'sub SNMP_PRIV_KEY_SIZ () {32;}' unless defined(&SNMP_PRIV_KEY_SIZ);
    eval 'sub SNMP_USM_AUTH_SIZE () {12;}' unless defined(&SNMP_USM_AUTH_SIZE);
    eval 'sub SNMP_USM_PRIV_SIZE () {8;}' unless defined(&SNMP_USM_PRIV_SIZE);
    eval 'sub SNMP_AUTH_HMACMD5_KEY_SIZ () {16;}' unless defined(&SNMP_AUTH_HMACMD5_KEY_SIZ);
    eval 'sub SNMP_AUTH_HMACSHA_KEY_SIZ () {20;}' unless defined(&SNMP_AUTH_HMACSHA_KEY_SIZ);
    eval 'sub SNMP_PRIV_AES_KEY_SIZ () {16;}' unless defined(&SNMP_PRIV_AES_KEY_SIZ);
    eval 'sub SNMP_PRIV_DES_KEY_SIZ () {8;}' unless defined(&SNMP_PRIV_DES_KEY_SIZ);
    eval("sub SNMP_SECMODEL_ANY () { 0; }") unless defined(&SNMP_SECMODEL_ANY);
    eval("sub SNMP_SECMODEL_SNMPv1 () { 1; }") unless defined(&SNMP_SECMODEL_SNMPv1);
    eval("sub SNMP_SECMODEL_SNMPv2c () { 2; }") unless defined(&SNMP_SECMODEL_SNMPv2c);
    eval("sub SNMP_SECMODEL_USM () { 3; }") unless defined(&SNMP_SECMODEL_USM);
    eval("sub SNMP_SECMODEL_UNKNOWN () { 4; }") unless defined(&SNMP_SECMODEL_UNKNOWN);
    eval("sub SNMP_noAuthNoPriv () { 1; }") unless defined(&SNMP_noAuthNoPriv);
    eval("sub SNMP_authNoPriv () { 2; }") unless defined(&SNMP_authNoPriv);
    eval("sub SNMP_authPriv () { 3; }") unless defined(&SNMP_authPriv);
    eval("sub SNMP_AUTH_NOAUTH () { 0; }") unless defined(&SNMP_AUTH_NOAUTH);
    eval("sub SNMP_AUTH_HMAC_MD5 () { 1; }") unless defined(&SNMP_AUTH_HMAC_MD5);
    eval("sub SNMP_AUTH_HMAC_SHA () { 2; }") unless defined(&SNMP_AUTH_HMAC_SHA);
    eval("sub SNMP_PRIV_NOPRIV () { 0; }") unless defined(&SNMP_PRIV_NOPRIV);
    eval("sub SNMP_PRIV_DES () { 1; }") unless defined(&SNMP_PRIV_DES);
    eval("sub SNMP_PRIV_AES () { 2; }") unless defined(&SNMP_PRIV_AES);
    eval 'sub snmp_v1_pdu () { &snmp_pdu;}' unless defined(&snmp_v1_pdu);
    eval 'sub SNMP_PDU_GET () {0;}' unless defined(&SNMP_PDU_GET);
    eval 'sub SNMP_PDU_GETNEXT () {1;}' unless defined(&SNMP_PDU_GETNEXT);
    eval 'sub SNMP_PDU_RESPONSE () {2;}' unless defined(&SNMP_PDU_RESPONSE);
    eval 'sub SNMP_PDU_SET () {3;}' unless defined(&SNMP_PDU_SET);
    eval 'sub SNMP_PDU_TRAP () {4;}' unless defined(&SNMP_PDU_TRAP);
    eval 'sub SNMP_PDU_GETBULK () {5;}' unless defined(&SNMP_PDU_GETBULK);
    eval 'sub SNMP_PDU_INFORM () {6;}' unless defined(&SNMP_PDU_INFORM);
    eval 'sub SNMP_PDU_TRAP2 () {7;}' unless defined(&SNMP_PDU_TRAP2);
    eval 'sub SNMP_PDU_REPORT () {8;}' unless defined(&SNMP_PDU_REPORT);
    eval 'sub SNMP_ERR_NOERROR () {0;}' unless defined(&SNMP_ERR_NOERROR);
    eval 'sub SNMP_ERR_TOOBIG () {1;}' unless defined(&SNMP_ERR_TOOBIG);
    eval 'sub SNMP_ERR_NOSUCHNAME () {2;}' unless defined(&SNMP_ERR_NOSUCHNAME);
    eval 'sub SNMP_ERR_BADVALUE () {3;}' unless defined(&SNMP_ERR_BADVALUE);
    eval 'sub SNMP_ERR_READONLY () {4;}' unless defined(&SNMP_ERR_READONLY);
    eval 'sub SNMP_ERR_GENERR () {5;}' unless defined(&SNMP_ERR_GENERR);
    eval 'sub SNMP_ERR_NO_ACCESS () {6;}' unless defined(&SNMP_ERR_NO_ACCESS);
    eval 'sub SNMP_ERR_WRONG_TYPE () {7;}' unless defined(&SNMP_ERR_WRONG_TYPE);
    eval 'sub SNMP_ERR_WRONG_LENGTH () {8;}' unless defined(&SNMP_ERR_WRONG_LENGTH);
    eval 'sub SNMP_ERR_WRONG_ENCODING () {9;}' unless defined(&SNMP_ERR_WRONG_ENCODING);
    eval 'sub SNMP_ERR_WRONG_VALUE () {10;}' unless defined(&SNMP_ERR_WRONG_VALUE);
    eval 'sub SNMP_ERR_NO_CREATION () {11;}' unless defined(&SNMP_ERR_NO_CREATION);
    eval 'sub SNMP_ERR_INCONS_VALUE () {12;}' unless defined(&SNMP_ERR_INCONS_VALUE);
    eval 'sub SNMP_ERR_RES_UNAVAIL () {13;}' unless defined(&SNMP_ERR_RES_UNAVAIL);
    eval 'sub SNMP_ERR_COMMIT_FAILED () {14;}' unless defined(&SNMP_ERR_COMMIT_FAILED);
    eval 'sub SNMP_ERR_UNDO_FAILED () {15;}' unless defined(&SNMP_ERR_UNDO_FAILED);
    eval 'sub SNMP_ERR_AUTH_ERR () {16;}' unless defined(&SNMP_ERR_AUTH_ERR);
    eval 'sub SNMP_ERR_NOT_WRITEABLE () {17;}' unless defined(&SNMP_ERR_NOT_WRITEABLE);
    eval 'sub SNMP_ERR_INCONS_NAME () {18;}' unless defined(&SNMP_ERR_INCONS_NAME);
    eval 'sub SNMP_TRAP_COLDSTART () {0;}' unless defined(&SNMP_TRAP_COLDSTART);
    eval 'sub SNMP_TRAP_WARMSTART () {1;}' unless defined(&SNMP_TRAP_WARMSTART);
    eval 'sub SNMP_TRAP_LINKDOWN () {2;}' unless defined(&SNMP_TRAP_LINKDOWN);
    eval 'sub SNMP_TRAP_LINKUP () {3;}' unless defined(&SNMP_TRAP_LINKUP);
    eval 'sub SNMP_TRAP_AUTHENTICATION_FAILURE () {4;}' unless defined(&SNMP_TRAP_AUTHENTICATION_FAILURE);
    eval 'sub SNMP_TRAP_EGP_NEIGHBOR_LOSS () {5;}' unless defined(&SNMP_TRAP_EGP_NEIGHBOR_LOSS);
    eval 'sub SNMP_TRAP_ENTERPRISE () {6;}' unless defined(&SNMP_TRAP_ENTERPRISE);
    eval("sub SNMP_CODE_OK () { 0; }") unless defined(&SNMP_CODE_OK);
    eval("sub SNMP_CODE_FAILED () { 1; }") unless defined(&SNMP_CODE_FAILED);
    eval("sub SNMP_CODE_BADVERS () { 2; }") unless defined(&SNMP_CODE_BADVERS);
    eval("sub SNMP_CODE_BADLEN () { 3; }") unless defined(&SNMP_CODE_BADLEN);
    eval("sub SNMP_CODE_BADENC () { 4; }") unless defined(&SNMP_CODE_BADENC);
    eval("sub SNMP_CODE_OORANGE () { 5; }") unless defined(&SNMP_CODE_OORANGE);
    eval("sub SNMP_CODE_BADSECLEVEL () { 6; }") unless defined(&SNMP_CODE_BADSECLEVEL);
    eval("sub SNMP_CODE_NOTINTIME () { 7; }") unless defined(&SNMP_CODE_NOTINTIME);
    eval("sub SNMP_CODE_BADUSER () { 8; }") unless defined(&SNMP_CODE_BADUSER);
    eval("sub SNMP_CODE_BADENGINE () { 9; }") unless defined(&SNMP_CODE_BADENGINE);
    eval("sub SNMP_CODE_BADDIGEST () { 10; }") unless defined(&SNMP_CODE_BADDIGEST);
    eval("sub SNMP_CODE_EDECRYPT () { 11; }") unless defined(&SNMP_CODE_EDECRYPT);
    eval 'sub SNMP_MSG_AUTH_FLAG () {0x1;}' unless defined(&SNMP_MSG_AUTH_FLAG);
    eval 'sub SNMP_MSG_PRIV_FLAG () {0x2;}' unless defined(&SNMP_MSG_PRIV_FLAG);
    eval 'sub SNMP_MSG_REPORT_FLAG () {0x4;}' unless defined(&SNMP_MSG_REPORT_FLAG);
    eval 'sub SNMP_MSG_AUTODISCOVER () {0x80;}' unless defined(&SNMP_MSG_AUTODISCOVER);
    eval 'sub TRUTH_MK {
        my($F) = @_;
	    eval q((($F) ? 1: 2));
    }' unless defined(&TRUTH_MK);
    eval 'sub TRUTH_GET {
        my($T) = @_;
	    eval q(((($T) == 1) ? 1: 0));
    }' unless defined(&TRUTH_GET);
    eval 'sub TRUTH_OK {
        my($T) = @_;
	    eval q((($T) == 1|| ($T) == 2));
    }' unless defined(&TRUTH_OK);
}
1;
