require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LIBCPP_INTTYPES_H)) {
    eval 'sub _LIBCPP_INTTYPES_H () {1;}' unless defined(&_LIBCPP_INTTYPES_H);
    require '__config';
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    if(defined(&__cplusplus)  && !defined(&__STDC_FORMAT_MACROS)) {
	eval 'sub __STDC_FORMAT_MACROS () {1;}' unless defined(&__STDC_FORMAT_MACROS);
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "inttypes.ph" } keys(%INC));
	@REM = map { "$_/inttypes.ph" } (grep { not exists($INCD{"$_/inttypes.ph"}) and -f "$_/inttypes.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
    if(defined(&__cplusplus)) {
	require 'stdint.ph';
	undef(&imaxabs) if defined(&imaxabs);
	undef(&imaxdiv) if defined(&imaxdiv);
    }
}
1;
