require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__need_FILE) || defined(&__need___FILE)) {
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "stdio.ph" } keys(%INC));
	@REM = map { "$_/stdio.ph" } (grep { not exists($INCD{"$_/stdio.ph"}) and -f "$_/stdio.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
}
 elsif(!defined(&_LIBCPP_STDIO_H)) {
    eval 'sub _LIBCPP_STDIO_H () {1;}' unless defined(&_LIBCPP_STDIO_H);
    require '__config';
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "stdio.ph" } keys(%INC));
	@REM = map { "$_/stdio.ph" } (grep { not exists($INCD{"$_/stdio.ph"}) and -f "$_/stdio.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
    if(defined(&__cplusplus)) {
	if(defined(&_LIBCPP_MSVCRT_LIKE)) {
	}
	undef(&getc) if defined(&getc);
	undef(&putc) if defined(&putc);
	undef(&clearerr) if defined(&clearerr);
	undef(&feof) if defined(&feof);
	undef(&ferror) if defined(&ferror);
    }
}
1;
