require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__need_malloc_and_calloc)) {
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "stdlib.ph" } keys(%INC));
	@REM = map { "$_/stdlib.ph" } (grep { not exists($INCD{"$_/stdlib.ph"}) and -f "$_/stdlib.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
}
 elsif(!defined(&_LIBCPP_STDLIB_H)) {
    eval 'sub _LIBCPP_STDLIB_H () {1;}' unless defined(&_LIBCPP_STDLIB_H);
    require '__config';
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "stdlib.ph" } keys(%INC));
	@REM = map { "$_/stdlib.ph" } (grep { not exists($INCD{"$_/stdlib.ph"}) and -f "$_/stdlib.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
    if(defined(&__cplusplus)) {
	undef(&abs) if defined(&abs);
	undef(&div) if defined(&div);
	undef(&labs) if defined(&labs);
	undef(&ldiv) if defined(&ldiv);
	unless(defined(&_LIBCPP_HAS_NO_LONG_LONG)) {
	    undef(&llabs) if defined(&llabs);
	    undef(&lldiv) if defined(&lldiv);
	}
	if(!defined(&_LIBCPP_MSVCRT)  && !defined(&__sun__)  && !defined(&_AIX)) {
	    unless(defined(&_LIBCPP_HAS_NO_LONG_LONG)) {
	    }
	    unless(defined(&_LIBCPP_HAS_NO_LONG_LONG)) {
	    }
	}
    }
}
1;
