require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LIBCPP_LIMITS_H)) {
    eval 'sub _LIBCPP_LIMITS_H () {1;}' unless defined(&_LIBCPP_LIMITS_H);
    require '__config';
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    unless(defined(&__GNUC__)) {
	eval {
	    my(@REM);
	    my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "limits.ph" } keys(%INC));
	    @REM = map { "$_/limits.ph" } (grep { not exists($INCD{"$_/limits.ph"}) and -f "$_/limits.ph" } @INC);
	    require "$REM[0]" if @REM;
	};
	warn($@) if $@;
    } else {
	eval 'sub _GCC_LIMITS_H_ () {1;}' unless defined(&_GCC_LIMITS_H_);
	eval 'sub _GCC_NEXT_LIMITS_H () {1;}' unless defined(&_GCC_NEXT_LIMITS_H);
	eval {
	    my(@REM);
	    my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "limits.ph" } keys(%INC));
	    @REM = map { "$_/limits.ph" } (grep { not exists($INCD{"$_/limits.ph"}) and -f "$_/limits.ph" } @INC);
	    require "$REM[0]" if @REM;
	};
	warn($@) if $@;
	undef(&_GCC_LIMITS_H_) if defined(&_GCC_LIMITS_H_);
	eval {
	    my(@REM);
	    my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "limits.ph" } keys(%INC));
	    @REM = map { "$_/limits.ph" } (grep { not exists($INCD{"$_/limits.ph"}) and -f "$_/limits.ph" } @INC);
	    require "$REM[0]" if @REM;
	};
	warn($@) if $@;
    }
}
1;
