require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__need_ptrdiff_t) || defined(&__need_size_t) || defined(&__need_wchar_t) || defined(&__need_NULL) || defined(&__need_wint_t)) {
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "stddef.ph" } keys(%INC));
	@REM = map { "$_/stddef.ph" } (grep { not exists($INCD{"$_/stddef.ph"}) and -f "$_/stddef.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
}
 elsif(!defined(&_LIBCPP_STDDEF_H)) {
    eval 'sub _LIBCPP_STDDEF_H () {1;}' unless defined(&_LIBCPP_STDDEF_H);
    require '__config';
    if(!defined(&_LIBCPP_HAS_NO_PRAGMA_SYSTEM_HEADER)) {
    }
    eval {
	my(@REM);
	my(%INCD) = map { $INC{$_} => 1 } (grep { $_ eq "stddef.ph" } keys(%INC));
	@REM = map { "$_/stddef.ph" } (grep { not exists($INCD{"$_/stddef.ph"}) and -f "$_/stddef.ph" } @INC);
	require "$REM[0]" if @REM;
    };
    warn($@) if $@;
    if(defined(&__cplusplus)) {
	require '__nullptr';
	if(!defined(&__CLANG_MAX_ALIGN_T_DEFINED)  && !defined(&_GCC_MAX_ALIGN_T)  && !defined(&__DEFINED_max_align_t)) {
	}
    }
}
1;
