require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval("sub _URC_OK () { 0; }") unless defined(&_URC_OK);
eval("sub _URC_FOREIGN_EXCEPTION_CAUGHT () { 1; }") unless defined(&_URC_FOREIGN_EXCEPTION_CAUGHT);
eval("sub _URC_END_OF_STACK () { 5; }") unless defined(&_URC_END_OF_STACK);
eval("sub _URC_HANDLER_FOUND () { 6; }") unless defined(&_URC_HANDLER_FOUND);
eval("sub _URC_INSTALL_CONTEXT () { 7; }") unless defined(&_URC_INSTALL_CONTEXT);
eval("sub _URC_CONTINUE_UNWIND () { 8; }") unless defined(&_URC_CONTINUE_UNWIND);
eval("sub _URC_FAILURE () { 9; }") unless defined(&_URC_FAILURE);
eval("sub _URC_FATAL_PHASE1_ERROR () { _URC_FAILURE; }") unless defined(&_URC_FATAL_PHASE1_ERROR);
if(defined(&__clang__)) {
} else {
    eval 'sub _US_VIRTUAL_UNWIND_FRAME () {0;}' unless defined(&_US_VIRTUAL_UNWIND_FRAME);
    eval 'sub _US_UNWIND_FRAME_STARTING () {1;}' unless defined(&_US_UNWIND_FRAME_STARTING);
    eval 'sub _US_UNWIND_FRAME_RESUME () {2;}' unless defined(&_US_UNWIND_FRAME_RESUME);
    eval 'sub _US_ACTION_MASK () {3;}' unless defined(&_US_ACTION_MASK);
}
eval("sub _UVRSR_OK () { 0; }") unless defined(&_UVRSR_OK);
eval("sub _UVRSR_NOT_IMPLEMENTED () { 1; }") unless defined(&_UVRSR_NOT_IMPLEMENTED);
eval("sub _UVRSR_FAILED () { 2; }") unless defined(&_UVRSR_FAILED);
eval("sub _UVRSC_CORE () { 0; }") unless defined(&_UVRSC_CORE);
eval("sub _UVRSC_VFP () { 1; }") unless defined(&_UVRSC_VFP);
eval("sub _UVRSC_WMMXD () { 3; }") unless defined(&_UVRSC_WMMXD);
eval("sub _UVRSC_WMMXC () { 4; }") unless defined(&_UVRSC_WMMXC);
eval("sub _UVRSD_UINT32 () { 0; }") unless defined(&_UVRSD_UINT32);
eval("sub _UVRSD_VFPX () { 1; }") unless defined(&_UVRSD_VFPX);
eval("sub _UVRSD_UINT64 () { 3; }") unless defined(&_UVRSD_UINT64);
eval("sub _UVRSD_FLOAT () { 4; }") unless defined(&_UVRSD_FLOAT);
eval("sub _UVRSD_DOUBLE () { 5; }") unless defined(&_UVRSD_DOUBLE);
eval 'sub _UA_SEARCH_PHASE () {1;}' unless defined(&_UA_SEARCH_PHASE);
eval 'sub _UA_CLEANUP_PHASE () {2;}' unless defined(&_UA_CLEANUP_PHASE);
eval 'sub _UA_HANDLER_FRAME () {4;}' unless defined(&_UA_HANDLER_FRAME);
eval 'sub _UA_FORCE_UNWIND () {8;}' unless defined(&_UA_FORCE_UNWIND);
unless(defined(&_Unwind_GetGR)) {
    sub _Unwind_GetGR {
	my($context,$reg) = @_;
	eval q({ my $val;  &_Unwind_VRS_Get($context,  &_UVRSC_CORE, $reg,  &_UVRSD_UINT32,  $val);  $val; });
    }
}
unless(defined(&_Unwind_SetGR)) {
    sub _Unwind_SetGR {
	my($context,$reg,$val) = @_;
	eval q({  &_Unwind_VRS_Set($context,  &_UVRSC_CORE, $reg,  &_UVRSD_UINT32, $val); });
    }
}
unless(defined(&_Unwind_GetIP)) {
    sub _Unwind_GetIP {
	my($context) = @_;
	eval q({  &_Unwind_GetGR($context, 15) & ~1; });
    }
}
unless(defined(&_Unwind_SetIP)) {
    sub _Unwind_SetIP {
	my($context,$val) = @_;
	eval q({ my $thumbState =  &_Unwind_GetGR($context, 15) & 1;  &_Unwind_SetGR($context, 15, ($val |  $thumbState)); });
    }
}
unless(defined(&DECLARE_PERSONALITY_FUNCTION)) {
    sub DECLARE_PERSONALITY_FUNCTION {
	my($name) = @_;
	eval q( &_Unwind_Reason_Code $name( &_Unwind_State  &state, 'struct _Unwind_Exception' * &exceptionObject, 'struct _Unwind_Context' * &context););
    }
}
unless(defined(&BEGIN_PERSONALITY_FUNCTION)) {
    sub BEGIN_PERSONALITY_FUNCTION {
	my($name) = @_;
	eval q( &_Unwind_Reason_Code $name( &_Unwind_State  &state, 'struct _Unwind_Exception' * &exceptionObject, 'struct _Unwind_Context' * &context){ 'int'  &version = 1;  &uint64_t  &exceptionClass =  ($exceptionObject->{exception_class}); 'int'  &actions;  &switch ( &state) {  &default:  &return  &_URC_FAILURE;  &case  &_US_VIRTUAL_UNWIND_FRAME: {  &actions =  &_UA_SEARCH_PHASE;  &break; }  &case  &_US_UNWIND_FRAME_STARTING: {  &actions =  &_UA_CLEANUP_PHASE;  &if ( ($exceptionObject->{barrier_cache}->{sp}) ==  &_Unwind_GetGR( &context, 13)) {  &actions |=  &_UA_HANDLER_FRAME; }  &break; }  &case  &_US_UNWIND_FRAME_RESUME: {  &return  &continueUnwinding( &exceptionObject,  &context);  &break; } }  &_Unwind_SetGR ( &context, 12,  &reinterpret_cast<'unsigned long'>( &exceptionObject)););
    }
}
unless(defined(&CALL_PERSONALITY_FUNCTION)) {
    sub CALL_PERSONALITY_FUNCTION {
	my($name) = @_;
	eval q($name( &state, &exceptionObject, &context));
    }
}
1;
