require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CAM_CAM_CCB_H)) {
    eval 'sub _CAM_CAM_CCB_H () {1;}' unless defined(&_CAM_CAM_CCB_H);
    require 'sys/queue.ph';
    require 'sys/cdefs.ph';
    require 'sys/time.ph';
    require 'sys/limits.ph';
    unless(defined(&_KERNEL)) {
	require 'sys/callout.ph';
    }
    require 'cam/cam_debug.ph';
    require 'cam/scsi/scsi_all.ph';
    require 'cam/ata/ata_all.ph';
    require 'cam/nvme/nvme_all.ph';
    eval 'sub IOCDBLEN () { &CAM_MAX_CDBLEN;}' unless defined(&IOCDBLEN);
    eval 'sub VUHBALEN () {14;}' unless defined(&VUHBALEN);
    eval 'sub SIM_IDLEN () {16;}' unless defined(&SIM_IDLEN);
    eval 'sub HBA_IDLEN () {16;}' unless defined(&HBA_IDLEN);
    eval 'sub DEV_IDLEN () {16;}' unless defined(&DEV_IDLEN);
    eval 'sub CCB_PERIPH_PRIV_SIZE () {2;}' unless defined(&CCB_PERIPH_PRIV_SIZE);
    eval 'sub CCB_SIM_PRIV_SIZE () {2;}' unless defined(&CCB_SIM_PRIV_SIZE);
    eval("sub CAM_CDB_POINTER () { 0x00000001; }") unless defined(&CAM_CDB_POINTER);
    eval("sub CAM_QUEUE_ENABLE () { 0x00000002; }") unless defined(&CAM_QUEUE_ENABLE);
    eval("sub CAM_CDB_LINKED () { 0x00000004; }") unless defined(&CAM_CDB_LINKED);
    eval("sub CAM_NEGOTIATE () { 0x00000008; }") unless defined(&CAM_NEGOTIATE);
    eval("sub CAM_DATA_ISPHYS () { 0x00000010; }") unless defined(&CAM_DATA_ISPHYS);
    eval("sub CAM_DIS_AUTOSENSE () { 0x00000020; }") unless defined(&CAM_DIS_AUTOSENSE);
    eval("sub CAM_DIR_BOTH () { 0x00000000; }") unless defined(&CAM_DIR_BOTH);
    eval("sub CAM_DIR_IN () { 0x00000040; }") unless defined(&CAM_DIR_IN);
    eval("sub CAM_DIR_OUT () { 0x00000080; }") unless defined(&CAM_DIR_OUT);
    eval("sub CAM_DIR_NONE () { 0x000000C0; }") unless defined(&CAM_DIR_NONE);
    eval("sub CAM_DIR_MASK () { 0x000000C0; }") unless defined(&CAM_DIR_MASK);
    eval("sub CAM_DATA_VADDR () { 0x00000000; }") unless defined(&CAM_DATA_VADDR);
    eval("sub CAM_DATA_PADDR () { 0x00000010; }") unless defined(&CAM_DATA_PADDR);
    eval("sub CAM_DATA_SG () { 0x00040000; }") unless defined(&CAM_DATA_SG);
    eval("sub CAM_DATA_SG_PADDR () { 0x00040010; }") unless defined(&CAM_DATA_SG_PADDR);
    eval("sub CAM_DATA_BIO () { 0x00200000; }") unless defined(&CAM_DATA_BIO);
    eval("sub CAM_DATA_MASK () { 0x00240010; }") unless defined(&CAM_DATA_MASK);
    eval("sub CAM_SOFT_RST_OP () { 0x00000100; }") unless defined(&CAM_SOFT_RST_OP);
    eval("sub CAM_ENG_SYNC () { 0x00000200; }") unless defined(&CAM_ENG_SYNC);
    eval("sub CAM_DEV_QFRZDIS () { 0x00000400; }") unless defined(&CAM_DEV_QFRZDIS);
    eval("sub CAM_DEV_QFREEZE () { 0x00000800; }") unless defined(&CAM_DEV_QFREEZE);
    eval("sub CAM_HIGH_POWER () { 0x00001000; }") unless defined(&CAM_HIGH_POWER);
    eval("sub CAM_SENSE_PTR () { 0x00002000; }") unless defined(&CAM_SENSE_PTR);
    eval("sub CAM_SENSE_PHYS () { 0x00004000; }") unless defined(&CAM_SENSE_PHYS);
    eval("sub CAM_TAG_ACTION_VALID () { 0x00008000; }") unless defined(&CAM_TAG_ACTION_VALID);
    eval("sub CAM_PASS_ERR_RECOVER () { 0x00010000; }") unless defined(&CAM_PASS_ERR_RECOVER);
    eval("sub CAM_DIS_DISCONNECT () { 0x00020000; }") unless defined(&CAM_DIS_DISCONNECT);
    eval("sub CAM_MSG_BUF_PHYS () { 0x00080000; }") unless defined(&CAM_MSG_BUF_PHYS);
    eval("sub CAM_SNS_BUF_PHYS () { 0x00100000; }") unless defined(&CAM_SNS_BUF_PHYS);
    eval("sub CAM_CDB_PHYS () { 0x00400000; }") unless defined(&CAM_CDB_PHYS);
    eval("sub CAM_ENG_SGLIST () { 0x00800000; }") unless defined(&CAM_ENG_SGLIST);
    eval("sub CAM_DIS_AUTOSRP () { 0x01000000; }") unless defined(&CAM_DIS_AUTOSRP);
    eval("sub CAM_DIS_AUTODISC () { 0x02000000; }") unless defined(&CAM_DIS_AUTODISC);
    eval("sub CAM_TGT_CCB_AVAIL () { 0x04000000; }") unless defined(&CAM_TGT_CCB_AVAIL);
    eval("sub CAM_TGT_PHASE_MODE () { 0x08000000; }") unless defined(&CAM_TGT_PHASE_MODE);
    eval("sub CAM_MSGB_VALID () { 0x10000000; }") unless defined(&CAM_MSGB_VALID);
    eval("sub CAM_STATUS_VALID () { 0x20000000; }") unless defined(&CAM_STATUS_VALID);
    eval("sub CAM_DATAB_VALID () { 0x40000000; }") unless defined(&CAM_DATAB_VALID);
    eval("sub CAM_SEND_SENSE () { 0x08000000; }") unless defined(&CAM_SEND_SENSE);
    eval("sub CAM_TERM_IO () { 0x10000000; }") unless defined(&CAM_TERM_IO);
    eval("sub CAM_DISCONNECT () { 0x20000000; }") unless defined(&CAM_DISCONNECT);
    eval("sub CAM_SEND_STATUS () { 0x40000000; }") unless defined(&CAM_SEND_STATUS);
    eval("sub CAM_UNLOCKED () { 0x80000000; }") unless defined(&CAM_UNLOCKED);
    eval("sub CAM_USER_DATA_ADDR () { 0x00000002; }") unless defined(&CAM_USER_DATA_ADDR);
    eval("sub CAM_SG_FORMAT_IOVEC () { 0x00000004; }") unless defined(&CAM_SG_FORMAT_IOVEC);
    eval("sub CAM_UNMAPPED_BUF () { 0x00000008; }") unless defined(&CAM_UNMAPPED_BUF);
    eval("sub XPT_FC_QUEUED () { 0x100; }") unless defined(&XPT_FC_QUEUED);
    eval("sub XPT_FC_USER_CCB () { 0x200; }") unless defined(&XPT_FC_USER_CCB);
    eval("sub XPT_FC_XPT_ONLY () { 0x400; }") unless defined(&XPT_FC_XPT_ONLY);
    eval("sub XPT_FC_DEV_QUEUED () { 0x800|XPT_FC_QUEUED; }") unless defined(&XPT_FC_DEV_QUEUED);
    eval("sub XPT_NOOP () { 0x00; }") unless defined(&XPT_NOOP);
    eval("sub XPT_SCSI_IO () { 0x01|XPT_FC_DEV_QUEUED; }") unless defined(&XPT_SCSI_IO);
    eval("sub XPT_GDEV_TYPE () { 0x02; }") unless defined(&XPT_GDEV_TYPE);
    eval("sub XPT_GDEVLIST () { 0x03; }") unless defined(&XPT_GDEVLIST);
    eval("sub XPT_PATH_INQ () { 0x04; }") unless defined(&XPT_PATH_INQ);
    eval("sub XPT_REL_SIMQ () { 0x05; }") unless defined(&XPT_REL_SIMQ);
    eval("sub XPT_SASYNC_CB () { 0x06; }") unless defined(&XPT_SASYNC_CB);
    eval("sub XPT_SDEV_TYPE () { 0x07; }") unless defined(&XPT_SDEV_TYPE);
    eval("sub XPT_SCAN_BUS () { 0x08|XPT_FC_QUEUED|XPT_FC_USER_CCB|XPT_FC_XPT_ONLY; }") unless defined(&XPT_SCAN_BUS);
    eval("sub XPT_DEV_MATCH () { 0x09|XPT_FC_XPT_ONLY; }") unless defined(&XPT_DEV_MATCH);
    eval("sub XPT_DEBUG () { 0x0a; }") unless defined(&XPT_DEBUG);
    eval("sub XPT_PATH_STATS () { 0x0b; }") unless defined(&XPT_PATH_STATS);
    eval("sub XPT_GDEV_STATS () { 0x0c; }") unless defined(&XPT_GDEV_STATS);
    eval("sub XPT_DEV_ADVINFO () { 0x0e; }") unless defined(&XPT_DEV_ADVINFO);
    eval("sub XPT_ASYNC () { 0x0f|XPT_FC_QUEUED|XPT_FC_USER_CCB|XPT_FC_XPT_ONLY; }") unless defined(&XPT_ASYNC);
    eval("sub XPT_ABORT () { 0x10; }") unless defined(&XPT_ABORT);
    eval("sub XPT_RESET_BUS () { 0x11|XPT_FC_XPT_ONLY; }") unless defined(&XPT_RESET_BUS);
    eval("sub XPT_RESET_DEV () { 0x12|XPT_FC_DEV_QUEUED; }") unless defined(&XPT_RESET_DEV);
    eval("sub XPT_TERM_IO () { 0x13; }") unless defined(&XPT_TERM_IO);
    eval("sub XPT_SCAN_LUN () { 0x14|XPT_FC_QUEUED|XPT_FC_USER_CCB|XPT_FC_XPT_ONLY; }") unless defined(&XPT_SCAN_LUN);
    eval("sub XPT_GET_TRAN_SETTINGS () { 0x15; }") unless defined(&XPT_GET_TRAN_SETTINGS);
    eval("sub XPT_SET_TRAN_SETTINGS () { 0x16; }") unless defined(&XPT_SET_TRAN_SETTINGS);
    eval("sub XPT_CALC_GEOMETRY () { 0x17; }") unless defined(&XPT_CALC_GEOMETRY);
    eval("sub XPT_ATA_IO () { 0x18|XPT_FC_DEV_QUEUED; }") unless defined(&XPT_ATA_IO);
    eval("sub XPT_GET_SIM_KNOB_OLD () { 0x18; }") unless defined(&XPT_GET_SIM_KNOB_OLD);
    eval("sub XPT_SET_SIM_KNOB () { 0x19; }") unless defined(&XPT_SET_SIM_KNOB);
    eval("sub XPT_GET_SIM_KNOB () { 0x1a; }") unless defined(&XPT_GET_SIM_KNOB);
    eval("sub XPT_SMP_IO () { 0x1b|XPT_FC_DEV_QUEUED; }") unless defined(&XPT_SMP_IO);
    eval("sub XPT_NVME_IO () { 0x1c|XPT_FC_DEV_QUEUED; }") unless defined(&XPT_NVME_IO);
    eval("sub XPT_MMCSD_IO () { 0x1d|XPT_FC_DEV_QUEUED; }") unless defined(&XPT_MMCSD_IO);
    eval("sub XPT_SCAN_TGT () { 0x1E|XPT_FC_QUEUED|XPT_FC_USER_CCB|XPT_FC_XPT_ONLY; }") unless defined(&XPT_SCAN_TGT);
    eval("sub XPT_NVME_ADMIN () { 0x1f|XPT_FC_DEV_QUEUED; }") unless defined(&XPT_NVME_ADMIN);
    eval("sub XPT_ENG_INQ () { 0x20|XPT_FC_XPT_ONLY; }") unless defined(&XPT_ENG_INQ);
    eval("sub XPT_ENG_EXEC () { 0x21|XPT_FC_DEV_QUEUED; }") unless defined(&XPT_ENG_EXEC);
    eval("sub XPT_EN_LUN () { 0x30; }") unless defined(&XPT_EN_LUN);
    eval("sub XPT_TARGET_IO () { 0x31|XPT_FC_DEV_QUEUED; }") unless defined(&XPT_TARGET_IO);
    eval("sub XPT_ACCEPT_TARGET_IO () { 0x32|XPT_FC_QUEUED|XPT_FC_USER_CCB; }") unless defined(&XPT_ACCEPT_TARGET_IO);
    eval("sub XPT_CONT_TARGET_IO () { 0x33|XPT_FC_DEV_QUEUED; }") unless defined(&XPT_CONT_TARGET_IO);
    eval("sub XPT_IMMED_NOTIFY () { 0x34|XPT_FC_QUEUED|XPT_FC_USER_CCB; }") unless defined(&XPT_IMMED_NOTIFY);
    eval("sub XPT_NOTIFY_ACK () { 0x35; }") unless defined(&XPT_NOTIFY_ACK);
    eval("sub XPT_IMMEDIATE_NOTIFY () { 0x36|XPT_FC_QUEUED|XPT_FC_USER_CCB; }") unless defined(&XPT_IMMEDIATE_NOTIFY);
    eval("sub XPT_NOTIFY_ACKNOWLEDGE () { 0x37|XPT_FC_QUEUED|XPT_FC_USER_CCB; }") unless defined(&XPT_NOTIFY_ACKNOWLEDGE);
    eval("sub XPT_REPROBE_LUN () { 0x38|XPT_FC_QUEUED|XPT_FC_USER_CCB; }") unless defined(&XPT_REPROBE_LUN);
    eval("sub XPT_VUNIQUE () { 0x80; }") unless defined(&XPT_VUNIQUE);
    eval 'sub XPT_FC_GROUP_MASK () {0xf0;}' unless defined(&XPT_FC_GROUP_MASK);
    eval 'sub XPT_FC_GROUP {
        my($op) = @_;
	    eval q((($op) &  &XPT_FC_GROUP_MASK));
    }' unless defined(&XPT_FC_GROUP);
    eval 'sub XPT_FC_GROUP_COMMON () {0x;}' unless defined(&XPT_FC_GROUP_COMMON);
    eval 'sub XPT_FC_GROUP_SCSI_CONTROL () {0x10;}' unless defined(&XPT_FC_GROUP_SCSI_CONTROL);
    eval 'sub XPT_FC_GROUP_HBA_ENGINE () {0x20;}' unless defined(&XPT_FC_GROUP_HBA_ENGINE);
    eval 'sub XPT_FC_GROUP_TMODE () {0x30;}' unless defined(&XPT_FC_GROUP_TMODE);
    eval 'sub XPT_FC_GROUP_VENDOR_UNIQUE () {0x80;}' unless defined(&XPT_FC_GROUP_VENDOR_UNIQUE);
    eval 'sub XPT_FC_IS_DEV_QUEUED {
        my($ccb) = @_;
	    eval q(((($ccb)-> ($ccb_h->{func_code}) &  &XPT_FC_DEV_QUEUED) ==  &XPT_FC_DEV_QUEUED));
    }' unless defined(&XPT_FC_IS_DEV_QUEUED);
    eval 'sub XPT_FC_IS_QUEUED {
        my($ccb) = @_;
	    eval q(((($ccb)-> ($ccb_h->{func_code}) &  &XPT_FC_QUEUED) != 0));
    }' unless defined(&XPT_FC_IS_QUEUED);
    eval("sub PROTO_UNKNOWN () { 0; }") unless defined(&PROTO_UNKNOWN);
    eval("sub PROTO_UNSPECIFIED () { 1; }") unless defined(&PROTO_UNSPECIFIED);
    eval("sub PROTO_SCSI () { 2; }") unless defined(&PROTO_SCSI);
    eval("sub PROTO_ATA () { 3; }") unless defined(&PROTO_ATA);
    eval("sub PROTO_ATAPI () { 4; }") unless defined(&PROTO_ATAPI);
    eval("sub PROTO_SATAPM () { 5; }") unless defined(&PROTO_SATAPM);
    eval("sub PROTO_SEMB () { 6; }") unless defined(&PROTO_SEMB);
    eval("sub PROTO_NVME () { 7; }") unless defined(&PROTO_NVME);
    eval("sub XPORT_UNKNOWN () { 0; }") unless defined(&XPORT_UNKNOWN);
    eval("sub XPORT_UNSPECIFIED () { 1; }") unless defined(&XPORT_UNSPECIFIED);
    eval("sub XPORT_SPI () { 2; }") unless defined(&XPORT_SPI);
    eval("sub XPORT_FC () { 3; }") unless defined(&XPORT_FC);
    eval("sub XPORT_SSA () { 4; }") unless defined(&XPORT_SSA);
    eval("sub XPORT_USB () { 5; }") unless defined(&XPORT_USB);
    eval("sub XPORT_PPB () { 6; }") unless defined(&XPORT_PPB);
    eval("sub XPORT_ATA () { 7; }") unless defined(&XPORT_ATA);
    eval("sub XPORT_SAS () { 8; }") unless defined(&XPORT_SAS);
    eval("sub XPORT_SATA () { 9; }") unless defined(&XPORT_SATA);
    eval("sub XPORT_ISCSI () { 10; }") unless defined(&XPORT_ISCSI);
    eval("sub XPORT_SRP () { 11; }") unless defined(&XPORT_SRP);
    eval("sub XPORT_NVME () { 12; }") unless defined(&XPORT_NVME);
    eval 'sub XPORT_IS_ATA {
        my($t) = @_;
	    eval q((($t) ==  &XPORT_ATA || ($t) ==  &XPORT_SATA));
    }' unless defined(&XPORT_IS_ATA);
    eval 'sub XPORT_IS_SCSI {
        my($t) = @_;
	    eval q((($t) !=  &XPORT_UNKNOWN  && ($t) !=  &XPORT_UNSPECIFIED  && ! &XPORT_IS_ATA($t)));
    }' unless defined(&XPORT_IS_SCSI);
    eval 'sub XPORT_DEVSTAT_TYPE {
        my($t) = @_;
	    eval q(( &XPORT_IS_ATA($t) ?  &DEVSTAT_TYPE_IF_IDE :  &XPORT_IS_SCSI($t) ?  &DEVSTAT_TYPE_IF_SCSI :  &DEVSTAT_TYPE_IF_OTHER));
    }' unless defined(&XPORT_DEVSTAT_TYPE);
    eval 'sub PROTO_VERSION_UNKNOWN () {( &UINT_MAX - 1);}' unless defined(&PROTO_VERSION_UNKNOWN);
    eval 'sub PROTO_VERSION_UNSPECIFIED () { &UINT_MAX;}' unless defined(&PROTO_VERSION_UNSPECIFIED);
    eval 'sub XPORT_VERSION_UNKNOWN () {( &UINT_MAX - 1);}' unless defined(&XPORT_VERSION_UNKNOWN);
    eval 'sub XPORT_VERSION_UNSPECIFIED () { &UINT_MAX;}' unless defined(&XPORT_VERSION_UNSPECIFIED);
    eval("sub CAM_GDEVLIST_LAST_DEVICE () { 0; }") unless defined(&CAM_GDEVLIST_LAST_DEVICE);
    eval("sub CAM_GDEVLIST_LIST_CHANGED () { 1; }") unless defined(&CAM_GDEVLIST_LIST_CHANGED);
    eval("sub CAM_GDEVLIST_MORE_DEVS () { 2; }") unless defined(&CAM_GDEVLIST_MORE_DEVS);
    eval("sub CAM_GDEVLIST_ERROR () { 3; }") unless defined(&CAM_GDEVLIST_ERROR);
    eval("sub PERIPH_MATCH_NONE () { 0x000; }") unless defined(&PERIPH_MATCH_NONE);
    eval("sub PERIPH_MATCH_PATH () { 0x001; }") unless defined(&PERIPH_MATCH_PATH);
    eval("sub PERIPH_MATCH_TARGET () { 0x002; }") unless defined(&PERIPH_MATCH_TARGET);
    eval("sub PERIPH_MATCH_LUN () { 0x004; }") unless defined(&PERIPH_MATCH_LUN);
    eval("sub PERIPH_MATCH_NAME () { 0x008; }") unless defined(&PERIPH_MATCH_NAME);
    eval("sub PERIPH_MATCH_UNIT () { 0x010; }") unless defined(&PERIPH_MATCH_UNIT);
    eval("sub PERIPH_MATCH_ANY () { 0x01f; }") unless defined(&PERIPH_MATCH_ANY);
    eval("sub DEV_MATCH_NONE () { 0x000; }") unless defined(&DEV_MATCH_NONE);
    eval("sub DEV_MATCH_PATH () { 0x001; }") unless defined(&DEV_MATCH_PATH);
    eval("sub DEV_MATCH_TARGET () { 0x002; }") unless defined(&DEV_MATCH_TARGET);
    eval("sub DEV_MATCH_LUN () { 0x004; }") unless defined(&DEV_MATCH_LUN);
    eval("sub DEV_MATCH_INQUIRY () { 0x008; }") unless defined(&DEV_MATCH_INQUIRY);
    eval("sub DEV_MATCH_DEVID () { 0x010; }") unless defined(&DEV_MATCH_DEVID);
    eval("sub DEV_MATCH_ANY () { 0x00f; }") unless defined(&DEV_MATCH_ANY);
    eval("sub BUS_MATCH_NONE () { 0x000; }") unless defined(&BUS_MATCH_NONE);
    eval("sub BUS_MATCH_PATH () { 0x001; }") unless defined(&BUS_MATCH_PATH);
    eval("sub BUS_MATCH_NAME () { 0x002; }") unless defined(&BUS_MATCH_NAME);
    eval("sub BUS_MATCH_UNIT () { 0x004; }") unless defined(&BUS_MATCH_UNIT);
    eval("sub BUS_MATCH_BUS_ID () { 0x008; }") unless defined(&BUS_MATCH_BUS_ID);
    eval("sub BUS_MATCH_ANY () { 0x00f; }") unless defined(&BUS_MATCH_ANY);
    eval("sub DEV_MATCH_PERIPH () { 0; }") unless defined(&DEV_MATCH_PERIPH);
    eval("sub DEV_MATCH_DEVICE () { 1; }") unless defined(&DEV_MATCH_DEVICE);
    eval("sub DEV_MATCH_BUS () { 2; }") unless defined(&DEV_MATCH_BUS);
    eval("sub DEV_RESULT_NOFLAG () { 0x00; }") unless defined(&DEV_RESULT_NOFLAG);
    eval("sub DEV_RESULT_UNCONFIGURED () { 0x01; }") unless defined(&DEV_RESULT_UNCONFIGURED);
    eval("sub CAM_DEV_MATCH_LAST () { 0; }") unless defined(&CAM_DEV_MATCH_LAST);
    eval("sub CAM_DEV_MATCH_MORE () { 1; }") unless defined(&CAM_DEV_MATCH_MORE);
    eval("sub CAM_DEV_MATCH_LIST_CHANGED () { 2; }") unless defined(&CAM_DEV_MATCH_LIST_CHANGED);
    eval("sub CAM_DEV_MATCH_SIZE_ERROR () { 3; }") unless defined(&CAM_DEV_MATCH_SIZE_ERROR);
    eval("sub CAM_DEV_MATCH_ERROR () { 4; }") unless defined(&CAM_DEV_MATCH_ERROR);
    eval("sub CAM_DEV_POS_NONE () { 0x000; }") unless defined(&CAM_DEV_POS_NONE);
    eval("sub CAM_DEV_POS_BUS () { 0x001; }") unless defined(&CAM_DEV_POS_BUS);
    eval("sub CAM_DEV_POS_TARGET () { 0x002; }") unless defined(&CAM_DEV_POS_TARGET);
    eval("sub CAM_DEV_POS_DEVICE () { 0x004; }") unless defined(&CAM_DEV_POS_DEVICE);
    eval("sub CAM_DEV_POS_PERIPH () { 0x008; }") unless defined(&CAM_DEV_POS_PERIPH);
    eval("sub CAM_DEV_POS_PDPTR () { 0x010; }") unless defined(&CAM_DEV_POS_PDPTR);
    eval("sub CAM_DEV_POS_TYPEMASK () { 0xf00; }") unless defined(&CAM_DEV_POS_TYPEMASK);
    eval("sub CAM_DEV_POS_EDT () { 0x100; }") unless defined(&CAM_DEV_POS_EDT);
    eval("sub CAM_DEV_POS_PDRV () { 0x200; }") unless defined(&CAM_DEV_POS_PDRV);
    eval 'sub CAM_BUS_GENERATION () {0x;}' unless defined(&CAM_BUS_GENERATION);
    eval 'sub CAM_TARGET_GENERATION () {0x1;}' unless defined(&CAM_TARGET_GENERATION);
    eval 'sub CAM_DEV_GENERATION () {0x2;}' unless defined(&CAM_DEV_GENERATION);
    eval 'sub CAM_PERIPH_GENERATION () {0x3;}' unless defined(&CAM_PERIPH_GENERATION);
    eval 'sub CAM_VERSION () {0x19;}' unless defined(&CAM_VERSION);
    eval("sub PI_MDP_ABLE () { 0x80; }") unless defined(&PI_MDP_ABLE);
    eval("sub PI_WIDE_32 () { 0x40; }") unless defined(&PI_WIDE_32);
    eval("sub PI_WIDE_16 () { 0x20; }") unless defined(&PI_WIDE_16);
    eval("sub PI_SDTR_ABLE () { 0x10; }") unless defined(&PI_SDTR_ABLE);
    eval("sub PI_LINKED_CDB () { 0x08; }") unless defined(&PI_LINKED_CDB);
    eval("sub PI_SATAPM () { 0x04; }") unless defined(&PI_SATAPM);
    eval("sub PI_TAG_ABLE () { 0x02; }") unless defined(&PI_TAG_ABLE);
    eval("sub PI_SOFT_RST () { 0x01; }") unless defined(&PI_SOFT_RST);
    eval("sub PIT_PROCESSOR () { 0x80; }") unless defined(&PIT_PROCESSOR);
    eval("sub PIT_PHASE () { 0x40; }") unless defined(&PIT_PHASE);
    eval("sub PIT_DISCONNECT () { 0x20; }") unless defined(&PIT_DISCONNECT);
    eval("sub PIT_TERM_IO () { 0x10; }") unless defined(&PIT_TERM_IO);
    eval("sub PIT_GRP_6 () { 0x08; }") unless defined(&PIT_GRP_6);
    eval("sub PIT_GRP_7 () { 0x04; }") unless defined(&PIT_GRP_7);
    eval("sub PIM_ATA_EXT () { 0x200; }") unless defined(&PIM_ATA_EXT);
    eval("sub PIM_EXTLUNS () { 0x100; }") unless defined(&PIM_EXTLUNS);
    eval("sub PIM_SCANHILO () { 0x80; }") unless defined(&PIM_SCANHILO);
    eval("sub PIM_NOREMOVE () { 0x40; }") unless defined(&PIM_NOREMOVE);
    eval("sub PIM_NOINITIATOR () { 0x20; }") unless defined(&PIM_NOINITIATOR);
    eval("sub PIM_NOBUSRESET () { 0x10; }") unless defined(&PIM_NOBUSRESET);
    eval("sub PIM_NO_6_BYTE () { 0x08; }") unless defined(&PIM_NO_6_BYTE);
    eval("sub PIM_SEQSCAN () { 0x04; }") unless defined(&PIM_SEQSCAN);
    eval("sub PIM_UNMAPPED () { 0x02; }") unless defined(&PIM_UNMAPPED);
    eval("sub PIM_NOSCAN () { 0x01; }") unless defined(&PIM_NOSCAN);
    eval 'sub PATHINQ_SETTINGS_SIZE () {128;}' unless defined(&PATHINQ_SETTINGS_SIZE);
    eval("sub SMP_FLAG_NONE () { 0x00; }") unless defined(&SMP_FLAG_NONE);
    eval("sub SMP_FLAG_REQ_SG () { 0x01; }") unless defined(&SMP_FLAG_REQ_SG);
    eval("sub SMP_FLAG_RSP_SG () { 0x02; }") unless defined(&SMP_FLAG_RSP_SG);
    eval 'sub CAM_TAG_ACTION_NONE () {0x;}' unless defined(&CAM_TAG_ACTION_NONE);
    eval 'sub scsiio_cdb_ptr {
        my($ccb) = @_;
	    eval q({ (( ($ccb->{ccb_h}->{flags}) &  &CAM_CDB_POINTER) ?  ($ccb->{cdb_io}->{cdb_ptr}) :  ($ccb->{cdb_io}->{cdb_bytes})); });
    }' unless defined(&scsiio_cdb_ptr);
    eval 'sub ATA_FLAG_AUX () {0x1;}' unless defined(&ATA_FLAG_AUX);
    eval 'sub atio_cdb_ptr {
        my($ccb) = @_;
	    eval q({ (( ($ccb->{ccb_h}->{flags}) &  &CAM_CDB_POINTER) ?  ($ccb->{cdb_io}->{cdb_ptr}) :  ($ccb->{cdb_io}->{cdb_bytes})); });
    }' unless defined(&atio_cdb_ptr);
    eval 'sub RELSIM_ADJUST_OPENINGS () {0x1;}' unless defined(&RELSIM_ADJUST_OPENINGS);
    eval 'sub RELSIM_RELEASE_AFTER_TIMEOUT () {0x2;}' unless defined(&RELSIM_RELEASE_AFTER_TIMEOUT);
    eval 'sub RELSIM_RELEASE_AFTER_CMDCMPLT () {0x4;}' unless defined(&RELSIM_RELEASE_AFTER_CMDCMPLT);
    eval 'sub RELSIM_RELEASE_AFTER_QEMPTY () {0x8;}' unless defined(&RELSIM_RELEASE_AFTER_QEMPTY);
    eval("sub AC_UNIT_ATTENTION () { 0x4000; }") unless defined(&AC_UNIT_ATTENTION);
    eval("sub AC_ADVINFO_CHANGED () { 0x2000; }") unless defined(&AC_ADVINFO_CHANGED);
    eval("sub AC_CONTRACT () { 0x1000; }") unless defined(&AC_CONTRACT);
    eval("sub AC_GETDEV_CHANGED () { 0x800; }") unless defined(&AC_GETDEV_CHANGED);
    eval("sub AC_INQ_CHANGED () { 0x400; }") unless defined(&AC_INQ_CHANGED);
    eval("sub AC_TRANSFER_NEG () { 0x200; }") unless defined(&AC_TRANSFER_NEG);
    eval("sub AC_LOST_DEVICE () { 0x100; }") unless defined(&AC_LOST_DEVICE);
    eval("sub AC_FOUND_DEVICE () { 0x080; }") unless defined(&AC_FOUND_DEVICE);
    eval("sub AC_PATH_DEREGISTERED () { 0x040; }") unless defined(&AC_PATH_DEREGISTERED);
    eval("sub AC_PATH_REGISTERED () { 0x020; }") unless defined(&AC_PATH_REGISTERED);
    eval("sub AC_SENT_BDR () { 0x010; }") unless defined(&AC_SENT_BDR);
    eval("sub AC_SCSI_AEN () { 0x008; }") unless defined(&AC_SCSI_AEN);
    eval("sub AC_UNSOL_RESEL () { 0x002; }") unless defined(&AC_UNSOL_RESEL);
    eval("sub AC_BUS_RESET () { 0x001; }") unless defined(&AC_BUS_RESET);
    eval 'sub AC_CONTRACT_DATA_MAX () {(128- $sizeof{ &u_int64_t});}' unless defined(&AC_CONTRACT_DATA_MAX);
    eval 'sub AC_CONTRACT_DEV_CHG () {1;}' unless defined(&AC_CONTRACT_DEV_CHG);
    eval("sub CTS_TYPE_CURRENT_SETTINGS () { 0; }") unless defined(&CTS_TYPE_CURRENT_SETTINGS);
    eval("sub CTS_TYPE_USER_SETTINGS () { 1; }") unless defined(&CTS_TYPE_USER_SETTINGS);
    eval 'sub CTS_SCSI_VALID_TQ () {0x1;}' unless defined(&CTS_SCSI_VALID_TQ);
    eval 'sub CTS_SCSI_FLAGS_TAG_ENB () {0x1;}' unless defined(&CTS_SCSI_FLAGS_TAG_ENB);
    eval 'sub CTS_ATA_VALID_TQ () {0x1;}' unless defined(&CTS_ATA_VALID_TQ);
    eval 'sub CTS_ATA_FLAGS_TAG_ENB () {0x1;}' unless defined(&CTS_ATA_FLAGS_TAG_ENB);
    eval 'sub CTS_SPI_VALID_SYNC_RATE () {0x1;}' unless defined(&CTS_SPI_VALID_SYNC_RATE);
    eval 'sub CTS_SPI_VALID_SYNC_OFFSET () {0x2;}' unless defined(&CTS_SPI_VALID_SYNC_OFFSET);
    eval 'sub CTS_SPI_VALID_BUS_WIDTH () {0x4;}' unless defined(&CTS_SPI_VALID_BUS_WIDTH);
    eval 'sub CTS_SPI_VALID_DISC () {0x8;}' unless defined(&CTS_SPI_VALID_DISC);
    eval 'sub CTS_SPI_VALID_PPR_OPTIONS () {0x10;}' unless defined(&CTS_SPI_VALID_PPR_OPTIONS);
    eval 'sub CTS_SPI_FLAGS_DISC_ENB () {0x1;}' unless defined(&CTS_SPI_FLAGS_DISC_ENB);
    eval 'sub CTS_FC_VALID_WWNN () {0x8000;}' unless defined(&CTS_FC_VALID_WWNN);
    eval 'sub CTS_FC_VALID_WWPN () {0x4000;}' unless defined(&CTS_FC_VALID_WWPN);
    eval 'sub CTS_FC_VALID_PORT () {0x2000;}' unless defined(&CTS_FC_VALID_PORT);
    eval 'sub CTS_FC_VALID_SPEED () {0x1000;}' unless defined(&CTS_FC_VALID_SPEED);
    eval 'sub CTS_SAS_VALID_SPEED () {0x1000;}' unless defined(&CTS_SAS_VALID_SPEED);
    eval 'sub CTS_ATA_VALID_MODE () {0x1;}' unless defined(&CTS_ATA_VALID_MODE);
    eval 'sub CTS_ATA_VALID_BYTECOUNT () {0x2;}' unless defined(&CTS_ATA_VALID_BYTECOUNT);
    eval 'sub CTS_ATA_VALID_ATAPI () {0x20;}' unless defined(&CTS_ATA_VALID_ATAPI);
    eval 'sub CTS_ATA_VALID_CAPS () {0x40;}' unless defined(&CTS_ATA_VALID_CAPS);
    eval 'sub CTS_ATA_CAPS_H () {0xffff;}' unless defined(&CTS_ATA_CAPS_H);
    eval 'sub CTS_ATA_CAPS_H_DMA48 () {0x1;}' unless defined(&CTS_ATA_CAPS_H_DMA48);
    eval 'sub CTS_ATA_CAPS_D () {0xffff0000;}' unless defined(&CTS_ATA_CAPS_D);
    eval 'sub CTS_SATA_VALID_MODE () {0x1;}' unless defined(&CTS_SATA_VALID_MODE);
    eval 'sub CTS_SATA_VALID_BYTECOUNT () {0x2;}' unless defined(&CTS_SATA_VALID_BYTECOUNT);
    eval 'sub CTS_SATA_VALID_REVISION () {0x4;}' unless defined(&CTS_SATA_VALID_REVISION);
    eval 'sub CTS_SATA_VALID_PM () {0x8;}' unless defined(&CTS_SATA_VALID_PM);
    eval 'sub CTS_SATA_VALID_TAGS () {0x10;}' unless defined(&CTS_SATA_VALID_TAGS);
    eval 'sub CTS_SATA_VALID_ATAPI () {0x20;}' unless defined(&CTS_SATA_VALID_ATAPI);
    eval 'sub CTS_SATA_VALID_CAPS () {0x40;}' unless defined(&CTS_SATA_VALID_CAPS);
    eval 'sub CTS_SATA_CAPS_H () {0xffff;}' unless defined(&CTS_SATA_CAPS_H);
    eval 'sub CTS_SATA_CAPS_H_PMREQ () {0x1;}' unless defined(&CTS_SATA_CAPS_H_PMREQ);
    eval 'sub CTS_SATA_CAPS_H_APST () {0x2;}' unless defined(&CTS_SATA_CAPS_H_APST);
    eval 'sub CTS_SATA_CAPS_H_DMAAA () {0x10;}' unless defined(&CTS_SATA_CAPS_H_DMAAA);
    eval 'sub CTS_SATA_CAPS_H_AN () {0x20;}' unless defined(&CTS_SATA_CAPS_H_AN);
    eval 'sub CTS_SATA_CAPS_D () {0xffff0000;}' unless defined(&CTS_SATA_CAPS_D);
    eval 'sub CTS_SATA_CAPS_D_PMREQ () {0x10000;}' unless defined(&CTS_SATA_CAPS_D_PMREQ);
    eval 'sub CTS_SATA_CAPS_D_APST () {0x20000;}' unless defined(&CTS_SATA_CAPS_D_APST);
    eval 'sub CTS_NVME_VALID_SPEC () {0x1;}' unless defined(&CTS_NVME_VALID_SPEC);
    eval 'sub CTS_NVME_VALID_CAPS () {0x2;}' unless defined(&CTS_NVME_VALID_CAPS);
    eval 'sub KNOB_VALID_ADDRESS () {0x1;}' unless defined(&KNOB_VALID_ADDRESS);
    eval 'sub KNOB_VALID_ROLE () {0x2;}' unless defined(&KNOB_VALID_ROLE);
    eval 'sub KNOB_ROLE_NONE () {0x;}' unless defined(&KNOB_ROLE_NONE);
    eval 'sub KNOB_ROLE_INITIATOR () {0x1;}' unless defined(&KNOB_ROLE_INITIATOR);
    eval 'sub KNOB_ROLE_TARGET () {0x2;}' unless defined(&KNOB_ROLE_TARGET);
    eval 'sub KNOB_ROLE_BOTH () {0x3;}' unless defined(&KNOB_ROLE_BOTH);
    eval 'sub KNOB_SETTINGS_SIZE () {128;}' unless defined(&KNOB_SETTINGS_SIZE);
    eval 'sub CAM_RSP_TMF_COMPLETE () {0x;}' unless defined(&CAM_RSP_TMF_COMPLETE);
    eval 'sub CAM_RSP_TMF_REJECTED () {0x4;}' unless defined(&CAM_RSP_TMF_REJECTED);
    eval 'sub CAM_RSP_TMF_FAILED () {0x5;}' unless defined(&CAM_RSP_TMF_FAILED);
    eval 'sub CAM_RSP_TMF_SUCCEEDED () {0x8;}' unless defined(&CAM_RSP_TMF_SUCCEEDED);
    eval 'sub CAM_RSP_TMF_INCORRECT_LUN () {0x9;}' unless defined(&CAM_RSP_TMF_INCORRECT_LUN);
    eval("sub EIT_BUFFER () { 0; }") unless defined(&EIT_BUFFER);
    eval("sub EIT_LOSSLESS () { 1; }") unless defined(&EIT_LOSSLESS);
    eval("sub EIT_LOSSY () { 2; }") unless defined(&EIT_LOSSY);
    eval("sub EIT_ENCRYPT () { 3; }") unless defined(&EIT_ENCRYPT);
    eval("sub EAD_VUNIQUE () { 0; }") unless defined(&EAD_VUNIQUE);
    eval("sub EAD_LZ1V1 () { 1; }") unless defined(&EAD_LZ1V1);
    eval("sub EAD_LZ2V1 () { 2; }") unless defined(&EAD_LZ2V1);
    eval("sub EAD_LZ2V2 () { 3; }") unless defined(&EAD_LZ2V2);
    eval 'sub CAM_TIME_DEFAULT () {0x;}' unless defined(&CAM_TIME_DEFAULT);
    eval 'sub CAM_TIME_INFINITY () {0xffffffff;}' unless defined(&CAM_TIME_INFINITY);
    eval 'sub CAM_SUCCESS () {0;}' unless defined(&CAM_SUCCESS);
    eval 'sub CAM_FAILURE () {1;}' unless defined(&CAM_FAILURE);
    eval 'sub CAM_FALSE () {0;}' unless defined(&CAM_FALSE);
    eval 'sub CAM_TRUE () {1;}' unless defined(&CAM_TRUE);
    eval 'sub XPT_CCB_INVALID () {-1;}' unless defined(&XPT_CCB_INVALID);
    eval 'sub CDAI_FLAG_NONE () {0x;}' unless defined(&CDAI_FLAG_NONE);
    eval 'sub CDAI_FLAG_STORE () {0x1;}' unless defined(&CDAI_FLAG_STORE);
    eval 'sub CDAI_TYPE_SCSI_DEVID () {1;}' unless defined(&CDAI_TYPE_SCSI_DEVID);
    eval 'sub CDAI_TYPE_SERIAL_NUM () {2;}' unless defined(&CDAI_TYPE_SERIAL_NUM);
    eval 'sub CDAI_TYPE_PHYS_PATH () {3;}' unless defined(&CDAI_TYPE_PHYS_PATH);
    eval 'sub CDAI_TYPE_RCAPLONG () {4;}' unless defined(&CDAI_TYPE_RCAPLONG);
    eval 'sub CDAI_TYPE_EXT_INQ () {5;}' unless defined(&CDAI_TYPE_EXT_INQ);
    eval 'sub CDAI_TYPE_NVME_CNTRL () {6;}' unless defined(&CDAI_TYPE_NVME_CNTRL);
    eval 'sub CDAI_TYPE_NVME_NS () {7;}' unless defined(&CDAI_TYPE_NVME_NS);
    eval 'sub CAM_SCSI_DEVID_MAXLEN () {65536;}' unless defined(&CAM_SCSI_DEVID_MAXLEN);
    eval 'sub CCB_CLEAR_ALL_EXCEPT_HDR {
        my($ccbp) = @_;
	    eval q( &bzero(($ccbp) + $sizeof{($ccbp)-> &ccb_h}, $sizeof{($ccbp)} - $sizeof{($ccbp)-> &ccb_h}));
    }' unless defined(&CCB_CLEAR_ALL_EXCEPT_HDR);
    eval 'sub cam_fill_ctio () {
        eval q((\'struct ccb_scsiio\' * &csio,  &u_int32_t  &retries,  &void (* &cbfcnp)(\'struct cam_periph\' *, \'union ccb\' *),  &u_int32_t  &flags, \'u_int\'  &tag_action, \'u_int\'  &tag_id, \'u_int\'  &init_id, \'u_int\'  &scsi_status,  &u_int8_t * &data_ptr,  &u_int32_t  &dxfer_len,  &u_int32_t  &timeout) {  ($csio->{ccb_h}->{func_code}) =  &XPT_CONT_TARGET_IO;  ($csio->{ccb_h}->{flags}) =  &flags;  ($csio->{ccb_h}->{xflags}) = 0;  ($csio->{ccb_h}->{retry_count}) =  &retries;  ($csio->{ccb_h}->{cbfcnp}) =  &cbfcnp;  ($csio->{ccb_h}->{timeout}) =  &timeout;  ($csio->{data_ptr}) =  &data_ptr;  ($csio->{dxfer_len}) =  &dxfer_len;  ($csio->{scsi_status}) =  &scsi_status;  ($csio->{tag_action}) =  &tag_action;  ($csio->{tag_id}) =  &tag_id;  ($csio->{init_id}) =  &init_id; });
    }' unless defined(&cam_fill_ctio);
    eval 'sub cam_fill_ataio () {
        eval q((\'struct ccb_ataio\' * &ataio,  &u_int32_t  &retries,  &void (* &cbfcnp)(\'struct cam_periph\' *, \'union ccb\' *),  &u_int32_t  &flags, \'u_int\'  &tag_action  &__unused,  &u_int8_t * &data_ptr,  &u_int32_t  &dxfer_len,  &u_int32_t  &timeout) {  ($ataio->{ccb_h}->{func_code}) =  &XPT_ATA_IO;  ($ataio->{ccb_h}->{flags}) =  &flags;  ($ataio->{ccb_h}->{retry_count}) =  &retries;  ($ataio->{ccb_h}->{cbfcnp}) =  &cbfcnp;  ($ataio->{ccb_h}->{timeout}) =  &timeout;  ($ataio->{data_ptr}) =  &data_ptr;  ($ataio->{dxfer_len}) =  &dxfer_len;  ($ataio->{ata_flags}) = 0; });
    }' unless defined(&cam_fill_ataio);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub cam_fill_smpio () {
        eval q((\'struct ccb_smpio\' * &smpio,  &uint32_t  &retries,  &void (* &cbfcnp)(\'struct cam_periph\' *, \'union ccb\' *),  &uint32_t  &flags,  &uint8_t * &smp_request, \'int\'  &smp_request_len,  &uint8_t * &smp_response, \'int\'  &smp_response_len,  &uint32_t  &timeout) {  ($smpio->{ccb_h}->{func_code}) =  &XPT_SMP_IO;  ($smpio->{ccb_h}->{flags}) =  &flags;  ($smpio->{ccb_h}->{retry_count}) =  &retries;  ($smpio->{ccb_h}->{cbfcnp}) =  &cbfcnp;  ($smpio->{ccb_h}->{timeout}) =  &timeout;  ($smpio->{smp_request}) =  &smp_request;  ($smpio->{smp_request_len}) =  &smp_request_len;  ($smpio->{smp_response}) =  &smp_response;  ($smpio->{smp_response_len}) =  &smp_response_len; });
    }' unless defined(&cam_fill_smpio);
    eval 'sub cam_set_ccbstatus {
        my($ccb,$status) = @_;
	    eval q({  ($ccb->{ccb_h}->{status}) &= ~ &CAM_STATUS_MASK;  ($ccb->{ccb_h}->{status}) |= $status; });
    }' unless defined(&cam_set_ccbstatus);
    eval 'sub cam_ccb_status {
        my($ccb) = @_;
	    eval q({ (( &cam_status)( ($ccb->{ccb_h}->{status}) &  &CAM_STATUS_MASK)); });
    }' unless defined(&cam_ccb_status);
    eval 'sub cam_fill_nvmeio () {
        eval q((\'struct ccb_nvmeio\' * &nvmeio,  &u_int32_t  &retries,  &void (* &cbfcnp)(\'struct cam_periph\' *, \'union ccb\' *),  &u_int32_t  &flags,  &u_int8_t * &data_ptr,  &u_int32_t  &dxfer_len,  &u_int32_t  &timeout) {  ($nvmeio->{ccb_h}->{func_code}) =  &XPT_NVME_IO;  ($nvmeio->{ccb_h}->{flags}) =  &flags;  ($nvmeio->{ccb_h}->{retry_count}) =  &retries;  ($nvmeio->{ccb_h}->{cbfcnp}) =  &cbfcnp;  ($nvmeio->{ccb_h}->{timeout}) =  &timeout;  ($nvmeio->{data_ptr}) =  &data_ptr;  ($nvmeio->{dxfer_len}) =  &dxfer_len; });
    }' unless defined(&cam_fill_nvmeio);
    eval 'sub cam_fill_nvmeadmin () {
        eval q((\'struct ccb_nvmeio\' * &nvmeio,  &u_int32_t  &retries,  &void (* &cbfcnp)(\'struct cam_periph\' *, \'union ccb\' *),  &u_int32_t  &flags,  &u_int8_t * &data_ptr,  &u_int32_t  &dxfer_len,  &u_int32_t  &timeout) {  ($nvmeio->{ccb_h}->{func_code}) =  &XPT_NVME_ADMIN;  ($nvmeio->{ccb_h}->{flags}) =  &flags;  ($nvmeio->{ccb_h}->{retry_count}) =  &retries;  ($nvmeio->{ccb_h}->{cbfcnp}) =  &cbfcnp;  ($nvmeio->{ccb_h}->{timeout}) =  &timeout;  ($nvmeio->{data_ptr}) =  &data_ptr;  ($nvmeio->{dxfer_len}) =  &dxfer_len; });
    }' unless defined(&cam_fill_nvmeadmin);
}
1;
