require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CAM_CAM_QUEUE_H)) {
    eval 'sub _CAM_CAM_QUEUE_H () {1;}' unless defined(&_CAM_CAM_QUEUE_H);
    if(defined(&_KERNEL)) {
	require 'sys/lock.ph';
	require 'sys/mutex.ph';
	require 'sys/queue.ph';
	require 'cam/cam.ph';
	eval 'sub CAMQ_HEAD () {1;}' unless defined(&CAMQ_HEAD);
	eval 'sub CAMQ_GET_HEAD {
	    my($camq) = @_;
    	    eval q((($camq)-> $queue_array[ &CAMQ_HEAD]));
	}' unless defined(&CAMQ_GET_HEAD);
	eval 'sub CAMQ_GET_PRIO {
	    my($camq) = @_;
    	    eval q(((($camq)-> &entries > 0) ? (($camq)-> ($queue_array[&CAMQ_HEAD]->{priority})) : 0));
	}' unless defined(&CAMQ_GET_PRIO);
	eval 'sub cam_ccbq_pending_ccb_count {
	    my($ccbq) = @_;
    	    eval q({ ( ($ccbq->{queue}->{entries}) +  ($ccbq->{queue_extra_entries})); });
	}' unless defined(&cam_ccbq_pending_ccb_count);
	eval 'sub cam_ccbq_take_opening {
	    my($ccbq) = @_;
    	    eval q({  ($ccbq->{allocated})++; });
	}' unless defined(&cam_ccbq_take_opening);
	eval 'sub cam_ccbq_insert_ccb {
	    my($ccbq,$new_ccb) = @_;
    	    eval q({ \'struct ccb_hdr\' * &old_ccb; \'struct camq\' * &queue =  ($ccbq->{queue});  &KASSERT(( ($new_ccb->{ccb_h}->{func_code}) &  &XPT_FC_QUEUED) != 0 && ( ($new_ccb->{ccb_h}->{func_code}) &  &XPT_FC_USER_CCB) == 0, (\\"%s: Cannot queue ccb %p func_code %#x\\",  &__func__, $new_ccb,  ($new_ccb->{ccb_h}->{func_code})));  &if ( ($queue->{entries}) ==  ($queue->{array_size})  &&  &camq_resize( ($ccbq->{queue}),  ($queue->{array_size}) * 2) !=  &CAM_REQ_CMP) {  &old_ccb =  &camq_remove( &queue,  ($queue->{entries}));  &TAILQ_INSERT_HEAD( ($ccbq->{queue_extra_head}),  &old_ccb,  ($xpt_links->{tqe}));  ($old_ccb->{pinfo}->{index}) =  &CAM_EXTRAQ_INDEX;  ($ccbq->{queue_extra_entries})++; }  &camq_insert( &queue,  ($new_ccb->{ccb_h}->{pinfo})); });
	}' unless defined(&cam_ccbq_insert_ccb);
	eval 'sub cam_ccbq_remove_ccb {
	    my($ccbq,$ccb) = @_;
    	    eval q({ \'struct ccb_hdr\' * &cccb, * &bccb; \'struct camq\' * &queue =  ($ccbq->{queue});  &cam_pinfo * &removed_entry  &__unused;  &if ( ($ccb->{ccb_h}->{pinfo}->{index}) ==  &CAM_EXTRAQ_INDEX) {  &TAILQ_REMOVE( ($ccbq->{queue_extra_head}),  ($ccb->{ccb_h}),  ($xpt_links->{tqe}));  ($ccb->{ccb_h}->{pinfo}->{index}) =  &CAM_UNQUEUED_INDEX;  ($ccbq->{queue_extra_entries})--; ; }  &removed_entry =  &camq_remove( &queue,  ($ccb->{ccb_h}->{pinfo}->{index}));  &KASSERT( &removed_entry ==  ($ccb->{ccb_h}->{pinfo}), (\\"%s: Removed wrong entry from queue (%p != %p)\\",  &__func__,  &removed_entry,  ($ccb->{ccb_h}->{pinfo})));  &bccb =  &TAILQ_FIRST( ($ccbq->{queue_extra_head}));  &if ( &bccb ==  &NULL) ;  &TAILQ_FOREACH( &cccb,  ($ccbq->{queue_extra_head}),  ($xpt_links->{tqe})) {  &if ( ($b$ccb->{pinfo}->{priority}) >  ($c$ccb->{pinfo}->{priority}) || ( ($b$ccb->{pinfo}->{priority}) ==  ($c$ccb->{pinfo}->{priority})  &&  &GENERATIONCMP( ($b$ccb->{pinfo}->{generation}), >,  ($c$ccb->{pinfo}->{generation}))))  &bccb =  &cccb; }  &TAILQ_REMOVE( ($ccbq->{queue_extra_head}),  &bccb,  ($xpt_links->{tqe}));  ($ccbq->{queue_extra_entries})--;  &camq_insert( &queue,  ($b$ccb->{pinfo})); });
	}' unless defined(&cam_ccbq_remove_ccb);
	eval 'sub cam_ccbq_peek_ccb {
	    my($ccbq,$index) = @_;
    	    eval q({ ( ($ccbq->{queue}->{queue_array[$index]})); });
	}' unless defined(&cam_ccbq_peek_ccb);
	eval 'sub cam_ccbq_send_ccb {
	    my($ccbq,$send_ccb) = @_;
    	    eval q({  ($send_ccb->{ccb_h}->{pinfo}->{index}) =  &CAM_ACTIVE_INDEX;  ($ccbq->{dev_active})++;  ($ccbq->{dev_openings})--; });
	}' unless defined(&cam_ccbq_send_ccb);
	eval 'sub cam_ccbq_ccb_done {
	    my($ccbq,$done_ccb) = @_;
    	    eval q({  ($ccbq->{dev_active})--;  ($ccbq->{dev_openings})++; });
	}' unless defined(&cam_ccbq_ccb_done);
	eval 'sub cam_ccbq_release_opening {
	    my($ccbq) = @_;
    	    eval q({  ($ccbq->{allocated})--; });
	}' unless defined(&cam_ccbq_release_opening);
    }
}
1;
