require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CAM_CAM_XPT_H)) {
    eval 'sub _CAM_CAM_XPT_H () {1;}' unless defined(&_CAM_CAM_XPT_H);
    if(defined(&_KERNEL)) {
	eval 'sub xpt_path_lock {
	    my($path) = @_;
    	    eval q( &mtx_lock( &xpt_path_mtx($path)));
	}' unless defined(&xpt_path_lock);
	eval 'sub xpt_path_unlock {
	    my($path) = @_;
    	    eval q( &mtx_unlock( &xpt_path_mtx($path)));
	}' unless defined(&xpt_path_unlock);
	eval 'sub xpt_path_assert {
	    my($path, $what) = @_;
    	    eval q( &mtx_assert( &xpt_path_mtx($path), ($what)));
	}' unless defined(&xpt_path_assert);
	eval 'sub xpt_path_owned {
	    my($path) = @_;
    	    eval q( &mtx_owned( &xpt_path_mtx($path)));
	}' unless defined(&xpt_path_owned);
	eval 'sub xpt_path_sleep {
	    my($path, $chan, $priority, $wmesg, $timo) = @_;
    	    eval q( &msleep(($chan),  &xpt_path_mtx($path), ($priority), ($wmesg), ($timo)));
	}' unless defined(&xpt_path_sleep);
    }
}
1;
