require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SCSI_SCSI_ALL_H)) {
    eval 'sub _SCSI_SCSI_ALL_H () {1;}' unless defined(&_SCSI_SCSI_ALL_H);
    require 'sys/cdefs.ph';
    require 'machine/stdarg.ph';
    if(defined(&_KERNEL)) {
    }
    eval 'sub SCSI_CTL_LINK () {0x1;}' unless defined(&SCSI_CTL_LINK);
    eval 'sub SCSI_CTL_FLAG () {0x2;}' unless defined(&SCSI_CTL_FLAG);
    eval 'sub SCSI_CTL_VENDOR () {0xc0;}' unless defined(&SCSI_CTL_VENDOR);
    eval 'sub SCSI_CMD_LUN () {0xa0;}' unless defined(&SCSI_CMD_LUN);
    eval 'sub SCSI_CMD_LUN_SHIFT () {5;}' unless defined(&SCSI_CMD_LUN_SHIFT);
    eval 'sub SCSI_MAX_CDBLEN () {16;}' unless defined(&SCSI_MAX_CDBLEN);
    if(defined(&CAM_MAX_CDBLEN)  && ((defined(&CAM_MAX_CDBLEN) ? &CAM_MAX_CDBLEN : undef) < (defined(&SCSI_MAX_CDBLEN) ? &SCSI_MAX_CDBLEN : undef))) {
	die("CAM_MAX_CDBLEN cannot be less than SCSI_MAX_CDBLEN");
    }
    eval 'sub SCSI_CDB6_LEN {
        my($len) = @_;
	    eval q((($len) == 0? 256: $len));
    }' unless defined(&SCSI_CDB6_LEN);
    eval("sub SS_NOP () { 0x000000; }") unless defined(&SS_NOP);
    eval("sub SS_RETRY () { 0x010000; }") unless defined(&SS_RETRY);
    eval("sub SS_FAIL () { 0x020000; }") unless defined(&SS_FAIL);
    eval("sub SS_START () { 0x030000; }") unless defined(&SS_START);
    eval("sub SS_TUR () { 0x040000; }") unless defined(&SS_TUR);
    eval("sub SS_MASK () { 0xff0000; }") unless defined(&SS_MASK);
    eval("sub SSQ_NONE () { 0x0000; }") unless defined(&SSQ_NONE);
    eval("sub SSQ_DECREMENT_COUNT () { 0x0100; }") unless defined(&SSQ_DECREMENT_COUNT);
    eval("sub SSQ_MANY () { 0x0200; }") unless defined(&SSQ_MANY);
    eval("sub SSQ_RANGE () { 0x0400; }") unless defined(&SSQ_RANGE);
    eval("sub SSQ_PRINT_SENSE () { 0x0800; }") unless defined(&SSQ_PRINT_SENSE);
    eval("sub SSQ_UA () { 0x1000; }") unless defined(&SSQ_UA);
    eval("sub SSQ_RESCAN () { 0x2000; }") unless defined(&SSQ_RESCAN);
    eval("sub SSQ_LOST () { 0x4000; }") unless defined(&SSQ_LOST);
    eval("sub SSQ_MASK () { 0xff00; }") unless defined(&SSQ_MASK);
    eval 'sub SS_ERRMASK () {0xff;}' unless defined(&SS_ERRMASK);
    eval 'sub SS_RDEF () { &SS_RETRY| &SSQ_DECREMENT_COUNT| &SSQ_PRINT_SENSE| &EIO;}' unless defined(&SS_RDEF);
    eval 'sub SS_RET () { &SS_RETRY| &SSQ_DECREMENT_COUNT| &SSQ_PRINT_SENSE;}' unless defined(&SS_RET);
    eval 'sub SS_WAIT () { &SS_TUR| &SSQ_MANY| &SSQ_DECREMENT_COUNT| &SSQ_PRINT_SENSE;}' unless defined(&SS_WAIT);
    eval 'sub SS_FATAL () { &SS_FAIL| &SSQ_PRINT_SENSE;}' unless defined(&SS_FATAL);
    eval 'sub SRS_DESC () {0x1;}' unless defined(&SRS_DESC);
    eval 'sub SRD_PCV () {0x1;}' unless defined(&SRD_PCV);
    eval 'sub SSD_UNITOFFL () {0x1;}' unless defined(&SSD_UNITOFFL);
    eval 'sub SSD_DEVOFFL () {0x2;}' unless defined(&SSD_DEVOFFL);
    eval 'sub SSD_SELFTEST () {0x4;}' unless defined(&SSD_SELFTEST);
    eval 'sub SSD_PF () {0x10;}' unless defined(&SSD_PF);
    eval 'sub SSD_SELF_TEST_CODE_MASK () {0xe0;}' unless defined(&SSD_SELF_TEST_CODE_MASK);
    eval 'sub SSD_SELF_TEST_CODE_SHIFT () {5;}' unless defined(&SSD_SELF_TEST_CODE_SHIFT);
    eval 'sub SSD_SELF_TEST_CODE_NONE () {0x;}' unless defined(&SSD_SELF_TEST_CODE_NONE);
    eval 'sub SSD_SELF_TEST_CODE_BG_SHORT () {0x1;}' unless defined(&SSD_SELF_TEST_CODE_BG_SHORT);
    eval 'sub SSD_SELF_TEST_CODE_BG_EXTENDED () {0x2;}' unless defined(&SSD_SELF_TEST_CODE_BG_EXTENDED);
    eval 'sub SSD_SELF_TEST_CODE_BG_ABORT () {0x4;}' unless defined(&SSD_SELF_TEST_CODE_BG_ABORT);
    eval 'sub SSD_SELF_TEST_CODE_FG_SHORT () {0x5;}' unless defined(&SSD_SELF_TEST_CODE_FG_SHORT);
    eval 'sub SSD_SELF_TEST_CODE_FG_EXTENDED () {0x6;}' unless defined(&SSD_SELF_TEST_CODE_FG_EXTENDED);
    eval 'sub SI_EVPD () {0x1;}' unless defined(&SI_EVPD);
    eval 'sub SI_CMDDT () {0x2;}' unless defined(&SI_CMDDT);
    eval 'sub SMS_DBD () {0x8;}' unless defined(&SMS_DBD);
    eval 'sub SMS_PAGE_CODE () {0x3f;}' unless defined(&SMS_PAGE_CODE);
    eval 'sub SMS_VENDOR_SPECIFIC_PAGE () {0x;}' unless defined(&SMS_VENDOR_SPECIFIC_PAGE);
    eval 'sub SMS_DISCONNECT_RECONNECT_PAGE () {0x2;}' unless defined(&SMS_DISCONNECT_RECONNECT_PAGE);
    eval 'sub SMS_FORMAT_DEVICE_PAGE () {0x3;}' unless defined(&SMS_FORMAT_DEVICE_PAGE);
    eval 'sub SMS_GEOMETRY_PAGE () {0x4;}' unless defined(&SMS_GEOMETRY_PAGE);
    eval 'sub SMS_CACHE_PAGE () {0x8;}' unless defined(&SMS_CACHE_PAGE);
    eval 'sub SMS_PERIPHERAL_DEVICE_PAGE () {0x9;}' unless defined(&SMS_PERIPHERAL_DEVICE_PAGE);
    eval 'sub SMS_CONTROL_MODE_PAGE () {0xa;}' unless defined(&SMS_CONTROL_MODE_PAGE);
    eval 'sub SMS_PROTO_SPECIFIC_PAGE () {0x19;}' unless defined(&SMS_PROTO_SPECIFIC_PAGE);
    eval 'sub SMS_INFO_EXCEPTIONS_PAGE () {0x1c;}' unless defined(&SMS_INFO_EXCEPTIONS_PAGE);
    eval 'sub SMS_ALL_PAGES_PAGE () {0x3f;}' unless defined(&SMS_ALL_PAGES_PAGE);
    eval 'sub SMS_PAGE_CTRL_MASK () {0xc0;}' unless defined(&SMS_PAGE_CTRL_MASK);
    eval 'sub SMS_PAGE_CTRL_CURRENT () {0x;}' unless defined(&SMS_PAGE_CTRL_CURRENT);
    eval 'sub SMS_PAGE_CTRL_CHANGEABLE () {0x40;}' unless defined(&SMS_PAGE_CTRL_CHANGEABLE);
    eval 'sub SMS_PAGE_CTRL_DEFAULT () {0x80;}' unless defined(&SMS_PAGE_CTRL_DEFAULT);
    eval 'sub SMS_PAGE_CTRL_SAVED () {0xc0;}' unless defined(&SMS_PAGE_CTRL_SAVED);
    eval 'sub SMS_SUBPAGE_PAGE_0 () {0x;}' unless defined(&SMS_SUBPAGE_PAGE_0);
    eval 'sub SMS_SUBPAGE_ALL () {0xff;}' unless defined(&SMS_SUBPAGE_ALL);
    eval 'sub SMS10_LLBAA () {0x10;}' unless defined(&SMS10_LLBAA);
    eval 'sub SMS_SP () {0x1;}' unless defined(&SMS_SP);
    eval 'sub SMS_RTD () {0x2;}' unless defined(&SMS_RTD);
    eval 'sub SMS_PF () {0x10;}' unless defined(&SMS_PF);
    eval 'sub SPRI_RK () {0x;}' unless defined(&SPRI_RK);
    eval 'sub SPRI_RR () {0x1;}' unless defined(&SPRI_RR);
    eval 'sub SPRI_RC () {0x2;}' unless defined(&SPRI_RC);
    eval 'sub SPRI_RS () {0x3;}' unless defined(&SPRI_RS);
    eval 'sub SPRI_MAX_LEN () {0xffff;}' unless defined(&SPRI_MAX_LEN);
    eval 'sub SPRI_RLR_C () {0x80;}' unless defined(&SPRI_RLR_C);
    eval 'sub SPRI_CRH () {0x10;}' unless defined(&SPRI_CRH);
    eval 'sub SPRI_SIP_C () {0x8;}' unless defined(&SPRI_SIP_C);
    eval 'sub SPRI_ATP_C () {0x4;}' unless defined(&SPRI_ATP_C);
    eval 'sub SPRI_PTPL_C () {0x1;}' unless defined(&SPRI_PTPL_C);
    eval 'sub SPRI_TMV () {0x80;}' unless defined(&SPRI_TMV);
    eval 'sub SPRI_ALLOW_CMD_MASK () {0x70;}' unless defined(&SPRI_ALLOW_CMD_MASK);
    eval 'sub SPRI_ALLOW_CMD_SHIFT () {4;}' unless defined(&SPRI_ALLOW_CMD_SHIFT);
    eval 'sub SPRI_ALLOW_NA () {0x;}' unless defined(&SPRI_ALLOW_NA);
    eval 'sub SPRI_ALLOW_1 () {0x10;}' unless defined(&SPRI_ALLOW_1);
    eval 'sub SPRI_ALLOW_2 () {0x20;}' unless defined(&SPRI_ALLOW_2);
    eval 'sub SPRI_ALLOW_3 () {0x30;}' unless defined(&SPRI_ALLOW_3);
    eval 'sub SPRI_ALLOW_4 () {0x40;}' unless defined(&SPRI_ALLOW_4);
    eval 'sub SPRI_ALLOW_5 () {0x50;}' unless defined(&SPRI_ALLOW_5);
    eval 'sub SPRI_PTPL_A () {0x1;}' unless defined(&SPRI_PTPL_A);
    eval 'sub SPRI_TM_WR_EX_AR () {0x8000;}' unless defined(&SPRI_TM_WR_EX_AR);
    eval 'sub SPRI_TM_EX_AC_RO () {0x4000;}' unless defined(&SPRI_TM_EX_AC_RO);
    eval 'sub SPRI_TM_WR_EX_RO () {0x2000;}' unless defined(&SPRI_TM_WR_EX_RO);
    eval 'sub SPRI_TM_EX_AC () {0x800;}' unless defined(&SPRI_TM_EX_AC);
    eval 'sub SPRI_TM_WR_EX () {0x200;}' unless defined(&SPRI_TM_WR_EX);
    eval 'sub SPRI_TM_EX_AC_AR () {0x1;}' unless defined(&SPRI_TM_EX_AC_AR);
    eval 'sub SPRT_WE () {0x1;}' unless defined(&SPRT_WE);
    eval 'sub SPRT_EA () {0x3;}' unless defined(&SPRT_EA);
    eval 'sub SPRT_WERO () {0x5;}' unless defined(&SPRT_WERO);
    eval 'sub SPRT_EARO () {0x6;}' unless defined(&SPRT_EARO);
    eval 'sub SPRT_WEAR () {0x7;}' unless defined(&SPRT_WEAR);
    eval 'sub SPRT_EAAR () {0x8;}' unless defined(&SPRT_EAAR);
    eval 'sub SPRI_FULL_ALL_TG_PT () {0x2;}' unless defined(&SPRI_FULL_ALL_TG_PT);
    eval 'sub SPRI_FULL_R_HOLDER () {0x1;}' unless defined(&SPRI_FULL_R_HOLDER);
    eval 'sub SPRO_REGISTER () {0x;}' unless defined(&SPRO_REGISTER);
    eval 'sub SPRO_RESERVE () {0x1;}' unless defined(&SPRO_RESERVE);
    eval 'sub SPRO_RELEASE () {0x2;}' unless defined(&SPRO_RELEASE);
    eval 'sub SPRO_CLEAR () {0x3;}' unless defined(&SPRO_CLEAR);
    eval 'sub SPRO_PREEMPT () {0x4;}' unless defined(&SPRO_PREEMPT);
    eval 'sub SPRO_PRE_ABO () {0x5;}' unless defined(&SPRO_PRE_ABO);
    eval 'sub SPRO_REG_IGNO () {0x6;}' unless defined(&SPRO_REG_IGNO);
    eval 'sub SPRO_REG_MOVE () {0x7;}' unless defined(&SPRO_REG_MOVE);
    eval 'sub SPRO_REPL_LOST_RES () {0x8;}' unless defined(&SPRO_REPL_LOST_RES);
    eval 'sub SPRO_ACTION_MASK () {0x1f;}' unless defined(&SPRO_ACTION_MASK);
    eval 'sub SPR_SCOPE_MASK () {0xf0;}' unless defined(&SPR_SCOPE_MASK);
    eval 'sub SPR_SCOPE_SHIFT () {4;}' unless defined(&SPR_SCOPE_SHIFT);
    eval 'sub SPR_LU_SCOPE () {0x;}' unless defined(&SPR_LU_SCOPE);
    eval 'sub SPR_EXTENT_SCOPE () {0x10;}' unless defined(&SPR_EXTENT_SCOPE);
    eval 'sub SPR_ELEMENT_SCOPE () {0x20;}' unless defined(&SPR_ELEMENT_SCOPE);
    eval 'sub SPR_TYPE_MASK () {0xf;}' unless defined(&SPR_TYPE_MASK);
    eval 'sub SPR_TYPE_RD_SHARED () {0x;}' unless defined(&SPR_TYPE_RD_SHARED);
    eval 'sub SPR_TYPE_WR_EX () {0x1;}' unless defined(&SPR_TYPE_WR_EX);
    eval 'sub SPR_TYPE_RD_EX () {0x2;}' unless defined(&SPR_TYPE_RD_EX);
    eval 'sub SPR_TYPE_EX_AC () {0x3;}' unless defined(&SPR_TYPE_EX_AC);
    eval 'sub SPR_TYPE_SHARED () {0x4;}' unless defined(&SPR_TYPE_SHARED);
    eval 'sub SPR_TYPE_WR_EX_RO () {0x5;}' unless defined(&SPR_TYPE_WR_EX_RO);
    eval 'sub SPR_TYPE_EX_AC_RO () {0x6;}' unless defined(&SPR_TYPE_EX_AC_RO);
    eval 'sub SPR_TYPE_WR_EX_AR () {0x7;}' unless defined(&SPR_TYPE_WR_EX_AR);
    eval 'sub SPR_TYPE_EX_AC_AR () {0x8;}' unless defined(&SPR_TYPE_EX_AC_AR);
    eval 'sub SPR_SPEC_I_PT () {0x8;}' unless defined(&SPR_SPEC_I_PT);
    eval 'sub SPR_ALL_TG_PT () {0x4;}' unless defined(&SPR_ALL_TG_PT);
    eval 'sub SPR_APTPL () {0x1;}' unless defined(&SPR_APTPL);
    eval 'sub SPR_REG_MOVE_UNREG () {0x2;}' unless defined(&SPR_REG_MOVE_UNREG);
    eval 'sub SPR_REG_MOVE_APTPL () {0x1;}' unless defined(&SPR_REG_MOVE_APTPL);
    eval 'sub SCSI_TRN_FORMAT_MASK () {0xc0;}' unless defined(&SCSI_TRN_FORMAT_MASK);
    eval 'sub SCSI_TRN_FORMAT_SHIFT () {6;}' unless defined(&SCSI_TRN_FORMAT_SHIFT);
    eval 'sub SCSI_TRN_PROTO_MASK () {0xf;}' unless defined(&SCSI_TRN_PROTO_MASK);
    eval 'sub SCSI_TRN_FCP_FORMAT_DEFAULT () {0x;}' unless defined(&SCSI_TRN_FCP_FORMAT_DEFAULT);
    eval 'sub SCSI_TRN_SPI_FORMAT_DEFAULT () {0x;}' unless defined(&SCSI_TRN_SPI_FORMAT_DEFAULT);
    eval 'sub SCSI_TRN_1394_FORMAT_DEFAULT () {0x;}' unless defined(&SCSI_TRN_1394_FORMAT_DEFAULT);
    eval 'sub SCSI_TRN_RDMA_FORMAT_DEFAULT () {0x;}' unless defined(&SCSI_TRN_RDMA_FORMAT_DEFAULT);
    eval 'sub SCSI_TRN_RDMA_PORT_LEN () {16;}' unless defined(&SCSI_TRN_RDMA_PORT_LEN);
    eval 'sub SCSI_TRN_ISCSI_FORMAT_DEVICE () {0x;}' unless defined(&SCSI_TRN_ISCSI_FORMAT_DEVICE);
    eval 'sub SCSI_TRN_ISCSI_FORMAT_PORT () {0x40;}' unless defined(&SCSI_TRN_ISCSI_FORMAT_PORT);
    eval 'sub SCSI_TRN_SAS_FORMAT_DEFAULT () {0x;}' unless defined(&SCSI_TRN_SAS_FORMAT_DEFAULT);
    eval 'sub SCSI_TRN_SOP_BUS_MAX () {0xff;}' unless defined(&SCSI_TRN_SOP_BUS_MAX);
    eval 'sub SCSI_TRN_SOP_DEV_MAX () {0x1f;}' unless defined(&SCSI_TRN_SOP_DEV_MAX);
    eval 'sub SCSI_TRN_SOP_DEV_MASK () {0xf8;}' unless defined(&SCSI_TRN_SOP_DEV_MASK);
    eval 'sub SCSI_TRN_SOP_DEV_SHIFT () {3;}' unless defined(&SCSI_TRN_SOP_DEV_SHIFT);
    eval 'sub SCSI_TRN_SOP_FUNC_NORM_MASK () {0x7;}' unless defined(&SCSI_TRN_SOP_FUNC_NORM_MASK);
    eval 'sub SCSI_TRN_SOP_FUNC_NORM_MAX () {0x7;}' unless defined(&SCSI_TRN_SOP_FUNC_NORM_MAX);
    eval 'sub SCSI_TRN_SOP_FUNC_ALT_MAX () {0xff;}' unless defined(&SCSI_TRN_SOP_FUNC_ALT_MAX);
    eval 'sub SCSI_TRN_SOP_FORMAT_DEFAULT () {0x;}' unless defined(&SCSI_TRN_SOP_FORMAT_DEFAULT);
    eval 'sub SLS_SP () {0x1;}' unless defined(&SLS_SP);
    eval 'sub SLS_PPC () {0x2;}' unless defined(&SLS_PPC);
    eval 'sub SLS_PAGE_CODE () {0x3f;}' unless defined(&SLS_PAGE_CODE);
    eval 'sub SLS_SUPPORTED_PAGES_PAGE () {0x;}' unless defined(&SLS_SUPPORTED_PAGES_PAGE);
    eval 'sub SLS_OVERRUN_PAGE () {0x1;}' unless defined(&SLS_OVERRUN_PAGE);
    eval 'sub SLS_ERROR_WRITE_PAGE () {0x2;}' unless defined(&SLS_ERROR_WRITE_PAGE);
    eval 'sub SLS_ERROR_READ_PAGE () {0x3;}' unless defined(&SLS_ERROR_READ_PAGE);
    eval 'sub SLS_ERROR_READREVERSE_PAGE () {0x4;}' unless defined(&SLS_ERROR_READREVERSE_PAGE);
    eval 'sub SLS_ERROR_VERIFY_PAGE () {0x5;}' unless defined(&SLS_ERROR_VERIFY_PAGE);
    eval 'sub SLS_ERROR_NONMEDIUM_PAGE () {0x6;}' unless defined(&SLS_ERROR_NONMEDIUM_PAGE);
    eval 'sub SLS_ERROR_LASTN_PAGE () {0x7;}' unless defined(&SLS_ERROR_LASTN_PAGE);
    eval 'sub SLS_LOGICAL_BLOCK_PROVISIONING () {0xc;}' unless defined(&SLS_LOGICAL_BLOCK_PROVISIONING);
    eval 'sub SLS_SELF_TEST_PAGE () {0x10;}' unless defined(&SLS_SELF_TEST_PAGE);
    eval 'sub SLS_SOLID_STATE_MEDIA () {0x11;}' unless defined(&SLS_SOLID_STATE_MEDIA);
    eval 'sub SLS_STAT_AND_PERF () {0x19;}' unless defined(&SLS_STAT_AND_PERF);
    eval 'sub SLS_IE_PAGE () {0x2f;}' unless defined(&SLS_IE_PAGE);
    eval 'sub SLS_PAGE_CTRL_MASK () {0xc0;}' unless defined(&SLS_PAGE_CTRL_MASK);
    eval 'sub SLS_PAGE_CTRL_THRESHOLD () {0x;}' unless defined(&SLS_PAGE_CTRL_THRESHOLD);
    eval 'sub SLS_PAGE_CTRL_CUMULATIVE () {0x40;}' unless defined(&SLS_PAGE_CTRL_CUMULATIVE);
    eval 'sub SLS_PAGE_CTRL_THRESH_DEFAULT () {0x80;}' unless defined(&SLS_PAGE_CTRL_THRESH_DEFAULT);
    eval 'sub SLS_PAGE_CTRL_CUMUL_DEFAULT () {0xc0;}' unless defined(&SLS_PAGE_CTRL_CUMUL_DEFAULT);
    eval 'sub SLS_SUPPORTED_SUBPAGES_SUBPAGE () {0xff;}' unless defined(&SLS_SUPPORTED_SUBPAGES_SUBPAGE);
    eval 'sub SLS_PCR () {0x2;}' unless defined(&SLS_PCR);
    eval 'sub SL_PAGE_CODE () {0x3f;}' unless defined(&SL_PAGE_CODE);
    eval 'sub SL_SPF () {0x40;}' unless defined(&SL_SPF);
    eval 'sub SL_DS () {0x80;}' unless defined(&SL_DS);
    eval 'sub SLP_LP () {0x1;}' unless defined(&SLP_LP);
    eval 'sub SLP_LBIN () {0x2;}' unless defined(&SLP_LBIN);
    eval 'sub SLP_TMC_MASK () {0xc;}' unless defined(&SLP_TMC_MASK);
    eval 'sub SLP_TMC_ALWAYS () {0x;}' unless defined(&SLP_TMC_ALWAYS);
    eval 'sub SLP_TMC_EQUAL () {0x4;}' unless defined(&SLP_TMC_EQUAL);
    eval 'sub SLP_TMC_NOTEQUAL () {0x8;}' unless defined(&SLP_TMC_NOTEQUAL);
    eval 'sub SLP_TMC_GREATER () {0xc;}' unless defined(&SLP_TMC_GREATER);
    eval 'sub SLP_ETC () {0x10;}' unless defined(&SLP_ETC);
    eval 'sub SLP_TSD () {0x20;}' unless defined(&SLP_TSD);
    eval 'sub SLP_DS () {0x40;}' unless defined(&SLP_DS);
    eval 'sub SLP_DU () {0x80;}' unless defined(&SLP_DU);
    eval 'sub SLP_SS_MEDIA_PCT_USED () {0x1;}' unless defined(&SLP_SS_MEDIA_PCT_USED);
    eval 'sub SLP_SAP () {0x1;}' unless defined(&SLP_SAP);
    eval 'sub SLP_IT () {0x2;}' unless defined(&SLP_IT);
    eval 'sub SLP_TI () {0x3;}' unless defined(&SLP_TI);
    eval 'sub SLP_FUA_SAP () {0x4;}' unless defined(&SLP_FUA_SAP);
    eval 'sub SLP_IE_GEN () {0x;}' unless defined(&SLP_IE_GEN);
    eval 'sub SCP_RLEC () {0x1;}' unless defined(&SCP_RLEC);
    eval 'sub SCP_GLTSD () {0x2;}' unless defined(&SCP_GLTSD);
    eval 'sub SCP_DSENSE () {0x4;}' unless defined(&SCP_DSENSE);
    eval 'sub SCP_DPICZ () {0x8;}' unless defined(&SCP_DPICZ);
    eval 'sub SCP_TMF_ONLY () {0x10;}' unless defined(&SCP_TMF_ONLY);
    eval 'sub SCP_TST_MASK () {0xe0;}' unless defined(&SCP_TST_MASK);
    eval 'sub SCP_TST_ONE () {0x;}' unless defined(&SCP_TST_ONE);
    eval 'sub SCP_TST_SEPARATE () {0x20;}' unless defined(&SCP_TST_SEPARATE);
    eval 'sub SCP_QUEUE_ALG_MASK () {0xf0;}' unless defined(&SCP_QUEUE_ALG_MASK);
    eval 'sub SCP_QUEUE_ALG_RESTRICTED () {0x;}' unless defined(&SCP_QUEUE_ALG_RESTRICTED);
    eval 'sub SCP_QUEUE_ALG_UNRESTRICTED () {0x10;}' unless defined(&SCP_QUEUE_ALG_UNRESTRICTED);
    eval 'sub SCP_NUAR () {0x8;}' unless defined(&SCP_NUAR);
    eval 'sub SCP_QUEUE_ERR () {0x2;}' unless defined(&SCP_QUEUE_ERR);
    eval 'sub SCP_QUEUE_DQUE () {0x1;}' unless defined(&SCP_QUEUE_DQUE);
    eval 'sub SCP_EECA () {0x80;}' unless defined(&SCP_EECA);
    eval 'sub SCP_RAC () {0x40;}' unless defined(&SCP_RAC);
    eval 'sub SCP_SWP () {0x8;}' unless defined(&SCP_SWP);
    eval 'sub SCP_RAENP () {0x4;}' unless defined(&SCP_RAENP);
    eval 'sub SCP_UAAENP () {0x2;}' unless defined(&SCP_UAAENP);
    eval 'sub SCP_EAENP () {0x1;}' unless defined(&SCP_EAENP);
    eval 'sub SCP_ATO () {0x80;}' unless defined(&SCP_ATO);
    eval 'sub SCP_TAS () {0x40;}' unless defined(&SCP_TAS);
    eval 'sub SCP_ATMPE () {0x20;}' unless defined(&SCP_ATMPE);
    eval 'sub SCP_RWWP () {0x10;}' unless defined(&SCP_RWWP);
    eval 'sub SCEP_PAGE_CODE () {0xa;}' unless defined(&SCEP_PAGE_CODE);
    eval 'sub SCEP_SUBPAGE_CODE () {0x1;}' unless defined(&SCEP_SUBPAGE_CODE);
    eval 'sub SCEP_TCMOS () {0x4;}' unless defined(&SCEP_TCMOS);
    eval 'sub SCEP_SCSIP () {0x2;}' unless defined(&SCEP_SCSIP);
    eval 'sub SCEP_IALUAE () {0x1;}' unless defined(&SCEP_IALUAE);
    eval 'sub SCHP_PAGE_SAVABLE () {0x80;}' unless defined(&SCHP_PAGE_SAVABLE);
    eval 'sub SCHP_FLAGS_WCE () {0x4;}' unless defined(&SCHP_FLAGS_WCE);
    eval 'sub SCHP_FLAGS_MF () {0x2;}' unless defined(&SCHP_FLAGS_MF);
    eval 'sub SCHP_FLAGS_RCD () {0x1;}' unless defined(&SCHP_FLAGS_RCD);
    eval 'sub SMS_CACHING_PAGE () {0x8;}' unless defined(&SMS_CACHING_PAGE);
    eval 'sub SCP_IC () {0x80;}' unless defined(&SCP_IC);
    eval 'sub SCP_ABPF () {0x40;}' unless defined(&SCP_ABPF);
    eval 'sub SCP_CAP () {0x20;}' unless defined(&SCP_CAP);
    eval 'sub SCP_DISC () {0x10;}' unless defined(&SCP_DISC);
    eval 'sub SCP_SIZE () {0x8;}' unless defined(&SCP_SIZE);
    eval 'sub SCP_WCE () {0x4;}' unless defined(&SCP_WCE);
    eval 'sub SCP_MF () {0x2;}' unless defined(&SCP_MF);
    eval 'sub SCP_RCD () {0x1;}' unless defined(&SCP_RCD);
    eval 'sub SCP_FSW () {0x80;}' unless defined(&SCP_FSW);
    eval 'sub SCP_LBCSS () {0x40;}' unless defined(&SCP_LBCSS);
    eval 'sub SCP_DRA () {0x20;}' unless defined(&SCP_DRA);
    eval 'sub SCP_VS1 () {0x10;}' unless defined(&SCP_VS1);
    eval 'sub SCP_VS2 () {0x8;}' unless defined(&SCP_VS2);
    eval 'sub SIEP_PAGE_SAVABLE () {0x80;}' unless defined(&SIEP_PAGE_SAVABLE);
    eval 'sub SIEP_FLAGS_PERF () {0x80;}' unless defined(&SIEP_FLAGS_PERF);
    eval 'sub SIEP_FLAGS_EBF () {0x20;}' unless defined(&SIEP_FLAGS_EBF);
    eval 'sub SIEP_FLAGS_EWASC () {0x10;}' unless defined(&SIEP_FLAGS_EWASC);
    eval 'sub SIEP_FLAGS_DEXCPT () {0x8;}' unless defined(&SIEP_FLAGS_DEXCPT);
    eval 'sub SIEP_FLAGS_TEST () {0x4;}' unless defined(&SIEP_FLAGS_TEST);
    eval 'sub SIEP_FLAGS_EBACKERR () {0x2;}' unless defined(&SIEP_FLAGS_EBACKERR);
    eval 'sub SIEP_FLAGS_LOGERR () {0x1;}' unless defined(&SIEP_FLAGS_LOGERR);
    eval 'sub SIEP_MRIE_NO () {0x;}' unless defined(&SIEP_MRIE_NO);
    eval 'sub SIEP_MRIE_UA () {0x2;}' unless defined(&SIEP_MRIE_UA);
    eval 'sub SIEP_MRIE_REC_COND () {0x3;}' unless defined(&SIEP_MRIE_REC_COND);
    eval 'sub SIEP_MRIE_REC_UNCOND () {0x4;}' unless defined(&SIEP_MRIE_REC_UNCOND);
    eval 'sub SIEP_MRIE_NO_SENSE () {0x5;}' unless defined(&SIEP_MRIE_NO_SENSE);
    eval 'sub SIEP_MRIE_ON_REQ () {0x6;}' unless defined(&SIEP_MRIE_ON_REQ);
    eval 'sub SLBPPD_ENABLED () {0x80;}' unless defined(&SLBPPD_ENABLED);
    eval 'sub SLBPPD_TYPE_MASK () {0x38;}' unless defined(&SLBPPD_TYPE_MASK);
    eval 'sub SLBPPD_ARMING_MASK () {0x7;}' unless defined(&SLBPPD_ARMING_MASK);
    eval 'sub SLBPPD_ARMING_DEC () {0x2;}' unless defined(&SLBPPD_ARMING_DEC);
    eval 'sub SLBPPD_ARMING_INC () {0x1;}' unless defined(&SLBPPD_ARMING_INC);
    eval 'sub SLBPP_SITUA () {0x1;}' unless defined(&SLBPP_SITUA);
    eval 'sub SCSI_PROTO_FC () {0x;}' unless defined(&SCSI_PROTO_FC);
    eval 'sub SCSI_PROTO_SPI () {0x1;}' unless defined(&SCSI_PROTO_SPI);
    eval 'sub SCSI_PROTO_SSA () {0x2;}' unless defined(&SCSI_PROTO_SSA);
    eval 'sub SCSI_PROTO_1394 () {0x3;}' unless defined(&SCSI_PROTO_1394);
    eval 'sub SCSI_PROTO_RDMA () {0x4;}' unless defined(&SCSI_PROTO_RDMA);
    eval 'sub SCSI_PROTO_ISCSI () {0x5;}' unless defined(&SCSI_PROTO_ISCSI);
    eval 'sub SCSI_PROTO_iSCSI () {0x5;}' unless defined(&SCSI_PROTO_iSCSI);
    eval 'sub SCSI_PROTO_SAS () {0x6;}' unless defined(&SCSI_PROTO_SAS);
    eval 'sub SCSI_PROTO_ADT () {0x7;}' unless defined(&SCSI_PROTO_ADT);
    eval 'sub SCSI_PROTO_ADITP () {0x7;}' unless defined(&SCSI_PROTO_ADITP);
    eval 'sub SCSI_PROTO_ATA () {0x8;}' unless defined(&SCSI_PROTO_ATA);
    eval 'sub SCSI_PROTO_UAS () {0x9;}' unless defined(&SCSI_PROTO_UAS);
    eval 'sub SCSI_PROTO_SOP () {0xa;}' unless defined(&SCSI_PROTO_SOP);
    eval 'sub SCSI_PROTO_NONE () {0xf;}' unless defined(&SCSI_PROTO_NONE);
    eval 'sub SPSP_PAGE_SAVABLE () {0x80;}' unless defined(&SPSP_PAGE_SAVABLE);
    eval 'sub SPSP_PROTO_FC () { &SCSI_PROTO_FC;}' unless defined(&SPSP_PROTO_FC);
    eval 'sub SPSP_PROTO_SPI () { &SCSI_PROTO_SPI;}' unless defined(&SPSP_PROTO_SPI);
    eval 'sub SPSP_PROTO_SSA () { &SCSI_PROTO_SSA;}' unless defined(&SPSP_PROTO_SSA);
    eval 'sub SPSP_PROTO_1394 () { &SCSI_PROTO_1394;}' unless defined(&SPSP_PROTO_1394);
    eval 'sub SPSP_PROTO_RDMA () { &SCSI_PROTO_RDMA;}' unless defined(&SPSP_PROTO_RDMA);
    eval 'sub SPSP_PROTO_ISCSI () { &SCSI_PROTO_ISCSI;}' unless defined(&SPSP_PROTO_ISCSI);
    eval 'sub SPSP_PROTO_SAS () { &SCSI_PROTO_SAS;}' unless defined(&SPSP_PROTO_SAS);
    eval 'sub SPSP_PROTO_ADT () { &SCSI_PROTO_ADITP;}' unless defined(&SPSP_PROTO_ADT);
    eval 'sub SPSP_PROTO_ATA () { &SCSI_PROTO_ATA;}' unless defined(&SPSP_PROTO_ATA);
    eval 'sub SPSP_PROTO_UAS () { &SCSI_PROTO_UAS;}' unless defined(&SPSP_PROTO_UAS);
    eval 'sub SPSP_PROTO_SOP () { &SCSI_PROTO_SOP;}' unless defined(&SPSP_PROTO_SOP);
    eval 'sub SPSP_PROTO_NONE () { &SCSI_PROTO_NONE;}' unless defined(&SPSP_PROTO_NONE);
    eval 'sub SR_EXTENT () {0x1;}' unless defined(&SR_EXTENT);
    eval 'sub SR_ID_MASK () {0xe;}' unless defined(&SR_ID_MASK);
    eval 'sub SR_3RDPTY () {0x10;}' unless defined(&SR_3RDPTY);
    eval 'sub SR_LUN_MASK () {0xe0;}' unless defined(&SR_LUN_MASK);
    eval 'sub SR10_3RDPTY () {0x10;}' unless defined(&SR10_3RDPTY);
    eval 'sub SR10_LONGID () {0x2;}' unless defined(&SR10_LONGID);
    eval 'sub SR10_EXTENT () {0x1;}' unless defined(&SR10_EXTENT);
    eval 'sub PR_PREVENT () {0x1;}' unless defined(&PR_PREVENT);
    eval 'sub PR_ALLOW () {0x;}' unless defined(&PR_ALLOW);
    eval 'sub SSC_IMMED () {0x2;}' unless defined(&SSC_IMMED);
    eval 'sub SSC_RELADR () {0x1;}' unless defined(&SSC_RELADR);
    eval 'sub SF_LONGLIST () {0x20;}' unless defined(&SF_LONGLIST);
    eval 'sub SF_FMTDATA () {0x10;}' unless defined(&SF_FMTDATA);
    eval 'sub SF_CMPLIST () {0x8;}' unless defined(&SF_CMPLIST);
    eval 'sub SF_FORMAT_MASK () {0x7;}' unless defined(&SF_FORMAT_MASK);
    eval 'sub SF_FORMAT_BLOCK () {0x;}' unless defined(&SF_FORMAT_BLOCK);
    eval 'sub SF_FORMAT_LONG_BLOCK () {0x3;}' unless defined(&SF_FORMAT_LONG_BLOCK);
    eval 'sub SF_FORMAT_BFI () {0x4;}' unless defined(&SF_FORMAT_BFI);
    eval 'sub SF_FORMAT_PHYS () {0x5;}' unless defined(&SF_FORMAT_PHYS);
    eval 'sub SF_DATA_FOV () {0x80;}' unless defined(&SF_DATA_FOV);
    eval 'sub SF_DATA_DPRY () {0x40;}' unless defined(&SF_DATA_DPRY);
    eval 'sub SF_DATA_DCRT () {0x20;}' unless defined(&SF_DATA_DCRT);
    eval 'sub SF_DATA_STPF () {0x10;}' unless defined(&SF_DATA_STPF);
    eval 'sub SF_DATA_IP () {0x8;}' unless defined(&SF_DATA_IP);
    eval 'sub SF_DATA_DSP () {0x4;}' unless defined(&SF_DATA_DSP);
    eval 'sub SF_DATA_IMMED () {0x2;}' unless defined(&SF_DATA_IMMED);
    eval 'sub SF_DATA_VS () {0x1;}' unless defined(&SF_DATA_VS);
    eval 'sub RWB_MODE () {0x1f;}' unless defined(&RWB_MODE);
    eval 'sub RWB_MODE_HDR_DATA () {0x;}' unless defined(&RWB_MODE_HDR_DATA);
    eval 'sub RWB_MODE_VENDOR () {0x1;}' unless defined(&RWB_MODE_VENDOR);
    eval 'sub RWB_MODE_DATA () {0x2;}' unless defined(&RWB_MODE_DATA);
    eval 'sub RWB_MODE_DESCR () {0x3;}' unless defined(&RWB_MODE_DESCR);
    eval 'sub RWB_MODE_DOWNLOAD () {0x4;}' unless defined(&RWB_MODE_DOWNLOAD);
    eval 'sub RWB_MODE_DOWNLOAD_SAVE () {0x5;}' unless defined(&RWB_MODE_DOWNLOAD_SAVE);
    eval 'sub RWB_MODE_ECHO () {0xa;}' unless defined(&RWB_MODE_ECHO);
    eval 'sub RWB_MODE_ECHO_DESCR () {0xb;}' unless defined(&RWB_MODE_ECHO_DESCR);
    eval 'sub RWB_MODE_ERROR_HISTORY () {0x1c;}' unless defined(&RWB_MODE_ERROR_HISTORY);
    eval 'sub SRA_SA_ATTR_VALUES () {0x;}' unless defined(&SRA_SA_ATTR_VALUES);
    eval 'sub SRA_SA_ATTR_LIST () {0x1;}' unless defined(&SRA_SA_ATTR_LIST);
    eval 'sub SRA_SA_LOG_VOL_LIST () {0x2;}' unless defined(&SRA_SA_LOG_VOL_LIST);
    eval 'sub SRA_SA_PART_LIST () {0x3;}' unless defined(&SRA_SA_PART_LIST);
    eval 'sub SRA_SA_RESTRICTED () {0x4;}' unless defined(&SRA_SA_RESTRICTED);
    eval 'sub SRA_SA_SUPPORTED_ATTRS () {0x5;}' unless defined(&SRA_SA_SUPPORTED_ATTRS);
    eval 'sub SRA_SA_MASK () {0x1f;}' unless defined(&SRA_SA_MASK);
    eval 'sub SRA_CACHE () {0x1;}' unless defined(&SRA_CACHE);
    eval 'sub SWA_WTC () {0x1;}' unless defined(&SWA_WTC);
    eval 'sub SMA_ATTR_ID_DEVICE_MIN () {0x;}' unless defined(&SMA_ATTR_ID_DEVICE_MIN);
    eval 'sub SMA_ATTR_REM_CAP_PARTITION () {0x;}' unless defined(&SMA_ATTR_REM_CAP_PARTITION);
    eval 'sub SMA_ATTR_MAX_CAP_PARTITION () {0x1;}' unless defined(&SMA_ATTR_MAX_CAP_PARTITION);
    eval 'sub SMA_ATTR_TAPEALERT_FLAGS () {0x2;}' unless defined(&SMA_ATTR_TAPEALERT_FLAGS);
    eval 'sub SMA_ATTR_LOAD_COUNT () {0x3;}' unless defined(&SMA_ATTR_LOAD_COUNT);
    eval 'sub SMA_ATTR_MAM_SPACE_REMAINING () {0x4;}' unless defined(&SMA_ATTR_MAM_SPACE_REMAINING);
    eval 'sub SMA_ATTR_DEV_ASSIGNING_ORG () {0x5;}' unless defined(&SMA_ATTR_DEV_ASSIGNING_ORG);
    eval 'sub SMA_ATTR_FORMAT_DENSITY_CODE () {0x6;}' unless defined(&SMA_ATTR_FORMAT_DENSITY_CODE);
    eval 'sub SMA_ATTR_INITIALIZATION_COUNT () {0x7;}' unless defined(&SMA_ATTR_INITIALIZATION_COUNT);
    eval 'sub SMA_ATTR_VOLUME_ID () {0x8;}' unless defined(&SMA_ATTR_VOLUME_ID);
    eval 'sub SMA_ATTR_VOLUME_CHANGE_REF () {0x9;}' unless defined(&SMA_ATTR_VOLUME_CHANGE_REF);
    eval 'sub SMA_ATTR_DEV_SERIAL_LAST_LOAD () {0x20a;}' unless defined(&SMA_ATTR_DEV_SERIAL_LAST_LOAD);
    eval 'sub SMA_ATTR_DEV_SERIAL_LAST_LOAD_1 () {0x20b;}' unless defined(&SMA_ATTR_DEV_SERIAL_LAST_LOAD_1);
    eval 'sub SMA_ATTR_DEV_SERIAL_LAST_LOAD_2 () {0x20c;}' unless defined(&SMA_ATTR_DEV_SERIAL_LAST_LOAD_2);
    eval 'sub SMA_ATTR_DEV_SERIAL_LAST_LOAD_3 () {0x20d;}' unless defined(&SMA_ATTR_DEV_SERIAL_LAST_LOAD_3);
    eval 'sub SMA_ATTR_TOTAL_MB_WRITTEN_LT () {0x220;}' unless defined(&SMA_ATTR_TOTAL_MB_WRITTEN_LT);
    eval 'sub SMA_ATTR_TOTAL_MB_READ_LT () {0x221;}' unless defined(&SMA_ATTR_TOTAL_MB_READ_LT);
    eval 'sub SMA_ATTR_TOTAL_MB_WRITTEN_CUR () {0x222;}' unless defined(&SMA_ATTR_TOTAL_MB_WRITTEN_CUR);
    eval 'sub SMA_ATTR_TOTAL_MB_READ_CUR () {0x223;}' unless defined(&SMA_ATTR_TOTAL_MB_READ_CUR);
    eval 'sub SMA_ATTR_FIRST_ENC_BLOCK () {0x224;}' unless defined(&SMA_ATTR_FIRST_ENC_BLOCK);
    eval 'sub SMA_ATTR_NEXT_UNENC_BLOCK () {0x225;}' unless defined(&SMA_ATTR_NEXT_UNENC_BLOCK);
    eval 'sub SMA_ATTR_MEDIUM_USAGE_HIST () {0x340;}' unless defined(&SMA_ATTR_MEDIUM_USAGE_HIST);
    eval 'sub SMA_ATTR_PART_USAGE_HIST () {0x341;}' unless defined(&SMA_ATTR_PART_USAGE_HIST);
    eval 'sub SMA_ATTR_ID_DEVICE_MAX () {0x3ff;}' unless defined(&SMA_ATTR_ID_DEVICE_MAX);
    eval 'sub SMA_ATTR_ID_MEDIUM_MIN () {0x400;}' unless defined(&SMA_ATTR_ID_MEDIUM_MIN);
    eval 'sub SMA_ATTR_MED_MANUF () {0x400;}' unless defined(&SMA_ATTR_MED_MANUF);
    eval 'sub SMA_ATTR_MED_SERIAL () {0x401;}' unless defined(&SMA_ATTR_MED_SERIAL);
    eval 'sub SMA_ATTR_MED_LENGTH () {0x402;}' unless defined(&SMA_ATTR_MED_LENGTH);
    eval 'sub SMA_ATTR_MED_WIDTH () {0x403;}' unless defined(&SMA_ATTR_MED_WIDTH);
    eval 'sub SMA_ATTR_MED_ASSIGNING_ORG () {0x404;}' unless defined(&SMA_ATTR_MED_ASSIGNING_ORG);
    eval 'sub SMA_ATTR_MED_DENSITY_CODE () {0x405;}' unless defined(&SMA_ATTR_MED_DENSITY_CODE);
    eval 'sub SMA_ATTR_MED_MANUF_DATE () {0x406;}' unless defined(&SMA_ATTR_MED_MANUF_DATE);
    eval 'sub SMA_ATTR_MAM_CAPACITY () {0x407;}' unless defined(&SMA_ATTR_MAM_CAPACITY);
    eval 'sub SMA_ATTR_MED_TYPE () {0x408;}' unless defined(&SMA_ATTR_MED_TYPE);
    eval 'sub SMA_ATTR_MED_TYPE_INFO () {0x409;}' unless defined(&SMA_ATTR_MED_TYPE_INFO);
    eval 'sub SMA_ATTR_MED_SERIAL_NUM () {0x40a;}' unless defined(&SMA_ATTR_MED_SERIAL_NUM);
    eval 'sub SMA_ATTR_ID_MEDIUM_MAX () {0x7ff;}' unless defined(&SMA_ATTR_ID_MEDIUM_MAX);
    eval 'sub SMA_ATTR_ID_HOST_MIN () {0x800;}' unless defined(&SMA_ATTR_ID_HOST_MIN);
    eval 'sub SMA_ATTR_APP_VENDOR () {0x800;}' unless defined(&SMA_ATTR_APP_VENDOR);
    eval 'sub SMA_ATTR_APP_NAME () {0x801;}' unless defined(&SMA_ATTR_APP_NAME);
    eval 'sub SMA_ATTR_APP_VERSION () {0x802;}' unless defined(&SMA_ATTR_APP_VERSION);
    eval 'sub SMA_ATTR_USER_MED_TEXT_LABEL () {0x803;}' unless defined(&SMA_ATTR_USER_MED_TEXT_LABEL);
    eval 'sub SMA_ATTR_LAST_WRITTEN_TIME () {0x804;}' unless defined(&SMA_ATTR_LAST_WRITTEN_TIME);
    eval 'sub SMA_ATTR_TEXT_LOCAL_ID () {0x805;}' unless defined(&SMA_ATTR_TEXT_LOCAL_ID);
    eval 'sub SMA_ATTR_BARCODE () {0x806;}' unless defined(&SMA_ATTR_BARCODE);
    eval 'sub SMA_ATTR_HOST_OWNER_NAME () {0x807;}' unless defined(&SMA_ATTR_HOST_OWNER_NAME);
    eval 'sub SMA_ATTR_MEDIA_POOL () {0x808;}' unless defined(&SMA_ATTR_MEDIA_POOL);
    eval 'sub SMA_ATTR_PART_USER_LABEL () {0x809;}' unless defined(&SMA_ATTR_PART_USER_LABEL);
    eval 'sub SMA_ATTR_LOAD_UNLOAD_AT_PART () {0x80a;}' unless defined(&SMA_ATTR_LOAD_UNLOAD_AT_PART);
    eval 'sub SMA_ATTR_APP_FORMAT_VERSION () {0x80b;}' unless defined(&SMA_ATTR_APP_FORMAT_VERSION);
    eval 'sub SMA_ATTR_VOL_COHERENCY_INFO () {0x80c;}' unless defined(&SMA_ATTR_VOL_COHERENCY_INFO);
    eval 'sub SMA_ATTR_ID_HOST_MAX () {0xbff;}' unless defined(&SMA_ATTR_ID_HOST_MAX);
    eval 'sub SMA_ATTR_VENDOR_DEVICE_MIN () {0xc00;}' unless defined(&SMA_ATTR_VENDOR_DEVICE_MIN);
    eval 'sub SMA_ATTR_VENDOR_DEVICE_MAX () {0xfff;}' unless defined(&SMA_ATTR_VENDOR_DEVICE_MAX);
    eval 'sub SMA_ATTR_VENDOR_MEDIUM_MIN () {0x1000;}' unless defined(&SMA_ATTR_VENDOR_MEDIUM_MIN);
    eval 'sub SMA_ATTR_VENDOR_MEDIUM_MAX () {0x13ff;}' unless defined(&SMA_ATTR_VENDOR_MEDIUM_MAX);
    eval 'sub SMA_ATTR_VENDOR_HOST_MIN () {0x1400;}' unless defined(&SMA_ATTR_VENDOR_HOST_MIN);
    eval 'sub SMA_ATTR_VENDOR_HOST_MAX () {0x17ff;}' unless defined(&SMA_ATTR_VENDOR_HOST_MAX);
    eval 'sub SMA_FORMAT_BINARY () {0x;}' unless defined(&SMA_FORMAT_BINARY);
    eval 'sub SMA_FORMAT_ASCII () {0x1;}' unless defined(&SMA_FORMAT_ASCII);
    eval 'sub SMA_FORMAT_TEXT () {0x2;}' unless defined(&SMA_FORMAT_TEXT);
    eval 'sub SMA_FORMAT_MASK () {0x3;}' unless defined(&SMA_FORMAT_MASK);
    eval 'sub SMA_READ_ONLY () {0x80;}' unless defined(&SMA_READ_ONLY);
    eval 'sub SCSI_LTFS_VER0_LEN () {42;}' unless defined(&SCSI_LTFS_VER0_LEN);
    eval 'sub SCSI_LTFS_VER1_LEN () {43;}' unless defined(&SCSI_LTFS_VER1_LEN);
    eval 'sub SCSI_LTFS_UUID_LEN () {36;}' unless defined(&SCSI_LTFS_UUID_LEN);
    eval 'sub SCSI_LTFS_STR_NAME () {"LTFS";}' unless defined(&SCSI_LTFS_STR_NAME);
    eval 'sub SCSI_LTFS_STR_LEN () {4;}' unless defined(&SCSI_LTFS_STR_LEN);
    eval("sub SCSI_ATTR_FLAG_NONE () { 0x00; }") unless defined(&SCSI_ATTR_FLAG_NONE);
    eval("sub SCSI_ATTR_FLAG_HEX () { 0x01; }") unless defined(&SCSI_ATTR_FLAG_HEX);
    eval("sub SCSI_ATTR_FLAG_FP () { 0x02; }") unless defined(&SCSI_ATTR_FLAG_FP);
    eval("sub SCSI_ATTR_FLAG_DIV_10 () { 0x04; }") unless defined(&SCSI_ATTR_FLAG_DIV_10);
    eval("sub SCSI_ATTR_FLAG_FP_1DIGIT () { 0x08; }") unless defined(&SCSI_ATTR_FLAG_FP_1DIGIT);
    eval("sub SCSI_ATTR_OUTPUT_NONE () { 0x00; }") unless defined(&SCSI_ATTR_OUTPUT_NONE);
    eval("sub SCSI_ATTR_OUTPUT_TEXT_MASK () { 0x03; }") unless defined(&SCSI_ATTR_OUTPUT_TEXT_MASK);
    eval("sub SCSI_ATTR_OUTPUT_TEXT_RAW () { 0x00; }") unless defined(&SCSI_ATTR_OUTPUT_TEXT_RAW);
    eval("sub SCSI_ATTR_OUTPUT_TEXT_ESC () { 0x01; }") unless defined(&SCSI_ATTR_OUTPUT_TEXT_ESC);
    eval("sub SCSI_ATTR_OUTPUT_TEXT_RSV1 () { 0x02; }") unless defined(&SCSI_ATTR_OUTPUT_TEXT_RSV1);
    eval("sub SCSI_ATTR_OUTPUT_TEXT_RSV2 () { 0x03; }") unless defined(&SCSI_ATTR_OUTPUT_TEXT_RSV2);
    eval("sub SCSI_ATTR_OUTPUT_NONASCII_MASK () { 0x0c; }") unless defined(&SCSI_ATTR_OUTPUT_NONASCII_MASK);
    eval("sub SCSI_ATTR_OUTPUT_NONASCII_TRIM () { 0x00; }") unless defined(&SCSI_ATTR_OUTPUT_NONASCII_TRIM);
    eval("sub SCSI_ATTR_OUTPUT_NONASCII_ESC () { 0x04; }") unless defined(&SCSI_ATTR_OUTPUT_NONASCII_ESC);
    eval("sub SCSI_ATTR_OUTPUT_NONASCII_RAW () { 0x08; }") unless defined(&SCSI_ATTR_OUTPUT_NONASCII_RAW);
    eval("sub SCSI_ATTR_OUTPUT_NONASCII_RSV1 () { 0x0c; }") unless defined(&SCSI_ATTR_OUTPUT_NONASCII_RSV1);
    eval("sub SCSI_ATTR_OUTPUT_FIELD_MASK () { 0xf0; }") unless defined(&SCSI_ATTR_OUTPUT_FIELD_MASK);
    eval("sub SCSI_ATTR_OUTPUT_FIELD_ALL () { 0xf0; }") unless defined(&SCSI_ATTR_OUTPUT_FIELD_ALL);
    eval("sub SCSI_ATTR_OUTPUT_FIELD_NONE () { 0x00; }") unless defined(&SCSI_ATTR_OUTPUT_FIELD_NONE);
    eval("sub SCSI_ATTR_OUTPUT_FIELD_DESC () { 0x10; }") unless defined(&SCSI_ATTR_OUTPUT_FIELD_DESC);
    eval("sub SCSI_ATTR_OUTPUT_FIELD_NUM () { 0x20; }") unless defined(&SCSI_ATTR_OUTPUT_FIELD_NUM);
    eval("sub SCSI_ATTR_OUTPUT_FIELD_SIZE () { 0x40; }") unless defined(&SCSI_ATTR_OUTPUT_FIELD_SIZE);
    eval("sub SCSI_ATTR_OUTPUT_FIELD_RW () { 0x80; }") unless defined(&SCSI_ATTR_OUTPUT_FIELD_RW);
    eval 'sub SRW_TOPADDR () {0x1f;}' unless defined(&SRW_TOPADDR);
    eval 'sub SRW10_RELADDR () {0x1;}' unless defined(&SRW10_RELADDR);
    eval 'sub SRW10_EBP () {0x4;}' unless defined(&SRW10_EBP);
    eval 'sub SRW10_FUA () {0x8;}' unless defined(&SRW10_FUA);
    eval 'sub SRW10_DPO () {0x10;}' unless defined(&SRW10_DPO);
    eval 'sub SRW12_RELADDR () {0x1;}' unless defined(&SRW12_RELADDR);
    eval 'sub SRW12_FUA () {0x8;}' unless defined(&SRW12_FUA);
    eval 'sub SRW12_DPO () {0x10;}' unless defined(&SRW12_DPO);
    eval 'sub SRW16_RELADDR () {0x1;}' unless defined(&SRW16_RELADDR);
    eval 'sub SRW16_FUA () {0x8;}' unless defined(&SRW16_FUA);
    eval 'sub SRW16_DPO () {0x10;}' unless defined(&SRW16_DPO);
    eval 'sub SWS_LBDATA () {0x2;}' unless defined(&SWS_LBDATA);
    eval 'sub SWS_PBDATA () {0x4;}' unless defined(&SWS_PBDATA);
    eval 'sub SWS_UNMAP () {0x8;}' unless defined(&SWS_UNMAP);
    eval 'sub SWS_ANCHOR () {0x10;}' unless defined(&SWS_ANCHOR);
    eval 'sub SWS_NDOB () {0x1;}' unless defined(&SWS_NDOB);
    eval 'sub SU_ANCHOR () {0x1;}' unless defined(&SU_ANCHOR);
    eval 'sub SWV_BYTCHK () {0x2;}' unless defined(&SWV_BYTCHK);
    eval 'sub SWV_DPO () {0x10;}' unless defined(&SWV_DPO);
    eval 'sub SWV_WRPROECT_MASK () {0xe0;}' unless defined(&SWV_WRPROECT_MASK);
    eval 'sub SSS_IMMED () {0x1;}' unless defined(&SSS_IMMED);
    eval 'sub SSS_START () {0x1;}' unless defined(&SSS_START);
    eval 'sub SSS_LOEJ () {0x2;}' unless defined(&SSS_LOEJ);
    eval 'sub SSS_PC_MASK () {0xf0;}' unless defined(&SSS_PC_MASK);
    eval 'sub SSS_PC_START_VALID () {0x;}' unless defined(&SSS_PC_START_VALID);
    eval 'sub SSS_PC_ACTIVE () {0x10;}' unless defined(&SSS_PC_ACTIVE);
    eval 'sub SSS_PC_IDLE () {0x20;}' unless defined(&SSS_PC_IDLE);
    eval 'sub SSS_PC_STANDBY () {0x30;}' unless defined(&SSS_PC_STANDBY);
    eval 'sub SSS_PC_LU_CONTROL () {0x70;}' unless defined(&SSS_PC_LU_CONTROL);
    eval 'sub SSS_PC_FORCE_IDLE_0 () {0xa0;}' unless defined(&SSS_PC_FORCE_IDLE_0);
    eval 'sub SSS_PC_FORCE_STANDBY_0 () {0xb0;}' unless defined(&SSS_PC_FORCE_STANDBY_0);
    eval 'sub AP_PROTO_HARD_RESET () {(0x << 1);}' unless defined(&AP_PROTO_HARD_RESET);
    eval 'sub AP_PROTO_SRST () {(0x1 << 1);}' unless defined(&AP_PROTO_SRST);
    eval 'sub AP_PROTO_NON_DATA () {(0x3 << 1);}' unless defined(&AP_PROTO_NON_DATA);
    eval 'sub AP_PROTO_PIO_IN () {(0x4 << 1);}' unless defined(&AP_PROTO_PIO_IN);
    eval 'sub AP_PROTO_PIO_OUT () {(0x5 << 1);}' unless defined(&AP_PROTO_PIO_OUT);
    eval 'sub AP_PROTO_DMA () {(0x6 << 1);}' unless defined(&AP_PROTO_DMA);
    eval 'sub AP_PROTO_DMA_QUEUED () {(0x7 << 1);}' unless defined(&AP_PROTO_DMA_QUEUED);
    eval 'sub AP_PROTO_DEVICE_DIAG () {(0x8 << 1);}' unless defined(&AP_PROTO_DEVICE_DIAG);
    eval 'sub AP_PROTO_DEVICE_RESET () {(0x9 << 1);}' unless defined(&AP_PROTO_DEVICE_RESET);
    eval 'sub AP_PROTO_UDMA_IN () {(0xa << 1);}' unless defined(&AP_PROTO_UDMA_IN);
    eval 'sub AP_PROTO_UDMA_OUT () {(0xb << 1);}' unless defined(&AP_PROTO_UDMA_OUT);
    eval 'sub AP_PROTO_FPDMA () {(0xc << 1);}' unless defined(&AP_PROTO_FPDMA);
    eval 'sub AP_PROTO_RESP_INFO () {(0xf << 1);}' unless defined(&AP_PROTO_RESP_INFO);
    eval 'sub AP_PROTO_MASK () {0x1e;}' unless defined(&AP_PROTO_MASK);
    eval 'sub AP_MULTI () {0xe0;}' unless defined(&AP_MULTI);
    eval 'sub AP_T_LEN () {0x3;}' unless defined(&AP_T_LEN);
    eval 'sub AP_BB () {0x4;}' unless defined(&AP_BB);
    eval 'sub AP_T_DIR () {0x8;}' unless defined(&AP_T_DIR);
    eval 'sub AP_CK_COND () {0x20;}' unless defined(&AP_CK_COND);
    eval 'sub AP_OFFLINE () {0x60;}' unless defined(&AP_OFFLINE);
    eval 'sub SERVICE_ACTION_MASK () {0x1f;}' unless defined(&SERVICE_ACTION_MASK);
    eval 'sub SA_RPRT_TRGT_GRP () {0xa;}' unless defined(&SA_RPRT_TRGT_GRP);
    eval 'sub RSO_RCTD () {0x80;}' unless defined(&RSO_RCTD);
    eval 'sub RSO_OPTIONS_MASK () {0x7;}' unless defined(&RSO_OPTIONS_MASK);
    eval 'sub RSO_OPTIONS_ALL () {0x;}' unless defined(&RSO_OPTIONS_ALL);
    eval 'sub RSO_OPTIONS_OC () {0x1;}' unless defined(&RSO_OPTIONS_OC);
    eval 'sub RSO_OPTIONS_OC_SA () {0x2;}' unless defined(&RSO_OPTIONS_OC_SA);
    eval 'sub RSO_OPTIONS_OC_ASA () {0x3;}' unless defined(&RSO_OPTIONS_OC_ASA);
    eval 'sub RSO_SERVACTV () {0x1;}' unless defined(&RSO_SERVACTV);
    eval 'sub RSO_CTDP () {0x2;}' unless defined(&RSO_CTDP);
    eval 'sub RSO_CDLP_MASK () {0xc;}' unless defined(&RSO_CDLP_MASK);
    eval 'sub RSO_CDLP_NO () {0x;}' unless defined(&RSO_CDLP_NO);
    eval 'sub RSO_CDLP_A () {0x4;}' unless defined(&RSO_CDLP_A);
    eval 'sub RSO_CDLP_B () {0x8;}' unless defined(&RSO_CDLP_B);
    eval 'sub RSO_ONE_CTDP () {0x80;}' unless defined(&RSO_ONE_CTDP);
    eval 'sub RSO_ONE_CDLP_MASK () {0x18;}' unless defined(&RSO_ONE_CDLP_MASK);
    eval 'sub RSO_ONE_CDLP_NO () {0x;}' unless defined(&RSO_ONE_CDLP_NO);
    eval 'sub RSO_ONE_CDLP_A () {0x8;}' unless defined(&RSO_ONE_CDLP_A);
    eval 'sub RSO_ONE_CDLP_B () {0x10;}' unless defined(&RSO_ONE_CDLP_B);
    eval 'sub RSO_ONE_SUP_MASK () {0x7;}' unless defined(&RSO_ONE_SUP_MASK);
    eval 'sub RSO_ONE_SUP_UNAVAIL () {0x;}' unless defined(&RSO_ONE_SUP_UNAVAIL);
    eval 'sub RSO_ONE_SUP_NOT_SUP () {0x1;}' unless defined(&RSO_ONE_SUP_NOT_SUP);
    eval 'sub RSO_ONE_SUP_AVAIL () {0x3;}' unless defined(&RSO_ONE_SUP_AVAIL);
    eval 'sub RSO_ONE_SUP_VENDOR () {0x5;}' unless defined(&RSO_ONE_SUP_VENDOR);
    eval 'sub RST_REPD () {0x80;}' unless defined(&RST_REPD);
    eval 'sub RST_WAKES () {0x1;}' unless defined(&RST_WAKES);
    eval 'sub RST_TRS () {0x2;}' unless defined(&RST_TRS);
    eval 'sub RST_QTS () {0x4;}' unless defined(&RST_QTS);
    eval 'sub RST_LURS () {0x8;}' unless defined(&RST_LURS);
    eval 'sub RST_CTSS () {0x10;}' unless defined(&RST_CTSS);
    eval 'sub RST_CACAS () {0x20;}' unless defined(&RST_CACAS);
    eval 'sub RST_ATSS () {0x40;}' unless defined(&RST_ATSS);
    eval 'sub RST_ATS () {0x80;}' unless defined(&RST_ATS);
    eval 'sub RST_ITNRS () {0x1;}' unless defined(&RST_ITNRS);
    eval 'sub RST_QTSS () {0x2;}' unless defined(&RST_QTSS);
    eval 'sub RST_QAES () {0x4;}' unless defined(&RST_QAES);
    eval 'sub RST_TMFTMOV () {0x1;}' unless defined(&RST_TMFTMOV);
    eval 'sub RST_WAKETS () {0x1;}' unless defined(&RST_WAKETS);
    eval 'sub RST_TRTS () {0x2;}' unless defined(&RST_TRTS);
    eval 'sub RST_QTTS () {0x4;}' unless defined(&RST_QTTS);
    eval 'sub RST_LURTS () {0x8;}' unless defined(&RST_LURTS);
    eval 'sub RST_CTSTS () {0x10;}' unless defined(&RST_CTSTS);
    eval 'sub RST_CACATS () {0x20;}' unless defined(&RST_CACATS);
    eval 'sub RST_ATSTS () {0x40;}' unless defined(&RST_ATSTS);
    eval 'sub RST_ATTS () {0x80;}' unless defined(&RST_ATTS);
    eval 'sub RST_ITNRTS () {0x1;}' unless defined(&RST_ITNRTS);
    eval 'sub RST_QTSTS () {0x2;}' unless defined(&RST_QTSTS);
    eval 'sub RST_QAETS () {0x4;}' unless defined(&RST_QAETS);
    eval 'sub RTS_ORIG_MASK () {0x;}' unless defined(&RTS_ORIG_MASK);
    eval 'sub RTS_ORIG_ZERO () {0x;}' unless defined(&RTS_ORIG_ZERO);
    eval 'sub RTS_ORIG_SET () {0x2;}' unless defined(&RTS_ORIG_SET);
    eval 'sub RTS_ORIG_OUTSIDE () {0x3;}' unless defined(&RTS_ORIG_OUTSIDE);
    eval 'sub RCS_RCS_LID1 () {0x;}' unless defined(&RCS_RCS_LID1);
    eval 'sub RCS_CCS_INPROG () {0x;}' unless defined(&RCS_CCS_INPROG);
    eval 'sub RCS_CCS_COMPLETED () {0x1;}' unless defined(&RCS_CCS_COMPLETED);
    eval 'sub RCS_CCS_ERROR () {0x2;}' unless defined(&RCS_CCS_ERROR);
    eval 'sub RCS_TC_BYTES () {0x;}' unless defined(&RCS_TC_BYTES);
    eval 'sub RCS_TC_KBYTES () {0x1;}' unless defined(&RCS_TC_KBYTES);
    eval 'sub RCS_TC_MBYTES () {0x2;}' unless defined(&RCS_TC_MBYTES);
    eval 'sub RCS_TC_GBYTES () {0x3;}' unless defined(&RCS_TC_GBYTES);
    eval 'sub RCS_TC_TBYTES () {0x4;}' unless defined(&RCS_TC_TBYTES);
    eval 'sub RCS_TC_PBYTES () {0x5;}' unless defined(&RCS_TC_PBYTES);
    eval 'sub RCS_TC_EBYTES () {0x6;}' unless defined(&RCS_TC_EBYTES);
    eval 'sub RCS_TC_LBAS () {0xf1;}' unless defined(&RCS_TC_LBAS);
    eval 'sub RCS_RCFD () {0x4;}' unless defined(&RCS_RCFD);
    eval 'sub RCS_RCS_LID4 () {0x5;}' unless defined(&RCS_RCS_LID4);
    eval 'sub RCS_CCS_COMPLETED_PROD () {0x3;}' unless defined(&RCS_CCS_COMPLETED_PROD);
    eval 'sub RCS_CCS_COMPLETED_RESID () {0x4;}' unless defined(&RCS_CCS_COMPLETED_RESID);
    eval 'sub RCS_CCS_INPROG_FGBG () {0x10;}' unless defined(&RCS_CCS_INPROG_FGBG);
    eval 'sub RCS_CCS_INPROG_FG () {0x11;}' unless defined(&RCS_CCS_INPROG_FG);
    eval 'sub RCS_CCS_INPROG_BG () {0x12;}' unless defined(&RCS_CCS_INPROG_BG);
    eval 'sub RCS_CCS_ABORTED () {0x60;}' unless defined(&RCS_CCS_ABORTED);
    eval 'sub RCS_RCOP () {0x3;}' unless defined(&RCS_RCOP);
    eval 'sub RCOP_SNLID () {0x1;}' unless defined(&RCOP_SNLID);
    eval 'sub EC_EC_LID1 () {0x;}' unless defined(&EC_EC_LID1);
    eval 'sub EC_EC_LID4 () {0x1;}' unless defined(&EC_EC_LID4);
    eval 'sub EC_CSCD_FIXED () {0x1;}' unless defined(&EC_CSCD_FIXED);
    eval 'sub EC_CSCD_PAD () {0x4;}' unless defined(&EC_CSCD_PAD);
    eval 'sub EC_CSCD_EXT () {0xff;}' unless defined(&EC_CSCD_EXT);
    eval 'sub EC_NUL () {0x20;}' unless defined(&EC_NUL);
    eval 'sub EC_LUIDT_MASK () {0xc0;}' unless defined(&EC_LUIDT_MASK);
    eval 'sub EC_LUIDT_LUN () {0x;}' unless defined(&EC_LUIDT_LUN);
    eval 'sub EC_LUIDT_PROXY_TOKEN () {0x40;}' unless defined(&EC_LUIDT_PROXY_TOKEN);
    eval 'sub EC_CSCD_ID () {0xe4;}' unless defined(&EC_CSCD_ID);
    eval 'sub EC_SEG_DC () {0x2;}' unless defined(&EC_SEG_DC);
    eval 'sub EC_SEG_CAT () {0x1;}' unless defined(&EC_SEG_CAT);
    eval 'sub EC_SEG_B2B () {0x2;}' unless defined(&EC_SEG_B2B);
    eval 'sub EC_SEG_VERIFY () {0x7;}' unless defined(&EC_SEG_VERIFY);
    eval 'sub EC_SEG_REGISTER_KEY () {0x14;}' unless defined(&EC_SEG_REGISTER_KEY);
    eval 'sub EC_PRIORITY () {0x7;}' unless defined(&EC_PRIORITY);
    eval 'sub EC_LIST_ID_USAGE_MASK () {0x18;}' unless defined(&EC_LIST_ID_USAGE_MASK);
    eval 'sub EC_LIST_ID_USAGE_FULL () {0x8;}' unless defined(&EC_LIST_ID_USAGE_FULL);
    eval 'sub EC_LIST_ID_USAGE_NOHOLD () {0x10;}' unless defined(&EC_LIST_ID_USAGE_NOHOLD);
    eval 'sub EC_LIST_ID_USAGE_NONE () {0x18;}' unless defined(&EC_LIST_ID_USAGE_NONE);
    eval 'sub EC_STR () {0x20;}' unless defined(&EC_STR);
    eval 'sub EC_LIST_FORMAT () {0x1;}' unless defined(&EC_LIST_FORMAT);
    eval 'sub EC_IMMED () {0x1;}' unless defined(&EC_IMMED);
    eval 'sub EC_G_SENSE () {0x2;}' unless defined(&EC_G_SENSE);
    eval 'sub EC_COA () {0x1c;}' unless defined(&EC_COA);
    eval 'sub EC_PT () {0x10;}' unless defined(&EC_PT);
    eval 'sub EC_PT_IMMED () {0x1;}' unless defined(&EC_PT_IMMED);
    eval 'sub EC_PT_RTV () {0x2;}' unless defined(&EC_PT_RTV);
    eval 'sub EC_WUT () {0x11;}' unless defined(&EC_WUT);
    eval 'sub EC_WUT_IMMED () {0x1;}' unless defined(&EC_WUT_IMMED);
    eval 'sub EC_WUT_DEL_TKN () {0x2;}' unless defined(&EC_WUT_DEL_TKN);
    eval 'sub RCS_RRTI () {0x7;}' unless defined(&RCS_RRTI);
    eval 'sub ROD_TYPE_INTERNAL () {0x;}' unless defined(&ROD_TYPE_INTERNAL);
    eval 'sub ROD_TYPE_AUR () {0x10000;}' unless defined(&ROD_TYPE_AUR);
    eval 'sub ROD_TYPE_PIT_DEF () {0x800000;}' unless defined(&ROD_TYPE_PIT_DEF);
    eval 'sub ROD_TYPE_PIT_VULN () {0x800001;}' unless defined(&ROD_TYPE_PIT_VULN);
    eval 'sub ROD_TYPE_PIT_PERS () {0x800002;}' unless defined(&ROD_TYPE_PIT_PERS);
    eval 'sub ROD_TYPE_PIT_ANY () {0x80ffff;}' unless defined(&ROD_TYPE_PIT_ANY);
    eval 'sub ROD_TYPE_BLOCK_ZERO () {0xffff0001;}' unless defined(&ROD_TYPE_BLOCK_ZERO);
    eval 'sub RCS_RART () {0x8;}' unless defined(&RCS_RART);
    eval 'sub AP_EXTEND () {0x1;}' unless defined(&AP_EXTEND);
    eval 'sub AP_FLAG_TLEN_NO_DATA () {(0<< 0);}' unless defined(&AP_FLAG_TLEN_NO_DATA);
    eval 'sub AP_FLAG_TLEN_FEAT () {(1<< 0);}' unless defined(&AP_FLAG_TLEN_FEAT);
    eval 'sub AP_FLAG_TLEN_SECT_CNT () {(2<< 0);}' unless defined(&AP_FLAG_TLEN_SECT_CNT);
    eval 'sub AP_FLAG_TLEN_STPSIU () {(3<< 0);}' unless defined(&AP_FLAG_TLEN_STPSIU);
    eval 'sub AP_FLAG_BYT_BLOK_BYTES () {(0<< 2);}' unless defined(&AP_FLAG_BYT_BLOK_BYTES);
    eval 'sub AP_FLAG_BYT_BLOK_BLOCKS () {(1<< 2);}' unless defined(&AP_FLAG_BYT_BLOK_BLOCKS);
    eval 'sub AP_FLAG_TDIR_TO_DEV () {(0<< 3);}' unless defined(&AP_FLAG_TDIR_TO_DEV);
    eval 'sub AP_FLAG_TDIR_FROM_DEV () {(1<< 3);}' unless defined(&AP_FLAG_TDIR_FROM_DEV);
    eval 'sub AP_FLAG_CHK_COND () {(1<< 5);}' unless defined(&AP_FLAG_CHK_COND);
    eval 'sub ATA_PASS_32_SA () {0x1ff0;}' unless defined(&ATA_PASS_32_SA);
    eval 'sub SC_SCSI_1 () {0x1;}' unless defined(&SC_SCSI_1);
    eval 'sub SC_SCSI_2 () {0x3;}' unless defined(&SC_SCSI_2);
    eval 'sub TEST_UNIT_READY () {0x;}' unless defined(&TEST_UNIT_READY);
    eval 'sub REQUEST_SENSE () {0x3;}' unless defined(&REQUEST_SENSE);
    eval 'sub READ_6 () {0x8;}' unless defined(&READ_6);
    eval 'sub WRITE_6 () {0xa;}' unless defined(&WRITE_6);
    eval 'sub INQUIRY () {0x12;}' unless defined(&INQUIRY);
    eval 'sub MODE_SELECT_6 () {0x15;}' unless defined(&MODE_SELECT_6);
    eval 'sub MODE_SENSE_6 () {0x1a;}' unless defined(&MODE_SENSE_6);
    eval 'sub START_STOP_UNIT () {0x1b;}' unless defined(&START_STOP_UNIT);
    eval 'sub START_STOP () {0x1b;}' unless defined(&START_STOP);
    eval 'sub RESERVE () {0x16;}' unless defined(&RESERVE);
    eval 'sub RELEASE () {0x17;}' unless defined(&RELEASE);
    eval 'sub RECEIVE_DIAGNOSTIC () {0x1c;}' unless defined(&RECEIVE_DIAGNOSTIC);
    eval 'sub SEND_DIAGNOSTIC () {0x1d;}' unless defined(&SEND_DIAGNOSTIC);
    eval 'sub PREVENT_ALLOW () {0x1e;}' unless defined(&PREVENT_ALLOW);
    eval 'sub READ_CAPACITY () {0x25;}' unless defined(&READ_CAPACITY);
    eval 'sub READ_10 () {0x28;}' unless defined(&READ_10);
    eval 'sub WRITE_10 () {0x2a;}' unless defined(&WRITE_10);
    eval 'sub POSITION_TO_ELEMENT () {0x2b;}' unless defined(&POSITION_TO_ELEMENT);
    eval 'sub WRITE_VERIFY_10 () {0x2e;}' unless defined(&WRITE_VERIFY_10);
    eval 'sub VERIFY_10 () {0x2f;}' unless defined(&VERIFY_10);
    eval 'sub SYNCHRONIZE_CACHE () {0x35;}' unless defined(&SYNCHRONIZE_CACHE);
    eval 'sub READ_DEFECT_DATA_10 () {0x37;}' unless defined(&READ_DEFECT_DATA_10);
    eval 'sub WRITE_BUFFER () {0x3b;}' unless defined(&WRITE_BUFFER);
    eval 'sub READ_BUFFER () {0x3c;}' unless defined(&READ_BUFFER);
    eval 'sub CHANGE_DEFINITION () {0x40;}' unless defined(&CHANGE_DEFINITION);
    eval 'sub WRITE_SAME_10 () {0x41;}' unless defined(&WRITE_SAME_10);
    eval 'sub UNMAP () {0x42;}' unless defined(&UNMAP);
    eval 'sub LOG_SELECT () {0x4c;}' unless defined(&LOG_SELECT);
    eval 'sub LOG_SENSE () {0x4d;}' unless defined(&LOG_SENSE);
    eval 'sub MODE_SELECT_10 () {0x55;}' unless defined(&MODE_SELECT_10);
    eval 'sub RESERVE_10 () {0x56;}' unless defined(&RESERVE_10);
    eval 'sub RELEASE_10 () {0x57;}' unless defined(&RELEASE_10);
    eval 'sub MODE_SENSE_10 () {0x5a;}' unless defined(&MODE_SENSE_10);
    eval 'sub PERSISTENT_RES_IN () {0x5e;}' unless defined(&PERSISTENT_RES_IN);
    eval 'sub PERSISTENT_RES_OUT () {0x5f;}' unless defined(&PERSISTENT_RES_OUT);
    eval 'sub EXTENDED_CDB () {0x7e;}' unless defined(&EXTENDED_CDB);
    eval 'sub VARIABLE_LEN_CDB () {0x7f;}' unless defined(&VARIABLE_LEN_CDB);
    eval 'sub EXTENDED_COPY () {0x83;}' unless defined(&EXTENDED_COPY);
    eval 'sub RECEIVE_COPY_STATUS () {0x84;}' unless defined(&RECEIVE_COPY_STATUS);
    eval 'sub ATA_PASS_16 () {0x85;}' unless defined(&ATA_PASS_16);
    eval 'sub READ_16 () {0x88;}' unless defined(&READ_16);
    eval 'sub COMPARE_AND_WRITE () {0x89;}' unless defined(&COMPARE_AND_WRITE);
    eval 'sub WRITE_16 () {0x8a;}' unless defined(&WRITE_16);
    eval 'sub READ_ATTRIBUTE () {0x8c;}' unless defined(&READ_ATTRIBUTE);
    eval 'sub WRITE_ATTRIBUTE () {0x8d;}' unless defined(&WRITE_ATTRIBUTE);
    eval 'sub WRITE_VERIFY_16 () {0x8e;}' unless defined(&WRITE_VERIFY_16);
    eval 'sub VERIFY_16 () {0x8f;}' unless defined(&VERIFY_16);
    eval 'sub SYNCHRONIZE_CACHE_16 () {0x91;}' unless defined(&SYNCHRONIZE_CACHE_16);
    eval 'sub WRITE_SAME_16 () {0x93;}' unless defined(&WRITE_SAME_16);
    eval 'sub READ_BUFFER_16 () {0x9b;}' unless defined(&READ_BUFFER_16);
    eval 'sub WRITE_ATOMIC_16 () {0x9c;}' unless defined(&WRITE_ATOMIC_16);
    eval 'sub SERVICE_ACTION_IN () {0x9e;}' unless defined(&SERVICE_ACTION_IN);
    eval 'sub REPORT_LUNS () {0xa0;}' unless defined(&REPORT_LUNS);
    eval 'sub ATA_PASS_12 () {0xa1;}' unless defined(&ATA_PASS_12);
    eval 'sub SECURITY_PROTOCOL_IN () {0xa2;}' unless defined(&SECURITY_PROTOCOL_IN);
    eval 'sub MAINTENANCE_IN () {0xa3;}' unless defined(&MAINTENANCE_IN);
    eval 'sub MAINTENANCE_OUT () {0xa4;}' unless defined(&MAINTENANCE_OUT);
    eval 'sub MOVE_MEDIUM () {0xa5;}' unless defined(&MOVE_MEDIUM);
    eval 'sub READ_12 () {0xa8;}' unless defined(&READ_12);
    eval 'sub WRITE_12 () {0xaa;}' unless defined(&WRITE_12);
    eval 'sub WRITE_VERIFY_12 () {0xae;}' unless defined(&WRITE_VERIFY_12);
    eval 'sub VERIFY_12 () {0xaf;}' unless defined(&VERIFY_12);
    eval 'sub SECURITY_PROTOCOL_OUT () {0xb5;}' unless defined(&SECURITY_PROTOCOL_OUT);
    eval 'sub READ_ELEMENT_STATUS () {0xb8;}' unless defined(&READ_ELEMENT_STATUS);
    eval 'sub READ_CD () {0xbe;}' unless defined(&READ_CD);
    eval 'sub REPORT_IDENTIFYING_INFRMATION () {0x5;}' unless defined(&REPORT_IDENTIFYING_INFRMATION);
    eval 'sub REPORT_TARGET_PORT_GROUPS () {0xa;}' unless defined(&REPORT_TARGET_PORT_GROUPS);
    eval 'sub REPORT_ALIASES () {0xb;}' unless defined(&REPORT_ALIASES);
    eval 'sub REPORT_SUPPORTED_OPERATION_CODES () {0xc;}' unless defined(&REPORT_SUPPORTED_OPERATION_CODES);
    eval 'sub REPORT_SUPPORTED_TASK_MANAGEMENT_FUNCTIONS () {0xd;}' unless defined(&REPORT_SUPPORTED_TASK_MANAGEMENT_FUNCTIONS);
    eval 'sub REPORT_PRIORITY () {0xe;}' unless defined(&REPORT_PRIORITY);
    eval 'sub REPORT_TIMESTAMP () {0xf;}' unless defined(&REPORT_TIMESTAMP);
    eval 'sub MANAGEMENT_PROTOCOL_IN () {0x10;}' unless defined(&MANAGEMENT_PROTOCOL_IN);
    eval 'sub SET_IDENTIFY_INFORMATION () {0x6;}' unless defined(&SET_IDENTIFY_INFORMATION);
    eval 'sub SET_TARGET_PORT_GROUPS () {0xa;}' unless defined(&SET_TARGET_PORT_GROUPS);
    eval 'sub CHANGE_ALIASES () {0xb;}' unless defined(&CHANGE_ALIASES);
    eval 'sub SET_PRIORITY () {0xe;}' unless defined(&SET_PRIORITY);
    eval 'sub SET_TIMESTAMP () {0xf;}' unless defined(&SET_TIMESTAMP);
    eval 'sub MANGAEMENT_PROTOCOL_OUT () {0x10;}' unless defined(&MANGAEMENT_PROTOCOL_OUT);
    eval 'sub T_DIRECT () {0x;}' unless defined(&T_DIRECT);
    eval 'sub T_SEQUENTIAL () {0x1;}' unless defined(&T_SEQUENTIAL);
    eval 'sub T_PRINTER () {0x2;}' unless defined(&T_PRINTER);
    eval 'sub T_PROCESSOR () {0x3;}' unless defined(&T_PROCESSOR);
    eval 'sub T_WORM () {0x4;}' unless defined(&T_WORM);
    eval 'sub T_CDROM () {0x5;}' unless defined(&T_CDROM);
    eval 'sub T_SCANNER () {0x6;}' unless defined(&T_SCANNER);
    eval 'sub T_OPTICAL () {0x7;}' unless defined(&T_OPTICAL);
    eval 'sub T_CHANGER () {0x8;}' unless defined(&T_CHANGER);
    eval 'sub T_COMM () {0x9;}' unless defined(&T_COMM);
    eval 'sub T_ASC0 () {0xa;}' unless defined(&T_ASC0);
    eval 'sub T_ASC1 () {0xb;}' unless defined(&T_ASC1);
    eval 'sub T_STORARRAY () {0xc;}' unless defined(&T_STORARRAY);
    eval 'sub T_ENCLOSURE () {0xd;}' unless defined(&T_ENCLOSURE);
    eval 'sub T_RBC () {0xe;}' unless defined(&T_RBC);
    eval 'sub T_OCRW () {0xf;}' unless defined(&T_OCRW);
    eval 'sub T_OSD () {0x11;}' unless defined(&T_OSD);
    eval 'sub T_ADC () {0x12;}' unless defined(&T_ADC);
    eval 'sub T_ZBC_HM () {0x14;}' unless defined(&T_ZBC_HM);
    eval 'sub T_NODEVICE () {0x1f;}' unless defined(&T_NODEVICE);
    eval 'sub T_ANY () {0xff;}' unless defined(&T_ANY);
    eval 'sub T_REMOV () {1;}' unless defined(&T_REMOV);
    eval 'sub T_FIXED () {0;}' unless defined(&T_FIXED);
    eval 'sub SHORT_INQUIRY_LENGTH () {36;}' unless defined(&SHORT_INQUIRY_LENGTH);
    eval 'sub SID_TYPE {
        my($inq_data) = @_;
	    eval q((($inq_data)-> &device & 0x1f));
    }' unless defined(&SID_TYPE);
    eval 'sub SID_QUAL {
        my($inq_data) = @_;
	    eval q(((($inq_data)-> &device & 0xe0) >> 5));
    }' unless defined(&SID_QUAL);
    eval 'sub SID_QUAL_LU_CONNECTED () {0x;}' unless defined(&SID_QUAL_LU_CONNECTED);
    eval 'sub SID_QUAL_LU_OFFLINE () {0x1;}' unless defined(&SID_QUAL_LU_OFFLINE);
    eval 'sub SID_QUAL_RSVD () {0x2;}' unless defined(&SID_QUAL_RSVD);
    eval 'sub SID_QUAL_BAD_LU () {0x3;}' unless defined(&SID_QUAL_BAD_LU);
    eval 'sub SID_QUAL_IS_VENDOR_UNIQUE {
        my($inq_data) = @_;
	    eval q((( &SID_QUAL($inq_data) & 0x4) != 0));
    }' unless defined(&SID_QUAL_IS_VENDOR_UNIQUE);
    eval 'sub SID_QUAL2 () {0x7f;}' unless defined(&SID_QUAL2);
    eval 'sub SID_LU_CONG () {0x40;}' unless defined(&SID_LU_CONG);
    eval 'sub SID_RMB () {0x80;}' unless defined(&SID_RMB);
    eval 'sub SID_IS_REMOVABLE {
        my($inq_data) = @_;
	    eval q(((($inq_data)-> &dev_qual2 &  &SID_RMB) != 0));
    }' unless defined(&SID_IS_REMOVABLE);
    eval 'sub SID_ANSI_REV {
        my($inq_data) = @_;
	    eval q((($inq_data)-> &version & 0x7));
    }' unless defined(&SID_ANSI_REV);
    eval 'sub SCSI_REV_0 () {0;}' unless defined(&SCSI_REV_0);
    eval 'sub SCSI_REV_CCS () {1;}' unless defined(&SCSI_REV_CCS);
    eval 'sub SCSI_REV_2 () {2;}' unless defined(&SCSI_REV_2);
    eval 'sub SCSI_REV_SPC () {3;}' unless defined(&SCSI_REV_SPC);
    eval 'sub SCSI_REV_SPC2 () {4;}' unless defined(&SCSI_REV_SPC2);
    eval 'sub SCSI_REV_SPC3 () {5;}' unless defined(&SCSI_REV_SPC3);
    eval 'sub SCSI_REV_SPC4 () {6;}' unless defined(&SCSI_REV_SPC4);
    eval 'sub SCSI_REV_SPC5 () {7;}' unless defined(&SCSI_REV_SPC5);
    eval 'sub SID_ECMA () {0x38;}' unless defined(&SID_ECMA);
    eval 'sub SID_ISO () {0xc0;}' unless defined(&SID_ISO);
    eval 'sub SID_AENC () {0x80;}' unless defined(&SID_AENC);
    eval 'sub SID_TrmIOP () {0x40;}' unless defined(&SID_TrmIOP);
    eval 'sub SID_NormACA () {0x20;}' unless defined(&SID_NormACA);
    eval 'sub SID_HiSup () {0x10;}' unless defined(&SID_HiSup);
    eval 'sub SID_ADDITIONAL_LENGTH {
        my($iqd) = @_;
	    eval q((($iqd)-> &additional_length +  &__offsetof(\'struct scsi_inquiry_data\',  &additional_length) + 1));
    }' unless defined(&SID_ADDITIONAL_LENGTH);
    eval 'sub SPC3_SID_PROTECT () {0x1;}' unless defined(&SPC3_SID_PROTECT);
    eval 'sub SPC3_SID_3PC () {0x8;}' unless defined(&SPC3_SID_3PC);
    eval 'sub SPC3_SID_TPGS_MASK () {0x30;}' unless defined(&SPC3_SID_TPGS_MASK);
    eval 'sub SPC3_SID_TPGS_IMPLICIT () {0x10;}' unless defined(&SPC3_SID_TPGS_IMPLICIT);
    eval 'sub SPC3_SID_TPGS_EXPLICIT () {0x20;}' unless defined(&SPC3_SID_TPGS_EXPLICIT);
    eval 'sub SPC3_SID_ACC () {0x40;}' unless defined(&SPC3_SID_ACC);
    eval 'sub SPC3_SID_SCCS () {0x80;}' unless defined(&SPC3_SID_SCCS);
    eval 'sub SPC2_SID_ADDR16 () {0x1;}' unless defined(&SPC2_SID_ADDR16);
    eval 'sub SPC2_SID_MChngr () {0x8;}' unless defined(&SPC2_SID_MChngr);
    eval 'sub SPC2_SID_MultiP () {0x10;}' unless defined(&SPC2_SID_MultiP);
    eval 'sub SPC2_SID_EncServ () {0x40;}' unless defined(&SPC2_SID_EncServ);
    eval 'sub SPC2_SID_BQueue () {0x80;}' unless defined(&SPC2_SID_BQueue);
    eval 'sub INQ_DATA_TQ_ENABLED {
        my($iqd) = @_;
	    eval q((( &SID_ANSI_REV($iqd) <  &SCSI_REV_SPC2)? (($iqd)-> &flags &  &SID_CmdQue) : ((($iqd)-> &flags &  &SID_CmdQue)  && !(($iqd)-> &spc2_flags &  &SPC2_SID_BQueue)) || (!(($iqd)-> &flags &  &SID_CmdQue)  && (($iqd)-> &spc2_flags &  &SPC2_SID_BQueue))));
    }' unless defined(&INQ_DATA_TQ_ENABLED);
    eval 'sub SID_SftRe () {0x1;}' unless defined(&SID_SftRe);
    eval 'sub SID_CmdQue () {0x2;}' unless defined(&SID_CmdQue);
    eval 'sub SID_Linked () {0x8;}' unless defined(&SID_Linked);
    eval 'sub SID_Sync () {0x10;}' unless defined(&SID_Sync);
    eval 'sub SID_WBus16 () {0x20;}' unless defined(&SID_WBus16);
    eval 'sub SID_WBus32 () {0x40;}' unless defined(&SID_WBus32);
    eval 'sub SID_RelAdr () {0x80;}' unless defined(&SID_RelAdr);
    eval 'sub SID_VENDOR_SIZE () {8;}' unless defined(&SID_VENDOR_SIZE);
    eval 'sub SID_PRODUCT_SIZE () {16;}' unless defined(&SID_PRODUCT_SIZE);
    eval 'sub SID_REVISION_SIZE () {4;}' unless defined(&SID_REVISION_SIZE);
    eval 'sub SID_VENDOR_SPECIFIC_0_SIZE () {20;}' unless defined(&SID_VENDOR_SPECIFIC_0_SIZE);
    eval 'sub SID_SPI_IUS () {0x1;}' unless defined(&SID_SPI_IUS);
    eval 'sub SID_SPI_QAS () {0x2;}' unless defined(&SID_SPI_QAS);
    eval 'sub SID_SPI_CLOCK_ST () {0x;}' unless defined(&SID_SPI_CLOCK_ST);
    eval 'sub SID_SPI_CLOCK_DT () {0x4;}' unless defined(&SID_SPI_CLOCK_DT);
    eval 'sub SID_SPI_CLOCK_DT_ST () {0xc;}' unless defined(&SID_SPI_CLOCK_DT_ST);
    eval 'sub SID_SPI_MASK () {0xf;}' unless defined(&SID_SPI_MASK);
    eval 'sub SID_VENDOR_SPECIFIC_1_SIZE () {160;}' unless defined(&SID_VENDOR_SPECIFIC_1_SIZE);
    eval 'sub SVPD_SUPPORTED_PAGE_LIST () {0x;}' unless defined(&SVPD_SUPPORTED_PAGE_LIST);
    eval 'sub SVPD_SUPPORTED_PAGES_HDR_LEN () {4;}' unless defined(&SVPD_SUPPORTED_PAGES_HDR_LEN);
    eval 'sub SVPD_SUPPORTED_PAGES_SIZE () {251;}' unless defined(&SVPD_SUPPORTED_PAGES_SIZE);
    eval 'sub SVPD_SUPPORTED_PAGES () {0x;}' unless defined(&SVPD_SUPPORTED_PAGES);
    eval 'sub SVPD_UNIT_SERIAL_NUMBER () {0x80;}' unless defined(&SVPD_UNIT_SERIAL_NUMBER);
    eval 'sub SVPD_SERIAL_NUM_SIZE () {251;}' unless defined(&SVPD_SERIAL_NUM_SIZE);
    eval 'sub SVPD_DEVICE_ID () {0x83;}' unless defined(&SVPD_DEVICE_ID);
    eval 'sub SVPD_DEVICE_ID_MAX_SIZE () {252;}' unless defined(&SVPD_DEVICE_ID_MAX_SIZE);
    eval 'sub SVPD_DEVICE_ID_HDR_LEN () { &__offsetof(\'struct scsi_vpd_device_id\',  &desc_list);}' unless defined(&SVPD_DEVICE_ID_HDR_LEN);
    eval 'sub SVPD_ID_PROTO_SHIFT () {4;}' unless defined(&SVPD_ID_PROTO_SHIFT);
    eval 'sub SVPD_ID_CODESET_BINARY () {0x1;}' unless defined(&SVPD_ID_CODESET_BINARY);
    eval 'sub SVPD_ID_CODESET_ASCII () {0x2;}' unless defined(&SVPD_ID_CODESET_ASCII);
    eval 'sub SVPD_ID_CODESET_UTF8 () {0x3;}' unless defined(&SVPD_ID_CODESET_UTF8);
    eval 'sub SVPD_ID_CODESET_MASK () {0xf;}' unless defined(&SVPD_ID_CODESET_MASK);
    eval 'sub SVPD_ID_PIV () {0x80;}' unless defined(&SVPD_ID_PIV);
    eval 'sub SVPD_ID_ASSOC_LUN () {0x;}' unless defined(&SVPD_ID_ASSOC_LUN);
    eval 'sub SVPD_ID_ASSOC_PORT () {0x10;}' unless defined(&SVPD_ID_ASSOC_PORT);
    eval 'sub SVPD_ID_ASSOC_TARGET () {0x20;}' unless defined(&SVPD_ID_ASSOC_TARGET);
    eval 'sub SVPD_ID_ASSOC_MASK () {0x30;}' unless defined(&SVPD_ID_ASSOC_MASK);
    eval 'sub SVPD_ID_TYPE_VENDOR () {0x;}' unless defined(&SVPD_ID_TYPE_VENDOR);
    eval 'sub SVPD_ID_TYPE_T10 () {0x1;}' unless defined(&SVPD_ID_TYPE_T10);
    eval 'sub SVPD_ID_TYPE_EUI64 () {0x2;}' unless defined(&SVPD_ID_TYPE_EUI64);
    eval 'sub SVPD_ID_TYPE_NAA () {0x3;}' unless defined(&SVPD_ID_TYPE_NAA);
    eval 'sub SVPD_ID_TYPE_RELTARG () {0x4;}' unless defined(&SVPD_ID_TYPE_RELTARG);
    eval 'sub SVPD_ID_TYPE_TPORTGRP () {0x5;}' unless defined(&SVPD_ID_TYPE_TPORTGRP);
    eval 'sub SVPD_ID_TYPE_LUNGRP () {0x6;}' unless defined(&SVPD_ID_TYPE_LUNGRP);
    eval 'sub SVPD_ID_TYPE_MD5_LUN_ID () {0x7;}' unless defined(&SVPD_ID_TYPE_MD5_LUN_ID);
    eval 'sub SVPD_ID_TYPE_SCSI_NAME () {0x8;}' unless defined(&SVPD_ID_TYPE_SCSI_NAME);
    eval 'sub SVPD_ID_TYPE_PROTO () {0x9;}' unless defined(&SVPD_ID_TYPE_PROTO);
    eval 'sub SVPD_ID_TYPE_UUID () {0xa;}' unless defined(&SVPD_ID_TYPE_UUID);
    eval 'sub SVPD_ID_TYPE_MASK () {0xf;}' unless defined(&SVPD_ID_TYPE_MASK);
    eval 'sub SVPD_DEVICE_ID_DESC_HDR_LEN () { &__offsetof(\'struct scsi_vpd_id_descriptor\',  &identifier);}' unless defined(&SVPD_DEVICE_ID_DESC_HDR_LEN);
    eval 'sub SVPD_ID_NAA_NAA_SHIFT () {4;}' unless defined(&SVPD_ID_NAA_NAA_SHIFT);
    eval 'sub SVPD_ID_NAA_IEEE_EXT () {0x2;}' unless defined(&SVPD_ID_NAA_IEEE_EXT);
    eval 'sub SVPD_ID_NAA_LOCAL_REG () {0x3;}' unless defined(&SVPD_ID_NAA_LOCAL_REG);
    eval 'sub SVPD_ID_NAA_IEEE_REG () {0x5;}' unless defined(&SVPD_ID_NAA_IEEE_REG);
    eval 'sub SVPD_ID_NAA_IEEE_REG_EXT () {0x6;}' unless defined(&SVPD_ID_NAA_IEEE_REG_EXT);
    eval 'sub SVPD_EXTENDED_INQUIRY_DATA () {0x86;}' unless defined(&SVPD_EXTENDED_INQUIRY_DATA);
    eval 'sub SVPD_EID_AM_MASK () {0xc0;}' unless defined(&SVPD_EID_AM_MASK);
    eval 'sub SVPD_EID_AM_DEFER () {0x80;}' unless defined(&SVPD_EID_AM_DEFER);
    eval 'sub SVPD_EID_AM_IMMED () {0x40;}' unless defined(&SVPD_EID_AM_IMMED);
    eval 'sub SVPD_EID_AM_UNDEFINED () {0x;}' unless defined(&SVPD_EID_AM_UNDEFINED);
    eval 'sub SVPD_EID_AM_RESERVED () {0xc0;}' unless defined(&SVPD_EID_AM_RESERVED);
    eval 'sub SVPD_EID_SPT () {0x38;}' unless defined(&SVPD_EID_SPT);
    eval 'sub SVPD_EID_SPT_1 () {0x;}' unless defined(&SVPD_EID_SPT_1);
    eval 'sub SVPD_EID_SPT_12 () {0x8;}' unless defined(&SVPD_EID_SPT_12);
    eval 'sub SVPD_EID_SPT_2 () {0x10;}' unless defined(&SVPD_EID_SPT_2);
    eval 'sub SVPD_EID_SPT_13 () {0x18;}' unless defined(&SVPD_EID_SPT_13);
    eval 'sub SVPD_EID_SPT_3 () {0x20;}' unless defined(&SVPD_EID_SPT_3);
    eval 'sub SVPD_EID_SPT_23 () {0x28;}' unless defined(&SVPD_EID_SPT_23);
    eval 'sub SVPD_EID_SPT_123 () {0x38;}' unless defined(&SVPD_EID_SPT_123);
    eval 'sub SVPD_EID_SA_SPT_LBP () {0x8;}' unless defined(&SVPD_EID_SA_SPT_LBP);
    eval 'sub SVPD_EID_GRD_CHK () {0x4;}' unless defined(&SVPD_EID_GRD_CHK);
    eval 'sub SVPD_EID_APP_CHK () {0x2;}' unless defined(&SVPD_EID_APP_CHK);
    eval 'sub SVPD_EID_REF_CHK () {0x1;}' unless defined(&SVPD_EID_REF_CHK);
    eval 'sub SVPD_EID_UASK_SUP () {0x20;}' unless defined(&SVPD_EID_UASK_SUP);
    eval 'sub SVPD_EID_GROUP_SUP () {0x10;}' unless defined(&SVPD_EID_GROUP_SUP);
    eval 'sub SVPD_EID_PRIOR_SUP () {0x8;}' unless defined(&SVPD_EID_PRIOR_SUP);
    eval 'sub SVPD_EID_HEADSUP () {0x4;}' unless defined(&SVPD_EID_HEADSUP);
    eval 'sub SVPD_EID_ORDSUP () {0x2;}' unless defined(&SVPD_EID_ORDSUP);
    eval 'sub SVPD_EID_SIMPSUP () {0x1;}' unless defined(&SVPD_EID_SIMPSUP);
    eval 'sub SVPD_EID_WU_SUP () {0x8;}' unless defined(&SVPD_EID_WU_SUP);
    eval 'sub SVPD_EID_CRD_SUP () {0x4;}' unless defined(&SVPD_EID_CRD_SUP);
    eval 'sub SVPD_EID_NV_SUP () {0x2;}' unless defined(&SVPD_EID_NV_SUP);
    eval 'sub SVPD_EID_V_SUP () {0x1;}' unless defined(&SVPD_EID_V_SUP);
    eval 'sub SVPD_EID_NO_PI_CHK () {0x20;}' unless defined(&SVPD_EID_NO_PI_CHK);
    eval 'sub SVPD_EID_P_I_I_SUP () {0x10;}' unless defined(&SVPD_EID_P_I_I_SUP);
    eval 'sub SVPD_EID_LUICLR () {0x1;}' unless defined(&SVPD_EID_LUICLR);
    eval 'sub SVPD_EID_LUCT_MASK () {0xe0;}' unless defined(&SVPD_EID_LUCT_MASK);
    eval 'sub SVPD_EID_LUCT_NOT_REP () {0x;}' unless defined(&SVPD_EID_LUCT_NOT_REP);
    eval 'sub SVPD_EID_LUCT_CONGL () {0x20;}' unless defined(&SVPD_EID_LUCT_CONGL);
    eval 'sub SVPD_EID_LUCT_GROUP () {0x40;}' unless defined(&SVPD_EID_LUCT_GROUP);
    eval 'sub SVPD_EID_R_SUP () {0x10;}' unless defined(&SVPD_EID_R_SUP);
    eval 'sub SVPD_EID_RTD_SUP () {0x8;}' unless defined(&SVPD_EID_RTD_SUP);
    eval 'sub SVPD_EID_HSSRELEF () {0x2;}' unless defined(&SVPD_EID_HSSRELEF);
    eval 'sub SVPD_EID_CBCS () {0x1;}' unless defined(&SVPD_EID_CBCS);
    eval 'sub SVPD_EID_MULTI_I_T_FW () {0xf;}' unless defined(&SVPD_EID_MULTI_I_T_FW);
    eval 'sub SVPD_EID_MC_VENDOR_SPEC () {0x;}' unless defined(&SVPD_EID_MC_VENDOR_SPEC);
    eval 'sub SVPD_EID_MC_MODE_1 () {0x1;}' unless defined(&SVPD_EID_MC_MODE_1);
    eval 'sub SVPD_EID_MC_MODE_2 () {0x2;}' unless defined(&SVPD_EID_MC_MODE_2);
    eval 'sub SVPD_EID_MC_MODE_3 () {0x3;}' unless defined(&SVPD_EID_MC_MODE_3);
    eval 'sub SVPD_EID_POA_SUP () {0x80;}' unless defined(&SVPD_EID_POA_SUP);
    eval 'sub SVPD_EID_HRA_SUP () {0x40;}' unless defined(&SVPD_EID_HRA_SUP);
    eval 'sub SVPD_EID_VSA_SUP () {0x20;}' unless defined(&SVPD_EID_VSA_SUP);
    eval 'sub SVPD_EID_IBS () {0x80;}' unless defined(&SVPD_EID_IBS);
    eval 'sub SVPD_EID_IAS () {0x40;}' unless defined(&SVPD_EID_IAS);
    eval 'sub SVPD_EID_SAC () {0x4;}' unless defined(&SVPD_EID_SAC);
    eval 'sub SVPD_EID_NRD1 () {0x2;}' unless defined(&SVPD_EID_NRD1);
    eval 'sub SVPD_EID_NRD0 () {0x1;}' unless defined(&SVPD_EID_NRD0);
    eval 'sub SVPD_MPP_SHARED () {0x;}' unless defined(&SVPD_MPP_SHARED);
    eval 'sub SVPD_MPP_PORT () {0x1;}' unless defined(&SVPD_MPP_PORT);
    eval 'sub SVPD_MPP_I_T () {0x3;}' unless defined(&SVPD_MPP_I_T);
    eval 'sub SVPD_MPP_MLUS () {0x80;}' unless defined(&SVPD_MPP_MLUS);
    eval 'sub SVPD_MODE_PAGE_POLICY () {0x87;}' unless defined(&SVPD_MODE_PAGE_POLICY);
    eval 'sub SVPD_SCSI_PORTS () {0x88;}' unless defined(&SVPD_SCSI_PORTS);
    eval 'sub SVPD_ATA_INFORMATION () {0x89;}' unless defined(&SVPD_ATA_INFORMATION);
    eval 'sub SVPD_TPC_BDRL () {0x;}' unless defined(&SVPD_TPC_BDRL);
    eval 'sub SVPD_TPC_SC () {0x1;}' unless defined(&SVPD_TPC_SC);
    eval 'sub SVPD_TPC_PD () {0x4;}' unless defined(&SVPD_TPC_PD);
    eval 'sub SVPD_TPC_SD () {0x8;}' unless defined(&SVPD_TPC_SD);
    eval 'sub SVPD_TPC_SDID () {0xc;}' unless defined(&SVPD_TPC_SDID);
    eval 'sub SVPD_TPC_RTF_BLOCK () {0x;}' unless defined(&SVPD_TPC_RTF_BLOCK);
    eval 'sub SVPD_TPC_RTF () {0x106;}' unless defined(&SVPD_TPC_RTF);
    eval 'sub SVPD_TPC_SRTD_TOUT () {0x1;}' unless defined(&SVPD_TPC_SRTD_TOUT);
    eval 'sub SVPD_TPC_SRTD_TIN () {0x2;}' unless defined(&SVPD_TPC_SRTD_TIN);
    eval 'sub SVPD_TPC_SRTD_ECPY () {0x80;}' unless defined(&SVPD_TPC_SRTD_ECPY);
    eval 'sub SVPD_TPC_SRT () {0x108;}' unless defined(&SVPD_TPC_SRT);
    eval 'sub SVPD_TPC_GCO () {0x8001;}' unless defined(&SVPD_TPC_GCO);
    eval 'sub SVPD_SCSI_TPC () {0x8f;}' unless defined(&SVPD_SCSI_TPC);
    eval 'sub SVPD_BDC () {0xb1;}' unless defined(&SVPD_BDC);
    eval 'sub SVPD_BDC_RATE_NOT_REPORTED () {0x;}' unless defined(&SVPD_BDC_RATE_NOT_REPORTED);
    eval 'sub SVPD_BDC_RATE_NON_ROTATING () {0x1;}' unless defined(&SVPD_BDC_RATE_NON_ROTATING);
    eval 'sub SVPD_BDC_FORM_NOT_REPORTED () {0x;}' unless defined(&SVPD_BDC_FORM_NOT_REPORTED);
    eval 'sub SVPD_BDC_FORM_5_25INCH () {0x1;}' unless defined(&SVPD_BDC_FORM_5_25INCH);
    eval 'sub SVPD_BDC_FORM_3_5INCH () {0x2;}' unless defined(&SVPD_BDC_FORM_3_5INCH);
    eval 'sub SVPD_BDC_FORM_2_5INCH () {0x3;}' unless defined(&SVPD_BDC_FORM_2_5INCH);
    eval 'sub SVPD_BDC_FORM_1_5INCH () {0x4;}' unless defined(&SVPD_BDC_FORM_1_5INCH);
    eval 'sub SVPD_BDC_FORM_LESSTHAN_1_5INCH () {0x5;}' unless defined(&SVPD_BDC_FORM_LESSTHAN_1_5INCH);
    eval 'sub SVPD_BDC () {0xb1;}' unless defined(&SVPD_BDC);
    eval 'sub SVPD_NOT_REPORTED () {0x;}' unless defined(&SVPD_NOT_REPORTED);
    eval 'sub SVPD_NON_ROTATING () {0x1;}' unless defined(&SVPD_NON_ROTATING);
    eval 'sub SVPD_VBULS () {0x1;}' unless defined(&SVPD_VBULS);
    eval 'sub SVPD_FUAB () {0x2;}' unless defined(&SVPD_FUAB);
    eval 'sub SVPD_ZBC_NR () {0x;}' unless defined(&SVPD_ZBC_NR);
    eval 'sub SVPD_HAW_ZBC () {0x10;}' unless defined(&SVPD_HAW_ZBC);
    eval 'sub SVPD_DM_ZBC () {0x20;}' unless defined(&SVPD_DM_ZBC);
    eval 'sub SVPD_ZBC_MASK () {0x30;}' unless defined(&SVPD_ZBC_MASK);
    eval 'sub SBDC_IS_PRESENT {
        my($bdc, $length, $field) = @_;
	    eval q((($length >=  &offsetof(\'struct scsi_vpd_block_device_characteristics\', $field) + $sizeof{ ($bdc->{field})}) ? 1: 0));
    }' unless defined(&SBDC_IS_PRESENT);
    eval 'sub SVPD_LBP () {0xb2;}' unless defined(&SVPD_LBP);
    eval 'sub SVPD_LBP_PL_BASIC () {0x4;}' unless defined(&SVPD_LBP_PL_BASIC);
    eval 'sub SVPD_LBP_UNMAP () {0x80;}' unless defined(&SVPD_LBP_UNMAP);
    eval 'sub SVPD_LBP_WS16 () {0x40;}' unless defined(&SVPD_LBP_WS16);
    eval 'sub SVPD_LBP_WS10 () {0x20;}' unless defined(&SVPD_LBP_WS10);
    eval 'sub SVPD_LBP_RZ () {0x4;}' unless defined(&SVPD_LBP_RZ);
    eval 'sub SVPD_LBP_ANC_SUP () {0x2;}' unless defined(&SVPD_LBP_ANC_SUP);
    eval 'sub SVPD_LBP_DP () {0x1;}' unless defined(&SVPD_LBP_DP);
    eval 'sub SVPD_LBP_RESOURCE () {0x1;}' unless defined(&SVPD_LBP_RESOURCE);
    eval 'sub SVPD_LBP_THIN () {0x2;}' unless defined(&SVPD_LBP_THIN);
    eval 'sub SVPD_BLOCK_LIMITS () {0xb0;}' unless defined(&SVPD_BLOCK_LIMITS);
    eval 'sub SVPD_BL_PL_BASIC () {0x10;}' unless defined(&SVPD_BL_PL_BASIC);
    eval 'sub SVPD_BL_PL_TP () {0x3c;}' unless defined(&SVPD_BL_PL_TP);
    eval 'sub SVPD_ZONED_BDC () {0xb6;}' unless defined(&SVPD_ZONED_BDC);
    eval 'sub SVPD_ZBDC_PL () {0x3c;}' unless defined(&SVPD_ZBDC_PL);
    eval 'sub SVPD_ZBDC_URSWRZ () {0x1;}' unless defined(&SVPD_ZBDC_URSWRZ);
    eval 'sub SVPD_ZBDC_OPT_SEQ_NR () {0xffffffff;}' unless defined(&SVPD_ZBDC_OPT_SEQ_NR);
    eval 'sub SVPD_ZBDC_OPT_NONSEQ_NR () {0xffffffff;}' unless defined(&SVPD_ZBDC_OPT_NONSEQ_NR);
    eval 'sub SVPD_ZBDC_MAX_SEQ_UNLIMITED () {0xffffffff;}' unless defined(&SVPD_ZBDC_MAX_SEQ_UNLIMITED);
    eval 'sub SRC_RELADR () {0x1;}' unless defined(&SRC_RELADR);
    eval 'sub SRC_PMI () {0x1;}' unless defined(&SRC_PMI);
    eval 'sub SRC16_SERVICE_ACTION () {0x10;}' unless defined(&SRC16_SERVICE_ACTION);
    eval 'sub SRC16_PMI () {0x1;}' unless defined(&SRC16_PMI);
    eval 'sub SRC16_RELADR () {0x2;}' unless defined(&SRC16_RELADR);
    eval 'sub SRC16_PROT_EN () {0x1;}' unless defined(&SRC16_PROT_EN);
    eval 'sub SRC16_P_TYPE () {0xe;}' unless defined(&SRC16_P_TYPE);
    eval 'sub SRC16_PTYPE_1 () {0x;}' unless defined(&SRC16_PTYPE_1);
    eval 'sub SRC16_PTYPE_2 () {0x2;}' unless defined(&SRC16_PTYPE_2);
    eval 'sub SRC16_PTYPE_3 () {0x4;}' unless defined(&SRC16_PTYPE_3);
    eval 'sub SRC16_LBPPBE () {0xf;}' unless defined(&SRC16_LBPPBE);
    eval 'sub SRC16_PI_EXPONENT () {0xf0;}' unless defined(&SRC16_PI_EXPONENT);
    eval 'sub SRC16_PI_EXPONENT_SHIFT () {4;}' unless defined(&SRC16_PI_EXPONENT_SHIFT);
    eval 'sub SRC16_LALBA () {0x3f;}' unless defined(&SRC16_LALBA);
    eval 'sub SRC16_LBPRZ () {0x40;}' unless defined(&SRC16_LBPRZ);
    eval 'sub SRC16_LBPME () {0x80;}' unless defined(&SRC16_LBPME);
    eval 'sub SRC16_LALBA_A () {0x3fff;}' unless defined(&SRC16_LALBA_A);
    eval 'sub SRC16_LBPRZ_A () {0x4000;}' unless defined(&SRC16_LBPRZ_A);
    eval 'sub SRC16_LBPME_A () {0x8000;}' unless defined(&SRC16_LBPME_A);
    eval 'sub SGLS_SERVICE_ACTION () {0x12;}' unless defined(&SGLS_SERVICE_ACTION);
    eval 'sub RPL_REPORT_DEFAULT () {0x;}' unless defined(&RPL_REPORT_DEFAULT);
    eval 'sub RPL_REPORT_WELLKNOWN () {0x1;}' unless defined(&RPL_REPORT_WELLKNOWN);
    eval 'sub RPL_REPORT_ALL () {0x2;}' unless defined(&RPL_REPORT_ALL);
    eval 'sub RPL_REPORT_ADMIN () {0x10;}' unless defined(&RPL_REPORT_ADMIN);
    eval 'sub RPL_REPORT_NONSUBSID () {0x11;}' unless defined(&RPL_REPORT_NONSUBSID);
    eval 'sub RPL_REPORT_CONGLOM () {0x12;}' unless defined(&RPL_REPORT_CONGLOM);
    eval 'sub RPL_LUNDATA_PERIPH_BUS_MASK () {0x3f;}' unless defined(&RPL_LUNDATA_PERIPH_BUS_MASK);
    eval 'sub RPL_LUNDATA_FLAT_LUN_MASK () {0x3f;}' unless defined(&RPL_LUNDATA_FLAT_LUN_MASK);
    eval 'sub RPL_LUNDATA_FLAT_LUN_BITS () {0x6;}' unless defined(&RPL_LUNDATA_FLAT_LUN_BITS);
    eval 'sub RPL_LUNDATA_LUN_TARG_MASK () {0x3f;}' unless defined(&RPL_LUNDATA_LUN_TARG_MASK);
    eval 'sub RPL_LUNDATA_LUN_BUS_MASK () {0xe0;}' unless defined(&RPL_LUNDATA_LUN_BUS_MASK);
    eval 'sub RPL_LUNDATA_LUN_LUN_MASK () {0x1f;}' unless defined(&RPL_LUNDATA_LUN_LUN_MASK);
    eval 'sub RPL_LUNDATA_EXT_LEN_MASK () {0x30;}' unless defined(&RPL_LUNDATA_EXT_LEN_MASK);
    eval 'sub RPL_LUNDATA_EXT_EAM_MASK () {0xf;}' unless defined(&RPL_LUNDATA_EXT_EAM_MASK);
    eval 'sub RPL_LUNDATA_EXT_EAM_WK () {0x1;}' unless defined(&RPL_LUNDATA_EXT_EAM_WK);
    eval 'sub RPL_LUNDATA_EXT_EAM_NOT_SPEC () {0xf;}' unless defined(&RPL_LUNDATA_EXT_EAM_NOT_SPEC);
    eval 'sub RPL_LUNDATA_ATYP_MASK () {0xc0;}' unless defined(&RPL_LUNDATA_ATYP_MASK);
    eval 'sub RPL_LUNDATA_ATYP_PERIPH () {0x;}' unless defined(&RPL_LUNDATA_ATYP_PERIPH);
    eval 'sub RPL_LUNDATA_ATYP_FLAT () {0x40;}' unless defined(&RPL_LUNDATA_ATYP_FLAT);
    eval 'sub RPL_LUNDATA_ATYP_LUN () {0x80;}' unless defined(&RPL_LUNDATA_ATYP_LUN);
    eval 'sub RPL_LUNDATA_ATYP_EXTLUN () {0xc0;}' unless defined(&RPL_LUNDATA_ATYP_EXTLUN);
    eval 'sub STG_PDF_MASK () {0xe0;}' unless defined(&STG_PDF_MASK);
    eval 'sub STG_PDF_LENGTH () {0x;}' unless defined(&STG_PDF_LENGTH);
    eval 'sub STG_PDF_EXTENDED () {0x20;}' unless defined(&STG_PDF_EXTENDED);
    eval 'sub TPG_PRIMARY () {0x80;}' unless defined(&TPG_PRIMARY);
    eval 'sub TPG_ASYMMETRIC_ACCESS_STATE_MASK () {0xf;}' unless defined(&TPG_ASYMMETRIC_ACCESS_STATE_MASK);
    eval 'sub TPG_ASYMMETRIC_ACCESS_OPTIMIZED () {0x;}' unless defined(&TPG_ASYMMETRIC_ACCESS_OPTIMIZED);
    eval 'sub TPG_ASYMMETRIC_ACCESS_NONOPTIMIZED () {0x1;}' unless defined(&TPG_ASYMMETRIC_ACCESS_NONOPTIMIZED);
    eval 'sub TPG_ASYMMETRIC_ACCESS_STANDBY () {0x2;}' unless defined(&TPG_ASYMMETRIC_ACCESS_STANDBY);
    eval 'sub TPG_ASYMMETRIC_ACCESS_UNAVAILABLE () {0x3;}' unless defined(&TPG_ASYMMETRIC_ACCESS_UNAVAILABLE);
    eval 'sub TPG_ASYMMETRIC_ACCESS_LBA_DEPENDENT () {0x4;}' unless defined(&TPG_ASYMMETRIC_ACCESS_LBA_DEPENDENT);
    eval 'sub TPG_ASYMMETRIC_ACCESS_OFFLINE () {0xe;}' unless defined(&TPG_ASYMMETRIC_ACCESS_OFFLINE);
    eval 'sub TPG_ASYMMETRIC_ACCESS_TRANSITIONING () {0xf;}' unless defined(&TPG_ASYMMETRIC_ACCESS_TRANSITIONING);
    eval 'sub TPG_AO_SUP () {0x1;}' unless defined(&TPG_AO_SUP);
    eval 'sub TPG_AN_SUP () {0x2;}' unless defined(&TPG_AN_SUP);
    eval 'sub TPG_S_SUP () {0x4;}' unless defined(&TPG_S_SUP);
    eval 'sub TPG_U_SUP () {0x8;}' unless defined(&TPG_U_SUP);
    eval 'sub TPG_LBD_SUP () {0x10;}' unless defined(&TPG_LBD_SUP);
    eval 'sub TPG_O_SUP () {0x40;}' unless defined(&TPG_O_SUP);
    eval 'sub TPG_T_SUP () {0x80;}' unless defined(&TPG_T_SUP);
    eval 'sub TPG_UNAVLBL () {0;}' unless defined(&TPG_UNAVLBL);
    eval 'sub TPG_SET_BY_STPG () {0x1;}' unless defined(&TPG_SET_BY_STPG);
    eval 'sub TPG_IMPLICIT () {0x2;}' unless defined(&TPG_IMPLICIT);
    eval 'sub SPI_PROT_INFORMATION () {0x;}' unless defined(&SPI_PROT_INFORMATION);
    eval 'sub SPI_PROT_CBCS () {0x7;}' unless defined(&SPI_PROT_CBCS);
    eval 'sub SPI_PROT_TAPE_DATA_ENC () {0x20;}' unless defined(&SPI_PROT_TAPE_DATA_ENC);
    eval 'sub SPI_PROT_DATA_ENC_CONFIG () {0x21;}' unless defined(&SPI_PROT_DATA_ENC_CONFIG);
    eval 'sub SPI_PROT_SA_CREATE_CAP () {0x40;}' unless defined(&SPI_PROT_SA_CREATE_CAP);
    eval 'sub SPI_PROT_IKEV2_SCSI () {0x41;}' unless defined(&SPI_PROT_IKEV2_SCSI);
    eval 'sub SPI_PROT_JEDEC_UFS () {0xec;}' unless defined(&SPI_PROT_JEDEC_UFS);
    eval 'sub SPI_PROT_SDCARD_TFSSS () {0xed;}' unless defined(&SPI_PROT_SDCARD_TFSSS);
    eval 'sub SPI_PROT_AUTH_HOST_TRANSIENT () {0xee;}' unless defined(&SPI_PROT_AUTH_HOST_TRANSIENT);
    eval 'sub SPI_PROT_ATA_DEVICE_PASSWORD () {0xef;}' unless defined(&SPI_PROT_ATA_DEVICE_PASSWORD);
    eval 'sub SPI_INC_512 () {0x80;}' unless defined(&SPI_INC_512);
    eval 'sub SPO_INC_512 () {0x80;}' unless defined(&SPO_INC_512);
    eval("sub SSD_TYPE_NONE () { 0; }") unless defined(&SSD_TYPE_NONE);
    eval("sub SSD_TYPE_FIXED () { 1; }") unless defined(&SSD_TYPE_FIXED);
    eval("sub SSD_TYPE_DESC () { 2; }") unless defined(&SSD_TYPE_DESC);
    eval("sub SSD_ELEM_NONE () { 0; }") unless defined(&SSD_ELEM_NONE);
    eval("sub SSD_ELEM_SKIP () { 1; }") unless defined(&SSD_ELEM_SKIP);
    eval("sub SSD_ELEM_DESC () { 2; }") unless defined(&SSD_ELEM_DESC);
    eval("sub SSD_ELEM_SKS () { 3; }") unless defined(&SSD_ELEM_SKS);
    eval("sub SSD_ELEM_COMMAND () { 4; }") unless defined(&SSD_ELEM_COMMAND);
    eval("sub SSD_ELEM_INFO () { 5; }") unless defined(&SSD_ELEM_INFO);
    eval("sub SSD_ELEM_FRU () { 6; }") unless defined(&SSD_ELEM_FRU);
    eval("sub SSD_ELEM_STREAM () { 7; }") unless defined(&SSD_ELEM_STREAM);
    eval("sub SSD_ELEM_MAX () { 8; }") unless defined(&SSD_ELEM_MAX);
    eval 'sub SSD_FULL_SIZE () {252;}' unless defined(&SSD_FULL_SIZE);
    eval 'sub SSD_MIN_SIZE () {18;}' unless defined(&SSD_MIN_SIZE);
    eval 'sub SSD_EXTRA_MAX () {244;}' unless defined(&SSD_EXTRA_MAX);
    eval 'sub SSD_ERRCODE () {0x7f;}' unless defined(&SSD_ERRCODE);
    eval 'sub SSD_CURRENT_ERROR () {0x70;}' unless defined(&SSD_CURRENT_ERROR);
    eval 'sub SSD_DEFERRED_ERROR () {0x71;}' unless defined(&SSD_DEFERRED_ERROR);
    eval 'sub SSD_ERRCODE_VALID () {0x80;}' unless defined(&SSD_ERRCODE_VALID);
    eval 'sub SSD_KEY () {0xf;}' unless defined(&SSD_KEY);
    eval 'sub SSD_KEY_NO_SENSE () {0x;}' unless defined(&SSD_KEY_NO_SENSE);
    eval 'sub SSD_KEY_RECOVERED_ERROR () {0x1;}' unless defined(&SSD_KEY_RECOVERED_ERROR);
    eval 'sub SSD_KEY_NOT_READY () {0x2;}' unless defined(&SSD_KEY_NOT_READY);
    eval 'sub SSD_KEY_MEDIUM_ERROR () {0x3;}' unless defined(&SSD_KEY_MEDIUM_ERROR);
    eval 'sub SSD_KEY_HARDWARE_ERROR () {0x4;}' unless defined(&SSD_KEY_HARDWARE_ERROR);
    eval 'sub SSD_KEY_ILLEGAL_REQUEST () {0x5;}' unless defined(&SSD_KEY_ILLEGAL_REQUEST);
    eval 'sub SSD_KEY_UNIT_ATTENTION () {0x6;}' unless defined(&SSD_KEY_UNIT_ATTENTION);
    eval 'sub SSD_KEY_DATA_PROTECT () {0x7;}' unless defined(&SSD_KEY_DATA_PROTECT);
    eval 'sub SSD_KEY_BLANK_CHECK () {0x8;}' unless defined(&SSD_KEY_BLANK_CHECK);
    eval 'sub SSD_KEY_Vendor_Specific () {0x9;}' unless defined(&SSD_KEY_Vendor_Specific);
    eval 'sub SSD_KEY_COPY_ABORTED () {0xa;}' unless defined(&SSD_KEY_COPY_ABORTED);
    eval 'sub SSD_KEY_ABORTED_COMMAND () {0xb;}' unless defined(&SSD_KEY_ABORTED_COMMAND);
    eval 'sub SSD_KEY_EQUAL () {0xc;}' unless defined(&SSD_KEY_EQUAL);
    eval 'sub SSD_KEY_VOLUME_OVERFLOW () {0xd;}' unless defined(&SSD_KEY_VOLUME_OVERFLOW);
    eval 'sub SSD_KEY_MISCOMPARE () {0xe;}' unless defined(&SSD_KEY_MISCOMPARE);
    eval 'sub SSD_KEY_COMPLETED () {0xf;}' unless defined(&SSD_KEY_COMPLETED);
    eval 'sub SSD_SDAT_OVFL () {0x10;}' unless defined(&SSD_SDAT_OVFL);
    eval 'sub SSD_ILI () {0x20;}' unless defined(&SSD_ILI);
    eval 'sub SSD_EOM () {0x40;}' unless defined(&SSD_EOM);
    eval 'sub SSD_FILEMARK () {0x80;}' unless defined(&SSD_FILEMARK);
    eval 'sub SSD_SCS_VALID () {0x80;}' unless defined(&SSD_SCS_VALID);
    eval 'sub SSD_FIELDPTR_CMD () {0x40;}' unless defined(&SSD_FIELDPTR_CMD);
    eval 'sub SSD_BITPTR_VALID () {0x8;}' unless defined(&SSD_BITPTR_VALID);
    eval 'sub SSD_BITPTR_VALUE () {0x7;}' unless defined(&SSD_BITPTR_VALUE);
    eval 'sub SSD_FIXED_IS_PRESENT {
        my($sense, $length, $field) = @_;
	    eval q((($length >= ( &offsetof(\'struct scsi_sense_data_fixed\', $field) + $sizeof{ ($sense->{field})})) ? 1:0));
    }' unless defined(&SSD_FIXED_IS_PRESENT);
    eval 'sub SSD_FIXED_IS_FILLED {
        my($sense, $field) = @_;
	    eval q((((( &offsetof(\'struct scsi_sense_data_fixed\', $field) + $sizeof{ ($sense->{field})}) - ( &offsetof(\'struct scsi_sense_data_fixed\',  &extra_len) + $sizeof{ ($sense->{extra_len})})) <=  ($sense->{extra_len})) ? 1: 0));
    }' unless defined(&SSD_FIXED_IS_FILLED);
    eval 'sub SSD_DESC_CURRENT_ERROR () {0x72;}' unless defined(&SSD_DESC_CURRENT_ERROR);
    eval 'sub SSD_DESC_DEFERRED_ERROR () {0x73;}' unless defined(&SSD_DESC_DEFERRED_ERROR);
    eval 'sub SSDD_SDAT_OVFL () {0x80;}' unless defined(&SSDD_SDAT_OVFL);
    eval 'sub SSD_DESC_IS_PRESENT {
        my($sense, $length, $field) = @_;
	    eval q((($length >= ( &offsetof(\'struct scsi_sense_data_desc\', $field) + $sizeof{ ($sense->{field})})) ? 1:0));
    }' unless defined(&SSD_DESC_IS_PRESENT);
    eval 'sub SSD_DESC_INFO () {0x;}' unless defined(&SSD_DESC_INFO);
    eval 'sub SSD_INFO_VALID () {0x80;}' unless defined(&SSD_INFO_VALID);
    eval 'sub SSD_DESC_COMMAND () {0x1;}' unless defined(&SSD_DESC_COMMAND);
    eval 'sub SSD_DESC_SKS () {0x2;}' unless defined(&SSD_DESC_SKS);
    eval 'sub SSD_SKS_VALID () {0x80;}' unless defined(&SSD_SKS_VALID);
    eval 'sub SSD_SKS_FIELD_VALID () {0x80;}' unless defined(&SSD_SKS_FIELD_VALID);
    eval 'sub SSD_SKS_FIELD_CMD () {0x40;}' unless defined(&SSD_SKS_FIELD_CMD);
    eval 'sub SSD_SKS_BPV () {0x8;}' unless defined(&SSD_SKS_BPV);
    eval 'sub SSD_SKS_BIT_VALUE () {0x7;}' unless defined(&SSD_SKS_BIT_VALUE);
    eval 'sub SSD_SKS_RETRY_VALID () {0x80;}' unless defined(&SSD_SKS_RETRY_VALID);
    eval 'sub SSD_SKS_PROGRESS_VALID () {0x80;}' unless defined(&SSD_SKS_PROGRESS_VALID);
    eval 'sub SSD_SKS_PROGRESS_DENOM () {0x10000;}' unless defined(&SSD_SKS_PROGRESS_DENOM);
    eval 'sub SSD_SKS_SEGMENT_VALID () {0x80;}' unless defined(&SSD_SKS_SEGMENT_VALID);
    eval 'sub SSD_SKS_SEGMENT_SD () {0x20;}' unless defined(&SSD_SKS_SEGMENT_SD);
    eval 'sub SSD_SKS_SEGMENT_BPV () {0x8;}' unless defined(&SSD_SKS_SEGMENT_BPV);
    eval 'sub SSD_SKS_SEGMENT_BITPTR () {0x7;}' unless defined(&SSD_SKS_SEGMENT_BITPTR);
    eval 'sub SSD_SKS_OVERFLOW_VALID () {0x80;}' unless defined(&SSD_SKS_OVERFLOW_VALID);
    eval 'sub SSD_SKS_OVERFLOW_SET () {0x1;}' unless defined(&SSD_SKS_OVERFLOW_SET);
    eval 'sub SSD_DESC_FRU () {0x3;}' unless defined(&SSD_DESC_FRU);
    eval 'sub SSD_DESC_STREAM () {0x4;}' unless defined(&SSD_DESC_STREAM);
    eval 'sub SSD_DESC_STREAM_FM () {0x80;}' unless defined(&SSD_DESC_STREAM_FM);
    eval 'sub SSD_DESC_STREAM_EOM () {0x40;}' unless defined(&SSD_DESC_STREAM_EOM);
    eval 'sub SSD_DESC_STREAM_ILI () {0x20;}' unless defined(&SSD_DESC_STREAM_ILI);
    eval 'sub SSD_DESC_BLOCK () {0x5;}' unless defined(&SSD_DESC_BLOCK);
    eval 'sub SSD_DESC_BLOCK_ILI () {0x20;}' unless defined(&SSD_DESC_BLOCK_ILI);
    eval 'sub SSD_DESC_OSD_OBJID () {0x6;}' unless defined(&SSD_DESC_OSD_OBJID);
    eval 'sub SSD_DESC_OSD_INTEGRITY () {0x7;}' unless defined(&SSD_DESC_OSD_INTEGRITY);
    eval 'sub SSD_DESC_OSD_ATTR_ID () {0x8;}' unless defined(&SSD_DESC_OSD_ATTR_ID);
    eval 'sub SSD_DESC_ATA () {0x9;}' unless defined(&SSD_DESC_ATA);
    eval 'sub SSD_DESC_ATA_FLAG_EXTEND () {0x1;}' unless defined(&SSD_DESC_ATA_FLAG_EXTEND);
    eval 'sub SSD_DESC_PROGRESS () {0xa;}' unless defined(&SSD_DESC_PROGRESS);
    eval 'sub SSD_DESC_FORWARDED () {0xc;}' unless defined(&SSD_DESC_FORWARDED);
    eval 'sub SSD_FORWARDED_FSDT () {0x80;}' unless defined(&SSD_FORWARDED_FSDT);
    eval 'sub SSD_FORWARDED_SDS_MASK () {0xf;}' unless defined(&SSD_FORWARDED_SDS_MASK);
    eval 'sub SSD_FORWARDED_SDS_UNK () {0x;}' unless defined(&SSD_FORWARDED_SDS_UNK);
    eval 'sub SSD_FORWARDED_SDS_EXSRC () {0x1;}' unless defined(&SSD_FORWARDED_SDS_EXSRC);
    eval 'sub SSD_FORWARDED_SDS_EXDST () {0x2;}' unless defined(&SSD_FORWARDED_SDS_EXDST);
    eval 'sub SSD_DESC_VENDOR_MIN () {0x80;}' unless defined(&SSD_DESC_VENDOR_MIN);
    eval 'sub SSD_DESC_VENDOR_MAX () {0xff;}' unless defined(&SSD_DESC_VENDOR_MAX);
    eval 'sub SMPH_PS () {0x80;}' unless defined(&SMPH_PS);
    eval 'sub SMPH_SPF () {0x40;}' unless defined(&SMPH_SPF);
    eval 'sub SMPH_PC_MASK () {0x3f;}' unless defined(&SMPH_PC_MASK);
    eval 'sub SCSI_DEFAULT_DENSITY () {0x;}' unless defined(&SCSI_DEFAULT_DENSITY);
    eval 'sub SCSI_SAME_DENSITY () {0x7f;}' unless defined(&SCSI_SAME_DENSITY);
    eval 'sub SCSI_STATUS_OK () {0x;}' unless defined(&SCSI_STATUS_OK);
    eval 'sub SCSI_STATUS_CHECK_COND () {0x2;}' unless defined(&SCSI_STATUS_CHECK_COND);
    eval 'sub SCSI_STATUS_COND_MET () {0x4;}' unless defined(&SCSI_STATUS_COND_MET);
    eval 'sub SCSI_STATUS_BUSY () {0x8;}' unless defined(&SCSI_STATUS_BUSY);
    eval 'sub SCSI_STATUS_INTERMED () {0x10;}' unless defined(&SCSI_STATUS_INTERMED);
    eval 'sub SCSI_STATUS_INTERMED_COND_MET () {0x14;}' unless defined(&SCSI_STATUS_INTERMED_COND_MET);
    eval 'sub SCSI_STATUS_RESERV_CONFLICT () {0x18;}' unless defined(&SCSI_STATUS_RESERV_CONFLICT);
    eval 'sub SCSI_STATUS_CMD_TERMINATED () {0x22;}' unless defined(&SCSI_STATUS_CMD_TERMINATED);
    eval 'sub SCSI_STATUS_QUEUE_FULL () {0x28;}' unless defined(&SCSI_STATUS_QUEUE_FULL);
    eval 'sub SCSI_STATUS_ACA_ACTIVE () {0x30;}' unless defined(&SCSI_STATUS_ACA_ACTIVE);
    eval 'sub SCSI_STATUS_TASK_ABORTED () {0x40;}' unless defined(&SCSI_STATUS_TASK_ABORTED);
    eval 'sub SIP_MEDIA_REMOVABLE () {0x1;}' unless defined(&SIP_MEDIA_REMOVABLE);
    eval 'sub SIP_MEDIA_FIXED () {0x2;}' unless defined(&SIP_MEDIA_FIXED);
    eval("sub SSS_FLAG_NONE () { 0x00; }") unless defined(&SSS_FLAG_NONE);
    eval("sub SSS_FLAG_PRINT_COMMAND () { 0x01; }") unless defined(&SSS_FLAG_PRINT_COMMAND);
    eval("sub SCSI_NV_FOUND () { 0; }") unless defined(&SCSI_NV_FOUND);
    eval("sub SCSI_NV_AMBIGUOUS () { 1; }") unless defined(&SCSI_NV_AMBIGUOUS);
    eval("sub SCSI_NV_NOT_FOUND () { 2; }") unless defined(&SCSI_NV_NOT_FOUND);
    eval("sub SCSI_NV_FLAG_NONE () { 0x00; }") unless defined(&SCSI_NV_FLAG_NONE);
    eval("sub SCSI_NV_FLAG_IG_CASE () { 0x01; }") unless defined(&SCSI_NV_FLAG_IG_CASE);
    unless(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    } else {
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
    if(defined(&_KERNEL)) {
    }
    eval 'sub SCSI_RW_READ () {0x1;}' unless defined(&SCSI_RW_READ);
    eval 'sub SCSI_RW_WRITE () {0x2;}' unless defined(&SCSI_RW_WRITE);
    eval 'sub SCSI_RW_DIRMASK () {0x3;}' unless defined(&SCSI_RW_DIRMASK);
    eval 'sub SCSI_RW_BIO () {0x1000;}' unless defined(&SCSI_RW_BIO);
    eval 'sub scsi_ulto2b {
        my($val,$bytes) = @_;
	    eval q({ $bytes->[0] = ($val >> 8) & 0xff; $bytes->[1] = $val & 0xff; });
    }' unless defined(&scsi_ulto2b);
    eval 'sub scsi_ulto3b {
        my($val,$bytes) = @_;
	    eval q({ $bytes->[0] = ($val >> 16) & 0xff; $bytes->[1] = ($val >> 8) & 0xff; $bytes->[2] = $val & 0xff; });
    }' unless defined(&scsi_ulto3b);
    eval 'sub scsi_ulto4b {
        my($val,$bytes) = @_;
	    eval q({ $bytes->[0] = ($val >> 24) & 0xff; $bytes->[1] = ($val >> 16) & 0xff; $bytes->[2] = ($val >> 8) & 0xff; $bytes->[3] = $val & 0xff; });
    }' unless defined(&scsi_ulto4b);
    eval 'sub scsi_u64to8b {
        my($val,$bytes) = @_;
	    eval q({ $bytes->[0] = ($val >> 56) & 0xff; $bytes->[1] = ($val >> 48) & 0xff; $bytes->[2] = ($val >> 40) & 0xff; $bytes->[3] = ($val >> 32) & 0xff; $bytes->[4] = ($val >> 24) & 0xff; $bytes->[5] = ($val >> 16) & 0xff; $bytes->[6] = ($val >> 8) & 0xff; $bytes->[7] = $val & 0xff; });
    }' unless defined(&scsi_u64to8b);
    eval 'sub scsi_2btoul {
        my($bytes) = @_;
	    eval q({  &uint32_t  &rv;  &rv = ($bytes->[0] << 8) | $bytes->[1]; ( &rv); });
    }' unless defined(&scsi_2btoul);
    eval 'sub scsi_3btoul {
        my($bytes) = @_;
	    eval q({  &uint32_t  &rv;  &rv = ($bytes->[0] << 16) | ($bytes->[1] << 8) | $bytes->[2]; ( &rv); });
    }' unless defined(&scsi_3btoul);
    eval 'sub scsi_3btol {
        my($bytes) = @_;
	    eval q({  &uint32_t  &rc =  &scsi_3btoul($bytes);  &if ( &rc & 0x800000)  &rc |= 0xff000000; ( &int32_t)  &rc; });
    }' unless defined(&scsi_3btol);
    eval 'sub scsi_4btoul {
        my($bytes) = @_;
	    eval q({  &uint32_t  &rv;  &rv = ($bytes->[0] << 24) | ($bytes->[1] << 16) | ($bytes->[2] << 8) | $bytes->[3]; ( &rv); });
    }' unless defined(&scsi_4btoul);
    eval 'sub scsi_8btou64 {
        my($bytes) = @_;
	    eval q({  &uint64_t  &rv;  &rv = ((( &uint64_t)$bytes->[0]) << 56) | ((( &uint64_t)$bytes->[1]) << 48) | ((( &uint64_t)$bytes->[2]) << 40) | ((( &uint64_t)$bytes->[3]) << 32) | ((( &uint64_t)$bytes->[4]) << 24) | ((( &uint64_t)$bytes->[5]) << 16) | ((( &uint64_t)$bytes->[6]) << 8) | $bytes->[7]; ( &rv); });
    }' unless defined(&scsi_8btou64);
    eval 'sub find_mode_page_10 {
        my($mode_header) = @_;
	    eval q({  &void * &page_start;  &page_start = ( &void *)(( &u_int8_t *)$mode_header->[1] +  &scsi_2btoul( ($mode_header->{blk_desc_len}))); ( &page_start); });
    }' unless defined(&find_mode_page_10);
}
1;
