require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SCSI_SCSI_DA_H)) {
    eval 'sub _SCSI_SCSI_DA_H () {1;}' unless defined(&_SCSI_SCSI_DA_H);
    require 'sys/cdefs.ph';
    eval 'sub SRZU_LUN_MASK () {0xe0;}' unless defined(&SRZU_LUN_MASK);
    eval 'sub FU_FORMAT_MASK () { &SRDD10_DLIST_FORMAT_MASK;}' unless defined(&FU_FORMAT_MASK);
    eval 'sub FU_BLOCK_FORMAT () { &SRDD10_BLOCK_FORMAT;}' unless defined(&FU_BLOCK_FORMAT);
    eval 'sub FU_BFI_FORMAT () { &SRDD10_BYTES_FROM_INDEX_FORMAT;}' unless defined(&FU_BFI_FORMAT);
    eval 'sub FU_PHYS_FORMAT () { &SRDD10_PHYSICAL_SECTOR_FORMAT;}' unless defined(&FU_PHYS_FORMAT);
    eval 'sub FU_CMPLST () {0x8;}' unless defined(&FU_CMPLST);
    eval 'sub FU_FMT_DATA () {0x10;}' unless defined(&FU_FMT_DATA);
    eval 'sub SRDD10_GLIST () {0x8;}' unless defined(&SRDD10_GLIST);
    eval 'sub SRDD10_PLIST () {0x10;}' unless defined(&SRDD10_PLIST);
    eval 'sub SRDD10_DLIST_FORMAT_MASK () {0x7;}' unless defined(&SRDD10_DLIST_FORMAT_MASK);
    eval 'sub SRDD10_BLOCK_FORMAT () {0x;}' unless defined(&SRDD10_BLOCK_FORMAT);
    eval 'sub SRDD10_EXT_BFI_FORMAT () {0x1;}' unless defined(&SRDD10_EXT_BFI_FORMAT);
    eval 'sub SRDD10_EXT_PHYS_FORMAT () {0x2;}' unless defined(&SRDD10_EXT_PHYS_FORMAT);
    eval 'sub SRDD10_LONG_BLOCK_FORMAT () {0x3;}' unless defined(&SRDD10_LONG_BLOCK_FORMAT);
    eval 'sub SRDD10_BYTES_FROM_INDEX_FORMAT () {0x4;}' unless defined(&SRDD10_BYTES_FROM_INDEX_FORMAT);
    eval 'sub SRDD10_PHYSICAL_SECTOR_FORMAT () {0x5;}' unless defined(&SRDD10_PHYSICAL_SECTOR_FORMAT);
    eval 'sub SRDD10_VENDOR_FORMAT () {0x6;}' unless defined(&SRDD10_VENDOR_FORMAT);
    eval 'sub SRDD10_MAX_LENGTH () {0xffff;}' unless defined(&SRDD10_MAX_LENGTH);
    eval 'sub SSZ_SERVICE_ACTION_OVERWRITE () {0x1;}' unless defined(&SSZ_SERVICE_ACTION_OVERWRITE);
    eval 'sub SSZ_SERVICE_ACTION_BLOCK_ERASE () {0x2;}' unless defined(&SSZ_SERVICE_ACTION_BLOCK_ERASE);
    eval 'sub SSZ_SERVICE_ACTION_CRYPTO_ERASE () {0x3;}' unless defined(&SSZ_SERVICE_ACTION_CRYPTO_ERASE);
    eval 'sub SSZ_SERVICE_ACTION_EXIT_MODE_FAILURE () {0x1f;}' unless defined(&SSZ_SERVICE_ACTION_EXIT_MODE_FAILURE);
    eval 'sub SSZ_UNRESTRICTED_EXIT () {0x20;}' unless defined(&SSZ_UNRESTRICTED_EXIT);
    eval 'sub SSZ_IMMED () {0x80;}' unless defined(&SSZ_IMMED);
    eval 'sub SSZPL_INVERT () {0x80;}' unless defined(&SSZPL_INVERT);
    eval 'sub SSZPL_MAX_PATTERN_LENGTH () {65535;}' unless defined(&SSZPL_MAX_PATTERN_LENGTH);
    eval 'sub SRDD12_GLIST () {0x8;}' unless defined(&SRDD12_GLIST);
    eval 'sub SRDD12_PLIST () {0x10;}' unless defined(&SRDD12_PLIST);
    eval 'sub SRDD12_DLIST_FORMAT_MASK () {0x7;}' unless defined(&SRDD12_DLIST_FORMAT_MASK);
    eval 'sub SRDD12_BLOCK_FORMAT () { &SRDD10_BLOCK_FORMAT;}' unless defined(&SRDD12_BLOCK_FORMAT);
    eval 'sub SRDD12_BYTES_FROM_INDEX_FORMAT () { &SRDD10_BYTES_FROM_INDEX_FORMAT;}' unless defined(&SRDD12_BYTES_FROM_INDEX_FORMAT);
    eval 'sub SRDD12_PHYSICAL_SECTOR_FORMAT () { &SRDD10_PHYSICAL_SECTOR_FORMAT;}' unless defined(&SRDD12_PHYSICAL_SECTOR_FORMAT);
    eval 'sub SRDD12_MAX_LENGTH () {0xffffffff;}' unless defined(&SRDD12_MAX_LENGTH);
    eval 'sub ZBC_OUT_SA_CLOSE () {0x1;}' unless defined(&ZBC_OUT_SA_CLOSE);
    eval 'sub ZBC_OUT_SA_FINISH () {0x2;}' unless defined(&ZBC_OUT_SA_FINISH);
    eval 'sub ZBC_OUT_SA_OPEN () {0x3;}' unless defined(&ZBC_OUT_SA_OPEN);
    eval 'sub ZBC_OUT_SA_RWP () {0x4;}' unless defined(&ZBC_OUT_SA_RWP);
    eval 'sub ZBC_OUT_ALL () {0x1;}' unless defined(&ZBC_OUT_ALL);
    eval 'sub ZBC_IN_SA_REPORT_ZONES () {0x;}' unless defined(&ZBC_IN_SA_REPORT_ZONES);
    eval 'sub ZBC_IN_PARTIAL () {0x80;}' unless defined(&ZBC_IN_PARTIAL);
    eval 'sub ZBC_IN_REP_ALL_ZONES () {0x;}' unless defined(&ZBC_IN_REP_ALL_ZONES);
    eval 'sub ZBC_IN_REP_EMPTY () {0x1;}' unless defined(&ZBC_IN_REP_EMPTY);
    eval 'sub ZBC_IN_REP_IMP_OPEN () {0x2;}' unless defined(&ZBC_IN_REP_IMP_OPEN);
    eval 'sub ZBC_IN_REP_EXP_OPEN () {0x3;}' unless defined(&ZBC_IN_REP_EXP_OPEN);
    eval 'sub ZBC_IN_REP_CLOSED () {0x4;}' unless defined(&ZBC_IN_REP_CLOSED);
    eval 'sub ZBC_IN_REP_FULL () {0x5;}' unless defined(&ZBC_IN_REP_FULL);
    eval 'sub ZBC_IN_REP_READONLY () {0x6;}' unless defined(&ZBC_IN_REP_READONLY);
    eval 'sub ZBC_IN_REP_OFFLINE () {0x7;}' unless defined(&ZBC_IN_REP_OFFLINE);
    eval 'sub ZBC_IN_REP_RESET () {0x10;}' unless defined(&ZBC_IN_REP_RESET);
    eval 'sub ZBC_IN_REP_NON_SEQ () {0x11;}' unless defined(&ZBC_IN_REP_NON_SEQ);
    eval 'sub ZBC_IN_REP_NON_WP () {0x3f;}' unless defined(&ZBC_IN_REP_NON_WP);
    eval 'sub ZBC_IN_REP_MASK () {0x3f;}' unless defined(&ZBC_IN_REP_MASK);
    eval 'sub SRZ_TYPE_CONVENTIONAL () {0x1;}' unless defined(&SRZ_TYPE_CONVENTIONAL);
    eval 'sub SRZ_TYPE_SEQ_REQUIRED () {0x2;}' unless defined(&SRZ_TYPE_SEQ_REQUIRED);
    eval 'sub SRZ_TYPE_SEQ_PREFERRED () {0x3;}' unless defined(&SRZ_TYPE_SEQ_PREFERRED);
    eval 'sub SRZ_TYPE_MASK () {0xf;}' unless defined(&SRZ_TYPE_MASK);
    eval 'sub SRZ_ZONE_COND_SHIFT () {4;}' unless defined(&SRZ_ZONE_COND_SHIFT);
    eval 'sub SRZ_ZONE_COND_MASK () {0xf0;}' unless defined(&SRZ_ZONE_COND_MASK);
    eval 'sub SRZ_ZONE_COND_NWP () {0x;}' unless defined(&SRZ_ZONE_COND_NWP);
    eval 'sub SRZ_ZONE_COND_EMPTY () {0x10;}' unless defined(&SRZ_ZONE_COND_EMPTY);
    eval 'sub SRZ_ZONE_COND_IMP_OPEN () {0x20;}' unless defined(&SRZ_ZONE_COND_IMP_OPEN);
    eval 'sub SRZ_ZONE_COND_EXP_OPEN () {0x30;}' unless defined(&SRZ_ZONE_COND_EXP_OPEN);
    eval 'sub SRZ_ZONE_COND_CLOSED () {0x40;}' unless defined(&SRZ_ZONE_COND_CLOSED);
    eval 'sub SRZ_ZONE_COND_READONLY () {0xd0;}' unless defined(&SRZ_ZONE_COND_READONLY);
    eval 'sub SRZ_ZONE_COND_FULL () {0xe0;}' unless defined(&SRZ_ZONE_COND_FULL);
    eval 'sub SRZ_ZONE_COND_OFFLINE () {0xf0;}' unless defined(&SRZ_ZONE_COND_OFFLINE);
    eval 'sub SRZ_ZONE_NON_SEQ () {0x2;}' unless defined(&SRZ_ZONE_NON_SEQ);
    eval 'sub SRZ_ZONE_RESET () {0x1;}' unless defined(&SRZ_ZONE_RESET);
    eval 'sub SRZ_SAME_ALL_DIFFERENT () {0x;}' unless defined(&SRZ_SAME_ALL_DIFFERENT);
    eval 'sub SRZ_SAME_ALL_SAME () {0x1;}' unless defined(&SRZ_SAME_ALL_SAME);
    eval 'sub SRZ_SAME_LAST_DIFFERENT () {0x2;}' unless defined(&SRZ_SAME_LAST_DIFFERENT);
    eval 'sub SRZ_SAME_TYPES_DIFFERENT () {0x3;}' unless defined(&SRZ_SAME_TYPES_DIFFERENT);
    eval 'sub SRZ_SAME_MASK () {0xf;}' unless defined(&SRZ_SAME_MASK);
    eval 'sub REZERO_UNIT () {0x1;}' unless defined(&REZERO_UNIT);
    eval 'sub FORMAT_UNIT () {0x4;}' unless defined(&FORMAT_UNIT);
    eval 'sub REASSIGN_BLOCKS () {0x7;}' unless defined(&REASSIGN_BLOCKS);
    eval 'sub MODE_SELECT () {0x15;}' unless defined(&MODE_SELECT);
    eval 'sub MODE_SENSE () {0x1a;}' unless defined(&MODE_SENSE);
    eval 'sub READ_FORMAT_CAPACITIES () {0x23;}' unless defined(&READ_FORMAT_CAPACITIES);
    eval 'sub WRITE_AND_VERIFY () {0x2e;}' unless defined(&WRITE_AND_VERIFY);
    eval 'sub VERIFY () {0x2f;}' unless defined(&VERIFY);
    eval 'sub READ_DEFECT_DATA_10 () {0x37;}' unless defined(&READ_DEFECT_DATA_10);
    eval 'sub SANITIZE () {0x48;}' unless defined(&SANITIZE);
    eval 'sub ZBC_OUT () {0x94;}' unless defined(&ZBC_OUT);
    eval 'sub ZBC_IN () {0x95;}' unless defined(&ZBC_IN);
    eval 'sub READ_DEFECT_DATA_12 () {0xb7;}' unless defined(&READ_DEFECT_DATA_12);
    eval 'sub FU_DLH_VS () {0x1;}' unless defined(&FU_DLH_VS);
    eval 'sub FU_DLH_IMMED () {0x2;}' unless defined(&FU_DLH_IMMED);
    eval 'sub FU_DLH_DSP () {0x4;}' unless defined(&FU_DLH_DSP);
    eval 'sub FU_DLH_IP () {0x8;}' unless defined(&FU_DLH_IP);
    eval 'sub FU_DLH_STPF () {0x10;}' unless defined(&FU_DLH_STPF);
    eval 'sub FU_DLH_DCRT () {0x20;}' unless defined(&FU_DLH_DCRT);
    eval 'sub FU_DLH_DPRY () {0x40;}' unless defined(&FU_DLH_DPRY);
    eval 'sub FU_DLH_FOV () {0x80;}' unless defined(&FU_DLH_FOV);
    eval 'sub FU_INIT_NO_HDR () {0x;}' unless defined(&FU_INIT_NO_HDR);
    eval 'sub FU_INIT_LBA_MSB () {0x40;}' unless defined(&FU_INIT_LBA_MSB);
    eval 'sub FU_INIT_LBA_EACH () {0x80;}' unless defined(&FU_INIT_LBA_EACH);
    eval 'sub FU_INIT_SI () {0x20;}' unless defined(&FU_INIT_SI);
    eval 'sub FU_INIT_PAT_DEFAULT () {0x;}' unless defined(&FU_INIT_PAT_DEFAULT);
    eval 'sub FU_INIT_PAT_REPEAT () {0x1;}' unless defined(&FU_INIT_PAT_REPEAT);
    eval 'sub SRFC_LUN_MASK () {0xe0;}' unless defined(&SRFC_LUN_MASK);
    eval 'sub SVFY_LUN_MASK () {0xe0;}' unless defined(&SVFY_LUN_MASK);
    eval 'sub SVFY_RELADR () {0x1;}' unless defined(&SVFY_RELADR);
    eval 'sub SVFY_BYTCHK () {0x2;}' unless defined(&SVFY_BYTCHK);
    eval 'sub SVFY_DPO () {0x10;}' unless defined(&SVFY_DPO);
    eval 'sub SWVY_LUN_MASK () {0xe0;}' unless defined(&SWVY_LUN_MASK);
    eval 'sub SWVY_RELADR () {0x1;}' unless defined(&SWVY_RELADR);
    eval 'sub SWVY_BYTECHK () {0x2;}' unless defined(&SWVY_BYTECHK);
    eval 'sub SWVY_DPO () {0x10;}' unless defined(&SWVY_DPO);
    eval 'sub FCD_CODE_MASK () {0x3;}' unless defined(&FCD_CODE_MASK);
    eval 'sub FCD_UNFORMATTED () {0x1;}' unless defined(&FCD_UNFORMATTED);
    eval 'sub FCD_FORMATTED () {0x2;}' unless defined(&FCD_FORMATTED);
    eval 'sub FCD_NOMEDIA () {0x3;}' unless defined(&FCD_NOMEDIA);
    eval 'sub SRDDH10_GLIST () {0x8;}' unless defined(&SRDDH10_GLIST);
    eval 'sub SRDDH10_PLIST () {0x10;}' unless defined(&SRDDH10_PLIST);
    eval 'sub SRDDH10_DLIST_FORMAT_MASK () {0x7;}' unless defined(&SRDDH10_DLIST_FORMAT_MASK);
    eval 'sub SRDDH10_BLOCK_FORMAT () {0x;}' unless defined(&SRDDH10_BLOCK_FORMAT);
    eval 'sub SRDDH10_BYTES_FROM_INDEX_FORMAT () {0x4;}' unless defined(&SRDDH10_BYTES_FROM_INDEX_FORMAT);
    eval 'sub SRDDH10_PHYSICAL_SECTOR_FORMAT () {0x5;}' unless defined(&SRDDH10_PHYSICAL_SECTOR_FORMAT);
    eval 'sub SRDDH10_MAX_LENGTH () { &SRDD10_MAX_LENGTH - $sizeof{\'struct scsi_read_defect_data_hdr_10\'};}' unless defined(&SRDDH10_MAX_LENGTH);
    eval 'sub SDD_EXT_BFI_MADS () {0x80000000;}' unless defined(&SDD_EXT_BFI_MADS);
    eval 'sub SDD_EXT_BFI_FLAG_MASK () {0xf0000000;}' unless defined(&SDD_EXT_BFI_FLAG_MASK);
    eval 'sub SDD_EXT_BFI_ENTIRE_TRACK () {0xfffffff;}' unless defined(&SDD_EXT_BFI_ENTIRE_TRACK);
    eval 'sub SDD_EXT_PHYS_MADS () {0x80000000;}' unless defined(&SDD_EXT_PHYS_MADS);
    eval 'sub SDD_EXT_PHYS_FLAG_MASK () {0xf0000000;}' unless defined(&SDD_EXT_PHYS_FLAG_MASK);
    eval 'sub SDD_EXT_PHYS_ENTIRE_TRACK () {0xfffffff;}' unless defined(&SDD_EXT_PHYS_ENTIRE_TRACK);
    eval 'sub SRDDH12_GLIST () {0x8;}' unless defined(&SRDDH12_GLIST);
    eval 'sub SRDDH12_PLIST () {0x10;}' unless defined(&SRDDH12_PLIST);
    eval 'sub SRDDH12_DLIST_FORMAT_MASK () {0x7;}' unless defined(&SRDDH12_DLIST_FORMAT_MASK);
    eval 'sub SRDDH12_BLOCK_FORMAT () {0x;}' unless defined(&SRDDH12_BLOCK_FORMAT);
    eval 'sub SRDDH12_BYTES_FROM_INDEX_FORMAT () {0x4;}' unless defined(&SRDDH12_BYTES_FROM_INDEX_FORMAT);
    eval 'sub SRDDH12_PHYSICAL_SECTOR_FORMAT () {0x5;}' unless defined(&SRDDH12_PHYSICAL_SECTOR_FORMAT);
    eval 'sub SRDDH12_MAX_LENGTH () { &SRDD12_MAX_LENGTH - $sizeof{\'struct scsi_read_defect_data_hdr_12\'};}' unless defined(&SRDDH12_MAX_LENGTH);
    eval 'sub SMS_FORMAT_DEVICE_PAGE () {0x3;}' unless defined(&SMS_FORMAT_DEVICE_PAGE);
    eval 'sub SMS_FORMAT_DEVICE_PLEN () {0x16;}' unless defined(&SMS_FORMAT_DEVICE_PLEN);
    eval 'sub DISK_FMT_SURF () {0x10;}' unless defined(&DISK_FMT_SURF);
    eval 'sub DISK_FMT_RMB () {0x20;}' unless defined(&DISK_FMT_RMB);
    eval 'sub DISK_FMT_HSEC () {0x40;}' unless defined(&DISK_FMT_HSEC);
    eval 'sub DISK_FMT_SSEC () {0x80;}' unless defined(&DISK_FMT_SSEC);
    eval 'sub SMS_RIGID_GEOMETRY_PAGE () {0x4;}' unless defined(&SMS_RIGID_GEOMETRY_PAGE);
    eval 'sub SMS_RIGID_GEOMETRY_PLEN () {0x16;}' unless defined(&SMS_RIGID_GEOMETRY_PLEN);
    eval 'sub SMS_FLEXIBLE_GEOMETRY_PAGE () {0x5;}' unless defined(&SMS_FLEXIBLE_GEOMETRY_PAGE);
    eval 'sub SMS_FLEXIBLE_GEOMETRY_PLEN () {0x1e;}' unless defined(&SMS_FLEXIBLE_GEOMETRY_PLEN);
    eval 'sub SFP_SSEC () {0x80;}' unless defined(&SFP_SSEC);
    eval 'sub SFP_HSEC () {0x40;}' unless defined(&SFP_HSEC);
    eval 'sub SFP_RMB () {0x20;}' unless defined(&SFP_RMB);
    eval 'sub SFP_SURF () {0x10;}' unless defined(&SFP_SURF);
    eval 'sub SMS_RIGID_DISK_PAGE () {0x4;}' unless defined(&SMS_RIGID_DISK_PAGE);
    eval 'sub SRDP_RPL_DISABLED () {0x;}' unless defined(&SRDP_RPL_DISABLED);
    eval 'sub SRDP_RPL_SLAVE () {0x1;}' unless defined(&SRDP_RPL_SLAVE);
    eval 'sub SRDP_RPL_MASTER () {0x2;}' unless defined(&SRDP_RPL_MASTER);
    eval 'sub SRDP_RPL_MASTER_CONTROL () {0x3;}' unless defined(&SRDP_RPL_MASTER_CONTROL);
    eval 'sub SMS_RW_ERROR_RECOVERY_PAGE () {0x1;}' unless defined(&SMS_RW_ERROR_RECOVERY_PAGE);
    eval 'sub SMS_RWER_AWRE () {0x80;}' unless defined(&SMS_RWER_AWRE);
    eval 'sub SMS_RWER_ARRE () {0x40;}' unless defined(&SMS_RWER_ARRE);
    eval 'sub SMS_RWER_TB () {0x20;}' unless defined(&SMS_RWER_TB);
    eval 'sub SMS_RWER_RC () {0x10;}' unless defined(&SMS_RWER_RC);
    eval 'sub SMS_RWER_EER () {0x8;}' unless defined(&SMS_RWER_EER);
    eval 'sub SMS_RWER_PER () {0x4;}' unless defined(&SMS_RWER_PER);
    eval 'sub SMS_RWER_DTE () {0x2;}' unless defined(&SMS_RWER_DTE);
    eval 'sub SMS_RWER_DCR () {0x1;}' unless defined(&SMS_RWER_DCR);
    eval 'sub SMS_RWER_LBPERE () {0x80;}' unless defined(&SMS_RWER_LBPERE);
    eval 'sub SMS_VERIFY_ERROR_RECOVERY_PAGE () {0x7;}' unless defined(&SMS_VERIFY_ERROR_RECOVERY_PAGE);
    eval 'sub SMS_VER_EER () {0x8;}' unless defined(&SMS_VER_EER);
    eval 'sub SMS_VER_PER () {0x4;}' unless defined(&SMS_VER_PER);
    eval 'sub SMS_VER_DTE () {0x2;}' unless defined(&SMS_VER_DTE);
    eval 'sub SMS_VER_DCR () {0x1;}' unless defined(&SMS_VER_DCR);
    unless(defined(&_KERNEL)) {
    }
}
1;
