require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub SCSI_LOW_DIAGNOSTIC () {1;}' unless defined(&SCSI_LOW_DIAGNOSTIC);
eval 'sub SCSI_LOW_ALT_QTAG_ALLOCATE () {1;}' unless defined(&SCSI_LOW_ALT_QTAG_ALLOCATE);
unless(defined(&_SCSI_LOW_H_)) {
    eval 'sub _SCSI_LOW_H_ () {1;}' unless defined(&_SCSI_LOW_H_);
    require 'sys/bus.ph';
    require 'sys/kdb.ph';
    require 'cam/cam.ph';
    require 'cam/cam_ccb.ph';
    require 'cam/cam_sim.ph';
    require 'cam/cam_xpt_sim.ph';
    require 'cam/cam_debug.ph';
    require 'cam/scsi/scsi_dvcfg.ph';
    require 'i386/isa/ccbque.ph';
    undef(&MSG_IDENTIFY) if defined(&MSG_IDENTIFY);
    eval 'sub SCSI_LOW_SYNC () { &DVF_SCSI_SYNC;}' unless defined(&SCSI_LOW_SYNC);
    eval 'sub SCSI_LOW_DISC () { &DVF_SCSI_DISC;}' unless defined(&SCSI_LOW_DISC);
    eval 'sub SCSI_LOW_WAIT () { &DVF_SCSI_WAIT;}' unless defined(&SCSI_LOW_WAIT);
    eval 'sub SCSI_LOW_LINK () { &DVF_SCSI_LINK;}' unless defined(&SCSI_LOW_LINK);
    eval 'sub SCSI_LOW_QTAG () { &DVF_SCSI_QTAG;}' unless defined(&SCSI_LOW_QTAG);
    eval 'sub SCSI_LOW_NOPARITY () { &DVF_SCSI_NOPARITY;}' unless defined(&SCSI_LOW_NOPARITY);
    eval 'sub SCSI_LOW_SAVESP () { &DVF_SCSI_SAVESP;}' unless defined(&SCSI_LOW_SAVESP);
    eval 'sub SCSI_LOW_DEFCFG () { &DVF_SCSI_DEFCFG;}' unless defined(&SCSI_LOW_DEFCFG);
    eval 'sub SCSI_LOW_BITS () { &DVF_SCSI_BITS;}' unless defined(&SCSI_LOW_BITS);
    eval 'sub SCSI_LOW_PERIOD {
        my($n) = @_;
	    eval q( &DVF_SCSI_PERIOD($n));
    }' unless defined(&SCSI_LOW_PERIOD);
    eval 'sub SCSI_LOW_OFFSET {
        my($n) = @_;
	    eval q( &DVF_SCSI_OFFSET($n));
    }' unless defined(&SCSI_LOW_OFFSET);
    unless(defined(&SCSI_LOW_NTARGETS)) {
	eval 'sub SCSI_LOW_NTARGETS () {8;}' unless defined(&SCSI_LOW_NTARGETS);
    }
    eval 'sub SCSI_LOW_NCCB () {128;}' unless defined(&SCSI_LOW_NCCB);
    eval 'sub SCSI_LOW_MAX_RETRY () {3;}' unless defined(&SCSI_LOW_MAX_RETRY);
    eval 'sub SCSI_LOW_MAX_SELECTION_RETRY () {10;}' unless defined(&SCSI_LOW_MAX_SELECTION_RETRY);
    eval 'sub SCSI_LOW_TIMEOUT_HZ () {10;}' unless defined(&SCSI_LOW_TIMEOUT_HZ);
    eval 'sub SCSI_LOW_MIN_TOUT () {12;}' unless defined(&SCSI_LOW_MIN_TOUT);
    eval 'sub SCSI_LOW_TIMEOUT_CHECK_INTERVAL () {1;}' unless defined(&SCSI_LOW_TIMEOUT_CHECK_INTERVAL);
    eval 'sub SCSI_LOW_POWDOWN_TC () {15;}' unless defined(&SCSI_LOW_POWDOWN_TC);
    eval 'sub SCSI_LOW_MAX_PHCHANGES () {256;}' unless defined(&SCSI_LOW_MAX_PHCHANGES);
    eval 'sub SCSI2_RESET_DELAY () {5000000;}' unless defined(&SCSI2_RESET_DELAY);
    eval 'sub SCSI_LOW_MAX_MSGLEN () {32;}' unless defined(&SCSI_LOW_MAX_MSGLEN);
    eval 'sub SCSI_LOW_MSG_LOG_DATALEN () {8;}' unless defined(&SCSI_LOW_MSG_LOG_DATALEN);
    eval 'sub SCSI_LOW_RWUNK () {(-1);}' unless defined(&SCSI_LOW_RWUNK);
    eval 'sub SCSI_LOW_WRITE () {0;}' unless defined(&SCSI_LOW_WRITE);
    eval 'sub SCSI_LOW_READ () {1;}' unless defined(&SCSI_LOW_READ);
    eval 'sub SCSI_LOW_UNKLUN () {( -1);}' unless defined(&SCSI_LOW_UNKLUN);
    eval 'sub SCSI_LOW_UNKTAG () {(( &scsi_low_tag_t) -1);}' unless defined(&SCSI_LOW_UNKTAG);
    eval 'sub CCB_INTERNAL () {0x1;}' unless defined(&CCB_INTERNAL);
    eval 'sub CCB_SENSE () {0x2;}' unless defined(&CCB_SENSE);
    eval 'sub CCB_CLEARQ () {0x4;}' unless defined(&CCB_CLEARQ);
    eval 'sub CCB_DISCQ () {0x8;}' unless defined(&CCB_DISCQ);
    eval 'sub CCB_STARTQ () {0x10;}' unless defined(&CCB_STARTQ);
    eval 'sub CCB_POLLED () {0x100;}' unless defined(&CCB_POLLED);
    eval 'sub CCB_NORETRY () {0x200;}' unless defined(&CCB_NORETRY);
    eval 'sub CCB_AUTOSENSE () {0x400;}' unless defined(&CCB_AUTOSENSE);
    eval 'sub CCB_URGENT () {0x800;}' unless defined(&CCB_URGENT);
    eval 'sub CCB_NOSDONE () {0x1000;}' unless defined(&CCB_NOSDONE);
    eval 'sub CCB_SCSIIO () {0x2000;}' unless defined(&CCB_SCSIIO);
    eval 'sub CCB_SILENT () {0x4000;}' unless defined(&CCB_SILENT);
    eval 'sub SCSI_LOW_MAXNEXUS () {($sizeof{\'u_int\'} *  &NBBY);}' unless defined(&SCSI_LOW_MAXNEXUS);
    if(defined(&SCSI_LOW_ALT_QTAG_ALLOCATE)) {
    }
    eval 'sub SCSI_LOW_QFLAG_CA_QCLEAR () {0x1;}' unless defined(&SCSI_LOW_QFLAG_CA_QCLEAR);
    eval 'sub SCSI_LOW_LUN_SLEEP () {0x;}' unless defined(&SCSI_LOW_LUN_SLEEP);
    eval 'sub SCSI_LOW_LUN_START () {0x1;}' unless defined(&SCSI_LOW_LUN_START);
    eval 'sub SCSI_LOW_LUN_INQ () {0x2;}' unless defined(&SCSI_LOW_LUN_INQ);
    eval 'sub SCSI_LOW_LUN_MODEQ () {0x3;}' unless defined(&SCSI_LOW_LUN_MODEQ);
    eval 'sub SCSI_LOW_LUN_OK () {0x4;}' unless defined(&SCSI_LOW_LUN_OK);
    eval 'sub SCSI_LOW_LUN_FLAGS_USER_VALID () {0x1;}' unless defined(&SCSI_LOW_LUN_FLAGS_USER_VALID);
    eval 'sub SCSI_LOW_LUN_FLAGS_DISK_VALID () {0x2;}' unless defined(&SCSI_LOW_LUN_FLAGS_DISK_VALID);
    eval 'sub SCSI_LOW_LUN_FLAGS_QUIRKS_VALID () {0x4;}' unless defined(&SCSI_LOW_LUN_FLAGS_QUIRKS_VALID);
    eval 'sub SCSI_LOW_LUN_FLAGS_ALL_VALID () {( &SCSI_LOW_LUN_FLAGS_USER_VALID |  &SCSI_LOW_LUN_FLAGS_DISK_VALID |  &SCSI_LOW_LUN_FLAGS_QUIRKS_VALID);}' unless defined(&SCSI_LOW_LUN_FLAGS_ALL_VALID);
    eval 'sub PH_NULL () {0x;}' unless defined(&PH_NULL);
    eval 'sub PH_ARBSTART () {0x1;}' unless defined(&PH_ARBSTART);
    eval 'sub PH_SELSTART () {0x2;}' unless defined(&PH_SELSTART);
    eval 'sub PH_SELECTED () {0x3;}' unless defined(&PH_SELECTED);
    eval 'sub PH_CMD () {0x4;}' unless defined(&PH_CMD);
    eval 'sub PH_DATA () {0x5;}' unless defined(&PH_DATA);
    eval 'sub PH_MSGIN () {0x6;}' unless defined(&PH_MSGIN);
    eval 'sub PH_MSGOUT () {0x7;}' unless defined(&PH_MSGOUT);
    eval 'sub PH_STAT () {0x8;}' unless defined(&PH_STAT);
    eval 'sub PH_DISC () {0x9;}' unless defined(&PH_DISC);
    eval 'sub PH_RESEL () {0xa;}' unless defined(&PH_RESEL);
    eval 'sub SCSI_LOW_MSG_RESET () {0x1;}' unless defined(&SCSI_LOW_MSG_RESET);
    eval 'sub SCSI_LOW_MSG_REJECT () {0x2;}' unless defined(&SCSI_LOW_MSG_REJECT);
    eval 'sub SCSI_LOW_MSG_PARITY () {0x4;}' unless defined(&SCSI_LOW_MSG_PARITY);
    eval 'sub SCSI_LOW_MSG_ERROR () {0x8;}' unless defined(&SCSI_LOW_MSG_ERROR);
    eval 'sub SCSI_LOW_MSG_IDENTIFY () {0x10;}' unless defined(&SCSI_LOW_MSG_IDENTIFY);
    eval 'sub SCSI_LOW_MSG_ABORT () {0x20;}' unless defined(&SCSI_LOW_MSG_ABORT);
    eval 'sub SCSI_LOW_MSG_TERMIO () {0x40;}' unless defined(&SCSI_LOW_MSG_TERMIO);
    eval 'sub SCSI_LOW_MSG_SIMPLE_QTAG () {0x80;}' unless defined(&SCSI_LOW_MSG_SIMPLE_QTAG);
    eval 'sub SCSI_LOW_MSG_ORDERED_QTAG () {0x100;}' unless defined(&SCSI_LOW_MSG_ORDERED_QTAG);
    eval 'sub SCSI_LOW_MSG_HEAD_QTAG () {0x200;}' unless defined(&SCSI_LOW_MSG_HEAD_QTAG);
    eval 'sub SCSI_LOW_MSG_ABORT_QTAG () {0x400;}' unless defined(&SCSI_LOW_MSG_ABORT_QTAG);
    eval 'sub SCSI_LOW_MSG_CLEAR_QTAG () {0x800;}' unless defined(&SCSI_LOW_MSG_CLEAR_QTAG);
    eval 'sub SCSI_LOW_MSG_WIDE () {0x1000;}' unless defined(&SCSI_LOW_MSG_WIDE);
    eval 'sub SCSI_LOW_MSG_SYNCH () {0x2000;}' unless defined(&SCSI_LOW_MSG_SYNCH);
    eval 'sub SCSI_LOW_MSG_NOOP () {0x4000;}' unless defined(&SCSI_LOW_MSG_NOOP);
    eval 'sub SCSI_LOW_MSG_LAST () {0x8000;}' unless defined(&SCSI_LOW_MSG_LAST);
    eval 'sub SCSI_LOW_MSG_ALL () {0xffffffff;}' unless defined(&SCSI_LOW_MSG_ALL);
    eval 'sub SCSI_LOW_TARG_FLAGS_USER_VALID () {0x1;}' unless defined(&SCSI_LOW_TARG_FLAGS_USER_VALID);
    eval 'sub SCSI_LOW_TARG_FLAGS_DISK_VALID () {0x2;}' unless defined(&SCSI_LOW_TARG_FLAGS_DISK_VALID);
    eval 'sub SCSI_LOW_TARG_FLAGS_QUIRKS_VALID () {0x4;}' unless defined(&SCSI_LOW_TARG_FLAGS_QUIRKS_VALID);
    eval 'sub SCSI_LOW_TARG_FLAGS_ALL_VALID () {( &SCSI_LOW_TARG_FLAGS_USER_VALID |  &SCSI_LOW_TARG_FLAGS_DISK_VALID |  &SCSI_LOW_TARG_FLAGS_QUIRKS_VALID);}' unless defined(&SCSI_LOW_TARG_FLAGS_ALL_VALID);
    eval 'sub SCSI_LOW_BUS_WIDTH_8 () {0;}' unless defined(&SCSI_LOW_BUS_WIDTH_8);
    eval 'sub SCSI_LOW_BUS_WIDTH_16 () {1;}' unless defined(&SCSI_LOW_BUS_WIDTH_16);
    eval 'sub SCSI_LOW_BUS_WIDTH_32 () {2;}' unless defined(&SCSI_LOW_BUS_WIDTH_32);
    if(defined(&SCSI_LOW_DIAGNOSTIC)) {
    }
    eval 'sub SCSI_LOW_START_OK () {0;}' unless defined(&SCSI_LOW_START_OK);
    eval 'sub SCSI_LOW_START_FAIL () {1;}' unless defined(&SCSI_LOW_START_FAIL);
    eval 'sub SCSI_LOW_INFO_ALLOC () {0;}' unless defined(&SCSI_LOW_INFO_ALLOC);
    eval 'sub SCSI_LOW_INFO_REVOKE () {1;}' unless defined(&SCSI_LOW_INFO_REVOKE);
    eval 'sub SCSI_LOW_INFO_DEALLOC () {2;}' unless defined(&SCSI_LOW_INFO_DEALLOC);
    eval 'sub SCSI_LOW_POWDOWN () {1;}' unless defined(&SCSI_LOW_POWDOWN);
    eval 'sub SCSI_LOW_ENGAGE () {2;}' unless defined(&SCSI_LOW_ENGAGE);
    eval 'sub SC_LOW_INIT_T () {( &int (*)( &sc_low_t, \'int\'));}' unless defined(&SC_LOW_INIT_T);
    eval 'sub SC_LOW_BUSRST_T () {( &void (*)( &sc_low_t));}' unless defined(&SC_LOW_BUSRST_T);
    eval 'sub SC_LOW_TARG_INIT_T () {( &int (*)( &sc_low_t, \'struct targ_info\' *, \'int\'));}' unless defined(&SC_LOW_TARG_INIT_T);
    eval 'sub SC_LOW_LUN_INIT_T () {( &int (*)( &sc_low_t, \'struct targ_info\' *, \'struct lun_info\' *, \'int\'));}' unless defined(&SC_LOW_LUN_INIT_T);
    eval 'sub SC_LOW_SELECT_T () {( &int (*)( &sc_low_t, \'struct slccb\' *));}' unless defined(&SC_LOW_SELECT_T);
    eval 'sub SC_LOW_ATTEN_T () {( &void (*)( &sc_low_t));}' unless defined(&SC_LOW_ATTEN_T);
    eval 'sub SC_LOW_NEXUS_T () {( &int (*)( &sc_low_t));}' unless defined(&SC_LOW_NEXUS_T);
    eval 'sub SC_LOW_MSG_T () {( &int (*)( &sc_low_t, \'struct targ_info\' *, \'u_int\'));}' unless defined(&SC_LOW_MSG_T);
    eval 'sub SC_LOW_POLL_T () {( &int (*)( &void *));}' unless defined(&SC_LOW_POLL_T);
    eval 'sub SC_LOW_POWER_T () {( &int (*)( &sc_low_t, \'u_int\'));}' unless defined(&SC_LOW_POWER_T);
    eval 'sub SC_LOW_TIMEOUT_T () {( &int (*)( &sc_low_t));}' unless defined(&SC_LOW_TIMEOUT_T);
    if(defined(&SCSI_LOW_POWFUNC)) {
    }
    eval 'sub MSGPH_NULL () {0x;}' unless defined(&MSGPH_NULL);
    eval 'sub MSGPH_DISC () {0x1;}' unless defined(&MSGPH_DISC);
    eval 'sub MSGPH_CMDC () {0x2;}' unless defined(&MSGPH_CMDC);
    eval 'sub MSGPH_ABORT () {0x3;}' unless defined(&MSGPH_ABORT);
    eval 'sub MSGPH_TERM () {0x4;}' unless defined(&MSGPH_TERM);
    eval 'sub MSGPH_LCTERM () {0x5;}' unless defined(&MSGPH_LCTERM);
    eval 'sub MSGPH_RESET () {0x6;}' unless defined(&MSGPH_RESET);
    eval 'sub FATALIO () {0x1;}' unless defined(&FATALIO);
    eval 'sub ABORTIO () {0x2;}' unless defined(&ABORTIO);
    eval 'sub TIMEOUTIO () {0x4;}' unless defined(&TIMEOUTIO);
    eval 'sub SELTIMEOUTIO () {0x8;}' unless defined(&SELTIMEOUTIO);
    eval 'sub PDMAERR () {0x10;}' unless defined(&PDMAERR);
    eval 'sub MSGERR () {0x20;}' unless defined(&MSGERR);
    eval 'sub PARITYERR () {0x40;}' unless defined(&PARITYERR);
    eval 'sub BUSYERR () {0x80;}' unless defined(&BUSYERR);
    eval 'sub STATERR () {0x100;}' unless defined(&STATERR);
    eval 'sub UACAERR () {0x200;}' unless defined(&UACAERR);
    eval 'sub SENSEIO () {0x1000;}' unless defined(&SENSEIO);
    eval 'sub SENSEERR () {0x2000;}' unless defined(&SENSEERR);
    eval 'sub UBFERR () {0x4000;}' unless defined(&UBFERR);
    eval 'sub PENDINGIO () {0x8000;}' unless defined(&PENDINGIO);
    eval 'sub SCSI_LOW_ERRORBITS () {"\\020\\017ubferr\\016senseerr\\015senseio\\012uacaerr\\011staterr\\010busy\\007parity\\006msgerr\\005pdmaerr\\004seltimeout\\003timeout\\002abort\\001fatal";}' unless defined(&SCSI_LOW_ERRORBITS);
    eval 'sub HW_POWDOWN () {0x1;}' unless defined(&HW_POWDOWN);
    eval 'sub HW_RESUME () {0x2;}' unless defined(&HW_RESUME);
    eval 'sub HW_PDMASTART () {0x4;}' unless defined(&HW_PDMASTART);
    eval 'sub HW_INACTIVE () {0x8;}' unless defined(&HW_INACTIVE);
    eval 'sub HW_POWERCTRL () {0x10;}' unless defined(&HW_POWERCTRL);
    eval 'sub HW_INITIALIZING () {0x20;}' unless defined(&HW_INITIALIZING);
    eval 'sub HW_READ_PADDING () {0x1000;}' unless defined(&HW_READ_PADDING);
    eval 'sub HW_WRITE_PADDING () {0x2000;}' unless defined(&HW_WRITE_PADDING);
    eval 'sub CFG_NODISC () {0x1;}' unless defined(&CFG_NODISC);
    eval 'sub CFG_NOPARITY () {0x2;}' unless defined(&CFG_NOPARITY);
    eval 'sub CFG_NOATTEN () {0x4;}' unless defined(&CFG_NOATTEN);
    eval 'sub CFG_ASYNC () {0x8;}' unless defined(&CFG_ASYNC);
    eval 'sub CFG_NOQTAG () {0x10;}' unless defined(&CFG_NOQTAG);
    eval 'sub SHOW_SYNCH_NEG () {0x1;}' unless defined(&SHOW_SYNCH_NEG);
    eval 'sub SHOW_WIDE_NEG () {0x2;}' unless defined(&SHOW_WIDE_NEG);
    eval 'sub SHOW_CALCF_RES () {0x10;}' unless defined(&SHOW_CALCF_RES);
    eval 'sub SHOW_PROBE_RES () {0x20;}' unless defined(&SHOW_PROBE_RES);
    eval 'sub SHOW_ALL_NEG () {-1;}' unless defined(&SHOW_ALL_NEG);
    eval 'sub SCSI_LOW_LOCK {
        my($sl) = @_;
	    eval q( &mtx_lock(($sl)-> &sl_lock));
    }' unless defined(&SCSI_LOW_LOCK);
    eval 'sub SCSI_LOW_UNLOCK {
        my($sl) = @_;
	    eval q( &mtx_unlock(($sl)-> &sl_lock));
    }' unless defined(&SCSI_LOW_UNLOCK);
    eval 'sub SCSI_LOW_ASSERT_LOCKED {
        my($sl) = @_;
	    eval q( &mtx_assert(($sl)-> &sl_lock,  &MA_OWNED));
    }' unless defined(&SCSI_LOW_ASSERT_LOCKED);
    eval 'sub SCSI_LOW_MSGOUT_INIT () {0x1;}' unless defined(&SCSI_LOW_MSGOUT_INIT);
    eval 'sub SCSI_LOW_MSGOUT_UNIFY () {0x2;}' unless defined(&SCSI_LOW_MSGOUT_UNIFY);
    eval 'sub SCSI_LOW_DATA_PE () {0x80000000;}' unless defined(&SCSI_LOW_DATA_PE);
    eval 'sub SCSI_LOW_RESTART_HARD () {1;}' unless defined(&SCSI_LOW_RESTART_HARD);
    eval 'sub SCSI_LOW_RESTART_SOFT () {0;}' unless defined(&SCSI_LOW_RESTART_SOFT);
    eval 'sub SCSI_LOW_SETUP_PHASE {
        my($ti, $phase) = @_;
	    eval q({ ($ti)-> &ti_ophase =  ($ti->{ti_phase}); ($ti)-> &ti_phase = ($phase); });
    }' unless defined(&SCSI_LOW_SETUP_PHASE);
    eval 'sub SCSI_LOW_SETUP_MSGPHASE {
        my($slp, $PHASE) = @_;
	    eval q({ ($slp)-> &sl_msgphase = ($PHASE); });
    }' unless defined(&SCSI_LOW_SETUP_MSGPHASE);
    eval 'sub SCSI_LOW_ASSERT_ATN {
        my($slp) = @_;
	    eval q({ ($slp)-> &sl_atten = 1; });
    }' unless defined(&SCSI_LOW_ASSERT_ATN);
    eval 'sub SCSI_LOW_DEASSERT_ATN {
        my($slp) = @_;
	    eval q({ ($slp)-> &sl_atten = 0; });
    }' unless defined(&SCSI_LOW_DEASSERT_ATN);
    eval 'sub scsi_low_is_msgout_continue {
        my($ti,$mask) = @_;
	    eval q(*$ti; \'u_int\' $mask; { (( ($ti->{ti_msgflags}) & (~$mask)) != 0); });
    }' unless defined(&scsi_low_is_msgout_continue);
    eval 'sub scsi_low_is_disconnect_ok {
        my($cb) = @_;
	    eval q(*$cb; { (( ($cb->{li}->{li_flags}) &  &SCSI_LOW_DISC) != 0 && ( ($cb->{c$cb_flags}) & ( &CCB_SENSE |  &CCB_CLEARQ)) == 0); });
    }' unless defined(&scsi_low_is_disconnect_ok);
    eval 'sub scsi_low_attention {
        my($slp) = @_;
	    eval q(*$slp; {  &if ( ($slp->{sl_atten}) != 0) ; (* ($slp->{sl_funcs}->{scsi_low_attention})) ($slp);  &SCSI_LOW_ASSERT_ATN($slp); });
    }' unless defined(&scsi_low_attention);
    eval 'sub scsi_low_assert_msg {
        my($slp,$ti,$msg,$now) = @_;
	    eval q(*$slp; \'struct targ_info\' *$ti; \'u_int\' $msg; \'int\' $now; {  ($ti->{ti_msgflags}) |= $msg;  &if ($now != 0)  &scsi_low_attention($slp); 0; });
    }' unless defined(&scsi_low_assert_msg);
    eval 'sub scsi_low_arbit_win {
        my($slp) = @_;
	    eval q(*$slp; {  ($slp->{sl_selid}) =  &NULL; });
    }' unless defined(&scsi_low_arbit_win);
    eval 'sub scsi_low_data_finish {
        my($slp) = @_;
	    eval q(*$slp; {  &if ( ($slp->{sl_Qnexus}) !=  &NULL) {  ($slp->{sl_Qnexus}->{ccb_datalen}) =  ($slp->{sl_scp}->{scp_datalen}); } });
    }' unless defined(&scsi_low_data_finish);
    eval 'sub scsi_low_statusin {
        my($slp,$ti,$c) = @_;
	    eval q(*$slp; \'struct targ_info\' *$ti; \'u_int\' $c; {  ($slp->{sl_ph_count}) ++;  &if (($c &  &SCSI_LOW_DATA_PE) != 0) {  &scsi_low_assert_msg($slp, $ti,  &SCSI_LOW_MSG_ERROR, 0);  &EIO; }  ($slp->{sl_scp}->{s$cp_status}) = ( &u_int8_t) $c; 0; });
    }' unless defined(&scsi_low_statusin);
    eval 'sub ST_GOOD () {0x;}' unless defined(&ST_GOOD);
    eval 'sub ST_CHKCOND () {0x2;}' unless defined(&ST_CHKCOND);
    eval 'sub ST_MET () {0x4;}' unless defined(&ST_MET);
    eval 'sub ST_BUSY () {0x8;}' unless defined(&ST_BUSY);
    eval 'sub ST_INTERGOOD () {0x10;}' unless defined(&ST_INTERGOOD);
    eval 'sub ST_INTERMET () {0x14;}' unless defined(&ST_INTERMET);
    eval 'sub ST_CONFLICT () {0x18;}' unless defined(&ST_CONFLICT);
    eval 'sub ST_CMDTERM () {0x22;}' unless defined(&ST_CMDTERM);
    eval 'sub ST_QUEFULL () {0x28;}' unless defined(&ST_QUEFULL);
    eval 'sub ST_UNKNOWN () {0xff;}' unless defined(&ST_UNKNOWN);
    eval 'sub MSG_COMP () {0x;}' unless defined(&MSG_COMP);
    eval 'sub MSG_EXTEND () {0x1;}' unless defined(&MSG_EXTEND);
    eval 'sub MKMSG_EXTEND {
        my($XLEN, $XCODE) = @_;
	    eval q(((() <<  &NBBY) | (($XCODE))));
    }' unless defined(&MKMSG_EXTEND);
    eval 'sub MSG_EXTEND_MDPCODE () {0x;}' unless defined(&MSG_EXTEND_MDPCODE);
    eval 'sub MSG_EXTEND_MDPLEN () {0x5;}' unless defined(&MSG_EXTEND_MDPLEN);
    eval 'sub MSG_EXTEND_SYNCHCODE () {0x1;}' unless defined(&MSG_EXTEND_SYNCHCODE);
    eval 'sub MSG_EXTEND_SYNCHLEN () {0x3;}' unless defined(&MSG_EXTEND_SYNCHLEN);
    eval 'sub MSG_EXTEND_WIDECODE () {0x3;}' unless defined(&MSG_EXTEND_WIDECODE);
    eval 'sub MSG_EXTEND_WIDELEN () {0x2;}' unless defined(&MSG_EXTEND_WIDELEN);
    eval 'sub MSG_SAVESP () {0x2;}' unless defined(&MSG_SAVESP);
    eval 'sub MSG_RESTORESP () {0x3;}' unless defined(&MSG_RESTORESP);
    eval 'sub MSG_DISCON () {0x4;}' unless defined(&MSG_DISCON);
    eval 'sub MSG_I_ERROR () {0x5;}' unless defined(&MSG_I_ERROR);
    eval 'sub MSG_ABORT () {0x6;}' unless defined(&MSG_ABORT);
    eval 'sub MSG_REJECT () {0x7;}' unless defined(&MSG_REJECT);
    eval 'sub MSG_NOOP () {0x8;}' unless defined(&MSG_NOOP);
    eval 'sub MSG_PARITY () {0x9;}' unless defined(&MSG_PARITY);
    eval 'sub MSG_LCOMP () {0xa;}' unless defined(&MSG_LCOMP);
    eval 'sub MSG_LCOMP_F () {0xb;}' unless defined(&MSG_LCOMP_F);
    eval 'sub MSG_RESET () {0xc;}' unless defined(&MSG_RESET);
    eval 'sub MSG_ABORT_QTAG () {0xd;}' unless defined(&MSG_ABORT_QTAG);
    eval 'sub MSG_CLEAR_QTAG () {0xe;}' unless defined(&MSG_CLEAR_QTAG);
    eval 'sub MSG_TERM_IO () {0x11;}' unless defined(&MSG_TERM_IO);
    eval 'sub MSG_SIMPLE_QTAG () {0x20;}' unless defined(&MSG_SIMPLE_QTAG);
    eval 'sub MSG_HEAD_QTAG () {0x21;}' unless defined(&MSG_HEAD_QTAG);
    eval 'sub MSG_ORDERED_QTAG () {0x22;}' unless defined(&MSG_ORDERED_QTAG);
    eval 'sub MSG_IDENTIFY () {0x80;}' unless defined(&MSG_IDENTIFY);
    eval 'sub MSG_IDENTIFY_DISCPRIV () {0x40;}' unless defined(&MSG_IDENTIFY_DISCPRIV);
}
1;
