require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SCSI_SG_H)) {
    eval 'sub _SCSI_SG_H () {1;}' unless defined(&_SCSI_SG_H);
    eval 'sub SGIOC () {\'"\';}' unless defined(&SGIOC);
    eval 'sub SG_SET_TIMEOUT () { &_IOW( &SGIOC, 0x1, \'u_int\');}' unless defined(&SG_SET_TIMEOUT);
    eval 'sub SG_GET_TIMEOUT () { &_IO( &SGIOC, 0x2);}' unless defined(&SG_GET_TIMEOUT);
    eval 'sub SG_EMULATED_HOST () { &_IOR( &SGIOC, 0x3, \'int\');}' unless defined(&SG_EMULATED_HOST);
    eval 'sub SG_SET_TRANSFORM () { &_IO( &SGIOC, 0x4);}' unless defined(&SG_SET_TRANSFORM);
    eval 'sub SG_GET_TRANSFORM () { &_IO( &SGIOC, 0x5);}' unless defined(&SG_GET_TRANSFORM);
    eval 'sub SG_GET_COMMAND_Q () { &_IOW( &SGIOC, 0x70, \'int\');}' unless defined(&SG_GET_COMMAND_Q);
    eval 'sub SG_SET_COMMAND_Q () { &_IOR( &SGIOC, 0x71, \'int\');}' unless defined(&SG_SET_COMMAND_Q);
    eval 'sub SG_GET_RESERVED_SIZE () { &_IOR( &SGIOC, 0x72, \'int\');}' unless defined(&SG_GET_RESERVED_SIZE);
    eval 'sub SG_SET_RESERVED_SIZE () { &_IOW( &SGIOC, 0x75, \'int\');}' unless defined(&SG_SET_RESERVED_SIZE);
    eval 'sub SG_GET_SCSI_ID () { &_IOR( &SGIOC, 0x76, \'struct sg_scsi_id\');}' unless defined(&SG_GET_SCSI_ID);
    eval 'sub SG_SET_FORCE_LOW_DMA () { &_IOW( &SGIOC, 0x79, \'int\');}' unless defined(&SG_SET_FORCE_LOW_DMA);
    eval 'sub SG_GET_LOW_DMA () { &_IOR( &SGIOC, 0x7a, \'int\');}' unless defined(&SG_GET_LOW_DMA);
    eval 'sub SG_SET_FORCE_PACK_ID () { &_IOW( &SGIOC, 0x7b, \'int\');}' unless defined(&SG_SET_FORCE_PACK_ID);
    eval 'sub SG_GET_PACK_ID () { &_IOR( &SGIOC, 0x7c, \'int\');}' unless defined(&SG_GET_PACK_ID);
    eval 'sub SG_GET_NUM_WAITING () { &_IOR( &SGIOC, 0x7d, \'int\');}' unless defined(&SG_GET_NUM_WAITING);
    eval 'sub SG_SET_DEBUG () { &_IOW( &SGIOC, 0x7e, \'int\');}' unless defined(&SG_SET_DEBUG);
    eval 'sub SG_GET_SG_TABLESIZE () { &_IOR( &SGIOC, 0x7f, \'int\');}' unless defined(&SG_GET_SG_TABLESIZE);
    eval 'sub SG_GET_VERSION_NUM () { &_IOR( &SGIOC, 0x82, \'int\');}' unless defined(&SG_GET_VERSION_NUM);
    eval 'sub SG_NEXT_CMD_LEN () { &_IOW( &SGIOC, 0x83, \'int\');}' unless defined(&SG_NEXT_CMD_LEN);
    eval 'sub SG_SCSI_RESET () { &_IOW( &SGIOC, 0x84, \'int\');}' unless defined(&SG_SCSI_RESET);
    eval 'sub SG_IO () { &_IOWR( &SGIOC, 0x85, \'struct sg_io_hdr\');}' unless defined(&SG_IO);
    eval 'sub SG_GET_REQUEST_TABLE () { &_IO( &SGIOC, 0x86);}' unless defined(&SG_GET_REQUEST_TABLE);
    eval 'sub SG_SET_KEEP_ORPHAN () { &_IOW( &SGIOC, 0x87, \'int\');}' unless defined(&SG_SET_KEEP_ORPHAN);
    eval 'sub SG_GET_KEEP_ORPHAN () { &_IOR( &SGIOC, 0x88, \'int\');}' unless defined(&SG_GET_KEEP_ORPHAN);
    eval 'sub SG_GET_ACCESS_COUNT () { &_IOR( &SGIOC, 0x89, \'int\');}' unless defined(&SG_GET_ACCESS_COUNT);
    eval 'sub SG_DXFER_NONE () {-1;}' unless defined(&SG_DXFER_NONE);
    eval 'sub SG_DXFER_TO_DEV () {-2;}' unless defined(&SG_DXFER_TO_DEV);
    eval 'sub SG_DXFER_FROM_DEV () {-3;}' unless defined(&SG_DXFER_FROM_DEV);
    eval 'sub SG_DXFER_TO_FROM_DEV () {-4;}' unless defined(&SG_DXFER_TO_FROM_DEV);
    eval 'sub SG_DXFER_UNKNOWN () {-5;}' unless defined(&SG_DXFER_UNKNOWN);
    eval 'sub SG_MAX_SENSE () {16;}' unless defined(&SG_MAX_SENSE);
    eval 'sub DID_OK () {0x;}' unless defined(&DID_OK);
    eval 'sub DID_NO_CONNECT () {0x1;}' unless defined(&DID_NO_CONNECT);
    eval 'sub DID_BUS_BUSY () {0x2;}' unless defined(&DID_BUS_BUSY);
    eval 'sub DID_TIME_OUT () {0x3;}' unless defined(&DID_TIME_OUT);
    eval 'sub DID_BAD_TARGET () {0x4;}' unless defined(&DID_BAD_TARGET);
    eval 'sub DID_ABORT () {0x5;}' unless defined(&DID_ABORT);
    eval 'sub DID_PARITY () {0x6;}' unless defined(&DID_PARITY);
    eval 'sub DID_ERROR () {0x7;}' unless defined(&DID_ERROR);
    eval 'sub DID_RESET () {0x8;}' unless defined(&DID_RESET);
    eval 'sub DID_BAD_INTR () {0x9;}' unless defined(&DID_BAD_INTR);
    eval 'sub DID_PASSTHROUGH () {0xa;}' unless defined(&DID_PASSTHROUGH);
    eval 'sub DID_SOFT_ERROR () {0xb;}' unless defined(&DID_SOFT_ERROR);
    eval 'sub DID_IMM_RETRY () {0xc;}' unless defined(&DID_IMM_RETRY);
    eval 'sub DRIVER_OK () {0x;}' unless defined(&DRIVER_OK);
    eval 'sub DRIVER_BUSY () {0x1;}' unless defined(&DRIVER_BUSY);
    eval 'sub DRIVER_SOFT () {0x2;}' unless defined(&DRIVER_SOFT);
    eval 'sub DRIVER_MEDIA () {0x3;}' unless defined(&DRIVER_MEDIA);
    eval 'sub DRIVER_ERROR () {0x4;}' unless defined(&DRIVER_ERROR);
    eval 'sub DRIVER_INVALID () {0x5;}' unless defined(&DRIVER_INVALID);
    eval 'sub DRIVER_TIMEOUT () {0x6;}' unless defined(&DRIVER_TIMEOUT);
    eval 'sub DRIVER_HARD () {0x7;}' unless defined(&DRIVER_HARD);
    eval 'sub DRIVER_SENSE () {0x8;}' unless defined(&DRIVER_SENSE);
    eval 'sub SUGGEST_RETRY () {0x10;}' unless defined(&SUGGEST_RETRY);
    eval 'sub SUGGEST_ABORT () {0x20;}' unless defined(&SUGGEST_ABORT);
    eval 'sub SUGGEST_REMAP () {0x30;}' unless defined(&SUGGEST_REMAP);
    eval 'sub SUGGEST_DIE () {0x40;}' unless defined(&SUGGEST_DIE);
    eval 'sub SUGGEST_SENSE () {0x80;}' unless defined(&SUGGEST_SENSE);
    eval 'sub SUGGEST_IS_OK () {0xff;}' unless defined(&SUGGEST_IS_OK);
    eval 'sub DRIVER_MASK () {0xf;}' unless defined(&DRIVER_MASK);
    eval 'sub SUGGEST_MASK () {0xf0;}' unless defined(&SUGGEST_MASK);
    eval 'sub SG_DEFAULT_HZ () {1000;}' unless defined(&SG_DEFAULT_HZ);
    eval 'sub SG_DEFAULT_TIMEOUT () {(60* &SG_DEFAULT_HZ);}' unless defined(&SG_DEFAULT_TIMEOUT);
}
1;
