require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CRYPTO_XFORM_ENC_H_)) {
    eval 'sub _CRYPTO_XFORM_ENC_H_ () {1;}' unless defined(&_CRYPTO_XFORM_ENC_H_);
    require 'sys/malloc.ph';
    require 'sys/errno.ph';
    require 'crypto/blowfish/blowfish.ph';
    require 'crypto/des/des.ph';
    require 'crypto/rijndael/rijndael.ph';
    require 'crypto/camellia/camellia.ph';
    require 'opencrypto/cast.ph';
    require 'opencrypto/skipjack.ph';
    require 'opencrypto/cryptodev.ph';
    require 'opencrypto/xform_userland.ph';
    eval 'sub AESICM_BLOCKSIZE () { &AES_BLOCK_LEN;}' unless defined(&AESICM_BLOCKSIZE);
    eval 'sub AES_XTS_BLOCKSIZE () {16;}' unless defined(&AES_XTS_BLOCKSIZE);
    eval 'sub AES_XTS_IVSIZE () {8;}' unless defined(&AES_XTS_IVSIZE);
    eval 'sub AES_XTS_ALPHA () {0x87;}' unless defined(&AES_XTS_ALPHA);
}
1;
