require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CRYPTO_XFORM_USERLAND_H_)) {
    eval 'sub _CRYPTO_XFORM_USERLAND_H_ () {1;}' unless defined(&_CRYPTO_XFORM_USERLAND_H_);
    if(defined(&_KERNEL)) {
	require 'sys/systm.ph';
	eval 'sub KMALLOC {
	    my($size, $type, $flags) = @_;
    	    eval q( &malloc($size, $type, $flags));
	}' unless defined(&KMALLOC);
	eval 'sub KFREE {
	    my($ptr, $type) = @_;
    	    eval q( &free($ptr, $type));
	}' unless defined(&KFREE);
    } else {
	if(defined(&_STANDALONE)) {
	    require 'stand.ph';
	} else {
	    require 'stdlib.ph';
	    require 'string.ph';
	}
	eval 'sub KMALLOC {
	    my($size, $type, $flags) = @_;
    	    eval q( &malloc($size));
	}' unless defined(&KMALLOC);
	eval 'sub KFREE {
	    my($ptr, $type) = @_;
    	    eval q( &free($ptr));
	}' unless defined(&KFREE);
    }
}
1;
