require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__ACPI_HPET_H__)) {
    eval 'sub __ACPI_HPET_H__ () {1;}' unless defined(&__ACPI_HPET_H__);
    eval 'sub HPET_MEM_WIDTH () {0x400;}' unless defined(&HPET_MEM_WIDTH);
    eval 'sub HPET_CAPABILITIES () {0x;}' unless defined(&HPET_CAPABILITIES);
    eval 'sub HPET_CAP_VENDOR_ID () {0xffff0000;}' unless defined(&HPET_CAP_VENDOR_ID);
    eval 'sub HPET_CAP_LEG_RT () {0x8000;}' unless defined(&HPET_CAP_LEG_RT);
    eval 'sub HPET_CAP_COUNT_SIZE () {0x2000;}' unless defined(&HPET_CAP_COUNT_SIZE);
    eval 'sub HPET_CAP_NUM_TIM () {0x1f00;}' unless defined(&HPET_CAP_NUM_TIM);
    eval 'sub HPET_CAP_REV_ID () {0xff;}' unless defined(&HPET_CAP_REV_ID);
    eval 'sub HPET_PERIOD () {0x4;}' unless defined(&HPET_PERIOD);
    eval 'sub HPET_CONFIG () {0x10;}' unless defined(&HPET_CONFIG);
    eval 'sub HPET_CNF_LEG_RT () {0x2;}' unless defined(&HPET_CNF_LEG_RT);
    eval 'sub HPET_CNF_ENABLE () {0x1;}' unless defined(&HPET_CNF_ENABLE);
    eval 'sub HPET_ISR () {0x20;}' unless defined(&HPET_ISR);
    eval 'sub HPET_MAIN_COUNTER () {0xf0;}' unless defined(&HPET_MAIN_COUNTER);
    eval 'sub HPET_TIMER_CAP_CNF {
        my($x) = @_;
	    eval q((($x) * 0x20 + 0x100));
    }' unless defined(&HPET_TIMER_CAP_CNF);
    eval 'sub HPET_TCAP_INT_ROUTE () {0xffffffff00000000;}' unless defined(&HPET_TCAP_INT_ROUTE);
    eval 'sub HPET_TCAP_FSB_INT_DEL () {0x8000;}' unless defined(&HPET_TCAP_FSB_INT_DEL);
    eval 'sub HPET_TCNF_FSB_EN () {0x4000;}' unless defined(&HPET_TCNF_FSB_EN);
    eval 'sub HPET_TCNF_INT_ROUTE () {0x3e00;}' unless defined(&HPET_TCNF_INT_ROUTE);
    eval 'sub HPET_TCNF_32MODE () {0x100;}' unless defined(&HPET_TCNF_32MODE);
    eval 'sub HPET_TCNF_VAL_SET () {0x40;}' unless defined(&HPET_TCNF_VAL_SET);
    eval 'sub HPET_TCAP_SIZE () {0x20;}' unless defined(&HPET_TCAP_SIZE);
    eval 'sub HPET_TCAP_PER_INT () {0x10;}' unless defined(&HPET_TCAP_PER_INT);
    eval 'sub HPET_TCNF_TYPE () {0x8;}' unless defined(&HPET_TCNF_TYPE);
    eval 'sub HPET_TCNF_INT_ENB () {0x4;}' unless defined(&HPET_TCNF_INT_ENB);
    eval 'sub HPET_TCNF_INT_TYPE () {0x2;}' unless defined(&HPET_TCNF_INT_TYPE);
    eval 'sub HPET_TIMER_COMPARATOR {
        my($x) = @_;
	    eval q((($x) * 0x20 + 0x108));
    }' unless defined(&HPET_TIMER_COMPARATOR);
    eval 'sub HPET_TIMER_FSB_VAL {
        my($x) = @_;
	    eval q((($x) * 0x20 + 0x110));
    }' unless defined(&HPET_TIMER_FSB_VAL);
    eval 'sub HPET_TIMER_FSB_ADDR {
        my($x) = @_;
	    eval q((($x) * 0x20 + 0x114));
    }' unless defined(&HPET_TIMER_FSB_ADDR);
    eval 'sub HPET_MIN_CYCLES () {128;}' unless defined(&HPET_MIN_CYCLES);
    if(defined(&_KERNEL)) {
    }
}
1;
