require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ACPIIO_H_)) {
    eval 'sub _ACPIIO_H_ () {1;}' unless defined(&_ACPIIO_H_);
    eval 'sub ACPIIO_SETSLPSTATE () { &_IOW(ord(\'P\'), 3, \'int\');}' unless defined(&ACPIIO_SETSLPSTATE);
    eval 'sub ACPIIO_REQSLPSTATE () { &_IOW(ord(\'P\'), 4, \'int\');}' unless defined(&ACPIIO_REQSLPSTATE);
    eval 'sub ACPIIO_ACKSLPSTATE () { &_IOW(ord(\'P\'), 5, \'int\');}' unless defined(&ACPIIO_ACKSLPSTATE);
    eval 'sub ACPI_CMBAT_MAXSTRLEN () {32;}' unless defined(&ACPI_CMBAT_MAXSTRLEN);
    eval 'sub ACPI_BIF_UNITS_MW () {0;}' unless defined(&ACPI_BIF_UNITS_MW);
    eval 'sub ACPI_BIF_UNITS_MA () {1;}' unless defined(&ACPI_BIF_UNITS_MA);
    eval 'sub ACPI_BATT_STAT_DISCHARG () {0x1;}' unless defined(&ACPI_BATT_STAT_DISCHARG);
    eval 'sub ACPI_BATT_STAT_CHARGING () {0x2;}' unless defined(&ACPI_BATT_STAT_CHARGING);
    eval 'sub ACPI_BATT_STAT_CRITICAL () {0x4;}' unless defined(&ACPI_BATT_STAT_CRITICAL);
    eval 'sub ACPI_BATT_STAT_INVALID () {( &ACPI_BATT_STAT_DISCHARG |  &ACPI_BATT_STAT_CHARGING);}' unless defined(&ACPI_BATT_STAT_INVALID);
    eval 'sub ACPI_BATT_STAT_BST_MASK () {( &ACPI_BATT_STAT_INVALID |  &ACPI_BATT_STAT_CRITICAL);}' unless defined(&ACPI_BATT_STAT_BST_MASK);
    eval 'sub ACPI_BATT_STAT_NOT_PRESENT () { &ACPI_BATT_STAT_BST_MASK;}' unless defined(&ACPI_BATT_STAT_NOT_PRESENT);
    eval 'sub ACPI_BATTERY_ALL_UNITS () {(-1);}' unless defined(&ACPI_BATTERY_ALL_UNITS);
    eval 'sub ACPI_BATT_UNKNOWN () {0xffffffff;}' unless defined(&ACPI_BATT_UNKNOWN);
    eval 'sub ACPIIO_BATT_GET_UNITS () { &_IOR(ord(\'B\'), 0x1, \'int\');}' unless defined(&ACPIIO_BATT_GET_UNITS);
    eval 'sub ACPIIO_BATT_GET_BATTINFO () { &_IOWR(ord(\'B\'), 0x3, \'union acpi_battery_ioctl_arg\');}' unless defined(&ACPIIO_BATT_GET_BATTINFO);
    eval 'sub ACPIIO_BATT_GET_BIF () { &_IOWR(ord(\'B\'), 0x10, \'union acpi_battery_ioctl_arg\');}' unless defined(&ACPIIO_BATT_GET_BIF);
    eval 'sub ACPIIO_BATT_GET_BST () { &_IOWR(ord(\'B\'), 0x11, \'union acpi_battery_ioctl_arg\');}' unless defined(&ACPIIO_BATT_GET_BST);
    eval 'sub ACPIIO_CMBAT_GET_BIF () { &ACPIIO_BATT_GET_BIF;}' unless defined(&ACPIIO_CMBAT_GET_BIF);
    eval 'sub ACPIIO_CMBAT_GET_BST () { &ACPIIO_BATT_GET_BST;}' unless defined(&ACPIIO_CMBAT_GET_BST);
    eval 'sub ACPIIO_ACAD_GET_STATUS () { &_IOR(ord(\'A\'), 1, \'int\');}' unless defined(&ACPIIO_ACAD_GET_STATUS);
    if(defined(&_KERNEL)) {
    }
}
1;
