require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_PCI_AGPREG_H_)) {
    eval 'sub _PCI_AGPREG_H_ () {1;}' unless defined(&_PCI_AGPREG_H_);
    eval 'sub AGP_APBASE () { &PCIR_BAR(0);}' unless defined(&AGP_APBASE);
    eval 'sub AGP_CAPID () {0x;}' unless defined(&AGP_CAPID);
    eval 'sub AGP_STATUS () {0x4;}' unless defined(&AGP_STATUS);
    eval 'sub AGP_COMMAND () {0x8;}' unless defined(&AGP_COMMAND);
    eval 'sub AGP_STATUS_AGP3 () {0x8;}' unless defined(&AGP_STATUS_AGP3);
    eval 'sub AGP_STATUS_RQ_MASK () {0xff000000;}' unless defined(&AGP_STATUS_RQ_MASK);
    eval 'sub AGP_COMMAND_RQ_MASK () {0xff000000;}' unless defined(&AGP_COMMAND_RQ_MASK);
    eval 'sub AGP_STATUS_ARQSZ_MASK () {0xe000;}' unless defined(&AGP_STATUS_ARQSZ_MASK);
    eval 'sub AGP_COMMAND_ARQSZ_MASK () {0xe000;}' unless defined(&AGP_COMMAND_ARQSZ_MASK);
    eval 'sub AGP_STATUS_CAL_MASK () {0x1c00;}' unless defined(&AGP_STATUS_CAL_MASK);
    eval 'sub AGP_COMMAND_CAL_MASK () {0x1c00;}' unless defined(&AGP_COMMAND_CAL_MASK);
    eval 'sub AGP_STATUS_ISOCH () {0x10000;}' unless defined(&AGP_STATUS_ISOCH);
    eval 'sub AGP_STATUS_SBA () {0x200;}' unless defined(&AGP_STATUS_SBA);
    eval 'sub AGP_STATUS_ITA_COH () {0x100;}' unless defined(&AGP_STATUS_ITA_COH);
    eval 'sub AGP_STATUS_GART64 () {0x80;}' unless defined(&AGP_STATUS_GART64);
    eval 'sub AGP_STATUS_HTRANS () {0x40;}' unless defined(&AGP_STATUS_HTRANS);
    eval 'sub AGP_STATUS_64BIT () {0x20;}' unless defined(&AGP_STATUS_64BIT);
    eval 'sub AGP_STATUS_FW () {0x10;}' unless defined(&AGP_STATUS_FW);
    eval 'sub AGP_COMMAND_RQ_MASK () {0xff000000;}' unless defined(&AGP_COMMAND_RQ_MASK);
    eval 'sub AGP_COMMAND_ARQSZ_MASK () {0xe000;}' unless defined(&AGP_COMMAND_ARQSZ_MASK);
    eval 'sub AGP_COMMAND_CAL_MASK () {0x1c00;}' unless defined(&AGP_COMMAND_CAL_MASK);
    eval 'sub AGP_COMMAND_SBA () {0x200;}' unless defined(&AGP_COMMAND_SBA);
    eval 'sub AGP_COMMAND_AGP () {0x100;}' unless defined(&AGP_COMMAND_AGP);
    eval 'sub AGP_COMMAND_GART64 () {0x80;}' unless defined(&AGP_COMMAND_GART64);
    eval 'sub AGP_COMMAND_64BIT () {0x20;}' unless defined(&AGP_COMMAND_64BIT);
    eval 'sub AGP_COMMAND_FW () {0x10;}' unless defined(&AGP_COMMAND_FW);
    eval 'sub AGP_INTEL_NBXCFG () {0x50;}' unless defined(&AGP_INTEL_NBXCFG);
    eval 'sub AGP_INTEL_ERRSTS () {0x91;}' unless defined(&AGP_INTEL_ERRSTS);
    eval 'sub AGP_INTEL_AGPCTRL () {0xb0;}' unless defined(&AGP_INTEL_AGPCTRL);
    eval 'sub AGP_INTEL_APSIZE () {0xb4;}' unless defined(&AGP_INTEL_APSIZE);
    eval 'sub AGP_INTEL_ATTBASE () {0xb8;}' unless defined(&AGP_INTEL_ATTBASE);
    eval 'sub AGP_INTEL_MCHCFG () {0x50;}' unless defined(&AGP_INTEL_MCHCFG);
    eval 'sub AGP_INTEL_I820_RDCR () {0x51;}' unless defined(&AGP_INTEL_I820_RDCR);
    eval 'sub AGP_INTEL_I845_AGPM () {0x51;}' unless defined(&AGP_INTEL_I845_AGPM);
    eval 'sub AGP_INTEL_I8XX_ERRSTS () {0xc8;}' unless defined(&AGP_INTEL_I8XX_ERRSTS);
    eval 'sub AGP_VIA_GARTCTRL () {0x80;}' unless defined(&AGP_VIA_GARTCTRL);
    eval 'sub AGP_VIA_APSIZE () {0x84;}' unless defined(&AGP_VIA_APSIZE);
    eval 'sub AGP_VIA_ATTBASE () {0x88;}' unless defined(&AGP_VIA_ATTBASE);
    eval 'sub AGP3_VIA_GARTCTRL () {0x90;}' unless defined(&AGP3_VIA_GARTCTRL);
    eval 'sub AGP3_VIA_APSIZE () {0x94;}' unless defined(&AGP3_VIA_APSIZE);
    eval 'sub AGP3_VIA_ATTBASE () {0x98;}' unless defined(&AGP3_VIA_ATTBASE);
    eval 'sub AGP_VIA_AGPSEL () {0xfd;}' unless defined(&AGP_VIA_AGPSEL);
    eval 'sub AGP_SIS_ATTBASE () {0x90;}' unless defined(&AGP_SIS_ATTBASE);
    eval 'sub AGP_SIS_WINCTRL () {0x94;}' unless defined(&AGP_SIS_WINCTRL);
    eval 'sub AGP_SIS_TLBCTRL () {0x97;}' unless defined(&AGP_SIS_TLBCTRL);
    eval 'sub AGP_SIS_TLBFLUSH () {0x98;}' unless defined(&AGP_SIS_TLBFLUSH);
    eval 'sub AGP_ALI_AGPCTRL () {0xb8;}' unless defined(&AGP_ALI_AGPCTRL);
    eval 'sub AGP_ALI_ATTBASE () {0xbc;}' unless defined(&AGP_ALI_ATTBASE);
    eval 'sub AGP_ALI_TLBCTRL () {0xc0;}' unless defined(&AGP_ALI_TLBCTRL);
    eval 'sub AGP_AMD751_APBASE () {0x10;}' unless defined(&AGP_AMD751_APBASE);
    eval 'sub AGP_AMD751_REGISTERS () {0x14;}' unless defined(&AGP_AMD751_REGISTERS);
    eval 'sub AGP_AMD751_APCTRL () {0xac;}' unless defined(&AGP_AMD751_APCTRL);
    eval 'sub AGP_AMD751_MODECTRL () {0xb0;}' unless defined(&AGP_AMD751_MODECTRL);
    eval 'sub AGP_AMD751_MODECTRL_SYNEN () {0x80;}' unless defined(&AGP_AMD751_MODECTRL_SYNEN);
    eval 'sub AGP_AMD751_MODECTRL2 () {0xb2;}' unless defined(&AGP_AMD751_MODECTRL2);
    eval 'sub AGP_AMD751_MODECTRL2_G1LM () {0x1;}' unless defined(&AGP_AMD751_MODECTRL2_G1LM);
    eval 'sub AGP_AMD751_MODECTRL2_GPDCE () {0x2;}' unless defined(&AGP_AMD751_MODECTRL2_GPDCE);
    eval 'sub AGP_AMD751_MODECTRL2_NGSE () {0x8;}' unless defined(&AGP_AMD751_MODECTRL2_NGSE);
    eval 'sub AGP_AMD751_CAPS () {0x;}' unless defined(&AGP_AMD751_CAPS);
    eval 'sub AGP_AMD751_CAPS_EHI () {0x800;}' unless defined(&AGP_AMD751_CAPS_EHI);
    eval 'sub AGP_AMD751_CAPS_P2P () {0x400;}' unless defined(&AGP_AMD751_CAPS_P2P);
    eval 'sub AGP_AMD751_CAPS_MPC () {0x200;}' unless defined(&AGP_AMD751_CAPS_MPC);
    eval 'sub AGP_AMD751_CAPS_VBE () {0x100;}' unless defined(&AGP_AMD751_CAPS_VBE);
    eval 'sub AGP_AMD751_CAPS_REV () {0xff;}' unless defined(&AGP_AMD751_CAPS_REV);
    eval 'sub AGP_AMD751_STATUS () {0x2;}' unless defined(&AGP_AMD751_STATUS);
    eval 'sub AGP_AMD751_STATUS_P2PS () {0x800;}' unless defined(&AGP_AMD751_STATUS_P2PS);
    eval 'sub AGP_AMD751_STATUS_GCS () {0x400;}' unless defined(&AGP_AMD751_STATUS_GCS);
    eval 'sub AGP_AMD751_STATUS_MPS () {0x200;}' unless defined(&AGP_AMD751_STATUS_MPS);
    eval 'sub AGP_AMD751_STATUS_VBES () {0x100;}' unless defined(&AGP_AMD751_STATUS_VBES);
    eval 'sub AGP_AMD751_STATUS_P2PE () {0x8;}' unless defined(&AGP_AMD751_STATUS_P2PE);
    eval 'sub AGP_AMD751_STATUS_GCE () {0x4;}' unless defined(&AGP_AMD751_STATUS_GCE);
    eval 'sub AGP_AMD751_STATUS_VBEE () {0x1;}' unless defined(&AGP_AMD751_STATUS_VBEE);
    eval 'sub AGP_AMD751_ATTBASE () {0x4;}' unless defined(&AGP_AMD751_ATTBASE);
    eval 'sub AGP_AMD751_TLBCTRL () {0xc;}' unless defined(&AGP_AMD751_TLBCTRL);
    eval 'sub AGP_I810_SMRAM () {0x70;}' unless defined(&AGP_I810_SMRAM);
    eval 'sub AGP_I810_SMRAM_GMS () {0xc0;}' unless defined(&AGP_I810_SMRAM_GMS);
    eval 'sub AGP_I810_SMRAM_GMS_DISABLED () {0x;}' unless defined(&AGP_I810_SMRAM_GMS_DISABLED);
    eval 'sub AGP_I810_SMRAM_GMS_ENABLED_0 () {0x40;}' unless defined(&AGP_I810_SMRAM_GMS_ENABLED_0);
    eval 'sub AGP_I810_SMRAM_GMS_ENABLED_512 () {0x80;}' unless defined(&AGP_I810_SMRAM_GMS_ENABLED_512);
    eval 'sub AGP_I810_SMRAM_GMS_ENABLED_1024 () {0xc0;}' unless defined(&AGP_I810_SMRAM_GMS_ENABLED_1024);
    eval 'sub AGP_I810_MISCC () {0x72;}' unless defined(&AGP_I810_MISCC);
    eval 'sub AGP_I810_MISCC_WINSIZE () {0x1;}' unless defined(&AGP_I810_MISCC_WINSIZE);
    eval 'sub AGP_I810_MISCC_WINSIZE_64 () {0x;}' unless defined(&AGP_I810_MISCC_WINSIZE_64);
    eval 'sub AGP_I810_MISCC_WINSIZE_32 () {0x1;}' unless defined(&AGP_I810_MISCC_WINSIZE_32);
    eval 'sub AGP_I810_MISCC_PLCK () {0x8;}' unless defined(&AGP_I810_MISCC_PLCK);
    eval 'sub AGP_I810_MISCC_PLCK_UNLOCKED () {0x;}' unless defined(&AGP_I810_MISCC_PLCK_UNLOCKED);
    eval 'sub AGP_I810_MISCC_PLCK_LOCKED () {0x8;}' unless defined(&AGP_I810_MISCC_PLCK_LOCKED);
    eval 'sub AGP_I810_MISCC_WPTC () {0x30;}' unless defined(&AGP_I810_MISCC_WPTC);
    eval 'sub AGP_I810_MISCC_WPTC_NOLIMIT () {0x;}' unless defined(&AGP_I810_MISCC_WPTC_NOLIMIT);
    eval 'sub AGP_I810_MISCC_WPTC_62 () {0x10;}' unless defined(&AGP_I810_MISCC_WPTC_62);
    eval 'sub AGP_I810_MISCC_WPTC_50 () {0x20;}' unless defined(&AGP_I810_MISCC_WPTC_50);
    eval 'sub AGP_I810_MISCC_WPTC_37 () {0x30;}' unless defined(&AGP_I810_MISCC_WPTC_37);
    eval 'sub AGP_I810_MISCC_RPTC () {0xc0;}' unless defined(&AGP_I810_MISCC_RPTC);
    eval 'sub AGP_I810_MISCC_RPTC_NOLIMIT () {0x;}' unless defined(&AGP_I810_MISCC_RPTC_NOLIMIT);
    eval 'sub AGP_I810_MISCC_RPTC_62 () {0x40;}' unless defined(&AGP_I810_MISCC_RPTC_62);
    eval 'sub AGP_I810_MISCC_RPTC_50 () {0x80;}' unless defined(&AGP_I810_MISCC_RPTC_50);
    eval 'sub AGP_I810_MISCC_RPTC_37 () {0xc0;}' unless defined(&AGP_I810_MISCC_RPTC_37);
    eval 'sub AGP_I810_GMADR () {0x10;}' unless defined(&AGP_I810_GMADR);
    eval 'sub AGP_I810_MMADR () {0x14;}' unless defined(&AGP_I810_MMADR);
    eval 'sub I810_PTE_VALID () {0x1;}' unless defined(&I810_PTE_VALID);
    eval 'sub I810_PTE_MAIN_UNCACHED () {0x;}' unless defined(&I810_PTE_MAIN_UNCACHED);
    eval 'sub I810_PTE_LOCAL () {0x2;}' unless defined(&I810_PTE_LOCAL);
    eval 'sub I830_PTE_SYSTEM_CACHED () {0x6;}' unless defined(&I830_PTE_SYSTEM_CACHED);
    eval 'sub GEN6_PTE_RESERVED () {0x;}' unless defined(&GEN6_PTE_RESERVED);
    eval 'sub GEN6_PTE_UNCACHED () {0x2;}' unless defined(&GEN6_PTE_UNCACHED);
    eval 'sub GEN6_PTE_LLC () {0x4;}' unless defined(&GEN6_PTE_LLC);
    eval 'sub GEN6_PTE_LLC_MLC () {0x6;}' unless defined(&GEN6_PTE_LLC_MLC);
    eval 'sub GEN6_PTE_GFDT () {0x8;}' unless defined(&GEN6_PTE_GFDT);
    eval 'sub AGP_I810_PGTBL_CTL () {0x2020;}' unless defined(&AGP_I810_PGTBL_CTL);
    eval 'sub AGP_I810_PGTBL_ENABLED () {0x1;}' unless defined(&AGP_I810_PGTBL_ENABLED);
    eval 'sub AGP_I810_PGTBL_SIZE_MASK () {0xe;}' unless defined(&AGP_I810_PGTBL_SIZE_MASK);
    eval 'sub AGP_I810_PGTBL_SIZE_512KB () {(0<< 1);}' unless defined(&AGP_I810_PGTBL_SIZE_512KB);
    eval 'sub AGP_I810_PGTBL_SIZE_256KB () {(1<< 1);}' unless defined(&AGP_I810_PGTBL_SIZE_256KB);
    eval 'sub AGP_I810_PGTBL_SIZE_128KB () {(2<< 1);}' unless defined(&AGP_I810_PGTBL_SIZE_128KB);
    eval 'sub AGP_I810_PGTBL_SIZE_1MB () {(3<< 1);}' unless defined(&AGP_I810_PGTBL_SIZE_1MB);
    eval 'sub AGP_I810_PGTBL_SIZE_2MB () {(4<< 1);}' unless defined(&AGP_I810_PGTBL_SIZE_2MB);
    eval 'sub AGP_I810_PGTBL_SIZE_1_5MB () {(5<< 1);}' unless defined(&AGP_I810_PGTBL_SIZE_1_5MB);
    eval 'sub AGP_G33_GCC1_SIZE_MASK () {(3<< 8);}' unless defined(&AGP_G33_GCC1_SIZE_MASK);
    eval 'sub AGP_G33_GCC1_SIZE_1M () {(1<< 8);}' unless defined(&AGP_G33_GCC1_SIZE_1M);
    eval 'sub AGP_G33_GCC1_SIZE_2M () {(2<< 8);}' unless defined(&AGP_G33_GCC1_SIZE_2M);
    eval 'sub AGP_G4x_GCC1_SIZE_MASK () {(0xf << 8);}' unless defined(&AGP_G4x_GCC1_SIZE_MASK);
    eval 'sub AGP_G4x_GCC1_SIZE_1M () {(0x1 << 8);}' unless defined(&AGP_G4x_GCC1_SIZE_1M);
    eval 'sub AGP_G4x_GCC1_SIZE_2M () {(0x3 << 8);}' unless defined(&AGP_G4x_GCC1_SIZE_2M);
    eval 'sub AGP_G4x_GCC1_SIZE_VT_EN () {(0x8 << 8);}' unless defined(&AGP_G4x_GCC1_SIZE_VT_EN);
    eval 'sub AGP_G4x_GCC1_SIZE_VT_1M () {( &AGP_G4x_GCC1_SIZE_1M |  &AGP_G4x_GCC1_SIZE_VT_EN);}' unless defined(&AGP_G4x_GCC1_SIZE_VT_1M);
    eval 'sub AGP_G4x_GCC1_SIZE_VT_1_5M () {((0x2 << 8) |  &AGP_G4x_GCC1_SIZE_VT_EN);}' unless defined(&AGP_G4x_GCC1_SIZE_VT_1_5M);
    eval 'sub AGP_G4x_GCC1_SIZE_VT_2M () {( &AGP_G4x_GCC1_SIZE_2M |  &AGP_G4x_GCC1_SIZE_VT_EN);}' unless defined(&AGP_G4x_GCC1_SIZE_VT_2M);
    eval 'sub AGP_I810_DRT () {0x3000;}' unless defined(&AGP_I810_DRT);
    eval 'sub AGP_I810_DRT_UNPOPULATED () {0x;}' unless defined(&AGP_I810_DRT_UNPOPULATED);
    eval 'sub AGP_I810_DRT_POPULATED () {0x1;}' unless defined(&AGP_I810_DRT_POPULATED);
    eval 'sub AGP_I810_GTT () {0x10000;}' unless defined(&AGP_I810_GTT);
    eval 'sub AGP_I830_GCC1 () {0x52;}' unless defined(&AGP_I830_GCC1);
    eval 'sub AGP_I830_GCC1_DEV2 () {0x8;}' unless defined(&AGP_I830_GCC1_DEV2);
    eval 'sub AGP_I830_GCC1_DEV2_ENABLED () {0x;}' unless defined(&AGP_I830_GCC1_DEV2_ENABLED);
    eval 'sub AGP_I830_GCC1_DEV2_DISABLED () {0x8;}' unless defined(&AGP_I830_GCC1_DEV2_DISABLED);
    eval 'sub AGP_I830_GCC1_GMS () {0xf0;}' unless defined(&AGP_I830_GCC1_GMS);
    eval 'sub AGP_I830_GCC1_GMS_STOLEN_512 () {0x20;}' unless defined(&AGP_I830_GCC1_GMS_STOLEN_512);
    eval 'sub AGP_I830_GCC1_GMS_STOLEN_1024 () {0x30;}' unless defined(&AGP_I830_GCC1_GMS_STOLEN_1024);
    eval 'sub AGP_I830_GCC1_GMS_STOLEN_8192 () {0x40;}' unless defined(&AGP_I830_GCC1_GMS_STOLEN_8192);
    eval 'sub AGP_I830_GCC1_GMASIZE () {0x1;}' unless defined(&AGP_I830_GCC1_GMASIZE);
    eval 'sub AGP_I830_GCC1_GMASIZE_64 () {0x1;}' unless defined(&AGP_I830_GCC1_GMASIZE_64);
    eval 'sub AGP_I830_GCC1_GMASIZE_128 () {0x;}' unless defined(&AGP_I830_GCC1_GMASIZE_128);
    eval 'sub AGP_I830_HIC () {0x70;}' unless defined(&AGP_I830_HIC);
    eval 'sub AGP_I855_GCC1 () {0x52;}' unless defined(&AGP_I855_GCC1);
    eval 'sub AGP_I855_GCC1_DEV2 () {0x8;}' unless defined(&AGP_I855_GCC1_DEV2);
    eval 'sub AGP_I855_GCC1_DEV2_ENABLED () {0x;}' unless defined(&AGP_I855_GCC1_DEV2_ENABLED);
    eval 'sub AGP_I855_GCC1_DEV2_DISABLED () {0x8;}' unless defined(&AGP_I855_GCC1_DEV2_DISABLED);
    eval 'sub AGP_I855_GCC1_GMS () {0xf0;}' unless defined(&AGP_I855_GCC1_GMS);
    eval 'sub AGP_I855_GCC1_GMS_STOLEN_0M () {0x;}' unless defined(&AGP_I855_GCC1_GMS_STOLEN_0M);
    eval 'sub AGP_I855_GCC1_GMS_STOLEN_1M () {0x10;}' unless defined(&AGP_I855_GCC1_GMS_STOLEN_1M);
    eval 'sub AGP_I855_GCC1_GMS_STOLEN_4M () {0x20;}' unless defined(&AGP_I855_GCC1_GMS_STOLEN_4M);
    eval 'sub AGP_I855_GCC1_GMS_STOLEN_8M () {0x30;}' unless defined(&AGP_I855_GCC1_GMS_STOLEN_8M);
    eval 'sub AGP_I855_GCC1_GMS_STOLEN_16M () {0x40;}' unless defined(&AGP_I855_GCC1_GMS_STOLEN_16M);
    eval 'sub AGP_I855_GCC1_GMS_STOLEN_32M () {0x50;}' unless defined(&AGP_I855_GCC1_GMS_STOLEN_32M);
    eval 'sub AGP_I85X_CAPID () {0x44;}' unless defined(&AGP_I85X_CAPID);
    eval 'sub AGP_I85X_VARIANT_MASK () {0x7;}' unless defined(&AGP_I85X_VARIANT_MASK);
    eval 'sub AGP_I85X_VARIANT_SHIFT () {5;}' unless defined(&AGP_I85X_VARIANT_SHIFT);
    eval 'sub AGP_I855_GME () {0x;}' unless defined(&AGP_I855_GME);
    eval 'sub AGP_I855_GM () {0x4;}' unless defined(&AGP_I855_GM);
    eval 'sub AGP_I852_GME () {0x2;}' unless defined(&AGP_I852_GME);
    eval 'sub AGP_I852_GM () {0x5;}' unless defined(&AGP_I852_GM);
    eval 'sub AGP_I915_GMADR () {0x18;}' unless defined(&AGP_I915_GMADR);
    eval 'sub AGP_I915_MMADR () {0x10;}' unless defined(&AGP_I915_MMADR);
    eval 'sub AGP_I915_GTTADR () {0x1c;}' unless defined(&AGP_I915_GTTADR);
    eval 'sub AGP_I915_GCC1_GMS_STOLEN_48M () {0x60;}' unless defined(&AGP_I915_GCC1_GMS_STOLEN_48M);
    eval 'sub AGP_I915_GCC1_GMS_STOLEN_64M () {0x70;}' unless defined(&AGP_I915_GCC1_GMS_STOLEN_64M);
    eval 'sub AGP_I915_DEVEN () {0x54;}' unless defined(&AGP_I915_DEVEN);
    eval 'sub AGP_SB_DEVEN_D2EN () {0x10;}' unless defined(&AGP_SB_DEVEN_D2EN);
    eval 'sub AGP_SB_DEVEN_D2EN_ENABLED () {0x10;}' unless defined(&AGP_SB_DEVEN_D2EN_ENABLED);
    eval 'sub AGP_SB_DEVEN_D2EN_DISABLED () {0x;}' unless defined(&AGP_SB_DEVEN_D2EN_DISABLED);
    eval 'sub AGP_I915_DEVEN_D2F0 () {0x8;}' unless defined(&AGP_I915_DEVEN_D2F0);
    eval 'sub AGP_I915_DEVEN_D2F0_ENABLED () {0x8;}' unless defined(&AGP_I915_DEVEN_D2F0_ENABLED);
    eval 'sub AGP_I915_DEVEN_D2F0_DISABLED () {0x;}' unless defined(&AGP_I915_DEVEN_D2F0_DISABLED);
    eval 'sub AGP_I915_MSAC () {0x62;}' unless defined(&AGP_I915_MSAC);
    eval 'sub AGP_I915_MSAC_GMASIZE () {0x2;}' unless defined(&AGP_I915_MSAC_GMASIZE);
    eval 'sub AGP_I915_MSAC_GMASIZE_128 () {0x2;}' unless defined(&AGP_I915_MSAC_GMASIZE_128);
    eval 'sub AGP_I915_MSAC_GMASIZE_256 () {0x;}' unless defined(&AGP_I915_MSAC_GMASIZE_256);
    eval 'sub AGP_I915_IFPADDR () {0x60;}' unless defined(&AGP_I915_IFPADDR);
    eval 'sub AGP_G33_MGGC_GGMS_MASK () {(3<< 8);}' unless defined(&AGP_G33_MGGC_GGMS_MASK);
    eval 'sub AGP_G33_MGGC_GGMS_SIZE_1M () {(1<< 8);}' unless defined(&AGP_G33_MGGC_GGMS_SIZE_1M);
    eval 'sub AGP_G33_MGGC_GGMS_SIZE_2M () {(2<< 8);}' unless defined(&AGP_G33_MGGC_GGMS_SIZE_2M);
    eval 'sub AGP_G33_GCC1_GMS_STOLEN_128M () {0x80;}' unless defined(&AGP_G33_GCC1_GMS_STOLEN_128M);
    eval 'sub AGP_G33_GCC1_GMS_STOLEN_256M () {0x90;}' unless defined(&AGP_G33_GCC1_GMS_STOLEN_256M);
    eval 'sub AGP_I965_GTTMMADR () {0x10;}' unless defined(&AGP_I965_GTTMMADR);
    eval 'sub AGP_I965_APBASE () {0x18;}' unless defined(&AGP_I965_APBASE);
    eval 'sub AGP_I965_MSAC () {0x62;}' unless defined(&AGP_I965_MSAC);
    eval 'sub AGP_I965_MSAC_GMASIZE_128 () {0x;}' unless defined(&AGP_I965_MSAC_GMASIZE_128);
    eval 'sub AGP_I965_MSAC_GMASIZE_256 () {0x2;}' unless defined(&AGP_I965_MSAC_GMASIZE_256);
    eval 'sub AGP_I965_MSAC_GMASIZE_512 () {0x6;}' unless defined(&AGP_I965_MSAC_GMASIZE_512);
    eval 'sub AGP_I965_PGTBL_SIZE_1MB () {(3<< 1);}' unless defined(&AGP_I965_PGTBL_SIZE_1MB);
    eval 'sub AGP_I965_PGTBL_SIZE_2MB () {(4<< 1);}' unless defined(&AGP_I965_PGTBL_SIZE_2MB);
    eval 'sub AGP_I965_PGTBL_SIZE_1_5MB () {(5<< 1);}' unless defined(&AGP_I965_PGTBL_SIZE_1_5MB);
    eval 'sub AGP_I965_PGTBL_CTL2 () {0x20c4;}' unless defined(&AGP_I965_PGTBL_CTL2);
    eval 'sub AGP_I965_IFPADDR () {0x70;}' unless defined(&AGP_I965_IFPADDR);
    eval 'sub AGP_G4X_GCC1_GMS_STOLEN_96M () {0xa0;}' unless defined(&AGP_G4X_GCC1_GMS_STOLEN_96M);
    eval 'sub AGP_G4X_GCC1_GMS_STOLEN_160M () {0xb0;}' unless defined(&AGP_G4X_GCC1_GMS_STOLEN_160M);
    eval 'sub AGP_G4X_GCC1_GMS_STOLEN_224M () {0xc0;}' unless defined(&AGP_G4X_GCC1_GMS_STOLEN_224M);
    eval 'sub AGP_G4X_GCC1_GMS_STOLEN_352M () {0xd0;}' unless defined(&AGP_G4X_GCC1_GMS_STOLEN_352M);
    eval 'sub AGP_SNB_GCC1 () {0x50;}' unless defined(&AGP_SNB_GCC1);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_MASK () {0xf8;}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_MASK);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_32M () {(1<< 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_32M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_64M () {(2<< 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_64M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_96M () {(3<< 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_96M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_128M () {(4<< 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_128M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_160M () {(5<< 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_160M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_192M () {(6<< 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_192M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_224M () {(7<< 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_224M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_256M () {(8<< 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_256M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_288M () {(9<< 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_288M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_320M () {(0xa << 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_320M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_352M () {(0xb << 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_352M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_384M () {(0xc << 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_384M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_416M () {(0xd << 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_416M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_448M () {(0xe << 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_448M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_480M () {(0xf << 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_480M);
    eval 'sub AGP_SNB_GMCH_GMS_STOLEN_512M () {(0x10 << 3);}' unless defined(&AGP_SNB_GMCH_GMS_STOLEN_512M);
    eval 'sub AGP_SNB_GTT_SIZE_0M () {(0<< 8);}' unless defined(&AGP_SNB_GTT_SIZE_0M);
    eval 'sub AGP_SNB_GTT_SIZE_1M () {(1<< 8);}' unless defined(&AGP_SNB_GTT_SIZE_1M);
    eval 'sub AGP_SNB_GTT_SIZE_2M () {(2<< 8);}' unless defined(&AGP_SNB_GTT_SIZE_2M);
    eval 'sub AGP_SNB_GTT_SIZE_MASK () {(3<< 8);}' unless defined(&AGP_SNB_GTT_SIZE_MASK);
    eval 'sub AGP_SNB_GFX_MODE () {0x2520;}' unless defined(&AGP_SNB_GFX_MODE);
    eval 'sub AGP_NVIDIA_0_APBASE () {0x10;}' unless defined(&AGP_NVIDIA_0_APBASE);
    eval 'sub AGP_NVIDIA_0_APSIZE () {0x80;}' unless defined(&AGP_NVIDIA_0_APSIZE);
    eval 'sub AGP_NVIDIA_1_WBC () {0xf0;}' unless defined(&AGP_NVIDIA_1_WBC);
    eval 'sub AGP_NVIDIA_2_GARTCTRL () {0xd0;}' unless defined(&AGP_NVIDIA_2_GARTCTRL);
    eval 'sub AGP_NVIDIA_2_APBASE () {0xd8;}' unless defined(&AGP_NVIDIA_2_APBASE);
    eval 'sub AGP_NVIDIA_2_APLIMIT () {0xdc;}' unless defined(&AGP_NVIDIA_2_APLIMIT);
    eval 'sub AGP_NVIDIA_2_ATTBASE {
        my($i) = @_;
	    eval q((0xe0 + ($i) * 4));
    }' unless defined(&AGP_NVIDIA_2_ATTBASE);
    eval 'sub AGP_NVIDIA_3_APBASE () {0x50;}' unless defined(&AGP_NVIDIA_3_APBASE);
    eval 'sub AGP_NVIDIA_3_APLIMIT () {0x54;}' unless defined(&AGP_NVIDIA_3_APLIMIT);
    eval 'sub AGP_AMD64_APCTRL () {0x90;}' unless defined(&AGP_AMD64_APCTRL);
    eval 'sub AGP_AMD64_APBASE () {0x94;}' unless defined(&AGP_AMD64_APBASE);
    eval 'sub AGP_AMD64_ATTBASE () {0x98;}' unless defined(&AGP_AMD64_ATTBASE);
    eval 'sub AGP_AMD64_CACHECTRL () {0x9c;}' unless defined(&AGP_AMD64_CACHECTRL);
    eval 'sub AGP_AMD64_APCTRL_GARTEN () {0x1;}' unless defined(&AGP_AMD64_APCTRL_GARTEN);
    eval 'sub AGP_AMD64_APCTRL_SIZE_MASK () {0xe;}' unless defined(&AGP_AMD64_APCTRL_SIZE_MASK);
    eval 'sub AGP_AMD64_APCTRL_DISGARTCPU () {0x10;}' unless defined(&AGP_AMD64_APCTRL_DISGARTCPU);
    eval 'sub AGP_AMD64_APCTRL_DISGARTIO () {0x20;}' unless defined(&AGP_AMD64_APCTRL_DISGARTIO);
    eval 'sub AGP_AMD64_APCTRL_DISWLKPRB () {0x40;}' unless defined(&AGP_AMD64_APCTRL_DISWLKPRB);
    eval 'sub AGP_AMD64_APBASE_MASK () {0x7fff;}' unless defined(&AGP_AMD64_APBASE_MASK);
    eval 'sub AGP_AMD64_ATTBASE_MASK () {0xfffffff0;}' unless defined(&AGP_AMD64_ATTBASE_MASK);
    eval 'sub AGP_AMD64_CACHECTRL_INVGART () {0x1;}' unless defined(&AGP_AMD64_CACHECTRL_INVGART);
    eval 'sub AGP_AMD64_CACHECTRL_PTEERR () {0x2;}' unless defined(&AGP_AMD64_CACHECTRL_PTEERR);
    eval 'sub AGP_AMD64_NVIDIA_0_APBASE () {0x10;}' unless defined(&AGP_AMD64_NVIDIA_0_APBASE);
    eval 'sub AGP_AMD64_NVIDIA_1_APBASE1 () {0x50;}' unless defined(&AGP_AMD64_NVIDIA_1_APBASE1);
    eval 'sub AGP_AMD64_NVIDIA_1_APLIMIT1 () {0x54;}' unless defined(&AGP_AMD64_NVIDIA_1_APLIMIT1);
    eval 'sub AGP_AMD64_NVIDIA_1_APSIZE () {0xa8;}' unless defined(&AGP_AMD64_NVIDIA_1_APSIZE);
    eval 'sub AGP_AMD64_NVIDIA_1_APBASE2 () {0xd8;}' unless defined(&AGP_AMD64_NVIDIA_1_APBASE2);
    eval 'sub AGP_AMD64_NVIDIA_1_APLIMIT2 () {0xdc;}' unless defined(&AGP_AMD64_NVIDIA_1_APLIMIT2);
    eval 'sub AGP_AMD64_ULI_APBASE () {0x10;}' unless defined(&AGP_AMD64_ULI_APBASE);
    eval 'sub AGP_AMD64_ULI_HTT_FEATURE () {0x50;}' unless defined(&AGP_AMD64_ULI_HTT_FEATURE);
    eval 'sub AGP_AMD64_ULI_ENU_SCR () {0x54;}' unless defined(&AGP_AMD64_ULI_ENU_SCR);
    eval 'sub ATI_GART_MMADDR () {0x14;}' unless defined(&ATI_GART_MMADDR);
    eval 'sub ATI_RS100_APSIZE () {0xac;}' unless defined(&ATI_RS100_APSIZE);
    eval 'sub ATI_RS100_IG_AGPMODE () {0xb0;}' unless defined(&ATI_RS100_IG_AGPMODE);
    eval 'sub ATI_RS300_APSIZE () {0xf8;}' unless defined(&ATI_RS300_APSIZE);
    eval 'sub ATI_RS300_IG_AGPMODE () {0xfc;}' unless defined(&ATI_RS300_IG_AGPMODE);
    eval 'sub ATI_GART_FEATURE_ID () {0x;}' unless defined(&ATI_GART_FEATURE_ID);
    eval 'sub ATI_GART_BASE () {0x4;}' unless defined(&ATI_GART_BASE);
    eval 'sub ATI_GART_CACHE_CNTRL () {0xc;}' unless defined(&ATI_GART_CACHE_CNTRL);
}
1;
