require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub CISS_HDR_ADDRESS_MODE_PERIPHERAL () {0x;}' unless defined(&CISS_HDR_ADDRESS_MODE_PERIPHERAL);
eval 'sub CISS_HDR_ADDRESS_MODE_LOGICAL () {0x1;}' unless defined(&CISS_HDR_ADDRESS_MODE_LOGICAL);
eval 'sub CISS_HDR_ADDRESS_MODE_MASK_PERIPHERAL () {0x3;}' unless defined(&CISS_HDR_ADDRESS_MODE_MASK_PERIPHERAL);
unless(defined(&CISS_EXTRA_MODE2)) {
    sub CISS_EXTRA_MODE2 {
	my($extra) = @_;
	eval q((($extra & 0xc0000000) >> 30));
    }
}
unless(defined(&CISS_EXTRA_BUS2)) {
    sub CISS_EXTRA_BUS2 {
	my($extra) = @_;
	eval q((($extra & 0x3f000000) >> 24));
    }
}
unless(defined(&CISS_EXTRA_TARGET2)) {
    sub CISS_EXTRA_TARGET2 {
	my($extra) = @_;
	eval q((($extra & 0xff0000) >> 16));
    }
}
unless(defined(&CISS_EXTRA_MODE3)) {
    sub CISS_EXTRA_MODE3 {
	my($extra) = @_;
	eval q((($extra & 0xc000) >> 14));
    }
}
unless(defined(&CISS_EXTRA_BUS3)) {
    sub CISS_EXTRA_BUS3 {
	my($extra) = @_;
	eval q((($extra & 0x3f00) >> 8));
    }
}
unless(defined(&CISS_EXTRA_TARGET3)) {
    sub CISS_EXTRA_TARGET3 {
	my($extra) = @_;
	eval q((($extra & 0xff)));
    }
}
eval 'sub CISS_HDR_HOST_TAG_ERROR () {(1<<1);}' unless defined(&CISS_HDR_HOST_TAG_ERROR);
eval 'sub CISS_CDB_TYPE_COMMAND () {0;}' unless defined(&CISS_CDB_TYPE_COMMAND);
eval 'sub CISS_CDB_TYPE_MESSAGE () {1;}' unless defined(&CISS_CDB_TYPE_MESSAGE);
eval 'sub CISS_CDB_ATTRIBUTE_UNTAGGED () {0;}' unless defined(&CISS_CDB_ATTRIBUTE_UNTAGGED);
eval 'sub CISS_CDB_ATTRIBUTE_SIMPLE () {4;}' unless defined(&CISS_CDB_ATTRIBUTE_SIMPLE);
eval 'sub CISS_CDB_ATTRIBUTE_HEAD_OF_QUEUE () {5;}' unless defined(&CISS_CDB_ATTRIBUTE_HEAD_OF_QUEUE);
eval 'sub CISS_CDB_ATTRIBUTE_ORDERED () {6;}' unless defined(&CISS_CDB_ATTRIBUTE_ORDERED);
eval 'sub CISS_CDB_ATTRIBUTE_AUTO_CONTINGENT () {7;}' unless defined(&CISS_CDB_ATTRIBUTE_AUTO_CONTINGENT);
eval 'sub CISS_CDB_DIRECTION_NONE () {0;}' unless defined(&CISS_CDB_DIRECTION_NONE);
eval 'sub CISS_CDB_DIRECTION_WRITE () {1;}' unless defined(&CISS_CDB_DIRECTION_WRITE);
eval 'sub CISS_CDB_DIRECTION_READ () {2;}' unless defined(&CISS_CDB_DIRECTION_READ);
eval 'sub CISS_CDB_BUFFER_SIZE () {16;}' unless defined(&CISS_CDB_BUFFER_SIZE);
eval 'sub CISS_SCSI_STATUS_GOOD () {0x;}' unless defined(&CISS_SCSI_STATUS_GOOD);
eval 'sub CISS_SCSI_STATUS_CHECK_CONDITION () {0x2;}' unless defined(&CISS_SCSI_STATUS_CHECK_CONDITION);
eval 'sub CISS_SCSI_STATUS_CONDITION_MET () {0x4;}' unless defined(&CISS_SCSI_STATUS_CONDITION_MET);
eval 'sub CISS_SCSI_STATUS_BUSY () {0x8;}' unless defined(&CISS_SCSI_STATUS_BUSY);
eval 'sub CISS_SCSI_STATUS_INDETERMINATE () {0x10;}' unless defined(&CISS_SCSI_STATUS_INDETERMINATE);
eval 'sub CISS_SCSI_STATUS_INDETERMINATE_CM () {0x14;}' unless defined(&CISS_SCSI_STATUS_INDETERMINATE_CM);
eval 'sub CISS_SCSI_STATUS_RESERVATION_CONFLICT () {0x18;}' unless defined(&CISS_SCSI_STATUS_RESERVATION_CONFLICT);
eval 'sub CISS_SCSI_STATUS_COMMAND_TERMINATED () {0x22;}' unless defined(&CISS_SCSI_STATUS_COMMAND_TERMINATED);
eval 'sub CISS_SCSI_STATUS_QUEUE_FULL () {0x28;}' unless defined(&CISS_SCSI_STATUS_QUEUE_FULL);
eval 'sub CISS_SCSI_STATUS_ACA_ACTIVE () {0x30;}' unless defined(&CISS_SCSI_STATUS_ACA_ACTIVE);
eval 'sub CISS_CMD_STATUS_SUCCESS () {0;}' unless defined(&CISS_CMD_STATUS_SUCCESS);
eval 'sub CISS_CMD_STATUS_TARGET_STATUS () {1;}' unless defined(&CISS_CMD_STATUS_TARGET_STATUS);
eval 'sub CISS_CMD_STATUS_DATA_UNDERRUN () {2;}' unless defined(&CISS_CMD_STATUS_DATA_UNDERRUN);
eval 'sub CISS_CMD_STATUS_DATA_OVERRUN () {3;}' unless defined(&CISS_CMD_STATUS_DATA_OVERRUN);
eval 'sub CISS_CMD_STATUS_INVALID_COMMAND () {4;}' unless defined(&CISS_CMD_STATUS_INVALID_COMMAND);
eval 'sub CISS_CMD_STATUS_PROTOCOL_ERROR () {5;}' unless defined(&CISS_CMD_STATUS_PROTOCOL_ERROR);
eval 'sub CISS_CMD_STATUS_HARDWARE_ERROR () {6;}' unless defined(&CISS_CMD_STATUS_HARDWARE_ERROR);
eval 'sub CISS_CMD_STATUS_CONNECTION_LOST () {7;}' unless defined(&CISS_CMD_STATUS_CONNECTION_LOST);
eval 'sub CISS_CMD_STATUS_ABORTED () {8;}' unless defined(&CISS_CMD_STATUS_ABORTED);
eval 'sub CISS_CMD_STATUS_ABORT_FAILED () {9;}' unless defined(&CISS_CMD_STATUS_ABORT_FAILED);
eval 'sub CISS_CMD_STATUS_UNSOLICITED_ABORT () {10;}' unless defined(&CISS_CMD_STATUS_UNSOLICITED_ABORT);
eval 'sub CISS_CMD_STATUS_TIMEOUT () {11;}' unless defined(&CISS_CMD_STATUS_TIMEOUT);
eval 'sub CISS_CMD_STATUS_UNABORTABLE () {12;}' unless defined(&CISS_CMD_STATUS_UNABORTABLE);
eval 'sub CISS_SG_ADDRESS_BITBUCKET () {(~( &u_int64_t)0);}' unless defined(&CISS_SG_ADDRESS_BITBUCKET);
eval 'sub CISS_OPCODE_REPORT_LOGICAL_LUNS () {0xc2;}' unless defined(&CISS_OPCODE_REPORT_LOGICAL_LUNS);
eval 'sub CISS_OPCODE_REPORT_PHYSICAL_LUNS () {0xc3;}' unless defined(&CISS_OPCODE_REPORT_PHYSICAL_LUNS);
eval 'sub CISS_VPD_LOGICAL_DRIVE_GEOMETRY () {0xc1;}' unless defined(&CISS_VPD_LOGICAL_DRIVE_GEOMETRY);
eval 'sub CISS_OPCODE_MESSAGE_ABORT () {0x;}' unless defined(&CISS_OPCODE_MESSAGE_ABORT);
eval 'sub CISS_MESSAGE_ABORT_TASK () {0x;}' unless defined(&CISS_MESSAGE_ABORT_TASK);
eval 'sub CISS_MESSAGE_ABORT_TASK_SET () {0x1;}' unless defined(&CISS_MESSAGE_ABORT_TASK_SET);
eval 'sub CISS_MESSAGE_ABORT_CLEAR_ACA () {0x2;}' unless defined(&CISS_MESSAGE_ABORT_CLEAR_ACA);
eval 'sub CISS_MESSAGE_ABORT_CLEAR_TASK_SET () {0x3;}' unless defined(&CISS_MESSAGE_ABORT_CLEAR_TASK_SET);
eval 'sub CISS_OPCODE_MESSAGE_RESET () {0x1;}' unless defined(&CISS_OPCODE_MESSAGE_RESET);
eval 'sub CISS_MESSAGE_RESET_CONTROLLER () {0x;}' unless defined(&CISS_MESSAGE_RESET_CONTROLLER);
eval 'sub CISS_MESSAGE_RESET_BUS () {0x1;}' unless defined(&CISS_MESSAGE_RESET_BUS);
eval 'sub CISS_MESSAGE_RESET_TARGET () {0x3;}' unless defined(&CISS_MESSAGE_RESET_TARGET);
eval 'sub CISS_MESSAGE_RESET_LOGICAL_UNIT () {0x4;}' unless defined(&CISS_MESSAGE_RESET_LOGICAL_UNIT);
eval 'sub CISS_OPCODE_MESSAGE_SCAN () {0x2;}' unless defined(&CISS_OPCODE_MESSAGE_SCAN);
eval 'sub CISS_MESSAGE_SCAN_CONTROLLER () {0x;}' unless defined(&CISS_MESSAGE_SCAN_CONTROLLER);
eval 'sub CISS_MESSAGE_SCAN_BUS () {0x1;}' unless defined(&CISS_MESSAGE_SCAN_BUS);
eval 'sub CISS_MESSAGE_SCAN_TARGET () {0x3;}' unless defined(&CISS_MESSAGE_SCAN_TARGET);
eval 'sub CISS_MESSAGE_SCAN_LOGICAL_UNIT () {0x4;}' unless defined(&CISS_MESSAGE_SCAN_LOGICAL_UNIT);
eval 'sub CISS_OPCODE_MESSAGE_NOP () {0x3;}' unless defined(&CISS_OPCODE_MESSAGE_NOP);
eval 'sub CISS_OPCODE_READ () {0xc0;}' unless defined(&CISS_OPCODE_READ);
eval 'sub CISS_OPCODE_WRITE () {0xc1;}' unless defined(&CISS_OPCODE_WRITE);
eval 'sub CISS_COMMAND_NOTIFY_ON_EVENT () {0xd0;}' unless defined(&CISS_COMMAND_NOTIFY_ON_EVENT);
eval 'sub CISS_COMMAND_ABORT_NOTIFY () {0xd1;}' unless defined(&CISS_COMMAND_ABORT_NOTIFY);
eval 'sub CISS_NOTIFY_DATA_SIZE () {512;}' unless defined(&CISS_NOTIFY_DATA_SIZE);
eval 'sub CISS_NOTIFY_NOTIFIER () {0;}' unless defined(&CISS_NOTIFY_NOTIFIER);
eval 'sub CISS_NOTIFY_NOTIFIER_STATUS () {0;}' unless defined(&CISS_NOTIFY_NOTIFIER_STATUS);
eval 'sub CISS_NOTIFY_NOTIFIER_PROTOCOL () {1;}' unless defined(&CISS_NOTIFY_NOTIFIER_PROTOCOL);
eval 'sub CISS_NOTIFY_HOTPLUG () {1;}' unless defined(&CISS_NOTIFY_HOTPLUG);
eval 'sub CISS_NOTIFY_HOTPLUG_PHYSICAL () {0;}' unless defined(&CISS_NOTIFY_HOTPLUG_PHYSICAL);
eval 'sub CISS_NOTIFY_HOTPLUG_POWERSUPPLY () {1;}' unless defined(&CISS_NOTIFY_HOTPLUG_POWERSUPPLY);
eval 'sub CISS_NOTIFY_HOTPLUG_FAN () {2;}' unless defined(&CISS_NOTIFY_HOTPLUG_FAN);
eval 'sub CISS_NOTIFY_HOTPLUG_POWER () {3;}' unless defined(&CISS_NOTIFY_HOTPLUG_POWER);
eval 'sub CISS_NOTIFY_HOTPLUG_REDUNDANT () {4;}' unless defined(&CISS_NOTIFY_HOTPLUG_REDUNDANT);
eval 'sub CISS_NOTIFY_HOTPLUG_NONDISK () {5;}' unless defined(&CISS_NOTIFY_HOTPLUG_NONDISK);
eval 'sub CISS_NOTIFY_HARDWARE () {2;}' unless defined(&CISS_NOTIFY_HARDWARE);
eval 'sub CISS_NOTIFY_HARDWARE_CABLES () {0;}' unless defined(&CISS_NOTIFY_HARDWARE_CABLES);
eval 'sub CISS_NOTIFY_HARDWARE_MEMORY () {1;}' unless defined(&CISS_NOTIFY_HARDWARE_MEMORY);
eval 'sub CISS_NOTIFY_HARDWARE_FAN () {2;}' unless defined(&CISS_NOTIFY_HARDWARE_FAN);
eval 'sub CISS_NOTIFY_HARDWARE_VRM () {3;}' unless defined(&CISS_NOTIFY_HARDWARE_VRM);
eval 'sub CISS_NOTIFY_ENVIRONMENT () {3;}' unless defined(&CISS_NOTIFY_ENVIRONMENT);
eval 'sub CISS_NOTIFY_ENVIRONMENT_TEMPERATURE () {0;}' unless defined(&CISS_NOTIFY_ENVIRONMENT_TEMPERATURE);
eval 'sub CISS_NOTIFY_ENVIRONMENT_POWERSUPPLY () {1;}' unless defined(&CISS_NOTIFY_ENVIRONMENT_POWERSUPPLY);
eval 'sub CISS_NOTIFY_ENVIRONMENT_CHASSIS () {2;}' unless defined(&CISS_NOTIFY_ENVIRONMENT_CHASSIS);
eval 'sub CISS_NOTIFY_ENVIRONMENT_POWER () {3;}' unless defined(&CISS_NOTIFY_ENVIRONMENT_POWER);
eval 'sub CISS_NOTIFY_PHYSICAL () {4;}' unless defined(&CISS_NOTIFY_PHYSICAL);
eval 'sub CISS_NOTIFY_PHYSICAL_STATE () {0;}' unless defined(&CISS_NOTIFY_PHYSICAL_STATE);
eval 'sub CISS_NOTIFY_LOGICAL () {5;}' unless defined(&CISS_NOTIFY_LOGICAL);
eval 'sub CISS_NOTIFY_LOGICAL_STATUS () {0;}' unless defined(&CISS_NOTIFY_LOGICAL_STATUS);
eval 'sub CISS_NOTIFY_LOGICAL_ERROR () {1;}' unless defined(&CISS_NOTIFY_LOGICAL_ERROR);
eval 'sub CISS_NOTIFY_LOGICAL_SURFACE () {2;}' unless defined(&CISS_NOTIFY_LOGICAL_SURFACE);
eval 'sub CISS_NOTIFY_REDUNDANT () {6;}' unless defined(&CISS_NOTIFY_REDUNDANT);
eval 'sub CISS_NOTIFY_REDUNDANT_STATUS () {0;}' unless defined(&CISS_NOTIFY_REDUNDANT_STATUS);
eval 'sub CISS_NOTIFY_CISS () {8;}' unless defined(&CISS_NOTIFY_CISS);
eval 'sub CISS_NOTIFY_CISS_REDUNDANT_CHANGE () {0;}' unless defined(&CISS_NOTIFY_CISS_REDUNDANT_CHANGE);
eval 'sub CISS_NOTIFY_CISS_PATH_STATUS () {1;}' unless defined(&CISS_NOTIFY_CISS_PATH_STATUS);
eval 'sub CISS_NOTIFY_CISS_HARDWARE_ERROR () {2;}' unless defined(&CISS_NOTIFY_CISS_HARDWARE_ERROR);
eval 'sub CISS_NOTIFY_CISS_LOGICAL () {3;}' unless defined(&CISS_NOTIFY_CISS_LOGICAL);
eval 'sub CISS_TRANSPORT_METHOD_READY () {(1<<0);}' unless defined(&CISS_TRANSPORT_METHOD_READY);
eval 'sub CISS_TRANSPORT_METHOD_SIMPLE () {(1<<1);}' unless defined(&CISS_TRANSPORT_METHOD_SIMPLE);
eval 'sub CISS_TRANSPORT_METHOD_PERF () {(1<<2);}' unless defined(&CISS_TRANSPORT_METHOD_PERF);
eval 'sub CISS_TRANSPORT_BUS_TYPE_ULTRA2 () {(1<<0);}' unless defined(&CISS_TRANSPORT_BUS_TYPE_ULTRA2);
eval 'sub CISS_TRANSPORT_BUS_TYPE_ULTRA3 () {(1<<1);}' unless defined(&CISS_TRANSPORT_BUS_TYPE_ULTRA3);
eval 'sub CISS_TRANSPORT_BUS_TYPE_FIBRE1 () {(1<<8);}' unless defined(&CISS_TRANSPORT_BUS_TYPE_FIBRE1);
eval 'sub CISS_TRANSPORT_BUS_TYPE_FIBRE2 () {(1<<9);}' unless defined(&CISS_TRANSPORT_BUS_TYPE_FIBRE2);
eval 'sub CISS_DRIVER_SUPPORT_UNIT_ATTENTION () {(1<<0);}' unless defined(&CISS_DRIVER_SUPPORT_UNIT_ATTENTION);
eval 'sub CISS_DRIVER_QUICK_INIT () {(1<<1);}' unless defined(&CISS_DRIVER_QUICK_INIT);
eval 'sub CISS_DRIVER_INTERRUPT_ON_LOCKUP () {(1<<2);}' unless defined(&CISS_DRIVER_INTERRUPT_ON_LOCKUP);
eval 'sub CISS_DRIVER_SUPPORT_MIXED_Q_TAGS () {(1<<3);}' unless defined(&CISS_DRIVER_SUPPORT_MIXED_Q_TAGS);
eval 'sub CISS_DRIVER_HOST_IS_ALPHA () {(1<<4);}' unless defined(&CISS_DRIVER_HOST_IS_ALPHA);
eval 'sub CISS_DRIVER_MULTI_LUN_SUPPORT () {(1<<5);}' unless defined(&CISS_DRIVER_MULTI_LUN_SUPPORT);
eval 'sub CISS_DRIVER_MESSAGE_REQUESTS_SUPPORTED () {(1<<7);}' unless defined(&CISS_DRIVER_MESSAGE_REQUESTS_SUPPORTED);
eval 'sub CISS_DRIVER_DAUGHTER_ATTACHED () {(1<<8);}' unless defined(&CISS_DRIVER_DAUGHTER_ATTACHED);
eval 'sub CISS_DRIVER_SCSI_PREFETCH () {(1<<9);}' unless defined(&CISS_DRIVER_SCSI_PREFETCH);
eval 'sub CISS_SG_FETCH_MAX () {0;}' unless defined(&CISS_SG_FETCH_MAX);
eval 'sub CISS_SG_FETCH_1 () {1;}' unless defined(&CISS_SG_FETCH_1);
eval 'sub CISS_SG_FETCH_2 () {2;}' unless defined(&CISS_SG_FETCH_2);
eval 'sub CISS_SG_FETCH_4 () {3;}' unless defined(&CISS_SG_FETCH_4);
eval 'sub CISS_SG_FETCH_8 () {4;}' unless defined(&CISS_SG_FETCH_8);
eval 'sub CISS_SG_FETCH_16 () {5;}' unless defined(&CISS_SG_FETCH_16);
eval 'sub CISS_SG_FETCH_32 () {6;}' unless defined(&CISS_SG_FETCH_32);
eval 'sub CISS_SG_FETCH_NONE () {7;}' unless defined(&CISS_SG_FETCH_NONE);
eval 'sub CISS_ARRAY_CONTROLLER_READ () {0x26;}' unless defined(&CISS_ARRAY_CONTROLLER_READ);
eval 'sub CISS_ARRAY_CONTROLLER_WRITE () {0x27;}' unless defined(&CISS_ARRAY_CONTROLLER_WRITE);
eval 'sub CISS_BMIC_ID_LDRIVE () {0x10;}' unless defined(&CISS_BMIC_ID_LDRIVE);
eval 'sub CISS_BMIC_ID_CTLR () {0x11;}' unless defined(&CISS_BMIC_ID_CTLR);
eval 'sub CISS_BMIC_ID_LSTATUS () {0x12;}' unless defined(&CISS_BMIC_ID_LSTATUS);
eval 'sub CISS_BMIC_ID_PDRIVE () {0x15;}' unless defined(&CISS_BMIC_ID_PDRIVE);
eval 'sub CISS_BMIC_BLINK_PDRIVE () {0x16;}' unless defined(&CISS_BMIC_BLINK_PDRIVE);
eval 'sub CISS_BMIC_SENSE_BLINK_PDRIVE () {0x17;}' unless defined(&CISS_BMIC_SENSE_BLINK_PDRIVE);
eval 'sub CISS_BMIC_SOFT_RESET () {0x40;}' unless defined(&CISS_BMIC_SOFT_RESET);
eval 'sub CISS_BMIC_FLUSH_CACHE () {0xc2;}' unless defined(&CISS_BMIC_FLUSH_CACHE);
eval 'sub CISS_BMIC_ACCEPT_MEDIA () {0xe0;}' unless defined(&CISS_BMIC_ACCEPT_MEDIA);
unless(defined(&CISS_BIG_MAP_ID)) {
    sub CISS_BIG_MAP_ID {
	my($sc, $bus, $target) = @_;
	eval q((0x80 | (($sc)-> ($ciss_id->{drives_per_scsi_bus}) * ($bus)) | ($target)));
    }
}
unless(defined(&CISS_BIG_MAP_BUS)) {
    sub CISS_BIG_MAP_BUS {
	my($sc, $id) = @_;
	eval q(((($id) & 0x80) ? ((($id) & ~0x80) / ($sc)-> ($ciss_id->{drives_per_scsi_bus})) : -1));
    }
}
unless(defined(&CISS_BIG_MAP_TARGET)) {
    sub CISS_BIG_MAP_TARGET {
	my($sc, $id) = @_;
	eval q(((($id) & 0x80) ? ((($id) & ~0x80) % ($sc)-> ($ciss_id->{drives_per_scsi_bus})) : -1));
    }
}
eval 'sub CISS_BIG_MAP_ENTRIES () {128;}' unless defined(&CISS_BIG_MAP_ENTRIES);
unless(defined(&CISS_LUN_TO_BUS)) {
    sub CISS_LUN_TO_BUS {
	my($x) = @_;
	eval q(((($x) >> 16) & 0xff));
    }
}
unless(defined(&CISS_LUN_TO_TARGET)) {
    sub CISS_LUN_TO_TARGET {
	my($x) = @_;
	eval q((($x) & 0xff));
    }
}
eval 'sub CISS_LDRIVE_RAID0 () {0;}' unless defined(&CISS_LDRIVE_RAID0);
eval 'sub CISS_LDRIVE_RAID4 () {1;}' unless defined(&CISS_LDRIVE_RAID4);
eval 'sub CISS_LDRIVE_RAID1 () {2;}' unless defined(&CISS_LDRIVE_RAID1);
eval 'sub CISS_LDRIVE_RAID5 () {3;}' unless defined(&CISS_LDRIVE_RAID5);
eval 'sub CISS_LDRIVE_RAID51 () {4;}' unless defined(&CISS_LDRIVE_RAID51);
eval 'sub CISS_LDRIVE_RAIDADG () {5;}' unless defined(&CISS_LDRIVE_RAIDADG);
eval 'sub CISS_LSTATUS_OK () {0;}' unless defined(&CISS_LSTATUS_OK);
eval 'sub CISS_LSTATUS_FAILED () {1;}' unless defined(&CISS_LSTATUS_FAILED);
eval 'sub CISS_LSTATUS_NOT_CONFIGURED () {2;}' unless defined(&CISS_LSTATUS_NOT_CONFIGURED);
eval 'sub CISS_LSTATUS_INTERIM_RECOVERY () {3;}' unless defined(&CISS_LSTATUS_INTERIM_RECOVERY);
eval 'sub CISS_LSTATUS_READY_RECOVERY () {4;}' unless defined(&CISS_LSTATUS_READY_RECOVERY);
eval 'sub CISS_LSTATUS_RECOVERING () {5;}' unless defined(&CISS_LSTATUS_RECOVERING);
eval 'sub CISS_LSTATUS_WRONG_PDRIVE () {6;}' unless defined(&CISS_LSTATUS_WRONG_PDRIVE);
eval 'sub CISS_LSTATUS_MISSING_PDRIVE () {7;}' unless defined(&CISS_LSTATUS_MISSING_PDRIVE);
eval 'sub CISS_LSTATUS_EXPANDING () {10;}' unless defined(&CISS_LSTATUS_EXPANDING);
eval 'sub CISS_LSTATUS_BECOMING_READY () {11;}' unless defined(&CISS_LSTATUS_BECOMING_READY);
eval 'sub CISS_LSTATUS_QUEUED_FOR_EXPANSION () {12;}' unless defined(&CISS_LSTATUS_QUEUED_FOR_EXPANSION);
eval 'sub CONTROLLER_FLAGS_FLASH_ROM_INSTALLED () {0x1;}' unless defined(&CONTROLLER_FLAGS_FLASH_ROM_INSTALLED);
eval 'sub CONTROLLER_FLAGS_DIAGS_MODE_BIT () {0x2;}' unless defined(&CONTROLLER_FLAGS_DIAGS_MODE_BIT);
eval 'sub CONTROLLER_FLAGS_EXPAND_32MB_FX () {0x4;}' unless defined(&CONTROLLER_FLAGS_EXPAND_32MB_FX);
eval 'sub CONTROLLER_FLAGS_MORE_THAN_7_SUPPORT () {0x8;}' unless defined(&CONTROLLER_FLAGS_MORE_THAN_7_SUPPORT);
eval 'sub CONTROLLER_FLAGS_DAISY_SUPPORT_BIT () {0x10;}' unless defined(&CONTROLLER_FLAGS_DAISY_SUPPORT_BIT);
eval 'sub CONTROLLER_FLAGS_RES6 () {0x20;}' unless defined(&CONTROLLER_FLAGS_RES6);
eval 'sub CONTROLLER_FLAGS_RES7 () {0x40;}' unless defined(&CONTROLLER_FLAGS_RES7);
eval 'sub CONTROLLER_FLAGS_BIG_MAP_SUPPORT () {0x80;}' unless defined(&CONTROLLER_FLAGS_BIG_MAP_SUPPORT);
eval 'sub HOST_FLAGS_SDB_ASIC_WORK_AROUND () {0x1;}' unless defined(&HOST_FLAGS_SDB_ASIC_WORK_AROUND);
eval 'sub HOST_FLAGS_PCI_DATA_BUS_PARITY_SUPPORT () {0x2;}' unless defined(&HOST_FLAGS_PCI_DATA_BUS_PARITY_SUPPORT);
eval 'sub HOST_FLAGS_RES3 () {0x4;}' unless defined(&HOST_FLAGS_RES3);
eval 'sub HOST_FLAGS_RES4 () {0x8;}' unless defined(&HOST_FLAGS_RES4);
eval 'sub HOST_FLAGS_RES5 () {0x10;}' unless defined(&HOST_FLAGS_RES5);
eval 'sub HOST_FLAGS_RES6 () {0x20;}' unless defined(&HOST_FLAGS_RES6);
eval 'sub HOST_FLAGS_RES7 () {0x30;}' unless defined(&HOST_FLAGS_RES7);
eval 'sub HOST_FLAGS_RES8 () {0x40;}' unless defined(&HOST_FLAGS_RES8);
eval 'sub EXPAND_DISABLE_NOT_NEEDED () {0x1;}' unless defined(&EXPAND_DISABLE_NOT_NEEDED);
eval 'sub EXPAND_DISABLE_MISSING_CACHE_BOARD () {0x2;}' unless defined(&EXPAND_DISABLE_MISSING_CACHE_BOARD);
eval 'sub EXPAND_DISABLE_WCXC_FATAL_CACHE_BITS () {0x4;}' unless defined(&EXPAND_DISABLE_WCXC_FATAL_CACHE_BITS);
eval 'sub EXPAND_DISABLE_CACHE_PERM_DISABLED () {0x8;}' unless defined(&EXPAND_DISABLE_CACHE_PERM_DISABLED);
eval 'sub EXPAND_DISABLE_RAM_ALLOCATION_FAILED () {0x10;}' unless defined(&EXPAND_DISABLE_RAM_ALLOCATION_FAILED);
eval 'sub EXPAND_DISABLE_BATTEREIS_DISCHARGED () {0x20;}' unless defined(&EXPAND_DISABLE_BATTEREIS_DISCHARGED);
eval 'sub EXPAND_DISABLE_RES7 () {0x40;}' unless defined(&EXPAND_DISABLE_RES7);
eval 'sub EXPAND_DISABLE_REBUILD_RUNNING () {0x80;}' unless defined(&EXPAND_DISABLE_REBUILD_RUNNING);
eval 'sub YMORE_CONTROLLER_FLAGS_JBOD_SUPPORTED () {( 1<< 25);}' unless defined(&YMORE_CONTROLLER_FLAGS_JBOD_SUPPORTED);
eval 'sub PWR_UP_FLAG_JBOD_ENABLED () {0x8;}' unless defined(&PWR_UP_FLAG_JBOD_ENABLED);
eval 'sub CISS_BMIC_BLINK_ALL () {1;}' unless defined(&CISS_BMIC_BLINK_ALL);
eval 'sub CISS_BMIC_BLINK_TIMED () {2;}' unless defined(&CISS_BMIC_BLINK_TIMED);
eval 'sub CISS_BMIC_FLUSH_AND_ENABLE () {0;}' unless defined(&CISS_BMIC_FLUSH_AND_ENABLE);
eval 'sub CISS_BMIC_FLUSH_AND_DISABLE () {1;}' unless defined(&CISS_BMIC_FLUSH_AND_DISABLE);
if(defined(&_KERNEL)) {
    eval 'sub CISS_TL_SIMPLE_BAR_REGS () {0x10;}' unless defined(&CISS_TL_SIMPLE_BAR_REGS);
    eval 'sub CISS_TL_SIMPLE_BAR_CFG () {0x14;}' unless defined(&CISS_TL_SIMPLE_BAR_CFG);
    eval 'sub CISS_TL_SIMPLE_IDBR () {0x20;}' unless defined(&CISS_TL_SIMPLE_IDBR);
    eval 'sub CISS_TL_SIMPLE_IDBR_CFG_TABLE () {(1<<0);}' unless defined(&CISS_TL_SIMPLE_IDBR_CFG_TABLE);
    eval 'sub CISS_TL_SIMPLE_ISR () {0x30;}' unless defined(&CISS_TL_SIMPLE_ISR);
    eval 'sub CISS_TL_SIMPLE_IMR () {0x34;}' unless defined(&CISS_TL_SIMPLE_IMR);
    eval 'sub CISS_TL_SIMPLE_INTR_OPQ_SA5 () {(1<<3);}' unless defined(&CISS_TL_SIMPLE_INTR_OPQ_SA5);
    eval 'sub CISS_TL_SIMPLE_INTR_OPQ_SA5B () {(1<<2);}' unless defined(&CISS_TL_SIMPLE_INTR_OPQ_SA5B);
    eval 'sub CISS_TL_SIMPLE_IPQ () {0x40;}' unless defined(&CISS_TL_SIMPLE_IPQ);
    eval 'sub CISS_TL_SIMPLE_OPQ () {0x44;}' unless defined(&CISS_TL_SIMPLE_OPQ);
    eval 'sub CISS_TL_SIMPLE_OPQ_EMPTY () {(~( &u_int32_t)0);}' unless defined(&CISS_TL_SIMPLE_OPQ_EMPTY);
    eval 'sub CISS_TL_SIMPLE_OSR () {0x9c;}' unless defined(&CISS_TL_SIMPLE_OSR);
    eval 'sub CISS_TL_SIMPLE_ODC () {0xa0;}' unless defined(&CISS_TL_SIMPLE_ODC);
    eval 'sub CISS_TL_SIMPLE_ODC_CLEAR () {(0x1);}' unless defined(&CISS_TL_SIMPLE_ODC_CLEAR);
    eval 'sub CISS_TL_SIMPLE_CFG_BAR () {0xb4;}' unless defined(&CISS_TL_SIMPLE_CFG_BAR);
    eval 'sub CISS_TL_SIMPLE_CFG_OFF () {0xb8;}' unless defined(&CISS_TL_SIMPLE_CFG_OFF);
    eval 'sub CISS_TL_SIMPLE_READ {
        my($sc, $ofs) = @_;
	    eval q( &bus_space_read_4( ($sc->{ciss_regs_btag}),  ($sc->{ciss_regs_bhandle}), $ofs));
    }' unless defined(&CISS_TL_SIMPLE_READ);
    eval 'sub CISS_TL_SIMPLE_WRITE {
        my($sc, $ofs, $val) = @_;
	    eval q( &bus_space_write_4( ($sc->{ciss_regs_btag}),  ($sc->{ciss_regs_bhandle}), $ofs, $val));
    }' unless defined(&CISS_TL_SIMPLE_WRITE);
    eval 'sub CISS_TL_SIMPLE_POST_CMD {
        my($sc, $phys) = @_;
	    eval q( &CISS_TL_SIMPLE_WRITE($sc,  &CISS_TL_SIMPLE_IPQ, $phys));
    }' unless defined(&CISS_TL_SIMPLE_POST_CMD);
    eval 'sub CISS_TL_SIMPLE_FETCH_CMD {
        my($sc) = @_;
	    eval q( &CISS_TL_SIMPLE_READ($sc,  &CISS_TL_SIMPLE_OPQ));
    }' unless defined(&CISS_TL_SIMPLE_FETCH_CMD);
    eval 'sub CISS_TL_PERF_INTR_OPQ () {( &CISS_TL_SIMPLE_INTR_OPQ_SA5 |  &CISS_TL_SIMPLE_INTR_OPQ_SA5B);}' unless defined(&CISS_TL_PERF_INTR_OPQ);
    eval 'sub CISS_TL_PERF_INTR_MSI () {0x1;}' unless defined(&CISS_TL_PERF_INTR_MSI);
    eval 'sub CISS_TL_PERF_POST_CMD {
        my($sc, $cr) = @_;
	    eval q( &CISS_TL_SIMPLE_WRITE($sc,  &CISS_TL_SIMPLE_IPQ,  ($cr->{cr_ccphys}) | ($cr)-> &cr_sg_tag));
    }' unless defined(&CISS_TL_PERF_POST_CMD);
    eval 'sub CISS_TL_PERF_FLUSH_INT {
        my($sc) = @_;
	    eval q( &CISS_TL_SIMPLE_READ($sc,  &CISS_TL_SIMPLE_OSR));
    }' unless defined(&CISS_TL_PERF_FLUSH_INT);
    eval 'sub CISS_TL_PERF_CLEAR_INT {
        my($sc) = @_;
	    eval q( &CISS_TL_SIMPLE_WRITE($sc,  &CISS_TL_SIMPLE_ODC,  &CISS_TL_SIMPLE_ODC_CLEAR));
    }' unless defined(&CISS_TL_PERF_CLEAR_INT);
    eval 'sub CISS_CYCLE_MASK () {0x1;}' unless defined(&CISS_CYCLE_MASK);
    eval 'sub CISS_MSI_COUNT () {1;}' unless defined(&CISS_MSI_COUNT);
    eval 'sub CISS_TL_SIMPLE_DISABLE_INTERRUPTS {
        my($sc) = @_;
	    eval q( &CISS_TL_SIMPLE_WRITE($sc,  &CISS_TL_SIMPLE_IMR,  &CISS_TL_SIMPLE_READ($sc,  &CISS_TL_SIMPLE_IMR) | ($sc)-> &ciss_interrupt_mask));
    }' unless defined(&CISS_TL_SIMPLE_DISABLE_INTERRUPTS);
    eval 'sub CISS_TL_SIMPLE_ENABLE_INTERRUPTS {
        my($sc) = @_;
	    eval q( &CISS_TL_SIMPLE_WRITE($sc,  &CISS_TL_SIMPLE_IMR,  &CISS_TL_SIMPLE_READ($sc,  &CISS_TL_SIMPLE_IMR) & ~($sc)-> &ciss_interrupt_mask));
    }' unless defined(&CISS_TL_SIMPLE_ENABLE_INTERRUPTS);
}
1;
