require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FIREWIRE_H)) {
    eval 'sub _FIREWIRE_H () {1;}' unless defined(&_FIREWIRE_H);
    eval 'sub DEV_DEF () {0;}' unless defined(&DEV_DEF);
    eval 'sub DEV_DV () {2;}' unless defined(&DEV_DV);
    eval 'sub MAXREC {
        my($x) = @_;
	    eval q((2<< ($x)));
    }' unless defined(&MAXREC);
    eval 'sub FWPMAX_S400 () {(2048+ 20);}' unless defined(&FWPMAX_S400);
    eval 'sub FWMAXQUEUE () {128;}' unless defined(&FWMAXQUEUE);
    eval 'sub FWLOCALBUS () {0xffc0;}' unless defined(&FWLOCALBUS);
    eval 'sub FWTCODE_WREQQ () {0;}' unless defined(&FWTCODE_WREQQ);
    eval 'sub FWTCODE_WREQB () {1;}' unless defined(&FWTCODE_WREQB);
    eval 'sub FWTCODE_WRES () {2;}' unless defined(&FWTCODE_WRES);
    eval 'sub FWTCODE_RREQQ () {4;}' unless defined(&FWTCODE_RREQQ);
    eval 'sub FWTCODE_RREQB () {5;}' unless defined(&FWTCODE_RREQB);
    eval 'sub FWTCODE_RRESQ () {6;}' unless defined(&FWTCODE_RRESQ);
    eval 'sub FWTCODE_RRESB () {7;}' unless defined(&FWTCODE_RRESB);
    eval 'sub FWTCODE_CYCS () {8;}' unless defined(&FWTCODE_CYCS);
    eval 'sub FWTCODE_LREQ () {9;}' unless defined(&FWTCODE_LREQ);
    eval 'sub FWTCODE_STREAM () {0xa;}' unless defined(&FWTCODE_STREAM);
    eval 'sub FWTCODE_LRES () {0xb;}' unless defined(&FWTCODE_LRES);
    eval 'sub FWTCODE_PHY () {0xe;}' unless defined(&FWTCODE_PHY);
    eval 'sub FWRETRY_1 () {0;}' unless defined(&FWRETRY_1);
    eval 'sub FWRETRY_X () {1;}' unless defined(&FWRETRY_X);
    eval 'sub FWRETRY_A () {2;}' unless defined(&FWRETRY_A);
    eval 'sub FWRETRY_B () {3;}' unless defined(&FWRETRY_B);
    eval 'sub FWRCODE_COMPLETE () {0;}' unless defined(&FWRCODE_COMPLETE);
    eval 'sub FWRCODE_ER_CONFL () {4;}' unless defined(&FWRCODE_ER_CONFL);
    eval 'sub FWRCODE_ER_DATA () {5;}' unless defined(&FWRCODE_ER_DATA);
    eval 'sub FWRCODE_ER_TYPE () {6;}' unless defined(&FWRCODE_ER_TYPE);
    eval 'sub FWRCODE_ER_ADDR () {7;}' unless defined(&FWRCODE_ER_ADDR);
    eval 'sub FWSPD_S100 () {0;}' unless defined(&FWSPD_S100);
    eval 'sub FWSPD_S200 () {1;}' unless defined(&FWSPD_S200);
    eval 'sub FWSPD_S400 () {2;}' unless defined(&FWSPD_S400);
    eval 'sub FWSPD_S800 () {3;}' unless defined(&FWSPD_S800);
    eval 'sub FWSPD_S1600 () {4;}' unless defined(&FWSPD_S1600);
    eval 'sub FWSPD_S3200 () {5;}' unless defined(&FWSPD_S3200);
    eval 'sub FWP_TL_VALID () {(1<< 7);}' unless defined(&FWP_TL_VALID);
    if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
	eval 'sub BIT4x2 {
	    my($x,$y) = @_;
    	    eval q( &uint8_t $x:4, $y:4);
	}' unless defined(&BIT4x2);
	eval 'sub BIT16x2 {
	    my($x,$y) = @_;
    	    eval q( &uint32_t $x:16, $y:16);
	}' unless defined(&BIT16x2);
    } else {
	eval 'sub BIT4x2 {
	    my($x,$y) = @_;
    	    eval q( &uint8_t $y:4, $x:4);
	}' unless defined(&BIT4x2);
	eval 'sub BIT16x2 {
	    my($x,$y) = @_;
    	    eval q( &uint32_t $y:16, $x:16);
	}' unless defined(&BIT16x2);
    }
    if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
	eval 'sub COMMON_HDR {
	    my($a,$b,$c,$d) = @_;
    	    eval q( &uint32_t $a:16,$b:8,$c:4,$d:4);
	}' unless defined(&COMMON_HDR);
	eval 'sub COMMON_RES {
	    my($a,$b,$c,$d) = @_;
    	    eval q( &uint32_t $a:16,$b:4,$c:4,$d:8);
	}' unless defined(&COMMON_RES);
    } else {
	eval 'sub COMMON_HDR {
	    my($a,$b,$c,$d) = @_;
    	    eval q( &uint32_t $d:4,$c:4,$b:8,$a:16);
	}' unless defined(&COMMON_HDR);
	eval 'sub COMMON_RES {
	    my($a,$b,$c,$d) = @_;
    	    eval q( &uint32_t $d:8,$c:4,$b:4,$a:16);
	}' unless defined(&COMMON_RES);
    }
    eval 'sub RESP_CMP () {0;}' unless defined(&RESP_CMP);
    eval 'sub RESP_CONFLICT_ERROR () {4;}' unless defined(&RESP_CONFLICT_ERROR);
    eval 'sub RESP_DATA_ERROR () {5;}' unless defined(&RESP_DATA_ERROR);
    eval 'sub RESP_TYPE_ERROR () {6;}' unless defined(&RESP_TYPE_ERROR);
    eval 'sub RESP_ADDRESS_ERROR () {7;}' unless defined(&RESP_ADDRESS_ERROR);
    eval 'sub EXTCODE_MASK_SWAP () {1;}' unless defined(&EXTCODE_MASK_SWAP);
    eval 'sub EXTCODE_CMP_SWAP () {2;}' unless defined(&EXTCODE_CMP_SWAP);
    eval 'sub EXTCODE_FETCH_ADD () {3;}' unless defined(&EXTCODE_FETCH_ADD);
    eval 'sub EXTCODE_LITTLE_ADD () {4;}' unless defined(&EXTCODE_LITTLE_ADD);
    eval 'sub EXTCODE_BOUNDED_ADD () {5;}' unless defined(&EXTCODE_BOUNDED_ADD);
    eval 'sub EXTCODE_WRAP_ADD () {6;}' unless defined(&EXTCODE_WRAP_ADD);
    eval 'sub FW_EUI64_BYTE {
        my($eui, $x) = @_;
	    eval q((((($x) < 4)? (($eui)-> &hi >> (8* (3- ($x)))): (($eui)-> &lo >> (8* (7- ($x)))) ) & 0xff));
    }' unless defined(&FW_EUI64_BYTE);
    eval 'sub FW_EUI64_EQUAL {
        my($x, $y) = @_;
	    eval q((($x). &hi == ($y). &hi  && ($x). &lo == ($y). &lo));
    }' unless defined(&FW_EUI64_EQUAL);
    eval 'sub FWASREQNODE () {0;}' unless defined(&FWASREQNODE);
    eval 'sub FWASREQEUI () {1;}' unless defined(&FWASREQEUI);
    eval 'sub FWASRESTL () {2;}' unless defined(&FWASRESTL);
    eval 'sub FWASREQSTREAM () {3;}' unless defined(&FWASREQSTREAM);
    eval 'sub FW_MAX_DEVLST () {70;}' unless defined(&FW_MAX_DEVLST);
    eval 'sub FW_SELF_ID_PORT_CONNECTED_TO_CHILD () {3;}' unless defined(&FW_SELF_ID_PORT_CONNECTED_TO_CHILD);
    eval 'sub FW_SELF_ID_PORT_CONNECTED_TO_PARENT () {2;}' unless defined(&FW_SELF_ID_PORT_CONNECTED_TO_PARENT);
    eval 'sub FW_SELF_ID_PORT_NOT_CONNECTED () {1;}' unless defined(&FW_SELF_ID_PORT_NOT_CONNECTED);
    eval 'sub FW_SELF_ID_PORT_NOT_EXISTS () {0;}' unless defined(&FW_SELF_ID_PORT_NOT_EXISTS);
    eval 'sub FW_SELF_ID_PAGE0 () {0;}' unless defined(&FW_SELF_ID_PAGE0);
    eval 'sub FW_SELF_ID_PAGE1 () {1;}' unless defined(&FW_SELF_ID_PAGE1);
    if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
    } else {
    }
    eval 'sub FW_SSTBUF () { &_IOWR(ord(\'S\'), 86, \'struct fw_isobufreq\');}' unless defined(&FW_SSTBUF);
    eval 'sub FW_GSTBUF () { &_IOWR(ord(\'S\'), 87, \'struct fw_isobufreq\');}' unless defined(&FW_GSTBUF);
    eval 'sub FW_SRSTREAM () { &_IOWR(ord(\'S\'), 88, \'struct fw_isochreq\');}' unless defined(&FW_SRSTREAM);
    eval 'sub FW_GRSTREAM () { &_IOWR(ord(\'S\'), 89, \'struct fw_isochreq\');}' unless defined(&FW_GRSTREAM);
    eval 'sub FW_STSTREAM () { &_IOWR(ord(\'S\'), 90, \'struct fw_isochreq\');}' unless defined(&FW_STSTREAM);
    eval 'sub FW_GTSTREAM () { &_IOWR(ord(\'S\'), 91, \'struct fw_isochreq\');}' unless defined(&FW_GTSTREAM);
    eval 'sub FW_ASYREQ () { &_IOWR(ord(\'S\'), 92, \'struct fw_asyreq\');}' unless defined(&FW_ASYREQ);
    eval 'sub FW_IBUSRST () { &_IOR(ord(\'S\'), 1, \'unsigned int\');}' unless defined(&FW_IBUSRST);
    eval 'sub FW_GDEVLST () { &_IOWR(ord(\'S\'), 2, \'struct fw_devlstreq\');}' unless defined(&FW_GDEVLST);
    eval 'sub FW_SBINDADDR () { &_IOWR(ord(\'S\'), 3, \'struct fw_asybindreq\');}' unless defined(&FW_SBINDADDR);
    eval 'sub FW_CBINDADDR () { &_IOWR(ord(\'S\'), 4, \'struct fw_asybindreq\');}' unless defined(&FW_CBINDADDR);
    eval 'sub FW_GTPMAP () { &_IOR(ord(\'S\'), 5, \'struct fw_topology_map\');}' unless defined(&FW_GTPMAP);
    eval 'sub FW_GCROM () { &_IOWR(ord(\'S\'), 7, \'struct fw_crom_buf\');}' unless defined(&FW_GCROM);
    eval 'sub FW_SDEUI64 () { &_IOW(ord(\'S\'), 20, \'struct fw_eui64\');}' unless defined(&FW_SDEUI64);
    eval 'sub FW_GDEUI64 () { &_IOR(ord(\'S\'), 21, \'struct fw_eui64\');}' unless defined(&FW_GDEUI64);
    eval 'sub FWOHCI_RDREG () { &_IOWR(ord(\'S\'), 80, \'struct fw_reg_req_t\');}' unless defined(&FWOHCI_RDREG);
    eval 'sub FWOHCI_WRREG () { &_IOWR(ord(\'S\'), 81, \'struct fw_reg_req_t\');}' unless defined(&FWOHCI_WRREG);
    eval 'sub FWOHCI_RDPHYREG () { &_IOWR(ord(\'S\'), 82, \'struct fw_reg_req_t\');}' unless defined(&FWOHCI_RDPHYREG);
    eval 'sub FWOHCI_WRPHYREG () { &_IOWR(ord(\'S\'), 83, \'struct fw_reg_req_t\');}' unless defined(&FWOHCI_WRPHYREG);
    eval 'sub DUMPDMA () { &_IOWR(ord(\'S\'), 82,  &uint32_t);}' unless defined(&DUMPDMA);
    if(defined(&_KERNEL)) {
	eval 'sub FWMAXNDMA () {0x100;}' unless defined(&FWMAXNDMA);
	eval 'sub MAKEMINOR {
	    my($f, $u, $s) = @_;
    	    eval q((($f) | ((($u) & 0xff) << 8) | ($s & 0xff)));
	}' unless defined(&MAKEMINOR);
	eval 'sub DEV2UNIT {
	    my($x) = @_;
    	    eval q((( &dev2unit($x) & 0xff00) >> 8));
	}' unless defined(&DEV2UNIT);
	eval 'sub DEV2SUB {
	    my($x) = @_;
    	    eval q(( &dev2unit($x) & 0xff));
	}' unless defined(&DEV2SUB);
	eval 'sub FWMEM_FLAG () {0x10000;}' unless defined(&FWMEM_FLAG);
	eval 'sub DEV_FWMEM {
	    my($x) = @_;
    	    eval q(( &dev2unit($x) &  &FWMEM_FLAG));
	}' unless defined(&DEV_FWMEM);
    }
}
1;
