require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub STATE_CLEAR () {0x;}' unless defined(&STATE_CLEAR);
eval 'sub STATE_SET () {0x4;}' unless defined(&STATE_SET);
eval 'sub NODE_IDS () {0x8;}' unless defined(&NODE_IDS);
eval 'sub RESET_START () {0xc;}' unless defined(&RESET_START);
eval 'sub SPLIT_TIMEOUT_HI () {0x18;}' unless defined(&SPLIT_TIMEOUT_HI);
eval 'sub SPLIT_TIMEOUT_LO () {0x1c;}' unless defined(&SPLIT_TIMEOUT_LO);
eval 'sub CYCLE_TIME () {0x200;}' unless defined(&CYCLE_TIME);
eval 'sub BUS_TIME () {0x204;}' unless defined(&BUS_TIME);
eval 'sub BUSY_TIMEOUT () {0x210;}' unless defined(&BUSY_TIMEOUT);
eval 'sub PRIORITY_BUDGET () {0x218;}' unless defined(&PRIORITY_BUDGET);
eval 'sub BUS_MGR_ID () {0x21c;}' unless defined(&BUS_MGR_ID);
eval 'sub BANDWIDTH_AV () {0x220;}' unless defined(&BANDWIDTH_AV);
eval 'sub CHANNELS_AV_HI () {0x224;}' unless defined(&CHANNELS_AV_HI);
eval 'sub CHANNELS_AV_LO () {0x228;}' unless defined(&CHANNELS_AV_LO);
eval 'sub IP_CHANNELS () {0x234;}' unless defined(&IP_CHANNELS);
eval 'sub CONF_ROM () {0x400;}' unless defined(&CONF_ROM);
eval 'sub TOPO_MAP () {0x1000;}' unless defined(&TOPO_MAP);
eval 'sub SPED_MAP () {0x2000;}' unless defined(&SPED_MAP);
eval 'sub CSRTYPE_SHIFT () {6;}' unless defined(&CSRTYPE_SHIFT);
eval 'sub CSRTYPE_MASK () {(3<<  &CSRTYPE_SHIFT);}' unless defined(&CSRTYPE_MASK);
eval 'sub CSRTYPE_I () {(0<<  &CSRTYPE_SHIFT);}' unless defined(&CSRTYPE_I);
eval 'sub CSRTYPE_C () {(1<<  &CSRTYPE_SHIFT);}' unless defined(&CSRTYPE_C);
eval 'sub CSRTYPE_L () {(2<<  &CSRTYPE_SHIFT);}' unless defined(&CSRTYPE_L);
eval 'sub CSRTYPE_D () {(3<<  &CSRTYPE_SHIFT);}' unless defined(&CSRTYPE_D);
eval 'sub CSRKEY_MASK () {0x3f;}' unless defined(&CSRKEY_MASK);
eval 'sub CSRKEY_DESC () {0x1;}' unless defined(&CSRKEY_DESC);
eval 'sub CSRKEY_BDINFO () {0x2;}' unless defined(&CSRKEY_BDINFO);
eval 'sub CSRKEY_VENDOR () {0x3;}' unless defined(&CSRKEY_VENDOR);
eval 'sub CSRKEY_HW () {0x4;}' unless defined(&CSRKEY_HW);
eval 'sub CSRKEY_MODULE () {0x7;}' unless defined(&CSRKEY_MODULE);
eval 'sub CSRKEY_NCAP () {0xc;}' unless defined(&CSRKEY_NCAP);
eval 'sub CSRKEY_EUI64 () {0xd;}' unless defined(&CSRKEY_EUI64);
eval 'sub CSRKEY_UNIT () {0x11;}' unless defined(&CSRKEY_UNIT);
eval 'sub CSRKEY_SPEC () {0x12;}' unless defined(&CSRKEY_SPEC);
eval 'sub CSRKEY_VER () {0x13;}' unless defined(&CSRKEY_VER);
eval 'sub CSRKEY_DINFO () {0x14;}' unless defined(&CSRKEY_DINFO);
eval 'sub CSRKEY_ULOC () {0x15;}' unless defined(&CSRKEY_ULOC);
eval 'sub CSRKEY_MODEL () {0x17;}' unless defined(&CSRKEY_MODEL);
eval 'sub CSRKEY_INST () {0x18;}' unless defined(&CSRKEY_INST);
eval 'sub CSRKEY_KEYW () {0x19;}' unless defined(&CSRKEY_KEYW);
eval 'sub CSRKEY_FEAT () {0x1a;}' unless defined(&CSRKEY_FEAT);
eval 'sub CSRKEY_EROM () {0x1b;}' unless defined(&CSRKEY_EROM);
eval 'sub CSRKEY_EKSID () {0x1c;}' unless defined(&CSRKEY_EKSID);
eval 'sub CSRKEY_EKEY () {0x1d;}' unless defined(&CSRKEY_EKEY);
eval 'sub CSRKEY_EDATA () {0x1e;}' unless defined(&CSRKEY_EDATA);
eval 'sub CSRKEY_MDESC () {0x1f;}' unless defined(&CSRKEY_MDESC);
eval 'sub CSRKEY_DID () {0x20;}' unless defined(&CSRKEY_DID);
eval 'sub CSRKEY_REV () {0x21;}' unless defined(&CSRKEY_REV);
eval 'sub CSRKEY_FIRM_VER () {0x3c;}' unless defined(&CSRKEY_FIRM_VER);
eval 'sub CSRKEY_UNIT_CH () {0x3a;}' unless defined(&CSRKEY_UNIT_CH);
eval 'sub CSRKEY_COM_SPEC () {0x38;}' unless defined(&CSRKEY_COM_SPEC);
eval 'sub CSRKEY_COM_SET () {0x39;}' unless defined(&CSRKEY_COM_SET);
eval 'sub CROM_UDIR () {( &CSRTYPE_D |  &CSRKEY_UNIT);}' unless defined(&CROM_UDIR);
eval 'sub CROM_TEXTLEAF () {( &CSRTYPE_L |  &CSRKEY_DESC);}' unless defined(&CROM_TEXTLEAF);
eval 'sub CROM_LUN () {( &CSRTYPE_I |  &CSRKEY_DINFO);}' unless defined(&CROM_LUN);
eval 'sub CROM_MGM () {( &CSRTYPE_C |  &CSRKEY_DINFO);}' unless defined(&CROM_MGM);
eval 'sub CSRVAL_VENDOR_PRIVATE () {0xacde48;}' unless defined(&CSRVAL_VENDOR_PRIVATE);
eval 'sub CSRVAL_1394TA () {0xa02d;}' unless defined(&CSRVAL_1394TA);
eval 'sub CSRVAL_ANSIT10 () {0x609e;}' unless defined(&CSRVAL_ANSIT10);
eval 'sub CSRVAL_IETF () {0x5e;}' unless defined(&CSRVAL_IETF);
eval 'sub CSR_PROTAVC () {0x10001;}' unless defined(&CSR_PROTAVC);
eval 'sub CSR_PROTCAL () {0x10002;}' unless defined(&CSR_PROTCAL);
eval 'sub CSR_PROTEHS () {0x10004;}' unless defined(&CSR_PROTEHS);
eval 'sub CSR_PROTHAVI () {0x10008;}' unless defined(&CSR_PROTHAVI);
eval 'sub CSR_PROTCAM104 () {0x100;}' unless defined(&CSR_PROTCAM104);
eval 'sub CSR_PROTCAM120 () {0x101;}' unless defined(&CSR_PROTCAM120);
eval 'sub CSR_PROTCAM130 () {0x102;}' unless defined(&CSR_PROTCAM130);
eval 'sub CSR_PROTDPP () {0xa6be2;}' unless defined(&CSR_PROTDPP);
eval 'sub CSR_PROTIICP () {0x4b661f;}' unless defined(&CSR_PROTIICP);
eval 'sub CSRVAL_T10SBP2 () {0x10483;}' unless defined(&CSRVAL_T10SBP2);
eval 'sub CSRVAL_SCSI () {0x104d8;}' unless defined(&CSRVAL_SCSI);
if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
} else {
}
if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
} else {
}
if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
} else {
}
eval 'sub CSR_BUS_NAME_IEEE1394 () {0x31333934;}' unless defined(&CSR_BUS_NAME_IEEE1394);
if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
} else {
}
eval 'sub MAXROM_4 () {0;}' unless defined(&MAXROM_4);
eval 'sub MAXROM_64 () {1;}' unless defined(&MAXROM_64);
eval 'sub MAXROM_1024 () {2;}' unless defined(&MAXROM_1024);
eval 'sub CROM_MAX_DEPTH () {10;}' unless defined(&CROM_MAX_DEPTH);
if(!defined(&_KERNEL)  && !defined(&_BOOT)) {
}
if(defined(&_KERNEL) || defined(&_BOOT) || defined(&TEST)) {
    eval 'sub CROM_MAX_CHUNK_LEN () {20;}' unless defined(&CROM_MAX_CHUNK_LEN);
}
1;
