require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub CD180_GIVR () {0x40;}' unless defined(&CD180_GIVR);
eval 'sub CD180_GICR () {0x41;}' unless defined(&CD180_GICR);
eval 'sub CD180_PILR1 () {0x61;}' unless defined(&CD180_PILR1);
eval 'sub CD180_PILR2 () {0x62;}' unless defined(&CD180_PILR2);
eval 'sub CD180_PILR3 () {0x63;}' unless defined(&CD180_PILR3);
eval 'sub CD180_CAR () {0x64;}' unless defined(&CD180_CAR);
eval 'sub CD180_GFRCR () {0x6b;}' unless defined(&CD180_GFRCR);
eval 'sub CD180_PPRH () {0x70;}' unless defined(&CD180_PPRH);
eval 'sub CD180_PPRL () {0x71;}' unless defined(&CD180_PPRL);
eval 'sub CD180_RDR () {0x78;}' unless defined(&CD180_RDR);
eval 'sub CD180_RCSR () {0x7a;}' unless defined(&CD180_RCSR);
eval 'sub CD180_TDR () {0x7b;}' unless defined(&CD180_TDR);
eval 'sub CD180_EOIR () {0x7f;}' unless defined(&CD180_EOIR);
eval 'sub CD180_CCR () {0x1;}' unless defined(&CD180_CCR);
eval 'sub CD180_IER () {0x2;}' unless defined(&CD180_IER);
eval 'sub CD180_COR1 () {0x3;}' unless defined(&CD180_COR1);
eval 'sub CD180_COR2 () {0x4;}' unless defined(&CD180_COR2);
eval 'sub CD180_COR3 () {0x5;}' unless defined(&CD180_COR3);
eval 'sub CD180_CCSR () {0x6;}' unless defined(&CD180_CCSR);
eval 'sub CD180_RDCR () {0x7;}' unless defined(&CD180_RDCR);
eval 'sub CD180_SCHR1 () {0x9;}' unless defined(&CD180_SCHR1);
eval 'sub CD180_SCHR2 () {0xa;}' unless defined(&CD180_SCHR2);
eval 'sub CD180_SCHR3 () {0xb;}' unless defined(&CD180_SCHR3);
eval 'sub CD180_SCHR4 () {0xc;}' unless defined(&CD180_SCHR4);
eval 'sub CD180_MCOR1 () {0x10;}' unless defined(&CD180_MCOR1);
eval 'sub CD180_MCOR2 () {0x11;}' unless defined(&CD180_MCOR2);
eval 'sub CD180_MCR () {0x12;}' unless defined(&CD180_MCR);
eval 'sub CD180_RTPR () {0x18;}' unless defined(&CD180_RTPR);
eval 'sub CD180_MSVR () {0x28;}' unless defined(&CD180_MSVR);
eval 'sub CD180_RBPRH () {0x31;}' unless defined(&CD180_RBPRH);
eval 'sub CD180_RBPRL () {0x32;}' unless defined(&CD180_RBPRL);
eval 'sub CD180_TBPRH () {0x39;}' unless defined(&CD180_TBPRH);
eval 'sub CD180_TBPRL () {0x3a;}' unless defined(&CD180_TBPRL);
eval 'sub GIVR_IT_MSCI () {0x1;}' unless defined(&GIVR_IT_MSCI);
eval 'sub GIVR_IT_TDI () {0x2;}' unless defined(&GIVR_IT_TDI);
eval 'sub GIVR_IT_RGDI () {0x3;}' unless defined(&GIVR_IT_RGDI);
eval 'sub GIVR_IT_REI () {0x7;}' unless defined(&GIVR_IT_REI);
eval 'sub GICR_CHAN () {0x1c;}' unless defined(&GICR_CHAN);
eval 'sub GICR_LSH () {2;}' unless defined(&GICR_LSH);
eval 'sub CAR_CHAN () {0x7;}' unless defined(&CAR_CHAN);
eval 'sub CAR_A7 () {0x8;}' unless defined(&CAR_A7);
eval 'sub RCSR_OE () {0x1;}' unless defined(&RCSR_OE);
eval 'sub RCSR_FE () {0x2;}' unless defined(&RCSR_FE);
eval 'sub RCSR_PE () {0x4;}' unless defined(&RCSR_PE);
eval 'sub RCSR_Break () {0x8;}' unless defined(&RCSR_Break);
eval 'sub RCSR_Timeout () {0x80;}' unless defined(&RCSR_Timeout);
eval 'sub RCSR_SCMASK () {0x70;}' unless defined(&RCSR_SCMASK);
eval 'sub RCSR_SC1 () {0x10;}' unless defined(&RCSR_SC1);
eval 'sub RCSR_SC2 () {0x20;}' unless defined(&RCSR_SC2);
eval 'sub RCSR_SC3 () {0x30;}' unless defined(&RCSR_SC3);
eval 'sub RCSR_SC4 () {0x40;}' unless defined(&RCSR_SC4);
eval 'sub CCR_ResetChan () {0x80;}' unless defined(&CCR_ResetChan);
eval 'sub CCR_HWRESET () {0x81;}' unless defined(&CCR_HWRESET);
eval 'sub CCR_CORCHG1 () {0x42;}' unless defined(&CCR_CORCHG1);
eval 'sub CCR_CORCHG2 () {0x44;}' unless defined(&CCR_CORCHG2);
eval 'sub CCR_CORCHG3 () {0x48;}' unless defined(&CCR_CORCHG3);
eval 'sub CCR_SENDSPCH1 () {0x21;}' unless defined(&CCR_SENDSPCH1);
eval 'sub CCR_SENDSPCH2 () {0x22;}' unless defined(&CCR_SENDSPCH2);
eval 'sub CCR_SENDSPCH3 () {0x23;}' unless defined(&CCR_SENDSPCH3);
eval 'sub CCR_SENDSPCH4 () {0x24;}' unless defined(&CCR_SENDSPCH4);
eval 'sub CCR_RCVRDIS () {0x11;}' unless defined(&CCR_RCVRDIS);
eval 'sub CCR_RCVREN () {0x12;}' unless defined(&CCR_RCVREN);
eval 'sub CCR_XMTRDIS () {0x14;}' unless defined(&CCR_XMTRDIS);
eval 'sub CCR_XMTREN () {0x18;}' unless defined(&CCR_XMTREN);
eval 'sub IER_DSR () {0x80;}' unless defined(&IER_DSR);
eval 'sub IER_CD () {0x40;}' unless defined(&IER_CD);
eval 'sub IER_CTS () {0x20;}' unless defined(&IER_CTS);
eval 'sub IER_RxData () {0x10;}' unless defined(&IER_RxData);
eval 'sub IER_RxSC () {0x8;}' unless defined(&IER_RxSC);
eval 'sub IER_TxRdy () {0x4;}' unless defined(&IER_TxRdy);
eval 'sub IER_TxMpty () {0x2;}' unless defined(&IER_TxMpty);
eval 'sub IER_RET () {0x1;}' unless defined(&IER_RET);
eval 'sub COR1_ODDP () {0x80;}' unless defined(&COR1_ODDP);
eval 'sub COR1_ParMMASK () {0x60;}' unless defined(&COR1_ParMMASK);
eval 'sub COR1_NOPAR () {0x2;}' unless defined(&COR1_NOPAR);
eval 'sub COR1_FORCEPAR () {0x20;}' unless defined(&COR1_FORCEPAR);
eval 'sub COR1_NORMPAR () {0x40;}' unless defined(&COR1_NORMPAR);
eval 'sub COR1_Ignore () {0x10;}' unless defined(&COR1_Ignore);
eval 'sub COR1_StopMASK () {0xc;}' unless defined(&COR1_StopMASK);
eval 'sub COR1_1SB () {0x;}' unless defined(&COR1_1SB);
eval 'sub COR1_15SB () {0x4;}' unless defined(&COR1_15SB);
eval 'sub COR1_2SB () {0x8;}' unless defined(&COR1_2SB);
eval 'sub COR1_CHLMASK () {0x3;}' unless defined(&COR1_CHLMASK);
eval 'sub COR1_5BITS () {0x;}' unless defined(&COR1_5BITS);
eval 'sub COR1_6BITS () {0x1;}' unless defined(&COR1_6BITS);
eval 'sub COR1_7BITS () {0x2;}' unless defined(&COR1_7BITS);
eval 'sub COR1_8BITS () {0x3;}' unless defined(&COR1_8BITS);
eval 'sub COR2_IXM () {0x80;}' unless defined(&COR2_IXM);
eval 'sub COR2_TxIBE () {0x40;}' unless defined(&COR2_TxIBE);
eval 'sub COR2_ETC () {0x20;}' unless defined(&COR2_ETC);
eval 'sub COR2_LLM () {0x10;}' unless defined(&COR2_LLM);
eval 'sub COR2_RLM () {0x8;}' unless defined(&COR2_RLM);
eval 'sub COR2_RtsAO () {0x4;}' unless defined(&COR2_RtsAO);
eval 'sub COR2_CtsAE () {0x2;}' unless defined(&COR2_CtsAE);
eval 'sub COR2_DsrAE () {0x1;}' unless defined(&COR2_DsrAE);
eval 'sub COR3_XonCH () {0x80;}' unless defined(&COR3_XonCH);
eval 'sub COR3_XoffCH () {0x40;}' unless defined(&COR3_XoffCH);
eval 'sub COR3_FCT () {0x20;}' unless defined(&COR3_FCT);
eval 'sub COR3_SCDE () {0x10;}' unless defined(&COR3_SCDE);
eval 'sub COR3_RxTHMASK () {0xf;}' unless defined(&COR3_RxTHMASK);
eval 'sub CCSR_RxEn () {0x80;}' unless defined(&CCSR_RxEn);
eval 'sub CCSR_RxFloff () {0x40;}' unless defined(&CCSR_RxFloff);
eval 'sub CCSR_RxFlon () {0x20;}' unless defined(&CCSR_RxFlon);
eval 'sub CCSR_TxEn () {0x8;}' unless defined(&CCSR_TxEn);
eval 'sub CCSR_TxFloff () {0x4;}' unless defined(&CCSR_TxFloff);
eval 'sub CCSR_TxFlon () {0x2;}' unless defined(&CCSR_TxFlon);
eval 'sub MCOR1_DSRzd () {0x80;}' unless defined(&MCOR1_DSRzd);
eval 'sub MCOR1_CDzd () {0x40;}' unless defined(&MCOR1_CDzd);
eval 'sub MCOR1_CTSzd () {0x20;}' unless defined(&MCOR1_CTSzd);
eval 'sub MCOR1_DTRthMASK () {0xf;}' unless defined(&MCOR1_DTRthMASK);
eval 'sub MCOR2_DSRod () {0x80;}' unless defined(&MCOR2_DSRod);
eval 'sub MCOR2_CDod () {0x40;}' unless defined(&MCOR2_CDod);
eval 'sub MCOR2_CTSod () {0x20;}' unless defined(&MCOR2_CTSod);
eval 'sub MCR_DSRchg () {0x80;}' unless defined(&MCR_DSRchg);
eval 'sub MCR_CDchg () {0x40;}' unless defined(&MCR_CDchg);
eval 'sub MCR_CTSchg () {0x20;}' unless defined(&MCR_CTSchg);
eval 'sub MSVR_DSR () {0x80;}' unless defined(&MSVR_DSR);
eval 'sub MSVR_CD () {0x40;}' unless defined(&MSVR_CD);
eval 'sub MSVR_CTS () {0x20;}' unless defined(&MSVR_CTS);
eval 'sub MSVR_DTR () {0x2;}' unless defined(&MSVR_DTR);
eval 'sub MSVR_RTS () {0x1;}' unless defined(&MSVR_RTS);
eval 'sub CD180_C_ESC () {0x;}' unless defined(&CD180_C_ESC);
eval 'sub CD180_C_SBRK () {0x81;}' unless defined(&CD180_C_SBRK);
eval 'sub CD180_C_DELAY () {0x82;}' unless defined(&CD180_C_DELAY);
eval 'sub CD180_C_EBRK () {0x83;}' unless defined(&CD180_C_EBRK);
eval 'sub CD180_NCHAN () {8;}' unless defined(&CD180_NCHAN);
eval 'sub CD180_CTICKS () {16;}' unless defined(&CD180_CTICKS);
eval 'sub CD180_NFIFO () {8;}' unless defined(&CD180_NFIFO);
1;
