require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_IC_QUICC_H_)) {
    eval 'sub _DEV_IC_QUICC_H_ () {1;}' unless defined(&_DEV_IC_QUICC_H_);
    eval 'sub QUICC_PRAM_BASE () {0x8000;}' unless defined(&QUICC_PRAM_BASE);
    eval 'sub QUICC_PRAM_REV_NUM () {( &QUICC_PRAM_BASE + 0xaf0);}' unless defined(&QUICC_PRAM_REV_NUM);
    eval 'sub QUICC_PRAM_SIZE_SCC () {256;}' unless defined(&QUICC_PRAM_SIZE_SCC);
    eval 'sub QUICC_PRAM_BASE_SCC {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE +  &QUICC_PRAM_SIZE_SCC * ($u)));
    }' unless defined(&QUICC_PRAM_BASE_SCC);
    eval 'sub QUICC_PRAM_SCC_RBASE {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x));
    }' unless defined(&QUICC_PRAM_SCC_RBASE);
    eval 'sub QUICC_PRAM_SCC_TBASE {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x2));
    }' unless defined(&QUICC_PRAM_SCC_TBASE);
    eval 'sub QUICC_PRAM_SCC_RFCR {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x4));
    }' unless defined(&QUICC_PRAM_SCC_RFCR);
    eval 'sub QUICC_PRAM_SCC_TFCR {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x5));
    }' unless defined(&QUICC_PRAM_SCC_TFCR);
    eval 'sub QUICC_PRAM_SCC_MRBLR {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x6));
    }' unless defined(&QUICC_PRAM_SCC_MRBLR);
    eval 'sub QUICC_PRAM_SCC_RBPTR {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x10));
    }' unless defined(&QUICC_PRAM_SCC_RBPTR);
    eval 'sub QUICC_PRAM_SCC_TBPTR {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x20));
    }' unless defined(&QUICC_PRAM_SCC_TBPTR);
    eval 'sub QUICC_PRAM_SIZE_SCC_UART () {0x68;}' unless defined(&QUICC_PRAM_SIZE_SCC_UART);
    eval 'sub QUICC_PRAM_SCC_UART_MAX_IDL {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x38));
    }' unless defined(&QUICC_PRAM_SCC_UART_MAX_IDL);
    eval 'sub QUICC_PRAM_SCC_UART_IDLC {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x3a));
    }' unless defined(&QUICC_PRAM_SCC_UART_IDLC);
    eval 'sub QUICC_PRAM_SCC_UART_BRKCR {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x3c));
    }' unless defined(&QUICC_PRAM_SCC_UART_BRKCR);
    eval 'sub QUICC_PRAM_SCC_UART_PAREC {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x3e));
    }' unless defined(&QUICC_PRAM_SCC_UART_PAREC);
    eval 'sub QUICC_PRAM_SCC_UART_FRMEC {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x40));
    }' unless defined(&QUICC_PRAM_SCC_UART_FRMEC);
    eval 'sub QUICC_PRAM_SCC_UART_NOSEC {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x42));
    }' unless defined(&QUICC_PRAM_SCC_UART_NOSEC);
    eval 'sub QUICC_PRAM_SCC_UART_BRKEC {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x44));
    }' unless defined(&QUICC_PRAM_SCC_UART_BRKEC);
    eval 'sub QUICC_PRAM_SCC_UART_BRKLN {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x46));
    }' unless defined(&QUICC_PRAM_SCC_UART_BRKLN);
    eval 'sub QUICC_PRAM_SCC_UART_UADDR1 {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x48));
    }' unless defined(&QUICC_PRAM_SCC_UART_UADDR1);
    eval 'sub QUICC_PRAM_SCC_UART_UADDR2 {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x4a));
    }' unless defined(&QUICC_PRAM_SCC_UART_UADDR2);
    eval 'sub QUICC_PRAM_SCC_UART_TOSEQ {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x4e));
    }' unless defined(&QUICC_PRAM_SCC_UART_TOSEQ);
    eval 'sub QUICC_PRAM_SCC_UART_CC {
        my($u,$n) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x50 + ($n)*2));
    }' unless defined(&QUICC_PRAM_SCC_UART_CC);
    eval 'sub QUICC_PRAM_SCC_UART_RCCM {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x60));
    }' unless defined(&QUICC_PRAM_SCC_UART_RCCM);
    eval 'sub QUICC_PRAM_SCC_UART_RCCR {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x62));
    }' unless defined(&QUICC_PRAM_SCC_UART_RCCR);
    eval 'sub QUICC_PRAM_SCC_UART_RLBC {
        my($u) = @_;
	    eval q(( &QUICC_PRAM_BASE_SCC($u) + 0x64));
    }' unless defined(&QUICC_PRAM_SCC_UART_RLBC);
    eval 'sub QUICC_REG_SICR () {0x10c00;}' unless defined(&QUICC_REG_SICR);
    eval 'sub QUICC_REG_SIVEC () {0x10c04;}' unless defined(&QUICC_REG_SIVEC);
    eval 'sub QUICC_REG_SIPNR_H () {0x10c08;}' unless defined(&QUICC_REG_SIPNR_H);
    eval 'sub QUICC_REG_SIPNR_L () {0x10c0c;}' unless defined(&QUICC_REG_SIPNR_L);
    eval 'sub QUICC_REG_SCPRR_H () {0x10c14;}' unless defined(&QUICC_REG_SCPRR_H);
    eval 'sub QUICC_REG_SCPRR_L () {0x10c18;}' unless defined(&QUICC_REG_SCPRR_L);
    eval 'sub QUICC_REG_SIMR_H () {0x10c1c;}' unless defined(&QUICC_REG_SIMR_H);
    eval 'sub QUICC_REG_SIMR_L () {0x10c20;}' unless defined(&QUICC_REG_SIMR_L);
    eval 'sub QUICC_REG_SIEXR () {0x10c24;}' unless defined(&QUICC_REG_SIEXR);
    eval 'sub QUICC_REG_SCCR () {0x10c80;}' unless defined(&QUICC_REG_SCCR);
    eval 'sub QUICC_REG_BRG {
        my($u) = @_;
	    eval q((0x119f0 + (($u) & 3) * 4- (($u) & 4) * 0x100));
    }' unless defined(&QUICC_REG_BRG);
    eval 'sub QUICC_REG_SIZE_SCC () {0x20;}' unless defined(&QUICC_REG_SIZE_SCC);
    eval 'sub QUICC_REG_BASE_SCC {
        my($u) = @_;
	    eval q((0x11a00 +  &QUICC_REG_SIZE_SCC * ($u)));
    }' unless defined(&QUICC_REG_BASE_SCC);
    eval 'sub QUICC_REG_SCC_GSMR_L {
        my($u) = @_;
	    eval q(( &QUICC_REG_BASE_SCC($u) + 0x));
    }' unless defined(&QUICC_REG_SCC_GSMR_L);
    eval 'sub QUICC_REG_SCC_GSMR_H {
        my($u) = @_;
	    eval q(( &QUICC_REG_BASE_SCC($u) + 0x4));
    }' unless defined(&QUICC_REG_SCC_GSMR_H);
    eval 'sub QUICC_REG_SCC_PSMR {
        my($u) = @_;
	    eval q(( &QUICC_REG_BASE_SCC($u) + 0x8));
    }' unless defined(&QUICC_REG_SCC_PSMR);
    eval 'sub QUICC_REG_SCC_TODR {
        my($u) = @_;
	    eval q(( &QUICC_REG_BASE_SCC($u) + 0xc));
    }' unless defined(&QUICC_REG_SCC_TODR);
    eval 'sub QUICC_REG_SCC_DSR {
        my($u) = @_;
	    eval q(( &QUICC_REG_BASE_SCC($u) + 0xe));
    }' unless defined(&QUICC_REG_SCC_DSR);
    eval 'sub QUICC_REG_SCC_SCCE {
        my($u) = @_;
	    eval q(( &QUICC_REG_BASE_SCC($u) + 0x10));
    }' unless defined(&QUICC_REG_SCC_SCCE);
    eval 'sub QUICC_REG_SCC_SCCM {
        my($u) = @_;
	    eval q(( &QUICC_REG_BASE_SCC($u) + 0x14));
    }' unless defined(&QUICC_REG_SCC_SCCM);
    eval 'sub QUICC_REG_SCC_SCCS {
        my($u) = @_;
	    eval q(( &QUICC_REG_BASE_SCC($u) + 0x17));
    }' unless defined(&QUICC_REG_SCC_SCCS);
}
1;
