require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_WD33C93REG_H_)) {
    eval 'sub _WD33C93REG_H_ () {1;}' unless defined(&_WD33C93REG_H_);
    eval 'sub wd3s_oid () {0x;}' unless defined(&wd3s_oid);
    eval 'sub IDR_FS_16_20 () {0x80;}' unless defined(&IDR_FS_16_20);
    eval 'sub IDR_FS_12_15 () {0x40;}' unless defined(&IDR_FS_12_15);
    eval 'sub IDR_FS_8_10 () {0x;}' unless defined(&IDR_FS_8_10);
    eval 'sub IDR_RAF () {0x20;}' unless defined(&IDR_RAF);
    eval 'sub IDR_EHP () {0x10;}' unless defined(&IDR_EHP);
    eval 'sub IDR_EAF () {0x8;}' unless defined(&IDR_EAF);
    eval 'sub IDR_IDM () {0x7;}' unless defined(&IDR_IDM);
    eval 'sub wd3s_ctrl () {0x1;}' unless defined(&wd3s_ctrl);
    eval 'sub CR_DMA () {0x80;}' unless defined(&CR_DMA);
    eval 'sub CR_DMAD () {0x40;}' unless defined(&CR_DMAD);
    eval 'sub CR_HLT_HOST_PARITY () {0x10;}' unless defined(&CR_HLT_HOST_PARITY);
    eval 'sub CR_DIS_INT () {0x8;}' unless defined(&CR_DIS_INT);
    eval 'sub CR_IDIS_INT () {0x4;}' unless defined(&CR_IDIS_INT);
    eval 'sub CR_HLT_ATN () {0x2;}' unless defined(&CR_HLT_ATN);
    eval 'sub CR_HLT_BUS_PARITY () {0x1;}' unless defined(&CR_HLT_BUS_PARITY);
    eval 'sub CR_DEFAULT () {( &CR_DIS_INT |  &CR_IDIS_INT);}' unless defined(&CR_DEFAULT);
    eval 'sub CR_DEFAULT_HP () {( &CR_DEFAULT |  &CR_HLT_BUS_PARITY);}' unless defined(&CR_DEFAULT_HP);
    eval 'sub wd3s_tout () {0x2;}' unless defined(&wd3s_tout);
    eval 'sub wd3s_cdb () {0x3;}' unless defined(&wd3s_cdb);
    eval 'sub wd3s_lun () {0xf;}' unless defined(&wd3s_lun);
    eval 'sub wd3s_cph () {0x10;}' unless defined(&wd3s_cph);
    eval 'sub wd3s_synch () {0x11;}' unless defined(&wd3s_synch);
    eval 'sub wd3s_cnt () {0x12;}' unless defined(&wd3s_cnt);
    eval 'sub wd3s_did () {0x15;}' unless defined(&wd3s_did);
    eval 'sub DIDR_SCC () {0x80;}' unless defined(&DIDR_SCC);
    eval 'sub DIDR_DPD () {0x40;}' unless defined(&DIDR_DPD);
    eval 'sub wd3s_sid () {0x16;}' unless defined(&wd3s_sid);
    eval 'sub SIDR_RESEL () {0x80;}' unless defined(&SIDR_RESEL);
    eval 'sub SIDR_SEL () {0x40;}' unless defined(&SIDR_SEL);
    eval 'sub SIDR_VALID () {0x8;}' unless defined(&SIDR_VALID);
    eval 'sub SIDR_IDM () {0x7;}' unless defined(&SIDR_IDM);
    eval 'sub wd3s_stat () {0x17;}' unless defined(&wd3s_stat);
    eval 'sub BSR_CM () {0xf0;}' unless defined(&BSR_CM);
    eval 'sub BSR_CMDCPL () {0x10;}' unless defined(&BSR_CMDCPL);
    eval 'sub BSR_CMDABT () {0x20;}' unless defined(&BSR_CMDABT);
    eval 'sub BSR_CMDERR () {0x40;}' unless defined(&BSR_CMDERR);
    eval 'sub BSR_CMDREQ () {0x80;}' unless defined(&BSR_CMDREQ);
    eval 'sub BSR_SM () {0xf;}' unless defined(&BSR_SM);
    eval 'sub BSR_PM () {0x7;}' unless defined(&BSR_PM);
    eval 'sub BSR_PHVALID () {0x8;}' unless defined(&BSR_PHVALID);
    eval 'sub BSR_IOR () {0x1;}' unless defined(&BSR_IOR);
    eval 'sub BSR_DATAOUT () {0x;}' unless defined(&BSR_DATAOUT);
    eval 'sub BSR_DATAIN () {0x1;}' unless defined(&BSR_DATAIN);
    eval 'sub BSR_CMDOUT () {0x2;}' unless defined(&BSR_CMDOUT);
    eval 'sub BSR_STATIN () {0x3;}' unless defined(&BSR_STATIN);
    eval 'sub BSR_UNSPINFO0 () {0x4;}' unless defined(&BSR_UNSPINFO0);
    eval 'sub BSR_UNSPINFO1 () {0x5;}' unless defined(&BSR_UNSPINFO1);
    eval 'sub BSR_MSGOUT () {0x6;}' unless defined(&BSR_MSGOUT);
    eval 'sub BSR_MSGIN () {0x7;}' unless defined(&BSR_MSGIN);
    eval 'sub BSR_RESET () {0x;}' unless defined(&BSR_RESET);
    eval 'sub BSR_AFM_RESET () {0x1;}' unless defined(&BSR_AFM_RESET);
    eval 'sub BSR_SELECTED () {0x11;}' unless defined(&BSR_SELECTED);
    eval 'sub BSR_SATFIN () {0x16;}' unless defined(&BSR_SATFIN);
    eval 'sub BSR_ACKREQ () {0x20;}' unless defined(&BSR_ACKREQ);
    eval 'sub BSR_SATSDP () {0x21;}' unless defined(&BSR_SATSDP);
    eval 'sub BSR_RESEL () {0x80;}' unless defined(&BSR_RESEL);
    eval 'sub BSR_AFM_RESEL () {0x81;}' unless defined(&BSR_AFM_RESEL);
    eval 'sub BSR_DISC () {0x85;}' unless defined(&BSR_DISC);
    eval 'sub wd3s_cmd () {0x18;}' unless defined(&wd3s_cmd);
    eval 'sub wd3s_data () {0x19;}' unless defined(&wd3s_data);
    eval 'sub wd3s_qtag () {0x1a;}' unless defined(&wd3s_qtag);
    eval 'sub wd3s_mbank () {0x30;}' unless defined(&wd3s_mbank);
    eval 'sub MBR_RST () {0x2;}' unless defined(&MBR_RST);
    eval 'sub MBR_IEN () {0x4;}' unless defined(&MBR_IEN);
    eval 'sub wd3s_mwin () {0x31;}' unless defined(&wd3s_mwin);
    eval 'sub wd3s_auxc () {0x33;}' unless defined(&wd3s_auxc);
    eval 'sub AUXCR_HIDM () {0x7;}' unless defined(&AUXCR_HIDM);
    eval 'sub AUXCR_INTM () {0x38;}' unless defined(&AUXCR_INTM);
    eval 'sub AUXCR_RRST () {0x80;}' unless defined(&AUXCR_RRST);
    eval 'sub STR_INT () {0x80;}' unless defined(&STR_INT);
    eval 'sub STR_LCI () {0x40;}' unless defined(&STR_LCI);
    eval 'sub STR_BSY () {0x20;}' unless defined(&STR_BSY);
    eval 'sub STR_CIP () {0x10;}' unless defined(&STR_CIP);
    eval 'sub STR_PE () {0x2;}' unless defined(&STR_PE);
    eval 'sub STR_DBR () {0x1;}' unless defined(&STR_DBR);
    eval 'sub STR_BUSY () {0xf0;}' unless defined(&STR_BUSY);
    eval 'sub CMDP_DMES () {0x1;}' unless defined(&CMDP_DMES);
    eval 'sub CMDP_DMER () {0x2;}' unless defined(&CMDP_DMER);
    eval 'sub CMDP_TCMS () {0x4;}' unless defined(&CMDP_TCMS);
    eval 'sub CMDP_TCMR () {0x8;}' unless defined(&CMDP_TCMR);
    eval 'sub CMDP_TCIR () {0x10;}' unless defined(&CMDP_TCIR);
    eval 'sub WD3S_SBT () {0x80;}' unless defined(&WD3S_SBT);
    eval 'sub WD3S_RESET () {0x;}' unless defined(&WD3S_RESET);
    eval 'sub WD3S_ABORT () {0x1;}' unless defined(&WD3S_ABORT);
    eval 'sub WD3S_ASSERT_ATN () {0x2;}' unless defined(&WD3S_ASSERT_ATN);
    eval 'sub WD3S_NEGATE_ACK () {0x3;}' unless defined(&WD3S_NEGATE_ACK);
    eval 'sub WD3S_DISCONNECT () {0x4;}' unless defined(&WD3S_DISCONNECT);
    eval 'sub WD3S_RESELECT () {0x5;}' unless defined(&WD3S_RESELECT);
    eval 'sub WD3S_SELECT_ATN () {0x6;}' unless defined(&WD3S_SELECT_ATN);
    eval 'sub WD3S_SELECT_NO_ATN () {0x7;}' unless defined(&WD3S_SELECT_NO_ATN);
    eval 'sub WD3S_SELECT_ATN_TFR () {0x8;}' unless defined(&WD3S_SELECT_ATN_TFR);
    eval 'sub WD3S_SELECT_NO_ATN_TFR () {0x9;}' unless defined(&WD3S_SELECT_NO_ATN_TFR);
    eval 'sub WD3S_RESELECT_RCV_DATA () {0xa;}' unless defined(&WD3S_RESELECT_RCV_DATA);
    eval 'sub WD3S_RESELECT_SEND_DATA () {0xb;}' unless defined(&WD3S_RESELECT_SEND_DATA);
    eval 'sub WD3S_WAIT_SELECT_RCV () {0xc;}' unless defined(&WD3S_WAIT_SELECT_RCV);
    eval 'sub WD3S_CMD_COMPSEQ () {0xd;}' unless defined(&WD3S_CMD_COMPSEQ);
    eval 'sub WD3S_SEND_DISC_MSG () {0xe;}' unless defined(&WD3S_SEND_DISC_MSG);
    eval 'sub WD3S_SET_IDI () {0xf;}' unless defined(&WD3S_SET_IDI);
    eval 'sub WD3S_RCV_CMD () {0x10;}' unless defined(&WD3S_RCV_CMD);
    eval 'sub WD3S_RCV_DATA () {0x11;}' unless defined(&WD3S_RCV_DATA);
    eval 'sub WD3S_RCV_MSG_OUT () {0x12;}' unless defined(&WD3S_RCV_MSG_OUT);
    eval 'sub WD3S_RCV_UNSP_INFO_OUT () {0x13;}' unless defined(&WD3S_RCV_UNSP_INFO_OUT);
    eval 'sub WD3S_SEND_STATUS () {0x14;}' unless defined(&WD3S_SEND_STATUS);
    eval 'sub WD3S_SEND_DATA () {0x15;}' unless defined(&WD3S_SEND_DATA);
    eval 'sub WD3S_SEND_MSG_IN () {0x16;}' unless defined(&WD3S_SEND_MSG_IN);
    eval 'sub WD3S_SEND_UNSP_INFO_IN () {0x17;}' unless defined(&WD3S_SEND_UNSP_INFO_IN);
    eval 'sub WD3S_TRANSLATE_ADDRESS () {0x18;}' unless defined(&WD3S_TRANSLATE_ADDRESS);
    eval 'sub WD3S_TFR_INFO () {0x20;}' unless defined(&WD3S_TFR_INFO);
}
1;
