require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_IC_Z8530_H_)) {
    eval 'sub _DEV_IC_Z8530_H_ () {1;}' unless defined(&_DEV_IC_Z8530_H_);
    eval 'sub CHAN_A () {2;}' unless defined(&CHAN_A);
    eval 'sub CHAN_B () {0;}' unless defined(&CHAN_B);
    eval 'sub REG_CTRL () {0;}' unless defined(&REG_CTRL);
    eval 'sub REG_DATA () {1;}' unless defined(&REG_DATA);
    eval 'sub WR_CR () {0;}' unless defined(&WR_CR);
    eval 'sub WR_IDT () {1;}' unless defined(&WR_IDT);
    eval 'sub WR_IV () {2;}' unless defined(&WR_IV);
    eval 'sub WR_RPC () {3;}' unless defined(&WR_RPC);
    eval 'sub WR_MPM () {4;}' unless defined(&WR_MPM);
    eval 'sub WR_TPC () {5;}' unless defined(&WR_TPC);
    eval 'sub WR_SCAF () {6;}' unless defined(&WR_SCAF);
    eval 'sub WR_SCF () {7;}' unless defined(&WR_SCF);
    eval 'sub WR_EFC () {7;}' unless defined(&WR_EFC);
    eval 'sub WR_TB () {8;}' unless defined(&WR_TB);
    eval 'sub WR_MIC () {9;}' unless defined(&WR_MIC);
    eval 'sub WR_MCB1 () {10;}' unless defined(&WR_MCB1);
    eval 'sub WR_CMC () {11;}' unless defined(&WR_CMC);
    eval 'sub WR_TCL () {12;}' unless defined(&WR_TCL);
    eval 'sub WR_TCH () {13;}' unless defined(&WR_TCH);
    eval 'sub WR_MCB2 () {14;}' unless defined(&WR_MCB2);
    eval 'sub WR_IC () {15;}' unless defined(&WR_IC);
    eval 'sub RR_BES () {0;}' unless defined(&RR_BES);
    eval 'sub RR_SRC () {1;}' unless defined(&RR_SRC);
    eval 'sub RR_IV () {2;}' unless defined(&RR_IV);
    eval 'sub RR_IP () {3;}' unless defined(&RR_IP);
    eval 'sub RR_MPM () {4;}' unless defined(&RR_MPM);
    eval 'sub RR_TPC () {5;}' unless defined(&RR_TPC);
    eval 'sub RR_BCL () {6;}' unless defined(&RR_BCL);
    eval 'sub RR_BCH () {7;}' unless defined(&RR_BCH);
    eval 'sub RR_RB () {8;}' unless defined(&RR_RB);
    eval 'sub RR_RPC () {9;}' unless defined(&RR_RPC);
    eval 'sub RR_MSB () {10;}' unless defined(&RR_MSB);
    eval 'sub RR_MCB1 () {11;}' unless defined(&RR_MCB1);
    eval 'sub RR_TCL () {12;}' unless defined(&RR_TCL);
    eval 'sub RR_TCH () {13;}' unless defined(&RR_TCH);
    eval 'sub RR_EFC () {14;}' unless defined(&RR_EFC);
    eval 'sub RR_IC () {15;}' unless defined(&RR_IC);
    eval 'sub BES_BRK () {0x80;}' unless defined(&BES_BRK);
    eval 'sub BES_TXU () {0x40;}' unless defined(&BES_TXU);
    eval 'sub BES_CTS () {0x20;}' unless defined(&BES_CTS);
    eval 'sub BES_SYNC () {0x10;}' unless defined(&BES_SYNC);
    eval 'sub BES_DCD () {0x8;}' unless defined(&BES_DCD);
    eval 'sub BES_TXE () {0x4;}' unless defined(&BES_TXE);
    eval 'sub BES_ZC () {0x2;}' unless defined(&BES_ZC);
    eval 'sub BES_RXA () {0x1;}' unless defined(&BES_RXA);
    eval 'sub CMC_XTAL () {0x80;}' unless defined(&CMC_XTAL);
    eval 'sub CMC_RC_DPLL () {0x60;}' unless defined(&CMC_RC_DPLL);
    eval 'sub CMC_RC_BRG () {0x40;}' unless defined(&CMC_RC_BRG);
    eval 'sub CMC_RC_TRXC () {0x20;}' unless defined(&CMC_RC_TRXC);
    eval 'sub CMC_RC_RTXC () {0x;}' unless defined(&CMC_RC_RTXC);
    eval 'sub CMC_TC_DPLL () {0x18;}' unless defined(&CMC_TC_DPLL);
    eval 'sub CMC_TC_BRG () {0x10;}' unless defined(&CMC_TC_BRG);
    eval 'sub CMC_TC_TRXC () {0x8;}' unless defined(&CMC_TC_TRXC);
    eval 'sub CMC_TC_RTXC () {0x;}' unless defined(&CMC_TC_RTXC);
    eval 'sub CMC_TRXC_OUT () {0x4;}' unless defined(&CMC_TRXC_OUT);
    eval 'sub CMC_TRXC_DPLL () {0x3;}' unless defined(&CMC_TRXC_DPLL);
    eval 'sub CMC_TRXC_BRG () {0x2;}' unless defined(&CMC_TRXC_BRG);
    eval 'sub CMC_TRXC_XMIT () {0x1;}' unless defined(&CMC_TRXC_XMIT);
    eval 'sub CMC_TRXC_XTAL () {0x;}' unless defined(&CMC_TRXC_XTAL);
    eval 'sub CR_RSTTXU () {0xc0;}' unless defined(&CR_RSTTXU);
    eval 'sub CR_RSTTXCRC () {0x80;}' unless defined(&CR_RSTTXCRC);
    eval 'sub CR_RSTRXCRC () {0x40;}' unless defined(&CR_RSTRXCRC);
    eval 'sub CR_RSTIUS () {0x38;}' unless defined(&CR_RSTIUS);
    eval 'sub CR_RSTERR () {0x30;}' unless defined(&CR_RSTERR);
    eval 'sub CR_RSTTXI () {0x28;}' unless defined(&CR_RSTTXI);
    eval 'sub CR_ENARXI () {0x20;}' unless defined(&CR_ENARXI);
    eval 'sub CR_ABORT () {0x18;}' unless defined(&CR_ABORT);
    eval 'sub CR_RSTXSI () {0x10;}' unless defined(&CR_RSTXSI);
    eval 'sub EFC_ERE () {0x40;}' unless defined(&EFC_ERE);
    eval 'sub EFC_FE () {0x20;}' unless defined(&EFC_FE);
    eval 'sub EFC_RQT () {0x10;}' unless defined(&EFC_RQT);
    eval 'sub EFC_FHF () {0x8;}' unless defined(&EFC_FHF);
    eval 'sub EFC_RTS () {0x4;}' unless defined(&EFC_RTS);
    eval 'sub EFC_EOM () {0x2;}' unless defined(&EFC_EOM);
    eval 'sub EFC_FLAG () {0x1;}' unless defined(&EFC_FLAG);
    eval 'sub IC_BRK () {0x80;}' unless defined(&IC_BRK);
    eval 'sub IC_TXU () {0x40;}' unless defined(&IC_TXU);
    eval 'sub IC_CTS () {0x20;}' unless defined(&IC_CTS);
    eval 'sub IC_SYNC () {0x10;}' unless defined(&IC_SYNC);
    eval 'sub IC_DCD () {0x8;}' unless defined(&IC_DCD);
    eval 'sub IC_FIFO () {0x4;}' unless defined(&IC_FIFO);
    eval 'sub IC_ZC () {0x2;}' unless defined(&IC_ZC);
    eval 'sub IC_EF () {0x1;}' unless defined(&IC_EF);
    eval 'sub IDT_WRE () {0x80;}' unless defined(&IDT_WRE);
    eval 'sub IDT_REQ () {0x40;}' unless defined(&IDT_REQ);
    eval 'sub IDT_WRR () {0x20;}' unless defined(&IDT_WRR);
    eval 'sub IDT_RISC () {0x18;}' unless defined(&IDT_RISC);
    eval 'sub IDT_RIA () {0x10;}' unless defined(&IDT_RIA);
    eval 'sub IDT_RIF () {0x8;}' unless defined(&IDT_RIF);
    eval 'sub IDT_PSC () {0x4;}' unless defined(&IDT_PSC);
    eval 'sub IDT_TIE () {0x2;}' unless defined(&IDT_TIE);
    eval 'sub IDT_XIE () {0x1;}' unless defined(&IDT_XIE);
    eval 'sub IP_RIA () {0x20;}' unless defined(&IP_RIA);
    eval 'sub IP_TIA () {0x10;}' unless defined(&IP_TIA);
    eval 'sub IP_SIA () {0x8;}' unless defined(&IP_SIA);
    eval 'sub IP_RIB () {0x4;}' unless defined(&IP_RIB);
    eval 'sub IP_TIB () {0x2;}' unless defined(&IP_TIB);
    eval 'sub IP_SIB () {0x1;}' unless defined(&IP_SIB);
    eval 'sub IV_SCA () {0xe;}' unless defined(&IV_SCA);
    eval 'sub IV_RAA () {0xc;}' unless defined(&IV_RAA);
    eval 'sub IV_XSA () {0xa;}' unless defined(&IV_XSA);
    eval 'sub IV_TEA () {0x8;}' unless defined(&IV_TEA);
    eval 'sub IV_SCB () {0x6;}' unless defined(&IV_SCB);
    eval 'sub IV_RAB () {0x4;}' unless defined(&IV_RAB);
    eval 'sub IV_XSB () {0x2;}' unless defined(&IV_XSB);
    eval 'sub IV_TEB () {0x;}' unless defined(&IV_TEB);
    eval 'sub MCB1_CRC1 () {0x80;}' unless defined(&MCB1_CRC1);
    eval 'sub MCB1_FM0 () {0x60;}' unless defined(&MCB1_FM0);
    eval 'sub MCB1_FM1 () {0x40;}' unless defined(&MCB1_FM1);
    eval 'sub MCB1_NRZI () {0x20;}' unless defined(&MCB1_NRZI);
    eval 'sub MCB1_NRZ () {0x;}' unless defined(&MCB1_NRZ);
    eval 'sub MCB1_AOP () {0x10;}' unless defined(&MCB1_AOP);
    eval 'sub MCB1_MI () {0x8;}' unless defined(&MCB1_MI);
    eval 'sub MCB1_AOU () {0x4;}' unless defined(&MCB1_AOU);
    eval 'sub MCB1_LM () {0x2;}' unless defined(&MCB1_LM);
    eval 'sub MCB1_SIX () {0x1;}' unless defined(&MCB1_SIX);
    eval 'sub MCB2_NRZI () {0xe0;}' unless defined(&MCB2_NRZI);
    eval 'sub MCB2_FM () {0xc0;}' unless defined(&MCB2_FM);
    eval 'sub MCB2_RTXC () {0xa0;}' unless defined(&MCB2_RTXC);
    eval 'sub MCB2_BRG () {0x80;}' unless defined(&MCB2_BRG);
    eval 'sub MCB2_OFF () {0x60;}' unless defined(&MCB2_OFF);
    eval 'sub MCB2_RMC () {0x40;}' unless defined(&MCB2_RMC);
    eval 'sub MCB2_ESM () {0x20;}' unless defined(&MCB2_ESM);
    eval 'sub MCB2_LL () {0x10;}' unless defined(&MCB2_LL);
    eval 'sub MCB2_AE () {0x8;}' unless defined(&MCB2_AE);
    eval 'sub MCB2_REQ () {0x4;}' unless defined(&MCB2_REQ);
    eval 'sub MCB2_PCLK () {0x2;}' unless defined(&MCB2_PCLK);
    eval 'sub MCB2_BRGE () {0x1;}' unless defined(&MCB2_BRGE);
    eval 'sub MIC_FHR () {0xc0;}' unless defined(&MIC_FHR);
    eval 'sub MIC_CRA () {0x80;}' unless defined(&MIC_CRA);
    eval 'sub MIC_CRB () {0x40;}' unless defined(&MIC_CRB);
    eval 'sub MIC_SIE () {0x20;}' unless defined(&MIC_SIE);
    eval 'sub MIC_SH () {0x10;}' unless defined(&MIC_SH);
    eval 'sub MIC_MIE () {0x8;}' unless defined(&MIC_MIE);
    eval 'sub MIC_DLC () {0x4;}' unless defined(&MIC_DLC);
    eval 'sub MIC_NV () {0x2;}' unless defined(&MIC_NV);
    eval 'sub MIC_VIS () {0x1;}' unless defined(&MIC_VIS);
    eval 'sub MPM_CM64 () {0xc0;}' unless defined(&MPM_CM64);
    eval 'sub MPM_CM32 () {0x80;}' unless defined(&MPM_CM32);
    eval 'sub MPM_CM16 () {0x40;}' unless defined(&MPM_CM16);
    eval 'sub MPM_CM1 () {0x;}' unless defined(&MPM_CM1);
    eval 'sub MPM_EXT () {0x30;}' unless defined(&MPM_EXT);
    eval 'sub MPM_SDLC () {0x20;}' unless defined(&MPM_SDLC);
    eval 'sub MPM_BI () {0x10;}' unless defined(&MPM_BI);
    eval 'sub MPM_MONO () {0x;}' unless defined(&MPM_MONO);
    eval 'sub MPM_SB2 () {0xc;}' unless defined(&MPM_SB2);
    eval 'sub MPM_SB15 () {0x8;}' unless defined(&MPM_SB15);
    eval 'sub MPM_SB1 () {0x4;}' unless defined(&MPM_SB1);
    eval 'sub MPM_SYNC () {0x;}' unless defined(&MPM_SYNC);
    eval 'sub MPM_EVEN () {0x2;}' unless defined(&MPM_EVEN);
    eval 'sub MPM_PE () {0x1;}' unless defined(&MPM_PE);
    eval 'sub RPC_RB8 () {0xc0;}' unless defined(&RPC_RB8);
    eval 'sub RPC_RB6 () {0x80;}' unless defined(&RPC_RB6);
    eval 'sub RPC_RB7 () {0x40;}' unless defined(&RPC_RB7);
    eval 'sub RPC_RB5 () {0x;}' unless defined(&RPC_RB5);
    eval 'sub RPC_AE () {0x20;}' unless defined(&RPC_AE);
    eval 'sub RPC_EHM () {0x10;}' unless defined(&RPC_EHM);
    eval 'sub RPC_CRC () {0x8;}' unless defined(&RPC_CRC);
    eval 'sub RPC_ASM () {0x4;}' unless defined(&RPC_ASM);
    eval 'sub RPC_LI () {0x2;}' unless defined(&RPC_LI);
    eval 'sub RPC_RXE () {0x1;}' unless defined(&RPC_RXE);
    eval 'sub SRC_EOF () {0x80;}' unless defined(&SRC_EOF);
    eval 'sub SRC_FE () {0x40;}' unless defined(&SRC_FE);
    eval 'sub SRC_OVR () {0x20;}' unless defined(&SRC_OVR);
    eval 'sub SRC_PE () {0x10;}' unless defined(&SRC_PE);
    eval 'sub SRC_RC0 () {0x8;}' unless defined(&SRC_RC0);
    eval 'sub SRC_RC1 () {0x4;}' unless defined(&SRC_RC1);
    eval 'sub SRC_RC2 () {0x2;}' unless defined(&SRC_RC2);
    eval 'sub SRC_AS () {0x1;}' unless defined(&SRC_AS);
    eval 'sub TPC_DTR () {0x80;}' unless defined(&TPC_DTR);
    eval 'sub TPC_TB8 () {0x60;}' unless defined(&TPC_TB8);
    eval 'sub TPC_TB6 () {0x40;}' unless defined(&TPC_TB6);
    eval 'sub TPC_TB7 () {0x20;}' unless defined(&TPC_TB7);
    eval 'sub TPC_TB5 () {0x;}' unless defined(&TPC_TB5);
    eval 'sub TPC_BRK () {0x10;}' unless defined(&TPC_BRK);
    eval 'sub TPC_TXE () {0x8;}' unless defined(&TPC_TXE);
    eval 'sub TPC_CRC16 () {0x4;}' unless defined(&TPC_CRC16);
    eval 'sub TPC_RTS () {0x2;}' unless defined(&TPC_RTS);
    eval 'sub TPC_CRC () {0x1;}' unless defined(&TPC_CRC);
}
1;
