require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&IF_LMC_H)) {
    eval 'sub IF_LMC_H () {1;}' unless defined(&IF_LMC_H);
    eval 'sub DEVICE_NAME () {"lmc";}' unless defined(&DEVICE_NAME);
    eval 'sub DRIVER_MAJOR_VERSION () {2005;}' unless defined(&DRIVER_MAJOR_VERSION);
    eval 'sub DRIVER_MINOR_VERSION () {9;}' unless defined(&DRIVER_MINOR_VERSION);
    eval 'sub DRIVER_SUB_VERSION () {29;}' unless defined(&DRIVER_SUB_VERSION);
    eval 'sub NG_LMC_NODE_TYPE () { &DEVICE_NAME;}' unless defined(&NG_LMC_NODE_TYPE);
    eval 'sub NGM_LMC_COOKIE () {1128054761;}' unless defined(&NGM_LMC_COOKIE);
    eval 'sub TLP_CFID () {0x;}' unless defined(&TLP_CFID);
    eval 'sub TLP_CFCS () {0x4;}' unless defined(&TLP_CFCS);
    eval 'sub TLP_CFRV () {0x8;}' unless defined(&TLP_CFRV);
    eval 'sub TLP_CFLT () {0xc;}' unless defined(&TLP_CFLT);
    eval 'sub TLP_CBIO () {0x10;}' unless defined(&TLP_CBIO);
    eval 'sub TLP_CBMA () {0x14;}' unless defined(&TLP_CBMA);
    eval 'sub TLP_CSID () {0x2c;}' unless defined(&TLP_CSID);
    eval 'sub TLP_CFIT () {0x3c;}' unless defined(&TLP_CFIT);
    eval 'sub TLP_CFDD () {0x40;}' unless defined(&TLP_CFDD);
    eval 'sub TLP_CFID_TULIP () {0x91011;}' unless defined(&TLP_CFID_TULIP);
    eval 'sub TLP_CFCS_MSTR_ABORT () {0x20000000;}' unless defined(&TLP_CFCS_MSTR_ABORT);
    eval 'sub TLP_CFCS_TARG_ABORT () {0x10000000;}' unless defined(&TLP_CFCS_TARG_ABORT);
    eval 'sub TLP_CFCS_SYS_ERROR () {0x100;}' unless defined(&TLP_CFCS_SYS_ERROR);
    eval 'sub TLP_CFCS_PAR_ERROR () {0x40;}' unless defined(&TLP_CFCS_PAR_ERROR);
    eval 'sub TLP_CFCS_MWI_ENABLE () {0x10;}' unless defined(&TLP_CFCS_MWI_ENABLE);
    eval 'sub TLP_CFCS_BUS_MASTER () {0x4;}' unless defined(&TLP_CFCS_BUS_MASTER);
    eval 'sub TLP_CFCS_MEM_ENABLE () {0x2;}' unless defined(&TLP_CFCS_MEM_ENABLE);
    eval 'sub TLP_CFCS_IO_ENABLE () {0x1;}' unless defined(&TLP_CFCS_IO_ENABLE);
    eval 'sub TLP_CFLT_LATENCY () {0xff00;}' unless defined(&TLP_CFLT_LATENCY);
    eval 'sub TLP_CFLT_CACHE () {0xff;}' unless defined(&TLP_CFLT_CACHE);
    eval 'sub TLP_CSID_HSSI () {0x31376;}' unless defined(&TLP_CSID_HSSI);
    eval 'sub TLP_CSID_T3 () {0x41376;}' unless defined(&TLP_CSID_T3);
    eval 'sub TLP_CSID_SSI () {0x51376;}' unless defined(&TLP_CSID_SSI);
    eval 'sub TLP_CSID_T1E1 () {0x61376;}' unless defined(&TLP_CSID_T1E1);
    eval 'sub TLP_CSID_HSSIc () {0x71376;}' unless defined(&TLP_CSID_HSSIc);
    eval 'sub TLP_CSID_SDSL () {0x81376;}' unless defined(&TLP_CSID_SDSL);
    eval 'sub TLP_CFIT_MAX_LAT () {0xff000000;}' unless defined(&TLP_CFIT_MAX_LAT);
    eval 'sub TLP_CFDD_SLEEP () {0x80000000;}' unless defined(&TLP_CFDD_SLEEP);
    eval 'sub TLP_CFDD_SNOOZE () {0x40000000;}' unless defined(&TLP_CFDD_SNOOZE);
    eval 'sub TLP_CSR_STRIDE () {8;}' unless defined(&TLP_CSR_STRIDE);
    eval 'sub TLP_BUS_MODE () {0*  &TLP_CSR_STRIDE;}' unless defined(&TLP_BUS_MODE);
    eval 'sub TLP_TX_POLL () {1*  &TLP_CSR_STRIDE;}' unless defined(&TLP_TX_POLL);
    eval 'sub TLP_RX_POLL () {2*  &TLP_CSR_STRIDE;}' unless defined(&TLP_RX_POLL);
    eval 'sub TLP_RX_LIST () {3*  &TLP_CSR_STRIDE;}' unless defined(&TLP_RX_LIST);
    eval 'sub TLP_TX_LIST () {4*  &TLP_CSR_STRIDE;}' unless defined(&TLP_TX_LIST);
    eval 'sub TLP_STATUS () {5*  &TLP_CSR_STRIDE;}' unless defined(&TLP_STATUS);
    eval 'sub TLP_OP_MODE () {6*  &TLP_CSR_STRIDE;}' unless defined(&TLP_OP_MODE);
    eval 'sub TLP_INT_ENBL () {7*  &TLP_CSR_STRIDE;}' unless defined(&TLP_INT_ENBL);
    eval 'sub TLP_MISSED () {8*  &TLP_CSR_STRIDE;}' unless defined(&TLP_MISSED);
    eval 'sub TLP_SROM_MII () {9*  &TLP_CSR_STRIDE;}' unless defined(&TLP_SROM_MII);
    eval 'sub TLP_BIOS_ROM () {10*  &TLP_CSR_STRIDE;}' unless defined(&TLP_BIOS_ROM);
    eval 'sub TLP_TIMER () {11*  &TLP_CSR_STRIDE;}' unless defined(&TLP_TIMER);
    eval 'sub TLP_GPIO () {12*  &TLP_CSR_STRIDE;}' unless defined(&TLP_GPIO);
    eval 'sub TLP_CSR13 () {13*  &TLP_CSR_STRIDE;}' unless defined(&TLP_CSR13);
    eval 'sub TLP_CSR14 () {14*  &TLP_CSR_STRIDE;}' unless defined(&TLP_CSR14);
    eval 'sub TLP_WDOG () {15*  &TLP_CSR_STRIDE;}' unless defined(&TLP_WDOG);
    eval 'sub TLP_CSR_SIZE () {128;}' unless defined(&TLP_CSR_SIZE);
    eval 'sub TLP_BUS_WRITE_INVAL () {0x1000000;}' unless defined(&TLP_BUS_WRITE_INVAL);
    eval 'sub TLP_BUS_READ_LINE () {0x800000;}' unless defined(&TLP_BUS_READ_LINE);
    eval 'sub TLP_BUS_READ_MULT () {0x200000;}' unless defined(&TLP_BUS_READ_MULT);
    eval 'sub TLP_BUS_DESC_BIGEND () {0x100000;}' unless defined(&TLP_BUS_DESC_BIGEND);
    eval 'sub TLP_BUS_TAP () {0xe0000;}' unless defined(&TLP_BUS_TAP);
    eval 'sub TLP_BUS_CAL () {0xc000;}' unless defined(&TLP_BUS_CAL);
    eval 'sub TLP_BUS_PBL () {0x3f00;}' unless defined(&TLP_BUS_PBL);
    eval 'sub TLP_BUS_DATA_BIGEND () {0x80;}' unless defined(&TLP_BUS_DATA_BIGEND);
    eval 'sub TLP_BUS_DSL () {0x7c;}' unless defined(&TLP_BUS_DSL);
    eval 'sub TLP_BUS_ARB () {0x2;}' unless defined(&TLP_BUS_ARB);
    eval 'sub TLP_BUS_RESET () {0x1;}' unless defined(&TLP_BUS_RESET);
    eval 'sub TLP_BUS_CAL_SHIFT () {14;}' unless defined(&TLP_BUS_CAL_SHIFT);
    eval 'sub TLP_BUS_PBL_SHIFT () {8;}' unless defined(&TLP_BUS_PBL_SHIFT);
    eval 'sub TLP_STAT_FATAL_BITS () {0x3800000;}' unless defined(&TLP_STAT_FATAL_BITS);
    eval 'sub TLP_STAT_TX_FSM () {0x700000;}' unless defined(&TLP_STAT_TX_FSM);
    eval 'sub TLP_STAT_RX_FSM () {0xe0000;}' unless defined(&TLP_STAT_RX_FSM);
    eval 'sub TLP_STAT_FATAL_ERROR () {0x2000;}' unless defined(&TLP_STAT_FATAL_ERROR);
    eval 'sub TLP_STAT_TX_UNDERRUN () {0x20;}' unless defined(&TLP_STAT_TX_UNDERRUN);
    eval 'sub TLP_STAT_FATAL_SHIFT () {23;}' unless defined(&TLP_STAT_FATAL_SHIFT);
    eval 'sub TLP_OP_RECEIVE_ALL () {0x40000000;}' unless defined(&TLP_OP_RECEIVE_ALL);
    eval 'sub TLP_OP_MUST_BE_ONE () {0x2000000;}' unless defined(&TLP_OP_MUST_BE_ONE);
    eval 'sub TLP_OP_NO_HEART_BEAT () {0x80000;}' unless defined(&TLP_OP_NO_HEART_BEAT);
    eval 'sub TLP_OP_PORT_SELECT () {0x40000;}' unless defined(&TLP_OP_PORT_SELECT);
    eval 'sub TLP_OP_TX_THRESH () {0xc000;}' unless defined(&TLP_OP_TX_THRESH);
    eval 'sub TLP_OP_TX_RUN () {0x2000;}' unless defined(&TLP_OP_TX_RUN);
    eval 'sub TLP_OP_LOOP_MODE () {0xc00;}' unless defined(&TLP_OP_LOOP_MODE);
    eval 'sub TLP_OP_EXT_LOOP () {0x800;}' unless defined(&TLP_OP_EXT_LOOP);
    eval 'sub TLP_OP_INT_LOOP () {0x400;}' unless defined(&TLP_OP_INT_LOOP);
    eval 'sub TLP_OP_FULL_DUPLEX () {0x200;}' unless defined(&TLP_OP_FULL_DUPLEX);
    eval 'sub TLP_OP_PROMISCUOUS () {0x40;}' unless defined(&TLP_OP_PROMISCUOUS);
    eval 'sub TLP_OP_PASS_BAD_PKT () {0x8;}' unless defined(&TLP_OP_PASS_BAD_PKT);
    eval 'sub TLP_OP_RX_RUN () {0x2;}' unless defined(&TLP_OP_RX_RUN);
    eval 'sub TLP_OP_TR_SHIFT () {14;}' unless defined(&TLP_OP_TR_SHIFT);
    eval 'sub TLP_OP_INIT () {( &TLP_OP_PORT_SELECT |  &TLP_OP_FULL_DUPLEX |  &TLP_OP_MUST_BE_ONE |  &TLP_OP_NO_HEART_BEAT |  &TLP_OP_RECEIVE_ALL |  &TLP_OP_PROMISCUOUS |  &TLP_OP_PASS_BAD_PKT |  &TLP_OP_RX_RUN |  &TLP_OP_TX_RUN);}' unless defined(&TLP_OP_INIT);
    eval 'sub TLP_INT_NORMAL_INTR () {0x10000;}' unless defined(&TLP_INT_NORMAL_INTR);
    eval 'sub TLP_INT_ABNRML_INTR () {0x8000;}' unless defined(&TLP_INT_ABNRML_INTR);
    eval 'sub TLP_INT_FATAL_ERROR () {0x2000;}' unless defined(&TLP_INT_FATAL_ERROR);
    eval 'sub TLP_INT_RX_NO_BUFS () {0x80;}' unless defined(&TLP_INT_RX_NO_BUFS);
    eval 'sub TLP_INT_RX_INTR () {0x40;}' unless defined(&TLP_INT_RX_INTR);
    eval 'sub TLP_INT_TX_UNDERRUN () {0x20;}' unless defined(&TLP_INT_TX_UNDERRUN);
    eval 'sub TLP_INT_TX_INTR () {0x1;}' unless defined(&TLP_INT_TX_INTR);
    eval 'sub TLP_INT_DISABLE () {0;}' unless defined(&TLP_INT_DISABLE);
    eval 'sub TLP_INT_TX () {( &TLP_INT_NORMAL_INTR |  &TLP_INT_ABNRML_INTR |  &TLP_INT_FATAL_ERROR |  &TLP_INT_TX_UNDERRUN |  &TLP_INT_TX_INTR);}' unless defined(&TLP_INT_TX);
    eval 'sub TLP_INT_RX () {( &TLP_INT_NORMAL_INTR |  &TLP_INT_ABNRML_INTR |  &TLP_INT_FATAL_ERROR |  &TLP_INT_RX_NO_BUFS |  &TLP_INT_RX_INTR);}' unless defined(&TLP_INT_RX);
    eval 'sub TLP_INT_TXRX () {( &TLP_INT_TX |  &TLP_INT_RX);}' unless defined(&TLP_INT_TXRX);
    eval 'sub TLP_MISS_OCO () {0x10000000;}' unless defined(&TLP_MISS_OCO);
    eval 'sub TLP_MISS_OVERRUN () {0xffe0000;}' unless defined(&TLP_MISS_OVERRUN);
    eval 'sub TLP_MISS_MFO () {0x10000;}' unless defined(&TLP_MISS_MFO);
    eval 'sub TLP_MISS_MISSED () {0xffff;}' unless defined(&TLP_MISS_MISSED);
    eval 'sub TLP_OVERRUN_SHIFT () {17;}' unless defined(&TLP_OVERRUN_SHIFT);
    eval 'sub TLP_MII_MDIN () {0x80000;}' unless defined(&TLP_MII_MDIN);
    eval 'sub TLP_MII_MDOE () {0x40000;}' unless defined(&TLP_MII_MDOE);
    eval 'sub TLP_MII_MDOUT () {0x20000;}' unless defined(&TLP_MII_MDOUT);
    eval 'sub TLP_MII_MDC () {0x10000;}' unless defined(&TLP_MII_MDC);
    eval 'sub TLP_BIOS_RD () {0x4000;}' unless defined(&TLP_BIOS_RD);
    eval 'sub TLP_BIOS_WR () {0x2000;}' unless defined(&TLP_BIOS_WR);
    eval 'sub TLP_BIOS_SEL () {0x1000;}' unless defined(&TLP_BIOS_SEL);
    eval 'sub TLP_SROM_RD () {0x4000;}' unless defined(&TLP_SROM_RD);
    eval 'sub TLP_SROM_SEL () {0x800;}' unless defined(&TLP_SROM_SEL);
    eval 'sub TLP_SROM_DOUT () {0x8;}' unless defined(&TLP_SROM_DOUT);
    eval 'sub TLP_SROM_DIN () {0x4;}' unless defined(&TLP_SROM_DIN);
    eval 'sub TLP_SROM_CLK () {0x2;}' unless defined(&TLP_SROM_CLK);
    eval 'sub TLP_SROM_CS () {0x1;}' unless defined(&TLP_SROM_CS);
    eval 'sub TLP_GPIO_DIR () {0x100;}' unless defined(&TLP_GPIO_DIR);
    eval 'sub TLP_WDOG_RX_OFF () {0x10;}' unless defined(&TLP_WDOG_RX_OFF);
    eval 'sub TLP_WDOG_TX_OFF () {0x1;}' unless defined(&TLP_WDOG_TX_OFF);
    eval 'sub TLP_WDOG_INIT () {( &TLP_WDOG_TX_OFF |  &TLP_WDOG_RX_OFF);}' unless defined(&TLP_WDOG_INIT);
    eval 'sub GPIO_INIT () {0x1;}' unless defined(&GPIO_INIT);
    eval 'sub GPIO_RESET () {0x2;}' unless defined(&GPIO_RESET);
    eval 'sub GPIO_MODE () {0x10;}' unless defined(&GPIO_MODE);
    eval 'sub GPIO_DP () {0x20;}' unless defined(&GPIO_DP);
    eval 'sub GPIO_DATA () {0x40;}' unless defined(&GPIO_DATA);
    eval 'sub GPIO_CLK () {0x80;}' unless defined(&GPIO_CLK);
    eval 'sub GPIO_HSSI_ST () {0x4;}' unless defined(&GPIO_HSSI_ST);
    eval 'sub GPIO_HSSI_TXCLK () {0x8;}' unless defined(&GPIO_HSSI_TXCLK);
    eval 'sub GPIO_HSSI_SYNTH () {0x4;}' unless defined(&GPIO_HSSI_SYNTH);
    eval 'sub GPIO_HSSI_DCE () {0x8;}' unless defined(&GPIO_HSSI_DCE);
    eval 'sub GPIO_T3_DAC () {0x4;}' unless defined(&GPIO_T3_DAC);
    eval 'sub GPIO_T3_INTEN () {0x8;}' unless defined(&GPIO_T3_INTEN);
    eval 'sub GPIO_SSI_SYNTH () {0x4;}' unless defined(&GPIO_SSI_SYNTH);
    eval 'sub GPIO_SSI_DCE () {0x8;}' unless defined(&GPIO_SSI_DCE);
    eval 'sub GPIO_T1_INTEN () {0x8;}' unless defined(&GPIO_T1_INTEN);
    eval 'sub MII16_LED_ALL () {0x780;}' unless defined(&MII16_LED_ALL);
    eval 'sub MII16_FIFO () {0x800;}' unless defined(&MII16_FIFO);
    eval 'sub MII16_HSSI_TA () {0x1;}' unless defined(&MII16_HSSI_TA);
    eval 'sub MII16_HSSI_CA () {0x2;}' unless defined(&MII16_HSSI_CA);
    eval 'sub MII16_HSSI_LA () {0x4;}' unless defined(&MII16_HSSI_LA);
    eval 'sub MII16_HSSI_LB () {0x8;}' unless defined(&MII16_HSSI_LB);
    eval 'sub MII16_HSSI_LC () {0x10;}' unless defined(&MII16_HSSI_LC);
    eval 'sub MII16_HSSI_TM () {0x20;}' unless defined(&MII16_HSSI_TM);
    eval 'sub MII16_HSSI_CRC32 () {0x40;}' unless defined(&MII16_HSSI_CRC32);
    eval 'sub MII16_HSSI_LED_LL () {0x80;}' unless defined(&MII16_HSSI_LED_LL);
    eval 'sub MII16_HSSI_LED_LR () {0x100;}' unless defined(&MII16_HSSI_LED_LR);
    eval 'sub MII16_HSSI_LED_UL () {0x200;}' unless defined(&MII16_HSSI_LED_UL);
    eval 'sub MII16_HSSI_LED_UR () {0x400;}' unless defined(&MII16_HSSI_LED_UR);
    eval 'sub MII16_HSSI_FIFO () {0x800;}' unless defined(&MII16_HSSI_FIFO);
    eval 'sub MII16_HSSI_FORCECA () {0x1000;}' unless defined(&MII16_HSSI_FORCECA);
    eval 'sub MII16_HSSI_CLKMUX () {0x6000;}' unless defined(&MII16_HSSI_CLKMUX);
    eval 'sub MII16_HSSI_LOOP () {0x8000;}' unless defined(&MII16_HSSI_LOOP);
    eval 'sub MII16_HSSI_MODEM () {0x3f;}' unless defined(&MII16_HSSI_MODEM);
    eval 'sub MII16_DS3_ZERO () {0x1;}' unless defined(&MII16_DS3_ZERO);
    eval 'sub MII16_DS3_TRLBK () {0x2;}' unless defined(&MII16_DS3_TRLBK);
    eval 'sub MII16_DS3_LNLBK () {0x4;}' unless defined(&MII16_DS3_LNLBK);
    eval 'sub MII16_DS3_RAIS () {0x8;}' unless defined(&MII16_DS3_RAIS);
    eval 'sub MII16_DS3_TAIS () {0x10;}' unless defined(&MII16_DS3_TAIS);
    eval 'sub MII16_DS3_BIST () {0x20;}' unless defined(&MII16_DS3_BIST);
    eval 'sub MII16_DS3_DLOS () {0x40;}' unless defined(&MII16_DS3_DLOS);
    eval 'sub MII16_DS3_LED_BLU () {0x80;}' unless defined(&MII16_DS3_LED_BLU);
    eval 'sub MII16_DS3_LED_YEL () {0x100;}' unless defined(&MII16_DS3_LED_YEL);
    eval 'sub MII16_DS3_LED_RED () {0x200;}' unless defined(&MII16_DS3_LED_RED);
    eval 'sub MII16_DS3_LED_GRN () {0x400;}' unless defined(&MII16_DS3_LED_GRN);
    eval 'sub MII16_DS3_FIFO () {0x800;}' unless defined(&MII16_DS3_FIFO);
    eval 'sub MII16_DS3_CRC32 () {0x1000;}' unless defined(&MII16_DS3_CRC32);
    eval 'sub MII16_DS3_SCRAM () {0x2000;}' unless defined(&MII16_DS3_SCRAM);
    eval 'sub MII16_DS3_POLY () {0x4000;}' unless defined(&MII16_DS3_POLY);
    eval 'sub MII16_DS3_FRAME () {0x8000;}' unless defined(&MII16_DS3_FRAME);
    eval 'sub MII16_SSI_DTR () {0x1;}' unless defined(&MII16_SSI_DTR);
    eval 'sub MII16_SSI_DSR () {0x2;}' unless defined(&MII16_SSI_DSR);
    eval 'sub MII16_SSI_RTS () {0x4;}' unless defined(&MII16_SSI_RTS);
    eval 'sub MII16_SSI_CTS () {0x8;}' unless defined(&MII16_SSI_CTS);
    eval 'sub MII16_SSI_DCD () {0x10;}' unless defined(&MII16_SSI_DCD);
    eval 'sub MII16_SSI_RI () {0x20;}' unless defined(&MII16_SSI_RI);
    eval 'sub MII16_SSI_CRC32 () {0x40;}' unless defined(&MII16_SSI_CRC32);
    eval 'sub MII16_SSI_LED_LL () {0x80;}' unless defined(&MII16_SSI_LED_LL);
    eval 'sub MII16_SSI_LED_LR () {0x100;}' unless defined(&MII16_SSI_LED_LR);
    eval 'sub MII16_SSI_LED_UL () {0x200;}' unless defined(&MII16_SSI_LED_UL);
    eval 'sub MII16_SSI_LED_UR () {0x400;}' unless defined(&MII16_SSI_LED_UR);
    eval 'sub MII16_SSI_FIFO () {0x800;}' unless defined(&MII16_SSI_FIFO);
    eval 'sub MII16_SSI_LL () {0x1000;}' unless defined(&MII16_SSI_LL);
    eval 'sub MII16_SSI_RL () {0x2000;}' unless defined(&MII16_SSI_RL);
    eval 'sub MII16_SSI_TM () {0x4000;}' unless defined(&MII16_SSI_TM);
    eval 'sub MII16_SSI_LOOP () {0x8000;}' unless defined(&MII16_SSI_LOOP);
    eval 'sub MII16_SSI_MODEM () {0x703f;}' unless defined(&MII16_SSI_MODEM);
    eval 'sub MII17_SSI_CABLE_SHIFT () {3;}' unless defined(&MII17_SSI_CABLE_SHIFT);
    eval 'sub MII17_SSI_CABLE_MASK () {0x38;}' unless defined(&MII17_SSI_CABLE_MASK);
    eval 'sub MII17_SSI_PRESCALE () {0x40;}' unless defined(&MII17_SSI_PRESCALE);
    eval 'sub MII17_SSI_ITF () {0x100;}' unless defined(&MII17_SSI_ITF);
    eval 'sub MII17_SSI_NRZI () {0x400;}' unless defined(&MII17_SSI_NRZI);
    eval 'sub MII16_T1_UNUSED1 () {0x1;}' unless defined(&MII16_T1_UNUSED1);
    eval 'sub MII16_T1_INVERT () {0x2;}' unless defined(&MII16_T1_INVERT);
    eval 'sub MII16_T1_XOE () {0x4;}' unless defined(&MII16_T1_XOE);
    eval 'sub MII16_T1_RST () {0x8;}' unless defined(&MII16_T1_RST);
    eval 'sub MII16_T1_Z () {0x10;}' unless defined(&MII16_T1_Z);
    eval 'sub MII16_T1_INTR () {0x20;}' unless defined(&MII16_T1_INTR);
    eval 'sub MII16_T1_ONESEC () {0x40;}' unless defined(&MII16_T1_ONESEC);
    eval 'sub MII16_T1_LED_BLU () {0x80;}' unless defined(&MII16_T1_LED_BLU);
    eval 'sub MII16_T1_LED_YEL () {0x100;}' unless defined(&MII16_T1_LED_YEL);
    eval 'sub MII16_T1_LED_RED () {0x200;}' unless defined(&MII16_T1_LED_RED);
    eval 'sub MII16_T1_LED_GRN () {0x400;}' unless defined(&MII16_T1_LED_GRN);
    eval 'sub MII16_T1_FIFO () {0x800;}' unless defined(&MII16_T1_FIFO);
    eval 'sub MII16_T1_CRC32 () {0x1000;}' unless defined(&MII16_T1_CRC32);
    eval 'sub MII16_T1_UNUSED2 () {0xe000;}' unless defined(&MII16_T1_UNUSED2);
    eval 'sub T3CSR_STAT0 () {0x;}' unless defined(&T3CSR_STAT0);
    eval 'sub T3CSR_CTL1 () {0x1;}' unless defined(&T3CSR_CTL1);
    eval 'sub T3CSR_FEBE () {0x2;}' unless defined(&T3CSR_FEBE);
    eval 'sub T3CSR_CERR () {0x3;}' unless defined(&T3CSR_CERR);
    eval 'sub T3CSR_PERR () {0x4;}' unless defined(&T3CSR_PERR);
    eval 'sub T3CSR_TX_FEAC () {0x5;}' unless defined(&T3CSR_TX_FEAC);
    eval 'sub T3CSR_RX_FEAC () {0x6;}' unless defined(&T3CSR_RX_FEAC);
    eval 'sub T3CSR_STAT7 () {0x7;}' unless defined(&T3CSR_STAT7);
    eval 'sub T3CSR_CTL8 () {0x8;}' unless defined(&T3CSR_CTL8);
    eval 'sub T3CSR_STAT9 () {0x9;}' unless defined(&T3CSR_STAT9);
    eval 'sub T3CSR_FERR () {0xa;}' unless defined(&T3CSR_FERR);
    eval 'sub T3CSR_MERR () {0xb;}' unless defined(&T3CSR_MERR);
    eval 'sub T3CSR_CTL12 () {0xc;}' unless defined(&T3CSR_CTL12);
    eval 'sub T3CSR_DBL_FEAC () {0xd;}' unless defined(&T3CSR_DBL_FEAC);
    eval 'sub T3CSR_CTL14 () {0xe;}' unless defined(&T3CSR_CTL14);
    eval 'sub T3CSR_FEAC_STK () {0xf;}' unless defined(&T3CSR_FEAC_STK);
    eval 'sub T3CSR_STAT16 () {0x10;}' unless defined(&T3CSR_STAT16);
    eval 'sub T3CSR_INTEN () {0x11;}' unless defined(&T3CSR_INTEN);
    eval 'sub T3CSR_CVLO () {0x12;}' unless defined(&T3CSR_CVLO);
    eval 'sub T3CSR_CVHI () {0x13;}' unless defined(&T3CSR_CVHI);
    eval 'sub T3CSR_CTL20 () {0x14;}' unless defined(&T3CSR_CTL20);
    eval 'sub CTL1_XTX () {0x1;}' unless defined(&CTL1_XTX);
    eval 'sub CTL1_3LOOP () {0x2;}' unless defined(&CTL1_3LOOP);
    eval 'sub CTL1_SER () {0x4;}' unless defined(&CTL1_SER);
    eval 'sub CTL1_M13MODE () {0x8;}' unless defined(&CTL1_M13MODE);
    eval 'sub CTL1_TXIDL () {0x10;}' unless defined(&CTL1_TXIDL);
    eval 'sub CTL1_ENAIS () {0x20;}' unless defined(&CTL1_ENAIS);
    eval 'sub CTL1_TXAIS () {0x40;}' unless defined(&CTL1_TXAIS);
    eval 'sub CTL1_NOFEBE () {0x80;}' unless defined(&CTL1_NOFEBE);
    eval 'sub CTL5_EMODE () {0x80;}' unless defined(&CTL5_EMODE);
    eval 'sub CTL5_START () {0x40;}' unless defined(&CTL5_START);
    eval 'sub CTL8_FBEC () {0x80;}' unless defined(&CTL8_FBEC);
    eval 'sub CTL8_TBLU () {0x20;}' unless defined(&CTL8_TBLU);
    eval 'sub STAT9_SEF () {0x80;}' unless defined(&STAT9_SEF);
    eval 'sub STAT9_RBLU () {0x20;}' unless defined(&STAT9_RBLU);
    eval 'sub CTL12_RTPLLEN () {0x80;}' unless defined(&CTL12_RTPLLEN);
    eval 'sub CTL12_RTPLOOP () {0x40;}' unless defined(&CTL12_RTPLOOP);
    eval 'sub CTL12_DLCB1 () {0x8;}' unless defined(&CTL12_DLCB1);
    eval 'sub CTL12_C21 () {0x4;}' unless defined(&CTL12_C21);
    eval 'sub CTL12_MCB1 () {0x2;}' unless defined(&CTL12_MCB1);
    eval 'sub CTL13_DFEXEC () {0x40;}' unless defined(&CTL13_DFEXEC);
    eval 'sub CTL14_FEAC10 () {0x80;}' unless defined(&CTL14_FEAC10);
    eval 'sub CTL14_RGCEN () {0x20;}' unless defined(&CTL14_RGCEN);
    eval 'sub CTL14_TGCEN () {0x10;}' unless defined(&CTL14_TGCEN);
    eval 'sub FEAC_STK_MORE () {0x80;}' unless defined(&FEAC_STK_MORE);
    eval 'sub FEAC_STK_VALID () {0x40;}' unless defined(&FEAC_STK_VALID);
    eval 'sub FEAC_STK_FEAC () {0x3f;}' unless defined(&FEAC_STK_FEAC);
    eval 'sub STAT16_XERR () {0x1;}' unless defined(&STAT16_XERR);
    eval 'sub STAT16_SEF () {0x2;}' unless defined(&STAT16_SEF);
    eval 'sub STAT16_RTLOC () {0x4;}' unless defined(&STAT16_RTLOC);
    eval 'sub STAT16_FEAC () {0x8;}' unless defined(&STAT16_FEAC);
    eval 'sub STAT16_RIDL () {0x10;}' unless defined(&STAT16_RIDL);
    eval 'sub STAT16_RAIS () {0x20;}' unless defined(&STAT16_RAIS);
    eval 'sub STAT16_ROOF () {0x40;}' unless defined(&STAT16_ROOF);
    eval 'sub STAT16_RLOS () {0x80;}' unless defined(&STAT16_RLOS);
    eval 'sub CTL20_CVEN () {0x1;}' unless defined(&CTL20_CVEN);
    eval 'sub T3BOP_OOF () {0x;}' unless defined(&T3BOP_OOF);
    eval 'sub T3BOP_LINE_UP () {0x7;}' unless defined(&T3BOP_LINE_UP);
    eval 'sub T3BOP_LINE_DOWN () {0x1c;}' unless defined(&T3BOP_LINE_DOWN);
    eval 'sub T3BOP_LOOP_DS3 () {0x1b;}' unless defined(&T3BOP_LOOP_DS3);
    eval 'sub T3BOP_IDLE () {0x1a;}' unless defined(&T3BOP_IDLE);
    eval 'sub T3BOP_AIS () {0x16;}' unless defined(&T3BOP_AIS);
    eval 'sub T3BOP_LOS () {0xe;}' unless defined(&T3BOP_LOS);
    eval 'sub Bt8370_DID () {0x;}' unless defined(&Bt8370_DID);
    eval 'sub Bt8370_CR0 () {0x1;}' unless defined(&Bt8370_CR0);
    eval 'sub Bt8370_JAT_CR () {0x2;}' unless defined(&Bt8370_JAT_CR);
    eval 'sub Bt8370_IRR () {0x3;}' unless defined(&Bt8370_IRR);
    eval 'sub Bt8370_ISR7 () {0x4;}' unless defined(&Bt8370_ISR7);
    eval 'sub Bt8370_ISR6 () {0x5;}' unless defined(&Bt8370_ISR6);
    eval 'sub Bt8370_ISR5 () {0x6;}' unless defined(&Bt8370_ISR5);
    eval 'sub Bt8370_ISR4 () {0x7;}' unless defined(&Bt8370_ISR4);
    eval 'sub Bt8370_ISR3 () {0x8;}' unless defined(&Bt8370_ISR3);
    eval 'sub Bt8370_ISR2 () {0x9;}' unless defined(&Bt8370_ISR2);
    eval 'sub Bt8370_ISR1 () {0xa;}' unless defined(&Bt8370_ISR1);
    eval 'sub Bt8370_ISR0 () {0xb;}' unless defined(&Bt8370_ISR0);
    eval 'sub Bt8370_IER7 () {0xc;}' unless defined(&Bt8370_IER7);
    eval 'sub Bt8370_IER6 () {0xd;}' unless defined(&Bt8370_IER6);
    eval 'sub Bt8370_IER5 () {0xe;}' unless defined(&Bt8370_IER5);
    eval 'sub Bt8370_IER4 () {0xf;}' unless defined(&Bt8370_IER4);
    eval 'sub Bt8370_IER3 () {0x10;}' unless defined(&Bt8370_IER3);
    eval 'sub Bt8370_IER2 () {0x11;}' unless defined(&Bt8370_IER2);
    eval 'sub Bt8370_IER1 () {0x12;}' unless defined(&Bt8370_IER1);
    eval 'sub Bt8370_IER0 () {0x13;}' unless defined(&Bt8370_IER0);
    eval 'sub Bt8370_LOOP () {0x14;}' unless defined(&Bt8370_LOOP);
    eval 'sub Bt8370_DL3_TS () {0x15;}' unless defined(&Bt8370_DL3_TS);
    eval 'sub Bt8370_DL3_BIT () {0x16;}' unless defined(&Bt8370_DL3_BIT);
    eval 'sub Bt8370_FSTAT () {0x17;}' unless defined(&Bt8370_FSTAT);
    eval 'sub Bt8370_PIO () {0x18;}' unless defined(&Bt8370_PIO);
    eval 'sub Bt8370_POE () {0x19;}' unless defined(&Bt8370_POE);
    eval 'sub Bt8370_CMUX () {0x1a;}' unless defined(&Bt8370_CMUX);
    eval 'sub Bt8370_TMUX () {0x1b;}' unless defined(&Bt8370_TMUX);
    eval 'sub Bt8370_TEST () {0x1c;}' unless defined(&Bt8370_TEST);
    eval 'sub Bt8370_LIU_CR () {0x20;}' unless defined(&Bt8370_LIU_CR);
    eval 'sub Bt8370_RSTAT () {0x21;}' unless defined(&Bt8370_RSTAT);
    eval 'sub Bt8370_RLIU_CR () {0x22;}' unless defined(&Bt8370_RLIU_CR);
    eval 'sub Bt8370_LPF () {0x23;}' unless defined(&Bt8370_LPF);
    eval 'sub Bt8370_VGA_MAX () {0x24;}' unless defined(&Bt8370_VGA_MAX);
    eval 'sub Bt8370_EQ_DAT () {0x25;}' unless defined(&Bt8370_EQ_DAT);
    eval 'sub Bt8370_EQ_PTR () {0x26;}' unless defined(&Bt8370_EQ_PTR);
    eval 'sub Bt8370_DSLICE () {0x27;}' unless defined(&Bt8370_DSLICE);
    eval 'sub Bt8370_EQ_OUT () {0x28;}' unless defined(&Bt8370_EQ_OUT);
    eval 'sub Bt8370_VGA () {0x29;}' unless defined(&Bt8370_VGA);
    eval 'sub Bt8370_PRE_EQ () {0x2a;}' unless defined(&Bt8370_PRE_EQ);
    eval 'sub Bt8370_COEFF0 () {0x30;}' unless defined(&Bt8370_COEFF0);
    eval 'sub Bt8370_GAIN0 () {0x38;}' unless defined(&Bt8370_GAIN0);
    eval 'sub Bt8370_GAIN1 () {0x39;}' unless defined(&Bt8370_GAIN1);
    eval 'sub Bt8370_GAIN2 () {0x3a;}' unless defined(&Bt8370_GAIN2);
    eval 'sub Bt8370_GAIN3 () {0x3b;}' unless defined(&Bt8370_GAIN3);
    eval 'sub Bt8370_GAIN4 () {0x3c;}' unless defined(&Bt8370_GAIN4);
    eval 'sub Bt8370_RCR0 () {0x40;}' unless defined(&Bt8370_RCR0);
    eval 'sub Bt8370_RPATT () {0x41;}' unless defined(&Bt8370_RPATT);
    eval 'sub Bt8370_RLB () {0x42;}' unless defined(&Bt8370_RLB);
    eval 'sub Bt8370_LBA () {0x43;}' unless defined(&Bt8370_LBA);
    eval 'sub Bt8370_LBD () {0x44;}' unless defined(&Bt8370_LBD);
    eval 'sub Bt8370_RALM () {0x45;}' unless defined(&Bt8370_RALM);
    eval 'sub Bt8370_LATCH () {0x46;}' unless defined(&Bt8370_LATCH);
    eval 'sub Bt8370_ALM1 () {0x47;}' unless defined(&Bt8370_ALM1);
    eval 'sub Bt8370_ALM2 () {0x48;}' unless defined(&Bt8370_ALM2);
    eval 'sub Bt8370_ALM3 () {0x49;}' unless defined(&Bt8370_ALM3);
    eval 'sub Bt8370_FERR_LO () {0x50;}' unless defined(&Bt8370_FERR_LO);
    eval 'sub Bt8370_FERR_HI () {0x51;}' unless defined(&Bt8370_FERR_HI);
    eval 'sub Bt8370_CRC_LO () {0x52;}' unless defined(&Bt8370_CRC_LO);
    eval 'sub Bt8370_CRC_HI () {0x53;}' unless defined(&Bt8370_CRC_HI);
    eval 'sub Bt8370_LCV_LO () {0x54;}' unless defined(&Bt8370_LCV_LO);
    eval 'sub Bt8370_LCV_HI () {0x55;}' unless defined(&Bt8370_LCV_HI);
    eval 'sub Bt8370_FEBE_LO () {0x56;}' unless defined(&Bt8370_FEBE_LO);
    eval 'sub Bt8370_FEBE_HI () {0x57;}' unless defined(&Bt8370_FEBE_HI);
    eval 'sub Bt8370_BERR_LO () {0x58;}' unless defined(&Bt8370_BERR_LO);
    eval 'sub Bt8370_BERR_HI () {0x59;}' unless defined(&Bt8370_BERR_HI);
    eval 'sub Bt8370_AERR () {0x5a;}' unless defined(&Bt8370_AERR);
    eval 'sub Bt8370_RSA4 () {0x5b;}' unless defined(&Bt8370_RSA4);
    eval 'sub Bt8370_RSA5 () {0x5c;}' unless defined(&Bt8370_RSA5);
    eval 'sub Bt8370_RSA6 () {0x5d;}' unless defined(&Bt8370_RSA6);
    eval 'sub Bt8370_RSA7 () {0x5e;}' unless defined(&Bt8370_RSA7);
    eval 'sub Bt8370_RSA8 () {0x5f;}' unless defined(&Bt8370_RSA8);
    eval 'sub Bt8370_SHAPE0 () {0x60;}' unless defined(&Bt8370_SHAPE0);
    eval 'sub Bt8370_TLIU_CR () {0x68;}' unless defined(&Bt8370_TLIU_CR);
    eval 'sub Bt8370_TCR0 () {0x70;}' unless defined(&Bt8370_TCR0);
    eval 'sub Bt8370_TCR1 () {0x71;}' unless defined(&Bt8370_TCR1);
    eval 'sub Bt8370_TFRM () {0x72;}' unless defined(&Bt8370_TFRM);
    eval 'sub Bt8370_TERROR () {0x73;}' unless defined(&Bt8370_TERROR);
    eval 'sub Bt8370_TMAN () {0x74;}' unless defined(&Bt8370_TMAN);
    eval 'sub Bt8370_TALM () {0x75;}' unless defined(&Bt8370_TALM);
    eval 'sub Bt8370_TPATT () {0x76;}' unless defined(&Bt8370_TPATT);
    eval 'sub Bt8370_TLB () {0x77;}' unless defined(&Bt8370_TLB);
    eval 'sub Bt8370_LBP () {0x78;}' unless defined(&Bt8370_LBP);
    eval 'sub Bt8370_TSA4 () {0x7b;}' unless defined(&Bt8370_TSA4);
    eval 'sub Bt8370_TSA5 () {0x7c;}' unless defined(&Bt8370_TSA5);
    eval 'sub Bt8370_TSA6 () {0x7d;}' unless defined(&Bt8370_TSA6);
    eval 'sub Bt8370_TSA7 () {0x7e;}' unless defined(&Bt8370_TSA7);
    eval 'sub Bt8370_TSA8 () {0x7f;}' unless defined(&Bt8370_TSA8);
    eval 'sub Bt8370_CLAD_CR () {0x90;}' unless defined(&Bt8370_CLAD_CR);
    eval 'sub Bt8370_CSEL () {0x91;}' unless defined(&Bt8370_CSEL);
    eval 'sub Bt8370_CPHASE () {0x92;}' unless defined(&Bt8370_CPHASE);
    eval 'sub Bt8370_CTEST () {0x93;}' unless defined(&Bt8370_CTEST);
    eval 'sub Bt8370_BOP () {0xa0;}' unless defined(&Bt8370_BOP);
    eval 'sub Bt8370_TBOP () {0xa1;}' unless defined(&Bt8370_TBOP);
    eval 'sub Bt8370_RBOP () {0xa2;}' unless defined(&Bt8370_RBOP);
    eval 'sub Bt8370_BOP_STAT () {0xa3;}' unless defined(&Bt8370_BOP_STAT);
    eval 'sub Bt8370_DL1_TS () {0xa4;}' unless defined(&Bt8370_DL1_TS);
    eval 'sub Bt8370_DL1_BIT () {0xa5;}' unless defined(&Bt8370_DL1_BIT);
    eval 'sub Bt8370_DL1_CTL () {0xa6;}' unless defined(&Bt8370_DL1_CTL);
    eval 'sub Bt8370_RDL1_FFC () {0xa7;}' unless defined(&Bt8370_RDL1_FFC);
    eval 'sub Bt8370_RDL1 () {0xa8;}' unless defined(&Bt8370_RDL1);
    eval 'sub Bt8370_RDL1_STAT () {0xa9;}' unless defined(&Bt8370_RDL1_STAT);
    eval 'sub Bt8370_PRM () {0xaa;}' unless defined(&Bt8370_PRM);
    eval 'sub Bt8370_TDL1_FEC () {0xab;}' unless defined(&Bt8370_TDL1_FEC);
    eval 'sub Bt8370_TDL1_EOM () {0xac;}' unless defined(&Bt8370_TDL1_EOM);
    eval 'sub Bt8370_TDL1 () {0xad;}' unless defined(&Bt8370_TDL1);
    eval 'sub Bt8370_TDL1_STAT () {0xae;}' unless defined(&Bt8370_TDL1_STAT);
    eval 'sub Bt8370_DL2_TS () {0xaf;}' unless defined(&Bt8370_DL2_TS);
    eval 'sub Bt8370_DL2_BIT () {0xb0;}' unless defined(&Bt8370_DL2_BIT);
    eval 'sub Bt8370_DL2_CTL () {0xb1;}' unless defined(&Bt8370_DL2_CTL);
    eval 'sub Bt8370_RDL2_FFC () {0xb2;}' unless defined(&Bt8370_RDL2_FFC);
    eval 'sub Bt8370_RDL2 () {0xb3;}' unless defined(&Bt8370_RDL2);
    eval 'sub Bt8370_RDL2_STAT () {0xb4;}' unless defined(&Bt8370_RDL2_STAT);
    eval 'sub Bt8370_TDL2_FEC () {0xb6;}' unless defined(&Bt8370_TDL2_FEC);
    eval 'sub Bt8370_TDL2_EOM () {0xb7;}' unless defined(&Bt8370_TDL2_EOM);
    eval 'sub Bt8370_TDL2 () {0xb8;}' unless defined(&Bt8370_TDL2);
    eval 'sub Bt8370_TDL2_STAT () {0xb9;}' unless defined(&Bt8370_TDL2_STAT);
    eval 'sub Bt8370_DL_TEST1 () {0xba;}' unless defined(&Bt8370_DL_TEST1);
    eval 'sub Bt8370_DL_TEST2 () {0xbb;}' unless defined(&Bt8370_DL_TEST2);
    eval 'sub Bt8370_DL_TEST3 () {0xbc;}' unless defined(&Bt8370_DL_TEST3);
    eval 'sub Bt8370_DL_TEST4 () {0xbd;}' unless defined(&Bt8370_DL_TEST4);
    eval 'sub Bt8370_DL_TEST5 () {0xbe;}' unless defined(&Bt8370_DL_TEST5);
    eval 'sub Bt8370_SBI_CR () {0xd0;}' unless defined(&Bt8370_SBI_CR);
    eval 'sub Bt8370_RSB_CR () {0xd1;}' unless defined(&Bt8370_RSB_CR);
    eval 'sub Bt8370_RSYNC_BIT () {0xd2;}' unless defined(&Bt8370_RSYNC_BIT);
    eval 'sub Bt8370_RSYNC_TS () {0xd3;}' unless defined(&Bt8370_RSYNC_TS);
    eval 'sub Bt8370_TSB_CR () {0xd4;}' unless defined(&Bt8370_TSB_CR);
    eval 'sub Bt8370_TSYNC_BIT () {0xd5;}' unless defined(&Bt8370_TSYNC_BIT);
    eval 'sub Bt8370_TSYNC_TS () {0xd6;}' unless defined(&Bt8370_TSYNC_TS);
    eval 'sub Bt8370_RSIG_CR () {0xd7;}' unless defined(&Bt8370_RSIG_CR);
    eval 'sub Bt8370_RSYNC_FRM () {0xd8;}' unless defined(&Bt8370_RSYNC_FRM);
    eval 'sub Bt8370_SSTAT () {0xd9;}' unless defined(&Bt8370_SSTAT);
    eval 'sub Bt8370_STACK () {0xda;}' unless defined(&Bt8370_STACK);
    eval 'sub Bt8370_RPHASE () {0xdb;}' unless defined(&Bt8370_RPHASE);
    eval 'sub Bt8370_TPHASE () {0xdc;}' unless defined(&Bt8370_TPHASE);
    eval 'sub Bt8370_PERR () {0xdd;}' unless defined(&Bt8370_PERR);
    eval 'sub Bt8370_SBCn () {0xe0;}' unless defined(&Bt8370_SBCn);
    eval 'sub Bt8370_TPCn () {0x100;}' unless defined(&Bt8370_TPCn);
    eval 'sub Bt8370_TSIGn () {0x120;}' unless defined(&Bt8370_TSIGn);
    eval 'sub Bt8370_TSLIP_LOn () {0x140;}' unless defined(&Bt8370_TSLIP_LOn);
    eval 'sub Bt8370_TSLIP_HIn () {0x160;}' unless defined(&Bt8370_TSLIP_HIn);
    eval 'sub Bt8370_RPCn () {0x180;}' unless defined(&Bt8370_RPCn);
    eval 'sub Bt8370_RSIGn () {0x1a0;}' unless defined(&Bt8370_RSIGn);
    eval 'sub Bt8370_RSLIP_LOn () {0x1c0;}' unless defined(&Bt8370_RSLIP_LOn);
    eval 'sub Bt8370_RSLIP_HIn () {0x1e0;}' unless defined(&Bt8370_RSLIP_HIn);
    eval 'sub LOOP_ANALOG () {0x1;}' unless defined(&LOOP_ANALOG);
    eval 'sub LOOP_FRAMER () {0x2;}' unless defined(&LOOP_FRAMER);
    eval 'sub LOOP_LINE () {0x4;}' unless defined(&LOOP_LINE);
    eval 'sub LOOP_PAYLOAD () {0x8;}' unless defined(&LOOP_PAYLOAD);
    eval 'sub LOOP_DUAL () {0x6;}' unless defined(&LOOP_DUAL);
    eval 'sub ALM1_SIGFRZ () {0x1;}' unless defined(&ALM1_SIGFRZ);
    eval 'sub ALM1_RLOF () {0x2;}' unless defined(&ALM1_RLOF);
    eval 'sub ALM1_RLOS () {0x4;}' unless defined(&ALM1_RLOS);
    eval 'sub ALM1_RALOS () {0x8;}' unless defined(&ALM1_RALOS);
    eval 'sub ALM1_RAIS () {0x10;}' unless defined(&ALM1_RAIS);
    eval 'sub ALM1_RYEL () {0x40;}' unless defined(&ALM1_RYEL);
    eval 'sub ALM1_RMYEL () {0x80;}' unless defined(&ALM1_RMYEL);
    eval 'sub ALM3_FRED () {0x4;}' unless defined(&ALM3_FRED);
    eval 'sub ALM3_MRED () {0x8;}' unless defined(&ALM3_MRED);
    eval 'sub ALM3_SRED () {0x10;}' unless defined(&ALM3_SRED);
    eval 'sub ALM3_SEF () {0x20;}' unless defined(&ALM3_SEF);
    eval 'sub ALM3_RMAIS () {0x40;}' unless defined(&ALM3_RMAIS);
    eval 'sub TALM_TAIS () {0x1;}' unless defined(&TALM_TAIS);
    eval 'sub TALM_TYEL () {0x2;}' unless defined(&TALM_TYEL);
    eval 'sub TALM_TMYEL () {0x4;}' unless defined(&TALM_TMYEL);
    eval 'sub TALM_AUTO_AIS () {0x8;}' unless defined(&TALM_AUTO_AIS);
    eval 'sub TALM_AUTO_YEL () {0x10;}' unless defined(&TALM_AUTO_YEL);
    eval 'sub TALM_AUTO_MYEL () {0x20;}' unless defined(&TALM_AUTO_MYEL);
    eval 'sub RBOP_OFF () {0x;}' unless defined(&RBOP_OFF);
    eval 'sub RBOP_25 () {0xe0;}' unless defined(&RBOP_25);
    eval 'sub TBOP_OFF () {0x;}' unless defined(&TBOP_OFF);
    eval 'sub TBOP_25 () {0xb;}' unless defined(&TBOP_25);
    eval 'sub TBOP_CONT () {0xf;}' unless defined(&TBOP_CONT);
    eval 'sub T1BOP_OOF () {0x;}' unless defined(&T1BOP_OOF);
    eval 'sub T1BOP_LINE_UP () {0x7;}' unless defined(&T1BOP_LINE_UP);
    eval 'sub T1BOP_LINE_DOWN () {0x1c;}' unless defined(&T1BOP_LINE_DOWN);
    eval 'sub T1BOP_PAY_UP () {0xa;}' unless defined(&T1BOP_PAY_UP);
    eval 'sub T1BOP_PAY_DOWN () {0x19;}' unless defined(&T1BOP_PAY_DOWN);
    eval 'sub T1BOP_NET_UP () {0x9;}' unless defined(&T1BOP_NET_UP);
    eval 'sub T1BOP_NET_DOWN () {0x12;}' unless defined(&T1BOP_NET_DOWN);
    if((defined(&BSD) ? &BSD : undef)) {
	eval 'sub LMCIOCGSTAT () { &_IOWR(ord(\'i\'), 240, \'struct status\');}' unless defined(&LMCIOCGSTAT);
	eval 'sub LMCIOCGCFG () { &_IOWR(ord(\'i\'), 241, \'struct config\');}' unless defined(&LMCIOCGCFG);
	eval 'sub LMCIOCSCFG () { &_IOW(ord(\'i\'), 242, \'struct config\');}' unless defined(&LMCIOCSCFG);
	eval 'sub LMCIOCREAD () { &_IOWR(ord(\'i\'), 243, \'struct ioctl\');}' unless defined(&LMCIOCREAD);
	eval 'sub LMCIOCWRITE () { &_IOW(ord(\'i\'), 244, \'struct ioctl\');}' unless defined(&LMCIOCWRITE);
	eval 'sub LMCIOCTL () { &_IOWR(ord(\'i\'), 245, \'struct ioctl\');}' unless defined(&LMCIOCTL);
    }
    eval 'sub DIR_IO () {0;}' unless defined(&DIR_IO);
    eval 'sub DIR_IOW () {1;}' unless defined(&DIR_IOW);
    eval 'sub DIR_IOR () {2;}' unless defined(&DIR_IOR);
    eval 'sub DIR_IOWR () {3;}' unless defined(&DIR_IOWR);
    eval 'sub TSEND_NORMAL () {1;}' unless defined(&TSEND_NORMAL);
    eval 'sub TSEND_LINE () {2;}' unless defined(&TSEND_LINE);
    eval 'sub TSEND_PAYLOAD () {3;}' unless defined(&TSEND_PAYLOAD);
    eval 'sub TSEND_RESET () {4;}' unless defined(&TSEND_RESET);
    eval 'sub TSEND_QRS () {5;}' unless defined(&TSEND_QRS);
    eval 'sub T1PRM_FE () {0x8000;}' unless defined(&T1PRM_FE);
    eval 'sub T1PRM_SE () {0x4000;}' unless defined(&T1PRM_SE);
    eval 'sub T1PRM_LB () {0x2000;}' unless defined(&T1PRM_LB);
    eval 'sub T1PRM_G1 () {0x1000;}' unless defined(&T1PRM_G1);
    eval 'sub T1PRM_R () {0x800;}' unless defined(&T1PRM_R);
    eval 'sub T1PRM_G2 () {0x400;}' unless defined(&T1PRM_G2);
    eval 'sub T1PRM_SEQ () {0x300;}' unless defined(&T1PRM_SEQ);
    eval 'sub T1PRM_G3 () {0x80;}' unless defined(&T1PRM_G3);
    eval 'sub T1PRM_LV () {0x40;}' unless defined(&T1PRM_LV);
    eval 'sub T1PRM_G4 () {0x20;}' unless defined(&T1PRM_G4);
    eval 'sub T1PRM_U () {0x18;}' unless defined(&T1PRM_U);
    eval 'sub T1PRM_G5 () {0x4;}' unless defined(&T1PRM_G5);
    eval 'sub T1PRM_SL () {0x2;}' unless defined(&T1PRM_SL);
    eval 'sub T1PRM_G6 () {0x1;}' unless defined(&T1PRM_G6);
    eval 'sub TLINE_NORM () {0x1;}' unless defined(&TLINE_NORM);
    eval 'sub TLINE_RX_RAI () {0x2;}' unless defined(&TLINE_RX_RAI);
    eval 'sub TLINE_TX_RAI () {0x4;}' unless defined(&TLINE_TX_RAI);
    eval 'sub TLINE_RX_AIS () {0x8;}' unless defined(&TLINE_RX_AIS);
    eval 'sub TLINE_TX_AIS () {0x10;}' unless defined(&TLINE_TX_AIS);
    eval 'sub TLINE_LOF () {0x20;}' unless defined(&TLINE_LOF);
    eval 'sub TLINE_LOS () {0x40;}' unless defined(&TLINE_LOS);
    eval 'sub TLINE_LOOP () {0x80;}' unless defined(&TLINE_LOOP);
    eval 'sub T1LINE_RX_TS16_AIS () {0x100;}' unless defined(&T1LINE_RX_TS16_AIS);
    eval 'sub T1LINE_RX_TS16_LOMF () {0x200;}' unless defined(&T1LINE_RX_TS16_LOMF);
    eval 'sub T1LINE_TX_TS16_LOMF () {0x400;}' unless defined(&T1LINE_TX_TS16_LOMF);
    eval 'sub T1LINE_RX_TEST () {0x800;}' unless defined(&T1LINE_RX_TEST);
    eval 'sub T1LINE_SEF () {0x1000;}' unless defined(&T1LINE_SEF);
    eval 'sub T3LINE_RX_IDLE () {0x100;}' unless defined(&T3LINE_RX_IDLE);
    eval 'sub T3LINE_SEF () {0x200;}' unless defined(&T3LINE_SEF);
    eval 'sub TLOOP_NONE () {0x1;}' unless defined(&TLOOP_NONE);
    eval 'sub TLOOP_NEAR_PAYLOAD () {0x2;}' unless defined(&TLOOP_NEAR_PAYLOAD);
    eval 'sub TLOOP_NEAR_LINE () {0x4;}' unless defined(&TLOOP_NEAR_LINE);
    eval 'sub TLOOP_NEAR_OTHER () {0x8;}' unless defined(&TLOOP_NEAR_OTHER);
    eval 'sub TLOOP_NEAR_INWARD () {0x10;}' unless defined(&TLOOP_NEAR_INWARD);
    eval 'sub TLOOP_FAR_PAYLOAD () {0x20;}' unless defined(&TLOOP_FAR_PAYLOAD);
    eval 'sub TLOOP_FAR_LINE () {0x40;}' unless defined(&TLOOP_FAR_LINE);
    eval 'sub PKG_RAWIP () {1;}' unless defined(&PKG_RAWIP);
    eval 'sub PKG_SPPP () {2;}' unless defined(&PKG_SPPP);
    eval 'sub PKG_P2P () {3;}' unless defined(&PKG_P2P);
    eval 'sub PKG_NG () {4;}' unless defined(&PKG_NG);
    eval 'sub PKG_GEN_HDLC () {5;}' unless defined(&PKG_GEN_HDLC);
    eval 'sub PROT_PPP () {1;}' unless defined(&PROT_PPP);
    eval 'sub PROT_C_HDLC () {2;}' unless defined(&PROT_C_HDLC);
    eval 'sub PROT_FRM_RLY () {3;}' unless defined(&PROT_FRM_RLY);
    eval 'sub PROT_X25 () {4;}' unless defined(&PROT_X25);
    eval 'sub PROT_ETH_HDLC () {5;}' unless defined(&PROT_ETH_HDLC);
    eval 'sub PROT_IP_HDLC () {6;}' unless defined(&PROT_IP_HDLC);
    eval 'sub STATUS_UP () {1;}' unless defined(&STATUS_UP);
    eval 'sub STATUS_DOWN () {2;}' unless defined(&STATUS_DOWN);
    eval 'sub STATUS_TEST () {3;}' unless defined(&STATUS_TEST);
    eval 'sub SYNTH_FREF () {20 &e6;}' unless defined(&SYNTH_FREF);
    eval 'sub SYNTH_FMIN () {50 &e6;}' unless defined(&SYNTH_FMIN);
    eval 'sub SYNTH_FMAX () {250 &e6;}' unless defined(&SYNTH_FMAX);
    eval 'sub CFG_CRC_0 () {0;}' unless defined(&CFG_CRC_0);
    eval 'sub CFG_CRC_16 () {2;}' unless defined(&CFG_CRC_16);
    eval 'sub CFG_CRC_32 () {4;}' unless defined(&CFG_CRC_32);
    eval 'sub CFG_LOOP_NONE () {1;}' unless defined(&CFG_LOOP_NONE);
    eval 'sub CFG_LOOP_PAYLOAD () {2;}' unless defined(&CFG_LOOP_PAYLOAD);
    eval 'sub CFG_LOOP_LINE () {3;}' unless defined(&CFG_LOOP_LINE);
    eval 'sub CFG_LOOP_OTHER () {4;}' unless defined(&CFG_LOOP_OTHER);
    eval 'sub CFG_LOOP_INWARD () {5;}' unless defined(&CFG_LOOP_INWARD);
    eval 'sub CFG_LOOP_DUAL () {6;}' unless defined(&CFG_LOOP_DUAL);
    eval 'sub CFG_LOOP_TULIP () {16;}' unless defined(&CFG_LOOP_TULIP);
    eval 'sub CFG_LOOP_PINS () {17;}' unless defined(&CFG_LOOP_PINS);
    eval 'sub CFG_LOOP_LL () {18;}' unless defined(&CFG_LOOP_LL);
    eval 'sub CFG_LOOP_RL () {19;}' unless defined(&CFG_LOOP_RL);
    eval 'sub CFG_CLKMUX_ST () {1;}' unless defined(&CFG_CLKMUX_ST);
    eval 'sub CFG_CLKMUX_INT () {2;}' unless defined(&CFG_CLKMUX_INT);
    eval 'sub CFG_CLKMUX_RT () {3;}' unless defined(&CFG_CLKMUX_RT);
    eval 'sub CFG_CLKMUX_EXT () {4;}' unless defined(&CFG_CLKMUX_EXT);
    eval 'sub CFG_FORMAT_T1SF () {9;}' unless defined(&CFG_FORMAT_T1SF);
    eval 'sub CFG_FORMAT_T1ESF () {27;}' unless defined(&CFG_FORMAT_T1ESF);
    eval 'sub CFG_FORMAT_E1FAS () {0;}' unless defined(&CFG_FORMAT_E1FAS);
    eval 'sub CFG_FORMAT_E1FASCRC () {8;}' unless defined(&CFG_FORMAT_E1FASCRC);
    eval 'sub CFG_FORMAT_E1FASCAS () {16;}' unless defined(&CFG_FORMAT_E1FASCAS);
    eval 'sub CFG_FORMAT_E1FASCRCCAS () {24;}' unless defined(&CFG_FORMAT_E1FASCRCCAS);
    eval 'sub CFG_FORMAT_E1NONE () {32;}' unless defined(&CFG_FORMAT_E1NONE);
    eval 'sub CFG_FORMAT_T3CPAR () {100;}' unless defined(&CFG_FORMAT_T3CPAR);
    eval 'sub CFG_FORMAT_T3M13 () {101;}' unless defined(&CFG_FORMAT_T3M13);
    eval 'sub FORMAT_T1ANY () {(( ($sc->{config}->{format}) & 1)==1);}' unless defined(&FORMAT_T1ANY);
    eval 'sub FORMAT_E1ANY () {(( ($sc->{config}->{format}) & 1)==0);}' unless defined(&FORMAT_E1ANY);
    eval 'sub FORMAT_E1CAS () {(( ($sc->{config}->{format}) & 0x11)==0x10);}' unless defined(&FORMAT_E1CAS);
    eval 'sub FORMAT_E1CRC () {(( ($sc->{config}->{format}) & 0x9)==0x8);}' unless defined(&FORMAT_E1CRC);
    eval 'sub FORMAT_E1NONE () {( ($sc->{config}->{format}) ==  &CFG_FORMAT_E1NONE);}' unless defined(&FORMAT_E1NONE);
    eval 'sub FORMAT_T1ESF () {( ($sc->{config}->{format}) ==  &CFG_FORMAT_T1ESF);}' unless defined(&FORMAT_T1ESF);
    eval 'sub FORMAT_T1SF () {( ($sc->{config}->{format}) ==  &CFG_FORMAT_T1SF);}' unless defined(&FORMAT_T1SF);
    eval 'sub FORMAT_T3CPAR () {( ($sc->{config}->{format}) ==  &CFG_FORMAT_T3CPAR);}' unless defined(&FORMAT_T3CPAR);
    eval 'sub CFG_SCRAM_OFF () {1;}' unless defined(&CFG_SCRAM_OFF);
    eval 'sub CFG_SCRAM_DL_KEN () {2;}' unless defined(&CFG_SCRAM_DL_KEN);
    eval 'sub CFG_SCRAM_LARS () {3;}' unless defined(&CFG_SCRAM_LARS);
    eval 'sub CFG_DTE () {1;}' unless defined(&CFG_DTE);
    eval 'sub CFG_DCE () {2;}' unless defined(&CFG_DCE);
    eval 'sub CFG_GAIN_SHORT () {0x24;}' unless defined(&CFG_GAIN_SHORT);
    eval 'sub CFG_GAIN_MEDIUM () {0x2c;}' unless defined(&CFG_GAIN_MEDIUM);
    eval 'sub CFG_GAIN_LONG () {0x34;}' unless defined(&CFG_GAIN_LONG);
    eval 'sub CFG_GAIN_EXTEND () {0x3f;}' unless defined(&CFG_GAIN_EXTEND);
    eval 'sub CFG_GAIN_AUTO () {0xff;}' unless defined(&CFG_GAIN_AUTO);
    eval 'sub CFG_PULSE_T1DSX0 () {0;}' unless defined(&CFG_PULSE_T1DSX0);
    eval 'sub CFG_PULSE_T1DSX1 () {2;}' unless defined(&CFG_PULSE_T1DSX1);
    eval 'sub CFG_PULSE_T1DSX2 () {4;}' unless defined(&CFG_PULSE_T1DSX2);
    eval 'sub CFG_PULSE_T1DSX3 () {6;}' unless defined(&CFG_PULSE_T1DSX3);
    eval 'sub CFG_PULSE_T1DSX4 () {8;}' unless defined(&CFG_PULSE_T1DSX4);
    eval 'sub CFG_PULSE_E1COAX () {10;}' unless defined(&CFG_PULSE_E1COAX);
    eval 'sub CFG_PULSE_E1TWIST () {12;}' unless defined(&CFG_PULSE_E1TWIST);
    eval 'sub CFG_PULSE_T1CSU () {14;}' unless defined(&CFG_PULSE_T1CSU);
    eval 'sub CFG_PULSE_AUTO () {0xff;}' unless defined(&CFG_PULSE_AUTO);
    eval 'sub CFG_LBO_0DB () {0;}' unless defined(&CFG_LBO_0DB);
    eval 'sub CFG_LBO_7DB () {16;}' unless defined(&CFG_LBO_7DB);
    eval 'sub CFG_LBO_15DB () {32;}' unless defined(&CFG_LBO_15DB);
    eval 'sub CFG_LBO_22DB () {48;}' unless defined(&CFG_LBO_22DB);
    eval 'sub CFG_LBO_AUTO () {0xff;}' unless defined(&CFG_LBO_AUTO);
    eval 'sub IOCTL_RW_PCI () {1;}' unless defined(&IOCTL_RW_PCI);
    eval 'sub IOCTL_RW_CSR () {2;}' unless defined(&IOCTL_RW_CSR);
    eval 'sub IOCTL_RW_SROM () {3;}' unless defined(&IOCTL_RW_SROM);
    eval 'sub IOCTL_RW_BIOS () {4;}' unless defined(&IOCTL_RW_BIOS);
    eval 'sub IOCTL_RW_MII () {5;}' unless defined(&IOCTL_RW_MII);
    eval 'sub IOCTL_RW_FRAME () {6;}' unless defined(&IOCTL_RW_FRAME);
    eval 'sub IOCTL_WO_SYNTH () {7;}' unless defined(&IOCTL_WO_SYNTH);
    eval 'sub IOCTL_WO_DAC () {8;}' unless defined(&IOCTL_WO_DAC);
    eval 'sub IOCTL_XILINX_RESET () {16;}' unless defined(&IOCTL_XILINX_RESET);
    eval 'sub IOCTL_XILINX_ROM () {17;}' unless defined(&IOCTL_XILINX_ROM);
    eval 'sub IOCTL_XILINX_FILE () {18;}' unless defined(&IOCTL_XILINX_FILE);
    eval 'sub IOCTL_SET_STATUS () {50;}' unless defined(&IOCTL_SET_STATUS);
    eval 'sub IOCTL_SNMP_SEND () {51;}' unless defined(&IOCTL_SNMP_SEND);
    eval 'sub IOCTL_SNMP_LOOP () {52;}' unless defined(&IOCTL_SNMP_LOOP);
    eval 'sub IOCTL_SNMP_SIGS () {53;}' unless defined(&IOCTL_SNMP_SIGS);
    eval 'sub IOCTL_RESET_CNTRS () {54;}' unless defined(&IOCTL_RESET_CNTRS);
    if(((defined(&_KERNEL) ? &_KERNEL : undef) || (defined(&KERNEL) ? &KERNEL : undef) || (defined(&__KERNEL__) ? &__KERNEL__ : undef))) {
	eval 'sub SNDQ_MAXLEN () {32;}' unless defined(&SNDQ_MAXLEN);
	eval 'sub DESCS_PER_PKT () {4;}' unless defined(&DESCS_PER_PKT);
	eval 'sub NUM_TX_DESCS () {( &DESCS_PER_PKT *  &SNDQ_MAXLEN);}' unless defined(&NUM_TX_DESCS);
	eval 'sub MAX_CHUNK_LEN () {2016;}' unless defined(&MAX_CHUNK_LEN);
	eval 'sub MAX_DESC_LEN () {(2*  &MAX_CHUNK_LEN);}' unless defined(&MAX_DESC_LEN);
	if(((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&LITTLE_ENDIAN) ? &LITTLE_ENDIAN : undef)) ) {
	} else {
	}
	eval 'sub TLP_BUS_DSL_VAL () {($sizeof{ &bus_dmamap_t} &  &TLP_BUS_DSL);}' unless defined(&TLP_BUS_DSL_VAL);
	eval 'sub TLP_DSTS_OWNER () {0x80000000;}' unless defined(&TLP_DSTS_OWNER);
	eval 'sub TLP_DSTS_RX_DESC_ERR () {0x4000;}' unless defined(&TLP_DSTS_RX_DESC_ERR);
	eval 'sub TLP_DSTS_RX_FIRST_DESC () {0x200;}' unless defined(&TLP_DSTS_RX_FIRST_DESC);
	eval 'sub TLP_DSTS_RX_LAST_DESC () {0x100;}' unless defined(&TLP_DSTS_RX_LAST_DESC);
	eval 'sub TLP_DSTS_RX_MII_ERR () {0x8;}' unless defined(&TLP_DSTS_RX_MII_ERR);
	eval 'sub TLP_DSTS_RX_DRIBBLE () {0x4;}' unless defined(&TLP_DSTS_RX_DRIBBLE);
	eval 'sub TLP_DSTS_TX_UNDERRUN () {0x2;}' unless defined(&TLP_DSTS_TX_UNDERRUN);
	eval 'sub TLP_DSTS_RX_OVERRUN () {0x1;}' unless defined(&TLP_DSTS_RX_OVERRUN);
	eval 'sub TLP_DSTS_RX_BAD () {( &TLP_DSTS_RX_MII_ERR |  &TLP_DSTS_RX_DRIBBLE |  &TLP_DSTS_RX_DESC_ERR |  &TLP_DSTS_RX_OVERRUN);}' unless defined(&TLP_DSTS_RX_BAD);
	eval 'sub TLP_DCTL_TX_INTERRUPT () {0x200;}' unless defined(&TLP_DCTL_TX_INTERRUPT);
	eval 'sub TLP_DCTL_TX_LAST_SEG () {0x100;}' unless defined(&TLP_DCTL_TX_LAST_SEG);
	eval 'sub TLP_DCTL_TX_FIRST_SEG () {0x80;}' unless defined(&TLP_DCTL_TX_FIRST_SEG);
	eval 'sub TLP_DCTL_TX_NO_CRC () {0x10;}' unless defined(&TLP_DCTL_TX_NO_CRC);
	eval 'sub TLP_DCTL_END_RING () {0x8;}' unless defined(&TLP_DCTL_END_RING);
	eval 'sub TLP_DCTL_TX_NO_PAD () {0x2;}' unless defined(&TLP_DCTL_TX_NO_PAD);
	if((defined(&BSD) ? &BSD : undef)) {
	}
	eval 'sub FLAG_IFNET () {0x2;}' unless defined(&FLAG_IFNET);
	eval 'sub FLAG_NETDEV () {0x4;}' unless defined(&FLAG_NETDEV);
	eval 'sub FLAG_NETGRAPH () {0x8;}' unless defined(&FLAG_NETGRAPH);
	eval 'sub IOREF_CSR () {1;}' unless defined(&IOREF_CSR);
	if(defined(&DEVICE_POLLING)) {
	    eval 'sub DEV_POLL () {1;}' unless defined(&DEV_POLL);
	} else {
	    eval 'sub DEV_POLL () {0;}' unless defined(&DEV_POLL);
	}
	if(defined(&ALTQ)  && (defined(&ALTQ) ? &ALTQ : undef)) {
	    eval 'sub ALTQ_PRESENT () {1;}' unless defined(&ALTQ_PRESENT);
	} else {
	    eval 'sub ALTQ_PRESENT () {0;}' unless defined(&ALTQ_PRESENT);
	}
	if((defined(&IFNET) ? &IFNET : undef)) {
	    if((defined(&NSPPP) ? &NSPPP : undef)) {
	    }
 elsif((defined(&P2P) ? &P2P : undef)) {
	    }
	}
	if((defined(&NETGRAPH) ? &NETGRAPH : undef)) {
	}
	if(defined(&DEVICE_POLLING)) {
	}
	eval 'sub READ_PCI_CFG {
	    my($sc, $addr) = @_;
    	    eval q( &pci_read_config (($sc)-> &dev, $addr, 4));
	}' unless defined(&READ_PCI_CFG);
	eval 'sub WRITE_PCI_CFG {
	    my($sc, $addr, $data) = @_;
    	    eval q( &pci_write_config(($sc)-> &dev, $addr, $data, 4));
	}' unless defined(&WRITE_PCI_CFG);
	eval 'sub READ_CSR {
	    my($csr) = @_;
    	    eval q( &bus_space_read_4 ( ($sc->{csr_tag}),  ($sc->{csr_handle}), $csr));
	}' unless defined(&READ_CSR);
	eval 'sub WRITE_CSR {
	    my($csr, $val) = @_;
    	    eval q( &bus_space_write_4( ($sc->{csr_tag}),  ($sc->{csr_handle}), $csr, $val));
	}' unless defined(&WRITE_CSR);
	eval 'sub NAME_UNIT () { &device_get_nameunit( ($sc->{dev}));}' unless defined(&NAME_UNIT);
	eval 'sub DRIVER_DEBUG () {(( ($sc->{config}->{debug})) || ( ($sc->{ifp}->{if_flags}) &  &IFF_DEBUG));}' unless defined(&DRIVER_DEBUG);
	eval 'sub TOP_TRYLOCK () { &mtx_trylock( ($sc->{top_mtx}));}' unless defined(&TOP_TRYLOCK);
	eval 'sub TOP_UNLOCK () { &mtx_unlock ( ($sc->{top_mtx}));}' unless defined(&TOP_UNLOCK);
	eval 'sub BOTTOM_TRYLOCK () { &mtx_trylock( ($sc->{bottom_mtx}));}' unless defined(&BOTTOM_TRYLOCK);
	eval 'sub BOTTOM_UNLOCK () { &mtx_unlock ( ($sc->{bottom_mtx}));}' unless defined(&BOTTOM_UNLOCK);
	eval 'sub CHECK_CAP () { &priv_check( &curthread,  &PRIV_DRIVER);}' unless defined(&CHECK_CAP);
	eval 'sub DISABLE_INTR () {1;}' unless defined(&DISABLE_INTR);
	eval 'sub ENABLE_INTR () {1;}' unless defined(&ENABLE_INTR);
	eval 'sub IRQ_NONE () {1;}' unless defined(&IRQ_NONE);
	eval 'sub IRQ_HANDLED () {1;}' unless defined(&IRQ_HANDLED);
	eval 'sub IFP2SC {
	    my($ifp) = @_;
    	    eval q(($ifp)-> &if_softc);
	}' unless defined(&IFP2SC);
	eval 'sub COPY_BREAK () { &MHLEN;}' unless defined(&COPY_BREAK);
	eval 'sub SLEEP {
	    my($usecs) = @_;
    	    eval q( &tsleep( &sc,  &PCATCH |  &PZERO,  &DEVICE_NAME, 1+($usecs/ &tick)));
	}' unless defined(&SLEEP);
	eval 'sub DMA_SYNC {
	    my($map, $size, $flags) = @_;
    	    eval q( &bus_dmamap_sync( ($ring->{tag}), $map, $flags));
	}' unless defined(&DMA_SYNC);
	eval 'sub DMA_LOAD {
	    my($map, $addr, $size) = @_;
    	    eval q( &bus_dmamap_load( ($ring->{tag}), $map, $addr, $size,  &fbsd_dmamap_load,  &ring, 0));
	}' unless defined(&DMA_LOAD);
	if(((defined(&NBPFILTER) ? &NBPFILTER : undef) != 0)) {
	    eval 'sub LMC_BPF_MTAP {
	        my($mbuf) = @_;
    		eval q( &BPF_MTAP( ($sc->{ifp}), $mbuf));
	    }' unless defined(&LMC_BPF_MTAP);
	    eval 'sub LMC_BPF_ATTACH {
	        my($dlt, $len) = @_;
    		eval q( &bpfattach( ($sc->{ifp}), $dlt, $len));
	    }' unless defined(&LMC_BPF_ATTACH);
	    eval 'sub LMC_BPF_DETACH () { &bpfdetach( ($sc->{ifp}));}' unless defined(&LMC_BPF_DETACH);
	}
	eval 'sub IF_DROP {
	    my($ifq) = @_;
    	    eval q( &_IF_DROP($ifq));
	}' unless defined(&IF_DROP);
	eval 'sub IF_QFULL {
	    my($ifq) = @_;
    	    eval q( &_IF_QFULL($ifq));
	}' unless defined(&IF_QFULL);
	eval 'sub IFF_RUNNING () { &IFF_DRV_RUNNING;}' unless defined(&IFF_RUNNING);
	if(((defined(&NBPFILTER) ? &NBPFILTER : undef) == 0)) {
	    eval 'sub LMC_BPF_MTAP {
	        my($mbuf) = @_;
    		eval q();
	    }' unless defined(&LMC_BPF_MTAP);
	    eval 'sub LMC_BPF_ATTACH {
	        my($dlt, $len) = @_;
    		eval q();
	    }' unless defined(&LMC_BPF_ATTACH);
	    eval 'sub LMC_BPF_DETACH () {1;}' unless defined(&LMC_BPF_DETACH);
	}
	eval 'sub HSSI_DESC () {"SBE/LMC HSSI Card";}' unless defined(&HSSI_DESC);
	eval 'sub T3_DESC () {"SBE/LMC T3 Card";}' unless defined(&T3_DESC);
	eval 'sub SSI_DESC () {"SBE/LMC SSI Card";}' unless defined(&SSI_DESC);
	eval 'sub T1E1_DESC () {"SBE/LMC T1E1 Card";}' unless defined(&T1E1_DESC);
	if((defined(&IFNET) ? &IFNET : undef)) {
	}
	if((defined(&BSD) ? &BSD : undef)) {
	}
	if((defined(&BSD) ? &BSD : undef)) {
	    if((defined(&__FreeBSD__)  && defined(&DEVICE_POLLING))) {
	    }
	}
	if((defined(&P2P) ? &P2P : undef)) {
	}
	if((defined(&NSPPP) ? &NSPPP : undef)) {
	}
	if((defined(&IFNET) ? &IFNET : undef)) {
	}
	if((defined(&NETGRAPH) ? &NETGRAPH : undef)) {
	    if(((defined(&IFNET) ? &IFNET : undef) == 0)) {
	    }
	}
    }
}
1;
