require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MFIREG_H)) {
    eval 'sub _MFIREG_H () {1;}' unless defined(&_MFIREG_H);
    require 'sys/cdefs.ph';
    eval 'sub MEGAMFI_FRAME_SIZE () {64;}' unless defined(&MEGAMFI_FRAME_SIZE);
    eval 'sub MFI_IMSG0 () {0x10;}' unless defined(&MFI_IMSG0);
    eval 'sub MFI_IMSG1 () {0x14;}' unless defined(&MFI_IMSG1);
    eval 'sub MFI_OMSG0 () {0x18;}' unless defined(&MFI_OMSG0);
    eval 'sub MFI_OMSG1 () {0x1c;}' unless defined(&MFI_OMSG1);
    eval 'sub MFI_IDB () {0x20;}' unless defined(&MFI_IDB);
    eval 'sub MFI_ISTS () {0x24;}' unless defined(&MFI_ISTS);
    eval 'sub MFI_IMSK () {0x28;}' unless defined(&MFI_IMSK);
    eval 'sub MFI_ODB () {0x2c;}' unless defined(&MFI_ODB);
    eval 'sub MFI_OSTS () {0x30;}' unless defined(&MFI_OSTS);
    eval 'sub MFI_OMSK () {0x34;}' unless defined(&MFI_OMSK);
    eval 'sub MFI_IQP () {0x40;}' unless defined(&MFI_IQP);
    eval 'sub MFI_OQP () {0x44;}' unless defined(&MFI_OQP);
    eval 'sub MFI_RFPI () {0x48;}' unless defined(&MFI_RFPI);
    eval 'sub MFI_RPI () {0x6c;}' unless defined(&MFI_RPI);
    eval 'sub MFI_ILQP () {0xc0;}' unless defined(&MFI_ILQP);
    eval 'sub MFI_IHQP () {0xc4;}' unless defined(&MFI_IHQP);
    eval 'sub MFI_ODR0 () {0x9c;}' unless defined(&MFI_ODR0);
    eval 'sub MFI_ODCR0 () {0xa0;}' unless defined(&MFI_ODCR0);
    eval 'sub MFI_OSP0 () {0xb0;}' unless defined(&MFI_OSP0);
    eval 'sub MFI_1078_EIM () {0x80000004;}' unless defined(&MFI_1078_EIM);
    eval 'sub MFI_RMI () {0x2;}' unless defined(&MFI_RMI);
    eval 'sub MFI_1078_RM () {0x80000000;}' unless defined(&MFI_1078_RM);
    eval 'sub MFI_ODC () {0x4;}' unless defined(&MFI_ODC);
    eval 'sub MFI_WSR () {0x4;}' unless defined(&MFI_WSR);
    eval 'sub MFI_HDR () {0x8;}' unless defined(&MFI_HDR);
    eval 'sub MFI_RSR () {0x3c3;}' unless defined(&MFI_RSR);
    eval 'sub MFI_GEN2_EIM () {0x5;}' unless defined(&MFI_GEN2_EIM);
    eval 'sub MFI_GEN2_RM () {0x1;}' unless defined(&MFI_GEN2_RM);
    eval 'sub MFI_SKINNY_IDB () {0x;}' unless defined(&MFI_SKINNY_IDB);
    eval 'sub MFI_IQPL () {0xc0;}' unless defined(&MFI_IQPL);
    eval 'sub MFI_IQPH () {0xc4;}' unless defined(&MFI_IQPH);
    eval 'sub MFI_SKINNY_RM () {0x1;}' unless defined(&MFI_SKINNY_RM);
    eval 'sub MFI_OSTS_INTR_VALID () {0x2;}' unless defined(&MFI_OSTS_INTR_VALID);
    eval 'sub MFI_FIRMWARE_STATE_CHANGE () {0x2;}' unless defined(&MFI_FIRMWARE_STATE_CHANGE);
    eval 'sub MFI_STATE_CHANGE_INTERRUPT () {0x4;}' unless defined(&MFI_STATE_CHANGE_INTERRUPT);
    eval 'sub MFI_FWSTATE_MASK () {0xf0000000;}' unless defined(&MFI_FWSTATE_MASK);
    eval 'sub MFI_FWSTATE_UNDEFINED () {0x;}' unless defined(&MFI_FWSTATE_UNDEFINED);
    eval 'sub MFI_FWSTATE_BB_INIT () {0x10000000;}' unless defined(&MFI_FWSTATE_BB_INIT);
    eval 'sub MFI_FWSTATE_FW_INIT () {0x40000000;}' unless defined(&MFI_FWSTATE_FW_INIT);
    eval 'sub MFI_FWSTATE_WAIT_HANDSHAKE () {0x60000000;}' unless defined(&MFI_FWSTATE_WAIT_HANDSHAKE);
    eval 'sub MFI_FWSTATE_FW_INIT_2 () {0x70000000;}' unless defined(&MFI_FWSTATE_FW_INIT_2);
    eval 'sub MFI_FWSTATE_DEVICE_SCAN () {0x80000000;}' unless defined(&MFI_FWSTATE_DEVICE_SCAN);
    eval 'sub MFI_FWSTATE_BOOT_MESSAGE_PENDING () {0x90000000;}' unless defined(&MFI_FWSTATE_BOOT_MESSAGE_PENDING);
    eval 'sub MFI_FWSTATE_FLUSH_CACHE () {0xa0000000;}' unless defined(&MFI_FWSTATE_FLUSH_CACHE);
    eval 'sub MFI_FWSTATE_READY () {0xb0000000;}' unless defined(&MFI_FWSTATE_READY);
    eval 'sub MFI_FWSTATE_OPERATIONAL () {0xc0000000;}' unless defined(&MFI_FWSTATE_OPERATIONAL);
    eval 'sub MFI_FWSTATE_FAULT () {0xf0000000;}' unless defined(&MFI_FWSTATE_FAULT);
    eval 'sub MFI_FWSTATE_MAXSGL_MASK () {0xff0000;}' unless defined(&MFI_FWSTATE_MAXSGL_MASK);
    eval 'sub MFI_FWSTATE_MAXCMD_MASK () {0xffff;}' unless defined(&MFI_FWSTATE_MAXCMD_MASK);
    eval 'sub MFI_FWSTATE_HOSTMEMREQD_MASK () {0x8000000;}' unless defined(&MFI_FWSTATE_HOSTMEMREQD_MASK);
    eval 'sub MFI_FWSTATE_BOOT_MESSAGE_PENDING () {0x90000000;}' unless defined(&MFI_FWSTATE_BOOT_MESSAGE_PENDING);
    eval 'sub MFI_RESET_REQUIRED () {0x1;}' unless defined(&MFI_RESET_REQUIRED);
    eval 'sub MFI_FWSTATE_TB_MASK () {0xf0000000;}' unless defined(&MFI_FWSTATE_TB_MASK);
    eval 'sub MFI_FWSTATE_TB_RESET () {0x;}' unless defined(&MFI_FWSTATE_TB_RESET);
    eval 'sub MFI_FWSTATE_TB_READY () {0x10000000;}' unless defined(&MFI_FWSTATE_TB_READY);
    eval 'sub MFI_FWSTATE_TB_OPERATIONAL () {0x20000000;}' unless defined(&MFI_FWSTATE_TB_OPERATIONAL);
    eval 'sub MFI_FWSTATE_TB_FAULT () {0x40000000;}' unless defined(&MFI_FWSTATE_TB_FAULT);
    eval 'sub MFI_FWINIT_ABORT () {0x;}' unless defined(&MFI_FWINIT_ABORT);
    eval 'sub MFI_FWINIT_READY () {0x2;}' unless defined(&MFI_FWINIT_READY);
    eval 'sub MFI_FWINIT_MFIMODE () {0x4;}' unless defined(&MFI_FWINIT_MFIMODE);
    eval 'sub MFI_FWINIT_CLEAR_HANDSHAKE () {0x8;}' unless defined(&MFI_FWINIT_CLEAR_HANDSHAKE);
    eval 'sub MFI_FWINIT_HOTPLUG () {0x10;}' unless defined(&MFI_FWINIT_HOTPLUG);
    eval 'sub MFI_STOP_ADP () {0x20;}' unless defined(&MFI_STOP_ADP);
    eval 'sub MFI_ADP_RESET () {0x40;}' unless defined(&MFI_ADP_RESET);
    eval 'sub DIAG_WRITE_ENABLE () {0x80;}' unless defined(&DIAG_WRITE_ENABLE);
    eval 'sub DIAG_RESET_ADAPTER () {0x4;}' unless defined(&DIAG_RESET_ADAPTER);
    eval("sub MFI_CMD_INIT () { 0x00; }") unless defined(&MFI_CMD_INIT);
    eval("sub MFI_CMD_LD_READ () { 1; }") unless defined(&MFI_CMD_LD_READ);
    eval("sub MFI_CMD_LD_WRITE () { 2; }") unless defined(&MFI_CMD_LD_WRITE);
    eval("sub MFI_CMD_LD_SCSI_IO () { 3; }") unless defined(&MFI_CMD_LD_SCSI_IO);
    eval("sub MFI_CMD_PD_SCSI_IO () { 4; }") unless defined(&MFI_CMD_PD_SCSI_IO);
    eval("sub MFI_CMD_DCMD () { 5; }") unless defined(&MFI_CMD_DCMD);
    eval("sub MFI_CMD_ABORT () { 6; }") unless defined(&MFI_CMD_ABORT);
    eval("sub MFI_CMD_SMP () { 7; }") unless defined(&MFI_CMD_SMP);
    eval("sub MFI_CMD_STP () { 8; }") unless defined(&MFI_CMD_STP);
    eval("sub MFI_DCMD_CTRL_GETINFO () { 0x01010000; }") unless defined(&MFI_DCMD_CTRL_GETINFO);
    eval("sub MFI_DCMD_CTRL_MFI_HOST_MEM_ALLOC () { 0x0100e100; }") unless defined(&MFI_DCMD_CTRL_MFI_HOST_MEM_ALLOC);
    eval("sub MFI_DCMD_CTRL_MFC_DEFAULTS_GET () { 0x010e0201; }") unless defined(&MFI_DCMD_CTRL_MFC_DEFAULTS_GET);
    eval("sub MFI_DCMD_CTRL_MFC_DEFAULTS_SET () { 0x010e0202; }") unless defined(&MFI_DCMD_CTRL_MFC_DEFAULTS_SET);
    eval("sub MFI_DCMD_CTRL_FLUSHCACHE () { 0x01101000; }") unless defined(&MFI_DCMD_CTRL_FLUSHCACHE);
    eval("sub MFI_DCMD_CTRL_GET_PROPS () { 0x01020100; }") unless defined(&MFI_DCMD_CTRL_GET_PROPS);
    eval("sub MFI_DCMD_CTRL_SET_PROPS () { 0x01020200; }") unless defined(&MFI_DCMD_CTRL_SET_PROPS);
    eval("sub MFI_DCMD_CTRL_SHUTDOWN () { 0x01050000; }") unless defined(&MFI_DCMD_CTRL_SHUTDOWN);
    eval("sub MFI_DCMD_CTRL_EVENT_GETINFO () { 0x01040100; }") unless defined(&MFI_DCMD_CTRL_EVENT_GETINFO);
    eval("sub MFI_DCMD_CTRL_EVENT_GET () { 0x01040300; }") unless defined(&MFI_DCMD_CTRL_EVENT_GET);
    eval("sub MFI_DCMD_CTRL_EVENT_WAIT () { 0x01040500; }") unless defined(&MFI_DCMD_CTRL_EVENT_WAIT);
    eval("sub MFI_DCMD_PR_GET_STATUS () { 0x01070100; }") unless defined(&MFI_DCMD_PR_GET_STATUS);
    eval("sub MFI_DCMD_PR_GET_PROPERTIES () { 0x01070200; }") unless defined(&MFI_DCMD_PR_GET_PROPERTIES);
    eval("sub MFI_DCMD_PR_SET_PROPERTIES () { 0x01070300; }") unless defined(&MFI_DCMD_PR_SET_PROPERTIES);
    eval("sub MFI_DCMD_PR_START () { 0x01070400; }") unless defined(&MFI_DCMD_PR_START);
    eval("sub MFI_DCMD_PR_STOP () { 0x01070500; }") unless defined(&MFI_DCMD_PR_STOP);
    eval("sub MFI_DCMD_TIME_SECS_GET () { 0x01080201; }") unless defined(&MFI_DCMD_TIME_SECS_GET);
    eval("sub MFI_DCMD_FLASH_FW_OPEN () { 0x010f0100; }") unless defined(&MFI_DCMD_FLASH_FW_OPEN);
    eval("sub MFI_DCMD_FLASH_FW_DOWNLOAD () { 0x010f0200; }") unless defined(&MFI_DCMD_FLASH_FW_DOWNLOAD);
    eval("sub MFI_DCMD_FLASH_FW_FLASH () { 0x010f0300; }") unless defined(&MFI_DCMD_FLASH_FW_FLASH);
    eval("sub MFI_DCMD_FLASH_FW_CLOSE () { 0x010f0400; }") unless defined(&MFI_DCMD_FLASH_FW_CLOSE);
    eval("sub MFI_DCMD_PD_GET_LIST () { 0x02010000; }") unless defined(&MFI_DCMD_PD_GET_LIST);
    eval("sub MFI_DCMD_PD_LIST_QUERY () { 0x02010100; }") unless defined(&MFI_DCMD_PD_LIST_QUERY);
    eval("sub MFI_DCMD_PD_GET_INFO () { 0x02020000; }") unless defined(&MFI_DCMD_PD_GET_INFO);
    eval("sub MFI_DCMD_PD_STATE_SET () { 0x02030100; }") unless defined(&MFI_DCMD_PD_STATE_SET);
    eval("sub MFI_DCMD_PD_REBUILD_START () { 0x02040100; }") unless defined(&MFI_DCMD_PD_REBUILD_START);
    eval("sub MFI_DCMD_PD_REBUILD_ABORT () { 0x02040200; }") unless defined(&MFI_DCMD_PD_REBUILD_ABORT);
    eval("sub MFI_DCMD_PD_CLEAR_START () { 0x02050100; }") unless defined(&MFI_DCMD_PD_CLEAR_START);
    eval("sub MFI_DCMD_PD_CLEAR_ABORT () { 0x02050200; }") unless defined(&MFI_DCMD_PD_CLEAR_ABORT);
    eval("sub MFI_DCMD_PD_GET_PROGRESS () { 0x02060000; }") unless defined(&MFI_DCMD_PD_GET_PROGRESS);
    eval("sub MFI_DCMD_PD_LOCATE_START () { 0x02070100; }") unless defined(&MFI_DCMD_PD_LOCATE_START);
    eval("sub MFI_DCMD_PD_LOCATE_STOP () { 0x02070200; }") unless defined(&MFI_DCMD_PD_LOCATE_STOP);
    eval("sub MFI_DCMD_LD_MAP_GET_INFO () { 0x0300e101; }") unless defined(&MFI_DCMD_LD_MAP_GET_INFO);
    eval("sub MFI_DCMD_LD_SYNC () { 0x0300e102; }") unless defined(&MFI_DCMD_LD_SYNC);
    eval("sub MFI_DCMD_LD_GET_LIST () { 0x03010000; }") unless defined(&MFI_DCMD_LD_GET_LIST);
    eval("sub MFI_DCMD_LD_GET_INFO () { 0x03020000; }") unless defined(&MFI_DCMD_LD_GET_INFO);
    eval("sub MFI_DCMD_LD_GET_PROP () { 0x03030000; }") unless defined(&MFI_DCMD_LD_GET_PROP);
    eval("sub MFI_DCMD_LD_SET_PROP () { 0x03040000; }") unless defined(&MFI_DCMD_LD_SET_PROP);
    eval("sub MFI_DCMD_LD_INIT_START () { 0x03060100; }") unless defined(&MFI_DCMD_LD_INIT_START);
    eval("sub MFI_DCMD_LD_DELETE () { 0x03090000; }") unless defined(&MFI_DCMD_LD_DELETE);
    eval("sub MFI_DCMD_CFG_READ () { 0x04010000; }") unless defined(&MFI_DCMD_CFG_READ);
    eval("sub MFI_DCMD_CFG_ADD () { 0x04020000; }") unless defined(&MFI_DCMD_CFG_ADD);
    eval("sub MFI_DCMD_CFG_CLEAR () { 0x04030000; }") unless defined(&MFI_DCMD_CFG_CLEAR);
    eval("sub MFI_DCMD_CFG_MAKE_SPARE () { 0x04040000; }") unless defined(&MFI_DCMD_CFG_MAKE_SPARE);
    eval("sub MFI_DCMD_CFG_REMOVE_SPARE () { 0x04050000; }") unless defined(&MFI_DCMD_CFG_REMOVE_SPARE);
    eval("sub MFI_DCMD_CFG_FOREIGN_SCAN () { 0x04060100; }") unless defined(&MFI_DCMD_CFG_FOREIGN_SCAN);
    eval("sub MFI_DCMD_CFG_FOREIGN_DISPLAY () { 0x04060200; }") unless defined(&MFI_DCMD_CFG_FOREIGN_DISPLAY);
    eval("sub MFI_DCMD_CFG_FOREIGN_PREVIEW () { 0x04060300; }") unless defined(&MFI_DCMD_CFG_FOREIGN_PREVIEW);
    eval("sub MFI_DCMD_CFG_FOREIGN_IMPORT () { 0x04060400; }") unless defined(&MFI_DCMD_CFG_FOREIGN_IMPORT);
    eval("sub MFI_DCMD_CFG_FOREIGN_CLEAR () { 0x04060500; }") unless defined(&MFI_DCMD_CFG_FOREIGN_CLEAR);
    eval("sub MFI_DCMD_BBU_GET_STATUS () { 0x05010000; }") unless defined(&MFI_DCMD_BBU_GET_STATUS);
    eval("sub MFI_DCMD_BBU_GET_CAPACITY_INFO () { 0x05020000; }") unless defined(&MFI_DCMD_BBU_GET_CAPACITY_INFO);
    eval("sub MFI_DCMD_BBU_GET_DESIGN_INFO () { 0x05030000; }") unless defined(&MFI_DCMD_BBU_GET_DESIGN_INFO);
    eval("sub MFI_DCMD_BBU_START_LEARN () { 0x05040000; }") unless defined(&MFI_DCMD_BBU_START_LEARN);
    eval("sub MFI_DCMD_BBU_GET_PROP () { 0x05050100; }") unless defined(&MFI_DCMD_BBU_GET_PROP);
    eval("sub MFI_DCMD_BBU_SET_PROP () { 0x05050200; }") unless defined(&MFI_DCMD_BBU_SET_PROP);
    eval("sub MFI_DCMD_CLUSTER () { 0x08000000; }") unless defined(&MFI_DCMD_CLUSTER);
    eval("sub MFI_DCMD_CLUSTER_RESET_ALL () { 0x08010100; }") unless defined(&MFI_DCMD_CLUSTER_RESET_ALL);
    eval("sub MFI_DCMD_CLUSTER_RESET_LD () { 0x08010200; }") unless defined(&MFI_DCMD_CLUSTER_RESET_LD);
    eval 'sub MFI_FLUSHCACHE_CTRL () {0x1;}' unless defined(&MFI_FLUSHCACHE_CTRL);
    eval 'sub MFI_FLUSHCACHE_DISK () {0x2;}' unless defined(&MFI_FLUSHCACHE_DISK);
    eval 'sub MFI_SHUTDOWN_SPINDOWN () {0x1;}' unless defined(&MFI_SHUTDOWN_SPINDOWN);
    eval 'sub MFI_FRAME_POST_IN_REPLY_QUEUE () {0x;}' unless defined(&MFI_FRAME_POST_IN_REPLY_QUEUE);
    eval 'sub MFI_FRAME_DONT_POST_IN_REPLY_QUEUE () {0x1;}' unless defined(&MFI_FRAME_DONT_POST_IN_REPLY_QUEUE);
    eval 'sub MFI_FRAME_SGL32 () {0x;}' unless defined(&MFI_FRAME_SGL32);
    eval 'sub MFI_FRAME_SGL64 () {0x2;}' unless defined(&MFI_FRAME_SGL64);
    eval 'sub MFI_FRAME_SENSE32 () {0x;}' unless defined(&MFI_FRAME_SENSE32);
    eval 'sub MFI_FRAME_SENSE64 () {0x4;}' unless defined(&MFI_FRAME_SENSE64);
    eval 'sub MFI_FRAME_DIR_NONE () {0x;}' unless defined(&MFI_FRAME_DIR_NONE);
    eval 'sub MFI_FRAME_DIR_WRITE () {0x8;}' unless defined(&MFI_FRAME_DIR_WRITE);
    eval 'sub MFI_FRAME_DIR_READ () {0x10;}' unless defined(&MFI_FRAME_DIR_READ);
    eval 'sub MFI_FRAME_DIR_BOTH () {0x18;}' unless defined(&MFI_FRAME_DIR_BOTH);
    eval 'sub MFI_FRAME_IEEE_SGL () {0x20;}' unless defined(&MFI_FRAME_IEEE_SGL);
    eval 'sub MFI_FRAME_FMT () {"\\20" "\\1NOPOST" "\\2SGL64" "\\3SENSE64" "\\4WRITE" "\\5READ" "\\6IEEESGL";}' unless defined(&MFI_FRAME_FMT);
    eval 'sub MR_COMMAND_SIZE () {( &MFI_FRAME_SIZE*20);}' unless defined(&MR_COMMAND_SIZE);
    eval 'sub MEGASAS_THUNDERBOLT_MSG_ALLIGNMENT () {256;}' unless defined(&MEGASAS_THUNDERBOLT_MSG_ALLIGNMENT);
    eval 'sub MEGASAS_THUNDERBOLT_NEW_MSG_SIZE () {256;}' unless defined(&MEGASAS_THUNDERBOLT_NEW_MSG_SIZE);
    eval 'sub MEGASAS_THUNDERBOLT_MAX_COMMANDS () {1024;}' unless defined(&MEGASAS_THUNDERBOLT_MAX_COMMANDS);
    eval 'sub MEGASAS_THUNDERBOLT_MAX_REPLY_COUNT () {1024;}' unless defined(&MEGASAS_THUNDERBOLT_MAX_REPLY_COUNT);
    eval 'sub MEGASAS_THUNDERBOLT_REPLY_SIZE () {8;}' unless defined(&MEGASAS_THUNDERBOLT_REPLY_SIZE);
    eval 'sub MEGASAS_THUNDERBOLT_MAX_CHAIN_COUNT () {1;}' unless defined(&MEGASAS_THUNDERBOLT_MAX_CHAIN_COUNT);
    eval 'sub MEGASAS_MAX_SZ_CHAIN_FRAME () {1024;}' unless defined(&MEGASAS_MAX_SZ_CHAIN_FRAME);
    eval 'sub MPI2_FUNCTION_PASSTHRU_IO_REQUEST () {0xf0;}' unless defined(&MPI2_FUNCTION_PASSTHRU_IO_REQUEST);
    eval 'sub MPI2_FUNCTION_LD_IO_REQUEST () {0xf1;}' unless defined(&MPI2_FUNCTION_LD_IO_REQUEST);
    eval 'sub MR_INTERNAL_MFI_FRAMES_SMID () {1;}' unless defined(&MR_INTERNAL_MFI_FRAMES_SMID);
    eval 'sub MR_CTRL_EVENT_WAIT_SMID () {2;}' unless defined(&MR_CTRL_EVENT_WAIT_SMID);
    eval 'sub MR_INTERNAL_DRIVER_RESET_SMID () {3;}' unless defined(&MR_INTERNAL_DRIVER_RESET_SMID);
    eval("sub MFI_STAT_OK () { 0x00; }") unless defined(&MFI_STAT_OK);
    eval("sub MFI_STAT_INVALID_CMD () { 1; }") unless defined(&MFI_STAT_INVALID_CMD);
    eval("sub MFI_STAT_INVALID_DCMD () { 2; }") unless defined(&MFI_STAT_INVALID_DCMD);
    eval("sub MFI_STAT_INVALID_PARAMETER () { 3; }") unless defined(&MFI_STAT_INVALID_PARAMETER);
    eval("sub MFI_STAT_INVALID_SEQUENCE_NUMBER () { 4; }") unless defined(&MFI_STAT_INVALID_SEQUENCE_NUMBER);
    eval("sub MFI_STAT_ABORT_NOT_POSSIBLE () { 5; }") unless defined(&MFI_STAT_ABORT_NOT_POSSIBLE);
    eval("sub MFI_STAT_APP_HOST_CODE_NOT_FOUND () { 6; }") unless defined(&MFI_STAT_APP_HOST_CODE_NOT_FOUND);
    eval("sub MFI_STAT_APP_IN_USE () { 7; }") unless defined(&MFI_STAT_APP_IN_USE);
    eval("sub MFI_STAT_APP_NOT_INITIALIZED () { 8; }") unless defined(&MFI_STAT_APP_NOT_INITIALIZED);
    eval("sub MFI_STAT_ARRAY_INDEX_INVALID () { 9; }") unless defined(&MFI_STAT_ARRAY_INDEX_INVALID);
    eval("sub MFI_STAT_ARRAY_ROW_NOT_EMPTY () { 10; }") unless defined(&MFI_STAT_ARRAY_ROW_NOT_EMPTY);
    eval("sub MFI_STAT_CONFIG_RESOURCE_CONFLICT () { 11; }") unless defined(&MFI_STAT_CONFIG_RESOURCE_CONFLICT);
    eval("sub MFI_STAT_DEVICE_NOT_FOUND () { 12; }") unless defined(&MFI_STAT_DEVICE_NOT_FOUND);
    eval("sub MFI_STAT_DRIVE_TOO_SMALL () { 13; }") unless defined(&MFI_STAT_DRIVE_TOO_SMALL);
    eval("sub MFI_STAT_FLASH_ALLOC_FAIL () { 14; }") unless defined(&MFI_STAT_FLASH_ALLOC_FAIL);
    eval("sub MFI_STAT_FLASH_BUSY () { 15; }") unless defined(&MFI_STAT_FLASH_BUSY);
    eval("sub MFI_STAT_FLASH_ERROR () { 0x10; }") unless defined(&MFI_STAT_FLASH_ERROR);
    eval("sub MFI_STAT_FLASH_IMAGE_BAD () { 1; }") unless defined(&MFI_STAT_FLASH_IMAGE_BAD);
    eval("sub MFI_STAT_FLASH_IMAGE_INCOMPLETE () { 2; }") unless defined(&MFI_STAT_FLASH_IMAGE_INCOMPLETE);
    eval("sub MFI_STAT_FLASH_NOT_OPEN () { 3; }") unless defined(&MFI_STAT_FLASH_NOT_OPEN);
    eval("sub MFI_STAT_FLASH_NOT_STARTED () { 4; }") unless defined(&MFI_STAT_FLASH_NOT_STARTED);
    eval("sub MFI_STAT_FLUSH_FAILED () { 5; }") unless defined(&MFI_STAT_FLUSH_FAILED);
    eval("sub MFI_STAT_HOST_CODE_NOT_FOUNT () { 6; }") unless defined(&MFI_STAT_HOST_CODE_NOT_FOUNT);
    eval("sub MFI_STAT_LD_CC_IN_PROGRESS () { 7; }") unless defined(&MFI_STAT_LD_CC_IN_PROGRESS);
    eval("sub MFI_STAT_LD_INIT_IN_PROGRESS () { 8; }") unless defined(&MFI_STAT_LD_INIT_IN_PROGRESS);
    eval("sub MFI_STAT_LD_LBA_OUT_OF_RANGE () { 9; }") unless defined(&MFI_STAT_LD_LBA_OUT_OF_RANGE);
    eval("sub MFI_STAT_LD_MAX_CONFIGURED () { 10; }") unless defined(&MFI_STAT_LD_MAX_CONFIGURED);
    eval("sub MFI_STAT_LD_NOT_OPTIMAL () { 11; }") unless defined(&MFI_STAT_LD_NOT_OPTIMAL);
    eval("sub MFI_STAT_LD_RBLD_IN_PROGRESS () { 12; }") unless defined(&MFI_STAT_LD_RBLD_IN_PROGRESS);
    eval("sub MFI_STAT_LD_RECON_IN_PROGRESS () { 13; }") unless defined(&MFI_STAT_LD_RECON_IN_PROGRESS);
    eval("sub MFI_STAT_LD_WRONG_RAID_LEVEL () { 14; }") unless defined(&MFI_STAT_LD_WRONG_RAID_LEVEL);
    eval("sub MFI_STAT_MAX_SPARES_EXCEEDED () { 15; }") unless defined(&MFI_STAT_MAX_SPARES_EXCEEDED);
    eval("sub MFI_STAT_MEMORY_NOT_AVAILABLE () { 0x20; }") unless defined(&MFI_STAT_MEMORY_NOT_AVAILABLE);
    eval("sub MFI_STAT_MFC_HW_ERROR () { 1; }") unless defined(&MFI_STAT_MFC_HW_ERROR);
    eval("sub MFI_STAT_NO_HW_PRESENT () { 2; }") unless defined(&MFI_STAT_NO_HW_PRESENT);
    eval("sub MFI_STAT_NOT_FOUND () { 3; }") unless defined(&MFI_STAT_NOT_FOUND);
    eval("sub MFI_STAT_NOT_IN_ENCL () { 4; }") unless defined(&MFI_STAT_NOT_IN_ENCL);
    eval("sub MFI_STAT_PD_CLEAR_IN_PROGRESS () { 5; }") unless defined(&MFI_STAT_PD_CLEAR_IN_PROGRESS);
    eval("sub MFI_STAT_PD_TYPE_WRONG () { 6; }") unless defined(&MFI_STAT_PD_TYPE_WRONG);
    eval("sub MFI_STAT_PR_DISABLED () { 7; }") unless defined(&MFI_STAT_PR_DISABLED);
    eval("sub MFI_STAT_ROW_INDEX_INVALID () { 8; }") unless defined(&MFI_STAT_ROW_INDEX_INVALID);
    eval("sub MFI_STAT_SAS_CONFIG_INVALID_ACTION () { 9; }") unless defined(&MFI_STAT_SAS_CONFIG_INVALID_ACTION);
    eval("sub MFI_STAT_SAS_CONFIG_INVALID_DATA () { 10; }") unless defined(&MFI_STAT_SAS_CONFIG_INVALID_DATA);
    eval("sub MFI_STAT_SAS_CONFIG_INVALID_PAGE () { 11; }") unless defined(&MFI_STAT_SAS_CONFIG_INVALID_PAGE);
    eval("sub MFI_STAT_SAS_CONFIG_INVALID_TYPE () { 12; }") unless defined(&MFI_STAT_SAS_CONFIG_INVALID_TYPE);
    eval("sub MFI_STAT_SCSI_DONE_WITH_ERROR () { 13; }") unless defined(&MFI_STAT_SCSI_DONE_WITH_ERROR);
    eval("sub MFI_STAT_SCSI_IO_FAILED () { 14; }") unless defined(&MFI_STAT_SCSI_IO_FAILED);
    eval("sub MFI_STAT_SCSI_RESERVATION_CONFLICT () { 15; }") unless defined(&MFI_STAT_SCSI_RESERVATION_CONFLICT);
    eval("sub MFI_STAT_SHUTDOWN_FAILED () { 0x30; }") unless defined(&MFI_STAT_SHUTDOWN_FAILED);
    eval("sub MFI_STAT_TIME_NOT_SET () { 1; }") unless defined(&MFI_STAT_TIME_NOT_SET);
    eval("sub MFI_STAT_WRONG_STATE () { 2; }") unless defined(&MFI_STAT_WRONG_STATE);
    eval("sub MFI_STAT_LD_OFFLINE () { 3; }") unless defined(&MFI_STAT_LD_OFFLINE);
    eval("sub MFI_STAT_PEER_NOTIFICATION_REJECTED () { 4; }") unless defined(&MFI_STAT_PEER_NOTIFICATION_REJECTED);
    eval("sub MFI_STAT_PEER_NOTIFICATION_FAILED () { 5; }") unless defined(&MFI_STAT_PEER_NOTIFICATION_FAILED);
    eval("sub MFI_STAT_RESERVATION_IN_PROGRESS () { 6; }") unless defined(&MFI_STAT_RESERVATION_IN_PROGRESS);
    eval("sub MFI_STAT_I2C_ERRORS_DETECTED () { 7; }") unless defined(&MFI_STAT_I2C_ERRORS_DETECTED);
    eval("sub MFI_STAT_PCI_ERRORS_DETECTED () { 8; }") unless defined(&MFI_STAT_PCI_ERRORS_DETECTED);
    eval("sub MFI_STAT_DIAG_FAILED () { 9; }") unless defined(&MFI_STAT_DIAG_FAILED);
    eval("sub MFI_STAT_BOOT_MSG_PENDING () { 10; }") unless defined(&MFI_STAT_BOOT_MSG_PENDING);
    eval("sub MFI_STAT_FOREIGN_CONFIG_INCOMPLETE () { 11; }") unless defined(&MFI_STAT_FOREIGN_CONFIG_INCOMPLETE);
    eval("sub MFI_STAT_INVALID_STATUS () { 0xFF; }") unless defined(&MFI_STAT_INVALID_STATUS);
    eval("sub MFI_EVT_CLASS_DEBUG () { -2; }") unless defined(&MFI_EVT_CLASS_DEBUG);
    eval("sub MFI_EVT_CLASS_PROGRESS () { -1; }") unless defined(&MFI_EVT_CLASS_PROGRESS);
    eval("sub MFI_EVT_CLASS_INFO () { 0; }") unless defined(&MFI_EVT_CLASS_INFO);
    eval("sub MFI_EVT_CLASS_WARNING () { 1; }") unless defined(&MFI_EVT_CLASS_WARNING);
    eval("sub MFI_EVT_CLASS_CRITICAL () { 2; }") unless defined(&MFI_EVT_CLASS_CRITICAL);
    eval("sub MFI_EVT_CLASS_FATAL () { 3; }") unless defined(&MFI_EVT_CLASS_FATAL);
    eval("sub MFI_EVT_CLASS_DEAD () { 4; }") unless defined(&MFI_EVT_CLASS_DEAD);
    eval("sub MFI_EVT_LOCALE_LD () { 0x0001; }") unless defined(&MFI_EVT_LOCALE_LD);
    eval("sub MFI_EVT_LOCALE_PD () { 0x0002; }") unless defined(&MFI_EVT_LOCALE_PD);
    eval("sub MFI_EVT_LOCALE_ENCL () { 0x0004; }") unless defined(&MFI_EVT_LOCALE_ENCL);
    eval("sub MFI_EVT_LOCALE_BBU () { 0x0008; }") unless defined(&MFI_EVT_LOCALE_BBU);
    eval("sub MFI_EVT_LOCALE_SAS () { 0x0010; }") unless defined(&MFI_EVT_LOCALE_SAS);
    eval("sub MFI_EVT_LOCALE_CTRL () { 0x0020; }") unless defined(&MFI_EVT_LOCALE_CTRL);
    eval("sub MFI_EVT_LOCALE_CONFIG () { 0x0040; }") unless defined(&MFI_EVT_LOCALE_CONFIG);
    eval("sub MFI_EVT_LOCALE_CLUSTER () { 0x0080; }") unless defined(&MFI_EVT_LOCALE_CLUSTER);
    eval("sub MFI_EVT_LOCALE_ALL () { 0xffff; }") unless defined(&MFI_EVT_LOCALE_ALL);
    eval("sub MR_EVT_ARGS_NONE () { 0x00; }") unless defined(&MR_EVT_ARGS_NONE);
    eval("sub MR_EVT_ARGS_CDB_SENSE () { 1; }") unless defined(&MR_EVT_ARGS_CDB_SENSE);
    eval("sub MR_EVT_ARGS_LD () { 2; }") unless defined(&MR_EVT_ARGS_LD);
    eval("sub MR_EVT_ARGS_LD_COUNT () { 3; }") unless defined(&MR_EVT_ARGS_LD_COUNT);
    eval("sub MR_EVT_ARGS_LD_LBA () { 4; }") unless defined(&MR_EVT_ARGS_LD_LBA);
    eval("sub MR_EVT_ARGS_LD_OWNER () { 5; }") unless defined(&MR_EVT_ARGS_LD_OWNER);
    eval("sub MR_EVT_ARGS_LD_LBA_PD_LBA () { 6; }") unless defined(&MR_EVT_ARGS_LD_LBA_PD_LBA);
    eval("sub MR_EVT_ARGS_LD_PROG () { 7; }") unless defined(&MR_EVT_ARGS_LD_PROG);
    eval("sub MR_EVT_ARGS_LD_STATE () { 8; }") unless defined(&MR_EVT_ARGS_LD_STATE);
    eval("sub MR_EVT_ARGS_LD_STRIP () { 9; }") unless defined(&MR_EVT_ARGS_LD_STRIP);
    eval("sub MR_EVT_ARGS_PD () { 10; }") unless defined(&MR_EVT_ARGS_PD);
    eval("sub MR_EVT_ARGS_PD_ERR () { 11; }") unless defined(&MR_EVT_ARGS_PD_ERR);
    eval("sub MR_EVT_ARGS_PD_LBA () { 12; }") unless defined(&MR_EVT_ARGS_PD_LBA);
    eval("sub MR_EVT_ARGS_PD_LBA_LD () { 13; }") unless defined(&MR_EVT_ARGS_PD_LBA_LD);
    eval("sub MR_EVT_ARGS_PD_PROG () { 14; }") unless defined(&MR_EVT_ARGS_PD_PROG);
    eval("sub MR_EVT_ARGS_PD_STATE () { 15; }") unless defined(&MR_EVT_ARGS_PD_STATE);
    eval("sub MR_EVT_ARGS_PCI () { 16; }") unless defined(&MR_EVT_ARGS_PCI);
    eval("sub MR_EVT_ARGS_RATE () { 17; }") unless defined(&MR_EVT_ARGS_RATE);
    eval("sub MR_EVT_ARGS_STR () { 18; }") unless defined(&MR_EVT_ARGS_STR);
    eval("sub MR_EVT_ARGS_TIME () { 19; }") unless defined(&MR_EVT_ARGS_TIME);
    eval("sub MR_EVT_ARGS_ECC () { 20; }") unless defined(&MR_EVT_ARGS_ECC);
    eval 'sub MR_EVT_CTRL_HOST_BUS_SCAN_REQUESTED () {0x152;}' unless defined(&MR_EVT_CTRL_HOST_BUS_SCAN_REQUESTED);
    eval 'sub MR_EVT_PD_REMOVED () {0x70;}' unless defined(&MR_EVT_PD_REMOVED);
    eval 'sub MR_EVT_PD_INSERTED () {0x5b;}' unless defined(&MR_EVT_PD_INSERTED);
    eval 'sub MR_EVT_LD_CHANGE () {0x51;}' unless defined(&MR_EVT_LD_CHANGE);
    eval("sub MR_LD_CACHE_WRITE_BACK () { 0x01; }") unless defined(&MR_LD_CACHE_WRITE_BACK);
    eval("sub MR_LD_CACHE_WRITE_ADAPTIVE () { 0x02; }") unless defined(&MR_LD_CACHE_WRITE_ADAPTIVE);
    eval("sub MR_LD_CACHE_READ_AHEAD () { 0x04; }") unless defined(&MR_LD_CACHE_READ_AHEAD);
    eval("sub MR_LD_CACHE_READ_ADAPTIVE () { 0x08; }") unless defined(&MR_LD_CACHE_READ_ADAPTIVE);
    eval("sub MR_LD_CACHE_WRITE_CACHE_BAD_BBU () { 0x10; }") unless defined(&MR_LD_CACHE_WRITE_CACHE_BAD_BBU);
    eval("sub MR_LD_CACHE_ALLOW_WRITE_CACHE () { 0x20; }") unless defined(&MR_LD_CACHE_ALLOW_WRITE_CACHE);
    eval("sub MR_LD_CACHE_ALLOW_READ_CACHE () { 0x40; }") unless defined(&MR_LD_CACHE_ALLOW_READ_CACHE);
    eval 'sub MR_LD_CACHE_MASK () {0x7f;}' unless defined(&MR_LD_CACHE_MASK);
    eval 'sub MR_LD_CACHE_POLICY_READ_AHEAD_NONE () {0;}' unless defined(&MR_LD_CACHE_POLICY_READ_AHEAD_NONE);
    eval 'sub MR_LD_CACHE_POLICY_READ_AHEAD_ALWAYS () { &MR_LD_CACHE_READ_AHEAD;}' unless defined(&MR_LD_CACHE_POLICY_READ_AHEAD_ALWAYS);
    eval 'sub MR_LD_CACHE_POLICY_READ_AHEAD_ADAPTIVE () {( &MR_LD_CACHE_READ_AHEAD |  &MR_LD_CACHE_READ_ADAPTIVE);}' unless defined(&MR_LD_CACHE_POLICY_READ_AHEAD_ADAPTIVE);
    eval 'sub MR_LD_CACHE_POLICY_WRITE_THROUGH () {0;}' unless defined(&MR_LD_CACHE_POLICY_WRITE_THROUGH);
    eval 'sub MR_LD_CACHE_POLICY_WRITE_BACK () { &MR_LD_CACHE_WRITE_BACK;}' unless defined(&MR_LD_CACHE_POLICY_WRITE_BACK);
    eval 'sub MR_LD_CACHE_POLICY_IO_CACHED () {( &MR_LD_CACHE_ALLOW_WRITE_CACHE |  &MR_LD_CACHE_ALLOW_READ_CACHE);}' unless defined(&MR_LD_CACHE_POLICY_IO_CACHED);
    eval 'sub MR_LD_CACHE_POLICY_IO_DIRECT () {0;}' unless defined(&MR_LD_CACHE_POLICY_IO_DIRECT);
    eval("sub MR_PD_CACHE_UNCHANGED () { 0; }") unless defined(&MR_PD_CACHE_UNCHANGED);
    eval("sub MR_PD_CACHE_ENABLE () { 1; }") unless defined(&MR_PD_CACHE_ENABLE);
    eval("sub MR_PD_CACHE_DISABLE () { 2; }") unless defined(&MR_PD_CACHE_DISABLE);
    eval("sub MR_PD_QUERY_TYPE_ALL () { 0; }") unless defined(&MR_PD_QUERY_TYPE_ALL);
    eval("sub MR_PD_QUERY_TYPE_STATE () { 1; }") unless defined(&MR_PD_QUERY_TYPE_STATE);
    eval("sub MR_PD_QUERY_TYPE_POWER_STATE () { 2; }") unless defined(&MR_PD_QUERY_TYPE_POWER_STATE);
    eval("sub MR_PD_QUERY_TYPE_MEDIA_TYPE () { 3; }") unless defined(&MR_PD_QUERY_TYPE_MEDIA_TYPE);
    eval("sub MR_PD_QUERY_TYPE_SPEED () { 4; }") unless defined(&MR_PD_QUERY_TYPE_SPEED);
    eval("sub MR_PD_QUERY_TYPE_EXPOSED_TO_HOST () { 5; }") unless defined(&MR_PD_QUERY_TYPE_EXPOSED_TO_HOST);
    eval 'sub MFI_MAX_PD_CHANNELS () {2;}' unless defined(&MFI_MAX_PD_CHANNELS);
    eval 'sub MFI_MAX_LD_CHANNELS () {2;}' unless defined(&MFI_MAX_LD_CHANNELS);
    eval 'sub MFI_MAX_CHANNELS () {( &MFI_MAX_PD_CHANNELS +  &MFI_MAX_LD_CHANNELS);}' unless defined(&MFI_MAX_CHANNELS);
    eval 'sub MFI_MAX_CHANNEL_DEVS () {128;}' unless defined(&MFI_MAX_CHANNEL_DEVS);
    eval 'sub MFI_DEFAULT_ID () {-1;}' unless defined(&MFI_DEFAULT_ID);
    eval 'sub MFI_MAX_LUN () {8;}' unless defined(&MFI_MAX_LUN);
    eval 'sub MFI_MAX_LD () {64;}' unless defined(&MFI_MAX_LD);
    eval 'sub MFI_MAX_PD () {256;}' unless defined(&MFI_MAX_PD);
    eval 'sub MFI_FRAME_SIZE () {64;}' unless defined(&MFI_FRAME_SIZE);
    eval 'sub MFI_MBOX_SIZE () {12;}' unless defined(&MFI_MBOX_SIZE);
    eval 'sub MFI_POLL_TIMEOUT_SECS () {60;}' unless defined(&MFI_POLL_TIMEOUT_SECS);
    eval 'sub MFI_SECTOR_LEN () {512;}' unless defined(&MFI_SECTOR_LEN);
    eval 'sub MFI_FRAME_DATAOUT () {0x8;}' unless defined(&MFI_FRAME_DATAOUT);
    eval 'sub MFI_FRAME_DATAIN () {0x10;}' unless defined(&MFI_FRAME_DATAIN);
    if(defined(&MFI_ADDRESS_IS_uint64_t)) {
    } else {
    }
    eval 'sub MFI_IO_FRAME_SIZE () {40;}' unless defined(&MFI_IO_FRAME_SIZE);
    eval 'sub MFI_PASS_FRAME_SIZE () {48;}' unless defined(&MFI_PASS_FRAME_SIZE);
    eval 'sub MFI_DCMD_FRAME_SIZE () {40;}' unless defined(&MFI_DCMD_FRAME_SIZE);
    eval 'sub MFI_SENSE_LEN () {128;}' unless defined(&MFI_SENSE_LEN);
    eval 'sub MFI_INFO_HOST_PCIX () {0x1;}' unless defined(&MFI_INFO_HOST_PCIX);
    eval 'sub MFI_INFO_HOST_PCIE () {0x2;}' unless defined(&MFI_INFO_HOST_PCIE);
    eval 'sub MFI_INFO_HOST_ISCSI () {0x4;}' unless defined(&MFI_INFO_HOST_ISCSI);
    eval 'sub MFI_INFO_HOST_SAS3G () {0x8;}' unless defined(&MFI_INFO_HOST_SAS3G);
    eval 'sub MFI_INFO_DEV_SPI () {0x1;}' unless defined(&MFI_INFO_DEV_SPI);
    eval 'sub MFI_INFO_DEV_SAS3G () {0x2;}' unless defined(&MFI_INFO_DEV_SAS3G);
    eval 'sub MFI_INFO_DEV_SATA1 () {0x4;}' unless defined(&MFI_INFO_DEV_SATA1);
    eval 'sub MFI_INFO_DEV_SATA3G () {0x8;}' unless defined(&MFI_INFO_DEV_SATA3G);
    eval 'sub MFI_INFO_HW_BBU () {0x1;}' unless defined(&MFI_INFO_HW_BBU);
    eval 'sub MFI_INFO_HW_ALARM () {0x2;}' unless defined(&MFI_INFO_HW_ALARM);
    eval 'sub MFI_INFO_HW_NVRAM () {0x4;}' unless defined(&MFI_INFO_HW_NVRAM);
    eval 'sub MFI_INFO_HW_UART () {0x8;}' unless defined(&MFI_INFO_HW_UART);
    eval 'sub MFI_INFO_RAID_0 () {0x1;}' unless defined(&MFI_INFO_RAID_0);
    eval 'sub MFI_INFO_RAID_1 () {0x2;}' unless defined(&MFI_INFO_RAID_1);
    eval 'sub MFI_INFO_RAID_5 () {0x4;}' unless defined(&MFI_INFO_RAID_5);
    eval 'sub MFI_INFO_RAID_1E () {0x8;}' unless defined(&MFI_INFO_RAID_1E);
    eval 'sub MFI_INFO_RAID_6 () {0x10;}' unless defined(&MFI_INFO_RAID_6);
    eval 'sub MFI_INFO_AOPS_RBLD_RATE () {0x1;}' unless defined(&MFI_INFO_AOPS_RBLD_RATE);
    eval 'sub MFI_INFO_AOPS_CC_RATE () {0x2;}' unless defined(&MFI_INFO_AOPS_CC_RATE);
    eval 'sub MFI_INFO_AOPS_BGI_RATE () {0x4;}' unless defined(&MFI_INFO_AOPS_BGI_RATE);
    eval 'sub MFI_INFO_AOPS_RECON_RATE () {0x8;}' unless defined(&MFI_INFO_AOPS_RECON_RATE);
    eval 'sub MFI_INFO_AOPS_PATROL_RATE () {0x10;}' unless defined(&MFI_INFO_AOPS_PATROL_RATE);
    eval 'sub MFI_INFO_AOPS_ALARM_CONTROL () {0x20;}' unless defined(&MFI_INFO_AOPS_ALARM_CONTROL);
    eval 'sub MFI_INFO_AOPS_CLUSTER_SUPPORTED () {0x40;}' unless defined(&MFI_INFO_AOPS_CLUSTER_SUPPORTED);
    eval 'sub MFI_INFO_AOPS_BBU () {0x80;}' unless defined(&MFI_INFO_AOPS_BBU);
    eval 'sub MFI_INFO_AOPS_SPANNING_ALLOWED () {0x100;}' unless defined(&MFI_INFO_AOPS_SPANNING_ALLOWED);
    eval 'sub MFI_INFO_AOPS_DEDICATED_SPARES () {0x200;}' unless defined(&MFI_INFO_AOPS_DEDICATED_SPARES);
    eval 'sub MFI_INFO_AOPS_REVERTIBLE_SPARES () {0x400;}' unless defined(&MFI_INFO_AOPS_REVERTIBLE_SPARES);
    eval 'sub MFI_INFO_AOPS_FOREIGN_IMPORT () {0x800;}' unless defined(&MFI_INFO_AOPS_FOREIGN_IMPORT);
    eval 'sub MFI_INFO_AOPS_SELF_DIAGNOSTIC () {0x1000;}' unless defined(&MFI_INFO_AOPS_SELF_DIAGNOSTIC);
    eval 'sub MFI_INFO_AOPS_MIXED_ARRAY () {0x2000;}' unless defined(&MFI_INFO_AOPS_MIXED_ARRAY);
    eval 'sub MFI_INFO_AOPS_GLOBAL_SPARES () {0x4000;}' unless defined(&MFI_INFO_AOPS_GLOBAL_SPARES);
    eval 'sub MFI_INFO_LDOPS_READ_POLICY () {0x1;}' unless defined(&MFI_INFO_LDOPS_READ_POLICY);
    eval 'sub MFI_INFO_LDOPS_WRITE_POLICY () {0x2;}' unless defined(&MFI_INFO_LDOPS_WRITE_POLICY);
    eval 'sub MFI_INFO_LDOPS_IO_POLICY () {0x4;}' unless defined(&MFI_INFO_LDOPS_IO_POLICY);
    eval 'sub MFI_INFO_LDOPS_ACCESS_POLICY () {0x8;}' unless defined(&MFI_INFO_LDOPS_ACCESS_POLICY);
    eval 'sub MFI_INFO_LDOPS_DISK_CACHE_POLICY () {0x10;}' unless defined(&MFI_INFO_LDOPS_DISK_CACHE_POLICY);
    eval 'sub MFI_INFO_PDOPS_FORCE_ONLINE () {0x1;}' unless defined(&MFI_INFO_PDOPS_FORCE_ONLINE);
    eval 'sub MFI_INFO_PDOPS_FORCE_OFFLINE () {0x2;}' unless defined(&MFI_INFO_PDOPS_FORCE_OFFLINE);
    eval 'sub MFI_INFO_PDOPS_FORCE_REBUILD () {0x4;}' unless defined(&MFI_INFO_PDOPS_FORCE_REBUILD);
    eval 'sub MFI_INFO_PDMIX_SAS () {0x1;}' unless defined(&MFI_INFO_PDMIX_SAS);
    eval 'sub MFI_INFO_PDMIX_SATA () {0x2;}' unless defined(&MFI_INFO_PDMIX_SATA);
    eval 'sub MFI_INFO_PDMIX_ENCL () {0x4;}' unless defined(&MFI_INFO_PDMIX_ENCL);
    eval 'sub MFI_INFO_PDMIX_LD () {0x8;}' unless defined(&MFI_INFO_PDMIX_LD);
    eval 'sub MFI_INFO_PDMIX_SATA_CLUSTER () {0x10;}' unless defined(&MFI_INFO_PDMIX_SATA_CLUSTER);
    eval 'sub MFI_PD_PROGRESS_REBUILD () {(1<<0);}' unless defined(&MFI_PD_PROGRESS_REBUILD);
    eval 'sub MFI_PD_PROGRESS_PATROL () {(1<<1);}' unless defined(&MFI_PD_PROGRESS_PATROL);
    eval 'sub MFI_PD_PROGRESS_CLEAR () {(1<<2);}' unless defined(&MFI_PD_PROGRESS_CLEAR);
    eval 'sub MAX_SYS_PDS () {240;}' unless defined(&MAX_SYS_PDS);
    eval("sub MFI_PD_STATE_UNCONFIGURED_GOOD () { 0x00; }") unless defined(&MFI_PD_STATE_UNCONFIGURED_GOOD);
    eval("sub MFI_PD_STATE_UNCONFIGURED_BAD () { 0x01; }") unless defined(&MFI_PD_STATE_UNCONFIGURED_BAD);
    eval("sub MFI_PD_STATE_HOT_SPARE () { 0x02; }") unless defined(&MFI_PD_STATE_HOT_SPARE);
    eval("sub MFI_PD_STATE_OFFLINE () { 0x10; }") unless defined(&MFI_PD_STATE_OFFLINE);
    eval("sub MFI_PD_STATE_FAILED () { 0x11; }") unless defined(&MFI_PD_STATE_FAILED);
    eval("sub MFI_PD_STATE_REBUILD () { 0x14; }") unless defined(&MFI_PD_STATE_REBUILD);
    eval("sub MFI_PD_STATE_ONLINE () { 0x18; }") unless defined(&MFI_PD_STATE_ONLINE);
    eval("sub MFI_PD_STATE_COPYBACK () { 0x20; }") unless defined(&MFI_PD_STATE_COPYBACK);
    eval("sub MFI_PD_STATE_SYSTEM () { 0x40; }") unless defined(&MFI_PD_STATE_SYSTEM);
    eval 'sub MFI_PD_STATE_JBOD () { &MFI_PD_STATE_SYSTEM;}' unless defined(&MFI_PD_STATE_JBOD);
    eval("sub MFI_LD_ACCESS_RW () { 0; }") unless defined(&MFI_LD_ACCESS_RW);
    eval("sub MFI_LD_ACCSSS_RO () { 2; }") unless defined(&MFI_LD_ACCSSS_RO);
    eval("sub MFI_LD_ACCESS_BLOCKED () { 3; }") unless defined(&MFI_LD_ACCESS_BLOCKED);
    eval 'sub MFI_LD_ACCESS_MASK () {3;}' unless defined(&MFI_LD_ACCESS_MASK);
    eval("sub MFI_LD_STATE_OFFLINE () { 0; }") unless defined(&MFI_LD_STATE_OFFLINE);
    eval("sub MFI_LD_STATE_PARTIALLY_DEGRADED () { 1; }") unless defined(&MFI_LD_STATE_PARTIALLY_DEGRADED);
    eval("sub MFI_LD_STATE_DEGRADED () { 2; }") unless defined(&MFI_LD_STATE_DEGRADED);
    eval("sub MFI_LD_STATE_OPTIMAL () { 3; }") unless defined(&MFI_LD_STATE_OPTIMAL);
    eval 'sub MFI_LD_PARAMS_INIT_NO () {0;}' unless defined(&MFI_LD_PARAMS_INIT_NO);
    eval 'sub MFI_LD_PARAMS_INIT_QUICK () {1;}' unless defined(&MFI_LD_PARAMS_INIT_QUICK);
    eval 'sub MFI_LD_PARAMS_INIT_FULL () {2;}' unless defined(&MFI_LD_PARAMS_INIT_FULL);
    eval 'sub MFI_LD_PROGRESS_CC () {(1<<0);}' unless defined(&MFI_LD_PROGRESS_CC);
    eval 'sub MFI_LD_PROGRESS_BGI () {(1<<1);}' unless defined(&MFI_LD_PROGRESS_BGI);
    eval 'sub MFI_LD_PROGRESS_FGI () {(1<<2);}' unless defined(&MFI_LD_PROGRESS_FGI);
    eval 'sub MFI_LD_PROGRESS_RECON () {(1<<3);}' unless defined(&MFI_LD_PROGRESS_RECON);
    eval 'sub MFI_MAX_SPAN_DEPTH () {8;}' unless defined(&MFI_MAX_SPAN_DEPTH);
    eval 'sub MFI_MAX_ARRAYS () {16;}' unless defined(&MFI_MAX_ARRAYS);
    eval 'sub MFI_SPARE_DEDICATED () {(1<< 0);}' unless defined(&MFI_SPARE_DEDICATED);
    eval 'sub MFI_SPARE_REVERTIBLE () {(1<< 1);}' unless defined(&MFI_SPARE_REVERTIBLE);
    eval 'sub MFI_SPARE_ENCL_AFFINITY () {(1<< 2);}' unless defined(&MFI_SPARE_ENCL_AFFINITY);
    eval 'sub MFI_MAX_ROW_SIZE () {32;}' unless defined(&MFI_MAX_ROW_SIZE);
    eval 'sub MFI_BBU_TYPE_NONE () {0;}' unless defined(&MFI_BBU_TYPE_NONE);
    eval 'sub MFI_BBU_TYPE_IBBU () {1;}' unless defined(&MFI_BBU_TYPE_IBBU);
    eval 'sub MFI_BBU_TYPE_BBU () {2;}' unless defined(&MFI_BBU_TYPE_BBU);
    eval 'sub MFI_BBU_STATE_PACK_MISSING () {(1<< 0);}' unless defined(&MFI_BBU_STATE_PACK_MISSING);
    eval 'sub MFI_BBU_STATE_VOLTAGE_LOW () {(1<< 1);}' unless defined(&MFI_BBU_STATE_VOLTAGE_LOW);
    eval 'sub MFI_BBU_STATE_TEMPERATURE_HIGH () {(1<< 2);}' unless defined(&MFI_BBU_STATE_TEMPERATURE_HIGH);
    eval 'sub MFI_BBU_STATE_CHARGE_ACTIVE () {(1<< 3);}' unless defined(&MFI_BBU_STATE_CHARGE_ACTIVE);
    eval 'sub MFI_BBU_STATE_DISCHARGE_ACTIVE () {(1<< 4);}' unless defined(&MFI_BBU_STATE_DISCHARGE_ACTIVE);
    eval 'sub MFI_BBU_STATE_LEARN_CYC_REQ () {(1<< 5);}' unless defined(&MFI_BBU_STATE_LEARN_CYC_REQ);
    eval 'sub MFI_BBU_STATE_LEARN_CYC_ACTIVE () {(1<< 6);}' unless defined(&MFI_BBU_STATE_LEARN_CYC_ACTIVE);
    eval 'sub MFI_BBU_STATE_LEARN_CYC_FAIL () {(1<< 7);}' unless defined(&MFI_BBU_STATE_LEARN_CYC_FAIL);
    eval 'sub MFI_BBU_STATE_LEARN_CYC_TIMEOUT () {(1<< 8);}' unless defined(&MFI_BBU_STATE_LEARN_CYC_TIMEOUT);
    eval 'sub MFI_BBU_STATE_I2C_ERR_DETECT () {(1<< 9);}' unless defined(&MFI_BBU_STATE_I2C_ERR_DETECT);
    eval("sub MFI_PR_STATE_STOPPED () { 0; }") unless defined(&MFI_PR_STATE_STOPPED);
    eval("sub MFI_PR_STATE_READY () { 1; }") unless defined(&MFI_PR_STATE_READY);
    eval("sub MFI_PR_STATE_ACTIVE () { 2; }") unless defined(&MFI_PR_STATE_ACTIVE);
    eval("sub MFI_PR_STATE_ABORTED () { 0xff; }") unless defined(&MFI_PR_STATE_ABORTED);
    eval("sub MFI_PR_OPMODE_AUTO () { 0; }") unless defined(&MFI_PR_OPMODE_AUTO);
    eval("sub MFI_PR_OPMODE_MANUAL () { 1; }") unless defined(&MFI_PR_OPMODE_MANUAL);
    eval("sub MFI_PR_OPMODE_DISABLED () { 2; }") unless defined(&MFI_PR_OPMODE_DISABLED);
    eval 'sub NA_MPI2_FUNCTION_SCSI_IO_REQUEST () {(0x);}' unless defined(&NA_MPI2_FUNCTION_SCSI_IO_REQUEST);
    eval 'sub MPI2_FUNCTION_SCSI_TASK_MGMT () {(0x1);}' unless defined(&MPI2_FUNCTION_SCSI_TASK_MGMT);
    eval 'sub MPI2_FUNCTION_IOC_INIT () {(0x2);}' unless defined(&MPI2_FUNCTION_IOC_INIT);
    eval 'sub MPI2_FUNCTION_IOC_FACTS () {(0x3);}' unless defined(&MPI2_FUNCTION_IOC_FACTS);
    eval 'sub MPI2_FUNCTION_CONFIG () {(0x4);}' unless defined(&MPI2_FUNCTION_CONFIG);
    eval 'sub MPI2_FUNCTION_PORT_FACTS () {(0x5);}' unless defined(&MPI2_FUNCTION_PORT_FACTS);
    eval 'sub MPI2_FUNCTION_PORT_ENABLE () {(0x6);}' unless defined(&MPI2_FUNCTION_PORT_ENABLE);
    eval 'sub MPI2_FUNCTION_EVENT_NOTIFICATION () {(0x7);}' unless defined(&MPI2_FUNCTION_EVENT_NOTIFICATION);
    eval 'sub MPI2_FUNCTION_EVENT_ACK () {(0x8);}' unless defined(&MPI2_FUNCTION_EVENT_ACK);
    eval 'sub MPI2_FUNCTION_FW_DOWNLOAD () {(0x9);}' unless defined(&MPI2_FUNCTION_FW_DOWNLOAD);
    eval 'sub MPI2_FUNCTION_TARGET_ASSIST () {(0xb);}' unless defined(&MPI2_FUNCTION_TARGET_ASSIST);
    eval 'sub MPI2_FUNCTION_TARGET_STATUS_SEND () {(0xc);}' unless defined(&MPI2_FUNCTION_TARGET_STATUS_SEND);
    eval 'sub MPI2_FUNCTION_TARGET_MODE_ABORT () {(0xd);}' unless defined(&MPI2_FUNCTION_TARGET_MODE_ABORT);
    eval 'sub MPI2_FUNCTION_FW_UPLOAD () {(0x12);}' unless defined(&MPI2_FUNCTION_FW_UPLOAD);
    eval 'sub MPI2_FUNCTION_RAID_ACTION () {(0x15);}' unless defined(&MPI2_FUNCTION_RAID_ACTION);
    eval 'sub MPI2_FUNCTION_RAID_SCSI_IO_PASSTHROUGH () {(0x16);}' unless defined(&MPI2_FUNCTION_RAID_SCSI_IO_PASSTHROUGH);
    eval 'sub MPI2_FUNCTION_TOOLBOX () {(0x17);}' unless defined(&MPI2_FUNCTION_TOOLBOX);
    eval 'sub MPI2_FUNCTION_SCSI_ENCLOSURE_PROCESSOR () {(0x18);}' unless defined(&MPI2_FUNCTION_SCSI_ENCLOSURE_PROCESSOR);
    eval 'sub MPI2_FUNCTION_SMP_PASSTHROUGH () {(0x1a);}' unless defined(&MPI2_FUNCTION_SMP_PASSTHROUGH);
    eval 'sub MPI2_FUNCTION_SAS_IO_UNIT_CONTROL () {(0x1b);}' unless defined(&MPI2_FUNCTION_SAS_IO_UNIT_CONTROL);
    eval 'sub MPI2_FUNCTION_SATA_PASSTHROUGH () {(0x1c);}' unless defined(&MPI2_FUNCTION_SATA_PASSTHROUGH);
    eval 'sub MPI2_FUNCTION_DIAG_BUFFER_POST () {(0x1d);}' unless defined(&MPI2_FUNCTION_DIAG_BUFFER_POST);
    eval 'sub MPI2_FUNCTION_DIAG_RELEASE () {(0x1e);}' unless defined(&MPI2_FUNCTION_DIAG_RELEASE);
    eval 'sub MPI2_FUNCTION_TARGET_CMD_BUF_BASE_POST () {(0x24);}' unless defined(&MPI2_FUNCTION_TARGET_CMD_BUF_BASE_POST);
    eval 'sub MPI2_FUNCTION_TARGET_CMD_BUF_LIST_POST () {(0x25);}' unless defined(&MPI2_FUNCTION_TARGET_CMD_BUF_LIST_POST);
    eval 'sub MPI2_FUNCTION_RAID_ACCELERATOR () {(0x2c);}' unless defined(&MPI2_FUNCTION_RAID_ACCELERATOR);
    eval 'sub MPI2_FUNCTION_HOST_BASED_DISCOVERY_ACTION () {(0x2f);}' unless defined(&MPI2_FUNCTION_HOST_BASED_DISCOVERY_ACTION);
    eval 'sub MPI2_FUNCTION_PWR_MGMT_CONTROL () {(0x30);}' unless defined(&MPI2_FUNCTION_PWR_MGMT_CONTROL);
    eval 'sub MPI2_FUNCTION_MIN_PRODUCT_SPECIFIC () {(0xf0);}' unless defined(&MPI2_FUNCTION_MIN_PRODUCT_SPECIFIC);
    eval 'sub MPI2_FUNCTION_MAX_PRODUCT_SPECIFIC () {(0xff);}' unless defined(&MPI2_FUNCTION_MAX_PRODUCT_SPECIFIC);
    eval 'sub MPI2_FUNCTION_IOC_MESSAGE_UNIT_RESET () {(0x40);}' unless defined(&MPI2_FUNCTION_IOC_MESSAGE_UNIT_RESET);
    eval 'sub MPI2_FUNCTION_HANDSHAKE () {(0x42);}' unless defined(&MPI2_FUNCTION_HANDSHAKE);
    eval 'sub MPI2_VERSION_MAJOR () {(0x2);}' unless defined(&MPI2_VERSION_MAJOR);
    eval 'sub MPI2_VERSION_MINOR () {(0x);}' unless defined(&MPI2_VERSION_MINOR);
    eval 'sub MPI2_VERSION_MAJOR_MASK () {(0xff00);}' unless defined(&MPI2_VERSION_MAJOR_MASK);
    eval 'sub MPI2_VERSION_MAJOR_SHIFT () {(8);}' unless defined(&MPI2_VERSION_MAJOR_SHIFT);
    eval 'sub MPI2_VERSION_MINOR_MASK () {(0xff);}' unless defined(&MPI2_VERSION_MINOR_MASK);
    eval 'sub MPI2_VERSION_MINOR_SHIFT () {(0);}' unless defined(&MPI2_VERSION_MINOR_SHIFT);
    eval 'sub MPI2_VERSION () {(( &MPI2_VERSION_MAJOR <<  &MPI2_VERSION_MAJOR_SHIFT) |  &MPI2_VERSION_MINOR);}' unless defined(&MPI2_VERSION);
    eval 'sub MPI2_VERSION_02_00 () {(0x200);}' unless defined(&MPI2_VERSION_02_00);
    eval 'sub MPI2_HEADER_VERSION_UNIT () {(0x10);}' unless defined(&MPI2_HEADER_VERSION_UNIT);
    eval 'sub MPI2_HEADER_VERSION_DEV () {(0x);}' unless defined(&MPI2_HEADER_VERSION_DEV);
    eval 'sub MPI2_HEADER_VERSION_UNIT_MASK () {(0xff00);}' unless defined(&MPI2_HEADER_VERSION_UNIT_MASK);
    eval 'sub MPI2_HEADER_VERSION_UNIT_SHIFT () {(8);}' unless defined(&MPI2_HEADER_VERSION_UNIT_SHIFT);
    eval 'sub MPI2_HEADER_VERSION_DEV_MASK () {(0xff);}' unless defined(&MPI2_HEADER_VERSION_DEV_MASK);
    eval 'sub MPI2_HEADER_VERSION_DEV_SHIFT () {(0);}' unless defined(&MPI2_HEADER_VERSION_DEV_SHIFT);
    eval 'sub MPI2_HEADER_VERSION () {(( &MPI2_HEADER_VERSION_UNIT << 8) |  &MPI2_HEADER_VERSION_DEV);}' unless defined(&MPI2_HEADER_VERSION);
    eval 'sub MPI2_WHOINIT_NOT_INITIALIZED () {(0x);}' unless defined(&MPI2_WHOINIT_NOT_INITIALIZED);
    eval 'sub MPI2_WHOINIT_SYSTEM_BIOS () {(0x1);}' unless defined(&MPI2_WHOINIT_SYSTEM_BIOS);
    eval 'sub MPI2_WHOINIT_ROM_BIOS () {(0x2);}' unless defined(&MPI2_WHOINIT_ROM_BIOS);
    eval 'sub MPI2_WHOINIT_PCI_PEER () {(0x3);}' unless defined(&MPI2_WHOINIT_PCI_PEER);
    eval 'sub MPI2_WHOINIT_HOST_DRIVER () {(0x4);}' unless defined(&MPI2_WHOINIT_HOST_DRIVER);
    eval 'sub MPI2_WHOINIT_MANUFACTURER () {(0x5);}' unless defined(&MPI2_WHOINIT_MANUFACTURER);
    eval 'sub MPI2_IEEE_SGE_FLAGS_ELEMENT_TYPE_MASK () {(0x80);}' unless defined(&MPI2_IEEE_SGE_FLAGS_ELEMENT_TYPE_MASK);
    eval 'sub MPI2_IEEE32_SGE_FLAGS_SHIFT () {(24);}' unless defined(&MPI2_IEEE32_SGE_FLAGS_SHIFT);
    eval 'sub MPI2_IEEE32_SGE_LENGTH_MASK () {(0xffffff);}' unless defined(&MPI2_IEEE32_SGE_LENGTH_MASK);
    eval 'sub MPI2_IEEE_SGE_FLAGS_SIMPLE_ELEMENT () {(0x);}' unless defined(&MPI2_IEEE_SGE_FLAGS_SIMPLE_ELEMENT);
    eval 'sub MPI2_IEEE_SGE_FLAGS_CHAIN_ELEMENT () {(0x80);}' unless defined(&MPI2_IEEE_SGE_FLAGS_CHAIN_ELEMENT);
    eval 'sub MPI2_IEEE_SGE_FLAGS_ADDR_MASK () {(0x3);}' unless defined(&MPI2_IEEE_SGE_FLAGS_ADDR_MASK);
    eval 'sub MPI2_IEEE_SGE_FLAGS_SYSTEM_ADDR () {(0x);}' unless defined(&MPI2_IEEE_SGE_FLAGS_SYSTEM_ADDR);
    eval 'sub MPI2_IEEE_SGE_FLAGS_IOCDDR_ADDR () {(0x1);}' unless defined(&MPI2_IEEE_SGE_FLAGS_IOCDDR_ADDR);
    eval 'sub MPI2_IEEE_SGE_FLAGS_IOCPLB_ADDR () {(0x2);}' unless defined(&MPI2_IEEE_SGE_FLAGS_IOCPLB_ADDR);
    eval 'sub MPI2_IEEE_SGE_FLAGS_IOCPLBNTA_ADDR () {(0x3);}' unless defined(&MPI2_IEEE_SGE_FLAGS_IOCPLBNTA_ADDR);
    eval 'sub MPI2_SGE_FLAGS_32_BIT_ADDRESSING () {(0x);}' unless defined(&MPI2_SGE_FLAGS_32_BIT_ADDRESSING);
    eval 'sub MPI2_SGE_FLAGS_64_BIT_ADDRESSING () {(0x2);}' unless defined(&MPI2_SGE_FLAGS_64_BIT_ADDRESSING);
    eval 'sub MPI2_SCSIIO_CONTROL_ADDCDBLEN_MASK () {(0xfc000000);}' unless defined(&MPI2_SCSIIO_CONTROL_ADDCDBLEN_MASK);
    eval 'sub MPI2_SCSIIO_CONTROL_ADDCDBLEN_SHIFT () {(26);}' unless defined(&MPI2_SCSIIO_CONTROL_ADDCDBLEN_SHIFT);
    eval 'sub MPI2_SCSIIO_CONTROL_DATADIRECTION_MASK () {(0x3000000);}' unless defined(&MPI2_SCSIIO_CONTROL_DATADIRECTION_MASK);
    eval 'sub MPI2_SCSIIO_CONTROL_NODATATRANSFER () {(0x);}' unless defined(&MPI2_SCSIIO_CONTROL_NODATATRANSFER);
    eval 'sub MPI2_SCSIIO_CONTROL_WRITE () {(0x1000000);}' unless defined(&MPI2_SCSIIO_CONTROL_WRITE);
    eval 'sub MPI2_SCSIIO_CONTROL_READ () {(0x2000000);}' unless defined(&MPI2_SCSIIO_CONTROL_READ);
    eval 'sub MPI2_SCSIIO_CONTROL_BIDIRECTIONAL () {(0x3000000);}' unless defined(&MPI2_SCSIIO_CONTROL_BIDIRECTIONAL);
    eval 'sub MPI2_SCSIIO_CONTROL_TASKPRI_MASK () {(0x7800);}' unless defined(&MPI2_SCSIIO_CONTROL_TASKPRI_MASK);
    eval 'sub MPI2_SCSIIO_CONTROL_TASKPRI_SHIFT () {(11);}' unless defined(&MPI2_SCSIIO_CONTROL_TASKPRI_SHIFT);
    eval 'sub MPI2_SCSIIO_CONTROL_TASKATTRIBUTE_MASK () {(0x700);}' unless defined(&MPI2_SCSIIO_CONTROL_TASKATTRIBUTE_MASK);
    eval 'sub MPI2_SCSIIO_CONTROL_SIMPLEQ () {(0x);}' unless defined(&MPI2_SCSIIO_CONTROL_SIMPLEQ);
    eval 'sub MPI2_SCSIIO_CONTROL_HEADOFQ () {(0x100);}' unless defined(&MPI2_SCSIIO_CONTROL_HEADOFQ);
    eval 'sub MPI2_SCSIIO_CONTROL_ORDEREDQ () {(0x200);}' unless defined(&MPI2_SCSIIO_CONTROL_ORDEREDQ);
    eval 'sub MPI2_SCSIIO_CONTROL_ACAQ () {(0x400);}' unless defined(&MPI2_SCSIIO_CONTROL_ACAQ);
    eval 'sub MPI2_SCSIIO_CONTROL_TLR_MASK () {(0xc0);}' unless defined(&MPI2_SCSIIO_CONTROL_TLR_MASK);
    eval 'sub MPI2_SCSIIO_CONTROL_NO_TLR () {(0x);}' unless defined(&MPI2_SCSIIO_CONTROL_NO_TLR);
    eval 'sub MPI2_SCSIIO_CONTROL_TLR_ON () {(0x40);}' unless defined(&MPI2_SCSIIO_CONTROL_TLR_ON);
    eval 'sub MPI2_SCSIIO_CONTROL_TLR_OFF () {(0x80);}' unless defined(&MPI2_SCSIIO_CONTROL_TLR_OFF);
    eval 'sub MPI25_IEEE_SGE_FLAGS_END_OF_LIST () {(0x40);}' unless defined(&MPI25_IEEE_SGE_FLAGS_END_OF_LIST);
    eval 'sub MPI2_REQ_DESCRIPT_FLAGS_TYPE_MASK () {(0xe);}' unless defined(&MPI2_REQ_DESCRIPT_FLAGS_TYPE_MASK);
    eval 'sub MPI2_REQ_DESCRIPT_FLAGS_SCSI_IO () {(0x);}' unless defined(&MPI2_REQ_DESCRIPT_FLAGS_SCSI_IO);
    eval 'sub MPI2_REQ_DESCRIPT_FLAGS_SCSI_TARGET () {(0x2);}' unless defined(&MPI2_REQ_DESCRIPT_FLAGS_SCSI_TARGET);
    eval 'sub MPI2_REQ_DESCRIPT_FLAGS_HIGH_PRIORITY () {(0x6);}' unless defined(&MPI2_REQ_DESCRIPT_FLAGS_HIGH_PRIORITY);
    eval 'sub MPI2_REQ_DESCRIPT_FLAGS_DEFAULT_TYPE () {(0x8);}' unless defined(&MPI2_REQ_DESCRIPT_FLAGS_DEFAULT_TYPE);
    eval 'sub MPI2_REQ_DESCRIPT_FLAGS_RAID_ACCELERATOR () {(0xa);}' unless defined(&MPI2_REQ_DESCRIPT_FLAGS_RAID_ACCELERATOR);
    eval 'sub MPI2_REQ_DESCRIPT_FLAGS_IOC_FIFO_MARKER () {(0x1);}' unless defined(&MPI2_REQ_DESCRIPT_FLAGS_IOC_FIFO_MARKER);
    eval 'sub MPI2_RPY_DESCRIPT_FLAGS_TYPE_MASK () {(0xf);}' unless defined(&MPI2_RPY_DESCRIPT_FLAGS_TYPE_MASK);
    eval 'sub MPI2_RPY_DESCRIPT_FLAGS_SCSI_IO_SUCCESS () {(0x);}' unless defined(&MPI2_RPY_DESCRIPT_FLAGS_SCSI_IO_SUCCESS);
    eval 'sub MPI2_RPY_DESCRIPT_FLAGS_ADDRESS_REPLY () {(0x1);}' unless defined(&MPI2_RPY_DESCRIPT_FLAGS_ADDRESS_REPLY);
    eval 'sub MPI2_RPY_DESCRIPT_FLAGS_TARGETASSIST_SUCCESS () {(0x2);}' unless defined(&MPI2_RPY_DESCRIPT_FLAGS_TARGETASSIST_SUCCESS);
    eval 'sub MPI2_RPY_DESCRIPT_FLAGS_TARGET_COMMAND_BUFFER () {(0x3);}' unless defined(&MPI2_RPY_DESCRIPT_FLAGS_TARGET_COMMAND_BUFFER);
    eval 'sub MPI2_RPY_DESCRIPT_FLAGS_RAID_ACCELERATOR_SUCCESS () {(0x5);}' unless defined(&MPI2_RPY_DESCRIPT_FLAGS_RAID_ACCELERATOR_SUCCESS);
    eval 'sub MPI2_RPY_DESCRIPT_FLAGS_UNUSED () {(0xf);}' unless defined(&MPI2_RPY_DESCRIPT_FLAGS_UNUSED);
    eval 'sub MPI2_RPY_DESCRIPT_UNUSED_WORD0_MARK () {(0xffffffff);}' unless defined(&MPI2_RPY_DESCRIPT_UNUSED_WORD0_MARK);
    eval 'sub MPI2_RPY_DESCRIPT_UNUSED_WORD1_MARK () {(0xffffffff);}' unless defined(&MPI2_RPY_DESCRIPT_UNUSED_WORD1_MARK);
    eval 'sub MFI_SCSI_MAX_TARGETS () {128;}' unless defined(&MFI_SCSI_MAX_TARGETS);
    eval 'sub MFI_SCSI_MAX_LUNS () {8;}' unless defined(&MFI_SCSI_MAX_LUNS);
    eval 'sub MFI_SCSI_INITIATOR_ID () {255;}' unless defined(&MFI_SCSI_INITIATOR_ID);
    eval 'sub MFI_SCSI_MAX_CMDS () {8;}' unless defined(&MFI_SCSI_MAX_CMDS);
    eval 'sub MFI_SCSI_MAX_CDB_LEN () {16;}' unless defined(&MFI_SCSI_MAX_CDB_LEN);
}
1;
