require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MPI_INIT_H)) {
    eval 'sub MPI_INIT_H () {1;}' unless defined(&MPI_INIT_H);
    eval 'sub MPI_SCSIIO_MSGFLGS_SENSE_WIDTH () {(0x1);}' unless defined(&MPI_SCSIIO_MSGFLGS_SENSE_WIDTH);
    eval 'sub MPI_SCSIIO_MSGFLGS_SENSE_WIDTH_32 () {(0x);}' unless defined(&MPI_SCSIIO_MSGFLGS_SENSE_WIDTH_32);
    eval 'sub MPI_SCSIIO_MSGFLGS_SENSE_WIDTH_64 () {(0x1);}' unless defined(&MPI_SCSIIO_MSGFLGS_SENSE_WIDTH_64);
    eval 'sub MPI_SCSIIO_MSGFLGS_SENSE_LOCATION () {(0x2);}' unless defined(&MPI_SCSIIO_MSGFLGS_SENSE_LOCATION);
    eval 'sub MPI_SCSIIO_MSGFLGS_SENSE_LOC_HOST () {(0x);}' unless defined(&MPI_SCSIIO_MSGFLGS_SENSE_LOC_HOST);
    eval 'sub MPI_SCSIIO_MSGFLGS_SENSE_LOC_IOC () {(0x2);}' unless defined(&MPI_SCSIIO_MSGFLGS_SENSE_LOC_IOC);
    eval 'sub MPI_SCSIIO_MSGFLGS_CMD_DETERMINES_DATA_DIR () {(0x4);}' unless defined(&MPI_SCSIIO_MSGFLGS_CMD_DETERMINES_DATA_DIR);
    eval 'sub MPI_SCSIIO_LUN_FIRST_LEVEL_ADDRESSING () {(0xffff);}' unless defined(&MPI_SCSIIO_LUN_FIRST_LEVEL_ADDRESSING);
    eval 'sub MPI_SCSIIO_LUN_SECOND_LEVEL_ADDRESSING () {(0xffff0000);}' unless defined(&MPI_SCSIIO_LUN_SECOND_LEVEL_ADDRESSING);
    eval 'sub MPI_SCSIIO_LUN_THIRD_LEVEL_ADDRESSING () {(0xffff);}' unless defined(&MPI_SCSIIO_LUN_THIRD_LEVEL_ADDRESSING);
    eval 'sub MPI_SCSIIO_LUN_FOURTH_LEVEL_ADDRESSING () {(0xffff0000);}' unless defined(&MPI_SCSIIO_LUN_FOURTH_LEVEL_ADDRESSING);
    eval 'sub MPI_SCSIIO_LUN_LEVEL_1_WORD () {(0xff00);}' unless defined(&MPI_SCSIIO_LUN_LEVEL_1_WORD);
    eval 'sub MPI_SCSIIO_LUN_LEVEL_1_DWORD () {(0xff00);}' unless defined(&MPI_SCSIIO_LUN_LEVEL_1_DWORD);
    eval 'sub MPI_SCSIIO_CONTROL_DATADIRECTION_MASK () {(0x3000000);}' unless defined(&MPI_SCSIIO_CONTROL_DATADIRECTION_MASK);
    eval 'sub MPI_SCSIIO_CONTROL_NODATATRANSFER () {(0x);}' unless defined(&MPI_SCSIIO_CONTROL_NODATATRANSFER);
    eval 'sub MPI_SCSIIO_CONTROL_WRITE () {(0x1000000);}' unless defined(&MPI_SCSIIO_CONTROL_WRITE);
    eval 'sub MPI_SCSIIO_CONTROL_READ () {(0x2000000);}' unless defined(&MPI_SCSIIO_CONTROL_READ);
    eval 'sub MPI_SCSIIO_CONTROL_ADDCDBLEN_MASK () {(0x3c000000);}' unless defined(&MPI_SCSIIO_CONTROL_ADDCDBLEN_MASK);
    eval 'sub MPI_SCSIIO_CONTROL_ADDCDBLEN_SHIFT () {(26);}' unless defined(&MPI_SCSIIO_CONTROL_ADDCDBLEN_SHIFT);
    eval 'sub MPI_SCSIIO_CONTROL_TASKATTRIBUTE_MASK () {(0x700);}' unless defined(&MPI_SCSIIO_CONTROL_TASKATTRIBUTE_MASK);
    eval 'sub MPI_SCSIIO_CONTROL_SIMPLEQ () {(0x);}' unless defined(&MPI_SCSIIO_CONTROL_SIMPLEQ);
    eval 'sub MPI_SCSIIO_CONTROL_HEADOFQ () {(0x100);}' unless defined(&MPI_SCSIIO_CONTROL_HEADOFQ);
    eval 'sub MPI_SCSIIO_CONTROL_ORDEREDQ () {(0x200);}' unless defined(&MPI_SCSIIO_CONTROL_ORDEREDQ);
    eval 'sub MPI_SCSIIO_CONTROL_ACAQ () {(0x400);}' unless defined(&MPI_SCSIIO_CONTROL_ACAQ);
    eval 'sub MPI_SCSIIO_CONTROL_UNTAGGED () {(0x500);}' unless defined(&MPI_SCSIIO_CONTROL_UNTAGGED);
    eval 'sub MPI_SCSIIO_CONTROL_NO_DISCONNECT () {(0x700);}' unless defined(&MPI_SCSIIO_CONTROL_NO_DISCONNECT);
    eval 'sub MPI_SCSIIO_CONTROL_TASKMANAGE_MASK () {(0xff0000);}' unless defined(&MPI_SCSIIO_CONTROL_TASKMANAGE_MASK);
    eval 'sub MPI_SCSIIO_CONTROL_OBSOLETE () {(0x800000);}' unless defined(&MPI_SCSIIO_CONTROL_OBSOLETE);
    eval 'sub MPI_SCSIIO_CONTROL_CLEAR_ACA_RSV () {(0x400000);}' unless defined(&MPI_SCSIIO_CONTROL_CLEAR_ACA_RSV);
    eval 'sub MPI_SCSIIO_CONTROL_TARGET_RESET () {(0x200000);}' unless defined(&MPI_SCSIIO_CONTROL_TARGET_RESET);
    eval 'sub MPI_SCSIIO_CONTROL_LUN_RESET_RSV () {(0x100000);}' unless defined(&MPI_SCSIIO_CONTROL_LUN_RESET_RSV);
    eval 'sub MPI_SCSIIO_CONTROL_RESERVED () {(0x80000);}' unless defined(&MPI_SCSIIO_CONTROL_RESERVED);
    eval 'sub MPI_SCSIIO_CONTROL_CLR_TASK_SET_RSV () {(0x40000);}' unless defined(&MPI_SCSIIO_CONTROL_CLR_TASK_SET_RSV);
    eval 'sub MPI_SCSIIO_CONTROL_ABORT_TASK_SET () {(0x20000);}' unless defined(&MPI_SCSIIO_CONTROL_ABORT_TASK_SET);
    eval 'sub MPI_SCSIIO_CONTROL_RESERVED2 () {(0x10000);}' unless defined(&MPI_SCSIIO_CONTROL_RESERVED2);
    eval 'sub MPI_SCSI_STATUS_SUCCESS () {(0x);}' unless defined(&MPI_SCSI_STATUS_SUCCESS);
    eval 'sub MPI_SCSI_STATUS_CHECK_CONDITION () {(0x2);}' unless defined(&MPI_SCSI_STATUS_CHECK_CONDITION);
    eval 'sub MPI_SCSI_STATUS_CONDITION_MET () {(0x4);}' unless defined(&MPI_SCSI_STATUS_CONDITION_MET);
    eval 'sub MPI_SCSI_STATUS_BUSY () {(0x8);}' unless defined(&MPI_SCSI_STATUS_BUSY);
    eval 'sub MPI_SCSI_STATUS_INTERMEDIATE () {(0x10);}' unless defined(&MPI_SCSI_STATUS_INTERMEDIATE);
    eval 'sub MPI_SCSI_STATUS_INTERMEDIATE_CONDMET () {(0x14);}' unless defined(&MPI_SCSI_STATUS_INTERMEDIATE_CONDMET);
    eval 'sub MPI_SCSI_STATUS_RESERVATION_CONFLICT () {(0x18);}' unless defined(&MPI_SCSI_STATUS_RESERVATION_CONFLICT);
    eval 'sub MPI_SCSI_STATUS_COMMAND_TERMINATED () {(0x22);}' unless defined(&MPI_SCSI_STATUS_COMMAND_TERMINATED);
    eval 'sub MPI_SCSI_STATUS_TASK_SET_FULL () {(0x28);}' unless defined(&MPI_SCSI_STATUS_TASK_SET_FULL);
    eval 'sub MPI_SCSI_STATUS_ACA_ACTIVE () {(0x30);}' unless defined(&MPI_SCSI_STATUS_ACA_ACTIVE);
    eval 'sub MPI_SCSI_STATUS_FCPEXT_DEVICE_LOGGED_OUT () {(0x80);}' unless defined(&MPI_SCSI_STATUS_FCPEXT_DEVICE_LOGGED_OUT);
    eval 'sub MPI_SCSI_STATUS_FCPEXT_NO_LINK () {(0x81);}' unless defined(&MPI_SCSI_STATUS_FCPEXT_NO_LINK);
    eval 'sub MPI_SCSI_STATUS_FCPEXT_UNASSIGNED () {(0x82);}' unless defined(&MPI_SCSI_STATUS_FCPEXT_UNASSIGNED);
    eval 'sub MPI_SCSI_STATE_AUTOSENSE_VALID () {(0x1);}' unless defined(&MPI_SCSI_STATE_AUTOSENSE_VALID);
    eval 'sub MPI_SCSI_STATE_AUTOSENSE_FAILED () {(0x2);}' unless defined(&MPI_SCSI_STATE_AUTOSENSE_FAILED);
    eval 'sub MPI_SCSI_STATE_NO_SCSI_STATUS () {(0x4);}' unless defined(&MPI_SCSI_STATE_NO_SCSI_STATUS);
    eval 'sub MPI_SCSI_STATE_TERMINATED () {(0x8);}' unless defined(&MPI_SCSI_STATE_TERMINATED);
    eval 'sub MPI_SCSI_STATE_RESPONSE_INFO_VALID () {(0x10);}' unless defined(&MPI_SCSI_STATE_RESPONSE_INFO_VALID);
    eval 'sub MPI_SCSI_STATE_QUEUE_TAG_REJECTED () {(0x20);}' unless defined(&MPI_SCSI_STATE_QUEUE_TAG_REJECTED);
    eval 'sub MPI_SCSI_RSP_INFO_FUNCTION_COMPLETE () {(0x);}' unless defined(&MPI_SCSI_RSP_INFO_FUNCTION_COMPLETE);
    eval 'sub MPI_SCSI_RSP_INFO_FCP_BURST_LEN_ERROR () {(0x1000000);}' unless defined(&MPI_SCSI_RSP_INFO_FCP_BURST_LEN_ERROR);
    eval 'sub MPI_SCSI_RSP_INFO_CMND_FIELDS_INVALID () {(0x2000000);}' unless defined(&MPI_SCSI_RSP_INFO_CMND_FIELDS_INVALID);
    eval 'sub MPI_SCSI_RSP_INFO_FCP_DATA_RO_ERROR () {(0x3000000);}' unless defined(&MPI_SCSI_RSP_INFO_FCP_DATA_RO_ERROR);
    eval 'sub MPI_SCSI_RSP_INFO_TASK_MGMT_UNSUPPORTED () {(0x4000000);}' unless defined(&MPI_SCSI_RSP_INFO_TASK_MGMT_UNSUPPORTED);
    eval 'sub MPI_SCSI_RSP_INFO_TASK_MGMT_FAILED () {(0x5000000);}' unless defined(&MPI_SCSI_RSP_INFO_TASK_MGMT_FAILED);
    eval 'sub MPI_SCSI_RSP_INFO_SPI_LQ_INVALID_TYPE () {(0x6000000);}' unless defined(&MPI_SCSI_RSP_INFO_SPI_LQ_INVALID_TYPE);
    eval 'sub MPI_SCSI_TASKTAG_UNKNOWN () {(0xffff);}' unless defined(&MPI_SCSI_TASKTAG_UNKNOWN);
    eval 'sub MPI_SCSIIO32_MSGFLGS_SENSE_WIDTH () {(0x1);}' unless defined(&MPI_SCSIIO32_MSGFLGS_SENSE_WIDTH);
    eval 'sub MPI_SCSIIO32_MSGFLGS_32_SENSE_WIDTH () {(0x);}' unless defined(&MPI_SCSIIO32_MSGFLGS_32_SENSE_WIDTH);
    eval 'sub MPI_SCSIIO32_MSGFLGS_64_SENSE_WIDTH () {(0x1);}' unless defined(&MPI_SCSIIO32_MSGFLGS_64_SENSE_WIDTH);
    eval 'sub MPI_SCSIIO32_MSGFLGS_SENSE_LOCATION () {(0x2);}' unless defined(&MPI_SCSIIO32_MSGFLGS_SENSE_LOCATION);
    eval 'sub MPI_SCSIIO32_MSGFLGS_SENSE_LOC_HOST () {(0x);}' unless defined(&MPI_SCSIIO32_MSGFLGS_SENSE_LOC_HOST);
    eval 'sub MPI_SCSIIO32_MSGFLGS_SENSE_LOC_IOC () {(0x2);}' unless defined(&MPI_SCSIIO32_MSGFLGS_SENSE_LOC_IOC);
    eval 'sub MPI_SCSIIO32_MSGFLGS_CMD_DETERMINES_DATA_DIR () {(0x4);}' unless defined(&MPI_SCSIIO32_MSGFLGS_CMD_DETERMINES_DATA_DIR);
    eval 'sub MPI_SCSIIO32_MSGFLGS_SGL_OFFSETS_CHAINS () {(0x8);}' unless defined(&MPI_SCSIIO32_MSGFLGS_SGL_OFFSETS_CHAINS);
    eval 'sub MPI_SCSIIO32_MSGFLGS_MULTICAST () {(0x10);}' unless defined(&MPI_SCSIIO32_MSGFLGS_MULTICAST);
    eval 'sub MPI_SCSIIO32_MSGFLGS_BIDIRECTIONAL () {(0x20);}' unless defined(&MPI_SCSIIO32_MSGFLGS_BIDIRECTIONAL);
    eval 'sub MPI_SCSIIO32_MSGFLGS_LARGE_CDB () {(0x40);}' unless defined(&MPI_SCSIIO32_MSGFLGS_LARGE_CDB);
    eval 'sub MPI_SCSIIO32_FLAGS_FORM_MASK () {(0x3);}' unless defined(&MPI_SCSIIO32_FLAGS_FORM_MASK);
    eval 'sub MPI_SCSIIO32_FLAGS_FORM_SCSIID () {(0x);}' unless defined(&MPI_SCSIIO32_FLAGS_FORM_SCSIID);
    eval 'sub MPI_SCSIIO32_FLAGS_FORM_WWID () {(0x1);}' unless defined(&MPI_SCSIIO32_FLAGS_FORM_WWID);
    eval 'sub MPI_SCSIIO32_LUN_FIRST_LEVEL_ADDRESSING () {(0xffff);}' unless defined(&MPI_SCSIIO32_LUN_FIRST_LEVEL_ADDRESSING);
    eval 'sub MPI_SCSIIO32_LUN_SECOND_LEVEL_ADDRESSING () {(0xffff0000);}' unless defined(&MPI_SCSIIO32_LUN_SECOND_LEVEL_ADDRESSING);
    eval 'sub MPI_SCSIIO32_LUN_THIRD_LEVEL_ADDRESSING () {(0xffff);}' unless defined(&MPI_SCSIIO32_LUN_THIRD_LEVEL_ADDRESSING);
    eval 'sub MPI_SCSIIO32_LUN_FOURTH_LEVEL_ADDRESSING () {(0xffff0000);}' unless defined(&MPI_SCSIIO32_LUN_FOURTH_LEVEL_ADDRESSING);
    eval 'sub MPI_SCSIIO32_LUN_LEVEL_1_WORD () {(0xff00);}' unless defined(&MPI_SCSIIO32_LUN_LEVEL_1_WORD);
    eval 'sub MPI_SCSIIO32_LUN_LEVEL_1_DWORD () {(0xff00);}' unless defined(&MPI_SCSIIO32_LUN_LEVEL_1_DWORD);
    eval 'sub MPI_SCSIIO32_CONTROL_DATADIRECTION_MASK () {(0x3000000);}' unless defined(&MPI_SCSIIO32_CONTROL_DATADIRECTION_MASK);
    eval 'sub MPI_SCSIIO32_CONTROL_NODATATRANSFER () {(0x);}' unless defined(&MPI_SCSIIO32_CONTROL_NODATATRANSFER);
    eval 'sub MPI_SCSIIO32_CONTROL_WRITE () {(0x1000000);}' unless defined(&MPI_SCSIIO32_CONTROL_WRITE);
    eval 'sub MPI_SCSIIO32_CONTROL_READ () {(0x2000000);}' unless defined(&MPI_SCSIIO32_CONTROL_READ);
    eval 'sub MPI_SCSIIO32_CONTROL_BIDIRECTIONAL () {(0x3000000);}' unless defined(&MPI_SCSIIO32_CONTROL_BIDIRECTIONAL);
    eval 'sub MPI_SCSIIO32_CONTROL_ADDCDBLEN_MASK () {(0xfc000000);}' unless defined(&MPI_SCSIIO32_CONTROL_ADDCDBLEN_MASK);
    eval 'sub MPI_SCSIIO32_CONTROL_ADDCDBLEN_SHIFT () {(26);}' unless defined(&MPI_SCSIIO32_CONTROL_ADDCDBLEN_SHIFT);
    eval 'sub MPI_SCSIIO32_CONTROL_TASKATTRIBUTE_MASK () {(0x700);}' unless defined(&MPI_SCSIIO32_CONTROL_TASKATTRIBUTE_MASK);
    eval 'sub MPI_SCSIIO32_CONTROL_SIMPLEQ () {(0x);}' unless defined(&MPI_SCSIIO32_CONTROL_SIMPLEQ);
    eval 'sub MPI_SCSIIO32_CONTROL_HEADOFQ () {(0x100);}' unless defined(&MPI_SCSIIO32_CONTROL_HEADOFQ);
    eval 'sub MPI_SCSIIO32_CONTROL_ORDEREDQ () {(0x200);}' unless defined(&MPI_SCSIIO32_CONTROL_ORDEREDQ);
    eval 'sub MPI_SCSIIO32_CONTROL_ACAQ () {(0x400);}' unless defined(&MPI_SCSIIO32_CONTROL_ACAQ);
    eval 'sub MPI_SCSIIO32_CONTROL_UNTAGGED () {(0x500);}' unless defined(&MPI_SCSIIO32_CONTROL_UNTAGGED);
    eval 'sub MPI_SCSIIO32_CONTROL_NO_DISCONNECT () {(0x700);}' unless defined(&MPI_SCSIIO32_CONTROL_NO_DISCONNECT);
    eval 'sub MPI_SCSIIO32_CONTROL_TASKMANAGE_MASK () {(0xff0000);}' unless defined(&MPI_SCSIIO32_CONTROL_TASKMANAGE_MASK);
    eval 'sub MPI_SCSIIO32_CONTROL_OBSOLETE () {(0x800000);}' unless defined(&MPI_SCSIIO32_CONTROL_OBSOLETE);
    eval 'sub MPI_SCSIIO32_CONTROL_CLEAR_ACA_RSV () {(0x400000);}' unless defined(&MPI_SCSIIO32_CONTROL_CLEAR_ACA_RSV);
    eval 'sub MPI_SCSIIO32_CONTROL_TARGET_RESET () {(0x200000);}' unless defined(&MPI_SCSIIO32_CONTROL_TARGET_RESET);
    eval 'sub MPI_SCSIIO32_CONTROL_LUN_RESET_RSV () {(0x100000);}' unless defined(&MPI_SCSIIO32_CONTROL_LUN_RESET_RSV);
    eval 'sub MPI_SCSIIO32_CONTROL_RESERVED () {(0x80000);}' unless defined(&MPI_SCSIIO32_CONTROL_RESERVED);
    eval 'sub MPI_SCSIIO32_CONTROL_CLR_TASK_SET_RSV () {(0x40000);}' unless defined(&MPI_SCSIIO32_CONTROL_CLR_TASK_SET_RSV);
    eval 'sub MPI_SCSIIO32_CONTROL_ABORT_TASK_SET () {(0x20000);}' unless defined(&MPI_SCSIIO32_CONTROL_ABORT_TASK_SET);
    eval 'sub MPI_SCSIIO32_CONTROL_RESERVED2 () {(0x10000);}' unless defined(&MPI_SCSIIO32_CONTROL_RESERVED2);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_MASK_OP () {(0x7);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_MASK_OP);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_NOOP_OP () {(0x);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_NOOP_OP);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_CHK_OP () {(0x1);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_CHK_OP);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_STRIP_OP () {(0x2);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_STRIP_OP);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_CHKRM_OP () {(0x3);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_CHKRM_OP);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_INSERT_OP () {(0x4);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_INSERT_OP);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_REPLACE_OP () {(0x6);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_REPLACE_OP);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_CHKREGEN_OP () {(0x7);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_CHKREGEN_OP);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_PASS_REF_TAG () {(0x8);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_PASS_REF_TAG);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_8_9THS_MODE () {(0x10);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_8_9THS_MODE);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_T10_CHK_MASK () {(0x700);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_T10_CHK_MASK);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_T10_CHK_GUARD () {(0x100);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_T10_CHK_GUARD);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_T10_CHK_REFTAG () {(0x200);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_T10_CHK_REFTAG);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_T10_CHK_LBATAG () {(0x400);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_T10_CHK_LBATAG);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_T10_CHK_SHIFT () {(8);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_T10_CHK_SHIFT);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_INC_SEC_APPTAG () {(0x1000);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_INC_SEC_APPTAG);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_INC_PRI_APPTAG () {(0x2000);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_INC_PRI_APPTAG);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_INC_SEC_REFTAG () {(0x4000);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_INC_SEC_REFTAG);
    eval 'sub MPI_SCSIIO32_EEDPFLAGS_INC_PRI_REFTAG () {(0x8000);}' unless defined(&MPI_SCSIIO32_EEDPFLAGS_INC_PRI_REFTAG);
    eval 'sub MPI_SCSITASKMGMT_TASKTYPE_ABORT_TASK () {(0x1);}' unless defined(&MPI_SCSITASKMGMT_TASKTYPE_ABORT_TASK);
    eval 'sub MPI_SCSITASKMGMT_TASKTYPE_ABRT_TASK_SET () {(0x2);}' unless defined(&MPI_SCSITASKMGMT_TASKTYPE_ABRT_TASK_SET);
    eval 'sub MPI_SCSITASKMGMT_TASKTYPE_TARGET_RESET () {(0x3);}' unless defined(&MPI_SCSITASKMGMT_TASKTYPE_TARGET_RESET);
    eval 'sub MPI_SCSITASKMGMT_TASKTYPE_RESET_BUS () {(0x4);}' unless defined(&MPI_SCSITASKMGMT_TASKTYPE_RESET_BUS);
    eval 'sub MPI_SCSITASKMGMT_TASKTYPE_LOGICAL_UNIT_RESET () {(0x5);}' unless defined(&MPI_SCSITASKMGMT_TASKTYPE_LOGICAL_UNIT_RESET);
    eval 'sub MPI_SCSITASKMGMT_TASKTYPE_CLEAR_TASK_SET () {(0x6);}' unless defined(&MPI_SCSITASKMGMT_TASKTYPE_CLEAR_TASK_SET);
    eval 'sub MPI_SCSITASKMGMT_TASKTYPE_QUERY_TASK () {(0x7);}' unless defined(&MPI_SCSITASKMGMT_TASKTYPE_QUERY_TASK);
    eval 'sub MPI_SCSITASKMGMT_TASKTYPE_CLR_ACA () {(0x8);}' unless defined(&MPI_SCSITASKMGMT_TASKTYPE_CLR_ACA);
    eval 'sub MPI_SCSITASKMGMT_MSGFLAGS_DO_NOT_SEND_TASK_IU () {(0x1);}' unless defined(&MPI_SCSITASKMGMT_MSGFLAGS_DO_NOT_SEND_TASK_IU);
    eval 'sub MPI_SCSITASKMGMT_MSGFLAGS_TARGET_RESET_OPTION () {(0x);}' unless defined(&MPI_SCSITASKMGMT_MSGFLAGS_TARGET_RESET_OPTION);
    eval 'sub MPI_SCSITASKMGMT_MSGFLAGS_LIP_RESET_OPTION () {(0x2);}' unless defined(&MPI_SCSITASKMGMT_MSGFLAGS_LIP_RESET_OPTION);
    eval 'sub MPI_SCSITASKMGMT_MSGFLAGS_LIPRESET_RESET_OPTION () {(0x4);}' unless defined(&MPI_SCSITASKMGMT_MSGFLAGS_LIPRESET_RESET_OPTION);
    eval 'sub MPI_SCSITASKMGMT_MSGFLAGS_SOFT_RESET_OPTION () {(0x8);}' unless defined(&MPI_SCSITASKMGMT_MSGFLAGS_SOFT_RESET_OPTION);
    eval 'sub MPI_SCSITASKMGMT_RSP_TM_COMPLETE () {(0x);}' unless defined(&MPI_SCSITASKMGMT_RSP_TM_COMPLETE);
    eval 'sub MPI_SCSITASKMGMT_RSP_INVALID_FRAME () {(0x2);}' unless defined(&MPI_SCSITASKMGMT_RSP_INVALID_FRAME);
    eval 'sub MPI_SCSITASKMGMT_RSP_TM_NOT_SUPPORTED () {(0x4);}' unless defined(&MPI_SCSITASKMGMT_RSP_TM_NOT_SUPPORTED);
    eval 'sub MPI_SCSITASKMGMT_RSP_TM_FAILED () {(0x5);}' unless defined(&MPI_SCSITASKMGMT_RSP_TM_FAILED);
    eval 'sub MPI_SCSITASKMGMT_RSP_TM_SUCCEEDED () {(0x8);}' unless defined(&MPI_SCSITASKMGMT_RSP_TM_SUCCEEDED);
    eval 'sub MPI_SCSITASKMGMT_RSP_TM_INVALID_LUN () {(0x9);}' unless defined(&MPI_SCSITASKMGMT_RSP_TM_INVALID_LUN);
    eval 'sub MPI_SCSITASKMGMT_RSP_IO_QUEUED_ON_IOC () {(0x80);}' unless defined(&MPI_SCSITASKMGMT_RSP_IO_QUEUED_ON_IOC);
    eval 'sub MPI_SEP_REQ_ACTION_WRITE_STATUS () {(0x);}' unless defined(&MPI_SEP_REQ_ACTION_WRITE_STATUS);
    eval 'sub MPI_SEP_REQ_ACTION_READ_STATUS () {(0x1);}' unless defined(&MPI_SEP_REQ_ACTION_READ_STATUS);
    eval 'sub MPI_SEP_REQ_FLAGS_ENCLOSURE_SLOT_ADDRESS () {(0x1);}' unless defined(&MPI_SEP_REQ_FLAGS_ENCLOSURE_SLOT_ADDRESS);
    eval 'sub MPI_SEP_REQ_FLAGS_BUS_TARGETID_ADDRESS () {(0x);}' unless defined(&MPI_SEP_REQ_FLAGS_BUS_TARGETID_ADDRESS);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_NO_ERROR () {(0x1);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_NO_ERROR);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_DEV_FAULTY () {(0x2);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_DEV_FAULTY);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_DEV_REBUILDING () {(0x4);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_DEV_REBUILDING);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_IN_FAILED_ARRAY () {(0x8);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_IN_FAILED_ARRAY);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_IN_CRITICAL_ARRAY () {(0x10);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_IN_CRITICAL_ARRAY);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_PARITY_CHECK () {(0x20);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_PARITY_CHECK);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_PREDICTED_FAULT () {(0x40);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_PREDICTED_FAULT);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_UNCONFIGURED () {(0x80);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_UNCONFIGURED);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_HOT_SPARE () {(0x100);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_HOT_SPARE);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_REBUILD_STOPPED () {(0x200);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_REBUILD_STOPPED);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_REQ_CONSISTENCY_CHECK () {(0x1000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_REQ_CONSISTENCY_CHECK);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_DISABLE () {(0x2000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_DISABLE);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_REQ_RESERVED_DEVICE () {(0x4000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_REQ_RESERVED_DEVICE);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_IDENTIFY_REQUEST () {(0x20000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_IDENTIFY_REQUEST);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_REQUEST_REMOVE () {(0x40000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_REQUEST_REMOVE);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_REQUEST_INSERT () {(0x80000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_REQUEST_INSERT);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_DO_NOT_MOVE () {(0x400000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_DO_NOT_MOVE);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_ACTIVE () {(0x800000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_ACTIVE);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_B_ENABLE_BYPASS () {(0x4000000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_B_ENABLE_BYPASS);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_A_ENABLE_BYPASS () {(0x8000000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_A_ENABLE_BYPASS);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_DEV_OFF () {(0x10000000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_DEV_OFF);
    eval 'sub MPI_SEP_REQ_SLOTSTATUS_SWAP_RESET () {(0x80000000);}' unless defined(&MPI_SEP_REQ_SLOTSTATUS_SWAP_RESET);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_NO_ERROR () {(0x1);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_NO_ERROR);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_DEV_FAULTY () {(0x2);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_DEV_FAULTY);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_DEV_REBUILDING () {(0x4);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_DEV_REBUILDING);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_IN_FAILED_ARRAY () {(0x8);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_IN_FAILED_ARRAY);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_IN_CRITICAL_ARRAY () {(0x10);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_IN_CRITICAL_ARRAY);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_PARITY_CHECK () {(0x20);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_PARITY_CHECK);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_PREDICTED_FAULT () {(0x40);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_PREDICTED_FAULT);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_UNCONFIGURED () {(0x80);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_UNCONFIGURED);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_HOT_SPARE () {(0x100);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_HOT_SPARE);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_REBUILD_STOPPED () {(0x200);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_REBUILD_STOPPED);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_CONSISTENCY_CHECK () {(0x1000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_CONSISTENCY_CHECK);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_DISABLE () {(0x2000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_DISABLE);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_RESERVED_DEVICE () {(0x4000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_RESERVED_DEVICE);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_REPORT () {(0x10000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_REPORT);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_IDENTIFY_REQUEST () {(0x20000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_IDENTIFY_REQUEST);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_REMOVE_READY () {(0x40000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_REMOVE_READY);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_INSERT_READY () {(0x80000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_INSERT_READY);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_DO_NOT_REMOVE () {(0x400000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_DO_NOT_REMOVE);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_ACTIVE () {(0x800000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_ACTIVE);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_B_BYPASS_ENABLED () {(0x1000000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_B_BYPASS_ENABLED);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_A_BYPASS_ENABLED () {(0x2000000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_A_BYPASS_ENABLED);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_B_ENABLE_BYPASS () {(0x4000000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_B_ENABLE_BYPASS);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_A_ENABLE_BYPASS () {(0x8000000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_A_ENABLE_BYPASS);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_DEV_OFF () {(0x10000000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_DEV_OFF);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_FAULT_SENSED () {(0x40000000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_FAULT_SENSED);
    eval 'sub MPI_SEP_REPLY_SLOTSTATUS_SWAPPED () {(0x80000000);}' unless defined(&MPI_SEP_REPLY_SLOTSTATUS_SWAPPED);
}
1;
