require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MPI_IOC_H)) {
    eval 'sub MPI_IOC_H () {1;}' unless defined(&MPI_IOC_H);
    eval 'sub MPI_WHOINIT_NO_ONE () {(0x);}' unless defined(&MPI_WHOINIT_NO_ONE);
    eval 'sub MPI_WHOINIT_SYSTEM_BIOS () {(0x1);}' unless defined(&MPI_WHOINIT_SYSTEM_BIOS);
    eval 'sub MPI_WHOINIT_ROM_BIOS () {(0x2);}' unless defined(&MPI_WHOINIT_ROM_BIOS);
    eval 'sub MPI_WHOINIT_PCI_PEER () {(0x3);}' unless defined(&MPI_WHOINIT_PCI_PEER);
    eval 'sub MPI_WHOINIT_HOST_DRIVER () {(0x4);}' unless defined(&MPI_WHOINIT_HOST_DRIVER);
    eval 'sub MPI_WHOINIT_MANUFACTURER () {(0x5);}' unless defined(&MPI_WHOINIT_MANUFACTURER);
    eval 'sub MPI_IOCINIT_FLAGS_HOST_PAGE_BUFFER_PERSISTENT () {(0x4);}' unless defined(&MPI_IOCINIT_FLAGS_HOST_PAGE_BUFFER_PERSISTENT);
    eval 'sub MPI_IOCINIT_FLAGS_REPLY_FIFO_HOST_SIGNAL () {(0x2);}' unless defined(&MPI_IOCINIT_FLAGS_REPLY_FIFO_HOST_SIGNAL);
    eval 'sub MPI_IOCINIT_FLAGS_DISCARD_FW_IMAGE () {(0x1);}' unless defined(&MPI_IOCINIT_FLAGS_DISCARD_FW_IMAGE);
    eval 'sub MPI_IOCINIT_MSGVERSION_MAJOR_MASK () {(0xff00);}' unless defined(&MPI_IOCINIT_MSGVERSION_MAJOR_MASK);
    eval 'sub MPI_IOCINIT_MSGVERSION_MAJOR_SHIFT () {(8);}' unless defined(&MPI_IOCINIT_MSGVERSION_MAJOR_SHIFT);
    eval 'sub MPI_IOCINIT_MSGVERSION_MINOR_MASK () {(0xff);}' unless defined(&MPI_IOCINIT_MSGVERSION_MINOR_MASK);
    eval 'sub MPI_IOCINIT_MSGVERSION_MINOR_SHIFT () {(0);}' unless defined(&MPI_IOCINIT_MSGVERSION_MINOR_SHIFT);
    eval 'sub MPI_IOCINIT_HEADERVERSION_UNIT_MASK () {(0xff00);}' unless defined(&MPI_IOCINIT_HEADERVERSION_UNIT_MASK);
    eval 'sub MPI_IOCINIT_HEADERVERSION_UNIT_SHIFT () {(8);}' unless defined(&MPI_IOCINIT_HEADERVERSION_UNIT_SHIFT);
    eval 'sub MPI_IOCINIT_HEADERVERSION_DEV_MASK () {(0xff);}' unless defined(&MPI_IOCINIT_HEADERVERSION_DEV_MASK);
    eval 'sub MPI_IOCINIT_HEADERVERSION_DEV_SHIFT () {(0);}' unless defined(&MPI_IOCINIT_HEADERVERSION_DEV_SHIFT);
    eval 'sub MPI_IOCFACTS_MSGVERSION_MAJOR_MASK () {(0xff00);}' unless defined(&MPI_IOCFACTS_MSGVERSION_MAJOR_MASK);
    eval 'sub MPI_IOCFACTS_MSGVERSION_MAJOR_SHIFT () {(8);}' unless defined(&MPI_IOCFACTS_MSGVERSION_MAJOR_SHIFT);
    eval 'sub MPI_IOCFACTS_MSGVERSION_MINOR_MASK () {(0xff);}' unless defined(&MPI_IOCFACTS_MSGVERSION_MINOR_MASK);
    eval 'sub MPI_IOCFACTS_MSGVERSION_MINOR_SHIFT () {(0);}' unless defined(&MPI_IOCFACTS_MSGVERSION_MINOR_SHIFT);
    eval 'sub MPI_IOCFACTS_HDRVERSION_UNIT_MASK () {(0xff00);}' unless defined(&MPI_IOCFACTS_HDRVERSION_UNIT_MASK);
    eval 'sub MPI_IOCFACTS_HDRVERSION_UNIT_SHIFT () {(8);}' unless defined(&MPI_IOCFACTS_HDRVERSION_UNIT_SHIFT);
    eval 'sub MPI_IOCFACTS_HDRVERSION_DEV_MASK () {(0xff);}' unless defined(&MPI_IOCFACTS_HDRVERSION_DEV_MASK);
    eval 'sub MPI_IOCFACTS_HDRVERSION_DEV_SHIFT () {(0);}' unless defined(&MPI_IOCFACTS_HDRVERSION_DEV_SHIFT);
    eval 'sub MPI_IOCFACTS_EXCEPT_CONFIG_CHECKSUM_FAIL () {(0x1);}' unless defined(&MPI_IOCFACTS_EXCEPT_CONFIG_CHECKSUM_FAIL);
    eval 'sub MPI_IOCFACTS_EXCEPT_RAID_CONFIG_INVALID () {(0x2);}' unless defined(&MPI_IOCFACTS_EXCEPT_RAID_CONFIG_INVALID);
    eval 'sub MPI_IOCFACTS_EXCEPT_FW_CHECKSUM_FAIL () {(0x4);}' unless defined(&MPI_IOCFACTS_EXCEPT_FW_CHECKSUM_FAIL);
    eval 'sub MPI_IOCFACTS_EXCEPT_PERSISTENT_TABLE_FULL () {(0x8);}' unless defined(&MPI_IOCFACTS_EXCEPT_PERSISTENT_TABLE_FULL);
    eval 'sub MPI_IOCFACTS_EXCEPT_METADATA_UNSUPPORTED () {(0x10);}' unless defined(&MPI_IOCFACTS_EXCEPT_METADATA_UNSUPPORTED);
    eval 'sub MPI_IOCFACTS_FLAGS_FW_DOWNLOAD_BOOT () {(0x1);}' unless defined(&MPI_IOCFACTS_FLAGS_FW_DOWNLOAD_BOOT);
    eval 'sub MPI_IOCFACTS_FLAGS_REPLY_FIFO_HOST_SIGNAL () {(0x2);}' unless defined(&MPI_IOCFACTS_FLAGS_REPLY_FIFO_HOST_SIGNAL);
    eval 'sub MPI_IOCFACTS_FLAGS_HOST_PAGE_BUFFER_PERSISTENT () {(0x4);}' unless defined(&MPI_IOCFACTS_FLAGS_HOST_PAGE_BUFFER_PERSISTENT);
    eval 'sub MPI_IOCFACTS_EVENTSTATE_DISABLED () {(0x);}' unless defined(&MPI_IOCFACTS_EVENTSTATE_DISABLED);
    eval 'sub MPI_IOCFACTS_EVENTSTATE_ENABLED () {(0x1);}' unless defined(&MPI_IOCFACTS_EVENTSTATE_ENABLED);
    eval 'sub MPI_IOCFACTS_CAPABILITY_HIGH_PRI_Q () {(0x1);}' unless defined(&MPI_IOCFACTS_CAPABILITY_HIGH_PRI_Q);
    eval 'sub MPI_IOCFACTS_CAPABILITY_REPLY_HOST_SIGNAL () {(0x2);}' unless defined(&MPI_IOCFACTS_CAPABILITY_REPLY_HOST_SIGNAL);
    eval 'sub MPI_IOCFACTS_CAPABILITY_QUEUE_FULL_HANDLING () {(0x4);}' unless defined(&MPI_IOCFACTS_CAPABILITY_QUEUE_FULL_HANDLING);
    eval 'sub MPI_IOCFACTS_CAPABILITY_DIAG_TRACE_BUFFER () {(0x8);}' unless defined(&MPI_IOCFACTS_CAPABILITY_DIAG_TRACE_BUFFER);
    eval 'sub MPI_IOCFACTS_CAPABILITY_SNAPSHOT_BUFFER () {(0x10);}' unless defined(&MPI_IOCFACTS_CAPABILITY_SNAPSHOT_BUFFER);
    eval 'sub MPI_IOCFACTS_CAPABILITY_EXTENDED_BUFFER () {(0x20);}' unless defined(&MPI_IOCFACTS_CAPABILITY_EXTENDED_BUFFER);
    eval 'sub MPI_IOCFACTS_CAPABILITY_EEDP () {(0x40);}' unless defined(&MPI_IOCFACTS_CAPABILITY_EEDP);
    eval 'sub MPI_IOCFACTS_CAPABILITY_BIDIRECTIONAL () {(0x80);}' unless defined(&MPI_IOCFACTS_CAPABILITY_BIDIRECTIONAL);
    eval 'sub MPI_IOCFACTS_CAPABILITY_MULTICAST () {(0x100);}' unless defined(&MPI_IOCFACTS_CAPABILITY_MULTICAST);
    eval 'sub MPI_IOCFACTS_CAPABILITY_SCSIIO32 () {(0x200);}' unless defined(&MPI_IOCFACTS_CAPABILITY_SCSIIO32);
    eval 'sub MPI_IOCFACTS_CAPABILITY_NO_SCSIIO16 () {(0x400);}' unless defined(&MPI_IOCFACTS_CAPABILITY_NO_SCSIIO16);
    eval 'sub MPI_IOCFACTS_CAPABILITY_TLR () {(0x800);}' unless defined(&MPI_IOCFACTS_CAPABILITY_TLR);
    eval 'sub MPI_PORTFACTS_PORTTYPE_INACTIVE () {(0x);}' unless defined(&MPI_PORTFACTS_PORTTYPE_INACTIVE);
    eval 'sub MPI_PORTFACTS_PORTTYPE_SCSI () {(0x1);}' unless defined(&MPI_PORTFACTS_PORTTYPE_SCSI);
    eval 'sub MPI_PORTFACTS_PORTTYPE_FC () {(0x10);}' unless defined(&MPI_PORTFACTS_PORTTYPE_FC);
    eval 'sub MPI_PORTFACTS_PORTTYPE_ISCSI () {(0x20);}' unless defined(&MPI_PORTFACTS_PORTTYPE_ISCSI);
    eval 'sub MPI_PORTFACTS_PORTTYPE_SAS () {(0x30);}' unless defined(&MPI_PORTFACTS_PORTTYPE_SAS);
    eval 'sub MPI_PORTFACTS_PROTOCOL_LOGBUSADDR () {(0x1);}' unless defined(&MPI_PORTFACTS_PROTOCOL_LOGBUSADDR);
    eval 'sub MPI_PORTFACTS_PROTOCOL_LAN () {(0x2);}' unless defined(&MPI_PORTFACTS_PROTOCOL_LAN);
    eval 'sub MPI_PORTFACTS_PROTOCOL_TARGET () {(0x4);}' unless defined(&MPI_PORTFACTS_PROTOCOL_TARGET);
    eval 'sub MPI_PORTFACTS_PROTOCOL_INITIATOR () {(0x8);}' unless defined(&MPI_PORTFACTS_PROTOCOL_INITIATOR);
    eval 'sub MPI_EVENT_NOTIFICATION_SWITCH_OFF () {(0x);}' unless defined(&MPI_EVENT_NOTIFICATION_SWITCH_OFF);
    eval 'sub MPI_EVENT_NOTIFICATION_SWITCH_ON () {(0x1);}' unless defined(&MPI_EVENT_NOTIFICATION_SWITCH_ON);
    eval 'sub MPI_EVENT_NONE () {(0x);}' unless defined(&MPI_EVENT_NONE);
    eval 'sub MPI_EVENT_LOG_DATA () {(0x1);}' unless defined(&MPI_EVENT_LOG_DATA);
    eval 'sub MPI_EVENT_STATE_CHANGE () {(0x2);}' unless defined(&MPI_EVENT_STATE_CHANGE);
    eval 'sub MPI_EVENT_UNIT_ATTENTION () {(0x3);}' unless defined(&MPI_EVENT_UNIT_ATTENTION);
    eval 'sub MPI_EVENT_IOC_BUS_RESET () {(0x4);}' unless defined(&MPI_EVENT_IOC_BUS_RESET);
    eval 'sub MPI_EVENT_EXT_BUS_RESET () {(0x5);}' unless defined(&MPI_EVENT_EXT_BUS_RESET);
    eval 'sub MPI_EVENT_RESCAN () {(0x6);}' unless defined(&MPI_EVENT_RESCAN);
    eval 'sub MPI_EVENT_LINK_STATUS_CHANGE () {(0x7);}' unless defined(&MPI_EVENT_LINK_STATUS_CHANGE);
    eval 'sub MPI_EVENT_LOOP_STATE_CHANGE () {(0x8);}' unless defined(&MPI_EVENT_LOOP_STATE_CHANGE);
    eval 'sub MPI_EVENT_LOGOUT () {(0x9);}' unless defined(&MPI_EVENT_LOGOUT);
    eval 'sub MPI_EVENT_EVENT_CHANGE () {(0xa);}' unless defined(&MPI_EVENT_EVENT_CHANGE);
    eval 'sub MPI_EVENT_INTEGRATED_RAID () {(0xb);}' unless defined(&MPI_EVENT_INTEGRATED_RAID);
    eval 'sub MPI_EVENT_SCSI_DEVICE_STATUS_CHANGE () {(0xc);}' unless defined(&MPI_EVENT_SCSI_DEVICE_STATUS_CHANGE);
    eval 'sub MPI_EVENT_ON_BUS_TIMER_EXPIRED () {(0xd);}' unless defined(&MPI_EVENT_ON_BUS_TIMER_EXPIRED);
    eval 'sub MPI_EVENT_QUEUE_FULL () {(0xe);}' unless defined(&MPI_EVENT_QUEUE_FULL);
    eval 'sub MPI_EVENT_SAS_DEVICE_STATUS_CHANGE () {(0xf);}' unless defined(&MPI_EVENT_SAS_DEVICE_STATUS_CHANGE);
    eval 'sub MPI_EVENT_SAS_SES () {(0x10);}' unless defined(&MPI_EVENT_SAS_SES);
    eval 'sub MPI_EVENT_PERSISTENT_TABLE_FULL () {(0x11);}' unless defined(&MPI_EVENT_PERSISTENT_TABLE_FULL);
    eval 'sub MPI_EVENT_SAS_PHY_LINK_STATUS () {(0x12);}' unless defined(&MPI_EVENT_SAS_PHY_LINK_STATUS);
    eval 'sub MPI_EVENT_SAS_DISCOVERY_ERROR () {(0x13);}' unless defined(&MPI_EVENT_SAS_DISCOVERY_ERROR);
    eval 'sub MPI_EVENT_IR_RESYNC_UPDATE () {(0x14);}' unless defined(&MPI_EVENT_IR_RESYNC_UPDATE);
    eval 'sub MPI_EVENT_IR2 () {(0x15);}' unless defined(&MPI_EVENT_IR2);
    eval 'sub MPI_EVENT_SAS_DISCOVERY () {(0x16);}' unless defined(&MPI_EVENT_SAS_DISCOVERY);
    eval 'sub MPI_EVENT_SAS_BROADCAST_PRIMITIVE () {(0x17);}' unless defined(&MPI_EVENT_SAS_BROADCAST_PRIMITIVE);
    eval 'sub MPI_EVENT_SAS_INIT_DEVICE_STATUS_CHANGE () {(0x18);}' unless defined(&MPI_EVENT_SAS_INIT_DEVICE_STATUS_CHANGE);
    eval 'sub MPI_EVENT_SAS_INIT_TABLE_OVERFLOW () {(0x19);}' unless defined(&MPI_EVENT_SAS_INIT_TABLE_OVERFLOW);
    eval 'sub MPI_EVENT_SAS_SMP_ERROR () {(0x1a);}' unless defined(&MPI_EVENT_SAS_SMP_ERROR);
    eval 'sub MPI_EVENT_SAS_EXPANDER_STATUS_CHANGE () {(0x1b);}' unless defined(&MPI_EVENT_SAS_EXPANDER_STATUS_CHANGE);
    eval 'sub MPI_EVENT_LOG_ENTRY_ADDED () {(0x21);}' unless defined(&MPI_EVENT_LOG_ENTRY_ADDED);
    eval 'sub MPI_EVENT_NOTIFICATION_ACK_NOT_REQUIRED () {(0x);}' unless defined(&MPI_EVENT_NOTIFICATION_ACK_NOT_REQUIRED);
    eval 'sub MPI_EVENT_NOTIFICATION_ACK_REQUIRED () {(0x1);}' unless defined(&MPI_EVENT_NOTIFICATION_ACK_REQUIRED);
    eval 'sub MPI_EVENT_DATA_LOG_ENTRY_DATA_LENGTH () {(0x1c);}' unless defined(&MPI_EVENT_DATA_LOG_ENTRY_DATA_LENGTH);
    eval 'sub MPI_EVENT_SCSI_DEV_STAT_RC_ADDED () {(0x3);}' unless defined(&MPI_EVENT_SCSI_DEV_STAT_RC_ADDED);
    eval 'sub MPI_EVENT_SCSI_DEV_STAT_RC_NOT_RESPONDING () {(0x4);}' unless defined(&MPI_EVENT_SCSI_DEV_STAT_RC_NOT_RESPONDING);
    eval 'sub MPI_EVENT_SCSI_DEV_STAT_RC_SMART_DATA () {(0x5);}' unless defined(&MPI_EVENT_SCSI_DEV_STAT_RC_SMART_DATA);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_ADDED () {(0x3);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_ADDED);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_NOT_RESPONDING () {(0x4);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_NOT_RESPONDING);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_SMART_DATA () {(0x5);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_SMART_DATA);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_NO_PERSIST_ADDED () {(0x6);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_NO_PERSIST_ADDED);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_UNSUPPORTED () {(0x7);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_UNSUPPORTED);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_INTERNAL_DEVICE_RESET () {(0x8);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_INTERNAL_DEVICE_RESET);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_TASK_ABORT_INTERNAL () {(0x9);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_TASK_ABORT_INTERNAL);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_ABORT_TASK_SET_INTERNAL () {(0xa);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_ABORT_TASK_SET_INTERNAL);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_CLEAR_TASK_SET_INTERNAL () {(0xb);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_CLEAR_TASK_SET_INTERNAL);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_QUERY_TASK_INTERNAL () {(0xc);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_QUERY_TASK_INTERNAL);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_ASYNC_NOTIFICATION () {(0xd);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_ASYNC_NOTIFICATION);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_CMPL_INTERNAL_DEV_RESET () {(0xe);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_CMPL_INTERNAL_DEV_RESET);
    eval 'sub MPI_EVENT_SAS_DEV_STAT_RC_CMPL_TASK_ABORT_INTERNAL () {(0xf);}' unless defined(&MPI_EVENT_SAS_DEV_STAT_RC_CMPL_TASK_ABORT_INTERNAL);
    eval 'sub MPI_EVENT_RAID_RC_VOLUME_CREATED () {(0x);}' unless defined(&MPI_EVENT_RAID_RC_VOLUME_CREATED);
    eval 'sub MPI_EVENT_RAID_RC_VOLUME_DELETED () {(0x1);}' unless defined(&MPI_EVENT_RAID_RC_VOLUME_DELETED);
    eval 'sub MPI_EVENT_RAID_RC_VOLUME_SETTINGS_CHANGED () {(0x2);}' unless defined(&MPI_EVENT_RAID_RC_VOLUME_SETTINGS_CHANGED);
    eval 'sub MPI_EVENT_RAID_RC_VOLUME_STATUS_CHANGED () {(0x3);}' unless defined(&MPI_EVENT_RAID_RC_VOLUME_STATUS_CHANGED);
    eval 'sub MPI_EVENT_RAID_RC_VOLUME_PHYSDISK_CHANGED () {(0x4);}' unless defined(&MPI_EVENT_RAID_RC_VOLUME_PHYSDISK_CHANGED);
    eval 'sub MPI_EVENT_RAID_RC_PHYSDISK_CREATED () {(0x5);}' unless defined(&MPI_EVENT_RAID_RC_PHYSDISK_CREATED);
    eval 'sub MPI_EVENT_RAID_RC_PHYSDISK_DELETED () {(0x6);}' unless defined(&MPI_EVENT_RAID_RC_PHYSDISK_DELETED);
    eval 'sub MPI_EVENT_RAID_RC_PHYSDISK_SETTINGS_CHANGED () {(0x7);}' unless defined(&MPI_EVENT_RAID_RC_PHYSDISK_SETTINGS_CHANGED);
    eval 'sub MPI_EVENT_RAID_RC_PHYSDISK_STATUS_CHANGED () {(0x8);}' unless defined(&MPI_EVENT_RAID_RC_PHYSDISK_STATUS_CHANGED);
    eval 'sub MPI_EVENT_RAID_RC_DOMAIN_VAL_NEEDED () {(0x9);}' unless defined(&MPI_EVENT_RAID_RC_DOMAIN_VAL_NEEDED);
    eval 'sub MPI_EVENT_RAID_RC_SMART_DATA () {(0xa);}' unless defined(&MPI_EVENT_RAID_RC_SMART_DATA);
    eval 'sub MPI_EVENT_RAID_RC_REPLACE_ACTION_STARTED () {(0xb);}' unless defined(&MPI_EVENT_RAID_RC_REPLACE_ACTION_STARTED);
    eval 'sub MPI_EVENT_IR2_RC_LD_STATE_CHANGED () {(0x1);}' unless defined(&MPI_EVENT_IR2_RC_LD_STATE_CHANGED);
    eval 'sub MPI_EVENT_IR2_RC_PD_STATE_CHANGED () {(0x2);}' unless defined(&MPI_EVENT_IR2_RC_PD_STATE_CHANGED);
    eval 'sub MPI_EVENT_IR2_RC_BAD_BLOCK_TABLE_FULL () {(0x3);}' unless defined(&MPI_EVENT_IR2_RC_BAD_BLOCK_TABLE_FULL);
    eval 'sub MPI_EVENT_IR2_RC_PD_INSERTED () {(0x4);}' unless defined(&MPI_EVENT_IR2_RC_PD_INSERTED);
    eval 'sub MPI_EVENT_IR2_RC_PD_REMOVED () {(0x5);}' unless defined(&MPI_EVENT_IR2_RC_PD_REMOVED);
    eval 'sub MPI_EVENT_IR2_RC_FOREIGN_CFG_DETECTED () {(0x6);}' unless defined(&MPI_EVENT_IR2_RC_FOREIGN_CFG_DETECTED);
    eval 'sub MPI_EVENT_IR2_RC_REBUILD_MEDIUM_ERROR () {(0x7);}' unless defined(&MPI_EVENT_IR2_RC_REBUILD_MEDIUM_ERROR);
    eval 'sub MPI_EVENT_IR2_RC_DUAL_PORT_ADDED () {(0x8);}' unless defined(&MPI_EVENT_IR2_RC_DUAL_PORT_ADDED);
    eval 'sub MPI_EVENT_IR2_RC_DUAL_PORT_REMOVED () {(0x9);}' unless defined(&MPI_EVENT_IR2_RC_DUAL_PORT_REMOVED);
    eval 'sub MPI_LD_STATE_OPTIMAL () {(0x);}' unless defined(&MPI_LD_STATE_OPTIMAL);
    eval 'sub MPI_LD_STATE_DEGRADED () {(0x1);}' unless defined(&MPI_LD_STATE_DEGRADED);
    eval 'sub MPI_LD_STATE_FAILED () {(0x2);}' unless defined(&MPI_LD_STATE_FAILED);
    eval 'sub MPI_LD_STATE_MISSING () {(0x3);}' unless defined(&MPI_LD_STATE_MISSING);
    eval 'sub MPI_LD_STATE_OFFLINE () {(0x4);}' unless defined(&MPI_LD_STATE_OFFLINE);
    eval 'sub MPI_PD_STATE_ONLINE () {(0x);}' unless defined(&MPI_PD_STATE_ONLINE);
    eval 'sub MPI_PD_STATE_MISSING () {(0x1);}' unless defined(&MPI_PD_STATE_MISSING);
    eval 'sub MPI_PD_STATE_NOT_COMPATIBLE () {(0x2);}' unless defined(&MPI_PD_STATE_NOT_COMPATIBLE);
    eval 'sub MPI_PD_STATE_FAILED () {(0x3);}' unless defined(&MPI_PD_STATE_FAILED);
    eval 'sub MPI_PD_STATE_INITIALIZING () {(0x4);}' unless defined(&MPI_PD_STATE_INITIALIZING);
    eval 'sub MPI_PD_STATE_OFFLINE_AT_HOST_REQUEST () {(0x5);}' unless defined(&MPI_PD_STATE_OFFLINE_AT_HOST_REQUEST);
    eval 'sub MPI_PD_STATE_FAILED_AT_HOST_REQUEST () {(0x6);}' unless defined(&MPI_PD_STATE_FAILED_AT_HOST_REQUEST);
    eval 'sub MPI_PD_STATE_OFFLINE_FOR_ANOTHER_REASON () {(0xff);}' unless defined(&MPI_PD_STATE_OFFLINE_FOR_ANOTHER_REASON);
    eval 'sub MPI_EVENT_LINK_STATUS_FAILURE () {(0x);}' unless defined(&MPI_EVENT_LINK_STATUS_FAILURE);
    eval 'sub MPI_EVENT_LINK_STATUS_ACTIVE () {(0x1);}' unless defined(&MPI_EVENT_LINK_STATUS_ACTIVE);
    eval 'sub MPI_EVENT_LOOP_STATE_CHANGE_LIP () {(0x1);}' unless defined(&MPI_EVENT_LOOP_STATE_CHANGE_LIP);
    eval 'sub MPI_EVENT_LOOP_STATE_CHANGE_LPE () {(0x2);}' unless defined(&MPI_EVENT_LOOP_STATE_CHANGE_LPE);
    eval 'sub MPI_EVENT_LOOP_STATE_CHANGE_LPB () {(0x3);}' unless defined(&MPI_EVENT_LOOP_STATE_CHANGE_LPB);
    eval 'sub MPI_EVENT_LOGOUT_ALL_ALIASES () {(0xff);}' unless defined(&MPI_EVENT_LOGOUT_ALL_ALIASES);
    eval 'sub MPI_EVENT_PRIMITIVE_CHANGE () {(0x1);}' unless defined(&MPI_EVENT_PRIMITIVE_CHANGE);
    eval 'sub MPI_EVENT_PRIMITIVE_EXPANDER () {(0x3);}' unless defined(&MPI_EVENT_PRIMITIVE_EXPANDER);
    eval 'sub MPI_EVENT_PRIMITIVE_ASYNCHRONOUS_EVENT () {(0x4);}' unless defined(&MPI_EVENT_PRIMITIVE_ASYNCHRONOUS_EVENT);
    eval 'sub MPI_EVENT_PRIMITIVE_RESERVED3 () {(0x5);}' unless defined(&MPI_EVENT_PRIMITIVE_RESERVED3);
    eval 'sub MPI_EVENT_PRIMITIVE_RESERVED4 () {(0x6);}' unless defined(&MPI_EVENT_PRIMITIVE_RESERVED4);
    eval 'sub MPI_EVENT_PRIMITIVE_CHANGE0_RESERVED () {(0x7);}' unless defined(&MPI_EVENT_PRIMITIVE_CHANGE0_RESERVED);
    eval 'sub MPI_EVENT_PRIMITIVE_CHANGE1_RESERVED () {(0x8);}' unless defined(&MPI_EVENT_PRIMITIVE_CHANGE1_RESERVED);
    eval 'sub MPI_EVENT_SAS_PLS_LR_CURRENT_MASK () {(0xf0);}' unless defined(&MPI_EVENT_SAS_PLS_LR_CURRENT_MASK);
    eval 'sub MPI_EVENT_SAS_PLS_LR_CURRENT_SHIFT () {(4);}' unless defined(&MPI_EVENT_SAS_PLS_LR_CURRENT_SHIFT);
    eval 'sub MPI_EVENT_SAS_PLS_LR_PREVIOUS_MASK () {(0xf);}' unless defined(&MPI_EVENT_SAS_PLS_LR_PREVIOUS_MASK);
    eval 'sub MPI_EVENT_SAS_PLS_LR_PREVIOUS_SHIFT () {(0);}' unless defined(&MPI_EVENT_SAS_PLS_LR_PREVIOUS_SHIFT);
    eval 'sub MPI_EVENT_SAS_PLS_LR_RATE_UNKNOWN () {(0x);}' unless defined(&MPI_EVENT_SAS_PLS_LR_RATE_UNKNOWN);
    eval 'sub MPI_EVENT_SAS_PLS_LR_RATE_PHY_DISABLED () {(0x1);}' unless defined(&MPI_EVENT_SAS_PLS_LR_RATE_PHY_DISABLED);
    eval 'sub MPI_EVENT_SAS_PLS_LR_RATE_FAILED_SPEED_NEGOTIATION () {(0x2);}' unless defined(&MPI_EVENT_SAS_PLS_LR_RATE_FAILED_SPEED_NEGOTIATION);
    eval 'sub MPI_EVENT_SAS_PLS_LR_RATE_SATA_OOB_COMPLETE () {(0x3);}' unless defined(&MPI_EVENT_SAS_PLS_LR_RATE_SATA_OOB_COMPLETE);
    eval 'sub MPI_EVENT_SAS_PLS_LR_RATE_1_5 () {(0x8);}' unless defined(&MPI_EVENT_SAS_PLS_LR_RATE_1_5);
    eval 'sub MPI_EVENT_SAS_PLS_LR_RATE_3_0 () {(0x9);}' unless defined(&MPI_EVENT_SAS_PLS_LR_RATE_3_0);
    eval 'sub MPI_EVENT_SAS_PLS_LR_RATE_6_0 () {(0xa);}' unless defined(&MPI_EVENT_SAS_PLS_LR_RATE_6_0);
    eval 'sub MPI_EVENT_SAS_DSCVRY_COMPLETE () {(0x);}' unless defined(&MPI_EVENT_SAS_DSCVRY_COMPLETE);
    eval 'sub MPI_EVENT_SAS_DSCVRY_IN_PROGRESS () {(0x1);}' unless defined(&MPI_EVENT_SAS_DSCVRY_IN_PROGRESS);
    eval 'sub MPI_EVENT_SAS_DSCVRY_PHY_BITS_MASK () {(0xffff0000);}' unless defined(&MPI_EVENT_SAS_DSCVRY_PHY_BITS_MASK);
    eval 'sub MPI_EVENT_SAS_DSCVRY_PHY_BITS_SHIFT () {(16);}' unless defined(&MPI_EVENT_SAS_DSCVRY_PHY_BITS_SHIFT);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_LOOP_DETECTED () {(0x1);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_LOOP_DETECTED);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_UNADDRESSABLE_DEVICE () {(0x2);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_UNADDRESSABLE_DEVICE);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_MULTIPLE_PORTS () {(0x4);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_MULTIPLE_PORTS);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_EXPANDER_ERR () {(0x8);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_EXPANDER_ERR);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_SMP_TIMEOUT () {(0x10);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_SMP_TIMEOUT);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_OUT_ROUTE_ENTRIES () {(0x20);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_OUT_ROUTE_ENTRIES);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_INDEX_NOT_EXIST () {(0x40);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_INDEX_NOT_EXIST);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_SMP_FUNCTION_FAILED () {(0x80);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_SMP_FUNCTION_FAILED);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_SMP_CRC_ERROR () {(0x100);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_SMP_CRC_ERROR);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_MULTPL_SUBTRACTIVE () {(0x200);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_MULTPL_SUBTRACTIVE);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_TABLE_TO_TABLE () {(0x400);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_TABLE_TO_TABLE);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_UNSUPPORTED_DEVICE () {(0x800);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_UNSUPPORTED_DEVICE);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_MAX_SATA_TARGETS () {(0x1000);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_MAX_SATA_TARGETS);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_MULTI_PORT_DOMAIN () {(0x2000);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_MULTI_PORT_DOMAIN);
    eval 'sub MPI_EVENT_DSCVRY_ERR_DS_SATA_INIT_FAILURE () {(0x4000);}' unless defined(&MPI_EVENT_DSCVRY_ERR_DS_SATA_INIT_FAILURE);
    eval 'sub MPI_EVENT_SAS_SMP_FUNCTION_RESULT_VALID () {(0x);}' unless defined(&MPI_EVENT_SAS_SMP_FUNCTION_RESULT_VALID);
    eval 'sub MPI_EVENT_SAS_SMP_CRC_ERROR () {(0x1);}' unless defined(&MPI_EVENT_SAS_SMP_CRC_ERROR);
    eval 'sub MPI_EVENT_SAS_SMP_TIMEOUT () {(0x2);}' unless defined(&MPI_EVENT_SAS_SMP_TIMEOUT);
    eval 'sub MPI_EVENT_SAS_SMP_NO_DESTINATION () {(0x3);}' unless defined(&MPI_EVENT_SAS_SMP_NO_DESTINATION);
    eval 'sub MPI_EVENT_SAS_SMP_BAD_DESTINATION () {(0x4);}' unless defined(&MPI_EVENT_SAS_SMP_BAD_DESTINATION);
    eval 'sub MPI_EVENT_SAS_INIT_RC_ADDED () {(0x1);}' unless defined(&MPI_EVENT_SAS_INIT_RC_ADDED);
    eval 'sub MPI_EVENT_SAS_INIT_RC_REMOVED () {(0x2);}' unless defined(&MPI_EVENT_SAS_INIT_RC_REMOVED);
    eval 'sub MPI_EVENT_SAS_INIT_RC_INACCESSIBLE () {(0x3);}' unless defined(&MPI_EVENT_SAS_INIT_RC_INACCESSIBLE);
    eval 'sub MPI_EVENT_SAS_EXP_RC_ADDED () {(0x);}' unless defined(&MPI_EVENT_SAS_EXP_RC_ADDED);
    eval 'sub MPI_EVENT_SAS_EXP_RC_NOT_RESPONDING () {(0x1);}' unless defined(&MPI_EVENT_SAS_EXP_RC_NOT_RESPONDING);
    eval 'sub MPI_EVENT_SAS_EXP_DS_LOOP_DETECTED () {(0x1);}' unless defined(&MPI_EVENT_SAS_EXP_DS_LOOP_DETECTED);
    eval 'sub MPI_EVENT_SAS_EXP_DS_UNADDRESSABLE_DEVICE () {(0x2);}' unless defined(&MPI_EVENT_SAS_EXP_DS_UNADDRESSABLE_DEVICE);
    eval 'sub MPI_EVENT_SAS_EXP_DS_MULTIPLE_PORTS () {(0x4);}' unless defined(&MPI_EVENT_SAS_EXP_DS_MULTIPLE_PORTS);
    eval 'sub MPI_EVENT_SAS_EXP_DS_EXPANDER_ERR () {(0x8);}' unless defined(&MPI_EVENT_SAS_EXP_DS_EXPANDER_ERR);
    eval 'sub MPI_EVENT_SAS_EXP_DS_SMP_TIMEOUT () {(0x10);}' unless defined(&MPI_EVENT_SAS_EXP_DS_SMP_TIMEOUT);
    eval 'sub MPI_EVENT_SAS_EXP_DS_OUT_ROUTE_ENTRIES () {(0x20);}' unless defined(&MPI_EVENT_SAS_EXP_DS_OUT_ROUTE_ENTRIES);
    eval 'sub MPI_EVENT_SAS_EXP_DS_INDEX_NOT_EXIST () {(0x40);}' unless defined(&MPI_EVENT_SAS_EXP_DS_INDEX_NOT_EXIST);
    eval 'sub MPI_EVENT_SAS_EXP_DS_SMP_FUNCTION_FAILED () {(0x80);}' unless defined(&MPI_EVENT_SAS_EXP_DS_SMP_FUNCTION_FAILED);
    eval 'sub MPI_EVENT_SAS_EXP_DS_SMP_CRC_ERROR () {(0x100);}' unless defined(&MPI_EVENT_SAS_EXP_DS_SMP_CRC_ERROR);
    eval 'sub MPI_EVENT_SAS_EXP_DS_SUBTRACTIVE_LINK () {(0x200);}' unless defined(&MPI_EVENT_SAS_EXP_DS_SUBTRACTIVE_LINK);
    eval 'sub MPI_EVENT_SAS_EXP_DS_TABLE_LINK () {(0x400);}' unless defined(&MPI_EVENT_SAS_EXP_DS_TABLE_LINK);
    eval 'sub MPI_EVENT_SAS_EXP_DS_UNSUPPORTED_DEVICE () {(0x800);}' unless defined(&MPI_EVENT_SAS_EXP_DS_UNSUPPORTED_DEVICE);
    eval 'sub MPI_EVENT_SAS_EXP_FLAGS_ROUTE_TABLE_CONFIG () {(0x2);}' unless defined(&MPI_EVENT_SAS_EXP_FLAGS_ROUTE_TABLE_CONFIG);
    eval 'sub MPI_EVENT_SAS_EXP_FLAGS_CONFIG_IN_PROGRESS () {(0x1);}' unless defined(&MPI_EVENT_SAS_EXP_FLAGS_CONFIG_IN_PROGRESS);
    eval 'sub MPI_FW_DOWNLOAD_MSGFLGS_LAST_SEGMENT () {(0x1);}' unless defined(&MPI_FW_DOWNLOAD_MSGFLGS_LAST_SEGMENT);
    eval 'sub MPI_FW_DOWNLOAD_ITYPE_RESERVED () {(0x);}' unless defined(&MPI_FW_DOWNLOAD_ITYPE_RESERVED);
    eval 'sub MPI_FW_DOWNLOAD_ITYPE_FW () {(0x1);}' unless defined(&MPI_FW_DOWNLOAD_ITYPE_FW);
    eval 'sub MPI_FW_DOWNLOAD_ITYPE_BIOS () {(0x2);}' unless defined(&MPI_FW_DOWNLOAD_ITYPE_BIOS);
    eval 'sub MPI_FW_DOWNLOAD_ITYPE_NVDATA () {(0x3);}' unless defined(&MPI_FW_DOWNLOAD_ITYPE_NVDATA);
    eval 'sub MPI_FW_DOWNLOAD_ITYPE_BOOTLOADER () {(0x4);}' unless defined(&MPI_FW_DOWNLOAD_ITYPE_BOOTLOADER);
    eval 'sub MPI_FW_DOWNLOAD_ITYPE_MANUFACTURING () {(0x6);}' unless defined(&MPI_FW_DOWNLOAD_ITYPE_MANUFACTURING);
    eval 'sub MPI_FW_DOWNLOAD_ITYPE_CONFIG_1 () {(0x7);}' unless defined(&MPI_FW_DOWNLOAD_ITYPE_CONFIG_1);
    eval 'sub MPI_FW_DOWNLOAD_ITYPE_CONFIG_2 () {(0x8);}' unless defined(&MPI_FW_DOWNLOAD_ITYPE_CONFIG_2);
    eval 'sub MPI_FW_DOWNLOAD_ITYPE_MEGARAID () {(0x9);}' unless defined(&MPI_FW_DOWNLOAD_ITYPE_MEGARAID);
    eval 'sub MPI_FW_DOWNLOAD_ITYPE_COMMON_BOOT_BLOCK () {(0xb);}' unless defined(&MPI_FW_DOWNLOAD_ITYPE_COMMON_BOOT_BLOCK);
    eval 'sub MPI_FW_UPLOAD_ITYPE_FW_IOC_MEM () {(0x);}' unless defined(&MPI_FW_UPLOAD_ITYPE_FW_IOC_MEM);
    eval 'sub MPI_FW_UPLOAD_ITYPE_FW_FLASH () {(0x1);}' unless defined(&MPI_FW_UPLOAD_ITYPE_FW_FLASH);
    eval 'sub MPI_FW_UPLOAD_ITYPE_BIOS_FLASH () {(0x2);}' unless defined(&MPI_FW_UPLOAD_ITYPE_BIOS_FLASH);
    eval 'sub MPI_FW_UPLOAD_ITYPE_NVDATA () {(0x3);}' unless defined(&MPI_FW_UPLOAD_ITYPE_NVDATA);
    eval 'sub MPI_FW_UPLOAD_ITYPE_BOOTLOADER () {(0x4);}' unless defined(&MPI_FW_UPLOAD_ITYPE_BOOTLOADER);
    eval 'sub MPI_FW_UPLOAD_ITYPE_FW_BACKUP () {(0x5);}' unless defined(&MPI_FW_UPLOAD_ITYPE_FW_BACKUP);
    eval 'sub MPI_FW_UPLOAD_ITYPE_MANUFACTURING () {(0x6);}' unless defined(&MPI_FW_UPLOAD_ITYPE_MANUFACTURING);
    eval 'sub MPI_FW_UPLOAD_ITYPE_CONFIG_1 () {(0x7);}' unless defined(&MPI_FW_UPLOAD_ITYPE_CONFIG_1);
    eval 'sub MPI_FW_UPLOAD_ITYPE_CONFIG_2 () {(0x8);}' unless defined(&MPI_FW_UPLOAD_ITYPE_CONFIG_2);
    eval 'sub MPI_FW_UPLOAD_ITYPE_MEGARAID () {(0x9);}' unless defined(&MPI_FW_UPLOAD_ITYPE_MEGARAID);
    eval 'sub MPI_FW_UPLOAD_ITYPE_COMPLETE () {(0xa);}' unless defined(&MPI_FW_UPLOAD_ITYPE_COMPLETE);
    eval 'sub MPI_FW_UPLOAD_ITYPE_COMMON_BOOT_BLOCK () {(0xb);}' unless defined(&MPI_FW_UPLOAD_ITYPE_COMMON_BOOT_BLOCK);
    eval 'sub MPI_FW_HEADER_WHAT_SIGNATURE () {(0x29232840);}' unless defined(&MPI_FW_HEADER_WHAT_SIGNATURE);
    eval 'sub MPI_FW_HEADER_PID_TYPE_MASK () {(0xf000);}' unless defined(&MPI_FW_HEADER_PID_TYPE_MASK);
    eval 'sub MPI_FW_HEADER_PID_TYPE_SCSI () {(0x);}' unless defined(&MPI_FW_HEADER_PID_TYPE_SCSI);
    eval 'sub MPI_FW_HEADER_PID_TYPE_FC () {(0x1000);}' unless defined(&MPI_FW_HEADER_PID_TYPE_FC);
    eval 'sub MPI_FW_HEADER_PID_TYPE_SAS () {(0x2000);}' unless defined(&MPI_FW_HEADER_PID_TYPE_SAS);
    eval 'sub MPI_FW_HEADER_SIGNATURE_0 () {(0x5aeaa55a);}' unless defined(&MPI_FW_HEADER_SIGNATURE_0);
    eval 'sub MPI_FW_HEADER_SIGNATURE_1 () {(0xa55aeaa5);}' unless defined(&MPI_FW_HEADER_SIGNATURE_1);
    eval 'sub MPI_FW_HEADER_SIGNATURE_2 () {(0x5aa55aea);}' unless defined(&MPI_FW_HEADER_SIGNATURE_2);
    eval 'sub MPI_FW_HEADER_PID_PROD_MASK () {(0xf00);}' unless defined(&MPI_FW_HEADER_PID_PROD_MASK);
    eval 'sub MPI_FW_HEADER_PID_PROD_INITIATOR_SCSI () {(0x100);}' unless defined(&MPI_FW_HEADER_PID_PROD_INITIATOR_SCSI);
    eval 'sub MPI_FW_HEADER_PID_PROD_TARGET_INITIATOR_SCSI () {(0x200);}' unless defined(&MPI_FW_HEADER_PID_PROD_TARGET_INITIATOR_SCSI);
    eval 'sub MPI_FW_HEADER_PID_PROD_TARGET_SCSI () {(0x300);}' unless defined(&MPI_FW_HEADER_PID_PROD_TARGET_SCSI);
    eval 'sub MPI_FW_HEADER_PID_PROD_IM_SCSI () {(0x400);}' unless defined(&MPI_FW_HEADER_PID_PROD_IM_SCSI);
    eval 'sub MPI_FW_HEADER_PID_PROD_IS_SCSI () {(0x500);}' unless defined(&MPI_FW_HEADER_PID_PROD_IS_SCSI);
    eval 'sub MPI_FW_HEADER_PID_PROD_CTX_SCSI () {(0x600);}' unless defined(&MPI_FW_HEADER_PID_PROD_CTX_SCSI);
    eval 'sub MPI_FW_HEADER_PID_PROD_IR_SCSI () {(0x700);}' unless defined(&MPI_FW_HEADER_PID_PROD_IR_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_MASK () {(0xff);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_MASK);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1030A0_SCSI () {(0x1);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1030A0_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1030B0_SCSI () {(0x2);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1030B0_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1030B1_SCSI () {(0x3);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1030B1_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1030C0_SCSI () {(0x4);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1030C0_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1020A0_SCSI () {(0x5);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1020A0_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1020B0_SCSI () {(0x6);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1020B0_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1020B1_SCSI () {(0x7);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1020B1_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1020C0_SCSI () {(0x8);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1020C0_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1035A0_SCSI () {(0x9);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1035A0_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1035B0_SCSI () {(0xa);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1035B0_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1030TA0_SCSI () {(0xb);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1030TA0_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1020TA0_SCSI () {(0xc);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1020TA0_SCSI);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_909_FC () {(0x);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_909_FC);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_919_FC () {(0x1);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_919_FC);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_919X_FC () {(0x2);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_919X_FC);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_919XL_FC () {(0x3);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_919XL_FC);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_939X_FC () {(0x4);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_939X_FC);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_959_FC () {(0x5);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_959_FC);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_949E_FC () {(0x6);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_949E_FC);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1064_SAS () {(0x1);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1064_SAS);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1068_SAS () {(0x2);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1068_SAS);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_1078_SAS () {(0x3);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_1078_SAS);
    eval 'sub MPI_FW_HEADER_PID_FAMILY_106xE_SAS () {(0x4);}' unless defined(&MPI_FW_HEADER_PID_FAMILY_106xE_SAS);
    eval 'sub MPI_EXT_IMAGE_TYPE_UNSPECIFIED () {(0x);}' unless defined(&MPI_EXT_IMAGE_TYPE_UNSPECIFIED);
    eval 'sub MPI_EXT_IMAGE_TYPE_FW () {(0x1);}' unless defined(&MPI_EXT_IMAGE_TYPE_FW);
    eval 'sub MPI_EXT_IMAGE_TYPE_NVDATA () {(0x3);}' unless defined(&MPI_EXT_IMAGE_TYPE_NVDATA);
    eval 'sub MPI_EXT_IMAGE_TYPE_BOOTLOADER () {(0x4);}' unless defined(&MPI_EXT_IMAGE_TYPE_BOOTLOADER);
    eval 'sub MPI_EXT_IMAGE_TYPE_INITIALIZATION () {(0x5);}' unless defined(&MPI_EXT_IMAGE_TYPE_INITIALIZATION);
}
1;
