require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MPI_LAN_H)) {
    eval 'sub MPI_LAN_H () {1;}' unless defined(&MPI_LAN_H);
    eval 'sub LAN_REPLY_PACKET_LENGTH_MASK () {(0xffff);}' unless defined(&LAN_REPLY_PACKET_LENGTH_MASK);
    eval 'sub LAN_REPLY_PACKET_LENGTH_SHIFT () {(0);}' unless defined(&LAN_REPLY_PACKET_LENGTH_SHIFT);
    eval 'sub LAN_REPLY_BUCKET_CONTEXT_MASK () {(0x7ff0000);}' unless defined(&LAN_REPLY_BUCKET_CONTEXT_MASK);
    eval 'sub LAN_REPLY_BUCKET_CONTEXT_SHIFT () {(16);}' unless defined(&LAN_REPLY_BUCKET_CONTEXT_SHIFT);
    eval 'sub LAN_REPLY_BUFFER_CONTEXT_MASK () {(0x7ffffff);}' unless defined(&LAN_REPLY_BUFFER_CONTEXT_MASK);
    eval 'sub LAN_REPLY_BUFFER_CONTEXT_SHIFT () {(0);}' unless defined(&LAN_REPLY_BUFFER_CONTEXT_SHIFT);
    eval 'sub LAN_REPLY_FORM_MASK () {(0x18000000);}' unless defined(&LAN_REPLY_FORM_MASK);
    eval 'sub LAN_REPLY_FORM_RECEIVE_SINGLE () {(0x);}' unless defined(&LAN_REPLY_FORM_RECEIVE_SINGLE);
    eval 'sub LAN_REPLY_FORM_RECEIVE_MULTIPLE () {(0x1);}' unless defined(&LAN_REPLY_FORM_RECEIVE_MULTIPLE);
    eval 'sub LAN_REPLY_FORM_SEND_SINGLE () {(0x2);}' unless defined(&LAN_REPLY_FORM_SEND_SINGLE);
    eval 'sub LAN_REPLY_FORM_MESSAGE_CONTEXT () {(0x3);}' unless defined(&LAN_REPLY_FORM_MESSAGE_CONTEXT);
    eval 'sub LAN_REPLY_FORM_SHIFT () {(27);}' unless defined(&LAN_REPLY_FORM_SHIFT);
    eval 'sub GET_LAN_PACKET_LENGTH {
        my($x) = @_;
	    eval q(((($x) &  &LAN_REPLY_PACKET_LENGTH_MASK) >>  &LAN_REPLY_PACKET_LENGTH_SHIFT));
    }' unless defined(&GET_LAN_PACKET_LENGTH);
    eval 'sub SET_LAN_PACKET_LENGTH {
        my($x, $lth) = @_;
	    eval q((($x) = (($x) & ~ &LAN_REPLY_PACKET_LENGTH_MASK) | ((($lth) <<  &LAN_REPLY_PACKET_LENGTH_SHIFT) &  &LAN_REPLY_PACKET_LENGTH_MASK)));
    }' unless defined(&SET_LAN_PACKET_LENGTH);
    eval 'sub GET_LAN_BUCKET_CONTEXT {
        my($x) = @_;
	    eval q(((($x) &  &LAN_REPLY_BUCKET_CONTEXT_MASK) >>  &LAN_REPLY_BUCKET_CONTEXT_SHIFT));
    }' unless defined(&GET_LAN_BUCKET_CONTEXT);
    eval 'sub SET_LAN_BUCKET_CONTEXT {
        my($x, $ctx) = @_;
	    eval q((($x) = (($x) & ~ &LAN_REPLY_BUCKET_CONTEXT_MASK) | ((($ctx) <<  &LAN_REPLY_BUCKET_CONTEXT_SHIFT) &  &LAN_REPLY_BUCKET_CONTEXT_MASK)));
    }' unless defined(&SET_LAN_BUCKET_CONTEXT);
    eval 'sub GET_LAN_BUFFER_CONTEXT {
        my($x) = @_;
	    eval q(((($x) &  &LAN_REPLY_BUFFER_CONTEXT_MASK) >>  &LAN_REPLY_BUFFER_CONTEXT_SHIFT));
    }' unless defined(&GET_LAN_BUFFER_CONTEXT);
    eval 'sub SET_LAN_BUFFER_CONTEXT {
        my($x, $ctx) = @_;
	    eval q((($x) = (($x) & ~ &LAN_REPLY_BUFFER_CONTEXT_MASK) | ((($ctx) <<  &LAN_REPLY_BUFFER_CONTEXT_SHIFT) &  &LAN_REPLY_BUFFER_CONTEXT_MASK)));
    }' unless defined(&SET_LAN_BUFFER_CONTEXT);
    eval 'sub GET_LAN_FORM {
        my($x) = @_;
	    eval q(((($x) &  &LAN_REPLY_FORM_MASK) >>  &LAN_REPLY_FORM_SHIFT));
    }' unless defined(&GET_LAN_FORM);
    eval 'sub SET_LAN_FORM {
        my($x, $frm) = @_;
	    eval q((($x) = (($x) & ~ &LAN_REPLY_FORM_MASK) | ((($frm) <<  &LAN_REPLY_FORM_SHIFT) &  &LAN_REPLY_FORM_MASK)));
    }' unless defined(&SET_LAN_FORM);
    eval 'sub MPI_LAN_DEVICE_STATE_RESET () {(0x);}' unless defined(&MPI_LAN_DEVICE_STATE_RESET);
    eval 'sub MPI_LAN_DEVICE_STATE_OPERATIONAL () {(0x1);}' unless defined(&MPI_LAN_DEVICE_STATE_OPERATIONAL);
    eval 'sub MPI_LAN_TX_MODES_ENABLE_LOOPBACK_SUPPRESSION () {(0x1);}' unless defined(&MPI_LAN_TX_MODES_ENABLE_LOOPBACK_SUPPRESSION);
}
1;
