require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MPI_RAID_H)) {
    eval 'sub MPI_RAID_H () {1;}' unless defined(&MPI_RAID_H);
    eval 'sub MPI_RAID_ACTION_STATUS () {(0x);}' unless defined(&MPI_RAID_ACTION_STATUS);
    eval 'sub MPI_RAID_ACTION_INDICATOR_STRUCT () {(0x1);}' unless defined(&MPI_RAID_ACTION_INDICATOR_STRUCT);
    eval 'sub MPI_RAID_ACTION_CREATE_VOLUME () {(0x2);}' unless defined(&MPI_RAID_ACTION_CREATE_VOLUME);
    eval 'sub MPI_RAID_ACTION_DELETE_VOLUME () {(0x3);}' unless defined(&MPI_RAID_ACTION_DELETE_VOLUME);
    eval 'sub MPI_RAID_ACTION_DISABLE_VOLUME () {(0x4);}' unless defined(&MPI_RAID_ACTION_DISABLE_VOLUME);
    eval 'sub MPI_RAID_ACTION_ENABLE_VOLUME () {(0x5);}' unless defined(&MPI_RAID_ACTION_ENABLE_VOLUME);
    eval 'sub MPI_RAID_ACTION_QUIESCE_PHYS_IO () {(0x6);}' unless defined(&MPI_RAID_ACTION_QUIESCE_PHYS_IO);
    eval 'sub MPI_RAID_ACTION_ENABLE_PHYS_IO () {(0x7);}' unless defined(&MPI_RAID_ACTION_ENABLE_PHYS_IO);
    eval 'sub MPI_RAID_ACTION_CHANGE_VOLUME_SETTINGS () {(0x8);}' unless defined(&MPI_RAID_ACTION_CHANGE_VOLUME_SETTINGS);
    eval 'sub MPI_RAID_ACTION_PHYSDISK_OFFLINE () {(0xa);}' unless defined(&MPI_RAID_ACTION_PHYSDISK_OFFLINE);
    eval 'sub MPI_RAID_ACTION_PHYSDISK_ONLINE () {(0xb);}' unless defined(&MPI_RAID_ACTION_PHYSDISK_ONLINE);
    eval 'sub MPI_RAID_ACTION_CHANGE_PHYSDISK_SETTINGS () {(0xc);}' unless defined(&MPI_RAID_ACTION_CHANGE_PHYSDISK_SETTINGS);
    eval 'sub MPI_RAID_ACTION_CREATE_PHYSDISK () {(0xd);}' unless defined(&MPI_RAID_ACTION_CREATE_PHYSDISK);
    eval 'sub MPI_RAID_ACTION_DELETE_PHYSDISK () {(0xe);}' unless defined(&MPI_RAID_ACTION_DELETE_PHYSDISK);
    eval 'sub MPI_RAID_ACTION_FAIL_PHYSDISK () {(0xf);}' unless defined(&MPI_RAID_ACTION_FAIL_PHYSDISK);
    eval 'sub MPI_RAID_ACTION_REPLACE_PHYSDISK () {(0x10);}' unless defined(&MPI_RAID_ACTION_REPLACE_PHYSDISK);
    eval 'sub MPI_RAID_ACTION_ACTIVATE_VOLUME () {(0x11);}' unless defined(&MPI_RAID_ACTION_ACTIVATE_VOLUME);
    eval 'sub MPI_RAID_ACTION_INACTIVATE_VOLUME () {(0x12);}' unless defined(&MPI_RAID_ACTION_INACTIVATE_VOLUME);
    eval 'sub MPI_RAID_ACTION_SET_RESYNC_RATE () {(0x13);}' unless defined(&MPI_RAID_ACTION_SET_RESYNC_RATE);
    eval 'sub MPI_RAID_ACTION_SET_DATA_SCRUB_RATE () {(0x14);}' unless defined(&MPI_RAID_ACTION_SET_DATA_SCRUB_RATE);
    eval 'sub MPI_RAID_ACTION_DEVICE_FW_UPDATE_MODE () {(0x15);}' unless defined(&MPI_RAID_ACTION_DEVICE_FW_UPDATE_MODE);
    eval 'sub MPI_RAID_ACTION_SET_VOLUME_NAME () {(0x16);}' unless defined(&MPI_RAID_ACTION_SET_VOLUME_NAME);
    eval 'sub MPI_RAID_ACTION_ADATA_DO_NOT_SYNC () {(0x1);}' unless defined(&MPI_RAID_ACTION_ADATA_DO_NOT_SYNC);
    eval 'sub MPI_RAID_ACTION_ADATA_LOW_LEVEL_INIT () {(0x2);}' unless defined(&MPI_RAID_ACTION_ADATA_LOW_LEVEL_INIT);
    eval 'sub MPI_RAID_ACTION_ADATA_KEEP_PHYS_DISKS () {(0x);}' unless defined(&MPI_RAID_ACTION_ADATA_KEEP_PHYS_DISKS);
    eval 'sub MPI_RAID_ACTION_ADATA_DEL_PHYS_DISKS () {(0x1);}' unless defined(&MPI_RAID_ACTION_ADATA_DEL_PHYS_DISKS);
    eval 'sub MPI_RAID_ACTION_ADATA_KEEP_LBA0 () {(0x);}' unless defined(&MPI_RAID_ACTION_ADATA_KEEP_LBA0);
    eval 'sub MPI_RAID_ACTION_ADATA_ZERO_LBA0 () {(0x2);}' unless defined(&MPI_RAID_ACTION_ADATA_ZERO_LBA0);
    eval 'sub MPI_RAID_ACTION_ADATA_DISABLE_FULL_REBUILD () {(0x1);}' unless defined(&MPI_RAID_ACTION_ADATA_DISABLE_FULL_REBUILD);
    eval 'sub MPI_RAID_ACTION_ADATA_INACTIVATE_ALL () {(0x1);}' unless defined(&MPI_RAID_ACTION_ADATA_INACTIVATE_ALL);
    eval 'sub MPI_RAID_ACTION_ADATA_RESYNC_RATE_MASK () {(0xff);}' unless defined(&MPI_RAID_ACTION_ADATA_RESYNC_RATE_MASK);
    eval 'sub MPI_RAID_ACTION_ADATA_DATA_SCRUB_RATE_MASK () {(0xff);}' unless defined(&MPI_RAID_ACTION_ADATA_DATA_SCRUB_RATE_MASK);
    eval 'sub MPI_RAID_ACTION_ADATA_ENABLE_FW_UPDATE () {(0x1);}' unless defined(&MPI_RAID_ACTION_ADATA_ENABLE_FW_UPDATE);
    eval 'sub MPI_RAID_ACTION_ADATA_MASK_FW_UPDATE_TIMEOUT () {(0xff00);}' unless defined(&MPI_RAID_ACTION_ADATA_MASK_FW_UPDATE_TIMEOUT);
    eval 'sub MPI_RAID_ACTION_ADATA_SHIFT_FW_UPDATE_TIMEOUT () {(8);}' unless defined(&MPI_RAID_ACTION_ADATA_SHIFT_FW_UPDATE_TIMEOUT);
    eval 'sub MPI_RAID_ACTION_ASTATUS_SUCCESS () {(0x);}' unless defined(&MPI_RAID_ACTION_ASTATUS_SUCCESS);
    eval 'sub MPI_RAID_ACTION_ASTATUS_INVALID_ACTION () {(0x1);}' unless defined(&MPI_RAID_ACTION_ASTATUS_INVALID_ACTION);
    eval 'sub MPI_RAID_ACTION_ASTATUS_FAILURE () {(0x2);}' unless defined(&MPI_RAID_ACTION_ASTATUS_FAILURE);
    eval 'sub MPI_RAID_ACTION_ASTATUS_IN_PROGRESS () {(0x3);}' unless defined(&MPI_RAID_ACTION_ASTATUS_IN_PROGRESS);
}
1;
