require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MPI_TARG_H)) {
    eval 'sub MPI_TARG_H () {1;}' unless defined(&MPI_TARG_H);
    eval 'sub CMD_BUFFER_POST_FLAGS_PORT_MASK () {(0x1);}' unless defined(&CMD_BUFFER_POST_FLAGS_PORT_MASK);
    eval 'sub CMD_BUFFER_POST_FLAGS_ADDR_MODE_MASK () {(0x80);}' unless defined(&CMD_BUFFER_POST_FLAGS_ADDR_MODE_MASK);
    eval 'sub CMD_BUFFER_POST_FLAGS_ADDR_MODE_32 () {(0);}' unless defined(&CMD_BUFFER_POST_FLAGS_ADDR_MODE_32);
    eval 'sub CMD_BUFFER_POST_FLAGS_ADDR_MODE_64 () {(1);}' unless defined(&CMD_BUFFER_POST_FLAGS_ADDR_MODE_64);
    eval 'sub CMD_BUFFER_POST_FLAGS_64_BIT_ADDR () {(0x80);}' unless defined(&CMD_BUFFER_POST_FLAGS_64_BIT_ADDR);
    eval 'sub CMD_BUFFER_POST_IO_INDEX_MASK () {(0x3fff);}' unless defined(&CMD_BUFFER_POST_IO_INDEX_MASK);
    eval 'sub CMD_BUFFER_POST_IO_INDEX_MASK_0100 () {(0x3ff);}' unless defined(&CMD_BUFFER_POST_IO_INDEX_MASK_0100);
    eval 'sub PRIORITY_REASON_NO_DISCONNECT () {(0x);}' unless defined(&PRIORITY_REASON_NO_DISCONNECT);
    eval 'sub PRIORITY_REASON_SCSI_TASK_MANAGEMENT () {(0x1);}' unless defined(&PRIORITY_REASON_SCSI_TASK_MANAGEMENT);
    eval 'sub PRIORITY_REASON_CMD_PARITY_ERR () {(0x2);}' unless defined(&PRIORITY_REASON_CMD_PARITY_ERR);
    eval 'sub PRIORITY_REASON_MSG_OUT_PARITY_ERR () {(0x3);}' unless defined(&PRIORITY_REASON_MSG_OUT_PARITY_ERR);
    eval 'sub PRIORITY_REASON_LQ_CRC_ERR () {(0x4);}' unless defined(&PRIORITY_REASON_LQ_CRC_ERR);
    eval 'sub PRIORITY_REASON_CMD_CRC_ERR () {(0x5);}' unless defined(&PRIORITY_REASON_CMD_CRC_ERR);
    eval 'sub PRIORITY_REASON_PROTOCOL_ERR () {(0x6);}' unless defined(&PRIORITY_REASON_PROTOCOL_ERR);
    eval 'sub PRIORITY_REASON_DATA_OUT_PARITY_ERR () {(0x7);}' unless defined(&PRIORITY_REASON_DATA_OUT_PARITY_ERR);
    eval 'sub PRIORITY_REASON_DATA_OUT_CRC_ERR () {(0x8);}' unless defined(&PRIORITY_REASON_DATA_OUT_CRC_ERR);
    eval 'sub PRIORITY_REASON_TARGET_BUSY () {(0x9);}' unless defined(&PRIORITY_REASON_TARGET_BUSY);
    eval 'sub PRIORITY_REASON_UNKNOWN () {(0xff);}' unless defined(&PRIORITY_REASON_UNKNOWN);
    eval 'sub CMD_BUFFER_POST_BASE_FLAGS_AUTO_POST_ALL () {(0x1);}' unless defined(&CMD_BUFFER_POST_BASE_FLAGS_AUTO_POST_ALL);
    eval 'sub TARGET_ASSIST_FLAGS_DATA_DIRECTION () {(0x1);}' unless defined(&TARGET_ASSIST_FLAGS_DATA_DIRECTION);
    eval 'sub TARGET_ASSIST_FLAGS_AUTO_STATUS () {(0x2);}' unless defined(&TARGET_ASSIST_FLAGS_AUTO_STATUS);
    eval 'sub TARGET_ASSIST_FLAGS_HIGH_PRIORITY () {(0x4);}' unless defined(&TARGET_ASSIST_FLAGS_HIGH_PRIORITY);
    eval 'sub TARGET_ASSIST_FLAGS_CONFIRMED () {(0x8);}' unless defined(&TARGET_ASSIST_FLAGS_CONFIRMED);
    eval 'sub TARGET_ASSIST_FLAGS_REPOST_CMD_BUFFER () {(0x80);}' unless defined(&TARGET_ASSIST_FLAGS_REPOST_CMD_BUFFER);
    eval 'sub TARGET_ASSIST_EXT_MSGFLAGS_BIDIRECTIONAL () {(0x20);}' unless defined(&TARGET_ASSIST_EXT_MSGFLAGS_BIDIRECTIONAL);
    eval 'sub TARGET_ASSIST_EXT_MSGFLAGS_MULTICAST () {(0x10);}' unless defined(&TARGET_ASSIST_EXT_MSGFLAGS_MULTICAST);
    eval 'sub TARGET_ASSIST_EXT_MSGFLAGS_SGL_OFFSET_CHAINS () {(0x8);}' unless defined(&TARGET_ASSIST_EXT_MSGFLAGS_SGL_OFFSET_CHAINS);
    eval 'sub TARGET_ASSIST_EXT_EEDP_MASK_OP () {(0x7);}' unless defined(&TARGET_ASSIST_EXT_EEDP_MASK_OP);
    eval 'sub TARGET_ASSIST_EXT_EEDP_NOOP_OP () {(0x);}' unless defined(&TARGET_ASSIST_EXT_EEDP_NOOP_OP);
    eval 'sub TARGET_ASSIST_EXT_EEDP_CHK_OP () {(0x1);}' unless defined(&TARGET_ASSIST_EXT_EEDP_CHK_OP);
    eval 'sub TARGET_ASSIST_EXT_EEDP_STRIP_OP () {(0x2);}' unless defined(&TARGET_ASSIST_EXT_EEDP_STRIP_OP);
    eval 'sub TARGET_ASSIST_EXT_EEDP_CHKRM_OP () {(0x3);}' unless defined(&TARGET_ASSIST_EXT_EEDP_CHKRM_OP);
    eval 'sub TARGET_ASSIST_EXT_EEDP_INSERT_OP () {(0x4);}' unless defined(&TARGET_ASSIST_EXT_EEDP_INSERT_OP);
    eval 'sub TARGET_ASSIST_EXT_EEDP_REPLACE_OP () {(0x6);}' unless defined(&TARGET_ASSIST_EXT_EEDP_REPLACE_OP);
    eval 'sub TARGET_ASSIST_EXT_EEDP_CHKREGEN_OP () {(0x7);}' unless defined(&TARGET_ASSIST_EXT_EEDP_CHKREGEN_OP);
    eval 'sub TARGET_ASSIST_EXT_EEDP_PASS_REF_TAG () {(0x8);}' unless defined(&TARGET_ASSIST_EXT_EEDP_PASS_REF_TAG);
    eval 'sub TARGET_ASSIST_EXT_EEDP_T10_CHK_MASK () {(0x700);}' unless defined(&TARGET_ASSIST_EXT_EEDP_T10_CHK_MASK);
    eval 'sub TARGET_ASSIST_EXT_EEDP_T10_CHK_GUARD () {(0x100);}' unless defined(&TARGET_ASSIST_EXT_EEDP_T10_CHK_GUARD);
    eval 'sub TARGET_ASSIST_EXT_EEDP_T10_CHK_APPTAG () {(0x200);}' unless defined(&TARGET_ASSIST_EXT_EEDP_T10_CHK_APPTAG);
    eval 'sub TARGET_ASSIST_EXT_EEDP_T10_CHK_REFTAG () {(0x400);}' unless defined(&TARGET_ASSIST_EXT_EEDP_T10_CHK_REFTAG);
    eval 'sub TARGET_ASSIST_EXT_EEDP_T10_CHK_SHIFT () {(8);}' unless defined(&TARGET_ASSIST_EXT_EEDP_T10_CHK_SHIFT);
    eval 'sub TARGET_ASSIST_EXT_EEDP_INC_SEC_APPTAG () {(0x1000);}' unless defined(&TARGET_ASSIST_EXT_EEDP_INC_SEC_APPTAG);
    eval 'sub TARGET_ASSIST_EXT_EEDP_INC_PRI_APPTAG () {(0x2000);}' unless defined(&TARGET_ASSIST_EXT_EEDP_INC_PRI_APPTAG);
    eval 'sub TARGET_ASSIST_EXT_EEDP_INC_SEC_REFTAG () {(0x4000);}' unless defined(&TARGET_ASSIST_EXT_EEDP_INC_SEC_REFTAG);
    eval 'sub TARGET_ASSIST_EXT_EEDP_INC_PRI_REFTAG () {(0x8000);}' unless defined(&TARGET_ASSIST_EXT_EEDP_INC_PRI_REFTAG);
    eval 'sub TARGET_STATUS_SEND_FLAGS_AUTO_GOOD_STATUS () {(0x1);}' unless defined(&TARGET_STATUS_SEND_FLAGS_AUTO_GOOD_STATUS);
    eval 'sub TARGET_STATUS_SEND_FLAGS_HIGH_PRIORITY () {(0x4);}' unless defined(&TARGET_STATUS_SEND_FLAGS_HIGH_PRIORITY);
    eval 'sub TARGET_STATUS_SEND_FLAGS_CONFIRMED () {(0x8);}' unless defined(&TARGET_STATUS_SEND_FLAGS_CONFIRMED);
    eval 'sub TARGET_STATUS_SEND_FLAGS_REPOST_CMD_BUFFER () {(0x80);}' unless defined(&TARGET_STATUS_SEND_FLAGS_REPOST_CMD_BUFFER);
    eval 'sub TARGET_MODE_ABORT_TYPE_ALL_CMD_BUFFERS () {(0x);}' unless defined(&TARGET_MODE_ABORT_TYPE_ALL_CMD_BUFFERS);
    eval 'sub TARGET_MODE_ABORT_TYPE_ALL_IO () {(0x1);}' unless defined(&TARGET_MODE_ABORT_TYPE_ALL_IO);
    eval 'sub TARGET_MODE_ABORT_TYPE_EXACT_IO () {(0x2);}' unless defined(&TARGET_MODE_ABORT_TYPE_EXACT_IO);
    eval 'sub TARGET_MODE_ABORT_TYPE_EXACT_IO_REQUEST () {(0x3);}' unless defined(&TARGET_MODE_ABORT_TYPE_EXACT_IO_REQUEST);
    eval 'sub TARGET_MODE_REPLY_IO_INDEX_MASK () {(0x3fff);}' unless defined(&TARGET_MODE_REPLY_IO_INDEX_MASK);
    eval 'sub TARGET_MODE_REPLY_IO_INDEX_SHIFT () {(0);}' unless defined(&TARGET_MODE_REPLY_IO_INDEX_SHIFT);
    eval 'sub TARGET_MODE_REPLY_INITIATOR_INDEX_MASK () {(0x3ffc000);}' unless defined(&TARGET_MODE_REPLY_INITIATOR_INDEX_MASK);
    eval 'sub TARGET_MODE_REPLY_INITIATOR_INDEX_SHIFT () {(14);}' unless defined(&TARGET_MODE_REPLY_INITIATOR_INDEX_SHIFT);
    eval 'sub TARGET_MODE_REPLY_ALIAS_MASK () {(0x4000000);}' unless defined(&TARGET_MODE_REPLY_ALIAS_MASK);
    eval 'sub TARGET_MODE_REPLY_ALIAS_SHIFT () {(26);}' unless defined(&TARGET_MODE_REPLY_ALIAS_SHIFT);
    eval 'sub TARGET_MODE_REPLY_PORT_MASK () {(0x10000000);}' unless defined(&TARGET_MODE_REPLY_PORT_MASK);
    eval 'sub TARGET_MODE_REPLY_PORT_SHIFT () {(28);}' unless defined(&TARGET_MODE_REPLY_PORT_SHIFT);
    eval 'sub GET_IO_INDEX {
        my($x) = @_;
	    eval q(((($x) &  &TARGET_MODE_REPLY_IO_INDEX_MASK) >>  &TARGET_MODE_REPLY_IO_INDEX_SHIFT));
    }' unless defined(&GET_IO_INDEX);
    eval 'sub SET_IO_INDEX {
        my($t, $i) = @_;
	    eval q((($t) = (($t) & ~ &TARGET_MODE_REPLY_IO_INDEX_MASK) | ((($i) <<  &TARGET_MODE_REPLY_IO_INDEX_SHIFT) &  &TARGET_MODE_REPLY_IO_INDEX_MASK)));
    }' unless defined(&SET_IO_INDEX);
    eval 'sub GET_INITIATOR_INDEX {
        my($x) = @_;
	    eval q(((($x) &  &TARGET_MODE_REPLY_INITIATOR_INDEX_MASK) >>  &TARGET_MODE_REPLY_INITIATOR_INDEX_SHIFT));
    }' unless defined(&GET_INITIATOR_INDEX);
    eval 'sub SET_INITIATOR_INDEX {
        my($t, $ii) = @_;
	    eval q((($t) = (($t) & ~ &TARGET_MODE_REPLY_INITIATOR_INDEX_MASK) | ((($ii) <<  &TARGET_MODE_REPLY_INITIATOR_INDEX_SHIFT) &  &TARGET_MODE_REPLY_INITIATOR_INDEX_MASK)));
    }' unless defined(&SET_INITIATOR_INDEX);
    eval 'sub GET_ALIAS {
        my($x) = @_;
	    eval q(((($x) &  &TARGET_MODE_REPLY_ALIAS_MASK) >>  &TARGET_MODE_REPLY_ALIAS_SHIFT));
    }' unless defined(&GET_ALIAS);
    eval 'sub SET_ALIAS {
        my($t, $a) = @_;
	    eval q((($t) = (($t) & ~ &TARGET_MODE_REPLY_ALIAS_MASK) | ((($a) <<  &TARGET_MODE_REPLY_ALIAS_SHIFT) &  &TARGET_MODE_REPLY_ALIAS_MASK)));
    }' unless defined(&SET_ALIAS);
    eval 'sub GET_PORT {
        my($x) = @_;
	    eval q(((($x) &  &TARGET_MODE_REPLY_PORT_MASK) >>  &TARGET_MODE_REPLY_PORT_SHIFT));
    }' unless defined(&GET_PORT);
    eval 'sub SET_PORT {
        my($t, $p) = @_;
	    eval q((($t) = (($t) & ~ &TARGET_MODE_REPLY_PORT_MASK) | ((($p) <<  &TARGET_MODE_REPLY_PORT_SHIFT) &  &TARGET_MODE_REPLY_PORT_MASK)));
    }' unless defined(&SET_PORT);
    eval 'sub TARGET_MODE_REPLY_0100_MASK_HOST_INDEX () {(0x3ff);}' unless defined(&TARGET_MODE_REPLY_0100_MASK_HOST_INDEX);
    eval 'sub TARGET_MODE_REPLY_0100_SHIFT_HOST_INDEX () {(0);}' unless defined(&TARGET_MODE_REPLY_0100_SHIFT_HOST_INDEX);
    eval 'sub TARGET_MODE_REPLY_0100_MASK_IOC_INDEX () {(0x1ff800);}' unless defined(&TARGET_MODE_REPLY_0100_MASK_IOC_INDEX);
    eval 'sub TARGET_MODE_REPLY_0100_SHIFT_IOC_INDEX () {(11);}' unless defined(&TARGET_MODE_REPLY_0100_SHIFT_IOC_INDEX);
    eval 'sub TARGET_MODE_REPLY_0100_PORT_MASK () {(0x400000);}' unless defined(&TARGET_MODE_REPLY_0100_PORT_MASK);
    eval 'sub TARGET_MODE_REPLY_0100_PORT_SHIFT () {(22);}' unless defined(&TARGET_MODE_REPLY_0100_PORT_SHIFT);
    eval 'sub TARGET_MODE_REPLY_0100_MASK_INITIATOR_INDEX () {(0x1f800000);}' unless defined(&TARGET_MODE_REPLY_0100_MASK_INITIATOR_INDEX);
    eval 'sub TARGET_MODE_REPLY_0100_SHIFT_INITIATOR_INDEX () {(23);}' unless defined(&TARGET_MODE_REPLY_0100_SHIFT_INITIATOR_INDEX);
    eval 'sub GET_HOST_INDEX_0100 {
        my($x) = @_;
	    eval q(((($x) &  &TARGET_MODE_REPLY_0100_MASK_HOST_INDEX) >>  &TARGET_MODE_REPLY_0100_SHIFT_HOST_INDEX));
    }' unless defined(&GET_HOST_INDEX_0100);
    eval 'sub SET_HOST_INDEX_0100 {
        my($t, $hi) = @_;
	    eval q((($t) = (($t) & ~ &TARGET_MODE_REPLY_0100_MASK_HOST_INDEX) | ((($hi) <<  &TARGET_MODE_REPLY_0100_SHIFT_HOST_INDEX) &  &TARGET_MODE_REPLY_0100_MASK_HOST_INDEX)));
    }' unless defined(&SET_HOST_INDEX_0100);
    eval 'sub GET_IOC_INDEX_0100 {
        my($x) = @_;
	    eval q(((($x) &  &TARGET_MODE_REPLY_0100_MASK_IOC_INDEX) >>  &TARGET_MODE_REPLY_0100_SHIFT_IOC_INDEX));
    }' unless defined(&GET_IOC_INDEX_0100);
    eval 'sub SET_IOC_INDEX_0100 {
        my($t, $ii) = @_;
	    eval q((($t) = (($t) & ~ &TARGET_MODE_REPLY_0100_MASK_IOC_INDEX) | ((($ii) <<  &TARGET_MODE_REPLY_0100_SHIFT_IOC_INDEX) &  &TARGET_MODE_REPLY_0100_MASK_IOC_INDEX)));
    }' unless defined(&SET_IOC_INDEX_0100);
    eval 'sub GET_INITIATOR_INDEX_0100 {
        my($x) = @_;
	    eval q(((($x) &  &TARGET_MODE_REPLY_0100_MASK_INITIATOR_INDEX) >>  &TARGET_MODE_REPLY_0100_SHIFT_INITIATOR_INDEX));
    }' unless defined(&GET_INITIATOR_INDEX_0100);
    eval 'sub SET_INITIATOR_INDEX_0100 {
        my($t, $ii) = @_;
	    eval q((($t) = (($t) & ~ &TARGET_MODE_REPLY_0100_MASK_INITIATOR_INDEX) | ((($ii) <<  &TARGET_MODE_REPLY_0100_SHIFT_INITIATOR_INDEX) &  &TARGET_MODE_REPLY_0100_MASK_INITIATOR_INDEX)));
    }' unless defined(&SET_INITIATOR_INDEX_0100);
}
1;
