require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__PPB_MSQ_H)) {
    eval 'sub __PPB_MSQ_H () {1;}' unless defined(&__PPB_MSQ_H);
    eval 'sub MS_INS_MASK () {0xff;}' unless defined(&MS_INS_MASK);
    eval 'sub MS_ARG_MASK () {0xf00;}' unless defined(&MS_ARG_MASK);
    eval 'sub MS_TYP_MASK () {0xf000;}' unless defined(&MS_TYP_MASK);
    eval 'sub MS_INS_OFFSET () {0;}' unless defined(&MS_INS_OFFSET);
    eval 'sub MS_ARG_OFFSET () {8;}' unless defined(&MS_ARG_OFFSET);
    eval 'sub MS_TYP_OFFSET () {12;}' unless defined(&MS_TYP_OFFSET);
    eval 'sub MS_TYP_INT () {0x;}' unless defined(&MS_TYP_INT);
    eval 'sub MS_TYP_CHA () {0x1;}' unless defined(&MS_TYP_CHA);
    eval 'sub MS_TYP_PTR () {0x2;}' unless defined(&MS_TYP_PTR);
    eval 'sub MS_TYP_FUN () {0x3;}' unless defined(&MS_TYP_FUN);
    eval 'sub MS_PARAM {
        my($ins,$arg,$typ) = @_;
	    eval q(((($ins<< &MS_INS_OFFSET) &  &MS_INS_MASK) | (($arg<< &MS_ARG_OFFSET) &  &MS_ARG_MASK) | (($typ<< &MS_TYP_OFFSET) &  &MS_TYP_MASK)));
    }' unless defined(&MS_PARAM);
    eval 'sub MS_INS {
        my($param) = @_;
	    eval q((($param &  &MS_INS_MASK) >>  &MS_INS_OFFSET));
    }' unless defined(&MS_INS);
    eval 'sub MS_ARG {
        my($param) = @_;
	    eval q((($param &  &MS_ARG_MASK) >>  &MS_ARG_OFFSET));
    }' unless defined(&MS_ARG);
    eval 'sub MS_TYP {
        my($param) = @_;
	    eval q((($param &  &MS_TYP_MASK) >>  &MS_TYP_OFFSET));
    }' unless defined(&MS_TYP);
    eval 'sub MS_OP_GET () {0;}' unless defined(&MS_OP_GET);
    eval 'sub MS_OP_PUT () {1;}' unless defined(&MS_OP_PUT);
    eval 'sub MS_OP_RFETCH () {2;}' unless defined(&MS_OP_RFETCH);
    eval 'sub MS_OP_RSET () {3;}' unless defined(&MS_OP_RSET);
    eval 'sub MS_OP_RASSERT () {4;}' unless defined(&MS_OP_RASSERT);
    eval 'sub MS_OP_DELAY () {5;}' unless defined(&MS_OP_DELAY);
    eval 'sub MS_OP_SET () {6;}' unless defined(&MS_OP_SET);
    eval 'sub MS_OP_DBRA () {7;}' unless defined(&MS_OP_DBRA);
    eval 'sub MS_OP_BRSET () {8;}' unless defined(&MS_OP_BRSET);
    eval 'sub MS_OP_BRCLEAR () {9;}' unless defined(&MS_OP_BRCLEAR);
    eval 'sub MS_OP_RET () {10;}' unless defined(&MS_OP_RET);
    eval 'sub MS_OP_C_CALL () {11;}' unless defined(&MS_OP_C_CALL);
    eval 'sub MS_OP_PTR () {12;}' unless defined(&MS_OP_PTR);
    eval 'sub MS_OP_ADELAY () {13;}' unless defined(&MS_OP_ADELAY);
    eval 'sub MS_OP_BRSTAT () {14;}' unless defined(&MS_OP_BRSTAT);
    eval 'sub MS_OP_SUBRET () {15;}' unless defined(&MS_OP_SUBRET);
    eval 'sub MS_OP_CALL () {16;}' unless defined(&MS_OP_CALL);
    eval 'sub MS_OP_RASSERT_P () {17;}' unless defined(&MS_OP_RASSERT_P);
    eval 'sub MS_OP_RFETCH_P () {18;}' unless defined(&MS_OP_RFETCH_P);
    eval 'sub MS_OP_TRIG () {19;}' unless defined(&MS_OP_TRIG);
    eval 'sub MS_CLEAR_ALL () {0x;}' unless defined(&MS_CLEAR_ALL);
    eval 'sub MS_ASSERT_NONE () {0x;}' unless defined(&MS_ASSERT_NONE);
    eval 'sub MS_ASSERT_ALL () {0xff;}' unless defined(&MS_ASSERT_ALL);
    eval 'sub MS_FETCH_ALL () {0xff;}' unless defined(&MS_FETCH_ALL);
    eval 'sub MS_NULL () {0;}' unless defined(&MS_NULL);
    eval 'sub MS_UNKNOWN () { &MS_NULL;}' unless defined(&MS_UNKNOWN);
    eval 'sub MS_ACCUM () {-1;}' unless defined(&MS_ACCUM);
    eval 'sub MS_REG_DTR () {0x;}' unless defined(&MS_REG_DTR);
    eval 'sub MS_REG_STR () {0x1;}' unless defined(&MS_REG_STR);
    eval 'sub MS_REG_CTR () {0x2;}' unless defined(&MS_REG_CTR);
    eval 'sub MS_REG_EPP_A () {0x3;}' unless defined(&MS_REG_EPP_A);
    eval 'sub MS_REG_EPP_D () {0x4;}' unless defined(&MS_REG_EPP_D);
    eval 'sub MS_RSET {
        my($reg,$assert,$clear) = @_;
	    eval q({  &MS_OP_RSET, {{ ($reg) }, { ($assert) }, { ($clear) }}});
    }' unless defined(&MS_RSET);
    eval 'sub MS_RASSERT {
        my($reg,$byte) = @_;
	    eval q({  &MS_OP_RASSERT, { { ($reg) }, { ($byte) }}});
    }' unless defined(&MS_RASSERT);
    eval 'sub MS_RCLR {
        my($reg,$clear) = @_;
	    eval q({  &MS_OP_RSET, {{ ($reg) }, {  &MS_ASSERT_NONE }, { ($clear) }}});
    }' unless defined(&MS_RCLR);
    eval 'sub MS_RFETCH {
        my($reg,$mask,$ptr) = @_;
	    eval q({  &MS_OP_RFETCH, {{ ($reg) }, { ($mask) }, { ($ptr) }}});
    }' unless defined(&MS_RFETCH);
    eval 'sub MS_TRIG {
        my($reg,$len,$array) = @_;
	    eval q({  &MS_OP_TRIG, {{ ($reg) }, { ($len) }, { ($array) }}});
    }' unless defined(&MS_TRIG);
    eval 'sub MS_RASSERT_P {
        my($n,$reg) = @_;
	    eval q({  &MS_OP_RASSERT_P, {{ ($n) }, { ($reg) }}});
    }' unless defined(&MS_RASSERT_P);
    eval 'sub MS_RFETCH_P {
        my($n,$reg,$mask) = @_;
	    eval q({  &MS_OP_RFETCH_P, {{ ($n) }, { ($reg) }, { ($mask) }}});
    }' unless defined(&MS_RFETCH_P);
    eval 'sub MS_PTR {
        my($ptr) = @_;
	    eval q({  &MS_OP_PTR, {{ ($ptr) }}});
    }' unless defined(&MS_PTR);
    eval 'sub MS_DASS {
        my($byte) = @_;
	    eval q( &MS_RASSERT( &MS_REG_DTR,$byte));
    }' unless defined(&MS_DASS);
    eval 'sub MS_SASS {
        my($byte) = @_;
	    eval q( &MS_RASSERT( &MS_REG_STR,$byte));
    }' unless defined(&MS_SASS);
    eval 'sub MS_CASS {
        my($byte) = @_;
	    eval q( &MS_RASSERT( &MS_REG_CTR,$byte));
    }' unless defined(&MS_CASS);
    eval 'sub MS_SET {
        my($accum) = @_;
	    eval q({  &MS_OP_SET, {{ ($accum) }}});
    }' unless defined(&MS_SET);
    eval 'sub MS_BRSET {
        my($mask,$offset) = @_;
	    eval q({  &MS_OP_BRSET, {{ ($mask) }, { ($offset) }}});
    }' unless defined(&MS_BRSET);
    eval 'sub MS_DBRA {
        my($offset) = @_;
	    eval q({  &MS_OP_DBRA, {{ ($offset) }}});
    }' unless defined(&MS_DBRA);
    eval 'sub MS_BRCLEAR {
        my($mask,$offset) = @_;
	    eval q({  &MS_OP_BRCLEAR, {{ ($mask) }, { ($offset) }}});
    }' unless defined(&MS_BRCLEAR);
    eval 'sub MS_BRSTAT {
        my($mask_set,$mask_clr,$offset) = @_;
	    eval q({  &MS_OP_BRSTAT, {{ $mask_set }, { $mask_clr }, { ($offset) }}});
    }' unless defined(&MS_BRSTAT);
    eval 'sub MS_C_CALL {
        my($function,$parameter) = @_;
	    eval q({  &MS_OP_C_CALL, {{ ($function) }, { ($parameter) }}});
    }' unless defined(&MS_C_CALL);
    eval 'sub MS_CALL {
        my($microseq) = @_;
	    eval q({  &MS_OP_CALL, {{ ($microseq) }}});
    }' unless defined(&MS_CALL);
    eval 'sub MS_PUT {
        my($ptr,$len) = @_;
	    eval q({  &MS_OP_PUT, {{ ($ptr) }, { ($len) }}});
    }' unless defined(&MS_PUT);
    eval 'sub MS_GET {
        my($ptr,$len) = @_;
	    eval q({  &MS_OP_GET, {{ ($ptr) }, { ($len) }}});
    }' unless defined(&MS_GET);
    eval 'sub MS_DELAY {
        my($udelay) = @_;
	    eval q({  &MS_OP_DELAY, {{ ($udelay) }}});
    }' unless defined(&MS_DELAY);
    eval 'sub MS_ADELAY {
        my($mdelay) = @_;
	    eval q({  &MS_OP_ADELAY, {{ ($mdelay) }}});
    }' unless defined(&MS_ADELAY);
    eval 'sub MS_SUBRET {
        my($code) = @_;
	    eval q({  &MS_OP_SUBRET, {{ ($code) }}});
    }' unless defined(&MS_SUBRET);
    eval 'sub MS_RET {
        my($code) = @_;
	    eval q({  &MS_OP_RET, {{ ($code) }}});
    }' unless defined(&MS_RET);
    eval 'sub ppb_MS_GET_init {
        my($bus,$dev,$body) = @_;
	    eval q( &ppb_MS_init($bus, $dev, $body,  &MS_OP_GET));
    }' unless defined(&ppb_MS_GET_init);
    eval 'sub ppb_MS_PUT_init {
        my($bus,$dev,$body) = @_;
	    eval q( &ppb_MS_init($bus, $dev, $body,  &MS_OP_PUT));
    }' unless defined(&ppb_MS_PUT_init);
}
1;
