require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__DEV_SMBUS_SMBCONF_H)) {
    eval 'sub __DEV_SMBUS_SMBCONF_H () {1;}' unless defined(&__DEV_SMBUS_SMBCONF_H);
    require 'sys/queue.ph';
    eval 'sub SMBPRI () {( &PZERO+8);}' unless defined(&SMBPRI);
    eval 'sub n {
        my($flags) = @_;
	    eval q((~($flags) & ($flags)));
    }' unless defined(&n);
    eval 'sub SMBUS_ORDER_HINTED () {20;}' unless defined(&SMBUS_ORDER_HINTED);
    eval 'sub SMBUS_ORDER_PNP () {40;}' unless defined(&SMBUS_ORDER_PNP);
    eval 'sub SMB_DONTWAIT () {0;}' unless defined(&SMB_DONTWAIT);
    eval 'sub SMB_NOINTR () {0;}' unless defined(&SMB_NOINTR);
    eval 'sub SMB_WAIT () {0x1;}' unless defined(&SMB_WAIT);
    eval 'sub SMB_INTR () {0x2;}' unless defined(&SMB_INTR);
    eval 'sub SMB_REQUEST_BUS () {0x1;}' unless defined(&SMB_REQUEST_BUS);
    eval 'sub SMB_RELEASE_BUS () {0x2;}' unless defined(&SMB_RELEASE_BUS);
    eval 'sub SMB_ENOERR () {0x;}' unless defined(&SMB_ENOERR);
    eval 'sub SMB_EBUSERR () {0x1;}' unless defined(&SMB_EBUSERR);
    eval 'sub SMB_ENOTSUPP () {0x2;}' unless defined(&SMB_ENOTSUPP);
    eval 'sub SMB_ENOACK () {0x4;}' unless defined(&SMB_ENOACK);
    eval 'sub SMB_ECOLLI () {0x8;}' unless defined(&SMB_ECOLLI);
    eval 'sub SMB_EABORT () {0x10;}' unless defined(&SMB_EABORT);
    eval 'sub SMB_ETIMEOUT () {0x20;}' unless defined(&SMB_ETIMEOUT);
    eval 'sub SMB_EBUSY () {0x40;}' unless defined(&SMB_EBUSY);
    eval 'sub SMB_EINVAL () {0x100;}' unless defined(&SMB_EINVAL);
    eval 'sub SMB_QWRITE () {0x;}' unless defined(&SMB_QWRITE);
    eval 'sub SMB_QREAD () {0x1;}' unless defined(&SMB_QREAD);
    eval("sub SMBUS_IVAR_ADDR () { 0; }") unless defined(&SMBUS_IVAR_ADDR);
    eval 'sub SMBUS_ACCESSOR {
        my($var, $ivar, $type) = @_;
	    eval q( &__BUS_ACCESSOR( &smbus, $var,  &SMBUS, $ivar, $type));
    }' unless defined(&SMBUS_ACCESSOR);
    undef(&SMBUS_ACCESSOR) if defined(&SMBUS_ACCESSOR);
    eval 'sub smbus_quick {
        my($bus,$slave,$how) = @_;
	    eval q(( &SMBUS_QUICK( &device_get_parent($bus), $slave, $how)));
    }' unless defined(&smbus_quick);
    eval 'sub smbus_sendb {
        my($bus,$slave,$byte) = @_;
	    eval q(( &SMBUS_SENDB( &device_get_parent($bus), $slave, $byte)));
    }' unless defined(&smbus_sendb);
    eval 'sub smbus_recvb {
        my($bus,$slave,$byte) = @_;
	    eval q(( &SMBUS_RECVB( &device_get_parent($bus), $slave, $byte)));
    }' unless defined(&smbus_recvb);
    eval 'sub smbus_writeb {
        my($bus,$slave,$cmd,$byte) = @_;
	    eval q(( &SMBUS_WRITEB( &device_get_parent($bus), $slave, $cmd, $byte)));
    }' unless defined(&smbus_writeb);
    eval 'sub smbus_writew {
        my($bus,$slave,$cmd,$word) = @_;
	    eval q(( &SMBUS_WRITEW( &device_get_parent($bus), $slave, $cmd, $word)));
    }' unless defined(&smbus_writew);
    eval 'sub smbus_readb {
        my($bus,$slave,$cmd,$byte) = @_;
	    eval q(( &SMBUS_READB( &device_get_parent($bus), $slave, $cmd, $byte)));
    }' unless defined(&smbus_readb);
    eval 'sub smbus_readw {
        my($bus,$slave,$cmd,$word) = @_;
	    eval q(( &SMBUS_READW( &device_get_parent($bus), $slave, $cmd, $word)));
    }' unless defined(&smbus_readw);
    eval 'sub smbus_pcall {
        my($bus,$slave,$cmd,$sdata,$rdata) = @_;
	    eval q(( &SMBUS_PCALL( &device_get_parent($bus), $slave, $cmd, $sdata, $rdata)));
    }' unless defined(&smbus_pcall);
    eval 'sub smbus_bwrite {
        my($bus,$slave,$cmd,$count,$buf) = @_;
	    eval q(( &SMBUS_BWRITE( &device_get_parent($bus), $slave, $cmd, $count, $buf)));
    }' unless defined(&smbus_bwrite);
    eval 'sub smbus_bread {
        my($bus,$slave,$cmd,$count,$buf) = @_;
	    eval q(( &SMBUS_BREAD( &device_get_parent($bus), $slave, $cmd, $count, $buf)));
    }' unless defined(&smbus_bread);
    eval 'sub smbus_trans {
        my($bus,$slave,$cmd,$op,$wbuf,$wcount,$rbuf,$rcount,$actualp) = @_;
	    eval q(( &SMBUS_TRANS( &device_get_parent($bus), $slave, $cmd, $op, $wbuf, $wcount, $rbuf, $rcount, $actualp)));
    }' unless defined(&smbus_trans);
    eval 'sub SMBUS_MODVER () {1;}' unless defined(&SMBUS_MODVER);
    eval 'sub SMBUS_MINVER () {1;}' unless defined(&SMBUS_MINVER);
    eval 'sub SMBUS_MAXVER () {1;}' unless defined(&SMBUS_MAXVER);
    eval 'sub SMBUS_PREFVER () { &SMBUS_MODVER;}' unless defined(&SMBUS_PREFVER);
}
1;
