require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_USB_CORE_H_)) {
    eval 'sub _USB_CORE_H_ () {1;}' unless defined(&_USB_CORE_H_);
    eval 'sub USB_GET_DATA_ISREAD {
        my($xfer) = @_;
	    eval q((($xfer)-> ($flags_int->{usb_mode}) ==  &USB_MODE_DEVICE ? ((($xfer)-> &endpointno &  &UE_DIR_IN) ? 0: 1) : ((($xfer)-> &endpointno &  &UE_DIR_IN) ? 1: 0)));
    }' unless defined(&USB_GET_DATA_ISREAD);
    eval 'sub USB_BUS_LOCK {
        my($_b) = @_;
	    eval q( &mtx_lock(($_b)-> &bus_mtx));
    }' unless defined(&USB_BUS_LOCK);
    eval 'sub USB_BUS_UNLOCK {
        my($_b) = @_;
	    eval q( &mtx_unlock(($_b)-> &bus_mtx));
    }' unless defined(&USB_BUS_UNLOCK);
    eval 'sub USB_BUS_LOCK_ASSERT {
        my($_b, $_t) = @_;
	    eval q( &mtx_assert(($_b)-> &bus_mtx, $_t));
    }' unless defined(&USB_BUS_LOCK_ASSERT);
    eval 'sub USB_BUS_SPIN_LOCK {
        my($_b) = @_;
	    eval q( &mtx_lock_spin(($_b)-> &bus_spin_lock));
    }' unless defined(&USB_BUS_SPIN_LOCK);
    eval 'sub USB_BUS_SPIN_UNLOCK {
        my($_b) = @_;
	    eval q( &mtx_unlock_spin(($_b)-> &bus_spin_lock));
    }' unless defined(&USB_BUS_SPIN_UNLOCK);
    eval 'sub USB_BUS_SPIN_LOCK_ASSERT {
        my($_b, $_t) = @_;
	    eval q( &mtx_assert(($_b)-> &bus_spin_lock, $_t));
    }' unless defined(&USB_BUS_SPIN_LOCK_ASSERT);
    eval 'sub USB_XFER_LOCK {
        my($_x) = @_;
	    eval q( &mtx_lock(($_x)-> ($xroot->{xfer_mtx})));
    }' unless defined(&USB_XFER_LOCK);
    eval 'sub USB_XFER_UNLOCK {
        my($_x) = @_;
	    eval q( &mtx_unlock(($_x)-> ($xroot->{xfer_mtx})));
    }' unless defined(&USB_XFER_UNLOCK);
    eval 'sub USB_XFER_LOCK_ASSERT {
        my($_x, $_t) = @_;
	    eval q( &mtx_assert(($_x)-> ($xroot->{xfer_mtx}), $_t));
    }' unless defined(&USB_XFER_LOCK_ASSERT);
    eval 'sub USB_P2U {
        my($ptr) = @_;
	    eval q(((( &const  &uint8_t *)($ptr)) - (( &const  &uint8_t *)0)));
    }' unless defined(&USB_P2U);
    eval 'sub USB_ADD_BYTES {
        my($ptr,$size) = @_;
	    eval q((( &void *)( &USB_P2U($ptr) + ($size))));
    }' unless defined(&USB_ADD_BYTES);
    eval 'sub USB_ASSERT () { &KASSERT;}' unless defined(&USB_ASSERT);
    if((defined(&USB_HAVE_BUSDMA) ? &USB_HAVE_BUSDMA : undef)) {
    }
}
1;
