require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_USB_FREEBSD_H_)) {
    eval 'sub _USB_FREEBSD_H_ () {1;}' unless defined(&_USB_FREEBSD_H_);
    eval 'sub USB_HAVE_UGEN () {1;}' unless defined(&USB_HAVE_UGEN);
    eval 'sub USB_HAVE_DEVCTL () {1;}' unless defined(&USB_HAVE_DEVCTL);
    eval 'sub USB_HAVE_BUSDMA () {1;}' unless defined(&USB_HAVE_BUSDMA);
    eval 'sub USB_HAVE_COMPAT_LINUX () {1;}' unless defined(&USB_HAVE_COMPAT_LINUX);
    eval 'sub USB_HAVE_USER_IO () {1;}' unless defined(&USB_HAVE_USER_IO);
    eval 'sub USB_HAVE_MBUF () {1;}' unless defined(&USB_HAVE_MBUF);
    eval 'sub USB_HAVE_TT_SUPPORT () {1;}' unless defined(&USB_HAVE_TT_SUPPORT);
    eval 'sub USB_HAVE_POWERD () {1;}' unless defined(&USB_HAVE_POWERD);
    eval 'sub USB_HAVE_MSCTEST () {1;}' unless defined(&USB_HAVE_MSCTEST);
    eval 'sub USB_HAVE_MSCTEST_DETACH () {1;}' unless defined(&USB_HAVE_MSCTEST_DETACH);
    eval 'sub USB_HAVE_PF () {1;}' unless defined(&USB_HAVE_PF);
    eval 'sub USB_HAVE_ROOT_MOUNT_HOLD () {1;}' unless defined(&USB_HAVE_ROOT_MOUNT_HOLD);
    eval 'sub USB_HAVE_ID_SECTION () {1;}' unless defined(&USB_HAVE_ID_SECTION);
    eval 'sub USB_HAVE_PER_BUS_PROCESS () {1;}' unless defined(&USB_HAVE_PER_BUS_PROCESS);
    eval 'sub USB_HAVE_FIXED_ENDPOINT () {0;}' unless defined(&USB_HAVE_FIXED_ENDPOINT);
    eval 'sub USB_HAVE_FIXED_IFACE () {0;}' unless defined(&USB_HAVE_FIXED_IFACE);
    eval 'sub USB_HAVE_FIXED_CONFIG () {0;}' unless defined(&USB_HAVE_FIXED_CONFIG);
    eval 'sub USB_HAVE_FIXED_PORT () {0;}' unless defined(&USB_HAVE_FIXED_PORT);
    eval 'sub USB_HAVE_DISABLE_ENUM () {1;}' unless defined(&USB_HAVE_DISABLE_ENUM);
    eval 'sub USB_CALLOUT_ZERO_TICKS () {1;}' unless defined(&USB_CALLOUT_ZERO_TICKS);
    eval 'sub USB_TD_GET_PROC {
        my($td) = @_;
	    eval q(($td)-> &td_proc);
    }' unless defined(&USB_TD_GET_PROC);
    eval 'sub USB_PROC_GET_GID {
        my($td) = @_;
	    eval q(($td)-> &p_pgid);
    }' unless defined(&USB_PROC_GET_GID);
    if((!defined(&USB_HOST_ALIGN)) || ((defined(&USB_HOST_ALIGN) ? &USB_HOST_ALIGN : undef) <= 0)) {
	undef(&USB_HOST_ALIGN) if defined(&USB_HOST_ALIGN);
	if(defined(&__arm__) || defined(&__mips__) || defined(&__powerpc__)) {
	    eval 'sub USB_HOST_ALIGN () {32;}' unless defined(&USB_HOST_ALIGN);
	} else {
	    eval 'sub USB_HOST_ALIGN () {8;}' unless defined(&USB_HOST_ALIGN);
	}
    }
    if(((-(defined(&USB_HOST_ALIGN) ? &USB_HOST_ALIGN : undef)) & (defined(&USB_HOST_ALIGN) ? &USB_HOST_ALIGN : undef)) != (defined(&USB_HOST_ALIGN) ? &USB_HOST_ALIGN : undef)) {
	die("USB_HOST_ALIGN is not power of two.");
    }
    eval 'sub USB_FS_ISOC_UFRAME_MAX () {4;}' unless defined(&USB_FS_ISOC_UFRAME_MAX);
    eval 'sub USB_BUS_MAX () {256;}' unless defined(&USB_BUS_MAX);
    eval 'sub USB_MAX_DEVICES () {128;}' unless defined(&USB_MAX_DEVICES);
    eval 'sub USB_CONFIG_MAX () {65535;}' unless defined(&USB_CONFIG_MAX);
    eval 'sub USB_IFACE_MAX () {32;}' unless defined(&USB_IFACE_MAX);
    eval 'sub USB_FIFO_MAX () {128;}' unless defined(&USB_FIFO_MAX);
    eval 'sub USB_MAX_EP_STREAMS () {8;}' unless defined(&USB_MAX_EP_STREAMS);
    eval 'sub USB_MAX_EP_UNITS () {32;}' unless defined(&USB_MAX_EP_UNITS);
    eval 'sub USB_MAX_PORTS () {255;}' unless defined(&USB_MAX_PORTS);
    eval 'sub USB_MAX_FS_ISOC_FRAMES_PER_XFER () {(120);}' unless defined(&USB_MAX_FS_ISOC_FRAMES_PER_XFER);
    eval 'sub USB_MAX_HS_ISOC_FRAMES_PER_XFER () {(8*120);}' unless defined(&USB_MAX_HS_ISOC_FRAMES_PER_XFER);
    eval 'sub USB_HUB_MAX_DEPTH () {5;}' unless defined(&USB_HUB_MAX_DEPTH);
    eval 'sub USB_EP0_BUFSIZE () {1024;}' unless defined(&USB_EP0_BUFSIZE);
    eval 'sub USB_CS_RESET_LIMIT () {20;}' unless defined(&USB_CS_RESET_LIMIT);
    eval 'sub USB_MAX_AUTO_QUIRK () {8;}' unless defined(&USB_MAX_AUTO_QUIRK);
}
1;
