require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_USB_IOCTL_H_)) {
    eval 'sub _USB_IOCTL_H_ () {1;}' unless defined(&_USB_IOCTL_H_);
    unless(defined(&USB_GLOBAL_INCLUDE_FILE)) {
	require 'sys/ioccom.ph';
	require 'sys/cdefs.ph';
	require 'dev/usb/usb_endian.ph';
	require 'dev/usb/usb.ph';
    }
    eval 'sub USB_DEVICE_NAME () {"usbctl";}' unless defined(&USB_DEVICE_NAME);
    eval 'sub USB_DEVICE_DIR () {"usb";}' unless defined(&USB_DEVICE_DIR);
    eval 'sub USB_GENERIC_NAME () {"ugen";}' unless defined(&USB_GENERIC_NAME);
    eval 'sub USB_TEMPLATE_SYSCTL () {"hw.usb.template";}' unless defined(&USB_TEMPLATE_SYSCTL);
    if(defined(&COMPAT_32BIT)) {
	eval 'sub USB_IOCTL_STRUCT_ALIGN {
	    my($n) = @_;
    	    eval q( &__aligned($n));
	}' unless defined(&USB_IOCTL_STRUCT_ALIGN);
    } else {
	eval 'sub USB_IOCTL_STRUCT_ALIGN {
	    my($n) = @_;
    	    eval q();
	}' unless defined(&USB_IOCTL_STRUCT_ALIGN);
    }
    eval("sub USB_TEMP_MSC () { 0; }") unless defined(&USB_TEMP_MSC);
    eval("sub USB_TEMP_CDCE () { 1; }") unless defined(&USB_TEMP_CDCE);
    eval("sub USB_TEMP_MTP () { 2; }") unless defined(&USB_TEMP_MTP);
    eval("sub USB_TEMP_MODEM () { 3; }") unless defined(&USB_TEMP_MODEM);
    eval("sub USB_TEMP_AUDIO () { 4; }") unless defined(&USB_TEMP_AUDIO);
    eval("sub USB_TEMP_KBD () { 5; }") unless defined(&USB_TEMP_KBD);
    eval("sub USB_TEMP_MOUSE () { 6; }") unless defined(&USB_TEMP_MOUSE);
    eval("sub USB_TEMP_PHONE () { 7; }") unless defined(&USB_TEMP_PHONE);
    eval("sub USB_TEMP_SERIALNET () { 8; }") unless defined(&USB_TEMP_SERIALNET);
    eval("sub USB_TEMP_MIDI () { 9; }") unless defined(&USB_TEMP_MIDI);
    eval("sub USB_TEMP_MAX () { 10; }") unless defined(&USB_TEMP_MAX);
    if(defined(&COMPAT_32BIT)) {
    } else {
    }
    if(defined(&COMPAT_32BIT)) {
    } else {
    }
    if(defined(&COMPAT_32BIT)) {
    } else {
    }
    eval 'sub USB_DEVICE_PORT_PATH_MAX () {32;}' unless defined(&USB_DEVICE_PORT_PATH_MAX);
    if(defined(&COMPAT_32BIT)) {
    } else {
    }
    eval 'sub USB_FS_FLAG_SINGLE_SHORT_OK () {0x1;}' unless defined(&USB_FS_FLAG_SINGLE_SHORT_OK);
    eval 'sub USB_FS_FLAG_MULTI_SHORT_OK () {0x2;}' unless defined(&USB_FS_FLAG_MULTI_SHORT_OK);
    eval 'sub USB_FS_FLAG_FORCE_SHORT () {0x4;}' unless defined(&USB_FS_FLAG_FORCE_SHORT);
    eval 'sub USB_FS_FLAG_CLEAR_STALL () {0x8;}' unless defined(&USB_FS_FLAG_CLEAR_STALL);
    eval 'sub USB_FS_TIMEOUT_NONE () {0;}' unless defined(&USB_FS_TIMEOUT_NONE);
    if(defined(&COMPAT_32BIT)) {
    } else {
    }
    eval 'sub USB_FS_MAX_BUFSIZE () {(1<< 18);}' unless defined(&USB_FS_MAX_BUFSIZE);
    eval 'sub USB_FS_MAX_FRAMES () {(1 << 12);}' unless defined(&USB_FS_MAX_FRAMES);
    eval 'sub USB_FS_MAX_FRAMES_PRE_SCALE () {(1 << 31);}' unless defined(&USB_FS_MAX_FRAMES_PRE_SCALE);
    eval 'sub USB_REQUEST () { &_IOWR(ord(\'U\'), 1, \'struct usb_ctl_request\');}' unless defined(&USB_REQUEST);
    eval 'sub USB_SETDEBUG () { &_IOW (ord(\'U\'), 2, \'int\');}' unless defined(&USB_SETDEBUG);
    eval 'sub USB_DISCOVER () { &_IO (ord(\'U\'), 3);}' unless defined(&USB_DISCOVER);
    eval 'sub USB_DEVICEINFO () { &_IOWR(ord(\'U\'), 4, \'struct usb_device_info\');}' unless defined(&USB_DEVICEINFO);
    eval 'sub USB_DEVICESTATS () { &_IOR (ord(\'U\'), 5, \'struct usb_device_stats\');}' unless defined(&USB_DEVICESTATS);
    eval 'sub USB_DEVICEENUMERATE () { &_IOW (ord(\'U\'), 6, \'int\');}' unless defined(&USB_DEVICEENUMERATE);
    eval 'sub USB_GET_REPORT_DESC () { &_IOWR(ord(\'U\'), 21, \'struct usb_gen_descriptor\');}' unless defined(&USB_GET_REPORT_DESC);
    eval 'sub USB_SET_IMMED () { &_IOW (ord(\'U\'), 22, \'int\');}' unless defined(&USB_SET_IMMED);
    eval 'sub USB_GET_REPORT () { &_IOWR(ord(\'U\'), 23, \'struct usb_gen_descriptor\');}' unless defined(&USB_GET_REPORT);
    eval 'sub USB_SET_REPORT () { &_IOW (ord(\'U\'), 24, \'struct usb_gen_descriptor\');}' unless defined(&USB_SET_REPORT);
    eval 'sub USB_GET_REPORT_ID () { &_IOR (ord(\'U\'), 25, \'int\');}' unless defined(&USB_GET_REPORT_ID);
    eval 'sub USB_GET_CONFIG () { &_IOR (ord(\'U\'), 100, \'int\');}' unless defined(&USB_GET_CONFIG);
    eval 'sub USB_SET_CONFIG () { &_IOW (ord(\'U\'), 101, \'int\');}' unless defined(&USB_SET_CONFIG);
    eval 'sub USB_GET_ALTINTERFACE () { &_IOWR(ord(\'U\'), 102, \'struct usb_alt_interface\');}' unless defined(&USB_GET_ALTINTERFACE);
    eval 'sub USB_SET_ALTINTERFACE () { &_IOWR(ord(\'U\'), 103, \'struct usb_alt_interface\');}' unless defined(&USB_SET_ALTINTERFACE);
    eval 'sub USB_GET_DEVICE_DESC () { &_IOR (ord(\'U\'), 105, \'struct usb_device_descriptor\');}' unless defined(&USB_GET_DEVICE_DESC);
    eval 'sub USB_GET_CONFIG_DESC () { &_IOR (ord(\'U\'), 106, \'struct usb_config_descriptor\');}' unless defined(&USB_GET_CONFIG_DESC);
    eval 'sub USB_GET_RX_INTERFACE_DESC () { &_IOR (ord(\'U\'), 107, \'struct usb_interface_descriptor\');}' unless defined(&USB_GET_RX_INTERFACE_DESC);
    eval 'sub USB_GET_RX_ENDPOINT_DESC () { &_IOR (ord(\'U\'), 108, \'struct usb_endpoint_descriptor\');}' unless defined(&USB_GET_RX_ENDPOINT_DESC);
    eval 'sub USB_GET_FULL_DESC () { &_IOWR(ord(\'U\'), 109, \'struct usb_gen_descriptor\');}' unless defined(&USB_GET_FULL_DESC);
    eval 'sub USB_GET_STRING_DESC () { &_IOWR(ord(\'U\'), 110, \'struct usb_gen_descriptor\');}' unless defined(&USB_GET_STRING_DESC);
    eval 'sub USB_DO_REQUEST () { &_IOWR(ord(\'U\'), 111, \'struct usb_ctl_request\');}' unless defined(&USB_DO_REQUEST);
    eval 'sub USB_GET_DEVICEINFO () { &_IOR (ord(\'U\'), 112, \'struct usb_device_info\');}' unless defined(&USB_GET_DEVICEINFO);
    eval 'sub USB_SET_RX_SHORT_XFER () { &_IOW (ord(\'U\'), 113, \'int\');}' unless defined(&USB_SET_RX_SHORT_XFER);
    eval 'sub USB_SET_RX_TIMEOUT () { &_IOW (ord(\'U\'), 114, \'int\');}' unless defined(&USB_SET_RX_TIMEOUT);
    eval 'sub USB_GET_RX_FRAME_SIZE () { &_IOR (ord(\'U\'), 115, \'int\');}' unless defined(&USB_GET_RX_FRAME_SIZE);
    eval 'sub USB_GET_RX_BUFFER_SIZE () { &_IOR (ord(\'U\'), 117, \'int\');}' unless defined(&USB_GET_RX_BUFFER_SIZE);
    eval 'sub USB_SET_RX_BUFFER_SIZE () { &_IOW (ord(\'U\'), 118, \'int\');}' unless defined(&USB_SET_RX_BUFFER_SIZE);
    eval 'sub USB_SET_RX_STALL_FLAG () { &_IOW (ord(\'U\'), 119, \'int\');}' unless defined(&USB_SET_RX_STALL_FLAG);
    eval 'sub USB_SET_TX_STALL_FLAG () { &_IOW (ord(\'U\'), 120, \'int\');}' unless defined(&USB_SET_TX_STALL_FLAG);
    eval 'sub USB_GET_IFACE_DRIVER () { &_IOWR(ord(\'U\'), 121, \'struct usb_gen_descriptor\');}' unless defined(&USB_GET_IFACE_DRIVER);
    eval 'sub USB_CLAIM_INTERFACE () { &_IOW (ord(\'U\'), 122, \'int\');}' unless defined(&USB_CLAIM_INTERFACE);
    eval 'sub USB_RELEASE_INTERFACE () { &_IOW (ord(\'U\'), 123, \'int\');}' unless defined(&USB_RELEASE_INTERFACE);
    eval 'sub USB_IFACE_DRIVER_ACTIVE () { &_IOW (ord(\'U\'), 124, \'int\');}' unless defined(&USB_IFACE_DRIVER_ACTIVE);
    eval 'sub USB_IFACE_DRIVER_DETACH () { &_IOW (ord(\'U\'), 125, \'int\');}' unless defined(&USB_IFACE_DRIVER_DETACH);
    eval 'sub USB_GET_PLUGTIME () { &_IOR (ord(\'U\'), 126,  &uint32_t);}' unless defined(&USB_GET_PLUGTIME);
    eval 'sub USB_READ_DIR () { &_IOW (ord(\'U\'), 127, \'struct usb_read_dir\');}' unless defined(&USB_READ_DIR);
    eval 'sub USB_GET_DEV_PORT_PATH () { &_IOR (ord(\'U\'), 134, \'struct usb_device_port_path\');}' unless defined(&USB_GET_DEV_PORT_PATH);
    eval 'sub USB_GET_POWER_USAGE () { &_IOR (ord(\'U\'), 135, \'int\');}' unless defined(&USB_GET_POWER_USAGE);
    eval 'sub USB_SET_TX_FORCE_SHORT () { &_IOW (ord(\'U\'), 136, \'int\');}' unless defined(&USB_SET_TX_FORCE_SHORT);
    eval 'sub USB_SET_TX_TIMEOUT () { &_IOW (ord(\'U\'), 137, \'int\');}' unless defined(&USB_SET_TX_TIMEOUT);
    eval 'sub USB_GET_TX_FRAME_SIZE () { &_IOR (ord(\'U\'), 138, \'int\');}' unless defined(&USB_GET_TX_FRAME_SIZE);
    eval 'sub USB_GET_TX_BUFFER_SIZE () { &_IOR (ord(\'U\'), 139, \'int\');}' unless defined(&USB_GET_TX_BUFFER_SIZE);
    eval 'sub USB_SET_TX_BUFFER_SIZE () { &_IOW (ord(\'U\'), 140, \'int\');}' unless defined(&USB_SET_TX_BUFFER_SIZE);
    eval 'sub USB_GET_TX_INTERFACE_DESC () { &_IOR (ord(\'U\'), 141, \'struct usb_interface_descriptor\');}' unless defined(&USB_GET_TX_INTERFACE_DESC);
    eval 'sub USB_GET_TX_ENDPOINT_DESC () { &_IOR (ord(\'U\'), 142, \'struct usb_endpoint_descriptor\');}' unless defined(&USB_GET_TX_ENDPOINT_DESC);
    eval 'sub USB_SET_PORT_ENABLE () { &_IOW (ord(\'U\'), 143, \'int\');}' unless defined(&USB_SET_PORT_ENABLE);
    eval 'sub USB_SET_PORT_DISABLE () { &_IOW (ord(\'U\'), 144, \'int\');}' unless defined(&USB_SET_PORT_DISABLE);
    eval 'sub USB_SET_POWER_MODE () { &_IOW (ord(\'U\'), 145, \'int\');}' unless defined(&USB_SET_POWER_MODE);
    eval 'sub USB_GET_POWER_MODE () { &_IOR (ord(\'U\'), 146, \'int\');}' unless defined(&USB_GET_POWER_MODE);
    eval 'sub USB_SET_TEMPLATE () { &_IOW (ord(\'U\'), 147, \'int\');}' unless defined(&USB_SET_TEMPLATE);
    eval 'sub USB_GET_TEMPLATE () { &_IOR (ord(\'U\'), 148, \'int\');}' unless defined(&USB_GET_TEMPLATE);
    eval 'sub USB_GET_CM_OVER_DATA () { &_IOR (ord(\'U\'), 180, \'int\');}' unless defined(&USB_GET_CM_OVER_DATA);
    eval 'sub USB_SET_CM_OVER_DATA () { &_IOW (ord(\'U\'), 181, \'int\');}' unless defined(&USB_SET_CM_OVER_DATA);
    eval 'sub USB_GET_GPIO () { &_IOR (ord(\'U\'), 182, \'int\');}' unless defined(&USB_GET_GPIO);
    eval 'sub USB_SET_GPIO () { &_IOW (ord(\'U\'), 183, \'int\');}' unless defined(&USB_SET_GPIO);
    eval 'sub USB_FS_START () { &_IOW (ord(\'U\'), 192, \'struct usb_fs_start\');}' unless defined(&USB_FS_START);
    eval 'sub USB_FS_STOP () { &_IOW (ord(\'U\'), 193, \'struct usb_fs_stop\');}' unless defined(&USB_FS_STOP);
    eval 'sub USB_FS_COMPLETE () { &_IOR (ord(\'U\'), 194, \'struct usb_fs_complete\');}' unless defined(&USB_FS_COMPLETE);
    eval 'sub USB_FS_INIT () { &_IOW (ord(\'U\'), 195, \'struct usb_fs_init\');}' unless defined(&USB_FS_INIT);
    eval 'sub USB_FS_UNINIT () { &_IOW (ord(\'U\'), 196, \'struct usb_fs_uninit\');}' unless defined(&USB_FS_UNINIT);
    eval 'sub USB_FS_OPEN () { &_IOWR(ord(\'U\'), 197, \'struct usb_fs_open\');}' unless defined(&USB_FS_OPEN);
    eval 'sub USB_FS_CLOSE () { &_IOW (ord(\'U\'), 198, \'struct usb_fs_close\');}' unless defined(&USB_FS_CLOSE);
    eval 'sub USB_FS_CLEAR_STALL_SYNC () { &_IOW (ord(\'U\'), 199, \'struct usb_fs_clear_stall_sync\');}' unless defined(&USB_FS_CLEAR_STALL_SYNC);
    eval 'sub USB_FS_OPEN_STREAM () { &_IOWR(ord(\'U\'), 200, \'struct usb_fs_open_stream\');}' unless defined(&USB_FS_OPEN_STREAM);
    eval 'sub USB_DEV_QUIRK_GET () { &_IOWR(ord(\'Q\'), 0, \'struct usb_gen_quirk\');}' unless defined(&USB_DEV_QUIRK_GET);
    eval 'sub USB_QUIRK_NAME_GET () { &_IOWR(ord(\'Q\'), 1, \'struct usb_gen_quirk\');}' unless defined(&USB_QUIRK_NAME_GET);
    eval 'sub USB_DEV_QUIRK_ADD () { &_IOW (ord(\'Q\'), 2, \'struct usb_gen_quirk\');}' unless defined(&USB_DEV_QUIRK_ADD);
    eval 'sub USB_DEV_QUIRK_REMOVE () { &_IOW (ord(\'Q\'), 3, \'struct usb_gen_quirk\');}' unless defined(&USB_DEV_QUIRK_REMOVE);
}
1;
