require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_USB_MBUF_H_)) {
    eval 'sub _USB_MBUF_H_ () {1;}' unless defined(&_USB_MBUF_H_);
    eval 'sub USB_IF_ENQUEUE {
        my($ifq, $m) = @_;
	    eval q( &do { ($m)-> &usb_nextpkt =  &NULL;  &if (($ifq)-> &ifq_tail ==  &NULL) ($ifq)-> &ifq_head = ($m);  &else ($ifq)-> ($ifq_tail->{usb_nextpkt}) = ($m); ($ifq)-> &ifq_tail = ($m); ($ifq)-> &ifq_len++; }  &while (0));
    }' unless defined(&USB_IF_ENQUEUE);
    eval 'sub USB_IF_DEQUEUE {
        my($ifq, $m) = @_;
	    eval q( &do { ($m) = ($ifq)-> &ifq_head;  &if ($m) {  &if ((($ifq)-> &ifq_head = ($m)-> &usb_nextpkt) ==  &NULL) { ($ifq)-> &ifq_tail =  &NULL; } ($m)-> &usb_nextpkt =  &NULL; ($ifq)-> &ifq_len--; } }  &while (0));
    }' unless defined(&USB_IF_DEQUEUE);
    eval 'sub USB_IF_PREPEND {
        my($ifq, $m) = @_;
	    eval q( &do { ($m)-> &usb_nextpkt = ($ifq)-> &ifq_head;  &if (($ifq)-> &ifq_tail ==  &NULL) { ($ifq)-> &ifq_tail = ($m); } ($ifq)-> &ifq_head = ($m); ($ifq)-> &ifq_len++; }  &while (0));
    }' unless defined(&USB_IF_PREPEND);
    eval 'sub USB_IF_QFULL {
        my($ifq) = @_;
	    eval q((($ifq)-> &ifq_len >= ($ifq)-> &ifq_maxlen));
    }' unless defined(&USB_IF_QFULL);
    eval 'sub USB_IF_QLEN {
        my($ifq) = @_;
	    eval q((($ifq)-> &ifq_len));
    }' unless defined(&USB_IF_QLEN);
    eval 'sub USB_IF_POLL {
        my($ifq, $m) = @_;
	    eval q((($m) = ($ifq)-> &ifq_head));
    }' unless defined(&USB_IF_POLL);
    eval 'sub USB_MBUF_RESET {
        my($m) = @_;
	    eval q( &do { ($m)-> &cur_data_ptr = ($m)-> &min_data_ptr; ($m)-> &cur_data_len = ($m)-> &max_data_len; ($m)-> &last_packet = 0; }  &while (0));
    }' unless defined(&USB_MBUF_RESET);
}
1;
