require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_USB_PF_H)) {
    eval 'sub _DEV_USB_PF_H () {1;}' unless defined(&_DEV_USB_PF_H);
    eval 'sub USBPF_MODE_HOST () {0;}' unless defined(&USBPF_MODE_HOST);
    eval 'sub USBPF_MODE_DEVICE () {1;}' unless defined(&USBPF_MODE_DEVICE);
    eval 'sub USBPF_FLAG_FORCE_SHORT_XFER () {(1<< 0);}' unless defined(&USBPF_FLAG_FORCE_SHORT_XFER);
    eval 'sub USBPF_FLAG_SHORT_XFER_OK () {(1<< 1);}' unless defined(&USBPF_FLAG_SHORT_XFER_OK);
    eval 'sub USBPF_FLAG_SHORT_FRAMES_OK () {(1<< 2);}' unless defined(&USBPF_FLAG_SHORT_FRAMES_OK);
    eval 'sub USBPF_FLAG_PIPE_BOF () {(1<< 3);}' unless defined(&USBPF_FLAG_PIPE_BOF);
    eval 'sub USBPF_FLAG_PROXY_BUFFER () {(1<< 4);}' unless defined(&USBPF_FLAG_PROXY_BUFFER);
    eval 'sub USBPF_FLAG_EXT_BUFFER () {(1<< 5);}' unless defined(&USBPF_FLAG_EXT_BUFFER);
    eval 'sub USBPF_FLAG_MANUAL_STATUS () {(1<< 6);}' unless defined(&USBPF_FLAG_MANUAL_STATUS);
    eval 'sub USBPF_FLAG_NO_PIPE_OK () {(1<< 7);}' unless defined(&USBPF_FLAG_NO_PIPE_OK);
    eval 'sub USBPF_FLAG_STALL_PIPE () {(1<< 8);}' unless defined(&USBPF_FLAG_STALL_PIPE);
    eval 'sub USBPF_STATUS_OPEN () {(1<< 0);}' unless defined(&USBPF_STATUS_OPEN);
    eval 'sub USBPF_STATUS_TRANSFERRING () {(1<< 1);}' unless defined(&USBPF_STATUS_TRANSFERRING);
    eval 'sub USBPF_STATUS_DID_DMA_DELAY () {(1<< 2);}' unless defined(&USBPF_STATUS_DID_DMA_DELAY);
    eval 'sub USBPF_STATUS_DID_CLOSE () {(1<< 3);}' unless defined(&USBPF_STATUS_DID_CLOSE);
    eval 'sub USBPF_STATUS_DRAINING () {(1<< 4);}' unless defined(&USBPF_STATUS_DRAINING);
    eval 'sub USBPF_STATUS_STARTED () {(1<< 5);}' unless defined(&USBPF_STATUS_STARTED);
    eval 'sub USBPF_STATUS_BW_RECLAIMED () {(1<< 6);}' unless defined(&USBPF_STATUS_BW_RECLAIMED);
    eval 'sub USBPF_STATUS_CONTROL_XFR () {(1<< 7);}' unless defined(&USBPF_STATUS_CONTROL_XFR);
    eval 'sub USBPF_STATUS_CONTROL_HDR () {(1<< 8);}' unless defined(&USBPF_STATUS_CONTROL_HDR);
    eval 'sub USBPF_STATUS_CONTROL_ACT () {(1<< 9);}' unless defined(&USBPF_STATUS_CONTROL_ACT);
    eval 'sub USBPF_STATUS_CONTROL_STALL () {(1<< 10);}' unless defined(&USBPF_STATUS_CONTROL_STALL);
    eval 'sub USBPF_STATUS_SHORT_FRAMES_OK () {(1<< 11);}' unless defined(&USBPF_STATUS_SHORT_FRAMES_OK);
    eval 'sub USBPF_STATUS_SHORT_XFER_OK () {(1<< 12);}' unless defined(&USBPF_STATUS_SHORT_XFER_OK);
    eval 'sub USBPF_STATUS_BDMA_ENABLE () {(1<< 13);}' unless defined(&USBPF_STATUS_BDMA_ENABLE);
    eval 'sub USBPF_STATUS_BDMA_NO_POST_SYNC () {(1<< 14);}' unless defined(&USBPF_STATUS_BDMA_NO_POST_SYNC);
    eval 'sub USBPF_STATUS_BDMA_SETUP () {(1<< 15);}' unless defined(&USBPF_STATUS_BDMA_SETUP);
    eval 'sub USBPF_STATUS_ISOCHRONOUS_XFR () {(1<< 16);}' unless defined(&USBPF_STATUS_ISOCHRONOUS_XFR);
    eval 'sub USBPF_STATUS_CURR_DMA_SET () {(1<< 17);}' unless defined(&USBPF_STATUS_CURR_DMA_SET);
    eval 'sub USBPF_STATUS_CAN_CANCEL_IMMED () {(1<< 18);}' unless defined(&USBPF_STATUS_CAN_CANCEL_IMMED);
    eval 'sub USBPF_STATUS_DOING_CALLBACK () {(1<< 19);}' unless defined(&USBPF_STATUS_DOING_CALLBACK);
    eval 'sub USBPF_FRAME_ALIGN {
        my($x) = @_;
	    eval q(((($x) + 3) & ~3));
    }' unless defined(&USBPF_FRAME_ALIGN);
    eval 'sub USBPF_FRAMEFLAG_READ () {(1<< 0);}' unless defined(&USBPF_FRAMEFLAG_READ);
    eval 'sub USBPF_FRAMEFLAG_DATA_FOLLOWS () {(1<< 1);}' unless defined(&USBPF_FRAMEFLAG_DATA_FOLLOWS);
    eval 'sub USBPF_HDR_LEN () {128;}' unless defined(&USBPF_HDR_LEN);
    eval 'sub USBPF_FRAME_HDR_LEN () {8;}' unless defined(&USBPF_FRAME_HDR_LEN);
    eval 'sub USBPF_XFERTAP_SUBMIT () {0;}' unless defined(&USBPF_XFERTAP_SUBMIT);
    eval 'sub USBPF_XFERTAP_DONE () {1;}' unless defined(&USBPF_XFERTAP_DONE);
    if(defined(&_KERNEL)) {
    }
}
1;
