require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_DEV_UTOPIA_UTOPIA_H)) {
    eval 'sub _DEV_UTOPIA_UTOPIA_H () {1;}' unless defined(&_DEV_UTOPIA_UTOPIA_H);
    eval 'sub UTP_REGT_BITS () {0x;}' unless defined(&UTP_REGT_BITS);
    eval 'sub UTP_REGT_INT8 () {0x1;}' unless defined(&UTP_REGT_INT8);
    eval 'sub UTP_REGT_INT10BITS () {0x2;}' unless defined(&UTP_REGT_INT10BITS);
    eval 'sub UTP_REGT_INT12 () {0x3;}' unless defined(&UTP_REGT_INT12);
    eval 'sub UTP_REGT_INT16 () {0x4;}' unless defined(&UTP_REGT_INT16);
    eval 'sub UTP_REGT_INT19 () {0x5;}' unless defined(&UTP_REGT_INT19);
    eval 'sub UTP_REGT_INT20 () {0x6;}' unless defined(&UTP_REGT_INT20);
    eval 'sub UTP_REGT_INT21 () {0x7;}' unless defined(&UTP_REGT_INT21);
    eval 'sub UTP_REGT_INT18 () {0x8;}' unless defined(&UTP_REGT_INT18);
    eval 'sub UTP_REG_ADD () {0, 0, 1, 1, 1, 2, 2, 2, 2;}' unless defined(&UTP_REG_ADD);
    eval 'sub UTP_FL_NORESET () {0x1;}' unless defined(&UTP_FL_NORESET);
    eval 'sub UTP_FL_POLL_CARRIER () {0x2;}' unless defined(&UTP_FL_POLL_CARRIER);
    eval 'sub UTP_ST_ACTIVE () {0x1;}' unless defined(&UTP_ST_ACTIVE);
    eval 'sub UTP_ST_SDH () {0x2;}' unless defined(&UTP_ST_SDH);
    eval 'sub UTP_ST_UNASS () {0x4;}' unless defined(&UTP_ST_UNASS);
    eval 'sub UTP_ST_NOSCRAMB () {0x8;}' unless defined(&UTP_ST_NOSCRAMB);
    eval 'sub UTP_ST_DETACH () {0x10;}' unless defined(&UTP_ST_DETACH);
    eval 'sub UTP_ST_ATTACHED () {0x20;}' unless defined(&UTP_ST_ATTACHED);
    eval 'sub UTP_CARR_UNKNOWN () {0;}' unless defined(&UTP_CARR_UNKNOWN);
    eval 'sub UTP_CARR_OK () {1;}' unless defined(&UTP_CARR_OK);
    eval 'sub UTP_CARR_LOST () {2;}' unless defined(&UTP_CARR_LOST);
    eval 'sub UTP_LOOP_NONE () {0x;}' unless defined(&UTP_LOOP_NONE);
    eval 'sub UTP_LOOP_TIME () {0x1;}' unless defined(&UTP_LOOP_TIME);
    eval 'sub UTP_LOOP_DIAG () {0x2;}' unless defined(&UTP_LOOP_DIAG);
    eval 'sub UTP_LOOP_LINE () {0x4;}' unless defined(&UTP_LOOP_LINE);
    eval 'sub UTP_LOOP_PARAL () {0x8;}' unless defined(&UTP_LOOP_PARAL);
    eval 'sub UTP_LOOP_TWIST () {0x10;}' unless defined(&UTP_LOOP_TWIST);
    eval 'sub UTP_LOOP_PATH () {0x20;}' unless defined(&UTP_LOOP_PATH);
    eval 'sub UTP_TYPE_UNKNOWN () {0;}' unless defined(&UTP_TYPE_UNKNOWN);
    eval 'sub UTP_TYPE_SUNI_LITE () {1;}' unless defined(&UTP_TYPE_SUNI_LITE);
    eval 'sub UTP_TYPE_SUNI_ULTRA () {2;}' unless defined(&UTP_TYPE_SUNI_ULTRA);
    eval 'sub UTP_TYPE_SUNI_622 () {3;}' unless defined(&UTP_TYPE_SUNI_622);
    eval 'sub UTP_TYPE_IDT77105 () {4;}' unless defined(&UTP_TYPE_IDT77105);
    eval 'sub UTP_TYPE_IDT77155 () {5;}' unless defined(&UTP_TYPE_IDT77155);
    eval 'sub UTP_TYPE_CX28250 () {6;}' unless defined(&UTP_TYPE_CX28250);
    if(defined(&_KERNEL)) {
	require 'sys/queue.ph';
	eval 'sub utopia_reset {
	    my($S) = @_;
    	    eval q((($S)-> ($chip->{reset})(($S))));
	}' unless defined(&utopia_reset);
	eval 'sub utopia_set_sdh {
	    my($S, $SDH) = @_;
    	    eval q((($S)-> ($chip->{set_sdh})(($S), ($SDH))));
	}' unless defined(&utopia_set_sdh);
	eval 'sub utopia_set_unass {
	    my($S, $U) = @_;
    	    eval q((($S)-> ($chip->{set_unass})(($S), ($U))));
	}' unless defined(&utopia_set_unass);
	eval 'sub utopia_set_noscramb {
	    my($S, $N) = @_;
    	    eval q((($S)-> ($chip->{set_noscramb})(($S), ($N))));
	}' unless defined(&utopia_set_noscramb);
	eval 'sub utopia_update_carrier {
	    my($S) = @_;
    	    eval q((($S)-> ($chip->{update_carrier})(($S))));
	}' unless defined(&utopia_update_carrier);
	eval 'sub utopia_update_stats {
	    my($S) = @_;
    	    eval q((($S)-> ($chip->{update_stats})(($S))));
	}' unless defined(&utopia_update_stats);
	eval 'sub utopia_set_loopback {
	    my($S, $L) = @_;
    	    eval q((($S)-> ($chip->{set_loopback})(($S), ($L))));
	}' unless defined(&utopia_set_loopback);
	eval 'sub utopia_intr {
	    my($S) = @_;
    	    eval q((($S)-> ($chip->{intr})(($S))));
	}' unless defined(&utopia_intr);
    }
}
1;
