require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_CUSE_IOCTL_H_)) {
    eval 'sub _CUSE_IOCTL_H_ () {1;}' unless defined(&_CUSE_IOCTL_H_);
    require 'sys/ioccom.ph';
    require 'sys/types.ph';
    eval 'sub CUSE_BUFFER_MAX () { &PAGE_SIZE;}' unless defined(&CUSE_BUFFER_MAX);
    eval 'sub CUSE_DEVICES_MAX () {64;}' unless defined(&CUSE_DEVICES_MAX);
    eval 'sub CUSE_BUF_MIN_PTR () {0x10000;}' unless defined(&CUSE_BUF_MIN_PTR);
    eval 'sub CUSE_BUF_MAX_PTR () {0x20000;}' unless defined(&CUSE_BUF_MAX_PTR);
    eval 'sub CUSE_ALLOC_UNIT_MAX () {128;}' unless defined(&CUSE_ALLOC_UNIT_MAX);
    eval 'sub CUSE_ALLOC_PAGES_MAX () {(((16 * 1024 * 1024) +  &PAGE_SIZE - 1) /  &PAGE_SIZE);}' unless defined(&CUSE_ALLOC_PAGES_MAX);
    eval 'sub CUSE_IOCTL_GET_COMMAND () { &_IOR(ord(\'C\'), 0, \'struct cuse_command\');}' unless defined(&CUSE_IOCTL_GET_COMMAND);
    eval 'sub CUSE_IOCTL_WRITE_DATA () { &_IOW(ord(\'C\'), 1, \'struct cuse_data_chunk\');}' unless defined(&CUSE_IOCTL_WRITE_DATA);
    eval 'sub CUSE_IOCTL_READ_DATA () { &_IOW(ord(\'C\'), 2, \'struct cuse_data_chunk\');}' unless defined(&CUSE_IOCTL_READ_DATA);
    eval 'sub CUSE_IOCTL_SYNC_COMMAND () { &_IOW(ord(\'C\'), 3, \'int\');}' unless defined(&CUSE_IOCTL_SYNC_COMMAND);
    eval 'sub CUSE_IOCTL_GET_SIG () { &_IOR(ord(\'C\'), 4, \'int\');}' unless defined(&CUSE_IOCTL_GET_SIG);
    eval 'sub CUSE_IOCTL_ALLOC_MEMORY () { &_IOW(ord(\'C\'), 5, \'struct cuse_alloc_info\');}' unless defined(&CUSE_IOCTL_ALLOC_MEMORY);
    eval 'sub CUSE_IOCTL_FREE_MEMORY () { &_IOW(ord(\'C\'), 6, \'struct cuse_alloc_info\');}' unless defined(&CUSE_IOCTL_FREE_MEMORY);
    eval 'sub CUSE_IOCTL_SET_PFH () { &_IOW(ord(\'C\'), 7,  &uintptr_t);}' unless defined(&CUSE_IOCTL_SET_PFH);
    eval 'sub CUSE_IOCTL_CREATE_DEV () { &_IOW(ord(\'C\'), 8, \'struct cuse_create_dev\');}' unless defined(&CUSE_IOCTL_CREATE_DEV);
    eval 'sub CUSE_IOCTL_DESTROY_DEV () { &_IOW(ord(\'C\'), 9, \'struct cuse_dev\' *);}' unless defined(&CUSE_IOCTL_DESTROY_DEV);
    eval 'sub CUSE_IOCTL_ALLOC_UNIT () { &_IOR(ord(\'C\'),10, \'int\');}' unless defined(&CUSE_IOCTL_ALLOC_UNIT);
    eval 'sub CUSE_IOCTL_FREE_UNIT () { &_IOW(ord(\'C\'),11, \'int\');}' unless defined(&CUSE_IOCTL_FREE_UNIT);
    eval 'sub CUSE_IOCTL_SELWAKEUP () { &_IOW(ord(\'C\'),12, \'int\');}' unless defined(&CUSE_IOCTL_SELWAKEUP);
    eval 'sub CUSE_IOCTL_ALLOC_UNIT_BY_ID () { &_IOWR(ord(\'C\'),13, \'int\');}' unless defined(&CUSE_IOCTL_ALLOC_UNIT_BY_ID);
    eval 'sub CUSE_IOCTL_FREE_UNIT_BY_ID () { &_IOWR(ord(\'C\'),14, \'int\');}' unless defined(&CUSE_IOCTL_FREE_UNIT_BY_ID);
}
1;
