require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFS_NFS_H_)) {
    eval 'sub _NFS_NFS_H_ () {1;}' unless defined(&_NFS_NFS_H_);
    eval 'sub NFS_MAXIOVEC () {34;}' unless defined(&NFS_MAXIOVEC);
    eval 'sub NFS_TICKINTVL () {500;}' unless defined(&NFS_TICKINTVL);
    eval 'sub NFS_HZ () {( &hz /  &nfscl_ticks);}' unless defined(&NFS_HZ);
    eval 'sub NFS_TIMEO () {(1*  &NFS_HZ);}' unless defined(&NFS_TIMEO);
    eval 'sub NFS_MINTIMEO () {(1*  &NFS_HZ);}' unless defined(&NFS_MINTIMEO);
    eval 'sub NFS_MAXTIMEO () {(60*  &NFS_HZ);}' unless defined(&NFS_MAXTIMEO);
    eval 'sub NFS_TCPTIMEO () {300;}' unless defined(&NFS_TCPTIMEO);
    eval 'sub NFS_MAXRCVTIMEO () {60;}' unless defined(&NFS_MAXRCVTIMEO);
    eval 'sub NFS_MINIDEMTIMEO () {(5*  &NFS_HZ);}' unless defined(&NFS_MINIDEMTIMEO);
    eval 'sub NFS_MAXREXMIT () {100;}' unless defined(&NFS_MAXREXMIT);
    eval 'sub NFSV4_CALLBACKTIMEO () {(2*  &NFS_HZ);}' unless defined(&NFSV4_CALLBACKTIMEO);
    eval 'sub NFSV4_CALLBACKRETRY () {5;}' unless defined(&NFSV4_CALLBACKRETRY);
    eval 'sub NFSV4_SLOTS () {64;}' unless defined(&NFSV4_SLOTS);
    eval 'sub NFSV4_CBSLOTS () {8;}' unless defined(&NFSV4_CBSLOTS);
    eval 'sub NFSV4_CBRETRYCNT () {4;}' unless defined(&NFSV4_CBRETRYCNT);
    eval 'sub NFSV4_UPCALLTIMEO () {(15*  &NFS_HZ);}' unless defined(&NFSV4_UPCALLTIMEO);
    eval 'sub NFSV4_UPCALLRETRY () {4;}' unless defined(&NFSV4_UPCALLRETRY);
    eval 'sub NFS_MAXWINDOW () {1024;}' unless defined(&NFS_MAXWINDOW);
    eval 'sub NFS_RETRANS () {10;}' unless defined(&NFS_RETRANS);
    eval 'sub NFS_RETRANS_TCP () {2;}' unless defined(&NFS_RETRANS_TCP);
    eval 'sub NFS_MAXGRPS () {16;}' unless defined(&NFS_MAXGRPS);
    eval 'sub NFS_TRYLATERDEL () {15;}' unless defined(&NFS_TRYLATERDEL);
    unless(defined(&NFS_REMOVETIMEO)) {
	eval 'sub NFS_REMOVETIMEO () {15;}' unless defined(&NFS_REMOVETIMEO);
    }
    unless(defined(&NFS_MINATTRTIMO)) {
	eval 'sub NFS_MINATTRTIMO () {5;}' unless defined(&NFS_MINATTRTIMO);
    }
    unless(defined(&NFS_MAXATTRTIMO)) {
	eval 'sub NFS_MAXATTRTIMO () {60;}' unless defined(&NFS_MAXATTRTIMO);
    }
    eval 'sub NFS_WSIZE () {8192;}' unless defined(&NFS_WSIZE);
    eval 'sub NFS_RSIZE () {8192;}' unless defined(&NFS_RSIZE);
    eval 'sub NFS_READDIRSIZE () {8192;}' unless defined(&NFS_READDIRSIZE);
    eval 'sub NFS_DEFRAHEAD () {1;}' unless defined(&NFS_DEFRAHEAD);
    eval 'sub NFS_MAXRAHEAD () {16;}' unless defined(&NFS_MAXRAHEAD);
    eval 'sub NFS_MAXASYNCDAEMON () {64;}' unless defined(&NFS_MAXASYNCDAEMON);
    eval 'sub NFS_MAXUIDHASH () {64;}' unless defined(&NFS_MAXUIDHASH);
    unless(defined(&NFSRV_LEASE)) {
	eval 'sub NFSRV_LEASE () {120;}' unless defined(&NFSRV_LEASE);
    }
    unless(defined(&NFSRV_STALELEASE)) {
	eval 'sub NFSRV_STALELEASE () {(5*  &nfsrv_lease);}' unless defined(&NFSRV_STALELEASE);
    }
    unless(defined(&NFSRV_MOULDYLEASE)) {
	eval 'sub NFSRV_MOULDYLEASE () {604800;}' unless defined(&NFSRV_MOULDYLEASE);
    }
    unless(defined(&NFSCLIENTHASHSIZE)) {
	eval 'sub NFSCLIENTHASHSIZE () {20;}' unless defined(&NFSCLIENTHASHSIZE);
    }
    unless(defined(&NFSLOCKHASHSIZE)) {
	eval 'sub NFSLOCKHASHSIZE () {20;}' unless defined(&NFSLOCKHASHSIZE);
    }
    unless(defined(&NFSSESSIONHASHSIZE)) {
	eval 'sub NFSSESSIONHASHSIZE () {20;}' unless defined(&NFSSESSIONHASHSIZE);
    }
    eval 'sub NFSSTATEHASHSIZE () {10;}' unless defined(&NFSSTATEHASHSIZE);
    unless(defined(&NFSCLDELEGHIGHWATER)) {
	eval 'sub NFSCLDELEGHIGHWATER () {10000;}' unless defined(&NFSCLDELEGHIGHWATER);
    }
    unless(defined(&NFSCLLAYOUTHIGHWATER)) {
	eval 'sub NFSCLLAYOUTHIGHWATER () {10000;}' unless defined(&NFSCLLAYOUTHIGHWATER);
    }
    unless(defined(&NFSNOOPEN)) {
	eval 'sub NFSNOOPEN () {120;}' unless defined(&NFSNOOPEN);
    }
    eval 'sub NFSRV_LEASEDELTA () {15;}' unless defined(&NFSRV_LEASEDELTA);
    eval 'sub NFS_IDMAXSIZE () {4;}' unless defined(&NFS_IDMAXSIZE);
    unless(defined(&NFSRVCACHE_UDPTIMEOUT)) {
	eval 'sub NFSRVCACHE_UDPTIMEOUT () {30;}' unless defined(&NFSRVCACHE_UDPTIMEOUT);
    }
    unless(defined(&NFSRVCACHE_UDPHIGHWATER)) {
	eval 'sub NFSRVCACHE_UDPHIGHWATER () {500;}' unless defined(&NFSRVCACHE_UDPHIGHWATER);
    }
    unless(defined(&NFSRVCACHE_TCPTIMEOUT)) {
	eval 'sub NFSRVCACHE_TCPTIMEOUT () {(3600*12);}' unless defined(&NFSRVCACHE_TCPTIMEOUT);
    }
    unless(defined(&NFSRVCACHE_FLOODLEVEL)) {
	eval 'sub NFSRVCACHE_FLOODLEVEL () {16384;}' unless defined(&NFSRVCACHE_FLOODLEVEL);
    }
    unless(defined(&NFSRV_CLIENTHIGHWATER)) {
	eval 'sub NFSRV_CLIENTHIGHWATER () {1000;}' unless defined(&NFSRV_CLIENTHIGHWATER);
    }
    unless(defined(&NFSRV_MAXDUMPLIST)) {
	eval 'sub NFSRV_MAXDUMPLIST () {10000;}' unless defined(&NFSRV_MAXDUMPLIST);
    }
    unless(defined(&NFS_ACCESSCACHESIZE)) {
	eval 'sub NFS_ACCESSCACHESIZE () {8;}' unless defined(&NFS_ACCESSCACHESIZE);
    }
    eval 'sub NFSV4_CBPORT () {7745;}' unless defined(&NFSV4_CBPORT);
    eval 'sub NFSRV_V4DELEGLIMIT {
        my($c) = @_;
	    eval q(((($c) * 5) >  &nfsrv_v4statelimit));
    }' unless defined(&NFSRV_V4DELEGLIMIT);
    eval 'sub NFS_READDIRBLKSIZ () { &DIRBLKSIZ;}' unless defined(&NFS_READDIRBLKSIZ);
    eval 'sub NFS_CMPFH {
        my($n, $f, $s) = @_;
	    eval q((-> ($n_fhp->{n$fh_len}) ==  && ! &NFSBCMP(-> ($n_fhp->{n$fh_fh}), ($f), ($s))));
    }' unless defined(&NFS_CMPFH);
    eval 'sub NFSRV_CMPFH {
        my($nf, $ns, $f, $s) = @_;
	    eval q(( ==  && ! &NFSBCMP(, ($f), ($s))));
    }' unless defined(&NFSRV_CMPFH);
    eval 'sub NFS_CMPTIME {
        my($t1, $t2) = @_;
	    eval q((($t1). &tv_sec == ($t2). &tv_sec  && ($t1). &tv_nsec == ($t2). &tv_nsec));
    }' unless defined(&NFS_CMPTIME);
    eval 'sub NFS_SETTIME {
        my($t) = @_;
	    eval q( &do { ($t). &tv_sec =  ($time->{tv_sec}); ($t). &tv_nsec = 1000*  ($time->{tv_usec}); }  &while (0));
    }' unless defined(&NFS_SETTIME);
    eval 'sub NFS_SRVMAXDATA {
        my($n) = @_;
	    eval q(((($n)-> &nd_flag & ( &ND_NFSV3 |  &ND_NFSV4)) ?  &NFS_SRVMAXIO :  &NFS_V2MAXDATA));
    }' unless defined(&NFS_SRVMAXDATA);
    eval 'sub NFS64BITSSET () {0xffffffffffffffff;}' unless defined(&NFS64BITSSET);
    eval 'sub NFS64BITSMINUS1 () {0xfffffffffffffffe;}' unless defined(&NFS64BITSMINUS1);
    eval 'sub LCL_NEEDSCONFIRM () {0x1;}' unless defined(&LCL_NEEDSCONFIRM);
    eval 'sub LCL_DONTCLEAN () {0x2;}' unless defined(&LCL_DONTCLEAN);
    eval 'sub LCL_WAKEUPWANTED () {0x4;}' unless defined(&LCL_WAKEUPWANTED);
    eval 'sub LCL_TCPCALLBACK () {0x8;}' unless defined(&LCL_TCPCALLBACK);
    eval 'sub LCL_CALLBACKSON () {0x10;}' unless defined(&LCL_CALLBACKSON);
    eval 'sub LCL_INDEXNOTOK () {0x20;}' unless defined(&LCL_INDEXNOTOK);
    eval 'sub LCL_STAMPEDSTABLE () {0x40;}' unless defined(&LCL_STAMPEDSTABLE);
    eval 'sub LCL_EXPIREIT () {0x80;}' unless defined(&LCL_EXPIREIT);
    eval 'sub LCL_CBDOWN () {0x100;}' unless defined(&LCL_CBDOWN);
    eval 'sub LCL_KERBV () {0x400;}' unless defined(&LCL_KERBV);
    eval 'sub LCL_NAME () {0x800;}' unless defined(&LCL_NAME);
    eval 'sub LCL_NEEDSCBNULL () {0x1000;}' unless defined(&LCL_NEEDSCBNULL);
    eval 'sub LCL_GSSINTEGRITY () {0x2000;}' unless defined(&LCL_GSSINTEGRITY);
    eval 'sub LCL_GSSPRIVACY () {0x4000;}' unless defined(&LCL_GSSPRIVACY);
    eval 'sub LCL_ADMINREVOKED () {0x8000;}' unless defined(&LCL_ADMINREVOKED);
    eval 'sub LCL_RECLAIMCOMPLETE () {0x10000;}' unless defined(&LCL_RECLAIMCOMPLETE);
    eval 'sub LCL_NFSV41 () {0x20000;}' unless defined(&LCL_NFSV41);
    eval 'sub LCL_GSS () { &LCL_KERBV;}' unless defined(&LCL_GSS);
    eval 'sub NFSLCK_READACCESS () {0x1;}' unless defined(&NFSLCK_READACCESS);
    eval 'sub NFSLCK_WRITEACCESS () {0x2;}' unless defined(&NFSLCK_WRITEACCESS);
    eval 'sub NFSLCK_ACCESSBITS () {( &NFSLCK_READACCESS |  &NFSLCK_WRITEACCESS);}' unless defined(&NFSLCK_ACCESSBITS);
    eval 'sub NFSLCK_SHIFT () {2;}' unless defined(&NFSLCK_SHIFT);
    eval 'sub NFSLCK_READDENY () {0x4;}' unless defined(&NFSLCK_READDENY);
    eval 'sub NFSLCK_WRITEDENY () {0x8;}' unless defined(&NFSLCK_WRITEDENY);
    eval 'sub NFSLCK_DENYBITS () {( &NFSLCK_READDENY |  &NFSLCK_WRITEDENY);}' unless defined(&NFSLCK_DENYBITS);
    eval 'sub NFSLCK_SHAREBITS () {( &NFSLCK_READACCESS| &NFSLCK_WRITEACCESS| &NFSLCK_READDENY| &NFSLCK_WRITEDENY);}' unless defined(&NFSLCK_SHAREBITS);
    eval 'sub NFSLCK_LOCKSHIFT () {4;}' unless defined(&NFSLCK_LOCKSHIFT);
    eval 'sub NFSLCK_READ () {0x10;}' unless defined(&NFSLCK_READ);
    eval 'sub NFSLCK_WRITE () {0x20;}' unless defined(&NFSLCK_WRITE);
    eval 'sub NFSLCK_BLOCKING () {0x40;}' unless defined(&NFSLCK_BLOCKING);
    eval 'sub NFSLCK_RECLAIM () {0x80;}' unless defined(&NFSLCK_RECLAIM);
    eval 'sub NFSLCK_OPENTOLOCK () {0x100;}' unless defined(&NFSLCK_OPENTOLOCK);
    eval 'sub NFSLCK_TEST () {0x200;}' unless defined(&NFSLCK_TEST);
    eval 'sub NFSLCK_LOCK () {0x400;}' unless defined(&NFSLCK_LOCK);
    eval 'sub NFSLCK_UNLOCK () {0x800;}' unless defined(&NFSLCK_UNLOCK);
    eval 'sub NFSLCK_OPEN () {0x1000;}' unless defined(&NFSLCK_OPEN);
    eval 'sub NFSLCK_CLOSE () {0x2000;}' unless defined(&NFSLCK_CLOSE);
    eval 'sub NFSLCK_CHECK () {0x4000;}' unless defined(&NFSLCK_CHECK);
    eval 'sub NFSLCK_RELEASE () {0x8000;}' unless defined(&NFSLCK_RELEASE);
    eval 'sub NFSLCK_NEEDSCONFIRM () {0x10000;}' unless defined(&NFSLCK_NEEDSCONFIRM);
    eval 'sub NFSLCK_CONFIRM () {0x20000;}' unless defined(&NFSLCK_CONFIRM);
    eval 'sub NFSLCK_DOWNGRADE () {0x40000;}' unless defined(&NFSLCK_DOWNGRADE);
    eval 'sub NFSLCK_DELEGREAD () {0x80000;}' unless defined(&NFSLCK_DELEGREAD);
    eval 'sub NFSLCK_DELEGWRITE () {0x100000;}' unless defined(&NFSLCK_DELEGWRITE);
    eval 'sub NFSLCK_DELEGCUR () {0x200000;}' unless defined(&NFSLCK_DELEGCUR);
    eval 'sub NFSLCK_DELEGPREV () {0x400000;}' unless defined(&NFSLCK_DELEGPREV);
    eval 'sub NFSLCK_OLDDELEG () {0x800000;}' unless defined(&NFSLCK_OLDDELEG);
    eval 'sub NFSLCK_DELEGRECALL () {0x1000000;}' unless defined(&NFSLCK_DELEGRECALL);
    eval 'sub NFSLCK_SETATTR () {0x2000000;}' unless defined(&NFSLCK_SETATTR);
    eval 'sub NFSLCK_DELEGPURGE () {0x4000000;}' unless defined(&NFSLCK_DELEGPURGE);
    eval 'sub NFSLCK_DELEGRETURN () {0x8000000;}' unless defined(&NFSLCK_DELEGRETURN);
    eval 'sub NFSLCK_WANTWDELEG () {0x10000000;}' unless defined(&NFSLCK_WANTWDELEG);
    eval 'sub NFSLCK_WANTRDELEG () {0x20000000;}' unless defined(&NFSLCK_WANTRDELEG);
    eval 'sub NFSLCK_WANTNODELEG () {0x40000000;}' unless defined(&NFSLCK_WANTNODELEG);
    eval 'sub NFSLCK_WANTBITS () {( &NFSLCK_WANTWDELEG |  &NFSLCK_WANTRDELEG |  &NFSLCK_WANTNODELEG);}' unless defined(&NFSLCK_WANTBITS);
    eval 'sub NFSID_INITIALIZE () {0x1;}' unless defined(&NFSID_INITIALIZE);
    eval 'sub NFSID_ADDUID () {0x2;}' unless defined(&NFSID_ADDUID);
    eval 'sub NFSID_DELUID () {0x4;}' unless defined(&NFSID_DELUID);
    eval 'sub NFSID_ADDUSERNAME () {0x8;}' unless defined(&NFSID_ADDUSERNAME);
    eval 'sub NFSID_DELUSERNAME () {0x10;}' unless defined(&NFSID_DELUSERNAME);
    eval 'sub NFSID_ADDGID () {0x20;}' unless defined(&NFSID_ADDGID);
    eval 'sub NFSID_DELGID () {0x40;}' unless defined(&NFSID_DELGID);
    eval 'sub NFSID_ADDGROUPNAME () {0x80;}' unless defined(&NFSID_ADDGROUPNAME);
    eval 'sub NFSID_DELGROUPNAME () {0x100;}' unless defined(&NFSID_DELGROUPNAME);
    eval 'sub NFS_NFSSTATS () {1;}' unless defined(&NFS_NFSSTATS);
    eval 'sub NFSATTRBIT_MAXWORDS () {3;}' unless defined(&NFSATTRBIT_MAXWORDS);
    eval 'sub NFSZERO_ATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] = 0; ($b)-> $bits[1] = 0; ($b)-> $bits[2] = 0; }  &while (0));
    }' unless defined(&NFSZERO_ATTRBIT);
    eval 'sub NFSSET_ATTRBIT {
        my($t, $f) = @_;
	    eval q( &do { ($t)-> $bits[0] = ($f)-> $bits[0]; ($t)-> $bits[1] = ($f)-> $bits[1]; ($t)-> $bits[2] = ($f)-> $bits[2]; }  &while (0));
    }' unless defined(&NFSSET_ATTRBIT);
    eval 'sub NFSSETSUPP_ATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] =  &NFSATTRBIT_SUPP0; ($b)-> $bits[1] = ( &NFSATTRBIT_SUPP1 |  &NFSATTRBIT_SUPPSETONLY); ($b)-> $bits[2] =  &NFSATTRBIT_SUPP2; }  &while (0));
    }' unless defined(&NFSSETSUPP_ATTRBIT);
    eval 'sub NFSISSET_ATTRBIT {
        my($b, $p) = @_;
	    eval q((($b)-> $bits[($p) / 32] & (1<< (($p) % 32))));
    }' unless defined(&NFSISSET_ATTRBIT);
    eval 'sub NFSSETBIT_ATTRBIT {
        my($b, $p) = @_;
	    eval q((($b)-> $bits[($p) / 32] |= (1<< (($p) % 32))));
    }' unless defined(&NFSSETBIT_ATTRBIT);
    eval 'sub NFSCLRBIT_ATTRBIT {
        my($b, $p) = @_;
	    eval q((($b)-> $bits[($p) / 32] &= ~(1<< (($p) % 32))));
    }' unless defined(&NFSCLRBIT_ATTRBIT);
    eval 'sub NFSCLRALL_ATTRBIT {
        my($b, $a) = @_;
	    eval q( &do { ($b)-> $bits[0] &= ~(($a)-> $bits[0]); ($b)-> $bits[1] &= ~(($a)-> $bits[1]); ($b)-> $bits[2] &= ~(($a)-> $bits[2]); }  &while (0));
    }' unless defined(&NFSCLRALL_ATTRBIT);
    eval 'sub NFSCLRNOT_ATTRBIT {
        my($b, $a) = @_;
	    eval q( &do { ($b)-> $bits[0] &= (($a)-> $bits[0]); ($b)-> $bits[1] &= (($a)-> $bits[1]); ($b)-> $bits[2] &= (($a)-> $bits[2]); }  &while (0));
    }' unless defined(&NFSCLRNOT_ATTRBIT);
    eval 'sub NFSCLRNOTFILLABLE_ATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] &=  &NFSATTRBIT_SUPP0; ($b)-> $bits[1] &=  &NFSATTRBIT_SUPP1; ($b)-> $bits[2] &=  &NFSATTRBIT_SUPP2; }  &while (0));
    }' unless defined(&NFSCLRNOTFILLABLE_ATTRBIT);
    eval 'sub NFSCLRNOTSETABLE_ATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] &=  &NFSATTRBIT_SETABLE0; ($b)-> $bits[1] &=  &NFSATTRBIT_SETABLE1; ($b)-> $bits[2] &=  &NFSATTRBIT_SETABLE2; }  &while (0));
    }' unless defined(&NFSCLRNOTSETABLE_ATTRBIT);
    eval 'sub NFSNONZERO_ATTRBIT {
        my($b) = @_;
	    eval q((($b)-> $bits[0] || ($b)-> $bits[1] || ($b)-> $bits[2]));
    }' unless defined(&NFSNONZERO_ATTRBIT);
    eval 'sub NFSEQUAL_ATTRBIT {
        my($b, $p) = @_;
	    eval q((($b)-> $bits[0] == ($p)-> $bits[0]  && ($b)-> $bits[1] == ($p)-> $bits[1]  && ($b)-> $bits[2] == ($p)-> $bits[2]));
    }' unless defined(&NFSEQUAL_ATTRBIT);
    eval 'sub NFSGETATTR_ATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] =  &NFSATTRBIT_GETATTR0; ($b)-> $bits[1] =  &NFSATTRBIT_GETATTR1; ($b)-> $bits[2] =  &NFSATTRBIT_GETATTR2; }  &while (0));
    }' unless defined(&NFSGETATTR_ATTRBIT);
    eval 'sub NFSWCCATTR_ATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] =  &NFSATTRBIT_WCCATTR0; ($b)-> $bits[1] =  &NFSATTRBIT_WCCATTR1; ($b)-> $bits[2] =  &NFSATTRBIT_WCCATTR2; }  &while (0));
    }' unless defined(&NFSWCCATTR_ATTRBIT);
    eval 'sub NFSWRITEGETATTR_ATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] =  &NFSATTRBIT_WRITEGETATTR0; ($b)-> $bits[1] =  &NFSATTRBIT_WRITEGETATTR1; ($b)-> $bits[2] =  &NFSATTRBIT_WRITEGETATTR2; }  &while (0));
    }' unless defined(&NFSWRITEGETATTR_ATTRBIT);
    eval 'sub NFSCBGETATTR_ATTRBIT {
        my($b, $c) = @_;
	    eval q( &do { ($c)-> $bits[0] = (($b)-> $bits[0] &  &NFSATTRBIT_CBGETATTR0); ($c)-> $bits[1] = (($b)-> $bits[1] &  &NFSATTRBIT_CBGETATTR1); ($c)-> $bits[2] = (($b)-> $bits[2] &  &NFSATTRBIT_CBGETATTR2); }  &while (0));
    }' unless defined(&NFSCBGETATTR_ATTRBIT);
    eval 'sub NFSPATHCONF_GETATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] =  &NFSGETATTRBIT_PATHCONF0; ($b)-> $bits[1] =  &NFSGETATTRBIT_PATHCONF1; ($b)-> $bits[2] =  &NFSGETATTRBIT_PATHCONF2; }  &while (0));
    }' unless defined(&NFSPATHCONF_GETATTRBIT);
    eval 'sub NFSSTATFS_GETATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] =  &NFSGETATTRBIT_STATFS0; ($b)-> $bits[1] =  &NFSGETATTRBIT_STATFS1; ($b)-> $bits[2] =  &NFSGETATTRBIT_STATFS2; }  &while (0));
    }' unless defined(&NFSSTATFS_GETATTRBIT);
    eval 'sub NFSISSETSTATFS_ATTRBIT {
        my($b) = @_;
	    eval q(((($b)-> $bits[0] &  &NFSATTRBIT_STATFS0) || (($b)-> $bits[1] &  &NFSATTRBIT_STATFS1) || (($b)-> $bits[2] &  &NFSATTRBIT_STATFS2)));
    }' unless defined(&NFSISSETSTATFS_ATTRBIT);
    eval 'sub NFSCLRSTATFS_ATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] &= ~ &NFSATTRBIT_STATFS0; ($b)-> $bits[1] &= ~ &NFSATTRBIT_STATFS1; ($b)-> $bits[2] &= ~ &NFSATTRBIT_STATFS2; }  &while (0));
    }' unless defined(&NFSCLRSTATFS_ATTRBIT);
    eval 'sub NFSREADDIRPLUS_ATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] =  &NFSATTRBIT_READDIRPLUS0; ($b)-> $bits[1] =  &NFSATTRBIT_READDIRPLUS1; ($b)-> $bits[2] =  &NFSATTRBIT_READDIRPLUS2; }  &while (0));
    }' unless defined(&NFSREADDIRPLUS_ATTRBIT);
    eval 'sub NFSREFERRAL_ATTRBIT {
        my($b) = @_;
	    eval q( &do { ($b)-> $bits[0] =  &NFSATTRBIT_REFERRAL0; ($b)-> $bits[1] =  &NFSATTRBIT_REFERRAL1; ($b)-> $bits[2] =  &NFSATTRBIT_REFERRAL2; }  &while (0));
    }' unless defined(&NFSREFERRAL_ATTRBIT);
    eval 'sub NFSV4ROOT_FSID0 () {(( &int32_t) -1);}' unless defined(&NFSV4ROOT_FSID0);
    eval 'sub NFSV4ROOT_FSID1 () {(( &int32_t) -1);}' unless defined(&NFSV4ROOT_FSID1);
    eval 'sub NFSV4ROOT_REFERRAL () {(( &int32_t) -2);}' unless defined(&NFSV4ROOT_REFERRAL);
    eval 'sub NFSV4ROOT_INO () {2;}' unless defined(&NFSV4ROOT_INO);
    eval 'sub NFSV4ROOT_GEN () {1;}' unless defined(&NFSV4ROOT_GEN);
    if(defined(&_KERNEL) || defined(&KERNEL)) {
	eval 'sub NFSIGNORE_SOERROR {
	    my($s, $e) = @_;
    	    eval q((($e) !=  &EINTR  && ($e) !=  &ERESTART  && ($e) !=  &EWOULDBLOCK  && (($s) &  &PR_CONNREQUIRED) == 0));
	}' unless defined(&NFSIGNORE_SOERROR);
	eval 'sub NFSR_SNDLOCK () {0x1;}' unless defined(&NFSR_SNDLOCK);
	eval 'sub NFSR_WANTSND () {0x2;}' unless defined(&NFSR_WANTSND);
	eval 'sub NFSR_RCVLOCK () {0x4;}' unless defined(&NFSR_RCVLOCK);
	eval 'sub NFSR_WANTRCV () {0x8;}' unless defined(&NFSR_WANTRCV);
	eval 'sub NFSR_RESERVEDPORT () {0x10;}' unless defined(&NFSR_RESERVEDPORT);
	eval 'sub NFSR_LOCALHOST () {0x20;}' unless defined(&NFSR_LOCALHOST);
	eval 'sub R_DONTRECOVER () {0x100;}' unless defined(&R_DONTRECOVER);
	eval 'sub KERBV_MECH () {0;}' unless defined(&KERBV_MECH);
	eval 'sub nd_princlen () { &nd_gssnamelen;}' unless defined(&nd_princlen);
	eval 'sub nd_principal () { &nd_gssname;}' unless defined(&nd_principal);
	eval 'sub ND_DONTSAVEREPLY () {0x1;}' unless defined(&ND_DONTSAVEREPLY);
	eval 'sub ND_SAVEREPLY () {0x2;}' unless defined(&ND_SAVEREPLY);
	eval 'sub ND_NFSV2 () {0x4;}' unless defined(&ND_NFSV2);
	eval 'sub ND_NFSV3 () {0x8;}' unless defined(&ND_NFSV3);
	eval 'sub ND_NFSV4 () {0x10;}' unless defined(&ND_NFSV4);
	eval 'sub ND_KERBV () {0x20;}' unless defined(&ND_KERBV);
	eval 'sub ND_GSSINTEGRITY () {0x40;}' unless defined(&ND_GSSINTEGRITY);
	eval 'sub ND_GSSPRIVACY () {0x80;}' unless defined(&ND_GSSPRIVACY);
	eval 'sub ND_WINDOWVERF () {0x100;}' unless defined(&ND_WINDOWVERF);
	eval 'sub ND_GSSINITREPLY () {0x200;}' unless defined(&ND_GSSINITREPLY);
	eval 'sub ND_STREAMSOCK () {0x400;}' unless defined(&ND_STREAMSOCK);
	eval 'sub ND_PUBLOOKUP () {0x800;}' unless defined(&ND_PUBLOOKUP);
	eval 'sub ND_USEGSSNAME () {0x1000;}' unless defined(&ND_USEGSSNAME);
	eval 'sub ND_SAMETCPCONN () {0x2000;}' unless defined(&ND_SAMETCPCONN);
	eval 'sub ND_IMPLIEDCLID () {0x4000;}' unless defined(&ND_IMPLIEDCLID);
	eval 'sub ND_NOMOREDATA () {0x8000;}' unless defined(&ND_NOMOREDATA);
	eval 'sub ND_V4WCCATTR () {0x10000;}' unless defined(&ND_V4WCCATTR);
	eval 'sub ND_NFSCB () {0x20000;}' unless defined(&ND_NFSCB);
	eval 'sub ND_AUTHNONE () {0x40000;}' unless defined(&ND_AUTHNONE);
	eval 'sub ND_EXAUTHSYS () {0x80000;}' unless defined(&ND_EXAUTHSYS);
	eval 'sub ND_EXGSS () {0x100000;}' unless defined(&ND_EXGSS);
	eval 'sub ND_EXGSSINTEGRITY () {0x200000;}' unless defined(&ND_EXGSSINTEGRITY);
	eval 'sub ND_EXGSSPRIVACY () {0x400000;}' unless defined(&ND_EXGSSPRIVACY);
	eval 'sub ND_INCRSEQID () {0x800000;}' unless defined(&ND_INCRSEQID);
	eval 'sub ND_NFSCL () {0x1000000;}' unless defined(&ND_NFSCL);
	eval 'sub ND_NFSV41 () {0x2000000;}' unless defined(&ND_NFSV41);
	eval 'sub ND_HASSEQUENCE () {0x4000000;}' unless defined(&ND_HASSEQUENCE);
	eval 'sub ND_CACHETHIS () {0x8000000;}' unless defined(&ND_CACHETHIS);
	eval 'sub ND_LASTOP () {0x10000000;}' unless defined(&ND_LASTOP);
	eval 'sub ND_LOOPBADSESS () {0x20000000;}' unless defined(&ND_LOOPBADSESS);
	eval 'sub ND_GSS () {( &ND_KERBV);}' unless defined(&ND_GSS);
	eval 'sub NFSRVSEQID_FIRST () {0x1;}' unless defined(&NFSRVSEQID_FIRST);
	eval 'sub NFSRVSEQID_LAST () {0x2;}' unless defined(&NFSRVSEQID_LAST);
	eval 'sub NFSRVSEQID_OPEN () {0x4;}' unless defined(&NFSRVSEQID_OPEN);
	eval 'sub LIST_NEWHEAD {
	    my($nhead, $ohead, $field) = @_;
    	    eval q( &do {  &if ((($nhead)-> &lh_first = ($ohead)-> &lh_first) !=  &NULL) ($ohead)-> ($lh_first->{field}->{le_prev}) = ($nhead)-> &lh_first; ($ohead)-> &lh_first =  &NULL; }  &while (0));
	}' unless defined(&LIST_NEWHEAD);
	eval 'sub LIST_PREPEND {
	    my($head, $phead, $lelm, $field) = @_;
    	    eval q( &do {  &if (($head)-> &lh_first !=  &NULL) { ($lelm)-> ($field->{le_next}) = ($head)-> &lh_first; ($lelm)-> ($field->{le_next}->{field}->{le_prev}) = ($lelm)-> ($field->{le_next}); } ($head)-> &lh_first = ($phead)-> &lh_first; ($head)-> ($lh_first->{field}->{le_prev}) = ($head)-> &lh_first; }  &while (0));
	}' unless defined(&LIST_PREPEND);
	eval 'sub NFSV4LOCK_LOCK () {0x1;}' unless defined(&NFSV4LOCK_LOCK);
	eval 'sub NFSV4LOCK_LOCKWANTED () {0x2;}' unless defined(&NFSV4LOCK_LOCKWANTED);
	eval 'sub NFSV4LOCK_WANTED () {0x4;}' unless defined(&NFSV4LOCK_WANTED);
	eval 'sub NFSACCCHK_NOOVERRIDE () {0;}' unless defined(&NFSACCCHK_NOOVERRIDE);
	eval 'sub NFSACCCHK_ALLOWROOT () {1;}' unless defined(&NFSACCCHK_ALLOWROOT);
	eval 'sub NFSACCCHK_ALLOWOWNER () {2;}' unless defined(&NFSACCCHK_ALLOWOWNER);
	eval 'sub NFSACCCHK_VPNOTLOCKED () {0;}' unless defined(&NFSACCCHK_VPNOTLOCKED);
	eval 'sub NFSACCCHK_VPISLOCKED () {1;}' unless defined(&NFSACCCHK_VPISLOCKED);
    }
}
1;
