require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFS_NFSCLSTATE_H_)) {
    eval 'sub _NFS_NFSCLSTATE_H_ () {1;}' unless defined(&_NFS_NFSCLSTATE_H_);
    eval 'sub NFSCLDELEGHASHSIZE () {256;}' unless defined(&NFSCLDELEGHASHSIZE);
    eval 'sub NFSCLDELEGHASH {
        my($c, $f, $l) = @_;
	    eval q(((($c)-> $nfsc_deleghash[ &ncl_hash(($f), ($l)) %  &NFSCLDELEGHASHSIZE])));
    }' unless defined(&NFSCLDELEGHASH);
    eval 'sub NFSCLLAYOUTHASHSIZE () {256;}' unless defined(&NFSCLLAYOUTHASHSIZE);
    eval 'sub NFSCLLAYOUTHASH {
        my($c, $f, $l) = @_;
	    eval q(((($c)-> $nfsc_layouthash[ &ncl_hash(($f), ($l)) %  &NFSCLLAYOUTHASHSIZE])));
    }' unless defined(&NFSCLLAYOUTHASH);
    eval 'sub NFSCLDS_HASWRITEVERF () {0x1;}' unless defined(&NFSCLDS_HASWRITEVERF);
    eval 'sub NFSCLDS_MDS () {0x2;}' unless defined(&NFSCLDS_MDS);
    eval 'sub NFSCLDS_DS () {0x4;}' unless defined(&NFSCLDS_DS);
    eval 'sub NFSCLDS_CLOSED () {0x8;}' unless defined(&NFSCLDS_CLOSED);
    eval 'sub NFSCLFLAGS_INITED () {0x1;}' unless defined(&NFSCLFLAGS_INITED);
    eval 'sub NFSCLFLAGS_HASCLIENTID () {0x2;}' unless defined(&NFSCLFLAGS_HASCLIENTID);
    eval 'sub NFSCLFLAGS_RECOVER () {0x4;}' unless defined(&NFSCLFLAGS_RECOVER);
    eval 'sub NFSCLFLAGS_UMOUNT () {0x8;}' unless defined(&NFSCLFLAGS_UMOUNT);
    eval 'sub NFSCLFLAGS_HASTHREAD () {0x10;}' unless defined(&NFSCLFLAGS_HASTHREAD);
    eval 'sub NFSCLFLAGS_AFINET6 () {0x20;}' unless defined(&NFSCLFLAGS_AFINET6);
    eval 'sub NFSCLFLAGS_EXPIREIT () {0x40;}' unless defined(&NFSCLFLAGS_EXPIREIT);
    eval 'sub NFSCLFLAGS_FIRSTDELEG () {0x80;}' unless defined(&NFSCLFLAGS_FIRSTDELEG);
    eval 'sub NFSCLFLAGS_GOTDELEG () {0x100;}' unless defined(&NFSCLFLAGS_GOTDELEG);
    eval 'sub NFSCLFLAGS_RECVRINPROG () {0x200;}' unless defined(&NFSCLFLAGS_RECVRINPROG);
    eval 'sub NFSCLDL_READ () {0x1;}' unless defined(&NFSCLDL_READ);
    eval 'sub NFSCLDL_WRITE () {0x2;}' unless defined(&NFSCLDL_WRITE);
    eval 'sub NFSCLDL_RECALL () {0x4;}' unless defined(&NFSCLDL_RECALL);
    eval 'sub NFSCLDL_NEEDRECLAIM () {0x8;}' unless defined(&NFSCLDL_NEEDRECLAIM);
    eval 'sub NFSCLDL_ZAPPED () {0x10;}' unless defined(&NFSCLDL_ZAPPED);
    eval 'sub NFSCLDL_MODTIMESET () {0x20;}' unless defined(&NFSCLDL_MODTIMESET);
    eval 'sub NFSCLDL_DELEGRET () {0x40;}' unless defined(&NFSCLDL_DELEGRET);
    eval 'sub NFSCLOPEN_OK () {0;}' unless defined(&NFSCLOPEN_OK);
    eval 'sub NFSCLOPEN_DOOPEN () {1;}' unless defined(&NFSCLOPEN_DOOPEN);
    eval 'sub NFSCLOPEN_DOOPENDOWNGRADE () {2;}' unless defined(&NFSCLOPEN_DOOPENDOWNGRADE);
    eval 'sub NFSCLOPEN_SETCRED () {3;}' unless defined(&NFSCLOPEN_SETCRED);
    eval 'sub NFSLY_FILES () {0x1;}' unless defined(&NFSLY_FILES);
    eval 'sub NFSLY_BLOCK () {0x2;}' unless defined(&NFSLY_BLOCK);
    eval 'sub NFSLY_OBJECT () {0x4;}' unless defined(&NFSLY_OBJECT);
    eval 'sub NFSLY_RECALL () {0x8;}' unless defined(&NFSLY_RECALL);
    eval 'sub NFSLY_RECALLFILE () {0x10;}' unless defined(&NFSLY_RECALLFILE);
    eval 'sub NFSLY_RECALLFSID () {0x20;}' unless defined(&NFSLY_RECALLFSID);
    eval 'sub NFSLY_RECALLALL () {0x40;}' unless defined(&NFSLY_RECALLALL);
    eval 'sub NFSLY_RETONCLOSE () {0x80;}' unless defined(&NFSLY_RETONCLOSE);
    eval 'sub NFSLY_WRITTEN () {0x100;}' unless defined(&NFSLY_WRITTEN);
    eval 'sub NFSFL_RECALL () {0x1;}' unless defined(&NFSFL_RECALL);
    eval 'sub NFSCL_INCRSEQID {
        my($s, $n) = @_;
	    eval q( &do {  &if ((($n)-> &nd_flag &  &ND_INCRSEQID)) ($s)++; }  &while (0));
    }' unless defined(&NFSCL_INCRSEQID);
}
1;
