require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFS_NFSKPIPORT_H_)) {
    eval 'sub _NFS_NFSKPIPORT_H_ () {1;}' unless defined(&_NFS_NFSKPIPORT_H_);
    eval 'sub vfs_statfs {
        my($m) = @_;
	    eval q(((($m)-> &mnt_stat)));
    }' unless defined(&vfs_statfs);
    eval 'sub vfs_flags {
        my($m) = @_;
	    eval q((($m)-> &mnt_flag));
    }' unless defined(&vfs_flags);
    eval 'sub vnode_mount {
        my($v) = @_;
	    eval q((($v)-> &v_mount));
    }' unless defined(&vnode_mount);
    eval 'sub vnode_vtype {
        my($v) = @_;
	    eval q((($v)-> &v_type));
    }' unless defined(&vnode_vtype);
    eval 'sub mbuf_freem {
        my($m) = @_;
	    eval q( &m_freem($m));
    }' unless defined(&mbuf_freem);
    eval 'sub mbuf_data {
        my($m) = @_;
	    eval q( &mtod(($m),  &void *));
    }' unless defined(&mbuf_data);
    eval 'sub mbuf_len {
        my($m) = @_;
	    eval q((($m)-> &m_len));
    }' unless defined(&mbuf_len);
    eval 'sub mbuf_next {
        my($m) = @_;
	    eval q((($m)-> &m_next));
    }' unless defined(&mbuf_next);
    eval 'sub mbuf_setlen {
        my($m, $l) = @_;
	    eval q((($m)-> &m_len = ($l)));
    }' unless defined(&mbuf_setlen);
    eval 'sub mbuf_setnext {
        my($m, $p) = @_;
	    eval q((($m)-> &m_next = ($p)));
    }' unless defined(&mbuf_setnext);
    eval 'sub mbuf_pkthdr_len {
        my($m) = @_;
	    eval q((($m)-> ($m_pkthdr->{len})));
    }' unless defined(&mbuf_pkthdr_len);
    eval 'sub mbuf_pkthdr_setlen {
        my($m, $l) = @_;
	    eval q((($m)-> ($m_pkthdr->{len}) = ($l)));
    }' unless defined(&mbuf_pkthdr_setlen);
    eval 'sub mbuf_pkthdr_setrcvif {
        my($m, $p) = @_;
	    eval q((($m)-> ($m_pkthdr->{rcvif}) = ($p)));
    }' unless defined(&mbuf_pkthdr_setrcvif);
    eval 'sub CAST_USER_ADDR_T {
        my($a) = @_;
	    eval q(($a));
    }' unless defined(&CAST_USER_ADDR_T);
    eval 'sub CAST_DOWN {
        my($c, $a) = @_;
	    eval q((($c) ($a)));
    }' unless defined(&CAST_DOWN);
    eval 'sub uio_uio_resid {
        my($p) = @_;
	    eval q((($p)-> &uio_resid));
    }' unless defined(&uio_uio_resid);
    eval 'sub uio_uio_resid_add {
        my($p, $v) = @_;
	    eval q((($p)-> &uio_resid += ($v)));
    }' unless defined(&uio_uio_resid_add);
    eval 'sub uio_uio_resid_set {
        my($p, $v) = @_;
	    eval q((($p)-> &uio_resid = ($v)));
    }' unless defined(&uio_uio_resid_set);
    eval 'sub uio_iov_base {
        my($p) = @_;
	    eval q((($p)-> ($uio_iov->{iov_base})));
    }' unless defined(&uio_iov_base);
    eval 'sub uio_iov_base_add {
        my($p, $v) = @_;
	    eval q( &do { \'char\' * &pp;  &pp = ($p)-> ($uio_iov->{iov_base});  &pp += ($v); ($p)-> ($uio_iov->{iov_base}) = ( &void *) &pp; }  &while (0));
    }' unless defined(&uio_iov_base_add);
    eval 'sub uio_iov_len {
        my($p) = @_;
	    eval q((($p)-> ($uio_iov->{iov_len})));
    }' unless defined(&uio_iov_len);
    eval 'sub uio_iov_len_add {
        my($p, $v) = @_;
	    eval q((($p)-> ($uio_iov->{iov_len}) += ($v)));
    }' unless defined(&uio_iov_len_add);
}
1;
