require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFS_NFSPORT_H_)) {
    eval 'sub _NFS_NFSPORT_H_ () {1;}' unless defined(&_NFS_NFSPORT_H_);
    if(defined(&_KERNEL)) {
	require 'sys/unistd.ph';
	require 'sys/param.ph';
	require 'sys/systm.ph';
	require 'sys/conf.ph';
	require 'sys/dirent.ph';
	require 'sys/domain.ph';
	require 'sys/fcntl.ph';
	require 'sys/file.ph';
	require 'sys/filedesc.ph';
	require 'sys/jail.ph';
	require 'sys/kernel.ph';
	require 'sys/lockf.ph';
	require 'sys/malloc.ph';
	require 'sys/mbuf.ph';
	require 'sys/mount.ph';
	require 'sys/mutex.ph';
	require 'sys/namei.ph';
	require 'sys/proc.ph';
	require 'sys/protosw.ph';
	require 'sys/reboot.ph';
	require 'sys/resourcevar.ph';
	require 'sys/signalvar.ph';
	require 'sys/socket.ph';
	require 'sys/socketvar.ph';
	require 'sys/stat.ph';
	require 'sys/syslog.ph';
	require 'sys/sysproto.ph';
	require 'sys/time.ph';
	require 'sys/uio.ph';
	require 'sys/vnode.ph';
	require 'sys/bio.ph';
	require 'sys/buf.ph';
	require 'sys/acl.ph';
	require 'sys/module.ph';
	require 'sys/sysent.ph';
	require 'sys/syscall.ph';
	require 'sys/priv.ph';
	require 'sys/kthread.ph';
	require 'sys/syscallsubr.ph';
	require 'net/if.ph';
	require 'net/if_var.ph';
	require 'net/radix.ph';
	require 'net/route.ph';
	require 'net/if_dl.ph';
	require 'netinet/in.ph';
	require 'netinet/in_pcb.ph';
	require 'netinet/in_systm.ph';
	require 'netinet/in_var.ph';
	require 'netinet/ip.ph';
	require 'netinet/ip_var.ph';
	require 'netinet/tcp.ph';
	require 'netinet/tcp_fsm.ph';
	require 'netinet/tcp_seq.ph';
	require 'netinet/tcp_timer.ph';
	require 'netinet/tcp_var.ph';
	require 'machine/in_cksum.ph';
	require 'crypto/des/des.ph';
	require 'sys/md5.ph';
	require 'rpc/rpc.ph';
	require 'rpc/rpcsec_gss.ph';
	eval 'sub APPLESTATIC () {1;}' unless defined(&APPLESTATIC);
	require 'ufs/ufs/dir.ph';
	require 'ufs/ufs/quota.ph';
	require 'ufs/ufs/inode.ph';
	require 'ufs/ufs/extattr.ph';
	require 'ufs/ufs/ufsmount.ph';
	require 'vm/uma.ph';
	require 'vm/vm.ph';
	require 'vm/vm_object.ph';
	require 'vm/vm_extern.ph';
	require 'nfs/nfssvc.ph';
	require './fs/nfs/opt_nfs.ph';
	require './fs/nfs/opt_ufs.ph';
	eval 'sub NFSSOCKADDR_T () {\'struct sockaddr\' *;}' unless defined(&NFSSOCKADDR_T);
	eval 'sub NFSPROC_T () {\'struct thread\';}' unless defined(&NFSPROC_T);
	eval 'sub NFSDEV_T () { &dev_t;}' unless defined(&NFSDEV_T);
	eval 'sub NFSSVCARGS () { &nfssvc_args;}' unless defined(&NFSSVCARGS);
	eval 'sub NFSACL_T () {\'struct acl\';}' unless defined(&NFSACL_T);
	eval 'sub NFS_ACCESS_ARGS () {\'struct vop_access_args\';}' unless defined(&NFS_ACCESS_ARGS);
	eval 'sub NFS_OPEN_ARGS () {\'struct vop_open_args\';}' unless defined(&NFS_OPEN_ARGS);
	eval 'sub NFS_GETATTR_ARGS () {\'struct vop_getattr_args\';}' unless defined(&NFS_GETATTR_ARGS);
	eval 'sub NFS_LOOKUP_ARGS () {\'struct vop_lookup_args\';}' unless defined(&NFS_LOOKUP_ARGS);
	eval 'sub NFS_READDIR_ARGS () {\'struct vop_readdir_args\';}' unless defined(&NFS_READDIR_ARGS);
	eval 'sub NFSMGET {
	    my($m) = @_;
    	    eval q( &do {  &MGET(($m),  &M_WAITOK,  &MT_DATA);  &while (($m) ==  &NULL ) { ( &void)  &nfs_catnap( &PZERO, 0, \\"nfsmget\\");  &MGET(($m),  &M_WAITOK,  &MT_DATA); } }  &while (0));
	}' unless defined(&NFSMGET);
	eval 'sub NFSMGETHDR {
	    my($m) = @_;
    	    eval q( &do {  &MGETHDR(($m),  &M_WAITOK,  &MT_DATA);  &while (($m) ==  &NULL ) { ( &void)  &nfs_catnap( &PZERO, 0, \\"nfsmget\\");  &MGETHDR(($m),  &M_WAITOK,  &MT_DATA); } }  &while (0));
	}' unless defined(&NFSMGETHDR);
	eval 'sub NFSMCLGET {
	    my($m, $w) = @_;
    	    eval q( &do {  &MGET(($m),  &M_WAITOK,  &MT_DATA);  &while (($m) ==  &NULL ) { ( &void)  &nfs_catnap( &PZERO, 0, \\"nfsmget\\");  &MGET(($m),  &M_WAITOK,  &MT_DATA); }  &MCLGET(($m), ($w)); }  &while (0));
	}' unless defined(&NFSMCLGET);
	eval 'sub NFSMCLGETHDR {
	    my($m, $w) = @_;
    	    eval q( &do {  &MGETHDR(($m),  &M_WAITOK,  &MT_DATA);  &while (($m) ==  &NULL ) { ( &void)  &nfs_catnap( &PZERO, 0, \\"nfsmget\\");  &MGETHDR(($m),  &M_WAITOK,  &MT_DATA); } }  &while (0));
	}' unless defined(&NFSMCLGETHDR);
	eval 'sub NFSMTOD () { &mtod;}' unless defined(&NFSMTOD);
	eval 'sub NFSV4CL_LOCKNAMELEN () {12;}' unless defined(&NFSV4CL_LOCKNAMELEN);
	eval 'sub NFSMUTEX_T () {\'struct mtx\';}' unless defined(&NFSMUTEX_T);
    }
    eval 'sub NFSV4OP_ACCESS () {3;}' unless defined(&NFSV4OP_ACCESS);
    eval 'sub NFSV4OP_CLOSE () {4;}' unless defined(&NFSV4OP_CLOSE);
    eval 'sub NFSV4OP_COMMIT () {5;}' unless defined(&NFSV4OP_COMMIT);
    eval 'sub NFSV4OP_CREATE () {6;}' unless defined(&NFSV4OP_CREATE);
    eval 'sub NFSV4OP_DELEGPURGE () {7;}' unless defined(&NFSV4OP_DELEGPURGE);
    eval 'sub NFSV4OP_DELEGRETURN () {8;}' unless defined(&NFSV4OP_DELEGRETURN);
    eval 'sub NFSV4OP_GETATTR () {9;}' unless defined(&NFSV4OP_GETATTR);
    eval 'sub NFSV4OP_GETFH () {10;}' unless defined(&NFSV4OP_GETFH);
    eval 'sub NFSV4OP_LINK () {11;}' unless defined(&NFSV4OP_LINK);
    eval 'sub NFSV4OP_LOCK () {12;}' unless defined(&NFSV4OP_LOCK);
    eval 'sub NFSV4OP_LOCKT () {13;}' unless defined(&NFSV4OP_LOCKT);
    eval 'sub NFSV4OP_LOCKU () {14;}' unless defined(&NFSV4OP_LOCKU);
    eval 'sub NFSV4OP_LOOKUP () {15;}' unless defined(&NFSV4OP_LOOKUP);
    eval 'sub NFSV4OP_LOOKUPP () {16;}' unless defined(&NFSV4OP_LOOKUPP);
    eval 'sub NFSV4OP_NVERIFY () {17;}' unless defined(&NFSV4OP_NVERIFY);
    eval 'sub NFSV4OP_OPEN () {18;}' unless defined(&NFSV4OP_OPEN);
    eval 'sub NFSV4OP_OPENATTR () {19;}' unless defined(&NFSV4OP_OPENATTR);
    eval 'sub NFSV4OP_OPENCONFIRM () {20;}' unless defined(&NFSV4OP_OPENCONFIRM);
    eval 'sub NFSV4OP_OPENDOWNGRADE () {21;}' unless defined(&NFSV4OP_OPENDOWNGRADE);
    eval 'sub NFSV4OP_PUTFH () {22;}' unless defined(&NFSV4OP_PUTFH);
    eval 'sub NFSV4OP_PUTPUBFH () {23;}' unless defined(&NFSV4OP_PUTPUBFH);
    eval 'sub NFSV4OP_PUTROOTFH () {24;}' unless defined(&NFSV4OP_PUTROOTFH);
    eval 'sub NFSV4OP_READ () {25;}' unless defined(&NFSV4OP_READ);
    eval 'sub NFSV4OP_READDIR () {26;}' unless defined(&NFSV4OP_READDIR);
    eval 'sub NFSV4OP_READLINK () {27;}' unless defined(&NFSV4OP_READLINK);
    eval 'sub NFSV4OP_REMOVE () {28;}' unless defined(&NFSV4OP_REMOVE);
    eval 'sub NFSV4OP_RENAME () {29;}' unless defined(&NFSV4OP_RENAME);
    eval 'sub NFSV4OP_RENEW () {30;}' unless defined(&NFSV4OP_RENEW);
    eval 'sub NFSV4OP_RESTOREFH () {31;}' unless defined(&NFSV4OP_RESTOREFH);
    eval 'sub NFSV4OP_SAVEFH () {32;}' unless defined(&NFSV4OP_SAVEFH);
    eval 'sub NFSV4OP_SECINFO () {33;}' unless defined(&NFSV4OP_SECINFO);
    eval 'sub NFSV4OP_SETATTR () {34;}' unless defined(&NFSV4OP_SETATTR);
    eval 'sub NFSV4OP_SETCLIENTID () {35;}' unless defined(&NFSV4OP_SETCLIENTID);
    eval 'sub NFSV4OP_SETCLIENTIDCFRM () {36;}' unless defined(&NFSV4OP_SETCLIENTIDCFRM);
    eval 'sub NFSV4OP_VERIFY () {37;}' unless defined(&NFSV4OP_VERIFY);
    eval 'sub NFSV4OP_WRITE () {38;}' unless defined(&NFSV4OP_WRITE);
    eval 'sub NFSV4OP_RELEASELCKOWN () {39;}' unless defined(&NFSV4OP_RELEASELCKOWN);
    eval 'sub NFSV4OP_NOPS () {40;}' unless defined(&NFSV4OP_NOPS);
    eval 'sub NFSV4OP_BACKCHANNELCTL () {40;}' unless defined(&NFSV4OP_BACKCHANNELCTL);
    eval 'sub NFSV4OP_BINDCONNTOSESS () {41;}' unless defined(&NFSV4OP_BINDCONNTOSESS);
    eval 'sub NFSV4OP_EXCHANGEID () {42;}' unless defined(&NFSV4OP_EXCHANGEID);
    eval 'sub NFSV4OP_CREATESESSION () {43;}' unless defined(&NFSV4OP_CREATESESSION);
    eval 'sub NFSV4OP_DESTROYSESSION () {44;}' unless defined(&NFSV4OP_DESTROYSESSION);
    eval 'sub NFSV4OP_FREESTATEID () {45;}' unless defined(&NFSV4OP_FREESTATEID);
    eval 'sub NFSV4OP_GETDIRDELEG () {46;}' unless defined(&NFSV4OP_GETDIRDELEG);
    eval 'sub NFSV4OP_GETDEVINFO () {47;}' unless defined(&NFSV4OP_GETDEVINFO);
    eval 'sub NFSV4OP_GETDEVLIST () {48;}' unless defined(&NFSV4OP_GETDEVLIST);
    eval 'sub NFSV4OP_LAYOUTCOMMIT () {49;}' unless defined(&NFSV4OP_LAYOUTCOMMIT);
    eval 'sub NFSV4OP_LAYOUTGET () {50;}' unless defined(&NFSV4OP_LAYOUTGET);
    eval 'sub NFSV4OP_LAYOUTRETURN () {51;}' unless defined(&NFSV4OP_LAYOUTRETURN);
    eval 'sub NFSV4OP_SECINFONONAME () {52;}' unless defined(&NFSV4OP_SECINFONONAME);
    eval 'sub NFSV4OP_SEQUENCE () {53;}' unless defined(&NFSV4OP_SEQUENCE);
    eval 'sub NFSV4OP_SETSSV () {54;}' unless defined(&NFSV4OP_SETSSV);
    eval 'sub NFSV4OP_TESTSTATEID () {55;}' unless defined(&NFSV4OP_TESTSTATEID);
    eval 'sub NFSV4OP_WANTDELEG () {56;}' unless defined(&NFSV4OP_WANTDELEG);
    eval 'sub NFSV4OP_DESTROYCLIENTID () {57;}' unless defined(&NFSV4OP_DESTROYCLIENTID);
    eval 'sub NFSV4OP_RECLAIMCOMPL () {58;}' unless defined(&NFSV4OP_RECLAIMCOMPL);
    eval 'sub NFSV41_NOPS () {59;}' unless defined(&NFSV41_NOPS);
    eval 'sub NFSV42_NOPS () {72;}' unless defined(&NFSV42_NOPS);
    eval 'sub NFSV4OP_OPILLEGAL () {10044;}' unless defined(&NFSV4OP_OPILLEGAL);
    eval 'sub NFSV4OP_SYMLINK () {( &NFSV42_NOPS);}' unless defined(&NFSV4OP_SYMLINK);
    eval 'sub NFSV4OP_MKDIR () {( &NFSV42_NOPS + 1);}' unless defined(&NFSV4OP_MKDIR);
    eval 'sub NFSV4OP_RMDIR () {( &NFSV42_NOPS + 2);}' unless defined(&NFSV4OP_RMDIR);
    eval 'sub NFSV4OP_READDIRPLUS () {( &NFSV42_NOPS + 3);}' unless defined(&NFSV4OP_READDIRPLUS);
    eval 'sub NFSV4OP_MKNOD () {( &NFSV42_NOPS + 4);}' unless defined(&NFSV4OP_MKNOD);
    eval 'sub NFSV4OP_FSSTAT () {( &NFSV42_NOPS + 5);}' unless defined(&NFSV4OP_FSSTAT);
    eval 'sub NFSV4OP_FSINFO () {( &NFSV42_NOPS + 6);}' unless defined(&NFSV4OP_FSINFO);
    eval 'sub NFSV4OP_PATHCONF () {( &NFSV42_NOPS + 7);}' unless defined(&NFSV4OP_PATHCONF);
    eval 'sub NFSV4OP_V3CREATE () {( &NFSV42_NOPS + 8);}' unless defined(&NFSV4OP_V3CREATE);
    eval 'sub NFSV4OP_FAKENOPS () {9;}' unless defined(&NFSV4OP_FAKENOPS);
    eval 'sub NFSV4OP_CBGETATTR () {3;}' unless defined(&NFSV4OP_CBGETATTR);
    eval 'sub NFSV4OP_CBRECALL () {4;}' unless defined(&NFSV4OP_CBRECALL);
    eval 'sub NFSV4OP_CBNOPS () {5;}' unless defined(&NFSV4OP_CBNOPS);
    eval 'sub NFSV4OP_CBLAYOUTRECALL () {5;}' unless defined(&NFSV4OP_CBLAYOUTRECALL);
    eval 'sub NFSV4OP_CBNOTIFY () {6;}' unless defined(&NFSV4OP_CBNOTIFY);
    eval 'sub NFSV4OP_CBPUSHDELEG () {7;}' unless defined(&NFSV4OP_CBPUSHDELEG);
    eval 'sub NFSV4OP_CBRECALLANY () {8;}' unless defined(&NFSV4OP_CBRECALLANY);
    eval 'sub NFSV4OP_CBRECALLOBJAVAIL () {9;}' unless defined(&NFSV4OP_CBRECALLOBJAVAIL);
    eval 'sub NFSV4OP_CBRECALLSLOT () {10;}' unless defined(&NFSV4OP_CBRECALLSLOT);
    eval 'sub NFSV4OP_CBSEQUENCE () {11;}' unless defined(&NFSV4OP_CBSEQUENCE);
    eval 'sub NFSV4OP_CBWANTCANCELLED () {12;}' unless defined(&NFSV4OP_CBWANTCANCELLED);
    eval 'sub NFSV4OP_CBNOTIFYLOCK () {13;}' unless defined(&NFSV4OP_CBNOTIFYLOCK);
    eval 'sub NFSV4OP_CBNOTIFYDEVID () {14;}' unless defined(&NFSV4OP_CBNOTIFYDEVID);
    eval 'sub NFSV41_CBNOPS () {15;}' unless defined(&NFSV41_CBNOPS);
    eval 'sub NFSV42_CBNOPS () {16;}' unless defined(&NFSV42_CBNOPS);
    unless(defined(&NFS_V3NPROCS)) {
	eval 'sub NFS_V3NPROCS () {22;}' unless defined(&NFS_V3NPROCS);
	eval 'sub NFSPROC_LOOKUPP () {22;}' unless defined(&NFSPROC_LOOKUPP);
	eval 'sub NFSPROC_SETCLIENTID () {23;}' unless defined(&NFSPROC_SETCLIENTID);
	eval 'sub NFSPROC_SETCLIENTIDCFRM () {24;}' unless defined(&NFSPROC_SETCLIENTIDCFRM);
	eval 'sub NFSPROC_LOCK () {25;}' unless defined(&NFSPROC_LOCK);
	eval 'sub NFSPROC_LOCKU () {26;}' unless defined(&NFSPROC_LOCKU);
	eval 'sub NFSPROC_OPEN () {27;}' unless defined(&NFSPROC_OPEN);
	eval 'sub NFSPROC_CLOSE () {28;}' unless defined(&NFSPROC_CLOSE);
	eval 'sub NFSPROC_OPENCONFIRM () {29;}' unless defined(&NFSPROC_OPENCONFIRM);
	eval 'sub NFSPROC_LOCKT () {30;}' unless defined(&NFSPROC_LOCKT);
	eval 'sub NFSPROC_OPENDOWNGRADE () {31;}' unless defined(&NFSPROC_OPENDOWNGRADE);
	eval 'sub NFSPROC_RENEW () {32;}' unless defined(&NFSPROC_RENEW);
	eval 'sub NFSPROC_PUTROOTFH () {33;}' unless defined(&NFSPROC_PUTROOTFH);
	eval 'sub NFSPROC_RELEASELCKOWN () {34;}' unless defined(&NFSPROC_RELEASELCKOWN);
	eval 'sub NFSPROC_DELEGRETURN () {35;}' unless defined(&NFSPROC_DELEGRETURN);
	eval 'sub NFSPROC_RETDELEGREMOVE () {36;}' unless defined(&NFSPROC_RETDELEGREMOVE);
	eval 'sub NFSPROC_RETDELEGRENAME1 () {37;}' unless defined(&NFSPROC_RETDELEGRENAME1);
	eval 'sub NFSPROC_RETDELEGRENAME2 () {38;}' unless defined(&NFSPROC_RETDELEGRENAME2);
	eval 'sub NFSPROC_GETACL () {39;}' unless defined(&NFSPROC_GETACL);
	eval 'sub NFSPROC_SETACL () {40;}' unless defined(&NFSPROC_SETACL);
	eval 'sub NFSV4_NPROCS () {41;}' unless defined(&NFSV4_NPROCS);
	eval 'sub NFSPROC_EXCHANGEID () {41;}' unless defined(&NFSPROC_EXCHANGEID);
	eval 'sub NFSPROC_CREATESESSION () {42;}' unless defined(&NFSPROC_CREATESESSION);
	eval 'sub NFSPROC_DESTROYSESSION () {43;}' unless defined(&NFSPROC_DESTROYSESSION);
	eval 'sub NFSPROC_DESTROYCLIENT () {44;}' unless defined(&NFSPROC_DESTROYCLIENT);
	eval 'sub NFSPROC_FREESTATEID () {45;}' unless defined(&NFSPROC_FREESTATEID);
	eval 'sub NFSPROC_LAYOUTGET () {46;}' unless defined(&NFSPROC_LAYOUTGET);
	eval 'sub NFSPROC_GETDEVICEINFO () {47;}' unless defined(&NFSPROC_GETDEVICEINFO);
	eval 'sub NFSPROC_LAYOUTCOMMIT () {48;}' unless defined(&NFSPROC_LAYOUTCOMMIT);
	eval 'sub NFSPROC_LAYOUTRETURN () {49;}' unless defined(&NFSPROC_LAYOUTRETURN);
	eval 'sub NFSPROC_RECLAIMCOMPL () {50;}' unless defined(&NFSPROC_RECLAIMCOMPL);
	eval 'sub NFSPROC_WRITEDS () {51;}' unless defined(&NFSPROC_WRITEDS);
	eval 'sub NFSPROC_READDS () {52;}' unless defined(&NFSPROC_READDS);
	eval 'sub NFSPROC_COMMITDS () {53;}' unless defined(&NFSPROC_COMMITDS);
	eval 'sub NFSPROC_OPENLAYGET () {54;}' unless defined(&NFSPROC_OPENLAYGET);
	eval 'sub NFSPROC_CREATELAYGET () {55;}' unless defined(&NFSPROC_CREATELAYGET);
	eval 'sub NFSV41_NPROCS () {56;}' unless defined(&NFSV41_NPROCS);
    }
    eval 'sub NFSSTATS_V1 () {1;}' unless defined(&NFSSTATS_V1);
    if(defined(&_KERNEL)) {
	unless(defined(&NFS_NPROCS)) {
	    eval 'sub NFS_NPROCS () { &NFSV4_NPROCS;}' unless defined(&NFS_NPROCS);
	}
	require 'fs/nfs/nfskpiport.ph';
	require 'fs/nfs/nfsdport.ph';
	require 'fs/nfs/rpcv2.ph';
	require 'fs/nfs/nfsproto.ph';
	require 'fs/nfs/nfs.ph';
	require 'fs/nfs/nfsclstate.ph';
	require 'fs/nfs/nfs_var.ph';
	require 'fs/nfs/nfsm_subs.ph';
	require 'fs/nfs/nfsrvcache.ph';
	require 'fs/nfs/nfsrvstate.ph';
	require 'fs/nfs/xdr_subs.ph';
	require 'fs/nfs/nfscl.ph';
	require 'nfsclient/nfsargs.ph';
	require 'fs/nfsclient/nfsmount.ph';
	eval 'sub na_type () { ($na_vattr->{va_type});}' unless defined(&na_type);
	eval 'sub na_mode () { ($na_vattr->{va_mode});}' unless defined(&na_mode);
	eval 'sub na_nlink () { ($na_vattr->{va_nlink});}' unless defined(&na_nlink);
	eval 'sub na_uid () { ($na_vattr->{va_uid});}' unless defined(&na_uid);
	eval 'sub na_gid () { ($na_vattr->{va_gid});}' unless defined(&na_gid);
	eval 'sub na_fsid () { ($na_vattr->{va_fsid});}' unless defined(&na_fsid);
	eval 'sub na_fileid () { ($na_vattr->{va_fileid});}' unless defined(&na_fileid);
	eval 'sub na_size () { ($na_vattr->{va_size});}' unless defined(&na_size);
	eval 'sub na_blocksize () { ($na_vattr->{va_blocksize});}' unless defined(&na_blocksize);
	eval 'sub na_atime () { ($na_vattr->{va_atime});}' unless defined(&na_atime);
	eval 'sub na_mtime () { ($na_vattr->{va_mtime});}' unless defined(&na_mtime);
	eval 'sub na_ctime () { ($na_vattr->{va_ctime});}' unless defined(&na_ctime);
	eval 'sub na_gen () { ($na_vattr->{va_gen});}' unless defined(&na_gen);
	eval 'sub na_flags () { ($na_vattr->{va_flags});}' unless defined(&na_flags);
	eval 'sub na_rdev () { ($na_vattr->{va_rdev});}' unless defined(&na_rdev);
	eval 'sub na_bytes () { ($na_vattr->{va_bytes});}' unless defined(&na_bytes);
	eval 'sub na_filerev () { ($na_vattr->{va_filerev});}' unless defined(&na_filerev);
	eval 'sub na_vaflags () { ($na_vattr->{va_vaflags});}' unless defined(&na_vaflags);
	require 'fs/nfsclient/nfsnode.ph';
	eval 'sub nsf_lease () { ($nsf_rec->{lease});}' unless defined(&nsf_lease);
	eval 'sub nsf_numboots () { ($nsf_rec->{numboots});}' unless defined(&nsf_numboots);
	eval 'sub NFSNSF_UPDATEDONE () {0x1;}' unless defined(&NFSNSF_UPDATEDONE);
	eval 'sub NFSNSF_GRACEOVER () {0x2;}' unless defined(&NFSNSF_GRACEOVER);
	eval 'sub NFSNSF_NEEDLOCK () {0x4;}' unless defined(&NFSNSF_NEEDLOCK);
	eval 'sub NFSNSF_EXPIREDCLIENT () {0x8;}' unless defined(&NFSNSF_EXPIREDCLIENT);
	eval 'sub NFSNSF_NOOPENS () {0x10;}' unless defined(&NFSNSF_NOOPENS);
	eval 'sub NFSNSF_OK () {0x20;}' unless defined(&NFSNSF_OK);
	eval 'sub NFSNSF_MAXNUMBOOTS () {10000;}' unless defined(&NFSNSF_MAXNUMBOOTS);
	eval 'sub NFSNST_NEWSTATE () {0x1;}' unless defined(&NFSNST_NEWSTATE);
	eval 'sub NFSNST_REVOKE () {0x2;}' unless defined(&NFSNST_REVOKE);
	eval 'sub NFSNST_GOTSTATE () {0x4;}' unless defined(&NFSNST_GOTSTATE);
	eval 'sub nst_timestamp () { ($nst_rec->{timestamp});}' unless defined(&nst_timestamp);
	eval 'sub nst_len () { ($nst_rec->{len});}' unless defined(&nst_len);
	eval 'sub nst_flag () { ($nst_rec->{flag});}' unless defined(&nst_flag);
	eval 'sub nst_client () { ($nst_rec->{client});}' unless defined(&nst_client);
	eval 'sub NFSRV_V4STATELIMIT () {500000;}' unless defined(&NFSRV_V4STATELIMIT);
	eval 'sub NFSSOCKADDR {
	    my($a, $t) = @_;
    	    eval q((($t)($a)));
	}' unless defined(&NFSSOCKADDR);
	eval 'sub NFSSOCKADDRALLOC {
	    my($a) = @_;
    	    eval q( &do {  &MALLOC(($a), \'struct sockaddr\' *, $sizeof{\'struct sockaddr\'},  &M_SONAME,  &M_WAITOK);  &NFSBZERO(($a), $sizeof{\'struct sockaddr\'}); }  &while (0));
	}' unless defined(&NFSSOCKADDRALLOC);
	eval 'sub NFSSOCKADDRSIZE {
	    my($a, $s) = @_;
    	    eval q((($a)-> &sa_len = ($s)));
	}' unless defined(&NFSSOCKADDRSIZE);
	eval 'sub NFSSOCKADDRFREE {
	    my($a) = @_;
    	    eval q( &do {  &if ($a)  &FREE(($a),  &M_SONAME); }  &while (0));
	}' unless defined(&NFSSOCKADDRFREE);
	eval 'sub NFSNEWCRED {
	    my($c) = @_;
    	    eval q(( &crdup($c)));
	}' unless defined(&NFSNEWCRED);
	eval 'sub NFSPROCCRED {
	    my($p) = @_;
    	    eval q((($p)-> &td_ucred));
	}' unless defined(&NFSPROCCRED);
	eval 'sub NFSFREECRED {
	    my($c) = @_;
    	    eval q(( &crfree($c)));
	}' unless defined(&NFSFREECRED);
	eval 'sub NFSUIOPROC {
	    my($u, $p) = @_;
    	    eval q((($u)-> &uio_td =  &NULL));
	}' unless defined(&NFSUIOPROC);
	eval 'sub NFSPROCP {
	    my($p) = @_;
    	    eval q((($p)-> &td_proc));
	}' unless defined(&NFSPROCP);
	eval 'sub NFSCNHASHZERO {
	    my($c) = @_;
    	    eval q();
	}' unless defined(&NFSCNHASHZERO);
	eval 'sub NFSCNHASH {
	    my($c, $v) = @_;
    	    eval q();
	}' unless defined(&NFSCNHASH);
	eval 'sub NCHNAMLEN () {9999999;}' unless defined(&NCHNAMLEN);
	eval 'sub NFS_TIMERINIT () { &newnfs_timer( &NULL);}' unless defined(&NFS_TIMERINIT);
	eval 'sub NFSSTATESPINLOCK () { &extern \'struct mtx\'  &nfs_state_mutex;}' unless defined(&NFSSTATESPINLOCK);
	eval 'sub NFSLOCKSTATE () {
	    eval q( &mtx_lock( &nfs_state_mutex));
	}' unless defined(&NFSLOCKSTATE);
	eval 'sub NFSUNLOCKSTATE () {
	    eval q( &mtx_unlock( &nfs_state_mutex));
	}' unless defined(&NFSUNLOCKSTATE);
	eval 'sub NFSSTATEMUTEXPTR () {( &nfs_state_mutex);}' unless defined(&NFSSTATEMUTEXPTR);
	eval 'sub NFSREQSPINLOCK () { &extern \'struct mtx\'  &nfs_req_mutex;}' unless defined(&NFSREQSPINLOCK);
	eval 'sub NFSLOCKREQ () {
	    eval q( &mtx_lock( &nfs_req_mutex));
	}' unless defined(&NFSLOCKREQ);
	eval 'sub NFSUNLOCKREQ () {
	    eval q( &mtx_unlock( &nfs_req_mutex));
	}' unless defined(&NFSUNLOCKREQ);
	eval 'sub NFSSOCKMUTEX () { &extern \'struct mtx\'  &nfs_slock_mutex;}' unless defined(&NFSSOCKMUTEX);
	eval 'sub NFSSOCKMUTEXPTR () {( &nfs_slock_mutex);}' unless defined(&NFSSOCKMUTEXPTR);
	eval 'sub NFSLOCKSOCK () {
	    eval q( &mtx_lock( &nfs_slock_mutex));
	}' unless defined(&NFSLOCKSOCK);
	eval 'sub NFSUNLOCKSOCK () {
	    eval q( &mtx_unlock( &nfs_slock_mutex));
	}' unless defined(&NFSUNLOCKSOCK);
	eval 'sub NFSNAMEIDMUTEX () { &extern \'struct mtx\'  &nfs_nameid_mutex;}' unless defined(&NFSNAMEIDMUTEX);
	eval 'sub NFSLOCKNAMEID () {
	    eval q( &mtx_lock( &nfs_nameid_mutex));
	}' unless defined(&NFSLOCKNAMEID);
	eval 'sub NFSUNLOCKNAMEID () {
	    eval q( &mtx_unlock( &nfs_nameid_mutex));
	}' unless defined(&NFSUNLOCKNAMEID);
	eval 'sub NFSNAMEIDREQUIRED () {
	    eval q( &mtx_assert( &nfs_nameid_mutex,  &MA_OWNED));
	}' unless defined(&NFSNAMEIDREQUIRED);
	eval 'sub NFSCLSTATEMUTEX () { &extern \'struct mtx\'  &nfs_clstate_mutex;}' unless defined(&NFSCLSTATEMUTEX);
	eval 'sub NFSCLSTATEMUTEXPTR () {( &nfs_clstate_mutex);}' unless defined(&NFSCLSTATEMUTEXPTR);
	eval 'sub NFSLOCKCLSTATE () {
	    eval q( &mtx_lock( &nfs_clstate_mutex));
	}' unless defined(&NFSLOCKCLSTATE);
	eval 'sub NFSUNLOCKCLSTATE () {
	    eval q( &mtx_unlock( &nfs_clstate_mutex));
	}' unless defined(&NFSUNLOCKCLSTATE);
	eval 'sub NFSDLOCKMUTEX () { &extern \'struct mtx\'  &newnfsd_mtx;}' unless defined(&NFSDLOCKMUTEX);
	eval 'sub NFSDLOCKMUTEXPTR () {( &newnfsd_mtx);}' unless defined(&NFSDLOCKMUTEXPTR);
	eval 'sub NFSD_LOCK () {
	    eval q( &mtx_lock( &newnfsd_mtx));
	}' unless defined(&NFSD_LOCK);
	eval 'sub NFSD_UNLOCK () {
	    eval q( &mtx_unlock( &newnfsd_mtx));
	}' unless defined(&NFSD_UNLOCK);
	eval 'sub NFSD_LOCK_ASSERT () {
	    eval q( &mtx_assert( &newnfsd_mtx,  &MA_OWNED));
	}' unless defined(&NFSD_LOCK_ASSERT);
	eval 'sub NFSD_UNLOCK_ASSERT () {
	    eval q( &mtx_assert( &newnfsd_mtx,  &MA_NOTOWNED));
	}' unless defined(&NFSD_UNLOCK_ASSERT);
	eval 'sub NFSV4ROOTLOCKMUTEX () { &extern \'struct mtx\'  &nfs_v4root_mutex;}' unless defined(&NFSV4ROOTLOCKMUTEX);
	eval 'sub NFSV4ROOTLOCKMUTEXPTR () {( &nfs_v4root_mutex);}' unless defined(&NFSV4ROOTLOCKMUTEXPTR);
	eval 'sub NFSLOCKV4ROOTMUTEX () {
	    eval q( &mtx_lock( &nfs_v4root_mutex));
	}' unless defined(&NFSLOCKV4ROOTMUTEX);
	eval 'sub NFSUNLOCKV4ROOTMUTEX () {
	    eval q( &mtx_unlock( &nfs_v4root_mutex));
	}' unless defined(&NFSUNLOCKV4ROOTMUTEX);
	eval 'sub NFSLOCKNODE {
	    my($n) = @_;
    	    eval q( &mtx_lock((($n)-> &n_mtx)));
	}' unless defined(&NFSLOCKNODE);
	eval 'sub NFSUNLOCKNODE {
	    my($n) = @_;
    	    eval q( &mtx_unlock((($n)-> &n_mtx)));
	}' unless defined(&NFSUNLOCKNODE);
	eval 'sub NFSLOCKMNT {
	    my($m) = @_;
    	    eval q( &mtx_lock((($m)-> &nm_mtx)));
	}' unless defined(&NFSLOCKMNT);
	eval 'sub NFSUNLOCKMNT {
	    my($m) = @_;
    	    eval q( &mtx_unlock((($m)-> &nm_mtx)));
	}' unless defined(&NFSUNLOCKMNT);
	eval 'sub NFSLOCKREQUEST {
	    my($r) = @_;
    	    eval q( &mtx_lock((($r)-> &r_mtx)));
	}' unless defined(&NFSLOCKREQUEST);
	eval 'sub NFSUNLOCKREQUEST {
	    my($r) = @_;
    	    eval q( &mtx_unlock((($r)-> &r_mtx)));
	}' unless defined(&NFSUNLOCKREQUEST);
	eval 'sub NFSPROCLISTLOCK () {
	    eval q( &sx_slock( &allproc_lock));
	}' unless defined(&NFSPROCLISTLOCK);
	eval 'sub NFSPROCLISTUNLOCK () {
	    eval q( &sx_sunlock( &allproc_lock));
	}' unless defined(&NFSPROCLISTUNLOCK);
	eval 'sub NFSLOCKSOCKREQ {
	    my($r) = @_;
    	    eval q( &mtx_lock((($r)-> &nr_mtx)));
	}' unless defined(&NFSLOCKSOCKREQ);
	eval 'sub NFSUNLOCKSOCKREQ {
	    my($r) = @_;
    	    eval q( &mtx_unlock((($r)-> &nr_mtx)));
	}' unless defined(&NFSUNLOCKSOCKREQ);
	eval 'sub NFSLOCKDS {
	    my($d) = @_;
    	    eval q( &mtx_lock((($d)-> &nfsclds_mtx)));
	}' unless defined(&NFSLOCKDS);
	eval 'sub NFSUNLOCKDS {
	    my($d) = @_;
    	    eval q( &mtx_unlock((($d)-> &nfsclds_mtx)));
	}' unless defined(&NFSUNLOCKDS);
	eval 'sub NFSSESSIONMUTEXPTR {
	    my($s) = @_;
    	    eval q(((($s)-> &mtx)));
	}' unless defined(&NFSSESSIONMUTEXPTR);
	eval 'sub NFSLOCKSESSION {
	    my($s) = @_;
    	    eval q( &mtx_lock((($s)-> &mtx)));
	}' unless defined(&NFSLOCKSESSION);
	eval 'sub NFSUNLOCKSESSION {
	    my($s) = @_;
    	    eval q( &mtx_unlock((($s)-> &mtx)));
	}' unless defined(&NFSUNLOCKSESSION);
	eval 'sub NFSINITSOCKMUTEX {
	    my($m) = @_;
    	    eval q( &mtx_init(($m), \\"nfssock\\",  &NULL,  &MTX_DEF));
	}' unless defined(&NFSINITSOCKMUTEX);
	eval 'sub NFSFREEMUTEX {
	    my($m) = @_;
    	    eval q( &mtx_destroy(($m)));
	}' unless defined(&NFSFREEMUTEX);
	eval 'sub PDIRUNLOCK () {0x;}' unless defined(&PDIRUNLOCK);
	eval 'sub MAX_COMMIT_COUNT () {(1024* 1024);}' unless defined(&MAX_COMMIT_COUNT);
	eval 'sub NFSMAKEDEV {
	    my($m, $n) = @_;
    	    eval q( &makedev(($m), ($n)));
	}' unless defined(&NFSMAKEDEV);
	eval 'sub NFSMAJOR {
	    my($d) = @_;
    	    eval q( &major($d));
	}' unless defined(&NFSMAJOR);
	eval 'sub NFSMINOR {
	    my($d) = @_;
    	    eval q( &minor($d));
	}' unless defined(&NFSMINOR);
	eval 'sub DIRENT_SIZE {
	    my($dp) = @_;
    	    eval q( &GENERIC_DIRSIZ($dp));
	}' unless defined(&DIRENT_SIZE);
	eval 'sub VT_NFSV4ROOT () {"nfsv4root";}' unless defined(&VT_NFSV4ROOT);
	eval 'sub NFSD_RDWR {
	    my($r, $v, $b, $l, $o, $s, $i, $c, $a, $p) = @_;
    	    eval q( &vn_rdwr(($r), ($v), ($b), ($l), ($o), ($s), ($i), ($c),  &NULL, ($a), ($p)));
	}' unless defined(&NFSD_RDWR);
	eval 'sub NFSBCOPY {
	    my($s, $d, $l) = @_;
    	    eval q( &bcopy(($s), ($d), ($l)));
	}' unless defined(&NFSBCOPY);
	eval 'sub NFSOVBCOPY {
	    my($s, $d, $l) = @_;
    	    eval q( &ovbcopy(($s), ($d), ($l)));
	}' unless defined(&NFSOVBCOPY);
	eval 'sub NFSBCMP {
	    my($s, $d, $l) = @_;
    	    eval q( &bcmp(($s), ($d), ($l)));
	}' unless defined(&NFSBCMP);
	eval 'sub NFSBZERO {
	    my($s, $l) = @_;
    	    eval q( &bzero(($s), ($l)));
	}' unless defined(&NFSBZERO);
	eval 'sub LIST_END {
	    my($head) = @_;
    	    eval q( &NULL);
	}' unless defined(&LIST_END);
	eval 'sub SLIST_END {
	    my($head) = @_;
    	    eval q( &NULL);
	}' unless defined(&SLIST_END);
	eval 'sub TAILQ_END {
	    my($head) = @_;
    	    eval q( &NULL);
	}' unless defined(&TAILQ_END);
	eval 'sub NFSD_MONOSEC () { &time_uptime;}' unless defined(&NFSD_MONOSEC);
	eval 'sub M_NFSRVCACHE () { &M_NEWNFSRVCACHE;}' unless defined(&M_NFSRVCACHE);
	eval 'sub M_NFSDCLIENT () { &M_NEWNFSDCLIENT;}' unless defined(&M_NFSDCLIENT);
	eval 'sub M_NFSDSTATE () { &M_NEWNFSDSTATE;}' unless defined(&M_NFSDSTATE);
	eval 'sub M_NFSDLOCK () { &M_NEWNFSDLOCK;}' unless defined(&M_NFSDLOCK);
	eval 'sub M_NFSDLOCKFILE () { &M_NEWNFSDLOCKFILE;}' unless defined(&M_NFSDLOCKFILE);
	eval 'sub M_NFSSTRING () { &M_NEWNFSSTRING;}' unless defined(&M_NFSSTRING);
	eval 'sub M_NFSUSERGROUP () { &M_NEWNFSUSERGROUP;}' unless defined(&M_NFSUSERGROUP);
	eval 'sub M_NFSDREQ () { &M_NEWNFSDREQ;}' unless defined(&M_NFSDREQ);
	eval 'sub M_NFSFH () { &M_NEWNFSFH;}' unless defined(&M_NFSFH);
	eval 'sub M_NFSCLOWNER () { &M_NEWNFSCLOWNER;}' unless defined(&M_NFSCLOWNER);
	eval 'sub M_NFSCLOPEN () { &M_NEWNFSCLOPEN;}' unless defined(&M_NFSCLOPEN);
	eval 'sub M_NFSCLDELEG () { &M_NEWNFSCLDELEG;}' unless defined(&M_NFSCLDELEG);
	eval 'sub M_NFSCLCLIENT () { &M_NEWNFSCLCLIENT;}' unless defined(&M_NFSCLCLIENT);
	eval 'sub M_NFSCLLOCKOWNER () { &M_NEWNFSCLLOCKOWNER;}' unless defined(&M_NFSCLLOCKOWNER);
	eval 'sub M_NFSCLLOCK () { &M_NEWNFSCLLOCK;}' unless defined(&M_NFSCLLOCK);
	eval 'sub M_NFSDIROFF () { &M_NEWNFSDIROFF;}' unless defined(&M_NFSDIROFF);
	eval 'sub M_NFSV4NODE () { &M_NEWNFSV4NODE;}' unless defined(&M_NFSV4NODE);
	eval 'sub M_NFSDIRECTIO () { &M_NEWNFSDIRECTIO;}' unless defined(&M_NFSDIRECTIO);
	eval 'sub M_NFSDROLLBACK () { &M_NEWNFSDROLLBACK;}' unless defined(&M_NFSDROLLBACK);
	eval 'sub M_NFSLAYOUT () { &M_NEWNFSLAYOUT;}' unless defined(&M_NFSLAYOUT);
	eval 'sub M_NFSFLAYOUT () { &M_NEWNFSFLAYOUT;}' unless defined(&M_NFSFLAYOUT);
	eval 'sub M_NFSDEVINFO () { &M_NEWNFSDEVINFO;}' unless defined(&M_NFSDEVINFO);
	eval 'sub M_NFSSOCKREQ () { &M_NEWNFSSOCKREQ;}' unless defined(&M_NFSSOCKREQ);
	eval 'sub M_NFSCLDS () { &M_NEWNFSCLDS;}' unless defined(&M_NFSCLDS);
	eval 'sub M_NFSLAYRECALL () { &M_NEWNFSLAYRECALL;}' unless defined(&M_NFSLAYRECALL);
	eval 'sub M_NFSDSESSION () { &M_NEWNFSDSESSION;}' unless defined(&M_NFSDSESSION);
	eval 'sub NFSINT_SIGMASK {
	    my($set) = @_;
    	    eval q(( &SIGISMEMBER($set,  &SIGINT) ||  &SIGISMEMBER($set,  &SIGTERM) ||  &SIGISMEMBER($set,  &SIGHUP) ||  &SIGISMEMBER($set,  &SIGKILL) ||  &SIGISMEMBER($set,  &SIGQUIT)));
	}' unless defined(&NFSINT_SIGMASK);
	eval 'sub NFSQUOTABLKTOBYTE {
	    my($q, $b) = @_;
    	    eval q(($q) *= ($b));
	}' unless defined(&NFSQUOTABLKTOBYTE);
	eval 'sub NFSRV_MAXFILESIZE () {(( &u_int64_t)0x800000000000);}' unless defined(&NFSRV_MAXFILESIZE);
	eval 'sub STRCHR {
	    my($s, $c) = @_;
    	    eval q( &strchr(($s), ($c)));
	}' unless defined(&STRCHR);
	eval 'sub NFSWRITERPC_SETTIME {
	    my($w, $n, $a, $v4) = @_;
    	    eval q( &do {  &if ($w) {  &mtx_lock((($n)-> &n_mtx)); ($n)-> &n_mtime = ($a)-> &na_mtime;  &if ($v4) ($n)-> &n_change = ($a)-> &na_filerev;  &mtx_unlock((($n)-> &n_mtx)); } }  &while (0));
	}' unless defined(&NFSWRITERPC_SETTIME);
	eval 'sub NFS_LATTR_NOSHRINK () {1;}' unless defined(&NFS_LATTR_NOSHRINK);
	eval 'sub NFSINCRGLOBAL {
	    my($a) = @_;
    	    eval q((($a)++));
	}' unless defined(&NFSINCRGLOBAL);
	eval 'sub NFSATTRISSET {
	    my($t, $v, $a) = @_;
    	    eval q((($v)->$a != ($t) &VNOVAL));
	}' unless defined(&NFSATTRISSET);
	eval 'sub NFSATTRISSETTIME {
	    my($v, $a) = @_;
    	    eval q((($v)-> ($a->{t$v_sec}) !=  &VNOVAL));
	}' unless defined(&NFSATTRISSETTIME);
	eval 'sub NFSSTA_HASWRITEVERF () {0x40000;}' unless defined(&NFSSTA_HASWRITEVERF);
	eval 'sub NFSSTA_GOTFSINFO () {0x100000;}' unless defined(&NFSSTA_GOTFSINFO);
	eval 'sub NFSSTA_OPENMODE () {0x200000;}' unless defined(&NFSSTA_OPENMODE);
	eval 'sub NFSSTA_NOLAYOUTCOMMIT () {0x4000000;}' unless defined(&NFSSTA_NOLAYOUTCOMMIT);
	eval 'sub NFSSTA_SESSPERSIST () {0x8000000;}' unless defined(&NFSSTA_SESSPERSIST);
	eval 'sub NFSSTA_TIMEO () {0x10000000;}' unless defined(&NFSSTA_TIMEO);
	eval 'sub NFSSTA_LOCKTIMEO () {0x20000000;}' unless defined(&NFSSTA_LOCKTIMEO);
	eval 'sub NFSSTA_HASSETFSID () {0x40000000;}' unless defined(&NFSSTA_HASSETFSID);
	eval 'sub NFSSTA_PNFS () {0x80000000;}' unless defined(&NFSSTA_PNFS);
	eval 'sub NFSHASNFSV3 {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_NFSV3));
	}' unless defined(&NFSHASNFSV3);
	eval 'sub NFSHASNFSV4 {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_NFSV4));
	}' unless defined(&NFSHASNFSV4);
	eval 'sub NFSHASNFSV4N {
	    my($n) = @_;
    	    eval q((($n)-> &nm_minorvers > 0));
	}' unless defined(&NFSHASNFSV4N);
	eval 'sub NFSHASNFSV3OR4 {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag & ( &NFSMNT_NFSV3 |  &NFSMNT_NFSV4)));
	}' unless defined(&NFSHASNFSV3OR4);
	eval 'sub NFSHASGOTFSINFO {
	    my($n) = @_;
    	    eval q((($n)-> &nm_state &  &NFSSTA_GOTFSINFO));
	}' unless defined(&NFSHASGOTFSINFO);
	eval 'sub NFSHASHASSETFSID {
	    my($n) = @_;
    	    eval q((($n)-> &nm_state &  &NFSSTA_HASSETFSID));
	}' unless defined(&NFSHASHASSETFSID);
	eval 'sub NFSHASSTRICT3530 {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_STRICT3530));
	}' unless defined(&NFSHASSTRICT3530);
	eval 'sub NFSHASWRITEVERF {
	    my($n) = @_;
    	    eval q((($n)-> &nm_state &  &NFSSTA_HASWRITEVERF));
	}' unless defined(&NFSHASWRITEVERF);
	eval 'sub NFSHASINT {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_INT));
	}' unless defined(&NFSHASINT);
	eval 'sub NFSHASSOFT {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_SOFT));
	}' unless defined(&NFSHASSOFT);
	eval 'sub NFSHASINTORSOFT {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag & ( &NFSMNT_INT |  &NFSMNT_SOFT)));
	}' unless defined(&NFSHASINTORSOFT);
	eval 'sub NFSHASDUMBTIMR {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_DUMBTIMR));
	}' unless defined(&NFSHASDUMBTIMR);
	eval 'sub NFSHASNOCONN {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_MNTD));
	}' unless defined(&NFSHASNOCONN);
	eval 'sub NFSHASKERB {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_KERB));
	}' unless defined(&NFSHASKERB);
	eval 'sub NFSHASALLGSSNAME {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_ALLGSSNAME));
	}' unless defined(&NFSHASALLGSSNAME);
	eval 'sub NFSHASINTEGRITY {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_INTEGRITY));
	}' unless defined(&NFSHASINTEGRITY);
	eval 'sub NFSHASPRIVACY {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_PRIVACY));
	}' unless defined(&NFSHASPRIVACY);
	eval 'sub NFSSETWRITEVERF {
	    my($n) = @_;
    	    eval q((($n)-> &nm_state |=  &NFSSTA_HASWRITEVERF));
	}' unless defined(&NFSSETWRITEVERF);
	eval 'sub NFSSETHASSETFSID {
	    my($n) = @_;
    	    eval q((($n)-> &nm_state |=  &NFSSTA_HASSETFSID));
	}' unless defined(&NFSSETHASSETFSID);
	eval 'sub NFSHASPNFSOPT {
	    my($n) = @_;
    	    eval q((($n)-> &nm_flag &  &NFSMNT_PNFS));
	}' unless defined(&NFSHASPNFSOPT);
	eval 'sub NFSHASNOLAYOUTCOMMIT {
	    my($n) = @_;
    	    eval q((($n)-> &nm_state &  &NFSSTA_NOLAYOUTCOMMIT));
	}' unless defined(&NFSHASNOLAYOUTCOMMIT);
	eval 'sub NFSHASSESSPERSIST {
	    my($n) = @_;
    	    eval q((($n)-> &nm_state &  &NFSSTA_SESSPERSIST));
	}' unless defined(&NFSHASSESSPERSIST);
	eval 'sub NFSHASPNFS {
	    my($n) = @_;
    	    eval q((($n)-> &nm_state &  &NFSSTA_PNFS));
	}' unless defined(&NFSHASPNFS);
	eval 'sub NFSHASOPENMODE {
	    my($n) = @_;
    	    eval q((($n)-> &nm_state &  &NFSSTA_OPENMODE));
	}' unless defined(&NFSHASOPENMODE);
	eval 'sub NFSHASONEOPENOWN {
	    my($n) = @_;
    	    eval q(((($n)-> &nm_flag &  &NFSMNT_ONEOPENOWN) != 0 && ($n)-> &nm_minorvers > 0));
	}' unless defined(&NFSHASONEOPENOWN);
	eval 'sub vfs_statfs {
	    my($m) = @_;
    	    eval q(((($m)-> &mnt_stat)));
	}' unless defined(&vfs_statfs);
	eval 'sub NFSSETBOOTTIME {
	    my($b) = @_;
    	    eval q(( &getboottime($b)));
	}' unless defined(&NFSSETBOOTTIME);
	eval 'sub NFS_DIRBLKSIZ () {(16*  &DIRBLKSIZ);}' unless defined(&NFS_DIRBLKSIZ);
	eval 'sub NFSMNT_RDONLY {
	    my($m) = @_;
    	    eval q((($m)-> &mnt_flag &  &MNT_RDONLY));
	}' unless defined(&NFSMNT_RDONLY);
    }
    unless(defined(&MNT_EXSTRICTACCESS)) {
	eval 'sub MNT_EXSTRICTACCESS () {0x;}' unless defined(&MNT_EXSTRICTACCESS);
    }
    unless(defined(&MNT_EXV4ONLY)) {
	eval 'sub MNT_EXV4ONLY () {0x;}' unless defined(&MNT_EXV4ONLY);
    }
    if(defined(&_KERNEL)) {
	eval 'sub NFSINVALATTRCACHE {
	    my($n) = @_;
    	    eval q((($n)-> &n_attrstamp = 0));
	}' unless defined(&NFSINVALATTRCACHE);
	eval 'sub NFSVOPLOCK {
	    my($v, $f) = @_;
    	    eval q( &vn_lock(($v), ($f)));
	}' unless defined(&NFSVOPLOCK);
	eval 'sub NFSVOPUNLOCK {
	    my($v, $f) = @_;
    	    eval q( &VOP_UNLOCK(($v), ($f)));
	}' unless defined(&NFSVOPUNLOCK);
	eval 'sub NFSVOPISLOCKED {
	    my($v) = @_;
    	    eval q( &VOP_ISLOCKED(($v)));
	}' unless defined(&NFSVOPISLOCKED);
	eval 'sub ncl_hash {
	    my($f, $l) = @_;
    	    eval q(( &fnv_32_buf(($f), ($l),  &FNV1_32_INIT)));
	}' unless defined(&ncl_hash);
	unless(defined(&NFS_MINDIRATTRTIMO)) {
	    eval 'sub NFS_MINDIRATTRTIMO () {3;}' unless defined(&NFS_MINDIRATTRTIMO);
	}
	unless(defined(&NFS_MAXDIRATTRTIMO)) {
	    eval 'sub NFS_MAXDIRATTRTIMO () {60;}' unless defined(&NFS_MAXDIRATTRTIMO);
	}
	unless(defined(&NFS_MAXBSIZE)) {
	    eval 'sub NFS_MAXBSIZE () {( &maxbcachebuf);}' unless defined(&NFS_MAXBSIZE);
	}
	if(defined(&VV_DISABLEDELEG)) {
	    eval 'sub NFSVNO_DELEGOK {
	        my($v) = @_;
    		eval q((($v) ==  &NULL || (($v)-> &v_vflag &  &VV_DISABLEDELEG) == 0));
	    }' unless defined(&NFSVNO_DELEGOK);
	} else {
	    eval 'sub NFSVNO_DELEGOK {
	        my($v) = @_;
    		eval q((1));
	    }' unless defined(&NFSVNO_DELEGOK);
	}
    }
}
1;
