require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFS_NFSPROTO_H_)) {
    eval 'sub _NFS_NFSPROTO_H_ () {1;}' unless defined(&_NFS_NFSPROTO_H_);
    eval 'sub NFS_PORT () {2049;}' unless defined(&NFS_PORT);
    eval 'sub NFS_PROG () {100003;}' unless defined(&NFS_PROG);
    eval 'sub NFS_CALLBCKPROG () {0x40000000;}' unless defined(&NFS_CALLBCKPROG);
    eval 'sub NFS_VER2 () {2;}' unless defined(&NFS_VER2);
    eval 'sub NFS_VER3 () {3;}' unless defined(&NFS_VER3);
    eval 'sub NFS_VER4 () {4;}' unless defined(&NFS_VER4);
    eval 'sub NFS_V2MAXDATA () {8192;}' unless defined(&NFS_V2MAXDATA);
    eval 'sub NFS_MAXDGRAMDATA () {16384;}' unless defined(&NFS_MAXDGRAMDATA);
    eval 'sub NFS_MAXPATHLEN () {1024;}' unless defined(&NFS_MAXPATHLEN);
    eval 'sub NFS_MAXNAMLEN () {255;}' unless defined(&NFS_MAXNAMLEN);
    eval 'sub NFS_MAXPKTHDR () {404;}' unless defined(&NFS_MAXPKTHDR);
    eval 'sub NFS_MAXXDR () {4096;}' unless defined(&NFS_MAXXDR);
    eval 'sub NFS_MAXPACKET () {( &NFS_SRVMAXIO +  &NFS_MAXXDR);}' unless defined(&NFS_MAXPACKET);
    eval 'sub NFS_MINPACKET () {20;}' unless defined(&NFS_MINPACKET);
    eval 'sub NFS_FABLKSIZE () {512;}' unless defined(&NFS_FABLKSIZE);
    eval 'sub NFSV4_MINORVERSION () {0;}' unless defined(&NFSV4_MINORVERSION);
    eval 'sub NFSV41_MINORVERSION () {1;}' unless defined(&NFSV41_MINORVERSION);
    eval 'sub NFSV4_CBVERS () {1;}' unless defined(&NFSV4_CBVERS);
    eval 'sub NFSV41_CBVERS () {4;}' unless defined(&NFSV41_CBVERS);
    eval 'sub NFSV4_SMALLSTR () {50;}' unless defined(&NFSV4_SMALLSTR);
    eval 'sub NFS_SRVMAXIO () {(128* 1024);}' unless defined(&NFS_SRVMAXIO);
    eval 'sub NFSERR_OK () {0;}' unless defined(&NFSERR_OK);
    eval 'sub NFSERR_PERM () {1;}' unless defined(&NFSERR_PERM);
    eval 'sub NFSERR_NOENT () {2;}' unless defined(&NFSERR_NOENT);
    eval 'sub NFSERR_IO () {5;}' unless defined(&NFSERR_IO);
    eval 'sub NFSERR_NXIO () {6;}' unless defined(&NFSERR_NXIO);
    eval 'sub NFSERR_ACCES () {13;}' unless defined(&NFSERR_ACCES);
    eval 'sub NFSERR_EXIST () {17;}' unless defined(&NFSERR_EXIST);
    eval 'sub NFSERR_XDEV () {18;}' unless defined(&NFSERR_XDEV);
    eval 'sub NFSERR_NODEV () {19;}' unless defined(&NFSERR_NODEV);
    eval 'sub NFSERR_NOTDIR () {20;}' unless defined(&NFSERR_NOTDIR);
    eval 'sub NFSERR_ISDIR () {21;}' unless defined(&NFSERR_ISDIR);
    eval 'sub NFSERR_INVAL () {22;}' unless defined(&NFSERR_INVAL);
    eval 'sub NFSERR_FBIG () {27;}' unless defined(&NFSERR_FBIG);
    eval 'sub NFSERR_NOSPC () {28;}' unless defined(&NFSERR_NOSPC);
    eval 'sub NFSERR_ROFS () {30;}' unless defined(&NFSERR_ROFS);
    eval 'sub NFSERR_MLINK () {31;}' unless defined(&NFSERR_MLINK);
    eval 'sub NFSERR_NAMETOL () {63;}' unless defined(&NFSERR_NAMETOL);
    eval 'sub NFSERR_NOTEMPTY () {66;}' unless defined(&NFSERR_NOTEMPTY);
    eval 'sub NFSERR_DQUOT () {69;}' unless defined(&NFSERR_DQUOT);
    eval 'sub NFSERR_STALE () {70;}' unless defined(&NFSERR_STALE);
    eval 'sub NFSERR_REMOTE () {71;}' unless defined(&NFSERR_REMOTE);
    eval 'sub NFSERR_WFLUSH () {99;}' unless defined(&NFSERR_WFLUSH);
    eval 'sub NFSERR_BADHANDLE () {10001;}' unless defined(&NFSERR_BADHANDLE);
    eval 'sub NFSERR_NOT_SYNC () {10002;}' unless defined(&NFSERR_NOT_SYNC);
    eval 'sub NFSERR_BAD_COOKIE () {10003;}' unless defined(&NFSERR_BAD_COOKIE);
    eval 'sub NFSERR_NOTSUPP () {10004;}' unless defined(&NFSERR_NOTSUPP);
    eval 'sub NFSERR_TOOSMALL () {10005;}' unless defined(&NFSERR_TOOSMALL);
    eval 'sub NFSERR_SERVERFAULT () {10006;}' unless defined(&NFSERR_SERVERFAULT);
    eval 'sub NFSERR_BADTYPE () {10007;}' unless defined(&NFSERR_BADTYPE);
    eval 'sub NFSERR_DELAY () {10008;}' unless defined(&NFSERR_DELAY);
    eval 'sub NFSERR_SAME () {10009;}' unless defined(&NFSERR_SAME);
    eval 'sub NFSERR_DENIED () {10010;}' unless defined(&NFSERR_DENIED);
    eval 'sub NFSERR_EXPIRED () {10011;}' unless defined(&NFSERR_EXPIRED);
    eval 'sub NFSERR_LOCKED () {10012;}' unless defined(&NFSERR_LOCKED);
    eval 'sub NFSERR_GRACE () {10013;}' unless defined(&NFSERR_GRACE);
    eval 'sub NFSERR_FHEXPIRED () {10014;}' unless defined(&NFSERR_FHEXPIRED);
    eval 'sub NFSERR_SHAREDENIED () {10015;}' unless defined(&NFSERR_SHAREDENIED);
    eval 'sub NFSERR_WRONGSEC () {10016;}' unless defined(&NFSERR_WRONGSEC);
    eval 'sub NFSERR_CLIDINUSE () {10017;}' unless defined(&NFSERR_CLIDINUSE);
    eval 'sub NFSERR_RESOURCE () {10018;}' unless defined(&NFSERR_RESOURCE);
    eval 'sub NFSERR_MOVED () {10019;}' unless defined(&NFSERR_MOVED);
    eval 'sub NFSERR_NOFILEHANDLE () {10020;}' unless defined(&NFSERR_NOFILEHANDLE);
    eval 'sub NFSERR_MINORVERMISMATCH () {10021;}' unless defined(&NFSERR_MINORVERMISMATCH);
    eval 'sub NFSERR_STALECLIENTID () {10022;}' unless defined(&NFSERR_STALECLIENTID);
    eval 'sub NFSERR_STALESTATEID () {10023;}' unless defined(&NFSERR_STALESTATEID);
    eval 'sub NFSERR_OLDSTATEID () {10024;}' unless defined(&NFSERR_OLDSTATEID);
    eval 'sub NFSERR_BADSTATEID () {10025;}' unless defined(&NFSERR_BADSTATEID);
    eval 'sub NFSERR_BADSEQID () {10026;}' unless defined(&NFSERR_BADSEQID);
    eval 'sub NFSERR_NOTSAME () {10027;}' unless defined(&NFSERR_NOTSAME);
    eval 'sub NFSERR_LOCKRANGE () {10028;}' unless defined(&NFSERR_LOCKRANGE);
    eval 'sub NFSERR_SYMLINK () {10029;}' unless defined(&NFSERR_SYMLINK);
    eval 'sub NFSERR_RESTOREFH () {10030;}' unless defined(&NFSERR_RESTOREFH);
    eval 'sub NFSERR_LEASEMOVED () {10031;}' unless defined(&NFSERR_LEASEMOVED);
    eval 'sub NFSERR_ATTRNOTSUPP () {10032;}' unless defined(&NFSERR_ATTRNOTSUPP);
    eval 'sub NFSERR_NOGRACE () {10033;}' unless defined(&NFSERR_NOGRACE);
    eval 'sub NFSERR_RECLAIMBAD () {10034;}' unless defined(&NFSERR_RECLAIMBAD);
    eval 'sub NFSERR_RECLAIMCONFLICT () {10035;}' unless defined(&NFSERR_RECLAIMCONFLICT);
    eval 'sub NFSERR_BADXDR () {10036;}' unless defined(&NFSERR_BADXDR);
    eval 'sub NFSERR_LOCKSHELD () {10037;}' unless defined(&NFSERR_LOCKSHELD);
    eval 'sub NFSERR_OPENMODE () {10038;}' unless defined(&NFSERR_OPENMODE);
    eval 'sub NFSERR_BADOWNER () {10039;}' unless defined(&NFSERR_BADOWNER);
    eval 'sub NFSERR_BADCHAR () {10040;}' unless defined(&NFSERR_BADCHAR);
    eval 'sub NFSERR_BADNAME () {10041;}' unless defined(&NFSERR_BADNAME);
    eval 'sub NFSERR_BADRANGE () {10042;}' unless defined(&NFSERR_BADRANGE);
    eval 'sub NFSERR_LOCKNOTSUPP () {10043;}' unless defined(&NFSERR_LOCKNOTSUPP);
    eval 'sub NFSERR_OPILLEGAL () {10044;}' unless defined(&NFSERR_OPILLEGAL);
    eval 'sub NFSERR_DEADLOCK () {10045;}' unless defined(&NFSERR_DEADLOCK);
    eval 'sub NFSERR_FILEOPEN () {10046;}' unless defined(&NFSERR_FILEOPEN);
    eval 'sub NFSERR_ADMINREVOKED () {10047;}' unless defined(&NFSERR_ADMINREVOKED);
    eval 'sub NFSERR_CBPATHDOWN () {10048;}' unless defined(&NFSERR_CBPATHDOWN);
    eval 'sub NFSERR_BADIOMODE () {10049;}' unless defined(&NFSERR_BADIOMODE);
    eval 'sub NFSERR_BADLAYOUT () {10050;}' unless defined(&NFSERR_BADLAYOUT);
    eval 'sub NFSERR_BADSESSIONDIGEST () {10051;}' unless defined(&NFSERR_BADSESSIONDIGEST);
    eval 'sub NFSERR_BADSESSION () {10052;}' unless defined(&NFSERR_BADSESSION);
    eval 'sub NFSERR_BADSLOT () {10053;}' unless defined(&NFSERR_BADSLOT);
    eval 'sub NFSERR_COMPLETEALREADY () {10054;}' unless defined(&NFSERR_COMPLETEALREADY);
    eval 'sub NFSERR_NOTBNDTOSESS () {10055;}' unless defined(&NFSERR_NOTBNDTOSESS);
    eval 'sub NFSERR_DELEGALREADYWANT () {10056;}' unless defined(&NFSERR_DELEGALREADYWANT);
    eval 'sub NFSERR_BACKCHANBUSY () {10057;}' unless defined(&NFSERR_BACKCHANBUSY);
    eval 'sub NFSERR_LAYOUTTRYLATER () {10058;}' unless defined(&NFSERR_LAYOUTTRYLATER);
    eval 'sub NFSERR_LAYOUTUNAVAIL () {10059;}' unless defined(&NFSERR_LAYOUTUNAVAIL);
    eval 'sub NFSERR_NOMATCHLAYOUT () {10060;}' unless defined(&NFSERR_NOMATCHLAYOUT);
    eval 'sub NFSERR_RECALLCONFLICT () {10061;}' unless defined(&NFSERR_RECALLCONFLICT);
    eval 'sub NFSERR_UNKNLAYOUTTYPE () {10062;}' unless defined(&NFSERR_UNKNLAYOUTTYPE);
    eval 'sub NFSERR_SEQMISORDERED () {10063;}' unless defined(&NFSERR_SEQMISORDERED);
    eval 'sub NFSERR_SEQUENCEPOS () {10064;}' unless defined(&NFSERR_SEQUENCEPOS);
    eval 'sub NFSERR_REQTOOBIG () {10065;}' unless defined(&NFSERR_REQTOOBIG);
    eval 'sub NFSERR_REPTOOBIG () {10066;}' unless defined(&NFSERR_REPTOOBIG);
    eval 'sub NFSERR_REPTOOBIGTOCACHE () {10067;}' unless defined(&NFSERR_REPTOOBIGTOCACHE);
    eval 'sub NFSERR_RETRYUNCACHEDREP () {10068;}' unless defined(&NFSERR_RETRYUNCACHEDREP);
    eval 'sub NFSERR_UNSAFECOMPOUND () {10069;}' unless defined(&NFSERR_UNSAFECOMPOUND);
    eval 'sub NFSERR_TOOMANYOPS () {10070;}' unless defined(&NFSERR_TOOMANYOPS);
    eval 'sub NFSERR_OPNOTINSESS () {10071;}' unless defined(&NFSERR_OPNOTINSESS);
    eval 'sub NFSERR_HASHALGUNSUPP () {10072;}' unless defined(&NFSERR_HASHALGUNSUPP);
    eval 'sub NFSERR_CLIENTIDBUSY () {10074;}' unless defined(&NFSERR_CLIENTIDBUSY);
    eval 'sub NFSERR_PNFSIOHOLE () {10075;}' unless defined(&NFSERR_PNFSIOHOLE);
    eval 'sub NFSERR_SEQFALSERETRY () {10076;}' unless defined(&NFSERR_SEQFALSERETRY);
    eval 'sub NFSERR_BADHIGHSLOT () {10077;}' unless defined(&NFSERR_BADHIGHSLOT);
    eval 'sub NFSERR_DEADSESSION () {10078;}' unless defined(&NFSERR_DEADSESSION);
    eval 'sub NFSERR_ENCRALGUNSUPP () {10079;}' unless defined(&NFSERR_ENCRALGUNSUPP);
    eval 'sub NFSERR_PNFSNOLAYOUT () {10080;}' unless defined(&NFSERR_PNFSNOLAYOUT);
    eval 'sub NFSERR_NOTONLYOP () {10081;}' unless defined(&NFSERR_NOTONLYOP);
    eval 'sub NFSERR_WRONGCRED () {10082;}' unless defined(&NFSERR_WRONGCRED);
    eval 'sub NFSERR_WRONGTYPE () {10083;}' unless defined(&NFSERR_WRONGTYPE);
    eval 'sub NFSERR_DIRDELEGUNAVAIL () {10084;}' unless defined(&NFSERR_DIRDELEGUNAVAIL);
    eval 'sub NFSERR_REJECTDELEG () {10085;}' unless defined(&NFSERR_REJECTDELEG);
    eval 'sub NFSERR_RETURNCONFLICT () {10086;}' unless defined(&NFSERR_RETURNCONFLICT);
    eval 'sub NFSERR_DELEGREVOKED () {10087;}' unless defined(&NFSERR_DELEGREVOKED);
    eval 'sub NFSERR_STALEWRITEVERF () {30001;}' unless defined(&NFSERR_STALEWRITEVERF);
    eval 'sub NFSERR_DONTREPLY () {30003;}' unless defined(&NFSERR_DONTREPLY);
    eval 'sub NFSERR_RETVOID () {30004;}' unless defined(&NFSERR_RETVOID);
    eval 'sub NFSERR_REPLYFROMCACHE () {30005;}' unless defined(&NFSERR_REPLYFROMCACHE);
    eval 'sub NFSERR_STALEDONTRECOVER () {30006;}' unless defined(&NFSERR_STALEDONTRECOVER);
    eval 'sub NFSERR_RPCERR () {0x40000000;}' unless defined(&NFSERR_RPCERR);
    eval 'sub NFSERR_AUTHERR () {0x80000000;}' unless defined(&NFSERR_AUTHERR);
    eval 'sub NFSERR_RPCMISMATCH () {( &NFSERR_RPCERR |  &RPC_MISMATCH);}' unless defined(&NFSERR_RPCMISMATCH);
    eval 'sub NFSERR_PROGUNAVAIL () {( &NFSERR_RPCERR |  &RPC_PROGUNAVAIL);}' unless defined(&NFSERR_PROGUNAVAIL);
    eval 'sub NFSERR_PROGMISMATCH () {( &NFSERR_RPCERR |  &RPC_PROGMISMATCH);}' unless defined(&NFSERR_PROGMISMATCH);
    eval 'sub NFSERR_PROGNOTV4 () {( &NFSERR_RPCERR | 0xffff);}' unless defined(&NFSERR_PROGNOTV4);
    eval 'sub NFSERR_PROCUNAVAIL () {( &NFSERR_RPCERR |  &RPC_PROCUNAVAIL);}' unless defined(&NFSERR_PROCUNAVAIL);
    eval 'sub NFSERR_GARBAGE () {( &NFSERR_RPCERR |  &RPC_GARBAGE);}' unless defined(&NFSERR_GARBAGE);
    eval 'sub NFSX_UNSIGNED () {4;}' unless defined(&NFSX_UNSIGNED);
    eval 'sub NFSX_HYPER () {(2*  &NFSX_UNSIGNED);}' unless defined(&NFSX_HYPER);
    eval 'sub NFSX_V2FH () {32;}' unless defined(&NFSX_V2FH);
    eval 'sub NFSX_V2FATTR () {68;}' unless defined(&NFSX_V2FATTR);
    eval 'sub NFSX_V2SATTR () {32;}' unless defined(&NFSX_V2SATTR);
    eval 'sub NFSX_V2COOKIE () {4;}' unless defined(&NFSX_V2COOKIE);
    eval 'sub NFSX_V2STATFS () {20;}' unless defined(&NFSX_V2STATFS);
    eval 'sub NFSX_V3FHMAX () {64;}' unless defined(&NFSX_V3FHMAX);
    eval 'sub NFSX_V3FATTR () {84;}' unless defined(&NFSX_V3FATTR);
    eval 'sub NFSX_V3SATTR () {60;}' unless defined(&NFSX_V3SATTR);
    eval 'sub NFSX_V3SRVSATTR () {($sizeof{\'struct nfsv3_sattr\'});}' unless defined(&NFSX_V3SRVSATTR);
    eval 'sub NFSX_V3POSTOPATTR () {( &NFSX_V3FATTR +  &NFSX_UNSIGNED);}' unless defined(&NFSX_V3POSTOPATTR);
    eval 'sub NFSX_V3WCCDATA () {( &NFSX_V3POSTOPATTR + 8*  &NFSX_UNSIGNED);}' unless defined(&NFSX_V3WCCDATA);
    eval 'sub NFSX_V3STATFS () {52;}' unless defined(&NFSX_V3STATFS);
    eval 'sub NFSX_V3FSINFO () {48;}' unless defined(&NFSX_V3FSINFO);
    eval 'sub NFSX_V3PATHCONF () {24;}' unless defined(&NFSX_V3PATHCONF);
    eval 'sub NFSX_V4FHMAX () {128;}' unless defined(&NFSX_V4FHMAX);
    eval 'sub NFSX_V4FSID () {(2*  &NFSX_HYPER);}' unless defined(&NFSX_V4FSID);
    eval 'sub NFSX_V4SPECDATA () {(2*  &NFSX_UNSIGNED);}' unless defined(&NFSX_V4SPECDATA);
    eval 'sub NFSX_V4TIME () {( &NFSX_HYPER +  &NFSX_UNSIGNED);}' unless defined(&NFSX_V4TIME);
    eval 'sub NFSX_V4SETTIME () {( &NFSX_UNSIGNED +  &NFSX_V4TIME);}' unless defined(&NFSX_V4SETTIME);
    eval 'sub NFSX_V4SESSIONID () {16;}' unless defined(&NFSX_V4SESSIONID);
    eval 'sub NFSX_V4DEVICEID () {16;}' unless defined(&NFSX_V4DEVICEID);
    eval 'sub NFSX_FHMAX () {( &NFSX_V4FHMAX);}' unless defined(&NFSX_FHMAX);
    eval 'sub NFSX_MYFH () {($sizeof{ &fhandle_t});}' unless defined(&NFSX_MYFH);
    eval 'sub NFSX_VERF () {8;}' unless defined(&NFSX_VERF);
    eval 'sub NFSX_STATEIDOTHER () {12;}' unless defined(&NFSX_STATEIDOTHER);
    eval 'sub NFSX_STATEID () {( &NFSX_UNSIGNED +  &NFSX_STATEIDOTHER);}' unless defined(&NFSX_STATEID);
    eval 'sub NFSX_GSSH () {12;}' unless defined(&NFSX_GSSH);
    eval 'sub NFSX_STATFS {
        my($v3) = @_;
	    eval q((($v3) ?  &NFSX_V3STATFS :  &NFSX_V2STATFS));
    }' unless defined(&NFSX_STATFS);
    eval 'sub NFSPROC_NULL () {0;}' unless defined(&NFSPROC_NULL);
    eval 'sub NFSPROC_GETATTR () {1;}' unless defined(&NFSPROC_GETATTR);
    eval 'sub NFSPROC_SETATTR () {2;}' unless defined(&NFSPROC_SETATTR);
    eval 'sub NFSPROC_LOOKUP () {3;}' unless defined(&NFSPROC_LOOKUP);
    eval 'sub NFSPROC_ACCESS () {4;}' unless defined(&NFSPROC_ACCESS);
    eval 'sub NFSPROC_READLINK () {5;}' unless defined(&NFSPROC_READLINK);
    eval 'sub NFSPROC_READ () {6;}' unless defined(&NFSPROC_READ);
    eval 'sub NFSPROC_WRITE () {7;}' unless defined(&NFSPROC_WRITE);
    eval 'sub NFSPROC_CREATE () {8;}' unless defined(&NFSPROC_CREATE);
    eval 'sub NFSPROC_MKDIR () {9;}' unless defined(&NFSPROC_MKDIR);
    eval 'sub NFSPROC_SYMLINK () {10;}' unless defined(&NFSPROC_SYMLINK);
    eval 'sub NFSPROC_MKNOD () {11;}' unless defined(&NFSPROC_MKNOD);
    eval 'sub NFSPROC_REMOVE () {12;}' unless defined(&NFSPROC_REMOVE);
    eval 'sub NFSPROC_RMDIR () {13;}' unless defined(&NFSPROC_RMDIR);
    eval 'sub NFSPROC_RENAME () {14;}' unless defined(&NFSPROC_RENAME);
    eval 'sub NFSPROC_LINK () {15;}' unless defined(&NFSPROC_LINK);
    eval 'sub NFSPROC_READDIR () {16;}' unless defined(&NFSPROC_READDIR);
    eval 'sub NFSPROC_READDIRPLUS () {17;}' unless defined(&NFSPROC_READDIRPLUS);
    eval 'sub NFSPROC_FSSTAT () {18;}' unless defined(&NFSPROC_FSSTAT);
    eval 'sub NFSPROC_FSINFO () {19;}' unless defined(&NFSPROC_FSINFO);
    eval 'sub NFSPROC_PATHCONF () {20;}' unless defined(&NFSPROC_PATHCONF);
    eval 'sub NFSPROC_COMMIT () {21;}' unless defined(&NFSPROC_COMMIT);
    unless(defined(&NFS_V3NPROCS)) {
	eval 'sub NFS_V3NPROCS () {22;}' unless defined(&NFS_V3NPROCS);
	eval 'sub NFSPROC_LOOKUPP () {22;}' unless defined(&NFSPROC_LOOKUPP);
	eval 'sub NFSPROC_SETCLIENTID () {23;}' unless defined(&NFSPROC_SETCLIENTID);
	eval 'sub NFSPROC_SETCLIENTIDCFRM () {24;}' unless defined(&NFSPROC_SETCLIENTIDCFRM);
	eval 'sub NFSPROC_LOCK () {25;}' unless defined(&NFSPROC_LOCK);
	eval 'sub NFSPROC_LOCKU () {26;}' unless defined(&NFSPROC_LOCKU);
	eval 'sub NFSPROC_OPEN () {27;}' unless defined(&NFSPROC_OPEN);
	eval 'sub NFSPROC_CLOSE () {28;}' unless defined(&NFSPROC_CLOSE);
	eval 'sub NFSPROC_OPENCONFIRM () {29;}' unless defined(&NFSPROC_OPENCONFIRM);
	eval 'sub NFSPROC_LOCKT () {30;}' unless defined(&NFSPROC_LOCKT);
	eval 'sub NFSPROC_OPENDOWNGRADE () {31;}' unless defined(&NFSPROC_OPENDOWNGRADE);
	eval 'sub NFSPROC_RENEW () {32;}' unless defined(&NFSPROC_RENEW);
	eval 'sub NFSPROC_PUTROOTFH () {33;}' unless defined(&NFSPROC_PUTROOTFH);
	eval 'sub NFSPROC_RELEASELCKOWN () {34;}' unless defined(&NFSPROC_RELEASELCKOWN);
	eval 'sub NFSPROC_DELEGRETURN () {35;}' unless defined(&NFSPROC_DELEGRETURN);
	eval 'sub NFSPROC_RETDELEGREMOVE () {36;}' unless defined(&NFSPROC_RETDELEGREMOVE);
	eval 'sub NFSPROC_RETDELEGRENAME1 () {37;}' unless defined(&NFSPROC_RETDELEGRENAME1);
	eval 'sub NFSPROC_RETDELEGRENAME2 () {38;}' unless defined(&NFSPROC_RETDELEGRENAME2);
	eval 'sub NFSPROC_GETACL () {39;}' unless defined(&NFSPROC_GETACL);
	eval 'sub NFSPROC_SETACL () {40;}' unless defined(&NFSPROC_SETACL);
	eval 'sub NFSV4_NPROCS () {41;}' unless defined(&NFSV4_NPROCS);
	eval 'sub NFSPROC_EXCHANGEID () {41;}' unless defined(&NFSPROC_EXCHANGEID);
	eval 'sub NFSPROC_CREATESESSION () {42;}' unless defined(&NFSPROC_CREATESESSION);
	eval 'sub NFSPROC_DESTROYSESSION () {43;}' unless defined(&NFSPROC_DESTROYSESSION);
	eval 'sub NFSPROC_DESTROYCLIENT () {44;}' unless defined(&NFSPROC_DESTROYCLIENT);
	eval 'sub NFSPROC_FREESTATEID () {45;}' unless defined(&NFSPROC_FREESTATEID);
	eval 'sub NFSPROC_LAYOUTGET () {46;}' unless defined(&NFSPROC_LAYOUTGET);
	eval 'sub NFSPROC_GETDEVICEINFO () {47;}' unless defined(&NFSPROC_GETDEVICEINFO);
	eval 'sub NFSPROC_LAYOUTCOMMIT () {48;}' unless defined(&NFSPROC_LAYOUTCOMMIT);
	eval 'sub NFSPROC_LAYOUTRETURN () {49;}' unless defined(&NFSPROC_LAYOUTRETURN);
	eval 'sub NFSPROC_RECLAIMCOMPL () {50;}' unless defined(&NFSPROC_RECLAIMCOMPL);
	eval 'sub NFSPROC_WRITEDS () {51;}' unless defined(&NFSPROC_WRITEDS);
	eval 'sub NFSPROC_READDS () {52;}' unless defined(&NFSPROC_READDS);
	eval 'sub NFSPROC_COMMITDS () {53;}' unless defined(&NFSPROC_COMMITDS);
	eval 'sub NFSPROC_OPENLAYGET () {54;}' unless defined(&NFSPROC_OPENLAYGET);
	eval 'sub NFSPROC_CREATELAYGET () {55;}' unless defined(&NFSPROC_CREATELAYGET);
	eval 'sub NFSV41_NPROCS () {56;}' unless defined(&NFSV41_NPROCS);
    }
    unless(defined(&NFS_NPROCS)) {
	eval 'sub NFS_NPROCS () { &NFSV4_NPROCS;}' unless defined(&NFS_NPROCS);
    }
    eval 'sub NFSPROC_NOOP () { &NFSV42_NOPS;}' unless defined(&NFSPROC_NOOP);
    eval 'sub NFSV2PROC_NULL () {0;}' unless defined(&NFSV2PROC_NULL);
    eval 'sub NFSV2PROC_GETATTR () {1;}' unless defined(&NFSV2PROC_GETATTR);
    eval 'sub NFSV2PROC_SETATTR () {2;}' unless defined(&NFSV2PROC_SETATTR);
    eval 'sub NFSV2PROC_NOOP () {3;}' unless defined(&NFSV2PROC_NOOP);
    eval 'sub NFSV2PROC_ROOT () { &NFSV2PROC_NOOP;}' unless defined(&NFSV2PROC_ROOT);
    eval 'sub NFSV2PROC_LOOKUP () {4;}' unless defined(&NFSV2PROC_LOOKUP);
    eval 'sub NFSV2PROC_READLINK () {5;}' unless defined(&NFSV2PROC_READLINK);
    eval 'sub NFSV2PROC_READ () {6;}' unless defined(&NFSV2PROC_READ);
    eval 'sub NFSV2PROC_WRITECACHE () { &NFSV2PROC_NOOP;}' unless defined(&NFSV2PROC_WRITECACHE);
    eval 'sub NFSV2PROC_WRITE () {8;}' unless defined(&NFSV2PROC_WRITE);
    eval 'sub NFSV2PROC_CREATE () {9;}' unless defined(&NFSV2PROC_CREATE);
    eval 'sub NFSV2PROC_REMOVE () {10;}' unless defined(&NFSV2PROC_REMOVE);
    eval 'sub NFSV2PROC_RENAME () {11;}' unless defined(&NFSV2PROC_RENAME);
    eval 'sub NFSV2PROC_LINK () {12;}' unless defined(&NFSV2PROC_LINK);
    eval 'sub NFSV2PROC_SYMLINK () {13;}' unless defined(&NFSV2PROC_SYMLINK);
    eval 'sub NFSV2PROC_MKDIR () {14;}' unless defined(&NFSV2PROC_MKDIR);
    eval 'sub NFSV2PROC_RMDIR () {15;}' unless defined(&NFSV2PROC_RMDIR);
    eval 'sub NFSV2PROC_READDIR () {16;}' unless defined(&NFSV2PROC_READDIR);
    eval 'sub NFSV2PROC_STATFS () {17;}' unless defined(&NFSV2PROC_STATFS);
    eval 'sub NFSV4PROC_COMPOUND () {1;}' unless defined(&NFSV4PROC_COMPOUND);
    eval 'sub NFSV4PROC_CBNULL () {0;}' unless defined(&NFSV4PROC_CBNULL);
    eval 'sub NFSV4PROC_CBCOMPOUND () {1;}' unless defined(&NFSV4PROC_CBCOMPOUND);
    eval 'sub NFSV3SATTRTIME_DONTCHANGE () {0;}' unless defined(&NFSV3SATTRTIME_DONTCHANGE);
    eval 'sub NFSV3SATTRTIME_TOSERVER () {1;}' unless defined(&NFSV3SATTRTIME_TOSERVER);
    eval 'sub NFSV3SATTRTIME_TOCLIENT () {2;}' unless defined(&NFSV3SATTRTIME_TOCLIENT);
    eval 'sub NFSV4SATTRTIME_TOSERVER () {0;}' unless defined(&NFSV4SATTRTIME_TOSERVER);
    eval 'sub NFSV4SATTRTIME_TOCLIENT () {1;}' unless defined(&NFSV4SATTRTIME_TOCLIENT);
    eval 'sub NFSV4LOCKT_READ () {1;}' unless defined(&NFSV4LOCKT_READ);
    eval 'sub NFSV4LOCKT_WRITE () {2;}' unless defined(&NFSV4LOCKT_WRITE);
    eval 'sub NFSV4LOCKT_READW () {3;}' unless defined(&NFSV4LOCKT_READW);
    eval 'sub NFSV4LOCKT_WRITEW () {4;}' unless defined(&NFSV4LOCKT_WRITEW);
    eval 'sub NFSV4LOCKT_RELEASE () {5;}' unless defined(&NFSV4LOCKT_RELEASE);
    eval 'sub NFSV4OPEN_NOCREATE () {0;}' unless defined(&NFSV4OPEN_NOCREATE);
    eval 'sub NFSV4OPEN_CREATE () {1;}' unless defined(&NFSV4OPEN_CREATE);
    eval 'sub NFSV4OPEN_CLAIMNULL () {0;}' unless defined(&NFSV4OPEN_CLAIMNULL);
    eval 'sub NFSV4OPEN_CLAIMPREVIOUS () {1;}' unless defined(&NFSV4OPEN_CLAIMPREVIOUS);
    eval 'sub NFSV4OPEN_CLAIMDELEGATECUR () {2;}' unless defined(&NFSV4OPEN_CLAIMDELEGATECUR);
    eval 'sub NFSV4OPEN_CLAIMDELEGATEPREV () {3;}' unless defined(&NFSV4OPEN_CLAIMDELEGATEPREV);
    eval 'sub NFSV4OPEN_CLAIMFH () {4;}' unless defined(&NFSV4OPEN_CLAIMFH);
    eval 'sub NFSV4OPEN_CLAIMDELEGATECURFH () {5;}' unless defined(&NFSV4OPEN_CLAIMDELEGATECURFH);
    eval 'sub NFSV4OPEN_CLAIMDELEGATEPREVFH () {6;}' unless defined(&NFSV4OPEN_CLAIMDELEGATEPREVFH);
    eval 'sub NFSV4OPEN_DELEGATENONE () {0;}' unless defined(&NFSV4OPEN_DELEGATENONE);
    eval 'sub NFSV4OPEN_DELEGATEREAD () {1;}' unless defined(&NFSV4OPEN_DELEGATEREAD);
    eval 'sub NFSV4OPEN_DELEGATEWRITE () {2;}' unless defined(&NFSV4OPEN_DELEGATEWRITE);
    eval 'sub NFSV4OPEN_DELEGATENONEEXT () {3;}' unless defined(&NFSV4OPEN_DELEGATENONEEXT);
    eval 'sub NFSV4OPEN_LIMITSIZE () {1;}' unless defined(&NFSV4OPEN_LIMITSIZE);
    eval 'sub NFSV4OPEN_LIMITBLOCKS () {2;}' unless defined(&NFSV4OPEN_LIMITBLOCKS);
    eval 'sub NFSV4ACE_ALLOWEDTYPE () {0x;}' unless defined(&NFSV4ACE_ALLOWEDTYPE);
    eval 'sub NFSV4ACE_DENIEDTYPE () {0x1;}' unless defined(&NFSV4ACE_DENIEDTYPE);
    eval 'sub NFSV4ACE_AUDITTYPE () {0x2;}' unless defined(&NFSV4ACE_AUDITTYPE);
    eval 'sub NFSV4ACE_ALARMTYPE () {0x3;}' unless defined(&NFSV4ACE_ALARMTYPE);
    eval 'sub NFSV4ACE_SUPALLOWED () {0x1;}' unless defined(&NFSV4ACE_SUPALLOWED);
    eval 'sub NFSV4ACE_SUPDENIED () {0x2;}' unless defined(&NFSV4ACE_SUPDENIED);
    eval 'sub NFSV4ACE_SUPAUDIT () {0x4;}' unless defined(&NFSV4ACE_SUPAUDIT);
    eval 'sub NFSV4ACE_SUPALARM () {0x8;}' unless defined(&NFSV4ACE_SUPALARM);
    eval 'sub NFSV4ACE_SUPTYPES () {( &NFSV4ACE_SUPALLOWED |  &NFSV4ACE_SUPDENIED);}' unless defined(&NFSV4ACE_SUPTYPES);
    eval 'sub NFSV4ACE_FILEINHERIT () {0x1;}' unless defined(&NFSV4ACE_FILEINHERIT);
    eval 'sub NFSV4ACE_DIRECTORYINHERIT () {0x2;}' unless defined(&NFSV4ACE_DIRECTORYINHERIT);
    eval 'sub NFSV4ACE_NOPROPAGATEINHERIT () {0x4;}' unless defined(&NFSV4ACE_NOPROPAGATEINHERIT);
    eval 'sub NFSV4ACE_INHERITONLY () {0x8;}' unless defined(&NFSV4ACE_INHERITONLY);
    eval 'sub NFSV4ACE_SUCCESSFULACCESS () {0x10;}' unless defined(&NFSV4ACE_SUCCESSFULACCESS);
    eval 'sub NFSV4ACE_FAILEDACCESS () {0x20;}' unless defined(&NFSV4ACE_FAILEDACCESS);
    eval 'sub NFSV4ACE_IDENTIFIERGROUP () {0x40;}' unless defined(&NFSV4ACE_IDENTIFIERGROUP);
    eval 'sub NFSV4ACE_READDATA () {0x1;}' unless defined(&NFSV4ACE_READDATA);
    eval 'sub NFSV4ACE_LISTDIRECTORY () {0x1;}' unless defined(&NFSV4ACE_LISTDIRECTORY);
    eval 'sub NFSV4ACE_WRITEDATA () {0x2;}' unless defined(&NFSV4ACE_WRITEDATA);
    eval 'sub NFSV4ACE_ADDFILE () {0x2;}' unless defined(&NFSV4ACE_ADDFILE);
    eval 'sub NFSV4ACE_APPENDDATA () {0x4;}' unless defined(&NFSV4ACE_APPENDDATA);
    eval 'sub NFSV4ACE_ADDSUBDIRECTORY () {0x4;}' unless defined(&NFSV4ACE_ADDSUBDIRECTORY);
    eval 'sub NFSV4ACE_READNAMEDATTR () {0x8;}' unless defined(&NFSV4ACE_READNAMEDATTR);
    eval 'sub NFSV4ACE_WRITENAMEDATTR () {0x10;}' unless defined(&NFSV4ACE_WRITENAMEDATTR);
    eval 'sub NFSV4ACE_EXECUTE () {0x20;}' unless defined(&NFSV4ACE_EXECUTE);
    eval 'sub NFSV4ACE_SEARCH () {0x20;}' unless defined(&NFSV4ACE_SEARCH);
    eval 'sub NFSV4ACE_DELETECHILD () {0x40;}' unless defined(&NFSV4ACE_DELETECHILD);
    eval 'sub NFSV4ACE_READATTRIBUTES () {0x80;}' unless defined(&NFSV4ACE_READATTRIBUTES);
    eval 'sub NFSV4ACE_WRITEATTRIBUTES () {0x100;}' unless defined(&NFSV4ACE_WRITEATTRIBUTES);
    eval 'sub NFSV4ACE_DELETE () {0x10000;}' unless defined(&NFSV4ACE_DELETE);
    eval 'sub NFSV4ACE_READACL () {0x20000;}' unless defined(&NFSV4ACE_READACL);
    eval 'sub NFSV4ACE_WRITEACL () {0x40000;}' unless defined(&NFSV4ACE_WRITEACL);
    eval 'sub NFSV4ACE_WRITEOWNER () {0x80000;}' unless defined(&NFSV4ACE_WRITEOWNER);
    eval 'sub NFSV4ACE_SYNCHRONIZE () {0x100000;}' unless defined(&NFSV4ACE_SYNCHRONIZE);
    eval 'sub NFSV4ACE_ALLFILESMASK () {( &NFSV4ACE_READATTRIBUTES |  &NFSV4ACE_READACL);}' unless defined(&NFSV4ACE_ALLFILESMASK);
    eval 'sub NFSV4ACE_OWNERMASK () {( &NFSV4ACE_WRITEATTRIBUTES |  &NFSV4ACE_WRITEACL);}' unless defined(&NFSV4ACE_OWNERMASK);
    eval 'sub NFSV4ACE_DIRREADMASK () { &NFSV4ACE_LISTDIRECTORY;}' unless defined(&NFSV4ACE_DIRREADMASK);
    eval 'sub NFSV4ACE_DIREXECUTEMASK () { &NFSV4ACE_EXECUTE;}' unless defined(&NFSV4ACE_DIREXECUTEMASK);
    eval 'sub NFSV4ACE_DIRWRITEMASK () {( &NFSV4ACE_ADDFILE |  &NFSV4ACE_ADDSUBDIRECTORY |  &NFSV4ACE_DELETECHILD);}' unless defined(&NFSV4ACE_DIRWRITEMASK);
    eval 'sub NFSV4ACE_READMASK () { &NFSV4ACE_READDATA;}' unless defined(&NFSV4ACE_READMASK);
    eval 'sub NFSV4ACE_WRITEMASK () {( &NFSV4ACE_WRITEDATA |  &NFSV4ACE_APPENDDATA);}' unless defined(&NFSV4ACE_WRITEMASK);
    eval 'sub NFSV4ACE_EXECUTEMASK () { &NFSV4ACE_EXECUTE;}' unless defined(&NFSV4ACE_EXECUTEMASK);
    eval 'sub NFSV4ACE_ALLFILEBITS () {( &NFSV4ACE_READMASK |  &NFSV4ACE_WRITEMASK |  &NFSV4ACE_EXECUTEMASK |  &NFSV4ACE_SYNCHRONIZE);}' unless defined(&NFSV4ACE_ALLFILEBITS);
    eval 'sub NFSV4ACE_ALLDIRBITS () {( &NFSV4ACE_DIRREADMASK |  &NFSV4ACE_DIRWRITEMASK |  &NFSV4ACE_DIREXECUTEMASK);}' unless defined(&NFSV4ACE_ALLDIRBITS);
    eval 'sub NFSV4ACE_AUDITMASK () {0x;}' unless defined(&NFSV4ACE_AUDITMASK);
    eval 'sub NFSV4ACE_GENERICREAD () {0x120081;}' unless defined(&NFSV4ACE_GENERICREAD);
    eval 'sub NFSV4ACE_GENERICWRITE () {0x160106;}' unless defined(&NFSV4ACE_GENERICWRITE);
    eval 'sub NFSV4ACE_GENERICEXECUTE () {0x1200a0;}' unless defined(&NFSV4ACE_GENERICEXECUTE);
    eval 'sub NFSSTATEID_PUTALLZERO () {0;}' unless defined(&NFSSTATEID_PUTALLZERO);
    eval 'sub NFSSTATEID_PUTALLONE () {1;}' unless defined(&NFSSTATEID_PUTALLONE);
    eval 'sub NFSSTATEID_PUTSTATEID () {2;}' unless defined(&NFSSTATEID_PUTSTATEID);
    eval 'sub NFSSTATEID_PUTSEQIDZERO () {3;}' unless defined(&NFSSTATEID_PUTSEQIDZERO);
    eval 'sub NFSV4OPEN_ACCESSREAD () {0x1;}' unless defined(&NFSV4OPEN_ACCESSREAD);
    eval 'sub NFSV4OPEN_ACCESSWRITE () {0x2;}' unless defined(&NFSV4OPEN_ACCESSWRITE);
    eval 'sub NFSV4OPEN_ACCESSBOTH () {0x3;}' unless defined(&NFSV4OPEN_ACCESSBOTH);
    eval 'sub NFSV4OPEN_WANTDELEGMASK () {0xff00;}' unless defined(&NFSV4OPEN_WANTDELEGMASK);
    eval 'sub NFSV4OPEN_WANTREADDELEG () {0x100;}' unless defined(&NFSV4OPEN_WANTREADDELEG);
    eval 'sub NFSV4OPEN_WANTWRITEDELEG () {0x200;}' unless defined(&NFSV4OPEN_WANTWRITEDELEG);
    eval 'sub NFSV4OPEN_WANTANYDELEG () {0x300;}' unless defined(&NFSV4OPEN_WANTANYDELEG);
    eval 'sub NFSV4OPEN_WANTNODELEG () {0x400;}' unless defined(&NFSV4OPEN_WANTNODELEG);
    eval 'sub NFSV4OPEN_WANTCANCEL () {0x500;}' unless defined(&NFSV4OPEN_WANTCANCEL);
    eval 'sub NFSV4OPEN_WANTSIGNALDELEG () {0x10000;}' unless defined(&NFSV4OPEN_WANTSIGNALDELEG);
    eval 'sub NFSV4OPEN_WANTPUSHDELEG () {0x20000;}' unless defined(&NFSV4OPEN_WANTPUSHDELEG);
    eval 'sub NFSV4OPEN_DENYNONE () {0x;}' unless defined(&NFSV4OPEN_DENYNONE);
    eval 'sub NFSV4OPEN_DENYREAD () {0x1;}' unless defined(&NFSV4OPEN_DENYREAD);
    eval 'sub NFSV4OPEN_DENYWRITE () {0x2;}' unless defined(&NFSV4OPEN_DENYWRITE);
    eval 'sub NFSV4OPEN_DENYBOTH () {0x3;}' unless defined(&NFSV4OPEN_DENYBOTH);
    eval 'sub NFSV4OPEN_NOTWANTED () {0;}' unless defined(&NFSV4OPEN_NOTWANTED);
    eval 'sub NFSV4OPEN_CONTENTION () {1;}' unless defined(&NFSV4OPEN_CONTENTION);
    eval 'sub NFSV4OPEN_RESOURCE () {2;}' unless defined(&NFSV4OPEN_RESOURCE);
    eval 'sub NFSV4OPEN_NOTSUPPFTYPE () {3;}' unless defined(&NFSV4OPEN_NOTSUPPFTYPE);
    eval 'sub NFSV4OPEN_NOTSUPPWRITEFTYPE () {4;}' unless defined(&NFSV4OPEN_NOTSUPPWRITEFTYPE);
    eval 'sub NFSV4OPEN_NOTSUPPUPGRADE () {5;}' unless defined(&NFSV4OPEN_NOTSUPPUPGRADE);
    eval 'sub NFSV4OPEN_NOTSUPPDOWNGRADE () {6;}' unless defined(&NFSV4OPEN_NOTSUPPDOWNGRADE);
    eval 'sub NFSV4OPEN_CANCELLED () {7;}' unless defined(&NFSV4OPEN_CANCELLED);
    eval 'sub NFSV4OPEN_ISDIR () {8;}' unless defined(&NFSV4OPEN_ISDIR);
    eval 'sub NFSV4OPEN_RESULTCONFIRM () {0x2;}' unless defined(&NFSV4OPEN_RESULTCONFIRM);
    eval 'sub NFSV4OPEN_LOCKTYPEPOSIX () {0x4;}' unless defined(&NFSV4OPEN_LOCKTYPEPOSIX);
    eval 'sub NFSV4OPEN_PRESERVEUNLINKED () {0x8;}' unless defined(&NFSV4OPEN_PRESERVEUNLINKED);
    eval 'sub NFSV4OPEN_MAYNOTIFYLOCK () {0x20;}' unless defined(&NFSV4OPEN_MAYNOTIFYLOCK);
    eval 'sub NFSV4OPEN_RFLAGS () {( &NFSV4OPEN_RESULTCONFIRM |  &NFSV4OPEN_LOCKTYPEPOSIX |  &NFSV4OPEN_PRESERVEUNLINKED |  &NFSV4OPEN_MAYNOTIFYLOCK);}' unless defined(&NFSV4OPEN_RFLAGS);
    eval 'sub NFSV4OPEN_RECALL () {0x10000;}' unless defined(&NFSV4OPEN_RECALL);
    eval 'sub NFSV4OPEN_READDELEGATE () {0x20000;}' unless defined(&NFSV4OPEN_READDELEGATE);
    eval 'sub NFSV4OPEN_WRITEDELEGATE () {0x40000;}' unless defined(&NFSV4OPEN_WRITEDELEGATE);
    eval 'sub NFSV4OPEN_WDRESOURCE () {0x80000;}' unless defined(&NFSV4OPEN_WDRESOURCE);
    eval 'sub NFSV4OPEN_WDCONTENTION () {0x100000;}' unless defined(&NFSV4OPEN_WDCONTENTION);
    eval 'sub NFSV4OPEN_WDNOTWANTED () {0x200000;}' unless defined(&NFSV4OPEN_WDNOTWANTED);
    eval 'sub NFSV4FHTYPE_PERSISTENT () {0x;}' unless defined(&NFSV4FHTYPE_PERSISTENT);
    eval 'sub NFSV4FHTYPE_NOEXPIREWITHOPEN () {0x1;}' unless defined(&NFSV4FHTYPE_NOEXPIREWITHOPEN);
    eval 'sub NFSV4FHTYPE_VOLATILEANY () {0x2;}' unless defined(&NFSV4FHTYPE_VOLATILEANY);
    eval 'sub NFSV4FHTYPE_VOLATILEMIGRATE () {0x4;}' unless defined(&NFSV4FHTYPE_VOLATILEMIGRATE);
    eval 'sub NFSV4FHTYPE_VOLATILERENAME () {0x8;}' unless defined(&NFSV4FHTYPE_VOLATILERENAME);
    eval 'sub NFSV4_OPAQUELIMIT () {1024;}' unless defined(&NFSV4_OPAQUELIMIT);
    eval 'sub NFSACCESS_READ () {0x1;}' unless defined(&NFSACCESS_READ);
    eval 'sub NFSACCESS_LOOKUP () {0x2;}' unless defined(&NFSACCESS_LOOKUP);
    eval 'sub NFSACCESS_MODIFY () {0x4;}' unless defined(&NFSACCESS_MODIFY);
    eval 'sub NFSACCESS_EXTEND () {0x8;}' unless defined(&NFSACCESS_EXTEND);
    eval 'sub NFSACCESS_DELETE () {0x10;}' unless defined(&NFSACCESS_DELETE);
    eval 'sub NFSACCESS_EXECUTE () {0x20;}' unless defined(&NFSACCESS_EXECUTE);
    eval 'sub NFSWRITE_UNSTABLE () {0;}' unless defined(&NFSWRITE_UNSTABLE);
    eval 'sub NFSWRITE_DATASYNC () {1;}' unless defined(&NFSWRITE_DATASYNC);
    eval 'sub NFSWRITE_FILESYNC () {2;}' unless defined(&NFSWRITE_FILESYNC);
    eval 'sub NFSCREATE_UNCHECKED () {0;}' unless defined(&NFSCREATE_UNCHECKED);
    eval 'sub NFSCREATE_GUARDED () {1;}' unless defined(&NFSCREATE_GUARDED);
    eval 'sub NFSCREATE_EXCLUSIVE () {2;}' unless defined(&NFSCREATE_EXCLUSIVE);
    eval 'sub NFSCREATE_EXCLUSIVE41 () {3;}' unless defined(&NFSCREATE_EXCLUSIVE41);
    eval 'sub NFSV3FSINFO_LINK () {0x1;}' unless defined(&NFSV3FSINFO_LINK);
    eval 'sub NFSV3FSINFO_SYMLINK () {0x2;}' unless defined(&NFSV3FSINFO_SYMLINK);
    eval 'sub NFSV3FSINFO_HOMOGENEOUS () {0x8;}' unless defined(&NFSV3FSINFO_HOMOGENEOUS);
    eval 'sub NFSV3FSINFO_CANSETTIME () {0x10;}' unless defined(&NFSV3FSINFO_CANSETTIME);
    eval 'sub NFSV4EXCH_SUPPMOVEDREFER () {0x1;}' unless defined(&NFSV4EXCH_SUPPMOVEDREFER);
    eval 'sub NFSV4EXCH_SUPPMOVEDMIGR () {0x2;}' unless defined(&NFSV4EXCH_SUPPMOVEDMIGR);
    eval 'sub NFSV4EXCH_BINDPRINCSTATEID () {0x100;}' unless defined(&NFSV4EXCH_BINDPRINCSTATEID);
    eval 'sub NFSV4EXCH_USENONPNFS () {0x10000;}' unless defined(&NFSV4EXCH_USENONPNFS);
    eval 'sub NFSV4EXCH_USEPNFSMDS () {0x20000;}' unless defined(&NFSV4EXCH_USEPNFSMDS);
    eval 'sub NFSV4EXCH_USEPNFSDS () {0x40000;}' unless defined(&NFSV4EXCH_USEPNFSDS);
    eval 'sub NFSV4EXCH_MASKPNFS () {0x70000;}' unless defined(&NFSV4EXCH_MASKPNFS);
    eval 'sub NFSV4EXCH_UPDCONFIRMEDRECA () {0x40000000;}' unless defined(&NFSV4EXCH_UPDCONFIRMEDRECA);
    eval 'sub NFSV4EXCH_CONFIRMEDR () {0x80000000;}' unless defined(&NFSV4EXCH_CONFIRMEDR);
    eval 'sub NFSV4EXCH_SP4NONE () {0;}' unless defined(&NFSV4EXCH_SP4NONE);
    eval 'sub NFSV4EXCH_SP4MACHCRED () {1;}' unless defined(&NFSV4EXCH_SP4MACHCRED);
    eval 'sub NFSV4EXCH_SP4SSV () {2;}' unless defined(&NFSV4EXCH_SP4SSV);
    eval 'sub NFSV4CRSESS_PERSIST () {0x1;}' unless defined(&NFSV4CRSESS_PERSIST);
    eval 'sub NFSV4CRSESS_CONNBACKCHAN () {0x2;}' unless defined(&NFSV4CRSESS_CONNBACKCHAN);
    eval 'sub NFSV4CRSESS_CONNRDMA () {0x4;}' unless defined(&NFSV4CRSESS_CONNRDMA);
    eval 'sub NFSV4SEQ_CBPATHDOWN () {0x1;}' unless defined(&NFSV4SEQ_CBPATHDOWN);
    eval 'sub NFSV4SEQ_CBGSSCONTEXPIRING () {0x2;}' unless defined(&NFSV4SEQ_CBGSSCONTEXPIRING);
    eval 'sub NFSV4SEQ_CBGSSCONTEXPIRED () {0x4;}' unless defined(&NFSV4SEQ_CBGSSCONTEXPIRED);
    eval 'sub NFSV4SEQ_EXPIREDALLSTATEREVOKED () {0x8;}' unless defined(&NFSV4SEQ_EXPIREDALLSTATEREVOKED);
    eval 'sub NFSV4SEQ_EXPIREDSOMESTATEREVOKED () {0x10;}' unless defined(&NFSV4SEQ_EXPIREDSOMESTATEREVOKED);
    eval 'sub NFSV4SEQ_ADMINSTATEREVOKED () {0x20;}' unless defined(&NFSV4SEQ_ADMINSTATEREVOKED);
    eval 'sub NFSV4SEQ_RECALLABLESTATEREVOKED () {0x40;}' unless defined(&NFSV4SEQ_RECALLABLESTATEREVOKED);
    eval 'sub NFSV4SEQ_LEASEMOVED () {0x80;}' unless defined(&NFSV4SEQ_LEASEMOVED);
    eval 'sub NFSV4SEQ_RESTARTRECLAIMNEEDED () {0x100;}' unless defined(&NFSV4SEQ_RESTARTRECLAIMNEEDED);
    eval 'sub NFSV4SEQ_CBPATHDOWNSESSION () {0x200;}' unless defined(&NFSV4SEQ_CBPATHDOWNSESSION);
    eval 'sub NFSV4SEQ_BACKCHANNELFAULT () {0x400;}' unless defined(&NFSV4SEQ_BACKCHANNELFAULT);
    eval 'sub NFSV4SEQ_DEVIDCHANGED () {0x800;}' unless defined(&NFSV4SEQ_DEVIDCHANGED);
    eval 'sub NFSV4SEQ_DEVIDDELETED () {0x1000;}' unless defined(&NFSV4SEQ_DEVIDDELETED);
    eval 'sub NFSLAYOUTRETURN_FILE () {1;}' unless defined(&NFSLAYOUTRETURN_FILE);
    eval 'sub NFSLAYOUTRETURN_FSID () {2;}' unless defined(&NFSLAYOUTRETURN_FSID);
    eval 'sub NFSLAYOUTRETURN_ALL () {3;}' unless defined(&NFSLAYOUTRETURN_ALL);
    eval 'sub NFSLAYOUT_NFSV4_1_FILES () {0x1;}' unless defined(&NFSLAYOUT_NFSV4_1_FILES);
    eval 'sub NFSLAYOUT_OSD2_OBJECTS () {0x2;}' unless defined(&NFSLAYOUT_OSD2_OBJECTS);
    eval 'sub NFSLAYOUT_BLOCK_VOLUME () {0x3;}' unless defined(&NFSLAYOUT_BLOCK_VOLUME);
    eval 'sub NFSLAYOUTIOMODE_READ () {1;}' unless defined(&NFSLAYOUTIOMODE_READ);
    eval 'sub NFSLAYOUTIOMODE_RW () {2;}' unless defined(&NFSLAYOUTIOMODE_RW);
    eval 'sub NFSLAYOUTIOMODE_ANY () {3;}' unless defined(&NFSLAYOUTIOMODE_ANY);
    eval 'sub NFSDEVICEIDNOTIFY_CHANGEBIT () {0x1;}' unless defined(&NFSDEVICEIDNOTIFY_CHANGEBIT);
    eval 'sub NFSDEVICEIDNOTIFY_DELETEBIT () {0x2;}' unless defined(&NFSDEVICEIDNOTIFY_DELETEBIT);
    eval 'sub NFSFLAYUTIL_DENSE () {0x1;}' unless defined(&NFSFLAYUTIL_DENSE);
    eval 'sub NFSFLAYUTIL_COMMIT_THRU_MDS () {0x2;}' unless defined(&NFSFLAYUTIL_COMMIT_THRU_MDS);
    eval 'sub vtonfsv2_mode {
        my($t,$m) = @_;
	    eval q( &txdr_unsigned((($t) ==  &VFIFO) ?  &MAKEIMODE( &VCHR, ($m)) :  &MAKEIMODE(($t), ($m))));
    }' unless defined(&vtonfsv2_mode);
    eval 'sub vtonfsv34_mode {
        my($m) = @_;
	    eval q( &txdr_unsigned(($m) & 07777));
    }' unless defined(&vtonfsv34_mode);
    eval 'sub nfstov_mode {
        my($a) = @_;
	    eval q(( &fxdr_unsigned( &u_int16_t, ($a))&07777));
    }' unless defined(&nfstov_mode);
    eval 'sub vtonfsv2_type {
        my($a) = @_;
	    eval q(((( &u_int32_t)($a)) >= 9?  &txdr_unsigned( &NFNON) :  &txdr_unsigned( $newnfsv2_type[(( &u_int32_t)($a))])));
    }' unless defined(&vtonfsv2_type);
    eval 'sub vtonfsv34_type {
        my($a) = @_;
	    eval q(((( &u_int32_t)($a)) >= 9?  &txdr_unsigned( &NFNON) :  &txdr_unsigned( $nfsv34_type[(( &u_int32_t)($a))])));
    }' unless defined(&vtonfsv34_type);
    eval 'sub nfsv2tov_type {
        my($a) = @_;
	    eval q( $newnv2tov_type[ &fxdr_unsigned( &u_int32_t,($a))&0x7]);
    }' unless defined(&nfsv2tov_type);
    eval 'sub nfsv34tov_type {
        my($a) = @_;
	    eval q( $nv34tov_type[ &fxdr_unsigned( &u_int32_t,($a))&0x7]);
    }' unless defined(&nfsv34tov_type);
    eval 'sub vtonfs_dtype {
        my($a) = @_;
	    eval q(((( &u_int32_t)($a)) >= 9?  &IFTODT( &VTTOIF( &VNON)) :  &IFTODT( &VTTOIF($a))));
    }' unless defined(&vtonfs_dtype);
    eval("sub NFNON () { 0; }") unless defined(&NFNON);
    eval("sub NFREG () { 1; }") unless defined(&NFREG);
    eval("sub NFDIR () { 2; }") unless defined(&NFDIR);
    eval("sub NFBLK () { 3; }") unless defined(&NFBLK);
    eval("sub NFCHR () { 4; }") unless defined(&NFCHR);
    eval("sub NFLNK () { 5; }") unless defined(&NFLNK);
    eval("sub NFSOCK () { 6; }") unless defined(&NFSOCK);
    eval("sub NFFIFO () { 7; }") unless defined(&NFFIFO);
    eval("sub NFATTRDIR () { 8; }") unless defined(&NFATTRDIR);
    eval("sub NFNAMEDATTR () { 9; }") unless defined(&NFNAMEDATTR);
    eval 'sub fa2_size () { ($fa_un->{fa_nfsv2}->{nfsv2fa_size});}' unless defined(&fa2_size);
    eval 'sub fa2_blocksize () { ($fa_un->{fa_nfsv2}->{nfsv2fa_blocksize});}' unless defined(&fa2_blocksize);
    eval 'sub fa2_rdev () { ($fa_un->{fa_nfsv2}->{nfsv2fa_rdev});}' unless defined(&fa2_rdev);
    eval 'sub fa2_blocks () { ($fa_un->{fa_nfsv2}->{nfsv2fa_blocks});}' unless defined(&fa2_blocks);
    eval 'sub fa2_fsid () { ($fa_un->{fa_nfsv2}->{nfsv2fa_fsid});}' unless defined(&fa2_fsid);
    eval 'sub fa2_fileid () { ($fa_un->{fa_nfsv2}->{nfsv2fa_fileid});}' unless defined(&fa2_fileid);
    eval 'sub fa2_atime () { ($fa_un->{fa_nfsv2}->{nfsv2fa_atime});}' unless defined(&fa2_atime);
    eval 'sub fa2_mtime () { ($fa_un->{fa_nfsv2}->{nfsv2fa_mtime});}' unless defined(&fa2_mtime);
    eval 'sub fa2_ctime () { ($fa_un->{fa_nfsv2}->{nfsv2fa_ctime});}' unless defined(&fa2_ctime);
    eval 'sub fa3_size () { ($fa_un->{fa_nfsv3}->{nfsv3fa_size});}' unless defined(&fa3_size);
    eval 'sub fa3_used () { ($fa_un->{fa_nfsv3}->{nfsv3fa_used});}' unless defined(&fa3_used);
    eval 'sub fa3_rdev () { ($fa_un->{fa_nfsv3}->{nfsv3fa_rdev});}' unless defined(&fa3_rdev);
    eval 'sub fa3_fsid () { ($fa_un->{fa_nfsv3}->{nfsv3fa_fsid});}' unless defined(&fa3_fsid);
    eval 'sub fa3_fileid () { ($fa_un->{fa_nfsv3}->{nfsv3fa_fileid});}' unless defined(&fa3_fileid);
    eval 'sub fa3_atime () { ($fa_un->{fa_nfsv3}->{nfsv3fa_atime});}' unless defined(&fa3_atime);
    eval 'sub fa3_mtime () { ($fa_un->{fa_nfsv3}->{nfsv3fa_mtime});}' unless defined(&fa3_mtime);
    eval 'sub fa3_ctime () { ($fa_un->{fa_nfsv3}->{nfsv3fa_ctime});}' unless defined(&fa3_ctime);
    eval 'sub NFSATTRBIT_SUPPORTEDATTRS () {0;}' unless defined(&NFSATTRBIT_SUPPORTEDATTRS);
    eval 'sub NFSATTRBIT_TYPE () {1;}' unless defined(&NFSATTRBIT_TYPE);
    eval 'sub NFSATTRBIT_FHEXPIRETYPE () {2;}' unless defined(&NFSATTRBIT_FHEXPIRETYPE);
    eval 'sub NFSATTRBIT_CHANGE () {3;}' unless defined(&NFSATTRBIT_CHANGE);
    eval 'sub NFSATTRBIT_SIZE () {4;}' unless defined(&NFSATTRBIT_SIZE);
    eval 'sub NFSATTRBIT_LINKSUPPORT () {5;}' unless defined(&NFSATTRBIT_LINKSUPPORT);
    eval 'sub NFSATTRBIT_SYMLINKSUPPORT () {6;}' unless defined(&NFSATTRBIT_SYMLINKSUPPORT);
    eval 'sub NFSATTRBIT_NAMEDATTR () {7;}' unless defined(&NFSATTRBIT_NAMEDATTR);
    eval 'sub NFSATTRBIT_FSID () {8;}' unless defined(&NFSATTRBIT_FSID);
    eval 'sub NFSATTRBIT_UNIQUEHANDLES () {9;}' unless defined(&NFSATTRBIT_UNIQUEHANDLES);
    eval 'sub NFSATTRBIT_LEASETIME () {10;}' unless defined(&NFSATTRBIT_LEASETIME);
    eval 'sub NFSATTRBIT_RDATTRERROR () {11;}' unless defined(&NFSATTRBIT_RDATTRERROR);
    eval 'sub NFSATTRBIT_ACL () {12;}' unless defined(&NFSATTRBIT_ACL);
    eval 'sub NFSATTRBIT_ACLSUPPORT () {13;}' unless defined(&NFSATTRBIT_ACLSUPPORT);
    eval 'sub NFSATTRBIT_ARCHIVE () {14;}' unless defined(&NFSATTRBIT_ARCHIVE);
    eval 'sub NFSATTRBIT_CANSETTIME () {15;}' unless defined(&NFSATTRBIT_CANSETTIME);
    eval 'sub NFSATTRBIT_CASEINSENSITIVE () {16;}' unless defined(&NFSATTRBIT_CASEINSENSITIVE);
    eval 'sub NFSATTRBIT_CASEPRESERVING () {17;}' unless defined(&NFSATTRBIT_CASEPRESERVING);
    eval 'sub NFSATTRBIT_CHOWNRESTRICTED () {18;}' unless defined(&NFSATTRBIT_CHOWNRESTRICTED);
    eval 'sub NFSATTRBIT_FILEHANDLE () {19;}' unless defined(&NFSATTRBIT_FILEHANDLE);
    eval 'sub NFSATTRBIT_FILEID () {20;}' unless defined(&NFSATTRBIT_FILEID);
    eval 'sub NFSATTRBIT_FILESAVAIL () {21;}' unless defined(&NFSATTRBIT_FILESAVAIL);
    eval 'sub NFSATTRBIT_FILESFREE () {22;}' unless defined(&NFSATTRBIT_FILESFREE);
    eval 'sub NFSATTRBIT_FILESTOTAL () {23;}' unless defined(&NFSATTRBIT_FILESTOTAL);
    eval 'sub NFSATTRBIT_FSLOCATIONS () {24;}' unless defined(&NFSATTRBIT_FSLOCATIONS);
    eval 'sub NFSATTRBIT_HIDDEN () {25;}' unless defined(&NFSATTRBIT_HIDDEN);
    eval 'sub NFSATTRBIT_HOMOGENEOUS () {26;}' unless defined(&NFSATTRBIT_HOMOGENEOUS);
    eval 'sub NFSATTRBIT_MAXFILESIZE () {27;}' unless defined(&NFSATTRBIT_MAXFILESIZE);
    eval 'sub NFSATTRBIT_MAXLINK () {28;}' unless defined(&NFSATTRBIT_MAXLINK);
    eval 'sub NFSATTRBIT_MAXNAME () {29;}' unless defined(&NFSATTRBIT_MAXNAME);
    eval 'sub NFSATTRBIT_MAXREAD () {30;}' unless defined(&NFSATTRBIT_MAXREAD);
    eval 'sub NFSATTRBIT_MAXWRITE () {31;}' unless defined(&NFSATTRBIT_MAXWRITE);
    eval 'sub NFSATTRBIT_MIMETYPE () {32;}' unless defined(&NFSATTRBIT_MIMETYPE);
    eval 'sub NFSATTRBIT_MODE () {33;}' unless defined(&NFSATTRBIT_MODE);
    eval 'sub NFSATTRBIT_NOTRUNC () {34;}' unless defined(&NFSATTRBIT_NOTRUNC);
    eval 'sub NFSATTRBIT_NUMLINKS () {35;}' unless defined(&NFSATTRBIT_NUMLINKS);
    eval 'sub NFSATTRBIT_OWNER () {36;}' unless defined(&NFSATTRBIT_OWNER);
    eval 'sub NFSATTRBIT_OWNERGROUP () {37;}' unless defined(&NFSATTRBIT_OWNERGROUP);
    eval 'sub NFSATTRBIT_QUOTAHARD () {38;}' unless defined(&NFSATTRBIT_QUOTAHARD);
    eval 'sub NFSATTRBIT_QUOTASOFT () {39;}' unless defined(&NFSATTRBIT_QUOTASOFT);
    eval 'sub NFSATTRBIT_QUOTAUSED () {40;}' unless defined(&NFSATTRBIT_QUOTAUSED);
    eval 'sub NFSATTRBIT_RAWDEV () {41;}' unless defined(&NFSATTRBIT_RAWDEV);
    eval 'sub NFSATTRBIT_SPACEAVAIL () {42;}' unless defined(&NFSATTRBIT_SPACEAVAIL);
    eval 'sub NFSATTRBIT_SPACEFREE () {43;}' unless defined(&NFSATTRBIT_SPACEFREE);
    eval 'sub NFSATTRBIT_SPACETOTAL () {44;}' unless defined(&NFSATTRBIT_SPACETOTAL);
    eval 'sub NFSATTRBIT_SPACEUSED () {45;}' unless defined(&NFSATTRBIT_SPACEUSED);
    eval 'sub NFSATTRBIT_SYSTEM () {46;}' unless defined(&NFSATTRBIT_SYSTEM);
    eval 'sub NFSATTRBIT_TIMEACCESS () {47;}' unless defined(&NFSATTRBIT_TIMEACCESS);
    eval 'sub NFSATTRBIT_TIMEACCESSSET () {48;}' unless defined(&NFSATTRBIT_TIMEACCESSSET);
    eval 'sub NFSATTRBIT_TIMEBACKUP () {49;}' unless defined(&NFSATTRBIT_TIMEBACKUP);
    eval 'sub NFSATTRBIT_TIMECREATE () {50;}' unless defined(&NFSATTRBIT_TIMECREATE);
    eval 'sub NFSATTRBIT_TIMEDELTA () {51;}' unless defined(&NFSATTRBIT_TIMEDELTA);
    eval 'sub NFSATTRBIT_TIMEMETADATA () {52;}' unless defined(&NFSATTRBIT_TIMEMETADATA);
    eval 'sub NFSATTRBIT_TIMEMODIFY () {53;}' unless defined(&NFSATTRBIT_TIMEMODIFY);
    eval 'sub NFSATTRBIT_TIMEMODIFYSET () {54;}' unless defined(&NFSATTRBIT_TIMEMODIFYSET);
    eval 'sub NFSATTRBIT_MOUNTEDONFILEID () {55;}' unless defined(&NFSATTRBIT_MOUNTEDONFILEID);
    eval 'sub NFSATTRBIT_DIRNOTIFDELAY () {56;}' unless defined(&NFSATTRBIT_DIRNOTIFDELAY);
    eval 'sub NFSATTRBIT_DIRENTNOTIFDELAY () {57;}' unless defined(&NFSATTRBIT_DIRENTNOTIFDELAY);
    eval 'sub NFSATTRBIT_DACL () {58;}' unless defined(&NFSATTRBIT_DACL);
    eval 'sub NFSATTRBIT_SACL () {59;}' unless defined(&NFSATTRBIT_SACL);
    eval 'sub NFSATTRBIT_CHANGEPOLICY () {60;}' unless defined(&NFSATTRBIT_CHANGEPOLICY);
    eval 'sub NFSATTRBIT_FSSTATUS () {61;}' unless defined(&NFSATTRBIT_FSSTATUS);
    eval 'sub NFSATTRBIT_FSLAYOUTTYPE () {62;}' unless defined(&NFSATTRBIT_FSLAYOUTTYPE);
    eval 'sub NFSATTRBIT_LAYOUTHINT () {63;}' unless defined(&NFSATTRBIT_LAYOUTHINT);
    eval 'sub NFSATTRBIT_LAYOUTTYPE () {64;}' unless defined(&NFSATTRBIT_LAYOUTTYPE);
    eval 'sub NFSATTRBIT_LAYOUTBLKSIZE () {65;}' unless defined(&NFSATTRBIT_LAYOUTBLKSIZE);
    eval 'sub NFSATTRBIT_LAYOUTALIGNMENT () {66;}' unless defined(&NFSATTRBIT_LAYOUTALIGNMENT);
    eval 'sub NFSATTRBIT_FSLOCATIONSINFO () {67;}' unless defined(&NFSATTRBIT_FSLOCATIONSINFO);
    eval 'sub NFSATTRBIT_MDSTHRESHOLD () {68;}' unless defined(&NFSATTRBIT_MDSTHRESHOLD);
    eval 'sub NFSATTRBIT_RETENTIONGET () {69;}' unless defined(&NFSATTRBIT_RETENTIONGET);
    eval 'sub NFSATTRBIT_RETENTIONSET () {70;}' unless defined(&NFSATTRBIT_RETENTIONSET);
    eval 'sub NFSATTRBIT_RETENTEVTGET () {71;}' unless defined(&NFSATTRBIT_RETENTEVTGET);
    eval 'sub NFSATTRBIT_RETENTEVTSET () {72;}' unless defined(&NFSATTRBIT_RETENTEVTSET);
    eval 'sub NFSATTRBIT_RETENTIONHOLD () {73;}' unless defined(&NFSATTRBIT_RETENTIONHOLD);
    eval 'sub NFSATTRBIT_MODESETMASKED () {74;}' unless defined(&NFSATTRBIT_MODESETMASKED);
    eval 'sub NFSATTRBIT_SUPPATTREXCLCREAT () {75;}' unless defined(&NFSATTRBIT_SUPPATTREXCLCREAT);
    eval 'sub NFSATTRBIT_FSCHARSETCAP () {76;}' unless defined(&NFSATTRBIT_FSCHARSETCAP);
    eval 'sub NFSATTRBM_SUPPORTEDATTRS () {0x1;}' unless defined(&NFSATTRBM_SUPPORTEDATTRS);
    eval 'sub NFSATTRBM_TYPE () {0x2;}' unless defined(&NFSATTRBM_TYPE);
    eval 'sub NFSATTRBM_FHEXPIRETYPE () {0x4;}' unless defined(&NFSATTRBM_FHEXPIRETYPE);
    eval 'sub NFSATTRBM_CHANGE () {0x8;}' unless defined(&NFSATTRBM_CHANGE);
    eval 'sub NFSATTRBM_SIZE () {0x10;}' unless defined(&NFSATTRBM_SIZE);
    eval 'sub NFSATTRBM_LINKSUPPORT () {0x20;}' unless defined(&NFSATTRBM_LINKSUPPORT);
    eval 'sub NFSATTRBM_SYMLINKSUPPORT () {0x40;}' unless defined(&NFSATTRBM_SYMLINKSUPPORT);
    eval 'sub NFSATTRBM_NAMEDATTR () {0x80;}' unless defined(&NFSATTRBM_NAMEDATTR);
    eval 'sub NFSATTRBM_FSID () {0x100;}' unless defined(&NFSATTRBM_FSID);
    eval 'sub NFSATTRBM_UNIQUEHANDLES () {0x200;}' unless defined(&NFSATTRBM_UNIQUEHANDLES);
    eval 'sub NFSATTRBM_LEASETIME () {0x400;}' unless defined(&NFSATTRBM_LEASETIME);
    eval 'sub NFSATTRBM_RDATTRERROR () {0x800;}' unless defined(&NFSATTRBM_RDATTRERROR);
    eval 'sub NFSATTRBM_ACL () {0x1000;}' unless defined(&NFSATTRBM_ACL);
    eval 'sub NFSATTRBM_ACLSUPPORT () {0x2000;}' unless defined(&NFSATTRBM_ACLSUPPORT);
    eval 'sub NFSATTRBM_ARCHIVE () {0x4000;}' unless defined(&NFSATTRBM_ARCHIVE);
    eval 'sub NFSATTRBM_CANSETTIME () {0x8000;}' unless defined(&NFSATTRBM_CANSETTIME);
    eval 'sub NFSATTRBM_CASEINSENSITIVE () {0x10000;}' unless defined(&NFSATTRBM_CASEINSENSITIVE);
    eval 'sub NFSATTRBM_CASEPRESERVING () {0x20000;}' unless defined(&NFSATTRBM_CASEPRESERVING);
    eval 'sub NFSATTRBM_CHOWNRESTRICTED () {0x40000;}' unless defined(&NFSATTRBM_CHOWNRESTRICTED);
    eval 'sub NFSATTRBM_FILEHANDLE () {0x80000;}' unless defined(&NFSATTRBM_FILEHANDLE);
    eval 'sub NFSATTRBM_FILEID () {0x100000;}' unless defined(&NFSATTRBM_FILEID);
    eval 'sub NFSATTRBM_FILESAVAIL () {0x200000;}' unless defined(&NFSATTRBM_FILESAVAIL);
    eval 'sub NFSATTRBM_FILESFREE () {0x400000;}' unless defined(&NFSATTRBM_FILESFREE);
    eval 'sub NFSATTRBM_FILESTOTAL () {0x800000;}' unless defined(&NFSATTRBM_FILESTOTAL);
    eval 'sub NFSATTRBM_FSLOCATIONS () {0x1000000;}' unless defined(&NFSATTRBM_FSLOCATIONS);
    eval 'sub NFSATTRBM_HIDDEN () {0x2000000;}' unless defined(&NFSATTRBM_HIDDEN);
    eval 'sub NFSATTRBM_HOMOGENEOUS () {0x4000000;}' unless defined(&NFSATTRBM_HOMOGENEOUS);
    eval 'sub NFSATTRBM_MAXFILESIZE () {0x8000000;}' unless defined(&NFSATTRBM_MAXFILESIZE);
    eval 'sub NFSATTRBM_MAXLINK () {0x10000000;}' unless defined(&NFSATTRBM_MAXLINK);
    eval 'sub NFSATTRBM_MAXNAME () {0x20000000;}' unless defined(&NFSATTRBM_MAXNAME);
    eval 'sub NFSATTRBM_MAXREAD () {0x40000000;}' unless defined(&NFSATTRBM_MAXREAD);
    eval 'sub NFSATTRBM_MAXWRITE () {0x80000000;}' unless defined(&NFSATTRBM_MAXWRITE);
    eval 'sub NFSATTRBM_MIMETYPE () {0x1;}' unless defined(&NFSATTRBM_MIMETYPE);
    eval 'sub NFSATTRBM_MODE () {0x2;}' unless defined(&NFSATTRBM_MODE);
    eval 'sub NFSATTRBM_NOTRUNC () {0x4;}' unless defined(&NFSATTRBM_NOTRUNC);
    eval 'sub NFSATTRBM_NUMLINKS () {0x8;}' unless defined(&NFSATTRBM_NUMLINKS);
    eval 'sub NFSATTRBM_OWNER () {0x10;}' unless defined(&NFSATTRBM_OWNER);
    eval 'sub NFSATTRBM_OWNERGROUP () {0x20;}' unless defined(&NFSATTRBM_OWNERGROUP);
    eval 'sub NFSATTRBM_QUOTAHARD () {0x40;}' unless defined(&NFSATTRBM_QUOTAHARD);
    eval 'sub NFSATTRBM_QUOTASOFT () {0x80;}' unless defined(&NFSATTRBM_QUOTASOFT);
    eval 'sub NFSATTRBM_QUOTAUSED () {0x100;}' unless defined(&NFSATTRBM_QUOTAUSED);
    eval 'sub NFSATTRBM_RAWDEV () {0x200;}' unless defined(&NFSATTRBM_RAWDEV);
    eval 'sub NFSATTRBM_SPACEAVAIL () {0x400;}' unless defined(&NFSATTRBM_SPACEAVAIL);
    eval 'sub NFSATTRBM_SPACEFREE () {0x800;}' unless defined(&NFSATTRBM_SPACEFREE);
    eval 'sub NFSATTRBM_SPACETOTAL () {0x1000;}' unless defined(&NFSATTRBM_SPACETOTAL);
    eval 'sub NFSATTRBM_SPACEUSED () {0x2000;}' unless defined(&NFSATTRBM_SPACEUSED);
    eval 'sub NFSATTRBM_SYSTEM () {0x4000;}' unless defined(&NFSATTRBM_SYSTEM);
    eval 'sub NFSATTRBM_TIMEACCESS () {0x8000;}' unless defined(&NFSATTRBM_TIMEACCESS);
    eval 'sub NFSATTRBM_TIMEACCESSSET () {0x10000;}' unless defined(&NFSATTRBM_TIMEACCESSSET);
    eval 'sub NFSATTRBM_TIMEBACKUP () {0x20000;}' unless defined(&NFSATTRBM_TIMEBACKUP);
    eval 'sub NFSATTRBM_TIMECREATE () {0x40000;}' unless defined(&NFSATTRBM_TIMECREATE);
    eval 'sub NFSATTRBM_TIMEDELTA () {0x80000;}' unless defined(&NFSATTRBM_TIMEDELTA);
    eval 'sub NFSATTRBM_TIMEMETADATA () {0x100000;}' unless defined(&NFSATTRBM_TIMEMETADATA);
    eval 'sub NFSATTRBM_TIMEMODIFY () {0x200000;}' unless defined(&NFSATTRBM_TIMEMODIFY);
    eval 'sub NFSATTRBM_TIMEMODIFYSET () {0x400000;}' unless defined(&NFSATTRBM_TIMEMODIFYSET);
    eval 'sub NFSATTRBM_MOUNTEDONFILEID () {0x800000;}' unless defined(&NFSATTRBM_MOUNTEDONFILEID);
    eval 'sub NFSATTRBM_DIRNOTIFDELAY () {0x1000000;}' unless defined(&NFSATTRBM_DIRNOTIFDELAY);
    eval 'sub NFSATTRBM_DIRENTNOTIFDELAY () {0x2000000;}' unless defined(&NFSATTRBM_DIRENTNOTIFDELAY);
    eval 'sub NFSATTRBM_DACL () {0x4000000;}' unless defined(&NFSATTRBM_DACL);
    eval 'sub NFSATTRBM_SACL () {0x8000000;}' unless defined(&NFSATTRBM_SACL);
    eval 'sub NFSATTRBM_CHANGEPOLICY () {0x10000000;}' unless defined(&NFSATTRBM_CHANGEPOLICY);
    eval 'sub NFSATTRBM_FSSTATUS () {0x20000000;}' unless defined(&NFSATTRBM_FSSTATUS);
    eval 'sub NFSATTRBM_FSLAYOUTTYPE () {0x40000000;}' unless defined(&NFSATTRBM_FSLAYOUTTYPE);
    eval 'sub NFSATTRBM_LAYOUTHINT () {0x80000000;}' unless defined(&NFSATTRBM_LAYOUTHINT);
    eval 'sub NFSATTRBM_LAYOUTTYPE () {0x1;}' unless defined(&NFSATTRBM_LAYOUTTYPE);
    eval 'sub NFSATTRBM_LAYOUTBLKSIZE () {0x2;}' unless defined(&NFSATTRBM_LAYOUTBLKSIZE);
    eval 'sub NFSATTRBM_LAYOUTALIGNMENT () {0x4;}' unless defined(&NFSATTRBM_LAYOUTALIGNMENT);
    eval 'sub NFSATTRBM_FSLOCATIONSINFO () {0x8;}' unless defined(&NFSATTRBM_FSLOCATIONSINFO);
    eval 'sub NFSATTRBM_MDSTHRESHOLD () {0x10;}' unless defined(&NFSATTRBM_MDSTHRESHOLD);
    eval 'sub NFSATTRBM_RETENTIONGET () {0x20;}' unless defined(&NFSATTRBM_RETENTIONGET);
    eval 'sub NFSATTRBM_RETENTIONSET () {0x40;}' unless defined(&NFSATTRBM_RETENTIONSET);
    eval 'sub NFSATTRBM_RETENTEVTGET () {0x80;}' unless defined(&NFSATTRBM_RETENTEVTGET);
    eval 'sub NFSATTRBM_RETENTEVTSET () {0x100;}' unless defined(&NFSATTRBM_RETENTEVTSET);
    eval 'sub NFSATTRBM_RETENTIONHOLD () {0x200;}' unless defined(&NFSATTRBM_RETENTIONHOLD);
    eval 'sub NFSATTRBM_MODESETMASKED () {0x400;}' unless defined(&NFSATTRBM_MODESETMASKED);
    eval 'sub NFSATTRBM_SUPPATTREXCLCREAT () {0x800;}' unless defined(&NFSATTRBM_SUPPATTREXCLCREAT);
    eval 'sub NFSATTRBM_FSCHARSETCAP () {0x1000;}' unless defined(&NFSATTRBM_FSCHARSETCAP);
    eval 'sub NFSATTRBIT_MAX () {77;}' unless defined(&NFSATTRBIT_MAX);
    eval 'sub NFSATTRBIT_SUPP0 () {( &NFSATTRBM_SUPPORTEDATTRS |  &NFSATTRBM_TYPE |  &NFSATTRBM_FHEXPIRETYPE |  &NFSATTRBM_CHANGE |  &NFSATTRBM_SIZE |  &NFSATTRBM_LINKSUPPORT |  &NFSATTRBM_SYMLINKSUPPORT |  &NFSATTRBM_NAMEDATTR |  &NFSATTRBM_FSID |  &NFSATTRBM_UNIQUEHANDLES |  &NFSATTRBM_LEASETIME |  &NFSATTRBM_RDATTRERROR |  &NFSATTRBM_ACL |  &NFSATTRBM_ACLSUPPORT |  &NFSATTRBM_CANSETTIME |  &NFSATTRBM_CASEINSENSITIVE |  &NFSATTRBM_CASEPRESERVING |  &NFSATTRBM_CHOWNRESTRICTED |  &NFSATTRBM_FILEHANDLE |  &NFSATTRBM_FILEID |  &NFSATTRBM_FILESAVAIL |  &NFSATTRBM_FILESFREE |  &NFSATTRBM_FILESTOTAL |  &NFSATTRBM_FSLOCATIONS |  &NFSATTRBM_HOMOGENEOUS |  &NFSATTRBM_MAXFILESIZE |  &NFSATTRBM_MAXLINK |  &NFSATTRBM_MAXNAME |  &NFSATTRBM_MAXREAD |  &NFSATTRBM_MAXWRITE);}' unless defined(&NFSATTRBIT_SUPP0);
    eval 'sub NFSATTRBIT_S1 () {( &NFSATTRBM_MODE |  &NFSATTRBM_NOTRUNC |  &NFSATTRBM_NUMLINKS |  &NFSATTRBM_OWNER |  &NFSATTRBM_OWNERGROUP |  &NFSATTRBM_RAWDEV |  &NFSATTRBM_SPACEAVAIL |  &NFSATTRBM_SPACEFREE |  &NFSATTRBM_SPACETOTAL |  &NFSATTRBM_SPACEUSED |  &NFSATTRBM_TIMEACCESS |  &NFSATTRBM_TIMEDELTA |  &NFSATTRBM_TIMEMETADATA |  &NFSATTRBM_TIMEMODIFY |  &NFSATTRBM_MOUNTEDONFILEID |  &NFSATTRBM_QUOTAHARD |  &NFSATTRBM_QUOTASOFT |  &NFSATTRBM_QUOTAUSED);}' unless defined(&NFSATTRBIT_S1);
    if(defined(&QUOTA)) {
	eval 'sub NFSATTRBIT_SUPP1 () {( &NFSATTRBIT_S1 |  &NFSATTRBM_QUOTAHARD |  &NFSATTRBM_QUOTASOFT |  &NFSATTRBM_QUOTAUSED);}' unless defined(&NFSATTRBIT_SUPP1);
    } else {
	eval 'sub NFSATTRBIT_SUPP1 () { &NFSATTRBIT_S1;}' unless defined(&NFSATTRBIT_SUPP1);
    }
    eval 'sub NFSATTRBIT_SUPP2 () { &NFSATTRBM_SUPPATTREXCLCREAT;}' unless defined(&NFSATTRBIT_SUPP2);
    eval 'sub NFSATTRBIT_SUPPSETONLY () {( &NFSATTRBM_TIMEACCESSSET |  &NFSATTRBM_TIMEMODIFYSET);}' unless defined(&NFSATTRBIT_SUPPSETONLY);
    eval 'sub NFSATTRBIT_SETABLE0 () {( &NFSATTRBM_SIZE |  &NFSATTRBM_ACL);}' unless defined(&NFSATTRBIT_SETABLE0);
    eval 'sub NFSATTRBIT_SETABLE1 () {( &NFSATTRBM_MODE |  &NFSATTRBM_OWNER |  &NFSATTRBM_OWNERGROUP |  &NFSATTRBM_TIMEACCESSSET |  &NFSATTRBM_TIMEMODIFYSET);}' unless defined(&NFSATTRBIT_SETABLE1);
    eval 'sub NFSATTRBIT_SETABLE2 () {0;}' unless defined(&NFSATTRBIT_SETABLE2);
    eval 'sub NFSATTRBIT_GETATTR0 () {( &NFSATTRBM_SUPPORTEDATTRS |  &NFSATTRBM_TYPE |  &NFSATTRBM_CHANGE |  &NFSATTRBM_SIZE |  &NFSATTRBM_FSID |  &NFSATTRBM_FILEID |  &NFSATTRBM_MAXREAD);}' unless defined(&NFSATTRBIT_GETATTR0);
    eval 'sub NFSATTRBIT_GETATTR1 () {( &NFSATTRBM_MODE |  &NFSATTRBM_NUMLINKS |  &NFSATTRBM_OWNER |  &NFSATTRBM_OWNERGROUP |  &NFSATTRBM_RAWDEV |  &NFSATTRBM_SPACEUSED |  &NFSATTRBM_TIMEACCESS |  &NFSATTRBM_TIMEMETADATA |  &NFSATTRBM_TIMEMODIFY);}' unless defined(&NFSATTRBIT_GETATTR1);
    eval 'sub NFSATTRBIT_GETATTR2 () {0;}' unless defined(&NFSATTRBIT_GETATTR2);
    eval 'sub NFSATTRBIT_WRITEGETATTR0 () {( &NFSATTRBM_SUPPORTEDATTRS |  &NFSATTRBM_TYPE |  &NFSATTRBM_CHANGE |  &NFSATTRBM_SIZE |  &NFSATTRBM_FSID |  &NFSATTRBM_FILEID |  &NFSATTRBM_MAXREAD);}' unless defined(&NFSATTRBIT_WRITEGETATTR0);
    eval 'sub NFSATTRBIT_WRITEGETATTR1 () {( &NFSATTRBM_MODE |  &NFSATTRBM_NUMLINKS |  &NFSATTRBM_RAWDEV |  &NFSATTRBM_SPACEUSED |  &NFSATTRBM_TIMEACCESS |  &NFSATTRBM_TIMEMETADATA |  &NFSATTRBM_TIMEMODIFY);}' unless defined(&NFSATTRBIT_WRITEGETATTR1);
    eval 'sub NFSATTRBIT_WRITEGETATTR2 () {0;}' unless defined(&NFSATTRBIT_WRITEGETATTR2);
    eval 'sub NFSATTRBIT_WCCATTR0 () {0;}' unless defined(&NFSATTRBIT_WCCATTR0);
    eval 'sub NFSATTRBIT_WCCATTR1 () {( &NFSATTRBM_TIMEMODIFY);}' unless defined(&NFSATTRBIT_WCCATTR1);
    eval 'sub NFSATTRBIT_WCCATTR2 () {0;}' unless defined(&NFSATTRBIT_WCCATTR2);
    eval 'sub NFSATTRBIT_CBGETATTR0 () {( &NFSATTRBM_CHANGE |  &NFSATTRBM_SIZE);}' unless defined(&NFSATTRBIT_CBGETATTR0);
    eval 'sub NFSATTRBIT_CBGETATTR1 () {0x;}' unless defined(&NFSATTRBIT_CBGETATTR1);
    eval 'sub NFSATTRBIT_CBGETATTR2 () {0x;}' unless defined(&NFSATTRBIT_CBGETATTR2);
    eval 'sub NFSATTRBIT_STATFS0 () {( &NFSATTRBM_LINKSUPPORT |  &NFSATTRBM_SYMLINKSUPPORT |  &NFSATTRBM_CANSETTIME |  &NFSATTRBM_FILESAVAIL |  &NFSATTRBM_FILESFREE |  &NFSATTRBM_FILESTOTAL |  &NFSATTRBM_HOMOGENEOUS |  &NFSATTRBM_MAXFILESIZE |  &NFSATTRBM_MAXNAME |  &NFSATTRBM_MAXREAD |  &NFSATTRBM_MAXWRITE);}' unless defined(&NFSATTRBIT_STATFS0);
    eval 'sub NFSATTRBIT_STATFS1 () {( &NFSATTRBM_QUOTAHARD |  &NFSATTRBM_QUOTASOFT |  &NFSATTRBM_QUOTAUSED |  &NFSATTRBM_SPACEAVAIL |  &NFSATTRBM_SPACEFREE |  &NFSATTRBM_SPACETOTAL |  &NFSATTRBM_SPACEUSED |  &NFSATTRBM_TIMEDELTA);}' unless defined(&NFSATTRBIT_STATFS1);
    eval 'sub NFSATTRBIT_STATFS2 () {0;}' unless defined(&NFSATTRBIT_STATFS2);
    eval 'sub NFSGETATTRBIT_STATFS0 () {( &NFSATTRBIT_GETATTR0 |  &NFSATTRBM_LINKSUPPORT |  &NFSATTRBM_SYMLINKSUPPORT |  &NFSATTRBM_CANSETTIME |  &NFSATTRBM_FILESFREE |  &NFSATTRBM_FILESTOTAL |  &NFSATTRBM_HOMOGENEOUS |  &NFSATTRBM_MAXFILESIZE |  &NFSATTRBM_MAXNAME |  &NFSATTRBM_MAXREAD |  &NFSATTRBM_MAXWRITE);}' unless defined(&NFSGETATTRBIT_STATFS0);
    eval 'sub NFSGETATTRBIT_STATFS1 () {( &NFSATTRBIT_GETATTR1 |  &NFSATTRBM_SPACEAVAIL |  &NFSATTRBM_SPACEFREE |  &NFSATTRBM_SPACETOTAL |  &NFSATTRBM_TIMEDELTA);}' unless defined(&NFSGETATTRBIT_STATFS1);
    eval 'sub NFSGETATTRBIT_STATFS2 () {0;}' unless defined(&NFSGETATTRBIT_STATFS2);
    eval 'sub NFSGETATTRBIT_PATHCONF0 () {( &NFSATTRBIT_GETATTR0 |  &NFSATTRBM_CASEINSENSITIVE |  &NFSATTRBM_CASEPRESERVING |  &NFSATTRBM_CHOWNRESTRICTED |  &NFSATTRBM_MAXLINK |  &NFSATTRBM_MAXNAME);}' unless defined(&NFSGETATTRBIT_PATHCONF0);
    eval 'sub NFSGETATTRBIT_PATHCONF1 () {( &NFSATTRBIT_GETATTR1 |  &NFSATTRBM_NOTRUNC);}' unless defined(&NFSGETATTRBIT_PATHCONF1);
    eval 'sub NFSGETATTRBIT_PATHCONF2 () {0;}' unless defined(&NFSGETATTRBIT_PATHCONF2);
    eval 'sub NFSATTRBIT_READDIRPLUS0 () {( &NFSATTRBIT_GETATTR0 |  &NFSATTRBM_FILEHANDLE |  &NFSATTRBM_RDATTRERROR);}' unless defined(&NFSATTRBIT_READDIRPLUS0);
    eval 'sub NFSATTRBIT_READDIRPLUS1 () { &NFSATTRBIT_GETATTR1;}' unless defined(&NFSATTRBIT_READDIRPLUS1);
    eval 'sub NFSATTRBIT_READDIRPLUS2 () {0;}' unless defined(&NFSATTRBIT_READDIRPLUS2);
    eval 'sub NFSATTRBIT_REFERRAL0 () {( &NFSATTRBM_TYPE |  &NFSATTRBM_FSID |  &NFSATTRBM_RDATTRERROR |  &NFSATTRBM_FSLOCATIONS);}' unless defined(&NFSATTRBIT_REFERRAL0);
    eval 'sub NFSATTRBIT_REFERRAL1 () { &NFSATTRBM_MOUNTEDONFILEID;}' unless defined(&NFSATTRBIT_REFERRAL1);
    eval 'sub NFSATTRBIT_REFERRAL2 () {0;}' unless defined(&NFSATTRBIT_REFERRAL2);
    eval 'sub sf_tsize () { ($sf_un->{sf_nfsv2}->{nfsv2sf_tsize});}' unless defined(&sf_tsize);
    eval 'sub sf_bsize () { ($sf_un->{sf_nfsv2}->{nfsv2sf_bsize});}' unless defined(&sf_bsize);
    eval 'sub sf_blocks () { ($sf_un->{sf_nfsv2}->{nfsv2sf_blocks});}' unless defined(&sf_blocks);
    eval 'sub sf_bfree () { ($sf_un->{sf_nfsv2}->{nfsv2sf_bfree});}' unless defined(&sf_bfree);
    eval 'sub sf_bavail () { ($sf_un->{sf_nfsv2}->{nfsv2sf_bavail});}' unless defined(&sf_bavail);
    eval 'sub sf_tbytes () { ($sf_un->{sf_nfsv3}->{nfsv3sf_tbytes});}' unless defined(&sf_tbytes);
    eval 'sub sf_fbytes () { ($sf_un->{sf_nfsv3}->{nfsv3sf_fbytes});}' unless defined(&sf_fbytes);
    eval 'sub sf_abytes () { ($sf_un->{sf_nfsv3}->{nfsv3sf_abytes});}' unless defined(&sf_abytes);
    eval 'sub sf_tfiles () { ($sf_un->{sf_nfsv3}->{nfsv3sf_tfiles});}' unless defined(&sf_tfiles);
    eval 'sub sf_ffiles () { ($sf_un->{sf_nfsv3}->{nfsv3sf_ffiles});}' unless defined(&sf_ffiles);
    eval 'sub sf_afiles () { ($sf_un->{sf_nfsv3}->{nfsv3sf_afiles});}' unless defined(&sf_afiles);
    eval 'sub sf_invarsec () { ($sf_un->{sf_nfsv3}->{nfsv3sf_invarsec});}' unless defined(&sf_invarsec);
    eval 'sub NFSV3_FSFLINK () {0x1;}' unless defined(&NFSV3_FSFLINK);
    eval 'sub NFSV3_FSFSYMLINK () {0x2;}' unless defined(&NFSV3_FSFSYMLINK);
    eval 'sub NFSV3_FSFHOMOGENEOUS () {0x4;}' unless defined(&NFSV3_FSFHOMOGENEOUS);
    eval 'sub NFSV3_FSFCANSETTIME () {0x8;}' unless defined(&NFSV3_FSFCANSETTIME);
    eval 'sub fs_maxname () { &fs_rtmult;}' unless defined(&fs_maxname);
}
1;
