require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFS_RPCV2_H_)) {
    eval 'sub _NFS_RPCV2_H_ () {1;}' unless defined(&_NFS_RPCV2_H_);
    eval 'sub RPC_VER2 () {2;}' unless defined(&RPC_VER2);
    eval 'sub RPCAUTH_NULL () {0;}' unless defined(&RPCAUTH_NULL);
    eval 'sub RPCAUTH_UNIX () {1;}' unless defined(&RPCAUTH_UNIX);
    eval 'sub RPCAUTH_SHORT () {2;}' unless defined(&RPCAUTH_SHORT);
    eval 'sub RPCAUTH_KERB4 () {4;}' unless defined(&RPCAUTH_KERB4);
    eval 'sub RPCAUTH_GSS () {6;}' unless defined(&RPCAUTH_GSS);
    eval 'sub RPCAUTH_GSSKRB5 () {390003;}' unless defined(&RPCAUTH_GSSKRB5);
    eval 'sub RPCAUTH_GSSKRB5INTEGRITY () {390004;}' unless defined(&RPCAUTH_GSSKRB5INTEGRITY);
    eval 'sub RPCAUTH_GSSKRB5PRIVACY () {390005;}' unless defined(&RPCAUTH_GSSKRB5PRIVACY);
    eval 'sub RPCAUTH_MAXSIZ () {400;}' unless defined(&RPCAUTH_MAXSIZ);
    eval 'sub RPCVERF_MAXSIZ () {12;}' unless defined(&RPCVERF_MAXSIZ);
    eval 'sub RPCAUTHUNIX_MINSIZ () {(5*  &NFSX_UNSIGNED);}' unless defined(&RPCAUTHUNIX_MINSIZ);
    eval 'sub RPCAUTH_UNIXGIDS () {16;}' unless defined(&RPCAUTH_UNIXGIDS);
    eval 'sub RPCAUTHGSS_VERS1 () {1;}' unless defined(&RPCAUTHGSS_VERS1);
    eval 'sub RPCAUTHGSS_DATA () {0;}' unless defined(&RPCAUTHGSS_DATA);
    eval 'sub RPCAUTHGSS_INIT () {1;}' unless defined(&RPCAUTHGSS_INIT);
    eval 'sub RPCAUTHGSS_CONTINIT () {2;}' unless defined(&RPCAUTHGSS_CONTINIT);
    eval 'sub RPCAUTHGSS_DESTROY () {3;}' unless defined(&RPCAUTHGSS_DESTROY);
    eval 'sub RPCAUTHGSS_SVCNONE () {1;}' unless defined(&RPCAUTHGSS_SVCNONE);
    eval 'sub RPCAUTHGSS_SVCINTEGRITY () {2;}' unless defined(&RPCAUTHGSS_SVCINTEGRITY);
    eval 'sub RPCAUTHGSS_SVCPRIVACY () {3;}' unless defined(&RPCAUTHGSS_SVCPRIVACY);
    eval 'sub RPCAUTHGSS_MAXSEQ () {0x80000000;}' unless defined(&RPCAUTHGSS_MAXSEQ);
    eval 'sub RPCAUTHGSS_WINDOW () {64;}' unless defined(&RPCAUTHGSS_WINDOW);
    eval 'sub RPCAUTHGSS_SEQWINDOW () {( &RPCAUTHGSS_WINDOW + 1);}' unless defined(&RPCAUTHGSS_SEQWINDOW);
    eval 'sub RPCAUTHGSS_MIC () {1;}' unless defined(&RPCAUTHGSS_MIC);
    eval 'sub RPCAUTHGSS_WRAP () {2;}' unless defined(&RPCAUTHGSS_WRAP);
    eval 'sub GSS_KERBV_QOP () {0;}' unless defined(&GSS_KERBV_QOP);
    eval 'sub RPCGSS_KEYSIZ () {8;}' unless defined(&RPCGSS_KEYSIZ);
    eval 'sub GSSX_AUTHHEAD () {(5*  &NFSX_UNSIGNED);}' unless defined(&GSSX_AUTHHEAD);
    eval 'sub GSSX_MYHANDLE () {($sizeof{\'long\'} + $sizeof{ &u_int64_t});}' unless defined(&GSSX_MYHANDLE);
    eval 'sub GSSX_RPCHEADER () {(13*  &NFSX_UNSIGNED +  &GSSX_MYHANDLE);}' unless defined(&GSSX_RPCHEADER);
    eval 'sub GSSX_MINWRAP () {(2*  &NFSX_UNSIGNED);}' unless defined(&GSSX_MINWRAP);
    eval 'sub GSSX_KERBVTOKEN () {24;}' unless defined(&GSSX_KERBVTOKEN);
    eval 'sub GSSX_LOCALHANDLE () {($sizeof{ &void });}' unless defined(&GSSX_LOCALHANDLE);
    eval 'sub RPCPROG_GSSD () {0x20101010;}' unless defined(&RPCPROG_GSSD);
    eval 'sub RPCGSSD_VERS () {1;}' unless defined(&RPCGSSD_VERS);
    eval 'sub RPCGSSD_INIT () {1;}' unless defined(&RPCGSSD_INIT);
    eval 'sub RPCGSSD_CONTINIT () {2;}' unless defined(&RPCGSSD_CONTINIT);
    eval 'sub RPCGSSD_CONTINITDESTROY () {3;}' unless defined(&RPCGSSD_CONTINITDESTROY);
    eval 'sub RPCGSSD_CLINIT () {4;}' unless defined(&RPCGSSD_CLINIT);
    eval 'sub RPCGSSD_CLINITUID () {5;}' unless defined(&RPCGSSD_CLINITUID);
    eval 'sub RPCGSSD_CLCONT () {6;}' unless defined(&RPCGSSD_CLCONT);
    eval 'sub RPCGSSD_CLCONTUID () {7;}' unless defined(&RPCGSSD_CLCONTUID);
    eval 'sub RPCGSSD_CLINITNAME () {8;}' unless defined(&RPCGSSD_CLINITNAME);
    eval 'sub RPCGSSD_CLCONTNAME () {9;}' unless defined(&RPCGSSD_CLCONTNAME);
    eval 'sub RPCPROG_NFSUSERD () {0x21010101;}' unless defined(&RPCPROG_NFSUSERD);
    eval 'sub RPCNFSUSERD_VERS () {1;}' unless defined(&RPCNFSUSERD_VERS);
    eval 'sub RPCNFSUSERD_GETUID () {1;}' unless defined(&RPCNFSUSERD_GETUID);
    eval 'sub RPCNFSUSERD_GETGID () {2;}' unless defined(&RPCNFSUSERD_GETGID);
    eval 'sub RPCNFSUSERD_GETUSER () {3;}' unless defined(&RPCNFSUSERD_GETUSER);
    eval 'sub RPCNFSUSERD_GETGROUP () {4;}' unless defined(&RPCNFSUSERD_GETGROUP);
    if(!defined(&_GSSAPI_H_)  && !defined(&GSSAPI_H_)  && !defined(&_GSSAPI_GSSAPI_H_)  && !defined(&_RPCSEC_GSS_H)) {
	eval 'sub GSS_S_COMPLETE () {0x;}' unless defined(&GSS_S_COMPLETE);
	eval 'sub GSS_S_CONTINUE_NEEDED () {0x1;}' unless defined(&GSS_S_CONTINUE_NEEDED);
	eval 'sub GSS_S_DUPLICATE_TOKEN () {0x2;}' unless defined(&GSS_S_DUPLICATE_TOKEN);
	eval 'sub GSS_S_OLD_TOKEN () {0x4;}' unless defined(&GSS_S_OLD_TOKEN);
	eval 'sub GSS_S_UNSEQ_TOKEN () {0x8;}' unless defined(&GSS_S_UNSEQ_TOKEN);
	eval 'sub GSS_S_GAP_TOKEN () {0x10;}' unless defined(&GSS_S_GAP_TOKEN);
	eval 'sub GSS_S_BAD_MECH () {0x10000;}' unless defined(&GSS_S_BAD_MECH);
	eval 'sub GSS_S_BAD_NAME () {0x20000;}' unless defined(&GSS_S_BAD_NAME);
	eval 'sub GSS_S_BAD_NAMETYPE () {0x30000;}' unless defined(&GSS_S_BAD_NAMETYPE);
	eval 'sub GSS_S_BAD_BINDINGS () {0x40000;}' unless defined(&GSS_S_BAD_BINDINGS);
	eval 'sub GSS_S_BAD_STATUS () {0x50000;}' unless defined(&GSS_S_BAD_STATUS);
	eval 'sub GSS_S_BAD_MIC () {0x60000;}' unless defined(&GSS_S_BAD_MIC);
	eval 'sub GSS_S_BAD_SIG () {0x60000;}' unless defined(&GSS_S_BAD_SIG);
	eval 'sub GSS_S_NO_CRED () {0x70000;}' unless defined(&GSS_S_NO_CRED);
	eval 'sub GSS_S_NO_CONTEXT () {0x80000;}' unless defined(&GSS_S_NO_CONTEXT);
	eval 'sub GSS_S_DEFECTIVE_TOKEN () {0x90000;}' unless defined(&GSS_S_DEFECTIVE_TOKEN);
	eval 'sub GSS_S_DEFECTIVE_CREDENTIAL () {0xa0000;}' unless defined(&GSS_S_DEFECTIVE_CREDENTIAL);
	eval 'sub GSS_S_CREDENTIALS_EXPIRED () {0xb0000;}' unless defined(&GSS_S_CREDENTIALS_EXPIRED);
	eval 'sub GSS_S_CONTEXT_EXPIRED () {0xc0000;}' unless defined(&GSS_S_CONTEXT_EXPIRED);
	eval 'sub GSS_S_FAILURE () {0xd0000;}' unless defined(&GSS_S_FAILURE);
	eval 'sub GSS_S_BAD_QOP () {0xe0000;}' unless defined(&GSS_S_BAD_QOP);
	eval 'sub GSS_S_UNAUTHORIZED () {0xf0000;}' unless defined(&GSS_S_UNAUTHORIZED);
	eval 'sub GSS_S_UNAVAILABLE () {0x100000;}' unless defined(&GSS_S_UNAVAILABLE);
	eval 'sub GSS_S_DUPLICATE_ELEMENT () {0x110000;}' unless defined(&GSS_S_DUPLICATE_ELEMENT);
	eval 'sub GSS_S_NAME_NOT_MN () {0x120000;}' unless defined(&GSS_S_NAME_NOT_MN);
	eval 'sub GSS_S_CALL_INACCESSIBLE_READ () {0x1000000;}' unless defined(&GSS_S_CALL_INACCESSIBLE_READ);
	eval 'sub GSS_S_CALL_INACCESSIBLE_WRITE () {0x2000000;}' unless defined(&GSS_S_CALL_INACCESSIBLE_WRITE);
	eval 'sub GSS_S_CALL_BAD_STRUCTURE () {0x3000000;}' unless defined(&GSS_S_CALL_BAD_STRUCTURE);
    }
    eval 'sub RPC_CALL () {0;}' unless defined(&RPC_CALL);
    eval 'sub RPC_REPLY () {1;}' unless defined(&RPC_REPLY);
    eval 'sub RPC_MSGACCEPTED () {0;}' unless defined(&RPC_MSGACCEPTED);
    eval 'sub RPC_MSGDENIED () {1;}' unless defined(&RPC_MSGDENIED);
    eval 'sub RPC_PROGUNAVAIL () {1;}' unless defined(&RPC_PROGUNAVAIL);
    eval 'sub RPC_PROGMISMATCH () {2;}' unless defined(&RPC_PROGMISMATCH);
    eval 'sub RPC_PROCUNAVAIL () {3;}' unless defined(&RPC_PROCUNAVAIL);
    eval 'sub RPC_GARBAGE () {4;}' unless defined(&RPC_GARBAGE);
    eval 'sub RPC_MISMATCH () {0;}' unless defined(&RPC_MISMATCH);
    eval 'sub RPC_AUTHERR () {1;}' unless defined(&RPC_AUTHERR);
    eval 'sub AUTH_BADCRED () {1;}' unless defined(&AUTH_BADCRED);
    eval 'sub AUTH_REJECTCRED () {2;}' unless defined(&AUTH_REJECTCRED);
    eval 'sub AUTH_BADVERF () {3;}' unless defined(&AUTH_BADVERF);
    eval 'sub AUTH_REJECTVERF () {4;}' unless defined(&AUTH_REJECTVERF);
    eval 'sub AUTH_TOOWEAK () {5;}' unless defined(&AUTH_TOOWEAK);
    eval 'sub AUTH_PROBCRED () {13;}' unless defined(&AUTH_PROBCRED);
    eval 'sub AUTH_CTXCRED () {14;}' unless defined(&AUTH_CTXCRED);
    eval 'sub RPC_SIZ () {24;}' unless defined(&RPC_SIZ);
    eval 'sub RPC_REPLYSIZ () {28;}' unless defined(&RPC_REPLYSIZ);
    eval 'sub RPCPROG_MNT () {100005;}' unless defined(&RPCPROG_MNT);
    eval 'sub RPCMNT_VER1 () {1;}' unless defined(&RPCMNT_VER1);
    eval 'sub RPCMNT_VER3 () {3;}' unless defined(&RPCMNT_VER3);
    eval 'sub RPCMNT_MOUNT () {1;}' unless defined(&RPCMNT_MOUNT);
    eval 'sub RPCMNT_DUMP () {2;}' unless defined(&RPCMNT_DUMP);
    eval 'sub RPCMNT_UMOUNT () {3;}' unless defined(&RPCMNT_UMOUNT);
    eval 'sub RPCMNT_UMNTALL () {4;}' unless defined(&RPCMNT_UMNTALL);
    eval 'sub RPCMNT_EXPORT () {5;}' unless defined(&RPCMNT_EXPORT);
    eval 'sub RPCMNT_NAMELEN () {255;}' unless defined(&RPCMNT_NAMELEN);
    eval 'sub RPCMNT_PATHLEN () {1024;}' unless defined(&RPCMNT_PATHLEN);
    eval 'sub RPCPROG_NFS () {100003;}' unless defined(&RPCPROG_NFS);
}
1;
