require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&FS_NULL_H)) {
    eval 'sub FS_NULL_H () {1;}' unless defined(&FS_NULL_H);
    eval 'sub NULLM_CACHE () {0x1;}' unless defined(&NULLM_CACHE);
    if(defined(&_KERNEL)) {
	eval 'sub NULLV_NOUNLOCK () {0x1;}' unless defined(&NULLV_NOUNLOCK);
	eval 'sub NULLV_DROP () {0x2;}' unless defined(&NULLV_DROP);
	eval 'sub MOUNTTONULLMOUNT {
	    my($mp) = @_;
    	    eval q(((($mp)-> &mnt_data)));
	}' unless defined(&MOUNTTONULLMOUNT);
	eval 'sub VTONULL {
	    my($vp) = @_;
    	    eval q((($vp)-> &v_data));
	}' unless defined(&VTONULL);
	eval 'sub NULLTOV {
	    my($xp) = @_;
    	    eval q((($xp)-> &null_vnode));
	}' unless defined(&NULLTOV);
	if(defined(&DIAGNOSTIC)) {
	    eval 'sub NULLVPTOLOWERVP {
	        my($vp) = @_;
    		eval q( &null_checkvp(($vp),  &__FILE__,  &__LINE__));
	    }' unless defined(&NULLVPTOLOWERVP);
	} else {
	    eval 'sub NULLVPTOLOWERVP {
	        my($vp) = @_;
    		eval q(( &VTONULL($vp)-> &null_lowervp));
	    }' unless defined(&NULLVPTOLOWERVP);
	}
	if(defined(&MALLOC_DECLARE)) {
	}
	if(defined(&NULLFS_DEBUG)) {
	    eval 'sub NULLFSDEBUG () {( &format,  &args...)  &printf( &format ,  &args);}' unless defined(&NULLFSDEBUG);
	} else {
	    eval 'sub NULLFSDEBUG () {( &format,  &args...);}' unless defined(&NULLFSDEBUG);
	}
    }
}
1;
