require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&_KERNEL)) {
    eval("sub UNIONFS_TRADITIONAL () { 0; }") unless defined(&UNIONFS_TRADITIONAL);
    eval("sub UNIONFS_TRANSPARENT () { 1; }") unless defined(&UNIONFS_TRANSPARENT);
    eval("sub UNIONFS_MASQUERADE () { 2; }") unless defined(&UNIONFS_MASQUERADE);
    eval("sub UNIONFS_WHITE_ALWAYS () { 0; }") unless defined(&UNIONFS_WHITE_ALWAYS);
    eval("sub UNIONFS_WHITE_WHENNEEDED () { 1; }") unless defined(&UNIONFS_WHITE_WHENNEEDED);
    eval 'sub UNS_OPENL_4_READDIR () {0x1;}' unless defined(&UNS_OPENL_4_READDIR);
    eval 'sub UNIONFS_OPENEXTL () {0x1;}' unless defined(&UNIONFS_OPENEXTL);
    eval 'sub UNIONFS_OPENEXTU () {0x2;}' unless defined(&UNIONFS_OPENEXTU);
    eval 'sub MOUNTTOUNIONFSMOUNT {
        my($mp) = @_;
	    eval q(((($mp)-> &mnt_data)));
    }' unless defined(&MOUNTTOUNIONFSMOUNT);
    eval 'sub VTOUNIONFS {
        my($vp) = @_;
	    eval q((($vp)-> &v_data));
    }' unless defined(&VTOUNIONFS);
    eval 'sub UNIONFSTOV {
        my($xp) = @_;
	    eval q((($xp)-> &un_vnode));
    }' unless defined(&UNIONFSTOV);
    if(defined(&DIAGNOSTIC)) {
	eval 'sub UNIONFSVPTOLOWERVP {
	    my($vp) = @_;
    	    eval q( &unionfs_checklowervp(($vp),  &__FILE__,  &__LINE__));
	}' unless defined(&UNIONFSVPTOLOWERVP);
	eval 'sub UNIONFSVPTOUPPERVP {
	    my($vp) = @_;
    	    eval q( &unionfs_checkuppervp(($vp),  &__FILE__,  &__LINE__));
	}' unless defined(&UNIONFSVPTOUPPERVP);
    } else {
	eval 'sub UNIONFSVPTOLOWERVP {
	    my($vp) = @_;
    	    eval q(( &VTOUNIONFS($vp)-> &un_lowervp));
	}' unless defined(&UNIONFSVPTOLOWERVP);
	eval 'sub UNIONFSVPTOUPPERVP {
	    my($vp) = @_;
    	    eval q(( &VTOUNIONFS($vp)-> &un_uppervp));
	}' unless defined(&UNIONFSVPTOUPPERVP);
    }
    if(defined(&MALLOC_DECLARE)) {
    }
    if(defined(&UNIONFS_DEBUG)) {
	eval 'sub UNIONFSDEBUG () {( &format,  &args...)  &printf( &format ,  &args);}' unless defined(&UNIONFSDEBUG);
    } else {
	eval 'sub UNIONFSDEBUG () {( &format,  &args...);}' unless defined(&UNIONFSDEBUG);
    }
}
1;
