require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_G_CONCAT_H_)) {
    eval 'sub _G_CONCAT_H_ () {1;}' unless defined(&_G_CONCAT_H_);
    require 'sys/endian.ph';
    eval 'sub G_CONCAT_CLASS_NAME () {"CONCAT";}' unless defined(&G_CONCAT_CLASS_NAME);
    eval 'sub G_CONCAT_MAGIC () {"GEOM::CONCAT";}' unless defined(&G_CONCAT_MAGIC);
    eval 'sub G_CONCAT_VERSION () {4;}' unless defined(&G_CONCAT_VERSION);
    if(defined(&_KERNEL)) {
	eval 'sub G_CONCAT_TYPE_MANUAL () {0;}' unless defined(&G_CONCAT_TYPE_MANUAL);
	eval 'sub G_CONCAT_TYPE_AUTOMATIC () {1;}' unless defined(&G_CONCAT_TYPE_AUTOMATIC);
	eval 'sub G_CONCAT_DEBUG () {( &lvl, ...)  &do {  &if ( &g_concat_debug >= ( &lvl)) {  &printf("GEOM_CONCAT");  &if ( &g_concat_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf("\\n"); } }  &while (0);}' unless defined(&G_CONCAT_DEBUG);
	eval 'sub G_CONCAT_LOGREQ () {( &bp, ...)  &do {  &if ( &g_concat_debug >= 2) {  &printf("GEOM_CONCAT[2]: ");  &printf( &__VA_ARGS__);  &printf(" ");  &g_print_bio( &bp);  &printf("\\n"); } }  &while (0);}' unless defined(&G_CONCAT_LOGREQ);
	eval 'sub sc_name () { ($sc_geom->{name});}' unless defined(&sc_name);
    }
    eval 'sub concat_metadata_encode {
        my($md,$data) = @_;
	    eval q({  &bcopy( ($md->{md_magic}), $data, $sizeof{ ($md->{md_magic})});  &le32enc($data + 16,  ($md->{md_version}));  &bcopy( ($md->{md_name}), $data + 20, $sizeof{ ($md->{md_name})});  &le32enc($data + 36,  ($md->{md_id}));  &le16enc($data + 40,  ($md->{md_no}));  &le16enc($data + 42,  ($md->{md_all}));  &bcopy( ($md->{md_provider}), $data + 44, $sizeof{ ($md->{md_provider})});  &le64enc($data + 60,  ($md->{md_provsize})); });
    }' unless defined(&concat_metadata_encode);
    eval 'sub concat_metadata_decode {
        my($data,$md) = @_;
	    eval q({  &bcopy($data,  ($md->{md_magic}), $sizeof{ ($md->{md_magic})});  ($md->{md_version}) =  &le32dec($data + 16);  &bcopy($data + 20,  ($md->{md_name}), $sizeof{ ($md->{md_name})});  ($md->{md_id}) =  &le32dec($data + 36);  ($md->{md_no}) =  &le16dec($data + 40);  ($md->{md_all}) =  &le16dec($data + 42);  &bcopy($data + 44,  ($md->{md_provider}), $sizeof{ ($md->{md_provider})});  ($md->{md_provsize}) =  &le64dec($data + 60); });
    }' unless defined(&concat_metadata_decode);
}
1;
