require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_G_GATE_H_)) {
    eval 'sub _G_GATE_H_ () {1;}' unless defined(&_G_GATE_H_);
    require 'sys/param.ph';
    require 'sys/lock.ph';
    require 'sys/mutex.ph';
    require 'sys/queue.ph';
    require 'geom/geom.ph';
    eval 'sub G_GATE_CLASS_NAME () {"GATE";}' unless defined(&G_GATE_CLASS_NAME);
    eval 'sub G_GATE_PROVIDER_NAME () {"ggate";}' unless defined(&G_GATE_PROVIDER_NAME);
    eval 'sub G_GATE_MOD_NAME () {"ggate";}' unless defined(&G_GATE_MOD_NAME);
    eval 'sub G_GATE_CTL_NAME () {"ggctl";}' unless defined(&G_GATE_CTL_NAME);
    eval 'sub G_GATE_VERSION () {3;}' unless defined(&G_GATE_VERSION);
    eval 'sub G_GATE_MAX_QUEUE_SIZE () {4096;}' unless defined(&G_GATE_MAX_QUEUE_SIZE);
    eval 'sub G_GATE_FLAG_READONLY () {0x1;}' unless defined(&G_GATE_FLAG_READONLY);
    eval 'sub G_GATE_FLAG_WRITEONLY () {0x2;}' unless defined(&G_GATE_FLAG_WRITEONLY);
    eval 'sub G_GATE_FLAG_DESTROY () {0x1000;}' unless defined(&G_GATE_FLAG_DESTROY);
    eval 'sub G_GATE_USERFLAGS () {( &G_GATE_FLAG_READONLY |  &G_GATE_FLAG_WRITEONLY);}' unless defined(&G_GATE_USERFLAGS);
    eval 'sub G_GATE_UNIT_AUTO () {(-1);}' unless defined(&G_GATE_UNIT_AUTO);
    eval 'sub G_GATE_NAME_GIVEN () {(-2);}' unless defined(&G_GATE_NAME_GIVEN);
    eval 'sub G_GATE_CMD_CREATE () { &_IOWR(ord(\'m\'), 0, \'struct g_gate_ctl_create\');}' unless defined(&G_GATE_CMD_CREATE);
    eval 'sub G_GATE_CMD_MODIFY () { &_IOWR(ord(\'m\'), 1, \'struct g_gate_ctl_modify\');}' unless defined(&G_GATE_CMD_MODIFY);
    eval 'sub G_GATE_CMD_DESTROY () { &_IOWR(ord(\'m\'), 2, \'struct g_gate_ctl_destroy\');}' unless defined(&G_GATE_CMD_DESTROY);
    eval 'sub G_GATE_CMD_CANCEL () { &_IOWR(ord(\'m\'), 3, \'struct g_gate_ctl_cancel\');}' unless defined(&G_GATE_CMD_CANCEL);
    eval 'sub G_GATE_CMD_START () { &_IOWR(ord(\'m\'), 4, \'struct g_gate_ctl_io\');}' unless defined(&G_GATE_CMD_START);
    eval 'sub G_GATE_CMD_DONE () { &_IOWR(ord(\'m\'), 5, \'struct g_gate_ctl_io\');}' unless defined(&G_GATE_CMD_DONE);
    eval 'sub G_GATE_INFOSIZE () {2048;}' unless defined(&G_GATE_INFOSIZE);
    if(defined(&_KERNEL)) {
	eval 'sub G_GATE_DEBUG () {( &lvl, ...)  &do {  &if ( &g_gate_debug >= ( &lvl)) {  &printf("GEOM_GATE");  &if ( &g_gate_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf("\\n"); } }  &while (0);}' unless defined(&G_GATE_DEBUG);
	eval 'sub G_GATE_LOGREQ () {( &lvl,  &bp, ...)  &do {  &if ( &g_gate_debug >= ( &lvl)) {  &printf("GEOM_GATE");  &if ( &g_gate_debug > 0)  &printf("[%u]",  &lvl);  &printf(": ");  &printf( &__VA_ARGS__);  &printf(" ");  &g_print_bio( &bp);  &printf("\\n"); } }  &while (0);}' unless defined(&G_GATE_LOGREQ);
    }
    eval 'sub GG_MODIFY_MEDIASIZE () {0x1;}' unless defined(&GG_MODIFY_MEDIASIZE);
    eval 'sub GG_MODIFY_INFO () {0x2;}' unless defined(&GG_MODIFY_INFO);
    eval 'sub GG_MODIFY_READPROV () {0x4;}' unless defined(&GG_MODIFY_READPROV);
    eval 'sub GG_MODIFY_READOFFSET () {0x8;}' unless defined(&GG_MODIFY_READOFFSET);
}
1;
