require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/types.ph';
unless(defined(&UINT16BYTES)) {
    sub UINT16BYTES {
	my($p) = @_;
	eval q((( &uint32_t)(($p)[0] + (256*($p)[1]))));
    }
}
unless(defined(&UINT32BYTES)) {
    sub UINT32BYTES {
	my($p) = @_;
	eval q((( &uint32_t)(($p)[0] + (256*($p)[1]) + (65536*($p)[2]) + (16777216*($p)[3]))));
    }
}
eval 'sub FAT_DES_ATTR_READ_ONLY () {0x1;}' unless defined(&FAT_DES_ATTR_READ_ONLY);
eval 'sub FAT_DES_ATTR_HIDDEN () {0x2;}' unless defined(&FAT_DES_ATTR_HIDDEN);
eval 'sub FAT_DES_ATTR_SYSTEM () {0x4;}' unless defined(&FAT_DES_ATTR_SYSTEM);
eval 'sub FAT_DES_ATTR_VOLUME_ID () {0x8;}' unless defined(&FAT_DES_ATTR_VOLUME_ID);
eval 'sub FAT_DES_ATTR_DIRECTORY () {0x10;}' unless defined(&FAT_DES_ATTR_DIRECTORY);
eval 'sub FAT_DES_ATTR_ARCHIVE () {0x20;}' unless defined(&FAT_DES_ATTR_ARCHIVE);
eval 'sub FAT_DES_ATTR_LONG_NAME () {( &FAT_DES_ATTR_READ_ONLY |  &FAT_DES_ATTR_HIDDEN |  &FAT_DES_ATTR_SYSTEM |  &FAT_DES_ATTR_VOLUME_ID);}' unless defined(&FAT_DES_ATTR_LONG_NAME);
1;
