require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_G_MULTIPATH_H_)) {
    eval 'sub _G_MULTIPATH_H_ () {1;}' unless defined(&_G_MULTIPATH_H_);
    eval 'sub G_MULTIPATH_CLASS_NAME () {"MULTIPATH";}' unless defined(&G_MULTIPATH_CLASS_NAME);
    eval 'sub G_MULTIPATH_VERSION () {1;}' unless defined(&G_MULTIPATH_VERSION);
    eval 'sub G_MULTIPATH_MAGIC () {"GEOM::MULTIPATH";}' unless defined(&G_MULTIPATH_MAGIC);
    require 'sys/endian.ph';
    if(defined(&_KERNEL)) {
    }
    eval 'sub multipath_metadata_encode {
        my($md,$data) = @_;
	    eval q({  &bcopy( ($md->{md_magic}), $data, $sizeof{ ($md->{md_magic})}); $data += $sizeof{ ($md->{md_magic})};  &bcopy( ($md->{md_uuid}), $data, $sizeof{ ($md->{md_uuid})}); $data += $sizeof{ ($md->{md_uuid})};  &bcopy( ($md->{md_name}), $data, $sizeof{ ($md->{md_name})}); $data += $sizeof{ ($md->{md_name})};  &le32enc($data,  ($md->{md_version})); $data += $sizeof{ ($md->{md_version})};  &le32enc($data,  ($md->{md_sectorsize})); $data += $sizeof{ ($md->{md_sectorsize})};  &le64enc($data,  ($md->{md_size})); $data += $sizeof{ ($md->{md_size})}; *$data =  ($md->{md_active_active}); });
    }' unless defined(&multipath_metadata_encode);
    eval 'sub multipath_metadata_decode {
        my($data,$md) = @_;
	    eval q({  &bcopy($data,  ($md->{md_magic}), $sizeof{ ($md->{md_magic})}); $data += $sizeof{ ($md->{md_magic})};  &bcopy($data,  ($md->{md_uuid}), $sizeof{ ($md->{md_uuid})}); $data += $sizeof{ ($md->{md_uuid})};  &bcopy($data,  ($md->{md_name}), $sizeof{ ($md->{md_name})}); $data += $sizeof{ ($md->{md_name})};  ($md->{md_version}) =  &le32dec($data); $data += $sizeof{ ($md->{md_version})};  ($md->{md_sectorsize}) =  &le32dec($data); $data += $sizeof{ ($md->{md_sectorsize})};  ($md->{md_size}) =  &le64dec($data); $data += $sizeof{ ($md->{md_size})};  ($md->{md_active_active}) = *$data; });
    }' unless defined(&multipath_metadata_decode);
}
1;
