require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_G_RAID_H_)) {
    eval 'sub _G_RAID_H_ () {1;}' unless defined(&_G_RAID_H_);
    require 'sys/param.ph';
    require 'sys/kobj.ph';
    require 'sys/bio.ph';
    require 'sys/time.ph';
    if(defined(&_KERNEL)) {
	require 'sys/sysctl.ph';
    }
    eval 'sub G_RAID_CLASS_NAME () {"RAID";}' unless defined(&G_RAID_CLASS_NAME);
    eval 'sub G_RAID_MAGIC () {"GEOM::RAID";}' unless defined(&G_RAID_MAGIC);
    eval 'sub G_RAID_VERSION () {0;}' unless defined(&G_RAID_VERSION);
    eval 'sub G_RAID_DEVICE_FLAG_NOAUTOSYNC () {0x1;}' unless defined(&G_RAID_DEVICE_FLAG_NOAUTOSYNC);
    eval 'sub G_RAID_DEVICE_FLAG_NOFAILSYNC () {0x2;}' unless defined(&G_RAID_DEVICE_FLAG_NOFAILSYNC);
    eval 'sub G_RAID_DEVICE_FLAG_MASK () {( &G_RAID_DEVICE_FLAG_NOAUTOSYNC |  &G_RAID_DEVICE_FLAG_NOFAILSYNC);}' unless defined(&G_RAID_DEVICE_FLAG_MASK);
    if(defined(&_KERNEL)) {
	eval 'sub G_RAID_DEBUG () {( &lvl,  &fmt, ...)  &do {  &if ( &g_raid_debug >= ( &lvl)) {  &if ( &g_raid_debug > 0) {  &printf("GEOM_RAID[%u]: "  &fmt "\\n",  &lvl,   &__VA_ARGS__); }  &else {  &printf("GEOM_RAID: "  &fmt "\\n",   &__VA_ARGS__); } } }  &while (0);}' unless defined(&G_RAID_DEBUG);
	eval 'sub G_RAID_DEBUG1 () {( &lvl,  &sc,  &fmt, ...)  &do {  &if ( &g_raid_debug >= ( &lvl)) {  &if ( &g_raid_debug > 0) {  &printf("GEOM_RAID[%u]: %s: "  &fmt "\\n",  &lvl, ( &sc)-> &sc_name,   &__VA_ARGS__); }  &else {  &printf("GEOM_RAID: %s: "  &fmt "\\n", ( &sc)-> &sc_name,   &__VA_ARGS__); } } }  &while (0);}' unless defined(&G_RAID_DEBUG1);
	eval 'sub G_RAID_LOGREQ () {( &lvl,  &bp,  &fmt, ...)  &do {  &if ( &g_raid_debug >= ( &lvl)) {  &if ( &g_raid_debug > 0) {  &printf("GEOM_RAID[%u]: "  &fmt " ",  &lvl,   &__VA_ARGS__); }  &else  &printf("GEOM_RAID: "  &fmt " ",   &__VA_ARGS__);  &g_print_bio( &bp);  &printf("\\n"); } }  &while (0);}' unless defined(&G_RAID_LOGREQ);
	eval 'sub G_RAID_BIO_FLAG_SYNC () {0x1;}' unless defined(&G_RAID_BIO_FLAG_SYNC);
	eval 'sub G_RAID_BIO_FLAG_REMAP () {0x2;}' unless defined(&G_RAID_BIO_FLAG_REMAP);
	eval 'sub G_RAID_BIO_FLAG_SPECIAL () {( &G_RAID_BIO_FLAG_SYNC| &G_RAID_BIO_FLAG_REMAP);}' unless defined(&G_RAID_BIO_FLAG_SPECIAL);
	eval 'sub G_RAID_BIO_FLAG_LOCKED () {0x80;}' unless defined(&G_RAID_BIO_FLAG_LOCKED);
	eval 'sub G_RAID_EVENT_WAIT () {0x1;}' unless defined(&G_RAID_EVENT_WAIT);
	eval 'sub G_RAID_EVENT_VOLUME () {0x2;}' unless defined(&G_RAID_EVENT_VOLUME);
	eval 'sub G_RAID_EVENT_SUBDISK () {0x4;}' unless defined(&G_RAID_EVENT_SUBDISK);
	eval 'sub G_RAID_EVENT_DISK () {0x8;}' unless defined(&G_RAID_EVENT_DISK);
	eval 'sub G_RAID_EVENT_DONE () {0x10;}' unless defined(&G_RAID_EVENT_DONE);
	eval 'sub G_RAID_DISK_S_NONE () {0x;}' unless defined(&G_RAID_DISK_S_NONE);
	eval 'sub G_RAID_DISK_S_OFFLINE () {0x1;}' unless defined(&G_RAID_DISK_S_OFFLINE);
	eval 'sub G_RAID_DISK_S_DISABLED () {0x2;}' unless defined(&G_RAID_DISK_S_DISABLED);
	eval 'sub G_RAID_DISK_S_FAILED () {0x3;}' unless defined(&G_RAID_DISK_S_FAILED);
	eval 'sub G_RAID_DISK_S_STALE_FAILED () {0x4;}' unless defined(&G_RAID_DISK_S_STALE_FAILED);
	eval 'sub G_RAID_DISK_S_SPARE () {0x5;}' unless defined(&G_RAID_DISK_S_SPARE);
	eval 'sub G_RAID_DISK_S_STALE () {0x6;}' unless defined(&G_RAID_DISK_S_STALE);
	eval 'sub G_RAID_DISK_S_ACTIVE () {0x7;}' unless defined(&G_RAID_DISK_S_ACTIVE);
	eval 'sub G_RAID_DISK_E_DISCONNECTED () {0x1;}' unless defined(&G_RAID_DISK_E_DISCONNECTED);
	eval 'sub G_RAID_SUBDISK_S_NONE () {0x;}' unless defined(&G_RAID_SUBDISK_S_NONE);
	eval 'sub G_RAID_SUBDISK_S_FAILED () {0x1;}' unless defined(&G_RAID_SUBDISK_S_FAILED);
	eval 'sub G_RAID_SUBDISK_S_NEW () {0x2;}' unless defined(&G_RAID_SUBDISK_S_NEW);
	eval 'sub G_RAID_SUBDISK_S_REBUILD () {0x3;}' unless defined(&G_RAID_SUBDISK_S_REBUILD);
	eval 'sub G_RAID_SUBDISK_S_UNINITIALIZED () {0x4;}' unless defined(&G_RAID_SUBDISK_S_UNINITIALIZED);
	eval 'sub G_RAID_SUBDISK_S_STALE () {0x5;}' unless defined(&G_RAID_SUBDISK_S_STALE);
	eval 'sub G_RAID_SUBDISK_S_RESYNC () {0x6;}' unless defined(&G_RAID_SUBDISK_S_RESYNC);
	eval 'sub G_RAID_SUBDISK_S_ACTIVE () {0x7;}' unless defined(&G_RAID_SUBDISK_S_ACTIVE);
	eval 'sub G_RAID_SUBDISK_E_NEW () {0x1;}' unless defined(&G_RAID_SUBDISK_E_NEW);
	eval 'sub G_RAID_SUBDISK_E_FAILED () {0x2;}' unless defined(&G_RAID_SUBDISK_E_FAILED);
	eval 'sub G_RAID_SUBDISK_E_DISCONNECTED () {0x3;}' unless defined(&G_RAID_SUBDISK_E_DISCONNECTED);
	eval 'sub G_RAID_SUBDISK_E_FIRST_TR_PRIVATE () {0x80;}' unless defined(&G_RAID_SUBDISK_E_FIRST_TR_PRIVATE);
	eval 'sub G_RAID_SUBDISK_POS {
	    my($sd) = @_;
    	    eval q((($sd)-> &sd_disk ? (($sd)-> ($sd_disk->{d_last_offset}) - ($sd)-> &sd_offset) : 0));
	}' unless defined(&G_RAID_SUBDISK_POS);
	eval 'sub G_RAID_SUBDISK_TRACK_SIZE () {(1* 1024* 1024);}' unless defined(&G_RAID_SUBDISK_TRACK_SIZE);
	eval 'sub G_RAID_SUBDISK_LOAD {
	    my($sd) = @_;
    	    eval q((($sd)-> &sd_disk ? (($sd)-> ($sd_disk->{d_load})) : 0));
	}' unless defined(&G_RAID_SUBDISK_LOAD);
	eval 'sub G_RAID_SUBDISK_LOAD_SCALE () {256;}' unless defined(&G_RAID_SUBDISK_LOAD_SCALE);
	eval 'sub G_RAID_MAX_SUBDISKS () {16;}' unless defined(&G_RAID_MAX_SUBDISKS);
	eval 'sub G_RAID_MAX_VOLUMENAME () {32;}' unless defined(&G_RAID_MAX_VOLUMENAME);
	eval 'sub G_RAID_VOLUME_S_STARTING () {0x;}' unless defined(&G_RAID_VOLUME_S_STARTING);
	eval 'sub G_RAID_VOLUME_S_BROKEN () {0x1;}' unless defined(&G_RAID_VOLUME_S_BROKEN);
	eval 'sub G_RAID_VOLUME_S_DEGRADED () {0x2;}' unless defined(&G_RAID_VOLUME_S_DEGRADED);
	eval 'sub G_RAID_VOLUME_S_SUBOPTIMAL () {0x3;}' unless defined(&G_RAID_VOLUME_S_SUBOPTIMAL);
	eval 'sub G_RAID_VOLUME_S_OPTIMAL () {0x4;}' unless defined(&G_RAID_VOLUME_S_OPTIMAL);
	eval 'sub G_RAID_VOLUME_S_UNSUPPORTED () {0x5;}' unless defined(&G_RAID_VOLUME_S_UNSUPPORTED);
	eval 'sub G_RAID_VOLUME_S_STOPPED () {0x6;}' unless defined(&G_RAID_VOLUME_S_STOPPED);
	eval 'sub G_RAID_VOLUME_S_ALIVE {
	    my($s) = @_;
    	    eval q((($s) ==  &G_RAID_VOLUME_S_DEGRADED || ($s) ==  &G_RAID_VOLUME_S_SUBOPTIMAL || ($s) ==  &G_RAID_VOLUME_S_OPTIMAL));
	}' unless defined(&G_RAID_VOLUME_S_ALIVE);
	eval 'sub G_RAID_VOLUME_E_DOWN () {0x;}' unless defined(&G_RAID_VOLUME_E_DOWN);
	eval 'sub G_RAID_VOLUME_E_UP () {0x1;}' unless defined(&G_RAID_VOLUME_E_UP);
	eval 'sub G_RAID_VOLUME_E_START () {0x10;}' unless defined(&G_RAID_VOLUME_E_START);
	eval 'sub G_RAID_VOLUME_E_STARTMD () {0x11;}' unless defined(&G_RAID_VOLUME_E_STARTMD);
	eval 'sub G_RAID_VOLUME_RL_RAID0 () {0x;}' unless defined(&G_RAID_VOLUME_RL_RAID0);
	eval 'sub G_RAID_VOLUME_RL_RAID1 () {0x1;}' unless defined(&G_RAID_VOLUME_RL_RAID1);
	eval 'sub G_RAID_VOLUME_RL_RAID3 () {0x3;}' unless defined(&G_RAID_VOLUME_RL_RAID3);
	eval 'sub G_RAID_VOLUME_RL_RAID4 () {0x4;}' unless defined(&G_RAID_VOLUME_RL_RAID4);
	eval 'sub G_RAID_VOLUME_RL_RAID5 () {0x5;}' unless defined(&G_RAID_VOLUME_RL_RAID5);
	eval 'sub G_RAID_VOLUME_RL_RAID6 () {0x6;}' unless defined(&G_RAID_VOLUME_RL_RAID6);
	eval 'sub G_RAID_VOLUME_RL_RAIDMDF () {0x7;}' unless defined(&G_RAID_VOLUME_RL_RAIDMDF);
	eval 'sub G_RAID_VOLUME_RL_RAID1E () {0x11;}' unless defined(&G_RAID_VOLUME_RL_RAID1E);
	eval 'sub G_RAID_VOLUME_RL_SINGLE () {0xf;}' unless defined(&G_RAID_VOLUME_RL_SINGLE);
	eval 'sub G_RAID_VOLUME_RL_CONCAT () {0x1f;}' unless defined(&G_RAID_VOLUME_RL_CONCAT);
	eval 'sub G_RAID_VOLUME_RL_RAID5E () {0x15;}' unless defined(&G_RAID_VOLUME_RL_RAID5E);
	eval 'sub G_RAID_VOLUME_RL_RAID5EE () {0x25;}' unless defined(&G_RAID_VOLUME_RL_RAID5EE);
	eval 'sub G_RAID_VOLUME_RL_RAID5R () {0x35;}' unless defined(&G_RAID_VOLUME_RL_RAID5R);
	eval 'sub G_RAID_VOLUME_RL_UNKNOWN () {0xff;}' unless defined(&G_RAID_VOLUME_RL_UNKNOWN);
	eval 'sub G_RAID_VOLUME_RLQ_NONE () {0x;}' unless defined(&G_RAID_VOLUME_RLQ_NONE);
	eval 'sub G_RAID_VOLUME_RLQ_R1SM () {0x;}' unless defined(&G_RAID_VOLUME_RLQ_R1SM);
	eval 'sub G_RAID_VOLUME_RLQ_R1MM () {0x1;}' unless defined(&G_RAID_VOLUME_RLQ_R1MM);
	eval 'sub G_RAID_VOLUME_RLQ_R3P0 () {0x;}' unless defined(&G_RAID_VOLUME_RLQ_R3P0);
	eval 'sub G_RAID_VOLUME_RLQ_R3PN () {0x1;}' unless defined(&G_RAID_VOLUME_RLQ_R3PN);
	eval 'sub G_RAID_VOLUME_RLQ_R4P0 () {0x;}' unless defined(&G_RAID_VOLUME_RLQ_R4P0);
	eval 'sub G_RAID_VOLUME_RLQ_R4PN () {0x1;}' unless defined(&G_RAID_VOLUME_RLQ_R4PN);
	eval 'sub G_RAID_VOLUME_RLQ_R5RA () {0x;}' unless defined(&G_RAID_VOLUME_RLQ_R5RA);
	eval 'sub G_RAID_VOLUME_RLQ_R5RS () {0x1;}' unless defined(&G_RAID_VOLUME_RLQ_R5RS);
	eval 'sub G_RAID_VOLUME_RLQ_R5LA () {0x2;}' unless defined(&G_RAID_VOLUME_RLQ_R5LA);
	eval 'sub G_RAID_VOLUME_RLQ_R5LS () {0x3;}' unless defined(&G_RAID_VOLUME_RLQ_R5LS);
	eval 'sub G_RAID_VOLUME_RLQ_R6RA () {0x;}' unless defined(&G_RAID_VOLUME_RLQ_R6RA);
	eval 'sub G_RAID_VOLUME_RLQ_R6RS () {0x1;}' unless defined(&G_RAID_VOLUME_RLQ_R6RS);
	eval 'sub G_RAID_VOLUME_RLQ_R6LA () {0x2;}' unless defined(&G_RAID_VOLUME_RLQ_R6LA);
	eval 'sub G_RAID_VOLUME_RLQ_R6LS () {0x3;}' unless defined(&G_RAID_VOLUME_RLQ_R6LS);
	eval 'sub G_RAID_VOLUME_RLQ_RMDFRA () {0x;}' unless defined(&G_RAID_VOLUME_RLQ_RMDFRA);
	eval 'sub G_RAID_VOLUME_RLQ_RMDFRS () {0x1;}' unless defined(&G_RAID_VOLUME_RLQ_RMDFRS);
	eval 'sub G_RAID_VOLUME_RLQ_RMDFLA () {0x2;}' unless defined(&G_RAID_VOLUME_RLQ_RMDFLA);
	eval 'sub G_RAID_VOLUME_RLQ_RMDFLS () {0x3;}' unless defined(&G_RAID_VOLUME_RLQ_RMDFLS);
	eval 'sub G_RAID_VOLUME_RLQ_R1EA () {0x;}' unless defined(&G_RAID_VOLUME_RLQ_R1EA);
	eval 'sub G_RAID_VOLUME_RLQ_R1EO () {0x1;}' unless defined(&G_RAID_VOLUME_RLQ_R1EO);
	eval 'sub G_RAID_VOLUME_RLQ_R5ERA () {0x;}' unless defined(&G_RAID_VOLUME_RLQ_R5ERA);
	eval 'sub G_RAID_VOLUME_RLQ_R5ERS () {0x1;}' unless defined(&G_RAID_VOLUME_RLQ_R5ERS);
	eval 'sub G_RAID_VOLUME_RLQ_R5ELA () {0x2;}' unless defined(&G_RAID_VOLUME_RLQ_R5ELA);
	eval 'sub G_RAID_VOLUME_RLQ_R5ELS () {0x3;}' unless defined(&G_RAID_VOLUME_RLQ_R5ELS);
	eval 'sub G_RAID_VOLUME_RLQ_R5EERA () {0x;}' unless defined(&G_RAID_VOLUME_RLQ_R5EERA);
	eval 'sub G_RAID_VOLUME_RLQ_R5EERS () {0x1;}' unless defined(&G_RAID_VOLUME_RLQ_R5EERS);
	eval 'sub G_RAID_VOLUME_RLQ_R5EELA () {0x2;}' unless defined(&G_RAID_VOLUME_RLQ_R5EELA);
	eval 'sub G_RAID_VOLUME_RLQ_R5EELS () {0x3;}' unless defined(&G_RAID_VOLUME_RLQ_R5EELS);
	eval 'sub G_RAID_VOLUME_RLQ_R5RRA () {0x;}' unless defined(&G_RAID_VOLUME_RLQ_R5RRA);
	eval 'sub G_RAID_VOLUME_RLQ_R5RRS () {0x1;}' unless defined(&G_RAID_VOLUME_RLQ_R5RRS);
	eval 'sub G_RAID_VOLUME_RLQ_R5RLA () {0x2;}' unless defined(&G_RAID_VOLUME_RLQ_R5RLA);
	eval 'sub G_RAID_VOLUME_RLQ_R5RLS () {0x3;}' unless defined(&G_RAID_VOLUME_RLQ_R5RLS);
	eval 'sub G_RAID_VOLUME_RLQ_UNKNOWN () {0xff;}' unless defined(&G_RAID_VOLUME_RLQ_UNKNOWN);
	eval 'sub G_RAID_NODE_E_WAKE () {0x;}' unless defined(&G_RAID_NODE_E_WAKE);
	eval 'sub G_RAID_NODE_E_START () {0x1;}' unless defined(&G_RAID_NODE_E_START);
	eval 'sub sc_name () { ($sc_geom->{name});}' unless defined(&sc_name);
	eval 'sub G_RAID_MD_DECLARE {
	    my($name, $label) = @_;
    	    eval q( &static  &moduledata_t  &g_raid_md_$name &_mod = { \\"g_raid_md_\\"  &__XSTRING($name),  &g_raid_md_modevent,  &g_raid_md_$name &_class };  &DECLARE_MODULE( &g_raid_md_$name,  &g_raid_md_$name &_mod,  &SI_SUB_DRIVERS,  &SI_ORDER_SECOND);  &MODULE_DEPEND( &g_raid_md_$name,  &geom_raid, 0, 0, 0);  &SYSCTL_NODE( &_kern_geom_raid,  &OID_AUTO, $name,  &CTLFLAG_RD,  &NULL, $label \\" metadata module\\");  &SYSCTL_INT( &_kern_geom_raid_$name,  &OID_AUTO,  &enable,  &CTLFLAG_RWTUN,  &g_raid_md_$name ($_class->{mdc_enable}), 0, \\"Enable \\" $label \\" metadata format taste\\"));
	}' unless defined(&G_RAID_MD_DECLARE);
	eval 'sub G_RAID_TR_DECLARE {
	    my($name, $label) = @_;
    	    eval q( &static  &moduledata_t  &g_raid_tr_$name &_mod = { \\"g_raid_tr_\\"  &__XSTRING($name),  &g_raid_tr_modevent,  &g_raid_tr_$name &_class };  &DECLARE_MODULE( &g_raid_tr_$name,  &g_raid_tr_$name &_mod,  &SI_SUB_DRIVERS,  &SI_ORDER_FIRST);  &MODULE_DEPEND( &g_raid_tr_$name,  &geom_raid, 0, 0, 0);  &SYSCTL_NODE( &_kern_geom_raid,  &OID_AUTO, $name,  &CTLFLAG_RD,  &NULL, $label \\" transformation module\\");  &SYSCTL_INT( &_kern_geom_raid_$name,  &OID_AUTO,  &enable,  &CTLFLAG_RWTUN,  &g_raid_tr_$name ($_class->{trc_enable}), 0, \\"Enable \\" $label \\" transformation module taste\\"));
	}' unless defined(&G_RAID_TR_DECLARE);
	eval 'sub G_RAID_DESTROY_SOFT () {0;}' unless defined(&G_RAID_DESTROY_SOFT);
	eval 'sub G_RAID_DESTROY_DELAYED () {1;}' unless defined(&G_RAID_DESTROY_DELAYED);
	eval 'sub G_RAID_DESTROY_HARD () {2;}' unless defined(&G_RAID_DESTROY_HARD);
    }
}
1;
