require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MD_DDF_H)) {
    eval 'sub MD_DDF_H () {1;}' unless defined(&MD_DDF_H);
    eval 'sub DDF_HEADER_LENGTH () {512;}' unless defined(&DDF_HEADER_LENGTH);
    eval 'sub DDF_HEADER_SIGNATURE () {0xde11de11;}' unless defined(&DDF_HEADER_SIGNATURE);
    eval 'sub DDF_HEADER_CLOSED () {0x;}' unless defined(&DDF_HEADER_CLOSED);
    eval 'sub DDF_HEADER_OPENED_MASK () {0xf;}' unless defined(&DDF_HEADER_OPENED_MASK);
    eval 'sub DDF_HEADER_OPEN_ANCHOR () {0xff;}' unless defined(&DDF_HEADER_OPEN_ANCHOR);
    eval 'sub DDF_HEADER_ANCHOR () {0x;}' unless defined(&DDF_HEADER_ANCHOR);
    eval 'sub DDF_HEADER_PRIMARY () {0x1;}' unless defined(&DDF_HEADER_PRIMARY);
    eval 'sub DDF_HEADER_SECONDARY () {0x2;}' unless defined(&DDF_HEADER_SECONDARY);
    eval 'sub DDF_CONTROLLER_DATA_SIGNATURE () {0xad111111;}' unless defined(&DDF_CONTROLLER_DATA_SIGNATURE);
    eval 'sub DDF_DEVICE_SCSI_FLAG_BROKEN () {(1<< 7);}' unless defined(&DDF_DEVICE_SCSI_FLAG_BROKEN);
    eval 'sub DDF_DEVICE_SAS_PHY_ID () {0x7f;}' unless defined(&DDF_DEVICE_SAS_PHY_ID);
    eval 'sub DDF_DEVICE_SAS_FLAG_BROKEN () {(1<< 7);}' unless defined(&DDF_DEVICE_SAS_FLAG_BROKEN);
    eval 'sub DDF_PDE_GUID_FORCE () {(1<< 0);}' unless defined(&DDF_PDE_GUID_FORCE);
    eval 'sub DDF_PDE_PARTICIPATING () {(1<< 1);}' unless defined(&DDF_PDE_PARTICIPATING);
    eval 'sub DDF_PDE_GLOBAL_SPARE () {(1<< 2);}' unless defined(&DDF_PDE_GLOBAL_SPARE);
    eval 'sub DDF_PDE_CONFIG_SPARE () {(1<< 3);}' unless defined(&DDF_PDE_CONFIG_SPARE);
    eval 'sub DDF_PDE_FOREIGN () {(1<< 4);}' unless defined(&DDF_PDE_FOREIGN);
    eval 'sub DDF_PDE_LEGACY () {(1<< 5);}' unless defined(&DDF_PDE_LEGACY);
    eval 'sub DDF_PDE_TYPE_MASK () {(0xf << 12);}' unless defined(&DDF_PDE_TYPE_MASK);
    eval 'sub DDF_PDE_UNKNOWN () {(0x << 12);}' unless defined(&DDF_PDE_UNKNOWN);
    eval 'sub DDF_PDE_SCSI () {(0x1 << 12);}' unless defined(&DDF_PDE_SCSI);
    eval 'sub DDF_PDE_SAS () {(0x2 << 12);}' unless defined(&DDF_PDE_SAS);
    eval 'sub DDF_PDE_SATA () {(0x3 << 12);}' unless defined(&DDF_PDE_SATA);
    eval 'sub DDF_PDE_FC () {(0x4 << 12);}' unless defined(&DDF_PDE_FC);
    eval 'sub DDF_PDE_ONLINE () {(1<< 0);}' unless defined(&DDF_PDE_ONLINE);
    eval 'sub DDF_PDE_FAILED () {(1<< 1);}' unless defined(&DDF_PDE_FAILED);
    eval 'sub DDF_PDE_REBUILD () {(1<< 2);}' unless defined(&DDF_PDE_REBUILD);
    eval 'sub DDF_PDE_TRANSITION () {(1<< 3);}' unless defined(&DDF_PDE_TRANSITION);
    eval 'sub DDF_PDE_PFA () {(1<< 4);}' unless defined(&DDF_PDE_PFA);
    eval 'sub DDF_PDE_UNRECOVERED () {(1<< 5);}' unless defined(&DDF_PDE_UNRECOVERED);
    eval 'sub DDF_PDE_MISSING () {(1<< 6);}' unless defined(&DDF_PDE_MISSING);
    eval 'sub DDF_PDR_SIGNATURE () {0x22222222;}' unless defined(&DDF_PDR_SIGNATURE);
    eval 'sub DDF_VDE_SHARED () {(1<< 0);}' unless defined(&DDF_VDE_SHARED);
    eval 'sub DDF_VDE_ENFORCE_GROUP () {(1<< 1);}' unless defined(&DDF_VDE_ENFORCE_GROUP);
    eval 'sub DDF_VDE_UNICODE_NAME () {(1<< 2);}' unless defined(&DDF_VDE_UNICODE_NAME);
    eval 'sub DDF_VDE_OWNER_ID_VALID () {(1<< 3);}' unless defined(&DDF_VDE_OWNER_ID_VALID);
    eval 'sub DDF_VDE_OPTIMAL () {0x;}' unless defined(&DDF_VDE_OPTIMAL);
    eval 'sub DDF_VDE_DEGRADED () {0x1;}' unless defined(&DDF_VDE_DEGRADED);
    eval 'sub DDF_VDE_DELETED () {0x2;}' unless defined(&DDF_VDE_DELETED);
    eval 'sub DDF_VDE_MISSING () {0x3;}' unless defined(&DDF_VDE_MISSING);
    eval 'sub DDF_VDE_FAILED () {0x4;}' unless defined(&DDF_VDE_FAILED);
    eval 'sub DDF_VDE_PARTIAL () {0x5;}' unless defined(&DDF_VDE_PARTIAL);
    eval 'sub DDF_VDE_OFFLINE () {0x6;}' unless defined(&DDF_VDE_OFFLINE);
    eval 'sub DDF_VDE_STATE_MASK () {0x7;}' unless defined(&DDF_VDE_STATE_MASK);
    eval 'sub DDF_VDE_MORPH () {(1<< 3);}' unless defined(&DDF_VDE_MORPH);
    eval 'sub DDF_VDE_DIRTY () {(1<< 4);}' unless defined(&DDF_VDE_DIRTY);
    eval 'sub DDF_VDE_UNINTIALIZED () {0x;}' unless defined(&DDF_VDE_UNINTIALIZED);
    eval 'sub DDF_VDE_INIT_QUICK () {0x1;}' unless defined(&DDF_VDE_INIT_QUICK);
    eval 'sub DDF_VDE_INIT_FULL () {0x2;}' unless defined(&DDF_VDE_INIT_FULL);
    eval 'sub DDF_VDE_INIT_MASK () {0x3;}' unless defined(&DDF_VDE_INIT_MASK);
    eval 'sub DDF_VDE_UACCESS_RW () {0x;}' unless defined(&DDF_VDE_UACCESS_RW);
    eval 'sub DDF_VDE_UACCESS_RO () {0x80;}' unless defined(&DDF_VDE_UACCESS_RO);
    eval 'sub DDF_VDE_UACCESS_BLOCKED () {0xc0;}' unless defined(&DDF_VDE_UACCESS_BLOCKED);
    eval 'sub DDF_VDE_UACCESS_MASK () {0xc0;}' unless defined(&DDF_VDE_UACCESS_MASK);
    eval 'sub DDF_VD_RECORD_SIGNATURE () {0xdddddddd;}' unless defined(&DDF_VD_RECORD_SIGNATURE);
    eval 'sub DDF_CR_INVALID () {0xffffffff;}' unless defined(&DDF_CR_INVALID);
    eval 'sub DDF_VDCR_SIGNATURE () {0xeeeeeeee;}' unless defined(&DDF_VDCR_SIGNATURE);
    eval 'sub DDF_VDCR_RAID0 () {0x;}' unless defined(&DDF_VDCR_RAID0);
    eval 'sub DDF_VDCR_RAID1 () {0x1;}' unless defined(&DDF_VDCR_RAID1);
    eval 'sub DDF_VDCR_RAID3 () {0x3;}' unless defined(&DDF_VDCR_RAID3);
    eval 'sub DDF_VDCR_RAID4 () {0x4;}' unless defined(&DDF_VDCR_RAID4);
    eval 'sub DDF_VDCR_RAID5 () {0x5;}' unless defined(&DDF_VDCR_RAID5);
    eval 'sub DDF_VDCR_RAID6 () {0x6;}' unless defined(&DDF_VDCR_RAID6);
    eval 'sub DDF_VDCR_RAID1E () {0x11;}' unless defined(&DDF_VDCR_RAID1E);
    eval 'sub DDF_VDCR_SINGLE () {0xf;}' unless defined(&DDF_VDCR_SINGLE);
    eval 'sub DDF_VDCR_CONCAT () {0x1f;}' unless defined(&DDF_VDCR_CONCAT);
    eval 'sub DDF_VDCR_RAID5E () {0x15;}' unless defined(&DDF_VDCR_RAID5E);
    eval 'sub DDF_VDCR_RAID5EE () {0x25;}' unless defined(&DDF_VDCR_RAID5EE);
    eval 'sub DDF_VDCR_CACHE_WB () {(1<< 0);}' unless defined(&DDF_VDCR_CACHE_WB);
    eval 'sub DDF_VDCR_CACHE_WB_ADAPTIVE () {(1<< 1);}' unless defined(&DDF_VDCR_CACHE_WB_ADAPTIVE);
    eval 'sub DDF_VDCR_CACHE_RA () {(1<< 2);}' unless defined(&DDF_VDCR_CACHE_RA);
    eval 'sub DDF_VDCR_CACHE_RA_ADAPTIVE () {(1<< 3);}' unless defined(&DDF_VDCR_CACHE_RA_ADAPTIVE);
    eval 'sub DDF_VDCR_CACHE_WCACHE_NOBATTERY () {(1<< 4);}' unless defined(&DDF_VDCR_CACHE_WCACHE_NOBATTERY);
    eval 'sub DDF_VDCR_CACHE_WCACHE_ALLOW () {(1<< 5);}' unless defined(&DDF_VDCR_CACHE_WCACHE_ALLOW);
    eval 'sub DDF_VDCR_CACHE_RCACHE_ALLOW () {(1<< 6);}' unless defined(&DDF_VDCR_CACHE_RCACHE_ALLOW);
    eval 'sub DDF_VDCR_CACHE_VENDOR () {(1<< 7);}' unless defined(&DDF_VDCR_CACHE_VENDOR);
    eval 'sub DDF_VUCR_SIGNATURE () {0x88888888;}' unless defined(&DDF_VUCR_SIGNATURE);
    eval 'sub DDF_SA_SIGNATURE () {0x55555555;}' unless defined(&DDF_SA_SIGNATURE);
    eval 'sub DDF_SAR_TYPE_DEDICATED () {(1<< 0);}' unless defined(&DDF_SAR_TYPE_DEDICATED);
    eval 'sub DDF_SAR_TYPE_REVERTIBLE () {(1<< 1);}' unless defined(&DDF_SAR_TYPE_REVERTIBLE);
    eval 'sub DDF_SAR_TYPE_ACTIVE () {(1<< 2);}' unless defined(&DDF_SAR_TYPE_ACTIVE);
    eval 'sub DDF_SAR_TYPE_ENCL_AFFINITY () {(1<< 3);}' unless defined(&DDF_SAR_TYPE_ENCL_AFFINITY);
    eval 'sub DDF_PDD_SIGNATURE () {0x33333333;}' unless defined(&DDF_PDD_SIGNATURE);
    eval 'sub DDF_PDD_FORCED_REF () {0x1;}' unless defined(&DDF_PDD_FORCED_REF);
    eval 'sub DDF_PDD_FORCED_GUID () {0x1;}' unless defined(&DDF_PDD_FORCED_GUID);
    eval 'sub DDF_BBML_SIGNATURE () {0xabadb10c;}' unless defined(&DDF_BBML_SIGNATURE);
    eval 'sub DDF_VENDOR_LOG_SIGNATURE () {0x1dbeef0;}' unless defined(&DDF_VENDOR_LOG_SIGNATURE);
}
1;
