require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PC_BIOS_H_)) {
    eval 'sub _MACHINE_PC_BIOS_H_ () {1;}' unless defined(&_MACHINE_PC_BIOS_H_);
    eval 'sub SMAP_SIG () {0x534d4150;}' unless defined(&SMAP_SIG);
    eval 'sub SMAP_TYPE_MEMORY () {1;}' unless defined(&SMAP_TYPE_MEMORY);
    eval 'sub SMAP_TYPE_RESERVED () {2;}' unless defined(&SMAP_TYPE_RESERVED);
    eval 'sub SMAP_TYPE_ACPI_RECLAIM () {3;}' unless defined(&SMAP_TYPE_ACPI_RECLAIM);
    eval 'sub SMAP_TYPE_ACPI_NVS () {4;}' unless defined(&SMAP_TYPE_ACPI_NVS);
    eval 'sub SMAP_TYPE_ACPI_ERROR () {5;}' unless defined(&SMAP_TYPE_ACPI_ERROR);
    eval 'sub SMAP_TYPE_DISABLED () {6;}' unless defined(&SMAP_TYPE_DISABLED);
    eval 'sub SMAP_TYPE_PMEM () {7;}' unless defined(&SMAP_TYPE_PMEM);
    eval 'sub SMAP_TYPE_PRAM () {12;}' unless defined(&SMAP_TYPE_PRAM);
    eval 'sub SMAP_XATTR_ENABLED () {0x1;}' unless defined(&SMAP_XATTR_ENABLED);
    eval 'sub SMAP_XATTR_NON_VOLATILE () {0x2;}' unless defined(&SMAP_XATTR_NON_VOLATILE);
    eval 'sub SMAP_XATTR_MASK () {( &SMAP_XATTR_ENABLED |  &SMAP_XATTR_NON_VOLATILE);}' unless defined(&SMAP_XATTR_MASK);
    eval 'sub SMBIOS_START () {0xf0000;}' unless defined(&SMBIOS_START);
    eval 'sub SMBIOS_STEP () {0x10;}' unless defined(&SMBIOS_STEP);
    eval 'sub SMBIOS_OFF () {0;}' unless defined(&SMBIOS_OFF);
    eval 'sub SMBIOS_LEN () {4;}' unless defined(&SMBIOS_LEN);
    eval 'sub SMBIOS_SIG () {"_SM_";}' unless defined(&SMBIOS_SIG);
    if(defined(&_KERNEL)) {
	eval 'sub BIOS_PADDRTOVADDR {
	    my($x) = @_;
    	    eval q((($x) +  &KERNBASE));
	}' unless defined(&BIOS_PADDRTOVADDR);
	eval 'sub BIOS_VADDRTOPADDR {
	    my($x) = @_;
    	    eval q((($x) -  &KERNBASE));
	}' unless defined(&BIOS_VADDRTOPADDR);
    }
}
1;
