require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_BPF_H_)) {
    eval 'sub _NET_BPF_H_ () {1;}' unless defined(&_NET_BPF_H_);
    eval 'sub BPF_RELEASE () {199606;}' unless defined(&BPF_RELEASE);
    eval 'sub BPF_ALIGNMENT () {$sizeof{\'long\'};}' unless defined(&BPF_ALIGNMENT);
    eval 'sub BPF_WORDALIGN {
        my($x) = @_;
	    eval q(((($x)+( &BPF_ALIGNMENT-1))&~( &BPF_ALIGNMENT-1)));
    }' unless defined(&BPF_WORDALIGN);
    eval 'sub BPF_MAXINSNS () {512;}' unless defined(&BPF_MAXINSNS);
    eval 'sub BPF_MAXBUFSIZE () {0x80000;}' unless defined(&BPF_MAXBUFSIZE);
    eval 'sub BPF_MINBUFSIZE () {32;}' unless defined(&BPF_MINBUFSIZE);
    eval 'sub BPF_MAJOR_VERSION () {1;}' unless defined(&BPF_MAJOR_VERSION);
    eval 'sub BPF_MINOR_VERSION () {1;}' unless defined(&BPF_MINOR_VERSION);
    eval 'sub BPF_BUFMODE_BUFFER () {1;}' unless defined(&BPF_BUFMODE_BUFFER);
    eval 'sub BPF_BUFMODE_ZBUF () {2;}' unless defined(&BPF_BUFMODE_ZBUF);
    eval 'sub BIOCGBLEN () { &_IOR(ord(\'B\'), 102, \'u_int\');}' unless defined(&BIOCGBLEN);
    eval 'sub BIOCSBLEN () { &_IOWR(ord(\'B\'), 102, \'u_int\');}' unless defined(&BIOCSBLEN);
    eval 'sub BIOCSETF () { &_IOW(ord(\'B\'), 103, \'struct bpf_program\');}' unless defined(&BIOCSETF);
    eval 'sub BIOCFLUSH () { &_IO(ord(\'B\'), 104);}' unless defined(&BIOCFLUSH);
    eval 'sub BIOCPROMISC () { &_IO(ord(\'B\'), 105);}' unless defined(&BIOCPROMISC);
    eval 'sub BIOCGDLT () { &_IOR(ord(\'B\'), 106, \'u_int\');}' unless defined(&BIOCGDLT);
    eval 'sub BIOCGETIF () { &_IOR(ord(\'B\'), 107, \'struct ifreq\');}' unless defined(&BIOCGETIF);
    eval 'sub BIOCSETIF () { &_IOW(ord(\'B\'), 108, \'struct ifreq\');}' unless defined(&BIOCSETIF);
    eval 'sub BIOCSRTIMEOUT () { &_IOW(ord(\'B\'), 109, \'struct timeval\');}' unless defined(&BIOCSRTIMEOUT);
    eval 'sub BIOCGRTIMEOUT () { &_IOR(ord(\'B\'), 110, \'struct timeval\');}' unless defined(&BIOCGRTIMEOUT);
    eval 'sub BIOCGSTATS () { &_IOR(ord(\'B\'), 111, \'struct bpf_stat\');}' unless defined(&BIOCGSTATS);
    eval 'sub BIOCIMMEDIATE () { &_IOW(ord(\'B\'), 112, \'u_int\');}' unless defined(&BIOCIMMEDIATE);
    eval 'sub BIOCVERSION () { &_IOR(ord(\'B\'), 113, \'struct bpf_version\');}' unless defined(&BIOCVERSION);
    eval 'sub BIOCGRSIG () { &_IOR(ord(\'B\'), 114, \'u_int\');}' unless defined(&BIOCGRSIG);
    eval 'sub BIOCSRSIG () { &_IOW(ord(\'B\'), 115, \'u_int\');}' unless defined(&BIOCSRSIG);
    eval 'sub BIOCGHDRCMPLT () { &_IOR(ord(\'B\'), 116, \'u_int\');}' unless defined(&BIOCGHDRCMPLT);
    eval 'sub BIOCSHDRCMPLT () { &_IOW(ord(\'B\'), 117, \'u_int\');}' unless defined(&BIOCSHDRCMPLT);
    eval 'sub BIOCGDIRECTION () { &_IOR(ord(\'B\'), 118, \'u_int\');}' unless defined(&BIOCGDIRECTION);
    eval 'sub BIOCSDIRECTION () { &_IOW(ord(\'B\'), 119, \'u_int\');}' unless defined(&BIOCSDIRECTION);
    eval 'sub BIOCSDLT () { &_IOW(ord(\'B\'), 120, \'u_int\');}' unless defined(&BIOCSDLT);
    eval 'sub BIOCGDLTLIST () { &_IOWR(ord(\'B\'), 121, \'struct bpf_dltlist\');}' unless defined(&BIOCGDLTLIST);
    eval 'sub BIOCLOCK () { &_IO(ord(\'B\'), 122);}' unless defined(&BIOCLOCK);
    eval 'sub BIOCSETWF () { &_IOW(ord(\'B\'), 123, \'struct bpf_program\');}' unless defined(&BIOCSETWF);
    eval 'sub BIOCFEEDBACK () { &_IOW(ord(\'B\'), 124, \'u_int\');}' unless defined(&BIOCFEEDBACK);
    eval 'sub BIOCGETBUFMODE () { &_IOR(ord(\'B\'), 125, \'u_int\');}' unless defined(&BIOCGETBUFMODE);
    eval 'sub BIOCSETBUFMODE () { &_IOW(ord(\'B\'), 126, \'u_int\');}' unless defined(&BIOCSETBUFMODE);
    eval 'sub BIOCGETZMAX () { &_IOR(ord(\'B\'), 127, \'size_t\');}' unless defined(&BIOCGETZMAX);
    eval 'sub BIOCROTZBUF () { &_IOR(ord(\'B\'), 128, \'struct bpf_zbuf\');}' unless defined(&BIOCROTZBUF);
    eval 'sub BIOCSETZBUF () { &_IOW(ord(\'B\'), 129, \'struct bpf_zbuf\');}' unless defined(&BIOCSETZBUF);
    eval 'sub BIOCSETFNR () { &_IOW(ord(\'B\'), 130, \'struct bpf_program\');}' unless defined(&BIOCSETFNR);
    eval 'sub BIOCGTSTAMP () { &_IOR(ord(\'B\'), 131, \'u_int\');}' unless defined(&BIOCGTSTAMP);
    eval 'sub BIOCSTSTAMP () { &_IOW(ord(\'B\'), 132, \'u_int\');}' unless defined(&BIOCSTSTAMP);
    eval 'sub BIOCGSEESENT () { &BIOCGDIRECTION;}' unless defined(&BIOCGSEESENT);
    eval 'sub BIOCSSEESENT () { &BIOCSDIRECTION;}' unless defined(&BIOCSSEESENT);
    eval("sub BPF_D_IN () { 0; }") unless defined(&BPF_D_IN);
    eval("sub BPF_D_INOUT () { 1; }") unless defined(&BPF_D_INOUT);
    eval("sub BPF_D_OUT () { 2; }") unless defined(&BPF_D_OUT);
    eval 'sub BPF_T_MICROTIME () {0x;}' unless defined(&BPF_T_MICROTIME);
    eval 'sub BPF_T_NANOTIME () {0x1;}' unless defined(&BPF_T_NANOTIME);
    eval 'sub BPF_T_BINTIME () {0x2;}' unless defined(&BPF_T_BINTIME);
    eval 'sub BPF_T_NONE () {0x3;}' unless defined(&BPF_T_NONE);
    eval 'sub BPF_T_FORMAT_MASK () {0x3;}' unless defined(&BPF_T_FORMAT_MASK);
    eval 'sub BPF_T_NORMAL () {0x;}' unless defined(&BPF_T_NORMAL);
    eval 'sub BPF_T_FAST () {0x100;}' unless defined(&BPF_T_FAST);
    eval 'sub BPF_T_MONOTONIC () {0x200;}' unless defined(&BPF_T_MONOTONIC);
    eval 'sub BPF_T_MONOTONIC_FAST () {( &BPF_T_FAST |  &BPF_T_MONOTONIC);}' unless defined(&BPF_T_MONOTONIC_FAST);
    eval 'sub BPF_T_FLAG_MASK () {0x300;}' unless defined(&BPF_T_FLAG_MASK);
    eval 'sub BPF_T_FORMAT {
        my($t) = @_;
	    eval q((($t) &  &BPF_T_FORMAT_MASK));
    }' unless defined(&BPF_T_FORMAT);
    eval 'sub BPF_T_FLAG {
        my($t) = @_;
	    eval q((($t) &  &BPF_T_FLAG_MASK));
    }' unless defined(&BPF_T_FLAG);
    eval 'sub BPF_T_VALID {
        my($t) = @_;
	    eval q((($t) ==  &BPF_T_NONE || ( &BPF_T_FORMAT($t) !=  &BPF_T_NONE  && (($t) & ~( &BPF_T_FORMAT_MASK |  &BPF_T_FLAG_MASK)) == 0)));
    }' unless defined(&BPF_T_VALID);
    eval 'sub BPF_T_MICROTIME_FAST () {( &BPF_T_MICROTIME |  &BPF_T_FAST);}' unless defined(&BPF_T_MICROTIME_FAST);
    eval 'sub BPF_T_NANOTIME_FAST () {( &BPF_T_NANOTIME |  &BPF_T_FAST);}' unless defined(&BPF_T_NANOTIME_FAST);
    eval 'sub BPF_T_BINTIME_FAST () {( &BPF_T_BINTIME |  &BPF_T_FAST);}' unless defined(&BPF_T_BINTIME_FAST);
    eval 'sub BPF_T_MICROTIME_MONOTONIC () {( &BPF_T_MICROTIME |  &BPF_T_MONOTONIC);}' unless defined(&BPF_T_MICROTIME_MONOTONIC);
    eval 'sub BPF_T_NANOTIME_MONOTONIC () {( &BPF_T_NANOTIME |  &BPF_T_MONOTONIC);}' unless defined(&BPF_T_NANOTIME_MONOTONIC);
    eval 'sub BPF_T_BINTIME_MONOTONIC () {( &BPF_T_BINTIME |  &BPF_T_MONOTONIC);}' unless defined(&BPF_T_BINTIME_MONOTONIC);
    eval 'sub BPF_T_MICROTIME_MONOTONIC_FAST () {( &BPF_T_MICROTIME |  &BPF_T_MONOTONIC_FAST);}' unless defined(&BPF_T_MICROTIME_MONOTONIC_FAST);
    eval 'sub BPF_T_NANOTIME_MONOTONIC_FAST () {( &BPF_T_NANOTIME |  &BPF_T_MONOTONIC_FAST);}' unless defined(&BPF_T_NANOTIME_MONOTONIC_FAST);
    eval 'sub BPF_T_BINTIME_MONOTONIC_FAST () {( &BPF_T_BINTIME |  &BPF_T_MONOTONIC_FAST);}' unless defined(&BPF_T_BINTIME_MONOTONIC_FAST);
    if(defined(&_KERNEL)) {
	eval 'sub MTAG_BPF () {0x627066;}' unless defined(&MTAG_BPF);
	eval 'sub MTAG_BPF_TIMESTAMP () {0;}' unless defined(&MTAG_BPF_TIMESTAMP);
    }
    require 'net/dlt.ph';
    eval 'sub BPF_CLASS {
        my($code) = @_;
	    eval q((($code) & 0x7));
    }' unless defined(&BPF_CLASS);
    eval 'sub BPF_LD () {0x;}' unless defined(&BPF_LD);
    eval 'sub BPF_LDX () {0x1;}' unless defined(&BPF_LDX);
    eval 'sub BPF_ST () {0x2;}' unless defined(&BPF_ST);
    eval 'sub BPF_STX () {0x3;}' unless defined(&BPF_STX);
    eval 'sub BPF_ALU () {0x4;}' unless defined(&BPF_ALU);
    eval 'sub BPF_JMP () {0x5;}' unless defined(&BPF_JMP);
    eval 'sub BPF_RET () {0x6;}' unless defined(&BPF_RET);
    eval 'sub BPF_MISC () {0x7;}' unless defined(&BPF_MISC);
    eval 'sub BPF_SIZE {
        my($code) = @_;
	    eval q((($code) & 0x18));
    }' unless defined(&BPF_SIZE);
    eval 'sub BPF_W () {0x;}' unless defined(&BPF_W);
    eval 'sub BPF_H () {0x8;}' unless defined(&BPF_H);
    eval 'sub BPF_B () {0x10;}' unless defined(&BPF_B);
    eval 'sub BPF_MODE {
        my($code) = @_;
	    eval q((($code) & 0xe0));
    }' unless defined(&BPF_MODE);
    eval 'sub BPF_IMM () {0x;}' unless defined(&BPF_IMM);
    eval 'sub BPF_ABS () {0x20;}' unless defined(&BPF_ABS);
    eval 'sub BPF_IND () {0x40;}' unless defined(&BPF_IND);
    eval 'sub BPF_MEM () {0x60;}' unless defined(&BPF_MEM);
    eval 'sub BPF_LEN () {0x80;}' unless defined(&BPF_LEN);
    eval 'sub BPF_MSH () {0xa0;}' unless defined(&BPF_MSH);
    eval 'sub BPF_OP {
        my($code) = @_;
	    eval q((($code) & 0xf0));
    }' unless defined(&BPF_OP);
    eval 'sub BPF_ADD () {0x;}' unless defined(&BPF_ADD);
    eval 'sub BPF_SUB () {0x10;}' unless defined(&BPF_SUB);
    eval 'sub BPF_MUL () {0x20;}' unless defined(&BPF_MUL);
    eval 'sub BPF_DIV () {0x30;}' unless defined(&BPF_DIV);
    eval 'sub BPF_OR () {0x40;}' unless defined(&BPF_OR);
    eval 'sub BPF_AND () {0x50;}' unless defined(&BPF_AND);
    eval 'sub BPF_LSH () {0x60;}' unless defined(&BPF_LSH);
    eval 'sub BPF_RSH () {0x70;}' unless defined(&BPF_RSH);
    eval 'sub BPF_NEG () {0x80;}' unless defined(&BPF_NEG);
    eval 'sub BPF_MOD () {0x90;}' unless defined(&BPF_MOD);
    eval 'sub BPF_XOR () {0xa0;}' unless defined(&BPF_XOR);
    eval 'sub BPF_JA () {0x;}' unless defined(&BPF_JA);
    eval 'sub BPF_JEQ () {0x10;}' unless defined(&BPF_JEQ);
    eval 'sub BPF_JGT () {0x20;}' unless defined(&BPF_JGT);
    eval 'sub BPF_JGE () {0x30;}' unless defined(&BPF_JGE);
    eval 'sub BPF_JSET () {0x40;}' unless defined(&BPF_JSET);
    eval 'sub BPF_SRC {
        my($code) = @_;
	    eval q((($code) & 0x8));
    }' unless defined(&BPF_SRC);
    eval 'sub BPF_K () {0x;}' unless defined(&BPF_K);
    eval 'sub BPF_X () {0x8;}' unless defined(&BPF_X);
    eval 'sub BPF_RVAL {
        my($code) = @_;
	    eval q((($code) & 0x18));
    }' unless defined(&BPF_RVAL);
    eval 'sub BPF_A () {0x10;}' unless defined(&BPF_A);
    eval 'sub BPF_MISCOP {
        my($code) = @_;
	    eval q((($code) & 0xf8));
    }' unless defined(&BPF_MISCOP);
    eval 'sub BPF_TAX () {0x;}' unless defined(&BPF_TAX);
    eval 'sub BPF_TXA () {0x80;}' unless defined(&BPF_TXA);
    eval 'sub BPF_STMT {
        my($code, $k) = @_;
	    eval q({ ($code), 0, 0, $k });
    }' unless defined(&BPF_STMT);
    eval 'sub BPF_JUMP {
        my($code, $k, $jt, $jf) = @_;
	    eval q({ ($code), $jt, $jf, $k });
    }' unless defined(&BPF_JUMP);
    if(defined(&_KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
	if(defined(&SYSCTL_DECL)) {
	}
	eval 'sub ROTATE_BUFFERS {
	    my($d) = @_;
    	    eval q( &do { ($d)-> &bd_hbuf = ($d)-> &bd_sbuf; ($d)-> &bd_hlen = ($d)-> &bd_slen; ($d)-> &bd_sbuf = ($d)-> &bd_fbuf; ($d)-> &bd_slen = 0; ($d)-> &bd_fbuf =  &NULL;  &bpf_bufheld($d); }  &while (0));
	}' unless defined(&ROTATE_BUFFERS);
	if(defined(&VIMAGE)) {
	}
	eval 'sub bpf_peers_present {
	    my($bpf) = @_;
    	    eval q({ \'struct bpf_if_ext\' * &ext;  &ext = $bpf;  &if (! &LIST_EMPTY( ($ext->{bif_dlist}))) (1); (0); });
	}' unless defined(&bpf_peers_present);
	eval 'sub BPF_TAP {
	    my($_ifp,$_pkt,$_pktlen) = @_;
    	    eval q( &do {  &if ( &bpf_peers_present(($_ifp)-> &if_bpf))  &bpf_tap(($_ifp)-> &if_bpf, ($_pkt), ($_pktlen)); }  &while (0));
	}' unless defined(&BPF_TAP);
	eval 'sub BPF_MTAP {
	    my($_ifp,$_m) = @_;
    	    eval q( &do {  &if ( &bpf_peers_present(($_ifp)-> &if_bpf)) {  &M_ASSERTVALID($_m);  &bpf_mtap(($_ifp)-> &if_bpf, ($_m)); } }  &while (0));
	}' unless defined(&BPF_MTAP);
	eval 'sub BPF_MTAP2 {
	    my($_ifp,$_data,$_dlen,$_m) = @_;
    	    eval q( &do {  &if ( &bpf_peers_present(($_ifp)-> &if_bpf)) {  &M_ASSERTVALID($_m);  &bpf_mtap2(($_ifp)-> &if_bpf,($_data),($_dlen),($_m)); } }  &while (0));
	}' unless defined(&BPF_MTAP2);
    }
    eval 'sub BPF_MEMWORDS () {16;}' unless defined(&BPF_MEMWORDS);
    if(defined(&_SYS_EVENTHANDLER_H_)) {
    }
}
1;
