require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/callout.ph';
require 'sys/queue.ph';
eval 'sub BSTP_IFSTATE_DISABLED () {0;}' unless defined(&BSTP_IFSTATE_DISABLED);
eval 'sub BSTP_IFSTATE_LISTENING () {1;}' unless defined(&BSTP_IFSTATE_LISTENING);
eval 'sub BSTP_IFSTATE_LEARNING () {2;}' unless defined(&BSTP_IFSTATE_LEARNING);
eval 'sub BSTP_IFSTATE_FORWARDING () {3;}' unless defined(&BSTP_IFSTATE_FORWARDING);
eval 'sub BSTP_IFSTATE_BLOCKING () {4;}' unless defined(&BSTP_IFSTATE_BLOCKING);
eval 'sub BSTP_IFSTATE_DISCARDING () {5;}' unless defined(&BSTP_IFSTATE_DISCARDING);
eval 'sub BSTP_TCSTATE_ACTIVE () {1;}' unless defined(&BSTP_TCSTATE_ACTIVE);
eval 'sub BSTP_TCSTATE_DETECTED () {2;}' unless defined(&BSTP_TCSTATE_DETECTED);
eval 'sub BSTP_TCSTATE_INACTIVE () {3;}' unless defined(&BSTP_TCSTATE_INACTIVE);
eval 'sub BSTP_TCSTATE_LEARNING () {4;}' unless defined(&BSTP_TCSTATE_LEARNING);
eval 'sub BSTP_TCSTATE_PROPAG () {5;}' unless defined(&BSTP_TCSTATE_PROPAG);
eval 'sub BSTP_TCSTATE_ACK () {6;}' unless defined(&BSTP_TCSTATE_ACK);
eval 'sub BSTP_TCSTATE_TC () {7;}' unless defined(&BSTP_TCSTATE_TC);
eval 'sub BSTP_TCSTATE_TCN () {8;}' unless defined(&BSTP_TCSTATE_TCN);
eval 'sub BSTP_ROLE_DISABLED () {0;}' unless defined(&BSTP_ROLE_DISABLED);
eval 'sub BSTP_ROLE_ROOT () {1;}' unless defined(&BSTP_ROLE_ROOT);
eval 'sub BSTP_ROLE_DESIGNATED () {2;}' unless defined(&BSTP_ROLE_DESIGNATED);
eval 'sub BSTP_ROLE_ALTERNATE () {3;}' unless defined(&BSTP_ROLE_ALTERNATE);
eval 'sub BSTP_ROLE_BACKUP () {4;}' unless defined(&BSTP_ROLE_BACKUP);
if(defined(&_KERNEL)) {
    eval 'sub BSTP_PORT_CANMIGRATE () {0x1;}' unless defined(&BSTP_PORT_CANMIGRATE);
    eval 'sub BSTP_PORT_NEWINFO () {0x2;}' unless defined(&BSTP_PORT_NEWINFO);
    eval 'sub BSTP_PORT_DISPUTED () {0x4;}' unless defined(&BSTP_PORT_DISPUTED);
    eval 'sub BSTP_PORT_ADMCOST () {0x8;}' unless defined(&BSTP_PORT_ADMCOST);
    eval 'sub BSTP_PORT_AUTOEDGE () {0x10;}' unless defined(&BSTP_PORT_AUTOEDGE);
    eval 'sub BSTP_PORT_AUTOPTP () {0x20;}' unless defined(&BSTP_PORT_AUTOPTP);
    eval 'sub BSTP_PORT_ADMEDGE () {0x40;}' unless defined(&BSTP_PORT_ADMEDGE);
    eval 'sub BSTP_PORT_PNDCOST () {0x80;}' unless defined(&BSTP_PORT_PNDCOST);
    eval 'sub BSTP_PDU_SUPERIOR () {1;}' unless defined(&BSTP_PDU_SUPERIOR);
    eval 'sub BSTP_PDU_REPEATED () {2;}' unless defined(&BSTP_PDU_REPEATED);
    eval 'sub BSTP_PDU_INFERIOR () {3;}' unless defined(&BSTP_PDU_INFERIOR);
    eval 'sub BSTP_PDU_INFERIORALT () {4;}' unless defined(&BSTP_PDU_INFERIORALT);
    eval 'sub BSTP_PDU_OTHER () {5;}' unless defined(&BSTP_PDU_OTHER);
    eval 'sub BSTP_PDU_PRMASK () {0xc;}' unless defined(&BSTP_PDU_PRMASK);
    eval 'sub BSTP_PDU_PRSHIFT () {2;}' unless defined(&BSTP_PDU_PRSHIFT);
    eval 'sub BSTP_PDU_F_UNKN () {0x;}' unless defined(&BSTP_PDU_F_UNKN);
    eval 'sub BSTP_PDU_F_ALT () {0x1;}' unless defined(&BSTP_PDU_F_ALT);
    eval 'sub BSTP_PDU_F_ROOT () {0x2;}' unless defined(&BSTP_PDU_F_ROOT);
    eval 'sub BSTP_PDU_F_DESG () {0x3;}' unless defined(&BSTP_PDU_F_DESG);
    eval 'sub BSTP_PDU_STPMASK () {0x81;}' unless defined(&BSTP_PDU_STPMASK);
    eval 'sub BSTP_PDU_RSTPMASK () {0x7f;}' unless defined(&BSTP_PDU_RSTPMASK);
    eval 'sub BSTP_PDU_F_TC () {0x1;}' unless defined(&BSTP_PDU_F_TC);
    eval 'sub BSTP_PDU_F_P () {0x2;}' unless defined(&BSTP_PDU_F_P);
    eval 'sub BSTP_PDU_F_L () {0x10;}' unless defined(&BSTP_PDU_F_L);
    eval 'sub BSTP_PDU_F_F () {0x20;}' unless defined(&BSTP_PDU_F_F);
    eval 'sub BSTP_PDU_F_A () {0x40;}' unless defined(&BSTP_PDU_F_A);
    eval 'sub BSTP_PDU_F_TCA () {0x80;}' unless defined(&BSTP_PDU_F_TCA);
    eval 'sub BSTP_DEFAULT_MAX_AGE () {(20* 256);}' unless defined(&BSTP_DEFAULT_MAX_AGE);
    eval 'sub BSTP_DEFAULT_HELLO_TIME () {(2* 256);}' unless defined(&BSTP_DEFAULT_HELLO_TIME);
    eval 'sub BSTP_DEFAULT_FORWARD_DELAY () {(15* 256);}' unless defined(&BSTP_DEFAULT_FORWARD_DELAY);
    eval 'sub BSTP_DEFAULT_HOLD_TIME () {(1* 256);}' unless defined(&BSTP_DEFAULT_HOLD_TIME);
    eval 'sub BSTP_DEFAULT_MIGRATE_DELAY () {(3* 256);}' unless defined(&BSTP_DEFAULT_MIGRATE_DELAY);
    eval 'sub BSTP_DEFAULT_HOLD_COUNT () {6;}' unless defined(&BSTP_DEFAULT_HOLD_COUNT);
    eval 'sub BSTP_DEFAULT_BRIDGE_PRIORITY () {0x8000;}' unless defined(&BSTP_DEFAULT_BRIDGE_PRIORITY);
    eval 'sub BSTP_DEFAULT_PORT_PRIORITY () {0x80;}' unless defined(&BSTP_DEFAULT_PORT_PRIORITY);
    eval 'sub BSTP_DEFAULT_PATH_COST () {55;}' unless defined(&BSTP_DEFAULT_PATH_COST);
    eval 'sub BSTP_MIN_HELLO_TIME () {(1* 256);}' unless defined(&BSTP_MIN_HELLO_TIME);
    eval 'sub BSTP_MIN_MAX_AGE () {(6* 256);}' unless defined(&BSTP_MIN_MAX_AGE);
    eval 'sub BSTP_MIN_FORWARD_DELAY () {(4* 256);}' unless defined(&BSTP_MIN_FORWARD_DELAY);
    eval 'sub BSTP_MIN_HOLD_COUNT () {1;}' unless defined(&BSTP_MIN_HOLD_COUNT);
    eval 'sub BSTP_MAX_HELLO_TIME () {(2* 256);}' unless defined(&BSTP_MAX_HELLO_TIME);
    eval 'sub BSTP_MAX_MAX_AGE () {(40* 256);}' unless defined(&BSTP_MAX_MAX_AGE);
    eval 'sub BSTP_MAX_FORWARD_DELAY () {(30* 256);}' unless defined(&BSTP_MAX_FORWARD_DELAY);
    eval 'sub BSTP_MAX_HOLD_COUNT () {10;}' unless defined(&BSTP_MAX_HOLD_COUNT);
    eval 'sub BSTP_MAX_PRIORITY () {61440;}' unless defined(&BSTP_MAX_PRIORITY);
    eval 'sub BSTP_MAX_PORT_PRIORITY () {240;}' unless defined(&BSTP_MAX_PORT_PRIORITY);
    eval 'sub BSTP_MAX_PATH_COST () {200000000;}' unless defined(&BSTP_MAX_PATH_COST);
    eval 'sub BSTP_MSGTYPE_CFG () {0x;}' unless defined(&BSTP_MSGTYPE_CFG);
    eval 'sub BSTP_MSGTYPE_RSTP () {0x2;}' unless defined(&BSTP_MSGTYPE_RSTP);
    eval 'sub BSTP_MSGTYPE_TCN () {0x80;}' unless defined(&BSTP_MSGTYPE_TCN);
    eval 'sub BSTP_PROTO_ID () {0x;}' unless defined(&BSTP_PROTO_ID);
    eval 'sub BSTP_PROTO_STP () {0x;}' unless defined(&BSTP_PROTO_STP);
    eval 'sub BSTP_PROTO_RSTP () {0x2;}' unless defined(&BSTP_PROTO_RSTP);
    eval 'sub BSTP_PROTO_MAX () { &BSTP_PROTO_RSTP;}' unless defined(&BSTP_PROTO_MAX);
    eval 'sub BSTP_INFO_RECEIVED () {1;}' unless defined(&BSTP_INFO_RECEIVED);
    eval 'sub BSTP_INFO_MINE () {2;}' unless defined(&BSTP_INFO_MINE);
    eval 'sub BSTP_INFO_AGED () {3;}' unless defined(&BSTP_INFO_AGED);
    eval 'sub BSTP_INFO_DISABLED () {4;}' unless defined(&BSTP_INFO_DISABLED);
    eval 'sub BSTP_MESSAGE_AGE_INCR () {(1* 256);}' unless defined(&BSTP_MESSAGE_AGE_INCR);
    eval 'sub BSTP_TICK_VAL () {(1* 256);}' unless defined(&BSTP_TICK_VAL);
    eval 'sub BSTP_LINK_TIMER () {( &BSTP_TICK_VAL * 15);}' unless defined(&BSTP_LINK_TIMER);
    eval 'sub BSTP_BPDU_STP_LEN () {(3+ 35);}' unless defined(&BSTP_BPDU_STP_LEN);
    eval 'sub BSTP_BPDU_RSTP_LEN () {(3+ 36);}' unless defined(&BSTP_BPDU_RSTP_LEN);
    eval 'sub BSTP_LOCK_INIT {
        my($_bs) = @_;
	    eval q( &mtx_init(($_bs)-> &bs_mtx, \\"bstp\\",  &NULL,  &MTX_DEF));
    }' unless defined(&BSTP_LOCK_INIT);
    eval 'sub BSTP_LOCK_DESTROY {
        my($_bs) = @_;
	    eval q( &mtx_destroy(($_bs)-> &bs_mtx));
    }' unless defined(&BSTP_LOCK_DESTROY);
    eval 'sub BSTP_LOCK {
        my($_bs) = @_;
	    eval q( &mtx_lock(($_bs)-> &bs_mtx));
    }' unless defined(&BSTP_LOCK);
    eval 'sub BSTP_UNLOCK {
        my($_bs) = @_;
	    eval q( &mtx_unlock(($_bs)-> &bs_mtx));
    }' unless defined(&BSTP_UNLOCK);
    eval 'sub BSTP_LOCK_ASSERT {
        my($_bs) = @_;
	    eval q( &mtx_assert(($_bs)-> &bs_mtx,  &MA_OWNED));
    }' unless defined(&BSTP_LOCK_ASSERT);
}
1;
