require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_IF_GIF_H_)) {
    eval 'sub _NET_IF_GIF_H_ () {1;}' unless defined(&_NET_IF_GIF_H_);
    if(defined(&_KERNEL)) {
	require './net/opt_inet.ph';
	require './net/opt_inet6.ph';
	require 'netinet/in.ph';
	if(defined(&INET6)) {
	}
	eval 'sub GIF2IFP {
	    my($sc) = @_;
    	    eval q((($sc)-> &gif_ifp));
	}' unless defined(&GIF2IFP);
	eval 'sub GIF_LOCK_INIT {
	    my($sc) = @_;
    	    eval q( &rm_init(($sc)-> &gif_lock, \\"gif softc\\"));
	}' unless defined(&GIF_LOCK_INIT);
	eval 'sub GIF_LOCK_DESTROY {
	    my($sc) = @_;
    	    eval q( &rm_destroy(($sc)-> &gif_lock));
	}' unless defined(&GIF_LOCK_DESTROY);
	eval 'sub GIF_RLOCK_TRACKER () {\'struct rm_priotracker\'  &gif_tracker;}' unless defined(&GIF_RLOCK_TRACKER);
	eval 'sub GIF_RLOCK {
	    my($sc) = @_;
    	    eval q( &rm_rlock(($sc)-> &gif_lock,  &gif_tracker));
	}' unless defined(&GIF_RLOCK);
	eval 'sub GIF_RUNLOCK {
	    my($sc) = @_;
    	    eval q( &rm_runlock(($sc)-> &gif_lock,  &gif_tracker));
	}' unless defined(&GIF_RUNLOCK);
	eval 'sub GIF_RLOCK_ASSERT {
	    my($sc) = @_;
    	    eval q( &rm_assert(($sc)-> &gif_lock,  &RA_RLOCKED));
	}' unless defined(&GIF_RLOCK_ASSERT);
	eval 'sub GIF_WLOCK {
	    my($sc) = @_;
    	    eval q( &rm_wlock(($sc)-> &gif_lock));
	}' unless defined(&GIF_WLOCK);
	eval 'sub GIF_WUNLOCK {
	    my($sc) = @_;
    	    eval q( &rm_wunlock(($sc)-> &gif_lock));
	}' unless defined(&GIF_WUNLOCK);
	eval 'sub GIF_WLOCK_ASSERT {
	    my($sc) = @_;
    	    eval q( &rm_assert(($sc)-> &gif_lock,  &RA_WLOCKED));
	}' unless defined(&GIF_WLOCK_ASSERT);
	eval 'sub gif_iphdr () { ($gif_uhdr->{iphdr});}' unless defined(&gif_iphdr);
	eval 'sub gif_hdr () { ($gif_uhdr->{hdr});}' unless defined(&gif_hdr);
	if(defined(&INET6)) {
	    eval 'sub gif_ip6hdr () { ($gif_uhdr->{ip6hdr});}' unless defined(&gif_ip6hdr);
	}
	eval 'sub GIF_MTU () {(1280);}' unless defined(&GIF_MTU);
	eval 'sub GIF_MTU_MIN () {(1280);}' unless defined(&GIF_MTU_MIN);
	eval 'sub GIF_MTU_MAX () {(8192);}' unless defined(&GIF_MTU_MAX);
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&LITTLE_ENDIAN) ? &LITTLE_ENDIAN : undef)) {
	}
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
	}
	eval 'sub ETHERIP_VERSION () {0x3;}' unless defined(&ETHERIP_VERSION);
	eval 'sub ETHERIP_ALIGN () {2;}' unless defined(&ETHERIP_ALIGN);
	if(defined(&INET)) {
	}
	if(defined(&INET6)) {
	}
    }
    eval 'sub GIFGOPTS () { &_IOWR(ord(\'i\'), 150, \'struct ifreq\');}' unless defined(&GIFGOPTS);
    eval 'sub GIFSOPTS () { &_IOW(ord(\'i\'), 151, \'struct ifreq\');}' unless defined(&GIFSOPTS);
    eval 'sub GIF_IGNORE_SOURCE () {0x2;}' unless defined(&GIF_IGNORE_SOURCE);
    eval 'sub GIF_OPTMASK () {( &GIF_IGNORE_SOURCE);}' unless defined(&GIF_OPTMASK);
}
1;
