require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_ISO88025_H_)) {
    eval 'sub _NET_ISO88025_H_ () {1;}' unless defined(&_NET_ISO88025_H_);
    eval 'sub ISO88025_ADDR_LEN () {6;}' unless defined(&ISO88025_ADDR_LEN);
    eval 'sub ISO88025_CF_LEN () {2;}' unless defined(&ISO88025_CF_LEN);
    eval 'sub ISO88025_HDR_LEN () {( &ISO88025_CF_LEN + ( &ISO88025_ADDR_LEN * 2));}' unless defined(&ISO88025_HDR_LEN);
    eval 'sub RCF_LEN () {2;}' unless defined(&RCF_LEN);
    eval 'sub RIF_MAX_RD () {14;}' unless defined(&RIF_MAX_RD);
    eval 'sub RIF_MAX_LEN () {16;}' unless defined(&RIF_MAX_LEN);
    eval 'sub TR_AC () {0x10;}' unless defined(&TR_AC);
    eval 'sub TR_LLC_FRAME () {0x40;}' unless defined(&TR_LLC_FRAME);
    eval 'sub TR_4MBPS () {4000000;}' unless defined(&TR_4MBPS);
    eval 'sub TR_16MBPS () {16000000;}' unless defined(&TR_16MBPS);
    eval 'sub TR_100MBPS () {100000000;}' unless defined(&TR_100MBPS);
    eval 'sub TR_RII () {0x80;}' unless defined(&TR_RII);
    eval 'sub TR_RCF_BCST_MASK () {0xe000;}' unless defined(&TR_RCF_BCST_MASK);
    eval 'sub TR_RCF_LEN_MASK () {0x1f00;}' unless defined(&TR_RCF_LEN_MASK);
    eval 'sub TR_RCF_DIR () {0x80;}' unless defined(&TR_RCF_DIR);
    eval 'sub TR_RCF_LF_MASK () {0x70;}' unless defined(&TR_RCF_LF_MASK);
    eval 'sub TR_RCF_RIFLEN {
        my($x) = @_;
	    eval q((( &ntohs($x) &  &TR_RCF_LEN_MASK) >> 8));
    }' unless defined(&TR_RCF_RIFLEN);
    eval 'sub ISO88025_MIN_LEN () {0;}' unless defined(&ISO88025_MIN_LEN);
    eval 'sub ISO88025_MAX_LEN_4 () {4464;}' unless defined(&ISO88025_MAX_LEN_4);
    eval 'sub ISO88025_MAX_LEN_16 () {17960;}' unless defined(&ISO88025_MAX_LEN_16);
    eval 'sub ISO88025_MAX_LEN () { &ISO88025_MAX_LEN_16;}' unless defined(&ISO88025_MAX_LEN);
    eval 'sub ISO88025_IS_VALID_LEN {
        my($foo) = @_;
	    eval q((($foo) >=  &ISO88025_MIN_LEN  && ($foo) <=  &ISO88025_MAX_LEN));
    }' unless defined(&ISO88025_IS_VALID_LEN);
    eval 'sub AC_PRI_MASK () {0xe0;}' unless defined(&AC_PRI_MASK);
    eval 'sub AC_TOKEN () {0x10;}' unless defined(&AC_TOKEN);
    eval 'sub AC_MONITOR () {0x8;}' unless defined(&AC_MONITOR);
    eval 'sub AC_RESV_MASK () {0x7;}' unless defined(&AC_RESV_MASK);
    eval 'sub FC_FT_MASK () {0xc0;}' unless defined(&FC_FT_MASK);
    eval 'sub FC_FT_MAC () {0x;}' unless defined(&FC_FT_MAC);
    eval 'sub FC_FT_LLC () {0x40;}' unless defined(&FC_FT_LLC);
    eval 'sub FC_ATTN_MASK () {0xf;}' unless defined(&FC_ATTN_MASK);
    eval 'sub FC_ATTN_EB () {0x1;}' unless defined(&FC_ATTN_EB);
    eval 'sub FC_ATTN_BE () {0x2;}' unless defined(&FC_ATTN_BE);
    eval 'sub FC_ATTN_CT () {0x3;}' unless defined(&FC_ATTN_CT);
    eval 'sub FC_ATTN_RP () {0x4;}' unless defined(&FC_ATTN_RP);
    eval 'sub FC_ATTN_AMP () {0x5;}' unless defined(&FC_ATTN_AMP);
    eval 'sub FC_ATTN_SMP () {0x6;}' unless defined(&FC_ATTN_SMP);
    eval 'sub DA_IG () {0x80;}' unless defined(&DA_IG);
    eval 'sub DA_UL () {0x40;}' unless defined(&DA_UL);
    eval 'sub SA_RII () {0x80;}' unless defined(&SA_RII);
    eval 'sub SA_IG () {0x40;}' unless defined(&SA_IG);
    eval 'sub ISO88025_MAX {
        my($a, $b) = @_;
	    eval q(((($a)>($b))?($a):($b)));
    }' unless defined(&ISO88025_MAX);
    eval 'sub SDL_ISO88025 {
        my($s) = @_;
	    eval q(( (($s)-> &sdl_data +  &ISO88025_MAX(($s)-> &sdl_nlen + ($s)-> &sdl_alen + ($s)-> &sdl_slen, 12))));
    }' unless defined(&SDL_ISO88025);
    eval 'sub ISO88025_MAX_MTU () {18000;}' unless defined(&ISO88025_MAX_MTU);
    eval 'sub ISO88025_DEFAULT_MTU () {1500;}' unless defined(&ISO88025_DEFAULT_MTU);
    eval 'sub ISO88025_BPF_UNSUPPORTED () {0;}' unless defined(&ISO88025_BPF_UNSUPPORTED);
    eval 'sub ISO88025_BPF_SUPPORTED () {1;}' unless defined(&ISO88025_BPF_SUPPORTED);
    if(defined(&_KERNEL)) {
    }
}
1;
