require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_NETMAP_USER_H_)) {
    eval 'sub _NET_NETMAP_USER_H_ () {1;}' unless defined(&_NET_NETMAP_USER_H_);
    require 'stdint.ph';
    require 'sys/socket.ph';
    require 'net/if.ph';
    unless(defined(&likely)) {
	eval 'sub likely {
	    my($x) = @_;
    	    eval q( &__builtin_expect(!!($x), 1));
	}' unless defined(&likely);
	eval 'sub unlikely {
	    my($x) = @_;
    	    eval q( &__builtin_expect(!!($x), 0));
	}' unless defined(&unlikely);
    }
    require 'net/netmap.ph';
    eval 'sub _NETMAP_OFFSET {
        my($type, $ptr, $offset) = @_;
	    eval q((($type)( &void *)(($ptr) + ($offset))));
    }' unless defined(&_NETMAP_OFFSET);
    eval 'sub NETMAP_IF {
        my($_base, $_ofs) = @_;
	    eval q( &_NETMAP_OFFSET(\'struct netmap_if\' *, $_base, $_ofs));
    }' unless defined(&NETMAP_IF);
    eval 'sub NETMAP_TXRING {
        my($nifp, $index) = @_;
	    eval q( &_NETMAP_OFFSET(\'struct netmap_ring\' *, $nifp, ($nifp)-> $ring_ofs[$index] ));
    }' unless defined(&NETMAP_TXRING);
    eval 'sub NETMAP_RXRING {
        my($nifp, $index) = @_;
	    eval q( &_NETMAP_OFFSET(\'struct netmap_ring\' *, $nifp, ($nifp)-> $ring_ofs[$index + ($nifp)-> &ni_tx_rings + 1] ));
    }' unless defined(&NETMAP_RXRING);
    eval 'sub NETMAP_BUF {
        my($ring, $index) = @_;
	    eval q((($ring) + ($ring)-> &buf_ofs + (($index)*($ring)-> &nr_buf_size)));
    }' unless defined(&NETMAP_BUF);
    eval 'sub NETMAP_BUF_IDX {
        my($ring, $buf) = @_;
	    eval q(( ( - (($ring) + ($ring)-> &buf_ofs) ) / ($ring)-> &nr_buf_size ));
    }' unless defined(&NETMAP_BUF_IDX);
    eval 'sub nm_ring_next {
        my($r,$i) = @_;
	    eval q({ (  &unlikely($i + 1==  ($r->{num_slots})) ? 0: $i + 1); });
    }' unless defined(&nm_ring_next);
    eval 'sub nm_ring_space {
        my($ring) = @_;
	    eval q({ \'int\'  &ret =  ($ring->{tail}) -  ($ring->{cur});  &if ( &ret < 0)  &ret +=  ($ring->{num_slots});  &ret; });
    }' unless defined(&nm_ring_space);
    if(defined(&NETMAP_WITH_LIBS)) {
	unless(defined(&HAVE_NETMAP_WITH_LIBS)) {
	    eval 'sub HAVE_NETMAP_WITH_LIBS () {1;}' unless defined(&HAVE_NETMAP_WITH_LIBS);
	    require 'stdio.ph';
	    require 'sys/time.ph';
	    require 'sys/mman.ph';
	    require 'string.ph';
	    require 'sys/ioctl.ph';
	    require 'sys/errno.ph';
	    require 'fcntl.ph';
	    require 'unistd.ph';
	    require 'signal.ph';
	    require 'stdlib.ph';
	    unless(defined(&ND)) {
		eval 'sub ND () {( &_fmt, ...)  &do {}  &while(0);}' unless defined(&ND);
		eval 'sub D () {( &_fmt, ...)  &do { \'struct timeval\'  &_t0;  &gettimeofday(& &_t0,  &NULL);  &fprintf( &stderr, "%03d.%06d %s [%d] "  &_fmt "\\n", ( ($_t0->{tv_sec}) % 1000),  ($_t0->{tv_usec}),  &__FUNCTION__,  &__LINE__,  &__VA_ARGS__); }  &while (0);}' unless defined(&D);
		eval 'sub RD () {( &lps,  &format, ...)  &do {  &static \'int\'  &__t0,  &__cnt; \'struct timeval\'  &__xxts;  &gettimeofday(& &__xxts,  &NULL);  &if ( &__t0 !=  ($__xxts->{tv_sec})) {  &__t0 =  ($__xxts->{tv_sec});  &__cnt = 0; }  &if ( &__cnt++ <  &lps) {  &D( &format,  &__VA_ARGS__); } }  &while (0);}' unless defined(&RD);
	    }
	    if(defined(&WIN32)) {
	    }
	    eval 'sub NM_ERRBUF_SIZE () {512;}' unless defined(&NM_ERRBUF_SIZE);
	    eval 'sub P2NMD {
	        my($p) = @_;
    		eval q((($p)));
	    }' unless defined(&P2NMD);
	    eval 'sub IS_NETMAP_DESC {
	        my($d) = @_;
    		eval q((($d)  &&  &P2NMD($d)-> &self ==  &P2NMD($d)));
	    }' unless defined(&IS_NETMAP_DESC);
	    eval 'sub NETMAP_FD {
	        my($d) = @_;
    		eval q(( &P2NMD($d)-> &fd));
	    }' unless defined(&NETMAP_FD);
	    eval("sub NM_OPEN_NO_MMAP () { 0x040000; }") unless defined(&NM_OPEN_NO_MMAP);
	    eval("sub NM_OPEN_IFNAME () { 0x080000; }") unless defined(&NM_OPEN_IFNAME);
	    eval("sub NM_OPEN_ARG1 () { 0x100000; }") unless defined(&NM_OPEN_ARG1);
	    eval("sub NM_OPEN_ARG2 () { 0x200000; }") unless defined(&NM_OPEN_ARG2);
	    eval("sub NM_OPEN_ARG3 () { 0x400000; }") unless defined(&NM_OPEN_ARG3);
	    eval("sub NM_OPEN_RING_CFG () { 0x800000; }") unless defined(&NM_OPEN_RING_CFG);
	    eval 'sub MAXERRMSG () {80;}' unless defined(&MAXERRMSG);
	    eval("sub P_START () { 0; }") unless defined(&P_START);
	    eval("sub P_RNGSFXOK () { 1; }") unless defined(&P_RNGSFXOK);
	    eval("sub P_GETNUM () { 2; }") unless defined(&P_GETNUM);
	    eval("sub P_FLAGS () { 3; }") unless defined(&P_FLAGS);
	    eval("sub P_FLAGSOK () { 4; }") unless defined(&P_FLAGSOK);
	    if(defined(&DEBUG_NETMAP_USER)) {
	    }
	}
    }
}
1;
