require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_RADIX_H_)) {
    eval 'sub _RADIX_H_ () {1;}' unless defined(&_RADIX_H_);
    if(defined(&_KERNEL)) {
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
	require 'sys/_rwlock.ph';
    }
    if(defined(&MALLOC_DECLARE)) {
    }
    eval 'sub RNF_NORMAL () {1;}' unless defined(&RNF_NORMAL);
    eval 'sub RNF_ROOT () {2;}' unless defined(&RNF_ROOT);
    eval 'sub RNF_ACTIVE () {4;}' unless defined(&RNF_ACTIVE);
    if(defined(&RN_DEBUG)) {
    }
    eval 'sub rn_dupedkey () { ($rn_u->{rn_leaf}->{rn_Dupedkey});}' unless defined(&rn_dupedkey);
    eval 'sub rn_key () { ($rn_u->{rn_leaf}->{rn_Key});}' unless defined(&rn_key);
    eval 'sub rn_mask () { ($rn_u->{rn_leaf}->{rn_Mask});}' unless defined(&rn_mask);
    eval 'sub rn_offset () { ($rn_u->{rn_node}->{rn_Off});}' unless defined(&rn_offset);
    eval 'sub rn_left () { ($rn_u->{rn_node}->{rn_L});}' unless defined(&rn_left);
    eval 'sub rn_right () { ($rn_u->{rn_node}->{rn_R});}' unless defined(&rn_right);
    eval 'sub rm_mask () { ($rm_rmu->{rmu_mask});}' unless defined(&rm_mask);
    eval 'sub rm_leaf () { ($rm_rmu->{rmu_leaf});}' unless defined(&rm_leaf);
    if(defined(&_KERNEL)) {
    }
    unless(defined(&_KERNEL)) {
	eval 'sub R_Malloc {
	    my($p, $t, $n) = @_;
    	    eval q(($p = ($t)  &malloc(($n))));
	}' unless defined(&R_Malloc);
	eval 'sub R_Zalloc {
	    my($p, $t, $n) = @_;
    	    eval q(($p = ($t)  &calloc(1,($n))));
	}' unless defined(&R_Zalloc);
	eval 'sub R_Free {
	    my($p) = @_;
    	    eval q( &free($p););
	}' unless defined(&R_Free);
    } else {
	eval 'sub R_Malloc {
	    my($p, $t, $n) = @_;
    	    eval q(($p = ($t)  &malloc(($n),  &M_RTABLE,  &M_NOWAIT)));
	}' unless defined(&R_Malloc);
	eval 'sub R_Zalloc {
	    my($p, $t, $n) = @_;
    	    eval q(($p = ($t)  &malloc(($n),  &M_RTABLE,  &M_NOWAIT |  &M_ZERO)));
	}' unless defined(&R_Zalloc);
	eval 'sub R_Free {
	    my($p) = @_;
    	    eval q( &free($p,  &M_RTABLE););
	}' unless defined(&R_Free);
	eval 'sub RADIX_NODE_HEAD_LOCK_INIT {
	    my($rnh) = @_;
    	    eval q( &rw_init_flags(($rnh)-> &rnh_lock, \\"radix node head\\", 0));
	}' unless defined(&RADIX_NODE_HEAD_LOCK_INIT);
	eval 'sub RADIX_NODE_HEAD_LOCK {
	    my($rnh) = @_;
    	    eval q( &rw_wlock(($rnh)-> &rnh_lock));
	}' unless defined(&RADIX_NODE_HEAD_LOCK);
	eval 'sub RADIX_NODE_HEAD_UNLOCK {
	    my($rnh) = @_;
    	    eval q( &rw_wunlock(($rnh)-> &rnh_lock));
	}' unless defined(&RADIX_NODE_HEAD_UNLOCK);
	eval 'sub RADIX_NODE_HEAD_RLOCK {
	    my($rnh) = @_;
    	    eval q( &rw_rlock(($rnh)-> &rnh_lock));
	}' unless defined(&RADIX_NODE_HEAD_RLOCK);
	eval 'sub RADIX_NODE_HEAD_RUNLOCK {
	    my($rnh) = @_;
    	    eval q( &rw_runlock(($rnh)-> &rnh_lock));
	}' unless defined(&RADIX_NODE_HEAD_RUNLOCK);
	eval 'sub RADIX_NODE_HEAD_LOCK_TRY_UPGRADE {
	    my($rnh) = @_;
    	    eval q( &rw_try_upgrade(($rnh)-> &rnh_lock));
	}' unless defined(&RADIX_NODE_HEAD_LOCK_TRY_UPGRADE);
	eval 'sub RADIX_NODE_HEAD_DESTROY {
	    my($rnh) = @_;
    	    eval q( &rw_destroy(($rnh)-> &rnh_lock));
	}' unless defined(&RADIX_NODE_HEAD_DESTROY);
	eval 'sub RADIX_NODE_HEAD_LOCK_ASSERT {
	    my($rnh) = @_;
    	    eval q( &rw_assert(($rnh)-> &rnh_lock,  &RA_LOCKED));
	}' unless defined(&RADIX_NODE_HEAD_LOCK_ASSERT);
	eval 'sub RADIX_NODE_HEAD_WLOCK_ASSERT {
	    my($rnh) = @_;
    	    eval q( &rw_assert(($rnh)-> &rnh_lock,  &RA_WLOCKED));
	}' unless defined(&RADIX_NODE_HEAD_WLOCK_ASSERT);
    }
}
1;
