require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_CRYPTO_H_)) {
    eval 'sub _NET80211_IEEE80211_CRYPTO_H_ () {1;}' unless defined(&_NET80211_IEEE80211_CRYPTO_H_);
    eval 'sub IEEE80211_KEYBUF_SIZE () {16;}' unless defined(&IEEE80211_KEYBUF_SIZE);
    eval 'sub IEEE80211_MICBUF_SIZE () {(8+8);}' unless defined(&IEEE80211_MICBUF_SIZE);
    eval 'sub IEEE80211_KEY_XMIT () {0x1;}' unless defined(&IEEE80211_KEY_XMIT);
    eval 'sub IEEE80211_KEY_RECV () {0x2;}' unless defined(&IEEE80211_KEY_RECV);
    eval 'sub IEEE80211_KEY_GROUP () {0x4;}' unless defined(&IEEE80211_KEY_GROUP);
    eval 'sub IEEE80211_KEY_NOREPLAY () {0x8;}' unless defined(&IEEE80211_KEY_NOREPLAY);
    eval 'sub IEEE80211_KEY_SWENCRYPT () {0x10;}' unless defined(&IEEE80211_KEY_SWENCRYPT);
    eval 'sub IEEE80211_KEY_SWDECRYPT () {0x20;}' unless defined(&IEEE80211_KEY_SWDECRYPT);
    eval 'sub IEEE80211_KEY_SWENMIC () {0x40;}' unless defined(&IEEE80211_KEY_SWENMIC);
    eval 'sub IEEE80211_KEY_SWDEMIC () {0x80;}' unless defined(&IEEE80211_KEY_SWDEMIC);
    eval 'sub IEEE80211_KEY_DEVKEY () {0x100;}' unless defined(&IEEE80211_KEY_DEVKEY);
    eval 'sub IEEE80211_KEY_CIPHER0 () {0x1000;}' unless defined(&IEEE80211_KEY_CIPHER0);
    eval 'sub IEEE80211_KEY_CIPHER1 () {0x2000;}' unless defined(&IEEE80211_KEY_CIPHER1);
    eval 'sub wk_txmic () { &wk_key+ &IEEE80211_KEYBUF_SIZE+0;}' unless defined(&wk_txmic);
    eval 'sub wk_rxmic () { &wk_key+ &IEEE80211_KEYBUF_SIZE+8;}' unless defined(&wk_rxmic);
    eval 'sub IEEE80211_KEY_COMMON () {( &IEEE80211_KEY_XMIT |  &IEEE80211_KEY_RECV |  &IEEE80211_KEY_GROUP |  &IEEE80211_KEY_NOREPLAY);}' unless defined(&IEEE80211_KEY_COMMON);
    eval 'sub IEEE80211_KEY_DEVICE () {( &IEEE80211_KEY_DEVKEY| &IEEE80211_KEY_CIPHER0| &IEEE80211_KEY_CIPHER1);}' unless defined(&IEEE80211_KEY_DEVICE);
    eval 'sub IEEE80211_KEY_SWCRYPT () {( &IEEE80211_KEY_SWENCRYPT |  &IEEE80211_KEY_SWDECRYPT);}' unless defined(&IEEE80211_KEY_SWCRYPT);
    eval 'sub IEEE80211_KEY_SWMIC () {( &IEEE80211_KEY_SWENMIC |  &IEEE80211_KEY_SWDEMIC);}' unless defined(&IEEE80211_KEY_SWMIC);
    eval 'sub IEEE80211_KEY_BITS () {"\\20\\1XMIT\\2RECV\\3GROUP\\4SWENCRYPT\\5SWDECRYPT\\6SWENMIC\\7SWDEMIC" "\\10DEVKEY\\11CIPHER0\\12CIPHER1";}' unless defined(&IEEE80211_KEY_BITS);
    eval 'sub IEEE80211_KEYIX_NONE () {(( &ieee80211_keyix) -1);}' unless defined(&IEEE80211_KEYIX_NONE);
    eval 'sub IEEE80211_CIPHER_WEP () {0;}' unless defined(&IEEE80211_CIPHER_WEP);
    eval 'sub IEEE80211_CIPHER_TKIP () {1;}' unless defined(&IEEE80211_CIPHER_TKIP);
    eval 'sub IEEE80211_CIPHER_AES_OCB () {2;}' unless defined(&IEEE80211_CIPHER_AES_OCB);
    eval 'sub IEEE80211_CIPHER_AES_CCM () {3;}' unless defined(&IEEE80211_CIPHER_AES_CCM);
    eval 'sub IEEE80211_CIPHER_TKIPMIC () {4;}' unless defined(&IEEE80211_CIPHER_TKIPMIC);
    eval 'sub IEEE80211_CIPHER_CKIP () {5;}' unless defined(&IEEE80211_CIPHER_CKIP);
    eval 'sub IEEE80211_CIPHER_NONE () {6;}' unless defined(&IEEE80211_CIPHER_NONE);
    eval 'sub IEEE80211_CIPHER_MAX () {( &IEEE80211_CIPHER_NONE+1);}' unless defined(&IEEE80211_CIPHER_MAX);
    eval 'sub IEEE80211_CRYPTO_WEP () {(1<< &IEEE80211_CIPHER_WEP);}' unless defined(&IEEE80211_CRYPTO_WEP);
    eval 'sub IEEE80211_CRYPTO_TKIP () {(1<< &IEEE80211_CIPHER_TKIP);}' unless defined(&IEEE80211_CRYPTO_TKIP);
    eval 'sub IEEE80211_CRYPTO_AES_OCB () {(1<< &IEEE80211_CIPHER_AES_OCB);}' unless defined(&IEEE80211_CRYPTO_AES_OCB);
    eval 'sub IEEE80211_CRYPTO_AES_CCM () {(1<< &IEEE80211_CIPHER_AES_CCM);}' unless defined(&IEEE80211_CRYPTO_AES_CCM);
    eval 'sub IEEE80211_CRYPTO_TKIPMIC () {(1<< &IEEE80211_CIPHER_TKIPMIC);}' unless defined(&IEEE80211_CRYPTO_TKIPMIC);
    eval 'sub IEEE80211_CRYPTO_CKIP () {(1<< &IEEE80211_CIPHER_CKIP);}' unless defined(&IEEE80211_CRYPTO_CKIP);
    eval 'sub IEEE80211_CRYPTO_BITS () {"\\20\\1WEP\\2TKIP\\3AES\\4AES_CCM\\5TKIPMIC\\6CKIP";}' unless defined(&IEEE80211_CRYPTO_BITS);
    if(defined(&__KERNEL__) || defined(&_KERNEL)) {
	eval 'sub IEEE80211_KEY_UNDEFINED {
	    my($k) = @_;
    	    eval q((($k)-> &wk_cipher ==  &ieee80211_cipher_none));
	}' unless defined(&IEEE80211_KEY_UNDEFINED);
    }
}
1;
