require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_RADIOTAP_H_)) {
    eval 'sub _NET80211_IEEE80211_RADIOTAP_H_ () {1;}' unless defined(&_NET80211_IEEE80211_RADIOTAP_H_);
    if(defined(&__KERNEL__) || defined(&_KERNEL)) {
	unless(defined(&DLT_IEEE802_11_RADIO)) {
	    eval 'sub DLT_IEEE802_11_RADIO () {127;}' unless defined(&DLT_IEEE802_11_RADIO);
	}
    }
    eval 'sub IEEE80211_RADIOTAP_HDRLEN () {64;}' unless defined(&IEEE80211_RADIOTAP_HDRLEN);
    eval("sub IEEE80211_RADIOTAP_TSFT () { 0; }") unless defined(&IEEE80211_RADIOTAP_TSFT);
    eval("sub IEEE80211_RADIOTAP_FLAGS () { 1; }") unless defined(&IEEE80211_RADIOTAP_FLAGS);
    eval("sub IEEE80211_RADIOTAP_RATE () { 2; }") unless defined(&IEEE80211_RADIOTAP_RATE);
    eval("sub IEEE80211_RADIOTAP_CHANNEL () { 3; }") unless defined(&IEEE80211_RADIOTAP_CHANNEL);
    eval("sub IEEE80211_RADIOTAP_FHSS () { 4; }") unless defined(&IEEE80211_RADIOTAP_FHSS);
    eval("sub IEEE80211_RADIOTAP_DBM_ANTSIGNAL () { 5; }") unless defined(&IEEE80211_RADIOTAP_DBM_ANTSIGNAL);
    eval("sub IEEE80211_RADIOTAP_DBM_ANTNOISE () { 6; }") unless defined(&IEEE80211_RADIOTAP_DBM_ANTNOISE);
    eval("sub IEEE80211_RADIOTAP_LOCK_QUALITY () { 7; }") unless defined(&IEEE80211_RADIOTAP_LOCK_QUALITY);
    eval("sub IEEE80211_RADIOTAP_TX_ATTENUATION () { 8; }") unless defined(&IEEE80211_RADIOTAP_TX_ATTENUATION);
    eval("sub IEEE80211_RADIOTAP_DB_TX_ATTENUATION () { 9; }") unless defined(&IEEE80211_RADIOTAP_DB_TX_ATTENUATION);
    eval("sub IEEE80211_RADIOTAP_DBM_TX_POWER () { 10; }") unless defined(&IEEE80211_RADIOTAP_DBM_TX_POWER);
    eval("sub IEEE80211_RADIOTAP_ANTENNA () { 11; }") unless defined(&IEEE80211_RADIOTAP_ANTENNA);
    eval("sub IEEE80211_RADIOTAP_DB_ANTSIGNAL () { 12; }") unless defined(&IEEE80211_RADIOTAP_DB_ANTSIGNAL);
    eval("sub IEEE80211_RADIOTAP_DB_ANTNOISE () { 13; }") unless defined(&IEEE80211_RADIOTAP_DB_ANTNOISE);
    eval("sub IEEE80211_RADIOTAP_RX_FLAGS () { 14; }") unless defined(&IEEE80211_RADIOTAP_RX_FLAGS);
    eval("sub IEEE80211_RADIOTAP_TX_FLAGS () { 15; }") unless defined(&IEEE80211_RADIOTAP_TX_FLAGS);
    eval("sub IEEE80211_RADIOTAP_RTS_RETRIES () { 16; }") unless defined(&IEEE80211_RADIOTAP_RTS_RETRIES);
    eval("sub IEEE80211_RADIOTAP_DATA_RETRIES () { 17; }") unless defined(&IEEE80211_RADIOTAP_DATA_RETRIES);
    eval("sub IEEE80211_RADIOTAP_XCHANNEL () { 18; }") unless defined(&IEEE80211_RADIOTAP_XCHANNEL);
    eval("sub IEEE80211_RADIOTAP_MCS () { 19; }") unless defined(&IEEE80211_RADIOTAP_MCS);
    eval("sub IEEE80211_RADIOTAP_AMPDU_STATUS () { 20; }") unless defined(&IEEE80211_RADIOTAP_AMPDU_STATUS);
    eval("sub IEEE80211_RADIOTAP_RADIOTAP_NAMESPACE () { 29; }") unless defined(&IEEE80211_RADIOTAP_RADIOTAP_NAMESPACE);
    eval("sub IEEE80211_RADIOTAP_VENDOREXT () { 30; }") unless defined(&IEEE80211_RADIOTAP_VENDOREXT);
    eval("sub IEEE80211_RADIOTAP_EXT () { 31; }") unless defined(&IEEE80211_RADIOTAP_EXT);
    unless(defined(&_KERNEL)) {
	eval 'sub IEEE80211_CHAN_TURBO () {0x10;}' unless defined(&IEEE80211_CHAN_TURBO);
	eval 'sub IEEE80211_CHAN_CCK () {0x20;}' unless defined(&IEEE80211_CHAN_CCK);
	eval 'sub IEEE80211_CHAN_OFDM () {0x40;}' unless defined(&IEEE80211_CHAN_OFDM);
	eval 'sub IEEE80211_CHAN_2GHZ () {0x80;}' unless defined(&IEEE80211_CHAN_2GHZ);
	eval 'sub IEEE80211_CHAN_5GHZ () {0x100;}' unless defined(&IEEE80211_CHAN_5GHZ);
	eval 'sub IEEE80211_CHAN_PASSIVE () {0x200;}' unless defined(&IEEE80211_CHAN_PASSIVE);
	eval 'sub IEEE80211_CHAN_DYN () {0x400;}' unless defined(&IEEE80211_CHAN_DYN);
	eval 'sub IEEE80211_CHAN_GFSK () {0x800;}' unless defined(&IEEE80211_CHAN_GFSK);
	eval 'sub IEEE80211_CHAN_GSM () {0x1000;}' unless defined(&IEEE80211_CHAN_GSM);
	eval 'sub IEEE80211_CHAN_STURBO () {0x2000;}' unless defined(&IEEE80211_CHAN_STURBO);
	eval 'sub IEEE80211_CHAN_HALF () {0x4000;}' unless defined(&IEEE80211_CHAN_HALF);
	eval 'sub IEEE80211_CHAN_QUARTER () {0x8000;}' unless defined(&IEEE80211_CHAN_QUARTER);
    }
    eval 'sub IEEE80211_RADIOTAP_F_CFP () {0x1;}' unless defined(&IEEE80211_RADIOTAP_F_CFP);
    eval 'sub IEEE80211_RADIOTAP_F_SHORTPRE () {0x2;}' unless defined(&IEEE80211_RADIOTAP_F_SHORTPRE);
    eval 'sub IEEE80211_RADIOTAP_F_WEP () {0x4;}' unless defined(&IEEE80211_RADIOTAP_F_WEP);
    eval 'sub IEEE80211_RADIOTAP_F_FRAG () {0x8;}' unless defined(&IEEE80211_RADIOTAP_F_FRAG);
    eval 'sub IEEE80211_RADIOTAP_F_FCS () {0x10;}' unless defined(&IEEE80211_RADIOTAP_F_FCS);
    eval 'sub IEEE80211_RADIOTAP_F_DATAPAD () {0x20;}' unless defined(&IEEE80211_RADIOTAP_F_DATAPAD);
    eval 'sub IEEE80211_RADIOTAP_F_BADFCS () {0x40;}' unless defined(&IEEE80211_RADIOTAP_F_BADFCS);
    eval 'sub IEEE80211_RADIOTAP_F_SHORTGI () {0x80;}' unless defined(&IEEE80211_RADIOTAP_F_SHORTGI);
}
1;
