require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET80211_IEEE80211_SUPERG_H_)) {
    eval 'sub _NET80211_IEEE80211_SUPERG_H_ () {1;}' unless defined(&_NET80211_IEEE80211_SUPERG_H_);
    eval 'sub ATHEROS_CAP_TURBO_PRIME () {0x1;}' unless defined(&ATHEROS_CAP_TURBO_PRIME);
    eval 'sub ATHEROS_CAP_COMPRESSION () {0x2;}' unless defined(&ATHEROS_CAP_COMPRESSION);
    eval 'sub ATHEROS_CAP_FAST_FRAME () {0x4;}' unless defined(&ATHEROS_CAP_FAST_FRAME);
    eval 'sub ATHEROS_CAP_XR () {0x8;}' unless defined(&ATHEROS_CAP_XR);
    eval 'sub ATHEROS_CAP_AR () {0x10;}' unless defined(&ATHEROS_CAP_AR);
    eval 'sub ATHEROS_CAP_BURST () {0x20;}' unless defined(&ATHEROS_CAP_BURST);
    eval 'sub ATHEROS_CAP_WME () {0x40;}' unless defined(&ATHEROS_CAP_WME);
    eval 'sub ATHEROS_CAP_BOOST () {0x80;}' unless defined(&ATHEROS_CAP_BOOST);
    eval 'sub ATH_OUI_VERSION () {0x;}' unless defined(&ATH_OUI_VERSION);
    eval 'sub ATH_OUI_SUBTYPE () {0x1;}' unless defined(&ATH_OUI_SUBTYPE);
    if(defined(&_KERNEL)) {
	eval 'sub ieee80211_amsdu_tx_ok {
	    my($ni) = @_;
    	    eval q({  &if (( ($ni->{ni_ic}->{ic_caps}) &  &IEEE80211_C_SWAMSDUTX) == 0) (0);  &if (( ($ni->{ni_vap}->{iv_flags_ht}) &  &IEEE80211_FHT_AMSDU_TX) == 0) (0);  &if (( ($ni->{ni_flags}) &  &IEEE80211_NODE_HT) == 0) (0); (1); });
	}' unless defined(&ieee80211_amsdu_tx_ok);
	eval 'sub ieee80211_ff_age_all {
	    my($ic,$quanta) = @_;
    	    eval q({ \'struct ieee80211_superg\' * &sg =  ($ic->{ic_superg});  &if ( &sg !=  &NULL) {  &ieee80211_ff_age($ic,  ($sg->{ff_stageq[&WME_AC_VO]}), $quanta);  &ieee80211_ff_age($ic,  ($sg->{ff_stageq[&WME_AC_VI]}), $quanta);  &ieee80211_ff_age($ic,  ($sg->{ff_stageq[&WME_AC_BE]}), $quanta);  &ieee80211_ff_age($ic,  ($sg->{ff_stageq[&WME_AC_BK]}), $quanta); } });
	}' unless defined(&ieee80211_ff_age_all);
	eval 'sub ieee80211_ff_flush {
	    my($ic,$ac) = @_;
    	    eval q({ \'struct ieee80211_superg\' * &sg =  ($ic->{ic_superg});  &if ( &sg !=  &NULL)  &ieee80211_ff_age($ic,  ($sg->{ff_stageq[$ac]}), 0x7fffffff); });
	}' unless defined(&ieee80211_ff_flush);
	eval 'sub ieee80211_ff_flush_all {
	    my($ic) = @_;
    	    eval q({  &ieee80211_ff_age_all($ic, 0x7fffffff); });
	}' unless defined(&ieee80211_ff_flush_all);
	eval 'sub ieee80211_decap_fastframe {
	    my($vap,$ni,$m) = @_;
    	    eval q({  &IEEE80211_ATH_CAP($vap, $ni,  &IEEE80211_NODE_FF) ?  &ieee80211_ff_decap($ni, $m) : $m; });
	}' unless defined(&ieee80211_decap_fastframe);
    }
}
1;
