require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETGRAPH_ATM_NG_ATM_H_)) {
    eval 'sub _NETGRAPH_ATM_NG_ATM_H_ () {1;}' unless defined(&_NETGRAPH_ATM_NG_ATM_H_);
    eval 'sub NG_ATM_NODE_TYPE () {"atm";}' unless defined(&NG_ATM_NODE_TYPE);
    eval 'sub NGM_ATM_COOKIE () {960802260;}' unless defined(&NGM_ATM_COOKIE);
    eval("sub NGM_ATM_GET_IFNAME () { 1; }") unless defined(&NGM_ATM_GET_IFNAME);
    eval("sub NGM_ATM_GET_CONFIG () { 2; }") unless defined(&NGM_ATM_GET_CONFIG);
    eval("sub NGM_ATM_GET_VCCS () { 3; }") unless defined(&NGM_ATM_GET_VCCS);
    eval("sub NGM_ATM_CPCS_INIT () { 4; }") unless defined(&NGM_ATM_CPCS_INIT);
    eval("sub NGM_ATM_CPCS_TERM () { 5; }") unless defined(&NGM_ATM_CPCS_TERM);
    eval("sub NGM_ATM_GET_VCC () { 6; }") unless defined(&NGM_ATM_GET_VCC);
    eval("sub NGM_ATM_GET_VCCID () { 7; }") unless defined(&NGM_ATM_GET_VCCID);
    eval("sub NGM_ATM_GET_STATS () { 8; }") unless defined(&NGM_ATM_GET_STATS);
    eval("sub NGM_ATM_CARRIER_CHANGE () { 1000; }") unless defined(&NGM_ATM_CARRIER_CHANGE);
    eval("sub NGM_ATM_VCC_CHANGE () { 1001; }") unless defined(&NGM_ATM_VCC_CHANGE);
    eval("sub NGM_ATM_ACR_CHANGE () { 1002; }") unless defined(&NGM_ATM_ACR_CHANGE);
    eval("sub NGM_ATM_IF_CHANGE () { 1003; }") unless defined(&NGM_ATM_IF_CHANGE);
    eval 'sub NGM_ATM_CONFIG_INFO () {{ { "pcr",  &ng_parse_uint32_type }, { "vpi_bits",  &ng_parse_uint32_type }, { "vci_bits",  &ng_parse_uint32_type }, { "max_vpcs",  &ng_parse_uint32_type }, { "max_vccs",  &ng_parse_uint32_type }, {  &NULL } };}' unless defined(&NGM_ATM_CONFIG_INFO);
    eval 'sub NGM_ATM_TPARAM_INFO () {{ { "pcr",  &ng_parse_uint32_type }, { "scr",  &ng_parse_uint32_type }, { "mbs",  &ng_parse_uint32_type }, { "mcr",  &ng_parse_uint32_type }, { "icr",  &ng_parse_uint32_type }, { "tbe",  &ng_parse_uint32_type }, { "nrm",  &ng_parse_uint8_type }, { "trm",  &ng_parse_uint8_type }, { "adtf",  &ng_parse_uint16_type }, { "rif",  &ng_parse_uint8_type }, { "rdf",  &ng_parse_uint8_type }, { "cdf",  &ng_parse_uint8_type }, {  &NULL } };}' unless defined(&NGM_ATM_TPARAM_INFO);
    eval 'sub NGM_ATM_VCC_INFO () {{ { "flags",  &ng_parse_hint16_type }, { "vpi",  &ng_parse_uint16_type }, { "vci",  &ng_parse_uint16_type }, { "rmtu",  &ng_parse_uint16_type }, { "tmtu",  &ng_parse_uint16_type }, { "aal",  &ng_parse_uint8_type }, { "traffic",  &ng_parse_uint8_type }, { "tparam",  &ng_atm_tparam_type }, {  &NULL } };}' unless defined(&NGM_ATM_VCC_INFO);
    eval 'sub NGM_ATM_VCCARRAY_INFO () {{  &ng_atm_vcc_type,  &ng_atm_vccarray_getlen,  &NULL };}' unless defined(&NGM_ATM_VCCARRAY_INFO);
    eval 'sub NGM_ATM_VCCTABLE_INFO () {{ { "count",  &ng_parse_uint32_type }, { "vccs",  &ng_atm_vccarray_type }, {  &NULL } };}' unless defined(&NGM_ATM_VCCTABLE_INFO);
    eval 'sub NGM_ATM_CPCS_INIT_INFO () {{ { "name",  &ng_parse_hookbuf_type }, { "flags",  &ng_parse_hint32_type }, { "vci",  &ng_parse_uint16_type }, { "vpi",  &ng_parse_uint16_type }, { "rmtu",  &ng_parse_uint16_type }, { "tmtu",  &ng_parse_uint16_type }, { "aal",  &ng_parse_uint8_type }, { "traffic",  &ng_parse_uint8_type }, { "pcr",  &ng_parse_uint32_type }, { "scr",  &ng_parse_uint32_type }, { "mbs",  &ng_parse_uint32_type }, { "mcr",  &ng_parse_uint32_type }, { "icr",  &ng_parse_uint32_type }, { "tbe",  &ng_parse_uint32_type }, { "nrm",  &ng_parse_uint8_type }, { "trm",  &ng_parse_uint8_type }, { "adtf",  &ng_parse_uint16_type }, { "rif",  &ng_parse_uint8_type }, { "rdf",  &ng_parse_uint8_type }, { "cdf",  &ng_parse_uint8_type }, {  &NULL } };}' unless defined(&NGM_ATM_CPCS_INIT_INFO);
    eval 'sub NGM_ATM_CPCS_TERM_INFO () {{ { "name",  &ng_parse_hookbuf_type }, {  &NULL } };}' unless defined(&NGM_ATM_CPCS_TERM_INFO);
    eval 'sub NGM_ATM_STATS_INFO () {{ { "in_packets",  &ng_parse_uint64_type }, { "in_errors",  &ng_parse_uint64_type }, { "out_packets",  &ng_parse_uint64_type }, { "out_errors",  &ng_parse_uint64_type }, {  &NULL } };}' unless defined(&NGM_ATM_STATS_INFO);
    eval 'sub NGM_ATM_IF_CHANGE_INFO () {{ { "node",  &ng_parse_hint32_type }, { "carrier",  &ng_parse_uint8_type }, { "running",  &ng_parse_uint8_type }, {  &NULL } };}' unless defined(&NGM_ATM_IF_CHANGE_INFO);
    eval 'sub NGM_ATM_VCC_CHANGE_INFO () {{ { "node",  &ng_parse_hint32_type }, { "vci",  &ng_parse_uint16_type }, { "vpi",  &ng_parse_uint8_type }, { "state",  &ng_parse_uint8_type }, {  &NULL } };}' unless defined(&NGM_ATM_VCC_CHANGE_INFO);
    eval 'sub NGM_ATM_ACR_CHANGE_INFO () {{ { "node",  &ng_parse_hint32_type }, { "vci",  &ng_parse_uint16_type }, { "vpi",  &ng_parse_uint8_type }, { "acr",  &ng_parse_uint32_type }, {  &NULL } };}' unless defined(&NGM_ATM_ACR_CHANGE_INFO);
}
1;
