require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub ACTIVE_TIMEOUT () {(30*60);}' unless defined(&ACTIVE_TIMEOUT);
eval 'sub INACTIVE_TIMEOUT () {15;}' unless defined(&INACTIVE_TIMEOUT);
eval 'sub NETFLOW_V1 () {1;}' unless defined(&NETFLOW_V1);
eval 'sub NETFLOW_V5 () {5;}' unless defined(&NETFLOW_V5);
eval 'sub NETFLOW_V9 () {9;}' unless defined(&NETFLOW_V9);
eval 'sub NETFLOW_V1_MAX_RECORDS () {24;}' unless defined(&NETFLOW_V1_MAX_RECORDS);
eval 'sub NETFLOW_V5_MAX_RECORDS () {30;}' unless defined(&NETFLOW_V5_MAX_RECORDS);
eval 'sub NETFLOW_V1_MAX_SIZE () {($sizeof{ &netflow_v1_header}+ $sizeof{ &netflow_v1_record}* &NETFLOW_V1_MAX_RECORDS);}' unless defined(&NETFLOW_V1_MAX_SIZE);
eval 'sub NETFLOW_V5_MAX_SIZE () {($sizeof{ &netflow_v5_header}+ $sizeof{ &netflow_v5_record}* &NETFLOW_V5_MAX_RECORDS);}' unless defined(&NETFLOW_V5_MAX_SIZE);
eval 'sub NETFLOW_V9_FIELD_IN_BYTES () {1;}' unless defined(&NETFLOW_V9_FIELD_IN_BYTES);
eval 'sub NETFLOW_V9_FIELD_IN_PKTS () {2;}' unless defined(&NETFLOW_V9_FIELD_IN_PKTS);
eval 'sub NETFLOW_V9_FIELD_FLOWS () {3;}' unless defined(&NETFLOW_V9_FIELD_FLOWS);
eval 'sub NETFLOW_V9_FIELD_PROTOCOL () {4;}' unless defined(&NETFLOW_V9_FIELD_PROTOCOL);
eval 'sub NETFLOW_V9_FIELD_TOS () {5;}' unless defined(&NETFLOW_V9_FIELD_TOS);
eval 'sub NETFLOW_V9_FIELD_TCP_FLAGS () {6;}' unless defined(&NETFLOW_V9_FIELD_TCP_FLAGS);
eval 'sub NETFLOW_V9_FIELD_L4_SRC_PORT () {7;}' unless defined(&NETFLOW_V9_FIELD_L4_SRC_PORT);
eval 'sub NETFLOW_V9_FIELD_IPV4_SRC_ADDR () {8;}' unless defined(&NETFLOW_V9_FIELD_IPV4_SRC_ADDR);
eval 'sub NETFLOW_V9_FIELD_SRC_MASK () {9;}' unless defined(&NETFLOW_V9_FIELD_SRC_MASK);
eval 'sub NETFLOW_V9_FIELD_INPUT_SNMP () {10;}' unless defined(&NETFLOW_V9_FIELD_INPUT_SNMP);
eval 'sub NETFLOW_V9_FIELD_L4_DST_PORT () {11;}' unless defined(&NETFLOW_V9_FIELD_L4_DST_PORT);
eval 'sub NETFLOW_V9_FIELD_IPV4_DST_ADDR () {12;}' unless defined(&NETFLOW_V9_FIELD_IPV4_DST_ADDR);
eval 'sub NETFLOW_V9_FIELD_DST_MASK () {13;}' unless defined(&NETFLOW_V9_FIELD_DST_MASK);
eval 'sub NETFLOW_V9_FIELD_OUTPUT_SNMP () {14;}' unless defined(&NETFLOW_V9_FIELD_OUTPUT_SNMP);
eval 'sub NETFLOW_V9_FIELD_IPV4_NEXT_HOP () {15;}' unless defined(&NETFLOW_V9_FIELD_IPV4_NEXT_HOP);
eval 'sub NETFLOW_V9_FIELD_SRC_AS () {16;}' unless defined(&NETFLOW_V9_FIELD_SRC_AS);
eval 'sub NETFLOW_V9_FIELD_DST_AS () {17;}' unless defined(&NETFLOW_V9_FIELD_DST_AS);
eval 'sub NETFLOW_V9_FIELD_BGP_IPV4_NEXT_HOP () {18;}' unless defined(&NETFLOW_V9_FIELD_BGP_IPV4_NEXT_HOP);
eval 'sub NETFLOW_V9_FIELD_MUL_DST_PKTS () {19;}' unless defined(&NETFLOW_V9_FIELD_MUL_DST_PKTS);
eval 'sub NETFLOW_V9_FIELD_MUL_DST_BYTES () {20;}' unless defined(&NETFLOW_V9_FIELD_MUL_DST_BYTES);
eval 'sub NETFLOW_V9_FIELD_LAST_SWITCHED () {21;}' unless defined(&NETFLOW_V9_FIELD_LAST_SWITCHED);
eval 'sub NETFLOW_V9_FIELD_FIRST_SWITCHED () {22;}' unless defined(&NETFLOW_V9_FIELD_FIRST_SWITCHED);
eval 'sub NETFLOW_V9_FIELD_OUT_BYTES () {23;}' unless defined(&NETFLOW_V9_FIELD_OUT_BYTES);
eval 'sub NETFLOW_V9_FIELD_OUT_PKTS () {24;}' unless defined(&NETFLOW_V9_FIELD_OUT_PKTS);
eval 'sub NETFLOW_V9_FIELD_IPV6_SRC_ADDR () {27;}' unless defined(&NETFLOW_V9_FIELD_IPV6_SRC_ADDR);
eval 'sub NETFLOW_V9_FIELD_IPV6_DST_ADDR () {28;}' unless defined(&NETFLOW_V9_FIELD_IPV6_DST_ADDR);
eval 'sub NETFLOW_V9_FIELD_IPV6_SRC_MASK () {29;}' unless defined(&NETFLOW_V9_FIELD_IPV6_SRC_MASK);
eval 'sub NETFLOW_V9_FIELD_IPV6_DST_MASK () {30;}' unless defined(&NETFLOW_V9_FIELD_IPV6_DST_MASK);
eval 'sub NETFLOW_V9_FIELD_IPV6_FLOW_LABEL () {31;}' unless defined(&NETFLOW_V9_FIELD_IPV6_FLOW_LABEL);
eval 'sub NETFLOW_V9_FIELD_ICMP_TYPE () {32;}' unless defined(&NETFLOW_V9_FIELD_ICMP_TYPE);
eval 'sub NETFLOW_V9_FIELD_MUL_IGMP_TYPE () {33;}' unless defined(&NETFLOW_V9_FIELD_MUL_IGMP_TYPE);
eval 'sub NETFLOW_V9_FIELD_SAMPLING_INTERVAL () {34;}' unless defined(&NETFLOW_V9_FIELD_SAMPLING_INTERVAL);
eval 'sub NETFLOW_V9_FIELD_SAMPLING_ALGORITHM () {35;}' unless defined(&NETFLOW_V9_FIELD_SAMPLING_ALGORITHM);
eval 'sub NETFLOW_V9_FIELD_FLOW_ACTIVE_TIMEOUT () {36;}' unless defined(&NETFLOW_V9_FIELD_FLOW_ACTIVE_TIMEOUT);
eval 'sub NETFLOW_V9_FIELD_FLOW_INACTIVE_TIMEOUT () {37;}' unless defined(&NETFLOW_V9_FIELD_FLOW_INACTIVE_TIMEOUT);
eval 'sub NETFLOW_V9_FIELD_ENGINE_TYPE () {38;}' unless defined(&NETFLOW_V9_FIELD_ENGINE_TYPE);
eval 'sub NETFLOW_V9_FIELD_ENGINE_ID () {39;}' unless defined(&NETFLOW_V9_FIELD_ENGINE_ID);
eval 'sub NETFLOW_V9_FIELD_TOTAL_BYTES_EXP () {40;}' unless defined(&NETFLOW_V9_FIELD_TOTAL_BYTES_EXP);
eval 'sub NETFLOW_V9_FIELD_TOTAL_PKTS_EXP () {41;}' unless defined(&NETFLOW_V9_FIELD_TOTAL_PKTS_EXP);
eval 'sub NETFLOW_V9_FIELD_TOTAL_FLOWS_EXP () {42;}' unless defined(&NETFLOW_V9_FIELD_TOTAL_FLOWS_EXP);
eval 'sub NETFLOW_V9_FIELD_MPLS_TOP_LABEL_TYPE () {46;}' unless defined(&NETFLOW_V9_FIELD_MPLS_TOP_LABEL_TYPE);
eval 'sub NETFLOW_V9_FIELD_MPLS_TOP_LABEL_IP_ADDR () {47;}' unless defined(&NETFLOW_V9_FIELD_MPLS_TOP_LABEL_IP_ADDR);
eval 'sub NETFLOW_V9_FIELD_FLOW_SAMPLER_ID () {48;}' unless defined(&NETFLOW_V9_FIELD_FLOW_SAMPLER_ID);
eval 'sub NETFLOW_V9_FIELD_FLOW_SAMPLER_MODE () {49;}' unless defined(&NETFLOW_V9_FIELD_FLOW_SAMPLER_MODE);
eval 'sub NETFLOW_V9_FIELD_FLOW_SAMPLER_RANDOM_INTERVAL () {50;}' unless defined(&NETFLOW_V9_FIELD_FLOW_SAMPLER_RANDOM_INTERVAL);
eval 'sub NETFLOW_V9_FIELD_DST_TOS () {55;}' unless defined(&NETFLOW_V9_FIELD_DST_TOS);
eval 'sub NETFLOW_V9_FIELD_SRC_MAC () {56;}' unless defined(&NETFLOW_V9_FIELD_SRC_MAC);
eval 'sub NETFLOW_V9_FIELD_DST_MAC () {57;}' unless defined(&NETFLOW_V9_FIELD_DST_MAC);
eval 'sub NETFLOW_V9_FIELD_SRC_VLAN () {58;}' unless defined(&NETFLOW_V9_FIELD_SRC_VLAN);
eval 'sub NETFLOW_V9_FIELD_DST_VLAN () {59;}' unless defined(&NETFLOW_V9_FIELD_DST_VLAN);
eval 'sub NETFLOW_V9_FIELD_IP_PROTOCOL_VERSION () {60;}' unless defined(&NETFLOW_V9_FIELD_IP_PROTOCOL_VERSION);
eval 'sub NETFLOW_V9_FIELD_DIRECTION () {61;}' unless defined(&NETFLOW_V9_FIELD_DIRECTION);
eval 'sub NETFLOW_V9_FIELD_IPV6_NEXT_HOP () {62;}' unless defined(&NETFLOW_V9_FIELD_IPV6_NEXT_HOP);
eval 'sub NETFLOW_V9_FIELD_BGP_IPV6_NEXT_HOP () {63;}' unless defined(&NETFLOW_V9_FIELD_BGP_IPV6_NEXT_HOP);
eval 'sub NETFLOW_V9_FIELD_IPV6_OPTION_HEADERS () {64;}' unless defined(&NETFLOW_V9_FIELD_IPV6_OPTION_HEADERS);
eval 'sub NETFLOW_V9_FIELD_MPLS_LABEL_1 () {70;}' unless defined(&NETFLOW_V9_FIELD_MPLS_LABEL_1);
eval 'sub NETFLOW_V9_FIELD_MPLS_LABEL_2 () {71;}' unless defined(&NETFLOW_V9_FIELD_MPLS_LABEL_2);
eval 'sub NETFLOW_V9_FIELD_MPLS_LABEL_3 () {72;}' unless defined(&NETFLOW_V9_FIELD_MPLS_LABEL_3);
eval 'sub NETFLOW_V9_FIELD_MPLS_LABEL_4 () {73;}' unless defined(&NETFLOW_V9_FIELD_MPLS_LABEL_4);
eval 'sub NETFLOW_V9_FIELD_MPLS_LABEL_5 () {74;}' unless defined(&NETFLOW_V9_FIELD_MPLS_LABEL_5);
eval 'sub NETFLOW_V9_FIELD_MPLS_LABEL_6 () {75;}' unless defined(&NETFLOW_V9_FIELD_MPLS_LABEL_6);
eval 'sub NETFLOW_V9_FIELD_MPLS_LABEL_7 () {76;}' unless defined(&NETFLOW_V9_FIELD_MPLS_LABEL_7);
eval 'sub NETFLOW_V9_FIELD_MPLS_LABEL_8 () {77;}' unless defined(&NETFLOW_V9_FIELD_MPLS_LABEL_8);
eval 'sub NETFLOW_V9_FIELD_MPLS_LABEL_9 () {78;}' unless defined(&NETFLOW_V9_FIELD_MPLS_LABEL_9);
eval 'sub NETFLOW_V9_FIELD_MPLS_LABEL_10 () {79;}' unless defined(&NETFLOW_V9_FIELD_MPLS_LABEL_10);
eval 'sub NETFLOW_V9_MAX_RESERVED_FLOWSET () {0xff;}' unless defined(&NETFLOW_V9_MAX_RESERVED_FLOWSET);
1;
