require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETGRAPH_NG_CAR_H_)) {
    eval 'sub _NETGRAPH_NG_CAR_H_ () {1;}' unless defined(&_NETGRAPH_NG_CAR_H_);
    eval 'sub NG_CAR_NODE_TYPE () {"car";}' unless defined(&NG_CAR_NODE_TYPE);
    eval 'sub NGM_CAR_COOKIE () {1173648034;}' unless defined(&NGM_CAR_COOKIE);
    eval 'sub NG_CAR_HOOK_UPPER () {"upper";}' unless defined(&NG_CAR_HOOK_UPPER);
    eval 'sub NG_CAR_HOOK_LOWER () {"lower";}' unless defined(&NG_CAR_HOOK_LOWER);
    eval 'sub NG_CAR_HOOKSTATS () {{ { "passed",  &ng_parse_uint64_type }, { "droped",  &ng_parse_uint64_type }, { "green",  &ng_parse_uint64_type }, { "yellow",  &ng_parse_uint64_type }, { "red",  &ng_parse_uint64_type }, { "errors",  &ng_parse_uint64_type }, {  &NULL } };}' unless defined(&NG_CAR_HOOKSTATS);
    eval 'sub NG_CAR_BULKSTATS {
        my($hstatstype) = @_;
	    eval q({ { \\"upstream\\", ($hstatstype) }, { \\"downstream\\", ($hstatstype) }, {  &NULL } });
    }' unless defined(&NG_CAR_BULKSTATS);
    eval 'sub NG_CAR_HOOKCONF () {{ { "cbs",  &ng_parse_uint64_type }, { "ebs",  &ng_parse_uint64_type }, { "cir",  &ng_parse_uint64_type }, { "pir",  &ng_parse_uint64_type }, { "greenAction",  &ng_parse_uint8_type }, { "yellowAction",  &ng_parse_uint8_type }, { "redAction",  &ng_parse_uint8_type }, { "mode",  &ng_parse_uint8_type }, { "opt",  &ng_parse_uint8_type }, {  &NULL } };}' unless defined(&NG_CAR_HOOKCONF);
    eval 'sub NG_CAR_CBS_MIN () {8192;}' unless defined(&NG_CAR_CBS_MIN);
    eval 'sub NG_CAR_EBS_MIN () {8192;}' unless defined(&NG_CAR_EBS_MIN);
    eval 'sub NG_CAR_CIR_DFLT () {10240;}' unless defined(&NG_CAR_CIR_DFLT);
    eval("sub NG_CAR_ACTION_FORWARD () { 1; }") unless defined(&NG_CAR_ACTION_FORWARD);
    eval("sub NG_CAR_ACTION_DROP () { 2; }") unless defined(&NG_CAR_ACTION_DROP);
    eval("sub NG_CAR_ACTION_MARK () { 3; }") unless defined(&NG_CAR_ACTION_MARK);
    eval("sub NG_CAR_ACTION_SET_TOS () { 4; }") unless defined(&NG_CAR_ACTION_SET_TOS);
    eval("sub NG_CAR_SINGLE_RATE () { 0; }") unless defined(&NG_CAR_SINGLE_RATE);
    eval("sub NG_CAR_DOUBLE_RATE () { 1; }") unless defined(&NG_CAR_DOUBLE_RATE);
    eval("sub NG_CAR_RED () { 2; }") unless defined(&NG_CAR_RED);
    eval("sub NG_CAR_SHAPE () { 3; }") unless defined(&NG_CAR_SHAPE);
    eval 'sub NG_CAR_COLOR_AWARE () {1;}' unless defined(&NG_CAR_COLOR_AWARE);
    eval 'sub NG_CAR_COUNT_PACKETS () {2;}' unless defined(&NG_CAR_COUNT_PACKETS);
    eval 'sub NG_CAR_BULKCONF {
        my($hconftype) = @_;
	    eval q({ { \\"upstream\\", ($hconftype) }, { \\"downstream\\", ($hconftype) }, {  &NULL } });
    }' unless defined(&NG_CAR_BULKCONF);
    eval("sub NGM_CAR_GET_STATS () { 1; }") unless defined(&NGM_CAR_GET_STATS);
    eval("sub NGM_CAR_CLR_STATS () { 2; }") unless defined(&NGM_CAR_CLR_STATS);
    eval("sub NGM_CAR_GETCLR_STATS () { 3; }") unless defined(&NGM_CAR_GETCLR_STATS);
    eval("sub NGM_CAR_GET_CONF () { 4; }") unless defined(&NGM_CAR_GET_CONF);
    eval("sub NGM_CAR_SET_CONF () { 5; }") unless defined(&NGM_CAR_SET_CONF);
}
1;
