require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETGRAPH_NG_L2TP_H_)) {
    eval 'sub _NETGRAPH_NG_L2TP_H_ () {1;}' unless defined(&_NETGRAPH_NG_L2TP_H_);
    eval 'sub NG_L2TP_NODE_TYPE () {"l2tp";}' unless defined(&NG_L2TP_NODE_TYPE);
    eval 'sub NGM_L2TP_COOKIE () {1091515793;}' unless defined(&NGM_L2TP_COOKIE);
    eval 'sub NG_L2TP_HOOK_CTRL () {"ctrl";}' unless defined(&NG_L2TP_HOOK_CTRL);
    eval 'sub NG_L2TP_HOOK_LOWER () {"lower";}' unless defined(&NG_L2TP_HOOK_LOWER);
    eval 'sub NG_L2TP_HOOK_SESSION_P () {"session_";}' unless defined(&NG_L2TP_HOOK_SESSION_P);
    eval 'sub NG_L2TP_HOOK_SESSION_F () {"session_%04x";}' unless defined(&NG_L2TP_HOOK_SESSION_F);
    eval 'sub NG_L2TP_SEQ_CONFIG_TYPE_INFO () {{ { "ns",  &ng_parse_uint16_type }, { "nr",  &ng_parse_uint16_type }, {  &NULL } };}' unless defined(&NG_L2TP_SEQ_CONFIG_TYPE_INFO);
    eval 'sub NG_L2TP_CONFIG_TYPE_INFO () {{ { "enabled",  &ng_parse_uint8_type }, { "match_id",  &ng_parse_uint8_type }, { "tunnel_id",  &ng_parse_hint16_type }, { "peer_id",  &ng_parse_hint16_type }, { "peer_win",  &ng_parse_uint16_type }, { "rexmit_max",  &ng_parse_uint16_type }, { "rexmit_max_to",  &ng_parse_uint16_type }, {  &NULL } };}' unless defined(&NG_L2TP_CONFIG_TYPE_INFO);
    eval 'sub NG_L2TP_SESS_CONFIG_TYPE_INFO () {{ { "session_id",  &ng_parse_hint16_type }, { "peer_id",  &ng_parse_hint16_type }, { "control_dseq",  &ng_parse_uint8_type }, { "enable_dseq",  &ng_parse_uint8_type }, { "include_length",  &ng_parse_uint8_type }, {  &NULL } };}' unless defined(&NG_L2TP_SESS_CONFIG_TYPE_INFO);
    eval 'sub NG_L2TP_STATS_TYPE_INFO () {{ { "xmitPackets",  &ng_parse_uint32_type }, { "xmitOctets",  &ng_parse_uint32_type }, { "xmitZLBs",  &ng_parse_uint32_type }, { "xmitDrops",  &ng_parse_uint32_type }, { "xmitTooBig",  &ng_parse_uint32_type }, { "xmitInvalid",  &ng_parse_uint32_type }, { "xmitDataTooBig",  &ng_parse_uint32_type }, { "xmitRetransmits",  &ng_parse_uint32_type }, { "recvPackets",  &ng_parse_uint32_type }, { "recvOctets",  &ng_parse_uint32_type }, { "recvRunts",  &ng_parse_uint32_type }, { "recvInvalid",  &ng_parse_uint32_type }, { "recvWrongTunnel",  &ng_parse_uint32_type }, { "recvUnknownSID",  &ng_parse_uint32_type }, { "recvBadAcks",  &ng_parse_uint32_type }, { "recvOutOfOrder",  &ng_parse_uint32_type }, { "recvDuplicates",  &ng_parse_uint32_type }, { "recvDataDrops",  &ng_parse_uint32_type }, { "recvZLBs",  &ng_parse_uint32_type }, { "memoryFailures",  &ng_parse_uint32_type }, {  &NULL } };}' unless defined(&NG_L2TP_STATS_TYPE_INFO);
    eval 'sub NG_L2TP_SESSION_STATS_TYPE_INFO () {{ { "xmitPackets",  &ng_parse_uint64_type }, { "xmitOctets",  &ng_parse_uint64_type }, { "recvPackets",  &ng_parse_uint64_type }, { "recvOctets",  &ng_parse_uint64_type }, {  &NULL } };}' unless defined(&NG_L2TP_SESSION_STATS_TYPE_INFO);
    eval("sub NGM_L2TP_SET_CONFIG () { 1; }") unless defined(&NGM_L2TP_SET_CONFIG);
    eval("sub NGM_L2TP_GET_CONFIG () { 2; }") unless defined(&NGM_L2TP_GET_CONFIG);
    eval("sub NGM_L2TP_SET_SESS_CONFIG () { 3; }") unless defined(&NGM_L2TP_SET_SESS_CONFIG);
    eval("sub NGM_L2TP_GET_SESS_CONFIG () { 4; }") unless defined(&NGM_L2TP_GET_SESS_CONFIG);
    eval("sub NGM_L2TP_GET_STATS () { 5; }") unless defined(&NGM_L2TP_GET_STATS);
    eval("sub NGM_L2TP_CLR_STATS () { 6; }") unless defined(&NGM_L2TP_CLR_STATS);
    eval("sub NGM_L2TP_GETCLR_STATS () { 7; }") unless defined(&NGM_L2TP_GETCLR_STATS);
    eval("sub NGM_L2TP_GET_SESSION_STATS () { 8; }") unless defined(&NGM_L2TP_GET_SESSION_STATS);
    eval("sub NGM_L2TP_CLR_SESSION_STATS () { 9; }") unless defined(&NGM_L2TP_CLR_SESSION_STATS);
    eval("sub NGM_L2TP_GETCLR_SESSION_STATS () { 10; }") unless defined(&NGM_L2TP_GETCLR_SESSION_STATS);
    eval("sub NGM_L2TP_ACK_FAILURE () { 11; }") unless defined(&NGM_L2TP_ACK_FAILURE);
    eval("sub NGM_L2TP_SET_SEQ () { 12; }") unless defined(&NGM_L2TP_SET_SEQ);
}
1;
