require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETGRAPH_PIPE_H_)) {
    eval 'sub _NETGRAPH_PIPE_H_ () {1;}' unless defined(&_NETGRAPH_PIPE_H_);
    eval 'sub NG_PIPE_NODE_TYPE () {"pipe";}' unless defined(&NG_PIPE_NODE_TYPE);
    eval 'sub NGM_PIPE_COOKIE () {200708191;}' unless defined(&NGM_PIPE_COOKIE);
    eval 'sub NG_PIPE_HOOK_UPPER () {"upper";}' unless defined(&NG_PIPE_HOOK_UPPER);
    eval 'sub NG_PIPE_HOOK_LOWER () {"lower";}' unless defined(&NG_PIPE_HOOK_LOWER);
    eval 'sub MAX_FSIZE () {16384;}' unless defined(&MAX_FSIZE);
    eval 'sub MAX_OHSIZE () {256;}' unless defined(&MAX_OHSIZE);
    eval 'sub NG_PIPE_HOOKSTAT_INFO () {{ { "FwdOctets",  &ng_parse_uint64_type }, { "FwdFrames",  &ng_parse_uint64_type }, { "queueDropOctets",  &ng_parse_uint64_type }, { "queueDropFrames",  &ng_parse_uint64_type }, { "delayDropOctets",  &ng_parse_uint64_type }, { "delayDropFrames",  &ng_parse_uint64_type }, {  &NULL }, };}' unless defined(&NG_PIPE_HOOKSTAT_INFO);
    eval 'sub NG_PIPE_STATS_INFO {
        my($hstype) = @_;
	    eval q({ { \\"downstream\\", ($hstype) }, { \\"upstream\\", ($hstype) }, {  &NULL }, });
    }' unless defined(&NG_PIPE_STATS_INFO);
    eval 'sub NG_PIPE_HOOKRUN_INFO () {{ { "queues",  &ng_parse_uint32_type }, { "queuedOctets",  &ng_parse_uint32_type }, { "queuedFrames",  &ng_parse_uint32_type }, { "delayedOctets",  &ng_parse_uint32_type }, { "delayedFrames",  &ng_parse_uint32_type }, {  &NULL }, };}' unless defined(&NG_PIPE_HOOKRUN_INFO);
    eval 'sub NG_PIPE_RUN_INFO {
        my($hstype) = @_;
	    eval q({ { \\"downstream\\", ($hstype) }, { \\"upstream\\", ($hstype) }, {  &NULL }, });
    }' unless defined(&NG_PIPE_RUN_INFO);
    eval 'sub NG_PIPE_HOOKCFG_INFO () {{ { "bandwidth",  &ng_parse_uint64_type }, { "BER",  &ng_parse_uint64_type }, { "queuelen",  &ng_parse_uint32_type }, { "delaylen",  &ng_parse_uint32_type }, { "duplicate",  &ng_parse_uint32_type }, { "fifo",  &ng_parse_uint32_type }, { "drr",  &ng_parse_uint32_type }, { "wfq",  &ng_parse_uint32_type }, { "droptail",  &ng_parse_uint32_type }, { "drophead",  &ng_parse_uint32_type }, {  &NULL }, };}' unless defined(&NG_PIPE_HOOKCFG_INFO);
    eval 'sub NG_PIPE_CFG_INFO {
        my($hstype) = @_;
	    eval q({ { \\"bandwidth\\",  &ng_parse_uint64_type }, { \\"delay\\",  &ng_parse_uint64_type }, { \\"header_offset\\",  &ng_parse_uint32_type }, { \\"overhead\\",  &ng_parse_uint32_type }, { \\"downstream\\", ($hstype) }, { \\"upstream\\", ($hstype) }, {  &NULL }, });
    }' unless defined(&NG_PIPE_CFG_INFO);
    eval("sub NGM_PIPE_GET_STATS () { 1; }") unless defined(&NGM_PIPE_GET_STATS);
    eval("sub NGM_PIPE_CLR_STATS () { 2; }") unless defined(&NGM_PIPE_CLR_STATS);
    eval("sub NGM_PIPE_GETCLR_STATS () { 3; }") unless defined(&NGM_PIPE_GETCLR_STATS);
    eval("sub NGM_PIPE_GET_RUN () { 4; }") unless defined(&NGM_PIPE_GET_RUN);
    eval("sub NGM_PIPE_GET_CFG () { 5; }") unless defined(&NGM_PIPE_GET_CFG);
    eval("sub NGM_PIPE_SET_CFG () { 6; }") unless defined(&NGM_PIPE_SET_CFG);
}
1;
