require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETGRAPH_NG_PPP_H_)) {
    eval 'sub _NETGRAPH_NG_PPP_H_ () {1;}' unless defined(&_NETGRAPH_NG_PPP_H_);
    eval 'sub NG_PPP_NODE_TYPE () {"ppp";}' unless defined(&NG_PPP_NODE_TYPE);
    eval 'sub NGM_PPP_COOKIE () {940897795;}' unless defined(&NGM_PPP_COOKIE);
    eval 'sub NG_PPP_STATS64 () {1;}' unless defined(&NG_PPP_STATS64);
    eval 'sub NG_PPP_MAX_LINKS () {16;}' unless defined(&NG_PPP_MAX_LINKS);
    eval 'sub NG_PPP_BUNDLE_LINKNUM () {0xffff;}' unless defined(&NG_PPP_BUNDLE_LINKNUM);
    eval 'sub NG_PPP_MAX_LATENCY () {1000;}' unless defined(&NG_PPP_MAX_LATENCY);
    eval 'sub NG_PPP_MAX_BANDWIDTH () {125000;}' unless defined(&NG_PPP_MAX_BANDWIDTH);
    eval 'sub NG_PPP_HOOK_BYPASS () {"bypass";}' unless defined(&NG_PPP_HOOK_BYPASS);
    eval 'sub NG_PPP_HOOK_COMPRESS () {"compress";}' unless defined(&NG_PPP_HOOK_COMPRESS);
    eval 'sub NG_PPP_HOOK_DECOMPRESS () {"decompress";}' unless defined(&NG_PPP_HOOK_DECOMPRESS);
    eval 'sub NG_PPP_HOOK_ENCRYPT () {"encrypt";}' unless defined(&NG_PPP_HOOK_ENCRYPT);
    eval 'sub NG_PPP_HOOK_DECRYPT () {"decrypt";}' unless defined(&NG_PPP_HOOK_DECRYPT);
    eval 'sub NG_PPP_HOOK_VJC_IP () {"vjc_ip";}' unless defined(&NG_PPP_HOOK_VJC_IP);
    eval 'sub NG_PPP_HOOK_VJC_COMP () {"vjc_vjcomp";}' unless defined(&NG_PPP_HOOK_VJC_COMP);
    eval 'sub NG_PPP_HOOK_VJC_UNCOMP () {"vjc_vjuncomp";}' unless defined(&NG_PPP_HOOK_VJC_UNCOMP);
    eval 'sub NG_PPP_HOOK_VJC_VJIP () {"vjc_vjip";}' unless defined(&NG_PPP_HOOK_VJC_VJIP);
    eval 'sub NG_PPP_HOOK_INET () {"inet";}' unless defined(&NG_PPP_HOOK_INET);
    eval 'sub NG_PPP_HOOK_ATALK () {"atalk";}' unless defined(&NG_PPP_HOOK_ATALK);
    eval 'sub NG_PPP_HOOK_IPX () {"ipx";}' unless defined(&NG_PPP_HOOK_IPX);
    eval 'sub NG_PPP_HOOK_IPV6 () {"ipv6";}' unless defined(&NG_PPP_HOOK_IPV6);
    eval 'sub NG_PPP_HOOK_LINK_PREFIX () {"link";}' unless defined(&NG_PPP_HOOK_LINK_PREFIX);
    eval("sub NG_PPP_COMPRESS_NONE () { 0; }") unless defined(&NG_PPP_COMPRESS_NONE);
    eval("sub NG_PPP_COMPRESS_SIMPLE () { 1; }") unless defined(&NG_PPP_COMPRESS_SIMPLE);
    eval("sub NG_PPP_COMPRESS_FULL () { 2; }") unless defined(&NG_PPP_COMPRESS_FULL);
    eval("sub NG_PPP_DECOMPRESS_NONE () { 0; }") unless defined(&NG_PPP_DECOMPRESS_NONE);
    eval("sub NG_PPP_DECOMPRESS_SIMPLE () { 1; }") unless defined(&NG_PPP_DECOMPRESS_SIMPLE);
    eval("sub NG_PPP_DECOMPRESS_FULL () { 2; }") unless defined(&NG_PPP_DECOMPRESS_FULL);
    eval("sub NGM_PPP_SET_CONFIG () { 1; }") unless defined(&NGM_PPP_SET_CONFIG);
    eval("sub NGM_PPP_GET_CONFIG () { 2; }") unless defined(&NGM_PPP_GET_CONFIG);
    eval("sub NGM_PPP_GET_MP_STATE () { 3; }") unless defined(&NGM_PPP_GET_MP_STATE);
    eval("sub NGM_PPP_GET_LINK_STATS () { 4; }") unless defined(&NGM_PPP_GET_LINK_STATS);
    eval("sub NGM_PPP_CLR_LINK_STATS () { 5; }") unless defined(&NGM_PPP_CLR_LINK_STATS);
    eval("sub NGM_PPP_GETCLR_LINK_STATS () { 6; }") unless defined(&NGM_PPP_GETCLR_LINK_STATS);
    eval("sub NGM_PPP_GET_LINK_STATS64 () { 7; }") unless defined(&NGM_PPP_GET_LINK_STATS64);
    eval("sub NGM_PPP_GETCLR_LINK_STATS64 () { 8; }") unless defined(&NGM_PPP_GETCLR_LINK_STATS64);
    eval 'sub NG_PPP_MP_STATE_TYPE_INFO {
        my($atype) = @_;
	    eval q({ { \\"rseq\\", ($atype) }, { \\"mseq\\",  &ng_parse_hint32_type }, { \\"xseq\\",  &ng_parse_hint32_type }, {  &NULL } });
    }' unless defined(&NG_PPP_MP_STATE_TYPE_INFO);
    eval 'sub NG_PPP_LINK_TYPE_INFO () {{ { "enableLink",  &ng_parse_uint8_type }, { "enableProtoComp",  &ng_parse_uint8_type }, { "enableACFComp",  &ng_parse_uint8_type }, { "mru",  &ng_parse_uint16_type }, { "latency",  &ng_parse_uint32_type }, { "bandwidth",  &ng_parse_uint32_type }, {  &NULL } };}' unless defined(&NG_PPP_LINK_TYPE_INFO);
    eval 'sub NG_PPP_BUND_TYPE_INFO () {{ { "mrru",  &ng_parse_uint16_type }, { "enableMultilink",  &ng_parse_uint8_type }, { "recvShortSeq",  &ng_parse_uint8_type }, { "xmitShortSeq",  &ng_parse_uint8_type }, { "enableRoundRobin",  &ng_parse_uint8_type }, { "enableIP",  &ng_parse_uint8_type }, { "enableIPv6",  &ng_parse_uint8_type }, { "enableAtalk",  &ng_parse_uint8_type }, { "enableIPX",  &ng_parse_uint8_type }, { "enableCompression",  &ng_parse_uint8_type }, { "enableDecompression",  &ng_parse_uint8_type }, { "enableEncryption",  &ng_parse_uint8_type }, { "enableDecryption",  &ng_parse_uint8_type }, { "enableVJCompression",  &ng_parse_uint8_type }, { "enableVJDecompression",  &ng_parse_uint8_type }, {  &NULL } };}' unless defined(&NG_PPP_BUND_TYPE_INFO);
    eval 'sub NG_PPP_CONFIG_TYPE_INFO {
        my($bctype, $arytype) = @_;
	    eval q({ { \\"bund\\", ($bctype) }, { \\"links\\", ($arytype) }, {  &NULL } });
    }' unless defined(&NG_PPP_CONFIG_TYPE_INFO);
    eval 'sub NG_PPP_STATS_TYPE_INFO () {{ { "xmitFrames",  &ng_parse_uint32_type }, { "xmitOctets",  &ng_parse_uint32_type }, { "recvFrames",  &ng_parse_uint32_type }, { "recvOctets",  &ng_parse_uint32_type }, { "badProtos",  &ng_parse_uint32_type }, { "runts",  &ng_parse_uint32_type }, { "dupFragments",  &ng_parse_uint32_type }, { "dropFragments",  &ng_parse_uint32_type }, {  &NULL } };}' unless defined(&NG_PPP_STATS_TYPE_INFO);
    eval 'sub NG_PPP_STATS64_TYPE_INFO () {{ { "xmitFrames",  &ng_parse_uint64_type }, { "xmitOctets",  &ng_parse_uint64_type }, { "recvFrames",  &ng_parse_uint64_type }, { "recvOctets",  &ng_parse_uint64_type }, { "badProtos",  &ng_parse_uint64_type }, { "runts",  &ng_parse_uint64_type }, { "dupFragments",  &ng_parse_uint64_type }, { "dropFragments",  &ng_parse_uint64_type }, {  &NULL } };}' unless defined(&NG_PPP_STATS64_TYPE_INFO);
}
1;
