require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_IF_ETHER_H_)) {
    eval 'sub _NETINET_IF_ETHER_H_ () {1;}' unless defined(&_NETINET_IF_ETHER_H_);
    require 'net/ethernet.ph';
    require 'net/if_arp.ph';
    eval 'sub ETHER_MAP_IP_MULTICAST {
        my($ipaddr, $enaddr) = @_;
	    eval q({ ($enaddr)[0] = 0x1; ($enaddr)[1] = 0x; ($enaddr)[2] = 0x5e; ($enaddr)[3] = (( &const \'u_char\' *)$ipaddr)[1] & 0x7f; ($enaddr)[4] = (( &const \'u_char\' *)$ipaddr)[2]; ($enaddr)[5] = (( &const \'u_char\' *)$ipaddr)[3]; });
    }' unless defined(&ETHER_MAP_IP_MULTICAST);
    eval 'sub ETHER_MAP_IPV6_MULTICAST {
        my($ip6addr, $enaddr) = @_;
	    eval q({ ($enaddr)[0] = 0x33; ($enaddr)[1] = 0x33; ($enaddr)[2] = (( &const \'u_char\' *)$ip6addr)[12]; ($enaddr)[3] = (( &const \'u_char\' *)$ip6addr)[13]; ($enaddr)[4] = (( &const \'u_char\' *)$ip6addr)[14]; ($enaddr)[5] = (( &const \'u_char\' *)$ip6addr)[15]; });
    }' unless defined(&ETHER_MAP_IPV6_MULTICAST);
    eval 'sub arp_hrd () { ($ea_hdr->{ar_hrd});}' unless defined(&arp_hrd);
    eval 'sub arp_pro () { ($ea_hdr->{ar_pro});}' unless defined(&arp_pro);
    eval 'sub arp_hln () { ($ea_hdr->{ar_hln});}' unless defined(&arp_hln);
    eval 'sub arp_pln () { ($ea_hdr->{ar_pln});}' unless defined(&arp_pln);
    eval 'sub arp_op () { ($ea_hdr->{ar_op});}' unless defined(&arp_op);
    unless(defined(&BURN_BRIDGES)) {
	eval 'sub SIN_PROXY () {1;}' unless defined(&SIN_PROXY);
    }
    eval 'sub RTF_USETRAILERS () { &RTF_PROTO1;}' unless defined(&RTF_USETRAILERS);
    eval 'sub RTF_ANNOUNCE () { &RTF_PROTO2;}' unless defined(&RTF_ANNOUNCE);
    if(defined(&_KERNEL)) {
    }
}
1;
