require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NETINET_SCTP_H_)) {
    eval 'sub _NETINET_SCTP_H_ () {1;}' unless defined(&_NETINET_SCTP_H_);
    require 'sys/types.ph';
    eval 'sub SCTP_PACKED () { &__attribute__(( &packed));}' unless defined(&SCTP_PACKED);
    eval 'sub SCTP_RTOINFO () {0x1;}' unless defined(&SCTP_RTOINFO);
    eval 'sub SCTP_ASSOCINFO () {0x2;}' unless defined(&SCTP_ASSOCINFO);
    eval 'sub SCTP_INITMSG () {0x3;}' unless defined(&SCTP_INITMSG);
    eval 'sub SCTP_NODELAY () {0x4;}' unless defined(&SCTP_NODELAY);
    eval 'sub SCTP_AUTOCLOSE () {0x5;}' unless defined(&SCTP_AUTOCLOSE);
    eval 'sub SCTP_SET_PEER_PRIMARY_ADDR () {0x6;}' unless defined(&SCTP_SET_PEER_PRIMARY_ADDR);
    eval 'sub SCTP_PRIMARY_ADDR () {0x7;}' unless defined(&SCTP_PRIMARY_ADDR);
    eval 'sub SCTP_ADAPTATION_LAYER () {0x8;}' unless defined(&SCTP_ADAPTATION_LAYER);
    eval 'sub SCTP_ADAPTION_LAYER () {0x8;}' unless defined(&SCTP_ADAPTION_LAYER);
    eval 'sub SCTP_DISABLE_FRAGMENTS () {0x9;}' unless defined(&SCTP_DISABLE_FRAGMENTS);
    eval 'sub SCTP_PEER_ADDR_PARAMS () {0xa;}' unless defined(&SCTP_PEER_ADDR_PARAMS);
    eval 'sub SCTP_DEFAULT_SEND_PARAM () {0xb;}' unless defined(&SCTP_DEFAULT_SEND_PARAM);
    eval 'sub SCTP_EVENTS () {0xc;}' unless defined(&SCTP_EVENTS);
    eval 'sub SCTP_I_WANT_MAPPED_V4_ADDR () {0xd;}' unless defined(&SCTP_I_WANT_MAPPED_V4_ADDR);
    eval 'sub SCTP_MAXSEG () {0xe;}' unless defined(&SCTP_MAXSEG);
    eval 'sub SCTP_DELAYED_SACK () {0xf;}' unless defined(&SCTP_DELAYED_SACK);
    eval 'sub SCTP_FRAGMENT_INTERLEAVE () {0x10;}' unless defined(&SCTP_FRAGMENT_INTERLEAVE);
    eval 'sub SCTP_PARTIAL_DELIVERY_POINT () {0x11;}' unless defined(&SCTP_PARTIAL_DELIVERY_POINT);
    eval 'sub SCTP_AUTH_CHUNK () {0x12;}' unless defined(&SCTP_AUTH_CHUNK);
    eval 'sub SCTP_AUTH_KEY () {0x13;}' unless defined(&SCTP_AUTH_KEY);
    eval 'sub SCTP_HMAC_IDENT () {0x14;}' unless defined(&SCTP_HMAC_IDENT);
    eval 'sub SCTP_AUTH_ACTIVE_KEY () {0x15;}' unless defined(&SCTP_AUTH_ACTIVE_KEY);
    eval 'sub SCTP_AUTH_DELETE_KEY () {0x16;}' unless defined(&SCTP_AUTH_DELETE_KEY);
    eval 'sub SCTP_USE_EXT_RCVINFO () {0x17;}' unless defined(&SCTP_USE_EXT_RCVINFO);
    eval 'sub SCTP_AUTO_ASCONF () {0x18;}' unless defined(&SCTP_AUTO_ASCONF);
    eval 'sub SCTP_MAXBURST () {0x19;}' unless defined(&SCTP_MAXBURST);
    eval 'sub SCTP_MAX_BURST () {0x19;}' unless defined(&SCTP_MAX_BURST);
    eval 'sub SCTP_CONTEXT () {0x1a;}' unless defined(&SCTP_CONTEXT);
    eval 'sub SCTP_EXPLICIT_EOR () {0x1b;}' unless defined(&SCTP_EXPLICIT_EOR);
    eval 'sub SCTP_REUSE_PORT () {0x1c;}' unless defined(&SCTP_REUSE_PORT);
    eval 'sub SCTP_AUTH_DEACTIVATE_KEY () {0x1d;}' unless defined(&SCTP_AUTH_DEACTIVATE_KEY);
    eval 'sub SCTP_EVENT () {0x1e;}' unless defined(&SCTP_EVENT);
    eval 'sub SCTP_RECVRCVINFO () {0x1f;}' unless defined(&SCTP_RECVRCVINFO);
    eval 'sub SCTP_RECVNXTINFO () {0x20;}' unless defined(&SCTP_RECVNXTINFO);
    eval 'sub SCTP_DEFAULT_SNDINFO () {0x21;}' unless defined(&SCTP_DEFAULT_SNDINFO);
    eval 'sub SCTP_DEFAULT_PRINFO () {0x22;}' unless defined(&SCTP_DEFAULT_PRINFO);
    eval 'sub SCTP_PEER_ADDR_THLDS () {0x23;}' unless defined(&SCTP_PEER_ADDR_THLDS);
    eval 'sub SCTP_REMOTE_UDP_ENCAPS_PORT () {0x24;}' unless defined(&SCTP_REMOTE_UDP_ENCAPS_PORT);
    eval 'sub SCTP_ECN_SUPPORTED () {0x25;}' unless defined(&SCTP_ECN_SUPPORTED);
    eval 'sub SCTP_PR_SUPPORTED () {0x26;}' unless defined(&SCTP_PR_SUPPORTED);
    eval 'sub SCTP_AUTH_SUPPORTED () {0x27;}' unless defined(&SCTP_AUTH_SUPPORTED);
    eval 'sub SCTP_ASCONF_SUPPORTED () {0x28;}' unless defined(&SCTP_ASCONF_SUPPORTED);
    eval 'sub SCTP_RECONFIG_SUPPORTED () {0x29;}' unless defined(&SCTP_RECONFIG_SUPPORTED);
    eval 'sub SCTP_NRSACK_SUPPORTED () {0x30;}' unless defined(&SCTP_NRSACK_SUPPORTED);
    eval 'sub SCTP_PKTDROP_SUPPORTED () {0x31;}' unless defined(&SCTP_PKTDROP_SUPPORTED);
    eval 'sub SCTP_MAX_CWND () {0x32;}' unless defined(&SCTP_MAX_CWND);
    eval 'sub SCTP_STATUS () {0x100;}' unless defined(&SCTP_STATUS);
    eval 'sub SCTP_GET_PEER_ADDR_INFO () {0x101;}' unless defined(&SCTP_GET_PEER_ADDR_INFO);
    eval 'sub SCTP_PEER_AUTH_CHUNKS () {0x102;}' unless defined(&SCTP_PEER_AUTH_CHUNKS);
    eval 'sub SCTP_LOCAL_AUTH_CHUNKS () {0x103;}' unless defined(&SCTP_LOCAL_AUTH_CHUNKS);
    eval 'sub SCTP_GET_ASSOC_NUMBER () {0x104;}' unless defined(&SCTP_GET_ASSOC_NUMBER);
    eval 'sub SCTP_GET_ASSOC_ID_LIST () {0x105;}' unless defined(&SCTP_GET_ASSOC_ID_LIST);
    eval 'sub SCTP_TIMEOUTS () {0x106;}' unless defined(&SCTP_TIMEOUTS);
    eval 'sub SCTP_PR_STREAM_STATUS () {0x107;}' unless defined(&SCTP_PR_STREAM_STATUS);
    eval 'sub SCTP_PR_ASSOC_STATUS () {0x108;}' unless defined(&SCTP_PR_ASSOC_STATUS);
    eval 'sub SCTP_ENABLE_STREAM_RESET () {0x900;}' unless defined(&SCTP_ENABLE_STREAM_RESET);
    eval 'sub SCTP_RESET_STREAMS () {0x901;}' unless defined(&SCTP_RESET_STREAMS);
    eval 'sub SCTP_RESET_ASSOC () {0x902;}' unless defined(&SCTP_RESET_ASSOC);
    eval 'sub SCTP_ADD_STREAMS () {0x903;}' unless defined(&SCTP_ADD_STREAMS);
    eval 'sub SCTP_ENABLE_RESET_STREAM_REQ () {0x1;}' unless defined(&SCTP_ENABLE_RESET_STREAM_REQ);
    eval 'sub SCTP_ENABLE_RESET_ASSOC_REQ () {0x2;}' unless defined(&SCTP_ENABLE_RESET_ASSOC_REQ);
    eval 'sub SCTP_ENABLE_CHANGE_ASSOC_REQ () {0x4;}' unless defined(&SCTP_ENABLE_CHANGE_ASSOC_REQ);
    eval 'sub SCTP_ENABLE_VALUE_MASK () {0x7;}' unless defined(&SCTP_ENABLE_VALUE_MASK);
    eval 'sub SCTP_STREAM_RESET_INCOMING () {0x1;}' unless defined(&SCTP_STREAM_RESET_INCOMING);
    eval 'sub SCTP_STREAM_RESET_OUTGOING () {0x2;}' unless defined(&SCTP_STREAM_RESET_OUTGOING);
    eval 'sub SCTP_SET_DEBUG_LEVEL () {0x1005;}' unless defined(&SCTP_SET_DEBUG_LEVEL);
    eval 'sub SCTP_CLR_STAT_LOG () {0x1007;}' unless defined(&SCTP_CLR_STAT_LOG);
    eval 'sub SCTP_CMT_ON_OFF () {0x1200;}' unless defined(&SCTP_CMT_ON_OFF);
    eval 'sub SCTP_CMT_USE_DAC () {0x1201;}' unless defined(&SCTP_CMT_USE_DAC);
    eval 'sub SCTP_PLUGGABLE_CC () {0x1202;}' unless defined(&SCTP_PLUGGABLE_CC);
    eval 'sub SCTP_PLUGGABLE_SS () {0x1203;}' unless defined(&SCTP_PLUGGABLE_SS);
    eval 'sub SCTP_SS_VALUE () {0x1204;}' unless defined(&SCTP_SS_VALUE);
    eval 'sub SCTP_CC_OPTION () {0x1205;}' unless defined(&SCTP_CC_OPTION);
    eval 'sub SCTP_INTERLEAVING_SUPPORTED () {0x1206;}' unless defined(&SCTP_INTERLEAVING_SUPPORTED);
    eval 'sub SCTP_GET_SNDBUF_USE () {0x1101;}' unless defined(&SCTP_GET_SNDBUF_USE);
    eval 'sub SCTP_GET_STAT_LOG () {0x1103;}' unless defined(&SCTP_GET_STAT_LOG);
    eval 'sub SCTP_PCB_STATUS () {0x1104;}' unless defined(&SCTP_PCB_STATUS);
    eval 'sub SCTP_GET_NONCE_VALUES () {0x1105;}' unless defined(&SCTP_GET_NONCE_VALUES);
    eval 'sub SCTP_SET_DYNAMIC_PRIMARY () {0x2001;}' unless defined(&SCTP_SET_DYNAMIC_PRIMARY);
    eval 'sub SCTP_VRF_ID () {0x3001;}' unless defined(&SCTP_VRF_ID);
    eval 'sub SCTP_ADD_VRF_ID () {0x3002;}' unless defined(&SCTP_ADD_VRF_ID);
    eval 'sub SCTP_GET_VRF_IDS () {0x3003;}' unless defined(&SCTP_GET_VRF_IDS);
    eval 'sub SCTP_GET_ASOC_VRF () {0x3004;}' unless defined(&SCTP_GET_ASOC_VRF);
    eval 'sub SCTP_DEL_VRF_ID () {0x3005;}' unless defined(&SCTP_DEL_VRF_ID);
    eval 'sub SCTP_GET_PACKET_LOG () {0x4001;}' unless defined(&SCTP_GET_PACKET_LOG);
    eval 'sub SCTP_BINDX_ADD_ADDR () {0x8001;}' unless defined(&SCTP_BINDX_ADD_ADDR);
    eval 'sub SCTP_BINDX_REM_ADDR () {0x8002;}' unless defined(&SCTP_BINDX_REM_ADDR);
    eval 'sub SCTP_GET_PEER_ADDRESSES () {0x8003;}' unless defined(&SCTP_GET_PEER_ADDRESSES);
    eval 'sub SCTP_GET_LOCAL_ADDRESSES () {0x8004;}' unless defined(&SCTP_GET_LOCAL_ADDRESSES);
    eval 'sub SCTP_GET_LOCAL_ADDR_SIZE () {0x8005;}' unless defined(&SCTP_GET_LOCAL_ADDR_SIZE);
    eval 'sub SCTP_GET_REMOTE_ADDR_SIZE () {0x8006;}' unless defined(&SCTP_GET_REMOTE_ADDR_SIZE);
    eval 'sub SCTP_CONNECT_X () {0x8007;}' unless defined(&SCTP_CONNECT_X);
    eval 'sub SCTP_CONNECT_X_DELAYED () {0x8008;}' unless defined(&SCTP_CONNECT_X_DELAYED);
    eval 'sub SCTP_CONNECT_X_COMPLETE () {0x8009;}' unless defined(&SCTP_CONNECT_X_COMPLETE);
    eval 'sub SCTP_PEELOFF () {0x800a;}' unless defined(&SCTP_PEELOFF);
    eval 'sub SCTP_GET_ADDR_LEN () {0x800b;}' unless defined(&SCTP_GET_ADDR_LEN);
    eval 'sub SCTP_SET_INITIAL_DBG_SEQ () {0x9f00;}' unless defined(&SCTP_SET_INITIAL_DBG_SEQ);
    eval 'sub SCTP_CC_RFC2581 () {0x;}' unless defined(&SCTP_CC_RFC2581);
    eval 'sub SCTP_CC_HSTCP () {0x1;}' unless defined(&SCTP_CC_HSTCP);
    eval 'sub SCTP_CC_HTCP () {0x2;}' unless defined(&SCTP_CC_HTCP);
    eval 'sub SCTP_CC_RTCC () {0x3;}' unless defined(&SCTP_CC_RTCC);
    eval 'sub SCTP_CC_OPT_RTCC_SETMODE () {0x2000;}' unless defined(&SCTP_CC_OPT_RTCC_SETMODE);
    eval 'sub SCTP_CC_OPT_USE_DCCC_ECN () {0x2001;}' unless defined(&SCTP_CC_OPT_USE_DCCC_ECN);
    eval 'sub SCTP_CC_OPT_STEADY_STEP () {0x2002;}' unless defined(&SCTP_CC_OPT_STEADY_STEP);
    eval 'sub SCTP_CMT_OFF () {0;}' unless defined(&SCTP_CMT_OFF);
    eval 'sub SCTP_CMT_BASE () {1;}' unless defined(&SCTP_CMT_BASE);
    eval 'sub SCTP_CMT_RPV1 () {2;}' unless defined(&SCTP_CMT_RPV1);
    eval 'sub SCTP_CMT_RPV2 () {3;}' unless defined(&SCTP_CMT_RPV2);
    eval 'sub SCTP_CMT_MPTCP () {4;}' unless defined(&SCTP_CMT_MPTCP);
    eval 'sub SCTP_CMT_MAX () { &SCTP_CMT_MPTCP;}' unless defined(&SCTP_CMT_MAX);
    eval 'sub SCTP_SS_DEFAULT () {0x;}' unless defined(&SCTP_SS_DEFAULT);
    eval 'sub SCTP_SS_ROUND_ROBIN () {0x1;}' unless defined(&SCTP_SS_ROUND_ROBIN);
    eval 'sub SCTP_SS_ROUND_ROBIN_PACKET () {0x2;}' unless defined(&SCTP_SS_ROUND_ROBIN_PACKET);
    eval 'sub SCTP_SS_PRIORITY () {0x3;}' unless defined(&SCTP_SS_PRIORITY);
    eval 'sub SCTP_SS_FAIR_BANDWITH () {0x4;}' unless defined(&SCTP_SS_FAIR_BANDWITH);
    eval 'sub SCTP_SS_FIRST_COME () {0x5;}' unless defined(&SCTP_SS_FIRST_COME);
    eval 'sub SCTP_FRAG_LEVEL_0 () {0x;}' unless defined(&SCTP_FRAG_LEVEL_0);
    eval 'sub SCTP_FRAG_LEVEL_1 () {0x1;}' unless defined(&SCTP_FRAG_LEVEL_1);
    eval 'sub SCTP_FRAG_LEVEL_2 () {0x2;}' unless defined(&SCTP_FRAG_LEVEL_2);
    eval 'sub SCTP_CLOSED () {0x;}' unless defined(&SCTP_CLOSED);
    eval 'sub SCTP_BOUND () {0x1000;}' unless defined(&SCTP_BOUND);
    eval 'sub SCTP_LISTEN () {0x2000;}' unless defined(&SCTP_LISTEN);
    eval 'sub SCTP_COOKIE_WAIT () {0x2;}' unless defined(&SCTP_COOKIE_WAIT);
    eval 'sub SCTP_COOKIE_ECHOED () {0x4;}' unless defined(&SCTP_COOKIE_ECHOED);
    eval 'sub SCTP_ESTABLISHED () {0x8;}' unless defined(&SCTP_ESTABLISHED);
    eval 'sub SCTP_SHUTDOWN_SENT () {0x10;}' unless defined(&SCTP_SHUTDOWN_SENT);
    eval 'sub SCTP_SHUTDOWN_RECEIVED () {0x20;}' unless defined(&SCTP_SHUTDOWN_RECEIVED);
    eval 'sub SCTP_SHUTDOWN_ACK_SENT () {0x40;}' unless defined(&SCTP_SHUTDOWN_ACK_SENT);
    eval 'sub SCTP_SHUTDOWN_PENDING () {0x80;}' unless defined(&SCTP_SHUTDOWN_PENDING);
    eval 'sub SCTP_CAUSE_NO_ERROR () {0x;}' unless defined(&SCTP_CAUSE_NO_ERROR);
    eval 'sub SCTP_CAUSE_INVALID_STREAM () {0x1;}' unless defined(&SCTP_CAUSE_INVALID_STREAM);
    eval 'sub SCTP_CAUSE_MISSING_PARAM () {0x2;}' unless defined(&SCTP_CAUSE_MISSING_PARAM);
    eval 'sub SCTP_CAUSE_STALE_COOKIE () {0x3;}' unless defined(&SCTP_CAUSE_STALE_COOKIE);
    eval 'sub SCTP_CAUSE_OUT_OF_RESC () {0x4;}' unless defined(&SCTP_CAUSE_OUT_OF_RESC);
    eval 'sub SCTP_CAUSE_UNRESOLVABLE_ADDR () {0x5;}' unless defined(&SCTP_CAUSE_UNRESOLVABLE_ADDR);
    eval 'sub SCTP_CAUSE_UNRECOG_CHUNK () {0x6;}' unless defined(&SCTP_CAUSE_UNRECOG_CHUNK);
    eval 'sub SCTP_CAUSE_INVALID_PARAM () {0x7;}' unless defined(&SCTP_CAUSE_INVALID_PARAM);
    eval 'sub SCTP_CAUSE_UNRECOG_PARAM () {0x8;}' unless defined(&SCTP_CAUSE_UNRECOG_PARAM);
    eval 'sub SCTP_CAUSE_NO_USER_DATA () {0x9;}' unless defined(&SCTP_CAUSE_NO_USER_DATA);
    eval 'sub SCTP_CAUSE_COOKIE_IN_SHUTDOWN () {0xa;}' unless defined(&SCTP_CAUSE_COOKIE_IN_SHUTDOWN);
    eval 'sub SCTP_CAUSE_RESTART_W_NEWADDR () {0xb;}' unless defined(&SCTP_CAUSE_RESTART_W_NEWADDR);
    eval 'sub SCTP_CAUSE_USER_INITIATED_ABT () {0xc;}' unless defined(&SCTP_CAUSE_USER_INITIATED_ABT);
    eval 'sub SCTP_CAUSE_PROTOCOL_VIOLATION () {0xd;}' unless defined(&SCTP_CAUSE_PROTOCOL_VIOLATION);
    eval 'sub SCTP_CAUSE_DELETING_LAST_ADDR () {0xa0;}' unless defined(&SCTP_CAUSE_DELETING_LAST_ADDR);
    eval 'sub SCTP_CAUSE_RESOURCE_SHORTAGE () {0xa1;}' unless defined(&SCTP_CAUSE_RESOURCE_SHORTAGE);
    eval 'sub SCTP_CAUSE_DELETING_SRC_ADDR () {0xa2;}' unless defined(&SCTP_CAUSE_DELETING_SRC_ADDR);
    eval 'sub SCTP_CAUSE_ILLEGAL_ASCONF_ACK () {0xa3;}' unless defined(&SCTP_CAUSE_ILLEGAL_ASCONF_ACK);
    eval 'sub SCTP_CAUSE_REQUEST_REFUSED () {0xa4;}' unless defined(&SCTP_CAUSE_REQUEST_REFUSED);
    eval 'sub SCTP_CAUSE_NAT_COLLIDING_STATE () {0xb0;}' unless defined(&SCTP_CAUSE_NAT_COLLIDING_STATE);
    eval 'sub SCTP_CAUSE_NAT_MISSING_STATE () {0xb1;}' unless defined(&SCTP_CAUSE_NAT_MISSING_STATE);
    eval 'sub SCTP_CAUSE_UNSUPPORTED_HMACID () {0x105;}' unless defined(&SCTP_CAUSE_UNSUPPORTED_HMACID);
    eval 'sub SCTP_DATA () {0x;}' unless defined(&SCTP_DATA);
    eval 'sub SCTP_INITIATION () {0x1;}' unless defined(&SCTP_INITIATION);
    eval 'sub SCTP_INITIATION_ACK () {0x2;}' unless defined(&SCTP_INITIATION_ACK);
    eval 'sub SCTP_SELECTIVE_ACK () {0x3;}' unless defined(&SCTP_SELECTIVE_ACK);
    eval 'sub SCTP_HEARTBEAT_REQUEST () {0x4;}' unless defined(&SCTP_HEARTBEAT_REQUEST);
    eval 'sub SCTP_HEARTBEAT_ACK () {0x5;}' unless defined(&SCTP_HEARTBEAT_ACK);
    eval 'sub SCTP_ABORT_ASSOCIATION () {0x6;}' unless defined(&SCTP_ABORT_ASSOCIATION);
    eval 'sub SCTP_SHUTDOWN () {0x7;}' unless defined(&SCTP_SHUTDOWN);
    eval 'sub SCTP_SHUTDOWN_ACK () {0x8;}' unless defined(&SCTP_SHUTDOWN_ACK);
    eval 'sub SCTP_OPERATION_ERROR () {0x9;}' unless defined(&SCTP_OPERATION_ERROR);
    eval 'sub SCTP_COOKIE_ECHO () {0xa;}' unless defined(&SCTP_COOKIE_ECHO);
    eval 'sub SCTP_COOKIE_ACK () {0xb;}' unless defined(&SCTP_COOKIE_ACK);
    eval 'sub SCTP_ECN_ECHO () {0xc;}' unless defined(&SCTP_ECN_ECHO);
    eval 'sub SCTP_ECN_CWR () {0xd;}' unless defined(&SCTP_ECN_CWR);
    eval 'sub SCTP_SHUTDOWN_COMPLETE () {0xe;}' unless defined(&SCTP_SHUTDOWN_COMPLETE);
    eval 'sub SCTP_AUTHENTICATION () {0xf;}' unless defined(&SCTP_AUTHENTICATION);
    eval 'sub SCTP_NR_SELECTIVE_ACK () {0x10;}' unless defined(&SCTP_NR_SELECTIVE_ACK);
    eval 'sub SCTP_IDATA () {0x40;}' unless defined(&SCTP_IDATA);
    eval 'sub SCTP_ASCONF_ACK () {0x80;}' unless defined(&SCTP_ASCONF_ACK);
    eval 'sub SCTP_PACKET_DROPPED () {0x81;}' unless defined(&SCTP_PACKET_DROPPED);
    eval 'sub SCTP_STREAM_RESET () {0x82;}' unless defined(&SCTP_STREAM_RESET);
    eval 'sub SCTP_PAD_CHUNK () {0x84;}' unless defined(&SCTP_PAD_CHUNK);
    eval 'sub SCTP_FORWARD_CUM_TSN () {0xc0;}' unless defined(&SCTP_FORWARD_CUM_TSN);
    eval 'sub SCTP_ASCONF () {0xc1;}' unless defined(&SCTP_ASCONF);
    eval 'sub SCTP_IFORWARD_CUM_TSN () {0xc2;}' unless defined(&SCTP_IFORWARD_CUM_TSN);
    eval 'sub SCTP_HAD_NO_TCB () {0x1;}' unless defined(&SCTP_HAD_NO_TCB);
    eval 'sub SCTP_FROM_MIDDLE_BOX () { &SCTP_HAD_NO_TCB;}' unless defined(&SCTP_FROM_MIDDLE_BOX);
    eval 'sub SCTP_BADCRC () {0x2;}' unless defined(&SCTP_BADCRC);
    eval 'sub SCTP_PACKET_TRUNCATED () {0x4;}' unless defined(&SCTP_PACKET_TRUNCATED);
    eval 'sub SCTP_CWR_REDUCE_OVERRIDE () {0x1;}' unless defined(&SCTP_CWR_REDUCE_OVERRIDE);
    eval 'sub SCTP_CWR_IN_SAME_WINDOW () {0x2;}' unless defined(&SCTP_CWR_IN_SAME_WINDOW);
    eval 'sub SCTP_SAT_NETWORK_MIN () {400;}' unless defined(&SCTP_SAT_NETWORK_MIN);
    eval 'sub SCTP_SAT_NETWORK_BURST_INCR () {2;}' unless defined(&SCTP_SAT_NETWORK_BURST_INCR);
    eval 'sub SCTP_DATA_FRAG_MASK () {0x3;}' unless defined(&SCTP_DATA_FRAG_MASK);
    eval 'sub SCTP_DATA_MIDDLE_FRAG () {0x;}' unless defined(&SCTP_DATA_MIDDLE_FRAG);
    eval 'sub SCTP_DATA_LAST_FRAG () {0x1;}' unless defined(&SCTP_DATA_LAST_FRAG);
    eval 'sub SCTP_DATA_FIRST_FRAG () {0x2;}' unless defined(&SCTP_DATA_FIRST_FRAG);
    eval 'sub SCTP_DATA_NOT_FRAG () {0x3;}' unless defined(&SCTP_DATA_NOT_FRAG);
    eval 'sub SCTP_DATA_UNORDERED () {0x4;}' unless defined(&SCTP_DATA_UNORDERED);
    eval 'sub SCTP_DATA_SACK_IMMEDIATELY () {0x8;}' unless defined(&SCTP_DATA_SACK_IMMEDIATELY);
    eval 'sub SCTP_SACK_NONCE_SUM () {0x1;}' unless defined(&SCTP_SACK_NONCE_SUM);
    eval 'sub SCTP_SACK_CMT_DAC () {0x80;}' unless defined(&SCTP_SACK_CMT_DAC);
    eval 'sub SCTP_PCB_FLAGS_UDPTYPE () {0x1;}' unless defined(&SCTP_PCB_FLAGS_UDPTYPE);
    eval 'sub SCTP_PCB_FLAGS_TCPTYPE () {0x2;}' unless defined(&SCTP_PCB_FLAGS_TCPTYPE);
    eval 'sub SCTP_PCB_FLAGS_BOUNDALL () {0x4;}' unless defined(&SCTP_PCB_FLAGS_BOUNDALL);
    eval 'sub SCTP_PCB_FLAGS_ACCEPTING () {0x8;}' unless defined(&SCTP_PCB_FLAGS_ACCEPTING);
    eval 'sub SCTP_PCB_FLAGS_UNBOUND () {0x10;}' unless defined(&SCTP_PCB_FLAGS_UNBOUND);
    eval 'sub SCTP_PCB_FLAGS_CLOSE_IP () {0x40000;}' unless defined(&SCTP_PCB_FLAGS_CLOSE_IP);
    eval 'sub SCTP_PCB_FLAGS_WAS_CONNECTED () {0x80000;}' unless defined(&SCTP_PCB_FLAGS_WAS_CONNECTED);
    eval 'sub SCTP_PCB_FLAGS_WAS_ABORTED () {0x100000;}' unless defined(&SCTP_PCB_FLAGS_WAS_ABORTED);
    eval 'sub SCTP_PCB_FLAGS_CONNECTED () {0x200000;}' unless defined(&SCTP_PCB_FLAGS_CONNECTED);
    eval 'sub SCTP_PCB_FLAGS_IN_TCPPOOL () {0x400000;}' unless defined(&SCTP_PCB_FLAGS_IN_TCPPOOL);
    eval 'sub SCTP_PCB_FLAGS_DONT_WAKE () {0x800000;}' unless defined(&SCTP_PCB_FLAGS_DONT_WAKE);
    eval 'sub SCTP_PCB_FLAGS_WAKEOUTPUT () {0x1000000;}' unless defined(&SCTP_PCB_FLAGS_WAKEOUTPUT);
    eval 'sub SCTP_PCB_FLAGS_WAKEINPUT () {0x2000000;}' unless defined(&SCTP_PCB_FLAGS_WAKEINPUT);
    eval 'sub SCTP_PCB_FLAGS_BOUND_V6 () {0x4000000;}' unless defined(&SCTP_PCB_FLAGS_BOUND_V6);
    eval 'sub SCTP_PCB_FLAGS_BLOCKING_IO () {0x8000000;}' unless defined(&SCTP_PCB_FLAGS_BLOCKING_IO);
    eval 'sub SCTP_PCB_FLAGS_SOCKET_GONE () {0x10000000;}' unless defined(&SCTP_PCB_FLAGS_SOCKET_GONE);
    eval 'sub SCTP_PCB_FLAGS_SOCKET_ALLGONE () {0x20000000;}' unless defined(&SCTP_PCB_FLAGS_SOCKET_ALLGONE);
    eval 'sub SCTP_PCB_FLAGS_SOCKET_CANT_READ () {0x40000000;}' unless defined(&SCTP_PCB_FLAGS_SOCKET_CANT_READ);
    eval 'sub SCTP_PCB_COPY_FLAGS () {( &SCTP_PCB_FLAGS_BOUNDALL|  &SCTP_PCB_FLAGS_WAKEINPUT|  &SCTP_PCB_FLAGS_BOUND_V6);}' unless defined(&SCTP_PCB_COPY_FLAGS);
    eval 'sub SCTP_PCB_FLAGS_DO_NOT_PMTUD () {0x1;}' unless defined(&SCTP_PCB_FLAGS_DO_NOT_PMTUD);
    eval 'sub SCTP_PCB_FLAGS_EXT_RCVINFO () {0x2;}' unless defined(&SCTP_PCB_FLAGS_EXT_RCVINFO);
    eval 'sub SCTP_PCB_FLAGS_DONOT_HEARTBEAT () {0x4;}' unless defined(&SCTP_PCB_FLAGS_DONOT_HEARTBEAT);
    eval 'sub SCTP_PCB_FLAGS_FRAG_INTERLEAVE () {0x8;}' unless defined(&SCTP_PCB_FLAGS_FRAG_INTERLEAVE);
    eval 'sub SCTP_PCB_FLAGS_INTERLEAVE_STRMS () {0x10;}' unless defined(&SCTP_PCB_FLAGS_INTERLEAVE_STRMS);
    eval 'sub SCTP_PCB_FLAGS_DO_ASCONF () {0x20;}' unless defined(&SCTP_PCB_FLAGS_DO_ASCONF);
    eval 'sub SCTP_PCB_FLAGS_AUTO_ASCONF () {0x40;}' unless defined(&SCTP_PCB_FLAGS_AUTO_ASCONF);
    eval 'sub SCTP_PCB_FLAGS_NODELAY () {0x100;}' unless defined(&SCTP_PCB_FLAGS_NODELAY);
    eval 'sub SCTP_PCB_FLAGS_AUTOCLOSE () {0x200;}' unless defined(&SCTP_PCB_FLAGS_AUTOCLOSE);
    eval 'sub SCTP_PCB_FLAGS_RECVDATAIOEVNT () {0x400;}' unless defined(&SCTP_PCB_FLAGS_RECVDATAIOEVNT);
    eval 'sub SCTP_PCB_FLAGS_RECVASSOCEVNT () {0x800;}' unless defined(&SCTP_PCB_FLAGS_RECVASSOCEVNT);
    eval 'sub SCTP_PCB_FLAGS_RECVPADDREVNT () {0x1000;}' unless defined(&SCTP_PCB_FLAGS_RECVPADDREVNT);
    eval 'sub SCTP_PCB_FLAGS_RECVPEERERR () {0x2000;}' unless defined(&SCTP_PCB_FLAGS_RECVPEERERR);
    eval 'sub SCTP_PCB_FLAGS_RECVSENDFAILEVNT () {0x4000;}' unless defined(&SCTP_PCB_FLAGS_RECVSENDFAILEVNT);
    eval 'sub SCTP_PCB_FLAGS_RECVSHUTDOWNEVNT () {0x8000;}' unless defined(&SCTP_PCB_FLAGS_RECVSHUTDOWNEVNT);
    eval 'sub SCTP_PCB_FLAGS_ADAPTATIONEVNT () {0x10000;}' unless defined(&SCTP_PCB_FLAGS_ADAPTATIONEVNT);
    eval 'sub SCTP_PCB_FLAGS_PDAPIEVNT () {0x20000;}' unless defined(&SCTP_PCB_FLAGS_PDAPIEVNT);
    eval 'sub SCTP_PCB_FLAGS_AUTHEVNT () {0x40000;}' unless defined(&SCTP_PCB_FLAGS_AUTHEVNT);
    eval 'sub SCTP_PCB_FLAGS_STREAM_RESETEVNT () {0x80000;}' unless defined(&SCTP_PCB_FLAGS_STREAM_RESETEVNT);
    eval 'sub SCTP_PCB_FLAGS_NO_FRAGMENT () {0x100000;}' unless defined(&SCTP_PCB_FLAGS_NO_FRAGMENT);
    eval 'sub SCTP_PCB_FLAGS_EXPLICIT_EOR () {0x400000;}' unless defined(&SCTP_PCB_FLAGS_EXPLICIT_EOR);
    eval 'sub SCTP_PCB_FLAGS_NEEDS_MAPPED_V4 () {0x800000;}' unless defined(&SCTP_PCB_FLAGS_NEEDS_MAPPED_V4);
    eval 'sub SCTP_PCB_FLAGS_MULTIPLE_ASCONFS () {0x1000000;}' unless defined(&SCTP_PCB_FLAGS_MULTIPLE_ASCONFS);
    eval 'sub SCTP_PCB_FLAGS_PORTREUSE () {0x2000000;}' unless defined(&SCTP_PCB_FLAGS_PORTREUSE);
    eval 'sub SCTP_PCB_FLAGS_DRYEVNT () {0x4000000;}' unless defined(&SCTP_PCB_FLAGS_DRYEVNT);
    eval 'sub SCTP_PCB_FLAGS_RECVRCVINFO () {0x8000000;}' unless defined(&SCTP_PCB_FLAGS_RECVRCVINFO);
    eval 'sub SCTP_PCB_FLAGS_RECVNXTINFO () {0x10000000;}' unless defined(&SCTP_PCB_FLAGS_RECVNXTINFO);
    eval 'sub SCTP_PCB_FLAGS_ASSOC_RESETEVNT () {0x20000000;}' unless defined(&SCTP_PCB_FLAGS_ASSOC_RESETEVNT);
    eval 'sub SCTP_PCB_FLAGS_STREAM_CHANGEEVNT () {0x40000000;}' unless defined(&SCTP_PCB_FLAGS_STREAM_CHANGEEVNT);
    eval 'sub SCTP_PCB_FLAGS_RECVNSENDFAILEVNT () {0x80000000;}' unless defined(&SCTP_PCB_FLAGS_RECVNSENDFAILEVNT);
    eval 'sub SCTP_MOBILITY_BASE () {0x1;}' unless defined(&SCTP_MOBILITY_BASE);
    eval 'sub SCTP_MOBILITY_FASTHANDOFF () {0x2;}' unless defined(&SCTP_MOBILITY_FASTHANDOFF);
    eval 'sub SCTP_MOBILITY_PRIM_DELETED () {0x4;}' unless defined(&SCTP_MOBILITY_PRIM_DELETED);
    eval 'sub SCTP_SMALLEST_PMTU () {512;}' unless defined(&SCTP_SMALLEST_PMTU);
    undef(&SCTP_PACKED) if defined(&SCTP_PACKED);
    require 'netinet/sctp_uio.ph';
    eval 'sub SCTP_PACKET_LOG_SIZE () {65536;}' unless defined(&SCTP_PACKET_LOG_SIZE);
    eval 'sub SCTP_MAX_SACK_DELAY () {500;}' unless defined(&SCTP_MAX_SACK_DELAY);
    eval 'sub SCTP_MAX_HB_INTERVAL () {14400000;}' unless defined(&SCTP_MAX_HB_INTERVAL);
    eval 'sub SCTP_MAX_COOKIE_LIFE () {3600000;}' unless defined(&SCTP_MAX_COOKIE_LIFE);
    eval 'sub SCTP_BLK_LOGGING_ENABLE () {0x1;}' unless defined(&SCTP_BLK_LOGGING_ENABLE);
    eval 'sub SCTP_CWND_MONITOR_ENABLE () {0x2;}' unless defined(&SCTP_CWND_MONITOR_ENABLE);
    eval 'sub SCTP_CWND_LOGGING_ENABLE () {0x4;}' unless defined(&SCTP_CWND_LOGGING_ENABLE);
    eval 'sub SCTP_FLIGHT_LOGGING_ENABLE () {0x20;}' unless defined(&SCTP_FLIGHT_LOGGING_ENABLE);
    eval 'sub SCTP_FR_LOGGING_ENABLE () {0x40;}' unless defined(&SCTP_FR_LOGGING_ENABLE);
    eval 'sub SCTP_LOCK_LOGGING_ENABLE () {0x80;}' unless defined(&SCTP_LOCK_LOGGING_ENABLE);
    eval 'sub SCTP_MAP_LOGGING_ENABLE () {0x100;}' unless defined(&SCTP_MAP_LOGGING_ENABLE);
    eval 'sub SCTP_MBCNT_LOGGING_ENABLE () {0x200;}' unless defined(&SCTP_MBCNT_LOGGING_ENABLE);
    eval 'sub SCTP_MBUF_LOGGING_ENABLE () {0x400;}' unless defined(&SCTP_MBUF_LOGGING_ENABLE);
    eval 'sub SCTP_NAGLE_LOGGING_ENABLE () {0x800;}' unless defined(&SCTP_NAGLE_LOGGING_ENABLE);
    eval 'sub SCTP_RECV_RWND_LOGGING_ENABLE () {0x1000;}' unless defined(&SCTP_RECV_RWND_LOGGING_ENABLE);
    eval 'sub SCTP_RTTVAR_LOGGING_ENABLE () {0x2000;}' unless defined(&SCTP_RTTVAR_LOGGING_ENABLE);
    eval 'sub SCTP_SACK_LOGGING_ENABLE () {0x4000;}' unless defined(&SCTP_SACK_LOGGING_ENABLE);
    eval 'sub SCTP_SACK_RWND_LOGGING_ENABLE () {0x8000;}' unless defined(&SCTP_SACK_RWND_LOGGING_ENABLE);
    eval 'sub SCTP_SB_LOGGING_ENABLE () {0x10000;}' unless defined(&SCTP_SB_LOGGING_ENABLE);
    eval 'sub SCTP_STR_LOGGING_ENABLE () {0x20000;}' unless defined(&SCTP_STR_LOGGING_ENABLE);
    eval 'sub SCTP_WAKE_LOGGING_ENABLE () {0x40000;}' unless defined(&SCTP_WAKE_LOGGING_ENABLE);
    eval 'sub SCTP_LOG_MAXBURST_ENABLE () {0x80000;}' unless defined(&SCTP_LOG_MAXBURST_ENABLE);
    eval 'sub SCTP_LOG_RWND_ENABLE () {0x100000;}' unless defined(&SCTP_LOG_RWND_ENABLE);
    eval 'sub SCTP_LOG_SACK_ARRIVALS_ENABLE () {0x200000;}' unless defined(&SCTP_LOG_SACK_ARRIVALS_ENABLE);
    eval 'sub SCTP_LTRACE_CHUNK_ENABLE () {0x400000;}' unless defined(&SCTP_LTRACE_CHUNK_ENABLE);
    eval 'sub SCTP_LTRACE_ERROR_ENABLE () {0x800000;}' unless defined(&SCTP_LTRACE_ERROR_ENABLE);
    eval 'sub SCTP_LAST_PACKET_TRACING () {0x1000000;}' unless defined(&SCTP_LAST_PACKET_TRACING);
    eval 'sub SCTP_THRESHOLD_LOGGING () {0x2000000;}' unless defined(&SCTP_THRESHOLD_LOGGING);
    eval 'sub SCTP_LOG_AT_SEND_2_SCTP () {0x4000000;}' unless defined(&SCTP_LOG_AT_SEND_2_SCTP);
    eval 'sub SCTP_LOG_AT_SEND_2_OUTQ () {0x8000000;}' unless defined(&SCTP_LOG_AT_SEND_2_OUTQ);
    eval 'sub SCTP_LOG_TRY_ADVANCE () {0x10000000;}' unless defined(&SCTP_LOG_TRY_ADVANCE);
}
1;
