require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NETINET_SCTP_HEADER_H_)) {
    eval 'sub _NETINET_SCTP_HEADER_H_ () {1;}' unless defined(&_NETINET_SCTP_HEADER_H_);
    require 'sys/time.ph';
    require 'netinet/sctp.ph';
    require 'netinet/sctp_constants.ph';
    eval 'sub SCTP_PACKED () { &__attribute__(( &packed));}' unless defined(&SCTP_PACKED);
    eval 'sub SCTP_V6_ADDR_BYTES () {16;}' unless defined(&SCTP_V6_ADDR_BYTES);
    eval 'sub SCTP_ARRAY_MIN_LEN () {1;}' unless defined(&SCTP_ARRAY_MIN_LEN);
    eval 'sub SCTP_MAX_ADDR_PARAMS_SIZE () {12;}' unless defined(&SCTP_MAX_ADDR_PARAMS_SIZE);
    eval 'sub SCTP_MAX_SUPPORTED_EXT () {256;}' unless defined(&SCTP_MAX_SUPPORTED_EXT);
    eval 'sub SCTP_IDENTIFICATION_SIZE () {16;}' unless defined(&SCTP_IDENTIFICATION_SIZE);
    eval 'sub SCTP_ADDRESS_SIZE () {4;}' unless defined(&SCTP_ADDRESS_SIZE);
    eval 'sub SCTP_RESERVE_SPACE () {6;}' unless defined(&SCTP_RESERVE_SPACE);
    eval 'sub sctp_init_ack () { &sctp_init;}' unless defined(&sctp_init_ack);
    eval 'sub sctp_init_ack_chunk () { &sctp_init_chunk;}' unless defined(&sctp_init_ack_chunk);
    eval 'sub sctp_init_ack_msg () { &sctp_init_msg;}' unless defined(&sctp_init_ack_msg);
    eval 'sub sctp_heartbeat_ack () { &sctp_heartbeat;}' unless defined(&sctp_heartbeat_ack);
    eval 'sub sctp_heartbeat_ack_chunk () { &sctp_heartbeat_chunk;}' unless defined(&sctp_heartbeat_ack_chunk);
    eval 'sub SCTP_NUM_DB_TO_VERIFY () {31;}' unless defined(&SCTP_NUM_DB_TO_VERIFY);
    eval 'sub SCTP_STREAM_RESET_RESULT_NOTHING_TO_DO () {0x;}' unless defined(&SCTP_STREAM_RESET_RESULT_NOTHING_TO_DO);
    eval 'sub SCTP_STREAM_RESET_RESULT_PERFORMED () {0x1;}' unless defined(&SCTP_STREAM_RESET_RESULT_PERFORMED);
    eval 'sub SCTP_STREAM_RESET_RESULT_DENIED () {0x2;}' unless defined(&SCTP_STREAM_RESET_RESULT_DENIED);
    eval 'sub SCTP_STREAM_RESET_RESULT_ERR__WRONG_SSN () {0x3;}' unless defined(&SCTP_STREAM_RESET_RESULT_ERR__WRONG_SSN);
    eval 'sub SCTP_STREAM_RESET_RESULT_ERR_IN_PROGRESS () {0x4;}' unless defined(&SCTP_STREAM_RESET_RESULT_ERR_IN_PROGRESS);
    eval 'sub SCTP_STREAM_RESET_RESULT_ERR_BAD_SEQNO () {0x5;}' unless defined(&SCTP_STREAM_RESET_RESULT_ERR_BAD_SEQNO);
    eval 'sub SCTP_STREAM_RESET_RESULT_IN_PROGRESS () {0x6;}' unless defined(&SCTP_STREAM_RESET_RESULT_IN_PROGRESS);
    eval 'sub SCTP_RANDOM_MAX_SIZE () {256;}' unless defined(&SCTP_RANDOM_MAX_SIZE);
    unless(defined(&SCTP_MAX_OVERHEAD)) {
	if(defined(&INET6)) {
	    eval 'sub SCTP_MAX_OVERHEAD () {($sizeof{\'struct sctp_data_chunk\'} + $sizeof{\'struct sctphdr\'} + $sizeof{\'struct sctp_ecne_chunk\'} + $sizeof{\'struct sctp_sack_chunk\'} + $sizeof{\'struct ip6_hdr\'});}' unless defined(&SCTP_MAX_OVERHEAD);
	    eval 'sub SCTP_MED_OVERHEAD () {($sizeof{\'struct sctp_data_chunk\'} + $sizeof{\'struct sctphdr\'} + $sizeof{\'struct ip6_hdr\'});}' unless defined(&SCTP_MED_OVERHEAD);
	    eval 'sub SCTP_MIN_OVERHEAD () {($sizeof{\'struct ip6_hdr\'} + $sizeof{\'struct sctphdr\'});}' unless defined(&SCTP_MIN_OVERHEAD);
	} else {
	    eval 'sub SCTP_MAX_OVERHEAD () {($sizeof{\'struct sctp_data_chunk\'} + $sizeof{\'struct sctphdr\'} + $sizeof{\'struct sctp_ecne_chunk\'} + $sizeof{\'struct sctp_sack_chunk\'} + $sizeof{\'struct ip\'});}' unless defined(&SCTP_MAX_OVERHEAD);
	    eval 'sub SCTP_MED_OVERHEAD () {($sizeof{\'struct sctp_data_chunk\'} + $sizeof{\'struct sctphdr\'} + $sizeof{\'struct ip\'});}' unless defined(&SCTP_MED_OVERHEAD);
	    eval 'sub SCTP_MIN_OVERHEAD () {($sizeof{\'struct ip\'} + $sizeof{\'struct sctphdr\'});}' unless defined(&SCTP_MIN_OVERHEAD);
	}
    }
    eval 'sub SCTP_MED_V4_OVERHEAD () {($sizeof{\'struct sctp_data_chunk\'} + $sizeof{\'struct sctphdr\'} + $sizeof{\'struct ip\'});}' unless defined(&SCTP_MED_V4_OVERHEAD);
    eval 'sub SCTP_MIN_V4_OVERHEAD () {($sizeof{\'struct ip\'} + $sizeof{\'struct sctphdr\'});}' unless defined(&SCTP_MIN_V4_OVERHEAD);
    undef(&SCTP_PACKED) if defined(&SCTP_PACKED);
}
1;
