require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NETINET_SCTP_LOCK_BSD_H_)) {
    eval 'sub _NETINET_SCTP_LOCK_BSD_H_ () {1;}' unless defined(&_NETINET_SCTP_LOCK_BSD_H_);
    eval 'sub SCTP_IPI_COUNT_INIT () {
        eval q();
    }' unless defined(&SCTP_IPI_COUNT_INIT);
    eval 'sub SCTP_STATLOG_INIT_LOCK () {
        eval q();
    }' unless defined(&SCTP_STATLOG_INIT_LOCK);
    eval 'sub SCTP_STATLOG_LOCK () {
        eval q();
    }' unless defined(&SCTP_STATLOG_LOCK);
    eval 'sub SCTP_STATLOG_UNLOCK () {
        eval q();
    }' unless defined(&SCTP_STATLOG_UNLOCK);
    eval 'sub SCTP_STATLOG_DESTROY () {
        eval q();
    }' unless defined(&SCTP_STATLOG_DESTROY);
    eval 'sub SCTP_INP_INFO_LOCK_DESTROY () {
        eval q( &do {  &if( &rw_wowned( &SCTP_BASE_INFO( &ipi_ep_mtx))) {  &rw_wunlock( &SCTP_BASE_INFO( &ipi_ep_mtx)); }  &rw_destroy( &SCTP_BASE_INFO( &ipi_ep_mtx)); }  &while (0));
    }' unless defined(&SCTP_INP_INFO_LOCK_DESTROY);
    eval 'sub SCTP_INP_INFO_LOCK_INIT () {
        eval q( &rw_init( &SCTP_BASE_INFO( &ipi_ep_mtx), \\"sctp-info\\"););
    }' unless defined(&SCTP_INP_INFO_LOCK_INIT);
    eval 'sub SCTP_INP_INFO_RLOCK () {
        eval q( &do {  &rw_rlock( &SCTP_BASE_INFO( &ipi_ep_mtx)); }  &while (0));
    }' unless defined(&SCTP_INP_INFO_RLOCK);
    eval 'sub SCTP_MCORE_QLOCK_INIT {
        my($cpstr) = @_;
	    eval q( &do {  &mtx_init(($cpstr)-> &que_mtx, \\"sctp-mcore_queue\\",\\"queue_lock\\",  &MTX_DEF| &MTX_DUPOK); }  &while (0));
    }' unless defined(&SCTP_MCORE_QLOCK_INIT);
    eval 'sub SCTP_MCORE_QLOCK {
        my($cpstr) = @_;
	    eval q( &do {  &mtx_lock(($cpstr)-> &que_mtx); }  &while (0));
    }' unless defined(&SCTP_MCORE_QLOCK);
    eval 'sub SCTP_MCORE_QUNLOCK {
        my($cpstr) = @_;
	    eval q( &do {  &mtx_unlock(($cpstr)-> &que_mtx); }  &while (0));
    }' unless defined(&SCTP_MCORE_QUNLOCK);
    eval 'sub SCTP_MCORE_QDESTROY {
        my($cpstr) = @_;
	    eval q( &do {  &if( &mtx_owned(($cpstr)-> &core_mtx)) {  &mtx_unlock(($cpstr)-> &que_mtx); }  &mtx_destroy(($cpstr)-> &que_mtx); }  &while (0));
    }' unless defined(&SCTP_MCORE_QDESTROY);
    eval 'sub SCTP_MCORE_LOCK_INIT {
        my($cpstr) = @_;
	    eval q( &do {  &mtx_init(($cpstr)-> &core_mtx, \\"sctp-cpulck\\",\\"cpu_proc_lock\\",  &MTX_DEF| &MTX_DUPOK); }  &while (0));
    }' unless defined(&SCTP_MCORE_LOCK_INIT);
    eval 'sub SCTP_MCORE_LOCK {
        my($cpstr) = @_;
	    eval q( &do {  &mtx_lock(($cpstr)-> &core_mtx); }  &while (0));
    }' unless defined(&SCTP_MCORE_LOCK);
    eval 'sub SCTP_MCORE_UNLOCK {
        my($cpstr) = @_;
	    eval q( &do {  &mtx_unlock(($cpstr)-> &core_mtx); }  &while (0));
    }' unless defined(&SCTP_MCORE_UNLOCK);
    eval 'sub SCTP_MCORE_DESTROY {
        my($cpstr) = @_;
	    eval q( &do {  &if( &mtx_owned(($cpstr)-> &core_mtx)) {  &mtx_unlock(($cpstr)-> &core_mtx); }  &mtx_destroy(($cpstr)-> &core_mtx); }  &while (0));
    }' unless defined(&SCTP_MCORE_DESTROY);
    eval 'sub SCTP_INP_INFO_WLOCK () {
        eval q( &do {  &rw_wlock( &SCTP_BASE_INFO( &ipi_ep_mtx)); }  &while (0));
    }' unless defined(&SCTP_INP_INFO_WLOCK);
    eval 'sub SCTP_INP_INFO_RUNLOCK () {
        eval q( &rw_runlock( &SCTP_BASE_INFO( &ipi_ep_mtx)));
    }' unless defined(&SCTP_INP_INFO_RUNLOCK);
    eval 'sub SCTP_INP_INFO_WUNLOCK () {
        eval q( &rw_wunlock( &SCTP_BASE_INFO( &ipi_ep_mtx)));
    }' unless defined(&SCTP_INP_INFO_WUNLOCK);
    eval 'sub SCTP_IPI_ADDR_INIT () {
        eval q( &rw_init( &SCTP_BASE_INFO( &ipi_addr_mtx), \\"sctp-addr\\"));
    }' unless defined(&SCTP_IPI_ADDR_INIT);
    eval 'sub SCTP_IPI_ADDR_DESTROY () {
        eval q( &do {  &if( &rw_wowned( &SCTP_BASE_INFO( &ipi_addr_mtx))) {  &rw_wunlock( &SCTP_BASE_INFO( &ipi_addr_mtx)); }  &rw_destroy( &SCTP_BASE_INFO( &ipi_addr_mtx)); }  &while (0));
    }' unless defined(&SCTP_IPI_ADDR_DESTROY);
    eval 'sub SCTP_IPI_ADDR_RLOCK () {
        eval q( &do {  &rw_rlock( &SCTP_BASE_INFO( &ipi_addr_mtx)); }  &while (0));
    }' unless defined(&SCTP_IPI_ADDR_RLOCK);
    eval 'sub SCTP_IPI_ADDR_WLOCK () {
        eval q( &do {  &rw_wlock( &SCTP_BASE_INFO( &ipi_addr_mtx)); }  &while (0));
    }' unless defined(&SCTP_IPI_ADDR_WLOCK);
    eval 'sub SCTP_IPI_ADDR_RUNLOCK () {
        eval q( &rw_runlock( &SCTP_BASE_INFO( &ipi_addr_mtx)));
    }' unless defined(&SCTP_IPI_ADDR_RUNLOCK);
    eval 'sub SCTP_IPI_ADDR_WUNLOCK () {
        eval q( &rw_wunlock( &SCTP_BASE_INFO( &ipi_addr_mtx)));
    }' unless defined(&SCTP_IPI_ADDR_WUNLOCK);
    eval 'sub SCTP_IPI_ITERATOR_WQ_INIT () {
        eval q( &mtx_init( ($sctp_it_ctl->{ipi_iterator_wq_mtx}), \\"sctp-it-wq\\", \\"sctp_it_wq\\",  &MTX_DEF));
    }' unless defined(&SCTP_IPI_ITERATOR_WQ_INIT);
    eval 'sub SCTP_IPI_ITERATOR_WQ_DESTROY () {
        eval q( &mtx_destroy( ($sctp_it_ctl->{ipi_iterator_wq_mtx})));
    }' unless defined(&SCTP_IPI_ITERATOR_WQ_DESTROY);
    eval 'sub SCTP_IPI_ITERATOR_WQ_LOCK () {
        eval q( &do {  &mtx_lock( ($sctp_it_ctl->{ipi_iterator_wq_mtx})); }  &while (0));
    }' unless defined(&SCTP_IPI_ITERATOR_WQ_LOCK);
    eval 'sub SCTP_IPI_ITERATOR_WQ_UNLOCK () {
        eval q( &mtx_unlock( ($sctp_it_ctl->{ipi_iterator_wq_mtx})));
    }' unless defined(&SCTP_IPI_ITERATOR_WQ_UNLOCK);
    eval 'sub SCTP_IP_PKTLOG_INIT () {
        eval q( &mtx_init( &SCTP_BASE_INFO( &ipi_pktlog_mtx), \\"sctp-pktlog\\", \\"packetlog\\",  &MTX_DEF));
    }' unless defined(&SCTP_IP_PKTLOG_INIT);
    eval 'sub SCTP_IP_PKTLOG_LOCK () {
        eval q( &do {  &mtx_lock( &SCTP_BASE_INFO( &ipi_pktlog_mtx)); }  &while (0));
    }' unless defined(&SCTP_IP_PKTLOG_LOCK);
    eval 'sub SCTP_IP_PKTLOG_UNLOCK () {
        eval q( &mtx_unlock( &SCTP_BASE_INFO( &ipi_pktlog_mtx)));
    }' unless defined(&SCTP_IP_PKTLOG_UNLOCK);
    eval 'sub SCTP_IP_PKTLOG_DESTROY () {
        eval q( &mtx_destroy( &SCTP_BASE_INFO( &ipi_pktlog_mtx)));
    }' unless defined(&SCTP_IP_PKTLOG_DESTROY);
    eval 'sub SCTP_INP_READ_INIT {
        my($_inp) = @_;
	    eval q( &mtx_init(($_inp)-> &inp_rdata_mtx, \\"sctp-read\\", \\"inpr\\",  &MTX_DEF |  &MTX_DUPOK));
    }' unless defined(&SCTP_INP_READ_INIT);
    eval 'sub SCTP_INP_READ_DESTROY {
        my($_inp) = @_;
	    eval q( &mtx_destroy(($_inp)-> &inp_rdata_mtx));
    }' unless defined(&SCTP_INP_READ_DESTROY);
    eval 'sub SCTP_INP_READ_LOCK {
        my($_inp) = @_;
	    eval q( &do {  &mtx_lock(($_inp)-> &inp_rdata_mtx); }  &while (0));
    }' unless defined(&SCTP_INP_READ_LOCK);
    eval 'sub SCTP_INP_READ_UNLOCK {
        my($_inp) = @_;
	    eval q( &mtx_unlock(($_inp)-> &inp_rdata_mtx));
    }' unless defined(&SCTP_INP_READ_UNLOCK);
    eval 'sub SCTP_INP_LOCK_INIT {
        my($_inp) = @_;
	    eval q( &mtx_init(($_inp)-> &inp_mtx, \\"sctp-inp\\", \\"inp\\",  &MTX_DEF |  &MTX_DUPOK));
    }' unless defined(&SCTP_INP_LOCK_INIT);
    eval 'sub SCTP_ASOC_CREATE_LOCK_INIT {
        my($_inp) = @_;
	    eval q( &mtx_init(($_inp)-> &inp_create_mtx, \\"sctp-create\\", \\"inp_create\\",  &MTX_DEF |  &MTX_DUPOK));
    }' unless defined(&SCTP_ASOC_CREATE_LOCK_INIT);
    eval 'sub SCTP_INP_LOCK_DESTROY {
        my($_inp) = @_;
	    eval q( &mtx_destroy(($_inp)-> &inp_mtx));
    }' unless defined(&SCTP_INP_LOCK_DESTROY);
    eval 'sub SCTP_INP_LOCK_CONTENDED {
        my($_inp) = @_;
	    eval q((($_inp)-> ($inp_mtx->{mtx_lock}) &  &MTX_CONTESTED));
    }' unless defined(&SCTP_INP_LOCK_CONTENDED);
    eval 'sub SCTP_INP_READ_CONTENDED {
        my($_inp) = @_;
	    eval q((($_inp)-> ($inp_rdata_mtx->{mtx_lock}) &  &MTX_CONTESTED));
    }' unless defined(&SCTP_INP_READ_CONTENDED);
    eval 'sub SCTP_ASOC_CREATE_LOCK_CONTENDED {
        my($_inp) = @_;
	    eval q((($_inp)-> ($inp_create_mtx->{mtx_lock}) &  &MTX_CONTESTED));
    }' unless defined(&SCTP_ASOC_CREATE_LOCK_CONTENDED);
    eval 'sub SCTP_ASOC_CREATE_LOCK_DESTROY {
        my($_inp) = @_;
	    eval q( &mtx_destroy(($_inp)-> &inp_create_mtx));
    }' unless defined(&SCTP_ASOC_CREATE_LOCK_DESTROY);
    if(defined(&SCTP_LOCK_LOGGING)) {
	eval 'sub SCTP_INP_RLOCK {
	    my($_inp) = @_;
    	    eval q( &do {  &if( &SCTP_BASE_SYSCTL( &sctp_logging_level) &  &SCTP_LOCK_LOGGING_ENABLE)  &sctp_log_lock($_inp,  &NULL,  &SCTP_LOG_LOCK_INP);  &mtx_lock(($_inp)-> &inp_mtx); }  &while (0));
	}' unless defined(&SCTP_INP_RLOCK);
	eval 'sub SCTP_INP_WLOCK {
	    my($_inp) = @_;
    	    eval q( &do {  &if( &SCTP_BASE_SYSCTL( &sctp_logging_level) &  &SCTP_LOCK_LOGGING_ENABLE)  &sctp_log_lock($_inp,  &NULL,  &SCTP_LOG_LOCK_INP);  &mtx_lock(($_inp)-> &inp_mtx); }  &while (0));
	}' unless defined(&SCTP_INP_WLOCK);
    } else {
	eval 'sub SCTP_INP_RLOCK {
	    my($_inp) = @_;
    	    eval q( &do {  &mtx_lock(($_inp)-> &inp_mtx); }  &while (0));
	}' unless defined(&SCTP_INP_RLOCK);
	eval 'sub SCTP_INP_WLOCK {
	    my($_inp) = @_;
    	    eval q( &do {  &mtx_lock(($_inp)-> &inp_mtx); }  &while (0));
	}' unless defined(&SCTP_INP_WLOCK);
    }
    eval 'sub SCTP_TCB_SEND_LOCK_INIT {
        my($_tcb) = @_;
	    eval q( &mtx_init(($_tcb)-> &tcb_send_mtx, \\"sctp-send-tcb\\", \\"tcbs\\",  &MTX_DEF |  &MTX_DUPOK));
    }' unless defined(&SCTP_TCB_SEND_LOCK_INIT);
    eval 'sub SCTP_TCB_SEND_LOCK_DESTROY {
        my($_tcb) = @_;
	    eval q( &mtx_destroy(($_tcb)-> &tcb_send_mtx));
    }' unless defined(&SCTP_TCB_SEND_LOCK_DESTROY);
    eval 'sub SCTP_TCB_SEND_LOCK {
        my($_tcb) = @_;
	    eval q( &do {  &mtx_lock(($_tcb)-> &tcb_send_mtx); }  &while (0));
    }' unless defined(&SCTP_TCB_SEND_LOCK);
    eval 'sub SCTP_TCB_SEND_UNLOCK {
        my($_tcb) = @_;
	    eval q( &mtx_unlock(($_tcb)-> &tcb_send_mtx));
    }' unless defined(&SCTP_TCB_SEND_UNLOCK);
    eval 'sub SCTP_INP_INCR_REF {
        my($_inp) = @_;
	    eval q( &atomic_add_int((($_inp)-> &refcount), 1));
    }' unless defined(&SCTP_INP_INCR_REF);
    eval 'sub SCTP_INP_DECR_REF {
        my($_inp) = @_;
	    eval q( &atomic_add_int((($_inp)-> &refcount), -1));
    }' unless defined(&SCTP_INP_DECR_REF);
    if(defined(&SCTP_LOCK_LOGGING)) {
	eval 'sub SCTP_ASOC_CREATE_LOCK {
	    my($_inp) = @_;
    	    eval q( &do {  &if( &SCTP_BASE_SYSCTL( &sctp_logging_level) &  &SCTP_LOCK_LOGGING_ENABLE)  &sctp_log_lock($_inp,  &NULL,  &SCTP_LOG_LOCK_CREATE);  &mtx_lock(($_inp)-> &inp_create_mtx); }  &while (0));
	}' unless defined(&SCTP_ASOC_CREATE_LOCK);
    } else {
	eval 'sub SCTP_ASOC_CREATE_LOCK {
	    my($_inp) = @_;
    	    eval q( &do {  &mtx_lock(($_inp)-> &inp_create_mtx); }  &while (0));
	}' unless defined(&SCTP_ASOC_CREATE_LOCK);
    }
    eval 'sub SCTP_INP_RUNLOCK {
        my($_inp) = @_;
	    eval q( &mtx_unlock(($_inp)-> &inp_mtx));
    }' unless defined(&SCTP_INP_RUNLOCK);
    eval 'sub SCTP_INP_WUNLOCK {
        my($_inp) = @_;
	    eval q( &mtx_unlock(($_inp)-> &inp_mtx));
    }' unless defined(&SCTP_INP_WUNLOCK);
    eval 'sub SCTP_ASOC_CREATE_UNLOCK {
        my($_inp) = @_;
	    eval q( &mtx_unlock(($_inp)-> &inp_create_mtx));
    }' unless defined(&SCTP_ASOC_CREATE_UNLOCK);
    eval 'sub SCTP_TCB_LOCK_INIT {
        my($_tcb) = @_;
	    eval q( &mtx_init(($_tcb)-> &tcb_mtx, \\"sctp-tcb\\", \\"tcb\\",  &MTX_DEF |  &MTX_DUPOK));
    }' unless defined(&SCTP_TCB_LOCK_INIT);
    eval 'sub SCTP_TCB_LOCK_DESTROY {
        my($_tcb) = @_;
	    eval q( &mtx_destroy(($_tcb)-> &tcb_mtx));
    }' unless defined(&SCTP_TCB_LOCK_DESTROY);
    if(defined(&SCTP_LOCK_LOGGING)) {
	eval 'sub SCTP_TCB_LOCK {
	    my($_tcb) = @_;
    	    eval q( &do {  &if( &SCTP_BASE_SYSCTL( &sctp_logging_level) &  &SCTP_LOCK_LOGGING_ENABLE)  &sctp_log_lock( ($_tcb->{sctp_ep}), $_tcb,  &SCTP_LOG_LOCK_TCB);  &mtx_lock(($_tcb)-> &tcb_mtx); }  &while (0));
	}' unless defined(&SCTP_TCB_LOCK);
    } else {
	eval 'sub SCTP_TCB_LOCK {
	    my($_tcb) = @_;
    	    eval q( &do {  &mtx_lock(($_tcb)-> &tcb_mtx); }  &while (0));
	}' unless defined(&SCTP_TCB_LOCK);
    }
    eval 'sub SCTP_TCB_TRYLOCK {
        my($_tcb) = @_;
	    eval q( &mtx_trylock(($_tcb)-> &tcb_mtx));
    }' unless defined(&SCTP_TCB_TRYLOCK);
    eval 'sub SCTP_TCB_UNLOCK {
        my($_tcb) = @_;
	    eval q( &mtx_unlock(($_tcb)-> &tcb_mtx));
    }' unless defined(&SCTP_TCB_UNLOCK);
    eval 'sub SCTP_TCB_UNLOCK_IFOWNED {
        my($_tcb) = @_;
	    eval q( &do {  &if ( &mtx_owned(($_tcb)-> &tcb_mtx))  &mtx_unlock(($_tcb)-> &tcb_mtx); }  &while (0));
    }' unless defined(&SCTP_TCB_UNLOCK_IFOWNED);
    if(defined(&INVARIANTS)) {
	eval 'sub SCTP_TCB_LOCK_ASSERT {
	    my($_tcb) = @_;
    	    eval q( &do {  &if ( &mtx_owned(($_tcb)-> &tcb_mtx) == 0)  &panic(\\"Don\'t own TCB lock\\"); }  &while (0));
	}' unless defined(&SCTP_TCB_LOCK_ASSERT);
    } else {
	eval 'sub SCTP_TCB_LOCK_ASSERT {
	    my($_tcb) = @_;
    	    eval q();
	}' unless defined(&SCTP_TCB_LOCK_ASSERT);
    }
    eval 'sub SCTP_ITERATOR_LOCK_INIT () {
        eval q( &mtx_init( ($sctp_it_ctl->{it_mtx}), \\"sctp-it\\", \\"iterator\\",  &MTX_DEF));
    }' unless defined(&SCTP_ITERATOR_LOCK_INIT);
    if(defined(&INVARIANTS)) {
	eval 'sub SCTP_ITERATOR_LOCK () {
	    eval q( &do {  &if ( &mtx_owned( ($sctp_it_ctl->{it_mtx})))  &panic(\\"Iterator Lock\\");  &mtx_lock( ($sctp_it_ctl->{it_mtx})); }  &while (0));
	}' unless defined(&SCTP_ITERATOR_LOCK);
    } else {
	eval 'sub SCTP_ITERATOR_LOCK () {
	    eval q( &do {  &mtx_lock( ($sctp_it_ctl->{it_mtx})); }  &while (0));
	}' unless defined(&SCTP_ITERATOR_LOCK);
    }
    eval 'sub SCTP_ITERATOR_UNLOCK () {
        eval q( &mtx_unlock( ($sctp_it_ctl->{it_mtx})));
    }' unless defined(&SCTP_ITERATOR_UNLOCK);
    eval 'sub SCTP_ITERATOR_LOCK_DESTROY () {
        eval q( &mtx_destroy( ($sctp_it_ctl->{it_mtx})));
    }' unless defined(&SCTP_ITERATOR_LOCK_DESTROY);
    eval 'sub SCTP_WQ_ADDR_INIT () {
        eval q( &do {  &mtx_init( &SCTP_BASE_INFO( &wq_addr_mtx), \\"sctp-addr-wq\\",\\"sctp_addr_wq\\", &MTX_DEF); }  &while (0));
    }' unless defined(&SCTP_WQ_ADDR_INIT);
    eval 'sub SCTP_WQ_ADDR_DESTROY () {
        eval q( &do {  &if( &mtx_owned( &SCTP_BASE_INFO( &wq_addr_mtx))) {  &mtx_unlock( &SCTP_BASE_INFO( &wq_addr_mtx)); }  &mtx_destroy( &SCTP_BASE_INFO( &wq_addr_mtx)); }  &while (0));
    }' unless defined(&SCTP_WQ_ADDR_DESTROY);
    eval 'sub SCTP_WQ_ADDR_LOCK () {
        eval q( &do {  &mtx_lock( &SCTP_BASE_INFO( &wq_addr_mtx)); }  &while (0));
    }' unless defined(&SCTP_WQ_ADDR_LOCK);
    eval 'sub SCTP_WQ_ADDR_UNLOCK () {
        eval q( &do {  &mtx_unlock( &SCTP_BASE_INFO( &wq_addr_mtx)); }  &while (0));
    }' unless defined(&SCTP_WQ_ADDR_UNLOCK);
    eval 'sub SCTP_INCR_EP_COUNT () {
        eval q( &do {  &atomic_add_int( &SCTP_BASE_INFO( &ipi_count_ep), 1); }  &while (0));
    }' unless defined(&SCTP_INCR_EP_COUNT);
    eval 'sub SCTP_DECR_EP_COUNT () {
        eval q( &do {  &atomic_subtract_int( &SCTP_BASE_INFO( &ipi_count_ep), 1); }  &while (0));
    }' unless defined(&SCTP_DECR_EP_COUNT);
    eval 'sub SCTP_INCR_ASOC_COUNT () {
        eval q( &do {  &atomic_add_int( &SCTP_BASE_INFO( &ipi_count_asoc), 1); }  &while (0));
    }' unless defined(&SCTP_INCR_ASOC_COUNT);
    eval 'sub SCTP_DECR_ASOC_COUNT () {
        eval q( &do {  &atomic_subtract_int( &SCTP_BASE_INFO( &ipi_count_asoc), 1); }  &while (0));
    }' unless defined(&SCTP_DECR_ASOC_COUNT);
    eval 'sub SCTP_INCR_LADDR_COUNT () {
        eval q( &do {  &atomic_add_int( &SCTP_BASE_INFO( &ipi_count_laddr), 1); }  &while (0));
    }' unless defined(&SCTP_INCR_LADDR_COUNT);
    eval 'sub SCTP_DECR_LADDR_COUNT () {
        eval q( &do {  &atomic_subtract_int( &SCTP_BASE_INFO( &ipi_count_laddr), 1); }  &while (0));
    }' unless defined(&SCTP_DECR_LADDR_COUNT);
    eval 'sub SCTP_INCR_RADDR_COUNT () {
        eval q( &do {  &atomic_add_int( &SCTP_BASE_INFO( &ipi_count_raddr), 1); }  &while (0));
    }' unless defined(&SCTP_INCR_RADDR_COUNT);
    eval 'sub SCTP_DECR_RADDR_COUNT () {
        eval q( &do {  &atomic_subtract_int( &SCTP_BASE_INFO( &ipi_count_raddr),1); }  &while (0));
    }' unless defined(&SCTP_DECR_RADDR_COUNT);
    eval 'sub SCTP_INCR_CHK_COUNT () {
        eval q( &do {  &atomic_add_int( &SCTP_BASE_INFO( &ipi_count_chunk), 1); }  &while (0));
    }' unless defined(&SCTP_INCR_CHK_COUNT);
    if(defined(&INVARIANTS)) {
	eval 'sub SCTP_DECR_CHK_COUNT () {
	    eval q( &do {  &if( &SCTP_BASE_INFO( &ipi_count_chunk) == 0)  &panic(\\"chunk count to 0?\\");  &atomic_subtract_int( &SCTP_BASE_INFO( &ipi_count_chunk), 1); }  &while (0));
	}' unless defined(&SCTP_DECR_CHK_COUNT);
    } else {
	eval 'sub SCTP_DECR_CHK_COUNT () {
	    eval q( &do {  &if( &SCTP_BASE_INFO( &ipi_count_chunk) != 0)  &atomic_subtract_int( &SCTP_BASE_INFO( &ipi_count_chunk), 1); }  &while (0));
	}' unless defined(&SCTP_DECR_CHK_COUNT);
    }
    eval 'sub SCTP_INCR_READQ_COUNT () {
        eval q( &do {  &atomic_add_int( &SCTP_BASE_INFO( &ipi_count_readq),1); }  &while (0));
    }' unless defined(&SCTP_INCR_READQ_COUNT);
    eval 'sub SCTP_DECR_READQ_COUNT () {
        eval q( &do {  &atomic_subtract_int( &SCTP_BASE_INFO( &ipi_count_readq), 1); }  &while (0));
    }' unless defined(&SCTP_DECR_READQ_COUNT);
    eval 'sub SCTP_INCR_STRMOQ_COUNT () {
        eval q( &do {  &atomic_add_int( &SCTP_BASE_INFO( &ipi_count_strmoq), 1); }  &while (0));
    }' unless defined(&SCTP_INCR_STRMOQ_COUNT);
    eval 'sub SCTP_DECR_STRMOQ_COUNT () {
        eval q( &do {  &atomic_subtract_int( &SCTP_BASE_INFO( &ipi_count_strmoq), 1); }  &while (0));
    }' unless defined(&SCTP_DECR_STRMOQ_COUNT);
    if(defined(&SCTP_SO_LOCK_TESTING)) {
	eval 'sub SCTP_INP_SO {
	    my($sctpinp) = @_;
    	    eval q(($sctpinp)-> ($ip_inp->{inp}->{inp_socket}));
	}' unless defined(&SCTP_INP_SO);
	eval 'sub SCTP_SOCKET_LOCK {
	    my($so, $refcnt) = @_;
    	    eval q();
	}' unless defined(&SCTP_SOCKET_LOCK);
	eval 'sub SCTP_SOCKET_UNLOCK {
	    my($so, $refcnt) = @_;
    	    eval q();
	}' unless defined(&SCTP_SOCKET_UNLOCK);
    }
}
1;
