require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NETINET_SCTP_SYSCTL_H_)) {
    eval 'sub _NETINET_SCTP_SYSCTL_H_ () {1;}' unless defined(&_NETINET_SCTP_SYSCTL_H_);
    require 'netinet/sctp_os.ph';
    require 'netinet/sctp_constants.ph';
    if(defined(&SCTP_LOCAL_TRACE_BUF)) {
    }
    if(defined(&SCTP_DEBUG)) {
    }
    if(defined(&__APPLE__) || defined(&SCTP_SO_LOCK_TESTING)) {
    }
    eval 'sub SCTPCTL_MAXDGRAM_DESC () {"Maximum outgoing SCTP buffer size";}' unless defined(&SCTPCTL_MAXDGRAM_DESC);
    eval 'sub SCTPCTL_MAXDGRAM_MIN () {0;}' unless defined(&SCTPCTL_MAXDGRAM_MIN);
    eval 'sub SCTPCTL_MAXDGRAM_MAX () {0xffffffff;}' unless defined(&SCTPCTL_MAXDGRAM_MAX);
    eval 'sub SCTPCTL_MAXDGRAM_DEFAULT () {262144;}' unless defined(&SCTPCTL_MAXDGRAM_DEFAULT);
    eval 'sub SCTPCTL_RECVSPACE_DESC () {"Maximum incoming SCTP buffer size";}' unless defined(&SCTPCTL_RECVSPACE_DESC);
    eval 'sub SCTPCTL_RECVSPACE_MIN () {0;}' unless defined(&SCTPCTL_RECVSPACE_MIN);
    eval 'sub SCTPCTL_RECVSPACE_MAX () {0xffffffff;}' unless defined(&SCTPCTL_RECVSPACE_MAX);
    eval 'sub SCTPCTL_RECVSPACE_DEFAULT () {262144;}' unless defined(&SCTPCTL_RECVSPACE_DEFAULT);
    eval 'sub SCTPCTL_AUTOASCONF_DESC () {"Enable SCTP Auto-ASCONF";}' unless defined(&SCTPCTL_AUTOASCONF_DESC);
    eval 'sub SCTPCTL_AUTOASCONF_MIN () {0;}' unless defined(&SCTPCTL_AUTOASCONF_MIN);
    eval 'sub SCTPCTL_AUTOASCONF_MAX () {1;}' unless defined(&SCTPCTL_AUTOASCONF_MAX);
    eval 'sub SCTPCTL_AUTOASCONF_DEFAULT () {1;}' unless defined(&SCTPCTL_AUTOASCONF_DEFAULT);
    eval 'sub SCTPCTL_MULTIPLEASCONFS_DESC () {"Enable SCTP Muliple-ASCONFs";}' unless defined(&SCTPCTL_MULTIPLEASCONFS_DESC);
    eval 'sub SCTPCTL_MULTIPLEASCONFS_MIN () {0;}' unless defined(&SCTPCTL_MULTIPLEASCONFS_MIN);
    eval 'sub SCTPCTL_MULTIPLEASCONFS_MAX () {1;}' unless defined(&SCTPCTL_MULTIPLEASCONFS_MAX);
    eval 'sub SCTPCTL_MULTIPLEASCONFS_DEFAULT () { &SCTP_DEFAULT_MULTIPLE_ASCONFS;}' unless defined(&SCTPCTL_MULTIPLEASCONFS_DEFAULT);
    eval 'sub SCTPCTL_ECN_ENABLE_DESC () {"Enable SCTP ECN";}' unless defined(&SCTPCTL_ECN_ENABLE_DESC);
    eval 'sub SCTPCTL_ECN_ENABLE_MIN () {0;}' unless defined(&SCTPCTL_ECN_ENABLE_MIN);
    eval 'sub SCTPCTL_ECN_ENABLE_MAX () {1;}' unless defined(&SCTPCTL_ECN_ENABLE_MAX);
    eval 'sub SCTPCTL_ECN_ENABLE_DEFAULT () {1;}' unless defined(&SCTPCTL_ECN_ENABLE_DEFAULT);
    eval 'sub SCTPCTL_PR_ENABLE_DESC () {"Enable PR-SCTP";}' unless defined(&SCTPCTL_PR_ENABLE_DESC);
    eval 'sub SCTPCTL_PR_ENABLE_MIN () {0;}' unless defined(&SCTPCTL_PR_ENABLE_MIN);
    eval 'sub SCTPCTL_PR_ENABLE_MAX () {1;}' unless defined(&SCTPCTL_PR_ENABLE_MAX);
    eval 'sub SCTPCTL_PR_ENABLE_DEFAULT () {1;}' unless defined(&SCTPCTL_PR_ENABLE_DEFAULT);
    eval 'sub SCTPCTL_AUTH_ENABLE_DESC () {"Enable SCTP AUTH function";}' unless defined(&SCTPCTL_AUTH_ENABLE_DESC);
    eval 'sub SCTPCTL_AUTH_ENABLE_MIN () {0;}' unless defined(&SCTPCTL_AUTH_ENABLE_MIN);
    eval 'sub SCTPCTL_AUTH_ENABLE_MAX () {1;}' unless defined(&SCTPCTL_AUTH_ENABLE_MAX);
    eval 'sub SCTPCTL_AUTH_ENABLE_DEFAULT () {1;}' unless defined(&SCTPCTL_AUTH_ENABLE_DEFAULT);
    eval 'sub SCTPCTL_ASCONF_ENABLE_DESC () {"Enable SCTP ASCONF";}' unless defined(&SCTPCTL_ASCONF_ENABLE_DESC);
    eval 'sub SCTPCTL_ASCONF_ENABLE_MIN () {0;}' unless defined(&SCTPCTL_ASCONF_ENABLE_MIN);
    eval 'sub SCTPCTL_ASCONF_ENABLE_MAX () {1;}' unless defined(&SCTPCTL_ASCONF_ENABLE_MAX);
    eval 'sub SCTPCTL_ASCONF_ENABLE_DEFAULT () {1;}' unless defined(&SCTPCTL_ASCONF_ENABLE_DEFAULT);
    eval 'sub SCTPCTL_RECONFIG_ENABLE_DESC () {"Enable SCTP RE-CONFIG";}' unless defined(&SCTPCTL_RECONFIG_ENABLE_DESC);
    eval 'sub SCTPCTL_RECONFIG_ENABLE_MIN () {0;}' unless defined(&SCTPCTL_RECONFIG_ENABLE_MIN);
    eval 'sub SCTPCTL_RECONFIG_ENABLE_MAX () {1;}' unless defined(&SCTPCTL_RECONFIG_ENABLE_MAX);
    eval 'sub SCTPCTL_RECONFIG_ENABLE_DEFAULT () {1;}' unless defined(&SCTPCTL_RECONFIG_ENABLE_DEFAULT);
    eval 'sub SCTPCTL_NRSACK_ENABLE_DESC () {"Enable SCTP NR-SACK";}' unless defined(&SCTPCTL_NRSACK_ENABLE_DESC);
    eval 'sub SCTPCTL_NRSACK_ENABLE_MIN () {0;}' unless defined(&SCTPCTL_NRSACK_ENABLE_MIN);
    eval 'sub SCTPCTL_NRSACK_ENABLE_MAX () {1;}' unless defined(&SCTPCTL_NRSACK_ENABLE_MAX);
    eval 'sub SCTPCTL_NRSACK_ENABLE_DEFAULT () {0;}' unless defined(&SCTPCTL_NRSACK_ENABLE_DEFAULT);
    eval 'sub SCTPCTL_PKTDROP_ENABLE_DESC () {"Enable SCTP PKTDROP";}' unless defined(&SCTPCTL_PKTDROP_ENABLE_DESC);
    eval 'sub SCTPCTL_PKTDROP_ENABLE_MIN () {0;}' unless defined(&SCTPCTL_PKTDROP_ENABLE_MIN);
    eval 'sub SCTPCTL_PKTDROP_ENABLE_MAX () {1;}' unless defined(&SCTPCTL_PKTDROP_ENABLE_MAX);
    eval 'sub SCTPCTL_PKTDROP_ENABLE_DEFAULT () {0;}' unless defined(&SCTPCTL_PKTDROP_ENABLE_DEFAULT);
    eval 'sub SCTPCTL_LOOPBACK_NOCSUM_DESC () {"Enable NO Csum on packets sent on loopback";}' unless defined(&SCTPCTL_LOOPBACK_NOCSUM_DESC);
    eval 'sub SCTPCTL_LOOPBACK_NOCSUM_MIN () {0;}' unless defined(&SCTPCTL_LOOPBACK_NOCSUM_MIN);
    eval 'sub SCTPCTL_LOOPBACK_NOCSUM_MAX () {1;}' unless defined(&SCTPCTL_LOOPBACK_NOCSUM_MAX);
    eval 'sub SCTPCTL_LOOPBACK_NOCSUM_DEFAULT () {1;}' unless defined(&SCTPCTL_LOOPBACK_NOCSUM_DEFAULT);
    eval 'sub SCTPCTL_PEER_CHKOH_DESC () {"Amount to debit peers rwnd per chunk sent";}' unless defined(&SCTPCTL_PEER_CHKOH_DESC);
    eval 'sub SCTPCTL_PEER_CHKOH_MIN () {0;}' unless defined(&SCTPCTL_PEER_CHKOH_MIN);
    eval 'sub SCTPCTL_PEER_CHKOH_MAX () {0xffffffff;}' unless defined(&SCTPCTL_PEER_CHKOH_MAX);
    eval 'sub SCTPCTL_PEER_CHKOH_DEFAULT () {256;}' unless defined(&SCTPCTL_PEER_CHKOH_DEFAULT);
    eval 'sub SCTPCTL_MAXBURST_DESC () {"Default max burst for sctp endpoints";}' unless defined(&SCTPCTL_MAXBURST_DESC);
    eval 'sub SCTPCTL_MAXBURST_MIN () {0;}' unless defined(&SCTPCTL_MAXBURST_MIN);
    eval 'sub SCTPCTL_MAXBURST_MAX () {0xffffffff;}' unless defined(&SCTPCTL_MAXBURST_MAX);
    eval 'sub SCTPCTL_MAXBURST_DEFAULT () { &SCTP_DEF_MAX_BURST;}' unless defined(&SCTPCTL_MAXBURST_DEFAULT);
    eval 'sub SCTPCTL_FRMAXBURST_DESC () {"Default fr max burst for sctp endpoints";}' unless defined(&SCTPCTL_FRMAXBURST_DESC);
    eval 'sub SCTPCTL_FRMAXBURST_MIN () {0;}' unless defined(&SCTPCTL_FRMAXBURST_MIN);
    eval 'sub SCTPCTL_FRMAXBURST_MAX () {0xffffffff;}' unless defined(&SCTPCTL_FRMAXBURST_MAX);
    eval 'sub SCTPCTL_FRMAXBURST_DEFAULT () { &SCTP_DEF_FRMAX_BURST;}' unless defined(&SCTPCTL_FRMAXBURST_DEFAULT);
    eval 'sub SCTPCTL_MAXCHUNKS_DESC () {"Default max chunks on queue per asoc";}' unless defined(&SCTPCTL_MAXCHUNKS_DESC);
    eval 'sub SCTPCTL_MAXCHUNKS_MIN () {0;}' unless defined(&SCTPCTL_MAXCHUNKS_MIN);
    eval 'sub SCTPCTL_MAXCHUNKS_MAX () {0xffffffff;}' unless defined(&SCTPCTL_MAXCHUNKS_MAX);
    eval 'sub SCTPCTL_MAXCHUNKS_DEFAULT () { &SCTP_ASOC_MAX_CHUNKS_ON_QUEUE;}' unless defined(&SCTPCTL_MAXCHUNKS_DEFAULT);
    eval 'sub SCTPCTL_TCBHASHSIZE_DESC () {"Tunable for TCB hash table sizes";}' unless defined(&SCTPCTL_TCBHASHSIZE_DESC);
    eval 'sub SCTPCTL_TCBHASHSIZE_MIN () {1;}' unless defined(&SCTPCTL_TCBHASHSIZE_MIN);
    eval 'sub SCTPCTL_TCBHASHSIZE_MAX () {0xffffffff;}' unless defined(&SCTPCTL_TCBHASHSIZE_MAX);
    eval 'sub SCTPCTL_TCBHASHSIZE_DEFAULT () { &SCTP_TCBHASHSIZE;}' unless defined(&SCTPCTL_TCBHASHSIZE_DEFAULT);
    eval 'sub SCTPCTL_PCBHASHSIZE_DESC () {"Tunable for PCB hash table sizes";}' unless defined(&SCTPCTL_PCBHASHSIZE_DESC);
    eval 'sub SCTPCTL_PCBHASHSIZE_MIN () {1;}' unless defined(&SCTPCTL_PCBHASHSIZE_MIN);
    eval 'sub SCTPCTL_PCBHASHSIZE_MAX () {0xffffffff;}' unless defined(&SCTPCTL_PCBHASHSIZE_MAX);
    eval 'sub SCTPCTL_PCBHASHSIZE_DEFAULT () { &SCTP_PCBHASHSIZE;}' unless defined(&SCTPCTL_PCBHASHSIZE_DEFAULT);
    eval 'sub SCTPCTL_MIN_SPLIT_POINT_DESC () {"Minimum size when splitting a chunk";}' unless defined(&SCTPCTL_MIN_SPLIT_POINT_DESC);
    eval 'sub SCTPCTL_MIN_SPLIT_POINT_MIN () {0;}' unless defined(&SCTPCTL_MIN_SPLIT_POINT_MIN);
    eval 'sub SCTPCTL_MIN_SPLIT_POINT_MAX () {0xffffffff;}' unless defined(&SCTPCTL_MIN_SPLIT_POINT_MAX);
    eval 'sub SCTPCTL_MIN_SPLIT_POINT_DEFAULT () { &SCTP_DEFAULT_SPLIT_POINT_MIN;}' unless defined(&SCTPCTL_MIN_SPLIT_POINT_DEFAULT);
    eval 'sub SCTPCTL_CHUNKSCALE_DESC () {"Tunable for Scaling of number of chunks and messages";}' unless defined(&SCTPCTL_CHUNKSCALE_DESC);
    eval 'sub SCTPCTL_CHUNKSCALE_MIN () {1;}' unless defined(&SCTPCTL_CHUNKSCALE_MIN);
    eval 'sub SCTPCTL_CHUNKSCALE_MAX () {0xffffffff;}' unless defined(&SCTPCTL_CHUNKSCALE_MAX);
    eval 'sub SCTPCTL_CHUNKSCALE_DEFAULT () { &SCTP_CHUNKQUEUE_SCALE;}' unless defined(&SCTPCTL_CHUNKSCALE_DEFAULT);
    eval 'sub SCTPCTL_DELAYED_SACK_TIME_DESC () {"Default delayed SACK timer in ms";}' unless defined(&SCTPCTL_DELAYED_SACK_TIME_DESC);
    eval 'sub SCTPCTL_DELAYED_SACK_TIME_MIN () {0;}' unless defined(&SCTPCTL_DELAYED_SACK_TIME_MIN);
    eval 'sub SCTPCTL_DELAYED_SACK_TIME_MAX () {0xffffffff;}' unless defined(&SCTPCTL_DELAYED_SACK_TIME_MAX);
    eval 'sub SCTPCTL_DELAYED_SACK_TIME_DEFAULT () { &SCTP_RECV_MSEC;}' unless defined(&SCTPCTL_DELAYED_SACK_TIME_DEFAULT);
    eval 'sub SCTPCTL_SACK_FREQ_DESC () {"Default SACK frequency";}' unless defined(&SCTPCTL_SACK_FREQ_DESC);
    eval 'sub SCTPCTL_SACK_FREQ_MIN () {0;}' unless defined(&SCTPCTL_SACK_FREQ_MIN);
    eval 'sub SCTPCTL_SACK_FREQ_MAX () {0xffffffff;}' unless defined(&SCTPCTL_SACK_FREQ_MAX);
    eval 'sub SCTPCTL_SACK_FREQ_DEFAULT () { &SCTP_DEFAULT_SACK_FREQ;}' unless defined(&SCTPCTL_SACK_FREQ_DEFAULT);
    eval 'sub SCTPCTL_SYS_RESOURCE_DESC () {"Max number of cached resources in the system";}' unless defined(&SCTPCTL_SYS_RESOURCE_DESC);
    eval 'sub SCTPCTL_SYS_RESOURCE_MIN () {0;}' unless defined(&SCTPCTL_SYS_RESOURCE_MIN);
    eval 'sub SCTPCTL_SYS_RESOURCE_MAX () {0xffffffff;}' unless defined(&SCTPCTL_SYS_RESOURCE_MAX);
    eval 'sub SCTPCTL_SYS_RESOURCE_DEFAULT () { &SCTP_DEF_SYSTEM_RESC_LIMIT;}' unless defined(&SCTPCTL_SYS_RESOURCE_DEFAULT);
    eval 'sub SCTPCTL_ASOC_RESOURCE_DESC () {"Max number of cached resources in an asoc";}' unless defined(&SCTPCTL_ASOC_RESOURCE_DESC);
    eval 'sub SCTPCTL_ASOC_RESOURCE_MIN () {0;}' unless defined(&SCTPCTL_ASOC_RESOURCE_MIN);
    eval 'sub SCTPCTL_ASOC_RESOURCE_MAX () {0xffffffff;}' unless defined(&SCTPCTL_ASOC_RESOURCE_MAX);
    eval 'sub SCTPCTL_ASOC_RESOURCE_DEFAULT () { &SCTP_DEF_ASOC_RESC_LIMIT;}' unless defined(&SCTPCTL_ASOC_RESOURCE_DEFAULT);
    eval 'sub SCTPCTL_HEARTBEAT_INTERVAL_DESC () {"Default heartbeat interval in ms";}' unless defined(&SCTPCTL_HEARTBEAT_INTERVAL_DESC);
    eval 'sub SCTPCTL_HEARTBEAT_INTERVAL_MIN () {0;}' unless defined(&SCTPCTL_HEARTBEAT_INTERVAL_MIN);
    eval 'sub SCTPCTL_HEARTBEAT_INTERVAL_MAX () {0xffffffff;}' unless defined(&SCTPCTL_HEARTBEAT_INTERVAL_MAX);
    eval 'sub SCTPCTL_HEARTBEAT_INTERVAL_DEFAULT () { &SCTP_HB_DEFAULT_MSEC;}' unless defined(&SCTPCTL_HEARTBEAT_INTERVAL_DEFAULT);
    eval 'sub SCTPCTL_PMTU_RAISE_TIME_DESC () {"Default PMTU raise timer in seconds";}' unless defined(&SCTPCTL_PMTU_RAISE_TIME_DESC);
    eval 'sub SCTPCTL_PMTU_RAISE_TIME_MIN () {0;}' unless defined(&SCTPCTL_PMTU_RAISE_TIME_MIN);
    eval 'sub SCTPCTL_PMTU_RAISE_TIME_MAX () {0xffffffff;}' unless defined(&SCTPCTL_PMTU_RAISE_TIME_MAX);
    eval 'sub SCTPCTL_PMTU_RAISE_TIME_DEFAULT () { &SCTP_DEF_PMTU_RAISE_SEC;}' unless defined(&SCTPCTL_PMTU_RAISE_TIME_DEFAULT);
    eval 'sub SCTPCTL_SHUTDOWN_GUARD_TIME_DESC () {"Shutdown guard timer in seconds (0 means 5 times RTO.Max)";}' unless defined(&SCTPCTL_SHUTDOWN_GUARD_TIME_DESC);
    eval 'sub SCTPCTL_SHUTDOWN_GUARD_TIME_MIN () {0;}' unless defined(&SCTPCTL_SHUTDOWN_GUARD_TIME_MIN);
    eval 'sub SCTPCTL_SHUTDOWN_GUARD_TIME_MAX () {0xffffffff;}' unless defined(&SCTPCTL_SHUTDOWN_GUARD_TIME_MAX);
    eval 'sub SCTPCTL_SHUTDOWN_GUARD_TIME_DEFAULT () {0;}' unless defined(&SCTPCTL_SHUTDOWN_GUARD_TIME_DEFAULT);
    eval 'sub SCTPCTL_SECRET_LIFETIME_DESC () {"Default secret lifetime in seconds";}' unless defined(&SCTPCTL_SECRET_LIFETIME_DESC);
    eval 'sub SCTPCTL_SECRET_LIFETIME_MIN () {0;}' unless defined(&SCTPCTL_SECRET_LIFETIME_MIN);
    eval 'sub SCTPCTL_SECRET_LIFETIME_MAX () {0xffffffff;}' unless defined(&SCTPCTL_SECRET_LIFETIME_MAX);
    eval 'sub SCTPCTL_SECRET_LIFETIME_DEFAULT () { &SCTP_DEFAULT_SECRET_LIFE_SEC;}' unless defined(&SCTPCTL_SECRET_LIFETIME_DEFAULT);
    eval 'sub SCTPCTL_RTO_MAX_DESC () {"Default maximum retransmission timeout in ms";}' unless defined(&SCTPCTL_RTO_MAX_DESC);
    eval 'sub SCTPCTL_RTO_MAX_MIN () {0;}' unless defined(&SCTPCTL_RTO_MAX_MIN);
    eval 'sub SCTPCTL_RTO_MAX_MAX () {0xffffffff;}' unless defined(&SCTPCTL_RTO_MAX_MAX);
    eval 'sub SCTPCTL_RTO_MAX_DEFAULT () { &SCTP_RTO_UPPER_BOUND;}' unless defined(&SCTPCTL_RTO_MAX_DEFAULT);
    eval 'sub SCTPCTL_RTO_MIN_DESC () {"Default minimum retransmission timeout in ms";}' unless defined(&SCTPCTL_RTO_MIN_DESC);
    eval 'sub SCTPCTL_RTO_MIN_MIN () {0;}' unless defined(&SCTPCTL_RTO_MIN_MIN);
    eval 'sub SCTPCTL_RTO_MIN_MAX () {0xffffffff;}' unless defined(&SCTPCTL_RTO_MIN_MAX);
    eval 'sub SCTPCTL_RTO_MIN_DEFAULT () { &SCTP_RTO_LOWER_BOUND;}' unless defined(&SCTPCTL_RTO_MIN_DEFAULT);
    eval 'sub SCTPCTL_RTO_INITIAL_DESC () {"Default initial retransmission timeout in ms";}' unless defined(&SCTPCTL_RTO_INITIAL_DESC);
    eval 'sub SCTPCTL_RTO_INITIAL_MIN () {0;}' unless defined(&SCTPCTL_RTO_INITIAL_MIN);
    eval 'sub SCTPCTL_RTO_INITIAL_MAX () {0xffffffff;}' unless defined(&SCTPCTL_RTO_INITIAL_MAX);
    eval 'sub SCTPCTL_RTO_INITIAL_DEFAULT () { &SCTP_RTO_INITIAL;}' unless defined(&SCTPCTL_RTO_INITIAL_DEFAULT);
    eval 'sub SCTPCTL_INIT_RTO_MAX_DESC () {"Default maximum retransmission timeout during association setup in ms";}' unless defined(&SCTPCTL_INIT_RTO_MAX_DESC);
    eval 'sub SCTPCTL_INIT_RTO_MAX_MIN () {0;}' unless defined(&SCTPCTL_INIT_RTO_MAX_MIN);
    eval 'sub SCTPCTL_INIT_RTO_MAX_MAX () {0xffffffff;}' unless defined(&SCTPCTL_INIT_RTO_MAX_MAX);
    eval 'sub SCTPCTL_INIT_RTO_MAX_DEFAULT () { &SCTP_RTO_UPPER_BOUND;}' unless defined(&SCTPCTL_INIT_RTO_MAX_DEFAULT);
    eval 'sub SCTPCTL_VALID_COOKIE_LIFE_DESC () {"Default cookie lifetime in seconds";}' unless defined(&SCTPCTL_VALID_COOKIE_LIFE_DESC);
    eval 'sub SCTPCTL_VALID_COOKIE_LIFE_MIN () {0;}' unless defined(&SCTPCTL_VALID_COOKIE_LIFE_MIN);
    eval 'sub SCTPCTL_VALID_COOKIE_LIFE_MAX () {0xffffffff;}' unless defined(&SCTPCTL_VALID_COOKIE_LIFE_MAX);
    eval 'sub SCTPCTL_VALID_COOKIE_LIFE_DEFAULT () { &SCTP_DEFAULT_COOKIE_LIFE;}' unless defined(&SCTPCTL_VALID_COOKIE_LIFE_DEFAULT);
    eval 'sub SCTPCTL_INIT_RTX_MAX_DESC () {"Default maximum number of retransmission for INIT chunks";}' unless defined(&SCTPCTL_INIT_RTX_MAX_DESC);
    eval 'sub SCTPCTL_INIT_RTX_MAX_MIN () {0;}' unless defined(&SCTPCTL_INIT_RTX_MAX_MIN);
    eval 'sub SCTPCTL_INIT_RTX_MAX_MAX () {0xffffffff;}' unless defined(&SCTPCTL_INIT_RTX_MAX_MAX);
    eval 'sub SCTPCTL_INIT_RTX_MAX_DEFAULT () { &SCTP_DEF_MAX_INIT;}' unless defined(&SCTPCTL_INIT_RTX_MAX_DEFAULT);
    eval 'sub SCTPCTL_ASSOC_RTX_MAX_DESC () {"Default maximum number of retransmissions per association";}' unless defined(&SCTPCTL_ASSOC_RTX_MAX_DESC);
    eval 'sub SCTPCTL_ASSOC_RTX_MAX_MIN () {0;}' unless defined(&SCTPCTL_ASSOC_RTX_MAX_MIN);
    eval 'sub SCTPCTL_ASSOC_RTX_MAX_MAX () {0xffffffff;}' unless defined(&SCTPCTL_ASSOC_RTX_MAX_MAX);
    eval 'sub SCTPCTL_ASSOC_RTX_MAX_DEFAULT () { &SCTP_DEF_MAX_SEND;}' unless defined(&SCTPCTL_ASSOC_RTX_MAX_DEFAULT);
    eval 'sub SCTPCTL_PATH_RTX_MAX_DESC () {"Default maximum of retransmissions per path";}' unless defined(&SCTPCTL_PATH_RTX_MAX_DESC);
    eval 'sub SCTPCTL_PATH_RTX_MAX_MIN () {0;}' unless defined(&SCTPCTL_PATH_RTX_MAX_MIN);
    eval 'sub SCTPCTL_PATH_RTX_MAX_MAX () {0xffffffff;}' unless defined(&SCTPCTL_PATH_RTX_MAX_MAX);
    eval 'sub SCTPCTL_PATH_RTX_MAX_DEFAULT () { &SCTP_DEF_MAX_PATH_RTX;}' unless defined(&SCTPCTL_PATH_RTX_MAX_DEFAULT);
    eval 'sub SCTPCTL_PATH_PF_THRESHOLD_DESC () {"Default potentially failed threshold";}' unless defined(&SCTPCTL_PATH_PF_THRESHOLD_DESC);
    eval 'sub SCTPCTL_PATH_PF_THRESHOLD_MIN () {0;}' unless defined(&SCTPCTL_PATH_PF_THRESHOLD_MIN);
    eval 'sub SCTPCTL_PATH_PF_THRESHOLD_MAX () {0xffff;}' unless defined(&SCTPCTL_PATH_PF_THRESHOLD_MAX);
    eval 'sub SCTPCTL_PATH_PF_THRESHOLD_DEFAULT () { &SCTPCTL_PATH_PF_THRESHOLD_MAX;}' unless defined(&SCTPCTL_PATH_PF_THRESHOLD_DEFAULT);
    eval 'sub SCTPCTL_ADD_MORE_ON_OUTPUT_DESC () {"When space-wise is it worthwhile to try to add more to a socket send buffer";}' unless defined(&SCTPCTL_ADD_MORE_ON_OUTPUT_DESC);
    eval 'sub SCTPCTL_ADD_MORE_ON_OUTPUT_MIN () {0;}' unless defined(&SCTPCTL_ADD_MORE_ON_OUTPUT_MIN);
    eval 'sub SCTPCTL_ADD_MORE_ON_OUTPUT_MAX () {0xffffffff;}' unless defined(&SCTPCTL_ADD_MORE_ON_OUTPUT_MAX);
    eval 'sub SCTPCTL_ADD_MORE_ON_OUTPUT_DEFAULT () { &SCTP_DEFAULT_ADD_MORE;}' unless defined(&SCTPCTL_ADD_MORE_ON_OUTPUT_DEFAULT);
    eval 'sub SCTPCTL_INCOMING_STREAMS_DESC () {"Default number of incoming streams";}' unless defined(&SCTPCTL_INCOMING_STREAMS_DESC);
    eval 'sub SCTPCTL_INCOMING_STREAMS_MIN () {1;}' unless defined(&SCTPCTL_INCOMING_STREAMS_MIN);
    eval 'sub SCTPCTL_INCOMING_STREAMS_MAX () {65535;}' unless defined(&SCTPCTL_INCOMING_STREAMS_MAX);
    eval 'sub SCTPCTL_INCOMING_STREAMS_DEFAULT () { &SCTP_ISTREAM_INITIAL;}' unless defined(&SCTPCTL_INCOMING_STREAMS_DEFAULT);
    eval 'sub SCTPCTL_OUTGOING_STREAMS_DESC () {"Default number of outgoing streams";}' unless defined(&SCTPCTL_OUTGOING_STREAMS_DESC);
    eval 'sub SCTPCTL_OUTGOING_STREAMS_MIN () {1;}' unless defined(&SCTPCTL_OUTGOING_STREAMS_MIN);
    eval 'sub SCTPCTL_OUTGOING_STREAMS_MAX () {65535;}' unless defined(&SCTPCTL_OUTGOING_STREAMS_MAX);
    eval 'sub SCTPCTL_OUTGOING_STREAMS_DEFAULT () { &SCTP_OSTREAM_INITIAL;}' unless defined(&SCTPCTL_OUTGOING_STREAMS_DEFAULT);
    eval 'sub SCTPCTL_CMT_ON_OFF_DESC () {"CMT settings";}' unless defined(&SCTPCTL_CMT_ON_OFF_DESC);
    eval 'sub SCTPCTL_CMT_ON_OFF_MIN () { &SCTP_CMT_OFF;}' unless defined(&SCTPCTL_CMT_ON_OFF_MIN);
    eval 'sub SCTPCTL_CMT_ON_OFF_MAX () { &SCTP_CMT_MAX;}' unless defined(&SCTPCTL_CMT_ON_OFF_MAX);
    eval 'sub SCTPCTL_CMT_ON_OFF_DEFAULT () { &SCTP_CMT_OFF;}' unless defined(&SCTPCTL_CMT_ON_OFF_DEFAULT);
    eval 'sub SCTPCTL_CMT_USE_DAC_DESC () {"CMT DAC on/off flag";}' unless defined(&SCTPCTL_CMT_USE_DAC_DESC);
    eval 'sub SCTPCTL_CMT_USE_DAC_MIN () {0;}' unless defined(&SCTPCTL_CMT_USE_DAC_MIN);
    eval 'sub SCTPCTL_CMT_USE_DAC_MAX () {1;}' unless defined(&SCTPCTL_CMT_USE_DAC_MAX);
    eval 'sub SCTPCTL_CMT_USE_DAC_DEFAULT () {0;}' unless defined(&SCTPCTL_CMT_USE_DAC_DEFAULT);
    eval 'sub SCTPCTL_CWND_MAXBURST_DESC () {"Use a CWND adjusting maxburst";}' unless defined(&SCTPCTL_CWND_MAXBURST_DESC);
    eval 'sub SCTPCTL_CWND_MAXBURST_MIN () {0;}' unless defined(&SCTPCTL_CWND_MAXBURST_MIN);
    eval 'sub SCTPCTL_CWND_MAXBURST_MAX () {1;}' unless defined(&SCTPCTL_CWND_MAXBURST_MAX);
    eval 'sub SCTPCTL_CWND_MAXBURST_DEFAULT () {1;}' unless defined(&SCTPCTL_CWND_MAXBURST_DEFAULT);
    eval 'sub SCTPCTL_NAT_FRIENDLY_DESC () {"SCTP NAT friendly operation";}' unless defined(&SCTPCTL_NAT_FRIENDLY_DESC);
    eval 'sub SCTPCTL_NAT_FRIENDLY_MIN () {0;}' unless defined(&SCTPCTL_NAT_FRIENDLY_MIN);
    eval 'sub SCTPCTL_NAT_FRIENDLY_MAX () {1;}' unless defined(&SCTPCTL_NAT_FRIENDLY_MAX);
    eval 'sub SCTPCTL_NAT_FRIENDLY_DEFAULT () {1;}' unless defined(&SCTPCTL_NAT_FRIENDLY_DEFAULT);
    eval 'sub SCTPCTL_ABC_L_VAR_DESC () {"SCTP ABC max increase per SACK (L)";}' unless defined(&SCTPCTL_ABC_L_VAR_DESC);
    eval 'sub SCTPCTL_ABC_L_VAR_MIN () {0;}' unless defined(&SCTPCTL_ABC_L_VAR_MIN);
    eval 'sub SCTPCTL_ABC_L_VAR_MAX () {0xffffffff;}' unless defined(&SCTPCTL_ABC_L_VAR_MAX);
    eval 'sub SCTPCTL_ABC_L_VAR_DEFAULT () {2;}' unless defined(&SCTPCTL_ABC_L_VAR_DEFAULT);
    eval 'sub SCTPCTL_MAX_CHAINED_MBUFS_DESC () {"Default max number of small mbufs on a chain";}' unless defined(&SCTPCTL_MAX_CHAINED_MBUFS_DESC);
    eval 'sub SCTPCTL_MAX_CHAINED_MBUFS_MIN () {0;}' unless defined(&SCTPCTL_MAX_CHAINED_MBUFS_MIN);
    eval 'sub SCTPCTL_MAX_CHAINED_MBUFS_MAX () {0xffffffff;}' unless defined(&SCTPCTL_MAX_CHAINED_MBUFS_MAX);
    eval 'sub SCTPCTL_MAX_CHAINED_MBUFS_DEFAULT () { &SCTP_DEFAULT_MBUFS_IN_CHAIN;}' unless defined(&SCTPCTL_MAX_CHAINED_MBUFS_DEFAULT);
    eval 'sub SCTPCTL_DO_SCTP_DRAIN_DESC () {"Should SCTP respond to the drain calls";}' unless defined(&SCTPCTL_DO_SCTP_DRAIN_DESC);
    eval 'sub SCTPCTL_DO_SCTP_DRAIN_MIN () {0;}' unless defined(&SCTPCTL_DO_SCTP_DRAIN_MIN);
    eval 'sub SCTPCTL_DO_SCTP_DRAIN_MAX () {1;}' unless defined(&SCTPCTL_DO_SCTP_DRAIN_MAX);
    eval 'sub SCTPCTL_DO_SCTP_DRAIN_DEFAULT () {1;}' unless defined(&SCTPCTL_DO_SCTP_DRAIN_DEFAULT);
    eval 'sub SCTPCTL_HB_MAX_BURST_DESC () {"Confirmation Heartbeat max burst";}' unless defined(&SCTPCTL_HB_MAX_BURST_DESC);
    eval 'sub SCTPCTL_HB_MAX_BURST_MIN () {1;}' unless defined(&SCTPCTL_HB_MAX_BURST_MIN);
    eval 'sub SCTPCTL_HB_MAX_BURST_MAX () {0xffffffff;}' unless defined(&SCTPCTL_HB_MAX_BURST_MAX);
    eval 'sub SCTPCTL_HB_MAX_BURST_DEFAULT () { &SCTP_DEF_HBMAX_BURST;}' unless defined(&SCTPCTL_HB_MAX_BURST_DEFAULT);
    eval 'sub SCTPCTL_ABORT_AT_LIMIT_DESC () {"When one-2-one hits qlimit abort";}' unless defined(&SCTPCTL_ABORT_AT_LIMIT_DESC);
    eval 'sub SCTPCTL_ABORT_AT_LIMIT_MIN () {0;}' unless defined(&SCTPCTL_ABORT_AT_LIMIT_MIN);
    eval 'sub SCTPCTL_ABORT_AT_LIMIT_MAX () {1;}' unless defined(&SCTPCTL_ABORT_AT_LIMIT_MAX);
    eval 'sub SCTPCTL_ABORT_AT_LIMIT_DEFAULT () {0;}' unless defined(&SCTPCTL_ABORT_AT_LIMIT_DEFAULT);
    eval 'sub SCTPCTL_MIN_RESIDUAL_DESC () {"Minimum residual data chunk in second part of split";}' unless defined(&SCTPCTL_MIN_RESIDUAL_DESC);
    eval 'sub SCTPCTL_MIN_RESIDUAL_MIN () {20;}' unless defined(&SCTPCTL_MIN_RESIDUAL_MIN);
    eval 'sub SCTPCTL_MIN_RESIDUAL_MAX () {65535;}' unless defined(&SCTPCTL_MIN_RESIDUAL_MAX);
    eval 'sub SCTPCTL_MIN_RESIDUAL_DEFAULT () {1452;}' unless defined(&SCTPCTL_MIN_RESIDUAL_DEFAULT);
    eval 'sub SCTPCTL_MAX_RETRAN_CHUNK_DESC () {"Maximum times an unlucky chunk can be retran\'d before assoc abort";}' unless defined(&SCTPCTL_MAX_RETRAN_CHUNK_DESC);
    eval 'sub SCTPCTL_MAX_RETRAN_CHUNK_MIN () {0;}' unless defined(&SCTPCTL_MAX_RETRAN_CHUNK_MIN);
    eval 'sub SCTPCTL_MAX_RETRAN_CHUNK_MAX () {65535;}' unless defined(&SCTPCTL_MAX_RETRAN_CHUNK_MAX);
    eval 'sub SCTPCTL_MAX_RETRAN_CHUNK_DEFAULT () {30;}' unless defined(&SCTPCTL_MAX_RETRAN_CHUNK_DEFAULT);
    eval 'sub SCTPCTL_LOGGING_LEVEL_DESC () {"Ltrace/KTR trace logging level";}' unless defined(&SCTPCTL_LOGGING_LEVEL_DESC);
    eval 'sub SCTPCTL_LOGGING_LEVEL_MIN () {0;}' unless defined(&SCTPCTL_LOGGING_LEVEL_MIN);
    eval 'sub SCTPCTL_LOGGING_LEVEL_MAX () {0xffffffff;}' unless defined(&SCTPCTL_LOGGING_LEVEL_MAX);
    eval 'sub SCTPCTL_LOGGING_LEVEL_DEFAULT () {0;}' unless defined(&SCTPCTL_LOGGING_LEVEL_DEFAULT);
    eval 'sub SCTPCTL_DEFAULT_CC_MODULE_DESC () {"Default congestion control module";}' unless defined(&SCTPCTL_DEFAULT_CC_MODULE_DESC);
    eval 'sub SCTPCTL_DEFAULT_CC_MODULE_MIN () {0;}' unless defined(&SCTPCTL_DEFAULT_CC_MODULE_MIN);
    eval 'sub SCTPCTL_DEFAULT_CC_MODULE_MAX () {2;}' unless defined(&SCTPCTL_DEFAULT_CC_MODULE_MAX);
    eval 'sub SCTPCTL_DEFAULT_CC_MODULE_DEFAULT () {0;}' unless defined(&SCTPCTL_DEFAULT_CC_MODULE_DEFAULT);
    eval 'sub SCTPCTL_DEFAULT_SS_MODULE_DESC () {"Default stream scheduling module";}' unless defined(&SCTPCTL_DEFAULT_SS_MODULE_DESC);
    eval 'sub SCTPCTL_DEFAULT_SS_MODULE_MIN () {0;}' unless defined(&SCTPCTL_DEFAULT_SS_MODULE_MIN);
    eval 'sub SCTPCTL_DEFAULT_SS_MODULE_MAX () {5;}' unless defined(&SCTPCTL_DEFAULT_SS_MODULE_MAX);
    eval 'sub SCTPCTL_DEFAULT_SS_MODULE_DEFAULT () {0;}' unless defined(&SCTPCTL_DEFAULT_SS_MODULE_DEFAULT);
    eval 'sub SCTPCTL_DEFAULT_FRAG_INTERLEAVE_DESC () {"Default fragment interleave level";}' unless defined(&SCTPCTL_DEFAULT_FRAG_INTERLEAVE_DESC);
    eval 'sub SCTPCTL_DEFAULT_FRAG_INTERLEAVE_MIN () {0;}' unless defined(&SCTPCTL_DEFAULT_FRAG_INTERLEAVE_MIN);
    eval 'sub SCTPCTL_DEFAULT_FRAG_INTERLEAVE_MAX () {2;}' unless defined(&SCTPCTL_DEFAULT_FRAG_INTERLEAVE_MAX);
    eval 'sub SCTPCTL_DEFAULT_FRAG_INTERLEAVE_DEFAULT () {1;}' unless defined(&SCTPCTL_DEFAULT_FRAG_INTERLEAVE_DEFAULT);
    eval 'sub SCTPCTL_MOBILITY_BASE_DESC () {"Enable SCTP base mobility";}' unless defined(&SCTPCTL_MOBILITY_BASE_DESC);
    eval 'sub SCTPCTL_MOBILITY_BASE_MIN () {0;}' unless defined(&SCTPCTL_MOBILITY_BASE_MIN);
    eval 'sub SCTPCTL_MOBILITY_BASE_MAX () {1;}' unless defined(&SCTPCTL_MOBILITY_BASE_MAX);
    eval 'sub SCTPCTL_MOBILITY_BASE_DEFAULT () {0;}' unless defined(&SCTPCTL_MOBILITY_BASE_DEFAULT);
    eval 'sub SCTPCTL_MOBILITY_FASTHANDOFF_DESC () {"Enable SCTP fast handoff";}' unless defined(&SCTPCTL_MOBILITY_FASTHANDOFF_DESC);
    eval 'sub SCTPCTL_MOBILITY_FASTHANDOFF_MIN () {0;}' unless defined(&SCTPCTL_MOBILITY_FASTHANDOFF_MIN);
    eval 'sub SCTPCTL_MOBILITY_FASTHANDOFF_MAX () {1;}' unless defined(&SCTPCTL_MOBILITY_FASTHANDOFF_MAX);
    eval 'sub SCTPCTL_MOBILITY_FASTHANDOFF_DEFAULT () {0;}' unless defined(&SCTPCTL_MOBILITY_FASTHANDOFF_DEFAULT);
    eval 'sub SCTPCTL_UDP_TUNNELING_PORT_DESC () {"Set the SCTP/UDP tunneling port";}' unless defined(&SCTPCTL_UDP_TUNNELING_PORT_DESC);
    eval 'sub SCTPCTL_UDP_TUNNELING_PORT_MIN () {0;}' unless defined(&SCTPCTL_UDP_TUNNELING_PORT_MIN);
    eval 'sub SCTPCTL_UDP_TUNNELING_PORT_MAX () {65535;}' unless defined(&SCTPCTL_UDP_TUNNELING_PORT_MAX);
    eval 'sub SCTPCTL_UDP_TUNNELING_PORT_DEFAULT () {0;}' unless defined(&SCTPCTL_UDP_TUNNELING_PORT_DEFAULT);
    eval 'sub SCTPCTL_SACK_IMMEDIATELY_ENABLE_DESC () {"Enable sending of the SACK-IMMEDIATELY-bit.";}' unless defined(&SCTPCTL_SACK_IMMEDIATELY_ENABLE_DESC);
    eval 'sub SCTPCTL_SACK_IMMEDIATELY_ENABLE_MIN () {0;}' unless defined(&SCTPCTL_SACK_IMMEDIATELY_ENABLE_MIN);
    eval 'sub SCTPCTL_SACK_IMMEDIATELY_ENABLE_MAX () {1;}' unless defined(&SCTPCTL_SACK_IMMEDIATELY_ENABLE_MAX);
    eval 'sub SCTPCTL_SACK_IMMEDIATELY_ENABLE_DEFAULT () { &SCTPCTL_SACK_IMMEDIATELY_ENABLE_MAX;}' unless defined(&SCTPCTL_SACK_IMMEDIATELY_ENABLE_DEFAULT);
    eval 'sub SCTPCTL_NAT_FRIENDLY_INITS_DESC () {"Enable sending of the nat-friendly SCTP option on INITs.";}' unless defined(&SCTPCTL_NAT_FRIENDLY_INITS_DESC);
    eval 'sub SCTPCTL_NAT_FRIENDLY_INITS_MIN () {0;}' unless defined(&SCTPCTL_NAT_FRIENDLY_INITS_MIN);
    eval 'sub SCTPCTL_NAT_FRIENDLY_INITS_MAX () {1;}' unless defined(&SCTPCTL_NAT_FRIENDLY_INITS_MAX);
    eval 'sub SCTPCTL_NAT_FRIENDLY_INITS_DEFAULT () { &SCTPCTL_NAT_FRIENDLY_INITS_MIN;}' unless defined(&SCTPCTL_NAT_FRIENDLY_INITS_DEFAULT);
    eval 'sub SCTPCTL_TIME_WAIT_DESC () {"Vtag time wait time in seconds, 0 disables it.";}' unless defined(&SCTPCTL_TIME_WAIT_DESC);
    eval 'sub SCTPCTL_TIME_WAIT_MIN () {0;}' unless defined(&SCTPCTL_TIME_WAIT_MIN);
    eval 'sub SCTPCTL_TIME_WAIT_MAX () {0xffffffff;}' unless defined(&SCTPCTL_TIME_WAIT_MAX);
    eval 'sub SCTPCTL_TIME_WAIT_DEFAULT () { &SCTP_TIME_WAIT;}' unless defined(&SCTPCTL_TIME_WAIT_DEFAULT);
    eval 'sub SCTPCTL_BUFFER_SPLITTING_DESC () {"Enable send/receive buffer splitting.";}' unless defined(&SCTPCTL_BUFFER_SPLITTING_DESC);
    eval 'sub SCTPCTL_BUFFER_SPLITTING_MIN () {0;}' unless defined(&SCTPCTL_BUFFER_SPLITTING_MIN);
    eval 'sub SCTPCTL_BUFFER_SPLITTING_MAX () {0x3;}' unless defined(&SCTPCTL_BUFFER_SPLITTING_MAX);
    eval 'sub SCTPCTL_BUFFER_SPLITTING_DEFAULT () { &SCTPCTL_BUFFER_SPLITTING_MIN;}' unless defined(&SCTPCTL_BUFFER_SPLITTING_DEFAULT);
    eval 'sub SCTPCTL_INITIAL_CWND_DESC () {"Initial congestion window in MTUs";}' unless defined(&SCTPCTL_INITIAL_CWND_DESC);
    eval 'sub SCTPCTL_INITIAL_CWND_MIN () {0;}' unless defined(&SCTPCTL_INITIAL_CWND_MIN);
    eval 'sub SCTPCTL_INITIAL_CWND_MAX () {0xffffffff;}' unless defined(&SCTPCTL_INITIAL_CWND_MAX);
    eval 'sub SCTPCTL_INITIAL_CWND_DEFAULT () {3;}' unless defined(&SCTPCTL_INITIAL_CWND_DEFAULT);
    eval 'sub SCTPCTL_RTTVAR_BW_DESC () {"Shift amount for bw smoothing on rtt calc";}' unless defined(&SCTPCTL_RTTVAR_BW_DESC);
    eval 'sub SCTPCTL_RTTVAR_BW_MIN () {0;}' unless defined(&SCTPCTL_RTTVAR_BW_MIN);
    eval 'sub SCTPCTL_RTTVAR_BW_MAX () {32;}' unless defined(&SCTPCTL_RTTVAR_BW_MAX);
    eval 'sub SCTPCTL_RTTVAR_BW_DEFAULT () {4;}' unless defined(&SCTPCTL_RTTVAR_BW_DEFAULT);
    eval 'sub SCTPCTL_RTTVAR_RTT_DESC () {"Shift amount for rtt smoothing on rtt calc";}' unless defined(&SCTPCTL_RTTVAR_RTT_DESC);
    eval 'sub SCTPCTL_RTTVAR_RTT_MIN () {0;}' unless defined(&SCTPCTL_RTTVAR_RTT_MIN);
    eval 'sub SCTPCTL_RTTVAR_RTT_MAX () {32;}' unless defined(&SCTPCTL_RTTVAR_RTT_MAX);
    eval 'sub SCTPCTL_RTTVAR_RTT_DEFAULT () {5;}' unless defined(&SCTPCTL_RTTVAR_RTT_DEFAULT);
    eval 'sub SCTPCTL_RTTVAR_EQRET_DESC () {"What to return when rtt and bw are unchanged";}' unless defined(&SCTPCTL_RTTVAR_EQRET_DESC);
    eval 'sub SCTPCTL_RTTVAR_EQRET_MIN () {0;}' unless defined(&SCTPCTL_RTTVAR_EQRET_MIN);
    eval 'sub SCTPCTL_RTTVAR_EQRET_MAX () {1;}' unless defined(&SCTPCTL_RTTVAR_EQRET_MAX);
    eval 'sub SCTPCTL_RTTVAR_EQRET_DEFAULT () {0;}' unless defined(&SCTPCTL_RTTVAR_EQRET_DEFAULT);
    eval 'sub SCTPCTL_RTTVAR_STEADYS_DESC () {"How many the sames it takes to try step down of cwnd";}' unless defined(&SCTPCTL_RTTVAR_STEADYS_DESC);
    eval 'sub SCTPCTL_RTTVAR_STEADYS_MIN () {0;}' unless defined(&SCTPCTL_RTTVAR_STEADYS_MIN);
    eval 'sub SCTPCTL_RTTVAR_STEADYS_MAX () {0xffff;}' unless defined(&SCTPCTL_RTTVAR_STEADYS_MAX);
    eval 'sub SCTPCTL_RTTVAR_STEADYS_DEFAULT () {20;}' unless defined(&SCTPCTL_RTTVAR_STEADYS_DEFAULT);
    eval 'sub SCTPCTL_RTTVAR_DCCCECN_DESC () {"Enable for RTCC CC datacenter ECN";}' unless defined(&SCTPCTL_RTTVAR_DCCCECN_DESC);
    eval 'sub SCTPCTL_RTTVAR_DCCCECN_MIN () {0;}' unless defined(&SCTPCTL_RTTVAR_DCCCECN_MIN);
    eval 'sub SCTPCTL_RTTVAR_DCCCECN_MAX () {1;}' unless defined(&SCTPCTL_RTTVAR_DCCCECN_MAX);
    eval 'sub SCTPCTL_RTTVAR_DCCCECN_DEFAULT () {1;}' unless defined(&SCTPCTL_RTTVAR_DCCCECN_DEFAULT);
    eval 'sub SCTPCTL_BLACKHOLE_DESC () {"Enable SCTP blackholing. See blackhole(4) for more details.";}' unless defined(&SCTPCTL_BLACKHOLE_DESC);
    eval 'sub SCTPCTL_BLACKHOLE_MIN () {0;}' unless defined(&SCTPCTL_BLACKHOLE_MIN);
    eval 'sub SCTPCTL_BLACKHOLE_MAX () {2;}' unless defined(&SCTPCTL_BLACKHOLE_MAX);
    eval 'sub SCTPCTL_BLACKHOLE_DEFAULT () { &SCTPCTL_BLACKHOLE_MIN;}' unless defined(&SCTPCTL_BLACKHOLE_DEFAULT);
    eval 'sub SCTPCTL_DIAG_INFO_CODE_DESC () {"Diagnostic information error cause code";}' unless defined(&SCTPCTL_DIAG_INFO_CODE_DESC);
    eval 'sub SCTPCTL_DIAG_INFO_CODE_MIN () {0;}' unless defined(&SCTPCTL_DIAG_INFO_CODE_MIN);
    eval 'sub SCTPCTL_DIAG_INFO_CODE_MAX () {65535;}' unless defined(&SCTPCTL_DIAG_INFO_CODE_MAX);
    eval 'sub SCTPCTL_DIAG_INFO_CODE_DEFAULT () {0;}' unless defined(&SCTPCTL_DIAG_INFO_CODE_DEFAULT);
    if(defined(&SCTP_DEBUG)) {
	eval 'sub SCTPCTL_DEBUG_DESC () {"Configure debug output";}' unless defined(&SCTPCTL_DEBUG_DESC);
	eval 'sub SCTPCTL_DEBUG_MIN () {0;}' unless defined(&SCTPCTL_DEBUG_MIN);
	eval 'sub SCTPCTL_DEBUG_MAX () {0xffffffff;}' unless defined(&SCTPCTL_DEBUG_MAX);
	eval 'sub SCTPCTL_DEBUG_DEFAULT () {0;}' unless defined(&SCTPCTL_DEBUG_DEFAULT);
    }
    if(defined(&__APPLE__) || defined(&SCTP_SO_LOCK_TESTING)) {
	eval 'sub SCTPCTL_OUTPUT_UNLOCKED_DESC () {"Unlock socket when sending packets down to IP.";}' unless defined(&SCTPCTL_OUTPUT_UNLOCKED_DESC);
	eval 'sub SCTPCTL_OUTPUT_UNLOCKED_MIN () {0;}' unless defined(&SCTPCTL_OUTPUT_UNLOCKED_MIN);
	eval 'sub SCTPCTL_OUTPUT_UNLOCKED_MAX () {1;}' unless defined(&SCTPCTL_OUTPUT_UNLOCKED_MAX);
	eval 'sub SCTPCTL_OUTPUT_UNLOCKED_DEFAULT () { &SCTPCTL_OUTPUT_UNLOCKED_MIN;}' unless defined(&SCTPCTL_OUTPUT_UNLOCKED_DEFAULT);
    }
    if(defined(&_KERNEL) || defined(&__Userspace__)) {
	if(defined(&SYSCTL_DECL)) {
	}
    }
}
1;
