require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NETINET_SCTP_UIO_H_)) {
    eval 'sub _NETINET_SCTP_UIO_H_ () {1;}' unless defined(&_NETINET_SCTP_UIO_H_);
    if(! defined(&_KERNEL)) {
	require 'stdint.ph';
    }
    require 'sys/types.ph';
    require 'sys/socket.ph';
    require 'netinet/in.ph';
    eval 'sub SCTP_FUTURE_ASSOC () {0;}' unless defined(&SCTP_FUTURE_ASSOC);
    eval 'sub SCTP_CURRENT_ASSOC () {1;}' unless defined(&SCTP_CURRENT_ASSOC);
    eval 'sub SCTP_ALL_ASSOC () {2;}' unless defined(&SCTP_ALL_ASSOC);
    eval 'sub sctp_stream_reset_events () { &sctp_stream_reset_event;}' unless defined(&sctp_stream_reset_events);
    eval 'sub SCTP_INIT () {0x1;}' unless defined(&SCTP_INIT);
    eval 'sub SCTP_SNDRCV () {0x2;}' unless defined(&SCTP_SNDRCV);
    eval 'sub SCTP_EXTRCV () {0x3;}' unless defined(&SCTP_EXTRCV);
    eval 'sub SCTP_SNDINFO () {0x4;}' unless defined(&SCTP_SNDINFO);
    eval 'sub SCTP_RCVINFO () {0x5;}' unless defined(&SCTP_RCVINFO);
    eval 'sub SCTP_NXTINFO () {0x6;}' unless defined(&SCTP_NXTINFO);
    eval 'sub SCTP_PRINFO () {0x7;}' unless defined(&SCTP_PRINFO);
    eval 'sub SCTP_AUTHINFO () {0x8;}' unless defined(&SCTP_AUTHINFO);
    eval 'sub SCTP_DSTADDRV4 () {0x9;}' unless defined(&SCTP_DSTADDRV4);
    eval 'sub SCTP_DSTADDRV6 () {0xa;}' unless defined(&SCTP_DSTADDRV6);
    eval 'sub SCTP_ALIGN_RESV_PAD () {92;}' unless defined(&SCTP_ALIGN_RESV_PAD);
    eval 'sub SCTP_ALIGN_RESV_PAD_SHORT () {76;}' unless defined(&SCTP_ALIGN_RESV_PAD_SHORT);
    eval 'sub sinfo_pr_value () { &sinfo_timetolive;}' unless defined(&sinfo_pr_value);
    eval 'sub sreinfo_next_flags () { &serinfo_next_flags;}' unless defined(&sreinfo_next_flags);
    eval 'sub sreinfo_next_stream () { &serinfo_next_stream;}' unless defined(&sreinfo_next_stream);
    eval 'sub sreinfo_next_aid () { &serinfo_next_aid;}' unless defined(&sreinfo_next_aid);
    eval 'sub sreinfo_next_length () { &serinfo_next_length;}' unless defined(&sreinfo_next_length);
    eval 'sub sreinfo_next_ppid () { &serinfo_next_ppid;}' unless defined(&sreinfo_next_ppid);
    eval 'sub SCTP_NO_NEXT_MSG () {0x;}' unless defined(&SCTP_NO_NEXT_MSG);
    eval 'sub SCTP_NEXT_MSG_AVAIL () {0x1;}' unless defined(&SCTP_NEXT_MSG_AVAIL);
    eval 'sub SCTP_NEXT_MSG_ISCOMPLETE () {0x2;}' unless defined(&SCTP_NEXT_MSG_ISCOMPLETE);
    eval 'sub SCTP_NEXT_MSG_IS_UNORDERED () {0x4;}' unless defined(&SCTP_NEXT_MSG_IS_UNORDERED);
    eval 'sub SCTP_NEXT_MSG_IS_NOTIFICATION () {0x8;}' unless defined(&SCTP_NEXT_MSG_IS_NOTIFICATION);
    eval 'sub SCTP_RECVV_NOINFO () {0;}' unless defined(&SCTP_RECVV_NOINFO);
    eval 'sub SCTP_RECVV_RCVINFO () {1;}' unless defined(&SCTP_RECVV_RCVINFO);
    eval 'sub SCTP_RECVV_NXTINFO () {2;}' unless defined(&SCTP_RECVV_NXTINFO);
    eval 'sub SCTP_RECVV_RN () {3;}' unless defined(&SCTP_RECVV_RN);
    eval 'sub SCTP_SENDV_NOINFO () {0;}' unless defined(&SCTP_SENDV_NOINFO);
    eval 'sub SCTP_SENDV_SNDINFO () {1;}' unless defined(&SCTP_SENDV_SNDINFO);
    eval 'sub SCTP_SENDV_PRINFO () {2;}' unless defined(&SCTP_SENDV_PRINFO);
    eval 'sub SCTP_SENDV_AUTHINFO () {3;}' unless defined(&SCTP_SENDV_AUTHINFO);
    eval 'sub SCTP_SENDV_SPA () {4;}' unless defined(&SCTP_SENDV_SPA);
    eval 'sub SCTP_SEND_SNDINFO_VALID () {0x1;}' unless defined(&SCTP_SEND_SNDINFO_VALID);
    eval 'sub SCTP_SEND_PRINFO_VALID () {0x2;}' unless defined(&SCTP_SEND_PRINFO_VALID);
    eval 'sub SCTP_SEND_AUTHINFO_VALID () {0x4;}' unless defined(&SCTP_SEND_AUTHINFO_VALID);
    eval 'sub SCTP_NOTIFICATION () {0x10;}' unless defined(&SCTP_NOTIFICATION);
    eval 'sub SCTP_COMPLETE () {0x20;}' unless defined(&SCTP_COMPLETE);
    eval 'sub SCTP_EOF () {0x100;}' unless defined(&SCTP_EOF);
    eval 'sub SCTP_ABORT () {0x200;}' unless defined(&SCTP_ABORT);
    eval 'sub SCTP_UNORDERED () {0x400;}' unless defined(&SCTP_UNORDERED);
    eval 'sub SCTP_ADDR_OVER () {0x800;}' unless defined(&SCTP_ADDR_OVER);
    eval 'sub SCTP_SENDALL () {0x1000;}' unless defined(&SCTP_SENDALL);
    eval 'sub SCTP_EOR () {0x2000;}' unless defined(&SCTP_EOR);
    eval 'sub SCTP_SACK_IMMEDIATELY () {0x4000;}' unless defined(&SCTP_SACK_IMMEDIATELY);
    eval 'sub INVALID_SINFO_FLAG {
        my($x) = @_;
	    eval q(((($x) & 0xfffffff0 & ~( &SCTP_EOF |  &SCTP_ABORT |  &SCTP_UNORDERED |  &SCTP_ADDR_OVER |  &SCTP_SENDALL |  &SCTP_EOR |  &SCTP_SACK_IMMEDIATELY)) != 0));
    }' unless defined(&INVALID_SINFO_FLAG);
    eval 'sub SCTP_PR_SCTP_NONE () {0x;}' unless defined(&SCTP_PR_SCTP_NONE);
    eval 'sub SCTP_PR_SCTP_TTL () {0x1;}' unless defined(&SCTP_PR_SCTP_TTL);
    eval 'sub SCTP_PR_SCTP_PRIO () {0x2;}' unless defined(&SCTP_PR_SCTP_PRIO);
    eval 'sub SCTP_PR_SCTP_BUF () { &SCTP_PR_SCTP_PRIO;}' unless defined(&SCTP_PR_SCTP_BUF);
    eval 'sub SCTP_PR_SCTP_RTX () {0x3;}' unless defined(&SCTP_PR_SCTP_RTX);
    eval 'sub SCTP_PR_SCTP_MAX () { &SCTP_PR_SCTP_RTX;}' unless defined(&SCTP_PR_SCTP_MAX);
    eval 'sub SCTP_PR_SCTP_ALL () {0xf;}' unless defined(&SCTP_PR_SCTP_ALL);
    eval 'sub PR_SCTP_POLICY {
        my($x) = @_;
	    eval q((($x) & 0xf));
    }' unless defined(&PR_SCTP_POLICY);
    eval 'sub PR_SCTP_ENABLED {
        my($x) = @_;
	    eval q((( &PR_SCTP_POLICY($x) !=  &SCTP_PR_SCTP_NONE)  && ( &PR_SCTP_POLICY($x) !=  &SCTP_PR_SCTP_ALL)));
    }' unless defined(&PR_SCTP_ENABLED);
    eval 'sub PR_SCTP_TTL_ENABLED {
        my($x) = @_;
	    eval q(( &PR_SCTP_POLICY($x) ==  &SCTP_PR_SCTP_TTL));
    }' unless defined(&PR_SCTP_TTL_ENABLED);
    eval 'sub PR_SCTP_BUF_ENABLED {
        my($x) = @_;
	    eval q(( &PR_SCTP_POLICY($x) ==  &SCTP_PR_SCTP_BUF));
    }' unless defined(&PR_SCTP_BUF_ENABLED);
    eval 'sub PR_SCTP_RTX_ENABLED {
        my($x) = @_;
	    eval q(( &PR_SCTP_POLICY($x) ==  &SCTP_PR_SCTP_RTX));
    }' unless defined(&PR_SCTP_RTX_ENABLED);
    eval 'sub PR_SCTP_INVALID_POLICY {
        my($x) = @_;
	    eval q(( &PR_SCTP_POLICY($x) >  &SCTP_PR_SCTP_MAX));
    }' unless defined(&PR_SCTP_INVALID_POLICY);
    eval 'sub PR_SCTP_VALID_POLICY {
        my($x) = @_;
	    eval q(( &PR_SCTP_POLICY($x) <=  &SCTP_PR_SCTP_MAX));
    }' unless defined(&PR_SCTP_VALID_POLICY);
    eval 'sub SCTP_COMM_UP () {0x1;}' unless defined(&SCTP_COMM_UP);
    eval 'sub SCTP_COMM_LOST () {0x2;}' unless defined(&SCTP_COMM_LOST);
    eval 'sub SCTP_RESTART () {0x3;}' unless defined(&SCTP_RESTART);
    eval 'sub SCTP_SHUTDOWN_COMP () {0x4;}' unless defined(&SCTP_SHUTDOWN_COMP);
    eval 'sub SCTP_CANT_STR_ASSOC () {0x5;}' unless defined(&SCTP_CANT_STR_ASSOC);
    eval 'sub SCTP_ASSOC_SUPPORTS_PR () {0x1;}' unless defined(&SCTP_ASSOC_SUPPORTS_PR);
    eval 'sub SCTP_ASSOC_SUPPORTS_AUTH () {0x2;}' unless defined(&SCTP_ASSOC_SUPPORTS_AUTH);
    eval 'sub SCTP_ASSOC_SUPPORTS_ASCONF () {0x3;}' unless defined(&SCTP_ASSOC_SUPPORTS_ASCONF);
    eval 'sub SCTP_ASSOC_SUPPORTS_MULTIBUF () {0x4;}' unless defined(&SCTP_ASSOC_SUPPORTS_MULTIBUF);
    eval 'sub SCTP_ASSOC_SUPPORTS_RE_CONFIG () {0x5;}' unless defined(&SCTP_ASSOC_SUPPORTS_RE_CONFIG);
    eval 'sub SCTP_ASSOC_SUPPORTS_INTERLEAVING () {0x6;}' unless defined(&SCTP_ASSOC_SUPPORTS_INTERLEAVING);
    eval 'sub SCTP_ASSOC_SUPPORTS_MAX () {0x6;}' unless defined(&SCTP_ASSOC_SUPPORTS_MAX);
    eval 'sub SCTP_ADDR_AVAILABLE () {0x1;}' unless defined(&SCTP_ADDR_AVAILABLE);
    eval 'sub SCTP_ADDR_UNREACHABLE () {0x2;}' unless defined(&SCTP_ADDR_UNREACHABLE);
    eval 'sub SCTP_ADDR_REMOVED () {0x3;}' unless defined(&SCTP_ADDR_REMOVED);
    eval 'sub SCTP_ADDR_ADDED () {0x4;}' unless defined(&SCTP_ADDR_ADDED);
    eval 'sub SCTP_ADDR_MADE_PRIM () {0x5;}' unless defined(&SCTP_ADDR_MADE_PRIM);
    eval 'sub SCTP_ADDR_CONFIRMED () {0x6;}' unless defined(&SCTP_ADDR_CONFIRMED);
    eval 'sub SCTP_ACTIVE () {0x1;}' unless defined(&SCTP_ACTIVE);
    eval 'sub SCTP_INACTIVE () {0x2;}' unless defined(&SCTP_INACTIVE);
    eval 'sub SCTP_UNCONFIRMED () {0x200;}' unless defined(&SCTP_UNCONFIRMED);
    eval 'sub SCTP_DATA_UNSENT () {0x1;}' unless defined(&SCTP_DATA_UNSENT);
    eval 'sub SCTP_DATA_SENT () {0x2;}' unless defined(&SCTP_DATA_SENT);
    eval 'sub SCTP_PARTIAL_DELIVERY_ABORTED () {0x1;}' unless defined(&SCTP_PARTIAL_DELIVERY_ABORTED);
    eval 'sub SCTP_AUTH_NEW_KEY () {0x1;}' unless defined(&SCTP_AUTH_NEW_KEY);
    eval 'sub SCTP_AUTH_NEWKEY () { &SCTP_AUTH_NEW_KEY;}' unless defined(&SCTP_AUTH_NEWKEY);
    eval 'sub SCTP_AUTH_NO_AUTH () {0x2;}' unless defined(&SCTP_AUTH_NO_AUTH);
    eval 'sub SCTP_AUTH_FREE_KEY () {0x3;}' unless defined(&SCTP_AUTH_FREE_KEY);
    eval 'sub SCTP_STREAM_RESET_INCOMING_SSN () {0x1;}' unless defined(&SCTP_STREAM_RESET_INCOMING_SSN);
    eval 'sub SCTP_STREAM_RESET_OUTGOING_SSN () {0x2;}' unless defined(&SCTP_STREAM_RESET_OUTGOING_SSN);
    eval 'sub SCTP_STREAM_RESET_DENIED () {0x4;}' unless defined(&SCTP_STREAM_RESET_DENIED);
    eval 'sub SCTP_STREAM_RESET_FAILED () {0x8;}' unless defined(&SCTP_STREAM_RESET_FAILED);
    eval 'sub SCTP_ASSOC_RESET_DENIED () {0x4;}' unless defined(&SCTP_ASSOC_RESET_DENIED);
    eval 'sub SCTP_ASSOC_RESET_FAILED () {0x8;}' unless defined(&SCTP_ASSOC_RESET_FAILED);
    eval 'sub SCTP_STREAM_CHANGE_DENIED () {0x4;}' unless defined(&SCTP_STREAM_CHANGE_DENIED);
    eval 'sub SCTP_STREAM_CHANGE_FAILED () {0x8;}' unless defined(&SCTP_STREAM_CHANGE_FAILED);
    eval 'sub SCTP_ASSOC_CHANGE () {0x1;}' unless defined(&SCTP_ASSOC_CHANGE);
    eval 'sub SCTP_PEER_ADDR_CHANGE () {0x2;}' unless defined(&SCTP_PEER_ADDR_CHANGE);
    eval 'sub SCTP_REMOTE_ERROR () {0x3;}' unless defined(&SCTP_REMOTE_ERROR);
    eval 'sub SCTP_SEND_FAILED () {0x4;}' unless defined(&SCTP_SEND_FAILED);
    eval 'sub SCTP_SHUTDOWN_EVENT () {0x5;}' unless defined(&SCTP_SHUTDOWN_EVENT);
    eval 'sub SCTP_ADAPTATION_INDICATION () {0x6;}' unless defined(&SCTP_ADAPTATION_INDICATION);
    eval 'sub SCTP_ADAPTION_INDICATION () {0x6;}' unless defined(&SCTP_ADAPTION_INDICATION);
    eval 'sub SCTP_PARTIAL_DELIVERY_EVENT () {0x7;}' unless defined(&SCTP_PARTIAL_DELIVERY_EVENT);
    eval 'sub SCTP_AUTHENTICATION_EVENT () {0x8;}' unless defined(&SCTP_AUTHENTICATION_EVENT);
    eval 'sub SCTP_STREAM_RESET_EVENT () {0x9;}' unless defined(&SCTP_STREAM_RESET_EVENT);
    eval 'sub SCTP_SENDER_DRY_EVENT () {0xa;}' unless defined(&SCTP_SENDER_DRY_EVENT);
    eval 'sub SCTP_NOTIFICATIONS_STOPPED_EVENT () {0xb;}' unless defined(&SCTP_NOTIFICATIONS_STOPPED_EVENT);
    eval 'sub SCTP_ASSOC_RESET_EVENT () {0xc;}' unless defined(&SCTP_ASSOC_RESET_EVENT);
    eval 'sub SCTP_STREAM_CHANGE_EVENT () {0xd;}' unless defined(&SCTP_STREAM_CHANGE_EVENT);
    eval 'sub SCTP_SEND_FAILED_EVENT () {0xe;}' unless defined(&SCTP_SEND_FAILED_EVENT);
    eval 'sub spp_ipv4_tos () { &spp_dscp;}' unless defined(&spp_ipv4_tos);
    eval 'sub SPP_HB_ENABLE () {0x1;}' unless defined(&SPP_HB_ENABLE);
    eval 'sub SPP_HB_DISABLE () {0x2;}' unless defined(&SPP_HB_DISABLE);
    eval 'sub SPP_HB_DEMAND () {0x4;}' unless defined(&SPP_HB_DEMAND);
    eval 'sub SPP_PMTUD_ENABLE () {0x8;}' unless defined(&SPP_PMTUD_ENABLE);
    eval 'sub SPP_PMTUD_DISABLE () {0x10;}' unless defined(&SPP_PMTUD_DISABLE);
    eval 'sub SPP_HB_TIME_IS_ZERO () {0x80;}' unless defined(&SPP_HB_TIME_IS_ZERO);
    eval 'sub SPP_IPV6_FLOWLABEL () {0x100;}' unless defined(&SPP_IPV6_FLOWLABEL);
    eval 'sub SPP_DSCP () {0x200;}' unless defined(&SPP_DSCP);
    eval 'sub SPP_IPV4_TOS () { &SPP_DSCP;}' unless defined(&SPP_IPV4_TOS);
    eval 'sub SCTP_AUTH_HMAC_ID_RSVD () {0x;}' unless defined(&SCTP_AUTH_HMAC_ID_RSVD);
    eval 'sub SCTP_AUTH_HMAC_ID_SHA1 () {0x1;}' unless defined(&SCTP_AUTH_HMAC_ID_SHA1);
    eval 'sub SCTP_AUTH_HMAC_ID_SHA256 () {0x3;}' unless defined(&SCTP_AUTH_HMAC_ID_SHA256);
    eval 'sub SCTP_MAX_EXPLICT_STR_RESET () {1000;}' unless defined(&SCTP_MAX_EXPLICT_STR_RESET);
    eval 'sub SCTP_STAT_INCR {
        my($_x) = @_;
	    eval q( &SCTP_STAT_INCR_BY($_x,1));
    }' unless defined(&SCTP_STAT_INCR);
    eval 'sub SCTP_STAT_DECR {
        my($_x) = @_;
	    eval q( &SCTP_STAT_DECR_BY($_x,1));
    }' unless defined(&SCTP_STAT_DECR);
    if(defined(&__FreeBSD__)  && defined(&SMP)  && defined(&SCTP_USE_PERCPU_STAT)) {
	eval 'sub SCTP_STAT_INCR_BY {
	    my($_x,$_d) = @_;
    	    eval q(( ($SCTP_BASE_STATS[&PCPU_GET(cpuid)]->{_x}) += $_d));
	}' unless defined(&SCTP_STAT_INCR_BY);
	eval 'sub SCTP_STAT_DECR_BY {
	    my($_x,$_d) = @_;
    	    eval q(( ($SCTP_BASE_STATS[&PCPU_GET(cpuid)]->{_x}) -= $_d));
	}' unless defined(&SCTP_STAT_DECR_BY);
    } else {
	eval 'sub SCTP_STAT_INCR_BY {
	    my($_x,$_d) = @_;
    	    eval q( &atomic_add_int( &SCTP_BASE_STAT($_x), $_d));
	}' unless defined(&SCTP_STAT_INCR_BY);
	eval 'sub SCTP_STAT_DECR_BY {
	    my($_x,$_d) = @_;
    	    eval q( &atomic_subtract_int( &SCTP_BASE_STAT($_x), $_d));
	}' unless defined(&SCTP_STAT_DECR_BY);
    }
    eval 'sub SCTP_STAT_INCR_COUNTER32 {
        my($_x) = @_;
	    eval q( &SCTP_STAT_INCR($_x));
    }' unless defined(&SCTP_STAT_INCR_COUNTER32);
    eval 'sub SCTP_STAT_INCR_COUNTER64 {
        my($_x) = @_;
	    eval q( &SCTP_STAT_INCR($_x));
    }' unless defined(&SCTP_STAT_INCR_COUNTER64);
    eval 'sub SCTP_STAT_INCR_GAUGE32 {
        my($_x) = @_;
	    eval q( &SCTP_STAT_INCR($_x));
    }' unless defined(&SCTP_STAT_INCR_GAUGE32);
    eval 'sub SCTP_STAT_DECR_COUNTER32 {
        my($_x) = @_;
	    eval q( &SCTP_STAT_DECR($_x));
    }' unless defined(&SCTP_STAT_DECR_COUNTER32);
    eval 'sub SCTP_STAT_DECR_COUNTER64 {
        my($_x) = @_;
	    eval q( &SCTP_STAT_DECR($_x));
    }' unless defined(&SCTP_STAT_DECR_COUNTER64);
    eval 'sub SCTP_STAT_DECR_GAUGE32 {
        my($_x) = @_;
	    eval q( &SCTP_STAT_DECR($_x));
    }' unless defined(&SCTP_STAT_DECR_GAUGE32);
    unless(defined(&ntohll)) {
	require 'sys/endian.ph';
	eval 'sub ntohll {
	    my($x) = @_;
    	    eval q( &be64toh($x));
	}' unless defined(&ntohll);
    }
    unless(defined(&htonll)) {
	require 'sys/endian.ph';
	eval 'sub htonll {
	    my($x) = @_;
    	    eval q( &htobe64($x));
	}' unless defined(&htonll);
    }
    if(defined(&__LP64__)) {
    } else {
    }
    eval 'sub SCTP_MAX_LOGGING_SIZE () {30000;}' unless defined(&SCTP_MAX_LOGGING_SIZE);
    eval 'sub SCTP_TRACE_PARAMS () {6;}' unless defined(&SCTP_TRACE_PARAMS);
    if(defined(&_KERNEL) || defined(&__Userspace__)) {
    }
    if(!(defined(&_KERNEL))  && !(defined(&__Userspace__))) {
    }
}
1;
