require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'sys/cdefs.ph';
unless(defined(&_NETINET_SCTP_UTIL_H_)) {
    eval 'sub _NETINET_SCTP_UTIL_H_ () {1;}' unless defined(&_NETINET_SCTP_UTIL_H_);
    if(defined(&_KERNEL) || defined(&__Userspace__)) {
	eval 'sub SCTP_READ_LOCK_HELD () {1;}' unless defined(&SCTP_READ_LOCK_HELD);
	eval 'sub SCTP_READ_LOCK_NOT_HELD () {0;}' unless defined(&SCTP_READ_LOCK_NOT_HELD);
	if(defined(&SCTP_ASOCLOG_OF_TSNS)) {
	}
	if(defined(&SCTP_MBUF_LOGGING)) {
	} else {
	    eval 'sub sctp_m_free () { &m_free;}' unless defined(&sctp_m_free);
	    eval 'sub sctp_m_freem () { &m_freem;}' unless defined(&sctp_m_freem);
	}
	if(defined(&SCTP_LOCAL_TRACE_BUF) || defined(&__APPLE__)) {
	}
	eval 'sub sctp_get_associd {
	    my($stcb) = @_;
    	    eval q((( &sctp_assoc_t) ($stcb->{asoc}->{assoc_id})));
	}' unless defined(&sctp_get_associd);
	if(!defined(&__APPLE__)  && !defined(&SCTP_SO_LOCK_TESTING)) {
	}
	if(!defined(&__APPLE__)  && !defined(&SCTP_SO_LOCK_TESTING)) {
	}
	if(!defined(&__APPLE__)  && !defined(&SCTP_SO_LOCK_TESTING)) {
	}
	if(!defined(&__APPLE__)  && !defined(&SCTP_SO_LOCK_TESTING)) {
	}
	if(!defined(&__APPLE__)  && !defined(&SCTP_SO_LOCK_TESTING)) {
	}
	if(!defined(&__APPLE__)  && !defined(&SCTP_SO_LOCK_TESTING)) {
	}
	if(defined(&INET6)) {
	    eval 'sub sctp_recover_scope_mac {
	        my($addr, $store) = @_;
    		eval q( &do {  &if (( ($addr->{sin6_family}) ==  &AF_INET6)  && ( &IN6_IS_SCOPE_LINKLOCAL( ($addr->{sin6_addr})))) { *$store = *$addr;  &if ( ($addr->{sin6_scope_id}) == 0) {  &if (! &sa6_recoverscope($store)) { $addr = $store; } }  &else {  &in6_clearscope( ($addr->{sin6_addr})); $addr = $store; } } }  &while (0));
	    }' unless defined(&sctp_recover_scope_mac);
	}
	if(!defined(&__APPLE__)  && !defined(&SCTP_SO_LOCK_TESTING)) {
	}
	if(defined(&SCTP_MBCNT_LOGGING)) {
	} else {
	    eval 'sub sctp_free_bufspace {
	        my($stcb, $asoc, $tp1, $chk_cnt) = @_;
    		eval q( &do {  &if ( ($tp1->{data}) !=  &NULL) {  &atomic_subtract_int((($asoc)-> &chunks_on_out_queue), $chk_cnt);  &if (($asoc)-> &total_output_queue_size >=  ($tp1->{book_size})) {  &atomic_subtract_int((($asoc)-> &total_output_queue_size),  ($tp1->{book_size})); }  &else { ($asoc)-> &total_output_queue_size = 0; }  &if ( ($stcb->{sctp_socket})  && (( ($stcb->{sctp_ep}->{sctp_flags}) &  &SCTP_PCB_FLAGS_TCPTYPE) || ( ($stcb->{sctp_ep}->{sctp_flags}) &  &SCTP_PCB_FLAGS_IN_TCPPOOL))) {  &if ( ($stcb->{sctp_socket}->{so_snd}->{sb_cc}) >=  ($tp1->{book_size})) {  &atomic_subtract_int((($stcb)-> ($sctp_socket->{so_snd}->{sb_cc})),  ($tp1->{book_size})); }  &else {  ($stcb->{sctp_socket}->{so_snd}->{sb_cc}) = 0; } } } }  &while (0));
	    }' unless defined(&sctp_free_bufspace);
	}
	eval 'sub sctp_free_spbufspace {
	    my($stcb, $asoc, $sp) = @_;
    	    eval q( &do {  &if ( ($sp->{data}) !=  &NULL) {  &if (($asoc)-> &total_output_queue_size >=  ($sp->{length})) {  &atomic_subtract_int(($asoc)-> &total_output_queue_size,  ($sp->{length})); }  &else { ($asoc)-> &total_output_queue_size = 0; }  &if ( ($stcb->{sctp_socket})  && (( ($stcb->{sctp_ep}->{sctp_flags}) &  &SCTP_PCB_FLAGS_TCPTYPE) || ( ($stcb->{sctp_ep}->{sctp_flags}) &  &SCTP_PCB_FLAGS_IN_TCPPOOL))) {  &if ( ($stcb->{sctp_socket}->{so_snd}->{sb_cc}) >=  ($sp->{length})) {  &atomic_subtract_int( ($stcb->{sctp_socket}->{so_snd}->{sb_cc}), ($sp->{length})); }  &else {  ($stcb->{sctp_socket}->{so_snd}->{sb_cc}) = 0; } } } }  &while (0));
	}' unless defined(&sctp_free_spbufspace);
	eval 'sub sctp_snd_sb_alloc {
	    my($stcb, $sz) = @_;
    	    eval q( &do {  &atomic_add_int( ($stcb->{asoc}->{total_output_queue_size}),$sz);  &if (( ($stcb->{sctp_socket}) !=  &NULL)  && (( ($stcb->{sctp_ep}->{sctp_flags}) &  &SCTP_PCB_FLAGS_TCPTYPE) || ( ($stcb->{sctp_ep}->{sctp_flags}) &  &SCTP_PCB_FLAGS_IN_TCPPOOL))) {  &atomic_add_int( ($stcb->{sctp_socket}->{so_snd}->{sb_cc}),$sz); } }  &while (0));
	}' unless defined(&sctp_snd_sb_alloc);
	if(defined(&SCTP_MBUF_LOGGING)) {
	}
	if(defined(&SCTP_AUDITING_ENABLED)) {
	}
	if(defined(&INET6) || defined(&INET)) {
	}
    }
}
1;
