require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_TCP_H_)) {
    eval 'sub _NETINET_TCP_H_ () {1;}' unless defined(&_NETINET_TCP_H_);
    require 'sys/cdefs.ph';
    require 'sys/types.ph';
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub tcp6_seq () { &tcp_seq;}' unless defined(&tcp6_seq);
	eval 'sub tcp6hdr () { &tcphdr;}' unless defined(&tcp6hdr);
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&LITTLE_ENDIAN) ? &LITTLE_ENDIAN : undef)) {
	}
	if((defined(&BYTE_ORDER) ? &BYTE_ORDER : undef) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : undef)) {
	}
	eval 'sub TH_FIN () {0x1;}' unless defined(&TH_FIN);
	eval 'sub TH_SYN () {0x2;}' unless defined(&TH_SYN);
	eval 'sub TH_RST () {0x4;}' unless defined(&TH_RST);
	eval 'sub TH_PUSH () {0x8;}' unless defined(&TH_PUSH);
	eval 'sub TH_ACK () {0x10;}' unless defined(&TH_ACK);
	eval 'sub TH_URG () {0x20;}' unless defined(&TH_URG);
	eval 'sub TH_ECE () {0x40;}' unless defined(&TH_ECE);
	eval 'sub TH_CWR () {0x80;}' unless defined(&TH_CWR);
	eval 'sub TH_FLAGS () {( &TH_FIN| &TH_SYN| &TH_RST| &TH_PUSH| &TH_ACK| &TH_URG| &TH_ECE| &TH_CWR);}' unless defined(&TH_FLAGS);
	eval 'sub PRINT_TH_FLAGS () {"\\20\\1FIN\\2SYN\\3RST\\4PUSH\\5ACK\\6URG\\7ECE\\10CWR";}' unless defined(&PRINT_TH_FLAGS);
	eval 'sub TCPOPT_EOL () {0;}' unless defined(&TCPOPT_EOL);
	eval 'sub TCPOLEN_EOL () {1;}' unless defined(&TCPOLEN_EOL);
	eval 'sub TCPOPT_PAD () {0;}' unless defined(&TCPOPT_PAD);
	eval 'sub TCPOLEN_PAD () {1;}' unless defined(&TCPOLEN_PAD);
	eval 'sub TCPOPT_NOP () {1;}' unless defined(&TCPOPT_NOP);
	eval 'sub TCPOLEN_NOP () {1;}' unless defined(&TCPOLEN_NOP);
	eval 'sub TCPOPT_MAXSEG () {2;}' unless defined(&TCPOPT_MAXSEG);
	eval 'sub TCPOLEN_MAXSEG () {4;}' unless defined(&TCPOLEN_MAXSEG);
	eval 'sub TCPOPT_WINDOW () {3;}' unless defined(&TCPOPT_WINDOW);
	eval 'sub TCPOLEN_WINDOW () {3;}' unless defined(&TCPOLEN_WINDOW);
	eval 'sub TCPOPT_SACK_PERMITTED () {4;}' unless defined(&TCPOPT_SACK_PERMITTED);
	eval 'sub TCPOLEN_SACK_PERMITTED () {2;}' unless defined(&TCPOLEN_SACK_PERMITTED);
	eval 'sub TCPOPT_SACK () {5;}' unless defined(&TCPOPT_SACK);
	eval 'sub TCPOLEN_SACKHDR () {2;}' unless defined(&TCPOLEN_SACKHDR);
	eval 'sub TCPOLEN_SACK () {8;}' unless defined(&TCPOLEN_SACK);
	eval 'sub TCPOPT_TIMESTAMP () {8;}' unless defined(&TCPOPT_TIMESTAMP);
	eval 'sub TCPOLEN_TIMESTAMP () {10;}' unless defined(&TCPOLEN_TIMESTAMP);
	eval 'sub TCPOLEN_TSTAMP_APPA () {( &TCPOLEN_TIMESTAMP+2);}' unless defined(&TCPOLEN_TSTAMP_APPA);
	eval 'sub TCPOPT_SIGNATURE () {19;}' unless defined(&TCPOPT_SIGNATURE);
	eval 'sub TCPOLEN_SIGNATURE () {18;}' unless defined(&TCPOLEN_SIGNATURE);
	eval 'sub TCPOPT_FAST_OPEN () {34;}' unless defined(&TCPOPT_FAST_OPEN);
	eval 'sub TCPOLEN_FAST_OPEN_EMPTY () {2;}' unless defined(&TCPOLEN_FAST_OPEN_EMPTY);
	eval 'sub TCPOLEN_FAST_OPEN_MIN () {6;}' unless defined(&TCPOLEN_FAST_OPEN_MIN);
	eval 'sub TCPOLEN_FAST_OPEN_MAX () {18;}' unless defined(&TCPOLEN_FAST_OPEN_MAX);
	eval 'sub MAX_SACK_BLKS () {6;}' unless defined(&MAX_SACK_BLKS);
	eval 'sub TCP_MAX_SACK () {4;}' unless defined(&TCP_MAX_SACK);
	eval 'sub TCP_MSS () {536;}' unless defined(&TCP_MSS);
	eval 'sub TCP6_MSS () {1220;}' unless defined(&TCP6_MSS);
	eval 'sub TCP_MINMSS () {216;}' unless defined(&TCP_MINMSS);
	eval 'sub TCP_MAXWIN () {65535;}' unless defined(&TCP_MAXWIN);
	eval 'sub TTCP_CLIENT_SND_WND () {4096;}' unless defined(&TTCP_CLIENT_SND_WND);
	eval 'sub TCP_MAX_WINSHIFT () {14;}' unless defined(&TCP_MAX_WINSHIFT);
	eval 'sub TCP_MAXBURST () {4;}' unless defined(&TCP_MAXBURST);
	eval 'sub TCP_MAXHLEN () {(0xf<<2);}' unless defined(&TCP_MAXHLEN);
	eval 'sub TCP_MAXOLEN () {( &TCP_MAXHLEN - $sizeof{\'struct tcphdr\'});}' unless defined(&TCP_MAXOLEN);
    }
    eval 'sub TCP_NODELAY () {1;}' unless defined(&TCP_NODELAY);
    if((defined(&__BSD_VISIBLE) ? &__BSD_VISIBLE : undef)) {
	eval 'sub TCP_MAXSEG () {2;}' unless defined(&TCP_MAXSEG);
	eval 'sub TCP_NOPUSH () {4;}' unless defined(&TCP_NOPUSH);
	eval 'sub TCP_NOOPT () {8;}' unless defined(&TCP_NOOPT);
	eval 'sub TCP_MD5SIG () {16;}' unless defined(&TCP_MD5SIG);
	eval 'sub TCP_INFO () {32;}' unless defined(&TCP_INFO);
	eval 'sub TCP_CONGESTION () {64;}' unless defined(&TCP_CONGESTION);
	eval 'sub TCP_CCALGOOPT () {65;}' unless defined(&TCP_CCALGOOPT);
	eval 'sub TCP_KEEPINIT () {128;}' unless defined(&TCP_KEEPINIT);
	eval 'sub TCP_KEEPIDLE () {256;}' unless defined(&TCP_KEEPIDLE);
	eval 'sub TCP_KEEPINTVL () {512;}' unless defined(&TCP_KEEPINTVL);
	eval 'sub TCP_KEEPCNT () {1024;}' unless defined(&TCP_KEEPCNT);
	eval 'sub TCP_FASTOPEN () {1025;}' unless defined(&TCP_FASTOPEN);
	eval 'sub TCP_PCAP_OUT () {2048;}' unless defined(&TCP_PCAP_OUT);
	eval 'sub TCP_PCAP_IN () {4096;}' unless defined(&TCP_PCAP_IN);
	eval 'sub TCP_FUNCTION_BLK () {8192;}' unless defined(&TCP_FUNCTION_BLK);
	eval 'sub TCP_VENDOR () { &SO_VENDOR;}' unless defined(&TCP_VENDOR);
	eval 'sub TCP_CA_NAME_MAX () {16;}' unless defined(&TCP_CA_NAME_MAX);
	eval 'sub TCPI_OPT_TIMESTAMPS () {0x1;}' unless defined(&TCPI_OPT_TIMESTAMPS);
	eval 'sub TCPI_OPT_SACK () {0x2;}' unless defined(&TCPI_OPT_SACK);
	eval 'sub TCPI_OPT_WSCALE () {0x4;}' unless defined(&TCPI_OPT_WSCALE);
	eval 'sub TCPI_OPT_ECN () {0x8;}' unless defined(&TCPI_OPT_ECN);
	eval 'sub TCPI_OPT_TOE () {0x10;}' unless defined(&TCPI_OPT_TOE);
    }
    eval 'sub TCP_FUNCTION_NAME_LEN_MAX () {32;}' unless defined(&TCP_FUNCTION_NAME_LEN_MAX);
}
1;
