require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETINET_UDP_VAR_H_)) {
    eval 'sub _NETINET_UDP_VAR_H_ () {1;}' unless defined(&_NETINET_UDP_VAR_H_);
    eval 'sub ui_x1 () { ($ui_i->{ih_x1});}' unless defined(&ui_x1);
    eval 'sub ui_v () { ($ui_i->{ih_x1[0]});}' unless defined(&ui_v);
    eval 'sub ui_pr () { ($ui_i->{ih_pr});}' unless defined(&ui_pr);
    eval 'sub ui_len () { ($ui_i->{ih_len});}' unless defined(&ui_len);
    eval 'sub ui_src () { ($ui_i->{ih_src});}' unless defined(&ui_src);
    eval 'sub ui_dst () { ($ui_i->{ih_dst});}' unless defined(&ui_dst);
    eval 'sub ui_sport () { ($ui_u->{uh_sport});}' unless defined(&ui_sport);
    eval 'sub ui_dport () { ($ui_u->{uh_dport});}' unless defined(&ui_dport);
    eval 'sub ui_ulen () { ($ui_u->{uh_ulen});}' unless defined(&ui_ulen);
    eval 'sub ui_sum () { ($ui_u->{uh_sum});}' unless defined(&ui_sum);
    eval 'sub intoudpcb {
        my($ip) = @_;
	    eval q((($ip)-> &inp_ppcb));
    }' unless defined(&intoudpcb);
    eval 'sub sotoudpcb {
        my($so) = @_;
	    eval q(( &intoudpcb( &sotoinpcb($so))));
    }' unless defined(&sotoudpcb);
    eval 'sub UF_ESPINUDP_NON_IKE () {0x1;}' unless defined(&UF_ESPINUDP_NON_IKE);
    eval 'sub UF_ESPINUDP () {0x2;}' unless defined(&UF_ESPINUDP);
    if(defined(&_KERNEL)) {
	require 'sys/counter.ph';
	eval 'sub UDPSTAT_ADD {
	    my($name, $val) = @_;
    	    eval q( &VNET_PCPUSTAT_ADD(\'struct udpstat\',  &udpstat, $name, ($val)));
	}' unless defined(&UDPSTAT_ADD);
	eval 'sub UDPSTAT_INC {
	    my($name) = @_;
    	    eval q( &UDPSTAT_ADD($name, 1));
	}' unless defined(&UDPSTAT_INC);
	eval 'sub KMOD_UDPSTAT_INC {
	    my($name) = @_;
    	    eval q( &kmod_udpstat_inc( &offsetof(\'struct udpstat\', $name) / $sizeof{ &uint64_t}));
	}' unless defined(&KMOD_UDPSTAT_INC);
    }
    eval 'sub UDPCTL_CHECKSUM () {1;}' unless defined(&UDPCTL_CHECKSUM);
    eval 'sub UDPCTL_STATS () {2;}' unless defined(&UDPCTL_STATS);
    eval 'sub UDPCTL_MAXDGRAM () {3;}' unless defined(&UDPCTL_MAXDGRAM);
    eval 'sub UDPCTL_RECVSPACE () {4;}' unless defined(&UDPCTL_RECVSPACE);
    eval 'sub UDPCTL_PCBLIST () {5;}' unless defined(&UDPCTL_PCBLIST);
    if(defined(&_KERNEL)) {
	require 'netinet/in_pcb.ph';
	eval 'sub V_udb () { &VNET( &udb);}' unless defined(&V_udb);
	eval 'sub V_udbinfo () { &VNET( &udbinfo);}' unless defined(&V_udbinfo);
	eval 'sub V_ulitecb () { &VNET( &ulitecb);}' unless defined(&V_ulitecb);
	eval 'sub V_ulitecbinfo () { &VNET( &ulitecbinfo);}' unless defined(&V_ulitecbinfo);
	eval 'sub V_udp_cksum () { &VNET( &udp_cksum);}' unless defined(&V_udp_cksum);
	eval 'sub V_udp_blackhole () { &VNET( &udp_blackhole);}' unless defined(&V_udp_blackhole);
	eval 'sub udp_get_inpcbinfo {
	    my($protocol) = @_;
    	    eval q({ ($protocol ==  &IPPROTO_UDP) ?  &V_udbinfo :  &V_ulitecbinfo; });
	}' unless defined(&udp_get_inpcbinfo);
	eval 'sub udp_get_pcblist {
	    my($protocol) = @_;
    	    eval q({ ($protocol ==  &IPPROTO_UDP) ?  &V_udb :  &V_ulitecb; });
	}' unless defined(&udp_get_pcblist);
    }
}
1;
