require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETIPSEC_IPSEC6_H_)) {
    eval 'sub _NETIPSEC_IPSEC6_H_ () {1;}' unless defined(&_NETIPSEC_IPSEC6_H_);
    require 'net/pfkeyv2.ph';
    require 'netipsec/keydb.ph';
    if(defined(&_KERNEL)) {
	require 'sys/counter.ph';
	eval 'sub IPSEC6STAT_INC {
	    my($name) = @_;
    	    eval q( &VNET_PCPUSTAT_ADD(\'struct ipsecstat\',  &ipsec6stat, $name, 1));
	}' unless defined(&IPSEC6STAT_INC);
	eval 'sub V_ip6_esp_trans_deflev () { &VNET( &ip6_esp_trans_deflev);}' unless defined(&V_ip6_esp_trans_deflev);
	eval 'sub V_ip6_esp_net_deflev () { &VNET( &ip6_esp_net_deflev);}' unless defined(&V_ip6_esp_net_deflev);
	eval 'sub V_ip6_ah_trans_deflev () { &VNET( &ip6_ah_trans_deflev);}' unless defined(&V_ip6_ah_trans_deflev);
	eval 'sub V_ip6_ah_net_deflev () { &VNET( &ip6_ah_net_deflev);}' unless defined(&V_ip6_ah_net_deflev);
	eval 'sub V_ip6_ipsec_ecn () { &VNET( &ip6_ipsec_ecn);}' unless defined(&V_ip6_ipsec_ecn);
    }
}
1;
