require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETIPSEC_XFORM_H_)) {
    eval 'sub _NETIPSEC_XFORM_H_ () {1;}' unless defined(&_NETIPSEC_XFORM_H_);
    require 'sys/types.ph';
    require 'sys/queue.ph';
    require 'netinet/in.ph';
    require 'opencrypto/xform.ph';
    eval 'sub AH_HMAC_HASHLEN () {12;}' unless defined(&AH_HMAC_HASHLEN);
    eval 'sub AH_HMAC_MAXHASHLEN () {( &SHA2_512_HASH_LEN/2);}' unless defined(&AH_HMAC_MAXHASHLEN);
    eval 'sub AH_HMAC_INITIAL_RPL () {1;}' unless defined(&AH_HMAC_INITIAL_RPL);
    if(defined(&_KERNEL)) {
	eval 'sub XF_IP4 () {1;}' unless defined(&XF_IP4);
	eval 'sub XF_AH () {2;}' unless defined(&XF_AH);
	eval 'sub XF_ESP () {3;}' unless defined(&XF_ESP);
	eval 'sub XF_TCPSIGNATURE () {5;}' unless defined(&XF_TCPSIGNATURE);
	eval 'sub XF_IPCOMP () {6;}' unless defined(&XF_IPCOMP);
    }
}
1;
