require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETNATM_API_ATMAPI_H_)) {
    eval 'sub _NETNATM_API_ATMAPI_H_ () {1;}' unless defined(&_NETNATM_API_ATMAPI_H_);
    require 'sys/types.ph';
    eval 'sub ATM_EPNAMSIZ () {65;}' unless defined(&ATM_EPNAMSIZ);
    eval("sub ATM_A0 () { 0; }") unless defined(&ATM_A0);
    eval("sub ATM_A1 () { 1; }") unless defined(&ATM_A1);
    eval("sub ATM_A2 () { 2; }") unless defined(&ATM_A2);
    eval("sub ATM_A3 () { 3; }") unless defined(&ATM_A3);
    eval("sub ATM_A4 () { 4; }") unless defined(&ATM_A4);
    eval("sub ATM_A5 () { 5; }") unless defined(&ATM_A5);
    eval("sub ATM_A6 () { 6; }") unless defined(&ATM_A6);
    eval("sub ATM_A7 () { 7; }") unless defined(&ATM_A7);
    eval("sub ATM_A8 () { 8; }") unless defined(&ATM_A8);
    eval("sub ATM_A9 () { 9; }") unless defined(&ATM_A9);
    eval("sub ATM_A10 () { 10; }") unless defined(&ATM_A10);
    eval("sub ATM_A11 () { 11; }") unless defined(&ATM_A11);
    eval("sub ATMOP_RESP () { 0; }") unless defined(&ATMOP_RESP);
    eval("sub ATMOP_ABORT_CONNECTION () { 1; }") unless defined(&ATMOP_ABORT_CONNECTION);
    eval("sub ATMOP_ACCEPT_INCOMING_CALL () { 2; }") unless defined(&ATMOP_ACCEPT_INCOMING_CALL);
    eval("sub ATMOP_ADD_PARTY () { 3; }") unless defined(&ATMOP_ADD_PARTY);
    eval("sub ATMOP_ADD_PARTY_REJECT () { 4; }") unless defined(&ATMOP_ADD_PARTY_REJECT);
    eval("sub ATMOP_ADD_PARTY_SUCCESS () { 5; }") unless defined(&ATMOP_ADD_PARTY_SUCCESS);
    eval("sub ATMOP_ARRIVAL_OF_INCOMING_CALL () { 6; }") unless defined(&ATMOP_ARRIVAL_OF_INCOMING_CALL);
    eval("sub ATMOP_CALL_RELEASE () { 7; }") unless defined(&ATMOP_CALL_RELEASE);
    eval("sub ATMOP_CONNECT_OUTGOING_CALL () { 8; }") unless defined(&ATMOP_CONNECT_OUTGOING_CALL);
    eval("sub ATMOP_DROP_PARTY () { 9; }") unless defined(&ATMOP_DROP_PARTY);
    eval("sub ATMOP_GET_LOCAL_PORT_INFO () { 10; }") unless defined(&ATMOP_GET_LOCAL_PORT_INFO);
    eval("sub ATMOP_P2MP_CALL_ACTIVE () { 11; }") unless defined(&ATMOP_P2MP_CALL_ACTIVE);
    eval("sub ATMOP_P2P_CALL_ACTIVE () { 12; }") unless defined(&ATMOP_P2P_CALL_ACTIVE);
    eval("sub ATMOP_PREPARE_INCOMING_CALL () { 13; }") unless defined(&ATMOP_PREPARE_INCOMING_CALL);
    eval("sub ATMOP_PREPARE_OUTGOING_CALL () { 14; }") unless defined(&ATMOP_PREPARE_OUTGOING_CALL);
    eval("sub ATMOP_QUERY_CONNECTION_ATTRIBUTES () { 15; }") unless defined(&ATMOP_QUERY_CONNECTION_ATTRIBUTES);
    eval("sub ATMOP_REJECT_INCOMING_CALL () { 16; }") unless defined(&ATMOP_REJECT_INCOMING_CALL);
    eval("sub ATMOP_SET_CONNECTION_ATTRIBUTES () { 17; }") unless defined(&ATMOP_SET_CONNECTION_ATTRIBUTES);
    eval("sub ATMOP_WAIT_ON_INCOMING_CALL () { 18; }") unless defined(&ATMOP_WAIT_ON_INCOMING_CALL);
    eval("sub ATMOP_SET_CONNECTION_ATTRIBUTES_X () { 19; }") unless defined(&ATMOP_SET_CONNECTION_ATTRIBUTES_X);
    eval("sub ATMOP_QUERY_CONNECTION_ATTRIBUTES_X () { 20; }") unless defined(&ATMOP_QUERY_CONNECTION_ATTRIBUTES_X);
    eval("sub ATMOP_QUERY_STATE () { 21; }") unless defined(&ATMOP_QUERY_STATE);
    eval 'sub ATM_DEFINE_ERRORS () { &DEF( &ATMERR_OK, 0, "OK")  &DEF( &ATMERR_SYS, -1, "syscall error")  &DEF( &ATMERR_BAD_OP, -2, "bad operation")  &DEF( &ATMERR_BAD_ARGS, -3, "bad arguments for operation")  &DEF( &ATMERR_BAD_STATE, -4, "operation in bad state")  &DEF( &ATMERR_BAD_ATTR, -5, "unknown attribute")  &DEF( &ATMERR_BAD_VALUE, -6, "bad attribute value")  &DEF( &ATMERR_BUSY, -7, "busy")  &DEF( &ATMERR_RDONLY, -8, "read-only attribute")  &DEF( &ATMERR_BAD_SAP, -9, "bad SAP")  &DEF( &ATMERR_OVERLAP, -10,"overlaping SAP")  &DEF( &ATMERR_BAD_ENDPOINT, -11,"bad ATM endpoint")  &DEF( &ATMERR_PREVIOUSLY_ABORTED,-12,"previously aborted")  &DEF( &ATMERR_NO_CALL, -13,"no incoming call")  &DEF( &ATMERR_BAD_LEAF_IDENT, -14,"bad leaf identifier")  &DEF( &ATMERR_BAD_PORT, -15,"unknown port")  &DEF( &ATMERR_BAD_SIGNAL, -29- &UNIAPI_ERROR_BAD_SIGNAL, "bad signal")  &DEF( &ATMERR_BADCU, -29- &UNIAPI_ERROR_BADCU, "bad coordinator state")  &DEF( &ATMERR_BAD_CALLSTATE, -29- &UNIAPI_ERROR_BAD_CALLSTATE, "bad call state")  &DEF( &ATMERR_BAD_EPSTATE, -29- &UNIAPI_ERROR_BAD_EPSTATE, "bad party state")  &DEF( &ATMERR_BAD_UNIARG, -29- &UNIAPI_ERROR_BAD_ARG, "bad uni argument")  &DEF( &ATMERR_BAD_CALL, -29- &UNIAPI_ERROR_BAD_CALL, "unknown call")  &DEF( &ATMERR_BAD_PARTY, -29- &UNIAPI_ERROR_BAD_PARTY, "unknown party")  &DEF( &ATMERR_BAD_CTYPE, -29- &UNIAPI_ERROR_BAD_CTYPE, "wrong call type")  &DEF( &ATMERR_BAD_IE, -29- &UNIAPI_ERROR_BAD_IE, "bad information element")  &DEF( &ATMERR_EPREF_INUSE, -29- &UNIAPI_ERROR_EPREF_INUSE, "endpoint reference in use")  &DEF( &ATMERR_MISSING_IE, -29- &UNIAPI_ERROR_MISSING_IE, "missing information element")  &DEF( &ATMERR_ENCODING, -29- &UNIAPI_ERROR_ENCODING, "encoding error")  &DEF( &ATMERR_NOMEM, -29- &UNIAPI_ERROR_NOMEM, "no memory")  &DEF( &ATMERR_UNIBUSY, -29- &UNIAPI_ERROR_BUSY, "uni process busy");}' unless defined(&ATM_DEFINE_ERRORS);
    eval 'sub ATM_MKUNIERR {
        my($E) = @_;
	    eval q((-29- ($E)));
    }' unless defined(&ATM_MKUNIERR);
    eval("sub VAL () { 0; }") unless defined(&VAL);
    eval("sub ATM_ATTR_NONE () { 0; }") unless defined(&ATM_ATTR_NONE);
    eval("sub ATM_ATTR_BLLI_SELECTOR () { 1; }") unless defined(&ATM_ATTR_BLLI_SELECTOR);
    eval("sub ATM_ATTR_BLLI () { 2; }") unless defined(&ATM_ATTR_BLLI);
    eval("sub ATM_ATTR_BEARER () { 3; }") unless defined(&ATM_ATTR_BEARER);
    eval("sub ATM_ATTR_TRAFFIC () { 4; }") unless defined(&ATM_ATTR_TRAFFIC);
    eval("sub ATM_ATTR_QOS () { 5; }") unless defined(&ATM_ATTR_QOS);
    eval("sub ATM_ATTR_EXQOS () { 6; }") unless defined(&ATM_ATTR_EXQOS);
    eval("sub ATM_ATTR_CALLED () { 7; }") unless defined(&ATM_ATTR_CALLED);
    eval("sub ATM_ATTR_CALLEDSUB () { 8; }") unless defined(&ATM_ATTR_CALLEDSUB);
    eval("sub ATM_ATTR_CALLING () { 9; }") unless defined(&ATM_ATTR_CALLING);
    eval("sub ATM_ATTR_CALLINGSUB () { 10; }") unless defined(&ATM_ATTR_CALLINGSUB);
    eval("sub ATM_ATTR_AAL () { 11; }") unless defined(&ATM_ATTR_AAL);
    eval("sub ATM_ATTR_EPREF () { 12; }") unless defined(&ATM_ATTR_EPREF);
    eval("sub ATM_ATTR_CONNED () { 13; }") unless defined(&ATM_ATTR_CONNED);
    eval("sub ATM_ATTR_CONNEDSUB () { 14; }") unless defined(&ATM_ATTR_CONNEDSUB);
    eval("sub ATM_ATTR_EETD () { 15; }") unless defined(&ATM_ATTR_EETD);
    eval("sub ATM_ATTR_ABRSETUP () { 16; }") unless defined(&ATM_ATTR_ABRSETUP);
    eval("sub ATM_ATTR_ABRADD () { 17; }") unless defined(&ATM_ATTR_ABRADD);
    eval("sub ATM_ATTR_CONNID () { 18; }") unless defined(&ATM_ATTR_CONNID);
    eval("sub ATM_ATTR_MDCR () { 19; }") unless defined(&ATM_ATTR_MDCR);
    eval("sub ATMRESP_NONE () { 0; }") unless defined(&ATMRESP_NONE);
    eval("sub ATMRESP_ATTRS () { 1; }") unless defined(&ATMRESP_ATTRS);
    eval("sub ATMRESP_PORTS () { 2; }") unless defined(&ATMRESP_PORTS);
    eval("sub ATMRESP_STATE () { 3; }") unless defined(&ATMRESP_STATE);
    eval("sub ATMRESP_EXSTAT () { 4; }") unless defined(&ATMRESP_EXSTAT);
    if(defined(&__GNUC__)  && (defined(&__GNUC__) ? &__GNUC__ : undef) < 3) {
    } else {
    }
    if(defined(&__GNUC__)  && (defined(&__GNUC__) ? &__GNUC__ : undef) < 3) {
    } else {
    }
}
1;
