require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETNATM_MSG_UNISTRUCT_H_)) {
    eval 'sub _NETNATM_MSG_UNISTRUCT_H_ () {1;}' unless defined(&_NETNATM_MSG_UNISTRUCT_H_);
    require 'netnatm/msg/uni_config.ph';
    require 'netnatm/msg/uni_hdr.ph';
    eval("sub UNI_AAL_SUB_ID () { 0x85; }") unless defined(&UNI_AAL_SUB_ID);
    eval("sub UNI_AAL_CBR_ID () { 0x86; }") unless defined(&UNI_AAL_CBR_ID);
    eval("sub UNI_AAL_MULT_ID () { 0x87; }") unless defined(&UNI_AAL_MULT_ID);
    eval("sub UNI_AAL_SCREC_ID () { 0x88; }") unless defined(&UNI_AAL_SCREC_ID);
    eval("sub UNI_AAL_ECM_ID () { 0x89; }") unless defined(&UNI_AAL_ECM_ID);
    eval("sub UNI_AAL_BSIZE_ID () { 0x8a; }") unless defined(&UNI_AAL_BSIZE_ID);
    eval("sub UNI_AAL_PART_ID () { 0x8b; }") unless defined(&UNI_AAL_PART_ID);
    eval("sub UNI_AAL_FWDCPCS_ID () { 0x8c; }") unless defined(&UNI_AAL_FWDCPCS_ID);
    eval("sub UNI_AAL_BWDCPCS_ID () { 0x81; }") unless defined(&UNI_AAL_BWDCPCS_ID);
    eval("sub UNI_AAL_MID_ID () { 0x82; }") unless defined(&UNI_AAL_MID_ID);
    eval("sub UNI_AAL_SSCS_ID () { 0x84; }") unless defined(&UNI_AAL_SSCS_ID);
    eval("sub UNI_AAL_0 () { 0x00; }") unless defined(&UNI_AAL_0);
    eval("sub UNI_AAL_1 () { 0x01; }") unless defined(&UNI_AAL_1);
    eval("sub UNI_AAL_2 () { 0x02; }") unless defined(&UNI_AAL_2);
    eval("sub UNI_AAL_4 () { 0x03; }") unless defined(&UNI_AAL_4);
    eval("sub UNI_AAL_5 () { 0x05; }") unless defined(&UNI_AAL_5);
    eval("sub UNI_AAL_USER () { 0x10; }") unless defined(&UNI_AAL_USER);
    eval("sub UNI_AAL1_SUB_NULL () { 0x00; }") unless defined(&UNI_AAL1_SUB_NULL);
    eval("sub UNI_AAL1_SUB_VOICE () { 0x01; }") unless defined(&UNI_AAL1_SUB_VOICE);
    eval("sub UNI_AAL1_SUB_CIRCUIT () { 0x02; }") unless defined(&UNI_AAL1_SUB_CIRCUIT);
    eval("sub UNI_AAL1_SUB_HQAUDIO () { 0x04; }") unless defined(&UNI_AAL1_SUB_HQAUDIO);
    eval("sub UNI_AAL1_SUB_VIDEO () { 0x05; }") unless defined(&UNI_AAL1_SUB_VIDEO);
    eval("sub UNI_AAL1_CBR_64 () { 0x01; }") unless defined(&UNI_AAL1_CBR_64);
    eval("sub UNI_AAL1_CBR_1544 () { 0x04; }") unless defined(&UNI_AAL1_CBR_1544);
    eval("sub UNI_AAL1_CBR_6312 () { 0x05; }") unless defined(&UNI_AAL1_CBR_6312);
    eval("sub UNI_AAL1_CBR_32064 () { 0x06; }") unless defined(&UNI_AAL1_CBR_32064);
    eval("sub UNI_AAL1_CBR_44736 () { 0x07; }") unless defined(&UNI_AAL1_CBR_44736);
    eval("sub UNI_AAL1_CBR_97728 () { 0x08; }") unless defined(&UNI_AAL1_CBR_97728);
    eval("sub UNI_AAL1_CBR_2048 () { 0x10; }") unless defined(&UNI_AAL1_CBR_2048);
    eval("sub UNI_AAL1_CBR_8448 () { 0x11; }") unless defined(&UNI_AAL1_CBR_8448);
    eval("sub UNI_AAL1_CBR_34368 () { 0x12; }") unless defined(&UNI_AAL1_CBR_34368);
    eval("sub UNI_AAL1_CBR_139264 () { 0x13; }") unless defined(&UNI_AAL1_CBR_139264);
    eval("sub UNI_AAL1_CBR_N64 () { 0x40; }") unless defined(&UNI_AAL1_CBR_N64);
    eval("sub UNI_AAL1_CBR_N8 () { 0x41; }") unless defined(&UNI_AAL1_CBR_N8);
    eval("sub UNI_AAL1_SCREC_NULL () { 0x00; }") unless defined(&UNI_AAL1_SCREC_NULL);
    eval("sub UNI_AAL1_SCREC_SRTS () { 0x01; }") unless defined(&UNI_AAL1_SCREC_SRTS);
    eval("sub UNI_AAL1_SCREC_ACLK () { 0x02; }") unless defined(&UNI_AAL1_SCREC_ACLK);
    eval("sub UNI_AAL1_ECM_NULL () { 0x00; }") unless defined(&UNI_AAL1_ECM_NULL);
    eval("sub UNI_AAL1_ECM_LOSS () { 0x01; }") unless defined(&UNI_AAL1_ECM_LOSS);
    eval("sub UNI_AAL1_ECM_DELAY () { 0x02; }") unless defined(&UNI_AAL1_ECM_DELAY);
    eval("sub UNI_AAL_SSCS_NULL () { 0x00; }") unless defined(&UNI_AAL_SSCS_NULL);
    eval("sub UNI_AAL_SSCS_SSCOPA () { 0x01; }") unless defined(&UNI_AAL_SSCS_SSCOPA);
    eval("sub UNI_AAL_SSCS_SSCOPU () { 0x02; }") unless defined(&UNI_AAL_SSCS_SSCOPU);
    eval("sub UNI_AAL_SSCS_FRAME () { 0x04; }") unless defined(&UNI_AAL_SSCS_FRAME);
    eval 'sub UNI_AAL1_MULT_P () {0x1;}' unless defined(&UNI_AAL1_MULT_P);
    eval 'sub UNI_AAL1_SCREC_P () {0x2;}' unless defined(&UNI_AAL1_SCREC_P);
    eval 'sub UNI_AAL1_ECM_P () {0x4;}' unless defined(&UNI_AAL1_ECM_P);
    eval 'sub UNI_AAL1_BSIZE_P () {0x8;}' unless defined(&UNI_AAL1_BSIZE_P);
    eval 'sub UNI_AAL1_PART_P () {0x10;}' unless defined(&UNI_AAL1_PART_P);
    eval 'sub UNI_AAL4_CPCS_P () {0x1;}' unless defined(&UNI_AAL4_CPCS_P);
    eval 'sub UNI_AAL4_MID_P () {0x2;}' unless defined(&UNI_AAL4_MID_P);
    eval 'sub UNI_AAL4_SSCS_P () {0x4;}' unless defined(&UNI_AAL4_SSCS_P);
    eval 'sub UNI_AAL5_CPCS_P () {0x1;}' unless defined(&UNI_AAL5_CPCS_P);
    eval 'sub UNI_AAL5_SSCS_P () {0x2;}' unless defined(&UNI_AAL5_SSCS_P);
    eval("sub UNI_ADDR_UNKNOWN () { 0x0; }") unless defined(&UNI_ADDR_UNKNOWN);
    eval("sub UNI_ADDR_INTERNATIONAL () { 0x1; }") unless defined(&UNI_ADDR_INTERNATIONAL);
    eval("sub UNI_ADDR_NATIONAL () { 0x2; }") unless defined(&UNI_ADDR_NATIONAL);
    eval("sub UNI_ADDR_NETWORK () { 0x3; }") unless defined(&UNI_ADDR_NETWORK);
    eval("sub UNI_ADDR_SUBSCR () { 0x4; }") unless defined(&UNI_ADDR_SUBSCR);
    eval("sub UNI_ADDR_ABBR () { 0x6; }") unless defined(&UNI_ADDR_ABBR);
    eval("sub UNI_ADDR_E164 () { 0x1; }") unless defined(&UNI_ADDR_E164);
    eval("sub UNI_ADDR_ATME () { 0x2; }") unless defined(&UNI_ADDR_ATME);
    eval("sub UNI_ADDR_DATA () { 0x3; }") unless defined(&UNI_ADDR_DATA);
    eval("sub UNI_ADDR_PRIVATE () { 0x9; }") unless defined(&UNI_ADDR_PRIVATE);
    eval("sub UNI_SUBADDR_NSAP () { 0x0; }") unless defined(&UNI_SUBADDR_NSAP);
    eval("sub UNI_SUBADDR_ATME () { 0x1; }") unless defined(&UNI_SUBADDR_ATME);
    eval("sub UNI_SUBADDR_USER () { 0x2; }") unless defined(&UNI_SUBADDR_USER);
    eval("sub UNI_ADDR_PRES () { 0x0; }") unless defined(&UNI_ADDR_PRES);
    eval("sub UNI_ADDR_RESTRICT () { 0x1; }") unless defined(&UNI_ADDR_RESTRICT);
    eval("sub UNI_ADDR_NONUMBER () { 0x2; }") unless defined(&UNI_ADDR_NONUMBER);
    eval("sub UNI_ADDR_SCREEN_NOT () { 0x0; }") unless defined(&UNI_ADDR_SCREEN_NOT);
    eval("sub UNI_ADDR_SCREEN_PASSED () { 0x1; }") unless defined(&UNI_ADDR_SCREEN_PASSED);
    eval("sub UNI_ADDR_SCREEN_FAILED () { 0x2; }") unless defined(&UNI_ADDR_SCREEN_FAILED);
    eval("sub UNI_ADDR_SCREEN_NET () { 0x3; }") unless defined(&UNI_ADDR_SCREEN_NET);
    eval 'sub UNI_CALLING_SCREEN_P () {0x1;}' unless defined(&UNI_CALLING_SCREEN_P);
    eval 'sub UNI_CONNED_SCREEN_P () {0x1;}' unless defined(&UNI_CONNED_SCREEN_P);
    eval("sub UNI_BEARER_A () { 0x01; }") unless defined(&UNI_BEARER_A);
    eval("sub UNI_BEARER_C () { 0x03; }") unless defined(&UNI_BEARER_C);
    eval("sub UNI_BEARER_X () { 0x10; }") unless defined(&UNI_BEARER_X);
    eval("sub UNI_BEARER_TVP () { 0x30; }") unless defined(&UNI_BEARER_TVP);
    eval("sub UNI_BEARER_ATC_CBR () { 0x05; }") unless defined(&UNI_BEARER_ATC_CBR);
    eval("sub UNI_BEARER_ATC_CBR1 () { 0x07; }") unless defined(&UNI_BEARER_ATC_CBR1);
    eval("sub UNI_BEARER_ATC_VBR () { 0x09; }") unless defined(&UNI_BEARER_ATC_VBR);
    eval("sub UNI_BEARER_ATC_VBR1 () { 0x13; }") unless defined(&UNI_BEARER_ATC_VBR1);
    eval("sub UNI_BEARER_ATC_NVBR () { 0x0a; }") unless defined(&UNI_BEARER_ATC_NVBR);
    eval("sub UNI_BEARER_ATC_NVBR1 () { 0x0b; }") unless defined(&UNI_BEARER_ATC_NVBR1);
    eval("sub UNI_BEARER_ATC_ABR () { 0x0c; }") unless defined(&UNI_BEARER_ATC_ABR);
    eval("sub UNI_BEARER_ATCX_0 () { 0x00; }") unless defined(&UNI_BEARER_ATCX_0);
    eval("sub UNI_BEARER_ATCX_1 () { 0x01; }") unless defined(&UNI_BEARER_ATCX_1);
    eval("sub UNI_BEARER_ATCX_2 () { 0x02; }") unless defined(&UNI_BEARER_ATCX_2);
    eval("sub UNI_BEARER_ATCX_4 () { 0x04; }") unless defined(&UNI_BEARER_ATCX_4);
    eval("sub UNI_BEARER_ATCX_6 () { 0x06; }") unless defined(&UNI_BEARER_ATCX_6);
    eval("sub UNI_BEARER_ATCX_8 () { 0x08; }") unless defined(&UNI_BEARER_ATCX_8);
    eval("sub UNI_BEARER_NOCLIP () { 0x0; }") unless defined(&UNI_BEARER_NOCLIP);
    eval("sub UNI_BEARER_CLIP () { 0x1; }") unless defined(&UNI_BEARER_CLIP);
    eval("sub UNI_BEARER_P2P () { 0x0; }") unless defined(&UNI_BEARER_P2P);
    eval("sub UNI_BEARER_MP () { 0x1; }") unless defined(&UNI_BEARER_MP);
    eval 'sub UNI_BEARER_ATC_P () {0x2;}' unless defined(&UNI_BEARER_ATC_P);
    eval("sub UNI_BHLI_ISO () { 0x00; }") unless defined(&UNI_BHLI_ISO);
    eval("sub UNI_BHLI_USER () { 0x01; }") unless defined(&UNI_BHLI_USER);
    eval("sub UNI_BHLI_VENDOR () { 0x03; }") unless defined(&UNI_BHLI_VENDOR);
    eval("sub UNI_BLLI_L1_ID () { 0x1; }") unless defined(&UNI_BLLI_L1_ID);
    eval("sub UNI_BLLI_L2_ID () { 0x2; }") unless defined(&UNI_BLLI_L2_ID);
    eval("sub UNI_BLLI_L3_ID () { 0x3; }") unless defined(&UNI_BLLI_L3_ID);
    eval("sub UNI_BLLI_L2_BASIC () { 0x01; }") unless defined(&UNI_BLLI_L2_BASIC);
    eval("sub UNI_BLLI_L2_Q921 () { 0x02; }") unless defined(&UNI_BLLI_L2_Q921);
    eval("sub UNI_BLLI_L2_X25LL () { 0x06; }") unless defined(&UNI_BLLI_L2_X25LL);
    eval("sub UNI_BLLI_L2_X25ML () { 0x07; }") unless defined(&UNI_BLLI_L2_X25ML);
    eval("sub UNI_BLLI_L2_LABP () { 0x08; }") unless defined(&UNI_BLLI_L2_LABP);
    eval("sub UNI_BLLI_L2_HDLC_ARM () { 0x09; }") unless defined(&UNI_BLLI_L2_HDLC_ARM);
    eval("sub UNI_BLLI_L2_HDLC_NRM () { 0x0a; }") unless defined(&UNI_BLLI_L2_HDLC_NRM);
    eval("sub UNI_BLLI_L2_HDLC_ABM () { 0x0b; }") unless defined(&UNI_BLLI_L2_HDLC_ABM);
    eval("sub UNI_BLLI_L2_LAN () { 0x0c; }") unless defined(&UNI_BLLI_L2_LAN);
    eval("sub UNI_BLLI_L2_X75 () { 0x0d; }") unless defined(&UNI_BLLI_L2_X75);
    eval("sub UNI_BLLI_L2_Q922 () { 0x0e; }") unless defined(&UNI_BLLI_L2_Q922);
    eval("sub UNI_BLLI_L2_USER () { 0x10; }") unless defined(&UNI_BLLI_L2_USER);
    eval("sub UNI_BLLI_L2_ISO7776 () { 0x11; }") unless defined(&UNI_BLLI_L2_ISO7776);
    eval("sub UNI_BLLI_L2NORM () { 0x1; }") unless defined(&UNI_BLLI_L2NORM);
    eval("sub UNI_BLLI_L2EXT () { 0x2; }") unless defined(&UNI_BLLI_L2EXT);
    eval("sub UNI_BLLI_L3_X25 () { 0x06; }") unless defined(&UNI_BLLI_L3_X25);
    eval("sub UNI_BLLI_L3_ISO8208 () { 0x07; }") unless defined(&UNI_BLLI_L3_ISO8208);
    eval("sub UNI_BLLI_L3_X223 () { 0x08; }") unless defined(&UNI_BLLI_L3_X223);
    eval("sub UNI_BLLI_L3_CLMP () { 0x09; }") unless defined(&UNI_BLLI_L3_CLMP);
    eval("sub UNI_BLLI_L3_T70 () { 0x0a; }") unless defined(&UNI_BLLI_L3_T70);
    eval("sub UNI_BLLI_L3_TR9577 () { 0x0b; }") unless defined(&UNI_BLLI_L3_TR9577);
    eval("sub UNI_BLLI_L3_H310 () { 0x0c; }") unless defined(&UNI_BLLI_L3_H310);
    eval("sub UNI_BLLI_L3_H321 () { 0x0d; }") unless defined(&UNI_BLLI_L3_H321);
    eval("sub UNI_BLLI_L3_USER () { 0x10; }") unless defined(&UNI_BLLI_L3_USER);
    eval("sub UNI_BLLI_L3NSEQ () { 0x1; }") unless defined(&UNI_BLLI_L3NSEQ);
    eval("sub UNI_BLLI_L3ESEQ () { 0x2; }") unless defined(&UNI_BLLI_L3ESEQ);
    eval("sub UNI_BLLI_L3_16 () { 0x4; }") unless defined(&UNI_BLLI_L3_16);
    eval("sub UNI_BLLI_L3_32 () { 0x5; }") unless defined(&UNI_BLLI_L3_32);
    eval("sub UNI_BLLI_L3_64 () { 0x6; }") unless defined(&UNI_BLLI_L3_64);
    eval("sub UNI_BLLI_L3_128 () { 0x7; }") unless defined(&UNI_BLLI_L3_128);
    eval("sub UNI_BLLI_L3_256 () { 0x8; }") unless defined(&UNI_BLLI_L3_256);
    eval("sub UNI_BLLI_L3_512 () { 0x9; }") unless defined(&UNI_BLLI_L3_512);
    eval("sub UNI_BLLI_L3_1024 () { 0xa; }") unless defined(&UNI_BLLI_L3_1024);
    eval("sub UNI_BLLI_L3_2048 () { 0xb; }") unless defined(&UNI_BLLI_L3_2048);
    eval("sub UNI_BLLI_L3_4096 () { 0xc; }") unless defined(&UNI_BLLI_L3_4096);
    eval("sub UNI_BLLI_L3_TTYPE_RECV () { 0x1; }") unless defined(&UNI_BLLI_L3_TTYPE_RECV);
    eval("sub UNI_BLLI_L3_TTYPE_SEND () { 0x2; }") unless defined(&UNI_BLLI_L3_TTYPE_SEND);
    eval("sub UNI_BLLI_L3_TTYPE_BOTH () { 0x3; }") unless defined(&UNI_BLLI_L3_TTYPE_BOTH);
    eval("sub UNI_BLLI_L3_MUX_NOMUX () { 0; }") unless defined(&UNI_BLLI_L3_MUX_NOMUX);
    eval("sub UNI_BLLI_L3_MUX_TS () { 1; }") unless defined(&UNI_BLLI_L3_MUX_TS);
    eval("sub UNI_BLLI_L3_MUX_TSFEC () { 2; }") unless defined(&UNI_BLLI_L3_MUX_TSFEC);
    eval("sub UNI_BLLI_L3_MUX_PS () { 3; }") unless defined(&UNI_BLLI_L3_MUX_PS);
    eval("sub UNI_BLLI_L3_MUX_PSFEC () { 4; }") unless defined(&UNI_BLLI_L3_MUX_PSFEC);
    eval("sub UNI_BLLI_L3_MUX_H221 () { 5; }") unless defined(&UNI_BLLI_L3_MUX_H221);
    eval("sub UNI_BLLI_L3_TCAP_NOIND () { 0; }") unless defined(&UNI_BLLI_L3_TCAP_NOIND);
    eval("sub UNI_BLLI_L3_TCAP_AAL1 () { 1; }") unless defined(&UNI_BLLI_L3_TCAP_AAL1);
    eval("sub UNI_BLLI_L3_TCAP_AAL5 () { 2; }") unless defined(&UNI_BLLI_L3_TCAP_AAL5);
    eval("sub UNI_BLLI_L3_TCAP_AAL15 () { 3; }") unless defined(&UNI_BLLI_L3_TCAP_AAL15);
    eval("sub UNI_BLLI_L3_SNAP () { 0x80; }") unless defined(&UNI_BLLI_L3_SNAP);
    eval 'sub UNI_BLLI_L1_P () {0x1;}' unless defined(&UNI_BLLI_L1_P);
    eval 'sub UNI_BLLI_L2_P () {0x2;}' unless defined(&UNI_BLLI_L2_P);
    eval 'sub UNI_BLLI_L2_Q933_P () {0x4;}' unless defined(&UNI_BLLI_L2_Q933_P);
    eval 'sub UNI_BLLI_L2_WSIZ_P () {0x8;}' unless defined(&UNI_BLLI_L2_WSIZ_P);
    eval 'sub UNI_BLLI_L2_USER_P () {0x10;}' unless defined(&UNI_BLLI_L2_USER_P);
    eval 'sub UNI_BLLI_L3_P () {0x20;}' unless defined(&UNI_BLLI_L3_P);
    eval 'sub UNI_BLLI_L3_MODE_P () {0x40;}' unless defined(&UNI_BLLI_L3_MODE_P);
    eval 'sub UNI_BLLI_L3_PSIZ_P () {0x80;}' unless defined(&UNI_BLLI_L3_PSIZ_P);
    eval 'sub UNI_BLLI_L3_WSIZ_P () {0x100;}' unless defined(&UNI_BLLI_L3_WSIZ_P);
    eval 'sub UNI_BLLI_L3_USER_P () {0x200;}' unless defined(&UNI_BLLI_L3_USER_P);
    eval 'sub UNI_BLLI_L3_IPI_P () {0x400;}' unless defined(&UNI_BLLI_L3_IPI_P);
    eval 'sub UNI_BLLI_L3_SNAP_P () {0x800;}' unless defined(&UNI_BLLI_L3_SNAP_P);
    eval 'sub UNI_BLLI_L3_TTYPE_P () {0x1000;}' unless defined(&UNI_BLLI_L3_TTYPE_P);
    eval 'sub UNI_BLLI_L3_MUX_P () {0x2000;}' unless defined(&UNI_BLLI_L3_MUX_P);
    eval("sub UNI_CALLSTATE_U0 () { 0x00; }") unless defined(&UNI_CALLSTATE_U0);
    eval("sub UNI_CALLSTATE_N0 () { 0x00; }") unless defined(&UNI_CALLSTATE_N0);
    eval("sub UNI_CALLSTATE_NN0 () { 0x00; }") unless defined(&UNI_CALLSTATE_NN0);
    eval("sub UNI_CALLSTATE_U1 () { 0x01; }") unless defined(&UNI_CALLSTATE_U1);
    eval("sub UNI_CALLSTATE_N1 () { 0x01; }") unless defined(&UNI_CALLSTATE_N1);
    eval("sub UNI_CALLSTATE_NN1 () { 0x01; }") unless defined(&UNI_CALLSTATE_NN1);
    eval("sub UNI_CALLSTATE_U3 () { 0x03; }") unless defined(&UNI_CALLSTATE_U3);
    eval("sub UNI_CALLSTATE_N3 () { 0x03; }") unless defined(&UNI_CALLSTATE_N3);
    eval("sub UNI_CALLSTATE_NN3 () { 0x03; }") unless defined(&UNI_CALLSTATE_NN3);
    eval("sub UNI_CALLSTATE_U4 () { 0x04; }") unless defined(&UNI_CALLSTATE_U4);
    eval("sub UNI_CALLSTATE_N4 () { 0x04; }") unless defined(&UNI_CALLSTATE_N4);
    eval("sub UNI_CALLSTATE_NN4 () { 0x04; }") unless defined(&UNI_CALLSTATE_NN4);
    eval("sub UNI_CALLSTATE_U6 () { 0x06; }") unless defined(&UNI_CALLSTATE_U6);
    eval("sub UNI_CALLSTATE_N6 () { 0x06; }") unless defined(&UNI_CALLSTATE_N6);
    eval("sub UNI_CALLSTATE_NN6 () { 0x06; }") unless defined(&UNI_CALLSTATE_NN6);
    eval("sub UNI_CALLSTATE_U7 () { 0x07; }") unless defined(&UNI_CALLSTATE_U7);
    eval("sub UNI_CALLSTATE_N7 () { 0x07; }") unless defined(&UNI_CALLSTATE_N7);
    eval("sub UNI_CALLSTATE_NN7 () { 0x07; }") unless defined(&UNI_CALLSTATE_NN7);
    eval("sub UNI_CALLSTATE_U8 () { 0x08; }") unless defined(&UNI_CALLSTATE_U8);
    eval("sub UNI_CALLSTATE_N8 () { 0x08; }") unless defined(&UNI_CALLSTATE_N8);
    eval("sub UNI_CALLSTATE_U9 () { 0x09; }") unless defined(&UNI_CALLSTATE_U9);
    eval("sub UNI_CALLSTATE_N9 () { 0x09; }") unless defined(&UNI_CALLSTATE_N9);
    eval("sub UNI_CALLSTATE_NN9 () { 0x09; }") unless defined(&UNI_CALLSTATE_NN9);
    eval("sub UNI_CALLSTATE_U10 () { 0x0a; }") unless defined(&UNI_CALLSTATE_U10);
    eval("sub UNI_CALLSTATE_N10 () { 0x0a; }") unless defined(&UNI_CALLSTATE_N10);
    eval("sub UNI_CALLSTATE_NN10 () { 0x0a; }") unless defined(&UNI_CALLSTATE_NN10);
    eval("sub UNI_CALLSTATE_U11 () { 0x0b; }") unless defined(&UNI_CALLSTATE_U11);
    eval("sub UNI_CALLSTATE_N11 () { 0x0b; }") unless defined(&UNI_CALLSTATE_N11);
    eval("sub UNI_CALLSTATE_NN11 () { 0x0b; }") unless defined(&UNI_CALLSTATE_NN11);
    eval("sub UNI_CALLSTATE_U12 () { 0x0c; }") unless defined(&UNI_CALLSTATE_U12);
    eval("sub UNI_CALLSTATE_N12 () { 0x0c; }") unless defined(&UNI_CALLSTATE_N12);
    eval("sub UNI_CALLSTATE_NN12 () { 0x0c; }") unless defined(&UNI_CALLSTATE_NN12);
    eval("sub UNI_CALLSTATE_REST0 () { 0x00; }") unless defined(&UNI_CALLSTATE_REST0);
    eval("sub UNI_CALLSTATE_REST1 () { 0x3d; }") unless defined(&UNI_CALLSTATE_REST1);
    eval("sub UNI_CALLSTATE_REST2 () { 0x3e; }") unless defined(&UNI_CALLSTATE_REST2);
    eval("sub UNI_CALLSTATE_U13 () { 0x0d; }") unless defined(&UNI_CALLSTATE_U13);
    eval("sub UNI_CALLSTATE_N13 () { 0x0d; }") unless defined(&UNI_CALLSTATE_N13);
    eval("sub UNI_CALLSTATE_U14 () { 0x0e; }") unless defined(&UNI_CALLSTATE_U14);
    eval("sub UNI_CALLSTATE_N14 () { 0x0e; }") unless defined(&UNI_CALLSTATE_N14);
    eval("sub UNI_CAUSE_LOC_USER () { 0x0; }") unless defined(&UNI_CAUSE_LOC_USER);
    eval("sub UNI_CAUSE_LOC_PRIVLOC () { 0x1; }") unless defined(&UNI_CAUSE_LOC_PRIVLOC);
    eval("sub UNI_CAUSE_LOC_PUBLOC () { 0x2; }") unless defined(&UNI_CAUSE_LOC_PUBLOC);
    eval("sub UNI_CAUSE_LOC_TRANSIT () { 0x3; }") unless defined(&UNI_CAUSE_LOC_TRANSIT);
    eval("sub UNI_CAUSE_LOC_PUBREM () { 0x4; }") unless defined(&UNI_CAUSE_LOC_PUBREM);
    eval("sub UNI_CAUSE_LOC_PRIVREM () { 0x5; }") unless defined(&UNI_CAUSE_LOC_PRIVREM);
    eval("sub UNI_CAUSE_LOC_INTERNAT () { 0x6; }") unless defined(&UNI_CAUSE_LOC_INTERNAT);
    eval("sub UNI_CAUSE_LOC_BEYOND () { 0x7; }") unless defined(&UNI_CAUSE_LOC_BEYOND);
    eval 'sub UNI_DECLARE_CAUSE_VALUES () { &D( &UNALL_NUM, 0x1 ,  &COND,  &Q.850, "Unallocated (unassigned) number")  &D( &NOROUTE_NET, 0x2 ,  &TNS,  &Q.850, "No route to specified transit network")  &D( &NOROUTE, 0x3 ,  &COND,  &Q.850, "No route to destination")  &D( &SPTONE, 0x4 ,  &NONE,  &Q.850, "Send special information tone")  &D( &BADTRUNK, 0x5 ,  &NONE,  &Q.850, "Misdialled trunk prefix")  &D( &BADCHAN, 0x6 ,  &NONE,  &Q.850, "Channel unacceptable")  &D( &CALLAWARDED, 0x7 ,  &NONE,  &Q.850, "Call awarded and being delivered in an established channel")  &D( &PREEMPT, 0x8 ,  &NONE,  &Q.850, "Preemption")  &D( &PREEMPT_RES, 0x9 ,  &NONE,  &Q.850, "Preemption - circuit reserved for reuse")  &D( &CLEARING, 0x10 ,  &COND,  &Q.850, "Normal call clearing")  &D( &BUSY, 0x11 ,  &CCBS,  &Q.850, "User busy")  &D( &NO_RESPONSE, 0x12 ,  &NONE,  &Q.850, "No user responding")  &D( &NO_RESP_ALERT,0x13 ,  &NONE,  &Q.850, "No answer from user (user alerted)")  &D( &ABSENT, 0x14 ,  &NONE,  &Q.850, "Subscriber absent")  &D( &REJECTED, 0x15 ,  &REJ,  &Q.850, "Call rejected")  &D( &NUMCHG, 0x16 ,  &NUMBER,  &Q.850, "Number changed")  &D( &REDIR, 0x17 ,  &NONE,  &Q.850, "Redirection to new destination")  &N( &CLIR_REJECTED,0x17 ,  &NONE,  &UNI4.0, "User rejects call with calling line identification restriction (CLIR)")  &D( &EXCHG_ERR, 0x19 ,  &NONE,  &Q.850, "Exchange routing error")  &D( &NOSEL_CLEAR, 0x1a ,  &NONE,  &Q.850, "Non-selected user clearing")  &D( &DST_OOO, 0x1b ,  &NONE,  &Q.850, "Destination out of order")  &D( &INV_ADDR, 0x1c ,  &NONE,  &Q.850, "Invalid number format (address incomplete)")  &D( &FAC_REJ, 0x1d ,  &FAC,  &Q.850, "Facility rejected")  &D( &STATUS, 0x1e ,  &NONE,  &Q.850, "Response to STATUS ENQUIRY")  &D( &UNSPEC, 0x1f ,  &NONE,  &Q.850, "Normal, unspecified")  &D( &TMY_PARTY, 0x20 ,  &NONE,  &Q.2971, "Too many pending add party requests")  &D( &NOCHAN, 0x22 ,  &CCBS,  &Q.850, "No circuit/channel available")  &N( &SOFT_NAVL, 0x22 ,  &NONE,  &PNNI1.0,"Requested called party soft PVPC or PVCC not available") &D( &VPCI_NAVL, 0x23 ,  &NONE,  &Q.2610, "Requested VPCI/VCI not available")  &D( &VPCI_FAIL, 0x24 ,  &NONE,  &Q.2610, "VPCI/VPI assignment failure")  &D( &CRATE_NAVL, 0x25 ,  &CRATE,  &Q.2610, "User cell rate not available")  &D( &NET_OOO, 0x26 ,  &NONE,  &Q.850, "Network out of order")  &D( &FRAME_OOS, 0x27 ,  &NONE,  &Q.850, "Permanent frame mode connection out of service")  &D( &FRAME_OP, 0x28 ,  &NONE,  &Q.850, "Permanent frame mode connection operational")  &D( &TEMP, 0x29 ,  &NONE,  &Q.850, "Temporary failure")  &D( &CONG, 0x2a ,  &NONE,  &Q.850, "Switching equipment congestion")  &D( &ACC_DISC, 0x2b ,  &IE,  &Q.850, "Access information discarded")  &D( &REQNOCHAN, 0x2c ,  &NONE,  &Q.850, "Requested circuit/channel not available")  &D( &NOVPCI, 0x2d ,  &NONE,  &Q.2610, "No VPCI/VCI available")  &D( &PREC_BLOCK, 0x2e ,  &NONE,  &Q.850, "Precedence call blocked")  &D( &RESRC_NAVL, 0x2f ,  &NONE,  &Q.850, "Resource unavailable, unspecified")  &D( &QOS_NAVL, 0x31 ,  &COND,  &Q.850, "Quality of service not available")  &D( &FAC_NOTSUB, 0x32 ,  &FAC,  &Q.850, "Requested facility not subscribed")  &D( &OUT_CUG, 0x35 ,  &NONE,  &Q.850, "Outgoing calls barred within CUG")  &N( &PGL_CHG, 0x35 ,  &NONE,  &PNNI1.0,"Call cleared due to change in PGL")  &D( &IN_CUG, 0x37 ,  &NONE,  &Q.850, "Incoming call barred within CUG")  &D( &BEARER_NAUTH, 0x39 ,  &ATTR,  &Q.850, "Bearer capability not authorized")  &D( &BEARER_NAVL, 0x3a ,  &ATTR,  &Q.850, "Bearer capability not presently available")  &D( &INCONS, 0x3e ,  &NONE,  &Q.850, "Inconsistency in designated outgoing access information and subscriber class")  &D( &OPT_NAVL, 0x3f ,  &NONE,  &Q.850, "Service or option not available, unspecified")  &D( &BEARER_NIMPL, 0x41 ,  &ATTR,  &Q.850, "Bearer capability not implemented")  &D( &CHANNEL_NIMPL,0x42 ,  &CHANNEL,  &Q.850, "Channel type not implemented")  &D( &FAC_NIMPL, 0x45 ,  &FAC,  &Q.850, "Requested facility not implemented")  &D( &RESTR_DIG, 0x46 ,  &NONE,  &Q.850, "Only restricted digital information bearer capability is available")  &D( &TRAFFIC_UNSUP,0x49 ,  &NONE,  &Q.2971, "Unsupported combination of traffic parameters")  &N( &AAL_UNSUP, 0x4c ,  &NONE,  &UNI3.1, "AAL parameters cannot be supported")  &D( &CREF_INV, 0x51 ,  &NONE,  &Q.850, "Invalid call reference value")  &D( &CHANNEL_NEX, 0x52 ,  &CHANID,  &Q.850, "Identified channel does not exist")  &D( &SUSPENDED, 0x53 ,  &NONE,  &Q.850, "A suspended call exists, but this call identity does not")  &D( &CID_INUSE, 0x54 ,  &NONE,  &Q.850, "Call identity in use")  &D( &NOTSUSP, 0x55 ,  &NONE,  &Q.850, "No call suspended")  &D( &CLEARED, 0x56 ,  &CAUSE,  &Q.850, "Call having requested call identity has been cleared")  &D( &NOT_MEMBER, 0x57 ,  &NONE,  &Q.850, "User not member of CUG")  &D( &INCOMP, 0x58 ,  &PARAM,  &Q.850, "Incompatible destination")  &D( &ENDP_INV, 0x59 ,  &IE,  &UNI3.1, "Invalid endpoint reference")  &D( &NEX_CUG, 0x5a ,  &NONE,  &Q.850, "Non-existend CUG")  &D( &TRANSIT_INV, 0x5b ,  &NONE,  &Q.850, "Invalid transit network selection")  &D( &AALNOTSUPP, 0x5d ,  &NONE,  &Q.2610, "AAL parameters cannot be supported")  &D( &INVMSG, 0x5f ,  &NONE,  &Q.850, "Invalid message, unspecified")  &D( &MANDAT, 0x60 ,  &IE,  &Q.850, "Mandatory information element is missing")  &D( &MTYPE_NIMPL, 0x61 ,  &MTYPE,  &Q.850, "Message type non-existent or not implemented")  &D( &MSG_NOTCOMP, 0x62 ,  &MTYPE,  &Q.850, "Message not compatible with call state or message type non-existent or not implemented")  &D( &IE_NIMPL, 0x63 ,  &IE,  &Q.850, "Information element/parameter non-existent or not implemented")  &D( &IE_INV, 0x64 ,  &IE,  &Q.850, "Invalid information element contents")  &D( &MSG_INCOMP, 0x65 ,  &MTYPE,  &Q.850, "Message not compatible with call state")  &D( &RECOVER, 0x66 ,  &TIMER,  &Q.850, "Recovery on timer expiry")  &D( &PARAM_NEX, 0x67 ,  &PARAM,  &Q.850, "Parameter non-existent or not implemented, passed on")  &N( &BAD_LENGTH, 0x68 ,  &NONE,  &UNI3.1, "Incorrect message length")  &D( &PARAM_UNREC, 0x6e ,  &PARAM,  &Q.850, "Message with unrecognized parameter, discarded")  &D( &PROTO, 0x6f ,  &NONE,  &Q.850, "Protocol error, unspecified")  &D( &INTERWORKING, 0x7f ,  &NONE,  &Q.850, "Interworking, unspecified");}' unless defined(&UNI_DECLARE_CAUSE_VALUES);
    eval 'sub D {
        my($NAME,$VAL,$DIAG,$STD,$STR) = @_;
	    eval q( &UNI_CAUSE_$NAME = $VAL,);
    }' unless defined(&D);
    eval 'sub N {
        my($NAME,$VAL,$DIAG,$STD,$STR) = @_;
	    eval q( &UNI_CAUSE_$NAME = $VAL,);
    }' unless defined(&N);
    eval("sub UNI_DECLARE_CAUSE_VALUES () { 0; }") unless defined(&UNI_DECLARE_CAUSE_VALUES);
    undef(&D) if defined(&D);
    undef(&N) if defined(&N);
    eval("sub UNI_CAUSE_CLASS_NORM () { 0x0; }") unless defined(&UNI_CAUSE_CLASS_NORM);
    eval("sub UNI_CAUSE_CLASS_NORM1 () { 0x1; }") unless defined(&UNI_CAUSE_CLASS_NORM1);
    eval("sub UNI_CAUSE_CLASS_RES () { 0x2; }") unless defined(&UNI_CAUSE_CLASS_RES);
    eval("sub UNI_CAUSE_CLASS_NAVL () { 0x3; }") unless defined(&UNI_CAUSE_CLASS_NAVL);
    eval("sub UNI_CAUSE_CLASS_NIMPL () { 0x4; }") unless defined(&UNI_CAUSE_CLASS_NIMPL);
    eval("sub UNI_CAUSE_CLASS_INV () { 0x5; }") unless defined(&UNI_CAUSE_CLASS_INV);
    eval("sub UNI_CAUSE_CLASS_PROTO () { 0x6; }") unless defined(&UNI_CAUSE_CLASS_PROTO);
    eval("sub UNI_CAUSE_CLASS_INTER () { 0x7; }") unless defined(&UNI_CAUSE_CLASS_INTER);
    eval("sub UNI_CAUSE_PU_PROVIDER () { 0; }") unless defined(&UNI_CAUSE_PU_PROVIDER);
    eval("sub UNI_CAUSE_PU_USER () { 1; }") unless defined(&UNI_CAUSE_PU_USER);
    eval("sub UNI_CAUSE_NA_NORMAL () { 0; }") unless defined(&UNI_CAUSE_NA_NORMAL);
    eval("sub UNI_CAUSE_NA_ABNORMAL () { 1; }") unless defined(&UNI_CAUSE_NA_ABNORMAL);
    eval("sub UNI_CAUSE_COND_UNKNOWN () { 0; }") unless defined(&UNI_CAUSE_COND_UNKNOWN);
    eval("sub UNI_CAUSE_COND_PERM () { 1; }") unless defined(&UNI_CAUSE_COND_PERM);
    eval("sub UNI_CAUSE_COND_TRANS () { 2; }") unless defined(&UNI_CAUSE_COND_TRANS);
    eval("sub UNI_CAUSE_REASON_USER () { 0x00; }") unless defined(&UNI_CAUSE_REASON_USER);
    eval("sub UNI_CAUSE_REASON_IEMISS () { 0x01; }") unless defined(&UNI_CAUSE_REASON_IEMISS);
    eval("sub UNI_CAUSE_REASON_IESUFF () { 0x02; }") unless defined(&UNI_CAUSE_REASON_IESUFF);
    eval("sub UNI_DIAG_NONE () { 0; }") unless defined(&UNI_DIAG_NONE);
    eval("sub UNI_DIAG_COND () { 1; }") unless defined(&UNI_DIAG_COND);
    eval("sub UNI_DIAG_TNS () { 2; }") unless defined(&UNI_DIAG_TNS);
    eval("sub UNI_DIAG_REJ () { 3; }") unless defined(&UNI_DIAG_REJ);
    eval("sub UNI_DIAG_NUMBER () { 4; }") unless defined(&UNI_DIAG_NUMBER);
    eval("sub UNI_DIAG_CRATE () { 5; }") unless defined(&UNI_DIAG_CRATE);
    eval("sub UNI_DIAG_ATTR () { 6; }") unless defined(&UNI_DIAG_ATTR);
    eval("sub UNI_DIAG_PARAM () { 7; }") unless defined(&UNI_DIAG_PARAM);
    eval("sub UNI_DIAG_TIMER () { 8; }") unless defined(&UNI_DIAG_TIMER);
    eval("sub UNI_DIAG_MTYPE () { 9; }") unless defined(&UNI_DIAG_MTYPE);
    eval("sub UNI_DIAG_IE () { 10; }") unless defined(&UNI_DIAG_IE);
    eval("sub UNI_DIAG_CHANID () { 11; }") unless defined(&UNI_DIAG_CHANID);
    eval("sub UNI_DIAG_CAUSE () { UNI_DIAG_NONE; }") unless defined(&UNI_DIAG_CAUSE);
    eval("sub UNI_DIAG_CHANNEL () { UNI_DIAG_NONE; }") unless defined(&UNI_DIAG_CHANNEL);
    eval("sub UNI_DIAG_CCBS () { UNI_DIAG_NONE; }") unless defined(&UNI_DIAG_CCBS);
    eval("sub UNI_DIAG_FAC () { UNI_DIAG_NONE; }") unless defined(&UNI_DIAG_FAC);
    eval("sub UNI_CAUSE_TRAFFIC_N () { 34-6; }") unless defined(&UNI_CAUSE_TRAFFIC_N);
    eval("sub UNI_CAUSE_IE_N () { 34-6; }") unless defined(&UNI_CAUSE_IE_N);
    eval("sub UNI_CAUSE_ATTR_N () { (34-6)/3; }") unless defined(&UNI_CAUSE_ATTR_N);
    eval 'sub UNI_CAUSE_COND_P () {0x1;}' unless defined(&UNI_CAUSE_COND_P);
    eval 'sub UNI_CAUSE_REJ_P () {0x2;}' unless defined(&UNI_CAUSE_REJ_P);
    eval 'sub UNI_CAUSE_REJ_USER_P () {0x4;}' unless defined(&UNI_CAUSE_REJ_USER_P);
    eval 'sub UNI_CAUSE_REJ_IE_P () {0x8;}' unless defined(&UNI_CAUSE_REJ_IE_P);
    eval 'sub UNI_CAUSE_IE_P () {0x10;}' unless defined(&UNI_CAUSE_IE_P);
    eval 'sub UNI_CAUSE_TRAFFIC_P () {0x20;}' unless defined(&UNI_CAUSE_TRAFFIC_P);
    eval 'sub UNI_CAUSE_VPCI_P () {0x40;}' unless defined(&UNI_CAUSE_VPCI_P);
    eval 'sub UNI_CAUSE_MTYPE_P () {0x80;}' unless defined(&UNI_CAUSE_MTYPE_P);
    eval 'sub UNI_CAUSE_TIMER_P () {0x100;}' unless defined(&UNI_CAUSE_TIMER_P);
    eval 'sub UNI_CAUSE_TNS_P () {0x200;}' unless defined(&UNI_CAUSE_TNS_P);
    eval 'sub UNI_CAUSE_NUMBER_P () {0x400;}' unless defined(&UNI_CAUSE_NUMBER_P);
    eval 'sub UNI_CAUSE_ATTR_P () {0x800;}' unless defined(&UNI_CAUSE_ATTR_P);
    eval 'sub UNI_CAUSE_PARAM_P () {0x1000;}' unless defined(&UNI_CAUSE_PARAM_P);
    eval("sub UNI_CONNID_VCI () { 0; }") unless defined(&UNI_CONNID_VCI);
    eval("sub UNI_CONNID_ANYVCI () { 1; }") unless defined(&UNI_CONNID_ANYVCI);
    eval("sub UNI_CONNID_NOVCI () { 4; }") unless defined(&UNI_CONNID_NOVCI);
    eval("sub UNI_CONNID_ASSOC () { 0; }") unless defined(&UNI_CONNID_ASSOC);
    eval("sub UNI_CONNID_NONASSOC () { 1; }") unless defined(&UNI_CONNID_NONASSOC);
    eval("sub UNI_EPSTATE_NULL () { 0x00; }") unless defined(&UNI_EPSTATE_NULL);
    eval("sub UNI_EPSTATE_ADD_INIT () { 0x01; }") unless defined(&UNI_EPSTATE_ADD_INIT);
    eval("sub UNI_EPSTATE_ALERT_DLVD () { 0x04; }") unless defined(&UNI_EPSTATE_ALERT_DLVD);
    eval("sub UNI_EPSTATE_ADD_RCVD () { 0x06; }") unless defined(&UNI_EPSTATE_ADD_RCVD);
    eval("sub UNI_EPSTATE_ALERT_RCVD () { 0x07; }") unless defined(&UNI_EPSTATE_ALERT_RCVD);
    eval("sub UNI_EPSTATE_ACTIVE () { 0x0a; }") unless defined(&UNI_EPSTATE_ACTIVE);
    eval("sub UNI_EPSTATE_DROP_INIT () { 0x0b; }") unless defined(&UNI_EPSTATE_DROP_INIT);
    eval("sub UNI_EPSTATE_DROP_RCVD () { 0x0c; }") unless defined(&UNI_EPSTATE_DROP_RCVD);
    eval("sub UNI_FACILITY_ROSE () { 0x11; }") unless defined(&UNI_FACILITY_ROSE);
    eval("sub UNI_FACILITY_MAXAPDU () { 128; }") unless defined(&UNI_FACILITY_MAXAPDU);
    eval("sub UNI_NOTIFY_MAXLEN () { 128; }") unless defined(&UNI_NOTIFY_MAXLEN);
    eval("sub UNI_QOS_CLASS0 () { 0x00; }") unless defined(&UNI_QOS_CLASS0);
    eval("sub UNI_QOS_CLASS1 () { 0x01; }") unless defined(&UNI_QOS_CLASS1);
    eval("sub UNI_QOS_CLASS2 () { 0x02; }") unless defined(&UNI_QOS_CLASS2);
    eval("sub UNI_QOS_CLASS3 () { 0x03; }") unless defined(&UNI_QOS_CLASS3);
    eval("sub UNI_QOS_CLASS4 () { 0x04; }") unless defined(&UNI_QOS_CLASS4);
    eval("sub UNI_REPEAT_PRIDESC () { 0x02; }") unless defined(&UNI_REPEAT_PRIDESC);
    eval("sub UNI_REPEAT_STACK () { 0x0a; }") unless defined(&UNI_REPEAT_STACK);
    eval("sub UNI_RESTART_CHANNEL () { 0x0; }") unless defined(&UNI_RESTART_CHANNEL);
    eval("sub UNI_RESTART_PATH () { 0x1; }") unless defined(&UNI_RESTART_PATH);
    eval("sub UNI_RESTART_ALL () { 0x2; }") unless defined(&UNI_RESTART_ALL);
    eval("sub UNI_TRAFFIC_FMDCR_ID () { 0x00; }") unless defined(&UNI_TRAFFIC_FMDCR_ID);
    eval("sub UNI_TRAFFIC_BMDCR_ID () { 0x02; }") unless defined(&UNI_TRAFFIC_BMDCR_ID);
    eval("sub UNI_TRAFFIC_FPCR0_ID () { 0x82; }") unless defined(&UNI_TRAFFIC_FPCR0_ID);
    eval("sub UNI_TRAFFIC_BPCR0_ID () { 0x83; }") unless defined(&UNI_TRAFFIC_BPCR0_ID);
    eval("sub UNI_TRAFFIC_FPCR1_ID () { 0x84; }") unless defined(&UNI_TRAFFIC_FPCR1_ID);
    eval("sub UNI_TRAFFIC_BPCR1_ID () { 0x85; }") unless defined(&UNI_TRAFFIC_BPCR1_ID);
    eval("sub UNI_TRAFFIC_FSCR0_ID () { 0x88; }") unless defined(&UNI_TRAFFIC_FSCR0_ID);
    eval("sub UNI_TRAFFIC_BSCR0_ID () { 0x89; }") unless defined(&UNI_TRAFFIC_BSCR0_ID);
    eval("sub UNI_TRAFFIC_FSCR1_ID () { 0x90; }") unless defined(&UNI_TRAFFIC_FSCR1_ID);
    eval("sub UNI_TRAFFIC_BSCR1_ID () { 0x91; }") unless defined(&UNI_TRAFFIC_BSCR1_ID);
    eval("sub UNI_TRAFFIC_FABR1_ID () { 0x92; }") unless defined(&UNI_TRAFFIC_FABR1_ID);
    eval("sub UNI_TRAFFIC_BABR1_ID () { 0x93; }") unless defined(&UNI_TRAFFIC_BABR1_ID);
    eval("sub UNI_TRAFFIC_FMBS0_ID () { 0xa0; }") unless defined(&UNI_TRAFFIC_FMBS0_ID);
    eval("sub UNI_TRAFFIC_BMBS0_ID () { 0xa1; }") unless defined(&UNI_TRAFFIC_BMBS0_ID);
    eval("sub UNI_TRAFFIC_FMBS1_ID () { 0xb0; }") unless defined(&UNI_TRAFFIC_FMBS1_ID);
    eval("sub UNI_TRAFFIC_BMBS1_ID () { 0xb1; }") unless defined(&UNI_TRAFFIC_BMBS1_ID);
    eval("sub UNI_TRAFFIC_BEST_ID () { 0xbe; }") unless defined(&UNI_TRAFFIC_BEST_ID);
    eval("sub UNI_TRAFFIC_MOPT_ID () { 0xbf; }") unless defined(&UNI_TRAFFIC_MOPT_ID);
    eval("sub UNI_TRAFFIC_FTAG () { 0x01; }") unless defined(&UNI_TRAFFIC_FTAG);
    eval("sub UNI_TRAFFIC_BTAG () { 0x02; }") unless defined(&UNI_TRAFFIC_BTAG);
    eval("sub UNI_TRAFFIC_FDISC () { 0x80; }") unless defined(&UNI_TRAFFIC_FDISC);
    eval("sub UNI_TRAFFIC_BDISC () { 0x40; }") unless defined(&UNI_TRAFFIC_BDISC);
    eval("sub UNI_MINTRAFFIC_FPCR0_ID () { 0x82; }") unless defined(&UNI_MINTRAFFIC_FPCR0_ID);
    eval("sub UNI_MINTRAFFIC_BPCR0_ID () { 0x83; }") unless defined(&UNI_MINTRAFFIC_BPCR0_ID);
    eval("sub UNI_MINTRAFFIC_FPCR1_ID () { 0x84; }") unless defined(&UNI_MINTRAFFIC_FPCR1_ID);
    eval("sub UNI_MINTRAFFIC_BPCR1_ID () { 0x85; }") unless defined(&UNI_MINTRAFFIC_BPCR1_ID);
    eval("sub UNI_MINTRAFFIC_FABR1_ID () { 0x92; }") unless defined(&UNI_MINTRAFFIC_FABR1_ID);
    eval("sub UNI_MINTRAFFIC_BABR1_ID () { 0x93; }") unless defined(&UNI_MINTRAFFIC_BABR1_ID);
    eval("sub UNI_MDCR_ORIGIN_USER () { 0x00; }") unless defined(&UNI_MDCR_ORIGIN_USER);
    eval("sub UNI_MDCR_ORIGIN_NET () { 0x01; }") unless defined(&UNI_MDCR_ORIGIN_NET);
    eval 'sub UNI_TRAFFIC_FPCR0_P () {0x1;}' unless defined(&UNI_TRAFFIC_FPCR0_P);
    eval 'sub UNI_TRAFFIC_BPCR0_P () {0x2;}' unless defined(&UNI_TRAFFIC_BPCR0_P);
    eval 'sub UNI_TRAFFIC_FPCR1_P () {0x4;}' unless defined(&UNI_TRAFFIC_FPCR1_P);
    eval 'sub UNI_TRAFFIC_BPCR1_P () {0x8;}' unless defined(&UNI_TRAFFIC_BPCR1_P);
    eval 'sub UNI_TRAFFIC_FSCR0_P () {0x10;}' unless defined(&UNI_TRAFFIC_FSCR0_P);
    eval 'sub UNI_TRAFFIC_BSCR0_P () {0x20;}' unless defined(&UNI_TRAFFIC_BSCR0_P);
    eval 'sub UNI_TRAFFIC_FSCR1_P () {0x40;}' unless defined(&UNI_TRAFFIC_FSCR1_P);
    eval 'sub UNI_TRAFFIC_BSCR1_P () {0x80;}' unless defined(&UNI_TRAFFIC_BSCR1_P);
    eval 'sub UNI_TRAFFIC_FMBS0_P () {0x100;}' unless defined(&UNI_TRAFFIC_FMBS0_P);
    eval 'sub UNI_TRAFFIC_BMBS0_P () {0x200;}' unless defined(&UNI_TRAFFIC_BMBS0_P);
    eval 'sub UNI_TRAFFIC_FMBS1_P () {0x400;}' unless defined(&UNI_TRAFFIC_FMBS1_P);
    eval 'sub UNI_TRAFFIC_BMBS1_P () {0x800;}' unless defined(&UNI_TRAFFIC_BMBS1_P);
    eval 'sub UNI_TRAFFIC_BEST_P () {0x1000;}' unless defined(&UNI_TRAFFIC_BEST_P);
    eval 'sub UNI_TRAFFIC_MOPT_P () {0x2000;}' unless defined(&UNI_TRAFFIC_MOPT_P);
    eval 'sub UNI_TRAFFIC_FABR1_P () {0x4000;}' unless defined(&UNI_TRAFFIC_FABR1_P);
    eval 'sub UNI_TRAFFIC_BABR1_P () {0x8000;}' unless defined(&UNI_TRAFFIC_BABR1_P);
    eval 'sub UNI_MINTRAFFIC_FPCR0_P () {0x1;}' unless defined(&UNI_MINTRAFFIC_FPCR0_P);
    eval 'sub UNI_MINTRAFFIC_BPCR0_P () {0x2;}' unless defined(&UNI_MINTRAFFIC_BPCR0_P);
    eval 'sub UNI_MINTRAFFIC_FPCR1_P () {0x4;}' unless defined(&UNI_MINTRAFFIC_FPCR1_P);
    eval 'sub UNI_MINTRAFFIC_BPCR1_P () {0x8;}' unless defined(&UNI_MINTRAFFIC_BPCR1_P);
    eval 'sub UNI_MINTRAFFIC_FABR1_P () {0x10;}' unless defined(&UNI_MINTRAFFIC_FABR1_P);
    eval 'sub UNI_MINTRAFFIC_BABR1_P () {0x20;}' unless defined(&UNI_MINTRAFFIC_BABR1_P);
    eval("sub UNI_GIT_STD_DSMCC () { 0x01; }") unless defined(&UNI_GIT_STD_DSMCC);
    eval("sub UNI_GIT_STD_H245 () { 0x02; }") unless defined(&UNI_GIT_STD_H245);
    eval("sub UNI_GIT_TYPE_SESS () { 0x01; }") unless defined(&UNI_GIT_TYPE_SESS);
    eval("sub UNI_GIT_TYPE_RES () { 0x02; }") unless defined(&UNI_GIT_TYPE_RES);
    eval("sub UNI_GIT_MAXSESS () { 20; }") unless defined(&UNI_GIT_MAXSESS);
    eval("sub UNI_GIT_MAXRES () { 4; }") unless defined(&UNI_GIT_MAXRES);
    eval("sub UNI_GIT_MAXVAL () { 20; }") unless defined(&UNI_GIT_MAXVAL);
    eval("sub UNI_GIT_MAXSUB () { 2; }") unless defined(&UNI_GIT_MAXSUB);
    eval("sub UNI_EETD_CTD_ID () { 0x01; }") unless defined(&UNI_EETD_CTD_ID);
    eval("sub UNI_EETD_MTD_ID () { 0x03; }") unless defined(&UNI_EETD_MTD_ID);
    eval("sub UNI_EETD_NET_ID () { 0x0a; }") unless defined(&UNI_EETD_NET_ID);
    eval("sub UNI_EETD_PMTD_ID () { 0x0b; }") unless defined(&UNI_EETD_PMTD_ID);
    eval("sub UNI_EETD_PCTD_ID () { 0x11; }") unless defined(&UNI_EETD_PCTD_ID);
    eval("sub UNI_EETD_ANYMAX () { 0xffff; }") unless defined(&UNI_EETD_ANYMAX);
    eval("sub UNI_EETD_MAXVAL () { 0xffff; }") unless defined(&UNI_EETD_MAXVAL);
    eval 'sub UNI_EETD_CUM_P () {0x1;}' unless defined(&UNI_EETD_CUM_P);
    eval 'sub UNI_EETD_MAX_P () {0x2;}' unless defined(&UNI_EETD_MAX_P);
    eval 'sub UNI_EETD_NET_P () {0x4;}' unless defined(&UNI_EETD_NET_P);
    eval 'sub UNI_EETD_PMTD_P () {0x8;}' unless defined(&UNI_EETD_PMTD_P);
    eval 'sub UNI_EETD_PCTD_P () {0x10;}' unless defined(&UNI_EETD_PCTD_P);
    eval("sub UNI_LIJ_IDTYPE_ROOT () { 0x0; }") unless defined(&UNI_LIJ_IDTYPE_ROOT);
    eval("sub UNI_LIJ_SCREEN_NETJOIN () { 0x0; }") unless defined(&UNI_LIJ_SCREEN_NETJOIN);
    eval("sub UNI_EXQOS_FACC_ID () { 0x94; }") unless defined(&UNI_EXQOS_FACC_ID);
    eval("sub UNI_EXQOS_BACC_ID () { 0x95; }") unless defined(&UNI_EXQOS_BACC_ID);
    eval("sub UNI_EXQOS_FCUM_ID () { 0x96; }") unless defined(&UNI_EXQOS_FCUM_ID);
    eval("sub UNI_EXQOS_BCUM_ID () { 0x97; }") unless defined(&UNI_EXQOS_BCUM_ID);
    eval("sub UNI_EXQOS_FCLR_ID () { 0xa2; }") unless defined(&UNI_EXQOS_FCLR_ID);
    eval("sub UNI_EXQOS_BCLR_ID () { 0xa3; }") unless defined(&UNI_EXQOS_BCLR_ID);
    eval("sub UNI_EXQOS_USER () { 0; }") unless defined(&UNI_EXQOS_USER);
    eval("sub UNI_EXQOS_NET () { 1; }") unless defined(&UNI_EXQOS_NET);
    eval("sub UNI_EXQOS_ANY_CDV () { 0xffffff; }") unless defined(&UNI_EXQOS_ANY_CDV);
    eval("sub UNI_EXQOS_ANY_CLR () { 0xff; }") unless defined(&UNI_EXQOS_ANY_CLR);
    eval 'sub UNI_EXQOS_FACC_P () {0x1;}' unless defined(&UNI_EXQOS_FACC_P);
    eval 'sub UNI_EXQOS_BACC_P () {0x2;}' unless defined(&UNI_EXQOS_BACC_P);
    eval 'sub UNI_EXQOS_FCUM_P () {0x4;}' unless defined(&UNI_EXQOS_FCUM_P);
    eval 'sub UNI_EXQOS_BCUM_P () {0x8;}' unless defined(&UNI_EXQOS_BCUM_P);
    eval 'sub UNI_EXQOS_FCLR_P () {0x10;}' unless defined(&UNI_EXQOS_FCLR_P);
    eval 'sub UNI_EXQOS_BCLR_P () {0x20;}' unless defined(&UNI_EXQOS_BCLR_P);
    eval("sub UNI_ABRADD_FADD_ID () { 0xc2; }") unless defined(&UNI_ABRADD_FADD_ID);
    eval("sub UNI_ABRADD_BADD_ID () { 0xc3; }") unless defined(&UNI_ABRADD_BADD_ID);
    eval("sub UNI_ABRSETUP_FICR_ID () { 0xc2; }") unless defined(&UNI_ABRSETUP_FICR_ID);
    eval("sub UNI_ABRSETUP_BICR_ID () { 0xc3; }") unless defined(&UNI_ABRSETUP_BICR_ID);
    eval("sub UNI_ABRSETUP_FTBE_ID () { 0xc4; }") unless defined(&UNI_ABRSETUP_FTBE_ID);
    eval("sub UNI_ABRSETUP_BTBE_ID () { 0xc5; }") unless defined(&UNI_ABRSETUP_BTBE_ID);
    eval("sub UNI_ABRSETUP_RMFRT_ID () { 0xc6; }") unless defined(&UNI_ABRSETUP_RMFRT_ID);
    eval("sub UNI_ABRSETUP_FRIF_ID () { 0xc8; }") unless defined(&UNI_ABRSETUP_FRIF_ID);
    eval("sub UNI_ABRSETUP_BRIF_ID () { 0xc9; }") unless defined(&UNI_ABRSETUP_BRIF_ID);
    eval("sub UNI_ABRSETUP_FRDF_ID () { 0xca; }") unless defined(&UNI_ABRSETUP_FRDF_ID);
    eval("sub UNI_ABRSETUP_BRDF_ID () { 0xcb; }") unless defined(&UNI_ABRSETUP_BRDF_ID);
    eval 'sub UNI_ABR_REC_NRM_P () {0x80000000;}' unless defined(&UNI_ABR_REC_NRM_P);
    eval 'sub UNI_ABR_REC_TRM_P () {0x40000000;}' unless defined(&UNI_ABR_REC_TRM_P);
    eval 'sub UNI_ABR_REC_CDF_P () {0x20000000;}' unless defined(&UNI_ABR_REC_CDF_P);
    eval 'sub UNI_ABR_REC_ADTF_P () {0x10000000;}' unless defined(&UNI_ABR_REC_ADTF_P);
    eval 'sub UNI_ABRSETUP_FICR_P () {0x1;}' unless defined(&UNI_ABRSETUP_FICR_P);
    eval 'sub UNI_ABRSETUP_BICR_P () {0x2;}' unless defined(&UNI_ABRSETUP_BICR_P);
    eval 'sub UNI_ABRSETUP_FTBE_P () {0x4;}' unless defined(&UNI_ABRSETUP_FTBE_P);
    eval 'sub UNI_ABRSETUP_BTBE_P () {0x8;}' unless defined(&UNI_ABRSETUP_BTBE_P);
    eval 'sub UNI_ABRSETUP_FRIF_P () {0x10;}' unless defined(&UNI_ABRSETUP_FRIF_P);
    eval 'sub UNI_ABRSETUP_BRIF_P () {0x20;}' unless defined(&UNI_ABRSETUP_BRIF_P);
    eval 'sub UNI_ABRSETUP_FRDF_P () {0x40;}' unless defined(&UNI_ABRSETUP_FRDF_P);
    eval 'sub UNI_ABRSETUP_BRDF_P () {0x80;}' unless defined(&UNI_ABRSETUP_BRDF_P);
    eval 'sub UNI_ABRSETUP_RMFRT_P () {0x100;}' unless defined(&UNI_ABRSETUP_RMFRT_P);
    eval("sub UNI_CSCOPE_ORG () { 0x01; }") unless defined(&UNI_CSCOPE_ORG);
    eval("sub UNI_CSCOPE_ORG_LOC () { 0x01; }") unless defined(&UNI_CSCOPE_ORG_LOC);
    eval("sub UNI_CSCOPE_ORG_LOC_P1 () { 0x02; }") unless defined(&UNI_CSCOPE_ORG_LOC_P1);
    eval("sub UNI_CSCOPE_ORG_LOC_P2 () { 0x03; }") unless defined(&UNI_CSCOPE_ORG_LOC_P2);
    eval("sub UNI_CSCOPE_ORG_SITE_M1 () { 0x04; }") unless defined(&UNI_CSCOPE_ORG_SITE_M1);
    eval("sub UNI_CSCOPE_ORG_SITE () { 0x05; }") unless defined(&UNI_CSCOPE_ORG_SITE);
    eval("sub UNI_CSCOPE_ORG_SITE_P1 () { 0x06; }") unless defined(&UNI_CSCOPE_ORG_SITE_P1);
    eval("sub UNI_CSCOPE_ORG_ORG_M1 () { 0x07; }") unless defined(&UNI_CSCOPE_ORG_ORG_M1);
    eval("sub UNI_CSCOPE_ORG_ORG () { 0x08; }") unless defined(&UNI_CSCOPE_ORG_ORG);
    eval("sub UNI_CSCOPE_ORG_ORG_P1 () { 0x09; }") unless defined(&UNI_CSCOPE_ORG_ORG_P1);
    eval("sub UNI_CSCOPE_ORG_COMM_M1 () { 0x0a; }") unless defined(&UNI_CSCOPE_ORG_COMM_M1);
    eval("sub UNI_CSCOPE_ORG_COMM () { 0x0b; }") unless defined(&UNI_CSCOPE_ORG_COMM);
    eval("sub UNI_CSCOPE_ORG_COMM_P1 () { 0x0c; }") unless defined(&UNI_CSCOPE_ORG_COMM_P1);
    eval("sub UNI_CSCOPE_ORG_REG () { 0x0d; }") unless defined(&UNI_CSCOPE_ORG_REG);
    eval("sub UNI_CSCOPE_ORG_INTER () { 0x0e; }") unless defined(&UNI_CSCOPE_ORG_INTER);
    eval("sub UNI_CSCOPE_ORG_GLOBAL () { 0x0f; }") unless defined(&UNI_CSCOPE_ORG_GLOBAL);
    eval("sub UNI_REPORT_MODCONF () { 0x01; }") unless defined(&UNI_REPORT_MODCONF);
    eval("sub UNI_REPORT_CLOCK () { 0x02; }") unless defined(&UNI_REPORT_CLOCK);
    eval("sub UNI_REPORT_EEAVAIL () { 0x04; }") unless defined(&UNI_REPORT_EEAVAIL);
    eval("sub UNI_REPORT_EEREQ () { 0x05; }") unless defined(&UNI_REPORT_EEREQ);
    eval("sub UNI_REPORT_EECOMPL () { 0x06; }") unless defined(&UNI_REPORT_EECOMPL);
    eval("sub UNI_DTL_LOGNP () { 0x01; }") unless defined(&UNI_DTL_LOGNP);
    eval("sub UNI_DTL_LOGNP_SIZE () { 27; }") unless defined(&UNI_DTL_LOGNP_SIZE);
    eval("sub UNI_CRANKBACK_IF () { 0x02; }") unless defined(&UNI_CRANKBACK_IF);
    eval("sub UNI_CRANKBACK_NODE () { 0x03; }") unless defined(&UNI_CRANKBACK_NODE);
    eval("sub UNI_CRANKBACK_LINK () { 0x04; }") unless defined(&UNI_CRANKBACK_LINK);
    eval("sub UNI_CAUSE_NXNODE_UNREACH () { 128; }") unless defined(&UNI_CAUSE_NXNODE_UNREACH);
    eval("sub UNI_CAUSE_DTL_NOT_MY_ID () { 160; }") unless defined(&UNI_CAUSE_DTL_NOT_MY_ID);
    eval 'sub UNI_CRANKBACK_TOP_P () {0x1;}' unless defined(&UNI_CRANKBACK_TOP_P);
    eval 'sub UNI_CRANKBACK_TOPX_P () {0x2;}' unless defined(&UNI_CRANKBACK_TOPX_P);
    eval 'sub UNI_CRANKBACK_QOS_P () {0x4;}' unless defined(&UNI_CRANKBACK_QOS_P);
    eval("sub UNI_SOFT_SEL_ANY () { 0x00; }") unless defined(&UNI_SOFT_SEL_ANY);
    eval("sub UNI_SOFT_SEL_REQ () { 0x02; }") unless defined(&UNI_SOFT_SEL_REQ);
    eval("sub UNI_SOFT_SEL_ASS () { 0x04; }") unless defined(&UNI_SOFT_SEL_ASS);
    eval 'sub UNI_CALLING_SOFT_VCI_P () {0x1;}' unless defined(&UNI_CALLING_SOFT_VCI_P);
    eval 'sub UNI_CALLED_SOFT_VPI_P () {0x1;}' unless defined(&UNI_CALLED_SOFT_VPI_P);
    eval 'sub UNI_CALLED_SOFT_VCI_P () {0x2;}' unless defined(&UNI_CALLED_SOFT_VCI_P);
    require 'netnatm/msg/uni_ie.ph';
    require 'netnatm/msg/uni_msg.ph';
}
1;
