require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETNATM_UNIMSG_H_)) {
    eval 'sub _NETNATM_UNIMSG_H_ () {1;}' unless defined(&_NETNATM_UNIMSG_H_);
    require 'sys/types.ph';
    if(defined(&_KERNEL)) {
	if(defined(&__FreeBSD__)) {
	    require 'sys/systm.ph';
	}
	require 'sys/stdint.ph';
    } else {
	require 'string.ph';
	require 'stdint.ph';
    }
    eval 'sub uni_msg_len {
        my($M) = @_;
	    eval q(((($M)-> &b_wptr - ($M)-> &b_rptr)));
    }' unless defined(&uni_msg_len);
    eval 'sub uni_msg_space {
        my($M) = @_;
	    eval q(((($M)-> &b_lim - ($M)-> &b_wptr)));
    }' unless defined(&uni_msg_space);
    eval 'sub uni_msg_leading {
        my($M) = @_;
	    eval q(((($M)-> &b_rptr - ($M)-> &b_buf)));
    }' unless defined(&uni_msg_leading);
    eval 'sub uni_msg_size {
        my($M) = @_;
	    eval q(((($M)-> &b_lim - ($M)-> &b_buf)););
    }' unless defined(&uni_msg_size);
    eval 'sub uni_msg_ensure {
        my($M, $S) = @_;
	    eval q((( &uni_msg_space($M) >= ($S)) ? 0:  &uni_msg_extend($M, $S)));
    }' unless defined(&uni_msg_ensure);
    eval 'sub uni_msg_rptr {
        my($MSG, $TYPE) = @_;
	    eval q((($TYPE)( &void *)($MSG)-> &b_rptr));
    }' unless defined(&uni_msg_rptr);
    eval 'sub uni_msg_wptr {
        my($MSG, $TYPE) = @_;
	    eval q((($TYPE)( &void *)($MSG)-> &b_wptr));
    }' unless defined(&uni_msg_wptr);
    unless(defined(&_KERNEL)) {
    }
}
1;
