require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NET_PF_H_)) {
    eval 'sub _NET_PF_H_ () {1;}' unless defined(&_NET_PF_H_);
    eval 'sub PF_TCPS_PROXY_SRC () {(( &TCP_NSTATES)+0);}' unless defined(&PF_TCPS_PROXY_SRC);
    eval 'sub PF_TCPS_PROXY_DST () {(( &TCP_NSTATES)+1);}' unless defined(&PF_TCPS_PROXY_DST);
    eval 'sub PF_MD5_DIGEST_LENGTH () {16;}' unless defined(&PF_MD5_DIGEST_LENGTH);
    if(defined(&MD5_DIGEST_LENGTH)) {
	if((defined(&PF_MD5_DIGEST_LENGTH) ? &PF_MD5_DIGEST_LENGTH : undef) != (defined(&MD5_DIGEST_LENGTH) ? &MD5_DIGEST_LENGTH : undef)) {
	}
    }
    eval("sub PF_INOUT () { 0; }") unless defined(&PF_INOUT);
    eval("sub PF_IN () { 1; }") unless defined(&PF_IN);
    eval("sub PF_OUT () { 2; }") unless defined(&PF_OUT);
    eval("sub PF_PASS () { 0; }") unless defined(&PF_PASS);
    eval("sub PF_DROP () { 1; }") unless defined(&PF_DROP);
    eval("sub PF_SCRUB () { 2; }") unless defined(&PF_SCRUB);
    eval("sub PF_NOSCRUB () { 3; }") unless defined(&PF_NOSCRUB);
    eval("sub PF_NAT () { 4; }") unless defined(&PF_NAT);
    eval("sub PF_NONAT () { 5; }") unless defined(&PF_NONAT);
    eval("sub PF_BINAT () { 6; }") unless defined(&PF_BINAT);
    eval("sub PF_NOBINAT () { 7; }") unless defined(&PF_NOBINAT);
    eval("sub PF_RDR () { 8; }") unless defined(&PF_RDR);
    eval("sub PF_NORDR () { 9; }") unless defined(&PF_NORDR);
    eval("sub PF_SYNPROXY_DROP () { 10; }") unless defined(&PF_SYNPROXY_DROP);
    eval("sub PF_DEFER () { 11; }") unless defined(&PF_DEFER);
    eval("sub PF_RULESET_SCRUB () { 0; }") unless defined(&PF_RULESET_SCRUB);
    eval("sub PF_RULESET_FILTER () { 1; }") unless defined(&PF_RULESET_FILTER);
    eval("sub PF_RULESET_NAT () { 2; }") unless defined(&PF_RULESET_NAT);
    eval("sub PF_RULESET_BINAT () { 3; }") unless defined(&PF_RULESET_BINAT);
    eval("sub PF_RULESET_RDR () { 4; }") unless defined(&PF_RULESET_RDR);
    eval("sub PF_RULESET_MAX () { 5; }") unless defined(&PF_RULESET_MAX);
    eval("sub PF_OP_NONE () { 0; }") unless defined(&PF_OP_NONE);
    eval("sub PF_OP_IRG () { 1; }") unless defined(&PF_OP_IRG);
    eval("sub PF_OP_EQ () { 2; }") unless defined(&PF_OP_EQ);
    eval("sub PF_OP_NE () { 3; }") unless defined(&PF_OP_NE);
    eval("sub PF_OP_LT () { 4; }") unless defined(&PF_OP_LT);
    eval("sub PF_OP_LE () { 5; }") unless defined(&PF_OP_LE);
    eval("sub PF_OP_GT () { 6; }") unless defined(&PF_OP_GT);
    eval("sub PF_OP_GE () { 7; }") unless defined(&PF_OP_GE);
    eval("sub PF_OP_XRG () { 8; }") unless defined(&PF_OP_XRG);
    eval("sub PF_OP_RRG () { 9; }") unless defined(&PF_OP_RRG);
    eval("sub PF_DEBUG_NONE () { 0; }") unless defined(&PF_DEBUG_NONE);
    eval("sub PF_DEBUG_URGENT () { 1; }") unless defined(&PF_DEBUG_URGENT);
    eval("sub PF_DEBUG_MISC () { 2; }") unless defined(&PF_DEBUG_MISC);
    eval("sub PF_DEBUG_NOISY () { 3; }") unless defined(&PF_DEBUG_NOISY);
    eval("sub PF_CHANGE_NONE () { 0; }") unless defined(&PF_CHANGE_NONE);
    eval("sub PF_CHANGE_ADD_HEAD () { 1; }") unless defined(&PF_CHANGE_ADD_HEAD);
    eval("sub PF_CHANGE_ADD_TAIL () { 2; }") unless defined(&PF_CHANGE_ADD_TAIL);
    eval("sub PF_CHANGE_ADD_BEFORE () { 3; }") unless defined(&PF_CHANGE_ADD_BEFORE);
    eval("sub PF_CHANGE_ADD_AFTER () { 4; }") unless defined(&PF_CHANGE_ADD_AFTER);
    eval("sub PF_CHANGE_REMOVE () { 5; }") unless defined(&PF_CHANGE_REMOVE);
    eval("sub PF_CHANGE_GET_TICKET () { 6; }") unless defined(&PF_CHANGE_GET_TICKET);
    eval("sub PF_GET_NONE () { 0; }") unless defined(&PF_GET_NONE);
    eval("sub PF_GET_CLR_CNTR () { 1; }") unless defined(&PF_GET_CLR_CNTR);
    eval("sub PF_SK_WIRE () { 0; }") unless defined(&PF_SK_WIRE);
    eval("sub PF_SK_STACK () { 1; }") unless defined(&PF_SK_STACK);
    eval("sub PF_SK_BOTH () { 2; }") unless defined(&PF_SK_BOTH);
    eval("sub PFTM_TCP_FIRST_PACKET () { 0; }") unless defined(&PFTM_TCP_FIRST_PACKET);
    eval("sub PFTM_TCP_OPENING () { 1; }") unless defined(&PFTM_TCP_OPENING);
    eval("sub PFTM_TCP_ESTABLISHED () { 2; }") unless defined(&PFTM_TCP_ESTABLISHED);
    eval("sub PFTM_TCP_CLOSING () { 3; }") unless defined(&PFTM_TCP_CLOSING);
    eval("sub PFTM_TCP_FIN_WAIT () { 4; }") unless defined(&PFTM_TCP_FIN_WAIT);
    eval("sub PFTM_TCP_CLOSED () { 5; }") unless defined(&PFTM_TCP_CLOSED);
    eval("sub PFTM_UDP_FIRST_PACKET () { 6; }") unless defined(&PFTM_UDP_FIRST_PACKET);
    eval("sub PFTM_UDP_SINGLE () { 7; }") unless defined(&PFTM_UDP_SINGLE);
    eval("sub PFTM_UDP_MULTIPLE () { 8; }") unless defined(&PFTM_UDP_MULTIPLE);
    eval("sub PFTM_ICMP_FIRST_PACKET () { 9; }") unless defined(&PFTM_ICMP_FIRST_PACKET);
    eval("sub PFTM_ICMP_ERROR_REPLY () { 10; }") unless defined(&PFTM_ICMP_ERROR_REPLY);
    eval("sub PFTM_OTHER_FIRST_PACKET () { 11; }") unless defined(&PFTM_OTHER_FIRST_PACKET);
    eval("sub PFTM_OTHER_SINGLE () { 12; }") unless defined(&PFTM_OTHER_SINGLE);
    eval("sub PFTM_OTHER_MULTIPLE () { 13; }") unless defined(&PFTM_OTHER_MULTIPLE);
    eval("sub PFTM_FRAG () { 14; }") unless defined(&PFTM_FRAG);
    eval("sub PFTM_INTERVAL () { 15; }") unless defined(&PFTM_INTERVAL);
    eval("sub PFTM_ADAPTIVE_START () { 16; }") unless defined(&PFTM_ADAPTIVE_START);
    eval("sub PFTM_ADAPTIVE_END () { 17; }") unless defined(&PFTM_ADAPTIVE_END);
    eval("sub PFTM_SRC_NODE () { 18; }") unless defined(&PFTM_SRC_NODE);
    eval("sub PFTM_TS_DIFF () { 19; }") unless defined(&PFTM_TS_DIFF);
    eval("sub PFTM_MAX () { 20; }") unless defined(&PFTM_MAX);
    eval("sub PFTM_PURGE () { 21; }") unless defined(&PFTM_PURGE);
    eval("sub PFTM_UNLINKED () { 22; }") unless defined(&PFTM_UNLINKED);
    eval 'sub PFTM_TCP_FIRST_PACKET_VAL () {120;}' unless defined(&PFTM_TCP_FIRST_PACKET_VAL);
    eval 'sub PFTM_TCP_OPENING_VAL () {30;}' unless defined(&PFTM_TCP_OPENING_VAL);
    eval 'sub PFTM_TCP_ESTABLISHED_VAL () {24*60*60;}' unless defined(&PFTM_TCP_ESTABLISHED_VAL);
    eval 'sub PFTM_TCP_CLOSING_VAL () {15* 60;}' unless defined(&PFTM_TCP_CLOSING_VAL);
    eval 'sub PFTM_TCP_FIN_WAIT_VAL () {45;}' unless defined(&PFTM_TCP_FIN_WAIT_VAL);
    eval 'sub PFTM_TCP_CLOSED_VAL () {90;}' unless defined(&PFTM_TCP_CLOSED_VAL);
    eval 'sub PFTM_UDP_FIRST_PACKET_VAL () {60;}' unless defined(&PFTM_UDP_FIRST_PACKET_VAL);
    eval 'sub PFTM_UDP_SINGLE_VAL () {30;}' unless defined(&PFTM_UDP_SINGLE_VAL);
    eval 'sub PFTM_UDP_MULTIPLE_VAL () {60;}' unless defined(&PFTM_UDP_MULTIPLE_VAL);
    eval 'sub PFTM_ICMP_FIRST_PACKET_VAL () {20;}' unless defined(&PFTM_ICMP_FIRST_PACKET_VAL);
    eval 'sub PFTM_ICMP_ERROR_REPLY_VAL () {10;}' unless defined(&PFTM_ICMP_ERROR_REPLY_VAL);
    eval 'sub PFTM_OTHER_FIRST_PACKET_VAL () {60;}' unless defined(&PFTM_OTHER_FIRST_PACKET_VAL);
    eval 'sub PFTM_OTHER_SINGLE_VAL () {30;}' unless defined(&PFTM_OTHER_SINGLE_VAL);
    eval 'sub PFTM_OTHER_MULTIPLE_VAL () {60;}' unless defined(&PFTM_OTHER_MULTIPLE_VAL);
    eval 'sub PFTM_FRAG_VAL () {30;}' unless defined(&PFTM_FRAG_VAL);
    eval 'sub PFTM_INTERVAL_VAL () {10;}' unless defined(&PFTM_INTERVAL_VAL);
    eval 'sub PFTM_SRC_NODE_VAL () {0;}' unless defined(&PFTM_SRC_NODE_VAL);
    eval 'sub PFTM_TS_DIFF_VAL () {30;}' unless defined(&PFTM_TS_DIFF_VAL);
    eval("sub PF_NOPFROUTE () { 0; }") unless defined(&PF_NOPFROUTE);
    eval("sub PF_FASTROUTE () { 1; }") unless defined(&PF_FASTROUTE);
    eval("sub PF_ROUTETO () { 2; }") unless defined(&PF_ROUTETO);
    eval("sub PF_DUPTO () { 3; }") unless defined(&PF_DUPTO);
    eval("sub PF_REPLYTO () { 4; }") unless defined(&PF_REPLYTO);
    eval("sub PF_LIMIT_STATES () { 0; }") unless defined(&PF_LIMIT_STATES);
    eval("sub PF_LIMIT_SRC_NODES () { 1; }") unless defined(&PF_LIMIT_SRC_NODES);
    eval("sub PF_LIMIT_FRAGS () { 2; }") unless defined(&PF_LIMIT_FRAGS);
    eval("sub PF_LIMIT_TABLE_ENTRIES () { 3; }") unless defined(&PF_LIMIT_TABLE_ENTRIES);
    eval("sub PF_LIMIT_MAX () { 4; }") unless defined(&PF_LIMIT_MAX);
    eval 'sub PF_POOL_IDMASK () {0xf;}' unless defined(&PF_POOL_IDMASK);
    eval("sub PF_POOL_NONE () { 0; }") unless defined(&PF_POOL_NONE);
    eval("sub PF_POOL_BITMASK () { 1; }") unless defined(&PF_POOL_BITMASK);
    eval("sub PF_POOL_RANDOM () { 2; }") unless defined(&PF_POOL_RANDOM);
    eval("sub PF_POOL_SRCHASH () { 3; }") unless defined(&PF_POOL_SRCHASH);
    eval("sub PF_POOL_ROUNDROBIN () { 4; }") unless defined(&PF_POOL_ROUNDROBIN);
    eval("sub PF_ADDR_ADDRMASK () { 0; }") unless defined(&PF_ADDR_ADDRMASK);
    eval("sub PF_ADDR_NOROUTE () { 1; }") unless defined(&PF_ADDR_NOROUTE);
    eval("sub PF_ADDR_DYNIFTL () { 2; }") unless defined(&PF_ADDR_DYNIFTL);
    eval("sub PF_ADDR_TABLE () { 3; }") unless defined(&PF_ADDR_TABLE);
    eval("sub PF_ADDR_URPFFAILED () { 4; }") unless defined(&PF_ADDR_URPFFAILED);
    eval("sub PF_ADDR_RANGE () { 5; }") unless defined(&PF_ADDR_RANGE);
    eval 'sub PF_POOL_TYPEMASK () {0xf;}' unless defined(&PF_POOL_TYPEMASK);
    eval 'sub PF_POOL_STICKYADDR () {0x20;}' unless defined(&PF_POOL_STICKYADDR);
    eval 'sub PF_WSCALE_FLAG () {0x80;}' unless defined(&PF_WSCALE_FLAG);
    eval 'sub PF_WSCALE_MASK () {0xf;}' unless defined(&PF_WSCALE_MASK);
    eval 'sub PF_LOG () {0x1;}' unless defined(&PF_LOG);
    eval 'sub PF_LOG_ALL () {0x2;}' unless defined(&PF_LOG_ALL);
    eval 'sub PF_LOG_SOCKET_LOOKUP () {0x4;}' unless defined(&PF_LOG_SOCKET_LOOKUP);
    eval 'sub PFRES_MATCH () {0;}' unless defined(&PFRES_MATCH);
    eval 'sub PFRES_BADOFF () {1;}' unless defined(&PFRES_BADOFF);
    eval 'sub PFRES_FRAG () {2;}' unless defined(&PFRES_FRAG);
    eval 'sub PFRES_SHORT () {3;}' unless defined(&PFRES_SHORT);
    eval 'sub PFRES_NORM () {4;}' unless defined(&PFRES_NORM);
    eval 'sub PFRES_MEMORY () {5;}' unless defined(&PFRES_MEMORY);
    eval 'sub PFRES_TS () {6;}' unless defined(&PFRES_TS);
    eval 'sub PFRES_CONGEST () {7;}' unless defined(&PFRES_CONGEST);
    eval 'sub PFRES_IPOPTIONS () {8;}' unless defined(&PFRES_IPOPTIONS);
    eval 'sub PFRES_PROTCKSUM () {9;}' unless defined(&PFRES_PROTCKSUM);
    eval 'sub PFRES_BADSTATE () {10;}' unless defined(&PFRES_BADSTATE);
    eval 'sub PFRES_STATEINS () {11;}' unless defined(&PFRES_STATEINS);
    eval 'sub PFRES_MAXSTATES () {12;}' unless defined(&PFRES_MAXSTATES);
    eval 'sub PFRES_SRCLIMIT () {13;}' unless defined(&PFRES_SRCLIMIT);
    eval 'sub PFRES_SYNPROXY () {14;}' unless defined(&PFRES_SYNPROXY);
    eval 'sub PFRES_MAPFAILED () {15;}' unless defined(&PFRES_MAPFAILED);
    eval 'sub PFRES_MAX () {16;}' unless defined(&PFRES_MAX);
    eval 'sub PFRES_NAMES () {{ "match", "bad-offset", "fragment", "short", "normalize", "memory", "bad-timestamp", "congestion", "ip-option", "proto-cksum", "state-mismatch", "state-insert", "state-limit", "src-limit", "synproxy", "map-failed",  &NULL };}' unless defined(&PFRES_NAMES);
    eval 'sub LCNT_STATES () {0;}' unless defined(&LCNT_STATES);
    eval 'sub LCNT_SRCSTATES () {1;}' unless defined(&LCNT_SRCSTATES);
    eval 'sub LCNT_SRCNODES () {2;}' unless defined(&LCNT_SRCNODES);
    eval 'sub LCNT_SRCCONN () {3;}' unless defined(&LCNT_SRCCONN);
    eval 'sub LCNT_SRCCONNRATE () {4;}' unless defined(&LCNT_SRCCONNRATE);
    eval 'sub LCNT_OVERLOAD_TABLE () {5;}' unless defined(&LCNT_OVERLOAD_TABLE);
    eval 'sub LCNT_OVERLOAD_FLUSH () {6;}' unless defined(&LCNT_OVERLOAD_FLUSH);
    eval 'sub LCNT_MAX () {7;}' unless defined(&LCNT_MAX);
    eval 'sub LCNT_NAMES () {{ "max states per rule", "max-src-states", "max-src-nodes", "max-src-conn", "max-src-conn-rate", "overload table insertion", "overload flush states",  &NULL };}' unless defined(&LCNT_NAMES);
    eval 'sub FCNT_STATE_SEARCH () {0;}' unless defined(&FCNT_STATE_SEARCH);
    eval 'sub FCNT_STATE_INSERT () {1;}' unless defined(&FCNT_STATE_INSERT);
    eval 'sub FCNT_STATE_REMOVALS () {2;}' unless defined(&FCNT_STATE_REMOVALS);
    eval 'sub FCNT_MAX () {3;}' unless defined(&FCNT_MAX);
    eval 'sub SCNT_SRC_NODE_SEARCH () {0;}' unless defined(&SCNT_SRC_NODE_SEARCH);
    eval 'sub SCNT_SRC_NODE_INSERT () {1;}' unless defined(&SCNT_SRC_NODE_INSERT);
    eval 'sub SCNT_SRC_NODE_REMOVALS () {2;}' unless defined(&SCNT_SRC_NODE_REMOVALS);
    eval 'sub SCNT_MAX () {3;}' unless defined(&SCNT_MAX);
    eval 'sub PF_TABLE_NAME_SIZE () {32;}' unless defined(&PF_TABLE_NAME_SIZE);
    eval 'sub PF_QNAME_SIZE () {64;}' unless defined(&PF_QNAME_SIZE);
}
1;
