require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NETSMB_SMB_SUBR_H_)) {
    eval 'sub _NETSMB_SMB_SUBR_H_ () {1;}' unless defined(&_NETSMB_SMB_SUBR_H_);
    unless(defined(&_KERNEL)) {
	die("This file shouldn't be included from userland programs");
    }
    if(defined(&MALLOC_DECLARE)) {
    }
    eval 'sub SMBERROR () {( &format,  &args...)  &printf("%s: " &format,  &__func__ ,  &args);}' unless defined(&SMBERROR);
    eval 'sub SMBPANIC () {( &format,  &args...)  &printf("%s: " &format,  &__func__ ,  &args);}' unless defined(&SMBPANIC);
    if(defined(&SMB_SOCKET_DEBUG)) {
	eval 'sub SMBSDEBUG () {( &format,  &args...)  &printf("%s: " &format,  &__func__ ,  &args);}' unless defined(&SMBSDEBUG);
    } else {
	eval 'sub SMBSDEBUG () {( &format,  &args...);}' unless defined(&SMBSDEBUG);
    }
    if(defined(&SMB_IOD_DEBUG)) {
	eval 'sub SMBIODEBUG () {( &format,  &args...)  &printf("%s: " &format,  &__func__ ,  &args);}' unless defined(&SMBIODEBUG);
    } else {
	eval 'sub SMBIODEBUG () {( &format,  &args...);}' unless defined(&SMBIODEBUG);
    }
    if(defined(&SMB_SOCKETDATA_DEBUG)) {
    } else {
	eval 'sub m_dumpm {
	    my($m) = @_;
    	    eval q();
	}' unless defined(&m_dumpm);
    }
    eval 'sub SMB_SIGMASK {
        my($set) = @_;
	    eval q(( &SIGISMEMBER($set,  &SIGINT) ||  &SIGISMEMBER($set,  &SIGTERM) ||  &SIGISMEMBER($set,  &SIGHUP) ||  &SIGISMEMBER($set,  &SIGKILL) ||  &SIGISMEMBER($set,  &SIGQUIT)));
    }' unless defined(&SMB_SIGMASK);
    eval 'sub smb_suser {
        my($cred) = @_;
	    eval q( &priv_check_cred($cred,  &PRIV_NETSMB, 0));
    }' unless defined(&smb_suser);
    require 'sys/lock.ph';
    require 'sys/mutex.ph';
    eval 'sub smb_slock () { &mtx;}' unless defined(&smb_slock);
    eval 'sub smb_sl_init {
        my($mtx, $desc) = @_;
	    eval q( &mtx_init($mtx, $desc,  &NULL,  &MTX_DEF));
    }' unless defined(&smb_sl_init);
    eval 'sub smb_sl_destroy {
        my($mtx) = @_;
	    eval q( &mtx_destroy($mtx));
    }' unless defined(&smb_sl_destroy);
    eval 'sub smb_sl_lock {
        my($mtx) = @_;
	    eval q( &mtx_lock($mtx));
    }' unless defined(&smb_sl_lock);
    eval 'sub smb_sl_unlock {
        my($mtx) = @_;
	    eval q( &mtx_unlock($mtx));
    }' unless defined(&smb_sl_unlock);
    eval 'sub SMB_STRFREE {
        my($p) = @_;
	    eval q( &do {  &if ($p)  &smb_strfree($p); }  &while(0));
    }' unless defined(&SMB_STRFREE);
}
1;
