require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFS_NFS_COMMON_H_)) {
    eval 'sub _NFS_NFS_COMMON_H_ () {1;}' unless defined(&_NFS_NFS_COMMON_H_);
    eval 'sub vtonfsv2_mode {
        my($t, $m) = @_;
	    eval q( &txdr_unsigned((($t) ==  &VFIFO) ?  &MAKEIMODE( &VCHR, ($m)) :  &MAKEIMODE(($t), ($m))));
    }' unless defined(&vtonfsv2_mode);
    eval 'sub nfsv3tov_type {
        my($a) = @_;
	    eval q( $nv3tov_type[ &fxdr_unsigned( &u_int32_t,($a))&0x7]);
    }' unless defined(&nfsv3tov_type);
    eval 'sub vtonfsv3_type {
        my($a) = @_;
	    eval q( &txdr_unsigned( $nfsv3_type[(( &int32_t)($a))]));
    }' unless defined(&vtonfsv3_type);
    eval 'sub nfsm_build {
        my($c, $s) = @_;
	    eval q(($c) &nfsm_build_xx(($s),  &mb,  &bpos));
    }' unless defined(&nfsm_build);
    eval 'sub nfsm_dcheck {
        my($t1, $mrep) = @_;
	    eval q( &do {  &if ($t1 != 0) {  &error = $t1;  &m_freem(($mrep)); ($mrep) =  &NULL;  &goto  &nfsmout; } }  &while (0));
    }' unless defined(&nfsm_dcheck);
    eval 'sub nfsm_dcheckp {
        my($retp, $mrep) = @_;
	    eval q( &do {  &if ($retp ==  &NULL) {  &error =  &EBADRPC;  &m_freem(($mrep)); ($mrep) =  &NULL;  &goto  &nfsmout; } }  &while (0));
    }' unless defined(&nfsm_dcheckp);
    eval 'sub nfsm_dissect {
        my($c, $s) = @_;
	    eval q(({  &void * &ret;  &ret =  &nfsm_dissect_xx(($s),  &md,  &dpos);  &nfsm_dcheckp( &ret,  &mrep); ($c) &ret; }));
    }' unless defined(&nfsm_dissect);
    eval 'sub nfsm_dissect_nonblock {
        my($c, $s) = @_;
	    eval q(({  &void * &ret;  &ret =  &nfsm_dissect_xx_nonblock(($s),  &md,  &dpos);  &nfsm_dcheckp( &ret,  &mrep); ($c) &ret; }));
    }' unless defined(&nfsm_dissect_nonblock);
    eval 'sub nfsm_strsiz {
        my($s,$m) = @_;
	    eval q( &do { \'int\'  &t1;  &t1 =  &nfsm_strsiz_xx(($s), ($m),  &md,  &dpos);  &nfsm_dcheck( &t1,  &mrep); }  &while(0));
    }' unless defined(&nfsm_strsiz);
    eval 'sub nfsm_mtouio {
        my($p,$s) = @_;
	    eval q( &do {  &int32_t  &t1 = 0;  &if (($s) > 0)  &t1 =  &nfsm_mbuftouio( &md, ($p), ($s),  &dpos);  &nfsm_dcheck( &t1,  &mrep); }  &while (0));
    }' unless defined(&nfsm_mtouio);
    eval 'sub nfsm_rndup {
        my($a) = @_;
	    eval q(((($a)+3)(~0x3)));
    }' unless defined(&nfsm_rndup);
    eval 'sub nfsm_adv {
        my($s) = @_;
	    eval q( &do { \'int\'  &t1;  &t1 =  &nfsm_adv_xx(($s),  &md,  &dpos);  &nfsm_dcheck( &t1,  &mrep); }  &while (0));
    }' unless defined(&nfsm_adv);
    if(defined(&__NO_STRICT_ALIGNMENT)) {
	eval 'sub nfsm_aligned {
	    my($p, $t) = @_;
    	    eval q(1);
	}' unless defined(&nfsm_aligned);
    } else {
	eval 'sub nfsm_aligned {
	    my($p, $t) = @_;
    	    eval q((((($p)) & ($sizeof{$t} - 1)) == 0));
	}' unless defined(&nfsm_aligned);
    }
}
1;
