require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFSCLIENT_NFS_KDTRACE_H_)) {
    eval 'sub _NFSCLIENT_NFS_KDTRACE_H_ () {1;}' unless defined(&_NFSCLIENT_NFS_KDTRACE_H_);
    if(defined(&KDTRACE_HOOKS)) {
	require 'sys/dtrace_bsd.ph';
	eval 'sub KDTRACE_NFS_ACCESSCACHE_FLUSH_DONE {
	    my($vp) = @_;
    	    eval q( &do {  &if ( &dtrace_nfsclient_accesscache_flush_done_probe !=  &NULL) ( &dtrace_nfsclient_accesscache_flush_done_probe)(  &nfsclient_accesscache_flush_done_id, ($vp)); }  &while (0));
	}' unless defined(&KDTRACE_NFS_ACCESSCACHE_FLUSH_DONE);
	eval 'sub KDTRACE_NFS_ACCESSCACHE_GET_HIT {
	    my($vp, $uid, $mode) = @_;
    	    eval q( &do {  &if ( &dtrace_nfsclient_accesscache_get_hit_probe !=  &NULL) ( &dtrace_nfsclient_accesscache_get_hit_probe)(  &nfsclient_accesscache_get_hit_id, ($vp), ($uid), ($mode)); }  &while (0));
	}' unless defined(&KDTRACE_NFS_ACCESSCACHE_GET_HIT);
	eval 'sub KDTRACE_NFS_ACCESSCACHE_GET_MISS {
	    my($vp, $uid, $mode) = @_;
    	    eval q( &do {  &if ( &dtrace_nfsclient_accesscache_get_miss_probe !=  &NULL) ( &dtrace_nfsclient_accesscache_get_miss_probe)(  &nfsclient_accesscache_get_miss_id, ($vp), ($uid), ($mode)); }  &while (0));
	}' unless defined(&KDTRACE_NFS_ACCESSCACHE_GET_MISS);
	eval 'sub KDTRACE_NFS_ACCESSCACHE_LOAD_DONE {
	    my($vp, $uid, $rmode, $error) = @_;
    	    eval q( &do {  &if ( &dtrace_nfsclient_accesscache_load_done_probe !=  &NULL) ( &dtrace_nfsclient_accesscache_load_done_probe)(  &nfsclient_accesscache_load_done_id, ($vp), ($uid), ($rmode), ($error)); }  &while (0));
	}' unless defined(&KDTRACE_NFS_ACCESSCACHE_LOAD_DONE);
	eval 'sub KDTRACE_NFS_ATTRCACHE_FLUSH_DONE {
	    my($vp) = @_;
    	    eval q( &do {  &if ( &dtrace_nfsclient_attrcache_flush_done_probe !=  &NULL) ( &dtrace_nfsclient_attrcache_flush_done_probe)(  &nfsclient_attrcache_flush_done_id, ($vp)); }  &while (0));
	}' unless defined(&KDTRACE_NFS_ATTRCACHE_FLUSH_DONE);
	eval 'sub KDTRACE_NFS_ATTRCACHE_GET_HIT {
	    my($vp, $vap) = @_;
    	    eval q( &do {  &if ( &dtrace_nfsclient_attrcache_get_hit_probe !=  &NULL) ( &dtrace_nfsclient_attrcache_get_hit_probe)(  &nfsclient_attrcache_get_hit_id, ($vp), ($vap)); }  &while (0));
	}' unless defined(&KDTRACE_NFS_ATTRCACHE_GET_HIT);
	eval 'sub KDTRACE_NFS_ATTRCACHE_GET_MISS {
	    my($vp) = @_;
    	    eval q( &do {  &if ( &dtrace_nfsclient_attrcache_get_miss_probe !=  &NULL) ( &dtrace_nfsclient_attrcache_get_miss_probe)(  &nfsclient_attrcache_get_miss_id, ($vp)); }  &while (0));
	}' unless defined(&KDTRACE_NFS_ATTRCACHE_GET_MISS);
	eval 'sub KDTRACE_NFS_ATTRCACHE_LOAD_DONE {
	    my($vp, $vap, $error) = @_;
    	    eval q( &do {  &if ( &dtrace_nfsclient_attrcache_load_done_probe !=  &NULL) ( &dtrace_nfsclient_attrcache_load_done_probe)(  &nfsclient_attrcache_load_done_id, ($vp), ($vap), ($error)); }  &while (0));
	}' unless defined(&KDTRACE_NFS_ATTRCACHE_LOAD_DONE);
    } else {
	eval 'sub KDTRACE_NFS_ACCESSCACHE_FLUSH_DONE {
	    my($vp) = @_;
    	    eval q();
	}' unless defined(&KDTRACE_NFS_ACCESSCACHE_FLUSH_DONE);
	eval 'sub KDTRACE_NFS_ACCESSCACHE_GET_HIT {
	    my($vp, $uid, $mode) = @_;
    	    eval q();
	}' unless defined(&KDTRACE_NFS_ACCESSCACHE_GET_HIT);
	eval 'sub KDTRACE_NFS_ACCESSCACHE_GET_MISS {
	    my($vp, $uid, $mode) = @_;
    	    eval q();
	}' unless defined(&KDTRACE_NFS_ACCESSCACHE_GET_MISS);
	eval 'sub KDTRACE_NFS_ACCESSCACHE_LOAD_DONE {
	    my($vp, $uid, $rmode, $error) = @_;
    	    eval q();
	}' unless defined(&KDTRACE_NFS_ACCESSCACHE_LOAD_DONE);
	eval 'sub KDTRACE_NFS_ATTRCACHE_FLUSH_DONE {
	    my($vp) = @_;
    	    eval q();
	}' unless defined(&KDTRACE_NFS_ATTRCACHE_FLUSH_DONE);
	eval 'sub KDTRACE_NFS_ATTRCACHE_GET_HIT {
	    my($vp, $vap) = @_;
    	    eval q();
	}' unless defined(&KDTRACE_NFS_ATTRCACHE_GET_HIT);
	eval 'sub KDTRACE_NFS_ATTRCACHE_GET_MISS {
	    my($vp) = @_;
    	    eval q();
	}' unless defined(&KDTRACE_NFS_ATTRCACHE_GET_MISS);
	eval 'sub KDTRACE_NFS_ATTRCACHE_LOAD_DONE {
	    my($vp, $vap, $error) = @_;
    	    eval q();
	}' unless defined(&KDTRACE_NFS_ATTRCACHE_LOAD_DONE);
    }
}
1;
