require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFS_NFSPROTO_H_)) {
    eval 'sub _NFS_NFSPROTO_H_ () {1;}' unless defined(&_NFS_NFSPROTO_H_);
    eval 'sub NFS_PORT () {2049;}' unless defined(&NFS_PORT);
    eval 'sub NFS_PROG () {100003;}' unless defined(&NFS_PROG);
    eval 'sub NFS_VER2 () {2;}' unless defined(&NFS_VER2);
    eval 'sub NFS_VER3 () {3;}' unless defined(&NFS_VER3);
    eval 'sub NFS_VER4 () {4;}' unless defined(&NFS_VER4);
    eval 'sub NFS_V2MAXDATA () {8192;}' unless defined(&NFS_V2MAXDATA);
    eval 'sub NFS_MAXDGRAMDATA () {16384;}' unless defined(&NFS_MAXDGRAMDATA);
    eval 'sub NFS_MAXDATA () {32768;}' unless defined(&NFS_MAXDATA);
    eval 'sub NFS_MAXPATHLEN () {1024;}' unless defined(&NFS_MAXPATHLEN);
    eval 'sub NFS_MAXNAMLEN () {255;}' unless defined(&NFS_MAXNAMLEN);
    eval 'sub NFS_MAXPKTHDR () {404;}' unless defined(&NFS_MAXPKTHDR);
    eval 'sub NFS_MAXPACKET () {( &NFS_MAXPKTHDR +  &NFS_MAXDATA);}' unless defined(&NFS_MAXPACKET);
    eval 'sub NFS_MINPACKET () {20;}' unless defined(&NFS_MINPACKET);
    eval 'sub NFS_FABLKSIZE () {512;}' unless defined(&NFS_FABLKSIZE);
    eval 'sub NFS_OK () {0;}' unless defined(&NFS_OK);
    eval 'sub NFSERR_PERM () {1;}' unless defined(&NFSERR_PERM);
    eval 'sub NFSERR_NOENT () {2;}' unless defined(&NFSERR_NOENT);
    eval 'sub NFSERR_IO () {5;}' unless defined(&NFSERR_IO);
    eval 'sub NFSERR_NXIO () {6;}' unless defined(&NFSERR_NXIO);
    eval 'sub NFSERR_ACCES () {13;}' unless defined(&NFSERR_ACCES);
    eval 'sub NFSERR_EXIST () {17;}' unless defined(&NFSERR_EXIST);
    eval 'sub NFSERR_XDEV () {18;}' unless defined(&NFSERR_XDEV);
    eval 'sub NFSERR_NODEV () {19;}' unless defined(&NFSERR_NODEV);
    eval 'sub NFSERR_NOTDIR () {20;}' unless defined(&NFSERR_NOTDIR);
    eval 'sub NFSERR_ISDIR () {21;}' unless defined(&NFSERR_ISDIR);
    eval 'sub NFSERR_INVAL () {22;}' unless defined(&NFSERR_INVAL);
    eval 'sub NFSERR_FBIG () {27;}' unless defined(&NFSERR_FBIG);
    eval 'sub NFSERR_NOSPC () {28;}' unless defined(&NFSERR_NOSPC);
    eval 'sub NFSERR_ROFS () {30;}' unless defined(&NFSERR_ROFS);
    eval 'sub NFSERR_MLINK () {31;}' unless defined(&NFSERR_MLINK);
    eval 'sub NFSERR_NAMETOL () {63;}' unless defined(&NFSERR_NAMETOL);
    eval 'sub NFSERR_NOTEMPTY () {66;}' unless defined(&NFSERR_NOTEMPTY);
    eval 'sub NFSERR_DQUOT () {69;}' unless defined(&NFSERR_DQUOT);
    eval 'sub NFSERR_STALE () {70;}' unless defined(&NFSERR_STALE);
    eval 'sub NFSERR_REMOTE () {71;}' unless defined(&NFSERR_REMOTE);
    eval 'sub NFSERR_WFLUSH () {99;}' unless defined(&NFSERR_WFLUSH);
    eval 'sub NFSERR_BADHANDLE () {10001;}' unless defined(&NFSERR_BADHANDLE);
    eval 'sub NFSERR_NOT_SYNC () {10002;}' unless defined(&NFSERR_NOT_SYNC);
    eval 'sub NFSERR_BAD_COOKIE () {10003;}' unless defined(&NFSERR_BAD_COOKIE);
    eval 'sub NFSERR_NOTSUPP () {10004;}' unless defined(&NFSERR_NOTSUPP);
    eval 'sub NFSERR_TOOSMALL () {10005;}' unless defined(&NFSERR_TOOSMALL);
    eval 'sub NFSERR_SERVERFAULT () {10006;}' unless defined(&NFSERR_SERVERFAULT);
    eval 'sub NFSERR_BADTYPE () {10007;}' unless defined(&NFSERR_BADTYPE);
    eval 'sub NFSERR_JUKEBOX () {10008;}' unless defined(&NFSERR_JUKEBOX);
    eval 'sub NFSERR_TRYLATER () { &NFSERR_JUKEBOX;}' unless defined(&NFSERR_TRYLATER);
    eval 'sub NFSERR_SAME () {10009;}' unless defined(&NFSERR_SAME);
    eval 'sub NFSERR_DENIED () {10010;}' unless defined(&NFSERR_DENIED);
    eval 'sub NFSERR_EXPIRED () {10011;}' unless defined(&NFSERR_EXPIRED);
    eval 'sub NFSERR_LOCKED () {10012;}' unless defined(&NFSERR_LOCKED);
    eval 'sub NFSERR_GRACE () {10013;}' unless defined(&NFSERR_GRACE);
    eval 'sub NFSERR_FHEXPIRED () {10014;}' unless defined(&NFSERR_FHEXPIRED);
    eval 'sub NFSERR_SHARDE_DENIED () {10015;}' unless defined(&NFSERR_SHARDE_DENIED);
    eval 'sub NFSERR_WRONGSEC () {10016;}' unless defined(&NFSERR_WRONGSEC);
    eval 'sub NFSERR_CLID_INUSE () {10017;}' unless defined(&NFSERR_CLID_INUSE);
    eval 'sub NFSERR_RESOURCE () {10018;}' unless defined(&NFSERR_RESOURCE);
    eval 'sub NFSERR_MOVED () {10019;}' unless defined(&NFSERR_MOVED);
    eval 'sub NFSERR_NOFILEHANDLE () {10020;}' unless defined(&NFSERR_NOFILEHANDLE);
    eval 'sub NFSERR_MINOR_VERS_MISMATCH () {10021;}' unless defined(&NFSERR_MINOR_VERS_MISMATCH);
    eval 'sub NFSERR_STALE_CLIENTID () {10022;}' unless defined(&NFSERR_STALE_CLIENTID);
    eval 'sub NFSERR_STALE_STATEID () {10023;}' unless defined(&NFSERR_STALE_STATEID);
    eval 'sub NFSERR_OLD_STATEID () {10024;}' unless defined(&NFSERR_OLD_STATEID);
    eval 'sub NFSERR_BAD_STATEID () {10025;}' unless defined(&NFSERR_BAD_STATEID);
    eval 'sub NFSERR_BAD_SEQID () {10026;}' unless defined(&NFSERR_BAD_SEQID);
    eval 'sub NFSERR_NOT_SAME () {10027;}' unless defined(&NFSERR_NOT_SAME);
    eval 'sub NFSERR_LOCK_RANGE () {10028;}' unless defined(&NFSERR_LOCK_RANGE);
    eval 'sub NFSERR_SYMLINK () {10029;}' unless defined(&NFSERR_SYMLINK);
    eval 'sub NFSERR_READDIR_NOSPC () {10030;}' unless defined(&NFSERR_READDIR_NOSPC);
    eval 'sub NFSERR_LEASE_MOVED () {10031;}' unless defined(&NFSERR_LEASE_MOVED);
    eval 'sub NFSERR_ATTRNOTSUPP () {10032;}' unless defined(&NFSERR_ATTRNOTSUPP);
    eval 'sub NFSERR_NO_GRACE () {10033;}' unless defined(&NFSERR_NO_GRACE);
    eval 'sub NFSERR_RECLAIM_BAD () {10034;}' unless defined(&NFSERR_RECLAIM_BAD);
    eval 'sub NFSERR_RECLAIM_CONFLICT () {10035;}' unless defined(&NFSERR_RECLAIM_CONFLICT);
    eval 'sub NFSERR_BADXDR () {10036;}' unless defined(&NFSERR_BADXDR);
    eval 'sub NFSERR_LOCKS_HELD () {10037;}' unless defined(&NFSERR_LOCKS_HELD);
    eval 'sub NFSERR_OPENMODE () {10038;}' unless defined(&NFSERR_OPENMODE);
    eval 'sub NFSERR_BADOWNER () {10039;}' unless defined(&NFSERR_BADOWNER);
    eval 'sub NFSERR_BADCHAR () {10040;}' unless defined(&NFSERR_BADCHAR);
    eval 'sub NFSERR_BADNAME () {10041;}' unless defined(&NFSERR_BADNAME);
    eval 'sub NFSERR_BAD_RANGE () {10042;}' unless defined(&NFSERR_BAD_RANGE);
    eval 'sub NFSERR_LOCK_NOTSUPP () {10043;}' unless defined(&NFSERR_LOCK_NOTSUPP);
    eval 'sub NFSERR_OP_ILLEGAL () {10044;}' unless defined(&NFSERR_OP_ILLEGAL);
    eval 'sub NFSERR_DEADLOCK () {10045;}' unless defined(&NFSERR_DEADLOCK);
    eval 'sub NFSERR_FILE_OPEN () {10046;}' unless defined(&NFSERR_FILE_OPEN);
    eval 'sub NFSERR_STALEWRITEVERF () {30001;}' unless defined(&NFSERR_STALEWRITEVERF);
    eval 'sub NFSERR_RETVOID () {0x20000000;}' unless defined(&NFSERR_RETVOID);
    eval 'sub NFSERR_AUTHERR () {0x40000000;}' unless defined(&NFSERR_AUTHERR);
    eval 'sub NFSERR_RETERR () {0x80000000;}' unless defined(&NFSERR_RETERR);
    eval 'sub NFSX_UNSIGNED () {4;}' unless defined(&NFSX_UNSIGNED);
    eval 'sub NFSX_V2FH () {32;}' unless defined(&NFSX_V2FH);
    eval 'sub NFSX_V2FATTR () {68;}' unless defined(&NFSX_V2FATTR);
    eval 'sub NFSX_V2SATTR () {32;}' unless defined(&NFSX_V2SATTR);
    eval 'sub NFSX_V2COOKIE () {4;}' unless defined(&NFSX_V2COOKIE);
    eval 'sub NFSX_V2STATFS () {20;}' unless defined(&NFSX_V2STATFS);
    eval 'sub NFSX_V3FH () {($sizeof{ &fhandle_t});}' unless defined(&NFSX_V3FH);
    eval 'sub NFSX_V3FHMAX () {64;}' unless defined(&NFSX_V3FHMAX);
    eval 'sub NFSX_V3FATTR () {84;}' unless defined(&NFSX_V3FATTR);
    eval 'sub NFSX_V3SATTR () {60;}' unless defined(&NFSX_V3SATTR);
    eval 'sub NFSX_V3SRVSATTR () {($sizeof{\'struct nfsv3_sattr\'});}' unless defined(&NFSX_V3SRVSATTR);
    eval 'sub NFSX_V3POSTOPATTR () {( &NFSX_V3FATTR +  &NFSX_UNSIGNED);}' unless defined(&NFSX_V3POSTOPATTR);
    eval 'sub NFSX_V3WCCDATA () {( &NFSX_V3POSTOPATTR + 8*  &NFSX_UNSIGNED);}' unless defined(&NFSX_V3WCCDATA);
    eval 'sub NFSX_V3COOKIEVERF () {8;}' unless defined(&NFSX_V3COOKIEVERF);
    eval 'sub NFSX_V3WRITEVERF () {8;}' unless defined(&NFSX_V3WRITEVERF);
    eval 'sub NFSX_V3CREATEVERF () {8;}' unless defined(&NFSX_V3CREATEVERF);
    eval 'sub NFSX_V3STATFS () {52;}' unless defined(&NFSX_V3STATFS);
    eval 'sub NFSX_V3FSINFO () {48;}' unless defined(&NFSX_V3FSINFO);
    eval 'sub NFSX_V3PATHCONF () {24;}' unless defined(&NFSX_V3PATHCONF);
    eval 'sub NFSX_V4VERF () {8;}' unless defined(&NFSX_V4VERF);
    eval 'sub NFSX_V4FH () {128;}' unless defined(&NFSX_V4FH);
    eval 'sub NFSX_V4STATEID () {16;}' unless defined(&NFSX_V4STATEID);
    eval 'sub NFSX_FH {
        my($v3) = @_;
	    eval q((($v3) ? ( &NFSX_V3FHMAX +  &NFSX_UNSIGNED) :  &NFSX_V2FH));
    }' unless defined(&NFSX_FH);
    eval 'sub NFSX_SRVFH {
        my($v3) = @_;
	    eval q((($v3) ?  &NFSX_V3FH :  &NFSX_V2FH));
    }' unless defined(&NFSX_SRVFH);
    eval 'sub NFSX_FATTR {
        my($v3) = @_;
	    eval q((($v3) ?  &NFSX_V3FATTR :  &NFSX_V2FATTR));
    }' unless defined(&NFSX_FATTR);
    eval 'sub NFSX_PREOPATTR {
        my($v3) = @_;
	    eval q((($v3) ? (7*  &NFSX_UNSIGNED) : 0));
    }' unless defined(&NFSX_PREOPATTR);
    eval 'sub NFSX_POSTOPATTR {
        my($v3) = @_;
	    eval q((($v3) ? ( &NFSX_V3FATTR +  &NFSX_UNSIGNED) : 0));
    }' unless defined(&NFSX_POSTOPATTR);
    eval 'sub NFSX_POSTOPORFATTR {
        my($v3) = @_;
	    eval q((($v3) ? ( &NFSX_V3FATTR +  &NFSX_UNSIGNED) :  &NFSX_V2FATTR));
    }' unless defined(&NFSX_POSTOPORFATTR);
    eval 'sub NFSX_WCCDATA {
        my($v3) = @_;
	    eval q((($v3) ?  &NFSX_V3WCCDATA : 0));
    }' unless defined(&NFSX_WCCDATA);
    eval 'sub NFSX_WCCORFATTR {
        my($v3) = @_;
	    eval q((($v3) ?  &NFSX_V3WCCDATA :  &NFSX_V2FATTR));
    }' unless defined(&NFSX_WCCORFATTR);
    eval 'sub NFSX_SATTR {
        my($v3) = @_;
	    eval q((($v3) ?  &NFSX_V3SATTR :  &NFSX_V2SATTR));
    }' unless defined(&NFSX_SATTR);
    eval 'sub NFSX_COOKIEVERF {
        my($v3) = @_;
	    eval q((($v3) ?  &NFSX_V3COOKIEVERF : 0));
    }' unless defined(&NFSX_COOKIEVERF);
    eval 'sub NFSX_WRITEVERF {
        my($v3) = @_;
	    eval q((($v3) ?  &NFSX_V3WRITEVERF : 0));
    }' unless defined(&NFSX_WRITEVERF);
    eval 'sub NFSX_READDIR {
        my($v3) = @_;
	    eval q((($v3) ? (5*  &NFSX_UNSIGNED) : (2*  &NFSX_UNSIGNED)));
    }' unless defined(&NFSX_READDIR);
    eval 'sub NFSX_STATFS {
        my($v3) = @_;
	    eval q((($v3) ?  &NFSX_V3STATFS :  &NFSX_V2STATFS));
    }' unless defined(&NFSX_STATFS);
    eval 'sub NFSPROC_NULL () {0;}' unless defined(&NFSPROC_NULL);
    eval 'sub NFSPROC_GETATTR () {1;}' unless defined(&NFSPROC_GETATTR);
    eval 'sub NFSPROC_SETATTR () {2;}' unless defined(&NFSPROC_SETATTR);
    eval 'sub NFSPROC_LOOKUP () {3;}' unless defined(&NFSPROC_LOOKUP);
    eval 'sub NFSPROC_ACCESS () {4;}' unless defined(&NFSPROC_ACCESS);
    eval 'sub NFSPROC_READLINK () {5;}' unless defined(&NFSPROC_READLINK);
    eval 'sub NFSPROC_READ () {6;}' unless defined(&NFSPROC_READ);
    eval 'sub NFSPROC_WRITE () {7;}' unless defined(&NFSPROC_WRITE);
    eval 'sub NFSPROC_CREATE () {8;}' unless defined(&NFSPROC_CREATE);
    eval 'sub NFSPROC_MKDIR () {9;}' unless defined(&NFSPROC_MKDIR);
    eval 'sub NFSPROC_SYMLINK () {10;}' unless defined(&NFSPROC_SYMLINK);
    eval 'sub NFSPROC_MKNOD () {11;}' unless defined(&NFSPROC_MKNOD);
    eval 'sub NFSPROC_REMOVE () {12;}' unless defined(&NFSPROC_REMOVE);
    eval 'sub NFSPROC_RMDIR () {13;}' unless defined(&NFSPROC_RMDIR);
    eval 'sub NFSPROC_RENAME () {14;}' unless defined(&NFSPROC_RENAME);
    eval 'sub NFSPROC_LINK () {15;}' unless defined(&NFSPROC_LINK);
    eval 'sub NFSPROC_READDIR () {16;}' unless defined(&NFSPROC_READDIR);
    eval 'sub NFSPROC_READDIRPLUS () {17;}' unless defined(&NFSPROC_READDIRPLUS);
    eval 'sub NFSPROC_FSSTAT () {18;}' unless defined(&NFSPROC_FSSTAT);
    eval 'sub NFSPROC_FSINFO () {19;}' unless defined(&NFSPROC_FSINFO);
    eval 'sub NFSPROC_PATHCONF () {20;}' unless defined(&NFSPROC_PATHCONF);
    eval 'sub NFSPROC_COMMIT () {21;}' unless defined(&NFSPROC_COMMIT);
    eval 'sub NFSPROC_NOOP () {22;}' unless defined(&NFSPROC_NOOP);
    eval 'sub NFS_NPROCS () {23;}' unless defined(&NFS_NPROCS);
    eval 'sub NFSV2PROC_NULL () {0;}' unless defined(&NFSV2PROC_NULL);
    eval 'sub NFSV2PROC_GETATTR () {1;}' unless defined(&NFSV2PROC_GETATTR);
    eval 'sub NFSV2PROC_SETATTR () {2;}' unless defined(&NFSV2PROC_SETATTR);
    eval 'sub NFSV2PROC_NOOP () {3;}' unless defined(&NFSV2PROC_NOOP);
    eval 'sub NFSV2PROC_ROOT () { &NFSV2PROC_NOOP;}' unless defined(&NFSV2PROC_ROOT);
    eval 'sub NFSV2PROC_LOOKUP () {4;}' unless defined(&NFSV2PROC_LOOKUP);
    eval 'sub NFSV2PROC_READLINK () {5;}' unless defined(&NFSV2PROC_READLINK);
    eval 'sub NFSV2PROC_READ () {6;}' unless defined(&NFSV2PROC_READ);
    eval 'sub NFSV2PROC_WRITECACHE () { &NFSV2PROC_NOOP;}' unless defined(&NFSV2PROC_WRITECACHE);
    eval 'sub NFSV2PROC_WRITE () {8;}' unless defined(&NFSV2PROC_WRITE);
    eval 'sub NFSV2PROC_CREATE () {9;}' unless defined(&NFSV2PROC_CREATE);
    eval 'sub NFSV2PROC_REMOVE () {10;}' unless defined(&NFSV2PROC_REMOVE);
    eval 'sub NFSV2PROC_RENAME () {11;}' unless defined(&NFSV2PROC_RENAME);
    eval 'sub NFSV2PROC_LINK () {12;}' unless defined(&NFSV2PROC_LINK);
    eval 'sub NFSV2PROC_SYMLINK () {13;}' unless defined(&NFSV2PROC_SYMLINK);
    eval 'sub NFSV2PROC_MKDIR () {14;}' unless defined(&NFSV2PROC_MKDIR);
    eval 'sub NFSV2PROC_RMDIR () {15;}' unless defined(&NFSV2PROC_RMDIR);
    eval 'sub NFSV2PROC_READDIR () {16;}' unless defined(&NFSV2PROC_READDIR);
    eval 'sub NFSV2PROC_STATFS () {17;}' unless defined(&NFSV2PROC_STATFS);
    eval 'sub NFSV4PROC_NULL () {0;}' unless defined(&NFSV4PROC_NULL);
    eval 'sub NFSV4PROC_COMPOUND () {1;}' unless defined(&NFSV4PROC_COMPOUND);
    eval 'sub NFSV4OP_ACCESS () {3;}' unless defined(&NFSV4OP_ACCESS);
    eval 'sub NFSV4OP_CLOSE () {4;}' unless defined(&NFSV4OP_CLOSE);
    eval 'sub NFSV4OP_COMMIT () {5;}' unless defined(&NFSV4OP_COMMIT);
    eval 'sub NFSV4OP_CREATE () {6;}' unless defined(&NFSV4OP_CREATE);
    eval 'sub NFSV4OP_DELEGPURGE () {7;}' unless defined(&NFSV4OP_DELEGPURGE);
    eval 'sub NFSV4OP_DELEGRETURN () {8;}' unless defined(&NFSV4OP_DELEGRETURN);
    eval 'sub NFSV4OP_GETATTR () {9;}' unless defined(&NFSV4OP_GETATTR);
    eval 'sub NFSV4OP_GETFH () {10;}' unless defined(&NFSV4OP_GETFH);
    eval 'sub NFSV4OP_LINK () {11;}' unless defined(&NFSV4OP_LINK);
    eval 'sub NFSV4OP_LOCK () {12;}' unless defined(&NFSV4OP_LOCK);
    eval 'sub NFSV4OP_LOCKT () {13;}' unless defined(&NFSV4OP_LOCKT);
    eval 'sub NFSV4OP_LOCKU () {14;}' unless defined(&NFSV4OP_LOCKU);
    eval 'sub NFSV4OP_LOOKUP () {15;}' unless defined(&NFSV4OP_LOOKUP);
    eval 'sub NFSV4OP_LOOKUPP () {16;}' unless defined(&NFSV4OP_LOOKUPP);
    eval 'sub NFSV4OP_NVERIFY () {17;}' unless defined(&NFSV4OP_NVERIFY);
    eval 'sub NFSV4OP_OPEN () {18;}' unless defined(&NFSV4OP_OPEN);
    eval 'sub NFSV4OP_OPENATTR () {19;}' unless defined(&NFSV4OP_OPENATTR);
    eval 'sub NFSV4OP_OPEN_CONFIRM () {20;}' unless defined(&NFSV4OP_OPEN_CONFIRM);
    eval 'sub NFSV4OP_OPEN_DOWNGRADE () {21;}' unless defined(&NFSV4OP_OPEN_DOWNGRADE);
    eval 'sub NFSV4OP_PUTFH () {22;}' unless defined(&NFSV4OP_PUTFH);
    eval 'sub NFSV4OP_PUTPUBFH () {23;}' unless defined(&NFSV4OP_PUTPUBFH);
    eval 'sub NFSV4OP_PUTROOTFH () {24;}' unless defined(&NFSV4OP_PUTROOTFH);
    eval 'sub NFSV4OP_READ () {25;}' unless defined(&NFSV4OP_READ);
    eval 'sub NFSV4OP_READDIR () {26;}' unless defined(&NFSV4OP_READDIR);
    eval 'sub NFSV4OP_READLINK () {27;}' unless defined(&NFSV4OP_READLINK);
    eval 'sub NFSV4OP_REMOVE () {28;}' unless defined(&NFSV4OP_REMOVE);
    eval 'sub NFSV4OP_RENAME () {29;}' unless defined(&NFSV4OP_RENAME);
    eval 'sub NFSV4OP_RENEW () {30;}' unless defined(&NFSV4OP_RENEW);
    eval 'sub NFSV4OP_RESTOREFH () {31;}' unless defined(&NFSV4OP_RESTOREFH);
    eval 'sub NFSV4OP_SAVEFH () {32;}' unless defined(&NFSV4OP_SAVEFH);
    eval 'sub NFSV4OP_SECINFO () {33;}' unless defined(&NFSV4OP_SECINFO);
    eval 'sub NFSV4OP_SETATTR () {34;}' unless defined(&NFSV4OP_SETATTR);
    eval 'sub NFSV4OP_SETCLIENTID () {35;}' unless defined(&NFSV4OP_SETCLIENTID);
    eval 'sub NFSV4OP_SETCLIENTID_CONFIRM () {36;}' unless defined(&NFSV4OP_SETCLIENTID_CONFIRM);
    eval 'sub NFSV4OP_VERIFY () {37;}' unless defined(&NFSV4OP_VERIFY);
    eval 'sub NFSV4OP_WRITE () {38;}' unless defined(&NFSV4OP_WRITE);
    eval 'sub NFSV3SATTRTIME_DONTCHANGE () {0;}' unless defined(&NFSV3SATTRTIME_DONTCHANGE);
    eval 'sub NFSV3SATTRTIME_TOSERVER () {1;}' unless defined(&NFSV3SATTRTIME_TOSERVER);
    eval 'sub NFSV3SATTRTIME_TOCLIENT () {2;}' unless defined(&NFSV3SATTRTIME_TOCLIENT);
    eval 'sub NFSV3ACCESS_READ () {0x1;}' unless defined(&NFSV3ACCESS_READ);
    eval 'sub NFSV3ACCESS_LOOKUP () {0x2;}' unless defined(&NFSV3ACCESS_LOOKUP);
    eval 'sub NFSV3ACCESS_MODIFY () {0x4;}' unless defined(&NFSV3ACCESS_MODIFY);
    eval 'sub NFSV3ACCESS_EXTEND () {0x8;}' unless defined(&NFSV3ACCESS_EXTEND);
    eval 'sub NFSV3ACCESS_DELETE () {0x10;}' unless defined(&NFSV3ACCESS_DELETE);
    eval 'sub NFSV3ACCESS_EXECUTE () {0x20;}' unless defined(&NFSV3ACCESS_EXECUTE);
    eval 'sub NFSV3WRITE_UNSTABLE () {0;}' unless defined(&NFSV3WRITE_UNSTABLE);
    eval 'sub NFSV3WRITE_DATASYNC () {1;}' unless defined(&NFSV3WRITE_DATASYNC);
    eval 'sub NFSV3WRITE_FILESYNC () {2;}' unless defined(&NFSV3WRITE_FILESYNC);
    eval 'sub NFSV3CREATE_UNCHECKED () {0;}' unless defined(&NFSV3CREATE_UNCHECKED);
    eval 'sub NFSV3CREATE_GUARDED () {1;}' unless defined(&NFSV3CREATE_GUARDED);
    eval 'sub NFSV3CREATE_EXCLUSIVE () {2;}' unless defined(&NFSV3CREATE_EXCLUSIVE);
    eval 'sub NFSV3FSINFO_LINK () {0x1;}' unless defined(&NFSV3FSINFO_LINK);
    eval 'sub NFSV3FSINFO_SYMLINK () {0x2;}' unless defined(&NFSV3FSINFO_SYMLINK);
    eval 'sub NFSV3FSINFO_HOMOGENEOUS () {0x8;}' unless defined(&NFSV3FSINFO_HOMOGENEOUS);
    eval 'sub NFSV3FSINFO_CANSETTIME () {0x10;}' unless defined(&NFSV3FSINFO_CANSETTIME);
    eval 'sub NFSV4ACCESS_READ () {0x1;}' unless defined(&NFSV4ACCESS_READ);
    eval 'sub NFSV4ACCESS_LOOKUP () {0x2;}' unless defined(&NFSV4ACCESS_LOOKUP);
    eval 'sub NFSV4ACCESS_MODIFY () {0x4;}' unless defined(&NFSV4ACCESS_MODIFY);
    eval 'sub NFSV4ACCESS_EXTEND () {0x8;}' unless defined(&NFSV4ACCESS_EXTEND);
    eval 'sub NFSV4ACCESS_DELETE () {0x10;}' unless defined(&NFSV4ACCESS_DELETE);
    eval 'sub NFSV4ACCESS_EXECUTE () {0x20;}' unless defined(&NFSV4ACCESS_EXECUTE);
    eval 'sub NFSV4OPENRES_MLOCK () {0x1;}' unless defined(&NFSV4OPENRES_MLOCK);
    eval 'sub NFSV4OPENRES_CONFIRM () {0x2;}' unless defined(&NFSV4OPENRES_CONFIRM);
    eval 'sub NFSV4OPENSHARE_ACCESS_READ () {0x1;}' unless defined(&NFSV4OPENSHARE_ACCESS_READ);
    eval 'sub NFSV4OPENSHARE_ACCESS_WRITE () {0x2;}' unless defined(&NFSV4OPENSHARE_ACCESS_WRITE);
    eval 'sub NFSV4OPENSHARE_ACCESS_BOTH () {0x3;}' unless defined(&NFSV4OPENSHARE_ACCESS_BOTH);
    eval 'sub NFSV4OPENSHARE_DENY_NONE () {0x;}' unless defined(&NFSV4OPENSHARE_DENY_NONE);
    eval 'sub NFSV4OPENSHARE_DENY_READ () {0x1;}' unless defined(&NFSV4OPENSHARE_DENY_READ);
    eval 'sub NFSV4OPENSHARE_DENY_WRITE () {0x2;}' unless defined(&NFSV4OPENSHARE_DENY_WRITE);
    eval 'sub NFSV4OPENSHARE_DENY_BOTH () {0x3;}' unless defined(&NFSV4OPENSHARE_DENY_BOTH);
    eval("sub NFNON () { 0; }") unless defined(&NFNON);
    eval("sub NFREG () { 1; }") unless defined(&NFREG);
    eval("sub NFDIR () { 2; }") unless defined(&NFDIR);
    eval("sub NFBLK () { 3; }") unless defined(&NFBLK);
    eval("sub NFCHR () { 4; }") unless defined(&NFCHR);
    eval("sub NFLNK () { 5; }") unless defined(&NFLNK);
    eval("sub NFSOCK () { 6; }") unless defined(&NFSOCK);
    eval("sub NFFIFO () { 7; }") unless defined(&NFFIFO);
    eval("sub NFATTRDIR () { 8; }") unless defined(&NFATTRDIR);
    eval("sub NFNAMEDATTR () { 9; }") unless defined(&NFNAMEDATTR);
    eval("sub NFBAD () { 10; }") unless defined(&NFBAD);
    eval("sub NCLNULL () { 0; }") unless defined(&NCLNULL);
    eval("sub NCLPREV () { 1; }") unless defined(&NCLPREV);
    eval("sub NCLDELEGCUR () { 2; }") unless defined(&NCLDELEGCUR);
    eval("sub NCLDELEGPREV () { 3; }") unless defined(&NCLDELEGPREV);
    eval("sub NSHUNSTABLE () { 0; }") unless defined(&NSHUNSTABLE);
    eval("sub NSHDATASYNC () { 1; }") unless defined(&NSHDATASYNC);
    eval("sub NSHFILESYNC () { 2; }") unless defined(&NSHFILESYNC);
    eval("sub OTNOCREATE () { 0; }") unless defined(&OTNOCREATE);
    eval("sub OTCREATE () { 1; }") unless defined(&OTCREATE);
    eval("sub CMUNCHECKED () { 0; }") unless defined(&CMUNCHECKED);
    eval("sub CMGUARDED () { 1; }") unless defined(&CMGUARDED);
    eval("sub CMEXCLUSIVE () { 2; }") unless defined(&CMEXCLUSIVE);
    eval("sub THSERVERTIME () { 0; }") unless defined(&THSERVERTIME);
    eval("sub THCLIENTTIME () { 1; }") unless defined(&THCLIENTTIME);
    eval("sub ODNONE () { 0; }") unless defined(&ODNONE);
    eval("sub ODREAD () { 1; }") unless defined(&ODREAD);
    eval("sub ODWRITE () { 2; }") unless defined(&ODWRITE);
    unless(defined(&NFS_SMALLFH)) {
	eval 'sub NFS_SMALLFH () {128;}' unless defined(&NFS_SMALLFH);
    }
    eval 'sub fa2_size () { ($fa_un->{fa_nfsv2}->{nfsv2fa_size});}' unless defined(&fa2_size);
    eval 'sub fa2_blocksize () { ($fa_un->{fa_nfsv2}->{nfsv2fa_blocksize});}' unless defined(&fa2_blocksize);
    eval 'sub fa2_rdev () { ($fa_un->{fa_nfsv2}->{nfsv2fa_rdev});}' unless defined(&fa2_rdev);
    eval 'sub fa2_blocks () { ($fa_un->{fa_nfsv2}->{nfsv2fa_blocks});}' unless defined(&fa2_blocks);
    eval 'sub fa2_fsid () { ($fa_un->{fa_nfsv2}->{nfsv2fa_fsid});}' unless defined(&fa2_fsid);
    eval 'sub fa2_fileid () { ($fa_un->{fa_nfsv2}->{nfsv2fa_fileid});}' unless defined(&fa2_fileid);
    eval 'sub fa2_atime () { ($fa_un->{fa_nfsv2}->{nfsv2fa_atime});}' unless defined(&fa2_atime);
    eval 'sub fa2_mtime () { ($fa_un->{fa_nfsv2}->{nfsv2fa_mtime});}' unless defined(&fa2_mtime);
    eval 'sub fa2_ctime () { ($fa_un->{fa_nfsv2}->{nfsv2fa_ctime});}' unless defined(&fa2_ctime);
    eval 'sub fa3_size () { ($fa_un->{fa_nfsv3}->{nfsv3fa_size});}' unless defined(&fa3_size);
    eval 'sub fa3_used () { ($fa_un->{fa_nfsv3}->{nfsv3fa_used});}' unless defined(&fa3_used);
    eval 'sub fa3_rdev () { ($fa_un->{fa_nfsv3}->{nfsv3fa_rdev});}' unless defined(&fa3_rdev);
    eval 'sub fa3_fsid () { ($fa_un->{fa_nfsv3}->{nfsv3fa_fsid});}' unless defined(&fa3_fsid);
    eval 'sub fa3_fileid () { ($fa_un->{fa_nfsv3}->{nfsv3fa_fileid});}' unless defined(&fa3_fileid);
    eval 'sub fa3_atime () { ($fa_un->{fa_nfsv3}->{nfsv3fa_atime});}' unless defined(&fa3_atime);
    eval 'sub fa3_mtime () { ($fa_un->{fa_nfsv3}->{nfsv3fa_mtime});}' unless defined(&fa3_mtime);
    eval 'sub fa3_ctime () { ($fa_un->{fa_nfsv3}->{nfsv3fa_ctime});}' unless defined(&fa3_ctime);
    eval 'sub FA4V_SIZE () {0x1;}' unless defined(&FA4V_SIZE);
    eval 'sub FA4V_FSID () {0x2;}' unless defined(&FA4V_FSID);
    eval 'sub FA4V_FILEID () {0x4;}' unless defined(&FA4V_FILEID);
    eval 'sub FA4V_MODE () {0x8;}' unless defined(&FA4V_MODE);
    eval 'sub FA4V_NLINK () {0x10;}' unless defined(&FA4V_NLINK);
    eval 'sub FA4V_UID () {0x20;}' unless defined(&FA4V_UID);
    eval 'sub FA4V_GID () {0x40;}' unless defined(&FA4V_GID);
    eval 'sub FA4V_RDEV () {0x80;}' unless defined(&FA4V_RDEV);
    eval 'sub FA4V_ATIME () {0x100;}' unless defined(&FA4V_ATIME);
    eval 'sub FA4V_BTIME () {0x200;}' unless defined(&FA4V_BTIME);
    eval 'sub FA4V_CTIME () {0x400;}' unless defined(&FA4V_CTIME);
    eval 'sub FA4V_MTIME () {0x800;}' unless defined(&FA4V_MTIME);
    eval 'sub FA4V_MAXREAD () {0x1000;}' unless defined(&FA4V_MAXREAD);
    eval 'sub FA4V_MAXWRITE () {0x2000;}' unless defined(&FA4V_MAXWRITE);
    eval 'sub FA4V_TYPE () {0x4000;}' unless defined(&FA4V_TYPE);
    eval 'sub FA4V_FFREE () {0x8000;}' unless defined(&FA4V_FFREE);
    eval 'sub FA4V_FTOTAL () {0x10000;}' unless defined(&FA4V_FTOTAL);
    eval 'sub FA4V_MAXNAME () {0x20000;}' unless defined(&FA4V_MAXNAME);
    eval 'sub FA4V_SAVAIL () {0x40000;}' unless defined(&FA4V_SAVAIL);
    eval 'sub FA4V_SFREE () {0x80000;}' unless defined(&FA4V_SFREE);
    eval 'sub FA4V_STOTAL () {0x100000;}' unless defined(&FA4V_STOTAL);
    eval 'sub FA4V_CHANGEID () {0x200000;}' unless defined(&FA4V_CHANGEID);
    eval 'sub FA4V_LEASE_TIME () {0x400000;}' unless defined(&FA4V_LEASE_TIME);
    eval 'sub FA4V_MAXFILESIZE () {0x800000;}' unless defined(&FA4V_MAXFILESIZE);
    eval 'sub FA4V_ACL () {0x1000000;}' unless defined(&FA4V_ACL);
    eval 'sub FA4_SUPPORTED_ATTRS () {0;}' unless defined(&FA4_SUPPORTED_ATTRS);
    eval 'sub FA4_TYPE () {1;}' unless defined(&FA4_TYPE);
    eval 'sub FA4_FH_EXPIRE_TYPE () {2;}' unless defined(&FA4_FH_EXPIRE_TYPE);
    eval 'sub FA4_CHANGE () {3;}' unless defined(&FA4_CHANGE);
    eval 'sub FA4_SIZE () {4;}' unless defined(&FA4_SIZE);
    eval 'sub FA4_LINK_SUPPORT () {5;}' unless defined(&FA4_LINK_SUPPORT);
    eval 'sub FA4_SYMLINK_SUPPORT () {6;}' unless defined(&FA4_SYMLINK_SUPPORT);
    eval 'sub FA4_NAMED_ATTR () {7;}' unless defined(&FA4_NAMED_ATTR);
    eval 'sub FA4_FSID () {8;}' unless defined(&FA4_FSID);
    eval 'sub FA4_UNIQUE_HANDLES () {9;}' unless defined(&FA4_UNIQUE_HANDLES);
    eval 'sub FA4_LEASE_TIME () {10;}' unless defined(&FA4_LEASE_TIME);
    eval 'sub FA4_RDATTR_ERROR () {11;}' unless defined(&FA4_RDATTR_ERROR);
    eval 'sub FA4_ACL () {12;}' unless defined(&FA4_ACL);
    eval 'sub FA4_ACLSUPPORT () {13;}' unless defined(&FA4_ACLSUPPORT);
    eval 'sub FA4_ARCHIVE () {14;}' unless defined(&FA4_ARCHIVE);
    eval 'sub FA4_CANSETTIME () {15;}' unless defined(&FA4_CANSETTIME);
    eval 'sub FA4_CASE_INSENSITIVE () {16;}' unless defined(&FA4_CASE_INSENSITIVE);
    eval 'sub FA4_CASE_PRESERVING () {17;}' unless defined(&FA4_CASE_PRESERVING);
    eval 'sub FA4_CHOWN_RESTRICTED () {18;}' unless defined(&FA4_CHOWN_RESTRICTED);
    eval 'sub FA4_FILEHANDLE () {19;}' unless defined(&FA4_FILEHANDLE);
    eval 'sub FA4_FILEID () {20;}' unless defined(&FA4_FILEID);
    eval 'sub FA4_FILES_AVAIL () {21;}' unless defined(&FA4_FILES_AVAIL);
    eval 'sub FA4_FILES_FREE () {22;}' unless defined(&FA4_FILES_FREE);
    eval 'sub FA4_FILES_TOTAL () {23;}' unless defined(&FA4_FILES_TOTAL);
    eval 'sub FA4_FS_LOCATIONS () {24;}' unless defined(&FA4_FS_LOCATIONS);
    eval 'sub FA4_HIDDEN () {25;}' unless defined(&FA4_HIDDEN);
    eval 'sub FA4_HOMOGENEOUS () {26;}' unless defined(&FA4_HOMOGENEOUS);
    eval 'sub FA4_MAXFILESIZE () {27;}' unless defined(&FA4_MAXFILESIZE);
    eval 'sub FA4_MAXLINK () {28;}' unless defined(&FA4_MAXLINK);
    eval 'sub FA4_MAXNAME () {29;}' unless defined(&FA4_MAXNAME);
    eval 'sub FA4_MAXREAD () {30;}' unless defined(&FA4_MAXREAD);
    eval 'sub FA4_MAXWRITE () {31;}' unless defined(&FA4_MAXWRITE);
    eval 'sub FA4_MIMETYPE () {32;}' unless defined(&FA4_MIMETYPE);
    eval 'sub FA4_MODE () {33;}' unless defined(&FA4_MODE);
    eval 'sub FA4_NO_TRUNC () {34;}' unless defined(&FA4_NO_TRUNC);
    eval 'sub FA4_NUMLINKS () {35;}' unless defined(&FA4_NUMLINKS);
    eval 'sub FA4_OWNER () {36;}' unless defined(&FA4_OWNER);
    eval 'sub FA4_OWNER_GROUP () {37;}' unless defined(&FA4_OWNER_GROUP);
    eval 'sub FA4_QUOTA_HARD () {38;}' unless defined(&FA4_QUOTA_HARD);
    eval 'sub FA4_QUOTA_SOFT () {39;}' unless defined(&FA4_QUOTA_SOFT);
    eval 'sub FA4_QUOTA_USED () {40;}' unless defined(&FA4_QUOTA_USED);
    eval 'sub FA4_RAWDEV () {41;}' unless defined(&FA4_RAWDEV);
    eval 'sub FA4_SPACE_AVAIL () {42;}' unless defined(&FA4_SPACE_AVAIL);
    eval 'sub FA4_SPACE_FREE () {43;}' unless defined(&FA4_SPACE_FREE);
    eval 'sub FA4_SPACE_TOTAL () {44;}' unless defined(&FA4_SPACE_TOTAL);
    eval 'sub FA4_SPACE_USED () {45;}' unless defined(&FA4_SPACE_USED);
    eval 'sub FA4_SYSTEM () {46;}' unless defined(&FA4_SYSTEM);
    eval 'sub FA4_TIME_ACCESS () {47;}' unless defined(&FA4_TIME_ACCESS);
    eval 'sub FA4_TIME_ACCESS_SET () {48;}' unless defined(&FA4_TIME_ACCESS_SET);
    eval 'sub FA4_TIME_BACKUP () {49;}' unless defined(&FA4_TIME_BACKUP);
    eval 'sub FA4_TIME_CREATE () {50;}' unless defined(&FA4_TIME_CREATE);
    eval 'sub FA4_TIME_DELTA () {51;}' unless defined(&FA4_TIME_DELTA);
    eval 'sub FA4_TIME_METADATA () {52;}' unless defined(&FA4_TIME_METADATA);
    eval 'sub FA4_TIME_MODIFY () {53;}' unless defined(&FA4_TIME_MODIFY);
    eval 'sub FA4_TIME_MODIFY_SET () {54;}' unless defined(&FA4_TIME_MODIFY_SET);
    eval 'sub FA4_ATTR_MAX () {55;}' unless defined(&FA4_ATTR_MAX);
    eval 'sub FA4_SET {
        my($n, $p) = @_;
	    eval q((($p)[($n)/32] |= (1<< (($n) % 32))));
    }' unless defined(&FA4_SET);
    eval 'sub FA4_CLR {
        my($n, $p) = @_;
	    eval q((($p)[($n)/32] &= ~(1<< (($n) % 32))));
    }' unless defined(&FA4_CLR);
    eval 'sub FA4_ISSET {
        my($n, $p) = @_;
	    eval q((($p)[($n)/32] & (1<< (($n) % 32))));
    }' unless defined(&FA4_ISSET);
    eval 'sub FA4_ZERO {
        my($p) = @_;
	    eval q( &bzero(($p), 8));
    }' unless defined(&FA4_ZERO);
    eval 'sub FA4_SKIP {
        my($p) = @_;
	    eval q((($p) += 2));
    }' unless defined(&FA4_SKIP);
    eval 'sub sf_tsize () { ($sf_un->{sf_nfsv2}->{nfsv2sf_tsize});}' unless defined(&sf_tsize);
    eval 'sub sf_bsize () { ($sf_un->{sf_nfsv2}->{nfsv2sf_bsize});}' unless defined(&sf_bsize);
    eval 'sub sf_blocks () { ($sf_un->{sf_nfsv2}->{nfsv2sf_blocks});}' unless defined(&sf_blocks);
    eval 'sub sf_bfree () { ($sf_un->{sf_nfsv2}->{nfsv2sf_bfree});}' unless defined(&sf_bfree);
    eval 'sub sf_bavail () { ($sf_un->{sf_nfsv2}->{nfsv2sf_bavail});}' unless defined(&sf_bavail);
    eval 'sub sf_tbytes () { ($sf_un->{sf_nfsv3}->{nfsv3sf_tbytes});}' unless defined(&sf_tbytes);
    eval 'sub sf_fbytes () { ($sf_un->{sf_nfsv3}->{nfsv3sf_fbytes});}' unless defined(&sf_fbytes);
    eval 'sub sf_abytes () { ($sf_un->{sf_nfsv3}->{nfsv3sf_abytes});}' unless defined(&sf_abytes);
    eval 'sub sf_tfiles () { ($sf_un->{sf_nfsv3}->{nfsv3sf_tfiles});}' unless defined(&sf_tfiles);
    eval 'sub sf_ffiles () { ($sf_un->{sf_nfsv3}->{nfsv3sf_ffiles});}' unless defined(&sf_ffiles);
    eval 'sub sf_afiles () { ($sf_un->{sf_nfsv3}->{nfsv3sf_afiles});}' unless defined(&sf_afiles);
    eval 'sub sf_invarsec () { ($sf_un->{sf_nfsv3}->{nfsv3sf_invarsec});}' unless defined(&sf_invarsec);
}
1;
