require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFSSERVER_NFSM_SUBS_H_)) {
    eval 'sub _NFSSERVER_NFSM_SUBS_H_ () {1;}' unless defined(&_NFSSERVER_NFSM_SUBS_H_);
    require 'nfs/nfs_common.ph';
    eval 'sub nfstov_mode {
        my($a) = @_;
	    eval q(( &fxdr_unsigned( &u_int32_t, ($a)) &  &ALLPERMS));
    }' unless defined(&nfstov_mode);
    eval 'sub nfsm_srvstrsiz {
        my($s, $m) = @_;
	    eval q( &do { \'int\'  &t1;  &t1 =  &nfsm_srvstrsiz_xx(($s), ($m),  &md,  &dpos);  &if ( &t1) {  &error =  &t1;  &nfsm_reply(0); } }  &while (0));
    }' unless defined(&nfsm_srvstrsiz);
    eval 'sub nfsm_srvnamesiz {
        my($s) = @_;
	    eval q( &do { \'int\'  &t1;  &t1 =  &nfsm_srvnamesiz_xx(($s),  &NFS_MAXNAMLEN,  &md,  &dpos);  &if ( &t1) {  &error =  &t1;  &nfsm_reply(0); } }  &while (0));
    }' unless defined(&nfsm_srvnamesiz);
    eval 'sub nfsm_srvpathsiz {
        my($s) = @_;
	    eval q( &do { \'int\'  &t1;  &t1 =  &nfsm_srvnamesiz0_xx(($s),  &NFS_MAXPATHLEN,  &md,  &dpos);  &if ( &t1) {  &error =  &t1;  &nfsm_reply(0); } }  &while (0));
    }' unless defined(&nfsm_srvpathsiz);
    eval 'sub nfsm_srvmtofh {
        my($f) = @_;
	    eval q( &do { \'int\'  &t1;  &t1 =  &nfsm_srvmtofh_xx(($f),  ($n$fsd->{nd_flag}) &  &ND_NFSV3,  &md,  &dpos);  &if ( &t1) {  &error =  &t1;  &nfsm_reply(0); } }  &while (0));
    }' unless defined(&nfsm_srvmtofh);
    eval 'sub nfsm_srvsattr {
        my($a) = @_;
	    eval q( &do { \'int\'  &t1;  &t1 =  &nfsm_srvsattr_xx(($a),  &md,  &dpos);  &if ( &t1) {  &error =  &t1;  &m_freem( &mrep);  &mrep =  &NULL;  &goto  &nfsmout; } }  &while (0));
    }' unless defined(&nfsm_srvsattr);
    eval 'sub nfsm_reply {
        my($s) = @_;
	    eval q( &do {  &if ( &mrep !=  &NULL) {  &m_freem( &mrep);  &mrep =  &NULL; }  &mreq =  &nfs_rephead(($s),  &nfsd,  &error,  &mb,  &bpos); * &mrq =  &mreq;  &if ( &error ==  &EBADRPC) {  &error = 0;  &goto  &nfsmout; } }  &while (0));
    }' unless defined(&nfsm_reply);
    eval 'sub nfsm_writereply {
        my($s) = @_;
	    eval q( &do {  &mreq =  &nfs_rephead(($s),  &nfsd,  &error,  &mb,  &bpos); }  &while(0));
    }' unless defined(&nfsm_writereply);
    eval 'sub nfsm_srvfhtom {
        my($f, $v3) = @_;
	    eval q( &nfsm_srvfhtom_xx(($f), ($v3),  &mb,  &bpos));
    }' unless defined(&nfsm_srvfhtom);
    eval 'sub nfsm_srvpostop_fh {
        my($f) = @_;
	    eval q( &nfsm_srvpostop_fh_xx(($f),  &mb,  &bpos));
    }' unless defined(&nfsm_srvpostop_fh);
    eval 'sub nfsm_srvwcc_data {
        my($br, $b, $ar, $a) = @_;
	    eval q( &nfsm_srvwcc( &nfsd, ($br), ($b), ($ar), ($a),  &mb,  &bpos));
    }' unless defined(&nfsm_srvwcc_data);
    eval 'sub nfsm_srvpostop_attr {
        my($r, $a) = @_;
	    eval q( &nfsm_srvpostopattr( &nfsd, ($r), ($a),  &mb,  &bpos));
    }' unless defined(&nfsm_srvpostop_attr);
    eval 'sub nfsm_srvfillattr {
        my($a, $f) = @_;
	    eval q( &nfsm_srvfattr( &nfsd, ($a), ($f)));
    }' unless defined(&nfsm_srvfillattr);
    eval 'sub nfsm_clget () { &nfsm_clget_xx( &tl,  &mb,  &mp,  &bp,  &be,  &bpos);}' unless defined(&nfsm_clget);
}
1;
