require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__cplusplus)) {
}
unless(defined(&OPENSSL_DOING_MAKEDEPEND)) {
    unless(defined(&OPENSSL_NO_EC_NISTP_64_GCC_128)) {
	eval 'sub OPENSSL_NO_EC_NISTP_64_GCC_128 () {1;}' unless defined(&OPENSSL_NO_EC_NISTP_64_GCC_128);
    }
    unless(defined(&OPENSSL_NO_GMP)) {
	eval 'sub OPENSSL_NO_GMP () {1;}' unless defined(&OPENSSL_NO_GMP);
    }
    unless(defined(&OPENSSL_NO_JPAKE)) {
	eval 'sub OPENSSL_NO_JPAKE () {1;}' unless defined(&OPENSSL_NO_JPAKE);
    }
    unless(defined(&OPENSSL_NO_KRB5)) {
	eval 'sub OPENSSL_NO_KRB5 () {1;}' unless defined(&OPENSSL_NO_KRB5);
    }
    unless(defined(&OPENSSL_NO_LIBUNBOUND)) {
	eval 'sub OPENSSL_NO_LIBUNBOUND () {1;}' unless defined(&OPENSSL_NO_LIBUNBOUND);
    }
    unless(defined(&OPENSSL_NO_MD2)) {
	eval 'sub OPENSSL_NO_MD2 () {1;}' unless defined(&OPENSSL_NO_MD2);
    }
    unless(defined(&OPENSSL_NO_SCTP)) {
	eval 'sub OPENSSL_NO_SCTP () {1;}' unless defined(&OPENSSL_NO_SCTP);
    }
    unless(defined(&OPENSSL_NO_SSL_TRACE)) {
	eval 'sub OPENSSL_NO_SSL_TRACE () {1;}' unless defined(&OPENSSL_NO_SSL_TRACE);
    }
    unless(defined(&OPENSSL_NO_SSL2)) {
	eval 'sub OPENSSL_NO_SSL2 () {1;}' unless defined(&OPENSSL_NO_SSL2);
    }
    unless(defined(&OPENSSL_NO_STORE)) {
	eval 'sub OPENSSL_NO_STORE () {1;}' unless defined(&OPENSSL_NO_STORE);
    }
    unless(defined(&OPENSSL_NO_UNIT_TEST)) {
	eval 'sub OPENSSL_NO_UNIT_TEST () {1;}' unless defined(&OPENSSL_NO_UNIT_TEST);
    }
    unless(defined(&OPENSSL_NO_WEAK_SSL_CIPHERS)) {
	eval 'sub OPENSSL_NO_WEAK_SSL_CIPHERS () {1;}' unless defined(&OPENSSL_NO_WEAK_SSL_CIPHERS);
    }
}
unless(defined(&OPENSSL_THREADS)) {
    eval 'sub OPENSSL_THREADS () {1;}' unless defined(&OPENSSL_THREADS);
}
unless(defined(&OPENSSL_NO_STATIC_ENGINE)) {
    eval 'sub OPENSSL_NO_STATIC_ENGINE () {1;}' unless defined(&OPENSSL_NO_STATIC_ENGINE);
}
if(defined(&OPENSSL_ALGORITHM_DEFINES)) {
    if(defined(&OPENSSL_NO_EC_NISTP_64_GCC_128)  && !defined(&NO_EC_NISTP_64_GCC_128)) {
	eval 'sub NO_EC_NISTP_64_GCC_128 () {1;}' unless defined(&NO_EC_NISTP_64_GCC_128);
    }
    if(defined(&OPENSSL_NO_GMP)  && !defined(&NO_GMP)) {
	eval 'sub NO_GMP () {1;}' unless defined(&NO_GMP);
    }
    if(defined(&OPENSSL_NO_JPAKE)  && !defined(&NO_JPAKE)) {
	eval 'sub NO_JPAKE () {1;}' unless defined(&NO_JPAKE);
    }
    if(defined(&OPENSSL_NO_KRB5)  && !defined(&NO_KRB5)) {
	eval 'sub NO_KRB5 () {1;}' unless defined(&NO_KRB5);
    }
    if(defined(&OPENSSL_NO_LIBUNBOUND)  && !defined(&NO_LIBUNBOUND)) {
	eval 'sub NO_LIBUNBOUND () {1;}' unless defined(&NO_LIBUNBOUND);
    }
    if(defined(&OPENSSL_NO_MD2)  && !defined(&NO_MD2)) {
	eval 'sub NO_MD2 () {1;}' unless defined(&NO_MD2);
    }
    if(defined(&OPENSSL_NO_SCTP)  && !defined(&NO_SCTP)) {
	eval 'sub NO_SCTP () {1;}' unless defined(&NO_SCTP);
    }
    if(defined(&OPENSSL_NO_SSL_TRACE)  && !defined(&NO_SSL_TRACE)) {
	eval 'sub NO_SSL_TRACE () {1;}' unless defined(&NO_SSL_TRACE);
    }
    if(defined(&OPENSSL_NO_SSL2)  && !defined(&NO_SSL2)) {
	eval 'sub NO_SSL2 () {1;}' unless defined(&NO_SSL2);
    }
    if(defined(&OPENSSL_NO_STORE)  && !defined(&NO_STORE)) {
	eval 'sub NO_STORE () {1;}' unless defined(&NO_STORE);
    }
    if(defined(&OPENSSL_NO_UNIT_TEST)  && !defined(&NO_UNIT_TEST)) {
	eval 'sub NO_UNIT_TEST () {1;}' unless defined(&NO_UNIT_TEST);
    }
    if(defined(&OPENSSL_NO_WEAK_SSL_CIPHERS)  && !defined(&NO_WEAK_SSL_CIPHERS)) {
	eval 'sub NO_WEAK_SSL_CIPHERS () {1;}' unless defined(&NO_WEAK_SSL_CIPHERS);
    }
}
eval 'sub OPENSSL_CPUID_OBJ () {1;}' unless defined(&OPENSSL_CPUID_OBJ);
undef(&I386_ONLY) if defined(&I386_ONLY);
if(!(defined(&VMS) || defined(&__VMS)) ) {
    if(defined(&HEADER_CRYPTLIB_H)  && !defined(&OPENSSLDIR)) {
	eval 'sub ENGINESDIR () {"/usr/lib/engines";}' unless defined(&ENGINESDIR);
	eval 'sub OPENSSLDIR () {"/etc/ssl";}' unless defined(&OPENSSLDIR);
    }
}
undef(&OPENSSL_UNISTD) if defined(&OPENSSL_UNISTD);
eval 'sub OPENSSL_UNISTD () {< ($unistd->{h})>;}' unless defined(&OPENSSL_UNISTD);
undef(&OPENSSL_EXPORT_VAR_AS_FUNCTION) if defined(&OPENSSL_EXPORT_VAR_AS_FUNCTION);
if(defined(&HEADER_IDEA_H)  && !defined(&IDEA_INT)) {
    eval 'sub IDEA_INT () {\'unsigned int\';}' unless defined(&IDEA_INT);
}
if(defined(&HEADER_MD2_H)  && !defined(&MD2_INT)) {
    eval 'sub MD2_INT () {\'unsigned int\';}' unless defined(&MD2_INT);
}
if(defined(&HEADER_RC2_H)  && !defined(&RC2_INT)) {
    eval 'sub RC2_INT () {\'unsigned int\';}' unless defined(&RC2_INT);
}
if(defined(&HEADER_RC4_H)) {
    if(!defined(&RC4_INT)) {
	eval 'sub RC4_INT () {\'unsigned int\';}' unless defined(&RC4_INT);
    }
    if(!defined(&RC4_CHUNK)) {
	if(defined(&__LP64__)) {
	    eval 'sub RC4_CHUNK () {\'unsigned long\';}' unless defined(&RC4_CHUNK);
	} else {
	    undef(&RC4_CHUNK) if defined(&RC4_CHUNK);
	}
    }
}
if((defined(&HEADER_NEW_DES_H) || defined(&HEADER_DES_H))  && !defined(&DES_LONG)) {
    unless(defined(&DES_LONG)) {
	if(defined(&__LP64__)) {
	    eval 'sub DES_LONG () {\'unsigned int\';}' unless defined(&DES_LONG);
	} else {
	    eval 'sub DES_LONG () {\'unsigned long\';}' unless defined(&DES_LONG);
	}
    }
}
if(defined(&HEADER_BN_H)  && !defined(&CONFIG_HEADER_BN_H)) {
    eval 'sub CONFIG_HEADER_BN_H () {1;}' unless defined(&CONFIG_HEADER_BN_H);
    if(defined(&__LP64__)) {
	undef(&BN_LLONG) if defined(&BN_LLONG);
    } else {
	eval 'sub BN_LLONG () {1;}' unless defined(&BN_LLONG);
    }
    if(defined(&__LP64__)) {
	eval 'sub SIXTY_FOUR_BIT_LONG () {1;}' unless defined(&SIXTY_FOUR_BIT_LONG);
	undef(&SIXTY_FOUR_BIT) if defined(&SIXTY_FOUR_BIT);
	undef(&THIRTY_TWO_BIT) if defined(&THIRTY_TWO_BIT);
    } else {
	undef(&SIXTY_FOUR_BIT_LONG) if defined(&SIXTY_FOUR_BIT_LONG);
	undef(&SIXTY_FOUR_BIT) if defined(&SIXTY_FOUR_BIT);
	eval 'sub THIRTY_TWO_BIT () {1;}' unless defined(&THIRTY_TWO_BIT);
    }
}
if(defined(&HEADER_RC4_LOCL_H)  && !defined(&CONFIG_HEADER_RC4_LOCL_H)) {
    eval 'sub CONFIG_HEADER_RC4_LOCL_H () {1;}' unless defined(&CONFIG_HEADER_RC4_LOCL_H);
    if(defined(&__LP64__)) {
	undef(&RC4_INDEX) if defined(&RC4_INDEX);
    } else {
	eval 'sub RC4_INDEX () {1;}' unless defined(&RC4_INDEX);
    }
}
if(defined(&HEADER_BF_LOCL_H)  && !defined(&CONFIG_HEADER_BF_LOCL_H)) {
    eval 'sub CONFIG_HEADER_BF_LOCL_H () {1;}' unless defined(&CONFIG_HEADER_BF_LOCL_H);
    undef(&BF_PTR) if defined(&BF_PTR);
}
if(defined(&HEADER_DES_LOCL_H)  && !defined(&CONFIG_HEADER_DES_LOCL_H)) {
    eval 'sub CONFIG_HEADER_DES_LOCL_H () {1;}' unless defined(&CONFIG_HEADER_DES_LOCL_H);
    unless(defined(&DES_DEFAULT_OPTIONS)) {
	unless(defined(&DES_PTR)) {
	    if(defined(&__LP64__)) {
		undef(&DES_PTR) if defined(&DES_PTR);
	    } else {
		eval 'sub DES_PTR () {1;}' unless defined(&DES_PTR);
	    }
	}
	unless(defined(&DES_RISC1)) {
	    if(defined(&__LP64__)) {
		undef(&DES_RISC1) if defined(&DES_RISC1);
	    } else {
		eval 'sub DES_RISC1 () {1;}' unless defined(&DES_RISC1);
	    }
	}
	unless(defined(&DES_RISC2)) {
	    undef(&DES_RISC2) if defined(&DES_RISC2);
	}
	if(defined(&DES_RISC1)  && defined(&DES_RISC2)) {
	    die("YOU\ SHOULD\ NOT\ HAVE\ BOTH\ DES_RISC1\ AND\ DES_RISC2\ DEFINED\!\!\!\!\!");
	}
	unless(defined(&DES_UNROLL)) {
	    eval 'sub DES_UNROLL () {1;}' unless defined(&DES_UNROLL);
	}
	if(!defined(&DES_PTR)  && !defined(&DES_RISC1)  && !defined(&DES_RISC2)  && !defined(&DES_UNROLL)) {
	    if(defined( (defined(&__sun) ? &__sun : undef) ) || defined ( (defined(&sun) ? &sun : undef) ) ) {
		eval 'sub DES_PTR () {1;}' unless defined(&DES_PTR);
		eval 'sub DES_RISC1 () {1;}' unless defined(&DES_RISC1);
		eval 'sub DES_UNROLL () {1;}' unless defined(&DES_UNROLL);
	    }
 elsif(defined( (defined(&__ultrix) ? &__ultrix : undef) ) ) {
		eval 'sub DES_PTR () {1;}' unless defined(&DES_PTR);
		eval 'sub DES_RISC2 () {1;}' unless defined(&DES_RISC2);
		eval 'sub DES_UNROLL () {1;}' unless defined(&DES_UNROLL);
	    }
 elsif(defined( (defined(&__osf1__) ? &__osf1__ : undef) ) ) {
		eval 'sub DES_PTR () {1;}' unless defined(&DES_PTR);
		eval 'sub DES_RISC2 () {1;}' unless defined(&DES_RISC2);
	    }
 elsif(defined ( (defined(&_AIX) ? &_AIX : undef) ) ) {
	    }
 elsif(defined( (defined(&__hpux) ? &__hpux : undef) ) ) {
	    }
 elsif(defined( (defined(&__aux) ? &__aux : undef) ) ) {
	    }
 elsif(defined( (defined(&__dgux) ? &__dgux : undef) ) ) {
		eval 'sub DES_UNROLL () {1;}' unless defined(&DES_UNROLL);
	    }
 elsif(defined( (defined(&__sgi) ? &__sgi : undef) ) ) {
		eval 'sub DES_PTR () {1;}' unless defined(&DES_PTR);
		eval 'sub DES_RISC2 () {1;}' unless defined(&DES_RISC2);
		eval 'sub DES_UNROLL () {1;}' unless defined(&DES_UNROLL);
	    }
 elsif(defined(&i386) || defined(&__i386__) ) {
		eval 'sub DES_PTR () {1;}' unless defined(&DES_PTR);
		eval 'sub DES_RISC1 () {1;}' unless defined(&DES_RISC1);
		eval 'sub DES_UNROLL () {1;}' unless defined(&DES_UNROLL);
	    }
	}
    }
}
if(defined(&__cplusplus)) {
}
1;
