require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&lib_pcap_export_defs_h)) {
    eval 'sub lib_pcap_export_defs_h () {1;}' unless defined(&lib_pcap_export_defs_h);
    eval 'sub IS_AT_LEAST_GNUC_VERSION {
        my($major, $minor) = @_;
	    eval q((defined( &__GNUC__)  && ( &__GNUC__ > ($major) || ( &__GNUC__ == ($major)  &&  &__GNUC_MINOR__ >= ($minor)))));
    }' unless defined(&IS_AT_LEAST_GNUC_VERSION);
    if(defined(&_WIN32)) {
	if(defined(&BUILDING_PCAP)) {
	    eval 'sub PCAP_API_DEF () { &__declspec( &dllexport);}' unless defined(&PCAP_API_DEF);
	} else {
	    eval 'sub PCAP_API_DEF () { &__declspec( &dllimport);}' unless defined(&PCAP_API_DEF);
	}
    }
 elsif(defined(&MSDOS)) {
	eval 'sub PCAP_API_DEF () {1;}' unless defined(&PCAP_API_DEF);
    } else {
	if(defined(&BUILDING_PCAP)) {
	    if( &IS_AT_LEAST_GNUC_VERSION(3, 4)) {
		eval 'sub PCAP_API_DEF () { &__attribute__(( &visibility("default")));}' unless defined(&PCAP_API_DEF);
	    }
 elsif(defined(&__SUNPRO_C)  && ((defined(&__SUNPRO_C) ? &__SUNPRO_C : undef) >= 0x550)) {
		eval 'sub PCAP_API_DEF () { &__global;}' unless defined(&PCAP_API_DEF);
	    } else {
		eval 'sub PCAP_API_DEF () {1;}' unless defined(&PCAP_API_DEF);
	    }
	} else {
	    eval 'sub PCAP_API_DEF () {1;}' unless defined(&PCAP_API_DEF);
	}
    }
    eval 'sub PCAP_API () { &PCAP_API_DEF  &extern;}' unless defined(&PCAP_API);
}
1;
