require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SECURITY_AUDIT_PRIVATE_H_)) {
    eval 'sub _SECURITY_AUDIT_PRIVATE_H_ () {1;}' unless defined(&_SECURITY_AUDIT_PRIVATE_H_);
    unless(defined(&_KERNEL)) {
	die("no user-serviceable parts inside");
    }
    require 'sys/caprights.ph';
    require 'sys/ipc.ph';
    require 'sys/socket.ph';
    require 'sys/ucred.ph';
    if(defined(&MALLOC_DECLARE)) {
    }
    eval 'sub BSM_SUCCESS () {0;}' unless defined(&BSM_SUCCESS);
    eval 'sub BSM_FAILURE () {1;}' unless defined(&BSM_FAILURE);
    eval 'sub BSM_NOAUDIT () {2;}' unless defined(&BSM_NOAUDIT);
    eval 'sub AR_COMMIT_KERNEL () {0x1;}' unless defined(&AR_COMMIT_KERNEL);
    eval 'sub AR_COMMIT_USER () {0x10;}' unless defined(&AR_COMMIT_USER);
    eval 'sub AR_PRESELECT_TRAIL () {0x1000;}' unless defined(&AR_PRESELECT_TRAIL);
    eval 'sub AR_PRESELECT_PIPE () {0x2000;}' unless defined(&AR_PRESELECT_PIPE);
    eval 'sub AR_PRESELECT_USER_TRAIL () {0x4000;}' unless defined(&AR_PRESELECT_USER_TRAIL);
    eval 'sub AR_PRESELECT_USER_PIPE () {0x8000;}' unless defined(&AR_PRESELECT_USER_PIPE);
    eval 'sub ARG_EUID () {0x1;}' unless defined(&ARG_EUID);
    eval 'sub ARG_RUID () {0x2;}' unless defined(&ARG_RUID);
    eval 'sub ARG_SUID () {0x4;}' unless defined(&ARG_SUID);
    eval 'sub ARG_EGID () {0x8;}' unless defined(&ARG_EGID);
    eval 'sub ARG_RGID () {0x10;}' unless defined(&ARG_RGID);
    eval 'sub ARG_SGID () {0x20;}' unless defined(&ARG_SGID);
    eval 'sub ARG_PID () {0x40;}' unless defined(&ARG_PID);
    eval 'sub ARG_UID () {0x80;}' unless defined(&ARG_UID);
    eval 'sub ARG_AUID () {0x100;}' unless defined(&ARG_AUID);
    eval 'sub ARG_GID () {0x200;}' unless defined(&ARG_GID);
    eval 'sub ARG_FD () {0x400;}' unless defined(&ARG_FD);
    eval 'sub ARG_POSIX_IPC_PERM () {0x800;}' unless defined(&ARG_POSIX_IPC_PERM);
    eval 'sub ARG_FFLAGS () {0x1000;}' unless defined(&ARG_FFLAGS);
    eval 'sub ARG_MODE () {0x2000;}' unless defined(&ARG_MODE);
    eval 'sub ARG_DEV () {0x4000;}' unless defined(&ARG_DEV);
    eval 'sub ARG_ADDR () {0x8000;}' unless defined(&ARG_ADDR);
    eval 'sub ARG_LEN () {0x10000;}' unless defined(&ARG_LEN);
    eval 'sub ARG_MASK () {0x20000;}' unless defined(&ARG_MASK);
    eval 'sub ARG_SIGNUM () {0x40000;}' unless defined(&ARG_SIGNUM);
    eval 'sub ARG_LOGIN () {0x80000;}' unless defined(&ARG_LOGIN);
    eval 'sub ARG_SADDRINET () {0x100000;}' unless defined(&ARG_SADDRINET);
    eval 'sub ARG_SADDRINET6 () {0x200000;}' unless defined(&ARG_SADDRINET6);
    eval 'sub ARG_SADDRUNIX () {0x400000;}' unless defined(&ARG_SADDRUNIX);
    eval 'sub ARG_TERMID_ADDR () {0x400000;}' unless defined(&ARG_TERMID_ADDR);
    eval 'sub ARG_UNUSED2 () {0x1000000;}' unless defined(&ARG_UNUSED2);
    eval 'sub ARG_UPATH1 () {0x2000000;}' unless defined(&ARG_UPATH1);
    eval 'sub ARG_UPATH2 () {0x4000000;}' unless defined(&ARG_UPATH2);
    eval 'sub ARG_TEXT () {0x8000000;}' unless defined(&ARG_TEXT);
    eval 'sub ARG_VNODE1 () {0x10000000;}' unless defined(&ARG_VNODE1);
    eval 'sub ARG_VNODE2 () {0x20000000;}' unless defined(&ARG_VNODE2);
    eval 'sub ARG_SVIPC_CMD () {0x40000000;}' unless defined(&ARG_SVIPC_CMD);
    eval 'sub ARG_SVIPC_PERM () {0x80000000;}' unless defined(&ARG_SVIPC_PERM);
    eval 'sub ARG_SVIPC_ID () {0x100000000;}' unless defined(&ARG_SVIPC_ID);
    eval 'sub ARG_SVIPC_ADDR () {0x200000000;}' unless defined(&ARG_SVIPC_ADDR);
    eval 'sub ARG_GROUPSET () {0x400000000;}' unless defined(&ARG_GROUPSET);
    eval 'sub ARG_CMD () {0x800000000;}' unless defined(&ARG_CMD);
    eval 'sub ARG_SOCKINFO () {0x1000000000;}' unless defined(&ARG_SOCKINFO);
    eval 'sub ARG_ASID () {0x2000000000;}' unless defined(&ARG_ASID);
    eval 'sub ARG_TERMID () {0x4000000000;}' unless defined(&ARG_TERMID);
    eval 'sub ARG_AUDITON () {0x8000000000;}' unless defined(&ARG_AUDITON);
    eval 'sub ARG_VALUE () {0x10000000000;}' unless defined(&ARG_VALUE);
    eval 'sub ARG_AMASK () {0x20000000000;}' unless defined(&ARG_AMASK);
    eval 'sub ARG_CTLNAME () {0x40000000000;}' unless defined(&ARG_CTLNAME);
    eval 'sub ARG_PROCESS () {0x80000000000;}' unless defined(&ARG_PROCESS);
    eval 'sub ARG_MACHPORT1 () {0x100000000000;}' unless defined(&ARG_MACHPORT1);
    eval 'sub ARG_MACHPORT2 () {0x200000000000;}' unless defined(&ARG_MACHPORT2);
    eval 'sub ARG_EXIT () {0x400000000000;}' unless defined(&ARG_EXIT);
    eval 'sub ARG_IOVECSTR () {0x800000000000;}' unless defined(&ARG_IOVECSTR);
    eval 'sub ARG_ARGV () {0x1000000000000;}' unless defined(&ARG_ARGV);
    eval 'sub ARG_ENVV () {0x2000000000000;}' unless defined(&ARG_ENVV);
    eval 'sub ARG_ATFD1 () {0x4000000000000;}' unless defined(&ARG_ATFD1);
    eval 'sub ARG_ATFD2 () {0x8000000000000;}' unless defined(&ARG_ATFD2);
    eval 'sub ARG_RIGHTS () {0x10000000000000;}' unless defined(&ARG_RIGHTS);
    eval 'sub ARG_FCNTL_RIGHTS () {0x20000000000000;}' unless defined(&ARG_FCNTL_RIGHTS);
    eval 'sub ARG_NONE () {0x;}' unless defined(&ARG_NONE);
    eval 'sub ARG_ALL () {0xffffffffffffffff;}' unless defined(&ARG_ALL);
    eval 'sub ARG_IS_VALID {
        my($kar, $arg) = @_;
	    eval q((($kar)-> ($k_ar->{ar_valid_arg}) & ($arg)));
    }' unless defined(&ARG_IS_VALID);
    eval 'sub ARG_SET_VALID {
        my($kar, $arg) = @_;
	    eval q( &do { ($kar)-> ($k_ar->{ar_valid_arg}) |= ($arg); }  &while (0));
    }' unless defined(&ARG_SET_VALID);
    eval 'sub ARG_CLEAR_VALID {
        my($kar, $arg) = @_;
	    eval q( &do { ($kar)-> ($k_ar->{ar_valid_arg}) &= ~($arg); }  &while (0));
    }' unless defined(&ARG_CLEAR_VALID);
    eval 'sub AU_PRS_SUCCESS () {1;}' unless defined(&AU_PRS_SUCCESS);
    eval 'sub AU_PRS_FAILURE () {2;}' unless defined(&AU_PRS_FAILURE);
    eval 'sub AU_PRS_BOTH () {( &AU_PRS_SUCCESS| &AU_PRS_FAILURE);}' unless defined(&AU_PRS_BOTH);
    eval 'sub AUDIT_OPEN_FLAGS () {( &FWRITE |  &O_APPEND);}' unless defined(&AUDIT_OPEN_FLAGS);
    eval 'sub AUDIT_CLOSE_FLAGS () {( &FWRITE |  &O_APPEND);}' unless defined(&AUDIT_CLOSE_FLAGS);
    require 'sys/fcntl.ph';
    require 'sys/kernel.ph';
    require 'sys/malloc.ph';
}
1;
