require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_PMAP_VM_)) {
    eval 'sub _PMAP_VM_ () {1;}' unless defined(&_PMAP_VM_);
    require 'machine/pmap.ph';
    if(defined(&_KERNEL)) {
	eval 'sub PMAP_ENTER_NOSLEEP () {0x100;}' unless defined(&PMAP_ENTER_NOSLEEP);
	eval 'sub PMAP_ENTER_WIRED () {0x200;}' unless defined(&PMAP_ENTER_WIRED);
	eval 'sub PMAP_ENTER_RESERVED () {0xff000000;}' unless defined(&PMAP_ENTER_RESERVED);
	eval 'sub PMAP_TS_REFERENCED_MAX () {5;}' unless defined(&PMAP_TS_REFERENCED_MAX);
	eval 'sub pmap_resident_count {
	    my($pm) = @_;
    	    eval q((($pm)-> ($pm_stats->{resident_count})));
	}' unless defined(&pmap_resident_count);
	eval 'sub pmap_wired_count {
	    my($pm) = @_;
    	    eval q((($pm)-> ($pm_stats->{wired_count})));
	}' unless defined(&pmap_wired_count);
    }
}
1;
