require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&VM_H)) {
    eval 'sub VM_H () {1;}' unless defined(&VM_H);
    require 'machine/vm.ph';
    eval 'sub VM_INHERIT_SHARE () {(( &vm_inherit_t) 0);}' unless defined(&VM_INHERIT_SHARE);
    eval 'sub VM_INHERIT_COPY () {(( &vm_inherit_t) 1);}' unless defined(&VM_INHERIT_COPY);
    eval 'sub VM_INHERIT_NONE () {(( &vm_inherit_t) 2);}' unless defined(&VM_INHERIT_NONE);
    eval 'sub VM_INHERIT_ZERO () {(( &vm_inherit_t) 3);}' unless defined(&VM_INHERIT_ZERO);
    eval 'sub VM_INHERIT_DEFAULT () { &VM_INHERIT_COPY;}' unless defined(&VM_INHERIT_DEFAULT);
    eval 'sub VM_PROT_NONE () {(( &vm_prot_t) 0x);}' unless defined(&VM_PROT_NONE);
    eval 'sub VM_PROT_READ () {(( &vm_prot_t) 0x1);}' unless defined(&VM_PROT_READ);
    eval 'sub VM_PROT_WRITE () {(( &vm_prot_t) 0x2);}' unless defined(&VM_PROT_WRITE);
    eval 'sub VM_PROT_EXECUTE () {(( &vm_prot_t) 0x4);}' unless defined(&VM_PROT_EXECUTE);
    eval 'sub VM_PROT_COPY () {(( &vm_prot_t) 0x8);}' unless defined(&VM_PROT_COPY);
    eval 'sub VM_PROT_PRIV_FLAG () {(( &vm_prot_t) 0x10);}' unless defined(&VM_PROT_PRIV_FLAG);
    eval 'sub VM_PROT_FAULT_LOOKUP () { &VM_PROT_PRIV_FLAG;}' unless defined(&VM_PROT_FAULT_LOOKUP);
    eval 'sub VM_PROT_QUICK_NOFAULT () { &VM_PROT_PRIV_FLAG;}' unless defined(&VM_PROT_QUICK_NOFAULT);
    eval 'sub VM_PROT_ALL () {( &VM_PROT_READ| &VM_PROT_WRITE| &VM_PROT_EXECUTE);}' unless defined(&VM_PROT_ALL);
    eval 'sub VM_PROT_RW () {( &VM_PROT_READ| &VM_PROT_WRITE);}' unless defined(&VM_PROT_RW);
    eval 'sub VM_PROT_DEFAULT () { &VM_PROT_ALL;}' unless defined(&VM_PROT_DEFAULT);
    eval("sub OBJT_DEFAULT () { 0; }") unless defined(&OBJT_DEFAULT);
    eval("sub OBJT_SWAP () { 1; }") unless defined(&OBJT_SWAP);
    eval("sub OBJT_VNODE () { 2; }") unless defined(&OBJT_VNODE);
    eval("sub OBJT_DEVICE () { 3; }") unless defined(&OBJT_DEVICE);
    eval("sub OBJT_PHYS () { 4; }") unless defined(&OBJT_PHYS);
    eval("sub OBJT_DEAD () { 5; }") unless defined(&OBJT_DEAD);
    eval("sub OBJT_SG () { 6; }") unless defined(&OBJT_SG);
    eval("sub OBJT_MGTDEVICE () { 7; }") unless defined(&OBJT_MGTDEVICE);
    unless(defined(&_KERNEL)) {
    }
}
1;
