require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_VM_PAGER_)) {
    eval 'sub _VM_PAGER_ () {1;}' unless defined(&_VM_PAGER_);
    require 'sys/queue.ph';
    eval 'sub VM_PAGER_OK () {0;}' unless defined(&VM_PAGER_OK);
    eval 'sub VM_PAGER_BAD () {1;}' unless defined(&VM_PAGER_BAD);
    eval 'sub VM_PAGER_FAIL () {2;}' unless defined(&VM_PAGER_FAIL);
    eval 'sub VM_PAGER_PEND () {3;}' unless defined(&VM_PAGER_PEND);
    eval 'sub VM_PAGER_ERROR () {4;}' unless defined(&VM_PAGER_ERROR);
    eval 'sub VM_PAGER_AGAIN () {5;}' unless defined(&VM_PAGER_AGAIN);
    eval 'sub VM_PAGER_PUT_SYNC () {0x1;}' unless defined(&VM_PAGER_PUT_SYNC);
    eval 'sub VM_PAGER_PUT_INVAL () {0x2;}' unless defined(&VM_PAGER_PUT_INVAL);
    eval 'sub VM_PAGER_PUT_NOREUSE () {0x4;}' unless defined(&VM_PAGER_PUT_NOREUSE);
    eval 'sub VM_PAGER_CLUSTER_OK () {0x8;}' unless defined(&VM_PAGER_CLUSTER_OK);
    if(defined(&_KERNEL)) {
	eval 'sub vm_pager_put_pages {
	    my($object,$m,$count,$flags,$rtvals) = @_;
    	    eval q({  &VM_OBJECT_ASSERT_WLOCKED($object); (* ($pagertab[$object->{type]}->{pgo_putpages})) ($object, $m, $count, $flags, $rtvals); });
	}' unless defined(&vm_pager_put_pages);
	eval 'sub vm_pager_populate {
	    my($object,$pidx,$fault_type,$max_prot,$first,$last) = @_;
    	    eval q({  &MPASS(( ($object->{flags}) &  &OBJ_POPULATE) != 0);  &MPASS($pidx <  ($object->{size}));  &MPASS( ($object->{paging_in_progress}) > 0); ((* ($pagertab[$object->{type]}->{pgo_populate}))($object, $pidx, $fault_type, $max_prot, $first, $last)); });
	}' unless defined(&vm_pager_populate);
    }
}
1;
