require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_VM_PARAM_)) {
    eval 'sub _VM_PARAM_ () {1;}' unless defined(&_VM_PARAM_);
    require 'machine/vmparam.ph';
    eval 'sub VM_TOTAL () {1;}' unless defined(&VM_TOTAL);
    eval 'sub VM_METER () { &VM_TOTAL;}' unless defined(&VM_METER);
    eval 'sub VM_LOADAVG () {2;}' unless defined(&VM_LOADAVG);
    eval 'sub VM_V_FREE_MIN () {3;}' unless defined(&VM_V_FREE_MIN);
    eval 'sub VM_V_FREE_TARGET () {4;}' unless defined(&VM_V_FREE_TARGET);
    eval 'sub VM_V_FREE_RESERVED () {5;}' unless defined(&VM_V_FREE_RESERVED);
    eval 'sub VM_V_INACTIVE_TARGET () {6;}' unless defined(&VM_V_INACTIVE_TARGET);
    eval 'sub VM_OBSOLETE_7 () {7;}' unless defined(&VM_OBSOLETE_7);
    eval 'sub VM_OBSOLETE_8 () {8;}' unless defined(&VM_OBSOLETE_8);
    eval 'sub VM_V_PAGEOUT_FREE_MIN () {9;}' unless defined(&VM_V_PAGEOUT_FREE_MIN);
    eval 'sub VM_OBSOLETE_10 () {10;}' unless defined(&VM_OBSOLETE_10);
    eval 'sub VM_SWAPPING_ENABLED () {11;}' unless defined(&VM_SWAPPING_ENABLED);
    eval 'sub VM_OVERCOMMIT () {12;}' unless defined(&VM_OVERCOMMIT);
    eval 'sub VM_MAXID () {13;}' unless defined(&VM_MAXID);
    eval 'sub XSWDEV_VERSION () {1;}' unless defined(&XSWDEV_VERSION);
    eval 'sub KERN_SUCCESS () {0;}' unless defined(&KERN_SUCCESS);
    eval 'sub KERN_INVALID_ADDRESS () {1;}' unless defined(&KERN_INVALID_ADDRESS);
    eval 'sub KERN_PROTECTION_FAILURE () {2;}' unless defined(&KERN_PROTECTION_FAILURE);
    eval 'sub KERN_NO_SPACE () {3;}' unless defined(&KERN_NO_SPACE);
    eval 'sub KERN_INVALID_ARGUMENT () {4;}' unless defined(&KERN_INVALID_ARGUMENT);
    eval 'sub KERN_FAILURE () {5;}' unless defined(&KERN_FAILURE);
    eval 'sub KERN_RESOURCE_SHORTAGE () {6;}' unless defined(&KERN_RESOURCE_SHORTAGE);
    eval 'sub KERN_NOT_RECEIVER () {7;}' unless defined(&KERN_NOT_RECEIVER);
    eval 'sub KERN_NO_ACCESS () {8;}' unless defined(&KERN_NO_ACCESS);
    unless(defined(&PA_LOCK_COUNT)) {
	if(defined(&SMP)) {
	    eval 'sub PA_LOCK_COUNT () {32;}' unless defined(&PA_LOCK_COUNT);
	} else {
	    eval 'sub PA_LOCK_COUNT () {1;}' unless defined(&PA_LOCK_COUNT);
	}
    }
    unless(defined(&ASSEMBLER)) {
	if(defined(&_KERNEL)) {
	    eval 'sub num_pages {
	        my($x) = @_;
    		eval q((( &vm_offset_t)(((( &vm_offset_t)($x)) +  &PAGE_MASK) >>  &PAGE_SHIFT)));
	    }' unless defined(&num_pages);
	}
    }
}
1;
