require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_VM_RADIX_H_)) {
    eval 'sub _VM_RADIX_H_ () {1;}' unless defined(&_VM_RADIX_H_);
    require 'vm/_vm_radix.ph';
    if(defined(&_KERNEL)) {
	eval 'sub vm_radix_init {
	    my($rtree) = @_;
    	    eval q({  ($rtree->{rt_root}) = 0; });
	}' unless defined(&vm_radix_init);
	eval 'sub vm_radix_is_empty {
	    my($rtree) = @_;
    	    eval q({ ( ($rtree->{rt_root}) == 0); });
	}' unless defined(&vm_radix_is_empty);
    }
}
1;
