require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_APICREG_H_)) {
    eval 'sub _X86_APICREG_H_ () {1;}' unless defined(&_X86_APICREG_H_);
    unless(defined(&LOCORE)) {
	require 'sys/types.ph';
	eval 'sub PAD3 () {\'int\' : 32; \'int\' : 32; \'int\' : 32;}' unless defined(&PAD3);
	eval 'sub PAD4 () {\'int\' : 32; \'int\' : 32; \'int\' : 32; \'int\' : 32;}' unless defined(&PAD4);
	eval("sub LAPIC_ID () { 0x2; }") unless defined(&LAPIC_ID);
	eval("sub LAPIC_VERSION () { 0x3; }") unless defined(&LAPIC_VERSION);
	eval("sub LAPIC_TPR () { 0x8; }") unless defined(&LAPIC_TPR);
	eval("sub LAPIC_APR () { 0x9; }") unless defined(&LAPIC_APR);
	eval("sub LAPIC_PPR () { 0xa; }") unless defined(&LAPIC_PPR);
	eval("sub LAPIC_EOI () { 0xb; }") unless defined(&LAPIC_EOI);
	eval("sub LAPIC_LDR () { 0xd; }") unless defined(&LAPIC_LDR);
	eval("sub LAPIC_DFR () { 0xe; }") unless defined(&LAPIC_DFR);
	eval("sub LAPIC_SVR () { 0xf; }") unless defined(&LAPIC_SVR);
	eval("sub LAPIC_ISR0 () { 0x10; }") unless defined(&LAPIC_ISR0);
	eval("sub LAPIC_ISR1 () { 0x11; }") unless defined(&LAPIC_ISR1);
	eval("sub LAPIC_ISR2 () { 0x12; }") unless defined(&LAPIC_ISR2);
	eval("sub LAPIC_ISR3 () { 0x13; }") unless defined(&LAPIC_ISR3);
	eval("sub LAPIC_ISR4 () { 0x14; }") unless defined(&LAPIC_ISR4);
	eval("sub LAPIC_ISR5 () { 0x15; }") unless defined(&LAPIC_ISR5);
	eval("sub LAPIC_ISR6 () { 0x16; }") unless defined(&LAPIC_ISR6);
	eval("sub LAPIC_ISR7 () { 0x17; }") unless defined(&LAPIC_ISR7);
	eval("sub LAPIC_TMR0 () { 0x18; }") unless defined(&LAPIC_TMR0);
	eval("sub LAPIC_TMR1 () { 0x19; }") unless defined(&LAPIC_TMR1);
	eval("sub LAPIC_TMR2 () { 0x1a; }") unless defined(&LAPIC_TMR2);
	eval("sub LAPIC_TMR3 () { 0x1b; }") unless defined(&LAPIC_TMR3);
	eval("sub LAPIC_TMR4 () { 0x1c; }") unless defined(&LAPIC_TMR4);
	eval("sub LAPIC_TMR5 () { 0x1d; }") unless defined(&LAPIC_TMR5);
	eval("sub LAPIC_TMR6 () { 0x1e; }") unless defined(&LAPIC_TMR6);
	eval("sub LAPIC_TMR7 () { 0x1f; }") unless defined(&LAPIC_TMR7);
	eval("sub LAPIC_IRR0 () { 0x20; }") unless defined(&LAPIC_IRR0);
	eval("sub LAPIC_IRR1 () { 0x21; }") unless defined(&LAPIC_IRR1);
	eval("sub LAPIC_IRR2 () { 0x22; }") unless defined(&LAPIC_IRR2);
	eval("sub LAPIC_IRR3 () { 0x23; }") unless defined(&LAPIC_IRR3);
	eval("sub LAPIC_IRR4 () { 0x24; }") unless defined(&LAPIC_IRR4);
	eval("sub LAPIC_IRR5 () { 0x25; }") unless defined(&LAPIC_IRR5);
	eval("sub LAPIC_IRR6 () { 0x26; }") unless defined(&LAPIC_IRR6);
	eval("sub LAPIC_IRR7 () { 0x27; }") unless defined(&LAPIC_IRR7);
	eval("sub LAPIC_ESR () { 0x28; }") unless defined(&LAPIC_ESR);
	eval("sub LAPIC_LVT_CMCI () { 0x2f; }") unless defined(&LAPIC_LVT_CMCI);
	eval("sub LAPIC_ICR_LO () { 0x30; }") unless defined(&LAPIC_ICR_LO);
	eval("sub LAPIC_ICR_HI () { 0x31; }") unless defined(&LAPIC_ICR_HI);
	eval("sub LAPIC_LVT_TIMER () { 0x32; }") unless defined(&LAPIC_LVT_TIMER);
	eval("sub LAPIC_LVT_THERMAL () { 0x33; }") unless defined(&LAPIC_LVT_THERMAL);
	eval("sub LAPIC_LVT_PCINT () { 0x34; }") unless defined(&LAPIC_LVT_PCINT);
	eval("sub LAPIC_LVT_LINT0 () { 0x35; }") unless defined(&LAPIC_LVT_LINT0);
	eval("sub LAPIC_LVT_LINT1 () { 0x36; }") unless defined(&LAPIC_LVT_LINT1);
	eval("sub LAPIC_LVT_ERROR () { 0x37; }") unless defined(&LAPIC_LVT_ERROR);
	eval("sub LAPIC_ICR_TIMER () { 0x38; }") unless defined(&LAPIC_ICR_TIMER);
	eval("sub LAPIC_CCR_TIMER () { 0x39; }") unless defined(&LAPIC_CCR_TIMER);
	eval("sub LAPIC_DCR_TIMER () { 0x3e; }") unless defined(&LAPIC_DCR_TIMER);
	eval("sub LAPIC_SELF_IPI () { 0x3f; }") unless defined(&LAPIC_SELF_IPI);
	eval("sub LAPIC_EXT_FEATURES () { 0x40; }") unless defined(&LAPIC_EXT_FEATURES);
	eval("sub LAPIC_EXT_CTRL () { 0x41; }") unless defined(&LAPIC_EXT_CTRL);
	eval("sub LAPIC_EXT_SEOI () { 0x42; }") unless defined(&LAPIC_EXT_SEOI);
	eval("sub LAPIC_EXT_IER0 () { 0x48; }") unless defined(&LAPIC_EXT_IER0);
	eval("sub LAPIC_EXT_IER1 () { 0x49; }") unless defined(&LAPIC_EXT_IER1);
	eval("sub LAPIC_EXT_IER2 () { 0x4a; }") unless defined(&LAPIC_EXT_IER2);
	eval("sub LAPIC_EXT_IER3 () { 0x4b; }") unless defined(&LAPIC_EXT_IER3);
	eval("sub LAPIC_EXT_IER4 () { 0x4c; }") unless defined(&LAPIC_EXT_IER4);
	eval("sub LAPIC_EXT_IER5 () { 0x4d; }") unless defined(&LAPIC_EXT_IER5);
	eval("sub LAPIC_EXT_IER6 () { 0x4e; }") unless defined(&LAPIC_EXT_IER6);
	eval("sub LAPIC_EXT_IER7 () { 0x4f; }") unless defined(&LAPIC_EXT_IER7);
	eval("sub LAPIC_EXT_LVT0 () { 0x50; }") unless defined(&LAPIC_EXT_LVT0);
	eval("sub LAPIC_EXT_LVT1 () { 0x51; }") unless defined(&LAPIC_EXT_LVT1);
	eval("sub LAPIC_EXT_LVT2 () { 0x52; }") unless defined(&LAPIC_EXT_LVT2);
	eval("sub LAPIC_EXT_LVT3 () { 0x53; }") unless defined(&LAPIC_EXT_LVT3);
	eval 'sub LAPIC_MEM_MUL () {0x10;}' unless defined(&LAPIC_MEM_MUL);
	eval 'sub LAPIC_MEM_REGION () {(( &LAPIC_EXT_LVT3 + 1) *  &LAPIC_MEM_MUL);}' unless defined(&LAPIC_MEM_REGION);
	undef(&PAD4) if defined(&PAD4);
	undef(&PAD3) if defined(&PAD3);
    }
    eval 'sub DEFAULT_APIC_BASE () {0xfee00000;}' unless defined(&DEFAULT_APIC_BASE);
    eval 'sub APIC_ID_MASK () {0xff000000;}' unless defined(&APIC_ID_MASK);
    eval 'sub APIC_ID_SHIFT () {24;}' unless defined(&APIC_ID_SHIFT);
    eval 'sub APIC_ID_CLUSTER () {0xf0;}' unless defined(&APIC_ID_CLUSTER);
    eval 'sub APIC_ID_CLUSTER_ID () {0xf;}' unless defined(&APIC_ID_CLUSTER_ID);
    eval 'sub APIC_MAX_CLUSTER () {0xe;}' unless defined(&APIC_MAX_CLUSTER);
    eval 'sub APIC_MAX_INTRACLUSTER_ID () {3;}' unless defined(&APIC_MAX_INTRACLUSTER_ID);
    eval 'sub APIC_ID_CLUSTER_SHIFT () {4;}' unless defined(&APIC_ID_CLUSTER_SHIFT);
    eval 'sub APIC_VER_VERSION () {0xff;}' unless defined(&APIC_VER_VERSION);
    eval 'sub APIC_VER_MAXLVT () {0xff0000;}' unless defined(&APIC_VER_MAXLVT);
    eval 'sub MAXLVTSHIFT () {16;}' unless defined(&MAXLVTSHIFT);
    eval 'sub APIC_VER_EOI_SUPPRESSION () {0x1000000;}' unless defined(&APIC_VER_EOI_SUPPRESSION);
    eval 'sub APIC_VER_AMD_EXT_SPACE () {0x80000000;}' unless defined(&APIC_VER_AMD_EXT_SPACE);
    eval 'sub APIC_LDR_RESERVED () {0xffffff;}' unless defined(&APIC_LDR_RESERVED);
    eval 'sub APIC_DFR_RESERVED () {0xfffffff;}' unless defined(&APIC_DFR_RESERVED);
    eval 'sub APIC_DFR_MODEL_MASK () {0xf0000000;}' unless defined(&APIC_DFR_MODEL_MASK);
    eval 'sub APIC_DFR_MODEL_FLAT () {0xf0000000;}' unless defined(&APIC_DFR_MODEL_FLAT);
    eval 'sub APIC_DFR_MODEL_CLUSTER () {0x;}' unless defined(&APIC_DFR_MODEL_CLUSTER);
    eval 'sub APIC_SVR_VECTOR () {0xff;}' unless defined(&APIC_SVR_VECTOR);
    eval 'sub APIC_SVR_VEC_PROG () {0xf0;}' unless defined(&APIC_SVR_VEC_PROG);
    eval 'sub APIC_SVR_VEC_FIX () {0xf;}' unless defined(&APIC_SVR_VEC_FIX);
    eval 'sub APIC_SVR_ENABLE () {0x100;}' unless defined(&APIC_SVR_ENABLE);
    eval 'sub APIC_SVR_SWDIS () {0x;}' unless defined(&APIC_SVR_SWDIS);
    eval 'sub APIC_SVR_SWEN () {0x100;}' unless defined(&APIC_SVR_SWEN);
    eval 'sub APIC_SVR_FOCUS () {0x200;}' unless defined(&APIC_SVR_FOCUS);
    eval 'sub APIC_SVR_FEN () {0x;}' unless defined(&APIC_SVR_FEN);
    eval 'sub APIC_SVR_FDIS () {0x200;}' unless defined(&APIC_SVR_FDIS);
    eval 'sub APIC_SVR_EOI_SUPPRESSION () {0x1000;}' unless defined(&APIC_SVR_EOI_SUPPRESSION);
    eval 'sub APIC_TPR_PRIO () {0xff;}' unless defined(&APIC_TPR_PRIO);
    eval 'sub APIC_TPR_INT () {0xf0;}' unless defined(&APIC_TPR_INT);
    eval 'sub APIC_TPR_SUB () {0xf;}' unless defined(&APIC_TPR_SUB);
    eval 'sub APIC_ESR_SEND_CS_ERROR () {0x1;}' unless defined(&APIC_ESR_SEND_CS_ERROR);
    eval 'sub APIC_ESR_RECEIVE_CS_ERROR () {0x2;}' unless defined(&APIC_ESR_RECEIVE_CS_ERROR);
    eval 'sub APIC_ESR_SEND_ACCEPT () {0x4;}' unless defined(&APIC_ESR_SEND_ACCEPT);
    eval 'sub APIC_ESR_RECEIVE_ACCEPT () {0x8;}' unless defined(&APIC_ESR_RECEIVE_ACCEPT);
    eval 'sub APIC_ESR_SEND_ILLEGAL_VECTOR () {0x20;}' unless defined(&APIC_ESR_SEND_ILLEGAL_VECTOR);
    eval 'sub APIC_ESR_RECEIVE_ILLEGAL_VECTOR () {0x40;}' unless defined(&APIC_ESR_RECEIVE_ILLEGAL_VECTOR);
    eval 'sub APIC_ESR_ILLEGAL_REGISTER () {0x80;}' unless defined(&APIC_ESR_ILLEGAL_REGISTER);
    eval 'sub APIC_VECTOR_MASK () {0xff;}' unless defined(&APIC_VECTOR_MASK);
    eval 'sub APIC_DELMODE_MASK () {0x700;}' unless defined(&APIC_DELMODE_MASK);
    eval 'sub APIC_DELMODE_FIXED () {0x;}' unless defined(&APIC_DELMODE_FIXED);
    eval 'sub APIC_DELMODE_LOWPRIO () {0x100;}' unless defined(&APIC_DELMODE_LOWPRIO);
    eval 'sub APIC_DELMODE_SMI () {0x200;}' unless defined(&APIC_DELMODE_SMI);
    eval 'sub APIC_DELMODE_RR () {0x300;}' unless defined(&APIC_DELMODE_RR);
    eval 'sub APIC_DELMODE_NMI () {0x400;}' unless defined(&APIC_DELMODE_NMI);
    eval 'sub APIC_DELMODE_INIT () {0x500;}' unless defined(&APIC_DELMODE_INIT);
    eval 'sub APIC_DELMODE_STARTUP () {0x600;}' unless defined(&APIC_DELMODE_STARTUP);
    eval 'sub APIC_DELMODE_RESV () {0x700;}' unless defined(&APIC_DELMODE_RESV);
    eval 'sub APIC_DESTMODE_MASK () {0x800;}' unless defined(&APIC_DESTMODE_MASK);
    eval 'sub APIC_DESTMODE_PHY () {0x;}' unless defined(&APIC_DESTMODE_PHY);
    eval 'sub APIC_DESTMODE_LOG () {0x800;}' unless defined(&APIC_DESTMODE_LOG);
    eval 'sub APIC_DELSTAT_MASK () {0x1000;}' unless defined(&APIC_DELSTAT_MASK);
    eval 'sub APIC_DELSTAT_IDLE () {0x;}' unless defined(&APIC_DELSTAT_IDLE);
    eval 'sub APIC_DELSTAT_PEND () {0x1000;}' unless defined(&APIC_DELSTAT_PEND);
    eval 'sub APIC_RESV1_MASK () {0x2000;}' unless defined(&APIC_RESV1_MASK);
    eval 'sub APIC_LEVEL_MASK () {0x4000;}' unless defined(&APIC_LEVEL_MASK);
    eval 'sub APIC_LEVEL_DEASSERT () {0x;}' unless defined(&APIC_LEVEL_DEASSERT);
    eval 'sub APIC_LEVEL_ASSERT () {0x4000;}' unless defined(&APIC_LEVEL_ASSERT);
    eval 'sub APIC_TRIGMOD_MASK () {0x8000;}' unless defined(&APIC_TRIGMOD_MASK);
    eval 'sub APIC_TRIGMOD_EDGE () {0x;}' unless defined(&APIC_TRIGMOD_EDGE);
    eval 'sub APIC_TRIGMOD_LEVEL () {0x8000;}' unless defined(&APIC_TRIGMOD_LEVEL);
    eval 'sub APIC_RRSTAT_MASK () {0x30000;}' unless defined(&APIC_RRSTAT_MASK);
    eval 'sub APIC_RRSTAT_INVALID () {0x;}' unless defined(&APIC_RRSTAT_INVALID);
    eval 'sub APIC_RRSTAT_INPROG () {0x10000;}' unless defined(&APIC_RRSTAT_INPROG);
    eval 'sub APIC_RRSTAT_VALID () {0x20000;}' unless defined(&APIC_RRSTAT_VALID);
    eval 'sub APIC_RRSTAT_RESV () {0x30000;}' unless defined(&APIC_RRSTAT_RESV);
    eval 'sub APIC_DEST_MASK () {0xc0000;}' unless defined(&APIC_DEST_MASK);
    eval 'sub APIC_DEST_DESTFLD () {0x;}' unless defined(&APIC_DEST_DESTFLD);
    eval 'sub APIC_DEST_SELF () {0x40000;}' unless defined(&APIC_DEST_SELF);
    eval 'sub APIC_DEST_ALLISELF () {0x80000;}' unless defined(&APIC_DEST_ALLISELF);
    eval 'sub APIC_DEST_ALLESELF () {0xc0000;}' unless defined(&APIC_DEST_ALLESELF);
    eval 'sub APIC_RESV2_MASK () {0xfff00000;}' unless defined(&APIC_RESV2_MASK);
    eval 'sub APIC_ICRLO_RESV_MASK () {( &APIC_RESV1_MASK |  &APIC_RESV2_MASK);}' unless defined(&APIC_ICRLO_RESV_MASK);
    eval 'sub APIC_LVT_VECTOR () {0xff;}' unless defined(&APIC_LVT_VECTOR);
    eval 'sub APIC_LVT_DM () {0x700;}' unless defined(&APIC_LVT_DM);
    eval 'sub APIC_LVT_DM_FIXED () {0x;}' unless defined(&APIC_LVT_DM_FIXED);
    eval 'sub APIC_LVT_DM_SMI () {0x200;}' unless defined(&APIC_LVT_DM_SMI);
    eval 'sub APIC_LVT_DM_NMI () {0x400;}' unless defined(&APIC_LVT_DM_NMI);
    eval 'sub APIC_LVT_DM_INIT () {0x500;}' unless defined(&APIC_LVT_DM_INIT);
    eval 'sub APIC_LVT_DM_EXTINT () {0x700;}' unless defined(&APIC_LVT_DM_EXTINT);
    eval 'sub APIC_LVT_DS () {0x1000;}' unless defined(&APIC_LVT_DS);
    eval 'sub APIC_LVT_IIPP () {0x2000;}' unless defined(&APIC_LVT_IIPP);
    eval 'sub APIC_LVT_IIPP_INTALO () {0x2000;}' unless defined(&APIC_LVT_IIPP_INTALO);
    eval 'sub APIC_LVT_IIPP_INTAHI () {0x;}' unless defined(&APIC_LVT_IIPP_INTAHI);
    eval 'sub APIC_LVT_RIRR () {0x4000;}' unless defined(&APIC_LVT_RIRR);
    eval 'sub APIC_LVT_TM () {0x8000;}' unless defined(&APIC_LVT_TM);
    eval 'sub APIC_LVT_M () {0x10000;}' unless defined(&APIC_LVT_M);
    eval 'sub APIC_LVTT_VECTOR () {0xff;}' unless defined(&APIC_LVTT_VECTOR);
    eval 'sub APIC_LVTT_DS () {0x1000;}' unless defined(&APIC_LVTT_DS);
    eval 'sub APIC_LVTT_M () {0x10000;}' unless defined(&APIC_LVTT_M);
    eval 'sub APIC_LVTT_TM () {0x60000;}' unless defined(&APIC_LVTT_TM);
    eval 'sub APIC_LVTT_TM_ONE_SHOT () {0x;}' unless defined(&APIC_LVTT_TM_ONE_SHOT);
    eval 'sub APIC_LVTT_TM_PERIODIC () {0x20000;}' unless defined(&APIC_LVTT_TM_PERIODIC);
    eval 'sub APIC_LVTT_TM_TSCDLT () {0x40000;}' unless defined(&APIC_LVTT_TM_TSCDLT);
    eval 'sub APIC_LVTT_TM_RSRV () {0x60000;}' unless defined(&APIC_LVTT_TM_RSRV);
    eval 'sub APIC_TIMER_MAX_COUNT () {0xffffffff;}' unless defined(&APIC_TIMER_MAX_COUNT);
    eval 'sub APIC_TDCR_2 () {0x;}' unless defined(&APIC_TDCR_2);
    eval 'sub APIC_TDCR_4 () {0x1;}' unless defined(&APIC_TDCR_4);
    eval 'sub APIC_TDCR_8 () {0x2;}' unless defined(&APIC_TDCR_8);
    eval 'sub APIC_TDCR_16 () {0x3;}' unless defined(&APIC_TDCR_16);
    eval 'sub APIC_TDCR_32 () {0x8;}' unless defined(&APIC_TDCR_32);
    eval 'sub APIC_TDCR_64 () {0x9;}' unless defined(&APIC_TDCR_64);
    eval 'sub APIC_TDCR_128 () {0xa;}' unless defined(&APIC_TDCR_128);
    eval 'sub APIC_TDCR_1 () {0xb;}' unless defined(&APIC_TDCR_1);
    eval 'sub APIC_EXTF_ELVT_MASK () {0xff0000;}' unless defined(&APIC_EXTF_ELVT_MASK);
    eval 'sub APIC_EXTF_ELVT_SHIFT () {16;}' unless defined(&APIC_EXTF_ELVT_SHIFT);
    eval 'sub APIC_EXTF_EXTID_CAP () {0x4;}' unless defined(&APIC_EXTF_EXTID_CAP);
    eval 'sub APIC_EXTF_SEIO_CAP () {0x2;}' unless defined(&APIC_EXTF_SEIO_CAP);
    eval 'sub APIC_EXTF_IER_CAP () {0x1;}' unless defined(&APIC_EXTF_IER_CAP);
    eval 'sub APIC_LVT_LINT0 () {0;}' unless defined(&APIC_LVT_LINT0);
    eval 'sub APIC_LVT_LINT1 () {1;}' unless defined(&APIC_LVT_LINT1);
    eval 'sub APIC_LVT_TIMER () {2;}' unless defined(&APIC_LVT_TIMER);
    eval 'sub APIC_LVT_ERROR () {3;}' unless defined(&APIC_LVT_ERROR);
    eval 'sub APIC_LVT_PMC () {4;}' unless defined(&APIC_LVT_PMC);
    eval 'sub APIC_LVT_THERMAL () {5;}' unless defined(&APIC_LVT_THERMAL);
    eval 'sub APIC_LVT_CMCI () {6;}' unless defined(&APIC_LVT_CMCI);
    eval 'sub APIC_LVT_MAX () { &APIC_LVT_CMCI;}' unless defined(&APIC_LVT_MAX);
    eval 'sub APIC_ELVT_IBS () {0;}' unless defined(&APIC_ELVT_IBS);
    eval 'sub APIC_ELVT_MCA () {1;}' unless defined(&APIC_ELVT_MCA);
    eval 'sub APIC_ELVT_DEI () {2;}' unless defined(&APIC_ELVT_DEI);
    eval 'sub APIC_ELVT_SBI () {3;}' unless defined(&APIC_ELVT_SBI);
    eval 'sub APIC_ELVT_MAX () { &APIC_ELVT_SBI;}' unless defined(&APIC_ELVT_MAX);
    eval 'sub DEFAULT_IO_APIC_BASE () {0xfec00000;}' unless defined(&DEFAULT_IO_APIC_BASE);
    eval 'sub IOAPIC_WINDOW () {0x10;}' unless defined(&IOAPIC_WINDOW);
    eval 'sub IOAPIC_EOIR () {0x40;}' unless defined(&IOAPIC_EOIR);
    eval 'sub IOAPIC_WND_SIZE () {0x50;}' unless defined(&IOAPIC_WND_SIZE);
    eval 'sub IOAPIC_ID () {0x;}' unless defined(&IOAPIC_ID);
    eval 'sub IOAPIC_VER () {0x1;}' unless defined(&IOAPIC_VER);
    eval 'sub IOAPIC_ARB () {0x2;}' unless defined(&IOAPIC_ARB);
    eval 'sub IOAPIC_REDTBL () {0x10;}' unless defined(&IOAPIC_REDTBL);
    eval 'sub IOAPIC_REDTBL0 () { &IOAPIC_REDTBL;}' unless defined(&IOAPIC_REDTBL0);
    eval 'sub IOAPIC_REDTBL1 () {( &IOAPIC_REDTBL+0x2);}' unless defined(&IOAPIC_REDTBL1);
    eval 'sub IOAPIC_REDTBL2 () {( &IOAPIC_REDTBL+0x4);}' unless defined(&IOAPIC_REDTBL2);
    eval 'sub IOAPIC_REDTBL3 () {( &IOAPIC_REDTBL+0x6);}' unless defined(&IOAPIC_REDTBL3);
    eval 'sub IOAPIC_REDTBL4 () {( &IOAPIC_REDTBL+0x8);}' unless defined(&IOAPIC_REDTBL4);
    eval 'sub IOAPIC_REDTBL5 () {( &IOAPIC_REDTBL+0xa);}' unless defined(&IOAPIC_REDTBL5);
    eval 'sub IOAPIC_REDTBL6 () {( &IOAPIC_REDTBL+0xc);}' unless defined(&IOAPIC_REDTBL6);
    eval 'sub IOAPIC_REDTBL7 () {( &IOAPIC_REDTBL+0xe);}' unless defined(&IOAPIC_REDTBL7);
    eval 'sub IOAPIC_REDTBL8 () {( &IOAPIC_REDTBL+0x10);}' unless defined(&IOAPIC_REDTBL8);
    eval 'sub IOAPIC_REDTBL9 () {( &IOAPIC_REDTBL+0x12);}' unless defined(&IOAPIC_REDTBL9);
    eval 'sub IOAPIC_REDTBL10 () {( &IOAPIC_REDTBL+0x14);}' unless defined(&IOAPIC_REDTBL10);
    eval 'sub IOAPIC_REDTBL11 () {( &IOAPIC_REDTBL+0x16);}' unless defined(&IOAPIC_REDTBL11);
    eval 'sub IOAPIC_REDTBL12 () {( &IOAPIC_REDTBL+0x18);}' unless defined(&IOAPIC_REDTBL12);
    eval 'sub IOAPIC_REDTBL13 () {( &IOAPIC_REDTBL+0x1a);}' unless defined(&IOAPIC_REDTBL13);
    eval 'sub IOAPIC_REDTBL14 () {( &IOAPIC_REDTBL+0x1c);}' unless defined(&IOAPIC_REDTBL14);
    eval 'sub IOAPIC_REDTBL15 () {( &IOAPIC_REDTBL+0x1e);}' unless defined(&IOAPIC_REDTBL15);
    eval 'sub IOAPIC_REDTBL16 () {( &IOAPIC_REDTBL+0x20);}' unless defined(&IOAPIC_REDTBL16);
    eval 'sub IOAPIC_REDTBL17 () {( &IOAPIC_REDTBL+0x22);}' unless defined(&IOAPIC_REDTBL17);
    eval 'sub IOAPIC_REDTBL18 () {( &IOAPIC_REDTBL+0x24);}' unless defined(&IOAPIC_REDTBL18);
    eval 'sub IOAPIC_REDTBL19 () {( &IOAPIC_REDTBL+0x26);}' unless defined(&IOAPIC_REDTBL19);
    eval 'sub IOAPIC_REDTBL20 () {( &IOAPIC_REDTBL+0x28);}' unless defined(&IOAPIC_REDTBL20);
    eval 'sub IOAPIC_REDTBL21 () {( &IOAPIC_REDTBL+0x2a);}' unless defined(&IOAPIC_REDTBL21);
    eval 'sub IOAPIC_REDTBL22 () {( &IOAPIC_REDTBL+0x2c);}' unless defined(&IOAPIC_REDTBL22);
    eval 'sub IOAPIC_REDTBL23 () {( &IOAPIC_REDTBL+0x2e);}' unless defined(&IOAPIC_REDTBL23);
    eval 'sub IOART_VER_VERSION () {0xff;}' unless defined(&IOART_VER_VERSION);
    eval 'sub IOART_VER_MAXREDIR () {0xff0000;}' unless defined(&IOART_VER_MAXREDIR);
    eval 'sub MAXREDIRSHIFT () {16;}' unless defined(&MAXREDIRSHIFT);
    eval 'sub IOART_DEST () { &APIC_ID_MASK;}' unless defined(&IOART_DEST);
    eval 'sub IOART_RESV () {0xfe0000;}' unless defined(&IOART_RESV);
    eval 'sub IOART_INTMASK () {0x10000;}' unless defined(&IOART_INTMASK);
    eval 'sub IOART_INTMCLR () {0x;}' unless defined(&IOART_INTMCLR);
    eval 'sub IOART_INTMSET () {0x10000;}' unless defined(&IOART_INTMSET);
    eval 'sub IOART_TRGRMOD () {0x8000;}' unless defined(&IOART_TRGRMOD);
    eval 'sub IOART_TRGREDG () {0x;}' unless defined(&IOART_TRGREDG);
    eval 'sub IOART_TRGRLVL () {0x8000;}' unless defined(&IOART_TRGRLVL);
    eval 'sub IOART_REM_IRR () {0x4000;}' unless defined(&IOART_REM_IRR);
    eval 'sub IOART_INTPOL () {0x2000;}' unless defined(&IOART_INTPOL);
    eval 'sub IOART_INTAHI () {0x;}' unless defined(&IOART_INTAHI);
    eval 'sub IOART_INTALO () {0x2000;}' unless defined(&IOART_INTALO);
    eval 'sub IOART_DELIVS () {0x1000;}' unless defined(&IOART_DELIVS);
    eval 'sub IOART_DESTMOD () {0x800;}' unless defined(&IOART_DESTMOD);
    eval 'sub IOART_DESTPHY () {0x;}' unless defined(&IOART_DESTPHY);
    eval 'sub IOART_DESTLOG () {0x800;}' unless defined(&IOART_DESTLOG);
    eval 'sub IOART_DELMOD () {0x700;}' unless defined(&IOART_DELMOD);
    eval 'sub IOART_DELFIXED () {0x;}' unless defined(&IOART_DELFIXED);
    eval 'sub IOART_DELLOPRI () {0x100;}' unless defined(&IOART_DELLOPRI);
    eval 'sub IOART_DELSMI () {0x200;}' unless defined(&IOART_DELSMI);
    eval 'sub IOART_DELRSV1 () {0x300;}' unless defined(&IOART_DELRSV1);
    eval 'sub IOART_DELNMI () {0x400;}' unless defined(&IOART_DELNMI);
    eval 'sub IOART_DELINIT () {0x500;}' unless defined(&IOART_DELINIT);
    eval 'sub IOART_DELRSV2 () {0x600;}' unless defined(&IOART_DELRSV2);
    eval 'sub IOART_DELEXINT () {0x700;}' unless defined(&IOART_DELEXINT);
    eval 'sub IOART_INTVEC () {0xff;}' unless defined(&IOART_INTVEC);
}
1;
