require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PTRACE_H_)) {
    eval 'sub _MACHINE_PTRACE_H_ () {1;}' unless defined(&_MACHINE_PTRACE_H_);
    eval 'sub __HAVE_PTRACE_MACHDEP () {1;}' unless defined(&__HAVE_PTRACE_MACHDEP);
    if(defined(&__i386__)) {
	eval 'sub PT_GETXMMREGS () {( &PT_FIRSTMACH + 0);}' unless defined(&PT_GETXMMREGS);
	eval 'sub PT_SETXMMREGS () {( &PT_FIRSTMACH + 1);}' unless defined(&PT_SETXMMREGS);
    }
    if(defined(&_KERNEL)) {
	eval 'sub PT_GETXSTATE_OLD () {( &PT_FIRSTMACH + 2);}' unless defined(&PT_GETXSTATE_OLD);
	eval 'sub PT_SETXSTATE_OLD () {( &PT_FIRSTMACH + 3);}' unless defined(&PT_SETXSTATE_OLD);
    }
    eval 'sub PT_GETXSTATE_INFO () {( &PT_FIRSTMACH + 4);}' unless defined(&PT_GETXSTATE_INFO);
    eval 'sub PT_GETXSTATE () {( &PT_FIRSTMACH + 5);}' unless defined(&PT_GETXSTATE);
    eval 'sub PT_SETXSTATE () {( &PT_FIRSTMACH + 6);}' unless defined(&PT_SETXSTATE);
    eval 'sub PT_GETFSBASE () {( &PT_FIRSTMACH + 7);}' unless defined(&PT_GETFSBASE);
    eval 'sub PT_SETFSBASE () {( &PT_FIRSTMACH + 8);}' unless defined(&PT_SETFSBASE);
    eval 'sub PT_GETGSBASE () {( &PT_FIRSTMACH + 9);}' unless defined(&PT_GETGSBASE);
    eval 'sub PT_SETGSBASE () {( &PT_FIRSTMACH + 10);}' unless defined(&PT_SETGSBASE);
}
1;
