require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_SPECIALREG_H_)) {
    eval 'sub _MACHINE_SPECIALREG_H_ () {1;}' unless defined(&_MACHINE_SPECIALREG_H_);
    eval 'sub CR0_PE () {0x1;}' unless defined(&CR0_PE);
    eval 'sub CR0_MP () {0x2;}' unless defined(&CR0_MP);
    eval 'sub CR0_EM () {0x4;}' unless defined(&CR0_EM);
    eval 'sub CR0_TS () {0x8;}' unless defined(&CR0_TS);
    eval 'sub CR0_PG () {0x80000000;}' unless defined(&CR0_PG);
    eval 'sub CR0_NE () {0x20;}' unless defined(&CR0_NE);
    eval 'sub CR0_WP () {0x10000;}' unless defined(&CR0_WP);
    eval 'sub CR0_AM () {0x40000;}' unless defined(&CR0_AM);
    eval 'sub CR0_NW () {0x20000000;}' unless defined(&CR0_NW);
    eval 'sub CR0_CD () {0x40000000;}' unless defined(&CR0_CD);
    eval 'sub CR3_PCID_SAVE () {0x8000000000000000;}' unless defined(&CR3_PCID_SAVE);
    eval 'sub CR3_PCID_MASK () {0xfff;}' unless defined(&CR3_PCID_MASK);
    eval 'sub CR4_VME () {0x1;}' unless defined(&CR4_VME);
    eval 'sub CR4_PVI () {0x2;}' unless defined(&CR4_PVI);
    eval 'sub CR4_TSD () {0x4;}' unless defined(&CR4_TSD);
    eval 'sub CR4_DE () {0x8;}' unless defined(&CR4_DE);
    eval 'sub CR4_PSE () {0x10;}' unless defined(&CR4_PSE);
    eval 'sub CR4_PAE () {0x20;}' unless defined(&CR4_PAE);
    eval 'sub CR4_MCE () {0x40;}' unless defined(&CR4_MCE);
    eval 'sub CR4_PGE () {0x80;}' unless defined(&CR4_PGE);
    eval 'sub CR4_PCE () {0x100;}' unless defined(&CR4_PCE);
    eval 'sub CR4_FXSR () {0x200;}' unless defined(&CR4_FXSR);
    eval 'sub CR4_XMM () {0x400;}' unless defined(&CR4_XMM);
    eval 'sub CR4_VMXE () {0x2000;}' unless defined(&CR4_VMXE);
    eval 'sub CR4_FSGSBASE () {0x10000;}' unless defined(&CR4_FSGSBASE);
    eval 'sub CR4_PCIDE () {0x20000;}' unless defined(&CR4_PCIDE);
    eval 'sub CR4_XSAVE () {0x40000;}' unless defined(&CR4_XSAVE);
    eval 'sub CR4_SMEP () {0x100000;}' unless defined(&CR4_SMEP);
    eval 'sub CR4_SMAP () {0x200000;}' unless defined(&CR4_SMAP);
    eval 'sub EFER_SCE () {0x1;}' unless defined(&EFER_SCE);
    eval 'sub EFER_LME () {0x100;}' unless defined(&EFER_LME);
    eval 'sub EFER_LMA () {0x400;}' unless defined(&EFER_LMA);
    eval 'sub EFER_NXE () {0x800;}' unless defined(&EFER_NXE);
    eval 'sub EFER_SVM () {0x1000;}' unless defined(&EFER_SVM);
    eval 'sub EFER_LMSLE () {0x2000;}' unless defined(&EFER_LMSLE);
    eval 'sub EFER_FFXSR () {0x4000;}' unless defined(&EFER_FFXSR);
    eval 'sub EFER_TCE () {0x8000;}' unless defined(&EFER_TCE);
    eval 'sub XCR0 () {0;}' unless defined(&XCR0);
    eval 'sub XFEATURE_ENABLED_X87 () {0x1;}' unless defined(&XFEATURE_ENABLED_X87);
    eval 'sub XFEATURE_ENABLED_SSE () {0x2;}' unless defined(&XFEATURE_ENABLED_SSE);
    eval 'sub XFEATURE_ENABLED_YMM_HI128 () {0x4;}' unless defined(&XFEATURE_ENABLED_YMM_HI128);
    eval 'sub XFEATURE_ENABLED_AVX () { &XFEATURE_ENABLED_YMM_HI128;}' unless defined(&XFEATURE_ENABLED_AVX);
    eval 'sub XFEATURE_ENABLED_BNDREGS () {0x8;}' unless defined(&XFEATURE_ENABLED_BNDREGS);
    eval 'sub XFEATURE_ENABLED_BNDCSR () {0x10;}' unless defined(&XFEATURE_ENABLED_BNDCSR);
    eval 'sub XFEATURE_ENABLED_OPMASK () {0x20;}' unless defined(&XFEATURE_ENABLED_OPMASK);
    eval 'sub XFEATURE_ENABLED_ZMM_HI256 () {0x40;}' unless defined(&XFEATURE_ENABLED_ZMM_HI256);
    eval 'sub XFEATURE_ENABLED_HI16_ZMM () {0x80;}' unless defined(&XFEATURE_ENABLED_HI16_ZMM);
    eval 'sub XFEATURE_AVX () {( &XFEATURE_ENABLED_X87 |  &XFEATURE_ENABLED_SSE |  &XFEATURE_ENABLED_AVX);}' unless defined(&XFEATURE_AVX);
    eval 'sub XFEATURE_AVX512 () {( &XFEATURE_ENABLED_OPMASK |  &XFEATURE_ENABLED_ZMM_HI256 |  &XFEATURE_ENABLED_HI16_ZMM);}' unless defined(&XFEATURE_AVX512);
    eval 'sub XFEATURE_MPX () {( &XFEATURE_ENABLED_BNDREGS |  &XFEATURE_ENABLED_BNDCSR);}' unless defined(&XFEATURE_MPX);
    eval 'sub CPUID_FPU () {0x1;}' unless defined(&CPUID_FPU);
    eval 'sub CPUID_VME () {0x2;}' unless defined(&CPUID_VME);
    eval 'sub CPUID_DE () {0x4;}' unless defined(&CPUID_DE);
    eval 'sub CPUID_PSE () {0x8;}' unless defined(&CPUID_PSE);
    eval 'sub CPUID_TSC () {0x10;}' unless defined(&CPUID_TSC);
    eval 'sub CPUID_MSR () {0x20;}' unless defined(&CPUID_MSR);
    eval 'sub CPUID_PAE () {0x40;}' unless defined(&CPUID_PAE);
    eval 'sub CPUID_MCE () {0x80;}' unless defined(&CPUID_MCE);
    eval 'sub CPUID_CX8 () {0x100;}' unless defined(&CPUID_CX8);
    eval 'sub CPUID_APIC () {0x200;}' unless defined(&CPUID_APIC);
    eval 'sub CPUID_B10 () {0x400;}' unless defined(&CPUID_B10);
    eval 'sub CPUID_SEP () {0x800;}' unless defined(&CPUID_SEP);
    eval 'sub CPUID_MTRR () {0x1000;}' unless defined(&CPUID_MTRR);
    eval 'sub CPUID_PGE () {0x2000;}' unless defined(&CPUID_PGE);
    eval 'sub CPUID_MCA () {0x4000;}' unless defined(&CPUID_MCA);
    eval 'sub CPUID_CMOV () {0x8000;}' unless defined(&CPUID_CMOV);
    eval 'sub CPUID_PAT () {0x10000;}' unless defined(&CPUID_PAT);
    eval 'sub CPUID_PSE36 () {0x20000;}' unless defined(&CPUID_PSE36);
    eval 'sub CPUID_PSN () {0x40000;}' unless defined(&CPUID_PSN);
    eval 'sub CPUID_CLFSH () {0x80000;}' unless defined(&CPUID_CLFSH);
    eval 'sub CPUID_B20 () {0x100000;}' unless defined(&CPUID_B20);
    eval 'sub CPUID_DS () {0x200000;}' unless defined(&CPUID_DS);
    eval 'sub CPUID_ACPI () {0x400000;}' unless defined(&CPUID_ACPI);
    eval 'sub CPUID_MMX () {0x800000;}' unless defined(&CPUID_MMX);
    eval 'sub CPUID_FXSR () {0x1000000;}' unless defined(&CPUID_FXSR);
    eval 'sub CPUID_SSE () {0x2000000;}' unless defined(&CPUID_SSE);
    eval 'sub CPUID_XMM () {0x2000000;}' unless defined(&CPUID_XMM);
    eval 'sub CPUID_SSE2 () {0x4000000;}' unless defined(&CPUID_SSE2);
    eval 'sub CPUID_SS () {0x8000000;}' unless defined(&CPUID_SS);
    eval 'sub CPUID_HTT () {0x10000000;}' unless defined(&CPUID_HTT);
    eval 'sub CPUID_TM () {0x20000000;}' unless defined(&CPUID_TM);
    eval 'sub CPUID_IA64 () {0x40000000;}' unless defined(&CPUID_IA64);
    eval 'sub CPUID_PBE () {0x80000000;}' unless defined(&CPUID_PBE);
    eval 'sub CPUID2_SSE3 () {0x1;}' unless defined(&CPUID2_SSE3);
    eval 'sub CPUID2_PCLMULQDQ () {0x2;}' unless defined(&CPUID2_PCLMULQDQ);
    eval 'sub CPUID2_DTES64 () {0x4;}' unless defined(&CPUID2_DTES64);
    eval 'sub CPUID2_MON () {0x8;}' unless defined(&CPUID2_MON);
    eval 'sub CPUID2_DS_CPL () {0x10;}' unless defined(&CPUID2_DS_CPL);
    eval 'sub CPUID2_VMX () {0x20;}' unless defined(&CPUID2_VMX);
    eval 'sub CPUID2_SMX () {0x40;}' unless defined(&CPUID2_SMX);
    eval 'sub CPUID2_EST () {0x80;}' unless defined(&CPUID2_EST);
    eval 'sub CPUID2_TM2 () {0x100;}' unless defined(&CPUID2_TM2);
    eval 'sub CPUID2_SSSE3 () {0x200;}' unless defined(&CPUID2_SSSE3);
    eval 'sub CPUID2_CNXTID () {0x400;}' unless defined(&CPUID2_CNXTID);
    eval 'sub CPUID2_SDBG () {0x800;}' unless defined(&CPUID2_SDBG);
    eval 'sub CPUID2_FMA () {0x1000;}' unless defined(&CPUID2_FMA);
    eval 'sub CPUID2_CX16 () {0x2000;}' unless defined(&CPUID2_CX16);
    eval 'sub CPUID2_XTPR () {0x4000;}' unless defined(&CPUID2_XTPR);
    eval 'sub CPUID2_PDCM () {0x8000;}' unless defined(&CPUID2_PDCM);
    eval 'sub CPUID2_PCID () {0x20000;}' unless defined(&CPUID2_PCID);
    eval 'sub CPUID2_DCA () {0x40000;}' unless defined(&CPUID2_DCA);
    eval 'sub CPUID2_SSE41 () {0x80000;}' unless defined(&CPUID2_SSE41);
    eval 'sub CPUID2_SSE42 () {0x100000;}' unless defined(&CPUID2_SSE42);
    eval 'sub CPUID2_X2APIC () {0x200000;}' unless defined(&CPUID2_X2APIC);
    eval 'sub CPUID2_MOVBE () {0x400000;}' unless defined(&CPUID2_MOVBE);
    eval 'sub CPUID2_POPCNT () {0x800000;}' unless defined(&CPUID2_POPCNT);
    eval 'sub CPUID2_TSCDLT () {0x1000000;}' unless defined(&CPUID2_TSCDLT);
    eval 'sub CPUID2_AESNI () {0x2000000;}' unless defined(&CPUID2_AESNI);
    eval 'sub CPUID2_XSAVE () {0x4000000;}' unless defined(&CPUID2_XSAVE);
    eval 'sub CPUID2_OSXSAVE () {0x8000000;}' unless defined(&CPUID2_OSXSAVE);
    eval 'sub CPUID2_AVX () {0x10000000;}' unless defined(&CPUID2_AVX);
    eval 'sub CPUID2_F16C () {0x20000000;}' unless defined(&CPUID2_F16C);
    eval 'sub CPUID2_RDRAND () {0x40000000;}' unless defined(&CPUID2_RDRAND);
    eval 'sub CPUID2_HV () {0x80000000;}' unless defined(&CPUID2_HV);
    eval 'sub CPUTPM1_SENSOR () {0x1;}' unless defined(&CPUTPM1_SENSOR);
    eval 'sub CPUTPM1_TURBO () {0x2;}' unless defined(&CPUTPM1_TURBO);
    eval 'sub CPUTPM1_ARAT () {0x4;}' unless defined(&CPUTPM1_ARAT);
    eval 'sub CPUTPM2_EFFREQ () {0x1;}' unless defined(&CPUTPM2_EFFREQ);
    eval 'sub AMDID_SYSCALL () {0x800;}' unless defined(&AMDID_SYSCALL);
    eval 'sub AMDID_MP () {0x80000;}' unless defined(&AMDID_MP);
    eval 'sub AMDID_NX () {0x100000;}' unless defined(&AMDID_NX);
    eval 'sub AMDID_EXT_MMX () {0x400000;}' unless defined(&AMDID_EXT_MMX);
    eval 'sub AMDID_FFXSR () {0x2000000;}' unless defined(&AMDID_FFXSR);
    eval 'sub AMDID_PAGE1GB () {0x4000000;}' unless defined(&AMDID_PAGE1GB);
    eval 'sub AMDID_RDTSCP () {0x8000000;}' unless defined(&AMDID_RDTSCP);
    eval 'sub AMDID_LM () {0x20000000;}' unless defined(&AMDID_LM);
    eval 'sub AMDID_EXT_3DNOW () {0x40000000;}' unless defined(&AMDID_EXT_3DNOW);
    eval 'sub AMDID_3DNOW () {0x80000000;}' unless defined(&AMDID_3DNOW);
    eval 'sub AMDID2_LAHF () {0x1;}' unless defined(&AMDID2_LAHF);
    eval 'sub AMDID2_CMP () {0x2;}' unless defined(&AMDID2_CMP);
    eval 'sub AMDID2_SVM () {0x4;}' unless defined(&AMDID2_SVM);
    eval 'sub AMDID2_EXT_APIC () {0x8;}' unless defined(&AMDID2_EXT_APIC);
    eval 'sub AMDID2_CR8 () {0x10;}' unless defined(&AMDID2_CR8);
    eval 'sub AMDID2_ABM () {0x20;}' unless defined(&AMDID2_ABM);
    eval 'sub AMDID2_SSE4A () {0x40;}' unless defined(&AMDID2_SSE4A);
    eval 'sub AMDID2_MAS () {0x80;}' unless defined(&AMDID2_MAS);
    eval 'sub AMDID2_PREFETCH () {0x100;}' unless defined(&AMDID2_PREFETCH);
    eval 'sub AMDID2_OSVW () {0x200;}' unless defined(&AMDID2_OSVW);
    eval 'sub AMDID2_IBS () {0x400;}' unless defined(&AMDID2_IBS);
    eval 'sub AMDID2_XOP () {0x800;}' unless defined(&AMDID2_XOP);
    eval 'sub AMDID2_SKINIT () {0x1000;}' unless defined(&AMDID2_SKINIT);
    eval 'sub AMDID2_WDT () {0x2000;}' unless defined(&AMDID2_WDT);
    eval 'sub AMDID2_LWP () {0x8000;}' unless defined(&AMDID2_LWP);
    eval 'sub AMDID2_FMA4 () {0x10000;}' unless defined(&AMDID2_FMA4);
    eval 'sub AMDID2_TCE () {0x20000;}' unless defined(&AMDID2_TCE);
    eval 'sub AMDID2_NODE_ID () {0x80000;}' unless defined(&AMDID2_NODE_ID);
    eval 'sub AMDID2_TBM () {0x200000;}' unless defined(&AMDID2_TBM);
    eval 'sub AMDID2_TOPOLOGY () {0x400000;}' unless defined(&AMDID2_TOPOLOGY);
    eval 'sub AMDID2_PCXC () {0x800000;}' unless defined(&AMDID2_PCXC);
    eval 'sub AMDID2_PNXC () {0x1000000;}' unless defined(&AMDID2_PNXC);
    eval 'sub AMDID2_DBE () {0x4000000;}' unless defined(&AMDID2_DBE);
    eval 'sub AMDID2_PTSC () {0x8000000;}' unless defined(&AMDID2_PTSC);
    eval 'sub AMDID2_PTSCEL2I () {0x10000000;}' unless defined(&AMDID2_PTSCEL2I);
    eval 'sub AMDID2_MWAITX () {0x20000000;}' unless defined(&AMDID2_MWAITX);
    eval 'sub CPUID_STEPPING () {0xf;}' unless defined(&CPUID_STEPPING);
    eval 'sub CPUID_MODEL () {0xf0;}' unless defined(&CPUID_MODEL);
    eval 'sub CPUID_FAMILY () {0xf00;}' unless defined(&CPUID_FAMILY);
    eval 'sub CPUID_EXT_MODEL () {0xf0000;}' unless defined(&CPUID_EXT_MODEL);
    eval 'sub CPUID_EXT_FAMILY () {0xff00000;}' unless defined(&CPUID_EXT_FAMILY);
    if(defined(&__i386__)) {
	eval 'sub CPUID_TO_MODEL {
	    my($id) = @_;
    	    eval q((((($id) &  &CPUID_MODEL) >> 4) | (((($id) &  &CPUID_FAMILY) >= 0x600) ? ((($id) &  &CPUID_EXT_MODEL) >> 12) : 0)));
	}' unless defined(&CPUID_TO_MODEL);
	eval 'sub CPUID_TO_FAMILY {
	    my($id) = @_;
    	    eval q((((($id) &  &CPUID_FAMILY) >> 8) + (((($id) &  &CPUID_FAMILY) == 0xf00) ? ((($id) &  &CPUID_EXT_FAMILY) >> 20) : 0)));
	}' unless defined(&CPUID_TO_FAMILY);
    } else {
	eval 'sub CPUID_TO_MODEL {
	    my($id) = @_;
    	    eval q((((($id) &  &CPUID_MODEL) >> 4) | ((($id) &  &CPUID_EXT_MODEL) >> 12)));
	}' unless defined(&CPUID_TO_MODEL);
	eval 'sub CPUID_TO_FAMILY {
	    my($id) = @_;
    	    eval q((((($id) &  &CPUID_FAMILY) >> 8) + ((($id) &  &CPUID_EXT_FAMILY) >> 20)));
	}' unless defined(&CPUID_TO_FAMILY);
    }
    eval 'sub CPUID_BRAND_INDEX () {0xff;}' unless defined(&CPUID_BRAND_INDEX);
    eval 'sub CPUID_CLFUSH_SIZE () {0xff00;}' unless defined(&CPUID_CLFUSH_SIZE);
    eval 'sub CPUID_HTT_CORES () {0xff0000;}' unless defined(&CPUID_HTT_CORES);
    eval 'sub CPUID_LOCAL_APIC_ID () {0xff000000;}' unless defined(&CPUID_LOCAL_APIC_ID);
    eval 'sub CPUID5_MON_MIN_SIZE () {0xffff;}' unless defined(&CPUID5_MON_MIN_SIZE);
    eval 'sub CPUID5_MON_MAX_SIZE () {0xffff;}' unless defined(&CPUID5_MON_MAX_SIZE);
    eval 'sub CPUID5_MON_MWAIT_EXT () {0x1;}' unless defined(&CPUID5_MON_MWAIT_EXT);
    eval 'sub CPUID5_MWAIT_INTRBREAK () {0x2;}' unless defined(&CPUID5_MWAIT_INTRBREAK);
    eval 'sub MWAIT_C0 () {0xf0;}' unless defined(&MWAIT_C0);
    eval 'sub MWAIT_C1 () {0x;}' unless defined(&MWAIT_C1);
    eval 'sub MWAIT_C2 () {0x10;}' unless defined(&MWAIT_C2);
    eval 'sub MWAIT_C3 () {0x20;}' unless defined(&MWAIT_C3);
    eval 'sub MWAIT_C4 () {0x30;}' unless defined(&MWAIT_C4);
    eval 'sub MWAIT_INTRBREAK () {0x1;}' unless defined(&MWAIT_INTRBREAK);
    eval 'sub CPUID_PERF_STAT () {0x1;}' unless defined(&CPUID_PERF_STAT);
    eval 'sub CPUID_PERF_BIAS () {0x8;}' unless defined(&CPUID_PERF_BIAS);
    eval 'sub CPUID_TYPE_INVAL () {0;}' unless defined(&CPUID_TYPE_INVAL);
    eval 'sub CPUID_TYPE_SMT () {1;}' unless defined(&CPUID_TYPE_SMT);
    eval 'sub CPUID_TYPE_CORE () {2;}' unless defined(&CPUID_TYPE_CORE);
    eval 'sub CPUID_EXTSTATE_XSAVEOPT () {0x1;}' unless defined(&CPUID_EXTSTATE_XSAVEOPT);
    eval 'sub CPUID_EXTSTATE_XSAVEC () {0x2;}' unless defined(&CPUID_EXTSTATE_XSAVEC);
    eval 'sub CPUID_EXTSTATE_XINUSE () {0x4;}' unless defined(&CPUID_EXTSTATE_XINUSE);
    eval 'sub CPUID_EXTSTATE_XSAVES () {0x8;}' unless defined(&CPUID_EXTSTATE_XSAVES);
    eval 'sub AMDPM_TS () {0x1;}' unless defined(&AMDPM_TS);
    eval 'sub AMDPM_FID () {0x2;}' unless defined(&AMDPM_FID);
    eval 'sub AMDPM_VID () {0x4;}' unless defined(&AMDPM_VID);
    eval 'sub AMDPM_TTP () {0x8;}' unless defined(&AMDPM_TTP);
    eval 'sub AMDPM_TM () {0x10;}' unless defined(&AMDPM_TM);
    eval 'sub AMDPM_STC () {0x20;}' unless defined(&AMDPM_STC);
    eval 'sub AMDPM_100MHZ_STEPS () {0x40;}' unless defined(&AMDPM_100MHZ_STEPS);
    eval 'sub AMDPM_HW_PSTATE () {0x80;}' unless defined(&AMDPM_HW_PSTATE);
    eval 'sub AMDPM_TSC_INVARIANT () {0x100;}' unless defined(&AMDPM_TSC_INVARIANT);
    eval 'sub AMDPM_CPB () {0x200;}' unless defined(&AMDPM_CPB);
    eval 'sub AMDFEID_CLZERO () {0x1;}' unless defined(&AMDFEID_CLZERO);
    eval 'sub AMDFEID_IRPERF () {0x2;}' unless defined(&AMDFEID_IRPERF);
    eval 'sub AMDFEID_XSAVEERPTR () {0x4;}' unless defined(&AMDFEID_XSAVEERPTR);
    eval 'sub AMDID_CMP_CORES () {0xff;}' unless defined(&AMDID_CMP_CORES);
    eval 'sub AMDID_COREID_SIZE () {0xf000;}' unless defined(&AMDID_COREID_SIZE);
    eval 'sub AMDID_COREID_SIZE_SHIFT () {12;}' unless defined(&AMDID_COREID_SIZE_SHIFT);
    eval 'sub CPUID_STDEXT_FSGSBASE () {0x1;}' unless defined(&CPUID_STDEXT_FSGSBASE);
    eval 'sub CPUID_STDEXT_TSC_ADJUST () {0x2;}' unless defined(&CPUID_STDEXT_TSC_ADJUST);
    eval 'sub CPUID_STDEXT_SGX () {0x4;}' unless defined(&CPUID_STDEXT_SGX);
    eval 'sub CPUID_STDEXT_BMI1 () {0x8;}' unless defined(&CPUID_STDEXT_BMI1);
    eval 'sub CPUID_STDEXT_HLE () {0x10;}' unless defined(&CPUID_STDEXT_HLE);
    eval 'sub CPUID_STDEXT_AVX2 () {0x20;}' unless defined(&CPUID_STDEXT_AVX2);
    eval 'sub CPUID_STDEXT_FDP_EXC () {0x40;}' unless defined(&CPUID_STDEXT_FDP_EXC);
    eval 'sub CPUID_STDEXT_SMEP () {0x80;}' unless defined(&CPUID_STDEXT_SMEP);
    eval 'sub CPUID_STDEXT_BMI2 () {0x100;}' unless defined(&CPUID_STDEXT_BMI2);
    eval 'sub CPUID_STDEXT_ERMS () {0x200;}' unless defined(&CPUID_STDEXT_ERMS);
    eval 'sub CPUID_STDEXT_INVPCID () {0x400;}' unless defined(&CPUID_STDEXT_INVPCID);
    eval 'sub CPUID_STDEXT_RTM () {0x800;}' unless defined(&CPUID_STDEXT_RTM);
    eval 'sub CPUID_STDEXT_PQM () {0x1000;}' unless defined(&CPUID_STDEXT_PQM);
    eval 'sub CPUID_STDEXT_NFPUSG () {0x2000;}' unless defined(&CPUID_STDEXT_NFPUSG);
    eval 'sub CPUID_STDEXT_MPX () {0x4000;}' unless defined(&CPUID_STDEXT_MPX);
    eval 'sub CPUID_STDEXT_PQE () {0x8000;}' unless defined(&CPUID_STDEXT_PQE);
    eval 'sub CPUID_STDEXT_AVX512F () {0x10000;}' unless defined(&CPUID_STDEXT_AVX512F);
    eval 'sub CPUID_STDEXT_AVX512DQ () {0x20000;}' unless defined(&CPUID_STDEXT_AVX512DQ);
    eval 'sub CPUID_STDEXT_RDSEED () {0x40000;}' unless defined(&CPUID_STDEXT_RDSEED);
    eval 'sub CPUID_STDEXT_ADX () {0x80000;}' unless defined(&CPUID_STDEXT_ADX);
    eval 'sub CPUID_STDEXT_SMAP () {0x100000;}' unless defined(&CPUID_STDEXT_SMAP);
    eval 'sub CPUID_STDEXT_AVX512IFMA () {0x200000;}' unless defined(&CPUID_STDEXT_AVX512IFMA);
    eval 'sub CPUID_STDEXT_PCOMMIT () {0x400000;}' unless defined(&CPUID_STDEXT_PCOMMIT);
    eval 'sub CPUID_STDEXT_CLFLUSHOPT () {0x800000;}' unless defined(&CPUID_STDEXT_CLFLUSHOPT);
    eval 'sub CPUID_STDEXT_CLWB () {0x1000000;}' unless defined(&CPUID_STDEXT_CLWB);
    eval 'sub CPUID_STDEXT_PROCTRACE () {0x2000000;}' unless defined(&CPUID_STDEXT_PROCTRACE);
    eval 'sub CPUID_STDEXT_AVX512PF () {0x4000000;}' unless defined(&CPUID_STDEXT_AVX512PF);
    eval 'sub CPUID_STDEXT_AVX512ER () {0x8000000;}' unless defined(&CPUID_STDEXT_AVX512ER);
    eval 'sub CPUID_STDEXT_AVX512CD () {0x10000000;}' unless defined(&CPUID_STDEXT_AVX512CD);
    eval 'sub CPUID_STDEXT_SHA () {0x20000000;}' unless defined(&CPUID_STDEXT_SHA);
    eval 'sub CPUID_STDEXT_AVX512BW () {0x40000000;}' unless defined(&CPUID_STDEXT_AVX512BW);
    eval 'sub CPUID_STDEXT_AVX512VL () {0x80000000;}' unless defined(&CPUID_STDEXT_AVX512VL);
    eval 'sub CPUID_STDEXT2_PREFETCHWT1 () {0x1;}' unless defined(&CPUID_STDEXT2_PREFETCHWT1);
    eval 'sub CPUID_STDEXT2_UMIP () {0x4;}' unless defined(&CPUID_STDEXT2_UMIP);
    eval 'sub CPUID_STDEXT2_PKU () {0x8;}' unless defined(&CPUID_STDEXT2_PKU);
    eval 'sub CPUID_STDEXT2_OSPKE () {0x10;}' unless defined(&CPUID_STDEXT2_OSPKE);
    eval 'sub CPUID_STDEXT2_RDPID () {0x400000;}' unless defined(&CPUID_STDEXT2_RDPID);
    eval 'sub CPUID_STDEXT2_SGXLC () {0x40000000;}' unless defined(&CPUID_STDEXT2_SGXLC);
    eval 'sub CPUID_STDEXT3_IBPB () {0x4000000;}' unless defined(&CPUID_STDEXT3_IBPB);
    eval 'sub CPUID_STDEXT3_STIBP () {0x8000000;}' unless defined(&CPUID_STDEXT3_STIBP);
    eval 'sub CPUID_STDEXT3_ARCH_CAP () {0x20000000;}' unless defined(&CPUID_STDEXT3_ARCH_CAP);
    eval 'sub CPUID_STDEXT3_SSBD () {0x80000000;}' unless defined(&CPUID_STDEXT3_SSBD);
    eval 'sub IA32_ARCH_CAP_RDCL_NO () {0x1;}' unless defined(&IA32_ARCH_CAP_RDCL_NO);
    eval 'sub IA32_ARCH_CAP_IBRS_ALL () {0x2;}' unless defined(&IA32_ARCH_CAP_IBRS_ALL);
    eval 'sub IA32_ARCH_CAP_SSBD_NO () {0x4;}' unless defined(&IA32_ARCH_CAP_SSBD_NO);
    eval 'sub AMD_VENDOR_ID () {"AuthenticAMD";}' unless defined(&AMD_VENDOR_ID);
    eval 'sub CENTAUR_VENDOR_ID () {"CentaurHauls";}' unless defined(&CENTAUR_VENDOR_ID);
    eval 'sub CYRIX_VENDOR_ID () {"CyrixInstead";}' unless defined(&CYRIX_VENDOR_ID);
    eval 'sub INTEL_VENDOR_ID () {"GenuineIntel";}' unless defined(&INTEL_VENDOR_ID);
    eval 'sub NEXGEN_VENDOR_ID () {"NexGenDriven";}' unless defined(&NEXGEN_VENDOR_ID);
    eval 'sub NSC_VENDOR_ID () {"Geode by NSC";}' unless defined(&NSC_VENDOR_ID);
    eval 'sub RISE_VENDOR_ID () {"RiseRiseRise";}' unless defined(&RISE_VENDOR_ID);
    eval 'sub SIS_VENDOR_ID () {"SiS SiS SiS ";}' unless defined(&SIS_VENDOR_ID);
    eval 'sub TRANSMETA_VENDOR_ID () {"GenuineTMx86";}' unless defined(&TRANSMETA_VENDOR_ID);
    eval 'sub UMC_VENDOR_ID () {"UMC UMC UMC ";}' unless defined(&UMC_VENDOR_ID);
    eval 'sub MSR_P5_MC_ADDR () {0x;}' unless defined(&MSR_P5_MC_ADDR);
    eval 'sub MSR_P5_MC_TYPE () {0x1;}' unless defined(&MSR_P5_MC_TYPE);
    eval 'sub MSR_TSC () {0x10;}' unless defined(&MSR_TSC);
    eval 'sub MSR_P5_CESR () {0x11;}' unless defined(&MSR_P5_CESR);
    eval 'sub MSR_P5_CTR0 () {0x12;}' unless defined(&MSR_P5_CTR0);
    eval 'sub MSR_P5_CTR1 () {0x13;}' unless defined(&MSR_P5_CTR1);
    eval 'sub MSR_IA32_PLATFORM_ID () {0x17;}' unless defined(&MSR_IA32_PLATFORM_ID);
    eval 'sub MSR_APICBASE () {0x1b;}' unless defined(&MSR_APICBASE);
    eval 'sub MSR_EBL_CR_POWERON () {0x2a;}' unless defined(&MSR_EBL_CR_POWERON);
    eval 'sub MSR_TEST_CTL () {0x33;}' unless defined(&MSR_TEST_CTL);
    eval 'sub MSR_IA32_FEATURE_CONTROL () {0x3a;}' unless defined(&MSR_IA32_FEATURE_CONTROL);
    eval 'sub MSR_IA32_SPEC_CTRL () {0x48;}' unless defined(&MSR_IA32_SPEC_CTRL);
    eval 'sub MSR_IA32_PRED_CMD () {0x49;}' unless defined(&MSR_IA32_PRED_CMD);
    eval 'sub MSR_BIOS_UPDT_TRIG () {0x79;}' unless defined(&MSR_BIOS_UPDT_TRIG);
    eval 'sub MSR_BBL_CR_D0 () {0x88;}' unless defined(&MSR_BBL_CR_D0);
    eval 'sub MSR_BBL_CR_D1 () {0x89;}' unless defined(&MSR_BBL_CR_D1);
    eval 'sub MSR_BBL_CR_D2 () {0x8a;}' unless defined(&MSR_BBL_CR_D2);
    eval 'sub MSR_BIOS_SIGN () {0x8b;}' unless defined(&MSR_BIOS_SIGN);
    eval 'sub MSR_PERFCTR0 () {0xc1;}' unless defined(&MSR_PERFCTR0);
    eval 'sub MSR_PERFCTR1 () {0xc2;}' unless defined(&MSR_PERFCTR1);
    eval 'sub MSR_PLATFORM_INFO () {0xce;}' unless defined(&MSR_PLATFORM_INFO);
    eval 'sub MSR_MPERF () {0xe7;}' unless defined(&MSR_MPERF);
    eval 'sub MSR_APERF () {0xe8;}' unless defined(&MSR_APERF);
    eval 'sub MSR_IA32_EXT_CONFIG () {0xee;}' unless defined(&MSR_IA32_EXT_CONFIG);
    eval 'sub MSR_MTRRcap () {0xfe;}' unless defined(&MSR_MTRRcap);
    eval 'sub MSR_IA32_ARCH_CAP () {0x10a;}' unless defined(&MSR_IA32_ARCH_CAP);
    eval 'sub MSR_BBL_CR_ADDR () {0x116;}' unless defined(&MSR_BBL_CR_ADDR);
    eval 'sub MSR_BBL_CR_DECC () {0x118;}' unless defined(&MSR_BBL_CR_DECC);
    eval 'sub MSR_BBL_CR_CTL () {0x119;}' unless defined(&MSR_BBL_CR_CTL);
    eval 'sub MSR_BBL_CR_TRIG () {0x11a;}' unless defined(&MSR_BBL_CR_TRIG);
    eval 'sub MSR_BBL_CR_BUSY () {0x11b;}' unless defined(&MSR_BBL_CR_BUSY);
    eval 'sub MSR_BBL_CR_CTL3 () {0x11e;}' unless defined(&MSR_BBL_CR_CTL3);
    eval 'sub MSR_SYSENTER_CS_MSR () {0x174;}' unless defined(&MSR_SYSENTER_CS_MSR);
    eval 'sub MSR_SYSENTER_ESP_MSR () {0x175;}' unless defined(&MSR_SYSENTER_ESP_MSR);
    eval 'sub MSR_SYSENTER_EIP_MSR () {0x176;}' unless defined(&MSR_SYSENTER_EIP_MSR);
    eval 'sub MSR_MCG_CAP () {0x179;}' unless defined(&MSR_MCG_CAP);
    eval 'sub MSR_MCG_STATUS () {0x17a;}' unless defined(&MSR_MCG_STATUS);
    eval 'sub MSR_MCG_CTL () {0x17b;}' unless defined(&MSR_MCG_CTL);
    eval 'sub MSR_EVNTSEL0 () {0x186;}' unless defined(&MSR_EVNTSEL0);
    eval 'sub MSR_EVNTSEL1 () {0x187;}' unless defined(&MSR_EVNTSEL1);
    eval 'sub MSR_THERM_CONTROL () {0x19a;}' unless defined(&MSR_THERM_CONTROL);
    eval 'sub MSR_THERM_INTERRUPT () {0x19b;}' unless defined(&MSR_THERM_INTERRUPT);
    eval 'sub MSR_THERM_STATUS () {0x19c;}' unless defined(&MSR_THERM_STATUS);
    eval 'sub MSR_IA32_MISC_ENABLE () {0x1a0;}' unless defined(&MSR_IA32_MISC_ENABLE);
    eval 'sub MSR_IA32_TEMPERATURE_TARGET () {0x1a2;}' unless defined(&MSR_IA32_TEMPERATURE_TARGET);
    eval 'sub MSR_TURBO_RATIO_LIMIT () {0x1ad;}' unless defined(&MSR_TURBO_RATIO_LIMIT);
    eval 'sub MSR_TURBO_RATIO_LIMIT1 () {0x1ae;}' unless defined(&MSR_TURBO_RATIO_LIMIT1);
    eval 'sub MSR_DEBUGCTLMSR () {0x1d9;}' unless defined(&MSR_DEBUGCTLMSR);
    eval 'sub MSR_LASTBRANCHFROMIP () {0x1db;}' unless defined(&MSR_LASTBRANCHFROMIP);
    eval 'sub MSR_LASTBRANCHTOIP () {0x1dc;}' unless defined(&MSR_LASTBRANCHTOIP);
    eval 'sub MSR_LASTINTFROMIP () {0x1dd;}' unless defined(&MSR_LASTINTFROMIP);
    eval 'sub MSR_LASTINTTOIP () {0x1de;}' unless defined(&MSR_LASTINTTOIP);
    eval 'sub MSR_ROB_CR_BKUPTMPDR6 () {0x1e0;}' unless defined(&MSR_ROB_CR_BKUPTMPDR6);
    eval 'sub MSR_MTRRVarBase () {0x200;}' unless defined(&MSR_MTRRVarBase);
    eval 'sub MSR_MTRR64kBase () {0x250;}' unless defined(&MSR_MTRR64kBase);
    eval 'sub MSR_MTRR16kBase () {0x258;}' unless defined(&MSR_MTRR16kBase);
    eval 'sub MSR_MTRR4kBase () {0x268;}' unless defined(&MSR_MTRR4kBase);
    eval 'sub MSR_PAT () {0x277;}' unless defined(&MSR_PAT);
    eval 'sub MSR_MC0_CTL2 () {0x280;}' unless defined(&MSR_MC0_CTL2);
    eval 'sub MSR_MTRRdefType () {0x2ff;}' unless defined(&MSR_MTRRdefType);
    eval 'sub MSR_MC0_CTL () {0x400;}' unless defined(&MSR_MC0_CTL);
    eval 'sub MSR_MC0_STATUS () {0x401;}' unless defined(&MSR_MC0_STATUS);
    eval 'sub MSR_MC0_ADDR () {0x402;}' unless defined(&MSR_MC0_ADDR);
    eval 'sub MSR_MC0_MISC () {0x403;}' unless defined(&MSR_MC0_MISC);
    eval 'sub MSR_MC1_CTL () {0x404;}' unless defined(&MSR_MC1_CTL);
    eval 'sub MSR_MC1_STATUS () {0x405;}' unless defined(&MSR_MC1_STATUS);
    eval 'sub MSR_MC1_ADDR () {0x406;}' unless defined(&MSR_MC1_ADDR);
    eval 'sub MSR_MC1_MISC () {0x407;}' unless defined(&MSR_MC1_MISC);
    eval 'sub MSR_MC2_CTL () {0x408;}' unless defined(&MSR_MC2_CTL);
    eval 'sub MSR_MC2_STATUS () {0x409;}' unless defined(&MSR_MC2_STATUS);
    eval 'sub MSR_MC2_ADDR () {0x40a;}' unless defined(&MSR_MC2_ADDR);
    eval 'sub MSR_MC2_MISC () {0x40b;}' unless defined(&MSR_MC2_MISC);
    eval 'sub MSR_MC3_CTL () {0x40c;}' unless defined(&MSR_MC3_CTL);
    eval 'sub MSR_MC3_STATUS () {0x40d;}' unless defined(&MSR_MC3_STATUS);
    eval 'sub MSR_MC3_ADDR () {0x40e;}' unless defined(&MSR_MC3_ADDR);
    eval 'sub MSR_MC3_MISC () {0x40f;}' unless defined(&MSR_MC3_MISC);
    eval 'sub MSR_MC4_CTL () {0x410;}' unless defined(&MSR_MC4_CTL);
    eval 'sub MSR_MC4_STATUS () {0x411;}' unless defined(&MSR_MC4_STATUS);
    eval 'sub MSR_MC4_ADDR () {0x412;}' unless defined(&MSR_MC4_ADDR);
    eval 'sub MSR_MC4_MISC () {0x413;}' unless defined(&MSR_MC4_MISC);
    eval 'sub MSR_RAPL_POWER_UNIT () {0x606;}' unless defined(&MSR_RAPL_POWER_UNIT);
    eval 'sub MSR_PKG_ENERGY_STATUS () {0x611;}' unless defined(&MSR_PKG_ENERGY_STATUS);
    eval 'sub MSR_DRAM_ENERGY_STATUS () {0x619;}' unless defined(&MSR_DRAM_ENERGY_STATUS);
    eval 'sub MSR_PP0_ENERGY_STATUS () {0x639;}' unless defined(&MSR_PP0_ENERGY_STATUS);
    eval 'sub MSR_PP1_ENERGY_STATUS () {0x641;}' unless defined(&MSR_PP1_ENERGY_STATUS);
    eval 'sub MSR_TSC_DEADLINE () {0x6e0;}' unless defined(&MSR_TSC_DEADLINE);
    eval 'sub MSR_VMX_BASIC () {0x480;}' unless defined(&MSR_VMX_BASIC);
    eval 'sub MSR_VMX_PINBASED_CTLS () {0x481;}' unless defined(&MSR_VMX_PINBASED_CTLS);
    eval 'sub MSR_VMX_PROCBASED_CTLS () {0x482;}' unless defined(&MSR_VMX_PROCBASED_CTLS);
    eval 'sub MSR_VMX_EXIT_CTLS () {0x483;}' unless defined(&MSR_VMX_EXIT_CTLS);
    eval 'sub MSR_VMX_ENTRY_CTLS () {0x484;}' unless defined(&MSR_VMX_ENTRY_CTLS);
    eval 'sub MSR_VMX_CR0_FIXED0 () {0x486;}' unless defined(&MSR_VMX_CR0_FIXED0);
    eval 'sub MSR_VMX_CR0_FIXED1 () {0x487;}' unless defined(&MSR_VMX_CR0_FIXED1);
    eval 'sub MSR_VMX_CR4_FIXED0 () {0x488;}' unless defined(&MSR_VMX_CR4_FIXED0);
    eval 'sub MSR_VMX_CR4_FIXED1 () {0x489;}' unless defined(&MSR_VMX_CR4_FIXED1);
    eval 'sub MSR_VMX_PROCBASED_CTLS2 () {0x48b;}' unless defined(&MSR_VMX_PROCBASED_CTLS2);
    eval 'sub MSR_VMX_EPT_VPID_CAP () {0x48c;}' unless defined(&MSR_VMX_EPT_VPID_CAP);
    eval 'sub MSR_VMX_TRUE_PINBASED_CTLS () {0x48d;}' unless defined(&MSR_VMX_TRUE_PINBASED_CTLS);
    eval 'sub MSR_VMX_TRUE_PROCBASED_CTLS () {0x48e;}' unless defined(&MSR_VMX_TRUE_PROCBASED_CTLS);
    eval 'sub MSR_VMX_TRUE_EXIT_CTLS () {0x48f;}' unless defined(&MSR_VMX_TRUE_EXIT_CTLS);
    eval 'sub MSR_VMX_TRUE_ENTRY_CTLS () {0x490;}' unless defined(&MSR_VMX_TRUE_ENTRY_CTLS);
    eval 'sub MSR_APIC_000 () {0x800;}' unless defined(&MSR_APIC_000);
    eval 'sub MSR_APIC_ID () {0x802;}' unless defined(&MSR_APIC_ID);
    eval 'sub MSR_APIC_VERSION () {0x803;}' unless defined(&MSR_APIC_VERSION);
    eval 'sub MSR_APIC_TPR () {0x808;}' unless defined(&MSR_APIC_TPR);
    eval 'sub MSR_APIC_EOI () {0x80b;}' unless defined(&MSR_APIC_EOI);
    eval 'sub MSR_APIC_LDR () {0x80d;}' unless defined(&MSR_APIC_LDR);
    eval 'sub MSR_APIC_SVR () {0x80f;}' unless defined(&MSR_APIC_SVR);
    eval 'sub MSR_APIC_ISR0 () {0x810;}' unless defined(&MSR_APIC_ISR0);
    eval 'sub MSR_APIC_ISR1 () {0x811;}' unless defined(&MSR_APIC_ISR1);
    eval 'sub MSR_APIC_ISR2 () {0x812;}' unless defined(&MSR_APIC_ISR2);
    eval 'sub MSR_APIC_ISR3 () {0x813;}' unless defined(&MSR_APIC_ISR3);
    eval 'sub MSR_APIC_ISR4 () {0x814;}' unless defined(&MSR_APIC_ISR4);
    eval 'sub MSR_APIC_ISR5 () {0x815;}' unless defined(&MSR_APIC_ISR5);
    eval 'sub MSR_APIC_ISR6 () {0x816;}' unless defined(&MSR_APIC_ISR6);
    eval 'sub MSR_APIC_ISR7 () {0x817;}' unless defined(&MSR_APIC_ISR7);
    eval 'sub MSR_APIC_TMR0 () {0x818;}' unless defined(&MSR_APIC_TMR0);
    eval 'sub MSR_APIC_IRR0 () {0x820;}' unless defined(&MSR_APIC_IRR0);
    eval 'sub MSR_APIC_ESR () {0x828;}' unless defined(&MSR_APIC_ESR);
    eval 'sub MSR_APIC_LVT_CMCI () {0x82f;}' unless defined(&MSR_APIC_LVT_CMCI);
    eval 'sub MSR_APIC_ICR () {0x830;}' unless defined(&MSR_APIC_ICR);
    eval 'sub MSR_APIC_LVT_TIMER () {0x832;}' unless defined(&MSR_APIC_LVT_TIMER);
    eval 'sub MSR_APIC_LVT_THERMAL () {0x833;}' unless defined(&MSR_APIC_LVT_THERMAL);
    eval 'sub MSR_APIC_LVT_PCINT () {0x834;}' unless defined(&MSR_APIC_LVT_PCINT);
    eval 'sub MSR_APIC_LVT_LINT0 () {0x835;}' unless defined(&MSR_APIC_LVT_LINT0);
    eval 'sub MSR_APIC_LVT_LINT1 () {0x836;}' unless defined(&MSR_APIC_LVT_LINT1);
    eval 'sub MSR_APIC_LVT_ERROR () {0x837;}' unless defined(&MSR_APIC_LVT_ERROR);
    eval 'sub MSR_APIC_ICR_TIMER () {0x838;}' unless defined(&MSR_APIC_ICR_TIMER);
    eval 'sub MSR_APIC_CCR_TIMER () {0x839;}' unless defined(&MSR_APIC_CCR_TIMER);
    eval 'sub MSR_APIC_DCR_TIMER () {0x83e;}' unless defined(&MSR_APIC_DCR_TIMER);
    eval 'sub MSR_APIC_SELF_IPI () {0x83f;}' unless defined(&MSR_APIC_SELF_IPI);
    eval 'sub MSR_IA32_XSS () {0xda0;}' unless defined(&MSR_IA32_XSS);
    eval 'sub APICBASE_RESERVED () {0x2ff;}' unless defined(&APICBASE_RESERVED);
    eval 'sub APICBASE_BSP () {0x100;}' unless defined(&APICBASE_BSP);
    eval 'sub APICBASE_X2APIC () {0x400;}' unless defined(&APICBASE_X2APIC);
    eval 'sub APICBASE_ENABLED () {0x800;}' unless defined(&APICBASE_ENABLED);
    eval 'sub APICBASE_ADDRESS () {0xfffff000;}' unless defined(&APICBASE_ADDRESS);
    eval 'sub IA32_FEATURE_CONTROL_LOCK () {0x1;}' unless defined(&IA32_FEATURE_CONTROL_LOCK);
    eval 'sub IA32_FEATURE_CONTROL_SMX_EN () {0x2;}' unless defined(&IA32_FEATURE_CONTROL_SMX_EN);
    eval 'sub IA32_FEATURE_CONTROL_VMX_EN () {0x4;}' unless defined(&IA32_FEATURE_CONTROL_VMX_EN);
    eval 'sub IA32_MISC_EN_FASTSTR () {0x1;}' unless defined(&IA32_MISC_EN_FASTSTR);
    eval 'sub IA32_MISC_EN_ATCCE () {0x8;}' unless defined(&IA32_MISC_EN_ATCCE);
    eval 'sub IA32_MISC_EN_PERFMON () {0x80;}' unless defined(&IA32_MISC_EN_PERFMON);
    eval 'sub IA32_MISC_EN_PEBSU () {0x1000;}' unless defined(&IA32_MISC_EN_PEBSU);
    eval 'sub IA32_MISC_EN_ESSTE () {0x10000;}' unless defined(&IA32_MISC_EN_ESSTE);
    eval 'sub IA32_MISC_EN_MONE () {0x40000;}' unless defined(&IA32_MISC_EN_MONE);
    eval 'sub IA32_MISC_EN_LIMCPUID () {0x400000;}' unless defined(&IA32_MISC_EN_LIMCPUID);
    eval 'sub IA32_MISC_EN_xTPRD () {0x800000;}' unless defined(&IA32_MISC_EN_xTPRD);
    eval 'sub IA32_MISC_EN_XDD () {0x400000000;}' unless defined(&IA32_MISC_EN_XDD);
    eval 'sub IA32_SPEC_CTRL_IBRS () {0x1;}' unless defined(&IA32_SPEC_CTRL_IBRS);
    eval 'sub IA32_SPEC_CTRL_STIBP () {0x2;}' unless defined(&IA32_SPEC_CTRL_STIBP);
    eval 'sub IA32_SPEC_CTRL_SSBD () {0x4;}' unless defined(&IA32_SPEC_CTRL_SSBD);
    eval 'sub IA32_PRED_CMD_IBPB_BARRIER () {0x1;}' unless defined(&IA32_PRED_CMD_IBPB_BARRIER);
    eval 'sub PAT_UNCACHEABLE () {0x;}' unless defined(&PAT_UNCACHEABLE);
    eval 'sub PAT_WRITE_COMBINING () {0x1;}' unless defined(&PAT_WRITE_COMBINING);
    eval 'sub PAT_WRITE_THROUGH () {0x4;}' unless defined(&PAT_WRITE_THROUGH);
    eval 'sub PAT_WRITE_PROTECTED () {0x5;}' unless defined(&PAT_WRITE_PROTECTED);
    eval 'sub PAT_WRITE_BACK () {0x6;}' unless defined(&PAT_WRITE_BACK);
    eval 'sub PAT_UNCACHED () {0x7;}' unless defined(&PAT_UNCACHED);
    eval 'sub PAT_VALUE {
        my($i, $m) = @_;
	    eval q((($m) << (8* ($i))));
    }' unless defined(&PAT_VALUE);
    eval 'sub PAT_MASK {
        my($i) = @_;
	    eval q( &PAT_VALUE($i, 0xff));
    }' unless defined(&PAT_MASK);
    eval 'sub MTRR_UNCACHEABLE () {0x;}' unless defined(&MTRR_UNCACHEABLE);
    eval 'sub MTRR_WRITE_COMBINING () {0x1;}' unless defined(&MTRR_WRITE_COMBINING);
    eval 'sub MTRR_WRITE_THROUGH () {0x4;}' unless defined(&MTRR_WRITE_THROUGH);
    eval 'sub MTRR_WRITE_PROTECTED () {0x5;}' unless defined(&MTRR_WRITE_PROTECTED);
    eval 'sub MTRR_WRITE_BACK () {0x6;}' unless defined(&MTRR_WRITE_BACK);
    eval 'sub MTRR_N64K () {8;}' unless defined(&MTRR_N64K);
    eval 'sub MTRR_N16K () {16;}' unless defined(&MTRR_N16K);
    eval 'sub MTRR_N4K () {64;}' unless defined(&MTRR_N4K);
    eval 'sub MTRR_CAP_WC () {0x400;}' unless defined(&MTRR_CAP_WC);
    eval 'sub MTRR_CAP_FIXED () {0x100;}' unless defined(&MTRR_CAP_FIXED);
    eval 'sub MTRR_CAP_VCNT () {0xff;}' unless defined(&MTRR_CAP_VCNT);
    eval 'sub MTRR_DEF_ENABLE () {0x800;}' unless defined(&MTRR_DEF_ENABLE);
    eval 'sub MTRR_DEF_FIXED_ENABLE () {0x400;}' unless defined(&MTRR_DEF_FIXED_ENABLE);
    eval 'sub MTRR_DEF_TYPE () {0xff;}' unless defined(&MTRR_DEF_TYPE);
    eval 'sub MTRR_PHYSBASE_PHYSBASE () {0xffffffffff000;}' unless defined(&MTRR_PHYSBASE_PHYSBASE);
    eval 'sub MTRR_PHYSBASE_TYPE () {0xff;}' unless defined(&MTRR_PHYSBASE_TYPE);
    eval 'sub MTRR_PHYSMASK_PHYSMASK () {0xffffffffff000;}' unless defined(&MTRR_PHYSMASK_PHYSMASK);
    eval 'sub MTRR_PHYSMASK_VALID () {0x800;}' unless defined(&MTRR_PHYSMASK_VALID);
    eval 'sub CCR0 () {0xc0;}' unless defined(&CCR0);
    eval 'sub CCR0_NC0 () {0x1;}' unless defined(&CCR0_NC0);
    eval 'sub CCR0_NC1 () {0x2;}' unless defined(&CCR0_NC1);
    eval 'sub CCR0_A20M () {0x4;}' unless defined(&CCR0_A20M);
    eval 'sub CCR0_KEN () {0x8;}' unless defined(&CCR0_KEN);
    eval 'sub CCR0_FLUSH () {0x10;}' unless defined(&CCR0_FLUSH);
    eval 'sub CCR0_BARB () {0x20;}' unless defined(&CCR0_BARB);
    eval 'sub CCR0_CO () {0x40;}' unless defined(&CCR0_CO);
    eval 'sub CCR0_SUSPEND () {0x80;}' unless defined(&CCR0_SUSPEND);
    eval 'sub CCR1 () {0xc1;}' unless defined(&CCR1);
    eval 'sub CCR1_RPL () {0x1;}' unless defined(&CCR1_RPL);
    eval 'sub CCR1_SMI () {0x2;}' unless defined(&CCR1_SMI);
    eval 'sub CCR1_SMAC () {0x4;}' unless defined(&CCR1_SMAC);
    eval 'sub CCR1_MMAC () {0x8;}' unless defined(&CCR1_MMAC);
    eval 'sub CCR1_NO_LOCK () {0x10;}' unless defined(&CCR1_NO_LOCK);
    eval 'sub CCR1_SM3 () {0x80;}' unless defined(&CCR1_SM3);
    eval 'sub CCR2 () {0xc2;}' unless defined(&CCR2);
    eval 'sub CCR2_WB () {0x2;}' unless defined(&CCR2_WB);
    eval 'sub CCR2_SADS () {0x2;}' unless defined(&CCR2_SADS);
    eval 'sub CCR2_LOCK_NW () {0x4;}' unless defined(&CCR2_LOCK_NW);
    eval 'sub CCR2_SUSP_HLT () {0x8;}' unless defined(&CCR2_SUSP_HLT);
    eval 'sub CCR2_WT1 () {0x10;}' unless defined(&CCR2_WT1);
    eval 'sub CCR2_WPR1 () {0x10;}' unless defined(&CCR2_WPR1);
    eval 'sub CCR2_BARB () {0x20;}' unless defined(&CCR2_BARB);
    eval 'sub CCR2_BWRT () {0x40;}' unless defined(&CCR2_BWRT);
    eval 'sub CCR2_USE_SUSP () {0x80;}' unless defined(&CCR2_USE_SUSP);
    eval 'sub CCR3 () {0xc3;}' unless defined(&CCR3);
    eval 'sub CCR3_SMILOCK () {0x1;}' unless defined(&CCR3_SMILOCK);
    eval 'sub CCR3_NMI () {0x2;}' unless defined(&CCR3_NMI);
    eval 'sub CCR3_LINBRST () {0x4;}' unless defined(&CCR3_LINBRST);
    eval 'sub CCR3_SMMMODE () {0x8;}' unless defined(&CCR3_SMMMODE);
    eval 'sub CCR3_MAPEN0 () {0x10;}' unless defined(&CCR3_MAPEN0);
    eval 'sub CCR3_MAPEN1 () {0x20;}' unless defined(&CCR3_MAPEN1);
    eval 'sub CCR3_MAPEN2 () {0x40;}' unless defined(&CCR3_MAPEN2);
    eval 'sub CCR3_MAPEN3 () {0x80;}' unless defined(&CCR3_MAPEN3);
    eval 'sub CCR4 () {0xe8;}' unless defined(&CCR4);
    eval 'sub CCR4_IOMASK () {0x7;}' unless defined(&CCR4_IOMASK);
    eval 'sub CCR4_MEM () {0x8;}' unless defined(&CCR4_MEM);
    eval 'sub CCR4_DTE () {0x10;}' unless defined(&CCR4_DTE);
    eval 'sub CCR4_FASTFPE () {0x20;}' unless defined(&CCR4_FASTFPE);
    eval 'sub CCR4_CPUID () {0x80;}' unless defined(&CCR4_CPUID);
    eval 'sub CCR5 () {0xe9;}' unless defined(&CCR5);
    eval 'sub CCR5_WT_ALLOC () {0x1;}' unless defined(&CCR5_WT_ALLOC);
    eval 'sub CCR5_SLOP () {0x2;}' unless defined(&CCR5_SLOP);
    eval 'sub CCR5_LBR1 () {0x10;}' unless defined(&CCR5_LBR1);
    eval 'sub CCR5_ARREN () {0x20;}' unless defined(&CCR5_ARREN);
    eval 'sub CCR6 () {0xea;}' unless defined(&CCR6);
    eval 'sub CCR7 () {0xeb;}' unless defined(&CCR7);
    eval 'sub PCR0 () {0x20;}' unless defined(&PCR0);
    eval 'sub PCR0_RSTK () {0x1;}' unless defined(&PCR0_RSTK);
    eval 'sub PCR0_BTB () {0x2;}' unless defined(&PCR0_BTB);
    eval 'sub PCR0_LOOP () {0x4;}' unless defined(&PCR0_LOOP);
    eval 'sub PCR0_AIS () {0x8;}' unless defined(&PCR0_AIS);
    eval 'sub PCR0_MLR () {0x10;}' unless defined(&PCR0_MLR);
    eval 'sub PCR0_BTBRT () {0x40;}' unless defined(&PCR0_BTBRT);
    eval 'sub PCR0_LSSER () {0x80;}' unless defined(&PCR0_LSSER);
    eval 'sub DIR0 () {0xfe;}' unless defined(&DIR0);
    eval 'sub DIR1 () {0xff;}' unless defined(&DIR1);
    eval 'sub MCG_CAP_COUNT () {0xff;}' unless defined(&MCG_CAP_COUNT);
    eval 'sub MCG_CAP_CTL_P () {0x100;}' unless defined(&MCG_CAP_CTL_P);
    eval 'sub MCG_CAP_EXT_P () {0x200;}' unless defined(&MCG_CAP_EXT_P);
    eval 'sub MCG_CAP_CMCI_P () {0x400;}' unless defined(&MCG_CAP_CMCI_P);
    eval 'sub MCG_CAP_TES_P () {0x800;}' unless defined(&MCG_CAP_TES_P);
    eval 'sub MCG_CAP_EXT_CNT () {0xff0000;}' unless defined(&MCG_CAP_EXT_CNT);
    eval 'sub MCG_CAP_SER_P () {0x1000000;}' unless defined(&MCG_CAP_SER_P);
    eval 'sub MCG_STATUS_RIPV () {0x1;}' unless defined(&MCG_STATUS_RIPV);
    eval 'sub MCG_STATUS_EIPV () {0x2;}' unless defined(&MCG_STATUS_EIPV);
    eval 'sub MCG_STATUS_MCIP () {0x4;}' unless defined(&MCG_STATUS_MCIP);
    eval 'sub MCG_CTL_ENABLE () {0xffffffffffffffff;}' unless defined(&MCG_CTL_ENABLE);
    eval 'sub MCG_CTL_DISABLE () {0x;}' unless defined(&MCG_CTL_DISABLE);
    eval 'sub MSR_MC_CTL {
        my($x) = @_;
	    eval q(( &MSR_MC0_CTL + ($x) * 4));
    }' unless defined(&MSR_MC_CTL);
    eval 'sub MSR_MC_STATUS {
        my($x) = @_;
	    eval q(( &MSR_MC0_STATUS + ($x) * 4));
    }' unless defined(&MSR_MC_STATUS);
    eval 'sub MSR_MC_ADDR {
        my($x) = @_;
	    eval q(( &MSR_MC0_ADDR + ($x) * 4));
    }' unless defined(&MSR_MC_ADDR);
    eval 'sub MSR_MC_MISC {
        my($x) = @_;
	    eval q(( &MSR_MC0_MISC + ($x) * 4));
    }' unless defined(&MSR_MC_MISC);
    eval 'sub MSR_MC_CTL2 {
        my($x) = @_;
	    eval q(( &MSR_MC0_CTL2 + ($x)));
    }' unless defined(&MSR_MC_CTL2);
    eval 'sub MC_STATUS_MCA_ERROR () {0xffff;}' unless defined(&MC_STATUS_MCA_ERROR);
    eval 'sub MC_STATUS_MODEL_ERROR () {0xffff0000;}' unless defined(&MC_STATUS_MODEL_ERROR);
    eval 'sub MC_STATUS_OTHER_INFO () {0x1ffffff00000000;}' unless defined(&MC_STATUS_OTHER_INFO);
    eval 'sub MC_STATUS_COR_COUNT () {0x1fffc000000000;}' unless defined(&MC_STATUS_COR_COUNT);
    eval 'sub MC_STATUS_TES_STATUS () {0x60000000000000;}' unless defined(&MC_STATUS_TES_STATUS);
    eval 'sub MC_STATUS_AR () {0x80000000000000;}' unless defined(&MC_STATUS_AR);
    eval 'sub MC_STATUS_S () {0x100000000000000;}' unless defined(&MC_STATUS_S);
    eval 'sub MC_STATUS_PCC () {0x200000000000000;}' unless defined(&MC_STATUS_PCC);
    eval 'sub MC_STATUS_ADDRV () {0x400000000000000;}' unless defined(&MC_STATUS_ADDRV);
    eval 'sub MC_STATUS_MISCV () {0x800000000000000;}' unless defined(&MC_STATUS_MISCV);
    eval 'sub MC_STATUS_EN () {0x1000000000000000;}' unless defined(&MC_STATUS_EN);
    eval 'sub MC_STATUS_UC () {0x2000000000000000;}' unless defined(&MC_STATUS_UC);
    eval 'sub MC_STATUS_OVER () {0x4000000000000000;}' unless defined(&MC_STATUS_OVER);
    eval 'sub MC_STATUS_VAL () {0x8000000000000000;}' unless defined(&MC_STATUS_VAL);
    eval 'sub MC_MISC_RA_LSB () {0x3f;}' unless defined(&MC_MISC_RA_LSB);
    eval 'sub MC_MISC_ADDRESS_MODE () {0x1c0;}' unless defined(&MC_MISC_ADDRESS_MODE);
    eval 'sub MC_CTL2_THRESHOLD () {0x7fff;}' unless defined(&MC_CTL2_THRESHOLD);
    eval 'sub MC_CTL2_CMCI_EN () {0x40000000;}' unless defined(&MC_CTL2_CMCI_EN);
    eval 'sub MC_AMDNB_BANK () {4;}' unless defined(&MC_AMDNB_BANK);
    eval 'sub MC_MISC_AMDNB_VAL () {0x8000000000000000;}' unless defined(&MC_MISC_AMDNB_VAL);
    eval 'sub MC_MISC_AMDNB_CNTP () {0x4000000000000000;}' unless defined(&MC_MISC_AMDNB_CNTP);
    eval 'sub MC_MISC_AMDNB_LOCK () {0x2000000000000000;}' unless defined(&MC_MISC_AMDNB_LOCK);
    eval 'sub MC_MISC_AMDNB_LVT_MASK () {0xf0000000000000;}' unless defined(&MC_MISC_AMDNB_LVT_MASK);
    eval 'sub MC_MISC_AMDNB_LVT_SHIFT () {52;}' unless defined(&MC_MISC_AMDNB_LVT_SHIFT);
    eval 'sub MC_MISC_AMDNB_CNTEN () {0x8000000000000;}' unless defined(&MC_MISC_AMDNB_CNTEN);
    eval 'sub MC_MISC_AMDNB_INT_MASK () {0x6000000000000;}' unless defined(&MC_MISC_AMDNB_INT_MASK);
    eval 'sub MC_MISC_AMDNB_INT_LVT () {0x2000000000000;}' unless defined(&MC_MISC_AMDNB_INT_LVT);
    eval 'sub MC_MISC_AMDNB_INT_SMI () {0x4000000000000;}' unless defined(&MC_MISC_AMDNB_INT_SMI);
    eval 'sub MC_MISC_AMDNB_OVERFLOW () {0x1000000000000;}' unless defined(&MC_MISC_AMDNB_OVERFLOW);
    eval 'sub MC_MISC_AMDNB_CNT_MASK () {0xfff00000000;}' unless defined(&MC_MISC_AMDNB_CNT_MASK);
    eval 'sub MC_MISC_AMDNB_CNT_SHIFT () {32;}' unless defined(&MC_MISC_AMDNB_CNT_SHIFT);
    eval 'sub MC_MISC_AMDNB_CNT_MAX () {0xfff;}' unless defined(&MC_MISC_AMDNB_CNT_MAX);
    eval 'sub MC_MISC_AMDNB_PTR_MASK () {0xff000000;}' unless defined(&MC_MISC_AMDNB_PTR_MASK);
    eval 'sub MC_MISC_AMDNB_PTR_SHIFT () {24;}' unless defined(&MC_MISC_AMDNB_PTR_SHIFT);
    eval 'sub NCR1 () {0xc4;}' unless defined(&NCR1);
    eval 'sub NCR2 () {0xc7;}' unless defined(&NCR2);
    eval 'sub NCR3 () {0xca;}' unless defined(&NCR3);
    eval 'sub NCR4 () {0xcd;}' unless defined(&NCR4);
    eval 'sub NCR_SIZE_0K () {0;}' unless defined(&NCR_SIZE_0K);
    eval 'sub NCR_SIZE_4K () {1;}' unless defined(&NCR_SIZE_4K);
    eval 'sub NCR_SIZE_8K () {2;}' unless defined(&NCR_SIZE_8K);
    eval 'sub NCR_SIZE_16K () {3;}' unless defined(&NCR_SIZE_16K);
    eval 'sub NCR_SIZE_32K () {4;}' unless defined(&NCR_SIZE_32K);
    eval 'sub NCR_SIZE_64K () {5;}' unless defined(&NCR_SIZE_64K);
    eval 'sub NCR_SIZE_128K () {6;}' unless defined(&NCR_SIZE_128K);
    eval 'sub NCR_SIZE_256K () {7;}' unless defined(&NCR_SIZE_256K);
    eval 'sub NCR_SIZE_512K () {8;}' unless defined(&NCR_SIZE_512K);
    eval 'sub NCR_SIZE_1M () {9;}' unless defined(&NCR_SIZE_1M);
    eval 'sub NCR_SIZE_2M () {10;}' unless defined(&NCR_SIZE_2M);
    eval 'sub NCR_SIZE_4M () {11;}' unless defined(&NCR_SIZE_4M);
    eval 'sub NCR_SIZE_8M () {12;}' unless defined(&NCR_SIZE_8M);
    eval 'sub NCR_SIZE_16M () {13;}' unless defined(&NCR_SIZE_16M);
    eval 'sub NCR_SIZE_32M () {14;}' unless defined(&NCR_SIZE_32M);
    eval 'sub NCR_SIZE_4G () {15;}' unless defined(&NCR_SIZE_4G);
    eval 'sub ARR0 () {0xc4;}' unless defined(&ARR0);
    eval 'sub ARR1 () {0xc7;}' unless defined(&ARR1);
    eval 'sub ARR2 () {0xca;}' unless defined(&ARR2);
    eval 'sub ARR3 () {0xcd;}' unless defined(&ARR3);
    eval 'sub ARR4 () {0xd0;}' unless defined(&ARR4);
    eval 'sub ARR5 () {0xd3;}' unless defined(&ARR5);
    eval 'sub ARR6 () {0xd6;}' unless defined(&ARR6);
    eval 'sub ARR7 () {0xd9;}' unless defined(&ARR7);
    eval 'sub ARR_SIZE_0K () {0;}' unless defined(&ARR_SIZE_0K);
    eval 'sub ARR_SIZE_4K () {1;}' unless defined(&ARR_SIZE_4K);
    eval 'sub ARR_SIZE_8K () {2;}' unless defined(&ARR_SIZE_8K);
    eval 'sub ARR_SIZE_16K () {3;}' unless defined(&ARR_SIZE_16K);
    eval 'sub ARR_SIZE_32K () {4;}' unless defined(&ARR_SIZE_32K);
    eval 'sub ARR_SIZE_64K () {5;}' unless defined(&ARR_SIZE_64K);
    eval 'sub ARR_SIZE_128K () {6;}' unless defined(&ARR_SIZE_128K);
    eval 'sub ARR_SIZE_256K () {7;}' unless defined(&ARR_SIZE_256K);
    eval 'sub ARR_SIZE_512K () {8;}' unless defined(&ARR_SIZE_512K);
    eval 'sub ARR_SIZE_1M () {9;}' unless defined(&ARR_SIZE_1M);
    eval 'sub ARR_SIZE_2M () {10;}' unless defined(&ARR_SIZE_2M);
    eval 'sub ARR_SIZE_4M () {11;}' unless defined(&ARR_SIZE_4M);
    eval 'sub ARR_SIZE_8M () {12;}' unless defined(&ARR_SIZE_8M);
    eval 'sub ARR_SIZE_16M () {13;}' unless defined(&ARR_SIZE_16M);
    eval 'sub ARR_SIZE_32M () {14;}' unless defined(&ARR_SIZE_32M);
    eval 'sub ARR_SIZE_4G () {15;}' unless defined(&ARR_SIZE_4G);
    eval 'sub RCR0 () {0xdc;}' unless defined(&RCR0);
    eval 'sub RCR1 () {0xdd;}' unless defined(&RCR1);
    eval 'sub RCR2 () {0xde;}' unless defined(&RCR2);
    eval 'sub RCR3 () {0xdf;}' unless defined(&RCR3);
    eval 'sub RCR4 () {0xe0;}' unless defined(&RCR4);
    eval 'sub RCR5 () {0xe1;}' unless defined(&RCR5);
    eval 'sub RCR6 () {0xe2;}' unless defined(&RCR6);
    eval 'sub RCR7 () {0xe3;}' unless defined(&RCR7);
    eval 'sub RCR_RCD () {0x1;}' unless defined(&RCR_RCD);
    eval 'sub RCR_RCE () {0x1;}' unless defined(&RCR_RCE);
    eval 'sub RCR_WWO () {0x2;}' unless defined(&RCR_WWO);
    eval 'sub RCR_WL () {0x4;}' unless defined(&RCR_WL);
    eval 'sub RCR_WG () {0x8;}' unless defined(&RCR_WG);
    eval 'sub RCR_WT () {0x10;}' unless defined(&RCR_WT);
    eval 'sub RCR_NLB () {0x20;}' unless defined(&RCR_NLB);
    eval 'sub AMD_WT_ALLOC_TME () {0x40000;}' unless defined(&AMD_WT_ALLOC_TME);
    eval 'sub AMD_WT_ALLOC_PRE () {0x20000;}' unless defined(&AMD_WT_ALLOC_PRE);
    eval 'sub AMD_WT_ALLOC_FRE () {0x10000;}' unless defined(&AMD_WT_ALLOC_FRE);
    eval 'sub MSR_EFER () {0xc0000080;}' unless defined(&MSR_EFER);
    eval 'sub MSR_STAR () {0xc0000081;}' unless defined(&MSR_STAR);
    eval 'sub MSR_LSTAR () {0xc0000082;}' unless defined(&MSR_LSTAR);
    eval 'sub MSR_CSTAR () {0xc0000083;}' unless defined(&MSR_CSTAR);
    eval 'sub MSR_SF_MASK () {0xc0000084;}' unless defined(&MSR_SF_MASK);
    eval 'sub MSR_FSBASE () {0xc0000100;}' unless defined(&MSR_FSBASE);
    eval 'sub MSR_GSBASE () {0xc0000101;}' unless defined(&MSR_GSBASE);
    eval 'sub MSR_KGSBASE () {0xc0000102;}' unless defined(&MSR_KGSBASE);
    eval 'sub MSR_PERFEVSEL0 () {0xc0010000;}' unless defined(&MSR_PERFEVSEL0);
    eval 'sub MSR_PERFEVSEL1 () {0xc0010001;}' unless defined(&MSR_PERFEVSEL1);
    eval 'sub MSR_PERFEVSEL2 () {0xc0010002;}' unless defined(&MSR_PERFEVSEL2);
    eval 'sub MSR_PERFEVSEL3 () {0xc0010003;}' unless defined(&MSR_PERFEVSEL3);
    eval 'sub MSR_K7_PERFCTR0 () {0xc0010004;}' unless defined(&MSR_K7_PERFCTR0);
    eval 'sub MSR_K7_PERFCTR1 () {0xc0010005;}' unless defined(&MSR_K7_PERFCTR1);
    eval 'sub MSR_K7_PERFCTR2 () {0xc0010006;}' unless defined(&MSR_K7_PERFCTR2);
    eval 'sub MSR_K7_PERFCTR3 () {0xc0010007;}' unless defined(&MSR_K7_PERFCTR3);
    eval 'sub MSR_SYSCFG () {0xc0010010;}' unless defined(&MSR_SYSCFG);
    eval 'sub MSR_HWCR () {0xc0010015;}' unless defined(&MSR_HWCR);
    eval 'sub MSR_IORRBASE0 () {0xc0010016;}' unless defined(&MSR_IORRBASE0);
    eval 'sub MSR_IORRMASK0 () {0xc0010017;}' unless defined(&MSR_IORRMASK0);
    eval 'sub MSR_IORRBASE1 () {0xc0010018;}' unless defined(&MSR_IORRBASE1);
    eval 'sub MSR_IORRMASK1 () {0xc0010019;}' unless defined(&MSR_IORRMASK1);
    eval 'sub MSR_TOP_MEM () {0xc001001a;}' unless defined(&MSR_TOP_MEM);
    eval 'sub MSR_TOP_MEM2 () {0xc001001d;}' unless defined(&MSR_TOP_MEM2);
    eval 'sub MSR_NB_CFG1 () {0xc001001f;}' unless defined(&MSR_NB_CFG1);
    eval 'sub MSR_P_STATE_LIMIT () {0xc0010061;}' unless defined(&MSR_P_STATE_LIMIT);
    eval 'sub MSR_P_STATE_CONTROL () {0xc0010062;}' unless defined(&MSR_P_STATE_CONTROL);
    eval 'sub MSR_P_STATE_STATUS () {0xc0010063;}' unless defined(&MSR_P_STATE_STATUS);
    eval 'sub MSR_P_STATE_CONFIG {
        my($n) = @_;
	    eval q((0xc0010064 + ($n)));
    }' unless defined(&MSR_P_STATE_CONFIG);
    eval 'sub MSR_SMM_ADDR () {0xc0010112;}' unless defined(&MSR_SMM_ADDR);
    eval 'sub MSR_SMM_MASK () {0xc0010113;}' unless defined(&MSR_SMM_MASK);
    eval 'sub MSR_EXTFEATURES () {0xc0011005;}' unless defined(&MSR_EXTFEATURES);
    eval 'sub MSR_IC_CFG () {0xc0011021;}' unless defined(&MSR_IC_CFG);
    eval 'sub MSR_K8_UCODE_UPDATE () {0xc0010020;}' unless defined(&MSR_K8_UCODE_UPDATE);
    eval 'sub MSR_MC0_CTL_MASK () {0xc0010044;}' unless defined(&MSR_MC0_CTL_MASK);
    eval 'sub MSR_VM_CR () {0xc0010114;}' unless defined(&MSR_VM_CR);
    eval 'sub MSR_VM_HSAVE_PA () {0xc0010117;}' unless defined(&MSR_VM_HSAVE_PA);
    eval 'sub VM_CR_SVMDIS () {0x10;}' unless defined(&VM_CR_SVMDIS);
    eval 'sub VIA_HAS_RNG () {1;}' unless defined(&VIA_HAS_RNG);
    eval 'sub VIA_HAS_AES () {1;}' unless defined(&VIA_HAS_AES);
    eval 'sub VIA_HAS_SHA () {2;}' unless defined(&VIA_HAS_SHA);
    eval 'sub VIA_HAS_MM () {4;}' unless defined(&VIA_HAS_MM);
    eval 'sub VIA_HAS_AESCTR () {8;}' unless defined(&VIA_HAS_AESCTR);
    eval 'sub VIA_CPUID_HAS_RNG () {0x4;}' unless defined(&VIA_CPUID_HAS_RNG);
    eval 'sub VIA_CPUID_DO_RNG () {0x8;}' unless defined(&VIA_CPUID_DO_RNG);
    eval 'sub VIA_CPUID_HAS_ACE () {0x40;}' unless defined(&VIA_CPUID_HAS_ACE);
    eval 'sub VIA_CPUID_DO_ACE () {0x80;}' unless defined(&VIA_CPUID_DO_ACE);
    eval 'sub VIA_CPUID_HAS_ACE2 () {0x100;}' unless defined(&VIA_CPUID_HAS_ACE2);
    eval 'sub VIA_CPUID_DO_ACE2 () {0x200;}' unless defined(&VIA_CPUID_DO_ACE2);
    eval 'sub VIA_CPUID_HAS_PHE () {0x400;}' unless defined(&VIA_CPUID_HAS_PHE);
    eval 'sub VIA_CPUID_DO_PHE () {0x800;}' unless defined(&VIA_CPUID_DO_PHE);
    eval 'sub VIA_CPUID_HAS_PMM () {0x1000;}' unless defined(&VIA_CPUID_HAS_PMM);
    eval 'sub VIA_CPUID_DO_PMM () {0x2000;}' unless defined(&VIA_CPUID_DO_PMM);
    eval 'sub VIA_CRYPT_CWLO_ROUND_M () {0xf;}' unless defined(&VIA_CRYPT_CWLO_ROUND_M);
    eval 'sub VIA_CRYPT_CWLO_ALG_M () {0x70;}' unless defined(&VIA_CRYPT_CWLO_ALG_M);
    eval 'sub VIA_CRYPT_CWLO_ALG_AES () {0x;}' unless defined(&VIA_CRYPT_CWLO_ALG_AES);
    eval 'sub VIA_CRYPT_CWLO_KEYGEN_M () {0x80;}' unless defined(&VIA_CRYPT_CWLO_KEYGEN_M);
    eval 'sub VIA_CRYPT_CWLO_KEYGEN_HW () {0x;}' unless defined(&VIA_CRYPT_CWLO_KEYGEN_HW);
    eval 'sub VIA_CRYPT_CWLO_KEYGEN_SW () {0x80;}' unless defined(&VIA_CRYPT_CWLO_KEYGEN_SW);
    eval 'sub VIA_CRYPT_CWLO_NORMAL () {0x;}' unless defined(&VIA_CRYPT_CWLO_NORMAL);
    eval 'sub VIA_CRYPT_CWLO_INTERMEDIATE () {0x100;}' unless defined(&VIA_CRYPT_CWLO_INTERMEDIATE);
    eval 'sub VIA_CRYPT_CWLO_ENCRYPT () {0x;}' unless defined(&VIA_CRYPT_CWLO_ENCRYPT);
    eval 'sub VIA_CRYPT_CWLO_DECRYPT () {0x200;}' unless defined(&VIA_CRYPT_CWLO_DECRYPT);
    eval 'sub VIA_CRYPT_CWLO_KEY128 () {0xa;}' unless defined(&VIA_CRYPT_CWLO_KEY128);
    eval 'sub VIA_CRYPT_CWLO_KEY192 () {0x40c;}' unless defined(&VIA_CRYPT_CWLO_KEY192);
    eval 'sub VIA_CRYPT_CWLO_KEY256 () {0x80e;}' unless defined(&VIA_CRYPT_CWLO_KEY256);
}
1;
