require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_VDSO_H)) {
    eval 'sub _X86_VDSO_H () {1;}' unless defined(&_X86_VDSO_H);
    eval 'sub VDSO_TIMEHANDS_MD () { &uint32_t  &th_x86_shift;  &uint32_t  &th_x86_hpet_idx;  &uint32_t  $th_res[6];;}' unless defined(&VDSO_TIMEHANDS_MD);
    eval 'sub VDSO_TH_ALGO_X86_TSC () { &VDSO_TH_ALGO_1;}' unless defined(&VDSO_TH_ALGO_X86_TSC);
    eval 'sub VDSO_TH_ALGO_X86_HPET () { &VDSO_TH_ALGO_2;}' unless defined(&VDSO_TH_ALGO_X86_HPET);
    eval 'sub VDSO_TH_ALGO_X86_HVTSC () { &VDSO_TH_ALGO_3;}' unless defined(&VDSO_TH_ALGO_X86_HVTSC);
    if(defined(&_KERNEL)) {
	if(defined(&COMPAT_FREEBSD32)) {
	    eval 'sub VDSO_TIMEHANDS_MD32 () { &VDSO_TIMEHANDS_MD;}' unless defined(&VDSO_TIMEHANDS_MD32);
	}
    }
}
1;
